/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/map","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ue=function(O){for(var t=[],i=0,y=O.length;i<y;i++)t[i]=se[O[i]];return t};const Ge=this,Xe=typeof global=="object"?global:{};var $e;(function(O){O.global=Ge;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}O.Environment=t})($e||($e={}));var $e;(function(O){class t{constructor(h,N,g){this.type=h,this.detail=N,this.timestamp=g}}O.LoaderEvent=t;class i{constructor(h){this._events=[new t(1,"",h)]}record(h,N){this._events.push(new t(h,N,O.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}O.LoaderEventRecorder=i;class y{record(h,N){}getEvents(){return[]}}y.INSTANCE=new y,O.NullLoaderEventRecorder=y})($e||($e={}));var $e;(function(O){class t{static fileUriToFilePath(y,R){if(R=decodeURI(R).replace(/%23/g,"#"),y){if(/^file:\/\/\//.test(R))return R.substr(8);if(/^file:\/\//.test(R))return R.substr(5)}else if(/^file:\/\//.test(R))return R.substr(7);return R}static startsWith(y,R){return y.length>=R.length&&y.substr(0,R.length)===R}static endsWith(y,R){return y.length>=R.length&&y.substr(y.length-R.length)===R}static containsQueryString(y){return/^[^\#]*\?/gi.test(y)}static isAbsolutePath(y){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(y)}static forEachProperty(y,R){if(y){let h;for(h in y)y.hasOwnProperty(h)&&R(h,y[h])}}static isEmpty(y){let R=!0;return t.forEachProperty(y,()=>{R=!1}),R}static recursiveClone(y){if(!y||typeof y!="object"||y instanceof RegExp||!Array.isArray(y)&&Object.getPrototypeOf(y)!==Object.prototype)return y;let R=Array.isArray(y)?[]:{};return t.forEachProperty(y,(h,N)=>{N&&typeof N=="object"?R[h]=t.recursiveClone(N):R[h]=N}),R}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(y){return t.startsWith(y,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,O.Utilities=t})($e||($e={}));var $e;(function(O){function t(R){if(R instanceof Error)return R;const h=new Error(R.message||String(R)||"Unknown Error");return R.stack&&(h.stack=R.stack),h}O.ensureError=t;class i{static validateConfigurationOptions(h){function N(g){if(g.phase==="loading"){console.error('Loading "'+g.moduleId+'" failed'),console.error(g),console.error("Here are the modules that depend on it:"),console.error(g.neededBy);return}if(g.phase==="factory"){console.error('The factory function of "'+g.moduleId+'" has thrown an exception'),console.error(g),console.error("Here are the modules that depend on it:"),console.error(g.neededBy);return}}if(h=h||{},typeof h.baseUrl!="string"&&(h.baseUrl=""),typeof h.isBuild!="boolean"&&(h.isBuild=!1),typeof h.paths!="object"&&(h.paths={}),typeof h.config!="object"&&(h.config={}),typeof h.catchError>"u"&&(h.catchError=!1),typeof h.recordStats>"u"&&(h.recordStats=!1),typeof h.urlArgs!="string"&&(h.urlArgs=""),typeof h.onError!="function"&&(h.onError=N),Array.isArray(h.ignoreDuplicateModules)||(h.ignoreDuplicateModules=[]),h.baseUrl.length>0&&(O.Utilities.endsWith(h.baseUrl,"/")||(h.baseUrl+="/")),typeof h.cspNonce!="string"&&(h.cspNonce=""),typeof h.preferScriptTags>"u"&&(h.preferScriptTags=!1),h.nodeCachedData&&typeof h.nodeCachedData=="object"&&(typeof h.nodeCachedData.seed!="string"&&(h.nodeCachedData.seed="seed"),(typeof h.nodeCachedData.writeDelay!="number"||h.nodeCachedData.writeDelay<0)&&(h.nodeCachedData.writeDelay=1e3*7),!h.nodeCachedData.path||typeof h.nodeCachedData.path!="string")){const g=t(new Error("INVALID cached data configuration, 'path' MUST be set"));g.phase="configuration",h.onError(g),h.nodeCachedData=void 0}return h}static mergeConfigurationOptions(h=null,N=null){let g=O.Utilities.recursiveClone(N||{});return O.Utilities.forEachProperty(h,(a,u)=>{a==="ignoreDuplicateModules"&&typeof g.ignoreDuplicateModules<"u"?g.ignoreDuplicateModules=g.ignoreDuplicateModules.concat(u):a==="paths"&&typeof g.paths<"u"?O.Utilities.forEachProperty(u,(c,w)=>g.paths[c]=w):a==="config"&&typeof g.config<"u"?O.Utilities.forEachProperty(u,(c,w)=>g.config[c]=w):g[a]=O.Utilities.recursiveClone(u)}),i.validateConfigurationOptions(g)}}O.ConfigurationOptionsUtil=i;class y{constructor(h,N){if(this._env=h,this.options=i.mergeConfigurationOptions(N),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let g=this.options.nodeRequire.main.filename,a=Math.max(g.lastIndexOf("/"),g.lastIndexOf("\\"));this.options.baseUrl=g.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let h=0;h<this.options.ignoreDuplicateModules.length;h++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[h]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,(h,N)=>{Array.isArray(N)?this.sortedPathsRules.push({from:h,to:N}):this.sortedPathsRules.push({from:h,to:[N]})}),this.sortedPathsRules.sort((h,N)=>N.from.length-h.from.length)}cloneAndMerge(h){return new y(this._env,i.mergeConfigurationOptions(h,this.options))}getOptionsLiteral(){return this.options}_applyPaths(h){let N;for(let g=0,a=this.sortedPathsRules.length;g<a;g++)if(N=this.sortedPathsRules[g],O.Utilities.startsWith(h,N.from)){let u=[];for(let c=0,w=N.to.length;c<w;c++)u.push(N.to[c]+h.substr(N.from.length));return u}return[h]}_addUrlArgsToUrl(h){return O.Utilities.containsQueryString(h)?h+"&"+this.options.urlArgs:h+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(h){return this.options.urlArgs?this._addUrlArgsToUrl(h):h}_addUrlArgsIfNecessaryToUrls(h){if(this.options.urlArgs)for(let N=0,g=h.length;N<g;N++)h[N]=this._addUrlArgsToUrl(h[N]);return h}moduleIdToPaths(h){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(h))return this.isBuild()?["empty:"]:["node|"+h];let N=h,g;if(!O.Utilities.endsWith(N,".js")&&!O.Utilities.isAbsolutePath(N)){g=this._applyPaths(N);for(let a=0,u=g.length;a<u;a++)this.isBuild()&&g[a]==="empty:"||(O.Utilities.isAbsolutePath(g[a])||(g[a]=this.options.baseUrl+g[a]),!O.Utilities.endsWith(g[a],".js")&&!O.Utilities.containsQueryString(g[a])&&(g[a]=g[a]+".js"))}else!O.Utilities.endsWith(N,".js")&&!O.Utilities.containsQueryString(N)&&(N=N+".js"),g=[N];return this._addUrlArgsIfNecessaryToUrls(g)}requireToUrl(h){let N=h;return O.Utilities.isAbsolutePath(N)||(N=this._applyPaths(N)[0],O.Utilities.isAbsolutePath(N)||(N=this.options.baseUrl+N)),this._addUrlArgsIfNecessaryToUrl(N)}isBuild(){return this.options.isBuild}shouldInvokeFactory(h){return!!(!this.options.isBuild||O.Utilities.isAnonymousModule(h)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[h])}isDuplicateMessageIgnoredFor(h){return this.ignoreDuplicateModulesMap.hasOwnProperty(h)}getConfigForModule(h){if(this.options.config)return this.options.config[h]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(h){this.options.onError(h)}}O.Configuration=y})($e||($e={}));var $e;(function(O){class t{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,c,w,d){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new R;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=u.getConfig().getOptionsLiteral();e?this._scriptLoader=new i:this._scriptLoader=new h(this._env)}else this._env.isNode?this._scriptLoader=new h(this._env):this._scriptLoader=new i;let m={callback:w,errorback:d};if(this._callbackMap.hasOwnProperty(c)){this._callbackMap[c].push(m);return}this._callbackMap[c]=[m],this._scriptLoader.load(u,c,()=>this.triggerCallback(c),e=>this.triggerErrorback(c,e))}triggerCallback(u){let c=this._callbackMap[u];delete this._callbackMap[u];for(let w=0;w<c.length;w++)c[w].callback()}triggerErrorback(u,c){let w=this._callbackMap[u];delete this._callbackMap[u];for(let d=0;d<w.length;d++)w[d].errorback(c)}}class i{attachListeners(u,c,w){let d=()=>{u.removeEventListener("load",m),u.removeEventListener("error",e)},m=P=>{d(),c()},e=P=>{d(),w(P)};u.addEventListener("load",m),u.addEventListener("error",e)}load(u,c,w,d){if(/^node\|/.test(c)){let m=u.getConfig().getOptionsLiteral(),e=N(u.getRecorder(),m.nodeRequire||O.global.nodeRequire),P=c.split("|"),j=null;try{j=e(P[1])}catch(L){d(L);return}u.enqueueDefineAnonymousModule([],()=>j),w()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,w,d);const{trustedTypesPolicy:e}=u.getConfig().getOptionsLiteral();e&&(c=e.createScriptURL(c)),m.setAttribute("src",c);const{cspNonce:P}=u.getConfig().getOptionsLiteral();P&&m.setAttribute("nonce",P),document.getElementsByTagName("head")[0].appendChild(m)}}}function y(a){const{trustedTypesPolicy:u}=a.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class R{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=y(u)),this._cachedCanUseEval}load(u,c,w,d){if(/^node\|/.test(c)){const m=u.getConfig().getOptionsLiteral(),e=N(u.getRecorder(),m.nodeRequire||O.global.nodeRequire),P=c.split("|");let j=null;try{j=e(P[1])}catch(L){d(L);return}u.enqueueDefineAnonymousModule([],function(){return j}),w()}else{const{trustedTypesPolicy:m}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(c).then(P=>{if(P.status!==200)throw new Error(P.statusText);return P.text()}).then(P=>{P=`${P}
//# sourceURL=${c}`,(m?self.eval(m.createScript("",P)):new Function(P)).call(self),w()}).then(void 0,d);return}try{m&&(c=m.createScriptURL(c)),importScripts(c),w()}catch(P){d(P)}}}}class h{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,c){const{nodeCachedData:w}=c.getConfig().getOptionsLiteral();if(!w||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const d=this,m=u("module");function e(P){const j=P.constructor;let L=function(v){try{return P.require(v)}finally{}};return L.resolve=function(v,p){return j._resolveFilename(v,P,!1,p)},L.resolve.paths=function(v){return j._resolveLookupPaths(v,P)},L.main=process.mainModule,L.extensions=j._extensions,L.cache=j._cache,L}m.prototype._compile=function(P,j){const L=m.wrap(P.replace(/^#!.*/,"")),$=c.getRecorder(),v=d._getCachedDataPath(w,j),p={filename:j};let l;try{const E=d._fs.readFileSync(v);l=E.slice(0,16),p.cachedData=E.slice(16),$.record(60,v)}catch{$.record(61,v)}const n=new d._vm.Script(L,p),s=n.runInThisContext(p),f=d._path.dirname(j),o=e(this),b=[this.exports,o,this,j,f,process,Xe,Buffer],A=s.apply(this.exports,b);return d._handleCachedData(n,L,v,!p.cachedData,c),d._verifyCachedData(n,L,v,l,c),A}}load(u,c,w,d){const m=u.getConfig().getOptionsLiteral(),e=N(u.getRecorder(),m.nodeRequire||O.global.nodeRequire),P=m.nodeInstrumenter||function(L){return L};this._init(e),this._initNodeRequire(e,u);let j=u.getRecorder();if(/^node\|/.test(c)){let L=c.split("|"),$=null;try{$=e(L[1])}catch(v){d(v);return}u.enqueueDefineAnonymousModule([],()=>$),w()}else{c=O.Utilities.fileUriToFilePath(this._env.isWindows,c);const L=this._path.normalize(c),$=this._getElectronRendererScriptPathOrUri(L),v=!!m.nodeCachedData,p=v?this._getCachedDataPath(m.nodeCachedData,c):void 0;this._readSourceAndCachedData(L,p,j,(l,n,s,f)=>{if(l){d(l);return}let o;n.charCodeAt(0)===h._BOM?o=h._PREFIX+n.substring(1)+h._SUFFIX:o=h._PREFIX+n+h._SUFFIX,o=P(o,L);const b={filename:$,cachedData:s},A=this._createAndEvalScript(u,o,b,w,d);this._handleCachedData(A,o,p,v&&!s,u),this._verifyCachedData(A,o,p,f,u)})}}_createAndEvalScript(u,c,w,d,m){const e=u.getRecorder();e.record(31,w.filename);const P=new this._vm.Script(c,w),j=P.runInThisContext(w),L=u.getGlobalAMDDefineFunc();let $=!1;const v=function(){return $=!0,L.apply(null,arguments)};return v.amd=L.amd,j.call(O.global,u.getGlobalAMDRequireFunc(),v,w.filename,this._path.dirname(w.filename)),e.record(32,w.filename),$?d():m(new Error(`Didn't receive define call in ${w.filename}!`)),P}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let c=u.match(/^([a-z])\:(.*)/i);return c?`file:///${(c[1].toUpperCase()+":"+c[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,c){const w=this._crypto.createHash("md5").update(c,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),d=this._path.basename(c).replace(/\.js$/,"");return this._path.join(u.path,`${d}-${w}.code`)}_handleCachedData(u,c,w,d,m){u.cachedDataRejected?this._fs.unlink(w,e=>{m.getRecorder().record(62,w),this._createAndWriteCachedData(u,c,w,m),e&&m.getConfig().onError(e)}):d&&this._createAndWriteCachedData(u,c,w,m)}_createAndWriteCachedData(u,c,w,d){let m=Math.ceil(d.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,P=0,j;const L=()=>{setTimeout(()=>{j||(j=this._crypto.createHash("md5").update(c,"utf8").digest());const $=u.createCachedData();if(!($.length===0||$.length===e||P>=5)){if($.length<e){L();return}e=$.length,this._fs.writeFile(w,Buffer.concat([j,$]),v=>{v&&d.getConfig().onError(v),d.getRecorder().record(63,w),L()})}},m*Math.pow(4,P++))};L()}_readSourceAndCachedData(u,c,w,d){if(!c)this._fs.readFile(u,{encoding:"utf8"},d);else{let m,e,P,j=2;const L=$=>{$?d($):--j===0&&d(void 0,m,e,P)};this._fs.readFile(u,{encoding:"utf8"},($,v)=>{m=v,L($)}),this._fs.readFile(c,($,v)=>{!$&&v&&v.length>0?(P=v.slice(0,16),e=v.slice(16),w.record(60,c)):w.record(61,c),L()})}}_verifyCachedData(u,c,w,d,m){d&&(u.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(c,"utf8").digest();d.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${w}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(w,P=>{P&&m.getConfig().onError(P)}))},Math.ceil(5e3*(1+Math.random()))))}}h._BOM=65279,h._PREFIX="(function (require, define, __filename, __dirname) { ",h._SUFFIX=`
});`;function N(a,u){if(u.__$__isRecorded)return u;const c=function(d){a.record(33,d);try{return u(d)}finally{a.record(34,d)}};return c.__$__isRecorded=!0,c}O.ensureRecordedNodeRequire=N;function g(a){return new t(a)}O.createScriptLoader=g})($e||($e={}));var $e;(function(O){class t{constructor(a){let u=a.lastIndexOf("/");u!==-1?this.fromModulePath=a.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(a){let u=a,c;for(c=/\/\.\//;c.test(u);)u=u.replace(c,"/");for(u=u.replace(/^\.\//g,""),c=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;c.test(u);)u=u.replace(c,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(a){let u=a;return O.Utilities.isAbsolutePath(u)||(O.Utilities.startsWith(u,"./")||O.Utilities.startsWith(u,"../"))&&(u=t._normalizeModuleId(this.fromModulePath+u)),u}}t.ROOT=new t(""),O.ModuleIdResolver=t;class i{constructor(a,u,c,w,d,m){this.id=a,this.strId=u,this.dependencies=c,this._callback=w,this._errorback=d,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,u){try{return{returnedValue:a.apply(O.global,u),producedError:null}}catch(c){return{returnedValue:null,producedError:c}}}static _invokeFactory(a,u,c,w){return a.shouldInvokeFactory(u)?a.shouldCatchError()?this._safeInvokeFunction(c,w):{returnedValue:c.apply(O.global,w),producedError:null}:{returnedValue:null,producedError:null}}complete(a,u,c,w){this._isComplete=!0;let d=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let m=i._invokeFactory(u,this.strId,this._callback,c);d=m.producedError,a.record(22,this.strId),!d&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(d){let m=O.ensureError(d);m.phase="factory",m.moduleId=this.strId,m.neededBy=w(this.id),this.error=m,u.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}O.Module=i;class y{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let u=this._strModuleIdToIntModuleId.get(a);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(a,u),this._intModuleIdToStrModuleId[u]=a),u}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class R{constructor(a){this.id=a}}R.EXPORTS=new R(0),R.MODULE=new R(1),R.REQUIRE=new R(2),O.RegularDependency=R;class h{constructor(a,u,c){this.id=a,this.pluginId=u,this.pluginParam=c}}O.PluginDependency=h;class N{constructor(a,u,c,w,d=0){this._env=a,this._scriptLoader=u,this._loaderAvailableTimestamp=d,this._defineFunc=c,this._requireFunc=w,this._moduleIdProvider=new y,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new N(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,u){let c=m=>m.replace(/\\/g,"/"),w=c(a),d=u.split(/\n/);for(let m=0;m<d.length;m++){let e=d[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let P=e[1],j=e[2],L=e[3],$=Math.max(P.lastIndexOf(" ")+1,P.lastIndexOf("(")+1);if(P=P.substr($),P=c(P),P===w){let v={line:parseInt(j,10),col:parseInt(L,10)};return v.line===1&&(v.col-=53),v}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],u=0;for(let c=0,w=this._modules2.length;c<w;c++){let d=this._modules2[c];if(!d)continue;let m=this._buildInfoPath[d.id]||null,e=this._buildInfoDefineStack[d.id]||null,P=this._buildInfoDependencies[d.id];a[u++]={id:d.strId,path:m,defineLocation:m&&e?N._findRelevantLocationInStack(m,e):null,dependencies:P,shim:null,exports:d.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let c=null;this._config.isBuild()&&(c=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:c,dependencies:a,callback:u}}defineModule(a,u,c,w,d,m=new t(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let P=new i(e,a,this._normalizeDependencies(u,m),c,w,m);this._modules2[e]=P,this._config.isBuild()&&(this._buildInfoDefineStack[e]=d,this._buildInfoDependencies[e]=(P.dependencies||[]).map(j=>this._moduleIdProvider.getStrModuleId(j.id))),this._resolve(P)}_normalizeDependency(a,u){if(a==="exports")return R.EXPORTS;if(a==="module")return R.MODULE;if(a==="require")return R.REQUIRE;let c=a.indexOf("!");if(c>=0){let w=u.resolveModule(a.substr(0,c)),d=u.resolveModule(a.substr(c+1)),m=this._moduleIdProvider.getModuleId(w+"!"+d),e=this._moduleIdProvider.getModuleId(w);return new h(m,e,d)}return new R(this._moduleIdProvider.getModuleId(u.resolveModule(a)))}_normalizeDependencies(a,u){let c=[],w=0;for(let d=0,m=a.length;d<m;d++)c[w++]=this._normalizeDependency(a[d],u);return c}_relativeRequire(a,u,c,w){if(typeof u=="string")return this.synchronousRequire(u,a);this.defineModule(O.Utilities.generateAnonymousModule(),u,c,w,null,a)}synchronousRequire(a,u=new t(a)){let c=this._normalizeDependency(a,u),w=this._modules2[c.id];if(!w)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!w.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(w.error)throw w.error;return w.exports}configure(a,u){let c=this._config.shouldRecordStats();u?this._config=new O.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!c&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),u.dependencies,u.callback,null,u.stack)}}_createLoadError(a,u){let c=this._moduleIdProvider.getStrModuleId(a),w=(this._inverseDependencies2[a]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const d=O.ensureError(u);return d.phase="loading",d.moduleId=c,d.neededBy=w,d}_onLoadError(a,u){const c=this._createLoadError(a,u);this._modules2[a]||(this._modules2[a]=new i(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let w=[];for(let e=0,P=this._moduleIdProvider.getMaxModuleId();e<P;e++)w[e]=!1;let d=!1,m=[];for(m.push(a),w[a]=!0;m.length>0;){let e=m.shift(),P=this._modules2[e];P&&(d=P.onDependencyError(c)||d);let j=this._inverseDependencies2[e];if(j)for(let L=0,$=j.length;L<$;L++){let v=j[L];w[v]||(m.push(v),w[v]=!0)}}d||this._config.onError(c)}_hasDependencyPath(a,u){let c=this._modules2[a];if(!c)return!1;let w=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)w[m]=!1;let d=[];for(d.push(c),w[a]=!0;d.length>0;){let e=d.shift().dependencies;if(e)for(let P=0,j=e.length;P<j;P++){let L=e[P];if(L.id===u)return!0;let $=this._modules2[L.id];$&&!w[L.id]&&(w[L.id]=!0,d.push($))}}return!1}_findCyclePath(a,u,c){if(a===u||c===50)return[a];let w=this._modules2[a];if(!w)return null;let d=w.dependencies;if(d)for(let m=0,e=d.length;m<e;m++){let P=this._findCyclePath(d[m].id,u,c+1);if(P!==null)return P.push(a),P}return null}_createRequire(a){let u=(c,w,d)=>this._relativeRequire(a,c,w,d);return u.toUrl=c=>this._config.requireToUrl(a.resolveModule(c)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(c,w=!1)=>{this.configure(c,w)},u.__$__nodeRequire=O.global.nodeRequire,u}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let u=this._moduleIdProvider.getStrModuleId(a),c=this._config.moduleIdToPaths(u),w=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||w.test(u))&&c.push("node|"+u);let d=-1,m=e=>{if(d++,d>=c.length)this._onLoadError(a,e);else{let P=c[d],j=this.getRecorder();if(this._config.isBuild()&&P==="empty:"){this._buildInfoPath[a]=P,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}j.record(10,P),this._scriptLoader.load(this,P,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=P),j.record(11,P),this._onLoad(a)},L=>{j.record(12,P),m(L)})}};m(null)}_loadPluginDependency(a,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let c=w=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],w,null,null)};c.error=w=>{this._config.onError(this._createLoadError(u.id,w))},a.load(u.pluginParam,this._createRequire(t.ROOT),c,this._config.getOptionsLiteral())}_resolve(a){let u=a.dependencies;if(u)for(let c=0,w=u.length;c<w;c++){let d=u[c];if(d===R.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(d===R.MODULE){a.unresolvedDependenciesCount--;continue}if(d===R.REQUIRE){a.unresolvedDependenciesCount--;continue}let m=this._modules2[d.id];if(m&&m.isComplete()){if(m.error){a.onDependencyError(m.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(d.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(d.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(d.id,a.id,0)||[];e.reverse(),e.push(d.id),console.warn(e.map(P=>this._moduleIdProvider.getStrModuleId(P)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[d.id]=this._inverseDependencies2[d.id]||[],this._inverseDependencies2[d.id].push(a.id),d instanceof h){let e=this._modules2[d.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,d);continue}let P=this._inversePluginDependencies2.get(d.pluginId);P||(P=[],this._inversePluginDependencies2.set(d.pluginId,P)),P.push(d),this._loadModule(d.pluginId);continue}this._loadModule(d.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let u=this.getRecorder();if(a.isComplete())return;let c=a.dependencies,w=[];if(c)for(let P=0,j=c.length;P<j;P++){let L=c[P];if(L===R.EXPORTS){w[P]=a.exports;continue}if(L===R.MODULE){w[P]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(L===R.REQUIRE){w[P]=this._createRequire(a.moduleIdResolver);continue}let $=this._modules2[L.id];if($){w[P]=$.exports;continue}w[P]=null}const d=P=>(this._inverseDependencies2[P]||[]).map(j=>this._moduleIdProvider.getStrModuleId(j));a.complete(u,this._config,w,d);let m=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,m)for(let P=0,j=m.length;P<j;P++){let L=m[P],$=this._modules2[L];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let P=0,j=e.length;P<j;P++)this._loadPluginDependency(a.exports,e[P])}}}O.ModuleManager=N})($e||($e={}));var ie,$e;(function(O){const t=new O.Environment;let i=null;const y=function(g,a,u){typeof g!="string"&&(u=a,a=g,g=null),(typeof a!="object"||!Array.isArray(a))&&(u=a,a=null),a||(a=["require","exports","module"]),g?i.defineModule(g,a,u,null,null):i.enqueueDefineAnonymousModule(a,u)};y.amd={jQuery:!0};const R=function(g,a=!1){i.configure(g,a)},h=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){R(arguments[0]);return}if(typeof arguments[0]=="string")return i.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){i.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};h.config=R,h.getConfig=function(){return i.getConfig().getOptionsLiteral()},h.reset=function(){i=i.reset()},h.getBuildInfo=function(){return i.getBuildInfo()},h.getStats=function(){return i.getLoaderEvents()},h.define=y;function N(){if(typeof O.global.require<"u"||typeof require<"u"){const g=O.global.require||require;if(typeof g=="function"&&typeof g.resolve=="function"){const a=O.ensureRecordedNodeRequire(i.getRecorder(),g);O.global.nodeRequire=a,h.nodeRequire=a,h.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=h:(t.isElectronRenderer||(O.global.define=y),O.global.require=h)}O.init=N,(typeof O.global.define!="function"||!O.global.define.amd)&&(i=new O.ModuleManager(t,O.createScriptLoader(t),y,h,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require<"u"&&typeof O.global.require!="function"&&h.config(O.global.require),ie=function(){return y.apply(null,arguments)},ie.amd=y.amd,typeof doNotInitLoader>"u"&&N())})($e||($e={})),ie(se[72],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=i;function i(g,a,u,c){if(c=c||{},(c["vs/css"]||{}).disabled){u({});return}const d=a.toUrl(g+".css");y(g,d,()=>{u({})},m=>{typeof u.error=="function"&&u.error("Could not find "+d+".")})}function y(g,a,u,c){if(R(g,a)){u();return}h(g,a,u,c)}function R(g,a){const u=window.document.getElementsByTagName("link");for(let c=0,w=u.length;c<w;c++){const d=u[c].getAttribute("data-name"),m=u[c].getAttribute("href");if(d===g||m===a)return!0}return!1}function h(g,a,u,c){const w=document.createElement("link");w.setAttribute("rel","stylesheet"),w.setAttribute("type","text/css"),w.setAttribute("data-name",g),N(g,w,u,c),w.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(w)}function N(g,a,u,c){const w=()=>{a.removeEventListener("load",d),a.removeEventListener("error",m)},d=e=>{w(),u()},m=e=>{w(),c(e)};a.addEventListener("load",d),a.addEventListener("error",m)}}),ie("vs/nls",["require","exports"],function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localize=c,t.localize2=w,t.getConfiguredDefaultLocale=d,t.setPseudoTranslation=m,t.create=e,t.load=P;let i=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const y="i-default";function R(j,L){let $;return L.length===0?$=j:$=j.replace(/\{(\d+)\}/g,(v,p)=>{const l=p[0],n=L[l];let s=v;return typeof n=="string"?s=n:(typeof n=="number"||typeof n=="boolean"||n===void 0||n===null)&&(s=String(n)),s}),i&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function h(j,L){let $=j[L];return $||($=j["*"],$)?$:null}function N(j){return j.charAt(j.length-1)==="/"?j:j+"/"}async function g(j,L,$){const v=N(j)+N(L)+"vscode/"+N($),p=await fetch(v);if(p.ok)return await p.json();throw new Error(`${p.status} - ${p.statusText}`)}function a(j){return function(L,$){const v=Array.prototype.slice.call(arguments,2);return R(j[L],v)}}function u(j){return(L,$,...v)=>({value:R(j[L],v),original:R($,v)})}function c(j,L,...$){return R(L,$)}function w(j,L,...$){const v=R(L,$);return{value:v,original:v}}function d(j){}function m(j){i=j}function e(j,L){return{localize:a(L[j]),localize2:u(L[j]),getConfiguredDefaultLocale:L.getConfiguredDefaultLocale??($=>{})}}function P(j,L,$,v){const p=v["vs/nls"]??{};if(!j||j.length===0)return $({localize:c,localize2:w,getConfiguredDefaultLocale:()=>p.availableLanguages?.["*"]});const l=p.availableLanguages?h(p.availableLanguages,j):null,n=l===null||l===y;let s=".nls";n||(s=s+"."+l);const f=o=>{Array.isArray(o)?(o.localize=a(o),o.localize2=u(o)):(o.localize=a(o[j]),o.localize2=u(o[j])),o.getConfiguredDefaultLocale=()=>p.availableLanguages?.["*"],$(o)};typeof p.loadBundle=="function"?p.loadBundle(j,l,(o,b)=>{o?L([j+".nls"],f):f(b)}):p.translationServiceUrl&&!n?(async()=>{try{const o=await g(p.translationServiceUrl,l,j);return f(o)}catch(o){if(!l.includes("-"))return console.error(o),L([j+".nls"],f);try{const b=l.split("-")[0],A=await g(p.translationServiceUrl,b,j);return p.availableLanguages??={},p.availableLanguages["*"]=b,f(A)}catch(b){return console.error(b),L([j+".nls"],f)}}})():L([j+s],f,o=>{if(s===".nls"){console.error("Failed trying to load default language strings",o);return}console.error(`Failed to load message bundle for language ${l}. Falling back to the default language:`,o),L([j+".nls"],f)})}}),function(){const O=globalThis.MonacoEnvironment,t=O&&O.baseUrl?O.baseUrl:"../../../";function i(c,w){if(O?.createTrustedTypesPolicy)try{return O.createTrustedTypesPolicy(c,w)}catch(d){console.warn(d);return}try{return self.trustedTypes?.createPolicy(c,w)}catch(d){console.warn(d);return}}const y=i("amdLoader",{createScriptURL:c=>c,createScript:(c,...w)=>{const d=w.slice(0,-1).join(","),m=w.pop().toString();return`(function anonymous(${d}) { ${m}
})`}});function R(){try{return(y?globalThis.eval(y.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function h(){return new Promise((c,w)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return c();const d=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(d)&&d.substring(0,globalThis.origin.length)!==globalThis.origin)&&R()){fetch(d).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${d}`,(y?globalThis.eval(y.createScript("",e)):new Function(e)).call(globalThis),c()}).then(void 0,w);return}y?importScripts(y.createScriptURL(d)):importScripts(d),c()})}function N(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:y,amdModulesPattern:/^vs\//})}function g(c){h().then(()=>{N(),require([c],function(w){setTimeout(function(){const d=w.create((m,e)=>{globalThis.postMessage(m,e)},null);for(globalThis.onmessage=m=>d.onmessage(m.data,m.ports);u.length>0;){const m=u.shift();d.onmessage(m.data,m.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&N();let a=!0;const u=[];globalThis.onmessage=c=>{if(!a){u.push(c);return}a=!1,g(c.data)}}(),ie(se[9],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=y,t.$hb=R,t.$ib=h,t.$jb=N,t.$kb=g,t.$lb=a,t.$nb=c,t.$ob=w,t.$pb=d,t.$qb=m,t.$rb=e;function i(P,j){const L=y(P,j);if(L!==-1)return P[L]}function y(P,j,L=P.length-1){for(let $=L;$>=0;$--){const v=P[$];if(j(v))return $}return-1}function R(P,j){const L=h(P,j);return L===-1?void 0:P[L]}function h(P,j,L=0,$=P.length){let v=L,p=$;for(;v<p;){const l=Math.floor((v+p)/2);j(P[l])?v=l+1:p=l}return v-1}function N(P,j){const L=g(P,j);return L===P.length?void 0:P[L]}function g(P,j,L=0,$=P.length){let v=L,p=$;for(;v<p;){const l=Math.floor((v+p)/2);j(P[l])?p=l:v=l+1}return v}function a(P,j,L=0,$=P.length){const v=g(P,j,L,$);return v===P.length?-1:v}class u{static{this.assertInvariants=!1}constructor(j){this.e=j,this.c=0}findLastMonotonous(j){if(u.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!j($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=j}const L=h(this.e,j,this.c);return this.c=L+1,L===-1?void 0:this.e[L]}}t.$mb=u;function c(P,j){if(P.length===0)return;let L=P[0];for(let $=1;$<P.length;$++){const v=P[$];j(v,L)>0&&(L=v)}return L}function w(P,j){if(P.length===0)return;let L=P[0];for(let $=1;$<P.length;$++){const v=P[$];j(v,L)>=0&&(L=v)}return L}function d(P,j){return c(P,(L,$)=>-j(L,$))}function m(P,j){if(P.length===0)return-1;let L=0;for(let $=1;$<P.length;$++){const v=P[$];j(v,P[L])>0&&(L=$)}return L}function e(P,j){for(const L of P){const $=j(L);if($!==void 0)return $}}}),ie(se[35],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=y,t.$M=R,t.$N=h;function i(N,g){const a=Object.create(null);for(const u of N){const c=g(u);let w=a[c];w||(w=a[c]=[]),w.push(u)}return a}function y(N,g){const a=[],u=[];for(const c of N)g.has(c)||a.push(c);for(const c of g)N.has(c)||u.push(c);return{removed:a,added:u}}function R(N,g){const a=[],u=[];for(const[c,w]of N)g.has(c)||a.push(w);for(const[c,w]of g)N.has(c)||u.push(w);return{removed:a,added:u}}function h(N,g){const a=new Set;for(const u of g)N.has(u)&&a.add(u);return a}}),ie(se[36],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ot=t.$Nt=t.$Mt=t.$Lt=void 0;function i(g,a){const u=Math.pow(10,a);return Math.round(g*u)/u}class y{constructor(a,u,c,w=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,c))|0,this.a=i(Math.max(Math.min(1,w),0),3)}static equals(a,u){return a.r===u.r&&a.g===u.g&&a.b===u.b&&a.a===u.a}}t.$Lt=y;class R{constructor(a,u,c,w){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.l=i(Math.max(Math.min(1,c),0),3),this.a=i(Math.max(Math.min(1,w),0),3)}static equals(a,u){return a.h===u.h&&a.s===u.s&&a.l===u.l&&a.a===u.a}static fromRGBA(a){const u=a.r/255,c=a.g/255,w=a.b/255,d=a.a,m=Math.max(u,c,w),e=Math.min(u,c,w);let P=0,j=0;const L=(e+m)/2,$=m-e;if($>0){switch(j=Math.min(L<=.5?$/(2*L):$/(2-2*L),1),m){case u:P=(c-w)/$+(c<w?6:0);break;case c:P=(w-u)/$+2;break;case w:P=(u-c)/$+4;break}P*=60,P=Math.round(P)}return new R(P,j,L,d)}static i(a,u,c){return c<0&&(c+=1),c>1&&(c-=1),c<1/6?a+(u-a)*6*c:c<1/2?u:c<2/3?a+(u-a)*(2/3-c)*6:a}static toRGBA(a){const u=a.h/360,{s:c,l:w,a:d}=a;let m,e,P;if(c===0)m=e=P=w;else{const j=w<.5?w*(1+c):w+c-w*c,L=2*w-j;m=R.i(L,j,u+1/3),e=R.i(L,j,u),P=R.i(L,j,u-1/3)}return new y(Math.round(m*255),Math.round(e*255),Math.round(P*255),d)}}t.$Mt=R;class h{constructor(a,u,c,w){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.v=i(Math.max(Math.min(1,c),0),3),this.a=i(Math.max(Math.min(1,w),0),3)}static equals(a,u){return a.h===u.h&&a.s===u.s&&a.v===u.v&&a.a===u.a}static fromRGBA(a){const u=a.r/255,c=a.g/255,w=a.b/255,d=Math.max(u,c,w),m=Math.min(u,c,w),e=d-m,P=d===0?0:e/d;let j;return e===0?j=0:d===u?j=((c-w)/e%6+6)%6:d===c?j=(w-u)/e+2:j=(u-c)/e+4,new h(Math.round(j*60),P,d,a.a)}static toRGBA(a){const{h:u,s:c,v:w,a:d}=a,m=w*c,e=m*(1-Math.abs(u/60%2-1)),P=w-m;let[j,L,$]=[0,0,0];return u<60?(j=m,L=e):u<120?(j=e,L=m):u<180?(L=m,$=e):u<240?(L=e,$=m):u<300?(j=e,$=m):u<=360&&(j=m,$=e),j=Math.round((j+P)*255),L=Math.round((L+P)*255),$=Math.round(($+P)*255),new y(j,L,$,d)}}t.$Nt=h;class N{static fromHex(a){return N.Format.CSS.parseHex(a)||N.red}static equals(a,u){return!a&&!u?!0:!a||!u?!1:a.equals(u)}get hsla(){return this.i?this.i:R.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:h.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof y)this.rgba=a;else if(a instanceof R)this.i=a,this.rgba=R.toRGBA(a);else if(a instanceof h)this.j=a,this.rgba=h.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&y.equals(this.rgba,a.rgba)&&R.equals(this.hsla,a.hsla)&&h.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=N.k(this.rgba.r),u=N.k(this.rgba.g),c=N.k(this.rgba.b),w=.2126*a+.7152*u+.0722*c;return i(w,4)}static k(a){const u=a/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(a){const u=this.getRelativeLuminance(),c=a.getRelativeLuminance();return u>c?(u+.05)/(c+.05):(c+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const u=this.getRelativeLuminance(),c=a.getRelativeLuminance();return u>c}isDarkerThan(a){const u=this.getRelativeLuminance(),c=a.getRelativeLuminance();return u<c}lighten(a){return new N(new R(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new N(new R(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:u,g:c,b:w,a:d}=this.rgba;return new N(new y(u,c,w,d*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new N(new y(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const u=a.rgba,c=this.rgba.a,w=u.a,d=c+w*(1-c);if(d<1e-6)return N.transparent;const m=this.rgba.r*c/d+u.r*w*(1-c)/d,e=this.rgba.g*c/d+u.g*w*(1-c)/d,P=this.rgba.b*c/d+u.b*w*(1-c)/d;return new N(new y(m,e,P,d))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:u,g:c,b:w,a:d}=this.rgba;return new N(new y(a.rgba.r-d*(a.rgba.r-u),a.rgba.g-d*(a.rgba.g-c),a.rgba.b-d*(a.rgba.b-w),1))}flatten(...a){const u=a.reduceRight((c,w)=>N.o(w,c));return N.o(this,u)}static o(a,u){const c=1-a.rgba.a;return new N(new y(c*u.rgba.r+a.rgba.a*a.rgba.r,c*u.rgba.g+a.rgba.a*a.rgba.g,c*u.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=N.Format.CSS.format(this)),this.u}static getLighterColor(a,u,c){if(a.isLighterThan(u))return a;c=c||.5;const w=a.getRelativeLuminance(),d=u.getRelativeLuminance();return c=c*(d-w)/d,a.lighten(c)}static getDarkerColor(a,u,c){if(a.isDarkerThan(u))return a;c=c||.5;const w=a.getRelativeLuminance(),d=u.getRelativeLuminance();return c=c*(w-d)/w,a.darken(c)}static{this.white=new N(new y(255,255,255,1))}static{this.black=new N(new y(0,0,0,1))}static{this.red=new N(new y(255,0,0,1))}static{this.blue=new N(new y(0,0,255,1))}static{this.green=new N(new y(0,255,0,1))}static{this.cyan=new N(new y(0,255,255,1))}static{this.lightgrey=new N(new y(211,211,211,1))}static{this.transparent=new N(new y(0,0,0,0))}}t.$Ot=N,function(g){let a;(function(u){let c;(function(w){function d(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:g.Format.CSS.formatRGBA(n)}w.formatRGB=d;function m(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}w.formatRGBA=m;function e(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:g.Format.CSS.formatHSLA(n)}w.formatHSL=e;function P(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}w.formatHSLA=P;function j(n){const s=n.toString(16);return s.length!==2?"0"+s:s}function L(n){return`#${j(n.rgba.r)}${j(n.rgba.g)}${j(n.rgba.b)}`}w.formatHex=L;function $(n,s=!1){return s&&n.rgba.a===1?g.Format.CSS.formatHex(n):`#${j(n.rgba.r)}${j(n.rgba.g)}${j(n.rgba.b)}${j(Math.round(n.rgba.a*255))}`}w.formatHexA=$;function v(n){return n.isOpaque()?g.Format.CSS.formatHex(n):g.Format.CSS.formatRGBA(n)}w.format=v;function p(n){const s=n.length;if(s===0||n.charCodeAt(0)!==35)return null;if(s===7){const f=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),o=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),b=16*l(n.charCodeAt(5))+l(n.charCodeAt(6));return new g(new y(f,o,b,1))}if(s===9){const f=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),o=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),b=16*l(n.charCodeAt(5))+l(n.charCodeAt(6)),A=16*l(n.charCodeAt(7))+l(n.charCodeAt(8));return new g(new y(f,o,b,A/255))}if(s===4){const f=l(n.charCodeAt(1)),o=l(n.charCodeAt(2)),b=l(n.charCodeAt(3));return new g(new y(16*f+f,16*o+o,16*b+b))}if(s===5){const f=l(n.charCodeAt(1)),o=l(n.charCodeAt(2)),b=l(n.charCodeAt(3)),A=l(n.charCodeAt(4));return new g(new y(16*f+f,16*o+o,16*b+b,(16*A+A)/255))}return null}w.parseHex=p;function l(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(c=u.CSS||(u.CSS={}))})(a=g.Format||(g.Format={}))}(N||(t.$Ot=N={}))}),ie(se[37],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wt=void 0;class i{constructor(R,h,N,g){this.originalStart=R,this.originalLength=h,this.modifiedStart=N,this.modifiedLength=g}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$wt=i}),ie(se[3],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=y,t.$Z=R,t.$1=h,t.$2=N,t.$3=g,t.$4=u,t.$6=w,t.$7=d,t.$8=m,t.$0=P;class i{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?v.isErrorNoTelemetry(n)?new v(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}t.$W=i,t.$X=new i;function y(l){t.$X.setUnexpectedErrorHandler(l)}function R(l){if(!l||typeof l!="object")return!1;const n=l;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function h(l){u(l)||t.$X.onUnexpectedError(l)}function N(l){u(l)||t.$X.onUnexpectedExternalError(l)}function g(l){if(l instanceof Error){const{name:n,message:s}=l,f=l.stacktrace||l.stack;return{$isError:!0,name:n,message:s,stack:f,noTelemetry:v.isErrorNoTelemetry(l)}}return l}const a="Canceled";function u(l){return l instanceof c?!0:l instanceof Error&&l.name===a&&l.message===a}class c extends Error{constructor(){super(a),this.name=this.message}}t.$5=c;function w(){const l=new Error(a);return l.name=l.message,l}function d(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function m(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class e extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function P(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class j extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}t.$$=j;class L extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}t.$_=L;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=$;class v extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof v)return n;const s=new v;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}t.$bb=v;class p extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype)}}t.$cb=p}),ie(se[6],ue([0,1,3,9]),function(O,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=R,t.$tb=h,t.$ub=N,t.$vb=g,t.$wb=a,t.$xb=u,t.$yb=c,t.$zb=w,t.$Ab=d,t.$Bb=m,t.$Cb=e,t.$Db=P,t.$Eb=j,t.top=L,t.$Gb=$,t.$Hb=p,t.$Ib=l,t.$Jb=n,t.$Kb=s,t.$Lb=f,t.$Mb=o,t.$Nb=b,t.$Ob=A,t.$Pb=E,t.$Qb=M,t.$Rb=k,t.$Sb=S,t.$Tb=x,t.$Ub=D,t.$Vb=q,t.$Wb=I,t.$Xb=z,t.$Yb=Z,t.$Zb=Q,t.$1b=J,t.$2b=X,t.$3b=K,t.$4b=F,t.$5b=H,t.$6b=he,t.$7b=r,t.$8b=Le,t.$$b=Be;function R(V,C=0){return V[V.length-(1+C)]}function h(V){if(V.length===0)throw new Error("Invalid tail call");return[V.slice(0,V.length-1),V[V.length-1]]}function N(V,C,W=(Y,ee)=>Y===ee){if(V===C)return!0;if(!V||!C||V.length!==C.length)return!1;for(let Y=0,ee=V.length;Y<ee;Y++)if(!W(V[Y],C[Y]))return!1;return!0}function g(V,C){const W=V.length-1;C<W&&(V[C]=V[W]),V.pop()}function a(V,C,W){return u(V.length,Y=>W(V[Y],C))}function u(V,C){let W=0,Y=V-1;for(;W<=Y;){const ee=(W+Y)/2|0,fe=C(ee);if(fe<0)W=ee+1;else if(fe>0)Y=ee-1;else return ee}return-(W+1)}function c(V,C,W){if(V=V|0,V>=C.length)throw new TypeError("invalid index");const Y=C[Math.floor(C.length*Math.random())],ee=[],fe=[],de=[];for(const ne of C){const U=W(ne,Y);U<0?ee.push(ne):U>0?fe.push(ne):de.push(ne)}return V<ee.length?c(V,ee,W):V<ee.length+de.length?de[0]:c(V-(ee.length+de.length),fe,W)}function w(V,C){const W=[];let Y;for(const ee of V.slice(0).sort(C))!Y||C(Y[0],ee)!==0?(Y=[ee],W.push(Y)):Y.push(ee);return W}function*d(V,C){let W,Y;for(const ee of V)Y!==void 0&&C(Y,ee)?W.push(ee):(W&&(yield W),W=[ee]),Y=ee;W&&(yield W)}function m(V,C){for(let W=0;W<=V.length;W++)C(W===0?void 0:V[W-1],W===V.length?void 0:V[W])}function e(V,C){for(let W=0;W<V.length;W++)C(W===0?void 0:V[W-1],V[W],W+1===V.length?void 0:V[W+1])}function P(V,C,W){const Y=[];function ee(ne,U,re){if(U===0&&re.length===0)return;const te=Y[Y.length-1];te&&te.start+te.deleteCount===ne?(te.deleteCount+=U,te.toInsert.push(...re)):Y.push({start:ne,deleteCount:U,toInsert:re})}let fe=0,de=0;for(;;){if(fe===V.length){ee(fe,0,C.slice(de));break}if(de===C.length){ee(fe,V.length-fe,[]);break}const ne=V[fe],U=C[de],re=W(ne,U);re===0?(fe+=1,de+=1):re<0?(ee(fe,1,[]),fe+=1):re>0&&(ee(fe,0,[U]),de+=1)}return Y}function j(V,C,W){const Y=P(V,C,W),ee=[],fe=[];for(const de of Y)ee.push(...V.slice(de.start,de.start+de.deleteCount)),fe.push(...de.toInsert);return{removed:ee,added:fe}}function L(V,C,W){if(W===0)return[];const Y=V.slice(0,W).sort(C);return v(V,C,Y,W,V.length),Y}function $(V,C,W,Y,ee){return W===0?Promise.resolve([]):new Promise((fe,de)=>{(async()=>{const ne=V.length,U=V.slice(0,W).sort(C);for(let re=W,te=Math.min(W+Y,ne);re<ne;re=te,te=Math.min(te+Y,ne)){if(re>W&&await new Promise(oe=>setTimeout(oe)),ee&&ee.isCancellationRequested)throw new i.$5;v(V,C,U,re,te)}return U})().then(fe,de)})}function v(V,C,W,Y,ee){for(const fe=W.length;Y<ee;Y++){const de=V[Y];if(C(de,W[fe-1])<0){W.pop();const ne=(0,y.$kb)(W,U=>C(de,U)<0);W.splice(ne,0,de)}}}function p(V){return V.filter(C=>!!C)}function l(V){let C=0;for(let W=0;W<V.length;W++)V[W]&&(V[C]=V[W],C+=1);V.length=C}function n(V,C,W){V.splice(W,0,V.splice(C,1)[0])}function s(V){return!Array.isArray(V)||V.length===0}function f(V){return Array.isArray(V)&&V.length>0}function o(V,C=W=>W){const W=new Set;return V.filter(Y=>{const ee=C(Y);return W.has(ee)?!1:(W.add(ee),!0)})}function b(V){const C=new Set;return W=>{const Y=V(W);return C.has(Y)?!1:(C.add(Y),!0)}}function A(V,C){return V.length>0?V[0]:C}function E(V,C){return V.length>0?V[V.length-1]:C}function M(V,C,W=(Y,ee)=>Y===ee){let Y=0;for(let ee=0,fe=Math.min(V.length,C.length);ee<fe&&W(V[ee],C[ee]);ee++)Y++;return Y}function k(V){return[].concat(...V)}function S(V,C){let W=typeof C=="number"?V:0;typeof C=="number"?W=V:(W=0,C=V);const Y=[];if(W<=C)for(let ee=W;ee<C;ee++)Y.push(ee);else for(let ee=W;ee>C;ee--)Y.push(ee);return Y}function x(V,C,W){return V.reduce((Y,ee)=>(Y[C(ee)]=W?W(ee):ee,Y),Object.create(null))}function D(V,C){return V.push(C),()=>q(V,C)}function q(V,C){const W=V.indexOf(C);if(W>-1)return V.splice(W,1),C}function I(V,C,W){const Y=V.slice(0,C),ee=V.slice(C);return Y.concat(W,ee)}function z(V,C){let W;if(typeof C=="number"){let Y=C;W=()=>{const ee=Math.sin(Y++)*179426549;return ee-Math.floor(ee)}}else W=Math.random;for(let Y=V.length-1;Y>0;Y-=1){const ee=Math.floor(W()*(Y+1)),fe=V[Y];V[Y]=V[ee],V[ee]=fe}}function Z(V,C){const W=V.indexOf(C);W>-1&&(V.splice(W,1),V.unshift(C))}function Q(V,C){const W=V.indexOf(C);W>-1&&(V.splice(W,1),V.push(C))}function J(V,C){for(const W of C)V.push(W)}function X(V,C){return Array.isArray(V)?V.map(C):C(V)}function K(V){return Array.isArray(V)?V:[V]}function F(V){return V[Math.floor(Math.random()*V.length)]}function H(V,C,W){const Y=le(V,C),ee=V.length,fe=W.length;V.length=ee+fe;for(let de=ee-1;de>=Y;de--)V[de+fe]=V[de];for(let de=0;de<fe;de++)V[de+Y]=W[de]}function he(V,C,W,Y){const ee=le(V,C);let fe=V.splice(ee,W);return fe===void 0&&(fe=[]),H(V,ee,Y),fe}function le(V,C){return C<0?Math.max(C+V.length,0):Math.min(C,V.length)}var be;(function(V){function C(fe){return fe<0}V.isLessThan=C;function W(fe){return fe<=0}V.isLessThanOrEqual=W;function Y(fe){return fe>0}V.isGreaterThan=Y;function ee(fe){return fe===0}V.isNeitherLessOrGreaterThan=ee,V.greaterThan=1,V.lessThan=-1,V.neitherLessOrGreaterThan=0})(be||(t.CompareResult=be={}));function r(V,C){return(W,Y)=>C(V(W),V(Y))}function Le(...V){return(C,W)=>{for(const Y of V){const ee=Y(C,W);if(!be.isNeitherLessOrGreaterThan(ee))return ee}return be.neitherLessOrGreaterThan}}const je=(V,C)=>V-C;t.$9b=je;const Se=(V,C)=>(0,t.$9b)(V?1:0,C?1:0);t.$0b=Se;function Be(V){return(C,W)=>-V(C,W)}class De{constructor(C){this.g=C,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(C){let W=this.c;for(;W<this.g.length&&C(this.g[W]);)W++;const Y=W===this.c?null:this.g.slice(this.c,W);return this.c=W,Y}takeFromEndWhile(C){let W=this.d;for(;W>=0&&C(this.g[W]);)W--;const Y=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,Y}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const C=this.g[this.c];return this.c++,C}removeLast(){const C=this.g[this.d];return this.d--,C}takeCount(C){const W=this.g.slice(this.c,this.c+C);return this.c+=C,W}}t.$_b=De;class Me{static{this.empty=new Me(C=>{})}constructor(C){this.iterate=C}forEach(C){this.iterate(W=>(C(W),!0))}toArray(){const C=[];return this.iterate(W=>(C.push(W),!0)),C}filter(C){return new Me(W=>this.iterate(Y=>C(Y)?W(Y):!0))}map(C){return new Me(W=>this.iterate(Y=>W(C(Y))))}some(C){let W=!1;return this.iterate(Y=>(W=C(Y),!W)),W}findFirst(C){let W;return this.iterate(Y=>C(Y)?(W=Y,!1):!0),W}findLast(C){let W;return this.iterate(Y=>(C(Y)&&(W=Y),!0)),W}findLastMaxBy(C){let W,Y=!0;return this.iterate(ee=>((Y||be.isGreaterThan(C(ee,W)))&&(Y=!1,W=ee),!0)),W}}t.$ac=Me;class Te{constructor(C){this.c=C}static createSortPermutation(C,W){const Y=Array.from(C.keys()).sort((ee,fe)=>W(C[ee],C[fe]));return new Te(Y)}apply(C){return C.map((W,Y)=>C[this.c[Y]])}inverse(){const C=this.c.slice();for(let W=0;W<this.c.length;W++)C[this.c[W]]=W;return new Te(C)}}t.$bc=Te}),ie(se[13],ue([0,1,3]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=y,t.$fd=R,t.$gd=h,t.$hd=N,t.$id=g,t.$jd=a;function y(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}function R(u,c="Unreachable"){throw new Error(c)}function h(u){if(!u)throw new i.$cb("Assertion Failed")}function N(u){u||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function g(u){if(!u()){debugger;u(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function a(u,c){let w=0;for(;w<u.length-1;){const d=u[w],m=u[w+1];if(!c(d,m))return!1;w++}return!0}}),ie(se[20],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(y,R){const h=this;let N=!1,g;return function(){if(N)return g;if(N=!0,R)try{g=y.apply(h,arguments)}finally{R()}else g=y.apply(h,arguments);return g}}}),ie(se[21],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(y){function R(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}y.is=R;const h=Object.freeze([]);function N(){return h}y.empty=N;function*g(n){yield n}y.single=g;function a(n){return R(n)?n:g(n)}y.wrap=a;function u(n){return n||h}y.from=u;function*c(n){for(let s=n.length-1;s>=0;s--)yield n[s]}y.reverse=c;function w(n){return!n||n[Symbol.iterator]().next().done===!0}y.isEmpty=w;function d(n){return n[Symbol.iterator]().next().value}y.first=d;function m(n,s){for(const f of n)if(s(f))return!0;return!1}y.some=m;function e(n,s){for(const f of n)if(s(f))return f}y.find=e;function*P(n,s){for(const f of n)s(f)&&(yield f)}y.filter=P;function*j(n,s){let f=0;for(const o of n)yield s(o,f++)}y.map=j;function*L(...n){for(const s of n)yield*s}y.concat=L;function $(n,s,f){let o=f;for(const b of n)o=s(o,b);return o}y.reduce=$;function*v(n,s,f=n.length){for(s<0&&(s+=n.length),f<0?f+=n.length:f>n.length&&(f=n.length);s<f;s++)yield n[s]}y.slice=v;function p(n,s=Number.POSITIVE_INFINITY){const f=[];if(s===0)return[f,n];const o=n[Symbol.iterator]();for(let b=0;b<s;b++){const A=o.next();if(A.done)return[f,y.empty()];f.push(A.value)}return[f,{[Symbol.iterator](){return o}}]}y.consume=p;async function l(n){const s=[];for await(const f of n)s.push(f);return Promise.resolve(s)}y.asyncToArray=l})(i||(t.Iterable=i={}))}),ie(se[38],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$Cr=t.$Br=t.$Ar=t.$zr=t.$yr=t.ScanCode=t.KeyCode=void 0,t.$Dr=m;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(y||(t.ScanCode=y={}));class R{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(P,j){this._keyCodeToStr[P]=j,this._strToKeyCode[j.toLowerCase()]=P}keyCodeToStr(P){return this._keyCodeToStr[P]}strToKeyCode(P){return this._strToKeyCode[P.toLowerCase()]||0}}const h=new R,N=new R,g=new R;t.$yr=new Array(230),t.$zr={};const a=[],u=Object.create(null),c=Object.create(null);t.$Ar={lowerCaseToEnum:e=>c[e]||0,toEnum:e=>u[e]||0,toString:e=>a[e]||"None"},t.$Br=[],t.$Cr=[];for(let e=0;e<=193;e++)t.$Br[e]=-1;for(let e=0;e<=132;e++)t.$Cr[e]=-1;(function(){const e="",P=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],j=[],L=[];for(const $ of P){const[v,p,l,n,s,f,o,b,A]=$;if(L[p]||(L[p]=!0,a[p]=l,u[l]=p,c[l.toLowerCase()]=p,v&&(t.$Br[p]=n,n!==0&&n!==3&&n!==5&&n!==4&&n!==6&&n!==57&&(t.$Cr[n]=p))),!j[n]){if(j[n]=!0,!s)throw new Error(`String representation missing for key code ${n} around scan code ${l}`);h.define(n,s),N.define(n,b||s),g.define(n,A||b||s)}f&&(t.$yr[f]=n),o&&(t.$zr[o]=n)}t.$Cr[3]=46})();var w;(function(e){function P(l){return h.keyCodeToStr(l)}e.toString=P;function j(l){return h.strToKeyCode(l)}e.fromString=j;function L(l){return N.keyCodeToStr(l)}e.toUserSettingsUS=L;function $(l){return g.keyCodeToStr(l)}e.toUserSettingsGeneral=$;function v(l){return N.strToKeyCode(l)||g.strToKeyCode(l)}e.fromUserSettings=v;function p(l){if(l>=98&&l<=113)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return h.keyCodeToStr(l)}e.toElectronAccelerator=p})(w||(t.KeyCodeUtils=w={}));var d;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(d||(t.KeyMod=d={}));function m(e,P){const j=(P&65535)<<16>>>0;return(e|j)>>>0}}),ie(se[39],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(R){this.d=R,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(R){this.c=R}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),ie(se[22],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(h){this.element=h,this.next=i.Undefined,this.prev=i.Undefined}}class y{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let h=this.a;for(;h!==i.Undefined;){const N=h.next;h.prev=i.Undefined,h.next=i.Undefined,h=N}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(h){return this.d(h,!1)}push(h){return this.d(h,!0)}d(h,N){const g=new i(h);if(this.a===i.Undefined)this.a=g,this.b=g;else if(N){const u=this.b;this.b=g,g.prev=u,u.next=g}else{const u=this.a;this.a=g,g.next=u,u.prev=g}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(g))}}shift(){if(this.a!==i.Undefined){const h=this.a.element;return this.e(this.a),h}}pop(){if(this.b!==i.Undefined){const h=this.b.element;return this.e(this.b),h}}e(h){if(h.prev!==i.Undefined&&h.next!==i.Undefined){const N=h.prev;N.next=h.next,h.next.prev=N}else h.prev===i.Undefined&&h.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):h.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):h.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let h=this.a;for(;h!==i.Undefined;)yield h.element,h=h.next}}t.$6c=y}),ie(se[14],ue([0,1]),function(O,t){"use strict";var i,y,R;Object.defineProperty(t,"__esModule",{value:!0}),t.$Ic=t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=h,t.$zc=N,t.$Ac=g,t.$Jc=p;function h(l,n,s){let f=l.get(n);return f===void 0&&(f=s,l.set(n,f)),f}function N(l){const n=[];return l.forEach((s,f)=>{n.push(`${f} => ${s}`)}),`Map(${l.size}) {${n.join(", ")}}`}function g(l){const n=[];return l.forEach(s=>{n.push(s)}),`Set(${l.size}) {${n.join(", ")}}`}class a{constructor(n,s){this.uri=n,this.value=s}}function u(l){return Array.isArray(l)}class c{static{this.c=n=>n.toString()}constructor(n,s){if(this[i]="ResourceMap",n instanceof c)this.d=new Map(n.d),this.e=s??c.c;else if(u(n)){this.d=new Map,this.e=s??c.c;for(const[f,o]of n)this.set(f,o)}else this.d=new Map,this.e=n??c.c}set(n,s){return this.d.set(this.e(n),new a(n,s)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[f,o]of this.d)n(o.value,o.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}t.$Bc=c;class w{constructor(n,s){this[y]="ResourceSet",!n||typeof n=="function"?this.c=new c(n):(this.c=new c(s),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,s){this.c.forEach((f,o)=>n.call(s,o,o,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=w;var d;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(d||(t.Touch=d={}));class m{constructor(){this[R]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,s=0){const f=this.c.get(n);if(f)return s!==0&&this.m(f,s),f.value}set(n,s,f=0){let o=this.c.get(n);if(o)o.value=s,f!==0&&this.m(o,f);else{switch(o={key:n,value:s,next:void 0,previous:void 0},f){case 0:this.k(o);break;case 1:this.j(o);break;case 2:this.k(o);break;default:this.k(o);break}this.c.set(n,o),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this.c.get(n);if(s)return this.c.delete(n),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,s){const f=this.g;let o=this.d;for(;o;){if(s?n.bind(s)(o.value,o.key,this):n(o.value,o.key,this),this.g!==f)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,s=this.g;let f=this.d;const o={[Symbol.iterator](){return o},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:f.key,done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return o}values(){const n=this,s=this.g;let f=this.d;const o={[Symbol.iterator](){return o},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:f.value,done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return o}entries(){const n=this,s=this.g;let f=this.d;const o={[Symbol.iterator](){return o},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:[f.key,f.value],done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return o}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this.d,f=this.size;for(;s&&f>n;)this.c.delete(s.key),s=s.next,f--;this.d=s,this.f=f,s&&(s.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this.e,f=this.size;for(;s&&f>n;)this.c.delete(s.key),s=s.previous,f--;this.e=s,this.f=f,s&&(s.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const s=n.next,f=n.previous;if(!s||!f)throw new Error("Invalid list");s.previous=f,f.next=s}n.next=void 0,n.previous=void 0,this.g++}m(n,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this.d)return;const f=n.next,o=n.previous;n===this.e?(o.next=void 0,this.e=o):(f.previous=o,o.next=f),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(s===2){if(n===this.e)return;const f=n.next,o=n.previous;n===this.d?(f.previous=void 0,this.d=f):(f.previous=o,o.next=f),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((s,f)=>{n.push([f,s])}),n}fromJSON(n){this.clear();for(const[s,f]of n)this.set(s,f)}}t.$Dc=m;class e extends m{constructor(n,s=1){super(),this.n=n,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class P extends e{constructor(n,s=1){super(n,s)}q(n){this.h(n)}set(n,s){return super.set(n,s),this.p(),this}}t.$Ec=P;class j extends e{constructor(n,s=1){super(n,s)}q(n){this.i(n)}set(n,s){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,s),this}}t.$Fc=j;class L{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let s=this.c.get(n)||0;return s===0?!1:(s--,s===0?this.c.delete(n):this.c.set(n,s),!0)}has(n){return this.c.has(n)}}t.$Gc=L;class ${constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[s,f]of n)this.set(s,f)}clear(){this.c.clear(),this.d.clear()}set(n,s){this.c.set(n,s),this.d.set(s,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const s=this.c.get(n);return s===void 0?!1:(this.c.delete(n),this.d.delete(s),!0)}forEach(n,s){this.c.forEach((f,o)=>{n.call(s,f,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Hc=$;class v{constructor(){this.c=new Map}add(n,s){let f=this.c.get(n);f||(f=new Set,this.c.set(n,f)),f.add(s)}delete(n,s){const f=this.c.get(n);f&&(f.delete(s),f.size===0&&this.c.delete(n))}forEach(n,s){const f=this.c.get(n);f&&f.forEach(s)}get(n){const s=this.c.get(n);return s||new Set}}t.$Ic=v;function p(l,n){if(l===n)return!0;if(l.size!==n.size)return!1;for(const[s,f]of l)if(!n.has(s)||n.get(s)!==f)return!1;for(const[s]of n)if(!l.has(s))return!1;return!0}}),ie(se[10],ue([0,1,6,35,14,20,21]),function(O,t,i,y,R,h,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Kc=void 0,t.$Lc=c,t.$Mc=w,t.$Nc=d,t.$Oc=P,t.$Pc=j,t.$Qc=L,t.$Rc=$,t.$Sc=v,t.$Tc=p,t.$4c=k;const g=!1;let a=null;class u{constructor(){this.b=new Map}static{this.a=0}c(D){let q=this.b.get(D);return q||(q={parent:null,source:null,isSingleton:!1,value:D,idx:u.a++},this.b.set(D,q)),q}trackDisposable(D){const q=this.c(D);q.source||(q.source=new Error().stack)}setParent(D,q){const I=this.c(D);I.parent=q}markAsDisposed(D){this.b.delete(D)}markAsSingleton(D){this.c(D).isSingleton=!0}f(D,q){const I=q.get(D);if(I)return I;const z=D.parent?this.f(this.c(D.parent),q):D;return q.set(D,z),z}getTrackedDisposables(){const D=new Map;return[...this.b.entries()].filter(([,I])=>I.source!==null&&!this.f(I,D).isSingleton).flatMap(([I])=>I)}computeLeakingDisposables(D=10,q){let I;if(q)I=q;else{const X=new Map,K=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,X).isSingleton);if(K.length===0)return;const F=new Set(K.map(H=>H.value));if(I=K.filter(H=>!(H.parent&&F.has(H.parent))),I.length===0)throw new Error("There are cyclic diposable chains!")}if(!I)return;function z(X){function K(H,he){for(;H.length>0&&he.some(le=>typeof le=="string"?le===H[0]:H[0].match(le));)H.shift()}const F=X.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return K(F,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),F.reverse()}const Z=new R.$Ic;for(const X of I){const K=z(X);for(let F=0;F<=K.length;F++)Z.add(K.slice(0,F).join(`
`),X)}I.sort((0,i.$7b)(X=>X.idx,i.$9b));let Q="",J=0;for(const X of I.slice(0,D)){J++;const K=z(X),F=[];for(let H=0;H<K.length;H++){let he=K[H];he=`(shared with ${Z.get(K.slice(0,H+1).join(`
`)).size}/${I.length} leaks) at ${he}`;const be=Z.get(K.slice(0,H).join(`
`)),r=(0,y.$K)([...be].map(Le=>z(Le)[H]),Le=>Le);delete r[K[H]];for(const[Le,je]of Object.entries(r))F.unshift(`    - stacktraces of ${je.length} other leaks continue with ${Le}`);F.unshift(he)}Q+=`


==================== Leaking disposable ${J}/${I.length}: ${X.value.constructor.name} ====================
${F.join(`
`)}
============================================================

`}return I.length>D&&(Q+=`


... and ${I.length-D} more leaking disposables

`),{leaks:I,details:Q}}}t.$Kc=u;function c(x){a=x}if(g){const x="__is_disposable_tracked__";c(new class{trackDisposable(D){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{D[x]||console.log(q)},3e3)}setParent(D,q){if(D&&D!==n.None)try{D[x]=!0}catch{}}markAsDisposed(D){if(D&&D!==n.None)try{D[x]=!0}catch{}}markAsSingleton(D){}})}function w(x){return a?.trackDisposable(x),x}function d(x){a?.markAsDisposed(x)}function m(x,D){a?.setParent(x,D)}function e(x,D){if(a)for(const q of x)a.setParent(q,D)}function P(x){return a?.markAsSingleton(x),x}function j(x){return typeof x=="object"&&x!==null&&typeof x.dispose=="function"&&x.dispose.length===0}function L(x){if(N.Iterable.is(x)){const D=[];for(const q of x)if(q)try{q.dispose()}catch(I){D.push(I)}if(D.length===1)throw D[0];if(D.length>1)throw new AggregateError(D,"Encountered errors while disposing of store");return Array.isArray(x)?[]:x}else if(x)return x.dispose(),x}function $(x){for(const D of x)j(D)&&D.dispose();return[]}function v(...x){const D=p(()=>L(x));return e(x,D),D}function p(x){const D=w({dispose:(0,h.$db)(()=>{d(D),x()})});return D}class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,w(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{L(this.f)}finally{this.f.clear()}}add(D){if(!D)return D;if(D===this)throw new Error("Cannot register a disposable on itself!");return m(D,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(D),D}delete(D){if(D){if(D===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(D),D.dispose()}}deleteAndLeak(D){D&&this.f.has(D)&&(this.f.delete(D),m(D,null))}}t.$Uc=l;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new l,w(this),m(this.q,this)}dispose(){d(this),this.q.dispose()}B(D){if(D===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(D)}}t.$Vc=n;class s{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(D){this.b||D===this.a||(this.a?.dispose(),D&&m(D,this),this.a=D)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const D=this.a;return this.a=void 0,D&&m(D,null),D}}t.$Wc=s;class f{constructor(D){this.a=new s,this.b=!1,this.a.value=D}get value(){return this.a.value}set value(D){this.b||D===this.a.value||(this.a.value=D)}dispose(){this.b=!0,this.a.dispose()}}t.$Xc=f;class o{constructor(D){this.b=D,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Yc=o;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(D){let q=D;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,d(this))},this}}t.$Zc=b;class A{constructor(){this.a=new Map}acquire(D,...q){let I=this.a.get(D);I||(I={counter:0,object:this.b(D,...q)},this.a.set(D,I));const{object:z}=I,Z=(0,h.$db)(()=>{--I.counter===0&&(this.c(D,I.object),this.a.delete(D))});return I.counter++,{object:z,dispose:Z}}}t.$1c=A;class E{constructor(D){this.a=D}async acquire(D,...q){const I=this.a.acquire(D,...q);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(z){throw I.dispose(),z}}}t.$2c=E;class M{constructor(D){this.object=D}dispose(){}}t.$3c=M;function k(x){const D=new l;try{x(D)}finally{D.dispose()}}class S{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{L(this.a.values())}finally{this.a.clear()}}has(D){return this.a.has(D)}get size(){return this.a.size}get(D){return this.a.get(D)}set(D,q,I=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),I||this.a.get(D)?.dispose(),this.a.set(D,q)}deleteAndDispose(D){this.a.get(D)?.dispose(),this.a.delete(D)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$5c=S}),ie(se[23],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ae=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class y{static create(h){return new y(h)}constructor(h){this.c=i&&h===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$ae=y}),ie(se[11],ue([0,1,3,20,10,22,23]),function(O,t,i,y,R,h,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$ce=t.Event=void 0,t.$de=m;const g=!1,a=!1,u=!1;var c;(function(q){q.None=()=>R.$Vc.None;function I(ne){if(u){const{onDidAddListener:U}=ne,re=P.create();let te=0;ne.onDidAddListener=()=>{++te===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),U?.()}}}function z(ne,U){return be(ne,()=>{},0,void 0,!0,void 0,U)}q.defer=z;function Z(ne){return(U,re=null,te)=>{let oe=!1,ce;return ce=ne(me=>{if(!oe)return ce?ce.dispose():oe=!0,U.call(re,me)},null,te),oe&&ce.dispose(),ce}}q.once=Z;function Q(ne,U,re){return he((te,oe=null,ce)=>ne(me=>te.call(oe,U(me)),null,ce),re)}q.map=Q;function J(ne,U,re){return he((te,oe=null,ce)=>ne(me=>{U(me),te.call(oe,me)},null,ce),re)}q.forEach=J;function X(ne,U,re){return he((te,oe=null,ce)=>ne(me=>U(me)&&te.call(oe,me),null,ce),re)}q.filter=X;function K(ne){return ne}q.signal=K;function F(...ne){return(U,re=null,te)=>{const oe=(0,R.$Sc)(...ne.map(ce=>ce(me=>U.call(re,me))));return le(oe,te)}}q.any=F;function H(ne,U,re,te){let oe=re;return Q(ne,ce=>(oe=U(oe,ce),oe),te)}q.reduce=H;function he(ne,U){let re;const te={onWillAddFirstListener(){re=ne(oe.fire,oe)},onDidRemoveLastListener(){re?.dispose()}};U||I(te);const oe=new l(te);return U?.add(oe),oe.event}function le(ne,U){return U instanceof Array?U.push(ne):U&&U.add(ne),ne}function be(ne,U,re=100,te=!1,oe=!1,ce,me){let ve,we,ye,pe=0,Ie;const Oe={leakWarningThreshold:ce,onWillAddFirstListener(){ve=ne(ze=>{pe++,we=U(we,ze),te&&!ye&&(xe.fire(we),we=void 0),Ie=()=>{const We=we;we=void 0,ye=void 0,(!te||pe>1)&&xe.fire(We),pe=0},typeof re=="number"?(clearTimeout(ye),ye=setTimeout(Ie,re)):ye===void 0&&(ye=0,queueMicrotask(Ie))})},onWillRemoveListener(){oe&&pe>0&&Ie?.()},onDidRemoveLastListener(){Ie=void 0,ve.dispose()}};me||I(Oe);const xe=new l(Oe);return me?.add(xe),xe.event}q.debounce=be;function r(ne,U=0,re){return q.debounce(ne,(te,oe)=>te?(te.push(oe),te):[oe],U,void 0,!0,void 0,re)}q.accumulate=r;function Le(ne,U=(te,oe)=>te===oe,re){let te=!0,oe;return X(ne,ce=>{const me=te||!U(ce,oe);return te=!1,oe=ce,me},re)}q.latch=Le;function je(ne,U,re){return[q.filter(ne,U,re),q.filter(ne,te=>!U(te),re)]}q.split=je;function Se(ne,U=!1,re=[],te){let oe=re.slice(),ce=ne(we=>{oe?oe.push(we):ve.fire(we)});te&&te.add(ce);const me=()=>{oe?.forEach(we=>ve.fire(we)),oe=null},ve=new l({onWillAddFirstListener(){ce||(ce=ne(we=>ve.fire(we)),te&&te.add(ce))},onDidAddFirstListener(){oe&&(U?setTimeout(me):me())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return te&&te.add(ve),ve.event}q.buffer=Se;function Be(ne,U){return(te,oe,ce)=>{const me=U(new Me);return ne(function(ve){const we=me.evaluate(ve);we!==De&&te.call(oe,we)},void 0,ce)}}q.chain=Be;const De=Symbol("HaltChainable");class Me{constructor(){this.f=[]}map(U){return this.f.push(U),this}forEach(U){return this.f.push(re=>(U(re),re)),this}filter(U){return this.f.push(re=>U(re)?re:De),this}reduce(U,re){let te=re;return this.f.push(oe=>(te=U(te,oe),te)),this}latch(U=(re,te)=>re===te){let re=!0,te;return this.f.push(oe=>{const ce=re||!U(oe,te);return re=!1,te=oe,ce?oe:De}),this}evaluate(U){for(const re of this.f)if(U=re(U),U===De)break;return U}}function Te(ne,U,re=te=>te){const te=(...ve)=>me.fire(re(...ve)),oe=()=>ne.on(U,te),ce=()=>ne.removeListener(U,te),me=new l({onWillAddFirstListener:oe,onDidRemoveLastListener:ce});return me.event}q.fromNodeEventEmitter=Te;function V(ne,U,re=te=>te){const te=(...ve)=>me.fire(re(...ve)),oe=()=>ne.addEventListener(U,te),ce=()=>ne.removeEventListener(U,te),me=new l({onWillAddFirstListener:oe,onDidRemoveLastListener:ce});return me.event}q.fromDOMEventEmitter=V;function C(ne){return new Promise(U=>Z(ne)(U))}q.toPromise=C;function W(ne){const U=new l;return ne.then(re=>{U.fire(re)},()=>{U.fire(void 0)}).finally(()=>{U.dispose()}),U.event}q.fromPromise=W;function Y(ne,U,re){return U(re),ne(te=>U(te))}q.runAndSubscribe=Y;class ee{constructor(U,re){this._observable=U,this.f=0,this.g=!1;const te={onWillAddFirstListener:()=>{U.addObserver(this)},onDidRemoveLastListener:()=>{U.removeObserver(this)}};re||I(te),this.emitter=new l(te),re&&re.add(this.emitter)}beginUpdate(U){this.f++}handlePossibleChange(U){}handleChange(U,re){this.g=!0}endUpdate(U){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function fe(ne,U){return new ee(ne,U).emitter.event}q.fromObservable=fe;function de(ne){return(U,re,te)=>{let oe=0,ce=!1;const me={beginUpdate(){oe++},endUpdate(){oe--,oe===0&&(ne.reportChanges(),ce&&(ce=!1,U.call(re)))},handlePossibleChange(){},handleChange(){ce=!0}};ne.addObserver(me),ne.reportChanges();const ve={dispose(){ne.removeObserver(me)}};return te instanceof R.$Uc?te.add(ve):Array.isArray(te)&&te.push(ve),ve}}q.fromObservableLight=de})(c||(t.Event=c={}));class w{static{this.all=new Set}static{this.f=0}constructor(I){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${I}_${w.f++}`,w.all.add(this)}start(I){this.g=new N.$ae,this.listenerCount=I}stop(){if(this.g){const I=this.g.elapsed();this.durations.push(I),this.elapsedOverall+=I,this.invocationCount+=1,this.g=void 0}}}t.$ce=w;let d=-1;function m(q){const I=d;return d=q,{dispose(){d=I}}}class e{constructor(I,z=Math.random().toString(18).slice(2,5)){this.threshold=I,this.name=z,this.g=0}dispose(){this.f?.clear()}check(I,z){const Z=this.threshold;if(Z<=0||z<Z)return;this.f||(this.f=new Map);const Q=this.f.get(I.value)||0;if(this.f.set(I.value,Q+1),this.g-=1,this.g<=0){this.g=Z*.5;let J,X=0;for(const[K,F]of this.f)(!J||X<F)&&(J=K,X=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${z} listeners already. MOST frequent listener (${X}):`),console.warn(J)}return()=>{const J=this.f.get(I.value)||0;this.f.set(I.value,J-1)}}}class P{static create(){return new P(new Error().stack??"")}constructor(I){this.value=I}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let j=0;class L{constructor(I){this.value=I,this.id=j++}}const $=2,v=(q,I)=>{if(q instanceof L)I(q);else for(let z=0;z<q.length;z++){const Z=q[z];Z&&I(Z)}},p=g?new FinalizationRegistry(q=>{typeof q=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(q))}):void 0;class l{constructor(I){this.w=0,this.f=I,this.g=d>0||this.f?.leakWarningThreshold?new e(this.f?.leakWarningThreshold??d):void 0,this.j=this.f?._profName?new w(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(a){const I=this.t;queueMicrotask(()=>{v(I,z=>z.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(I,z,Z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),R.$Vc.None;if(this.m)return R.$Vc.None;z&&(I=I.bind(z));const Q=new L(I);let J,X;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Q.stack=P.create(),J=this.g.check(Q.stack,this.w+1)),a&&(Q.stack=X??P.create()),this.t?this.t instanceof L?(this.u??=new s,this.t=[this.t,Q]):this.t.push(Q):(this.f?.onWillAddFirstListener?.(this),this.t=Q,this.f?.onDidAddFirstListener?.(this)),this.w++;const K=(0,R.$Tc)(()=>{p?.unregister(K),J?.(),this.x(Q)});if(Z instanceof R.$Uc?Z.add(K):Array.isArray(Z)&&Z.push(K),p){const F=new Error().stack.split(`
`).slice(2).join(`
`).trim();p.register(K,F,K)}return K},this.q}x(I){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const z=this.t,Z=z.indexOf(I);if(Z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,z[Z]=void 0;const Q=this.u.current===this;if(this.w*$<=z.length){let J=0;for(let X=0;X<z.length;X++)z[X]?z[J++]=z[X]:Q&&(this.u.end--,J<this.u.i&&this.u.i--);z.length=J}}y(I,z){if(!I)return;const Z=this.f?.onListenerError||i.$1;if(!Z){I.value(z);return}try{I.value(z)}catch(Q){Z(Q)}}z(I){const z=I.current.t;for(;I.i<I.end;)this.y(z[I.i++],I.value);I.reset()}fire(I){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof L)this.y(this.t,I);else{const z=this.u;z.enqueue(this,I,this.t.length),this.z(z)}this.j?.stop()}hasListeners(){return this.w>0}}t.$ee=l;const n=()=>new s;t.$fe=n;class s{constructor(){this.i=-1,this.end=0}enqueue(I,z,Z){this.i=0,this.end=Z,this.current=I,this.value=z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class f extends l{async fireAsync(I,z,Z){if(this.t)for(this.h||(this.h=new h.$6c),v(this.t,Q=>this.h.push([Q.value,I]));this.h.size>0&&!z.isCancellationRequested;){const[Q,J]=this.h.shift(),X=[],K={...J,token:z,waitUntil:F=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");Z&&(F=Z(F,Q)),X.push(F)}};try{Q(K)}catch(F){(0,i.$1)(F);continue}Object.freeze(X),await Promise.allSettled(X).then(F=>{for(const H of F)H.status==="rejected"&&(0,i.$1)(H.reason)})}}}t.$ge=f;class o extends l{get isPaused(){return this.h!==0}constructor(I){super(I),this.h=0,this.s=new h.$6c,this.A=I?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const I=Array.from(this.s);this.s.clear(),super.fire(this.A(I))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(I){this.w&&(this.h!==0?this.s.push(I):super.fire(I))}}t.$he=o;class b extends o{constructor(I){super(I),this.k=I.delay??100}fire(I){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(I)}}t.$ie=b;class A extends l{constructor(I){super(I),this.h=[],this.k=I?.merge}fire(I){this.hasListeners()&&(this.h.push(I),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(z=>super.fire(z)),this.h=[]}))}}t.$je=A;class E{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(I){const z={event:I,listener:null};this.h.push(z),this.g&&this.m(z);const Z=()=>{this.g&&this.o(z);const Q=this.h.indexOf(z);this.h.splice(Q,1)};return(0,R.$Tc)((0,y.$db)(Z))}j(){this.g=!0,this.h.forEach(I=>this.m(I))}k(){this.g=!1,this.h.forEach(I=>this.o(I))}m(I){I.listener=I.event(z=>this.f.fire(z))}o(I){I.listener?.dispose(),I.listener=null}dispose(){this.f.dispose();for(const I of this.h)I.listener?.dispose();this.h=[]}}t.$ke=E;class M{constructor(I,z,Z,Q){this.f=new R.$Uc;const J=this.f.add(new E),X=this.f.add(new R.$5c);function K(F){X.set(F,J.add(Q(F)))}for(const F of I)K(F);this.f.add(z(F=>{K(F)})),this.f.add(Z(F=>{X.deleteAndDispose(F)})),this.event=J.event}dispose(){this.f.dispose()}}t.$le=M;class k{constructor(){this.f=[]}wrapEvent(I){return(z,Z,Q)=>I(J=>{const X=this.f[this.f.length-1];X?X.push(()=>z.call(Z,J)):z.call(Z,J)},void 0,Q)}bufferEvents(I){const z=[];this.f.push(z);const Z=I();return this.f.pop(),z.forEach(Q=>Q()),Z}}t.$me=k;class S{constructor(){this.f=!1,this.g=c.None,this.h=R.$Vc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(I){this.g=I,this.f&&(this.h.dispose(),this.h=I(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$ne=S;class x{static const(I){return new D(I)}constructor(I){this.g=I,this.f=new l,this.onDidChange=this.f.event}get value(){return this.g}set value(I){I!==this.g&&(this.g=I,this.f.fire(void 0))}}t.$oe=x;class D{constructor(I){this.value=I,this.onDidChange=c.None}}}),ie(se[24],ue([0,1,11]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pe=t.CancellationToken=void 0;const y=Object.freeze(function(g,a){const u=setTimeout(g.bind(a),0);return{dispose(){clearTimeout(u)}}});var R;(function(g){function a(u){return u===g.None||u===g.Cancelled||u instanceof h?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}g.isCancellationToken=a,g.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),g.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:y})})(R||(t.CancellationToken=R={}));class h{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?y:(this.b||(this.b=new i.$ee),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(a){this.f=void 0,this.g=void 0,this.g=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new h),this.f}cancel(){this.f?this.f instanceof h&&this.f.cancel():this.f=R.Cancelled}dispose(a=!1){a&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof h&&this.f.dispose():this.f=R.None}}t.$pe=N}),ie(se[40],ue([0,1,24]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4e=t.$3e=t.$1e=void 0,t.$2e=R;class y{constructor(a){this.b=a,this.a=null}get(){if(this.a)return this.a;const a=new i.$pe,u=this.b(a.token);return this.a={promise:u,dispose:()=>{this.a=null,a.cancel(),a.dispose()}},this.a}}t.$1e=y;function R(g){return g}class h{constructor(a,u){this.a=void 0,this.b=void 0,typeof a=="function"?(this.c=a,this.d=R):(this.c=u,this.d=a.getCacheKey)}get(a){const u=this.d(a);return this.b!==u&&(this.b=u,this.a=this.c(a)),this.a}}t.$3e=h;class N{get cachedValues(){return this.a}constructor(a,u){this.a=new Map,this.b=new Map,typeof a=="function"?(this.c=a,this.d=R):(this.c=u,this.d=a.getCacheKey)}get(a){const u=this.d(a);if(this.b.has(u))return this.b.get(u);const c=this.c(a);return this.a.set(a,c),this.b.set(u,c),c}}t.$4e=N}),ie(se[7],ue([0,1,40,39]),function(O,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7f=t.$6f=t.$5f=t.GraphemeBreakType=t.$Uf=t.$Nf=t.$Gf=t.$Ff=void 0,t.$7e=R,t.$8e=N,t.$9e=a,t.$0e=u,t.$$e=c,t.$_e=w,t.$af=d,t.$bf=m,t.$cf=e,t.$df=P,t.$ef=j,t.$ff=L,t.$gf=$,t.$hf=v,t.$if=p,t.$jf=l,t.$kf=n,t.$lf=s,t.$mf=f,t.$nf=o,t.$of=b,t.$pf=A,t.$qf=E,t.$rf=M,t.$sf=k,t.$tf=S,t.$uf=x,t.$vf=D,t.$wf=q,t.$xf=I,t.$yf=z,t.$zf=Z,t.$Af=Q,t.$Bf=J,t.$Cf=X,t.$Df=K,t.$Ef=F,t.$Hf=be,t.$If=r,t.$Jf=Le,t.$Kf=je,t.$Lf=De,t.$Mf=Te,t.$Of=V,t.$Pf=C,t.$Qf=W,t.$Rf=Y,t.$Sf=fe,t.$Tf=de,t.$Vf=ne,t.$Wf=U,t.$Xf=re,t.$Yf=te,t.$Zf=oe,t.$1f=ce,t.$2f=me,t.$3f=ve,t.$4f=Oe;function R(T){return!T||typeof T!="string"?!0:T.trim().length===0}const h=/{(\d+)}/g;function N(T,...B){return B.length===0?T:T.replace(h,function(G,_){const ae=parseInt(_,10);return isNaN(ae)||ae<0||ae>=B.length?G:B[ae]})}const g=/{([^}]+)}/g;function a(T,B){return Object.keys(B).length===0?T:T.replace(g,(G,_)=>B[_]??G)}function u(T){return T.replace(/[<>"'&]/g,B=>{switch(B){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return B})}function c(T){return T.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}function w(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function d(T,B){let G=0;const _=B.charCodeAt(0);for(let ae=T.length-1;ae>=0;ae--)T.charCodeAt(ae)===_&&G++;return G}function m(T,B,G="\u2026"){return T.length<=B?T:`${T.substr(0,B)}${G}`}function e(T,B,G="\u2026"){if(T.length<=B)return T;const _=Math.ceil(B/2)-G.length/2,ae=Math.floor(B/2)-G.length/2;return`${T.substr(0,_)}${G}${T.substr(T.length-ae)}`}function P(T,B=" "){const G=j(T,B);return L(G,B)}function j(T,B){if(!T||!B)return T;const G=B.length;if(G===0||T.length===0)return T;let _=0;for(;T.indexOf(B,_)===_;)_=_+G;return T.substring(_)}function L(T,B){if(!T||!B)return T;const G=B.length,_=T.length;if(G===0||_===0)return T;let ae=_,ge=-1;for(;ge=T.lastIndexOf(B,ae-1),!(ge===-1||ge+G!==ae);){if(ge===0)return"";ae=ge}return T.substring(0,ae)}function $(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function v(T){return T.replace(/\*/g,"")}function p(T,B,G={}){if(!T)throw new Error("Cannot create regex from empty string");B||(T=w(T)),G.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let _="";return G.global&&(_+="g"),G.matchCase||(_+="i"),G.multiline&&(_+="m"),G.unicode&&(_+="u"),new RegExp(T,_)}function l(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}function n(T){return T.split(/\r\n|\r|\n/)}function s(T){const B=[],G=T.split(/(\r\n|\r|\n)/);for(let _=0;_<Math.ceil(G.length/2);_++)B.push(G[2*_]+(G[2*_+1]??""));return B}function f(T){for(let B=0,G=T.length;B<G;B++){const _=T.charCodeAt(B);if(_!==32&&_!==9)return B}return-1}function o(T,B=0,G=T.length){for(let _=B;_<G;_++){const ae=T.charCodeAt(_);if(ae!==32&&ae!==9)return T.substring(B,_)}return T.substring(B,G)}function b(T,B=T.length-1){for(let G=B;G>=0;G--){const _=T.charCodeAt(G);if(_!==32&&_!==9)return G}return-1}function A(T,B,G){const _=[];let ae=0;for(const ge of T.matchAll(B)){if(_.push(T.slice(ae,ge.index)),ge.index===void 0)throw new Error("match.index should be defined");ae=ge.index+ge[0].length,_.push(G(ge[0],...ge.slice(1),ge.index,T,ge.groups))}return _.push(T.slice(ae)),Promise.all(_).then(ge=>ge.join(""))}function E(T,B){return T<B?-1:T>B?1:0}function M(T,B,G=0,_=T.length,ae=0,ge=B.length){for(;G<_&&ae<ge;G++,ae++){const Ae=T.charCodeAt(G),Ee=B.charCodeAt(ae);if(Ae<Ee)return-1;if(Ae>Ee)return 1}const Pe=_-G,Fe=ge-ae;return Pe<Fe?-1:Pe>Fe?1:0}function k(T,B){return S(T,B,0,T.length,0,B.length)}function S(T,B,G=0,_=T.length,ae=0,ge=B.length){for(;G<_&&ae<ge;G++,ae++){let Ae=T.charCodeAt(G),Ee=B.charCodeAt(ae);if(Ae===Ee)continue;if(Ae>=128||Ee>=128)return M(T.toLowerCase(),B.toLowerCase(),G,_,ae,ge);D(Ae)&&(Ae-=32),D(Ee)&&(Ee-=32);const Ne=Ae-Ee;if(Ne!==0)return Ne}const Pe=_-G,Fe=ge-ae;return Pe<Fe?-1:Pe>Fe?1:0}function x(T){return T>=48&&T<=57}function D(T){return T>=97&&T<=122}function q(T){return T>=65&&T<=90}function I(T,B){return T.length===B.length&&S(T,B)===0}function z(T,B){const G=B.length;return B.length>T.length?!1:S(T,B,0,G)===0}function Z(T,B){const G=Math.min(T.length,B.length);let _;for(_=0;_<G;_++)if(T.charCodeAt(_)!==B.charCodeAt(_))return _;return G}function Q(T,B){const G=Math.min(T.length,B.length);let _;const ae=T.length-1,ge=B.length-1;for(_=0;_<G;_++)if(T.charCodeAt(ae-_)!==B.charCodeAt(ge-_))return _;return G}function J(T){return 55296<=T&&T<=56319}function X(T){return 56320<=T&&T<=57343}function K(T,B){return(T-55296<<10)+(B-56320)+65536}function F(T,B,G){const _=T.charCodeAt(G);if(J(_)&&G+1<B){const ae=T.charCodeAt(G+1);if(X(ae))return K(_,ae)}return _}function H(T,B){const G=T.charCodeAt(B-1);if(X(G)&&B>1){const _=T.charCodeAt(B-2);if(J(_))return K(_,G)}return G}class he{get offset(){return this.e}constructor(B,G=0){this.c=B,this.d=B.length,this.e=G}setOffset(B){this.e=B}prevCodePoint(){const B=H(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=F(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.$Ff=he;class le{get offset(){return this.c.offset}constructor(B,G=0){this.c=new he(B,G)}nextGraphemeLength(){const B=pe.getInstance(),G=this.c,_=G.offset;let ae=B.getGraphemeBreakType(G.nextCodePoint());for(;!G.eol();){const ge=G.offset,Pe=B.getGraphemeBreakType(G.nextCodePoint());if(we(ae,Pe)){G.setOffset(ge);break}ae=Pe}return G.offset-_}prevGraphemeLength(){const B=pe.getInstance(),G=this.c,_=G.offset;let ae=B.getGraphemeBreakType(G.prevCodePoint());for(;G.offset>0;){const ge=G.offset,Pe=B.getGraphemeBreakType(G.prevCodePoint());if(we(Pe,ae)){G.setOffset(ge);break}ae=Pe}return _-G.offset}eol(){return this.c.eol()}}t.$Gf=le;function be(T,B){return new le(T,B).nextGraphemeLength()}function r(T,B){return new le(T,B).prevGraphemeLength()}function Le(T,B){B>0&&X(T.charCodeAt(B))&&B--;const G=B+be(T,B);return[G-r(T,G),G]}function je(T){const B=new le(T);let G=0;for(;!B.eol();)G++,B.nextGraphemeLength();return G}let Se;function Be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function De(T){return Se||(Se=Be()),Se.test(T)}const Me=/^[\t\n\r\x20-\x7E]*$/;function Te(T){return Me.test(T)}t.$Nf=/[\u2028\u2029]/;function V(T){return t.$Nf.test(T)}function C(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}function W(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}function Y(T,B,G=""){const _=T.trimStart();if(_.length<B)return _;const ae=/\b/g;let ge=0;for(;ae.test(_)&&!(_.length-ae.lastIndex<B);)ge=ae.lastIndex,ae.lastIndex+=1;return ge===0?_:G+_.substring(ge).trimStart()}const ee=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*fe(T){let B=0;for(const G of T.matchAll(ee))B!==G.index&&(yield{isCode:!1,str:T.substring(B,G.index)}),yield{isCode:!0,str:G[0]},B=G.index+G[0].length;B!==T.length&&(yield{isCode:!1,str:T.substring(B)})}function de(T){return T&&(T=T.replace(ee,"")),T}t.$Uf="\uFEFF";function ne(T){return!!(T&&T.length>0&&T.charCodeAt(0)===65279)}function U(T){return ne(T)?T.substr(1):T}function re(T,B){if(!T||!B||T.length<B.length)return!1;const G=B.length,_=T.toLowerCase();let ae=0,ge=-1;for(;ae<G;){const Pe=_.indexOf(B[ae],ge+1);if(Pe<0)return!1;ge=Pe,ae++}return!0}function te(T,B=!1){return T?(B&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}function oe(T){return T.charAt(0).toUpperCase()+T.slice(1)}function ce(T,B=1){if(B===0)return"";let G=-1;do G=T.indexOf(`
`,G+1),B--;while(B>0&&G>=0);return G===-1?T:(T[G-1]==="\r"&&G--,T.substr(0,G))}function me(T){return T=T%(2*26),T<26?String.fromCharCode(97+T):String.fromCharCode(65+T-26)}function ve(T){return pe.getInstance().getGraphemeBreakType(T)}function we(T,B){return T===0?B!==5&&B!==7:T===2&&B===3?!1:T===4||T===2||T===3||B===4||B===2||B===3?!0:!(T===8&&(B===8||B===9||B===11||B===12)||(T===11||T===9)&&(B===9||B===10)||(T===12||T===10)&&B===10||B===5||B===13||B===7||T===1||T===13&&B===14||T===6&&B===6)}var ye;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(ye||(t.GraphemeBreakType=ye={}));class pe{static{this.c=null}static getInstance(){return pe.c||(pe.c=new pe),pe.c}constructor(){this.d=Ie()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const G=this.d,_=G.length/3;let ae=1;for(;ae<=_;)if(B<G[3*ae])ae=2*ae;else if(B>G[3*ae+1])ae=2*ae+1;else return G[3*ae+2];return 0}}function Ie(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Oe(T,B){if(T===0)return 0;const G=xe(T,B);if(G!==void 0)return G;const _=new he(B,T);return _.prevCodePoint(),_.offset}function xe(T,B){const G=new he(B,T);let _=G.prevCodePoint();for(;ze(_)||_===65039||_===8419;){if(G.offset===0)return;_=G.prevCodePoint()}if(!W(_))return;let ae=G.offset;return ae>0&&G.prevCodePoint()===8205&&(ae=G.offset),ae}function ze(T){return 127995<=T&&T<=127999}var We;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),t.$5f="\xA0";class qe{static{this.c=new y.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$3e({getCacheKey:JSON.stringify},B=>{function G(Ne){const ke=new Map;for(let Re=0;Re<Ne.length;Re+=2)ke.set(Ne[Re],Ne[Re+1]);return ke}function _(Ne,ke){const Re=new Map(Ne);for(const[Ce,He]of ke)Re.set(Ce,He);return Re}function ae(Ne,ke){if(!Ne)return ke;const Re=new Map;for(const[Ce,He]of Ne)ke.has(Ce)&&Re.set(Ce,He);return Re}const ge=this.c.value;let Pe=B.filter(Ne=>!Ne.startsWith("_")&&Ne in ge);Pe.length===0&&(Pe=["_default"]);let Fe;for(const Ne of Pe){const ke=G(ge[Ne]);Fe=ae(Fe,ke)}const Ae=G(ge._common),Ee=_(Ae,Fe);return new qe(Ee)})}static getInstance(B){return qe.d.get(Array.from(B))}static{this.e=new y.$V(()=>Object.keys(qe.c.value).filter(B=>!B.startsWith("_")))}static getLocales(){return qe.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$6f=qe;class Ve{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ve.c())),this.d}static isInvisibleCharacter(B){return Ve.e().has(B)}static get codePoints(){return Ve.e()}}t.$7f=Ve}),ie(se[41],ue([0,1,7]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pj=t.$nj=void 0,t.$jj=y,t.$kj=R,t.$lj=h,t.$mj=g,t.$oj=P;function y(L){return R(L,0)}function R(L,$){switch(typeof L){case"object":return L===null?h(349,$):Array.isArray(L)?a(L,$):u(L,$);case"string":return g(L,$);case"boolean":return N(L,$);case"number":return h(L,$);case"undefined":return h(937,$);default:return h(617,$)}}function h(L,$){return($<<5)-$+L|0}function N(L,$){return h(L?433:863,$)}function g(L,$){$=h(149417,$);for(let v=0,p=L.length;v<p;v++)$=h(L.charCodeAt(v),$);return $}function a(L,$){return $=h(104579,$),L.reduce((v,p)=>R(p,v),$)}function u(L,$){return $=h(181387,$),Object.keys(L).sort().reduce((v,p)=>(v=g(p,v),R(L[p],v)),$)}class c{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=R($,this.g),this.g}}t.$nj=c;var w;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function d(L,$,v=32){const p=v-$,l=~((1<<p)-1);return(L<<$|(l&L)>>>p)>>>0}function m(L,$=0,v=L.byteLength,p=0){for(let l=0;l<v;l++)L[$+l]=p}function e(L,$,v="0"){for(;L.length<$;)L=v+L;return L}function P(L,$=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(v=>v.toString(16).padStart(2,"0")).join(""):e((L>>>0).toString(16),$/4)}class j{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const v=$.length;if(v===0)return;const p=this.p;let l=this.r,n=this.u,s,f;for(n!==0?(s=n,f=-1,n=0):(s=$.charCodeAt(0),f=0);;){let o=s;if(i.$Bf(s))if(f+1<v){const b=$.charCodeAt(f+1);i.$Cf(b)?(f++,o=i.$Df(s,b)):o=65533}else{n=s;break}else i.$Cf(s)&&(o=65533);if(l=this.w(p,l,o),f++,f<v)s=$.charCodeAt(f);else break}this.r=l,this.u=n}w($,v,p){return p<128?$[v++]=p:p<2048?($[v++]=192|(p&1984)>>>6,$[v++]=128|(p&63)>>>0):p<65536?($[v++]=224|(p&61440)>>>12,$[v++]=128|(p&4032)>>>6,$[v++]=128|(p&63)>>>0):($[v++]=240|(p&1835008)>>>18,$[v++]=128|(p&258048)>>>12,$[v++]=128|(p&4032)>>>6,$[v++]=128|(p&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,$[0]=$[64],$[1]=$[65],$[2]=$[66]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),P(this.h)+P(this.l)+P(this.m)+P(this.n)+P(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=j.g,v=this.q;for(let E=0;E<64;E+=4)$.setUint32(E,v.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)$.setUint32(E,d($.getUint32(E-12,!1)^$.getUint32(E-32,!1)^$.getUint32(E-56,!1)^$.getUint32(E-64,!1),1),!1);let p=this.h,l=this.l,n=this.m,s=this.n,f=this.o,o,b,A;for(let E=0;E<80;E++)E<20?(o=l&n|~l&s,b=1518500249):E<40?(o=l^n^s,b=1859775393):E<60?(o=l&n|l&s|n&s,b=2400959708):(o=l^n^s,b=3395469782),A=d(p,5)+o+f+b+$.getUint32(E*4,!1)&4294967295,f=s,s=n,n=d(l,30),l=p,p=A;this.h=this.h+p&4294967295,this.l=this.l+l&4294967295,this.m=this.m+n&4294967295,this.n=this.n+s&4294967295,this.o=this.o+f&4294967295}}t.$pj=j}),ie(se[25],ue([0,1,37,41]),function(O,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zt=t.$xt=void 0,t.$yt=h;class R{constructor(d){this.a=d}getElements(){const d=this.a,m=new Int32Array(d.length);for(let e=0,P=d.length;e<P;e++)m[e]=d.charCodeAt(e);return m}}t.$xt=R;function h(w,d,m){return new c(new R(w),new R(d)).ComputeDiff(m).changes}class N{static Assert(d,m){if(!d)throw new Error(m)}}class g{static Copy(d,m,e,P,j){for(let L=0;L<j;L++)e[P+L]=d[m+L]}static Copy2(d,m,e,P,j){for(let L=0;L<j;L++)e[P+L]=d[m+L]}}var a;(function(w){w[w.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class u{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$wt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(d,m){this.b=Math.min(this.b,d),this.c=Math.min(this.c,m),this.d++}AddModifiedElement(d,m){this.b=Math.min(this.b,d),this.c=Math.min(this.c,m),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class c{constructor(d,m,e=null){this.a=e,this.b=d,this.c=m;const[P,j,L]=c.o(d),[$,v,p]=c.o(m);this.d=L&&p,this.e=P,this.f=j,this.g=$,this.h=v,this.k=[],this.m=[]}static n(d){return d.length>0&&typeof d[0]=="string"}static o(d){const m=d.getElements();if(c.n(m)){const e=new Int32Array(m.length);for(let P=0,j=m.length;P<j;P++)e[P]=(0,y.$mj)(m[P],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}p(d,m){return this.f[d]!==this.h[m]?!1:this.d?this.e[d]===this.g[m]:!0}q(d,m){if(!this.p(d,m))return!1;const e=c.r(this.b,d),P=c.r(this.c,m);return e===P}static r(d,m){return typeof d.getStrictElement=="function"?d.getStrictElement(m):null}s(d,m){return this.f[d]!==this.f[m]?!1:this.d?this.e[d]===this.e[m]:!0}u(d,m){return this.h[d]!==this.h[m]?!1:this.d?this.g[d]===this.g[m]:!0}ComputeDiff(d){return this.v(0,this.f.length-1,0,this.h.length-1,d)}v(d,m,e,P,j){const L=[!1];let $=this.w(d,m,e,P,L);return j&&($=this.z($)),{quitEarly:L[0],changes:$}}w(d,m,e,P,j){for(j[0]=!1;d<=m&&e<=P&&this.p(d,e);)d++,e++;for(;m>=d&&P>=e&&this.p(m,P);)m--,P--;if(d>m||e>P){let n;return e<=P?(N.Assert(d===m+1,"originalStart should only be one more than originalEnd"),n=[new i.$wt(d,0,e,P-e+1)]):d<=m?(N.Assert(e===P+1,"modifiedStart should only be one more than modifiedEnd"),n=[new i.$wt(d,m-d+1,e,0)]):(N.Assert(d===m+1,"originalStart should only be one more than originalEnd"),N.Assert(e===P+1,"modifiedStart should only be one more than modifiedEnd"),n=[]),n}const L=[0],$=[0],v=this.y(d,m,e,P,L,$,j),p=L[0],l=$[0];if(v!==null)return v;if(!j[0]){const n=this.w(d,p,e,l,j);let s=[];return j[0]?s=[new i.$wt(p+1,m-(p+1)+1,l+1,P-(l+1)+1)]:s=this.w(p+1,m,l+1,P,j),this.H(n,s)}return[new i.$wt(d,m-d+1,e,P-e+1)]}x(d,m,e,P,j,L,$,v,p,l,n,s,f,o,b,A,E,M){let k=null,S=null,x=new u,D=m,q=e,I=f[0]-A[0]-P,z=-1073741824,Z=this.k.length-1;do{const Q=I+d;Q===D||Q<q&&p[Q-1]<p[Q+1]?(n=p[Q+1],o=n-I-P,n<z&&x.MarkNextChange(),z=n,x.AddModifiedElement(n+1,o),I=Q+1-d):(n=p[Q-1]+1,o=n-I-P,n<z&&x.MarkNextChange(),z=n-1,x.AddOriginalElement(n,o+1),I=Q-1-d),Z>=0&&(p=this.k[Z],d=p[0],D=1,q=p.length-1)}while(--Z>=-1);if(k=x.getReverseChanges(),M[0]){let Q=f[0]+1,J=A[0]+1;if(k!==null&&k.length>0){const X=k[k.length-1];Q=Math.max(Q,X.getOriginalEnd()),J=Math.max(J,X.getModifiedEnd())}S=[new i.$wt(Q,s-Q+1,J,b-J+1)]}else{x=new u,D=L,q=$,I=f[0]-A[0]-v,z=1073741824,Z=E?this.m.length-1:this.m.length-2;do{const Q=I+j;Q===D||Q<q&&l[Q-1]>=l[Q+1]?(n=l[Q+1]-1,o=n-I-v,n>z&&x.MarkNextChange(),z=n+1,x.AddOriginalElement(n+1,o+1),I=Q+1-j):(n=l[Q-1],o=n-I-v,n>z&&x.MarkNextChange(),z=n,x.AddModifiedElement(n+1,o+1),I=Q-1-j),Z>=0&&(l=this.m[Z],j=l[0],D=1,q=l.length-1)}while(--Z>=-1);S=x.getChanges()}return this.H(k,S)}y(d,m,e,P,j,L,$){let v=0,p=0,l=0,n=0,s=0,f=0;d--,e--,j[0]=0,L[0]=0,this.k=[],this.m=[];const o=m-d+(P-e),b=o+1,A=new Int32Array(b),E=new Int32Array(b),M=P-e,k=m-d,S=d-e,x=m-P,q=(k-M)%2===0;A[M]=d,E[k]=m,$[0]=!1;for(let I=1;I<=o/2+1;I++){let z=0,Z=0;l=this.J(M-I,I,M,b),n=this.J(M+I,I,M,b);for(let J=l;J<=n;J+=2){J===l||J<n&&A[J-1]<A[J+1]?v=A[J+1]:v=A[J-1]+1,p=v-(J-M)-S;const X=v;for(;v<m&&p<P&&this.p(v+1,p+1);)v++,p++;if(A[J]=v,v+p>z+Z&&(z=v,Z=p),!q&&Math.abs(J-k)<=I-1&&v>=E[J])return j[0]=v,L[0]=p,X<=E[J]&&1447>0&&I<=1448?this.x(M,l,n,S,k,s,f,x,A,E,v,m,j,p,P,L,q,$):null}const Q=(z-d+(Z-e)-I)/2;if(this.a!==null&&!this.a(z,Q))return $[0]=!0,j[0]=z,L[0]=Z,Q>0&&1447>0&&I<=1448?this.x(M,l,n,S,k,s,f,x,A,E,v,m,j,p,P,L,q,$):(d++,e++,[new i.$wt(d,m-d+1,e,P-e+1)]);s=this.J(k-I,I,k,b),f=this.J(k+I,I,k,b);for(let J=s;J<=f;J+=2){J===s||J<f&&E[J-1]>=E[J+1]?v=E[J+1]-1:v=E[J-1],p=v-(J-k)-x;const X=v;for(;v>d&&p>e&&this.p(v,p);)v--,p--;if(E[J]=v,q&&Math.abs(J-M)<=I&&v<=A[J])return j[0]=v,L[0]=p,X>=A[J]&&1447>0&&I<=1448?this.x(M,l,n,S,k,s,f,x,A,E,v,m,j,p,P,L,q,$):null}if(I<=1447){let J=new Int32Array(n-l+2);J[0]=M-l+1,g.Copy2(A,l,J,1,n-l+1),this.k.push(J),J=new Int32Array(f-s+2),J[0]=k-s+1,g.Copy2(E,s,J,1,f-s+1),this.m.push(J)}}return this.x(M,l,n,S,k,s,f,x,A,E,v,m,j,p,P,L,q,$)}z(d){for(let m=0;m<d.length;m++){const e=d[m],P=m<d.length-1?d[m+1].originalStart:this.f.length,j=m<d.length-1?d[m+1].modifiedStart:this.h.length,L=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<P&&e.modifiedStart+e.modifiedLength<j&&(!L||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const p=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!p)break;e.originalStart++,e.modifiedStart++}const v=[null];if(m<d.length-1&&this.I(d[m],d[m+1],v)){d[m]=v[0],d.splice(m+1,1),m--;continue}}for(let m=d.length-1;m>=0;m--){const e=d[m];let P=0,j=0;if(m>0){const n=d[m-1];P=n.originalStart+n.originalLength,j=n.modifiedStart+n.modifiedLength}const L=e.originalLength>0,$=e.modifiedLength>0;let v=0,p=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let n=1;;n++){const s=e.originalStart-n,f=e.modifiedStart-n;if(s<P||f<j||L&&!this.s(s,s+e.originalLength)||$&&!this.u(f,f+e.modifiedLength))break;const b=(s===P&&f===j?5:0)+this.G(s,e.originalLength,f,e.modifiedLength);b>p&&(p=b,v=n)}e.originalStart-=v,e.modifiedStart-=v;const l=[null];if(m>0&&this.I(d[m-1],d[m],l)){d[m-1]=l[0],d.splice(m,1),m++;continue}}if(this.d)for(let m=1,e=d.length;m<e;m++){const P=d[m-1],j=d[m],L=j.originalStart-P.originalStart-P.originalLength,$=P.originalStart,v=j.originalStart+j.originalLength,p=v-$,l=P.modifiedStart,n=j.modifiedStart+j.modifiedLength,s=n-l;if(L<5&&p<20&&s<20){const f=this.A($,p,l,s,L);if(f){const[o,b]=f;(o!==P.originalStart+P.originalLength||b!==P.modifiedStart+P.modifiedLength)&&(P.originalLength=o-P.originalStart,P.modifiedLength=b-P.modifiedStart,j.originalStart=o+L,j.modifiedStart=b+L,j.originalLength=v-j.originalStart,j.modifiedLength=n-j.modifiedStart)}}}return d}A(d,m,e,P,j){if(m<j||P<j)return null;const L=d+m-j+1,$=e+P-j+1;let v=0,p=0,l=0;for(let n=d;n<L;n++)for(let s=e;s<$;s++){const f=this.B(n,s,j);f>0&&f>v&&(v=f,p=n,l=s)}return v>0?[p,l]:null}B(d,m,e){let P=0;for(let j=0;j<e;j++){if(!this.p(d+j,m+j))return 0;P+=this.e[d+j].length}return P}C(d){return d<=0||d>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[d])}D(d,m){if(this.C(d)||this.C(d-1))return!0;if(m>0){const e=d+m;if(this.C(e-1)||this.C(e))return!0}return!1}E(d){return d<=0||d>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[d])}F(d,m){if(this.E(d)||this.E(d-1))return!0;if(m>0){const e=d+m;if(this.E(e-1)||this.E(e))return!0}return!1}G(d,m,e,P){const j=this.D(d,m)?1:0,L=this.F(e,P)?1:0;return j+L}H(d,m){const e=[];if(d.length===0||m.length===0)return m.length>0?m:d;if(this.I(d[d.length-1],m[0],e)){const P=new Array(d.length+m.length-1);return g.Copy(d,0,P,0,d.length-1),P[d.length-1]=e[0],g.Copy(m,1,P,d.length,m.length-1),P}else{const P=new Array(d.length+m.length);return g.Copy(d,0,P,0,d.length),g.Copy(m,0,P,d.length,m.length),P}}I(d,m,e){if(N.Assert(d.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),N.Assert(d.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),d.originalStart+d.originalLength>=m.originalStart||d.modifiedStart+d.modifiedLength>=m.modifiedStart){const P=d.originalStart;let j=d.originalLength;const L=d.modifiedStart;let $=d.modifiedLength;return d.originalStart+d.originalLength>=m.originalStart&&(j=m.originalStart+m.originalLength-d.originalStart),d.modifiedStart+d.modifiedLength>=m.modifiedStart&&($=m.modifiedStart+m.modifiedLength-d.modifiedStart),e[0]=new i.$wt(P,j,L,$),!0}else return e[0]=null,!1}J(d,m,e,P){if(d>=0&&d<P)return d;const j=e,L=P-e-1,$=m%2===0;if(d<0){const v=j%2===0;return $===v?0:1}else{const v=L%2===0;return $===v?P-1:P-2}}}t.$zt=c}),ie(se[26],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8f=i,t.$9f=y,t.$0f=R,t.$$f=h,t.$_f=N,t.$ag=g,t.$bg=a,t.$cg=u,t.$dg=c,t.$eg=w,t.$fg=d,t.$gg=m,t.$hg=e,t.$ig=j,t.$jg=L,t.$kg=$,t.$lg=v,t.$mg=p;function i(l){return typeof l=="string"}function y(l){return Array.isArray(l)&&l.every(n=>i(n))}function R(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}function h(l){const n=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof n}function N(l){return typeof l=="number"&&!isNaN(l)}function g(l){return!!l&&typeof l[Symbol.iterator]=="function"}function a(l){return l===!0||l===!1}function u(l){return typeof l>"u"}function c(l){return!w(l)}function w(l){return u(l)||l===null}function d(l,n){if(!l)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function m(l){if(w(l))throw new Error("Assertion Failed: argument is undefined or null");return l}function e(...l){const n=[];for(let s=0;s<l.length;s++){const f=l[s];if(w(f))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(f)}return n}const P=Object.prototype.hasOwnProperty;function j(l){if(!R(l))return!1;for(const n in l)if(P.call(l,n))return!1;return!0}function L(l){return typeof l=="function"}function $(...l){return l.length>0&&l.every(L)}function v(l,n){const s=Math.min(l.length,n.length);for(let f=0;f<s;f++)p(l[f],n[f])}function p(l,n){if(i(n)){if(typeof l!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(L(n)){try{if(l instanceof n)return}catch{}if(!w(l)&&l.constructor===n||n.length===1&&n.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),ie(se[27],ue([0,1,26]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pj=R,t.$Qj=h;const y=Object.create(null);function R(N,g){if((0,i.$8f)(g)){const a=y[g];if(a===void 0)throw new Error(`${N} references an unknown codicon: ${g}`);g=a}return y[N]=g,{id:N}}function h(){return y}}),ie(se[42],ue([0,1,27]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rj=void 0,t.$Rj={add:(0,i.$Pj)("add",6e4),plus:(0,i.$Pj)("plus",6e4),gistNew:(0,i.$Pj)("gist-new",6e4),repoCreate:(0,i.$Pj)("repo-create",6e4),lightbulb:(0,i.$Pj)("lightbulb",60001),lightBulb:(0,i.$Pj)("light-bulb",60001),repo:(0,i.$Pj)("repo",60002),repoDelete:(0,i.$Pj)("repo-delete",60002),gistFork:(0,i.$Pj)("gist-fork",60003),repoForked:(0,i.$Pj)("repo-forked",60003),gitPullRequest:(0,i.$Pj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Pj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Pj)("record-keys",60005),keyboard:(0,i.$Pj)("keyboard",60005),tag:(0,i.$Pj)("tag",60006),gitPullRequestLabel:(0,i.$Pj)("git-pull-request-label",60006),tagAdd:(0,i.$Pj)("tag-add",60006),tagRemove:(0,i.$Pj)("tag-remove",60006),person:(0,i.$Pj)("person",60007),personFollow:(0,i.$Pj)("person-follow",60007),personOutline:(0,i.$Pj)("person-outline",60007),personFilled:(0,i.$Pj)("person-filled",60007),gitBranch:(0,i.$Pj)("git-branch",60008),gitBranchCreate:(0,i.$Pj)("git-branch-create",60008),gitBranchDelete:(0,i.$Pj)("git-branch-delete",60008),sourceControl:(0,i.$Pj)("source-control",60008),mirror:(0,i.$Pj)("mirror",60009),mirrorPublic:(0,i.$Pj)("mirror-public",60009),star:(0,i.$Pj)("star",60010),starAdd:(0,i.$Pj)("star-add",60010),starDelete:(0,i.$Pj)("star-delete",60010),starEmpty:(0,i.$Pj)("star-empty",60010),comment:(0,i.$Pj)("comment",60011),commentAdd:(0,i.$Pj)("comment-add",60011),alert:(0,i.$Pj)("alert",60012),warning:(0,i.$Pj)("warning",60012),search:(0,i.$Pj)("search",60013),searchSave:(0,i.$Pj)("search-save",60013),logOut:(0,i.$Pj)("log-out",60014),signOut:(0,i.$Pj)("sign-out",60014),logIn:(0,i.$Pj)("log-in",60015),signIn:(0,i.$Pj)("sign-in",60015),eye:(0,i.$Pj)("eye",60016),eyeUnwatch:(0,i.$Pj)("eye-unwatch",60016),eyeWatch:(0,i.$Pj)("eye-watch",60016),circleFilled:(0,i.$Pj)("circle-filled",60017),primitiveDot:(0,i.$Pj)("primitive-dot",60017),closeDirty:(0,i.$Pj)("close-dirty",60017),debugBreakpoint:(0,i.$Pj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Pj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Pj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Pj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Pj)("primitive-square",60018),edit:(0,i.$Pj)("edit",60019),pencil:(0,i.$Pj)("pencil",60019),info:(0,i.$Pj)("info",60020),issueOpened:(0,i.$Pj)("issue-opened",60020),gistPrivate:(0,i.$Pj)("gist-private",60021),gitForkPrivate:(0,i.$Pj)("git-fork-private",60021),lock:(0,i.$Pj)("lock",60021),mirrorPrivate:(0,i.$Pj)("mirror-private",60021),close:(0,i.$Pj)("close",60022),removeClose:(0,i.$Pj)("remove-close",60022),x:(0,i.$Pj)("x",60022),repoSync:(0,i.$Pj)("repo-sync",60023),sync:(0,i.$Pj)("sync",60023),clone:(0,i.$Pj)("clone",60024),desktopDownload:(0,i.$Pj)("desktop-download",60024),beaker:(0,i.$Pj)("beaker",60025),microscope:(0,i.$Pj)("microscope",60025),vm:(0,i.$Pj)("vm",60026),deviceDesktop:(0,i.$Pj)("device-desktop",60026),file:(0,i.$Pj)("file",60027),fileText:(0,i.$Pj)("file-text",60027),more:(0,i.$Pj)("more",60028),ellipsis:(0,i.$Pj)("ellipsis",60028),kebabHorizontal:(0,i.$Pj)("kebab-horizontal",60028),mailReply:(0,i.$Pj)("mail-reply",60029),reply:(0,i.$Pj)("reply",60029),organization:(0,i.$Pj)("organization",60030),organizationFilled:(0,i.$Pj)("organization-filled",60030),organizationOutline:(0,i.$Pj)("organization-outline",60030),newFile:(0,i.$Pj)("new-file",60031),fileAdd:(0,i.$Pj)("file-add",60031),newFolder:(0,i.$Pj)("new-folder",60032),fileDirectoryCreate:(0,i.$Pj)("file-directory-create",60032),trash:(0,i.$Pj)("trash",60033),trashcan:(0,i.$Pj)("trashcan",60033),history:(0,i.$Pj)("history",60034),clock:(0,i.$Pj)("clock",60034),folder:(0,i.$Pj)("folder",60035),fileDirectory:(0,i.$Pj)("file-directory",60035),symbolFolder:(0,i.$Pj)("symbol-folder",60035),logoGithub:(0,i.$Pj)("logo-github",60036),markGithub:(0,i.$Pj)("mark-github",60036),github:(0,i.$Pj)("github",60036),terminal:(0,i.$Pj)("terminal",60037),console:(0,i.$Pj)("console",60037),repl:(0,i.$Pj)("repl",60037),zap:(0,i.$Pj)("zap",60038),symbolEvent:(0,i.$Pj)("symbol-event",60038),error:(0,i.$Pj)("error",60039),stop:(0,i.$Pj)("stop",60039),variable:(0,i.$Pj)("variable",60040),symbolVariable:(0,i.$Pj)("symbol-variable",60040),array:(0,i.$Pj)("array",60042),symbolArray:(0,i.$Pj)("symbol-array",60042),symbolModule:(0,i.$Pj)("symbol-module",60043),symbolPackage:(0,i.$Pj)("symbol-package",60043),symbolNamespace:(0,i.$Pj)("symbol-namespace",60043),symbolObject:(0,i.$Pj)("symbol-object",60043),symbolMethod:(0,i.$Pj)("symbol-method",60044),symbolFunction:(0,i.$Pj)("symbol-function",60044),symbolConstructor:(0,i.$Pj)("symbol-constructor",60044),symbolBoolean:(0,i.$Pj)("symbol-boolean",60047),symbolNull:(0,i.$Pj)("symbol-null",60047),symbolNumeric:(0,i.$Pj)("symbol-numeric",60048),symbolNumber:(0,i.$Pj)("symbol-number",60048),symbolStructure:(0,i.$Pj)("symbol-structure",60049),symbolStruct:(0,i.$Pj)("symbol-struct",60049),symbolParameter:(0,i.$Pj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Pj)("symbol-type-parameter",60050),symbolKey:(0,i.$Pj)("symbol-key",60051),symbolText:(0,i.$Pj)("symbol-text",60051),symbolReference:(0,i.$Pj)("symbol-reference",60052),goToFile:(0,i.$Pj)("go-to-file",60052),symbolEnum:(0,i.$Pj)("symbol-enum",60053),symbolValue:(0,i.$Pj)("symbol-value",60053),symbolRuler:(0,i.$Pj)("symbol-ruler",60054),symbolUnit:(0,i.$Pj)("symbol-unit",60054),activateBreakpoints:(0,i.$Pj)("activate-breakpoints",60055),archive:(0,i.$Pj)("archive",60056),arrowBoth:(0,i.$Pj)("arrow-both",60057),arrowDown:(0,i.$Pj)("arrow-down",60058),arrowLeft:(0,i.$Pj)("arrow-left",60059),arrowRight:(0,i.$Pj)("arrow-right",60060),arrowSmallDown:(0,i.$Pj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Pj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Pj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Pj)("arrow-small-up",60064),arrowUp:(0,i.$Pj)("arrow-up",60065),bell:(0,i.$Pj)("bell",60066),bold:(0,i.$Pj)("bold",60067),book:(0,i.$Pj)("book",60068),bookmark:(0,i.$Pj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Pj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Pj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Pj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Pj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Pj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Pj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Pj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Pj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Pj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Pj)("briefcase",60076),broadcast:(0,i.$Pj)("broadcast",60077),browser:(0,i.$Pj)("browser",60078),bug:(0,i.$Pj)("bug",60079),calendar:(0,i.$Pj)("calendar",60080),caseSensitive:(0,i.$Pj)("case-sensitive",60081),check:(0,i.$Pj)("check",60082),checklist:(0,i.$Pj)("checklist",60083),chevronDown:(0,i.$Pj)("chevron-down",60084),chevronLeft:(0,i.$Pj)("chevron-left",60085),chevronRight:(0,i.$Pj)("chevron-right",60086),chevronUp:(0,i.$Pj)("chevron-up",60087),chromeClose:(0,i.$Pj)("chrome-close",60088),chromeMaximize:(0,i.$Pj)("chrome-maximize",60089),chromeMinimize:(0,i.$Pj)("chrome-minimize",60090),chromeRestore:(0,i.$Pj)("chrome-restore",60091),circleOutline:(0,i.$Pj)("circle-outline",60092),circle:(0,i.$Pj)("circle",60092),debugBreakpointUnverified:(0,i.$Pj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Pj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Pj)("circle-slash",60093),circuitBoard:(0,i.$Pj)("circuit-board",60094),clearAll:(0,i.$Pj)("clear-all",60095),clippy:(0,i.$Pj)("clippy",60096),closeAll:(0,i.$Pj)("close-all",60097),cloudDownload:(0,i.$Pj)("cloud-download",60098),cloudUpload:(0,i.$Pj)("cloud-upload",60099),code:(0,i.$Pj)("code",60100),collapseAll:(0,i.$Pj)("collapse-all",60101),colorMode:(0,i.$Pj)("color-mode",60102),commentDiscussion:(0,i.$Pj)("comment-discussion",60103),creditCard:(0,i.$Pj)("credit-card",60105),dash:(0,i.$Pj)("dash",60108),dashboard:(0,i.$Pj)("dashboard",60109),database:(0,i.$Pj)("database",60110),debugContinue:(0,i.$Pj)("debug-continue",60111),debugDisconnect:(0,i.$Pj)("debug-disconnect",60112),debugPause:(0,i.$Pj)("debug-pause",60113),debugRestart:(0,i.$Pj)("debug-restart",60114),debugStart:(0,i.$Pj)("debug-start",60115),debugStepInto:(0,i.$Pj)("debug-step-into",60116),debugStepOut:(0,i.$Pj)("debug-step-out",60117),debugStepOver:(0,i.$Pj)("debug-step-over",60118),debugStop:(0,i.$Pj)("debug-stop",60119),debug:(0,i.$Pj)("debug",60120),deviceCameraVideo:(0,i.$Pj)("device-camera-video",60121),deviceCamera:(0,i.$Pj)("device-camera",60122),deviceMobile:(0,i.$Pj)("device-mobile",60123),diffAdded:(0,i.$Pj)("diff-added",60124),diffIgnored:(0,i.$Pj)("diff-ignored",60125),diffModified:(0,i.$Pj)("diff-modified",60126),diffRemoved:(0,i.$Pj)("diff-removed",60127),diffRenamed:(0,i.$Pj)("diff-renamed",60128),diff:(0,i.$Pj)("diff",60129),diffSidebyside:(0,i.$Pj)("diff-sidebyside",60129),discard:(0,i.$Pj)("discard",60130),editorLayout:(0,i.$Pj)("editor-layout",60131),emptyWindow:(0,i.$Pj)("empty-window",60132),exclude:(0,i.$Pj)("exclude",60133),extensions:(0,i.$Pj)("extensions",60134),eyeClosed:(0,i.$Pj)("eye-closed",60135),fileBinary:(0,i.$Pj)("file-binary",60136),fileCode:(0,i.$Pj)("file-code",60137),fileMedia:(0,i.$Pj)("file-media",60138),filePdf:(0,i.$Pj)("file-pdf",60139),fileSubmodule:(0,i.$Pj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Pj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Pj)("file-symlink-file",60142),fileZip:(0,i.$Pj)("file-zip",60143),files:(0,i.$Pj)("files",60144),filter:(0,i.$Pj)("filter",60145),flame:(0,i.$Pj)("flame",60146),foldDown:(0,i.$Pj)("fold-down",60147),foldUp:(0,i.$Pj)("fold-up",60148),fold:(0,i.$Pj)("fold",60149),folderActive:(0,i.$Pj)("folder-active",60150),folderOpened:(0,i.$Pj)("folder-opened",60151),gear:(0,i.$Pj)("gear",60152),gift:(0,i.$Pj)("gift",60153),gistSecret:(0,i.$Pj)("gist-secret",60154),gist:(0,i.$Pj)("gist",60155),gitCommit:(0,i.$Pj)("git-commit",60156),gitCompare:(0,i.$Pj)("git-compare",60157),compareChanges:(0,i.$Pj)("compare-changes",60157),gitMerge:(0,i.$Pj)("git-merge",60158),githubAction:(0,i.$Pj)("github-action",60159),githubAlt:(0,i.$Pj)("github-alt",60160),globe:(0,i.$Pj)("globe",60161),grabber:(0,i.$Pj)("grabber",60162),graph:(0,i.$Pj)("graph",60163),gripper:(0,i.$Pj)("gripper",60164),heart:(0,i.$Pj)("heart",60165),home:(0,i.$Pj)("home",60166),horizontalRule:(0,i.$Pj)("horizontal-rule",60167),hubot:(0,i.$Pj)("hubot",60168),inbox:(0,i.$Pj)("inbox",60169),issueReopened:(0,i.$Pj)("issue-reopened",60171),issues:(0,i.$Pj)("issues",60172),italic:(0,i.$Pj)("italic",60173),jersey:(0,i.$Pj)("jersey",60174),json:(0,i.$Pj)("json",60175),kebabVertical:(0,i.$Pj)("kebab-vertical",60176),key:(0,i.$Pj)("key",60177),law:(0,i.$Pj)("law",60178),lightbulbAutofix:(0,i.$Pj)("lightbulb-autofix",60179),linkExternal:(0,i.$Pj)("link-external",60180),link:(0,i.$Pj)("link",60181),listOrdered:(0,i.$Pj)("list-ordered",60182),listUnordered:(0,i.$Pj)("list-unordered",60183),liveShare:(0,i.$Pj)("live-share",60184),loading:(0,i.$Pj)("loading",60185),location:(0,i.$Pj)("location",60186),mailRead:(0,i.$Pj)("mail-read",60187),mail:(0,i.$Pj)("mail",60188),markdown:(0,i.$Pj)("markdown",60189),megaphone:(0,i.$Pj)("megaphone",60190),mention:(0,i.$Pj)("mention",60191),milestone:(0,i.$Pj)("milestone",60192),gitPullRequestMilestone:(0,i.$Pj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Pj)("mortar-board",60193),move:(0,i.$Pj)("move",60194),multipleWindows:(0,i.$Pj)("multiple-windows",60195),mute:(0,i.$Pj)("mute",60196),noNewline:(0,i.$Pj)("no-newline",60197),note:(0,i.$Pj)("note",60198),octoface:(0,i.$Pj)("octoface",60199),openPreview:(0,i.$Pj)("open-preview",60200),package:(0,i.$Pj)("package",60201),paintcan:(0,i.$Pj)("paintcan",60202),pin:(0,i.$Pj)("pin",60203),play:(0,i.$Pj)("play",60204),run:(0,i.$Pj)("run",60204),plug:(0,i.$Pj)("plug",60205),preserveCase:(0,i.$Pj)("preserve-case",60206),preview:(0,i.$Pj)("preview",60207),project:(0,i.$Pj)("project",60208),pulse:(0,i.$Pj)("pulse",60209),question:(0,i.$Pj)("question",60210),quote:(0,i.$Pj)("quote",60211),radioTower:(0,i.$Pj)("radio-tower",60212),reactions:(0,i.$Pj)("reactions",60213),references:(0,i.$Pj)("references",60214),refresh:(0,i.$Pj)("refresh",60215),regex:(0,i.$Pj)("regex",60216),remoteExplorer:(0,i.$Pj)("remote-explorer",60217),remote:(0,i.$Pj)("remote",60218),remove:(0,i.$Pj)("remove",60219),replaceAll:(0,i.$Pj)("replace-all",60220),replace:(0,i.$Pj)("replace",60221),repoClone:(0,i.$Pj)("repo-clone",60222),repoForcePush:(0,i.$Pj)("repo-force-push",60223),repoPull:(0,i.$Pj)("repo-pull",60224),repoPush:(0,i.$Pj)("repo-push",60225),report:(0,i.$Pj)("report",60226),requestChanges:(0,i.$Pj)("request-changes",60227),rocket:(0,i.$Pj)("rocket",60228),rootFolderOpened:(0,i.$Pj)("root-folder-opened",60229),rootFolder:(0,i.$Pj)("root-folder",60230),rss:(0,i.$Pj)("rss",60231),ruby:(0,i.$Pj)("ruby",60232),saveAll:(0,i.$Pj)("save-all",60233),saveAs:(0,i.$Pj)("save-as",60234),save:(0,i.$Pj)("save",60235),screenFull:(0,i.$Pj)("screen-full",60236),screenNormal:(0,i.$Pj)("screen-normal",60237),searchStop:(0,i.$Pj)("search-stop",60238),server:(0,i.$Pj)("server",60240),settingsGear:(0,i.$Pj)("settings-gear",60241),settings:(0,i.$Pj)("settings",60242),shield:(0,i.$Pj)("shield",60243),smiley:(0,i.$Pj)("smiley",60244),sortPrecedence:(0,i.$Pj)("sort-precedence",60245),splitHorizontal:(0,i.$Pj)("split-horizontal",60246),splitVertical:(0,i.$Pj)("split-vertical",60247),squirrel:(0,i.$Pj)("squirrel",60248),starFull:(0,i.$Pj)("star-full",60249),starHalf:(0,i.$Pj)("star-half",60250),symbolClass:(0,i.$Pj)("symbol-class",60251),symbolColor:(0,i.$Pj)("symbol-color",60252),symbolConstant:(0,i.$Pj)("symbol-constant",60253),symbolEnumMember:(0,i.$Pj)("symbol-enum-member",60254),symbolField:(0,i.$Pj)("symbol-field",60255),symbolFile:(0,i.$Pj)("symbol-file",60256),symbolInterface:(0,i.$Pj)("symbol-interface",60257),symbolKeyword:(0,i.$Pj)("symbol-keyword",60258),symbolMisc:(0,i.$Pj)("symbol-misc",60259),symbolOperator:(0,i.$Pj)("symbol-operator",60260),symbolProperty:(0,i.$Pj)("symbol-property",60261),wrench:(0,i.$Pj)("wrench",60261),wrenchSubaction:(0,i.$Pj)("wrench-subaction",60261),symbolSnippet:(0,i.$Pj)("symbol-snippet",60262),tasklist:(0,i.$Pj)("tasklist",60263),telescope:(0,i.$Pj)("telescope",60264),textSize:(0,i.$Pj)("text-size",60265),threeBars:(0,i.$Pj)("three-bars",60266),thumbsdown:(0,i.$Pj)("thumbsdown",60267),thumbsup:(0,i.$Pj)("thumbsup",60268),tools:(0,i.$Pj)("tools",60269),triangleDown:(0,i.$Pj)("triangle-down",60270),triangleLeft:(0,i.$Pj)("triangle-left",60271),triangleRight:(0,i.$Pj)("triangle-right",60272),triangleUp:(0,i.$Pj)("triangle-up",60273),twitter:(0,i.$Pj)("twitter",60274),unfold:(0,i.$Pj)("unfold",60275),unlock:(0,i.$Pj)("unlock",60276),unmute:(0,i.$Pj)("unmute",60277),unverified:(0,i.$Pj)("unverified",60278),verified:(0,i.$Pj)("verified",60279),versions:(0,i.$Pj)("versions",60280),vmActive:(0,i.$Pj)("vm-active",60281),vmOutline:(0,i.$Pj)("vm-outline",60282),vmRunning:(0,i.$Pj)("vm-running",60283),watch:(0,i.$Pj)("watch",60284),whitespace:(0,i.$Pj)("whitespace",60285),wholeWord:(0,i.$Pj)("whole-word",60286),window:(0,i.$Pj)("window",60287),wordWrap:(0,i.$Pj)("word-wrap",60288),zoomIn:(0,i.$Pj)("zoom-in",60289),zoomOut:(0,i.$Pj)("zoom-out",60290),listFilter:(0,i.$Pj)("list-filter",60291),listFlat:(0,i.$Pj)("list-flat",60292),listSelection:(0,i.$Pj)("list-selection",60293),selection:(0,i.$Pj)("selection",60293),listTree:(0,i.$Pj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Pj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Pj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Pj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Pj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Pj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Pj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Pj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Pj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Pj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Pj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Pj)("symbol-string",60301),debugReverseContinue:(0,i.$Pj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Pj)("debug-step-back",60303),debugRestartFrame:(0,i.$Pj)("debug-restart-frame",60304),debugAlt:(0,i.$Pj)("debug-alt",60305),callIncoming:(0,i.$Pj)("call-incoming",60306),callOutgoing:(0,i.$Pj)("call-outgoing",60307),menu:(0,i.$Pj)("menu",60308),expandAll:(0,i.$Pj)("expand-all",60309),feedback:(0,i.$Pj)("feedback",60310),gitPullRequestReviewer:(0,i.$Pj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Pj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Pj)("ungroup-by-ref-type",60312),account:(0,i.$Pj)("account",60313),gitPullRequestAssignee:(0,i.$Pj)("git-pull-request-assignee",60313),bellDot:(0,i.$Pj)("bell-dot",60314),debugConsole:(0,i.$Pj)("debug-console",60315),library:(0,i.$Pj)("library",60316),output:(0,i.$Pj)("output",60317),runAll:(0,i.$Pj)("run-all",60318),syncIgnored:(0,i.$Pj)("sync-ignored",60319),pinned:(0,i.$Pj)("pinned",60320),githubInverted:(0,i.$Pj)("github-inverted",60321),serverProcess:(0,i.$Pj)("server-process",60322),serverEnvironment:(0,i.$Pj)("server-environment",60323),pass:(0,i.$Pj)("pass",60324),issueClosed:(0,i.$Pj)("issue-closed",60324),stopCircle:(0,i.$Pj)("stop-circle",60325),playCircle:(0,i.$Pj)("play-circle",60326),record:(0,i.$Pj)("record",60327),debugAltSmall:(0,i.$Pj)("debug-alt-small",60328),vmConnect:(0,i.$Pj)("vm-connect",60329),cloud:(0,i.$Pj)("cloud",60330),merge:(0,i.$Pj)("merge",60331),export:(0,i.$Pj)("export",60332),graphLeft:(0,i.$Pj)("graph-left",60333),magnet:(0,i.$Pj)("magnet",60334),notebook:(0,i.$Pj)("notebook",60335),redo:(0,i.$Pj)("redo",60336),checkAll:(0,i.$Pj)("check-all",60337),pinnedDirty:(0,i.$Pj)("pinned-dirty",60338),passFilled:(0,i.$Pj)("pass-filled",60339),circleLargeFilled:(0,i.$Pj)("circle-large-filled",60340),circleLarge:(0,i.$Pj)("circle-large",60341),circleLargeOutline:(0,i.$Pj)("circle-large-outline",60341),combine:(0,i.$Pj)("combine",60342),gather:(0,i.$Pj)("gather",60342),table:(0,i.$Pj)("table",60343),variableGroup:(0,i.$Pj)("variable-group",60344),typeHierarchy:(0,i.$Pj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Pj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Pj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Pj)("git-pull-request-create",60348),runAbove:(0,i.$Pj)("run-above",60349),runBelow:(0,i.$Pj)("run-below",60350),notebookTemplate:(0,i.$Pj)("notebook-template",60351),debugRerun:(0,i.$Pj)("debug-rerun",60352),workspaceTrusted:(0,i.$Pj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Pj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Pj)("workspace-unknown",60355),terminalCmd:(0,i.$Pj)("terminal-cmd",60356),terminalDebian:(0,i.$Pj)("terminal-debian",60357),terminalLinux:(0,i.$Pj)("terminal-linux",60358),terminalPowershell:(0,i.$Pj)("terminal-powershell",60359),terminalTmux:(0,i.$Pj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Pj)("terminal-ubuntu",60361),terminalBash:(0,i.$Pj)("terminal-bash",60362),arrowSwap:(0,i.$Pj)("arrow-swap",60363),copy:(0,i.$Pj)("copy",60364),personAdd:(0,i.$Pj)("person-add",60365),filterFilled:(0,i.$Pj)("filter-filled",60366),wand:(0,i.$Pj)("wand",60367),debugLineByLine:(0,i.$Pj)("debug-line-by-line",60368),inspect:(0,i.$Pj)("inspect",60369),layers:(0,i.$Pj)("layers",60370),layersDot:(0,i.$Pj)("layers-dot",60371),layersActive:(0,i.$Pj)("layers-active",60372),compass:(0,i.$Pj)("compass",60373),compassDot:(0,i.$Pj)("compass-dot",60374),compassActive:(0,i.$Pj)("compass-active",60375),azure:(0,i.$Pj)("azure",60376),issueDraft:(0,i.$Pj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Pj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Pj)("git-pull-request-draft",60379),debugAll:(0,i.$Pj)("debug-all",60380),debugCoverage:(0,i.$Pj)("debug-coverage",60381),runErrors:(0,i.$Pj)("run-errors",60382),folderLibrary:(0,i.$Pj)("folder-library",60383),debugContinueSmall:(0,i.$Pj)("debug-continue-small",60384),beakerStop:(0,i.$Pj)("beaker-stop",60385),graphLine:(0,i.$Pj)("graph-line",60386),graphScatter:(0,i.$Pj)("graph-scatter",60387),pieChart:(0,i.$Pj)("pie-chart",60388),bracket:(0,i.$Pj)("bracket",60175),bracketDot:(0,i.$Pj)("bracket-dot",60389),bracketError:(0,i.$Pj)("bracket-error",60390),lockSmall:(0,i.$Pj)("lock-small",60391),azureDevops:(0,i.$Pj)("azure-devops",60392),verifiedFilled:(0,i.$Pj)("verified-filled",60393),newline:(0,i.$Pj)("newline",60394),layout:(0,i.$Pj)("layout",60395),layoutActivitybarLeft:(0,i.$Pj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Pj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Pj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Pj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Pj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Pj)("layout-panel-right",60401),layoutPanel:(0,i.$Pj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Pj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Pj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Pj)("layout-statusbar",60405),layoutMenubar:(0,i.$Pj)("layout-menubar",60406),layoutCentered:(0,i.$Pj)("layout-centered",60407),target:(0,i.$Pj)("target",60408),indent:(0,i.$Pj)("indent",60409),recordSmall:(0,i.$Pj)("record-small",60410),errorSmall:(0,i.$Pj)("error-small",60411),terminalDecorationError:(0,i.$Pj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Pj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Pj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Pj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Pj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Pj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Pj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Pj)("layout-sidebar-left-off",60418),blank:(0,i.$Pj)("blank",60419),heartFilled:(0,i.$Pj)("heart-filled",60420),map:(0,i.$Pj)("map",60421),mapHorizontal:(0,i.$Pj)("map-horizontal",60421),foldHorizontal:(0,i.$Pj)("fold-horizontal",60421),mapFilled:(0,i.$Pj)("map-filled",60422),mapHorizontalFilled:(0,i.$Pj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Pj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Pj)("circle-small",60423),bellSlash:(0,i.$Pj)("bell-slash",60424),bellSlashDot:(0,i.$Pj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Pj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Pj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Pj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Pj)("search-fuzzy",60429),commentDraft:(0,i.$Pj)("comment-draft",60430),send:(0,i.$Pj)("send",60431),sparkle:(0,i.$Pj)("sparkle",60432),insert:(0,i.$Pj)("insert",60433),mic:(0,i.$Pj)("mic",60434),thumbsdownFilled:(0,i.$Pj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Pj)("thumbsup-filled",60436),coffee:(0,i.$Pj)("coffee",60437),snake:(0,i.$Pj)("snake",60438),game:(0,i.$Pj)("game",60439),vr:(0,i.$Pj)("vr",60440),chip:(0,i.$Pj)("chip",60441),piano:(0,i.$Pj)("piano",60442),music:(0,i.$Pj)("music",60443),micFilled:(0,i.$Pj)("mic-filled",60444),repoFetch:(0,i.$Pj)("repo-fetch",60445),copilot:(0,i.$Pj)("copilot",60446),lightbulbSparkle:(0,i.$Pj)("lightbulb-sparkle",60447),robot:(0,i.$Pj)("robot",60448),sparkleFilled:(0,i.$Pj)("sparkle-filled",60449),diffSingle:(0,i.$Pj)("diff-single",60450),diffMultiple:(0,i.$Pj)("diff-multiple",60451),surroundWith:(0,i.$Pj)("surround-with",60452),share:(0,i.$Pj)("share",60453),gitStash:(0,i.$Pj)("git-stash",60454),gitStashApply:(0,i.$Pj)("git-stash-apply",60455),gitStashPop:(0,i.$Pj)("git-stash-pop",60456),vscode:(0,i.$Pj)("vscode",60457),vscodeInsiders:(0,i.$Pj)("vscode-insiders",60458),codeOss:(0,i.$Pj)("code-oss",60459),runCoverage:(0,i.$Pj)("run-coverage",60460),runAllCoverage:(0,i.$Pj)("run-all-coverage",60461),coverage:(0,i.$Pj)("coverage",60462),githubProject:(0,i.$Pj)("github-project",60463),mapVertical:(0,i.$Pj)("map-vertical",60464),foldVertical:(0,i.$Pj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Pj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Pj)("fold-vertical-filled",60465),goToSearch:(0,i.$Pj)("go-to-search",60466),percentage:(0,i.$Pj)("percentage",60467),sortPercentage:(0,i.$Pj)("sort-percentage",60467)}}),ie(se[43],ue([0,1,27,42]),function(O,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uj=t.$Tj=void 0,t.$Sj=R;function R(){return Object.values(t.$Uj)}t.$Tj={dialogError:(0,i.$Pj)("dialog-error","error"),dialogWarning:(0,i.$Pj)("dialog-warning","warning"),dialogInfo:(0,i.$Pj)("dialog-info","info"),dialogClose:(0,i.$Pj)("dialog-close","close"),treeItemExpanded:(0,i.$Pj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Pj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Pj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Pj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Pj)("tree-item-loading","loading"),menuSelection:(0,i.$Pj)("menu-selection","check"),menuSubmenu:(0,i.$Pj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Pj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Pj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Pj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Pj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Pj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Pj)("toolbar-more","more"),quickInputBack:(0,i.$Pj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Pj)("drop-down-button",60084),symbolCustomColor:(0,i.$Pj)("symbol-customcolor",60252),exportIcon:(0,i.$Pj)("export",60332),workspaceUnspecified:(0,i.$Pj)("workspace-unspecified",60355),newLine:(0,i.$Pj)("newline",60394),thumbsDownFilled:(0,i.$Pj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Pj)("thumbsup-filled",60436),gitFetch:(0,i.$Pj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Pj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Pj)("debug-breakpoint-pending",60377)},t.$Uj={...y.$Rj,...t.$Tj}}),ie(se[15],ue([0,1,26]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2n=y,t.$3n=R,t.$4n=N,t.$5n=a,t.$6n=u,t.$7n=c,t.$8n=w,t.$9n=d,t.$0n=m,t.$$n=e,t.$_n=P,t.$ao=j;function y(L){if(!L||typeof L!="object"||L instanceof RegExp)return L;const $=Array.isArray(L)?[]:{};return Object.entries(L).forEach(([v,p])=>{$[v]=p&&typeof p=="object"?y(p):p}),$}function R(L){if(!L||typeof L!="object")return L;const $=[L];for(;$.length>0;){const v=$.shift();Object.freeze(v);for(const p in v)if(h.call(v,p)){const l=v[p];typeof l=="object"&&!Object.isFrozen(l)&&!(0,i.$$f)(l)&&$.push(l)}}return L}const h=Object.prototype.hasOwnProperty;function N(L,$){return g(L,$,new Set)}function g(L,$,v){if((0,i.$eg)(L))return L;const p=$(L);if(typeof p<"u")return p;if(Array.isArray(L)){const l=[];for(const n of L)l.push(g(n,$,v));return l}if((0,i.$0f)(L)){if(v.has(L))throw new Error("Cannot clone recursive data-structure");v.add(L);const l={};for(const n in L)h.call(L,n)&&(l[n]=g(L[n],$,v));return v.delete(L),l}return L}function a(L,$,v=!0){return(0,i.$0f)(L)?((0,i.$0f)($)&&Object.keys($).forEach(p=>{p in L?v&&((0,i.$0f)(L[p])&&(0,i.$0f)($[p])?a(L[p],$[p],v):L[p]=$[p]):L[p]=$[p]}),L):$}function u(L,$){if(L===$)return!0;if(L==null||$===null||$===void 0||typeof L!=typeof $||typeof L!="object"||Array.isArray(L)!==Array.isArray($))return!1;let v,p;if(Array.isArray(L)){if(L.length!==$.length)return!1;for(v=0;v<L.length;v++)if(!u(L[v],$[v]))return!1}else{const l=[];for(p in L)l.push(p);l.sort();const n=[];for(p in $)n.push(p);if(n.sort(),!u(l,n))return!1;for(v=0;v<l.length;v++)if(!u(L[l[v]],$[l[v]]))return!1}return!0}function c(L){const $=new Set;return JSON.stringify(L,(v,p)=>{if((0,i.$0f)(p)||Array.isArray(p)){if($.has(p))return"[Circular]";$.add(p)}return typeof p=="bigint"?`[BigInt ${p.toString()}]`:p})}function w(L,$){const v=Object.create(null);return!L||!$||Object.keys($).forEach(l=>{const n=L[l],s=$[l];u(n,s)||(v[l]=s)}),v}function d(L,$){const v=$.toLowerCase(),p=Object.keys(L).find(l=>l.toLowerCase()===v);return p?L[p]:L[$]}function m(L,$){const v=Object.create(null);for(const[p,l]of Object.entries(L))$(p,l)&&(v[p]=l);return v}function e(L){let $=[];for(;Object.prototype!==L;)$=$.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return $}function P(L){const $=[];for(const v of e(L))typeof L[v]=="function"&&$.push(v);return $}function j(L,$){const v=l=>function(){const n=Array.prototype.slice.call(arguments,0);return $(l,n)},p={};for(const l of L)p[l]=v(l);return p}}),ie(se[28],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$5e=y,t.$6e=R;var i;(function(h){h[h.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",h[h.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",h[h.MAX_UINT_8=255]="MAX_UINT_8",h[h.MAX_UINT_16=65535]="MAX_UINT_16",h[h.MAX_UINT_32=4294967295]="MAX_UINT_32",h[h.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function y(h){return h<0?0:h>255?255:h|0}function R(h){return h<0?0:h>4294967295?4294967295:h|0}}),ie(se[29],ue([0,1,28]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$It=t.$Ht=void 0;class y{constructor(g){const a=(0,i.$5e)(g);this.c=a,this.a=y.d(a),this.b=new Map}static d(g){const a=new Uint8Array(256);return a.fill(g),a}set(g,a){const u=(0,i.$5e)(a);g>=0&&g<256?this.a[g]=u:this.b.set(g,u)}get(g){return g>=0&&g<256?this.a[g]:this.b.get(g)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$Ht=y;var R;(function(N){N[N.False=0]="False",N[N.True=1]="True"})(R||(R={}));class h{constructor(){this.a=new y(0)}add(g){this.a.set(g,1)}has(g){return this.a.get(g)===1}clear(){return this.a.clear()}}t.$It=h}),ie(se[4],ue([0,1,3]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bt=t.$At=void 0;class y{static addRange(N,g){let a=0;for(;a<g.length&&g[a].endExclusive<N.start;)a++;let u=a;for(;u<g.length&&g[u].start<=N.endExclusive;)u++;if(a===u)g.splice(a,0,N);else{const c=Math.min(N.start,g[a].start),w=Math.max(N.endExclusive,g[u-1].endExclusive);g.splice(a,u-a,new y(c,w))}}static tryCreate(N,g){if(!(N>g))return new y(N,g)}static ofLength(N){return new y(0,N)}static ofStartAndLength(N,g){return new y(N,N+g)}constructor(N,g){if(this.start=N,this.endExclusive=g,N>g)throw new i.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(N){return new y(this.start+N,this.endExclusive+N)}deltaStart(N){return new y(this.start+N,this.endExclusive)}deltaEnd(N){return new y(this.start,this.endExclusive+N)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(N){return this.start===N.start&&this.endExclusive===N.endExclusive}containsRange(N){return this.start<=N.start&&N.endExclusive<=this.endExclusive}contains(N){return this.start<=N&&N<this.endExclusive}join(N){return new y(Math.min(this.start,N.start),Math.max(this.endExclusive,N.endExclusive))}intersect(N){const g=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);if(g<=a)return new y(g,a)}intersects(N){const g=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);return g<a}intersectsOrTouches(N){const g=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);return g<=a}isBefore(N){return this.endExclusive<=N.start}isAfter(N){return this.start>=N.endExclusive}slice(N){return N.slice(this.start,this.endExclusive)}substring(N){return N.substring(this.start,this.endExclusive)}clip(N){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,N))}clipCyclic(N){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return N<this.start?this.endExclusive-(this.start-N)%this.length:N>=this.endExclusive?this.start+(N-this.start)%this.length:N}map(N){const g=[];for(let a=this.start;a<this.endExclusive;a++)g.push(N(a));return g}forEach(N){for(let g=this.start;g<this.endExclusive;g++)N(g)}}t.$At=y;class R{constructor(){this.a=[]}addRange(N){let g=0;for(;g<this.a.length&&this.a[g].endExclusive<N.start;)g++;let a=g;for(;a<this.a.length&&this.a[a].start<=N.endExclusive;)a++;if(g===a)this.a.splice(g,0,N);else{const u=Math.min(N.start,this.a[g].start),c=Math.max(N.endExclusive,this.a[a-1].endExclusive);this.a.splice(g,a-g,new y(u,c))}}toString(){return this.a.map(N=>N.toString()).join(", ")}intersectsStrict(N){let g=0;for(;g<this.a.length&&this.a[g].endExclusive<=N.start;)g++;return g<this.a.length&&this.a[g].start<N.endExclusive}intersectWithRange(N){const g=new R;for(const a of this.a){const u=a.intersect(N);u&&g.addRange(u)}return g}intersectWithRangeLength(N){return this.intersectWithRange(N).length}get length(){return this.a.reduce((N,g)=>N+g.length,0)}}t.$Bt=R}),ie(se[5],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$st=void 0;class i{constructor(R,h){this.lineNumber=R,this.column=h}with(R=this.lineNumber,h=this.column){return R===this.lineNumber&&h===this.column?this:new i(R,h)}delta(R=0,h=0){return this.with(this.lineNumber+R,this.column+h)}equals(R){return i.equals(this,R)}static equals(R,h){return!R&&!h?!0:!!R&&!!h&&R.lineNumber===h.lineNumber&&R.column===h.column}isBefore(R){return i.isBefore(this,R)}static isBefore(R,h){return R.lineNumber<h.lineNumber?!0:h.lineNumber<R.lineNumber?!1:R.column<h.column}isBeforeOrEqual(R){return i.isBeforeOrEqual(this,R)}static isBeforeOrEqual(R,h){return R.lineNumber<h.lineNumber?!0:h.lineNumber<R.lineNumber?!1:R.column<=h.column}static compare(R,h){const N=R.lineNumber|0,g=h.lineNumber|0;if(N===g){const a=R.column|0,u=h.column|0;return a-u}return N-g}clone(){return new i(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(R){return new i(R.lineNumber,R.column)}static isIPosition(R){return R&&typeof R.lineNumber=="number"&&typeof R.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$st=i}),ie(se[2],ue([0,1,5]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tt=void 0;class y{constructor(h,N,g,a){h>g||h===g&&N>a?(this.startLineNumber=g,this.startColumn=a,this.endLineNumber=h,this.endColumn=N):(this.startLineNumber=h,this.startColumn=N,this.endLineNumber=g,this.endColumn=a)}isEmpty(){return y.isEmpty(this)}static isEmpty(h){return h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn}containsPosition(h){return y.containsPosition(this,h)}static containsPosition(h,N){return!(N.lineNumber<h.startLineNumber||N.lineNumber>h.endLineNumber||N.lineNumber===h.startLineNumber&&N.column<h.startColumn||N.lineNumber===h.endLineNumber&&N.column>h.endColumn)}static strictContainsPosition(h,N){return!(N.lineNumber<h.startLineNumber||N.lineNumber>h.endLineNumber||N.lineNumber===h.startLineNumber&&N.column<=h.startColumn||N.lineNumber===h.endLineNumber&&N.column>=h.endColumn)}containsRange(h){return y.containsRange(this,h)}static containsRange(h,N){return!(N.startLineNumber<h.startLineNumber||N.endLineNumber<h.startLineNumber||N.startLineNumber>h.endLineNumber||N.endLineNumber>h.endLineNumber||N.startLineNumber===h.startLineNumber&&N.startColumn<h.startColumn||N.endLineNumber===h.endLineNumber&&N.endColumn>h.endColumn)}strictContainsRange(h){return y.strictContainsRange(this,h)}static strictContainsRange(h,N){return!(N.startLineNumber<h.startLineNumber||N.endLineNumber<h.startLineNumber||N.startLineNumber>h.endLineNumber||N.endLineNumber>h.endLineNumber||N.startLineNumber===h.startLineNumber&&N.startColumn<=h.startColumn||N.endLineNumber===h.endLineNumber&&N.endColumn>=h.endColumn)}plusRange(h){return y.plusRange(this,h)}static plusRange(h,N){let g,a,u,c;return N.startLineNumber<h.startLineNumber?(g=N.startLineNumber,a=N.startColumn):N.startLineNumber===h.startLineNumber?(g=N.startLineNumber,a=Math.min(N.startColumn,h.startColumn)):(g=h.startLineNumber,a=h.startColumn),N.endLineNumber>h.endLineNumber?(u=N.endLineNumber,c=N.endColumn):N.endLineNumber===h.endLineNumber?(u=N.endLineNumber,c=Math.max(N.endColumn,h.endColumn)):(u=h.endLineNumber,c=h.endColumn),new y(g,a,u,c)}intersectRanges(h){return y.intersectRanges(this,h)}static intersectRanges(h,N){let g=h.startLineNumber,a=h.startColumn,u=h.endLineNumber,c=h.endColumn;const w=N.startLineNumber,d=N.startColumn,m=N.endLineNumber,e=N.endColumn;return g<w?(g=w,a=d):g===w&&(a=Math.max(a,d)),u>m?(u=m,c=e):u===m&&(c=Math.min(c,e)),g>u||g===u&&a>c?null:new y(g,a,u,c)}equalsRange(h){return y.equalsRange(this,h)}static equalsRange(h,N){return!h&&!N?!0:!!h&&!!N&&h.startLineNumber===N.startLineNumber&&h.startColumn===N.startColumn&&h.endLineNumber===N.endLineNumber&&h.endColumn===N.endColumn}getEndPosition(){return y.getEndPosition(this)}static getEndPosition(h){return new i.$st(h.endLineNumber,h.endColumn)}getStartPosition(){return y.getStartPosition(this)}static getStartPosition(h){return new i.$st(h.startLineNumber,h.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(h,N){return new y(this.startLineNumber,this.startColumn,h,N)}setStartPosition(h,N){return new y(h,N,this.endLineNumber,this.endColumn)}collapseToStart(){return y.collapseToStart(this)}static collapseToStart(h){return new y(h.startLineNumber,h.startColumn,h.startLineNumber,h.startColumn)}collapseToEnd(){return y.collapseToEnd(this)}static collapseToEnd(h){return new y(h.endLineNumber,h.endColumn,h.endLineNumber,h.endColumn)}delta(h){return new y(this.startLineNumber+h,this.startColumn,this.endLineNumber+h,this.endColumn)}static fromPositions(h,N=h){return new y(h.lineNumber,h.column,N.lineNumber,N.column)}static lift(h){return h?new y(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):null}static isIRange(h){return h&&typeof h.startLineNumber=="number"&&typeof h.startColumn=="number"&&typeof h.endLineNumber=="number"&&typeof h.endColumn=="number"}static areIntersectingOrTouching(h,N){return!(h.endLineNumber<N.startLineNumber||h.endLineNumber===N.startLineNumber&&h.endColumn<N.startColumn||N.endLineNumber<h.startLineNumber||N.endLineNumber===h.startLineNumber&&N.endColumn<h.startColumn)}static areIntersecting(h,N){return!(h.endLineNumber<N.startLineNumber||h.endLineNumber===N.startLineNumber&&h.endColumn<=N.startColumn||N.endLineNumber<h.startLineNumber||N.endLineNumber===h.startLineNumber&&N.endColumn<=h.startColumn)}static compareRangesUsingStarts(h,N){if(h&&N){const u=h.startLineNumber|0,c=N.startLineNumber|0;if(u===c){const w=h.startColumn|0,d=N.startColumn|0;if(w===d){const m=h.endLineNumber|0,e=N.endLineNumber|0;if(m===e){const P=h.endColumn|0,j=N.endColumn|0;return P-j}return m-e}return w-d}return u-c}return(h?1:0)-(N?1:0)}static compareRangesUsingEnds(h,N){return h.endLineNumber===N.endLineNumber?h.endColumn===N.endColumn?h.startLineNumber===N.startLineNumber?h.startColumn-N.startColumn:h.startLineNumber-N.startLineNumber:h.endColumn-N.endColumn:h.endLineNumber-N.endLineNumber}static spansMultipleLines(h){return h.endLineNumber>h.startLineNumber}toJSON(){return this}}t.$tt=y}),ie(se[44],ue([0,1,2]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ut=void 0;class y{static insert(h,N){return{range:new i.$tt(h.lineNumber,h.column,h.lineNumber,h.column),text:N,forceMoveMarkers:!0}}static delete(h){return{range:h,text:null}}static replace(h,N){return{range:h,text:N}}static replaceMove(h,N){return{range:h,text:N,forceMoveMarkers:!0}}}t.$ut=y}),ie(se[12],ue([0,1,3,4,2,9]),function(O,t,i,y,R,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lv=t.$Kv=void 0;class N{static fromRange(u){return new N(u.startLineNumber,u.endLineNumber)}static fromRangeInclusive(u){return new N(u.startLineNumber,u.endLineNumber+1)}static subtract(u,c){return c?u.startLineNumber<c.startLineNumber&&c.endLineNumberExclusive<u.endLineNumberExclusive?[new N(u.startLineNumber,c.startLineNumber),new N(c.endLineNumberExclusive,u.endLineNumberExclusive)]:c.startLineNumber<=u.startLineNumber&&u.endLineNumberExclusive<=c.endLineNumberExclusive?[]:c.endLineNumberExclusive<u.endLineNumberExclusive?[new N(Math.max(c.endLineNumberExclusive,u.startLineNumber),u.endLineNumberExclusive)]:[new N(u.startLineNumber,Math.min(c.startLineNumber,u.endLineNumberExclusive))]:[u]}static joinMany(u){if(u.length===0)return[];let c=new g(u[0].slice());for(let w=1;w<u.length;w++)c=c.getUnion(new g(u[w].slice()));return c.ranges}static join(u){if(u.length===0)throw new i.$cb("lineRanges cannot be empty");let c=u[0].startLineNumber,w=u[0].endLineNumberExclusive;for(let d=1;d<u.length;d++)c=Math.min(c,u[d].startLineNumber),w=Math.max(w,u[d].endLineNumberExclusive);return new N(c,w)}static ofLength(u,c){return new N(u,u+c)}static deserialize(u){return new N(u[0],u[1])}static invert(u,c){if(u.isEmpty)return[];const w=[];return u.startLineNumber>1&&w.push(new N(1,u.startLineNumber)),u.endLineNumberExclusive<c.getLineCount()+1&&w.push(new N(u.endLineNumberExclusive,c.getLineCount()+1)),w.filter(d=>!d.isEmpty)}static asRange(u,c){return u.isEmpty?new R.$tt(u.startLineNumber,1,u.startLineNumber,c.getLineLength(u.startLineNumber)):new R.$tt(u.startLineNumber,1,u.endLineNumberExclusive-1,c.getLineLength(u.endLineNumberExclusive-1))}constructor(u,c){if(u>c)throw new i.$cb(`startLineNumber ${u} cannot be after endLineNumberExclusive ${c}`);this.startLineNumber=u,this.endLineNumberExclusive=c}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new N(this.startLineNumber+u,this.endLineNumberExclusive+u)}deltaLength(u){return new N(this.startLineNumber,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new N(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const c=Math.max(this.startLineNumber,u.startLineNumber),w=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(c<=w)return new N(c,w)}intersectsStrict(u){return this.startLineNumber<u.endLineNumberExclusive&&u.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new R.$tt(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new R.$tt(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(u){const c=[];for(let w=this.startLineNumber;w<this.endLineNumberExclusive;w++)c.push(u(w));return c}forEach(u){for(let c=this.startLineNumber;c<this.endLineNumberExclusive;c++)u(c)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}toOffsetRange(){return new y.$At(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$Kv=N;class g{constructor(u=[]){this.c=u}get ranges(){return this.c}addRange(u){if(u.length===0)return;const c=(0,h.$kb)(this.c,d=>d.endLineNumberExclusive>=u.startLineNumber),w=(0,h.$ib)(this.c,d=>d.startLineNumber<=u.endLineNumberExclusive)+1;if(c===w)this.c.splice(c,0,u);else if(c===w-1){const d=this.c[c];this.c[c]=d.join(u)}else{const d=this.c[c].join(this.c[w-1]).join(u);this.c.splice(c,w-c,d)}}contains(u){const c=(0,h.$hb)(this.c,w=>w.startLineNumber<=u);return!!c&&c.endLineNumberExclusive>u}intersects(u){const c=(0,h.$hb)(this.c,w=>w.startLineNumber<u.endLineNumberExclusive);return!!c&&c.endLineNumberExclusive>u.startLineNumber}getUnion(u){if(this.c.length===0)return u;if(u.c.length===0)return this;const c=[];let w=0,d=0,m=null;for(;w<this.c.length||d<u.c.length;){let e=null;if(w<this.c.length&&d<u.c.length){const P=this.c[w],j=u.c[d];P.startLineNumber<j.startLineNumber?(e=P,w++):(e=j,d++)}else w<this.c.length?(e=this.c[w],w++):(e=u.c[d],d++);m===null?m=e:m.endLineNumberExclusive>=e.startLineNumber?m=new N(m.startLineNumber,Math.max(m.endLineNumberExclusive,e.endLineNumberExclusive)):(c.push(m),m=e)}return m!==null&&c.push(m),new g(c)}subtractFrom(u){const c=(0,h.$kb)(this.c,e=>e.endLineNumberExclusive>=u.startLineNumber),w=(0,h.$ib)(this.c,e=>e.startLineNumber<=u.endLineNumberExclusive)+1;if(c===w)return new g([u]);const d=[];let m=u.startLineNumber;for(let e=c;e<w;e++){const P=this.c[e];P.startLineNumber>m&&d.push(new N(m,P.startLineNumber)),m=P.endLineNumberExclusive}return m<u.endLineNumberExclusive&&d.push(new N(m,u.endLineNumberExclusive)),new g(d)}toString(){return this.c.map(u=>u.toString()).join(", ")}getIntersection(u){const c=[];let w=0,d=0;for(;w<this.c.length&&d<u.c.length;){const m=this.c[w],e=u.c[d],P=m.intersect(e);P&&!P.isEmpty&&c.push(P),m.endLineNumberExclusive<e.endLineNumberExclusive?w++:d++}return new g(c)}getWithDelta(u){return new g(this.c.map(c=>c.delta(u)))}}t.$Lv=g}),ie(se[45],ue([0,1,5,2]),function(O,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vt=t.SelectionDirection=void 0;var R;(function(N){N[N.LTR=0]="LTR",N[N.RTL=1]="RTL"})(R||(t.SelectionDirection=R={}));class h extends y.$tt{constructor(g,a,u,c){super(g,a,u,c),this.selectionStartLineNumber=g,this.selectionStartColumn=a,this.positionLineNumber=u,this.positionColumn=c}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(g){return h.selectionsEqual(this,g)}static selectionsEqual(g,a){return g.selectionStartLineNumber===a.selectionStartLineNumber&&g.selectionStartColumn===a.selectionStartColumn&&g.positionLineNumber===a.positionLineNumber&&g.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(g,a){return this.getDirection()===0?new h(this.startLineNumber,this.startColumn,g,a):new h(g,a,this.startLineNumber,this.startColumn)}getPosition(){return new i.$st(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new i.$st(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(g,a){return this.getDirection()===0?new h(g,a,this.endLineNumber,this.endColumn):new h(this.endLineNumber,this.endColumn,g,a)}static fromPositions(g,a=g){return new h(g.lineNumber,g.column,a.lineNumber,a.column)}static fromRange(g,a){return a===0?new h(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):new h(g.endLineNumber,g.endColumn,g.startLineNumber,g.startColumn)}static liftSelection(g){return new h(g.selectionStartLineNumber,g.selectionStartColumn,g.positionLineNumber,g.positionColumn)}static selectionsArrEqual(g,a){if(g&&!a||!g&&a)return!1;if(!g&&!a)return!0;if(g.length!==a.length)return!1;for(let u=0,c=g.length;u<c;u++)if(!this.selectionsEqual(g[u],a[u]))return!1;return!0}static isISelection(g){return g&&typeof g.selectionStartLineNumber=="number"&&typeof g.selectionStartColumn=="number"&&typeof g.positionLineNumber=="number"&&typeof g.positionColumn=="number"}static createWithDirection(g,a,u,c,w){return w===0?new h(g,a,u,c):new h(u,c,g,a)}}t.$vt=h}),ie(se[46],ue([0,1,14,29]),function(O,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jt=t.WordCharacterClass=void 0,t.$Kt=g;var R;(function(a){a[a.Regular=0]="Regular",a[a.Whitespace=1]="Whitespace",a[a.WordSeparator=2]="WordSeparator"})(R||(t.WordCharacterClass=R={}));class h extends y.$Ht{constructor(u,c){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=c,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let w=0,d=u.length;w<d;w++)this.set(u.charCodeAt(w),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(u,c){let w=null;for(const d of this.h(u)){if(d.index>c)break;w=d}return w}findNextIntlWordAtOrAfterOffset(u,c){for(const w of this.h(u))if(!(w.index<c))return w;return null}h(u){return this.e?this.f===u?this.g:(this.f=u,this.g=this.j(this.e.segment(u)),this.g):[]}j(u){const c=[];for(const w of u)this.k(w)&&c.push(w);return c}k(u){return!!u.isWordLike}}t.$Jt=h;const N=new i.$Ec(10);function g(a,u){const c=`${a}/${u.join(",")}`;let w=N.get(c);return w||(w=new h(a,u),N.set(c,w)),w}}),ie(se[30],ue([0,1,21,10,22]),function(O,t,i,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5s=t.$4s=void 0,t.$6s=N,t.$7s=a,t.$8s=u,t.$4s="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function h(w=""){let d="(-?\\d*\\.\\d\\w*)|([^";for(const m of t.$4s)w.indexOf(m)>=0||(d+="\\"+m);return d+="\\s]+)",new RegExp(d,"g")}t.$5s=h();function N(w){let d=t.$5s;if(w&&w instanceof RegExp)if(w.global)d=w;else{let m="g";w.ignoreCase&&(m+="i"),w.multiline&&(m+="m"),w.unicode&&(m+="u"),d=new RegExp(w.source,m)}return d.lastIndex=0,d}const g=new R.$6c;g.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(w){const d=g.unshift(w);return(0,y.$Tc)(d)}function u(w,d,m,e,P){if(d=N(d),P||(P=i.Iterable.first(g)),m.length>P.maxLen){let p=w-P.maxLen/2;return p<0?p=0:e+=p,m=m.substring(p,w+P.maxLen/2),u(w,d,m,e,P)}const j=Date.now(),L=w-1-e;let $=-1,v=null;for(let p=1;!(Date.now()-j>=P.timeBudget);p++){const l=L-P.windowSize*p;d.lastIndex=Math.max(0,l);const n=c(d,m,L,$);if(!n&&v||(v=n,l<=0))break;$=l}if(v){const p={word:v[0],startColumn:e+1+v.index,endColumn:e+1+v.index+v[0].length};return d.lastIndex=0,p}return null}function c(w,d,m,e){let P;for(;P=w.exec(d);){const j=P.index||0;if(j<=m&&w.lastIndex>=m)return P;if(e>0&&j>e)return null}return null}}),ie(se[8],ue([0,1,6,3,4]),function(O,t,i,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$s3=t.$r3=t.$q3=t.$p3=t.$o3=void 0;class h{static trivial(w,d){return new h([new N(R.$At.ofLength(w.length),R.$At.ofLength(d.length))],!1)}static trivialTimedOut(w,d){return new h([new N(R.$At.ofLength(w.length),R.$At.ofLength(d.length))],!0)}constructor(w,d){this.diffs=w,this.hitTimeout=d}}t.$o3=h;class N{static invert(w,d){const m=[];return(0,i.$Bb)(w,(e,P)=>{m.push(N.fromOffsetPairs(e?e.getEndExclusives():g.zero,P?P.getStarts():new g(d,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+d)))}),m}static fromOffsetPairs(w,d){return new N(new R.$At(w.offset1,d.offset1),new R.$At(w.offset2,d.offset2))}constructor(w,d){this.seq1Range=w,this.seq2Range=d}swap(){return new N(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(w){return new N(this.seq1Range.join(w.seq1Range),this.seq2Range.join(w.seq2Range))}delta(w){return w===0?this:new N(this.seq1Range.delta(w),this.seq2Range.delta(w))}deltaStart(w){return w===0?this:new N(this.seq1Range.deltaStart(w),this.seq2Range.deltaStart(w))}deltaEnd(w){return w===0?this:new N(this.seq1Range.deltaEnd(w),this.seq2Range.deltaEnd(w))}intersectsOrTouches(w){return this.seq1Range.intersectsOrTouches(w.seq1Range)||this.seq2Range.intersectsOrTouches(w.seq2Range)}intersect(w){const d=this.seq1Range.intersect(w.seq1Range),m=this.seq2Range.intersect(w.seq2Range);if(!(!d||!m))return new N(d,m)}getStarts(){return new g(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new g(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$p3=N;class g{static{this.zero=new g(0,0)}static{this.max=new g(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(w,d){this.offset1=w,this.offset2=d}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(w){return w===0?this:new g(this.offset1+w,this.offset2+w)}equals(w){return this.offset1===w.offset1&&this.offset2===w.offset2}}t.$q3=g;class a{static{this.instance=new a}isValid(){return!0}}t.$r3=a;class u{constructor(w){if(this.e=w,this.c=Date.now(),this.d=!0,w<=0)throw new y.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$s3=u}),ie(se[31],ue([0,1,4,8]),function(O,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$x3=void 0;class R{compute(u,c,w=y.$r3.instance){if(u.length===0||c.length===0)return y.$o3.trivial(u,c);const d=u,m=c;function e(s,f){for(;s<d.length&&f<m.length&&d.getElement(s)===m.getElement(f);)s++,f++;return s}let P=0;const j=new N;j.set(0,e(0,0));const L=new g;L.set(0,j.get(0)===0?null:new h(null,0,0,j.get(0)));let $=0;e:for(;;){if(P++,!w.isValid())return y.$o3.trivialTimedOut(d,m);const s=-Math.min(P,m.length+P%2),f=Math.min(P,d.length+P%2);for($=s;$<=f;$+=2){let o=0;const b=$===f?-1:j.get($+1),A=$===s?-1:j.get($-1)+1;o++;const E=Math.min(Math.max(b,A),d.length),M=E-$;if(o++,E>d.length||M>m.length)continue;const k=e(E,M);j.set($,k);const S=E===b?L.get($+1):L.get($-1);if(L.set($,k!==E?new h(S,E,M,k-E):S),j.get($)===d.length&&j.get($)-$===m.length)break e}}let v=L.get($);const p=[];let l=d.length,n=m.length;for(;;){const s=v?v.x+v.length:0,f=v?v.y+v.length:0;if((s!==l||f!==n)&&p.push(new y.$p3(new i.$At(s,l),new i.$At(f,n))),!v)break;l=v.x,n=v.y,v=v.prev}return p.reverse(),new y.$o3(p,!1)}}t.$x3=R;class h{constructor(u,c,w,d){this.prev=u,this.x=c,this.y=w,this.length=d}}class N{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,c){if(u<0){if(u=-u-1,u>=this.b.length){const w=this.b;this.b=new Int32Array(w.length*2),this.b.set(w)}this.b[u]=c}else{if(u>=this.a.length){const w=this.a;this.a=new Int32Array(w.length*2),this.a.set(w)}this.a[u]=c}}}class g{constructor(){this.a=[],this.b=[]}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,c){u<0?(u=-u-1,this.b[u]=c):this.a[u]=c}}}),ie(se[47],ue([0,1,6,4,8]),function(O,t,i,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$B3=h,t.$C3=u,t.$D3=c,t.$E3=d,t.$F3=m;function h(e,P,j){let L=j;return L=N(e,P,L),L=N(e,P,L),L=g(e,P,L),L}function N(e,P,j){if(j.length===0)return j;const L=[];L.push(j[0]);for(let v=1;v<j.length;v++){const p=L[L.length-1];let l=j[v];if(l.seq1Range.isEmpty||l.seq2Range.isEmpty){const n=l.seq1Range.start-p.seq1Range.endExclusive;let s;for(s=1;s<=n&&!(e.getElement(l.seq1Range.start-s)!==e.getElement(l.seq1Range.endExclusive-s)||P.getElement(l.seq2Range.start-s)!==P.getElement(l.seq2Range.endExclusive-s));s++);if(s--,s===n){L[L.length-1]=new R.$p3(new y.$At(p.seq1Range.start,l.seq1Range.endExclusive-n),new y.$At(p.seq2Range.start,l.seq2Range.endExclusive-n));continue}l=l.delta(-s)}L.push(l)}const $=[];for(let v=0;v<L.length-1;v++){const p=L[v+1];let l=L[v];if(l.seq1Range.isEmpty||l.seq2Range.isEmpty){const n=p.seq1Range.start-l.seq1Range.endExclusive;let s;for(s=0;s<n&&!(!e.isStronglyEqual(l.seq1Range.start+s,l.seq1Range.endExclusive+s)||!P.isStronglyEqual(l.seq2Range.start+s,l.seq2Range.endExclusive+s));s++);if(s===n){L[v+1]=new R.$p3(new y.$At(l.seq1Range.start+n,p.seq1Range.endExclusive),new y.$At(l.seq2Range.start+n,p.seq2Range.endExclusive));continue}s>0&&(l=l.delta(s))}$.push(l)}return L.length>0&&$.push(L[L.length-1]),$}function g(e,P,j){if(!e.getBoundaryScore||!P.getBoundaryScore)return j;for(let L=0;L<j.length;L++){const $=L>0?j[L-1]:void 0,v=j[L],p=L+1<j.length?j[L+1]:void 0,l=new y.$At($?$.seq1Range.endExclusive+1:0,p?p.seq1Range.start-1:e.length),n=new y.$At($?$.seq2Range.endExclusive+1:0,p?p.seq2Range.start-1:P.length);v.seq1Range.isEmpty?j[L]=a(v,e,P,l,n):v.seq2Range.isEmpty&&(j[L]=a(v.swap(),P,e,n,l).swap())}return j}function a(e,P,j,L,$){let p=1;for(;e.seq1Range.start-p>=L.start&&e.seq2Range.start-p>=$.start&&j.isStronglyEqual(e.seq2Range.start-p,e.seq2Range.endExclusive-p)&&p<100;)p++;p--;let l=0;for(;e.seq1Range.start+l<L.endExclusive&&e.seq2Range.endExclusive+l<$.endExclusive&&j.isStronglyEqual(e.seq2Range.start+l,e.seq2Range.endExclusive+l)&&l<100;)l++;if(p===0&&l===0)return e;let n=0,s=-1;for(let f=-p;f<=l;f++){const o=e.seq2Range.start+f,b=e.seq2Range.endExclusive+f,A=e.seq1Range.start+f,E=P.getBoundaryScore(A)+j.getBoundaryScore(o)+j.getBoundaryScore(b);E>s&&(s=E,n=f)}return e.delta(n)}function u(e,P,j){const L=[];for(const $ of j){const v=L[L.length-1];if(!v){L.push($);continue}$.seq1Range.start-v.seq1Range.endExclusive<=2||$.seq2Range.start-v.seq2Range.endExclusive<=2?L[L.length-1]=new R.$p3(v.seq1Range.join($.seq1Range),v.seq2Range.join($.seq2Range)):L.push($)}return L}function c(e,P,j){const L=R.$p3.invert(j,e.length),$=[];let v=new R.$q3(0,0);function p(n,s){if(n.offset1<v.offset1||n.offset2<v.offset2)return;const f=e.findWordContaining(n.offset1),o=P.findWordContaining(n.offset2);if(!f||!o)return;let b=new R.$p3(f,o);const A=b.intersect(s);let E=A.seq1Range.length,M=A.seq2Range.length;for(;L.length>0;){const k=L[0];if(!(k.seq1Range.intersects(b.seq1Range)||k.seq2Range.intersects(b.seq2Range)))break;const x=e.findWordContaining(k.seq1Range.start),D=P.findWordContaining(k.seq2Range.start),q=new R.$p3(x,D),I=q.intersect(k);if(E+=I.seq1Range.length,M+=I.seq2Range.length,b=b.join(q),b.seq1Range.endExclusive>=k.seq1Range.endExclusive)L.shift();else break}E+M<(b.seq1Range.length+b.seq2Range.length)*2/3&&$.push(b),v=b.getEndExclusives()}for(;L.length>0;){const n=L.shift();n.seq1Range.isEmpty||(p(n.getStarts(),n),p(n.getEndExclusives().delta(-1),n))}return w(j,$)}function w(e,P){const j=[];for(;e.length>0||P.length>0;){const L=e[0],$=P[0];let v;L&&(!$||L.seq1Range.start<$.seq1Range.start)?v=e.shift():v=P.shift(),j.length>0&&j[j.length-1].seq1Range.endExclusive>=v.seq1Range.start?j[j.length-1]=j[j.length-1].join(v):j.push(v)}return j}function d(e,P,j){let L=j;if(L.length===0)return L;let $=0,v;do{v=!1;const p=[L[0]];for(let l=1;l<L.length;l++){let f=function(b,A){const E=new y.$At(s.seq1Range.endExclusive,n.seq1Range.start);return e.getText(E).replace(/\s/g,"").length<=4&&(b.seq1Range.length+b.seq2Range.length>5||A.seq1Range.length+A.seq2Range.length>5)};const n=L[l],s=p[p.length-1];f(s,n)?(v=!0,p[p.length-1]=p[p.length-1].join(n)):p.push(n)}L=p}while($++<10&&v);return L}function m(e,P,j){let L=j;if(L.length===0)return L;let $=0,v;do{v=!1;const l=[L[0]];for(let n=1;n<L.length;n++){let o=function(A,E){const M=new y.$At(f.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(M)>5||M.length>500)return!1;const S=e.getText(M).trim();if(S.length>20||S.split(/\r\n|\r|\n/).length>1)return!1;const x=e.countLinesIn(A.seq1Range),D=A.seq1Range.length,q=P.countLinesIn(A.seq2Range),I=A.seq2Range.length,z=e.countLinesIn(E.seq1Range),Z=E.seq1Range.length,Q=P.countLinesIn(E.seq2Range),J=E.seq2Range.length,X=2*40+50;function K(F){return Math.min(F,X)}return Math.pow(Math.pow(K(x*40+D),1.5)+Math.pow(K(q*40+I),1.5),1.5)+Math.pow(Math.pow(K(z*40+Z),1.5)+Math.pow(K(Q*40+J),1.5),1.5)>(X**1.5)**1.5*1.3};const s=L[n],f=l[l.length-1];o(f,s)?(v=!0,l[l.length-1]=l[l.length-1].join(s)):l.push(s)}L=l}while($++<10&&v);const p=[];return(0,i.$Cb)(L,(l,n,s)=>{let f=n;function o(S){return S.length>0&&S.trim().length<=3&&n.seq1Range.length+n.seq2Range.length>100}const b=e.extendToFullLines(n.seq1Range),A=e.getText(new y.$At(b.start,n.seq1Range.start));o(A)&&(f=f.deltaStart(-A.length));const E=e.getText(new y.$At(n.seq1Range.endExclusive,b.endExclusive));o(E)&&(f=f.deltaEnd(E.length));const M=R.$p3.fromOffsetPairs(l?l.getEndExclusives():R.$q3.zero,s?s.getStarts():R.$q3.max),k=f.intersect(M);p.length>0&&k.getStarts().equals(p[p.length-1].getEndExclusives())?p[p.length-1]=p[p.length-1].join(k):p.push(k)}),p}}),ie(se[48],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$A3=void 0;class i{constructor(h,N){this.a=h,this.b=N}getElement(h){return this.a[h]}get length(){return this.a.length}getBoundaryScore(h){const N=h===0?0:y(this.b[h-1]),g=h===this.b.length?0:y(this.b[h]);return 1e3-(N+g)}getText(h){return this.b.slice(h.start,h.endExclusive).join(`
`)}isStronglyEqual(h,N){return this.b[h]===this.b[N]}}t.$A3=i;function y(R){let h=0;for(;h<R.length&&(R.charCodeAt(h)===32||R.charCodeAt(h)===9);)h++;return h}}),ie(se[16],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$v3=t.$t3=void 0,t.$u3=y;class i{constructor(N,g){this.width=N,this.height=g,this.a=[],this.a=new Array(N*g)}get(N,g){return this.a[N+g*this.width]}set(N,g,a){this.a[N+g*this.width]=a}}t.$t3=i;function y(h){return h===32||h===9}class R{static{this.a=new Map}static b(N){let g=this.a.get(N);return g===void 0&&(g=this.a.size,this.a.set(N,g)),g}constructor(N,g,a){this.range=N,this.lines=g,this.source=a,this.d=[];let u=0;for(let c=N.startLineNumber-1;c<N.endLineNumberExclusive-1;c++){const w=g[c];for(let m=0;m<w.length;m++){u++;const e=w[m],P=R.b(e);this.d[P]=(this.d[P]||0)+1}u++;const d=R.b(`
`);this.d[d]=(this.d[d]||0)+1}this.c=u}computeSimilarity(N){let g=0;const a=Math.max(this.d.length,N.d.length);for(let u=0;u<a;u++)g+=Math.abs((this.d[u]??0)-(N.d[u]??0));return 1-g/(this.c+N.c)}}t.$v3=R}),ie(se[49],ue([0,1,4,8,16]),function(O,t,i,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$w3=void 0;class h{compute(g,a,u=y.$r3.instance,c){if(g.length===0||a.length===0)return y.$o3.trivial(g,a);const w=new R.$t3(g.length,a.length),d=new R.$t3(g.length,a.length),m=new R.$t3(g.length,a.length);for(let p=0;p<g.length;p++)for(let l=0;l<a.length;l++){if(!u.isValid())return y.$o3.trivialTimedOut(g,a);const n=p===0?0:w.get(p-1,l),s=l===0?0:w.get(p,l-1);let f;g.getElement(p)===a.getElement(l)?(p===0||l===0?f=0:f=w.get(p-1,l-1),p>0&&l>0&&d.get(p-1,l-1)===3&&(f+=m.get(p-1,l-1)),f+=c?c(p,l):1):f=-1;const o=Math.max(n,s,f);if(o===f){const b=p>0&&l>0?m.get(p-1,l-1):0;m.set(p,l,b+1),d.set(p,l,3)}else o===n?(m.set(p,l,0),d.set(p,l,1)):o===s&&(m.set(p,l,0),d.set(p,l,2));w.set(p,l,o)}const e=[];let P=g.length,j=a.length;function L(p,l){(p+1!==P||l+1!==j)&&e.push(new y.$p3(new i.$At(p+1,P),new i.$At(l+1,j))),P=p,j=l}let $=g.length-1,v=a.length-1;for(;$>=0&&v>=0;)d.get($,v)===3?(L($,v),$--,v--):d.get($,v)===1?$--:v--;return L(-1,-1),e.reverse(),new y.$o3(e,!1)}}t.$w3=h}),ie(se[32],ue([0,1,9,4,5,2,16]),function(O,t,i,y,R,h,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$y3=void 0;class g{constructor(e,P,j){this.lines=e,this.considerWhitespaceChanges=j,this.b=[],this.c=[],this.d=[];let L=!1;P.start>0&&P.endExclusive>=e.length&&(P=new y.$At(P.start-1,P.endExclusive),L=!0),this.lineRange=P,this.c[0]=0;for(let $=this.lineRange.start;$<this.lineRange.endExclusive;$++){let v=e[$],p=0;if(L)p=v.length,v="",L=!1;else if(!j){const l=v.trimStart();p=v.length-l.length,v=l.trimEnd()}this.d.push(p);for(let l=0;l<v.length;l++)this.b.push(v.charCodeAt(l));$<e.length-1&&(this.b.push(10),this.c[$-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new y.$At(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(P=>String.fromCharCode(P)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const P=d(e>0?this.b[e-1]:-1),j=d(e<this.b.length?this.b[e]:-1);if(P===7&&j===8)return 0;if(P===8)return 150;let L=0;return P!==j&&(L+=10,P===0&&j===1&&(L+=1)),L+=w(P),L+=w(j),L}translateOffset(e){if(this.lineRange.isEmpty)return new R.$st(this.lineRange.start+1,1);const P=(0,i.$ib)(this.c,j=>j<=e);return new R.$st(this.lineRange.start+P+1,e-this.c[P]+this.d[P]+1)}translateRange(e){return h.$tt.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!a(this.b[e]))return;let P=e;for(;P>0&&a(this.b[P-1]);)P--;let j=e;for(;j<this.b.length&&a(this.b[j]);)j++;return new y.$At(P,j)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,P){return this.b[e]===this.b[P]}extendToFullLines(e){const P=(0,i.$hb)(this.c,L=>L<=e.start)??0,j=(0,i.$jb)(this.c,L=>e.endExclusive<=L)??this.b.length;return new y.$At(P,j)}}t.$y3=g;function a(m){return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57}var u;(function(m){m[m.WordLower=0]="WordLower",m[m.WordUpper=1]="WordUpper",m[m.WordNumber=2]="WordNumber",m[m.End=3]="End",m[m.Other=4]="Other",m[m.Separator=5]="Separator",m[m.Space=6]="Space",m[m.LineBreakCR=7]="LineBreakCR",m[m.LineBreakLF=8]="LineBreakLF"})(u||(u={}));const c={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function w(m){return c[m]}function d(m){return m===10?8:m===13?7:(0,N.$u3)(m)?6:m>=97&&m<=122?0:m>=65&&m<=90?1:m>=48&&m<=57?2:m===-1?3:m===44||m===59?5:4}}),ie(se[33],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qv=t.$Pv=void 0;class i{constructor(h,N,g){this.changes=h,this.moves=N,this.hitTimeout=g}}t.$Pv=i;class y{constructor(h,N){this.lineRangeMapping=h,this.changes=N}flip(){return new y(this.lineRangeMapping.flip(),this.changes.map(h=>h.flip()))}}t.$Qv=y}),ie(se[17],ue([0,1,12]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ov=t.$Nv=t.$Mv=void 0;class y{static inverse(g,a,u){const c=[];let w=1,d=1;for(const e of g){const P=new y(new i.$Kv(w,e.original.startLineNumber),new i.$Kv(d,e.modified.startLineNumber));P.modified.isEmpty||c.push(P),w=e.original.endLineNumberExclusive,d=e.modified.endLineNumberExclusive}const m=new y(new i.$Kv(w,a+1),new i.$Kv(d,u+1));return m.modified.isEmpty||c.push(m),c}static clip(g,a,u){const c=[];for(const w of g){const d=w.original.intersect(a),m=w.modified.intersect(u);d&&!d.isEmpty&&m&&!m.isEmpty&&c.push(new y(d,m))}return c}constructor(g,a){this.original=g,this.modified=a}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new y(this.modified,this.original)}join(g){return new y(this.original.join(g.original),this.modified.join(g.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$Mv=y;class R extends y{static fromRangeMappings(g){const a=i.$Kv.join(g.map(c=>i.$Kv.fromRangeInclusive(c.originalRange))),u=i.$Kv.join(g.map(c=>i.$Kv.fromRangeInclusive(c.modifiedRange)));return new R(a,u,g)}constructor(g,a,u){super(g,a),this.innerChanges=u}flip(){return new R(this.modified,this.original,this.innerChanges?.map(g=>g.flip()))}withInnerChangesFromLineRanges(){return new R(this.original,this.modified,[new h(this.original.toExclusiveRange(),this.modified.toExclusiveRange())])}}t.$Nv=R;class h{constructor(g,a){this.originalRange=g,this.modifiedRange=a}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new h(this.modifiedRange,this.originalRange)}}t.$Ov=h}),ie(se[50],ue([0,1,8,17,6,9,14,12,4,32,16,31]),function(O,t,i,y,R,h,N,g,a,u,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$z3=d;function d(v,p,l,n,s,f){let{moves:o,excludedChanges:b}=e(v,p,l,f);if(!f.isValid())return[];const A=v.filter(M=>!b.has(M)),E=P(A,n,s,p,l,f);return(0,R.$1b)(o,E),o=L(o),o=o.filter(M=>{const k=M.original.toOffsetRange().slice(p).map(x=>x.trim());return k.join(`
`).length>=15&&m(k,x=>x.length>=2)>=2}),o=$(v,o),o}function m(v,p){let l=0;for(const n of v)p(n)&&l++;return l}function e(v,p,l,n){const s=[],f=v.filter(A=>A.modified.isEmpty&&A.original.length>=3).map(A=>new c.$v3(A.original,p,A)),o=new Set(v.filter(A=>A.original.isEmpty&&A.modified.length>=3).map(A=>new c.$v3(A.modified,l,A))),b=new Set;for(const A of f){let E=-1,M;for(const k of o){const S=A.computeSimilarity(k);S>E&&(E=S,M=k)}if(E>.9&&M&&(o.delete(M),s.push(new y.$Mv(A.range,M.range)),b.add(A.source),b.add(M.source)),!n.isValid())return{moves:s,excludedChanges:b}}return{moves:s,excludedChanges:b}}function P(v,p,l,n,s,f){const o=[],b=new N.$Ic;for(const S of v)for(let x=S.original.startLineNumber;x<S.original.endLineNumberExclusive-2;x++){const D=`${p[x-1]}:${p[x+1-1]}:${p[x+2-1]}`;b.add(D,{range:new g.$Kv(x,x+3)})}const A=[];v.sort((0,R.$7b)(S=>S.modified.startLineNumber,R.$9b));for(const S of v){let x=[];for(let D=S.modified.startLineNumber;D<S.modified.endLineNumberExclusive-2;D++){const q=`${l[D-1]}:${l[D+1-1]}:${l[D+2-1]}`,I=new g.$Kv(D,D+3),z=[];b.forEach(q,({range:Z})=>{for(const J of x)if(J.originalLineRange.endLineNumberExclusive+1===Z.endLineNumberExclusive&&J.modifiedLineRange.endLineNumberExclusive+1===I.endLineNumberExclusive){J.originalLineRange=new g.$Kv(J.originalLineRange.startLineNumber,Z.endLineNumberExclusive),J.modifiedLineRange=new g.$Kv(J.modifiedLineRange.startLineNumber,I.endLineNumberExclusive),z.push(J);return}const Q={modifiedLineRange:I,originalLineRange:Z};A.push(Q),z.push(Q)}),x=z}if(!f.isValid())return[]}A.sort((0,R.$$b)((0,R.$7b)(S=>S.modifiedLineRange.length,R.$9b)));const E=new g.$Lv,M=new g.$Lv;for(const S of A){const x=S.modifiedLineRange.startLineNumber-S.originalLineRange.startLineNumber,D=E.subtractFrom(S.modifiedLineRange),q=M.subtractFrom(S.originalLineRange).getWithDelta(x),I=D.getIntersection(q);for(const z of I.ranges){if(z.length<3)continue;const Z=z,Q=z.delta(-x);o.push(new y.$Mv(Q,Z)),E.addRange(Z),M.addRange(Q)}}o.sort((0,R.$7b)(S=>S.original.startLineNumber,R.$9b));const k=new h.$mb(v);for(let S=0;S<o.length;S++){const x=o[S],D=k.findLastMonotonous(K=>K.original.startLineNumber<=x.original.startLineNumber),q=(0,h.$hb)(v,K=>K.modified.startLineNumber<=x.modified.startLineNumber),I=Math.max(x.original.startLineNumber-D.original.startLineNumber,x.modified.startLineNumber-q.modified.startLineNumber),z=k.findLastMonotonous(K=>K.original.startLineNumber<x.original.endLineNumberExclusive),Z=(0,h.$hb)(v,K=>K.modified.startLineNumber<x.modified.endLineNumberExclusive),Q=Math.max(z.original.endLineNumberExclusive-x.original.endLineNumberExclusive,Z.modified.endLineNumberExclusive-x.modified.endLineNumberExclusive);let J;for(J=0;J<I;J++){const K=x.original.startLineNumber-J-1,F=x.modified.startLineNumber-J-1;if(K>n.length||F>s.length||E.contains(F)||M.contains(K)||!j(n[K-1],s[F-1],f))break}J>0&&(M.addRange(new g.$Kv(x.original.startLineNumber-J,x.original.startLineNumber)),E.addRange(new g.$Kv(x.modified.startLineNumber-J,x.modified.startLineNumber)));let X;for(X=0;X<Q;X++){const K=x.original.endLineNumberExclusive+X,F=x.modified.endLineNumberExclusive+X;if(K>n.length||F>s.length||E.contains(F)||M.contains(K)||!j(n[K-1],s[F-1],f))break}X>0&&(M.addRange(new g.$Kv(x.original.endLineNumberExclusive,x.original.endLineNumberExclusive+X)),E.addRange(new g.$Kv(x.modified.endLineNumberExclusive,x.modified.endLineNumberExclusive+X))),(J>0||X>0)&&(o[S]=new y.$Mv(new g.$Kv(x.original.startLineNumber-J,x.original.endLineNumberExclusive+X),new g.$Kv(x.modified.startLineNumber-J,x.modified.endLineNumberExclusive+X)))}return o}function j(v,p,l){if(v.trim()===p.trim())return!0;if(v.length>300&&p.length>300)return!1;const s=new w.$x3().compute(new u.$y3([v],new a.$At(0,1),!1),new u.$y3([p],new a.$At(0,1),!1),l);let f=0;const o=i.$p3.invert(s.diffs,v.length);for(const M of o)M.seq1Range.forEach(k=>{(0,c.$u3)(v.charCodeAt(k))||f++});function b(M){let k=0;for(let S=0;S<v.length;S++)(0,c.$u3)(M.charCodeAt(S))||k++;return k}const A=b(v.length>p.length?v:p);return f/A>.6&&A>10}function L(v){if(v.length===0)return v;v.sort((0,R.$7b)(l=>l.original.startLineNumber,R.$9b));const p=[v[0]];for(let l=1;l<v.length;l++){const n=p[p.length-1],s=v[l],f=s.original.startLineNumber-n.original.endLineNumberExclusive,o=s.modified.startLineNumber-n.modified.endLineNumberExclusive;if(f>=0&&o>=0&&f+o<=2){p[p.length-1]=n.join(s);continue}p.push(s)}return p}function $(v,p){const l=new h.$mb(v);return p=p.filter(n=>{const s=l.findLastMonotonous(b=>b.original.startLineNumber<n.original.endLineNumberExclusive)||new y.$Mv(new g.$Kv(1,1),new g.$Kv(1,1)),f=(0,h.$hb)(v,b=>b.modified.startLineNumber<n.modified.endLineNumberExclusive);return s!==f}),p}}),ie(se[51],ue([0,1,6,13,12,4,2,8,49,31,50,47,48,32,33,17]),function(O,t,i,y,R,h,N,g,a,u,c,w,d,m,e,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$G3=void 0,t.$H3=L,t.$I3=$;class j{constructor(){this.e=new a.$w3,this.f=new u.$x3}computeDiff(p,l,n){if(p.length<=1&&(0,i.$ub)(p,l,(X,K)=>X===K))return new e.$Pv([],[],!1);if(p.length===1&&p[0].length===0||l.length===1&&l[0].length===0)return new e.$Pv([new P.$Nv(new R.$Kv(1,p.length+1),new R.$Kv(1,l.length+1),[new P.$Ov(new N.$tt(1,1,p.length,p[0].length+1),new N.$tt(1,1,l.length,l[0].length+1))])],[],!1);const s=n.maxComputationTimeMs===0?g.$r3.instance:new g.$s3(n.maxComputationTimeMs),f=!n.ignoreTrimWhitespace,o=new Map;function b(X){let K=o.get(X);return K===void 0&&(K=o.size,o.set(X,K)),K}const A=p.map(X=>b(X.trim())),E=l.map(X=>b(X.trim())),M=new d.$A3(A,p),k=new d.$A3(E,l),S=M.length+k.length<1700?this.e.compute(M,k,s,(X,K)=>p[X]===l[K]?l[K].length===0?.1:1+Math.log(1+l[K].length):.99):this.f.compute(M,k);let x=S.diffs,D=S.hitTimeout;x=(0,w.$B3)(M,k,x),x=(0,w.$E3)(M,k,x);const q=[],I=X=>{if(f)for(let K=0;K<X;K++){const F=z+K,H=Z+K;if(p[F]!==l[H]){const he=this.j(p,l,new g.$p3(new h.$At(F,F+1),new h.$At(H,H+1)),s,f);for(const le of he.mappings)q.push(le);he.hitTimeout&&(D=!0)}}};let z=0,Z=0;for(const X of x){(0,y.$id)(()=>X.seq1Range.start-z===X.seq2Range.start-Z);const K=X.seq1Range.start-z;I(K),z=X.seq1Range.endExclusive,Z=X.seq2Range.endExclusive;const F=this.j(p,l,X,s,f);F.hitTimeout&&(D=!0);for(const H of F.mappings)q.push(H)}I(p.length-z);const Q=L(q,p,l);let J=[];return n.computeMoves&&(J=this.h(Q,p,l,A,E,s,f)),(0,y.$id)(()=>{function X(F,H){if(F.lineNumber<1||F.lineNumber>H.length)return!1;const he=H[F.lineNumber-1];return!(F.column<1||F.column>he.length+1)}function K(F,H){return!(F.startLineNumber<1||F.startLineNumber>H.length+1||F.endLineNumberExclusive<1||F.endLineNumberExclusive>H.length+1)}for(const F of Q){if(!F.innerChanges)return!1;for(const H of F.innerChanges)if(!(X(H.modifiedRange.getStartPosition(),l)&&X(H.modifiedRange.getEndPosition(),l)&&X(H.originalRange.getStartPosition(),p)&&X(H.originalRange.getEndPosition(),p)))return!1;if(!K(F.modified,l)||!K(F.original,p))return!1}return!0}),new e.$Pv(Q,J,D)}h(p,l,n,s,f,o,b){return(0,c.$z3)(p,l,n,s,f,o).map(M=>{const k=this.j(l,n,new g.$p3(M.original.toOffsetRange(),M.modified.toOffsetRange()),o,b),S=L(k.mappings,l,n,!0);return new e.$Qv(M,S)})}j(p,l,n,s,f){const o=new m.$y3(p,n.seq1Range,f),b=new m.$y3(l,n.seq2Range,f),A=o.length+b.length<500?this.e.compute(o,b,s):this.f.compute(o,b,s);let E=A.diffs;return E=(0,w.$B3)(o,b,E),E=(0,w.$D3)(o,b,E),E=(0,w.$C3)(o,b,E),E=(0,w.$F3)(o,b,E),{mappings:E.map(k=>new P.$Ov(o.translateRange(k.seq1Range),b.translateRange(k.seq2Range))),hitTimeout:A.hitTimeout}}}t.$G3=j;function L(v,p,l,n=!1){const s=[];for(const f of(0,i.$Ab)(v.map(o=>$(o,p,l)),(o,b)=>o.original.overlapOrTouch(b.original)||o.modified.overlapOrTouch(b.modified))){const o=f[0],b=f[f.length-1];s.push(new P.$Nv(o.original.join(b.original),o.modified.join(b.modified),f.map(A=>A.innerChanges[0])))}return(0,y.$id)(()=>!n&&s.length>0&&(s[0].modified.startLineNumber!==s[0].original.startLineNumber||l.length-s[s.length-1].modified.endLineNumberExclusive!==p.length-s[s.length-1].original.endLineNumberExclusive)?!1:(0,y.$jd)(s,(f,o)=>o.original.startLineNumber-f.original.endLineNumberExclusive===o.modified.startLineNumber-f.modified.endLineNumberExclusive&&f.original.endLineNumberExclusive<o.original.startLineNumber&&f.modified.endLineNumberExclusive<o.modified.startLineNumber)),s}function $(v,p,l){let n=0,s=0;v.modifiedRange.endColumn===1&&v.originalRange.endColumn===1&&v.originalRange.startLineNumber+n<=v.originalRange.endLineNumber&&v.modifiedRange.startLineNumber+n<=v.modifiedRange.endLineNumber&&(s=-1),v.modifiedRange.startColumn-1>=l[v.modifiedRange.startLineNumber-1].length&&v.originalRange.startColumn-1>=p[v.originalRange.startLineNumber-1].length&&v.originalRange.startLineNumber<=v.originalRange.endLineNumber+s&&v.modifiedRange.startLineNumber<=v.modifiedRange.endLineNumber+s&&(n=1);const f=new R.$Kv(v.originalRange.startLineNumber+n,v.originalRange.endLineNumber+1+s),o=new R.$Kv(v.modifiedRange.startLineNumber+n,v.modifiedRange.endLineNumber+1+s);return new P.$Nv(f,o,[v])}}),ie(se[34],ue([0,1,25,33,17,7,2,13,12]),function(O,t,i,y,R,h,N,g,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sv=t.$Rv=void 0;const u=3;class c{computeDiff(n,s,f){const b=new L(n,s,{maxComputationTime:f.maxComputationTimeMs,shouldIgnoreTrimWhitespace:f.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),A=[];let E=null;for(const M of b.changes){let k;M.originalEndLineNumber===0?k=new a.$Kv(M.originalStartLineNumber+1,M.originalStartLineNumber+1):k=new a.$Kv(M.originalStartLineNumber,M.originalEndLineNumber+1);let S;M.modifiedEndLineNumber===0?S=new a.$Kv(M.modifiedStartLineNumber+1,M.modifiedStartLineNumber+1):S=new a.$Kv(M.modifiedStartLineNumber,M.modifiedEndLineNumber+1);let x=new R.$Nv(k,S,M.charChanges?.map(D=>new R.$Ov(new N.$tt(D.originalStartLineNumber,D.originalStartColumn,D.originalEndLineNumber,D.originalEndColumn),new N.$tt(D.modifiedStartLineNumber,D.modifiedStartColumn,D.modifiedEndLineNumber,D.modifiedEndColumn))));E&&(E.modified.endLineNumberExclusive===x.modified.startLineNumber||E.original.endLineNumberExclusive===x.original.startLineNumber)&&(x=new R.$Nv(E.original.join(x.original),E.modified.join(x.modified),E.innerChanges&&x.innerChanges?E.innerChanges.concat(x.innerChanges):void 0),A.pop()),A.push(x),E=x}return(0,g.$id)(()=>(0,g.$jd)(A,(M,k)=>k.original.startLineNumber-M.original.endLineNumberExclusive===k.modified.startLineNumber-M.modified.endLineNumberExclusive&&M.original.endLineNumberExclusive<k.original.startLineNumber&&M.modified.endLineNumberExclusive<k.modified.startLineNumber)),new y.$Pv(A,[],b.quitEarly)}}t.$Rv=c;function w(l,n,s,f){return new i.$zt(l,n,s).ComputeDiff(f)}class d{constructor(n){const s=[],f=[];for(let o=0,b=n.length;o<b;o++)s[o]=$(n[o],1),f[o]=v(n[o],1);this.lines=n,this.a=s,this.b=f}getElements(){const n=[];for(let s=0,f=this.lines.length;s<f;s++)n[s]=this.lines[s].substring(this.a[s]-1,this.b[s]-1);return n}getStrictElement(n){return this.lines[n]}getStartLineNumber(n){return n+1}getEndLineNumber(n){return n+1}createCharSequence(n,s,f){const o=[],b=[],A=[];let E=0;for(let M=s;M<=f;M++){const k=this.lines[M],S=n?this.a[M]:1,x=n?this.b[M]:k.length+1;for(let D=S;D<x;D++)o[E]=k.charCodeAt(D-1),b[E]=M+1,A[E]=D,E++;!n&&M<f&&(o[E]=10,b[E]=M+1,A[E]=k.length+1,E++)}return new m(o,b,A)}}class m{constructor(n,s,f){this.a=n,this.b=s,this.d=f}toString(){return"["+this.a.map((n,s)=>(n===10?"\\n":String.fromCharCode(n))+`-(${this.b[s]},${this.d[s]})`).join(", ")+"]"}e(n,s){if(n<0||n>=s.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(n){return n>0&&n===this.b.length?this.getEndLineNumber(n-1):(this.e(n,this.b),this.b[n])}getEndLineNumber(n){return n===-1?this.getStartLineNumber(n+1):(this.e(n,this.b),this.a[n]===10?this.b[n]+1:this.b[n])}getStartColumn(n){return n>0&&n===this.d.length?this.getEndColumn(n-1):(this.e(n,this.d),this.d[n])}getEndColumn(n){return n===-1?this.getStartColumn(n+1):(this.e(n,this.d),this.a[n]===10?1:this.d[n]+1)}}class e{constructor(n,s,f,o,b,A,E,M){this.originalStartLineNumber=n,this.originalStartColumn=s,this.originalEndLineNumber=f,this.originalEndColumn=o,this.modifiedStartLineNumber=b,this.modifiedStartColumn=A,this.modifiedEndLineNumber=E,this.modifiedEndColumn=M}static createFromDiffChange(n,s,f){const o=s.getStartLineNumber(n.originalStart),b=s.getStartColumn(n.originalStart),A=s.getEndLineNumber(n.originalStart+n.originalLength-1),E=s.getEndColumn(n.originalStart+n.originalLength-1),M=f.getStartLineNumber(n.modifiedStart),k=f.getStartColumn(n.modifiedStart),S=f.getEndLineNumber(n.modifiedStart+n.modifiedLength-1),x=f.getEndColumn(n.modifiedStart+n.modifiedLength-1);return new e(o,b,A,E,M,k,S,x)}}function P(l){if(l.length<=1)return l;const n=[l[0]];let s=n[0];for(let f=1,o=l.length;f<o;f++){const b=l[f],A=b.originalStart-(s.originalStart+s.originalLength),E=b.modifiedStart-(s.modifiedStart+s.modifiedLength);Math.min(A,E)<u?(s.originalLength=b.originalStart+b.originalLength-s.originalStart,s.modifiedLength=b.modifiedStart+b.modifiedLength-s.modifiedStart):(n.push(b),s=b)}return n}class j{constructor(n,s,f,o,b){this.originalStartLineNumber=n,this.originalEndLineNumber=s,this.modifiedStartLineNumber=f,this.modifiedEndLineNumber=o,this.charChanges=b}static createFromDiffResult(n,s,f,o,b,A,E){let M,k,S,x,D;if(s.originalLength===0?(M=f.getStartLineNumber(s.originalStart)-1,k=0):(M=f.getStartLineNumber(s.originalStart),k=f.getEndLineNumber(s.originalStart+s.originalLength-1)),s.modifiedLength===0?(S=o.getStartLineNumber(s.modifiedStart)-1,x=0):(S=o.getStartLineNumber(s.modifiedStart),x=o.getEndLineNumber(s.modifiedStart+s.modifiedLength-1)),A&&s.originalLength>0&&s.originalLength<20&&s.modifiedLength>0&&s.modifiedLength<20&&b()){const q=f.createCharSequence(n,s.originalStart,s.originalStart+s.originalLength-1),I=o.createCharSequence(n,s.modifiedStart,s.modifiedStart+s.modifiedLength-1);if(q.getElements().length>0&&I.getElements().length>0){let z=w(q,I,b,!0).changes;E&&(z=P(z)),D=[];for(let Z=0,Q=z.length;Z<Q;Z++)D.push(e.createFromDiffChange(z[Z],q,I))}}return new j(M,k,S,x,D)}}class L{constructor(n,s,f){this.a=f.shouldComputeCharChanges,this.b=f.shouldPostProcessCharChanges,this.d=f.shouldIgnoreTrimWhitespace,this.e=f.shouldMakePrettyDiff,this.f=n,this.g=s,this.h=new d(n),this.j=new d(s),this.k=p(f.maxComputationTime),this.l=p(f.maxComputationTime===0?0:Math.min(f.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const n=w(this.h,this.j,this.k,this.e),s=n.changes,f=n.quitEarly;if(this.d){const E=[];for(let M=0,k=s.length;M<k;M++)E.push(j.createFromDiffResult(this.d,s[M],this.h,this.j,this.l,this.a,this.b));return{quitEarly:f,changes:E}}const o=[];let b=0,A=0;for(let E=-1,M=s.length;E<M;E++){const k=E+1<M?s[E+1]:null,S=k?k.originalStart:this.f.length,x=k?k.modifiedStart:this.g.length;for(;b<S&&A<x;){const D=this.f[b],q=this.g[A];if(D!==q){{let I=$(D,1),z=$(q,1);for(;I>1&&z>1;){const Z=D.charCodeAt(I-2),Q=q.charCodeAt(z-2);if(Z!==Q)break;I--,z--}(I>1||z>1)&&this.m(o,b+1,1,I,A+1,1,z)}{let I=v(D,1),z=v(q,1);const Z=D.length+1,Q=q.length+1;for(;I<Z&&z<Q;){const J=D.charCodeAt(I-1),X=D.charCodeAt(z-1);if(J!==X)break;I++,z++}(I<Z||z<Q)&&this.m(o,b+1,I,Z,A+1,z,Q)}}b++,A++}k&&(o.push(j.createFromDiffResult(this.d,k,this.h,this.j,this.l,this.a,this.b)),b+=k.originalLength,A+=k.modifiedLength)}return{quitEarly:f,changes:o}}m(n,s,f,o,b,A,E){if(this.n(n,s,f,o,b,A,E))return;let M;this.a&&(M=[new e(s,f,s,o,b,A,b,E)]),n.push(new j(s,s,b,b,M))}n(n,s,f,o,b,A,E){const M=n.length;if(M===0)return!1;const k=n[M-1];return k.originalEndLineNumber===0||k.modifiedEndLineNumber===0?!1:k.originalEndLineNumber===s&&k.modifiedEndLineNumber===b?(this.a&&k.charChanges&&k.charChanges.push(new e(s,f,s,o,b,A,b,E)),!0):k.originalEndLineNumber+1===s&&k.modifiedEndLineNumber+1===b?(k.originalEndLineNumber=s,k.modifiedEndLineNumber=b,this.a&&k.charChanges&&k.charChanges.push(new e(s,f,s,o,b,A,b,E)),!0):!1}}t.$Sv=L;function $(l,n){const s=h.$mf(l);return s===-1?n:s+1}function v(l,n){const s=h.$of(l);return s===-1?n:s+2}function p(l){if(l===0)return()=>!0;const n=Date.now();return()=>Date.now()-n<l}}),ie(se[52],ue([0,1,34,51]),function(O,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J3=void 0,t.$J3={getLegacy:()=>new i.$Rv,getDefault:()=>new y.$G3}}),ie(se[53],ue([0,1,36]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K3=w;function y(d){const m=[];for(const e of d){const P=Number(e);(P||P===0&&e.replace(/\s/g,"")!=="")&&m.push(P)}return m}function R(d,m,e,P){return{red:d/255,blue:e/255,green:m/255,alpha:P}}function h(d,m){const e=m.index,P=m[0].length;if(!e)return;const j=d.positionAt(e);return{startLineNumber:j.lineNumber,startColumn:j.column,endLineNumber:j.lineNumber,endColumn:j.column+P}}function N(d,m){if(!d)return;const e=i.$Ot.Format.CSS.parseHex(m);if(e)return{range:d,color:R(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function g(d,m,e){if(!d||m.length!==1)return;const j=m[0].values(),L=y(j);return{range:d,color:R(L[0],L[1],L[2],e?L[3]:1)}}function a(d,m,e){if(!d||m.length!==1)return;const j=m[0].values(),L=y(j),$=new i.$Ot(new i.$Mt(L[0],L[1]/100,L[2]/100,e?L[3]:1));return{range:d,color:R($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function u(d,m){return typeof d=="string"?[...d.matchAll(m)]:d.findMatches(m)}function c(d){const m=[],P=u(d,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(P.length>0)for(const j of P){const L=j.filter(l=>l!==void 0),$=L[1],v=L[2];if(!v)continue;let p;if($==="rgb"){const l=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;p=g(h(d,j),u(v,l),!1)}else if($==="rgba"){const l=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;p=g(h(d,j),u(v,l),!0)}else if($==="hsl"){const l=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;p=a(h(d,j),u(v,l),!1)}else if($==="hsla"){const l=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;p=a(h(d,j),u(v,l),!0)}else $==="#"&&(p=N(h(d,j),$+v));p&&m.push(p)}return m}function w(d){return!d||typeof d.getValue!="function"||typeof d.positionAt!="function"?[]:c(d)}}),ie(se[54],ue([0,1,29]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$j3=t.$i3=t.State=void 0,t.$k3=d;var y;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(y||(t.State=y={}));class R{constructor(e,P,j){const L=new Uint8Array(e*P);for(let $=0,v=e*P;$<v;$++)L[$]=j;this.a=L,this.rows=e,this.cols=P}get(e,P){return this.a[e*this.cols+P]}set(e,P,j){this.a[e*this.cols+P]=j}}class h{constructor(e){let P=0,j=0;for(let $=0,v=e.length;$<v;$++){const[p,l,n]=e[$];l>P&&(P=l),p>j&&(j=p),n>j&&(j=n)}P++,j++;const L=new R(j,P,0);for(let $=0,v=e.length;$<v;$++){const[p,l,n]=e[$];L.set(p,l,n)}this.a=L,this.b=P}nextState(e,P){return P<0||P>=this.b?0:this.a.get(e,P)}}t.$i3=h;let N=null;function g(){return N===null&&(N=new h([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),N}var a;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let u=null;function c(){if(u===null){u=new i.$Ht(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let P=0;P<m.length;P++)u.set(m.charCodeAt(P),1);const e=".,;:";for(let P=0;P<e.length;P++)u.set(e.charCodeAt(P),2)}return u}class w{static a(e,P,j,L,$){let v=$-1;do{const p=P.charCodeAt(v);if(e.get(p)!==2)break;v--}while(v>L);if(L>0){const p=P.charCodeAt(L-1),l=P.charCodeAt(v);(p===40&&l===41||p===91&&l===93||p===123&&l===125)&&v--}return{range:{startLineNumber:j,startColumn:L+1,endLineNumber:j,endColumn:v+2},url:P.substring(L,v+1)}}static computeLinks(e,P=g()){const j=c(),L=[];for(let $=1,v=e.getLineCount();$<=v;$++){const p=e.getLineContent($),l=p.length;let n=0,s=0,f=0,o=1,b=!1,A=!1,E=!1,M=!1;for(;n<l;){let k=!1;const S=p.charCodeAt(n);if(o===13){let x;switch(S){case 40:b=!0,x=0;break;case 41:x=b?0:1;break;case 91:E=!0,A=!0,x=0;break;case 93:E=!1,x=A?0:1;break;case 123:M=!0,x=0;break;case 125:x=M?0:1;break;case 39:case 34:case 96:f===S?x=1:f===39||f===34||f===96?x=0:x=1;break;case 42:x=f===42?1:0;break;case 124:x=f===124?1:0;break;case 32:x=E?0:1;break;default:x=j.get(S)}x===1&&(L.push(w.a(j,p,$,s,n)),k=!0)}else if(o===12){let x;S===91?(A=!0,x=0):x=j.get(S),x===1?k=!0:o=13}else o=P.nextState(o,S),o===0&&(k=!0);k&&(o=1,b=!1,A=!1,M=!1,s=n+1,f=S),n++}o===13&&L.push(w.a(j,p,$,s,l))}return L}}t.$j3=w;function d(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:w.computeLinks(m)}}),ie(se[55],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$l3=void 0;class i{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new i}navigateValueSet(R,h,N,g,a){if(R&&h){const u=this.a(h,a);if(u)return{range:R,value:u}}if(N&&g){const u=this.a(g,a);if(u)return{range:N,value:u}}return null}a(R,h){const N=this.b(R,h);return N!==null?N:this.d(R,h)}b(R,h){const N=Math.pow(10,R.length-(R.lastIndexOf(".")+1));let g=Number(R);const a=parseFloat(R);return!isNaN(g)&&!isNaN(a)&&g===a?g===0&&!h?null:(g=Math.floor(g*N),g+=h?N:-N,String(g/N)):null}d(R,h){return this.e(this.c,R,h)}e(R,h,N){let g=null;for(let a=0,u=R.length;g===null&&a<u;a++)g=this.f(R[a],h,N);return g}f(R,h,N){let g=R.indexOf(h);return g>=0?(g+=N?1:-1,g<0?g=R.length-1:g%=R.length,R[g]):null}}t.$l3=i}),ie(se[56],ue([0,1,15]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Iv=t.$Hv=t.$Gv=t.ModelConstants=t.PositionAffinity=t.TrackedRangeStickiness=t.$Ev=t.$Dv=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0,t.$Fv=e,t.$Jv=p;var y;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(y||(t.OverviewRulerLane=y={}));var R;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=3]="Right"})(R||(t.GlyphMarginLane=R={}));var h;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(h||(t.MinimapPosition=h={}));var N;(function(l){l[l.Normal=1]="Normal",l[l.Underlined=2]="Underlined"})(N||(t.MinimapSectionHeaderStyle=N={}));var g;(function(l){l[l.Both=0]="Both",l[l.Right=1]="Right",l[l.Left=2]="Left",l[l.None=3]="None"})(g||(t.InjectedTextCursorStops=g={}));var a;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(a||(t.EndOfLinePreference=a={}));var u;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(u||(t.DefaultEndOfLine=u={}));var c;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(c||(t.EndOfLineSequence=c={}));class w{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(n){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,n.tabSize|0),n.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,n.indentSize|0),this.a=!1),this.insertSpaces=!!n.insertSpaces,this.defaultEOL=n.defaultEOL|0,this.trimAutoWhitespace=!!n.trimAutoWhitespace,this.bracketPairColorizationOptions=n.bracketPairColorizationOptions}equals(n){return this.tabSize===n.tabSize&&this.a===n.a&&this.indentSize===n.indentSize&&this.insertSpaces===n.insertSpaces&&this.defaultEOL===n.defaultEOL&&this.trimAutoWhitespace===n.trimAutoWhitespace&&(0,i.$6n)(this.bracketPairColorizationOptions,n.bracketPairColorizationOptions)}createChangeEvent(n){return{tabSize:this.tabSize!==n.tabSize,indentSize:this.indentSize!==n.indentSize,insertSpaces:this.insertSpaces!==n.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==n.trimAutoWhitespace}}}t.$Dv=w;class d{constructor(n,s){this._findMatchBrand=void 0,this.range=n,this.matches=s}}t.$Ev=d;var m;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(t.TrackedRangeStickiness=m={}));function e(l){return l&&typeof l.read=="function"}var P;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None",l[l.LeftOfInjectedText=3]="LeftOfInjectedText",l[l.RightOfInjectedText=4]="RightOfInjectedText"})(P||(t.PositionAffinity=P={}));var j;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(j||(t.ModelConstants=j={}));class L{constructor(n,s,f,o,b,A){this.identifier=n,this.range=s,this.text=f,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=b,this._isTracked=A}}t.$Gv=L;class ${constructor(n,s,f){this.regex=n,this.wordSeparators=s,this.simpleSearch=f}}t.$Hv=$;class v{constructor(n,s,f){this.reverseEdits=n,this.changes=s,this.trimAutoWhitespaceLineNumbers=f}}t.$Iv=v;function p(l){return!l.isTooLargeForSyncing()&&!l.isForSimpleWidget}}),ie(se[57],ue([0,1,6,28]),function(O,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xv=t.$Wv=t.$Vv=void 0;class R{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,u){a=(0,y.$6e)(a);const c=this.a,w=this.b,d=u.length;return d===0?!1:(this.a=new Uint32Array(c.length+d),this.a.set(c.subarray(0,a),0),this.a.set(c.subarray(a),a+d),this.a.set(u,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(w.subarray(0,this.c[0]+1)),!0)}setValue(a,u){return a=(0,y.$6e)(a),u=(0,y.$6e)(u),this.a[a]===u?!1:(this.a[a]=u,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,u){a=(0,y.$6e)(a),u=(0,y.$6e)(u);const c=this.a,w=this.b;if(a>=c.length)return!1;const d=c.length-a;return u>=d&&(u=d),u===0?!1:(this.a=new Uint32Array(c.length-u),this.a.set(c.subarray(0,a),0),this.a.set(c.subarray(a+u),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(w.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,y.$6e)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let u=this.c[0]+1;u===0&&(this.b[0]=this.a[0],u++),a>=this.a.length&&(a=this.a.length-1);for(let c=u;c<=a;c++)this.b[c]=this.b[c-1]+this.a[c];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let u=0,c=this.a.length-1,w=0,d=0,m=0;for(;u<=c;)if(w=u+(c-u)/2|0,d=this.b[w],m=d-this.a[w],a<m)c=w-1;else if(a>=d)u=w+1;else break;return new N(w,a-m)}}t.$Vv=R;class h{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const u=this.e[a],c=u>0?this.d[u-1]:0;return new N(u,a-c)}removeValues(a,u){this.a.splice(a,u),this.f(a)}insertValues(a,u){this.a=(0,i.$Wb)(this.a,a,u),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,u=this.a.length;a<u;a++){const c=this.a[a],w=a>0?this.d[a-1]:0;this.d[a]=w+c;for(let d=0;d<c;d++)this.e[w+d]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,u){this.a[a]!==u&&(this.a[a]=u,this.f(a))}}t.$Wv=h;class N{constructor(a,u){this.index=a,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=u}}t.$Xv=N}),ie(se[58],ue([0,1,7,5,57]),function(O,t,i,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yv=void 0;class h{constructor(g,a,u,c){this.d=g,this.f=a,this.g=u,this.h=c,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(g){g.eol&&g.eol!==this.g&&(this.g=g.eol,this.j=null);const a=g.changes;for(const u of a)this.o(u.range),this.p(new y.$st(u.range.startLineNumber,u.range.startColumn),u.text);this.h=g.versionId,this.k=null}l(){if(!this.j){const g=this.g.length,a=this.f.length,u=new Uint32Array(a);for(let c=0;c<a;c++)u[c]=this.f[c].length+g;this.j=new R.$Vv(u)}}n(g,a){this.f[g]=a,this.j&&this.j.setValue(g,this.f[g].length+this.g.length)}o(g){if(g.startLineNumber===g.endLineNumber){if(g.startColumn===g.endColumn)return;this.n(g.startLineNumber-1,this.f[g.startLineNumber-1].substring(0,g.startColumn-1)+this.f[g.startLineNumber-1].substring(g.endColumn-1));return}this.n(g.startLineNumber-1,this.f[g.startLineNumber-1].substring(0,g.startColumn-1)+this.f[g.endLineNumber-1].substring(g.endColumn-1)),this.f.splice(g.startLineNumber,g.endLineNumber-g.startLineNumber),this.j&&this.j.removeValues(g.startLineNumber,g.endLineNumber-g.startLineNumber)}p(g,a){if(a.length===0)return;const u=(0,i.$kf)(a);if(u.length===1){this.n(g.lineNumber-1,this.f[g.lineNumber-1].substring(0,g.column-1)+u[0]+this.f[g.lineNumber-1].substring(g.column-1));return}u[u.length-1]+=this.f[g.lineNumber-1].substring(g.column-1),this.n(g.lineNumber-1,this.f[g.lineNumber-1].substring(0,g.column-1)+u[0]);const c=new Uint32Array(u.length-1);for(let w=1;w<u.length;w++)this.f.splice(g.lineNumber+w-1,0,u[w]),c[w-1]=u[w].length+this.g.length;this.j&&this.j.insertValues(g.lineNumber,c)}}t.$Yv=h}),ie(se[59],ue([0,1,7,46,5,2,56]),function(O,t,i,y,R,h,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NC=t.$LC=t.$IC=void 0,t.$JC=u,t.$KC=c,t.$MC=P;const g=999;class a{constructor($,v,p,l){this.searchString=$,this.isRegex=v,this.matchCase=p,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=u(this.searchString):$=this.searchString.indexOf(`
`)>=0;let v=null;try{v=i.$if(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!v)return null;let p=!this.isRegex&&!$;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new N.$Hv(v,this.wordSeparators?(0,y.$Kt)(this.wordSeparators,[]):null,p?this.searchString:null)}}t.$IC=a;function u(L){if(!L||L.length===0)return!1;for(let $=0,v=L.length;$<v;$++){const p=L.charCodeAt($);if(p===10)return!0;if(p===92){if($++,$>=v)break;const l=L.charCodeAt($);if(l===110||l===114||l===87)return!0}}return!1}function c(L,$,v){if(!v)return new N.$Ev(L,null);const p=[];for(let l=0,n=$.length;l<n;l++)p[l]=$[l];return new N.$Ev(L,p)}class w{constructor($){const v=[];let p=0;for(let l=0,n=$.length;l<n;l++)$.charCodeAt(l)===10&&(v[p++]=l);this.a=v}findLineFeedCountBeforeOffset($){const v=this.a;let p=0,l=v.length-1;if(l===-1||$<=v[0])return 0;for(;p<l;){const n=p+((l-p)/2>>0);v[n]>=$?l=n-1:v[n+1]>=$?(p=n,l=n):p=n+1}return p+1}}class d{static findMatches($,v,p,l,n){const s=v.parseSearchRequest();return s?s.regex.multiline?this.b($,p,new j(s.wordSeparators,s.regex),l,n):this.c($,p,s,l,n):[]}static a($,v,p,l,n,s){let f,o=0;l?(o=l.findLineFeedCountBeforeOffset(n),f=v+n+o):f=v+n;let b;if(l){const k=l.findLineFeedCountBeforeOffset(n+s.length)-o;b=f+s.length+k}else b=f+s.length;const A=$.getPositionAt(f),E=$.getPositionAt(b);return new h.$tt(A.lineNumber,A.column,E.lineNumber,E.column)}static b($,v,p,l,n){const s=$.getOffsetAt(v.getStartPosition()),f=$.getValueInRange(v,1),o=$.getEOL()===`\r
`?new w(f):null,b=[];let A=0,E;for(p.reset(0);E=p.next(f);)if(b[A++]=c(this.a($,s,f,o,E.index,E[0]),E,l),A>=n)return b;return b}static c($,v,p,l,n){const s=[];let f=0;if(v.startLineNumber===v.endLineNumber){const b=$.getLineContent(v.startLineNumber).substring(v.startColumn-1,v.endColumn-1);return f=this.d(p,b,v.startLineNumber,v.startColumn-1,f,s,l,n),s}const o=$.getLineContent(v.startLineNumber).substring(v.startColumn-1);f=this.d(p,o,v.startLineNumber,v.startColumn-1,f,s,l,n);for(let b=v.startLineNumber+1;b<v.endLineNumber&&f<n;b++)f=this.d(p,$.getLineContent(b),b,0,f,s,l,n);if(f<n){const b=$.getLineContent(v.endLineNumber).substring(0,v.endColumn-1);f=this.d(p,b,v.endLineNumber,0,f,s,l,n)}return s}static d($,v,p,l,n,s,f,o){const b=$.wordSeparators;if(!f&&$.simpleSearch){const M=$.simpleSearch,k=M.length,S=v.length;let x=-k;for(;(x=v.indexOf(M,x+k))!==-1;)if((!b||P(b,v,S,x,k))&&(s[n++]=new N.$Ev(new h.$tt(p,x+1+l,p,x+1+k+l),null),n>=o))return n;return n}const A=new j($.wordSeparators,$.regex);let E;A.reset(0);do if(E=A.next(v),E&&(s[n++]=c(new h.$tt(p,E.index+1+l,p,E.index+1+E[0].length+l),E,f),n>=o))return n;while(E);return n}static findNextMatch($,v,p,l){const n=v.parseSearchRequest();if(!n)return null;const s=new j(n.wordSeparators,n.regex);return n.regex.multiline?this.e($,p,s,l):this.f($,p,s,l)}static e($,v,p,l){const n=new R.$st(v.lineNumber,1),s=$.getOffsetAt(n),f=$.getLineCount(),o=$.getValueInRange(new h.$tt(n.lineNumber,n.column,f,$.getLineMaxColumn(f)),1),b=$.getEOL()===`\r
`?new w(o):null;p.reset(v.column-1);const A=p.next(o);return A?c(this.a($,s,o,b,A.index,A[0]),A,l):v.lineNumber!==1||v.column!==1?this.e($,new R.$st(1,1),p,l):null}static f($,v,p,l){const n=$.getLineCount(),s=v.lineNumber,f=$.getLineContent(s),o=this.g(p,f,s,v.column,l);if(o)return o;for(let b=1;b<=n;b++){const A=(s+b-1)%n,E=$.getLineContent(A+1),M=this.g(p,E,A+1,1,l);if(M)return M}return null}static g($,v,p,l,n){$.reset(l-1);const s=$.next(v);return s?c(new h.$tt(p,s.index+1,p,s.index+1+s[0].length),s,n):null}static findPreviousMatch($,v,p,l){const n=v.parseSearchRequest();if(!n)return null;const s=new j(n.wordSeparators,n.regex);return n.regex.multiline?this.h($,p,s,l):this.j($,p,s,l)}static h($,v,p,l){const n=this.b($,new h.$tt(1,1,v.lineNumber,v.column),p,l,10*g);if(n.length>0)return n[n.length-1];const s=$.getLineCount();return v.lineNumber!==s||v.column!==$.getLineMaxColumn(s)?this.h($,new R.$st(s,$.getLineMaxColumn(s)),p,l):null}static j($,v,p,l){const n=$.getLineCount(),s=v.lineNumber,f=$.getLineContent(s).substring(0,v.column-1),o=this.k(p,f,s,l);if(o)return o;for(let b=1;b<=n;b++){const A=(n+s-b-1)%n,E=$.getLineContent(A+1),M=this.k(p,E,A+1,l);if(M)return M}return null}static k($,v,p,l){let n=null,s;for($.reset(0);s=$.next(v);)n=c(new h.$tt(p,s.index+1,p,s.index+1+s[0].length),s,l);return n}}t.$LC=d;function m(L,$,v,p,l){if(p===0)return!0;const n=$.charCodeAt(p-1);if(L.get(n)!==0||n===13||n===10)return!0;if(l>0){const s=$.charCodeAt(p);if(L.get(s)!==0)return!0}return!1}function e(L,$,v,p,l){if(p+l===v)return!0;const n=$.charCodeAt(p+l);if(L.get(n)!==0||n===13||n===10)return!0;if(l>0){const s=$.charCodeAt(p+l-1);if(L.get(s)!==0)return!0}return!1}function P(L,$,v,p,l){return m(L,$,v,p,l)&&e(L,$,v,p,l)}class j{constructor($,v){this._wordSeparators=$,this.a=v,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const v=$.length;let p;do{if(this.b+this.c===v||(p=this.a.exec($),!p))return null;const l=p.index,n=p[0].length;if(l===this.b&&n===this.c){if(n===0){i.$Ef($,v,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=l,this.c=n,!this._wordSeparators||P(this._wordSeparators,$,v,l,n))return p}while(p);return null}}t.$NC=j}),ie(se[60],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L3=R;const i=/\bMARK:\s*(.*)$/d,y=/^-+|-+$/g;function R(u,c){let w=[];if(c.findRegionSectionHeaders&&c.foldingRules?.markers){const d=h(u,c);w=w.concat(d)}if(c.findMarkSectionHeaders){const d=N(u);w=w.concat(d)}return w}function h(u,c){const w=[],d=u.getLineCount();for(let m=1;m<=d;m++){const e=u.getLineContent(m),P=e.match(c.foldingRules.markers.start);if(P){const j={startLineNumber:m,startColumn:P[0].length+1,endLineNumber:m,endColumn:e.length+1};if(j.endColumn>j.startColumn){const L={range:j,...a(e.substring(P[0].length)),shouldBeInComments:!1};(L.text||L.hasSeparatorLine)&&w.push(L)}}}return w}function N(u){const c=[],w=u.getLineCount();for(let d=1;d<=w;d++){const m=u.getLineContent(d);g(m,d,c)}return c}function g(u,c,w){i.lastIndex=0;const d=i.exec(u);if(d){const m=d.indices[1][0]+1,e=d.indices[1][1]+1,P={startLineNumber:c,startColumn:m,endLineNumber:c,endColumn:e};if(P.endColumn>P.startColumn){const j={range:P,...a(d[1]),shouldBeInComments:!0};(j.text||j.hasSeparatorLine)&&w.push(j)}}}function a(u){u=u.trim();const c=u.startsWith("-");return u=u.replace(y,""),{text:u,hasSeparatorLine:c}}}),ie(se[61],ue([0,1,2,59,7,13,30]),function(O,t,i,y,R,h,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$h3=void 0;class g{static computeUnicodeHighlights(e,P,j){const L=j?j.startLineNumber:1,$=j?j.endLineNumber:e.getLineCount(),v=new c(P),p=v.getCandidateCodePoints();let l;p==="allNonBasicAscii"?l=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):l=new RegExp(`${a(Array.from(p))}`,"g");const n=new y.$NC(null,l),s=[];let f=!1,o,b=0,A=0,E=0;e:for(let M=L,k=$;M<=k;M++){const S=e.getLineContent(M),x=S.length;n.reset(0);do if(o=n.next(S),o){let D=o.index,q=o.index+o[0].length;if(D>0){const Q=S.charCodeAt(D-1);R.$Bf(Q)&&D--}if(q+1<x){const Q=S.charCodeAt(q-1);R.$Bf(Q)&&q++}const I=S.substring(D,q);let z=(0,N.$8s)(D+1,N.$5s,S,0);z&&z.endColumn<=D+1&&(z=null);const Z=v.shouldHighlightNonBasicASCII(I,z?z.word:null);if(Z!==0){if(Z===3?b++:Z===2?A++:Z===1?E++:(0,h.$fd)(Z),s.length>=1e3){f=!0;break e}s.push(new i.$tt(M,D+1,M,q+1))}}while(o)}return{ranges:s,hasMore:f,ambiguousCharacterCount:b,invisibleCharacterCount:A,nonBasicAsciiCharacterCount:E}}static computeUnicodeHighlightReason(e,P){const j=new c(P);switch(j.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),v=j.ambiguousCharacters.getPrimaryConfusable($),p=R.$6f.getLocales().filter(l=>!R.$6f.getInstance(new Set([...P.allowedLocales,l])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(v),notAmbiguousInLocales:p}}case 1:return{kind:2}}}}t.$h3=g;function a(m,e){return`[${R.$_e(m.map(j=>String.fromCodePoint(j)).join(""))}]`}var u;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(u||(t.UnicodeHighlighterReasonKind=u={}));class c{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=R.$6f.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const P of R.$7f.codePoints)w(String.fromCodePoint(P))||e.add(P);if(this.b.ambiguousCharacters)for(const P of this.ambiguousCharacters.getConfusableCodePoints())e.add(P);for(const P of this.a)e.delete(P);return e}shouldHighlightNonBasicASCII(e,P){const j=e.codePointAt(0);if(this.a.has(j))return 0;if(this.b.nonBasicASCII)return 1;let L=!1,$=!1;if(P)for(const v of P){const p=v.codePointAt(0),l=R.$Mf(v);L=L||l,!l&&!this.ambiguousCharacters.isAmbiguous(p)&&!R.$7f.isInvisibleCharacter(p)&&($=!0)}return!L&&$?0:this.b.invisibleCharacters&&!w(e)&&R.$7f.isInvisibleCharacter(j)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(j)?3:0}}function w(m){return m===" "||m===`
`||m==="	"}var d;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(d||(d={}))}),ie(se[62],ue([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.PartialAcceptTriggerKind=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.HoverVerbosityAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var i;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(i||(t.AccessibilitySupport=i={}));var y;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(y||(t.CodeActionTriggerType=y={}));var R;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(R||(t.CompletionItemInsertTextRule=R={}));var h;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(h||(t.CompletionItemKind=h={}));var N;(function(r){r[r.Deprecated=1]="Deprecated"})(N||(t.CompletionItemTag=N={}));var g;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(t.CompletionTriggerKind=g={}));var a;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(a||(t.ContentWidgetPositionPreference=a={}));var u;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(u||(t.CursorChangeReason=u={}));var c;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(c||(t.DefaultEndOfLine=c={}));var w;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(w||(t.DocumentHighlightKind=w={}));var d;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(d||(t.EditorAutoIndentStrategy=d={}));var m;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",r[r.quickSuggestions=89]="quickSuggestions",r[r.quickSuggestionsDelay=90]="quickSuggestionsDelay",r[r.readOnly=91]="readOnly",r[r.readOnlyMessage=92]="readOnlyMessage",r[r.renameOnType=93]="renameOnType",r[r.renderControlCharacters=94]="renderControlCharacters",r[r.renderFinalNewline=95]="renderFinalNewline",r[r.renderLineHighlight=96]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=98]="renderValidationDecorations",r[r.renderWhitespace=99]="renderWhitespace",r[r.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",r[r.roundedSelection=101]="roundedSelection",r[r.rulers=102]="rulers",r[r.scrollbar=103]="scrollbar",r[r.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=105]="scrollBeyondLastLine",r[r.scrollPredominantAxis=106]="scrollPredominantAxis",r[r.selectionClipboard=107]="selectionClipboard",r[r.selectionHighlight=108]="selectionHighlight",r[r.selectOnLineNumbers=109]="selectOnLineNumbers",r[r.showFoldingControls=110]="showFoldingControls",r[r.showUnused=111]="showUnused",r[r.snippetSuggestions=112]="snippetSuggestions",r[r.smartSelect=113]="smartSelect",r[r.smoothScrolling=114]="smoothScrolling",r[r.stickyScroll=115]="stickyScroll",r[r.stickyTabStops=116]="stickyTabStops",r[r.stopRenderingLineAfter=117]="stopRenderingLineAfter",r[r.suggest=118]="suggest",r[r.suggestFontSize=119]="suggestFontSize",r[r.suggestLineHeight=120]="suggestLineHeight",r[r.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",r[r.suggestSelection=122]="suggestSelection",r[r.tabCompletion=123]="tabCompletion",r[r.tabIndex=124]="tabIndex",r[r.unicodeHighlighting=125]="unicodeHighlighting",r[r.unusualLineTerminators=126]="unusualLineTerminators",r[r.useShadowDOM=127]="useShadowDOM",r[r.useTabStops=128]="useTabStops",r[r.wordBreak=129]="wordBreak",r[r.wordSegmenterLocales=130]="wordSegmenterLocales",r[r.wordSeparators=131]="wordSeparators",r[r.wordWrap=132]="wordWrap",r[r.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=135]="wordWrapColumn",r[r.wordWrapOverride1=136]="wordWrapOverride1",r[r.wordWrapOverride2=137]="wordWrapOverride2",r[r.wrappingIndent=138]="wrappingIndent",r[r.wrappingStrategy=139]="wrappingStrategy",r[r.showDeprecated=140]="showDeprecated",r[r.inlayHints=141]="inlayHints",r[r.editorClassName=142]="editorClassName",r[r.pixelRatio=143]="pixelRatio",r[r.tabFocusMode=144]="tabFocusMode",r[r.layoutInfo=145]="layoutInfo",r[r.wrappingInfo=146]="wrappingInfo",r[r.defaultColorDecorators=147]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(m||(t.EditorOption=m={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var P;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(P||(t.EndOfLineSequence=P={}));var j;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(j||(t.GlyphMarginLane=j={}));var L;(function(r){r[r.Increase=0]="Increase",r[r.Decrease=1]="Decrease"})(L||(t.HoverVerbosityAction=L={}));var $;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})($||(t.IndentAction=$={}));var v;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(v||(t.InjectedTextCursorStops=v={}));var p;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(p||(t.InlayHintKind=p={}));var l;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(l||(t.InlineCompletionTriggerKind=l={}));var n;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(n||(t.InlineEditTriggerKind=n={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(s||(t.KeyCode=s={}));var f;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(f||(t.MarkerSeverity=f={}));var o;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(o||(t.MarkerTag=o={}));var b;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(b||(t.MinimapPosition=b={}));var A;(function(r){r[r.Normal=1]="Normal",r[r.Underlined=2]="Underlined"})(A||(t.MinimapSectionHeaderStyle=A={}));var E;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(E||(t.MouseTargetType=E={}));var M;(function(r){r[r.AIGenerated=1]="AIGenerated"})(M||(t.NewSymbolNameTag=M={}));var k;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(k||(t.OverlayWidgetPositionPreference=k={}));var S;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(S||(t.OverviewRulerLane=S={}));var x;(function(r){r[r.Word=0]="Word",r[r.Line=1]="Line",r[r.Suggest=2]="Suggest"})(x||(t.PartialAcceptTriggerKind=x={}));var D;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(D||(t.PositionAffinity=D={}));var q;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(q||(t.RenderLineNumbersType=q={}));var I;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(I||(t.RenderMinimap=I={}));var z;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(z||(t.ScrollType=z={}));var Z;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(Z||(t.ScrollbarVisibility=Z={}));var Q;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(Q||(t.SelectionDirection=Q={}));var J;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(J||(t.ShowLightbulbIconMode=J={}));var X;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(X||(t.SignatureHelpTriggerKind=X={}));var K;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(K||(t.SymbolKind=K={}));var F;(function(r){r[r.Deprecated=1]="Deprecated"})(F||(t.SymbolTag=F={}));var H;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(H||(t.TextEditorCursorBlinkingStyle=H={}));var he;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(he||(t.TextEditorCursorStyle=he={}));var le;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(le||(t.TrackedRangeStickiness=le={}));var be;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(be||(t.WrappingIndent=be={}))}),ie(se[63],ue([0,1,11,10]),function(O,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vt=void 0;class R{constructor(){this.a=new Map,this.b=new Map,this.c=new i.$ee,this.onDidChange=this.c.event,this.d=null}handleChange(g){this.c.fire({changedLanguages:g,changedColorMap:!1})}register(g,a){return this.a.set(g,a),this.handleChange([g]),(0,y.$Tc)(()=>{this.a.get(g)===a&&(this.a.delete(g),this.handleChange([g]))})}get(g){return this.a.get(g)||null}registerFactory(g,a){this.b.get(g)?.dispose();const u=new h(this,g,a);return this.b.set(g,u),(0,y.$Tc)(()=>{const c=this.b.get(g);!c||c!==u||(this.b.delete(g),c.dispose())})}async getOrCreate(g){const a=this.get(g);if(a)return a;const u=this.b.get(g);return!u||u.isResolved?null:(await u.resolve(),this.get(g))}isResolved(g){if(this.get(g))return!0;const u=this.b.get(g);return!!(!u||u.isResolved)}setColorMap(g){this.d=g,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$Vt=R;class h extends y.$Vc{get isResolved(){return this.c}constructor(g,a,u){super(),this.f=g,this.g=a,this.h=u,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const g=await this.h.tokenizationSupport;this.c=!0,g&&!this.a&&this.B(this.f.register(this.g,g))}}}),ie(se[64],ue([65,66]),function(O,t){return O.create("vs/base/common/platform",t)}),ie(se[18],ue([0,1,64]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=s,t.$D=M,t.$J=k,t.$g="en";let y=!1,R=!1,h=!1,N=!1,g=!1,a=!1,u=!1,c=!1,w=!1,d=!1,m,e=t.$g,P=t.$g,j,L;const $=globalThis;let v;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?v=$.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(v=process);const p=typeof v?.versions?.electron=="string",l=p&&v?.type==="renderer";if(typeof v=="object"){y=v.platform==="win32",R=v.platform==="darwin",h=v.platform==="linux",N=h&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,u=p,w=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.$g,e=t.$g;const S=v.env.VSCODE_NLS_CONFIG;if(S)try{const x=JSON.parse(S),D=x.availableLanguages["*"];m=x.locale,P=x.osLocale,e=D||t.$g,j=x._translationsConfigFile}catch{}g=!0}else typeof navigator=="object"&&!l?(L=navigator.userAgent,y=L.indexOf("Windows")>=0,R=L.indexOf("Macintosh")>=0,c=(L.indexOf("Macintosh")>=0||L.indexOf("iPad")>=0||L.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,h=L.indexOf("Linux")>=0,d=L?.indexOf("Mobi")>=0,a=!0,m=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=m,P=navigator.language):console.error("Unable to resolve platform.");var n;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(n||(t.Platform=n={}));function s(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let f=0;R?f=1:y?f=3:h&&(f=2),t.$i=y,t.$j=R,t.$k=h,t.$l=N,t.$m=g,t.$n=u,t.$o=a,t.$p=a&&typeof $.importScripts=="function",t.$q=t.$p?$.origin:void 0,t.$r=c,t.$s=d,t.$t=w,t.$u=f,t.$v=L,t.$w=e;var o;(function(S){function x(){return t.$w}S.value=x;function D(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}S.isDefaultVariant=D;function q(){return t.$w==="en"}S.isDefault=q})(o||(t.Language=o={})),t.$x=m,t.$y=P,t.$z=j,t.$A=typeof $.postMessage=="function"&&!$.importScripts,t.$B=(()=>{if(t.$A){const S=[];$.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let q=0,I=S.length;q<I;q++){const z=S[q];if(z.id===D.data.vscodeScheduleAsyncWork){S.splice(q,1),z.callback();return}}});let x=0;return D=>{const q=++x;S.push({id:q,callback:D}),$.postMessage({vscodeScheduleAsyncWork:q},"*")}}return S=>setTimeout(S)})();var b;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(b||(t.OperatingSystem=b={})),t.OS=R||c?2:y?1:3;let A=!0,E=!1;function M(){if(!E){E=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,A=new Uint16Array(S.buffer)[0]===513}return A}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function k(S){return parseFloat(S)>=20}}),ie(se[67],ue([0,1,18]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let y;const R=globalThis.vscode;if(typeof R<"u"&&typeof R.process<"u"){const h=R.process;y={get platform(){return h.platform},get arch(){return h.arch},get env(){return h.env},cwd(){return h.cwd()}}}else typeof process<"u"?y={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:y={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=y.cwd,t.env=y.env,t.$ec=y.platform,t.$fc=y.arch}),ie(se[68],ue([0,1,67]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0;const y=65,R=97,h=90,N=122,g=46,a=47,u=92,c=58,w=63;class d extends Error{constructor(s,f,o){let b;typeof f=="string"&&f.indexOf("not ")===0?(b="must not be",f=f.replace(/^not /,"")):b="must be";const A=s.indexOf(".")!==-1?"property":"argument";let E=`The "${s}" ${A} ${b} of type ${f}`;E+=`. Received type ${typeof o}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function m(n,s){if(n===null||typeof n!="object")throw new d(s,"Object",n)}function e(n,s){if(typeof n!="string")throw new d(s,"string",n)}const P=i.$ec==="win32";function j(n){return n===a||n===u}function L(n){return n===a}function $(n){return n>=y&&n<=h||n>=R&&n<=N}function v(n,s,f,o){let b="",A=0,E=-1,M=0,k=0;for(let S=0;S<=n.length;++S){if(S<n.length)k=n.charCodeAt(S);else{if(o(k))break;k=a}if(o(k)){if(!(E===S-1||M===1))if(M===2){if(b.length<2||A!==2||b.charCodeAt(b.length-1)!==g||b.charCodeAt(b.length-2)!==g){if(b.length>2){const x=b.lastIndexOf(f);x===-1?(b="",A=0):(b=b.slice(0,x),A=b.length-1-b.lastIndexOf(f)),E=S,M=0;continue}else if(b.length!==0){b="",A=0,E=S,M=0;continue}}s&&(b+=b.length>0?`${f}..`:"..",A=2)}else b.length>0?b+=`${f}${n.slice(E+1,S)}`:b=n.slice(E+1,S),A=S-E-1;E=S,M=0}else k===g&&M!==-1?++M:M=-1}return b}function p(n,s){m(s,"pathObject");const f=s.dir||s.root,o=s.base||`${s.name||""}${s.ext||""}`;return f?f===s.root?`${f}${o}`:`${f}${n}${o}`:o}t.$gc={resolve(...n){let s="",f="",o=!1;for(let b=n.length-1;b>=-1;b--){let A;if(b>=0){if(A=n[b],e(A,"path"),A.length===0)continue}else s.length===0?A=i.cwd():(A=i.env[`=${s}`]||i.cwd(),(A===void 0||A.slice(0,2).toLowerCase()!==s.toLowerCase()&&A.charCodeAt(2)===u)&&(A=`${s}\\`));const E=A.length;let M=0,k="",S=!1;const x=A.charCodeAt(0);if(E===1)j(x)&&(M=1,S=!0);else if(j(x))if(S=!0,j(A.charCodeAt(1))){let D=2,q=D;for(;D<E&&!j(A.charCodeAt(D));)D++;if(D<E&&D!==q){const I=A.slice(q,D);for(q=D;D<E&&j(A.charCodeAt(D));)D++;if(D<E&&D!==q){for(q=D;D<E&&!j(A.charCodeAt(D));)D++;(D===E||D!==q)&&(k=`\\\\${I}\\${A.slice(q,D)}`,M=D)}}}else M=1;else $(x)&&A.charCodeAt(1)===c&&(k=A.slice(0,2),M=2,E>2&&j(A.charCodeAt(2))&&(S=!0,M=3));if(k.length>0)if(s.length>0){if(k.toLowerCase()!==s.toLowerCase())continue}else s=k;if(o){if(s.length>0)break}else if(f=`${A.slice(M)}\\${f}`,o=S,S&&s.length>0)break}return f=v(f,!o,"\\",j),o?`${s}\\${f}`:`${s}${f}`||"."},normalize(n){e(n,"path");const s=n.length;if(s===0)return".";let f=0,o,b=!1;const A=n.charCodeAt(0);if(s===1)return L(A)?"\\":n;if(j(A))if(b=!0,j(n.charCodeAt(1))){let M=2,k=M;for(;M<s&&!j(n.charCodeAt(M));)M++;if(M<s&&M!==k){const S=n.slice(k,M);for(k=M;M<s&&j(n.charCodeAt(M));)M++;if(M<s&&M!==k){for(k=M;M<s&&!j(n.charCodeAt(M));)M++;if(M===s)return`\\\\${S}\\${n.slice(k)}\\`;M!==k&&(o=`\\\\${S}\\${n.slice(k,M)}`,f=M)}}}else f=1;else $(A)&&n.charCodeAt(1)===c&&(o=n.slice(0,2),f=2,s>2&&j(n.charCodeAt(2))&&(b=!0,f=3));let E=f<s?v(n.slice(f),!b,"\\",j):"";return E.length===0&&!b&&(E="."),E.length>0&&j(n.charCodeAt(s-1))&&(E+="\\"),o===void 0?b?`\\${E}`:E:b?`${o}\\${E}`:`${o}${E}`},isAbsolute(n){e(n,"path");const s=n.length;if(s===0)return!1;const f=n.charCodeAt(0);return j(f)||s>2&&$(f)&&n.charCodeAt(1)===c&&j(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,f;for(let A=0;A<n.length;++A){const E=n[A];e(E,"path"),E.length>0&&(s===void 0?s=f=E:s+=`\\${E}`)}if(s===void 0)return".";let o=!0,b=0;if(typeof f=="string"&&j(f.charCodeAt(0))){++b;const A=f.length;A>1&&j(f.charCodeAt(1))&&(++b,A>2&&(j(f.charCodeAt(2))?++b:o=!1))}if(o){for(;b<s.length&&j(s.charCodeAt(b));)b++;b>=2&&(s=`\\${s.slice(b)}`)}return t.$gc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s)return"";const f=t.$gc.resolve(n),o=t.$gc.resolve(s);if(f===o||(n=f.toLowerCase(),s=o.toLowerCase(),n===s))return"";let b=0;for(;b<n.length&&n.charCodeAt(b)===u;)b++;let A=n.length;for(;A-1>b&&n.charCodeAt(A-1)===u;)A--;const E=A-b;let M=0;for(;M<s.length&&s.charCodeAt(M)===u;)M++;let k=s.length;for(;k-1>M&&s.charCodeAt(k-1)===u;)k--;const S=k-M,x=E<S?E:S;let D=-1,q=0;for(;q<x;q++){const z=n.charCodeAt(b+q);if(z!==s.charCodeAt(M+q))break;z===u&&(D=q)}if(q!==x){if(D===-1)return o}else{if(S>x){if(s.charCodeAt(M+q)===u)return o.slice(M+q+1);if(q===2)return o.slice(M+q)}E>x&&(n.charCodeAt(b+q)===u?D=q:q===2&&(D=3)),D===-1&&(D=0)}let I="";for(q=b+D+1;q<=A;++q)(q===A||n.charCodeAt(q)===u)&&(I+=I.length===0?"..":"\\..");return M+=D,I.length>0?`${I}${o.slice(M,k)}`:(o.charCodeAt(M)===u&&++M,o.slice(M,k))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=t.$gc.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===u){if(s.charCodeAt(1)===u){const f=s.charCodeAt(2);if(f!==w&&f!==g)return`\\\\?\\UNC\\${s.slice(2)}`}}else if($(s.charCodeAt(0))&&s.charCodeAt(1)===c&&s.charCodeAt(2)===u)return`\\\\?\\${s}`;return n},dirname(n){e(n,"path");const s=n.length;if(s===0)return".";let f=-1,o=0;const b=n.charCodeAt(0);if(s===1)return j(b)?n:".";if(j(b)){if(f=o=1,j(n.charCodeAt(1))){let M=2,k=M;for(;M<s&&!j(n.charCodeAt(M));)M++;if(M<s&&M!==k){for(k=M;M<s&&j(n.charCodeAt(M));)M++;if(M<s&&M!==k){for(k=M;M<s&&!j(n.charCodeAt(M));)M++;if(M===s)return n;M!==k&&(f=o=M+1)}}}}else $(b)&&n.charCodeAt(1)===c&&(f=s>2&&j(n.charCodeAt(2))?3:2,o=f);let A=-1,E=!0;for(let M=s-1;M>=o;--M)if(j(n.charCodeAt(M))){if(!E){A=M;break}}else E=!1;if(A===-1){if(f===-1)return".";A=f}return n.slice(0,A)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let f=0,o=-1,b=!0,A;if(n.length>=2&&$(n.charCodeAt(0))&&n.charCodeAt(1)===c&&(f=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let E=s.length-1,M=-1;for(A=n.length-1;A>=f;--A){const k=n.charCodeAt(A);if(j(k)){if(!b){f=A+1;break}}else M===-1&&(b=!1,M=A+1),E>=0&&(k===s.charCodeAt(E)?--E===-1&&(o=A):(E=-1,o=M))}return f===o?o=M:o===-1&&(o=n.length),n.slice(f,o)}for(A=n.length-1;A>=f;--A)if(j(n.charCodeAt(A))){if(!b){f=A+1;break}}else o===-1&&(b=!1,o=A+1);return o===-1?"":n.slice(f,o)},extname(n){e(n,"path");let s=0,f=-1,o=0,b=-1,A=!0,E=0;n.length>=2&&n.charCodeAt(1)===c&&$(n.charCodeAt(0))&&(s=o=2);for(let M=n.length-1;M>=s;--M){const k=n.charCodeAt(M);if(j(k)){if(!A){o=M+1;break}continue}b===-1&&(A=!1,b=M+1),k===g?f===-1?f=M:E!==1&&(E=1):f!==-1&&(E=-1)}return f===-1||b===-1||E===0||E===1&&f===b-1&&f===o+1?"":n.slice(f,b)},format:p.bind(null,"\\"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const f=n.length;let o=0,b=n.charCodeAt(0);if(f===1)return j(b)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(j(b)){if(o=1,j(n.charCodeAt(1))){let D=2,q=D;for(;D<f&&!j(n.charCodeAt(D));)D++;if(D<f&&D!==q){for(q=D;D<f&&j(n.charCodeAt(D));)D++;if(D<f&&D!==q){for(q=D;D<f&&!j(n.charCodeAt(D));)D++;D===f?o=D:D!==q&&(o=D+1)}}}}else if($(b)&&n.charCodeAt(1)===c){if(f<=2)return s.root=s.dir=n,s;if(o=2,j(n.charCodeAt(2))){if(f===3)return s.root=s.dir=n,s;o=3}}o>0&&(s.root=n.slice(0,o));let A=-1,E=o,M=-1,k=!0,S=n.length-1,x=0;for(;S>=o;--S){if(b=n.charCodeAt(S),j(b)){if(!k){E=S+1;break}continue}M===-1&&(k=!1,M=S+1),b===g?A===-1?A=S:x!==1&&(x=1):A!==-1&&(x=-1)}return M!==-1&&(A===-1||x===0||x===1&&A===M-1&&A===E+1?s.base=s.name=n.slice(E,M):(s.name=n.slice(E,A),s.base=n.slice(E,M),s.ext=n.slice(A,M))),E>0&&E!==o?s.dir=n.slice(0,E-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(P){const n=/\\/g;return()=>{const s=i.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>i.cwd()})();t.$hc={resolve(...n){let s="",f=!1;for(let o=n.length-1;o>=-1&&!f;o--){const b=o>=0?n[o]:l();e(b,"path"),b.length!==0&&(s=`${b}/${s}`,f=b.charCodeAt(0)===a)}return s=v(s,!f,"/",L),f?`/${s}`:s.length>0?s:"."},normalize(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===a,f=n.charCodeAt(n.length-1)===a;return n=v(n,!s,"/",L),n.length===0?s?"/":f?"./":".":(f&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return e(n,"path"),n.length>0&&n.charCodeAt(0)===a},join(...n){if(n.length===0)return".";let s;for(let f=0;f<n.length;++f){const o=n[f];e(o,"path"),o.length>0&&(s===void 0?s=o:s+=`/${o}`)}return s===void 0?".":t.$hc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s||(n=t.$hc.resolve(n),s=t.$hc.resolve(s),n===s))return"";const f=1,o=n.length,b=o-f,A=1,E=s.length-A,M=b<E?b:E;let k=-1,S=0;for(;S<M;S++){const D=n.charCodeAt(f+S);if(D!==s.charCodeAt(A+S))break;D===a&&(k=S)}if(S===M)if(E>M){if(s.charCodeAt(A+S)===a)return s.slice(A+S+1);if(S===0)return s.slice(A+S)}else b>M&&(n.charCodeAt(f+S)===a?k=S:S===0&&(k=0));let x="";for(S=f+k+1;S<=o;++S)(S===o||n.charCodeAt(S)===a)&&(x+=x.length===0?"..":"/..");return`${x}${s.slice(A+k)}`},toNamespacedPath(n){return n},dirname(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===a;let f=-1,o=!0;for(let b=n.length-1;b>=1;--b)if(n.charCodeAt(b)===a){if(!o){f=b;break}}else o=!1;return f===-1?s?"/":".":s&&f===1?"//":n.slice(0,f)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let f=0,o=-1,b=!0,A;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let E=s.length-1,M=-1;for(A=n.length-1;A>=0;--A){const k=n.charCodeAt(A);if(k===a){if(!b){f=A+1;break}}else M===-1&&(b=!1,M=A+1),E>=0&&(k===s.charCodeAt(E)?--E===-1&&(o=A):(E=-1,o=M))}return f===o?o=M:o===-1&&(o=n.length),n.slice(f,o)}for(A=n.length-1;A>=0;--A)if(n.charCodeAt(A)===a){if(!b){f=A+1;break}}else o===-1&&(b=!1,o=A+1);return o===-1?"":n.slice(f,o)},extname(n){e(n,"path");let s=-1,f=0,o=-1,b=!0,A=0;for(let E=n.length-1;E>=0;--E){const M=n.charCodeAt(E);if(M===a){if(!b){f=E+1;break}continue}o===-1&&(b=!1,o=E+1),M===g?s===-1?s=E:A!==1&&(A=1):s!==-1&&(A=-1)}return s===-1||o===-1||A===0||A===1&&s===o-1&&s===f+1?"":n.slice(s,o)},format:p.bind(null,"/"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const f=n.charCodeAt(0)===a;let o;f?(s.root="/",o=1):o=0;let b=-1,A=0,E=-1,M=!0,k=n.length-1,S=0;for(;k>=o;--k){const x=n.charCodeAt(k);if(x===a){if(!M){A=k+1;break}continue}E===-1&&(M=!1,E=k+1),x===g?b===-1?b=k:S!==1&&(S=1):b!==-1&&(S=-1)}if(E!==-1){const x=A===0&&f?1:A;b===-1||S===0||S===1&&b===E-1&&b===A+1?s.base=s.name=n.slice(x,E):(s.name=n.slice(x,b),s.base=n.slice(x,E),s.ext=n.slice(b,E))}return A>0?s.dir=n.slice(0,A-1):f&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=P?t.$gc.normalize:t.$hc.normalize,t.$jc=P?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=P?t.$gc.join:t.$hc.join,t.$lc=P?t.$gc.resolve:t.$hc.resolve,t.$mc=P?t.$gc.relative:t.$hc.relative,t.$nc=P?t.$gc.dirname:t.$hc.dirname,t.$oc=P?t.$gc.basename:t.$hc.basename,t.$pc=P?t.$gc.extname:t.$hc.extname,t.$qc=P?t.$gc.format:t.$hc.format,t.$rc=P?t.$gc.parse:t.$hc.parse,t.$sc=P?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=P?t.$gc.sep:t.$hc.sep,t.$uc=P?t.$gc.delimiter:t.$hc.delimiter}),ie(se[19],ue([0,1,68,18]),function(O,t,i,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=e,t.$xc=p;const R=/^\w[\w\d+.-]*$/,h=/^\//,N=/^\/\//;function g(o,b){if(!o.scheme&&b)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!R.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!h.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(o,b){return!o&&!b?"file":o}function u(o,b){switch(o){case"https":case"http":case"file":b?b[0]!==w&&(b=w+b):b=w;break}return b}const c="",w="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(b){return b instanceof m?!0:b?typeof b.authority=="string"&&typeof b.fragment=="string"&&typeof b.path=="string"&&typeof b.query=="string"&&typeof b.scheme=="string"&&typeof b.fsPath=="string"&&typeof b.with=="function"&&typeof b.toString=="function":!1}constructor(b,A,E,M,k,S=!1){typeof b=="object"?(this.scheme=b.scheme||c,this.authority=b.authority||c,this.path=b.path||c,this.query=b.query||c,this.fragment=b.fragment||c):(this.scheme=a(b,S),this.authority=A||c,this.path=u(this.scheme,E||c),this.query=M||c,this.fragment=k||c,g(this,S))}get fsPath(){return p(this,!1)}with(b){if(!b)return this;let{scheme:A,authority:E,path:M,query:k,fragment:S}=b;return A===void 0?A=this.scheme:A===null&&(A=c),E===void 0?E=this.authority:E===null&&(E=c),M===void 0?M=this.path:M===null&&(M=c),k===void 0?k=this.query:k===null&&(k=c),S===void 0?S=this.fragment:S===null&&(S=c),A===this.scheme&&E===this.authority&&M===this.path&&k===this.query&&S===this.fragment?this:new j(A,E,M,k,S)}static parse(b,A=!1){const E=d.exec(b);return E?new j(E[2]||c,f(E[4]||c),f(E[5]||c),f(E[7]||c),f(E[9]||c),A):new j(c,c,c,c,c)}static file(b){let A=c;if(y.$i&&(b=b.replace(/\\/g,w)),b[0]===w&&b[1]===w){const E=b.indexOf(w,2);E===-1?(A=b.substring(2),b=w):(A=b.substring(2,E),b=b.substring(E)||w)}return new j("file",A,b,c,c)}static from(b,A){return new j(b.scheme,b.authority,b.path,b.query,b.fragment,A)}static joinPath(b,...A){if(!b.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return y.$i&&b.scheme==="file"?E=m.file(i.$gc.join(p(b,!0),...A)).path:E=i.$hc.join(b.path,...A),b.with({path:E})}toString(b=!1){return l(this,b)}toJSON(){return this}static revive(b){if(b){if(b instanceof m)return b;{const A=new j(b);return A._formatted=b.external??null,A._fsPath=b._sep===P?b.fsPath??null:null,A}}else return b}}t.URI=m;function e(o){return!o||typeof o!="object"?!1:typeof o.scheme=="string"&&(typeof o.authority=="string"||typeof o.authority>"u")&&(typeof o.path=="string"||typeof o.path>"u")&&(typeof o.query=="string"||typeof o.query>"u")&&(typeof o.fragment=="string"||typeof o.fragment>"u")}const P=y.$i?1:void 0;class j extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(b=!1){return b?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const b={$mid:1};return this._fsPath&&(b.fsPath=this._fsPath,b._sep=P),this._formatted&&(b.external=this._formatted),this.path&&(b.path=this.path),this.scheme&&(b.scheme=this.scheme),this.authority&&(b.authority=this.authority),this.query&&(b.query=this.query),this.fragment&&(b.fragment=this.fragment),b}}const L={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function $(o,b,A){let E,M=-1;for(let k=0;k<o.length;k++){const S=o.charCodeAt(k);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||b&&S===47||A&&S===91||A&&S===93||A&&S===58)M!==-1&&(E+=encodeURIComponent(o.substring(M,k)),M=-1),E!==void 0&&(E+=o.charAt(k));else{E===void 0&&(E=o.substr(0,k));const x=L[S];x!==void 0?(M!==-1&&(E+=encodeURIComponent(o.substring(M,k)),M=-1),E+=x):M===-1&&(M=k)}}return M!==-1&&(E+=encodeURIComponent(o.substring(M))),E!==void 0?E:o}function v(o){let b;for(let A=0;A<o.length;A++){const E=o.charCodeAt(A);E===35||E===63?(b===void 0&&(b=o.substr(0,A)),b+=L[E]):b!==void 0&&(b+=o[A])}return b!==void 0?b:o}function p(o,b){let A;return o.authority&&o.path.length>1&&o.scheme==="file"?A=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?b?A=o.path.substr(1):A=o.path[1].toLowerCase()+o.path.substr(2):A=o.path,y.$i&&(A=A.replace(/\//g,"\\")),A}function l(o,b){const A=b?v:$;let E="",{scheme:M,authority:k,path:S,query:x,fragment:D}=o;if(M&&(E+=M,E+=":"),(k||M==="file")&&(E+=w,E+=w),k){let q=k.indexOf("@");if(q!==-1){const I=k.substr(0,q);k=k.substr(q+1),q=I.lastIndexOf(":"),q===-1?E+=A(I,!1,!1):(E+=A(I.substr(0,q),!1,!1),E+=":",E+=A(I.substr(q+1),!1,!0)),E+="@"}k=k.toLowerCase(),q=k.lastIndexOf(":"),q===-1?E+=A(k,!1,!0):(E+=A(k.substr(0,q),!1,!0),E+=k.substr(q))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const q=S.charCodeAt(1);q>=65&&q<=90&&(S=`/${String.fromCharCode(q+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const q=S.charCodeAt(0);q>=65&&q<=90&&(S=`${String.fromCharCode(q+32)}:${S.substr(2)}`)}E+=A(S,!0,!1)}return x&&(E+="?",E+=A(x,!1,!1)),D&&(E+="#",E+=b?D:$(D,!1,!1)),E}function n(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+n(o.substr(3)):o}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function f(o){return o.match(s)?o.replace(s,b=>n(b)):o}}),ie(se[73],ue([0,1,3,11,10,15,18,7]),function(O,t,i,y,R,h,N,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=c,t.create=s;const a="$initialize";let u=!1;function c(f){N.$o&&(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(f.message))}var w;(function(f){f[f.Request=0]="Request",f[f.Reply=1]="Reply",f[f.SubscribeEvent=2]="SubscribeEvent",f[f.Event=3]="Event",f[f.UnsubscribeEvent=4]="UnsubscribeEvent"})(w||(w={}));class d{constructor(o,b,A,E){this.vsWorker=o,this.req=b,this.method=A,this.args=E,this.type=0}}class m{constructor(o,b,A,E){this.vsWorker=o,this.seq=b,this.res=A,this.err=E,this.type=1}}class e{constructor(o,b,A,E){this.vsWorker=o,this.req=b,this.eventName=A,this.arg=E,this.type=2}}class P{constructor(o,b,A){this.vsWorker=o,this.req=b,this.event=A,this.type=3}}class j{constructor(o,b){this.vsWorker=o,this.req=b,this.type=4}}class L{constructor(o){this.a=-1,this.g=o,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(o){this.a=o}sendMessage(o,b){const A=String(++this.b);return new Promise((E,M)=>{this.c[A]={resolve:E,reject:M},this.o(new d(this.a,A,o,b))})}listen(o,b){let A=null;const E=new y.$ee({onWillAddFirstListener:()=>{A=String(++this.b),this.d.set(A,E),this.o(new e(this.a,A,o,b))},onDidRemoveLastListener:()=>{this.d.delete(A),this.o(new j(this.a,A)),A=null}});return E.event}handleMessage(o){!o||!o.vsWorker||this.a!==-1&&o.vsWorker!==this.a||this.h(o)}h(o){switch(o.type){case 1:return this.j(o);case 0:return this.k(o);case 2:return this.l(o);case 3:return this.m(o);case 4:return this.n(o)}}j(o){if(!this.c[o.seq]){console.warn("Got reply to unknown seq");return}const b=this.c[o.seq];if(delete this.c[o.seq],o.err){let A=o.err;o.err.$isError&&(A=new Error,A.name=o.err.name,A.message=o.err.message,A.stack=o.err.stack),b.reject(A);return}b.resolve(o.res)}k(o){const b=o.req;this.g.handleMessage(o.method,o.args).then(E=>{this.o(new m(this.a,b,E,void 0))},E=>{E.detail instanceof Error&&(E.detail=(0,i.$3)(E.detail)),this.o(new m(this.a,b,void 0,(0,i.$3)(E)))})}l(o){const b=o.req,A=this.g.handleEvent(o.eventName,o.arg)(E=>{this.o(new P(this.a,b,E))});this.f.set(b,A)}m(o){if(!this.d.has(o.req)){console.warn("Got event for unknown req");return}this.d.get(o.req).fire(o.event)}n(o){if(!this.f.has(o.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(o.req).dispose(),this.f.delete(o.req)}o(o){const b=[];if(o.type===0)for(let A=0;A<o.args.length;A++)o.args[A]instanceof ArrayBuffer&&b.push(o.args[A]);else o.type===1&&o.res instanceof ArrayBuffer&&b.push(o.res);this.g.sendMessage(o,b)}}class $ extends R.$Vc{constructor(o,b,A){super();let E=null;this.a=this.B(o.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{E?.(q)})),this.c=new L({sendMessage:(q,I)=>{this.a.postMessage(q,I)},handleMessage:(q,I)=>{if(typeof A[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(A[q].apply(A,I))}catch(z){return Promise.reject(z)}},handleEvent:(q,I)=>{if(p(q)){const z=A[q].call(A,I);if(typeof z!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return z}if(v(q)){const z=A[q];if(typeof z!="function")throw new Error(`Missing event ${q} on main thread host.`);return z}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let M=null;const k=globalThis.require;typeof k<"u"&&typeof k.getConfig=="function"?M=k.getConfig():typeof globalThis.requirejs<"u"&&(M=globalThis.requirejs.s.contexts._.config);const S=(0,h.$_n)(A);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(M)),b,S]);const x=(q,I)=>this.g(q,I),D=(q,I)=>this.c.listen(q,I);this.f=new Promise((q,I)=>{E=I,this.b.then(z=>{q(l(z,x,D))},z=>{I(z),this.h("Worker failed to load "+b,z)})})}getProxyObject(){return this.f}g(o,b){return new Promise((A,E)=>{this.b.then(()=>{this.c.sendMessage(o,b).then(A,E)},E)})}h(o,b){console.error(o),console.info(b)}}t.SimpleWorkerClient=$;function v(f){return f[0]==="o"&&f[1]==="n"&&g.$wf(f.charCodeAt(2))}function p(f){return/^onDynamic/.test(f)&&g.$wf(f.charCodeAt(9))}function l(f,o,b){const A=k=>function(){const S=Array.prototype.slice.call(arguments,0);return o(k,S)},E=k=>function(S){return b(k,S)},M={};for(const k of f){if(p(k)){M[k]=E(k);continue}if(v(k)){M[k]=b(k,void 0);continue}M[k]=A(k)}return M}class n{constructor(o,b){this.a=b,this.b=null,this.c=new L({sendMessage:(A,E)=>{o(A,E)},handleMessage:(A,E)=>this.d(A,E),handleEvent:(A,E)=>this.f(A,E)})}onmessage(o){this.c.handleMessage(o)}d(o,b){if(o===a)return this.g(b[0],b[1],b[2],b[3]);if(!this.b||typeof this.b[o]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+o));try{return Promise.resolve(this.b[o].apply(this.b,b))}catch(A){return Promise.reject(A)}}f(o,b){if(!this.b)throw new Error("Missing requestHandler");if(p(o)){const A=this.b[o].call(this.b,b);if(typeof A!="function")throw new Error(`Missing dynamic event ${o} on request handler.`);return A}if(v(o)){const A=this.b[o];if(typeof A!="function")throw new Error(`Missing event ${o} on request handler.`);return A}throw new Error(`Malformed event name ${o}`)}g(o,b,A,E){this.c.setWorkerId(o);const S=l(E,(x,D)=>this.c.sendMessage(x,D),(x,D)=>this.c.listen(x,D));return this.a?(this.b=this.a(S),Promise.resolve((0,h.$_n)(this.b))):(b&&(typeof b.baseUrl<"u"&&delete b.baseUrl,typeof b.paths<"u"&&typeof b.paths.vs<"u"&&delete b.paths.vs,typeof b.trustedTypesPolicy<"u"&&delete b.trustedTypesPolicy,b.catchError=!0,globalThis.require.config(b)),new Promise((x,D)=>{(globalThis.require||O)([A],I=>{if(this.b=I.create(S),!this.b){D(new Error("No RequestHandler!"));return}x((0,h.$_n)(this.b))},D)}))}}t.SimpleWorkerServer=n;function s(f){return new n(f,null)}}),ie(se[69],ue([65,66]),function(O,t){return O.create("vs/editor/common/languages",t)}),ie(se[70],ue([0,1,43,19,44,2,63,69]),function(O,t,i,y,R,h,N,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.$eu=t.$du=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadApplicability=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTag=t.$cu=t.$bu=t.SymbolKinds=t.SymbolTag=t.$_t=t.SymbolKind=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.DocumentPasteTriggerKind=t.CodeActionTriggerType=t.$0t=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.PartialAcceptTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.HoverVerbosityAction=t.$9t=t.$8t=t.$7t=void 0,t.$$t=f,t.$au=b;class a{constructor(H,he,le){this.offset=H,this.type=he,this.language=le,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$7t=a;class u{constructor(H,he){this.tokens=H,this.endState=he,this._tokenizationResultBrand=void 0}}t.$8t=u;class c{constructor(H,he){this.tokens=H,this.endState=he,this._encodedTokenizationResultBrand=void 0}}t.$9t=c;var w;(function(F){F[F.Increase=0]="Increase",F[F.Decrease=1]="Decrease"})(w||(t.HoverVerbosityAction=w={}));var d;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(d||(t.CompletionItemKind=d={}));var m;(function(F){const H=new Map;H.set(0,i.$Uj.symbolMethod),H.set(1,i.$Uj.symbolFunction),H.set(2,i.$Uj.symbolConstructor),H.set(3,i.$Uj.symbolField),H.set(4,i.$Uj.symbolVariable),H.set(5,i.$Uj.symbolClass),H.set(6,i.$Uj.symbolStruct),H.set(7,i.$Uj.symbolInterface),H.set(8,i.$Uj.symbolModule),H.set(9,i.$Uj.symbolProperty),H.set(10,i.$Uj.symbolEvent),H.set(11,i.$Uj.symbolOperator),H.set(12,i.$Uj.symbolUnit),H.set(13,i.$Uj.symbolValue),H.set(15,i.$Uj.symbolEnum),H.set(14,i.$Uj.symbolConstant),H.set(15,i.$Uj.symbolEnum),H.set(16,i.$Uj.symbolEnumMember),H.set(17,i.$Uj.symbolKeyword),H.set(27,i.$Uj.symbolSnippet),H.set(18,i.$Uj.symbolText),H.set(19,i.$Uj.symbolColor),H.set(20,i.$Uj.symbolFile),H.set(21,i.$Uj.symbolReference),H.set(22,i.$Uj.symbolCustomColor),H.set(23,i.$Uj.symbolFolder),H.set(24,i.$Uj.symbolTypeParameter),H.set(25,i.$Uj.account),H.set(26,i.$Uj.issues);function he(r){let Le=H.get(r);return Le||(console.info("No codicon found for CompletionItemKind "+r),Le=i.$Uj.symbolProperty),Le}F.toIcon=he;const le=new Map;le.set("method",0),le.set("function",1),le.set("constructor",2),le.set("field",3),le.set("variable",4),le.set("class",5),le.set("struct",6),le.set("interface",7),le.set("module",8),le.set("property",9),le.set("event",10),le.set("operator",11),le.set("unit",12),le.set("value",13),le.set("constant",14),le.set("enum",15),le.set("enum-member",16),le.set("enumMember",16),le.set("keyword",17),le.set("snippet",27),le.set("text",18),le.set("color",19),le.set("file",20),le.set("reference",21),le.set("customcolor",22),le.set("folder",23),le.set("type-parameter",24),le.set("typeParameter",24),le.set("account",25),le.set("issue",26);function be(r,Le){let je=le.get(r);return typeof je>"u"&&!Le&&(je=9),je}F.fromString=be})(m||(t.CompletionItemKinds=m={}));var e;(function(F){F[F.Deprecated=1]="Deprecated"})(e||(t.CompletionItemTag=e={}));var P;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(P||(t.CompletionItemInsertTextRule=P={}));var j;(function(F){F[F.Word=0]="Word",F[F.Line=1]="Line",F[F.Suggest=2]="Suggest"})(j||(t.PartialAcceptTriggerKind=j={}));var L;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L||(t.CompletionTriggerKind=L={}));var $;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})($||(t.InlineCompletionTriggerKind=$={}));class v{constructor(H,he,le,be){this.range=H,this.text=he,this.completionKind=le,this.isSnippetText=be}equals(H){return h.$tt.lift(this.range).equalsRange(H.range)&&this.text===H.text&&this.completionKind===H.completionKind&&this.isSnippetText===H.isSnippetText}}t.$0t=v;var p;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(p||(t.CodeActionTriggerType=p={}));var l;(function(F){F[F.Automatic=0]="Automatic",F[F.PasteAs=1]="PasteAs"})(l||(t.DocumentPasteTriggerKind=l={}));var n;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(n||(t.SignatureHelpTriggerKind=n={}));var s;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(s||(t.DocumentHighlightKind=s={}));function f(F){return F&&y.URI.isUri(F.uri)&&h.$tt.isIRange(F.range)&&(h.$tt.isIRange(F.originSelectionRange)||h.$tt.isIRange(F.targetSelectionRange))}var o;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(o||(t.SymbolKind=o={})),t.$_t={17:(0,g.localize)(0,null),16:(0,g.localize)(1,null),4:(0,g.localize)(2,null),13:(0,g.localize)(3,null),8:(0,g.localize)(4,null),9:(0,g.localize)(5,null),21:(0,g.localize)(6,null),23:(0,g.localize)(7,null),7:(0,g.localize)(8,null),0:(0,g.localize)(9,null),11:(0,g.localize)(10,null),10:(0,g.localize)(11,null),19:(0,g.localize)(12,null),5:(0,g.localize)(13,null),1:(0,g.localize)(14,null),2:(0,g.localize)(15,null),20:(0,g.localize)(16,null),15:(0,g.localize)(17,null),18:(0,g.localize)(18,null),24:(0,g.localize)(19,null),3:(0,g.localize)(20,null),6:(0,g.localize)(21,null),14:(0,g.localize)(22,null),22:(0,g.localize)(23,null),25:(0,g.localize)(24,null),12:(0,g.localize)(25,null)};function b(F,H){return(0,g.localize)(26,null,F,t.$_t[H])}var A;(function(F){F[F.Deprecated=1]="Deprecated"})(A||(t.SymbolTag=A={}));var E;(function(F){const H=new Map;H.set(0,i.$Uj.symbolFile),H.set(1,i.$Uj.symbolModule),H.set(2,i.$Uj.symbolNamespace),H.set(3,i.$Uj.symbolPackage),H.set(4,i.$Uj.symbolClass),H.set(5,i.$Uj.symbolMethod),H.set(6,i.$Uj.symbolProperty),H.set(7,i.$Uj.symbolField),H.set(8,i.$Uj.symbolConstructor),H.set(9,i.$Uj.symbolEnum),H.set(10,i.$Uj.symbolInterface),H.set(11,i.$Uj.symbolFunction),H.set(12,i.$Uj.symbolVariable),H.set(13,i.$Uj.symbolConstant),H.set(14,i.$Uj.symbolString),H.set(15,i.$Uj.symbolNumber),H.set(16,i.$Uj.symbolBoolean),H.set(17,i.$Uj.symbolArray),H.set(18,i.$Uj.symbolObject),H.set(19,i.$Uj.symbolKey),H.set(20,i.$Uj.symbolNull),H.set(21,i.$Uj.symbolEnumMember),H.set(22,i.$Uj.symbolStruct),H.set(23,i.$Uj.symbolEvent),H.set(24,i.$Uj.symbolOperator),H.set(25,i.$Uj.symbolTypeParameter);function he(le){let be=H.get(le);return be||(console.info("No codicon found for SymbolKind "+le),be=i.$Uj.symbolProperty),be}F.toIcon=he})(E||(t.SymbolKinds=E={}));class M{static asEditOperation(H){return R.$ut.replace(h.$tt.lift(H.range),H.text)}}t.$bu=M;class k{static{this.Comment=new k("comment")}static{this.Imports=new k("imports")}static{this.Region=new k("region")}static fromValue(H){switch(H){case"comment":return k.Comment;case"imports":return k.Imports;case"region":return k.Region}return new k(H)}constructor(H){this.value=H}}t.$cu=k;var S;(function(F){F[F.AIGenerated=1]="AIGenerated"})(S||(t.NewSymbolNameTag=S={}));var x;(function(F){function H(he){return!he||typeof he!="object"?!1:typeof he.id=="string"&&typeof he.title=="string"}F.is=H})(x||(t.Command=x={}));var D;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(D||(t.CommentThreadCollapsibleState=D={}));var q;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(q||(t.CommentThreadState=q={}));var I;(function(F){F[F.Current=0]="Current",F[F.Outdated=1]="Outdated"})(I||(t.CommentThreadApplicability=I={}));var z;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(z||(t.CommentMode=z={}));var Z;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(Z||(t.CommentState=Z={}));var Q;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(Q||(t.InlayHintKind=Q={}));class J{constructor(H){this.b=H,this.a=null}dispose(){this.a&&this.a.then(H=>{H&&H.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$du=J,t.$eu=new N.$Vt;var X;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(X||(t.ExternalUriOpenerPriority=X={}));var K;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(K||(t.InlineEditTriggerKind=K={}))}),ie(se[71],ue([0,1,24,11,38,19,5,2,45,70,62]),function(O,t,i,y,R,h,N,g,a,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$m3=void 0,t.$n3=d;class w{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,P){return(0,R.$Dr)(e,P)}}t.$m3=w;function d(){return{editor:void 0,languages:void 0,CancellationTokenSource:i.$pe,Emitter:y.$ee,KeyCode:c.KeyCode,KeyMod:w,Position:N.$st,Range:g.$tt,Selection:a.$vt,SelectionDirection:c.SelectionDirection,MarkerSeverity:c.MarkerSeverity,MarkerTag:c.MarkerTag,Uri:h.URI,Token:u.$7t}}}),ie(se[74],ue([0,1,25,19,5,2,58,30,54,55,71,23,61,34,52,15,3,53,60]),function(O,t,i,y,R,h,N,g,a,u,c,w,d,m,e,P,j,L,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorSimpleWorker=void 0,t.create=l;class v extends N.$Yv{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(s){const f=[];for(let o=0;o<this.f.length;o++){const b=this.f[o],A=this.offsetAt(new R.$st(o+1,1)),E=b.matchAll(s);for(const M of E)(M.index||M.index===0)&&(M.index=M.index+A),f.push(M)}return f}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(s){return this.f[s-1]}getWordAtPosition(s,f){const o=(0,g.$8s)(s.column,(0,g.$6s)(f),this.f[s.lineNumber-1],0);return o?new h.$tt(s.lineNumber,o.startColumn,s.lineNumber,o.endColumn):null}getWordUntilPosition(s,f){const o=this.getWordAtPosition(s,f);return o?{word:this.f[s.lineNumber-1].substring(o.startColumn-1,s.column-1),startColumn:o.startColumn,endColumn:s.column}:{word:"",startColumn:s.column,endColumn:s.column}}words(s){const f=this.f,o=this.q.bind(this);let b=0,A="",E=0,M=[];return{*[Symbol.iterator](){for(;;)if(E<M.length){const k=A.substring(M[E].start,M[E].end);E+=1,yield k}else if(b<f.length)A=f[b],M=o(A,s),E=0,b+=1;else break}}}getLineWords(s,f){const o=this.f[s-1],b=this.q(o,f),A=[];for(const E of b)A.push({word:o.substring(E.start,E.end),startColumn:E.start+1,endColumn:E.end+1});return A}q(s,f){const o=[];let b;for(f.lastIndex=0;(b=f.exec(s))&&b[0].length!==0;)o.push({start:b.index,end:b.index+b[0].length});return o}getValueInRange(s){if(s=this.r(s),s.startLineNumber===s.endLineNumber)return this.f[s.startLineNumber-1].substring(s.startColumn-1,s.endColumn-1);const f=this.g,o=s.startLineNumber-1,b=s.endLineNumber-1,A=[];A.push(this.f[o].substring(s.startColumn-1));for(let E=o+1;E<b;E++)A.push(this.f[E]);return A.push(this.f[b].substring(0,s.endColumn-1)),A.join(f)}offsetAt(s){return s=this.s(s),this.l(),this.j.getPrefixSum(s.lineNumber-2)+(s.column-1)}positionAt(s){s=Math.floor(s),s=Math.max(0,s),this.l();const f=this.j.getIndexOf(s),o=this.f[f.index].length;return{lineNumber:1+f.index,column:1+Math.min(f.remainder,o)}}r(s){const f=this.s({lineNumber:s.startLineNumber,column:s.startColumn}),o=this.s({lineNumber:s.endLineNumber,column:s.endColumn});return f.lineNumber!==s.startLineNumber||f.column!==s.startColumn||o.lineNumber!==s.endLineNumber||o.column!==s.endColumn?{startLineNumber:f.lineNumber,startColumn:f.column,endLineNumber:o.lineNumber,endColumn:o.column}:s}s(s){if(!R.$st.isIPosition(s))throw new Error("bad position");let{lineNumber:f,column:o}=s,b=!1;if(f<1)f=1,o=1,b=!0;else if(f>this.f.length)f=this.f.length,o=this.f[f-1].length+1,b=!0;else{const A=this.f[f-1].length+1;o<1?(o=1,b=!0):o>A&&(o=A,b=!0)}return b?{lineNumber:f,column:o}:s}}class p{constructor(s,f){this.d=s,this.f=Object.create(null),this.g=f,this.h=null}dispose(){this.f=Object.create(null)}j(s){return this.f[s]}k(){const s=[];return Object.keys(this.f).forEach(f=>s.push(this.f[f])),s}acceptNewModel(s){this.f[s.url]=new v(y.URI.parse(s.url),s.lines,s.EOL,s.versionId)}acceptModelChanged(s,f){if(!this.f[s])return;this.f[s].onEvents(f)}acceptRemovedModel(s){this.f[s]&&delete this.f[s]}async computeUnicodeHighlights(s,f,o){const b=this.j(s);return b?d.$h3.computeUnicodeHighlights(b,f,o):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(s,f){const o=this.j(s);return o?(0,$.$L3)(o,f):[]}async computeDiff(s,f,o,b){const A=this.j(s),E=this.j(f);return!A||!E?null:p.l(A,E,o,b)}static l(s,f,o,b){const A=b==="advanced"?e.$J3.getDefault():e.$J3.getLegacy(),E=s.getLinesContent(),M=f.getLinesContent(),k=A.computeDiff(E,M,o),S=k.changes.length>0?!1:this.n(s,f);function x(D){return D.map(q=>[q.original.startLineNumber,q.original.endLineNumberExclusive,q.modified.startLineNumber,q.modified.endLineNumberExclusive,q.innerChanges?.map(I=>[I.originalRange.startLineNumber,I.originalRange.startColumn,I.originalRange.endLineNumber,I.originalRange.endColumn,I.modifiedRange.startLineNumber,I.modifiedRange.startColumn,I.modifiedRange.endLineNumber,I.modifiedRange.endColumn])])}return{identical:S,quitEarly:k.hitTimeout,changes:x(k.changes),moves:k.moves.map(D=>[D.lineRangeMapping.original.startLineNumber,D.lineRangeMapping.original.endLineNumberExclusive,D.lineRangeMapping.modified.startLineNumber,D.lineRangeMapping.modified.endLineNumberExclusive,x(D.changes)])}}static n(s,f){const o=s.getLineCount(),b=f.getLineCount();if(o!==b)return!1;for(let A=1;A<=o;A++){const E=s.getLineContent(A),M=f.getLineContent(A);if(E!==M)return!1}return!0}async computeDirtyDiff(s,f,o){const b=this.j(s),A=this.j(f);if(!b||!A)return null;const E=b.getLinesContent(),M=A.getLinesContent();return new m.$Sv(E,M,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:o,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(s,f,o){const b=this.j(s);if(!b)return f;const A=[];let E;f=f.slice(0).sort((k,S)=>{if(k.range&&S.range)return h.$tt.compareRangesUsingStarts(k.range,S.range);const x=k.range?0:1,D=S.range?0:1;return x-D});let M=0;for(let k=1;k<f.length;k++)h.$tt.getEndPosition(f[M].range).equals(h.$tt.getStartPosition(f[k].range))?(f[M].range=h.$tt.fromPositions(h.$tt.getStartPosition(f[M].range),h.$tt.getEndPosition(f[k].range)),f[M].text+=f[k].text):(M++,f[M]=f[k]);f.length=M+1;for(let{range:k,text:S,eol:x}of f){if(typeof x=="number"&&(E=x),h.$tt.isEmpty(k)&&!S)continue;const D=b.getValueInRange(k);if(S=S.replace(/\r\n|\n|\r/g,b.eol),D===S)continue;if(Math.max(S.length,D.length)>p.o){A.push({range:k,text:S});continue}const q=(0,i.$yt)(D,S,o),I=b.offsetAt(h.$tt.lift(k).getStartPosition());for(const z of q){const Z=b.positionAt(I+z.originalStart),Q=b.positionAt(I+z.originalStart+z.originalLength),J={text:S.substr(z.modifiedStart,z.modifiedLength),range:{startLineNumber:Z.lineNumber,startColumn:Z.column,endLineNumber:Q.lineNumber,endColumn:Q.column}};b.getValueInRange(J.range)!==J.text&&A.push(J)}}return typeof E=="number"&&A.push({eol:E,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),A}computeHumanReadableDiff(s,f,o){const b=this.j(s);if(!b)return f;const A=[];let E;f=f.slice(0).sort((M,k)=>{if(M.range&&k.range)return h.$tt.compareRangesUsingStarts(M.range,k.range);const S=M.range?0:1,x=k.range?0:1;return S-x});for(let{range:M,text:k,eol:S}of f){let Z=function(J,X){return new R.$st(J.lineNumber+X.lineNumber-1,X.lineNumber===1?J.column+X.column-1:X.column)},Q=function(J,X){const K=[];for(let F=X.startLineNumber;F<=X.endLineNumber;F++){const H=J[F-1];F===X.startLineNumber&&F===X.endLineNumber?K.push(H.substring(X.startColumn-1,X.endColumn-1)):F===X.startLineNumber?K.push(H.substring(X.startColumn-1)):F===X.endLineNumber?K.push(H.substring(0,X.endColumn-1)):K.push(H)}return K};if(typeof S=="number"&&(E=S),h.$tt.isEmpty(M)&&!k)continue;const x=b.getValueInRange(M);if(k=k.replace(/\r\n|\n|\r/g,b.eol),x===k)continue;if(Math.max(k.length,x.length)>p.o){A.push({range:M,text:k});continue}const D=x.split(/\r\n|\n|\r/),q=k.split(/\r\n|\n|\r/),I=e.$J3.getDefault().computeDiff(D,q,o),z=h.$tt.lift(M).getStartPosition();for(const J of I.changes)if(J.innerChanges)for(const X of J.innerChanges)A.push({range:h.$tt.fromPositions(Z(z,X.originalRange.getStartPosition()),Z(z,X.originalRange.getEndPosition())),text:Q(q,X.modifiedRange).join(b.eol)});else throw new j.$cb("The experimental diff algorithm always produces inner changes")}return typeof E=="number"&&A.push({eol:E,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),A}async computeLinks(s){const f=this.j(s);return f?(0,a.$k3)(f):null}async computeDefaultDocumentColors(s){const f=this.j(s);return f?(0,L.$K3)(f):null}static{this.p=1e4}async textualSuggest(s,f,o,b){const A=new w.$ae,E=new RegExp(o,b),M=new Set;e:for(const k of s){const S=this.j(k);if(S){for(const x of S.words(E))if(!(x===f||!isNaN(Number(x)))&&(M.add(x),M.size>p.p))break e}}return{words:Array.from(M),duration:A.elapsed()}}async computeWordRanges(s,f,o,b){const A=this.j(s);if(!A)return Object.create(null);const E=new RegExp(o,b),M=Object.create(null);for(let k=f.startLineNumber;k<f.endLineNumber;k++){const S=A.getLineWords(k,E);for(const x of S){if(!isNaN(Number(x.word)))continue;let D=M[x.word];D||(D=[],M[x.word]=D),D.push({startLineNumber:k,startColumn:x.startColumn,endLineNumber:k,endColumn:x.endColumn})}}return M}async navigateValueSet(s,f,o,b,A){const E=this.j(s);if(!E)return null;const M=new RegExp(b,A);f.startColumn===f.endColumn&&(f={startLineNumber:f.startLineNumber,startColumn:f.startColumn,endLineNumber:f.endLineNumber,endColumn:f.endColumn+1});const k=E.getValueInRange(f),S=E.getWordAtPosition({lineNumber:f.startLineNumber,column:f.startColumn},M);if(!S)return null;const x=E.getValueInRange(S);return u.$l3.INSTANCE.navigateValueSet(f,k,S,x,o)}loadForeignModule(s,f,o){const b=(M,k)=>this.d.fhr(M,k),E={host:(0,P.$ao)(o,b),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(E,f),Promise.resolve((0,P.$_n)(this.h))):new Promise((M,k)=>{O([s],S=>{this.h=S.create(E,f),M((0,P.$_n)(this.h))},k)})}fmr(s,f){if(!this.h||typeof this.h[s]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+s));try{return Promise.resolve(this.h[s].apply(this.h,f))}catch(o){return Promise.reject(o)}}}t.EditorSimpleWorker=p;function l(n){return new p(n,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,c.$n3)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5ae5a741bdb676abb667fd4896dc2a40e313db3a/core/vs/base/worker/workerMain.js.map
