/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/files/common/files","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ce=function(ne){for(var e=[],A=0,N=ne.length;A<N;A++)e[A]=ae[ne[A]];return e};define(ae[124],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class A{static get(){const L=new Map,j=new Map,O=new Map,R=new Map;function C(h,c){h.has(c.detail)||h.set(c.detail,-c.timestamp)}function f(h,c){const p=h.get(c.detail);p&&(p>=0||h.set(c.detail,p+c.timestamp))}let E=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(E=ne.getStats().slice(0).sort((h,c)=>h.timestamp-c.timestamp));for(const h of E)switch(h.type){case 10:C(L,h);break;case 11:case 12:f(L,h);break;case 21:C(j,h);break;case 22:f(j,h);break;case 33:C(O,h);break;case 34:f(O,h);break;case 31:C(R,h);break;case 32:f(R,h);break}let y=0;O.forEach(h=>y+=h);function w(h){const c=[];return h.forEach((p,g)=>c.push([g,p])),c}return{amdLoad:w(L),amdInvoke:w(j),nodeRequire:w(O),nodeEval:w(R),nodeRequireTotal:y}}static toMarkdownTable(L,j){let O="";const R=[];return L.forEach((C,f)=>{R[f]=C.length}),j.forEach(C=>{C.forEach((f,E)=>{typeof f>"u"&&(f=C[E]="-");const y=f.toString().length;R[E]=Math.max(y,R[E])})}),L.forEach((C,f)=>{O+=`| ${C+" ".repeat(R[f]-C.toString().length)} `}),O+=`|
`,L.forEach((C,f)=>{O+=`| ${"-".repeat(R[f])} `}),O+=`|
`,j.forEach(C=>{C.forEach((f,E)=>{typeof f<"u"&&(O+=`| ${f+" ".repeat(R[E]-f.toString().length)} `)}),O+=`|
`}),O}}e.$U=A}),define(ae[125],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=A,e.$gb=N,e.$hb=L,e.$ib=j,e.$jb=O,e.$kb=R,e.$lb=C,e.$nb=E,e.$ob=y,e.$pb=w,e.$qb=h,e.$rb=c;function A(p,g){const l=N(p,g);if(l!==-1)return p[l]}function N(p,g,l=p.length-1){for(let u=l;u>=0;u--){const m=p[u];if(g(m))return u}return-1}function L(p,g){const l=j(p,g);return l===-1?void 0:p[l]}function j(p,g,l=0,u=p.length){let m=l,d=u;for(;m<d;){const $=Math.floor((m+d)/2);g(p[$])?m=$+1:d=$}return m-1}function O(p,g){const l=R(p,g);return l===p.length?void 0:p[l]}function R(p,g,l=0,u=p.length){let m=l,d=u;for(;m<d;){const $=Math.floor((m+d)/2);g(p[$])?d=$:m=$+1}return m}function C(p,g,l=0,u=p.length){const m=R(p,g,l,u);return m===p.length?-1:m}class f{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(f.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!g(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const l=j(this.e,g,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$mb=f;function E(p,g){if(p.length===0)return;let l=p[0];for(let u=1;u<p.length;u++){const m=p[u];g(m,l)>0&&(l=m)}return l}function y(p,g){if(p.length===0)return;let l=p[0];for(let u=1;u<p.length;u++){const m=p[u];g(m,l)>=0&&(l=m)}return l}function w(p,g){return E(p,(l,u)=>-g(l,u))}function h(p,g){if(p.length===0)return-1;let l=0;for(let u=1;u<p.length;u++){const m=p[u];g(m,p[l])>0&&(l=u)}return l}function c(p,g){for(const l of p){const u=g(l);if(u!==void 0)return u}}}),define(ae[126],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=A,e.$L=N,e.$M=L,e.$N=j;function A(O,R){const C=Object.create(null);for(const f of O){const E=R(f);let y=C[E];y||(y=C[E]=[]),y.push(f)}return C}function N(O,R){const C=[],f=[];for(const E of O)R.has(E)||C.push(E);for(const E of R)O.has(E)||f.push(E);return{removed:C,added:f}}function L(O,R){const C=[],f=[];for(const[E,y]of O)R.has(E)||C.push(y);for(const[E,y]of R)O.has(E)||f.push(y);return{removed:C,added:f}}function j(O,R){const C=new Set;for(const f of R)O.has(f)&&C.add(f);return C}}),define(ae[84],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=N,e.$1h=L,e.$2h=j;function A(O){return(R,C,f)=>{let E=null,y=null;if(typeof f.value=="function"?(E="value",y=f.value):typeof f.get=="function"&&(E="get",y=f.get),!y)throw new Error("not supported");f[E]=O(y,C)}}function N(O,R,C){let f=null,E=null;if(typeof C.value=="function"?(f="value",E=C.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(f="get",E=C.get),!E)throw new Error("not supported");const y=`$memoize$${R}`;C[f]=function(...w){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,w)}),this[y]}}function L(O,R,C){return A((f,E)=>{const y=`$debounce$${E}`,w=`$debounce$result$${E}`;return function(...h){this[w]||(this[w]=C?C():void 0),clearTimeout(this[y]),R&&(this[w]=R(this[w],...h),h=[this[w]]),this[y]=setTimeout(()=>{f.apply(this,h),this[w]=C?C():void 0},O)}})}function j(O,R,C){return A((f,E)=>{const y=`$throttle$timer$${E}`,w=`$throttle$result$${E}`,h=`$throttle$lastRun$${E}`,c=`$throttle$pending$${E}`;return function(...p){if(this[w]||(this[w]=C?C():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),R&&(this[w]=R(this[w],...p)),this[c])return;const g=this[h]+O;g<=Date.now()?(this[h]=Date.now(),f.apply(this,[this[w]]),this[w]=C?C():void 0):(this[c]=!0,this[y]=setTimeout(()=>{this[c]=!1,this[h]=Date.now(),f.apply(this,[this[w]]),this[w]=C?C():void 0},g-Date.now()))}})}}),define(ae[7],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=L,e.$1=j,e.$2=O,e.$3=R,e.$4=f,e.$6=y,e.$7=w,e.$8=h,e.$0=p;class A{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?m.isErrorNoTelemetry(t)?new m(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=A,e.$X=new A;function N($){e.$X.setUnexpectedErrorHandler($)}function L($){if(!$||typeof $!="object")return!1;const t=$;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function j($){f($)||e.$X.onUnexpectedError($)}function O($){f($)||e.$X.onUnexpectedExternalError($)}function R($){if($ instanceof Error){const{name:t,message:r}=$,n=$.stacktrace||$.stack;return{$isError:!0,name:t,message:r,stack:n,noTelemetry:m.isErrorNoTelemetry($)}}return $}const C="Canceled";function f($){return $ instanceof E?!0:$ instanceof Error&&$.name===C&&$.message===C}class E extends Error{constructor(){super(C),this.name=this.message}}e.$5=E;function y(){const $=new Error(C);return $.name=$.message,$}function w($){return $?new Error(`Illegal argument: ${$}`):new Error("Illegal argument")}function h($){return $?new Error(`Illegal state: ${$}`):new Error("Illegal state")}class c extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=c;function p($){return $?$.message?$.message:$.stack?$.stack.split(`
`)[0]:String($):"Error"}class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class l extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=l;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=u;class m extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof m)return t;const r=new m;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=m;class d extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}e.$cb=d}),define(ae[17],ce([0,1,7,125]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=L,e.$tb=j,e.$ub=O,e.$vb=R,e.$wb=C,e.$xb=f,e.$yb=E,e.$zb=y,e.$Ab=w,e.$Bb=h,e.$Cb=c,e.$Db=p,e.$Eb=g,e.top=l,e.$Gb=u,e.$Hb=d,e.$Ib=$,e.$Jb=t,e.$Kb=r,e.$Lb=n,e.$Mb=s,e.$Nb=i,e.$Ob=o,e.$Pb=a,e.$Qb=b,e.$Rb=S,e.$Sb=v,e.$Tb=k,e.$Ub=P,e.$Vb=I,e.$Wb=F,e.$Xb=T,e.$Yb=q,e.$Zb=X,e.$1b=G,e.$2b=Q,e.$3b=W,e.$4b=J,e.$5b=H,e.$6b=B,e.$7b=he,e.$8b=te,e.$$b=D;function L(K,ee=0){return K[K.length-(1+ee)]}function j(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}function O(K,ee,_=(Y,se)=>Y===se){if(K===ee)return!0;if(!K||!ee||K.length!==ee.length)return!1;for(let Y=0,se=K.length;Y<se;Y++)if(!_(K[Y],ee[Y]))return!1;return!0}function R(K,ee){const _=K.length-1;ee<_&&(K[ee]=K[_]),K.pop()}function C(K,ee,_){return f(K.length,Y=>_(K[Y],ee))}function f(K,ee){let _=0,Y=K-1;for(;_<=Y;){const se=(_+Y)/2|0,ue=ee(se);if(ue<0)_=se+1;else if(ue>0)Y=se-1;else return se}return-(_+1)}function E(K,ee,_){if(K=K|0,K>=ee.length)throw new TypeError("invalid index");const Y=ee[Math.floor(ee.length*Math.random())],se=[],ue=[],ge=[];for(const fe of ee){const $e=_(fe,Y);$e<0?se.push(fe):$e>0?ue.push(fe):ge.push(fe)}return K<se.length?E(K,se,_):K<se.length+ge.length?ge[0]:E(K-(se.length+ge.length),ue,_)}function y(K,ee){const _=[];let Y;for(const se of K.slice(0).sort(ee))!Y||ee(Y[0],se)!==0?(Y=[se],_.push(Y)):Y.push(se);return _}function*w(K,ee){let _,Y;for(const se of K)Y!==void 0&&ee(Y,se)?_.push(se):(_&&(yield _),_=[se]),Y=se;_&&(yield _)}function h(K,ee){for(let _=0;_<=K.length;_++)ee(_===0?void 0:K[_-1],_===K.length?void 0:K[_])}function c(K,ee){for(let _=0;_<K.length;_++)ee(_===0?void 0:K[_-1],K[_],_+1===K.length?void 0:K[_+1])}function p(K,ee,_){const Y=[];function se(fe,$e,ye){if($e===0&&ye.length===0)return;const ve=Y[Y.length-1];ve&&ve.start+ve.deleteCount===fe?(ve.deleteCount+=$e,ve.toInsert.push(...ye)):Y.push({start:fe,deleteCount:$e,toInsert:ye})}let ue=0,ge=0;for(;;){if(ue===K.length){se(ue,0,ee.slice(ge));break}if(ge===ee.length){se(ue,K.length-ue,[]);break}const fe=K[ue],$e=ee[ge],ye=_(fe,$e);ye===0?(ue+=1,ge+=1):ye<0?(se(ue,1,[]),ue+=1):ye>0&&(se(ue,0,[$e]),ge+=1)}return Y}function g(K,ee,_){const Y=p(K,ee,_),se=[],ue=[];for(const ge of Y)se.push(...K.slice(ge.start,ge.start+ge.deleteCount)),ue.push(...ge.toInsert);return{removed:se,added:ue}}function l(K,ee,_){if(_===0)return[];const Y=K.slice(0,_).sort(ee);return m(K,ee,Y,_,K.length),Y}function u(K,ee,_,Y,se){return _===0?Promise.resolve([]):new Promise((ue,ge)=>{(async()=>{const fe=K.length,$e=K.slice(0,_).sort(ee);for(let ye=_,ve=Math.min(_+Y,fe);ye<fe;ye=ve,ve=Math.min(ve+Y,fe)){if(ye>_&&await new Promise(Ce=>setTimeout(Ce)),se&&se.isCancellationRequested)throw new A.$5;m(K,ee,$e,ye,ve)}return $e})().then(ue,ge)})}function m(K,ee,_,Y,se){for(const ue=_.length;Y<se;Y++){const ge=K[Y];if(ee(ge,_[ue-1])<0){_.pop();const fe=(0,N.$kb)(_,$e=>ee(ge,$e)<0);_.splice(fe,0,ge)}}}function d(K){return K.filter(ee=>!!ee)}function $(K){let ee=0;for(let _=0;_<K.length;_++)K[_]&&(K[ee]=K[_],ee+=1);K.length=ee}function t(K,ee,_){K.splice(_,0,K.splice(ee,1)[0])}function r(K){return!Array.isArray(K)||K.length===0}function n(K){return Array.isArray(K)&&K.length>0}function s(K,ee=_=>_){const _=new Set;return K.filter(Y=>{const se=ee(Y);return _.has(se)?!1:(_.add(se),!0)})}function i(K){const ee=new Set;return _=>{const Y=K(_);return ee.has(Y)?!1:(ee.add(Y),!0)}}function o(K,ee){return K.length>0?K[0]:ee}function a(K,ee){return K.length>0?K[K.length-1]:ee}function b(K,ee,_=(Y,se)=>Y===se){let Y=0;for(let se=0,ue=Math.min(K.length,ee.length);se<ue&&_(K[se],ee[se]);se++)Y++;return Y}function S(K){return[].concat(...K)}function v(K,ee){let _=typeof ee=="number"?K:0;typeof ee=="number"?_=K:(_=0,ee=K);const Y=[];if(_<=ee)for(let se=_;se<ee;se++)Y.push(se);else for(let se=_;se>ee;se--)Y.push(se);return Y}function k(K,ee,_){return K.reduce((Y,se)=>(Y[ee(se)]=_?_(se):se,Y),Object.create(null))}function P(K,ee){return K.push(ee),()=>I(K,ee)}function I(K,ee){const _=K.indexOf(ee);if(_>-1)return K.splice(_,1),ee}function F(K,ee,_){const Y=K.slice(0,ee),se=K.slice(ee);return Y.concat(_,se)}function T(K,ee){let _;if(typeof ee=="number"){let Y=ee;_=()=>{const se=Math.sin(Y++)*179426549;return se-Math.floor(se)}}else _=Math.random;for(let Y=K.length-1;Y>0;Y-=1){const se=Math.floor(_()*(Y+1)),ue=K[Y];K[Y]=K[se],K[se]=ue}}function q(K,ee){const _=K.indexOf(ee);_>-1&&(K.splice(_,1),K.unshift(ee))}function X(K,ee){const _=K.indexOf(ee);_>-1&&(K.splice(_,1),K.push(ee))}function G(K,ee){for(const _ of ee)K.push(_)}function Q(K,ee){return Array.isArray(K)?K.map(ee):ee(K)}function W(K){return Array.isArray(K)?K:[K]}function J(K){return K[Math.floor(Math.random()*K.length)]}function H(K,ee,_){const Y=ie(K,ee),se=K.length,ue=_.length;K.length=se+ue;for(let ge=se-1;ge>=Y;ge--)K[ge+ue]=K[ge];for(let ge=0;ge<ue;ge++)K[ge+Y]=_[ge]}function B(K,ee,_,Y){const se=ie(K,ee);let ue=K.splice(se,_);return ue===void 0&&(ue=[]),H(K,se,Y),ue}function ie(K,ee){return ee<0?Math.max(ee+K.length,0):Math.min(ee,K.length)}var re;(function(K){function ee(ue){return ue<0}K.isLessThan=ee;function _(ue){return ue<=0}K.isLessThanOrEqual=_;function Y(ue){return ue>0}K.isGreaterThan=Y;function se(ue){return ue===0}K.isNeitherLessOrGreaterThan=se,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function he(K,ee){return(_,Y)=>ee(K(_),K(Y))}function te(...K){return(ee,_)=>{for(const Y of K){const se=Y(ee,_);if(!re.isNeitherLessOrGreaterThan(se))return se}return re.neitherLessOrGreaterThan}}const V=(K,ee)=>K-ee;e.$9b=V;const U=(K,ee)=>(0,e.$9b)(K?1:0,ee?1:0);e.$0b=U;function D(K){return(ee,_)=>-K(ee,_)}class M{constructor(ee){this.g=ee,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let _=this.c;for(;_<this.g.length&&ee(this.g[_]);)_++;const Y=_===this.c?null:this.g.slice(this.c,_);return this.c=_,Y}takeFromEndWhile(ee){let _=this.d;for(;_>=0&&ee(this.g[_]);)_--;const Y=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,Y}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ee=this.g[this.c];return this.c++,ee}removeLast(){const ee=this.g[this.d];return this.d--,ee}takeCount(ee){const _=this.g.slice(this.c,this.c+ee);return this.c+=ee,_}}e.$_b=M;class z{static{this.empty=new z(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(_=>(ee(_),!0))}toArray(){const ee=[];return this.iterate(_=>(ee.push(_),!0)),ee}filter(ee){return new z(_=>this.iterate(Y=>ee(Y)?_(Y):!0))}map(ee){return new z(_=>this.iterate(Y=>_(ee(Y))))}some(ee){let _=!1;return this.iterate(Y=>(_=ee(Y),!_)),_}findFirst(ee){let _;return this.iterate(Y=>ee(Y)?(_=Y,!1):!0),_}findLast(ee){let _;return this.iterate(Y=>(ee(Y)&&(_=Y),!0)),_}findLastMaxBy(ee){let _,Y=!0;return this.iterate(se=>((Y||re.isGreaterThan(ee(se,_)))&&(Y=!1,_=se),!0)),_}}e.$ac=z;class x{constructor(ee){this.c=ee}static createSortPermutation(ee,_){const Y=Array.from(ee.keys()).sort((se,ue)=>_(ee[se],ee[ue]));return new x(Y)}apply(ee){return ee.map((_,Y)=>ee[this.c[Y]])}inverse(){const ee=this.c.slice();for(let _=0;_<this.c.length;_++)ee[this.c[_]]=_;return new x(ee)}}e.$bc=x}),define(ae[127],ce([0,1,7]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$fd=L,e.$gd=j,e.$hd=O,e.$id=R,e.$jd=C;function N(f,E){if(!f)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}function L(f,E="Unreachable"){throw new Error(E)}function j(f){if(!f)throw new A.$cb("Assertion Failed")}function O(f){f||(0,A.$1)(new A.$cb("Soft Assertion Failed"))}function R(f){if(!f()){debugger;f(),(0,A.$1)(new A.$cb("Assertion Failed"))}}function C(f,E){let y=0;for(;y<f.length-1;){const w=f[y],h=f[y+1];if(!E(w,h))return!1;y++}return!0}}),define(ae[85],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=A;function A(N,L){const j=this;let O=!1,R;return function(){if(O)return R;if(O=!0,L)try{R=N.apply(j,arguments)}finally{L()}else R=N.apply(j,arguments);return R}}}),define(ae[61],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var A;(function(N){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=L;const j=Object.freeze([]);function O(){return j}N.empty=O;function*R(t){yield t}N.single=R;function C(t){return L(t)?t:R(t)}N.wrap=C;function f(t){return t||j}N.from=f;function*E(t){for(let r=t.length-1;r>=0;r--)yield t[r]}N.reverse=E;function y(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=y;function w(t){return t[Symbol.iterator]().next().value}N.first=w;function h(t,r){for(const n of t)if(r(n))return!0;return!1}N.some=h;function c(t,r){for(const n of t)if(r(n))return n}N.find=c;function*p(t,r){for(const n of t)r(n)&&(yield n)}N.filter=p;function*g(t,r){let n=0;for(const s of t)yield r(s,n++)}N.map=g;function*l(...t){for(const r of t)yield*r}N.concat=l;function u(t,r,n){let s=n;for(const i of t)s=r(s,i);return s}N.reduce=u;function*m(t,r,n=t.length){for(r<0&&(r+=t.length),n<0?n+=t.length:n>t.length&&(n=t.length);r<n;r++)yield t[r]}N.slice=m;function d(t,r=Number.POSITIVE_INFINITY){const n=[];if(r===0)return[n,t];const s=t[Symbol.iterator]();for(let i=0;i<r;i++){const o=s.next();if(o.done)return[n,N.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return s}}]}N.consume=d;async function $(t){const r=[];for await(const n of t)r.push(n);return Promise.resolve(r)}N.asyncToArray=$})(A||(e.Iterable=A={}))}),define(ae[35],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Gn=O,e.$Hn=y,e.$In=w,e.$Jn=h,e.$Kn=c,e.$Ln=p,e.$Mn=g,e.$Nn=l,e.$On=u,e.$Pn=m,e.$Qn=d,e.$Rn=$;var A;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(A||(e.ScanError=A={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var j;(function(t){t.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function O(t,r=!1){let n=0;const s=t.length;let i="",o=0,a=16,b=0;function S(q){let X=0,G=0;for(;X<q;){const Q=t.charCodeAt(n);if(Q>=48&&Q<=57)G=G*16+Q-48;else if(Q>=65&&Q<=70)G=G*16+Q-65+10;else if(Q>=97&&Q<=102)G=G*16+Q-97+10;else break;n++,X++}return X<q&&(G=-1),G}function v(q){n=q,i="",o=0,a=16,b=0}function k(){const q=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&f(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&f(t.charCodeAt(n)))for(n++;n<t.length&&f(t.charCodeAt(n));)n++;else return b=3,t.substring(q,n);let X=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&f(t.charCodeAt(n))){for(n++;n<t.length&&f(t.charCodeAt(n));)n++;X=n}else b=3;return t.substring(q,X)}function P(){let q="",X=n;for(;;){if(n>=s){q+=t.substring(X,n),b=2;break}const G=t.charCodeAt(n);if(G===34){q+=t.substring(X,n),n++;break}if(G===92){if(q+=t.substring(X,n),n++,n>=s){b=2;break}switch(t.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const W=S(4);W>=0?q+=String.fromCharCode(W):b=4;break}default:b=5}X=n;continue}if(G>=0&&G<=31)if(C(G)){q+=t.substring(X,n),b=2;break}else b=6;n++}return q}function I(){if(i="",b=0,o=n,n>=s)return o=s,a=17;let q=t.charCodeAt(n);if(R(q)){do n++,i+=String.fromCharCode(q),q=t.charCodeAt(n);while(R(q));return a=15}if(C(q))return n++,i+=String.fromCharCode(q),q===13&&t.charCodeAt(n)===10&&(n++,i+=`
`),a=14;switch(q){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,i=P(),a=10;case 47:{const X=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!C(t.charCodeAt(n));)n++;return i=t.substring(X,n),a=12}if(t.charCodeAt(n+1)===42){n+=2;const G=s-1;let Q=!1;for(;n<G;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,Q=!0;break}n++}return Q||(n++,b=1),i=t.substring(X,n),a=13}return i+=String.fromCharCode(q),n++,a=16}case 45:if(i+=String.fromCharCode(q),n++,n===s||!f(t.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=k(),a=11;default:for(;n<s&&F(q);)n++,q=t.charCodeAt(n);if(o!==n){switch(i=t.substring(o,n),i){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return i+=String.fromCharCode(q),n++,a=16}}function F(q){if(R(q)||C(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let q;do q=I();while(q>=12&&q<=15);return q}return{setPosition:v,getPosition:()=>n,scan:r?T:I,getToken:()=>a,getTokenValue:()=>i,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>b}}function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function C(t){return t===10||t===13||t===8232||t===8233}function f(t){return t>=48&&t<=57}var E;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(E||(E={}));function y(t,r){const n=[],s=new Object;let i;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function b(S,v,k,P){o.value=S,o.offset=v,o.length=k,o.type=P,o.colonOffset=void 0,i=o}try{m(t,{onObjectBegin:(S,v)=>{if(r<=S)throw s;i=void 0,a=r>S,n.push("")},onObjectProperty:(S,v,k)=>{if(r<v||(b(S,v,k,"property"),n[n.length-1]=S,r<=v+k))throw s},onObjectEnd:(S,v)=>{if(r<=S)throw s;i=void 0,n.pop()},onArrayBegin:(S,v)=>{if(r<=S)throw s;i=void 0,n.push(0)},onArrayEnd:(S,v)=>{if(r<=S)throw s;i=void 0,n.pop()},onLiteralValue:(S,v,k)=>{if(r<v||(b(S,v,k,$(S)),r<=v+k))throw s},onSeparator:(S,v,k)=>{if(r<=v)throw s;if(S===":"&&i&&i.type==="property")i.colonOffset=v,a=!1,i=void 0;else if(S===","){const P=n[n.length-1];typeof P=="number"?n[n.length-1]=P+1:(a=!0,n[n.length-1]=""),i=void 0}}})}catch(S){if(S!==s)throw S}return{path:n,previousNode:i,isAtPropertyKey:a,matches:S=>{let v=0;for(let k=0;v<S.length&&k<n.length;k++)if(S[v]===n[k]||S[v]==="*")v++;else if(S[v]!=="**")return!1;return v===S.length}}}function w(t,r=[],n=j.DEFAULT){let s=null,i=[];const o=[];function a(S){Array.isArray(i)?i.push(S):s!==null&&(i[s]=S)}return m(t,{onObjectBegin:()=>{const S={};a(S),o.push(i),i=S,s=null},onObjectProperty:S=>{s=S},onObjectEnd:()=>{i=o.pop()},onArrayBegin:()=>{const S=[];a(S),o.push(i),i=S,s=null},onArrayEnd:()=>{i=o.pop()},onLiteralValue:a,onError:(S,v,k)=>{r.push({error:S,offset:v,length:k})}},n),i[0]}function h(t,r=[],n=j.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(S){s.type==="property"&&(s.length=S-s.offset,s=s.parent)}function o(S){return s.children.push(S),S}m(t,{onObjectBegin:S=>{s=o({type:"object",offset:S,length:-1,parent:s,children:[]})},onObjectProperty:(S,v,k)=>{s=o({type:"property",offset:v,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:S,offset:v,length:k,parent:s})},onObjectEnd:(S,v)=>{s.length=S+v-s.offset,s=s.parent,i(S+v)},onArrayBegin:(S,v)=>{s=o({type:"array",offset:S,length:-1,parent:s,children:[]})},onArrayEnd:(S,v)=>{s.length=S+v-s.offset,s=s.parent,i(S+v)},onLiteralValue:(S,v,k)=>{o({type:$(S),offset:v,length:k,parent:s,value:S}),i(v+k)},onSeparator:(S,v,k)=>{s.type==="property"&&(S===":"?s.colonOffset=v:S===","&&i(v))},onError:(S,v,k)=>{r.push({error:S,offset:v,length:k})}},n);const b=s.children[0];return b&&delete b.parent,b}function c(t,r){if(!t)return;let n=t;for(const s of r)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===s){n=o.children[1],i=!0;break}if(!i)return}else{const i=s;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}function p(t){if(!t.parent||!t.parent.children)return[];const r=p(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;r.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&r.push(n)}return r}function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const r=Object.create(null);for(const n of t.children){const s=n.children[1];s&&(r[n.children[0].value]=g(s))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function l(t,r,n=!1){return r>=t.offset&&r<t.offset+t.length||n&&r===t.offset+t.length}function u(t,r,n=!1){if(l(t,r,n)){const s=t.children;if(Array.isArray(s))for(let i=0;i<s.length&&s[i].offset<=r;i++){const o=u(s[i],r,n);if(o)return o}return t}}function m(t,r,n=j.DEFAULT){const s=O(t,!1);function i(he){return he?()=>he(s.getTokenOffset(),s.getTokenLength()):()=>!0}function o(he){return he?te=>he(te,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=i(r.onObjectBegin),b=o(r.onObjectProperty),S=i(r.onObjectEnd),v=i(r.onArrayBegin),k=i(r.onArrayEnd),P=o(r.onLiteralValue),I=o(r.onSeparator),F=i(r.onComment),T=o(r.onError),q=n&&n.disallowComments,X=n&&n.allowTrailingComma;function G(){for(;;){const he=s.scan();switch(s.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:q||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(he){case 12:case 13:q?Q(10):F();break;case 16:Q(1);break;case 15:case 14:break;default:return he}}}function Q(he,te=[],V=[]){if(T(he),te.length+V.length>0){let U=s.getToken();for(;U!==17;){if(te.indexOf(U)!==-1){G();break}else if(V.indexOf(U)!==-1)break;U=G()}}}function W(he){const te=s.getTokenValue();return he?P(te):b(te),G(),!0}function J(){switch(s.getToken()){case 11:{let he=0;try{he=JSON.parse(s.getTokenValue()),typeof he!="number"&&(Q(2),he=0)}catch{Q(2)}P(he);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return G(),!0}function H(){return s.getToken()!==10?(Q(3,[],[2,5]),!1):(W(!1),s.getToken()===6?(I(":"),G(),re()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function B(){a(),G();let he=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(he||Q(4,[],[]),I(","),G(),s.getToken()===2&&X)break}else he&&Q(6,[],[]);H()||Q(4,[],[2,5]),he=!0}return S(),s.getToken()!==2?Q(7,[2],[]):G(),!0}function ie(){v(),G();let he=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(he||Q(4,[],[]),I(","),G(),s.getToken()===4&&X)break}else he&&Q(6,[],[]);re()||Q(4,[],[4,5]),he=!0}return k(),s.getToken()!==4?Q(8,[4],[]):G(),!0}function re(){switch(s.getToken()){case 3:return ie();case 1:return B();case 10:return W(!0);default:return J()}}return G(),s.getToken()===17?n.allowEmptyContent?!0:(Q(4,[],[]),!1):re()?(s.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}function d(t,r){const n=O(t),s=[];let i,o=0,a;do switch(a=n.getPosition(),i=n.scan(),i){case 12:case 13:case 17:o!==a&&s.push(t.substring(o,a)),r!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,r)),o=n.getPosition();break}while(i!==17);return s.join("")}function $(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ae[44],ce([0,1,35]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=N,e.$Tn=L,e.$Un=R,e.$Vn=C;function N(f,E,y){let w,h,c,p,g;if(E){for(p=E.offset,g=p+E.length,c=p;c>0&&!C(f,c-1);)c--;let a=g;for(;a<f.length&&!C(f,a);)a++;h=f.substring(c,a),w=O(h,y)}else h=f,w=0,c=0,p=0,g=f.length;const l=R(y,f);let u=!1,m=0,d;y.insertSpaces?d=j(" ",y.tabSize||4):d="	";const $=(0,A.$Gn)(h,!1);let t=!1;function r(){return l+j(d,w+m)}function n(){let a=$.scan();for(u=!1;a===15||a===14;)u=u||a===14,a=$.scan();return t=a===16||$.getTokenError()!==0,a}const s=[];function i(a,b,S){!t&&b<g&&S>p&&f.substring(b,S)!==a&&s.push({offset:b,length:S-b,content:a})}let o=n();if(o!==17){const a=$.getTokenOffset()+c,b=j(d,w);i(b,c,a)}for(;o!==17;){let a=$.getTokenOffset()+$.getTokenLength()+c,b=n(),S="";for(;!u&&(b===12||b===13);){const k=$.getTokenOffset()+c;i(" ",a,k),a=$.getTokenOffset()+$.getTokenLength()+c,S=b===12?r():"",b=n()}if(b===2)o!==1&&(m--,S=r());else if(b===4)o!==3&&(m--,S=r());else{switch(o){case 3:case 1:m++,S=r();break;case 5:case 12:S=r();break;case 13:u?S=r():S=" ";break;case 6:S=" ";break;case 10:if(b===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?S=" ":b!==5&&b!==17&&(t=!0);break;case 16:t=!0;break}u&&(b===12||b===13)&&(S=r())}const v=$.getTokenOffset()+c;i(S,a,v),o=b}return s}function L(f,E){const y=JSON.stringify(f,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?y.replace(/\r\n|\r|\n/g,E.eol):y}function j(f,E){let y="";for(let w=0;w<E;w++)y+=f;return y}function O(f,E){let y=0,w=0;const h=E.tabSize||4;for(;y<f.length;){const c=f.charAt(y);if(c===" ")w++;else if(c==="	")w+=h;else break;y++}return Math.floor(w/h)}function R(f,E){for(let y=0;y<E.length;y++){const w=E.charAt(y);if(w==="\r")return y+1<E.length&&E.charAt(y+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return f&&f.eol||`
`}function C(f,E){return`\r
`.indexOf(f.charAt(E))!==-1}}),define(ae[62],ce([0,1,35,44]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=L,e.$Xn=j,e.$Yn=O,e.$Zn=R,e.$1n=C;function L(f,E,y){return j(f,E,void 0,y)}function j(f,E,y,w,h){const c=E.slice(),p=[],g=(0,A.$Jn)(f,p);let l,u;for(;c.length>0&&(u=c.pop(),l=(0,A.$Kn)(g,c),l===void 0&&y!==void 0);)typeof u=="string"?y={[u]:y}:y=[y];if(l)if(l.type==="object"&&typeof u=="string"&&Array.isArray(l.children)){const m=(0,A.$Kn)(l,[u]);if(m!==void 0)if(y===void 0){if(!m.parent)throw new Error("Malformed AST");const d=l.children.indexOf(m.parent);let $,t=m.parent.offset+m.parent.length;if(d>0){const r=l.children[d-1];$=r.offset+r.length}else $=l.offset+1,l.children.length>1&&(t=l.children[1].offset);return O(f,{offset:$,length:t-$,content:""},w)}else return O(f,{offset:m.offset,length:m.length,content:JSON.stringify(y)},w);else{if(y===void 0)return[];const d=`${JSON.stringify(u)}: ${JSON.stringify(y)}`,$=h?h(l.children.map(r=>r.children[0].value)):l.children.length;let t;if($>0){const r=l.children[$-1];t={offset:r.offset+r.length,length:0,content:","+d}}else l.children.length===0?t={offset:l.offset+1,length:0,content:d}:t={offset:l.offset+1,length:0,content:d+","};return O(f,t,w)}}else if(l.type==="array"&&typeof u=="number"&&Array.isArray(l.children))if(y!==void 0){const m=`${JSON.stringify(y)}`;let d;if(l.children.length===0||u===0)d={offset:l.offset+1,length:0,content:l.children.length===0?m:m+","};else{const $=u===-1||u>l.children.length?l.children.length:u,t=l.children[$-1];d={offset:t.offset+t.length,length:0,content:","+m}}return O(f,d,w)}else{const m=u,d=l.children[m];let $;if(l.children.length===1)$={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===m){const t=l.children[m-1],r=t.offset+t.length,n=l.offset+l.length;$={offset:r,length:n-2-r,content:""}}else $={offset:d.offset,length:l.children[m+1].offset-d.offset,content:""};return O(f,$,w)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${l.type}`);else return y===void 0?[]:O(f,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(y)},w)}function O(f,E,y){let w=R(f,E),h=E.offset,c=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;h>0&&!(0,N.$Vn)(w,h-1);)h--;for(;c<w.length&&!(0,N.$Vn)(w,c);)c++}const p=(0,N.$Sn)(w,{offset:h,length:c-h},y);for(let l=p.length-1;l>=0;l--){const u=p[l];w=R(w,u),h=Math.min(h,u.offset),c=Math.max(c,u.offset+u.length),c+=u.content.length-u.length}const g=f.length-(w.length-c)-h;return[{offset:h,length:g,content:w.substring(h,c)}]}function R(f,E){return f.substring(0,E.offset)+E.content+f.substring(E.offset+E.length)}function C(f,E){const y=E.slice(0).sort((h,c)=>{const p=h.offset-c.offset;return p===0?h.length-c.length:p});let w=f.length;for(let h=y.length-1;h>=0;h--){const c=y[h];if(c.offset+c.length<=w)f=R(f,c);else throw new Error("Overlapping edit");w=c.offset}return f}}),define(ae[53],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class A{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=A}),define(ae[86],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class A{static{this.Undefined=new A(void 0)}constructor(j){this.element=j,this.next=A.Undefined,this.prev=A.Undefined}}class N{constructor(){this.a=A.Undefined,this.b=A.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===A.Undefined}clear(){let j=this.a;for(;j!==A.Undefined;){const O=j.next;j.prev=A.Undefined,j.next=A.Undefined,j=O}this.a=A.Undefined,this.b=A.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,O){const R=new A(j);if(this.a===A.Undefined)this.a=R,this.b=R;else if(O){const f=this.b;this.b=R,R.prev=f,f.next=R}else{const f=this.a;this.a=R,R.next=f,f.prev=R}this.c+=1;let C=!1;return()=>{C||(C=!0,this.e(R))}}shift(){if(this.a!==A.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==A.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==A.Undefined&&j.next!==A.Undefined){const O=j.prev;O.next=j.next,j.next.prev=O}else j.prev===A.Undefined&&j.next===A.Undefined?(this.a=A.Undefined,this.b=A.Undefined):j.next===A.Undefined?(this.b=this.b.prev,this.b.next=A.Undefined):j.prev===A.Undefined&&(this.a=this.a.next,this.a.prev=A.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==A.Undefined;)yield j.element,j=j.next}}e.$6c=N}),define(ae[34],ce([0,1]),function(ne,e){"use strict";var A,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=j,e.$zc=O,e.$Ac=R,e.$Jc=d;function j($,t,r){let n=$.get(t);return n===void 0&&(n=r,$.set(t,n)),n}function O($){const t=[];return $.forEach((r,n)=>{t.push(`${n} => ${r}`)}),`Map(${$.size}) {${t.join(", ")}}`}function R($){const t=[];return $.forEach(r=>{t.push(r)}),`Set(${$.size}) {${t.join(", ")}}`}class C{constructor(t,r){this.uri=t,this.value=r}}function f($){return Array.isArray($)}class E{static{this.c=t=>t.toString()}constructor(t,r){if(this[A]="ResourceMap",t instanceof E)this.d=new Map(t.d),this.e=r??E.c;else if(f(t)){this.d=new Map,this.e=r??E.c;for(const[n,s]of t)this.set(n,s)}else this.d=new Map,this.e=t??E.c}set(t,r){return this.d.set(this.e(t),new C(t,r)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[n,s]of this.d)t(s.value,s.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=E;class y{constructor(t,r){this[N]="ResourceSet",!t||typeof t=="function"?this.c=new E(t):(this.c=new E(r),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,r){this.c.forEach((n,s)=>t.call(r,s,s,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=y;var w;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class h{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,r=0){const n=this.c.get(t);if(n)return r!==0&&this.m(n,r),n.value}set(t,r,n=0){let s=this.c.get(t);if(s)s.value=r,n!==0&&this.m(s,n);else{switch(s={key:t,value:r,next:void 0,previous:void 0},n){case 0:this.k(s);break;case 1:this.j(s);break;case 2:this.k(s);break;default:this.k(s);break}this.c.set(t,s),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this.c.get(t);if(r)return this.c.delete(t),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,r){const n=this.g;let s=this.d;for(;s;){if(r?t.bind(r)(s.value,s.key,this):t(s.value,s.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const t=this,r=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:n.key,done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}values(){const t=this,r=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:n.value,done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}entries(){const t=this,r=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:[n.key,n.value],done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.d,n=this.size;for(;r&&n>t;)this.c.delete(r.key),r=r.next,n--;this.d=r,this.f=n,r&&(r.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.e,n=this.size;for(;r&&n>t;)this.c.delete(r.key),r=r.previous,n--;this.e=r,this.f=n,r&&(r.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const r=t.next,n=t.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r}t.next=void 0,t.previous=void 0,this.g++}m(t,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this.d)return;const n=t.next,s=t.previous;t===this.e?(s.next=void 0,this.e=s):(n.previous=s,s.next=n),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(r===2){if(t===this.e)return;const n=t.next,s=t.previous;t===this.d?(n.previous=void 0,this.d=n):(n.previous=s,s.next=n),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((r,n)=>{t.push([n,r])}),t}fromJSON(t){this.clear();for(const[r,n]of t)this.set(r,n)}}e.$Dc=h;class c extends h{constructor(t,r=1){super(),this.n=t,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class p extends c{constructor(t,r=1){super(t,r)}q(t){this.h(t)}set(t,r){return super.set(t,r),this.p(),this}}e.$Ec=p;class g extends c{constructor(t,r=1){super(t,r)}q(t){this.i(t)}set(t,r){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,r),this}}e.$Fc=g;class l{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let r=this.c.get(t)||0;return r===0?!1:(r--,r===0?this.c.delete(t):this.c.set(t,r),!0)}has(t){return this.c.has(t)}}e.$Gc=l;class u{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[r,n]of t)this.set(r,n)}clear(){this.c.clear(),this.d.clear()}set(t,r){this.c.set(t,r),this.d.set(r,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const r=this.c.get(t);return r===void 0?!1:(this.c.delete(t),this.d.delete(r),!0)}forEach(t,r){this.c.forEach((n,s)=>{t.call(r,n,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=u;class m{constructor(){this.c=new Map}add(t,r){let n=this.c.get(t);n||(n=new Set,this.c.set(t,n)),n.add(r)}delete(t,r){const n=this.c.get(t);n&&(n.delete(r),n.size===0&&this.c.delete(t))}forEach(t,r){const n=this.c.get(t);n&&n.forEach(r)}get(t){const r=this.c.get(t);return r||new Set}}e.$Ic=m;function d($,t){if($===t)return!0;if($.size!==t.size)return!1;for(const[r,n]of $)if(!t.has(r)||t.get(r)!==n)return!1;for(const[r]of t)if(!$.has(r))return!1;return!0}}),define(ae[2],ce([0,1,17,126,34,85,61]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=E,e.$Mc=y,e.$Nc=w,e.$Oc=p,e.$Pc=g,e.$Qc=l,e.$Rc=u,e.$Sc=m,e.$Tc=d,e.$4c=S;const R=!1;let C=null;class f{constructor(){this.b=new Map}static{this.a=0}c(P){let I=this.b.get(P);return I||(I={parent:null,source:null,isSingleton:!1,value:P,idx:f.a++},this.b.set(P,I)),I}trackDisposable(P){const I=this.c(P);I.source||(I.source=new Error().stack)}setParent(P,I){const F=this.c(P);F.parent=I}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,I){const F=I.get(P);if(F)return F;const T=P.parent?this.f(this.c(P.parent),I):P;return I.set(P,T),T}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,P).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(P=10,I){let F;if(I)F=I;else{const Q=new Map,W=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,Q).isSingleton);if(W.length===0)return;const J=new Set(W.map(H=>H.value));if(F=W.filter(H=>!(H.parent&&J.has(H.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function T(Q){function W(H,B){for(;H.length>0&&B.some(ie=>typeof ie=="string"?ie===H[0]:H[0].match(ie));)H.shift()}const J=Q.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return W(J,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),J.reverse()}const q=new L.$Ic;for(const Q of F){const W=T(Q);for(let J=0;J<=W.length;J++)q.add(W.slice(0,J).join(`
`),Q)}F.sort((0,A.$7b)(Q=>Q.idx,A.$9b));let X="",G=0;for(const Q of F.slice(0,P)){G++;const W=T(Q),J=[];for(let H=0;H<W.length;H++){let B=W[H];B=`(shared with ${q.get(W.slice(0,H+1).join(`
`)).size}/${F.length} leaks) at ${B}`;const re=q.get(W.slice(0,H).join(`
`)),he=(0,N.$K)([...re].map(te=>T(te)[H]),te=>te);delete he[W[H]];for(const[te,V]of Object.entries(he))J.unshift(`    - stacktraces of ${V.length} other leaks continue with ${te}`);J.unshift(B)}X+=`


==================== Leaking disposable ${G}/${F.length}: ${Q.value.constructor.name} ====================
${J.join(`
`)}
============================================================

`}return F.length>P&&(X+=`


... and ${F.length-P} more leaking disposables

`),{leaks:F,details:X}}}e.$Kc=f;function E(k){C=k}if(R){const k="__is_disposable_tracked__";E(new class{trackDisposable(P){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[k]||console.log(I)},3e3)}setParent(P,I){if(P&&P!==t.None)try{P[k]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[k]=!0}catch{}}markAsSingleton(P){}})}function y(k){return C?.trackDisposable(k),k}function w(k){C?.markAsDisposed(k)}function h(k,P){C?.setParent(k,P)}function c(k,P){if(C)for(const I of k)C.setParent(I,P)}function p(k){return C?.markAsSingleton(k),k}function g(k){return typeof k=="object"&&k!==null&&typeof k.dispose=="function"&&k.dispose.length===0}function l(k){if(O.Iterable.is(k)){const P=[];for(const I of k)if(I)try{I.dispose()}catch(F){P.push(F)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function u(k){for(const P of k)g(P)&&P.dispose();return[]}function m(...k){const P=d(()=>l(k));return c(k,P),P}function d(k){const P=y({dispose:(0,j.$db)(()=>{w(P),k()})});return P}class ${static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return h(P,this),this.g?$.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),h(P,null))}}e.$Uc=$;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new $,y(this),h(this.q,this)}dispose(){w(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Vc=t;class r{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&h(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&h(P,null),P}}e.$Wc=r;class n{constructor(P){this.a=new r,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=n;class s{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=s;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(P){let I=P;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,w(this))},this}}e.$Zc=i;class o{constructor(){this.a=new Map}acquire(P,...I){let F=this.a.get(P);F||(F={counter:0,object:this.b(P,...I)},this.a.set(P,F));const{object:T}=F,q=(0,j.$db)(()=>{--F.counter===0&&(this.c(P,F.object),this.a.delete(P))});return F.counter++,{object:T,dispose:q}}}e.$1c=o;class a{constructor(P){this.a=P}async acquire(P,...I){const F=this.a.acquire(P,...I);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(T){throw F.dispose(),T}}}e.$2c=a;class b{constructor(P){this.object=P}dispose(){}}e.$3c=b;function S(k){const P=new $;try{k(P)}finally{P.dispose()}}class v{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,I,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(P)?.dispose(),this.a.set(P,I)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=v}),define(ae[87],ce([0,1,34]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=void 0,e.$am=L,e.$bm=O;const N=new A.$Ec(1e4);function L(f){return C(f,"NFC",N)}const j=new A.$Ec(1e4);function O(f){return C(f,"NFD",j)}const R=/[^\u0000-\u0080]/;function C(f,E,y){if(!f)return f;const w=y.get(f);if(w)return w;let h;return R.test(f)?h=f.normalize(E):h=f,y.set(f,h),h}e.$cm=function(){const f=/[\u0300-\u036f]/g;return function(E){return O(E).replace(f,"")}}()}),function(){function ne(L){const j=[];typeof L=="number"&&j.push("code/timeOrigin",L);function O(C){j.push(C,Date.now())}function R(){const C=[];for(let f=0;f<j.length;f+=2)C.push({name:j[f],startTime:j[f+1]});return C}return{mark:O,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const O of performance.getEntriesByType("mark"))j.push({name:O.name,startTime:Math.round(L+O.startTime)});return j}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function A(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return A(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=A(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=A(N))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var A=e();for(var N in A)(typeof exports=="object"?exports:ne)[N]=A[N]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function A(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return ne[N].call(L.exports,L,L.exports,A),L.l=!0,L.exports}return A.m=ne,A.c=e,A.d=function(N,L,j){A.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:j})},A.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},A.t=function(N,L){if(1&L&&(N=A(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var j=Object.create(null);if(A.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var O in N)A.d(j,O,function(R){return N[R]}.bind(null,O));return j},A.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return A.d(L,"a",L),L},A.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},A.p="",A(A.s=0)}([function(ne,e,A){(function(N){var L;e=ne.exports=V,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],C=e.src=[],f=0,E=f++;C[E]="0|[1-9]\\d*";var y=f++;C[y]="[0-9]+";var w=f++;C[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=f++;C[h]="("+C[E]+")\\.("+C[E]+")\\.("+C[E]+")";var c=f++;C[c]="("+C[y]+")\\.("+C[y]+")\\.("+C[y]+")";var p=f++;C[p]="(?:"+C[E]+"|"+C[w]+")";var g=f++;C[g]="(?:"+C[y]+"|"+C[w]+")";var l=f++;C[l]="(?:-("+C[p]+"(?:\\."+C[p]+")*))";var u=f++;C[u]="(?:-?("+C[g]+"(?:\\."+C[g]+")*))";var m=f++;C[m]="[0-9A-Za-z-]+";var d=f++;C[d]="(?:\\+("+C[m]+"(?:\\."+C[m]+")*))";var $=f++,t="v?"+C[h]+C[l]+"?"+C[d]+"?";C[$]="^"+t+"$";var r="[v=\\s]*"+C[c]+C[u]+"?"+C[d]+"?",n=f++;C[n]="^"+r+"$";var s=f++;C[s]="((?:<|>)?=?)";var i=f++;C[i]=C[y]+"|x|X|\\*";var o=f++;C[o]=C[E]+"|x|X|\\*";var a=f++;C[a]="[v=\\s]*("+C[o]+")(?:\\.("+C[o]+")(?:\\.("+C[o]+")(?:"+C[l]+")?"+C[d]+"?)?)?";var b=f++;C[b]="[v=\\s]*("+C[i]+")(?:\\.("+C[i]+")(?:\\.("+C[i]+")(?:"+C[u]+")?"+C[d]+"?)?)?";var S=f++;C[S]="^"+C[s]+"\\s*"+C[a]+"$";var v=f++;C[v]="^"+C[s]+"\\s*"+C[b]+"$";var k=f++;C[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=f++;C[P]="(?:~>?)";var I=f++;C[I]="(\\s*)"+C[P]+"\\s+",R[I]=new RegExp(C[I],"g");var F=f++;C[F]="^"+C[P]+C[a]+"$";var T=f++;C[T]="^"+C[P]+C[b]+"$";var q=f++;C[q]="(?:\\^)";var X=f++;C[X]="(\\s*)"+C[q]+"\\s+",R[X]=new RegExp(C[X],"g");var G=f++;C[G]="^"+C[q]+C[a]+"$";var Q=f++;C[Q]="^"+C[q]+C[b]+"$";var W=f++;C[W]="^"+C[s]+"\\s*("+r+")$|^$";var J=f++;C[J]="^"+C[s]+"\\s*("+t+")$|^$";var H=f++;C[H]="(\\s*)"+C[s]+"\\s*("+r+"|"+C[a]+")",R[H]=new RegExp(C[H],"g");var B=f++;C[B]="^\\s*("+C[a]+")\\s+-\\s+("+C[a]+")\\s*$";var ie=f++;C[ie]="^\\s*("+C[b]+")\\s+-\\s+("+C[b]+")\\s*$";var re=f++;C[re]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)L(he,C[he]),R[he]||(R[he]=new RegExp(C[he]));function te(le,me){if(le instanceof V)return le;if(typeof le!="string"||le.length>j||!(me?R[n]:R[$]).test(le))return null;try{return new V(le,me)}catch{return null}}function V(le,me){if(le instanceof V){if(le.loose===me)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof V))return new V(le,me);L("SemVer",le,me),this.loose=me;var we=le.trim().match(me?R[n]:R[$]);if(!we)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+we[1],this.minor=+we[2],this.patch=+we[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");we[4]?this.prerelease=we[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Ie=+Pe;if(Ie>=0&&Ie<O)return Ie}return Pe}):this.prerelease=[],this.build=we[5]?we[5].split("."):[],this.format()}e.parse=te,e.valid=function(le,me){var we=te(le,me);return we?we.version:null},e.clean=function(le,me){var we=te(le.trim().replace(/^[=v]+/,""),me);return we?we.version:null},e.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function(le){return L("SemVer.compare",this.version,this.loose,le),le instanceof V||(le=new V(le,this.loose)),this.compareMain(le)||this.comparePre(le)},V.prototype.compareMain=function(le){return le instanceof V||(le=new V(le,this.loose)),D(this.major,le.major)||D(this.minor,le.minor)||D(this.patch,le.patch)},V.prototype.comparePre=function(le){if(le instanceof V||(le=new V(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var me=0;do{var we=this.prerelease[me],Pe=le.prerelease[me];if(L("prerelease compare",me,we,Pe),we===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(we===void 0)return-1;if(we!==Pe)return D(we,Pe)}while(++me)},V.prototype.inc=function(le,me){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var we=this.prerelease.length;--we>=0;)typeof this.prerelease[we]=="number"&&(this.prerelease[we]++,we=-2);we===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,me,we,Pe){typeof we=="string"&&(Pe=we,we=void 0);try{return new V(le,we).inc(me,Pe).version}catch{return null}},e.diff=function(le,me){if(K(le,me))return null;var we=te(le),Pe=te(me);if(we.prerelease.length||Pe.prerelease.length){for(var Ie in we)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&we[Ie]!==Pe[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in we)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&we[Ie]!==Pe[Ie])return Ie},e.compareIdentifiers=D;var U=/^[0-9]+$/;function D(le,me){var we=U.test(le),Pe=U.test(me);return we&&Pe&&(le=+le,me=+me),we&&!Pe?-1:Pe&&!we?1:le<me?-1:le>me?1:0}function M(le,me,we){return new V(le,we).compare(new V(me,we))}function z(le,me,we){return M(le,me,we)>0}function x(le,me,we){return M(le,me,we)<0}function K(le,me,we){return M(le,me,we)===0}function ee(le,me,we){return M(le,me,we)!==0}function _(le,me,we){return M(le,me,we)>=0}function Y(le,me,we){return M(le,me,we)<=0}function se(le,me,we,Pe){var Ie;switch(me){case"===":typeof le=="object"&&(le=le.version),typeof we=="object"&&(we=we.version),Ie=le===we;break;case"!==":typeof le=="object"&&(le=le.version),typeof we=="object"&&(we=we.version),Ie=le!==we;break;case"":case"=":case"==":Ie=K(le,we,Pe);break;case"!=":Ie=ee(le,we,Pe);break;case">":Ie=z(le,we,Pe);break;case">=":Ie=_(le,we,Pe);break;case"<":Ie=x(le,we,Pe);break;case"<=":Ie=Y(le,we,Pe);break;default:throw new TypeError("Invalid operator: "+me)}return Ie}function ue(le,me){if(le instanceof ue){if(le.loose===me)return le;le=le.value}if(!(this instanceof ue))return new ue(le,me);L("comparator",le,me),this.loose=me,this.parse(le),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(le,me){return D(me,le)},e.major=function(le,me){return new V(le,me).major},e.minor=function(le,me){return new V(le,me).minor},e.patch=function(le,me){return new V(le,me).patch},e.compare=M,e.compareLoose=function(le,me){return M(le,me,!0)},e.rcompare=function(le,me,we){return M(me,le,we)},e.sort=function(le,me){return le.sort(function(we,Pe){return e.compare(we,Pe,me)})},e.rsort=function(le,me){return le.sort(function(we,Pe){return e.rcompare(we,Pe,me)})},e.gt=z,e.lt=x,e.eq=K,e.neq=ee,e.gte=_,e.lte=Y,e.cmp=se,e.Comparator=ue;var ge={};function fe(le,me){if(le instanceof fe)return le.loose===me?le:new fe(le.raw,me);if(le instanceof ue)return new fe(le.value,me);if(!(this instanceof fe))return new fe(le,me);if(this.loose=me,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(we){return this.parseRange(we.trim())},this).filter(function(we){return we.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function $e(le){return!le||le.toLowerCase()==="x"||le==="*"}function ye(le,me,we,Pe,Ie,Fe,Oe,qe,Me,ze,Ue,je,oe){return((me=$e(we)?"":$e(Pe)?">="+we+".0.0":$e(Ie)?">="+we+"."+Pe+".0":">="+me)+" "+(qe=$e(Me)?"":$e(ze)?"<"+(+Me+1)+".0.0":$e(Ue)?"<"+Me+"."+(+ze+1)+".0":je?"<="+Me+"."+ze+"."+Ue+"-"+je:"<="+qe)).trim()}function ve(le,me){for(var we=0;we<le.length;we++)if(!le[we].test(me))return!1;if(me.prerelease.length){for(we=0;we<le.length;we++)if(L(le[we].semver),le[we].semver!==ge&&le[we].semver.prerelease.length>0){var Pe=le[we].semver;if(Pe.major===me.major&&Pe.minor===me.minor&&Pe.patch===me.patch)return!0}return!1}return!0}function Ce(le,me,we){try{me=new fe(me,we)}catch{return!1}return me.test(le)}function Ae(le,me,we,Pe){var Ie,Fe,Oe,qe,Me;switch(le=new V(le,Pe),me=new fe(me,Pe),we){case">":Ie=z,Fe=Y,Oe=x,qe=">",Me=">=";break;case"<":Ie=x,Fe=_,Oe=z,qe="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(le,me,Pe))return!1;for(var ze=0;ze<me.set.length;++ze){var Ue=me.set[ze],je=null,oe=null;if(Ue.forEach(function(de){de.semver===ge&&(de=new ue(">=0.0.0")),je=je||de,oe=oe||de,Ie(de.semver,je.semver,Pe)?je=de:Oe(de.semver,oe.semver,Pe)&&(oe=de)}),je.operator===qe||je.operator===Me||(!oe.operator||oe.operator===qe)&&Fe(le,oe.semver)||oe.operator===Me&&Oe(le,oe.semver))return!1}return!0}ue.prototype.parse=function(le){var me=this.loose?R[W]:R[J],we=le.match(me);if(!we)throw new TypeError("Invalid comparator: "+le);this.operator=we[1],this.operator==="="&&(this.operator=""),we[2]?this.semver=new V(we[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(le){return L("Comparator.test",le,this.loose),this.semver===ge||(typeof le=="string"&&(le=new V(le,this.loose)),se(le,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(le,me){if(!(le instanceof ue))throw new TypeError("a Comparator is required");var we;if(this.operator==="")return we=new fe(le.value,me),Ce(this.value,we,me);if(le.operator==="")return we=new fe(this.value,me),Ce(le.semver,we,me);var Pe=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Fe=this.semver.version===le.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),qe=se(this.semver,"<",le.semver,me)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Me=se(this.semver,">",le.semver,me)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Pe||Ie||Fe&&Oe||qe||Me},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(le){var me=this.loose;le=le.trim(),L("range",le,me);var we=me?R[ie]:R[B];le=le.replace(we,ye),L("hyphen replace",le),le=le.replace(R[H],"$1$2$3"),L("comparator trim",le,R[H]),le=(le=(le=le.replace(R[I],"$1~")).replace(R[X],"$1^")).split(/\s+/).join(" ");var Pe=me?R[W]:R[J],Ie=le.split(" ").map(function(Fe){return function(Oe,qe){return L("comp",Oe),Oe=function(Me,ze){return Me.trim().split(/\s+/).map(function(Ue){return function(je,oe){L("caret",je,oe);var de=oe?R[Q]:R[G];return je.replace(de,function(pe,be,Se,Re,De){var Ne;return L("caret",je,pe,be,Se,Re,De),$e(be)?Ne="":$e(Se)?Ne=">="+be+".0.0 <"+(+be+1)+".0.0":$e(Re)?Ne=be==="0"?">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+".0 <"+(+be+1)+".0.0":De?(L("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ne=be==="0"?Se==="0"?">="+be+"."+Se+"."+Re+De+" <"+be+"."+Se+"."+(+Re+1):">="+be+"."+Se+"."+Re+De+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Re+De+" <"+(+be+1)+".0.0"):(L("no pr"),Ne=be==="0"?Se==="0"?">="+be+"."+Se+"."+Re+" <"+be+"."+Se+"."+(+Re+1):">="+be+"."+Se+"."+Re+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Re+" <"+(+be+1)+".0.0"),L("caret return",Ne),Ne})}(Ue,ze)}).join(" ")}(Oe,qe),L("caret",Oe),Oe=function(Me,ze){return Me.trim().split(/\s+/).map(function(Ue){return function(je,oe){var de=oe?R[T]:R[F];return je.replace(de,function(pe,be,Se,Re,De){var Ne;return L("tilde",je,pe,be,Se,Re,De),$e(be)?Ne="":$e(Se)?Ne=">="+be+".0.0 <"+(+be+1)+".0.0":$e(Re)?Ne=">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":De?(L("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ne=">="+be+"."+Se+"."+Re+De+" <"+be+"."+(+Se+1)+".0"):Ne=">="+be+"."+Se+"."+Re+" <"+be+"."+(+Se+1)+".0",L("tilde return",Ne),Ne})}(Ue,ze)}).join(" ")}(Oe,qe),L("tildes",Oe),Oe=function(Me,ze){return L("replaceXRanges",Me,ze),Me.split(/\s+/).map(function(Ue){return function(je,oe){je=je.trim();var de=oe?R[v]:R[S];return je.replace(de,function(pe,be,Se,Re,De,Ne){L("xRange",je,pe,be,Se,Re,De,Ne);var We=$e(Se),Be=We||$e(Re),Te=Be||$e(De);return be==="="&&Te&&(be=""),We?pe=be===">"||be==="<"?"<0.0.0":"*":be&&Te?(Be&&(Re=0),Te&&(De=0),be===">"?(be=">=",Be?(Se=+Se+1,Re=0,De=0):Te&&(Re=+Re+1,De=0)):be==="<="&&(be="<",Be?Se=+Se+1:Re=+Re+1),pe=be+Se+"."+Re+"."+De):Be?pe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Te&&(pe=">="+Se+"."+Re+".0 <"+Se+"."+(+Re+1)+".0"),L("xRange return",pe),pe})}(Ue,ze)}).join(" ")}(Oe,qe),L("xrange",Oe),Oe=function(Me,ze){return L("replaceStars",Me,ze),Me.trim().replace(R[re],"")}(Oe,qe),L("stars",Oe),Oe}(Fe,me)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Fe){return!!Fe.match(Pe)})),Ie=Ie.map(function(Fe){return new ue(Fe,me)})},fe.prototype.intersects=function(le,me){if(!(le instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(we){return we.every(function(Pe){return le.set.some(function(Ie){return Ie.every(function(Fe){return Pe.intersects(Fe,me)})})})})},e.toComparators=function(le,me){return new fe(le,me).set.map(function(we){return we.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new V(le,this.loose));for(var me=0;me<this.set.length;me++)if(ve(this.set[me],le))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(le,me,we){var Pe=null,Ie=null;try{var Fe=new fe(me,we)}catch{return null}return le.forEach(function(Oe){Fe.test(Oe)&&(Pe&&Ie.compare(Oe)!==-1||(Ie=new V(Pe=Oe,we)))}),Pe},e.minSatisfying=function(le,me,we){var Pe=null,Ie=null;try{var Fe=new fe(me,we)}catch{return null}return le.forEach(function(Oe){Fe.test(Oe)&&(Pe&&Ie.compare(Oe)!==1||(Ie=new V(Pe=Oe,we)))}),Pe},e.validRange=function(le,me){try{return new fe(le,me).range||"*"}catch{return null}},e.ltr=function(le,me,we){return Ae(le,me,"<",we)},e.gtr=function(le,me,we){return Ae(le,me,">",we)},e.outside=Ae,e.prerelease=function(le,me){var we=te(le,me);return we&&we.prerelease.length?we.prerelease:null},e.intersects=function(le,me,we){return le=new fe(le,we),me=new fe(me,we),le.intersects(me)},e.coerce=function(le){if(le instanceof V)return le;if(typeof le!="string")return null;var me=le.match(R[k]);return me==null?null:te((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,A(1))},function(ne,e){var A,N,L=ne.exports={};function j(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function R(g){if(A===setTimeout)return setTimeout(g,0);if((A===j||!A)&&setTimeout)return A=setTimeout,setTimeout(g,0);try{return A(g,0)}catch{try{return A.call(null,g,0)}catch{return A.call(this,g,0)}}}(function(){try{A=typeof setTimeout=="function"?setTimeout:j}catch{A=j}try{N=typeof clearTimeout=="function"?clearTimeout:O}catch{N=O}})();var C,f=[],E=!1,y=-1;function w(){E&&C&&(E=!1,C.length?f=C.concat(f):y=-1,f.length&&h())}function h(){if(!E){var g=R(w);E=!0;for(var l=f.length;l;){for(C=f,f=[];++y<l;)C&&C[y].run();y=-1,l=f.length}C=null,E=!1,function(u){if(N===clearTimeout)return clearTimeout(u);if((N===O||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(u);try{N(u)}catch{try{return N.call(null,u)}catch{return N.call(this,u)}}}(g)}}function c(g,l){this.fun=g,this.array=l}function p(){}L.nextTick=function(g){var l=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)l[u-1]=arguments[u];f.push(new c(g,l)),f.length!==1||E||R(h)},c.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=p,L.addListener=p,L.once=p,L.off=p,L.removeListener=p,L.removeAllListeners=p,L.emit=p,L.prependListener=p,L.prependOnceListener=p,L.listeners=function(g){return[]},L.binding=function(g){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(g){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ae[128],ce([0,1]),function(ne,e){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0;class N{constructor(R,C,f){this.level=R,this.key=C,this.value=f,this.forward=[]}}const L=void 0;class j{constructor(R,C=2**16){this.comparator=R,this[A]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(C)|0),this.e=new N(this.c,L,L)}get size(){return this.f}clear(){this.e=new N(this.c,L,L),this.f=0}has(R){return!!j.g(this,R,this.comparator)}get(R){return j.g(this,R,this.comparator)?.value}set(R,C){return j.h(this,R,C,this.comparator)&&(this.f+=1),this}delete(R){const C=j.k(this,R,this.comparator);return C&&(this.f-=1),C}forEach(R,C){let f=this.e.forward[0];for(;f;)R.call(C,f.value,f.key,this),f=f.forward[0]}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",C=this.e.forward[0];for(;C;)R+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return R}static g(R,C,f){let E=R.e;for(let y=R.d-1;y>=0;y--)for(;E.forward[y]&&f(E.forward[y].key,C)<0;)E=E.forward[y];if(E=E.forward[0],E&&f(E.key,C)===0)return E}static h(R,C,f,E){const y=[];let w=R.e;for(let h=R.d-1;h>=0;h--){for(;w.forward[h]&&E(w.forward[h].key,C)<0;)w=w.forward[h];y[h]=w}if(w=w.forward[0],w&&E(w.key,C)===0)return w.value=f,!1;{const h=j.j(R);if(h>R.d){for(let c=R.d;c<h;c++)y[c]=R.e;R.d=h}w=new N(h,C,f);for(let c=0;c<h;c++)w.forward[c]=y[c].forward[c],y[c].forward[c]=w;return!0}}static j(R,C=.5){let f=1;for(;Math.random()<C&&f<R.c;)f+=1;return f}static k(R,C,f){const E=[];let y=R.e;for(let w=R.d-1;w>=0;w--){for(;y.forward[w]&&f(y.forward[w].key,C)<0;)y=y.forward[w];E[w]=y}if(y=y.forward[0],!y||f(y.key,C)!==0)return!1;for(let w=0;w<R.d&&E[w].forward[w]===y;w++)E[w].forward[w]=y.forward[w];for(;R.d>0&&R.e.forward[R.d-1]===L;)R.d-=1;return!0}}e.$ys=j}),define(ae[63],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0;const A=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(j){return new N(j)}constructor(j){this.c=A&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ae=N}),define(ae[3],ce([0,1,7,85,2,86,63]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$ce=e.Event=void 0,e.$de=h;const R=!1,C=!1,f=!1;var E;(function(I){I.None=()=>L.$Vc.None;function F(fe){if(f){const{onDidAddListener:$e}=fe,ye=p.create();let ve=0;fe.onDidAddListener=()=>{++ve===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ye.print()),$e?.()}}}function T(fe,$e){return re(fe,()=>{},0,void 0,!0,void 0,$e)}I.defer=T;function q(fe){return($e,ye=null,ve)=>{let Ce=!1,Ae;return Ae=fe(le=>{if(!Ce)return Ae?Ae.dispose():Ce=!0,$e.call(ye,le)},null,ve),Ce&&Ae.dispose(),Ae}}I.once=q;function X(fe,$e,ye){return B((ve,Ce=null,Ae)=>fe(le=>ve.call(Ce,$e(le)),null,Ae),ye)}I.map=X;function G(fe,$e,ye){return B((ve,Ce=null,Ae)=>fe(le=>{$e(le),ve.call(Ce,le)},null,Ae),ye)}I.forEach=G;function Q(fe,$e,ye){return B((ve,Ce=null,Ae)=>fe(le=>$e(le)&&ve.call(Ce,le),null,Ae),ye)}I.filter=Q;function W(fe){return fe}I.signal=W;function J(...fe){return($e,ye=null,ve)=>{const Ce=(0,L.$Sc)(...fe.map(Ae=>Ae(le=>$e.call(ye,le))));return ie(Ce,ve)}}I.any=J;function H(fe,$e,ye,ve){let Ce=ye;return X(fe,Ae=>(Ce=$e(Ce,Ae),Ce),ve)}I.reduce=H;function B(fe,$e){let ye;const ve={onWillAddFirstListener(){ye=fe(Ce.fire,Ce)},onDidRemoveLastListener(){ye?.dispose()}};$e||F(ve);const Ce=new $(ve);return $e?.add(Ce),Ce.event}function ie(fe,$e){return $e instanceof Array?$e.push(fe):$e&&$e.add(fe),fe}function re(fe,$e,ye=100,ve=!1,Ce=!1,Ae,le){let me,we,Pe,Ie=0,Fe;const Oe={leakWarningThreshold:Ae,onWillAddFirstListener(){me=fe(Me=>{Ie++,we=$e(we,Me),ve&&!Pe&&(qe.fire(we),we=void 0),Fe=()=>{const ze=we;we=void 0,Pe=void 0,(!ve||Ie>1)&&qe.fire(ze),Ie=0},typeof ye=="number"?(clearTimeout(Pe),Pe=setTimeout(Fe,ye)):Pe===void 0&&(Pe=0,queueMicrotask(Fe))})},onWillRemoveListener(){Ce&&Ie>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,me.dispose()}};le||F(Oe);const qe=new $(Oe);return le?.add(qe),qe.event}I.debounce=re;function he(fe,$e=0,ye){return I.debounce(fe,(ve,Ce)=>ve?(ve.push(Ce),ve):[Ce],$e,void 0,!0,void 0,ye)}I.accumulate=he;function te(fe,$e=(ve,Ce)=>ve===Ce,ye){let ve=!0,Ce;return Q(fe,Ae=>{const le=ve||!$e(Ae,Ce);return ve=!1,Ce=Ae,le},ye)}I.latch=te;function V(fe,$e,ye){return[I.filter(fe,$e,ye),I.filter(fe,ve=>!$e(ve),ye)]}I.split=V;function U(fe,$e=!1,ye=[],ve){let Ce=ye.slice(),Ae=fe(we=>{Ce?Ce.push(we):me.fire(we)});ve&&ve.add(Ae);const le=()=>{Ce?.forEach(we=>me.fire(we)),Ce=null},me=new $({onWillAddFirstListener(){Ae||(Ae=fe(we=>me.fire(we)),ve&&ve.add(Ae))},onDidAddFirstListener(){Ce&&($e?setTimeout(le):le())},onDidRemoveLastListener(){Ae&&Ae.dispose(),Ae=null}});return ve&&ve.add(me),me.event}I.buffer=U;function D(fe,$e){return(ve,Ce,Ae)=>{const le=$e(new z);return fe(function(me){const we=le.evaluate(me);we!==M&&ve.call(Ce,we)},void 0,Ae)}}I.chain=D;const M=Symbol("HaltChainable");class z{constructor(){this.f=[]}map($e){return this.f.push($e),this}forEach($e){return this.f.push(ye=>($e(ye),ye)),this}filter($e){return this.f.push(ye=>$e(ye)?ye:M),this}reduce($e,ye){let ve=ye;return this.f.push(Ce=>(ve=$e(ve,Ce),ve)),this}latch($e=(ye,ve)=>ye===ve){let ye=!0,ve;return this.f.push(Ce=>{const Ae=ye||!$e(Ce,ve);return ye=!1,ve=Ce,Ae?Ce:M}),this}evaluate($e){for(const ye of this.f)if($e=ye($e),$e===M)break;return $e}}function x(fe,$e,ye=ve=>ve){const ve=(...me)=>le.fire(ye(...me)),Ce=()=>fe.on($e,ve),Ae=()=>fe.removeListener($e,ve),le=new $({onWillAddFirstListener:Ce,onDidRemoveLastListener:Ae});return le.event}I.fromNodeEventEmitter=x;function K(fe,$e,ye=ve=>ve){const ve=(...me)=>le.fire(ye(...me)),Ce=()=>fe.addEventListener($e,ve),Ae=()=>fe.removeEventListener($e,ve),le=new $({onWillAddFirstListener:Ce,onDidRemoveLastListener:Ae});return le.event}I.fromDOMEventEmitter=K;function ee(fe){return new Promise($e=>q(fe)($e))}I.toPromise=ee;function _(fe){const $e=new $;return fe.then(ye=>{$e.fire(ye)},()=>{$e.fire(void 0)}).finally(()=>{$e.dispose()}),$e.event}I.fromPromise=_;function Y(fe,$e,ye){return $e(ye),fe(ve=>$e(ve))}I.runAndSubscribe=Y;class se{constructor($e,ye){this._observable=$e,this.f=0,this.g=!1;const ve={onWillAddFirstListener:()=>{$e.addObserver(this)},onDidRemoveLastListener:()=>{$e.removeObserver(this)}};ye||F(ve),this.emitter=new $(ve),ye&&ye.add(this.emitter)}beginUpdate($e){this.f++}handlePossibleChange($e){}handleChange($e,ye){this.g=!0}endUpdate($e){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ue(fe,$e){return new se(fe,$e).emitter.event}I.fromObservable=ue;function ge(fe){return($e,ye,ve)=>{let Ce=0,Ae=!1;const le={beginUpdate(){Ce++},endUpdate(){Ce--,Ce===0&&(fe.reportChanges(),Ae&&(Ae=!1,$e.call(ye)))},handlePossibleChange(){},handleChange(){Ae=!0}};fe.addObserver(le),fe.reportChanges();const me={dispose(){fe.removeObserver(le)}};return ve instanceof L.$Uc?ve.add(me):Array.isArray(ve)&&ve.push(me),me}}I.fromObservableLight=ge})(E||(e.Event=E={}));class y{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${y.f++}`,y.all.add(this)}start(F){this.g=new O.$ae,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$ce=y;let w=-1;function h(I){const F=w;return w=I,{dispose(){w=F}}}class c{constructor(F,T=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=T,this.g=0}dispose(){this.f?.clear()}check(F,T){const q=this.threshold;if(q<=0||T<q)return;this.f||(this.f=new Map);const X=this.f.get(F.value)||0;if(this.f.set(F.value,X+1),this.g-=1,this.g<=0){this.g=q*.5;let G,Q=0;for(const[W,J]of this.f)(!G||Q<J)&&(G=W,Q=J);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${Q}):`),console.warn(G)}return()=>{const G=this.f.get(F.value)||0;this.f.set(F.value,G-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let g=0;class l{constructor(F){this.value=F,this.id=g++}}const u=2,m=(I,F)=>{if(I instanceof l)F(I);else for(let T=0;T<I.length;T++){const q=I[T];q&&F(q)}},d=R?new FinalizationRegistry(I=>{typeof I=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(I))}):void 0;class ${constructor(F){this.w=0,this.f=F,this.g=w>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??w):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(C){const F=this.t;queueMicrotask(()=>{m(F,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,T,q)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Vc.None;if(this.m)return L.$Vc.None;T&&(F=F.bind(T));const X=new l(F);let G,Q;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(X.stack=p.create(),G=this.g.check(X.stack,this.w+1)),C&&(X.stack=Q??p.create()),this.t?this.t instanceof l?(this.u??=new r,this.t=[this.t,X]):this.t.push(X):(this.f?.onWillAddFirstListener?.(this),this.t=X,this.f?.onDidAddFirstListener?.(this)),this.w++;const W=(0,L.$Tc)(()=>{d?.unregister(W),G?.(),this.x(X)});if(q instanceof L.$Uc?q.add(W):Array.isArray(q)&&q.push(W),d){const J=new Error().stack.split(`
`).slice(2).join(`
`).trim();d.register(W,J,W)}return W},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,q=T.indexOf(F);if(q===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[q]=void 0;const X=this.u.current===this;if(this.w*u<=T.length){let G=0;for(let Q=0;Q<T.length;Q++)T[Q]?T[G++]=T[Q]:X&&(this.u.end--,G<this.u.i&&this.u.i--);T.length=G}}y(F,T){if(!F)return;const q=this.f?.onListenerError||A.$1;if(!q){F.value(T);return}try{F.value(T)}catch(X){q(X)}}z(F){const T=F.current.t;for(;F.i<F.end;)this.y(T[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,F);else{const T=this.u;T.enqueue(this,F,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ee=$;const t=()=>new r;e.$fe=t;class r{constructor(){this.i=-1,this.end=0}enqueue(F,T,q){this.i=0,this.end=q,this.current=F,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends ${async fireAsync(F,T,q){if(this.t)for(this.h||(this.h=new j.$6c),m(this.t,X=>this.h.push([X.value,F]));this.h.size>0&&!T.isCancellationRequested;){const[X,G]=this.h.shift(),Q=[],W={...G,token:T,waitUntil:J=>{if(Object.isFrozen(Q))throw new Error("waitUntil can NOT be called asynchronous");q&&(J=q(J,X)),Q.push(J)}};try{X(W)}catch(J){(0,A.$1)(J);continue}Object.freeze(Q),await Promise.allSettled(Q).then(J=>{for(const H of J)H.status==="rejected"&&(0,A.$1)(H.reason)})}}}e.$ge=n;class s extends ${get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new j.$6c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$he=s;class i extends s{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$ie=i;class o extends ${constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}e.$je=o;class a{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const T={event:F,listener:null};this.h.push(T),this.g&&this.m(T);const q=()=>{this.g&&this.o(T);const X=this.h.indexOf(T);this.h.splice(X,1)};return(0,L.$Tc)((0,N.$db)(q))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(T=>this.f.fire(T))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$ke=a;class b{constructor(F,T,q,X){this.f=new L.$Uc;const G=this.f.add(new a),Q=this.f.add(new L.$5c);function W(J){Q.set(J,G.add(X(J)))}for(const J of F)W(J);this.f.add(T(J=>{W(J)})),this.f.add(q(J=>{Q.deleteAndDispose(J)})),this.event=G.event}dispose(){this.f.dispose()}}e.$le=b;class S{constructor(){this.f=[]}wrapEvent(F){return(T,q,X)=>F(G=>{const Q=this.f[this.f.length-1];Q?Q.push(()=>T.call(q,G)):T.call(q,G)},void 0,X)}bufferEvents(F){const T=[];this.f.push(T);const q=F();return this.f.pop(),T.forEach(X=>X()),q}}e.$me=S;class v{constructor(){this.f=!1,this.g=E.None,this.h=L.$Vc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ne=v;class k{static const(F){return new P(F)}constructor(F){this.g=F,this.f=new $,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$oe=k;class P{constructor(F){this.value=F,this.onDidChange=E.None}}}),define(ae[26],ce([0,1,3]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.CancellationToken=void 0;const N=Object.freeze(function(R,C){const f=setTimeout(R.bind(C),0);return{dispose(){clearTimeout(f)}}});var L;(function(R){function C(f){return f===R.None||f===R.Cancelled||f instanceof j?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}R.isCancellationToken=C,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new A.$ee),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(C){this.f=void 0,this.g=void 0,this.g=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=L.Cancelled}dispose(C=!1){C&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=L.None}}e.$pe=O}),define(ae[129],ce([0,1,26]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4e=e.$3e=e.$1e=void 0,e.$2e=L;class N{constructor(C){this.b=C,this.a=null}get(){if(this.a)return this.a;const C=new A.$pe,f=this.b(C.token);return this.a={promise:f,dispose:()=>{this.a=null,C.cancel(),C.dispose()}},this.a}}e.$1e=N;function L(R){return R}class j{constructor(C,f){this.a=void 0,this.b=void 0,typeof C=="function"?(this.c=C,this.d=L):(this.c=f,this.d=C.getCacheKey)}get(C){const f=this.d(C);return this.b!==f&&(this.b=f,this.a=this.c(C)),this.a}}e.$3e=j;class O{get cachedValues(){return this.a}constructor(C,f){this.a=new Map,this.b=new Map,typeof C=="function"?(this.c=C,this.d=L):(this.c=f,this.d=C.getCacheKey)}get(C){const f=this.d(C);if(this.b.has(f))return this.b.get(f);const E=this.c(C);return this.a.set(C,E),this.b.set(f,E),E}}e.$4e=O}),define(ae[50],ce([0,1,7,2]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=L,e.$re=j,e.$se=O,e.$te=R,e.$ue=f,e.$ve=E,e.$we=y,e.$xe=w,e.$ye=h,e.$ze=c,e.$Ae=p,e.$Be=g,e.$Ce=l,e.$De=u,e.$Ee=m;function L(d){const $=d;return $?typeof $.read=="function":!1}function j(d){const $=d;return $?[$.on,$.pause,$.resume,$.destroy].every(t=>typeof t=="function"):!1}function O(d){const $=d;return $?j($.stream)&&Array.isArray($.buffer)&&typeof $.ended=="boolean":!1}function R(d,$){return new C(d,$)}class C{constructor($,t){this.e=$,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write($){if(!this.a.destroyed){if(this.a.flowing)this.g($);else if(this.b.data.push($),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error($){this.a.destroyed||(this.a.flowing?this.h($):this.b.error.push($))}end($){this.a.destroyed||(typeof $<"u"&&this.write($),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g($){this.c.data.slice(0).forEach(t=>t($))}h($){this.c.error.length===0?(0,A.$1)($):this.c.error.slice(0).forEach(t=>t($))}i(){this.c.end.slice(0).forEach($=>$())}on($,t){if(!this.a.destroyed)switch($){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener($,t){if(this.a.destroyed)return;let r;switch($){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const n=r.indexOf(t);n>=0&&r.splice(n,1)}}j(){if(this.b.data.length>0){const $=this.e(this.b.data);this.g($),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const $ of this.b.error)this.h($);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(d,$){const t=[];let r;for(;(r=d.read())!==null;)t.push(r);return $(t)}function E(d,$,t){const r=[];let n;for(;(n=d.read())!==null&&r.length<t;)r.push(n);return n===null&&r.length>0?$(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return d.read()}}}function y(d,$){return new Promise((t,r)=>{const n=[];w(d,{onData:s=>{$&&n.push(s)},onError:s=>{$?r(s):t(void 0)},onEnd:()=>{t($?$(n):void 0)}})})}function w(d,$,t){d.on("error",r=>{t?.isCancellationRequested||$.onError(r)}),d.on("end",()=>{t?.isCancellationRequested||$.onEnd()}),d.on("data",r=>{t?.isCancellationRequested||$.onData(r)})}function h(d,$){return new Promise((t,r)=>{const n=new N.$Uc,s=[],i=b=>{if(s.push(b),s.length>$)return n.dispose(),d.pause(),t({stream:d,buffer:s,ended:!1})},o=b=>(n.dispose(),r(b)),a=()=>(n.dispose(),t({stream:d,buffer:s,ended:!0}));n.add((0,N.$Tc)(()=>d.removeListener("error",o))),d.on("error",o),n.add((0,N.$Tc)(()=>d.removeListener("end",a))),d.on("end",a),n.add((0,N.$Tc)(()=>d.removeListener("data",i))),d.on("data",i)})}function c(d,$){const t=R($);return t.end(d),t}function p(){const d=R(()=>{throw new Error("not supported")});return d.end(),d}function g(d){let $=!1;return{read:()=>$?null:($=!0,d)}}function l(d,$,t){const r=R(t);return w(d,{onData:n=>r.write($.data(n)),onError:n=>r.error($.error?$.error(n):n),onEnd:()=>r.end()}),r}function u(d,$,t){let r=!1;return{read:()=>{const n=$.read();return r?n:(r=!0,n!==null?t([d,n]):d)}}}function m(d,$,t){let r=!1;const n=R(t);return w($,{onData:s=>r?n.write(s):(r=!0,n.write(t([d,s]))),onError:s=>n.error(s),onEnd:()=>{r||(r=!0,n.write(d)),n.end()}}),n}}),define(ae[15],ce([0,1,53,50]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=void 0,e.$Ge=f,e.$He=E,e.$Ie=y,e.$Je=w,e.$Ke=h,e.$Le=c,e.$Me=p,e.$Ne=g,e.$Oe=l,e.$Pe=u,e.$Qe=m,e.$Re=d,e.$Se=$,e.$Te=t,e.$Ue=r,e.$Ve=n,e.$We=s,e.$Xe=i,e.$Ye=o,e.$Ze=S;const L=typeof Buffer<"u",j=new A.$V(()=>new Uint8Array(256));let O,R;class C{static alloc(k){return L?new C(Buffer.allocUnsafe(k)):new C(new Uint8Array(k))}static wrap(k){return L&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new C(k)}static fromString(k,P){return!(P?.dontUseNodeBuffer||!1)&&L?new C(Buffer.from(k)):(O||(O=new TextEncoder),new C(O.encode(k)))}static fromByteArray(k){const P=C.alloc(k.length);for(let I=0,F=k.length;I<F;I++)P.buffer[I]=k[I];return P}static concat(k,P){if(typeof P>"u"){P=0;for(let T=0,q=k.length;T<q;T++)P+=k[T].byteLength}const I=C.alloc(P);let F=0;for(let T=0,q=k.length;T<q;T++){const X=k[T];I.set(X,F),F+=X.byteLength}return I}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=C.alloc(this.byteLength);return k.set(this),k}toString(){return L?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(k,P){return new C(this.buffer.subarray(k,P))}set(k,P){if(k instanceof C)this.buffer.set(k.buffer,P);else if(k instanceof Uint8Array)this.buffer.set(k,P);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),P);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return w(this.buffer,k)}writeUInt32BE(k,P){h(this.buffer,k,P)}readUInt32LE(k){return c(this.buffer,k)}writeUInt32LE(k,P){p(this.buffer,k,P)}readUInt8(k){return g(this.buffer,k)}writeUInt8(k,P){l(this.buffer,k,P)}indexOf(k,P=0){return f(this.buffer,k instanceof C?k.buffer:k,P)}}e.$Fe=C;function f(v,k,P=0){const I=k.byteLength,F=v.byteLength;if(I===0)return 0;if(I===1)return v.indexOf(k[0]);if(I>F-P)return-1;const T=j.value;T.fill(k.length);for(let Q=0;Q<k.length;Q++)T[k[Q]]=k.length-Q-1;let q=P+k.length-1,X=q,G=-1;for(;q<F;)if(v[q]===k[X]){if(X===0){G=q;break}q--,X--}else q+=Math.max(k.length-X,T[v[q]]),X=k.length-1;return G}function E(v,k){return v[k+0]<<0>>>0|v[k+1]<<8>>>0}function y(v,k,P){v[P+0]=k&255,k=k>>>8,v[P+1]=k&255}function w(v,k){return v[k]*2**24+v[k+1]*2**16+v[k+2]*2**8+v[k+3]}function h(v,k,P){v[P+3]=k,k=k>>>8,v[P+2]=k,k=k>>>8,v[P+1]=k,k=k>>>8,v[P]=k}function c(v,k){return v[k+0]<<0>>>0|v[k+1]<<8>>>0|v[k+2]<<16>>>0|v[k+3]<<24>>>0}function p(v,k,P){v[P+0]=k&255,k=k>>>8,v[P+1]=k&255,k=k>>>8,v[P+2]=k&255,k=k>>>8,v[P+3]=k&255}function g(v,k){return v[k]}function l(v,k,P){v[P]=k}function u(v){return N.$ue(v,k=>C.concat(k))}function m(v){return N.$Be(v)}function d(v){return N.$we(v,k=>C.concat(k))}async function $(v){return v.ended?C.concat(v.buffer):C.concat([...v.buffer,await d(v.stream)])}function t(v){return N.$ze(v,k=>C.concat(k))}function r(v){return N.$Ce(v,{data:k=>typeof k=="string"?C.fromString(k):C.wrap(k)},k=>C.concat(k))}function n(v){return N.$te(k=>C.concat(k),v)}function s(v,k){return N.$De(v,k,P=>C.concat(P))}function i(v,k){return N.$Ee(v,k,P=>C.concat(P))}function o(v){let k=0,P=0,I=0;const F=new Uint8Array(Math.floor(v.length/4*3)),T=X=>{switch(P){case 3:F[I++]=k|X,P=0;break;case 2:F[I++]=k|X>>>2,k=X<<6,P=3;break;case 1:F[I++]=k|X>>>4,k=X<<4,P=2;break;default:k=X<<2,P=1}};for(let X=0;X<v.length;X++){const G=v.charCodeAt(X);if(G>=65&&G<=90)T(G-65);else if(G>=97&&G<=122)T(G-97+26);else if(G>=48&&G<=57)T(G-48+52);else if(G===43||G===45)T(62);else if(G===47||G===95)T(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${v[X]}`)}}const q=I;for(;P>0;)T(0);return C.wrap(F).slice(0,q)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:v},k=!0,P=!1){const I=P?b:a;let F="";const T=v.byteLength%3;let q=0;for(;q<v.byteLength-T;q+=3){const X=v[q+0],G=v[q+1],Q=v[q+2];F+=I[X>>>2],F+=I[(X<<4|G>>>4)&63],F+=I[(G<<2|Q>>>6)&63],F+=I[Q&63]}if(T===1){const X=v[q+0];F+=I[X>>>2],F+=I[X<<4&63],k&&(F+="==")}else if(T===2){const X=v[q+0],G=v[q+1];F+=I[X>>>2],F+=I[(X<<4|G>>>4)&63],F+=I[G<<2&63],k&&(F+="=")}return F}}),define(ae[27],ce([0,1,129,53]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.GraphemeBreakType=e.$Uf=e.$Nf=e.$Gf=e.$Ff=void 0,e.$7e=L,e.$8e=O,e.$9e=C,e.$0e=f,e.$$e=E,e.$_e=y,e.$af=w,e.$bf=h,e.$cf=c,e.$df=p,e.$ef=g,e.$ff=l,e.$gf=u,e.$hf=m,e.$if=d,e.$jf=$,e.$kf=t,e.$lf=r,e.$mf=n,e.$nf=s,e.$of=i,e.$pf=o,e.$qf=a,e.$rf=b,e.$sf=S,e.$tf=v,e.$uf=k,e.$vf=P,e.$wf=I,e.$xf=F,e.$yf=T,e.$zf=q,e.$Af=X,e.$Bf=G,e.$Cf=Q,e.$Df=W,e.$Ef=J,e.$Hf=re,e.$If=he,e.$Jf=te,e.$Kf=V,e.$Lf=M,e.$Mf=x,e.$Of=K,e.$Pf=ee,e.$Qf=_,e.$Rf=Y,e.$Sf=ue,e.$Tf=ge,e.$Vf=fe,e.$Wf=$e,e.$Xf=ye,e.$Yf=ve,e.$Zf=Ce,e.$1f=Ae,e.$2f=le,e.$3f=me,e.$4f=Oe;function L(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}const j=/{(\d+)}/g;function O(oe,...de){return de.length===0?oe:oe.replace(j,function(pe,be){const Se=parseInt(be,10);return isNaN(Se)||Se<0||Se>=de.length?pe:de[Se]})}const R=/{([^}]+)}/g;function C(oe,de){return Object.keys(de).length===0?oe:oe.replace(R,(pe,be)=>de[be]??pe)}function f(oe){return oe.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}function E(oe){return oe.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}function y(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function w(oe,de){let pe=0;const be=de.charCodeAt(0);for(let Se=oe.length-1;Se>=0;Se--)oe.charCodeAt(Se)===be&&pe++;return pe}function h(oe,de,pe="\u2026"){return oe.length<=de?oe:`${oe.substr(0,de)}${pe}`}function c(oe,de,pe="\u2026"){if(oe.length<=de)return oe;const be=Math.ceil(de/2)-pe.length/2,Se=Math.floor(de/2)-pe.length/2;return`${oe.substr(0,be)}${pe}${oe.substr(oe.length-Se)}`}function p(oe,de=" "){const pe=g(oe,de);return l(pe,de)}function g(oe,de){if(!oe||!de)return oe;const pe=de.length;if(pe===0||oe.length===0)return oe;let be=0;for(;oe.indexOf(de,be)===be;)be=be+pe;return oe.substring(be)}function l(oe,de){if(!oe||!de)return oe;const pe=de.length,be=oe.length;if(pe===0||be===0)return oe;let Se=be,Re=-1;for(;Re=oe.lastIndexOf(de,Se-1),!(Re===-1||Re+pe!==Se);){if(Re===0)return"";Se=Re}return oe.substring(0,Se)}function u(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function m(oe){return oe.replace(/\*/g,"")}function d(oe,de,pe={}){if(!oe)throw new Error("Cannot create regex from empty string");de||(oe=y(oe)),pe.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let be="";return pe.global&&(be+="g"),pe.matchCase||(be+="i"),pe.multiline&&(be+="m"),pe.unicode&&(be+="u"),new RegExp(oe,be)}function $(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}function t(oe){return oe.split(/\r\n|\r|\n/)}function r(oe){const de=[],pe=oe.split(/(\r\n|\r|\n)/);for(let be=0;be<Math.ceil(pe.length/2);be++)de.push(pe[2*be]+(pe[2*be+1]??""));return de}function n(oe){for(let de=0,pe=oe.length;de<pe;de++){const be=oe.charCodeAt(de);if(be!==32&&be!==9)return de}return-1}function s(oe,de=0,pe=oe.length){for(let be=de;be<pe;be++){const Se=oe.charCodeAt(be);if(Se!==32&&Se!==9)return oe.substring(de,be)}return oe.substring(de,pe)}function i(oe,de=oe.length-1){for(let pe=de;pe>=0;pe--){const be=oe.charCodeAt(pe);if(be!==32&&be!==9)return pe}return-1}function o(oe,de,pe){const be=[];let Se=0;for(const Re of oe.matchAll(de)){if(be.push(oe.slice(Se,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Se=Re.index+Re[0].length,be.push(pe(Re[0],...Re.slice(1),Re.index,oe,Re.groups))}return be.push(oe.slice(Se)),Promise.all(be).then(Re=>Re.join(""))}function a(oe,de){return oe<de?-1:oe>de?1:0}function b(oe,de,pe=0,be=oe.length,Se=0,Re=de.length){for(;pe<be&&Se<Re;pe++,Se++){const We=oe.charCodeAt(pe),Be=de.charCodeAt(Se);if(We<Be)return-1;if(We>Be)return 1}const De=be-pe,Ne=Re-Se;return De<Ne?-1:De>Ne?1:0}function S(oe,de){return v(oe,de,0,oe.length,0,de.length)}function v(oe,de,pe=0,be=oe.length,Se=0,Re=de.length){for(;pe<be&&Se<Re;pe++,Se++){let We=oe.charCodeAt(pe),Be=de.charCodeAt(Se);if(We===Be)continue;if(We>=128||Be>=128)return b(oe.toLowerCase(),de.toLowerCase(),pe,be,Se,Re);P(We)&&(We-=32),P(Be)&&(Be-=32);const Te=We-Be;if(Te!==0)return Te}const De=be-pe,Ne=Re-Se;return De<Ne?-1:De>Ne?1:0}function k(oe){return oe>=48&&oe<=57}function P(oe){return oe>=97&&oe<=122}function I(oe){return oe>=65&&oe<=90}function F(oe,de){return oe.length===de.length&&v(oe,de)===0}function T(oe,de){const pe=de.length;return de.length>oe.length?!1:v(oe,de,0,pe)===0}function q(oe,de){const pe=Math.min(oe.length,de.length);let be;for(be=0;be<pe;be++)if(oe.charCodeAt(be)!==de.charCodeAt(be))return be;return pe}function X(oe,de){const pe=Math.min(oe.length,de.length);let be;const Se=oe.length-1,Re=de.length-1;for(be=0;be<pe;be++)if(oe.charCodeAt(Se-be)!==de.charCodeAt(Re-be))return be;return pe}function G(oe){return 55296<=oe&&oe<=56319}function Q(oe){return 56320<=oe&&oe<=57343}function W(oe,de){return(oe-55296<<10)+(de-56320)+65536}function J(oe,de,pe){const be=oe.charCodeAt(pe);if(G(be)&&pe+1<de){const Se=oe.charCodeAt(pe+1);if(Q(Se))return W(be,Se)}return be}function H(oe,de){const pe=oe.charCodeAt(de-1);if(Q(pe)&&de>1){const be=oe.charCodeAt(de-2);if(G(be))return W(be,pe)}return pe}class B{get offset(){return this.e}constructor(de,pe=0){this.c=de,this.d=de.length,this.e=pe}setOffset(de){this.e=de}prevCodePoint(){const de=H(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=J(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$Ff=B;class ie{get offset(){return this.c.offset}constructor(de,pe=0){this.c=new B(de,pe)}nextGraphemeLength(){const de=Ie.getInstance(),pe=this.c,be=pe.offset;let Se=de.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Re=pe.offset,De=de.getGraphemeBreakType(pe.nextCodePoint());if(we(Se,De)){pe.setOffset(Re);break}Se=De}return pe.offset-be}prevGraphemeLength(){const de=Ie.getInstance(),pe=this.c,be=pe.offset;let Se=de.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Re=pe.offset,De=de.getGraphemeBreakType(pe.prevCodePoint());if(we(De,Se)){pe.setOffset(Re);break}Se=De}return be-pe.offset}eol(){return this.c.eol()}}e.$Gf=ie;function re(oe,de){return new ie(oe,de).nextGraphemeLength()}function he(oe,de){return new ie(oe,de).prevGraphemeLength()}function te(oe,de){de>0&&Q(oe.charCodeAt(de))&&de--;const pe=de+re(oe,de);return[pe-he(oe,pe),pe]}function V(oe){const de=new ie(oe);let pe=0;for(;!de.eol();)pe++,de.nextGraphemeLength();return pe}let U;function D(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function M(oe){return U||(U=D()),U.test(oe)}const z=/^[\t\n\r\x20-\x7E]*$/;function x(oe){return z.test(oe)}e.$Nf=/[\u2028\u2029]/;function K(oe){return e.$Nf.test(oe)}function ee(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}function _(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}function Y(oe,de,pe=""){const be=oe.trimStart();if(be.length<de)return be;const Se=/\b/g;let Re=0;for(;Se.test(be)&&!(be.length-Se.lastIndex<de);)Re=Se.lastIndex,Se.lastIndex+=1;return Re===0?be:pe+be.substring(Re).trimStart()}const se=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ue(oe){let de=0;for(const pe of oe.matchAll(se))de!==pe.index&&(yield{isCode:!1,str:oe.substring(de,pe.index)}),yield{isCode:!0,str:pe[0]},de=pe.index+pe[0].length;de!==oe.length&&(yield{isCode:!1,str:oe.substring(de)})}function ge(oe){return oe&&(oe=oe.replace(se,"")),oe}e.$Uf="\uFEFF";function fe(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}function $e(oe){return fe(oe)?oe.substr(1):oe}function ye(oe,de){if(!oe||!de||oe.length<de.length)return!1;const pe=de.length,be=oe.toLowerCase();let Se=0,Re=-1;for(;Se<pe;){const De=be.indexOf(de[Se],Re+1);if(De<0)return!1;Re=De,Se++}return!0}function ve(oe,de=!1){return oe?(de&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}function Ce(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}function Ae(oe,de=1){if(de===0)return"";let pe=-1;do pe=oe.indexOf(`
`,pe+1),de--;while(de>0&&pe>=0);return pe===-1?oe:(oe[pe-1]==="\r"&&pe--,oe.substr(0,pe))}function le(oe){return oe=oe%(2*26),oe<26?String.fromCharCode(97+oe):String.fromCharCode(65+oe-26)}function me(oe){return Ie.getInstance().getGraphemeBreakType(oe)}function we(oe,de){return oe===0?de!==5&&de!==7:oe===2&&de===3?!1:oe===4||oe===2||oe===3||de===4||de===2||de===3?!0:!(oe===8&&(de===8||de===9||de===11||de===12)||(oe===11||oe===9)&&(de===9||de===10)||(oe===12||oe===10)&&de===10||de===5||de===13||de===7||oe===1||oe===13&&de===14||oe===6&&de===6)}var Pe;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(e.GraphemeBreakType=Pe={}));class Ie{static{this.c=null}static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Fe()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const pe=this.d,be=pe.length/3;let Se=1;for(;Se<=be;)if(de<pe[3*Se])Se=2*Se;else if(de>pe[3*Se+1])Se=2*Se+1;else return pe[3*Se+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Oe(oe,de){if(oe===0)return 0;const pe=qe(oe,de);if(pe!==void 0)return pe;const be=new B(de,oe);return be.prevCodePoint(),be.offset}function qe(oe,de){const pe=new B(de,oe);let be=pe.prevCodePoint();for(;Me(be)||be===65039||be===8419;){if(pe.offset===0)return;be=pe.prevCodePoint()}if(!_(be))return;let Se=pe.offset;return Se>0&&pe.prevCodePoint()===8205&&(Se=pe.offset),Se}function Me(oe){return 127995<=oe&&oe<=127999}var ze;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$5f="\xA0";class Ue{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new A.$3e({getCacheKey:JSON.stringify},de=>{function pe(Te){const Ze=new Map;for(let Ge=0;Ge<Te.length;Ge+=2)Ze.set(Te[Ge],Te[Ge+1]);return Ze}function be(Te,Ze){const Ge=new Map(Te);for(const[_e,tt]of Ze)Ge.set(_e,tt);return Ge}function Se(Te,Ze){if(!Te)return Ze;const Ge=new Map;for(const[_e,tt]of Te)Ze.has(_e)&&Ge.set(_e,tt);return Ge}const Re=this.c.value;let De=de.filter(Te=>!Te.startsWith("_")&&Te in Re);De.length===0&&(De=["_default"]);let Ne;for(const Te of De){const Ze=pe(Re[Te]);Ne=Se(Ne,Ze)}const We=pe(Re._common),Be=be(We,Ne);return new Ue(Be)})}static getInstance(de){return Ue.d.get(Array.from(de))}static{this.e=new N.$V(()=>Object.keys(Ue.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return Ue.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$6f=Ue;class je{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(je.c())),this.d}static isInvisibleCharacter(de){return je.e().has(de)}static get codePoints(){return je.e()}}e.$7f=je}),define(ae[54],ce([0,1,27]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$nj=void 0,e.$jj=N,e.$kj=L,e.$lj=j,e.$mj=R,e.$oj=p;function N(l){return L(l,0)}function L(l,u){switch(typeof l){case"object":return l===null?j(349,u):Array.isArray(l)?C(l,u):f(l,u);case"string":return R(l,u);case"boolean":return O(l,u);case"number":return j(l,u);case"undefined":return j(937,u);default:return j(617,u)}}function j(l,u){return(u<<5)-u+l|0}function O(l,u){return j(l?433:863,u)}function R(l,u){u=j(149417,u);for(let m=0,d=l.length;m<d;m++)u=j(l.charCodeAt(m),u);return u}function C(l,u){return u=j(104579,u),l.reduce((m,d)=>L(d,m),u)}function f(l,u){return u=j(181387,u),Object.keys(l).sort().reduce((m,d)=>(m=R(d,m),L(l[d],m)),u)}class E{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=L(u,this.g),this.g}}e.$nj=E;var y;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function w(l,u,m=32){const d=m-u,$=~((1<<d)-1);return(l<<u|($&l)>>>d)>>>0}function h(l,u=0,m=l.byteLength,d=0){for(let $=0;$<m;$++)l[u+$]=d}function c(l,u,m="0"){for(;l.length<u;)l=m+l;return l}function p(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(m=>m.toString(16).padStart(2,"0")).join(""):c((l>>>0).toString(16),u/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const m=u.length;if(m===0)return;const d=this.p;let $=this.r,t=this.u,r,n;for(t!==0?(r=t,n=-1,t=0):(r=u.charCodeAt(0),n=0);;){let s=r;if(A.$Bf(r))if(n+1<m){const i=u.charCodeAt(n+1);A.$Cf(i)?(n++,s=A.$Df(r,i)):s=65533}else{t=r;break}else A.$Cf(r)&&(s=65533);if($=this.w(d,$,s),n++,n<m)r=u.charCodeAt(n);else break}this.r=$,this.u=t}w(u,m,d){return d<128?u[m++]=d:d<2048?(u[m++]=192|(d&1984)>>>6,u[m++]=128|(d&63)>>>0):d<65536?(u[m++]=224|(d&61440)>>>12,u[m++]=128|(d&4032)>>>6,u[m++]=128|(d&63)>>>0):(u[m++]=240|(d&1835008)>>>18,u[m++]=128|(d&258048)>>>12,u[m++]=128|(d&4032)>>>6,u[m++]=128|(d&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,u[0]=u[64],u[1]=u[65],u[2]=u[66]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=g.g,m=this.q;for(let a=0;a<64;a+=4)u.setUint32(a,m.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)u.setUint32(a,w(u.getUint32(a-12,!1)^u.getUint32(a-32,!1)^u.getUint32(a-56,!1)^u.getUint32(a-64,!1),1),!1);let d=this.h,$=this.l,t=this.m,r=this.n,n=this.o,s,i,o;for(let a=0;a<80;a++)a<20?(s=$&t|~$&r,i=1518500249):a<40?(s=$^t^r,i=1859775393):a<60?(s=$&t|$&r|t&r,i=2400959708):(s=$^t^r,i=3395469782),o=w(d,5)+s+n+i+u.getUint32(a*4,!1)&4294967295,n=r,r=t,t=w($,30),$=d,d=o;this.h=this.h+d&4294967295,this.l=this.l+$&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+n&4294967295}}e.$pj=g}),define(ae[88],ce([0,1,27]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const j="error",O="warning",R="warn",C="info",f="ignore";function E(w){return w?A.$xf(j,w)?L.Error:A.$xf(O,w)||A.$xf(R,w)?L.Warning:A.$xf(C,w)?L.Info:L.Ignore:L.Ignore}L.fromValue=E;function y(w){switch(w){case L.Error:return j;case L.Warning:return O;case L.Info:return C;default:return f}}L.toString=y}(N||(N={})),e.default=N}),define(ae[130],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0,e.$be=Symbol("MicrotaskDelay")}),define(ae[51],ce([0,1,17,27]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=void 0;class L{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const c=h.charCodeAt(0),p=this.b.charCodeAt(this.c);return c-p}value(){return this.b[this.c]}}e.$xi=L;class j{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,N.$rf)(h,this.b,0,h.length,this.c,this.d):(0,N.$tf)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$yi=j;class O{constructor(h=!0,c=!0){this.f=h,this.g=c}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let c=h.length-1;c>=0;c--,this.c--){const p=this.b.charCodeAt(c);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===47||this.f&&c===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,N.$rf)(h,this.b,0,h.length,this.d,this.e):(0,N.$tf)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$zi=O;var R;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(R||(R={}));class C{constructor(h,c){this.f=h,this.g=c,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,N.$sf)(h,this.c.scheme);if(this.d[this.e]===2)return(0,N.$sf)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,N.$qf)(h,this.c.query);if(this.d[this.e]===5)return(0,N.$qf)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Ai=C;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(E||(E={}));class y{static forUris(h=()=>!1,c=()=>!1){return new y(new C(h,c))}static forPaths(h=!1){return new y(new O(void 0,!h))}static forStrings(){return new y(new L)}static forConfigKeys(){return new y(new j)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,c){if(c){const p=c.slice(0);(0,A.$Xb)(p);for(const g of p)this.set(g,h)}else{const p=h.slice(0);(0,A.$Xb)(p);for(const g of p)this.set(g[0],g[1])}}set(h,c){const p=this.b.reset(h);let g;this.c||(this.c=new f,this.c.segment=p.value());const l=[];for(g=this.c;;){const m=p.cmp(g.segment);if(m>0)g.left||(g.left=new f,g.left.segment=p.value()),l.push([-1,g]),g=g.left;else if(m<0)g.right||(g.right=new f,g.right.segment=p.value()),l.push([1,g]),g=g.right;else if(p.hasNext())p.next(),g.mid||(g.mid=new f,g.mid.segment=p.value()),l.push([0,g]),g=g.mid;else break}const u=g.value;g.value=c,g.key=h;for(let m=l.length-1;m>=0;m--){const d=l[m][1];d.updateHeight();const $=d.balanceFactor();if($<-1||$>1){const t=l[m][0],r=l[m+1][0];if(t===1&&r===1)l[m][1]=d.rotateLeft();else if(t===-1&&r===-1)l[m][1]=d.rotateRight();else if(t===1&&r===-1)d.right=l[m+1][1]=l[m+1][1].rotateRight(),l[m][1]=d.rotateLeft();else if(t===-1&&r===1)d.left=l[m+1][1]=l[m+1][1].rotateLeft(),l[m][1]=d.rotateRight();else throw new Error;if(m>0)switch(l[m-1][0]){case-1:l[m-1][1].left=l[m][1];break;case 1:l[m-1][1].right=l[m][1];break;case 0:l[m-1][1].mid=l[m][1];break}else this.c=l[0][1]}}return u}get(h){return this.d(h)?.value}d(h){const c=this.b.reset(h);let p=this.c;for(;p;){const g=c.cmp(p.segment);if(g>0)p=p.left;else if(g<0)p=p.right;else if(c.hasNext())c.next(),p=p.mid;else break}return p}has(h){const c=this.d(h);return!(c?.value===void 0&&c?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,c){const p=this.b.reset(h),g=[];let l=this.c;for(;l;){const u=p.cmp(l.segment);if(u>0)g.push([-1,l]),l=l.left;else if(u<0)g.push([1,l]),l=l.right;else if(p.hasNext())p.next(),g.push([0,l]),l=l.mid;else break}if(l){if(c?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const u=this.f(l.right);if(u.key){const{key:m,value:d,segment:$}=u;this.e(u.key,!1),l.key=m,l.value=d,l.segment=$}}else{const u=l.left??l.right;if(g.length>0){const[m,d]=g[g.length-1];switch(m){case-1:d.left=u;break;case 0:d.mid=u;break;case 1:d.right=u;break}}else this.c=u}for(let u=g.length-1;u>=0;u--){const m=g[u][1];m.updateHeight();const d=m.balanceFactor();if(d>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),g[u][1]=m.rotateLeft()):d<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),g[u][1]=m.rotateRight()),u>0)switch(g[u-1][0]){case-1:g[u-1][1].left=g[u][1];break;case 1:g[u-1][1].right=g[u][1];break;case 0:g[u-1][1].mid=g[u][1];break}else this.c=g[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const c=this.b.reset(h);let p=this.c,g;for(;p;){const l=c.cmp(p.segment);if(l>0)p=p.left;else if(l<0)p=p.right;else if(c.hasNext())c.next(),g=p.value||g,p=p.mid;else break}return p&&p.value||g}findSuperstr(h){return this.g(h,!1)}g(h,c){const p=this.b.reset(h);let g=this.c;for(;g;){const l=p.cmp(g.segment);if(l>0)g=g.left;else if(l<0)g=g.right;else if(p.hasNext())p.next(),g=g.mid;else return g.mid?this.h(g.mid):c?g.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[c,p]of this)h(p,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const c=[];return this.j(h,c),c[Symbol.iterator]()}j(h,c){h&&(h.left&&this.j(h.left,c),h.value&&c.push([h.key,h.value]),h.mid&&this.j(h.mid,c),h.right&&this.j(h.right,c))}_isBalanced(){const h=c=>{if(!c)return!0;const p=c.balanceFactor();return p<-1||p>1?!1:h(c.left)&&h(c.right)};return h(this.c)}}e.$Bi=y}),define(ae[13],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=A,e.$9f=N,e.$0f=L,e.$$f=j,e.$_f=O,e.$ag=R,e.$bg=C,e.$cg=f,e.$dg=E,e.$eg=y,e.$fg=w,e.$gg=h,e.$hg=c,e.$ig=g,e.$jg=l,e.$kg=u,e.$lg=m,e.$mg=d;function A($){return typeof $=="string"}function N($){return Array.isArray($)&&$.every(t=>A(t))}function L($){return typeof $=="object"&&$!==null&&!Array.isArray($)&&!($ instanceof RegExp)&&!($ instanceof Date)}function j($){const t=Object.getPrototypeOf(Uint8Array);return typeof $=="object"&&$ instanceof t}function O($){return typeof $=="number"&&!isNaN($)}function R($){return!!$&&typeof $[Symbol.iterator]=="function"}function C($){return $===!0||$===!1}function f($){return typeof $>"u"}function E($){return!y($)}function y($){return f($)||$===null}function w($,t){if(!$)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function h($){if(y($))throw new Error("Assertion Failed: argument is undefined or null");return $}function c(...$){const t=[];for(let r=0;r<$.length;r++){const n=$[r];if(y(n))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(n)}return t}const p=Object.prototype.hasOwnProperty;function g($){if(!L($))return!1;for(const t in $)if(p.call($,t))return!1;return!0}function l($){return typeof $=="function"}function u(...$){return $.length>0&&$.every(l)}function m($,t){const r=Math.min($.length,t.length);for(let n=0;n<r;n++)d($[n],t[n])}function d($,t){if(A(t)){if(typeof $!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(l(t)){try{if($ instanceof t)return}catch{}if(!y($)&&$.constructor===t||t.length===1&&t.call(void 0,$)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ae[30],ce([0,1,13]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=N,e.$3n=L,e.$4n=O,e.$5n=C,e.$6n=f,e.$7n=E,e.$8n=y,e.$9n=w,e.$0n=h,e.$$n=c,e.$_n=p,e.$ao=g;function N(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([m,d])=>{u[m]=d&&typeof d=="object"?N(d):d}),u}function L(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const m=u.shift();Object.freeze(m);for(const d in m)if(j.call(m,d)){const $=m[d];typeof $=="object"&&!Object.isFrozen($)&&!(0,A.$$f)($)&&u.push($)}}return l}const j=Object.prototype.hasOwnProperty;function O(l,u){return R(l,u,new Set)}function R(l,u,m){if((0,A.$eg)(l))return l;const d=u(l);if(typeof d<"u")return d;if(Array.isArray(l)){const $=[];for(const t of l)$.push(R(t,u,m));return $}if((0,A.$0f)(l)){if(m.has(l))throw new Error("Cannot clone recursive data-structure");m.add(l);const $={};for(const t in l)j.call(l,t)&&($[t]=R(l[t],u,m));return m.delete(l),$}return l}function C(l,u,m=!0){return(0,A.$0f)(l)?((0,A.$0f)(u)&&Object.keys(u).forEach(d=>{d in l?m&&((0,A.$0f)(l[d])&&(0,A.$0f)(u[d])?C(l[d],u[d],m):l[d]=u[d]):l[d]=u[d]}),l):u}function f(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let m,d;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(m=0;m<l.length;m++)if(!f(l[m],u[m]))return!1}else{const $=[];for(d in l)$.push(d);$.sort();const t=[];for(d in u)t.push(d);if(t.sort(),!f($,t))return!1;for(m=0;m<$.length;m++)if(!f(l[$[m]],u[$[m]]))return!1}return!0}function E(l){const u=new Set;return JSON.stringify(l,(m,d)=>{if((0,A.$0f)(d)||Array.isArray(d)){if(u.has(d))return"[Circular]";u.add(d)}return typeof d=="bigint"?`[BigInt ${d.toString()}]`:d})}function y(l,u){const m=Object.create(null);return!l||!u||Object.keys(u).forEach($=>{const t=l[$],r=u[$];f(t,r)||(m[$]=r)}),m}function w(l,u){const m=u.toLowerCase(),d=Object.keys(l).find($=>$.toLowerCase()===m);return d?l[d]:l[u]}function h(l,u){const m=Object.create(null);for(const[d,$]of Object.entries(l))u(d,$)&&(m[d]=$);return m}function c(l){let u=[];for(;Object.prototype!==l;)u=u.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return u}function p(l){const u=[];for(const m of c(l))typeof l[m]=="function"&&u.push(m);return u}function g(l,u){const m=$=>function(){const t=Array.prototype.slice.call(arguments,0);return u($,t)},d={};for(const $ of l)d[$]=m($);return d}}),define(ae[32],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=void 0,e.$Qg=N;const A=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return A.test(L)}e.$Rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(R){for(let C=0;C<R.length;C++)R[C]=Math.floor(Math.random()*256);return R};const j=new Uint8Array(16),O=[];for(let R=0;R<256;R++)O.push(R.toString(16).padStart(2,"0"));return function(){L(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let C=0,f="";return f+=O[j[C++]],f+=O[j[C++]],f+=O[j[C++]],f+=O[j[C++]],f+="-",f+=O[j[C++]],f+=O[j[C++]],f+="-",f+=O[j[C++]],f+=O[j[C++]],f+="-",f+=O[j[C++]],f+=O[j[C++]],f+="-",f+=O[j[C++]],f+=O[j[C++]],f+=O[j[C++]],f+=O[j[C++]],f+=O[j[C++]],f+=O[j[C++]],f}}()}),define(ae[131],ce([0,1,37]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cn=j;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(O){const R=O.replace(/\-/g,":").toLowerCase();return!N.has(R)}function j(){const O=(0,A.networkInterfaces)();for(const R in O){const C=O[R];if(C){for(const{mac:f}of C)if(L(f))return f}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ae[132],ce([0,1,273,15]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NW=void 0;class L extends A.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const R=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(O,R,C){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let f=0;for(;f<this.a.length;){const E=typeof this.b=="number"?this.a.indexOf(this.b,f):(0,N.$Ge)(this.a,this.b,f);if(E===-1)break;this.push(this.a.slice(f,E+this.c)),f=E+this.c}this.a=f===this.a.length?void 0:this.a.slice(f),C()}_flush(O){this.a&&this.push(this.a),O()}}e.$NW=L}),define(ae[133],ce([0,1,64]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=N,e.$Vg=j;function N(R,C,f,E=1){let y=!1;return new Promise(w=>{const h=setTimeout(()=>{if(!y)return y=!0,w(0)},f);L(R,C,E,c=>{if(!y)return y=!0,clearTimeout(h),w(c)})})}function L(R,C,f,E){if(C===0)return E(0);const y=new A.Socket;y.once("connect",()=>(O(y),L(R+f,C-1,f,E))),y.once("data",()=>{}),y.once("error",w=>(O(y),w.code!=="ECONNREFUSED"?L(R+f,C-1,f,E):E(R))),y.connect(R,"127.0.0.1")}e.$Ug={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(R,C,f,E="127.0.0.1"){let y=!1,w,h=1;const c=A.createServer({pauseOnConnect:!0});function p(g,l){y||(y=!0,c.removeAllListeners(),c.close(),w&&clearTimeout(w),l(g))}return new Promise(g=>{w=setTimeout(()=>{p(0,g)},f),c.on("listening",()=>{p(R,g)}),c.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&h<C?(R++,h++,c.listen(R,E)):p(0,g)}),c.on("close",()=>{p(0,g)}),c.listen(R,E)})}function O(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(C){console.error(C)}}}),define(ae[134],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6W=A;function A(N){return!!N.parentPort}}),define(ae[135],ce([11,10]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ae[65],ce([0,1,135]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=f,e.$2m=E,e.$3m=y;const N=60,L=N*60,j=L*24,O=j*7,R=j*30,C=j*365;function f(w,h,c,p){typeof w!="number"&&(w=w.getTime());const g=Math.round((new Date().getTime()-w)/1e3);if(g<-30)return(0,A.localize)(0,null,f(new Date().getTime()+g*1e3,!1));if(!p&&g<30)return(0,A.localize)(1,null);let l;return g<N?(l=g,h?l===1?c?(0,A.localize)(2,null,l):(0,A.localize)(3,null,l):c?(0,A.localize)(4,null,l):(0,A.localize)(5,null,l):l===1?c?(0,A.localize)(6,null,l):(0,A.localize)(7,null,l):c?(0,A.localize)(8,null,l):(0,A.localize)(9,null,l)):g<L?(l=Math.floor(g/N),h?l===1?c?(0,A.localize)(10,null,l):(0,A.localize)(11,null,l):c?(0,A.localize)(12,null,l):(0,A.localize)(13,null,l):l===1?c?(0,A.localize)(14,null,l):(0,A.localize)(15,null,l):c?(0,A.localize)(16,null,l):(0,A.localize)(17,null,l)):g<j?(l=Math.floor(g/L),h?l===1?c?(0,A.localize)(18,null,l):(0,A.localize)(19,null,l):c?(0,A.localize)(20,null,l):(0,A.localize)(21,null,l):l===1?c?(0,A.localize)(22,null,l):(0,A.localize)(23,null,l):c?(0,A.localize)(24,null,l):(0,A.localize)(25,null,l)):g<O?(l=Math.floor(g/j),h?l===1?(0,A.localize)(26,null,l):(0,A.localize)(27,null,l):l===1?(0,A.localize)(28,null,l):(0,A.localize)(29,null,l)):g<R?(l=Math.floor(g/O),h?l===1?c?(0,A.localize)(30,null,l):(0,A.localize)(31,null,l):c?(0,A.localize)(32,null,l):(0,A.localize)(33,null,l):l===1?c?(0,A.localize)(34,null,l):(0,A.localize)(35,null,l):c?(0,A.localize)(36,null,l):(0,A.localize)(37,null,l)):g<C?(l=Math.floor(g/R),h?l===1?c?(0,A.localize)(38,null,l):(0,A.localize)(39,null,l):c?(0,A.localize)(40,null,l):(0,A.localize)(41,null,l):l===1?c?(0,A.localize)(42,null,l):(0,A.localize)(43,null,l):c?(0,A.localize)(44,null,l):(0,A.localize)(45,null,l)):(l=Math.floor(g/C),h?l===1?c?(0,A.localize)(46,null,l):(0,A.localize)(47,null,l):c?(0,A.localize)(48,null,l):(0,A.localize)(49,null,l):l===1?c?(0,A.localize)(50,null,l):(0,A.localize)(51,null,l):c?(0,A.localize)(52,null,l):(0,A.localize)(53,null,l))}function E(w,h){const c=Math.abs(w/1e3);return c<1?h?(0,A.localize)(54,null,w):(0,A.localize)(55,null,w):c<N?h?(0,A.localize)(56,null,Math.round(w)/1e3):(0,A.localize)(57,null,Math.round(w)/1e3):c<L?h?(0,A.localize)(58,null,Math.round(w/(1e3*N))):(0,A.localize)(59,null,Math.round(w/(1e3*N))):c<j?h?(0,A.localize)(60,null,Math.round(w/(1e3*L))):(0,A.localize)(61,null,Math.round(w/(1e3*L))):(0,A.localize)(62,null,Math.round(w/(1e3*j)))}function y(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ae[136],ce([11,10]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ae[38],ce([0,1,17,13,136]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gj=C,e.$hj=f,e.$ij=E;function j(y,w){return w&&(y.stack||y.stacktrace)?L.localize(0,null,R(y),O(y.stack)||O(y.stacktrace)):R(y)}function O(y){return Array.isArray(y)?y.join(`
`):y}function R(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?L.localize(1,null,y.message):y.message||L.localize(2,null)}function C(y=null,w=!1){if(!y)return L.localize(3,null);if(Array.isArray(y)){const h=A.$Hb(y),c=C(h[0],w);return h.length>1?L.localize(4,null,c,h.length):c}if(N.$8f(y))return y;if(y.detail){const h=y.detail;if(h.error)return j(h.error,w);if(h.exception)return j(h.exception,w)}return y.stack?j(y,w):y.message?y.message:L.localize(5,null)}function f(y){const w=y;return w instanceof Error&&Array.isArray(w.actions)}function E(y,w){let h;return typeof y=="string"?h=new Error(y):h=y,h.actions=w,h}}),define(ae[137],ce([11,10]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(ae[138],ce([0,1,137]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=N;function N(L){switch(L){case 1:return(0,A.localize)(0,null);case 2:return(0,A.localize)(1,null);case 3:return(0,A.localize)(2,null);case 4:return(0,A.localize)(3,null);case 5:return(0,A.localize)(4,null);case 6:return(0,A.localize)(5,null);case 7:return(0,A.localize)(6,null);case 8:return(0,A.localize)(7,null);case 9:return(0,A.localize)(8,null);default:return""}}}),define(ae[139],ce([11,10]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ae[5],ce([0,1,139]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=r,e.$D=b,e.$J=S,e.$g="en";let N=!1,L=!1,j=!1,O=!1,R=!1,C=!1,f=!1,E=!1,y=!1,w=!1,h,c=e.$g,p=e.$g,g,l;const u=globalThis;let m;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?m=u.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(m=process);const d=typeof m?.versions?.electron=="string",$=d&&m?.type==="renderer";if(typeof m=="object"){N=m.platform==="win32",L=m.platform==="darwin",j=m.platform==="linux",O=j&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,f=d,y=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$g,c=e.$g;const v=m.env.VSCODE_NLS_CONFIG;if(v)try{const k=JSON.parse(v),P=k.availableLanguages["*"];h=k.locale,p=k.osLocale,c=P||e.$g,g=k._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!$?(l=navigator.userAgent,N=l.indexOf("Windows")>=0,L=l.indexOf("Macintosh")>=0,E=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=l.indexOf("Linux")>=0,w=l?.indexOf("Mobi")>=0,C=!0,h=A.getConfiguredDefaultLocale(A.localize(0,null))||e.$g,c=h,p=navigator.language):console.error("Unable to resolve platform.");var t;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let n=0;L?n=1:N?n=3:j&&(n=2),e.$i=N,e.$j=L,e.$k=j,e.$l=O,e.$m=R,e.$n=f,e.$o=C,e.$p=C&&typeof u.importScripts=="function",e.$q=e.$p?u.origin:void 0,e.$r=E,e.$s=w,e.$t=y,e.$u=n,e.$v=l,e.$w=c;var s;(function(v){function k(){return e.$w}v.value=k;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}v.isDefaultVariant=P;function I(){return e.$w==="en"}v.isDefault=I})(s||(e.Language=s={})),e.$x=h,e.$y=p,e.$z=g,e.$A=typeof u.postMessage=="function"&&!u.importScripts,e.$B=(()=>{if(e.$A){const v=[];u.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let I=0,F=v.length;I<F;I++){const T=v[I];if(T.id===P.data.vscodeScheduleAsyncWork){v.splice(I,1),T.callback();return}}});let k=0;return P=>{const I=++k;v.push({id:I,callback:P}),u.postMessage({vscodeScheduleAsyncWork:I},"*")}}return v=>setTimeout(v)})();var i;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=L||E?2:N?1:3;let o=!0,a=!1;function b(){if(!a){a=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,o=new Uint16Array(v.buffer)[0]===513}return o}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function S(v){return parseFloat(v)>=20}}),define(ae[36],ce([0,1,5]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const j=L.process;N={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return A.$i?"win32":A.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$ec=N.platform,e.$fc=N.arch}),define(ae[140],ce([0,1,36]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uW=O;var N;(function(R){R.UNKNOWN="UNKNOWN",R.CINNAMON="CINNAMON",R.DEEPIN="DEEPIN",R.GNOME="GNOME",R.KDE3="KDE3",R.KDE4="KDE4",R.KDE5="KDE5",R.KDE6="KDE6",R.PANTHEON="PANTHEON",R.UNITY="UNITY",R.XFCE="XFCE",R.UKUI="UKUI",R.LXQT="LXQT"})(N||(N={}));const L="XDG_CURRENT_DESKTOP",j="KDE_SESSION_VERSION";function O(){const R=A.env[L];if(R){const f=R.split(":").map(E=>E.trim()).filter(E=>E.length>0);for(const E of f)switch(E){case"Unity":{const y=A.env.DESKTOP_SESSION;return y&&y.includes("gnome-fallback")?N.GNOME:N.UNITY}case"Deepin":return N.DEEPIN;case"GNOME":return N.GNOME;case"X-Cinnamon":return N.CINNAMON;case"KDE":{const y=A.env[j];return y==="5"?N.KDE5:y==="6"?N.KDE6:N.KDE4}case"Pantheon":return N.PANTHEON;case"XFCE":return N.XFCE;case"UKUI":return N.UKUI;case"LXQt":return N.LXQT}}const C=A.env.DESKTOP_SESSION;if(C)switch(C){case"deepin":return N.DEEPIN;case"gnome":case"mate":return N.GNOME;case"kde4":case"kde-plasma":return N.KDE4;case"kde":return j in A.env?N.KDE4:N.KDE3;case"xfce":case"xubuntu":return N.XFCE;case"ukui":return N.UKUI}return"GNOME_DESKTOP_SESSION_ID"in A.env?N.GNOME:"KDE_FULL_SESSION"in A.env?j in A.env?N.KDE4:N.KDE3:N.UNKNOWN}}),define(ae[14],ce([0,1,36]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const N=65,L=97,j=90,O=122,R=46,C=47,f=92,E=58,y=63;class w extends Error{constructor(r,n,s){let i;typeof n=="string"&&n.indexOf("not ")===0?(i="must not be",n=n.replace(/^not /,"")):i="must be";const o=r.indexOf(".")!==-1?"property":"argument";let a=`The "${r}" ${o} ${i} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,r){if(t===null||typeof t!="object")throw new w(r,"Object",t)}function c(t,r){if(typeof t!="string")throw new w(r,"string",t)}const p=A.$ec==="win32";function g(t){return t===C||t===f}function l(t){return t===C}function u(t){return t>=N&&t<=j||t>=L&&t<=O}function m(t,r,n,s){let i="",o=0,a=-1,b=0,S=0;for(let v=0;v<=t.length;++v){if(v<t.length)S=t.charCodeAt(v);else{if(s(S))break;S=C}if(s(S)){if(!(a===v-1||b===1))if(b===2){if(i.length<2||o!==2||i.charCodeAt(i.length-1)!==R||i.charCodeAt(i.length-2)!==R){if(i.length>2){const k=i.lastIndexOf(n);k===-1?(i="",o=0):(i=i.slice(0,k),o=i.length-1-i.lastIndexOf(n)),a=v,b=0;continue}else if(i.length!==0){i="",o=0,a=v,b=0;continue}}r&&(i+=i.length>0?`${n}..`:"..",o=2)}else i.length>0?i+=`${n}${t.slice(a+1,v)}`:i=t.slice(a+1,v),o=v-a-1;a=v,b=0}else S===R&&b!==-1?++b:b=-1}return i}function d(t,r){h(r,"pathObject");const n=r.dir||r.root,s=r.base||`${r.name||""}${r.ext||""}`;return n?n===r.root?`${n}${s}`:`${n}${t}${s}`:s}e.$gc={resolve(...t){let r="",n="",s=!1;for(let i=t.length-1;i>=-1;i--){let o;if(i>=0){if(o=t[i],c(o,"path"),o.length===0)continue}else r.length===0?o=A.cwd():(o=A.env[`=${r}`]||A.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===f)&&(o=`${r}\\`));const a=o.length;let b=0,S="",v=!1;const k=o.charCodeAt(0);if(a===1)g(k)&&(b=1,v=!0);else if(g(k))if(v=!0,g(o.charCodeAt(1))){let P=2,I=P;for(;P<a&&!g(o.charCodeAt(P));)P++;if(P<a&&P!==I){const F=o.slice(I,P);for(I=P;P<a&&g(o.charCodeAt(P));)P++;if(P<a&&P!==I){for(I=P;P<a&&!g(o.charCodeAt(P));)P++;(P===a||P!==I)&&(S=`\\\\${F}\\${o.slice(I,P)}`,b=P)}}}else b=1;else u(k)&&o.charCodeAt(1)===E&&(S=o.slice(0,2),b=2,a>2&&g(o.charCodeAt(2))&&(v=!0,b=3));if(S.length>0)if(r.length>0){if(S.toLowerCase()!==r.toLowerCase())continue}else r=S;if(s){if(r.length>0)break}else if(n=`${o.slice(b)}\\${n}`,s=v,v&&r.length>0)break}return n=m(n,!s,"\\",g),s?`${r}\\${n}`:`${r}${n}`||"."},normalize(t){c(t,"path");const r=t.length;if(r===0)return".";let n=0,s,i=!1;const o=t.charCodeAt(0);if(r===1)return l(o)?"\\":t;if(g(o))if(i=!0,g(t.charCodeAt(1))){let b=2,S=b;for(;b<r&&!g(t.charCodeAt(b));)b++;if(b<r&&b!==S){const v=t.slice(S,b);for(S=b;b<r&&g(t.charCodeAt(b));)b++;if(b<r&&b!==S){for(S=b;b<r&&!g(t.charCodeAt(b));)b++;if(b===r)return`\\\\${v}\\${t.slice(S)}\\`;b!==S&&(s=`\\\\${v}\\${t.slice(S,b)}`,n=b)}}}else n=1;else u(o)&&t.charCodeAt(1)===E&&(s=t.slice(0,2),n=2,r>2&&g(t.charCodeAt(2))&&(i=!0,n=3));let a=n<r?m(t.slice(n),!i,"\\",g):"";return a.length===0&&!i&&(a="."),a.length>0&&g(t.charCodeAt(r-1))&&(a+="\\"),s===void 0?i?`\\${a}`:a:i?`${s}\\${a}`:`${s}${a}`},isAbsolute(t){c(t,"path");const r=t.length;if(r===0)return!1;const n=t.charCodeAt(0);return g(n)||r>2&&u(n)&&t.charCodeAt(1)===E&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,n;for(let o=0;o<t.length;++o){const a=t[o];c(a,"path"),a.length>0&&(r===void 0?r=n=a:r+=`\\${a}`)}if(r===void 0)return".";let s=!0,i=0;if(typeof n=="string"&&g(n.charCodeAt(0))){++i;const o=n.length;o>1&&g(n.charCodeAt(1))&&(++i,o>2&&(g(n.charCodeAt(2))?++i:s=!1))}if(s){for(;i<r.length&&g(r.charCodeAt(i));)i++;i>=2&&(r=`\\${r.slice(i)}`)}return e.$gc.normalize(r)},relative(t,r){if(c(t,"from"),c(r,"to"),t===r)return"";const n=e.$gc.resolve(t),s=e.$gc.resolve(r);if(n===s||(t=n.toLowerCase(),r=s.toLowerCase(),t===r))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===f;)i++;let o=t.length;for(;o-1>i&&t.charCodeAt(o-1)===f;)o--;const a=o-i;let b=0;for(;b<r.length&&r.charCodeAt(b)===f;)b++;let S=r.length;for(;S-1>b&&r.charCodeAt(S-1)===f;)S--;const v=S-b,k=a<v?a:v;let P=-1,I=0;for(;I<k;I++){const T=t.charCodeAt(i+I);if(T!==r.charCodeAt(b+I))break;T===f&&(P=I)}if(I!==k){if(P===-1)return s}else{if(v>k){if(r.charCodeAt(b+I)===f)return s.slice(b+I+1);if(I===2)return s.slice(b+I)}a>k&&(t.charCodeAt(i+I)===f?P=I:I===2&&(P=3)),P===-1&&(P=0)}let F="";for(I=i+P+1;I<=o;++I)(I===o||t.charCodeAt(I)===f)&&(F+=F.length===0?"..":"\\..");return b+=P,F.length>0?`${F}${s.slice(b,S)}`:(s.charCodeAt(b)===f&&++b,s.slice(b,S))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$gc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===f){if(r.charCodeAt(1)===f){const n=r.charCodeAt(2);if(n!==y&&n!==R)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(u(r.charCodeAt(0))&&r.charCodeAt(1)===E&&r.charCodeAt(2)===f)return`\\\\?\\${r}`;return t},dirname(t){c(t,"path");const r=t.length;if(r===0)return".";let n=-1,s=0;const i=t.charCodeAt(0);if(r===1)return g(i)?t:".";if(g(i)){if(n=s=1,g(t.charCodeAt(1))){let b=2,S=b;for(;b<r&&!g(t.charCodeAt(b));)b++;if(b<r&&b!==S){for(S=b;b<r&&g(t.charCodeAt(b));)b++;if(b<r&&b!==S){for(S=b;b<r&&!g(t.charCodeAt(b));)b++;if(b===r)return t;b!==S&&(n=s=b+1)}}}}else u(i)&&t.charCodeAt(1)===E&&(n=r>2&&g(t.charCodeAt(2))?3:2,s=n);let o=-1,a=!0;for(let b=r-1;b>=s;--b)if(g(t.charCodeAt(b))){if(!a){o=b;break}}else a=!1;if(o===-1){if(n===-1)return".";o=n}return t.slice(0,o)},basename(t,r){r!==void 0&&c(r,"ext"),c(t,"path");let n=0,s=-1,i=!0,o;if(t.length>=2&&u(t.charCodeAt(0))&&t.charCodeAt(1)===E&&(n=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,b=-1;for(o=t.length-1;o>=n;--o){const S=t.charCodeAt(o);if(g(S)){if(!i){n=o+1;break}}else b===-1&&(i=!1,b=o+1),a>=0&&(S===r.charCodeAt(a)?--a===-1&&(s=o):(a=-1,s=b))}return n===s?s=b:s===-1&&(s=t.length),t.slice(n,s)}for(o=t.length-1;o>=n;--o)if(g(t.charCodeAt(o))){if(!i){n=o+1;break}}else s===-1&&(i=!1,s=o+1);return s===-1?"":t.slice(n,s)},extname(t){c(t,"path");let r=0,n=-1,s=0,i=-1,o=!0,a=0;t.length>=2&&t.charCodeAt(1)===E&&u(t.charCodeAt(0))&&(r=s=2);for(let b=t.length-1;b>=r;--b){const S=t.charCodeAt(b);if(g(S)){if(!o){s=b+1;break}continue}i===-1&&(o=!1,i=b+1),S===R?n===-1?n=b:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||i===-1||a===0||a===1&&n===i-1&&n===s+1?"":t.slice(n,i)},format:d.bind(null,"\\"),parse(t){c(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const n=t.length;let s=0,i=t.charCodeAt(0);if(n===1)return g(i)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(g(i)){if(s=1,g(t.charCodeAt(1))){let P=2,I=P;for(;P<n&&!g(t.charCodeAt(P));)P++;if(P<n&&P!==I){for(I=P;P<n&&g(t.charCodeAt(P));)P++;if(P<n&&P!==I){for(I=P;P<n&&!g(t.charCodeAt(P));)P++;P===n?s=P:P!==I&&(s=P+1)}}}}else if(u(i)&&t.charCodeAt(1)===E){if(n<=2)return r.root=r.dir=t,r;if(s=2,g(t.charCodeAt(2))){if(n===3)return r.root=r.dir=t,r;s=3}}s>0&&(r.root=t.slice(0,s));let o=-1,a=s,b=-1,S=!0,v=t.length-1,k=0;for(;v>=s;--v){if(i=t.charCodeAt(v),g(i)){if(!S){a=v+1;break}continue}b===-1&&(S=!1,b=v+1),i===R?o===-1?o=v:k!==1&&(k=1):o!==-1&&(k=-1)}return b!==-1&&(o===-1||k===0||k===1&&o===b-1&&o===a+1?r.base=r.name=t.slice(a,b):(r.name=t.slice(a,o),r.base=t.slice(a,b),r.ext=t.slice(o,b))),a>0&&a!==s?r.dir=t.slice(0,a-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const $=(()=>{if(p){const t=/\\/g;return()=>{const r=A.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>A.cwd()})();e.$hc={resolve(...t){let r="",n=!1;for(let s=t.length-1;s>=-1&&!n;s--){const i=s>=0?t[s]:$();c(i,"path"),i.length!==0&&(r=`${i}/${r}`,n=i.charCodeAt(0)===C)}return r=m(r,!n,"/",l),n?`/${r}`:r.length>0?r:"."},normalize(t){if(c(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===C,n=t.charCodeAt(t.length-1)===C;return t=m(t,!r,"/",l),t.length===0?r?"/":n?"./":".":(n&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return c(t,"path"),t.length>0&&t.charCodeAt(0)===C},join(...t){if(t.length===0)return".";let r;for(let n=0;n<t.length;++n){const s=t[n];c(s,"path"),s.length>0&&(r===void 0?r=s:r+=`/${s}`)}return r===void 0?".":e.$hc.normalize(r)},relative(t,r){if(c(t,"from"),c(r,"to"),t===r||(t=e.$hc.resolve(t),r=e.$hc.resolve(r),t===r))return"";const n=1,s=t.length,i=s-n,o=1,a=r.length-o,b=i<a?i:a;let S=-1,v=0;for(;v<b;v++){const P=t.charCodeAt(n+v);if(P!==r.charCodeAt(o+v))break;P===C&&(S=v)}if(v===b)if(a>b){if(r.charCodeAt(o+v)===C)return r.slice(o+v+1);if(v===0)return r.slice(o+v)}else i>b&&(t.charCodeAt(n+v)===C?S=v:v===0&&(S=0));let k="";for(v=n+S+1;v<=s;++v)(v===s||t.charCodeAt(v)===C)&&(k+=k.length===0?"..":"/..");return`${k}${r.slice(o+S)}`},toNamespacedPath(t){return t},dirname(t){if(c(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===C;let n=-1,s=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===C){if(!s){n=i;break}}else s=!1;return n===-1?r?"/":".":r&&n===1?"//":t.slice(0,n)},basename(t,r){r!==void 0&&c(r,"ext"),c(t,"path");let n=0,s=-1,i=!0,o;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,b=-1;for(o=t.length-1;o>=0;--o){const S=t.charCodeAt(o);if(S===C){if(!i){n=o+1;break}}else b===-1&&(i=!1,b=o+1),a>=0&&(S===r.charCodeAt(a)?--a===-1&&(s=o):(a=-1,s=b))}return n===s?s=b:s===-1&&(s=t.length),t.slice(n,s)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===C){if(!i){n=o+1;break}}else s===-1&&(i=!1,s=o+1);return s===-1?"":t.slice(n,s)},extname(t){c(t,"path");let r=-1,n=0,s=-1,i=!0,o=0;for(let a=t.length-1;a>=0;--a){const b=t.charCodeAt(a);if(b===C){if(!i){n=a+1;break}continue}s===-1&&(i=!1,s=a+1),b===R?r===-1?r=a:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||s===-1||o===0||o===1&&r===s-1&&r===n+1?"":t.slice(r,s)},format:d.bind(null,"/"),parse(t){c(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const n=t.charCodeAt(0)===C;let s;n?(r.root="/",s=1):s=0;let i=-1,o=0,a=-1,b=!0,S=t.length-1,v=0;for(;S>=s;--S){const k=t.charCodeAt(S);if(k===C){if(!b){o=S+1;break}continue}a===-1&&(b=!1,a=S+1),k===R?i===-1?i=S:v!==1&&(v=1):i!==-1&&(v=-1)}if(a!==-1){const k=o===0&&n?1:o;i===-1||v===0||v===1&&i===a-1&&i===o+1?r.base=r.name=t.slice(k,a):(r.name=t.slice(k,i),r.base=t.slice(k,a),r.ext=t.slice(i,a))}return o>0?r.dir=t.slice(0,o-1):n&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=p?e.$gc.normalize:e.$hc.normalize,e.$jc=p?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=p?e.$gc.join:e.$hc.join,e.$lc=p?e.$gc.resolve:e.$hc.resolve,e.$mc=p?e.$gc.relative:e.$hc.relative,e.$nc=p?e.$gc.dirname:e.$hc.dirname,e.$oc=p?e.$gc.basename:e.$hc.basename,e.$pc=p?e.$gc.extname:e.$hc.extname,e.$qc=p?e.$gc.format:e.$hc.format,e.$rc=p?e.$gc.parse:e.$hc.parse,e.$sc=p?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=p?e.$gc.sep:e.$hc.sep,e.$uc=p?e.$gc.delimiter:e.$hc.delimiter}),define(ae[40],ce([0,1,14,5,27,13]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=O,e.$og=R,e.$pg=C,e.$qg=f,e.$rg=E,e.$sg=c,e.$tg=p,e.$ug=g,e.$vg=l,e.$wg=u,e.$xg=m,e.$yg=d,e.$zg=$,e.$Ag=t,e.$Bg=r,e.$Cg=n,e.$Dg=o;function O(a){return a===47||a===92}function R(a){return a.replace(/[\\/]/g,A.$hc.sep)}function C(a){return a.indexOf("/")===-1&&(a=R(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}function f(a,b=A.$hc.sep){if(!a)return"";const S=a.length,v=a.charCodeAt(0);if(O(v)){if(O(a.charCodeAt(1))&&!O(a.charCodeAt(2))){let P=3;const I=P;for(;P<S&&!O(a.charCodeAt(P));P++);if(I!==P&&!O(a.charCodeAt(P+1))){for(P+=1;P<S;P++)if(O(a.charCodeAt(P)))return a.slice(0,P+1).replace(/[\\/]/g,b)}}return b}else if(l(v)&&a.charCodeAt(1)===58)return O(a.charCodeAt(2))?a.slice(0,2)+b:a.slice(0,2);let k=a.indexOf("://");if(k!==-1){for(k+=3;k<S;k++)if(O(a.charCodeAt(k)))return a.slice(0,k+1)}return""}function E(a){if(!N.$i||!a||a.length<5)return!1;let b=a.charCodeAt(0);if(b!==92||(b=a.charCodeAt(1),b!==92))return!1;let S=2;const v=S;for(;S<a.length&&(b=a.charCodeAt(S),b!==92);S++);return!(v===S||(b=a.charCodeAt(S+1),isNaN(b)||b===92))}const y=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(a,b=N.$i){const S=b?y:w;return!(!a||a.length===0||/^\s+$/.test(a)||(S.lastIndex=0,S.test(a))||b&&h.test(a)||a==="."||a===".."||b&&a[a.length-1]==="."||b&&a.length!==a.trim().length||a.length>255)}function p(a,b,S){const v=a===b;return!S||v?v:!a||!b?!1:(0,L.$xf)(a,b)}function g(a,b,S,v=A.sep){if(a===b)return!0;if(!a||!b||b.length>a.length)return!1;if(S){if(!(0,L.$yf)(a,b))return!1;if(b.length===a.length)return!0;let P=b.length;return b.charAt(b.length-1)===v&&P--,a.charAt(P)===v}return b.charAt(b.length-1)!==v&&(b+=v),a.indexOf(b)===0}function l(a){return a>=65&&a<=90||a>=97&&a<=122}function u(a,b){return N.$i&&a.endsWith(":")&&(a+=A.sep),(0,A.$jc)(a)||(a=(0,A.$kc)(b,a)),a=(0,A.$ic)(a),m(a)}function m(a){return N.$i?(a=(0,L.$ff)(a,A.sep),a.endsWith(":")&&(a+=A.sep)):(a=(0,L.$ff)(a,A.sep),a||(a=A.sep)),a}function d(a){const b=(0,A.$ic)(a);return N.$i?a.length>3?!1:$(b)&&(a.length===2||b.charCodeAt(2)===92):b===A.$hc.sep}function $(a,b=N.$i){return b?l(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}function t(a,b=N.$i){return $(a,b)?a[0]:void 0}function r(a,b,S){return b.length>a.length?-1:a===b?0:(S&&(a=a.toLowerCase(),b=b.toLowerCase()),a.indexOf(b))}function n(a){const b=a.split(":");let S,v,k;for(const P of b){const I=Number(P);(0,j.$_f)(I)?v===void 0?v=I:k===void 0&&(k=I):S=S?[S,P].join(":"):P}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:v!==void 0?v:void 0,column:k!==void 0?k:v!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(a,b,S=8){let v="";for(let P=0;P<S;P++){let I;P===0&&N.$i&&!b&&(S===3||S===4)?I=i:I=s,v+=I.charAt(Math.floor(Math.random()*I.length))}let k;return b?k=`${b}-${v}`:k=v,a?(0,A.$kc)(a,k):k}}),define(ae[141],ce([0,1,14]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=void 0,e.$Qs=j,e.$Rs=O,e.$Ss=R,e.$Ts=f,e.$Ps=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(E){const y=(0,A.$pc)(E),w=N[y.toLowerCase()];return w!==void 0?w:O(E)}function O(E){const y=(0,A.$pc)(E);return L[y.toLowerCase()]}function R(E){for(const y in L)if(L[y]===E)return y}const C=/^(.+)\/(.+?)(;.+)?$/;function f(E,y){const w=C.exec(E);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:y?void 0:E}}),define(ae[89],ce([0,1,5]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=j,e.$mm=O;var N;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function j(R,...C){const f=C.reduce((w,h)=>(w[h]=!0,w),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(w=>!f[w]).forEach(w=>{for(let h=0;h<E.length;h++)if(w.search(E[h])!==-1){delete R[w];break}})}function O(R){R&&(delete R.DEBUG,A.$j&&delete R.DYLD_LIBRARY_PATH,A.$k&&delete R.LD_PRELOAD)}}),define(ae[8],ce([0,1,14,5]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=c,e.$xc=d;const L=/^\w[\w\d+.-]*$/,j=/^\//,O=/^\/\//;function R(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!L.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!j.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(s,i){return!s&&!i?"file":s}function f(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==y&&(i=y+i):i=y;break}return i}const E="",y="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,o,a,b,S,v=!1){typeof i=="object"?(this.scheme=i.scheme||E,this.authority=i.authority||E,this.path=i.path||E,this.query=i.query||E,this.fragment=i.fragment||E):(this.scheme=C(i,v),this.authority=o||E,this.path=f(this.scheme,a||E),this.query=b||E,this.fragment=S||E,R(this,v))}get fsPath(){return d(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:a,path:b,query:S,fragment:v}=i;return o===void 0?o=this.scheme:o===null&&(o=E),a===void 0?a=this.authority:a===null&&(a=E),b===void 0?b=this.path:b===null&&(b=E),S===void 0?S=this.query:S===null&&(S=E),v===void 0?v=this.fragment:v===null&&(v=E),o===this.scheme&&a===this.authority&&b===this.path&&S===this.query&&v===this.fragment?this:new g(o,a,b,S,v)}static parse(i,o=!1){const a=w.exec(i);return a?new g(a[2]||E,n(a[4]||E),n(a[5]||E),n(a[7]||E),n(a[9]||E),o):new g(E,E,E,E,E)}static file(i){let o=E;if(N.$i&&(i=i.replace(/\\/g,y)),i[0]===y&&i[1]===y){const a=i.indexOf(y,2);a===-1?(o=i.substring(2),i=y):(o=i.substring(2,a),i=i.substring(a)||y)}return new g("file",o,i,E,E)}static from(i,o){return new g(i.scheme,i.authority,i.path,i.query,i.fragment,o)}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&i.scheme==="file"?a=h.file(A.$gc.join(d(i,!0),...o)).path:a=A.$hc.join(i.path,...o),i.with({path:a})}toString(i=!1){return $(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const o=new g(i);return o._formatted=i.external??null,o._fsPath=i._sep===p?i.fsPath??null:null,o}}else return i}}e.URI=h;function c(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const p=N.$i?1:void 0;class g extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(i=!1){return i?$(this,!0):(this._formatted||(this._formatted=$(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const l={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function u(s,i,o){let a,b=-1;for(let S=0;S<s.length;S++){const v=s.charCodeAt(S);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||i&&v===47||o&&v===91||o&&v===93||o&&v===58)b!==-1&&(a+=encodeURIComponent(s.substring(b,S)),b=-1),a!==void 0&&(a+=s.charAt(S));else{a===void 0&&(a=s.substr(0,S));const k=l[v];k!==void 0?(b!==-1&&(a+=encodeURIComponent(s.substring(b,S)),b=-1),a+=k):b===-1&&(b=S)}}return b!==-1&&(a+=encodeURIComponent(s.substring(b))),a!==void 0?a:s}function m(s){let i;for(let o=0;o<s.length;o++){const a=s.charCodeAt(o);a===35||a===63?(i===void 0&&(i=s.substr(0,o)),i+=l[a]):i!==void 0&&(i+=s[o])}return i!==void 0?i:s}function d(s,i){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,N.$i&&(o=o.replace(/\//g,"\\")),o}function $(s,i){const o=i?m:u;let a="",{scheme:b,authority:S,path:v,query:k,fragment:P}=s;if(b&&(a+=b,a+=":"),(S||b==="file")&&(a+=y,a+=y),S){let I=S.indexOf("@");if(I!==-1){const F=S.substr(0,I);S=S.substr(I+1),I=F.lastIndexOf(":"),I===-1?a+=o(F,!1,!1):(a+=o(F.substr(0,I),!1,!1),a+=":",a+=o(F.substr(I+1),!1,!0)),a+="@"}S=S.toLowerCase(),I=S.lastIndexOf(":"),I===-1?a+=o(S,!1,!0):(a+=o(S.substr(0,I),!1,!0),a+=S.substr(I))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const I=v.charCodeAt(1);I>=65&&I<=90&&(v=`/${String.fromCharCode(I+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const I=v.charCodeAt(0);I>=65&&I<=90&&(v=`${String.fromCharCode(I+32)}:${v.substr(2)}`)}a+=o(v,!0,!1)}return k&&(a+="?",a+=o(k,!1,!1)),P&&(a+="#",a+=i?P:u(P,!1,!1)),a}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(r)?s.replace(r,i=>t(i)):s}}),define(ae[142],ce([0,1,8]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=N,e.$Vq=L,e.$Wq=j,e.log=R;function N(f){const E=f;return E&&typeof E.type=="string"&&typeof E.severity=="string"}function L(f){const E=[];let y;try{const w=JSON.parse(f.arguments),h=w[w.length-1];h&&h.__$stack&&(w.pop(),y=h.__$stack),E.push(...w)}catch{E.push("Unable to log remote console arguments",f.arguments)}return{args:E,stack:y}}function j(f){if(typeof f!="string")return j(L(f).stack);const E=f;if(E){const y=O(E),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(w&&w.length===4)return{uri:A.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}function O(f){if(!f)return f;const E=f.indexOf(`
`);return E===-1?f:f.substring(0,E)}function R(f,E){const{args:y,stack:w}=L(f),h=typeof y[0]=="string"&&y.length===1;let c=O(w);c&&(c=`(${c.trim()})`);let p=[];if(typeof y[0]=="string"?c&&h?p=[`%c[${E}] %c${y[0]} %c${c}`,C("blue"),C(""),C("grey")]:p=[`%c[${E}] %c${y[0]}`,C("blue"),C(""),...y.slice(1)]:p=[`%c[${E}]%`,C("blue"),...y],c&&!h&&p.push(c),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,p)}function C(f){return`color: ${f}`}}),define(ae[66],ce([0,1,15,8]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=L,e.$4h=j,e.$5h=R;function L(C){return JSON.stringify(C,O)}function j(C){let f=JSON.parse(C);return f=R(f),f}function O(C,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function R(C,f=0){if(!C||f>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return N.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 17:return new Date(C.source)}if(C instanceof A.$Fe||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let E=0;E<C.length;++E)C[E]=R(C[E],f+1);else for(const E in C)Object.hasOwnProperty.call(C,E)&&(C[E]=R(C[E],f+1))}return C}}),define(ae[23],ce([0,1,7,5,27,8,14]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Ig=e.$Hg=e.$Gg=e.Schemas=void 0,e.$Eg=C,e.$Fg=f,e.$Jg=y;var R;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(R||(e.Schemas=R={}));function C(c,p){return j.URI.isUri(c)?(0,L.$xf)(c.scheme,p):(0,L.$yf)(c,p+":")}function f(c,...p){return p.some(g=>C(c,g))}e.$Gg="vscode-tkn",e.$Hg="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p,g){this.f=y(p,g)}getServerRootPath(){return this.f}get g(){return O.$hc.join(this.f,R.vscodeRemoteResource)}set(p,g,l){this.a[p]=g,this.b[p]=l}setConnectionToken(p,g){this.c[p]=g}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch($){return A.$1($),p}const g=p.authority;let l=this.a[g];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const u=this.b[g],m=this.c[g];let d=`path=${encodeURIComponent(p.path)}`;return typeof m=="string"&&(d+=`&${e.$Hg}=${encodeURIComponent(m)}`),j.URI.from({scheme:N.$o?this.d:R.vscodeRemoteResource,authority:`${l}:${u}`,path:this.g,query:d})}}e.$Ig=new E;function y(c,p){return O.$hc.join(p??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Kg="vs/../../extensions",e.$Lg="vs/../../node_modules",e.$Mg="vs/../../node_modules.asar",e.$Ng="vs/../../node_modules.asar.unpacked",e.$Og="vscode-app";class w{static{this.a=e.$Og}asBrowserUri(p){const g=this.b(p,ne);return this.uriToBrowserUri(g)}uriToBrowserUri(p){return p.scheme===R.vscodeRemote?e.$Ig.rewrite(p):p.scheme===R.file&&(N.$m||N.$q===`${R.vscodeFileResource}://${w.a}`)?p.with({scheme:R.vscodeFileResource,authority:p.authority||w.a,query:null,fragment:null}):p}asFileUri(p){const g=this.b(p,ne);return this.uriToFileUri(g)}uriToFileUri(p){return p.scheme===R.vscodeFileResource?p.with({scheme:R.file,authority:p.authority!==w.a?p.authority:null,query:null,fragment:null}):p}b(p,g){return j.URI.isUri(p)?p:j.URI.parse(g.toUrl(p))}}e.$Pg=new w;var h;(function(c){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(p.get("3"));const g="vscode-coi";function l(m){let d;typeof m=="string"?d=new URL(m).searchParams:m instanceof URL?d=m.searchParams:j.URI.isUri(m)&&(d=new URL(m.toString(!0)).searchParams);const $=d?.get(g);if($)return p.get($)}c.getHeadersFromQuery=l;function u(m,d,$){if(!globalThis.crossOriginIsolated)return;const t=d&&$?"3":$?"2":"1";m instanceof URLSearchParams?m.set(g,t):m[g]=t}c.addSearchParam=u})(h||(e.COI=h={}))}),define(ae[143],ce([0,1,124,23,5,8]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZD=E;class O{constructor(w,h,c){this.id=w,this.dependencies=h,this.callback=c}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,h,c)=>{typeof w!="string"&&(c=h,h=w,w=null),(typeof h!="object"||!Array.isArray(h))&&(c=h,h=null),this.c.push(new O(w,h,c))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const h=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!h)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(w){return new Promise((h,c)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const g=()=>{p.removeEventListener("load",l),p.removeEventListener("error",u)},l=m=>{g(),h(this.c.pop())},u=m=>{g(),c(m)};p.addEventListener("load",l),p.addEventListener("error",u),this.f&&(w=this.f.createScriptURL(w)),p.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(p)})}i(w){return new Promise((h,c)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),h(this.c.pop())}catch(p){c(p)}})}async j(w){try{const h=globalThis._VSCODE_NODE_MODULES.fs,c=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,g=j.URI.parse(w).fsPath,l=h.readFileSync(g).toString(),u=p.wrap(l.replace(/^#!.*/,""));return new c.Script(u).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const C=new Map;let f={};typeof globalThis.require=="object"&&(f=globalThis.require.paths??{});async function E(y,w,h){if(A.$T){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),f[y]&&(y=f[y]);const c=`${y}/${w}`;if(C.has(c))return C.get(c);let p;if(/^\w[\w\d+.-]*:\/\//.test(c))p=c;else{const m=`${h&&!L.$o?N.$Mg:N.$Lg}/${c}`;p=N.$Pg.asBrowserUri(m).toString(!0)}const g=R.INSTANCE.load(p);return C.set(c,g),g}else return await new Promise((c,p)=>{ne([y],c,p)})}}),define(ae[20],ce([0,1,40,23,14,5,27,8]),function(ne,e,A,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=void 0,e.$Wg=C,e.$fh=E,e.$gh=w;function C(h){return(0,R.$xc)(h,!0)}class f{constructor(c){this.a=c}compare(c,p,g=!1){return c===p?0:(0,O.$qf)(this.getComparisonKey(c,g),this.getComparisonKey(p,g))}isEqual(c,p,g=!1){return c===p?!0:!c||!p?!1:this.getComparisonKey(c,g)===this.getComparisonKey(p,g)}getComparisonKey(c,p=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,p,g=!1){if(c.scheme===p.scheme){if(c.scheme===N.Schemas.file)return A.$ug(C(c),C(p),this.a(c))&&c.query===p.query&&(g||c.fragment===p.fragment);if((0,e.$bh)(c.authority,p.authority))return A.$ug(c.path,p.path,this.a(c),"/")&&c.query===p.query&&(g||c.fragment===p.fragment)}return!1}joinPath(c,...p){return R.URI.joinPath(c,...p)}basenameOrAuthority(c){return(0,e.$6g)(c)||c.authority}basename(c){return L.$hc.basename(c.path)}extname(c){return L.$hc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let p;return c.scheme===N.Schemas.file?p=R.URI.file(L.$nc(C(c))).path:(p=L.$hc.dirname(c.path),c.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),p="/")),c.with({path:p})}normalizePath(c){if(!c.path.length)return c;let p;return c.scheme===N.Schemas.file?p=R.URI.file(L.$ic(C(c))).path:p=L.$hc.normalize(c.path),c.with({path:p})}relativePath(c,p){if(c.scheme!==p.scheme||!(0,e.$bh)(c.authority,p.authority))return;if(c.scheme===N.Schemas.file){const u=L.$mc(C(c),C(p));return j.$i?A.$og(u):u}let g=c.path||"/";const l=p.path||"/";if(this.a(c)){let u=0;for(const m=Math.min(g.length,l.length);u<m&&!(g.charCodeAt(u)!==l.charCodeAt(u)&&g.charAt(u).toLowerCase()!==l.charAt(u).toLowerCase());u++);g=l.substr(0,u)+g.substr(u)}return L.$hc.relative(g,l)}resolvePath(c,p){if(c.scheme===N.Schemas.file){const g=R.URI.file(L.$lc(C(c),p));return c.with({authority:g.authority,path:g.path})}return p=A.$pg(p),c.with({path:L.$hc.resolve(c.path,p)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,p){return c===p||c!==void 0&&p!==void 0&&(0,O.$xf)(c,p)}hasTrailingPathSeparator(c,p=L.sep){if(c.scheme===N.Schemas.file){const g=C(c);return g.length>A.$qg(g).length&&g[g.length-1]===p}else{const g=c.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,p=L.sep){return(0,e.$ch)(c,p)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,p=L.sep){let g=!1;if(c.scheme===N.Schemas.file){const l=C(c);g=l!==void 0&&l.length===A.$qg(l).length&&l[l.length-1]===p}else{p="/";const l=c.path;g=l.length===1&&l.charCodeAt(l.length-1)===47}return!g&&!(0,e.$ch)(c,p)?c.with({path:c.path+"/"}):c}}e.$Xg=f,e.$Yg=new f(()=>!1),e.$Zg=new f(h=>h.scheme===N.Schemas.file?!j.$k:!0),e.$1g=new f(h=>!0),e.$2g=e.$Yg.isEqual.bind(e.$Yg),e.$3g=e.$Yg.isEqualOrParent.bind(e.$Yg),e.$4g=e.$Yg.getComparisonKey.bind(e.$Yg),e.$5g=e.$Yg.basenameOrAuthority.bind(e.$Yg),e.$6g=e.$Yg.basename.bind(e.$Yg),e.$7g=e.$Yg.extname.bind(e.$Yg),e.$8g=e.$Yg.dirname.bind(e.$Yg),e.$9g=e.$Yg.joinPath.bind(e.$Yg),e.$0g=e.$Yg.normalizePath.bind(e.$Yg),e.$$g=e.$Yg.relativePath.bind(e.$Yg),e.$_g=e.$Yg.resolvePath.bind(e.$Yg),e.$ah=e.$Yg.isAbsolutePath.bind(e.$Yg),e.$bh=e.$Yg.isEqualAuthority.bind(e.$Yg),e.$ch=e.$Yg.hasTrailingPathSeparator.bind(e.$Yg),e.$dh=e.$Yg.removeTrailingPathSeparator.bind(e.$Yg),e.$eh=e.$Yg.addTrailingPathSeparator.bind(e.$Yg);function E(h,c){const p=[];for(let g=0;g<h.length;g++){const l=c(h[g]);h.some((u,m)=>m===g?!1:(0,e.$3g)(l,c(u)))||p.push(h[g])}return p}var y;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function c(p){const g=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(m=>{const[d,$]=m.split(":");d&&$&&g.set(d,$)});const u=p.path.substring(0,p.path.indexOf(";"));return u&&g.set(h.META_DATA_MIME,u),g}h.parseMetaData=c})(y||(e.DataUri=y={}));function w(h,c,p){if(c){let g=h.path;return g&&g[0]!==L.$hc.sep&&(g=L.$hc.sep+g),h.with({scheme:p,authority:c,path:g})}return h.with({scheme:p})}}),define(ae[6],ce([0,1,26,7,3,2,20,5,130,53]),function(ne,e,A,N,L,j,O,R,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.Promises=e.$Sh=e.$Rh=e.$Qh=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=void 0,e.$hh=E,e.$ih=y,e.$jh=w,e.$kh=h,e.$lh=c,e.$mh=p,e.$nh=g,e.$oh=l,e.$wh=o,e.$xh=a,e.$yh=b,e.$zh=S,e.$Ah=v,e.$Ph=B,e.$Xh=K;function E(_){return!!_&&typeof _.then=="function"}function y(_){const Y=new A.$pe,se=_(Y.token),ue=new Promise((ge,fe)=>{const $e=Y.token.onCancellationRequested(()=>{$e.dispose(),fe(new N.$5)});Promise.resolve(se).then(ye=>{$e.dispose(),Y.dispose(),ge(ye)},ye=>{$e.dispose(),Y.dispose(),fe(ye)})});return new class{cancel(){Y.cancel(),Y.dispose()}then(ge,fe){return ue.then(ge,fe)}catch(ge){return this.then(void 0,ge)}finally(ge){return ue.finally(ge)}}}function w(_,Y,se){return new Promise((ue,ge)=>{const fe=Y.onCancellationRequested(()=>{fe.dispose(),ue(se)});_.then(ue,ge).finally(()=>fe.dispose())})}function h(_,Y){return new Promise((se,ue)=>{const ge=Y.onCancellationRequested(()=>{ge.dispose(),ue(new N.$5)});_.then(se,ue).finally(()=>ge.dispose())})}async function c(_){let Y=-1;const se=_.map((ue,ge)=>ue.then(fe=>(Y=ge,fe)));try{return await Promise.race(se)}finally{_.forEach((ue,ge)=>{ge!==Y&&ue.cancel()})}}function p(_,Y,se){let ue;const ge=setTimeout(()=>{ue?.(void 0),se?.()},Y);return Promise.race([_.finally(()=>clearTimeout(ge)),new Promise(fe=>ue=fe)])}function g(_){return new Promise((Y,se)=>{const ue=_();E(ue)?ue.then(Y,se):Y(ue)})}function l(){let _,Y;return{promise:new Promise((ue,ge)=>{_=ue,Y=ge}),resolve:_,reject:Y}}class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Y){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Y,!this.b){const se=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(se,se).then(ue)})}return new Promise((se,ue)=>{this.b.then(se,ue)})}return this.a=Y(),new Promise((se,ue)=>{this.a.then(ge=>{this.a=null,se(ge)},ge=>{this.a=null,ue(ge)})})}dispose(){this.f=!0}}e.$ph=u;class m{constructor(){this.a=Promise.resolve(null)}queue(Y){return this.a=this.a.then(()=>Y(),()=>Y())}}e.$qh=m;class d{constructor(){this.a=new Map}queue(Y,se){const ge=(this.a.get(Y)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(Y)===ge&&this.a.delete(Y)});return this.a.set(Y,ge),ge}}e.$rh=d;const $=(_,Y)=>{let se=!0;const ue=setTimeout(()=>{se=!1,Y()},_);return{isTriggered:()=>se,dispose:()=>{clearTimeout(ue),se=!1}}},t=_=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,_())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};class r{constructor(Y){this.defaultDelay=Y,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Y,se=this.defaultDelay){this.g=Y,this.h(),this.b||(this.b=new Promise((ge,fe)=>{this.d=ge,this.f=fe}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=se===C.$be?t(ue):$(se,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$sh=r;class n{constructor(Y){this.a=new r(Y),this.b=new u}trigger(Y,se){return this.a.trigger(()=>this.b.queue(Y),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$th=n;class s{constructor(){this.a=!1,this.b=new Promise((Y,se)=>{this.d=Y})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$uh=s;class i extends s{constructor(Y){super(),this.f=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this.f),super.open()}}e.$vh=i;function o(_,Y){return Y?new Promise((se,ue)=>{const ge=setTimeout(()=>{fe.dispose(),se()},_),fe=Y.onCancellationRequested(()=>{clearTimeout(ge),fe.dispose(),ue(new N.$5)})}):y(se=>o(_,se))}function a(_,Y=0,se){const ue=setTimeout(()=>{_(),se&&ge.dispose()},Y),ge=(0,j.$Tc)(()=>{clearTimeout(ue),se?.deleteAndLeak(ge)});return se?.add(ge),ge}function b(_){const Y=[];let se=0;const ue=_.length;function ge(){return se<ue?_[se++]():null}function fe($e){$e!=null&&Y.push($e);const ye=ge();return ye?ye.then(fe):Promise.resolve(Y)}return Promise.resolve(null).then(fe)}function S(_,Y=ue=>!!ue,se=null){let ue=0;const ge=_.length,fe=()=>{if(ue>=ge)return Promise.resolve(se);const $e=_[ue++];return Promise.resolve($e()).then(ve=>Y(ve)?Promise.resolve(ve):fe())};return fe()}function v(_,Y=ue=>!!ue,se=null){if(_.length===0)return Promise.resolve(se);let ue=_.length;const ge=()=>{ue=-1;for(const fe of _)fe.cancel?.()};return new Promise((fe,$e)=>{for(const ye of _)ye.then(ve=>{--ue>=0&&Y(ve)?(ge(),fe(ve)):ue===0&&fe(se)}).catch(ve=>{--ue>=0&&(ge(),$e(ve))})})}class k{constructor(Y){this.a=0,this.b=!1,this.f=Y,this.g=[],this.d=0,this.h=new L.$ee}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Y){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((se,ue)=>{this.g.push({factory:Y,c:se,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Y=this.g.shift();this.d++;const se=Y.factory();se.then(Y.c,Y.e),se.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Bh=k;class P extends k{constructor(){super(1)}}e.$Ch=P;class I{constructor(){this.a=new ie,this.b=0}queue(Y){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Y())):this.a.run(this.b++,Y())}}e.$Dh=I;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Y=new te;return this.b.add(Y),Y.p}g(){for(const[,Y]of this.a)if(Y.size>0)return!1;return!0}queueSize(Y,se=O.$Yg){const ue=se.getComparisonKey(Y);return this.a.get(ue)?.size??0}queueFor(Y,se,ue=O.$Yg){const ge=ue.getComparisonKey(Y);let fe=this.a.get(ge);if(!fe){fe=new P;const $e=this.f++,ye=L.Event.once(fe.onDrained)(()=>{fe?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose($e),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$5c),this.d.set($e,ye),this.a.set(ge,fe)}return fe.queue(se)}h(){this.g()&&this.j()}j(){for(const Y of this.b)Y.complete();this.b.clear()}dispose(){for(const[,Y]of this.a)Y.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Eh=F;class T{constructor(Y,se){this.a=-1,typeof Y=="function"&&typeof se=="number"&&this.setIfNotSet(Y,se)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Y,se){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Y()},se)}setIfNotSet(Y,se){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Y()},se))}}e.$Fh=T;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Y,se,ue=globalThis){this.cancel();const ge=ue.setInterval(()=>{Y()},se);this.d=(0,j.$Tc)(()=>{ue.clearInterval(ge),this.d=void 0})}dispose(){this.cancel()}}e.$Gh=q;class X{constructor(Y,se){this.b=-1,this.a=Y,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Y=this.d){this.cancel(),this.b=setTimeout(this.f,Y)}get delay(){return this.d}set delay(Y){this.d=Y}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Hh=X;class G{constructor(Y,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=Y,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Y=this.b){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Y/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ih=G;class Q extends X{constructor(Y,se){super(Y,se),this.j=[]}work(Y){this.j.push(Y),this.isScheduled()||this.schedule()}h(){const Y=this.j;this.j=[],this.a?.(Y)}dispose(){this.j=[],super.dispose()}}e.$Jh=Q;class W extends j.$Vc{constructor(Y,se){super(),this.g=Y,this.h=se,this.a=[],this.b=this.B(new j.$Wc),this.f=!1}get pending(){return this.a.length}work(Y){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Y.length>this.g.maxBufferedWork)return!1}else if(this.pending+Y.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of Y)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new X(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Kh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Mh=(_,Y)=>{(0,R.$B)(()=>{if(se)return;const ue=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$Mh=(_,Y,se)=>{const ue=_.requestIdleCallback(Y,typeof se=="number"?{timeout:se}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,_.cancelIdleCallback(ue))}}},e.$Lh=_=>(0,e.$Mh)(globalThis,_)}();class J{constructor(Y,se){this.g=!1,this.d=()=>{try{this.j=se()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$Mh)(Y,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Nh=J;class H extends J{constructor(Y){super(globalThis,Y)}}e.$Oh=H;async function B(_,Y,se){let ue;for(let ge=0;ge<se;ge++)try{return await _()}catch(fe){ue=fe,await o(Y)}throw ue}class ie{isRunning(Y){return typeof Y=="number"?this.a?.taskId===Y:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Y,se,ue){return this.a={taskId:Y,cancel:()=>ue?.(),promise:se},se.then(()=>this.d(Y),()=>this.d(Y)),se}d(Y){this.a&&Y===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Y=this.b;this.b=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}queue(Y){if(this.b)this.b.run=Y;else{const{promise:se,resolve:ue,reject:ge}=l();this.b={run:Y,promise:se,promiseResolve:ue,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Qh=ie;class re{constructor(Y,se=()=>Date.now()){this.d=Y,this.f=se,this.a=0,this.b=0}increment(){const Y=this.f();return Y-this.a>this.d&&(this.a=Y,this.b=0),this.b++,this.b}}e.$Rh=re;var he;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(he||(he={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Y,se)=>{this.a=Y,this.b=se})}complete(Y){return new Promise(se=>{this.a(Y),this.d={outcome:0,value:Y},se()})}error(Y){return new Promise(se=>{this.b(Y),this.d={outcome:1,value:Y},se()})}cancel(){return this.error(new N.$5)}}e.$Sh=te;var V;(function(_){async function Y(ue){let ge;const fe=await Promise.all(ue.map($e=>$e.then(ye=>ye,ye=>{ge||(ge=ye)})));if(typeof ge<"u")throw ge;return fe}_.settled=Y;function se(ue){return new Promise(async(ge,fe)=>{try{await ue(ge,fe)}catch($e){fe($e)}})}_.withAsyncBody=se})(V||(e.Promises=V={}));class U{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Y){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Y.then(se=>(this.a=se,this.d=!0,se),se=>{throw this.b=se,this.d=!0,se})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Th=U;class D{constructor(Y){this.b=Y,this.a=new f.$V(()=>new U(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Uh=D;var M;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(M||(M={}));class z{static fromArray(Y){return new z(se=>{se.emitMany(Y)})}static fromPromise(Y){return new z(async se=>{se.emitMany(await Y)})}static fromPromises(Y){return new z(async se=>{await Promise.all(Y.map(async ue=>se.emitOne(await ue)))})}static merge(Y){return new z(async se=>{await Promise.all(Y.map(async ue=>{for await(const ge of ue)se.emitOne(ge)}))})}static{this.EMPTY=z.fromArray([])}constructor(Y,se){this.a=0,this.b=[],this.d=null,this.f=se,this.g=new L.$ee,queueMicrotask(async()=>{const ue={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(Y(ue)),this.k()}catch(ge){this.l(ge)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Y<this.b.length)return{done:!1,value:this.b[Y++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Y,se){return new z(async ue=>{for await(const ge of Y)ue.emitOne(se(ge))})}map(Y){return z.map(this,Y)}static filter(Y,se){return new z(async ue=>{for await(const ge of Y)se(ge)&&ue.emitOne(ge)})}filter(Y){return z.filter(this,Y)}static coalesce(Y){return z.filter(Y,se=>!!se)}coalesce(){return z.coalesce(this)}static async toPromise(Y){const se=[];for await(const ue of Y)se.push(ue);return se}toPromise(){return z.toPromise(this)}h(Y){this.a===0&&(this.b.push(Y),this.g.fire())}j(Y){this.a===0&&(this.b=this.b.concat(Y),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Y){this.a===0&&(this.a=2,this.d=Y,this.g.fire())}}e.$Vh=z;class x extends z{constructor(Y,se){super(se),this.m=Y}cancel(){this.m.cancel()}}e.$Wh=x;function K(_){const Y=new A.$pe,se=_(Y.token);return new x(Y,async ue=>{const ge=Y.token.onCancellationRequested(()=>{ge.dispose(),Y.dispose(),ue.reject(new N.$5)});try{for await(const fe of se){if(Y.token.isCancellationRequested)return;ue.emitOne(fe)}ge.dispose(),Y.dispose()}catch(fe){ge.dispose(),Y.dispose(),ue.reject(fe)}})}class ee{constructor(Y){this.a=new te,this.b=new z(ge=>{if(se){ge.reject(se);return}return ue&&ge.emitMany(ue),this.d=fe=>ge.reject(fe),this.f=fe=>ge.emitOne(fe),this.a.p},Y);let se,ue;this.f=ge=>{ue||(ue=[]),ue.push(ge)},this.d=ge=>{se||(se=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Y){this.d(Y),this.a.complete()}emitOne(Y){this.f(Y)}}e.$Yh=ee}),define(ae[90],ce([0,1,17,6,40,34,14,5,27]),function(ne,e,A,N,L,j,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$kk=f,e.$nk=c,e.$ok=P,e.$pk=I,e.$qk=F,e.$rk=T,e.$sk=q,e.$tk=W;function f(){return Object.create(null)}e.$lk="**",e.$mk="/";const E="[/\\\\]",y="[^/\\\\]",w=/\//g;function h(J,H){switch(J){case 0:return"";case 1:return`${y}*?`;default:return`(?:${E}|${y}+${E}${H?`|${E}${y}+`:""})*?`}}function c(J,H){if(!J)return[];const B=[];let ie=!1,re=!1,he="";for(const te of J){switch(te){case H:if(!ie&&!re){B.push(he),he="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":re=!0;break;case"]":re=!1;break}he+=te}return he&&B.push(he),B}function p(J){if(!J)return"";let H="";const B=c(J,e.$mk);if(B.every(ie=>ie===e.$lk))H=".*";else{let ie=!1;B.forEach((re,he)=>{if(re===e.$lk){if(ie)return;H+=h(2,he===B.length-1)}else{let te=!1,V="",U=!1,D="";for(const M of re){if(M!=="}"&&te){V+=M;continue}if(U&&(M!=="]"||!D)){let z;M==="-"?z=M:(M==="^"||M==="!")&&!D?z="^":M===e.$mk?z="":z=(0,C.$_e)(M),D+=z;continue}switch(M){case"{":te=!0;continue;case"[":U=!0;continue;case"}":{const x=`(?:${c(V,",").map(K=>p(K)).join("|")})`;H+=x,te=!1,V="";break}case"]":{H+="["+D+"]",U=!1,D="";break}case"?":H+=y;continue;case"*":H+=h(1);continue;default:H+=(0,C.$_e)(M)}}he<B.length-1&&(B[he+1]!==e.$lk||he+2<B.length)&&(H+=E)}ie=re===e.$lk})}return H}const g=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,$=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new j.$Ec(1e4),r=function(){return!1},n=function(){return null};function s(J,H){if(!J)return n;let B;typeof J!="string"?B=J.pattern:B=J,B=B.trim();const ie=`${B}_${!!H.trimForExclusions}`;let re=t.get(ie);if(re)return i(re,J);let he;return g.test(B)?re=a(B.substr(4),B):(he=l.exec(o(B,H)))?re=b(he[1],B):(H.trimForExclusions?m:u).test(B)?re=S(B,H):(he=d.exec(o(B,H)))?re=v(he[1].substr(1),B,!0):(he=$.exec(o(B,H)))?re=v(he[1],B,!1):re=k(B),t.set(ie,re),i(re,J)}function i(J,H){if(typeof H=="string")return J;const B=function(ie,re){return(0,L.$ug)(ie,H.base,!R.$k)?J((0,C.$ef)(ie.substr(H.base.length),O.sep),re):null};return B.allBasenames=J.allBasenames,B.allPaths=J.allPaths,B.basenames=J.basenames,B.patterns=J.patterns,B}function o(J,H){return H.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function a(J,H){return function(B,ie){return typeof B=="string"&&B.endsWith(J)?H:null}}function b(J,H){const B=`/${J}`,ie=`\\${J}`,re=function(te,V){return typeof te!="string"?null:V?V===J?H:null:te===J||te.endsWith(B)||te.endsWith(ie)?H:null},he=[J];return re.basenames=he,re.patterns=[H],re.allBasenames=he,re}function S(J,H){const B=Q(J.slice(1,-1).split(",").map(V=>s(V,H)).filter(V=>V!==n),J),ie=B.length;if(!ie)return n;if(ie===1)return B[0];const re=function(V,U){for(let D=0,M=B.length;D<M;D++)if(B[D](V,U))return J;return null},he=B.find(V=>!!V.allBasenames);he&&(re.allBasenames=he.allBasenames);const te=B.reduce((V,U)=>U.allPaths?V.concat(U.allPaths):V,[]);return te.length&&(re.allPaths=te),re}function v(J,H,B){const ie=O.sep===O.$hc.sep,re=ie?J:J.replace(w,O.sep),he=O.sep+re,te=O.$hc.sep+J;let V;return B?V=function(U,D){return typeof U=="string"&&(U===re||U.endsWith(he)||!ie&&(U===J||U.endsWith(te)))?H:null}:V=function(U,D){return typeof U=="string"&&(U===re||!ie&&U===J)?H:null},V.allPaths=[(B?"*/":"./")+J],V}function k(J){try{const H=new RegExp(`^${p(J)}$`);return function(B){return H.lastIndex=0,typeof B=="string"&&H.test(B)?J:null}}catch{return n}}function P(J,H,B){return!J||typeof H!="string"?!1:I(J)(H,void 0,B)}function I(J,H={}){if(!J)return r;if(typeof J=="string"||F(J)){const B=s(J,H);if(B===n)return r;const ie=function(re,he){return!!B(re,he)};return B.allBasenames&&(ie.allBasenames=B.allBasenames),B.allPaths&&(ie.allPaths=B.allPaths),ie}return X(J,H)}function F(J){const H=J;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}function T(J){return J.allBasenames||[]}function q(J){return J.allPaths||[]}function X(J,H){const B=Q(Object.getOwnPropertyNames(J).map(V=>G(V,J[V],H)).filter(V=>V!==n)),ie=B.length;if(!ie)return n;if(!B.some(V=>!!V.requiresSiblings)){if(ie===1)return B[0];const V=function(M,z){let x;for(let K=0,ee=B.length;K<ee;K++){const _=B[K](M,z);if(typeof _=="string")return _;(0,N.$hh)(_)&&(x||(x=[]),x.push(_))}return x?(async()=>{for(const K of x){const ee=await K;if(typeof ee=="string")return ee}return null})():null},U=B.find(M=>!!M.allBasenames);U&&(V.allBasenames=U.allBasenames);const D=B.reduce((M,z)=>z.allPaths?M.concat(z.allPaths):M,[]);return D.length&&(V.allPaths=D),V}const re=function(V,U,D){let M,z;for(let x=0,K=B.length;x<K;x++){const ee=B[x];ee.requiresSiblings&&D&&(U||(U=(0,O.$oc)(V)),M||(M=U.substr(0,U.length-(0,O.$pc)(V).length)));const _=ee(V,U,M,D);if(typeof _=="string")return _;(0,N.$hh)(_)&&(z||(z=[]),z.push(_))}return z?(async()=>{for(const x of z){const K=await x;if(typeof K=="string")return K}return null})():null},he=B.find(V=>!!V.allBasenames);he&&(re.allBasenames=he.allBasenames);const te=B.reduce((V,U)=>U.allPaths?V.concat(U.allPaths):V,[]);return te.length&&(re.allPaths=te),re}function G(J,H,B){if(H===!1)return n;const ie=s(J,B);if(ie===n)return n;if(typeof H=="boolean")return ie;if(H){const re=H.when;if(typeof re=="string"){const he=(te,V,U,D)=>{if(!D||!ie(te,V))return null;const M=re.replace("$(basename)",()=>U),z=D(M);return(0,N.$hh)(z)?z.then(x=>x?J:null):z?J:null};return he.requiresSiblings=!0,he}}return ie}function Q(J,H){const B=J.filter(V=>!!V.basenames);if(B.length<2)return J;const ie=B.reduce((V,U)=>{const D=U.basenames;return D?V.concat(D):V},[]);let re;if(H){re=[];for(let V=0,U=ie.length;V<U;V++)re.push(H)}else re=B.reduce((V,U)=>{const D=U.patterns;return D?V.concat(D):V},[]);const he=function(V,U){if(typeof V!="string")return null;if(!U){let M;for(M=V.length;M>0;M--){const z=V.charCodeAt(M-1);if(z===47||z===92)break}U=V.substr(M)}const D=ie.indexOf(U);return D!==-1?re[D]:null};he.basenames=ie,he.patterns=re,he.allBasenames=ie;const te=J.filter(V=>!V.basenames);return te.push(he),te}function W(J,H){return(0,A.$ub)(J,H,(B,ie)=>typeof B=="string"&&typeof ie=="string"?B===ie:typeof B!="string"&&typeof ie!="string"?B.base===ie.base&&B.pattern===ie.pattern:!1)}}),define(ae[91],ce([0,1,15,8]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=void 0,e.$zn=R,e.$An=f,e.$Bn=E;function L(y){return y.toJSON()}class j{constructor(w){this.a=w}transformIncoming(w){const h=this.a.transformIncoming(w);return h===w?w:L(N.URI.from(h))}transformOutgoing(w){const h=this.a.transformOutgoing(w);return h===w?w:L(N.URI.from(h))}transformOutgoingURI(w){const h=this.a.transformOutgoing(w);return h===w?w:N.URI.from(h)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$xn=j,e.$yn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function O(y,w,h){if(!y||h>200)return null;if(typeof y=="object"){if(y instanceof N.URI)return w.transformOutgoing(y);for(const c in y)if(Object.hasOwnProperty.call(y,c)){const p=O(y[c],w,h+1);p!==null&&(y[c]=p)}}return null}function R(y,w){const h=O(y,w,0);return h===null?y:h}function C(y,w,h,c){if(!y||c>200)return null;if(typeof y=="object"){if(y.$mid===1)return h?N.URI.revive(w.transformIncoming(y)):w.transformIncoming(y);if(y instanceof A.$Fe)return null;for(const p in y)if(Object.hasOwnProperty.call(y,p)){const g=C(y[p],w,h,c+1);g!==null&&(y[p]=g)}}return null}function f(y,w){const h=C(y,w,!1,0);return h===null?y:h}function E(y,w){const h=C(y,w,!0,0);return h===null?y:h}}),define(ae[144],ce([0,1,37,51,32,131,5]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=void 0,e.$En=C,e.$Fn=y,e.$Dn=new class{c(w){return this.a||(this.a=N.$Bi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,h=0;const c=(0,A.networkInterfaces)();for(const p in c){const g=c[p];if(g)for(const{mac:l,internal:u}of g)u||(h+=1,this.c(l.toUpperCase())&&(w+=1))}this.b=h>0?w/h:0}return this.b}};let R;async function C(w){return R||(R=(async()=>await f(w)||L.$Rg())()),R}async function f(w){try{const h=await new Promise((p,g)=>{ne(["crypto"],p,g)}),c=(0,j.$Cn)();return h.createHash("sha256").update(c,"utf8").digest("hex")}catch(h){w(h);return}}const E="Software\\Microsoft\\SQMClient";async function y(w){if(O.$i){const h=await new Promise((c,p)=>{ne(["@vscode/windows-registry"],c,p)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",E,"MachineId")||""}catch(c){return w(c),""}}return""}}),define(ae[145],ce([0,1,41,146,14,36]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OW=E,e.$PW=y;const O="XDG_SESSION_TYPE",R="WAYLAND_DISPLAY",C="XDG_RUNTIME_DIR";var f;(function(w){w.Wayland="wayland",w.XWayland="xwayland",w.X11="x11",w.Unknown="unknown"})(f||(f={}));async function E(w){const h=j.env[O];if(h)return h==="wayland"||h==="x11"?h:"unknown";if(j.env[R]){const p=j.env[C];if(p){const g=(0,L.$kc)(p,"wayland-0");try{return await(0,N.access)(g,A.constants.R_OK),"wayland"}catch(l){return w(l),"unknown"}}else return"unknown"}else return"x11"}function y(w,h){if(h)switch(h){case"auto":return w;case"x11":return w==="wayland"?"xwayland":"x11";case"wayland":return"wayland";default:return"unknown"}else return w==="wayland"?"xwayland":"x11"}}),define(ae[147],ce([0,1,41,146,274,5]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=O;async function O(R){if(j.$j||j.$i)return;let C;for(const f of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{C=await(0,N.open)(f,A.constants.R_OK);break}catch{}if(!C){R("Unable to retrieve release information from known identifier paths.");return}try{const f=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),E={id:"unknown"};for await(const y of(0,L.createInterface)({input:C.createReadStream(),crlfDelay:1/0})){if(!y.includes("="))continue;const w=y.split("=")[0].toUpperCase().trim();if(f.has(w)){const h=y.split("=")[1].replace(/"/g,"").toLowerCase().trim();w==="ID"||w==="DISTRIB_ID"?E.id=h:w==="ID_LIKE"?E.id_like=h:(w==="VERSION_ID"||w==="DISTRIB_RELEASE")&&(E.version_id=h)}}return E}catch(f){R(f)}}}),define(ae[31],ce([0,1,41,37,275,6,40,87,14,5,20,8]),function(ne,e,A,N,L,j,O,R,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=m,e.whenDeleted=t,e.configureFlushOnWrite=o,e.writeFileSync=b;var w;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function h(G,Q=w.UNLINK,W){if((0,O.$yg)(G))throw new Error("rimraf - will refuse to recursively delete root");return Q===w.UNLINK?p(G):c(G,W)}async function c(G,Q=(0,O.$Dg)((0,N.tmpdir)())){try{try{await A.promises.rename(G,Q)}catch(W){return W.code==="ENOENT"?void 0:p(G)}p(Q).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function p(G){return(0,L.promisify)(A.rm)(G,{recursive:!0,force:!0,maxRetries:3})}function g(G){if((0,O.$yg)(G))throw new Error("rimraf - will refuse to recursively delete root");A.rmSync(G,{recursive:!0,force:!0,maxRetries:3})}async function l(G,Q){return d(await(Q?u(G):(0,L.promisify)(A.readdir)(G)))}async function u(G){try{return await(0,L.promisify)(A.readdir)(G,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const Q=[],W=await l(G);for(const J of W){let H=!1,B=!1,ie=!1;try{const re=await e.Promises.lstat((0,C.$kc)(G,J));H=re.isFile(),B=re.isDirectory(),ie=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}Q.push({name:J,isFile:()=>H,isDirectory:()=>B,isSymbolicLink:()=>ie})}return Q}function m(G){return d(A.readdirSync(G))}function d(G){return G.map(Q=>typeof Q=="string"?f.$j?(0,R.$am)(Q):Q:(Q.name=f.$j?(0,R.$am)(Q.name):Q.name,Q))}async function $(G){const Q=await l(G),W=[];for(const J of Q)await r.existsDirectory((0,C.$kc)(G,J))&&W.push(J);return W}function t(G,Q=1e3){return new Promise(W=>{let J=!1;const H=setInterval(()=>{J||(J=!0,A.access(G,B=>{J=!1,B&&(clearInterval(H),W(void 0))}))},Q)})}var r;(function(G){async function Q(H){let B;try{if(B=await e.Promises.lstat(H),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(f.$i&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw re}throw ie}}G.stat=Q;async function W(H){try{const{stat:B,symbolicLink:ie}=await G.stat(H);return B.isFile()&&ie?.dangling!==!0}catch{}return!1}G.existsFile=W;async function J(H){try{const{stat:B,symbolicLink:ie}=await G.stat(H);return B.isDirectory()&&ie?.dangling!==!0}catch{}return!1}G.existsDirectory=J})(r||(e.SymlinkSupport=r={}));const n=new j.$Eh;function s(G,Q,W){return n.queueFor(y.URI.file(G),()=>{const J=S(W);return new Promise((H,B)=>a(G,Q,J,ie=>ie?B(ie):H()))},E.$Zg)}let i=!0;function o(G){i=G}function a(G,Q,W,J){if(!i)return A.writeFile(G,Q,{mode:W.mode,flag:W.flag},J);A.open(G,W.flag,W.mode,(H,B)=>{if(H)return J(H);A.writeFile(B,Q,ie=>{if(ie)return A.close(B,()=>J(ie));A.fdatasync(B,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),o(!1)),A.close(B,he=>J(he))))})})}function b(G,Q,W){const J=S(W);if(!i)return A.writeFileSync(G,Q,{mode:J.mode,flag:J.flag});const H=A.openSync(G,J.flag,J.mode);try{A.writeFileSync(H,Q);try{A.fdatasyncSync(H)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),o(!1)}}finally{A.closeSync(H)}}function S(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function v(G,Q,W=6e4){if(G!==Q)try{f.$i&&typeof W=="number"?await k(G,Q,Date.now(),W):await(0,L.promisify)(A.rename)(G,Q)}catch(J){if(G.toLowerCase()!==Q.toLowerCase()&&J.code==="EXDEV"||G.endsWith("."))await P(G,Q,{preserveSymlinks:!1}),await h(G,w.MOVE);else throw J}}async function k(G,Q,W,J,H=0){try{return await(0,L.promisify)(A.rename)(G,Q)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-W>=J)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${B}`),B;if(H===0){let ie=!1;try{const{stat:re}=await r.stat(Q);re.isFile()||(ie=!0)}catch{}if(ie)throw B}return await(0,j.$wh)(Math.min(100,H*10)),k(G,Q,W,J,H+1)}}async function P(G,Q,W){return F(G,Q,{root:{source:G,target:Q},options:W,handledSourcePaths:new Set})}const I=511;async function F(G,Q,W){if(W.handledSourcePaths.has(G))return;W.handledSourcePaths.add(G);const{stat:J,symbolicLink:H}=await r.stat(G);if(H){if(W.options.preserveSymlinks)try{return await X(G,Q,W)}catch{}if(H.dangling)return}return J.isDirectory()?T(G,Q,J.mode&I,W):q(G,Q,J.mode&I)}async function T(G,Q,W,J){await e.Promises.mkdir(Q,{recursive:!0,mode:W});const H=await l(G);for(const B of H)await F((0,C.$kc)(G,B),(0,C.$kc)(Q,B),J)}async function q(G,Q,W){await e.Promises.copyFile(G,Q),await e.Promises.chmod(Q,W)}async function X(G,Q,W){let J=await e.Promises.readlink(G);(0,O.$ug)(J,W.root.source,!f.$k)&&(J=(0,C.$kc)(W.root.target,J.substr(W.root.source.length+1))),await e.Promises.symlink(J,Q)}e.Promises=new class{get access(){return(0,L.promisify)(A.access)}get stat(){return(0,L.promisify)(A.stat)}get lstat(){return(0,L.promisify)(A.lstat)}get utimes(){return(0,L.promisify)(A.utimes)}get read(){return(G,Q,W,J,H)=>new Promise((B,ie)=>{A.read(G,Q,W,J,H,(re,he,te)=>re?ie(re):B({bytesRead:he,buffer:te}))})}get readFile(){return(0,L.promisify)(A.readFile)}get write(){return(G,Q,W,J,H)=>new Promise((B,ie)=>{A.write(G,Q,W,J,H,(re,he,te)=>re?ie(re):B({bytesWritten:he,buffer:te}))})}get appendFile(){return(0,L.promisify)(A.appendFile)}get fdatasync(){return(0,L.promisify)(A.fdatasync)}get truncate(){return(0,L.promisify)(A.truncate)}get copyFile(){return(0,L.promisify)(A.copyFile)}get open(){return(0,L.promisify)(A.open)}get close(){return(0,L.promisify)(A.close)}get symlink(){return(0,L.promisify)(A.symlink)}get readlink(){return(0,L.promisify)(A.readlink)}get chmod(){return(0,L.promisify)(A.chmod)}get mkdir(){return(0,L.promisify)(A.mkdir)}get unlink(){return(0,L.promisify)(A.unlink)}get rmdir(){return(0,L.promisify)(A.rmdir)}get realpath(){return(0,L.promisify)(A.realpath)}async exists(G){try{return await e.Promises.access(G),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return $}get writeFile(){return s}get rm(){return h}get rename(){return v}get copy(){return P}}}),define(ae[148],ce([0,1,41,14,5,27,31]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=R,e.$4q=C,e.$5q=f,e.$6q=E;function R(w){if(L.$k)return w;const h=(0,N.$nc)(w);if(w===h)return w;const c=((0,N.$oc)(w)||w).toLowerCase();try{const g=(0,O.readdirSync)(h).filter(l=>l.toLowerCase()===c);if(g.length===1){const l=R(h);if(l)return(0,N.$kc)(l,g[0])}else if(g.length>1){const l=g.indexOf(c);if(l>=0){const u=R(h);if(u)return(0,N.$kc)(u,g[l])}}}catch{}return null}async function C(w,h){if(L.$k)return w;const c=(0,N.$nc)(w);if(w===c)return w;const p=((0,N.$oc)(w)||w).toLowerCase();try{if(h?.isCancellationRequested)return null;const l=(await O.Promises.readdir(c)).filter(u=>u.toLowerCase()===p);if(l.length===1){const u=await C(c,h);if(u)return(0,N.$kc)(u,l[0])}else if(l.length>1){const u=l.indexOf(p);if(u>=0){const m=await C(c,h);if(m)return(0,N.$kc)(m,l[u])}}}catch{}return null}async function f(w){try{return await O.Promises.realpath(w)}catch{const c=y(w);return await O.Promises.access(c,A.constants.R_OK),c}}function E(w){try{return A.realpathSync(w)}catch{const c=y(w);return A.accessSync(c,A.constants.R_OK),c}}function y(w){return(0,j.$ff)((0,N.$ic)(w),N.sep)}}),define(ae[149],ce([0,1,14,5,36,89,13,31]),function(ne,e,A,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$nm=C,e.$om=f,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function C(y=L.env){return y.comspec||"cmd.exe"}function f(y){let w=[],h=!1;const c=function(p){if(h){w.push(p);return}(!y.send(p,l=>{if(l&&console.error(l),h=!1,w.length>0){const u=w.slice(0);w=[],u.forEach(m=>c(m))}})||N.$i)&&(h=!0)};return{send:c}}var E;(function(y){async function w(h,c,p){if(A.$jc(h))return h;if(c===void 0&&(c=L.cwd()),A.$nc(h)!=="."||(p===void 0&&O.$8f(L.env.PATH)&&(p=L.env.PATH.split(A.$uc)),p===void 0||p.length===0))return A.$kc(c,h);async function l(u){if(await R.Promises.exists(u)){let m;try{m=await R.Promises.stat(u)}catch(d){d.message.startsWith("EACCES")&&(m=await R.Promises.lstat(u))}return m?!m.isDirectory():!1}return!1}for(const u of p){let m;if(A.$jc(u)?m=A.$kc(u,h):m=A.$kc(c,u,h),await l(m))return m;let d=m+".com";if(await l(d)||(d=m+".exe",await l(d)))return d}return A.$kc(c,h)}y.findExecutable=w})(E||(e.win32=E={}))}),define(ae[150],ce([0,1,67,23]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=L;function L(O){return new Promise((R,C)=>{let f;const E=new Map;function y(h,c,p,g,l){const u=E.get(c);if(h===O||u){const m={name:w(p),cmd:p,pid:h,ppid:c,load:g,mem:l};E.set(h,m),h===O&&(f=m),u&&(u.children||(u.children=[]),u.children.push(m),u.children.length>1&&(u.children=u.children.sort((d,$)=>d.pid-$.pid)))}}function w(h){const c=/--utility-sub-type=network/i,p=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(p.exec(h))return"electron-crash-reporter";if(g.exec(h))return"winpty-agent";if(l.exec(h))return"conpty-agent";let m=u.exec(h);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?c.exec(h)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const d=/[a-zA-Z-]+\.js/g;let $="";do m=d.exec(h),m&&($+=m+" ");while(m);return $&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${$})`:h}if(process.platform==="win32"){const h=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,p)=>{ne(["@vscode/windows-process-tree"],c,p)}).then(c=>{c.getProcessList(O,p=>{if(!p){C(new Error(`Root process ${O} not found`));return}c.getProcessCpuUsage(p,g=>{const l=new Map;g.forEach(u=>{const m=h(u.commandLine||"");l.set(u.pid,{name:w(m),cmd:m,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),f=l.get(O),f?(l.forEach(u=>{const m=l.get(u.ppid);m&&(m.children||(m.children=[]),m.children.push(u))}),l.forEach(u=>{u.children&&(u.children=u.children.sort((m,d)=>m.pid-d.pid))}),R(f)):C(new Error(`Root process ${O} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let h=function(){let c=[f];const p=[];for(;c.length;){const l=c.shift();l&&(p.push(l.pid),l.children&&(c=c.concat(l.children)))}let g=JSON.stringify(N.$Pg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);g+=" "+p.join(" "),(0,A.exec)(g,{},(l,u,m)=>{if(l||m)C(l||new Error(m.toString()));else{const d=u.toString().split(`
`);for(let $=0;$<p.length;$++){const t=E.get(p[$]);t.load=parseFloat(d[$])}if(!f){C(new Error(`Root process ${O} not found`));return}R(f)}})};(0,A.exec)("which ps",{},(c,p,g)=>{if(c||g)if(process.platform!=="linux")C(c||new Error(g.toString()));else{const l=JSON.stringify(N.$Pg.asFileUri("vs/base/node/ps.sh").fsPath);(0,A.exec)(l,{},(u,m,d)=>{u||d?C(u||new Error(d.toString())):(j(m,y),h())})}else{const l=p.toString().trim();(0,A.exec)(`${l} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,d,$)=>{m||$&&!$.includes("screen size is bogus")?C(m||new Error($.toString())):(j(d,y),process.platform==="linux"?h():f?R(f):C(new Error(`Root process ${O} not found`)))})}})}})}function j(O,R){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,f=O.toString().split(`
`);for(const E of f){const y=C.exec(E.trim());y&&y.length===6&&R(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}});var Ee=this&&this.__decorate||function(ne,e,A,N){var L=arguments.length,j=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,A):N,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(ne,e,A,N);else for(var R=ne.length-1;R>=0;R--)(O=ne[R])&&(j=(L<3?O(j):L>3?O(e,A,j):O(e,A))||j);return L>3&&j&&Object.defineProperty(e,A,j),j};define(ae[42],ce([0,1,17,6,15,26,84,7,3,2,66,27,13]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.ProxyChannel=e.$di=e.$ai=e.$_h=e.$$h=e.RequestInitiator=e.$0h=e.$7h=e.$6h=void 0,e.$8h=o,e.$9h=a,e.$bi=I,e.$ci=F;var h;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(h||(h={}));function c(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(p||(p={}));function g(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(l||(l={}));function u(H){let B=0;for(let ie=0;;ie+=7){const re=H.read(1);if(B|=(re.buffer[0]&127)<<ie,!(re.buffer[0]&128))return B}}const m=n(0);function d(H,B){if(B===0){H.write(m);return}let ie=0;for(let he=B;he!==0;he=he>>>7)ie++;const re=L.$Fe.alloc(ie);for(let he=0;B!==0;he++)re.buffer[he]=B&127,B=B>>>7,B>0&&(re.buffer[he]|=128);H.write(re)}class ${constructor(B){this.b=B,this.a=0}read(B){const ie=this.b.slice(this.a,this.a+B);return this.a+=ie.byteLength,ie}}e.$6h=$;class t{constructor(){this.a=[]}get buffer(){return L.$Fe.concat(this.a)}write(B){this.a.push(B)}}e.$7h=t;var r;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(r||(r={}));function n(H){const B=L.$Fe.alloc(1);return B.writeUInt8(H,0),B}const s={Undefined:n(r.Undefined),String:n(r.String),Buffer:n(r.Buffer),VSBuffer:n(r.VSBuffer),Array:n(r.Array),Object:n(r.Object),Uint:n(r.Int)},i=typeof Buffer<"u";function o(H,B){if(typeof B>"u")H.write(s.Undefined);else if(typeof B=="string"){const ie=L.$Fe.fromString(B);H.write(s.String),d(H,ie.byteLength),H.write(ie)}else if(i&&Buffer.isBuffer(B)){const ie=L.$Fe.wrap(B);H.write(s.Buffer),d(H,ie.byteLength),H.write(ie)}else if(B instanceof L.$Fe)H.write(s.VSBuffer),d(H,B.byteLength),H.write(B);else if(Array.isArray(B)){H.write(s.Array),d(H,B.length);for(const ie of B)o(H,ie)}else if(typeof B=="number"&&(B|0)===B)H.write(s.Uint),d(H,B);else{const ie=L.$Fe.fromString(JSON.stringify(B));H.write(s.Object),d(H,ie.byteLength),H.write(ie)}}function a(H){switch(H.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return H.read(u(H)).toString();case r.Buffer:return H.read(u(H)).buffer;case r.VSBuffer:return H.read(u(H));case r.Array:{const ie=u(H),re=[];for(let he=0;he<ie;he++)re.push(a(H));return re}case r.Object:return JSON.parse(H.read(u(H)).toString());case r.Int:return u(H)}}class b{constructor(B,ie,re=null,he=1e3){this.h=B,this.j=ie,this.k=re,this.l=he,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(B,ie){this.b.set(B,ie),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case 200:{const ie=this.o([B.type]);this.k?.logOutgoing(ie,0,1,g(B.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([B.type,B.id],B.data);this.k?.logOutgoing(ie,B.id,1,g(B.type),B.data);return}}}o(B,ie=void 0){const re=new t;return o(re,B),o(re,ie),this.p(re.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const ie=new $(B),re=a(ie),he=a(ie),te=re[0];switch(te){case 100:return this.k?.logIncoming(B.byteLength,re[1],1,`${c(te)}: ${re[2]}.${re[3]}`,he),this.s({type:te,id:re[1],channelName:re[2],name:re[3],arg:he});case 102:return this.k?.logIncoming(B.byteLength,re[1],1,`${c(te)}: ${re[2]}.${re[3]}`,he),this.t({type:te,id:re[1],channelName:re[2],name:re[3],arg:he});case 101:return this.k?.logIncoming(B.byteLength,re[1],1,`${c(te)}`),this.u({type:te,id:re[1]});case 103:return this.k?.logIncoming(B.byteLength,re[1],1,`${c(te)}`),this.u({type:te,id:re[1]})}}s(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const re=new j.$pe;let he;try{he=ie.call(this.j,B.name,B.arg,re.token)}catch(U){he=Promise.reject(U)}const te=B.id;he.then(U=>{this.m({id:te,data:U,type:201})},U=>{U instanceof Error?this.m({id:te,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:te,data:U,type:203})}).finally(()=>{V.dispose(),this.d.delete(B.id)});const V=(0,f.$Tc)(()=>re.cancel());this.d.set(B.id,V)}t(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const re=B.id,te=ie.listen(this.j,B.name,B.arg)(V=>this.m({id:re,data:V,type:204}));this.d.set(B.id,te)}u(B){const ie=this.d.get(B.id);ie&&(ie.dispose(),this.d.delete(B.id))}v(B){let ie=this.g.get(B.channelName);ie||(ie=[],this.g.set(B.channelName,ie));const re=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:B,timeoutTimer:re})}w(B){const ie=this.g.get(B);if(ie){for(const re of ie)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,f.$Qc)(this.d.values()),this.d.clear()}}e.$0h=b;var S;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));class v{constructor(B,ie=null){this.l=B,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new C.$ee,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ie}getChannel(B){const ie=this;return{call(re,he,te){return ie.a?Promise.reject(new R.$5):ie.m(B,re,he,te)},listen(re,he){return ie.a?C.Event.None:ie.o(B,re,he)}}}m(B,ie,re,he=j.CancellationToken.None){const te=this.g++,U={id:te,type:100,channelName:B,name:ie,arg:re};if(he.isCancellationRequested)return Promise.reject(new R.$5);let D;return new Promise((z,x)=>{if(he.isCancellationRequested)return x(new R.$5);const K=()=>{const se=ue=>{switch(ue.type){case 201:this.f.delete(te),z(ue.data);break;case 202:{this.f.delete(te);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,x(ge);break}case 203:this.f.delete(te),x(ue.data);break}};this.f.set(te,se),this.p(U)};let ee=null;this.b===l.Idle?K():(ee=(0,N.$ih)(se=>this.u()),ee.then(()=>{ee=null,K()}));const _=()=>{ee?(ee.cancel(),ee=null):this.p({id:te,type:101}),x(new R.$5)},Y=he.onCancellationRequested(_);D=(0,f.$Sc)((0,f.$Tc)(_),Y),this.d.add(D)}).finally(()=>{D.dispose(),this.d.delete(D)})}o(B,ie,re){const he=this.g++,V={id:he,type:102,channelName:B,name:ie,arg:re};let U=null;const D=new C.$ee({onWillAddFirstListener:()=>{U=(0,N.$ih)(z=>this.u()),U.then(()=>{U=null,this.d.add(D),this.p(V)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(D),this.p({id:he,type:103}))}}),M=z=>D.fire(z.data);return this.f.set(he,M),D.event}p(B){switch(B.type){case 100:case 102:{const ie=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(ie,B.id,0,`${c(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const ie=this.q([B.type,B.id]);this.j?.logOutgoing(ie,B.id,0,c(B.type));return}}}q(B,ie=void 0){const re=new t;return o(re,B),o(re,ie),this.r(re.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const ie=new $(B),re=a(ie),he=a(ie),te=re[0];switch(te){case 200:return this.j?.logIncoming(B.byteLength,0,0,g(te)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(B.byteLength,re[1],0,g(te),he),this.t({type:re[0],id:re[1],data:he})}}t(B){if(B.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,f.$Qc)(this.d.values()),this.d.clear()}}e.$$h=v,Ee([O.$Zh],v.prototype,"onDidInitializePromise",null);class k{get connections(){const B=[];return this.f.forEach(ie=>B.push(ie)),B}constructor(B,ie,re){this.a=new Map,this.f=new Set,this.g=new C.$ee,this.onDidAddConnection=this.g.event,this.h=new C.$ee,this.onDidRemoveConnection=this.h.event,this.j=new f.$Uc,this.j.add(B(({protocol:he,onDidClientDisconnect:te})=>{const V=C.Event.once(he.onMessage);this.j.add(V(U=>{const D=new $(U),M=a(D),z=new b(he,M,ie,re),x=new v(he,ie);this.a.forEach((ee,_)=>z.registerChannel(_,ee));const K={channelServer:z,channelClient:x,ctx:M};this.f.add(K),this.g.fire(K),this.j.add(te(()=>{z.dispose(),x.dispose(),this.f.delete(K),this.h.fire(K)}))}))}))}getChannel(B,ie){const re=this;return{call(he,te,V){let U;if((0,w.$jg)(ie)){const M=(0,A.$4b)(re.connections.filter(ie));U=M?Promise.resolve(M):C.Event.toPromise(C.Event.filter(re.onDidAddConnection,ie))}else U=ie.routeCall(re,he,te);const D=U.then(M=>M.channelClient.getChannel(B));return I(D).call(he,te,V)},listen(he,te){if((0,w.$jg)(ie))return re.k(B,ie,he,te);const V=ie.routeEvent(re,he,te).then(U=>U.channelClient.getChannel(B));return I(V).listen(he,te)}}}k(B,ie,re,he){const te=this;let V;const U=new C.$ee({onWillAddFirstListener:()=>{V=new f.$Uc;const D=new C.$ke,M=new Map,z=K=>{const _=K.channelClient.getChannel(B).listen(re,he),Y=D.add(_);M.set(K,Y)},x=K=>{const ee=M.get(K);ee&&(ee.dispose(),M.delete(K))};te.connections.filter(ie).forEach(z),C.Event.filter(te.onDidAddConnection,ie)(z,void 0,V),te.onDidRemoveConnection(x,void 0,V),D.event(U.fire,U,V),V.add(D)},onDidRemoveLastListener:()=>{V?.dispose(),V=void 0}});return U.event}registerChannel(B,ie){this.a.set(B,ie);for(const re of this.f)re.channelServer.registerChannel(B,ie)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$_h=k;class P{constructor(B,ie,re=null){const he=new t;o(he,ie),B.send(he.buffer),this.a=new v(B,re),this.d=new b(B,ie,re)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,ie){this.d.registerChannel(B,ie)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ai=P;function I(H){return{call(B,ie,re){return H.then(he=>he.call(B,ie,re))},listen(B,ie){const re=new C.$ne;return H.then(he=>re.input=he.listen(B,ie)),re.event}}}function F(H){let B=!1;return{call(ie,re,he){return B?H.call(ie,re,he):(0,N.$wh)(0).then(()=>B=!0).then(()=>H.call(ie,re,he))},listen(ie,re){if(B)return H.listen(ie,re);const he=new C.$ne;return(0,N.$wh)(0).then(()=>B=!0).then(()=>he.input=H.listen(ie,re)),he.event}}}class T{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const ie of B.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await C.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$di=T;var q;(function(H){function B(te,V,U){const D=te,M=U&&U.disableMarshalling,z=new Map;for(const x in D)re(x)&&z.set(x,C.Event.buffer(D[x],!0,void 0,V));return new class{listen(x,K,ee){const _=z.get(K);if(_)return _;const Y=D[K];if(typeof Y=="function"){if(he(K))return Y.call(D,ee);if(re(K))return z.set(K,C.Event.buffer(D[K],!0,void 0,V)),z.get(K)}throw new R.$bb(`Event not found: ${K}`)}call(x,K,ee){const _=D[K];if(typeof _=="function"){if(!M&&Array.isArray(ee))for(let se=0;se<ee.length;se++)ee[se]=(0,E.$5h)(ee[se]);let Y=_.apply(D,ee);return Y instanceof Promise||(Y=Promise.resolve(Y)),Y}throw new R.$bb(`Method not found: ${K}`)}}}H.fromService=B;function ie(te,V){const U=V&&V.disableMarshalling;return new Proxy({},{get(D,M){if(typeof M=="string")return V?.properties?.has(M)?V.properties.get(M):he(M)?function(z){return te.listen(M,z)}:re(M)?te.listen(M):async function(...z){let x;V&&!(0,w.$eg)(V.context)?x=[V.context,...z]:x=z;const K=await te.call(M,x);return U?K:(0,E.$5h)(K)};throw new R.$bb(`Property not found: ${String(M)}`)}})}H.toService=ie;function re(te){return te[0]==="o"&&te[1]==="n"&&y.$wf(te.charCodeAt(2))}function he(te){return/^onDynamic/.test(te)&&y.$wf(te.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const X=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const B=H.toString();if(B!=="[object Object]")return B}return H}function Q(H){return Array.isArray(H)?H.map(G):G(H)}function W(H,B,ie,re,he,te,V){V=Q(V);const U=X[he],D=U[re%U.length];let M=[`%c[${H}]%c[${String(B).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${D}`];/\($/.test(te)?(M=M.concat(V),M.push(")")):M.push(V),console.log.apply(console,M)}class J{constructor(B,ie){this.d=B,this.f=ie,this.a=0,this.b=0}logOutgoing(B,ie,re,he,te){this.b+=B,W(this.d,this.b,B,ie,re,he,te)}logIncoming(B,ie,re,he,te){this.a+=B,W(this.f,this.a,B,ie,re,he,te)}}e.$ei=J}),define(ae[68],ce([0,1,15,3,2,42]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.ProtocolConstants=e.$fi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var R;(function(s){s.enableDiagnostics=!1,s.records=[];const i=new WeakMap;let o=0;function a(S,v){if(!i.has(S)){const k=String(++o);i.set(S,k)}return i.get(S)}function b(S,v,k,P){if(!s.enableDiagnostics)return;const I=a(S,v);if(P instanceof A.$Fe||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const F=A.$Fe.alloc(P.byteLength);F.set(P),s.records.push({timestamp:Date.now(),id:I,label:v,type:k,buff:F})}else s.records.push({timestamp:Date.now(),id:I,label:v,type:k,data:P})}s.traceSocketEvent=b})(R||(e.SocketDiagnostics=R={}));var C;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C||(e.SocketCloseEventType=C={}));let f=null;function E(){return f||(f=A.$Fe.alloc(0)),f}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,o){if(i===0)return E();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const v=this.a[0];return o&&(this.a.shift(),this.b-=i),v}if(this.a[0].byteLength>i){const v=this.a[0].slice(0,i);return o&&(this.a[0]=this.a[0].slice(i),this.b-=i),v}const a=A.$Fe.alloc(i);let b=0,S=0;for(;i>0;){const v=this.a[S];if(v.byteLength>i){const k=v.slice(0,i);a.set(k,b),b+=i,o&&(this.a[S]=v.slice(i),this.b-=i),i-=i}else a.set(v,b),b+=v.byteLength,o?(this.a.shift(),this.b-=v.byteLength):S++,i-=v.byteLength}return a}}e.$fi=y;var w;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(w||(w={}));function h(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var c;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(c||(e.ProtocolConstants=c={}));class p{constructor(i,o,a,b){this.type=i,this.id=o,this.ack=a,this.data=b,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends L.$Vc{constructor(i){super(),this.f=this.B(new N.$ee),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new y,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,b=this.g.id,S=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new p(a,b,S,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=A.$Fe.alloc(13);o.writeUInt8(i.type,0),o.writeUInt32BE(i.id,1),o.writeUInt32BE(i.ack,5),o.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(o,i.data)}g(i,o){const a=this.f===0;return this.d.push(i,o),this.f+=i.byteLength+o.byteLength,a}h(){const i=A.$Fe.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,o){this.g(i,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class u extends L.$Vc{constructor(i){super(),this.f=new N.$ee,this.onMessage=this.f.event,this.g=new N.$ee,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new l(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new p(1,0,0,i))}}e.$gi=u;class m extends j.$ai{static fromSocket(i,o){return new m(new u(i),o)}get onDidDispose(){return this.b.onDidDispose}constructor(i,o,a=null){super(i,o,a),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$hi=m;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$ee({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$ii=d;class ${constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,o=this.a;for(;o;)o=o.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let o=0,a=this.a;for(;a;)i[o++]=a.data,a=a.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const o=new $(i);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const i=Date.now();for(let o=0;o<r.a;o++)this.c[o]=i-1e3*o;setInterval(()=>{for(let o=r.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),o=(1+r.a)*1e3;let a=0;for(let b=0;b<r.a;b++)i-this.c[b]<=o&&a++;return 1-a/r.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new d,this.onControlMessage=this.u.event,this.v=new d,this.onMessage=this.v.event,this.w=new d,this.onDidDispose=this.w.event,this.x=new d,this.onSocketClose=this.x.event,this.y=new d,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??r.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Uc,this.o=i.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new p(5,0,0,E());this.p.write(i),this.p.flush()}sendPause(){const i=new p(7,0,0,E());this.p.write(i)}sendResume(){const i=new p(8,0,0,E());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,o){this.a=!0,this.r.dispose(),this.r=new L.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new p(3,0,this.h,E());this.p.write(i);const o=this.b.toArray();for(let a=0,b=o.length;a<b;a++)this.p.write(o[a]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const o=this.b.peek();if(o&&o.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new p(6,0,0,E())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let a=0,b=o.length;a<b;a++)this.p.write(o[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const o=++this.c;this.h=this.g;const a=new p(1,o,this.h,i);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(i){const o=new p(2,0,0,i);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),o=Date.now()-i.writtenTime,a=Date.now()-this.q.lastReadTime,b=Date.now()-this.n;if(o>=2e4&&a>=2e4&&b>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:a});return}const S=Math.max(2e4-o,2e4-a,2e4-b,500);this.f=setTimeout(()=>{this.f=null,this.B()},S)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new p(3,0,this.h,E());this.p.write(i)}D(){this.h=this.g;const i=new p(9,0,this.h,E());this.p.write(i)}}e.$ji=n}),define(ae[92],ce([0,1,67,6,15,26,142,7,3,2,30,149,89,42]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;class c extends h.$0h{constructor(l){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",u=>L.$Fe.wrap(Buffer.from(u,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$Yq=c;class p{constructor(l,u){this.i=l,this.j=u,this.c=new Set,this.g=new Map,this.h=new C.$ee,this.onDidProcessExit=this.h.event;const m=u&&u.timeout?u.timeout:6e4;this.b=new N.$sh(m),this.d=null,this.f=null}getChannel(l){const u=this;return{call(m,d,$){return u.k(l,m,d,$)},listen(m,d){return u.l(l,m,d)}}}k(l,u,m,d=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(R.$6());this.b.cancel();const $=this.n(l),t=(0,N.$ih)(s=>$.call(u,m,s)),r=d.onCancellationRequested(()=>t.cancel()),n=(0,f.$Tc)(()=>t.cancel());return this.c.add(n),t.finally(()=>{r.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(l,u,m){if(!this.b)return C.Event.None;this.b.cancel();let d;const $=new C.$ee({onWillAddFirstListener:()=>{d=this.n(l).listen(u,m)($.fire,$),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return $.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,E.$2n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,w.$mm)(u.env),this.d=(0,A.fork)(this.i,l,u);const m=new C.$ee,$=C.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,O.$Uq)(o)){(0,O.log)(o,`IPC Library: ${this.j.serverName}`);return}m.fire(L.$Fe.wrap(Buffer.from(o,"base64")))}),t=this.j.useQueue?(0,y.$om)(this.d):this.d,r=o=>this.d&&this.d.connected&&t.send(o.buffer.toString("base64")),n=m.event,s={send:r,onMessage:n};this.f=new h.$$h(s);const i=()=>this.o();process.once("exit",i),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,a)=>{process.removeListener("exit",i),$.dispose(),this.c.forEach(b=>(0,f.$Qc)(b)),this.c.clear(),o!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:a})})}return this.f}n(l){let u=this.g.get(l);return u||(u=this.m.getChannel(l),this.g.set(l,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Zq=p}),define(ae[151],ce([0,1,134,15,42,3,13,17]),function(ne,e,A,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7W=void 0,e.$8W=E;class C{constructor(w){this.a=w,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",h=>h.data?N.$Fe.wrap(h.data):N.$Fe.alloc(0)),w.start()}send(w){this.a.postMessage(w.buffer)}disconnect(){this.a.close()}}class f extends L.$_h{static b(w){(0,O.$fg)((0,A.$6W)(process),"Electron Utility Process");const h=new j.$ee;return process.parentPort.on("message",c=>{if(w?.handledClientConnection(c))return;const p=(0,R.$Ob)(c.ports);p&&h.fire(p)}),j.Event.map(h.event,c=>({protocol:new C(c),onDidClientDisconnect:j.Event.fromNodeEventEmitter(c,"close")}))}constructor(w){super(f.b(w))}}e.$7W=f;function E(y,w,h){const c=p=>{p.data===w&&(y.removeListener("message",c),h())};y.on("message",c)}}),define(ae[69],ce([0,1,6,3,2,66,13]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=e.StorageState=e.StorageHint=void 0,e.$Up=C;var R;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function C(w){const h=w;return h?.changed instanceof Map||h?.deleted instanceof Set}var f;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(f||(e.StorageState=f={}));class E extends L.$Vc{static{this.a=100}constructor(h,c=Object.create(null)){super(),this.r=h,this.s=c,this.b=this.B(new N.$he),this.onDidChangeStorage=this.b.event,this.c=f.None,this.f=new Map,this.g=this.B(new A.$th(E.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(h=>this.u(h)))}u(h){this.b.pause();try{h.changed?.forEach((c,p)=>this.w(p,c)),h.deleted?.forEach(c=>this.w(c,void 0))}finally{this.b.resume()}}w(h,c){if(this.c===f.Closed)return;let p=!1;(0,O.$eg)(c)?p=this.f.delete(h):this.f.get(h)!==c&&(this.f.set(h,c),p=!0),p&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===f.None&&(this.c=f.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(h,c){const p=this.f.get(h);return(0,O.$eg)(p)?c:p}getBoolean(h,c){const p=this.get(h);return(0,O.$eg)(p)?c:p==="true"}getNumber(h,c){const p=this.get(h);return(0,O.$eg)(p)?c:parseInt(p,10)}getObject(h,c){const p=this.get(h);return(0,O.$eg)(p)?c:(0,j.$4h)(p)}async set(h,c,p=!1){if(this.c===f.Closed)return;if((0,O.$eg)(c))return this.delete(h,p);const g=(0,O.$0f)(c)||Array.isArray(c)?(0,j.$3h)(c):String(c);if(this.f.get(h)!==g)return this.f.set(h,g),this.j.set(h,g),this.h.delete(h),this.b.fire({key:h,external:p}),this.D()}async delete(h,c=!1){if(!(this.c===f.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:c}),this.D()}async optimize(){if(this.c!==f.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=f.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(h).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(h){if(this.z)return this.D(h)}async D(h){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),h)}async whenFlushed(){if(this.z)return new Promise(h=>this.n.push(h))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$Vp=E;class y{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((c,p)=>this.a.set(p,c)),h.delete?.forEach(c=>this.a.delete(c))}async optimize(){}async close(){}}e.$Wp=y}),define(ae[152],ce([11,10]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(ae[70],ce([0,1,41,6,14,13,31,152]),function(ne,e,A,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=void 0,e.zip=g,e.$iq=l,e.$jq=m,e.$fq="end of central directory record signature not found";const C=new RegExp(e.$fq);class f extends Error{constructor($,t){let r=t.message;switch($){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=$,this.cause=t}}e.$gq=f;function E(d){const $=d.externalFileAttributes>>16||33188;return[448,56,7].map(t=>$&t).reduce((t,r)=>t+r,$&61440)}function y(d){if(d instanceof f)return d;let $;return C.test(d.message)&&($="CorruptZip"),new f($,d)}function w(d,$,t,r,n,s){const i=L.$nc($),o=L.$kc(r,i);if(!o.startsWith(r))return Promise.reject(new Error(R.localize(0,null,$)));const a=L.$kc(r,$);let b;return s.onCancellationRequested(()=>{b?.destroy()}),Promise.resolve(O.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((S,v)=>{if(!s.isCancellationRequested)try{b=(0,A.createWriteStream)(a,{mode:t}),b.once("close",()=>S()),b.once("error",v),d.once("error",v),d.pipe(b)}catch(k){v(k)}}))}function h(d,$,t,r){let n=(0,N.$ih)(()=>Promise.resolve()),s=0;const i=r.onCancellationRequested(()=>{n.cancel(),d.close()});return new Promise((o,a)=>{const b=new N.$qh,S=v=>{v.isCancellationRequested||(s++,d.readEntry())};d.once("error",a),d.once("close",()=>n.then(()=>{r.isCancellationRequested||d.entryCount===s?o():a(new f("Incomplete",new Error(R.localize(1,null,s,d.entryCount))))},a)),d.readEntry(),d.on("entry",v=>{if(r.isCancellationRequested)return;if(!t.sourcePathRegex.test(v.fileName)){S(r);return}const k=v.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(k)){const F=L.$kc($,k);n=(0,N.$ih)(T=>O.Promises.mkdir(F,{recursive:!0}).then(()=>S(T)).then(void 0,a));return}const P=p(d,v),I=E(v);n=(0,N.$ih)(F=>b.queue(()=>P.then(T=>w(T,k,I,$,t,F).then(()=>S(F)))).then(null,a))})}).finally(()=>i.dispose())}async function c(d,$=!1){const{open:t}=await new Promise((r,n)=>{ne(["yauzl"],r,n)});return new Promise((r,n)=>{t(d,$?{lazyEntries:!0}:void 0,(s,i)=>{s?n(y(s)):r((0,j.$gg)(i))})})}function p(d,$){return new Promise((t,r)=>{d.openReadStream($,(n,s)=>{n?r(y(n)):t((0,j.$gg)(s))})})}async function g(d,$){const{ZipFile:t}=await new Promise((r,n)=>{ne(["yazl"],r,n)});return new Promise((r,n)=>{const s=new t;$.forEach(o=>{o.contents?s.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&s.addFile(o.localPath,o.path)}),s.end();const i=(0,A.createWriteStream)(d);s.outputStream.pipe(i),s.outputStream.once("error",n),i.once("error",n),i.once("finish",()=>r(d))})}function l(d,$,t={},r){const n=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let s=c(d,!0);return t.overwrite&&(s=s.then(i=>O.Promises.rm($).then(()=>i))),s.then(i=>h(i,$,{sourcePathRegex:n},r))}function u(d,$){return c(d).then(t=>new Promise((r,n)=>{t.on("entry",s=>{s.fileName===$&&p(t,s).then(i=>r(i),i=>n(i))}),t.once("close",()=>n(new Error(R.localize(2,null,$))))}))}function m(d,$){return u(d,$).then(t=>new Promise((r,n)=>{const s=[];t.once("error",n),t.on("data",i=>s.push(i)),t.on("end",()=>r(Buffer.concat(s)))}))}}),define(ae[153],ce([11,10]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[154],ce([11,10]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[155],ce([11,10]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(ae[156],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ae[157],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[158],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[159],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[160],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ae[161],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ae[162],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[163],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(ae[164],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ae[165],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(ae[166],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[167],ce([11,10]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ae[168],ce([11,10]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(ae[169],ce([11,10]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ae[170],ce([11,10]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ae[171],ce([11,10]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(ae[172],ce([11,10]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ae[173],ce([11,10]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[174],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[175],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ae[176],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ae[177],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ae[178],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ae[179],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ae[180],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ae[181],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ae[182],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ae[183],ce([11,10]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ae[184],ce([0,1,7,155]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.TokenType=void 0;var L;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(L||(e.TokenType=L={}));function j(...f){switch(f.length){case 1:return(0,N.localize)(0,null,f[0]);case 2:return(0,N.localize)(1,null,f[0],f[1]);case 3:return(0,N.localize)(2,null,f[0],f[1],f[2]);default:return}}const O=(0,N.localize)(3,null),R=(0,N.localize)(4,null);class C{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return E.isTripleEq?"===":"==";case 4:return E.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return E.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return E.lexeme;case 18:return E.lexeme;case 19:return E.lexeme;case 20:return"EOF";default:throw(0,A.$8)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const y=this.d,w=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:w};this.g.push({offset:y,lexeme:w,additionalInfo:E}),this.f.push(h)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const y=this.c.substring(this.d,this.e),w=C.b.get(y);w?this.k(w):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,y=!1,w=!1;for(;;){if(E>=this.c.length){this.e=E,this.l(R);return}const c=this.c.charCodeAt(E);if(y)y=!1;else if(c===47&&!w){E++;break}else c===91?w=!0:c===92?y=!0:c===93&&(w=!1);E++}for(;E<this.c.length&&C.a.has(this.c.charCodeAt(E));)E++;this.e=E;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$qj=C}),define(ae[185],ce([0,1,65,84,23,14,36,20,8]),function(ne,e,A,N,L,j,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$6m=E,e.$7m=y,e.$4m=/^([^.]+\..+)[:=](.+)$/;class f{get appRoot(){return(0,j.$nc)(L.$Pg.asFileUri("").fsPath)}get userHome(){return C.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return C.URI.file((0,j.$kc)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.b.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get stateResource(){return(0,R.$9g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$9g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,A.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$kc)(this.userDataPath,"logs",h)}return C.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$9g)(C.URI.file((0,j.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$9g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$9g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$9g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=O.env.VSCODE_PORTABLE;return h?C.URI.file((0,j.$kc)(h,"argv.json")):(0,R.$9g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,j.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,j.$lc)(h):(0,j.$ic)((0,j.$kc)(L.$Pg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?C.URI.file((0,j.$lc)(h)):C.URI.file((0,j.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,j.$lc)(h);const c=O.env.VSCODE_EXTENSIONS;if(c)return c;const p=O.env.VSCODE_PORTABLE;return p?(0,j.$kc)(p,"extensions"):(0,R.$9g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(c=>/^[^:/?#]+?:\/\//.test(c)?C.URI.parse(c):C.URI.file((0,j.$ic)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?C.URI.parse(h):C.URI.file((0,j.$ic)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$4m.test(h))}get extensionLogLevel(){const h=[];for(const c of this.args.log||[]){const p=e.$4m.exec(c);p&&p[1]&&p[2]&&h.push([p[1],p[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.$9g)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=O.env.VSCODE_PORTABLE;return h?C.URI.file((0,j.$kc)(h,"policy.json")):(0,R.$9g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,c,p){this.a=h,this.b=c,this.c=p,this.editSessionId=this.args.editSessionId}}e.$5m=f,Ee([N.$Zh],f.prototype,"appRoot",null),Ee([N.$Zh],f.prototype,"userHome",null),Ee([N.$Zh],f.prototype,"userDataPath",null),Ee([N.$Zh],f.prototype,"appSettingsHome",null),Ee([N.$Zh],f.prototype,"tmpDir",null),Ee([N.$Zh],f.prototype,"cacheHome",null),Ee([N.$Zh],f.prototype,"stateResource",null),Ee([N.$Zh],f.prototype,"userRoamingDataHome",null),Ee([N.$Zh],f.prototype,"userDataSyncHome",null),Ee([N.$Zh],f.prototype,"sync",null),Ee([N.$Zh],f.prototype,"machineSettingsResource",null),Ee([N.$Zh],f.prototype,"workspaceStorageHome",null),Ee([N.$Zh],f.prototype,"localHistoryHome",null),Ee([N.$Zh],f.prototype,"keyboardLayoutResource",null),Ee([N.$Zh],f.prototype,"argvResource",null),Ee([N.$Zh],f.prototype,"isExtensionDevelopment",null),Ee([N.$Zh],f.prototype,"untitledWorkspacesHome",null),Ee([N.$Zh],f.prototype,"builtinExtensionsPath",null),Ee([N.$Zh],f.prototype,"extensionsPath",null),Ee([N.$Zh],f.prototype,"extensionDevelopmentLocationURI",null),Ee([N.$Zh],f.prototype,"extensionDevelopmentKind",null),Ee([N.$Zh],f.prototype,"extensionTestsLocationURI",null),Ee([N.$Zh],f.prototype,"debugExtensionHost",null),Ee([N.$Zh],f.prototype,"logLevel",null),Ee([N.$Zh],f.prototype,"extensionLogLevel",null),Ee([N.$Zh],f.prototype,"serviceMachineIdResource",null),Ee([N.$Zh],f.prototype,"disableTelemetry",null),Ee([N.$Zh],f.prototype,"disableWorkspaceTrust",null),Ee([N.$Zh],f.prototype,"useInMemorySecretStorage",null),Ee([N.$Zh],f.prototype,"policyFile",null);function E(w,h){return y(w["inspect-extensions"],w["inspect-brk-extensions"],5870,h,w.debugId,w.extensionEnvironment)}function y(w,h,c,p,g,l){const m=Number(h||w)||(p?null:c),d=m?!!h:!1;let $;if(l)try{$=JSON.parse(l)}catch{}return{port:m,break:d,debugId:g,env:$}}}),function(){"use strict";function ne(e,A,N){function L(O,R){const C=j(O,R),f=[C];return e.isAbsolute(C)||f.unshift(N),e.resolve(...f)}function j(O,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,R);const E=O["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(y,"AppData","Roaming")}break;case"darwin":f=e.join(A.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(A.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,R)}return{getUserDataPath:L}}if(typeof define=="function")define(ae[186],ce([276,37,36]),function(e,A,N){return ne(e,A,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),A=require("os");module.exports=ne(e,A,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[187],ce([0,1,37,185,186]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$9m=O,e.$0m=R;class j extends N.$5m{constructor(f,E){super(f,{homeDir:(0,A.homedir)(),tmpDir:(0,A.tmpdir)(),userDataDir:(0,L.getUserDataPath)(f,E.nameShort)},E)}}e.$8m=j;function O(C,f){return(0,N.$7m)(C["inspect-ptyhost"],C["inspect-brk-ptyhost"],5877,f,C.extensionEnvironment)}function R(C,f){return(0,N.$7m)(C["inspect-sharedprocess"],C["inspect-brk-sharedprocess"],5879,f,C.extensionEnvironment)}}),define(ae[188],ce([0,1,13,158]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=L;function L(O,R,C,f){try{j(O,R,C,f)}catch(E){O.error(E?.message??E)}return R}function j(O,R,C,f){const E=(y,w,h)=>{const c=y[w];if((0,A.$8f)(c)){const p=c,g=p.length;if(g>1&&p[0]==="%"&&p[g-1]==="%"){const l=p.substr(1,g-2);let u=C[l];u===void 0&&f&&(u=f[l]);const m=typeof u=="string"?u:u?.message,d=f?.[l],$=typeof d=="string"?d:d?.message;if(!m){$||O.warn(`[${R.name}]: ${(0,N.localize)(0,null,l)}`);return}if(h&&(w==="title"||w==="category")&&$&&$!==m){const t={value:m,original:$};y[w]=t}else y[w]=m}}else if((0,A.$0f)(c))for(const p in c)c.hasOwnProperty(p)&&(p==="commands"?E(c,p,!0):E(c,p,h));else if(Array.isArray(c))for(let p=0;p<c.length;p++)E(c,p,h)};for(const y in R)R.hasOwnProperty(y)&&E(R,y)}}),define(ae[189],ce([0,1,70,161]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=L;function L(j){return(0,A.$jq)(j,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}}),define(ae[190],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=e.$uec=void 0;class A{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$uec=A;class N{constructor(j){this.a=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,R){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${O}`)}}e.$vec=N}),define(ae[71],ce([0,1,20,88,162,55]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=C,e.$Gp=f,e.$Hp=E,e.$Ip=y,e.$Jp=w,e.$Kp=h,e.$Lp=c;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function C(l){return l=l.trim(),l==="*"||O.test(l)}function f(l){if(!C(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=l.match(O);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}function E(l){if(!l)return null;const u=l.majorBase,m=l.majorMustEqual,d=l.minorBase;let $=l.minorMustEqual;const t=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(u===0||($=!1),r=!1);let n=0;if(l.preRelease){const s=R.exec(l.preRelease);if(s){const[,i,o,a]=s;n=Date.UTC(Number(i),Number(o)-1,Number(a))}}return{majorBase:u,majorMustEqual:m,minorBase:d,minorMustEqual:$,patchBase:t,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:n}}function y(l,u,m){let d;typeof l=="string"?d=E(f(l)):d=l;let $;u instanceof Date?$=u.getTime():typeof u=="string"&&($=new Date(u).getTime());let t;if(typeof m=="string"?t=E(f(m)):t=m,!d||!t)return!1;const r=d.majorBase,n=d.minorBase,s=d.patchBase;let i=t.majorBase,o=t.minorBase,a=t.patchBase;const b=t.notBefore;let S=t.majorMustEqual,v=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?r>i?!0:r<i?!1:n>o?!0:n<o||$&&$<b?!1:s>=a:(r===1&&i===0&&(!S||!v||!k)&&(i=1,o=0,a=0,S=!0,v=!1,k=!1),r<i?!1:r>i?!S:n<o?!1:n>o?!v:s<a?!1:s>a?!k:!($&&$<b))}function w(l,u,m,d,$){const t=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return t.push([N.default.Error,L.localize(0,null)]),t;if(typeof d.name!="string")return t.push([N.default.Error,L.localize(1,null,"name")]),t;if(typeof d.version!="string")return t.push([N.default.Error,L.localize(2,null,"version")]),t;if(!d.engines)return t.push([N.default.Error,L.localize(3,null,"engines")]),t;if(typeof d.engines.vscode!="string")return t.push([N.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof d.extensionDependencies<"u"&&!g(d.extensionDependencies))return t.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof d.activationEvents<"u"){if(!g(d.activationEvents))return t.push([N.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof d.main>"u"&&typeof d.browser>"u")return t.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&t.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return t.push([N.default.Error,L.localize(9,null,"main")]),t;{const s=(0,A.$9g)(m,d.main);(0,A.$3g)(s,m)||t.push([N.default.Warning,L.localize(10,null,s.path,m.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return t.push([N.default.Error,L.localize(11,null,"browser")]),t;{const s=(0,A.$9g)(m,d.browser);(0,A.$3g)(s,m)||t.push([N.default.Warning,L.localize(12,null,s.path,m.path)])}}if(!j.valid(d.version))return t.push([N.default.Error,L.localize(13,null)]),t;const r=[];if(!h(l,u,d,$,r))for(const s of r)t.push([N.default.Error,s]);return t}function h(l,u,m,d,$){return d||typeof m.main>"u"&&typeof m.browser>"u"?!0:p(l,u,m.engines.vscode,$)}function c(l,u,m){return l==="*"||p(u,m,l)}function p(l,u,m,d=[]){const $=E(f(m));if(!$)return d.push(L.localize(14,null,m)),!1;if($.majorBase===0){if(!$.majorMustEqual||!$.minorMustEqual)return d.push(L.localize(15,null,m)),!1}else if(!$.majorMustEqual)return d.push(L.localize(16,null,m)),!1;return y(l,u,$)?!0:(d.push(L.localize(17,null,l,m)),!1)}function g(l){if(!Array.isArray(l))return!1;for(let u=0,m=l.length;u<m;u++)if(typeof l[u]!="string")return!1;return!0}}),define(ae[45],ce([0,1,15,32]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=L;async function L(j,O,R){let C=R&&R.get("storage.serviceMachineId",-1)||null;if(C)return C;try{const E=(await O.readFile(j.serviceMachineIdResource)).value.toString();C=(0,N.$Qg)(E)?E:null}catch{C=null}if(!C){C=(0,N.$Rg)();try{await O.writeFile(j.serviceMachineIdResource,A.$Fe.fromString(C))}catch{}}return R?.store("storage.serviceMachineId",C,-1,1),C}}),define(ae[72],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=void 0;class A{constructor(L,j=[],O=!1){this.ctor=L,this.staticArguments=j,this.supportsDelayedInstantiation=O}}e.$si=A}),define(ae[191],ce([0,1,72]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ws=j,e.$xs=O;const N=[];var L;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function j(R,C,f){C instanceof A.$si||(C=new A.$si(C,[],!!f)),N.push([R,C])}function O(){return N}}),define(ae[192],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=void 0;class A{constructor(j,O){this.key=j,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$_q=A;class N{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const O of this.a.values())O.outgoing.size===0&&j.push(O);return j}insertEdge(j,O){const R=this.lookupOrInsertNode(j),C=this.lookupOrInsertNode(O);R.outgoing.set(C.key,C),C.incoming.set(R.key,R)}removeNode(j){const O=this.b(j);this.a.delete(O);for(const R of this.a.values())R.outgoing.delete(O),R.incoming.delete(O)}lookupOrInsertNode(j){const O=this.b(j);let R=this.a.get(O);return R||(R=new A(O,j),this.a.set(O,R)),R}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[O,R]of this.a)j.push(`${O}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,O]of this.a){const R=new Set([j]),C=this.c(O,R);if(C)return C}}c(j,O){for(const[R,C]of j.outgoing){if(O.has(R))return[...O,R].join(" -> ");O.add(R);const f=this.c(C,O);if(f)return f;O.delete(R)}}}e.$ar=N}),define(ae[4],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e._util=void 0,e.$vi=L,e.$wi=j;var A;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function R(C){return C[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=R})(A||(e._util=A={})),e.$ui=L("instantiationService");function N(O,R,C){R[A.DI_TARGET]===R?R[A.DI_DEPENDENCIES].push({id:O,index:C}):(R[A.DI_DEPENDENCIES]=[{id:O,index:C}],R[A.DI_TARGET]=R)}function L(O){if(A.serviceIds.has(O))return A.serviceIds.get(O);const R=function(C,f,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(R,C,E)};return R.toString=()=>O,A.serviceIds.set(O,R),R}function j(O){return O}}),define(ae[193],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0,e.$7dc=(0,A.$vi)("checksumService")}),define(ae[21],ce([0,1,13,8,4]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$2i=void 0,e.$3i=j,e.$4i=O,e.$5i=C,e.$6i=f,e.$7i=E,e.$8i=y,e.$9i=w,e.$0i=c,e.$$i=p,e.$_i=g,e.$2i=(0,L.$vi)("configurationService");function j(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof N.URI)}function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof N.URI)}var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function C(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function f(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}function E(l,u){const m=Object.create(null);for(const d in l)y(m,d,l[d],u);return m}function y(l,u,m,d){const $=u.split("."),t=$.pop();let r=l;for(let n=0;n<$.length;n++){const s=$[n];let i=r[s];switch(typeof i){case"undefined":i=r[s]=Object.create(null);break;case"object":if(i===null){d(`Ignoring ${u} as ${$.slice(0,n+1).join(".")} is null`);return}break;default:d(`Ignoring ${u} as ${$.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}r=i}if(typeof r=="object"&&r!==null)try{r[t]=m}catch{d(`Ignoring ${u} as ${$.join(".")} is ${JSON.stringify(r)}`)}else d(`Ignoring ${u} as ${$.join(".")} is ${JSON.stringify(r)}`)}function w(l,u){const m=u.split(".");h(l,m)}function h(l,u){const m=u.shift();if(u.length===0){delete l[m];return}if(Object.keys(l).indexOf(m)!==-1){const d=l[m];typeof d=="object"&&!Array.isArray(d)&&(h(d,u),Object.keys(d).length===0&&delete l[m])}}function c(l,u,m){function d(r,n){let s=r;for(const i of n){if(typeof s!="object"||s===null)return;s=s[i]}return s}const $=u.split("."),t=d(l,$);return typeof t>"u"?m:t}function p(l,u,m){Object.keys(u).forEach(d=>{d!=="__proto__"&&(d in l?A.$0f(l[d])&&A.$0f(u[d])?p(l[d],u[d],m):m&&(l[d]=u[d]):l[d]=u[d])})}function g(l){return l.replace(/[\[\]]/g,"")}}),define(ae[93],ce([0,1,5,27,184,4,154,7]),function(ne,e,A,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$tj=e.$sj=e.ContextKeyExprType=void 0,e.$rj=f,e.$uj=r,e.$vj=n,e.$Oj=he;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",A.$j),C.set("isLinux",A.$k),C.set("isWindows",A.$i),C.set("isWeb",A.$o),C.set("isMacNative",A.$j&&!A.$o),C.set("isEdge",A.$H),C.set("isFirefox",A.$F),C.set("isChrome",A.$E),C.set("isSafari",A.$G);function f(U,D){if(C.get(U)!==void 0)throw(0,R.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");C.set(U,D)}const E=Object.prototype.hasOwnProperty;var y;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const w={regexParsingWithErrorRecovery:!0},h=(0,O.localize)(0,null),c=(0,O.localize)(1,null),p=(0,O.localize)(2,null),g=(0,O.localize)(3,null),l=(0,O.localize)(4,null),u=(0,O.localize)(5,null),m=(0,O.localize)(6,null),d=(0,O.localize)(7,null);class ${static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=w){this.k=D,this.d=new L.$qj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const M=this.l();if(!this.E()){const z=this.D(),x=z.type===17?u:void 0;throw this.h.push({message:l,offset:z.offset,lexeme:L.$qj.getLexeme(z),additionalInfo:x}),$.c}return M}catch(M){if(M!==$.c)throw M;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(16);){const M=this.o();D.push(M)}return D.length===1?D[0]:t.or(...D)}o(){const D=[this.s()];for(;this.y(15);){const M=this.s();D.push(M)}return D.length===1?D[0]:t.and(...D)}s(){if(this.y(2)){const D=this.D();switch(D.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const M=this.l();return this.A(1,g),M?.negate()}case 17:return this.z(),P.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const M=this.l();return this.A(1,g),M}case 17:{const M=D.lexeme;if(this.z(),this.y(9)){const x=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),x.type!==10)throw this.B("REGEX",x);const K=x.lexeme,ee=K.lastIndexOf("/"),_=ee===K.length-1?void 0:this.w(K.substring(ee+1));let Y;try{Y=new RegExp(K.substring(1,ee),_)}catch{throw this.B("REGEX",x)}return G.create(M,Y)}switch(x.type){case 10:case 19:{const K=[x.lexeme];this.z();let ee=this.D(),_=0;for(let fe=0;fe<x.lexeme.length;fe++)x.lexeme.charCodeAt(fe)===40?_++:x.lexeme.charCodeAt(fe)===41&&_--;for(;!this.E()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:_++;break;case 1:_--;break;case 10:case 18:for(let fe=0;fe<ee.lexeme.length;fe++)ee.lexeme.charCodeAt(fe)===40?_++:x.lexeme.charCodeAt(fe)===41&&_--}if(_<0)break;K.push(L.$qj.getLexeme(ee)),this.z(),ee=this.D()}const Y=K.join(""),se=Y.lastIndexOf("/"),ue=se===Y.length-1?void 0:this.w(Y.substring(se+1));let ge;try{ge=new RegExp(Y.substring(1,se),ue)}catch{throw this.B("REGEX",x)}return t.regex(M,ge)}case 18:{const K=x.lexeme;this.z();let ee=null;if(!(0,N.$7e)(K)){const _=K.indexOf("/"),Y=K.lastIndexOf("/");if(_!==Y&&_>=0){const se=K.slice(_+1,Y),ue=K[Y+1]==="i"?"i":"";try{ee=new RegExp(se,ue)}catch{throw this.B("REGEX",x)}}}if(ee===null)throw this.B("REGEX",x);return G.create(M,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const x=this.u();return t.notIn(M,x)}switch(this.D().type){case 3:{this.z();const x=this.u();if(this.x().type===18)return t.equals(M,x);switch(x){case"true":return t.has(M);case"false":return t.not(M);default:return t.equals(M,x)}}case 4:{this.z();const x=this.u();if(this.x().type===18)return t.notEquals(M,x);switch(x){case"true":return t.not(M);case"false":return t.has(M);default:return t.notEquals(M,x)}}case 5:return this.z(),q.create(M,this.u());case 6:return this.z(),X.create(M,this.u());case 7:return this.z(),F.create(M,this.u());case 8:return this.z(),T.create(M,this.u());case 13:return this.z(),t.in(M,this.u());default:return t.has(M)}}case 20:throw this.h.push({message:m,offset:D.offset,lexeme:"",additionalInfo:d}),$.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case 17:case 18:return this.z(),D.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,M){if(this.C(D))return this.z();throw this.B(M,this.D())}B(D,M,z){const x=(0,O.localize)(8,null,D,L.$qj.getLexeme(M)),K=M.offset,ee=L.$qj.getLexeme(M);return this.h.push({message:x,offset:K,lexeme:ee,additionalInfo:z}),$.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$sj=$;class t{static false(){return i.INSTANCE}static true(){return o.INSTANCE}static has(D){return a.create(D)}static equals(D,M){return b.create(D,M)}static notEquals(D,M){return k.create(D,M)}static regex(D,M){return G.create(D,M)}static in(D,M){return S.create(D,M)}static notIn(D,M){return v.create(D,M)}static not(D){return P.create(D)}static and(...D){return J.create(D,null,!0)}static or(...D){return H.create(D,null,!0)}static greater(D,M){return F.create(D,M)}static greaterEquals(D,M){return T.create(D,M)}static smaller(D,M){return q.create(D,M)}static smallerEquals(D,M){return X.create(D,M)}static{this.c=new $({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$tj=t;function r(U){const D=new $({regexParsingWithErrorRecovery:!1});return U.map(M=>(D.parse(M),D.lexingErrors.length>0?D.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,O.localize)(9,null,z.additionalInfo):(0,O.localize)(10,null),offset:z.offset,length:z.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}function n(U,D){const M=U?U.substituteConstants():void 0,z=D?D.substituteConstants():void 0;return!M&&!z?!0:!M||!z?!1:M.equals(z)}function s(U,D){return U.cmp(D)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return o.INSTANCE}}e.$wj=i;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return i.INSTANCE}}e.$xj=o;class a{static create(D,M=null){const z=C.get(D);return typeof z=="boolean"?z?o.INSTANCE:i.INSTANCE:new a(D,M)}constructor(D,M){this.key=D,this.c=M,this.type=2}cmp(D){return D.type!==this.type?this.type-D.type:ie(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=C.get(this.key);return typeof D=="boolean"?D?o.INSTANCE:i.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$yj=a;class b{static create(D,M,z=null){if(typeof M=="boolean")return M?a.create(D,z):P.create(D,z);const x=C.get(D);return typeof x=="boolean"?M===(x?"true":"false")?o.INSTANCE:i.INSTANCE:new b(D,M,z)}constructor(D,M,z){this.c=D,this.d=M,this.f=z,this.type=4}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=C.get(this.c);if(typeof D=="boolean"){const M=D?"true":"false";return this.d===M?o.INSTANCE:i.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$zj=b;class S{static create(D,M){return new S(D,M)}constructor(D,M){this.d=D,this.f=M,this.type=10,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:re(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const M=D.getValue(this.f),z=D.getValue(this.d);return Array.isArray(M)?M.includes(z):typeof z=="string"&&typeof M=="object"&&M!==null?E.call(M,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$Aj=S;class v{static create(D,M){return new v(D,M)}constructor(D,M){this.d=D,this.f=M,this.type=11,this.c=S.create(D,M)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Bj=v;class k{static create(D,M,z=null){if(typeof M=="boolean")return M?P.create(D,z):a.create(D,z);const x=C.get(D);return typeof x=="boolean"?M===(x?"true":"false")?i.INSTANCE:o.INSTANCE:new k(D,M,z)}constructor(D,M,z){this.c=D,this.d=M,this.f=z,this.type=5}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=C.get(this.c);if(typeof D=="boolean"){const M=D?"true":"false";return this.d===M?i.INSTANCE:o.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Cj=k;class P{static create(D,M=null){const z=C.get(D);return typeof z=="boolean"?z?i.INSTANCE:o.INSTANCE:new P(D,M)}constructor(D,M){this.c=D,this.d=M,this.type=3}cmp(D){return D.type!==this.type?this.type-D.type:ie(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=C.get(this.c);return typeof D=="boolean"?D?i.INSTANCE:o.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$Dj=P;function I(U,D){if(typeof U=="string"){const M=parseFloat(U);isNaN(M)||(U=M)}return typeof U=="string"||typeof U=="number"?D(U):i.INSTANCE}class F{static create(D,M,z=null){return I(M,x=>new F(D,x,z))}constructor(D,M,z){this.c=D,this.d=M,this.f=z,this.type=12}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$Ej=F;class T{static create(D,M,z=null){return I(M,x=>new T(D,x,z))}constructor(D,M,z){this.c=D,this.d=M,this.f=z,this.type=13}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Fj=T;class q{static create(D,M,z=null){return I(M,x=>new q(D,x,z))}constructor(D,M,z){this.c=D,this.d=M,this.f=z,this.type=14}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Gj=q;class X{static create(D,M,z=null){return I(M,x=>new X(D,x,z))}constructor(D,M,z){this.c=D,this.d=M,this.f=z,this.type=15}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Hj=X;class G{static create(D,M){return new G(D,M)}constructor(D,M){this.d=D,this.f=M,this.type=7,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const M=this.f?this.f.source:"",z=D.f?D.f.source:"";return M<z?-1:M>z?1:0}equals(D){if(D.type===this.type){const M=this.f?this.f.source:"",z=D.f?D.f.source:"";return this.d===D.d&&M===z}return!1}substituteConstants(){return this}evaluate(D){const M=D.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Q.create(this)),this.c}}e.$Ij=G;class Q{static create(D){return new Q(D)}constructor(D){this.c=D,this.type=8}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new Q(this.c.map(D))}negate(){return this.c}}e.$Jj=Q;function W(U){let D=null;for(let M=0,z=U.length;M<z;M++){const x=U[M].substituteConstants();if(U[M]!==x&&D===null){D=[];for(let K=0;K<M;K++)D[K]=U[K]}D!==null&&(D[M]=x)}return D===null?U:D}class J{static create(D,M,z){return J.d(D,M,z)}constructor(D,M){this.expr=D,this.c=M,this.type=6}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let M=0,z=this.expr.length;M<z;M++){const x=s(this.expr[M],D.expr[M]);if(x!==0)return x}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let M=0,z=this.expr.length;M<z;M++)if(!this.expr[M].equals(D.expr[M]))return!1;return!0}return!1}substituteConstants(){const D=W(this.expr);return D===this.expr?this:J.create(D,this.c,!1)}evaluate(D){for(let M=0,z=this.expr.length;M<z;M++)if(!this.expr[M].evaluate(D))return!1;return!0}static d(D,M,z){const x=[];let K=!1;for(const ee of D)if(ee){if(ee.type===1){K=!0;continue}if(ee.type===0)return i.INSTANCE;if(ee.type===6){x.push(...ee.expr);continue}x.push(ee)}if(x.length===0&&K)return o.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(s);for(let ee=1;ee<x.length;ee++)x[ee-1].equals(x[ee])&&(x.splice(ee,1),ee--);if(x.length===1)return x[0];for(;x.length>1;){const ee=x[x.length-1];if(ee.type!==9)break;x.pop();const _=x.pop(),Y=x.length===0,se=H.create(ee.expr.map(ue=>J.create([ue,_],null,z)),null,Y);se&&(x.push(se),x.sort(s))}if(x.length===1)return x[0];if(z){for(let ee=0;ee<x.length;ee++)for(let _=ee+1;_<x.length;_++)if(x[ee].negate().equals(x[_]))return i.INSTANCE;if(x.length===1)return x[0]}return new J(x,M)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const M of this.expr)D.push(...M.keys());return D}map(D){return new J(this.expr.map(M=>M.map(D)),null)}negate(){if(!this.c){const D=[];for(const M of this.expr)D.push(M.negate());this.c=H.create(D,this,!0)}return this.c}}e.$Kj=J;class H{static create(D,M,z){return H.d(D,M,z)}constructor(D,M){this.expr=D,this.c=M,this.type=9}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let M=0,z=this.expr.length;M<z;M++){const x=s(this.expr[M],D.expr[M]);if(x!==0)return x}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let M=0,z=this.expr.length;M<z;M++)if(!this.expr[M].equals(D.expr[M]))return!1;return!0}return!1}substituteConstants(){const D=W(this.expr);return D===this.expr?this:H.create(D,this.c,!1)}evaluate(D){for(let M=0,z=this.expr.length;M<z;M++)if(this.expr[M].evaluate(D))return!0;return!1}static d(D,M,z){let x=[],K=!1;if(D){for(let ee=0,_=D.length;ee<_;ee++){const Y=D[ee];if(Y){if(Y.type===0){K=!0;continue}if(Y.type===1)return o.INSTANCE;if(Y.type===9){x=x.concat(Y.expr);continue}x.push(Y)}}if(x.length===0&&K)return i.INSTANCE;x.sort(s)}if(x.length!==0){if(x.length===1)return x[0];for(let ee=1;ee<x.length;ee++)x[ee-1].equals(x[ee])&&(x.splice(ee,1),ee--);if(x.length===1)return x[0];if(z){for(let ee=0;ee<x.length;ee++)for(let _=ee+1;_<x.length;_++)if(x[ee].negate().equals(x[_]))return o.INSTANCE;if(x.length===1)return x[0]}return new H(x,M)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const M of this.expr)D.push(...M.keys());return D}map(D){return new H(this.expr.map(M=>M.map(D)),null)}negate(){if(!this.c){const D=[];for(const M of this.expr)D.push(M.negate());for(;D.length>1;){const M=D.shift(),z=D.shift(),x=[];for(const K of V(M))for(const ee of V(z))x.push(J.create([K,ee],null,!1));D.unshift(H.create(x,null,!1))}this.c=H.create(D,this,!0)}return this.c}}e.$Lj=H;class B extends a{static{this.d=[]}static all(){return B.d.values()}constructor(D,M,z){super(D,null),this.f=M,typeof z=="object"?B.d.push({...z,key:D}):z!==!0&&B.d.push({key:D,description:z,type:M!=null?typeof M:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return b.create(this.key,D)}notEqualsTo(D){return k.create(this.key,D)}}e.$Mj=B,e.$Nj=(0,j.$vi)("contextKeyService");function ie(U,D){return U<D?-1:U>D?1:0}function re(U,D,M,z){return U<M?-1:U>M?1:D<z?-1:D>z?1:0}function he(U,D){if(U.type===0||D.type===1)return!0;if(U.type===9)return D.type===9?te(U.expr,D.expr):!1;if(D.type===9){for(const M of D.expr)if(he(U,M))return!0;return!1}if(U.type===6){if(D.type===6)return te(D.expr,U.expr);for(const M of U.expr)if(he(M,D))return!0;return!1}return U.equals(D)}function te(U,D){let M=0,z=0;for(;M<U.length&&z<D.length;){const x=U[M].cmp(D[z]);if(x<0)return!1;x===0&&M++,z++}return M===U.length}function V(U){return U.type===9?U.expr:[U]}}),define(ae[94],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=e.$cn=e.ID=void 0,e.$dn=N,e.ID="diagnosticsService",e.$cn=(0,A.$vi)(e.ID);function N(j){return!!j.hostName&&!!j.errorMessage}class L{async getPerformanceInfo(O,R){return{}}async getSystemInfo(O,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,R){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$en=L}),define(ae[95],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=void 0,e.$Jo=(0,A.$vi)("downloadService")}),define(ae[16],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=void 0,e.$Ci=(0,A.$vi)("environmentService"),e.$Di=(0,A.$wi)(e.$Ci)}),define(ae[29],ce([0,1,157,4]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.ExtensionGalleryErrorCode=e.$6o=e.ExtensionManagementErrorCode=e.$5o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=void 0,e.$Yo=L,e.$Zo=j,e.$1o=O,e.$2o=R,e.$3o=C,e.$4o=f,e.$So="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$To=new RegExp(e.$So),e.$Uo="__web_extension",e.$Vo="skipWalkthrough",e.$Wo="extensionsSync",e.$Xo="dependecyOrPackExtensionInstall";function L(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function j(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function O(u,m){switch(u){case 3:return m==="x64"?"win32-x64":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function R(u,m){return m==="web"&&!u.includes("web")}function C(u,m,d){return R(m,d)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===d}function f(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}var E;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var y;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var w;(function(u){u.Install="install",u.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var h;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.$5o=(0,N.$vi)("extensionGalleryService");var c;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.DownloadSignature="DownloadSignature",u.UpdateMetadata="UpdateMetadata",u.Extract="Extract",u.Scanning="Scanning",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.NotAllowed="NotAllowed",u.Gallery="Gallery",u.Cancelled="Cancelled",u.Unknown="Unknown",u.Internal="Internal"})(c||(e.ExtensionManagementErrorCode=c={}));class p extends Error{constructor(m,d){super(m),this.code=d,this.name=d}}e.$6o=p;var g;(function(u){u.Timeout="Timeout",u.Cancelled="Cancelled",u.Failed="Failed"})(g||(e.ExtensionGalleryErrorCode=g={}));class l extends Error{constructor(m,d){super(m),this.code=d,this.name=d}}e.$7o=l,e.$8o=(0,N.$vi)("extensionManagementService"),e.$9o="extensionsIdentifiers/disabled",e.$0o="extensionsIdentifiers/enabled",e.$$o=(0,N.$vi)("IGlobalExtensionEnablementService"),e.$_o=(0,N.$vi)("IExtensionTipsService"),e.$ap=(0,A.localize2)(0,"Extensions"),e.$bp=(0,A.localize2)(1,"Preferences")}),define(ae[194],ce([0,1,3,2,30,8,91,29]),function(ne,e,A,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=e.$cq=void 0;function C(g,l){return g?j.URI.revive(l?l.transformIncoming(g):g):void 0}function f(g,l){return l?l.transformOutgoingURI(g):g}function E(g,l){l=l||O.$yn;const u=g.manifest;return{...(0,O.$Bn)({...g,manifest:void 0},l),manifest:u}}function y(g,l){return g?.profileLocation?(0,O.$Bn)(g,l??O.$yn):g}function w(g,l){return l?(0,L.$4n)(g,u=>u instanceof j.URI?l.transformOutgoingURI(u):void 0):g}class h{constructor(l,u){this.a=l,this.b=u,this.onInstallExtension=A.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=A.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=A.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=A.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=A.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,u){const m=this.b(l);switch(u){case"onInstallExtension":return A.Event.map(this.onInstallExtension,d=>({...d,profileLocation:d.profileLocation?f(d.profileLocation,m):d.profileLocation}));case"onDidInstallExtensions":return A.Event.map(this.onDidInstallExtensions,d=>d.map($=>({...$,local:$.local?w($.local,m):$.local,profileLocation:$.profileLocation?f($.profileLocation,m):$.profileLocation})));case"onUninstallExtension":return A.Event.map(this.onUninstallExtension,d=>({...d,profileLocation:d.profileLocation?f(d.profileLocation,m):d.profileLocation}));case"onDidUninstallExtension":return A.Event.map(this.onDidUninstallExtension,d=>({...d,profileLocation:d.profileLocation?f(d.profileLocation,m):d.profileLocation}));case"onDidUpdateExtensionMetadata":return A.Event.map(this.onDidUpdateExtensionMetadata,d=>w(d,m))}throw new Error("Invalid listen")}async call(l,u,m){const d=this.b(l);switch(u){case"zip":{const $=E(m[0],d),t=await this.a.zip($);return f(t,d)}case"unzip":return this.a.unzip(C(m[0],d));case"install":return this.a.install(C(m[0],d),y(m[1],d));case"installFromLocation":return this.a.installFromLocation(C(m[0],d),C(m[1],d));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(m[0],C(m[1],d),C(m[2],d));case"getManifest":return this.a.getManifest(C(m[0],d));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(m[0]);case"installFromGallery":return this.a.installFromGallery(m[0],y(m[1],d));case"installGalleryExtensions":{const $=m[0];return this.a.installGalleryExtensions($.map(({extension:t,options:r})=>({extension:t,options:y(r,d)??{}})))}case"uninstall":return this.a.uninstall(E(m[0],d),y(m[1],d));case"reinstallFromGallery":return this.a.reinstallFromGallery(E(m[0],d));case"getInstalled":return(await this.a.getInstalled(m[0],C(m[1],d),m[2])).map(t=>w(t,d));case"toggleAppliationScope":{const $=await this.a.toggleAppliationScope(E(m[0],d),C(m[1],d));return w($,d)}case"copyExtensions":return this.a.copyExtensions(C(m[0],d),C(m[1],d));case"updateMetadata":{const $=await this.a.updateMetadata(E(m[0],d),m[1],C(m[2],d));return w($,d)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(m[0],m[1],m[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$cq=h;class c extends N.$Vc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.m=l,this.c=this.B(new A.$ee),this.f=this.B(new A.$ee),this.g=this.B(new A.$ee),this.h=this.B(new A.$ee),this.j=this.B(new A.$ee),this.B(this.m.listen("onInstallExtension")(u=>this.n(this.c,{...u,source:this.r(u.source)?j.URI.revive(u.source):u.source,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(u=>this.n(this.f,u.map(m=>({...m,local:m.local?E(m.local,null):m.local,source:this.r(m.source)?j.URI.revive(m.source):m.source,profileLocation:j.URI.revive(m.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(u=>this.n(this.g,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(u=>this.n(this.h,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(E(u,null))))}n(l,u){l.fire(u)}r(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(l){const u=await this.getTargetPlatform();return l.allTargetPlatforms.some(m=>(0,R.$3o)(m,l.allTargetPlatforms,u))}zip(l){return Promise.resolve(this.m.call("zip",[l]).then(u=>j.URI.revive(u)))}unzip(l){return Promise.resolve(this.m.call("unzip",[l]))}install(l,u){return Promise.resolve(this.m.call("install",[l,u])).then(m=>E(m,null))}installFromLocation(l,u){return Promise.resolve(this.m.call("installFromLocation",[l,u])).then(m=>E(m,null))}async installExtensionsFromProfile(l,u,m){return(await this.m.call("installExtensionsFromProfile",[l,u,m])).map($=>E($,null))}getManifest(l){return Promise.resolve(this.m.call("getManifest",[l]))}installFromGallery(l,u){return Promise.resolve(this.m.call("installFromGallery",[l,u])).then(m=>E(m,null))}async installGalleryExtensions(l){return(await this.m.call("installGalleryExtensions",[l])).map(m=>({...m,local:m.local?E(m.local,null):m.local,source:this.r(m.source)?j.URI.revive(m.source):m.source,profileLocation:j.URI.revive(m.profileLocation)}))}uninstall(l,u){if(l.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[l,u]))}reinstallFromGallery(l){return Promise.resolve(this.m.call("reinstallFromGallery",[l])).then(u=>E(u,null))}getInstalled(l=null,u,m){return Promise.resolve(this.m.call("getInstalled",[l,u,m])).then(d=>d.map($=>E($,null)))}updateMetadata(l,u,m){return Promise.resolve(this.m.call("updateMetadata",[l,u,m])).then(d=>E(d,null))}toggleAppliationScope(l,u){return this.m.call("toggleAppliationScope",[l,u]).then(m=>E(m,null))}copyExtensions(l,u){return this.m.call("copyExtensions",[l,u])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(l,u,m){const d=await this.m.call("download",[l,u,m]);return j.URI.revive(d)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$dq=c;class p{constructor(l){this.a=l}listen(l,u){throw new Error("Invalid listen")}call(l,u,m){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive(m[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$eq=p}),define(ae[96],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j4b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$i4b=L;var N;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function L(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}var j;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$j4b=(0,A.$vi)("IExtensionRecommendationNotificationService")}),define(ae[12],ce([0,1,51,14,27,13,8,164,4,5,23,53]),function(ne,e,A,N,L,j,O,R,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$ul=e.FileKind=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.FileOperationResult=e.$ml=e.$ll=e.$kl=e.$il=e.FileChangeType=e.$hl=e.FileOperation=e.$bl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$2k=void 0,e.$3k=w,e.$4k=g,e.$5k=u,e.$6k=m,e.$7k=d,e.$8k=$,e.$9k=t,e.$0k=r,e.$$k=n,e.$_k=s,e.$al=i,e.$cl=b,e.$dl=S,e.$el=v,e.$fl=k,e.$gl=P,e.$jl=X,e.$vl=B,e.$wl=ie,e.$yl=he,e.$2k=(0,C.$vi)("fileService");function w(te){return te.create===!0}var h;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var c;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var p;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(p||(e.FileChangeFilter=p={}));function g(te){const V=te;return!!V&&typeof V.onDidChange=="function"}var l;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(l||(e.FileSystemProviderCapabilities=l={}));function u(te){return!!(te.capabilities&2)}function m(te){return!!(te.capabilities&8)}function d(te){return!!(te.capabilities&131072)}function $(te){return!!(te.capabilities&4)}function t(te){return!!(te.capabilities&16)}function r(te){return u(te)?!!(te.capabilities&16384):!1}function n(te){return u(te)?!!(te.capabilities&32768):!1}function s(te){return!!(te.capabilities&65536)}function i(te){return!!(te.capabilities&2048)}var o;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class a extends Error{static create(V,U){const D=new a(V.toString(),U);return v(D,U),D}constructor(V,U){super(V),this.code=U}}e.$bl=a;function b(te,V){return a.create(te,V)}function S(te){return te||b((0,R.localize)(0,null),o.Unknown)}function v(te,V){return te.name=V?`${V} (FileSystemError)`:"FileSystemError",te}function k(te){if(!te)return o.Unknown;if(te instanceof a)return te.code;const V=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!V)return o.Unknown;switch(V[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}function P(te){if(te instanceof G)return te.fileOperationResult;switch(k(te)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 9;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileTooLarge:return 7;default:return 10}}var I;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class F{constructor(V,U,D){this.resource=V,this.operation=U,this.target=D}isOperation(V){return this.operation===V}}e.$hl=F;var T;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class q{static{this.a=null}constructor(V,U){this.c=U,this.b=void 0,this.d=new y.$V(()=>{const D=A.$Bi.forUris(()=>this.c);return D.fill(this.rawAdded.map(M=>[M,!0])),D}),this.f=new y.$V(()=>{const D=A.$Bi.forUris(()=>this.c);return D.fill(this.rawUpdated.map(M=>[M,!0])),D}),this.g=new y.$V(()=>{const D=A.$Bi.forUris(()=>this.c);return D.fill(this.rawDeleted.map(M=>[M,!0])),D}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const D of V){switch(D.type){case 1:this.rawAdded.push(D.resource);break;case 0:this.rawUpdated.push(D.resource);break;case 2:this.rawDeleted.push(D.resource);break}this.b!==q.a&&(typeof D.cId=="number"?this.b===void 0?this.b=D.cId:this.b!==D.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(V,...U){return this.h(V,{includeChildren:!1},...U)}affects(V,...U){return this.h(V,{includeChildren:!0},...U)}h(V,U,...D){if(!V)return!1;const M=D.length>0;return!!((!M||D.includes(1))&&(this.d.value.get(V)||U.includeChildren&&this.d.value.findSuperstr(V))||(!M||D.includes(0))&&(this.f.value.get(V)||U.includeChildren&&this.f.value.findSuperstr(V))||(!M||D.includes(2))&&(this.g.value.findSubstr(V)||U.includeChildren&&this.g.value.findSuperstr(V)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(V){return this.b===V}hasCorrelation(){return typeof this.b=="number"}}e.$il=q;function X(te,V,U){return!te||!V||te===V||V.length>te.length?!1:(V.charAt(V.length-1)!==N.sep&&(V+=N.sep),U?(0,L.$yf)(te,V):te.indexOf(V)===0)}class G extends Error{constructor(V,U,D){super(V),this.fileOperationResult=U,this.options=D}}e.$kl=G;class Q extends G{constructor(V,U,D,M){super(V,U,M),this.fileOperationResult=U,this.size=D}}e.$ll=Q;class W extends G{constructor(V,U,D){super(V,2,D),this.stat=U}}e.$ml=W;var J;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$nl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ol={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$pl="files.associations",e.$ql="files.exclude",e.$rl="files.readonlyInclude",e.$sl="files.readonlyExclude",e.$tl="files.readonlyFromPermissions";var H;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$ul="";function B(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function ie(te,V){if(!V.hasProvider(O.URI.from({scheme:te.scheme})))return new Promise(U=>{const D=V.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===te.scheme&&M.added&&(D.dispose(),U())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(V){return(0,j.$_f)(V)||(V=0),V<re.KB?(0,R.localize)(1,null,V.toFixed(0)):V<re.MB?(0,R.localize)(2,null,(V/re.KB).toFixed(2)):V<re.GB?(0,R.localize)(3,null,(V/re.MB).toFixed(2)):V<re.TB?(0,R.localize)(4,null,(V/re.GB).toFixed(2)):(0,R.localize)(5,null,(V/re.TB).toFixed(2))}}e.$xl=re;function he(te){const V=typeof te=="string"||te?.scheme===E.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===E.Schemas.file?1024*re.MB:V?10*re.MB:f.$o?50*re.MB:1024*re.MB}});var Z=this&&this.__param||function(ne,e){return function(A,N){e(A,N,ne)}};define(ae[195],ce([0,1,73,50,12]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;let j=class{constructor(R){this.a=R}async checksum(R){const C=(await this.a.readFileStream(R)).value;return new Promise((f,E)=>{const y=(0,A.createHash)("sha256");(0,N.$xe)(C,{onData:w=>y.update(w.buffer),onError:w=>E(w),onEnd:()=>f(y.digest("base64").replace(/=+$/,""))})})}};e.$8dc=j,e.$8dc=j=Ee([Z(0,L.$2k)],j)}),define(ae[97],ce([0,1,15,7,165,12]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=O;async function O(E,y,w,h,c,p){let g;try{await R(E,y,w,h,c,p)}catch(l){g=l}finally{g&&c.errorTransformer&&(g=c.errorTransformer(g)),typeof g<"u"&&w.error(g),w.end()}}async function R(E,y,w,h,c,p){C(p);const g=await E.open(y,{create:!1});try{C(p);let l=0,u=0,m=c&&typeof c.length=="number"?c.length:void 0,d=A.$Fe.alloc(Math.min(c.bufferSize,typeof m=="number"?m:c.bufferSize)),$=c&&typeof c.position=="number"?c.position:0,t=0;do u=await E.read(g,$,d.buffer,t,d.byteLength-t),$+=u,t+=u,l+=u,typeof m=="number"&&(m-=u),t===d.byteLength&&(await w.write(h(d)),d=A.$Fe.alloc(Math.min(c.bufferSize,typeof m=="number"?m:c.bufferSize)),t=0);while(u>0&&(typeof m!="number"||m>0)&&C(p)&&f(l,c));if(t>0){let r=t;typeof m=="number"&&(r=Math.min(t,m)),w.write(h(d.slice(0,r)))}}catch(l){throw(0,j.$dl)(l)}finally{await E.close(g)}}function C(E){if(E.isCancellationRequested)throw(0,N.$6)();return!0}function f(E,y){if(typeof y?.limits?.size=="number"&&E>y.limits.size)throw(0,j.$cl)((0,L.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[46],ce([0,1,90,2,14,5,8,12]),function(ne,e,A,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=e.$Kq=void 0,e.$Iq=C,e.$Jq=f,e.$Nq=h,e.$Oq=c,e.$Pq=p,e.$Qq=g,e.$Rq=u,e.$Sq=m;function C(d){return typeof d.correlationId=="number"}function f(d){return d.recursive===!0}class E extends N.$Vc{static{this.a=5}constructor($,t,r,n){super(),this.h=$,this.j=t,this.m=r,this.n=n,this.c=this.B(new N.$Wc),this.f=void 0,this.g=0}s(){const $=new N.$Uc;this.c.value=$,this.b=this.r($),this.b.setVerboseLogging(this.m),$.add(this.b.onDidChangeFile(t=>this.h(t))),$.add(this.b.onDidLogMessage(t=>this.j(t))),$.add(this.b.onDidError(t=>this.t(t)))}t($){this.n.restartOnError?this.g<E.a&&this.f?(this.w(`restarting watcher after error: ${$}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${$}`):this.w($)}u($){this.g++,this.s(),this.watch($)}async watch($){this.f=$,await this.b?.watch($)}async setVerboseLogging($){this.m=$,await this.b?.setVerboseLogging($)}w($){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${$}`})}y($){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${$}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Kq=E;class y extends E{constructor($,t,r){super($,t,r,{type:"node.js",restartOnError:!1})}}e.$Lq=y;class w extends E{constructor($,t,r){super($,t,r,{type:"universal",restartOnError:!0})}}e.$Mq=w;function h(d){return d.map($=>({type:$.type,resource:O.URI.revive($.resource),cId:$.cId}))}function c(d){const $=new l;for(const t of d)$.processEvent(t);return $.coalesce()}function p(d,$){return typeof $=="string"&&!$.startsWith(A.$lk)&&!(0,L.$jc)($)?{base:d,pattern:$}:$}function g(d,$){const t=[];for(const r of $)t.push((0,A.$pk)(p(d,r)));return t}class l{constructor(){this.a=new Set,this.b=new Map}c($){return j.$k?$.resource.fsPath:$.resource.fsPath.toLowerCase()}processEvent($){const t=this.b.get(this.c($));let r=!1;if(t){const n=t.type,s=$.type;t.resource.fsPath!==$.resource.fsPath&&($.type===2||$.type===1)?r=!0:n===1&&s===2?(this.b.delete(this.c($)),this.a.delete(t)):n===2&&s===1?t.type=0:n===1&&s===0||(t.type=s)}else r=!0;r&&(this.a.add($),this.b.set(this.c($),$))}coalesce(){const $=[],t=[];return Array.from(this.a).filter(r=>r.type!==2?($.push(r),!1):!0).sort((r,n)=>r.resource.fsPath.length-n.resource.fsPath.length).filter(r=>t.some(n=>(0,R.$jl)(r.resource.fsPath,n,!j.$k))?!1:(t.push(r.resource.fsPath),!0)).concat($)}}function u(d,$){if(typeof $=="number")switch(d.type){case 1:return($&4)===0;case 2:return($&8)===0;case 0:return($&2)===0}return!1}function m(d){if(typeof d=="number"){const $=[];return d&4&&$.push("Added"),d&8&&$.push("Deleted"),d&2&&$.push("Updated"),$.length===0?"<all>":`[${$.join(", ")}]`}return"<none>"}}),define(ae[196],ce([0,1,15,38,7,3,2,50,32,12,46]),function(ne,e,A,N,L,j,O,R,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vQ=e.$uQ=void 0,e.$uQ="localFilesystem";class y extends O.$Vc{constructor(h,c){super(),this.a=h,this.b=c,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$ee),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$ee),this.onDidWatchError=this.g.event,this.h=(0,C.$Rg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,c){const{buffer:p}=await this.a.call("readFile",[h,c]);return p}readFileStream(h,c,p){const g=(0,R.$te)(u=>A.$Fe.concat(u.map(m=>A.$Fe.wrap(m))).buffer),l=new O.$Uc;return l.add(this.a.listen("readFileStream",[h,c])(u=>{if(u instanceof A.$Fe)g.write(u.buffer);else{if(u==="end")g.end();else{let m;if(u instanceof Error)m=u;else{const d=u;m=(0,f.$cl)(d.message??(0,N.$gj)(d),d.code??f.FileSystemProviderErrorCode.Unknown)}g.error(m),g.end()}l.dispose()}})),l.add(p.onCancellationRequested(()=>{g.error((0,L.$6)()),g.end(),l.dispose()})),g}writeFile(h,c,p){return this.a.call("writeFile",[h,A.$Fe.wrap(c),p])}open(h,c){return this.a.call("open",[h,c])}close(h){return this.a.call("close",[h])}async read(h,c,p,g,l){const[u,m]=await this.a.call("read",[h,c,l]);return p.set(u.buffer.slice(0,m),g),m}write(h,c,p,g,l){return this.a.call("write",[h,c,A.$Fe.wrap(p),g,l])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,c){return this.a.call("delete",[h,c])}rename(h,c,p){return this.a.call("rename",[h,c,p])}copy(h,c,p){return this.a.call("copy",[h,c,p])}cloneFile(h,c){return this.a.call("cloneFile",[h,c])}j(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const c=h;this.f.fire((0,E.$Nq)(c))}else{const c=h;this.g.fire(c)}}))}watch(h,c){const p=(0,C.$Rg)();return this.a.call("watch",[this.h,p,h,c]),(0,O.$Tc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$vQ=y}),define(ae[197],ce([0,1,41,2,46,3,8,6]),function(ne,e,A,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class C extends N.$Vc{constructor(){super(),this.a=this.B(new j.$ee),this.onDidChangeFile=this.a.event,this.b=this.B(new j.$ee),this.onDidLogMessage=this.b.event,this.c=this.B(new j.$ee),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$5c),this.m=new Set,this.n=5007,this.r=new R.$Sh,this.P=!1,this.B(this.f(E=>this.s(E)))}s(E){this.t(E)&&this.w(E)}t(E){return(0,L.$Iq)(E)}async watch(E){this.r.isSettled||this.r.complete(),this.r=new R.$Sh;try{this.h.clear(),this.g.clear();for(const y of E)this.t(y)?this.h.set(y.correlationId,y):this.g.add(y);for(const[y]of this.j)this.h.has(y)||(this.j.deleteAndDispose(y),this.m.delete(y));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(E=>!this.j.has(E.correlationId))])}isSuspended(E){return typeof E.correlationId!="number"?!1:this.m.has(E.correlationId)?"polling":this.j.has(E.correlationId)}async w(E){if(this.j.has(E.correlationId))return;const y=new N.$Uc;this.j.set(E.correlationId,y),await this.r.p,!y.isDisposed&&(this.z(E,y),this.u())}y(E){this.j.deleteAndDispose(E.correlationId),this.m.delete(E.correlationId),this.u()}z(E,y){this.C(E,y)?(this.N(`reusing an existing recursive watcher to monitor ${E.path}`),this.m.delete(E.correlationId)):(this.D(E,y),this.m.add(E.correlationId))}C(E,y){const w=this.M?.subscribe(E.path,(h,c)=>{y.isDisposed||(h?this.z(E,y):c?.type===1&&this.F(E))});return w?(y.add(w),!0):!1}D(E,y){let w=!1;const h=(c,p)=>{if(y.isDisposed)return;const g=this.G(c),l=this.G(p),u=w;w=g,!g&&(l||u)&&this.F(E)};this.N(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,A.watchFile)(E.path,{persistent:!1,interval:this.n},h)}catch(c){this.O(`fs.watchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}y.add((0,N.$Tc)(()=>{this.N(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,A.unwatchFile)(E.path,h)}catch(c){this.O(`fs.unwatchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}F(E){this.N(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const y={resource:O.URI.file(E.path),type:1,cId:E.correlationId};this.a.fire([y]),this.H(y,E),this.y(E)}G(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(E,y){if(this.P){const w=` >> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.I(w,y)}}I(E,y){this.P&&this.N(`${E}${typeof y.correlationId=="number"?` <${y.correlationId}> `:""}`)}J(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,L.$Sq)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}async setVerboseLogging(E){this.P=E}}e.$2q=C}),define(ae[198],ce([0,1,41,6,26,40,2,87,14,5,20,8,148,31,46]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0,e.$8q=g;class p extends O.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(u,m,d,$,t,r){super(),this.s=u,this.t=m,this.u=d,this.w=$,this.y=t,this.z=r,this.c=this.B(new N.$Kh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.u(n))),this.f=this.B(new N.$Jh(n=>this.M(n),p.b)),this.g=(0,c.$Qq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,c.$Qq)(this.s.path,this.s.includes):void 0,this.j=(0,c.$Iq)(this.s)?this.s.filter:void 0,this.m=new L.$pe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const u=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const m=await h.Promises.stat(u);if(this.m.token.isCancellationRequested)return;this.B(await this.G(u,m.isDirectory()))}catch(u){u.code!=="ENOENT"?this.O(u):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${u})`),this.D()}}D(){this.r=!0,this.w?.()}async F(u){let m=u.path;try{m=await h.Promises.realpath(u.path),u.path===m&&(m=await(0,w.$4q)(u.path,this.m.token)??u.path),u.path!==m&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${m})`)}catch{}return m}async G(u,m){const d=new O.$Uc;return this.H(u,m,d)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(u,m,d)),d}H(u,m,d){if(m)return!1;const $=y.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(r,n)=>{if(!d.isDisposed)if(r){const s=await this.G(u,m);d.isDisposed?s.dispose():d.add(s)}else n&&(typeof n.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:$,type:n.type,cId:this.s.correlationId},!0)});return t?(d.add(t),!0):!1}async I(u,m,d){if(f.$j&&(0,j.$ug)(u,"/Volumes/",!0)){this.O(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const $=new L.$pe(this.m.token);d.add((0,O.$Tc)(()=>$.dispose(!0)));const t=new O.$Uc;d.add(t);try{const r=y.URI.file(this.s.path),n=(0,C.$oc)(u),s=(0,A.watch)(u);t.add((0,O.$Tc)(()=>{s.removeAllListeners(),s.close()})),this.Q(`Started watching: '${u}'`);const i=new Set;if(m)try{for(const a of await h.Promises.readdir(u))i.add(a)}catch(a){this.O(a)}if($.token.isCancellationRequested)return;const o=new Map;t.add((0,O.$Tc)(()=>{for(const[,a]of o)a.dispose();o.clear()})),s.on("error",(a,b)=>{$.token.isCancellationRequested||(this.O(`Failed to watch ${u} for changes using fs.watch() (${a}, ${b})`),this.D())}),s.on("change",(a,b)=>{if($.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${a}"] ${b}`);let S="";if(b&&(S=b.toString(),f.$j&&(S=(0,R.$am)(S))),!(!S||a!=="change"&&a!=="rename"))if(m)if(a==="rename"){o.get(S)?.dispose();const v=setTimeout(async()=>{if(o.delete(S),S===n&&!await h.Promises.exists(u)){this.J(r);return}if($.token.isCancellationRequested)return;const k=await this.N((0,C.$kc)(u,S));if($.token.isCancellationRequested)return;let P;k?i.has(S)?P=0:(P=1,i.add(S)):(i.delete(S),P=2),this.L({resource:(0,E.$9g)(r,S),type:P,cId:this.s.correlationId})},p.a);o.set(S,(0,O.$Tc)(()=>clearTimeout(v)))}else{let v;i.has(S)?v=0:(v=1,i.add(S)),this.L({resource:(0,E.$9g)(r,S),type:v,cId:this.s.correlationId})}else if(a==="rename"||S!==n){const v=setTimeout(async()=>{const k=await h.Promises.exists(u);$.token.isCancellationRequested||(k?(this.L({resource:r,type:0,cId:this.s.correlationId},!0),t.add(await this.G(u,!1))):this.J(r))},p.a);t.clear(),t.add((0,O.$Tc)(()=>clearTimeout(v)))}else this.L({resource:r,type:0,cId:this.s.correlationId},!0)})}catch(r){$.token.isCancellationRequested||this.O(`Failed to watch ${u} for changes using fs.watch() (${r.toString()})`),this.D()}}J(u){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:u,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(u,m=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!m&&this.g.some(d=>d(u.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${u.resource.fsPath}`):!m&&this.h&&this.h.length>0&&!this.h.some(d=>d(u.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}M(u){const m=(0,c.$Oq)(u),d=[];for(const t of m){if((0,c.$Rq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}d.push(t)}if(d.length===0)return;if(this.z)for(const t of d)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(d)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(u){if(f.$k)return h.Promises.exists(u);try{const m=(0,C.$oc)(u);return(await h.Promises.readdir((0,C.$nc)(u))).some($=>$===m)}catch(m){return this.Q(m),!1}}setVerboseLogging(u){this.z=u}O(u){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}P(u){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}Q(u){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}R(u){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${u}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$7q=p;async function g(l,u,m,d,$=512){const t=await h.Promises.open(l,"r"),r=Buffer.allocUnsafe($),n=new L.$pe(d);let s,i=!1;const o={path:l,excludes:[],recursive:!1},a=new p(o,void 0,b=>{(async()=>{for(const{type:S}of b)if(S===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:v}=await h.Promises.read(t,r,0,$,null);if(!v||n.token.isCancellationRequested)break;u(r.slice(0,v))}}catch(v){s=new Error(v),n.dispose(!0)}finally{i=!1}}})()});return await a.ready,m(),new Promise((b,S)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await h.Promises.close(t)}catch(v){s=new Error(v)}s?S(s):b()})})}}),define(ae[199],ce([0,1,3,90,197,5,198,40]),function(ne,e,A,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;class C extends L.$2q{constructor(E){super(),this.M=E,this.onDidError=A.Event.None,this.watchers=new Set}async L(E){E=this.X(E);const y=[],w=new Set(Array.from(this.watchers));for(const h of E){const c=this.S(h);c&&(0,N.$tk)(c.request.excludes,h.excludes)&&(0,N.$tk)(c.request.includes,h.includes)?w.delete(c):y.push(h)}y.length&&this.N(`Request to start watching: ${y.map(h=>this.J(h)).join(",")}`),w.size&&this.N(`Request to stop watching: ${Array.from(w).map(h=>this.J(h.request)).join(",")}`);for(const h of w)this.W(h);for(const h of y)this.U(h)}S(E){for(const y of this.watchers)if(typeof E.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===E.correlationId)return y}else if((0,R.$tg)(y.request.path,E.path,!j.$k))return y}U(E){const y=new O.$7q(E,this.M,h=>this.a.fire(h),()=>this.c.fire(E),h=>this.b.fire(h),this.P),w={request:E,instance:y};this.watchers.add(w)}async stop(){await super.stop();for(const E of this.watchers)this.W(E)}W(E){this.N("stopping file watcher",E),this.watchers.delete(E),E.instance.dispose()}X(E){const y=new Map;for(const w of E){const h=j.$k?w.path:w.path.toLowerCase();let c=y.get(w.correlationId);c||(c=new Map,y.set(w.correlationId,c)),c.has(h)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(w)}`),c.set(h,w)}return Array.from(y.values()).map(w=>Array.from(w.values())).flat()}async setVerboseLogging(E){super.setVerboseLogging(E);for(const y of this.watchers)y.instance.setVerboseLogging(E)}N(E,y){this.P&&this.b.fire({type:"trace",message:this.$(E,y)})}O(E){this.b.fire({type:"warn",message:this.$(E)})}$(E,y){return y?`[File Watcher (node.js)] ${E} (${this.J(y.request)})`:`[File Watcher (node.js)] ${E}`}}e.$9q=C}),define(ae[200],ce([0,1,46,199]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class L extends A.$Lq{constructor(O,R,C){super(O,R,C),this.s()}r(O){return O.add(new N.$9q(void 0))}}e.$0q=L}),define(ae[201],ce([0,1,23,42,92,46]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;class O extends j.$Mq{constructor(C,f,E){super(C,f,E),this.s()}r(C){const f=C.add(new L.$Zq(A.$Pg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(f.onDidProcessExit(({code:E,signal:y})=>this.t(`terminated by itself with code ${E}, signal: ${y} (ETERM)`))),N.ProxyChannel.toService((0,N.$ci)(f.getChannel("watcher")))}}e.$1q=O}),define(ae[74],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class A{constructor(...L){this.a=new Map;for(const[j,O]of L)this.set(j,O)}set(L,j){const O=this.a.get(L);return this.a.set(L,j),O}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$ti=A}),define(ae[202],ce([0,1,6,7,2,72,192,4,74,86]),function(ne,e,A,N,L,j,O,R,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=void 0;const E=!1;class y extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class w{constructor(g=new C.$ti,l=!1,u,m=E){this.i=g,this.j=l,this.k=u,this.l=m,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(R.$ui,this),this._globalGraph=m?u?._globalGraph??new O.$ar(d=>d):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Qc)(this.h),this.h.clear();for(const g of this.g)(0,L.$Pc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g){this.m();const l=new class extends w{dispose(){this.h.delete(l),super.dispose()}}(g,this.j,this,this.l);return this.h.add(l),l}invokeFunction(g,...l){this.m();const u=c.traceInvocation(this.l,g);let m=!1;try{return g({get:$=>{if(m)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s($,u);if(!t)throw new Error(`[invokeFunction] unknown service '${$}'`);return t}},...l)}finally{m=!0,u.stop()}}createInstance(g,...l){this.m();let u,m;return g instanceof j.$si?(u=c.traceCreation(this.l,g.ctor),m=this.o(g.ctor,g.staticArguments.concat(l),u)):(u=c.traceCreation(this.l,g),m=this.o(g,l,u)),u.stop(),m}o(g,l=[],u){const m=R._util.getServiceDependencies(g).sort((t,r)=>t.index-r.index),d=[];for(const t of m){const r=this.s(t.id,u);r||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),d.push(r)}const $=m.length>0?m[0].index:l.length;if(l.length!==$){console.trace(`[createInstance] First service dependency of ${g.name} at position ${$+1} conflicts with ${l.length} static arguments`);const t=$-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,$)}return Reflect.construct(g,l.concat(d))}q(g,l){if(this.i.get(g)instanceof j.$si)this.i.set(g,l);else if(this.k)this.k.q(g,l);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const l=this.i.get(g);return!l&&this.k?this.k.r(g):l}s(g,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const u=this.r(g);return u instanceof j.$si?this.u(g,u,l.branch(g,!0)):(l.branch(g,!1),u)}u(g,l,u){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,l,u)}finally{this.t.delete(g)}}v(g,l,u){const m=new O.$ar(t=>t.id.toString());let d=0;const $=[{id:g,desc:l,_trace:u}];for(;$.length;){const t=$.pop();if(m.lookupOrInsertNode(t),d++>1e3)throw new y(m);for(const r of R._util.getServiceDependencies(t.desc.ctor)){const n=this.r(r.id);if(n||this.y(`[createInstance] ${g} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),n instanceof j.$si){const s={id:r.id,desc:n,_trace:t._trace.branch(r.id,!0)};m.insertEdge(t,s),$.push(s)}}}for(;;){const t=m.roots();if(t.length===0){if(!m.isEmpty())throw new y(m);break}for(const{data:r}of t){if(this.r(r.id)instanceof j.$si){const s=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,s)}m.removeNode(r)}}return this.r(g)}w(g,l,u=[],m,d){if(this.i.get(g)instanceof j.$si)return this.x(g,l,u,m,d,this.g);if(this.k)return this.k.w(g,l,u,m,d);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}x(g,l,u=[],m,d,$){if(m){const t=new w(void 0,this.j,this,this.l);t.c=String(g);const r=new Map,n=new A.$Oh(()=>{const s=t.o(l,u,d);for(const[i,o]of r){const a=s[i];if(typeof a=="function")for(const b of o)b.disposable=a.apply(s,b.listener)}return r.clear(),$.add(s),s});return new Proxy(Object.create(null),{get(s,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let b=r.get(i);return b||(b=new f.$6c,r.set(i,b)),(v,k,P)=>{if(n.isInitialized)return n.value[i](v,k,P);{const I={listener:[v,k,P],disposable:void 0},F=b.push(I);return(0,L.$Tc)(()=>{F(),I.disposable?.dispose()})}}}if(i in s)return s[i];const o=n.value;let a=o[i];return typeof a!="function"||(a=a.bind(o),s[i]=a),a},set(s,i,o){return n.value[i]=o,!0},getPrototypeOf(s){return l.prototype}})}else{const t=this.o(l,u,d);return $.add(t),t}}y(g,l){if(l&&console.warn(g),this.j)throw new Error(g)}}e.$br=w;var h;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(h||(h={}));class c{static{this.all=new Set}static{this.c=new class extends c{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,l){return g?new c(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):c.c}static traceCreation(g,l){return g?new c(1,l.name):c.c}static{this.f=0}constructor(g,l){this.type=g,this.name=l,this.g=Date.now(),this.h=[]}branch(g,l){const u=new c(3,g.toString());return this.h.push([g,l,u]),u}stop(){const g=Date.now()-this.g;c.f+=g;let l=!1;function u(d,$){const t=[],r=new Array(d+1).join("	");for(const[n,s,i]of $.h)if(s&&i){l=!0,t.push(`${r}CREATES -> ${n}`);const o=u(d+1,i);o&&t.push(o)}else t.push(`${r}uses -> ${n}`);return t.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${c.f.toFixed(2)}ms)`];(g>2||l)&&c.all.add(m.join(`
`))}}e.$cr=c}),define(ae[56],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=e.$Cdc=void 0,e.$Cdc=(0,A.$vi)("mainProcessService");class N{constructor(j,O){this.a=j,this.b=O}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,O){this.a.registerChannel(j,O)}}e.$Ddc=N}),define(ae[75],ce([0,1,26,2,5,167,29,4]),function(ne,e,A,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=void 0,e.$Pr=C;function C(E){return E.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.$Qr=(0,R.$vi)("languagePackService");let f=class extends N.$Vc{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new A.$pe;setTimeout(()=>y.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const c=w.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(g=>g.startsWith("lp-"))).map(p=>{const g=p.properties.localizedLanguages?.[0],l=C(p);return{...this.f(l,g,p),extensionId:p.identifier.id,galleryExtension:p}});return c.push(this.f("en","English")),c}f(y,w,h){const c=w??y;let p;if(c!==y&&(p=`(${y})`),y.toLowerCase()===L.$w.toLowerCase()&&(p??="",p+=(0,j.localize)(0,null)),h?.installCount){p??="";const g=h.installCount;let l;g>1e6?l=`${Math.floor(g/1e5)/10}M`:g>1e3?l=`${Math.floor(g/1e3)}K`:l=String(g),p+=` $(cloud-download) ${l}`}return{id:y,label:c,description:p}}};e.$Rr=f,e.$Rr=f=Ee([Z(0,O.$5o)],f)}),define(ae[203],ce([0,1,2,75]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=void 0;let L=class extends A.$Vc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$4dc=L,e.$4dc=L=Ee([Z(0,N.$Qr)],L)}),define(ae[9],ce([0,1,168,38,3,54,2,34,5,20,13,8,93,4]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$5j=e.LogLevel=e.$3j=e.$2j=void 0,e.$4j=p,e.log=l,e.$dk=a,e.$ek=b,e.$fk=S,e.$gk=v,e.$2j=(0,h.$vi)("logService"),e.$3j=(0,h.$vi)("loggerService");function c(){return new Date().toISOString()}function p(k){return(0,E.$_f)(k)}var g;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$5j=g.Info;function l(k,P,I){switch(P){case g.Trace:k.trace(I);break;case g.Debug:k.debug(I);break;case g.Info:k.info(I);break;case g.Warning:k.warn(I);break;case g.Error:k.error(I);break;case g.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function u(k,P=!1){let I="";for(let F=0;F<k.length;F++){let T=k[F];if(T instanceof Error&&(T=(0,N.$gj)(T,P)),typeof T=="object")try{T=JSON.stringify(T)}catch{}I+=(F>0?" ":"")+T}return I}class m extends O.$Vc{constructor(){super(...arguments),this.b=e.$5j,this.c=this.B(new L.$ee),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==g.Off&&this.b<=P}}e.$7j=m;class d extends m{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...I){this.f(g.Trace)&&this.g(g.Trace,u([P,...I],!0))}debug(P,...I){this.f(g.Debug)&&this.g(g.Debug,u([P,...I]))}info(P,...I){this.f(g.Info)&&this.g(g.Info,u([P,...I]))}warn(P,...I){this.f(g.Warning)&&this.g(g.Warning,u([P,...I]))}error(P,...I){if(this.f(g.Error))if(P instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=P.stack,this.g(g.Error,u(F))}else this.g(g.Error,u([P,...I]))}flush(){}}e.$8j=d;class $ extends m{constructor(P=e.$5j){super(),this.setLevel(P),this.g=!C.$i}trace(P,...I){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,P,...I):console.log(`[main ${c()}]`,P,...I))}debug(P,...I){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,P,...I):console.log(`[main ${c()}]`,P,...I))}info(P,...I){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,P,...I):console.log(`[main ${c()}]`,P,...I))}warn(P,...I){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,P,...I):console.warn(`[main ${c()}]`,P,...I))}error(P,...I){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,P,...I):console.error(`[main ${c()}]`,P,...I))}flush(){}}e.$9j=$;class t extends m{constructor(P=e.$5j,I=!0){super(),this.g=I,this.setLevel(P)}trace(P,...I){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...I):console.log(P,...I))}debug(P,...I){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...I):console.log(P,...I))}info(P,...I){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...I):console.log(P,...I))}warn(P,...I){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...I):console.log(P,...I))}error(P,...I){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...I):console.error(P,...I))}flush(){}}e.$0j=t;class r extends m{constructor(P,I=e.$5j){super(),this.g=P,this.setLevel(I)}trace(P,...I){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(P),...I])}debug(P,...I){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(P),...I])}info(P,...I){this.f(g.Info)&&this.g.log(g.Info,[this.h(P),...I])}warn(P,...I){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(P),...I])}error(P,...I){this.f(g.Error)&&this.g.log(g.Error,[this.h(P),...I])}h(P){return typeof P=="string"?P:(0,N.$gj)(P,this.f(g.Trace))}flush(){}}e.$$j=r;class n extends m{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const I of this.g)I.setLevel(P);super.setLevel(P)}trace(P,...I){for(const F of this.g)F.trace(P,...I)}debug(P,...I){for(const F of this.g)F.debug(P,...I)}info(P,...I){for(const F of this.g)F.info(P,...I)}warn(P,...I){for(const F of this.g)F.warn(P,...I)}error(P,...I){for(const F of this.g)F.error(P,...I)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$_j=n;class s extends O.$Vc{constructor(P,I,F){if(super(),this.h=P,this.j=I,this.b=new R.$Bc,this.c=this.B(new L.$ee),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$ee),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$ee),this.onDidChangeVisibility=this.g.event,F)for(const T of F)this.b.set(T.resource,{logger:void 0,info:T})}m(P){return(0,E.$8f)(P)?[...this.b.values()].find(I=>I.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,I){const F=this.n(P),T=(0,E.$8f)(P)?P:I?.id??(0,j.$jj)(F.toString()).toString(16);let q=this.b.get(F)?.logger;const X=I?.logLevel==="always"?g.Trace:I?.logLevel;q||(q=this.s(F,X??this.getLogLevel(F)??this.h,{...I,id:T}));const G={logger:q,info:{resource:F,id:T,logLevel:X,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(G.info),this.b.set(F,G),q}n(P){return(0,E.$8f)(P)?(0,f.$9g)(this.j,`${P}.log`):P}setLogLevel(P,I){if(y.URI.isUri(P)){const F=P,T=I,q=this.b.get(F);q&&T!==q.info.logLevel&&(q.info.logLevel=T===this.h?void 0:T,q.logger?.setLevel(T),this.b.set(q.info.resource,q),this.f.fire([F,T]))}else{this.h=P;for(const[F,T]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,I){const F=this.m(P);F&&I!==!F.info.hidden&&(F.info.hidden=!I,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,I]))}getLogLevel(P){let I;return P&&(I=this.b.get(P)?.info.logLevel),I??this.h}registerLogger(P){const I=this.b.get(P.resource);I?I.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const I=this.b.get(P);I&&(I.logger&&I.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ak=s;class i{constructor(){this.onDidChangeLogLevel=new L.$ee().event}setLevel(P){}getLevel(){return g.Info}trace(P,...I){}debug(P,...I){}info(P,...I){}warn(P,...I){}error(P,...I){}critical(P,...I){}dispose(){}flush(){}}e.$bk=i;class o extends i{}e.$ck=o;function a(k){if(k.verbose)return g.Trace;if(typeof k.logLevel=="string"){const P=v(k.logLevel.toLowerCase());if(P!==void 0)return P}return e.$5j}function b(k){switch(k){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function S(k){switch(k){case g.Trace:return{original:"Trace",value:A.localize(0,null)};case g.Debug:return{original:"Debug",value:A.localize(1,null)};case g.Info:return{original:"Info",value:A.localize(2,null)};case g.Warning:return{original:"Warning",value:A.localize(3,null)};case g.Error:return{original:"Error",value:A.localize(4,null)};case g.Off:return{original:"Off",value:A.localize(5,null)}}}function v(k){switch(k){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$hk=new w.$Mj("logLevel",b(g.Info))}),define(ae[204],ce([0,1,6,7,2,23,14,20,31,16,9]),function(ne,e,A,N,L,j,O,R,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=void 0;let y=class extends L.$Vc{constructor(h,c){super(),this.a=h,this.b=c,this.B(new A.$Hh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const h=(0,R.$6g)(this.a.logsHome),c=(0,R.$8g)(this.a.logsHome.with({scheme:j.Schemas.file})).fsPath,l=(await C.Promises.readdir(c)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==h),u=l.slice(0,Math.max(0,l.length-9));u.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${u.join(", ")}'`),await Promise.all(u.map(m=>C.Promises.rm((0,O.$kc)(c,m)))))}catch(h){(0,N.$1)(h)}}};e.$5dc=y,e.$5dc=y=Ee([Z(0,f.$Ci),Z(1,E.$2j)],y)}),define(ae[205],ce([0,1,17,6,7,3,40,2,14,46,9]),function(ne,e,A,N,L,j,O,R,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class y extends R.$Vc{constructor(h,c){super(),this.a=h,this.b=c,this.c=this.B(new j.$ee),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$ee),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$th(0)),this.w=[],this.y=this.B(new N.$th(0))}watch(h,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n(h,c):this.z(h,c)}n(h,c){const p={path:this.J(h),excludes:c.excludes,includes:c.includes,recursive:c.recursive,filter:c.filter,correlationId:c.correlationId},g=(0,A.$Ub)(this.j,p);return this.r(),(0,R.$Tc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(h=>(0,L.$1)(h))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,f.$Nq)(c)),c=>this.G(c),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const h=this.b?.watcher?.recursive?.usePolling;if(h===!0)for(const c of this.j)(0,f.$Jq)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const c of this.j)(0,f.$Jq)(c)&&h.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(h,c){const p={path:this.J(h),excludes:c.excludes,includes:c.includes,recursive:!1,filter:c.filter,correlationId:c.correlationId},g=(0,A.$Ub)(this.w,p);return this.C(),(0,R.$Tc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(h=>(0,L.$1)(h))}D(){return this.u||(this.u=this.B(this.F(h=>this.c.fire((0,f.$Nq)(h)),h=>this.G(h),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.u.watch(this.w)}G(h){h.type==="error"&&this.g.fire(h.message),this.H(h)}H(h){this.a[h.type](h.message)}I(h){return(0,C.$ic)(h.fsPath)}J(h){const c=this.I(h);return(0,O.$xg)(c)}}e.$Tq=y}),define(ae[206],ce([0,1,17,6,15,26,3,54,61,2,51,23,98,20,50,163,12,97,9,7]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u,m){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=void 0;let $=class extends f.$Vc{static{d=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new O.$ee),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$ee),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$ee),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$ee),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$ee),this.Y=this.B(new O.$ee),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$ee),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$Eh)}registerProvider(r,n){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${r}`);const s=new f.$Uc;return this.h.set(r,n),this.c.fire({added:!0,scheme:r,provider:n}),s.add(n.onDidChangeFile(i=>{const o=new g.$il(i,!this.S(n));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(i=>this.Z.fire(new Error(i)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:r}))),(0,f.$Tc)(()=>{this.c.fire({added:!1,scheme:r,provider:n}),this.h.delete(r),(0,f.$Qc)(s)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const n=[];this.f.fire({scheme:r,join(s){n.push(s)}}),!this.h.has(r)&&await N.Promises.settled(n)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,n){const s=this.h.get(r.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return C.Iterable.map(this.h,([r,n])=>({scheme:r,capabilities:n.capabilities}))}async j(r){if(!(0,h.$ah)(r))throw new g.$kl((0,p.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const n=this.h.get(r.scheme);if(!n){const s=new m.$bb;throw s.message=(0,p.localize)(1,null,r.toString()),s}return n}async m(r){const n=await this.j(r);if((0,g.$8k)(n)||(0,g.$5k)(n)||(0,g.$9k)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const n=await this.j(r);if((0,g.$8k)(n)||(0,g.$5k)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,n){try{return await this.s(r,n)}catch(s){throw(0,g.$fl)(s)===g.FileSystemProviderErrorCode.FileNotFound?new g.$kl((0,p.localize)(2,null,this.sb(r)),1):(0,g.$dl)(s)}}async s(r,n){const s=await this.j(r),i=this.S(s),o=n?.resolveTo,a=n?.resolveSingleChildDescendants,b=n?.resolveMetadata,S=await s.stat(r);let v;return this.t(s,r,S,void 0,!!b,(k,P)=>(v||(v=E.$Bi.forUris(()=>!i),v.set(r,!0),o&&v.fill(!0,o)),v.get(k.resource)||v.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&a?P===1:!1))}async t(r,n,s,i,o,a){const{providerExtUri:b}=this.R(r),S={resource:n,name:b.basename(n),isFile:(s.type&g.FileType.File)!==0,isDirectory:(s.type&g.FileType.Directory)!==0,isSymbolicLink:(s.type&g.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&g.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((s.permissions??0)&g.FilePermission.Locked),etag:(0,g.$vl)({mtime:s.mtime,size:s.size}),children:void 0};if(S.isDirectory&&a(S,i)){try{const v=await r.readdir(n),k=await N.Promises.settled(v.map(async([P,I])=>{try{const F=b.joinPath(n,P),T=o?await r.stat(F):{type:I};return await this.t(r,F,T,v.length,o,a)}catch(F){return this.b.trace(F),null}}));S.children=(0,A.$Hb)(k)}catch(v){this.b.trace(v),S.children=[]}return S}return S}async resolveAll(r){return N.Promises.settled(r.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(r){const n=await this.j(r),s=await n.stat(r);return this.t(n,r,s,void 0,!0,()=>!1)}async exists(r){const n=await this.j(r);try{return!!await n.stat(r)}catch{return!1}}async canCreateFile(r,n){try{await this.u(r,n)}catch(s){return s}return!0}async u(r,n){if(!n?.overwrite&&await this.exists(r))throw new g.$kl((0,p.localize)(3,null,this.sb(r)),3,n)}async createFile(r,n=L.$Fe.fromString(""),s){await this.u(r,s);const i=await this.writeFile(r,n);return this.r.fire(new g.$hl(r,0,i)),i}async writeFile(r,n,s){const i=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(i);let a=s;if((0,g.$$k)(i)&&!a?.atomic){const b=i.enforceAtomicWriteFile?.(r);b&&(a={...s,atomic:b})}try{await this.w(i,r,a)||await this.U(i,o.dirname(r));let S;if((0,g.$5k)(i)&&!(n instanceof L.$Fe))if((0,c.$re)(n)){const v=await(0,c.$ye)(n,3);v.ended?S=L.$Fe.concat(v.buffer):S=v}else S=(0,c.$ve)(n,v=>L.$Fe.concat(v),3);else S=n;!(0,g.$8k)(i)||(0,g.$5k)(i)&&S instanceof L.$Fe||(0,g.$5k)(i)&&(0,g.$$k)(i)&&a?.atomic?await this.hb(i,r,a,S):await this.db(i,r,a,S instanceof L.$Fe?(0,L.$Qe)(S):S),this.r.fire(new g.$hl(r,4))}catch(b){throw new g.$kl((0,p.localize)(4,null,this.sb(r),(0,g.$dl)(b).toString()),(0,g.$gl)(b),a)}return this.resolve(r,{resolveMetadata:!0})}async w(r,n,s){const i=!!s?.unlock;if(i&&!(r.capabilities&8192))throw new Error((0,p.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(r.capabilities&32768))throw new Error((0,p.localize)(6,null,this.sb(n)));if(!(r.capabilities&2))throw new Error((0,p.localize)(7,null,this.sb(n)));if(i)throw new Error((0,p.localize)(8,null,this.sb(n)))}let a;try{a=await r.stat(n)}catch{return}if(a.type&g.FileType.Directory)throw new g.$kl((0,p.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==g.$ul&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,g.$vl)({mtime:s.mtime,size:a.size}))throw new g.$kl((0,p.localize)(10,null),3,s);return a}async readFile(r,n,s){const i=await this.m(r);return n?.atomic?this.z(i,r,n,s):this.C(i,r,n,s)}async z(r,n,s,i){return new Promise((o,a)=>{this.cb.queueFor(n,async()=>{try{const b=await this.C(r,n,s,i);o(b)}catch(b){a(b)}},this.R(r).providerExtUri)})}async C(r,n,s,i){const o=await this.D(r,n,{...s,preferUnbuffered:!0},i);return{...o,value:await(0,L.$Re)(o.value)}}async readFileStream(r,n,s){const i=await this.m(r);return this.D(i,r,n,s)}async D(r,n,s,i){const o=new j.$pe(i);let a=s;(0,g.$0k)(r)&&r.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const b=this.J(n,a).then(v=>v,v=>{throw o.dispose(!0),v});let S;try{return typeof a?.etag=="string"&&a.etag!==g.$ul&&await b,a?.atomic&&(0,g.$0k)(r)||!((0,g.$8k)(r)||(0,g.$9k)(r))||(0,g.$5k)(r)&&a?.preferUnbuffered?S=this.I(r,n,a):(0,g.$9k)(r)?S=this.G(r,n,o.token,a):S=this.H(r,n,o.token,a),S.on("end",()=>o.dispose()),S.on("error",()=>o.dispose()),{...await b,value:S}}catch(v){throw S&&await(0,c.$we)(S),this.F(v,n,a)}}F(r,n,s){const i=(0,p.localize)(11,null,this.sb(n),(0,g.$dl)(r).toString());return r instanceof g.$ml?new g.$ml(i,r.stat,s):r instanceof g.$ll?new g.$ll(i,r.fileOperationResult,r.size,r.options):new g.$kl(i,(0,g.$gl)(r),s)}G(r,n,s,i=Object.create(null)){const o=r.readFileStream(n,i,s);return(0,c.$Ce)(o,{data:a=>a instanceof L.$Fe?a:L.$Fe.wrap(a),error:a=>this.F(a,n,i)},a=>L.$Fe.concat(a))}H(r,n,s,i=Object.create(null)){const o=(0,L.$Ve)();return(0,l.$Gq)(r,n,o,a=>a,{...i,bufferSize:this.a,errorTransformer:a=>this.F(a,n,i)},s),o}I(r,n,s){const i=(0,c.$te)(o=>L.$Fe.concat(o));return(async()=>{try{let o;s?.atomic&&(0,g.$0k)(r)?o=await r.readFile(n,{atomic:!0}):o=await r.readFile(n),typeof s?.position=="number"&&(o=o.slice(s.position)),typeof s?.length=="number"&&(o=o.slice(0,s.length)),this.L(n,o.byteLength,s),i.end(L.$Fe.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async J(r,n){const s=await this.resolve(r,{resolveMetadata:!0});if(s.isDirectory)throw new g.$kl((0,p.localize)(12,null,this.sb(r)),0,n);if(typeof n?.etag=="string"&&n.etag!==g.$ul&&n.etag===s.etag)throw new g.$ml((0,p.localize)(13,null),s,n);return this.L(r,s.size,n),s}L(r,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new g.$ll((0,p.localize)(14,null,this.sb(r)),7,n,s)}async canMove(r,n,s){return this.M(r,n,"move",s)}async canCopy(r,n,s){return this.M(r,n,"copy",s)}async M(r,n,s,i){if(r.toString()!==n.toString())try{const o=s==="move"?this.qb(await this.n(r),r):await this.m(r),a=this.qb(await this.n(n),n);await this.Q(o,r,a,n,s,i)}catch(o){return o}return!0}async move(r,n,s){const i=this.qb(await this.n(r),r),o=this.qb(await this.n(n),n),a=await this.N(i,r,o,n,"move",!!s),b=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new g.$hl(r,a==="move"?2:3,b)),b}async copy(r,n,s){const i=await this.m(r),o=this.qb(await this.n(n),n),a=await this.N(i,r,o,n,"copy",!!s),b=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new g.$hl(r,a==="copy"?3:2,b)),b}async N(r,n,s,i,o,a){if(n.toString()===i.toString())return o;const{exists:b,isSameResourceWithDifferentPathCase:S}=await this.Q(r,n,s,i,o,a);if(b&&!S&&a&&await this.del(i,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(i)),o==="copy"){if(r===s&&(0,g.$6k)(r))await r.copy(n,i,{overwrite:a});else{const v=await this.resolve(n);v.isDirectory?await this.P(r,v,s,i):await this.O(r,n,s,i)}return o}else return r===s?(await r.rename(n,i,{overwrite:a}),o):(await this.N(r,n,s,i,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(r,n,s,i){if((0,g.$8k)(r)&&(0,g.$8k)(s))return this.jb(r,n,s,i);if((0,g.$8k)(r)&&(0,g.$5k)(s))return this.pb(r,n,s,i);if((0,g.$5k)(r)&&(0,g.$8k)(s))return this.nb(r,n,s,i);if((0,g.$5k)(r)&&(0,g.$5k)(s))return this.lb(r,n,s,i)}async P(r,n,s,i){await s.mkdir(i),Array.isArray(n.children)&&await N.Promises.settled(n.children.map(async o=>{const a=this.R(s).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),s,a):this.O(r,o.resource,s,a)}))}async Q(r,n,s,i,o,a){let b=!1;if(r===s){const{providerExtUri:v,isPathCaseSensitive:k}=this.R(r);if(k||(b=v.isEqual(n,i)),b&&o==="copy")throw new Error((0,p.localize)(15,null,this.sb(n),this.sb(i)));if(!b&&v.isEqualOrParent(i,n))throw new Error((0,p.localize)(16,null,this.sb(n),this.sb(i)))}const S=await this.exists(i);if(S&&!b){if(!a)throw new g.$kl((0,p.localize)(17,null,this.sb(n),this.sb(i)),4);if(r===s){const{providerExtUri:v}=this.R(r);if(v.isEqualOrParent(n,i))throw new Error((0,p.localize)(18,null,this.sb(n),this.sb(i)))}}return{exists:S,isSameResourceWithDifferentPathCase:b}}R(r){const n=this.S(r);return{providerExtUri:n?h.$Yg:h.$1g,isPathCaseSensitive:n}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const n=this.qb(await this.j(r),r);await this.U(n,r);const s=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new g.$hl(r,0,s)),s}async U(r,n){const s=[],{providerExtUri:i}=this.R(r);for(;!i.isEqual(n,i.dirname(n));)try{if(!((await r.stat(n)).type&g.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(n)));break}catch(o){if((0,g.$fl)(o)!==g.FileSystemProviderErrorCode.FileNotFound)throw o;s.push(i.basename(n)),n=i.dirname(n)}for(let o=s.length-1;o>=0;o--){n=i.joinPath(n,s[o]);try{await r.mkdir(n)}catch(a){if((0,g.$fl)(a)!==g.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(r,n){try{await this.W(r,n)}catch(s){return s}return!0}async W(r,n){const s=this.qb(await this.j(r),r),i=!!n?.useTrash;if(i&&!(s.capabilities&4096))throw new Error((0,p.localize)(20,null,this.sb(r)));const o=n?.atomic;if(o&&!(s.capabilities&65536))throw new Error((0,p.localize)(21,null,this.sb(r)));if(i&&o)throw new Error((0,p.localize)(22,null,this.sb(r)));let a;try{a=await s.stat(r)}catch{}if(a)this.rb(r,a);else throw new g.$kl((0,p.localize)(23,null,this.sb(r)),1);if(!!!n?.recursive){const S=await this.resolve(r);if(S.isDirectory&&Array.isArray(S.children)&&S.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(r)))}return s}async del(r,n){const s=await this.W(r,n);let i=n;if((0,g.$_k)(s)&&!i?.atomic){const S=s.enforceAtomicDelete?.(r);S&&(i={...n,atomic:S})}const o=!!i?.useTrash,a=!!i?.recursive,b=i?.atomic??!1;await s.delete(r,{recursive:a,useTrash:o,atomic:b}),this.r.fire(new g.$hl(r,1))}async cloneFile(r,n){const s=await this.j(r),i=this.qb(await this.n(n),n);if(!(s===i&&this.R(s).providerExtUri.isEqual(r,n)))return s===i&&(0,g.$7k)(s)?s.cloneFile(r,n):(await this.U(i,this.R(i).providerExtUri.dirname(n)),s===i&&(0,g.$6k)(s)?this.cb.queueFor(r,()=>s.copy(r,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(r,()=>this.O(s,r,i,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(r,n){return this.watch(r,{...n,correlationId:d.ab++})}watch(r,n={recursive:!1,excludes:[]}){const s=new f.$Uc;let i=!1,o=()=>{i=!0};s.add((0,f.$Tc)(()=>o())),(async()=>{try{const b=await this.bb(r,n);i?(0,f.$Qc)(b):o=()=>(0,f.$Qc)(b)}catch(b){this.b.error(b)}})();const a=n.correlationId;if(typeof a=="number"){const b=s.add(new O.$ee);return s.add(this.X.event(v=>{v.correlates(a)&&b.fire(v)})),{onDidChange:b.event,dispose:()=>s.dispose()}}return s}async bb(r,n){const s=await this.j(r),i=(0,R.$jj)([this.R(s).providerExtUri.getComparisonKey(r),n]);let o=this.$.get(i);return o||(o={count:0,disposable:s.watch(r,n)},this.$.set(i,o)),o.count+=1,(0,f.$Tc)(()=>{o&&(o.count--,o.count===0&&((0,f.$Qc)(o.disposable),this.$.delete(i)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,f.$Qc)(r.disposable);this.$.clear()}async db(r,n,s,i){return this.cb.queueFor(n,async()=>{const o=await r.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,c.$re)(i)||(0,c.$se)(i)?await this.eb(r,o,i):await this.fb(r,o,i)}catch(a){throw(0,g.$dl)(a)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,n,s){let i=0,o;if((0,c.$se)(s)){if(s.buffer.length>0){const a=L.$Fe.concat(s.buffer);await this.gb(r,n,a,a.byteLength,i,0),i+=a.byteLength}if(s.ended)return;o=s.stream}else o=s;return new Promise((a,b)=>{(0,c.$xe)(o,{onData:async S=>{o.pause();try{await this.gb(r,n,S,S.byteLength,i,0)}catch(v){return b(v)}i+=S.byteLength,setTimeout(()=>o.resume())},onError:S=>b(S),onEnd:()=>a()})})}async fb(r,n,s){let i=0,o;for(;(o=s.read())!==null;)await this.gb(r,n,o,o.byteLength,i,0),i+=o.byteLength}async gb(r,n,s,i,o,a){let b=0;for(;b<i;){const S=await r.write(n,o+b,s.buffer,a+b,i-b);b+=S}}async hb(r,n,s,i){return this.cb.queueFor(n,()=>this.ib(r,n,s,i),this.R(r).providerExtUri)}async ib(r,n,s,i){let o;i instanceof L.$Fe?o=i:(0,c.$re)(i)?o=await(0,L.$Re)(i):(0,c.$se)(i)?o=await(0,L.$Se)(i):o=(0,L.$Pe)(i),await r.writeFile(n,o.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(r,n,s,i){return this.cb.queueFor(i,()=>this.kb(r,n,s,i),this.R(s).providerExtUri)}async kb(r,n,s,i){let o,a;try{o=await r.open(n,{create:!1}),a=await s.open(i,{create:!0,unlock:!1});const b=L.$Fe.alloc(this.a);let S=0,v=0,k=0;do k=await r.read(o,S,b.buffer,v,b.byteLength-v),await this.gb(s,a,b,k,S,v),S+=k,v+=k,v===b.byteLength&&(v=0);while(k>0)}catch(b){throw(0,g.$dl)(b)}finally{await N.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(r,n,s,i){return this.cb.queueFor(i,()=>this.mb(r,n,s,i),this.R(s).providerExtUri)}async mb(r,n,s,i){return s.writeFile(i,await r.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,n,s,i){return this.cb.queueFor(i,()=>this.ob(r,n,s,i),this.R(s).providerExtUri)}async ob(r,n,s,i){const o=await s.open(i,{create:!0,unlock:!1});try{const a=await r.readFile(n);await this.gb(s,o,L.$Fe.wrap(a),a.byteLength,0,0)}catch(a){throw(0,g.$dl)(a)}finally{await s.close(o)}}async pb(r,n,s,i){const o=await(0,L.$Re)(this.H(r,n,j.CancellationToken.None));await this.hb(s,i,void 0,o)}qb(r,n){if(r.capabilities&2048)throw new g.$kl((0,p.localize)(25,null,this.sb(n)),6);return r}rb(r,n){if((n.permissions??0)&g.FilePermission.Readonly)throw new g.$kl((0,p.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===y.Schemas.file?r.fsPath:r.toString(!0)}};e.$Hq=$,e.$Hq=$=d=Ee([Z(0,u.$2j)],$)}),define(ae[207],ce([0,1,41,277,6,34,15,3,40,2,14,5,20,50,31,166,12,97,205,38,201,200]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u,m,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0,(()=>{try{(0,N.gracefulify)(A)}catch(r){console.error(`Error enabling graceful-fs: ${(0,m.$gj)(r)}`)}})();class t extends u.$Tq{static{this.L=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=R.Event.None,this.P=new j.$Bc(i=>w.$Zg.getComparisonKey(i)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,y.$k&&(this.M|=1024)),this.M}async stat(n){try{const{stat:s,symbolicLink:i}=await c.SymlinkSupport.stat(this.I(n));return{type:this.O(s,i),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:g.FilePermission.Locked}}catch(s){throw this.hb(s)}}async N(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await c.Promises.readdir(this.I(n),{withFileTypes:!0}),i=[];return await Promise.all(s.map(async o=>{try{let a;o.isSymbolicLink()?a=(await this.stat((0,w.$9g)(n,o.name))).type:a=this.O(o),i.push([o.name,a])}catch(a){this.a.trace(a)}})),i}catch(s){throw this.hb(s)}}O(n,s){let i;return s?.dangling?i=g.FileType.Unknown:n.isFile()?i=g.FileType.File:n.isDirectory()?i=g.FileType.Directory:i=g.FileType.Unknown,s&&(i|=g.FileType.SymbolicLink),i}async Q(n){const s=this.I(n);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let i;for(;i=this.P.get(n);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await i.wait();const o=new L.$uh;return this.P.set(n,o),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,f.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.P.get(n)===o&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.P.delete(n)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),o.open()})}async readFile(n,s){let i;try{s?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(n)})`),i=await this.Q(n));const o=this.I(n);return await c.Promises.readFile(o)}catch(o){throw this.hb(o)}finally{i?.dispose()}}R(n){t.L&&this.a.trace(n)}readFileStream(n,s,i){const o=(0,h.$te)(a=>O.$Fe.concat(a.map(b=>O.$Fe.wrap(b))).buffer);return(0,l.$Gq)(this,n,o,a=>a.buffer,{...s,bufferSize:256*1024},i),o}async writeFile(n,s,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.S(n)?this.U(n,(0,w.$9g)((0,w.$8g)(n),`${(0,w.$6g)(n)}${i.atomic.postfix}`),s,i):this.W(n,s,i)}async S(n){try{const s=this.I(n),{symbolicLink:i}=await c.SymlinkSupport.stat(s);if(i)return!1}catch{}return!0}async U(n,s,i,o){const a=new f.$Uc;try{a.add(await this.Q(n)),a.add(await this.Q(s)),await this.W(s,i,o,!0);try{await this.rename(s,n,{overwrite:!0})}catch(b){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw b}}finally{a.dispose()}}async W(n,s,i,o){let a;try{const b=this.I(n);if(!i.create||!i.overwrite){if(await c.Promises.exists(b)){if(!i.overwrite)throw(0,g.$cl)((0,p.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,g.$cl)((0,p.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:i.unlock},o),await this.write(a,0,s,0,s.byteLength)}catch(b){throw await this.ib(n,b)}finally{typeof a=="number"&&await this.close(a)}}static{this.$=!0}static configureFlushOnWrite(n){t.$=n}async open(n,s,i){const o=this.I(n);let a;(0,g.$3k)(s)&&!i&&(a=await this.Q(n));let b;try{if((0,g.$3k)(s)&&s.unlock)try{const{stat:v}=await c.SymlinkSupport.stat(o);v.mode&128||await c.Promises.chmod(o,v.mode|128)}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}let S;if((0,g.$3k)(s)){if(y.$i)try{await c.Promises.truncate(o,0),S="r+"}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}S||(S="w")}else S="r";b=await c.Promises.open(o,S)}catch(S){throw a?.dispose(),(0,g.$3k)(s)?await this.ib(n,S):this.hb(S)}if(this.X.set(b,0),(0,g.$3k)(s)&&this.Z.set(b,n),a){const S=this.Y.get(b);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${b} (${o})`),this.Y.set(b,a),S&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${b} (${o})`),S.dispose())}return b}async close(n){const s=this.Y.get(n);try{if(this.X.delete(n),this.Z.delete(n)&&t.$)try{await c.Promises.fdatasync(n)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await c.Promises.close(n)}catch(i){throw this.hb(i)}finally{s&&(this.Y.get(n)===s&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.Y.delete(n)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,i,o,a){const b=this.ab(n,s);let S=null;try{S=(await c.Promises.read(n,i,o,a,b)).bytesRead}catch(v){throw this.hb(v)}finally{this.bb(n,b,S)}return S}ab(n,s){return s===this.X.get(n)?null:s}bb(n,s,i){const o=this.X.get(n);typeof o=="number"&&(typeof s=="number"||(typeof i=="number"?this.X.set(n,o+i):this.X.delete(n)))}async write(n,s,i,o,a){return(0,L.$Ph)(()=>this.cb(n,s,i,o,a),100,3)}async cb(n,s,i,o,a){const b=this.ab(n,s);let S=null;try{S=(await c.Promises.write(n,i,o,a,b)).bytesWritten}catch(v){throw await this.ib(this.Z.get(n),v)}finally{this.bb(n,b,S)}return S}async mkdir(n){try{await c.Promises.mkdir(this.I(n))}catch(s){throw this.hb(s)}}async delete(n,s){try{const i=this.I(n);if(s.recursive){let o;s?.atomic!==!1&&s.atomic.postfix&&(o=(0,E.$kc)((0,E.$nc)(i),`${(0,E.$oc)(i)}${s.atomic.postfix}`)),await c.Promises.rm(i,c.RimRafMode.MOVE,o)}else try{await c.Promises.unlink(i)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let a=!1;try{const{stat:b,symbolicLink:S}=await c.SymlinkSupport.stat(i);a=b.isDirectory()&&!S}catch{}if(a)await c.Promises.rmdir(i);else throw o}else throw o}}catch(i){throw this.hb(i)}}async rename(n,s,i){const o=this.I(n),a=this.I(s);if(o!==a)try{await this.db(n,s,"move",i.overwrite),await c.Promises.rename(o,a)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,p.localize)(2,null,(0,E.$oc)(o),(0,E.$oc)((0,E.$nc)(a)),b.toString()))),this.hb(b)}}async copy(n,s,i){const o=this.I(n),a=this.I(s);if(o!==a)try{await this.db(n,s,"copy",i.overwrite),await c.Promises.copy(o,a,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,p.localize)(3,null,(0,E.$oc)(o),(0,E.$oc)((0,E.$nc)(a)),b.toString()))),this.hb(b)}}async db(n,s,i,o){const a=this.I(n),b=this.I(s);let S=!1;if(!!(this.capabilities&1024)||(S=(0,C.$tg)(a,b,!0)),S){if(i==="copy")throw(0,g.$cl)((0,p.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const k=await this.N(n);if(!k)throw(0,g.$cl)((0,p.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const P=await this.N(s);if(P){if(!o)throw(0,g.$cl)((0,p.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);k.type&g.FileType.File&&P.type&g.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.eb(n,s,!1)}async eb(n,s,i){const o=this.I(n),a=this.I(s),b=!!(this.capabilities&1024);if((0,C.$tg)(o,a,!b))return;const S=new f.$Uc;try{S.add(await this.Q(n)),S.add(await this.Q(s)),i&&await c.Promises.mkdir((0,E.$nc)(a),{recursive:!0}),await c.Promises.copyFile(o,a)}catch(v){if(v.code==="ENOENT"&&!i)return this.eb(n,s,!0);throw this.hb(v)}finally{S.dispose()}}t(n,s,i){return new d.$1q(o=>n(o),o=>s(o),i)}F(n,s,i){return new $.$0q(o=>n(o),o=>s(o),i)}hb(n){if(n instanceof g.$bl)return n;let s=n,i;switch(n.code){case"ENOENT":i=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=g.FileSystemProviderErrorCode.Unknown;break;default:i=g.FileSystemProviderErrorCode.Unknown}return(0,g.$cl)(s,i)}async ib(n,s){let i=this.hb(s);if(n&&i.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await c.SymlinkSupport.stat(this.I(n));o.mode&128||(i=(0,g.$cl)(s,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return i}}e.$$q=t}),define(ae[99],ce([0,1,3,2,4,9]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=e.$rec=void 0,e.$rec=(0,L.$vi)("sharedProcessLifecycleService");let O=class extends N.$Vc{constructor(C){super(),this.b=C,this.a=this.B(new A.$ee),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$sec=O,e.$sec=O=Ee([Z(0,j.$2j)],O)}),define(ae[208],ce([0,1,8,3,9,2]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=e.$_r=e.$$r=void 0;class O extends L.$ak{constructor(y,w,h,c,p){super(w,h,c),this.r=y,this.t=p,this.B(p.listen("onDidChangeLogLevel",y)(g=>{(0,L.$4j)(g)?super.setLogLevel(g):super.setLogLevel(A.URI.revive(g[0]),g[1])})),this.B(p.listen("onDidChangeVisibility",y)(([g,l])=>super.setVisibility(A.URI.revive(g),l))),this.B(p.listen("onDidChangeLoggers",y)(({added:g,removed:l})=>{for(const u of g)super.registerLogger({...u,resource:A.URI.revive(u.resource)});for(const u of l)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new L.$$j({log:(y,w)=>{this.t.call("consoleLog",[y,w])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,w){super.setLogLevel(y,w),this.t.call("setLogLevel",[y,w])}setVisibility(y,w){super.setVisibility(y,w),this.t.call("setVisibility",[this.n(y),w])}s(y,w,h){return new R(this.t,y,w,h,this.r)}static setLogLevel(y,w,h){return y.call("setLogLevel",[w,h])}}e.$$r=O;class R extends L.$8j{constructor(y,w,h,c,p){super(c?.logLevel==="always"),this.r=y,this.s=w,this.m=!1,this.n=[],this.setLevel(h),this.r.call("createLogger",[w,c,p]).then(()=>{this.u(this.n),this.m=!0})}g(y,w){const h=[[y,w]];this.m?this.u(h):this.n.push(...h)}u(y){this.r.call("log",[this.s,y])}}class C{constructor(y,w){this.a=y,this.b=w}listen(y,w){const h=this.b(y);switch(w){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,c=>({added:[...c.added].map(p=>this.c(p,h)),removed:[...c.removed].map(p=>this.c(p,h))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,c=>[h.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,c=>(0,L.$4j)(c)?c:[h.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${w}`)}async call(y,w,h){const c=this.b(y);switch(w){case"setLogLevel":return(0,L.$4j)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(A.URI.revive(c.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,c)))}throw new Error(`Call not found: ${w}`)}c(y,w){return{...y,resource:w.transformOutgoingURI(y.resource)}}}e.$_r=C;class f extends j.$Vc{constructor(y,w){super(),w.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(h=>w.call("setLogLevel",[h]))),w.call("getRegisteredLoggers").then(h=>{for(const c of h)y.registerLogger({...c,resource:A.URI.revive(c.resource)})}),this.B(w.listen("onDidChangeVisibility")(([h,c])=>y.setVisibility(A.URI.revive(h),c))),this.B(w.listen("onDidChangeLoggers")(({added:h,removed:c})=>{for(const p of h)y.registerLogger({...p,resource:A.URI.revive(p.resource)});for(const p of c)y.deregisterLogger(p.resource)}))}}e.$as=f}),define(ae[209],ce([0,1,2,9]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=void 0;class L extends A.$Vc{constructor(O,R=[]){super(),this.a=new N.$_j([O,...R]),this.B(O.onDidChangeLogLevel(C=>this.setLevel(C)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...R){this.a.trace(O,...R)}debug(O,...R){this.a.debug(O,...R)}info(O,...R){this.a.info(O,...R)}warn(O,...R){this.a.warn(O,...R)}error(O,...R){this.a.error(O,...R)}flush(){this.a.flush()}}e.$MQ=L}),define(ae[57],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0,e.$ncc=(0,A.$vi)("nativeHostService")}),define(ae[210],ce([0,1,42,56]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;let L=class{constructor(O,R){return this.windowId=O,A.ProxyChannel.toService(R.getChannel("nativeHost"),{context:O,properties:(()=>{const C=new Map;return C.set("windowId",O),C})()})}};e.$Idc=L,e.$Idc=L=Ee([Z(1,N.$Cdc)],L)}),define(ae[58],ce([0,1,3,61,2,4]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=e.$do=void 0,e.$do=(0,j.$vi)("policy");class O extends L.$Vc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new A.$ee),this.onDidChange=this.h.event}async updatePolicyDefinitions(f){const E=Object.keys(this.f).length;return this.f={...f,...this.f},E!==Object.keys(this.f).length&&await this.j(f),N.Iterable.reduce(this.g.entries(),(y,[w,h])=>({...y,[w]:h}),{})}getPolicyValue(f){return this.g.get(f)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(f,[E,y])=>({...f,[E]:{definition:y,value:this.g.get(E)}}),{})}}e.$eo=O;class R{constructor(){this.onDidChange=A.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$fo=R}),define(ae[211],ce([0,1,3,2,58]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=e.$$cc=void 0;class j{constructor(C){this.b=C,this.a=new N.$Uc}listen(C,f){switch(f){case"onDidChange":return A.Event.map(this.b.onDidChange,E=>E.reduce((y,w)=>({...y,[w]:this.b.getPolicyValue(w)??null}),{}),this.a)}throw new Error(`Event not found: ${f}`)}call(C,f,E){switch(f){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(E)}throw new Error(`Call not found: ${f}`)}dispose(){this.a.dispose()}}e.$$cc=j;class O extends L.$eo{constructor(C,f){super(),this.a=f;for(const E in C){const{definition:y,value:w}=C[E];this.f[E]=y,w!==void 0&&this.g.set(E,w)}this.a.listen("onDidChange")(E=>{for(const y in E){const w=E[y];w===null?this.g.delete(y):this.g.set(y,w)}this.h.fire(Object.keys(E))})}async j(C){const f=await this.a.call("updatePolicyDefinitions",C);for(const E in f)this.g.set(E,f[E])}}e.$_cc=O}),define(ae[100],ce([0,1,36]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const j=L.context.configuration();if(j)N=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:j.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ae[24],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jk=e.$ik=void 0,e.$ik=(0,A.$vi)("productService"),e.$jk="vscode://schemas/vscode-product"}),define(ae[212],ce([0,1,6,7,2,14,31,9,24]),function(ne,e,A,N,L,j,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;let f=class extends L.$Vc{constructor(y,w,h){super(),this.b=w,this.c=h,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,y&&this.B(new A.$Hh(()=>{this.f(y)},3e4)).schedule()}async f(y){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const w=Date.now(),h=(0,j.$nc)(y),c=(0,j.$oc)(y),p=await O.Promises.readdir(h);await Promise.all(p.map(async g=>{if(g===c)return;const l=(0,j.$kc)(h,g),u=await O.Promises.stat(l);if(u.isDirectory()&&w-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${g}.`),O.Promises.rm(l)}))}catch(w){(0,N.$1)(w)}}};e.$2dc=f,e.$2dc=f=Ee([Z(1,C.$ik),Z(2,R.$2j)],f)}),define(ae[213],ce([0,1,6,7,2,14,31,16,9,24]),function(ne,e,A,N,L,j,O,R,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;let E=class extends L.$Vc{constructor(w,h,c){super(),this.b=w,this.c=h,this.f=c,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new A.$Hh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const w=Object.create(null),h=JSON.parse(await O.Promises.readFile((0,j.$kc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(h)){const m=h[u];w[`${m.hash}.${u}`]=!0}const c=(0,j.$kc)(this.b.userDataPath,"clp");if(!await O.Promises.exists(c))return;const g=await O.Promises.readdir(c);for(const u of g){if(w[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await O.Promises.rm((0,j.$kc)(c,u))}const l=Date.now();for(const u of Object.keys(w)){const m=(0,j.$kc)(c,u),d=await O.Promises.readdir(m);for(const $ of d){if($==="tcf.json")continue;const t=(0,j.$kc)(m,$),r=await O.Promises.stat(t);r.isDirectory()&&l-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$kc)(u,$)}`),await O.Promises.rm(t))}}}catch(w){(0,N.$1)(w)}}};e.$3dc=E,e.$3dc=E=Ee([Z(0,R.$Di),Z(1,C.$2j),Z(2,f.$ik)],E)}),define(ae[214],ce([0,1,14,4]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$mG=void 0,e.$mG=(0,N.$vi)("IV8InspectProfilingService");var L;(function(j){function O(C){return!!(C.samples&&C.timeDeltas)}j.isValidProfile=O;function R(C,f="noAbsolutePaths"){for(const E of C.nodes)E.callFrame&&E.callFrame.url&&((0,A.$jc)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(E.callFrame.url))&&(E.callFrame.url=(0,A.$kc)(f,(0,A.$oc)(E.callFrame.url)));return C}j.rewriteAbsolutePaths=R})(L||(e.Utils=L={}))}),define(ae[215],ce([0,1,32]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;class N{constructor(){this.a=new Map}async startProfiling(j){const R=await(await new Promise((f,E)=>{ne(["v8-inspect-profiler"],f,E)})).startProfiling({host:j.host,port:j.port,checkForPaused:!0}),C=(0,A.$Rg)();return this.a.set(C,R),C}async stopProfiling(j){const O=this.a.get(j);if(!O)throw new Error(`UNKNOWN session '${j}'`);const R=await O.stop();return this.a.delete(j),R.profile}}e.$hec=N}),define(ae[43],ce([0,1,127,13]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=void 0;class L{constructor(){this.a=new Map}add(O,R){A.ok(N.$8f(O)),A.ok(N.$0f(R)),A.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,R)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$bo=new L}),define(ae[101],ce([0,1,3,43]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0,e.$co={JSONContribution:"base.contributions.json"};function L(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class j{constructor(){this.b=new A.$ee,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(C,f){this.a[L(C)]=f,this.b.fire(C)}notifySchemaChanged(C){this.b.fire(C)}getSchemaContributions(){return{schemas:this.a}}}const O=new j;N.$bo.add(e.$co.JSONContribution,O)}),define(ae[47],ce([0,1,17,3,13,153,21,101,43]),function(ne,e,A,N,L,j,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.ConfigurationScope=e.$go=e.EditPresentationTypes=void 0,e.$ro=p,e.$so=g,e.$to=l,e.$uo=m,e.$vo=d;var f;(function($){$.Multiline="multilineText",$.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$go={Configuration:"base.contributions.configuration"};var E;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.MACHINE=2]="MACHINE",$[$.WINDOW=3]="WINDOW",$[$.RESOURCE=4]="RESOURCE",$[$.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",$[$.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E||(e.ConfigurationScope=E={})),e.$ho={properties:{},patternProperties:{}},e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no="vscode://schemas/settings/resourceLanguage",e.$oo="vscode://schemas/settings/configurationDefaults";const y=C.$bo.as(R.$co.JSONContribution);class w{constructor(){this.h=new Set,this.i=new N.$ee,this.onDidSchemaChange=this.i.event,this.j=new N.$ee,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$no,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const n=new Set;this.n(t,r,n),y.registerSchema(e.$no,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const r=new Set;this.o(t,r),y.registerSchema(e.$no,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const n=new Set;this.o(r,n),this.n(t,!1,n),y.registerSchema(e.$no,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const n=[];for(const{overrides:s,source:i}of t)for(const o in s)if(r.add(o),e.$qo.test(o)){const a=this.a.get(o),b=a?.valuesSources??new Map;if(i)for(const P of Object.keys(s[o]))b.set(P,i);const S={...a?.value||{},...s[o]};this.a.set(o,{source:i,value:S,valuesSources:b});const v=(0,O.$_i)(o),k={type:"object",default:S,description:j.localize(1,null,v),$ref:e.$no,defaultDefaultValue:S,source:L.$8f(i)?void 0:i,defaultValueSource:i};n.push(...p(o)),this.d[o]=k,this.b.properties[o]=k}else{this.a.set(o,{value:s[o],source:i});const a=this.d[o];a&&(this.w(o,a),this.r(o,a))}this.m(n)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:n,source:s}of t)for(const i in n){const o=this.a.get(i),a=L.$8f(s)?s:s?.id,b=L.$8f(o?.source)?o?.source:o?.source?.id;if(a===b)if(r.add(i),this.a.delete(i),e.$qo.test(i))delete this.d[i],delete this.b.properties[i];else{const S=this.d[i];S&&(this.w(i,S),this.r(i,S))}}this.u()}deltaConfiguration(t){let r=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,n){t.forEach(s=>{this.p(s,r,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(t,r){const n=s=>{if(s.properties)for(const i in s.properties){r.add(i);const o=this.d[i];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[i],this.s(i,s.properties[i])}s.allOf?.forEach(i=>n(i))};for(const s of t){n(s);const i=this.c.indexOf(s);i!==-1&&this.c.splice(i,1)}}p(t,r=!0,n,s,i=3,o){i=L.$eg(t.scope)?i:t.scope;const a=t.properties;if(a)for(const S in a){const v=a[S];if(r&&m(S,v)){delete a[S];continue}if(v.source=n,v.defaultDefaultValue=a[S].default,this.w(S,v),e.$qo.test(S)?v.scope=void 0:(v.scope=L.$eg(v.scope)?i:v.scope,v.restricted=L.$eg(v.restricted)?!!s?.includes(S):v.restricted),a[S].hasOwnProperty("included")&&!a[S].included){this.f[S]=a[S],delete a[S];continue}else this.d[S]=a[S],a[S].policy?.name&&this.e.set(a[S].policy.name,S);!a[S].deprecationMessage&&a[S].markdownDeprecationMessage&&(a[S].deprecationMessage=a[S].markdownDeprecationMessage),o.add(S)}const b=t.allOf;if(b)for(const S of b)this.p(S,r,n,s,i,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=n=>{const s=n.properties;if(s)for(const o in s)this.r(o,s[o]);n.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$ho.properties[t]=r,r.scope){case 1:e.$io.properties[t]=r;break;case 2:e.$jo.properties[t]=r;break;case 6:e.$ko.properties[t]=r;break;case 3:e.$lo.properties[t]=r;break;case 4:e.$mo.properties[t]=r;break;case 5:e.$mo.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$ho.properties[t],r.scope){case 1:delete e.$io.properties[t];break;case 2:delete e.$jo.properties[t];break;case 6:delete e.$ko.properties[t];break;case 3:delete e.$lo.properties[t];break;case 4:case 5:delete e.$mo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,n={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$no};this.w(r,n),e.$ho.properties[r]=n,e.$io.properties[r]=n,e.$jo.properties[r]=n,e.$ko.properties[r]=n,e.$lo.properties[r]=n,e.$mo.properties[r]=n}}v(){const t={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$no};e.$ho.patternProperties[e.$po]=t,e.$io.patternProperties[e.$po]=t,e.$jo.patternProperties[e.$po]=t,e.$ko.patternProperties[e.$po]=t,e.$lo.patternProperties[e.$po]=t,e.$mo.patternProperties[e.$po]=t,this.i.fire()}w(t,r){const n=this.a.get(t);let s=n?.value,i=n?.source;L.$cg(s)&&(s=r.defaultDefaultValue,i=void 0),L.$cg(s)&&(s=l(r.type)),r.default=s,r.defaultValueSource=i}}const h="\\[([^\\]]+)\\]",c=new RegExp(h,"g");e.$po=`^(${h})+$`,e.$qo=new RegExp(e.$po);function p($){const t=[];if(e.$qo.test($)){let r=c.exec($);for(;r?.length;){const n=r[1].trim();n&&t.push(n),r=c.exec($)}}return(0,A.$Mb)(t)}function g($){return $.reduce((t,r)=>`${t}[${r}]`,"")}function l($){switch(Array.isArray($)?$[0]:$){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const u=new w;C.$bo.add(e.$go.Configuration,u);function m($,t){return $.trim()?e.$qo.test($)?j.localize(7,null,$):u.getConfigurationProperties()[$]!==void 0?j.localize(8,null,$):t.policy?.name&&u.getPolicyConfigurations().get(t.policy?.name)!==void 0?j.localize(9,null,$,t.policy?.name,u.getPolicyConfigurations().get(t.policy?.name)):null:j.localize(6,null)}function d(){const $=[],t=u.getConfigurationProperties();for(const r of Object.keys(t))$.push([r,t[r].scope]);return $.push(["launch",4]),$.push(["task",4]),$}}),define(ae[76],ce([0,1,17,3,35,2,34,30,13,8,21,47,43]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$zo=e.$yo=e.$xo=e.$wo=void 0,e.$Ao=m;function h(r){return Object.isFrozen(r)?r:R.$3n(r)}class c{static createEmptyModel(n){return new c({},[],[],void 0,n)}constructor(n,s,i,o,a){this.b=n,this.c=s,this.d=i,this.raw=o,this.f=a,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof c)return s;const i=new p("",this.f);return i.parseRaw(s),i.configurationModel});this.g=n.reduce((s,i)=>i===s?i:s.merge(i),n[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,E.$0i)(this.contents,n):this.contents}inspect(n,s){const i=this;return{get value(){return h(i.rawConfiguration.getValue(n))},get override(){return s?h(i.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return h(s?i.rawConfiguration.override(s).getValue(n):i.rawConfiguration.getValue(n))},get overrides(){const o=[];for(const{contents:a,identifiers:b,keys:S}of i.rawConfiguration.overrides){const v=new c(a,S,[],void 0,i.f).getValue(n);v!==void 0&&o.push({identifiers:b,value:v})}return o.length?h(o):void 0}}}getOverrideValue(n,s){const i=this.j(s);return i?n?(0,E.$0i)(i,n):i:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const i of this.overrides)i.identifiers.includes(n)&&s.push(...i.keys);return A.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return A.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.h(n),this.a.set(n,s)),s}merge(...n){const s=R.$2n(this.contents),i=R.$2n(this.overrides),o=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const b of n)if(a.push(...b.raw?.length?b.raw:[b]),!b.isEmpty()){this.i(s,b.contents);for(const S of b.overrides){const[v]=i.filter(k=>A.$ub(k.identifiers,S.identifiers));v?(this.i(v.contents,S.contents),v.keys.push(...S.keys),v.keys=A.$Mb(v.keys)):i.push(R.$2n(S))}for(const S of b.keys)o.indexOf(S)===-1&&o.push(S)}return new c(s,o,i,a.every(b=>b instanceof c)?void 0:a,this.f)}h(n){const s=this.j(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const i={};for(const o of A.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[o];const b=s[o];b&&(typeof a=="object"&&typeof b=="object"?(a=R.$2n(a),this.i(a,b)):a=b),i[o]=a}return new c(i,this.keys,this.overrides,void 0,this.f)}i(n,s){for(const i of Object.keys(s)){if(i in n&&C.$0f(n[i])&&C.$0f(s[i])){this.i(n[i],s[i]);continue}n[i]=R.$2n(s[i])}}j(n){let s=null,i=null;const o=a=>{a&&(i?this.i(i,a):i=R.$2n(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&o(a.contents);return o(s),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.k(n,s,!0)}setValue(n,s){this.k(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,E.$9i)(this.contents,n),y.$qo.test(n)&&this.overrides.splice(this.overrides.findIndex(i=>A.$ub(i.identifiers,(0,y.$ro)(n))),1))}k(n,s,i){(0,E.$8i)(this.contents,n,s,o=>this.f.error(o)),i=i||this.keys.indexOf(n)===-1,i&&this.keys.push(n),y.$qo.test(n)&&this.overrides.push({identifiers:(0,y.$ro)(n),keys:Object.keys(this.contents[n]),contents:(0,E.$7i)(this.contents[n],o=>this.f.error(o))})}}e.$wo=c;class p{constructor(n,s){this.f=n,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||c.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!C.$eg(n)){const i=this.h(n);this.parseRaw(i,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:i,keys:o,overrides:a,restricted:b,hasExcludedProperties:S}=this.i(n,s);this.b=new c(i,o,a,S?[n]:void 0,this.g),this.c=b||[]}h(n){let s={},i=null,o=[];const a=[],b=[];function S(k){Array.isArray(o)?o.push(k):i!==null&&(o[i]=k)}const v={onObjectBegin:()=>{const k={};S(k),a.push(o),o=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const k=[];S(k),a.push(o),o=k,i=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:S,onError:(k,P,I)=>{b.push({error:k,offset:P,length:I})}};if(n)try{L.$Pn(n,v),s=o[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return s}i(n,s){const i=w.$bo.as(y.$go.Configuration).getConfigurationProperties(),o=this.j(n,i,!0,s);n=o.raw;const a=(0,E.$7i)(n,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`)),b=Object.keys(n),S=this.l(n,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:a,keys:b,overrides:S,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(n,s,i,o){let a=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const b={},S=[];for(const v in n)if(y.$qo.test(v)&&i){const k=this.j(n[v],s,!1,o);b[v]=k.raw,a=a||k.hasExcludedProperties,S.push(...k.restricted)}else{const k=s[v],P=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&S.push(v),!o.exclude?.includes(v)&&(o.include?.includes(v)||(P===void 0||o.scopes===void 0||o.scopes.includes(P))&&!(o.skipRestricted&&k?.restricted))?b[v]=n[v]:a=!0}return{raw:b,restricted:S,hasExcludedProperties:a}}l(n,s){const i=[];for(const o of Object.keys(n))if(y.$qo.test(o)){const a={};for(const b in n[o])a[b]=n[o][b];i.push({identifiers:(0,y.$ro)(o),keys:Object.keys(a),contents:(0,E.$7i)(a,s)})}return i}}e.$xo=p;class g extends j.$Vc{constructor(n,s,i,o,a){super(),this.c=n,this.f=s,this.g=o,this.h=a,this.b=this.B(new N.$ee),this.onDidChange=this.b.event,this.a=new p(this.c.toString(),a),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&i.isEqual(b.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return c.createEmptyModel(this.h)}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$yo=g;class l{constructor(n,s,i,o,a,b,S,v,k,P,I,F,T){this.a=n,this.b=s,this.c=i,this.overrideIdentifiers=o,this.d=a,this.f=b,this.g=S,this.h=v,this.i=k,this.j=P,this.k=I,this.l=F,this.m=T}get value(){return h(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class u{constructor(n,s,i,o,a,b,S,v,k,P){this.j=n,this.l=s,this.m=i,this.n=o,this.p=a,this.q=b,this.r=S,this.s=v,this.t=k,this.u=P,this.h=null,this.i=new O.$Bc,this.v=null}getValue(n,s,i){return this.w(n,s,i).getValue(n)}updateValue(n,s,i={}){let o;i.resource?(o=this.t.get(i.resource),o||(o=c.createEmptyModel(this.u),this.t.set(i.resource,o))):o=this.s,s===void 0?o.removeValue(n):o.setValue(n,s),i.resource||(this.h=null)}inspect(n,s,i){const o=this.w(n,s,i),a=this.A(s.resource,i),b=s.resource?this.t.get(s.resource)||this.s:this.s,S=new Set;for(const v of o.overrides)for(const k of v.identifiers)o.getOverrideValue(n,k)!==void 0&&S.add(k);return new l(n,s,o.getValue(n),S.size?[...S]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.q:void 0,a||void 0,b)}keys(n){const s=this.A(void 0,n);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.j=n,this.h=null,this.i.clear()}updatePolicyConfiguration(n){this.l=n}updateApplicationConfiguration(n){this.m=n,this.h=null,this.i.clear()}updateLocalUserConfiguration(n){this.n=n,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(n){this.p=n,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(n){this.q=n,this.h=null,this.i.clear()}updateFolderConfiguration(n,s){this.r.set(n,s),this.i.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.i.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const i=[];if(!s){const{added:o,updated:a,removed:b}=$(this.j,n);s=[...o,...a,...b]}for(const o of s)for(const a of(0,y.$ro)(o)){const b=this.j.getKeysForOverrideIdentifier(a),S=n.getKeysForOverrideIdentifier(a),v=[...S.filter(k=>b.indexOf(k)===-1),...b.filter(k=>S.indexOf(k)===-1),...b.filter(k=>!R.$6n(this.j.override(a).getValue(k),n.override(a).getValue(k)))];i.push([a,v])}return this.updateDefaultConfiguration(n),{keys:s,overrides:i}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:i,removed:o}=$(this.l,n),a=[...s,...i,...o];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.applicationConfiguration,n),b=[...s,...i,...o];return b.length&&this.updateApplicationConfiguration(n),{keys:b,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.localUserConfiguration,n),b=[...s,...i,...o];return b.length&&this.updateLocalUserConfiguration(n),{keys:b,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.remoteUserConfiguration,n),b=[...s,...i,...o];return b.length&&this.updateRemoteUserConfiguration(n),{keys:b,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.workspaceConfiguration,n),b=[...s,...i,...o];return b.length&&this.updateWorkspaceConfiguration(n),{keys:b,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const i=this.folderConfigurations.get(n),{added:o,updated:a,removed:b,overrides:S}=$(i,s),v=[...o,...a,...b];return(v.length||!i)&&this.updateFolderConfiguration(n,s),{keys:v,overrides:S}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:o,removed:a,overrides:b}=$(s,void 0);return{keys:[...i,...o,...a],overrides:b}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(n,s,i){let o=this.x(s,i);return s.overrideIdentifier&&(o=o.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(n)!==void 0&&(o=o.merge(this.l)),o}x({resource:n},s){let i=this.y();if(s&&n){const o=s.getFolder(n);o&&(i=this.z(o.uri)||i);const a=this.t.get(n);a&&(i=i.merge(a))}return i}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(n){let s=this.i.get(n);if(!s){const i=this.y(),o=this.r.get(n);o?(s=i.merge(o),this.i.set(n,s)):s=i}return s}A(n,s){if(s&&n){const i=s.getFolder(n);if(i)return this.r.get(i.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((n,s)=>{const{contents:i,overrides:o,keys:a}=this.r.get(s);return n.push([s,{contents:i,overrides:o,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.j.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.q.keys.forEach(s=>n.add(s)),this.r.forEach(s=>s.keys.forEach(i=>n.add(i))),[...n.values()]}B(){const n=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(i=>n.add(i))),[...n.values()]}D(n){const s=new Set;return this.j.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.q.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.r.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(o=>s.add(o))),[...s.values()]}static parse(n,s){const i=this.E(n.defaults,s),o=this.E(n.policy,s),a=this.E(n.application,s),b=this.E(n.user,s),S=this.E(n.workspace,s),v=n.folders.reduce((k,P)=>(k.set(f.URI.revive(P[0]),this.E(P[1],s)),k),new O.$Bc);return new u(i,o,a,b,c.createEmptyModel(s),S,v,c.createEmptyModel(s),new O.$Bc,s)}static E(n,s){return new c(n.contents,n.keys,n.overrides,void 0,s)}}e.$zo=u;function m(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const n=new Set,s=new Map;for(const o of r)o.keys.forEach(a=>n.add(a)),o.overrides.forEach(([a,b])=>{const S=(0,O.$yc)(s,a,new Set);b.forEach(v=>S.add(v))});const i=[];return s.forEach((o,a)=>i.push([a,[...o.values()]])),{keys:[...n.values()],overrides:i}}class d{constructor(n,s,i,o,a){this.change=n,this.f=s,this.g=i,this.h=o,this.i=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const b of n.keys)this.affectedKeys.add(b);for(const[,b]of n.overrides)for(const S of b)this.affectedKeys.add(S);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=u.parse(this.f.data,this.i)),this.j}affectsConfiguration(n,s){const i=this.a+n,o=this.d.indexOf(i);if(o<0)return!1;const a=o+i.length;if(a>=this.d.length)return!1;const b=this.d.charCodeAt(a);if(b!==this.b&&b!==this.c)return!1;if(s){const S=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,v=this.g.getValue(n,s,this.h);return!R.$6n(S,v)}return!0}}e.$Bo=d;function $(r,n){const{added:s,removed:i,updated:o}=t(n?.rawConfiguration,r?.rawConfiguration),a=[],b=r?.getAllOverrideIdentifiers()||[],S=n?.getAllOverrideIdentifiers()||[];if(n){const v=S.filter(k=>!b.includes(k));for(const k of v)a.push([k,n.getKeysForOverrideIdentifier(k)])}if(r){const v=b.filter(k=>!S.includes(k));for(const k of v)a.push([k,r.getKeysForOverrideIdentifier(k)])}if(n&&r){for(const v of b)if(S.includes(v)){const k=t({contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)},{contents:n.getOverrideValue(void 0,v)||{},keys:n.getKeysForOverrideIdentifier(v)});a.push([v,[...k.added,...k.removed,...k.updated]])}}return{added:s,removed:i,updated:o,overrides:a}}function t(r,n){const s=r?n?r.keys.filter(a=>n.keys.indexOf(a)===-1):[...r.keys]:[],i=n?r?n.keys.filter(a=>r.keys.indexOf(a)===-1):[...n.keys]:[],o=[];if(r&&n){for(const a of n.keys)if(r.keys.indexOf(a)!==-1){const b=(0,E.$0i)(n.contents,a),S=(0,E.$0i)(r.contents,a);R.$6n(b,S)||o.push(a)}}return{added:s,removed:i,updated:o}}}),define(ae[216],ce([0,1,17,3,2,30,13,76,47,9,58,43]),function(ne,e,A,N,L,j,O,R,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=void 0;class w extends L.$Vc{get configurationModel(){return this.b}constructor(g){super(),this.c=g,this.a=this.B(new N.$ee),this.onDidChangeConfiguration=this.a.event,this.b=R.$wo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(y.$bo.as(C.$go.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:l})=>this.f(Array.from(g),l))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(g,l){this.j(g,y.$bo.as(C.$go.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}g(){return{}}h(){this.b=R.$wo.createEmptyModel(this.c);const g=y.$bo.as(C.$go.Configuration).getConfigurationProperties();this.j(Object.keys(g),g)}j(g,l){const u=this.g();for(const m of g){const d=u[m],$=l[m];d!==void 0?this.b.addValue(m,d):$?this.b.addValue(m,$.default):this.b.removeValue(m)}}}e.$Co=w;class h{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=R.$wo.createEmptyModel(new f.$ck)}async initialize(){return this.configurationModel}}e.$Do=h;let c=class extends L.$Vc{get configurationModel(){return this.b}constructor(g,l,u){super(),this.c=g,this.f=l,this.g=u,this.a=this.B(new N.$ee),this.onDidChangeConfiguration=this.a.event,this.b=R.$wo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const l={},u=[],m=y.$bo.as(C.$go.Configuration).getConfigurationProperties();for(const d of g){const $=m[d];if(!$){u.push(d);continue}if($.policy){if($.type!=="string"&&$.type!=="number"){this.g.warn(`Policy ${$.policy.name} has unsupported type ${$.type}`);continue}u.push(d),l[$.policy.name]={type:$.type}}}return(0,O.$ig)(l)||await this.f.updatePolicyDefinitions(l),u}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const l=y.$bo.as(C.$go.Configuration).getPolicyConfigurations(),u=(0,A.$Hb)(g.map(m=>l.get(m)));this.m(u,!0)}m(g,l){this.g.trace("PolicyConfiguration#update",g);const u=y.$bo.as(C.$go.Configuration).getConfigurationProperties(),m=[],d=this.b.isEmpty();for(const $ of g){const t=u[$]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(d?r!==void 0:!(0,j.$6n)(this.b.getValue($),r))&&m.push([$,r])}else this.b.getValue($)!==void 0&&m.push([$,void 0])}if(m.length){this.g.trace("PolicyConfiguration#changed",m);const $=this.b;this.b=R.$wo.createEmptyModel(this.g);for(const t of $.keys)this.b.setValue(t,$.getValue(t));for(const[t,r]of m)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);l&&this.a.fire(this.b)}}};e.$Eo=c,e.$Eo=c=Ee([Z(1,E.$do),Z(2,f.$2j)],c)}),define(ae[217],ce([0,1,17,6,15,3,35,62,2,34,30,5,20,21,76,47,216,58]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=void 0;class u extends C.$Vc{constructor($,t,r,n){super(),this.m=$,this.n=n,this.h=this.B(new j.$ee),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.$Co(n)),this.c=r instanceof l.$fo?new g.$Do:this.B(new g.$Eo(this.b,r,n)),this.f=this.B(new c.$yo(this.m,{},w.$Zg,t,n)),this.a=new c.$zo(this.b.configurationModel,this.c.configurationModel,c.$wo.createEmptyModel(n),c.$wo.createEmptyModel(n),c.$wo.createEmptyModel(n),c.$wo.createEmptyModel(n),new f.$Bc,c.$wo.createEmptyModel(n),new f.$Bc,n),this.j=new m($,t,this),this.g=this.B(new N.$Hh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:i})=>this.s(s,i))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[$,t,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new c.$zo($,t,c.$wo.createEmptyModel(this.n),r,c.$wo.createEmptyModel(this.n),c.$wo.createEmptyModel(this.n),new f.$Bc,c.$wo.createEmptyModel(this.n),new f.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue($,t){const r=typeof $=="string"?$:void 0,n=(0,h.$3i)($)?$:(0,h.$3i)(t)?t:{};return this.a.getValue(r,n,void 0)}async updateValue($,t,r,n,s){const i=(0,h.$4i)(r)?r:(0,h.$3i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,o=i?n:r;if(o!==void 0&&o!==3&&o!==2)throw new Error(`Unable to write ${$} to target ${o}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,A.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const a=this.inspect($,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(a.policyValue!==void 0)throw new Error(`Unable to write ${$} because it is configured in system policy.`);if((0,E.$6n)(t,a.defaultValue)&&(t=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const S=i.overrideIdentifiers.sort(),v=this.a.localUserConfiguration.overrides.find(k=>(0,A.$ub)([...k.identifiers].sort(),S));v&&(i.overrideIdentifiers=v.identifiers)}const b=i?.overrideIdentifiers?.length?[(0,p.$so)(i.overrideIdentifiers),$]:[$];await this.j.write(b,t),await this.reloadConfiguration()}inspect($,t={}){return this.a.inspect($,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const $=await this.f.loadConfiguration();this.r($)}r($){const t=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration($);this.u(r,t,2)}s($,t){const r=this.a.toData(),n=this.a.compareAndUpdateDefaultConfiguration($,t);this.u(n,r,7)}t($){const t=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration($);this.u(r,t,7)}u($,t,r){const n=new c.$Bo($,{data:t},this.a,void 0,this.n);n.source=r,this.h.fire(n)}}e.$Fo=u;class m{constructor($,t,r){this.b=$,this.c=t,this.d=r,this.a=new N.$Ch}write($,t){return this.a.queue(()=>this.e($,t))}async e($,t){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)r="{}";else throw i}const n=[];if((0,O.$In)(r,n,{allowTrailingComma:!0,allowEmptyContent:!0}),n.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(r,$,t);r=(0,R.$1n)(r,s),await this.c.writeFile(this.b,L.$Fe.fromString(r))}f($,t,r){const{tabSize:n,insertSpaces:s,eol:i}=this.h;if(!t.length){const o=JSON.stringify(r,null,s?" ".repeat(n):"	");return[{content:o,length:o.length,offset:0}]}return(0,R.$Xn)($,t,r,{tabSize:n,insertSpaces:s,eol:i})}get h(){if(!this.g){let $=y.OS===3||y.OS===2?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&($=t),this.g={eol:$,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ae[218],ce([0,1,15,3,2,68]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dtb=e.$Btb=e.$Atb=void 0,e.$Ctb=R;const O=(f,E,y)=>{const w=new Uint8Array(16);for(let p=0;p<16;p++)w[p]=Math.round(Math.random()*256);const h=(0,A.$Ze)(A.$Fe.wrap(w));return[`GET ws://localhost${f}?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`].join(`\r
`)+`\r
\r
`};e.$Atb=O,e.$Btb=A.$Fe.fromString(`\r
\r
`);async function R(f,E,y,w,h){f.write(A.$Fe.fromString((0,e.$Atb)(E,y,w)));const c=new L.$Uc;try{return await new Promise((p,g)=>{let l;c.add(f.onData(u=>{l?l=A.$Fe.concat([l,u],l.byteLength+u.byteLength):l=u;const m=l.indexOf(e.$Btb);if(m===-1)return;p(f),f.pauseData();const d=l.slice(m+e.$Btb.byteLength);d.byteLength&&h.onData.fire(d)})),c.add(f.onClose(u=>g(u??new Error("socket closed")))),c.add(f.onEnd(()=>g(new Error("socket ended"))))})}catch(p){throw f.dispose(),p}finally{c.dispose()}}class C extends L.$Vc{constructor(E,y){super(),this.g=E,this.a=this.B(new N.$he),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new N.$ee),this.onDidDispose=this.b.event,this.f=!1,this.B(y.onData),this.B(y.onData.event(w=>this.a.fire(w))),this.onClose=this.B(y.onClose).event,this.onEnd=this.B(y.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(E,y){j.SocketDiagnostics.traceSocketEvent(this,this.g,E,y)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Dtb=C}),define(ae[219],ce([0,1,7,4]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.RemoteAuthorityResolverErrorCode=e.$Il=e.$Hl=e.RemoteConnectionType=e.$Gl=void 0,e.$Kl=f,e.$Gl=(0,N.$vi)("remoteAuthorityResolverService");var L;(function(E){E[E.WebSocket=0]="WebSocket",E[E.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class j{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$Hl=j;class O{constructor(y,w){this.host=y,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Il=O;var R;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound",E.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class C extends A.$bb{static isNotAvailable(y){return y instanceof C&&y._code===R.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof C&&y._code===R.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof C&&y._code===R.NoResolverFound}static isInvalidAuthority(y){return y instanceof C&&y._code===R.InvalidAuthority}static isHandled(y){return y instanceof C&&y.isHandled}constructor(y,w=R.Unknown,h){super(y),this._message=y,this._code=w,this._detail=h,this.isHandled=w===R.NotAvailable&&h===!0,Object.setPrototypeOf(this,C.prototype)}}e.$Jl=C;function f(E){const y=E.indexOf("+");return y===-1?E:E.substring(0,y)}}),define(ae[220],ce([0,1,6,15,26,7,3,2,23,98,63,32,68,219]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Pl=b,e.$Ql=S,e.$Rl=k;const c=30*1e3;var p;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function g(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(U){const D=new L.$pe;return setTimeout(()=>D.cancel(),U),D.token}function u(U,D){if(U.isCancellationRequested||D.isCancellationRequested)return L.CancellationToken.Cancelled;const M=new L.$pe;return U.onCancellationRequested(()=>M.cancel()),D.onCancellationRequested(()=>M.cancel()),M.token}class m{get didTimeout(){return this.c==="timedout"}constructor(D){this.c="pending",this.d=new R.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,A.$oh)(),D.isCancellationRequested?this.h():this.d.add(D.onCancellationRequested(()=>this.h()))}registerDisposable(D){this.c==="pending"?this.d.add(D):D.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const D=new Error("Time limit reached");return D.code="ETIMEDOUT",D.syscall="connect",D}resolve(D){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(D))}reject(D){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(D))}}function d(U,D){const M=new m(D);return M.registerDisposable(U.onControlMessage(z=>{const x=JSON.parse(z.toString()),K=B(x);K?M.reject(K):M.resolve(x)})),M.promise}function $(U,D,M,z,x,K,ee,_){const Y=new m(_),se=E.$ae.create(!1);return U.info(`Creating a socket (${ee})...`),f.mark(`code/willCreateSocket/${K}`),D.connect(M,z,x,ee).then(ue=>{Y.didTimeout?(f.mark(`code/didCreateSocketError/${K}`),U.info(`Creating a socket (${ee}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(f.mark(`code/didCreateSocketOK/${K}`),U.info(`Creating a socket (${ee}) was successful after ${se.elapsed()} ms.`),Y.resolve(ue))},ue=>{f.mark(`code/didCreateSocketError/${K}`),U.info(`Creating a socket (${ee}) returned an error after ${se.elapsed()} ms.`),U.error(ue),Y.reject(ue)}),Y.promise}function t(U,D){const M=new m(D);return U.then(z=>{M.didTimeout||M.resolve(z)},z=>{M.didTimeout||M.reject(z)}),M.promise}async function r(U,D,M,z){const x=te(U,D);U.logService.trace(`${x} 1/6. invoking socketFactory.connect().`);let K;try{K=await $(U.logService,U.remoteSocketFactoryService,U.connectTo,C.$Ig.getServerRootPath(),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,g(D),`renderer-${g(D)}-${U.reconnectionToken}`,z)}catch(ue){throw U.logService.error(`${x} socketFactory.connect() failed or timed out. Error:`),U.logService.error(ue),ue}U.logService.trace(`${x} 2/6. socketFactory.connect() was successful.`);let ee,_;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(K,null),ee=U.reconnectionProtocol,_=!1):(ee=new w.$ji({socket:K}),_=!0),U.logService.trace(`${x} 3/6. sending AuthRequest control message.`);const Y=await t(U.signService.createNewMessage((0,y.$Rg)()),z),se={type:"auth",auth:U.connectionToken||"00000000000000000000",data:Y.data};ee.sendControl(N.$Fe.fromString(JSON.stringify(se)));try{const ue=await d(ee,u(z,l(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}if(U.logService.trace(`${x} 4/6. received SignRequest control message.`),!await t(U.signService.validate(Y,ue.signedData),z)){const ye=new Error("Refused to connect to unsupported server");throw ye.code="VSCODE_CONNECTION_ERROR",ye}const fe=await t(U.signService.sign(ue.data),z),$e={type:"connectionType",commit:U.commit,signedData:fe,desiredConnectionType:D};return M&&($e.args=M),U.logService.trace(`${x} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(N.$Fe.fromString(JSON.stringify($e))),{protocol:ee,ownsProtocol:_}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(U.logService.error(`${x} the handshake timed out. Error:`),U.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${x} received error control message when negotiating connection. Error:`),U.logService.error(ue)),_&&H(ee),ue}}async function n(U,D,M,z){const x=Date.now(),K=te(U,D),{protocol:ee,ownsProtocol:_}=await r(U,D,M,z),Y=new m(z);return Y.registerDisposable(ee.onControlMessage(se=>{const ue=JSON.parse(se.toString()),ge=B(ue);ge?(U.logService.error(`${K} received error control message when negotiating connection. Error:`),U.logService.error(ge),_&&H(ee),Y.reject(ge)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${V(x)}!`),Y.resolve({protocol:ee,firstMessage:ue}))})),Y.promise}async function s(U,D){const{protocol:M}=await n(U,1,void 0,D);return{protocol:M}}async function i(U,D,M){const{protocol:z,firstMessage:x}=await n(U,2,D,M),K=x&&x.debugPort;return{protocol:z,debugPort:K}}async function o(U,D,M){const z=Date.now(),x=te(U,3),{protocol:K}=await r(U,3,D,M);return U.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${V(z)}!`),K}async function a(U,D,M){const{connectTo:z,connectionToken:x}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,connectTo:z,connectionToken:x,reconnectionToken:D,reconnectionProtocol:M,remoteSocketFactoryService:U.remoteSocketFactoryService,signService:U.signService,logService:U.logService}}async function b(U,D,M){return v(U,async z=>{const{protocol:x}=await s(z,L.CancellationToken.None);return new W(U,D,M,z.reconnectionToken,x)})}async function S(U,D){return v(U,async M=>{const{protocol:z,debugPort:x}=await i(M,D,L.CancellationToken.None);return new J(U,D,M.reconnectionToken,z,x)})}async function v(U,D){for(let z=1;;z++)try{const x=(0,y.$Rg)(),K=await a(U,x,null);return await D(K)}catch(x){if(z<5)U.logService.error(`[remote-connection][attempt ${z}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(x);else throw U.logService.error(`[remote-connection][attempt ${z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(x),Q.triggerPermanentFailure(0,0,h.$Jl.isHandled(x)),x}}async function k(U,D,M){const z=await a(U,(0,y.$Rg)(),null);return await o(z,{host:D,port:M},L.CancellationToken.None)}function P(U){return(0,A.$ih)(D=>new Promise((M,z)=>{const x=setTimeout(M,U*1e3);D.onCancellationRequested(()=>{clearTimeout(x),M()})}))}var I;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(I||(e.PersistentConnectionEventType=I={}));class F{constructor(D,M){this.reconnectionToken=D,this.millisSinceLastIncomingData=M,this.type=0}}e.$Sl=F;class T{constructor(D,M,z,x){this.reconnectionToken=D,this.millisSinceLastIncomingData=M,this.durationSeconds=z,this.c=x,this.type=1}skipWait(){this.c.cancel()}}e.$Tl=T;class q{constructor(D,M,z){this.reconnectionToken=D,this.millisSinceLastIncomingData=M,this.attempt=z,this.type=2}}e.$Ul=q;class X{constructor(D,M,z){this.reconnectionToken=D,this.millisSinceLastIncomingData=M,this.attempt=z,this.type=4}}e.$Vl=X;class G{constructor(D,M,z,x){this.reconnectionToken=D,this.millisSinceLastIncomingData=M,this.attempt=z,this.handled=x,this.type=3}}e.$Wl=G;class Q extends R.$Vc{static triggerPermanentFailure(D,M,z){this._permanentFailure=!0,this.f=D,this.g=M,this.h=z,this.j.forEach(x=>x.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(D=>D.y())}static debugPauseSocketWriting(){this.j.forEach(D=>D.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Q._permanentFailure}constructor(D,M,z,x,K){super(),this.t=D,this.u=M,this.reconnectionToken=z,this.protocol=x,this.w=K,this.m=this.B(new O.$ee),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new X(this.reconnectionToken,0,0)),this.B(x.onSocketClose(ee=>{const _=he(this.t,this.reconnectionToken,!0);ee?ee.type===0?(this.u.logService.info(`${_} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.u.logService.error(ee.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.u.logService.error(ee.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(x.onSocketTimeout(ee=>{const _=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.y()})),Q.j.push(this),this.B((0,R.$Tc)(()=>{const ee=Q.j.indexOf(this);ee>=0&&Q.j.splice(ee,1)})),this.n&&this.D(Q.f,Q.g,Q.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const D=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${D} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const x=z<M.length?M[z]:M[M.length-1];try{if(x>0){const ee=P(x);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x,ee)),this.u.logService.info(`${D} waiting for ${x} seconds before reconnecting...`);try{await ee}catch{}}if(this.n){this.u.logService.error(`${D} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this.u.logService.info(`${D} resolving connection...`);const K=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${D} connecting to ${K.connectTo}...`),await this.G(K,l(c)),this.u.logService.info(`${D} reconnected!`),this.m.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${D} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this.u.logService.error(`${D} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(h.$Jl.isTemporarilyNotAvailable(K)){this.u.logService.info(`${D} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this.u.logService.info(`${D} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((0,j.$4)(K)){this.u.logService.info(`${D} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if(K instanceof h.$Jl){this.u.logService.error(`${D} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,h.$Jl.isHandled(K));break}this.u.logService.error(`${D} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!this.n&&!this.s)}C(D,M,z){this.w?Q.triggerPermanentFailure(D,M,z):this.D(D,M,z)}D(D,M,z){this.m.fire(new G(this.reconnectionToken,D,M,z)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Xl=Q;class W extends Q{constructor(D,M,z,x,K){super(1,D,x,K,!0),this.client=this.B(new w.$hi(K,{remoteAuthority:M,clientId:z},D.ipcLogger))}async G(D,M){await s(D,M)}}e.$Yl=W;class J extends Q{constructor(D,M,z,x,K){super(2,D,z,x,!1),this.H=M,this.debugPort=K}async G(D,M){await i(D,this.H,M)}}e.$Zl=J;function H(U){try{U.acceptDisconnect();const D=U.getSocket();U.dispose(),D.dispose()}catch(D){(0,j.$1)(D)}}function B(U){if(U&&U.type==="error"){const D=new Error(`Connection error: ${U.reason}`);return D.code="VSCODE_CONNECTION_ERROR",D}return null}function ie(U,D){for(;U.length<D;)U+=" ";return U}function re(U,D){return`[remote-connection][${ie(g(U),13)}][${D.substr(0,5)}\u2026]`}function he(U,D,M){return`${re(U,D)}[${M?"reconnect":"initial"}]`}function te(U,D){return`${he(D,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.connectTo}]`}function V(U){return`${Date.now()-U} ms`}}),define(ae[102],ce([0,1,23]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=N,e.$Hm=L,e.$Im=j,e.$Jm=O;function N(C){return C.scheme===A.Schemas.vscodeRemote?C.authority:void 0}function L(C){if(!C)return;const f=C.indexOf("+");return f<0?C:C.substr(0,f)}function j(C){const{host:f,port:E}=R(C);if(typeof E>"u")throw new Error(`Invalid remote authority: ${C}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:f,port:E}}function O(C,f){let{host:E,port:y}=R(C);return typeof y>"u"&&(y=f),{host:E,port:y}}function R(C){const f=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(f)return{host:f[1],port:parseInt(f[2],10)};const E=C.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const y=C.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:C,port:void 0}}}),define(ae[48],ce([0,1,27,4,102]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Sm=e.$Rm=e.$Qm=e.TargetPlatform=e.ExtensionType=e.$Pm=e.$Nm=e.$Mm=e.$Lm=e.$Km=void 0,e.$Om=j,e.$Tm=y,e.$Um=w,e.$Vm=h,e.$Wm=c,e.$Km="extensions.user.cache",e.$Lm="extensions.builtin.cache",e.$Mm="undefined_publisher",e.$Nm=["ui","workspace","web"];function j(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$Pm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var O;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(O||(e.ExtensionType=O={}));var R;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class C{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,l){if(typeof g>"u"||g===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof g=="string"||typeof l=="string"){const u=typeof g=="string"?g:g.value,m=typeof l=="string"?l:l.value;return A.$xf(u,m)}return g._lower===l._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Qm=C;class f{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const l of g)this.add(l)}add(g){this.c.add(C.toKey(g))}delete(g){return this.c.delete(C.toKey(g))}has(g){return this.c.has(C.toKey(g))}}e.$Rm=f;class E{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(C.toKey(g))}get(g){return this.c.get(C.toKey(g))}has(g){return this.c.has(C.toKey(g))}set(g,l){this.c.set(C.toKey(g),l)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Sm=E;function y(p){return w(p)}function w(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}function h(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}function c(p,g){if(g){const l=`onResolveRemoteAuthority:${(0,L.$Hm)(g)}`;return!!p.activationEvents?.includes(l)}return!1}e.$Xm=(0,N.$vi)("IBuiltinExtensionsScannerService")}),define(ae[221],ce([0,1,2,48,12]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;class j extends A.$Vc{constructor(R,C,f,E,y){super(),this.a=R,this.b=C,this.c=f,this.f=y,this.B(E.onDidInstallExtensions(w=>this.g(w))),this.B(E.onDidUninstallExtension(w=>this.h(w)))}g(R){for(const C of R)C.local&&this.invalidate(C.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const C of this.a.profiles)this.c.extUri.isEqual(C.extensionsResource,R)&&await this.j(C);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,N.$Km))}catch(C){(0,L.$gl)(C)!==1&&this.f.error(C)}}}e.$Aq=j}),define(ae[103],ce([0,1,2,4]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=void 0,e.$Ll=(0,N.$vi)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(O,R){return this.a[O]??=[],this.a[O].push(R),(0,A.$Tc)(()=>{const C=this.a[O]?.indexOf(R);typeof C=="number"&&C>=0&&this.a[O]?.splice(C,1)})}b(O){return(this.a[O.type]||[]).find(C=>C.supports(O))}connect(O,R,C,f){const E=this.b(O);if(!E)throw new Error(`No socket factory found for ${O}`);return E.connect(O,R,C,f)}}e.$Ml=L}),define(ae[222],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=e.$eec=void 0,e.$eec=(0,A.$vi)("sharedProcessTunnelService"),e.$fec="sharedProcessTunnel"}),define(ae[104],ce([0,1,4,169]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=e.$oec=e.$nec=e.$mec=e.$lec=e.TunnelStates=e.$kec=e.$jec=void 0,e.$jec=(0,A.$vi)("IRemoteTunnelService"),e.$kec={active:!1};var L;(function(j){j.disconnected=O=>({type:"disconnected",onTokenFailed:O}),j.connected=(O,R)=>({type:"connected",info:O,serviceInstallFailed:R}),j.connecting=O=>({type:"connecting",progress:O}),j.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.$lec="remote.tunnels.access",e.$mec=e.$lec+".hostNameOverride",e.$nec=e.$lec+".preventSleep",e.$oec="remoteTunnelService",e.$pec=(0,N.localize)(0,null)}),define(ae[59],ce([0,1,15,7,2,171,47,4,9,43]),function(ne,e,A,N,L,j,O,R,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=e.$Mp=void 0,e.$Op=w,e.$Pp=h,e.$Qp=c,e.$Rp=p,e.$Sp=g,e.$Tp=l,e.$Mp=(0,R.$vi)("requestService");class E{constructor($){this.b=$}toJSON(){if(!this.a){const $=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?$[t]="*****":$[t]=this.b[t];this.a=$}return this.a}}class y extends L.$Vc{constructor($){super(),this.b=0,this.a=$.createLogger("network",{name:(0,j.localize)(0,null),when:C.$hk.isEqualTo((0,C.$ek)(C.LogLevel.Trace)).serialize()})}async c($,t,r){const n=`${$} #${++this.b}: ${t.url}`;this.a.trace(`${n} - begin`,t.type,new E(t.headers??{}));try{const s=await r();return this.a.trace(`${n} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,t.type,(0,N.$0)(s)),s}}}e.$Np=y;function w(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}function h(d){return d.res.statusCode===204}async function c(d){return h(d)?null:(await(0,A.$Re)(d.stream)).toString()}async function p(d){if(!w(d))throw new Error("Server returned "+d.res.statusCode);return c(d)}async function g(d){if(!w(d))throw new Error("Server returned "+d.res.statusCode);if(h(d))return null;const t=(await(0,A.$Re)(d.stream)).toString();try{return JSON.parse(t)}catch(r){throw r.message+=`:
`+t,r}}function l(d){m(d)}let u;function m(d){const $=f.$bo.as(O.$go.Configuration),t=u;u={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},$.updateConfigurations({add:[u],remove:t?[t]:[]})}m(1)}),define(ae[223],ce([0,1,26,23,12,59]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Q=void 0;let O=class{constructor(C,f){this.a=C,this.b=f}async download(C,f,E=A.CancellationToken.None){if(C.scheme===N.Schemas.file||C.scheme===N.Schemas.vscodeRemote){await this.b.copy(C,f);return}const y={type:"GET",url:C.toString(!0)},w=await this.a.request(y,E);if(w.res.statusCode===200)await this.b.writeFile(f,w.stream);else{const h=await(0,j.$Rp)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${h}`)}}};e.$2Q=O,e.$2Q=O=Ee([Z(0,j.$Mp),Z(1,L.$2k)],O)}),define(ae[224],ce([0,1,15,26]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=e.$Tr=void 0;class L{constructor(R){this.a=R}listen(R,C){throw new Error("Invalid listen")}call(R,C,f,E=N.CancellationToken.None){switch(C){case"request":return this.a.request(f[0],E).then(async({res:y,stream:w})=>{const h=await(0,A.$Re)(w);return[{statusCode:y.statusCode,headers:y.headers},h]});case"resolveProxy":return this.a.resolveProxy(f[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Tr=L;class j{constructor(R){this.a=R}async request(R,C){const[f,E]=await this.a.call("request",[R],C);return{res:f,stream:(0,A.$Te)(E)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Ur=j}),define(ae[225],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=e.$Icc=void 0,e.$Icc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Jcc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Kcc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[226],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C$b=void 0;class A{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const j=await this.c();if(j){const O=String(A.a++);return this.b.set(O,j),{id:O,data:j.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,j){if(!L.id)return!0;const O=this.b.get(L.id);if(!O)return!1;this.b.delete(L.id);try{return O.validate(j)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$C$b=A}),define(ae[105],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=void 0,e.$Nl="signService",e.$Ol=(0,A.$vi)(e.$Nl)}),define(ae[227],ce([0,1,226]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;class N extends A.$C$b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(O=>new O.signer().sign(j))}h(){return new Promise((j,O)=>ne(["vsda"],j,O))}}e.$ydc=N}),define(ae[77],ce([0,1,3,2]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zKb=e.$yKb=e.$xKb=e.$wKb=void 0;class L extends N.$Vc{constructor(y,w,h){super(),this.a=y,this.b=w,this.c=h}async getItems(){const y={profile:this.b,workspace:this.c},w=await this.a.call("getItems",y);return new Map(w)}updateItems(y){const w={profile:this.b,workspace:this.c};return y.insert&&(w.insert=Array.from(y.insert.entries())),y.delete&&(w.delete=Array.from(y.delete.values())),this.a.call("updateItems",w)}optimize(){const y={profile:this.b,workspace:this.c};return this.a.call("optimize",y)}}class j extends L{constructor(y,w){super(y,w,void 0),this.f=this.B(new A.$ee),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(y=>this.h(y)))}h(y){(Array.isArray(y.changed)||Array.isArray(y.deleted))&&this.f.fire({changed:y.changed?new Map(y.changed):void 0,deleted:y.deleted?new Set(y.deleted):void 0})}}class O extends j{constructor(y){super(y,void 0)}async close(){this.dispose()}}e.$wKb=O;class R extends j{constructor(y,w){super(y,w)}async close(){this.dispose()}}e.$xKb=R;class C extends L{constructor(y,w){super(y,void 0,w),this.onDidChangeItemsExternal=A.Event.None}async close(){this.dispose()}}e.$yKb=C;class f{constructor(y){this.a=y}isUsed(y){const w={payload:y,profile:void 0,workspace:void 0};return this.a.call("isUsed",w)}}e.$zKb=f}),define(ae[106],ce([0,1,5,36,32]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=O,e.$dp=R;function j(C){if(A.$u===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}function O(C,f,E,y,w,h,c,p,g){const l=Object.create(null);l["common.machineId"]=h,l["common.sqmId"]=c,l.sessionID=(0,L.$Rg)()+Date.now(),l.commitHash=y,l.version=w,l["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,A.$h)(A.$u),l["common.nodePlatform"]=N.$ec,l["common.nodeArch"]=E,l["common.product"]=g||"desktop",p&&(l["common.msftInternal"]=p);let u=0;const m=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),A.$l&&(l["common.snap"]="true");const d=j(f);return d&&(l["common.platformDetail"]=d),l}function R(C){const f=N.env.USERDNSDOMAIN;if(!f)return!1;const E=f.toLowerCase();return C.some(y=>E===y)}}),define(ae[22],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=void 0,e.$1l=(0,A.$vi)("telemetryService"),e.$2l=(0,A.$vi)("customEndpointTelemetryService"),e.$3l="telemetry.currentSessionDate",e.$4l="telemetry.firstSessionDate",e.$5l="telemetry.lastSessionDate",e.$6l="telemetry.machineId",e.$7l="telemetry.sqmId",e.$8l="telemetry",e.$9l="telemetry.telemetryLevel",e.$0l="telemetry.enableCrashReporter",e.$$l="telemetry.enableTelemetry";var N;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ae[228],ce([0,1,37,6,35,23,14,5,8,144,31,150,94,12,24,22]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=void 0,e.$Ds=l,e.$Es=m,e.$Fs=d;const g=new Map;async function l(t,r){const n=`${t}::${r.join(":")}`,s=g.get(n);if(s)return s;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,a=new Map,b=2e4;function S(k,P,I,F){const T=P.substring(k.length+1);return N.Promises.withAsyncBody(async q=>{let X;try{X=await E.Promises.readdir(P,{withFileTypes:!0})}catch{q();return}if(F.count>=b){F.count+=X.length,F.maxReached=!0,q();return}let G=X.length;if(G===0){q();return}let Q=X;F.count+X.length>b&&(F.maxReached=!0,G=b-F.count,Q=X.slice(0,G)),F.count+=X.length;for(const W of Q)if(W.isDirectory()){if(I.includes(W.name)||await S(k,(0,O.$kc)(P,W.name),I,F),--G===0){q();return}}else{const J=W.name.lastIndexOf(".");if(J>=0){const H=W.name.substring(J+1);H&&o.set(H,(o.get(H)??0)+1)}for(const H of i)H.relativePathPattern?.test(T)!==!1&&H.filePattern.test(W.name)&&a.set(H.tag,(a.get(H.tag)??0)+1);if(--G===0){q();return}}})}const v=N.Promises.withAsyncBody(async k=>{const P={count:0,maxReached:!1};await S(t,t,r,P);const I=await d(t);k({configFiles:u(a),fileTypes:u(o),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:I})});return g.set(n,v),v}function u(t){return Array.from(t.entries(),([r,n])=>({name:r,count:n})).sort((r,n)=>n.count-r.count)}function m(){const t={os:`${A.type()} ${A.arch()} ${A.release()}`,memory:`${(A.totalmem()/h.$xl.GB).toFixed(2)}GB (${(A.freemem()/h.$xl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(f.$Dn.value()*100)}%`},r=A.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}async function d(t){try{const r=new Map,n=(0,O.$kc)(t,".vscode","launch.json"),s=await E.Promises.readFile(n),i=[],o=(0,L.$In)(s.toString(),i);if(i.length)return console.log(`Unable to parse ${n}`),[];if((0,L.$Rn)(o)==="object"&&o.configurations)for(const a of o.configurations){const b=a.type;b&&(r.has(b)?r.set(b,r.get(b)+1):r.set(b,1))}return u(r)}catch{return[]}}let $=class{constructor(r,n){this.c=r,this.d=n}f(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}g(r){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${A.type()} ${A.arch()} ${A.release()}`);const s=A.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(A.totalmem()/h.$xl.GB).toFixed(2)}GB (${(A.freemem()/h.$xl.GB).toFixed(2)}GB free)`),R.$i||n.push(`Load (avg):       ${A.loadavg().map(i=>Math.round(i)).join(", ")}`),n.push(`VM:               ${Math.round(f.$Dn.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,y.$Cs)(r.mainPID),this.k(r)]).then(async s=>{let[i,o]=s,a=this.m(r,i);return n.forEach(b=>{if((0,w.$dn)(b))a+=`
${b.errorMessage}`,o+=`
${b.errorMessage}`;else if(a+=`

Remote: ${b.hostName}`,b.processes&&(a+=`
${this.m(r,b.processes)}`),b.workspaceMetadata){o+=`
|  Remote: ${b.hostName}`;for(const S of Object.keys(b.workspaceMetadata)){const v=b.workspaceMetadata[S];let k=`${v.fileCount} files`;v.maxFilesReached&&(k=`more than ${k}`),o+=`|    Folder (${S}): ${k}`,o+=this.h(v)}}}),{processInfo:a,workspaceInfo:o}})}async getSystemInfo(r,n){const{memory:s,vmHint:i,os:o,cpus:a}=m(),b={os:o,memory:s,cpus:a,vmHint:i,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return R.$i||(b.load=`${A.loadavg().map(S=>Math.round(S)).join(", ")}`),R.$k&&(b.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(b)}async getDiagnostics(r,n){const s=[];return(0,y.$Cs)(r.mainPID).then(async i=>(s.push(""),s.push(this.g(r)),s.push(""),s.push(this.m(r,i)),r.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(r))),n.forEach(o=>{if((0,w.$dn)(o))s.push(`
${o.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${o.hostName}`),s.push(this.f(o.machineInfo)),o.processes&&s.push(this.m(r,o.processes)),o.workspaceMetadata)for(const a of Object.keys(o.workspaceMetadata)){const b=o.workspaceMetadata[a];let S=`${b.fileCount} files`;b.maxFilesReached&&(S=`more than ${S}`),s.push(`Folder (${a}): ${S}`),s.push(this.h(b))}}),s.push(""),s.push(""),s.join(`
`)))}h(r){const n=[];let i=0;const o=(v,k)=>{const P=` ${v}(${k})`;i+P.length>60?(n.push(a),a="|                 ",i=a.length):i+=P.length,a+=P};let a="|      File types:";const b=10,S=r.fileTypes.length>b?b:r.fileTypes.length;for(let v=0;v<S;v++){const k=r.fileTypes[v];o(k.name,k.count)}if(n.push(a),r.configFiles.length>=0&&(a="|      Conf files:",i=0,r.configFiles.forEach(v=>{o(v.name,v.count)}),n.push(a)),r.launchConfigFiles.length>0){let v="|      Launch Configs:";r.launchConfigFiles.forEach(k=>{const P=k.count>1?` ${k.name}(${k.count})`:` ${k.name}`;v+=P}),n.push(v)}return n.join(`
`)}j(r){const n=Math.max(...Object.keys(r).map(s=>s.length));return Object.keys(r).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${r[s]}`).join(`
                  `)}k(r){const n=[],s=[];return r.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(n.push(`|  Window (${i.title})`),i.folderURIs.forEach(o=>{const a=C.URI.revive(o);if(a.scheme===j.Schemas.file){const b=a.fsPath;s.push(l(b,["node_modules",".git"]).then(S=>{let v=`${S.fileCount} files`;S.maxFilesReached&&(v=`more than ${v}`),n.push(`|    Folder (${(0,O.$oc)(b)}): ${v}`),n.push(this.h(S))}).catch(S=>{n.push(`|      Error: Unable to collect workspace stats for folder ${b} (${S.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(i=>n.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(r,n){const s=new Map;r.windows.forEach(o=>s.set(o.pid,`window [${o.id}] (${o.title})`)),r.pidToNames.forEach(({pid:o,name:a})=>s.set(o,a));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),n&&this.n(r.mainPID,s,i,n,0),i.join(`
`)}n(r,n,s,i,o){const a=o===0;let b;a?b=i.pid===r?`${this.d.applicationName} main`:"remote agent":n.has(i.pid)?b=n.get(i.pid):b=`${"  ".repeat(o)} ${i.name}`;const S=process.platform==="win32"?i.mem:A.totalmem()*(i.mem/100);s.push(`${i.load.toFixed(0).padStart(5," ")}	${(S/h.$xl.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${b}`),Array.isArray(i.children)&&i.children.forEach(v=>this.n(r,n,s,v,o+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:s}of r.folders){const i=C.URI.revive(s);if(i.scheme!==j.Schemas.file)continue;const o=i.fsPath;try{(await l(o,["node_modules",".git"])).fileTypes.forEach(b=>n.add(b.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const s=C.URI.revive(n);if(s.scheme!==j.Schemas.file)continue;const i=s.fsPath;try{const o=await l(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),o.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),o.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),o.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$Gs=$,e.$Gs=$=Ee([Z(0,p.$1l),Z(1,c.$ik)],$)}),define(ae[107],ce([0,1,7,4,9,22]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=e.ExtensionSignatureVerificationCode=e.$$p=void 0,e.$$p=(0,N.$vi)("IExtensionSignatureVerificationService");var O;(function(f){f.None="None",f.RequiredArgumentMissing="RequiredArgumentMissing",f.InvalidArgument="InvalidArgument",f.PackageIsUnreadable="PackageIsUnreadable",f.UnhandledException="UnhandledException",f.SignatureManifestIsMissing="SignatureManifestIsMissing",f.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",f.SignatureIsMissing="SignatureIsMissing",f.SignatureIsUnreadable="SignatureIsUnreadable",f.CertificateIsUnreadable="CertificateIsUnreadable",f.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",f.FileAlreadyExists="FileAlreadyExists",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",f.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",f.Success="Success",f.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",f.SignatureIsInvalid="SignatureIsInvalid",f.SignatureManifestIsInvalid="SignatureManifestIsInvalid",f.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",f.EntryIsMissing="EntryIsMissing",f.EntryIsTampered="EntryIsTampered",f.Untrusted="Untrusted",f.CertificateRevoked="CertificateRevoked",f.SignatureIsNotValid="SignatureIsNotValid",f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(O||(e.ExtensionSignatureVerificationCode=O={}));class R extends Error{constructor(E){super(E),this.code=E}}e.$_p=R;let C=class{constructor(E,y){this.b=E,this.c=y}d(){return this.a||(this.a=new Promise((E,y)=>ne(["@vscode/vsce-sign"],async w=>E(w),y))),this.a}async verify(E,y,w){let h;try{h=await this.d()}catch(l){return this.b.error("Could not load vsce-sign module",(0,A.$0)(l)),this.b.info(`Extension signature verification is not done: ${E}`),!1}const c=new Date().getTime();let p;try{p=await h.verify(y,w,this.b.getLevel()===L.LogLevel.Trace)}catch(l){p={code:"UnknownError",didExecute:!1,output:(0,A.$0)(l)}}const g=new Date().getTime()-c;if(this.b.info(`Extension signature verification result for ${E}: ${p.code}. Duration: ${g}ms.`),this.b.trace(`Extension signature verification output for ${E}:
${p.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:E,code:p.code,duration:g,didExecute:p.didExecute}),p.code==="Success")return!0;throw new R(p.code)}};e.$aq=C,e.$aq=C=Ee([Z(0,L.$2j),Z(1,j.$1l)],C)}),define(ae[108],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=e.$Ncc=void 0;class A{constructor(j){this.b=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,{eventName:R,data:C}){return this.b.forEach(f=>f.log(R,C)),Promise.resolve(null)}}e.$Ncc=A;class N{constructor(j){this.b=j}log(j,O){return this.b.call("log",{eventName:j,data:O}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Occ=N}),define(ae[49],ce([0,1,30,13,102,106,22]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=void 0,e.$lp=E,e.$mp=y,e.$np=w,e.$op=h,e.$pp=p,e.$qp=l,e.$rp=u,e.$sp=$;class R{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$ep=R;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$fp=C,e.$gp=new C;class f{async publicLog(r,n,s){}async publicLogError(r,n,s){}}e.$hp=f,e.$ip="telemetry",e.$jp="extensionTelemetryLog",e.$kp={log:()=>null,flush:()=>Promise.resolve(null)};function E(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry)}function y(t,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function w(t){const r=t.getValue(O.$9l),n=t.getValue(O.$0l);if(t.getValue(O.$$l)===!1||n===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function h(t){const r={},n={},s={};g(t,s);for(let i in s){i=i.length>150?i.substr(i.length-149):i;const o=s[i];typeof o=="number"?n[i]=o:typeof o=="boolean"?n[i]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${o.length}`),r[i]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[i]=o)}return{properties:r,measurements:n}}const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(t){if(!t)return"none";const r=(0,L.$Hm)(t);return c.has(r)?r:"other"}function g(t,r,n=0,s){if(t)for(const i of Object.getOwnPropertyNames(t)){const o=t[i],a=s?s+i:i;Array.isArray(o)?r[a]=(0,A.$7n)(o):o instanceof Date?r[a]=o.toISOString():(0,N.$0f)(o)?n<2?g(o,r,n+1,a+"."):r[a]=(0,A.$7n)(o):r[a]=o}}function l(t,r){const n=t.msftInternalDomains||[],s=r.getValue("telemetry.internalTesting");return(0,j.$dp)(n)||s}function u(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function m(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let n=t;const s=[];for(const b of r)for(;;){const S=b.exec(t);if(!S)break;s.push([S.index,b.lastIndex])}const i=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const b=o.exec(t);if(!b)break;const S=s.some(([v,k])=>b.index<k&&v<o.lastIndex);!i.test(b[0])&&!S&&(n+=t.substring(a,b.index)+"<REDACTED: user-file-path>",a=o.lastIndex)}return a<t.length&&(n+=t.substr(a)),n}function d(t){if(!t)return t;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of r)if(n.regex.test(t))return`<REDACTED: ${n.label}>`;return t}function $(t,r){return(0,A.$4n)(t,n=>{if(n instanceof R||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=m(s,r);for(const i of r)s=s.replace(i,"");return s=d(s),s}})}}),define(ae[33],ce([0,1,27,29,48,5,8,7,36,49]),function(ne,e,A,N,L,j,O,R,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$up=void 0,e.$tp=E,e.$vp=c,e.$wp=p,e.$xp=g,e.$yp=l,e.$zp=u,e.$Ap=m,e.$Bp=d,e.$Dp=$,e.$Ep=r;function E(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,A.$sf)(n.id,s.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(s){const i=s.manifest?s.manifest.version:s.version,o=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new w(s.identifier,i,o)}static parse(s){const i=y.exec(s);return i&&i[1]&&i[2]?new w({id:i[1]},i[2],i[4]||void 0):null}constructor(s,i,o="undefined"){this.version=i,this.targetPlatform=o,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof w?E(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$up=w;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function c(n){const s=h.exec(n);return s&&s[1]?[g(s[1]),s[2]]:[g(n),void 0]}function p(n,s){return`${n}.${s}`}function g(n){return n.toLowerCase()}function l(n,s){return g(p(n??L.$Mm,s))}function u(n,s){const i=[],o=a=>{for(const b of i)if(b.some(S=>E(s(S),s(a))))return b;return null};for(const a of n){const b=o(a);b?b.push(a):i.push([a])}return i}function m(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function d(n){return{id:new f.$ep(n.identifier.id),name:new f.$ep(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Cp=new L.$Qm("pprice.better-merge");function $(n,s){const i=[],o=s.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&i.every(b=>!E(b.identifier,{id:a}))){const b=n.filter(S=>E(S.identifier,{id:a}));b.length===1&&(i.push(b[0]),o.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}async function t(n,s){if(!j.$k)return!1;let i;try{i=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,R.$0)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(n,s){const i=await t(n,s),o=(0,N.$1o)(i?"alpine":j.$u,C.$fc);return s.debug("ComputeTargetPlatform:",o),o}}),define(ae[229],ce([0,1,17,2,20,8,12,24,6,3,14,5,36,33]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mac=e.$Lac=void 0;let c=class extends N.$Vc{constructor(m,d){super(),this.b=m,this.c=d,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,$])=>this.a.set($.configPath,$))}getConfigBasedTips(m){return this.f(m)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(m){const d=[];for(const[$,t]of this.a)if(!(t.configScheme&&t.configScheme!==m.scheme))try{const r=(await this.b.readFile((0,L.$9g)(m,$))).value.toString();for(const[n,s]of Object.entries(t.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(r))&&d.push({extensionId:n,extensionName:s.name,configName:t.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return d}};e.$Lac=c,e.$Lac=c=Ee([Z(0,O.$2k),Z(1,R.$ik)],c);const p="extensionTips/promptedExecutableTips",g="extensionTips/lastPromptedMediumImpExeTime";class l extends c{constructor(m,d,$,t,r,n,s,i){super(s,i),this.r=m,this.s=d,this.t=$,this.u=t,this.w=r,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([o,a])=>{const b=[],S=[],v=[];Object.entries(a.recommendations).forEach(([k,P])=>{P.important?a.important?b.push({extensionId:k,extensionName:P.name,isExtensionPack:!!P.isExtensionPack}):S.push({extensionId:k,extensionName:P.name,isExtensionPack:!!P.isExtensionPack}):v.push({extensionId:k,extensionName:P.name,isExtensionPack:!!P.isExtensionPack})}),b.length&&this.g.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:b}),S.length&&this.h.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:S}),v.length&&this.j.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v})}),(0,C.$xh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const m=await this.O(this.g),d=await this.O(this.h);return[...m,...d]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const m=await this.O(this.g),d=await this.O(this.h),$=await this.u.getInstalled();this.m=this.D(m,$),this.n=this.D(d,$)}D(m,d){const $=new Map;m.forEach(i=>$.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:r}=this.N([...$.keys()],d);for(const i of t){const o=$.get(i);o&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:o.exeName})}for(const i of r){const o=$.get(i);o&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:o.exeName})}const n=this.L(),s=new Map;for(const i of r){const o=$.get(i);if(o&&(!n[o.exeName]||!n[o.exeName].includes(o.extensionId))){let a=s.get(o.exeName);a||(a=[],s.set(o.exeName,a)),a.push(o)}}return s}F(){if(this.m.size===0)return;const[m,d]=[...this.m.entries()][0];this.H(d).then($=>{switch($){case"reacted":this.M(d[0].exeName,d);break;case"ignored":this.m.delete(m);break;case"incompatibleWindow":{const t=f.Event.once(f.Event.latch(f.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(t(()=>this.F()));break}case"toomany":{const t=this.B(new N.$Wc);t.value=(0,C.$xh)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const m=this.I(),d=Date.now()-m,$=7*24*60*60*1e3;if(d<$){const n=this.B(new N.$Wc);n.value=(0,C.$xh)(()=>{n.dispose(),this.G()},$-d);return}const[t,r]=[...this.n.entries()][0];this.H(r).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(t),this.M(r[0].exeName,r);const s=this.B(new N.$Wc);s.value=(0,C.$xh)(()=>{s.dispose(),this.G()},$);break}case"ignored":this.n.delete(t),this.G();break;case"incompatibleWindow":{const s=f.Event.once(f.Event.latch(f.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new N.$Wc);s.value=(0,C.$xh)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H(m){const d=await this.u.getInstalled(1),$=m.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(r=>d.every(n=>!(0,h.$tp)(n.identifier,{id:r})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:$,source:3,name:m[0].exeFriendlyName,searchValue:`@exe:"${m[0].exeName}"`})}I(){let m=this.w.getNumber(g,-1);return m||(m=Date.now(),this.J(m)),m}J(m){this.w.store(g,m,-1,1)}L(){return JSON.parse(this.w.get(p,-1,"{}"))}M(m,d){const $=this.L();$[m]=d.map(({extensionId:t})=>t.toLowerCase()),this.w.store(p,JSON.stringify($),-1,0)}N(m,d){const $=[],t=[],r=d.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return m.forEach(n=>{r.has(n.toLowerCase())?$.push(n):t.push(n)}),{installed:$,uninstalled:t}}async O(m){const d=[],$=new Map;for(const t of m.keys()){const r=m.get(t);if(!r||!(0,A.$Lb)(r.recommendations))continue;const n=[];y.$i?r.windowsPath&&n.push(r.windowsPath.replace("%USERPROFILE%",()=>w.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>w.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>w.env.ProgramFiles).replace("%APPDATA%",()=>w.env.APPDATA).replace("%WINDIR%",()=>w.env.WINDIR)):(n.push((0,E.$kc)("/usr/local/bin",t)),n.push((0,E.$kc)("/usr/bin",t)),n.push((0,E.$kc)(this.r.fsPath,t)));for(const s of n){let i=$.get(s);if(i===void 0&&(i=await this.b.exists(j.URI.file(s)),$.set(s,i)),i)for(const{extensionId:o,extensionName:a,isExtensionPack:b,whenNotInstalled:S}of r.recommendations)d.push({extensionId:o,extensionName:a,isExtensionPack:b,exeName:t,exeFriendlyName:r.exeFriendlyName,windowsPath:r.windowsPath,whenNotInstalled:S})}}return d}}e.$Mac=l}),define(ae[230],ce([0,1,26,33]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z4b=L;async function L(j,O,R,C,f){try{const E=await j.getExtensionsControlManifest();if(!E.deprecated)return;const y=await j.getInstalled(1);for(const[w,h]of Object.entries(E.deprecated)){if(!h?.extension)continue;const{id:c,autoMigrate:p,preRelease:g}=h.extension;if(!p)continue;const l=y.find(m=>(0,N.$tp)(m.identifier,{id:w}));if(!l)continue;const u=(await O.getExtensions([{id:c,preRelease:g}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0];if(!u){f.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${c}' extension is not found`);continue}try{f.info(`Migrating '${l.identifier.id}' extension to '${c}' extension...`);const m=!C.getDisabledExtensions().some($=>(0,N.$tp)($,l.identifier));await j.uninstall(l),f.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let d=y.find($=>(0,N.$tp)($.identifier,{id:c}));(!d||!d.isPreReleaseVersion&&m)&&(d=await j.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),f.info(`Installed the pre-release extension '${d.identifier.id}'`),m||(await C.disableExtension(d.identifier),f.info(`Disabled the pre-release extension '${d.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),p.storage&&(R.addToMigrationList((0,N.$wp)(l.manifest.publisher,l.manifest.name),(0,N.$wp)(d.manifest.publisher,d.manifest.name)),f.info("Added pre-release extension to the storage migration list"))),f.info(`Migrated '${l.identifier.id}' extension to '${c}' extension.`)}catch(m){f.error(m)}}}catch(E){f.error(E)}}}),define(ae[231],ce([0,1,6,7,2,23,20,55,13,32,31,70,21,16,29,33,107,12,9]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=void 0;let d=class extends L.$Vc{static{m=this}static{this.c=".sigzip"}constructor(t,r,n,s,i,o){super(),this.h=r,this.j=n,this.m=s,this.n=i,this.r=o,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,r,n){await this.g;const s=(0,O.$9g)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,s,o=>this.j.download(t,o,r))}catch(o){throw new c.$6o(o.message,c.ExtensionManagementErrorCode.Download)}let i=!1;if(n&&this.t(t)){const o=await this.u(t);try{i=await this.n.verify(t.identifier.id,s.fsPath,o.fsPath)}catch(a){if(i=a.code,i==="PackageIsInvalidZip"||i==="SignatureArchiveIsInvalidZip"){try{await this.delete(s)}catch(S){this.r.error(S)}throw new c.$6o(y.$fq,c.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(a){this.r.error(a)}}}return{location:s,verificationStatus:i}}t(t){if(!t.isSigned)return this.r.info(`Extension is not signed: ${t.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,C.$bg)(r)?r:!0}async u(t){await this.g;const r=(0,O.$9g)(this.extensionsDownloadDir,`${this.z(t)}${m.c}`);try{await this.w(t,r,n=>this.j.downloadSignatureArchive(t,n))}catch(n){throw new c.$6o(n.message,c.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(t,r,n){if(await this.h.exists(r))return;if(r.scheme!==j.Schemas.file){await n(r);return}const s=(0,O.$9g)(this.extensionsDownloadDir,`.${(0,f.$Rg)()}`);await this.h.exists(s)||await n(s);try{await E.Promises.rename(s.fsPath,r.fsPath,2*60*1e3)}catch(i){try{await this.h.del(s)}catch{}if(i.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,N.$0)(i)}. Deleted the file from downloaded location`,s.path),i}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const r=[],n=[],s=[];for(const a of t.children)if(a.name.endsWith(m.c))s.push(a.resource);else{const b=p.$up.parse(a.name);b&&n.push([b,a])}const i=(0,p.$zp)(n,([a])=>a),o=[];for(const a of i)a.sort((b,S)=>R.rcompare(b[0].version,S[0].version)),r.push(...a.slice(1).map(b=>b[1].resource)),o.push(a[0][1]);o.sort((a,b)=>a.mtime-b.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(a=>a.resource)),r.push(...s),await A.Promises.settled(r.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(t){this.r.error(t)}}z(t){return this.f?p.$up.create(t).toString().toLowerCase():(0,f.$Rg)()}};e.$xq=d,e.$xq=d=m=Ee([Z(0,h.$Di),Z(1,l.$2k),Z(2,c.$5o),Z(3,w.$2i),Z(4,g.$$p),Z(5,u.$2j)],d)}),define(ae[232],ce([0,1,3,2,34,33,48]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class R extends N.$Vc{constructor(f,E,y,w,h,c,p){super(),this.f=f,this.g=E,this.h=y,this.j=w,this.m=h,this.n=c,this.r=p,this.a=this.B(new A.$ee),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$5c),this.s().then(null,g=>p.error(g))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(f=>this.u(f.added))),this.B(this.j.onAddExtensions(f=>this.w(f))),this.B(this.j.onDidAddExtensions(f=>this.y(f))),this.B(this.j.onRemoveExtensions(f=>this.z(f))),this.B(this.j.onDidRemoveExtensions(f=>this.C(f))),this.B(this.n.onDidFilesChange(f=>this.D(f)))}async u(f){try{f.length&&await Promise.all(f.map(E=>(this.c.set(E.id,(0,N.$Sc)(this.n.watch(this.m.extUri.dirname(E.extensionsResource)),this.n.watch(E.extensionsResource))),this.G(E.extensionsResource))))}catch(E){throw this.r.error(E),E}}async w(f){for(const E of f.extensions)this.I(this.L(E.identifier,E.version),f.profileLocation)}async y(f){for(const E of f.extensions){const y=this.L(E.identifier,E.version);f.error?this.J(y,f.profileLocation):this.I(y,f.profileLocation)}}async z(f){for(const E of f.extensions)this.J(this.L(E.identifier,E.version),f.profileLocation)}async C(f){const E=[],y=[];for(const w of f.extensions){const h=this.L(w.identifier,w.version);f.error?this.I(h,f.profileLocation):(this.J(h,f.profileLocation),this.b.has(h)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),y.push(this.f.scanInstalledExtensionAtLocation(w.location).then(c=>{c?E.push(c):this.r.info("Extension not found at the location",w.location.toString())},c=>this.r.error(c)))))}try{await Promise.all(y),E.length&&await this.H(E)}catch(w){this.r.error(w)}}D(f){for(const E of this.h.profiles)f.contains(E.extensionsResource,0,1)&&this.F(E.extensionsResource)}async F(f){const E=[],y=[],w=await this.j.scanProfileExtensions(f),h=new Set,c=new Set;for(const[p,g]of this.b)g.has(f)&&c.add(p);for(const p of w){const g=this.L(p.identifier,p.version);h.add(g),c.has(g)||(E.push(p.identifier),this.I(g,f))}for(const p of c)if(!h.has(p)){const g=this.M(p);g&&(y.push(g.identifier),this.J(p,f))}(E.length||y.length)&&this.a.fire({added:E.length?{extensions:E,profileLocation:f}:void 0,removed:y.length?{extensions:y,profileLocation:f}:void 0})}async G(f){const E=await this.j.scanProfileExtensions(f);for(const y of E)this.I(this.L(y.identifier,y.version),f)}async H(f){f||(f=(await this.f.scanAllUserInstalledExtensions()).filter(y=>!this.b.has(this.L(y.identifier,y.manifest.version)))),f.length&&await this.f.markAsUninstalled(...f)}I(f,E){let y=this.b.get(f);y||this.b.set(f,y=new L.$Cc(w=>this.m.extUri.getComparisonKey(w))),y.add(E)}J(f,E){const y=this.b.get(f);y&&y.delete(E),y?.size||this.b.delete(f)}L(f,E){return`${O.$Qm.toKey(f.id)}@${E}`}M(f){const[E,y]=(0,j.$vp)(f);return y?{identifier:{id:E},version:y}:void 0}}e.$Bq=R}),define(ae[233],ce([0,1,45,49]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=L;async function L(j,O,R,C,f,E,y){const w={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${O.nameShort})`};if((0,N.$lp)(O,R)&&(0,N.$np)(C)===3){const h=await(0,A.$6p)(R,f,E);w["X-Market-User-Id"]=h,w["VSCode-SessionId"]=y.machineId||h}return w}}),define(ae[234],ce([0,1,73,17,6,2,23,14,31,16,29,33,9,75,8]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=void 0;let p=class extends h.$Rr{constructor(m,d,$,t){super($),this.h=m,this.j=t,this.g=this.B(new g(d,t)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(m,d){const t=(await this.g.getLanguagePacks())[d];if(!t){this.j.warn(`No language pack found for ${d}`);return}const r=t.translations[m];return r?c.URI.file(r):void 0}async getInstalledLanguages(){const m=await this.g.getLanguagePacks(),d=Object.keys(m).map($=>{const t=m[$];return{...this.f($,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return d.push(this.f("en","English")),d.sort(($,t)=>$.label.localeCompare(t.label)),d}async m(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",m.identifier.id),await this.update())}async n(m){const d=await this.g.getLanguagePacks();Object.keys(d).some($=>d[$]&&d[$].extensions.some(t=>(0,y.$tp)(t.extensionIdentifier,m.identifier)))&&(this.j.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,d]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),$=await this.g.update(d);return!(0,N.$ub)(Object.keys(m),Object.keys($))}};e.$Sr=p,e.$Sr=p=Ee([Z(0,E.$8o),Z(1,f.$Di),Z(2,E.$5o),Z(3,w.$2j)],p);let g=class extends j.$Vc{constructor(m,d){super(),this.j=d,this.c={},this.f=(0,R.$kc)(m.userDataPath,"languagepacks.json"),this.g=new L.$Ch}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(m){return this.s(d=>{Object.keys(d).forEach($=>delete d[$]),this.m(d,...m)}).then(()=>this.c)}m(m,...d){for(const $ of d)$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&this.n(m,$);Object.keys(m).forEach($=>this.r(m[$]))}n(m,d){const $=d.identifier,t=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const r of t)if(d.location.scheme===O.Schemas.file&&l(r)){let n=m[r.languageId];n||(n={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},m[r.languageId]=n);const s=n.extensions.filter(i=>(0,y.$tp)(i.extensionIdentifier,$))[0];s?s.version=d.manifest.version:n.extensions.push({extensionIdentifier:$,version:d.manifest.version});for(const i of r.translations)n.translations[i.id]=(0,R.$kc)(d.location.fsPath,i.path)}}r(m){if(m){const d=(0,A.createHash)("md5");for(const $ of m.extensions)d.update($.extensionIdentifier.uuid||$.extensionIdentifier.id).update($.version);m.hash=d.digest("hex")}}s(m=()=>null){return this.g.queue(()=>{let d=null;return C.Promises.readFile(this.f,"utf8").then(void 0,$=>$.code==="ENOENT"?Promise.resolve("{}"):Promise.reject($)).then($=>{try{return JSON.parse($)}catch{return{}}}).then($=>(d=m($),$)).then($=>{for(const r of Object.keys($))$[r]||delete $[r];this.c=$,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),C.Promises.writeFile(this.f,t)}).then(()=>d,$=>this.j.error($))})}};g=Ee([Z(0,f.$Di),Z(1,w.$2j)],g);function l(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const m of u.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(ae[235],ce([0,1,143,7,30,49]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function C(E,y,w){const h=await(0,A.$ZD)("@microsoft/1ds-core-js","dist/ms.core.js"),c=await(0,A.$ZD)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new h.AppInsightsCore,g=new c.PostChannel,l={instrumentationKey:E,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(w){l.extensionConfig={};const u={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:w};l.extensionConfig[g.identifier]=u}return p.initialize(l,[]),p.addTelemetryInitializer(u=>{u.ext=u.ext??{},u.ext.web=u.ext.web??{},u.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',y&&(u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),p}class f{constructor(y,w,h,c,p){this.e=y,this.f=w,this.g=h,this.h=p,this.c=O,this.d=R,this.g||(this.g={}),typeof c=="function"?this.a=c():this.a=c,this.b=null}i(y){if(this.a){if(typeof this.a!="string"){y(this.a);return}this.b||(this.b=C(this.a,this.e,this.h)),this.b.then(w=>{y(w)},w=>{(0,N.$1)(w),console.error(w)})}}log(y,w){if(!this.a)return;w=(0,L.$5n)(w,this.g),w=(0,j.$op)(w);const h=this.f+"/"+y;try{this.i(c=>{c.pluginVersionString=w?.properties.version??"Unknown",c.track({name:h,baseData:{name:h,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(y=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.$zQ=f}),define(ae[109],ce([0,1,2,172,16,9,24,49]),function(ne,e,A,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$__b=void 0;let C=class extends A.$Vc{constructor(E,y,w,h,c=""){super(),this.b=c;const p=y.getLogger(R.$ip);if(p)this.a=this.B(p);else{const l=(0,R.$mp)(h,w)?" (Not Sent)":"",u=()=>(0,R.$lp)(h,w)&&E.getLevel()===j.LogLevel.Trace;this.a=this.B(y.createLogger(R.$ip,{name:(0,N.localize)(0,null,l),hidden:!u()})),this.B(E.onDidChangeLogLevel(()=>y.setVisibility(R.$ip,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(E,y){this.a.trace(`${this.b}telemetry/${E}`,(0,R.$op)(y))}};e.$__b=C,e.$__b=C=Ee([Z(0,j.$2j),Z(1,j.$3j),Z(2,L.$Ci),Z(3,O.$ik)],C)}),define(ae[110],ce([0,1,2,30,5,27,173,21,47,100,24,43,22,49]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=void 0;let c=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,u,m){this.k=u,this.l=m,this.d={},this.i=new A.$Uc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,j.$_e)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$_e)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration(w.$9l)||d.affectsConfiguration(w.$$l)||d.affectsConfiguration(w.$0l))&&this.m()}))}setExperimentProperty(l,u){this.d[l]=u}m(){let l=(0,h.$np)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const m=u.usage?3:u.error?2:0;l=Math.min(l,m)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,u,m){this.g<u||(m=(0,N.$5n)(m,this.d),m=(0,h.$sp)(m,this.j),m=(0,N.$5n)(m,this.c),this.b.forEach(d=>d.log(l,m)))}publicLog(l,u){this.n(l,3,u)}publicLog2(l,u){this.publicLog(l,u)}publicLogError(l,u){this.h&&this.n(l,2,u)}publicLogError2(l,u){this.publicLogError(l,u)}};e.$Yr=c,e.$Yr=c=Ee([Z(1,R.$2i),Z(2,E.$ik)],c);function p(){const g=(0,O.localize)(0,null,f.default.nameLong),l=f.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",f.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=L.$o?"":(0,O.localize)(3,null),m=(0,O.localize)(4,null),d=(0,O.localize)(5,null),$=(0,O.localize)(6,null),t=(0,O.localize)(7,null),r=`
|       | ${m} | ${d} | ${$} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${g} ${l} ${u}

&nbsp;

${t}
${r}

&nbsp;

${n}
`}y.$bo.as(C.$go.Configuration).registerConfiguration({id:w.$8l,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[w.$9l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.$bo.as(C.$go.Configuration).registerConfiguration({id:w.$8l,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[w.$$l]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,O.localize)(16,null,f.default.nameLong,f.default.privacyStatementUrl):(0,O.localize)(15,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${w.$9l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[236],ce([0,1,15,26,278,235]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AQ=void 0;async function O(E,y){const w=await y.request(E,N.CancellationToken.None),h=(await(0,A.$Re)(w.stream)).toString(),c=w.res.statusCode??200;return{headers:w.res.headers,statusCode:c,responseData:h}}async function R(E){const y={method:E.type,headers:E.headers};return new Promise((h,c)=>{const p=L.request(E.url??"",y,g=>{g.on("data",function(l){h({headers:g.headers,statusCode:g.statusCode??200,responseData:l.toString()})}),g.on("error",function(l){c(l)})});p.write(E.data,g=>{g&&c(g)}),p.end()})}async function C(E,y,w){const h=typeof y.data=="string"?y.data:new TextDecoder().decode(y.data),c={type:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data).toString()},url:y.urlString,data:h};try{const p=E?await O(c,E):await R(c);w(p.statusCode,p.headers,p.responseData)}catch{w(0,{})}}class f extends j.$zQ{constructor(y,w,h,c,p){const g={sendPOST:(l,u)=>{C(y,l,u)}};super(w,h,c,p,g)}}e.$AQ=f}),define(ae[237],ce([0,1,23,92,21,16,9,24,22,108,109,110]),function(ne,e,A,N,L,j,O,R,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=void 0;let w=class{constructor(c,p,g,l,u,m){this.b=c,this.c=p,this.d=g,this.e=l,this.f=u,this.g=m,this.a=new Map}h(c){if(!this.a.has(c.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const g=[c.id,JSON.stringify(p),c.aiKey],u=new N.$Zq(A.$Pg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),m=[new f.$Occ(u),new E.$__b(this.d,this.e,this.f,this.g,`[${c.id}] `)];this.a.set(c.id,new y.$Yr({appenders:m,sendErrorTelemetry:c.sendErrorTelemetry},this.b,this.g))}return this.a.get(c.id)}publicLog(c,p,g){this.h(c).publicLog(p,g)}publicLogError(c,p,g){this.h(c).publicLogError(p,g)}};e.$9dc=w,e.$9dc=w=Ee([Z(0,L.$2i),Z(1,C.$1l),Z(2,O.$2j),Z(3,O.$3j),Z(4,j.$Ci),Z(5,R.$ik)],w)}),define(ae[78],ce([0,1,3,8,21,4,9]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=e.$iw=e.$gw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$cw=e.$bw=void 0,e.$dw=f,e.$ew=y,e.$fw=w,e.$hw=h,e.$jw=c,e.$kw=p,e.$bw=(0,j.$vi)("tunnelService"),e.$cw=(0,j.$vi)("sharedTunnelsService");var R;(function(u){u.Http="http",u.Https="https"})(R||(e.TunnelProtocol=R={}));var C;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(C||(e.TunnelPrivacyId=C={}));function f(u){return!!u.forwardPort}var E;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(E||(e.ProvidedOnAutoForward=E={}));function y(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(m)return{address:m[1],port:+m[2]}}function w(u){if(u.scheme!=="http"&&u.scheme!=="https"||!u.query)return;const m=u.query.split("&");for(const d of m){const $=d.split("=")[1];if(/^https?:/.exec($)){const t=y(N.URI.parse($));if(t)return t}}}e.$gw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function h(u){return e.$gw.indexOf(u)>=0}e.$iw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function c(u){return e.$iw.indexOf(u)>=0}function p(u,m,d,$){if(d===1)return!1;if(d===2&&c(m)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec($);if(t?.length===4&&parseInt(t[1])>=18)return!1}return u<1024}class g{constructor(m,d,$){this.remoteAddress=m,this.localAddress=d,this.b=$,this.a=new A.$ee,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$lw=g;let l=class{constructor(m,d){this.k=m,this.l=d,this.a=new A.$ee,this.onTunnelOpened=this.a.event,this.b=new A.$ee,this.onTunnelClosed=this.b.event,this.c=new A.$ee,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const m=this.l.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(m){return this.f=m,m?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this.g=m.elevation,this.i=m.privacyOptions,this.h=m.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const m=[],d=Array.from(this.e.values());for(const $ of d){const t=Array.from($.values());for(const r of t){const n=await r.value;n&&typeof n!="string"&&m.push(n)}}return m}async dispose(){for(const m of this.e.values()){for(const{value:d}of m.values())await d.then($=>typeof $!="string"?$?.dispose():void 0);m.clear()}this.e.clear()}setEnvironmentTunnel(m,d,$,t,r){this.q(m,d,Promise.resolve({tunnelRemoteHost:m,tunnelRemotePort:d,localAddress:$,privacy:t,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(m,d){(c(m)||h(m))&&(m=e.$gw[0]);const $=this.s(m,d);if($)return++$.refcount,$.value}openTunnel(m,d,$,t,r,n=!1,s,i){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${$} on local port ${r}.`);const o=this.f??m;if(!o)return;if(d||(d="localhost"),t||(t=this.m),this.f&&this.j.has($)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(o,d,$,t,r,n,s,i);return a?a.then(b=>{if(b){if(typeof b=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(d,$),b}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(d,$);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.o(b);return(b.tunnelRemoteHost!==d||b.tunnelRemotePort!==$)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&b.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const d=this.e.get(m.tunnelRemoteHost);if(d){const $=d.get(m.tunnelRemotePort);$&&($.refcount--,await this.p(m.tunnelRemoteHost,m.tunnelRemotePort,$))}}}}async p(m,d,$){if($.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${d}.`);const t=$.value.then(async r=>{r&&typeof r!="string"&&(await r.dispose(!0),this.b.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this.e.has(m)&&this.e.get(m).delete(d),t}}async closeTunnel(m,d){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${d} `);const $=this.e.get(m);if($&&$.has(d)){const t=$.get(d);t.refcount=0,await this.p(m,d,t)}}q(m,d,$){this.e.has(m)||this.e.set(m,new Map),this.e.get(m).set(d,{refcount:1,value:$})}async r(m,d){const $=this.e.get(m);if($){const t=$.get(d),r=t?await t.value:void 0;(!r||typeof r=="string")&&$.delete(d),$.size===0&&this.e.delete(m)}}s(m,d){const $=[m];h(m)?($.push(...e.$gw),$.push(...e.$iw)):c(m)&&$.push(...e.$iw);const t=$.map(r=>this.e.get(r));for(const r of t){const n=r?.get(d);if(n)return n}}canTunnel(m){return!!y(m)}u(m,d,$,t,r,n,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${$} on local port ${t}.`);const i=$;this.j.add(i);const o=t===void 0?$:t,a={elevationRequired:r?this.isPortPrivileged(o):!1},b={remoteAddress:{host:d,port:$},localAddressPort:t,privacy:n,public:n?n!==C.Private:void 0,protocol:s},S=m.forwardPort(b,a);return S?(this.q(d,$,S),S.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(i)})):this.j.delete(i),S}};e.$mw=l,e.$mw=l=Ee([Z(0,O.$2j),Z(1,L.$2i)],l)}),define(ae[238],ce([0,1,9,78,2,7,6]),function(ne,e,A,N,L,j,O){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;class C extends L.$Vc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$Sh),this.b.p)}setAddress(y){this.a=y,this.b&&(this.b.complete(y),this.b=null)}setTunnel(y){this.B(y)}}let f=class extends L.$Vc{static{R=this}static{this.a=0}constructor(y,w){super(),this.f=y,this.g=w,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(y=>y.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(y,w,h,c,p,g,l){const u=new C,m=await Promise.resolve(this.f.openTunnel(y,u,h,c,p,g,l));if(!m||typeof m=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${h}:${c} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(w))throw this.c.delete(w),u.dispose(),await m.dispose(),(0,j.$6)();return u.setTunnel(m),this.b.set(w,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${m.localAddress} (local) to ${h}:${c} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(y,w){const h=this.b.get(y);h&&h.setAddress(w)}async destroyTunnel(y){const w=this.b.get(y);if(w){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${y}.`),this.b.delete(y),await w.dispose();return}this.c.add(y)}};e.$gec=f,e.$gec=f=R=Ee([Z(0,N.$cw),Z(1,A.$2j)],f)}),define(ae[28],ce([0,1,4]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=void 0,e.$zl=(0,A.$vi)("IUriIdentityService")}),define(ae[239],ce([0,1,28,191,12,20,128,3,2]),function(ne,e,A,N,L,j,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;class f{static{this._clock=0}constructor(w){this.uri=w,this.time=f._clock++}touch(){return this.time=f._clock++,this}}let E=class{constructor(w){this.g=w,this.c=new C.$Uc,this.f=2**16;const h=new Map,c=p=>{let g=h.get(p.scheme);return g===void 0&&(g=w.hasProvider(p)&&!this.g.hasCapability(p,1024),h.set(p.scheme,g)),g};this.c.add(R.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(p=>{h.delete(p.scheme)})),this.extUri=new j.$Xg(c),this.d=new O.$ys((p,g)=>this.extUri.compare(p,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,j.$0g)(w));const h=this.d.get(w);return h?h.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new f(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((c,p)=>c[1].time<p[1].time?1:c[1].time>p[1].time?-1:0);f._clock=0,this.d.clear();const h=this.f*.5;for(let c=0;c<h;c++)this.d.set(w[c][0],w[c][1].touch())}};e.$zs=E,e.$zs=E=Ee([Z(0,L.$2k)],E),(0,N.$ws)(A.$zl,E,1)}),define(ae[240],ce([0,1,3,2,12,51,34]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class R extends N.$Vc{constructor(f,E,y,w,h,c){super(),this.f=f,this.g=E,this.h=y,this.j=w,this.m=h,this.n=c,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new A.$ee),this.onDidChangeFile=this.a.event,this.b=j.$Bi.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Cc(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(w.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const f of this.j.profiles)this.c.add(f.settingsResource),this.c.add(f.keybindingsResource),this.c.add(f.tasksResource),this.c.add(f.extensionsResource)}open(f,E){return this.g.open(this.t(f),E)}close(f){return this.g.close(f)}read(f,E,y,w,h){return this.g.read(f,E,y,w,h)}write(f,E,y,w,h){return this.g.write(f,E,y,w,h)}watch(f,E){this.b.set(f,f);const y=this.g.watch(this.t(f),E);return(0,N.$Tc)(()=>{this.b.delete(f),y.dispose()})}stat(f){return this.g.stat(this.t(f))}mkdir(f){return this.g.mkdir(this.t(f))}rename(f,E,y){return this.g.rename(this.t(f),this.t(E),y)}readFile(f,E){return this.g.readFile(this.t(f),E)}readFileStream(f,E,y){return this.g.readFileStream(this.t(f),E,y)}readdir(f){return this.g.readdir(this.t(f))}enforceAtomicReadFile(f){return this.c.has(f)}writeFile(f,E,y){return this.g.writeFile(this.t(f),E,y)}enforceAtomicWriteFile(f){return this.c.has(f)?{postfix:".vsctmp"}:!1}delete(f,E){return this.g.delete(this.t(f),E)}copy(f,E,y){if((0,L.$6k)(this.g))return this.g.copy(this.t(f),this.t(E),y);throw new Error("copy not supported")}cloneFile(f,E){if((0,L.$7k)(this.g))return this.g.cloneFile(this.t(f),this.t(E));throw new Error("clone not supported")}s(f){const E=[];for(const y of f){if(y.resource.scheme!==this.f)continue;const w=this.u(y.resource);this.b.findSubstr(w)&&E.push({resource:w,type:y.type,cId:y.cId})}E.length&&(this.n.debug("User data changed"),this.a.fire(E))}t(f){return f.with({scheme:this.f})}u(f){return f.with({scheme:this.h})}}e.$Bdc=R}),define(ae[79],ce([0,1,62]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=N,e.$cKb=L,e.$dKb=j;function N(O,R,C,f){const E=(0,A.$Xn)(O,R,C,f)[0];return E&&(O=O.substring(0,E.offset)+E.content+O.substring(E.offset+E.length)),O}function L(O,R,C){let f=C;for(;f>=0;){if(O.charAt(f)===R.charAt(R.length-1)&&R.length===1)return f+1;if(f--,R.length===2&&f>=0&&O.charAt(f)===R.charAt(0))return f+2}return 0}function j(O,R,C){let f=C;for(;f>=0;)if(O.charAt(f)===R.charAt(R.length-1)&&R.length===1||(f++,R.length===2&&f>=0&&O.charAt(f)===R.charAt(1)))return f;return O.length-1}}),define(ae[241],ce([0,1,30,55,13]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P$b=j;function j(h,c,p,g,l,u){const m=[],d=[],$=[];if(!c){const q=h.filter(({identifier:X})=>l.every(G=>G.toLowerCase()!==X.id.toLowerCase()));return{local:{added:m,removed:d,updated:$},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}h=h.map(y),c=c.map(y),p=p?p.map(y):null;const t=new Map,r=q=>{q.uuid&&t.set(q.id.toLowerCase(),q.uuid)};h.forEach(({identifier:q})=>r(q)),c.forEach(({identifier:q})=>r(q)),p?.forEach(({identifier:q})=>r(q)),g?.forEach(({identifier:q})=>r(q)),u?.forEach(q=>r(q));const n=q=>{const X=q.identifier.uuid||t.get(q.identifier.id.toLowerCase());return X?`uuid:${X}`:`id:${q.identifier.id.toLowerCase()}`},s=(q,X)=>(q.set(n(X),X),q),i=h.reduce(s,new Map),o=c.reduce(s,new Map),a=c.reduce((q,X)=>s(q,(0,A.$2n)(X)),new Map),b=p?p.reduce(s,new Map):null,S=g.reduce(s,new Map),v=l.reduce((q,X)=>{const G=t.get(X.toLowerCase());return q.add(G?`uuid:${G}`:`id:${X.toLowerCase()}`)},new Set),k=u?u.reduce((q,{id:X,uuid:G})=>(G=G??t.get(X.toLowerCase()),q.add(G?`uuid:${G}`:`id:${X.toLowerCase()}`)),new Set):null,P=O(i,o,v,!1);if(P.added.size>0||P.removed.size>0||P.updated.size>0){const q=O(b,i,v,!1),X=O(b,o,v,!0),G=(Q,W,J,H)=>{let B,ie,re;return W.installed?(B=H.pinned,re=H.preRelease,B&&(ie=H.version)):(B=J.pinned,re=J.preRelease,B&&(ie=J.version)),B===void 0&&(B=W.pinned,B&&(ie=W.version)),re===void 0&&(re=W.preRelease),{...H,installed:W.installed||J.installed,pinned:B,preRelease:re,version:ie??(J.version&&(!W.installed||N.gt(J.version,W.version))?J.version:W.version),state:C(W,J,b?.get(Q))}};for(const Q of X.removed.values()){const W=i.get(Q);if(!W)continue;const J=(0,L.$gg)(b?.get(Q)),H=k&&!k.has(Q)&&J.installed;W.installed&&H?d.push(W.identifier):a.set(Q,W)}for(const Q of X.added.values()){const W=(0,L.$gg)(o.get(Q)),J=i.get(Q);if(J){if(P.updated.has(Q)){const H=G(Q,J,W,W);R(J,W,!1,!1)||$.push(w(H,Q)),a.set(Q,H)}}else W.installed&&m.push(w(W,Q))}for(const Q of X.updated.values()){const W=(0,L.$gg)(o.get(Q)),J=(0,L.$gg)(b?.get(Q)),H=i.get(Q);if(H)if(k&&!k.has(Q)&&J.installed&&H.installed&&!W.installed)d.push(H.identifier);else{const ie=G(Q,H,W,W);$.push(w(ie,Q)),a.set(Q,ie)}else W.installed&&m.push(w(W,Q))}for(const Q of q.added.values())X.added.has(Q)||a.set(Q,(0,L.$gg)(i.get(Q)));for(const Q of q.updated.values()){if(X.removed.has(Q)||X.updated.has(Q))continue;const W=(0,L.$gg)(i.get(Q)),J=(0,L.$gg)(o.get(Q));a.set(Q,G(Q,W,J,W))}for(const Q of q.removed.values())X.updated.has(Q)||X.removed.has(Q)||S.has(Q)||(0,L.$gg)(o.get(Q)).installed&&k&&(k.has(Q)||!(0,L.$gg)(b?.get(Q)).installed||a.delete(Q))}const I=[],F=O(o,a,new Set,!0),T=F.added.size>0||F.updated.size>0||F.removed.size>0;return T&&a.forEach((q,X)=>I.push(w(q,X))),{local:{added:m,removed:d,updated:$},remote:T?{added:[...F.added].map(q=>a.get(q)),updated:[...F.updated].map(q=>a.get(q)),removed:[...F.removed].map(q=>o.get(q)),all:I}:null}}function O(h,c,p,g){const l=h?[...h.keys()].filter(t=>!p.has(t)):[],u=[...c.keys()].filter(t=>!p.has(t)),m=u.filter(t=>!l.includes(t)).reduce((t,r)=>(t.add(r),t),new Set),d=l.filter(t=>!u.includes(t)).reduce((t,r)=>(t.add(r),t),new Set),$=new Set;for(const t of l){if(d.has(t))continue;const r=h.get(t),n=c.get(t);(!n||!R(r,n,g,!0))&&$.add(t)}return{added:m,removed:d,updated:$}}function R(h,c,p,g){return!(h.disabled!==c.disabled||!!h.isApplicationScoped!=!!c.isApplicationScoped||g&&h.installed!==c.installed||h.installed&&c.installed&&(h.preRelease!==c.preRelease||h.pinned!==c.pinned||c.pinned&&h.version!==c.version)||!E(h.state,c.state)||p&&h.version!==c.version)}function C(h,c,p){const g=h.state,l=c.state,u=p?.state;if(!c.version||g&&N.gt(h.version,c.version))return g;if(l&&N.gt(c.version,h.version)||!g)return l;if(!l)return g;const m=(0,A.$2n)(g),d=u?f(u,l):{added:Object.keys(l).reduce((t,r)=>(t.add(r),t),new Set),removed:new Set,updated:new Set},$=u?f(u,g):{added:Object.keys(g).reduce((t,r)=>(t.add(r),t),new Set),removed:new Set,updated:new Set};for(const t of[...d.added.values(),...d.updated.values()])m[t]=l[t];for(const t of d.removed.values())$.updated.has(t)||delete m[t];return m}function f(h,c){const p=Object.keys(h),g=Object.keys(c),l=g.filter(d=>!p.includes(d)).reduce((d,$)=>(d.add($),d),new Set),u=p.filter(d=>!g.includes(d)).reduce((d,$)=>(d.add($),d),new Set),m=new Set;for(const d of p){if(u.has(d))continue;const $=h[d],t=c[d];(0,A.$6n)($,t)||m.add(d)}return{added:l,removed:u,updated:m}}function E(h={},c={}){const{added:p,removed:g,updated:l}=f(h,c);return p.size===0&&g.size===0&&l.size===0}function y(h){return{...h,disabled:!!h.disabled,installed:!!h.installed}}function w(h,c){const p={...h,identifier:{id:h.identifier.id,uuid:c.startsWith("uuid:")?c.substring(5):void 0},preRelease:!!h.preRelease,pinned:!!h.pinned};return h.disabled||delete p.disabled,h.installed||delete p.installed,h.state||delete p.state,h.isApplicationScoped||delete p.isApplicationScoped,p}}),define(ae[111],ce([0,1,17,21,4]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lMb=e.$kMb=void 0,e.$kMb=(0,L.$vi)("IIgnoredExtensionsManagementService");let j=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,C){let f=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return f=f.filter(E=>E!==R&&E!==`-${R}`),C&&f.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",f.length?f:void 0,2)}updateSynchronizedExtensions(R,C){let f=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return f=f.filter(E=>E!==R&&E!==`-${R}`),C&&f.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",f.length?f:void 0,2)}getIgnoredExtensions(R){const C=R.filter(w=>w.isMachineScoped).map(w=>w.identifier.id.toLowerCase()),f=this.b().map(w=>w.toLowerCase()),E=[],y=[];if(Array.isArray(f))for(const w of f)w.startsWith("-")?y.push(w.substring(1)):E.push(w);return(0,A.$Mb)([...C,...E].filter(w=>!y.includes(w)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};e.$lMb=j,e.$lMb=j=Ee([Z(0,N.$2i)],j)}),define(ae[242],ce([0,1,17,35,30,93,79]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V$b=C;function R(d){return(0,N.$In)(d)||[]}async function C(d,$,t,r,n){const s=R(d),i=R($),o=t?R(t):null,a=[...s,...i,...o||[]].map(G=>G.key),b=await n.resolveUserBindings(a),S=E(s,i,o,b);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:$,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const v=w(s),k=w(i),P=o?w(o):null,I=c(v,k,b),F=P?c(P,v,b):{added:[...v.keys()].reduce((G,Q)=>(G.add(Q),G),new Set),removed:new Set,updated:new Set},T=P?c(P,k,b):{added:[...k.keys()].reduce((G,Q)=>(G.add(Q),G),new Set),removed:new Set,updated:new Set},q=f(I,F,T);let X=d;for(const G of q.removed.values())q.conflicts.has(G)||(X=u(X,G,r));for(const G of q.added.values()){if(q.conflicts.has(G))continue;const Q=k.get(G);if(Q.some(W=>W.command!==`-${G}`&&S.conflicts.has(b[W.key]))){q.conflicts.add(G);continue}X=l(X,Q,r)}for(const G of q.updated.values()){if(q.conflicts.has(G))continue;const Q=k.get(G);if(Q.some(W=>W.command!==`-${G}`&&S.conflicts.has(b[W.key]))){q.conflicts.add(G);continue}X=m(X,G,Q,r)}return{mergeContent:X,hasChanges:!0,hasConflicts:q.conflicts.size>0}}function f(d,$,t){const r=new Set,n=new Set,s=new Set,i=new Set;for(const o of $.removed.values())t.updated.has(o)&&i.add(o);for(const o of t.removed.values())i.has(o)||($.updated.has(o)?i.add(o):n.add(o));for(const o of $.added.values())i.has(o)||t.added.has(o)&&d.updated.has(o)&&i.add(o);for(const o of t.added.values())i.has(o)||($.added.has(o)?d.updated.has(o)&&i.add(o):r.add(o));for(const o of $.updated.values())i.has(o)||t.updated.has(o)&&d.updated.has(o)&&i.add(o);for(const o of t.updated.values())i.has(o)||($.updated.has(o)?d.updated.has(o)&&i.add(o):s.add(o));return{added:r,removed:n,updated:s,conflicts:i}}function E(d,$,t,r){const n=new Set,s=y(d,r),i=y($,r),o=t?y(t,r):null,a=h(s,i);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const b=o?h(o,s):{added:[...s.keys()].reduce((F,T)=>(F.add(T),F),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const S=o?h(o,i):{added:[...i.keys()].reduce((F,T)=>(F.add(T),F),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:v,removed:k,updated:P,conflicts:I}=f(a,b,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:v,removed:k,updated:P,conflicts:I}}function y(d,$){const t=new Map;for(const r of d){const n=$[r.key];let s=t.get(n);s||(s=[],t.set(n,s)),s.push(r)}return t}function w(d){const $=new Map;for(const t of d){const r=t.command[0]==="-"?t.command.substring(1):t.command;let n=$.get(r);n||(n=[],$.set(r,n)),n.push(t)}return $}function h(d,$){const t=[...d.keys()],r=[...$.keys()],n=r.filter(o=>!t.includes(o)).reduce((o,a)=>(o.add(a),o),new Set),s=t.filter(o=>!r.includes(o)).reduce((o,a)=>(o.add(a),o),new Set),i=new Set;for(const o of t){if(s.has(o))continue;const a=d.get(o).map(S=>({...S,key:o})),b=$.get(o).map(S=>({...S,key:o}));(0,A.$ub)(a,b,(S,v)=>g(S,v))||i.add(o)}return{added:n,removed:s,updated:i}}function c(d,$,t){const r=[...d.keys()],n=[...$.keys()],s=n.filter(a=>!r.includes(a)).reduce((a,b)=>(a.add(b),a),new Set),i=r.filter(a=>!n.includes(a)).reduce((a,b)=>(a.add(b),a),new Set),o=new Set;for(const a of r){if(i.has(a))continue;const b=d.get(a).map(v=>({...v,key:t[v.key]})),S=$.get(a).map(v=>({...v,key:t[v.key]}));p(b,S)||o.add(a)}return{added:s,removed:i,updated:o}}function p(d,$){return!(!(0,A.$ub)(d.filter(({command:t})=>t[0]!=="-"),$.filter(({command:t})=>t[0]!=="-"),(t,r)=>g(t,r))||!(0,A.$ub)(d.filter(({command:t})=>t[0]==="-"),$.filter(({command:t})=>t[0]==="-"),(t,r)=>g(t,r)))}function g(d,$){if(d.command!==$.command||d.key!==$.key)return!1;const t=j.$tj.deserialize(d.when),r=j.$tj.deserialize($.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!L.$6n(d.args,$.args))}function l(d,$,t){for(const r of $)d=O.edit(d,[-1],r,t);return d}function u(d,$,t){const r=R(d);for(let n=r.length-1;n>=0;n--)(r[n].command===$||r[n].command===`-${$}`)&&(d=O.edit(d,[n],void 0,t));return d}function m(d,$,t,r){const n=R(d),s=n.findIndex(i=>i.command===$||i.command===`-${$}`);for(let i=n.length-1;i>=0;i--)(n[i].command===$||n[i].command===`-${$}`)&&(d=O.edit(d,[i],void 0,r));for(let i=t.length-1;i>=0;i--)d=O.edit(d,[s],t[i],r);return d}}),define(ae[243],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3$b=A,e.$4$b=L;function A(j,O,R){const C={},f={},E=new Set;if(!O)return{local:{added:C,updated:f,removed:[...E.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const y=N(j,O);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{local:{added:C,updated:f,removed:[...E.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const w=N(R,j),h=N(R,O),c={},p={},g=new Set,l=new Set;for(const u of w.removed.values())h.updated.has(u)?C[u]=O[u]:g.add(u);for(const u of h.removed.values())l.has(u)||(w.updated.has(u)?l.add(u):E.add(u));for(const u of w.updated.values())l.has(u)||(h.updated.has(u)?y.updated.has(u)&&l.add(u):p[u]=j[u]);for(const u of h.updated.values())l.has(u)||(w.updated.has(u)?y.updated.has(u)&&l.add(u):j[u]!==void 0&&(f[u]=O[u]));for(const u of w.added.values())l.has(u)||(h.added.has(u)?y.updated.has(u)&&l.add(u):c[u]=j[u]);for(const u of h.added.values())l.has(u)||(w.added.has(u)?y.updated.has(u)&&l.add(u):C[u]=O[u]);return{local:{added:C,removed:[...E.values()],updated:f},remote:{added:c,removed:[...g.values()],updated:p},conflicts:[...l.values()]}}function N(j,O){const R=j?Object.keys(j):[],C=O?Object.keys(O):[],f=C.filter(w=>!R.includes(w)).reduce((w,h)=>(w.add(h),w),new Set),E=R.filter(w=>!C.includes(w)).reduce((w,h)=>(w.add(h),w),new Set),y=new Set;for(const w of R){if(E.has(w))continue;const h=j[w],c=O[w];h!==c&&y.add(w)}return{added:f,removed:E,updated:y}}function L(j,O){const{added:R,removed:C,updated:f}=N(j,O);return R.size===0&&C.size===0&&f.size===0}}),define(ae[244],ce([0,1,30]),function(ne,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=N;function N(j,O,R,C){const f={added:[],removed:[],updated:[]};let E={added:[],removed:[],updated:[]};if(!O){const w=j.filter(({id:h})=>!C.includes(h));return w.length?E.added=w:E=null,{local:f,remote:E}}const y=L(j,O,C);if(y.added.length>0||y.removed.length>0||y.updated.length>0){const w=L(R,j,C),h=L(R,O,C);for(const c of h.removed){const p=j.find(g=>g.id===c);p&&f.removed.push(p)}for(const c of h.added){const p=O.find(g=>g.id===c);w.added.includes(c)?y.updated.includes(c)&&f.updated.push(p):f.added.push(p)}for(const c of h.updated)f.updated.push(O.find(p=>p.id===c));for(const c of w.added)h.added.includes(c)||E.added.push(j.find(p=>p.id===c));for(const c of w.updated)h.removed.includes(c)||h.updated.includes(c)||E.updated.push(j.find(p=>p.id===c));for(const c of w.removed){const p=O.find(g=>g.id===c);p&&E.removed.push(p)}}return E.added.length===0&&E.removed.length===0&&E.updated.length===0&&(E=null),{local:f,remote:E}}function L(j,O,R){j=j?j.filter(({id:h})=>!R.includes(h)):[],O=O.filter(({id:h})=>!R.includes(h));const C=j.map(({id:h})=>h),f=O.map(({id:h})=>h),E=f.filter(h=>!C.includes(h)),y=C.filter(h=>!f.includes(h)),w=[];for(const{id:h,name:c,shortName:p,icon:g,useDefaultFlags:l}of j){if(y.includes(h))continue;const u=O.find(m=>m.id===h);(!u||u.name!==c||u.shortName!==p||u.icon!==g||!(0,A.$6n)(u.useDefaultFlags,l))&&w.push(h)}return{added:E,removed:y,updated:w}}}),define(ae[25],ce([0,1,17,13,179,47,29,4,101,43]),function(ne,e,A,N,L,j,O,R,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gBb=e.$fBb=e.$eBb=e.$dBb=e.$cBb=e.$bBb=e.$aBb=e.$_Ab=e.$$Ab=e.$9Ab=e.MergeState=e.Change=e.SyncStatus=e.$8Ab=e.$7Ab=e.$6Ab=e.UserDataSyncErrorCode=e.$4Ab=e.$3Ab=e.$2Ab=e.$1Ab=e.$ZAb=e.$WAb=e.SyncResource=e.$TAb=e.$SAb=void 0,e.$QAb=E,e.$RAb=y,e.$UAb=w,e.$VAb=h,e.$XAb=p,e.$YAb=g,e.$5Ab=l,e.$0Ab=s;function E(){const i=f.$bo.as(j.$go.Configuration).getConfigurationProperties();return Object.keys(i).filter(o=>!!i[o].disallowSyncIgnore)}function y(){const i=f.$bo.as(j.$go.Configuration).getConfigurationProperties(),o=Object.keys(i).filter(S=>!!i[S].ignoreSync),a=Object.keys(i).filter(S=>i[S].scope===2||i[S].scope===6),b=E();return(0,A.$Mb)([...o,...a,...b])}e.$SAb="settingsSync",e.$TAb="settingsSync.keybindingsPerPlatform";function w(){const i="vscode://schemas/ignoredSettings",o=f.$bo.as(j.$go.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{[e.$TAb]:{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:O.$So,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=f.$bo.as(C.$co.JSONContribution),b=()=>{const S=E(),v=y(),k=Object.keys(j.$ho.properties).filter(F=>!v.includes(F)),P=v.filter(F=>!S.includes(F)),I={items:{type:"string",enum:[...k,...P.map(F=>`-${F}`)]}};a.registerSchema(i,I)};return o.onDidUpdateConfiguration(()=>b())}function h(i){return i&&(0,N.$0f)(i)&&(0,N.$8f)(i.id)&&Array.isArray(i.scopes)}var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(c||(e.SyncResource=c={})),e.$WAb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(i,...o){return i?[i,...o]:o}function g(i,o,a,b){return b.joinPath(a.userDataSyncHome,...p(i,o,`lastSync${o}.json`))}e.$ZAb=(0,R.$vi)("IUserDataSyncStoreManagementService"),e.$1Ab=(0,R.$vi)("IUserDataSyncStoreService"),e.$2Ab=(0,R.$vi)("IUserDataSyncLocalStoreService"),e.$3Ab="x-operation-id",e.$4Ab="X-Execution-Id";function l(i){const o={};return o[e.$4Ab]=i,o}var u;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class m extends Error{constructor(o,a,b,S){super(o),this.code=a,this.resource=b,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$6Ab=m;class d extends m{constructor(o,a,b,S,v){super(o,b,void 0,v),this.url=a,this.serverCode=S}}e.$7Ab=d;class $ extends m{constructor(o,a){super(o,a)}}e.$8Ab=$,function(i){function o(a){if(a instanceof i)return a;const b=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(b&&b[1]){const S=b[2]==="unknown"?void 0:b[2],v=b[3]==="unknown"?void 0:b[3];return new i(a.message,b[1],S,v)}return new i(a.message,"Unknown")}i.toUserDataSyncError=o}(m||(e.$6Ab=m={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var r;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(r||(e.Change=r={}));var n;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(n||(e.MergeState=n={})),e.$9Ab="sync.store.url.type";function s(i){return`sync.enable.${i}`}e.$$Ab=(0,R.$vi)("IUserDataSyncEnablementService"),e.$_Ab=(0,R.$vi)("IUserDataSyncService"),e.$aBb=(0,R.$vi)("IUserDataSyncResourceProviderService"),e.$bBb=(0,R.$vi)("IUserDataAutoSyncService"),e.$cBb=(0,R.$vi)("IUserDataSyncUtilService"),e.$dBb=(0,R.$vi)("IUserDataSyncLogService"),e.$eBb="userDataSync",e.$fBb="vscode-userdata-sync",e.$gBb="preview"}),define(ae[245],ce([0,1,30,25]),function(ne,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CLb=L;function L(O,R,C,f,E){if(!R)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const y=j(O,R);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const w=C?j(C,R):{added:Object.keys(R).reduce((u,m)=>(u.add(m),u),new Set),removed:new Set,updated:new Set},h=C?j(C,O):{added:Object.keys(O).reduce((u,m)=>(u.add(m),u),new Set),removed:new Set,updated:new Set},c={added:{},removed:[],updated:{}},p=A.$2n(R),g=!C;for(const u of h.added.values())u!==N.$9Ab&&g&&w.added.has(u)||(p[u]=O[u]);for(const u of h.updated.values())p[u]=O[u];for(const u of h.removed.values())f.unregistered.includes(u)||delete p[u];for(const u of w.added.values()){const m=R[u];if(f.machine.includes(u)){E.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(C&&h.added.has(u))continue;const d=O[u];d&&d.value===m.value||u===N.$9Ab&&g&&h.added.has(u)||(d?c.updated[u]=m:c.added[u]=m)}for(const u of w.updated.values()){const m=R[u];if(f.machine.includes(u)){E.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(u)||h.removed.has(u))continue;const d=O[u];d&&d.value===m.value||(c.updated[u]=m)}for(const u of w.removed.values()){if(f.machine.includes(u)){E.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}h.updated.has(u)||h.removed.has(u)||c.removed.push(u)}const l=j(R,p);return{local:c,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:p}}}function j(O,R){const C=Object.keys(O),f=Object.keys(R),E=f.filter(h=>!C.includes(h)).reduce((h,c)=>(h.add(c),h),new Set),y=C.filter(h=>!f.includes(h)).reduce((h,c)=>(h.add(c),h),new Set),w=new Set;for(const h of C){if(y.has(h))continue;const c=O[h],p=R[h];A.$6n(c,p)||w.add(h)}return{added:E,removed:y,updated:w}}}),define(ae[246],ce([0,1,17,35,62,44,30,79,25]),function(ne,e,A,N,L,j,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eKb=f,e.$fKb=w,e.$gKb=h,e.$hKb=c,e.$iKb=g,e.$jKb=u;function f(a,b,S){let v=[];S?v=y(S):v=E(b);const k=[],P=[...(0,C.$QAb)()];if(Array.isArray(v))for(const I of v)I.startsWith("-")?P.push(I.substring(1)):k.push(I);return(0,A.$Mb)([...a,...k].filter(I=>!P.includes(I)))}function E(a){let b=a.inspect("settingsSync.ignoredSettings").userValue;return b!==void 0||(b=a.inspect("sync.ignoredSettings").userValue,b!==void 0)?b:a.getValue("settingsSync.ignoredSettings")||[]}function y(a){const b=(0,N.$In)(a);return b?b["settingsSync.ignoredSettings"]||b["sync.ignoredSettings"]||[]:[]}function w(a,b){const S=(0,N.$In)(a)||{};let v="{}";for(const k of Object.keys(S)){const P=(0,L.$Xn)(v,[k],S[k],b);v=(0,L.$1n)(v,P)}return v}function h(a,b,S,v){if(S.length){const k=o(b),P=(0,N.$In)(b)||{},I=(0,N.$In)(a);if(!I)return a;const F=[];for(const T of S){const q=P[T],X=I[T];q===void 0?a=R.edit(a,[T],void 0,v):X!==void 0?a=R.edit(a,[T],q,v):F.push(t(T,k))}F.sort((T,q)=>T.startOffset-q.startOffset),F.forEach(T=>a=u(T.setting.key,b,a,v))}return a}function c(a,b,S,v,k,P){const I=h(a,b,v,P),F=S!==I,T=S!==b;if(!F&&!T)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!T)return{conflictsSettings:[],localContent:null,remoteContent:I,hasConflicts:!1};if(T&&!F)return{conflictsSettings:[],localContent:h(b,a,v,P),remoteContent:null,hasConflicts:!1};if(S===null&&g(a)){const M=p(a,b,v)?null:h(b,a,v,P);return{conflictsSettings:[],localContent:M,remoteContent:null,hasConflicts:!1}}let q=a,X=b;const G=(0,N.$In)(a),Q=(0,N.$In)(b),W=S?(0,N.$In)(S):null,J=v.reduce((M,z)=>(M.add(z),M),new Set),H=l(G,Q,J),B=l(W,G,J),ie=l(W,Q,J),re=new Map,he=new Set,te=M=>{he.add(M);const z=k.filter(({key:x})=>x===M)[0];z?(q=R.edit(q,[M],z.value,P),X=R.edit(X,[M],z.value,P)):re.set(M,{key:M,localValue:G[M],remoteValue:Q[M]})};for(const M of B.removed.values())ie.updated.has(M)?te(M):X=R.edit(X,[M],void 0,P);for(const M of ie.removed.values())he.has(M)||(B.updated.has(M)?te(M):q=R.edit(q,[M],void 0,P));for(const M of B.updated.values())he.has(M)||(ie.updated.has(M)?H.updated.has(M)&&te(M):X=R.edit(X,[M],G[M],P));for(const M of ie.updated.values())he.has(M)||(B.updated.has(M)?H.updated.has(M)&&te(M):q=R.edit(q,[M],Q[M],P));for(const M of B.added.values())he.has(M)||(ie.added.has(M)?H.updated.has(M)&&te(M):X=u(M,q,X,P));for(const M of ie.added.values())he.has(M)||(B.added.has(M)?H.updated.has(M)&&te(M):q=u(M,X,q,P));const V=re.size>0||!p(q,X,v),U=V||!p(q,a,[]),D=V||!p(X,b,[]);return{localContent:U?q:null,remoteContent:D?X:null,conflictsSettings:[...re.values()],hasConflicts:V}}function p(a,b,S){if(a===b)return!0;const v=(0,N.$In)(a),k=(0,N.$In)(b),P=S.reduce((T,q)=>(T.add(q),T),new Set),I=o(a).filter(T=>!(T.setting&&P.has(T.setting.key))),F=o(b).filter(T=>!(T.setting&&P.has(T.setting.key)));if(I.length!==F.length)return!1;for(let T=0;T<I.length;T++){const q=I[T],X=F[T];if(q.setting&&X.setting){if(q.setting.key!==X.setting.key||!O.$6n(v[q.setting.key],k[q.setting.key]))return!1}else if(!q.setting&&!X.setting){if(q.value!==X.value)return!1}else return!1}return!0}function g(a){return a?o(a).length===0:!0}function l(a,b,S){const v=a?Object.keys(a).filter(T=>!S.has(T)):[],k=Object.keys(b).filter(T=>!S.has(T)),P=k.filter(T=>!v.includes(T)).reduce((T,q)=>(T.add(q),T),new Set),I=v.filter(T=>!k.includes(T)).reduce((T,q)=>(T.add(q),T),new Set),F=new Set;if(a)for(const T of v){if(I.has(T))continue;const q=a[T],X=b[T];O.$6n(q,X)||F.add(T)}return{added:P,removed:I,updated:F}}function u(a,b,S,v){const k=(0,N.$In)(b),P=o(b),I=o(S),F=m(a,P,I);return d(S,a,k[a],F,I,v)}function m(a,b,S){const v=b.findIndex(P=>P.setting?.key===a),k=b[v-1];if(k){if(k.setting){const I=t(k.setting.key,S);if(I)return{index:S.indexOf(I),insertAfter:!0}}else{const I=r(v,b);if(I){const F=t(I.setting.key,S);if(F){const T=n(S.indexOf(F),S),q=s(b,I,b[v]);if(T){const X=s(S,F,T),G=i(q,X);return G?{index:S.indexOf(G),insertAfter:!0}:{index:S.indexOf(T),insertAfter:!1}}else{const X=s(S,F,S[S.length-1]),G=i(q,X);return G?{index:S.indexOf(G),insertAfter:!0}:{index:S.length-1,insertAfter:!0}}}}}const P=b[v+1];if(P)if(P.setting){const I=t(P.setting.key,S);if(I)return{index:S.indexOf(I),insertAfter:!1}}else{const I=n(v,b);if(I){const F=t(I.setting.key,S);if(F){const T=r(S.indexOf(F),S),q=s(b,b[v],I);if(T){const X=s(S,T,F),G=i(q.reverse(),X.reverse());return G?{index:S.indexOf(G),insertAfter:!1}:{index:S.indexOf(T),insertAfter:!0}}else{const X=s(S,S[0],F),G=i(q.reverse(),X.reverse());return G?{index:S.indexOf(G),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:S.length-1,insertAfter:!0}}function d(a,b,S,v,k,P){let I;return v.index===-1?I=(0,L.$Xn)(a,[b],S,P):I=$(a,b,S,v,k,P).map(F=>(0,L.$Yn)(a,F,P)[0]),(0,L.$1n)(a,I)}function $(a,b,S,v,k,P){const I=`${JSON.stringify(b)}: ${JSON.stringify(S)}`,F=(0,j.$Un)(P,a),T=k[v.index];if(v.insertAfter){const q=[];if(T.setting)q.push({offset:T.endOffset,length:0,content:","+I});else{const X=n(v.index,k),G=r(v.index,k),Q=G?.setting?.commaOffset;G&&Q===void 0&&q.push({offset:G.endOffset,length:0,content:","});const W=Q!==void 0&&Q>T.endOffset;q.push({offset:W?Q+1:T.endOffset,length:0,content:X?F+I+",":F+I})}return q}else{if(T.setting)return[{offset:T.startOffset,length:0,content:I+","}];const q=(k[v.index-1]&&!k[v.index-1].setting?F:"")+I+(n(v.index,k)?",":"")+F;return[{offset:T.startOffset,length:0,content:q}]}}function t(a,b){return b.filter(S=>S.setting?.key===a)[0]}function r(a,b){for(let S=a-1;S>=0;S--)if(b[S].setting)return b[S]}function n(a,b){for(let S=a+1;S<b.length;S++)if(b[S].setting)return b[S]}function s(a,b,S){const v=a.indexOf(b),k=a.indexOf(S);return a.filter((P,I)=>v<I&&I<k)}function i(a,b){if(a.length&&b.length){let S=0;for(;S<b.length&&S<a.length;S++)if(a[S].value!==b[S].value)return b[S-1];return b[S-1]}}function o(a){const b=[];let S=-1,v,k;const P={onObjectBegin:I=>{S++},onObjectProperty:(I,F,T)=>{S===0&&(v=F,k=I)},onObjectEnd:(I,F)=>{S--,S===0&&b.push({startOffset:v,endOffset:I+F,value:a.substring(v,I+F),setting:{key:k,commaOffset:void 0}})},onArrayBegin:(I,F)=>{S++},onArrayEnd:(I,F)=>{S--,S===0&&b.push({startOffset:v,endOffset:I+F,value:a.substring(v,I+F),setting:{key:k,commaOffset:void 0}})},onLiteralValue:(I,F,T)=>{S===0&&b.push({startOffset:v,endOffset:F+T,value:a.substring(v,F+T),setting:{key:k,commaOffset:void 0}})},onSeparator:(I,F,T)=>{if(S===0&&I===","){let q=b.length-1;for(;q>=0&&!b[q].setting;q--);const X=b[q];X&&b.splice(q,1,{startOffset:X.startOffset,endOffset:X.endOffset,value:X.value,setting:{key:X.setting.key,commaOffset:F}})}},onComment:(I,F)=>{S===0&&b.push({startOffset:I,endOffset:I+F,value:a.substring(I,I+F)})}};return(0,N.$Pn)(a,P),b}}),define(ae[80],ce([0,1,3,2,4,25]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZJb=e.$YJb=void 0,e.$YJb=(0,L.$vi)("IUserDataSyncAccountService");let O=class extends N.$Vc{get account(){return this.a}constructor(C,f){super(),this.g=C,this.h=f,this.b=this.B(new A.$ee),this.onDidChangeAccount=this.b.event,this.c=this.B(new A.$ee),this.onTokenFailed=this.c.event,this.f=!1,this.B(C.onTokenFailed(E=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,E),this.updateAccount(void 0),E==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(C.onTokenSucceed(()=>this.f=!1))}async updateAccount(C){(C&&this.a?C.token!==this.a.token||C.authenticationProviderId!==this.a.authenticationProviderId:C!==this.a)&&(this.a=C,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(C))}};e.$ZJb=O,e.$ZJb=O=Ee([Z(0,j.$1Ab),Z(1,j.$dBb)],O)}),define(ae[247],ce([0,1,20,180,16,9,25]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mMb=void 0;let R=class extends j.$7j{constructor(f,E){super(),this.g=this.B(f.createLogger((0,A.$9g)(E.logsHome,`${O.$eBb}.log`),{id:O.$eBb,name:(0,N.localize)(0,null)}))}trace(f,...E){this.g.trace(f,...E)}debug(f,...E){this.g.debug(f,...E)}info(f,...E){this.g.info(f,...E)}warn(f,...E){this.g.warn(f,...E)}error(f,...E){this.g.error(f,...E)}flush(){this.g.flush()}};e.$mMb=R,e.$mMb=R=Ee([Z(0,j.$3j),Z(1,L.$Ci)],R)}),define(ae[248],ce([0,1,6,3,2]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;class j extends L.$Vc{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:C,getActiveWindowId:f}){super(),this.a=this.B(new L.$Uc),N.Event.latch(N.Event.any(R,C))(this.f,this,this.a),this.b=(0,A.$ih)(()=>f()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$9cc=j}),define(ae[112],ce([0,1,183,14,51,20,8,4,23]),function(ne,e,A,N,L,j,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Pi=e.$Oi=e.WorkbenchState=e.$Ii=e.$Hi=e.$Ei=void 0,e.$Fi=f,e.$Gi=E,e.$Ji=y,e.$Ki=w,e.$Li=h,e.$Mi=p,e.$Ni=g,e.$Qi=m,e.$Vi=d,e.$Wi=$,e.$Yi=t,e.$Zi=r,e.$1i=n,e.$Ei=(0,R.$vi)("contextService");function f(s){const i=s;return typeof i?.id=="string"&&O.URI.isUri(i.uri)}function E(s){return typeof s?.id=="string"&&!f(s)&&!w(s)}e.$Hi={id:"ext-dev"},e.$Ii={id:"empty-window"};function y(s,i){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,N.$oc)(s)}:i?e.$Hi:e.$Ii;const o=s;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function w(s){const i=s;return typeof i?.id=="string"&&O.URI.isUri(i.configPath)}function h(s){const i=s;if(i?.uri)return{id:i.id,uri:O.URI.revive(i.uri)};const o=s;if(o?.configPath)return{id:o.id,configPath:O.URI.revive(o.configPath)};if(s?.id)return{id:s.id}}var c;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(c||(e.WorkbenchState=c={}));function p(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}function g(s){const i=s;return!!(i&&typeof i=="object"&&O.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}class l{constructor(i,o,a,b,S){this.h=i,this.j=a,this.k=b,this.l=S,this.c=L.$Bi.forUris(this.l,()=>!0),this.folders=o}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=L.$Bi.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Oi=l;class u{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,j.$9g)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Pi=u;function m(s){return new u({uri:s,index:0,name:(0,j.$5g)(s)},{uri:s.toString()})}e.$Ri="code-workspace",e.$Si=`.${e.$Ri}`,e.$Ti=[{name:(0,A.localize)(0,null),extensions:[e.$Ri]}],e.$Ui="workspace.json";function d(s,i){return j.$Zg.isEqualOrParent(s,i.untitledWorkspacesHome)}function $(s){let i;return O.URI.isUri(s)?i=s:i=s.configuration,i?.scheme===C.Schemas.tmp}e.$Xi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$Xi}function r(s,i){return!d(s,i)&&!$(s)}function n(s){return(typeof s=="string"?(0,N.$pc)(s):(0,j.$7g)(s))===e.$Si}}),define(ae[18],ce([0,1,54,3,2,20,8,174,16,12,4,9,112,34,28,6,32,27,13]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$El=e.$Bl=e.ProfileResourceType=void 0,e.$Al=d,e.$Cl=$,e.$Dl=t;var m;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(m||(e.ProfileResourceType=m={}));function d(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&O.URI.isUri(i.location)&&O.URI.isUri(i.globalStorageHome)&&O.URI.isUri(i.settingsResource)&&O.URI.isUri(i.keybindingsResource)&&O.URI.isUri(i.tasksResource)&&O.URI.isUri(i.snippetsHome)&&O.URI.isUri(i.extensionsResource))}e.$Bl=(0,E.$vi)("IUserDataProfilesService");function $(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:O.URI.revive(s.location).with({scheme:i}),globalStorageHome:O.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:O.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:O.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:O.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:O.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:O.URI.revive(s.extensionsResource).with({scheme:i}),cacheHome:O.URI.revive(s.cacheHome).with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function t(s,i,o,a,b,S){return{id:s,name:i,location:o,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:S&&b?.useDefaultFlags?.globalState?S.globalStorageHome:(0,j.$9g)(o,"globalStorage"),settingsResource:S&&b?.useDefaultFlags?.settings?S.settingsResource:(0,j.$9g)(o,"settings.json"),keybindingsResource:S&&b?.useDefaultFlags?.keybindings?S.keybindingsResource:(0,j.$9g)(o,"keybindings.json"),tasksResource:S&&b?.useDefaultFlags?.tasks?S.tasksResource:(0,j.$9g)(o,"tasks.json"),snippetsHome:S&&b?.useDefaultFlags?.snippets?S.snippetsHome:(0,j.$9g)(o,"snippets"),extensionsResource:S&&b?.useDefaultFlags?.extensions?S.extensionsResource:(0,j.$9g)(o,"extensions.json"),cacheHome:(0,j.$9g)(a,s),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}let r=class extends L.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(i,o,a,b){super(),this.t=i,this.u=o,this.w=a,this.y=b,this.f=!0,this.h=this.B(new N.$ee),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$ee),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$ee),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$ee),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new h.$Bc,emptyWindows:new Map},this.profilesHome=(0,j.$9g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$9g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(i){this.f!==i&&(this.z=void 0,this.f=i)}isEnabled(){return this.f}get C(){if(!this.z){const i=this.D(),o=[i];if(this.f)try{for(const S of this.O()){if(!S.name||!(0,u.$8f)(S.name)||!S.location){this.y.warn("Skipping the invalid stored profile",S.location||S.name);continue}o.push(t((0,j.$6g)(S.location),S.name,S.location,this.g,{shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags},i))}}catch(S){this.y.error(S)}const a=new h.$Bc,b=new Map;if(o.length)try{const S=this.Q();if(S.workspaces)for(const[v,k]of Object.entries(S.workspaces)){const P=O.URI.parse(v),I=o.find(F=>F.id===k);I&&a.set(P,I)}if(S.emptyWindows)for(const[v,k]of Object.entries(S.emptyWindows)){const P=o.find(I=>I.id===k);P&&b.set(v,P)}}catch(S){this.y.error(S)}this.z={profiles:o,workspaces:a,emptyWindows:b}}return this.z}D(){const i=t("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...i,extensionsResource:this.S()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const o="Temp",a=new RegExp(`${(0,l.$_e)(o)}\\s(\\d+)`);let b=0;for(const v of this.profiles){const k=a.exec(v.name),P=k?parseInt(k[1]):0;b=P>b?P:b}const S=`${o} ${b+1}`;return this.createProfile((0,A.$jj)((0,g.$Rg)()).toString(16),S,{transient:!0},i)}async createNamedProfile(i,o,a){return this.createProfile((0,A.$jj)((0,g.$Rg)()).toString(16),i,o,a)}async createProfile(i,o,a,b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=await this.F(i,o,a);return b&&await this.setProfileForWorkspace(b,S),S}async F(i,o,a){if(!(0,u.$8f)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.r.get(o);return b||(b=(async()=>{try{if(this.profiles.find(P=>P.name===o||P.id===i))throw new Error(`Profile with ${o} name already exists`);const v=t(i,o,(0,j.$9g)(this.profilesHome,i),this.g,a,this.defaultProfile);await this.u.createFolder(v.location);const k=[];return this.j.fire({profile:v,join(P){k.push(P)}}),await p.Promises.settled(k),this.I([v],[],[]),v}finally{this.r.delete(o)}})(),this.r.set(o,b)),b}async updateProfile(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(b=>b.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=t(a.id,o.name??a.name,a.location,this.g,{shortName:o.shortName??a.shortName,icon:o.icon===null?void 0:o.icon??a.icon,transient:o.transient??a.isTransient,useDefaultFlags:o.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(b=>b.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this.m.fire({profile:o,join(b){a.push(b)}});try{await Promise.allSettled(a)}catch(b){this.y.error(b)}for(const b of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(b)?.id&&this.C.emptyWindows.delete(b);for(const b of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(b)?.id&&this.C.workspaces.delete(b);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(b){(0,f.$gl)(b)!==1&&this.y.error(b)}}async setProfileForWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(b=>b.id===o.id);if(!a)throw new Error(`Profile '${o.name}' does not exist`);this.L(i,a)}unsetWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(i,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const i=await this.u.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(o=>o.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(i.map(o=>this.removeProfile(o)))}getProfileForWorkspace(i){const o=this.G(i);return O.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(i){return(0,w.$Fi)(i)?i.uri:(0,w.$Ki)(i)?i.configPath:i.id}H(i){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,i.location)))}I(i,o,a){const b=[...this.profiles,...i],S=[];this.s.profiles=[];for(let v of b)v.isDefault||o.some(k=>v.id===k.id)||(v=a.find(k=>v.id===k.id)??v,v.isTransient?this.s.profiles.push(v):S.push({location:v.location,name:v.name,shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags}));this.P(S),this.z=void 0,this.J(i,o,a)}J(i,o,a){this.h.fire({added:i,removed:o,updated:a,all:this.profiles})}L(i,o,a){a=o?.isTransient?!0:a,a||this.L(i,void 0,!0);const b=this.G(i),S=a?this.s:this.C;O.URI.isUri(b)?(S.workspaces.delete(b),o&&S.workspaces.set(b,o)):(S.emptyWindows.delete(b),o&&S.emptyWindows.set(b,o)),a||this.M()}M(){const i={};for(const[a,b]of this.C.workspaces.entries())i[a.toString()]=b.id;const o={};for(const[a,b]of this.C.emptyWindows.entries())o[a.toString()]=b.id;this.R({workspaces:i,emptyWindows:o}),this.z=void 0}N(i){const o={},a=this.D();if(i.workspaces)for(const[S,v]of Object.entries(i.workspaces)){const k=O.URI.parse(v);o[S]=this.w.extUri.isEqual(k,a.location)?a.id:this.w.extUri.basename(k)}const b={};if(i.emptyWindows)for(const[S,v]of Object.entries(i.emptyWindows)){const k=O.URI.parse(v);b[S]=this.w.extUri.isEqual(k,a.location)?a.id:this.w.extUri.basename(k)}return{workspaces:o,emptyWindows:b}}O(){return[]}P(i){throw new Error("not implemented")}Q(){return{}}R(i){throw new Error("not implemented")}S(){}};e.$El=r,e.$El=r=Ee([Z(0,C.$Ci),Z(1,f.$2k),Z(2,c.$zl),Z(3,y.$2j)],r);class n extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(i){this.a=i}Q(){return this.X}R(i){this.X=i}}e.$Fl=n}),define(ae[249],ce([0,1,6,2,18]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;let j=class extends N.$Vc{constructor(R){super(),this.B(new A.$Hh(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$iec=j,e.$iec=j=Ee([Z(0,L.$Bl)],j)}),define(ae[250],ce([0,1,17,6,26,7,3,2,5,13,8,156,29,33,48,9,24,22,28,18]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$kq=void 0,e.$lq=$;let d=class extends R.$Vc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,i,o,a,b,S){super(),this.z=s,this.C=i,this.D=o,this.F=a,this.G=b,this.H=S,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$ee),this.s=this.B(new O.$ee),this.t=this.B(new O.$ee),this.u=this.B(new O.$ee),this.w=this.B(new O.$ee),this.y=[],this.B((0,R.$Tc)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.m.forEach(v=>v.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const i=await this.getTargetPlatform();return s.allTargetPlatforms.some(o=>(0,w.$3o)(o,s.allTargetPlatforms,i))}async installFromGallery(s,i={}){try{const a=(await this.installGalleryExtensions([{extension:s,options:i}])).find(({identifier:b})=>(0,h.$tp)(b,s.identifier));if(a?.local)return a?.local;throw a?.error?a.error:new w.$6o(`Unknown error while installing extension ${s.identifier.id}`,w.ExtensionManagementErrorCode.Unknown)}catch(o){throw $(o)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new w.$6o(y.localize(0,null),w.ExtensionManagementErrorCode.NotAllowed);const i=[],o=[];return await Promise.allSettled(s.map(async({extension:a,options:b})=>{try{const S=await this.N(a,!!b?.installGivenVersion,!!b?.installPreReleaseVersion,b.productVersion??{version:this.G.version,date:this.G.date});o.push({...S,options:b})}catch(S){i.push({identifier:a.identifier,operation:2,source:a,error:S})}})),o.length&&i.push(...await this.I(o)),i}async uninstall(s,i={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,i)}async toggleAppliationScope(s,i){if((0,c.$Tm)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let o=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(i,this.H.defaultProfile.extensionsResource)||(o=await this.$(s,this.H.defaultProfile.extensionsResource,i));for(const a of this.H.profiles){const b=(await this.getInstalled(1,a.extensionsResource)).find(S=>(0,h.$tp)(S.identifier,s.identifier));b?this.w.fire(b):this.u.fire({identifier:s.identifier,profileLocation:a.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(i,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,i,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const i=new Map,o=new Map,a=[],b=(v,k)=>`${h.$up.create(v).toString()}-${k.toString()}`,S=(v,k,P,I)=>{const F=this.Y(v,k,P),T=`${(0,h.$yp)(v.publisher,v.name)}-${P.profileLocation.toString()}`;o.set(T,{task:F,root:I}),this.n.fire({identifier:F.identifier,source:k,profileLocation:P.profileLocation}),this.F.info("Installing extension:",F.identifier.id),E.URI.isUri(k)||this.j.set(b(k,P.profileLocation),{task:F,waitingTasks:[]})};try{for(const{manifest:v,extension:k,options:P}of s){const I=P.isApplicationScoped||P.isBuiltin||(0,c.$Tm)(v),F={...P,installOnlyNewlyAddedFromExtensionPack:P.installOnlyNewlyAddedFromExtensionPack??!E.URI.isUri(k),isApplicationScoped:I,profileLocation:I?this.H.defaultProfile.extensionsResource:P.profileLocation??this.X(),productVersion:P.productVersion??{version:this.G.version,date:this.G.date}},T=E.URI.isUri(k)?void 0:this.j.get(b(k,F.profileLocation));T?(this.F.info("Extension is already requested to install",T.task.identifier.id),a.push(T.task.waitUntilTaskIsFinished())):S(v,k,F,void 0)}return await Promise.all([...o.values()].map(async({task:v})=>{if(v.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const k=await this.M(v.identifier,v.manifest,!!v.options.installOnlyNewlyAddedFromExtensionPack,!!v.options.installPreReleaseVersion,v.options.profileLocation,v.options.productVersion),P=await this.getInstalled(void 0,v.options.profileLocation,v.options.productVersion),I={...v.options,context:{...v.options.context,[w.$Xo]:!0}};for(const{gallery:F,manifest:T}of(0,A.$Mb)(k,({gallery:q})=>q.identifier.id)){if(o.has(`${F.identifier.id.toLowerCase()}-${I.profileLocation.toString()}`))continue;const q=this.j.get(b(F,I.profileLocation));if(q){if(this.J(v,q.task)){const X=q.task.identifier;this.F.info("Waiting for already requested installing extension",X.id,v.identifier.id),q.waitingTasks.push(v),a.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,G=>G.some(Q=>(0,h.$tp)(Q.identifier,X)))).then(G=>{if(this.F.info("Finished waiting for already requested installing extension",X.id,v.identifier.id),!G.find(W=>(0,h.$tp)(W.identifier,X))?.local)throw new Error(`Extension ${X.id} is not installed`)}))}}else P.some(({identifier:X})=>(0,h.$tp)(X,F.identifier))||S(T,F,I,v)}}catch(k){if(E.URI.isUri(v.source))(0,A.$Lb)(v.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",v.identifier.id,k.message),(0,A.$Lb)(v.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",v.identifier.id,k.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),k}})),await this.L([...o.entries()].map(async([v,{task:k}])=>{const P=new Date().getTime();try{const I=await k.run();if(await this.L(this.y.map(F=>F.postInstall(I,k.source,k.options,L.CancellationToken.None))),!E.URI.isUri(k.source)){const F=k.operation===3,T=F?void 0:(new Date().getTime()-k.source.lastUpdated)/1e3;if(t(this.C,F?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$Bp)(k.source),verificationStatus:k.verificationStatus,duration:new Date().getTime()-P,durationSinceUpdate:T}),C.$o&&k.operation!==3)try{await this.z.reportStatistic(I.manifest.publisher,I.manifest.name,I.manifest.version,"install")}catch{}}i.set(v,{local:I,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.profileLocation,applicationScoped:I.isApplicationScoped})}catch(I){const F=$(I);throw E.URI.isUri(k.source)||t(this.C,k.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$Bp)(k.source),error:F}),i.set(v,{error:F,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.profileLocation,applicationScoped:k.options.isApplicationScoped}),this.F.error("Error while installing the extension",k.identifier.id,(0,j.$0)(F)),F}})),a.length&&await this.L(a),[...i.values()]}catch(v){const k=(F,T,q)=>{const X=[];F.manifest.extensionDependencies?.length&&X.push(...F.manifest.extensionDependencies),F.manifest.extensionPack?.length&&X.push(...F.manifest.extensionPack);for(const G of X){if(q.includes(G.toLowerCase()))continue;q.push(G.toLowerCase());const Q=i.get(`${G.toLowerCase()}-${T.toString()}`);Q?.local&&(q=k(Q.local,T,q))}return q},P=F=>({identifier:F.identifier,operation:2,source:F.source,context:F.options.context,profileLocation:F.profileLocation,error:v}),I=[];for(const[F,{task:T,root:q}]of o){const X=i.get(F);X?X.local&&q&&!i.get(`${q.identifier.id.toLowerCase()}-${T.profileLocation.toString()}`)?.local&&(I.push(this.Z(X.local,{versionOnly:!0,profileLocation:T.profileLocation})),i.set(F,P(T))):(T.cancel(),i.set(F,P(T)))}for(const[F,{task:T}]of o){const q=i.get(F);if(!q?.local||T.options.donotIncludePackAndDependencies)continue;k(q.local,T.profileLocation,[q.local.identifier.id.toLowerCase()]).slice(1).some(G=>o.has(`${G.toLowerCase()}-${T.profileLocation.toString()}`)&&!i.get(`${G.toLowerCase()}-${T.profileLocation.toString()}`)?.local)&&(I.push(this.Z(q.local,{versionOnly:!0,profileLocation:T.profileLocation})),i.set(F,P(T)))}throw I.length&&await Promise.allSettled(I.map(async F=>{try{await F.run(),this.F.info("Rollback: Uninstalled extension",F.extension.identifier.id)}catch(T){this.F.warn("Rollback: Error while uninstalling extension",F.extension.identifier.id,(0,j.$0)(T))}})),v}finally{for(const{task:v}of o.values())v.source&&!E.URI.isUri(v.source)&&this.j.delete(b(v.source,v.profileLocation));if(i.size){const v=[...i.values()];for(const k of v)k.local&&this.F.info("Extension installed successfully:",k.identifier.id);this.s.fire(v)}}}J(s,i){for(const[,{task:o,waitingTasks:a}]of this.j.entries())if(o===s&&(a.includes(i)||a.some(b=>this.J(b,i)))||o===i&&a[0]&&!this.J(s,a[0]))return!1;return!0}async L(s){const i=[],o=[],a=await Promise.allSettled(s);for(const b of a)b.status==="fulfilled"?i.push(b.value):o.push(b.reason);if(o.length){if(o.length===1)throw o[0];let b=new w.$6o("",w.ExtensionManagementErrorCode.Unknown);for(const S of o){const v=S instanceof w.$6o?S.code:w.ExtensionManagementErrorCode.Unknown;b=new w.$6o(S.message?`${S.message}, ${b.message}`:b.message,v!==w.ExtensionManagementErrorCode.Unknown&&v!==w.ExtensionManagementErrorCode.Internal?v:b.code)}throw b}return i}async M(s,i,o,a,b,S){if(!this.z.isEnabled())return[];const v=await this.getInstalled(void 0,b,S),k=[],P=[],I=async(F,T)=>{k.push(F);const q=T.extensionDependencies||[],X=[...q];if(T.extensionPack){const G=o?v.find(Q=>(0,h.$tp)(Q.identifier,F)):void 0;for(const Q of T.extensionPack)G&&G.manifest.extensionPack&&G.manifest.extensionPack.some(W=>(0,h.$tp)({id:W},{id:Q}))||X.every(W=>!(0,h.$tp)({id:W},{id:Q}))&&X.push(Q)}if(X.length){const G=X.filter(Q=>k.every(W=>!(0,h.$tp)(W,{id:Q})));if(G.length){const Q=await this.z.getExtensions(G.map(W=>({id:W,preRelease:a})),L.CancellationToken.None);for(const W of Q){if(k.find(B=>(0,h.$tp)(B,W.identifier)))continue;const J=q.some(B=>(0,h.$tp)({id:B},W.identifier));let H;try{H=await this.N(W,!1,a,S)}catch(B){if(J)throw B;this.F.info("Skipping the packed extension as it cannot be installed",W.identifier.id,(0,j.$0)(B));continue}P.push({gallery:H.extension,manifest:H.manifest}),await I(H.extension.identifier,H.manifest)}}}};return await I(s,i),P}async N(s,i,o,a){let b;const S=await this.getExtensionsControlManifest();if(S.malicious.some(P=>(0,h.$tp)(s.identifier,P)))throw new w.$6o(y.localize(1,null,s.identifier.id),w.ExtensionManagementErrorCode.Malicious);const v=S.deprecated[s.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),b=(await this.z.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:a},L.CancellationToken.None))[0],!b)throw new w.$6o(y.localize(2,null,s.identifier.id,v.extension.id),w.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const P=await this.getTargetPlatform();throw new w.$6o(y.localize(3,null,s.identifier.id,this.G.nameLong,(0,w.$Yo)(P)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(b=await this.O(s,i,o,a),!b)throw!o&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],L.CancellationToken.None))[0]?new w.$6o(y.localize(4,null,s.displayName??s.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.$6o(y.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),w.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",b.identifier.id);const k=await this.z.getManifest(b,L.CancellationToken.None);if(k===null)throw new w.$6o(`Missing manifest for extension ${b.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(k.version!==b.version)throw new w.$6o(`Cannot install '${b.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:b,manifest:k}}async O(s,i,o,a){const b=await this.getTargetPlatform();let S=null;return!i&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==o&&(S=(await this.z.getExtensions([{...s.identifier,preRelease:o}],{targetPlatform:b,compatible:!0,productVersion:a},L.CancellationToken.None))[0]||null),!S&&await this.z.isExtensionCompatible(s,o,b,a)&&(S=s),S||(i?S=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:b,compatible:!0,productVersion:a},L.CancellationToken.None))[0]||null:S=await this.z.getCompatibleExtension(s,o,b,a)),S}async P(s,i){const o={...i,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:i.profileLocation??this.X()},a=I=>`${I.id.toLowerCase()}${o.versionOnly?`-${s.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,b=this.m.get(a(s.identifier));if(b)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),b.waitUntilTaskIsFinished();const S=I=>{const F=this.Z(I,o);return this.m.set(a(F.extension.identifier),F),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${I.identifier.id}@${I.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${I.identifier.id}@${I.manifest.version}`),this.t.fire({identifier:I.identifier,profileLocation:o.profileLocation,applicationScoped:I.isApplicationScoped}),F},v=(I,F)=>{F?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${I.identifier.id}@${I.manifest.version}`,o.profileLocation.toString(),F.message):this.F.error("Failed to uninstall extension:",`${I.identifier.id}@${I.manifest.version}`,F.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${I.identifier.id}@${I.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${I.identifier.id}@${I.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,h.$Ap)(I),error:F}),this.u.fire({identifier:I.identifier,error:F?.code,profileLocation:o.profileLocation,applicationScoped:I.isApplicationScoped})},k=[],P=[];try{k.push(S(s));const I=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const F=this.S(s,I);for(const T of F)this.m.has(a(T.identifier))?this.F.info("Extensions is already requested to uninstall",T.identifier.id):k.push(S(T))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(k.map(F=>F.extension),I,s),await this.L(k.map(async F=>{try{if(await F.run(),await this.L(this.y.map(T=>T.postUninstall(F.extension,o,L.CancellationToken.None))),F.extension.identifier.uuid)try{await this.z.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}v(F.extension)}catch(T){const q=$(T);throw v(F.extension,q),q}finally{P.push(F)}}))}catch(I){const F=$(I);for(const T of k){try{T.cancel()}catch{}P.includes(T)||v(T.extension,F)}throw F}finally{for(const I of k)this.m.delete(a(I.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",I.extension.identifier.id)}}Q(s,i,o){for(const a of s){const b=this.U(a,i);if(b.length){const S=b.filter(v=>!s.some(k=>(0,h.$tp)(k.identifier,v.identifier)));if(S.length)throw new Error(this.R(a,S,o))}}}R(s,i,o){return o===s?i.length===1?y.localize(6,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?y.localize(7,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):y.localize(8,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?y.localize(9,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?y.localize(10,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):y.localize(11,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}S(s,i,o=[]){if(o.indexOf(s)!==-1)return[];o.push(s);const a=s.manifest.extensionPack?s.manifest.extensionPack:[];if(a.length){const b=i.filter(v=>!v.isBuiltin&&a.some(k=>(0,h.$tp)({id:k},v.identifier))),S=[];for(const v of b)S.push(...this.S(v,i,o));return[...b,...S]}return[]}U(s,i){return i.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(a=>(0,h.$tp)({id:a},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,j.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$kq=d,e.$kq=d=Ee([Z(0,w.$5o),Z(1,l.$1l),Z(2,u.$zl),Z(3,p.$2j),Z(4,g.$ik),Z(5,m.$Bl)],d);function $(n){if(n instanceof w.$6o)return n;if(n instanceof w.$7o){const i=new w.$6o(n.message,w.ExtensionManagementErrorCode.Gallery);return i.stack=n.stack,i}const s=new w.$6o(n.message,(0,j.$4)(n)?w.ExtensionManagementErrorCode.Cancelled:w.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}function t(n,s,{extensionData:i,verificationStatus:o,duration:a,error:b,durationSinceUpdate:S}){let v,k;(0,f.$dg)(o)&&(o===!0?o="Verified":(o===!1||(v=w.ExtensionManagementErrorCode.Signature,k=o),o="Unverified")),b&&(v=b.code,b.code===w.ExtensionManagementErrorCode.Signature&&(k=b.message)),n.publicLog(s,{...i,verificationStatus:o,success:!b,duration:a,errorcode:v,errorcodeDetail:k,durationSinceUpdate:S})}class r{constructor(){this.d=new N.$uh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,N.$ih)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$ih)(s=>new Promise((i,o)=>{const a=s.onCancellationRequested(()=>{a.dispose(),o(new j.$5)})})),this.d.open()),this.g.cancel()}}e.$mq=r}),define(ae[52],ce([0,1,6,15,2,3,34,8,29,33,12,4,9,18,28,13,7,22]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=e.$nq=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class m extends Error{constructor(n,s){super(n),this.code=s}}e.$nq=m,e.$oq=(0,y.$vi)("IExtensionsProfileScannerService");let d=class extends L.$Vc{constructor(n,s,i,o,a,b){super(),this.j=n,this.m=s,this.n=i,this.r=o,this.s=a,this.t=b,this.b=this.B(new j.$ee),this.onAddExtensions=this.b.event,this.c=this.B(new j.$ee),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$ee),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$ee),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Bc}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s,i){const o=[],a=[];try{return await this.u(s,b=>{const S=[];if(i)S.push(...b);else for(const v of b)n.some(([k])=>(0,f.$tp)(k.identifier,v.identifier)&&k.manifest.version!==v.version)?o.push(v):S.push(v);for(const[v,k]of n){const P=S.findIndex(F=>(0,f.$tp)(F.identifier,v.identifier)&&F.version===v.manifest.version),I={identifier:v.identifier,version:v.manifest.version,location:v.location,metadata:k};P===-1?(a.push(I),S.push(I)):S.splice(P,1,I)}return a.length&&this.b.fire({extensions:a,profileLocation:s}),o.length&&this.f.fire({extensions:o,profileLocation:s}),S}),a.length&&this.c.fire({extensions:a,profileLocation:s}),o.length&&this.g.fire({extensions:o,profileLocation:s}),a}catch(b){throw a.length&&this.c.fire({extensions:a,error:b,profileLocation:s}),o.length&&this.g.fire({extensions:o,error:b,profileLocation:s}),b}}async updateMetadata(n,s){const i=[];return await this.u(s,o=>{const a=[];for(const b of o){const S=n.find(([v])=>(0,f.$tp)(v.identifier,b.identifier)&&v.manifest.version===b.version);S&&(b.metadata={...b.metadata,...S[1]},i.push(b)),a.push(b)}return a}),i}async removeExtensionFromProfile(n,s){const i=[];try{await this.u(s,o=>{const a=[];for(const b of o)(0,f.$tp)(b.identifier,n.identifier)?i.push(b):a.push(b);return i.length&&this.f.fire({extensions:i,profileLocation:s}),a}),i.length&&this.g.fire({extensions:i,profileLocation:s})}catch(o){throw i.length&&this.g.fire({extensions:i,error:o,profileLocation:s}),o}}async u(n,s,i){return this.F(n).queue(async()=>{let o=[],a;try{const b=await this.m.readFile(n);a=JSON.parse(b.value.toString().trim()||"[]")}catch(b){if((0,E.$gl)(b)!==1)throw b;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&i?.bailOutWhenFileNotFound)throw new m((0,g.$0)(b),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let b=!1;for(const S of a){$(S)||this.w(n);let v;if((0,p.$8f)(S.relativeLocation)&&S.relativeLocation)v=this.z(S.relativeLocation);else if((0,p.$8f)(S.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${S.location}`);continue}else{v=R.URI.revive(S.location);const k=this.y(v);k&&(b=!0,S.relativeLocation=k)}(0,p.$cg)(S.metadata?.hasPreReleaseVersion)&&S.metadata?.preRelease&&(b=!0,S.metadata.hasPreReleaseVersion=!0),o.push({identifier:S.identifier,location:v,version:S.version,metadata:S.metadata})}b&&await this.m.writeFile(n,N.$Fe.fromString(JSON.stringify(a)))}if(s){o=s(o);const b=o.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),relativeLocation:this.y(S.location),metadata:S.metadata}));await this.m.writeFile(n,N.$Fe.fromString(JSON.stringify(b)))}return o})}w(n){const s=new m(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let i;try{i=(await this.m.readFile(n)).value.toString()}catch(a){if((0,E.$gl)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let o;try{const a=JSON.parse(i);Array.isArray(a)&&a.every(b=>$(b))?o=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$Fe.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,E.$gl)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,E.$gl)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,E.$gl)(a)!==1&&this.t.error(a)}return o})()),this.C}F(n){let s=this.h.get(n);return s||(s=new A.$Ch,this.h.set(n,s)),s}};e.$pq=d,e.$pq=d=Ee([Z(1,E.$2k),Z(2,h.$Bl),Z(3,c.$zl),Z(4,l.$1l),Z(5,w.$2j)],d);function $(r){return(0,p.$0f)(r)&&(0,C.$4o)(r.identifier)&&(t(r.location)||(0,p.$8f)(r.location)&&r.location)&&((0,p.$cg)(r.relativeLocation)||(0,p.$8f)(r.relativeLocation))&&r.version&&(0,p.$8f)(r.version)}function t(r){return r?(0,p.$8f)(r.path)&&(0,p.$8f)(r.scheme):!1}}),define(ae[81],ce([0,1,17,6,30,15,7,35,138,2,23,14,5,20,55,88,13,8,159,16,33,48,71,12,4,9,24,3,66,52,18,28,188]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s,i,o,a,b,S,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$uq=e.$tq=e.$sq=e.Translations=void 0,e.$vq=X;var P;(function(Q){function W(J,H){if(J===H)return!0;const B=Object.keys(J),ie=new Set;for(const re of Object.keys(H))ie.add(re);if(B.length!==ie.size)return!1;for(const re of B){if(J[re]!==H[re])return!1;ie.delete(re)}return ie.size===0}Q.equals=W})(P||(e.Translations=P={})),e.$sq=(0,n.$vi)("IExtensionsScannerService");let I=class extends f.$Vc{constructor(W,J,H,B,ie,re,he,te,V,U,D,M){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=J,this.r=H,this.s=B,this.t=ie,this.u=re,this.w=he,this.y=te,this.z=V,this.C=U,this.D=D,this.F=M,this.g=this.B(new o.$ee),this.onDidChangeCache=this.g.event,this.h=(0,h.$9g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(T,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,d.$Ep)(this.w,this.y)),this.G}async scanAllExtensions(W,J,H){const[B,ie]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(J)]),re=H?await this.scanExtensionsUnderDevelopment(W,[...B,...ie]):[];return this.L(B,ie,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const J=[];J.push(this.M(!!W.useCache,W.language)),J.push(this.N(W.language,!!W.checkControlFile));const[H,B]=await Promise.all(J);return this.J([...H,...B],0,W,!1)}async scanUserExtensions(W){const J=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",J);const H=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(J,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,H,W.productVersion??this.R()),ie=W.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let re;try{re=await ie.scanExtensions(B)}catch(he){if(he instanceof b.$nq&&he.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),re=await ie.scanExtensions(B);else throw he}return re=await this.J(re,1,W,!0),this.y.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(W,J){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===E.Schemas.file).map(async B=>{const ie=await this.P(B,!1,1,!0,W.language,!1,void 0,W.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ie)).map(he=>(he.type=J.find(te=>(0,d.$tp)(te.identifier,he.identifier))?.type??he.type,this.n.validate(he,ie)))}))).flat();return this.J(H,"development",W,!0)}return[]}async scanExistingExtension(W,J,H){const B=await this.P(W,!1,J,!0,H.language,!0,void 0,H.productVersion??this.R()),ie=await this.n.scanExtension(B);return!ie||!H.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(W,J,H){const B=await this.P(W,!1,J,!0,H.language,!0,void 0,H.productVersion??this.R()),ie=await this.n.scanOneOrMultipleExtensions(B);return this.J(ie,J,H,!0)}async scanMultipleExtensions(W,J,H){const B=[];return await Promise.all(W.map(async ie=>{const re=await this.scanOneOrMultipleExtensions(ie,J,H);B.push(...re)})),this.J(B,J,H,!0)}async scanMetadata(W){const J=(0,h.$9g)(W,"package.json"),H=(await this.w.readFile(J)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(W,J){const H=(0,h.$9g)(W,"package.json"),B=(await this.w.readFile(H)).value.toString(),ie=JSON.parse(B);J.isMachineScoped===!1&&delete J.isMachineScoped,J.isBuiltin===!1&&delete J.isBuiltin,ie.__metadata={...ie.__metadata,...J},await this.w.writeFile((0,h.$9g)(W,"package.json"),j.$Fe.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof b.$nq&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(J=>[J,J.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$Fe.fromString(JSON.stringify([])))}catch(J){(0,r.$gl)(J)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$0)(J))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,J,H,B){return H.includeAllVersions||(W=this.L(J===0?W:void 0,J===1?W:void 0,J==="development"?W:void 0,await this.getTargetPlatform(),B)),H.includeInvalid||(W=W.filter(ie=>ie.isValid)),W.sort((ie,re)=>{const he=y.$oc(ie.location.fsPath),te=y.$oc(re.location.fsPath);return he<te?-1:he>te?1:0})}L(W,J,H,B,ie){const re=(te,V,U)=>{if(te.isValid&&!V.isValid)return!1;if(te.isValid===V.isValid){if(ie&&c.gt(te.manifest.version,V.manifest.version))return this.y.debug(`Skipping extension ${V.location.path} with lower version ${V.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if(c.eq(te.manifest.version,V.manifest.version)){if(te.type===0)return this.y.debug(`Skipping extension ${V.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===B)return this.y.debug(`Skipping extension ${V.location.path} from different target platform ${V.targetPlatform}`),!1}}return U?this.y.warn(`Overwriting user extension ${te.location.path} with ${V.location.path}.`):this.y.debug(`Overwriting user extension ${te.location.path} with ${V.location.path}.`),!0},he=new $.$Sm;return W?.forEach(te=>{const V=he.get(te.identifier.id);(!V||re(V,te,!1))&&he.set(te.identifier.id,te)}),J?.forEach(te=>{const V=he.get(te.identifier.id);if(!V&&W&&te.type===0){this.y.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!V||re(V,te,!1))&&he.set(te.identifier.id,te)}),H?.forEach(te=>{const V=he.get(te.identifier.id);(!V||re(V,te,!0))&&he.set(te.identifier.id,te),he.set(te.identifier.id,te)}),[...he.values()]}async M(W,J){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0,this.R()),ie=await(W&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",ie.length),ie}async N(W,J){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const B=J?await this.O():{},ie=[],re=l.URI.file(y.$ic(y.$kc(E.$Pg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const te of H){const V=B[te.name]||"marketplace";switch(V){case"disabled":break;case"marketplace":ie.push((0,h.$9g)(re,te.name));break;default:ie.push(l.URI.file(V));break}}const he=await Promise.all(ie.map(async te=>this.n.scanExtension(await this.P(te,!1,0,!0,W,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",he.length),(0,A.$Hb)(he)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,J,H,B,ie,re,he,te){const V=await this.f(ie??w.$w),U=await this.Q(W),D=J&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=D?await this.Q(D):void 0;return new F(W,U,D,M,J,he,H,B,re,te.version,te.date,this.C.commit,!this.z.isBuilt,ie,V)}async Q(W){try{const J=await this.w.stat(W);if(typeof J.mtime=="number")return J.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$tq=I,e.$tq=I=Ee([Z(4,S.$Bl),Z(5,b.$oq),Z(6,r.$2k),Z(7,s.$2j),Z(8,m.$Ci),Z(9,i.$ik),Z(10,v.$zl),Z(11,n.$ui)],I);class F{constructor(W,J,H,B,ie,re,he,te,V,U,D,M,z,x,K){this.location=W,this.mtime=J,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=B,this.profile=ie,this.profileScanOptions=re,this.type=he,this.excludeObsolete=te,this.validate=V,this.productVersion=U,this.productDate=D,this.productCommit=M,this.devMode=z,this.language=x,this.translations=K}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,J){return(0,h.$2g)(W.location,J.location)&&W.mtime===J.mtime&&(0,h.$2g)(W.applicationExtensionslocation,J.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&W.profile===J.profile&&L.$6n(W.profileScanOptions,J.profileScanOptions)&&W.type===J.type&&W.excludeObsolete===J.excludeObsolete&&W.validate===J.validate&&W.productVersion===J.productVersion&&W.productDate===J.productDate&&W.productCommit===J.productCommit&&W.devMode===J.devMode&&W.language===J.language&&P.equals(W.translations,J.translations)}}e.$uq=F;let T=class extends f.$Vc{constructor(W,J,H,B,ie){super(),this.f=W,this.g=J,this.h=H,this.j=B,this.m=ie}async scanExtensions(W){const J=W.profile?await this.r(W):await this.n(W);let H={};if(W.excludeObsolete&&W.type===1)try{const B=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(B)}catch{}return(0,g.$ig)(H)?J:J.filter(B=>!H[d.$up.create(B).toString()])}async n(W){const J=await this.j.resolve(W.location);if(!J.children?.length)return[];const H=await Promise.all(J.children.map(async B=>{if(!B.isDirectory||W.type===1&&(0,h.$6g)(B.resource).indexOf(".")===0)return null;const ie=new F(B.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(ie)}));return(0,A.$Hb)(H).sort((B,ie)=>B.location.path<ie.location.path?-1:1)}async r(W){let J=await this.s(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.h.extUri.isEqual(W.location,W.applicationExtensionslocation)){J=J.filter(B=>!B.metadata?.isApplicationScoped);const H=await this.s(W.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,W);J.push(...H)}return J}async s(W,J,H){const B=await this.g.scanProfileExtensions(W,H.profileScanOptions);if(!B.length)return[];const ie=await Promise.all(B.map(async re=>{if(J(re)){const he=new F(re.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(he,re.metadata)}return null}));return(0,A.$Hb)(ie)}async scanOneOrMultipleExtensions(W){try{if(await this.j.exists((0,h.$9g)(W.location,"package.json"))){const J=await this.scanExtension(W);return J?[J]:[]}else return await this.scanExtensions(W)}catch(J){return this.m.error(`Error scanning extensions at ${W.location.path}:`,(0,O.$0)(J)),[]}}async scanExtension(W,J){try{let H=await this.scanExtensionManifest(W.location);if(H){H.publisher||(H.publisher=$.$Mm),J=J??H.__metadata,delete H.__metadata;const B=(0,d.$yp)(H.publisher,H.name),ie=J?.id?{id:B,uuid:J.id}:{id:B},re=J?.isSystem?0:W.type,he=re===0||!!J?.isBuiltin;H=await this.t(W.location,H,F.createNlsConfiguration(W));const te={type:re,identifier:ie,manifest:H,location:W.location,isBuiltin:he,targetPlatform:J?.targetPlatform??"undefined",publisherDisplayName:J?.publisherDisplayName,metadata:J,isValid:!0,validations:[]};return W.validate?this.validate(te,W):te}}catch(H){W.type!==0&&this.m.error(H)}return null}validate(W,J){let H=!0;const B=(0,t.$Jp)(J.productVersion,J.productDate,J.location,W.manifest,W.isBuiltin);for(const[ie,re]of B)ie===p.default.Error&&(H=!1,this.m.error(this.z(J.location,re)));return W.isValid=H,W.validations=B,W}async scanExtensionManifest(W){const J=(0,h.$9g)(W,"package.json");let H;try{H=(await this.j.readFile(J)).value.toString()}catch(ie){return(0,r.$gl)(ie)!==1&&this.m.error(this.z(W,(0,u.localize)(0,null,J.path,ie.message))),null}let B;try{B=JSON.parse(H)}catch{const re=[];(0,R.$In)(H,re);for(const he of re)this.m.error(this.z(W,(0,u.localize)(1,null,J.path,he.offset,he.length,(0,C.$qq)(he.error))));return null}return(0,R.$Rn)(B)!=="object"?(this.m.error(this.z(W,(0,u.localize)(2,null,J.path))),null):B}async t(W,J,H){const B=await this.u(W,J,H);if(B)try{const ie=[],re=await this.w(B.default,ie);if(ie.length>0)return ie.forEach(te=>{this.m.error(this.z(W,(0,u.localize)(3,null,B.default?.path,(0,C.$qq)(te.error))))}),J;if((0,R.$Rn)(B)!=="object")return this.m.error(this.z(W,(0,u.localize)(4,null,B.default?.path))),J;const he=B.values||Object.create(null);return(0,k.$rq)(this.m,J,he,re)}catch{}return J}async u(W,J,H){const B=(0,h.$9g)(W,"package.nls.json"),ie=(V,U)=>{U.forEach(D=>{this.m.error(this.z(W,(0,u.localize)(5,null,V?.path,(0,C.$qq)(D.error))))})},re=V=>{this.m.error(this.z(W,(0,u.localize)(6,null,V?.path)))},he=`${J.publisher}.${J.name}`,te=H.translations[he];if(te)try{const V=l.URI.file(te),U=(await this.j.readFile(V)).value.toString(),D=[],M=(0,R.$In)(U,D);return D.length>0?(ie(V,D),{values:void 0,default:B}):(0,R.$Rn)(M)!=="object"?(re(V),{values:void 0,default:B}):{values:M.contents?M.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.j.exists(B))return;let U;try{U=await this.y(W,H)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const D=(await this.j.readFile(U.localized)).value.toString(),M=[],z=(0,R.$In)(D,M);return M.length>0?(ie(U.localized,M),{values:void 0,default:U.original}):(0,R.$Rn)(z)!=="object"?(re(U.localized),{values:void 0,default:U.original}):{values:z,default:U.original}}catch{return{values:void 0,default:U.original}}}}async w(W,J){if(W)try{const H=(await this.j.readFile(W)).value.toString();return(0,R.$In)(H,J)}catch{}}y(W,J){return new Promise((H,B)=>{const ie=re=>{const he=(0,h.$9g)(W,`package.nls.${re}.json`);this.j.exists(he).then(te=>{te&&H({localized:he,original:(0,h.$9g)(W,"package.nls.json")});const V=re.lastIndexOf("-");V===-1?H({localized:(0,h.$9g)(W,"package.nls.json"),original:null}):(re=re.substring(0,V),ie(re))})};if(J.devMode||J.pseudo||!J.language)return H({localized:(0,h.$9g)(W,"package.nls.json"),original:null});ie(J.language)})}z(W,J){return`[${W.path}]: ${J}`}};T=Ee([Z(1,b.$oq),Z(2,v.$zl),Z(3,r.$2k),Z(4,s.$2j)],T);let q=class extends T{constructor(W,J,H,B,ie,re,he){super(J,B,ie,re,he),this.G=W,this.H=H,this.D=this.B(new N.$th(3e3)),this.F=this.B(new o.$ee),this.onDidChangeCache=this.F.event}async scanExtensions(W){const J=this.M(W),H=await this.I(J);if(this.C=W,H&&H.input&&F.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",W.location.toString()),this.D.trigger(()=>this.L()),H.result.map(ie=>(ie.location=l.URI.revive(ie.location),ie));const B=await super.scanExtensions(W);return await this.J(J,{input:W,result:B}),B}async I(W){try{const J=await this.j.readFile(W),H=JSON.parse(J.value.toString());return{result:H.result,input:(0,a.$5h)(H.input)}}catch(J){this.m.debug("Error while reading the extension cache file:",W.path,(0,O.$0)(J))}return null}async J(W,J){try{await this.j.writeFile(W,j.$Fe.fromString(JSON.stringify(J)))}catch(H){this.m.debug("Error while writing the extension cache file:",W.path,(0,O.$0)(H))}}async L(){if(!this.C)return;const W=this.M(this.C),J=await this.I(W);if(!J)return;const H=J.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!L.$6n(B,H))try{this.m.info("Invalidating Cache",H,B),await this.j.del(W),this.F.fire()}catch(ie){this.m.error(ie)}}M(W){const J=this.N(W);return this.h.extUri.joinPath(J.cacheHome,W.type===0?$.$Lm:$.$Km)}N(W){return W.type===0?this.H.defaultProfile:W.profile?this.h.extUri.isEqual(W.location,this.G.extensionsResource)?this.G:this.H.profiles.find(J=>this.h.extUri.isEqual(W.location,J.extensionsResource))??this.G:this.H.defaultProfile}};q=Ee([Z(2,S.$Bl),Z(3,b.$oq),Z(4,v.$zl),Z(5,r.$2k),Z(6,s.$2j)],q);function X(Q,W){const J=(0,d.$wp)(Q.manifest.publisher,Q.manifest.name);return{id:J,identifier:new $.$Qm(J),isBuiltin:Q.type===0,isUserBuiltin:Q.type===1&&Q.isBuiltin,isUnderDevelopment:W,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,publisherDisplayName:Q.publisherDisplayName,...Q.manifest}}class G extends I{constructor(W,J,H,B,ie,re,he,te,V,U,D,M){super(W,J,(0,h.$9g)(H,".vscode-oss-dev","extensions","control.json"),B,ie,re,he,te,V,U,D,M),this.S=(async()=>{if(w.$z)try{const z=await this.w.readFile(l.URI.file(w.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(W){return this.S}}e.$wq=G}),define(ae[251],ce([0,1,67,6,38,3,2,23,14,31,9,18]),function(ne,e,A,N,L,j,O,R,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=void 0;let w=class extends O.$Vc{constructor(c,p){super(),this.b=c,this.f=p,this.a=new N.$Bh(5)}async postUninstall(c){const p=this.g(c,"uninstall");p&&(this.f.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,c),this.f.info("Finished running post uninstall script",c.identifier.id,c.manifest.version)}catch(g){this.f.error("Failed to run post uninstall script",c.identifier.id,c.manifest.version),this.f.error(g)}}));try{await f.Promises.rm(this.m(c))}catch(g){this.f.error("Error while removing extension storage path",c.identifier.id),this.f.error(g)}}g(c,p){const g=`vscode:${p}`;if(c.location.scheme===R.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[g]=="string"){const l=c.manifest.scripts[g].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(c.identifier.id,c.manifest.version,`${g} should be a node script`),null):{script:(0,C.$kc)(c.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(c,p,g,l,u){return new Promise((m,d)=>{const $=this.j(c,p,g,u);let t;const r=n=>{t&&(clearTimeout(t),t=null),n?d(n):m(void 0)};$.on("error",n=>{r((0,L.$gj)(n)||"Unknown")}),$.on("exit",(n,s)=>{r(n?`post-${p} process exited with code ${n}`:void 0)}),l&&(t=setTimeout(()=>{t=null,$.kill(),d("timed out")},5e3))})}j(c,p,g,l){const u={silent:!0,execArgv:void 0},m=(0,A.fork)(c,[`--type=extension-post-${p}`,...g],u);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const d=j.Event.fromNodeEventEmitter(m.stdout,"data"),$=j.Event.fromNodeEventEmitter(m.stderr,"data");d(n=>this.f.info(l.identifier.id,l.manifest.version,`post-${p}`,n)),$(n=>this.f.error(l.identifier.id,l.manifest.version,`post-${p}`,n));const t=j.Event.any(j.Event.map(d,n=>({data:`%c${n}`,format:[""]})),j.Event.map($,n=>({data:`%c${n}`,format:["color: red"]})));return j.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),m}m(c){return(0,C.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};e.$yq=w,e.$yq=w=Ee([Z(0,y.$Bl),Z(1,E.$2j)],w)}),define(ae[113],ce([0,1,6,15,26,38,7,3,54,2,34,23,14,20,55,13,8,32,31,70,160,95,16,250,29,33,52,81,231,251,189,221,232,71,12,4,9,24,22,28,18]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s,i,o,a,b,S,v,k,P,I,F,T,q,X,G,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=e.$Dq=e.$Cq=void 0,e.$Cq=(0,F.$wi)(n.$8o);const W=".vsctmp";let J=class extends r.$kq{constructor(V,U,D,M,z,x,K,ee,_,Y,se,ue){super(V,U,se,D,Y,ue),this.eb=z,this.fb=x,this.gb=K,this.hb=_,this.db=new Map,this.qb=new E.$Cc;const ge=this.B(ee.createInstance(b.$yq));this.ab=this.B(ee.createInstance(H,$e=>ge.postUninstall($e))),this.bb=this.B(new v.$Aq(ue,_,se,this,this.F)),this.cb=this.B(ee.createInstance(a.$xq));const fe=this.B(new k.$Bq(this,this.eb,ue,x,se,_,D));this.B(fe.onDidChangeExtensionsByAnotherSource($e=>this.pb($e))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$Ep)(this.hb,this.F)),this.ib}async zip(V){this.F.trace("ExtensionManagementService#zip",V.identifier.id);const U=await this.ob(V),D=await(0,m.zip)((0,h.$9g)(this.cb.extensionsDownloadDir,(0,l.$Rg)()).fsPath,U);return g.URI.file(D)}async unzip(V){return this.F.trace("ExtensionManagementService#unzip",V.toString()),(await this.install(V)).identifier}async getManifest(V){const{location:U,cleanup:D}=await this.kb(V),M=w.$lc(U.fsPath);try{return await(0,S.$zq)(M)}finally{await D()}}getInstalled(V,U=this.H.defaultProfile.extensionsResource,D={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(V??null,U,D)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(V){return this.ab.scanUserExtensionAtLocation(V)}async install(V,U={}){this.F.trace("ExtensionManagementService#install",V.toString());const{location:D,cleanup:M}=await this.kb(V);try{const z=await(0,S.$zq)(w.$lc(D.fsPath)),x=(0,s.$yp)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,P.$Lp)(z.engines.vscode,this.G.version,this.G.date))throw new Error(d.localize(0,null,x,this.G.version));const ee=(await this.I([{manifest:z,extension:D,options:U}])).find(({identifier:_})=>(0,s.$tp)(_,{id:x}));if(ee?.local)return ee.local;throw ee?.error?ee.error:(0,r.$lq)(new Error(`Unknown error while installing extension ${x}`))}finally{await M()}}async installFromLocation(V,U){this.F.trace("ExtensionManagementService#installFromLocation",V.toString());const D=await this.ab.scanUserExtensionAtLocation(V);if(!D||!D.manifest.name||!D.manifest.version)throw new Error(`Cannot find a valid extension from the location ${V.toString()}`);return await this.tb([[D,{source:"resource"}]],U),this.F.info("Successfully installed extension",D.identifier.id,U.toString()),D}async installExtensionsFromProfile(V,U,D){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",V,U.toString(),D.toString());const M=(await this.getInstalled(1,U)).filter(z=>V.some(x=>(0,s.$tp)(x,z.identifier)));if(M.length){const z=await Promise.all(M.map(x=>this.ab.scanMetadata(x,U)));await this.tb(M.map((x,K)=>[x,z[K]]),D),this.F.info("Successfully installed extensions",M.map(x=>x.identifier.id),D.toString())}return M}async updateMetadata(V,U,D=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",V.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0,U.hasPreReleaseVersion=!0),U.isMachineScoped===!1&&(U.isMachineScoped=void 0),U.isBuiltin===!1&&(U.isBuiltin=void 0),U.pinned===!1&&(U.pinned=void 0),V=await this.ab.updateMetadata(V,U,D),this.bb.invalidate(D),this.w.fire(V),V}async reinstallFromGallery(V){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",V.identifier.id),!this.z.isEnabled())throw new Error(d.localize(1,null));const U=await this.getTargetPlatform(),[D]=await this.z.getExtensions([{...V.identifier,preRelease:V.preRelease}],{targetPlatform:U,compatible:!0},L.CancellationToken.None);if(!D)throw new Error(d.localize(2,null));await this.ab.setUninstalled(V);try{await this.ab.removeUninstalledExtension(V)}catch(M){throw new Error(d.localize(3,null,(0,j.$gj)(M)))}return this.installFromGallery(D)}$(V,U,D,M){return this.ab.copyExtension(V,U,D,M)}copyExtensions(V,U){return this.ab.copyExtensions(V,U,{version:this.G.version,date:this.G.date})}markAsUninstalled(...V){return this.ab.setUninstalled(...V)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(V){this.F.error(V)}}async download(V,U,D){const{location:M}=await this.cb.download(V,U,!D);return M}async kb(V){if(V.scheme===y.Schemas.file)return{location:V,async cleanup(){}};this.F.trace("Downloading extension from",V.toString());const U=(0,h.$9g)(this.cb.extensionsDownloadDir,(0,l.$Rg)());return await this.gb.download(V,U),this.F.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.hb.del(U)}catch(M){this.F.error(M)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(V,U,D){if(g.URI.isUri(U))return new re(V,U,D,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const M=s.$up.create(U).toString();let z=this.db.get(M);return z||(this.db.set(M,z=new ie(V,U,D,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),z.waitUntilTaskIsFinished().finally(()=>this.db.delete(M))),z}Z(V,U){return new he(V,U.profileLocation,this.fb)}async ob(V){const U=async M=>{let z=await u.Promises.readdir(M);z=z.map(ee=>w.$kc(M,ee));const x=await Promise.all(z.map(ee=>u.Promises.stat(ee)));let K=Promise.resolve([]);return x.forEach((ee,_)=>{const Y=z[_];ee.isFile()&&(K=K.then(se=>[...se,Y])),ee.isDirectory()&&(K=K.then(se=>U(Y).then(ue=>[...se,...ue])))}),K};return(await U(V.location.fsPath)).map(M=>({path:`extension/${w.$mc(V.location.fsPath,M)}`,localPath:M}))}async pb({added:V,removed:U}){if(U){const D=V&&this.D.extUri.isEqual(U.profileLocation,V.profileLocation)?U.extensions.filter(M=>V.extensions.every(z=>!(0,s.$tp)(z,M))):U.extensions;for(const M of D)this.F.info("Extensions removed from another source",M.id,U.profileLocation.toString()),this.u.fire({identifier:M,profileLocation:U.profileLocation})}if(V){const M=(await this.getInstalled(1,V.profileLocation)).filter(z=>V.extensions.some(x=>(0,s.$tp)(x,z.identifier)));this.s.fire(M.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,V.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:V.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(U=>this.qb.add(U)));const V=await this.hb.resolve(this.eb.userExtensionsLocation);for(const U of V.children??[])U.isDirectory&&this.qb.add(U.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(U=>this.sb(U)))}async sb(V){if(!V.affects(this.eb.userExtensionsLocation,1))return;const U=[];for(const D of V.rawAdded){if(this.qb.has(D)||!this.D.extUri.isEqual(this.D.extUri.dirname(D),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(D,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(D).startsWith(".")||!(await this.hb.stat(D)).isDirectory)continue;const M=await this.ab.scanUserExtensionAtLocation(D);M&&M.installedTimestamp===void 0&&(this.qb.add(D),U.push(M))}U.length&&(await this.tb(U.map(D=>[D,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",U.map(D=>D.identifier.id)))}async tb(V,U){const D=V.map(M=>M[0]);await this.ub(D),await this.fb.addExtensionsToProfile(V,U),this.s.fire(D.map(M=>({local:M,identifier:M.identifier,operation:1,profileLocation:U})))}async ub(V){const U=await this.ab.getUninstalledExtensions();for(const D of V){const M=s.$up.create(D);U[M.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",M.id),await this.ab.setInstalled(M),this.F.info("Removed the extension from uninstalled list:",M.id))}}};e.$Dq=J,e.$Dq=J=Ee([Z(0,n.$5o),Z(1,X.$1l),Z(2,T.$2j),Z(3,t.$Di),Z(4,o.$sq),Z(5,i.$oq),Z(6,$.$Jo),Z(7,F.$ui),Z(8,I.$2k),Z(9,q.$ik),Z(10,G.$zl),Z(11,Q.$Bl)],J);let H=class extends f.$Vc{constructor(V,U,D,M,z,x){super(),this.j=V,this.m=U,this.n=D,this.s=M,this.t=z,this.u=x,this.h=this.B(new R.$ee),this.onExtract=this.h.event,this.c=(0,h.$9g)(this.n.userExtensionsLocation,".obsolete"),this.g=new A.$Ch}async cleanUp(){await this.H(),await this.G()}async scanExtensions(V,U,D){const M={includeInvalid:!0,profileLocation:U,productVersion:D};let z=[];return V===null||V===0?z.push(...await this.n.scanAllExtensions({includeInvalid:!0},M,!1)):V===1&&z.push(...await this.n.scanUserExtensions(M)),z=V!==null?z.filter(x=>x.type===V):z,Promise.all(z.map(x=>this.F(x)))}async scanAllUserExtensions(V){const U=await this.n.scanUserExtensions({includeAllVersions:!V,includeInvalid:!0});return Promise.all(U.map(D=>this.F(D)))}async scanUserExtensionAtLocation(V){try{const U=await this.n.scanExistingExtension(V,1,{includeInvalid:!0});if(U)return await this.F(U)}catch(U){this.u.error(U)}return null}async extractUserExtension(V,U,D,M,z){const x=V.toString(),K=g.URI.file(w.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$Rg)()}`)),ee=g.URI.file(w.$kc(this.n.userExtensionsLocation.fsPath,x));let _=await this.m.exists(ee);if(_&&M){try{await this.y(V.id,ee,"removeExisting")}catch{throw new n.$6o(d.localize(4,null,ee.fsPath,V.id),n.ExtensionManagementErrorCode.Delete)}_=!1}if(_)await this.n.updateMetadata(ee,D);else try{try{this.u.trace(`Started extracting the extension from ${U} to ${ee.fsPath}`),await(0,m.$iq)(U,K.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${ee}:`,V.id)}catch(Y){let se=n.ExtensionManagementErrorCode.Extract;throw Y instanceof m.$gq&&(Y.type==="CorruptZip"?se=n.ExtensionManagementErrorCode.CorruptZip:Y.type==="Incomplete"&&(se=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$6o(Y.message,se)}await this.n.updateMetadata(K,D);try{this.u.trace(`Started renaming the extension from ${K.fsPath} to ${ee.fsPath}`),await this.C(K.fsPath,ee.fsPath),this.u.info("Renamed to",ee.fsPath)}catch(Y){if(Y.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",V.id);else throw this.u.info(`Rename failed because of ${(0,O.$0)(Y)}. Deleted from extracted location`,K),Y}this.h.fire(ee)}catch(Y){try{await this.m.del(K,{recursive:!0})}catch{}throw Y}return this.D(ee,1)}async scanMetadata(V,U){return U?(await this.w(V,U))?.metadata:this.n.scanMetadata(V.location)}async w(V,U){return(await this.s.scanProfileExtensions(U)).find(M=>(0,s.$tp)(M.identifier,V.identifier))}async updateMetadata(V,U,D){return D?await this.s.updateMetadata([[V,U]],D):await this.n.updateMetadata(V.location,U),this.D(V.location,V.type,D)}getUninstalledExtensions(){return this.z()}async setUninstalled(...V){const U=V.map(D=>s.$up.create(D));await this.z(D=>U.forEach(M=>{D[M.toString()]=!0,this.u.info("Marked extension as uninstalled",M.toString())}))}async setInstalled(V){await this.z(U=>delete U[V.toString()])}async removeExtension(V,U){if(this.t.extUri.isEqualOrParent(V.location,this.n.userExtensionsLocation))return this.y(V.identifier.id,V.location,U)}async removeUninstalledExtension(V){await this.removeExtension(V,"uninstalled"),await this.z(U=>delete U[s.$up.create(V).toString()])}async copyExtension(V,U,D,M){const z=await this.w(V,U),x=await this.w(V,D);if(M={...z?.metadata,...M},x)if(this.t.extUri.isEqual(x.location,V.location))await this.s.updateMetadata([[V,{...x.metadata,...M}]],D);else{const K=await this.D(x.location,V.type,D);await this.s.removeExtensionFromProfile(K,D),await this.s.addExtensionsToProfile([[V,{...x.metadata,...M}]],D)}else await this.s.addExtensionsToProfile([[V,M]],D);return this.D(V.location,V.type,D)}async copyExtensions(V,U,D){const M=await this.scanExtensions(1,V,D),z=await Promise.all(M.filter(x=>!x.isApplicationScoped).map(async x=>[x,await this.scanMetadata(x,V)]));await this.s.addExtensionsToProfile(z,U)}async y(V,U,D){this.u.trace(`Deleting ${D} extension from disk`,V,U.fsPath);const M=this.t.extUri.joinPath(this.t.extUri.dirname(U),`${this.t.extUri.basename(U)}.${(0,C.$jj)((0,l.$Rg)()).toString(16)}${W}`);await this.C(U.fsPath,M.fsPath),await this.m.del(M,{recursive:!0}),this.u.info(`Deleted ${D} extension from disk`,V,U.fsPath)}async z(V){return this.g.queue(async()=>{let U;try{U=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(M){if((0,I.$gl)(M)!==1)throw M}let D={};if(U)try{D=JSON.parse(U)}catch{}return V&&(V(D),Object.keys(D).length?await this.m.writeFile(this.c,N.$Fe.fromString(JSON.stringify(D))):await this.m.del(this.c)),D})}async C(V,U){try{await u.Promises.rename(V,U,2*60*1e3)}catch(D){throw new n.$6o(D.message||d.localize(5,null,V,U),D.code||n.ExtensionManagementErrorCode.Rename)}}async D(V,U,D){if(D){const z=(await this.n.scanUserExtensions({profileLocation:D})).find(x=>this.t.extUri.isEqual(x.location,V));if(z)return this.F(z)}else{const M=await this.n.scanExistingExtension(V,U,{includeInvalid:!0});if(M)return this.F(M)}throw new Error(d.localize(6,null,V.path))}async F(V){const U=await this.m.resolve(V.location);let D,M;return U.children&&(D=U.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,M=U.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:V.identifier,type:V.type,isBuiltin:V.isBuiltin||!!V.metadata?.isBuiltin,location:V.location,manifest:V.manifest,targetPlatform:V.targetPlatform,validations:V.validations,isValid:V.isValid,readmeUrl:D,changelogUrl:M,publisherDisplayName:V.metadata?.publisherDisplayName,publisherId:V.metadata?.publisherId||null,isApplicationScoped:!!V.metadata?.isApplicationScoped,isMachineScoped:!!V.metadata?.isMachineScoped,isPreReleaseVersion:!!V.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!V.metadata?.hasPreReleaseVersion,preRelease:!!V.metadata?.preRelease,installedTimestamp:V.metadata?.installedTimestamp,updated:!!V.metadata?.updated,pinned:!!V.metadata?.pinned,isWorkspaceScoped:!1,source:V.metadata?.source??(V.identifier.uuid?"gallery":"vsix")}}async G(){const V=await this.getUninstalledExtensions();if(Object.keys(V).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(V));const U=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),D=new Set;for(const z of U)V[s.$up.create(z).toString()]||D.add(z.identifier.id.toLowerCase());try{const z=(0,s.$zp)(U,x=>x.identifier);await A.Promises.settled(z.map(async x=>{const K=x.sort((ee,_)=>c.rcompare(ee.manifest.version,_.manifest.version))[0];D.has(K.identifier.id.toLowerCase())||await this.j(await this.F(K))}))}catch(z){this.u.error(z)}const M=U.filter(z=>z.metadata&&V[s.$up.create(z).toString()]);await Promise.allSettled(M.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let V;try{V=await this.m.resolve(this.n.userExtensionsLocation)}catch(U){(0,I.$gl)(U)!==1&&this.u.error(U);return}if(V?.children)try{await Promise.allSettled(V.children.map(async U=>{if(!(!U.isDirectory||!U.name.endsWith(W))){this.u.trace("Deleting the temporarily deleted folder",U.resource.toString());try{await this.m.del(U.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",U.resource.toString())}catch(D){(0,I.$gl)(D)!==1&&this.u.error(D)}}}))}catch{}}};e.$Eq=H,e.$Eq=H=Ee([Z(1,I.$2k),Z(2,o.$sq),Z(3,i.$oq),Z(4,G.$zl),Z(5,T.$2j)],H);class B extends r.$mq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$cg)(this.options.operation)?this.l:this.options.operation}constructor(V,U,D,M,z,x,K,ee,_,Y){super(),this.manifest=V,this.identifier=U,this.source=D,this.options=M,this.m=z,this.n=x,this.o=K,this.p=ee,this.q=_,this.s=Y,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(V){const[U,D]=await this.x(V);return this.j=U.isBuiltin||U.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[U,D]],this.j,!U.isValid),U}async u({zipPath:V,key:U,metadata:D},M,z){let x=await this.v(U);return x?x=await this.m.updateMetadata(x,D):(this.s.trace("Extracting extension...",U.id),x=await this.m.extractUserExtension(U,V,D,M,z),this.s.info("Extracting extension completed.",U.id)),x}async v(V){return await this.w(V)?(this.s.trace("Removing the extension from uninstalled list:",V.id),await this.m.setInstalled(V),this.s.info("Removed the extension from uninstalled list:",V.id),(await this.m.scanAllUserExtensions(!0)).find(M=>s.$up.create(M).equals(V))):void 0}async w(V){return!!(await this.m.getUninstalledExtensions())[V.toString()]}}class ie extends B{constructor(V,U,D,M,z,x,K,ee,_,Y,se){super(V,U.identifier,U,D,z,x,K,ee,_,Y),this.y=U,this.z=M,this.A=se}async x(V){let U;try{U=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(z){throw new n.$6o(z,n.ExtensionManagementErrorCode.Scanning)}const D=U.find(z=>(0,s.$tp)(z.identifier,this.y.identifier));D&&(this.l=3);const M={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||D?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||D?.isMachineScoped,isBuiltin:this.options.isBuiltin||D?.isBuiltin,isSystem:D?.type===0?!0:void 0,updated:!!D,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:D?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??D?.pinned,preRelease:(0,p.$bg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||D?.preRelease,source:"gallery"};if(D&&D.type!==0&&D.manifest.version===this.y.version)try{return[await this.m.updateMetadata(D,M),M]}catch(z){throw new n.$6o((0,O.$0)(z),n.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(M,V)}catch(z){if(z instanceof n.$6o&&(z.code===n.ExtensionManagementErrorCode.CorruptZip||z.code===n.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const x=await this.C(M,V);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),x}catch(x){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),x}}else throw z}}async C(V,U){const{location:D,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.D(D.fsPath),[await this.u({zipPath:D.fsPath,key:s.$up.create(this.y),metadata:V},!1,U),V]}catch(z){try{await this.z.delete(D)}catch(x){this.s.warn("Error while deleting the downloaded file",D.toString(),(0,O.$0)(x))}throw z}}async D(V){try{await(0,S.$zq)(V)}catch(U){throw new n.$6o(U.message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Fq=ie;class re extends B{constructor(V,U,D,M,z,x,K,ee,_,Y){super(V,{id:(0,s.$yp)(V.publisher,V.name)},U,D,z,x,K,ee,_,Y),this.y=U,this.z=M}async h(V){const U=await super.h(V);return this.C(U,V),U}async x(V){const U=new s.$up(this.identifier,this.manifest.version),M=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(K=>(0,s.$tp)(this.identifier,K.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||M?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||M?.isMachineScoped,isBuiltin:this.options.isBuiltin||M?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??M?.pinned,source:"vsix"};if(M)if(this.l=3,U.equals(new s.$up(M.identifier,M.manifest.version)))try{await this.m.removeExtension(M,"existing")}catch{throw new Error(d.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&c.gt(M.manifest.version,this.manifest.version)&&await this.m.setUninstalled(M);else{const K=await this.v(U);if(K)try{await this.m.removeExtension(K,"existing")}catch{throw new Error(d.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:w.$lc(this.y.fsPath),key:U,metadata:z},!0,V),z]}async C(V,U){try{let[D]=await this.z.getExtensions([{id:V.identifier.id,version:V.manifest.version}],U);if(D||([D]=await this.z.getExtensions([{id:V.identifier.id}],U)),D){const M={id:D.identifier.uuid,publisherDisplayName:D.publisherDisplayName,publisherId:D.publisherId,isPreReleaseVersion:D.properties.isPreReleaseVersion,hasPreReleaseVersion:V.hasPreReleaseVersion||D.properties.isPreReleaseVersion,preRelease:D.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(V,M,this.options.profileLocation)}}catch{}}}class he extends r.$mq{constructor(V,U,D){super(),this.extension=V,this.j=U,this.k=D}async h(V){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ae[252],ce([0,1,9,18,28,22,52,12,16,8]),function(ne,e,A,N,L,j,O,R,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LQ=void 0;let E=class extends O.$pq{constructor(w,h,c,p,g,l){super(f.URI.file(w.extensionsPath),h,c,p,g,l)}};e.$LQ=E,e.$LQ=E=Ee([Z(0,C.$Di),Z(1,R.$2k),Z(2,N.$Bl),Z(3,L.$zl),Z(4,j.$1l),Z(5,A.$2j)],E)}),define(ae[253],ce([0,1,8,16,52,81,12,4,9,24,28,18]),function(ne,e,A,N,L,j,O,R,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=void 0;let w=class extends j.$wq{constructor(c,p,g,l,u,m,d,$){super(A.URI.file(u.builtinExtensionsPath),A.URI.file(u.extensionsPath),u.userHome,c.defaultProfile,c,p,g,l,u,m,d,$)}};e.$adc=w,e.$adc=w=Ee([Z(0,y.$Bl),Z(1,L.$oq),Z(2,O.$2k),Z(3,C.$2j),Z(4,N.$Di),Z(5,f.$ik),Z(6,E.$zl),Z(7,R.$ui)],w)}),define(ae[19],ce([0,1,6,3,2,98,13,69,4,18]),function(ne,e,A,N,L,j,O,R,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$2p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Zp=e.$Yp=e.$Xp=void 0,e.$1p=h,e.$3p=p,e.$5p=l,e.$Xp="__$__isNewStorageMarker",e.$Yp="__$__targetStorageMarker",e.$Zp=(0,C.$vi)("storageService");var E;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(E||(e.WillSaveStateReason=E={}));var y;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var w;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function h(u){const m=u.get(e.$Yp);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}class c extends L.$Vc{static{this.a=60*1e3}constructor(m={flushInterval:c.a}){super(),this.m=m,this.b=this.B(new N.$he),this.c=this.B(new N.$he),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$ee),this.onWillSaveState=this.f.event,this.h=this.B(new A.$Hh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(m,d,$){return N.Event.filter(this.b.event,t=>t.scope===m&&(d===void 0||t.key===d),$)}n(){this.j.value=(0,A.$Lh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(m,d){const{key:$,external:t}=d;if($===e.$Yp){switch(m){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:m})}else this.b.fire({scope:m,key:$,target:this.J(m)[$],external:t})}w(m){this.f.fire({reason:m})}get(m,d,$){return this.P(d)?.get(m,$)}getBoolean(m,d,$){return this.P(d)?.getBoolean(m,$)}getNumber(m,d,$){return this.P(d)?.getNumber(m,$)}getObject(m,d,$){return this.P(d)?.getObject(m,$)}storeAll(m,d){this.y(()=>{for(const $ of m)this.store($.key,$.value,$.scope,$.target,d)})}store(m,d,$,t,r=!1){if((0,O.$eg)(d)){this.remove(m,$,r);return}this.y(()=>{this.z(m,$,t),this.P($)?.set(m,d,r)})}remove(m,d,$=!1){this.y(()=>{this.z(m,d,void 0),this.P(d)?.delete(m,$)})}y(m){this.b.pause(),this.c.pause();try{m()}finally{this.b.resume(),this.c.resume()}}keys(m,d){const $=[],t=this.J(m);for(const r of Object.keys(t))t[r]===d&&$.push(r);return $}z(m,d,$,t=!1){const r=this.J(d);typeof $=="number"?r[m]!==$&&(r[m]=$,this.P(d)?.set(e.$Yp,JSON.stringify(r),t)):typeof r[m]=="number"&&(delete r[m],this.P(d)?.set(e.$Yp,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(m){switch(m){case-1:return this.I;case 0:return this.G;default:return this.D}}L(m){const d=this.P(m);return d?h(d):Object.create(null)}isNew(m){return this.getBoolean(e.$Xp,m)===!0}async flush(m=E.NONE){this.f.fire({reason:m});const d=this.P(-1),$=this.P(0),t=this.P(1);switch(m){case E.NONE:await A.Promises.settled([d?.whenFlushed()??Promise.resolve(),$?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await A.Promises.settled([d?.flush(0)??Promise.resolve(),$?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.P(-1)?.items??new Map,d=this.P(0)?.items??new Map,$=this.P(1)?.items??new Map;return l(m,d,$,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(m){return await this.flush(),this.P(m)?.optimize()}async switch(m,d){return this.w(E.NONE),(0,f.$Al)(m)?this.R(m,d):this.S(m,d)}M(m,d){return!(m.id===d.id||p(d)&&p(m))}N(m,d,$){this.y(()=>{const t=new Set;for(const[r,n]of m)t.add(r),d.get(r)!==n&&this.u($,{key:r,external:!0});for(const[r]of d.items)t.has(r)||this.u($,{key:r,external:!0})})}}e.$2p=c;function p(u){return u.isDefault||!!u.useDefaultFlags?.globalState}class g extends c{constructor(){super(),this.U=this.B(new R.$Vp(new R.$Wp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$Vp(new R.$Wp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$Vp(new R.$Wp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(m=>this.u(1,m))),this.B(this.W.onDidChangeStorage(m=>this.u(0,m))),this.B(this.U.onDidChangeStorage(m=>this.u(-1,m)))}P(m){switch(m){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(m){return!1}}e.$4p=g;async function l(u,m,d,$,t,r){const n=P=>{try{return JSON.parse(P)}catch{return P}},s=new Map,i=new Map;u.forEach((P,I)=>{s.set(I,P),i.set(I,n(P))});const o=new Map,a=new Map;m.forEach((P,I)=>{o.set(I,P),a.set(I,n(P))});const b=new Map,S=new Map;d.forEach((P,I)=>{b.set(I,P),S.set(I,n(P))}),console.group($!==t?`Storage: Application (path: ${$})`:`Storage: Application & Profile (path: ${$}, default profile)`);const v=[];if(s.forEach((P,I)=>{v.push({key:I,value:P})}),console.table(v),console.groupEnd(),console.log(i),$!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];o.forEach((I,F)=>{P.push({key:F,value:I})}),console.table(P),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const k=[];b.forEach((P,I)=>{k.push({key:I,value:P})}),console.table(k),console.groupEnd(),console.log(S)}}),define(ae[114],ce([0,1,3,2,13,29,33,19]),function(ne,e,A,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJb=e.$WJb=void 0;let C=class extends N.$Vc{constructor(y,w){super(),this.a=new A.$ee,this.onDidChangeEnablement=this.a.event,this.b=this.B(new f(y)),this.B(this.b.onDidChange(h=>this.a.fire({extensions:h,source:"storage"}))),this.B(w.onDidInstallExtensions(h=>h.forEach(({local:c,operation:p})=>{c&&p===4&&this.f(c.identifier)})))}async enableExtension(y,w){return this.f(y)?(this.a.fire({extensions:[y],source:w}),!0):!1}async disableExtension(y,w){return this.c(y)?(this.a.fire({extensions:[y],source:w}),!0):!1}getDisabledExtensions(){return this.h(j.$9o)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(y){const w=this.getDisabledExtensions();return w.every(h=>!(0,O.$tp)(h,y))?(w.push(y),this.g(w),!0):!1}f(y){const w=this.getDisabledExtensions();for(let h=0;h<w.length;h++){const c=w[h];if((0,O.$tp)(c,y))return w.splice(h,1),this.g(w),!0}return!1}g(y){this.j(j.$9o,y)}h(y){return this.b.get(y,0)}j(y,w){this.b.set(y,w,0)}};e.$WJb=C,e.$WJb=C=Ee([Z(0,R.$Zp),Z(1,j.$8o)],C);class f extends N.$Vc{constructor(y){super(),this.c=y,this.a=Object.create(null),this.b=this.B(new A.$ee),this.onDidChange=this.b.event,this.B(y.onDidChangeValue(0,void 0,this.B(new N.$Uc))(w=>this.f(w)))}get(y,w){let h;return w===0?((0,L.$eg)(this.a[y])&&(this.a[y]=this.g(y,w)),h=this.a[y]):h=this.g(y,w),JSON.parse(h)}set(y,w,h){const c=JSON.stringify(w.map(({id:g,uuid:l})=>({id:g,uuid:l})));this.g(y,h)!==c&&(h===0&&(w.length?this.a[y]=c:delete this.a[y]),this.h(y,w.length?c:void 0,h))}f(y){if(!(0,L.$eg)(this.a[y.key])&&this.g(y.key,y.scope)!==this.a[y.key]){const h=this.get(y.key,y.scope);delete this.a[y.key];const c=this.get(y.key,y.scope),p=h.filter(l=>!c.some(u=>(0,O.$tp)(l,u))),g=c.filter(l=>!h.some(u=>(0,O.$tp)(u,l)));(p.length||g.length)&&this.b.fire([...p,...g])}}g(y,w){return this.c.get(y,w,"[]")}h(y,w,h){w?this.c.store(y,w,h,1):this.c.remove(y,h)}}e.$XJb=f}),define(ae[254],ce([0,1,17,26,7,5,36,13,8,21,16,29,33,71,12,9,24,59,233,19,22,63]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u,m,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=void 0,e.$8p=re;const t=j.$o?"web":(0,y.$1o)(j.$u,O.$fc),r="X-Market-Search-Activity-Id";var n;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished",M[M.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...M){return String(M.reduce((z,x)=>z|x,0))}var i;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class v{constructor(z=S){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,x=this.d.pageSize){return new v({...this.d,pageNumber:z,pageSize:x})}withFilter(z,...x){const K=[...this.d.criteria,...x.length?x.map(ee=>({filterType:z,value:ee})):[{filterType:z}]];return new v({...this.d,criteria:K})}withSortBy(z){return new v({...this.d,sortBy:z})}withSortOrder(z){return new v({...this.d,sortOrder:z})}withFlags(...z){return new v({...this.d,flags:z.reduce((x,K)=>x|K,0)})}withAssetTypes(...z){return new v({...this.d,assetTypes:z})}withSource(z){return new v({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:x,pageSize:K,sortBy:ee,sortOrder:_,flags:Y,assetTypes:se}=this.d;return{filters:[{criteria:z,pageNumber:x,pageSize:K,sortBy:ee,sortOrder:_}],assetTypes:se,flags:Y}}get searchText(){const z=this.d.criteria.filter(x=>x.filterType===i.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function k(M,z){const x=(M||[]).filter(K=>K.statisticName===z)[0];return x?x.value:0}function P(M){const z="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(K=>K.assetType.indexOf(z)===0).reduce((K,ee)=>{const _=T(M,ee.assetType);return _&&K.push([ee.assetType.substring(z.length),_]),K},[])}function I(M){if(M.properties){const z=M.properties.filter(ee=>ee.key===o.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),K=z.filter(ee=>x.test(ee.value))[0];return K?{uri:K.value,fallbackUri:K.value}:null}return T(M,o.Repository)}function F(M){return{uri:`${M.fallbackAssetUri}/${o.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${o.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function T(M,z){return M.files.filter(K=>K.assetType===z)[0]?{uri:`${M.assetUri}/${z}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${z}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}:null}function q(M,z){const x=M.properties?M.properties.filter(ee=>ee.key===z):[],K=x.length>0&&x[0].value;return K?K.split(",").map(ee=>(0,w.$xp)(ee)):[]}function X(M){const z=M.properties?M.properties.filter(x=>x.key===a.Engine):[];return z.length>0&&z[0].value||""}function G(M){const z=M.properties?M.properties.filter(x=>x.key===a.PreRelease):[];return z.length>0&&z[0].value==="true"}function Q(M){const z=M.properties?M.properties.filter(K=>K.key===a.LocalizedLanguages):[],x=z.length>0&&z[0].value||"";return x?x.split(","):[]}function W(M){return M.properties?.find(z=>z.key===a.SponsorLink)?.value}function J(M){return M.properties?.find(z=>z.key===a.SupportLink)?.value}function H(M){return M.indexOf("preview")!==-1}function B(M){return M.targetPlatform?(0,y.$Zo)(M.targetPlatform):"undefined"}function ie(M){const z=(0,A.$Mb)(M.versions.map(B)),x=!!M.tags?.includes(y.$Uo),K=z.indexOf("web");return x?K===-1&&z.push("web"):K!==-1&&z.splice(K,1),z}function re(M,z){for(let x=0;x<M.length;x++){const K=M[x];if(K.version===M[x-1]?.version){let ee=x;if(B(K)===z)for(;ee>0&&M[ee-1].version===K.version;)ee--;ee!==x&&(M.splice(x,1),M.splice(ee,0,K))}}return M}function he(M,z,x){M.telemetryData={index:z,querySource:x,queryActivityId:M.queryContext?.[r]}}function te(M,z,x,K){const ee=M.versions[0],_={manifest:T(z,o.Manifest),readme:T(z,o.Details),changelog:T(z,o.Changelog),license:T(z,o.License),repository:I(z),download:F(z),icon:T(z,o.Icon),signature:T(z,o.Signature),coreTranslations:P(z)};return{identifier:{id:(0,w.$yp)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:z.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(ee),description:M.shortDescription??"",installCount:k(M.statistics,"install"),rating:k(M.statistics,"averagerating"),ratingCount:k(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:x,assets:_,properties:{dependencies:q(z,a.Dependency),extensionPack:q(z,a.ExtensionPack),engine:X(z),localizedLanguages:Q(z),targetPlatform:B(z),isPreReleaseVersion:G(z)},hasPreReleaseVersion:G(ee),hasReleaseVersion:!0,preview:H(M.flags),isSigned:!!_.signature,queryContext:K,supportLink:J(ee)}}let V=class{constructor(z,x,K,ee,_,Y,se,ue){this.k=x,this.l=K,this.n=ee,this.o=_,this.q=Y,this.u=se,this.w=ue;const ge=se.extensionsGallery,fe=ge?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=fe?ge.servicePPEUrl:ge?.serviceUrl,this.g=fe?void 0:ge?.searchUrl,this.h=ge?.controlUrl,this.j=(0,u.$7p)(se.version,se,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,x,K){const ee=N.CancellationToken.isCancellationToken(x)?{}:x,_=N.CancellationToken.isCancellationToken(x)?x:K,Y=[],se=[],ue=[],ge=[];let fe=!0;for(const ve of z){ve.uuid?se.push(ve.uuid):Y.push(ve.id);const Ce=!!(ve.version||ve.preRelease);ue.push({id:ve.id,uuid:ve.uuid,includePreRelease:Ce}),ve.version&&ge.push({id:ve.id,uuid:ve.uuid,version:ve.version}),fe=fe&&!!ve.hasPreRelease&&!Ce}if(!se.length&&!Y.length)return[];let $e=new v().withPage(1,z.length);se.length&&($e=$e.withFilter(i.ExtensionId,...se)),Y.length&&($e=$e.withFilter(i.ExtensionName,...Y)),(ee.queryAllVersions||fe)&&($e=$e.withFlags($e.flags,n.IncludeVersions)),ee.source&&($e=$e.withSource(ee.source));const{extensions:ye}=await this.z($e,{targetPlatform:ee.targetPlatform??t,includePreRelease:ue,versions:ge,compatible:!!ee.compatible,productVersion:ee.productVersion??{version:this.u.version,date:this.u.date}},_);return ee.source&&ye.forEach((ve,Ce)=>he(ve,Ce,ee.source)),ye}async getCompatibleExtension(z,x,K,ee={version:this.u.version,date:this.u.date}){if((0,y.$2o)(z.allTargetPlatforms,K))return null;if(await this.isExtensionCompatible(z,x,K))return z;const _=new v().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,z.identifier.uuid),{extensions:Y}=await this.z(_,{targetPlatform:K,compatible:!0,includePreRelease:x,productVersion:ee},N.CancellationToken.None);return Y[0]||null}async isExtensionCompatible(z,x,K,ee={version:this.u.version,date:this.u.date}){if(!(0,y.$3o)(z.properties.targetPlatform,z.allTargetPlatforms,K)||!x&&z.properties.isPreReleaseVersion)return!1;let _=z.properties.engine;if(!_){const Y=await this.getManifest(z,N.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");_=Y.engines.vscode}return(0,h.$Lp)(_,ee.version,ee.date)}async y(z,x,K,ee,_,Y,se={version:this.u.version,date:this.u.date}){if(!(0,y.$3o)(B(x),_,Y)||K!=="any"&&G(x)!==(K==="prerelease"))return!1;if(ee)try{const ue=await this.E(z,x);if(!(0,h.$Lp)(ue,se.version,se.date))return!1}catch(ue){return this.l.error(`Error while getting the engine for the version ${x.version}.`,(0,L.$0)(ue)),!1}return!0}async query(z,x){let K=z.text||"";const ee=z.pageSize??50;let _=new v().withPage(1,ee);K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,$e,ye)=>(_=_.withFilter(i.Category,ye||$e),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,$e,ye)=>(_=_.withFilter(i.Tag,ye||$e),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(i.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),_=_.withFilter(i.SearchText,K)),_=_.withSortBy(0)):z.ids?_=_.withFilter(i.ExtensionId,...z.ids):z.names?_=_.withFilter(i.ExtensionName,...z.names):_=_.withSortBy(4),typeof z.sortBy=="number"&&(_=_.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(_=_.withSortOrder(z.sortOrder)),z.source&&(_=_.withSource(z.source));const Y=async(fe,$e)=>{const{extensions:ye,total:ve}=await this.z(fe,{targetPlatform:t,compatible:!1,includePreRelease:!!z.includePreRelease,productVersion:z.productVersion??{version:this.u.version,date:this.u.date}},$e);return ye.forEach((Ce,Ae)=>he(Ce,(fe.pageNumber-1)*fe.pageSize+Ae,z.source)),{extensions:ye,total:ve}},{extensions:se,total:ue}=await Y(_,x),ge=async(fe,$e)=>{if($e.isCancellationRequested)throw new L.$5;const{extensions:ye}=await Y(_.withPage(fe+1),$e);return ye};return{firstPage:se,total:ue,pageSize:_.pageSize,getPage:ge}}async z(z,x,K){const ee=z.flags;z.flags&n.IncludeLatestVersionOnly&&z.flags&n.IncludeVersions&&(z=z.withFlags(z.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(z.flags&n.IncludeLatestVersionOnly)&&!(z.flags&n.IncludeVersions)&&(z=z.withFlags(z.flags,n.IncludeLatestVersionOnly)),x.versions?.length&&(z=z.withFlags(z.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),z=z.withFlags(z.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:_,total:Y,context:se}=await this.B(z,K);if(!(z.flags&n.IncludeLatestVersionOnly)){const $e=[];for(const ye of _){const ve=await this.A(ye,x,se);ve&&$e.push(ve)}return{extensions:$e,total:Y}}const ge=[],fe=new Map;for(let $e=0;$e<_.length;$e++){const ye=_[$e],ve={id:(0,w.$yp)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},Ce=(0,R.$bg)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(le=>(0,w.$tp)(le,ve))?.includePreRelease;if(x.compatible&&(0,y.$2o)(ie(ye),x.targetPlatform))continue;const Ae=await this.A(ye,x,se);!Ae||Ae.properties.isPreReleaseVersion&&(!Ce||!Ae.hasReleaseVersion)||!Ae.properties.isPreReleaseVersion&&Ae.properties.targetPlatform!==x.targetPlatform&&Ae.hasPreReleaseVersion?fe.set(ye.extensionId,$e):ge.push([$e,Ae])}if(fe.size){const $e=new $.$ae,ye=new v().withFlags(ee&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,fe.size).withFilter(i.ExtensionId,...fe.keys()),{extensions:ve}=await this.z(ye,x,K);this.o.publicLog2("galleryService:additionalQuery",{duration:$e.elapsed(),count:fe.size});for(const Ce of ve){const Ae=fe.get(Ce.identifier.uuid);ge.push([Ae,Ce])}}return{extensions:ge.sort(($e,ye)=>$e[0]-ye[0]).map(([,$e])=>$e),total:Y}}async A(z,x,K){const ee={id:(0,w.$yp)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},_=x.versions?.find(ge=>(0,w.$tp)(ge,ee))?.version,Y=(0,R.$bg)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(ge=>(0,w.$tp)(ge,ee))?.includePreRelease,se=ie(z),ue=re(z.versions,x.targetPlatform);if(x.compatible&&(0,y.$2o)(se,x.targetPlatform))return null;for(let ge=0;ge<ue.length;ge++){const fe=ue[ge];if(!(_&&fe.version!==_)){if(await this.y((0,w.$yp)(z.publisher.publisherName,z.extensionName),fe,Y?"any":"release",x.compatible,se,x.targetPlatform,x.productVersion))return te(z,fe,se,K);if(_&&fe.version===_)return null}}return _||x.compatible?null:te(z,z.versions[0],se)}async B(z,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,s(n.Unpublished));const K=await this.j,ee=JSON.stringify(z.raw),_={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Y=new $.$ae;let se,ue,ge=0;try{if(se=await this.k.request({type:"POST",url:this.g&&z.criteria.some($e=>$e.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:ee,headers:_},x),se.res.statusCode&&se.res.statusCode>=400&&se.res.statusCode<500)return{galleryExtensions:[],total:ge};const fe=await(0,l.$Sp)(se);if(fe){const $e=fe.results[0],ye=$e.extensions,ve=$e.resultMetadata&&$e.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ge=ve&&ve.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:ge,context:{[r]:se.res.headers.activityid}}}return{galleryExtensions:[],total:ge}}catch(fe){const $e=(0,L.$4)(fe)?y.ExtensionGalleryErrorCode.Cancelled:(0,L.$0)(fe).startsWith("XHR timeout")?y.ExtensionGalleryErrorCode.Timeout:y.ExtensionGalleryErrorCode.Failed;throw ue=new y.$7o((0,L.$0)(fe),$e),ue}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(ee.length),duration:Y.elapsed(),success:!!se&&(0,l.$Op)(se),responseBodySize:se?.res.headers["Content-Length"],statusCode:se?String(se.res.statusCode):void 0,errorCode:ue?.code,count:String(ge)})}}async reportStatistic(z,x,K,ee){if(!this.isEnabled())return;const _=j.$o?this.x(`/itemName/${z}.${x}/version/${K}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${x}/${K}/stats?statType=${ee}`),Y=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:Y};try{await this.k.request({type:"POST",url:_,headers:ue},N.CancellationToken.None)}catch{}}async download(z,x,K){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const ee=(0,w.$Bp)(z),_=new Date().getTime(),Y=$e=>this.o.publicLog("galleryService:downloadVSIX",{...ee,duration:$e}),se=K===2?"install":K===3?"update":"",ue=se?{uri:`${z.assets.download.uri}${C.URI.parse(z.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${z.assets.download.fallbackUri}${C.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:z.assets.download,ge=z.queryContext?.[r]?{[r]:z.queryContext[r]}:void 0,fe=await this.D(z.identifier.id,ue,o.VSIX,ge?{headers:ge}:void 0);await this.q.writeFile(x,fe.stream),Y(new Date().getTime()-_)}async downloadSignatureArchive(z,x){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const K=await this.D(z.identifier.id,z.assets.signature,o.Signature);await this.q.writeFile(x,K.stream)}async getReadme(z,x){if(z.assets.readme){const K=await this.D(z.identifier.id,z.assets.readme,o.Details,{},x);return await(0,l.$Rp)(K)||""}return""}async getManifest(z,x){if(z.assets.manifest){const K=await this.D(z.identifier.id,z.assets.manifest,o.Manifest,{},x),ee=await(0,l.$Rp)(K);return ee?JSON.parse(ee):null}return null}async C(z,x,K){const ee=T(x,o.Manifest);if(!ee)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},Y=await this.D(z,ee,o.Manifest,{headers:_});return await(0,l.$Sp)(Y)}async getCoreTranslation(z,x){const K=z.assets.coreTranslations.filter(ee=>ee[0]===x.toUpperCase())[0];if(K){const ee=await this.D(z.identifier.id,K[1],K[0]),_=await(0,l.$Rp)(ee);return _?JSON.parse(_):null}return null}async getChangelog(z,x){if(z.assets.changelog){const K=await this.D(z.identifier.id,z.assets.changelog,o.Changelog,{},x);return await(0,l.$Rp)(K)||""}return""}async getAllCompatibleVersions(z,x,K){let ee=new v().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?ee=ee.withFilter(i.ExtensionId,z.identifier.uuid):ee=ee.withFilter(i.ExtensionName,z.identifier.id);const{galleryExtensions:_}=await this.B(ee,N.CancellationToken.None);if(!_.length)return[];const Y=ie(_[0]);if((0,y.$2o)(Y,K))return[];const se=[];await Promise.all(_[0].versions.map(async fe=>{try{await this.y(z.identifier.id,fe,x?"any":"release",!0,Y,K)&&se.push(fe)}catch{}}));const ue=[],ge=new Set;for(const fe of re(se,K))ge.has(fe.version)||(ge.add(fe.version),ue.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:G(fe)}));return ue}async D(z,x,K,ee={},_=N.CancellationToken.None){const Y=await this.j,se={type:"GET"},ue={...Y,...ee.headers||{}};ee={...ee,...se,headers:ue};const ge=x.uri,fe=x.fallbackUri,$e={...ee,url:ge};try{const ye=await this.k.request($e,_);if(ye.res.statusCode===200)return ye;const ve=await(0,l.$Rp)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${ve}`)}catch(ye){if((0,L.$4)(ye))throw ye;const ve=(0,L.$0)(ye);this.o.publicLog2("galleryService:cdnFallback",{extension:z,assetType:K,message:ve});const Ce={...ee,url:fe};return this.k.request(Ce,_)}}async E(z,x){let K=X(x);if(!K){this.o.publicLog2("galleryService:engineFallback",{extension:z,version:x.version});const ee=await this.C(z,x,N.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");K=ee.engines.vscode}return K}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,l.$Sp)(z),K=[],ee={},_=[];if(x){for(const Y of x.malicious)K.push({id:Y});if(x.migrateToPreRelease)for(const[Y,se]of Object.entries(x.migrateToPreRelease))(!se.engine||(0,h.$Lp)(se.engine,this.u.version,this.u.date))&&(ee[Y.toLowerCase()]={disallowInstall:!0,extension:{id:se.id,displayName:se.displayName,autoMigrate:{storage:!!se.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[Y,se]of Object.entries(x.deprecated))se&&(ee[Y.toLowerCase()]=(0,R.$bg)(se)?{}:se);if(x.search)for(const Y of x.search)_.push(Y)}return{malicious:K,deprecated:ee,search:_}}};V=Ee([Z(1,l.$Mp),Z(2,p.$2j),Z(3,E.$Ci),Z(4,d.$1l),Z(5,c.$2k),Z(6,g.$ik),Z(7,f.$2i)],V);let U=class extends V{constructor(z,x,K,ee,_,Y,se,ue){super(z,x,K,ee,_,Y,se,ue)}};e.$9p=U,e.$9p=U=Ee([Z(0,m.$Zp),Z(1,l.$Mp),Z(2,p.$2j),Z(3,E.$Ci),Z(4,d.$1l),Z(5,c.$2k),Z(6,g.$ik),Z(7,f.$2i)],U);let D=class extends V{constructor(z,x,K,ee,_,Y,se){super(void 0,z,x,K,ee,_,Y,se)}};e.$0p=D,e.$0p=D=Ee([Z(0,l.$Mp),Z(1,p.$2j),Z(2,E.$Ci),Z(3,d.$1l),Z(4,c.$2k),Z(5,g.$ik),Z(6,f.$2i)],D)}),define(ae[82],ce([0,1,4,3,2,19,33,24,17,9,13]),function(ne,e,A,N,L,j,O,R,C,f,E){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$1v=e.$Zv=void 0,e.$Zv=(0,A.$vi)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let h=class extends L.$Vc{static{y=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,O.$xp)(p.id)}@${p.version}`}static c(p){const g=w.exec(p);if(g&&g[1])return{id:g[1],version:g[2]}}static async removeOutdatedExtensionVersions(p,g){const l=await p.getInstalled(),u=[];for(const[m,d]of y.f(g)){const $=l.find(t=>(0,O.$tp)(t.identifier,{id:m}))?.manifest.version;for(const t of d)$!==t&&u.push(y.b({id:m,version:t}))}for(const m of u)g.remove(m,0)}static f(p){const g=new Map,l=p.keys(0,1);for(const u of l){const m=y.c(u);if(m){let d=g.get(m.id.toLowerCase());d||g.set(m.id.toLowerCase(),d=[]),d.push(m.version)}}return g}constructor(p,g,l){super(),this.j=p,this.m=g,this.n=l,this.g=this.B(new N.$ee),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=y.f(p),this.B(this.j.onDidChangeValue(0,void 0,this.B(new L.$Uc))(u=>this.r(u)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const g=y.c(p.key);if(g){if(this.j.get(p.key,0)===void 0)this.h.delete(g.id.toLowerCase());else{let l=this.h.get(g.id.toLowerCase());l||this.h.set(g.id.toLowerCase(),l=[]),l.push(g.version),this.g.fire()}return}}s(p){if((0,E.$8f)(p))return p;const g=p.manifest?p.manifest.publisher:p.publisher,l=p.manifest?p.manifest.name:p.name;return(0,O.$wp)(g,l)}getExtensionState(p,g){const l=this.s(p),u=this.getExtensionStateRaw(p,g);if(u)try{return JSON.parse(u)}catch(m){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${l}, global: ${g}): ${m}`)}}getExtensionStateRaw(p,g){const l=this.s(p),u=this.j.get(l,g?0:1);return u&&u?.length>y.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${l}, global: ${g}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(p,g,l){const u=this.s(p);g===void 0?this.j.remove(u,l?0:1):this.j.store(u,JSON.stringify(g),l?0:1,1)}setKeysForSync(p,g){this.j.store(y.b(p),JSON.stringify(g),0,1)}getKeysForSync(p){const g=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],l=this.j.get(y.b(p),0),u=l?JSON.parse(l):void 0;return u&&g?(0,C.$Mb)([...u,...g]):u||g}addToMigrationList(p,g){if(p!==g){const l=this.t.filter(u=>!u.includes(p)&&!u.includes(g));l.push([p,g]),this.t=l}}getSourceExtensionToMigrate(p){const g=this.t.find(([,l])=>p===l);return g?g[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",-1,"[]");try{const g=JSON.parse(p);if(Array.isArray(g))return g}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$1v=h,e.$1v=h=y=Ee([Z(0,j.$Zp),Z(1,R.$ik),Z(2,f.$2j)],h)}),define(ae[255],ce([0,1,2,29,82,230,113,9,19]),function(ne,e,A,N,L,j,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=void 0;let f=class extends A.$Vc{constructor(y,w,h,c,p,g){super(),y.cleanUp(),(0,j.$z4b)(y,w,h,c,g),L.$1v.removeOutdatedExtensionVersions(y,p)}};e.$qec=f,e.$qec=f=Ee([Z(0,O.$Cq),Z(1,N.$5o),Z(2,L.$Zv),Z(3,N.$$o),Z(4,C.$Zp),Z(5,R.$2j)],f)}),define(ae[256],ce([0,1,29,12,24,16,96,57,19,22,229]),function(ne,e,A,N,L,j,O,R,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;let y=class extends E.$Mac{constructor(h,c,p,g,l,u,m,d){super(h.userHome,l,c,p,g,u,m,d)}};e.$xec=y,e.$xec=y=Ee([Z(0,j.$Di),Z(1,f.$1l),Z(2,A.$8o),Z(3,C.$Zp),Z(4,R.$ncc),Z(5,O.$j4b),Z(6,N.$2k),Z(7,L.$ik)],y)}),define(ae[257],ce([0,1,104,3,22,16,2,9,14,67,24,5,6,99,21,170,37,19,13,132,20]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=void 0;const $=[A.$mec,A.$nec],t="remoteTunnelSession",r="remoteTunnelIsService";let n=class extends O.$Vc{constructor(a,b,S,v,k,P,I){super(),this.y=a,this.z=b,this.C=S,this.D=P,this.F=I,this.f=new N.$ee,this.onDidTokenFailed=this.f.event,this.g=new N.$ee,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$ee,this.onDidChangeMode=this.h.event,this.n=A.$kec,this.w=!1,this.I=(F,T)=>{T?this.j.error(F):this.j.info(F)},this.j=this.B(v.createLogger((0,d.$9g)(S.logsHome,`${A.$oec}.log`),{id:A.$oec,name:A.$pec})),this.t=new w.$sh(100),this.B(this.j.onDidChangeLogLevel(F=>this.j.info("Log level changed to "+(0,R.$ek)(F)))),this.B(k.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(P.onDidChangeConfiguration(F=>{$.some(T=>F.affectsConfiguration(T))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=A.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){i(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(b){this.j.error(b)}return this.s}J(){if(!this.u){let a;y.$j?a=this.C.appRoot:a=(0,C.$nc)((0,C.$nc)(this.C.appRoot)),this.u=(0,C.$kc)(a,"bin",`${this.z.tunnelApplicationName}${y.$i?".exe":""}`)}return this.u}async startTunnel(a){if(i(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(b){this.j.error(b)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(A.$kec);try{a&&this.O("uninstallService",["service","uninstall"])}catch(b){this.j.error(b)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(A.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",b=!1;const S=(T,q)=>{q?this.j.error(T):a+=T,!this.C.isBuilt&&T.startsWith("   Compiling")&&this.G(A.TunnelStates.connecting((0,p.localize)(0,null)))},v=this.O("status",["status"],S);this.r=v;try{if(await v,this.r!==v)return;let T;try{T=JSON.parse(a.trim().split(`
`).find(q=>q.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(A.TunnelStates.disconnected());return}if(b=T.service_installed,this.j.info(T.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!T.tunnel&&!this.n.active){this.G(A.TunnelStates.disconnected());return}}catch(T){this.j.error(T),this.G(A.TunnelStates.disconnected());return}finally{this.r===v&&(this.r=void 0)}const k=this.n.active?this.n.session:void 0;if(k&&k.token){const T=k.token;this.G(A.TunnelStates.connecting((0,p.localize)(1,null,k.accountLabel,k.providerId)));const q=(G,Q)=>{G=G.replaceAll(T,"*".repeat(4)),S(G,Q)},X=this.O("login",["user","login","--provider",k.providerId,"--access-token",T,"--log",(0,R.$ek)(this.j.getLevel())],q);this.r=X;try{if(await X,this.r!==X)return}catch(G){this.j.error(G),this.r=void 0,this.f.fire(k),this.G(A.TunnelStates.disconnected(k));return}}const P=this.Q();P?this.G(A.TunnelStates.connecting((0,p.localize)(2,null,P))):this.G(A.TunnelStates.connecting((0,p.localize)(3,null)));const I=["--accept-server-license-terms","--log",(0,R.$ek)(this.j.getLevel())];P?I.push("--name",P):I.push("--random-name");let F=!1;return this.n.active&&this.n.asService&&!b&&(F=await this.M(I)===!1),this.N(k,I,F)}async M(a){let b;try{b=await this.O("serviceInstall",["service","install",...a])}catch(S){this.j.error(S),b=1}if(b!==0){const S=(0,p.localize)(4,null);return this.j.warn(S),this.G(A.TunnelStates.connecting(S)),!1}return!0}async N(a,b,S){b.push("--parent-process-id",String(process.pid)),this.P()&&b.push("--no-sleep");let v=!1;const k=this.O("tunnel",b,(P,I)=>{I?this.j.error(P):this.j.info(P),P.includes("Connected to an existing tunnel process")&&(v=!0);const F=P.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const T={link:F[1],domain:F[2],tunnelName:F[4],isAttached:v};this.G(A.TunnelStates.connected(T,S))}else P.match(/error refreshing token/)&&(k.cancel(),this.f.fire(a),this.G(A.TunnelStates.disconnected(a)))});this.r=k,k.finally(()=>{k===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=A.$kec,this.G(A.TunnelStates.disconnected()))})}O(a,b,S=this.I){return(0,w.$ih)(v=>new Promise((k,P)=>{v.isCancellationRequested&&k(-1);let I;const F=["ignore","pipe","pipe"];if(v.onCancellationRequested(()=>{I&&(this.j.info(`${a} terminating(${I.pid})`),I.kill())}),!this.C.isBuilt)S(`Building tunnel CLI from sources and run
`,!1),S(`${a} Spawning: cargo run -- tunnel ${b.join(" ")}
`,!1),I=(0,f.spawn)("cargo",["run","--","tunnel",...b],{cwd:(0,C.$kc)(this.C.appRoot,"cli"),stdio:F});else{S(`Running tunnel CLI
`,!1);const T=this.J();S(`${a} Spawning: ${T} tunnel ${b.join(" ")}
`,!1),I=(0,f.spawn)(T,["tunnel",...b],{cwd:(0,g.homedir)(),stdio:F})}I.stdout.pipe(new m.$NW(`
`)).on("data",T=>{if(I){const q=T.toString();S(q,!1)}}),I.stderr.pipe(new m.$NW(`
`)).on("data",T=>{if(I){const q=T.toString();S(q,!0)}}),I.on("exit",T=>{I&&(S(`${a} exit(${I.pid}): + ${T} `,!1),I=void 0,k(T||0))}),I.on("error",T=>{I&&(S(`${a} error(${I.pid}): + ${T} `,!0),I=void 0,P())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(A.$nec)}Q(){let a=this.D.getValue(A.$mec)||(0,g.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(t,-1),b=this.F.getBoolean(r,-1,!1);if(a){const S=JSON.parse(a);if(S&&(0,u.$8f)(S.accountLabel)&&(0,u.$8f)(S.sessionId)&&(0,u.$8f)(S.providerId))return{active:!0,session:S,asService:b};this.j.error("Problems restoring session from storage, invalid format",S)}}catch(a){this.j.error("Problems restoring session from storage",a)}return A.$kec}S(a){if(a.active){const b={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(t,JSON.stringify(b),-1,1),this.F.store(r,a.asService,-1,1)}else this.F.remove(t,-1),this.F.remove(r,-1)}};e.$tec=n,e.$tec=n=Ee([Z(0,L.$1l),Z(1,E.$ik),Z(2,j.$Di),Z(3,R.$3j),Z(4,h.$rec),Z(5,c.$2i),Z(6,l.$Zp)],n);function s(o,a){return o&&a?o.sessionId===a.sessionId&&o.providerId===a.providerId&&o.token===a.token:o===a}const i=(o,a)=>o.active!==a.active?!1:o.active&&a.active?o.asService===a.asService&&s(o.session,a.session):!0}),define(ae[258],ce([0,1,6,2,23,20,69,19,77,18]),function(ne,e,A,N,L,j,O,R,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;class E extends R.$2p{constructor(w,h,c,p){super(),this.bb=w,this.cb=h,this.db=c,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Uc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Uc),this.ab=this.hb(this.bb)}fb(){const w=this.B(new C.$wKb(this.db.getChannel("storage"))),h=this.B(new O.$Vp(w));return this.B(h.onDidChangeStorage(c=>this.u(-1,c))),h}gb(w){this.X.clear(),this.W=w;let h;if((0,R.$3p)(w))h=this.U;else{const c=this.X.add(new C.$xKb(this.db.getChannel("storage"),w));h=this.X.add(new O.$Vp(c))}return this.X.add(h.onDidChangeStorage(c=>this.u(0,c))),h}hb(w){this.$.clear(),this.Z=w?.id;let h;if(w){const c=this.$.add(new C.$yKb(this.db.getChannel("storage"),w));h=this.$.add(new O.$Vp(c)),this.$.add(h.onDidChangeStorage(p=>this.u(1,p)))}return h}async O(){await A.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(w){switch(w){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(w){switch(w){case-1:return this.s.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;default:return this.Z?`${(0,j.$9g)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:L.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await A.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(w){if(!this.M(this.W,w))return;const h=this.Y,c=h.items;h!==this.U&&await h.close(),this.Y=this.gb(w),await this.Y.init(),this.N(c,this.Y,0)}async S(w,h){const c=this.ab,p=c?.items??new Map;await c?.close(),this.ab=this.hb(w),await this.ab.init(),this.N(p,this.ab,1)}hasScope(w){return(0,f.$Al)(w)?this.W.id===w.id:this.Z===w.id}}e.$yec=E}),define(ae[259],ce([0,1,3,2,18,91]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TQ=e.$SQ=void 0;class O{constructor(f,E){this.a=f,this.b=E}listen(f,E){const y=this.b(f);switch(E){case"onDidChangeProfiles":return A.Event.map(this.a.onDidChangeProfiles,w=>({all:w.all.map(h=>(0,j.$zn)({...h},y)),added:w.added.map(h=>(0,j.$zn)({...h},y)),removed:w.removed.map(h=>(0,j.$zn)({...h},y)),updated:w.updated.map(h=>(0,j.$zn)({...h},y))}))}throw new Error(`Invalid listen ${E}`)}async call(f,E,y){const w=this.b(f);switch(E){case"createProfile":{const h=await this.a.createProfile(y[0],y[1],y[2]);return(0,j.$zn)({...h},w)}case"updateProfile":{let h=(0,L.$Cl)((0,j.$An)(y[0],w),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,y[1]),(0,j.$zn)({...h},w)}case"removeProfile":{const h=(0,L.$Cl)((0,j.$An)(y[0],w),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${E}`)}}e.$SQ=O;class R extends N.$Vc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(f,E,y){super(),this.profilesHome=E,this.f=y,this.a=[],this.b=this.B(new A.$ee),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=f.map(w=>(0,L.$Cl)(w,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(w=>{const h=w.added.map(g=>(0,L.$Cl)(g,this.profilesHome.scheme)),c=w.removed.map(g=>(0,L.$Cl)(g,this.profilesHome.scheme)),p=w.updated.map(g=>(0,L.$Cl)(g,this.profilesHome.scheme));this.a=w.all.map(g=>(0,L.$Cl)(g,this.profilesHome.scheme)),this.b.fire({added:h,removed:c,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(f){this.c=f}isEnabled(){return this.c}async createNamedProfile(f,E,y){const w=await this.f.call("createNamedProfile",[f,E,y]);return(0,L.$Cl)(w,this.profilesHome.scheme)}async createProfile(f,E,y,w){const h=await this.f.call("createProfile",[f,E,y,w]);return(0,L.$Cl)(h,this.profilesHome.scheme)}async createTransientProfile(f){const E=await this.f.call("createTransientProfile",[f]);return(0,L.$Cl)(E,this.profilesHome.scheme)}async setProfileForWorkspace(f,E){await this.f.call("setProfileForWorkspace",[f,E])}removeProfile(f){return this.f.call("removeProfile",[f])}async updateProfile(f,E){const y=await this.f.call("updateProfile",[f,E]);return(0,L.$Cl)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$TQ=R}),define(ae[60],ce([0,1,2,69,4,19,3,77,18]),function(ne,e,A,N,L,j,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CKb=e.$BKb=e.$AKb=void 0,e.$AKb=(0,L.$vi)("IUserDataProfileStorageService");let f=class extends A.$Vc{constructor(h){super(),this.a=h}async readStorageData(h){return this.withProfileScopedStorageService(h,async c=>this.b(c))}async updateStorageData(h,c,p){return this.withProfileScopedStorageService(h,async g=>this.c(g,c,p))}async withProfileScopedStorageService(h,c){if(this.a.hasScope(h))return c(this.a);const p=await this.g(h),g=new y(p);try{await g.initialize();const l=await c(g);return await g.flush(),l}finally{g.dispose(),await this.f(p)}}b(h){const c=new Map,p=g=>{for(const l of h.keys(0,g))c.set(l,{value:h.get(l,0),target:g})};return p(0),p(1),c}c(h,c,p){h.storeAll(Array.from(c.entries()).map(([g,l])=>({key:g,value:l,scope:0,target:p})),!0)}async f(h){try{await h.close()}finally{(0,A.$Pc)(h)&&h.dispose()}}};e.$BKb=f,e.$BKb=f=Ee([Z(0,j.$Zp)],f);class E extends f{constructor(h,c,p,g){super(p),this.j=h;const l=h.getChannel("profileStorageListener"),u=this.B(new A.$Wc);this.h=this.B(new O.$ee({onWillAddFirstListener:()=>{u.value=l.listen("onDidChange")(m=>{g.trace("profile storage changes",m),this.h.fire({targetChanges:m.targetChanges.map(d=>(0,C.$Cl)(d,c.profilesHome.scheme)),valueChanges:m.valueChanges.map(d=>({...d,profile:(0,C.$Cl)(d.profile,c.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(h){const c=this.j.getChannel("storage");return(0,j.$3p)(h)?new R.$wKb(c):new R.$xKb(c,h)}}e.$CKb=E;class y extends j.$2p{constructor(h){super({flushInterval:100}),this.s=this.B(new N.$Vp(h))}O(){return this.s.init()}P(h){return h===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ae[260],ce([0,1,19,9,18,56,60]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;let R=class extends O.$CKb{constructor(f,E,y,w){super(f,E,y,w)}};e.$dec=R,e.$dec=R=Ee([Z(0,j.$Cdc),Z(1,L.$Bl),Z(2,A.$Zp),Z(3,N.$2j)],R)}),define(ae[39],ce([0,1,17,6,15,26,3,35,2,27,13,175,21,16,12,9,45,19,22,28,25,18]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u,m,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BLb=e.$ALb=e.$zLb=e.$yLb=void 0,e.$vLb=t,e.$wLb=r,e.$xLb=n;function t(b){return!!(b&&b.ref!==void 0&&typeof b.ref=="string"&&b.ref!==""&&b.syncData!==void 0&&(b.syncData===null||r(b.syncData)))}function r(b){return!!(b&&b.version!==void 0&&typeof b.version=="number"&&b.content!==void 0&&typeof b.content=="string"&&(Object.keys(b).length===2||Object.keys(b).length===3&&b.machineId!==void 0&&typeof b.machineId=="string"))}function n(b,S){return`${(0,f.$Zf)(b)}${S.isDefault?"":` (${S.name})`}`}let s=class extends C.$Vc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(S,v,k,P,I,F,T,q,X,G,Q,W){super(),this.syncResource=S,this.collection=v,this.G=k,this.H=P,this.I=I,this.J=F,this.L=T,this.M=q,this.N=X,this.O=G,this.P=Q,this.c=null,this.m="idle",this.n=this.B(new O.$ee),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$ee),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$th(50)),this.w=this.B(new O.$ee),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(S.syncResource,S.profile),this.h=W.extUri,this.f=this.h.joinPath(P.userDataSyncHome,...(0,d.$XAb)(S.profile.isDefault?void 0:S.profile.id,S.syncResource)),this.g=this.h.joinPath(this.f,d.$gBb),this.y=(0,d.$YAb)(S.profile.isDefault?void 0:S.profile.id,S.syncResource,P,this.h),this.j=(0,g.$6p)(P,k,I)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const S=await this.c;this.c=null;const v=await this.Y(S.remoteUserData,S.lastSyncUserData,!0,this.ob());this.S(v)}else{this.O.trace(`${this.D}: Checking for local changes...`);const S=await this.getLastSyncUserData();(S?await this.ub(S):!0)&&this.w.fire()}}S(S){this.m!==S&&(this.m=S,this.n.fire(S))}async sync(S,v={}){await this.U(S,!0,this.ob(),v)}async preview(S,v,k={}){return this.U(S,!1,v,k)}async apply(S,v={}){try{this.F={...v};const k=await this.ab(S);return this.S(k),this.c}finally{this.F={}}}async U(S,v,k,P){try{if(this.F={...P},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let I="idle";try{const F=await this.getLastSyncUserData(),T=await this.X(S,F);return I=await this.Y(T,F,v,k),I==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):I==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(I)}}finally{this.F={}}}async replace(S){const v=this.kb(S);if(!v)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const k=await this.getLastSyncUserData(),P=await this.X(null,k),I=await this.W(P),F=await this.qb({ref:P.ref,syncData:v},k,I,this.ob(),j.CancellationToken.None),T=[];for(const q of F){const X=await this.sb(q,q.remoteResource,void 0,j.CancellationToken.None),{remoteChange:G}=await this.sb(q,q.previewResource,q.remoteContent,j.CancellationToken.None);T.push([q,{...X,remoteChange:G!==0?G:2}])}await this.tb(P,k,T,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(S){const v=await this.j;return!!S.syncData?.machineId&&S.syncData.machineId===v}async X(S,v){if(v){const k=S?S[this.resource]:void 0;if(v.ref===k||k===void 0&&v.syncData===null)return v}return this.getRemoteUserData(v)}async Y(S,v,k,P){if(S.syncData&&S.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new d.$6Ab((0,y.localize)(0,null,this.resource,this.pb,S.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(S,v,k,P)}catch(I){if(I instanceof d.$6Ab)switch(I.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(S,v,k,P);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),S=await this.getRemoteUserData(null),v=await this.getLastSyncUserData(),this.Y(S,v,k,P)}throw I}}async Z(S,v,k,P){try{const I=await this.W(S),F=!I&&v===null&&this.gb()!==void 0,T=k&&!F;this.c||(this.c=(0,N.$ih)(X=>this.eb(S,v,I,T,P,X)));let q=await this.c;if(k&&F){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const X of q.resourcePreviews)q=await this.accept(X.remoteResource)||q}return this.cb(q.resourcePreviews),q.resourcePreviews.some(({mergeState:X})=>X==="conflict")?"hasConflicts":k?await this.ab(!1):"syncing"}catch(I){throw this.c=null,I}}async merge(S){return await this.$(S,async v=>{const k=await this.rb(v,j.CancellationToken.None);await this.G.writeFile(v.previewResource,L.$Fe.fromString(k?.content||""));const P=k&&!k.hasConflicts?await this.sb(v,v.previewResource,void 0,j.CancellationToken.None):void 0;return v.acceptResult=P,v.mergeState=k.hasConflicts?"conflict":P?"accepted":"preview",v.localChange=P?P.localChange:k.localChange,v.remoteChange=P?P.remoteChange:k.remoteChange,v}),this.c}async accept(S,v){return await this.$(S,async k=>{const P=await this.sb(k,S,v,j.CancellationToken.None);return k.acceptResult=P,k.mergeState="accepted",k.localChange=P.localChange,k.remoteChange=P.remoteChange,k}),this.c}async discard(S){return await this.$(S,async v=>{const k=await this.rb(v,j.CancellationToken.None);return await this.G.writeFile(v.previewResource,L.$Fe.fromString(k.content||"")),v.acceptResult=void 0,v.mergeState="preview",v.localChange=k.localChange,v.remoteChange=k.remoteChange,v}),this.c}async $(S,v){if(!this.c)return;let k=await this.c;const P=k.resourcePreviews.findIndex(({localResource:I,remoteResource:F,previewResource:T})=>this.h.isEqual(I,S)||this.h.isEqual(F,S)||this.h.isEqual(T,S));P!==-1&&(this.c=(0,N.$ih)(async I=>{const F=[...k.resourcePreviews];return F[P]=await v(F[P]),{...k,resourcePreviews:F}}),k=await this.c,this.cb(k.resourcePreviews),k.resourcePreviews.some(({mergeState:I})=>I==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(S){if(!this.c)return"idle";const v=await this.c;return v.resourcePreviews.some(({mergeState:k})=>k==="conflict")?"hasConflicts":v.resourcePreviews.some(({mergeState:k})=>k!=="accepted")?"syncing":(await this.tb(v.remoteUserData,v.lastSyncUserData,v.resourcePreviews.map(k=>[k,k.acceptResult]),S),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(S){const v=S.filter(({mergeState:k})=>k==="conflict");(0,A.$ub)(this.s,v,(k,P)=>this.h.isEqual(k.previewResource,P.previewResource))||(this.s=v,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const S=await this.getLastSyncUserData();return!!S&&S.syncData!==null}async db(S){const v=this.c?await this.c:null;if(v)for(const k of v.resourcePreviews){if(this.h.isEqual(k.acceptedResource,S))return k.acceptResult?k.acceptResult.content:null;if(this.h.isEqual(k.remoteResource,S))return k.remoteContent;if(this.h.isEqual(k.localResource,S))return k.localContent;if(this.h.isEqual(k.baseResource,S))return k.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(S){(0,c.$gl)(S)!==1&&this.O.error(S)}}async eb(S,v,k,P,I,F){const T=await this.qb(S,v,k,I,F),q=[];for(const X of T){const G=X.previewResource.with({scheme:d.$fBb,authority:"accepted"});if(X.localChange===0&&X.remoteChange===0)q.push({...X,acceptedResource:G,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Q=P?await this.rb(X,F):void 0;if(F.isCancellationRequested)break;await this.G.writeFile(X.previewResource,L.$Fe.fromString(Q?.content||""));const W=Q&&!Q.hasConflicts?await this.sb(X,X.previewResource,void 0,F):void 0;q.push({...X,acceptResult:W,mergeState:Q?.hasConflicts?"conflict":W?"accepted":"preview",localChange:W?W.localChange:Q?Q.localChange:X.localChange,remoteChange:W?W.remoteChange:Q?Q.remoteChange:X.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:S,lastSyncUserData:v,resourcePreviews:q,isLastSyncFromCurrentMachine:k}}async getLastSyncUserData(){let S=this.gb();if(S||(S=await this.jb()),!S)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const v=JSON.parse(S),k=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!v.version&&!!k&&v.version!==k,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${v.version} is not compatible with current sync state version ${k}.`),await this.resetLocal(),null;let P,I=1;for(;P===void 0&&I++<6;)try{const F=await this.hb();F&&(F.ref===v.ref?P=F.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof c.$kl&&F.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(F instanceof d.$6Ab)throw F;this.O.error(F,I)}}if(P===void 0)try{const F=await this.J.resolveResourceContent(this.resource,v.ref,this.collection,this.F);P=F===null?null:this.kb(F),await this.ib({ref:v.ref,syncData:P})}catch(F){if(F instanceof d.$6Ab&&F.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw F}return P===void 0?null:{...v,syncData:P}}async fb(S,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const k=this.M.getResourceSyncStateVersion(this.resource),P={ref:S.ref,version:k,...v};this.I.store(this.z,JSON.stringify(P),-1,1),await this.ib(S)}gb(){return this.I.get(this.z,-1)}async hb(){const S=(await this.G.readFile(this.y)).value.toString();try{const v=S?JSON.parse(S):void 0;if(t(v))return v}catch(v){this.O.error(v)}}async ib(S){await this.G.writeFile(this.y,L.$Fe.fromString(JSON.stringify(S)))}async jb(){try{const S=await this.G.readFile(this.y),v=JSON.parse(S.value.toString());await this.G.del(this.y),v.ref&&v.content!==void 0?(this.I.store(this.z,JSON.stringify({...v,content:void 0}),-1,1),await this.ib({ref:v.ref,syncData:v.content===null?null:JSON.parse(v.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,v)}catch(S){S instanceof c.$kl&&S.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(S)}return this.I.get(this.z,-1)}async getRemoteUserData(S){const{ref:v,content:k}=await this.lb(S);let P=null;return k!==null&&(P=this.kb(k)),{ref:v,syncData:P}}kb(S){try{const v=JSON.parse(S);if(r(v))return v}catch(v){this.O.error(v)}throw new d.$6Ab((0,y.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(S){const v=S?{ref:S.ref,content:S.syncData?JSON.stringify(S.syncData):null}:null;return this.J.readResource(this.resource,v,this.collection,this.F)}async mb(S,v){const k=await this.j,P={version:this.pb,machineId:k,content:S};try{return v=await this.J.writeResource(this.resource,JSON.stringify(P),v,this.collection,this.F),{ref:v,syncData:P}}catch(I){throw I instanceof d.$6Ab&&I.code==="TooLarge"&&(I=new d.$6Ab(I.message,I.code,this.resource)),I}}async nb(S){const v={version:this.pb,content:S};return this.L.writeResource(this.resource,JSON.stringify(v),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(d.$SAb)}};e.$yLb=s,e.$yLb=s=Ee([Z(2,c.$2k),Z(3,h.$Ci),Z(4,l.$Zp),Z(5,d.$1Ab),Z(6,d.$2Ab),Z(7,d.$$Ab),Z(8,u.$1l),Z(9,d.$dBb),Z(10,w.$2i),Z(11,m.$zl)],s);let i=class extends s{constructor(S,v,k,P,I,F,T,q,X,G,Q,W,J){super(v,k,P,I,F,T,q,X,G,Q,W,J),this.r=S,this.B(this.G.watch(this.h.dirname(S))),this.B(this.G.onDidFilesChange(H=>this.yb(H)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(S,v,k){try{v?await this.G.writeFile(this.r,L.$Fe.fromString(S),k?void 0:v):await this.G.createFile(this.r,L.$Fe.fromString(S),{overwrite:k})}catch(P){throw P instanceof c.$kl&&P.fileOperationResult===1||P instanceof c.$kl&&P.fileOperationResult===3?new d.$6Ab(P.message,"LocalPreconditionFailed"):P}}async xb(){try{await this.G.del(this.r)}catch(S){if(!(S instanceof c.$kl&&S.fileOperationResult===1))throw S}}yb(S){S.contains(this.r)&&this.Q()}};e.$zLb=i,e.$zLb=i=Ee([Z(3,c.$2k),Z(4,h.$Ci),Z(5,l.$Zp),Z(6,d.$1Ab),Z(7,d.$2Ab),Z(8,d.$$Ab),Z(9,u.$1l),Z(10,d.$dBb),Z(11,w.$2i),Z(12,m.$zl)],i);let o=class extends i{constructor(S,v,k,P,I,F,T,q,X,G,Q,W,J,H){super(S,v,k,P,I,F,T,q,X,G,Q,J,H),this.zb=W,this.Bb=void 0}Ab(S,v){const k=[],P=(0,R.$In)(S,k,{allowEmptyContent:!0,allowTrailingComma:!0});return k.length>0||!(0,E.$cg)(P)&&v!==Array.isArray(P)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$ALb=o,e.$ALb=o=Ee([Z(3,c.$2k),Z(4,h.$Ci),Z(5,l.$Zp),Z(6,d.$1Ab),Z(7,d.$2Ab),Z(8,d.$$Ab),Z(9,u.$1l),Z(10,d.$dBb),Z(11,d.$cBb),Z(12,w.$2i),Z(13,m.$zl)],o);let a=class{constructor(S,v,k,P,I,F,T){this.resource=S,this.g=v,this.h=k,this.j=P,this.k=I,this.l=F,this.d=T.extUri,this.f=(0,d.$YAb)(void 0,this.resource,k,this.d)}async initialize({ref:S,content:v}){if(!v){this.j.info("Remote content does not exist.",this.resource);return}const k=this.m(v);if(k)try{await this.o({ref:S,syncData:k})}catch(P){this.j.error(P)}}m(S){try{const v=JSON.parse(S);if(r(v))return v}catch(v){this.j.error(v)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(S,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const k={ref:S.ref,version:void 0,...v};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(k),-1,1),await this.k.writeFile(this.f,L.$Fe.fromString(JSON.stringify(S)))}};e.$BLb=a,e.$BLb=a=Ee([Z(1,$.$Bl),Z(2,h.$Ci),Z(3,p.$2j),Z(4,c.$2k),Z(5,l.$Zp),Z(6,m.$zl)],a)}),define(ae[115],ce([0,1,6,26,7,3,44,2,27,21,16,114,29,33,82,48,12,4,74,9,19,22,28,18,39,241,111,25,60]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s,i,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U$b=e.$T$b=e.$S$b=void 0,e.$Q$b=S,e.$R$b=v;async function b(F,T){const q=JSON.parse(F.content);if(F.version===1||F.version===2){const X=(await T.getInstalled(0)).filter(G=>G.isBuiltin);for(const G of q)F.version===1&&(G.enabled===!1&&(G.disabled=!0),delete G.enabled),F.version===2&&X.every(Q=>!(0,h.$tp)(Q.identifier,G.identifier))&&(G.installed=!0)}return q}function S(F){return JSON.parse(F.content)}function v(F,T){return F.sort((q,X)=>!q.identifier.uuid&&X.identifier.uuid?-1:q.identifier.uuid&&!X.identifier.uuid?1:(0,C.$qf)(q.identifier.id,X.identifier.id)),T?(0,O.$Tn)(F,{}):JSON.stringify(F)}let k=class extends n.$yLb{constructor(T,q,X,G,Q,W,J,H,B,ie,re,he,te,V,U,D,M){super({syncResource:"extensions",profile:T},q,G,X,Q,W,J,he,te,ie,re,U),this.Cb=H,this.Db=B,this.Eb=M,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:o.$fBb,authority:"base"}),this.yb=this.wb.with({scheme:o.$fBb,authority:"local"}),this.zb=this.wb.with({scheme:o.$fBb,authority:"remote"}),this.Ab=this.wb.with({scheme:o.$fBb,authority:"accepted"}),this.Bb=this.Eb.createInstance(P),this.B(j.Event.any(j.Event.filter(this.Cb.onDidInstallExtensions,z=>z.some(({local:x})=>!!x)),j.Event.filter(this.Cb.onDidUninstallExtension,z=>!z.error),j.Event.filter(D.onDidChange,z=>z.valueChanges.some(({profile:x,changes:K})=>this.syncResource.profile.id===x.id&&K.some(ee=>ee.key===w.$9o))),V.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(T,q){const X=T.syncData?await b(T.syncData,this.Cb):null,G=q?.skippedExtensions??[],Q=q?.builtinExtensions??null,W=q?.syncData?await b(q.syncData,this.Cb):null,{localExtensions:J,ignoredExtensions:H}=await this.Bb.getLocalExtensions(this.syncResource.profile);X?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:ie}=(0,s.$P$b)(J,X,W,G,H,Q),re={local:B,remote:ie,content:this.Hb(J,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:ie!==null?2:0},he=this.Ob(J,!1);return[{skippedExtensions:G,builtinExtensions:Q,baseResource:this.xb,baseContent:W?this.Ob(W,!1):he,localResource:this.yb,localContent:he,localExtensions:J,remoteResource:this.zb,remoteExtensions:X,remoteContent:X?this.Ob(X,!1):null,previewResource:this.wb,previewResult:re,localChange:re.localChange,remoteChange:re.remoteChange,acceptedResource:this.Ab}]}async ub(T){const q=T.syncData?await b(T.syncData,this.Cb):null,{localExtensions:X,ignoredExtensions:G}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,s.$P$b)(X,q,q,T.skippedExtensions||[],G,T.builtinExtensions||[]);return Q!==null}Hb(T,q,X,G){const Q=[...q,...X],W=new Set,J=H=>{W.add(H.id.toLowerCase()),H.uuid&&W.add(H.uuid)};Q.forEach(({identifier:H})=>J(H)),G.forEach(J);for(const H of T)W.has(H.identifier.id.toLowerCase())||H.identifier.uuid&&W.has(H.identifier.uuid)||Q.push(H);return this.Ob(Q,!1)}async rb(T,q){return{...T.previewResult,hasConflicts:!1}}async sb(T,q,X,G){if(this.h.isEqual(q,this.yb))return this.Kb(T);if(this.h.isEqual(q,this.zb))return this.Lb(T);if(this.h.isEqual(q,this.wb))return T.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Kb(T){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),X=this.Db.getIgnoredExtensions(q),G=(0,s.$P$b)(T.localExtensions,null,null,T.skippedExtensions,X,T.builtinExtensions),{local:Q,remote:W}=G;return{content:T.localContent,local:Q,remote:W,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:W!==null?2:0}}async Lb(T){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),X=this.Db.getIgnoredExtensions(q),G=T.remoteContent?JSON.parse(T.remoteContent):null;if(G!==null){const Q=(0,s.$P$b)(T.localExtensions,G,T.localExtensions,[],X,T.builtinExtensions),{local:W,remote:J}=Q;return{content:T.remoteContent,local:W,remote:J,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:J!==null?2:0}}else return{content:T.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(T,q,X,G){let{skippedExtensions:Q,builtinExtensions:W,localExtensions:J}=X[0][0];const{local:H,remote:B,localChange:ie,remoteChange:re}=X[0][1];if(ie===0&&re===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ie!==0&&(await this.nb(JSON.stringify(J)),Q=await this.Bb.updateLocalExtensions(H.added,H.removed,H.updated,Q,this.syncResource.profile)),B){this.O.trace(`${this.D}: Updating remote extensions...`);const he=JSON.stringify(B.all);T=await this.mb(he,G?null:T.ref),this.O.info(`${this.D}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(te=>te.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(te=>te.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(te=>te.identifier.id))}.`:""}`)}q?.ref!==T.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),W=this.Nb(J,W),await this.fb(T,{skippedExtensions:Q,builtinExtensions:W}),this.O.info(`${this.D}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(he=>he.identifier.id))}.`:""}`))}Nb(T,q){const X=new Set,G=[];for(const Q of T)X.add(Q.identifier.id.toLowerCase()),Q.installed||G.push(Q.identifier);if(q)for(const Q of q)X.has(Q.id.toLowerCase())||G.push(Q);return G}async resolveContent(T){if(this.h.isEqual(this.zb,T)||this.h.isEqual(this.xb,T)||this.h.isEqual(this.yb,T)||this.h.isEqual(this.Ab,T)){const q=await this.db(T);return q&&this.Ob(JSON.parse(q),!0)}return null}Ob(T,q){return v(T,q)}async hasLocalData(){try{const{localExtensions:T}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(T.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$S$b=k,e.$S$b=k=Ee([Z(2,E.$Ci),Z(3,g.$2k),Z(4,d.$Zp),Z(5,o.$1Ab),Z(6,o.$2Ab),Z(7,w.$8o),Z(8,i.$kMb),Z(9,o.$dBb),Z(10,f.$2i),Z(11,o.$$Ab),Z(12,$.$1l),Z(13,c.$Zv),Z(14,t.$zl),Z(15,a.$AKb),Z(16,l.$ui)],k);let P=class{constructor(T,q,X,G,Q,W){this.a=T,this.b=q,this.c=X,this.d=G,this.f=Q,this.g=W}async getLocalExtensions(T){const q=await this.a.getInstalled(void 0,T.extensionsResource),X=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(T,async(Q,W)=>{const J=Q.getDisabledExtensions();return q.map(H=>{const{identifier:B,isBuiltin:ie,manifest:re,preRelease:he,pinned:te,isApplicationScoped:V}=H,U={identifier:B,preRelease:he,version:re.version,pinned:!!te};V&&!(0,p.$Tm)(re)&&(U.isApplicationScoped=V),J.some(D=>(0,h.$tp)(D,B))&&(U.disabled=!0),ie||(U.installed=!0);try{const D=W.getKeysForSync({id:B.id,version:re.version});if(D){const M=W.getExtensionState(H,!0)||{};U.state=Object.keys(M).reduce((z,x)=>(D.includes(x)&&(z[x]=M[x]),z),{})}}catch(D){this.g.info(`${(0,n.$xLb)("extensions",T)}: Error while parsing extension state`,(0,L.$0)(D))}return U})}),ignoredExtensions:X}}async updateLocalExtensions(T,q,X,G,Q){const W=(0,n.$xLb)("extensions",Q),J=[],H=new Map,B=[],ie=[],re=await this.a.getInstalled(void 0,Q.extensionsResource);if((T.length||X.length)&&await this.j(Q,async(V,U)=>{await A.Promises.settled([...T,...X].map(async D=>{const M=re.find(K=>(0,h.$tp)(K.identifier,D.identifier));if(M&&M.isBuiltin){D.state&&M.manifest.version===D.version&&this.h(D.state,M,M.manifest.version,U),V.getDisabledExtensions().some(ee=>(0,h.$tp)(ee,D.identifier))!==!!D.disabled&&(D.disabled?(this.g.trace(`${W}: Disabling extension...`,D.identifier.id),await V.disableExtension(D.identifier),this.g.info(`${W}: Disabled extension`,D.identifier.id)):(this.g.trace(`${W}: Enabling extension...`,D.identifier.id),await V.enableExtension(D.identifier),this.g.info(`${W}: Enabled extension`,D.identifier.id))),B.push(D.identifier);return}const z=D.pinned?D.version:void 0,x=(await this.c.getExtensions([{...D.identifier,version:z,preRelease:z?void 0:D.preRelease}],N.CancellationToken.None))[0];if(D.state&&(M?M.manifest.version===D.version:x)&&this.h(D.state,M||x,M?.manifest.version,U),x)try{V.getDisabledExtensions().some(ee=>(0,h.$tp)(ee,D.identifier))!==!!D.disabled&&(D.disabled?(this.g.trace(`${W}: Disabling extension...`,D.identifier.id,x.version),await V.disableExtension(x.identifier),this.g.info(`${W}: Disabled extension`,D.identifier.id,x.version)):(this.g.trace(`${W}: Enabling extension...`,D.identifier.id,x.version),await V.enableExtension(x.identifier),this.g.info(`${W}: Enabled extension`,D.identifier.id,x.version))),(!M||M.preRelease!==D.preRelease||M.pinned!==D.pinned||z&&M.manifest.version!==z)&&(await this.a.canInstall(x)?(J.push({extension:x,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:D.pinned&&!!D.version,installPreReleaseVersion:D.preRelease,profileLocation:Q.extensionsResource,isApplicationScoped:D.isApplicationScoped,context:{[w.$Vo]:!0,[w.$Wo]:!0}}}),H.set(x.identifier.id.toLowerCase(),D)):(this.g.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,x.displayName||x.identifier.id),ie.push(D)))}catch(K){ie.push(D),this.g.error(K),this.g.info(`${W}: Skipped synchronizing extension`,x.displayName||x.identifier.id)}else ie.push(D),this.g.info(`${W}: Skipped synchronizing extension because the extension is not found.`,D.identifier.id)}))}),q.length){const V=re.filter(({identifier:U,isBuiltin:D})=>!D&&q.some(M=>(0,h.$tp)(U,M)));await A.Promises.settled(V.map(async U=>{this.g.trace(`${W}: Uninstalling local extension...`,U.identifier.id),await this.a.uninstall(U,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.g.info(`${W}: Uninstalled local extension.`,U.identifier.id),B.push(U.identifier)}))}const he=await this.a.installGalleryExtensions(J);for(const{identifier:V,local:U,error:D,source:M}of he){const z=M;if(U)this.g.info(`${W}: Installed extension.`,V.id,z.version),B.push(V);else{const x=H.get(V.id.toLowerCase());x&&(ie.push(x),this.g.info(`${W}: Skipped synchronizing extension`,z.displayName||z.identifier.id)),D instanceof w.$6o&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(D.code)?this.g.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,z.displayName||z.identifier.id):D&&this.g.error(D)}}const te=[];for(const V of G)B.some(U=>(0,h.$tp)(U,V.identifier))||te.push(V);for(const V of ie)te.some(U=>(0,h.$tp)(U.identifier,V.identifier))||te.push(V);return te}h(T,q,X,G){const Q=G.getExtensionState(q,!0)||{},W=X?G.getKeysForSync({id:q.identifier.id,version:X}):void 0;W?W.forEach(J=>{Q[J]=T[J]}):Object.keys(T).forEach(J=>Q[J]=T[J]),G.setExtensionState(q,Q,!0)}async j(T,q){return this.b.withProfileScopedStorageService(T,async X=>{const G=new R.$Uc,Q=this.f.createChild(new u.$ti([d.$Zp,X])),W=G.add(Q.createInstance(y.$WJb)),J=G.add(Q.createInstance(c.$1v));try{return await q(W,J)}finally{G.dispose()}})}};e.$T$b=P,e.$T$b=P=Ee([Z(0,w.$8o),Z(1,a.$AKb),Z(2,w.$5o),Z(3,i.$kMb),Z(4,l.$ui),Z(5,o.$dBb)],P);let I=class extends n.$BLb{constructor(T,q,X,G,Q,W,J,H){super("extensions",G,Q,W,X,J,H),this.p=T,this.q=q}async t(T){return T.syncData?await b(T.syncData,this.p):null}u(T,q){const X=[],G=[],Q=[];for(const W of T){if(this.q.hasToNeverSyncExtension(W.identifier.id))continue;const J=q.find(H=>(0,h.$tp)(H.identifier,W.identifier));J?(X.push(J),W.disabled&&Q.push(W.identifier)):W.installed&&(G.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&Q.push(W.identifier))}return{installedExtensions:X,newExtensions:G,disabledExtensions:Q,remoteExtensions:T}}};e.$U$b=I,e.$U$b=I=Ee([Z(0,w.$8o),Z(1,i.$kMb),Z(2,g.$2k),Z(3,r.$Bl),Z(4,E.$Ci),Z(5,m.$2j),Z(6,d.$Zp),Z(7,t.$zl)],I)}),define(ae[116],ce([0,1,15,7,3,35,44,5,32,21,16,12,9,45,19,22,28,39,79,245,25,18,60,4]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HLb=e.$GLb=e.$FLb=e.$ELb=void 0,e.$DLb=i;const n="globalState.argv.",s=["locale"];function i(k,P){const I=k.storage?Object.keys(k.storage).sort():[],F={};return I.forEach(T=>F[T]=k.storage[T]),k.storage=F,P?(0,O.$Tn)(k,{}):JSON.stringify(k)}const o=1;let a=class extends l.$yLb{constructor(P,I,F,T,q,X,G,Q,W,J,H,B,ie,re){super({syncResource:"globalState",profile:P},I,T,Q,B,q,X,W,J,G,H,ie),this.Bb=F,this.pb=o,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:d.$fBb,authority:"base"}),this.xb=this.vb.with({scheme:d.$fBb,authority:"local"}),this.yb=this.vb.with({scheme:d.$fBb,authority:"remote"}),this.zb=this.vb.with({scheme:d.$fBb,authority:"accepted"}),this.Ab=re.createInstance(b),this.B(T.watch(this.h.dirname(this.H.argvResource))),this.B(L.Event.any(L.Event.filter(T.onDidFilesChange,he=>he.contains(this.H.argvResource)),L.Event.filter(F.onDidChange,he=>!!(he.targetChanges.some(te=>this.syncResource.profile.id===te.id)||he.valueChanges.some(({profile:te,changes:V})=>this.syncResource.profile.id===te.id&&V.some(U=>U.target===0)))))(()=>this.Q()))}async qb(P,I,F){const T=P.syncData?JSON.parse(P.syncData.content):null;I=I===null&&F?P:I;const q=I&&I.syncData?JSON.parse(I.syncData.content):null,X=await this.Ab.getLocalGlobalState(this.syncResource.profile);T?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const G=await this.Jb(q),{local:Q,remote:W}=(0,m.$CLb)(X.storage,T?T.storage:null,q?q.storage:null,G,this.O),J={content:null,local:Q,remote:W,localChange:Object.keys(Q.added).length>0||Object.keys(Q.updated).length>0||Q.removed.length>0?2:0,remoteChange:W.all!==null?2:0},H=i(X,!1);return[{baseResource:this.wb,baseContent:q?i(q,!1):H,localResource:this.xb,localContent:H,localUserData:X,remoteResource:this.yb,remoteContent:T?i(T,!1):null,previewResource:this.vb,previewResult:J,localChange:J.localChange,remoteChange:J.remoteChange,acceptedResource:this.zb,storageKeys:G}]}async ub(P){const I=P.syncData?JSON.parse(P.syncData.content):null;if(I===null)return!0;const F=await this.Ab.getLocalGlobalState(this.syncResource.profile),T=await this.Jb(I),{remote:q}=(0,m.$CLb)(F.storage,I.storage,I.storage,T,this.O);return q.all!==null}async rb(P,I){return{...P.previewResult,hasConflicts:!1}}async sb(P,I,F,T){if(this.h.isEqual(I,this.xb))return this.Gb(P);if(this.h.isEqual(I,this.yb))return this.Hb(P);if(this.h.isEqual(I,this.vb))return P.previewResult;throw new Error(`Invalid Resource: ${I.toString()}`)}async Gb(P){return{content:P.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(P.localUserData.storage),removed:[],updated:[],all:P.localUserData.storage},localChange:0,remoteChange:2}}async Hb(P){if(P.remoteContent!==null){const I=JSON.parse(P.remoteContent),{local:F,remote:T}=(0,m.$CLb)(P.localUserData.storage,I.storage,null,P.storageKeys,this.O);return{content:P.remoteContent,local:F,remote:T,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:T!==null?2:0}}else return{content:P.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(P,I,F,T){const{localUserData:q}=F[0][0],{local:X,remote:G,localChange:Q,remoteChange:W}=F[0][1];if(Q===0&&W===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),Q!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(q)),await this.Ab.writeLocalGlobalState(X,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),W!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const J=JSON.stringify({storage:G.all});P=await this.mb(J,T?null:P.ref),this.O.info(`${this.D}: Updated remote ui state.${G.added.length?` Added: ${G.added}.`:""}${G.updated.length?` Updated: ${G.updated}.`:""}${G.removed.length?` Removed: ${G.removed}.`:""}`)}I?.ref!==P.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(P),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(P){if(this.h.isEqual(this.yb,P)||this.h.isEqual(this.wb,P)||this.h.isEqual(this.xb,P)||this.h.isEqual(this.zb,P)){const I=await this.db(P);return I&&i(JSON.parse(I),!0)}return null}async hasLocalData(){try{const{storage:P}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(P).length>1||P[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(P){const I=await this.Bb.readStorageData(this.syncResource.profile),F=[],T=[];for(const[G,Q]of I)Q.target===0?F.push(G):Q.target===1&&T.push(G);const q=[...F,...T],X=P?.storage?Object.keys(P.storage).filter(G=>!G.startsWith(n)&&!q.includes(G)&&I.get(G)!==void 0):[];if(!R.$o){const G=[...d.$WAb.map(Q=>(0,d.$0Ab)(Q)),d.$9Ab];X.push(...G),T.push(...G)}return{user:F,machine:T,unregistered:X}}};e.$ELb=a,e.$ELb=a=Ee([Z(2,t.$AKb),Z(3,y.$2k),Z(4,d.$1Ab),Z(5,d.$2Ab),Z(6,d.$dBb),Z(7,E.$Ci),Z(8,d.$$Ab),Z(9,p.$1l),Z(10,f.$2i),Z(11,c.$Zp),Z(12,g.$zl),Z(13,r.$ui)],a);let b=class{constructor(P,I,F,T){this.a=P,this.b=I,this.c=F,this.d=T}async getLocalGlobalState(P){const I={};if(P.isDefault){const T=await this.f(),q=(0,j.$In)(T);for(const X of s)q[X]!==void 0&&(I[`${n}${X}`]={version:1,value:q[X]})}const F=await this.c.readStorageData(P);for(const[T,q]of F)q.value&&q.target===0&&(I[T]={version:1,value:q.value});return{storage:I}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const P=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),P.value.toString()}catch(P){this.d.debug((0,N.$0)(P))}return"{}"}async writeLocalGlobalState({added:P,removed:I,updated:F},T){const q=(0,l.$xLb)("globalState",T),X={},G=new Map,Q=await this.c.readStorageData(T),W=(J,H)=>{for(const B of J){if(B.startsWith(n)){X[B.substring(n.length)]=H?H[B].value:void 0;continue}if(H){const ie=H[B];ie.value!==Q.get(B)?.value&&G.set(B,ie.value)}else Q.get(B)!==void 0&&G.set(B,void 0)}};if(W(Object.keys(P),P),W(Object.keys(F),F),W(I),Object.keys(X).length){this.d.trace(`${q}: Updating locale...`);const J=await this.f();let H=J;for(const B of Object.keys(X))H=(0,u.edit)(H,[B],X[B],{});J!==H&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,A.$Fe.fromString(H)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}G.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(T,G,0),this.d.info(`${q}: Updated global state`,[...G.keys()]))}};e.$FLb=b,e.$FLb=b=Ee([Z(0,y.$2k),Z(1,E.$Ci),Z(2,t.$AKb),Z(3,d.$dBb)],b);let S=class extends l.$BLb{constructor(P,I,F,T,q,X){super("globalState",F,T,q,I,P,X)}async o(P){const I=P.syncData?JSON.parse(P.syncData.content):null;if(!I){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},T={};for(const q of Object.keys(I.storage))q.startsWith(n)?F[q.substring(n.length)]=I.storage[q].value:this.l.get(q,0)===void 0&&(T[q]=I.storage[q].value);if(Object.keys(F).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const X of Object.keys(F))q=(0,u.edit)(q,[X],F[X],{});await this.k.writeFile(this.h.argvResource,A.$Fe.fromString(q))}if(Object.keys(T).length){const q=[];for(const X of Object.keys(T))q.push({key:X,value:T[X],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$GLb=S,e.$GLb=S=Ee([Z(0,c.$Zp),Z(1,y.$2k),Z(2,$.$Bl),Z(3,E.$Ci),Z(4,d.$dBb),Z(5,g.$zl)],S);let v=class{constructor(P,I,F,T,q){this.a=P,this.b=I,this.c=F,this.d=T,this.f=q}getSyncStoreType(P){return this.h(P)?.storage[d.$9Ab]?.value}async sync(P){const I=(0,d.$5Ab)((0,C.$Rg)());try{return await this.g(P,I)}catch(F){if(F instanceof d.$6Ab)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(P,I)}throw F}}async g(P,I){const F=await this.a.readResource("globalState",null,void 0,I),T=this.h(F)||{storage:{}};T.storage[d.$9Ab]={value:P,version:o};const q=await(0,h.$6p)(this.c,this.d,this.b),X={version:o,machineId:q,content:i(T,!1)};await this.a.writeResource("globalState",JSON.stringify(X),F.ref,void 0,I)}h({content:P}){if(!P)return null;const I=JSON.parse(P);if((0,l.$wLb)(I))return I?JSON.parse(I.content):null;throw new Error("Invalid remote data")}};e.$HLb=v,e.$HLb=v=Ee([Z(1,c.$Zp),Z(2,E.$Ci),Z(3,y.$2k),Z(4,w.$2j)],v)}),define(ae[117],ce([0,1,17,15,3,35,5,13,176,21,16,12,19,22,28,18,39,242,25]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y$b=e.$X$b=void 0,e.$W$b=m;function m(t,r,n){try{const s=JSON.parse(t);if(!r)return(0,R.$cg)(s.all)?null:s.all;switch(O.OS){case 2:return(0,R.$cg)(s.mac)?null:s.mac;case 3:return(0,R.$cg)(s.linux)?null:s.linux;case 1:return(0,R.$cg)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}let d=class extends g.$ALb{constructor(r,n,s,i,o,a,b,S,v,k,P,I,F){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},n,S,v,k,s,i,b,I,o,P,a,F),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:u.$fBb,authority:"base"}),this.Gb=this.Eb.with({scheme:u.$fBb,authority:"local"}),this.Hb=this.Eb.with({scheme:u.$fBb,authority:"remote"}),this.Ib=this.Eb.with({scheme:u.$fBb,authority:"accepted"}),this.B(L.Event.filter(a.onDidChangeConfiguration,T=>T.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(r,n,s,i){const o=r.syncData?m(r.syncData.content,i.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?r:n;const a=n?this.Ob(n):null,b=await this.vb(),S=await this.Cb();let v=null,k=!1,P=!1,I=!1;if(o){let q=b?b.value.toString():"[]";if(q=q||"[]",this.Ab(q,!0))throw new u.$6Ab((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==q||a!==o){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const X=await(0,l.$V$b)(q,o,a,S,this.zb);X.hasChanges&&(v=X.mergeContent,I=X.hasConflicts,k=I||X.mergeContent!==q,P=I||X.mergeContent!==o)}}else b&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=b.value.toString(),P=!0);const F={content:I?a:v,localChange:k?b?2:1:0,remoteChange:P?2:0,hasConflicts:I},T=b?b.value.toString():null;return[{fileContent:b,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:T,localChange:F.localChange,remoteResource:this.Hb,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.Eb,previewResult:F,acceptedResource:this.Ib}]}async ub(r){const n=this.Ob(r);if(n===null)return!0;const s=await this.vb(),i=s?s.value.toString():"",o=await this.Cb(),a=await(0,l.$V$b)(i||"[]",n,n,o,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(r,n){return r.previewResult}async sb(r,n,s,i){if(this.h.isEqual(n,this.Gb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(r,n,s,i){const{fileContent:o}=s[0][0];let{content:a,localChange:b,remoteChange:S}=s[0][1];if(b===0&&S===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new u.$6Ab((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(b!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),o&&await this.nb(this.Pb(o.value.toString())),await this.wb(a||"[]",o,i),this.O.info(`${this.D}: Updated local keybindings`)),S!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const v=this.Pb(a||"[]",r.syncData?.content);r=await this.mb(v,i?null:r.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==r.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(r,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.vb();if(r){const n=(0,j.$In)(r.value.toString());if((0,A.$Lb)(n))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Hb,r)||this.h.isEqual(this.Fb,r)||this.h.isEqual(this.Gb,r)||this.h.isEqual(this.Ib,r)?this.db(r):null}Ob(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Qb()?null:m(r.syncData.content,this.Qb(),this.O)}Pb(r,n){let s={};try{s=JSON.parse(n||"{}")}catch(i){this.O.error(i)}switch(this.Qb()?delete s.all:s.all=r,O.OS){case 2:s.mac=r;break;case 3:s.linux=r;break;case 1:s.windows=r;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(u.$TAb)}};e.$X$b=d,e.$X$b=d=Ee([Z(2,u.$1Ab),Z(3,u.$2Ab),Z(4,u.$dBb),Z(5,f.$2i),Z(6,u.$$Ab),Z(7,y.$2k),Z(8,E.$Ci),Z(9,w.$Zp),Z(10,u.$cBb),Z(11,h.$1l),Z(12,c.$zl)],d);let $=class extends g.$BLb{constructor(r,n,s,i,o,a){super("keybindings",n,s,i,r,o,a)}async o(r){const n=r.syncData?this.p(r.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$Fe.fromString(n)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,j.$In)(r.value.toString());return!(0,A.$Lb)(n)}catch(r){return r.fileOperationResult===1}}p(r){try{return m(r,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$Y$b=$,e.$Y$b=$=Ee([Z(0,y.$2k),Z(1,p.$Bl),Z(2,E.$Ci),Z(3,u.$dBb),Z(4,w.$Zp),Z(5,c.$zl)],$)}),define(ae[118],ce([0,1,15,3,177,21,76,16,29,12,19,22,28,18,39,246,25]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2$b=e.$1$b=void 0,e.$Z$b=u;function l($){return $&&$.settings&&typeof $.settings=="string"&&Object.keys($).length===1}function u($){const t=JSON.parse($);return l(t)?t:{settings:$}}let m=class extends c.$ALb{constructor(t,r,n,s,i,o,a,b,S,v,k,P,I,F){super(t.settingsResource,{syncResource:"settings",profile:t},r,n,s,i,o,a,k,P,b,S,v,F),this.Eb=I,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:g.$fBb,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.$fBb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.$fBb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.$fBb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(t){const r=await this.getLastSyncUserData(),n=await this.X(t,r),s=this.Lb(n),i=new O.$xo(g.$SAb,this.O);return s?.settings&&i.parse(s.settings),i.configurationModel.getValue(g.$SAb)||{}}async qb(t,r,n){const s=await this.vb(),i=await this.Cb(),o=this.Lb(t);r=r===null&&n?t:r;const a=r?this.Lb(r):null,b=await this.Pb();let S=null,v=!1,k=!1,P=!1;if(o){let q=s?s.value.toString().trim():"{}";q=q||"{}",this.Qb(q),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const X=(0,p.$hKb)(q,o.settings,a?a.settings:null,b,[],i);S=X.localContent||X.remoteContent,v=X.localContent!==null,k=X.remoteContent!==null,P=X.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),S=s.value.toString().trim()||"{}",this.Qb(S),k=!0);const I=s?s.value.toString():null,F=a?.settings??null,T={content:P?F:S,localChange:v?2:0,remoteChange:k?2:0,hasConflicts:P};return[{fileContent:s,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:I,localChange:T.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:T.remoteChange,previewResource:this.previewResource,previewResult:T,acceptedResource:this.acceptedResource}]}async ub(t){const r=this.Lb(t);if(r===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",i=await this.Pb(),o=await this.Cb();return(0,p.$hKb)(s||"{}",r.settings,r.settings,i,[],o).remoteContent!==null}async rb(t,r){const n=await this.Cb(),s=await this.Pb();return{...t.previewResult,content:t.previewResult.content?(0,p.$gKb)(t.previewResult.content,"{}",s,n):null}}async sb(t,r,n,s){const i=await this.Cb(),o=await this.Pb();if(this.h.isEqual(r,this.localResource))return{content:t.fileContent?(0,p.$gKb)(t.fileContent.value.toString(),"{}",o,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,p.$gKb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",o,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(r,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,p.$gKb)(n,t.fileContent?t.fileContent.value.toString():"{}",o,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async tb(t,r,n,s){const{fileContent:i}=n[0][0];let{content:o,localChange:a,remoteChange:b}=n[0][1];if(a===0&&b===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Qb(o),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),i&&await this.nb(JSON.stringify(this.Nb(i.value.toString()))),await this.wb(o,i,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),b!==0){const S=await this.Cb(),v=this.Lb(t),k=await this.Pb(o);o=(0,p.$gKb)(o,v?v.settings:"{}",k,S),this.O.trace(`${this.D}: Updating remote settings...`),t=await this.mb(JSON.stringify(this.Nb(o)),s?null:t.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}r?.ref!==t.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(t),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.vb();if(t)return!(0,p.$iKb)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.db(t):null}async db(t){let r=await super.db(t);if(r){const n=await this.Cb(),s=await this.Pb();r=(0,p.$gKb)(r,"{}",s,n)}return r}Lb(t){return t.syncData?this.Mb(t.syncData.content):null}Mb(t){try{return u(t)}catch(r){this.O.error(r)}return null}Nb(t){return{settings:t}}async Pb(t){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:i})=>!!i)),N.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const r=await this.Ob;return(0,p.$eKb)(r,this.P,t)}Qb(t){if(this.Ab(t,!1))throw new g.$6Ab((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$1$b=m,e.$1$b=m=Ee([Z(2,f.$2k),Z(3,R.$Ci),Z(4,E.$Zp),Z(5,g.$1Ab),Z(6,g.$2Ab),Z(7,g.$dBb),Z(8,g.$cBb),Z(9,j.$2i),Z(10,g.$$Ab),Z(11,y.$1l),Z(12,C.$8o),Z(13,w.$zl)],m);let d=class extends c.$BLb{constructor(t,r,n,s,i,o){super("settings",r,n,s,t,i,o)}async o(t){const r=t.syncData?this.p(t.syncData.content):null;if(!r){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,A.$Fe.fromString(r.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$iKb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}p(t){try{return u(t)}catch(r){this.j.error(r)}return null}};e.$2$b=d,e.$2$b=d=Ee([Z(0,f.$2k),Z(1,h.$Bl),Z(2,R.$Ci),Z(3,g.$dBb),Z(4,E.$Zp),Z(5,w.$zl)],d)}),define(ae[119],ce([0,1,15,3,30,21,16,12,19,22,28,18,39,243,25]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7$b=e.$6$b=void 0,e.$5$b=p;function p(u){return JSON.parse(u.content)}let g=class extends w.$yLb{constructor(m,d,$,t,r,n,s,i,o,a,b,S){super({syncResource:"snippets",profile:m},d,t,$,r,n,s,a,b,i,o,S),this.pb=1,this.vb=m.snippetsHome,this.B(this.G.watch($.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,v=>v.affects(this.vb))(()=>this.Q()))}async qb(m,d,$){const t=await this.Hb(),r=this.Gb(t),n=m.syncData?this.Fb(m.syncData):null;d=d===null&&$?m:d;const s=d&&d.syncData?this.Fb(d.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,h.$3$b)(r,n,s);return this.Bb(i,t,n||{},s||{})}async ub(m){const d=m.syncData?this.Fb(m.syncData):null;if(d===null)return!0;const $=await this.Hb(),t=this.Gb($),r=(0,h.$3$b)(t,d,d);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async rb(m,d){return m.previewResult}async sb(m,d,$,t){if(this.h.isEqualOrParent(d,this.g.with({scheme:c.$fBb,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(d,this.g.with({scheme:c.$fBb,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(d,this.g))return $===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:$,localChange:$===null?m.fileContent!==null?3:0:2,remoteChange:$===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(m,d,$,t){const r=$.map(([n,s])=>({...n,acceptResult:s}));r.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),r.some(({localChange:n})=>n!==0)&&(await this.Cb(r),await this.Db(r,t)),r.some(({remoteChange:n})=>n!==0)&&(m=await this.Eb(r,m,t)),d?.ref!==m.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(m),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of r)try{await this.G.del(n)}catch{}}Bb(m,d,$,t){const r=new Map;for(const n of Object.keys(m.local.added)){const s={content:m.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"accepted"})})}for(const n of Object.keys(m.local.updated)){const s={content:m.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"local"}),fileContent:d[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"accepted"})})}for(const n of m.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"local"}),fileContent:d[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"accepted"})})}for(const n of Object.keys(m.remote.added)){const s={content:m.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"local"}),fileContent:d[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"accepted"})})}for(const n of Object.keys(m.remote.updated)){const s={content:m.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"local"}),fileContent:d[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"accepted"})})}for(const n of m.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"accepted"})})}for(const n of m.conflicts){const s={content:t[n]??null,hasConflicts:!0,localChange:d[n]?2:1,remoteChange:$[n]?2:1},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"local"}),fileContent:d[n]||null,localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"remote"}),remoteContent:$[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"accepted"})})}for(const n of Object.keys(d))if(!r.has(n)){const s={content:d[n]?d[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"local"}),fileContent:d[n]||null,localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"remote"}),remoteContent:$[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$fBb,authority:"accepted"})})}return[...r.values()]}async resolveContent(m){return this.h.isEqualOrParent(m,this.g.with({scheme:c.$fBb,authority:"remote"}))||this.h.isEqualOrParent(m,this.g.with({scheme:c.$fBb,authority:"local"}))||this.h.isEqualOrParent(m,this.g.with({scheme:c.$fBb,authority:"base"}))||this.h.isEqualOrParent(m,this.g.with({scheme:c.$fBb,authority:"accepted"}))?this.db(m):null}async hasLocalData(){try{const m=await this.Hb();if(Object.keys(m).length)return!0}catch{}return!1}async Cb(m){const d={};for(const $ of m)$.fileContent&&(d[this.h.basename($.localResource)]=$.fileContent);await this.nb(JSON.stringify(this.Gb(d)))}async Db(m,d){for(const{fileContent:$,acceptResult:t,localResource:r,remoteResource:n,localChange:s}of m)if(s!==0){const i=n?this.h.basename(n):this.h.basename(r),o=this.h.joinPath(this.vb,i);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(o)),await this.G.del(o),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(o))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(o)),await this.G.createFile(o,A.$Fe.fromString(t.content),{overwrite:d}),this.O.info(`${this.D}: Created snippet`,this.h.basename(o))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(o)),await this.G.writeFile(o,A.$Fe.fromString(t.content),d?void 0:$),this.O.info(`${this.D}: Updated snippet`,this.h.basename(o)))}}async Eb(m,d,$){const t=d.syncData?this.Fb(d.syncData):{},r=(0,L.$2n)(t);for(const{acceptResult:n,localResource:s,remoteResource:i,remoteChange:o}of m)if(o!==0){const a=s?this.h.basename(s):this.h.basename(i);o===3?delete r[a]:r[a]=n.content}return(0,h.$4$b)(t,r)||(this.O.trace(`${this.D}: Updating remote snippets...`),d=await this.mb(JSON.stringify(r),$?null:d.ref),this.O.info(`${this.D}: Updated remote snippets`)),d}Fb(m){return p(m)}Gb(m){const d={};for(const $ of Object.keys(m))d[$]=m[$].value.toString();return d}async Hb(){const m={};let d;try{d=await this.G.resolve(this.vb)}catch($){if($ instanceof R.$kl&&$.fileOperationResult===1)return m;throw $}for(const $ of d.children||[]){const t=$.resource,r=this.h.extname(t);if(r===".json"||r===".code-snippets"){const n=this.h.relativePath(this.vb,t),s=await this.G.readFile(t);m[n]=s}}return m}};e.$6$b=g,e.$6$b=g=Ee([Z(2,O.$Ci),Z(3,R.$2k),Z(4,C.$Zp),Z(5,c.$1Ab),Z(6,c.$2Ab),Z(7,c.$dBb),Z(8,j.$2i),Z(9,c.$$Ab),Z(10,f.$1l),Z(11,E.$zl)],g);let l=class extends w.$BLb{constructor(m,d,$,t,r,n){super("snippets",d,$,t,m,r,n)}async o(m){const d=m.syncData?JSON.parse(m.syncData.content):null;if(!d){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(d)){const r=d[t];if(r){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(n,A.$Fe.fromString(r)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(m)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};e.$7$b=l,e.$7$b=l=Ee([Z(0,R.$2k),Z(1,y.$Bl),Z(2,O.$Ci),Z(3,c.$dBb),Z(4,C.$Zp),Z(5,E.$zl)],l)}),define(ae[120],ce([0,1,15,21,16,12,19,22,28,18,39,25]),function(ne,e,A,N,L,j,O,R,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0$b=e.$9$b=void 0,e.$8$b=w;function w(g,l){try{return JSON.parse(g).tasks??null}catch(u){return l.error(u),null}}let h=class extends E.$zLb{constructor(l,u,m,d,$,t,r,n,s,i,o,a){super(l.tasksResource,{syncResource:"tasks",profile:l},u,n,s,i,m,d,r,o,$,t,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:y.$fBb,authority:"base"}),this.Cb=this.Ab.with({scheme:y.$fBb,authority:"local"}),this.Db=this.Ab.with({scheme:y.$fBb,authority:"remote"}),this.Eb=this.Ab.with({scheme:y.$fBb,authority:"accepted"})}async qb(l,u,m,d){const $=l.syncData?w(l.syncData.content,this.O):null;u=u===null&&m?l:u;const t=u?.syncData?w(u.syncData.content,this.O):null,r=await this.vb();let n=null,s=!1,i=!1,o=!1;if(l.syncData){const S=r?r.value.toString():null;if(!t||t!==S||t!==$){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const v=p(S,$,t);n=v.content,o=v.hasConflicts,s=v.hasLocalChanged,i=v.hasRemoteChanged}}else r&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=r.value.toString(),i=!0);const a={content:o?t:n,localChange:s?r?2:1:0,remoteChange:i?2:0,hasConflicts:o},b=r?r.value.toString():null;return[{fileContent:r,baseResource:this.Bb,baseContent:t,localResource:this.Cb,localContent:b,localChange:a.localChange,remoteResource:this.Db,remoteContent:$,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(l){const u=l?.syncData?w(l.syncData.content,this.O):null;if(u===null)return!0;const m=await this.vb(),d=m?m.value.toString():null,$=p(d,u,u);return $.hasLocalChanged||$.hasRemoteChanged}async rb(l,u){return l.previewResult}async sb(l,u,m,d){if(this.h.isEqual(u,this.Cb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.Db))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.Ab))return m===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:m,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async tb(l,u,m,d){const{fileContent:$}=m[0][0],{content:t,localChange:r,remoteChange:n}=m[0][1];if(r===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),r!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),$&&await this.nb(JSON.stringify(this.Kb($.value.toString()))),t?await this.wb(t,$,d):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(t));l=await this.mb(s,d?null:l.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(l){return this.h.isEqual(this.Db,l)||this.h.isEqual(this.Bb,l)||this.h.isEqual(this.Cb,l)||this.h.isEqual(this.Eb,l)?this.db(l):null}Kb(l){return l?{tasks:l}:{}}};e.$9$b=h,e.$9$b=h=Ee([Z(2,y.$1Ab),Z(3,y.$2Ab),Z(4,y.$dBb),Z(5,N.$2i),Z(6,y.$$Ab),Z(7,j.$2k),Z(8,L.$Ci),Z(9,O.$Zp),Z(10,R.$1l),Z(11,C.$zl)],h);let c=class extends E.$BLb{constructor(l,u,m,d,$,t){super("tasks",u,m,d,l,$,t),this.c=this.g.defaultProfile.tasksResource}async o(l){const u=l.syncData?w(l.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,A.$Fe.fromString(u)),await this.n(l)}async p(){return this.k.exists(this.c)}};e.$0$b=c,e.$0$b=c=Ee([Z(0,j.$2k),Z(1,f.$Bl),Z(2,L.$Ci),Z(3,y.$dBb),Z(4,O.$Zp),Z(5,C.$zl)],c);function p(g,l,u){if(g===null&&l===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(g===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const m=u!==g,d=u!==l;return!m&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:m&&!d?{content:g,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!m?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:g,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ae[121],ce([0,1,44,21,16,12,19,22,28,18,39,244,25]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qac=void 0,e.$Rac=c,e.$Sac=p;let h=class extends E.$yLb{constructor(l,u,m,d,$,t,r,n,s,i,o,a,b){super({syncResource:"profiles",profile:l},u,d,$,t,r,n,o,a,s,i,b),this.vb=m,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:w.$fBb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$fBb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$fBb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$fBb,authority:"accepted"}),this.B(m.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?p(l.syncData):null}async getRemoteSyncedProfiles(l){const u=await this.getLastSyncUserData(),m=await this.X(l,u);return m?.syncData?p(m.syncData):null}async qb(l,u,m){if(!this.vb.isEnabled())throw new w.$6Ab("Cannot sync profiles because they are disabled","LocalError");const d=l.syncData?p(l.syncData):null,$=u?.syncData?p(u.syncData):null,t=this.Db(),{local:r,remote:n}=(0,y.$Pac)(t,d,$,[]),s={local:r,remote:n,content:$?this.Eb($):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:n!==null?2:0},i=c(t,!1);return[{baseResource:this.baseResource,baseContent:$?this.Eb($):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:d?this.Eb(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(l){const u=l?.syncData?p(l.syncData):null,m=this.Db(),{remote:d}=(0,y.$Pac)(m,u,u,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async rb(l,u){return{...l.previewResult,hasConflicts:!1}}async sb(l,u,m,d){if(this.h.isEqual(u,this.localResource))return this.Ab(l);if(this.h.isEqual(u,this.remoteResource))return this.Bb(l);if(this.h.isEqual(u,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async Ab(l){const u=this.Db(),m=(0,y.$Pac)(u,null,null,[]),{local:d,remote:$}=m;return{content:l.localContent,local:d,remote:$,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:$!==null?2:0}}async Bb(l){const u=l.remoteContent?JSON.parse(l.remoteContent):null,m=[],d=[];for(const $ of this.Db()){const t=u?.find(r=>r.id===$.id);t&&(m.push({id:$.id,name:$.name,collection:t.collection}),d.push($))}if(u!==null){const $=(0,y.$Pac)(d,u,m,[]),{local:t,remote:r}=$;return{content:l.remoteContent,local:t,remote:r,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(l,u,m,d){const{local:$,remote:t,localChange:r,remoteChange:n}=m[0][1];r===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=m[0][0].remoteProfiles||[];if(s.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new w.$6Ab("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0&&(await this.nb(c(this.Db(),!1)),await Promise.all($.removed.map(async i=>{this.O.trace(`${this.D}: Removing '${i.name}' profile...`),await this.vb.removeProfile(i),this.O.info(`${this.D}: Removed profile '${i.name}'.`)})),await Promise.all($.added.map(async i=>{this.O.trace(`${this.D}: Creating '${i.name}' profile...`),await this.vb.createProfile(i.id,i.name,{shortName:i.shortName,icon:i.icon,useDefaultFlags:i.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${i.name}'.`)})),await Promise.all($.updated.map(async i=>{const o=this.vb.profiles.find(a=>a.id===i.id);o?(this.O.trace(`${this.D}: Updating '${i.name}' profile...`),await this.vb.updateProfile(o,{name:i.name,shortName:i.shortName,icon:i.icon,useDefaultFlags:i.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${i.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${i.id}' to update.`)}))),n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const i=[],o=s.length+(t?.added.length??0)<=20;if(o)for(const a of t?.added||[]){const b=await this.J.createCollection(this.F);i.push(b),s.push({id:a.id,name:a.name,collection:b,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of t?.removed||[])s.splice(s.findIndex(({id:b})=>a.id===b),1);for(const a of t?.updated||[]){const b=s.find(({id:S})=>a.id===S);b&&s.splice(s.indexOf(b),1,{...b,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(s,d?null:l.ref),this.O.info(`${this.D}: Updated remote profiles.${o&&t?.added.length?` Added: ${JSON.stringify(t.added.map(a=>a.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(a=>a.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(a=>a.name))}.`:""}`)}catch(a){if(i.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const b of i)await this.J.deleteCollection(b,this.F)}throw a}for(const a of t?.removed||[])await this.J.deleteCollection(a.collection,this.F)}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,u){return this.mb(this.Eb(l),u)}async hasLocalData(){return this.Db().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const u=await this.db(l);return u&&(0,A.$Tn)(JSON.parse(u),{})}return null}Db(){return this.vb.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Eb(l){return JSON.stringify([...l].sort((u,m)=>u.name.localeCompare(m.name)))}};e.$Qac=h,e.$Qac=h=Ee([Z(2,f.$Bl),Z(3,j.$2k),Z(4,L.$Ci),Z(5,O.$Zp),Z(6,w.$1Ab),Z(7,w.$2Ab),Z(8,w.$dBb),Z(9,N.$2i),Z(10,w.$$Ab),Z(11,R.$1l),Z(12,C.$zl)],h);function c(g,l){const u=[...g].sort((m,d)=>m.name.localeCompare(d.name)).map(m=>({id:m.id,name:m.name}));return l?(0,A.$Tn)(u,{}):JSON.stringify(u)}function p(g){return JSON.parse(g.content)}}),define(ae[261],ce([0,1,3,2,5,16,19,22,25]),function(ne,e,A,N,L,j,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=void 0;const f="sync.enable";let E=class extends N.$Vc{constructor(w,h,c,p){super(),this.c=w,this.f=h,this.g=c,this.h=p,this.a=new A.$ee,this.onDidChangeEnablement=this.a.event,this.b=new A.$ee,this.onDidChangeResourceEnablement=this.b.event,this.B(w.onDidChangeValue(-1,void 0,this.B(new N.$Uc))(g=>this.m(g)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(f,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(w){w&&!this.canToggleEnablement()||(this.f.publicLog2(f,{enabled:w}),this.c.store(f,w,-1,1))}isResourceEnabled(w){return this.c.getBoolean((0,C.$0Ab)(w),-1,!0)}setResourceEnablement(w,h){if(this.isResourceEnabled(w)!==h){const c=(0,C.$0Ab)(w);this.j(c,h)}}getResourceSyncStateVersion(w){}j(w,h){this.c.store(w,h,-1,L.$o?0:1)}m(w){if(f===w.key){this.a.fire(this.isEnabled());return}const h=C.$WAb.filter(c=>(0,C.$0Ab)(c)===w.key)[0];if(h){this.b.fire([h,this.isResourceEnabled(h)]);return}}};e.$Dac=E,e.$Dac=E=Ee([Z(0,O.$Zp),Z(1,R.$1l),Z(2,j.$Ci),Z(3,C.$ZAb)],E)}),define(ae[262],ce([0,1,6,15,65,2,20,21,16,12,18,25]),function(ne,e,A,N,L,j,O,R,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oac=void 0;let w=class extends j.$Vc{constructor(c,p,g,l,u){super(),this.a=c,this.b=p,this.c=g,this.f=l,this.g=u,this.h()}async h(){for(const p of this.g.profiles)for(const g of y.$WAb)try{await this.m(this.j(g,p.isDefault?void 0:p.id))}catch(l){this.f.error(l)}let c;try{c=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,f.$gl)(p)!==1&&this.f.error(p);return}if(c.children){for(const p of c.children)if(p.isDirectory&&!this.g.profiles.some(g=>g.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(g){this.f.error(g)}}}async getAllResourceRefs(c,p,g){const l=this.j(c,p,g);try{const u=await this.b.resolve(l);if(u.children)return u.children.filter(d=>d.isFile&&!d.name.startsWith("lastSync")).sort().reverse().map(d=>({ref:d.name,created:this.n(d)}))}catch(u){if((0,f.$gl)(u)!==1)throw u}return[]}async resolveResourceContent(c,p,g,l){const u=this.j(c,g,l),m=(0,O.$9g)(u,p);try{return(await this.b.readFile(m)).value.toString()}catch(d){return this.f.error(d),null}}async writeResource(c,p,g,l,u){const m=this.j(c,l,u),d=(0,O.$9g)(m,`${(0,L.$3m)(g).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,N.$Fe.fromString(p))}catch($){this.f.error($)}}j(c,p,g=this.a.userDataSyncHome){return(0,O.$9g)(g,...p?[p,c]:[c])}async m(c){try{try{if(!await this.b.exists(c))return}catch{return}const p=await this.b.resolve(c);if(p.children){const g=p.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=g.filter(d=>Date.now()-this.n(d)>l);const m=g.length-u.length;m<10&&(u=u.slice(10-m)),await A.Promises.settled(u.map(async d=>{this.f.info("Deleting from backup",d.resource.path),await this.b.del(d.resource)}))}}catch(p){this.f.error(p)}}n(c){return new Date(parseInt(c.name.substring(0,4)),parseInt(c.name.substring(4,6))-1,parseInt(c.name.substring(6,8)),parseInt(c.name.substring(9,11)),parseInt(c.name.substring(11,13)),parseInt(c.name.substring(13,15))).getTime()}};e.$Oac=w,e.$Oac=w=Ee([Z(0,C.$Ci),Z(1,f.$2k),Z(2,R.$2i),Z(3,y.$dBb),Z(4,E.$Bl)],w)}),define(ae[83],ce([0,1,3,2,5,27,181,16,12,4,24,45,19,25]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$PAb=e.$NAb=void 0,e.$OAb=$,e.$NAb=(0,f.$vi)("IUserDataSyncMachinesService");const p="sync.currentMachineName",g="Safari",l="Chrome",u="Edge",m="Firefox",d="Android";function $(n){switch(n){case g:case l:case u:case m:case d:case(0,L.$h)(0):return!0}return!1}function t(){return L.$G?g:L.$E?l:L.$H?u:L.$F?m:L.$I?d:(0,L.$h)(L.$o?0:L.$u)}let r=class extends N.$Vc{static{c=this}static{this.a=1}static{this.b="machines"}constructor(s,i,o,a,b,S){super(),this.h=o,this.j=a,this.m=b,this.n=S,this.c=this.B(new A.$ee),this.onDidChange=this.c.event,this.g=null,this.f=(0,y.$6p)(s,i,o)}async getMachines(s){const i=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===i}))}async addCurrentMachine(s){const i=await this.f,o=await this.s(s);o.machines.some(({id:a})=>a===i)||(o.machines.push({id:i,name:this.r(o.machines),platform:t()}),await this.t(o))}async removeCurrentMachine(s){const i=await this.f,o=await this.s(s),a=o.machines.filter(({id:b})=>b!==i);a.length!==o.machines.length&&(o.machines=a,await this.t(o))}async renameMachine(s,i,o){const a=await this.s(o),b=a.machines.find(({id:S})=>S===s);if(b){b.name=i,await this.t(a);const S=await this.f;s===S&&this.h.store(p,i,-1,1)}}async setEnablements(s){const i=await this.s();for(const[o,a]of s){const b=i.machines.find(S=>S.id===o);b&&(b.disabled=a?void 0:!0)}await this.t(i)}r(s){const i=this.h.get(p,-1);if(i)return i;const o=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${t()} (${this.n.nameShort})`,a=new RegExp(`${(0,j.$_e)(o)}\\s#(\\d+)`);let b=0;for(const S of s){const v=a.exec(S.name),k=v?parseInt(v[1]):0;b=k>b?k:b}return`${o} #${b+1}`}async s(s){this.g=await this.u(s);const i=this.w(this.g);if(i.version!==c.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return i}async t(s){const i=JSON.stringify(s),o=await this.j.writeResource(c.b,i,this.g?.ref||null);this.g={ref:o,content:i},this.c.fire()}async u(s){if(this.g){const i=s&&s.latest?s.latest[c.b]:void 0;if(this.g.ref===i)return this.g;if(i===void 0&&this.g.content===null)return this.g}return this.j.readResource(c.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(i){this.m.error(i)}return{version:c.a,machines:[]}}};e.$PAb=r,e.$PAb=r=c=Ee([Z(0,R.$Ci),Z(1,C.$2k),Z(2,w.$Zp),Z(3,h.$1Ab),Z(4,h.$dBb),Z(5,E.$ik)],r)}),define(ae[263],ce([0,1,6,65,38,7,3,2,5,20,8,178,24,19,22,25,80,83]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uac=void 0;const u="sync.disableMachineEventually",m="sync.sessionId",d="sync.storeUrl",$="sync.productQuality";let t=class extends R.$Vc{get n(){const s=this.H.get(d,-1);return s?E.URI.parse(s):void 0}set n(s){s?this.H.store(d,s.toString(),-1,1):this.H.remove(d,-1)}get s(){return this.H.get($,-1)}set s(s){s?this.H.store($,s,-1,1):this.H.remove($,-1)}constructor(s,i,o,a,b,S,v,k,P,I){super(),this.u=i,this.w=o,this.y=a,this.z=b,this.C=S,this.D=v,this.F=k,this.G=P,this.H=I,this.a=this.B(new R.$Wc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$ee),this.onError=this.h.event,this.S=[],this.f=this.B(new A.$th(this.U())),this.j=this.n,this.n=i.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(i.onDidChangeUserDataSyncStore(()=>{(0,f.$2g)(this.n,i.userDataSyncStore?.url)||(this.j=this.n,this.n=i.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(v.onDidChangeAccount(()=>this.I())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(b.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:i}=this.L();s?this.a.value===void 0&&(this.a.value=new r(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.O(o))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(i&&this.C.info(i),this.a.clear()):i&&this.y.isEnabled()&&this.C.info(i))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$3m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,i,o){try{this.D.account&&!o&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(m,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),i)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const i=p.$6Ab.toUserDataSyncError(s);i instanceof p.$8Ab&&this.F.publicLog2("autosync/error",{code:i.code,service:this.u.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?C.$o&&i.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(i),this.b++),this.h.fire(i)}async P(){this.H.store(u,!0,-1,1),await(0,A.$wh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(u,-1,!1)}R(){this.H.remove(u,-1)}async triggerSync(s,i,o){if(this.a.value===void 0)return this.f.cancel();if(i&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$Uac=t,e.$Uac=t=Ee([Z(0,w.$ik),Z(1,p.$ZAb),Z(2,p.$1Ab),Z(3,p.$$Ab),Z(4,p.$_Ab),Z(5,p.$dBb),Z(6,g.$YJb),Z(7,c.$1l),Z(8,l.$NAb),Z(9,h.$Zp)],t);class r extends R.$Vc{static{this.a="Interval"}constructor(s,i,o,a,b,S,v,k,P){super(),this.m=s,this.n=i,this.r=o,this.s=a,this.u=b,this.w=S,this.y=v,this.z=k,this.C=P,this.b=this.B(new R.$Wc),this.c=this.B(new O.$ee),this.onDidStartSync=this.c.event,this.f=this.B(new O.$ee),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Tc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}D(){this.b.value=(0,A.$xh)(()=>{this.sync(r.a,!1),this.b.value=void 0},this.n)}sync(s,i){const o=(0,A.$ih)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(b){if((0,j.$4)(b))return}return this.H(s,i,a)});return this.j=o,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,f.$2g)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),i=this.r.userDataSyncStore;return!!i&&!!s&&(!(0,f.$2g)(i.defaultUrl,s.defaultUrl)||!(0,f.$2g)(i.insidersUrl,s.insidersUrl)||!(0,f.$2g)(i.stableUrl,s.stableUrl))}async H(s,i,o){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(i,o)}catch(b){if(this.y.error(b),a=b,p.$6Ab.toUserDataSyncError(b).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(i,o),a=void 0}catch(S){this.y.error(S),a=S}}this.f.fire(a)}async I(s,i){if(this.h=await this.u.createSyncTask(this.g,s),i.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$8Ab((0,y.localize)(0,null),"DefaultServiceChanged"):new p.$8Ab((0,y.localize)(1,null),"ServiceChanged"):new p.$8Ab((0,y.localize)(2,null),"TurnedOff");const o=this.C.get(m,-1);if(o&&this.g&&o!==this.g.session)throw this.F()?await this.G()?new p.$8Ab((0,y.localize)(3,null),"DefaultServiceChanged"):new p.$8Ab((0,y.localize)(4,null),"ServiceChanged"):new p.$8Ab((0,y.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(i.isCancellationRequested)return;const b=a.find(v=>v.isCurrent);if(b?.disabled)throw new p.$8Ab((0,y.localize)(6,null),"TurnedOff");const S=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-S}),this.g===null)try{this.g=await this.s.manifest(null)}catch(v){throw new p.$8Ab((0,L.$gj)(v),v instanceof p.$6Ab?v.code:"Unknown")}this.g&&this.g.session!==o&&this.C.store(m,this.g.session,-1,1),!i.isCancellationRequested&&(b||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(ae[264],ce([0,1,8,182,16,12,45,19,28,25,18,39,119,118,117,21,120,115,116,4,121,44,27]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$qbc=void 0;let n=class{static{r=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(i,o,a,b,S,v,k,P,I,F){this.e=i,this.f=o,this.g=a,this.h=S,this.i=v,this.j=k,this.k=P,this.l=I,this.n=F,this.d=b.extUri}async getRemoteSyncedProfiles(){const i=await this.e.readResource("profiles",null,void 0);if(i.content){const o=this.L(i.content,"profiles");return(0,d.$Sac)(o)}return[]}async getLocalSyncedProfiles(i){const o=await this.f.getAllResourceRefs("profiles",void 0,i);if(o.length){const a=await this.f.resolveResourceContent("profiles",o[0].ref,void 0,i);if(a){const b=this.L(a,"profiles");return(0,d.$Sac)(b)}}return[]}async getLocalSyncedMachines(i){const o=await this.f.getAllResourceRefs("machines",void 0,i);if(o.length){const a=await this.f.resolveResourceContent("machines",o[0].ref,void 0,i);if(a)return JSON.parse(a).machines.map(S=>({...S,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(i,o){return(await this.e.getAllResourceRefs(i,o?.collection)).map(({created:b,ref:S})=>({created:b,uri:this.J({remote:!0,syncResource:i,profile:o?.id??this.k.defaultProfile.id,location:void 0,collection:o?.collection,ref:S,node:void 0})}))}async getLocalSyncResourceHandles(i,o,a){return(await this.f.getAllResourceRefs(i,o?.collection,a)).map(({created:S,ref:v})=>({created:S,uri:this.J({remote:!1,syncResource:i,profile:o?.id??this.k.defaultProfile.id,collection:o?.collection,ref:v,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:i}){const o=this.K(i),a=o?this.k.profiles.find(b=>b.id===o.profile):void 0;return o&&a?{profile:a,syncResource:o?.syncResource}:void 0}async getAssociatedResources({uri:i}){const o=this.K(i);if(!o)return[];const a=this.k.profiles.find(b=>b.id===o.profile);switch(o.syncResource){case"settings":return this.s(i,a);case"keybindings":return this.u(i,a);case"tasks":return this.w(i,a);case"snippets":return this.y(i,a);case"globalState":return this.D(i,a);case"extensions":return this.A(i,a);case"profiles":return this.G(i,a);case"workspaceState":return[]}}async getMachineId({uri:i}){const o=this.K(i);if(o){if(o.remote){if(o.ref){const{content:a}=await this.M(o.syncResource,o.ref,o.collection);if(a)return this.L(a,o.syncResource)?.machineId}return}if(o.location){if(o.ref){const a=await this.f.resolveResourceContent(o.syncResource,o.ref,o.collection,o.location);if(a)return this.L(a,o.syncResource)?.machineId}return}return(0,O.$6p)(this.h,this.j,this.i)}}async resolveContent(i){const o=this.K(i);if(!o||o.node===r.a)return null;if(o.ref){const a=await this.o(o.remote,o.syncResource,o.collection,o.ref,o.location);return o.node&&a?this.q(o.syncResource,a,o.node):a}return!o.remote&&!o.node?this.r(o.syncResource,o.profile):null}async o(i,o,a,b,S){if(i){const{content:v}=await this.M(o,b,a);return v}return this.f.resolveResourceContent(o,b,a,S)}q(i,o,a){const b=this.L(o,i);switch(i){case"settings":return this.t(b,a);case"keybindings":return this.v(b,a);case"tasks":return this.x(b,a);case"snippets":return this.z(b,a);case"globalState":return this.E(b,a);case"extensions":return this.B(b,a);case"profiles":return this.H(b,a);case"workspaceState":return null}}async r(i,o){const a=this.k.profiles.find(b=>b.id===o);if(!a)return null;switch(i){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(i,o){const a=this.d.joinPath(i,"settings.json"),b=o?o.settingsResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}t(i,o){switch(o){case"settings.json":return(0,h.$Z$b)(i.content).settings}return null}u(i,o){const a=this.d.joinPath(i,"keybindings.json"),b=o?o.keybindingsResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}v(i,o){switch(o){case"keybindings.json":return(0,c.$W$b)(i.content,!!this.l.getValue(f.$TAb),this.g)}return null}w(i,o){const a=this.d.joinPath(i,"tasks.json"),b=o?o.tasksResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}x(i,o){switch(o){case"tasks.json":return(0,g.$8$b)(i.content,this.g)}return null}async y(i,o){const a=await this.resolveContent(i);if(a){const b=this.L(a,"snippets");if(b){const S=(0,w.$5$b)(b),v=[];for(const k of Object.keys(S)){const P=this.d.joinPath(i,k),I=o?this.d.joinPath(o.snippetsHome,k):this.d.joinPath(i,r.a);v.push({resource:P,comparableResource:I})}return v}}return[]}z(i,o){return(0,w.$5$b)(i)[o]||null}A(i,o){const a=this.d.joinPath(i,"extensions.json"),b=o?this.J({remote:!1,syncResource:"extensions",profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}B(i,o){switch(o){case"extensions.json":return(0,l.$R$b)((0,l.$Q$b)(i),!0)}return null}async C(i){const{localExtensions:o}=await this.n.createInstance(l.$T$b).getLocalExtensions(i);return(0,l.$R$b)(o,!0)}D(i,o){const a=this.d.joinPath(i,"globalState.json"),b=o?this.J({remote:!1,syncResource:"globalState",profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}E(i,o){switch(o){case"globalState.json":return(0,u.$DLb)(JSON.parse(i.content),!0)}return null}async F(i){const o=await this.n.createInstance(u.$FLb).getLocalGlobalState(i);return(0,u.$DLb)(o,!0)}G(i,o){const a=this.d.joinPath(i,"profiles.json"),b=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:b}]}H(i,o){switch(o){case"profiles.json":return(0,$.$Tn)(JSON.parse(i.content),{})}return null}async I(i){return(0,d.$Rac)(this.k.profiles.filter(o=>!o.isDefault&&!o.isTransient),!0)}J(i){const o=i.remote?r.b:r.c,a=[];return i.location&&(a.push(`scheme:${i.location.scheme}`),a.push(`authority:${i.location.authority}`),a.push((0,t.$df)(i.location.path,"/"))),a.push(`syncResource:${i.syncResource}`),a.push(`profile:${i.profile}`),i.collection&&a.push(`collection:${i.collection}`),i.ref&&a.push(`ref:${i.ref}`),i.node&&a.push(i.node),this.d.joinPath(A.URI.from({scheme:f.$fBb,authority:o,path:"/",query:i.location?.query,fragment:i.location?.fragment}),...a)}K(i){if(i.scheme!==f.$fBb)return;const o=[];for(;i.path!=="/";)o.unshift(this.d.basename(i)),i=this.d.dirname(i);if(o.length<2)return;const a=i.authority===r.b;let b,S;const v=[];let k,P,I,F,T;for(;o.length;){const q=o.shift();q.startsWith("scheme:")?b=q.substring(7):q.startsWith("authority:")?S=q.substring(10):q.startsWith("syncResource:")?k=q.substring(13):q.startsWith("profile:")?P=q.substring(8):q.startsWith("collection:")?I=q.substring(11):q.startsWith("ref:")?F=q.substring(4):k?T=q:v.push(q)}return{remote:a,syncResource:k,profile:P,collection:I,ref:F,node:T,location:b&&S!==void 0?this.d.joinPath(A.URI.from({scheme:b,authority:S,query:i.query,fragment:i.fragment,path:"/"}),...v):void 0}}L(i,o){try{const a=JSON.parse(i);if((0,y.$wLb)(a))return a}catch(a){this.g.error(a)}throw new f.$6Ab((0,N.localize)(0,null),"IncompatibleRemoteContent",o)}async M(i,o,a){const b=await this.e.resolveResourceContent(i,o,a);return{ref:o,content:b}}};e.$qbc=n,e.$qbc=n=r=Ee([Z(0,f.$1Ab),Z(1,f.$2Ab),Z(2,f.$dBb),Z(3,C.$zl),Z(4,L.$Ci),Z(5,R.$Zp),Z(6,j.$2k),Z(7,E.$Bl),Z(8,p.$2i),Z(9,m.$ui)],n)}),define(ae[265],ce([0,1,17,6,26,38,3,2,20,13,32,21,29,12,4,19,22,18,115,116,117,118,119,120,121,25]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=void 0;const i="sync.lastSyncTime";let o=class extends R.$Vc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(k,P,I,F,T,q,X,G,Q,W,J){super(),this.C=k,this.D=P,this.F=I,this.G=F,this.H=T,this.I=q,this.J=X,this.L=G,this.M=Q,this.N=W,this.O=J,this.f="uninitialized",this.g=this.B(new O.$ee),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$ee),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$ee),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$ee),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$ee),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$ee),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$ee),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=I.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(i,-1,void 0),this.B((0,R.$Tc)(()=>this.bb()))}async createSyncTask(k,P){this.cb(),this.H.info("Sync started.");const I=new Date().getTime(),F=(0,E.$Rg)();try{const G=(0,s.$5Ab)(F);P&&(G["Cache-Control"]="no-cache"),k=await this.D.manifest(k,G)}catch(G){const Q=s.$6Ab.toUserDataSyncError(G);throw S(Q,F,this.F,this.I),Q}const T=!1,q=this;let X;return{manifest:k,async run(){if(T)throw new Error("Can run a task only once");X=(0,N.$ih)(G=>q.P(k,!1,F,G)),await X.finally(()=>X=void 0),q.H.info(`Sync done. Took ${new Date().getTime()-I}ms`),q.$()},stop(){return X?.cancel(),q.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$6Ab("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const k=new Date().getTime(),P=(0,E.$Rg)(),I=(0,s.$5Ab)(P);let F;try{F=await this.D.manifest(null,I)}catch(X){const G=s.$6Ab.toUserDataSyncError(X);throw S(G,P,this.F,this.I),G}await this.resetLocal();const T=this,q=new L.$pe;return{id:P,async merge(){return T.P(F,!0,P,q.token)},async apply(){try{try{await T.R(F,P,q.token)}catch(X){if(s.$6Ab.toUserDataSyncError(X).code==="MethodNotFound")T.H.info("Client is making invalid requests. Cleaning up data..."),await T.cleanUpRemoteData(),T.H.info("Applying manual sync again..."),await T.R(F,P,q.token);else throw X}}catch(X){throw T.H.error(X),X}T.H.info(`Sync done. Took ${new Date().getTime()-k}ms`),T.$()},async stop(){q.cancel(),await T.U(),await T.resetLocal()}}}async P(k,P,I,F){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const T=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(T,k,P,I,F));const q=T.enabled.find(X=>X.resource==="profiles");if(q){const X=await q.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.Q(X,k,P,I,F)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(k,P,I,F,T){for(const q of k){if(T.isCancellationRequested)return;const X=this.M.profiles.find(Q=>Q.id===q.id);if(!X){this.H.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",q.name);const G=this.getOrCreateActiveProfileSynchronizer(X,q);this.n.push(...await this.S(G,P,I,F,T))}for(const[q,X]of this.z.entries())this.M.profiles.some(G=>G.id===X[0].profile.id)||(X[1].dispose(),this.z.delete(q))}async R(k,P,I){const F=this.ab();for(const Q of F){if(I.isCancellationRequested)return;await Q.apply(P,I)}const T=F.find(Q=>Q.profile.isDefault);if(!T)return;const q=T.enabled.find(Q=>Q.resource==="profiles");if(!q)return;const G=(await q.getRemoteSyncedProfiles(k?.latest??null)||[]).filter(Q=>F.every(W=>W.profile.id!==Q.id));G.length&&await this.Q(G,k,!1,P,I)}async S(k,P,I,F,T){return(await k.sync(P,I,F,T)).map(([X,G])=>({profile:k.profile,syncResource:X,error:G}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(k=>k.stop()))}async resolveContent(k){const P=await this.N.resolveContent(k);if(P)return P;for(const I of this.ab())for(const F of I.enabled){const T=await F.resolveContent(k);if(T)return T}return null}async replace(k){this.cb();const P=this.N.resolveUserDataSyncResource(k);if(!P)return;const I=await this.resolveContent(k.uri);I&&await this.W(P.profile,async F=>{if(P.syncResource===F.resource)return await F.replace(I),!0})}async accept(k,P,I,F){this.cb(),await this.W(k.profile,async T=>{if(k.syncResource===T.resource)return await T.accept(P,I),F&&await T.apply((0,f.$bg)(F)?!1:F.force,(0,s.$5Ab)((0,E.$Rg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async P=>{if(P.resource!=="globalState"&&await P.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async P=>{if(await P.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(k){this.H.error(k)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(i,-1);for(const[k]of this.z.values())try{await k.resetLocal()}catch(P){this.H.error(P)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const k=await this.N.getRemoteSyncedProfiles(),P=k.map(q=>q.collection),I=await this.D.getAllCollections(),F=I.filter(q=>!P.includes(q));F.length&&(this.H.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(q=>this.D.deleteCollection(q))),this.H.info("Deleted redundant collections on server"));const T=k.filter(q=>I.includes(q.collection));if(T.length!==k.length){const q=this.G.createInstance(n.$Qac,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(T,null),this.H.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData(k){this.cb();const P=await this.D.getActivityData();await this.C.writeFile(k,P)}async extractActivityData(k,P){const I=(await this.C.readFile(k)).value.toString(),F=JSON.parse(I);if(F.resources)for(const T in F.resources)for(const q of F.resources[T])await this.O.writeResource(T,q.content,new Date(q.created*1e3),void 0,P);if(F.collections)for(const T in F.collections)for(const q in F.collections[T].resources)for(const X of F.collections[T].resources?.[q]??[])await this.O.writeResource(q,X.content,new Date(X.created*1e3),T,P)}async W(k,P){const I=new R.$Uc;try{const F=this.z.get(k.id);if(F){const Q=await this.X(F[0],P,I);return(0,f.$cg)(Q)?null:Q}if(k.isDefault){const Q=I.add(this.G.createInstance(a,k,void 0)),W=await this.X(Q,P,I);return(0,f.$cg)(W)?null:W}if(this.M.isEnabled())return null;const T=I.add(this.G.createInstance(n.$Qac,k,void 0)),q=await this.D.manifest(null),G=(await T.getRemoteSyncedProfiles(q?.latest??null)||[]).find(Q=>Q.id===k.id);if(G){const Q=I.add(this.G.createInstance(a,k,G.collection)),W=await this.X(Q,P,I);return(0,f.$cg)(W)?null:W}return null}finally{I.dispose()}}async X(k,P,I){const F=[...k.enabled,...k.disabled.reduce((T,q)=>(q!=="workspaceState"&&T.push(I.add(k.createSynchronizer(q))),T),[])];for(const T of F){const q=await P(T);if(!(0,f.$cg)(q))return q}}Y(k){const P=this.f;this.f!==k&&(this.f=k,this.g.fire(k),P==="hasConflicts"&&this.$())}Z(){const k=this.ab().map(P=>P.conflicts).flat();(0,A.$ub)(this.j,k,(P,I)=>P.profile.id===I.profile.id&&P.syncResource===I.syncResource&&(0,A.$ub)(P.conflicts,I.conflicts,(F,T)=>(0,C.$2g)(F.previewResource,T.previewResource)))||(this.j=k,this.m.fire(k))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(i,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(k,P){let I=this.z.get(k.id);if(I&&I[0].collection!==P?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),I[1].dispose(),I=void 0,this.z.delete(k.id)),!I){const F=new R.$Uc,T=F.add(this.G.createInstance(a,k,P?.collection));F.add(T.onDidChangeStatus(q=>this.Y(q))),F.add(T.onDidChangeConflicts(q=>this.Z())),F.add(T.onDidChangeLocal(q=>this.h.fire(q))),this.z.set(k.id,I=[T,F])}return I[0]}ab(){const k=[];for(const[P]of this.z.values())k.push(P);return k}bb(){this.z.forEach(([,k])=>k.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$Tac=o,e.$Tac=o=Ee([Z(0,h.$2k),Z(1,s.$1Ab),Z(2,s.$ZAb),Z(3,c.$ui),Z(4,s.$dBb),Z(5,g.$1l),Z(6,p.$Zp),Z(7,s.$$Ab),Z(8,l.$Bl),Z(9,s.$aBb),Z(10,s.$2Ab)],o);let a=class extends R.$Vc{get enabled(){return this.f.sort((k,P)=>k[1]-P[1]).map(([k])=>k)}get disabled(){return s.$WAb.filter(k=>!this.r.isResourceEnabled(k))}get status(){return this.g}get conflicts(){return this.m}constructor(k,P,I,F,T,q,X,G,Q,W){super(),this.profile=k,this.collection=P,this.r=I,this.t=F,this.u=T,this.w=q,this.y=X,this.z=G,this.C=Q,this.D=W,this.f=[],this.g="idle",this.h=this.B(new O.$ee),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$ee),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$ee),this.onDidChangeConflicts=this.n.event,this.B(I.onDidChangeResourceEnablement(([J,H])=>this.F(J,H))),this.B((0,R.$Tc)(()=>this.f.splice(0,this.f.length).forEach(([,,J])=>J.dispose())));for(const J of s.$WAb)I.isResourceEnabled(J)&&this.G(J)}F(k,P){P?this.G(k):this.H(k)}G(k){if(this.f.some(([T])=>T.resource===k))return;if(k==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(k==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||k==="workspaceState")return;if(k!=="profiles"&&this.profile.useDefaultFlags?.[k]){this.z.debug(`Skipping syncing ${k} in ${this.profile.name} because it is already synced by default profile`);return}const P=new R.$Uc,I=P.add(this.createSynchronizer(k));P.add(I.onDidChangeStatus(()=>this.L())),P.add(I.onDidChangeConflicts(()=>this.M())),P.add(I.onDidChangeLocal(()=>this.j.fire(k)));const F=this.N(k);this.f.push([I,F,P])}H(k){const P=this.f.findIndex(([I])=>I.resource===k);if(P!==-1){const[[I,,F]]=this.f.splice(P,1);F.dispose(),this.L(),Promise.allSettled([I.stop(),I.resetLocal()]).then(null,T=>this.z.error(T))}}createSynchronizer(k){switch(k){case"settings":return this.t.createInstance($.$1$b,this.profile,this.collection);case"keybindings":return this.t.createInstance(d.$X$b,this.profile,this.collection);case"snippets":return this.t.createInstance(t.$6$b,this.profile,this.collection);case"tasks":return this.t.createInstance(r.$9$b,this.profile,this.collection);case"globalState":return this.t.createInstance(m.$ELb,this.profile,this.collection);case"extensions":return this.t.createInstance(u.$S$b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$Qac,this.profile,this.collection)}}async sync(k,P,I,F){if(F.isCancellationRequested)return[];const T=this.enabled;if(!T.length)return[];try{const q=[],X=(0,s.$5Ab)(I),G=(this.collection?k?.collections?.[this.collection]?.latest:k?.latest)??null,Q=P?await this.I(G):{};for(const W of T){if(F.isCancellationRequested)return[];if(!this.r.isResourceEnabled(W.resource))return[];try{if(P){const J=await W.preview(G,Q,X);if(J)for(const H of J.resourcePreviews)(H.localChange!==0||H.remoteChange!==0)&&H.mergeState==="preview"&&await W.merge(H.previewResource)}else await W.sync(G,X)}catch(J){const H=s.$6Ab.toUserDataSyncError(J);if(S(H,I,this.w,this.y),b(J))throw H;this.z.error(J),this.z.error(`${W.resource}: ${(0,j.$gj)(J)}`),q.push([W.resource,H])}}return q}finally{this.L()}}async apply(k,P){const I=(0,s.$5Ab)(k);for(const F of this.enabled){if(P.isCancellationRequested)return;try{await F.apply(!1,I)}catch(T){const q=s.$6Ab.toUserDataSyncError(T);if(S(q,k,this.w,this.y),b(T))throw q;this.z.error(T),this.z.error(`${F.resource}: ${(0,j.$gj)(T)}`)}}}async stop(){for(const k of this.enabled)try{k.status!=="idle"&&await k.stop()}catch(P){this.z.error(P)}}async resetLocal(){for(const k of this.enabled)try{await k.resetLocal()}catch(P){this.z.error(`${k.resource}: ${(0,j.$gj)(P)}`),this.z.error(P)}}async I(k){if(!this.profile.isDefault)return{};const P=this.D.getValue(s.$SAb),I=this.enabled.find(F=>F instanceof $.$1$b);if(I){const F=await I.getRemoteUserDataSyncConfiguration(k);return{...P,...F}}return P}J(k){this.g!==k&&(this.g=k,this.h.fire(k))}L(){return this.M(),this.enabled.some(k=>k.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(k=>k.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const k=this.enabled.filter(P=>P.status==="hasConflicts").filter(P=>P.conflicts.conflicts.length>0).map(P=>P.conflicts);(0,A.$ub)(this.m,k,(P,I)=>P.syncResource===I.syncResource&&(0,A.$ub)(P.conflicts,I.conflicts,(F,T)=>(0,C.$2g)(F.previewResource,T.previewResource)))||(this.m=k,this.n.fire(k))}N(k){switch(k){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=Ee([Z(2,s.$$Ab),Z(3,c.$ui),Z(4,w.$5o),Z(5,s.$ZAb),Z(6,g.$1l),Z(7,s.$dBb),Z(8,l.$Bl),Z(9,y.$2i)],a);function b(v){if(v instanceof s.$6Ab)switch(v.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function S(v,k,P,I){I.publicLog2("sync/error",{code:v.code,serverCode:v instanceof s.$7Ab?String(v.serverCode):void 0,url:v instanceof s.$7Ab?v.url:void 0,resource:v.resource,executionId:k,service:P.userDataSyncStore.url.toString()})}}),define(ae[266],ce([0,1,3,2,8,18,25]),function(ne,e,A,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=e.$bec=void 0;function R(w,h){return{...w,profile:(0,j.$Cl)(w.profile,h.profilesHome.scheme)}}function C(w){return{created:w.created,uri:L.URI.revive(w.uri)}}class f{constructor(h,c,p){this.c=h,this.d=c,this.f=p,this.a=new Map,this.b=new A.$ee}listen(h,c){switch(c){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${c}`)}async call(h,c,p){try{return await this.g(h,c,p)}catch(g){throw this.f.error(g),g}}async g(h,c,p){switch(c){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(L.URI.revive(p[0]));case"accept":return this.c.accept(R(p[0],this.d),L.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(C(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(L.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(L.URI.revive(p[0]),L.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if(c.startsWith("manualSync/")){const g=c.substring(11),l=p[0],u=this.h(l);switch(p=p.slice(1),g){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(h){const c=this.a.get(this.j(h));if(!c)throw new Error(`Manual sync taks not found: ${h}`);return c}async i(){const h=await this.c.createManualSyncTask();return this.a.set(this.j(h.id),h),h.id}j(h){return`manualSyncTask-${h}`}}e.$bec=f;let E=class extends N.$Vc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(h,c){super(),this.n=c,this.b="uninitialized",this.c=this.B(new A.$ee),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new A.$ee),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new A.$ee),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new A.$ee),this.onSyncErrors=this.m.event,this.a={call(p,g,l){return h.call(p,g,l).then(null,u=>{throw O.$6Ab.toUserDataSyncError(u)})},listen(p,g){return h.listen(p,g)}},this.a.call("_getInitialData").then(([p,g,l])=>{this.s(p),this.t(g),l&&this.u(l),this.B(this.a.listen("onDidChangeStatus")(u=>this.s(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.u(u)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(g=>({...g,error:O.$6Ab.toUserDataSyncError(g.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const h=await this.a.call("createManualSyncTask"),c=this;return new y(h,{async call(g,l,u){return c.a.call(`manualSync/${g}`,[h,...Array.isArray(l)?l:[l]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(h,c,p,g){return this.a.call("accept",[h,c,p,g])}resolveContent(h){return this.a.call("resolveContent",[h])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(h){return this.a.call("replace",[h])}saveRemoteActivityData(h){return this.a.call("getRemoteActivityData",[h])}extractActivityData(h,c){return this.a.call("extractActivityData",[h,c])}async s(h){this.b=h,this.c.fire(h)}async t(h){this.f=h.map(c=>({syncResource:c.syncResource,profile:(0,j.$Cl)(c.profile,this.n.profilesHome.scheme),conflicts:c.conflicts.map(p=>({...p,baseResource:L.URI.revive(p.baseResource),localResource:L.URI.revive(p.localResource),remoteResource:L.URI.revive(p.remoteResource),previewResource:L.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u(h){this.h!==h&&(this.h=h,this.j.fire(h))}};e.$cec=E,e.$cec=E=Ee([Z(1,j.$Bl)],E);class y extends N.$Vc{constructor(h,c){super(),this.id=h,this.a=c}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(ae[122],ce([0,1,6,26,7,3,2,141,5,20,13,8,32,21,16,12,24,59,45,19,25]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uLb=e.$tLb=e.$sLb=e.$rLb=e.$qLb=void 0;const $="configurationSync.store",t="sync.previous.store",r="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",i=100,o=1e3*60*5;let a=class extends O.$Vc{get userDataSyncStore(){return this.b}get c(){return this.h.get(d.$9Ab,-1)}set c(I){this.h.store(d.$9Ab,I,-1,C.$o?0:1)}constructor(I,F,T){super(),this.f=I,this.g=F,this.h=T,this.a=this.B(new j.$ee),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const q=this.B(new O.$Uc);this.B(j.Event.filter(T.onDidChangeValue(-1,d.$9Ab,q),()=>this.c!==this.userDataSyncStore?.type,q)(()=>this.j()))}j(){this.b=this.m(this.f[$]),this.a.fire()}m(I){if(I&&(I=C.$o&&I.web?{...I,...I.web}:I,(0,E.$8f)(I.url)&&(0,E.$0f)(I.authenticationProviders)&&Object.keys(I.authenticationProviders).every(F=>Array.isArray(I.authenticationProviders[F].scopes)))){const F=I,T=!!F.canSwitch,q=F.url===F.insidersUrl?"insiders":"stable",X=(T?this.c:void 0)||q,G=X==="insiders"?F.insidersUrl:X==="stable"?F.stableUrl:F.url;return{url:y.URI.parse(G),type:X,defaultType:q,defaultUrl:y.URI.parse(F.url),stableUrl:y.URI.parse(F.stableUrl),insidersUrl:y.URI.parse(F.insidersUrl),canSwitch:T,authenticationProviders:Object.keys(F.authenticationProviders).reduce((Q,W)=>(Q.push({id:W,scopes:F.authenticationProviders[W].scopes}),Q),[])}}}};e.$qLb=a,e.$qLb=a=Ee([Z(0,g.$ik),Z(1,h.$2i),Z(2,m.$Zp)],a);let b=class extends a{constructor(I,F,T){super(I,F,T);const q=this.h.get(t,-1);q&&(this.n=JSON.parse(q));const X=this.f[$];X?this.h.store(t,JSON.stringify(X),-1,1):this.h.remove(t,-1)}async switch(I){I!==this.c&&(this.c=I,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$rLb=b,e.$rLb=b=Ee([Z(0,g.$ik),Z(1,h.$2i),Z(2,m.$Zp)],b);let S=class extends O.$Vc{get donotMakeRequestsUntil(){return this.j}constructor(I,F,T,q,X,G,Q){super(),this.n=T,this.r=q,this.s=Q,this.g=this.B(new j.$ee),this.onTokenFailed=this.g.event,this.h=this.B(new j.$ee),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new j.$ee),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(I),this.c=(0,u.$6p)(X,G,Q).then(W=>{const J={"X-Client-Name":`${F.applicationName}${C.$o?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(J["X-Client-Commit"]=F.commit),J}),this.f=new k(i,o,this.n,this.r),this.u(),this.B((0,O.$Tc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(I,F){this.b={token:I,type:F}}t(I){this.a=I?(0,f.$9g)(I,"v1"):void 0}u(){const I=this.s.getNumber(r,-1);I&&Date.now()<I&&this.y(new Date(I))}y(I){this.j?.getTime()!==I?.getTime()&&(this.j=I,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(r,this.j.getTime(),-1,1),this.w=(0,A.$ih)(F=>(0,A.$wh)(this.j.getTime()-Date.now(),F).then(()=>this.y(void 0))),this.w.then(null,F=>null)):this.s.remove(r,-1),this.m.fire())}async getAllCollections(I={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,f.$9g)(this.a,"collection").toString();I={...I},I["Content-Type"]="application/json";const T=await this.D(F,{type:"GET",headers:I},[],N.CancellationToken.None);return(await(0,l.$Sp)(T))?.map(({id:q})=>q)||[]}async createCollection(I={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,f.$9g)(this.a,"collection").toString();I={...I},I["Content-Type"]=R.$Ps.text;const T=await this.D(F,{type:"POST",headers:I},[],N.CancellationToken.None),q=await(0,l.$Rp)(T);if(!q)throw new d.$7Ab("Server did not return the collection id",F,"NoCollection",T.res.statusCode,T.res.headers[d.$3Ab]);return q}async deleteCollection(I,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=I?(0,f.$9g)(this.a,"collection",I).toString():(0,f.$9g)(this.a,"collection").toString();F={...F},await this.D(T,{type:"DELETE",headers:F},[],N.CancellationToken.None)}async getAllResourceRefs(I,F){if(!this.a)throw new Error("No settings sync store url configured.");const T=this.z(this.a,F,I),q={},X=await this.D(T.toString(),{type:"GET",headers:q},[],N.CancellationToken.None);return(await(0,l.$Sp)(X)||[]).map(({url:Q,created:W})=>({ref:(0,f.$$g)(T,T.with({path:Q})),created:W*1e3}))}async resolveResourceContent(I,F,T,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=(0,f.$9g)(this.z(this.a,T,I),F).toString();q={...q},q["Cache-Control"]="no-cache";const G=await this.D(X,{type:"GET",headers:q},[],N.CancellationToken.None);return await(0,l.$Rp)(G)}async deleteResource(I,F,T){if(!this.a)throw new Error("No settings sync store url configured.");const q=F!==null?(0,f.$9g)(this.z(this.a,T,I),F).toString():this.z(this.a,T,I).toString(),X={};await this.D(q,{type:"DELETE",headers:X},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const I=(0,f.$9g)(this.a,"resource").toString(),F={"Content-Type":R.$Ps.text};await this.D(I,{type:"DELETE",headers:F},[],N.CancellationToken.None)}async readResource(I,F,T,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=(0,f.$9g)(this.z(this.a,T,I),"latest").toString();q={...q},q["Cache-Control"]="no-cache",F&&(q["If-None-Match"]=F.ref);const G=await this.D(X,{type:"GET",headers:q},[304],N.CancellationToken.None);let Q=null;if(G.res.statusCode===304&&(Q=F),Q===null){const W=G.res.headers.etag;if(!W)throw new d.$7Ab("Server did not return the ref",X,"NoRef",G.res.statusCode,G.res.headers[d.$3Ab]);const J=await(0,l.$Rp)(G);if(!J&&G.res.statusCode===304)throw new d.$7Ab("Empty response",X,"EmptyResponse",G.res.statusCode,G.res.headers[d.$3Ab]);Q={ref:W,content:J}}return Q}async writeResource(I,F,T,q,X={}){if(!this.a)throw new Error("No settings sync store url configured.");const G=this.z(this.a,q,I).toString();X={...X},X["Content-Type"]=R.$Ps.text,T&&(X["If-Match"]=T);const Q=await this.D(G,{type:"POST",data:F,headers:X},[],N.CancellationToken.None),W=Q.res.headers.etag;if(!W)throw new d.$7Ab("Server did not return the ref",G,"NoRef",Q.res.statusCode,Q.res.headers[d.$3Ab]);return W}async manifest(I,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,f.$9g)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",I&&(F["If-None-Match"]=I.ref);const q=await this.D(T,{type:"GET",headers:F},[304],N.CancellationToken.None);let X=null;if(q.res.statusCode===304&&(X=I),!X){const Q=q.res.headers.etag;if(!Q)throw new d.$7Ab("Server did not return the ref",T,"NoRef",q.res.statusCode,q.res.headers[d.$3Ab]);const W=await(0,l.$Rp)(q);if(!W&&q.res.statusCode===304)throw new d.$7Ab("Empty response",T,"EmptyResponse",q.res.statusCode,q.res.headers[d.$3Ab]);W&&(X={...JSON.parse(W),ref:Q})}const G=this.s.get(n,-1);return G&&X&&G!==X.session&&this.C(),X===null&&G&&this.C(),X&&this.s.store(n,X.session,-1,1),X}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const I=(0,f.$9g)(this.a,"download").toString(),F={},T=await this.D(I,{type:"GET",headers:F},[],N.CancellationToken.None);if(!(0,l.$Op)(T))throw new d.$7Ab("Server returned "+T.res.statusCode,I,"EmptyResponse",T.res.statusCode,T.res.headers[d.$3Ab]);if((0,l.$Pp)(T))throw new d.$7Ab("Empty response",I,"EmptyResponse",T.res.statusCode,T.res.headers[d.$3Ab]);return T.stream}z(I,F,T){return F?(0,f.$9g)(I,"collection",F,"resource",T):(0,f.$9g)(I,"resource",T)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(I,F,T,q){if(!this.b)throw new d.$7Ab("No Auth Token Available",I,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new d.$7Ab(`${F.type} request '${I}' failed because of too many requests (429).`,I,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const X=await this.c;F.headers={...F.headers||{},...X,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(F.headers),this.r.trace("Sending request to server",{url:I,type:F.type,headers:{...F.headers,authorization:void 0}});let G;try{G=await this.f.request(I,F,q)}catch(B){if(!(B instanceof d.$7Ab)){let ie="RequestFailed";const re=(0,L.$0)(B).toLowerCase();re.includes("xhr timeout")?ie="RequestTimeout":re.includes("protocol")&&re.includes("not supported")?ie="RequestProtocolNotSupported":re.includes("request path contains unescaped characters")?ie="RequestPathNotEscaped":re.includes("headers must be an object")?ie="RequestHeadersNotObject":(0,L.$4)(B)&&(ie="RequestCanceled"),B=new d.$7Ab(`Connection refused for the request '${I}'.`,I,ie,void 0,void 0)}throw this.r.info("Request failed",I),B}const Q=G.res.headers[d.$3Ab],W={url:I,status:G.res.statusCode,"execution-id":F.headers[d.$4Ab],"operation-id":Q},J=(0,l.$Op)(G)||G.res.statusCode&&T.includes(G.res.statusCode);let H="";if(J?this.r.trace("Request succeeded",W):(H=await(0,l.$Qp)(G)||"",this.r.info("Request failed",W,H)),G.res.statusCode===401||G.res.statusCode===403){if(this.b=void 0,G.res.statusCode===401)throw this.g.fire("Unauthorized"),new d.$7Ab(`${F.type} request '${I}' failed because of Unauthorized (401).`,I,"Unauthorized",G.res.statusCode,Q);if(G.res.statusCode===403)throw this.g.fire("Forbidden"),new d.$7Ab(`${F.type} request '${I}' failed because the access is forbidden (403).`,I,"Forbidden",G.res.statusCode,Q)}if(this.h.fire(),G.res.statusCode===404)throw new d.$7Ab(`${F.type} request '${I}' failed because the requested resource is not found (404).`,I,"NotFound",G.res.statusCode,Q);if(G.res.statusCode===405)throw new d.$7Ab(`${F.type} request '${I}' failed because the requested endpoint is not found (405). ${H}`,I,"MethodNotFound",G.res.statusCode,Q);if(G.res.statusCode===409)throw new d.$7Ab(`${F.type} request '${I}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,I,"Conflict",G.res.statusCode,Q);if(G.res.statusCode===410)throw new d.$7Ab(`${F.type} request '${I}' failed because the requested resource is not longer available (410).`,I,"Gone",G.res.statusCode,Q);if(G.res.statusCode===412)throw new d.$7Ab(`${F.type} request '${I}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,I,"PreconditionFailed",G.res.statusCode,Q);if(G.res.statusCode===413)throw new d.$7Ab(`${F.type} request '${I}' failed because of too large payload (413).`,I,"TooLarge",G.res.statusCode,Q);if(G.res.statusCode===426)throw new d.$7Ab(`${F.type} request '${I}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,I,"UpgradeRequired",G.res.statusCode,Q);if(G.res.statusCode===429){const B=G.res.headers["retry-after"];throw B?(this.y(new Date(Date.now()+parseInt(B)*1e3)),new d.$7Ab(`${F.type} request '${I}' failed because of too many requests (429).`,I,"TooManyRequestsAndRetryAfter",G.res.statusCode,Q)):new d.$7Ab(`${F.type} request '${I}' failed because of too many requests (429).`,I,"RemoteTooManyRequests",G.res.statusCode,Q)}if(!J)throw new d.$7Ab("Server returned "+G.res.statusCode,I,"Unknown",G.res.statusCode,Q);return G}F(I){let F=this.s.get(s,-1);F===void 0&&(F=(0,w.$Rg)(),this.s.store(s,F,-1,1)),I["X-Machine-Session-Id"]=F;const T=this.s.get(n,-1);T!==void 0&&(I["X-User-Session-Id"]=T)}};e.$sLb=S,e.$sLb=S=Ee([Z(1,g.$ik),Z(2,l.$Mp),Z(3,d.$dBb),Z(4,c.$Ci),Z(5,p.$2k),Z(6,m.$Zp)],S);let v=class extends S{constructor(I,F,T,q,X,G,Q){super(I.userDataSyncStore?.url,F,T,q,X,G,Q),this.B(I.onDidChangeUserDataSyncStore(()=>this.t(I.userDataSyncStore?.url)))}};e.$tLb=v,e.$tLb=v=Ee([Z(0,d.$ZAb),Z(1,g.$ik),Z(2,l.$Mp),Z(3,d.$dBb),Z(4,c.$Ci),Z(5,p.$2k),Z(6,m.$Zp)],v);class k{constructor(I,F,T,q){this.c=I,this.d=F,this.f=T,this.g=q,this.a=[],this.b=void 0}request(I,F,T){if(this.h()&&this.i(),F.url=I,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new d.$7Ab(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,I,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(I),this.f.request(F,T)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$uLb=k}),define(ae[267],ce([0,1,3,2,8,21,24,19,122]),function(ne,e,A,N,L,j,O,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=e.$_dc=e.$$dc=e.$0dc=void 0;class f{constructor(c){this.a=c}listen(c,p){switch(p){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${p}`)}call(c,p,g){switch(p){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(g)}throw new Error("Invalid call")}}e.$0dc=f;class E extends N.$Vc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(c){super(),this.c=c,this.b=this.B(new A.$ee),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(p=>{this.a=p,this.B(this.c.listen("onDidChangeAccount")(g=>{this.a=g,this.b.fire(g)}))})}updateAccount(c){return this.c.call("updateAccount",c)}}e.$$dc=E;class y{constructor(c){this.a=c}listen(c,p){switch(p){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${p}`)}call(c,p,g){switch(p){case"switch":return this.a.switch(g[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$_dc=y;let w=class extends C.$qLb{constructor(c,p,g,l){super(p,g,l),this.n=c,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(c){return this.n.call("switch",[c])}async getPreviousUserDataSyncStore(){const c=await this.n.call("getPreviousUserDataSyncStore");return this.r(c)}r(c){return{url:L.URI.revive(c.url),type:c.type,defaultUrl:L.URI.revive(c.defaultUrl),insidersUrl:L.URI.revive(c.insidersUrl),stableUrl:L.URI.revive(c.stableUrl),canSwitch:c.canSwitch,authenticationProviders:c.authenticationProviders}}};e.$aec=w,e.$aec=w=Ee([Z(1,O.$ik),Z(2,j.$2i),Z(3,R.$Zp)],w)}),define(ae[268],ce([0,1,3,57,24,19,22,263,25,80,83]),function(ne,e,A,N,L,j,O,R,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=void 0;let y=class extends R.$Uac{constructor(h,c,p,g,l,u,m,d,$,t,r){super(h,c,p,g,l,m,d,$,t,r),this.B(A.Event.debounce(A.Event.any(A.Event.map(u.onDidFocusMainWindow,()=>"windowFocus"),A.Event.map(u.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$wec=y,e.$wec=y=Ee([Z(0,L.$ik),Z(1,C.$ZAb),Z(2,C.$1Ab),Z(3,C.$$Ab),Z(4,C.$_Ab),Z(5,N.$ncc),Z(6,C.$dBb),Z(7,f.$YJb),Z(8,O.$1l),Z(9,E.$NAb),Z(10,j.$Zp)],y)}),define(ae[269],ce([0,1,73,23,5,20]),function(ne,e,A,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nbc=void 0,e.$Obc=O,e.$Pbc=R,e.$Qbc=C,e.$Nbc=128/4;function O(f){function E(){let y=f.scheme===N.Schemas.file?(0,j.$Wg)(f):f.toString();return L.$k||(y=y.toLowerCase()),(0,A.createHash)("md5").update(y).digest("hex")}return{id:E(),configPath:f}}function R(f,E){function y(){if(f.scheme!==N.Schemas.file)return(0,A.createHash)("md5").update(f.toString()).digest("hex");if(!E)return;let h;return L.$k?h=E.ino:L.$j?h=E.birthtime.getTime():L.$i&&(typeof E.birthtimeMs=="number"?h=Math.floor(E.birthtimeMs):h=E.birthtime.getTime()),(0,A.createHash)("md5").update(f.fsPath).update(h?String(h):"").digest("hex")}const w=y();if(typeof w=="string")return{id:w,uri:f}}function C(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ae[270],ce([0,1,6,7,2,14,31,16,9,77,112,269,57,56,23]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;let p=class extends L.$Vc{constructor(l,u,m,d){super(),this.a=l,this.b=u,this.c=m,this.f=d,this.B(new A.$Hh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const l=this.a.workspaceStorageHome.with({scheme:c.Schemas.file}).fsPath,u=await O.Promises.readdir(l),m=new f.$zKb(this.f.getChannel("storage"));await Promise.all(u.map(async d=>{const $=(0,j.$kc)(l,d);d.length===y.$Nbc||d===E.$Hi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===d)||await m.isUsed($)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await O.Promises.rm($))}))}catch(l){(0,N.$1)(l)}}};e.$6dc=p,e.$6dc=p=Ee([Z(0,R.$Di),Z(1,C.$2j),Z(2,w.$ncc),Z(3,h.$Cdc)],p)}),define(ae[123],ce([0,1,73,64,37,279,15,7,3,2,14,5,32,42,68]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$mi=e.$li=e.$ki=void 0,e.$ni=n,e.$oi=s,e.$qi=a,e.$ri=b;class p{traceSocketEvent(v,k){c.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,k)}constructor(v,k=""){this.f=!0,this.debugLabel=k,this.socket=v,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,R.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(v){const k=P=>{this.traceSocketEvent("read",P),v(O.$Fe.wrap(P))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(v){const k=P=>{v({type:0,hadError:P,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(v){const k=()=>{v()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(v){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",v),this.socket.write(v.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,R.$1)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,R.$1)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((v,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),v();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),v()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$ki=p;var g;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize",S[S.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var l;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(l||(l={}));class u extends f.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(v,k){this.socket.traceSocketEvent(v,k)}constructor(v,k,P,I){super(),this.f=this.B(new C.$ee),this.g=this.B(new C.$ee),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=v,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:P?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new m(this,k,P,I,this.f,(F,T)=>this.m(F,T))),this.B(this.a.onError(F=>{console.error(F),(0,R.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new c.$fi,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this.f.event(v)}onClose(v){return this.g.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){let k=0;for(;k<v.byteLength;)this.a.writeMessage(v.slice(k,Math.min(k+262144,v.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(v,{compressed:k,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",v);let I=2;v.byteLength<126?I+=0:v.byteLength<2**16?I+=2:I+=8;const F=O.$Fe.alloc(I),T=k?64:0,q=P&15;if(F.writeUInt8(128|T|q,0),v.byteLength<126)F.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){F.writeUInt8(126,1);let X=1;F.writeUInt8(v.byteLength>>>8&255,++X),F.writeUInt8(v.byteLength>>>0&255,++X)}else{F.writeUInt8(127,1);let X=1;F.writeUInt8(0,++X),F.writeUInt8(0,++X),F.writeUInt8(0,++X),F.writeUInt8(0,++X),F.writeUInt8(v.byteLength>>>24&255,++X),F.writeUInt8(v.byteLength>>>16&255,++X),F.writeUInt8(v.byteLength>>>8&255,++X),F.writeUInt8(v.byteLength>>>0&255,++X)}this.socket.write(O.$Fe.concat([F,v]))}end(){this.h=!0,this.socket.end()}n(v){if(v.byteLength!==0){for(this.b.acceptChunk(v);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),P=k.readUInt8(0),I=(P&128)>>>7,F=(P&64)>>>6,T=P&15,q=k.readUInt8(1),X=(q&128)>>>7,G=q&127;this.j.state=2,this.j.readLen=2+(X?4:0)+(G===126?2:0)+(G===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!I,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),P=k.readUInt8(1),I=(P&128)>>>7;let F=P&127,T=1;F===126?F=k.readUInt8(++T)*2**8+k.readUInt8(++T):F===127&&(F=k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*2**24+k.readUInt8(++T)*2**16+k.readUInt8(++T)*2**8+k.readUInt8(++T));let q=0;I&&(q=k.readUInt8(++T)*2**24+k.readUInt8(++T)*2**16+k.readUInt8(++T)*2**8+k.readUInt8(++T)),this.j.state=3,this.j.readLen=F,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$li=u;class m extends f.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$Fe.alloc(0)}constructor(v,k,P,I,F,T){super(),this.n=v,this.r=F,this.s=T,this.a=this.B(new C.$ee),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new C.$ee),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new C.$ee),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new d(this.n,I,P,{windowBits:15})),this.f=this.B(new $(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(v,k){this.g.push({data:v,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:v,options:k}=this.g.shift();if(this.f&&k.compressed){const P=await this.w(this.f,v);this.s(P,k)}else this.s(v,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(v,k){return new Promise((P,I)=>{v.write(k),v.flush(F=>P(F))})}acceptFrame(v,k,P){this.h.push({data:v,isCompressed:k,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const v=this.h.shift();if(this.b&&v.isCompressed){const k=await this.C(this.b,v.data,v.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(v.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(v,k,P){return new Promise((I,F)=>{v.write(k),P&&v.write(O.$Fe.fromByteArray([0,0,255,255])),v.flush(T=>I(T))})}}class d extends f.$Vc{get recordedInflateBytes(){return this.j?O.$Fe.concat(this.f):O.$Fe.alloc(0)}constructor(v,k,P,I){super(),this.h=v,this.j=k,this.a=this.B(new C.$ee),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(I),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(O.$Fe.wrap(F))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(v){this.j&&this.f.push(v.clone()),this.h.traceSocketEvent("zlibInflateWrite",v),this.b.write(v.buffer)}flush(v){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=O.$Fe.concat(this.g);this.g.length=0,v(k)})}}class $ extends f.$Vc{constructor(v,k){super(),this.g=v,this.a=this.B(new C.$ee),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(O.$Fe.wrap(P))})}write(v){this.g.traceSocketEvent("zlibDeflateWrite",v.buffer),this.b.write(v.buffer)}flush(v){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=O.$Fe.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),v(k)})}}function t(S,v){if(v===0)return;const k=S.byteLength>>>2;for(let X=0;X<k;X++){const G=S.readUInt32BE(X*4);S.writeUInt32BE(G^v,X*4)}const P=k*4,I=S.byteLength-P,F=v>>>24&255,T=v>>>16&255,q=v>>>8&255;I>=1&&S.writeUInt8(S.readUInt8(P)^F,P),I>=2&&S.writeUInt8(S.readUInt8(P+1)^T,P+1),I>=3&&S.writeUInt8(S.readUInt8(P+2)^q,P+2)}e.$mi=process.env.XDG_RUNTIME_DIR;const r={2:107,1:103};function n(){const S=(0,w.$Rg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;const v=process.platform!=="darwin"&&e.$mi?e.$mi:(0,L.tmpdir)(),k=(0,E.$kc)(v,`vscode-ipc-${S}.sock`);return i(k),k}function s(S,v,k){const I=(0,A.createHash)("sha256").update(S).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${k}-${v}-sock`;const F=k.substr(0,4),T=v.substr(0,6);let q;return process.platform!=="darwin"&&e.$mi&&!process.env.VSCODE_PORTABLE?q=(0,E.$kc)(e.$mi,`vscode-${I}-${F}-${T}.sock`):q=(0,E.$kc)(S,`${F}-${T}.sock`),i(q),q}function i(S){const v=r[y.$u];typeof v=="number"&&S.length>=v&&console.warn(`WARNING: IPC handle "${S}" is longer than ${v} chars, try a shorter --user-data-dir`)}class o extends h.$_h{static b(v){const k=C.Event.fromNodeEventEmitter(v,"connection");return C.Event.map(k,P=>({protocol:new c.$gi(new p(P,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(P,"close"))}))}constructor(v){super(o.b(v)),this.d=v}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$pi=o;function a(S){return new Promise((v,k)=>{const P=(0,N.createServer)();P.on("error",k),P.listen(S,()=>{P.removeListener("error",k),v(new o(P))})})}function b(S,v){return new Promise((k,P)=>{const I=(0,N.createConnection)(S,()=>{I.removeListener("error",P),k(c.$hi.fromSocket(new p(I,`ipc-client${v}`),v))});I.once("error",P)})}}),define(ae[271],ce([0,1,64,123,218]),function(ne,e,A,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0,e.$zec=new class{supports(j){return!0}connect({host:j,port:O},R,C,f){return new Promise((E,y)=>{const w=A.createConnection({host:j,port:O},()=>{w.removeListener("error",y),w.write((0,L.$Atb)(R,C,f));const h=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",h),E(new N.$ki(w,f)))};w.on("data",h)});w.setNoDelay(!0),w.once("error",y)})}}}),define(ae[272],ce([0,1,64,37,133,123,6,2,5,21,9,24,220,103,105,78,15]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=e.$vdc=e.$udc=e.$tdc=void 0;async function l(t,r,n,s,i){let o;for(let a=3;a&&(o?.dispose(),o=await new u(t,r,n,s,i).waitForReady(),!(i&&L.$Ug[i]||!L.$Ug[o.tunnelLocalPort]));a--);return o}class u extends R.$Vc{constructor(r,n,s,i,o){super(),this.m=n,this.n=o,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=A.createServer(),this.c=new O.$uh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,n=(0,p.$jw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,L.$Vg)(r,2,1e3,n),i=null;return this.b.listen(s,this.m),await this.c.wait(),i=this.b.address(),i||(s=0,this.b.listen(s,this.m),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async r(r){r.pause();const n=(0,p.$hw)(this.tunnelRemoteHost)||(0,p.$jw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,w.$Rl)(this.a,n,this.tunnelRemotePort),i=s.getSocket(),o=s.readEntireBuffer();s.dispose(),o.byteLength>0&&r.write(o.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),i.end()}),r.on("close",()=>i.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),i instanceof j.$ki?i.socket.destroy():i.end()}),i instanceof j.$ki?this.t(r,i):this.s(r,i),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),i.end()})}s(r,n){n.onClose(()=>r.destroy()),n.onEnd(()=>r.end()),n.onData(s=>r.write(s.buffer)),r.on("data",s=>n.write(g.$Fe.wrap(s))),r.resume()}t(r,n){const s=n.socket;s.on("end",()=>r.end()),s.on("close",()=>r.end()),s.on("error",()=>{r.destroy()}),s.pipe(r),r.pipe(s)}}e.$tdc=u;let m=class extends p.$mw{constructor(r,n,s,i,o){super(n,o),this.v=r,this.w=s,this.y=i}isPortPrivileged(r){return(0,p.$kw)(r,this.m,C.OS,N.release())}t(r,n,s,i,o,a,b,S){const v=this.s(n,s);if(v)return++v.refcount,v.value;if((0,p.$dw)(r))return this.u(r,n,s,o,a,b,S);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${o}.`);const k={commit:this.y.commit,quality:this.y.quality,addressProvider:r,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=l(k,i,n,s,o);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,P),P}}};e.$udc=m,e.$udc=m=Ee([Z(0,h.$Ll),Z(1,E.$2j),Z(2,c.$Ol),Z(3,y.$ik),Z(4,f.$2i)],m);let d=class extends m{constructor(r,n,s,i,o){super(r,n,s,i,o)}};e.$vdc=d,e.$vdc=d=Ee([Z(0,h.$Ll),Z(1,E.$2j),Z(2,c.$Ol),Z(3,y.$ik),Z(4,f.$2i)],d);let $=class extends R.$Vc{constructor(r,n,s,i,o){super(),this.b=r,this.c=n,this.f=s,this.g=i,this.h=o,this.a=new Map}async openTunnel(r,n,s,i,o,a,b,S,v){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${i} on local port ${a}.`),!this.a.has(r)){const k=new d(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(r,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(n,s,i,o,a,b,S,v)}};e.$wdc=$,e.$wdc=$=Ee([Z(0,h.$Ll),Z(1,E.$2j),Z(2,y.$ik),Z(3,c.$Ol),Z(4,f.$2i)],$)}),define(ae[280],ce([0,1,37,38,7,2,23,8,17,3,42,151,212,213,203,204,270,193,195,21,217,94,228,95,223,16,114,254,29,107,194,113,96,12,206,207,72,4,202,74,75,234,9,208,100,24,59,19,106,22,108,109,110,49,237,82,111,25,80,262,267,247,83,261,265,266,122,60,260,248,105,227,78,272,222,238,28,239,5,240,196,215,214,81,253,18,52,211,58,259,236,249,104,264,255,10,209,99,257,252,224,190,57,210,268,256,56,258,103,271,187,225,147,140,145]),function(ne,e,A,N,L,j,O,R,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s,i,o,a,b,S,v,k,P,I,F,T,q,X,G,Q,W,J,H,B,ie,re,he,te,V,U,D,M,z,x,K,ee,_,Y,se,ue,ge,fe,$e,ye,ve,Ce,Ae,le,me,we,Pe,Ie,Fe,Oe,qe,Me,ze,Ue,je,oe,de,pe,be,Se,Re,De,Ne,We,Be,Te,Ze,Ge,_e,tt,St,kt,gt,Ct,Pt,Rt,It,At,Dt,Ot,Lt,$t,jt,mt,Nt,Ft,st,Mt,Tt,wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=pt;class qt extends j.$Vc{constructor(ke){super(),this.f=ke,this.a=this.B(new y.$7W(this)),this.b=void 0,this.c=this.B(new f.$ee),this.g()}g(){let ke=!1;const Le=()=>{ke||(ke=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Le),(0,y.$8W)(process.parentPort,st.$Icc.exit,Le)}async init(){const ke=await this.h();(0,_.$UAb)(),ke.invokeFunction(Le=>{const He=Le.get(J.$2j),Ve=Le.get(V.$1l),Qe=Le.get(Re.$Bl);He.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Le),this.m(He),this.n(Ve,Qe),this.B(Qe.onDidChangeProfiles(()=>this.n(Ve,Qe))),this.r(Ve,He)}),this.B((0,j.$Sc)(ke.createInstance(w.$2dc,this.f.codeCachePath),ke.createInstance(h.$3dc),ke.createInstance(g.$6dc),ke.createInstance(p.$5dc),ke.createInstance(c.$4dc),ke.createInstance(tt.$qec),ke.createInstance(Ze.$iec)))}async h(){const ke=new G.$ti,Le={_serviceBrand:void 0,...B.default};ke.set(ie.$ik,Le);const He=new E.$di(Ke=>Ke==="main"),Ve=new $t.$Ddc(this.a,He);ke.set($t.$Cdc,Ve);const Qe=this.f.policiesData?new Ne.$_cc(this.f.policiesData,Ve.getChannel("policy")):new We.$fo;ke.set(We.$do,Qe);const Je=new Ft.$8m(this.f.args,Le);ke.set(s.$Di,Je);const et=new H.$$r(void 0,this.f.logLevel,Je.logsHome,this.f.loggers.map(Ke=>({...Ke,resource:R.URI.revive(Ke.resource)})),Ve.getChannel("logger"));ke.set(J.$3j,et);const ot=this.B(et.createLogger("sharedprocess",{name:(0,St.localize)(0,null)})),ht=this.B(new J.$0j(ot.getLevel())),Ye=this.B(new kt.$MQ(ot,[ht]));ke.set(J.$2j,Ye),this.b=this.B(new gt.$sec(Ye)),ke.set(gt.$rec,this.b);const Xe=this.B(new I.$Hq(Ye));ke.set(P.$2k,Xe);const ut=this.B(new F.$$q(Ye));Xe.registerProvider(O.Schemas.file,ut);const at=new ze.$zs(Xe);ke.set(Me.$zl,at);const xe=this.B(new Be.$TQ(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Je.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));ke.set(Re.$Bl,xe);const ft=this.B(new je.$Bdc(O.Schemas.file,this.B(new oe.$vQ(Ve.getChannel(oe.$uQ),{pathCaseSensitive:Ue.$k})),O.Schemas.vscodeUserData,xe,at,Ye));Xe.registerProvider(O.Schemas.vscodeUserData,ft);const it=this.B(new d.$Fo(xe.defaultProfile.settingsResource,Xe,Qe,Ye));ke.set(m.$2i,it);const dt=new jt.$yec(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},Ve,Je);ke.set(he.$Zp,dt),this.B((0,j.$Tc)(()=>dt.flush())),await Promise.all([it.initialize(),dt.initialize()]);const bt=new Rt.$Ur(Ve.getChannel("request"));ke.set(re.$Mp,bt),ke.set(l.$7dc,new T.$si(u.$8dc,void 0,!1)),ke.set(pe.$mG,new T.$si(de.$hec,void 0,!1));const yt=new Dt.$Idc(-1,Ve);ke.set(At.$ncc,yt),ke.set(r.$Jo,new T.$si(n.$2Q,void 0,!0));const Ut=this.B(new me.$9cc(yt)),Bt=new E.$di(Ke=>Ut.getActiveClientId().then(lt=>Ke===lt));ke.set(k.$j4b,new It.$uec(this.a.getChannel("extensionRecommendationNotification",Bt)));let ct;const nt=[],vt=(0,z.$qp)(Le,it);if((0,z.$lp)(Le,Je)){const Ke=new D.$__b(Ye,et,Je,Le);if(nt.push(Ke),!(0,z.$mp)(Le,Je)&&Le.aiConfig?.ariaKey){const lt=new Te.$AQ(bt,vt,"monacoworkbench",null,Le.aiConfig.ariaKey);this.B((0,j.$Tc)(()=>lt.flush())),nt.push(lt)}ct=new M.$Yr({appenders:nt,commonProperties:(0,te.$cp)((0,A.release)(),(0,A.hostname)(),process.arch,Le.commit,Le.version,this.f.machineId,this.f.sqmId,vt),sendErrorTelemetry:!0,piiPaths:(0,z.$rp)(Je)},it,Le)}else{ct=z.$gp;const Ke=z.$kp;nt.push(Ke)}this.a.registerChannel("telemetryAppender",new U.$Ncc(nt)),ke.set(V.$1l,ct);const Vt=new x.$9dc(it,ct,Ye,et,Je,Le);ke.set(V.$2l,Vt),ke.set(De.$oq,new T.$si(Pt.$LQ,void 0,!0)),ke.set(be.$sq,new T.$si(Se.$adc,void 0,!0)),ke.set(b.$$p,new T.$si(b.$aq,void 0,!0)),ke.set(v.$Cq,new T.$si(v.$Dq,void 0,!0)),ke.set(a.$5o,new T.$si(o.$9p,void 0,!0)),ke.set(a.$_o,new T.$si(Lt.$xec,void 0,!1)),ke.set(Q.$Qr,new T.$si(W.$Sr,void 0,!1)),ke.set($.$cn,new T.$si(t.$Gs,void 0,!1)),ke.set(Y.$YJb,new T.$si(Y.$ZJb,void 0,!0)),ke.set(_.$dBb,new T.$si(ge.$mMb,void 0,!0)),ke.set(_.$cBb,E.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ke=>Ke.ctx!=="main"))),ke.set(a.$$o,new T.$si(i.$WJb,void 0,!1)),ke.set(ee.$kMb,new T.$si(ee.$lMb,void 0,!0)),ke.set(K.$Zv,new T.$si(K.$1v)),ke.set(_.$ZAb,new T.$si(Ce.$rLb,void 0,!0)),ke.set(_.$1Ab,new T.$si(Ce.$tLb,void 0,!0)),ke.set(fe.$NAb,new T.$si(fe.$PAb,void 0,!0)),ke.set(_.$2Ab,new T.$si(se.$Oac,void 0,!1)),ke.set(_.$$Ab,new T.$si($e.$Dac,void 0,!0)),ke.set(_.$_Ab,new T.$si(ye.$Tac,void 0,!1)),ke.set(Ae.$AKb,new T.$si(le.$dec,void 0,!0)),ke.set(_.$aBb,new T.$si(_e.$qbc,void 0,!0)),ke.set(we.$Ol,new T.$si(Pe.$ydc,void 0,!1));const Et=new mt.$Ml;return ke.set(mt.$Ll,Et),Et.register(0,Nt.$zec),ke.set(Ie.$cw,new T.$si(Fe.$wdc)),ke.set(Oe.$eec,new T.$si(qe.$gec)),ke.set(Ge.$jec,new T.$si(Ct.$tec)),new X.$br(ke)}j(ke){const Le=new S.$cq(ke.get(a.$8o),()=>null);this.a.registerChannel("extensions",Le);const He=E.ProxyChannel.fromService(ke.get(Q.$Qr),this.q);this.a.registerChannel("languagePacks",He);const Ve=E.ProxyChannel.fromService(ke.get($.$cn),this.q);this.a.registerChannel("diagnostics",Ve);const Qe=new S.$eq(ke.get(a.$_o));this.a.registerChannel("extensionTipsService",Qe);const Je=E.ProxyChannel.fromService(ke.get(l.$7dc),this.q);this.a.registerChannel("checksum",Je);const et=E.ProxyChannel.fromService(ke.get(pe.$mG),this.q);this.a.registerChannel("v8InspectProfiling",et);const ot=E.ProxyChannel.fromService(ke.get(fe.$NAb),this.q);this.a.registerChannel("userDataSyncMachines",ot);const ht=E.ProxyChannel.fromService(ke.get(V.$2l),this.q);this.a.registerChannel("customEndpointTelemetry",ht);const Ye=new ue.$0dc(ke.get(Y.$YJb));this.a.registerChannel("userDataSyncAccount",Ye);const Xe=new ue.$_dc(ke.get(_.$ZAb));this.a.registerChannel("userDataSyncStoreManagement",Xe);const ut=new ve.$bec(ke.get(_.$_Ab),ke.get(Re.$Bl),ke.get(J.$2j));this.a.registerChannel("userDataSync",ut);const at=this.B(ke.get(q.$ui).createInstance(Ot.$wec));this.a.registerChannel("userDataAutoSync",E.ProxyChannel.fromService(at,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",E.ProxyChannel.fromService(ke.get(_.$aBb),this.q));const xe=E.ProxyChannel.fromService(ke.get(Oe.$eec),this.q);this.a.registerChannel(Oe.$fec,xe);const ft=E.ProxyChannel.fromService(ke.get(Ge.$jec),this.q);this.a.registerChannel("remoteTunnel",ft)}m(ke){process.on("uncaughtException",Le=>(0,L.$1)(Le)),process.on("unhandledRejection",Le=>(0,L.$1)(Le)),(0,L.setUnexpectedErrorHandler)(Le=>{const He=(0,N.$gj)(Le,!0);He&&ke.error(`[uncaught exception in sharedProcess]: ${He}`)})}n(ke,Le){ke.publicLog2("profilesInfo",{count:Le.profiles.length})}async r(ke,Le){if(Ue.$k){const[He,Ve]=await Promise.all([(0,Mt.$Sg)(Le.error.bind(Le)),(0,wt.$OW)(Le.error.bind(Le))]),Qe=(0,Tt.$uW)(),Je=(0,wt.$PW)(Ve,this.f.args["ozone-platform"]);He&&ke.publicLog2("clientPlatformInfo",{platformId:He.id,platformVersionId:He.version_id,platformIdLike:He.id_like,desktopEnvironment:Qe,displayProtocol:Ve,codeDisplayProtocol:Je})}}handledClientConnection(ke){if(ke.data!==st.$Kcc.response)return!1;const Le=(0,C.$Ob)(ke.ports);return Le?(this.c.fire(Le),!0):!1}}async function pt(rt){try{const ke=new qt(rt);process.parentPort.postMessage(st.$Icc.ipcReady),await ke.init(),process.parentPort.postMessage(st.$Icc.initDone)}catch(ke){process.parentPort.postMessage({error:ke.toString()})}}const zt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",rt=>{clearTimeout(zt),pt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5ae5a741bdb676abb667fd4896dc2a40e313db3a/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
