/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Pe=function(le){for(var e=[],d=0,N=le.length;d<N;d++)e[d]=ke[le[d]];return e};define(ke[163],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class d{static get(){const L=new Map,R=new Map,M=new Map,b=new Map;function m(y,w){y.has(w.detail)||y.set(w.detail,-w.timestamp)}function E(y,w){const h=y.get(w.detail);h&&(h>=0||y.set(w.detail,h+w.timestamp))}let A=[];typeof le=="function"&&typeof le.getStats=="function"&&(A=le.getStats().slice(0).sort((y,w)=>y.timestamp-w.timestamp));for(const y of A)switch(y.type){case 10:m(L,y);break;case 11:case 12:E(L,y);break;case 21:m(R,y);break;case 22:E(R,y);break;case 33:m(M,y);break;case 34:E(M,y);break;case 31:m(b,y);break;case 32:E(b,y);break}let D=0;M.forEach(y=>D+=y);function $(y){const w=[];return y.forEach((h,g)=>w.push([g,h])),w}return{amdLoad:$(L),amdInvoke:$(R),nodeRequire:$(M),nodeEval:$(b),nodeRequireTotal:D}}static toMarkdownTable(L,R){let M="";const b=[];return L.forEach((m,E)=>{b[E]=m.length}),R.forEach(m=>{m.forEach((E,A)=>{typeof E>"u"&&(E=m[A]="-");const D=E.toString().length;b[A]=Math.max(D,b[A])})}),L.forEach((m,E)=>{M+=`| ${m+" ".repeat(b[E]-m.toString().length)} `}),M+=`|
`,L.forEach((m,E)=>{M+=`| ${"-".repeat(b[E])} `}),M+=`|
`,R.forEach(m=>{m.forEach((E,A)=>{typeof E<"u"&&(M+=`| ${E+" ".repeat(b[A]-E.toString().length)} `)}),M+=`|
`}),M}}e.$U=d}),define(ke[164],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=d,e.$gb=N,e.$hb=L,e.$ib=R,e.$jb=M,e.$kb=b,e.$lb=m,e.$nb=A,e.$ob=D,e.$pb=$,e.$qb=y,e.$rb=w;function d(h,g){const a=N(h,g);if(a!==-1)return h[a]}function N(h,g,a=h.length-1){for(let n=a;n>=0;n--){const i=h[n];if(g(i))return n}return-1}function L(h,g){const a=R(h,g);return a===-1?void 0:h[a]}function R(h,g,a=0,n=h.length){let i=a,u=n;for(;i<u;){const o=Math.floor((i+u)/2);g(h[o])?i=o+1:u=o}return i-1}function M(h,g){const a=b(h,g);return a===h.length?void 0:h[a]}function b(h,g,a=0,n=h.length){let i=a,u=n;for(;i<u;){const o=Math.floor((i+u)/2);g(h[o])?u=o:i=o+1}return i}function m(h,g,a=0,n=h.length){const i=b(h,g,a,n);return i===h.length?-1:i}class E{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(E.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!g(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const a=R(this.e,g,this.c);return this.c=a+1,a===-1?void 0:this.e[a]}}e.$mb=E;function A(h,g){if(h.length===0)return;let a=h[0];for(let n=1;n<h.length;n++){const i=h[n];g(i,a)>0&&(a=i)}return a}function D(h,g){if(h.length===0)return;let a=h[0];for(let n=1;n<h.length;n++){const i=h[n];g(i,a)>=0&&(a=i)}return a}function $(h,g){return A(h,(a,n)=>-g(a,n))}function y(h,g){if(h.length===0)return-1;let a=0;for(let n=1;n<h.length;n++){const i=h[n];g(i,h[a])>0&&(a=n)}return a}function w(h,g){for(const a of h){const n=g(a);if(n!==void 0)return n}}}),define(ke[74],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=d,e.$L=N,e.$M=L,e.$N=R;function d(M,b){const m=Object.create(null);for(const E of M){const A=b(E);let D=m[A];D||(D=m[A]=[]),D.push(E)}return m}function N(M,b){const m=[],E=[];for(const A of M)b.has(A)||m.push(A);for(const A of b)M.has(A)||E.push(A);return{removed:m,added:E}}function L(M,b){const m=[],E=[];for(const[A,D]of M)b.has(A)||m.push(D);for(const[A,D]of b)M.has(A)||E.push(D);return{removed:m,added:E}}function R(M,b){const m=new Set;for(const E of b)M.has(E)&&m.add(E);return m}}),define(ke[55],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=N,e.$1h=L,e.$2h=R;function d(M){return(b,m,E)=>{let A=null,D=null;if(typeof E.value=="function"?(A="value",D=E.value):typeof E.get=="function"&&(A="get",D=E.get),!D)throw new Error("not supported");E[A]=M(D,m)}}function N(M,b,m){let E=null,A=null;if(typeof m.value=="function"?(E="value",A=m.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(E="get",A=m.get),!A)throw new Error("not supported");const D=`$memoize$${b}`;m[E]=function(...$){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,$)}),this[D]}}function L(M,b,m){return d((E,A)=>{const D=`$debounce$${A}`,$=`$debounce$result$${A}`;return function(...y){this[$]||(this[$]=m?m():void 0),clearTimeout(this[D]),b&&(this[$]=b(this[$],...y),y=[this[$]]),this[D]=setTimeout(()=>{E.apply(this,y),this[$]=m?m():void 0},M)}})}function R(M,b,m){return d((E,A)=>{const D=`$throttle$timer$${A}`,$=`$throttle$result$${A}`,y=`$throttle$lastRun$${A}`,w=`$throttle$pending$${A}`;return function(...h){if(this[$]||(this[$]=m?m():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),b&&(this[$]=b(this[$],...h)),this[w])return;const g=this[y]+M;g<=Date.now()?(this[y]=Date.now(),E.apply(this,[this[$]]),this[$]=m?m():void 0):(this[w]=!0,this[D]=setTimeout(()=>{this[w]=!1,this[y]=Date.now(),E.apply(this,[this[$]]),this[$]=m?m():void 0},g-Date.now()))}})}}),define(ke[13],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=L,e.$1=R,e.$2=M,e.$3=b,e.$4=E,e.$6=D,e.$7=$,e.$8=y,e.$0=h;class d{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(l=>{l(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=d,e.$X=new d;function N(o){e.$X.setUnexpectedErrorHandler(o)}function L(o){if(!o||typeof o!="object")return!1;const t=o;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(o){E(o)||e.$X.onUnexpectedError(o)}function M(o){E(o)||e.$X.onUnexpectedExternalError(o)}function b(o){if(o instanceof Error){const{name:t,message:l}=o,r=o.stacktrace||o.stack;return{$isError:!0,name:t,message:l,stack:r,noTelemetry:i.isErrorNoTelemetry(o)}}return o}const m="Canceled";function E(o){return o instanceof A?!0:o instanceof Error&&o.name===m&&o.message===m}class A extends Error{constructor(){super(m),this.name=this.message}}e.$5=A;function D(){const o=new Error(m);return o.name=o.message,o}function $(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function y(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class w extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=w;function h(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class a extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=a;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const l=new i;return l.message=t.message,l.stack=t.stack,l}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class u extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}e.$cb=u}),define(ke[19],Pe([1,0,13,164]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=L,e.$tb=R,e.$ub=M,e.$vb=b,e.$wb=m,e.$xb=E,e.$yb=A,e.$zb=D,e.$Ab=$,e.$Bb=y,e.$Cb=w,e.$Db=h,e.$Eb=g,e.top=a,e.$Gb=n,e.$Hb=u,e.$Ib=o,e.$Jb=t,e.$Kb=l,e.$Lb=r,e.$Mb=c,e.$Nb=s,e.$Ob=v,e.$Pb=f,e.$Qb=S,e.$Rb=p,e.$Sb=k,e.$Tb=P,e.$Ub=C,e.$Vb=I,e.$Wb=T,e.$Xb=j,e.$Yb=z,e.$Zb=O,e.$1b=F,e.$2b=B,e.$3b=Z,e.$4b=q,e.$5b=Q,e.$6b=x,e.$7b=me,e.$8b=ue,e.$$b=U;function L(se,re=0){return se[se.length-(1+re)]}function R(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}function M(se,re,oe=(K,ne)=>K===ne){if(se===re)return!0;if(!se||!re||se.length!==re.length)return!1;for(let K=0,ne=se.length;K<ne;K++)if(!oe(se[K],re[K]))return!1;return!0}function b(se,re){const oe=se.length-1;re<oe&&(se[re]=se[oe]),se.pop()}function m(se,re,oe){return E(se.length,K=>oe(se[K],re))}function E(se,re){let oe=0,K=se-1;for(;oe<=K;){const ne=(oe+K)/2|0,$e=re(ne);if($e<0)oe=ne+1;else if($e>0)K=ne-1;else return ne}return-(oe+1)}function A(se,re,oe){if(se=se|0,se>=re.length)throw new TypeError("invalid index");const K=re[Math.floor(re.length*Math.random())],ne=[],$e=[],be=[];for(const Ae of re){const fe=oe(Ae,K);fe<0?ne.push(Ae):fe>0?$e.push(Ae):be.push(Ae)}return se<ne.length?A(se,ne,oe):se<ne.length+be.length?be[0]:A(se-(ne.length+be.length),$e,oe)}function D(se,re){const oe=[];let K;for(const ne of se.slice(0).sort(re))!K||re(K[0],ne)!==0?(K=[ne],oe.push(K)):K.push(ne);return oe}function*$(se,re){let oe,K;for(const ne of se)K!==void 0&&re(K,ne)?oe.push(ne):(oe&&(yield oe),oe=[ne]),K=ne;oe&&(yield oe)}function y(se,re){for(let oe=0;oe<=se.length;oe++)re(oe===0?void 0:se[oe-1],oe===se.length?void 0:se[oe])}function w(se,re){for(let oe=0;oe<se.length;oe++)re(oe===0?void 0:se[oe-1],se[oe],oe+1===se.length?void 0:se[oe+1])}function h(se,re,oe){const K=[];function ne(Ae,fe,Se){if(fe===0&&Se.length===0)return;const Ie=K[K.length-1];Ie&&Ie.start+Ie.deleteCount===Ae?(Ie.deleteCount+=fe,Ie.toInsert.push(...Se)):K.push({start:Ae,deleteCount:fe,toInsert:Se})}let $e=0,be=0;for(;;){if($e===se.length){ne($e,0,re.slice(be));break}if(be===re.length){ne($e,se.length-$e,[]);break}const Ae=se[$e],fe=re[be],Se=oe(Ae,fe);Se===0?($e+=1,be+=1):Se<0?(ne($e,1,[]),$e+=1):Se>0&&(ne($e,0,[fe]),be+=1)}return K}function g(se,re,oe){const K=h(se,re,oe),ne=[],$e=[];for(const be of K)ne.push(...se.slice(be.start,be.start+be.deleteCount)),$e.push(...be.toInsert);return{removed:ne,added:$e}}function a(se,re,oe){if(oe===0)return[];const K=se.slice(0,oe).sort(re);return i(se,re,K,oe,se.length),K}function n(se,re,oe,K,ne){return oe===0?Promise.resolve([]):new Promise(($e,be)=>{(async()=>{const Ae=se.length,fe=se.slice(0,oe).sort(re);for(let Se=oe,Ie=Math.min(oe+K,Ae);Se<Ae;Se=Ie,Ie=Math.min(Ie+K,Ae)){if(Se>oe&&await new Promise(ze=>setTimeout(ze)),ne&&ne.isCancellationRequested)throw new d.$5;i(se,re,fe,Se,Ie)}return fe})().then($e,be)})}function i(se,re,oe,K,ne){for(const $e=oe.length;K<ne;K++){const be=se[K];if(re(be,oe[$e-1])<0){oe.pop();const Ae=(0,N.$kb)(oe,fe=>re(be,fe)<0);oe.splice(Ae,0,be)}}}function u(se){return se.filter(re=>!!re)}function o(se){let re=0;for(let oe=0;oe<se.length;oe++)se[oe]&&(se[re]=se[oe],re+=1);se.length=re}function t(se,re,oe){se.splice(oe,0,se.splice(re,1)[0])}function l(se){return!Array.isArray(se)||se.length===0}function r(se){return Array.isArray(se)&&se.length>0}function c(se,re=oe=>oe){const oe=new Set;return se.filter(K=>{const ne=re(K);return oe.has(ne)?!1:(oe.add(ne),!0)})}function s(se){const re=new Set;return oe=>{const K=se(oe);return re.has(K)?!1:(re.add(K),!0)}}function v(se,re){return se.length>0?se[0]:re}function f(se,re){return se.length>0?se[se.length-1]:re}function S(se,re,oe=(K,ne)=>K===ne){let K=0;for(let ne=0,$e=Math.min(se.length,re.length);ne<$e&&oe(se[ne],re[ne]);ne++)K++;return K}function p(se){return[].concat(...se)}function k(se,re){let oe=typeof re=="number"?se:0;typeof re=="number"?oe=se:(oe=0,re=se);const K=[];if(oe<=re)for(let ne=oe;ne<re;ne++)K.push(ne);else for(let ne=oe;ne>re;ne--)K.push(ne);return K}function P(se,re,oe){return se.reduce((K,ne)=>(K[re(ne)]=oe?oe(ne):ne,K),Object.create(null))}function C(se,re){return se.push(re),()=>I(se,re)}function I(se,re){const oe=se.indexOf(re);if(oe>-1)return se.splice(oe,1),re}function T(se,re,oe){const K=se.slice(0,re),ne=se.slice(re);return K.concat(oe,ne)}function j(se,re){let oe;if(typeof re=="number"){let K=re;oe=()=>{const ne=Math.sin(K++)*179426549;return ne-Math.floor(ne)}}else oe=Math.random;for(let K=se.length-1;K>0;K-=1){const ne=Math.floor(oe()*(K+1)),$e=se[K];se[K]=se[ne],se[ne]=$e}}function z(se,re){const oe=se.indexOf(re);oe>-1&&(se.splice(oe,1),se.unshift(re))}function O(se,re){const oe=se.indexOf(re);oe>-1&&(se.splice(oe,1),se.push(re))}function F(se,re){for(const oe of re)se.push(oe)}function B(se,re){return Array.isArray(se)?se.map(re):re(se)}function Z(se){return Array.isArray(se)?se:[se]}function q(se){return se[Math.floor(Math.random()*se.length)]}function Q(se,re,oe){const K=X(se,re),ne=se.length,$e=oe.length;se.length=ne+$e;for(let be=ne-1;be>=K;be--)se[be+$e]=se[be];for(let be=0;be<$e;be++)se[be+K]=oe[be]}function x(se,re,oe,K){const ne=X(se,re);let $e=se.splice(ne,oe);return $e===void 0&&($e=[]),Q(se,ne,K),$e}function X(se,re){return re<0?Math.max(re+se.length,0):Math.min(re,se.length)}var ie;(function(se){function re($e){return $e<0}se.isLessThan=re;function oe($e){return $e<=0}se.isLessThanOrEqual=oe;function K($e){return $e>0}se.isGreaterThan=K;function ne($e){return $e===0}se.isNeitherLessOrGreaterThan=ne,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function me(se,re){return(oe,K)=>re(se(oe),se(K))}function ue(...se){return(re,oe)=>{for(const K of se){const ne=K(re,oe);if(!ie.isNeitherLessOrGreaterThan(ne))return ne}return ie.neitherLessOrGreaterThan}}const ve=(se,re)=>se-re;e.$9b=ve;const te=(se,re)=>(0,e.$9b)(se?1:0,re?1:0);e.$0b=te;function U(se){return(re,oe)=>-se(re,oe)}class ee{constructor(re){this.g=re,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(re){let oe=this.c;for(;oe<this.g.length&&re(this.g[oe]);)oe++;const K=oe===this.c?null:this.g.slice(this.c,oe);return this.c=oe,K}takeFromEndWhile(re){let oe=this.d;for(;oe>=0&&re(this.g[oe]);)oe--;const K=oe===this.d?null:this.g.slice(oe+1,this.d+1);return this.d=oe,K}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const re=this.g[this.c];return this.c++,re}removeLast(){const re=this.g[this.d];return this.d--,re}takeCount(re){const oe=this.g.slice(this.c,this.c+re);return this.c+=re,oe}}e.$_b=ee;class pe{static{this.empty=new pe(re=>{})}constructor(re){this.iterate=re}forEach(re){this.iterate(oe=>(re(oe),!0))}toArray(){const re=[];return this.iterate(oe=>(re.push(oe),!0)),re}filter(re){return new pe(oe=>this.iterate(K=>re(K)?oe(K):!0))}map(re){return new pe(oe=>this.iterate(K=>oe(re(K))))}some(re){let oe=!1;return this.iterate(K=>(oe=re(K),!oe)),oe}findFirst(re){let oe;return this.iterate(K=>re(K)?(oe=K,!1):!0),oe}findLast(re){let oe;return this.iterate(K=>(re(K)&&(oe=K),!0)),oe}findLastMaxBy(re){let oe,K=!0;return this.iterate(ne=>((K||ie.isGreaterThan(re(ne,oe)))&&(K=!1,oe=ne),!0)),oe}}e.$ac=pe;class Ce{constructor(re){this.c=re}static createSortPermutation(re,oe){const K=Array.from(re.keys()).sort((ne,$e)=>oe(re[ne],re[$e]));return new Ce(K)}apply(re){return re.map((oe,K)=>re[this.c[K]])}inverse(){const re=this.c.slice();for(let oe=0;oe<this.c.length;oe++)re[this.c[oe]]=oe;return new Ce(re)}}e.$bc=Ce}),define(ke[62],Pe([1,0,13]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$fd=L,e.$gd=R,e.$hd=M,e.$id=b,e.$jd=m;function N(E,A){if(!E)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}function L(E,A="Unreachable"){throw new Error(A)}function R(E){if(!E)throw new d.$cb("Assertion Failed")}function M(E){E||(0,d.$1)(new d.$cb("Soft Assertion Failed"))}function b(E){if(!E()){debugger;E(),(0,d.$1)(new d.$cb("Assertion Failed"))}}function m(E,A){let D=0;for(;D<E.length-1;){const $=E[D],y=E[D+1];if(!A($,y))return!1;D++}return!0}}),define(ke[165],Pe([1,0,19]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=L,e.$9c=R,e.$0c=M,e.$$c=b,e.$_c=m,e.$ad=E;const N=(y,w)=>y===w;e.$7c=N;function L(y=e.$7c){return(w,h)=>d.$ub(w,h,y)}function R(){return(y,w)=>JSON.stringify(y)===JSON.stringify(w)}function M(){return(y,w)=>y.equals(w)}function b(y,w,h){return!y||!w?y===w:h(y,w)}function m(y,w){if(y===w)return!0;if(Array.isArray(y)&&Array.isArray(w)){if(y.length!==w.length)return!1;for(let h=0;h<y.length;h++)if(!m(y[h],w[h]))return!1;return!0}if(Object.getPrototypeOf(y)===Object.prototype&&Object.getPrototypeOf(w)===Object.prototype){const h=y,g=w,a=Object.keys(h),n=Object.keys(g),i=new Set(n);if(a.length!==n.length)return!1;for(const u of a)if(!i.has(u)||!m(h[u],g[u]))return!1;return!0}return!1}function E(y){return JSON.stringify($(y))}let A=0;const D=new WeakMap;function $(y){if(Array.isArray(y))return y.map($);if(y&&typeof y=="object")if(Object.getPrototypeOf(y)===Object.prototype){const w=y,h=Object.create(null);for(const g of Object.keys(w).sort())h[g]=$(w[g]);return h}else{let w=D.get(y);return w===void 0&&(w=A++,D.set(y,w)),w+"----2b76a038c20c4bcc"}return y}}),define(ke[75],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=d;function d(N,L){const R=this;let M=!1,b;return function(){if(M)return b;if(M=!0,L)try{b=N.apply(R,arguments)}finally{L()}else b=N.apply(R,arguments);return b}}}),define(ke[125],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uP=e.$tP=void 0;class d{constructor(L){this.a=L,this.b=0}nextId(){return this.a+ ++this.b}}e.$tP=d,e.$uP=new d("id#")}),define(ke[39],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var d;(function(N){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=L;const R=Object.freeze([]);function M(){return R}N.empty=M;function*b(t){yield t}N.single=b;function m(t){return L(t)?t:b(t)}N.wrap=m;function E(t){return t||R}N.from=E;function*A(t){for(let l=t.length-1;l>=0;l--)yield t[l]}N.reverse=A;function D(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=D;function $(t){return t[Symbol.iterator]().next().value}N.first=$;function y(t,l){for(const r of t)if(l(r))return!0;return!1}N.some=y;function w(t,l){for(const r of t)if(l(r))return r}N.find=w;function*h(t,l){for(const r of t)l(r)&&(yield r)}N.filter=h;function*g(t,l){let r=0;for(const c of t)yield l(c,r++)}N.map=g;function*a(...t){for(const l of t)yield*l}N.concat=a;function n(t,l,r){let c=r;for(const s of t)c=l(c,s);return c}N.reduce=n;function*i(t,l,r=t.length){for(l<0&&(l+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);l<r;l++)yield t[l]}N.slice=i;function u(t,l=Number.POSITIVE_INFINITY){const r=[];if(l===0)return[r,t];const c=t[Symbol.iterator]();for(let s=0;s<l;s++){const v=c.next();if(v.done)return[r,N.empty()];r.push(v.value)}return[r,{[Symbol.iterator](){return c}}]}N.consume=u;async function o(t){const l=[];for await(const r of t)l.push(r);return Promise.resolve(l)}N.asyncToArray=o})(d||(e.Iterable=d={}))}),define(ke[166],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Gn=M,e.$Hn=D,e.$In=$,e.$Jn=y,e.$Kn=w,e.$Ln=h,e.$Mn=g,e.$Nn=a,e.$On=n,e.$Pn=i,e.$Qn=u,e.$Rn=o;var d;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(d||(e.ScanError=d={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function M(t,l=!1){let r=0;const c=t.length;let s="",v=0,f=16,S=0;function p(z){let O=0,F=0;for(;O<z;){const B=t.charCodeAt(r);if(B>=48&&B<=57)F=F*16+B-48;else if(B>=65&&B<=70)F=F*16+B-65+10;else if(B>=97&&B<=102)F=F*16+B-97+10;else break;r++,O++}return O<z&&(F=-1),F}function k(z){r=z,s="",v=0,f=16,S=0}function P(){const z=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&E(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&E(t.charCodeAt(r)))for(r++;r<t.length&&E(t.charCodeAt(r));)r++;else return S=3,t.substring(z,r);let O=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&E(t.charCodeAt(r))){for(r++;r<t.length&&E(t.charCodeAt(r));)r++;O=r}else S=3;return t.substring(z,O)}function C(){let z="",O=r;for(;;){if(r>=c){z+=t.substring(O,r),S=2;break}const F=t.charCodeAt(r);if(F===34){z+=t.substring(O,r),r++;break}if(F===92){if(z+=t.substring(O,r),r++,r>=c){S=2;break}switch(t.charCodeAt(r++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const Z=p(4);Z>=0?z+=String.fromCharCode(Z):S=4;break}default:S=5}O=r;continue}if(F>=0&&F<=31)if(m(F)){z+=t.substring(O,r),S=2;break}else S=6;r++}return z}function I(){if(s="",S=0,v=r,r>=c)return v=c,f=17;let z=t.charCodeAt(r);if(b(z)){do r++,s+=String.fromCharCode(z),z=t.charCodeAt(r);while(b(z));return f=15}if(m(z))return r++,s+=String.fromCharCode(z),z===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),f=14;switch(z){case 123:return r++,f=1;case 125:return r++,f=2;case 91:return r++,f=3;case 93:return r++,f=4;case 58:return r++,f=6;case 44:return r++,f=5;case 34:return r++,s=C(),f=10;case 47:{const O=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<c&&!m(t.charCodeAt(r));)r++;return s=t.substring(O,r),f=12}if(t.charCodeAt(r+1)===42){r+=2;const F=c-1;let B=!1;for(;r<F;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,B=!0;break}r++}return B||(r++,S=1),s=t.substring(O,r),f=13}return s+=String.fromCharCode(z),r++,f=16}case 45:if(s+=String.fromCharCode(z),r++,r===c||!E(t.charCodeAt(r)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=P(),f=11;default:for(;r<c&&T(z);)r++,z=t.charCodeAt(r);if(v!==r){switch(s=t.substring(v,r),s){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return s+=String.fromCharCode(z),r++,f=16}}function T(z){if(b(z)||m(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let z;do z=I();while(z>=12&&z<=15);return z}return{setPosition:k,getPosition:()=>r,scan:l?j:I,getToken:()=>f,getTokenValue:()=>s,getTokenOffset:()=>v,getTokenLength:()=>r-v,getTokenError:()=>S}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function D(t,l){const r=[],c=new Object;let s;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function S(p,k,P,C){v.value=p,v.offset=k,v.length=P,v.type=C,v.colonOffset=void 0,s=v}try{i(t,{onObjectBegin:(p,k)=>{if(l<=p)throw c;s=void 0,f=l>p,r.push("")},onObjectProperty:(p,k,P)=>{if(l<k||(S(p,k,P,"property"),r[r.length-1]=p,l<=k+P))throw c},onObjectEnd:(p,k)=>{if(l<=p)throw c;s=void 0,r.pop()},onArrayBegin:(p,k)=>{if(l<=p)throw c;s=void 0,r.push(0)},onArrayEnd:(p,k)=>{if(l<=p)throw c;s=void 0,r.pop()},onLiteralValue:(p,k,P)=>{if(l<k||(S(p,k,P,o(p)),l<=k+P))throw c},onSeparator:(p,k,P)=>{if(l<=k)throw c;if(p===":"&&s&&s.type==="property")s.colonOffset=k,f=!1,s=void 0;else if(p===","){const C=r[r.length-1];typeof C=="number"?r[r.length-1]=C+1:(f=!0,r[r.length-1]=""),s=void 0}}})}catch(p){if(p!==c)throw p}return{path:r,previousNode:s,isAtPropertyKey:f,matches:p=>{let k=0;for(let P=0;k<p.length&&P<r.length;P++)if(p[k]===r[P]||p[k]==="*")k++;else if(p[k]!=="**")return!1;return k===p.length}}}function $(t,l=[],r=R.DEFAULT){let c=null,s=[];const v=[];function f(p){Array.isArray(s)?s.push(p):c!==null&&(s[c]=p)}return i(t,{onObjectBegin:()=>{const p={};f(p),v.push(s),s=p,c=null},onObjectProperty:p=>{c=p},onObjectEnd:()=>{s=v.pop()},onArrayBegin:()=>{const p=[];f(p),v.push(s),s=p,c=null},onArrayEnd:()=>{s=v.pop()},onLiteralValue:f,onError:(p,k,P)=>{l.push({error:p,offset:k,length:P})}},r),s[0]}function y(t,l=[],r=R.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(p){c.type==="property"&&(c.length=p-c.offset,c=c.parent)}function v(p){return c.children.push(p),p}i(t,{onObjectBegin:p=>{c=v({type:"object",offset:p,length:-1,parent:c,children:[]})},onObjectProperty:(p,k,P)=>{c=v({type:"property",offset:k,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:p,offset:k,length:P,parent:c})},onObjectEnd:(p,k)=>{c.length=p+k-c.offset,c=c.parent,s(p+k)},onArrayBegin:(p,k)=>{c=v({type:"array",offset:p,length:-1,parent:c,children:[]})},onArrayEnd:(p,k)=>{c.length=p+k-c.offset,c=c.parent,s(p+k)},onLiteralValue:(p,k,P)=>{v({type:o(p),offset:k,length:P,parent:c,value:p}),s(k+P)},onSeparator:(p,k,P)=>{c.type==="property"&&(p===":"?c.colonOffset=k:p===","&&s(k))},onError:(p,k,P)=>{l.push({error:p,offset:k,length:P})}},r);const S=c.children[0];return S&&delete S.parent,S}function w(t,l){if(!t)return;let r=t;for(const c of l)if(typeof c=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const v of r.children)if(Array.isArray(v.children)&&v.children[0].value===c){r=v.children[1],s=!0;break}if(!s)return}else{const s=c;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}function h(t){if(!t.parent||!t.parent.children)return[];const l=h(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;l.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&l.push(r)}return l}function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const l=Object.create(null);for(const r of t.children){const c=r.children[1];c&&(l[r.children[0].value]=g(c))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function a(t,l,r=!1){return l>=t.offset&&l<t.offset+t.length||r&&l===t.offset+t.length}function n(t,l,r=!1){if(a(t,l,r)){const c=t.children;if(Array.isArray(c))for(let s=0;s<c.length&&c[s].offset<=l;s++){const v=n(c[s],l,r);if(v)return v}return t}}function i(t,l,r=R.DEFAULT){const c=M(t,!1);function s(me){return me?()=>me(c.getTokenOffset(),c.getTokenLength()):()=>!0}function v(me){return me?ue=>me(ue,c.getTokenOffset(),c.getTokenLength()):()=>!0}const f=s(l.onObjectBegin),S=v(l.onObjectProperty),p=s(l.onObjectEnd),k=s(l.onArrayBegin),P=s(l.onArrayEnd),C=v(l.onLiteralValue),I=v(l.onSeparator),T=s(l.onComment),j=v(l.onError),z=r&&r.disallowComments,O=r&&r.allowTrailingComma;function F(){for(;;){const me=c.scan();switch(c.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:z||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(me){case 12:case 13:z?B(10):T();break;case 16:B(1);break;case 15:case 14:break;default:return me}}}function B(me,ue=[],ve=[]){if(j(me),ue.length+ve.length>0){let te=c.getToken();for(;te!==17;){if(ue.indexOf(te)!==-1){F();break}else if(ve.indexOf(te)!==-1)break;te=F()}}}function Z(me){const ue=c.getTokenValue();return me?C(ue):S(ue),F(),!0}function q(){switch(c.getToken()){case 11:{let me=0;try{me=JSON.parse(c.getTokenValue()),typeof me!="number"&&(B(2),me=0)}catch{B(2)}C(me);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return F(),!0}function Q(){return c.getToken()!==10?(B(3,[],[2,5]),!1):(Z(!1),c.getToken()===6?(I(":"),F(),ie()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function x(){f(),F();let me=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(me||B(4,[],[]),I(","),F(),c.getToken()===2&&O)break}else me&&B(6,[],[]);Q()||B(4,[],[2,5]),me=!0}return p(),c.getToken()!==2?B(7,[2],[]):F(),!0}function X(){k(),F();let me=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(me||B(4,[],[]),I(","),F(),c.getToken()===4&&O)break}else me&&B(6,[],[]);ie()||B(4,[],[4,5]),me=!0}return P(),c.getToken()!==4?B(8,[4],[]):F(),!0}function ie(){switch(c.getToken()){case 3:return X();case 1:return x();case 10:return Z(!0);default:return q()}}return F(),c.getToken()===17?r.allowEmptyContent?!0:(B(4,[],[]),!1):ie()?(c.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}function u(t,l){const r=M(t),c=[];let s,v=0,f;do switch(f=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:v!==f&&c.push(t.substring(v,f)),l!==void 0&&c.push(r.getTokenValue().replace(/[^\r\n]/g,l)),v=r.getPosition();break}while(s!==17);return c.join("")}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[46],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class d{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=d}),define(ke[76],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class d{static{this.Undefined=new d(void 0)}constructor(R){this.element=R,this.next=d.Undefined,this.prev=d.Undefined}}class N{constructor(){this.a=d.Undefined,this.b=d.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===d.Undefined}clear(){let R=this.a;for(;R!==d.Undefined;){const M=R.next;R.prev=d.Undefined,R.next=d.Undefined,R=M}this.a=d.Undefined,this.b=d.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,M){const b=new d(R);if(this.a===d.Undefined)this.a=b,this.b=b;else if(M){const E=this.b;this.b=b,b.prev=E,E.next=b}else{const E=this.a;this.a=b,b.next=E,E.prev=b}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e(b))}}shift(){if(this.a!==d.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==d.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==d.Undefined&&R.next!==d.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===d.Undefined&&R.next===d.Undefined?(this.a=d.Undefined,this.b=d.Undefined):R.next===d.Undefined?(this.b=this.b.prev,this.b.next=d.Undefined):R.prev===d.Undefined&&(this.a=this.a.next,this.a.prev=d.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==d.Undefined;)yield R.element,R=R.next}}e.$6c=N}),define(ke[27],Pe([1,0]),function(le,e){"use strict";var d,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=M,e.$Ac=b,e.$Jc=u;function R(o,t,l){let r=o.get(t);return r===void 0&&(r=l,o.set(t,r)),r}function M(o){const t=[];return o.forEach((l,r)=>{t.push(`${r} => ${l}`)}),`Map(${o.size}) {${t.join(", ")}}`}function b(o){const t=[];return o.forEach(l=>{t.push(l)}),`Set(${o.size}) {${t.join(", ")}}`}class m{constructor(t,l){this.uri=t,this.value=l}}function E(o){return Array.isArray(o)}class A{static{this.c=t=>t.toString()}constructor(t,l){if(this[d]="ResourceMap",t instanceof A)this.d=new Map(t.d),this.e=l??A.c;else if(E(t)){this.d=new Map,this.e=l??A.c;for(const[r,c]of t)this.set(r,c)}else this.d=new Map,this.e=t??A.c}set(t,l){return this.d.set(this.e(t),new m(t,l)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,l){typeof l<"u"&&(t=t.bind(l));for(const[r,c]of this.d)t(c.value,c.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(d=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=A;class D{constructor(t,l){this[N]="ResourceSet",!t||typeof t=="function"?this.c=new A(t):(this.c=new A(l),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,l){this.c.forEach((r,c)=>t.call(l,c,c,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=D;var $;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})($||(e.Touch=$={}));class y{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,l=0){const r=this.c.get(t);if(r)return l!==0&&this.m(r,l),r.value}set(t,l,r=0){let c=this.c.get(t);if(c)c.value=l,r!==0&&this.m(c,r);else{switch(c={key:t,value:l,next:void 0,previous:void 0},r){case 0:this.k(c);break;case 1:this.j(c);break;case 2:this.k(c);break;default:this.k(c);break}this.c.set(t,c),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const l=this.c.get(t);if(l)return this.c.delete(t),this.l(l),this.f--,l.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,l){const r=this.g;let c=this.d;for(;c;){if(l?t.bind(l)(c.value,c.key,this):t(c.value,c.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,l=this.g;let r=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==l)throw new Error("LinkedMap got modified during iteration.");if(r){const s={value:r.key,done:!1};return r=r.next,s}else return{value:void 0,done:!0}}};return c}values(){const t=this,l=this.g;let r=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==l)throw new Error("LinkedMap got modified during iteration.");if(r){const s={value:r.value,done:!1};return r=r.next,s}else return{value:void 0,done:!0}}};return c}entries(){const t=this,l=this.g;let r=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==l)throw new Error("LinkedMap got modified during iteration.");if(r){const s={value:[r.key,r.value],done:!1};return r=r.next,s}else return{value:void 0,done:!0}}};return c}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let l=this.d,r=this.size;for(;l&&r>t;)this.c.delete(l.key),l=l.next,r--;this.d=l,this.f=r,l&&(l.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let l=this.e,r=this.size;for(;l&&r>t;)this.c.delete(l.key),l=l.previous,r--;this.e=l,this.f=r,l&&(l.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const l=t.next,r=t.previous;if(!l||!r)throw new Error("Invalid list");l.previous=r,r.next=l}t.next=void 0,t.previous=void 0,this.g++}m(t,l){if(!this.d||!this.e)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(t===this.d)return;const r=t.next,c=t.previous;t===this.e?(c.next=void 0,this.e=c):(r.previous=c,c.next=r),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(l===2){if(t===this.e)return;const r=t.next,c=t.previous;t===this.d?(r.previous=void 0,this.d=r):(r.previous=c,c.next=r),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((l,r)=>{t.push([r,l])}),t}fromJSON(t){this.clear();for(const[l,r]of t)this.set(l,r)}}e.$Dc=y;class w extends y{constructor(t,l=1){super(),this.n=t,this.o=Math.min(Math.max(0,l),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,l=2){return super.get(t,l)}peek(t){return super.get(t,0)}set(t,l){return super.set(t,l,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class h extends w{constructor(t,l=1){super(t,l)}q(t){this.h(t)}set(t,l){return super.set(t,l),this.p(),this}}e.$Ec=h;class g extends w{constructor(t,l=1){super(t,l)}q(t){this.i(t)}set(t,l){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,l),this}}e.$Fc=g;class a{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let l=this.c.get(t)||0;return l===0?!1:(l--,l===0?this.c.delete(t):this.c.set(t,l),!0)}has(t){return this.c.has(t)}}e.$Gc=a;class n{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[l,r]of t)this.set(l,r)}clear(){this.c.clear(),this.d.clear()}set(t,l){this.c.set(t,l),this.d.set(l,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const l=this.c.get(t);return l===void 0?!1:(this.c.delete(t),this.d.delete(l),!0)}forEach(t,l){this.c.forEach((r,c)=>{t.call(l,r,c,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=n;class i{constructor(){this.c=new Map}add(t,l){let r=this.c.get(t);r||(r=new Set,this.c.set(t,r)),r.add(l)}delete(t,l){const r=this.c.get(t);r&&(r.delete(l),r.size===0&&this.c.delete(t))}forEach(t,l){const r=this.c.get(t);r&&r.forEach(l)}get(t){const l=this.c.get(t);return l||new Set}}e.$Ic=i;function u(o,t){if(o===t)return!0;if(o.size!==t.size)return!1;for(const[l,r]of o)if(!t.has(l)||t.get(l)!==r)return!1;for(const[l]of t)if(!o.has(l))return!1;return!0}}),define(ke[3],Pe([1,0,19,74,27,75,39]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=A,e.$Mc=D,e.$Nc=$,e.$Oc=h,e.$Pc=g,e.$Qc=a,e.$Rc=n,e.$Sc=i,e.$Tc=u,e.$4c=p;const b=!1;let m=null;class E{constructor(){this.b=new Map}static{this.a=0}c(C){let I=this.b.get(C);return I||(I={parent:null,source:null,isSingleton:!1,value:C,idx:E.a++},this.b.set(C,I)),I}trackDisposable(C){const I=this.c(C);I.source||(I.source=new Error().stack)}setParent(C,I){const T=this.c(C);T.parent=I}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,I){const T=I.get(C);if(T)return T;const j=C.parent?this.f(this.c(C.parent),I):C;return I.set(C,j),j}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,T])=>T.source!==null&&!this.f(T,C).isSingleton).flatMap(([T])=>T)}computeLeakingDisposables(C=10,I){let T;if(I)T=I;else{const B=new Map,Z=[...this.b.values()].filter(Q=>Q.source!==null&&!this.f(Q,B).isSingleton);if(Z.length===0)return;const q=new Set(Z.map(Q=>Q.value));if(T=Z.filter(Q=>!(Q.parent&&q.has(Q.parent))),T.length===0)throw new Error("There are cyclic diposable chains!")}if(!T)return;function j(B){function Z(Q,x){for(;Q.length>0&&x.some(X=>typeof X=="string"?X===Q[0]:Q[0].match(X));)Q.shift()}const q=B.source.split(`
`).map(Q=>Q.trim().replace("at ","")).filter(Q=>Q!=="");return Z(q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),q.reverse()}const z=new L.$Ic;for(const B of T){const Z=j(B);for(let q=0;q<=Z.length;q++)z.add(Z.slice(0,q).join(`
`),B)}T.sort((0,d.$7b)(B=>B.idx,d.$9b));let O="",F=0;for(const B of T.slice(0,C)){F++;const Z=j(B),q=[];for(let Q=0;Q<Z.length;Q++){let x=Z[Q];x=`(shared with ${z.get(Z.slice(0,Q+1).join(`
`)).size}/${T.length} leaks) at ${x}`;const ie=z.get(Z.slice(0,Q).join(`
`)),me=(0,N.$K)([...ie].map(ue=>j(ue)[Q]),ue=>ue);delete me[Z[Q]];for(const[ue,ve]of Object.entries(me))q.unshift(`    - stacktraces of ${ve.length} other leaks continue with ${ue}`);q.unshift(x)}O+=`


==================== Leaking disposable ${F}/${T.length}: ${B.value.constructor.name} ====================
${q.join(`
`)}
============================================================

`}return T.length>C&&(O+=`


... and ${T.length-C} more leaking disposables

`),{leaks:T,details:O}}}e.$Kc=E;function A(P){m=P}if(b){const P="__is_disposable_tracked__";A(new class{trackDisposable(C){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[P]||console.log(I)},3e3)}setParent(C,I){if(C&&C!==t.None)try{C[P]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[P]=!0}catch{}}markAsSingleton(C){}})}function D(P){return m?.trackDisposable(P),P}function $(P){m?.markAsDisposed(P)}function y(P,C){m?.setParent(P,C)}function w(P,C){if(m)for(const I of P)m.setParent(I,C)}function h(P){return m?.markAsSingleton(P),P}function g(P){return typeof P=="object"&&P!==null&&typeof P.dispose=="function"&&P.dispose.length===0}function a(P){if(M.Iterable.is(P)){const C=[];for(const I of P)if(I)try{I.dispose()}catch(T){C.push(T)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(P)?[]:P}else if(P)return P.dispose(),P}function n(P){for(const C of P)g(C)&&C.dispose();return[]}function i(...P){const C=u(()=>a(P));return w(P,C),C}function u(P){const C=D({dispose:(0,R.$db)(()=>{$(C),P()})});return C}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,D(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{a(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return y(C,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),y(C,null))}}e.$Uc=o;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,D(this),y(this.q,this)}dispose(){$(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Vc=t;class l{constructor(){this.b=!1,D(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&y(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&y(C,null),C}}e.$Wc=l;class r{constructor(C){this.a=new l,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=r;class c{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=c;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(C){let I=C;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,$(this))},this}}e.$Zc=s;class v{constructor(){this.a=new Map}acquire(C,...I){let T=this.a.get(C);T||(T={counter:0,object:this.b(C,...I)},this.a.set(C,T));const{object:j}=T,z=(0,R.$db)(()=>{--T.counter===0&&(this.c(C,T.object),this.a.delete(C))});return T.counter++,{object:j,dispose:z}}}e.$1c=v;class f{constructor(C){this.a=C}async acquire(C,...I){const T=this.a.acquire(C,...I);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(j){throw T.dispose(),j}}}e.$2c=f;class S{constructor(C){this.object=C}dispose(){}}e.$3c=S;function p(P){const C=new o;try{P(C)}finally{C.dispose()}}class k{constructor(){this.a=new Map,this.b=!1,D(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{a(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,I,T=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this.a.get(C)?.dispose(),this.a.set(C,I)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=k}),function(le,e){typeof define=="function"&&define.amd?define(ke[167],Pe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(se,re){for(var oe=0;oe<re.length;oe++){var K=re[oe];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(se,K.key,K)}}function d(se,re,oe){return re&&e(se.prototype,re),oe&&e(se,oe),Object.defineProperty(se,"prototype",{writable:!1}),se}function N(se,re){if(se){if(typeof se=="string")return L(se,re);var oe=Object.prototype.toString.call(se).slice(8,-1);if(oe==="Object"&&se.constructor&&(oe=se.constructor.name),oe==="Map"||oe==="Set")return Array.from(se);if(oe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(oe))return L(se,re)}}function L(se,re){(re==null||re>se.length)&&(re=se.length);for(var oe=0,K=new Array(re);oe<re;oe++)K[oe]=se[oe];return K}function R(se,re){var oe=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(oe)return(oe=oe.call(se)).next.bind(oe);if(Array.isArray(se)||(oe=N(se))||re&&se&&typeof se.length=="number"){oe&&(se=oe);var K=0;return function(){return K>=se.length?{done:!0}:{done:!1,value:se[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=M();function b(se){le.defaults=se}var m=/[&<>"']/,E=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(re){return $[re]};function w(se,re){if(re){if(m.test(se))return se.replace(E,y)}else if(A.test(se))return se.replace(D,y);return se}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(se){return se.replace(h,function(re,oe){return oe=oe.toLowerCase(),oe==="colon"?":":oe.charAt(0)==="#"?oe.charAt(1)==="x"?String.fromCharCode(parseInt(oe.substring(2),16)):String.fromCharCode(+oe.substring(1)):""})}var a=/(^|[^\[])\^/g;function n(se,re){se=typeof se=="string"?se:se.source,re=re||"";var oe={replace:function(ne,$e){return $e=$e.source||$e,$e=$e.replace(a,"$1"),se=se.replace(ne,$e),oe},getRegex:function(){return new RegExp(se,re)}};return oe}var i=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function o(se,re,oe){if(se){var K;try{K=decodeURIComponent(g(oe)).replace(i,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}re&&!u.test(oe)&&(oe=s(re,oe));try{oe=encodeURI(oe).replace(/%25/g,"%")}catch{return null}return oe}var t={},l=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(se,re){t[" "+se]||(l.test(se)?t[" "+se]=se+"/":t[" "+se]=p(se,"/",!0)),se=t[" "+se];var oe=se.indexOf(":")===-1;return re.substring(0,2)==="//"?oe?re:se.replace(r,"$1")+re:re.charAt(0)==="/"?oe?re:se.replace(c,"$1")+re:se+re}var v={exec:function(){}};function f(se){for(var re=1,oe,K;re<arguments.length;re++){oe=arguments[re];for(K in oe)Object.prototype.hasOwnProperty.call(oe,K)&&(se[K]=oe[K])}return se}function S(se,re){var oe=se.replace(/\|/g,function($e,be,Ae){for(var fe=!1,Se=be;--Se>=0&&Ae[Se]==="\\";)fe=!fe;return fe?"|":" |"}),K=oe.split(/ \|/),ne=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>re)K.splice(re);else for(;K.length<re;)K.push("");for(;ne<K.length;ne++)K[ne]=K[ne].trim().replace(/\\\|/g,"|");return K}function p(se,re,oe){var K=se.length;if(K===0)return"";for(var ne=0;ne<K;){var $e=se.charAt(K-ne-1);if($e===re&&!oe)ne++;else if($e!==re&&oe)ne++;else break}return se.slice(0,K-ne)}function k(se,re){if(se.indexOf(re[1])===-1)return-1;for(var oe=se.length,K=0,ne=0;ne<oe;ne++)if(se[ne]==="\\")ne++;else if(se[ne]===re[0])K++;else if(se[ne]===re[1]&&(K--,K<0))return ne;return-1}function P(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(se,re){if(re<1)return"";for(var oe="";re>1;)re&1&&(oe+=se),re>>=1,se+=se;return oe+se}function I(se,re,oe,K){var ne=re.href,$e=re.title?w(re.title):null,be=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){K.state.inLink=!0;var Ae={type:"link",raw:oe,href:ne,title:$e,text:be,tokens:K.inlineTokens(be)};return K.state.inLink=!1,Ae}return{type:"image",raw:oe,href:ne,title:$e,text:w(be)}}function T(se,re){var oe=se.match(/^(\s+)(?:```)/);if(oe===null)return re;var K=oe[1];return re.split(`
`).map(function(ne){var $e=ne.match(/^\s+/);if($e===null)return ne;var be=$e[0];return be.length>=K.length?ne.slice(K.length):ne}).join(`
`)}var j=function(){function se(oe){this.options=oe||le.defaults}var re=se.prototype;return re.space=function(K){var ne=this.rules.block.newline.exec(K);if(ne&&ne[0].length>0)return{type:"space",raw:ne[0]}},re.code=function(K){var ne=this.rules.block.code.exec(K);if(ne){var $e=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:p($e,`
`)}}},re.fences=function(K){var ne=this.rules.block.fences.exec(K);if(ne){var $e=ne[0],be=T($e,ne[3]||"");return{type:"code",raw:$e,lang:ne[2]?ne[2].trim():ne[2],text:be}}},re.heading=function(K){var ne=this.rules.block.heading.exec(K);if(ne){var $e=ne[2].trim();if(/#$/.test($e)){var be=p($e,"#");(this.options.pedantic||!be||/ $/.test(be))&&($e=be.trim())}return{type:"heading",raw:ne[0],depth:ne[1].length,text:$e,tokens:this.lexer.inline($e)}}},re.hr=function(K){var ne=this.rules.block.hr.exec(K);if(ne)return{type:"hr",raw:ne[0]}},re.blockquote=function(K){var ne=this.rules.block.blockquote.exec(K);if(ne){var $e=ne[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ne[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},re.list=function(K){var ne=this.rules.block.list.exec(K);if(ne){var $e,be,Ae,fe,Se,Ie,ze,V,W,J,Y,he,we=ne[1].trim(),je=we.length>1,qe={type:"list",raw:"",ordered:je,start:je?+we.slice(0,-1):"",loose:!1,items:[]};we=je?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=je?we:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(he=!1,!(!(ne=Ye.exec(K))||this.rules.block.hr.test(K)));){if($e=ne[0],K=K.substring($e.length),V=ne[2].split(`
`,1)[0],W=K.split(`
`,1)[0],this.options.pedantic?(fe=2,Y=V.trimLeft()):(fe=ne[2].search(/[^ ]/),fe=fe>4?1:fe,Y=V.slice(fe),fe+=ne[1].length),Ie=!1,!V&&/^ *$/.test(W)&&($e+=W+`
`,K=K.substring(W.length+1),he=!0),!he)for(var st=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,fe-1)+"}#");K&&(J=K.split(`
`,1)[0],V=J,this.options.pedantic&&(V=V.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(V)||ot.test(V)||st.test(V)||tt.test(K)));){if(V.search(/[^ ]/)>=fe||!V.trim())Y+=`
`+V.slice(fe);else if(!Ie)Y+=`
`+V;else break;!Ie&&!V.trim()&&(Ie=!0),$e+=J+`
`,K=K.substring(J.length+1)}qe.loose||(ze?qe.loose=!0:/\n *\n *$/.test($e)&&(ze=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(Y),be&&(Ae=be[0]!=="[ ] ",Y=Y.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:$e,task:!!be,checked:Ae,loose:!1,text:Y}),qe.raw+=$e}qe.items[qe.items.length-1].raw=$e.trimRight(),qe.items[qe.items.length-1].text=Y.trimRight(),qe.raw=qe.raw.trimRight();var De=qe.items.length;for(Se=0;Se<De;Se++){this.lexer.state.top=!1,qe.items[Se].tokens=this.lexer.blockTokens(qe.items[Se].text,[]);var Be=qe.items[Se].tokens.filter(function(Ne){return Ne.type==="space"}),Ge=Be.every(function(Ne){for(var Ze=Ne.raw.split(""),ae=0,ce=R(Ze),Re;!(Re=ce()).done;){var Ke=Re.value;if(Ke===`
`&&(ae+=1),ae>1)return!0}return!1});!qe.loose&&Be.length&&Ge&&(qe.loose=!0,qe.items[Se].loose=!0)}return qe}},re.html=function(K){var ne=this.rules.block.html.exec(K);if(ne){var $e={type:"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:ne[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(ne[0]):w(ne[0]);$e.type="paragraph",$e.text=be,$e.tokens=this.lexer.inline(be)}return $e}},re.def=function(K){var ne=this.rules.block.def.exec(K);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var $e=ne[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:ne[0],href:ne[2],title:ne[3]}}},re.table=function(K){var ne=this.rules.block.table.exec(K);if(ne){var $e={type:"table",header:S(ne[1]).map(function(ze){return{text:ze}}),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ne[3]&&ne[3].trim()?ne[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=ne[0];var be=$e.align.length,Ae,fe,Se,Ie;for(Ae=0;Ae<be;Ae++)/^ *-+: *$/.test($e.align[Ae])?$e.align[Ae]="right":/^ *:-+: *$/.test($e.align[Ae])?$e.align[Ae]="center":/^ *:-+ *$/.test($e.align[Ae])?$e.align[Ae]="left":$e.align[Ae]=null;for(be=$e.rows.length,Ae=0;Ae<be;Ae++)$e.rows[Ae]=S($e.rows[Ae],$e.header.length).map(function(ze){return{text:ze}});for(be=$e.header.length,fe=0;fe<be;fe++)$e.header[fe].tokens=this.lexer.inline($e.header[fe].text);for(be=$e.rows.length,fe=0;fe<be;fe++)for(Ie=$e.rows[fe],Se=0;Se<Ie.length;Se++)Ie[Se].tokens=this.lexer.inline(Ie[Se].text);return $e}}},re.lheading=function(K){var ne=this.rules.block.lheading.exec(K);if(ne)return{type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1],tokens:this.lexer.inline(ne[1])}},re.paragraph=function(K){var ne=this.rules.block.paragraph.exec(K);if(ne){var $e=ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1];return{type:"paragraph",raw:ne[0],text:$e,tokens:this.lexer.inline($e)}}},re.text=function(K){var ne=this.rules.block.text.exec(K);if(ne)return{type:"text",raw:ne[0],text:ne[0],tokens:this.lexer.inline(ne[0])}},re.escape=function(K){var ne=this.rules.inline.escape.exec(K);if(ne)return{type:"escape",raw:ne[0],text:w(ne[1])}},re.tag=function(K){var ne=this.rules.inline.tag.exec(K);if(ne)return!this.lexer.state.inLink&&/^<a /i.test(ne[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ne[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ne[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ne[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ne[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):w(ne[0]):ne[0]}},re.link=function(K){var ne=this.rules.inline.link.exec(K);if(ne){var $e=ne[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var be=p($e.slice(0,-1),"\\");if(($e.length-be.length)%2===0)return}else{var Ae=k(ne[2],"()");if(Ae>-1){var fe=ne[0].indexOf("!")===0?5:4,Se=fe+ne[1].length+Ae;ne[2]=ne[2].substring(0,Ae),ne[0]=ne[0].substring(0,Se).trim(),ne[3]=""}}var Ie=ne[2],ze="";if(this.options.pedantic){var V=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);V&&(Ie=V[1],ze=V[3])}else ze=ne[3]?ne[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test($e)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),I(ne,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},ne[0],this.lexer)}},re.reflink=function(K,ne){var $e;if(($e=this.rules.inline.reflink.exec(K))||($e=this.rules.inline.nolink.exec(K))){var be=($e[2]||$e[1]).replace(/\s+/g," ");if(be=ne[be.toLowerCase()],!be||!be.href){var Ae=$e[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return I($e,be,$e[0],this.lexer)}},re.emStrong=function(K,ne,$e){$e===void 0&&($e="");var be=this.rules.inline.emStrong.lDelim.exec(K);if(be&&!(be[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=be[1]||be[2]||"";if(!Ae||Ae&&($e===""||this.rules.inline.punctuation.exec($e))){var fe=be[0].length-1,Se,Ie,ze=fe,V=0,W=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(W.lastIndex=0,ne=ne.slice(-1*K.length+fe);(be=W.exec(ne))!=null;)if(Se=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!Se){if(Ie=Se.length,be[3]||be[4]){ze+=Ie;continue}else if((be[5]||be[6])&&fe%3&&!((fe+Ie)%3)){V+=Ie;continue}if(ze-=Ie,!(ze>0)){if(Ie=Math.min(Ie,Ie+ze+V),Math.min(fe,Ie)%2){var J=K.slice(1,fe+be.index+Ie);return{type:"em",raw:K.slice(0,fe+be.index+Ie+1),text:J,tokens:this.lexer.inlineTokens(J)}}var Y=K.slice(2,fe+be.index+Ie-1);return{type:"strong",raw:K.slice(0,fe+be.index+Ie+1),text:Y,tokens:this.lexer.inlineTokens(Y)}}}}}},re.codespan=function(K){var ne=this.rules.inline.code.exec(K);if(ne){var $e=ne[2].replace(/\n/g," "),be=/[^ ]/.test($e),Ae=/^ /.test($e)&&/ $/.test($e);return be&&Ae&&($e=$e.substring(1,$e.length-1)),$e=w($e,!0),{type:"codespan",raw:ne[0],text:$e}}},re.br=function(K){var ne=this.rules.inline.br.exec(K);if(ne)return{type:"br",raw:ne[0]}},re.del=function(K){var ne=this.rules.inline.del.exec(K);if(ne)return{type:"del",raw:ne[0],text:ne[2],tokens:this.lexer.inlineTokens(ne[2])}},re.autolink=function(K,ne){var $e=this.rules.inline.autolink.exec(K);if($e){var be,Ae;return $e[2]==="@"?(be=w(this.options.mangle?ne($e[1]):$e[1]),Ae="mailto:"+be):(be=w($e[1]),Ae=be),{type:"link",raw:$e[0],text:be,href:Ae,tokens:[{type:"text",raw:be,text:be}]}}},re.url=function(K,ne){var $e;if($e=this.rules.inline.url.exec(K)){var be,Ae;if($e[2]==="@")be=w(this.options.mangle?ne($e[0]):$e[0]),Ae="mailto:"+be;else{var fe;do fe=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(fe!==$e[0]);be=w($e[0]),$e[1]==="www."?Ae="http://"+be:Ae=be}return{type:"link",raw:$e[0],text:be,href:Ae,tokens:[{type:"text",raw:be,text:be}]}}},re.inlineText=function(K,ne){var $e=this.rules.inline.text.exec(K);if($e){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):w($e[0]):$e[0]:be=w(this.options.smartypants?ne($e[0]):$e[0]),{type:"text",raw:$e[0],text:be}}},se}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=f({},z),z.gfm=f({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=f({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=n(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=n(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=n(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=n(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=n(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=n(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=n(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=n(O.reflink).replace("label",O._label).replace("ref",z._label).getRegex(),O.nolink=n(O.nolink).replace("ref",z._label).getRegex(),O.reflinkSearch=n(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=f({},O),O.pedantic=f({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=f({},O.normal,{escape:n(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=n(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=f({},O.gfm,{br:n(O.br).replace("{2,}","*").getRegex(),text:n(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(se){var re="",oe,K,ne=se.length;for(oe=0;oe<ne;oe++)K=se.charCodeAt(oe),Math.random()>.5&&(K="x"+K.toString(16)),re+="&#"+K+";";return re}var Z=function(){function se(oe){this.tokens=[],this.tokens.links=Object.create(null),this.options=oe||le.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:z.normal,inline:O.normal};this.options.pedantic?(K.block=z.pedantic,K.inline=O.pedantic):this.options.gfm&&(K.block=z.gfm,this.options.breaks?K.inline=O.breaks:K.inline=O.gfm),this.tokenizer.rules=K}se.lex=function(K,ne){var $e=new se(ne);return $e.lex(K)},se.lexInline=function(K,ne){var $e=new se(ne);return $e.inlineTokens(K)};var re=se.prototype;return re.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var ne;ne=this.inlineQueue.shift();)this.inlineTokens(ne.src,ne.tokens);return this.tokens},re.blockTokens=function(K,ne){var $e=this;ne===void 0&&(ne=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(ze,V,W){return V+"    ".repeat(W.length)});for(var be,Ae,fe,Se;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(be=ze.call({lexer:$e},K,ne))?(K=K.substring(be.raw.length),ne.push(be),!0):!1}))){if(be=this.tokenizer.space(K)){K=K.substring(be.raw.length),be.raw.length===1&&ne.length>0?ne[ne.length-1].raw+=`
`:ne.push(be);continue}if(be=this.tokenizer.code(K)){K=K.substring(be.raw.length),Ae=ne[ne.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+be.raw,Ae.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ne.push(be);continue}if(be=this.tokenizer.fences(K)){K=K.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.heading(K)){K=K.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.hr(K)){K=K.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.blockquote(K)){K=K.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.list(K)){K=K.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.html(K)){K=K.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.def(K)){K=K.substring(be.raw.length),Ae=ne[ne.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+be.raw,Ae.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(K)){K=K.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.lheading(K)){K=K.substring(be.raw.length),ne.push(be);continue}if(fe=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,V=K.slice(1),W=void 0;$e.options.extensions.startBlock.forEach(function(J){W=J.call({lexer:this},V),typeof W=="number"&&W>=0&&(ze=Math.min(ze,W))}),ze<1/0&&ze>=0&&(fe=K.substring(0,ze+1))}(),this.state.top&&(be=this.tokenizer.paragraph(fe))){Ae=ne[ne.length-1],Se&&Ae.type==="paragraph"?(Ae.raw+=`
`+be.raw,Ae.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ne.push(be),Se=fe.length!==K.length,K=K.substring(be.raw.length);continue}if(be=this.tokenizer.text(K)){K=K.substring(be.raw.length),Ae=ne[ne.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+be.raw,Ae.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):ne.push(be);continue}if(K){var Ie="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,ne},re.inline=function(K,ne){return ne===void 0&&(ne=[]),this.inlineQueue.push({src:K,tokens:ne}),ne},re.inlineTokens=function(K,ne){var $e=this;ne===void 0&&(ne=[]);var be,Ae,fe,Se=K,Ie,ze,V;if(this.tokens.links){var W=Object.keys(this.tokens.links);if(W.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(Se))!=null;)W.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(Se=Se.slice(0,Ie.index)+"["+C("a",Ie[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(Se))!=null;)Se=Se.slice(0,Ie.index)+"["+C("a",Ie[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(Se))!=null;)Se=Se.slice(0,Ie.index)+"++"+Se.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(ze||(V=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Y){return(be=Y.call({lexer:$e},K,ne))?(K=K.substring(be.raw.length),ne.push(be),!0):!1}))){if(be=this.tokenizer.escape(K)){K=K.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.tag(K)){K=K.substring(be.raw.length),Ae=ne[ne.length-1],Ae&&be.type==="text"&&Ae.type==="text"?(Ae.raw+=be.raw,Ae.text+=be.text):ne.push(be);continue}if(be=this.tokenizer.link(K)){K=K.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(be.raw.length),Ae=ne[ne.length-1],Ae&&be.type==="text"&&Ae.type==="text"?(Ae.raw+=be.raw,Ae.text+=be.text):ne.push(be);continue}if(be=this.tokenizer.emStrong(K,Se,V)){K=K.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.codespan(K)){K=K.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.br(K)){K=K.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.del(K)){K=K.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.autolink(K,B)){K=K.substring(be.raw.length),ne.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(K,B))){K=K.substring(be.raw.length),ne.push(be);continue}if(fe=K,this.options.extensions&&this.options.extensions.startInline&&function(){var Y=1/0,he=K.slice(1),we=void 0;$e.options.extensions.startInline.forEach(function(je){we=je.call({lexer:this},he),typeof we=="number"&&we>=0&&(Y=Math.min(Y,we))}),Y<1/0&&Y>=0&&(fe=K.substring(0,Y+1))}(),be=this.tokenizer.inlineText(fe,F)){K=K.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(V=be.raw.slice(-1)),ze=!0,Ae=ne[ne.length-1],Ae&&Ae.type==="text"?(Ae.raw+=be.raw,Ae.text+=be.text):ne.push(be);continue}if(K){var J="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return ne},d(se,null,[{key:"rules",get:function(){return{block:z,inline:O}}}]),se}(),q=function(){function se(oe){this.options=oe||le.defaults}var re=se.prototype;return re.code=function(K,ne,$e){var be=(ne||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(K,be);Ae!=null&&Ae!==K&&($e=!0,K=Ae)}return K=K.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+w(be,!0)+'">'+($e?K:w(K,!0))+`</code></pre>
`:"<pre><code>"+($e?K:w(K,!0))+`</code></pre>
`},re.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},re.html=function(K){return K},re.heading=function(K,ne,$e,be){if(this.options.headerIds){var Ae=this.options.headerPrefix+be.slug($e);return"<h"+ne+' id="'+Ae+'">'+K+"</h"+ne+`>
`}return"<h"+ne+">"+K+"</h"+ne+`>
`},re.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},re.list=function(K,ne,$e){var be=ne?"ol":"ul",Ae=ne&&$e!==1?' start="'+$e+'"':"";return"<"+be+Ae+`>
`+K+"</"+be+`>
`},re.listitem=function(K){return"<li>"+K+`</li>
`},re.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},re.paragraph=function(K){return"<p>"+K+`</p>
`},re.table=function(K,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+ne+`</table>
`},re.tablerow=function(K){return`<tr>
`+K+`</tr>
`},re.tablecell=function(K,ne){var $e=ne.header?"th":"td",be=ne.align?"<"+$e+' align="'+ne.align+'">':"<"+$e+">";return be+K+("</"+$e+`>
`)},re.strong=function(K){return"<strong>"+K+"</strong>"},re.em=function(K){return"<em>"+K+"</em>"},re.codespan=function(K){return"<code>"+K+"</code>"},re.br=function(){return this.options.xhtml?"<br/>":"<br>"},re.del=function(K){return"<del>"+K+"</del>"},re.link=function(K,ne,$e){if(K=o(this.options.sanitize,this.options.baseUrl,K),K===null)return $e;var be='<a href="'+w(K)+'"';return ne&&(be+=' title="'+ne+'"'),be+=">"+$e+"</a>",be},re.image=function(K,ne,$e){if(K=o(this.options.sanitize,this.options.baseUrl,K),K===null)return $e;var be='<img src="'+K+'" alt="'+$e+'"';return ne&&(be+=' title="'+ne+'"'),be+=this.options.xhtml?"/>":">",be},re.text=function(K){return K},se}(),Q=function(){function se(){}var re=se.prototype;return re.strong=function(K){return K},re.em=function(K){return K},re.codespan=function(K){return K},re.del=function(K){return K},re.html=function(K){return K},re.text=function(K){return K},re.link=function(K,ne,$e){return""+$e},re.image=function(K,ne,$e){return""+$e},re.br=function(){return""},se}(),x=function(){function se(){this.seen={}}var re=se.prototype;return re.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},re.getNextSafeSlug=function(K,ne){var $e=K,be=0;if(this.seen.hasOwnProperty($e)){be=this.seen[K];do be++,$e=K+"-"+be;while(this.seen.hasOwnProperty($e))}return ne||(this.seen[K]=be,this.seen[$e]=0),$e},re.slug=function(K,ne){ne===void 0&&(ne={});var $e=this.serialize(K);return this.getNextSafeSlug($e,ne.dryrun)},se}(),X=function(){function se(oe){this.options=oe||le.defaults,this.options.renderer=this.options.renderer||new q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Q,this.slugger=new x}se.parse=function(K,ne){var $e=new se(ne);return $e.parse(K)},se.parseInline=function(K,ne){var $e=new se(ne);return $e.parseInline(K)};var re=se.prototype;return re.parse=function(K,ne){ne===void 0&&(ne=!0);var $e="",be,Ae,fe,Se,Ie,ze,V,W,J,Y,he,we,je,qe,Ye,st,tt,nt,ot,De=K.length;for(be=0;be<De;be++){if(Y=K[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Y.type]&&(ot=this.options.extensions.renderers[Y.type].call({parser:this},Y),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Y.type))){$e+=ot||"";continue}switch(Y.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(Y.tokens),Y.depth,g(this.parseInline(Y.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(Y.text,Y.lang,Y.escaped);continue}case"table":{for(W="",V="",Se=Y.header.length,Ae=0;Ae<Se;Ae++)V+=this.renderer.tablecell(this.parseInline(Y.header[Ae].tokens),{header:!0,align:Y.align[Ae]});for(W+=this.renderer.tablerow(V),J="",Se=Y.rows.length,Ae=0;Ae<Se;Ae++){for(ze=Y.rows[Ae],V="",Ie=ze.length,fe=0;fe<Ie;fe++)V+=this.renderer.tablecell(this.parseInline(ze[fe].tokens),{header:!1,align:Y.align[fe]});J+=this.renderer.tablerow(V)}$e+=this.renderer.table(W,J);continue}case"blockquote":{J=this.parse(Y.tokens),$e+=this.renderer.blockquote(J);continue}case"list":{for(he=Y.ordered,we=Y.start,je=Y.loose,Se=Y.items.length,J="",Ae=0;Ae<Se;Ae++)Ye=Y.items[Ae],st=Ye.checked,tt=Ye.task,qe="",Ye.task&&(nt=this.renderer.checkbox(st),je?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=nt+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=nt+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:nt}):qe+=nt),qe+=this.parse(Ye.tokens,je),J+=this.renderer.listitem(qe,tt,st);$e+=this.renderer.list(J,he,we);continue}case"html":{$e+=this.renderer.html(Y.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(Y.tokens));continue}case"text":{for(J=Y.tokens?this.parseInline(Y.tokens):Y.text;be+1<De&&K[be+1].type==="text";)Y=K[++be],J+=`
`+(Y.tokens?this.parseInline(Y.tokens):Y.text);$e+=ne?this.renderer.paragraph(J):J;continue}default:{var Be='Token with "'+Y.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return $e},re.parseInline=function(K,ne){ne=ne||this.renderer;var $e="",be,Ae,fe,Se=K.length;for(be=0;be<Se;be++){if(Ae=K[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(fe=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){$e+=fe||"";continue}switch(Ae.type){case"escape":{$e+=ne.text(Ae.text);break}case"html":{$e+=ne.html(Ae.text);break}case"link":{$e+=ne.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,ne));break}case"image":{$e+=ne.image(Ae.href,Ae.title,Ae.text);break}case"strong":{$e+=ne.strong(this.parseInline(Ae.tokens,ne));break}case"em":{$e+=ne.em(this.parseInline(Ae.tokens,ne));break}case"codespan":{$e+=ne.codespan(Ae.text);break}case"br":{$e+=ne.br();break}case"del":{$e+=ne.del(this.parseInline(Ae.tokens,ne));break}case"text":{$e+=ne.text(Ae.text);break}default:{var Ie='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return $e},se}();function ie(se,re,oe){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof re=="function"&&(oe=re,re=null),re=f({},ie.defaults,re||{}),P(re),oe){var K=re.highlight,ne;try{ne=Z.lex(se,re)}catch(Se){return oe(Se)}var $e=function(Ie){var ze;if(!Ie)try{re.walkTokens&&ie.walkTokens(ne,re.walkTokens),ze=X.parse(ne,re)}catch(V){Ie=V}return re.highlight=K,Ie?oe(Ie):oe(null,ze)};if(!K||K.length<3||(delete re.highlight,!ne.length))return $e();var be=0;ie.walkTokens(ne,function(Se){Se.type==="code"&&(be++,setTimeout(function(){K(Se.text,Se.lang,function(Ie,ze){if(Ie)return $e(Ie);ze!=null&&ze!==Se.text&&(Se.text=ze,Se.escaped=!0),be--,be===0&&$e()})},0))}),be===0&&$e();return}function Ae(Se){if(Se.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+w(Se.message+"",!0)+"</pre>";throw Se}try{var fe=Z.lex(se,re);if(re.walkTokens){if(re.async)return Promise.all(ie.walkTokens(fe,re.walkTokens)).then(function(){return X.parse(fe,re)}).catch(Ae);ie.walkTokens(fe,re.walkTokens)}return X.parse(fe,re)}catch(Se){Ae(Se)}}ie.options=ie.setOptions=function(se){return f(ie.defaults,se),b(ie.defaults),ie},ie.getDefaults=M,ie.defaults=le.defaults,ie.use=function(){for(var se=arguments.length,re=new Array(se),oe=0;oe<se;oe++)re[oe]=arguments[oe];var K=f.apply(void 0,[{}].concat(re)),ne=ie.defaults.extensions||{renderers:{},childTokens:{}},$e;re.forEach(function(be){if(be.extensions&&($e=!0,be.extensions.forEach(function(fe){if(!fe.name)throw new Error("extension name required");if(fe.renderer){var Se=ne.renderers?ne.renderers[fe.name]:null;Se?ne.renderers[fe.name]=function(){for(var Ie=arguments.length,ze=new Array(Ie),V=0;V<Ie;V++)ze[V]=arguments[V];var W=fe.renderer.apply(this,ze);return W===!1&&(W=Se.apply(this,ze)),W}:ne.renderers[fe.name]=fe.renderer}if(fe.tokenizer){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ne[fe.level]?ne[fe.level].unshift(fe.tokenizer):ne[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?ne.startBlock?ne.startBlock.push(fe.start):ne.startBlock=[fe.start]:fe.level==="inline"&&(ne.startInline?ne.startInline.push(fe.start):ne.startInline=[fe.start]))}fe.childTokens&&(ne.childTokens[fe.name]=fe.childTokens)})),be.renderer&&function(){var fe=ie.defaults.renderer||new q,Se=function(V){var W=fe[V];fe[V]=function(){for(var J=arguments.length,Y=new Array(J),he=0;he<J;he++)Y[he]=arguments[he];var we=be.renderer[V].apply(fe,Y);return we===!1&&(we=W.apply(fe,Y)),we}};for(var Ie in be.renderer)Se(Ie);K.renderer=fe}(),be.tokenizer&&function(){var fe=ie.defaults.tokenizer||new j,Se=function(V){var W=fe[V];fe[V]=function(){for(var J=arguments.length,Y=new Array(J),he=0;he<J;he++)Y[he]=arguments[he];var we=be.tokenizer[V].apply(fe,Y);return we===!1&&(we=W.apply(fe,Y)),we}};for(var Ie in be.tokenizer)Se(Ie);K.tokenizer=fe}(),be.walkTokens){var Ae=ie.defaults.walkTokens;K.walkTokens=function(fe){var Se=[];return Se.push(be.walkTokens.call(this,fe)),Ae&&(Se=Se.concat(Ae.call(this,fe))),Se}}$e&&(K.extensions=ne),ie.setOptions(K)})},ie.walkTokens=function(se,re){for(var oe=[],K=function(){var Ae=$e.value;switch(oe=oe.concat(re.call(ie,Ae)),Ae.type){case"table":{for(var fe=R(Ae.header),Se;!(Se=fe()).done;){var Ie=Se.value;oe=oe.concat(ie.walkTokens(Ie.tokens,re))}for(var ze=R(Ae.rows),V;!(V=ze()).done;)for(var W=V.value,J=R(W),Y;!(Y=J()).done;){var he=Y.value;oe=oe.concat(ie.walkTokens(he.tokens,re))}break}case"list":{oe=oe.concat(ie.walkTokens(Ae.items,re));break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[Ae.type]?ie.defaults.extensions.childTokens[Ae.type].forEach(function(we){oe=oe.concat(ie.walkTokens(Ae[we],re))}):Ae.tokens&&(oe=oe.concat(ie.walkTokens(Ae.tokens,re)))}},ne=R(se),$e;!($e=ne()).done;)K();return oe},ie.parseInline=function(se,re){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");re=f({},ie.defaults,re||{}),P(re);try{var oe=Z.lexInline(se,re);return re.walkTokens&&ie.walkTokens(oe,re.walkTokens),X.parseInline(oe,re)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+w(K.message+"",!0)+"</pre>";throw K}},ie.Parser=X,ie.parser=X.parse,ie.Renderer=q,ie.TextRenderer=Q,ie.Lexer=Z,ie.lexer=Z.lex,ie.Tokenizer=j,ie.Slugger=x,ie.parse=ie;var me=ie.options,ue=ie.setOptions,ve=ie.use,te=ie.walkTokens,U=ie.parseInline,ee=ie,pe=X.parse,Ce=Z.lex;le.Lexer=Z,le.Parser=X,le.Renderer=q,le.Slugger=x,le.TextRenderer=Q,le.Tokenizer=j,le.getDefaults=M,le.lexer=Ce,le.marked=ie,le.options=me,le.parse=ee,le.parseInline=U,le.parser=pe,le.setOptions=ue,le.use=ve,le.walkTokens=te,Object.defineProperty(le,"__esModule",{value:!0})}),define(ke[168],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=d;function d(h){const g=R(h);if(g&&g.length>0)return new Uint32Array(g)}let N=0;const L=new Uint32Array(10);function R(h){if(N=0,M(h,D,4352),N>0||(M(h,$,4449),N>0)||(M(h,y,4520),N>0)||(M(h,w,12593),N))return L.subarray(0,N);if(h>=44032&&h<=55203){const g=h-44032,a=g%588,n=Math.floor(g/588),i=Math.floor(a/28),u=a%28-1;if(n<D.length?M(n,D,0):4352+n-12593<w.length&&M(4352+n,w,12593),i<$.length?M(i,$,0):4449+i-12593<w.length&&M(4449+i-12593,w,12593),u>=0&&(u<y.length?M(u,y,0):4520+u-12593<w.length&&M(4520+u-12593,w,12593)),N>0)return L.subarray(0,N)}}function M(h,g,a){h>=a&&h<a+g.length&&b(g[h-a])}function b(h){h!==0&&(L[N++]=h&255,h>>8&&(L[N++]=h>>8&255),h>>16&&(L[N++]=h>>16&255))}var m;(function(h){h[h.InitialConsonant=4352]="InitialConsonant",h[h.Vowel=4449]="Vowel",h[h.FinalConsonant=4520]="FinalConsonant",h[h.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var E;(function(h){h[h.NUL=0]="NUL",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z"})(E||(E={}));var A;(function(h){h[h.fa=24934]="fa",h[h.fg=26470]="fg",h[h.fq=29030]="fq",h[h.fr=29286]="fr",h[h.ft=29798]="ft",h[h.fv=30310]="fv",h[h.fx=30822]="fx",h[h.hk=27496]="hk",h[h.hl=27752]="hl",h[h.ho=28520]="ho",h[h.ml=27757]="ml",h[h.nj=27246]="nj",h[h.nl=27758]="nl",h[h.np=28782]="np",h[h.qt=29809]="qt",h[h.rt=29810]="rt",h[h.sg=26483]="sg",h[h.sw=30579]="sw"})(A||(A={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),$=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),y=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),w=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[77],Pe([1,0,27]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=void 0,e.$am=L,e.$bm=M;const N=new d.$Ec(1e4);function L(E){return m(E,"NFC",N)}const R=new d.$Ec(1e4);function M(E){return m(E,"NFD",R)}const b=/[^\u0000-\u0080]/;function m(E,A,D){if(!E)return E;const $=D.get(E);if($)return $;let y;return b.test(E)?y=E.normalize(A):y=E,D.set(E,y),y}e.$cm=function(){const E=/[\u0300-\u036f]/g;return function(A){return M(A).replace(E,"")}}()}),define(ke[126],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=void 0,e.$Am=d,e.rot=N;function d(b,m,E){return Math.min(Math.max(b,m),E)}function N(b,m){return(m+b%m)%m}class L{constructor(){this.a=0}getNext(){return this.a++}}e.$Cm=L;class R{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Dm=R;class M{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const E=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Em=M}),define(ke[169],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=R,e.$dd=$;class d{constructor(w,h,g){this.owner=w,this.debugNameSource=h,this.referenceFn=g}getDebugName(w){return R(w,this)}}e.$bd=d;const N=new Map,L=new WeakMap;function R(y,w){const h=L.get(y);if(h)return h;const g=M(y,w);if(g){let a=N.get(g)??0;a++,N.set(g,a);const n=a===1?g:`${g}#${a}`;return L.set(y,n),n}}function M(y,w){const h=L.get(y);if(h)return h;const g=w.owner?A(w.owner)+".":"";let a;const n=w.debugNameSource;if(n!==void 0)if(typeof n=="function"){if(a=n(),a!==void 0)return g+a}else return g+n;const i=w.referenceFn;if(i!==void 0&&(a=$(i),a!==void 0))return g+a;if(w.owner!==void 0){const u=b(w.owner,y);if(u!==void 0)return g+u}}function b(y,w){for(const h in y)if(y[h]===w)return h}const m=new Map,E=new WeakMap;function A(y){const w=E.get(y);if(w)return w;const h=D(y);let g=m.get(h)??0;g++,m.set(h,g);const a=g===1?h:`${h}#${g}`;return E.set(y,a),a}function D(y){const w=y.constructor;return w?w.name:"Object"}function $(y){const w=y.toString(),g=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(w);return(g?g[1]:void 0)?.trim()}}),define(ke[170],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=N,e.$Jd=L;let d;function N(h){d=h}function L(){return d}class R{constructor(){this.a=0,this.d=new WeakMap}b(g){return M([b(y("|  ",this.a)),g])}c(g){return g.hadValue?g.didChange?[b(" "),E(A(g.oldValue,70),{color:"red",strikeThrough:!0}),b(" "),E(A(g.newValue,60),{color:"green"})]:[b(" (unchanged)")]:[b(" "),E(A(g.newValue,60),{color:"green"}),b(" (initial)")]}handleObservableChanged(g,a){console.log(...this.b([m("observable value changed"),E(g.debugName,{color:"BlueViolet"}),...this.c(a)]))}formatChanges(g){if(g.size!==0)return E(" (changed deps: "+[...g].map(a=>a.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(g){const a=g.handleChange;this.d.set(g,new Set),g.handleChange=(n,i)=>(this.d.get(g).add(n),a.apply(g,[n,i]))}handleDerivedRecomputed(g,a){const n=this.d.get(g);console.log(...this.b([m("derived recomputed"),E(g.debugName,{color:"BlueViolet"}),...this.c(a),this.formatChanges(n),{data:[{fn:g._computeFn}]}])),n.clear()}handleFromEventObservableTriggered(g,a){console.log(...this.b([m("observable from event triggered"),E(g.debugName,{color:"BlueViolet"}),...this.c(a),{data:[{fn:g._getValue}]}]))}handleAutorunCreated(g){const a=g.handleChange;this.d.set(g,new Set),g.handleChange=(n,i)=>(this.d.get(g).add(n),a.apply(g,[n,i]))}handleAutorunTriggered(g){const a=this.d.get(g);console.log(...this.b([m("autorun"),E(g.debugName,{color:"BlueViolet"}),this.formatChanges(a),{data:[{fn:g._runFn}]}])),a.clear(),this.a++}handleAutorunFinished(g){this.a--}handleBeginTransaction(g){let a=g.getDebugName();a===void 0&&(a=""),console.log(...this.b([m("transaction"),E(a,{color:"BlueViolet"}),{data:[{fn:g._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=R;function M(h){const g=new Array,a=[];let n="";function i(o){if("length"in o)for(const t of o)t&&i(t);else"text"in o?(n+=`%c${o.text}`,g.push(o.style),o.data&&a.push(...o.data)):"data"in o&&a.push(...o.data)}i(h);const u=[n,...g];return u.push(...a),u}function b(h){return E(h,{color:"black"})}function m(h){return E(w(`${h}: `,10),{color:"black",bold:!0})}function E(h,g={color:"black"}){function a(i){return Object.entries(i).reduce((u,[o,t])=>`${u}${o}:${t};`,"")}const n={color:g.color};return g.strikeThrough&&(n["text-decoration"]="line-through"),g.bold&&(n["font-weight"]="bold"),{text:h,style:a(n)}}function A(h,g){switch(typeof h){case"number":return""+h;case"string":return h.length+2<=g?`"${h}"`:`"${h.substr(0,g-7)}"+...`;case"boolean":return h?"true":"false";case"undefined":return"undefined";case"object":return h===null?"null":Array.isArray(h)?D(h,g):$(h,g);case"symbol":return h.toString();case"function":return`[[Function${h.name?" "+h.name:""}]]`;default:return""+h}}function D(h,g){let a="[ ",n=!0;for(const i of h){if(n||(a+=", "),a.length-5>g){a+="...";break}n=!1,a+=`${A(i,g-a.length)}`}return a+=" ]",a}function $(h,g){let a="{ ",n=!0;for(const[i,u]of Object.entries(h)){if(n||(a+=", "),a.length-5>g){a+="...";break}n=!1,a+=`${i}: ${A(u,g-a.length)}`}return a+=" }",a}function y(h,g){let a="";for(let n=1;n<=g;n++)a+=h;return a}function w(h,g){for(;h.length<g;)h+=" ";return h}}),define(ke[171],Pe([1,0,165,169,170]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$4d=e.$1d=e.$Vd=e.$Ud=void 0,e.$Rd=M,e.$Sd=m,e.$Td=A,e.$Wd=y,e.$Xd=h,e.$Yd=g,e.$Zd=a,e.$2d=i,e.$3d=u,e.$5d=t;let R;function M(r){R=r}let b;function m(r){b=r}let E;function A(r){E=r}class D{get TChange(){return null}reportChanges(){this.get()}read(c){return c?c.readObservable(this):this.get()}map(c,s){const v=s===void 0?void 0:c,f=s===void 0?c:s;return E({owner:v,debugName:()=>{const S=(0,N.$dd)(f);if(S!==void 0)return S;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(f.toString());if(k)return`${this.debugName}.${k[2]}`;if(!v)return`${this.debugName} (mapped)`},debugReferenceFn:f},S=>f(this.read(S),S))}recomputeInitiallyAndOnChange(c,s){return c.add(R(this,s)),this}keepObserved(c){return c.add(b(this)),this}get a(){return this.get()}}e.$Ud=D;class $ extends D{constructor(){super(...arguments),this.b=new Set}addObserver(c){const s=this.b.size;this.b.add(c),s===0&&this.c()}removeObserver(c){this.b.delete(c)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Vd=$;function y(r,c){const s=new n(r,c);try{r(s)}finally{s.finish()}}let w;function h(r){if(w)r(w);else{const c=new n(r,void 0);w=c;try{r(c)}finally{c.finish(),w=void 0}}}async function g(r,c){const s=new n(r,c);try{await r(s)}finally{s.finish()}}function a(r,c,s){r?c(r):y(c,s)}class n{constructor(c,s){this._fn=c,this.b=s,this.a=[],(0,L.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,N.$dd)(this._fn)}updateObserver(c,s){this.a.push({observer:c,observable:s}),c.beginUpdate(s)}finish(){const c=this.a;for(let s=0;s<c.length;s++){const{observer:v,observable:f}=c[s];v.endUpdate(f)}this.a=null,(0,L.$Jd)()?.handleEndTransaction()}}e.$1d=n;function i(r,c){let s;return typeof r=="string"?s=new N.$bd(void 0,r,void 0):s=new N.$bd(r,void 0,void 0),new o(s,c,d.$7c)}function u(r,c){return new o(new N.$bd(r.owner,r.debugName,void 0),c,r.equalsFn??d.$7c)}class o extends ${get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(c,s,v){super(),this.e=c,this.g=v,this.d=s}get(){return this.d}set(c,s,v){if(this.g(this.d,c))return;let f;s||(s=f=new n(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.d;this.h(c),(0,L.$Jd)()?.handleObservableChanged(this,{oldValue:S,newValue:c,change:v,didChange:!0,hadValue:!0});for(const p of this.b)s.updateObserver(p,this),p.handleChange(this,v)}finally{f&&f.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(c){this.d=c}}e.$4d=o;function t(r,c){let s;return typeof r=="string"?s=new N.$bd(void 0,r,void 0):s=new N.$bd(r,void 0,void 0),new l(s,c,d.$7c)}class l extends o{h(c){this.d!==c&&(this.d&&this.d.dispose(),this.d=c)}dispose(){this.d?.dispose()}}e.$6d=l}),function(){function le(L){const R=[];typeof L=="number"&&R.push("code/timeOrigin",L);function M(m){R.push(m,Date.now())}function b(){const m=[];for(let E=0;E<R.length;E+=2)m.push({name:R[E],startTime:R[E+1]});return m}return{mark:M,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(L+M.startTime)});return R}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function d(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=d(N))}(),define(ke[172],Pe([1,0,39]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dP=void 0;const N=Symbol("unset");class L{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||d.Iterable.empty()}insert(m,E,A){this.d(m,D=>D._value=E,A)}mutate(m,E){this.d(m,A=>A._value=E(A._value===N?void 0:A._value))}delete(m){const E=this.c(m);if(!E)return;let A=E.length-1;const D=E[A].node._value;if(D!==N){for(this.b--,E[A].node._value=N;A>0;A--){const{node:$,part:y}=E[A];if($.children?.size||$._value!==N)break;E[A-1].node.children.delete(y)}return D}}*deleteRecursive(m){const E=this.c(m);if(!E)return;const A=E[E.length-1].node;for(let D=E.length-1;D>0;D--){const $=E[D-1];if($.node.children.delete(E[D].part),$.node.children.size>0||$.node._value!==N)break}for(const D of R(A))D._value!==N&&(this.b--,yield D._value)}find(m){let E=this.a;for(const A of m){const D=E.children?.get(A);if(!D)return;E=D}return E._value===N?void 0:E._value}hasKeyOrParent(m){let E=this.a;for(const A of m){const D=E.children?.get(A);if(!D)return!1;if(D._value!==N)return!0;E=D}return!1}hasKeyOrChildren(m){let E=this.a;for(const A of m){const D=E.children?.get(A);if(!D)return!1;E=D}return!0}hasKey(m){let E=this.a;for(const A of m){const D=E.children?.get(A);if(!D)return!1;E=D}return E._value!==N}c(m){const E=[{part:"",node:this.a}];let A=0;for(const D of m){const $=E[A].node.children?.get(D);if(!$)return;E.push({part:D,node:$}),A++}return E}d(m,E,A){let D=this.a;for(const w of m){if(D.children)if(D.children.has(w))D=D.children.get(w);else{const h=new M;D.children.set(w,h),D=h}else{const h=new M;D.children=new Map([[w,h]]),D=h}A?.(D)}const $=D._value===N?0:1;E(D);const y=D._value===N?0:1;this.b+=y-$}*values(){for(const{_value:m}of R(this.a))m!==N&&(yield m)}}e.$dP=L;function*R(b){const m=[b];for(;m.length>0;){const E=m.pop();if(yield E,E.children)for(const A of E.children.values())m.push(A)}}class M{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value(m){this._value=m===void 0?N:m}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var d=e();for(var N in d)(typeof exports=="object"?exports:le)[N]=d[N]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function d(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return le[N].call(L.exports,L,L.exports,d),L.l=!0,L.exports}return d.m=le,d.c=e,d.d=function(N,L,R){d.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:R})},d.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},d.t=function(N,L){if(1&L&&(N=d(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var R=Object.create(null);if(d.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var M in N)d.d(R,M,function(b){return N[b]}.bind(null,M));return R},d.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return d.d(L,"a",L),L},d.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},d.p="",d(d.s=0)}([function(le,e,d){(function(N){var L;e=le.exports=ve,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],m=e.src=[],E=0,A=E++;m[A]="0|[1-9]\\d*";var D=E++;m[D]="[0-9]+";var $=E++;m[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=E++;m[y]="("+m[A]+")\\.("+m[A]+")\\.("+m[A]+")";var w=E++;m[w]="("+m[D]+")\\.("+m[D]+")\\.("+m[D]+")";var h=E++;m[h]="(?:"+m[A]+"|"+m[$]+")";var g=E++;m[g]="(?:"+m[D]+"|"+m[$]+")";var a=E++;m[a]="(?:-("+m[h]+"(?:\\."+m[h]+")*))";var n=E++;m[n]="(?:-?("+m[g]+"(?:\\."+m[g]+")*))";var i=E++;m[i]="[0-9A-Za-z-]+";var u=E++;m[u]="(?:\\+("+m[i]+"(?:\\."+m[i]+")*))";var o=E++,t="v?"+m[y]+m[a]+"?"+m[u]+"?";m[o]="^"+t+"$";var l="[v=\\s]*"+m[w]+m[n]+"?"+m[u]+"?",r=E++;m[r]="^"+l+"$";var c=E++;m[c]="((?:<|>)?=?)";var s=E++;m[s]=m[D]+"|x|X|\\*";var v=E++;m[v]=m[A]+"|x|X|\\*";var f=E++;m[f]="[v=\\s]*("+m[v]+")(?:\\.("+m[v]+")(?:\\.("+m[v]+")(?:"+m[a]+")?"+m[u]+"?)?)?";var S=E++;m[S]="[v=\\s]*("+m[s]+")(?:\\.("+m[s]+")(?:\\.("+m[s]+")(?:"+m[n]+")?"+m[u]+"?)?)?";var p=E++;m[p]="^"+m[c]+"\\s*"+m[f]+"$";var k=E++;m[k]="^"+m[c]+"\\s*"+m[S]+"$";var P=E++;m[P]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=E++;m[C]="(?:~>?)";var I=E++;m[I]="(\\s*)"+m[C]+"\\s+",b[I]=new RegExp(m[I],"g");var T=E++;m[T]="^"+m[C]+m[f]+"$";var j=E++;m[j]="^"+m[C]+m[S]+"$";var z=E++;m[z]="(?:\\^)";var O=E++;m[O]="(\\s*)"+m[z]+"\\s+",b[O]=new RegExp(m[O],"g");var F=E++;m[F]="^"+m[z]+m[f]+"$";var B=E++;m[B]="^"+m[z]+m[S]+"$";var Z=E++;m[Z]="^"+m[c]+"\\s*("+l+")$|^$";var q=E++;m[q]="^"+m[c]+"\\s*("+t+")$|^$";var Q=E++;m[Q]="(\\s*)"+m[c]+"\\s*("+l+"|"+m[f]+")",b[Q]=new RegExp(m[Q],"g");var x=E++;m[x]="^\\s*("+m[f]+")\\s+-\\s+("+m[f]+")\\s*$";var X=E++;m[X]="^\\s*("+m[S]+")\\s+-\\s+("+m[S]+")\\s*$";var ie=E++;m[ie]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)L(me,m[me]),b[me]||(b[me]=new RegExp(m[me]));function ue(W,J){if(W instanceof ve)return W;if(typeof W!="string"||W.length>R||!(J?b[r]:b[o]).test(W))return null;try{return new ve(W,J)}catch{return null}}function ve(W,J){if(W instanceof ve){if(W.loose===J)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ve))return new ve(W,J);L("SemVer",W,J),this.loose=J;var Y=W.trim().match(J?b[r]:b[o]);if(!Y)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+Y[1],this.minor=+Y[2],this.patch=+Y[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");Y[4]?this.prerelease=Y[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var we=+he;if(we>=0&&we<M)return we}return he}):this.prerelease=[],this.build=Y[5]?Y[5].split("."):[],this.format()}e.parse=ue,e.valid=function(W,J){var Y=ue(W,J);return Y?Y.version:null},e.clean=function(W,J){var Y=ue(W.trim().replace(/^[=v]+/,""),J);return Y?Y.version:null},e.SemVer=ve,ve.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ve.prototype.toString=function(){return this.version},ve.prototype.compare=function(W){return L("SemVer.compare",this.version,this.loose,W),W instanceof ve||(W=new ve(W,this.loose)),this.compareMain(W)||this.comparePre(W)},ve.prototype.compareMain=function(W){return W instanceof ve||(W=new ve(W,this.loose)),U(this.major,W.major)||U(this.minor,W.minor)||U(this.patch,W.patch)},ve.prototype.comparePre=function(W){if(W instanceof ve||(W=new ve(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var J=0;do{var Y=this.prerelease[J],he=W.prerelease[J];if(L("prerelease compare",J,Y,he),Y===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(Y===void 0)return-1;if(Y!==he)return U(Y,he)}while(++J)},ve.prototype.inc=function(W,J){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Y=this.prerelease.length;--Y>=0;)typeof this.prerelease[Y]=="number"&&(this.prerelease[Y]++,Y=-2);Y===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,J,Y,he){typeof Y=="string"&&(he=Y,Y=void 0);try{return new ve(W,Y).inc(J,he).version}catch{return null}},e.diff=function(W,J){if(se(W,J))return null;var Y=ue(W),he=ue(J);if(Y.prerelease.length||he.prerelease.length){for(var we in Y)if((we==="major"||we==="minor"||we==="patch")&&Y[we]!==he[we])return"pre"+we;return"prerelease"}for(var we in Y)if((we==="major"||we==="minor"||we==="patch")&&Y[we]!==he[we])return we},e.compareIdentifiers=U;var te=/^[0-9]+$/;function U(W,J){var Y=te.test(W),he=te.test(J);return Y&&he&&(W=+W,J=+J),Y&&!he?-1:he&&!Y?1:W<J?-1:W>J?1:0}function ee(W,J,Y){return new ve(W,Y).compare(new ve(J,Y))}function pe(W,J,Y){return ee(W,J,Y)>0}function Ce(W,J,Y){return ee(W,J,Y)<0}function se(W,J,Y){return ee(W,J,Y)===0}function re(W,J,Y){return ee(W,J,Y)!==0}function oe(W,J,Y){return ee(W,J,Y)>=0}function K(W,J,Y){return ee(W,J,Y)<=0}function ne(W,J,Y,he){var we;switch(J){case"===":typeof W=="object"&&(W=W.version),typeof Y=="object"&&(Y=Y.version),we=W===Y;break;case"!==":typeof W=="object"&&(W=W.version),typeof Y=="object"&&(Y=Y.version),we=W!==Y;break;case"":case"=":case"==":we=se(W,Y,he);break;case"!=":we=re(W,Y,he);break;case">":we=pe(W,Y,he);break;case">=":we=oe(W,Y,he);break;case"<":we=Ce(W,Y,he);break;case"<=":we=K(W,Y,he);break;default:throw new TypeError("Invalid operator: "+J)}return we}function $e(W,J){if(W instanceof $e){if(W.loose===J)return W;W=W.value}if(!(this instanceof $e))return new $e(W,J);L("comparator",W,J),this.loose=J,this.parse(W),this.semver===be?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(W,J){return U(J,W)},e.major=function(W,J){return new ve(W,J).major},e.minor=function(W,J){return new ve(W,J).minor},e.patch=function(W,J){return new ve(W,J).patch},e.compare=ee,e.compareLoose=function(W,J){return ee(W,J,!0)},e.rcompare=function(W,J,Y){return ee(J,W,Y)},e.sort=function(W,J){return W.sort(function(Y,he){return e.compare(Y,he,J)})},e.rsort=function(W,J){return W.sort(function(Y,he){return e.rcompare(Y,he,J)})},e.gt=pe,e.lt=Ce,e.eq=se,e.neq=re,e.gte=oe,e.lte=K,e.cmp=ne,e.Comparator=$e;var be={};function Ae(W,J){if(W instanceof Ae)return W.loose===J?W:new Ae(W.raw,J);if(W instanceof $e)return new Ae(W.value,J);if(!(this instanceof Ae))return new Ae(W,J);if(this.loose=J,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(Y){return this.parseRange(Y.trim())},this).filter(function(Y){return Y.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function fe(W){return!W||W.toLowerCase()==="x"||W==="*"}function Se(W,J,Y,he,we,je,qe,Ye,st,tt,nt,ot,De){return((J=fe(Y)?"":fe(he)?">="+Y+".0.0":fe(we)?">="+Y+"."+he+".0":">="+J)+" "+(Ye=fe(st)?"":fe(tt)?"<"+(+st+1)+".0.0":fe(nt)?"<"+st+"."+(+tt+1)+".0":ot?"<="+st+"."+tt+"."+nt+"-"+ot:"<="+Ye)).trim()}function Ie(W,J){for(var Y=0;Y<W.length;Y++)if(!W[Y].test(J))return!1;if(J.prerelease.length){for(Y=0;Y<W.length;Y++)if(L(W[Y].semver),W[Y].semver!==be&&W[Y].semver.prerelease.length>0){var he=W[Y].semver;if(he.major===J.major&&he.minor===J.minor&&he.patch===J.patch)return!0}return!1}return!0}function ze(W,J,Y){try{J=new Ae(J,Y)}catch{return!1}return J.test(W)}function V(W,J,Y,he){var we,je,qe,Ye,st;switch(W=new ve(W,he),J=new Ae(J,he),Y){case">":we=pe,je=K,qe=Ce,Ye=">",st=">=";break;case"<":we=Ce,je=oe,qe=pe,Ye="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(W,J,he))return!1;for(var tt=0;tt<J.set.length;++tt){var nt=J.set[tt],ot=null,De=null;if(nt.forEach(function(Be){Be.semver===be&&(Be=new $e(">=0.0.0")),ot=ot||Be,De=De||Be,we(Be.semver,ot.semver,he)?ot=Be:qe(Be.semver,De.semver,he)&&(De=Be)}),ot.operator===Ye||ot.operator===st||(!De.operator||De.operator===Ye)&&je(W,De.semver)||De.operator===st&&qe(W,De.semver))return!1}return!0}$e.prototype.parse=function(W){var J=this.loose?b[Z]:b[q],Y=W.match(J);if(!Y)throw new TypeError("Invalid comparator: "+W);this.operator=Y[1],this.operator==="="&&(this.operator=""),Y[2]?this.semver=new ve(Y[2],this.loose):this.semver=be},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(W){return L("Comparator.test",W,this.loose),this.semver===be||(typeof W=="string"&&(W=new ve(W,this.loose)),ne(W,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(W,J){if(!(W instanceof $e))throw new TypeError("a Comparator is required");var Y;if(this.operator==="")return Y=new Ae(W.value,J),ze(this.value,Y,J);if(W.operator==="")return Y=new Ae(this.value,J),ze(W.semver,Y,J);var he=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),je=this.semver.version===W.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Ye=ne(this.semver,"<",W.semver,J)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),st=ne(this.semver,">",W.semver,J)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return he||we||je&&qe||Ye||st},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(W){var J=this.loose;W=W.trim(),L("range",W,J);var Y=J?b[X]:b[x];W=W.replace(Y,Se),L("hyphen replace",W),W=W.replace(b[Q],"$1$2$3"),L("comparator trim",W,b[Q]),W=(W=(W=W.replace(b[I],"$1~")).replace(b[O],"$1^")).split(/\s+/).join(" ");var he=J?b[Z]:b[q],we=W.split(" ").map(function(je){return function(qe,Ye){return L("comp",qe),qe=function(st,tt){return st.trim().split(/\s+/).map(function(nt){return function(ot,De){L("caret",ot,De);var Be=De?b[B]:b[F];return ot.replace(Be,function(Ge,Ne,Ze,ae,ce){var Re;return L("caret",ot,Ge,Ne,Ze,ae,ce),fe(Ne)?Re="":fe(Ze)?Re=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":fe(ae)?Re=Ne==="0"?">="+Ne+"."+Ze+".0 <"+Ne+"."+(+Ze+1)+".0":">="+Ne+"."+Ze+".0 <"+(+Ne+1)+".0.0":ce?(L("replaceCaret pr",ce),ce.charAt(0)!=="-"&&(ce="-"+ce),Re=Ne==="0"?Ze==="0"?">="+Ne+"."+Ze+"."+ae+ce+" <"+Ne+"."+Ze+"."+(+ae+1):">="+Ne+"."+Ze+"."+ae+ce+" <"+Ne+"."+(+Ze+1)+".0":">="+Ne+"."+Ze+"."+ae+ce+" <"+(+Ne+1)+".0.0"):(L("no pr"),Re=Ne==="0"?Ze==="0"?">="+Ne+"."+Ze+"."+ae+" <"+Ne+"."+Ze+"."+(+ae+1):">="+Ne+"."+Ze+"."+ae+" <"+Ne+"."+(+Ze+1)+".0":">="+Ne+"."+Ze+"."+ae+" <"+(+Ne+1)+".0.0"),L("caret return",Re),Re})}(nt,tt)}).join(" ")}(qe,Ye),L("caret",qe),qe=function(st,tt){return st.trim().split(/\s+/).map(function(nt){return function(ot,De){var Be=De?b[j]:b[T];return ot.replace(Be,function(Ge,Ne,Ze,ae,ce){var Re;return L("tilde",ot,Ge,Ne,Ze,ae,ce),fe(Ne)?Re="":fe(Ze)?Re=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":fe(ae)?Re=">="+Ne+"."+Ze+".0 <"+Ne+"."+(+Ze+1)+".0":ce?(L("replaceTilde pr",ce),ce.charAt(0)!=="-"&&(ce="-"+ce),Re=">="+Ne+"."+Ze+"."+ae+ce+" <"+Ne+"."+(+Ze+1)+".0"):Re=">="+Ne+"."+Ze+"."+ae+" <"+Ne+"."+(+Ze+1)+".0",L("tilde return",Re),Re})}(nt,tt)}).join(" ")}(qe,Ye),L("tildes",qe),qe=function(st,tt){return L("replaceXRanges",st,tt),st.split(/\s+/).map(function(nt){return function(ot,De){ot=ot.trim();var Be=De?b[k]:b[p];return ot.replace(Be,function(Ge,Ne,Ze,ae,ce,Re){L("xRange",ot,Ge,Ne,Ze,ae,ce,Re);var Ke=fe(Ze),Me=Ke||fe(ae),it=Me||fe(ce);return Ne==="="&&it&&(Ne=""),Ke?Ge=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&it?(Me&&(ae=0),it&&(ce=0),Ne===">"?(Ne=">=",Me?(Ze=+Ze+1,ae=0,ce=0):it&&(ae=+ae+1,ce=0)):Ne==="<="&&(Ne="<",Me?Ze=+Ze+1:ae=+ae+1),Ge=Ne+Ze+"."+ae+"."+ce):Me?Ge=">="+Ze+".0.0 <"+(+Ze+1)+".0.0":it&&(Ge=">="+Ze+"."+ae+".0 <"+Ze+"."+(+ae+1)+".0"),L("xRange return",Ge),Ge})}(nt,tt)}).join(" ")}(qe,Ye),L("xrange",qe),qe=function(st,tt){return L("replaceStars",st,tt),st.trim().replace(b[ie],"")}(qe,Ye),L("stars",qe),qe}(je,J)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(je){return!!je.match(he)})),we=we.map(function(je){return new $e(je,J)})},Ae.prototype.intersects=function(W,J){if(!(W instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(Y){return Y.every(function(he){return W.set.some(function(we){return we.every(function(je){return he.intersects(je,J)})})})})},e.toComparators=function(W,J){return new Ae(W,J).set.map(function(Y){return Y.map(function(he){return he.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new ve(W,this.loose));for(var J=0;J<this.set.length;J++)if(Ie(this.set[J],W))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(W,J,Y){var he=null,we=null;try{var je=new Ae(J,Y)}catch{return null}return W.forEach(function(qe){je.test(qe)&&(he&&we.compare(qe)!==-1||(we=new ve(he=qe,Y)))}),he},e.minSatisfying=function(W,J,Y){var he=null,we=null;try{var je=new Ae(J,Y)}catch{return null}return W.forEach(function(qe){je.test(qe)&&(he&&we.compare(qe)!==1||(we=new ve(he=qe,Y)))}),he},e.validRange=function(W,J){try{return new Ae(W,J).range||"*"}catch{return null}},e.ltr=function(W,J,Y){return V(W,J,"<",Y)},e.gtr=function(W,J,Y){return V(W,J,">",Y)},e.outside=V,e.prerelease=function(W,J){var Y=ue(W,J);return Y&&Y.prerelease.length?Y.prerelease:null},e.intersects=function(W,J,Y){return W=new Ae(W,Y),J=new Ae(J,Y),W.intersects(J)},e.coerce=function(W){if(W instanceof ve)return W;if(typeof W!="string")return null;var J=W.match(b[P]);return J==null?null:ue((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,d(1))},function(le,e){var d,N,L=le.exports={};function R(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function b(g){if(d===setTimeout)return setTimeout(g,0);if((d===R||!d)&&setTimeout)return d=setTimeout,setTimeout(g,0);try{return d(g,0)}catch{try{return d.call(null,g,0)}catch{return d.call(this,g,0)}}}(function(){try{d=typeof setTimeout=="function"?setTimeout:R}catch{d=R}try{N=typeof clearTimeout=="function"?clearTimeout:M}catch{N=M}})();var m,E=[],A=!1,D=-1;function $(){A&&m&&(A=!1,m.length?E=m.concat(E):D=-1,E.length&&y())}function y(){if(!A){var g=b($);A=!0;for(var a=E.length;a;){for(m=E,E=[];++D<a;)m&&m[D].run();D=-1,a=E.length}m=null,A=!1,function(n){if(N===clearTimeout)return clearTimeout(n);if((N===M||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(n);try{N(n)}catch{try{return N.call(null,n)}catch{return N.call(this,n)}}}(g)}}function w(g,a){this.fun=g,this.array=a}function h(){}L.nextTick=function(g){var a=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)a[n-1]=arguments[n];E.push(new w(g,a)),E.length!==1||A||b(y)},w.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=h,L.addListener=h,L.once=h,L.off=h,L.removeListener=h,L.removeAllListeners=h,L.emit=h,L.prependListener=h,L.prependOnceListener=h,L.listeners=function(g){return[]},L.binding=function(g){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(g){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ke[40],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0;const d=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(R){return new N(R)}constructor(R){this.c=d&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ae=N}),define(ke[4],Pe([1,0,13,75,3,76,40]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$ce=e.Event=void 0,e.$de=y;const b=!1,m=!1,E=!1;var A;(function(I){I.None=()=>L.$Vc.None;function T(Ae){if(E){const{onDidAddListener:fe}=Ae,Se=h.create();let Ie=0;Ae.onDidAddListener=()=>{++Ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Se.print()),fe?.()}}}function j(Ae,fe){return ie(Ae,()=>{},0,void 0,!0,void 0,fe)}I.defer=j;function z(Ae){return(fe,Se=null,Ie)=>{let ze=!1,V;return V=Ae(W=>{if(!ze)return V?V.dispose():ze=!0,fe.call(Se,W)},null,Ie),ze&&V.dispose(),V}}I.once=z;function O(Ae,fe,Se){return x((Ie,ze=null,V)=>Ae(W=>Ie.call(ze,fe(W)),null,V),Se)}I.map=O;function F(Ae,fe,Se){return x((Ie,ze=null,V)=>Ae(W=>{fe(W),Ie.call(ze,W)},null,V),Se)}I.forEach=F;function B(Ae,fe,Se){return x((Ie,ze=null,V)=>Ae(W=>fe(W)&&Ie.call(ze,W),null,V),Se)}I.filter=B;function Z(Ae){return Ae}I.signal=Z;function q(...Ae){return(fe,Se=null,Ie)=>{const ze=(0,L.$Sc)(...Ae.map(V=>V(W=>fe.call(Se,W))));return X(ze,Ie)}}I.any=q;function Q(Ae,fe,Se,Ie){let ze=Se;return O(Ae,V=>(ze=fe(ze,V),ze),Ie)}I.reduce=Q;function x(Ae,fe){let Se;const Ie={onWillAddFirstListener(){Se=Ae(ze.fire,ze)},onDidRemoveLastListener(){Se?.dispose()}};fe||T(Ie);const ze=new o(Ie);return fe?.add(ze),ze.event}function X(Ae,fe){return fe instanceof Array?fe.push(Ae):fe&&fe.add(Ae),Ae}function ie(Ae,fe,Se=100,Ie=!1,ze=!1,V,W){let J,Y,he,we=0,je;const qe={leakWarningThreshold:V,onWillAddFirstListener(){J=Ae(st=>{we++,Y=fe(Y,st),Ie&&!he&&(Ye.fire(Y),Y=void 0),je=()=>{const tt=Y;Y=void 0,he=void 0,(!Ie||we>1)&&Ye.fire(tt),we=0},typeof Se=="number"?(clearTimeout(he),he=setTimeout(je,Se)):he===void 0&&(he=0,queueMicrotask(je))})},onWillRemoveListener(){ze&&we>0&&je?.()},onDidRemoveLastListener(){je=void 0,J.dispose()}};W||T(qe);const Ye=new o(qe);return W?.add(Ye),Ye.event}I.debounce=ie;function me(Ae,fe=0,Se){return I.debounce(Ae,(Ie,ze)=>Ie?(Ie.push(ze),Ie):[ze],fe,void 0,!0,void 0,Se)}I.accumulate=me;function ue(Ae,fe=(Ie,ze)=>Ie===ze,Se){let Ie=!0,ze;return B(Ae,V=>{const W=Ie||!fe(V,ze);return Ie=!1,ze=V,W},Se)}I.latch=ue;function ve(Ae,fe,Se){return[I.filter(Ae,fe,Se),I.filter(Ae,Ie=>!fe(Ie),Se)]}I.split=ve;function te(Ae,fe=!1,Se=[],Ie){let ze=Se.slice(),V=Ae(Y=>{ze?ze.push(Y):J.fire(Y)});Ie&&Ie.add(V);const W=()=>{ze?.forEach(Y=>J.fire(Y)),ze=null},J=new o({onWillAddFirstListener(){V||(V=Ae(Y=>J.fire(Y)),Ie&&Ie.add(V))},onDidAddFirstListener(){ze&&(fe?setTimeout(W):W())},onDidRemoveLastListener(){V&&V.dispose(),V=null}});return Ie&&Ie.add(J),J.event}I.buffer=te;function U(Ae,fe){return(Ie,ze,V)=>{const W=fe(new pe);return Ae(function(J){const Y=W.evaluate(J);Y!==ee&&Ie.call(ze,Y)},void 0,V)}}I.chain=U;const ee=Symbol("HaltChainable");class pe{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(Se=>(fe(Se),Se)),this}filter(fe){return this.f.push(Se=>fe(Se)?Se:ee),this}reduce(fe,Se){let Ie=Se;return this.f.push(ze=>(Ie=fe(Ie,ze),Ie)),this}latch(fe=(Se,Ie)=>Se===Ie){let Se=!0,Ie;return this.f.push(ze=>{const V=Se||!fe(ze,Ie);return Se=!1,Ie=ze,V?ze:ee}),this}evaluate(fe){for(const Se of this.f)if(fe=Se(fe),fe===ee)break;return fe}}function Ce(Ae,fe,Se=Ie=>Ie){const Ie=(...J)=>W.fire(Se(...J)),ze=()=>Ae.on(fe,Ie),V=()=>Ae.removeListener(fe,Ie),W=new o({onWillAddFirstListener:ze,onDidRemoveLastListener:V});return W.event}I.fromNodeEventEmitter=Ce;function se(Ae,fe,Se=Ie=>Ie){const Ie=(...J)=>W.fire(Se(...J)),ze=()=>Ae.addEventListener(fe,Ie),V=()=>Ae.removeEventListener(fe,Ie),W=new o({onWillAddFirstListener:ze,onDidRemoveLastListener:V});return W.event}I.fromDOMEventEmitter=se;function re(Ae){return new Promise(fe=>z(Ae)(fe))}I.toPromise=re;function oe(Ae){const fe=new o;return Ae.then(Se=>{fe.fire(Se)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}I.fromPromise=oe;function K(Ae,fe,Se){return fe(Se),Ae(Ie=>fe(Ie))}I.runAndSubscribe=K;class ne{constructor(fe,Se){this._observable=fe,this.f=0,this.g=!1;const Ie={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};Se||T(Ie),this.emitter=new o(Ie),Se&&Se.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,Se){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(Ae,fe){return new ne(Ae,fe).emitter.event}I.fromObservable=$e;function be(Ae){return(fe,Se,Ie)=>{let ze=0,V=!1;const W={beginUpdate(){ze++},endUpdate(){ze--,ze===0&&(Ae.reportChanges(),V&&(V=!1,fe.call(Se)))},handlePossibleChange(){},handleChange(){V=!0}};Ae.addObserver(W),Ae.reportChanges();const J={dispose(){Ae.removeObserver(W)}};return Ie instanceof L.$Uc?Ie.add(J):Array.isArray(Ie)&&Ie.push(J),J}}I.fromObservableLight=be})(A||(e.Event=A={}));class D{static{this.all=new Set}static{this.f=0}constructor(T){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${T}_${D.f++}`,D.all.add(this)}start(T){this.g=new M.$ae,this.listenerCount=T}stop(){if(this.g){const T=this.g.elapsed();this.durations.push(T),this.elapsedOverall+=T,this.invocationCount+=1,this.g=void 0}}}e.$ce=D;let $=-1;function y(I){const T=$;return $=I,{dispose(){$=T}}}class w{constructor(T,j=Math.random().toString(18).slice(2,5)){this.threshold=T,this.name=j,this.g=0}dispose(){this.f?.clear()}check(T,j){const z=this.threshold;if(z<=0||j<z)return;this.f||(this.f=new Map);const O=this.f.get(T.value)||0;if(this.f.set(T.value,O+1),this.g-=1,this.g<=0){this.g=z*.5;let F,B=0;for(const[Z,q]of this.f)(!F||B<q)&&(F=Z,B=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${j} listeners already. MOST frequent listener (${B}):`),console.warn(F)}return()=>{const F=this.f.get(T.value)||0;this.f.set(T.value,F-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(T){this.value=T}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let g=0;class a{constructor(T){this.value=T,this.id=g++}}const n=2,i=(I,T)=>{if(I instanceof a)T(I);else for(let j=0;j<I.length;j++){const z=I[j];z&&T(z)}},u=b?new FinalizationRegistry(I=>{typeof I=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(I))}):void 0;class o{constructor(T){this.w=0,this.f=T,this.g=$>0||this.f?.leakWarningThreshold?new w(this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new D(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(m){const T=this.t;queueMicrotask(()=>{i(T,j=>j.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(T,j,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Vc.None;if(this.m)return L.$Vc.None;j&&(T=T.bind(j));const O=new a(T);let F,B;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(O.stack=h.create(),F=this.g.check(O.stack,this.w+1)),m&&(O.stack=B??h.create()),this.t?this.t instanceof a?(this.u??=new l,this.t=[this.t,O]):this.t.push(O):(this.f?.onWillAddFirstListener?.(this),this.t=O,this.f?.onDidAddFirstListener?.(this)),this.w++;const Z=(0,L.$Tc)(()=>{u?.unregister(Z),F?.(),this.x(O)});if(z instanceof L.$Uc?z.add(Z):Array.isArray(z)&&z.push(Z),u){const q=new Error().stack.split(`
`).slice(2).join(`
`).trim();u.register(Z,q,Z)}return Z},this.q}x(T){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const j=this.t,z=j.indexOf(T);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,j[z]=void 0;const O=this.u.current===this;if(this.w*n<=j.length){let F=0;for(let B=0;B<j.length;B++)j[B]?j[F++]=j[B]:O&&(this.u.end--,F<this.u.i&&this.u.i--);j.length=F}}y(T,j){if(!T)return;const z=this.f?.onListenerError||d.$1;if(!z){T.value(j);return}try{T.value(j)}catch(O){z(O)}}z(T){const j=T.current.t;for(;T.i<T.end;)this.y(j[T.i++],T.value);T.reset()}fire(T){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof a)this.y(this.t,T);else{const j=this.u;j.enqueue(this,T,this.t.length),this.z(j)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ee=o;const t=()=>new l;e.$fe=t;class l{constructor(){this.i=-1,this.end=0}enqueue(T,j,z){this.i=0,this.end=z,this.current=T,this.value=j}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends o{async fireAsync(T,j,z){if(this.t)for(this.h||(this.h=new R.$6c),i(this.t,O=>this.h.push([O.value,T]));this.h.size>0&&!j.isCancellationRequested;){const[O,F]=this.h.shift(),B=[],Z={...F,token:j,waitUntil:q=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");z&&(q=z(q,O)),B.push(q)}};try{O(Z)}catch(q){(0,d.$1)(q);continue}Object.freeze(B),await Promise.allSettled(B).then(q=>{for(const Q of q)Q.status==="rejected"&&(0,d.$1)(Q.reason)})}}}e.$ge=r;class c extends o{get isPaused(){return this.h!==0}constructor(T){super(T),this.h=0,this.s=new R.$6c,this.A=T?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const T=Array.from(this.s);this.s.clear(),super.fire(this.A(T))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(T){this.w&&(this.h!==0?this.s.push(T):super.fire(T))}}e.$he=c;class s extends c{constructor(T){super(T),this.k=T.delay??100}fire(T){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(T)}}e.$ie=s;class v extends o{constructor(T){super(T),this.h=[],this.k=T?.merge}fire(T){this.hasListeners()&&(this.h.push(T),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(j=>super.fire(j)),this.h=[]}))}}e.$je=v;class f{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(T){const j={event:T,listener:null};this.h.push(j),this.g&&this.m(j);const z=()=>{this.g&&this.o(j);const O=this.h.indexOf(j);this.h.splice(O,1)};return(0,L.$Tc)((0,N.$db)(z))}j(){this.g=!0,this.h.forEach(T=>this.m(T))}k(){this.g=!1,this.h.forEach(T=>this.o(T))}m(T){T.listener=T.event(j=>this.f.fire(j))}o(T){T.listener?.dispose(),T.listener=null}dispose(){this.f.dispose();for(const T of this.h)T.listener?.dispose();this.h=[]}}e.$ke=f;class S{constructor(T,j,z,O){this.f=new L.$Uc;const F=this.f.add(new f),B=this.f.add(new L.$5c);function Z(q){B.set(q,F.add(O(q)))}for(const q of T)Z(q);this.f.add(j(q=>{Z(q)})),this.f.add(z(q=>{B.deleteAndDispose(q)})),this.event=F.event}dispose(){this.f.dispose()}}e.$le=S;class p{constructor(){this.f=[]}wrapEvent(T){return(j,z,O)=>T(F=>{const B=this.f[this.f.length-1];B?B.push(()=>j.call(z,F)):j.call(z,F)},void 0,O)}bufferEvents(T){const j=[];this.f.push(j);const z=T();return this.f.pop(),j.forEach(O=>O()),z}}e.$me=p;class k{constructor(){this.f=!1,this.g=A.None,this.h=L.$Vc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(T){this.g=T,this.f&&(this.h.dispose(),this.h=T(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ne=k;class P{static const(T){return new C(T)}constructor(T){this.g=T,this.f=new o,this.onDidChange=this.f.event}get value(){return this.g}set value(T){T!==this.g&&(this.g=T,this.f.fire(void 0))}}e.$oe=P;class C{constructor(T){this.value=T,this.onDidChange=A.None}}}),define(ke[22],Pe([1,0,4]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.CancellationToken=void 0;const N=Object.freeze(function(b,m){const E=setTimeout(b.bind(m),0);return{dispose(){clearTimeout(E)}}});var L;(function(b){function m(E){return E===b.None||E===b.Cancelled||E instanceof R?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}b.isCancellationToken=m,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:d.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new d.$ee),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor(m){this.f=void 0,this.g=void 0,this.g=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=L.Cancelled}dispose(m=!1){m&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=L.None}}e.$pe=M}),define(ke[173],Pe([1,0,22]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4e=e.$3e=e.$1e=void 0,e.$2e=L;class N{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new d.$pe,E=this.b(m.token);return this.a={promise:E,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}e.$1e=N;function L(b){return b}class R{constructor(m,E){this.a=void 0,this.b=void 0,typeof m=="function"?(this.c=m,this.d=L):(this.c=E,this.d=m.getCacheKey)}get(m){const E=this.d(m);return this.b!==E&&(this.b=E,this.a=this.c(m)),this.a}}e.$3e=R;class M{get cachedValues(){return this.a}constructor(m,E){this.a=new Map,this.b=new Map,typeof m=="function"?(this.c=m,this.d=L):(this.c=E,this.d=m.getCacheKey)}get(m){const E=this.d(m);if(this.b.has(E))return this.b.get(E);const A=this.c(m);return this.a.set(m,A),this.b.set(E,A),A}}e.$4e=M}),define(ke[98],Pe([1,0,13,3]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=L,e.$re=R,e.$se=M,e.$te=b,e.$ue=E,e.$ve=A,e.$we=D,e.$xe=$,e.$ye=y,e.$ze=w,e.$Ae=h,e.$Be=g,e.$Ce=a,e.$De=n,e.$Ee=i;function L(u){const o=u;return o?typeof o.read=="function":!1}function R(u){const o=u;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}function M(u){const o=u;return o?R(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function b(u,o){return new m(u,o)}class m{constructor(o,t){this.e=o,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(t=>t(o))}h(o){this.c.error.length===0?(0,d.$1)(o):this.c.error.slice(0).forEach(t=>t(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,t){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(o,t){if(this.a.destroyed)return;let l;switch(o){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const r=l.indexOf(t);r>=0&&l.splice(r,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(u,o){const t=[];let l;for(;(l=u.read())!==null;)t.push(l);return o(t)}function A(u,o,t){const l=[];let r;for(;(r=u.read())!==null&&l.length<t;)l.push(r);return r===null&&l.length>0?o(l):{read:()=>{if(l.length>0)return l.shift();if(typeof r<"u"){const c=r;return r=void 0,c}return u.read()}}}function D(u,o){return new Promise((t,l)=>{const r=[];$(u,{onData:c=>{o&&r.push(c)},onError:c=>{o?l(c):t(void 0)},onEnd:()=>{t(o?o(r):void 0)}})})}function $(u,o,t){u.on("error",l=>{t?.isCancellationRequested||o.onError(l)}),u.on("end",()=>{t?.isCancellationRequested||o.onEnd()}),u.on("data",l=>{t?.isCancellationRequested||o.onData(l)})}function y(u,o){return new Promise((t,l)=>{const r=new N.$Uc,c=[],s=S=>{if(c.push(S),c.length>o)return r.dispose(),u.pause(),t({stream:u,buffer:c,ended:!1})},v=S=>(r.dispose(),l(S)),f=()=>(r.dispose(),t({stream:u,buffer:c,ended:!0}));r.add((0,N.$Tc)(()=>u.removeListener("error",v))),u.on("error",v),r.add((0,N.$Tc)(()=>u.removeListener("end",f))),u.on("end",f),r.add((0,N.$Tc)(()=>u.removeListener("data",s))),u.on("data",s)})}function w(u,o){const t=b(o);return t.end(u),t}function h(){const u=b(()=>{throw new Error("not supported")});return u.end(),u}function g(u){let o=!1;return{read:()=>o?null:(o=!0,u)}}function a(u,o,t){const l=b(t);return $(u,{onData:r=>l.write(o.data(r)),onError:r=>l.error(o.error?o.error(r):r),onEnd:()=>l.end()}),l}function n(u,o,t){let l=!1;return{read:()=>{const r=o.read();return l?r:(l=!0,r!==null?t([u,r]):u)}}}function i(u,o,t){let l=!1;const r=b(t);return $(o,{onData:c=>l?r.write(c):(l=!0,r.write(t([u,c]))),onError:c=>r.error(c),onEnd:()=>{l||(l=!0,r.write(u)),r.end()}}),r}}),define(ke[21],Pe([1,0,46,98]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=void 0,e.$Ge=E,e.$He=A,e.$Ie=D,e.$Je=$,e.$Ke=y,e.$Le=w,e.$Me=h,e.$Ne=g,e.$Oe=a,e.$Pe=n,e.$Qe=i,e.$Re=u,e.$Se=o,e.$Te=t,e.$Ue=l,e.$Ve=r,e.$We=c,e.$Xe=s,e.$Ye=v,e.$Ze=p;const L=typeof Buffer<"u",R=new d.$V(()=>new Uint8Array(256));let M,b;class m{static alloc(P){return L?new m(Buffer.allocUnsafe(P)):new m(new Uint8Array(P))}static wrap(P){return L&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new m(P)}static fromString(P,C){return!(C?.dontUseNodeBuffer||!1)&&L?new m(Buffer.from(P)):(M||(M=new TextEncoder),new m(M.encode(P)))}static fromByteArray(P){const C=m.alloc(P.length);for(let I=0,T=P.length;I<T;I++)C.buffer[I]=P[I];return C}static concat(P,C){if(typeof C>"u"){C=0;for(let j=0,z=P.length;j<z;j++)C+=P[j].byteLength}const I=m.alloc(C);let T=0;for(let j=0,z=P.length;j<z;j++){const O=P[j];I.set(O,T),T+=O.byteLength}return I}constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}clone(){const P=m.alloc(this.byteLength);return P.set(this),P}toString(){return L?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(P,C){return new m(this.buffer.subarray(P,C))}set(P,C){if(P instanceof m)this.buffer.set(P.buffer,C);else if(P instanceof Uint8Array)this.buffer.set(P,C);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),C);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return $(this.buffer,P)}writeUInt32BE(P,C){y(this.buffer,P,C)}readUInt32LE(P){return w(this.buffer,P)}writeUInt32LE(P,C){h(this.buffer,P,C)}readUInt8(P){return g(this.buffer,P)}writeUInt8(P,C){a(this.buffer,P,C)}indexOf(P,C=0){return E(this.buffer,P instanceof m?P.buffer:P,C)}}e.$Fe=m;function E(k,P,C=0){const I=P.byteLength,T=k.byteLength;if(I===0)return 0;if(I===1)return k.indexOf(P[0]);if(I>T-C)return-1;const j=R.value;j.fill(P.length);for(let B=0;B<P.length;B++)j[P[B]]=P.length-B-1;let z=C+P.length-1,O=z,F=-1;for(;z<T;)if(k[z]===P[O]){if(O===0){F=z;break}z--,O--}else z+=Math.max(P.length-O,j[k[z]]),O=P.length-1;return F}function A(k,P){return k[P+0]<<0>>>0|k[P+1]<<8>>>0}function D(k,P,C){k[C+0]=P&255,P=P>>>8,k[C+1]=P&255}function $(k,P){return k[P]*2**24+k[P+1]*2**16+k[P+2]*2**8+k[P+3]}function y(k,P,C){k[C+3]=P,P=P>>>8,k[C+2]=P,P=P>>>8,k[C+1]=P,P=P>>>8,k[C]=P}function w(k,P){return k[P+0]<<0>>>0|k[P+1]<<8>>>0|k[P+2]<<16>>>0|k[P+3]<<24>>>0}function h(k,P,C){k[C+0]=P&255,P=P>>>8,k[C+1]=P&255,P=P>>>8,k[C+2]=P&255,P=P>>>8,k[C+3]=P&255}function g(k,P){return k[P]}function a(k,P,C){k[C]=P}function n(k){return N.$ue(k,P=>m.concat(P))}function i(k){return N.$Be(k)}function u(k){return N.$we(k,P=>m.concat(P))}async function o(k){return k.ended?m.concat(k.buffer):m.concat([...k.buffer,await u(k.stream)])}function t(k){return N.$ze(k,P=>m.concat(P))}function l(k){return N.$Ce(k,{data:P=>typeof P=="string"?m.fromString(P):m.wrap(P)},P=>m.concat(P))}function r(k){return N.$te(P=>m.concat(P),k)}function c(k,P){return N.$De(k,P,C=>m.concat(C))}function s(k,P){return N.$Ee(k,P,C=>m.concat(C))}function v(k){let P=0,C=0,I=0;const T=new Uint8Array(Math.floor(k.length/4*3)),j=O=>{switch(C){case 3:T[I++]=P|O,C=0;break;case 2:T[I++]=P|O>>>2,P=O<<6,C=3;break;case 1:T[I++]=P|O>>>4,P=O<<4,C=2;break;default:P=O<<2,C=1}};for(let O=0;O<k.length;O++){const F=k.charCodeAt(O);if(F>=65&&F<=90)j(F-65);else if(F>=97&&F<=122)j(F-97+26);else if(F>=48&&F<=57)j(F-48+52);else if(F===43||F===45)j(62);else if(F===47||F===95)j(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${k[O]}`)}}const z=I;for(;C>0;)j(0);return m.wrap(T).slice(0,z)}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:k},P=!0,C=!1){const I=C?S:f;let T="";const j=k.byteLength%3;let z=0;for(;z<k.byteLength-j;z+=3){const O=k[z+0],F=k[z+1],B=k[z+2];T+=I[O>>>2],T+=I[(O<<4|F>>>4)&63],T+=I[(F<<2|B>>>6)&63],T+=I[B&63]}if(j===1){const O=k[z+0];T+=I[O>>>2],T+=I[O<<4&63],P&&(T+="==")}else if(j===2){const O=k[z+0],F=k[z+1];T+=I[O>>>2],T+=I[(O<<4|F>>>4)&63],T+=I[F<<2&63],P&&(T+="=")}return T}}),define(ke[14],Pe([1,0,173,46]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.GraphemeBreakType=e.$Uf=e.$Nf=e.$Gf=e.$Ff=void 0,e.$7e=L,e.$8e=M,e.$9e=m,e.$0e=E,e.$$e=A,e.$_e=D,e.$af=$,e.$bf=y,e.$cf=w,e.$df=h,e.$ef=g,e.$ff=a,e.$gf=n,e.$hf=i,e.$if=u,e.$jf=o,e.$kf=t,e.$lf=l,e.$mf=r,e.$nf=c,e.$of=s,e.$pf=v,e.$qf=f,e.$rf=S,e.$sf=p,e.$tf=k,e.$uf=P,e.$vf=C,e.$wf=I,e.$xf=T,e.$yf=j,e.$zf=z,e.$Af=O,e.$Bf=F,e.$Cf=B,e.$Df=Z,e.$Ef=q,e.$Hf=ie,e.$If=me,e.$Jf=ue,e.$Kf=ve,e.$Lf=ee,e.$Mf=Ce,e.$Of=se,e.$Pf=re,e.$Qf=oe,e.$Rf=K,e.$Sf=$e,e.$Tf=be,e.$Vf=Ae,e.$Wf=fe,e.$Xf=Se,e.$Yf=Ie,e.$Zf=ze,e.$1f=V,e.$2f=W,e.$3f=J,e.$4f=qe;function L(De){return!De||typeof De!="string"?!0:De.trim().length===0}const R=/{(\d+)}/g;function M(De,...Be){return Be.length===0?De:De.replace(R,function(Ge,Ne){const Ze=parseInt(Ne,10);return isNaN(Ze)||Ze<0||Ze>=Be.length?Ge:Be[Ze]})}const b=/{([^}]+)}/g;function m(De,Be){return Object.keys(Be).length===0?De:De.replace(b,(Ge,Ne)=>Be[Ne]??Ge)}function E(De){return De.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function A(De){return De.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function D(De){return De.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function $(De,Be){let Ge=0;const Ne=Be.charCodeAt(0);for(let Ze=De.length-1;Ze>=0;Ze--)De.charCodeAt(Ze)===Ne&&Ge++;return Ge}function y(De,Be,Ge="\u2026"){return De.length<=Be?De:`${De.substr(0,Be)}${Ge}`}function w(De,Be,Ge="\u2026"){if(De.length<=Be)return De;const Ne=Math.ceil(Be/2)-Ge.length/2,Ze=Math.floor(Be/2)-Ge.length/2;return`${De.substr(0,Ne)}${Ge}${De.substr(De.length-Ze)}`}function h(De,Be=" "){const Ge=g(De,Be);return a(Ge,Be)}function g(De,Be){if(!De||!Be)return De;const Ge=Be.length;if(Ge===0||De.length===0)return De;let Ne=0;for(;De.indexOf(Be,Ne)===Ne;)Ne=Ne+Ge;return De.substring(Ne)}function a(De,Be){if(!De||!Be)return De;const Ge=Be.length,Ne=De.length;if(Ge===0||Ne===0)return De;let Ze=Ne,ae=-1;for(;ae=De.lastIndexOf(Be,Ze-1),!(ae===-1||ae+Ge!==Ze);){if(ae===0)return"";Ze=ae}return De.substring(0,Ze)}function n(De){return De.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(De){return De.replace(/\*/g,"")}function u(De,Be,Ge={}){if(!De)throw new Error("Cannot create regex from empty string");Be||(De=D(De)),Ge.wholeWord&&(/\B/.test(De.charAt(0))||(De="\\b"+De),/\B/.test(De.charAt(De.length-1))||(De=De+"\\b"));let Ne="";return Ge.global&&(Ne+="g"),Ge.matchCase||(Ne+="i"),Ge.multiline&&(Ne+="m"),Ge.unicode&&(Ne+="u"),new RegExp(De,Ne)}function o(De){return De.source==="^"||De.source==="^$"||De.source==="$"||De.source==="^\\s*$"?!1:!!(De.exec("")&&De.lastIndex===0)}function t(De){return De.split(/\r\n|\r|\n/)}function l(De){const Be=[],Ge=De.split(/(\r\n|\r|\n)/);for(let Ne=0;Ne<Math.ceil(Ge.length/2);Ne++)Be.push(Ge[2*Ne]+(Ge[2*Ne+1]??""));return Be}function r(De){for(let Be=0,Ge=De.length;Be<Ge;Be++){const Ne=De.charCodeAt(Be);if(Ne!==32&&Ne!==9)return Be}return-1}function c(De,Be=0,Ge=De.length){for(let Ne=Be;Ne<Ge;Ne++){const Ze=De.charCodeAt(Ne);if(Ze!==32&&Ze!==9)return De.substring(Be,Ne)}return De.substring(Be,Ge)}function s(De,Be=De.length-1){for(let Ge=Be;Ge>=0;Ge--){const Ne=De.charCodeAt(Ge);if(Ne!==32&&Ne!==9)return Ge}return-1}function v(De,Be,Ge){const Ne=[];let Ze=0;for(const ae of De.matchAll(Be)){if(Ne.push(De.slice(Ze,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");Ze=ae.index+ae[0].length,Ne.push(Ge(ae[0],...ae.slice(1),ae.index,De,ae.groups))}return Ne.push(De.slice(Ze)),Promise.all(Ne).then(ae=>ae.join(""))}function f(De,Be){return De<Be?-1:De>Be?1:0}function S(De,Be,Ge=0,Ne=De.length,Ze=0,ae=Be.length){for(;Ge<Ne&&Ze<ae;Ge++,Ze++){const Ke=De.charCodeAt(Ge),Me=Be.charCodeAt(Ze);if(Ke<Me)return-1;if(Ke>Me)return 1}const ce=Ne-Ge,Re=ae-Ze;return ce<Re?-1:ce>Re?1:0}function p(De,Be){return k(De,Be,0,De.length,0,Be.length)}function k(De,Be,Ge=0,Ne=De.length,Ze=0,ae=Be.length){for(;Ge<Ne&&Ze<ae;Ge++,Ze++){let Ke=De.charCodeAt(Ge),Me=Be.charCodeAt(Ze);if(Ke===Me)continue;if(Ke>=128||Me>=128)return S(De.toLowerCase(),Be.toLowerCase(),Ge,Ne,Ze,ae);C(Ke)&&(Ke-=32),C(Me)&&(Me-=32);const it=Ke-Me;if(it!==0)return it}const ce=Ne-Ge,Re=ae-Ze;return ce<Re?-1:ce>Re?1:0}function P(De){return De>=48&&De<=57}function C(De){return De>=97&&De<=122}function I(De){return De>=65&&De<=90}function T(De,Be){return De.length===Be.length&&k(De,Be)===0}function j(De,Be){const Ge=Be.length;return Be.length>De.length?!1:k(De,Be,0,Ge)===0}function z(De,Be){const Ge=Math.min(De.length,Be.length);let Ne;for(Ne=0;Ne<Ge;Ne++)if(De.charCodeAt(Ne)!==Be.charCodeAt(Ne))return Ne;return Ge}function O(De,Be){const Ge=Math.min(De.length,Be.length);let Ne;const Ze=De.length-1,ae=Be.length-1;for(Ne=0;Ne<Ge;Ne++)if(De.charCodeAt(Ze-Ne)!==Be.charCodeAt(ae-Ne))return Ne;return Ge}function F(De){return 55296<=De&&De<=56319}function B(De){return 56320<=De&&De<=57343}function Z(De,Be){return(De-55296<<10)+(Be-56320)+65536}function q(De,Be,Ge){const Ne=De.charCodeAt(Ge);if(F(Ne)&&Ge+1<Be){const Ze=De.charCodeAt(Ge+1);if(B(Ze))return Z(Ne,Ze)}return Ne}function Q(De,Be){const Ge=De.charCodeAt(Be-1);if(B(Ge)&&Be>1){const Ne=De.charCodeAt(Be-2);if(F(Ne))return Z(Ne,Ge)}return Ge}class x{get offset(){return this.e}constructor(Be,Ge=0){this.c=Be,this.d=Be.length,this.e=Ge}setOffset(Be){this.e=Be}prevCodePoint(){const Be=Q(this.c,this.e);return this.e-=Be>=65536?2:1,Be}nextCodePoint(){const Be=q(this.c,this.d,this.e);return this.e+=Be>=65536?2:1,Be}eol(){return this.e>=this.d}}e.$Ff=x;class X{get offset(){return this.c.offset}constructor(Be,Ge=0){this.c=new x(Be,Ge)}nextGraphemeLength(){const Be=we.getInstance(),Ge=this.c,Ne=Ge.offset;let Ze=Be.getGraphemeBreakType(Ge.nextCodePoint());for(;!Ge.eol();){const ae=Ge.offset,ce=Be.getGraphemeBreakType(Ge.nextCodePoint());if(Y(Ze,ce)){Ge.setOffset(ae);break}Ze=ce}return Ge.offset-Ne}prevGraphemeLength(){const Be=we.getInstance(),Ge=this.c,Ne=Ge.offset;let Ze=Be.getGraphemeBreakType(Ge.prevCodePoint());for(;Ge.offset>0;){const ae=Ge.offset,ce=Be.getGraphemeBreakType(Ge.prevCodePoint());if(Y(ce,Ze)){Ge.setOffset(ae);break}Ze=ce}return Ne-Ge.offset}eol(){return this.c.eol()}}e.$Gf=X;function ie(De,Be){return new X(De,Be).nextGraphemeLength()}function me(De,Be){return new X(De,Be).prevGraphemeLength()}function ue(De,Be){Be>0&&B(De.charCodeAt(Be))&&Be--;const Ge=Be+ie(De,Be);return[Ge-me(De,Ge),Ge]}function ve(De){const Be=new X(De);let Ge=0;for(;!Be.eol();)Ge++,Be.nextGraphemeLength();return Ge}let te;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ee(De){return te||(te=U()),te.test(De)}const pe=/^[\t\n\r\x20-\x7E]*$/;function Ce(De){return pe.test(De)}e.$Nf=/[\u2028\u2029]/;function se(De){return e.$Nf.test(De)}function re(De){return De>=11904&&De<=55215||De>=63744&&De<=64255||De>=65281&&De<=65374}function oe(De){return De>=127462&&De<=127487||De===8986||De===8987||De===9200||De===9203||De>=9728&&De<=10175||De===11088||De===11093||De>=127744&&De<=128591||De>=128640&&De<=128764||De>=128992&&De<=129008||De>=129280&&De<=129535||De>=129648&&De<=129782}function K(De,Be,Ge=""){const Ne=De.trimStart();if(Ne.length<Be)return Ne;const Ze=/\b/g;let ae=0;for(;Ze.test(Ne)&&!(Ne.length-Ze.lastIndex<Be);)ae=Ze.lastIndex,Ze.lastIndex+=1;return ae===0?Ne:Ge+Ne.substring(ae).trimStart()}const ne=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*$e(De){let Be=0;for(const Ge of De.matchAll(ne))Be!==Ge.index&&(yield{isCode:!1,str:De.substring(Be,Ge.index)}),yield{isCode:!0,str:Ge[0]},Be=Ge.index+Ge[0].length;Be!==De.length&&(yield{isCode:!1,str:De.substring(Be)})}function be(De){return De&&(De=De.replace(ne,"")),De}e.$Uf="\uFEFF";function Ae(De){return!!(De&&De.length>0&&De.charCodeAt(0)===65279)}function fe(De){return Ae(De)?De.substr(1):De}function Se(De,Be){if(!De||!Be||De.length<Be.length)return!1;const Ge=Be.length,Ne=De.toLowerCase();let Ze=0,ae=-1;for(;Ze<Ge;){const ce=Ne.indexOf(Be[Ze],ae+1);if(ce<0)return!1;ae=ce,Ze++}return!0}function Ie(De,Be=!1){return De?(Be&&(De=De.replace(/\\./g,"")),De.toLowerCase()!==De):!1}function ze(De){return De.charAt(0).toUpperCase()+De.slice(1)}function V(De,Be=1){if(Be===0)return"";let Ge=-1;do Ge=De.indexOf(`
`,Ge+1),Be--;while(Be>0&&Ge>=0);return Ge===-1?De:(De[Ge-1]==="\r"&&Ge--,De.substr(0,Ge))}function W(De){return De=De%(2*26),De<26?String.fromCharCode(97+De):String.fromCharCode(65+De-26)}function J(De){return we.getInstance().getGraphemeBreakType(De)}function Y(De,Be){return De===0?Be!==5&&Be!==7:De===2&&Be===3?!1:De===4||De===2||De===3||Be===4||Be===2||Be===3?!0:!(De===8&&(Be===8||Be===9||Be===11||Be===12)||(De===11||De===9)&&(Be===9||Be===10)||(De===12||De===10)&&Be===10||Be===5||Be===13||Be===7||De===1||De===13&&Be===14||De===6&&Be===6)}var he;(function(De){De[De.Other=0]="Other",De[De.Prepend=1]="Prepend",De[De.CR=2]="CR",De[De.LF=3]="LF",De[De.Control=4]="Control",De[De.Extend=5]="Extend",De[De.Regional_Indicator=6]="Regional_Indicator",De[De.SpacingMark=7]="SpacingMark",De[De.L=8]="L",De[De.V=9]="V",De[De.T=10]="T",De[De.LV=11]="LV",De[De.LVT=12]="LVT",De[De.ZWJ=13]="ZWJ",De[De.Extended_Pictographic=14]="Extended_Pictographic"})(he||(e.GraphemeBreakType=he={}));class we{static{this.c=null}static getInstance(){return we.c||(we.c=new we),we.c}constructor(){this.d=je()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const Ge=this.d,Ne=Ge.length/3;let Ze=1;for(;Ze<=Ne;)if(Be<Ge[3*Ze])Ze=2*Ze;else if(Be>Ge[3*Ze+1])Ze=2*Ze+1;else return Ge[3*Ze+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(De,Be){if(De===0)return 0;const Ge=Ye(De,Be);if(Ge!==void 0)return Ge;const Ne=new x(Be,De);return Ne.prevCodePoint(),Ne.offset}function Ye(De,Be){const Ge=new x(Be,De);let Ne=Ge.prevCodePoint();for(;st(Ne)||Ne===65039||Ne===8419;){if(Ge.offset===0)return;Ne=Ge.prevCodePoint()}if(!oe(Ne))return;let Ze=Ge.offset;return Ze>0&&Ge.prevCodePoint()===8205&&(Ze=Ge.offset),Ze}function st(De){return 127995<=De&&De<=127999}var tt;(function(De){De[De.zwj=8205]="zwj",De[De.emojiVariantSelector=65039]="emojiVariantSelector",De[De.enclosingKeyCap=8419]="enclosingKeyCap"})(tt||(tt={})),e.$5f="\xA0";class nt{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new d.$3e({getCacheKey:JSON.stringify},Be=>{function Ge(it){const lt=new Map;for(let bt=0;bt<it.length;bt+=2)lt.set(it[bt],it[bt+1]);return lt}function Ne(it,lt){const bt=new Map(it);for(const[Ot,Rt]of lt)bt.set(Ot,Rt);return bt}function Ze(it,lt){if(!it)return lt;const bt=new Map;for(const[Ot,Rt]of it)lt.has(Ot)&&bt.set(Ot,Rt);return bt}const ae=this.c.value;let ce=Be.filter(it=>!it.startsWith("_")&&it in ae);ce.length===0&&(ce=["_default"]);let Re;for(const it of ce){const lt=Ge(ae[it]);Re=Ze(Re,lt)}const Ke=Ge(ae._common),Me=Ne(Ke,Re);return new nt(Me)})}static getInstance(Be){return nt.d.get(Array.from(Be))}static{this.e=new N.$V(()=>Object.keys(nt.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return nt.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$6f=nt;class ot{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ot.c())),this.d}static isInvisibleCharacter(Be){return ot.e().has(Be)}static get codePoints(){return ot.e()}}e.$7f=ot}),define(ke[127],Pe([1,0,27,168,14]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.FuzzyScore=e.$xk=e.$wk=void 0,e.or=R,e.$yk=b,e.$zk=m,e.$Ak=D,e.$Bk=v,e.$Ck=f,e.$Dk=I,e.$Ek=T,e.$Fk=j,e.$Gk=z,e.$Hk=ee,e.$Jk=re,e.$Kk=ne,e.$Lk=$e;function R(...fe){return function(Se,Ie){for(let ze=0,V=fe.length;ze<V;ze++){const W=fe[ze](Se,Ie);if(W)return W}return null}}e.$wk=M.bind(void 0,!1),e.$xk=M.bind(void 0,!0);function M(fe,Se,Ie){if(!Ie||Ie.length<Se.length)return null;let ze;return fe?ze=L.$yf(Ie,Se):ze=Ie.indexOf(Se)===0,ze?Se.length>0?[{start:0,end:Se.length}]:[]:null}function b(fe,Se){const Ie=Se.toLowerCase().indexOf(fe.toLowerCase());return Ie===-1?null:[{start:Ie,end:Ie+fe.length}]}function m(fe,Se){return E(fe.toLowerCase(),Se.toLowerCase(),0,0)}function E(fe,Se,Ie,ze){if(Ie===fe.length)return[];if(ze===Se.length)return null;if(fe[Ie]===Se[ze]){let V=null;return(V=E(fe,Se,Ie+1,ze+1))?u({start:ze,end:ze+1},V):null}return E(fe,Se,Ie,ze+1)}function A(fe){return 97<=fe&&fe<=122}function D(fe){return 65<=fe&&fe<=90}function $(fe){return 48<=fe&&fe<=57}function y(fe){return fe===32||fe===9||fe===10||fe===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(fe=>w.add(fe.charCodeAt(0)));function h(fe){return y(fe)||w.has(fe)}function g(fe,Se){return fe===Se||h(fe)&&h(Se)}const a=new Map;function n(fe){if(a.has(fe))return a.get(fe);let Se;const Ie=(0,N.$uk)(fe);return Ie&&(Se=Ie),a.set(fe,Se),Se}function i(fe){return A(fe)||D(fe)||$(fe)}function u(fe,Se){return Se.length===0?Se=[fe]:fe.end===Se[0].start?Se[0].start=fe.start:Se.unshift(fe),Se}function o(fe,Se){for(let Ie=Se;Ie<fe.length;Ie++){const ze=fe.charCodeAt(Ie);if(D(ze)||$(ze)||Ie>0&&!i(fe.charCodeAt(Ie-1)))return Ie}return fe.length}function t(fe,Se,Ie,ze){if(Ie===fe.length)return[];if(ze===Se.length)return null;if(fe[Ie]!==Se[ze].toLowerCase())return null;{let V=null,W=ze+1;for(V=t(fe,Se,Ie+1,ze+1);!V&&(W=o(Se,W))<Se.length;)V=t(fe,Se,Ie+1,W),W++;return V===null?null:u({start:ze,end:ze+1},V)}}function l(fe){let Se=0,Ie=0,ze=0,V=0,W=0;for(let je=0;je<fe.length;je++)W=fe.charCodeAt(je),D(W)&&Se++,A(W)&&Ie++,i(W)&&ze++,$(W)&&V++;const J=Se/fe.length,Y=Ie/fe.length,he=ze/fe.length,we=V/fe.length;return{upperPercent:J,lowerPercent:Y,alphaPercent:he,numericPercent:we}}function r(fe){const{upperPercent:Se,lowerPercent:Ie}=fe;return Ie===0&&Se>.6}function c(fe){const{upperPercent:Se,lowerPercent:Ie,alphaPercent:ze,numericPercent:V}=fe;return Ie>.2&&Se<.8&&ze>.6&&V<.2}function s(fe){let Se=0,Ie=0,ze=0,V=0;for(let W=0;W<fe.length;W++)ze=fe.charCodeAt(W),D(ze)&&Se++,A(ze)&&Ie++,y(ze)&&V++;return(Se===0||Ie===0)&&V===0?fe.length<=30:Se<=5}function v(fe,Se){if(!Se||(Se=Se.trim(),Se.length===0)||!s(fe))return null;Se.length>60&&(Se=Se.substring(0,60));const Ie=l(Se);if(!c(Ie)){if(!r(Ie))return null;Se=Se.toLowerCase()}let ze=null,V=0;for(fe=fe.toLowerCase();V<Se.length&&(ze=t(fe,Se,0,V))===null;)V=o(Se,V+1);return ze}function f(fe,Se,Ie=!1){if(!Se||Se.length===0)return null;let ze=null,V=0;for(fe=fe.toLowerCase(),Se=Se.toLowerCase();V<Se.length&&(ze=S(fe,Se,0,V,Ie),ze===null);)V=p(Se,V+1);return ze}function S(fe,Se,Ie,ze,V){let W=0;if(Ie===fe.length)return[];if(ze===Se.length)return null;if(!g(fe.charCodeAt(Ie),Se.charCodeAt(ze))){const he=n(fe.charCodeAt(Ie));if(!he)return null;for(let we=0;we<he.length;we++)if(!g(he[we],Se.charCodeAt(ze+we)))return null;W+=he.length-1}let J=null,Y=ze+W+1;if(J=S(fe,Se,Ie+1,Y,V),!V)for(;!J&&(Y=p(Se,Y))<Se.length;)J=S(fe,Se,Ie+1,Y,V),Y++;if(!J)return null;if(fe.charCodeAt(Ie)!==Se.charCodeAt(ze)){const he=n(fe.charCodeAt(Ie));if(!he)return J;for(let we=0;we<he.length;we++)if(he[we]!==Se.charCodeAt(ze+we))return J}return u({start:ze,end:ze+W+1},J)}function p(fe,Se){for(let Ie=Se;Ie<fe.length;Ie++)if(h(fe.charCodeAt(Ie))||Ie>0&&h(fe.charCodeAt(Ie-1)))return Ie;return fe.length}const k=R(e.$xk,v,b),P=R(e.$xk,v,m),C=new d.$Ec(1e4);function I(fe,Se,Ie=!1){if(typeof fe!="string"||typeof Se!="string")return null;let ze=C.get(fe);ze||(ze=new RegExp(L.$gf(fe),"i"),C.set(fe,ze));const V=ze.exec(Se);return V?[{start:V.index,end:V.index+V[0].length}]:Ie?P(fe,Se):k(fe,Se)}function T(fe,Se){const Ie=re(fe,fe.toLowerCase(),0,Se,Se.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ie?z(Ie):null}function j(fe,Se,Ie,ze,V,W){const J=Math.min(13,fe.length);for(;Ie<J;Ie++){const Y=re(fe,Se,Ie,ze,V,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Y)return Y}return[0,W]}function z(fe){if(typeof fe>"u")return[];const Se=[],Ie=fe[1];for(let ze=fe.length-1;ze>1;ze--){const V=fe[ze]+Ie,W=Se[Se.length-1];W&&W.end===V?W.end=V+1:Se.push({start:V,end:V+1})}return Se}const O=128;function F(){const fe=[],Se=[];for(let Ie=0;Ie<=O;Ie++)Se[Ie]=0;for(let Ie=0;Ie<=O;Ie++)fe.push(Se.slice(0));return fe}function B(fe){const Se=[];for(let Ie=0;Ie<=fe;Ie++)Se[Ie]=0;return Se}const Z=B(2*O),q=B(2*O),Q=F(),x=F(),X=F(),ie=!1;function me(fe,Se,Ie,ze,V){function W(Y,he,we=" "){for(;Y.length<he;)Y=we+Y;return Y}let J=` |   |${ze.split("").map(Y=>W(Y,3)).join("|")}
`;for(let Y=0;Y<=Ie;Y++)Y===0?J+=" |":J+=`${Se[Y-1]}|`,J+=fe[Y].slice(0,V+1).map(he=>W(he.toString(),3)).join("|")+`
`;return J}function ue(fe,Se,Ie,ze){fe=fe.substr(Se),Ie=Ie.substr(ze),console.log(me(x,fe,fe.length,Ie,Ie.length)),console.log(me(X,fe,fe.length,Ie,Ie.length)),console.log(me(Q,fe,fe.length,Ie,Ie.length))}function ve(fe,Se){if(Se<0||Se>=fe.length)return!1;const Ie=fe.codePointAt(Se);switch(Ie){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$Qf(Ie)}}function te(fe,Se){if(Se<0||Se>=fe.length)return!1;switch(fe.charCodeAt(Se)){case 32:case 9:return!0;default:return!1}}function U(fe,Se,Ie){return Se[fe]!==Ie[fe]}function ee(fe,Se,Ie,ze,V,W,J=!1){for(;Se<Ie&&V<W;)fe[Se]===ze[V]&&(J&&(Z[Se]=V),Se+=1),V+=1;return Se===Ie}var pe;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var Ce;(function(fe){fe.Default=[-100,0];function Se(Ie){return!Ie||Ie.length===2&&Ie[0]===-100&&Ie[1]===0}fe.isDefault=Se})(Ce||(e.FuzzyScore=Ce={}));class se{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Se,Ie){this.firstMatchCanBeWeak=Se,this.boostFullMatch=Ie}}e.$Ik=se;function re(fe,Se,Ie,ze,V,W,J=se.default){const Y=fe.length>O?O:fe.length,he=ze.length>O?O:ze.length;if(Ie>=Y||W>=he||Y-Ie>he-W||!ee(Se,Ie,Y,V,W,he,!0))return;oe(Y,he,Ie,W,Se,V);let we=1,je=1,qe=Ie,Ye=W;const st=[!1];for(we=1,qe=Ie;qe<Y;we++,qe++){const Be=Z[qe],Ge=q[qe],Ne=qe+1<Y?q[qe+1]:he;for(je=Be-W+1,Ye=Be;Ye<Ne;je++,Ye++){let Ze=Number.MIN_SAFE_INTEGER,ae=!1;Ye<=Ge&&(Ze=K(fe,Se,qe,Ie,ze,V,Ye,he,W,Q[we-1][je-1]===0,st));let ce=0;Ze!==Number.MAX_SAFE_INTEGER&&(ae=!0,ce=Ze+x[we-1][je-1]);const Re=Ye>Be,Ke=Re?x[we][je-1]+(Q[we][je-1]>0?-5:0):0,Me=Ye>Be+1&&Q[we][je-1]>0,it=Me?x[we][je-2]+(Q[we][je-2]>0?-5:0):0;if(Me&&(!Re||it>=Ke)&&(!ae||it>=ce))x[we][je]=it,X[we][je]=3,Q[we][je]=0;else if(Re&&(!ae||Ke>=ce))x[we][je]=Ke,X[we][je]=2,Q[we][je]=0;else if(ae)x[we][je]=ce,X[we][je]=1,Q[we][je]=Q[we-1][je-1]+1;else throw new Error("not possible")}}if(ie&&ue(fe,Ie,ze,W),!st[0]&&!J.firstMatchCanBeWeak)return;we--,je--;const tt=[x[we][je],W];let nt=0,ot=0;for(;we>=1;){let Be=je;do{const Ge=X[we][Be];if(Ge===3)Be=Be-2;else if(Ge===2)Be=Be-1;else break}while(Be>=1);nt>1&&Se[Ie+we-1]===V[W+je-1]&&!U(Be+W-1,ze,V)&&nt+1>Q[we][Be]&&(Be=je),Be===je?nt++:nt=1,ot||(ot=Be),we--,je=Be-1,tt.push(je)}he===Y&&J.boostFullMatch&&(tt[0]+=2);const De=ot-Y;return tt[0]-=De,tt}function oe(fe,Se,Ie,ze,V,W){let J=fe-1,Y=Se-1;for(;J>=Ie&&Y>=ze;)V[J]===W[Y]&&(q[J]=Y,J--),Y--}function K(fe,Se,Ie,ze,V,W,J,Y,he,we,je){if(Se[Ie]!==W[J])return Number.MIN_SAFE_INTEGER;let qe=1,Ye=!1;return J===Ie-ze?qe=fe[Ie]===V[J]?7:5:U(J,V,W)&&(J===0||!U(J-1,V,W))?(qe=fe[Ie]===V[J]?7:5,Ye=!0):ve(W,J)&&(J===0||!ve(W,J-1))?qe=5:(ve(W,J-1)||te(W,J-1))&&(qe=5,Ye=!0),qe>1&&Ie===ze&&(je[0]=!0),Ye||(Ye=U(J,V,W)||ve(W,J-1)||te(W,J-1)),Ie===ze?J>he&&(qe-=Ye?3:5):we?qe+=Ye?2:0:qe+=Ye?0:1,J+1===Y&&(qe-=Ye?3:5),qe}function ne(fe,Se,Ie,ze,V,W,J){return be(fe,Se,Ie,ze,V,W,!0,J)}function $e(fe,Se,Ie,ze,V,W,J){return be(fe,Se,Ie,ze,V,W,!1,J)}function be(fe,Se,Ie,ze,V,W,J,Y){let he=re(fe,Se,Ie,ze,V,W,Y);if(he&&!J)return he;if(fe.length>=3){const we=Math.min(7,fe.length-1);for(let je=Ie+1;je<we;je++){const qe=Ae(fe,je);if(qe){const Ye=re(qe,qe.toLowerCase(),Ie,ze,V,W,Y);Ye&&(Ye[0]-=3,(!he||Ye[0]>he[0])&&(he=Ye))}}}return he}function Ae(fe,Se){if(Se+1>=fe.length)return;const Ie=fe[Se],ze=fe[Se+1];if(Ie!==ze)return fe.slice(0,Se)+ze+Ie+fe.slice(Se+2)}}),define(ke[56],Pe([1,0,14]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$nj=void 0,e.$jj=N,e.$kj=L,e.$lj=R,e.$mj=b,e.$oj=h;function N(a){return L(a,0)}function L(a,n){switch(typeof a){case"object":return a===null?R(349,n):Array.isArray(a)?m(a,n):E(a,n);case"string":return b(a,n);case"boolean":return M(a,n);case"number":return R(a,n);case"undefined":return R(937,n);default:return R(617,n)}}function R(a,n){return(n<<5)-n+a|0}function M(a,n){return R(a?433:863,n)}function b(a,n){n=R(149417,n);for(let i=0,u=a.length;i<u;i++)n=R(a.charCodeAt(i),n);return n}function m(a,n){return n=R(104579,n),a.reduce((i,u)=>L(u,i),n)}function E(a,n){return n=R(181387,n),Object.keys(a).sort().reduce((i,u)=>(i=b(u,i),L(a[u],i)),n)}class A{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=L(n,this.g),this.g}}e.$nj=A;var D;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function $(a,n,i=32){const u=i-n,o=~((1<<u)-1);return(a<<n|(o&a)>>>u)>>>0}function y(a,n=0,i=a.byteLength,u=0){for(let o=0;o<i;o++)a[n+o]=u}function w(a,n,i="0"){for(;a.length<n;)a=i+a;return a}function h(a,n=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(i=>i.toString(16).padStart(2,"0")).join(""):w((a>>>0).toString(16),n/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const u=this.p;let o=this.r,t=this.u,l,r;for(t!==0?(l=t,r=-1,t=0):(l=n.charCodeAt(0),r=0);;){let c=l;if(d.$Bf(l))if(r+1<i){const s=n.charCodeAt(r+1);d.$Cf(s)?(r++,c=d.$Df(l,s)):c=65533}else{t=l;break}else d.$Cf(l)&&(c=65533);if(o=this.w(u,o,c),r++,r<i)l=n.charCodeAt(r);else break}this.r=o,this.u=t}w(n,i,u){return u<128?n[i++]=u:u<2048?(n[i++]=192|(u&1984)>>>6,n[i++]=128|(u&63)>>>0):u<65536?(n[i++]=224|(u&61440)>>>12,n[i++]=128|(u&4032)>>>6,n[i++]=128|(u&63)>>>0):(n[i++]=240|(u&1835008)>>>18,n[i++]=128|(u&258048)>>>12,n[i++]=128|(u&4032)>>>6,n[i++]=128|(u&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=g.g,i=this.q;for(let f=0;f<64;f+=4)n.setUint32(f,i.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)n.setUint32(f,$(n.getUint32(f-12,!1)^n.getUint32(f-32,!1)^n.getUint32(f-56,!1)^n.getUint32(f-64,!1),1),!1);let u=this.h,o=this.l,t=this.m,l=this.n,r=this.o,c,s,v;for(let f=0;f<80;f++)f<20?(c=o&t|~o&l,s=1518500249):f<40?(c=o^t^l,s=1859775393):f<60?(c=o&t|o&l|t&l,s=2400959708):(c=o^t^l,s=3395469782),v=$(u,5)+c+r+s+n.getUint32(f*4,!1)&4294967295,r=l,l=t,t=$(o,30),o=u,u=v;this.h=this.h+u&4294967295,this.l=this.l+o&4294967295,this.m=this.m+t&4294967295,this.n=this.n+l&4294967295,this.o=this.o+r&4294967295}}e.$pj=g}),define(ke[41],Pe([1,0,14]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const R="error",M="warning",b="warn",m="info",E="ignore";function A($){return $?d.$xf(R,$)?L.Error:d.$xf(M,$)||d.$xf(b,$)?L.Warning:d.$xf(m,$)?L.Info:L.Ignore:L.Ignore}L.fromValue=A;function D($){switch($){case L.Error:return R;case L.Warning:return M;case L.Info:return m;default:return E}}L.toString=D}(N||(N={})),e.default=N}),define(ke[174],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0,e.$be=Symbol("MicrotaskDelay")}),define(ke[78],Pe([1,0,19,14]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=void 0;class L{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const w=y.charCodeAt(0),h=this.b.charCodeAt(this.c);return w-h}value(){return this.b[this.c]}}e.$xi=L;class R{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,N.$rf)(y,this.b,0,y.length,this.c,this.d):(0,N.$tf)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$yi=R;class M{constructor(y=!0,w=!0){this.f=y,this.g=w}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let w=y.length-1;w>=0;w--,this.c--){const h=this.b.charCodeAt(w);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const w=this.b.charCodeAt(this.e);if(w===47||this.f&&w===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,N.$rf)(y,this.b,0,y.length,this.d,this.e):(0,N.$tf)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$zi=M;var b;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(b||(b={}));class m{constructor(y,w){this.f=y,this.g=w,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,N.$sf)(y,this.c.scheme);if(this.d[this.e]===2)return(0,N.$sf)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,N.$qf)(y,this.c.query);if(this.d[this.e]===5)return(0,N.$qf)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Ai=m;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(A||(A={}));class D{static forUris(y=()=>!1,w=()=>!1){return new D(new m(y,w))}static forPaths(y=!1){return new D(new M(void 0,!y))}static forStrings(){return new D(new L)}static forConfigKeys(){return new D(new R)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,w){if(w){const h=w.slice(0);(0,d.$Xb)(h);for(const g of h)this.set(g,y)}else{const h=y.slice(0);(0,d.$Xb)(h);for(const g of h)this.set(g[0],g[1])}}set(y,w){const h=this.b.reset(y);let g;this.c||(this.c=new E,this.c.segment=h.value());const a=[];for(g=this.c;;){const i=h.cmp(g.segment);if(i>0)g.left||(g.left=new E,g.left.segment=h.value()),a.push([-1,g]),g=g.left;else if(i<0)g.right||(g.right=new E,g.right.segment=h.value()),a.push([1,g]),g=g.right;else if(h.hasNext())h.next(),g.mid||(g.mid=new E,g.mid.segment=h.value()),a.push([0,g]),g=g.mid;else break}const n=g.value;g.value=w,g.key=y;for(let i=a.length-1;i>=0;i--){const u=a[i][1];u.updateHeight();const o=u.balanceFactor();if(o<-1||o>1){const t=a[i][0],l=a[i+1][0];if(t===1&&l===1)a[i][1]=u.rotateLeft();else if(t===-1&&l===-1)a[i][1]=u.rotateRight();else if(t===1&&l===-1)u.right=a[i+1][1]=a[i+1][1].rotateRight(),a[i][1]=u.rotateLeft();else if(t===-1&&l===1)u.left=a[i+1][1]=a[i+1][1].rotateLeft(),a[i][1]=u.rotateRight();else throw new Error;if(i>0)switch(a[i-1][0]){case-1:a[i-1][1].left=a[i][1];break;case 1:a[i-1][1].right=a[i][1];break;case 0:a[i-1][1].mid=a[i][1];break}else this.c=a[0][1]}}return n}get(y){return this.d(y)?.value}d(y){const w=this.b.reset(y);let h=this.c;for(;h;){const g=w.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(w.hasNext())w.next(),h=h.mid;else break}return h}has(y){const w=this.d(y);return!(w?.value===void 0&&w?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,w){const h=this.b.reset(y),g=[];let a=this.c;for(;a;){const n=h.cmp(a.segment);if(n>0)g.push([-1,a]),a=a.left;else if(n<0)g.push([1,a]),a=a.right;else if(h.hasNext())h.next(),g.push([0,a]),a=a.mid;else break}if(a){if(w?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const n=this.f(a.right);if(n.key){const{key:i,value:u,segment:o}=n;this.e(n.key,!1),a.key=i,a.value=u,a.segment=o}}else{const n=a.left??a.right;if(g.length>0){const[i,u]=g[g.length-1];switch(i){case-1:u.left=n;break;case 0:u.mid=n;break;case 1:u.right=n;break}}else this.c=n}for(let n=g.length-1;n>=0;n--){const i=g[n][1];i.updateHeight();const u=i.balanceFactor();if(u>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),g[n][1]=i.rotateLeft()):u<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),g[n][1]=i.rotateRight()),n>0)switch(g[n-1][0]){case-1:g[n-1][1].left=g[n][1];break;case 1:g[n-1][1].right=g[n][1];break;case 0:g[n-1][1].mid=g[n][1];break}else this.c=g[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const w=this.b.reset(y);let h=this.c,g;for(;h;){const a=w.cmp(h.segment);if(a>0)h=h.left;else if(a<0)h=h.right;else if(w.hasNext())w.next(),g=h.value||g,h=h.mid;else break}return h&&h.value||g}findSuperstr(y){return this.g(y,!1)}g(y,w){const h=this.b.reset(y);let g=this.c;for(;g;){const a=h.cmp(g.segment);if(a>0)g=g.left;else if(a<0)g=g.right;else if(h.hasNext())h.next(),g=g.mid;else return g.mid?this.h(g.mid):w?g.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[w,h]of this)y(h,w)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const w=[];return this.j(y,w),w[Symbol.iterator]()}j(y,w){y&&(y.left&&this.j(y.left,w),y.value&&w.push([y.key,y.value]),y.mid&&this.j(y.mid,w),y.right&&this.j(y.right,w))}_isBalanced(){const y=w=>{if(!w)return!0;const h=w.balanceFactor();return h<-1||h>1?!1:y(w.left)&&y(w.right)};return y(this.c)}}e.$Bi=D}),define(ke[18],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=d,e.$9f=N,e.$0f=L,e.$$f=R,e.$_f=M,e.$ag=b,e.$bg=m,e.$cg=E,e.$dg=A,e.$eg=D,e.$fg=$,e.$gg=y,e.$hg=w,e.$ig=g,e.$jg=a,e.$kg=n,e.$lg=i,e.$mg=u;function d(o){return typeof o=="string"}function N(o){return Array.isArray(o)&&o.every(t=>d(t))}function L(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function R(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}function M(o){return typeof o=="number"&&!isNaN(o)}function b(o){return!!o&&typeof o[Symbol.iterator]=="function"}function m(o){return o===!0||o===!1}function E(o){return typeof o>"u"}function A(o){return!D(o)}function D(o){return E(o)||o===null}function $(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function y(o){if(D(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function w(...o){const t=[];for(let l=0;l<o.length;l++){const r=o[l];if(D(r))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);t.push(r)}return t}const h=Object.prototype.hasOwnProperty;function g(o){if(!L(o))return!1;for(const t in o)if(h.call(o,t))return!1;return!0}function a(o){return typeof o=="function"}function n(...o){return o.length>0&&o.every(a)}function i(o,t){const l=Math.min(o.length,t.length);for(let r=0;r<l;r++)u(o[r],t[r])}function u(o,t){if(d(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(o instanceof t)return}catch{}if(!D(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[99],Pe([1,0,18]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=L,e.$Qj=R;const N=Object.create(null);function L(M,b){if((0,d.$8f)(b)){const m=N[b];if(m===void 0)throw new Error(`${M} references an unknown codicon: ${b}`);b=m}return N[M]=b,{id:M}}function R(){return N}}),define(ke[175],Pe([1,0,99]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=void 0,e.$Rj={add:(0,d.$Pj)("add",6e4),plus:(0,d.$Pj)("plus",6e4),gistNew:(0,d.$Pj)("gist-new",6e4),repoCreate:(0,d.$Pj)("repo-create",6e4),lightbulb:(0,d.$Pj)("lightbulb",60001),lightBulb:(0,d.$Pj)("light-bulb",60001),repo:(0,d.$Pj)("repo",60002),repoDelete:(0,d.$Pj)("repo-delete",60002),gistFork:(0,d.$Pj)("gist-fork",60003),repoForked:(0,d.$Pj)("repo-forked",60003),gitPullRequest:(0,d.$Pj)("git-pull-request",60004),gitPullRequestAbandoned:(0,d.$Pj)("git-pull-request-abandoned",60004),recordKeys:(0,d.$Pj)("record-keys",60005),keyboard:(0,d.$Pj)("keyboard",60005),tag:(0,d.$Pj)("tag",60006),gitPullRequestLabel:(0,d.$Pj)("git-pull-request-label",60006),tagAdd:(0,d.$Pj)("tag-add",60006),tagRemove:(0,d.$Pj)("tag-remove",60006),person:(0,d.$Pj)("person",60007),personFollow:(0,d.$Pj)("person-follow",60007),personOutline:(0,d.$Pj)("person-outline",60007),personFilled:(0,d.$Pj)("person-filled",60007),gitBranch:(0,d.$Pj)("git-branch",60008),gitBranchCreate:(0,d.$Pj)("git-branch-create",60008),gitBranchDelete:(0,d.$Pj)("git-branch-delete",60008),sourceControl:(0,d.$Pj)("source-control",60008),mirror:(0,d.$Pj)("mirror",60009),mirrorPublic:(0,d.$Pj)("mirror-public",60009),star:(0,d.$Pj)("star",60010),starAdd:(0,d.$Pj)("star-add",60010),starDelete:(0,d.$Pj)("star-delete",60010),starEmpty:(0,d.$Pj)("star-empty",60010),comment:(0,d.$Pj)("comment",60011),commentAdd:(0,d.$Pj)("comment-add",60011),alert:(0,d.$Pj)("alert",60012),warning:(0,d.$Pj)("warning",60012),search:(0,d.$Pj)("search",60013),searchSave:(0,d.$Pj)("search-save",60013),logOut:(0,d.$Pj)("log-out",60014),signOut:(0,d.$Pj)("sign-out",60014),logIn:(0,d.$Pj)("log-in",60015),signIn:(0,d.$Pj)("sign-in",60015),eye:(0,d.$Pj)("eye",60016),eyeUnwatch:(0,d.$Pj)("eye-unwatch",60016),eyeWatch:(0,d.$Pj)("eye-watch",60016),circleFilled:(0,d.$Pj)("circle-filled",60017),primitiveDot:(0,d.$Pj)("primitive-dot",60017),closeDirty:(0,d.$Pj)("close-dirty",60017),debugBreakpoint:(0,d.$Pj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,d.$Pj)("debug-breakpoint-disabled",60017),debugHint:(0,d.$Pj)("debug-hint",60017),terminalDecorationSuccess:(0,d.$Pj)("terminal-decoration-success",60017),primitiveSquare:(0,d.$Pj)("primitive-square",60018),edit:(0,d.$Pj)("edit",60019),pencil:(0,d.$Pj)("pencil",60019),info:(0,d.$Pj)("info",60020),issueOpened:(0,d.$Pj)("issue-opened",60020),gistPrivate:(0,d.$Pj)("gist-private",60021),gitForkPrivate:(0,d.$Pj)("git-fork-private",60021),lock:(0,d.$Pj)("lock",60021),mirrorPrivate:(0,d.$Pj)("mirror-private",60021),close:(0,d.$Pj)("close",60022),removeClose:(0,d.$Pj)("remove-close",60022),x:(0,d.$Pj)("x",60022),repoSync:(0,d.$Pj)("repo-sync",60023),sync:(0,d.$Pj)("sync",60023),clone:(0,d.$Pj)("clone",60024),desktopDownload:(0,d.$Pj)("desktop-download",60024),beaker:(0,d.$Pj)("beaker",60025),microscope:(0,d.$Pj)("microscope",60025),vm:(0,d.$Pj)("vm",60026),deviceDesktop:(0,d.$Pj)("device-desktop",60026),file:(0,d.$Pj)("file",60027),fileText:(0,d.$Pj)("file-text",60027),more:(0,d.$Pj)("more",60028),ellipsis:(0,d.$Pj)("ellipsis",60028),kebabHorizontal:(0,d.$Pj)("kebab-horizontal",60028),mailReply:(0,d.$Pj)("mail-reply",60029),reply:(0,d.$Pj)("reply",60029),organization:(0,d.$Pj)("organization",60030),organizationFilled:(0,d.$Pj)("organization-filled",60030),organizationOutline:(0,d.$Pj)("organization-outline",60030),newFile:(0,d.$Pj)("new-file",60031),fileAdd:(0,d.$Pj)("file-add",60031),newFolder:(0,d.$Pj)("new-folder",60032),fileDirectoryCreate:(0,d.$Pj)("file-directory-create",60032),trash:(0,d.$Pj)("trash",60033),trashcan:(0,d.$Pj)("trashcan",60033),history:(0,d.$Pj)("history",60034),clock:(0,d.$Pj)("clock",60034),folder:(0,d.$Pj)("folder",60035),fileDirectory:(0,d.$Pj)("file-directory",60035),symbolFolder:(0,d.$Pj)("symbol-folder",60035),logoGithub:(0,d.$Pj)("logo-github",60036),markGithub:(0,d.$Pj)("mark-github",60036),github:(0,d.$Pj)("github",60036),terminal:(0,d.$Pj)("terminal",60037),console:(0,d.$Pj)("console",60037),repl:(0,d.$Pj)("repl",60037),zap:(0,d.$Pj)("zap",60038),symbolEvent:(0,d.$Pj)("symbol-event",60038),error:(0,d.$Pj)("error",60039),stop:(0,d.$Pj)("stop",60039),variable:(0,d.$Pj)("variable",60040),symbolVariable:(0,d.$Pj)("symbol-variable",60040),array:(0,d.$Pj)("array",60042),symbolArray:(0,d.$Pj)("symbol-array",60042),symbolModule:(0,d.$Pj)("symbol-module",60043),symbolPackage:(0,d.$Pj)("symbol-package",60043),symbolNamespace:(0,d.$Pj)("symbol-namespace",60043),symbolObject:(0,d.$Pj)("symbol-object",60043),symbolMethod:(0,d.$Pj)("symbol-method",60044),symbolFunction:(0,d.$Pj)("symbol-function",60044),symbolConstructor:(0,d.$Pj)("symbol-constructor",60044),symbolBoolean:(0,d.$Pj)("symbol-boolean",60047),symbolNull:(0,d.$Pj)("symbol-null",60047),symbolNumeric:(0,d.$Pj)("symbol-numeric",60048),symbolNumber:(0,d.$Pj)("symbol-number",60048),symbolStructure:(0,d.$Pj)("symbol-structure",60049),symbolStruct:(0,d.$Pj)("symbol-struct",60049),symbolParameter:(0,d.$Pj)("symbol-parameter",60050),symbolTypeParameter:(0,d.$Pj)("symbol-type-parameter",60050),symbolKey:(0,d.$Pj)("symbol-key",60051),symbolText:(0,d.$Pj)("symbol-text",60051),symbolReference:(0,d.$Pj)("symbol-reference",60052),goToFile:(0,d.$Pj)("go-to-file",60052),symbolEnum:(0,d.$Pj)("symbol-enum",60053),symbolValue:(0,d.$Pj)("symbol-value",60053),symbolRuler:(0,d.$Pj)("symbol-ruler",60054),symbolUnit:(0,d.$Pj)("symbol-unit",60054),activateBreakpoints:(0,d.$Pj)("activate-breakpoints",60055),archive:(0,d.$Pj)("archive",60056),arrowBoth:(0,d.$Pj)("arrow-both",60057),arrowDown:(0,d.$Pj)("arrow-down",60058),arrowLeft:(0,d.$Pj)("arrow-left",60059),arrowRight:(0,d.$Pj)("arrow-right",60060),arrowSmallDown:(0,d.$Pj)("arrow-small-down",60061),arrowSmallLeft:(0,d.$Pj)("arrow-small-left",60062),arrowSmallRight:(0,d.$Pj)("arrow-small-right",60063),arrowSmallUp:(0,d.$Pj)("arrow-small-up",60064),arrowUp:(0,d.$Pj)("arrow-up",60065),bell:(0,d.$Pj)("bell",60066),bold:(0,d.$Pj)("bold",60067),book:(0,d.$Pj)("book",60068),bookmark:(0,d.$Pj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,d.$Pj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,d.$Pj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,d.$Pj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,d.$Pj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,d.$Pj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,d.$Pj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,d.$Pj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,d.$Pj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,d.$Pj)("debug-breakpoint-log-disabled",60075),briefcase:(0,d.$Pj)("briefcase",60076),broadcast:(0,d.$Pj)("broadcast",60077),browser:(0,d.$Pj)("browser",60078),bug:(0,d.$Pj)("bug",60079),calendar:(0,d.$Pj)("calendar",60080),caseSensitive:(0,d.$Pj)("case-sensitive",60081),check:(0,d.$Pj)("check",60082),checklist:(0,d.$Pj)("checklist",60083),chevronDown:(0,d.$Pj)("chevron-down",60084),chevronLeft:(0,d.$Pj)("chevron-left",60085),chevronRight:(0,d.$Pj)("chevron-right",60086),chevronUp:(0,d.$Pj)("chevron-up",60087),chromeClose:(0,d.$Pj)("chrome-close",60088),chromeMaximize:(0,d.$Pj)("chrome-maximize",60089),chromeMinimize:(0,d.$Pj)("chrome-minimize",60090),chromeRestore:(0,d.$Pj)("chrome-restore",60091),circleOutline:(0,d.$Pj)("circle-outline",60092),circle:(0,d.$Pj)("circle",60092),debugBreakpointUnverified:(0,d.$Pj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,d.$Pj)("terminal-decoration-incomplete",60092),circleSlash:(0,d.$Pj)("circle-slash",60093),circuitBoard:(0,d.$Pj)("circuit-board",60094),clearAll:(0,d.$Pj)("clear-all",60095),clippy:(0,d.$Pj)("clippy",60096),closeAll:(0,d.$Pj)("close-all",60097),cloudDownload:(0,d.$Pj)("cloud-download",60098),cloudUpload:(0,d.$Pj)("cloud-upload",60099),code:(0,d.$Pj)("code",60100),collapseAll:(0,d.$Pj)("collapse-all",60101),colorMode:(0,d.$Pj)("color-mode",60102),commentDiscussion:(0,d.$Pj)("comment-discussion",60103),creditCard:(0,d.$Pj)("credit-card",60105),dash:(0,d.$Pj)("dash",60108),dashboard:(0,d.$Pj)("dashboard",60109),database:(0,d.$Pj)("database",60110),debugContinue:(0,d.$Pj)("debug-continue",60111),debugDisconnect:(0,d.$Pj)("debug-disconnect",60112),debugPause:(0,d.$Pj)("debug-pause",60113),debugRestart:(0,d.$Pj)("debug-restart",60114),debugStart:(0,d.$Pj)("debug-start",60115),debugStepInto:(0,d.$Pj)("debug-step-into",60116),debugStepOut:(0,d.$Pj)("debug-step-out",60117),debugStepOver:(0,d.$Pj)("debug-step-over",60118),debugStop:(0,d.$Pj)("debug-stop",60119),debug:(0,d.$Pj)("debug",60120),deviceCameraVideo:(0,d.$Pj)("device-camera-video",60121),deviceCamera:(0,d.$Pj)("device-camera",60122),deviceMobile:(0,d.$Pj)("device-mobile",60123),diffAdded:(0,d.$Pj)("diff-added",60124),diffIgnored:(0,d.$Pj)("diff-ignored",60125),diffModified:(0,d.$Pj)("diff-modified",60126),diffRemoved:(0,d.$Pj)("diff-removed",60127),diffRenamed:(0,d.$Pj)("diff-renamed",60128),diff:(0,d.$Pj)("diff",60129),diffSidebyside:(0,d.$Pj)("diff-sidebyside",60129),discard:(0,d.$Pj)("discard",60130),editorLayout:(0,d.$Pj)("editor-layout",60131),emptyWindow:(0,d.$Pj)("empty-window",60132),exclude:(0,d.$Pj)("exclude",60133),extensions:(0,d.$Pj)("extensions",60134),eyeClosed:(0,d.$Pj)("eye-closed",60135),fileBinary:(0,d.$Pj)("file-binary",60136),fileCode:(0,d.$Pj)("file-code",60137),fileMedia:(0,d.$Pj)("file-media",60138),filePdf:(0,d.$Pj)("file-pdf",60139),fileSubmodule:(0,d.$Pj)("file-submodule",60140),fileSymlinkDirectory:(0,d.$Pj)("file-symlink-directory",60141),fileSymlinkFile:(0,d.$Pj)("file-symlink-file",60142),fileZip:(0,d.$Pj)("file-zip",60143),files:(0,d.$Pj)("files",60144),filter:(0,d.$Pj)("filter",60145),flame:(0,d.$Pj)("flame",60146),foldDown:(0,d.$Pj)("fold-down",60147),foldUp:(0,d.$Pj)("fold-up",60148),fold:(0,d.$Pj)("fold",60149),folderActive:(0,d.$Pj)("folder-active",60150),folderOpened:(0,d.$Pj)("folder-opened",60151),gear:(0,d.$Pj)("gear",60152),gift:(0,d.$Pj)("gift",60153),gistSecret:(0,d.$Pj)("gist-secret",60154),gist:(0,d.$Pj)("gist",60155),gitCommit:(0,d.$Pj)("git-commit",60156),gitCompare:(0,d.$Pj)("git-compare",60157),compareChanges:(0,d.$Pj)("compare-changes",60157),gitMerge:(0,d.$Pj)("git-merge",60158),githubAction:(0,d.$Pj)("github-action",60159),githubAlt:(0,d.$Pj)("github-alt",60160),globe:(0,d.$Pj)("globe",60161),grabber:(0,d.$Pj)("grabber",60162),graph:(0,d.$Pj)("graph",60163),gripper:(0,d.$Pj)("gripper",60164),heart:(0,d.$Pj)("heart",60165),home:(0,d.$Pj)("home",60166),horizontalRule:(0,d.$Pj)("horizontal-rule",60167),hubot:(0,d.$Pj)("hubot",60168),inbox:(0,d.$Pj)("inbox",60169),issueReopened:(0,d.$Pj)("issue-reopened",60171),issues:(0,d.$Pj)("issues",60172),italic:(0,d.$Pj)("italic",60173),jersey:(0,d.$Pj)("jersey",60174),json:(0,d.$Pj)("json",60175),kebabVertical:(0,d.$Pj)("kebab-vertical",60176),key:(0,d.$Pj)("key",60177),law:(0,d.$Pj)("law",60178),lightbulbAutofix:(0,d.$Pj)("lightbulb-autofix",60179),linkExternal:(0,d.$Pj)("link-external",60180),link:(0,d.$Pj)("link",60181),listOrdered:(0,d.$Pj)("list-ordered",60182),listUnordered:(0,d.$Pj)("list-unordered",60183),liveShare:(0,d.$Pj)("live-share",60184),loading:(0,d.$Pj)("loading",60185),location:(0,d.$Pj)("location",60186),mailRead:(0,d.$Pj)("mail-read",60187),mail:(0,d.$Pj)("mail",60188),markdown:(0,d.$Pj)("markdown",60189),megaphone:(0,d.$Pj)("megaphone",60190),mention:(0,d.$Pj)("mention",60191),milestone:(0,d.$Pj)("milestone",60192),gitPullRequestMilestone:(0,d.$Pj)("git-pull-request-milestone",60192),mortarBoard:(0,d.$Pj)("mortar-board",60193),move:(0,d.$Pj)("move",60194),multipleWindows:(0,d.$Pj)("multiple-windows",60195),mute:(0,d.$Pj)("mute",60196),noNewline:(0,d.$Pj)("no-newline",60197),note:(0,d.$Pj)("note",60198),octoface:(0,d.$Pj)("octoface",60199),openPreview:(0,d.$Pj)("open-preview",60200),package:(0,d.$Pj)("package",60201),paintcan:(0,d.$Pj)("paintcan",60202),pin:(0,d.$Pj)("pin",60203),play:(0,d.$Pj)("play",60204),run:(0,d.$Pj)("run",60204),plug:(0,d.$Pj)("plug",60205),preserveCase:(0,d.$Pj)("preserve-case",60206),preview:(0,d.$Pj)("preview",60207),project:(0,d.$Pj)("project",60208),pulse:(0,d.$Pj)("pulse",60209),question:(0,d.$Pj)("question",60210),quote:(0,d.$Pj)("quote",60211),radioTower:(0,d.$Pj)("radio-tower",60212),reactions:(0,d.$Pj)("reactions",60213),references:(0,d.$Pj)("references",60214),refresh:(0,d.$Pj)("refresh",60215),regex:(0,d.$Pj)("regex",60216),remoteExplorer:(0,d.$Pj)("remote-explorer",60217),remote:(0,d.$Pj)("remote",60218),remove:(0,d.$Pj)("remove",60219),replaceAll:(0,d.$Pj)("replace-all",60220),replace:(0,d.$Pj)("replace",60221),repoClone:(0,d.$Pj)("repo-clone",60222),repoForcePush:(0,d.$Pj)("repo-force-push",60223),repoPull:(0,d.$Pj)("repo-pull",60224),repoPush:(0,d.$Pj)("repo-push",60225),report:(0,d.$Pj)("report",60226),requestChanges:(0,d.$Pj)("request-changes",60227),rocket:(0,d.$Pj)("rocket",60228),rootFolderOpened:(0,d.$Pj)("root-folder-opened",60229),rootFolder:(0,d.$Pj)("root-folder",60230),rss:(0,d.$Pj)("rss",60231),ruby:(0,d.$Pj)("ruby",60232),saveAll:(0,d.$Pj)("save-all",60233),saveAs:(0,d.$Pj)("save-as",60234),save:(0,d.$Pj)("save",60235),screenFull:(0,d.$Pj)("screen-full",60236),screenNormal:(0,d.$Pj)("screen-normal",60237),searchStop:(0,d.$Pj)("search-stop",60238),server:(0,d.$Pj)("server",60240),settingsGear:(0,d.$Pj)("settings-gear",60241),settings:(0,d.$Pj)("settings",60242),shield:(0,d.$Pj)("shield",60243),smiley:(0,d.$Pj)("smiley",60244),sortPrecedence:(0,d.$Pj)("sort-precedence",60245),splitHorizontal:(0,d.$Pj)("split-horizontal",60246),splitVertical:(0,d.$Pj)("split-vertical",60247),squirrel:(0,d.$Pj)("squirrel",60248),starFull:(0,d.$Pj)("star-full",60249),starHalf:(0,d.$Pj)("star-half",60250),symbolClass:(0,d.$Pj)("symbol-class",60251),symbolColor:(0,d.$Pj)("symbol-color",60252),symbolConstant:(0,d.$Pj)("symbol-constant",60253),symbolEnumMember:(0,d.$Pj)("symbol-enum-member",60254),symbolField:(0,d.$Pj)("symbol-field",60255),symbolFile:(0,d.$Pj)("symbol-file",60256),symbolInterface:(0,d.$Pj)("symbol-interface",60257),symbolKeyword:(0,d.$Pj)("symbol-keyword",60258),symbolMisc:(0,d.$Pj)("symbol-misc",60259),symbolOperator:(0,d.$Pj)("symbol-operator",60260),symbolProperty:(0,d.$Pj)("symbol-property",60261),wrench:(0,d.$Pj)("wrench",60261),wrenchSubaction:(0,d.$Pj)("wrench-subaction",60261),symbolSnippet:(0,d.$Pj)("symbol-snippet",60262),tasklist:(0,d.$Pj)("tasklist",60263),telescope:(0,d.$Pj)("telescope",60264),textSize:(0,d.$Pj)("text-size",60265),threeBars:(0,d.$Pj)("three-bars",60266),thumbsdown:(0,d.$Pj)("thumbsdown",60267),thumbsup:(0,d.$Pj)("thumbsup",60268),tools:(0,d.$Pj)("tools",60269),triangleDown:(0,d.$Pj)("triangle-down",60270),triangleLeft:(0,d.$Pj)("triangle-left",60271),triangleRight:(0,d.$Pj)("triangle-right",60272),triangleUp:(0,d.$Pj)("triangle-up",60273),twitter:(0,d.$Pj)("twitter",60274),unfold:(0,d.$Pj)("unfold",60275),unlock:(0,d.$Pj)("unlock",60276),unmute:(0,d.$Pj)("unmute",60277),unverified:(0,d.$Pj)("unverified",60278),verified:(0,d.$Pj)("verified",60279),versions:(0,d.$Pj)("versions",60280),vmActive:(0,d.$Pj)("vm-active",60281),vmOutline:(0,d.$Pj)("vm-outline",60282),vmRunning:(0,d.$Pj)("vm-running",60283),watch:(0,d.$Pj)("watch",60284),whitespace:(0,d.$Pj)("whitespace",60285),wholeWord:(0,d.$Pj)("whole-word",60286),window:(0,d.$Pj)("window",60287),wordWrap:(0,d.$Pj)("word-wrap",60288),zoomIn:(0,d.$Pj)("zoom-in",60289),zoomOut:(0,d.$Pj)("zoom-out",60290),listFilter:(0,d.$Pj)("list-filter",60291),listFlat:(0,d.$Pj)("list-flat",60292),listSelection:(0,d.$Pj)("list-selection",60293),selection:(0,d.$Pj)("selection",60293),listTree:(0,d.$Pj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,d.$Pj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,d.$Pj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,d.$Pj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,d.$Pj)("debug-stackframe-active",60297),circleSmallFilled:(0,d.$Pj)("circle-small-filled",60298),debugStackframeDot:(0,d.$Pj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,d.$Pj)("terminal-decoration-mark",60298),debugStackframe:(0,d.$Pj)("debug-stackframe",60299),debugStackframeFocused:(0,d.$Pj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,d.$Pj)("debug-breakpoint-unsupported",60300),symbolString:(0,d.$Pj)("symbol-string",60301),debugReverseContinue:(0,d.$Pj)("debug-reverse-continue",60302),debugStepBack:(0,d.$Pj)("debug-step-back",60303),debugRestartFrame:(0,d.$Pj)("debug-restart-frame",60304),debugAlt:(0,d.$Pj)("debug-alt",60305),callIncoming:(0,d.$Pj)("call-incoming",60306),callOutgoing:(0,d.$Pj)("call-outgoing",60307),menu:(0,d.$Pj)("menu",60308),expandAll:(0,d.$Pj)("expand-all",60309),feedback:(0,d.$Pj)("feedback",60310),gitPullRequestReviewer:(0,d.$Pj)("git-pull-request-reviewer",60310),groupByRefType:(0,d.$Pj)("group-by-ref-type",60311),ungroupByRefType:(0,d.$Pj)("ungroup-by-ref-type",60312),account:(0,d.$Pj)("account",60313),gitPullRequestAssignee:(0,d.$Pj)("git-pull-request-assignee",60313),bellDot:(0,d.$Pj)("bell-dot",60314),debugConsole:(0,d.$Pj)("debug-console",60315),library:(0,d.$Pj)("library",60316),output:(0,d.$Pj)("output",60317),runAll:(0,d.$Pj)("run-all",60318),syncIgnored:(0,d.$Pj)("sync-ignored",60319),pinned:(0,d.$Pj)("pinned",60320),githubInverted:(0,d.$Pj)("github-inverted",60321),serverProcess:(0,d.$Pj)("server-process",60322),serverEnvironment:(0,d.$Pj)("server-environment",60323),pass:(0,d.$Pj)("pass",60324),issueClosed:(0,d.$Pj)("issue-closed",60324),stopCircle:(0,d.$Pj)("stop-circle",60325),playCircle:(0,d.$Pj)("play-circle",60326),record:(0,d.$Pj)("record",60327),debugAltSmall:(0,d.$Pj)("debug-alt-small",60328),vmConnect:(0,d.$Pj)("vm-connect",60329),cloud:(0,d.$Pj)("cloud",60330),merge:(0,d.$Pj)("merge",60331),export:(0,d.$Pj)("export",60332),graphLeft:(0,d.$Pj)("graph-left",60333),magnet:(0,d.$Pj)("magnet",60334),notebook:(0,d.$Pj)("notebook",60335),redo:(0,d.$Pj)("redo",60336),checkAll:(0,d.$Pj)("check-all",60337),pinnedDirty:(0,d.$Pj)("pinned-dirty",60338),passFilled:(0,d.$Pj)("pass-filled",60339),circleLargeFilled:(0,d.$Pj)("circle-large-filled",60340),circleLarge:(0,d.$Pj)("circle-large",60341),circleLargeOutline:(0,d.$Pj)("circle-large-outline",60341),combine:(0,d.$Pj)("combine",60342),gather:(0,d.$Pj)("gather",60342),table:(0,d.$Pj)("table",60343),variableGroup:(0,d.$Pj)("variable-group",60344),typeHierarchy:(0,d.$Pj)("type-hierarchy",60345),typeHierarchySub:(0,d.$Pj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,d.$Pj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,d.$Pj)("git-pull-request-create",60348),runAbove:(0,d.$Pj)("run-above",60349),runBelow:(0,d.$Pj)("run-below",60350),notebookTemplate:(0,d.$Pj)("notebook-template",60351),debugRerun:(0,d.$Pj)("debug-rerun",60352),workspaceTrusted:(0,d.$Pj)("workspace-trusted",60353),workspaceUntrusted:(0,d.$Pj)("workspace-untrusted",60354),workspaceUnknown:(0,d.$Pj)("workspace-unknown",60355),terminalCmd:(0,d.$Pj)("terminal-cmd",60356),terminalDebian:(0,d.$Pj)("terminal-debian",60357),terminalLinux:(0,d.$Pj)("terminal-linux",60358),terminalPowershell:(0,d.$Pj)("terminal-powershell",60359),terminalTmux:(0,d.$Pj)("terminal-tmux",60360),terminalUbuntu:(0,d.$Pj)("terminal-ubuntu",60361),terminalBash:(0,d.$Pj)("terminal-bash",60362),arrowSwap:(0,d.$Pj)("arrow-swap",60363),copy:(0,d.$Pj)("copy",60364),personAdd:(0,d.$Pj)("person-add",60365),filterFilled:(0,d.$Pj)("filter-filled",60366),wand:(0,d.$Pj)("wand",60367),debugLineByLine:(0,d.$Pj)("debug-line-by-line",60368),inspect:(0,d.$Pj)("inspect",60369),layers:(0,d.$Pj)("layers",60370),layersDot:(0,d.$Pj)("layers-dot",60371),layersActive:(0,d.$Pj)("layers-active",60372),compass:(0,d.$Pj)("compass",60373),compassDot:(0,d.$Pj)("compass-dot",60374),compassActive:(0,d.$Pj)("compass-active",60375),azure:(0,d.$Pj)("azure",60376),issueDraft:(0,d.$Pj)("issue-draft",60377),gitPullRequestClosed:(0,d.$Pj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,d.$Pj)("git-pull-request-draft",60379),debugAll:(0,d.$Pj)("debug-all",60380),debugCoverage:(0,d.$Pj)("debug-coverage",60381),runErrors:(0,d.$Pj)("run-errors",60382),folderLibrary:(0,d.$Pj)("folder-library",60383),debugContinueSmall:(0,d.$Pj)("debug-continue-small",60384),beakerStop:(0,d.$Pj)("beaker-stop",60385),graphLine:(0,d.$Pj)("graph-line",60386),graphScatter:(0,d.$Pj)("graph-scatter",60387),pieChart:(0,d.$Pj)("pie-chart",60388),bracket:(0,d.$Pj)("bracket",60175),bracketDot:(0,d.$Pj)("bracket-dot",60389),bracketError:(0,d.$Pj)("bracket-error",60390),lockSmall:(0,d.$Pj)("lock-small",60391),azureDevops:(0,d.$Pj)("azure-devops",60392),verifiedFilled:(0,d.$Pj)("verified-filled",60393),newline:(0,d.$Pj)("newline",60394),layout:(0,d.$Pj)("layout",60395),layoutActivitybarLeft:(0,d.$Pj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,d.$Pj)("layout-activitybar-right",60397),layoutPanelLeft:(0,d.$Pj)("layout-panel-left",60398),layoutPanelCenter:(0,d.$Pj)("layout-panel-center",60399),layoutPanelJustify:(0,d.$Pj)("layout-panel-justify",60400),layoutPanelRight:(0,d.$Pj)("layout-panel-right",60401),layoutPanel:(0,d.$Pj)("layout-panel",60402),layoutSidebarLeft:(0,d.$Pj)("layout-sidebar-left",60403),layoutSidebarRight:(0,d.$Pj)("layout-sidebar-right",60404),layoutStatusbar:(0,d.$Pj)("layout-statusbar",60405),layoutMenubar:(0,d.$Pj)("layout-menubar",60406),layoutCentered:(0,d.$Pj)("layout-centered",60407),target:(0,d.$Pj)("target",60408),indent:(0,d.$Pj)("indent",60409),recordSmall:(0,d.$Pj)("record-small",60410),errorSmall:(0,d.$Pj)("error-small",60411),terminalDecorationError:(0,d.$Pj)("terminal-decoration-error",60411),arrowCircleDown:(0,d.$Pj)("arrow-circle-down",60412),arrowCircleLeft:(0,d.$Pj)("arrow-circle-left",60413),arrowCircleRight:(0,d.$Pj)("arrow-circle-right",60414),arrowCircleUp:(0,d.$Pj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,d.$Pj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,d.$Pj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,d.$Pj)("layout-sidebar-left-off",60418),blank:(0,d.$Pj)("blank",60419),heartFilled:(0,d.$Pj)("heart-filled",60420),map:(0,d.$Pj)("map",60421),mapHorizontal:(0,d.$Pj)("map-horizontal",60421),foldHorizontal:(0,d.$Pj)("fold-horizontal",60421),mapFilled:(0,d.$Pj)("map-filled",60422),mapHorizontalFilled:(0,d.$Pj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,d.$Pj)("fold-horizontal-filled",60422),circleSmall:(0,d.$Pj)("circle-small",60423),bellSlash:(0,d.$Pj)("bell-slash",60424),bellSlashDot:(0,d.$Pj)("bell-slash-dot",60425),commentUnresolved:(0,d.$Pj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,d.$Pj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,d.$Pj)("git-pull-request-new-changes",60428),searchFuzzy:(0,d.$Pj)("search-fuzzy",60429),commentDraft:(0,d.$Pj)("comment-draft",60430),send:(0,d.$Pj)("send",60431),sparkle:(0,d.$Pj)("sparkle",60432),insert:(0,d.$Pj)("insert",60433),mic:(0,d.$Pj)("mic",60434),thumbsdownFilled:(0,d.$Pj)("thumbsdown-filled",60435),thumbsupFilled:(0,d.$Pj)("thumbsup-filled",60436),coffee:(0,d.$Pj)("coffee",60437),snake:(0,d.$Pj)("snake",60438),game:(0,d.$Pj)("game",60439),vr:(0,d.$Pj)("vr",60440),chip:(0,d.$Pj)("chip",60441),piano:(0,d.$Pj)("piano",60442),music:(0,d.$Pj)("music",60443),micFilled:(0,d.$Pj)("mic-filled",60444),repoFetch:(0,d.$Pj)("repo-fetch",60445),copilot:(0,d.$Pj)("copilot",60446),lightbulbSparkle:(0,d.$Pj)("lightbulb-sparkle",60447),robot:(0,d.$Pj)("robot",60448),sparkleFilled:(0,d.$Pj)("sparkle-filled",60449),diffSingle:(0,d.$Pj)("diff-single",60450),diffMultiple:(0,d.$Pj)("diff-multiple",60451),surroundWith:(0,d.$Pj)("surround-with",60452),share:(0,d.$Pj)("share",60453),gitStash:(0,d.$Pj)("git-stash",60454),gitStashApply:(0,d.$Pj)("git-stash-apply",60455),gitStashPop:(0,d.$Pj)("git-stash-pop",60456),vscode:(0,d.$Pj)("vscode",60457),vscodeInsiders:(0,d.$Pj)("vscode-insiders",60458),codeOss:(0,d.$Pj)("code-oss",60459),runCoverage:(0,d.$Pj)("run-coverage",60460),runAllCoverage:(0,d.$Pj)("run-all-coverage",60461),coverage:(0,d.$Pj)("coverage",60462),githubProject:(0,d.$Pj)("github-project",60463),mapVertical:(0,d.$Pj)("map-vertical",60464),foldVertical:(0,d.$Pj)("fold-vertical",60464),mapVerticalFilled:(0,d.$Pj)("map-vertical-filled",60465),foldVerticalFilled:(0,d.$Pj)("fold-vertical-filled",60465),goToSearch:(0,d.$Pj)("go-to-search",60466),percentage:(0,d.$Pj)("percentage",60467),sortPercentage:(0,d.$Pj)("sort-percentage",60467)}}),define(ke[79],Pe([1,0,99,175]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=void 0,e.$Sj=L;function L(){return Object.values(e.$Uj)}e.$Tj={dialogError:(0,d.$Pj)("dialog-error","error"),dialogWarning:(0,d.$Pj)("dialog-warning","warning"),dialogInfo:(0,d.$Pj)("dialog-info","info"),dialogClose:(0,d.$Pj)("dialog-close","close"),treeItemExpanded:(0,d.$Pj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,d.$Pj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,d.$Pj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,d.$Pj)("tree-filter-clear","close"),treeItemLoading:(0,d.$Pj)("tree-item-loading","loading"),menuSelection:(0,d.$Pj)("menu-selection","check"),menuSubmenu:(0,d.$Pj)("menu-submenu","chevron-right"),menuBarMore:(0,d.$Pj)("menubar-more","more"),scrollbarButtonLeft:(0,d.$Pj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,d.$Pj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,d.$Pj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,d.$Pj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,d.$Pj)("toolbar-more","more"),quickInputBack:(0,d.$Pj)("quick-input-back","arrow-left"),dropDownButton:(0,d.$Pj)("drop-down-button",60084),symbolCustomColor:(0,d.$Pj)("symbol-customcolor",60252),exportIcon:(0,d.$Pj)("export",60332),workspaceUnspecified:(0,d.$Pj)("workspace-unspecified",60355),newLine:(0,d.$Pj)("newline",60394),thumbsDownFilled:(0,d.$Pj)("thumbsdown-filled",60435),thumbsUpFilled:(0,d.$Pj)("thumbsup-filled",60436),gitFetch:(0,d.$Pj)("git-fetch",60445),lightbulbSparkleAutofix:(0,d.$Pj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,d.$Pj)("debug-breakpoint-pending",60377)},e.$Uj={...N.$Rj,...e.$Tj}}),define(ke[24],Pe([1,0,18]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=N,e.$3n=L,e.$4n=M,e.$5n=m,e.$6n=E,e.$7n=A,e.$8n=D,e.$9n=$,e.$0n=y,e.$$n=w,e.$_n=h,e.$ao=g;function N(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const n=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([i,u])=>{n[i]=u&&typeof u=="object"?N(u):u}),n}function L(a){if(!a||typeof a!="object")return a;const n=[a];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const u in i)if(R.call(i,u)){const o=i[u];typeof o=="object"&&!Object.isFrozen(o)&&!(0,d.$$f)(o)&&n.push(o)}}return a}const R=Object.prototype.hasOwnProperty;function M(a,n){return b(a,n,new Set)}function b(a,n,i){if((0,d.$eg)(a))return a;const u=n(a);if(typeof u<"u")return u;if(Array.isArray(a)){const o=[];for(const t of a)o.push(b(t,n,i));return o}if((0,d.$0f)(a)){if(i.has(a))throw new Error("Cannot clone recursive data-structure");i.add(a);const o={};for(const t in a)R.call(a,t)&&(o[t]=b(a[t],n,i));return i.delete(a),o}return a}function m(a,n,i=!0){return(0,d.$0f)(a)?((0,d.$0f)(n)&&Object.keys(n).forEach(u=>{u in a?i&&((0,d.$0f)(a[u])&&(0,d.$0f)(n[u])?m(a[u],n[u],i):a[u]=n[u]):a[u]=n[u]}),a):n}function E(a,n){if(a===n)return!0;if(a==null||n===null||n===void 0||typeof a!=typeof n||typeof a!="object"||Array.isArray(a)!==Array.isArray(n))return!1;let i,u;if(Array.isArray(a)){if(a.length!==n.length)return!1;for(i=0;i<a.length;i++)if(!E(a[i],n[i]))return!1}else{const o=[];for(u in a)o.push(u);o.sort();const t=[];for(u in n)t.push(u);if(t.sort(),!E(o,t))return!1;for(i=0;i<o.length;i++)if(!E(a[o[i]],n[o[i]]))return!1}return!0}function A(a){const n=new Set;return JSON.stringify(a,(i,u)=>{if((0,d.$0f)(u)||Array.isArray(u)){if(n.has(u))return"[Circular]";n.add(u)}return typeof u=="bigint"?`[BigInt ${u.toString()}]`:u})}function D(a,n){const i=Object.create(null);return!a||!n||Object.keys(n).forEach(o=>{const t=a[o],l=n[o];E(t,l)||(i[o]=l)}),i}function $(a,n){const i=n.toLowerCase(),u=Object.keys(a).find(o=>o.toLowerCase()===i);return u?a[u]:a[n]}function y(a,n){const i=Object.create(null);for(const[u,o]of Object.entries(a))n(u,o)&&(i[u]=o);return i}function w(a){let n=[];for(;Object.prototype!==a;)n=n.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return n}function h(a){const n=[];for(const i of w(a))typeof a[i]=="function"&&n.push(i);return n}function g(a,n){const i=o=>function(){const t=Array.prototype.slice.call(arguments,0);return n(o,t)},u={};for(const o of a)u[o]=i(o);return u}}),define(ke[57],Pe([1,0,79]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Vj=L;var N;(function(M){function b(m){return m&&typeof m=="object"&&typeof m.id=="string"}M.isThemeColor=b})(N||(e.ThemeColor=N={}));function L(M){return{id:M}}var R;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function m(n){const i=b.exec(n.id);if(!i)return m(d.$Uj.error);const[,u,o]=i,t=["codicon","codicon-"+u];return o&&t.push("codicon-modifier-"+o.substring(1)),t}M.asClassNameArray=m;function E(n){return m(n).join(" ")}M.asClassName=E;function A(n){return"."+m(n).join(".")}M.asCSSSelector=A;function D(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||N.isThemeColor(n.color))}M.isThemeIcon=D;const $=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function y(n){const i=$.exec(n);if(!i)return;const[,u]=i;return{id:u}}M.fromString=y;function w(n){return{id:n}}M.fromId=w;function h(n,i){let u=n.id;const o=u.lastIndexOf("~");return o!==-1&&(u=u.substring(0,o)),i&&(u=`${u}~${i}`),{id:u}}M.modify=h;function g(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}M.getModifier=g;function a(n,i){return n.id===i.id&&n.color?.id===i.color?.id}M.isEqual=a})(R||(e.ThemeIcon=R={}))}),define(ke[176],Pe([1,0,127,14,57]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=m,e.$Nk=A,e.$Ok=$,e.$Pk=y,e.$Qk=h,e.$Rk=g;const R="$(",M=new RegExp(`\\$\\(${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${M.source}`,"g");function m(a){return a.replace(b,(n,i)=>i?n:`\\${n}`)}const E=new RegExp(`\\\\${M.source}`,"g");function A(a){return a.replace(E,n=>`\\${n}`)}const D=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function $(a){return a.indexOf(R)===-1?a:a.replace(D,(n,i,u,o)=>u?n:i||o||"")}function y(a){return a?a.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const w=new RegExp(`\\$\\(${L.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(a){w.lastIndex=0;let n="";const i=[];let u=0;for(;;){const o=w.lastIndex,t=w.exec(a),l=a.substring(o,t?.index);if(l.length>0){n+=l;for(let r=0;r<l.length;r++)i.push(u)}if(!t)break;u+=t[0].length}return{text:n,iconOffsets:i}}function g(a,n,i=!1){const{text:u,iconOffsets:o}=n;if(!o||o.length===0)return(0,d.$Dk)(a,u,i);const t=(0,N.$ef)(u," "),l=u.length-t.length,r=(0,d.$Dk)(a,t,i);if(r)for(const c of r){const s=o[c.start+l]+l;c.start+=s,c.end+=s}return r}}),define(ke[128],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$5e=N,e.$6e=L;var d;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(d||(e.Constants=d={}));function N(R){return R<0?0:R>255?255:R|0}function L(R){return R<0?0:R>4294967295?4294967295:R|0}}),define(ke[30],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=void 0,e.$Qg=N;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return d.test(L)}e.$Rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(b){for(let m=0;m<b.length;m++)b[m]=Math.floor(Math.random()*256);return b};const R=new Uint8Array(16),M=[];for(let b=0;b<256;b++)M.push(b.toString(16).padStart(2,"0"));return function(){L(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let m=0,E="";return E+=M[R[m++]],E+=M[R[m++]],E+=M[R[m++]],E+=M[R[m++]],E+="-",E+=M[R[m++]],E+=M[R[m++]],E+="-",E+=M[R[m++]],E+=M[R[m++]],E+="-",E+=M[R[m++]],E+=M[R[m++]],E+="-",E+=M[R[m++]],E+=M[R[m++]],E+=M[R[m++]],E+=M[R[m++]],E+=M[R[m++]],E+=M[R[m++]],E}}()}),define(ke[177],Pe([1,0,19,39,30]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=e.$Rt=void 0,e.$Pt=R,e.$Qt=M,e.$St=E;function R(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}function M(D,$,y){const w={id:(0,L.$Rg)(),name:D,uri:$,data:y};return{asString:async()=>"",asFile:()=>w,value:void 0}}class b{constructor(){this.a=new Map}get size(){let $=0;for(const y of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const y=[...this.a.keys()];return N.Iterable.some(this,([w,h])=>h.asFile())&&y.push("files"),A(m($),y)}get($){return this.a.get(this.b($))?.[0]}append($,y){const w=this.a.get($);w?w.push(y):this.a.set(this.b($),[y])}replace($,y){this.a.set(this.b($),[y])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,y]of this.a)for(const w of y)yield[$,w]}b($){return m($)}}e.$Rt=b;function m(D){return D.toLowerCase()}function E(D,$){return A(m(D),$.map(m))}function A(D,$){if(D==="*/*")return $.length>0;if($.includes(D))return!0;const y=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[w,h,g]=y;return g==="*"?$.some(a=>a.startsWith(h+"/")):!1}e.$Tt=Object.freeze({create:D=>(0,d.$Mb)(D.map($=>$.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$Tt.split(D).filter($=>!$.startsWith("#"))})}),define(ke[178],Pe([1,0,63]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=N,e.$Vg=R;function N(b,m,E,A=1){let D=!1;return new Promise($=>{const y=setTimeout(()=>{if(!D)return D=!0,$(0)},E);L(b,m,A,w=>{if(!D)return D=!0,clearTimeout(y),$(w)})})}function L(b,m,E,A){if(m===0)return A(0);const D=new d.Socket;D.once("connect",()=>(M(D),L(b+E,m-1,E,A))),D.once("data",()=>{}),D.once("error",$=>(M(D),$.code!=="ECONNREFUSED"?L(b+E,m-1,E,A):A(b))),D.connect(b,"127.0.0.1")}e.$Ug={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(b,m,E,A="127.0.0.1"){let D=!1,$,y=1;const w=d.createServer({pauseOnConnect:!0});function h(g,a){D||(D=!0,w.removeAllListeners(),w.close(),$&&clearTimeout($),a(g))}return new Promise(g=>{$=setTimeout(()=>{h(0,g)},E),w.on("listening",()=>{h(b,g)}),w.on("error",a=>{a&&(a.code==="EADDRINUSE"||a.code==="EACCES")&&y<m?(b++,y++,w.listen(b,A)):h(0,g)}),w.on("close",()=>{h(0,g)}),w.listen(b,A)})}function M(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(m){console.error(m)}}}),define(ke[129],Pe([1,0,128]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$It=e.$Ht=void 0;class N{constructor(b){const m=(0,d.$5e)(b);this.c=m,this.a=N.d(m),this.b=new Map}static d(b){const m=new Uint8Array(256);return m.fill(b),m}set(b,m){const E=(0,d.$5e)(m);b>=0&&b<256?this.a[b]=E:this.b.set(b,E)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Ht=N;var L;(function(M){M[M.False=0]="False",M[M.True=1]="True"})(L||(L={}));class R{constructor(){this.a=new N(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$It=R}),define(ke[179],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Wt=N;var d;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(d||(e.StringEOL=d={}));function N(L){let R=0,M=0,b=0,m=0;for(let E=0,A=L.length;E<A;E++){const D=L.charCodeAt(E);D===13?(R===0&&(M=E),R++,E+1<A&&L.charCodeAt(E+1)===10?(m|=2,E++):m|=3,b=E+1):D===10&&(m|=1,R===0&&(M=E),R++,b=E+1)}return R===0&&(M=L.length),[R,M,L.length-b,m]}}),define(ke[50],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=void 0;class d{constructor(L,R){this.lineNumber=L,this.column=R}with(L=this.lineNumber,R=this.column){return L===this.lineNumber&&R===this.column?this:new d(L,R)}delta(L=0,R=0){return this.with(this.lineNumber+L,this.column+R)}equals(L){return d.equals(this,L)}static equals(L,R){return!L&&!R?!0:!!L&&!!R&&L.lineNumber===R.lineNumber&&L.column===R.column}isBefore(L){return d.isBefore(this,L)}static isBefore(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<R.column}isBeforeOrEqual(L){return d.isBeforeOrEqual(this,L)}static isBeforeOrEqual(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<=R.column}static compare(L,R){const M=L.lineNumber|0,b=R.lineNumber|0;if(M===b){const m=L.column|0,E=R.column|0;return m-E}return M-b}clone(){return new d(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(L){return new d(L.lineNumber,L.column)}static isIPosition(L){return L&&typeof L.lineNumber=="number"&&typeof L.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$st=d}),define(ke[29],Pe([1,0,50]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0;class N{constructor(R,M,b,m){R>b||R===b&&M>m?(this.startLineNumber=b,this.startColumn=m,this.endLineNumber=R,this.endColumn=M):(this.startLineNumber=R,this.startColumn=M,this.endLineNumber=b,this.endColumn=m)}isEmpty(){return N.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return N.containsPosition(this,R)}static containsPosition(R,M){return!(M.lineNumber<R.startLineNumber||M.lineNumber>R.endLineNumber||M.lineNumber===R.startLineNumber&&M.column<R.startColumn||M.lineNumber===R.endLineNumber&&M.column>R.endColumn)}static strictContainsPosition(R,M){return!(M.lineNumber<R.startLineNumber||M.lineNumber>R.endLineNumber||M.lineNumber===R.startLineNumber&&M.column<=R.startColumn||M.lineNumber===R.endLineNumber&&M.column>=R.endColumn)}containsRange(R){return N.containsRange(this,R)}static containsRange(R,M){return!(M.startLineNumber<R.startLineNumber||M.endLineNumber<R.startLineNumber||M.startLineNumber>R.endLineNumber||M.endLineNumber>R.endLineNumber||M.startLineNumber===R.startLineNumber&&M.startColumn<R.startColumn||M.endLineNumber===R.endLineNumber&&M.endColumn>R.endColumn)}strictContainsRange(R){return N.strictContainsRange(this,R)}static strictContainsRange(R,M){return!(M.startLineNumber<R.startLineNumber||M.endLineNumber<R.startLineNumber||M.startLineNumber>R.endLineNumber||M.endLineNumber>R.endLineNumber||M.startLineNumber===R.startLineNumber&&M.startColumn<=R.startColumn||M.endLineNumber===R.endLineNumber&&M.endColumn>=R.endColumn)}plusRange(R){return N.plusRange(this,R)}static plusRange(R,M){let b,m,E,A;return M.startLineNumber<R.startLineNumber?(b=M.startLineNumber,m=M.startColumn):M.startLineNumber===R.startLineNumber?(b=M.startLineNumber,m=Math.min(M.startColumn,R.startColumn)):(b=R.startLineNumber,m=R.startColumn),M.endLineNumber>R.endLineNumber?(E=M.endLineNumber,A=M.endColumn):M.endLineNumber===R.endLineNumber?(E=M.endLineNumber,A=Math.max(M.endColumn,R.endColumn)):(E=R.endLineNumber,A=R.endColumn),new N(b,m,E,A)}intersectRanges(R){return N.intersectRanges(this,R)}static intersectRanges(R,M){let b=R.startLineNumber,m=R.startColumn,E=R.endLineNumber,A=R.endColumn;const D=M.startLineNumber,$=M.startColumn,y=M.endLineNumber,w=M.endColumn;return b<D?(b=D,m=$):b===D&&(m=Math.max(m,$)),E>y?(E=y,A=w):E===y&&(A=Math.min(A,w)),b>E||b===E&&m>A?null:new N(b,m,E,A)}equalsRange(R){return N.equalsRange(this,R)}static equalsRange(R,M){return!R&&!M?!0:!!R&&!!M&&R.startLineNumber===M.startLineNumber&&R.startColumn===M.startColumn&&R.endLineNumber===M.endLineNumber&&R.endColumn===M.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(R){return new d.$st(R.endLineNumber,R.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(R){return new d.$st(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,M){return new N(this.startLineNumber,this.startColumn,R,M)}setStartPosition(R,M){return new N(R,M,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(R){return new N(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(R){return new N(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new N(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,M=R){return new N(R.lineNumber,R.column,M.lineNumber,M.column)}static lift(R){return R?new N(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,M){return!(R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<M.startColumn||M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<R.startColumn)}static areIntersecting(R,M){return!(R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<=M.startColumn||M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,M){if(R&&M){const E=R.startLineNumber|0,A=M.startLineNumber|0;if(E===A){const D=R.startColumn|0,$=M.startColumn|0;if(D===$){const y=R.endLineNumber|0,w=M.endLineNumber|0;if(y===w){const h=R.endColumn|0,g=M.endColumn|0;return h-g}return y-w}return D-$}return E-A}return(R?1:0)-(M?1:0)}static compareRangesUsingEnds(R,M){return R.endLineNumber===M.endLineNumber?R.endColumn===M.endColumn?R.startLineNumber===M.startLineNumber?R.startColumn-M.startColumn:R.startLineNumber-M.startLineNumber:R.endColumn-M.endColumn:R.endLineNumber-M.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$tt=N}),define(ke[180],Pe([1,0,29]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=void 0;class N{static insert(R,M){return{range:new d.$tt(R.lineNumber,R.column,R.lineNumber,R.column),text:M,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,M){return{range:R,text:M}}static replaceMove(R,M){return{range:R,text:M,forceMoveMarkers:!0}}}e.$ut=N}),define(ke[181],Pe([1,0,50,29]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=e.SelectionDirection=void 0;var L;(function(M){M[M.LTR=0]="LTR",M[M.RTL=1]="RTL"})(L||(e.SelectionDirection=L={}));class R extends N.$tt{constructor(b,m,E,A){super(b,m,E,A),this.selectionStartLineNumber=b,this.selectionStartColumn=m,this.positionLineNumber=E,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return R.selectionsEqual(this,b)}static selectionsEqual(b,m){return b.selectionStartLineNumber===m.selectionStartLineNumber&&b.selectionStartColumn===m.selectionStartColumn&&b.positionLineNumber===m.positionLineNumber&&b.positionColumn===m.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,m){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,b,m):new R(b,m,this.startLineNumber,this.startColumn)}getPosition(){return new d.$st(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new d.$st(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,m){return this.getDirection()===0?new R(b,m,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,b,m)}static fromPositions(b,m=b){return new R(b.lineNumber,b.column,m.lineNumber,m.column)}static fromRange(b,m){return m===0?new R(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new R(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new R(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,m){if(b&&!m||!b&&m)return!1;if(!b&&!m)return!0;if(b.length!==m.length)return!1;for(let E=0,A=b.length;E<A;E++)if(!this.selectionsEqual(b[E],m[E]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,m,E,A,D){return D===0?new R(b,m,E,A):new R(E,A,b,m)}}e.$vt=R}),define(ke[182],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=void 0,e.$3s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[183],Pe([1,0,27,129]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=e.WordCharacterClass=void 0,e.$Kt=b;var L;(function(m){m[m.Regular=0]="Regular",m[m.Whitespace=1]="Whitespace",m[m.WordSeparator=2]="WordSeparator"})(L||(e.WordCharacterClass=L={}));class R extends N.$Ht{constructor(E,A){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=A,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let D=0,$=E.length;D<$;D++)this.set(E.charCodeAt(D),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(E,A){let D=null;for(const $ of this.h(E)){if($.index>A)break;D=$}return D}findNextIntlWordAtOrAfterOffset(E,A){for(const D of this.h(E))if(!(D.index<A))return D;return null}h(E){return this.e?this.f===E?this.g:(this.f=E,this.g=this.j(this.e.segment(E)),this.g):[]}j(E){const A=[];for(const D of E)this.k(D)&&A.push(D);return A}k(E){return!!E.isWordLike}}e.$Jt=R;const M=new d.$Ec(10);function b(m,E){const A=`${m}/${E.join(",")}`;let D=M.get(A);return D||(D=new R(m,E),M.set(A,D)),D}}),define(ke[130],Pe([1,0,39,3,76]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=e.$4s=void 0,e.$6s=M,e.$7s=m,e.$8s=E,e.$4s="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(D=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$4s)D.indexOf(y)>=0||($+="\\"+y);return $+="\\s]+)",new RegExp($,"g")}e.$5s=R();function M(D){let $=e.$5s;if(D&&D instanceof RegExp)if(D.global)$=D;else{let y="g";D.ignoreCase&&(y+="i"),D.multiline&&(y+="m"),D.unicode&&(y+="u"),$=new RegExp(D.source,y)}return $.lastIndex=0,$}const b=new L.$6c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function m(D){const $=b.unshift(D);return(0,N.$Tc)($)}function E(D,$,y,w,h){if($=M($),h||(h=d.Iterable.first(b)),y.length>h.maxLen){let u=D-h.maxLen/2;return u<0?u=0:w+=u,y=y.substring(u,D+h.maxLen/2),E(D,$,y,w,h)}const g=Date.now(),a=D-1-w;let n=-1,i=null;for(let u=1;!(Date.now()-g>=h.timeBudget);u++){const o=a-h.windowSize*u;$.lastIndex=Math.max(0,o);const t=A($,y,a,n);if(!t&&i||(i=t,o<=0))break;n=o}if(i){const u={word:i[0],startColumn:w+1+i.index,endColumn:w+1+i.index+i[0].length};return $.lastIndex=0,u}return null}function A(D,$,y,w){let h;for(;h=D.exec($);){const g=h.index||0;if(g<=y&&D.lastIndex>=y)return h;if(w>0&&g>w)return null}return null}}),define(ke[184],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ku=e.$ju=e.IndentAction=void 0;var d;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(d||(e.IndentAction=d={}));class N{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let m=0,E=b.notIn.length;m<E;m++)switch(b.notIn[m]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,m){if(b.getTokenCount()===0)return!0;const E=b.findTokenIndexAtOffset(m-2),A=b.getStandardTokenType(E);return this.isOK(A)}g(b,m){for(let E=b;E<=m;E++){const A=String.fromCharCode(E);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$ju=N;class L{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of b)R(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),R(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),R(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),R(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&R(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.$ku=L;function R(M,b,m){M.has(b)?M.get(b).push(m):M.set(b,[m])}}),define(ke[185],Pe([1,0,129]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j3=e.$i3=e.State=void 0,e.$k3=$;var N;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class L{constructor(w,h,g){const a=new Uint8Array(w*h);for(let n=0,i=w*h;n<i;n++)a[n]=g;this.a=a,this.rows=w,this.cols=h}get(w,h){return this.a[w*this.cols+h]}set(w,h,g){this.a[w*this.cols+h]=g}}class R{constructor(w){let h=0,g=0;for(let n=0,i=w.length;n<i;n++){const[u,o,t]=w[n];o>h&&(h=o),u>g&&(g=u),t>g&&(g=t)}h++,g++;const a=new L(g,h,0);for(let n=0,i=w.length;n<i;n++){const[u,o,t]=w[n];a.set(u,o,t)}this.a=a,this.b=h}nextState(w,h){return h<0||h>=this.b?0:this.a.get(w,h)}}e.$i3=R;let M=null;function b(){return M===null&&(M=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),M}var m;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(m||(m={}));let E=null;function A(){if(E===null){E=new d.$Ht(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<y.length;h++)E.set(y.charCodeAt(h),1);const w=".,;:";for(let h=0;h<w.length;h++)E.set(w.charCodeAt(h),2)}return E}class D{static a(w,h,g,a,n){let i=n-1;do{const u=h.charCodeAt(i);if(w.get(u)!==2)break;i--}while(i>a);if(a>0){const u=h.charCodeAt(a-1),o=h.charCodeAt(i);(u===40&&o===41||u===91&&o===93||u===123&&o===125)&&i--}return{range:{startLineNumber:g,startColumn:a+1,endLineNumber:g,endColumn:i+2},url:h.substring(a,i+1)}}static computeLinks(w,h=b()){const g=A(),a=[];for(let n=1,i=w.getLineCount();n<=i;n++){const u=w.getLineContent(n),o=u.length;let t=0,l=0,r=0,c=1,s=!1,v=!1,f=!1,S=!1;for(;t<o;){let p=!1;const k=u.charCodeAt(t);if(c===13){let P;switch(k){case 40:s=!0,P=0;break;case 41:P=s?0:1;break;case 91:f=!0,v=!0,P=0;break;case 93:f=!1,P=v?0:1;break;case 123:S=!0,P=0;break;case 125:P=S?0:1;break;case 39:case 34:case 96:r===k?P=1:r===39||r===34||r===96?P=0:P=1;break;case 42:P=r===42?1:0;break;case 124:P=r===124?1:0;break;case 32:P=f?0:1;break;default:P=g.get(k)}P===1&&(a.push(D.a(g,u,n,l,t)),p=!0)}else if(c===12){let P;k===91?(v=!0,P=0):P=g.get(k),P===1?p=!0:c=13}else c=h.nextState(c,k),c===0&&(p=!0);p&&(c=1,s=!1,v=!1,S=!1,l=t+1,r=k),t++}c===13&&a.push(D.a(g,u,n,l,o))}return a}}e.$j3=D;function $(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:D.computeLinks(y)}}),define(ke[80],Pe([1,0,24]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iv=e.$Hv=e.$Gv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$Ev=e.$Dv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$Fv=w,e.$Jv=u;var N;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var L;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=3]="Right"})(L||(e.GlyphMarginLane=L={}));var R;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var M;(function(o){o[o.Normal=1]="Normal",o[o.Underlined=2]="Underlined"})(M||(e.MinimapSectionHeaderStyle=M={}));var b;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(b||(e.InjectedTextCursorStops=b={}));var m;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(m||(e.EndOfLinePreference=m={}));var E;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var A;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(A||(e.EndOfLineSequence=A={}));class D{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,d.$6n)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$Dv=D;class ${constructor(t,l){this._findMatchBrand=void 0,this.range=t,this.matches=l}}e.$Ev=$;var y;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(y||(e.TrackedRangeStickiness=y={}));function w(o){return o&&typeof o.read=="function"}var h;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(h||(e.PositionAffinity=h={}));var g;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(g||(e.ModelConstants=g={}));class a{constructor(t,l,r,c,s,v){this.identifier=t,this.range=l,this.text=r,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=s,this._isTracked=v}}e.$Gv=a;class n{constructor(t,l,r){this.regex=t,this.wordSeparators=l,this.simpleSearch=r}}e.$Hv=n;class i{constructor(t,l,r){this.reverseEdits=t,this.changes=l,this.trimAutoWhitespaceLineNumbers=r}}e.$Iv=i;function u(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}}),define(ke[186],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=e.NodeColor=e.$yC=void 0,e.$AC=L,e.$BC=R,e.$CC=E,e.$DC=A,e.$EC=D,e.$FC=$,e.$GC=y,e.$HC=w;class d{constructor(g,a){this.piece=g,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$zC)return L(this.right);let g=this;for(;g.parent!==e.$zC&&g.parent.left!==g;)g=g.parent;return g.parent===e.$zC?e.$zC:g.parent}prev(){if(this.left!==e.$zC)return R(this.left);let g=this;for(;g.parent!==e.$zC&&g.parent.right!==g;)g=g.parent;return g.parent===e.$zC?e.$zC:g.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$yC=d;var N;(function(h){h[h.Black=0]="Black",h[h.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$zC=new d(null,0),e.$zC.parent=e.$zC,e.$zC.left=e.$zC,e.$zC.right=e.$zC,e.$zC.color=0;function L(h){for(;h.left!==e.$zC;)h=h.left;return h}function R(h){for(;h.right!==e.$zC;)h=h.right;return h}function M(h){return h===e.$zC?0:h.size_left+h.piece.length+M(h.right)}function b(h){return h===e.$zC?0:h.lf_left+h.piece.lineFeedCnt+b(h.right)}function m(){e.$zC.parent=e.$zC}function E(h,g){const a=g.right;a.size_left+=g.size_left+(g.piece?g.piece.length:0),a.lf_left+=g.lf_left+(g.piece?g.piece.lineFeedCnt:0),g.right=a.left,a.left!==e.$zC&&(a.left.parent=g),a.parent=g.parent,g.parent===e.$zC?h.root=a:g.parent.left===g?g.parent.left=a:g.parent.right=a,a.left=g,g.parent=a}function A(h,g){const a=g.left;g.left=a.right,a.right!==e.$zC&&(a.right.parent=g),a.parent=g.parent,g.size_left-=a.size_left+(a.piece?a.piece.length:0),g.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),g.parent===e.$zC?h.root=a:g===g.parent.right?g.parent.right=a:g.parent.left=a,a.right=g,g.parent=a}function D(h,g){let a,n;if(g.left===e.$zC?(n=g,a=n.right):g.right===e.$zC?(n=g,a=n.left):(n=L(g.right),a=n.right),n===h.root){h.root=a,a.color=0,g.detach(),m(),h.root.parent=e.$zC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=a:n.parent.right=a,n===g?(a.parent=n.parent,w(h,a)):(n.parent===g?a.parent=n:a.parent=n.parent,w(h,a),n.left=g.left,n.right=g.right,n.parent=g.parent,n.color=g.color,g===h.root?h.root=n:g===g.parent.left?g.parent.left=n:g.parent.right=n,n.left!==e.$zC&&(n.left.parent=n),n.right!==e.$zC&&(n.right.parent=n),n.size_left=g.size_left,n.lf_left=g.lf_left,w(h,n)),g.detach(),a.parent.left===a){const o=M(a),t=b(a);if(o!==a.parent.size_left||t!==a.parent.lf_left){const l=o-a.parent.size_left,r=t-a.parent.lf_left;a.parent.size_left=o,a.parent.lf_left=t,y(h,a.parent,l,r)}}if(w(h,a.parent),i){m();return}let u;for(;a!==h.root&&a.color===0;)a===a.parent.left?(u=a.parent.right,u.color===1&&(u.color=0,a.parent.color=1,E(h,a.parent),u=a.parent.right),u.left.color===0&&u.right.color===0?(u.color=1,a=a.parent):(u.right.color===0&&(u.left.color=0,u.color=1,A(h,u),u=a.parent.right),u.color=a.parent.color,a.parent.color=0,u.right.color=0,E(h,a.parent),a=h.root)):(u=a.parent.left,u.color===1&&(u.color=0,a.parent.color=1,A(h,a.parent),u=a.parent.left),u.left.color===0&&u.right.color===0?(u.color=1,a=a.parent):(u.left.color===0&&(u.right.color=0,u.color=1,E(h,u),u=a.parent.left),u.color=a.parent.color,a.parent.color=0,u.left.color=0,A(h,a.parent),a=h.root));a.color=0,m()}function $(h,g){for(w(h,g);g!==h.root&&g.parent.color===1;)if(g.parent===g.parent.parent.left){const a=g.parent.parent.right;a.color===1?(g.parent.color=0,a.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.right&&(g=g.parent,E(h,g)),g.parent.color=0,g.parent.parent.color=1,A(h,g.parent.parent))}else{const a=g.parent.parent.left;a.color===1?(g.parent.color=0,a.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.left&&(g=g.parent,A(h,g)),g.parent.color=0,g.parent.parent.color=1,E(h,g.parent.parent))}h.root.color=0}function y(h,g,a,n){for(;g!==h.root&&g!==e.$zC;)g.parent.left===g&&(g.parent.size_left+=a,g.parent.lf_left+=n),g=g.parent}function w(h,g){let a=0,n=0;if(g!==h.root){for(;g!==h.root&&g===g.parent.right;)g=g.parent;if(g!==h.root)for(g=g.parent,a=M(g.left)-g.size_left,n=b(g.left)-g.lf_left,g.size_left+=a,g.lf_left+=n;g!==h.root&&(a!==0||n!==0);)g.parent.left===g&&(g.parent.size_left+=a,g.parent.lf_left+=n),g=g.parent}}}),define(ke[187],Pe([1,0,19,128]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xv=e.$Wv=e.$Vv=void 0;class L{constructor(m){this.a=m,this.b=new Uint32Array(m.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(m,E){m=(0,N.$6e)(m);const A=this.a,D=this.b,$=E.length;return $===0?!1:(this.a=new Uint32Array(A.length+$),this.a.set(A.subarray(0,m),0),this.a.set(A.subarray(m),m+$),this.a.set(E,m),m-1<this.c[0]&&(this.c[0]=m-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(D.subarray(0,this.c[0]+1)),!0)}setValue(m,E){return m=(0,N.$6e)(m),E=(0,N.$6e)(E),this.a[m]===E?!1:(this.a[m]=E,m-1<this.c[0]&&(this.c[0]=m-1),!0)}removeValues(m,E){m=(0,N.$6e)(m),E=(0,N.$6e)(E);const A=this.a,D=this.b;if(m>=A.length)return!1;const $=A.length-m;return E>=$&&(E=$),E===0?!1:(this.a=new Uint32Array(A.length-E),this.a.set(A.subarray(0,m),0),this.a.set(A.subarray(m+E),m),this.b=new Uint32Array(this.a.length),m-1<this.c[0]&&(this.c[0]=m-1),this.c[0]>=0&&this.b.set(D.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(m){return m<0?0:(m=(0,N.$6e)(m),this.d(m))}d(m){if(m<=this.c[0])return this.b[m];let E=this.c[0]+1;E===0&&(this.b[0]=this.a[0],E++),m>=this.a.length&&(m=this.a.length-1);for(let A=E;A<=m;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],m),this.b[m]}getIndexOf(m){m=Math.floor(m),this.getTotalSum();let E=0,A=this.a.length-1,D=0,$=0,y=0;for(;E<=A;)if(D=E+(A-E)/2|0,$=this.b[D],y=$-this.a[D],m<y)A=D-1;else if(m>=$)E=D+1;else break;return new M(D,m-y)}}e.$Vv=L;class R{constructor(m){this.a=m,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(m){return this.g(),m===0?0:this.d[m-1]}getIndexOf(m){this.g();const E=this.e[m],A=E>0?this.d[E-1]:0;return new M(E,m-A)}removeValues(m,E){this.a.splice(m,E),this.f(m)}insertValues(m,E){this.a=(0,d.$Wb)(this.a,m,E),this.f(m)}f(m){this.b=!1,this.c=Math.min(this.c,m-1)}g(){if(!this.b){for(let m=this.c+1,E=this.a.length;m<E;m++){const A=this.a[m],D=m>0?this.d[m-1]:0;this.d[m]=D+A;for(let $=0;$<A;$++)this.e[D+$]=m}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(m,E){this.a[m]!==E&&(this.a[m]=E,this.f(m))}}e.$Wv=R;class M{constructor(m,E){this.index=m,this.remainder=E,this._prefixSumIndexOfResultBrand=void 0,this.index=m,this.remainder=E}}e.$Xv=M}),define(ke[188],Pe([1,0,14,50,187]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yv=void 0;class R{constructor(b,m,E,A){this.d=b,this.f=m,this.g=E,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const m=b.changes;for(const E of m)this.o(E.range),this.p(new N.$st(E.range.startLineNumber,E.range.startColumn),E.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,m=this.f.length,E=new Uint32Array(m);for(let A=0;A<m;A++)E[A]=this.f[A].length+b;this.j=new L.$Vv(E)}}n(b,m){this.f[b]=m,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,m){if(m.length===0)return;const E=(0,d.$kf)(m);if(E.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+E[0]+this.f[b.lineNumber-1].substring(b.column-1));return}E[E.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+E[0]);const A=new Uint32Array(E.length-1);for(let D=1;D<E.length;D++)this.f.splice(b.lineNumber+D-1,0,E[D]),A[D-1]=E[D].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,A)}}e.$Yv=R}),define(ke[100],Pe([1,0,14,183,50,29,80]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=e.$LC=e.$IC=void 0,e.$JC=E,e.$KC=A,e.$MC=h;const b=999;class m{constructor(n,i,u,o){this.searchString=n,this.isRegex=i,this.matchCase=u,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=E(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=d.$if(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let u=!this.isRegex&&!n;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new M.$Hv(i,this.wordSeparators?(0,N.$Kt)(this.wordSeparators,[]):null,u?this.searchString:null)}}e.$IC=m;function E(a){if(!a||a.length===0)return!1;for(let n=0,i=a.length;n<i;n++){const u=a.charCodeAt(n);if(u===10)return!0;if(u===92){if(n++,n>=i)break;const o=a.charCodeAt(n);if(o===110||o===114||o===87)return!0}}return!1}function A(a,n,i){if(!i)return new M.$Ev(a,null);const u=[];for(let o=0,t=n.length;o<t;o++)u[o]=n[o];return new M.$Ev(a,u)}class D{constructor(n){const i=[];let u=0;for(let o=0,t=n.length;o<t;o++)n.charCodeAt(o)===10&&(i[u++]=o);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let u=0,o=i.length-1;if(o===-1||n<=i[0])return 0;for(;u<o;){const t=u+((o-u)/2>>0);i[t]>=n?o=t-1:i[t+1]>=n?(u=t,o=t):u=t+1}return u+1}}class ${static findMatches(n,i,u,o,t){const l=i.parseSearchRequest();return l?l.regex.multiline?this.b(n,u,new g(l.wordSeparators,l.regex),o,t):this.c(n,u,l,o,t):[]}static a(n,i,u,o,t,l){let r,c=0;o?(c=o.findLineFeedCountBeforeOffset(t),r=i+t+c):r=i+t;let s;if(o){const p=o.findLineFeedCountBeforeOffset(t+l.length)-c;s=r+l.length+p}else s=r+l.length;const v=n.getPositionAt(r),f=n.getPositionAt(s);return new R.$tt(v.lineNumber,v.column,f.lineNumber,f.column)}static b(n,i,u,o,t){const l=n.getOffsetAt(i.getStartPosition()),r=n.getValueInRange(i,1),c=n.getEOL()===`\r
`?new D(r):null,s=[];let v=0,f;for(u.reset(0);f=u.next(r);)if(s[v++]=A(this.a(n,l,r,c,f.index,f[0]),f,o),v>=t)return s;return s}static c(n,i,u,o,t){const l=[];let r=0;if(i.startLineNumber===i.endLineNumber){const s=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return r=this.d(u,s,i.startLineNumber,i.startColumn-1,r,l,o,t),l}const c=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);r=this.d(u,c,i.startLineNumber,i.startColumn-1,r,l,o,t);for(let s=i.startLineNumber+1;s<i.endLineNumber&&r<t;s++)r=this.d(u,n.getLineContent(s),s,0,r,l,o,t);if(r<t){const s=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);r=this.d(u,s,i.endLineNumber,0,r,l,o,t)}return l}static d(n,i,u,o,t,l,r,c){const s=n.wordSeparators;if(!r&&n.simpleSearch){const S=n.simpleSearch,p=S.length,k=i.length;let P=-p;for(;(P=i.indexOf(S,P+p))!==-1;)if((!s||h(s,i,k,P,p))&&(l[t++]=new M.$Ev(new R.$tt(u,P+1+o,u,P+1+p+o),null),t>=c))return t;return t}const v=new g(n.wordSeparators,n.regex);let f;v.reset(0);do if(f=v.next(i),f&&(l[t++]=A(new R.$tt(u,f.index+1+o,u,f.index+1+f[0].length+o),f,r),t>=c))return t;while(f);return t}static findNextMatch(n,i,u,o){const t=i.parseSearchRequest();if(!t)return null;const l=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,u,l,o):this.f(n,u,l,o)}static e(n,i,u,o){const t=new L.$st(i.lineNumber,1),l=n.getOffsetAt(t),r=n.getLineCount(),c=n.getValueInRange(new R.$tt(t.lineNumber,t.column,r,n.getLineMaxColumn(r)),1),s=n.getEOL()===`\r
`?new D(c):null;u.reset(i.column-1);const v=u.next(c);return v?A(this.a(n,l,c,s,v.index,v[0]),v,o):i.lineNumber!==1||i.column!==1?this.e(n,new L.$st(1,1),u,o):null}static f(n,i,u,o){const t=n.getLineCount(),l=i.lineNumber,r=n.getLineContent(l),c=this.g(u,r,l,i.column,o);if(c)return c;for(let s=1;s<=t;s++){const v=(l+s-1)%t,f=n.getLineContent(v+1),S=this.g(u,f,v+1,1,o);if(S)return S}return null}static g(n,i,u,o,t){n.reset(o-1);const l=n.next(i);return l?A(new R.$tt(u,l.index+1,u,l.index+1+l[0].length),l,t):null}static findPreviousMatch(n,i,u,o){const t=i.parseSearchRequest();if(!t)return null;const l=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,u,l,o):this.j(n,u,l,o)}static h(n,i,u,o){const t=this.b(n,new R.$tt(1,1,i.lineNumber,i.column),u,o,10*b);if(t.length>0)return t[t.length-1];const l=n.getLineCount();return i.lineNumber!==l||i.column!==n.getLineMaxColumn(l)?this.h(n,new L.$st(l,n.getLineMaxColumn(l)),u,o):null}static j(n,i,u,o){const t=n.getLineCount(),l=i.lineNumber,r=n.getLineContent(l).substring(0,i.column-1),c=this.k(u,r,l,o);if(c)return c;for(let s=1;s<=t;s++){const v=(t+l-s-1)%t,f=n.getLineContent(v+1),S=this.k(u,f,v+1,o);if(S)return S}return null}static k(n,i,u,o){let t=null,l;for(n.reset(0);l=n.next(i);)t=A(new R.$tt(u,l.index+1,u,l.index+1+l[0].length),l,o);return t}}e.$LC=$;function y(a,n,i,u,o){if(u===0)return!0;const t=n.charCodeAt(u-1);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const l=n.charCodeAt(u);if(a.get(l)!==0)return!0}return!1}function w(a,n,i,u,o){if(u+o===i)return!0;const t=n.charCodeAt(u+o);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const l=n.charCodeAt(u+o-1);if(a.get(l)!==0)return!0}return!1}function h(a,n,i,u,o){return y(a,n,i,u,o)&&w(a,n,i,u,o)}class g{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let u;do{if(this.b+this.c===i||(u=this.a.exec(n),!u))return null;const o=u.index,t=u[0].length;if(o===this.b&&t===this.c){if(t===0){d.$Ef(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=t,!this._wordSeparators||h(this._wordSeparators,n,i,o,t))return u}while(u);return null}}e.$NC=g}),define(ke[131],Pe([1,0,50,29,80,186,100]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SC=e.$RC=e.$QC=void 0,e.$OC=A,e.$PC=D;const b=65535;function m(a){let n;return a[a.length-1]<65536?n=new Uint16Array(a.length):n=new Uint32Array(a.length),n.set(a,0),n}class E{constructor(n,i,u,o,t){this.lineStarts=n,this.cr=i,this.lf=u,this.crlf=o,this.isBasicASCII=t}}function A(a,n=!0){const i=[0];let u=1;for(let o=0,t=a.length;o<t;o++){const l=a.charCodeAt(o);l===13?o+1<t&&a.charCodeAt(o+1)===10?(i[u++]=o+2,o++):i[u++]=o+1:l===10&&(i[u++]=o+1)}return n?m(i):i}function D(a,n){a.length=0,a[0]=0;let i=1,u=0,o=0,t=0,l=!0;for(let c=0,s=n.length;c<s;c++){const v=n.charCodeAt(c);v===13?c+1<s&&n.charCodeAt(c+1)===10?(t++,a[i++]=c+2,c++):(u++,a[i++]=c+1):v===10?(o++,a[i++]=c+1):l&&v!==9&&(v<32||v>126)&&(l=!1)}const r=new E(m(a),u,o,t,l);return a.length=0,r}class ${constructor(n,i,u,o,t){this.bufferIndex=n,this.start=i,this.end=u,this.lineFeedCnt=o,this.length=t}}e.$QC=$;class y{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$RC=y;class w{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==R.$zC&&n.iterate(n.root,u=>(u!==R.$zC&&this.a.push(u.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class h{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const u=this.b[i];if(u.nodeStartOffset<=n&&u.nodeStartOffset+u.node.piece.length>=n)return u}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const u=this.b[i];if(u.nodeStartLineNumber&&u.nodeStartLineNumber<n&&u.nodeStartLineNumber+u.node.piece.lineFeedCnt>=n)return u}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const u=this.b;for(let o=0;o<u.length;o++){const t=u[o];if(t.node.parent===null||t.nodeStartOffset>=n){u[o]=null,i=!0;continue}}if(i){const o=[];for(const t of u)t!==null&&o.push(t);this.b=o}}}class g{constructor(n,i,u){this.create(n,i,u)}create(n,i,u){this.a=[new y("",[0])],this.g={line:0,column:0},this.root=R.$zC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=u;let o=null;for(let t=0,l=n.length;t<l;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=A(n[t].buffer));const r=new $(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),o=this.S(o,r)}this.h=new h(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=b,u=i-Math.floor(i/3),o=u*2;let t="",l=0;const r=[];if(this.iterate(this.root,c=>{const s=this.R(c),v=s.length;if(l<=u||l+v<o)return t+=s,l+=v,!0;const f=t.replace(/\r\n|\r|\n/g,n);return r.push(new y(f,A(f))),t=s,l=v,!0}),l>0){const c=t.replace(/\r\n|\r|\n/g,n);r.push(new y(c,A(c)))}this.create(r,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new w(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,o=>{if(o===R.$zC)return!0;const t=this.R(o),l=t.length,r=n.G(i),c=n.G(i+l),s=n.getValueInRange2(r,c);return i+=l,t===s})}getOffsetAt(n,i){let u=0,o=this.root;for(;o!==R.$zC;)if(o.left!==R.$zC&&o.lf_left+1>=n)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=n){u+=o.size_left;const t=this.B(o,n-o.lf_left-2);return u+=t+i-1}else n-=o.lf_left+o.piece.lineFeedCnt,u+=o.size_left+o.piece.length,o=o.right;return u}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,u=0;const o=n;for(;i!==R.$zC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(u+=i.lf_left+t.index,t.index===0){const l=this.getOffsetAt(u+1,1),r=o-l;return new d.$st(u+1,r+1)}return new d.$st(u+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,u+=i.lf_left+i.piece.lineFeedCnt,i.right===R.$zC){const t=this.getOffsetAt(u+1,1),l=o-n-t;return new d.$st(u+1,l+1)}else i=i.right;return new d.$st(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const u=this.H(n.startLineNumber,n.startColumn),o=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(u,o);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const r=n.node,c=this.a[r.piece.bufferIndex].buffer,s=this.u(r.piece.bufferIndex,r.piece.start);return c.substring(s+n.remainder,s+i.remainder)}let u=n.node;const o=this.a[u.piece.bufferIndex].buffer,t=this.u(u.piece.bufferIndex,u.piece.start);let l=o.substring(t+n.remainder,t+u.piece.length);for(u=u.next();u!==R.$zC;){const r=this.a[u.piece.bufferIndex].buffer,c=this.u(u.piece.bufferIndex,u.piece.start);if(u===i.node){l+=r.substring(c,c+i.remainder);break}else l+=r.substr(c,u.piece.length);u=u.next()}return l}getLinesContent(){const n=[];let i=0,u="",o=!1;return this.iterate(this.root,t=>{if(t===R.$zC)return!0;const l=t.piece;let r=l.length;if(r===0)return!0;const c=this.a[l.bufferIndex].buffer,s=this.a[l.bufferIndex].lineStarts,v=l.start.line,f=l.end.line;let S=s[v]+l.start.column;if(o&&(c.charCodeAt(S)===10&&(S++,r--),n[i++]=u,u="",o=!1,r===0))return!0;if(v===f)return!this.f&&c.charCodeAt(S+r-1)===13?(o=!0,u+=c.substr(S,r-1)):u+=c.substr(S,r),!0;u+=this.f?c.substring(S,Math.max(S,s[v+1]-this.e)):c.substring(S,s[v+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=u;for(let p=v+1;p<f;p++)u=this.f?c.substring(s[p],s[p+1]-this.e):c.substring(s[p],s[p+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=u;return!this.f&&c.charCodeAt(s[f]+l.end.column-1)===13?(o=!0,l.end.column===0?i--:u=c.substr(s[f],l.end.column-1)):u=c.substr(s[f],l.end.column),!0}),o&&(n[i++]=u,u=""),n[i++]=u,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const u=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start);return u.buffer.charCodeAt(o)}else{const i=this.a[n.node.piece.bufferIndex],o=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(o)}}getLineCharCode(n,i){const u=this.H(n,i+1);return this.l(u)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,u,o,t,l,r,c,s,v,f){const S=this.a[n.piece.bufferIndex],p=this.u(n.piece.bufferIndex,n.piece.start),k=this.u(n.piece.bufferIndex,t),P=this.u(n.piece.bufferIndex,l);let C;const I={line:0,column:0};let T,j;i._wordSeparators?(T=S.buffer.substring(k,P),j=z=>z+k,i.reset(0)):(T=S.buffer,j=z=>z,i.reset(k));do if(C=i.next(T),C){if(j(C.index)>=P)return v;this.s(n,j(C.index)-p,I);const z=this.t(n.piece.bufferIndex,t,I),O=I.line===t.line?I.column-t.column+o:I.column+1,F=O+C[0].length;if(f[v++]=(0,M.$KC)(new N.$tt(u+z,O,u+z,F),C,c),j(C.index)+C[0].length>=P||v>=s)return v}while(C);return v}findMatchesLineByLine(n,i,u,o){const t=[];let l=0;const r=new M.$NC(i.wordSeparators,i.regex);let c=this.H(n.startLineNumber,n.startColumn);if(c===null)return[];const s=this.H(n.endLineNumber,n.endColumn);if(s===null)return[];let v=this.s(c.node,c.remainder);const f=this.s(s.node,s.remainder);if(c.node===s.node)return this.findMatchesInNode(c.node,r,n.startLineNumber,n.startColumn,v,f,i,u,o,l,t),t;let S=n.startLineNumber,p=c.node;for(;p!==s.node;){const P=this.t(p.piece.bufferIndex,v,p.piece.end);if(P>=1){const I=this.a[p.piece.bufferIndex].lineStarts,T=this.u(p.piece.bufferIndex,p.piece.start),j=I[v.line+P],z=S===n.startLineNumber?n.startColumn:1;if(l=this.findMatchesInNode(p,r,S,z,v,this.s(p,j-T),i,u,o,l,t),l>=o)return t;S+=P}const C=S===n.startLineNumber?n.startColumn-1:0;if(S===n.endLineNumber){const I=this.getLineContent(S).substring(C,n.endColumn-1);return l=this.n(i,r,I,n.endLineNumber,C,l,t,u,o),t}if(l=this.n(i,r,this.getLineContent(S).substr(C),S,C,l,t,u,o),l>=o)return t;S++,c=this.H(S,1),p=c.node,v=this.s(c.node,c.remainder)}if(S===n.endLineNumber){const P=S===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(S).substring(P,n.endColumn-1);return l=this.n(i,r,C,n.endLineNumber,P,l,t,u,o),t}const k=S===n.startLineNumber?n.startColumn:1;return l=this.findMatchesInNode(s.node,r,S,k,v,f,i,u,o,l,t),t}n(n,i,u,o,t,l,r,c,s){const v=n.wordSeparators;if(!c&&n.simpleSearch){const S=n.simpleSearch,p=S.length,k=u.length;let P=-p;for(;(P=u.indexOf(S,P+p))!==-1;)if((!v||(0,M.$MC)(v,u,k,P,p))&&(r[l++]=new L.$Ev(new N.$tt(o,P+1+t,o,P+1+p+t),null),l>=s))return l;return l}let f;i.reset(0);do if(f=i.next(u),f&&(r[l++]=(0,M.$KC)(new N.$tt(o,f.index+1+t,o,f.index+1+f[0].length+t),f,c),l>=s))return l;while(f);return l}insert(n,i,u=!1){if(this.f=this.f&&u,this.j.lineNumber=0,this.j.value="",this.root!==R.$zC){const{node:o,remainder:t,nodeStartOffset:l}=this.G(n),r=o.piece,c=r.bufferIndex,s=this.s(o,t);if(o.piece.bufferIndex===0&&r.end.line===this.g.line&&r.end.column===this.g.column&&l+r.length===n&&i.length<b){this.F(o,i),this.y();return}if(l===n)this.o(i,o),this.h.validate(n);else if(l+o.piece.length>n){const v=[];let f=new $(r.bufferIndex,s,r.end,this.t(r.bufferIndex,s,r.end),this.u(c,r.end)-this.u(c,s));if(this.K()&&this.M(i)&&this.I(o,t)===10){const P={line:f.start.line+1,column:0};f=new $(f.bufferIndex,P,f.end,this.t(f.bufferIndex,P,f.end),f.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(o,t-1)===13){const P=this.s(o,t-1);this.C(o,P),i="\r"+i,o.piece.length===0&&v.push(o)}else this.C(o,s);else this.C(o,s);const S=this.w(i);f.length>0&&this.S(o,f);let p=o;for(let k=0;k<S.length;k++)p=this.S(p,S[k]);this.v(v)}else this.q(i,o)}else{const o=this.w(i);let t=this.T(null,o[0]);for(let l=1;l<o.length;l++)t=this.S(t,o[l])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===R.$zC)return;const u=this.G(n),o=this.G(n+i),t=u.node,l=o.node;if(t===l){const S=this.s(t,u.remainder),p=this.s(t,o.remainder);if(u.nodeStartOffset===n){if(i===t.piece.length){const k=t.next();(0,R.$EC)(this,t),this.N(k),this.y();return}this.D(t,p),this.h.validate(n),this.N(t),this.y();return}if(u.nodeStartOffset+t.piece.length===n+i){this.C(t,S),this.O(t),this.y();return}this.E(t,S,p),this.y();return}const r=[],c=this.s(t,u.remainder);this.C(t,c),this.h.validate(n),t.piece.length===0&&r.push(t);const s=this.s(l,o.remainder);this.D(l,s),l.piece.length===0&&r.push(l);const v=t.next();for(let S=v;S!==R.$zC&&S!==l;S=S.next())r.push(S);const f=t.piece.length===0?t.prev():t;this.v(r),this.O(f),this.y()}o(n,i){const u=[];if(this.K()&&this.M(n)&&this.L(i)){const l=i.piece,r={line:l.start.line+1,column:0},c=new $(l.bufferIndex,r,l.end,this.t(l.bufferIndex,r,l.end),l.length-1);i.piece=c,n+=`
`,(0,R.$GC)(this,i,-1,-1),i.piece.length===0&&u.push(i)}const o=this.w(n);let t=this.T(i,o[o.length-1]);for(let l=o.length-2;l>=0;l--)t=this.T(t,o[l]);this.N(t),this.v(u)}q(n,i){this.Q(n,i)&&(n+=`
`);const u=this.w(n),o=this.S(i,u[0]);let t=o;for(let l=1;l<u.length;l++)t=this.S(t,u[l]);this.N(o)}s(n,i,u){const o=n.piece,t=n.piece.bufferIndex,l=this.a[t].lineStarts,c=l[o.start.line]+o.start.column+i;let s=o.start.line,v=o.end.line,f=0,S=0,p=0;for(;s<=v&&(f=s+(v-s)/2|0,p=l[f],f!==v);)if(S=l[f+1],c<p)v=f-1;else if(c>=S)s=f+1;else break;return u?(u.line=f,u.column=c-p,null):{line:f,column:c-p}}t(n,i,u){if(u.column===0)return u.line-i.line;const o=this.a[n].lineStarts;if(u.line===o.length-1)return u.line-i.line;const t=o[u.line+1],l=o[u.line]+u.column;if(t>l+1)return u.line-i.line;const r=l-1;return this.a[n].buffer.charCodeAt(r)===13?u.line-i.line+1:u.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,R.$EC)(this,n[i])}w(n){if(n.length>b){const v=[];for(;n.length>b;){const S=n.charCodeAt(b-1);let p;S===13||S>=55296&&S<=56319?(p=n.substring(0,b-1),n=n.substring(b-1)):(p=n.substring(0,b),n=n.substring(b));const k=A(p);v.push(new $(this.a.length,{line:0,column:0},{line:k.length-1,column:p.length-k[k.length-1]},k.length-1,p.length)),this.a.push(new y(p,k))}const f=A(n);return v.push(new $(this.a.length,{line:0,column:0},{line:f.length-1,column:n.length-f[f.length-1]},f.length-1,n.length)),this.a.push(new y(n,f)),v}let i=this.a[0].buffer.length;const u=A(n,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let v=0;v<u.length;v++)u[v]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let v=0;v<u.length;v++)u[v]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,l=this.a[0].lineStarts.length-1,r=t-this.a[0].lineStarts[l],c={line:l,column:r},s=new $(0,o,c,this.t(0,o,c),t-i);return this.g=c,[s]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let u=this.root,o="";const t=this.h.get2(n);if(t){u=t.node;const l=this.B(u,n-t.nodeStartLineNumber-1),r=this.a[u.piece.bufferIndex].buffer,c=this.u(u.piece.bufferIndex,u.piece.start);if(t.nodeStartLineNumber+u.piece.lineFeedCnt===n)o=r.substring(c+l,c+u.piece.length);else{const s=this.B(u,n-t.nodeStartLineNumber);return r.substring(c+l,c+s-i)}}else{let l=0;const r=n;for(;u!==R.$zC;)if(u.left!==R.$zC&&u.lf_left>=n-1)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt>n-1){const c=this.B(u,n-u.lf_left-2),s=this.B(u,n-u.lf_left-1),v=this.a[u.piece.bufferIndex].buffer,f=this.u(u.piece.bufferIndex,u.piece.start);return l+=u.size_left,this.h.set({node:u,nodeStartOffset:l,nodeStartLineNumber:r-(n-1-u.lf_left)}),v.substring(f+c,f+s-i)}else if(u.lf_left+u.piece.lineFeedCnt===n-1){const c=this.B(u,n-u.lf_left-2),s=this.a[u.piece.bufferIndex].buffer,v=this.u(u.piece.bufferIndex,u.piece.start);o=s.substring(v+c,v+u.piece.length);break}else n-=u.lf_left+u.piece.lineFeedCnt,l+=u.size_left+u.piece.length,u=u.right}for(u=u.next();u!==R.$zC;){const l=this.a[u.piece.bufferIndex].buffer;if(u.piece.lineFeedCnt>0){const r=this.B(u,0),c=this.u(u.piece.bufferIndex,u.piece.start);return o+=l.substring(c,c+r-i),o}else{const r=this.u(u.piece.bufferIndex,u.piece.start);o+=l.substr(r,u.piece.length)}u=u.next()}return o}y(){let n=this.root,i=1,u=0;for(;n!==R.$zC;)i+=n.lf_left+n.piece.lineFeedCnt,u+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=u,this.h.validate(this.c)}A(n,i){const u=n.piece,o=this.s(n,i),t=o.line-u.start.line;if(this.u(u.bufferIndex,u.end)-this.u(u.bufferIndex,u.start)===i){const l=this.t(n.piece.bufferIndex,u.start,o);if(l!==t)return{index:l,remainder:0}}return{index:t,remainder:o.column}}B(n,i){if(i<0)return 0;const u=n.piece,o=this.a[u.bufferIndex].lineStarts,t=u.start.line+i+1;return t>u.end.line?o[u.end.line]+u.end.column-o[u.start.line]-u.start.column:o[t]-o[u.start.line]-u.start.column}C(n,i){const u=n.piece,o=u.lineFeedCnt,t=this.u(u.bufferIndex,u.end),l=i,r=this.u(u.bufferIndex,l),c=this.t(u.bufferIndex,u.start,l),s=c-o,v=r-t,f=u.length+v;n.piece=new $(u.bufferIndex,u.start,l,c,f),(0,R.$GC)(this,n,v,s)}D(n,i){const u=n.piece,o=u.lineFeedCnt,t=this.u(u.bufferIndex,u.start),l=i,r=this.t(u.bufferIndex,l,u.end),c=this.u(u.bufferIndex,l),s=r-o,v=t-c,f=u.length+v;n.piece=new $(u.bufferIndex,l,u.end,r,f),(0,R.$GC)(this,n,v,s)}E(n,i,u){const o=n.piece,t=o.start,l=o.end,r=o.length,c=o.lineFeedCnt,s=i,v=this.t(o.bufferIndex,o.start,s),f=this.u(o.bufferIndex,i)-this.u(o.bufferIndex,t);n.piece=new $(o.bufferIndex,o.start,s,v,f),(0,R.$GC)(this,n,f-r,v-c);const S=new $(o.bufferIndex,u,l,this.t(o.bufferIndex,u,l),this.u(o.bufferIndex,l)-this.u(o.bufferIndex,u)),p=this.S(n,S);this.N(p)}F(n,i){this.Q(i,n)&&(i+=`
`);const u=this.K()&&this.L(i)&&this.M(n),o=this.a[0].buffer.length;this.a[0].buffer+=i;const t=A(i,!1);for(let p=0;p<t.length;p++)t[p]+=o;if(u){const p=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-p}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const l=this.a[0].lineStarts.length-1,r=this.a[0].buffer.length-this.a[0].lineStarts[l],c={line:l,column:r},s=n.piece.length+i.length,v=n.piece.lineFeedCnt,f=this.t(0,n.piece.start,c),S=f-v;n.piece=new $(n.piece.bufferIndex,n.piece.start,c,f,s),this.g=c,(0,R.$GC)(this,n,i.length,S)}G(n){let i=this.root;const u=this.h.get(n);if(u)return{node:u.node,nodeStartOffset:u.nodeStartOffset,remainder:n-u.nodeStartOffset};let o=0;for(;i!==R.$zC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){o+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:o};return this.h.set(t),t}else n-=i.size_left+i.piece.length,o+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let u=this.root,o=0;for(;u!==R.$zC;)if(u.left!==R.$zC&&u.lf_left>=n-1)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt>n-1){const t=this.B(u,n-u.lf_left-2),l=this.B(u,n-u.lf_left-1);return o+=u.size_left,{node:u,remainder:Math.min(t+i-1,l),nodeStartOffset:o}}else if(u.lf_left+u.piece.lineFeedCnt===n-1){const t=this.B(u,n-u.lf_left-2);if(t+i-1<=u.piece.length)return{node:u,remainder:t+i-1,nodeStartOffset:o};i-=u.piece.length-t;break}else n-=u.lf_left+u.piece.lineFeedCnt,o+=u.size_left+u.piece.length,u=u.right;for(u=u.next();u!==R.$zC;){if(u.piece.lineFeedCnt>0){const t=this.B(u,0),l=this.J(u);return{node:u,remainder:Math.min(i-1,t),nodeStartOffset:l}}else if(u.piece.length>=i-1){const t=this.J(u);return{node:u,remainder:i-1,nodeStartOffset:t}}else i-=u.piece.length;u=u.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const u=this.a[n.piece.bufferIndex],o=this.u(n.piece.bufferIndex,n.piece.start)+i;return u.buffer.charCodeAt(o)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===R.$zC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,u=this.a[i.bufferIndex].lineStarts,o=i.start.line,t=u[o]+i.start.column;return o===u.length-1||u[o+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===R.$zC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const u=[],o=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:o[n.piece.end.line]-o[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const l=n.piece.length-1,r=n.piece.lineFeedCnt-1;n.piece=new $(n.piece.bufferIndex,n.piece.start,t,r,l),(0,R.$GC)(this,n,-1,-1),n.piece.length===0&&u.push(n);const c={line:i.piece.start.line+1,column:0},s=i.piece.length-1,v=this.t(i.piece.bufferIndex,c,i.piece.end);i.piece=new $(i.piece.bufferIndex,c,i.piece.end,v,s),(0,R.$GC)(this,i,-1,-1),i.piece.length===0&&u.push(i);const f=this.w(`\r
`);this.S(n,f[0]);for(let S=0;S<u.length;S++)(0,R.$EC)(this,u[S])}Q(n,i){if(this.K()&&this.M(n)){const u=i.next();if(this.L(u)){if(n+=`
`,u.piece.length===1)(0,R.$EC)(this,u);else{const o=u.piece,t={line:o.start.line+1,column:0},l=o.length-1,r=this.t(o.bufferIndex,t,o.end);u.piece=new $(o.bufferIndex,t,o.end,r,l),(0,R.$GC)(this,u,-1,-1)}return!0}}return!1}iterate(n,i){if(n===R.$zC)return i(R.$zC);const u=this.iterate(n.left,i);return u&&i(n)&&this.iterate(n.right,i)}R(n){if(n===R.$zC)return"";const i=this.a[n.piece.bufferIndex],u=n.piece,o=this.u(u.bufferIndex,u.start),t=this.u(u.bufferIndex,u.end);return i.buffer.substring(o,t)}getPieceContent(n){const i=this.a[n.bufferIndex],u=this.u(n.bufferIndex,n.start),o=this.u(n.bufferIndex,n.end);return i.buffer.substring(u,o)}S(n,i){const u=new R.$yC(i,1);if(u.left=R.$zC,u.right=R.$zC,u.parent=R.$zC,u.size_left=0,u.lf_left=0,this.root===R.$zC)this.root=u,u.color=0;else if(n.right===R.$zC)n.right=u,u.parent=n;else{const t=(0,R.$AC)(n.right);t.left=u,u.parent=t}return(0,R.$FC)(this,u),u}T(n,i){const u=new R.$yC(i,1);if(u.left=R.$zC,u.right=R.$zC,u.parent=R.$zC,u.size_left=0,u.lf_left=0,this.root===R.$zC)this.root=u,u.color=0;else if(n.left===R.$zC)n.left=u,u.parent=n;else{const o=(0,R.$BC)(n.left);o.right=u,u.parent=o}return(0,R.$FC)(this,u),u}U(n){let i="";return this.iterate(n,u=>(i+=this.R(u),!0)),i}}e.$SC=g}),define(ke[189],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o$=e.$n$=void 0;class d{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const M=this.a.get(R);return this.a.delete(R),M}}addDragOperationTransfer(R,M){this.a.set(R,M)}}e.$n$=d;class N{constructor(R){this.identifier=R}}e.$o$=N}),define(ke[190],Pe([1,0,4,3]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=void 0;class L{constructor(){this.a=new Map,this.b=new Map,this.c=new d.$ee,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,m){return this.a.set(b,m),this.handleChange([b]),(0,N.$Tc)(()=>{this.a.get(b)===m&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,m){this.b.get(b)?.dispose();const E=new R(this,b,m);return this.b.set(b,E),(0,N.$Tc)(()=>{const A=this.b.get(b);!A||A!==E||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const m=this.get(b);if(m)return m;const E=this.b.get(b);return!E||E.isResolved?null:(await E.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const E=this.b.get(b);return!!(!E||E.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Vt=L;class R extends N.$Vc{get isResolved(){return this.c}constructor(b,m,E){super(),this.f=b,this.g=m,this.h=E,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[191],Pe([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(ke[192],Pe([1,0,4,3,191]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=void 0,e.$fj=A;class R extends N.$Vc{constructor($,y="",w="",h=!0,g){super(),this.h=this.B(new d.$ee),this.onDidChange=this.h.event,this.w=!0,this.j=$,this.m=y,this.u=w,this.w=h,this.C=g}get id(){return this.j}get label(){return this.m}set label($){this.D($)}D($){this.m!==$&&(this.m=$,this.h.fire({label:$}))}get tooltip(){return this.n||""}set tooltip($){this.F($)}F($){this.n!==$&&(this.n=$,this.h.fire({tooltip:$}))}get class(){return this.u}set class($){this.G($)}G($){this.u!==$&&(this.u=$,this.h.fire({class:$}))}get enabled(){return this.w}set enabled($){this.H($)}H($){this.w!==$&&(this.w=$,this.h.fire({enabled:$}))}get checked(){return this.z}set checked($){this.I($)}I($){this.z!==$&&(this.z=$,this.h.fire({checked:$}))}async run($,y){this.C&&await this.C($)}}e.$aj=R;class M extends N.$Vc{constructor(){super(...arguments),this.f=this.B(new d.$ee),this.onWillRun=this.f.event,this.m=this.B(new d.$ee),this.onDidRun=this.m.event}async run($,y){if(!$.enabled)return;this.f.fire({action:$});let w;try{await this.u($,y)}catch(h){w=h}this.m.fire({action:$,error:w})}async u($,y){await $.run(y)}}e.$bj=M;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let y=[];for(const w of $)w.length&&(y.length?y=[...y,new b,...w]:y=w);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$cj=b;class m{get actions(){return this.a}constructor($,y,w,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=y,this.class=h,this.a=w}async run(){}}e.$dj=m;class E extends R{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,L.localize(0,null),void 0,!1)}}e.$ej=E;function A(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked,run:async(...$)=>D.run(...$),tooltip:D.label}}}),define(ke[193],Pe([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(ke[194],Pe([1,0,193]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=E,e.$2m=A,e.$3m=D;const N=60,L=N*60,R=L*24,M=R*7,b=R*30,m=R*365;function E($,y,w,h){typeof $!="number"&&($=$.getTime());const g=Math.round((new Date().getTime()-$)/1e3);if(g<-30)return(0,d.localize)(0,null,E(new Date().getTime()+g*1e3,!1));if(!h&&g<30)return(0,d.localize)(1,null);let a;return g<N?(a=g,y?a===1?w?(0,d.localize)(2,null,a):(0,d.localize)(3,null,a):w?(0,d.localize)(4,null,a):(0,d.localize)(5,null,a):a===1?w?(0,d.localize)(6,null,a):(0,d.localize)(7,null,a):w?(0,d.localize)(8,null,a):(0,d.localize)(9,null,a)):g<L?(a=Math.floor(g/N),y?a===1?w?(0,d.localize)(10,null,a):(0,d.localize)(11,null,a):w?(0,d.localize)(12,null,a):(0,d.localize)(13,null,a):a===1?w?(0,d.localize)(14,null,a):(0,d.localize)(15,null,a):w?(0,d.localize)(16,null,a):(0,d.localize)(17,null,a)):g<R?(a=Math.floor(g/L),y?a===1?w?(0,d.localize)(18,null,a):(0,d.localize)(19,null,a):w?(0,d.localize)(20,null,a):(0,d.localize)(21,null,a):a===1?w?(0,d.localize)(22,null,a):(0,d.localize)(23,null,a):w?(0,d.localize)(24,null,a):(0,d.localize)(25,null,a)):g<M?(a=Math.floor(g/R),y?a===1?(0,d.localize)(26,null,a):(0,d.localize)(27,null,a):a===1?(0,d.localize)(28,null,a):(0,d.localize)(29,null,a)):g<b?(a=Math.floor(g/M),y?a===1?w?(0,d.localize)(30,null,a):(0,d.localize)(31,null,a):w?(0,d.localize)(32,null,a):(0,d.localize)(33,null,a):a===1?w?(0,d.localize)(34,null,a):(0,d.localize)(35,null,a):w?(0,d.localize)(36,null,a):(0,d.localize)(37,null,a)):g<m?(a=Math.floor(g/b),y?a===1?w?(0,d.localize)(38,null,a):(0,d.localize)(39,null,a):w?(0,d.localize)(40,null,a):(0,d.localize)(41,null,a):a===1?w?(0,d.localize)(42,null,a):(0,d.localize)(43,null,a):w?(0,d.localize)(44,null,a):(0,d.localize)(45,null,a)):(a=Math.floor(g/m),y?a===1?w?(0,d.localize)(46,null,a):(0,d.localize)(47,null,a):w?(0,d.localize)(48,null,a):(0,d.localize)(49,null,a):a===1?w?(0,d.localize)(50,null,a):(0,d.localize)(51,null,a):w?(0,d.localize)(52,null,a):(0,d.localize)(53,null,a))}function A($,y){const w=Math.abs($/1e3);return w<1?y?(0,d.localize)(54,null,$):(0,d.localize)(55,null,$):w<N?y?(0,d.localize)(56,null,Math.round($)/1e3):(0,d.localize)(57,null,Math.round($)/1e3):w<L?y?(0,d.localize)(58,null,Math.round($/(1e3*N))):(0,d.localize)(59,null,Math.round($/(1e3*N))):w<R?y?(0,d.localize)(60,null,Math.round($/(1e3*L))):(0,d.localize)(61,null,Math.round($/(1e3*L))):(0,d.localize)(62,null,Math.round($/(1e3*R)))}function D($){return $.getFullYear()+"-"+String($.getMonth()+1).padStart(2,"0")+"-"+String($.getDate()).padStart(2,"0")+"T"+String($.getHours()).padStart(2,"0")+":"+String($.getMinutes()).padStart(2,"0")+":"+String($.getSeconds()).padStart(2,"0")+"."+($.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[195],Pe([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(ke[47],Pe([1,0,19,18,195]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gj=m,e.$hj=E,e.$ij=A;function R(D,$){return $&&(D.stack||D.stacktrace)?L.localize(0,null,b(D),M(D.stack)||M(D.stacktrace)):b(D)}function M(D){return Array.isArray(D)?D.join(`
`):D}function b(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?L.localize(1,null,D.message):D.message||L.localize(2,null)}function m(D=null,$=!1){if(!D)return L.localize(3,null);if(Array.isArray(D)){const y=d.$Hb(D),w=m(y[0],$);return y.length>1?L.localize(4,null,w,y.length):w}if(N.$8f(D))return D;if(D.detail){const y=D.detail;if(y.error)return R(y.error,$);if(y.exception)return R(y.exception,$)}return D.stack?R(D,$):D.message?D.message:L.localize(5,null)}function E(D){const $=D;return $ instanceof Error&&Array.isArray($.actions)}function A(D,$){let y;return typeof D=="string"?y=new Error(D):y=D,y.actions=$,y}}),define(ke[196],Pe([9,10]),function(le,e){return le.create("vs/base/common/platform",e)}),define(ke[12],Pe([1,0,196]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=l,e.$D=S,e.$J=p,e.$g="en";let N=!1,L=!1,R=!1,M=!1,b=!1,m=!1,E=!1,A=!1,D=!1,$=!1,y,w=e.$g,h=e.$g,g,a;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const u=typeof i?.versions?.electron=="string",o=u&&i?.type==="renderer";if(typeof i=="object"){N=i.platform==="win32",L=i.platform==="darwin",R=i.platform==="linux",M=R&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,E=u,D=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,w=e.$g;const k=i.env.VSCODE_NLS_CONFIG;if(k)try{const P=JSON.parse(k),C=P.availableLanguages["*"];y=P.locale,h=P.osLocale,w=C||e.$g,g=P._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!o?(a=navigator.userAgent,N=a.indexOf("Windows")>=0,L=a.indexOf("Macintosh")>=0,A=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=a.indexOf("Linux")>=0,$=a?.indexOf("Mobi")>=0,m=!0,y=d.getConfiguredDefaultLocale(d.localize(0,null))||e.$g,w=y,h=navigator.language):console.error("Unable to resolve platform.");var t;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(t||(e.Platform=t={}));function l(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let r=0;L?r=1:N?r=3:R&&(r=2),e.$i=N,e.$j=L,e.$k=R,e.$l=M,e.$m=b,e.$n=E,e.$o=m,e.$p=m&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=A,e.$s=$,e.$t=D,e.$u=r,e.$v=a,e.$w=w;var c;(function(k){function P(){return e.$w}k.value=P;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}k.isDefaultVariant=C;function I(){return e.$w==="en"}k.isDefault=I})(c||(e.Language=c={})),e.$x=y,e.$y=h,e.$z=g,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const k=[];n.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let I=0,T=k.length;I<T;I++){const j=k[I];if(j.id===C.data.vscodeScheduleAsyncWork){k.splice(I,1),j.callback();return}}});let P=0;return C=>{const I=++P;k.push({id:I,callback:C}),n.postMessage({vscodeScheduleAsyncWork:I},"*")}}return k=>setTimeout(k)})();var s;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=L||A?2:N?1:3;let v=!0,f=!1;function S(){if(!f){f=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,v=new Uint16Array(k.buffer)[0]===513}return v}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function p(k){return parseFloat(k)>=20}}),define(ke[51],Pe([1,0,12]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const R=L.process;N={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return d.$i?"win32":d.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$ec=N.platform,e.$fc=N.arch}),define(ke[17],Pe([1,0,51]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const N=65,L=97,R=90,M=122,b=46,m=47,E=92,A=58,D=63;class $ extends Error{constructor(l,r,c){let s;typeof r=="string"&&r.indexOf("not ")===0?(s="must not be",r=r.replace(/^not /,"")):s="must be";const v=l.indexOf(".")!==-1?"property":"argument";let f=`The "${l}" ${v} ${s} of type ${r}`;f+=`. Received type ${typeof c}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,l){if(t===null||typeof t!="object")throw new $(l,"Object",t)}function w(t,l){if(typeof t!="string")throw new $(l,"string",t)}const h=d.$ec==="win32";function g(t){return t===m||t===E}function a(t){return t===m}function n(t){return t>=N&&t<=R||t>=L&&t<=M}function i(t,l,r,c){let s="",v=0,f=-1,S=0,p=0;for(let k=0;k<=t.length;++k){if(k<t.length)p=t.charCodeAt(k);else{if(c(p))break;p=m}if(c(p)){if(!(f===k-1||S===1))if(S===2){if(s.length<2||v!==2||s.charCodeAt(s.length-1)!==b||s.charCodeAt(s.length-2)!==b){if(s.length>2){const P=s.lastIndexOf(r);P===-1?(s="",v=0):(s=s.slice(0,P),v=s.length-1-s.lastIndexOf(r)),f=k,S=0;continue}else if(s.length!==0){s="",v=0,f=k,S=0;continue}}l&&(s+=s.length>0?`${r}..`:"..",v=2)}else s.length>0?s+=`${r}${t.slice(f+1,k)}`:s=t.slice(f+1,k),v=k-f-1;f=k,S=0}else p===b&&S!==-1?++S:S=-1}return s}function u(t,l){y(l,"pathObject");const r=l.dir||l.root,c=l.base||`${l.name||""}${l.ext||""}`;return r?r===l.root?`${r}${c}`:`${r}${t}${c}`:c}e.$gc={resolve(...t){let l="",r="",c=!1;for(let s=t.length-1;s>=-1;s--){let v;if(s>=0){if(v=t[s],w(v,"path"),v.length===0)continue}else l.length===0?v=d.cwd():(v=d.env[`=${l}`]||d.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==l.toLowerCase()&&v.charCodeAt(2)===E)&&(v=`${l}\\`));const f=v.length;let S=0,p="",k=!1;const P=v.charCodeAt(0);if(f===1)g(P)&&(S=1,k=!0);else if(g(P))if(k=!0,g(v.charCodeAt(1))){let C=2,I=C;for(;C<f&&!g(v.charCodeAt(C));)C++;if(C<f&&C!==I){const T=v.slice(I,C);for(I=C;C<f&&g(v.charCodeAt(C));)C++;if(C<f&&C!==I){for(I=C;C<f&&!g(v.charCodeAt(C));)C++;(C===f||C!==I)&&(p=`\\\\${T}\\${v.slice(I,C)}`,S=C)}}}else S=1;else n(P)&&v.charCodeAt(1)===A&&(p=v.slice(0,2),S=2,f>2&&g(v.charCodeAt(2))&&(k=!0,S=3));if(p.length>0)if(l.length>0){if(p.toLowerCase()!==l.toLowerCase())continue}else l=p;if(c){if(l.length>0)break}else if(r=`${v.slice(S)}\\${r}`,c=k,k&&l.length>0)break}return r=i(r,!c,"\\",g),c?`${l}\\${r}`:`${l}${r}`||"."},normalize(t){w(t,"path");const l=t.length;if(l===0)return".";let r=0,c,s=!1;const v=t.charCodeAt(0);if(l===1)return a(v)?"\\":t;if(g(v))if(s=!0,g(t.charCodeAt(1))){let S=2,p=S;for(;S<l&&!g(t.charCodeAt(S));)S++;if(S<l&&S!==p){const k=t.slice(p,S);for(p=S;S<l&&g(t.charCodeAt(S));)S++;if(S<l&&S!==p){for(p=S;S<l&&!g(t.charCodeAt(S));)S++;if(S===l)return`\\\\${k}\\${t.slice(p)}\\`;S!==p&&(c=`\\\\${k}\\${t.slice(p,S)}`,r=S)}}}else r=1;else n(v)&&t.charCodeAt(1)===A&&(c=t.slice(0,2),r=2,l>2&&g(t.charCodeAt(2))&&(s=!0,r=3));let f=r<l?i(t.slice(r),!s,"\\",g):"";return f.length===0&&!s&&(f="."),f.length>0&&g(t.charCodeAt(l-1))&&(f+="\\"),c===void 0?s?`\\${f}`:f:s?`${c}\\${f}`:`${c}${f}`},isAbsolute(t){w(t,"path");const l=t.length;if(l===0)return!1;const r=t.charCodeAt(0);return g(r)||l>2&&n(r)&&t.charCodeAt(1)===A&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,r;for(let v=0;v<t.length;++v){const f=t[v];w(f,"path"),f.length>0&&(l===void 0?l=r=f:l+=`\\${f}`)}if(l===void 0)return".";let c=!0,s=0;if(typeof r=="string"&&g(r.charCodeAt(0))){++s;const v=r.length;v>1&&g(r.charCodeAt(1))&&(++s,v>2&&(g(r.charCodeAt(2))?++s:c=!1))}if(c){for(;s<l.length&&g(l.charCodeAt(s));)s++;s>=2&&(l=`\\${l.slice(s)}`)}return e.$gc.normalize(l)},relative(t,l){if(w(t,"from"),w(l,"to"),t===l)return"";const r=e.$gc.resolve(t),c=e.$gc.resolve(l);if(r===c||(t=r.toLowerCase(),l=c.toLowerCase(),t===l))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===E;)s++;let v=t.length;for(;v-1>s&&t.charCodeAt(v-1)===E;)v--;const f=v-s;let S=0;for(;S<l.length&&l.charCodeAt(S)===E;)S++;let p=l.length;for(;p-1>S&&l.charCodeAt(p-1)===E;)p--;const k=p-S,P=f<k?f:k;let C=-1,I=0;for(;I<P;I++){const j=t.charCodeAt(s+I);if(j!==l.charCodeAt(S+I))break;j===E&&(C=I)}if(I!==P){if(C===-1)return c}else{if(k>P){if(l.charCodeAt(S+I)===E)return c.slice(S+I+1);if(I===2)return c.slice(S+I)}f>P&&(t.charCodeAt(s+I)===E?C=I:I===2&&(C=3)),C===-1&&(C=0)}let T="";for(I=s+C+1;I<=v;++I)(I===v||t.charCodeAt(I)===E)&&(T+=T.length===0?"..":"\\..");return S+=C,T.length>0?`${T}${c.slice(S,p)}`:(c.charCodeAt(S)===E&&++S,c.slice(S,p))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.$gc.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===E){if(l.charCodeAt(1)===E){const r=l.charCodeAt(2);if(r!==D&&r!==b)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(n(l.charCodeAt(0))&&l.charCodeAt(1)===A&&l.charCodeAt(2)===E)return`\\\\?\\${l}`;return t},dirname(t){w(t,"path");const l=t.length;if(l===0)return".";let r=-1,c=0;const s=t.charCodeAt(0);if(l===1)return g(s)?t:".";if(g(s)){if(r=c=1,g(t.charCodeAt(1))){let S=2,p=S;for(;S<l&&!g(t.charCodeAt(S));)S++;if(S<l&&S!==p){for(p=S;S<l&&g(t.charCodeAt(S));)S++;if(S<l&&S!==p){for(p=S;S<l&&!g(t.charCodeAt(S));)S++;if(S===l)return t;S!==p&&(r=c=S+1)}}}}else n(s)&&t.charCodeAt(1)===A&&(r=l>2&&g(t.charCodeAt(2))?3:2,c=r);let v=-1,f=!0;for(let S=l-1;S>=c;--S)if(g(t.charCodeAt(S))){if(!f){v=S;break}}else f=!1;if(v===-1){if(r===-1)return".";v=r}return t.slice(0,v)},basename(t,l){l!==void 0&&w(l,"ext"),w(t,"path");let r=0,c=-1,s=!0,v;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(r=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let f=l.length-1,S=-1;for(v=t.length-1;v>=r;--v){const p=t.charCodeAt(v);if(g(p)){if(!s){r=v+1;break}}else S===-1&&(s=!1,S=v+1),f>=0&&(p===l.charCodeAt(f)?--f===-1&&(c=v):(f=-1,c=S))}return r===c?c=S:c===-1&&(c=t.length),t.slice(r,c)}for(v=t.length-1;v>=r;--v)if(g(t.charCodeAt(v))){if(!s){r=v+1;break}}else c===-1&&(s=!1,c=v+1);return c===-1?"":t.slice(r,c)},extname(t){w(t,"path");let l=0,r=-1,c=0,s=-1,v=!0,f=0;t.length>=2&&t.charCodeAt(1)===A&&n(t.charCodeAt(0))&&(l=c=2);for(let S=t.length-1;S>=l;--S){const p=t.charCodeAt(S);if(g(p)){if(!v){c=S+1;break}continue}s===-1&&(v=!1,s=S+1),p===b?r===-1?r=S:f!==1&&(f=1):r!==-1&&(f=-1)}return r===-1||s===-1||f===0||f===1&&r===s-1&&r===c+1?"":t.slice(r,s)},format:u.bind(null,"\\"),parse(t){w(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.length;let c=0,s=t.charCodeAt(0);if(r===1)return g(s)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(g(s)){if(c=1,g(t.charCodeAt(1))){let C=2,I=C;for(;C<r&&!g(t.charCodeAt(C));)C++;if(C<r&&C!==I){for(I=C;C<r&&g(t.charCodeAt(C));)C++;if(C<r&&C!==I){for(I=C;C<r&&!g(t.charCodeAt(C));)C++;C===r?c=C:C!==I&&(c=C+1)}}}}else if(n(s)&&t.charCodeAt(1)===A){if(r<=2)return l.root=l.dir=t,l;if(c=2,g(t.charCodeAt(2))){if(r===3)return l.root=l.dir=t,l;c=3}}c>0&&(l.root=t.slice(0,c));let v=-1,f=c,S=-1,p=!0,k=t.length-1,P=0;for(;k>=c;--k){if(s=t.charCodeAt(k),g(s)){if(!p){f=k+1;break}continue}S===-1&&(p=!1,S=k+1),s===b?v===-1?v=k:P!==1&&(P=1):v!==-1&&(P=-1)}return S!==-1&&(v===-1||P===0||P===1&&v===S-1&&v===f+1?l.base=l.name=t.slice(f,S):(l.name=t.slice(f,v),l.base=t.slice(f,S),l.ext=t.slice(v,S))),f>0&&f!==c?l.dir=t.slice(0,f-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(h){const t=/\\/g;return()=>{const l=d.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>d.cwd()})();e.$hc={resolve(...t){let l="",r=!1;for(let c=t.length-1;c>=-1&&!r;c--){const s=c>=0?t[c]:o();w(s,"path"),s.length!==0&&(l=`${s}/${l}`,r=s.charCodeAt(0)===m)}return l=i(l,!r,"/",a),r?`/${l}`:l.length>0?l:"."},normalize(t){if(w(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===m,r=t.charCodeAt(t.length-1)===m;return t=i(t,!l,"/",a),t.length===0?l?"/":r?"./":".":(r&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return w(t,"path"),t.length>0&&t.charCodeAt(0)===m},join(...t){if(t.length===0)return".";let l;for(let r=0;r<t.length;++r){const c=t[r];w(c,"path"),c.length>0&&(l===void 0?l=c:l+=`/${c}`)}return l===void 0?".":e.$hc.normalize(l)},relative(t,l){if(w(t,"from"),w(l,"to"),t===l||(t=e.$hc.resolve(t),l=e.$hc.resolve(l),t===l))return"";const r=1,c=t.length,s=c-r,v=1,f=l.length-v,S=s<f?s:f;let p=-1,k=0;for(;k<S;k++){const C=t.charCodeAt(r+k);if(C!==l.charCodeAt(v+k))break;C===m&&(p=k)}if(k===S)if(f>S){if(l.charCodeAt(v+k)===m)return l.slice(v+k+1);if(k===0)return l.slice(v+k)}else s>S&&(t.charCodeAt(r+k)===m?p=k:k===0&&(p=0));let P="";for(k=r+p+1;k<=c;++k)(k===c||t.charCodeAt(k)===m)&&(P+=P.length===0?"..":"/..");return`${P}${l.slice(v+p)}`},toNamespacedPath(t){return t},dirname(t){if(w(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===m;let r=-1,c=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===m){if(!c){r=s;break}}else c=!1;return r===-1?l?"/":".":l&&r===1?"//":t.slice(0,r)},basename(t,l){l!==void 0&&w(l,"ext"),w(t,"path");let r=0,c=-1,s=!0,v;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let f=l.length-1,S=-1;for(v=t.length-1;v>=0;--v){const p=t.charCodeAt(v);if(p===m){if(!s){r=v+1;break}}else S===-1&&(s=!1,S=v+1),f>=0&&(p===l.charCodeAt(f)?--f===-1&&(c=v):(f=-1,c=S))}return r===c?c=S:c===-1&&(c=t.length),t.slice(r,c)}for(v=t.length-1;v>=0;--v)if(t.charCodeAt(v)===m){if(!s){r=v+1;break}}else c===-1&&(s=!1,c=v+1);return c===-1?"":t.slice(r,c)},extname(t){w(t,"path");let l=-1,r=0,c=-1,s=!0,v=0;for(let f=t.length-1;f>=0;--f){const S=t.charCodeAt(f);if(S===m){if(!s){r=f+1;break}continue}c===-1&&(s=!1,c=f+1),S===b?l===-1?l=f:v!==1&&(v=1):l!==-1&&(v=-1)}return l===-1||c===-1||v===0||v===1&&l===c-1&&l===r+1?"":t.slice(l,c)},format:u.bind(null,"/"),parse(t){w(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.charCodeAt(0)===m;let c;r?(l.root="/",c=1):c=0;let s=-1,v=0,f=-1,S=!0,p=t.length-1,k=0;for(;p>=c;--p){const P=t.charCodeAt(p);if(P===m){if(!S){v=p+1;break}continue}f===-1&&(S=!1,f=p+1),P===b?s===-1?s=p:k!==1&&(k=1):s!==-1&&(k=-1)}if(f!==-1){const P=v===0&&r?1:v;s===-1||k===0||k===1&&s===f-1&&s===v+1?l.base=l.name=t.slice(P,f):(l.name=t.slice(P,s),l.base=t.slice(P,f),l.ext=t.slice(s,f))}return v>0?l.dir=t.slice(0,v-1):r&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=h?e.$gc.normalize:e.$hc.normalize,e.$jc=h?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=h?e.$gc.join:e.$hc.join,e.$lc=h?e.$gc.resolve:e.$hc.resolve,e.$mc=h?e.$gc.relative:e.$hc.relative,e.$nc=h?e.$gc.dirname:e.$hc.dirname,e.$oc=h?e.$gc.basename:e.$hc.basename,e.$pc=h?e.$gc.extname:e.$hc.extname,e.$qc=h?e.$gc.format:e.$hc.format,e.$rc=h?e.$gc.parse:e.$hc.parse,e.$sc=h?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=h?e.$gc.sep:e.$hc.sep,e.$uc=h?e.$gc.delimiter:e.$hc.delimiter}),define(ke[132],Pe([1,0,46,17]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=b,e.$gr=m,e.$hr=E,e.$ir=A,e.$jr=D,e.$kr=$,e.$lr=y,e.$mr=w,e.$nr=h,e.$or=g,e.$pr=s,e.$qr=v,e.$rr=f;const L=new d.$V(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),R=new d.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new d.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(S,p,k=!1){const P=S||"",C=p||"",I=L.value.collator.compare(P,C);return L.value.collatorIsNumeric&&I===0&&P!==C?P<C?-1:1:I}function m(S,p){const k=R.value.collator;return S=S||"",p=p||"",u(k,S,p)}function E(S,p){const k=R.value.collator;return S=S||"",p=p||"",r(S,p)||u(k,S,p)}function A(S,p){const k=R.value.collator;return S=S||"",p=p||"",l(S,p)||u(k,S,p)}function D(S,p){return S=S||"",p=p||"",S===p?0:S<p?-1:1}function $(S,p){const[k,P]=n(S),[C,I]=n(p);let T=L.value.collator.compare(P,I);if(T===0){if(L.value.collatorIsNumeric&&P!==I)return P<I?-1:1;if(T=L.value.collator.compare(k,C),L.value.collatorIsNumeric&&T===0&&k!==C)return k<C?-1:1}return T}function y(S,p){S=S||"",p=p||"";const k=i(S),P=i(p),C=R.value.collator,I=M.value.collator;return u(I,k,P)||u(C,S,p)}function w(S,p){S=S||"",p=p||"";const k=i(S),P=i(p),C=R.value.collator,I=M.value.collator;return u(I,k,P)||r(S,p)||u(C,S,p)}function h(S,p){S=S||"",p=p||"";const k=i(S),P=i(p),C=R.value.collator,I=M.value.collator;return u(I,k,P)||l(S,p)||u(C,S,p)}function g(S,p){S=S||"",p=p||"";const k=i(S).toLowerCase(),P=i(p).toLowerCase();return k!==P?k<P?-1:1:S!==p?S<p?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function n(S,p=!1){const k=S?a.exec(S):[];let P=[k&&k[1]||"",k&&k[3]||""];return p&&(!P[0]&&P[1]||P[0]&&P[0].charAt(0)===".")&&(P=[P[0]+"."+P[1],""]),P}function i(S){const p=S?a.exec(S):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function u(S,p,k){const P=S.compare(p,k);return P!==0?P:p.length!==k.length?p.length<k.length?-1:1:0}function o(S){const p=S.charAt(0);return p.toLocaleUpperCase()!==p}function t(S){const p=S.charAt(0);return p.toLocaleLowerCase()!==p}function l(S,p){return o(S)&&t(p)?-1:t(S)&&o(p)?1:0}function r(S,p){return t(S)&&o(p)?-1:o(S)&&t(p)?1:0}function c(S,p,k=!1){return k||(S=S&&S.toLowerCase(),p=p&&p.toLowerCase()),S===p?0:S<p?-1:1}function s(S,p,k=!1){const P=S.split(N.sep),C=p.split(N.sep),I=P.length-1,T=C.length-1;let j,z;for(let O=0;;O++){if(j=I===O,z=T===O,j&&z)return b(P[O],C[O],k);if(j)return-1;if(z)return 1;const F=c(P[O],C[O],k);if(F!==0)return F}}function v(S,p,k){const P=S.toLowerCase(),C=p.toLowerCase(),I=f(S,p,k);if(I)return I;const T=P.endsWith(k),j=C.endsWith(k);if(T!==j)return T?-1:1;const z=b(P,C);return z!==0?z:P.localeCompare(C)}function f(S,p,k){const P=S.toLowerCase(),C=p.toLowerCase(),I=P.startsWith(k),T=C.startsWith(k);if(I!==T)return I?-1:1;if(I&&T){if(P.length<C.length)return-1;if(P.length>C.length)return 1}return 0}}),define(ke[31],Pe([1,0,17,12,14,18]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=M,e.$og=b,e.$pg=m,e.$qg=E,e.$rg=A,e.$sg=w,e.$tg=h,e.$ug=g,e.$vg=a,e.$wg=n,e.$xg=i,e.$yg=u,e.$zg=o,e.$Ag=t,e.$Bg=l,e.$Cg=r,e.$Dg=v;function M(f){return f===47||f===92}function b(f){return f.replace(/[\\/]/g,d.$hc.sep)}function m(f){return f.indexOf("/")===-1&&(f=b(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}function E(f,S=d.$hc.sep){if(!f)return"";const p=f.length,k=f.charCodeAt(0);if(M(k)){if(M(f.charCodeAt(1))&&!M(f.charCodeAt(2))){let C=3;const I=C;for(;C<p&&!M(f.charCodeAt(C));C++);if(I!==C&&!M(f.charCodeAt(C+1))){for(C+=1;C<p;C++)if(M(f.charCodeAt(C)))return f.slice(0,C+1).replace(/[\\/]/g,S)}}return S}else if(a(k)&&f.charCodeAt(1)===58)return M(f.charCodeAt(2))?f.slice(0,2)+S:f.slice(0,2);let P=f.indexOf("://");if(P!==-1){for(P+=3;P<p;P++)if(M(f.charCodeAt(P)))return f.slice(0,P+1)}return""}function A(f){if(!N.$i||!f||f.length<5)return!1;let S=f.charCodeAt(0);if(S!==92||(S=f.charCodeAt(1),S!==92))return!1;let p=2;const k=p;for(;p<f.length&&(S=f.charCodeAt(p),S!==92);p++);return!(k===p||(S=f.charCodeAt(p+1),isNaN(S)||S===92))}const D=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(f,S=N.$i){const p=S?D:$;return!(!f||f.length===0||/^\s+$/.test(f)||(p.lastIndex=0,p.test(f))||S&&y.test(f)||f==="."||f===".."||S&&f[f.length-1]==="."||S&&f.length!==f.trim().length||f.length>255)}function h(f,S,p){const k=f===S;return!p||k?k:!f||!S?!1:(0,L.$xf)(f,S)}function g(f,S,p,k=d.sep){if(f===S)return!0;if(!f||!S||S.length>f.length)return!1;if(p){if(!(0,L.$yf)(f,S))return!1;if(S.length===f.length)return!0;let C=S.length;return S.charAt(S.length-1)===k&&C--,f.charAt(C)===k}return S.charAt(S.length-1)!==k&&(S+=k),f.indexOf(S)===0}function a(f){return f>=65&&f<=90||f>=97&&f<=122}function n(f,S){return N.$i&&f.endsWith(":")&&(f+=d.sep),(0,d.$jc)(f)||(f=(0,d.$kc)(S,f)),f=(0,d.$ic)(f),i(f)}function i(f){return N.$i?(f=(0,L.$ff)(f,d.sep),f.endsWith(":")&&(f+=d.sep)):(f=(0,L.$ff)(f,d.sep),f||(f=d.sep)),f}function u(f){const S=(0,d.$ic)(f);return N.$i?f.length>3?!1:o(S)&&(f.length===2||S.charCodeAt(2)===92):S===d.$hc.sep}function o(f,S=N.$i){return S?a(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}function t(f,S=N.$i){return o(f,S)?f[0]:void 0}function l(f,S,p){return S.length>f.length?-1:f===S?0:(p&&(f=f.toLowerCase(),S=S.toLowerCase()),f.indexOf(S))}function r(f){const S=f.split(":");let p,k,P;for(const C of S){const I=Number(C);(0,R.$_f)(I)?k===void 0?k=I:P===void 0&&(P=I):p=p?[p,C].join(":"):C}if(!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:k!==void 0?k:void 0,column:P!==void 0?P:k!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(f,S,p=8){let k="";for(let C=0;C<p;C++){let I;C===0&&N.$i&&!S&&(p===3||p===4)?I=s:I=c,k+=I.charAt(Math.floor(Math.random()*I.length))}let P;return S?P=`${S}-${k}`:P=k,f?(0,d.$kc)(f,P):P}}),define(ke[133],Pe([1,0,132,127,56,17,12,14]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=A,e.$tr=g,e.$ur=r,e.$vr=k,e.$wr=z,e.$xr=F;const m=0,E=[m,[]];function A(B,Z,q,Q){if(!B||!Z)return E;const x=B.length,X=Z.length;if(x<X)return E;const ie=B.toLowerCase();return D(Z,q,X,B,ie,x,Q)}function D(B,Z,q,Q,x,X,ie){const me=[],ue=[];for(let ee=0;ee<q;ee++){const pe=ee*X,Ce=pe-X,se=ee>0,re=B[ee],oe=Z[ee];for(let K=0;K<X;K++){const ne=K>0,$e=pe+K,be=$e-1,Ae=Ce+K-1,fe=ne?me[be]:0,Se=se&&ne?me[Ae]:0,Ie=se&&ne?ue[Ae]:0;let ze;!Se&&se?ze=0:ze=$(re,oe,Q,x,K,Ie),ze&&Se+ze>=fe&&(ie||se||x.startsWith(Z,K))?(ue[$e]=Ie+1,me[$e]=Se+ze):(ue[$e]=m,me[$e]=fe)}}const ve=[];let te=q-1,U=X-1;for(;te>=0&&U>=0;){const ee=te*X+U;ue[ee]===m||(ve.push(U),te--),U--}return[me[q*X-1],ve.reverse()]}function $(B,Z,q,Q,x,X){let ie=0;if(!y(Z,Q[x]))return ie;if(ie+=1,X>0&&(ie+=X*5),B===q[x]&&(ie+=1),x===0)ie+=8;else{const me=w(q.charCodeAt(x-1));me?ie+=me:(0,N.$Ak)(q.charCodeAt(x))&&X===0&&(ie+=2)}return ie}function y(B,Z){return B===Z?!0:B==="/"||B==="\\"?Z==="/"||Z==="\\":!1}function w(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function g(B,Z,q=0,Q=0){const x=Z;return x.values&&x.values.length>1?a(B,x.values,q,Q):n(B,Z,q,Q)}function a(B,Z,q,Q){let x=0;const X=[];for(const ie of Z){const[me,ue]=n(B,ie,q,Q);if(typeof me!="number")return h;x+=me,X.push(...ue)}return[x,S(X)]}function n(B,Z,q,Q){const x=(0,N.$Jk)(Z.original,Z.originalLowercase,q,B,B.toLowerCase(),Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return x?[x[0],(0,N.$Gk)(x)]:h}const i=Object.freeze({score:0}),u=1<<18,o=1<<17,t=65536;function l(B,Z,q,Q){const x=Q.values?Q.values:[Q];return(0,L.$jj)({[Q.normalized]:{values:x.map(ie=>({value:ie.normalized,expectContiguousMatch:ie.expectContiguousMatch})),label:B,description:Z,allowNonContiguousMatches:q}})}function r(B,Z,q,Q,x){if(!B||!Z.normalized)return i;const X=Q.getItemLabel(B);if(!X)return i;const ie=Q.getItemDescription(B),me=l(X,ie,q,Z),ue=x[me];if(ue)return ue;const ve=c(X,ie,Q.getItemPath(B),Z,q);return x[me]=ve,ve}function c(B,Z,q,Q,x){const X=!q||!Q.containsPathSeparator;return q&&(M.$k?Q.pathNormalized===q:(0,b.$xf)(Q.pathNormalized,q))?{score:u,labelMatch:[{start:0,end:B.length}],descriptionMatch:Z?[{start:0,end:Z.length}]:void 0}:Q.values&&Q.values.length>1?s(B,Z,q,Q.values,X,x):v(B,Z,q,Q,X,x)}function s(B,Z,q,Q,x,X){let ie=0;const me=[],ue=[];for(const ve of Q){const{score:te,labelMatch:U,descriptionMatch:ee}=v(B,Z,q,ve,x,X);if(te===m)return i;ie+=te,U&&me.push(...U),ee&&ue.push(...ee)}return{score:ie,labelMatch:S(me),descriptionMatch:S(ue)}}function v(B,Z,q,Q,x,X){if(x||!Z){const[ie,me]=A(B,Q.normalized,Q.normalizedLowercase,X&&!Q.expectContiguousMatch);if(ie){const ue=(0,N.$xk)(Q.normalized,B);let ve;if(ue){ve=o;const te=Math.round(Q.normalized.length/B.length*100);ve+=te}else ve=t;return{score:ve+ie,labelMatch:ue||f(me)}}}if(Z){let ie=Z;q&&(ie=`${Z}${R.sep}`);const me=ie.length,ue=`${ie}${B}`,[ve,te]=A(ue,Q.normalized,Q.normalizedLowercase,X&&!Q.expectContiguousMatch);if(ve){const U=f(te),ee=[],pe=[];return U.forEach(Ce=>{Ce.start<me&&Ce.end>me?(ee.push({start:0,end:Ce.end-me}),pe.push({start:Ce.start,end:me})):Ce.start>=me?ee.push({start:Ce.start-me,end:Ce.end-me}):pe.push(Ce)}),{score:ve,labelMatch:ee,descriptionMatch:pe}}}return i}function f(B){const Z=[];if(!B)return Z;let q;for(const Q of B)q&&q.end===Q?q.end+=1:(q={start:Q,end:Q+1},Z.push(q));return Z}function S(B){const Z=B.sort((x,X)=>x.start-X.start),q=[];let Q;for(const x of Z)!Q||!p(Q,x)?(Q=x,q.push(x)):(Q.start=Math.min(Q.start,x.start),Q.end=Math.max(Q.end,x.end));return q}function p(B,Z){return!(B.end<Z.start||Z.end<B.start)}function k(B,Z,q,Q,x,X){const ie=r(B,q,Q,x,X),me=r(Z,q,Q,x,X),ue=ie.score,ve=me.score;if((ue===u||ve===u)&&ue!==ve)return ue===u?-1:1;if(ue>t||ve>t){if(ue!==ve)return ue>ve?-1:1;if(ue<o&&ve<o){const re=C(ie.labelMatch,me.labelMatch);if(re!==0)return re}const Ce=x.getItemLabel(B)||"",se=x.getItemLabel(Z)||"";if(Ce.length!==se.length)return Ce.length-se.length}if(ue!==ve)return ue>ve?-1:1;const te=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0,U=Array.isArray(me.labelMatch)&&me.labelMatch.length>0;if(te&&!U)return-1;if(U&&!te)return 1;const ee=P(B,ie,x),pe=P(Z,me,x);return ee&&pe&&ee!==pe?pe>ee?-1:1:I(B,Z,q,x)}function P(B,Z,q){let Q=-1,x=-1;if(Z.descriptionMatch&&Z.descriptionMatch.length?Q=Z.descriptionMatch[0].start:Z.labelMatch&&Z.labelMatch.length&&(Q=Z.labelMatch[0].start),Z.labelMatch&&Z.labelMatch.length){if(x=Z.labelMatch[Z.labelMatch.length-1].end,Z.descriptionMatch&&Z.descriptionMatch.length){const X=q.getItemDescription(B);X&&(x+=X.length)}}else Z.descriptionMatch&&Z.descriptionMatch.length&&(x=Z.descriptionMatch[Z.descriptionMatch.length-1].end);return x-Q}function C(B,Z){if(!B&&!Z||(!B||!B.length)&&(!Z||!Z.length))return 0;if(!Z||!Z.length)return-1;if(!B||!B.length)return 1;const q=B[0].start,x=B[B.length-1].end-q,X=Z[0].start,me=Z[Z.length-1].end-X;return x===me?0:me<x?1:-1}function I(B,Z,q,Q){const x=Q.getItemLabel(B)||"",X=Q.getItemLabel(Z)||"",ie=Q.getItemDescription(B),me=Q.getItemDescription(Z),ue=x.length+(ie?ie.length:0),ve=X.length+(me?me.length:0);if(ue!==ve)return ue-ve;const te=Q.getItemPath(B),U=Q.getItemPath(Z);return te&&U&&te.length!==U.length?te.length-U.length:x!==X?(0,d.$qr)(x,X,q.normalized):ie&&me&&ie!==me?(0,d.$qr)(ie,me,q.normalized):te&&U&&te!==U?(0,d.$qr)(te,U,q.normalized):0}function T(B){return B.startsWith('"')&&B.endsWith('"')}const j=" ";function z(B){typeof B!="string"&&(B="");const Z=B.toLowerCase(),{pathNormalized:q,normalized:Q,normalizedLowercase:x}=O(B),X=q.indexOf(R.sep)>=0,ie=T(B);let me;const ue=B.split(j);if(ue.length>1)for(const ve of ue){const te=T(ve),{pathNormalized:U,normalized:ee,normalizedLowercase:pe}=O(ve);ee&&(me||(me=[]),me.push({original:ve,originalLowercase:ve.toLowerCase(),pathNormalized:U,normalized:ee,normalizedLowercase:pe,expectContiguousMatch:te}))}return{original:B,originalLowercase:Z,pathNormalized:q,normalized:Q,normalizedLowercase:x,values:me,containsPathSeparator:X,expectContiguousMatch:ie}}function O(B){let Z;M.$i?Z=B.replace(/\//g,R.sep):Z=B.replace(/\\/g,R.sep);const q=(0,b.$hf)(Z).replace(/\s|"/g,"");return{pathNormalized:Z,normalized:q,normalizedLowercase:q.toLowerCase()}}function F(B){return Array.isArray(B)?z(B.map(Z=>Z.original).join(j)):z(B.original)}}),define(ke[101],Pe([1,0,17]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=void 0,e.$Qs=R,e.$Rs=M,e.$Ss=b,e.$Ts=E,e.$Ps=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const D=(0,d.$pc)(A),$=N[D.toLowerCase()];return $!==void 0?$:M(A)}function M(A){const D=(0,d.$pc)(A);return L[D.toLowerCase()]}function b(A){for(const D in L)if(L[D]===A)return D}const m=/^(.+)\/(.+?)(;.+)?$/;function E(A,D){const $=m.exec(A);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:D?void 0:A}}),define(ke[102],Pe([1,0,12]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=R,e.$mm=M;var N;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function R(b,...m){const E=m.reduce(($,y)=>($[y]=!0,$),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter($=>!E[$]).forEach($=>{for(let y=0;y<A.length;y++)if($.search(A[y])!==-1){delete b[$];break}})}function M(b){b&&(delete b.DEBUG,d.$j&&delete b.DYLD_LIBRARY_PATH,d.$k&&delete b.LD_PRELOAD)}}),define(ke[2],Pe([1,0,17,12]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=w,e.$xc=u;const L=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function b(c,s){if(!c.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!L.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!R.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(c,s){return!c&&!s?"file":c}function E(c,s){switch(c){case"https":case"http":case"file":s?s[0]!==D&&(s=D+s):s=D;break}return s}const A="",D="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(s){return s instanceof y?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,v,f,S,p,k=!1){typeof s=="object"?(this.scheme=s.scheme||A,this.authority=s.authority||A,this.path=s.path||A,this.query=s.query||A,this.fragment=s.fragment||A):(this.scheme=m(s,k),this.authority=v||A,this.path=E(this.scheme,f||A),this.query=S||A,this.fragment=p||A,b(this,k))}get fsPath(){return u(this,!1)}with(s){if(!s)return this;let{scheme:v,authority:f,path:S,query:p,fragment:k}=s;return v===void 0?v=this.scheme:v===null&&(v=A),f===void 0?f=this.authority:f===null&&(f=A),S===void 0?S=this.path:S===null&&(S=A),p===void 0?p=this.query:p===null&&(p=A),k===void 0?k=this.fragment:k===null&&(k=A),v===this.scheme&&f===this.authority&&S===this.path&&p===this.query&&k===this.fragment?this:new g(v,f,S,p,k)}static parse(s,v=!1){const f=$.exec(s);return f?new g(f[2]||A,r(f[4]||A),r(f[5]||A),r(f[7]||A),r(f[9]||A),v):new g(A,A,A,A,A)}static file(s){let v=A;if(N.$i&&(s=s.replace(/\\/g,D)),s[0]===D&&s[1]===D){const f=s.indexOf(D,2);f===-1?(v=s.substring(2),s=D):(v=s.substring(2,f),s=s.substring(f)||D)}return new g("file",v,s,A,A)}static from(s,v){return new g(s.scheme,s.authority,s.path,s.query,s.fragment,v)}static joinPath(s,...v){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return N.$i&&s.scheme==="file"?f=y.file(d.$gc.join(u(s,!0),...v)).path:f=d.$hc.join(s.path,...v),s.with({path:f})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof y)return s;{const v=new g(s);return v._formatted=s.external??null,v._fsPath=s._sep===h?s.fsPath??null:null,v}}else return s}}e.URI=y;function w(c){return!c||typeof c!="object"?!1:typeof c.scheme=="string"&&(typeof c.authority=="string"||typeof c.authority>"u")&&(typeof c.path=="string"||typeof c.path>"u")&&(typeof c.query=="string"||typeof c.query>"u")&&(typeof c.fragment=="string"||typeof c.fragment>"u")}const h=N.$i?1:void 0;class g extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=h),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const a={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(c,s,v){let f,S=-1;for(let p=0;p<c.length;p++){const k=c.charCodeAt(p);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||s&&k===47||v&&k===91||v&&k===93||v&&k===58)S!==-1&&(f+=encodeURIComponent(c.substring(S,p)),S=-1),f!==void 0&&(f+=c.charAt(p));else{f===void 0&&(f=c.substr(0,p));const P=a[k];P!==void 0?(S!==-1&&(f+=encodeURIComponent(c.substring(S,p)),S=-1),f+=P):S===-1&&(S=p)}}return S!==-1&&(f+=encodeURIComponent(c.substring(S))),f!==void 0?f:c}function i(c){let s;for(let v=0;v<c.length;v++){const f=c.charCodeAt(v);f===35||f===63?(s===void 0&&(s=c.substr(0,v)),s+=a[f]):s!==void 0&&(s+=c[v])}return s!==void 0?s:c}function u(c,s){let v;return c.authority&&c.path.length>1&&c.scheme==="file"?v=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?s?v=c.path.substr(1):v=c.path[1].toLowerCase()+c.path.substr(2):v=c.path,N.$i&&(v=v.replace(/\//g,"\\")),v}function o(c,s){const v=s?i:n;let f="",{scheme:S,authority:p,path:k,query:P,fragment:C}=c;if(S&&(f+=S,f+=":"),(p||S==="file")&&(f+=D,f+=D),p){let I=p.indexOf("@");if(I!==-1){const T=p.substr(0,I);p=p.substr(I+1),I=T.lastIndexOf(":"),I===-1?f+=v(T,!1,!1):(f+=v(T.substr(0,I),!1,!1),f+=":",f+=v(T.substr(I+1),!1,!0)),f+="@"}p=p.toLowerCase(),I=p.lastIndexOf(":"),I===-1?f+=v(p,!1,!0):(f+=v(p.substr(0,I),!1,!0),f+=p.substr(I))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const I=k.charCodeAt(1);I>=65&&I<=90&&(k=`/${String.fromCharCode(I+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const I=k.charCodeAt(0);I>=65&&I<=90&&(k=`${String.fromCharCode(I+32)}:${k.substr(2)}`)}f+=v(k,!0,!1)}return P&&(f+="?",f+=v(P,!1,!1)),C&&(f+="#",f+=s?C:n(C,!1,!1)),f}function t(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+t(c.substr(3)):c}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(c){return c.match(l)?c.replace(l,s=>t(s)):c}}),define(ke[197],Pe([1,0,2]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=N,e.$Vq=L,e.$Wq=R,e.log=b;function N(E){const A=E;return A&&typeof A.type=="string"&&typeof A.severity=="string"}function L(E){const A=[];let D;try{const $=JSON.parse(E.arguments),y=$[$.length-1];y&&y.__$stack&&($.pop(),D=y.__$stack),A.push(...$)}catch{A.push("Unable to log remote console arguments",E.arguments)}return{args:A,stack:D}}function R(E){if(typeof E!="string")return R(L(E).stack);const A=E;if(A){const D=M(A),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(D||"");if($&&$.length===4)return{uri:d.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}function M(E){if(!E)return E;const A=E.indexOf(`
`);return A===-1?E:E.substring(0,A)}function b(E,A){const{args:D,stack:$}=L(E),y=typeof D[0]=="string"&&D.length===1;let w=M($);w&&(w=`(${w.trim()})`);let h=[];if(typeof D[0]=="string"?w&&y?h=[`%c[${A}] %c${D[0]} %c${w}`,m("blue"),m(""),m("grey")]:h=[`%c[${A}] %c${D[0]}`,m("blue"),m(""),...D.slice(1)]:h=[`%c[${A}]%`,m("blue"),...D],w&&!y&&h.push(w),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,h)}function m(E){return`color: ${E}`}}),define(ke[58],Pe([1,0,21,2]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=L,e.$4h=R,e.$5h=b;function L(m){return JSON.stringify(m,M)}function R(m){let E=JSON.parse(m);return E=b(E),E}function M(m,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function b(m,E=0){if(!m||E>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return N.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof d.$Fe||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let A=0;A<m.length;++A)m[A]=b(m[A],E+1);else for(const A in m)Object.hasOwnProperty.call(m,A)&&(m[A]=b(m[A],E+1))}return m}}),define(ke[15],Pe([1,0,13,12,14,2,17]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Ig=e.$Hg=e.$Gg=e.Schemas=void 0,e.$Eg=m,e.$Fg=E,e.$Jg=D;var b;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatCodeBlock="vscode-chat-code-block",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm",w.commentsInput="comment",w.codeSetting="code-setting"})(b||(e.Schemas=b={}));function m(w,h){return R.URI.isUri(w)?(0,L.$xf)(w.scheme,h):(0,L.$yf)(w,h+":")}function E(w,...h){return h.some(g=>m(w,g))}e.$Gg="vscode-tkn",e.$Hg="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h,g){this.f=D(h,g)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,b.vscodeRemoteResource)}set(h,g,a){this.a[h]=g,this.b[h]=a}setConnectionToken(h,g){this.c[h]=g}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(o){return d.$1(o),h}const g=h.authority;let a=this.a[g];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const n=this.b[g],i=this.c[g];let u=`path=${encodeURIComponent(h.path)}`;return typeof i=="string"&&(u+=`&${e.$Hg}=${encodeURIComponent(i)}`),R.URI.from({scheme:N.$o?this.d:b.vscodeRemoteResource,authority:`${a}:${n}`,path:this.g,query:u})}}e.$Ig=new A;function D(w,h){return M.$hc.join(h??"/",`${w.quality??"oss"}-${w.commit??"dev"}`)}e.$Kg="vs/../../extensions",e.$Lg="vs/../../node_modules",e.$Mg="vs/../../node_modules.asar",e.$Ng="vs/../../node_modules.asar.unpacked",e.$Og="vscode-app";class ${static{this.a=e.$Og}asBrowserUri(h){const g=this.b(h,le);return this.uriToBrowserUri(g)}uriToBrowserUri(h){return h.scheme===b.vscodeRemote?e.$Ig.rewrite(h):h.scheme===b.file&&(N.$m||N.$q===`${b.vscodeFileResource}://${$.a}`)?h.with({scheme:b.vscodeFileResource,authority:h.authority||$.a,query:null,fragment:null}):h}asFileUri(h){const g=this.b(h,le);return this.uriToFileUri(g)}uriToFileUri(h){return h.scheme===b.vscodeFileResource?h.with({scheme:b.file,authority:h.authority!==$.a?h.authority:null,query:null,fragment:null}):h}b(h,g){return R.URI.isUri(h)?h:R.URI.parse(g.toUrl(h))}}e.$Pg=new $;var y;(function(w){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(h.get("3"));const g="vscode-coi";function a(i){let u;typeof i=="string"?u=new URL(i).searchParams:i instanceof URL?u=i.searchParams:R.URI.isUri(i)&&(u=new URL(i.toString(!0)).searchParams);const o=u?.get(g);if(o)return h.get(o)}w.getHeadersFromQuery=a;function n(i,u,o){if(!globalThis.crossOriginIsolated)return;const t=u&&o?"3":o?"2":"1";i instanceof URLSearchParams?i.set(g,t):i[g]=t}w.addSearchParam=n})(y||(e.COI=y={}))}),define(ke[198],Pe([1,0,163,15,12,2]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZD=A;class M{constructor($,y,w){this.id=$,this.dependencies=y,this.callback=w}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,y,w)=>{typeof $!="string"&&(w=y,y=$,$=null),(typeof y!="object"||!Array.isArray(y))&&(w=y,y=null),this.c.push(new M($,y,w))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const y=await(this.a?this.i($):this.b?this.h($):this.j($));if(!y)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h($){return new Promise((y,w)=>{const h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript");const g=()=>{h.removeEventListener("load",a),h.removeEventListener("error",n)},a=i=>{g(),y(this.c.pop())},n=i=>{g(),w(i)};h.addEventListener("load",a),h.addEventListener("error",n),this.f&&($=this.f.createScriptURL($)),h.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(h)})}i($){return new Promise((y,w)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),y(this.c.pop())}catch(h){w(h)}})}async j($){try{const y=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,h=globalThis._VSCODE_NODE_MODULES.module,g=R.URI.parse($).fsPath,a=y.readFileSync(g).toString(),n=h.wrap(a.replace(/^#!.*/,""));return new w.Script(n).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const m=new Map;let E={};typeof globalThis.require=="object"&&(E=globalThis.require.paths??{});async function A(D,$,y){if(d.$T){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),E[D]&&(D=E[D]);const w=`${D}/${$}`;if(m.has(w))return m.get(w);let h;if(/^\w[\w\d+.-]*:\/\//.test(w))h=w;else{const i=`${y&&!L.$o?N.$Mg:N.$Lg}/${w}`;h=N.$Pg.asBrowserUri(i).toString(!0)}const g=b.INSTANCE.load(h);return m.set(w,g),g}else return await new Promise((w,h)=>{le([D],w,h)})}}),define(ke[23],Pe([1,0,31,15,17,12,14,2]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=void 0,e.$Wg=m,e.$fh=A,e.$gh=$;function m(y){return(0,b.$xc)(y,!0)}class E{constructor(w){this.a=w}compare(w,h,g=!1){return w===h?0:(0,M.$qf)(this.getComparisonKey(w,g),this.getComparisonKey(h,g))}isEqual(w,h,g=!1){return w===h?!0:!w||!h?!1:this.getComparisonKey(w,g)===this.getComparisonKey(h,g)}getComparisonKey(w,h=!1){return w.with({path:this.a(w)?w.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(w){return this.a(w)}isEqualOrParent(w,h,g=!1){if(w.scheme===h.scheme){if(w.scheme===N.Schemas.file)return d.$ug(m(w),m(h),this.a(w))&&w.query===h.query&&(g||w.fragment===h.fragment);if((0,e.$bh)(w.authority,h.authority))return d.$ug(w.path,h.path,this.a(w),"/")&&w.query===h.query&&(g||w.fragment===h.fragment)}return!1}joinPath(w,...h){return b.URI.joinPath(w,...h)}basenameOrAuthority(w){return(0,e.$6g)(w)||w.authority}basename(w){return L.$hc.basename(w.path)}extname(w){return L.$hc.extname(w.path)}dirname(w){if(w.path.length===0)return w;let h;return w.scheme===N.Schemas.file?h=b.URI.file(L.$nc(m(w))).path:(h=L.$hc.dirname(w.path),w.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),h="/")),w.with({path:h})}normalizePath(w){if(!w.path.length)return w;let h;return w.scheme===N.Schemas.file?h=b.URI.file(L.$ic(m(w))).path:h=L.$hc.normalize(w.path),w.with({path:h})}relativePath(w,h){if(w.scheme!==h.scheme||!(0,e.$bh)(w.authority,h.authority))return;if(w.scheme===N.Schemas.file){const n=L.$mc(m(w),m(h));return R.$i?d.$og(n):n}let g=w.path||"/";const a=h.path||"/";if(this.a(w)){let n=0;for(const i=Math.min(g.length,a.length);n<i&&!(g.charCodeAt(n)!==a.charCodeAt(n)&&g.charAt(n).toLowerCase()!==a.charAt(n).toLowerCase());n++);g=a.substr(0,n)+g.substr(n)}return L.$hc.relative(g,a)}resolvePath(w,h){if(w.scheme===N.Schemas.file){const g=b.URI.file(L.$lc(m(w),h));return w.with({authority:g.authority,path:g.path})}return h=d.$pg(h),w.with({path:L.$hc.resolve(w.path,h)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,h){return w===h||w!==void 0&&h!==void 0&&(0,M.$xf)(w,h)}hasTrailingPathSeparator(w,h=L.sep){if(w.scheme===N.Schemas.file){const g=m(w);return g.length>d.$qg(g).length&&g[g.length-1]===h}else{const g=w.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,h=L.sep){return(0,e.$ch)(w,h)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,h=L.sep){let g=!1;if(w.scheme===N.Schemas.file){const a=m(w);g=a!==void 0&&a.length===d.$qg(a).length&&a[a.length-1]===h}else{h="/";const a=w.path;g=a.length===1&&a.charCodeAt(a.length-1)===47}return!g&&!(0,e.$ch)(w,h)?w.with({path:w.path+"/"}):w}}e.$Xg=E,e.$Yg=new E(()=>!1),e.$Zg=new E(y=>y.scheme===N.Schemas.file?!R.$k:!0),e.$1g=new E(y=>!0),e.$2g=e.$Yg.isEqual.bind(e.$Yg),e.$3g=e.$Yg.isEqualOrParent.bind(e.$Yg),e.$4g=e.$Yg.getComparisonKey.bind(e.$Yg),e.$5g=e.$Yg.basenameOrAuthority.bind(e.$Yg),e.$6g=e.$Yg.basename.bind(e.$Yg),e.$7g=e.$Yg.extname.bind(e.$Yg),e.$8g=e.$Yg.dirname.bind(e.$Yg),e.$9g=e.$Yg.joinPath.bind(e.$Yg),e.$0g=e.$Yg.normalizePath.bind(e.$Yg),e.$$g=e.$Yg.relativePath.bind(e.$Yg),e.$_g=e.$Yg.resolvePath.bind(e.$Yg),e.$ah=e.$Yg.isAbsolutePath.bind(e.$Yg),e.$bh=e.$Yg.isEqualAuthority.bind(e.$Yg),e.$ch=e.$Yg.hasTrailingPathSeparator.bind(e.$Yg),e.$dh=e.$Yg.removeTrailingPathSeparator.bind(e.$Yg),e.$eh=e.$Yg.addTrailingPathSeparator.bind(e.$Yg);function A(y,w){const h=[];for(let g=0;g<y.length;g++){const a=w(y[g]);y.some((n,i)=>i===g?!1:(0,e.$3g)(a,w(n)))||h.push(y[g])}return h}var D;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function w(h){const g=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(i=>{const[u,o]=i.split(":");u&&o&&g.set(u,o)});const n=h.path.substring(0,h.path.indexOf(";"));return n&&g.set(y.META_DATA_MIME,n),g}y.parseMetaData=w})(D||(e.DataUri=D={}));function $(y,w,h){if(w){let g=y.path;return g&&g[0]!==L.$hc.sep&&(g=L.$hc.sep+g),y.with({scheme:h,authority:w,path:g})}return y.with({scheme:h})}}),define(ke[7],Pe([1,0,22,13,4,3,23,12,174,46]),function(le,e,d,N,L,R,M,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.Promises=e.$Sh=e.$Rh=e.$Qh=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=void 0,e.$hh=A,e.$ih=D,e.$jh=$,e.$kh=y,e.$lh=w,e.$mh=h,e.$nh=g,e.$oh=a,e.$wh=v,e.$xh=f,e.$yh=S,e.$zh=p,e.$Ah=k,e.$Ph=x,e.$Xh=se;function A(oe){return!!oe&&typeof oe.then=="function"}function D(oe){const K=new d.$pe,ne=oe(K.token),$e=new Promise((be,Ae)=>{const fe=K.token.onCancellationRequested(()=>{fe.dispose(),Ae(new N.$5)});Promise.resolve(ne).then(Se=>{fe.dispose(),K.dispose(),be(Se)},Se=>{fe.dispose(),K.dispose(),Ae(Se)})});return new class{cancel(){K.cancel(),K.dispose()}then(be,Ae){return $e.then(be,Ae)}catch(be){return this.then(void 0,be)}finally(be){return $e.finally(be)}}}function $(oe,K,ne){return new Promise(($e,be)=>{const Ae=K.onCancellationRequested(()=>{Ae.dispose(),$e(ne)});oe.then($e,be).finally(()=>Ae.dispose())})}function y(oe,K){return new Promise((ne,$e)=>{const be=K.onCancellationRequested(()=>{be.dispose(),$e(new N.$5)});oe.then(ne,$e).finally(()=>be.dispose())})}async function w(oe){let K=-1;const ne=oe.map(($e,be)=>$e.then(Ae=>(K=be,Ae)));try{return await Promise.race(ne)}finally{oe.forEach(($e,be)=>{be!==K&&$e.cancel()})}}function h(oe,K,ne){let $e;const be=setTimeout(()=>{$e?.(void 0),ne?.()},K);return Promise.race([oe.finally(()=>clearTimeout(be)),new Promise(Ae=>$e=Ae)])}function g(oe){return new Promise((K,ne)=>{const $e=oe();A($e)?$e.then(K,ne):K($e)})}function a(){let oe,K;return{promise:new Promise(($e,be)=>{oe=$e,K=be}),resolve:oe,reject:K}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const ne=()=>{if(this.b=null,this.f)return;const $e=this.queue(this.d);return this.d=null,$e};this.b=new Promise($e=>{this.a.then(ne,ne).then($e)})}return new Promise((ne,$e)=>{this.b.then(ne,$e)})}return this.a=K(),new Promise((ne,$e)=>{this.a.then(be=>{this.a=null,ne(be)},be=>{this.a=null,$e(be)})})}dispose(){this.f=!0}}e.$ph=n;class i{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$qh=i;class u{constructor(){this.a=new Map}queue(K,ne){const be=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.a.get(K)===be&&this.a.delete(K)});return this.a.set(K,be),be}}e.$rh=u;const o=(oe,K)=>{let ne=!0;const $e=setTimeout(()=>{ne=!1,K()},oe);return{isTriggered:()=>ne,dispose:()=>{clearTimeout($e),ne=!1}}},t=oe=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,oe())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class l{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,ne=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((be,Ae)=>{this.d=be,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const $e=()=>{this.a=null,this.d?.(null)};return this.a=ne===m.$be?t($e):o(ne,$e),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$sh=l;class r{constructor(K){this.a=new l(K),this.b=new n}trigger(K,ne){return this.a.trigger(()=>this.b.queue(K),ne)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$th=r;class c{constructor(){this.a=!1,this.b=new Promise((K,ne)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$uh=c;class s extends c{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$vh=s;function v(oe,K){return K?new Promise((ne,$e)=>{const be=setTimeout(()=>{Ae.dispose(),ne()},oe),Ae=K.onCancellationRequested(()=>{clearTimeout(be),Ae.dispose(),$e(new N.$5)})}):D(ne=>v(oe,ne))}function f(oe,K=0,ne){const $e=setTimeout(()=>{oe(),ne&&be.dispose()},K),be=(0,R.$Tc)(()=>{clearTimeout($e),ne?.deleteAndLeak(be)});return ne?.add(be),be}function S(oe){const K=[];let ne=0;const $e=oe.length;function be(){return ne<$e?oe[ne++]():null}function Ae(fe){fe!=null&&K.push(fe);const Se=be();return Se?Se.then(Ae):Promise.resolve(K)}return Promise.resolve(null).then(Ae)}function p(oe,K=$e=>!!$e,ne=null){let $e=0;const be=oe.length,Ae=()=>{if($e>=be)return Promise.resolve(ne);const fe=oe[$e++];return Promise.resolve(fe()).then(Ie=>K(Ie)?Promise.resolve(Ie):Ae())};return Ae()}function k(oe,K=$e=>!!$e,ne=null){if(oe.length===0)return Promise.resolve(ne);let $e=oe.length;const be=()=>{$e=-1;for(const Ae of oe)Ae.cancel?.()};return new Promise((Ae,fe)=>{for(const Se of oe)Se.then(Ie=>{--$e>=0&&K(Ie)?(be(),Ae(Ie)):$e===0&&Ae(ne)}).catch(Ie=>{--$e>=0&&(be(),fe(Ie))})})}class P{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new L.$ee}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ne,$e)=>{this.g.push({factory:K,c:ne,e:$e}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const ne=K.factory();ne.then(K.c,K.e),ne.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Bh=P;class C extends P{constructor(){super(1)}}e.$Ch=C;class I{constructor(){this.a=new X,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$Dh=I;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new ue;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,ne=M.$Yg){const $e=ne.getComparisonKey(K);return this.a.get($e)?.size??0}queueFor(K,ne,$e=M.$Yg){const be=$e.getComparisonKey(K);let Ae=this.a.get(be);if(!Ae){Ae=new C;const fe=this.f++,Se=L.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$5c),this.d.set(fe,Se),this.a.set(be,Ae)}return Ae.queue(ne)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Eh=T;class j{constructor(K,ne){this.a=-1,typeof K=="function"&&typeof ne=="number"&&this.setIfNotSet(K,ne)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,ne){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},ne)}setIfNotSet(K,ne){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},ne))}}e.$Fh=j;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,ne,$e=globalThis){this.cancel();const be=$e.setInterval(()=>{K()},ne);this.d=(0,R.$Tc)(()=>{$e.clearInterval(be),this.d=void 0})}dispose(){this.cancel()}}e.$Gh=z;class O{constructor(K,ne){this.b=-1,this.a=K,this.d=ne,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Hh=O;class F{constructor(K,ne){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.a=K,this.b=ne,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ih=F;class B extends O{constructor(K,ne){super(K,ne),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$Jh=B;class Z extends R.$Vc{constructor(K,ne){super(),this.g=K,this.h=ne,this.a=[],this.b=this.B(new R.$Wc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ne of K)this.a.push(ne);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new O(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Kh=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Mh=(oe,K)=>{(0,b.$B)(()=>{if(ne)return;const $e=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$e-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.$Mh=(oe,K,ne)=>{const $e=oe.requestIdleCallback(K,typeof ne=="number"?{timeout:ne}:void 0);let be=!1;return{dispose(){be||(be=!0,oe.cancelIdleCallback($e))}}},e.$Lh=oe=>(0,e.$Mh)(globalThis,oe)}();class q{constructor(K,ne){this.g=!1,this.d=()=>{try{this.j=ne()}catch($e){this.l=$e}finally{this.g=!0}},this.f=(0,e.$Mh)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Nh=q;class Q extends q{constructor(K){super(globalThis,K)}}e.$Oh=Q;async function x(oe,K,ne){let $e;for(let be=0;be<ne;be++)try{return await oe()}catch(Ae){$e=Ae,await v(K)}throw $e}class X{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,ne,$e){return this.a={taskId:K,cancel:()=>$e?.(),promise:ne},ne.then(()=>this.d(K),()=>this.d(K)),ne}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:ne,resolve:$e,reject:be}=a();this.b={run:K,promise:ne,promiseResolve:$e,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Qh=X;class ie{constructor(K,ne=()=>Date.now()){this.d=K,this.f=ne,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Rh=ie;var me;(function(oe){oe[oe.Resolved=0]="Resolved",oe[oe.Rejected=1]="Rejected"})(me||(me={}));class ue{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,ne)=>{this.a=K,this.b=ne})}complete(K){return new Promise(ne=>{this.a(K),this.d={outcome:0,value:K},ne()})}error(K){return new Promise(ne=>{this.b(K),this.d={outcome:1,value:K},ne()})}cancel(){return this.error(new N.$5)}}e.$Sh=ue;var ve;(function(oe){async function K($e){let be;const Ae=await Promise.all($e.map(fe=>fe.then(Se=>Se,Se=>{be||(be=Se)})));if(typeof be<"u")throw be;return Ae}oe.settled=K;function ne($e){return new Promise(async(be,Ae)=>{try{await $e(be,Ae)}catch(fe){Ae(fe)}})}oe.withAsyncBody=ne})(ve||(e.Promises=ve={}));class te{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(ne=>(this.a=ne,this.d=!0,ne),ne=>{throw this.b=ne,this.d=!0,ne})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Th=te;class U{constructor(K){this.b=K,this.a=new E.$V(()=>new te(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Uh=U;var ee;(function(oe){oe[oe.Initial=0]="Initial",oe[oe.DoneOK=1]="DoneOK",oe[oe.DoneError=2]="DoneError"})(ee||(ee={}));class pe{static fromArray(K){return new pe(ne=>{ne.emitMany(K)})}static fromPromise(K){return new pe(async ne=>{ne.emitMany(await K)})}static fromPromises(K){return new pe(async ne=>{await Promise.all(K.map(async $e=>ne.emitOne(await $e)))})}static merge(K){return new pe(async ne=>{await Promise.all(K.map(async $e=>{for await(const be of $e)ne.emitOne(be)}))})}static{this.EMPTY=pe.fromArray([])}constructor(K,ne){this.a=0,this.b=[],this.d=null,this.f=ne,this.g=new L.$ee,queueMicrotask(async()=>{const $e={emitOne:be=>this.h(be),emitMany:be=>this.j(be),reject:be=>this.l(be)};try{await Promise.resolve(K($e)),this.k()}catch(be){this.l(be)}finally{$e.emitOne=void 0,$e.emitMany=void 0,$e.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(K,ne){return new pe(async $e=>{for await(const be of K)$e.emitOne(ne(be))})}map(K){return pe.map(this,K)}static filter(K,ne){return new pe(async $e=>{for await(const be of K)ne(be)&&$e.emitOne(be)})}filter(K){return pe.filter(this,K)}static coalesce(K){return pe.filter(K,ne=>!!ne)}coalesce(){return pe.coalesce(this)}static async toPromise(K){const ne=[];for await(const $e of K)ne.push($e);return ne}toPromise(){return pe.toPromise(this)}h(K){this.a===0&&(this.b.push(K),this.g.fire())}j(K){this.a===0&&(this.b=this.b.concat(K),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(K){this.a===0&&(this.a=2,this.d=K,this.g.fire())}}e.$Vh=pe;class Ce extends pe{constructor(K,ne){super(ne),this.m=K}cancel(){this.m.cancel()}}e.$Wh=Ce;function se(oe){const K=new d.$pe,ne=oe(K.token);return new Ce(K,async $e=>{const be=K.token.onCancellationRequested(()=>{be.dispose(),K.dispose(),$e.reject(new N.$5)});try{for await(const Ae of ne){if(K.token.isCancellationRequested)return;$e.emitOne(Ae)}be.dispose(),K.dispose()}catch(Ae){be.dispose(),K.dispose(),$e.reject(Ae)}})}class re{constructor(K){this.a=new ue,this.b=new pe(be=>{if(ne){be.reject(ne);return}return $e&&be.emitMany($e),this.d=Ae=>be.reject(Ae),this.f=Ae=>be.emitOne(Ae),this.a.p},K);let ne,$e;this.f=be=>{$e||($e=[]),$e.push(be)},this.d=be=>{ne||(ne=be)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$Yh=re}),define(ke[35],Pe([1,0,19,7,31,27,17,12,14]),function(le,e,d,N,L,R,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$kk=E,e.$nk=w,e.$ok=C,e.$pk=I,e.$qk=T,e.$rk=j,e.$sk=z,e.$tk=Z;function E(){return Object.create(null)}e.$lk="**",e.$mk="/";const A="[/\\\\]",D="[^/\\\\]",$=/\//g;function y(q,Q){switch(q){case 0:return"";case 1:return`${D}*?`;default:return`(?:${A}|${D}+${A}${Q?`|${A}${D}+`:""})*?`}}function w(q,Q){if(!q)return[];const x=[];let X=!1,ie=!1,me="";for(const ue of q){switch(ue){case Q:if(!X&&!ie){x.push(me),me="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}me+=ue}return me&&x.push(me),x}function h(q){if(!q)return"";let Q="";const x=w(q,e.$mk);if(x.every(X=>X===e.$lk))Q=".*";else{let X=!1;x.forEach((ie,me)=>{if(ie===e.$lk){if(X)return;Q+=y(2,me===x.length-1)}else{let ue=!1,ve="",te=!1,U="";for(const ee of ie){if(ee!=="}"&&ue){ve+=ee;continue}if(te&&(ee!=="]"||!U)){let pe;ee==="-"?pe=ee:(ee==="^"||ee==="!")&&!U?pe="^":ee===e.$mk?pe="":pe=(0,m.$_e)(ee),U+=pe;continue}switch(ee){case"{":ue=!0;continue;case"[":te=!0;continue;case"}":{const Ce=`(?:${w(ve,",").map(se=>h(se)).join("|")})`;Q+=Ce,ue=!1,ve="";break}case"]":{Q+="["+U+"]",te=!1,U="";break}case"?":Q+=D;continue;case"*":Q+=y(1);continue;default:Q+=(0,m.$_e)(ee)}}me<x.length-1&&(x[me+1]!==e.$lk||me+2<x.length)&&(Q+=A)}X=ie===e.$lk})}return Q}const g=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Ec(1e4),l=function(){return!1},r=function(){return null};function c(q,Q){if(!q)return r;let x;typeof q!="string"?x=q.pattern:x=q,x=x.trim();const X=`${x}_${!!Q.trimForExclusions}`;let ie=t.get(X);if(ie)return s(ie,q);let me;return g.test(x)?ie=f(x.substr(4),x):(me=a.exec(v(x,Q)))?ie=S(me[1],x):(Q.trimForExclusions?i:n).test(x)?ie=p(x,Q):(me=u.exec(v(x,Q)))?ie=k(me[1].substr(1),x,!0):(me=o.exec(v(x,Q)))?ie=k(me[1],x,!1):ie=P(x),t.set(X,ie),s(ie,q)}function s(q,Q){if(typeof Q=="string")return q;const x=function(X,ie){return(0,L.$ug)(X,Q.base,!b.$k)?q((0,m.$ef)(X.substr(Q.base.length),M.sep),ie):null};return x.allBasenames=q.allBasenames,x.allPaths=q.allPaths,x.basenames=q.basenames,x.patterns=q.patterns,x}function v(q,Q){return Q.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function f(q,Q){return function(x,X){return typeof x=="string"&&x.endsWith(q)?Q:null}}function S(q,Q){const x=`/${q}`,X=`\\${q}`,ie=function(ue,ve){return typeof ue!="string"?null:ve?ve===q?Q:null:ue===q||ue.endsWith(x)||ue.endsWith(X)?Q:null},me=[q];return ie.basenames=me,ie.patterns=[Q],ie.allBasenames=me,ie}function p(q,Q){const x=B(q.slice(1,-1).split(",").map(ve=>c(ve,Q)).filter(ve=>ve!==r),q),X=x.length;if(!X)return r;if(X===1)return x[0];const ie=function(ve,te){for(let U=0,ee=x.length;U<ee;U++)if(x[U](ve,te))return q;return null},me=x.find(ve=>!!ve.allBasenames);me&&(ie.allBasenames=me.allBasenames);const ue=x.reduce((ve,te)=>te.allPaths?ve.concat(te.allPaths):ve,[]);return ue.length&&(ie.allPaths=ue),ie}function k(q,Q,x){const X=M.sep===M.$hc.sep,ie=X?q:q.replace($,M.sep),me=M.sep+ie,ue=M.$hc.sep+q;let ve;return x?ve=function(te,U){return typeof te=="string"&&(te===ie||te.endsWith(me)||!X&&(te===q||te.endsWith(ue)))?Q:null}:ve=function(te,U){return typeof te=="string"&&(te===ie||!X&&te===q)?Q:null},ve.allPaths=[(x?"*/":"./")+q],ve}function P(q){try{const Q=new RegExp(`^${h(q)}$`);return function(x){return Q.lastIndex=0,typeof x=="string"&&Q.test(x)?q:null}}catch{return r}}function C(q,Q,x){return!q||typeof Q!="string"?!1:I(q)(Q,void 0,x)}function I(q,Q={}){if(!q)return l;if(typeof q=="string"||T(q)){const x=c(q,Q);if(x===r)return l;const X=function(ie,me){return!!x(ie,me)};return x.allBasenames&&(X.allBasenames=x.allBasenames),x.allPaths&&(X.allPaths=x.allPaths),X}return O(q,Q)}function T(q){const Q=q;return Q?typeof Q.base=="string"&&typeof Q.pattern=="string":!1}function j(q){return q.allBasenames||[]}function z(q){return q.allPaths||[]}function O(q,Q){const x=B(Object.getOwnPropertyNames(q).map(ve=>F(ve,q[ve],Q)).filter(ve=>ve!==r)),X=x.length;if(!X)return r;if(!x.some(ve=>!!ve.requiresSiblings)){if(X===1)return x[0];const ve=function(ee,pe){let Ce;for(let se=0,re=x.length;se<re;se++){const oe=x[se](ee,pe);if(typeof oe=="string")return oe;(0,N.$hh)(oe)&&(Ce||(Ce=[]),Ce.push(oe))}return Ce?(async()=>{for(const se of Ce){const re=await se;if(typeof re=="string")return re}return null})():null},te=x.find(ee=>!!ee.allBasenames);te&&(ve.allBasenames=te.allBasenames);const U=x.reduce((ee,pe)=>pe.allPaths?ee.concat(pe.allPaths):ee,[]);return U.length&&(ve.allPaths=U),ve}const ie=function(ve,te,U){let ee,pe;for(let Ce=0,se=x.length;Ce<se;Ce++){const re=x[Ce];re.requiresSiblings&&U&&(te||(te=(0,M.$oc)(ve)),ee||(ee=te.substr(0,te.length-(0,M.$pc)(ve).length)));const oe=re(ve,te,ee,U);if(typeof oe=="string")return oe;(0,N.$hh)(oe)&&(pe||(pe=[]),pe.push(oe))}return pe?(async()=>{for(const Ce of pe){const se=await Ce;if(typeof se=="string")return se}return null})():null},me=x.find(ve=>!!ve.allBasenames);me&&(ie.allBasenames=me.allBasenames);const ue=x.reduce((ve,te)=>te.allPaths?ve.concat(te.allPaths):ve,[]);return ue.length&&(ie.allPaths=ue),ie}function F(q,Q,x){if(Q===!1)return r;const X=c(q,x);if(X===r)return r;if(typeof Q=="boolean")return X;if(Q){const ie=Q.when;if(typeof ie=="string"){const me=(ue,ve,te,U)=>{if(!U||!X(ue,ve))return null;const ee=ie.replace("$(basename)",()=>te),pe=U(ee);return(0,N.$hh)(pe)?pe.then(Ce=>Ce?q:null):pe?q:null};return me.requiresSiblings=!0,me}}return X}function B(q,Q){const x=q.filter(ve=>!!ve.basenames);if(x.length<2)return q;const X=x.reduce((ve,te)=>{const U=te.basenames;return U?ve.concat(U):ve},[]);let ie;if(Q){ie=[];for(let ve=0,te=X.length;ve<te;ve++)ie.push(Q)}else ie=x.reduce((ve,te)=>{const U=te.patterns;return U?ve.concat(U):ve},[]);const me=function(ve,te){if(typeof ve!="string")return null;if(!te){let ee;for(ee=ve.length;ee>0;ee--){const pe=ve.charCodeAt(ee-1);if(pe===47||pe===92)break}te=ve.substr(ee)}const U=X.indexOf(te);return U!==-1?ie[U]:null};me.basenames=X,me.patterns=ie,me.allBasenames=X;const ue=q.filter(ve=>!ve.basenames);return ue.push(me),ue}function Z(q,Q){return(0,d.$ub)(q,Q,(x,X)=>typeof x=="string"&&typeof X=="string"?x===X:typeof x!="string"&&typeof X!="string"?x.base===X.base&&x.pattern===X.pattern:!1)}}),define(ke[81],Pe([1,0,13,176,23,14,2]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.MarkdownStringTextNewlineStyle=void 0,e.$Tk=E,e.$Uk=A,e.$Vk=D,e.$Wk=$,e.$Xk=y,e.$Yk=w,e.$Zk=h,e.$1k=g;var b;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class m{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,d.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=$(this.supportThemeIcons?(0,N.$Mk)(n):n).replace(/([ \t]+)/g,(u,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${y(i,n)}
`,this}appendLink(n,i,u){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),u&&(this.value+=` "${this.c(this.c(u,'"'),")")}"`),this.value+=")",this}c(n,i){const u=new RegExp((0,R.$_e)(i),"g");return n.replace(u,(o,t)=>n.charAt(t-1)!=="\\"?`\\${o}`:o)}}e.$Sk=m;function E(a){return A(a)?!a.value:Array.isArray(a)?a.every(E):!0}function A(a){return a instanceof m?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function D(a,n){return a===n?!0:!a||!n?!1:a.value===n.value&&a.isTrusted===n.isTrusted&&a.supportThemeIcons===n.supportThemeIcons&&a.supportHtml===n.supportHtml&&(a.baseUri===n.baseUri||!!a.baseUri&&!!n.baseUri&&(0,L.$2g)(M.URI.from(a.baseUri),M.URI.from(n.baseUri)))}function $(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function y(a,n){const i=a.match(/^`+/gm)?.reduce((o,t)=>o.length>t.length?o:t).length??0,u=i>=3?i+1:3;return[`${"`".repeat(u)}${n}`,a,`${"`".repeat(u)}`].join(`
`)}function w(a){return a.replace(/"/g,"&quot;")}function h(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function g(a){const n=[],i=a.split("|").map(o=>o.trim());a=i[0];const u=i[1];if(u){const o=/height=(\d+)/.exec(u),t=/width=(\d+)/.exec(u),l=o?o[1]:"",r=t?t[1]:"",c=isFinite(parseInt(r)),s=isFinite(parseInt(l));c&&n.push(`width="${r}"`),s&&n.push(`height="${l}"`)}return{href:a,dimensions:n}}}),define(ke[103],Pe([1,0,19,31,17,12,23,14]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ww=m,e.$xw=A,e.$yw=$,e.$zw=y,e.$Aw=a,e.$Bw=i,e.$Cw=u,e.$Dw=o,e.$Ew=t,e.$Fw=l;function m(c,s){const{os:v,tildify:f,relative:S}=s;if(S){const P=E(c,S,v);if(typeof P=="string")return P}let p=c.fsPath;if(v===1&&!R.$i?p=p.replace(/\//g,"\\"):v!==1&&R.$i&&(p=p.replace(/\\/g,"/")),v!==1&&f?.userHome){const P=f.userHome.fsPath;let C;c.scheme!==f.userHome.scheme&&c.path[0]===L.$hc.sep&&c.path[1]!==L.$hc.sep?C=f.userHome.with({path:c.path}).fsPath:C=p,p=$(C,P,v)}return(v===1?L.$gc:L.$hc).normalize(A(p,v===1))}function E(c,s,v){const f=v===1?L.$gc:L.$hc,S=v===3?M.$Yg:M.$1g,p=s.getWorkspace(),k=(0,d.$Ob)(p.folders);if(!k)return;c.scheme!==k.uri.scheme&&c.path[0]===L.$hc.sep&&c.path[1]!==L.$hc.sep&&(c=k.uri.with({path:c.path}));const P=s.getWorkspaceFolder(c);if(!P)return;let C;if(S.isEqual(P.uri,c)?C="":C=S.relativePath(P.uri,c)??"",C&&(C=f.normalize(C)),p.folders.length>1&&!s.noPrefix){const I=P.name?P.name:S.basenameOrAuthority(P.uri);C=C?`${I} \u2022 ${C}`:I}return C}function A(c,s=R.$i){return(0,N.$zg)(c,s)?c.charAt(0).toUpperCase()+c.slice(1):c}let D=Object.create(null);function $(c,s,v=R.OS){if(v===1||!c||!s)return c;let f=D.original===s?D.normalized:void 0;f||(f=s,R.$i&&(f=(0,N.$og)(f)),f=`${(0,b.$ff)(f,L.$hc.sep)}${L.$hc.sep}`,D={original:s,normalized:f});let S=c;return R.$i&&(S=(0,N.$og)(S)),(v===3?S.startsWith(f):(0,b.$yf)(S,f))?`~/${S.substr(f.length)}`:c}function y(c,s){return c.replace(/^~($|\/|\\)/,`${s}$1`)}const w="\u2026",h="\\\\",g="~";function a(c,s=L.sep){const v=new Array(c.length);let f=!1;for(let S=0;S<c.length;S++){const p=c[S];if(p===""){v[S]=`.${s}`;continue}if(!p){v[S]=p;continue}f=!0;let k="",P=p;P.indexOf(h)===0?(k=P.substr(0,P.indexOf(h)+h.length),P=P.substr(P.indexOf(h)+h.length)):P.indexOf(s)===0?(k=P.substr(0,P.indexOf(s)+s.length),P=P.substr(P.indexOf(s)+s.length)):P.indexOf(g)===0&&(k=P.substr(0,P.indexOf(g)+g.length),P=P.substr(P.indexOf(g)+g.length));const C=P.split(s);for(let I=1;f&&I<=C.length;I++)for(let T=C.length-I;f&&T>=0;T--){f=!1;let j=C.slice(T,T+I).join(s);for(let z=0;!f&&z<c.length;z++)if(z!==S&&c[z]&&c[z].indexOf(j)>-1){const O=T+I===C.length,F=T>0&&c[z].indexOf(s)>-1?s+j:j,B=c[z].endsWith(F);f=!O||B}if(!f){let z="";(C[0].endsWith(":")||k!=="")&&(T===1&&(T=0,I++,j=C[0]+s+j),T>0&&(z=C[0]+s),z=k+z),T>0&&(z=z+w+s),z=z+j,T+I<C.length&&(z=z+s+w),v[S]=z}}f&&(v[S]=p)}return v}var n;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(c,s=Object.create(null)){const v=[];let f=!1,S="";for(const p of c)if(p==="$"||f&&p==="{")S&&v.push({value:S,type:n.TEXT}),S="",f=!0;else if(p==="}"&&f){const k=s[S];if(typeof k=="string")k.length&&v.push({value:k,type:n.VARIABLE});else if(k){const P=v[v.length-1];(!P||P.type!==n.SEPARATOR)&&v.push({value:k.label,type:n.SEPARATOR})}S="",f=!1}else S+=p;return S&&!f&&v.push({value:S,type:n.TEXT}),v.filter((p,k)=>{if(p.type===n.SEPARATOR){const P=v[k-1],C=v[k+1];return[P,C].every(I=>I&&(I.type===n.VARIABLE||I.type===n.TEXT)&&I.value.length>0)}return!0}).map(p=>p.value).join("")}function u(c,s){return R.$j||s?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):c.replace(/&&|&/g,v=>v==="&"?"&&":"&")}function o(c,s){return R.$j||s?c.replace(/\(&&\w\)|&&/g,""):R.$i?c.replace(/&&|&/g,v=>v==="&"?"&&":"&"):c.replace(/&&/g,"_")}function t(c){return c.replace(/&/g,"&&")}function l(c){if(c.endsWith("]")){const s=c.lastIndexOf(" [",c.length-2);if(s!==-1){const v=r(c.substring(0,s)),f=c.substring(s);return{name:v.name+f,parentPath:v.parentPath}}}return r(c)}function r(c){const s=c.indexOf("/")!==-1?L.$hc:L.$gc,v=s.basename(c),f=s.dirname(c);return v.length?{name:v,parentPath:f}:{name:f,parentPath:""}}}),define(ke[134],Pe([1,0,21,2]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=void 0,e.$zn=b,e.$An=E,e.$Bn=A;function L(D){return D.toJSON()}class R{constructor($){this.a=$}transformIncoming($){const y=this.a.transformIncoming($);return y===$?$:L(N.URI.from(y))}transformOutgoing($){const y=this.a.transformOutgoing($);return y===$?$:L(N.URI.from(y))}transformOutgoingURI($){const y=this.a.transformOutgoing($);return y===$?$:N.URI.from(y)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$xn=R,e.$yn=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function M(D,$,y){if(!D||y>200)return null;if(typeof D=="object"){if(D instanceof N.URI)return $.transformOutgoing(D);for(const w in D)if(Object.hasOwnProperty.call(D,w)){const h=M(D[w],$,y+1);h!==null&&(D[w]=h)}}return null}function b(D,$){const y=M(D,$,0);return y===null?D:y}function m(D,$,y,w){if(!D||w>200)return null;if(typeof D=="object"){if(D.$mid===1)return y?N.URI.revive($.transformIncoming(D)):$.transformIncoming(D);if(D instanceof d.$Fe)return null;for(const h in D)if(Object.hasOwnProperty.call(D,h)){const g=m(D[h],$,y,w+1);g!==null&&(D[h]=g)}}return null}function E(D,$){const y=m(D,$,!1,0);return y===null?D:y}function A(D,$){const y=m(D,$,!0,0);return y===null?D:y}}),define(ke[32],Pe([1,0,52,64,400,7,31,77,17,12,23,2]),function(le,e,d,N,L,R,M,b,m,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=v,e.writeFileSync=S;var $;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function y(F,B=$.UNLINK,Z){if((0,M.$yg)(F))throw new Error("rimraf - will refuse to recursively delete root");return B===$.UNLINK?h(F):w(F,Z)}async function w(F,B=(0,M.$Dg)((0,N.tmpdir)())){try{try{await d.promises.rename(F,B)}catch(Z){return Z.code==="ENOENT"?void 0:h(F)}h(B).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function h(F){return(0,L.promisify)(d.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function g(F){if((0,M.$yg)(F))throw new Error("rimraf - will refuse to recursively delete root");d.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}async function a(F,B){return u(await(B?n(F):(0,L.promisify)(d.readdir)(F)))}async function n(F){try{return await(0,L.promisify)(d.readdir)(F,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const B=[],Z=await a(F);for(const q of Z){let Q=!1,x=!1,X=!1;try{const ie=await e.Promises.lstat((0,m.$kc)(F,q));Q=ie.isFile(),x=ie.isDirectory(),X=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}B.push({name:q,isFile:()=>Q,isDirectory:()=>x,isSymbolicLink:()=>X})}return B}function i(F){return u(d.readdirSync(F))}function u(F){return F.map(B=>typeof B=="string"?E.$j?(0,b.$am)(B):B:(B.name=E.$j?(0,b.$am)(B.name):B.name,B))}async function o(F){const B=await a(F),Z=[];for(const q of B)await l.existsDirectory((0,m.$kc)(F,q))&&Z.push(q);return Z}function t(F,B=1e3){return new Promise(Z=>{let q=!1;const Q=setInterval(()=>{q||(q=!0,d.access(F,x=>{q=!1,x&&(clearInterval(Q),Z(void 0))}))},B)})}var l;(function(F){async function B(Q){let x;try{if(x=await e.Promises.lstat(Q),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(Q),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(E.$i&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Q)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw ie}throw X}}F.stat=B;async function Z(Q){try{const{stat:x,symbolicLink:X}=await F.stat(Q);return x.isFile()&&X?.dangling!==!0}catch{}return!1}F.existsFile=Z;async function q(Q){try{const{stat:x,symbolicLink:X}=await F.stat(Q);return x.isDirectory()&&X?.dangling!==!0}catch{}return!1}F.existsDirectory=q})(l||(e.SymlinkSupport=l={}));const r=new R.$Eh;function c(F,B,Z){return r.queueFor(D.URI.file(F),()=>{const q=p(Z);return new Promise((Q,x)=>f(F,B,q,X=>X?x(X):Q()))},A.$Zg)}let s=!0;function v(F){s=F}function f(F,B,Z,q){if(!s)return d.writeFile(F,B,{mode:Z.mode,flag:Z.flag},q);d.open(F,Z.flag,Z.mode,(Q,x)=>{if(Q)return q(Q);d.writeFile(x,B,X=>{if(X)return d.close(x,()=>q(X));d.fdatasync(x,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),v(!1)),d.close(x,me=>q(me))))})})}function S(F,B,Z){const q=p(Z);if(!s)return d.writeFileSync(F,B,{mode:q.mode,flag:q.flag});const Q=d.openSync(F,q.flag,q.mode);try{d.writeFileSync(Q,B);try{d.fdatasyncSync(Q)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),v(!1)}}finally{d.closeSync(Q)}}function p(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function k(F,B,Z=6e4){if(F!==B)try{E.$i&&typeof Z=="number"?await P(F,B,Date.now(),Z):await(0,L.promisify)(d.rename)(F,B)}catch(q){if(F.toLowerCase()!==B.toLowerCase()&&q.code==="EXDEV"||F.endsWith("."))await C(F,B,{preserveSymlinks:!1}),await y(F,$.MOVE);else throw q}}async function P(F,B,Z,q,Q=0){try{return await(0,L.promisify)(d.rename)(F,B)}catch(x){if(x.code!=="EACCES"&&x.code!=="EPERM"&&x.code!=="EBUSY")throw x;if(Date.now()-Z>=q)throw console.error(`[node.js fs] rename failed after ${Q} retries with error: ${x}`),x;if(Q===0){let X=!1;try{const{stat:ie}=await l.stat(B);ie.isFile()||(X=!0)}catch{}if(X)throw x}return await(0,R.$wh)(Math.min(100,Q*10)),P(F,B,Z,q,Q+1)}}async function C(F,B,Z){return T(F,B,{root:{source:F,target:B},options:Z,handledSourcePaths:new Set})}const I=511;async function T(F,B,Z){if(Z.handledSourcePaths.has(F))return;Z.handledSourcePaths.add(F);const{stat:q,symbolicLink:Q}=await l.stat(F);if(Q){if(Z.options.preserveSymlinks)try{return await O(F,B,Z)}catch{}if(Q.dangling)return}return q.isDirectory()?j(F,B,q.mode&I,Z):z(F,B,q.mode&I)}async function j(F,B,Z,q){await e.Promises.mkdir(B,{recursive:!0,mode:Z});const Q=await a(F);for(const x of Q)await T((0,m.$kc)(F,x),(0,m.$kc)(B,x),q)}async function z(F,B,Z){await e.Promises.copyFile(F,B),await e.Promises.chmod(B,Z)}async function O(F,B,Z){let q=await e.Promises.readlink(F);(0,M.$ug)(q,Z.root.source,!E.$k)&&(q=(0,m.$kc)(Z.root.target,q.substr(Z.root.source.length+1))),await e.Promises.symlink(q,B)}e.Promises=new class{get access(){return(0,L.promisify)(d.access)}get stat(){return(0,L.promisify)(d.stat)}get lstat(){return(0,L.promisify)(d.lstat)}get utimes(){return(0,L.promisify)(d.utimes)}get read(){return(F,B,Z,q,Q)=>new Promise((x,X)=>{d.read(F,B,Z,q,Q,(ie,me,ue)=>ie?X(ie):x({bytesRead:me,buffer:ue}))})}get readFile(){return(0,L.promisify)(d.readFile)}get write(){return(F,B,Z,q,Q)=>new Promise((x,X)=>{d.write(F,B,Z,q,Q,(ie,me,ue)=>ie?X(ie):x({bytesWritten:me,buffer:ue}))})}get appendFile(){return(0,L.promisify)(d.appendFile)}get fdatasync(){return(0,L.promisify)(d.fdatasync)}get truncate(){return(0,L.promisify)(d.truncate)}get copyFile(){return(0,L.promisify)(d.copyFile)}get open(){return(0,L.promisify)(d.open)}get close(){return(0,L.promisify)(d.close)}get symlink(){return(0,L.promisify)(d.symlink)}get readlink(){return(0,L.promisify)(d.readlink)}get chmod(){return(0,L.promisify)(d.chmod)}get mkdir(){return(0,L.promisify)(d.mkdir)}get unlink(){return(0,L.promisify)(d.unlink)}get rmdir(){return(0,L.promisify)(d.rmdir)}get realpath(){return(0,L.promisify)(d.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return a}get readDirsInDir(){return o}get writeFile(){return c}get rm(){return y}get rename(){return k}get copy(){return C}}}),define(ke[104],Pe([1,0,52,17,12,14,32]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=b,e.$4q=m,e.$5q=E,e.$6q=A;function b($){if(L.$k)return $;const y=(0,N.$nc)($);if($===y)return $;const w=((0,N.$oc)($)||$).toLowerCase();try{const g=(0,M.readdirSync)(y).filter(a=>a.toLowerCase()===w);if(g.length===1){const a=b(y);if(a)return(0,N.$kc)(a,g[0])}else if(g.length>1){const a=g.indexOf(w);if(a>=0){const n=b(y);if(n)return(0,N.$kc)(n,g[a])}}}catch{}return null}async function m($,y){if(L.$k)return $;const w=(0,N.$nc)($);if($===w)return $;const h=((0,N.$oc)($)||$).toLowerCase();try{if(y?.isCancellationRequested)return null;const a=(await M.Promises.readdir(w)).filter(n=>n.toLowerCase()===h);if(a.length===1){const n=await m(w,y);if(n)return(0,N.$kc)(n,a[0])}else if(a.length>1){const n=a.indexOf(h);if(n>=0){const i=await m(w,y);if(i)return(0,N.$kc)(i,a[n])}}}catch{}return null}async function E($){try{return await M.Promises.realpath($)}catch{const w=D($);return await M.Promises.access(w,d.constants.R_OK),w}}function A($){try{return d.realpathSync($)}catch{const w=D($);return d.accessSync(w,d.constants.R_OK),w}}function D($){return(0,R.$ff)((0,N.$ic)($),N.sep)}}),define(ke[105],Pe([1,0,17,12,51,102,18,32]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$nm=m,e.$om=E,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function m(D=L.env){return D.comspec||"cmd.exe"}function E(D){let $=[],y=!1;const w=function(h){if(y){$.push(h);return}(!D.send(h,a=>{if(a&&console.error(a),y=!1,$.length>0){const n=$.slice(0);$=[],n.forEach(i=>w(i))}})||N.$i)&&(y=!0)};return{send:w}}var A;(function(D){async function $(y,w,h){if(d.$jc(y))return y;if(w===void 0&&(w=L.cwd()),d.$nc(y)!=="."||(h===void 0&&M.$8f(L.env.PATH)&&(h=L.env.PATH.split(d.$uc)),h===void 0||h.length===0))return d.$kc(w,y);async function a(n){if(await b.Promises.exists(n)){let i;try{i=await b.Promises.stat(n)}catch(u){u.message.startsWith("EACCES")&&(i=await b.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of h){let i;if(d.$jc(n)?i=d.$kc(n,y):i=d.$kc(w,n,y),await a(i))return i;let u=i+".com";if(await a(u)||(u=i+".exe",await a(u)))return u}return d.$kc(w,y)}D.findExecutable=$})(A||(e.win32=A={}))});var Je=this&&this.__decorate||function(le,e,d,N){var L=arguments.length,R=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,d):N,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(le,e,d,N);else for(var b=le.length-1;b>=0;b--)(M=le[b])&&(R=(L<3?M(R):L>3?M(e,d,R):M(e,d))||R);return L>3&&R&&Object.defineProperty(e,d,R),R};define(ke[82],Pe([1,0,19,7,21,22,55,13,4,3,58,14,18]),function(le,e,d,N,L,R,M,b,m,E,A,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.ProxyChannel=e.$di=e.$ai=e.$_h=e.$$h=e.RequestInitiator=e.$0h=e.$7h=e.$6h=void 0,e.$8h=v,e.$9h=f,e.$bi=I,e.$ci=T;var y;(function(Q){Q[Q.Promise=100]="Promise",Q[Q.PromiseCancel=101]="PromiseCancel",Q[Q.EventListen=102]="EventListen",Q[Q.EventDispose=103]="EventDispose"})(y||(y={}));function w(Q){switch(Q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(Q){Q[Q.Initialize=200]="Initialize",Q[Q.PromiseSuccess=201]="PromiseSuccess",Q[Q.PromiseError=202]="PromiseError",Q[Q.PromiseErrorObj=203]="PromiseErrorObj",Q[Q.EventFire=204]="EventFire"})(h||(h={}));function g(Q){switch(Q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(Q){Q[Q.Uninitialized=0]="Uninitialized",Q[Q.Idle=1]="Idle"})(a||(a={}));function n(Q){let x=0;for(let X=0;;X+=7){const ie=Q.read(1);if(x|=(ie.buffer[0]&127)<<X,!(ie.buffer[0]&128))return x}}const i=r(0);function u(Q,x){if(x===0){Q.write(i);return}let X=0;for(let me=x;me!==0;me=me>>>7)X++;const ie=L.$Fe.alloc(X);for(let me=0;x!==0;me++)ie.buffer[me]=x&127,x=x>>>7,x>0&&(ie.buffer[me]|=128);Q.write(ie)}class o{constructor(x){this.b=x,this.a=0}read(x){const X=this.b.slice(this.a,this.a+x);return this.a+=X.byteLength,X}}e.$6h=o;class t{constructor(){this.a=[]}get buffer(){return L.$Fe.concat(this.a)}write(x){this.a.push(x)}}e.$7h=t;var l;(function(Q){Q[Q.Undefined=0]="Undefined",Q[Q.String=1]="String",Q[Q.Buffer=2]="Buffer",Q[Q.VSBuffer=3]="VSBuffer",Q[Q.Array=4]="Array",Q[Q.Object=5]="Object",Q[Q.Int=6]="Int"})(l||(l={}));function r(Q){const x=L.$Fe.alloc(1);return x.writeUInt8(Q,0),x}const c={Undefined:r(l.Undefined),String:r(l.String),Buffer:r(l.Buffer),VSBuffer:r(l.VSBuffer),Array:r(l.Array),Object:r(l.Object),Uint:r(l.Int)},s=typeof Buffer<"u";function v(Q,x){if(typeof x>"u")Q.write(c.Undefined);else if(typeof x=="string"){const X=L.$Fe.fromString(x);Q.write(c.String),u(Q,X.byteLength),Q.write(X)}else if(s&&Buffer.isBuffer(x)){const X=L.$Fe.wrap(x);Q.write(c.Buffer),u(Q,X.byteLength),Q.write(X)}else if(x instanceof L.$Fe)Q.write(c.VSBuffer),u(Q,x.byteLength),Q.write(x);else if(Array.isArray(x)){Q.write(c.Array),u(Q,x.length);for(const X of x)v(Q,X)}else if(typeof x=="number"&&(x|0)===x)Q.write(c.Uint),u(Q,x);else{const X=L.$Fe.fromString(JSON.stringify(x));Q.write(c.Object),u(Q,X.byteLength),Q.write(X)}}function f(Q){switch(Q.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return Q.read(n(Q)).toString();case l.Buffer:return Q.read(n(Q)).buffer;case l.VSBuffer:return Q.read(n(Q));case l.Array:{const X=n(Q),ie=[];for(let me=0;me<X;me++)ie.push(f(Q));return ie}case l.Object:return JSON.parse(Q.read(n(Q)).toString());case l.Int:return n(Q)}}class S{constructor(x,X,ie=null,me=1e3){this.h=x,this.j=X,this.k=ie,this.l=me,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ue=>this.q(ue)),this.m({type:200})}registerChannel(x,X){this.b.set(x,X),setTimeout(()=>this.w(x),0)}m(x){switch(x.type){case 200:{const X=this.o([x.type]);this.k?.logOutgoing(X,0,1,g(x.type));return}case 201:case 202:case 204:case 203:{const X=this.o([x.type,x.id],x.data);this.k?.logOutgoing(X,x.id,1,g(x.type),x.data);return}}}o(x,X=void 0){const ie=new t;return v(ie,x),v(ie,X),this.p(ie.buffer)}p(x){try{return this.h.send(x),x.byteLength}catch{return 0}}q(x){const X=new o(x),ie=f(X),me=f(X),ue=ie[0];switch(ue){case 100:return this.k?.logIncoming(x.byteLength,ie[1],1,`${w(ue)}: ${ie[2]}.${ie[3]}`,me),this.s({type:ue,id:ie[1],channelName:ie[2],name:ie[3],arg:me});case 102:return this.k?.logIncoming(x.byteLength,ie[1],1,`${w(ue)}: ${ie[2]}.${ie[3]}`,me),this.t({type:ue,id:ie[1],channelName:ie[2],name:ie[3],arg:me});case 101:return this.k?.logIncoming(x.byteLength,ie[1],1,`${w(ue)}`),this.u({type:ue,id:ie[1]});case 103:return this.k?.logIncoming(x.byteLength,ie[1],1,`${w(ue)}`),this.u({type:ue,id:ie[1]})}}s(x){const X=this.b.get(x.channelName);if(!X){this.v(x);return}const ie=new R.$pe;let me;try{me=X.call(this.j,x.name,x.arg,ie.token)}catch(te){me=Promise.reject(te)}const ue=x.id;me.then(te=>{this.m({id:ue,data:te,type:201})},te=>{te instanceof Error?this.m({id:ue,data:{message:te.message,name:te.name,stack:te.stack?te.stack.split?te.stack.split(`
`):te.stack:void 0},type:202}):this.m({id:ue,data:te,type:203})}).finally(()=>{ve.dispose(),this.d.delete(x.id)});const ve=(0,E.$Tc)(()=>ie.cancel());this.d.set(x.id,ve)}t(x){const X=this.b.get(x.channelName);if(!X){this.v(x);return}const ie=x.id,ue=X.listen(this.j,x.name,x.arg)(ve=>this.m({id:ie,data:ve,type:204}));this.d.set(x.id,ue)}u(x){const X=this.d.get(x.id);X&&(X.dispose(),this.d.delete(x.id))}v(x){let X=this.g.get(x.channelName);X||(X=[],this.g.set(x.channelName,X));const ie=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.m({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:x,timeoutTimer:ie})}w(x){const X=this.g.get(x);if(X){for(const ie of X)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(x)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,E.$Qc)(this.d.values()),this.d.clear()}}e.$0h=S;var p;(function(Q){Q[Q.LocalSide=0]="LocalSide",Q[Q.OtherSide=1]="OtherSide"})(p||(e.RequestInitiator=p={}));class k{constructor(x,X=null){this.l=x,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$ee,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=X}getChannel(x){const X=this;return{call(ie,me,ue){return X.a?Promise.reject(new b.$5):X.m(x,ie,me,ue)},listen(ie,me){return X.a?m.Event.None:X.o(x,ie,me)}}}m(x,X,ie,me=R.CancellationToken.None){const ue=this.g++,te={id:ue,type:100,channelName:x,name:X,arg:ie};if(me.isCancellationRequested)return Promise.reject(new b.$5);let U;return new Promise((pe,Ce)=>{if(me.isCancellationRequested)return Ce(new b.$5);const se=()=>{const ne=$e=>{switch($e.type){case 201:this.f.delete(ue),pe($e.data);break;case 202:{this.f.delete(ue);const be=new Error($e.data.message);be.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,be.name=$e.data.name,Ce(be);break}case 203:this.f.delete(ue),Ce($e.data);break}};this.f.set(ue,ne),this.p(te)};let re=null;this.b===a.Idle?se():(re=(0,N.$ih)(ne=>this.u()),re.then(()=>{re=null,se()}));const oe=()=>{re?(re.cancel(),re=null):this.p({id:ue,type:101}),Ce(new b.$5)},K=me.onCancellationRequested(oe);U=(0,E.$Sc)((0,E.$Tc)(oe),K),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(x,X,ie){const me=this.g++,ve={id:me,type:102,channelName:x,name:X,arg:ie};let te=null;const U=new m.$ee({onWillAddFirstListener:()=>{te=(0,N.$ih)(pe=>this.u()),te.then(()=>{te=null,this.d.add(U),this.p(ve)})},onDidRemoveLastListener:()=>{te?(te.cancel(),te=null):(this.d.delete(U),this.p({id:me,type:103}))}}),ee=pe=>U.fire(pe.data);return this.f.set(me,ee),U.event}p(x){switch(x.type){case 100:case 102:{const X=this.q([x.type,x.id,x.channelName,x.name],x.arg);this.j?.logOutgoing(X,x.id,0,`${w(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const X=this.q([x.type,x.id]);this.j?.logOutgoing(X,x.id,0,w(x.type));return}}}q(x,X=void 0){const ie=new t;return v(ie,x),v(ie,X),this.r(ie.buffer)}r(x){try{return this.l.send(x),x.byteLength}catch{return 0}}s(x){const X=new o(x),ie=f(X),me=f(X),ue=ie[0];switch(ue){case 200:return this.j?.logIncoming(x.byteLength,0,0,g(ue)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(x.byteLength,ie[1],0,g(ue),me),this.t({type:ie[0],id:ie[1],data:me})}}t(x){if(x.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(x.id)?.(x)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,E.$Qc)(this.d.values()),this.d.clear()}}e.$$h=k,Je([M.$Zh],k.prototype,"onDidInitializePromise",null);class P{get connections(){const x=[];return this.f.forEach(X=>x.push(X)),x}constructor(x,X,ie){this.a=new Map,this.f=new Set,this.g=new m.$ee,this.onDidAddConnection=this.g.event,this.h=new m.$ee,this.onDidRemoveConnection=this.h.event,this.j=new E.$Uc,this.j.add(x(({protocol:me,onDidClientDisconnect:ue})=>{const ve=m.Event.once(me.onMessage);this.j.add(ve(te=>{const U=new o(te),ee=f(U),pe=new S(me,ee,X,ie),Ce=new k(me,X);this.a.forEach((re,oe)=>pe.registerChannel(oe,re));const se={channelServer:pe,channelClient:Ce,ctx:ee};this.f.add(se),this.g.fire(se),this.j.add(ue(()=>{pe.dispose(),Ce.dispose(),this.f.delete(se),this.h.fire(se)}))}))}))}getChannel(x,X){const ie=this;return{call(me,ue,ve){let te;if((0,$.$jg)(X)){const ee=(0,d.$4b)(ie.connections.filter(X));te=ee?Promise.resolve(ee):m.Event.toPromise(m.Event.filter(ie.onDidAddConnection,X))}else te=X.routeCall(ie,me,ue);const U=te.then(ee=>ee.channelClient.getChannel(x));return I(U).call(me,ue,ve)},listen(me,ue){if((0,$.$jg)(X))return ie.k(x,X,me,ue);const ve=X.routeEvent(ie,me,ue).then(te=>te.channelClient.getChannel(x));return I(ve).listen(me,ue)}}}k(x,X,ie,me){const ue=this;let ve;const te=new m.$ee({onWillAddFirstListener:()=>{ve=new E.$Uc;const U=new m.$ke,ee=new Map,pe=se=>{const oe=se.channelClient.getChannel(x).listen(ie,me),K=U.add(oe);ee.set(se,K)},Ce=se=>{const re=ee.get(se);re&&(re.dispose(),ee.delete(se))};ue.connections.filter(X).forEach(pe),m.Event.filter(ue.onDidAddConnection,X)(pe,void 0,ve),ue.onDidRemoveConnection(Ce,void 0,ve),U.event(te.fire,te,ve),ve.add(U)},onDidRemoveLastListener:()=>{ve?.dispose(),ve=void 0}});return te.event}registerChannel(x,X){this.a.set(x,X);for(const ie of this.f)ie.channelServer.registerChannel(x,X)}dispose(){this.j.dispose();for(const x of this.f)x.channelClient.dispose(),x.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$_h=P;class C{constructor(x,X,ie=null){const me=new t;v(me,X),x.send(me.buffer),this.a=new k(x,ie),this.d=new S(x,X,ie)}getChannel(x){return this.a.getChannel(x)}registerChannel(x,X){this.d.registerChannel(x,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ai=C;function I(Q){return{call(x,X,ie){return Q.then(me=>me.call(x,X,ie))},listen(x,X){const ie=new m.$ne;return Q.then(me=>ie.input=me.listen(x,X)),ie.event}}}function T(Q){let x=!1;return{call(X,ie,me){return x?Q.call(X,ie,me):(0,N.$wh)(0).then(()=>x=!0).then(()=>Q.call(X,ie,me))},listen(X,ie){if(x)return Q.listen(X,ie);const me=new m.$ne;return(0,N.$wh)(0).then(()=>x=!0).then(()=>me.input=Q.listen(X,ie)),me.event}}}class j{constructor(x){this.a=x}routeCall(x){return this.b(x)}routeEvent(x){return this.b(x)}async b(x){for(const X of x.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await m.Event.toPromise(x.onDidAddConnection),await this.b(x)}}e.$di=j;var z;(function(Q){function x(ue,ve,te){const U=ue,ee=te&&te.disableMarshalling,pe=new Map;for(const Ce in U)ie(Ce)&&pe.set(Ce,m.Event.buffer(U[Ce],!0,void 0,ve));return new class{listen(Ce,se,re){const oe=pe.get(se);if(oe)return oe;const K=U[se];if(typeof K=="function"){if(me(se))return K.call(U,re);if(ie(se))return pe.set(se,m.Event.buffer(U[se],!0,void 0,ve)),pe.get(se)}throw new b.$bb(`Event not found: ${se}`)}call(Ce,se,re){const oe=U[se];if(typeof oe=="function"){if(!ee&&Array.isArray(re))for(let ne=0;ne<re.length;ne++)re[ne]=(0,A.$5h)(re[ne]);let K=oe.apply(U,re);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new b.$bb(`Method not found: ${se}`)}}}Q.fromService=x;function X(ue,ve){const te=ve&&ve.disableMarshalling;return new Proxy({},{get(U,ee){if(typeof ee=="string")return ve?.properties?.has(ee)?ve.properties.get(ee):me(ee)?function(pe){return ue.listen(ee,pe)}:ie(ee)?ue.listen(ee):async function(...pe){let Ce;ve&&!(0,$.$eg)(ve.context)?Ce=[ve.context,...pe]:Ce=pe;const se=await ue.call(ee,Ce);return te?se:(0,A.$5h)(se)};throw new b.$bb(`Property not found: ${String(ee)}`)}})}Q.toService=X;function ie(ue){return ue[0]==="o"&&ue[1]==="n"&&D.$wf(ue.charCodeAt(2))}function me(ue){return/^onDynamic/.test(ue)&&D.$wf(ue.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(Q){if(Array.isArray(Q))return Q;if(Q&&typeof Q=="object"&&typeof Q.toString=="function"){const x=Q.toString();if(x!=="[object Object]")return x}return Q}function B(Q){return Array.isArray(Q)?Q.map(F):F(Q)}function Z(Q,x,X,ie,me,ue,ve){ve=B(ve);const te=O[me],U=te[ie%te.length];let ee=[`%c[${Q}]%c[${String(x).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ue)?(ee=ee.concat(ve),ee.push(")")):ee.push(ve),console.log.apply(console,ee)}class q{constructor(x,X){this.d=x,this.f=X,this.a=0,this.b=0}logOutgoing(x,X,ie,me,ue){this.b+=x,Z(this.d,this.b,x,X,ie,me,ue)}logIncoming(x,X,ie,me,ue){this.a+=x,Z(this.f,this.a,x,X,ie,me,ue)}}e.$ei=q}),define(ke[83],Pe([1,0,21,4,3,82]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.ProtocolConstants=e.$fi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(c){c.Created="created",c.Read="read",c.Write="write",c.Open="open",c.Error="error",c.Close="close",c.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",c.NodeEndReceived="nodeEndReceived",c.NodeEndSent="nodeEndSent",c.NodeDrainBegin="nodeDrainBegin",c.NodeDrainEnd="nodeDrainEnd",c.zlibInflateError="zlibInflateError",c.zlibInflateData="zlibInflateData",c.zlibInflateInitialWrite="zlibInflateInitialWrite",c.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",c.zlibInflateWrite="zlibInflateWrite",c.zlibInflateFlushFired="zlibInflateFlushFired",c.zlibDeflateError="zlibDeflateError",c.zlibDeflateData="zlibDeflateData",c.zlibDeflateWrite="zlibDeflateWrite",c.zlibDeflateFlushFired="zlibDeflateFlushFired",c.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",c.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",c.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",c.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",c.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",c.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",c.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",c.ProtocolHeaderRead="protocolHeaderRead",c.ProtocolMessageRead="protocolMessageRead",c.ProtocolHeaderWrite="protocolHeaderWrite",c.ProtocolMessageWrite="protocolMessageWrite",c.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var b;(function(c){c.enableDiagnostics=!1,c.records=[];const s=new WeakMap;let v=0;function f(p,k){if(!s.has(p)){const P=String(++v);s.set(p,P)}return s.get(p)}function S(p,k,P,C){if(!c.enableDiagnostics)return;const I=f(p,k);if(C instanceof d.$Fe||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const T=d.$Fe.alloc(C.byteLength);T.set(C),c.records.push({timestamp:Date.now(),id:I,label:k,type:P,buff:T})}else c.records.push({timestamp:Date.now(),id:I,label:k,type:P,data:C})}c.traceSocketEvent=S})(b||(e.SocketDiagnostics=b={}));var m;(function(c){c[c.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",c[c.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m||(e.SocketCloseEventType=m={}));let E=null;function A(){return E||(E=d.$Fe.alloc(0)),E}class D{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,v){if(s===0)return A();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const k=this.a[0];return v&&(this.a.shift(),this.b-=s),k}if(this.a[0].byteLength>s){const k=this.a[0].slice(0,s);return v&&(this.a[0]=this.a[0].slice(s),this.b-=s),k}const f=d.$Fe.alloc(s);let S=0,p=0;for(;s>0;){const k=this.a[p];if(k.byteLength>s){const P=k.slice(0,s);f.set(P,S),S+=s,v&&(this.a[p]=k.slice(s),this.b-=s),s-=s}else f.set(k,S),S+=k.byteLength,v?(this.a.shift(),this.b-=k.byteLength):p++,s-=k.byteLength}return f}}e.$fi=D;var $;(function(c){c[c.None=0]="None",c[c.Regular=1]="Regular",c[c.Control=2]="Control",c[c.Ack=3]="Ack",c[c.Disconnect=5]="Disconnect",c[c.ReplayRequest=6]="ReplayRequest",c[c.Pause=7]="Pause",c[c.Resume=8]="Resume",c[c.KeepAlive=9]="KeepAlive"})($||($={}));function y(c){switch(c){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var w;(function(c){c[c.HeaderLength=13]="HeaderLength",c[c.AcknowledgeTime=2e3]="AcknowledgeTime",c[c.TimeoutTime=2e4]="TimeoutTime",c[c.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",c[c.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",c[c.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(w||(e.ProtocolConstants=w={}));class h{constructor(s,v,f,S){this.type=s,this.id=v,this.ack=f,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends L.$Vc{constructor(s){super(),this.f=this.B(new N.$ee),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new D,this.B(this.a.onData(v=>this.acceptChunk(v))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const v=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=v.readUInt32BE(9),this.g.messageType=v.readUInt8(0),this.g.id=v.readUInt32BE(1),this.g.ack=v.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const f=this.g.messageType,S=this.g.id,p=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",v),this.f.fire(new h(f,S,p,v)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class a{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const v=d.$Fe.alloc(13);v.writeUInt8(s.type,0),v.writeUInt32BE(s.id,1),v.writeUInt32BE(s.ack,5),v.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(v,s.data)}g(s,v){const f=this.f===0;return this.d.push(s,v),this.f+=s.byteLength+v.byteLength,f}h(){const s=d.$Fe.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,v){this.g(s,v)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class n extends L.$Vc{constructor(s){super(),this.f=new N.$ee,this.onMessage=this.f.event,this.g=new N.$ee,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new a(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(v=>{v.type===1&&this.f.fire(v.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new h(1,0,0,s))}}e.$gi=n;class i extends R.$ai{static fromSocket(s,v){return new i(new n(s),v)}get onDidDispose(){return this.b.onDidDispose}constructor(s,v,f=null){super(s,v,f),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$hi=i;class u{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$ee({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$ii=u;class o{constructor(s){this.data=s,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let s=0,v=this.a;for(;v;)v=v.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let v=0,f=this.a;for(;f;)s[v++]=f.data,f=f.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const v=new o(s);if(!this.a){this.a=v,this.b=v;return}this.b.next=v,this.b=v}}class l{static{this.a=10}static{this.b=null}static getInstance(){return l.b||(l.b=new l),l.b}constructor(){this.c=[];const s=Date.now();for(let v=0;v<l.a;v++)this.c[v]=s-1e3*v;setInterval(()=>{for(let v=l.a;v>=1;v--)this.c[v]=this.c[v-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),v=(1+l.a)*1e3;let f=0;for(let S=0;S<l.a;S++)s-this.c[S]<=v&&f++;return 1-f/l.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new u,this.onControlMessage=this.u.event,this.v=new u,this.onMessage=this.v.event,this.w=new u,this.onDidDispose=this.w.event,this.x=new u,this.onSocketClose=this.x.event,this.y=new u,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??l.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Uc,this.o=s.socket,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(v=>this.z(v))),this.r.add(this.o.onClose(v=>this.x.fire(v))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new h(5,0,0,A());this.p.write(s),this.p.flush()}sendPause(){const s=new h(7,0,0,A());this.p.write(s)}sendResume(){const s=new h(8,0,0,A());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,v){this.a=!0,this.r.dispose(),this.r=new L.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(f=>this.z(f))),this.r.add(this.o.onClose(f=>this.x.fire(f))),this.q.acceptChunk(v)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new h(3,0,this.h,A());this.p.write(s);const v=this.b.toArray();for(let f=0,S=v.length;f<S;f++)this.p.write(v[f]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const v=this.b.peek();if(v&&v.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const v=Date.now();v-this.m>1e4&&(this.m=v,this.p.write(new h(6,0,0,A())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const v=this.b.toArray();for(let f=0,S=v.length;f<S;f++)this.p.write(v[f]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const v=++this.c;this.h=this.g;const f=new h(1,v,this.h,s);this.b.push(f),this.a||(this.p.write(f),this.B())}sendControl(s){const v=new h(2,0,0,s);this.p.write(v)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),v=Date.now()-s.writtenTime,f=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(v>=2e4&&f>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:v,timeSinceLastReceivedSomeData:f});return}const p=Math.max(2e4-v,2e4-f,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},p)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new h(3,0,this.h,A());this.p.write(s)}D(){this.h=this.g;const s=new h(9,0,this.h,A());this.p.write(s)}}e.$ji=r}),define(ke[199],Pe([1,0,53,7,21,22,197,13,4,3,24,105,102,82]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;class w extends y.$0h{constructor(a){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:m.Event.fromNodeEventEmitter(process,"message",n=>L.$Fe.wrap(Buffer.from(n,"base64")))},a),process.once("disconnect",()=>this.dispose())}}e.$Yq=w;class h{constructor(a,n){this.i=a,this.j=n,this.c=new Set,this.g=new Map,this.h=new m.$ee,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new N.$sh(i),this.d=null,this.f=null}getChannel(a){const n=this;return{call(i,u,o){return n.k(a,i,u,o)},listen(i,u){return n.l(a,i,u)}}}k(a,n,i,u=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const o=this.n(a),t=(0,N.$ih)(c=>o.call(n,i,c)),l=u.onCancellationRequested(()=>t.cancel()),r=(0,E.$Tc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{l.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(a,n,i){if(!this.b)return m.Event.None;this.b.cancel();let u;const o=new m.$ee({onWillAddFirstListener:()=>{u=this.n(a).listen(n,i)(o.fire,o),this.c.add(u)},onDidRemoveLastListener:()=>{this.c.delete(u),u.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const a=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,A.$2n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(v=>!/^--inspect(-brk)?=/.test(v)).filter(v=>!v.startsWith("--vscode-"))),(0,$.$mm)(n.env),this.d=(0,d.fork)(this.i,a,n);const i=new m.$ee,o=m.Event.fromNodeEventEmitter(this.d,"message",v=>v)(v=>{if((0,M.$Uq)(v)){(0,M.log)(v,`IPC Library: ${this.j.serverName}`);return}i.fire(L.$Fe.wrap(Buffer.from(v,"base64")))}),t=this.j.useQueue?(0,D.$om)(this.d):this.d,l=v=>this.d&&this.d.connected&&t.send(v.buffer.toString("base64")),r=i.event,c={send:l,onMessage:r};this.f=new y.$$h(c);const s=()=>this.o();process.once("exit",s),this.d.on("error",v=>console.warn('IPC "'+this.j.serverName+'" errored with '+v)),this.d.on("exit",(v,f)=>{process.removeListener("exit",s),o.dispose(),this.c.forEach(S=>(0,E.$Qc)(S)),this.c.clear(),v!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+v+" and signal "+f),this.b?.cancel(),this.o(),this.h.fire({code:v,signal:f})})}return this.f}n(a){let n=this.g.get(a);return n||(n=this.m.getChannel(a),this.g.set(a,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Zq=h}),define(ke[200],Pe([1,0,7,4,3,58,18]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=e.StorageState=e.StorageHint=void 0,e.$Up=m;var b;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function m($){const y=$;return y?.changed instanceof Map||y?.deleted instanceof Set}var E;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(E||(e.StorageState=E={}));class A extends L.$Vc{static{this.a=100}constructor(y,w=Object.create(null)){super(),this.r=y,this.s=w,this.b=this.B(new N.$he),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new d.$th(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((w,h)=>this.w(h,w)),y.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w(y,w){if(this.c===E.Closed)return;let h=!1;(0,M.$eg)(w)?h=this.f.delete(y):this.f.get(y)!==w&&(this.f.set(y,w),h=!0),h&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,w){const h=this.f.get(y);return(0,M.$eg)(h)?w:h}getBoolean(y,w){const h=this.get(y);return(0,M.$eg)(h)?w:h==="true"}getNumber(y,w){const h=this.get(y);return(0,M.$eg)(h)?w:parseInt(h,10)}getObject(y,w){const h=this.get(y);return(0,M.$eg)(h)?w:(0,R.$4h)(h)}async set(y,w,h=!1){if(this.c===E.Closed)return;if((0,M.$eg)(w))return this.delete(y,h);const g=(0,M.$0f)(w)||Array.isArray(w)?(0,R.$3h)(w):String(w);if(this.f.get(y)!==g)return this.f.set(y,g),this.j.set(y,g),this.h.delete(y),this.b.fire({key:y,external:h}),this.D()}async delete(y,w=!1){if(!(this.c===E.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:w}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Vp=A;class D{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((w,h)=>this.a.set(h,w)),y.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$Wp=D}),define(ke[201],Pe([1,0,14,12,21]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=void 0,e.$Ct=A,e.$Dt=D;let R;function M(){return R||(R=new TextDecoder("UTF-16LE")),R}let b;function m(){return b||(b=new TextDecoder("UTF-16BE")),b}let E;function A(){return E||(E=N.$D()?M():m()),E}function D(w,h,g){const a=new Uint16Array(w.buffer,h,g);return g>0&&(a[0]===65279||a[0]===65534)?$(w,h,g):M().decode(a)}function $(w,h,g){const a=[];let n=0;for(let i=0;i<g;i++){const u=L.$He(w,h);h+=2,a[n++]=String.fromCharCode(u)}return a.join("")}class y{constructor(h){this.a=h|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const h=new Uint16Array(this.b.buffer,0,this.d);return A().decode(h)}f(){const h=this.e();this.d=0,this.c===null?this.c=[h]:this.c[this.c.length]=h}appendCharCode(h){const g=this.a-this.d;g<=1&&(g===0||d.$Bf(h))&&this.f(),this.b[this.d++]=h}appendASCIICharCode(h){this.d===this.a&&this.f(),this.b[this.d++]=h}appendString(h){const g=h.length;if(this.d+g>=this.a){this.f(),this.c[this.c.length]=h;return}for(let a=0;a<g;a++)this.b[this.d++]=h.charCodeAt(a)}}e.$Et=y}),define(ke[202],Pe([1,0,21,201]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=void 0,e.$Gt=M;function L(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,A,D,$){this.oldPosition=E,this.oldText=A,this.newPosition=D,this.newText=$}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${L(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${L(this.oldText)}")`:`(replace@${this.oldPosition} "${L(this.oldText)}" with "${L(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,A,D){const $=A.length;d.$Ke(E,$,D),D+=4;for(let y=0;y<$;y++)d.$Ie(E,A.charCodeAt(y),D),D+=2;return D}static d(E,A){const D=d.$Je(E,A);return A+=4,(0,N.$Dt)(E,A,D)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(E,A){return d.$Ke(E,this.oldPosition,A),A+=4,d.$Ke(E,this.newPosition,A),A+=4,A=R.c(E,this.oldText,A),A=R.c(E,this.newText,A),A}static read(E,A,D){const $=d.$Je(E,A);A+=4;const y=d.$Je(E,A);A+=4;const w=R.d(E,A);A+=R.a(w);const h=R.d(E,A);return A+=R.a(h),D.push(new R($,w,y,h)),A}}e.$Ft=R;function M(m,E){return m===null||m.length===0?E:new b(m,E).compress()}class b{constructor(E,A){this.a=E,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,A=0,D=this.n(E),$=this.l(A);for(;E<this.f||A<this.h;){if(D===null){this.k($),$=this.l(++A);continue}if($===null){this.m(D),D=this.n(++E);continue}if($.oldEnd<=D.newPosition){this.k($),$=this.l(++A);continue}if(D.newEnd<=$.oldPosition){this.m(D),D=this.n(++E);continue}if($.oldPosition<D.newPosition){const[a,n]=b.r($,D.newPosition-$.oldPosition);this.k(a),$=n;continue}if(D.newPosition<$.oldPosition){const[a,n]=b.q(D,$.oldPosition-D.newPosition);this.m(a),D=n;continue}let h,g;if($.oldEnd===D.newEnd)h=D,g=$,D=this.n(++E),$=this.l(++A);else if($.oldEnd<D.newEnd){const[a,n]=b.q(D,$.oldLength);h=a,g=$,D=n,$=this.l(++A)}else{const[a,n]=b.r($,D.newLength);h=D,g=a,D=this.n(++E),$=n}this.d[this.e++]=new R(h.oldPosition,h.oldText,g.newPosition,g.newText),this.g+=h.newLength-h.oldLength,this.j+=g.newLength-g.oldLength}const y=b.s(this.d);return b.t(y)}k(E){this.d[this.e++]=b.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=b.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,A){return new R(A.oldPosition-E,A.oldText,A.newPosition,A.newText)}static p(E,A){return new R(A.oldPosition,A.oldText,A.newPosition+E,A.newText)}static q(E,A){const D=E.newText.substr(0,A),$=E.newText.substr(A);return[new R(E.oldPosition,E.oldText,E.newPosition,D),new R(E.oldEnd,"",E.newPosition+A,$)]}static r(E,A){const D=E.oldText.substr(0,A),$=E.oldText.substr(A);return[new R(E.oldPosition,D,E.newPosition,E.newText),new R(E.oldPosition+A,$,E.newEnd,"")]}static s(E){if(E.length===0)return E;const A=[];let D=0,$=E[0];for(let y=1;y<E.length;y++){const w=E[y];$.oldEnd===w.oldPosition?$=new R($.oldPosition,$.oldText+w.oldText,$.newPosition,$.newText+w.newText):(A[D++]=$,$=w)}return A[D++]=$,A}static t(E){if(E.length===0)return E;const A=[];let D=0;for(let $=0;$<E.length;$++){const y=E[$];y.oldText!==y.newText&&(A[D++]=y)}return A}}}),define(ke[203],Pe([1,0,35,17]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4t=L,e.$5t=R;function L(M,b,m,E,A,D){if(Array.isArray(M)){let $=0;for(const y of M){const w=L(y,b,m,E,A,D);if(w===10)return w;w>$&&($=w)}return $}else{if(typeof M=="string")return E?M==="*"?5:M===m?10:0:0;if(M){const{language:$,pattern:y,scheme:w,hasAccessToAllModels:h,notebookType:g}=M;if(!E&&!h)return 0;g&&A&&(b=A);let a=0;if(w)if(w===b.scheme)a=10;else if(w==="*")a=5;else return 0;if($)if($===m)a=10;else if($==="*")a=Math.max(a,5);else return 0;if(g)if(g===D)a=10;else if(g==="*"&&D!==void 0)a=Math.max(a,5);else return 0;if(y){let n;if(typeof y=="string"?n=y:n={...y,base:(0,N.$ic)(y.base)},n===b.fsPath||(0,d.$ok)(n,b.fsPath))a=10;else return 0}return a}else return 0}}function R(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(R):!!M.notebookType}}),define(ke[204],Pe([1,0,4,14,29,80,131,179,202,3]),function(le,e,d,N,L,R,M,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TC=void 0;class A extends E.$Vc{constructor($,y,w,h,g,a,n){super(),this.m=this.B(new d.$ee),this.onDidChangeContent=this.m.event,this.f=y,this.j=!a,this.g=h,this.h=g,this.c=new M.$SC($,w,n)}equals($){return!($ instanceof A)||this.f!==$.f||this.getEOL()!==$.getEOL()?!1:this.c.equal($.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot($){return this.c.createSnapshot($?this.f:"")}getOffsetAt($,y){return this.c.getOffsetAt($,y)}getPositionAt($){return this.c.getPositionAt($)}getRangeAt($,y){const w=$+y,h=this.getPositionAt($),g=this.getPositionAt(w);return new L.$tt(h.lineNumber,h.column,g.lineNumber,g.column)}getValueInRange($,y=0){if($.isEmpty())return"";const w=this.n(y);return this.c.getValueInRange($,w)}getValueLengthInRange($,y=0){if($.isEmpty())return 0;if($.startLineNumber===$.endLineNumber)return $.endColumn-$.startColumn;const w=this.getOffsetAt($.startLineNumber,$.startColumn),h=this.getOffsetAt($.endLineNumber,$.endColumn);let g=0;const a=this.n(y),n=this.getEOL();if(a.length!==n.length){const i=a.length-n.length,u=$.endLineNumber-$.startLineNumber;g=i*u}return h-w+g}getCharacterCountInRange($,y=0){if(this.j){let w=0;const h=$.startLineNumber,g=$.endLineNumber;for(let a=h;a<=g;a++){const n=this.getLineContent(a),i=a===h?$.startColumn-1:0,u=a===g?$.endColumn-1:n.length;for(let o=i;o<u;o++)N.$Bf(n.charCodeAt(o))?(w=w+1,o=o+1):w=w+1}return w+=this.n(y).length*(g-h),w}return this.getValueLengthInRange($,y)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent($){return this.c.getLineContent($)}getLineCharCode($,y){return this.c.getLineCharCode($,y)}getCharCode($){return this.c.getCharCode($)}getLineLength($){return this.c.getLineLength($)}getLineMinColumn($){return 1}getLineMaxColumn($){return this.getLineLength($)+1}getLineFirstNonWhitespaceColumn($){const y=N.$mf(this.getLineContent($));return y===-1?0:y+1}getLineLastNonWhitespaceColumn($){const y=N.$of(this.getLineContent($));return y===-1?0:y+2}n($){switch($){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL($){this.c.setEOL($)}applyEdits($,y,w){let h=this.g,g=this.h,a=this.j,n=!0,i=[];for(let s=0;s<$.length;s++){const v=$[s];n&&v._isTracked&&(n=!1);const f=v.range;if(v.text){let C=!0;a||(C=!N.$Mf(v.text),a=C),!h&&C&&(h=N.$Lf(v.text)),!g&&C&&(g=N.$Of(v.text))}let S="",p=0,k=0,P=0;if(v.text){let C;[p,k,P,C]=(0,b.$Wt)(v.text);const I=this.getEOL();C===0||C===(I===`\r
`?2:1)?S=v.text:S=v.text.replace(/\r\n|\r|\n/g,I)}i[s]={sortIndex:s,identifier:v.identifier||null,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f),text:S,eolCount:p,firstLineLength:k,lastLineLength:P,forceMoveMarkers:!!v.forceMoveMarkers,isAutoWhitespaceEdit:v.isAutoWhitespaceEdit||!1}}i.sort(A.u);let u=!1;for(let s=0,v=i.length-1;s<v;s++){const f=i[s].range.getEndPosition(),S=i[s+1].range.getStartPosition();if(S.isBeforeOrEqual(f)){if(S.isBefore(f))throw new Error("Overlapping ranges are not allowed!");u=!0}}n&&(i=this.s(i));const o=w||y?A._getInverseEditRanges(i):[],t=[];if(y)for(let s=0;s<i.length;s++){const v=i[s],f=o[s];if(v.isAutoWhitespaceEdit&&v.range.isEmpty())for(let S=f.startLineNumber;S<=f.endLineNumber;S++){let p="";S===f.startLineNumber&&(p=this.getLineContent(v.range.startLineNumber),N.$mf(p)!==-1)||t.push({lineNumber:S,oldContent:p})}}let l=null;if(w){let s=0;l=[];for(let v=0;v<i.length;v++){const f=i[v],S=o[v],p=this.getValueInRange(f.range),k=f.rangeOffset+s;s+=f.text.length-p.length,l[v]={sortIndex:f.sortIndex,identifier:f.identifier,range:S,text:p,textChange:new m.$Ft(f.rangeOffset,p,k,f.text)}}u||l.sort((v,f)=>v.sortIndex-f.sortIndex)}this.g=h,this.h=g,this.j=a;const r=this.t(i);let c=null;if(y&&t.length>0){t.sort((s,v)=>v.lineNumber-s.lineNumber),c=[];for(let s=0,v=t.length;s<v;s++){const f=t[s].lineNumber;if(s>0&&t[s-1].lineNumber===f)continue;const S=t[s].oldContent,p=this.getLineContent(f);p.length===0||p===S||N.$mf(p)!==-1||c.push(f)}}return this.m.fire(),new R.$Iv(l,r,c)}s($){return $.length<1e3?$:[this._toSingleEditOperation($)]}_toSingleEditOperation($){let y=!1;const w=$[0].range,h=$[$.length-1].range,g=new L.$tt(w.startLineNumber,w.startColumn,h.endLineNumber,h.endColumn);let a=w.startLineNumber,n=w.startColumn;const i=[];for(let r=0,c=$.length;r<c;r++){const s=$[r],v=s.range;y=y||s.forceMoveMarkers,i.push(this.getValueInRange(new L.$tt(a,n,v.startLineNumber,v.startColumn))),s.text.length>0&&i.push(s.text),a=v.endLineNumber,n=v.endColumn}const u=i.join(""),[o,t,l]=(0,b.$Wt)(u);return{sortIndex:0,identifier:$[0].identifier,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g,0),text:u,eolCount:o,firstLineLength:t,lastLineLength:l,forceMoveMarkers:y,isAutoWhitespaceEdit:!1}}t($){$.sort(A.w);const y=[];for(let w=0;w<$.length;w++){const h=$[w],g=h.range.startLineNumber,a=h.range.startColumn,n=h.range.endLineNumber,i=h.range.endColumn;if(g===n&&a===i&&h.text.length===0)continue;h.text?(this.c.delete(h.rangeOffset,h.rangeLength),this.c.insert(h.rangeOffset,h.text,!0)):this.c.delete(h.rangeOffset,h.rangeLength);const u=new L.$tt(g,a,n,i);y.push({range:u,rangeLength:h.rangeLength,text:h.text,rangeOffset:h.rangeOffset,forceMoveMarkers:h.forceMoveMarkers})}return y}findMatchesLineByLine($,y,w,h){return this.c.findMatchesLineByLine($,y,w,h)}getPieceTree(){return this.c}static _getInverseEditRange($,y){const w=$.startLineNumber,h=$.startColumn,[g,a,n]=(0,b.$Wt)(y);let i;if(y.length>0){const u=g+1;u===1?i=new L.$tt(w,h,w,h+a):i=new L.$tt(w,h,w+u-1,n+1)}else i=new L.$tt(w,h,w,h);return i}static _getInverseEditRanges($){const y=[];let w=0,h=0,g=null;for(let a=0,n=$.length;a<n;a++){const i=$[a];let u,o;g?g.range.endLineNumber===i.range.startLineNumber?(u=w,o=h+(i.range.startColumn-g.range.endColumn)):(u=w+(i.range.startLineNumber-g.range.endLineNumber),o=i.range.startColumn):(u=i.range.startLineNumber,o=i.range.startColumn);let t;if(i.text.length>0){const l=i.eolCount+1;l===1?t=new L.$tt(u,o,u,o+i.firstLineLength):t=new L.$tt(u,o,u+l-1,i.lastLineLength+1)}else t=new L.$tt(u,o,u,o);w=t.endLineNumber,h=t.endColumn,y.push(t),g=i}return y}static u($,y){const w=L.$tt.compareRangesUsingEnds($.range,y.range);return w===0?$.sortIndex-y.sortIndex:w}static w($,y){const w=L.$tt.compareRangesUsingEnds($.range,y.range);return w===0?y.sortIndex-$.sortIndex:-w}}e.$TC=A}),define(ke[205],Pe([1,0,14,131,204]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=void 0;class R{constructor(m,E,A,D,$,y,w,h,g){this.a=m,this.b=E,this.c=A,this.d=D,this.e=$,this.f=y,this.g=w,this.h=h,this.j=g}k(m){const E=this.c+this.d+this.e,A=this.c+this.e;return E===0?m===1?`
`:`\r
`:A>E/2?`\r
`:`
`}create(m){const E=this.k(m),A=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let $=0,y=A.length;$<y;$++){const w=A[$].buffer.replace(/\r\n|\r|\n/g,E),h=(0,N.$OC)(w);A[$]=new N.$RC(w,h)}const D=new L.$TC(A,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(m){return this.a[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(m){if(m.length===0)return;this.a.length===0&&d.$Vf(m)&&(this.b=d.$Uf,m=m.substr(1));const E=m.charCodeAt(m.length-1);E===13||E>=55296&&E<=56319?(this.m(m.substr(0,m.length-1),!1),this.c=!0,this.d=E):(this.m(m,!1),this.c=!1,this.d=E)}m(m,E){!E&&m.length===0||(this.c?this.n(String.fromCharCode(this.d)+m):this.n(m))}n(m){const E=(0,N.$PC)(this.e,m);this.a.push(new N.$RC(m,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=d.$Lf(m)),this.k||(this.k=d.$Of(m)))}finish(m=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,m)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const m=this.a[this.a.length-1];m.buffer+=String.fromCharCode(this.d);const E=(0,N.$OC)(m.buffer);m.lineStarts=E,this.d===13&&this.f++}}}e.$UC=M}),define(ke[135],Pe([1,0,21,12]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bb=m,e.$8bb=A;var L;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(L||(L={}));function R(D){for(let $=0,y=D.length;$<y;$+=4){const w=D[$+0],h=D[$+1],g=D[$+2],a=D[$+3];D[$+0]=a,D[$+1]=g,D[$+2]=h,D[$+3]=w}}function M(D){const $=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return N.$D()||R($),d.$Fe.wrap($)}function b(D){const $=D.buffer;if(N.$D()||R($),$.byteOffset%4===0)return new Uint32Array($.buffer,$.byteOffset,$.length/4);{const y=new Uint8Array($.byteLength);return y.set($),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function m(D){const $=new Uint32Array(E(D));let y=0;if($[y++]=D.id,D.type==="full")$[y++]=1,$[y++]=D.data.length,$.set(D.data,y),y+=D.data.length;else{$[y++]=2,$[y++]=D.deltas.length;for(const w of D.deltas)$[y++]=w.start,$[y++]=w.deleteCount,w.data?($[y++]=w.data.length,$.set(w.data,y),y+=w.data.length):$[y++]=0}return M($)}function E(D){let $=0;if($+=2,D.type==="full")$+=1+D.data.length;else{$+=1,$+=3*D.deltas.length;for(const y of D.deltas)y.data&&($+=y.data.length)}return $}function A(D){const $=b(D);let y=0;const w=$[y++];if($[y++]===1){const n=$[y++],i=$.subarray(y,y+n);return y+=n,{id:w,type:"full",data:i}}const g=$[y++],a=[];for(let n=0;n<g;n++){const i=$[y++],u=$[y++],o=$[y++];let t;o>0&&(t=$.subarray(y,y+o),y+=o),a[n]={start:i,deleteCount:u,data:t}}return{id:w,type:"delta",deltas:a}}}),define(ke[206],Pe([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(ke[136],Pe([1,0,19,24,12,182,130,206]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=g,e.clampedInt=n,e.clampedFloat=u,e.stringSet=l,e.cursorStyleToString=P,e.filterValidationDecorations=be;var m;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(ce){this.c=ce}hasChanged(ce){return this.c[ce]}}e.ConfigurationChangedEvent=E;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class D{constructor(ce,Re,Ke,Me){this.id=ce,this.name=Re,this.defaultValue=Ke,this.schema=Me}applyUpdate(ce,Re){return y(ce,Re)}compute(ce,Re,Ke){return Ke}}class ${constructor(ce,Re){this.newValue=ce,this.didChange=Re}}e.ApplyUpdateResult=$;function y(ae,ce){if(typeof ae!="object"||typeof ce!="object"||!ae||!ce)return new $(ce,ae!==ce);if(Array.isArray(ae)||Array.isArray(ce)){const Ke=Array.isArray(ae)&&Array.isArray(ce)&&d.$ub(ae,ce);return new $(ce,!Ke)}let Re=!1;for(const Ke in ce)if(ce.hasOwnProperty(Ke)){const Me=y(ae[Ke],ce[Ke]);Me.didChange&&(ae[Ke]=Me.newValue,Re=!0)}return new $(ae,Re)}class w{constructor(ce){this.schema=void 0,this.id=ce,this.name="_never_",this.defaultValue=void 0}applyUpdate(ce,Re){return y(ce,Re)}validate(ce){return this.defaultValue}}class h{constructor(ce,Re,Ke,Me){this.id=ce,this.name=Re,this.defaultValue=Ke,this.schema=Me}applyUpdate(ce,Re){return y(ce,Re)}validate(ce){return typeof ce>"u"?this.defaultValue:ce}compute(ce,Re,Ke){return Ke}}function g(ae,ce){return typeof ae>"u"?ce:ae==="false"?!1:!!ae}class a extends h{constructor(ce,Re,Ke,Me=void 0){typeof Me<"u"&&(Me.type="boolean",Me.default=Ke),super(ce,Re,Ke,Me)}validate(ce){return g(ce,this.defaultValue)}}function n(ae,ce,Re,Ke){if(typeof ae>"u")return ce;let Me=parseInt(ae,10);return isNaN(Me)?ce:(Me=Math.max(Re,Me),Me=Math.min(Ke,Me),Me|0)}class i extends h{static clampedInt(ce,Re,Ke,Me){return n(ce,Re,Ke,Me)}constructor(ce,Re,Ke,Me,it,lt=void 0){typeof lt<"u"&&(lt.type="integer",lt.default=Ke,lt.minimum=Me,lt.maximum=it),super(ce,Re,Ke,lt),this.minimum=Me,this.maximum=it}validate(ce){return i.clampedInt(ce,this.defaultValue,this.minimum,this.maximum)}}function u(ae,ce,Re,Ke){if(typeof ae>"u")return ce;const Me=o.float(ae,ce);return o.clamp(Me,Re,Ke)}class o extends h{static clamp(ce,Re,Ke){return ce<Re?Re:ce>Ke?Ke:ce}static float(ce,Re){if(typeof ce=="number")return ce;if(typeof ce>"u")return Re;const Ke=parseFloat(ce);return isNaN(Ke)?Re:Ke}constructor(ce,Re,Ke,Me,it){typeof it<"u"&&(it.type="number",it.default=Ke),super(ce,Re,Ke,it),this.validationFn=Me}validate(ce){return this.validationFn(o.float(ce,this.defaultValue))}}class t extends h{static string(ce,Re){return typeof ce!="string"?Re:ce}constructor(ce,Re,Ke,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.default=Ke),super(ce,Re,Ke,Me)}validate(ce){return t.string(ce,this.defaultValue)}}function l(ae,ce,Re,Ke){return typeof ae!="string"?ce:Ke&&ae in Ke?Ke[ae]:Re.indexOf(ae)===-1?ce:ae}class r extends h{constructor(ce,Re,Ke,Me,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Me,it.default=Ke),super(ce,Re,Ke,it),this.c=Me}validate(ce){return l(ce,this.defaultValue,this.c)}}class c extends D{constructor(ce,Re,Ke,Me,it,lt,bt=void 0){typeof bt<"u"&&(bt.type="string",bt.enum=it,bt.default=Me),super(ce,Re,Ke,bt),this.c=it,this.d=lt}validate(ce){return typeof ce!="string"?this.defaultValue:this.c.indexOf(ce)===-1?this.defaultValue:this.d(ce)}}function s(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ce){switch(ce){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ce,Re,Ke){return Ke===0?ce.accessibilitySupport:Ke}}class f extends D{constructor(){const ce={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ce,{"editor.comments.insertSpace":{type:"boolean",default:ce.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ce.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{insertSpace:g(Re.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Re.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function p(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var k;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(k||(e.TextEditorCursorStyle=k={}));function P(ae){switch(ae){case k.Line:return"line";case k.Block:return"block";case k.Underline:return"underline";case k.LineThin:return"line-thin";case k.BlockOutline:return"block-outline";case k.UnderlineThin:return"underline-thin"}}function C(ae){switch(ae){case"line":return k.Line;case"block":return k.Block;case"underline":return k.Underline;case"line-thin":return k.LineThin;case"block-outline":return k.BlockOutline;case"underline-thin":return k.UnderlineThin}}class I extends w{constructor(){super(142)}compute(ce,Re,Ke){const Me=["monaco-editor"];return Re.get(39)&&Me.push(Re.get(39)),ce.extraEditorClassName&&Me.push(ce.extraEditorClassName),Re.get(74)==="default"?Me.push("mouse-default"):Re.get(74)==="copy"&&Me.push("mouse-copy"),Re.get(111)&&Me.push("showUnused"),Re.get(140)&&Me.push("showDeprecated"),Me.join(" ")}}class T extends a{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ce,Re,Ke){return Ke&&ce.emptySelectionClipboard}}class j extends D{constructor(){const ce={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ce,{"editor.find.cursorMoveOnType":{type:"boolean",default:ce.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ce.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ce.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ce.globalFindClipboard,description:b.localize(16,null),included:L.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ce.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ce.loop,description:b.localize(18,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{cursorMoveOnType:g(Re.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ce.seedSearchStringFromSelection=="boolean"?ce.seedSearchStringFromSelection?"always":"never":l(Re.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ce.autoFindInSelection=="boolean"?ce.autoFindInSelection?"always":"never":l(Re.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Re.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Re.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Re.loop,this.defaultValue.loop)}}}class z extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"||ce.length===0?z.OFF:ce==="true"?z.ON:ce:ce?z.ON:z.OFF}}e.EditorFontLigatures=z;class O extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?O.OFF:ce==="true"?O.TRANSLATE:ce:ce?O.TRANSLATE:O.OFF}compute(ce,Re,Ke){return ce.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class F extends w{constructor(){super(50)}compute(ce,Re,Ke){return ce.fontInfo}}class B extends h{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ce){const Re=o.float(ce,this.defaultValue);return Re===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(Re,6,100)}compute(ce,Re,Ke){return ce.fontInfo.fontSize}}class Z extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Z.d,maximum:Z.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ce){return ce==="normal"||ce==="bold"?ce:String(i.clampedInt(ce,e.EDITOR_FONT_DEFAULTS.fontWeight,Z.d,Z.e))}}class q extends D{constructor(){const ce={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Re={type:"string",enum:["peek","gotoAndPeek","goto"],default:ce.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ce,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Re},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Re},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Re},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Re},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Re},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ce.alternativeDefinitionCommand,enum:Ke,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ce.alternativeTypeDefinitionCommand,enum:Ke,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ce.alternativeDeclarationCommand,enum:Ke,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ce.alternativeImplementationCommand,enum:Ke,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ce.alternativeReferenceCommand,enum:Ke,description:b.localize(41,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{multiple:l(Re.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Re.multipleDefinitions??l(Re.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Re.multipleTypeDefinitions??l(Re.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Re.multipleDeclarations??l(Re.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Re.multipleImplementations??l(Re.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Re.multipleReferences??l(Re.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Re.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Re.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Re.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Re.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Re.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Q extends D{constructor(){const ce={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ce,{"editor.hover.enabled":{type:"boolean",default:ce.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ce.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ce.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ce.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ce.above,description:b.localize(46,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:g(Re.enabled,this.defaultValue.enabled),delay:i.clampedInt(Re.delay,this.defaultValue.delay,0,1e4),sticky:g(Re.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Re.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:g(Re.above,this.defaultValue.above)}}}var x;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(x||(e.RenderMinimap=x={}));class X extends w{constructor(){super(145)}compute(ce,Re,Ke){return X.computeLayout(Re,{memory:ce.memory,outerWidth:ce.outerWidth,outerHeight:ce.outerHeight,isDominatedByLongLines:ce.isDominatedByLongLines,lineHeight:ce.fontInfo.lineHeight,viewLineCount:ce.viewLineCount,lineNumbersDigitCount:ce.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ce.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ce.fontInfo.maxDigitWidth,pixelRatio:ce.pixelRatio,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ce){const Re=ce.height/ce.lineHeight,Ke=Math.floor(ce.paddingTop/ce.lineHeight);let Me=Math.floor(ce.paddingBottom/ce.lineHeight);ce.scrollBeyondLastLine&&(Me=Math.max(Me,Re-1));const it=(Ke+ce.viewLineCount+Me)/(ce.pixelRatio*ce.height),lt=Math.floor(ce.viewLineCount/it);return{typicalViewportLineCount:Re,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Me,desiredRatio:it,minimapLineCount:lt}}static c(ce,Re){const Ke=ce.outerWidth,Me=ce.outerHeight,it=ce.pixelRatio;if(!ce.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Me),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Me};const lt=Re.stableMinimapLayoutInput,bt=lt&&ce.outerHeight===lt.outerHeight&&ce.lineHeight===lt.lineHeight&&ce.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&ce.pixelRatio===lt.pixelRatio&&ce.scrollBeyondLastLine===lt.scrollBeyondLastLine&&ce.paddingTop===lt.paddingTop&&ce.paddingBottom===lt.paddingBottom&&ce.minimap.enabled===lt.minimap.enabled&&ce.minimap.side===lt.minimap.side&&ce.minimap.size===lt.minimap.size&&ce.minimap.showSlider===lt.minimap.showSlider&&ce.minimap.renderCharacters===lt.minimap.renderCharacters&&ce.minimap.maxColumn===lt.minimap.maxColumn&&ce.minimap.scale===lt.minimap.scale&&ce.verticalScrollbarWidth===lt.verticalScrollbarWidth&&ce.isViewportWrapping===lt.isViewportWrapping,Ot=ce.lineHeight,Rt=ce.typicalHalfwidthCharacterWidth,sn=ce.scrollBeyondLastLine,Zt=ce.minimap.renderCharacters;let Dt=it>=2?Math.round(ce.minimap.scale*2):ce.minimap.scale;const Xt=ce.minimap.maxColumn,xt=ce.minimap.size,et=ce.minimap.side,on=ce.verticalScrollbarWidth,qt=ce.viewLineCount,dt=ce.remainingWidth,wt=ce.isViewportWrapping,en=Zt?2:3;let Jt=Math.floor(it*Me);const Ft=Jt/it;let gt=!1,Bt=!1,Ht=en*Dt,Gt=Dt/it,xe=1;if(xt==="fill"||xt==="fit"){const{typicalViewportLineCount:Tt,extraLinesBeforeFirstLine:tn,extraLinesBeyondLastLine:Wt,desiredRatio:nn,minimapLineCount:Mt}=X.computeContainedMinimapLineCount({viewLineCount:qt,scrollBeyondLastLine:sn,paddingTop:ce.paddingTop,paddingBottom:ce.paddingBottom,height:Me,lineHeight:Ot,pixelRatio:it});if(qt/Mt>1)gt=!0,Bt=!0,Dt=1,Ht=1,Gt=Dt/it;else{let Nt=!1,Ct=Dt+1;if(xt==="fit"){const $t=Math.ceil((tn+qt+Wt)*Ht);wt&&bt&&dt<=Re.stableFitRemainingWidth?(Nt=!0,Ct=Re.stableFitMaxMinimapScale):Nt=$t>Jt}if(xt==="fill"||Nt){gt=!0;const $t=Dt;Ht=Math.min(Ot*it,Math.max(1,Math.floor(1/nn))),wt&&bt&&dt<=Re.stableFitRemainingWidth&&(Ct=Re.stableFitMaxMinimapScale),Dt=Math.min(Ct,Math.max(1,Math.floor(Ht/en))),Dt>$t&&(xe=Math.min(2,Dt/$t)),Gt=Dt/it/xe,Jt=Math.ceil(Math.max(Tt,tn+qt+Wt)*Ht),wt?(Re.stableMinimapLayoutInput=ce,Re.stableFitRemainingWidth=dt,Re.stableFitMaxMinimapScale=Dt):(Re.stableMinimapLayoutInput=null,Re.stableFitRemainingWidth=0)}}}const dn=Math.floor(Xt*Gt),Qt=Math.min(dn,Math.max(0,Math.floor((dt-on-2)*Gt/(Rt+Gt)))+e.MINIMAP_GUTTER_WIDTH);let zt=Math.floor(it*Qt);const mt=zt/it;zt=Math.floor(zt*xe);const Ut=Zt?1:2,It=et==="left"?0:Ke-Qt-on;return{renderMinimap:Ut,minimapLeft:It,minimapWidth:Qt,minimapHeightIsEditorHeight:gt,minimapIsSampling:Bt,minimapScale:Dt,minimapLineHeight:Ht,minimapCanvasInnerWidth:zt,minimapCanvasInnerHeight:Jt,minimapCanvasOuterWidth:mt,minimapCanvasOuterHeight:Ft}}static computeLayout(ce,Re){const Ke=Re.outerWidth|0,Me=Re.outerHeight|0,it=Re.lineHeight|0,lt=Re.lineNumbersDigitCount|0,bt=Re.typicalHalfwidthCharacterWidth,Ot=Re.maxDigitWidth,Rt=Re.pixelRatio,sn=Re.viewLineCount,Zt=ce.get(137),Dt=Zt==="inherit"?ce.get(136):Zt,Xt=Dt==="inherit"?ce.get(132):Dt,xt=ce.get(135),et=Re.isDominatedByLongLines,on=ce.get(57),qt=ce.get(68).renderType!==0,dt=ce.get(69),wt=ce.get(105),en=ce.get(84),Jt=ce.get(73),Ft=ce.get(103),gt=Ft.verticalScrollbarSize,Bt=Ft.verticalHasArrows,Ht=Ft.arrowSize,Gt=Ft.horizontalScrollbarSize,xe=ce.get(43),dn=ce.get(110)!=="never";let Qt=ce.get(66);xe&&dn&&(Qt+=16);let zt=0;if(qt){const rn=Math.max(lt,dt);zt=Math.round(rn*Ot)}let mt=0;on&&(mt=it*Re.glyphMarginDecorationLaneCount);let Ut=0,It=Ut+mt,Tt=It+zt,tn=Tt+Qt;const Wt=Ke-mt-zt-Qt;let nn=!1,Mt=!1,Lt=-1;Dt==="inherit"&&et?(nn=!0,Mt=!0):Xt==="on"||Xt==="bounded"?Mt=!0:Xt==="wordWrapColumn"&&(Lt=xt);const Nt=X.c({outerWidth:Ke,outerHeight:Me,lineHeight:it,typicalHalfwidthCharacterWidth:bt,pixelRatio:Rt,scrollBeyondLastLine:wt,paddingTop:en.top,paddingBottom:en.bottom,minimap:Jt,verticalScrollbarWidth:gt,viewLineCount:sn,remainingWidth:Wt,isViewportWrapping:Mt},Re.memory||new A);Nt.renderMinimap!==0&&Nt.minimapLeft===0&&(Ut+=Nt.minimapWidth,It+=Nt.minimapWidth,Tt+=Nt.minimapWidth,tn+=Nt.minimapWidth);const Ct=Wt-Nt.minimapWidth,$t=Math.max(1,Math.floor((Ct-gt-2)/bt)),kt=Bt?Ht:0;return Mt&&(Lt=Math.max(1,$t),Xt==="bounded"&&(Lt=Math.min(Lt,xt))),{width:Ke,height:Me,glyphMarginLeft:Ut,glyphMarginWidth:mt,glyphMarginDecorationLaneCount:Re.glyphMarginDecorationLaneCount,lineNumbersLeft:It,lineNumbersWidth:zt,decorationsLeft:Tt,decorationsWidth:Qt,contentLeft:tn,contentWidth:Ct,minimap:Nt,viewportColumn:$t,isWordWrapMinified:nn,isViewportWrapping:Mt,wrappingColumn:Lt,verticalScrollbarWidth:gt,horizontalScrollbarHeight:Gt,overviewRuler:{top:kt,width:gt,height:Me-2*kt,right:0}}}}e.EditorLayoutInfoComputer=X;class ie extends D{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ce){return l(ce,"simple",["simple","advanced"])}compute(ce,Re,Ke){return Re.get(2)===2?"advanced":Ke}}var me;(function(ae){ae.Off="off",ae.OnCode="onCode",ae.On="on"})(me||(e.ShowLightbulbIconMode=me={}));class ue extends D{constructor(){const ce={enabled:me.On};super(65,"lightbulb",ce,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[me.Off,me.OnCode,me.On],default:ce.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{enabled:l(ce.enabled,this.defaultValue.enabled,[me.Off,me.OnCode,me.On])}}}class ve extends D{constructor(){const ce={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ce,{"editor.stickyScroll.enabled":{type:"boolean",default:ce.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ce.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ce.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ce.scrollWithEditor,description:b.localize(57,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:g(Re.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Re.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:l(Re.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:g(Re.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class te extends D{constructor(){const ce={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ce,{"editor.inlayHints.enabled":{type:"string",default:ce.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ce.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ce.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ce.padding,description:b.localize(65,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return typeof Re.enabled=="boolean"&&(Re.enabled=Re.enabled?"on":"off"),{enabled:l(Re.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Re.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Re.fontFamily,this.defaultValue.fontFamily),padding:g(Re.padding,this.defaultValue.padding)}}}class U extends D{constructor(){super(66,"lineDecorationsWidth",10)}validate(ce){return typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)?-parseFloat(ce.substring(0,ce.length-2)):i.clampedInt(ce,this.defaultValue,0,1e3)}compute(ce,Re,Ke){return Ke<0?i.clampedInt(-Ke*ce.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class ee extends o{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ce=>o.clamp(ce,0,150),{markdownDescription:b.localize(66,null)})}compute(ce,Re,Ke){return ce.fontInfo.lineHeight}}class pe extends D{constructor(){const ce={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ce,{"editor.minimap.enabled":{type:"boolean",default:ce.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ce.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:ce.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ce.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ce.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:ce.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ce.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ce.maxColumn,description:b.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ce.showRegionSectionHeaders,description:b.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ce.showMarkSectionHeaders,description:b.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ce.sectionHeaderFontSize,description:b.localize(80,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:g(Re.enabled,this.defaultValue.enabled),autohide:g(Re.autohide,this.defaultValue.autohide),size:l(Re.size,this.defaultValue.size,["proportional","fill","fit"]),side:l(Re.side,this.defaultValue.side,["right","left"]),showSlider:l(Re.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Re.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Re.scale,1,1,3),maxColumn:i.clampedInt(Re.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:g(Re.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:g(Re.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:o.clamp(Re.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Ce(ae){return ae==="ctrlCmd"?L.$j?"metaKey":"ctrlKey":"altKey"}class se extends D{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(82,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{top:i.clampedInt(Re.top,0,0,1e3),bottom:i.clampedInt(Re.bottom,0,0,1e3)}}}class re extends D{constructor(){const ce={enabled:!0,cycle:!0};super(86,"parameterHints",ce,{"editor.parameterHints.enabled":{type:"boolean",default:ce.enabled,description:b.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ce.cycle,description:b.localize(84,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:g(Re.enabled,this.defaultValue.enabled),cycle:g(Re.cycle,this.defaultValue.cycle)}}}class oe extends w{constructor(){super(143)}compute(ce,Re,Ke){return ce.pixelRatio}}class K extends D{constructor(){const ce={other:"on",comments:"off",strings:"off"},Re=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(85,null),b.localize(86,null),b.localize(87,null)]}];super(89,"quickSuggestions",ce,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Re,default:ce.strings,description:b.localize(88,null)},comments:{anyOf:Re,default:ce.comments,description:b.localize(89,null)},other:{anyOf:Re,default:ce.other,description:b.localize(90,null)}},default:ce,markdownDescription:b.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ce}validate(ce){if(typeof ce=="boolean"){const Rt=ce?"on":"off";return{comments:Rt,strings:Rt,other:Rt}}if(!ce||typeof ce!="object")return this.defaultValue;const{other:Re,comments:Ke,strings:Me}=ce,it=["on","inline","off"];let lt,bt,Ot;return typeof Re=="boolean"?lt=Re?"on":"off":lt=l(Re,this.defaultValue.other,it),typeof Ke=="boolean"?bt=Ke?"on":"off":bt=l(Ke,this.defaultValue.comments,it),typeof Me=="boolean"?Ot=Me?"on":"off":Ot=l(Me,this.defaultValue.strings,it),{other:lt,comments:bt,strings:Ot}}}var ne;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(ne||(e.RenderLineNumbersType=ne={}));class $e extends D{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(92,null),b.localize(93,null),b.localize(94,null),b.localize(95,null)],default:"on",description:b.localize(96,null)})}validate(ce){let Re=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ce<"u"&&(typeof ce=="function"?(Re=4,Ke=ce):ce==="interval"?Re=3:ce==="relative"?Re=2:ce==="on"?Re=1:Re=0),{renderType:Re,renderFn:Ke}}}function be(ae){const ce=ae.get(98);return ce==="editable"?ae.get(91):ce!=="on"}class Ae extends D{constructor(){const ce=[],Re={type:"number",description:b.localize(97,null)};super(102,"rulers",ce,{type:"array",items:{anyOf:[Re,{type:["object"],properties:{column:Re,color:{type:"string",description:b.localize(98,null),format:"color-hex"}}}]},default:ce,description:b.localize(99,null)})}validate(ce){if(Array.isArray(ce)){const Re=[];for(const Ke of ce)if(typeof Ke=="number")Re.push({column:i.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Me=Ke;Re.push({column:i.clampedInt(Me.column,0,0,1e4),color:Me.color})}return Re.sort((Ke,Me)=>Ke.column-Me.column),Re}return this.defaultValue}}class fe extends D{constructor(){super(92,"readOnlyMessage",void 0)}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:ce}}function Se(ae,ce){if(typeof ae!="string")return ce;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ie extends D{constructor(){const ce={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ce,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(100,null),b.localize(101,null),b.localize(102,null)],default:"auto",description:b.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(104,null),b.localize(105,null),b.localize(106,null)],default:"auto",description:b.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ce.verticalScrollbarSize,description:b.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ce.horizontalScrollbarSize,description:b.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ce.scrollByPage,description:b.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ce.ignoreHorizontalScrollbarInContentHeight,description:b.localize(111,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce,Ke=i.clampedInt(Re.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Me=i.clampedInt(Re.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Re.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Se(Re.vertical,this.defaultValue.vertical),horizontal:Se(Re.horizontal,this.defaultValue.horizontal),useShadows:g(Re.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Re.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Re.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Re.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Re.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:i.clampedInt(Re.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Me,verticalSliderSize:i.clampedInt(Re.verticalSliderSize,Me,0,1e3),scrollByPage:g(Re.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:g(Re.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends D{constructor(){const ce={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ce,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.nonBasicASCII,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ce.invisibleCharacters,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ce.ambiguousCharacters,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeComments,description:b.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeStrings,description:b.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ce.allowedCharacters,description:b.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ce.allowedLocales,description:b.localize(118,null)}})}applyUpdate(ce,Re){let Ke=!1;Re.allowedCharacters&&ce&&(N.$6n(ce.allowedCharacters,Re.allowedCharacters)||(ce={...ce,allowedCharacters:Re.allowedCharacters},Ke=!0)),Re.allowedLocales&&ce&&(N.$6n(ce.allowedLocales,Re.allowedLocales)||(ce={...ce,allowedLocales:Re.allowedLocales},Ke=!0));const Me=super.applyUpdate(ce,Re);return Ke?new $(Me.newValue,!0):Me}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{nonBasicASCII:he(Re.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Re.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Re.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(Re.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(Re.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ce.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ce.allowedLocales,this.defaultValue.allowedLocales)}}c(ce,Re){if(typeof ce!="object"||!ce)return Re;const Ke={};for(const[Me,it]of Object.entries(ce))it===!0&&(Ke[Me]=!0);return Ke}}class V extends D{constructor(){const ce={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ce,{"editor.inlineSuggest.enabled":{type:"boolean",default:ce.enabled,description:b.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],description:b.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ce.suppressSuggestions,description:b.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ce.fontFamily,description:b.localize(125,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:g(Re.enabled,this.defaultValue.enabled),mode:l(Re.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:l(Re.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:g(Re.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:g(Re.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Re.fontFamily,this.defaultValue.fontFamily)}}}class W extends D{constructor(){const ce={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ce,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ce.enabled,description:b.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ce.fontFamily,description:b.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ce.backgroundColoring,description:b.localize(132,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:g(Re.enabled,this.defaultValue.enabled),showToolbar:l(Re.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Re.fontFamily,this.defaultValue.fontFamily),keepOnBlur:g(Re.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:g(Re.backgroundColoring,this.defaultValue.backgroundColoring)}}}class J extends D{constructor(){const ce={enabled:R.$3s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$3s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ce,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ce.independentColorPoolPerBracketType,description:b.localize(134,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:g(Re.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(Re.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Y extends D{constructor(){const ce={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ce,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:ce.bracketPairs,description:b.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null)],default:ce.bracketPairsHorizontal,description:b.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ce.highlightActiveBracketPair,description:b.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ce.indentation,description:b.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:ce.highlightActiveIndentation,description:b.localize(148,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{bracketPairs:he(Re.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(Re.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Re.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Re.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(Re.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(ae,ce,Re){const Ke=Re.indexOf(ae);return Ke===-1?ce:Re[Ke]}class we extends D{constructor(){const ce={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ce,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(149,null),b.localize(150,null)],default:ce.insertMode,description:b.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ce.filterGraceful,description:b.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ce.localityBonus,description:b.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ce.shareSuggestSelections,markdownDescription:b.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(155,null),b.localize(156,null),b.localize(157,null),b.localize(158,null)],default:ce.selectionMode,markdownDescription:b.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ce.snippetsPreventQuickSuggestions,description:b.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ce.showIcons,description:b.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ce.showStatusBar,description:b.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ce.preview,description:b.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ce.showInlineDetails,description:b.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(196,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{insertMode:l(Re.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Re.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Re.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Re.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Re.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:l(Re.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:g(Re.showIcons,this.defaultValue.showIcons),showStatusBar:g(Re.showStatusBar,this.defaultValue.showStatusBar),preview:g(Re.preview,this.defaultValue.preview),previewMode:l(Re.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Re.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Re.showMethods,this.defaultValue.showMethods),showFunctions:g(Re.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Re.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Re.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(Re.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(Re.showFields,this.defaultValue.showFields),showVariables:g(Re.showVariables,this.defaultValue.showVariables),showClasses:g(Re.showClasses,this.defaultValue.showClasses),showStructs:g(Re.showStructs,this.defaultValue.showStructs),showInterfaces:g(Re.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Re.showModules,this.defaultValue.showModules),showProperties:g(Re.showProperties,this.defaultValue.showProperties),showEvents:g(Re.showEvents,this.defaultValue.showEvents),showOperators:g(Re.showOperators,this.defaultValue.showOperators),showUnits:g(Re.showUnits,this.defaultValue.showUnits),showValues:g(Re.showValues,this.defaultValue.showValues),showConstants:g(Re.showConstants,this.defaultValue.showConstants),showEnums:g(Re.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Re.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Re.showKeywords,this.defaultValue.showKeywords),showWords:g(Re.showWords,this.defaultValue.showWords),showColors:g(Re.showColors,this.defaultValue.showColors),showFiles:g(Re.showFiles,this.defaultValue.showFiles),showReferences:g(Re.showReferences,this.defaultValue.showReferences),showFolders:g(Re.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Re.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Re.showSnippets,this.defaultValue.showSnippets),showUsers:g(Re.showUsers,this.defaultValue.showUsers),showIssues:g(Re.showIssues,this.defaultValue.showIssues)}}}class je extends D{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(198,null),default:!0,type:"boolean"}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(ce.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:g(ce.selectSubwords,this.defaultValue.selectSubwords)}}}class qe extends D{constructor(){const ce=[];super(130,"wordSegmenterLocales",ce,{anyOf:[{description:b.localize(199,null),type:"string"},{description:b.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ce){if(typeof ce=="string"&&(ce=[ce]),Array.isArray(ce)){const Re=[];for(const Ke of ce)if(typeof Ke=="string")try{Intl.Segmenter.supportedLocalesOf(Ke).length>0&&Re.push(Ke)}catch{}return Re}return this.defaultValue}}var Ye;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(Ye||(e.WrappingIndent=Ye={}));class st extends D{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(201,null),b.localize(202,null),b.localize(203,null),b.localize(204,null)],description:b.localize(205,null),default:"same"}})}validate(ce){switch(ce){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ce,Re,Ke){return Re.get(2)===2?0:Ke}}class tt extends w{constructor(){super(146)}compute(ce,Re,Ke){const Me=Re.get(145);return{isDominatedByLongLines:ce.isDominatedByLongLines,isWordWrapMinified:Me.isWordWrapMinified,isViewportWrapping:Me.isViewportWrapping,wrappingColumn:Me.wrappingColumn}}}class nt extends D{constructor(){const ce={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ce,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(208,null),b.localize(209,null)],default:"afterDrop"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:g(Re.enabled,this.defaultValue.enabled),showDropSelector:l(Re.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ot extends D{constructor(){const ce={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ce,{"editor.pasteAs.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(212,null),b.localize(213,null)],default:"afterPaste"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Re=ce;return{enabled:g(Re.enabled,this.defaultValue.enabled),showPasteSelector:l(Re.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const De="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.$j?Be:L.$k?Ge:De,fontWeight:"normal",fontSize:L.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var Ze;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.ariaRequired=5]="ariaRequired",ae[ae.autoClosingBrackets=6]="autoClosingBrackets",ae[ae.autoClosingComments=7]="autoClosingComments",ae[ae.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ae[ae.autoClosingDelete=9]="autoClosingDelete",ae[ae.autoClosingOvertype=10]="autoClosingOvertype",ae[ae.autoClosingQuotes=11]="autoClosingQuotes",ae[ae.autoIndent=12]="autoIndent",ae[ae.automaticLayout=13]="automaticLayout",ae[ae.autoSurround=14]="autoSurround",ae[ae.bracketPairColorization=15]="bracketPairColorization",ae[ae.guides=16]="guides",ae[ae.codeLens=17]="codeLens",ae[ae.codeLensFontFamily=18]="codeLensFontFamily",ae[ae.codeLensFontSize=19]="codeLensFontSize",ae[ae.colorDecorators=20]="colorDecorators",ae[ae.colorDecoratorsLimit=21]="colorDecoratorsLimit",ae[ae.columnSelection=22]="columnSelection",ae[ae.comments=23]="comments",ae[ae.contextmenu=24]="contextmenu",ae[ae.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=26]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=28]="cursorStyle",ae[ae.cursorSurroundingLines=29]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=31]="cursorWidth",ae[ae.disableLayerHinting=32]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ae[ae.domReadOnly=34]="domReadOnly",ae[ae.dragAndDrop=35]="dragAndDrop",ae[ae.dropIntoEditor=36]="dropIntoEditor",ae[ae.emptySelectionClipboard=37]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=39]="extraEditorClassName",ae[ae.fastScrollSensitivity=40]="fastScrollSensitivity",ae[ae.find=41]="find",ae[ae.fixedOverflowWidgets=42]="fixedOverflowWidgets",ae[ae.folding=43]="folding",ae[ae.foldingStrategy=44]="foldingStrategy",ae[ae.foldingHighlight=45]="foldingHighlight",ae[ae.foldingImportsByDefault=46]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=47]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=49]="fontFamily",ae[ae.fontInfo=50]="fontInfo",ae[ae.fontLigatures=51]="fontLigatures",ae[ae.fontSize=52]="fontSize",ae[ae.fontWeight=53]="fontWeight",ae[ae.fontVariations=54]="fontVariations",ae[ae.formatOnPaste=55]="formatOnPaste",ae[ae.formatOnType=56]="formatOnType",ae[ae.glyphMargin=57]="glyphMargin",ae[ae.gotoLocation=58]="gotoLocation",ae[ae.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ae[ae.hover=60]="hover",ae[ae.inDiffEditor=61]="inDiffEditor",ae[ae.inlineSuggest=62]="inlineSuggest",ae[ae.inlineEdit=63]="inlineEdit",ae[ae.letterSpacing=64]="letterSpacing",ae[ae.lightbulb=65]="lightbulb",ae[ae.lineDecorationsWidth=66]="lineDecorationsWidth",ae[ae.lineHeight=67]="lineHeight",ae[ae.lineNumbers=68]="lineNumbers",ae[ae.lineNumbersMinChars=69]="lineNumbersMinChars",ae[ae.linkedEditing=70]="linkedEditing",ae[ae.links=71]="links",ae[ae.matchBrackets=72]="matchBrackets",ae[ae.minimap=73]="minimap",ae[ae.mouseStyle=74]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=76]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=78]="multiCursorModifier",ae[ae.multiCursorPaste=79]="multiCursorPaste",ae[ae.multiCursorLimit=80]="multiCursorLimit",ae[ae.occurrencesHighlight=81]="occurrencesHighlight",ae[ae.overviewRulerBorder=82]="overviewRulerBorder",ae[ae.overviewRulerLanes=83]="overviewRulerLanes",ae[ae.padding=84]="padding",ae[ae.pasteAs=85]="pasteAs",ae[ae.parameterHints=86]="parameterHints",ae[ae.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=89]="quickSuggestions",ae[ae.quickSuggestionsDelay=90]="quickSuggestionsDelay",ae[ae.readOnly=91]="readOnly",ae[ae.readOnlyMessage=92]="readOnlyMessage",ae[ae.renameOnType=93]="renameOnType",ae[ae.renderControlCharacters=94]="renderControlCharacters",ae[ae.renderFinalNewline=95]="renderFinalNewline",ae[ae.renderLineHighlight=96]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=98]="renderValidationDecorations",ae[ae.renderWhitespace=99]="renderWhitespace",ae[ae.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ae[ae.roundedSelection=101]="roundedSelection",ae[ae.rulers=102]="rulers",ae[ae.scrollbar=103]="scrollbar",ae[ae.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=105]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=106]="scrollPredominantAxis",ae[ae.selectionClipboard=107]="selectionClipboard",ae[ae.selectionHighlight=108]="selectionHighlight",ae[ae.selectOnLineNumbers=109]="selectOnLineNumbers",ae[ae.showFoldingControls=110]="showFoldingControls",ae[ae.showUnused=111]="showUnused",ae[ae.snippetSuggestions=112]="snippetSuggestions",ae[ae.smartSelect=113]="smartSelect",ae[ae.smoothScrolling=114]="smoothScrolling",ae[ae.stickyScroll=115]="stickyScroll",ae[ae.stickyTabStops=116]="stickyTabStops",ae[ae.stopRenderingLineAfter=117]="stopRenderingLineAfter",ae[ae.suggest=118]="suggest",ae[ae.suggestFontSize=119]="suggestFontSize",ae[ae.suggestLineHeight=120]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ae[ae.suggestSelection=122]="suggestSelection",ae[ae.tabCompletion=123]="tabCompletion",ae[ae.tabIndex=124]="tabIndex",ae[ae.unicodeHighlighting=125]="unicodeHighlighting",ae[ae.unusualLineTerminators=126]="unusualLineTerminators",ae[ae.useShadowDOM=127]="useShadowDOM",ae[ae.useTabStops=128]="useTabStops",ae[ae.wordBreak=129]="wordBreak",ae[ae.wordSegmenterLocales=130]="wordSegmenterLocales",ae[ae.wordSeparators=131]="wordSeparators",ae[ae.wordWrap=132]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=135]="wordWrapColumn",ae[ae.wordWrapOverride1=136]="wordWrapOverride1",ae[ae.wordWrapOverride2=137]="wordWrapOverride2",ae[ae.wrappingIndent=138]="wrappingIndent",ae[ae.wrappingStrategy=139]="wrappingStrategy",ae[ae.showDeprecated=140]="showDeprecated",ae[ae.inlayHints=141]="inlayHints",ae[ae.editorClassName=142]="editorClassName",ae[ae.pixelRatio=143]="pixelRatio",ae[ae.tabFocusMode=144]="tabFocusMode",ae[ae.layoutInfo=145]="layoutInfo",ae[ae.wrappingInfo=146]="wrappingInfo",ae[ae.defaultColorDecorators=147]="defaultColorDecorators",ae[ae.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",ae[ae.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Ze||(e.EditorOption=Ze={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(214,null)})),acceptSuggestionOnEnter:Ne(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(215,null),""],markdownDescription:b.localize(216,null)})),accessibilitySupport:Ne(new v),accessibilityPageSize:Ne(new i(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(217,null),tags:["accessibility"]})),ariaLabel:Ne(new t(4,"ariaLabel",b.localize(218,null))),ariaRequired:Ne(new a(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new a(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(220,null),b.localize(221,null),""],description:b.localize(222,null)})),autoClosingComments:Ne(new r(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),autoClosingDelete:Ne(new r(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(226,null),""],description:b.localize(227,null)})),autoClosingOvertype:Ne(new r(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(228,null),""],description:b.localize(229,null)})),autoClosingQuotes:Ne(new r(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(230,null),b.localize(231,null),""],description:b.localize(232,null)})),autoIndent:Ne(new c(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[b.localize(233,null),b.localize(234,null),b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),automaticLayout:Ne(new a(13,"automaticLayout",!1)),autoSurround:Ne(new r(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null),""],description:b.localize(242,null)})),bracketPairColorization:Ne(new J),bracketPairGuides:Ne(new Y),stickyTabStops:Ne(new a(116,"stickyTabStops",!1,{description:b.localize(243,null)})),codeLens:Ne(new a(17,"codeLens",!0,{description:b.localize(244,null)})),codeLensFontFamily:Ne(new t(18,"codeLensFontFamily","",{description:b.localize(245,null)})),codeLensFontSize:Ne(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(246,null)})),colorDecorators:Ne(new a(20,"colorDecorators",!0,{description:b.localize(247,null)})),colorDecoratorActivatedOn:Ne(new r(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(248,null),b.localize(249,null),b.localize(250,null)],description:b.localize(251,null)})),colorDecoratorsLimit:Ne(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(252,null)})),columnSelection:Ne(new a(22,"columnSelection",!1,{description:b.localize(253,null)})),comments:Ne(new f),contextmenu:Ne(new a(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new a(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(254,null)})),cursorBlinking:Ne(new c(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],p,{description:b.localize(255,null)})),cursorSmoothCaretAnimation:Ne(new r(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(256,null),b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),cursorStyle:Ne(new c(28,"cursorStyle",k.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:b.localize(260,null)})),cursorSurroundingLines:Ne(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(261,null)})),cursorSurroundingLinesStyle:Ne(new r(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(262,null),b.localize(263,null)],markdownDescription:b.localize(264,null)})),cursorWidth:Ne(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(265,null)})),disableLayerHinting:Ne(new a(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new a(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new a(34,"domReadOnly",!1)),dragAndDrop:Ne(new a(35,"dragAndDrop",!0,{description:b.localize(266,null)})),emptySelectionClipboard:Ne(new T),dropIntoEditor:Ne(new nt),stickyScroll:Ne(new ve),experimentalWhitespaceRendering:Ne(new r(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(267,null),b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),extraEditorClassName:Ne(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ne(new o(40,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:b.localize(271,null)})),find:Ne(new j),fixedOverflowWidgets:Ne(new a(42,"fixedOverflowWidgets",!1)),folding:Ne(new a(43,"folding",!0,{description:b.localize(272,null)})),foldingStrategy:Ne(new r(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(273,null),b.localize(274,null)],description:b.localize(275,null)})),foldingHighlight:Ne(new a(45,"foldingHighlight",!0,{description:b.localize(276,null)})),foldingImportsByDefault:Ne(new a(46,"foldingImportsByDefault",!1,{description:b.localize(277,null)})),foldingMaximumRegions:Ne(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ne(new a(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(279,null)})),fontFamily:Ne(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(280,null)})),fontInfo:Ne(new F),fontLigatures2:Ne(new z),fontSize:Ne(new B),fontWeight:Ne(new Z),fontVariations:Ne(new O),formatOnPaste:Ne(new a(55,"formatOnPaste",!1,{description:b.localize(281,null)})),formatOnType:Ne(new a(56,"formatOnType",!1,{description:b.localize(282,null)})),glyphMargin:Ne(new a(57,"glyphMargin",!0,{description:b.localize(283,null)})),gotoLocation:Ne(new q),hideCursorInOverviewRuler:Ne(new a(59,"hideCursorInOverviewRuler",!1,{description:b.localize(284,null)})),hover:Ne(new Q),inDiffEditor:Ne(new a(61,"inDiffEditor",!1)),letterSpacing:Ne(new o(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>o.clamp(ae,-5,20),{description:b.localize(285,null)})),lightbulb:Ne(new ue),lineDecorationsWidth:Ne(new U),lineHeight:Ne(new ee),lineNumbers:Ne(new $e),lineNumbersMinChars:Ne(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new a(70,"linkedEditing",!1,{description:b.localize(286,null)})),links:Ne(new a(71,"links",!0,{description:b.localize(287,null)})),matchBrackets:Ne(new r(72,"matchBrackets","always",["always","near","never"],{description:b.localize(288,null)})),minimap:Ne(new pe),mouseStyle:Ne(new r(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new o(75,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:b.localize(289,null)})),mouseWheelZoom:Ne(new a(76,"mouseWheelZoom",!1,{markdownDescription:L.$j?b.localize(290,null):b.localize(291,null)})),multiCursorMergeOverlapping:Ne(new a(77,"multiCursorMergeOverlapping",!0,{description:b.localize(292,null)})),multiCursorModifier:Ne(new c(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ce,{markdownEnumDescriptions:[b.localize(293,null),b.localize(294,null)],markdownDescription:b.localize(295,null)})),multiCursorPaste:Ne(new r(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),multiCursorLimit:Ne(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(299,null)})),occurrencesHighlight:Ne(new r(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(300,null),b.localize(301,null),b.localize(302,null)],markdownDescription:b.localize(303,null)})),overviewRulerBorder:Ne(new a(82,"overviewRulerBorder",!0,{description:b.localize(304,null)})),overviewRulerLanes:Ne(new i(83,"overviewRulerLanes",3,0,3)),padding:Ne(new se),pasteAs:Ne(new ot),parameterHints:Ne(new re),peekWidgetDefaultFocus:Ne(new r(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(305,null),b.localize(306,null)],description:b.localize(307,null)})),definitionLinkOpensInPeek:Ne(new a(88,"definitionLinkOpensInPeek",!1,{description:b.localize(308,null)})),quickSuggestions:Ne(new K),quickSuggestionsDelay:Ne(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(309,null)})),readOnly:Ne(new a(91,"readOnly",!1)),readOnlyMessage:Ne(new fe),renameOnType:Ne(new a(93,"renameOnType",!1,{description:b.localize(310,null),markdownDeprecationMessage:b.localize(311,null)})),renderControlCharacters:Ne(new a(94,"renderControlCharacters",!0,{description:b.localize(312,null),restricted:!0})),renderFinalNewline:Ne(new r(95,"renderFinalNewline",L.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(313,null)})),renderLineHighlight:Ne(new r(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(314,null)],description:b.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ne(new a(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(316,null)})),renderValidationDecorations:Ne(new r(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new r(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(317,null),b.localize(318,null),b.localize(319,null),""],description:b.localize(320,null)})),revealHorizontalRightPadding:Ne(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new a(101,"roundedSelection",!0,{description:b.localize(321,null)})),rulers:Ne(new Ae),scrollbar:Ne(new Ie),scrollBeyondLastColumn:Ne(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(322,null)})),scrollBeyondLastLine:Ne(new a(105,"scrollBeyondLastLine",!0,{description:b.localize(323,null)})),scrollPredominantAxis:Ne(new a(106,"scrollPredominantAxis",!0,{description:b.localize(324,null)})),selectionClipboard:Ne(new a(107,"selectionClipboard",!0,{description:b.localize(325,null),included:L.$k})),selectionHighlight:Ne(new a(108,"selectionHighlight",!0,{description:b.localize(326,null)})),selectOnLineNumbers:Ne(new a(109,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new r(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(327,null),b.localize(328,null),b.localize(329,null)],description:b.localize(330,null)})),showUnused:Ne(new a(111,"showUnused",!0,{description:b.localize(331,null)})),showDeprecated:Ne(new a(140,"showDeprecated",!0,{description:b.localize(332,null)})),inlayHints:Ne(new te),snippetSuggestions:Ne(new r(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),smartSelect:Ne(new je),smoothScrolling:Ne(new a(114,"smoothScrolling",!1,{description:b.localize(338,null)})),stopRenderingLineAfter:Ne(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new we),inlineSuggest:Ne(new V),inlineEdit:Ne(new W),inlineCompletionsAccessibilityVerbose:Ne(new a(149,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(339,null)})),suggestFontSize:Ne(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new a(121,"suggestOnTriggerCharacters",!0,{description:b.localize(342,null)})),suggestSelection:Ne(new r(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),tabCompletion:Ne(new r(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null)],description:b.localize(350,null)})),tabIndex:Ne(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new ze),unusualLineTerminators:Ne(new r(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(351,null),b.localize(352,null),b.localize(353,null)],description:b.localize(354,null)})),useShadowDOM:Ne(new a(127,"useShadowDOM",!0)),useTabStops:Ne(new a(128,"useTabStops",!0,{description:b.localize(355,null)})),wordBreak:Ne(new r(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(356,null),b.localize(357,null)],description:b.localize(358,null)})),wordSegmenterLocales:Ne(new qe),wordSeparators:Ne(new t(131,"wordSeparators",M.$4s,{description:b.localize(359,null)})),wordWrap:Ne(new r(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(360,null),b.localize(361,null),b.localize(362,null),b.localize(363,null)],description:b.localize(364,null)})),wordWrapBreakAfterCharacters:Ne(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(365,null)})),wordWrapOverride1:Ne(new r(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new r(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new I),defaultColorDecorators:Ne(new a(147,"defaultColorDecorators",!1,{markdownDescription:b.localize(366,null)})),pixelRatio:Ne(new oe),tabFocusMode:Ne(new a(144,"tabFocusMode",!1,{markdownDescription:b.localize(367,null)})),layoutInfo:Ne(new X),wrappingInfo:Ne(new tt),wrappingIndent:Ne(new st),wrappingStrategy:Ne(new ie)}}),define(ke[207],Pe([9,10]),function(le,e){return le.create("vs/editor/common/languages",e)}),define(ke[84],Pe([1,0,79,2,180,29,190,207]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$eu=e.$du=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$cu=e.$bu=e.SymbolKinds=e.SymbolTag=e.$_t=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$0t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$9t=e.$8t=e.$7t=void 0,e.$$t=r,e.$au=s;class m{constructor(Q,x,X){this.offset=Q,this.type=x,this.language=X,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$7t=m;class E{constructor(Q,x){this.tokens=Q,this.endState=x,this._tokenizationResultBrand=void 0}}e.$8t=E;class A{constructor(Q,x){this.tokens=Q,this.endState=x,this._encodedTokenizationResultBrand=void 0}}e.$9t=A;var D;(function(q){q[q.Increase=0]="Increase",q[q.Decrease=1]="Decrease"})(D||(e.HoverVerbosityAction=D={}));var $;(function(q){q[q.Method=0]="Method",q[q.Function=1]="Function",q[q.Constructor=2]="Constructor",q[q.Field=3]="Field",q[q.Variable=4]="Variable",q[q.Class=5]="Class",q[q.Struct=6]="Struct",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Event=10]="Event",q[q.Operator=11]="Operator",q[q.Unit=12]="Unit",q[q.Value=13]="Value",q[q.Constant=14]="Constant",q[q.Enum=15]="Enum",q[q.EnumMember=16]="EnumMember",q[q.Keyword=17]="Keyword",q[q.Text=18]="Text",q[q.Color=19]="Color",q[q.File=20]="File",q[q.Reference=21]="Reference",q[q.Customcolor=22]="Customcolor",q[q.Folder=23]="Folder",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue",q[q.Snippet=27]="Snippet"})($||(e.CompletionItemKind=$={}));var y;(function(q){const Q=new Map;Q.set(0,d.$Uj.symbolMethod),Q.set(1,d.$Uj.symbolFunction),Q.set(2,d.$Uj.symbolConstructor),Q.set(3,d.$Uj.symbolField),Q.set(4,d.$Uj.symbolVariable),Q.set(5,d.$Uj.symbolClass),Q.set(6,d.$Uj.symbolStruct),Q.set(7,d.$Uj.symbolInterface),Q.set(8,d.$Uj.symbolModule),Q.set(9,d.$Uj.symbolProperty),Q.set(10,d.$Uj.symbolEvent),Q.set(11,d.$Uj.symbolOperator),Q.set(12,d.$Uj.symbolUnit),Q.set(13,d.$Uj.symbolValue),Q.set(15,d.$Uj.symbolEnum),Q.set(14,d.$Uj.symbolConstant),Q.set(15,d.$Uj.symbolEnum),Q.set(16,d.$Uj.symbolEnumMember),Q.set(17,d.$Uj.symbolKeyword),Q.set(27,d.$Uj.symbolSnippet),Q.set(18,d.$Uj.symbolText),Q.set(19,d.$Uj.symbolColor),Q.set(20,d.$Uj.symbolFile),Q.set(21,d.$Uj.symbolReference),Q.set(22,d.$Uj.symbolCustomColor),Q.set(23,d.$Uj.symbolFolder),Q.set(24,d.$Uj.symbolTypeParameter),Q.set(25,d.$Uj.account),Q.set(26,d.$Uj.issues);function x(me){let ue=Q.get(me);return ue||(console.info("No codicon found for CompletionItemKind "+me),ue=d.$Uj.symbolProperty),ue}q.toIcon=x;const X=new Map;X.set("method",0),X.set("function",1),X.set("constructor",2),X.set("field",3),X.set("variable",4),X.set("class",5),X.set("struct",6),X.set("interface",7),X.set("module",8),X.set("property",9),X.set("event",10),X.set("operator",11),X.set("unit",12),X.set("value",13),X.set("constant",14),X.set("enum",15),X.set("enum-member",16),X.set("enumMember",16),X.set("keyword",17),X.set("snippet",27),X.set("text",18),X.set("color",19),X.set("file",20),X.set("reference",21),X.set("customcolor",22),X.set("folder",23),X.set("type-parameter",24),X.set("typeParameter",24),X.set("account",25),X.set("issue",26);function ie(me,ue){let ve=X.get(me);return typeof ve>"u"&&!ue&&(ve=9),ve}q.fromString=ie})(y||(e.CompletionItemKinds=y={}));var w;(function(q){q[q.Deprecated=1]="Deprecated"})(w||(e.CompletionItemTag=w={}));var h;(function(q){q[q.None=0]="None",q[q.KeepWhitespace=1]="KeepWhitespace",q[q.InsertAsSnippet=4]="InsertAsSnippet"})(h||(e.CompletionItemInsertTextRule=h={}));var g;(function(q){q[q.Word=0]="Word",q[q.Line=1]="Line",q[q.Suggest=2]="Suggest"})(g||(e.PartialAcceptTriggerKind=g={}));var a;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(a||(e.CompletionTriggerKind=a={}));var n;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(n||(e.InlineCompletionTriggerKind=n={}));class i{constructor(Q,x,X,ie){this.range=Q,this.text=x,this.completionKind=X,this.isSnippetText=ie}equals(Q){return R.$tt.lift(this.range).equalsRange(Q.range)&&this.text===Q.text&&this.completionKind===Q.completionKind&&this.isSnippetText===Q.isSnippetText}}e.$0t=i;var u;(function(q){q[q.Invoke=1]="Invoke",q[q.Auto=2]="Auto"})(u||(e.CodeActionTriggerType=u={}));var o;(function(q){q[q.Automatic=0]="Automatic",q[q.PasteAs=1]="PasteAs"})(o||(e.DocumentPasteTriggerKind=o={}));var t;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var l;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(l||(e.DocumentHighlightKind=l={}));function r(q){return q&&N.URI.isUri(q.uri)&&R.$tt.isIRange(q.range)&&(R.$tt.isIRange(q.originSelectionRange)||R.$tt.isIRange(q.targetSelectionRange))}var c;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(c||(e.SymbolKind=c={})),e.$_t={17:(0,b.localize)(0,null),16:(0,b.localize)(1,null),4:(0,b.localize)(2,null),13:(0,b.localize)(3,null),8:(0,b.localize)(4,null),9:(0,b.localize)(5,null),21:(0,b.localize)(6,null),23:(0,b.localize)(7,null),7:(0,b.localize)(8,null),0:(0,b.localize)(9,null),11:(0,b.localize)(10,null),10:(0,b.localize)(11,null),19:(0,b.localize)(12,null),5:(0,b.localize)(13,null),1:(0,b.localize)(14,null),2:(0,b.localize)(15,null),20:(0,b.localize)(16,null),15:(0,b.localize)(17,null),18:(0,b.localize)(18,null),24:(0,b.localize)(19,null),3:(0,b.localize)(20,null),6:(0,b.localize)(21,null),14:(0,b.localize)(22,null),22:(0,b.localize)(23,null),25:(0,b.localize)(24,null),12:(0,b.localize)(25,null)};function s(q,Q){return(0,b.localize)(26,null,q,e.$_t[Q])}var v;(function(q){q[q.Deprecated=1]="Deprecated"})(v||(e.SymbolTag=v={}));var f;(function(q){const Q=new Map;Q.set(0,d.$Uj.symbolFile),Q.set(1,d.$Uj.symbolModule),Q.set(2,d.$Uj.symbolNamespace),Q.set(3,d.$Uj.symbolPackage),Q.set(4,d.$Uj.symbolClass),Q.set(5,d.$Uj.symbolMethod),Q.set(6,d.$Uj.symbolProperty),Q.set(7,d.$Uj.symbolField),Q.set(8,d.$Uj.symbolConstructor),Q.set(9,d.$Uj.symbolEnum),Q.set(10,d.$Uj.symbolInterface),Q.set(11,d.$Uj.symbolFunction),Q.set(12,d.$Uj.symbolVariable),Q.set(13,d.$Uj.symbolConstant),Q.set(14,d.$Uj.symbolString),Q.set(15,d.$Uj.symbolNumber),Q.set(16,d.$Uj.symbolBoolean),Q.set(17,d.$Uj.symbolArray),Q.set(18,d.$Uj.symbolObject),Q.set(19,d.$Uj.symbolKey),Q.set(20,d.$Uj.symbolNull),Q.set(21,d.$Uj.symbolEnumMember),Q.set(22,d.$Uj.symbolStruct),Q.set(23,d.$Uj.symbolEvent),Q.set(24,d.$Uj.symbolOperator),Q.set(25,d.$Uj.symbolTypeParameter);function x(X){let ie=Q.get(X);return ie||(console.info("No codicon found for SymbolKind "+X),ie=d.$Uj.symbolProperty),ie}q.toIcon=x})(f||(e.SymbolKinds=f={}));class S{static asEditOperation(Q){return L.$ut.replace(R.$tt.lift(Q.range),Q.text)}}e.$bu=S;class p{static{this.Comment=new p("comment")}static{this.Imports=new p("imports")}static{this.Region=new p("region")}static fromValue(Q){switch(Q){case"comment":return p.Comment;case"imports":return p.Imports;case"region":return p.Region}return new p(Q)}constructor(Q){this.value=Q}}e.$cu=p;var k;(function(q){q[q.AIGenerated=1]="AIGenerated"})(k||(e.NewSymbolNameTag=k={}));var P;(function(q){function Q(x){return!x||typeof x!="object"?!1:typeof x.id=="string"&&typeof x.title=="string"}q.is=Q})(P||(e.Command=P={}));var C;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(C||(e.CommentThreadCollapsibleState=C={}));var I;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(I||(e.CommentThreadState=I={}));var T;(function(q){q[q.Current=0]="Current",q[q.Outdated=1]="Outdated"})(T||(e.CommentThreadApplicability=T={}));var j;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(j||(e.CommentMode=j={}));var z;(function(q){q[q.Published=0]="Published",q[q.Draft=1]="Draft"})(z||(e.CommentState=z={}));var O;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(O||(e.InlayHintKind=O={}));class F{constructor(Q){this.b=Q,this.a=null}dispose(){this.a&&this.a.then(Q=>{Q&&Q.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$du=F,e.$eu=new M.$Vt;var B;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(B||(e.ExternalUriOpenerPriority=B={}));var Z;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(Z||(e.InlineEditTriggerKind=Z={}))}),define(ke[208],Pe([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[209],Pe([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[210],Pe([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(ke[211],Pe([9,10]),function(le,e){return le.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[212],Pe([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[213],Pe([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[214],Pe([9,10]),function(le,e){return le.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[215],Pe([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(ke[216],Pe([9,10]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(ke[217],Pe([9,10]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[218],Pe([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(ke[219],Pe([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(ke[220],Pe([9,10]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(ke[221],Pe([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[222],Pe([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[223],Pe([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(ke[224],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[225],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[226],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[227],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[228],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[229],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[230],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[231],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[232],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[233],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[234],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[235],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[236],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[237],Pe([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(ke[238],Pe([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(ke[239],Pe([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(ke[240],Pe([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[241],Pe([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[242],Pe([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[243],Pe([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[244],Pe([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[245],Pe([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[246],Pe([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[247],Pe([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[248],Pe([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[249],Pe([9,10]),function(le,e){return le.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[250],Pe([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[251],Pe([1,0,13,210]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.TokenType=void 0;var L;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(L||(e.TokenType=L={}));function R(...E){switch(E.length){case 1:return(0,N.localize)(0,null,E[0]);case 2:return(0,N.localize)(1,null,E[0],E[1]);case 3:return(0,N.localize)(2,null,E[0],E[1],E[2]);default:return}}const M=(0,N.localize)(3,null),b=(0,N.localize)(4,null);class m{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,d.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const D=this.d,$=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:$};this.g.push({offset:D,lexeme:$,additionalInfo:A}),this.f.push(y)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const D=this.c.substring(this.d,this.e),$=m.b.get(D);$?this.k($):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,D=!1,$=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(b);return}const w=this.c.charCodeAt(A);if(D)D=!1;else if(w===47&&!$){A++;break}else w===91?$=!0:w===92?D=!0:w===93&&($=!1);A++}for(;A<this.c.length&&m.a.has(this.c.charCodeAt(A));)A++;this.e=A;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$qj=m}),define(ke[252],Pe([1,0,23,41,213,401]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=m,e.$Gp=E,e.$Hp=A,e.$Ip=D,e.$Jp=$,e.$Kp=y,e.$Lp=w;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function m(a){return a=a.trim(),a==="*"||M.test(a)}function E(a){if(!m(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=a.match(M);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function A(a){if(!a)return null;const n=a.majorBase,i=a.majorMustEqual,u=a.minorBase;let o=a.minorMustEqual;const t=a.patchBase;let l=a.patchMustEqual;a.hasCaret&&(n===0||(o=!1),l=!1);let r=0;if(a.preRelease){const c=b.exec(a.preRelease);if(c){const[,s,v,f]=c;r=Date.UTC(Number(s),Number(v)-1,Number(f))}}return{majorBase:n,majorMustEqual:i,minorBase:u,minorMustEqual:o,patchBase:t,patchMustEqual:l,isMinimum:a.hasGreaterEquals,notBefore:r}}function D(a,n,i){let u;typeof a=="string"?u=A(E(a)):u=a;let o;n instanceof Date?o=n.getTime():typeof n=="string"&&(o=new Date(n).getTime());let t;if(typeof i=="string"?t=A(E(i)):t=i,!u||!t)return!1;const l=u.majorBase,r=u.minorBase,c=u.patchBase;let s=t.majorBase,v=t.minorBase,f=t.patchBase;const S=t.notBefore;let p=t.majorMustEqual,k=t.minorMustEqual,P=t.patchMustEqual;return t.isMinimum?l>s?!0:l<s?!1:r>v?!0:r<v||o&&o<S?!1:c>=f:(l===1&&s===0&&(!p||!k||!P)&&(s=1,v=0,f=0,p=!0,k=!1,P=!1),l<s?!1:l>s?!p:r<v?!1:r>v?!k:c<f?!1:c>f?!P:!(o&&o<S))}function $(a,n,i,u,o){const t=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return t.push([N.default.Error,L.localize(0,null)]),t;if(typeof u.name!="string")return t.push([N.default.Error,L.localize(1,null,"name")]),t;if(typeof u.version!="string")return t.push([N.default.Error,L.localize(2,null,"version")]),t;if(!u.engines)return t.push([N.default.Error,L.localize(3,null,"engines")]),t;if(typeof u.engines.vscode!="string")return t.push([N.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof u.extensionDependencies<"u"&&!g(u.extensionDependencies))return t.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof u.activationEvents<"u"){if(!g(u.activationEvents))return t.push([N.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof u.main>"u"&&typeof u.browser>"u")return t.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&t.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return t.push([N.default.Error,L.localize(9,null,"main")]),t;{const c=(0,d.$9g)(i,u.main);(0,d.$3g)(c,i)||t.push([N.default.Warning,L.localize(10,null,c.path,i.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return t.push([N.default.Error,L.localize(11,null,"browser")]),t;{const c=(0,d.$9g)(i,u.browser);(0,d.$3g)(c,i)||t.push([N.default.Warning,L.localize(12,null,c.path,i.path)])}}if(!R.valid(u.version))return t.push([N.default.Error,L.localize(13,null)]),t;const l=[];if(!y(a,n,u,o,l))for(const c of l)t.push([N.default.Error,c]);return t}function y(a,n,i,u,o){return u||typeof i.main>"u"&&typeof i.browser>"u"?!0:h(a,n,i.engines.vscode,o)}function w(a,n,i){return a==="*"||h(n,i,a)}function h(a,n,i,u=[]){const o=A(E(i));if(!o)return u.push(L.localize(14,null,i)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return u.push(L.localize(15,null,i)),!1}else if(!o.majorMustEqual)return u.push(L.localize(16,null,i)),!1;return D(a,n,o)?!0:(u.push(L.localize(17,null,a,i)),!1)}function g(a){if(!Array.isArray(a))return!1;for(let n=0,i=a.length;n<i;n++)if(typeof a[n]!="string")return!1;return!0}}),define(ke[106],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=void 0;class d{constructor(L,R=[],M=!1){this.ctor=L,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.$si=d}),define(ke[85],Pe([1,0,106]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ws=R,e.$xs=M;const N=[];var L;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function R(b,m,E){m instanceof d.$si||(m=new d.$si(m,[],!!E)),N.push([b,m])}function M(){return N}}),define(ke[253],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=void 0;class d{constructor(R,M){this.key=R,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$_q=d;class N{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const M of this.a.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const b=this.lookupOrInsertNode(R),m=this.lookupOrInsertNode(M);b.outgoing.set(m.key,m),m.incoming.set(b.key,b)}removeNode(R){const M=this.b(R);this.a.delete(M);for(const b of this.a.values())b.outgoing.delete(M),b.incoming.delete(M)}lookupOrInsertNode(R){const M=this.b(R);let b=this.a.get(M);return b||(b=new d(M,R),this.a.set(M,b)),b}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[M,b]of this.a)R.push(`${M}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this.a){const b=new Set([R]),m=this.c(M,b);if(m)return m}}c(R,M){for(const[b,m]of R.outgoing){if(M.has(b))return[...M,b].join(" -> ");M.add(b);const E=this.c(m,M);if(E)return E;M.delete(b)}}}e.$ar=N}),define(ke[5],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e._util=void 0,e.$vi=L,e.$wi=R;var d;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function b(m){return m[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=b})(d||(e._util=d={})),e.$ui=L("instantiationService");function N(M,b,m){b[d.DI_TARGET]===b?b[d.DI_DEPENDENCIES].push({id:M,index:m}):(b[d.DI_DEPENDENCIES]=[{id:M,index:m}],b[d.DI_TARGET]=b)}function L(M){if(d.serviceIds.has(M))return d.serviceIds.get(M);const b=function(m,E,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(b,m,A)};return b.toString=()=>M,d.serviceIds.set(M,b),b}function R(M){return M}}),define(ke[54],Pe([1,0,18,2,5]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$2i=void 0,e.$3i=R,e.$4i=M,e.$5i=m,e.$6i=E,e.$7i=A,e.$8i=D,e.$9i=$,e.$0i=w,e.$$i=h,e.$_i=g,e.$2i=(0,L.$vi)("configurationService");function R(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof N.URI)}function M(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof N.URI)}var b;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function m(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function A(a,n){const i=Object.create(null);for(const u in a)D(i,u,a[u],n);return i}function D(a,n,i,u){const o=n.split("."),t=o.pop();let l=a;for(let r=0;r<o.length;r++){const c=o[r];let s=l[c];switch(typeof s){case"undefined":s=l[c]=Object.create(null);break;case"object":if(s===null){u(`Ignoring ${n} as ${o.slice(0,r+1).join(".")} is null`);return}break;default:u(`Ignoring ${n} as ${o.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}l=s}if(typeof l=="object"&&l!==null)try{l[t]=i}catch{u(`Ignoring ${n} as ${o.join(".")} is ${JSON.stringify(l)}`)}else u(`Ignoring ${n} as ${o.join(".")} is ${JSON.stringify(l)}`)}function $(a,n){const i=n.split(".");y(a,i)}function y(a,n){const i=n.shift();if(n.length===0){delete a[i];return}if(Object.keys(a).indexOf(i)!==-1){const u=a[i];typeof u=="object"&&!Array.isArray(u)&&(y(u,n),Object.keys(u).length===0&&delete a[i])}}function w(a,n,i){function u(l,r){let c=l;for(const s of r){if(typeof c!="object"||c===null)return;c=c[s]}return c}const o=n.split("."),t=u(a,o);return typeof t>"u"?i:t}function h(a,n,i){Object.keys(n).forEach(u=>{u!=="__proto__"&&(u in a?d.$0f(a[u])&&d.$0f(n[u])?h(a[u],n[u],i):i&&(a[u]=n[u]):a[u]=n[u])})}function g(a){return a.replace(/[\[\]]/g,"")}}),define(ke[38],Pe([1,0,12,14,251,5,209,13]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$tj=e.$sj=e.ContextKeyExprType=void 0,e.$rj=E,e.$uj=l,e.$vj=r,e.$Oj=me;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",d.$j),m.set("isLinux",d.$k),m.set("isWindows",d.$i),m.set("isWeb",d.$o),m.set("isMacNative",d.$j&&!d.$o),m.set("isEdge",d.$H),m.set("isFirefox",d.$F),m.set("isChrome",d.$E),m.set("isSafari",d.$G);function E(te,U){if(m.get(te)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(te,U)}const A=Object.prototype.hasOwnProperty;var D;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const $={regexParsingWithErrorRecovery:!0},y=(0,M.localize)(0,null),w=(0,M.localize)(1,null),h=(0,M.localize)(2,null),g=(0,M.localize)(3,null),a=(0,M.localize)(4,null),n=(0,M.localize)(5,null),i=(0,M.localize)(6,null),u=(0,M.localize)(7,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=$){this.k=U,this.d=new L.$qj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:w});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ee=this.l();if(!this.E()){const pe=this.D(),Ce=pe.type===17?n:void 0;throw this.h.push({message:a,offset:pe.offset,lexeme:L.$qj.getLexeme(pe),additionalInfo:Ce}),o.c}return ee}catch(ee){if(ee!==o.c)throw ee;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ee=this.o();U.push(ee)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ee=this.s();U.push(ee)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),v.INSTANCE;case 0:{this.z();const ee=this.l();return this.A(1,g),ee?.negate()}case 17:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ee=this.l();return this.A(1,g),ee}case 17:{const ee=U.lexeme;if(this.z(),this.y(9)){const Ce=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ce.type!==10)throw this.B("REGEX",Ce);const se=Ce.lexeme,re=se.lastIndexOf("/"),oe=re===se.length-1?void 0:this.w(se.substring(re+1));let K;try{K=new RegExp(se.substring(1,re),oe)}catch{throw this.B("REGEX",Ce)}return F.create(ee,K)}switch(Ce.type){case 10:case 19:{const se=[Ce.lexeme];this.z();let re=this.D(),oe=0;for(let Ae=0;Ae<Ce.lexeme.length;Ae++)Ce.lexeme.charCodeAt(Ae)===40?oe++:Ce.lexeme.charCodeAt(Ae)===41&&oe--;for(;!this.E()&&re.type!==15&&re.type!==16;){switch(re.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let Ae=0;Ae<re.lexeme.length;Ae++)re.lexeme.charCodeAt(Ae)===40?oe++:Ce.lexeme.charCodeAt(Ae)===41&&oe--}if(oe<0)break;se.push(L.$qj.getLexeme(re)),this.z(),re=this.D()}const K=se.join(""),ne=K.lastIndexOf("/"),$e=ne===K.length-1?void 0:this.w(K.substring(ne+1));let be;try{be=new RegExp(K.substring(1,ne),$e)}catch{throw this.B("REGEX",Ce)}return t.regex(ee,be)}case 18:{const se=Ce.lexeme;this.z();let re=null;if(!(0,N.$7e)(se)){const oe=se.indexOf("/"),K=se.lastIndexOf("/");if(oe!==K&&oe>=0){const ne=se.slice(oe+1,K),$e=se[K+1]==="i"?"i":"";try{re=new RegExp(ne,$e)}catch{throw this.B("REGEX",Ce)}}}if(re===null)throw this.B("REGEX",Ce);return F.create(ee,re)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,h);const Ce=this.u();return t.notIn(ee,Ce)}switch(this.D().type){case 3:{this.z();const Ce=this.u();if(this.x().type===18)return t.equals(ee,Ce);switch(Ce){case"true":return t.has(ee);case"false":return t.not(ee);default:return t.equals(ee,Ce)}}case 4:{this.z();const Ce=this.u();if(this.x().type===18)return t.notEquals(ee,Ce);switch(Ce){case"true":return t.not(ee);case"false":return t.has(ee);default:return t.notEquals(ee,Ce)}}case 5:return this.z(),z.create(ee,this.u());case 6:return this.z(),O.create(ee,this.u());case 7:return this.z(),T.create(ee,this.u());case 8:return this.z(),j.create(ee,this.u());case 13:return this.z(),t.in(ee,this.u());default:return t.has(ee)}}case 20:throw this.h.push({message:i,offset:U.offset,lexeme:"",additionalInfo:u}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ee){if(this.C(U))return this.z();throw this.B(ee,this.D())}B(U,ee,pe){const Ce=(0,M.localize)(8,null,U,L.$qj.getLexeme(ee)),se=ee.offset,re=L.$qj.getLexeme(ee);return this.h.push({message:Ce,offset:se,lexeme:re,additionalInfo:pe}),o.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$sj=o;class t{static false(){return s.INSTANCE}static true(){return v.INSTANCE}static has(U){return f.create(U)}static equals(U,ee){return S.create(U,ee)}static notEquals(U,ee){return P.create(U,ee)}static regex(U,ee){return F.create(U,ee)}static in(U,ee){return p.create(U,ee)}static notIn(U,ee){return k.create(U,ee)}static not(U){return C.create(U)}static and(...U){return q.create(U,null,!0)}static or(...U){return Q.create(U,null,!0)}static greater(U,ee){return T.create(U,ee)}static greaterEquals(U,ee){return j.create(U,ee)}static smaller(U,ee){return z.create(U,ee)}static smallerEquals(U,ee){return O.create(U,ee)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$tj=t;function l(te){const U=new o({regexParsingWithErrorRecovery:!1});return te.map(ee=>(U.parse(ee),U.lexingErrors.length>0?U.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,M.localize)(9,null,pe.additionalInfo):(0,M.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}function r(te,U){const ee=te?te.substituteConstants():void 0,pe=U?U.substituteConstants():void 0;return!ee&&!pe?!0:!ee||!pe?!1:ee.equals(pe)}function c(te,U){return te.cmp(U)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return v.INSTANCE}}e.$wj=s;class v{static{this.INSTANCE=new v}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return s.INSTANCE}}e.$xj=v;class f{static create(U,ee=null){const pe=m.get(U);return typeof pe=="boolean"?pe?v.INSTANCE:s.INSTANCE:new f(U,ee)}constructor(U,ee){this.key=U,this.c=ee,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:X(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=m.get(this.key);return typeof U=="boolean"?U?v.INSTANCE:s.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$yj=f;class S{static create(U,ee,pe=null){if(typeof ee=="boolean")return ee?f.create(U,pe):C.create(U,pe);const Ce=m.get(U);return typeof Ce=="boolean"?ee===(Ce?"true":"false")?v.INSTANCE:s.INSTANCE:new S(U,ee,pe)}constructor(U,ee,pe){this.c=U,this.d=ee,this.f=pe,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ie(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=m.get(this.c);if(typeof U=="boolean"){const ee=U?"true":"false";return this.d===ee?v.INSTANCE:s.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$zj=S;class p{static create(U,ee){return new p(U,ee)}constructor(U,ee){this.d=U,this.f=ee,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ie(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ee=U.getValue(this.f),pe=U.getValue(this.d);return Array.isArray(ee)?ee.includes(pe):typeof pe=="string"&&typeof ee=="object"&&ee!==null?A.call(ee,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Aj=p;class k{static create(U,ee){return new k(U,ee)}constructor(U,ee){this.d=U,this.f=ee,this.type=11,this.c=p.create(U,ee)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Bj=k;class P{static create(U,ee,pe=null){if(typeof ee=="boolean")return ee?C.create(U,pe):f.create(U,pe);const Ce=m.get(U);return typeof Ce=="boolean"?ee===(Ce?"true":"false")?s.INSTANCE:v.INSTANCE:new P(U,ee,pe)}constructor(U,ee,pe){this.c=U,this.d=ee,this.f=pe,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ie(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=m.get(this.c);if(typeof U=="boolean"){const ee=U?"true":"false";return this.d===ee?s.INSTANCE:v.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Cj=P;class C{static create(U,ee=null){const pe=m.get(U);return typeof pe=="boolean"?pe?s.INSTANCE:v.INSTANCE:new C(U,ee)}constructor(U,ee){this.c=U,this.d=ee,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:X(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=m.get(this.c);return typeof U=="boolean"?U?s.INSTANCE:v.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.$Dj=C;function I(te,U){if(typeof te=="string"){const ee=parseFloat(te);isNaN(ee)||(te=ee)}return typeof te=="string"||typeof te=="number"?U(te):s.INSTANCE}class T{static create(U,ee,pe=null){return I(ee,Ce=>new T(U,Ce,pe))}constructor(U,ee,pe){this.c=U,this.d=ee,this.f=pe,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ie(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Ej=T;class j{static create(U,ee,pe=null){return I(ee,Ce=>new j(U,Ce,pe))}constructor(U,ee,pe){this.c=U,this.d=ee,this.f=pe,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ie(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Fj=j;class z{static create(U,ee,pe=null){return I(ee,Ce=>new z(U,Ce,pe))}constructor(U,ee,pe){this.c=U,this.d=ee,this.f=pe,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ie(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Gj=z;class O{static create(U,ee,pe=null){return I(ee,Ce=>new O(U,Ce,pe))}constructor(U,ee,pe){this.c=U,this.d=ee,this.f=pe,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ie(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Hj=O;class F{static create(U,ee){return new F(U,ee)}constructor(U,ee){this.d=U,this.f=ee,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ee=this.f?this.f.source:"",pe=U.f?U.f.source:"";return ee<pe?-1:ee>pe?1:0}equals(U){if(U.type===this.type){const ee=this.f?this.f.source:"",pe=U.f?U.f.source:"";return this.d===U.d&&ee===pe}return!1}substituteConstants(){return this}evaluate(U){const ee=U.getValue(this.d);return this.f?this.f.test(ee):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Ij=F;class B{static create(U){return new B(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new B(this.c.map(U))}negate(){return this.c}}e.$Jj=B;function Z(te){let U=null;for(let ee=0,pe=te.length;ee<pe;ee++){const Ce=te[ee].substituteConstants();if(te[ee]!==Ce&&U===null){U=[];for(let se=0;se<ee;se++)U[se]=te[se]}U!==null&&(U[ee]=Ce)}return U===null?te:U}class q{static create(U,ee,pe){return q.d(U,ee,pe)}constructor(U,ee){this.expr=U,this.c=ee,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ee=0,pe=this.expr.length;ee<pe;ee++){const Ce=c(this.expr[ee],U.expr[ee]);if(Ce!==0)return Ce}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ee=0,pe=this.expr.length;ee<pe;ee++)if(!this.expr[ee].equals(U.expr[ee]))return!1;return!0}return!1}substituteConstants(){const U=Z(this.expr);return U===this.expr?this:q.create(U,this.c,!1)}evaluate(U){for(let ee=0,pe=this.expr.length;ee<pe;ee++)if(!this.expr[ee].evaluate(U))return!1;return!0}static d(U,ee,pe){const Ce=[];let se=!1;for(const re of U)if(re){if(re.type===1){se=!0;continue}if(re.type===0)return s.INSTANCE;if(re.type===6){Ce.push(...re.expr);continue}Ce.push(re)}if(Ce.length===0&&se)return v.INSTANCE;if(Ce.length!==0){if(Ce.length===1)return Ce[0];Ce.sort(c);for(let re=1;re<Ce.length;re++)Ce[re-1].equals(Ce[re])&&(Ce.splice(re,1),re--);if(Ce.length===1)return Ce[0];for(;Ce.length>1;){const re=Ce[Ce.length-1];if(re.type!==9)break;Ce.pop();const oe=Ce.pop(),K=Ce.length===0,ne=Q.create(re.expr.map($e=>q.create([$e,oe],null,pe)),null,K);ne&&(Ce.push(ne),Ce.sort(c))}if(Ce.length===1)return Ce[0];if(pe){for(let re=0;re<Ce.length;re++)for(let oe=re+1;oe<Ce.length;oe++)if(Ce[re].negate().equals(Ce[oe]))return s.INSTANCE;if(Ce.length===1)return Ce[0]}return new q(Ce,ee)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ee of this.expr)U.push(...ee.keys());return U}map(U){return new q(this.expr.map(ee=>ee.map(U)),null)}negate(){if(!this.c){const U=[];for(const ee of this.expr)U.push(ee.negate());this.c=Q.create(U,this,!0)}return this.c}}e.$Kj=q;class Q{static create(U,ee,pe){return Q.d(U,ee,pe)}constructor(U,ee){this.expr=U,this.c=ee,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ee=0,pe=this.expr.length;ee<pe;ee++){const Ce=c(this.expr[ee],U.expr[ee]);if(Ce!==0)return Ce}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ee=0,pe=this.expr.length;ee<pe;ee++)if(!this.expr[ee].equals(U.expr[ee]))return!1;return!0}return!1}substituteConstants(){const U=Z(this.expr);return U===this.expr?this:Q.create(U,this.c,!1)}evaluate(U){for(let ee=0,pe=this.expr.length;ee<pe;ee++)if(this.expr[ee].evaluate(U))return!0;return!1}static d(U,ee,pe){let Ce=[],se=!1;if(U){for(let re=0,oe=U.length;re<oe;re++){const K=U[re];if(K){if(K.type===0){se=!0;continue}if(K.type===1)return v.INSTANCE;if(K.type===9){Ce=Ce.concat(K.expr);continue}Ce.push(K)}}if(Ce.length===0&&se)return s.INSTANCE;Ce.sort(c)}if(Ce.length!==0){if(Ce.length===1)return Ce[0];for(let re=1;re<Ce.length;re++)Ce[re-1].equals(Ce[re])&&(Ce.splice(re,1),re--);if(Ce.length===1)return Ce[0];if(pe){for(let re=0;re<Ce.length;re++)for(let oe=re+1;oe<Ce.length;oe++)if(Ce[re].negate().equals(Ce[oe]))return v.INSTANCE;if(Ce.length===1)return Ce[0]}return new Q(Ce,ee)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ee of this.expr)U.push(...ee.keys());return U}map(U){return new Q(this.expr.map(ee=>ee.map(U)),null)}negate(){if(!this.c){const U=[];for(const ee of this.expr)U.push(ee.negate());for(;U.length>1;){const ee=U.shift(),pe=U.shift(),Ce=[];for(const se of ve(ee))for(const re of ve(pe))Ce.push(q.create([se,re],null,!1));U.unshift(Q.create(Ce,null,!1))}this.c=Q.create(U,this,!0)}return this.c}}e.$Lj=Q;class x extends f{static{this.d=[]}static all(){return x.d.values()}constructor(U,ee,pe){super(U,null),this.f=ee,typeof pe=="object"?x.d.push({...pe,key:U}):pe!==!0&&x.d.push({key:U,description:pe,type:ee!=null?typeof ee:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return S.create(this.key,U)}notEqualsTo(U){return P.create(this.key,U)}}e.$Mj=x,e.$Nj=(0,R.$vi)("contextKeyService");function X(te,U){return te<U?-1:te>U?1:0}function ie(te,U,ee,pe){return te<ee?-1:te>ee?1:U<pe?-1:U>pe?1:0}function me(te,U){if(te.type===0||U.type===1)return!0;if(te.type===9)return U.type===9?ue(te.expr,U.expr):!1;if(U.type===9){for(const ee of U.expr)if(me(te,ee))return!0;return!1}if(te.type===6){if(U.type===6)return ue(U.expr,te.expr);for(const ee of te.expr)if(me(ee,U))return!0;return!1}return te.equals(U)}function ue(te,U){let ee=0,pe=0;for(;ee<te.length&&pe<U.length;){const Ce=te[ee].cmp(U[pe]);if(Ce<0)return!1;Ce===0&&ee++,pe++}return ee===te.length}function ve(te){return te.type===9?te.expr:[te]}}),define(ke[254],Pe([1,0,23,41,211,5,103,12,24]),function(le,e,d,N,L,R,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Iw=e.$Hw=e.$Gw=void 0,e.$Jw=y,e.$Kw=w,e.$Gw=(0,R.$vi)("dialogService");var E;(function(h){h[h.Confirmation=1]="Confirmation",h[h.Prompt=2]="Prompt",h[h.Input=3]="Input"})(E||(E={}));class A{a(g){return this.d(g,E.Confirmation)}b(g){return this.d(g,E.Prompt)}c(g){return this.d(g,E.Input)}d(g,a){const n=[];switch(a){case E.Confirmation:{const i=g;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(1,null));break}case E.Prompt:{const i=g;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(u=>u.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,L.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,L.localize)(3,null))),n.length===0&&n.push((0,L.localize)(4,null));break}case E.Input:{const i=g;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(6,null));break}}return n}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===N.default.Info?"info":g===N.default.Error?"error":g===N.default.Warning?"warning":"none"}f(g,a,n){const i=[...g.buttons??[]];g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&i.push(g.cancelButton);let u=i[a]?.run({checkboxChecked:n});return u instanceof Promise||(u=Promise.resolve(u)),{result:u,checkboxChecked:n}}}e.$Hw=A,e.$Iw=(0,R.$vi)("fileDialogService");var D;(function(h){h[h.SAVE=0]="SAVE",h[h.DONT_SAVE=1]="DONT_SAVE",h[h.CANCEL=2]="CANCEL"})(D||(e.ConfirmResult=D={}));const $=10;function y(h){const g=[];return g.push(...h.slice(0,$).map(a=>typeof a=="string"?a:(0,d.$6g)(a))),h.length>$&&(h.length-$===1?g.push((0,L.localize)(7,null)):g.push((0,L.localize)(8,null,h.length-$))),g.push(""),g.join(`
`)}function w(h,g){const a=(0,m.$2n)(h);let n=(a.buttons??[]).map(t=>(0,M.$Dw)(t)),i=(h.buttons||[]).map((t,l)=>l),u=0,o=a.cancelId??n.length-1;if(n.length>1){const t=typeof o=="number"?n[o]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&n.length>1&&o!==1){n.splice(o,1),n.splice(1,0,t);const l=i[o];i.splice(o,1),i.splice(1,0,l),o=1}b.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),u=n.length-1,typeof t=="string"&&(o=u-1))}else if(b.$i&&typeof t=="string"&&n.length>1&&o!==n.length-1){n.splice(o,1),n.push(t);const l=i[o];i.splice(o,1),i.push(l),o=n.length-1}}return a.buttons=n,a.defaultId=u,a.cancelId=o,a.noLink=!0,a.title=a.title||g.nameLong,{options:a,buttonIndeces:i}}}),define(ke[137],Pe([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=void 0,e.$Ci=(0,d.$vi)("environmentService"),e.$Di=(0,d.$wi)(e.$Ci)}),define(ke[138],Pe([1,0,212,5]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.ExtensionGalleryErrorCode=e.$6o=e.ExtensionManagementErrorCode=e.$5o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=void 0,e.$Yo=L,e.$Zo=R,e.$1o=M,e.$2o=b,e.$3o=m,e.$4o=E,e.$So="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$To=new RegExp(e.$So),e.$Uo="__web_extension",e.$Vo="skipWalkthrough",e.$Wo="extensionsSync",e.$Xo="dependecyOrPackExtensionInstall";function L(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(n,i){switch(n){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(n,i){return i==="web"&&!n.includes("web")}function m(n,i,u){return b(i,u)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===u}function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var A;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var D;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var $;(function(n){n.Install="install",n.Uninstall="uninstall"})($||(e.StatisticType=$={}));var y;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$5o=(0,N.$vi)("extensionGalleryService");var w;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));class h extends Error{constructor(i,u){super(i),this.code=u,this.name=u}}e.$6o=h;var g;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(g||(e.ExtensionGalleryErrorCode=g={}));class a extends Error{constructor(i,u){super(i),this.code=u,this.name=u}}e.$7o=a,e.$8o=(0,N.$vi)("extensionManagementService"),e.$9o="extensionsIdentifiers/disabled",e.$0o="extensionsIdentifiers/enabled",e.$$o=(0,N.$vi)("IGlobalExtensionEnablementService"),e.$_o=(0,N.$vi)("IExtensionTipsService"),e.$ap=(0,d.localize2)(0,"Extensions"),e.$bp=(0,d.localize2)(1,"Preferences")}),define(ke[255],Pe([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b7b=e.$a7b=void 0,e.$a7b=(0,d.$vi)("externalTerminal"),e.$b7b="Terminal.app"}),define(ke[256],Pe([1,0,53,55,15,17,12,102,32,105,214,255]),function(le,e,d,N,L,R,M,b,m,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=e.$kcc=e.$jcc=void 0;const $=A.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends y{static{this.b="cmd.exe"}openTerminal(o,t){return this.spawnTerminal(d,o,E.$nm(),t)}spawnTerminal(o,t,l,r){const c=t.windowsExec||w.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const s=R.$oc(c,".exe").toLowerCase();if(s==="cmder")return o.spawn(c,r?[r]:void 0),Promise.resolve(void 0);const v=["/c","start","/wait"];return c.indexOf(" ")>=0&&v.push('""'),v.push(c),s==="wt"&&v.push("-d ."),new Promise((f,S)=>{const p=a(process),k=o.spawn(l,v,{cwd:r,env:p,detached:!0});k.on("error",S),k.on("exit",()=>f())})}async runInTerminal(o,t,l,r,c){const s="windowsExec"in c&&c.windowsExec?c.windowsExec:w.getDefaultTerminalWindows(),v=await w.f();return new Promise((f,S)=>{const p=`"${t} - ${$}"`,k=`"${l.join('" "')}" & pause`,P=Object.assign({},a(process),r);Object.keys(P).filter(z=>P[z]===null).forEach(z=>delete P[z]);const C={cwd:t,env:P,windowsVerbatimArguments:!0};let I,T;R.$oc(s,".exe")==="wt"?(I=s,T=["-d",".",w.b,"/c",k]):v?(I=v,T=["-d",".",s,"/c",k]):(I=w.b,T=["/c","start",p,"/wait",s,"/c",`"${k}"`]),d.spawn(I,T,C).on("error",z=>{S(n(z))}),f(void 0)})}static getDefaultTerminalWindows(){if(!w.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return w.d}static async f(){try{const o=await E.win32.findExecutable("wt");return await m.Promises.exists(o)?o:void 0}catch{return}}}e.$jcc=w,Je([N.$Zh],w,"f",null);class h extends y{static{this.b="/usr/bin/osascript"}openTerminal(o,t){return this.spawnTerminal(d,o,t)}runInTerminal(o,t,l,r,c){const s=c.osxExec||D.$b7b;return new Promise((v,f)=>{if(s===D.$b7b||s==="iTerm.app"){const S=s===D.$b7b?"TerminalHelper":"iTermHelper",k=[L.$Pg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",o||$,"-w",t];for(const I of l)k.push("-a"),k.push(I);if(r){const I=Object.assign({},a(process),r);for(const T in I){const j=I[T];j===null?(k.push("-u"),k.push(T)):(k.push("-e"),k.push(`${T}=${j}`))}}let P="";const C=d.spawn(h.b,k);C.on("error",I=>{f(n(I))}),C.stderr.on("data",I=>{P+=I.toString()}),C.on("exit",I=>{if(I===0)v(void 0);else if(P){const T=P.split(`
`,1);f(new Error(T[0]))}else f(new Error(A.localize(1,null,S,I)))})}else f(new Error(A.localize(2,null,s)))})}spawnTerminal(o,t,l){const r=t.osxExec||D.$b7b;return new Promise((c,s)=>{const v=["-a",r];l&&v.push(l);const f=a(process),S=o.spawn("/usr/bin/open",v,{cwd:l,env:f});S.on("error",s),S.on("exit",()=>c())})}}e.$kcc=h;class g extends y{static{this.b=A.localize(3,null)}openTerminal(o,t){return this.spawnTerminal(d,o,t)}runInTerminal(o,t,l,r,c){const s=c.linuxExec?Promise.resolve(c.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((v,f)=>{const S=[];s.then(p=>{p.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const k=`${i(l)}; echo; read -p "${g.b}" -n1;`;S.push(`''${k}''`);const P=Object.assign({},a(process),r);Object.keys(P).filter(j=>P[j]===null).forEach(j=>delete P[j]);const C={cwd:t,env:P};let I="";const T=d.spawn(p,S,C);T.on("error",j=>{f(n(j))}),T.stderr.on("data",j=>{I+=j.toString()}),T.on("exit",j=>{if(j===0)v(void 0);else if(I){const z=I.split(`
`,1);f(new Error(z[0]))}else f(new Error(A.localize(4,null,p,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!g.d)if(!M.$k)g.d=Promise.resolve("xterm");else{const o=await m.Promises.exists("/etc/debian_version");g.d=new Promise(t=>{o?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return g.d}spawnTerminal(o,t,l){const r=t.linuxExec?Promise.resolve(t.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((c,s)=>{r.then(v=>{const f=a(process),S=o.spawn(v,[],{cwd:l,env:f});S.on("error",s),S.on("exit",()=>c())})})}}e.$lcc=g;function a(u){const o={...u.env};return(0,b.$lm)(o),o}function n(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(A.localize(5,null,u.path)):u}function i(u){let o="";for(const t of u)t.indexOf(" ")>=0?o+='"'+t+'"':o+=t,o+=" ";return o}}),define(ke[33],Pe([1,0,78,17,14,18,2,215,5,12,15,46]),function(le,e,d,N,L,R,M,b,m,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$ul=e.FileKind=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.FileOperationResult=e.$ml=e.$ll=e.$kl=e.$il=e.FileChangeType=e.$hl=e.FileOperation=e.$bl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$2k=void 0,e.$3k=$,e.$4k=g,e.$5k=n,e.$6k=i,e.$7k=u,e.$8k=o,e.$9k=t,e.$0k=l,e.$$k=r,e.$_k=c,e.$al=s,e.$cl=S,e.$dl=p,e.$el=k,e.$fl=P,e.$gl=C,e.$jl=O,e.$vl=x,e.$wl=X,e.$yl=me,e.$2k=(0,m.$vi)("fileService");function $(ue){return ue.create===!0}var y;(function(ue){ue[ue.Unknown=0]="Unknown",ue[ue.File=1]="File",ue[ue.Directory=2]="Directory",ue[ue.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var w;(function(ue){ue[ue.Readonly=1]="Readonly",ue[ue.Locked=2]="Locked"})(w||(e.FilePermission=w={}));var h;(function(ue){ue[ue.UPDATED=2]="UPDATED",ue[ue.ADDED=4]="ADDED",ue[ue.DELETED=8]="DELETED"})(h||(e.FileChangeFilter=h={}));function g(ue){const ve=ue;return!!ve&&typeof ve.onDidChange=="function"}var a;(function(ue){ue[ue.None=0]="None",ue[ue.FileReadWrite=2]="FileReadWrite",ue[ue.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ue[ue.FileReadStream=16]="FileReadStream",ue[ue.FileFolderCopy=8]="FileFolderCopy",ue[ue.PathCaseSensitive=1024]="PathCaseSensitive",ue[ue.Readonly=2048]="Readonly",ue[ue.Trash=4096]="Trash",ue[ue.FileWriteUnlock=8192]="FileWriteUnlock",ue[ue.FileAtomicRead=16384]="FileAtomicRead",ue[ue.FileAtomicWrite=32768]="FileAtomicWrite",ue[ue.FileAtomicDelete=65536]="FileAtomicDelete",ue[ue.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function n(ue){return!!(ue.capabilities&2)}function i(ue){return!!(ue.capabilities&8)}function u(ue){return!!(ue.capabilities&131072)}function o(ue){return!!(ue.capabilities&4)}function t(ue){return!!(ue.capabilities&16)}function l(ue){return n(ue)?!!(ue.capabilities&16384):!1}function r(ue){return n(ue)?!!(ue.capabilities&32768):!1}function c(ue){return!!(ue.capabilities&65536)}function s(ue){return!!(ue.capabilities&2048)}var v;(function(ue){ue.FileExists="EntryExists",ue.FileNotFound="EntryNotFound",ue.FileNotADirectory="EntryNotADirectory",ue.FileIsADirectory="EntryIsADirectory",ue.FileExceedsStorageQuota="EntryExceedsStorageQuota",ue.FileTooLarge="EntryTooLarge",ue.FileWriteLocked="EntryWriteLocked",ue.NoPermissions="NoPermissions",ue.Unavailable="Unavailable",ue.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class f extends Error{static create(ve,te){const U=new f(ve.toString(),te);return k(U,te),U}constructor(ve,te){super(ve),this.code=te}}e.$bl=f;function S(ue,ve){return f.create(ue,ve)}function p(ue){return ue||S((0,b.localize)(0,null),v.Unknown)}function k(ue,ve){return ue.name=ve?`${ve} (FileSystemError)`:"FileSystemError",ue}function P(ue){if(!ue)return v.Unknown;if(ue instanceof f)return ue.code;const ve=/^(.+) \(FileSystemError\)$/.exec(ue.name);if(!ve)return v.Unknown;switch(ve[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}function C(ue){if(ue instanceof F)return ue.fileOperationResult;switch(P(ue)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}var I;(function(ue){ue[ue.CREATE=0]="CREATE",ue[ue.DELETE=1]="DELETE",ue[ue.MOVE=2]="MOVE",ue[ue.COPY=3]="COPY",ue[ue.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class T{constructor(ve,te,U){this.resource=ve,this.operation=te,this.target=U}isOperation(ve){return this.operation===ve}}e.$hl=T;var j;(function(ue){ue[ue.UPDATED=0]="UPDATED",ue[ue.ADDED=1]="ADDED",ue[ue.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class z{static{this.a=null}constructor(ve,te){this.c=te,this.b=void 0,this.d=new D.$V(()=>{const U=d.$Bi.forUris(()=>this.c);return U.fill(this.rawAdded.map(ee=>[ee,!0])),U}),this.f=new D.$V(()=>{const U=d.$Bi.forUris(()=>this.c);return U.fill(this.rawUpdated.map(ee=>[ee,!0])),U}),this.g=new D.$V(()=>{const U=d.$Bi.forUris(()=>this.c);return U.fill(this.rawDeleted.map(ee=>[ee,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of ve){switch(U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}this.b!==z.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(ve,...te){return this.h(ve,{includeChildren:!1},...te)}affects(ve,...te){return this.h(ve,{includeChildren:!0},...te)}h(ve,te,...U){if(!ve)return!1;const ee=U.length>0;return!!((!ee||U.includes(1))&&(this.d.value.get(ve)||te.includeChildren&&this.d.value.findSuperstr(ve))||(!ee||U.includes(0))&&(this.f.value.get(ve)||te.includeChildren&&this.f.value.findSuperstr(ve))||(!ee||U.includes(2))&&(this.g.value.findSubstr(ve)||te.includeChildren&&this.g.value.findSuperstr(ve)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ve){return this.b===ve}hasCorrelation(){return typeof this.b=="number"}}e.$il=z;function O(ue,ve,te){return!ue||!ve||ue===ve||ve.length>ue.length?!1:(ve.charAt(ve.length-1)!==N.sep&&(ve+=N.sep),te?(0,L.$yf)(ue,ve):ue.indexOf(ve)===0)}class F extends Error{constructor(ve,te,U){super(ve),this.fileOperationResult=te,this.options=U}}e.$kl=F;class B extends F{constructor(ve,te,U,ee){super(ve,te,ee),this.fileOperationResult=te,this.size=U}}e.$ll=B;class Z extends F{constructor(ve,te,U){super(ve,2,U),this.stat=te}}e.$ml=Z;var q;(function(ue){ue[ue.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ue[ue.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ue[ue.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ue[ue.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ue[ue.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ue[ue.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ue[ue.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ue[ue.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ue[ue.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ue[ue.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ue[ue.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(q||(e.FileOperationResult=q={})),e.$nl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ol={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$pl="files.associations",e.$ql="files.exclude",e.$rl="files.readonlyInclude",e.$sl="files.readonlyExclude",e.$tl="files.readonlyFromPermissions";var Q;(function(ue){ue[ue.FILE=0]="FILE",ue[ue.FOLDER=1]="FOLDER",ue[ue.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$ul="";function x(ue){if(!(typeof ue.size!="number"||typeof ue.mtime!="number"))return ue.mtime.toString(29)+ue.size.toString(31)}async function X(ue,ve){if(!ve.hasProvider(M.URI.from({scheme:ue.scheme})))return new Promise(te=>{const U=ve.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===ue.scheme&&ee.added&&(U.dispose(),te())})})}class ie{static{this.KB=1024}static{this.MB=ie.KB*ie.KB}static{this.GB=ie.MB*ie.KB}static{this.TB=ie.GB*ie.KB}static formatSize(ve){return(0,R.$_f)(ve)||(ve=0),ve<ie.KB?(0,b.localize)(1,null,ve.toFixed(0)):ve<ie.MB?(0,b.localize)(2,null,(ve/ie.KB).toFixed(2)):ve<ie.GB?(0,b.localize)(3,null,(ve/ie.MB).toFixed(2)):ve<ie.TB?(0,b.localize)(4,null,(ve/ie.GB).toFixed(2)):(0,b.localize)(5,null,(ve/ie.TB).toFixed(2))}}e.$xl=ie;function me(ue){const ve=typeof ue=="string"||ue?.scheme===A.Schemas.vscodeRemote;return typeof ue!="string"&&ue?.scheme===A.Schemas.file?1024*ie.MB:ve?10*ie.MB:E.$o?50*ie.MB:1024*ie.MB}}),define(ke[257],Pe([1,0,21,13,216,33]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=M;async function M(A,D,$,y,w,h){let g;try{await b(A,D,$,y,w,h)}catch(a){g=a}finally{g&&w.errorTransformer&&(g=w.errorTransformer(g)),typeof g<"u"&&$.error(g),$.end()}}async function b(A,D,$,y,w,h){m(h);const g=await A.open(D,{create:!1});try{m(h);let a=0,n=0,i=w&&typeof w.length=="number"?w.length:void 0,u=d.$Fe.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),o=w&&typeof w.position=="number"?w.position:0,t=0;do n=await A.read(g,o,u.buffer,t,u.byteLength-t),o+=n,t+=n,a+=n,typeof i=="number"&&(i-=n),t===u.byteLength&&(await $.write(y(u)),u=d.$Fe.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&m(h)&&E(a,w));if(t>0){let l=t;typeof i=="number"&&(l=Math.min(t,i)),$.write(y(u.slice(0,l)))}}catch(a){throw(0,R.$dl)(a)}finally{await A.close(g)}}function m(A){if(A.isCancellationRequested)throw(0,N.$6)();return!0}function E(A,D){if(typeof D?.limits?.size=="number"&&A>D.limits.size)throw(0,R.$cl)((0,L.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[65],Pe([1,0,35,3,17,12,2,33]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=e.$Kq=void 0,e.$Iq=m,e.$Jq=E,e.$Nq=y,e.$Oq=w,e.$Pq=h,e.$Qq=g,e.$Rq=n,e.$Sq=i;function m(u){return typeof u.correlationId=="number"}function E(u){return u.recursive===!0}class A extends N.$Vc{static{this.a=5}constructor(o,t,l,r){super(),this.h=o,this.j=t,this.m=l,this.n=r,this.c=this.B(new N.$Wc),this.f=void 0,this.g=0}s(){const o=new N.$Uc;this.c.value=o,this.b=this.r(o),this.b.setVerboseLogging(this.m),o.add(this.b.onDidChangeFile(t=>this.h(t))),o.add(this.b.onDidLogMessage(t=>this.j(t))),o.add(this.b.onDidError(t=>this.t(t)))}t(o){this.n.restartOnError?this.g<A.a&&this.f?(this.w(`restarting watcher after error: ${o}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${o}`):this.w(o)}u(o){this.g++,this.s(),this.watch(o)}async watch(o){this.f=o,await this.b?.watch(o)}async setVerboseLogging(o){this.m=o,await this.b?.setVerboseLogging(o)}w(o){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${o}`})}y(o){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${o}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Kq=A;class D extends A{constructor(o,t,l){super(o,t,l,{type:"node.js",restartOnError:!1})}}e.$Lq=D;class $ extends A{constructor(o,t,l){super(o,t,l,{type:"universal",restartOnError:!0})}}e.$Mq=$;function y(u){return u.map(o=>({type:o.type,resource:M.URI.revive(o.resource),cId:o.cId}))}function w(u){const o=new a;for(const t of u)o.processEvent(t);return o.coalesce()}function h(u,o){return typeof o=="string"&&!o.startsWith(d.$lk)&&!(0,L.$jc)(o)?{base:u,pattern:o}:o}function g(u,o){const t=[];for(const l of o)t.push((0,d.$pk)(h(u,l)));return t}class a{constructor(){this.a=new Set,this.b=new Map}c(o){return R.$k?o.resource.fsPath:o.resource.fsPath.toLowerCase()}processEvent(o){const t=this.b.get(this.c(o));let l=!1;if(t){const r=t.type,c=o.type;t.resource.fsPath!==o.resource.fsPath&&(o.type===2||o.type===1)?l=!0:r===1&&c===2?(this.b.delete(this.c(o)),this.a.delete(t)):r===2&&c===1?t.type=0:r===1&&c===0||(t.type=c)}else l=!0;l&&(this.a.add(o),this.b.set(this.c(o),o))}coalesce(){const o=[],t=[];return Array.from(this.a).filter(l=>l.type!==2?(o.push(l),!1):!0).sort((l,r)=>l.resource.fsPath.length-r.resource.fsPath.length).filter(l=>t.some(r=>(0,b.$jl)(l.resource.fsPath,r,!R.$k))?!1:(t.push(l.resource.fsPath),!0)).concat(o)}}function n(u,o){if(typeof o=="number")switch(u.type){case 1:return(o&4)===0;case 2:return(o&8)===0;case 0:return(o&2)===0}return!1}function i(u){if(typeof u=="number"){const o=[];return u&4&&o.push("Added"),u&8&&o.push("Deleted"),u&2&&o.push("Updated"),o.length===0?"<all>":`[${o.join(", ")}]`}return"<none>"}}),define(ke[258],Pe([1,0,52,3,65,4,2,7]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class m extends N.$Vc{constructor(){super(),this.a=this.B(new R.$ee),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$ee),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$ee),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$5c),this.m=new Set,this.n=5007,this.r=new b.$Sh,this.P=!1,this.B(this.f(A=>this.s(A)))}s(A){this.t(A)&&this.w(A)}t(A){return(0,L.$Iq)(A)}async watch(A){this.r.isSettled||this.r.complete(),this.r=new b.$Sh;try{this.h.clear(),this.g.clear();for(const D of A)this.t(D)?this.h.set(D.correlationId,D):this.g.add(D);for(const[D]of this.j)this.h.has(D)||(this.j.deleteAndDispose(D),this.m.delete(D));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(A=>!this.j.has(A.correlationId))])}isSuspended(A){return typeof A.correlationId!="number"?!1:this.m.has(A.correlationId)?"polling":this.j.has(A.correlationId)}async w(A){if(this.j.has(A.correlationId))return;const D=new N.$Uc;this.j.set(A.correlationId,D),await this.r.p,!D.isDisposed&&(this.z(A,D),this.u())}y(A){this.j.deleteAndDispose(A.correlationId),this.m.delete(A.correlationId),this.u()}z(A,D){this.C(A,D)?(this.N(`reusing an existing recursive watcher to monitor ${A.path}`),this.m.delete(A.correlationId)):(this.D(A,D),this.m.add(A.correlationId))}C(A,D){const $=this.M?.subscribe(A.path,(y,w)=>{D.isDisposed||(y?this.z(A,D):w?.type===1&&this.F(A))});return $?(D.add($),!0):!1}D(A,D){let $=!1;const y=(w,h)=>{if(D.isDisposed)return;const g=this.G(w),a=this.G(h),n=$;$=g,!g&&(a||n)&&this.F(A)};this.N(`starting fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,d.watchFile)(A.path,{persistent:!1,interval:this.n},y)}catch(w){this.O(`fs.watchFile() failed with error ${w} on path ${A.path} (correlationId: ${A.correlationId})`)}D.add((0,N.$Tc)(()=>{this.N(`stopping fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,d.unwatchFile)(A.path,y)}catch(w){this.O(`fs.unwatchFile() failed with error ${w} on path ${A.path} (correlationId: ${A.correlationId})`)}}))}F(A){this.N(`detected ${A.path} exists again, resuming watcher (correlationId: ${A.correlationId})`);const D={resource:M.URI.file(A.path),type:1,cId:A.correlationId};this.a.fire([D]),this.H(D,A),this.y(A)}G(A){return A.ctimeMs===0&&A.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(A,D){if(this.P){const $=` >> normalized ${A.type===1?"[ADDED]":A.type===2?"[DELETED]":"[CHANGED]"} ${A.resource.fsPath}`;this.I($,D)}}I(A,D){this.P&&this.N(`${A}${typeof D.correlationId=="number"?` <${D.correlationId}> `:""}`)}J(A){return`${A.path} (excludes: ${A.excludes.length>0?A.excludes:"<none>"}, includes: ${A.includes&&A.includes.length>0?JSON.stringify(A.includes):"<all>"}, filter: ${(0,L.$Sq)(A.filter)}, correlationId: ${typeof A.correlationId=="number"?A.correlationId:"<none>"})`}async setVerboseLogging(A){this.P=A}}e.$2q=m}),define(ke[259],Pe([1,0,52,7,22,31,3,77,17,12,23,2,104,32,65]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0,e.$8q=g;class h extends M.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,i,u,o,t,l){super(),this.s=n,this.t=i,this.u=u,this.w=o,this.y=t,this.z=l,this.c=this.B(new N.$Kh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},r=>this.u(r))),this.f=this.B(new N.$Jh(r=>this.M(r),h.b)),this.g=(0,w.$Qq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,w.$Qq)(this.s.path,this.s.includes):void 0,this.j=(0,w.$Iq)(this.s)?this.s.filter:void 0,this.m=new L.$pe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const i=await y.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let i=n.path;try{i=await y.Promises.realpath(n.path),n.path===i&&(i=await(0,$.$4q)(n.path,this.m.token)??n.path),n.path!==i&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async G(n,i){const u=new M.$Uc;return this.H(n,i,u)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,i,u)),u}H(n,i,u){if(i)return!1;const o=D.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(l,r)=>{if(!u.isDisposed)if(l){const c=await this.G(n,i);u.isDisposed?c.dispose():u.add(c)}else r&&(typeof r.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:o,type:r.type,cId:this.s.correlationId},!0)});return t?(u.add(t),!0):!1}async I(n,i,u){if(E.$j&&(0,R.$ug)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const o=new L.$pe(this.m.token);u.add((0,M.$Tc)(()=>o.dispose(!0)));const t=new M.$Uc;u.add(t);try{const l=D.URI.file(this.s.path),r=(0,m.$oc)(n),c=(0,d.watch)(n);t.add((0,M.$Tc)(()=>{c.removeAllListeners(),c.close()})),this.Q(`Started watching: '${n}'`);const s=new Set;if(i)try{for(const f of await y.Promises.readdir(n))s.add(f)}catch(f){this.O(f)}if(o.token.isCancellationRequested)return;const v=new Map;t.add((0,M.$Tc)(()=>{for(const[,f]of v)f.dispose();v.clear()})),c.on("error",(f,S)=>{o.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${f}, ${S})`),this.D())}),c.on("change",(f,S)=>{if(o.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${f}"] ${S}`);let p="";if(S&&(p=S.toString(),E.$j&&(p=(0,b.$am)(p))),!(!p||f!=="change"&&f!=="rename"))if(i)if(f==="rename"){v.get(p)?.dispose();const k=setTimeout(async()=>{if(v.delete(p),p===r&&!await y.Promises.exists(n)){this.J(l);return}if(o.token.isCancellationRequested)return;const P=await this.N((0,m.$kc)(n,p));if(o.token.isCancellationRequested)return;let C;P?s.has(p)?C=0:(C=1,s.add(p)):(s.delete(p),C=2),this.L({resource:(0,A.$9g)(l,p),type:C,cId:this.s.correlationId})},h.a);v.set(p,(0,M.$Tc)(()=>clearTimeout(k)))}else{let k;s.has(p)?k=0:(k=1,s.add(p)),this.L({resource:(0,A.$9g)(l,p),type:k,cId:this.s.correlationId})}else if(f==="rename"||p!==r){const k=setTimeout(async()=>{const P=await y.Promises.exists(n);o.token.isCancellationRequested||(P?(this.L({resource:l,type:0,cId:this.s.correlationId},!0),t.add(await this.G(n,!1))):this.J(l))},h.a);t.clear(),t.add((0,M.$Tc)(()=>clearTimeout(k)))}else this.L({resource:l,type:0,cId:this.s.correlationId},!0)})}catch(l){o.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${l.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,i=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(u=>u(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(u=>u(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const i=(0,w.$Oq)(n),u=[];for(const t of i){if((0,w.$Rq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}u.push(t)}if(u.length===0)return;if(this.z)for(const t of u)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(E.$k)return y.Promises.exists(n);try{const i=(0,m.$oc)(n);return(await y.Promises.readdir((0,m.$nc)(n))).some(o=>o===i)}catch(i){return this.Q(i),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$7q=h;async function g(a,n,i,u,o=512){const t=await y.Promises.open(a,"r"),l=Buffer.allocUnsafe(o),r=new L.$pe(u);let c,s=!1;const v={path:a,excludes:[],recursive:!1},f=new h(v,void 0,S=>{(async()=>{for(const{type:p}of S)if(p===0){if(s)return;s=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:k}=await y.Promises.read(t,l,0,o,null);if(!k||r.token.isCancellationRequested)break;n(l.slice(0,k))}}catch(k){c=new Error(k),r.dispose(!0)}finally{s=!1}}})()});return await f.ready,i(),new Promise((S,p)=>{r.token.onCancellationRequested(async()=>{f.dispose();try{await y.Promises.close(t)}catch(k){c=new Error(k)}c?p(c):S()})})}}),define(ke[260],Pe([1,0,4,35,258,12,259,31]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;class m extends L.$2q{constructor(A){super(),this.M=A,this.onDidError=d.Event.None,this.watchers=new Set}async L(A){A=this.X(A);const D=[],$=new Set(Array.from(this.watchers));for(const y of A){const w=this.S(y);w&&(0,N.$tk)(w.request.excludes,y.excludes)&&(0,N.$tk)(w.request.includes,y.includes)?$.delete(w):D.push(y)}D.length&&this.N(`Request to start watching: ${D.map(y=>this.J(y)).join(",")}`),$.size&&this.N(`Request to stop watching: ${Array.from($).map(y=>this.J(y.request)).join(",")}`);for(const y of $)this.W(y);for(const y of D)this.U(y)}S(A){for(const D of this.watchers)if(typeof A.correlationId=="number"||typeof D.request.correlationId=="number"){if(D.request.correlationId===A.correlationId)return D}else if((0,b.$tg)(D.request.path,A.path,!R.$k))return D}U(A){const D=new M.$7q(A,this.M,y=>this.a.fire(y),()=>this.c.fire(A),y=>this.b.fire(y),this.P),$={request:A,instance:D};this.watchers.add($)}async stop(){await super.stop();for(const A of this.watchers)this.W(A)}W(A){this.N("stopping file watcher",A),this.watchers.delete(A),A.instance.dispose()}X(A){const D=new Map;for(const $ of A){const y=R.$k?$.path:$.path.toLowerCase();let w=D.get($.correlationId);w||(w=new Map,D.set($.correlationId,w)),w.has(y)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J($)}`),w.set(y,$)}return Array.from(D.values()).map($=>Array.from($.values())).flat()}async setVerboseLogging(A){super.setVerboseLogging(A);for(const D of this.watchers)D.instance.setVerboseLogging(A)}N(A,D){this.P&&this.b.fire({type:"trace",message:this.$(A,D)})}O(A){this.b.fire({type:"warn",message:this.$(A)})}$(A,D){return D?`[File Watcher (node.js)] ${A} (${this.J(D.request)})`:`[File Watcher (node.js)] ${A}`}}e.$9q=m}),define(ke[261],Pe([1,0,65,260]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class L extends d.$Lq{constructor(M,b,m){super(M,b,m),this.s()}r(M){return M.add(new N.$9q(void 0))}}e.$0q=L}),define(ke[262],Pe([1,0,15,82,199,65]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;class M extends R.$Mq{constructor(m,E,A){super(m,E,A),this.s()}r(m){const E=m.add(new L.$Zq(d.$Pg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return m.add(E.onDidProcessExit(({code:A,signal:D})=>this.t(`terminated by itself with code ${A}, signal: ${D} (ETERM)`))),N.ProxyChannel.toService((0,N.$ci)(E.getChannel("watcher")))}}e.$1q=M}),define(ke[107],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class d{constructor(...L){this.a=new Map;for(const[R,M]of L)this.set(R,M)}set(L,R){const M=this.a.get(L);return this.a.set(L,R),M}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$ti=d}),define(ke[263],Pe([1,0,7,13,3,106,253,5,107,76]),function(le,e,d,N,L,R,M,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=void 0;const A=!1;class D extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class ${constructor(g=new m.$ti,a=!1,n,i=A){this.i=g,this.j=a,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(b.$ui,this),this._globalGraph=i?n?._globalGraph??new M.$ar(u=>u):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Qc)(this.h),this.h.clear();for(const g of this.g)(0,L.$Pc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g){this.m();const a=new class extends ${dispose(){this.h.delete(a),super.dispose()}}(g,this.j,this,this.l);return this.h.add(a),a}invokeFunction(g,...a){this.m();const n=w.traceInvocation(this.l,g);let i=!1;try{return g({get:o=>{if(i)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(o,n);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...a)}finally{i=!0,n.stop()}}createInstance(g,...a){this.m();let n,i;return g instanceof R.$si?(n=w.traceCreation(this.l,g.ctor),i=this.o(g.ctor,g.staticArguments.concat(a),n)):(n=w.traceCreation(this.l,g),i=this.o(g,a,n)),n.stop(),i}o(g,a=[],n){const i=b._util.getServiceDependencies(g).sort((t,l)=>t.index-l.index),u=[];for(const t of i){const l=this.s(t.id,n);l||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),u.push(l)}const o=i.length>0?i[0].index:a.length;if(a.length!==o){console.trace(`[createInstance] First service dependency of ${g.name} at position ${o+1} conflicts with ${a.length} static arguments`);const t=o-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,o)}return Reflect.construct(g,a.concat(u))}q(g,a){if(this.i.get(g)instanceof R.$si)this.i.set(g,a);else if(this.k)this.k.q(g,a);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const a=this.i.get(g);return!a&&this.k?this.k.r(g):a}s(g,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const n=this.r(g);return n instanceof R.$si?this.u(g,n,a.branch(g,!0)):(a.branch(g,!1),n)}u(g,a,n){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,a,n)}finally{this.t.delete(g)}}v(g,a,n){const i=new M.$ar(t=>t.id.toString());let u=0;const o=[{id:g,desc:a,_trace:n}];for(;o.length;){const t=o.pop();if(i.lookupOrInsertNode(t),u++>1e3)throw new D(i);for(const l of b._util.getServiceDependencies(t.desc.ctor)){const r=this.r(l.id);if(r||this.y(`[createInstance] ${g} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),r instanceof R.$si){const c={id:l.id,desc:r,_trace:t._trace.branch(l.id,!0)};i.insertEdge(t,c),o.push(c)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new D(i);break}for(const{data:l}of t){if(this.r(l.id)instanceof R.$si){const c=this.w(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.q(l.id,c)}i.removeNode(l)}}return this.r(g)}w(g,a,n=[],i,u){if(this.i.get(g)instanceof R.$si)return this.x(g,a,n,i,u,this.g);if(this.k)return this.k.w(g,a,n,i,u);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}x(g,a,n=[],i,u,o){if(i){const t=new $(void 0,this.j,this,this.l);t.c=String(g);const l=new Map,r=new d.$Oh(()=>{const c=t.o(a,n,u);for(const[s,v]of l){const f=c[s];if(typeof f=="function")for(const S of v)S.disposable=f.apply(c,S.listener)}return l.clear(),o.add(c),c});return new Proxy(Object.create(null),{get(c,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let S=l.get(s);return S||(S=new E.$6c,l.set(s,S)),(k,P,C)=>{if(r.isInitialized)return r.value[s](k,P,C);{const I={listener:[k,P,C],disposable:void 0},T=S.push(I);return(0,L.$Tc)(()=>{T(),I.disposable?.dispose()})}}}if(s in c)return c[s];const v=r.value;let f=v[s];return typeof f!="function"||(f=f.bind(v),c[s]=f),f},set(c,s,v){return r.value[s]=v,!0},getPrototypeOf(c){return a.prototype}})}else{const t=this.o(a,n,u);return o.add(t),t}}y(g,a){if(a&&console.warn(g),this.j)throw new Error(g)}}e.$br=$;var y;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(y||(y={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,a){return g?new w(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(g,a){return g?new w(1,a.name):w.c}static{this.f=0}constructor(g,a){this.type=g,this.name=a,this.g=Date.now(),this.h=[]}branch(g,a){const n=new w(3,g.toString());return this.h.push([g,a,n]),n}stop(){const g=Date.now()-this.g;w.f+=g;let a=!1;function n(u,o){const t=[],l=new Array(u+1).join("	");for(const[r,c,s]of o.h)if(c&&s){a=!0,t.push(`${l}CREATES -> ${r}`);const v=n(u+1,s);v&&t.push(v)}else t.push(`${l}uses -> ${r}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(g>2||a)&&w.all.add(i.join(`
`))}}e.$cr=w}),define(ke[11],Pe([1,0,218,47,4,56,3,27,12,23,18,2,38,5]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$5j=e.LogLevel=e.$3j=e.$2j=void 0,e.$4j=h,e.log=a,e.$dk=f,e.$ek=S,e.$fk=p,e.$gk=k,e.$2j=(0,y.$vi)("logService"),e.$3j=(0,y.$vi)("loggerService");function w(){return new Date().toISOString()}function h(P){return(0,A.$_f)(P)}var g;(function(P){P[P.Off=0]="Off",P[P.Trace=1]="Trace",P[P.Debug=2]="Debug",P[P.Info=3]="Info",P[P.Warning=4]="Warning",P[P.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$5j=g.Info;function a(P,C,I){switch(C){case g.Trace:P.trace(I);break;case g.Debug:P.debug(I);break;case g.Info:P.info(I);break;case g.Warning:P.warn(I);break;case g.Error:P.error(I);break;case g.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(P,C=!1){let I="";for(let T=0;T<P.length;T++){let j=P[T];if(j instanceof Error&&(j=(0,N.$gj)(j,C)),typeof j=="object")try{j=JSON.stringify(j)}catch{}I+=(T>0?" ":"")+j}return I}class i extends M.$Vc{constructor(){super(...arguments),this.b=e.$5j,this.c=this.B(new L.$ee),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==g.Off&&this.b<=C}}e.$7j=i;class u extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...I){this.f(g.Trace)&&this.g(g.Trace,n([C,...I],!0))}debug(C,...I){this.f(g.Debug)&&this.g(g.Debug,n([C,...I]))}info(C,...I){this.f(g.Info)&&this.g(g.Info,n([C,...I]))}warn(C,...I){this.f(g.Warning)&&this.g(g.Warning,n([C,...I]))}error(C,...I){if(this.f(g.Error))if(C instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=C.stack,this.g(g.Error,n(T))}else this.g(g.Error,n([C,...I]))}flush(){}}e.$8j=u;class o extends i{constructor(C=e.$5j){super(),this.setLevel(C),this.g=!m.$i}trace(C,...I){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,C,...I):console.log(`[main ${w()}]`,C,...I))}debug(C,...I){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,C,...I):console.log(`[main ${w()}]`,C,...I))}info(C,...I){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,C,...I):console.log(`[main ${w()}]`,C,...I))}warn(C,...I){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,C,...I):console.warn(`[main ${w()}]`,C,...I))}error(C,...I){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,C,...I):console.error(`[main ${w()}]`,C,...I))}flush(){}}e.$9j=o;class t extends i{constructor(C=e.$5j,I=!0){super(),this.g=I,this.setLevel(C)}trace(C,...I){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...I):console.log(C,...I))}debug(C,...I){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...I):console.log(C,...I))}info(C,...I){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...I):console.log(C,...I))}warn(C,...I){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...I):console.log(C,...I))}error(C,...I){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...I):console.error(C,...I))}flush(){}}e.$0j=t;class l extends i{constructor(C,I=e.$5j){super(),this.g=C,this.setLevel(I)}trace(C,...I){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(C),...I])}debug(C,...I){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(C),...I])}info(C,...I){this.f(g.Info)&&this.g.log(g.Info,[this.h(C),...I])}warn(C,...I){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(C),...I])}error(C,...I){this.f(g.Error)&&this.g.log(g.Error,[this.h(C),...I])}h(C){return typeof C=="string"?C:(0,N.$gj)(C,this.f(g.Trace))}flush(){}}e.$$j=l;class r extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const I of this.g)I.setLevel(C);super.setLevel(C)}trace(C,...I){for(const T of this.g)T.trace(C,...I)}debug(C,...I){for(const T of this.g)T.debug(C,...I)}info(C,...I){for(const T of this.g)T.info(C,...I)}warn(C,...I){for(const T of this.g)T.warn(C,...I)}error(C,...I){for(const T of this.g)T.error(C,...I)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$_j=r;class c extends M.$Vc{constructor(C,I,T){if(super(),this.h=C,this.j=I,this.b=new b.$Bc,this.c=this.B(new L.$ee),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$ee),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$ee),this.onDidChangeVisibility=this.g.event,T)for(const j of T)this.b.set(j.resource,{logger:void 0,info:j})}m(C){return(0,A.$8f)(C)?[...this.b.values()].find(I=>I.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,I){const T=this.n(C),j=(0,A.$8f)(C)?C:I?.id??(0,R.$jj)(T.toString()).toString(16);let z=this.b.get(T)?.logger;const O=I?.logLevel==="always"?g.Trace:I?.logLevel;z||(z=this.s(T,O??this.getLogLevel(T)??this.h,{...I,id:j}));const F={logger:z,info:{resource:T,id:j,logLevel:O,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(F.info),this.b.set(T,F),z}n(C){return(0,A.$8f)(C)?(0,E.$9g)(this.j,`${C}.log`):C}setLogLevel(C,I){if(D.URI.isUri(C)){const T=C,j=I,z=this.b.get(T);z&&j!==z.info.logLevel&&(z.info.logLevel=j===this.h?void 0:j,z.logger?.setLevel(j),this.b.set(z.info.resource,z),this.f.fire([T,j]))}else{this.h=C;for(const[T,j]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,I){const T=this.m(C);T&&I!==!T.info.hidden&&(T.info.hidden=!I,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,I]))}getLogLevel(C){let I;return C&&(I=this.b.get(C)?.info.logLevel),I??this.h}registerLogger(C){const I=this.b.get(C.resource);I?I.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const I=this.b.get(C);I&&(I.logger&&I.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ak=c;class s{constructor(){this.onDidChangeLogLevel=new L.$ee().event}setLevel(C){}getLevel(){return g.Info}trace(C,...I){}debug(C,...I){}info(C,...I){}warn(C,...I){}error(C,...I){}critical(C,...I){}dispose(){}flush(){}}e.$bk=s;class v extends s{}e.$ck=v;function f(P){if(P.verbose)return g.Trace;if(typeof P.logLevel=="string"){const C=k(P.logLevel.toLowerCase());if(C!==void 0)return C}return e.$5j}function S(P){switch(P){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function p(P){switch(P){case g.Trace:return{original:"Trace",value:d.localize(0,null)};case g.Debug:return{original:"Debug",value:d.localize(1,null)};case g.Info:return{original:"Info",value:d.localize(2,null)};case g.Warning:return{original:"Warning",value:d.localize(3,null)};case g.Error:return{original:"Error",value:d.localize(4,null)};case g.Off:return{original:"Off",value:d.localize(5,null)}}}function k(P){switch(P){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$hk=new $.$Mj("logLevel",S(g.Info))}),define(ke[264],Pe([1,0,19,7,13,4,31,3,17,65,11]),function(le,e,d,N,L,R,M,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class D extends b.$Vc{constructor(y,w){super(),this.a=y,this.b=w,this.c=this.B(new R.$ee),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$ee),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$th(0)),this.w=[],this.y=this.B(new N.$th(0))}watch(y,w){return w.recursive||this.b?.watcher?.forceUniversal?this.n(y,w):this.z(y,w)}n(y,w){const h={path:this.J(y),excludes:w.excludes,includes:w.includes,recursive:w.recursive,filter:w.filter,correlationId:w.correlationId},g=(0,d.$Ub)(this.j,h);return this.r(),(0,b.$Tc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,L.$1)(y))}s(){this.h||(this.h=this.B(this.t(w=>this.c.fire((0,E.$Nq)(w)),w=>this.G(w),this.a.getLevel()===A.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===A.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const w of this.j)(0,E.$Jq)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const w of this.j)(0,E.$Jq)(w)&&y.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,w){const h={path:this.J(y),excludes:w.excludes,includes:w.includes,recursive:!1,filter:w.filter,correlationId:w.correlationId},g=(0,d.$Ub)(this.w,h);return this.C(),(0,b.$Tc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,L.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,E.$Nq)(y)),y=>this.G(y),this.a.getLevel()===A.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===A.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.H(y)}H(y){this.a[y.type](y.message)}I(y){return(0,m.$ic)(y.fsPath)}J(y){const w=this.I(y);return(0,M.$xg)(w)}}e.$Tq=D}),define(ke[265],Pe([1,0,52,402,7,27,21,4,31,3,17,12,23,98,32,217,33,257,264,47,262,261]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0,(()=>{try{(0,N.gracefulify)(d)}catch(l){console.error(`Error enabling graceful-fs: ${(0,i.$gj)(l)}`)}})();class t extends n.$Tq{static{this.L=!1}constructor(r,c){super(r,c),this.onDidChangeCapabilities=b.Event.None,this.P=new R.$Bc(s=>$.$Zg.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,D.$k&&(this.M|=1024)),this.M}async stat(r){try{const{stat:c,symbolicLink:s}=await w.SymlinkSupport.stat(this.I(r));return{type:this.O(c,s),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size,permissions:c.mode&128?void 0:g.FilePermission.Locked}}catch(c){throw this.hb(c)}}async N(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const c=await w.Promises.readdir(this.I(r),{withFileTypes:!0}),s=[];return await Promise.all(c.map(async v=>{try{let f;v.isSymbolicLink()?f=(await this.stat((0,$.$9g)(r,v.name))).type:f=this.O(v),s.push([v.name,f])}catch(f){this.a.trace(f)}})),s}catch(c){throw this.hb(c)}}O(r,c){let s;return c?.dangling?s=g.FileType.Unknown:r.isFile()?s=g.FileType.File:r.isDirectory()?s=g.FileType.Directory:s=g.FileType.Unknown,c&&(s|=g.FileType.SymbolicLink),s}async Q(r){const c=this.I(r);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${c})`);let s;for(;s=this.P.get(r);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${c})`),await s.wait();const v=new L.$uh;return this.P.set(r,v),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${c})`),(0,E.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${c})`),this.P.get(r)===v&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${c})`),this.P.delete(r)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${c})`),v.open()})}async readFile(r,c){let s;try{c?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(r)})`),s=await this.Q(r));const v=this.I(r);return await w.Promises.readFile(v)}catch(v){throw this.hb(v)}finally{s?.dispose()}}R(r){t.L&&this.a.trace(r)}readFileStream(r,c,s){const v=(0,y.$te)(f=>M.$Fe.concat(f.map(S=>M.$Fe.wrap(S))).buffer);return(0,a.$Gq)(this,r,v,f=>f.buffer,{...c,bufferSize:256*1024},s),v}async writeFile(r,c,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(r)?this.U(r,(0,$.$9g)((0,$.$8g)(r),`${(0,$.$6g)(r)}${s.atomic.postfix}`),c,s):this.W(r,c,s)}async S(r){try{const c=this.I(r),{symbolicLink:s}=await w.SymlinkSupport.stat(c);if(s)return!1}catch{}return!0}async U(r,c,s,v){const f=new E.$Uc;try{f.add(await this.Q(r)),f.add(await this.Q(c)),await this.W(c,s,v,!0);try{await this.rename(c,r,{overwrite:!0})}catch(S){try{await this.delete(c,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{f.dispose()}}async W(r,c,s,v){let f;try{const S=this.I(r);if(!s.create||!s.overwrite){if(await w.Promises.exists(S)){if(!s.overwrite)throw(0,g.$cl)((0,h.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,g.$cl)((0,h.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(r,{create:!0,unlock:s.unlock},v),await this.write(f,0,c,0,c.byteLength)}catch(S){throw await this.ib(r,S)}finally{typeof f=="number"&&await this.close(f)}}static{this.$=!0}static configureFlushOnWrite(r){t.$=r}async open(r,c,s){const v=this.I(r);let f;(0,g.$3k)(c)&&!s&&(f=await this.Q(r));let S;try{if((0,g.$3k)(c)&&c.unlock)try{const{stat:k}=await w.SymlinkSupport.stat(v);k.mode&128||await w.Promises.chmod(v,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let p;if((0,g.$3k)(c)){if(D.$i)try{await w.Promises.truncate(v,0),p="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}p||(p="w")}else p="r";S=await w.Promises.open(v,p)}catch(p){throw f?.dispose(),(0,g.$3k)(c)?await this.ib(r,p):this.hb(p)}if(this.X.set(S,0),(0,g.$3k)(c)&&this.Z.set(S,r),f){const p=this.Y.get(S);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${v})`),this.Y.set(S,f),p&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${v})`),p.dispose())}return S}async close(r){const c=this.Y.get(r);try{if(this.X.delete(r),this.Z.delete(r)&&t.$)try{await w.Promises.fdatasync(r)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await w.Promises.close(r)}catch(s){throw this.hb(s)}finally{c&&(this.Y.get(r)===c&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.Y.delete(r)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),c.dispose())}}async read(r,c,s,v,f){const S=this.ab(r,c);let p=null;try{p=(await w.Promises.read(r,s,v,f,S)).bytesRead}catch(k){throw this.hb(k)}finally{this.bb(r,S,p)}return p}ab(r,c){return c===this.X.get(r)?null:c}bb(r,c,s){const v=this.X.get(r);typeof v=="number"&&(typeof c=="number"||(typeof s=="number"?this.X.set(r,v+s):this.X.delete(r)))}async write(r,c,s,v,f){return(0,L.$Ph)(()=>this.cb(r,c,s,v,f),100,3)}async cb(r,c,s,v,f){const S=this.ab(r,c);let p=null;try{p=(await w.Promises.write(r,s,v,f,S)).bytesWritten}catch(k){throw await this.ib(this.Z.get(r),k)}finally{this.bb(r,S,p)}return p}async mkdir(r){try{await w.Promises.mkdir(this.I(r))}catch(c){throw this.hb(c)}}async delete(r,c){try{const s=this.I(r);if(c.recursive){let v;c?.atomic!==!1&&c.atomic.postfix&&(v=(0,A.$kc)((0,A.$nc)(s),`${(0,A.$oc)(s)}${c.atomic.postfix}`)),await w.Promises.rm(s,w.RimRafMode.MOVE,v)}else try{await w.Promises.unlink(s)}catch(v){if(v.code==="EPERM"||v.code==="EISDIR"){let f=!1;try{const{stat:S,symbolicLink:p}=await w.SymlinkSupport.stat(s);f=S.isDirectory()&&!p}catch{}if(f)await w.Promises.rmdir(s);else throw v}else throw v}}catch(s){throw this.hb(s)}}async rename(r,c,s){const v=this.I(r),f=this.I(c);if(v!==f)try{await this.db(r,c,"move",s.overwrite),await w.Promises.rename(v,f)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,h.localize)(2,null,(0,A.$oc)(v),(0,A.$oc)((0,A.$nc)(f)),S.toString()))),this.hb(S)}}async copy(r,c,s){const v=this.I(r),f=this.I(c);if(v!==f)try{await this.db(r,c,"copy",s.overwrite),await w.Promises.copy(v,f,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,h.localize)(3,null,(0,A.$oc)(v),(0,A.$oc)((0,A.$nc)(f)),S.toString()))),this.hb(S)}}async db(r,c,s,v){const f=this.I(r),S=this.I(c);let p=!1;if(!!(this.capabilities&1024)||(p=(0,m.$tg)(f,S,!0)),p){if(s==="copy")throw(0,g.$cl)((0,h.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const P=await this.N(r);if(!P)throw(0,g.$cl)((0,h.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(c);if(C){if(!v)throw(0,g.$cl)((0,h.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);P.type&g.FileType.File&&C.type&g.FileType.File||await this.delete(c,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,c){return this.eb(r,c,!1)}async eb(r,c,s){const v=this.I(r),f=this.I(c),S=!!(this.capabilities&1024);if((0,m.$tg)(v,f,!S))return;const p=new E.$Uc;try{p.add(await this.Q(r)),p.add(await this.Q(c)),s&&await w.Promises.mkdir((0,A.$nc)(f),{recursive:!0}),await w.Promises.copyFile(v,f)}catch(k){if(k.code==="ENOENT"&&!s)return this.eb(r,c,!0);throw this.hb(k)}finally{p.dispose()}}t(r,c,s){return new u.$1q(v=>r(v),v=>c(v),s)}F(r,c,s){return new o.$0q(v=>r(v),v=>c(v),s)}hb(r){if(r instanceof g.$bl)return r;let c=r,s;switch(r.code){case"ENOENT":s=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":c=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=g.FileSystemProviderErrorCode.Unknown;break;default:s=g.FileSystemProviderErrorCode.Unknown}return(0,g.$cl)(c,s)}async ib(r,c){let s=this.hb(c);if(r&&s.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:v}=await w.SymlinkSupport.stat(this.I(r));v.mode&128||(s=(0,g.$cl)(c,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(v){this.a.trace(v)}return s}}e.$$q=t}),define(ke[266],Pe([1,0,3,11]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=void 0;class L extends d.$Vc{constructor(M,b=[]){super(),this.a=new N.$_j([M,...b]),this.B(M.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...b){this.a.trace(M,...b)}debug(M,...b){this.a.debug(M,...b)}info(M,...b){this.a.info(M,...b)}warn(M,...b){this.a.warn(M,...b)}error(M,...b){this.a.error(M,...b)}flush(){this.a.flush()}}e.$MQ=L}),define(ke[267],Pe([1,0,33,11]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BQ=void 0;var L;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(L||(L={}));async function R(E,A,D,$,y){try{const w=await new Promise((g,a)=>{le(["@vscode/spdlog"],g,a)});w.setFlushOn(L.Trace);const h=await w.createAsyncRotatingLogger(E,A,D,$);return y?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(w){console.error(w)}return null}function M(E,A,D){switch(A){case N.LogLevel.Trace:E.trace(D);break;case N.LogLevel.Debug:E.debug(D);break;case N.LogLevel.Info:E.info(D);break;case N.LogLevel.Warning:E.warn(D);break;case N.LogLevel.Error:E.error(D);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(E,A){switch(A){case N.LogLevel.Trace:E.setLevel(L.Trace);break;case N.LogLevel.Debug:E.setLevel(L.Debug);break;case N.LogLevel.Info:E.setLevel(L.Info);break;case N.LogLevel.Warning:E.setLevel(L.Warning);break;case N.LogLevel.Error:E.setLevel(L.Error);break;case N.LogLevel.Off:E.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class m extends N.$8j{constructor(A,D,$,y,w){super(),this.m=[],this.setLevel(w),this.n=this.s(A,D,$,y),this.B(this.onDidChangeLogLevel(h=>{this.r&&b(this.r,h)}))}async s(A,D,$,y){const w=$?6:1,h=30/w*d.$xl.MB,g=await R(A,D,h,w,y);if(g){this.r=g,b(this.r,this.getLevel());for(const{level:a,message:n}of this.m)M(this.r,a,n);this.m=[]}}g(A,D){this.r?M(this.r,A,D):this.getLevel()<=A&&this.m.push({level:A,message:D})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$BQ=m}),define(ke[139],Pe([1,0,41,219,5]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var M;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(m){function E(w,h){return h-w}m.compare=E;const A=Object.create(null);A[m.Error]=(0,N.localize)(0,null),A[m.Warning]=(0,N.localize)(1,null),A[m.Info]=(0,N.localize)(2,null);function D(w){return A[w]||""}m.toString=D;function $(w){switch(w){case d.default.Error:return m.Error;case d.default.Warning:return m.Warning;case d.default.Info:return m.Info;case d.default.Ignore:return m.Hint}}m.fromSeverity=$;function y(w){switch(w){case m.Error:return d.default.Error;case m.Warning:return d.default.Warning;case m.Info:return d.default.Info;case m.Hint:return d.default.Ignore}}m.toSeverity=y}(M||(e.MarkerSeverity=M={}));var b;(function(m){const E="";function A($){return D($,!0)}m.makeKey=A;function D($,y){const w=[E];return $.source?w.push($.source.replace("\xA6","\\\xA6")):w.push(E),$.code?typeof $.code=="string"?w.push($.code.replace("\xA6","\\\xA6")):w.push($.code.value.replace("\xA6","\\\xA6")):w.push(E),$.severity!==void 0&&$.severity!==null?w.push(M.toString($.severity)):w.push(E),$.message&&y?w.push($.message.replace("\xA6","\\\xA6")):w.push(E),$.startLineNumber!==void 0&&$.startLineNumber!==null?w.push($.startLineNumber.toString()):w.push(E),$.startColumn!==void 0&&$.startColumn!==null?w.push($.startColumn.toString()):w.push(E),$.endLineNumber!==void 0&&$.endLineNumber!==null?w.push($.endLineNumber.toString()):w.push(E),$.endColumn!==void 0&&$.endColumn!==null?w.push($.endColumn.toString()):w.push(E),w.push(E),w.join("\xA6")}m.makeKeyOptionalMessage=D})(b||(e.IMarkerData=b={})),e.$3t=(0,L.$vi)("markerService")}),define(ke[268],Pe([1,0,4,41,5]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=e.$5v=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$3v=e.Severity=void 0,e.$4v=b,e.Severity=N.default,e.$3v=(0,L.$vi)("notificationService");var R;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var M;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function b(D){if(D){const $=D;return typeof $.id=="string"&&typeof $.label=="string"}return!1}var m;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class E{constructor(){this.progress=new A,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity($){}updateMessage($){}updateActions($){}close(){}}e.$5v=E;class A{infinite(){}done(){}total($){}worked($){}}e.$6v=A}),define(ke[269],Pe([1,0,51]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const R=L.context.configuration();if(R)N=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,d.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:R.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ke[108],Pe([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jk=e.$ik=void 0,e.$ik=(0,d.$vi)("productService"),e.$jk="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(le,e){return function(d,N){e(d,N,le)}};define(ke[109],Pe([1,0,7,22,3,5]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.$8v=e.ProgressLocation=e.$7v=void 0,e.$7v=(0,R.$vi)("progressService");var M;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$8v=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor($){this.b=$}report($){this.a=$,this.b(this.a)}}e.$9v=b;class m{get value(){return this.a}constructor($){this.e=$}report($){this.b?this.b.push($):this.b=[$],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const $=this.b.shift();this.a=$,await this.e(this.a)}}finally{this.c=!1;const $=this.d;this.d=void 0,$?.()}}drain(){return this.c?new Promise($=>{const y=this.d;this.d=()=>{y?.(),$()}}):Promise.resolve()}}e.$0v=m;let E=class extends L.$Vc{constructor($,y){super(),this.a=new d.$Sh,y.withProgress($,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,L.$Tc)(()=>this.a.complete()))}report($){this.b?this.b.report($):this.c=$}};e.$$v=E,e.$$v=E=Je([Ve(1,e.$7v)],E);class A extends L.$Vc{constructor($){super(),this.g=$,this.a=0,this.b=this.B(new L.$Uc)}start($){this.stop();const y=++this.a,w=new N.$pe;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},$),this.b.add((0,L.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,L.$Tc)(()=>w.cancel())),this.b.add((0,L.$Tc)(()=>this.c?this.c.done():void 0)),{id:y,token:w.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h($){this.a===$&&this.b.clear()}}e.$_v=A,e.$aw=(0,R.$vi)("editorProgressService")}),define(ke[36],Pe([1,0,62,18]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=void 0;class L{constructor(){this.a=new Map}add(M,b){d.ok(N.$8f(M)),d.ok(N.$0f(b)),d.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,b)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$bo=new L}),define(ke[110],Pe([1,0,4,36]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0,e.$co={JSONContribution:"base.contributions.json"};function L(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class R{constructor(){this.b=new d.$ee,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,E){this.a[L(m)]=E,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const M=new R;N.$bo.add(e.$co.JSONContribution,M)}),define(ke[66],Pe([1,0,19,4,18,208,54,110,36]),function(le,e,d,N,L,R,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.ConfigurationScope=e.$go=e.EditPresentationTypes=void 0,e.$ro=h,e.$so=g,e.$to=a,e.$uo=i,e.$vo=u;var E;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$go={Configuration:"base.contributions.configuration"};var A;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$ho={properties:{},patternProperties:{}},e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no="vscode://schemas/settings/resourceLanguage",e.$oo="vscode://schemas/settings/configurationDefaults";const D=m.$bo.as(b.$co.JSONContribution);class ${constructor(){this.h=new Set,this.i=new N.$ee,this.onDidSchemaChange=this.i.event,this.j=new N.$ee,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$no,this.g),this.v()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const r=new Set;this.n(t,l,r),D.registerSchema(e.$no,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const l=new Set;this.o(t,l),D.registerSchema(e.$no,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:t,remove:l}){const r=new Set;this.o(l,r),this.n(t,!1,r),D.registerSchema(e.$no,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const l=new Set;this.k(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(t,l){const r=[];for(const{overrides:c,source:s}of t)for(const v in c)if(l.add(v),e.$qo.test(v)){const f=this.a.get(v),S=f?.valuesSources??new Map;if(s)for(const C of Object.keys(c[v]))S.set(C,s);const p={...f?.value||{},...c[v]};this.a.set(v,{source:s,value:p,valuesSources:S});const k=(0,M.$_i)(v),P={type:"object",default:p,description:R.localize(1,null,k),$ref:e.$no,defaultDefaultValue:p,source:L.$8f(s)?void 0:s,defaultValueSource:s};r.push(...h(v)),this.d[v]=P,this.b.properties[v]=P}else{this.a.set(v,{value:c[v],source:s});const f=this.d[v];f&&(this.w(v,f),this.r(v,f))}this.m(r)}deregisterDefaultConfigurations(t){const l=new Set;this.l(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(t,l){for(const{overrides:r,source:c}of t)for(const s in r){const v=this.a.get(s),f=L.$8f(c)?c:c?.id,S=L.$8f(v?.source)?v?.source:v?.source?.id;if(f===S)if(l.add(s),this.a.delete(s),e.$qo.test(s))delete this.d[s],delete this.b.properties[s];else{const p=this.d[s];p&&(this.w(s,p),this.r(s,p))}}this.u()}deltaConfiguration(t){let l=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),l=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),l=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const l of t)this.h.add(l);this.u()}n(t,l,r){t.forEach(c=>{this.p(c,l,c.extensionInfo,c.restrictedProperties,void 0,r),this.c.push(c),this.q(c)})}o(t,l){const r=c=>{if(c.properties)for(const s in c.properties){l.add(s);const v=this.d[s];v?.policy?.name&&this.e.delete(v.policy.name),delete this.d[s],this.s(s,c.properties[s])}c.allOf?.forEach(s=>r(s))};for(const c of t){r(c);const s=this.c.indexOf(c);s!==-1&&this.c.splice(s,1)}}p(t,l=!0,r,c,s=3,v){s=L.$eg(t.scope)?s:t.scope;const f=t.properties;if(f)for(const p in f){const k=f[p];if(l&&i(p,k)){delete f[p];continue}if(k.source=r,k.defaultDefaultValue=f[p].default,this.w(p,k),e.$qo.test(p)?k.scope=void 0:(k.scope=L.$eg(k.scope)?s:k.scope,k.restricted=L.$eg(k.restricted)?!!c?.includes(p):k.restricted),f[p].hasOwnProperty("included")&&!f[p].included){this.f[p]=f[p],delete f[p];continue}else this.d[p]=f[p],f[p].policy?.name&&this.e.set(f[p].policy.name,p);!f[p].deprecationMessage&&f[p].markdownDeprecationMessage&&(f[p].deprecationMessage=f[p].markdownDeprecationMessage),v.add(p)}const S=t.allOf;if(S)for(const p of S)this.p(p,l,r,c,s,v)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const l=r=>{const c=r.properties;if(c)for(const v in c)this.r(v,c[v]);r.allOf?.forEach(l)};l(t)}r(t,l){switch(e.$ho.properties[t]=l,l.scope){case 1:e.$io.properties[t]=l;break;case 2:e.$jo.properties[t]=l;break;case 6:e.$ko.properties[t]=l;break;case 3:e.$lo.properties[t]=l;break;case 4:e.$mo.properties[t]=l;break;case 5:e.$mo.properties[t]=l,this.g.properties[t]=l;break}}s(t,l){switch(delete e.$ho.properties[t],l.scope){case 1:delete e.$io.properties[t];break;case 2:delete e.$jo.properties[t];break;case 6:delete e.$ko.properties[t];break;case 3:delete e.$lo.properties[t];break;case 4:case 5:delete e.$mo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const l=`[${t}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$no};this.w(l,r),e.$ho.properties[l]=r,e.$io.properties[l]=r,e.$jo.properties[l]=r,e.$ko.properties[l]=r,e.$lo.properties[l]=r,e.$mo.properties[l]=r}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$no};e.$ho.patternProperties[e.$po]=t,e.$io.patternProperties[e.$po]=t,e.$jo.patternProperties[e.$po]=t,e.$ko.patternProperties[e.$po]=t,e.$lo.patternProperties[e.$po]=t,e.$mo.patternProperties[e.$po]=t,this.i.fire()}w(t,l){const r=this.a.get(t);let c=r?.value,s=r?.source;L.$cg(c)&&(c=l.defaultDefaultValue,s=void 0),L.$cg(c)&&(c=a(l.type)),l.default=c,l.defaultValueSource=s}}const y="\\[([^\\]]+)\\]",w=new RegExp(y,"g");e.$po=`^(${y})+$`,e.$qo=new RegExp(e.$po);function h(o){const t=[];if(e.$qo.test(o)){let l=w.exec(o);for(;l?.length;){const r=l[1].trim();r&&t.push(r),l=w.exec(o)}}return(0,d.$Mb)(t)}function g(o){return o.reduce((t,l)=>`${t}[${l}]`,"")}function a(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new $;m.$bo.add(e.$go.Configuration,n);function i(o,t){return o.trim()?e.$qo.test(o)?R.localize(7,null,o):n.getConfigurationProperties()[o]!==void 0?R.localize(8,null,o):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,o,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function u(){const o=[],t=n.getConfigurationProperties();for(const l of Object.keys(t))o.push([l,t[l].scope]);return o.push(["launch",4]),o.push(["task",4]),o}}),define(ke[270],Pe([1,0,19,4,166,3,27,24,18,2,54,66,36]),function(le,e,d,N,L,R,M,b,m,E,A,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$zo=e.$yo=e.$xo=e.$wo=void 0,e.$Ao=i;function y(l){return Object.isFrozen(l)?l:b.$3n(l)}class w{static createEmptyModel(r){return new w({},[],[],void 0,r)}constructor(r,c,s,v,f){this.b=r,this.c=c,this.d=s,this.raw=v,this.f=f,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(c=>{if(c instanceof w)return c;const s=new h("",this.f);return s.parseRaw(c),s.configurationModel});this.g=r.reduce((c,s)=>s===c?s:c.merge(s),r[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,A.$0i)(this.contents,r):this.contents}inspect(r,c){const s=this;return{get value(){return y(s.rawConfiguration.getValue(r))},get override(){return c?y(s.rawConfiguration.getOverrideValue(r,c)):void 0},get merged(){return y(c?s.rawConfiguration.override(c).getValue(r):s.rawConfiguration.getValue(r))},get overrides(){const v=[];for(const{contents:f,identifiers:S,keys:p}of s.rawConfiguration.overrides){const k=new w(f,p,[],void 0,s.f).getValue(r);k!==void 0&&v.push({identifiers:S,value:k})}return v.length?y(v):void 0}}}getOverrideValue(r,c){const s=this.j(c);return s?r?(0,A.$0i)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const c=[];for(const s of this.overrides)s.identifiers.includes(r)&&c.push(...s.keys);return d.$Mb(c)}getAllOverrideIdentifiers(){const r=[];for(const c of this.overrides)r.push(...c.identifiers);return d.$Mb(r)}override(r){let c=this.a.get(r);return c||(c=this.h(r),this.a.set(r,c)),c}merge(...r){const c=b.$2n(this.contents),s=b.$2n(this.overrides),v=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const S of r)if(f.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.i(c,S.contents);for(const p of S.overrides){const[k]=s.filter(P=>d.$ub(P.identifiers,p.identifiers));k?(this.i(k.contents,p.contents),k.keys.push(...p.keys),k.keys=d.$Mb(k.keys)):s.push(b.$2n(p))}for(const p of S.keys)v.indexOf(p)===-1&&v.push(p)}return new w(c,v,s,f.every(S=>S instanceof w)?void 0:f,this.f)}h(r){const c=this.j(r);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const s={};for(const v of d.$Mb([...Object.keys(this.contents),...Object.keys(c)])){let f=this.contents[v];const S=c[v];S&&(typeof f=="object"&&typeof S=="object"?(f=b.$2n(f),this.i(f,S)):f=S),s[v]=f}return new w(s,this.keys,this.overrides,void 0,this.f)}i(r,c){for(const s of Object.keys(c)){if(s in r&&m.$0f(r[s])&&m.$0f(c[s])){this.i(r[s],c[s]);continue}r[s]=b.$2n(c[s])}}j(r){let c=null,s=null;const v=f=>{f&&(s?this.i(s,f):s=b.$2n(f))};for(const f of this.overrides)f.identifiers.length===1&&f.identifiers[0]===r?c=f.contents:f.identifiers.includes(r)&&v(f.contents);return v(c),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,c){this.k(r,c,!0)}setValue(r,c){this.k(r,c,!1)}removeValue(r){const c=this.keys.indexOf(r);c!==-1&&(this.keys.splice(c,1),(0,A.$9i)(this.contents,r),D.$qo.test(r)&&this.overrides.splice(this.overrides.findIndex(s=>d.$ub(s.identifiers,(0,D.$ro)(r))),1))}k(r,c,s){(0,A.$8i)(this.contents,r,c,v=>this.f.error(v)),s=s||this.keys.indexOf(r)===-1,s&&this.keys.push(r),D.$qo.test(r)&&this.overrides.push({identifiers:(0,D.$ro)(r),keys:Object.keys(this.contents[r]),contents:(0,A.$7i)(this.contents[r],v=>this.f.error(v))})}}e.$wo=w;class h{constructor(r,c){this.f=r,this.g=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||w.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,c){if(!m.$eg(r)){const s=this.h(r);this.parseRaw(s,c)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,c){this.a=r;const{contents:s,keys:v,overrides:f,restricted:S,hasExcludedProperties:p}=this.i(r,c);this.b=new w(s,v,f,p?[r]:void 0,this.g),this.c=S||[]}h(r){let c={},s=null,v=[];const f=[],S=[];function p(P){Array.isArray(v)?v.push(P):s!==null&&(v[s]=P)}const k={onObjectBegin:()=>{const P={};p(P),f.push(v),v=P,s=null},onObjectProperty:P=>{s=P},onObjectEnd:()=>{v=f.pop()},onArrayBegin:()=>{const P=[];p(P),f.push(v),v=P,s=null},onArrayEnd:()=>{v=f.pop()},onLiteralValue:p,onError:(P,C,I)=>{S.push({error:P,offset:C,length:I})}};if(r)try{L.$Pn(r,k),c=v[0]||{}}catch(P){this.g.error(`Error while parsing settings file ${this.f}: ${P}`),this.d=[P]}return c}i(r,c){const s=$.$bo.as(D.$go.Configuration).getConfigurationProperties(),v=this.j(r,s,!0,c);r=v.raw;const f=(0,A.$7i)(r,k=>this.g.error(`Conflict in settings file ${this.f}: ${k}`)),S=Object.keys(r),p=this.l(r,k=>this.g.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:f,keys:S,overrides:p,restricted:v.restricted,hasExcludedProperties:v.hasExcludedProperties}}j(r,c,s,v){let f=!1;if(!v?.scopes&&!v?.skipRestricted&&!v?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:f};const S={},p=[];for(const k in r)if(D.$qo.test(k)&&s){const P=this.j(r[k],c,!1,v);S[k]=P.raw,f=f||P.hasExcludedProperties,p.push(...P.restricted)}else{const P=c[k],C=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&p.push(k),!v.exclude?.includes(k)&&(v.include?.includes(k)||(C===void 0||v.scopes===void 0||v.scopes.includes(C))&&!(v.skipRestricted&&P?.restricted))?S[k]=r[k]:f=!0}return{raw:S,restricted:p,hasExcludedProperties:f}}l(r,c){const s=[];for(const v of Object.keys(r))if(D.$qo.test(v)){const f={};for(const S in r[v])f[S]=r[v][S];s.push({identifiers:(0,D.$ro)(v),keys:Object.keys(f),contents:(0,A.$7i)(f,c)})}return s}}e.$xo=h;class g extends R.$Vc{constructor(r,c,s,v,f){super(),this.c=r,this.f=c,this.g=v,this.h=f,this.b=this.B(new N.$ee),this.onDidChange=this.b.event,this.a=new h(this.c.toString(),f),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&s.isEqual(S.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return w.createEmptyModel(this.h)}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$yo=g;class a{constructor(r,c,s,v,f,S,p,k,P,C,I,T,j){this.a=r,this.b=c,this.c=s,this.overrideIdentifiers=v,this.d=f,this.f=S,this.g=p,this.h=k,this.i=P,this.j=C,this.k=I,this.l=T,this.m=j}get value(){return y(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(r,c,s,v,f,S,p,k,P,C){this.j=r,this.l=c,this.m=s,this.n=v,this.p=f,this.q=S,this.r=p,this.s=k,this.t=P,this.u=C,this.h=null,this.i=new M.$Bc,this.v=null}getValue(r,c,s){return this.w(r,c,s).getValue(r)}updateValue(r,c,s={}){let v;s.resource?(v=this.t.get(s.resource),v||(v=w.createEmptyModel(this.u),this.t.set(s.resource,v))):v=this.s,c===void 0?v.removeValue(r):v.setValue(r,c),s.resource||(this.h=null)}inspect(r,c,s){const v=this.w(r,c,s),f=this.A(c.resource,s),S=c.resource?this.t.get(c.resource)||this.s:this.s,p=new Set;for(const k of v.overrides)for(const P of k.identifiers)v.getOverrideValue(r,P)!==void 0&&p.add(P);return new a(r,c,v.getValue(r),p.size?[...p]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.q:void 0,f||void 0,S)}keys(r){const c=this.A(void 0,r);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(r){this.j=r,this.h=null,this.i.clear()}updatePolicyConfiguration(r){this.l=r}updateApplicationConfiguration(r){this.m=r,this.h=null,this.i.clear()}updateLocalUserConfiguration(r){this.n=r,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(r){this.p=r,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(r){this.q=r,this.h=null,this.i.clear()}updateFolderConfiguration(r,c){this.r.set(r,c),this.i.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.i.delete(r)}compareAndUpdateDefaultConfiguration(r,c){const s=[];if(!c){const{added:v,updated:f,removed:S}=o(this.j,r);c=[...v,...f,...S]}for(const v of c)for(const f of(0,D.$ro)(v)){const S=this.j.getKeysForOverrideIdentifier(f),p=r.getKeysForOverrideIdentifier(f),k=[...p.filter(P=>S.indexOf(P)===-1),...S.filter(P=>p.indexOf(P)===-1),...S.filter(P=>!b.$6n(this.j.override(f).getValue(P),r.override(f).getValue(P)))];s.push([f,k])}return this.updateDefaultConfiguration(r),{keys:c,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:c,updated:s,removed:v}=o(this.l,r),f=[...c,...s,...v];return f.length&&this.updatePolicyConfiguration(r),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:c,updated:s,removed:v,overrides:f}=o(this.applicationConfiguration,r),S=[...c,...s,...v];return S.length&&this.updateApplicationConfiguration(r),{keys:S,overrides:f}}compareAndUpdateLocalUserConfiguration(r){const{added:c,updated:s,removed:v,overrides:f}=o(this.localUserConfiguration,r),S=[...c,...s,...v];return S.length&&this.updateLocalUserConfiguration(r),{keys:S,overrides:f}}compareAndUpdateRemoteUserConfiguration(r){const{added:c,updated:s,removed:v,overrides:f}=o(this.remoteUserConfiguration,r),S=[...c,...s,...v];return S.length&&this.updateRemoteUserConfiguration(r),{keys:S,overrides:f}}compareAndUpdateWorkspaceConfiguration(r){const{added:c,updated:s,removed:v,overrides:f}=o(this.workspaceConfiguration,r),S=[...c,...s,...v];return S.length&&this.updateWorkspaceConfiguration(r),{keys:S,overrides:f}}compareAndUpdateFolderConfiguration(r,c){const s=this.folderConfigurations.get(r),{added:v,updated:f,removed:S,overrides:p}=o(s,c),k=[...v,...f,...S];return(k.length||!s)&&this.updateFolderConfiguration(r,c),{keys:k,overrides:p}}compareAndDeleteFolderConfiguration(r){const c=this.folderConfigurations.get(r);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:v,removed:f,overrides:S}=o(c,void 0);return{keys:[...s,...v,...f],overrides:S}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(r,c,s){let v=this.x(c,s);return c.overrideIdentifier&&(v=v.override(c.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(r)!==void 0&&(v=v.merge(this.l)),v}x({resource:r},c){let s=this.y();if(c&&r){const v=c.getFolder(r);v&&(s=this.z(v.uri)||s);const f=this.t.get(r);f&&(s=s.merge(f))}return s}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(r){let c=this.i.get(r);if(!c){const s=this.y(),v=this.r.get(r);v?(c=s.merge(v),this.i.set(r,c)):c=s}return c}A(r,c){if(c&&r){const s=c.getFolder(r);if(s)return this.r.get(s.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((r,c)=>{const{contents:s,overrides:v,keys:f}=this.r.get(c);return r.push([c,{contents:s,overrides:v,keys:f}]),r},[])}}allKeys(){const r=new Set;return this.j.keys.forEach(c=>r.add(c)),this.userConfiguration.keys.forEach(c=>r.add(c)),this.q.keys.forEach(c=>r.add(c)),this.r.forEach(c=>c.keys.forEach(s=>r.add(s))),[...r.values()]}B(){const r=new Set;return this.j.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.q.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.r.forEach(c=>c.getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}D(r){const c=new Set;return this.j.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this.q.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this.r.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(v=>c.add(v))),[...c.values()]}static parse(r,c){const s=this.E(r.defaults,c),v=this.E(r.policy,c),f=this.E(r.application,c),S=this.E(r.user,c),p=this.E(r.workspace,c),k=r.folders.reduce((P,C)=>(P.set(E.URI.revive(C[0]),this.E(C[1],c)),P),new M.$Bc);return new n(s,v,f,S,w.createEmptyModel(c),p,k,w.createEmptyModel(c),new M.$Bc,c)}static E(r,c){return new w(r.contents,r.keys,r.overrides,void 0,c)}}e.$zo=n;function i(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const r=new Set,c=new Map;for(const v of l)v.keys.forEach(f=>r.add(f)),v.overrides.forEach(([f,S])=>{const p=(0,M.$yc)(c,f,new Set);S.forEach(k=>p.add(k))});const s=[];return c.forEach((v,f)=>s.push([f,[...v.values()]])),{keys:[...r.values()],overrides:s}}class u{constructor(r,c,s,v,f){this.change=r,this.f=c,this.g=s,this.h=v,this.i=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const S of r.keys)this.affectedKeys.add(S);for(const[,S]of r.overrides)for(const p of S)this.affectedKeys.add(p);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(r,c){const s=this.a+r,v=this.d.indexOf(s);if(v<0)return!1;const f=v+s.length;if(f>=this.d.length)return!1;const S=this.d.charCodeAt(f);if(S!==this.b&&S!==this.c)return!1;if(c){const p=this.previousConfiguration?this.previousConfiguration.getValue(r,c,this.f?.workspace):void 0,k=this.g.getValue(r,c,this.h);return!b.$6n(p,k)}return!0}}e.$Bo=u;function o(l,r){const{added:c,removed:s,updated:v}=t(r?.rawConfiguration,l?.rawConfiguration),f=[],S=l?.getAllOverrideIdentifiers()||[],p=r?.getAllOverrideIdentifiers()||[];if(r){const k=p.filter(P=>!S.includes(P));for(const P of k)f.push([P,r.getKeysForOverrideIdentifier(P)])}if(l){const k=S.filter(P=>!p.includes(P));for(const P of k)f.push([P,l.getKeysForOverrideIdentifier(P)])}if(r&&l){for(const k of S)if(p.includes(k)){const P=t({contents:l.getOverrideValue(void 0,k)||{},keys:l.getKeysForOverrideIdentifier(k)},{contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)});f.push([k,[...P.added,...P.removed,...P.updated]])}}return{added:c,removed:s,updated:v,overrides:f}}function t(l,r){const c=l?r?l.keys.filter(f=>r.keys.indexOf(f)===-1):[...l.keys]:[],s=r?l?r.keys.filter(f=>l.keys.indexOf(f)===-1):[...r.keys]:[],v=[];if(l&&r){for(const f of r.keys)if(l.keys.indexOf(f)!==-1){const S=(0,A.$0i)(r.contents,f),p=(0,A.$0i)(l.contents,f);b.$6n(S,p)||v.push(f)}}return{added:c,removed:s,updated:v}}}),define(ke[271],Pe([1,0,21,4,3,83]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dtb=e.$Btb=e.$Atb=void 0,e.$Ctb=b;const M=(E,A,D)=>{const $=new Uint8Array(16);for(let h=0;h<16;h++)$[h]=Math.round(Math.random()*256);const y=(0,d.$Ze)(d.$Fe.wrap($));return[`GET ws://localhost${E}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$Atb=M,e.$Btb=d.$Fe.fromString(`\r
\r
`);async function b(E,A,D,$,y){E.write(d.$Fe.fromString((0,e.$Atb)(A,D,$)));const w=new L.$Uc;try{return await new Promise((h,g)=>{let a;w.add(E.onData(n=>{a?a=d.$Fe.concat([a,n],a.byteLength+n.byteLength):a=n;const i=a.indexOf(e.$Btb);if(i===-1)return;h(E),E.pauseData();const u=a.slice(i+e.$Btb.byteLength);u.byteLength&&y.onData.fire(u)})),w.add(E.onClose(n=>g(n??new Error("socket closed")))),w.add(E.onEnd(()=>g(new Error("socket ended"))))})}catch(h){throw E.dispose(),h}finally{w.dispose()}}class m extends L.$Vc{constructor(A,D){super(),this.g=A,this.a=this.B(new N.$he),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new N.$ee),this.onDidDispose=this.b.event,this.f=!1,this.B(D.onData),this.B(D.onData.event($=>this.a.fire($))),this.onClose=this.B(D.onClose).event,this.onEnd=this.B(D.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,D){R.SocketDiagnostics.traceSocketEvent(this,this.g,A,D)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Dtb=m}),define(ke[67],Pe([1,0,13,5]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.RemoteAuthorityResolverErrorCode=e.$Il=e.$Hl=e.RemoteConnectionType=e.$Gl=void 0,e.$Kl=E,e.$Gl=(0,N.$vi)("remoteAuthorityResolverService");var L;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class R{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$Hl=R;class M{constructor(D,$){this.host=D,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Il=M;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class m extends d.$bb{static isNotAvailable(D){return D instanceof m&&D._code===b.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof m&&D._code===b.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof m&&D._code===b.NoResolverFound}static isInvalidAuthority(D){return D instanceof m&&D._code===b.InvalidAuthority}static isHandled(D){return D instanceof m&&D.isHandled}constructor(D,$=b.Unknown,y){super(D),this._message=D,this._code=$,this._detail=y,this.isHandled=$===b.NotAvailable&&y===!0,Object.setPrototypeOf(this,m.prototype)}}e.$Jl=m;function E(A){const D=A.indexOf("+");return D===-1?A:A.substring(0,D)}}),define(ke[272],Pe([1,0,7,21,22,13,4,3,15,59,40,30,83,67]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Pl=S,e.$Ql=p,e.$Rl=P;const w=30*1e3;var h;(function(te){te[te.Management=1]="Management",te[te.ExtensionHost=2]="ExtensionHost",te[te.Tunnel=3]="Tunnel"})(h||(e.ConnectionType=h={}));function g(te){switch(te){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function a(te){const U=new L.$pe;return setTimeout(()=>U.cancel(),te),U.token}function n(te,U){if(te.isCancellationRequested||U.isCancellationRequested)return L.CancellationToken.Cancelled;const ee=new L.$pe;return te.onCancellationRequested(()=>ee.cancel()),U.onCancellationRequested(()=>ee.cancel()),ee.token}class i{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,d.$oh)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function u(te,U){const ee=new i(U);return ee.registerDisposable(te.onControlMessage(pe=>{const Ce=JSON.parse(pe.toString()),se=x(Ce);se?ee.reject(se):ee.resolve(Ce)})),ee.promise}function o(te,U,ee,pe,Ce,se,re,oe){const K=new i(oe),ne=A.$ae.create(!1);return te.info(`Creating a socket (${re})...`),E.mark(`code/willCreateSocket/${se}`),U.connect(ee,pe,Ce,re).then($e=>{K.didTimeout?(E.mark(`code/didCreateSocketError/${se}`),te.info(`Creating a socket (${re}) finished after ${ne.elapsed()} ms, but this is too late and has timed out already.`),$e?.dispose()):(E.mark(`code/didCreateSocketOK/${se}`),te.info(`Creating a socket (${re}) was successful after ${ne.elapsed()} ms.`),K.resolve($e))},$e=>{E.mark(`code/didCreateSocketError/${se}`),te.info(`Creating a socket (${re}) returned an error after ${ne.elapsed()} ms.`),te.error($e),K.reject($e)}),K.promise}function t(te,U){const ee=new i(U);return te.then(pe=>{ee.didTimeout||ee.resolve(pe)},pe=>{ee.didTimeout||ee.reject(pe)}),ee.promise}async function l(te,U,ee,pe){const Ce=ue(te,U);te.logService.trace(`${Ce} 1/6. invoking socketFactory.connect().`);let se;try{se=await o(te.logService,te.remoteSocketFactoryService,te.connectTo,m.$Ig.getServerRootPath(),`reconnectionToken=${te.reconnectionToken}&reconnection=${te.reconnectionProtocol?"true":"false"}`,g(U),`renderer-${g(U)}-${te.reconnectionToken}`,pe)}catch($e){throw te.logService.error(`${Ce} socketFactory.connect() failed or timed out. Error:`),te.logService.error($e),$e}te.logService.trace(`${Ce} 2/6. socketFactory.connect() was successful.`);let re,oe;te.reconnectionProtocol?(te.reconnectionProtocol.beginAcceptReconnection(se,null),re=te.reconnectionProtocol,oe=!1):(re=new $.$ji({socket:se}),oe=!0),te.logService.trace(`${Ce} 3/6. sending AuthRequest control message.`);const K=await t(te.signService.createNewMessage((0,D.$Rg)()),pe),ne={type:"auth",auth:te.connectionToken||"00000000000000000000",data:K.data};re.sendControl(N.$Fe.fromString(JSON.stringify(ne)));try{const $e=await u(re,n(pe,a(1e4)));if($e.type!=="sign"||typeof $e.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(te.logService.trace(`${Ce} 4/6. received SignRequest control message.`),!await t(te.signService.validate(K,$e.signedData),pe)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const Ae=await t(te.signService.sign($e.data),pe),fe={type:"connectionType",commit:te.commit,signedData:Ae,desiredConnectionType:U};return ee&&(fe.args=ee),te.logService.trace(`${Ce} 5/6. sending ConnectionTypeRequest control message.`),re.sendControl(N.$Fe.fromString(JSON.stringify(fe))),{protocol:re,ownsProtocol:oe}}catch($e){throw $e&&$e.code==="ETIMEDOUT"&&(te.logService.error(`${Ce} the handshake timed out. Error:`),te.logService.error($e)),$e&&$e.code==="VSCODE_CONNECTION_ERROR"&&(te.logService.error(`${Ce} received error control message when negotiating connection. Error:`),te.logService.error($e)),oe&&Q(re),$e}}async function r(te,U,ee,pe){const Ce=Date.now(),se=ue(te,U),{protocol:re,ownsProtocol:oe}=await l(te,U,ee,pe),K=new i(pe);return K.registerDisposable(re.onControlMessage(ne=>{const $e=JSON.parse(ne.toString()),be=x($e);be?(te.logService.error(`${se} received error control message when negotiating connection. Error:`),te.logService.error(be),oe&&Q(re),K.reject(be)):(te.reconnectionProtocol?.endAcceptReconnection(),te.logService.trace(`${se} 6/6. handshake finished, connection is up and running after ${ve(Ce)}!`),K.resolve({protocol:re,firstMessage:$e}))})),K.promise}async function c(te,U){const{protocol:ee}=await r(te,1,void 0,U);return{protocol:ee}}async function s(te,U,ee){const{protocol:pe,firstMessage:Ce}=await r(te,2,U,ee),se=Ce&&Ce.debugPort;return{protocol:pe,debugPort:se}}async function v(te,U,ee){const pe=Date.now(),Ce=ue(te,3),{protocol:se}=await l(te,3,U,ee);return te.logService.trace(`${Ce} 6/6. handshake finished, connection is up and running after ${ve(pe)}!`),se}async function f(te,U,ee){const{connectTo:pe,connectionToken:Ce}=await te.addressProvider.getAddress();return{commit:te.commit,quality:te.quality,connectTo:pe,connectionToken:Ce,reconnectionToken:U,reconnectionProtocol:ee,remoteSocketFactoryService:te.remoteSocketFactoryService,signService:te.signService,logService:te.logService}}async function S(te,U,ee){return k(te,async pe=>{const{protocol:Ce}=await c(pe,L.CancellationToken.None);return new Z(te,U,ee,pe.reconnectionToken,Ce)})}async function p(te,U){return k(te,async ee=>{const{protocol:pe,debugPort:Ce}=await s(ee,U,L.CancellationToken.None);return new q(te,U,ee.reconnectionToken,pe,Ce)})}async function k(te,U){for(let pe=1;;pe++)try{const Ce=(0,D.$Rg)(),se=await f(te,Ce,null);return await U(se)}catch(Ce){if(pe<5)te.logService.error(`[remote-connection][attempt ${pe}] An error occurred in initial connection! Will retry... Error:`),te.logService.error(Ce);else throw te.logService.error(`[remote-connection][attempt ${pe}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),te.logService.error(Ce),B.triggerPermanentFailure(0,0,y.$Jl.isHandled(Ce)),Ce}}async function P(te,U,ee){const pe=await f(te,(0,D.$Rg)(),null);return await v(pe,{host:U,port:ee},L.CancellationToken.None)}function C(te){return(0,d.$ih)(U=>new Promise((ee,pe)=>{const Ce=setTimeout(ee,te*1e3);U.onCancellationRequested(()=>{clearTimeout(Ce),ee()})}))}var I;(function(te){te[te.ConnectionLost=0]="ConnectionLost",te[te.ReconnectionWait=1]="ReconnectionWait",te[te.ReconnectionRunning=2]="ReconnectionRunning",te[te.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",te[te.ConnectionGain=4]="ConnectionGain"})(I||(e.PersistentConnectionEventType=I={}));class T{constructor(U,ee){this.reconnectionToken=U,this.millisSinceLastIncomingData=ee,this.type=0}}e.$Sl=T;class j{constructor(U,ee,pe,Ce){this.reconnectionToken=U,this.millisSinceLastIncomingData=ee,this.durationSeconds=pe,this.c=Ce,this.type=1}skipWait(){this.c.cancel()}}e.$Tl=j;class z{constructor(U,ee,pe){this.reconnectionToken=U,this.millisSinceLastIncomingData=ee,this.attempt=pe,this.type=2}}e.$Ul=z;class O{constructor(U,ee,pe){this.reconnectionToken=U,this.millisSinceLastIncomingData=ee,this.attempt=pe,this.type=4}}e.$Vl=O;class F{constructor(U,ee,pe,Ce){this.reconnectionToken=U,this.millisSinceLastIncomingData=ee,this.attempt=pe,this.handled=Ce,this.type=3}}e.$Wl=F;class B extends b.$Vc{static triggerPermanentFailure(U,ee,pe){this._permanentFailure=!0,this.f=U,this.g=ee,this.h=pe,this.j.forEach(Ce=>Ce.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(U,ee,pe,Ce,se){super(),this.t=U,this.u=ee,this.reconnectionToken=pe,this.protocol=Ce,this.w=se,this.m=this.B(new M.$ee),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new O(this.reconnectionToken,0,0)),this.B(Ce.onSocketClose(re=>{const oe=me(this.t,this.reconnectionToken,!0);re?re.type===0?(this.u.logService.info(`${oe} received socket close event (hadError: ${re.hadError}).`),re.error&&this.u.logService.error(re.error)):(this.u.logService.info(`${oe} received socket close event (wasClean: ${re.wasClean}, code: ${re.code}, reason: ${re.reason}).`),re.event&&this.u.logService.error(re.event)):this.u.logService.info(`${oe} received socket close event.`),this.y()})),this.B(Ce.onSocketTimeout(re=>{const oe=me(this.t,this.reconnectionToken,!0);this.u.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${re.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${re.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${re.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,b.$Tc)(()=>{const re=B.j.indexOf(this);re>=0&&B.j.splice(re,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=me(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ee=[0,5,5,10,10,10,10,10,30];let pe=-1;do{pe++;const Ce=pe<ee.length?ee[pe]:ee[ee.length-1];try{if(Ce>0){const re=C(Ce);this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Ce,re)),this.u.logService.info(`${U} waiting for ${Ce} seconds before reconnecting...`);try{await re}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe+1)),this.u.logService.info(`${U} resolving connection...`);const se=await f(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${se.connectTo}...`),await this.G(se,a(w)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe+1));break}catch(se){if(se.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}if(pe>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}if(y.$Jl.isTemporarilyNotAvailable(se)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if((se.code==="ETIMEDOUT"||se.code==="ENETUNREACH"||se.code==="ECONNREFUSED"||se.code==="ECONNRESET")&&se.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if((0,R.$4)(se)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(se);continue}if(se instanceof y.$Jl){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,y.$Jl.isHandled(se));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(se),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}}while(!this.n&&!this.s)}C(U,ee,pe){this.w?B.triggerPermanentFailure(U,ee,pe):this.D(U,ee,pe)}D(U,ee,pe){this.m.fire(new F(this.reconnectionToken,U,ee,pe)),Q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Xl=B;class Z extends B{constructor(U,ee,pe,Ce,se){super(1,U,Ce,se,!0),this.client=this.B(new $.$hi(se,{remoteAuthority:ee,clientId:pe},U.ipcLogger))}async G(U,ee){await c(U,ee)}}e.$Yl=Z;class q extends B{constructor(U,ee,pe,Ce,se){super(2,U,pe,Ce,!1),this.H=ee,this.debugPort=se}async G(U,ee){await s(U,this.H,ee)}}e.$Zl=q;function Q(te){try{te.acceptDisconnect();const U=te.getSocket();te.dispose(),U.dispose()}catch(U){(0,R.$1)(U)}}function x(te){if(te&&te.type==="error"){const U=new Error(`Connection error: ${te.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function X(te,U){for(;te.length<U;)te+=" ";return te}function ie(te,U){return`[remote-connection][${X(g(te),13)}][${U.substr(0,5)}\u2026]`}function me(te,U,ee){return`${ie(te,U)}[${ee?"reconnect":"initial"}]`}function ue(te,U){return`${me(U,te.reconnectionToken,!!te.reconnectionProtocol)}[${te.connectTo}]`}function ve(te){return`${Date.now()-te} ms`}}),define(ke[86],Pe([1,0,15]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=N,e.$Hm=L,e.$Im=R,e.$Jm=M;function N(m){return m.scheme===d.Schemas.vscodeRemote?m.authority:void 0}function L(m){if(!m)return;const E=m.indexOf("+");return E<0?m:m.substr(0,E)}function R(m){const{host:E,port:A}=b(m);if(typeof A>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:A}}function M(m,E){let{host:A,port:D}=b(m);return typeof D>"u"&&(D=E),{host:A,port:D}}function b(m){const E=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const A=m.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const D=m.match(/(.*):(\d+)$/);return D?{host:D[1],port:parseInt(D[2],10)}:{host:m,port:void 0}}}),define(ke[25],Pe([1,0,14,5,86]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Sm=e.$Rm=e.$Qm=e.TargetPlatform=e.ExtensionType=e.$Pm=e.$Nm=e.$Mm=e.$Lm=e.$Km=void 0,e.$Om=R,e.$Tm=D,e.$Um=$,e.$Vm=y,e.$Wm=w,e.$Km="extensions.user.cache",e.$Lm="extensions.builtin.cache",e.$Mm="undefined_publisher",e.$Nm=["ui","workspace","web"];function R(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$Pm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(M||(e.ExtensionType=M={}));var b;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class m{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,a){if(typeof g>"u"||g===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof g=="string"||typeof a=="string"){const n=typeof g=="string"?g:g.value,i=typeof a=="string"?a:a.value;return d.$xf(n,i)}return g._lower===a._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Qm=m;class E{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const a of g)this.add(a)}add(g){this.c.add(m.toKey(g))}delete(g){return this.c.delete(m.toKey(g))}has(g){return this.c.has(m.toKey(g))}}e.$Rm=E;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(m.toKey(g))}get(g){return this.c.get(m.toKey(g))}has(g){return this.c.has(m.toKey(g))}set(g,a){this.c.set(m.toKey(g),a)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Sm=A;function D(h){return $(h)}function $(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}function y(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}function w(h,g){if(g){const a=`onResolveRemoteAuthority:${(0,L.$Hm)(g)}`;return!!h.activationEvents?.includes(a)}return!1}e.$Xm=(0,N.$vi)("IBuiltinExtensionsScannerService")}),define(ke[140],Pe([1,0,13,25]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lG=e.$kG=void 0;class L{constructor(){this.a=new Map,this.b=new WeakMap}register(M,b){this.a.set(M,b)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const b=Object.create(null);for(const m of M){const E=this.readActivationEvents(m);E.length>0&&(b[N.$Qm.toKey(m.identifier)]=E)}return b}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const b=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let m=0;m<b.length;m++)b[m]==="onUri"&&(b[m]=`onUri:${N.$Qm.toKey(M.identifier)}`);if(!M.contributes)return b;for(const m in M.contributes){const E=this.a.get(m);if(!E)continue;const A=M.contributes[m],D=Array.isArray(A)?A:[A];try{E(D,b)}catch($){(0,d.$1)($)}}return b}}e.$kG=L,e.$lG=new L}),define(ke[273],Pe([1,0,3,5]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=void 0,e.$Ll=(0,N.$vi)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(M,b){return this.a[M]??=[],this.a[M].push(b),(0,d.$Tc)(()=>{const m=this.a[M]?.indexOf(b);typeof m=="number"&&m>=0&&this.a[M]?.splice(m,1)})}b(M){return(this.a[M.type]||[]).find(m=>m.supports(M))}connect(M,b,m,E){const A=this.b(M);if(!A)throw new Error(`No socket factory found for ${M}`);return A.connect(M,b,m,E)}}e.$Ml=L}),define(ke[274],Pe([1,0,21,13,3,220,66,5,11,36]),function(le,e,d,N,L,R,M,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=e.$Mp=void 0,e.$Op=$,e.$Pp=y,e.$Qp=w,e.$Rp=h,e.$Sp=g,e.$Tp=a,e.$Mp=(0,b.$vi)("requestService");class A{constructor(o){this.b=o}toJSON(){if(!this.a){const o=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?o[t]="*****":o[t]=this.b[t];this.a=o}return this.a}}class D extends L.$Vc{constructor(o){super(),this.b=0,this.a=o.createLogger("network",{name:(0,R.localize)(0,null),when:m.$hk.isEqualTo((0,m.$ek)(m.LogLevel.Trace)).serialize()})}async c(o,t,l){const r=`${o} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new A(t.headers??{}));try{const c=await l();return this.a.trace(`${r} - end`,t.type,c.res.statusCode,c.res.headers),c}catch(c){throw this.a.error(`${r} - error`,t.type,(0,N.$0)(c)),c}}}e.$Np=D;function $(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}function y(u){return u.res.statusCode===204}async function w(u){return y(u)?null:(await(0,d.$Re)(u.stream)).toString()}async function h(u){if(!$(u))throw new Error("Server returned "+u.res.statusCode);return w(u)}async function g(u){if(!$(u))throw new Error("Server returned "+u.res.statusCode);if(y(u))return null;const t=(await(0,d.$Re)(u.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}function a(u){i(u)}let n;function i(u){const o=E.$bo.as(M.$go.Configuration),t=n;n={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},o.updateConfigurations({add:[n],remove:t?[t]:[]})}i(1)}),define(ke[275],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C$b=void 0;class d{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const R=await this.c();if(R){const M=String(d.a++);return this.b.set(M,R),{id:M,data:R.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,R){if(!L.id)return!0;const M=this.b.get(L.id);if(!M)return!1;this.b.delete(L.id);try{return M.validate(R)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$C$b=d}),define(ke[111],Pe([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=void 0,e.$Nl="signService",e.$Ol=(0,d.$vi)(e.$Nl)}),define(ke[141],Pe([1,0,275]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;class N extends d.$C$b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(M=>new M.signer().sign(R))}h(){return new Promise((R,M)=>le(["vsda"],R,M))}}e.$ydc=N}),define(ke[276],Pe([1,0,12,51,30]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=M,e.$dp=b;function R(m){if(d.$u===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function M(m,E,A,D,$,y,w,h,g){const a=Object.create(null);a["common.machineId"]=y,a["common.sqmId"]=w,a.sessionID=(0,L.$Rg)()+Date.now(),a.commitHash=D,a.version=$,a["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,d.$h)(d.$u),a["common.nodePlatform"]=N.$ec,a["common.nodeArch"]=A,a["common.product"]=g||"desktop",h&&(a["common.msftInternal"]=h);let n=0;const i=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),d.$l&&(a["common.snap"]="true");const u=R(E);return u&&(a["common.platformDetail"]=u),a}function b(m){const E=N.env.USERDNSDOMAIN;if(!E)return!1;const A=E.toLowerCase();return m.some(D=>A===D)}}),define(ke[277],Pe([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=void 0,e.$1l=(0,d.$vi)("telemetryService"),e.$2l=(0,d.$vi)("customEndpointTelemetryService"),e.$3l="telemetry.currentSessionDate",e.$4l="telemetry.firstSessionDate",e.$5l="telemetry.lastSessionDate",e.$6l="telemetry.machineId",e.$7l="telemetry.sqmId",e.$8l="telemetry",e.$9l="telemetry.telemetryLevel",e.$0l="telemetry.enableCrashReporter",e.$$l="telemetry.enableTelemetry";var N;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ke[87],Pe([1,0,24,18,86,276,277]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=void 0,e.$lp=A,e.$mp=D,e.$np=$,e.$op=y,e.$pp=h,e.$qp=a,e.$rp=n,e.$sp=o;class b{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$ep=b;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$fp=m,e.$gp=new m;class E{async publicLog(l,r,c){}async publicLogError(l,r,c){}}e.$hp=E,e.$ip="telemetry",e.$jp="extensionTelemetryLog",e.$kp={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!t.enableTelemetry)}function D(t,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function $(t){const l=t.getValue(M.$9l),r=t.getValue(M.$0l);if(t.getValue(M.$$l)===!1||r===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function y(t){const l={},r={},c={};g(t,c);for(let s in c){s=s.length>150?s.substr(s.length-149):s;const v=c[s];typeof v=="number"?r[s]=v:typeof v=="boolean"?r[s]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${v.length}`),l[s]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(l[s]=v)}return{properties:l,measurements:r}}const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(t){if(!t)return"none";const l=(0,L.$Hm)(t);return w.has(l)?l:"other"}function g(t,l,r=0,c){if(t)for(const s of Object.getOwnPropertyNames(t)){const v=t[s],f=c?c+s:s;Array.isArray(v)?l[f]=(0,d.$7n)(v):v instanceof Date?l[f]=v.toISOString():(0,N.$0f)(v)?r<2?g(v,l,r+1,f+"."):l[f]=(0,d.$7n)(v):l[f]=v}}function a(t,l){const r=t.msftInternalDomains||[],c=l.getValue("telemetry.internalTesting");return(0,R.$dp)(r)||c}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,l){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const c=[];for(const S of l)for(;;){const p=S.exec(t);if(!p)break;c.push([p.index,S.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(r="";;){const S=v.exec(t);if(!S)break;const p=c.some(([k,P])=>S.index<P&&k<v.lastIndex);!s.test(S[0])&&!p&&(r+=t.substring(f,S.index)+"<REDACTED: user-file-path>",f=v.lastIndex)}return f<t.length&&(r+=t.substr(f)),r}function u(t){if(!t)return t;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of l)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function o(t,l){return(0,d.$4n)(t,r=>{if(r instanceof b||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let c=r.replaceAll("%20"," ");c=i(c,l);for(const s of l)c=c.replace(s,"");return c=u(c),c}})}}),define(ke[278],Pe([1,0,14,138,25,12,2,13,51,87]),function(le,e,d,N,L,R,M,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$up=void 0,e.$tp=A,e.$vp=w,e.$wp=h,e.$xp=g,e.$yp=a,e.$zp=n,e.$Ap=i,e.$Bp=u,e.$Dp=o,e.$Ep=l;function A(r,c){return r.uuid&&c.uuid?r.uuid===c.uuid:r.id===c.id?!0:(0,d.$sf)(r.id,c.id)===0}const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(c){const s=c.manifest?c.manifest.version:c.version,v=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new $(c.identifier,s,v)}static parse(c){const s=D.exec(c);return s&&s[1]&&s[2]?new $({id:s[1]},s[2],s[4]||void 0):null}constructor(c,s,v="undefined"){this.version=s,this.targetPlatform=v,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof $?A(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.$up=$;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(r){const c=y.exec(r);return c&&c[1]?[g(c[1]),c[2]]:[g(r),void 0]}function h(r,c){return`${r}.${c}`}function g(r){return r.toLowerCase()}function a(r,c){return g(h(r??L.$Mm,c))}function n(r,c){const s=[],v=f=>{for(const S of s)if(S.some(p=>A(c(p),c(f))))return S;return null};for(const f of r){const S=v(f);S?S.push(f):s.push([f])}return s}function i(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function u(r){return{id:new E.$ep(r.identifier.id),name:new E.$ep(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Cp=new L.$Qm("pprice.better-merge");function o(r,c){const s=[],v=c.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const f=v.shift();if(f&&s.every(S=>!A(S.identifier,{id:f}))){const S=r.filter(p=>A(p.identifier,{id:f}));S.length===1&&(s.push(S[0]),v.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function t(r,c){if(!R.$k)return!1;let s;try{s=(await r.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){c.debug("Error while getting the os-release file.",(0,b.$0)(f))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(r,c){const s=await t(r,c),v=(0,N.$1o)(s?"alpine":R.$u,m.$fc);return c.debug("ComputeTargetPlatform:",v),v}}),define(ke[279],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=d,e.$ls=N,e.$ms=L,e.$ns=R,e.$os=M,e.$ps=b;function d(m){return[...m.entries()]}function N(m){return m?[...m.entries()]:[]}function L(m){return new Map(m)}function R(m){return new Map(m??[])}function M(m){return Array.from(m.entries()).map(E=>[E[0],d(E[1].map),N(E[1].descriptionMap)])}function b(m){return new Map(m.map(E=>[E[0],{map:L(E[1]),descriptionMap:R(E[2])}]))}}),define(ke[280],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vtb=void 0;class d{constructor(L){this.b=L,this.a=new Map}dispose(){for(const L of this.a.values())L.dispose()}startBuffering(L,R,M=5){const b=R(m=>{const E=typeof m=="string"?m:m.data;let A=this.a.get(L);if(A){A.data.push(E);return}const D=setTimeout(()=>this.flushBuffer(L),M);A={data:[E],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(L),b.dispose()}},this.a.set(L,A)});return b}stopBuffering(L){this.a.get(L)?.dispose()}flushBuffer(L){const R=this.a.get(L);R&&(this.a.delete(L),this.b(L,R.data.join("")))}}e.$Vtb=d}),define(ke[281],Pe([1,0,7,79,99,57,4,18,2,221,110,36]),function(le,e,d,N,L,R,M,b,m,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fx=e.$ex=e.$dx=e.$cx=e.$bx=e.$ax=e.IconFontDefinition=e.IconContribution=e.$0w=void 0,e.$$w=g,e.$_w=a,e.$0w={IconContribution:"base.contributions.icons"};var $;(function(o){function t(l,r){let c=l.defaults;for(;R.ThemeIcon.isThemeIcon(c);){const s=h.getIcon(c.id);if(!s)return;c=s.defaults}return c}o.getDefinition=t})($||(e.IconContribution=$={}));var y;(function(o){function t(r){return{weight:r.weight,style:r.style,src:r.src.map(c=>({format:c.format,location:c.location.toString()}))}}o.toJSONObject=t;function l(r){const c=s=>(0,b.$8f)(s)?s:void 0;if(r&&Array.isArray(r.src)&&r.src.every(s=>(0,b.$8f)(s.format)&&(0,b.$8f)(s.location)))return{weight:c(r.weight),style:c(r.style),src:r.src.map(s=>({format:s.format,location:m.URI.parse(s.location)}))}}o.fromJSONObject=l})(y||(e.IconFontDefinition=y={}));class w{constructor(){this.a=new M.$ee,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,l,r,c){const s=this.b[t];if(s){if(r&&!s.description){s.description=r,this.d.properties[t].markdownDescription=`${r} $(${t})`;const S=this.e.enum.indexOf(t);S!==-1&&(this.e.enumDescriptions[S]=r),this.a.fire()}return s}const v={id:t,description:r,defaults:l,deprecationMessage:c};this.b[t]=v;const f={$ref:"#/definitions/icons"};return c&&(f.deprecationMessage=c),r&&(f.markdownDescription=`${r}: $(${t})`),this.d.properties[t]=f,this.e.enum.push(t),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const l=this.e.enum.indexOf(t);l!==-1&&(this.e.enum.splice(l,1),this.e.enumDescriptions.splice(l,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,l){const r=this.f[t];return r||(this.f[t]=l,this.a.fire(),l)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(s,v)=>s.id.localeCompare(v.id),l=s=>{for(;R.ThemeIcon.isThemeIcon(s.defaults);)s=this.b[s.defaults.id];return`codicon codicon-${s?s.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(s=>this.b[s]);for(const s of c.filter(v=>!!v.description).sort(t))r.push(`|<i class="${l(s)}"></i>|${s.id}|${R.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const s of c.filter(v=>!R.ThemeIcon.isThemeIcon(v.defaults)).sort(t))r.push(`|<i class="${l(s)}"></i>|${s.id}|`);return r.join(`
`)}}const h=new w;D.$bo.add(e.$0w.IconContribution,h);function g(o,t,l,r){return h.registerIcon(o,t,l,r)}function a(){return h}function n(){const o=(0,L.$Qj)();for(const t in o){const l="\\"+o[t].toString(16);h.registerIcon(t,{fontCharacter:l})}}n(),e.$ax="vscode://schemas/icons";const i=D.$bo.as(A.$co.JSONContribution);i.registerSchema(e.$ax,h.getIconSchema());const u=new d.$Hh(()=>i.notifySchemaChanged(e.$ax),200);h.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.$bx=g("widget-close",N.$Uj.close,(0,E.localize)(2,null)),e.$cx=g("goto-previous-location",N.$Uj.arrowUp,(0,E.localize)(3,null)),e.$dx=g("goto-next-location",N.$Uj.arrowDown,(0,E.localize)(4,null)),e.$ex=R.ThemeIcon.modify(N.$Uj.sync,"spin"),e.$fx=R.ThemeIcon.modify(N.$Uj.loading,"spin")}),define(ke[88],Pe([1,0,4,2,54,5,11]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=e.$iw=e.$gw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$cw=e.$bw=void 0,e.$dw=E,e.$ew=D,e.$fw=$,e.$hw=y,e.$jw=w,e.$kw=h,e.$bw=(0,R.$vi)("tunnelService"),e.$cw=(0,R.$vi)("sharedTunnelsService");var b;(function(n){n.Http="http",n.Https="https"})(b||(e.TunnelProtocol=b={}));var m;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(m||(e.TunnelPrivacyId=m={}));function E(n){return!!n.forwardPort}var A;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function D(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function $(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const u of i){const o=u.split("=")[1];if(/^https?:/.exec(o)){const t=D(N.URI.parse(o));if(t)return t}}}e.$gw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(n){return e.$gw.indexOf(n)>=0}e.$iw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(n){return e.$iw.indexOf(n)>=0}function h(n,i,u,o){if(u===1)return!1;if(u===2&&w(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class g{constructor(i,u,o){this.remoteAddress=i,this.localAddress=u,this.b=o,this.a=new d.$ee,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$lw=g;let a=class{constructor(i,u){this.k=i,this.l=u,this.a=new d.$ee,this.onTunnelOpened=this.a.event,this.b=new d.$ee,this.onTunnelClosed=this.b.event,this.c=new d.$ee,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],u=Array.from(this.e.values());for(const o of u){const t=Array.from(o.values());for(const l of t){const r=await l.value;r&&typeof r!="string"&&i.push(r)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:u}of i.values())await u.then(o=>typeof o!="string"?o?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,u,o,t,l){this.q(i,u,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:u,localAddress:o,privacy:t,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,u){(w(i)||y(i))&&(i=e.$gw[0]);const o=this.s(i,u);if(o)return++o.refcount,o.value}openTunnel(i,u,o,t,l,r=!1,c,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${o} on local port ${l}.`);const v=this.f??i;if(!v)return;if(u||(u="localhost"),t||(t=this.m),this.f&&this.j.has(o)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const f=this.t(v,u,o,t,l,r,c,s);return f?f.then(S=>{if(S){if(typeof S=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(u,o),S}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(u,o);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.o(S);return(S.tunnelRemoteHost!==u||S.tunnelRemotePort!==o)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&S.privacy!==c&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),f)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const u=this.e.get(i.tunnelRemoteHost);if(u){const o=u.get(i.tunnelRemotePort);o&&(o.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,o))}}}}async p(i,u,o){if(o.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${u}.`);const t=o.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(u),t}}async closeTunnel(i,u){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${u} `);const o=this.e.get(i);if(o&&o.has(u)){const t=o.get(u);t.refcount=0,await this.p(i,u,t)}}q(i,u,o){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(u,{refcount:1,value:o})}async r(i,u){const o=this.e.get(i);if(o){const t=o.get(u),l=t?await t.value:void 0;(!l||typeof l=="string")&&o.delete(u),o.size===0&&this.e.delete(i)}}s(i,u){const o=[i];y(i)?(o.push(...e.$gw),o.push(...e.$iw)):w(i)&&o.push(...e.$iw);const t=o.map(l=>this.e.get(l));for(const l of t){const r=l?.get(u);if(r)return r}}canTunnel(i){return!!D(i)}u(i,u,o,t,l,r,c){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${o} on local port ${t}.`);const s=o;this.j.add(s);const v=t===void 0?o:t,f={elevationRequired:l?this.isPortPrivileged(v):!1},S={remoteAddress:{host:u,port:o},localAddressPort:t,privacy:r,public:r?r!==m.Private:void 0,protocol:c},p=i.forwardPort(S,f);return p?(this.q(u,o,p),p.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),p}};e.$mw=a,e.$mw=a=Je([Ve(0,M.$2j),Ve(1,L.$2i)],a)}),define(ke[282],Pe([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=void 0,e.$zl=(0,d.$vi)("IUriIdentityService")}),define(ke[283],Pe([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$nw=void 0,e.$nw=(0,d.$vi)("editSessionIdentityService");var N;(function(L){L[L.Complete=100]="Complete",L[L.Partial=50]="Partial",L[L.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(ke[284],Pe([1,0,15]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=N,e.$yM=L,e.$zM=R,e.$AM=M,e.$BM=b;function N(m){return m.scheme!==d.Schemas.file&&m.scheme!==d.Schemas.vscodeRemote}function L(m){if(m.folders.length)return m.folders.every(E=>N(E.uri))?m.folders[0].uri:void 0;if(m.configuration&&N(m.configuration))return m.configuration}function R(m){return L(m)?.scheme}function M(m){return L(m)?.authority}function b(m){return L(m)!==void 0}}),define(ke[42],Pe([1,0,223,17,78,23,2,5,15]),function(le,e,d,N,L,R,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Pi=e.$Oi=e.WorkbenchState=e.$Ii=e.$Hi=e.$Ei=void 0,e.$Fi=E,e.$Gi=A,e.$Ji=D,e.$Ki=$,e.$Li=y,e.$Mi=h,e.$Ni=g,e.$Qi=i,e.$Vi=u,e.$Wi=o,e.$Yi=t,e.$Zi=l,e.$1i=r,e.$Ei=(0,b.$vi)("contextService");function E(c){const s=c;return typeof s?.id=="string"&&M.URI.isUri(s.uri)}function A(c){return typeof c?.id=="string"&&!E(c)&&!$(c)}e.$Hi={id:"ext-dev"},e.$Ii={id:"empty-window"};function D(c,s){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,N.$oc)(c)}:s?e.$Hi:e.$Ii;const v=c;return v.configuration?{id:v.id,configPath:v.configuration}:v.folders.length===1?{id:v.id,uri:v.folders[0].uri}:{id:v.id}}function $(c){const s=c;return typeof s?.id=="string"&&M.URI.isUri(s.configPath)}function y(c){const s=c;if(s?.uri)return{id:s.id,uri:M.URI.revive(s.uri)};const v=c;if(v?.configPath)return{id:v.id,configPath:M.URI.revive(v.configPath)};if(c?.id)return{id:c.id}}var w;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function h(c){const s=c;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function g(c){const s=c;return!!(s&&typeof s=="object"&&M.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class a{constructor(s,v,f,S,p){this.h=s,this.j=f,this.k=S,this.l=p,this.c=L.$Bi.forUris(this.l,()=>!0),this.folders=v}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=L.$Bi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Oi=a;class n{constructor(s,v){this.raw=v,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,R.$9g)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Pi=n;function i(c){return new n({uri:c,index:0,name:(0,R.$5g)(c)},{uri:c.toString()})}e.$Ri="code-workspace",e.$Si=`.${e.$Ri}`,e.$Ti=[{name:(0,d.localize)(0,null),extensions:[e.$Ri]}],e.$Ui="workspace.json";function u(c,s){return R.$Zg.isEqualOrParent(c,s.untitledWorkspacesHome)}function o(c){let s;return M.URI.isUri(c)?s=c:s=c.configuration,s?.scheme===m.Schemas.tmp}e.$Xi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(c){return c.id===e.$Xi}function l(c,s){return!u(c,s)&&!o(c)}function r(c){return(typeof c=="string"?(0,N.$pc)(c):(0,R.$7g)(c))===e.$Si}}),define(ke[285],Pe([1,0,56,4,3,23,2,222,137,33,5,11,42,27,282,7,30,14,18]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$El=e.$Bl=e.ProfileResourceType=void 0,e.$Al=u,e.$Cl=o,e.$Dl=t;var i;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function u(c){const s=c;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&M.URI.isUri(s.location)&&M.URI.isUri(s.globalStorageHome)&&M.URI.isUri(s.settingsResource)&&M.URI.isUri(s.keybindingsResource)&&M.URI.isUri(s.tasksResource)&&M.URI.isUri(s.snippetsHome)&&M.URI.isUri(s.extensionsResource))}e.$Bl=(0,A.$vi)("IUserDataProfilesService");function o(c,s){return{id:c.id,isDefault:c.isDefault,name:c.name,shortName:c.shortName,icon:c.icon,location:M.URI.revive(c.location).with({scheme:s}),globalStorageHome:M.URI.revive(c.globalStorageHome).with({scheme:s}),settingsResource:M.URI.revive(c.settingsResource).with({scheme:s}),keybindingsResource:M.URI.revive(c.keybindingsResource).with({scheme:s}),tasksResource:M.URI.revive(c.tasksResource).with({scheme:s}),snippetsHome:M.URI.revive(c.snippetsHome).with({scheme:s}),extensionsResource:M.URI.revive(c.extensionsResource).with({scheme:s}),cacheHome:M.URI.revive(c.cacheHome).with({scheme:s}),useDefaultFlags:c.useDefaultFlags,isTransient:c.isTransient}}function t(c,s,v,f,S,p){return{id:c,name:s,location:v,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:p&&S?.useDefaultFlags?.globalState?p.globalStorageHome:(0,R.$9g)(v,"globalStorage"),settingsResource:p&&S?.useDefaultFlags?.settings?p.settingsResource:(0,R.$9g)(v,"settings.json"),keybindingsResource:p&&S?.useDefaultFlags?.keybindings?p.keybindingsResource:(0,R.$9g)(v,"keybindings.json"),tasksResource:p&&S?.useDefaultFlags?.tasks?p.tasksResource:(0,R.$9g)(v,"tasks.json"),snippetsHome:p&&S?.useDefaultFlags?.snippets?p.snippetsHome:(0,R.$9g)(v,"snippets"),extensionsResource:p&&S?.useDefaultFlags?.extensions?p.extensionsResource:(0,R.$9g)(v,"extensions.json"),cacheHome:(0,R.$9g)(f,c),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let l=class extends L.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,v,f,S){super(),this.t=s,this.u=v,this.w=f,this.y=S,this.f=!0,this.h=this.B(new N.$ee),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$ee),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$ee),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$ee),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$9g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$9g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),v=[s];if(this.f)try{for(const p of this.O()){if(!p.name||!(0,n.$8f)(p.name)||!p.location){this.y.warn("Skipping the invalid stored profile",p.location||p.name);continue}v.push(t((0,R.$6g)(p.location),p.name,p.location,this.g,{shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags},s))}}catch(p){this.y.error(p)}const f=new y.$Bc,S=new Map;if(v.length)try{const p=this.Q();if(p.workspaces)for(const[k,P]of Object.entries(p.workspaces)){const C=M.URI.parse(k),I=v.find(T=>T.id===P);I&&f.set(C,I)}if(p.emptyWindows)for(const[k,P]of Object.entries(p.emptyWindows)){const C=v.find(I=>I.id===P);C&&S.set(k,C)}}catch(p){this.y.error(p)}this.z={profiles:v,workspaces:f,emptyWindows:S}}return this.z}D(){const s=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const v="Temp",f=new RegExp(`${(0,a.$_e)(v)}\\s(\\d+)`);let S=0;for(const k of this.profiles){const P=f.exec(k.name),C=P?parseInt(P[1]):0;S=C>S?C:S}const p=`${v} ${S+1}`;return this.createProfile((0,d.$jj)((0,g.$Rg)()).toString(16),p,{transient:!0},s)}async createNamedProfile(s,v,f){return this.createProfile((0,d.$jj)((0,g.$Rg)()).toString(16),s,v,f)}async createProfile(s,v,f,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=await this.F(s,v,f);return S&&await this.setProfileForWorkspace(S,p),p}async F(s,v,f){if(!(0,n.$8f)(v)||!v)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(v);return S||(S=(async()=>{try{if(this.profiles.find(C=>C.name===v||C.id===s))throw new Error(`Profile with ${v} name already exists`);const k=t(s,v,(0,R.$9g)(this.profilesHome,s),this.g,f,this.defaultProfile);await this.u.createFolder(k.location);const P=[];return this.j.fire({profile:k,join(C){P.push(C)}}),await h.Promises.settled(P),this.I([k],[],[]),k}finally{this.r.delete(v)}})(),this.r.set(v,S)),S}async updateProfile(s,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let f=this.profiles.find(S=>S.id===s.id);if(!f)throw new Error(`Profile '${s.name}' does not exist`);return f=t(f.id,v.name??f.name,f.location,this.g,{shortName:v.shortName??f.shortName,icon:v.icon===null?void 0:v.icon??f.icon,transient:v.transient??f.isTransient,useDefaultFlags:v.useDefaultFlags??f.useDefaultFlags},this.defaultProfile),this.I([],[],[f]),f}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const v=this.profiles.find(S=>S.id===s.id);if(!v)throw new Error(`Profile '${s.name}' does not exist`);const f=[];this.m.fire({profile:v,join(S){f.push(S)}});try{await Promise.allSettled(f)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])v.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])v.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[v],[]);try{await this.u.del(v.cacheHome,{recursive:!0})}catch(S){(0,E.$gl)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(s,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=this.profiles.find(S=>S.id===v.id);if(!f)throw new Error(`Profile '${v.name}' does not exist`);this.L(s,f)}unsetWorkspace(s,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,v)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(v=>v.isDirectory&&this.profiles.every(f=>!this.w.extUri.isEqual(f.location,v.resource))).map(v=>this.u.del(v.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(v=>!this.H(v));await Promise.allSettled(s.map(v=>this.removeProfile(v)))}getProfileForWorkspace(s){const v=this.G(s);return M.URI.isUri(v)?this.s.workspaces.get(v)??this.C.workspaces.get(v):this.s.emptyWindows.get(v)??this.C.emptyWindows.get(v)}G(s){return(0,$.$Fi)(s)?s.uri:(0,$.$Ki)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(v=>this.w.extUri.isEqual(v.location,s.location))||[...this.s.workspaces.values()].some(v=>this.w.extUri.isEqual(v.location,s.location))||[...this.C.emptyWindows.values()].some(v=>this.w.extUri.isEqual(v.location,s.location))||[...this.C.workspaces.values()].some(v=>this.w.extUri.isEqual(v.location,s.location)))}I(s,v,f){const S=[...this.profiles,...s],p=[];this.s.profiles=[];for(let k of S)k.isDefault||v.some(P=>k.id===P.id)||(k=f.find(P=>k.id===P.id)??k,k.isTransient?this.s.profiles.push(k):p.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(p),this.z=void 0,this.J(s,v,f)}J(s,v,f){this.h.fire({added:s,removed:v,updated:f,all:this.profiles})}L(s,v,f){f=v?.isTransient?!0:f,f||this.L(s,void 0,!0);const S=this.G(s),p=f?this.s:this.C;M.URI.isUri(S)?(p.workspaces.delete(S),v&&p.workspaces.set(S,v)):(p.emptyWindows.delete(S),v&&p.emptyWindows.set(S,v)),f||this.M()}M(){const s={};for(const[f,S]of this.C.workspaces.entries())s[f.toString()]=S.id;const v={};for(const[f,S]of this.C.emptyWindows.entries())v[f.toString()]=S.id;this.R({workspaces:s,emptyWindows:v}),this.z=void 0}N(s){const v={},f=this.D();if(s.workspaces)for(const[p,k]of Object.entries(s.workspaces)){const P=M.URI.parse(k);v[p]=this.w.extUri.isEqual(P,f.location)?f.id:this.w.extUri.basename(P)}const S={};if(s.emptyWindows)for(const[p,k]of Object.entries(s.emptyWindows)){const P=M.URI.parse(k);S[p]=this.w.extUri.isEqual(P,f.location)?f.id:this.w.extUri.basename(P)}return{workspaces:v,emptyWindows:S}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$El=l,e.$El=l=Je([Ve(0,m.$Ci),Ve(1,E.$2k),Ve(2,w.$zl),Ve(3,D.$2j)],l);class r extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Fl=r}),define(ke[142],Pe([1,0,7,4,3,59,18,200,5,285]),function(le,e,d,N,L,R,M,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$2p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Zp=e.$Yp=e.$Xp=void 0,e.$1p=y,e.$3p=h,e.$5p=a,e.$Xp="__$__isNewStorageMarker",e.$Yp="__$__targetStorageMarker",e.$Zp=(0,m.$vi)("storageService");var A;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var D;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(D||(e.StorageScope=D={}));var $;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function y(n){const i=n.get(e.$Yp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class w extends L.$Vc{static{this.a=60*1e3}constructor(i={flushInterval:w.a}){super(),this.m=i,this.b=this.B(new N.$he),this.c=this.B(new N.$he),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$ee),this.onWillSaveState=this.f.event,this.h=this.B(new d.$Hh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,u,o){return N.Event.filter(this.b.event,t=>t.scope===i&&(u===void 0||t.key===u),o)}n(){this.j.value=(0,d.$Lh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,u){const{key:o,external:t}=u;if(o===e.$Yp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:o,target:this.J(i)[o],external:t})}w(i){this.f.fire({reason:i})}get(i,u,o){return this.P(u)?.get(i,o)}getBoolean(i,u,o){return this.P(u)?.getBoolean(i,o)}getNumber(i,u,o){return this.P(u)?.getNumber(i,o)}getObject(i,u,o){return this.P(u)?.getObject(i,o)}storeAll(i,u){this.y(()=>{for(const o of i)this.store(o.key,o.value,o.scope,o.target,u)})}store(i,u,o,t,l=!1){if((0,M.$eg)(u)){this.remove(i,o,l);return}this.y(()=>{this.z(i,o,t),this.P(o)?.set(i,u,l)})}remove(i,u,o=!1){this.y(()=>{this.z(i,u,void 0),this.P(u)?.delete(i,o)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,u){const o=[],t=this.J(i);for(const l of Object.keys(t))t[l]===u&&o.push(l);return o}z(i,u,o,t=!1){const l=this.J(u);typeof o=="number"?l[i]!==o&&(l[i]=o,this.P(u)?.set(e.$Yp,JSON.stringify(l),t)):typeof l[i]=="number"&&(delete l[i],this.P(u)?.set(e.$Yp,JSON.stringify(l),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const u=this.P(i);return u?y(u):Object.create(null)}isNew(i){return this.getBoolean(e.$Xp,i)===!0}async flush(i=A.NONE){this.f.fire({reason:i});const u=this.P(-1),o=this.P(0),t=this.P(1);switch(i){case A.NONE:await d.Promises.settled([u?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await d.Promises.settled([u?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,u=this.P(0)?.items??new Map,o=this.P(1)?.items??new Map;return a(i,u,o,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,u){return this.w(A.NONE),(0,E.$Al)(i)?this.R(i,u):this.S(i,u)}M(i,u){return!(i.id===u.id||h(u)&&h(i))}N(i,u,o){this.y(()=>{const t=new Set;for(const[l,r]of i)t.add(l),u.get(l)!==r&&this.u(o,{key:l,external:!0});for(const[l]of u.items)t.has(l)||this.u(o,{key:l,external:!0})})}}e.$2p=w;function h(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class g extends w{constructor(){super(),this.U=this.B(new b.$Vp(new b.$Wp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Vp(new b.$Wp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Vp(new b.$Wp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$4p=g;async function a(n,i,u,o,t,l){const r=C=>{try{return JSON.parse(C)}catch{return C}},c=new Map,s=new Map;n.forEach((C,I)=>{c.set(I,C),s.set(I,r(C))});const v=new Map,f=new Map;i.forEach((C,I)=>{v.set(I,C),f.set(I,r(C))});const S=new Map,p=new Map;u.forEach((C,I)=>{S.set(I,C),p.set(I,r(C))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const k=[];if(c.forEach((C,I)=>{k.push({key:I,value:C})}),console.table(k),console.groupEnd(),console.log(s),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];v.forEach((I,T)=>{C.push({key:T,value:I})}),console.table(C),console.groupEnd(),console.log(f)}console.group(`Storage: Workspace (path: ${l})`);const P=[];S.forEach((C,I)=>{P.push({key:I,value:C})}),console.table(P),console.groupEnd(),console.log(p)}}),define(ke[112],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1kc=void 0;class d{static{this.a=!1}constructor(L){this.d=L,this.b=new Map,this.c=1}add(L){const R=this.c++;return this.b.set(R,L),this.e(),R}get(L,R){return this.b.has(L)?this.b.get(L)[R]:void 0}delete(L){this.b.delete(L),this.e()}e(){d.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$1kc=d}),define(ke[60],Pe([1,0,15,23,5]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kc=e.$6kc=void 0;class R{constructor(){this.a=new Set(Object.keys(d.Schemas)),this.b=new Map,this.extUri=new N.$Xg(b=>{const m=this.b.get(b.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos(b,m){m===null?this.b.delete(b.scheme):this.b.set(b.scheme,m)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$6kc=R,e.$7kc=(0,L.$vi)("IExtHostFileSystemInfo")}),define(ke[28],Pe([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EP=void 0,e.$EP=(0,d.$vi)("IExtHostInitDataService")}),define(ke[286],Pe([1,0,228,11,266,28]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=void 0;let M=class extends L.$MQ{constructor(m,E,A){const D=A.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",$=A.remote.isRemote?(0,d.localize)(0,null):m?(0,d.localize)(1,null):(0,d.localize)(2,null);super(E.createLogger(D,{name:$}))}};e.$anc=M,e.$anc=M=Je([Ve(1,N.$3j),Ve(2,R.$EP)],M)}),define(ke[287],Pe([1,0,7]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=e.$Llc=void 0;class N{constructor(M,b,m){this.h=new Map,this.a=M,this.b=b,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new d.$Hh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of E.values())A.complete()}catch(A){for(const D of E.values())D.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,b){let m=this.f[M];return typeof m>"u"&&(m=b),m}update(M,b){this.f[M]=b;const m=this.h.get(M);if(m!==void 0)return m.p;const E=new d.$Sh;return this.h.set(M,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Llc=N;class L extends N{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,b){super(M.identifier.value,!0,b),this.j=M}}e.$Mlc=L}),define(ke[288],Pe([1,0,4,2]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Amc=void 0;class L{constructor(M){this.c=M,this.a=new d.$ee,this.onDidSaveNotebookDocument=this.a.event,this.b=new d.$ee,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,b,m,E){const D=this.c.getNotebookDocument(N.URI.revive(M)).acceptModelChanged(b.value,m,E);this.b.fire(D)}$acceptDirtyStateChanged(M,b){this.c.getNotebookDocument(N.URI.revive(M)).acceptDirty(b)}$acceptModelSaved(M){const b=this.c.getNotebookDocument(N.URI.revive(M));this.a.fire(b.apiNotebook)}}e.$Amc=L}),define(ke[20],Pe([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=e.$oP=void 0,e.$oP=(0,d.$vi)("IExtHostRpcService");class N{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$pP=N}),define(ke[289],Pe([1,0,25,4]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=void 0;class L{#e;constructor(M,b){this.b=new N.$ee,this.onDidChange=this.b.event,this.a=d.$Qm.toKey(M.identifier),this.#e=b,this.#e.onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(M){return this.#e.get(this.a,M)}store(M,b){return this.#e.store(this.a,M,b)}delete(M){return this.#e.delete(this.a,M)}}e.$Vlc=L}),define(ke[68],Pe([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=e.$jlc=void 0,e.$jlc=(0,d.$vi)("IURITransformerService");class N{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$klc=N}),define(ke[290],Pe([1,0,21]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpb=L,e.$Dpb=M;class N{constructor(){this.buffers=[]}add(m){let E=this.buffers.indexOf(m);return E<0&&(E=this.buffers.length,this.buffers.push(m)),E}}function L(b,m){if(m.serializeBuffersForPostMessage){const E=new N,D=JSON.stringify(b,(y,w)=>{if(w instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(w)};if(ArrayBuffer.isView(w)){const h=R(w);if(h)return{$$vscode_array_buffer_reference$$:!0,index:E.add(w.buffer),view:{type:h,byteLength:w.byteLength,byteOffset:w.byteOffset}}}return w}),$=E.buffers.map(y=>{const w=new Uint8Array(y);return d.$Fe.wrap(w)});return{message:D,buffers:$}}else return{message:JSON.stringify(b),buffers:[]}}function R(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(b,m){const E=m.map($=>{const y=new ArrayBuffer($.byteLength);return new Uint8Array(y).set($.buffer),y}),A=m.length?($,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const w=y,{index:h}=w,g=E[h];if(w.view)switch(w.view.type){case 1:return new Int8Array(g,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return y}:void 0;return{message:JSON.parse(b,A),arrayBuffers:E}}}),define(ke[291],Pe([1,0,292,403,404,63,2,11,405]),function(le,e,d,N,L,R,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Inc=A;const E=!1;function A(i,u,o,t,l,r){const c=r.environment.useHostProxy,s=typeof c=="boolean"?c:!r.remote.isRemote,v={resolveProxy:p=>i.resolveProxy(p),lookupProxyAuthorization:g.bind(void 0,t,l,u,{},r.remote.isRemote),getProxyURL:()=>u.getConfiguration("http").get("proxy"),getProxySupport:()=>u.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>$(u),addCertificatesV2:()=>y(u),log:t,getLogLevel:()=>{const p=t.getLevel();switch(p){case b.LogLevel.Trace:return m.LogLevel.Trace;case b.LogLevel.Debug:return m.LogLevel.Debug;case b.LogLevel.Info:return m.LogLevel.Info;case b.LogLevel.Warning:return m.LogLevel.Warning;case b.LogLevel.Error:return m.LogLevel.Error;case b.LogLevel.Off:return m.LogLevel.Off;default:return k(p)}function k(P){return t.error("Unknown log level",P),m.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:s,loadAdditionalCertificates:async()=>{const p=[];if(r.remote.isRemote&&p.push((0,m.loadSystemCertificates)({log:t})),s){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const k=i.loadCertificates();k.then(P=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",P.length)),p.push(k)}return(await Promise.all(p)).flat()},env:process.env},f=(0,m.createProxyResolver)(v),S=D(v,f);return h(o,S)}function D(i,u){return{http:Object.assign(d,(0,m.createHttpPatch)(i,d,u)),https:Object.assign(N,(0,m.createHttpPatch)(i,N,u)),net:Object.assign(R,(0,m.createNetPatch)(i,R)),tls:Object.assign(L,(0,m.createTlsPatch)(i,L))}}function $(i){const u=i.getConfiguration("http");return!u.get("experimental.systemCertificatesV2",E)&&!!u.get("systemCertificates")}function y(i){const u=i.getConfiguration("http");return!!u.get("experimental.systemCertificatesV2",E)&&!!u.get("systemCertificates")}const w=new Map;function h(i,u){return i.getExtensionPathIndex().then(o=>{const t=globalThis._VSCODE_NODE_MODULES.module,l=t._load;t._load=function(c,s,v){if(c==="net")return u.net;if(c==="tls")return u.tls;if(c!=="http"&&c!=="https")return l.apply(this,arguments);const f=o.findSubstr(M.URI.file(s.filename));let S=w.get(f);if(S||w.set(f,S={}),!S[c]){const p=u[c];S[c]={...p}}return S[c]}})}async function g(i,u,o,t,l,r,c,s){const v=t[r];c&&(t[r]=c),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${r}`,`proxyAuthenticate:${c}`,`proxyAuthenticateCache:${v}`);const f=c||v,S=Array.isArray(f)?f:typeof f=="string"?[f]:[];if(n(u,S,l),S.some(p=>/^(Negotiate|Kerberos)( |$)/i.test(p))&&!s.kerberosRequested)try{s.kerberosRequested=!0;const p=await new Promise((T,j)=>{le(["kerberos"],T,j)}),k=new URL(r),P=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${k.hostname}`:`HTTP@${k.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${r}`,`spn:${P}`),"Negotiate "+await(await p.initializeClient(P)).step("")}catch(p){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",p)}}let a=!1;function n(i,u,o){a||!u.length||(a=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:u.map(t=>t.split(" ")[0]).join(","),extensionHostType:o?"remote":"local"}))}}),define(ke[293],Pe([1,0,134]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=L;function N(R){return{transformIncoming:M=>M.scheme==="vscode-remote"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="file"?{scheme:"vscode-local",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoing:M=>M.scheme==="file"?{scheme:"vscode-remote",authority:R,path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="vscode-local"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoingScheme:M=>M==="file"?"vscode-remote":M==="vscode-local"?"file":M}}function L(R){return new d.$xn(N(R))}}),define(ke[143],Pe([1,0,238,18,2,3,5,36,33,15,47,192,41]),function(le,e,d,N,L,R,M,b,m,E,A,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$JF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$AF=e.EditorInputCapabilities=e.$zF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=void 0,e.$qF=h,e.$rF=g,e.$sF=a,e.$tF=n,e.$uF=i,e.$vF=u,e.$wF=o,e.$xF=t,e.$yF=l,e.$BF=S,e.$CF=k,e.$DF=P,e.$EF=C,e.$FF=I,e.$GF=T,e.$HF=j,e.$IF=q,e.$KF=X,e.$LF=me,e.$MF=ue,e.$NF=ve,e.$lF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$mF={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.$nF="workbench.editor.sidebysideEditor",e.$oF="workbench.editors.textDiffEditor",e.$pF="workbench.editors.binaryResourceDiffEditor";var y;(function(te){te[te.PROGRAMMATIC=1]="PROGRAMMATIC",te[te.USER=2]="USER",te[te.EDIT=3]="EDIT",te[te.NAVIGATION=4]="NAVIGATION",te[te.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var w;(function(te){te[te.IDENTICAL=1]="IDENTICAL",te[te.SIMILAR=2]="SIMILAR",te[te.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function h(te){const U=te;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function g(te){const U=te;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function a(te,U,ee){for(const pe of ee.visibleEditorPanes)if(pe.group.id===U&&te.matches(pe.input))return pe.getViewState()}function n(te){if(S(te))return!1;const U=te;return L.URI.isUri(U?.resource)}function i(te){if(S(te))return!1;const U=te;return U?.original!==void 0&&U.modified!==void 0}function u(te){if(S(te))return!1;const U=te;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function o(te){if(S(te)||i(te))return!1;const U=te;return U?.primary!==void 0&&U.secondary!==void 0}function t(te){if(S(te))return!1;const U=te;return U?U.resource===void 0||U.resource.scheme===E.Schemas.untitled||U.forceUntitled===!0:!1}function l(te){if(S(te))return!1;const U=te;return L.URI.isUri(U?.base?.resource)&&L.URI.isUri(U?.input1?.resource)&&L.URI.isUri(U?.input2?.resource)&&L.URI.isUri(U?.result?.resource)}var r;(function(te){te[te.SHORT=0]="SHORT",te[te.MEDIUM=1]="MEDIUM",te[te.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var c;(function(te){te[te.EXPLICIT=1]="EXPLICIT",te[te.AUTO=2]="AUTO",te[te.FOCUS_CHANGE=3]="FOCUS_CHANGE",te[te.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class s{constructor(){this.a=new Map}registerSource(U,ee){let pe=this.a.get(U);return pe||(pe={source:U,label:ee},this.a.set(U,pe)),pe.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$zF=new s;var v;(function(te){te[te.None=0]="None",te[te.Readonly=2]="Readonly",te[te.Untitled=4]="Untitled",te[te.Singleton=8]="Singleton",te[te.RequiresTrust=16]="RequiresTrust",te[te.CanSplitInGroup=32]="CanSplitInGroup",te[te.ForceDescription=64]="ForceDescription",te[te.CanDropIntoEditor=128]="CanDropIntoEditor",te[te.MultipleEditors=256]="MultipleEditors",te[te.Scratchpad=512]="Scratchpad"})(v||(e.EditorInputCapabilities=v={}));class f extends R.$Vc{}e.$AF=f;function S(te){return te instanceof f}function p(te){const U=te;return L.URI.isUri(U?.preferredResource)}function k(te){const U=te;return S(U?.primary)&&S(U?.secondary)}function P(te){const U=te;return S(U?.modified)&&S(U?.original)}function C(te,U,ee,pe,Ce){return ve(pe,[(0,D.$fj)({id:"workbench.action.openLargeFile",label:(0,d.localize)(2,null),run:()=>{const se={...ee,limits:{size:Number.MAX_VALUE}};te.openEditor(U,se)}}),(0,D.$fj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,d.localize)(3,null),run:()=>Ce.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}function I(te){return S(te?.editor)}function T(te){const U=te;return I(te)&&U?.group!==void 0}function j(te){const U=te;return typeof U?.groupId=="number"&&S(U.editor)}var z;(function(te){te[te.UNKNOWN=0]="UNKNOWN",te[te.REPLACE=1]="REPLACE",te[te.MOVE=2]="MOVE",te[te.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var O;(function(te){te[te.GROUP_ACTIVE=0]="GROUP_ACTIVE",te[te.GROUP_INDEX=1]="GROUP_INDEX",te[te.GROUP_LABEL=2]="GROUP_LABEL",te[te.GROUP_LOCKED=3]="GROUP_LOCKED",te[te.EDITOR_OPEN=4]="EDITOR_OPEN",te[te.EDITOR_CLOSE=5]="EDITOR_CLOSE",te[te.EDITOR_MOVE=6]="EDITOR_MOVE",te[te.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",te[te.EDITOR_LABEL=8]="EDITOR_LABEL",te[te.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",te[te.EDITOR_PIN=10]="EDITOR_PIN",te[te.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",te[te.EDITOR_STICKY=12]="EDITOR_STICKY",te[te.EDITOR_DIRTY=13]="EDITOR_DIRTY",te[te.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(O||(e.GroupModelChangeKind=O={}));var F;(function(te){te[te.PRIMARY=1]="PRIMARY",te[te.SECONDARY=2]="SECONDARY",te[te.BOTH=3]="BOTH",te[te.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class B{getOriginalUri(U,ee){if(!U)return;if(l(U))return e.$JF.getOriginalUri(U.result,ee);if(ee?.supportSideBySide){const{primary:Ce,secondary:se}=this.a(U);if(Ce&&se){if(ee?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(Ce,{filterByScheme:ee.filterByScheme}),secondary:this.getOriginalUri(se,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===F.ANY)return this.getOriginalUri(Ce,{filterByScheme:ee.filterByScheme})??this.getOriginalUri(se,{filterByScheme:ee.filterByScheme});U=ee.supportSideBySide===F.PRIMARY?Ce:se}}if(i(U)||u(U)||o(U)||l(U))return;const pe=p(U)?U.preferredResource:U.resource;return!pe||!ee||!ee.filterByScheme?pe:this.b(pe,ee.filterByScheme)}a(U){return k(U)||o(U)?{primary:U.primary,secondary:U.secondary}:P(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,ee){if(!U)return;if(l(U))return e.$JF.getCanonicalUri(U.result,ee);if(ee?.supportSideBySide){const{primary:Ce,secondary:se}=this.a(U);if(Ce&&se){if(ee?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(Ce,{filterByScheme:ee.filterByScheme}),secondary:this.getCanonicalUri(se,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===F.ANY)return this.getCanonicalUri(Ce,{filterByScheme:ee.filterByScheme})??this.getCanonicalUri(se,{filterByScheme:ee.filterByScheme});U=ee.supportSideBySide===F.PRIMARY?Ce:se}}if(i(U)||u(U)||o(U)||l(U))return;const pe=U.resource;return!pe||!ee||!ee.filterByScheme?pe:this.b(pe,ee.filterByScheme)}b(U,ee){if(Array.isArray(ee)){if(ee.some(pe=>U.scheme===pe))return U}else if(ee===U.scheme)return U}}var Z;(function(te){te[te.UNKNOWN=0]="UNKNOWN",te[te.KEYBOARD=1]="KEYBOARD",te[te.MOUSE=2]="MOUSE"})(Z||(e.EditorCloseMethod=Z={}));function q(te,U,ee,pe){if(!te.isSticky(U))return!1;switch(pe.preventPinnedEditorClose){case"keyboardAndMouse":return ee===Z.MOUSE||ee===Z.KEYBOARD;case"mouse":return ee===Z.MOUSE;case"keyboard":return ee===Z.KEYBOARD}return!1}e.$JF=new B;var Q;(function(te){te[te.LEFT=0]="LEFT",te[te.RIGHT=1]="RIGHT"})(Q||(e.CloseDirection=Q={}));class x{constructor(){this.c=new Map,this.d=new Map}start(U){const ee=this.a=U.get(M.$ui);for(const[pe,Ce]of this.c)this.e(pe,Ce,ee);this.c.clear()}e(U,ee,pe){const Ce=pe.createInstance(ee);this.d.set(U,Ce)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,N.$gg)(this.b)}registerEditorSerializer(U,ee){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,ee,this.a):this.c.set(U,ee),(0,R.$Tc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}b.$bo.add(e.$lF.EditorFactory,new x);async function X(te,U,ee){return!te||!te.length?[]:await Promise.all(te.map(async pe=>{const Ce=L.URI.revive(pe.fileUri);if(!Ce){ee.info("Cannot resolve the path because it is not valid.",pe);return}if(!await U.canHandleResource(Ce)){ee.info("Cannot resolve the path because it cannot be handled",pe);return}let re=pe.exists,oe=pe.type;if(typeof re!="boolean"||typeof oe!="number")try{oe=(await U.stat(Ce)).isDirectory?m.FileType.Directory:m.FileType.Unknown,re=!0}catch(ne){ee.error(ne),re=!1}if(!re&&pe.openOnlyIfExists){ee.info("Cannot resolve the path because it does not exist",pe);return}if(oe===m.FileType.Directory){ee.info("Cannot resolve the path because it is a directory",pe);return}const K={...pe.options,pinned:!0};return re?{resource:Ce,options:K}:{resource:Ce,options:K,forceUntitled:!0}}))}var ie;(function(te){te[te.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",te[te.SEQUENTIAL=1]="SEQUENTIAL"})(ie||(e.EditorsOrder=ie={}));function me(te){const U=te;if(!U)return!1;const ee=U;if(ee.modified)return me(ee.modified);const pe=U;return!!(pe.contributionsState&&pe.viewState&&Array.isArray(pe.cursorState))}function ue(te){return(0,A.$hj)(te)}function ve(te,U,ee){const pe=(0,A.$ij)(te,U);return pe.forceMessage=ee?.forceMessage,pe.forceSeverity=ee?.forceSeverity,pe.allowDialog=ee?.allowDialog,pe}}),define(ke[294],Pe([1,0,4,239,5,3,27,36,19,24,79,281]),function(le,e,d,N,L,R,M,b,m,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VF=e.$UF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$TF=e.ViewContentGroups=e.$RF=e.ViewContainerLocation=e.Extensions=e.$QF=e.$PF=e.$OF=void 0,e.$SF=w,e.$OF="views",e.$PF=(0,N.localize)(0,null),e.$QF=(0,D.$$w)("default-view-icon",A.$Uj.window,(0,N.localize)(1,null));var $;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})($||(e.Extensions=$={}));var y;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel",l[l.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$RF=[0,1,2];function w(l){switch(l){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class h extends R.$Vc{constructor(){super(...arguments),this.c=this.B(new d.$ee),this.onDidRegister=this.c.event,this.f=this.B(new d.$ee),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,m.$Rb)([...this.g.values()])}registerViewContainer(r,c,s){const v=this.get(r.id);if(v)return v;const f=r;return f.openCommandActionDescriptor=s?.doNotRegisterOpenCommand?void 0:f.openCommandActionDescriptor??{id:f.id},(0,M.$yc)(this.g,c,[]).push(f),s?.isDefault&&this.h.push(f),this.c.fire({viewContainer:f,viewContainerLocation:c}),f}deregisterViewContainer(r){for(const c of this.g.keys()){const s=this.g.get(c),v=s?.indexOf(r);if(v!==-1){s?.splice(v,1),s.length===0&&this.g.delete(c),this.f.fire({viewContainer:r,viewContainerLocation:c});return}}}get(r){return this.all.filter(c=>c.id===r)[0]}getViewContainers(r){return[...this.g.get(r)||[]]}getViewContainerLocation(r){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(s=>s?.id===r.id).length>0)[0]}getDefaultViewContainer(r){return this.h.find(c=>this.getViewContainerLocation(c)===r)}}b.$bo.add($.ViewContainersRegistry,new h);var g;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(g||(e.ViewContentGroups=g={}));function a(l,r){const c=l.group??g.More,s=r.group??g.More;return c!==s?c.localeCompare(s):(l.order??5)-(r.order??5)}class n extends R.$Vc{constructor(){super(...arguments),this.c=this.B(new d.$ee),this.onViewsRegistered=this.c.event,this.f=this.B(new d.$ee),this.onViewsDeregistered=this.f.event,this.g=this.B(new d.$ee),this.onDidChangeContainer=this.g.event,this.h=this.B(new d.$ee),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Ic}registerViews(r,c){this.registerViews2([{views:r,viewContainer:c}])}registerViews2(r){r.forEach(({views:c,viewContainer:s})=>this.r(c,s)),this.c.fire(r)}deregisterViews(r,c){const s=this.s(r,c);s.length&&this.f.fire({views:s,viewContainer:c})}moveViews(r,c){for(const s of this.m.keys())if(s!==c){const v=this.s(r,s);v.length&&(this.r(v,c),this.g.fire({views:v,from:s,to:c}))}}getViews(r){return this.m.get(r)||[]}getView(r){for(const c of this.j){const s=(this.m.get(c)||[]).filter(v=>v.id===r)[0];if(s)return s}return null}getViewContainer(r){for(const c of this.j)if((this.m.get(c)||[]).filter(v=>v.id===r)[0])return c;return null}registerViewWelcomeContent(r,c){return this.n.add(r,c),this.h.fire(r),(0,R.$Tc)(()=>{this.n.delete(r,c),this.h.fire(r)})}registerViewWelcomeContent2(r,c){const s=new Map;for(const[v,f]of c)this.n.add(r,f),s.set(v,(0,R.$Tc)(()=>{this.n.delete(r,f),this.h.fire(r)}));return this.h.fire(r),s}getViewWelcomeContent(r){const c=[];return this.n.forEach(r,s=>c.push(s)),c.sort(a)}r(r,c){let s=this.m.get(c);s||(s=[],this.m.set(c,s),this.j.push(c));for(const v of r){if(this.getView(v.id)!==null)throw new Error((0,N.localize)(2,null,v.id));s.push(v)}}s(r,c){const s=this.m.get(c);if(!s)return[];const v=[],f=[];for(const S of s)r.includes(S)?v.push(S):f.push(S);return v.length&&(f.length?this.m.set(c,f):(this.m.delete(c),this.j.splice(this.j.indexOf(c),1))),v}}b.$bo.add($.ViewsRegistry,new n),e.$TF=(0,L.$vi)("viewDescriptorService");var i;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var u;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(u||(e.TreeItemCollapsibleState=u={}));class o{constructor(r,c){this.c=!1,this.d=!1,(0,E.$5n)(this,r),this.d=!!c,this.resolve=async s=>{if(c&&!this.c){const v=await c(s);v&&(this.tooltip=this.tooltip??v.tooltip,this.command=this.command??v.command)}s.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$UF=o;class t extends Error{constructor(r){super((0,N.localize)(3,null,r)),this.name="NoTreeViewError"}static is(r){return r.name==="NoTreeViewError"}}e.$VF=t}),define(ke[295],Pe([1,0,240,38]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=void 0,e.$ZF=new N.$Mj("chatSessionResponseVote","",{type:"string",description:(0,d.localize)(0,null)}),e.$1F=new N.$Mj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,d.localize)(1,null)}),e.$2F=new N.$Mj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,d.localize)(2,null)}),e.$3F=new N.$Mj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,d.localize)(3,null)}),e.$4F=new N.$Mj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,d.localize)(4,null)}),e.$5F=new N.$Mj("chatResponse",!1,{type:"boolean",description:(0,d.localize)(5,null)}),e.$6F=new N.$Mj("chatRequest",!1,{type:"boolean",description:(0,d.localize)(6,null)}),e.$7F=new N.$Mj("chatInputHasText",!1,{type:"boolean",description:(0,d.localize)(7,null)}),e.$8F=new N.$Mj("chatInputHasFocus",!1,{type:"boolean",description:(0,d.localize)(8,null)}),e.$9F=new N.$Mj("inChatInput",!1,{type:"boolean",description:(0,d.localize)(9,null)}),e.$0F=new N.$Mj("inChat",!1,{type:"boolean",description:(0,d.localize)(10,null)}),e.$$F=new N.$Mj("chatIsEnabled",!1,{type:"boolean",description:(0,d.localize)(11,null)}),e.$_F=new N.$Mj("chatCursorAtTop",!1),e.$aG=new N.$Mj("chatInputHasAgent",!1),e.$bG=new N.$Mj("chatLocation",void 0)}),define(ke[296],Pe([1,0,7,22,4,39,3,171,14,38,5,11,108,274,142,295]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.ChatAgentLocation=void 0;var a;(function(o){o.Panel="panel",o.Terminal="terminal",o.Notebook="notebook",o.Editor="editor"})(a||(e.ChatAgentLocation=a={})),function(o){function t(l){switch(l){case"panel":return o.Panel;case"terminal":return o.Terminal;case"notebook":return o.Notebook;case"editor":return o.Editor}return o.Panel}o.fromRaw=t}(a||(e.ChatAgentLocation=a={})),e.$_G=(0,A.$vi)("chatAgentService");let n=class{static{this.AGENT_LEADER="@"}constructor(t){this.f=t,this.b=[],this.d=new L.$ee,this.onDidChangeAgents=this.d.event,this.e=h.$$F.bindTo(this.f)}registerAgent(t,l){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const c=this,s=l.slashCommands;l={...l,get slashCommands(){return s.filter(f=>!f.when||c.f.contextMatchesRules(E.$tj.deserialize(f.when)))}};const v={data:l};return this.b.push(v),(0,M.$Tc)(()=>{this.b=this.b.filter(f=>f!==v),this.d.fire(void 0)})}registerAgentImplementation(t,l){const r=this.g(t);if(!r)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(r.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return r.data.isDefault&&this.e.set(!0),r.impl=l,this.d.fire(new i(r.data,l)),(0,M.$Tc)(()=>{r.impl=void 0,this.d.fire(void 0),r.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,l){const r={data:t,impl:l};return this.b.push(r),this.d.fire(new i(t,l)),(0,M.$Tc)(()=>{this.b=this.b.filter(c=>c!==r),this.d.fire(void 0)})}updateAgent(t,l){const r=this.g(t);if(!r?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);r.data.metadata={...r.data.metadata,...l},this.d.fire(new i(r.data,r.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(l=>!!l.isDefault&&l.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(l=>!!l.isDefault&&l.locations.includes(t))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(l=>l.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new i(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(l=>l.name===t)}async invokeAgent(t,l,r,c,s){const v=this.g(t);if(!v?.impl)throw new Error(`No activated agent with id ${t}`);return await v.impl.invoke(l,r,c,s)}async getFollowups(t,l,r,c,s){const v=this.g(t);if(!v?.impl)throw new Error(`No activated agent with id ${t}`);return v.impl?.provideFollowups?v.impl.provideFollowups(l,r,c,s):[]}};e.$aH=n,e.$aH=n=Je([Ve(0,E.$Nj)],n);class i{constructor(t,l){this.b=t,this.d=l}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisher(){return this.b.extensionPublisher}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,l,r,c){return this.d.invoke(t,l,r,c)}async provideFollowups(t,l,r,c){return this.d.provideFollowups?this.d.provideFollowups(t,l,r,c):[]}provideWelcomeMessage(t,l){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,l)}provideSampleQuestions(t,l){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,l)}}e.$bH=i,e.$cH=(0,A.$vi)("chatAgentNameService");let u=class{static{g=this}static{this.b="chat.participantNameRegistry"}constructor(t,l,r,c){if(this.g=l,this.h=r,this.i=c,this.e=(0,b.$2d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const s=c.get(g.b,-1);try{this.e.set(JSON.parse(s??"{}"),void 0)}catch{c.remove(g.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,d.$wh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},N.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const l=await(0,y.$Sp)(t);if(!l||l.version!==1)throw new Error("Unexpected chat participant registry response.");const r=l.restrictedChatParticipants;this.e.set(r,void 0),this.i.store(g.b,JSON.stringify(r),-1,1)}getAgentNameRestriction(t){return this.e.map(r=>r[t.name.toLowerCase()]).map(r=>r?r.some(c=>(0,m.$xf)(c,c.includes(".")?t.extensionId.value:t.extensionPublisher)):!0)}dispose(){this.f=!0}};e.$dH=u,e.$dH=u=g=Je([Ve(0,$.$ik),Ve(1,y.$Mp),Ve(2,D.$2j),Ve(3,w.$Zp)],u)}),define(ke[297],Pe([1,0,2,29,5]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jG=e.$iG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$gG=R,e.$hG=M;function R(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof d.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(N.$tt.isIRange)}function M(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(R)}var b;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var m;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(m||(e.ChatCopyKind=m={})),e.$iG=(0,L.$vi)("IChatService"),e.$jG="accessibility.voice.keywordActivation"}),define(ke[144],Pe([1,0,4,7,241]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pb=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new d.$ee,this.o=new d.$ee,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(b){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=b}onEvent(b){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=b}onRequest(b){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.u("response",b)}sendRequest(b,m,E,A){const D={command:b};if(m&&Object.keys(m).length>0&&(D.arguments=m),this.u("request",D),typeof A=="number"){const $=setTimeout(()=>{clearTimeout($);const y=this.f.get(D.seq);if(y){this.f.delete(D.seq);const w={type:"response",seq:0,request_seq:D.seq,success:!1,command:b,message:(0,L.localize)(0,null,A,b)};y(w)}},A)}return E&&this.f.set(D.seq,E),D.seq}acceptMessage(b){this.k?this.k(b):(this.m.push(b),this.m.length===1&&this.s())}q(b,m){return b.type!=="event"||m.type!=="event"}async s(){let b;for(;this.m.length;){if((!b||this.q(this.m[0],b))&&await(0,N.$wh)(0),b=this.m.shift(),!b)return;switch(b.type){case"event":this.j?.(b);break;case"request":this.g?.(b);break;case"response":{const m=b,E=this.f.get(m.request_seq);E&&(this.f.delete(m.request_seq),E(m));break}}}}u(b,m){m.type=b,m.seq=this.d++,this.sendMessage(m)}async w(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach((m,E)=>b.set(E,m)),await(0,N.$wh)(500),b.forEach((m,E)=>{m({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$3pb=R}),define(ke[298],Pe([1,0,2,242,38,5]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$tJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$rJ=e.MemoryRangeType=e.State=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=void 0,e.$qJ=m,e.$sJ=A,e.$eI="workbench.view.debug",e.$fI="workbench.debug.variablesView",e.$gI="workbench.debug.watchExpressionsView",e.$hI="workbench.debug.callStackView",e.$iI="workbench.debug.loadedScriptsView",e.$jI="workbench.debug.breakPointsView",e.$kI="workbench.debug.disassemblyView",e.$lI="workbench.panel.repl",e.$mI="workbench.panel.repl.view",e.$nI=new L.$Mj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$oI=new L.$Mj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$pI=new L.$Mj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$qI="debugUx",e.$rI=new L.$Mj(e.$qI,"default",{type:"string",description:N.localize(3,null)}),e.$sI=new L.$Mj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$tI=new L.$Mj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$uI=new L.$Mj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$vI=new L.$Mj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$wI=new L.$Mj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$xI=new L.$Mj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$yI=new L.$Mj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$zI=new L.$Mj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$AI=new L.$Mj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$BI=new L.$Mj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$CI=new L.$Mj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$DI=new L.$Mj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$EI=new L.$Mj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$FI=new L.$Mj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$GI=new L.$Mj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$HI=new L.$Mj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$II=new L.$Mj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$JI=new L.$Mj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$KI=new L.$Mj("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$LI=new L.$Mj("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$MI=new L.$Mj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$NI=new L.$Mj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$OI=new L.$Mj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$PI=new L.$Mj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$QI=new L.$Mj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$RI=new L.$Mj("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$SI=new L.$Mj("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$TI=new L.$Mj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$UI=new L.$Mj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$VI=new L.$Mj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$WI=new L.$Mj("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$XI=new L.$Mj("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$YI=new L.$Mj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$ZI=new L.$Mj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$1I=new L.$Mj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$2I=new L.$Mj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$3I=new L.$Mj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$4I=new L.$Mj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$5I=new L.$Mj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$6I=new L.$Mj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$7I=new L.$Mj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$8I=new L.$Mj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$9I=new L.$Mj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$0I=new L.$Mj("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$$I=new L.$Mj("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$_I=new L.$Mj("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$aJ=new L.$Mj("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$bJ=new L.$Mj("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$cJ=new L.$Mj("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$dJ=new L.$Mj("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$eJ=new L.$Mj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$fJ=new L.$Mj("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$gJ=new L.$Mj("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$hJ=new L.$Mj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$iJ=new L.$Mj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$jJ=new L.$Mj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$kJ=new L.$Mj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const M=i=>N.localize(61,null,i);e.$lJ=M,e.$mJ="editor.contrib.debug",e.$nJ="editor.contrib.breakpoint",e.$oJ="debug",e.$pJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var b;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(b||(e.State=b={}));function m(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$rJ="vscode-debug-memory";function A(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var D;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(D||(e.DataBreakpointSetType=D={}));var $;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})($||(e.DebugConfigurationProviderTriggerKind=$={}));var y;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(y||(e.DebuggerString=y={})),e.$tJ=(0,R.$vi)("debugService");var w;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var h;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(h||(e.DebugVisualizationType=h={}));var g;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(g||(e.DebugTreeItemCollapsibleState=g={}));var a;(function(i){i.deserialize=u=>u,i.serialize=u=>u})(a||(e.IDebugVisualizationTreeItem=a={}));var n;(function(i){i.deserialize=u=>({id:u.id,name:u.name,iconPath:u.iconPath&&{light:d.URI.revive(u.iconPath.light),dark:d.URI.revive(u.iconPath.dark)},iconClass:u.iconClass,visualization:u.visualization}),i.serialize=u=>u})(n||(e.IDebugVisualization=n={}))}),define(ke[299],Pe([1,0,14,2,17,24,15,29,22,19]),function(le,e,d,N,L,R,M,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sH=void 0,e.$gH=D,e.$hH=$,e.$iH=y,e.$jH=w,e.$kH=h,e.$lH=g,e.$mH=a,e.$nH=i,e.$oH=t,e.$pH=l,e.$qH=c,e.$rH=v;const A=/{([^}]+)}/g;function D(S,p,k){return S.replace(A,function(P,C){return p&&C.length>0&&C[0]!=="_"?P:k&&k.hasOwnProperty(C)?k[C]:P})}function $(S){const p={};for(const k of Object.keys(S))k.startsWith("!")||(p[k]=S[k]);return p}function y(S){return S.configuration.request==="attach"&&!w(S)&&(!S.parentSession||y(S.parentSession))}function w(S){let p=S.configuration.type;if(p)return p==="vslsShare"&&(p=S.configuration.adapterProxy.configuration.type),(0,d.$xf)(p,"extensionhost")||(0,d.$xf)(p,"pwa-extensionhost")?S:S.parentSession?w(S.parentSession):void 0}function h(S){return S.type&&(S.label||S.program||S.runtime)}function g(S,p,k){let P,C=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let T=null;for(;T=I.exec(S);){const j=T.index+1,z=j+T[0].length;if(j<=p&&z>=k){P=T[0],C=j;break}}if(P){const j=/\w+/g;let z=null;for(;(z=j.exec(P))&&!(z.index+1+C+z[0].length>=k););z&&(P=P.substring(0,j.lastIndex))}return P?{start:C,end:C+P.length-1}:{start:0,end:0}}async function a(S,p,k,P){if(S.evaluatableExpressionProvider.has(p)){const C=S.evaluatableExpressionProvider.ordered(p),I=(0,E.$Hb)(await Promise.all(C.map(async T=>{try{return await T.provideEvaluatableExpression(p,k,P??m.CancellationToken.None)}catch{return}})));if(I.length>0){let T=I[0].expression;const j=I[0].range;return T||(T=p.getLineContent(k.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:T}}}else{const C=p.getLineContent(k.lineNumber),{start:I,end:T}=g(C,k.column,k.column),j=C.substring(I-1,T);return{matchingExpression:j,range:new b.$tt(k.lineNumber,I,k.lineNumber,I+j.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(S){return!!(S&&S.match(n))}function u(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(i(S.path))return N.URI.parse(S.path);if((0,L.$jc)(S.path))return N.URI.file(S.path)}return S.path}function o(S){if(typeof S.path=="object"){const p=N.URI.revive(S.path);if(p)return p.scheme===M.Schemas.file?p.fsPath:p.toString()}return S.path}function t(S,p){const k=p?u:o,P=(0,R.$2n)(S);return r(P,(C,I)=>{C&&I&&(I.path=k(I))}),P}function l(S,p){const k=p?u:o,P=(0,R.$2n)(S);return r(P,(C,I)=>{!C&&I&&(I.path=k(I))}),P}function r(S,p){switch(S.type){case"event":{const k=S;switch(k.event){case"output":p(!1,k.body.source);break;case"loadedSource":p(!1,k.body.source);break;case"breakpoint":p(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=S;switch(k.command){case"setBreakpoints":p(!0,k.arguments.source);break;case"breakpointLocations":p(!0,k.arguments.source);break;case"source":p(!0,k.arguments.source);break;case"gotoTargets":p(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(P=>p(!1,P));break;default:break}break}case"response":{const k=S;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(P=>p(!1,P.source));break;case"loadedSources":k.body.sources.forEach(P=>p(!1,P));break;case"scopes":k.body.scopes.forEach(P=>p(!1,P.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(P=>p(!1,P.source));break;case"setBreakpoints":k.body.breakpoints.forEach(P=>p(!1,P.source));break;case"disassemble":k.body?.instructions.forEach(C=>p(!1,C.location));break;default:break}break}}}function c(S){return S.filter(p=>!p.presentation?.hidden).sort((p,k)=>p.presentation?k.presentation?p.presentation.group?k.presentation.group?p.presentation.group!==k.presentation.group?p.presentation.group.localeCompare(k.presentation.group):s(p.presentation.order,k.presentation.order):-1:k.presentation.group?1:s(p.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function s(S,p){return typeof S!="number"?typeof p!="number"?0:1:typeof p!="number"?-1:S-p}async function v(S,p){const k=S.getValue("debug.saveBeforeStart",{overrideIdentifier:p.activeTextEditorLanguageId});if(k!=="none"&&(await p.saveAll(),k==="allEditorsInActiveGroup")){const P=p.activeEditorPane;P&&P.input.resource?.scheme===M.Schemas.untitled&&await p.save({editor:P.input,groupId:P.group.id})}await S.reloadConfiguration()}const f=(S,p)=>!S||!p?S===p:S.name===p.name&&S.path===p.path&&S.sourceReference===p.sourceReference;e.$sH=f}),define(ke[300],Pe([1,0,53,63,24,17,12,14,32,243,144]),function(le,e,d,N,L,R,M,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=e.$jnc=e.$inc=e.$hnc=e.$gnc=void 0;class D extends A.$3pb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(a,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,a.on("data",i=>this.v(i))}sendMessage(a){if(this.l){const n=JSON.stringify(a);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${D.a}${n}`,"utf8")}}v(a){for(this.p=Buffer.concat([this.p,a]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(D.a);if(n!==-1){const u=this.p.toString("utf8",0,n).split(D.b);for(const o of u){const t=o.split(D.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+D.a.length);continue}}break}}}e.$gnc=D;class $ extends D{startSession(){return new Promise((a,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),a(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",u=>{i?this.n.fire(u):n(u)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$hnc=$;class y extends ${constructor(a){super(),this.z=a}y(a){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",a)}}e.$inc=y;class w extends ${constructor(a){super(),this.z=a}y(a){return N.createConnection(this.z.path,a)}}e.$jnc=w;class h extends D{constructor(a,n){super(),this.y=a,this.z=n}async startSession(){const a=this.y.command,n=this.y.args,i=this.y.options||{};try{if(a)if(R.$jc(a)){if(!await m.Promises.exists(a))throw new Error(E.localize(0,null,a))}else a.indexOf("/")<0&&a.indexOf("\\")<0;else throw new Error(E.localize(1,null,this.z));let u=process.env;if(i.env&&Object.keys(i.env).length>0&&(u=L.$5n(L.$2n(process.env),i.env)),a==="node")if(Array.isArray(n)&&n.length>0){const o=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:u,execArgv:o?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const l=d.fork(n[0],n.slice(1),t);if(!l.pid)throw new Error(E.localize(2,null,n[0]));this.x=l}else throw new Error(E.localize(3,null));else{const o={env:u};i.cwd&&(o.cwd=i.cwd),this.x=d.spawn(a,n,o)}this.x.on("error",o=>{this.n.fire(o)}),this.x.on("exit",(o,t)=>{this.o.fire(o)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",o=>{this.n.fire(o)}),this.x.stdin.on("error",o=>{this.n.fire(o)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(u){this.n.fire(u)}}async stopSession(){return this.x?(await this.w(),M.$i?new Promise((a,n)=>{const i=d.exec(`taskkill /F /T /PID ${this.x.pid}`,function(u,o,t){if(u)return n(u)});i.on("exit",a),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(a,n){if(!a)return;const i=Object.create(null);a.runtime&&(a.runtime.indexOf("./")===0?i.runtime=R.$kc(n,a.runtime):i.runtime=a.runtime),a.runtimeArgs&&(i.runtimeArgs=a.runtimeArgs),a.program&&(R.$jc(a.program)?i.program=a.program:i.program=R.$kc(n,a.program)),a.args&&(i.args=a.args);const u=a;return u.win&&(i.win=h.A(u.win,n)),u.winx86&&(i.winx86=h.A(u.winx86,n)),u.windows&&(i.windows=h.A(u.windows,n)),u.osx&&(i.osx=h.A(u.osx,n)),u.linux&&(i.linux=h.A(u.linux,n)),i}static platformAdapterExecutable(a,n){let i=Object.create(null);n=n.toLowerCase();for(const c of a)if(c.contributes){const s=c.contributes.debuggers;s&&s.length>0&&s.filter(v=>typeof v.type=="string"&&b.$xf(v.type,n)).forEach(v=>{const f=h.A(v,c.extensionLocation.fsPath);i=L.$5n(i,f,c.isBuiltin)})}let u;M.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?u=i.winx86||i.win||i.windows:M.$i?u=i.win||i.windows:M.$j?u=i.osx:M.$k&&(u=i.linux),u=u||i;const o=u.program||i.program,t=u.args||i.args,l=u.runtime||i.runtime,r=u.runtimeArgs||i.runtimeArgs;if(l)return{type:"executable",command:l,args:(r||[]).concat(typeof o=="string"?[o]:[]).concat(t||[])};if(o)return{type:"executable",command:o,args:t||[]}}}e.$knc=h}),define(ke[301],Pe([1,0,53,31,12]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=M,e.$mnc=m;function R(E,A){return new Promise((D,$)=>{let y="";const w=d.spawn(E,A);w.pid&&w.stdout.on("data",h=>{y+=h.toString()}),w.on("error",h=>{$(h)}),w.on("close",h=>{D(y)})})}async function M(E){if(E)if(L.$i){const A=await new Promise((D,$)=>{le(["@vscode/windows-process-tree"],D,$)});return new Promise(D=>{A.getProcessTree(E,$=>{D(!!$&&$.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(E)]).then(A=>{const D=A.trim();return!(D.length===0||D.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}var b;(function(E){E[E.cmd=0]="cmd",E[E.powershell=1]="powershell",E[E.bash=2]="bash"})(b||(b={}));function m(E,A,D,$,y){E=E.trim().toLowerCase();let w;E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0?w=1:E.indexOf("cmd.exe")>=0?w=0:E.indexOf("bash")>=0?w=2:L.$i?w=0:w=2;let h,g=" ";switch(w){case 1:if(h=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),$){const a=(0,N.$Ag)($);a&&(g+=`${a}:; `),g+=`cd ${h($)}; `}if(y)for(const a in y){const n=y[a];n===null?g+=`Remove-Item env:${a}; `:g+=`\${env:${a}}='${n}'; `}if(A.length>0){const a=A.shift(),n=D?a:h(a);g+=n[0]==="'"?`& ${n} `:`${n} `;for(const i of A)g+=i==="<"||i===">"||D?i:h(i),g+=" "}break;case 0:if(h=a=>(a=a.replace(/\"/g,'""'),a=a.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(n=>a.includes(n))||a.length===0?`"${a}"`:a),$){const a=(0,N.$Ag)($);a&&(g+=`${a}: && `),g+=`cd ${h($)} && `}if(y){g+='cmd /C "';for(const a in y){let n=y[a];n===null?g+=`set "${a}=" && `:(n=n.replace(/[&^|<>]/g,i=>`^${i}`),g+=`set "${a}=${n}" && `)}}for(const a of A)g+=a==="<"||a===">"||D?a:h(a),g+=" ";y&&(g+='"');break;case 2:{h=n=>(n=n.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),n.length===0?'""':n);const a=n=>/[^\w@%\/+=,.:^-]/.test(n)?`'${n.replace(/'/g,"'\\''")}'`:n;if($&&(g+=`cd ${h($)} ; `),y){g+="/usr/bin/env";for(const n in y){const i=y[n];i===null?g+=` -u ${a(n)}`:g+=` ${a(`${n}=${i}`)}`}g+=" "}for(const n of A)g+=n==="<"||n===">"||D?n:h(n),g+=" ";break}}return g}}),define(ke[302],Pe([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GK=e.CellExecutionUpdateType=void 0;var N;(function(L){L[L.Output=1]="Output",L[L.OutputItems=2]="OutputItems",L[L.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$GK=(0,d.$vi)("INotebookExecutionService")}),define(ke[303],Pe([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjb=e.$ajb=e.ProxyKernelState=e.$_ib=void 0,e.$_ib=100;var N;(function(L){L[L.Disconnected=1]="Disconnected",L[L.Connected=2]="Connected",L[L.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$ajb=(0,d.$vi)("INotebookKernelService"),e.$bjb=(0,d.$vi)("INotebookKernelHistoryService")}),define(ke[304],Pe([1,0,3,29,205,100]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Wb=void 0;class M extends d.$Vc{constructor(m,E,A){super(),this._source=m,this.b=E,this.c=A,this.a=void 0}f(m){const E=m.getLineCount();return new N.$tt(1,1,E,this.g(m,E))}g(m,E){if(E<1||E>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const m=new L.$UC;m.acceptChunk(this._source);const E=m.finish(!0),{textBuffer:A,disposable:D}=E.create(1);this.b=A,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(m=>{const E=new L.$UC;E.acceptChunk(m);const A=E.finish(!0),{textBuffer:D,disposable:$}=A.create(1);return this.B($),D})),this.a}findInInputs(m){const A=new R.$IC(m,!1,!1,null).parseSearchRequest();if(!A)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,A,!0,5e3)}findInOutputs(m){const A=new R.$IC(m,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(D=>{const $=D.findMatchesLineByLine(this.f(D),A,!0,5e3);if($.length!==0)return{textBuffer:D,matches:$}}).filter(D=>!!D):[]}}e.$0Wb=M}),define(ke[69],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(R){R.Delimiter="\0"})(d||(e.TestIdPathParts=d={}));var N;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class L{static fromExtHostTestItem(M,b,m=M.parent){if(M._isRoot)return new L([b]);const E=[M.id];for(let A=m;A&&A.id!==b;A=A.parent)E.push(A.id);return E.push(b),new L(E.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const b=M.indexOf("\0");return b===-1?M:M.slice(0,b)}static fromString(M){return new L(M.split("\0"))}static join(M,b){return new L([...M.path,b])}static joinToString(M,b){return M.toString()+"\0"+b}static parentId(M){const b=M.lastIndexOf("\0");return b===-1?void 0:M.slice(0,b)}static localId(M){const b=M.lastIndexOf("\0");return b===-1?M:M.slice(b+1)}static isChild(M,b){return b.startsWith(M)&&b[M.length]==="\0"}static compare(M,b){return M===b?0:L.isChild(M,b)?2:L.isChild(b,M)?3:1}constructor(M,b=M.length){if(this.path=M,this.d=b,M.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new L(this.path,1)}get parentId(){return this.d>1?new L(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new L(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new L(this.path,M)}compare(M){if(typeof M=="string")return L.compare(this.toString(),M);for(let b=0;b<M.d&&b<this.d;b++)if(M.path[b]!==this.path[b])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$ML=L}),define(ke[89],Pe([1,0,2,50,29,69]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$UL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$TL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$SL=e.$RL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$QL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$PL=e.$OL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$NL=e.TestResultState=void 0;var M;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$NL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(O){O[O.Run=1]="Run",O[O.Debug=2]="Debug",O[O.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var m;(function(O){O[O.Run=2]="Run",O[O.Debug=4]="Debug",O[O.Coverage=8]="Coverage",O[O.HasNonDefaultProfile=16]="HasNonDefaultProfile",O[O.HasConfigurable=32]="HasConfigurable",O[O.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$OL=[2,4,8,16,32,64];const E=O=>"runId"in O;e.$PL=E;var A;(function(O){O.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),O.deserialize=(F,B)=>({range:L.$tt.lift(B.range),uri:F.asCanonicalUri(d.URI.revive(B.uri))})})(A||(e.IRichLocation=A={}));var D;(function(O){O[O.Error=0]="Error",O[O.Output=1]="Output"})(D||(e.TestMessageType=D={}));var $;(function(O){O.serialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&A.serialize(F.location)}),O.deserialize=(F,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&A.deserialize(F,B.location)})})($||(e.ITestErrorMessage=$={}));const y=(O,F)=>`${F?"s":"e"}${O}`;e.$QL=y;var w;(function(O){O.serialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&A.serialize(F.location)}),O.deserialize=(F,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&A.deserialize(F,B.location)})})(w||(e.ITestOutputMessage=w={}));var h;(function(O){O.serialize=F=>F.type===0?$.serialize(F):w.serialize(F),O.deserialize=(F,B)=>B.type===0?$.deserialize(F,B):w.deserialize(F,B)})(h||(e.ITestMessage=h={}));var g;(function(O){O.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),O.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(h.serialize)}),O.deserialize=(F,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(Z=>h.deserialize(F,Z))})})(g||(e.ITestTaskState=g={}));const a="\0",n=(O,F)=>O+a+F;e.$RL=n;const i=O=>{const F=O.indexOf(a);return{ctrlId:O.slice(0,F),tagId:O.slice(F+1)}};e.$SL=i;var u;(function(O){O.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),O.deserialize=(F,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?F.asCanonicalUri(d.URI.revive(B.uri)):void 0,range:B.range?L.$tt.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(u||(e.ITestItem=u={}));var o;(function(O){O[O.NotExpandable=0]="NotExpandable",O[O.Expandable=1]="Expandable",O[O.BusyExpanding=2]="BusyExpanding",O[O.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var t;(function(O){O.serialize=F=>({expand:F.expand,item:u.serialize(F.item)}),O.deserialize=(F,B)=>({controllerId:R.$ML.root(B.item.extId),expand:B.expand,item:u.deserialize(F,B.item)})})(t||(e.InternalTestItem=t={}));var l;(function(O){O.serialize=F=>{let B;return F.item&&(B={},F.item.label!==void 0&&(B.label=F.item.label),F.item.tags!==void 0&&(B.tags=F.item.tags),F.item.busy!==void 0&&(B.busy=F.item.busy),F.item.uri!==void 0&&(B.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(B.range=F.item.range?.toJSON()),F.item.description!==void 0&&(B.description=F.item.description),F.item.error!==void 0&&(B.error=F.item.error),F.item.sortText!==void 0&&(B.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:B}},O.deserialize=F=>{let B;return F.item&&(B={},F.item.label!==void 0&&(B.label=F.item.label),F.item.tags!==void 0&&(B.tags=F.item.tags),F.item.busy!==void 0&&(B.busy=F.item.busy),F.item.range!==void 0&&(B.range=F.item.range?L.$tt.lift(F.item.range):null),F.item.description!==void 0&&(B.description=F.item.description),F.item.error!==void 0&&(B.error=F.item.error),F.item.sortText!==void 0&&(B.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:B}}})(l||(e.ITestItemUpdate=l={}));const r=(O,F)=>{F.expand!==void 0&&(O.expand=F.expand),F.item!==void 0&&(O.item=O.item?Object.assign(O.item,F.item):F.item)};e.$TL=r;var c;(function(O){O.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(g.serializeWithoutMessages)}),O.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(g.serialize)}),O.deserialize=(F,B)=>({...t.deserialize(F,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(Z=>g.deserialize(F,Z)),retired:!0})})(c||(e.TestResultItem=c={}));var s;(function(O){O.empty=()=>({covered:0,total:0}),O.sum=(F,B)=>{F.covered+=B.covered,F.total+=B.total}})(s||(e.ICoverageCount=s={}));var v;(function(O){O.serialize=F=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,uri:F.uri.toJSON()}),O.deserialize=(F,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,uri:F.asCanonicalUri(d.URI.revive(B.uri))})})(v||(e.IFileCoverage=v={}));function f(O){return{...O,location:O.location?.toJSON()}}function S(O){return O.location=O.location?N.$st.isIPosition(O.location)?N.$st.lift(O.location):L.$tt.lift(O.location):void 0,O}e.$UL=3;var p;(function(O){O[O.Declaration=0]="Declaration",O[O.Statement=1]="Statement",O[O.Branch=2]="Branch"})(p||(e.DetailType=p={}));var k;(function(O){O.serialize=F=>F.type===0?C.serialize(F):I.serialize(F),O.deserialize=F=>F.type===0?C.deserialize(F):I.deserialize(F)})(k||(e.CoverageDetails=k={}));var P;(function(O){O.serialize=f,O.deserialize=S})(P||(e.IBranchCoverage=P={}));var C;(function(O){O.serialize=f,O.deserialize=S})(C||(e.IDeclarationCoverage=C={}));var I;(function(O){O.serialize=F=>({...f(F),branches:F.branches?.map(P.serialize)}),O.deserialize=F=>({...S(F),branches:F.branches?.map(P.deserialize)})})(I||(e.IStatementCoverage=I={}));var T;(function(O){O[O.Add=0]="Add",O[O.Update=1]="Update",O[O.DocumentSynced=2]="DocumentSynced",O[O.Remove=3]="Remove",O[O.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",O[O.Retire=5]="Retire",O[O.AddTag=6]="AddTag",O[O.RemoveTag=7]="RemoveTag"})(T||(e.TestDiffOpType=T={}));var j;(function(O){O.deserialize=(F,B)=>B.op===0?{op:B.op,item:t.deserialize(F,B.item)}:B.op===1?{op:B.op,item:l.deserialize(B.item)}:B.op===2?{op:B.op,uri:F.asCanonicalUri(d.URI.revive(B.uri)),docv:B.docv}:B,O.serialize=F=>F.op===0?{op:F.op,item:t.serialize(F.item)}:F.op===1?{op:F.op,item:l.serialize(F.item)}:F})(j||(e.TestsDiffOp=j={}));class z{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const B=this.v();for(const Z of F)switch(Z.op){case 0:this.l(t.deserialize(this.k,Z.item),B);break;case 1:this.o(l.deserialize(Z.item),B);break;case 3:this.p(Z.itemId,B);break;case 5:this.q(Z.itemId);break;case 4:this.updatePendingRoots(Z.amount);break;case 6:this.c.set(Z.tag.id,Z.tag);break;case 7:this.c.delete(Z.id);break}B.complete?.()}l(F,B){const Z=R.$ML.parentId(F.item.extId)?.toString();let q;if(!Z)q=this.w(F),this.g.add(q),this.f.set(F.item.extId,q);else if(this.f.has(Z)){const Q=this.f.get(Z);Q.children.add(F.item.extId),q=this.w(F,Q),this.f.set(F.item.extId,q)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return B.add?.(q),F.expand===2&&this.h++,q}o(F,B){const Z=this.f.get(F.extId);if(Z)return F.expand!==void 0&&(Z.expand===2&&this.h--,F.expand===2&&this.h++),(0,e.$TL)(Z,F),B.update?.(Z),Z}p(F,B){const Z=this.f.get(F);if(!Z)return;const q=R.$ML.parentId(Z.item.extId)?.toString();q?this.f.get(q).children.delete(Z.item.extId):this.g.delete(Z);const Q=[[F]];for(;Q.length;)for(const x of Q.pop()){const X=this.f.get(x);X&&(Q.push(X.children),this.f.delete(x),B.remove?.(X,X!==Z),X.expand===2&&this.h--)}}q(F){}updatePendingRoots(F){this.j+=F}v(){return{}}}e.$VL=z}),define(ke[113],Pe([1,0,7,4,3,62,89,69]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.TestItemEventOp=void 0;var m;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const E=(n,i)=>n===i,D=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:E,label:E,description:E,error:E,sortText:E,tags:(n,i)=>!(n.length!==i.length||n.some(u=>!i.includes(u)))}),$=(n,i)=>{let u;for(const[o,t]of D)t(n[o],i[o])||(u?u[o]=i[o]:u={[o]:i[o]});return u};class y extends L.$Vc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new d.$Hh(()=>this.flushDiff(),200)),this.g=this.B(new N.$ee),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const u of this.tree.values())this.J(u)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const u of this.m)if(u.op===2&&u.uri===i.uri){u.docv=i.docv;return}break}case 1:{const u=this.m[this.m.length-1];if(u){if(u.op===1&&u.item.extId===i.item.extId){(0,M.$TL)(u.item,i.item);return}if(u.op===0&&u.item.item.extId===i.item.extId){(0,M.$TL)(u.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,u){const o=this.tree.get(i);if(o){if((o.expandLevels===void 0||u>o.expandLevels)&&(o.expandLevels=u),o.expand===1){const t=this.M(o);return t.isOpen()?this.L(o,u-1):t.wait().then(()=>this.L(o,u-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.L(o,u-1)):this.L(o,u-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,u){switch(u.op){case 3:this.O(b.$ML.joinToString(i.fullId,u.id));break;case 0:this.z(u.item,i);break;case 5:for(const o of u.ops)this.w(i,o);break;case 1:this.C(u.new,u.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:u.update}});break;case 6:this.y(i.actual.uri);break;default:(0,R.$fd)(u)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,u){const o=b.$ML.fromExtHostTestItem(i,this.root.id,u?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==u?.actual&&this.s.getChildren(t.parent).delete(i.id);let l=this.tree.get(o.toString());if(!l){l={fullId:o,actual:i,expandLevels:u?.expandLevels?u.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(l.fullId.toString(),l),this.G(i,u),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:l.expand,item:this.s.toITestItem(i)}}),this.I(i,l,u);return}if(l.actual===i){this.H(i,l,u);return}if(l.actual.uri?.toString()!==i.uri?.toString())return this.O(o.toString()),this.z(i,u);const r=this.s.getChildren(l.actual),c=l.actual,s=$(this.s.toITestItem(c),this.s.toITestItem(i));this.s.getApiFor(c).listener=void 0,l.actual=i,l.resolveBarrier=void 0,l.expand=0,s&&(s.hasOwnProperty("tags")&&(this.C(i.tags,c.tags,o.toString()),delete s.tags),this.w(l,{op:4,update:s})),this.I(i,l,u);for(const[f,S]of r)this.s.getChildren(i).get(S.id)||this.O(b.$ML.joinToString(o,S.id));const v=l.expandLevels;v!==void 0&&queueMicrotask(()=>{l.expand===1&&(l.expandLevels=void 0,this.expand(o.toString(),v))}),this.y(l.actual.uri)}C(i,u,o){const t=new Set(u.map(l=>l.id));for(const l of i)t.delete(l.id)||this.D(l);this.pushDiff({op:1,item:{extId:o,item:{tags:i.map(l=>(0,M.$RL)(this.s.controllerId,l.id))}}}),t.forEach(this.F,this)}D(i){const u=this.j.get(i.id);u?u.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$RL)(this.s.controllerId,i.id)}}))}F(i){const u=this.j.get(i);u&&!--u.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,M.$RL)(this.s.controllerId,i)}))}G(i,u){this.s.getApiFor(i).parent=u&&u.actual!==this.root?u.actual:void 0}H(i,u,o){this.G(i,o);const t=this.s.getApiFor(i);t.parent=o?.actual,t.listener=l=>this.w(u,l),this.J(u)}I(i,u,o){this.H(i,u,o);for(const[t,l]of this.s.getChildren(i))this.z(l,u)}J(i){let u;this.h?i.resolveBarrier?u=i.resolveBarrier.isOpen()?3:2:u=i.actual.canResolveChildren?1:0:u=0,u!==i.expand&&(i.expand=u,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:u}}),u===1&&i.expandLevels!==void 0&&this.M(i))}L(i,u){if(u<0)return;const o=[];for(const[t,l]of this.s.getChildren(i.actual)){const r=this.expand(b.$ML.joinToString(i.fullId,l.id),u);(0,d.$hh)(r)&&o.push(r)}if(o.length)return Promise.all(o).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const l=new d.$uh;return l.open(),l}i.expand=2,this.N(i);const u=i.resolveBarrier=new d.$uh,o=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,l)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(l){o(l)}return(0,d.$hh)(t)?t.catch(o).then(()=>{u.open(),this.J(i)}):(u.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const u=this.tree.get(i);if(!u)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const o=[u];for(;o.length;){const t=o.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const l of t.actual.tags)this.F(l.id);this.tree.delete(t.fullId.toString());for(const[l,r]of this.s.getChildren(t.actual))o.push(this.tree.get(b.$ML.joinToString(t.fullId,r.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$eP=y;class w extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$fP=w;class h extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$gP=h;class g extends Error{constructor(i,u,o){super(`TestItem with ID "${i}" is from controller "${u}" and cannot be added as a child of an item from controller "${o}".`)}}e.$hP=g;const a=(n,i,u)=>{let o=new Map;return{get size(){return o.size},forEach(t,l){for(const r of o.values())t.call(l,r,this)},[Symbol.iterator](){return o.entries()},replace(t){const l=new Map,r=new Set(o.keys()),c={op:5,ops:[]};for(const s of t){if(!(s instanceof u))throw new h(s.id);const v=i(s).controllerId;if(v!==n.controllerId)throw new g(s.id,v,n.controllerId);if(l.has(s.id))throw new w(s.id);l.set(s.id,s),r.delete(s.id),c.ops.push({op:0,item:s})}for(const s of r.keys())c.ops.push({op:3,id:s});n.listener?.(c),o=l},add(t){if(!(t instanceof u))throw new h(t.id);o.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){o.delete(t)&&n.listener?.({op:3,id:t})},get(t){return o.get(t)},toJSON(){return Array.from(o.values())}}};e.$iP=a}),define(ke[145],Pe([1,0,113]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kP=e.$jP=void 0;const N=new WeakMap,L=(M,b)=>{const m={controllerId:b};return N.set(M,m),m};e.$jP=L;const R=M=>{const b=N.get(M);if(!b)throw new d.$gP(M?.id||"<unknown>");return b};e.$kP=R}),define(ke[114],Pe([1,0,15,2]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3yb=e.$2yb=e.$1yb=void 0,e.$4yb=L,e.$5yb=M,e.$1yb="vscode-cdn.net",e.$2yb=`vscode-resource.${e.$1yb}`,e.$3yb=`'self' https://*.${e.$1yb}`;function L(b,m){return b.scheme===d.Schemas.http||b.scheme===d.Schemas.https?b:(m&&m.authority&&m.isRemote&&b.scheme===d.Schemas.file&&(b=N.URI.from({scheme:d.Schemas.vscodeRemote,authority:m.authority,path:b.path})),N.URI.from({scheme:d.Schemas.https,authority:`${b.scheme}+${R(b.authority)}.${e.$2yb}`,path:b.path,fragment:b.fragment,query:b.query}))}function R(b){return b.replace(/./g,m=>{const E=m.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?m:"-"+E.toString(16).padStart(4,"0")})}function M(b){return b.replace(/-([0-9a-f]{4})/g,(m,E)=>String.fromCharCode(parseInt(E,16)))}}),define(ke[305],Pe([1,0,4,3,114]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=void 0;class R{constructor(b,m,E){this.d=b,this.e=m,this.f=E,this.a=0,this.b=new N.$Uc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const A=m.getVisibleTextEditors();for(const D of this.c.values())A.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,m,E,A,D){let $;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===b){$=i;break}if(!$)throw new Error("not a visible editor");const y=this,w=this.a++,h=new d.$ee,g=new d.$ee,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,L.$4yb)(i,y.f)}get cspSource(){return L.$3yb}set options(i){this.b=i,y.d.$setOptions(w,i)}get options(){return this.b}set html(i){this.a=i,y.d.$setHtml(w,i)}get html(){return this.a}get onDidReceiveMessage(){return h.event}postMessage(i){return y.d.$postMessage(w,i)}},n=new class{constructor(){this.editor=b,this.line=m,this.height=E,this.webview=a,this.onDidDispose=g.event}dispose(){y.c.has(w)&&(y.c.delete(w),y.d.$disposeEditorInset(w),g.fire(),g.dispose(),h.dispose())}};return this.d.$createEditorInset(w,$.id,$.value.document.uri,m+1,E,A||{},D.identifier,D.extensionLocation),this.c.set(w,{editor:b,inset:n,onDidReceiveMessage:h}),n}$onDidDispose(b){const m=this.c.get(b);m&&m.inset.dispose()}$onDidReceiveMessage(b,m){this.c.get(b)?.onDidReceiveMessage.fire(m)}}e.$hlc=R}),define(ke[146],Pe([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5L=e.$4L=e.$3L=void 0,e.$3L="__",e.$4L=(0,d.$vi)("IAuthenticationService"),e.$5L=(0,d.$vi)("IAuthenticationExtensionsService")}),define(ke[306],Pe([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=e.VariableKind=e.$aQ=void 0,e.$aQ=(0,d.$vi)("configurationResolverService");var N;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class L extends Error{constructor(M,b){super(b),this.variable=M}}e.$bQ=L}),define(ke[307],Pe([1,0,17,51,18,24,12,103,246,306,14]),function(le,e,d,N,L,R,M,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,w,h,g){this.h=new Map,this.a=y,this.b=w,this.g=h,g&&(this.c=g.then(a=>this.i(a)))}i(y){if(M.$i){const w=Object.create(null);return Object.keys(y).forEach(h=>{w[h.toLowerCase()]=y[h]}),w}return y}resolveWithEnvironment(y,w,h){return this.l({env:this.i(y),userHome:void 0},w?w.uri:void 0,h)}async resolveAsync(y,w){const h={env:await this.c,userHome:await this.g};return this.l(h,y?y.uri:void 0,w)}async j(y,w,h,g){const a=R.$2n(w);M.$i&&a.windows?Object.keys(a.windows).forEach(i=>a[i]=a.windows[i]):M.$j&&a.osx?Object.keys(a.osx).forEach(i=>a[i]=a.osx[i]):M.$k&&a.linux&&Object.keys(a.linux).forEach(i=>a[i]=a.linux[i]),delete a.windows,delete a.osx,delete a.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,y?y.uri:void 0,a,h,g)}async resolveAnyAsync(y,w,h){return this.j(y,w,h)}async resolveAnyMap(y,w,h){const g=new Map;return{newConfig:await this.j(y,w,h,g),resolvedVariables:g}}resolveWithInteractionReplace(y,w,h,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,w,h,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,w){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,w)}async l(y,w,h,g,a){if(L.$8f(h))return this.m(y,w,h,g,a);if(Array.isArray(h))return Promise.all(h.map(n=>this.l(y,w,n,g,a)));if(L.$0f(h)){const n=Object.create(null),i=await Promise.all(Object.keys(h).map(async u=>[await this.m(y,w,u,g,a),await this.l(y,w,h[u],g,a)]));for(const[u,o]of i)n[u]=o;return n}return h}m(y,w,h,g,a){return(0,A.$pf)(h,D.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(D.VARIABLE_LHS))return n;let u=await this.o(y,n,i,w,g);return a?.set(i,u),u!==n&&L.$8f(u)&&u.match(D.VARIABLE_REGEXP)&&(u=await this.m(y,w,u,g,a)),u})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,w,h,g,a){let n;const i=h.split(":");i.length>1&&(h=i[0],n=i[1]);const u=l=>{const r=this.a.getFilePath();if(r)return(0,b.$xw)(r);throw new E.$bQ(l,(0,m.localize)(0,null,w))},o=l=>{const r=u(l);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,b.$xw)(c)}throw new E.$bQ(l,(0,m.localize)(1,null,w,d.$oc(r)))},t=l=>{if(n){const r=this.a.getFolderUri(n);if(r)return r;throw new E.$bQ(l,(0,m.localize)(2,null,w,n))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new E.$bQ(l,(0,m.localize)(3,null,w)):new E.$bQ(l,(0,m.localize)(4,null,w))};switch(h){case"env":if(n){if(y.env){const l=y.env[M.$i?n.toLowerCase():n];if(L.$8f(l))return l}return""}throw new E.$bQ(E.VariableKind.Env,(0,m.localize)(5,null,w));case"config":if(n){const l=this.a.getConfigurationValue(g,n);if(L.$eg(l))throw new E.$bQ(E.VariableKind.Config,(0,m.localize)(6,null,w,n));if(L.$0f(l))throw new E.$bQ(E.VariableKind.Config,(0,m.localize)(7,null,w,n));return l}throw new E.$bQ(E.VariableKind.Config,(0,m.localize)(8,null,w));case"command":return this.p(E.VariableKind.Command,w,n,a,"command");case"input":return this.p(E.VariableKind.Input,w,n,a,"input");case"extensionInstallFolder":if(n){const l=await this.a.getExtension(n);if(!l)throw new E.$bQ(E.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,w,n));return this.n(l.extensionLocation)}throw new E.$bQ(E.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,w));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,b.$xw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return g||n?(0,b.$xw)(this.n(t(E.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$xw)(d.$oc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new E.$bQ(E.VariableKind.UserHome,(0,m.localize)(11,null,w))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new E.$bQ(E.VariableKind.LineNumber,(0,m.localize)(12,null,w))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new E.$bQ(E.VariableKind.SelectedText,(0,m.localize)(13,null,w))}case"file":return u(E.VariableKind.File);case"fileWorkspaceFolder":return o(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return d.$oc(o(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||n?d.$mc(this.n(t(E.VariableKind.RelativeFile)),u(E.VariableKind.RelativeFile)):u(E.VariableKind.RelativeFile);case"relativeFileDirname":{const l=d.$nc(u(E.VariableKind.RelativeFileDirname));if(g||n){const r=d.$mc(this.n(t(E.VariableKind.RelativeFileDirname)),l);return r.length===0?".":r}return l}case"fileDirname":return d.$nc(u(E.VariableKind.FileDirname));case"fileExtname":return d.$pc(u(E.VariableKind.FileExtname));case"fileBasename":return d.$oc(u(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=d.$oc(u(E.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-d.$pc(l).length)}case"fileDirnameBasename":return d.$oc(d.$nc(u(E.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||w}case"execInstallFolder":{const l=this.a.getAppRoot();return l||w}case"pathSeparator":case"/":return d.sep;default:try{const l=n?`${h}:${n}`:h;return this.p(E.VariableKind.Unknown,w,l,a,void 0)}catch{return w}}}}p(y,w,h,g,a){if(h&&g){const n=a===void 0?g[h]:g[a+":"+h];if(typeof n=="string")return n;throw new E.$bQ(y,(0,m.localize)(14,null,w))}return w}}e.$qQ=D}),define(ke[147],Pe([1,0,5,143]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$QD=void 0,e.$RD=E,e.$SD=$,e.$TD=y,e.$QD=(0,d.$vi)("editorGroupsService");var L;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(L||(e.GroupDirection=L={}));var R;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var M;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var b;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var m;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function E(w){const h=w;return(0,N.$BF)(h?.editor)&&(0,N.$BF)(h?.replacement)}var A;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var D;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function $(w){const h=w;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}function y(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[308],Pe([1,0,5,147]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XD=e.$WD=e.$VD=e.$UD=void 0,e.$YD=L,e.$UD=(0,d.$vi)("editorService"),e.$VD=-1,e.$WD=-2,e.$XD=-3;function L(R){const M=R;return typeof R=="number"||(0,N.$SD)(M)}}),define(ke[148],Pe([1,0,5,137]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=void 0,e.$lM=(0,d.$wi)(N.$Ci)}),define(ke[149],Pe([1,0,25,4,17,3,7]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F_b=e.$E_b=e.$D_b=e.$C_b=e.$B_b=void 0;class b{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$B_b=b;class m{static isHostExtension(n,i,u){if(i.getExtensionDescription(n))return!1;const o=u.getExtensionDescription(n);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(n,i){this.j=n,this.c=new N.$ee,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(h),this.f=new d.$Sm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const u of i)this.h.has(u)||this.h.set(u,[]),this.h.get(u).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=g(this.e,i),this.e=this.e.concat(n);const u=m.l(this.e);return this.e=g(this.e,u.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new b(this.d,u)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,c){this.addNode(r),this.addNode(c),this.c.has(r)?this.c.get(r).push(c):this.c.set(r,[c])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,c){const s=i.getArcs(r);for(let v=0;v<s.length;v++)if(!c.has(s[v]))return!1;return!0}getNodes(){return this.e}},u=new d.$Sm;for(const r of n)if(u.set(r.identifier,r),r.extensionDependencies)for(const c of r.extensionDependencies)i.addArc(d.$Qm.toKey(r.identifier),d.$Qm.toKey(c));const o=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>o.add(r));const t=i.getNodes().filter(r=>!o.has(r));let l;do{l=!1;for(let r=0;r<t.length;r++){const c=t[r];i.hasOnlyGoodArcs(c,o)&&(t.splice(r,1),r--,o.add(c),l=!0)}}while(l);return t.map(r=>u.get(r))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$C_b=m;class E{constructor(n,i){this.versionId=n,this.extensions=i}}e.$D_b=E;class A{constructor(n){this.d=new y,this.c=new m(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new D(this,i)}deltaExtensions(n,i,u){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,u)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$E_b=A;class D extends R.$Vc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$F_b=D;class ${constructor(n){this.name=n;const i=(0,M.$oh)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class y{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new $(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const u=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(u),i=!1,this.d=!1,this.e())};n.resolve((0,R.$Tc)(o))}}var w;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(w||(w={}));function h(a,n){const i=a.isBuiltin?0:a.isUnderDevelopment?2:1,u=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==u)return i-u;const o=L.$hc.basename(a.extensionLocation.path),t=L.$hc.basename(n.extensionLocation.path);return o<t?-1:o>t?1:0}function g(a,n){const i=new d.$Rm(n);return a.filter(u=>!i.has(u.identifier))}}),define(ke[309],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.ExtHostConnectionType=void 0,e.$mn=b,e.$nn=m;var d;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(d||(e.ExtHostConnectionType=d={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(D){this.pipeName=D,this.type=1}serialize(D){D[N.ENV_KEY]=this.pipeName}}e.$jn=N;class L{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(D){D[L.ENV_KEY]="1"}}e.$kn=L;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(D){D[R.ENV_KEY]="1"}}e.$ln=R;function M(A){delete A[N.ENV_KEY],delete A[L.ENV_KEY],delete A[R.ENV_KEY]}function b(A,D){M(D),A.serialize(D)}function m(A){if(A[N.ENV_KEY])return E(A,new N(A[N.ENV_KEY]));if(A[L.ENV_KEY])return E(A,new L);if(A[R.ENV_KEY])return E(A,new R);throw new Error("No connection information defined in environment!")}function E(A,D){return M(A),D}}),define(ke[115],Pe([1,0,21]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Ym=M,e.$Zm=b;var N;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(N||(e.UIKind=N={}));var L;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(L||(e.ExtensionHostExitCode=L={}));var R;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function M(E){const A=d.$Fe.alloc(1);switch(E){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}function b(E,A){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}var m;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(ke[90],Pe([1,0,5,4,11,28,115,86,87,24,2,3,231]),function(le,e,d,N,L,R,M,b,m,E,A,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=e.$GP=e.$FP=void 0,e.$HP=h;let y=class extends D.$Vc{constructor(a,n){super(),this.s=a,this.t=n,this.a=this.B(new N.$ee),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$ee),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:m.$jp,name:(0,$.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,L.$4j)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,n,i){const u=this.getTelemetryDetails(),o=new w(n,i,a,this.n,this.j,this.getBuiltInCommonProperties(a),{isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}),t=this.r.get(a.identifier.value)??[];return this.r.set(a.identifier.value,[...t,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(a,n,i){this.f=a,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(a){const n=Object.create(null);switch(n["common.extname"]=`${a.publisher}.${a.name}`,n["common.extversion"]=a.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=h(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:n["common.uikind"]="web";break;case M.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,b.$Hm)((0,m.$pp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const n=this.getTelemetryDetails();this.r.forEach((i,u)=>{const o=i.filter(t=>!t.isDisposed);o.length===0?this.r.delete(u):this.r.set(u,o)}),this.r.forEach(i=>{for(const u of i)u.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(a,n){const u=this.r.get(a.value)?.filter(t=>!t.isDisposed);if(!u)return this.r.delete(a.value),!1;let o=!1;for(const t of u)t.ignoreUnhandledExtHostErrors||(t.logError(n),o=!0);return o}};e.$FP=y,e.$FP=y=Je([Ve(0,R.$EP),Ve(1,L.$3j)],y);class w{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,n,i,u,o,t,l){this.g=i,this.h=u,this.i=o,this.j=t,this.a=new N.$ee,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled}}updateTelemetryEnablements(a,n){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let n="properties"in a?a.properties??{}:a;return n=(0,m.$sp)(n,[]),this.c&&(n=(0,E.$5n)(n,this.c)),this.b||(n=(0,E.$5n)(n,this.j)),"properties"in a?a.properties=n:a=n,a}k(a,n){this.f&&(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(a,n),this.h.trace(a,n))}logUsage(a,n){this.d.isUsageEnabled&&this.k(a,n)}logError(a,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof a=="string")this.k(a,n);else{const i={name:a.name,message:a.message,stack:a.stack,cause:a.cause},u=(0,m.$sp)(i,[]),o=new Error(u.message,{cause:u.cause});o.stack=u.stack,o.name=u.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(o,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const a=this,n={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.$GP=w;function h(g){const a=Date.now()-new Date(g).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.$IP=(0,d.$vi)("IExtHostTelemetry")}),define(ke[26],Pe([1,0,4,2,278,140,25,5]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LG=e.ActivationKind=e.$IG=e.$HG=e.$EG=e.ExtensionHostStartup=e.$DG=e.$CG=e.$BG=e.$AG=void 0,e.$FG=$,e.$GG=y,e.$JG=a,e.$KG=n,e.$AG=Object.freeze({identifier:new M.$Qm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$BG="extensions.webWorker",e.$CG=(0,b.$vi)("extensionService");class m{constructor(o){this.dependency=o}}e.$DG=m;var E;(function(u){u[u.EagerAutoStart=1]="EagerAutoStart",u[u.EagerManualStart=2]="EagerManualStart",u[u.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(o,t,l){this.c=o,this.d=t.slice(0),this.e=l.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$lG.createActivationEventsMap(this.d)}}set(o,t,l){if(this.c>o)throw new Error(`ExtensionHostExtensions: invalid versionId ${o} (current: ${this.c})`);const r=[],c=[],s=[],v=[],f=D(this.d),S=D(t),p=(T,j)=>T.extensionLocation.toString()===j.extensionLocation.toString()||T.isBuiltin===j.isBuiltin||T.isUserBuiltin===j.isUserBuiltin||T.isUnderDevelopment===j.isUnderDevelopment;for(const T of this.d){const j=S.get(T.identifier);if(!j){r.push(T.identifier),f.delete(T.identifier);continue}if(!p(T,j)){r.push(T.identifier),f.delete(T.identifier);continue}}for(const T of t){const j=f.get(T.identifier);if(!j){c.push(T);continue}if(!p(j,T)){r.push(j.identifier),f.delete(j.identifier);continue}}const k=new M.$Rm(this.e),P=new M.$Rm(l);for(const T of this.e)P.has(T)||s.push(T);for(const T of l)k.has(T)||v.push(T);const C=R.$lG.createActivationEventsMap(c),I={versionId:o,toRemove:r,toAdd:c,addActivationEvents:C,myToRemove:s,myToAdd:v};return this.delta(I),I}delta(o){if(this.c>=o.versionId)return null;const{toRemove:t,toAdd:l,myToRemove:r,myToAdd:c}=o,s=new M.$Rm(t),v=new M.$Rm(r);for(let f=0;f<this.d.length;f++)s.has(this.d[f].identifier)&&(this.d.splice(f,1),f--);for(let f=0;f<this.e.length;f++)v.has(this.e[f])&&(this.e.splice(f,1),f--);for(const f of l)this.d.push(f);for(const f of c)this.e.push(f);return this.f=null,o}containsExtension(o){for(const t of this.e)if(M.$Qm.equals(t,o))return!0;return!1}containsActivationEvent(o){return this.f||(this.f=this.g()),this.f.has(o)}g(){const o=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const l=R.$lG.readActivationEvents(t);for(const r of l)o.add(r)}return o}}e.$EG=A;function D(u){const o=new M.$Sm;for(const t of u)o.set(t.identifier,t);return o}function $(u,o){return u.enabledApiProposals?u.enabledApiProposals.includes(o):!1}function y(u,o){if(!$(u,o))throw new Error(`Extension '${u.identifier.value}' CANNOT use API proposal: ${o}.
Its package.json#enabledApiProposals-property declares: ${u.enabledApiProposals?.join(", ")??"[]"} but NOT ${o}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${u.identifier.value}`)}class w{constructor(o,t,l,r){this.codeLoadingTime=o,this.activateCallTime=t,this.activateResolvedTime=l,this.activationReason=r}}e.$HG=w;class h{constructor(o,t){this.description=o,this.value=t}}e.$IG=h;var g;(function(u){u[u.Normal=0]="Normal",u[u.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function a(u){return{type:u.isBuiltin?0:1,isBuiltin:u.isBuiltin||u.isUserBuiltin,identifier:{id:(0,L.$yp)(u.publisher,u.name),uuid:u.uuid},manifest:u,location:u.extensionLocation,targetPlatform:u.targetPlatform,validations:[],isValid:!0}}function n(u,o){return{identifier:new M.$Qm((0,L.$wp)(u.manifest.publisher,u.manifest.name)),isBuiltin:u.type===0,isUserBuiltin:u.type===1&&u.isBuiltin,isUnderDevelopment:!!o,extensionLocation:u.location,...u.manifest,uuid:u.identifier.uuid,targetPlatform:u.targetPlatform,publisherDisplayName:u.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None,this.onWillStop=d.Event.None,this.extensions=[]}activateByEvent(o){return Promise.resolve(void 0)}activateById(o,t){return Promise.resolve(void 0)}activationEventIsDone(o){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(o,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$LG=i}),define(ke[310],Pe([1,0,13,149,25,26,11,7]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=e.$Hlc=e.$Glc=e.$Flc=e.$Elc=e.$Dlc=void 0;class m{static{this.NONE=new m(!1,-1,-1,-1)}constructor(a,n,i,u){this.startup=a,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=u}}e.$Dlc=m;class E{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,n){return a===-1||n===-1?-1:n-a}build(){return new m(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Elc=E;class A{constructor(a,n,i,u,o,t){this.activationFailed=a,this.activationFailedError=n,this.activationTimes=i,this.module=u,this.exports=o,this.subscriptions=t}}e.$Flc=A;class D extends A{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Glc=D;class $ extends A{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Hlc=$;class y extends A{constructor(a){super(!0,a,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let w=class{constructor(a,n,i,u){this.g=u,this.a=a,this.b=n,this.c=i,this.d=new L.$Sm,this.f=Object.create(null)}dispose(){for(const[a,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const a=[];for(const[n,i]of this.d)a.push(i.wait());await Promise.all(a)}isActivated(a){const n=this.d.get(a);return!!(n&&n.value)}getActivatedExtension(a){const n=this.d.get(a);if(!n||!n.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return n.value}async activateByEvent(a,n){if(this.f[a])return;const i=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(i.map(u=>({id:u.identifier,reason:{startup:n,extensionId:u.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,n){const i=this.a.getExtensionDescription(a);if(!i)throw new Error(`Extension '${a.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(a){const n=a.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const n=this.a.getExtensionDescription(a.id);if(!n){const o=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this.k(a,null,[],new y(o));return this.c.onExtensionActivationError(a.id,o,new R.$DG(a.id.value)),t}const i=[],u=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const o of u){if(this.m(o))continue;const t=this.d.get(o);if(t){i.push(t);continue}if(this.l(o)){i.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:a.reason}));continue}const l=this.a.getExtensionDescription(o);if(l){if(!l.main&&!l.browser)continue;i.push(this.j({id:l.identifier,reason:a.reason}));continue}const r=n.displayName||n.identifier.value,c=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${o}'`),s=this.k(a,n.displayName,[],new y(c));return this.c.onExtensionActivationError(n.identifier,c,new R.$DG(o)),s}return this.k(a,n.displayName,i,null)}k(a,n,i,u){const o=new h(a.id,n,a.reason,i,u,this.c,this.g);return this.d.set(a.id,o),o}l(a){return N.$C_b.isHostExtension(a,this.a,this.b)}m(a){const n=this.b.getExtensionDescription(a);return n?!n.main&&!n.browser:!1}};e.$Ilc=w,e.$Ilc=w=Je([Ve(3,M.$2j)],w);let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,n,i,u,o,t,l){this.c=a,this.d=n,this.f=i,this.g=u,this.h=o,this.j=t,this.k=l,this.a=new b.$uh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const n=this.g[a];if(n.value&&!n.value.activationFailed){this.g.splice(a,1),a--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new y(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const n=new Error;if(a&&a.name&&(n.name=a.name),a&&a.message?n.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(n.stack=a.stack),this.h=new y(n),this.b&&d.$4(a))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};h=Je([Ve(6,M.$2j)],h)}),define(ke[311],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testPreserveFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testPreserveFocus.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[312],Pe([1,0,248,13,41,138,110,36,25,311,108,140]),function(le,e,d,N,L,R,M,b,m,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=void 0;const $=b.$bo.as(M.$co.JSONContribution);class y{constructor(o,t,l){this.a=o,this.b=t,this.c=l}d(o,t){this.a({type:o,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(o){this.d(L.default.Error,o)}warn(o){this.d(L.default.Warning,o)}info(o){this.d(L.default.Info,o)}}e.$uG=y;class w{static a(o){const t=new m.$Rm;for(let l=0,r=o.length;l<r;l++)t.add(o[l].description.identifier);return t}static compute(o,t){if(!o||!o.length)return new w(t,[]);if(!t||!t.length)return new w([],o);const l=this.a(o),r=this.a(t),c=t.filter(v=>!l.has(v.description.identifier)),s=o.filter(v=>!r.has(v.description.identifier));return new w(c,s)}constructor(o,t){this.added=o,this.removed=t}}e.$vG=w;class h{constructor(o,t){this.name=o,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(o){if(this.a!==null)throw new Error("Handler already set!");this.a=o,this.d()}acceptUsers(o){this.c=w.compute(this.b,o),this.b=o,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(o){(0,N.$1)(o)}}}e.$wG=h;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[d.localize(0,null),d.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$xG={properties:{engines:{type:"object",description:d.localize(2,null),properties:{vscode:{type:"string",description:d.localize(3,null),default:"^1.22.0"}}},publisher:{description:d.localize(4,null),type:"string"},displayName:{description:d.localize(5,null),type:"string"},categories:{description:d.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$Pm},{type:"string",const:"Languages",deprecationMessage:d.localize(7,null)}]}},galleryBanner:{type:"object",description:d.localize(8,null),properties:{color:{description:d.localize(9,null),type:"string"},theme:{description:d.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:d.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:d.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:d.localize(13,null)},enabledApiProposals:{markdownDescription:d.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:d.localize(15,null),type:"string",enum:["none"],enumDescriptions:[d.localize(16,null)]},activationEvents:{description:d.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:d.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:d.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:d.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:d.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:d.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:d.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:d.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:d.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:d.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:d.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:d.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:d.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:d.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:d.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:d.localize(32,null)},{label:"onUri",body:"onUri",description:d.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:d.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:d.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:d.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:d.localize(37,null)},{label:"onRenderer",description:d.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:d.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:d.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:d.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:d.localize(42,null)},{label:"*",description:d.localize(43,null),body:"*"}]}},badges:{type:"array",description:d.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:d.localize(45,null)},href:{type:"string",description:d.localize(46,null)},description:{type:"string",description:d.localize(47,null)}}}},markdown:{type:"string",description:d.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:d.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:d.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$So}},extensionPack:{description:d.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$So}},extensionKind:{description:d.localize(52,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:d.localize(53,null)},{body:["workspace"],description:d.localize(54,null)},{body:["ui","workspace"],description:d.localize(55,null)},{body:["workspace","ui"],description:d.localize(56,null)},{body:[],description:d.localize(57,null)}]},capabilities:{description:d.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:d.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:d.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[d.localize(61,null),d.localize(62,null),d.localize(63,null)]},description:{type:"string",markdownDescription:d.localize(64,null)}}},untrustedWorkspaces:{description:d.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:d.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[d.localize(67,null),d.localize(68,null),d.localize(69,null)]},restrictedConfigurations:{description:d.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:d.localize(71,null)}}}}},sponsor:{description:d.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:d.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:d.localize(74,null),type:"string"},"vscode:uninstall":{description:d.localize(75,null),type:"string"}}},icon:{type:"string",description:d.localize(76,null)},l10n:{type:"string",description:d.localize(77,null)},pricing:{type:"string",markdownDescription:d.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(o){if(this.a.has(o.extensionPoint))throw new Error("Duplicate extension point: "+o.extensionPoint);const t=new h(o.extensionPoint,o.defaultExtensionKind);return this.a.set(o.extensionPoint,t),o.activationEventsGenerator&&D.$lG.register(o.extensionPoint,o.activationEventsGenerator),e.$xG.properties.contributes.properties[o.extensionPoint]=o.jsonSchema,$.registerSchema(a,e.$xG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$yG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};b.$bo.add(i.ExtensionsRegistry,new n),e.$zG=b.$bo.as(i.ExtensionsRegistry),$.registerSchema(a,e.$xG),$.registerSchema(A.$jk,{properties:{extensionEnabledApiProposals:{description:d.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(ke[313],Pe([1,0,244,18,24,312,38,4]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6H=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:d.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:d.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:d.localize(2,null),default:""}}};var E;(function($){function y(w,h,g){if(!w)return;const a=N.$8f(w.type)?w.type:void 0;if(!a||a.length===0){g.error(d.localize(3,null));return}const n=[];if(Array.isArray(w.required))for(const i of w.required)N.$8f(i)&&n.push(i);return{extensionId:h.value,taskType:a,required:n,properties:w.properties?L.$2n(w.properties):{},when:w.when?M.$tj.deserialize(w.when):void 0}}$.from=y})(E||(E={}));const A=R.$zG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:($,y)=>{for(const w of $)w.type&&y.push(`onTaskType:${w.type}`)},jsonSchema:{description:d.localize(4,null),type:"array",items:m}});class D{constructor(){this.d=new b.$ee,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,w)=>{A.setHandler((h,g)=>{this.c=void 0;try{for(const a of g.removed){const n=a.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const a of g.added){const n=a.value;for(const i of n){const u=E.from(i,a.description.identifier,a.collector);u&&(this.a[u.taskType]=u)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const w of this.all()){const h={type:"object",additionalProperties:!1};w.required.length>0&&(h.required=w.required.slice(0)),w.properties!==void 0?h.properties=L.$2n(w.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[w.taskType]},y.push(h)}this.c={oneOf:y}}return this.c}}e.$6H=new D}),define(ke[314],Pe([1,0,245,18,23,24,38,313]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$dI=e.JsonSchemaVersion=e.ExecutionEngine=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$0H=e.ShellQuoting=e.$9H=e.$8H=e.$7H=void 0,e.$7H="settings",e.$8H=new M.$Mj("taskRunning",!1,d.localize(0,null)),e.$9H=d.localize2(2,"Tasks");var m;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.$0H="$customized",function(O){function F(B){if(!B)return O.Strong;switch(B.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=F}(m||(e.ShellQuoting=m={}));var E;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var A;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(A||(e.RevealKind=A={})),function(O){function F(B){switch(B.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=F}(A||(e.RevealKind=A={}));var D;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(O){function F(B){switch(B.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=F}(D||(e.RevealProblemKind=D={}));var $;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})($||(e.PanelKind=$={})),function(O){function F(B){switch(B.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=F}($||(e.PanelKind=$={}));var y;(function(O){O.defaults={echo:!0,reveal:A.Always,revealProblems:D.Never,focus:!1,panel:$.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var w;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(w||(e.RuntimeType=w={})),function(O){function F(Z){switch(Z.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=F;function B(Z){switch(Z){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=B}(w||(e.RuntimeType=w={}));var h;(function(O){function F(B){return N.$8f(B)?B:B.value}O.value=F})(h||(e.CommandString=h={}));var g;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function F(Z){return Z===O.Clean._id||Z===O.Build._id||Z===O.Rebuild._id||Z===O.Test._id}O.is=F;function B(Z){if(Z!==void 0)return N.$8f(Z)?F(Z)?{_id:Z,isDefault:!1}:void 0:Z}O.from=B})(g||(e.TaskGroup=g={}));var a;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(a||(e.TaskScope=a={}));var n;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function F(B){switch(B){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=F})(n||(e.TaskSourceKind=n={}));var i;(function(O){O.parallel="parallel",O.sequence="sequence"})(i||(e.DependsOrder=i={}));var u;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(u||(e.RunOnOptions=u={}));var o;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:u.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class t{constructor(F,B,Z,q,Q,x){this._label="",this._id=F,B&&(this._label=B),Z&&(this.type=Z),this.runOptions=q,this.configurationProperties=Q,this._source=x}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,B=!1){if(F===void 0)return!1;if(N.$8f(F))return F===this._label||F===this.configurationProperties.identifier||B&&F===this._id;const Z=this.getDefinition(!0);return Z!==void 0&&Z._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$$H=t;class l extends t{constructor(F,B,Z,q,Q,x,X,ie){super(F,Z,void 0,X,ie,B),this.command={},this._source=B,this.hasDefinedMatchers=x,Q&&(this.command=Q)}clone(){return new l(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case w.Shell:B="shell";break;case w.Process:B="process";break;case w.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(F){return F instanceof l}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$7H:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const Z={type:e.$0H,folder:F,id:B};return JSON.stringify(Z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$6g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new l(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$_H=l;class r extends t{constructor(F,B,Z,q,Q,x,X){super(F,Z,q,x,X,B),this._source=B,this.configures=Q}static is(F){return F instanceof r}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$6g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$7H:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const Z={type:e.$0H,folder:F,id:B};return JSON.stringify(Z)}}e.$aI=r;class c extends t{constructor(F,B,Z,q,Q,x,X,ie,me){super(F,Z,q,ie,me,B),this.defines=Q,this.hasDefinedMatchers=X,this.command=x,this.icon=me.icon,this.hide=me.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof c}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new c(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$bI=c;class s extends t{constructor(F,B,Z,q,Q,x){super(F,Z,q,Q,x,B),this._source=B}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new s(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$cI=s;var v;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(v||(e.ExecutionEngine=v={})),function(O){O._default=O.Terminal}(v||(e.ExecutionEngine=v={}));var f;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(f||(e.JsonSchemaVersion=f={}));class S{constructor(F){this.c=new Map;for(let B=0;B<F.length;B++)this.c.set(F[B].uri.toString(),B)}compare(F,B){const Z=F.getWorkspaceFolder(),q=B.getWorkspaceFolder();if(Z&&q){let Q=this.c.get(Z.uri.toString());Q=Q===void 0?0:Q+1;let x=this.c.get(q.uri.toString());return x=x===void 0?0:x+1,Q===x?F._label.localeCompare(B._label):Q-x}else return!Z&&q?-1:Z&&!q?1:0}}e.$dI=S;var p;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(p||(e.TaskEventKind=p={}));var k;(function(O){O.SingleRun="singleRun",O.Background="background"})(k||(e.TaskRunType=k={}));var P;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(P||(e.TaskRunSource=P={}));var C;(function(O){function F(ie){return{taskId:ie._id,taskName:ie.configurationProperties.name,runType:ie.configurationProperties.isBackground?"background":"singleRun",group:ie.configurationProperties.group,__task:ie}}function B(ie,me,ue){return{...F(ie),kind:"start",terminalId:me,resolvedVariables:ue}}O.start=B;function Z(ie,me,ue){return{...F(ie),kind:"processStarted",terminalId:me,processId:ue}}O.processStarted=Z;function q(ie,me,ue){return{...F(ie),kind:"processEnded",terminalId:me,exitCode:ue}}O.processEnded=q;function Q(ie,me,ue){return{...F(ie),kind:"terminated",exitReason:ue,terminalId:me}}O.terminated=Q;function x(ie,me,ue){return{...F(me),kind:ie,terminalId:ue}}O.general=x;function X(){return{kind:"changed"}}O.changed=X})(C||(e.TaskEvent=C={}));var I;(function(O){function F(Z){const q=Object.keys(Z).sort();let Q="";for(const x of q){let X=Z[x];X instanceof Object?X=F(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),Q+=x+","+X+","}return Q}function B(Z){const Q={_key:F(Z),type:Z.taskType};return Object.assign(Q,Z),Q}O.create=B})(I||(e.KeyedTaskIdentifier=I={}));var T;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection",O.VerboseLogging="task.verboseLogging"})(T||(e.TaskSettingId=T={}));var j;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var z;(function(O){function F(B,Z){const q=b.$6H.get(B.type);if(q===void 0){const ie=R.$2n(B);return delete ie._key,I.create(ie)}const Q=Object.create(null);Q.type=q.taskType;const x=new Set;q.required.forEach(ie=>x.add(ie));const X=q.properties;for(const ie of Object.keys(X)){const me=B[ie];if(me!=null)Q[ie]=me;else if(x.has(ie)){const ue=X[ie];if(ue.default!==void 0)Q[ie]=R.$2n(ue.default);else switch(ue.type){case"boolean":Q[ie]=!1;break;case"number":case"integer":Q[ie]=0;break;case"string":Q[ie]="";break;default:Z.error(d.localize(1,null,JSON.stringify(B,void 0,0),ie));return}}}return I.create(Q)}O.createTaskIdentifier=F})(z||(e.TaskDefinition=z={}))}),define(ke[315],Pe([1,0,13]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H_b=e.$G_b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,b)=>{this.b=M,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,d.$1)(M))}then(M,b){return this.j().then(M,b)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$G_b=N;class L extends N{constructor(){super(),this.h=!0,this.i=new d.$5}}e.$H_b=L}),define(ke[48],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uw=e.$rw=void 0,e.$sw=L,e.$tw=R;class d{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++d.count}}e.$rw=d;const N=[];function L(b){const m=new d(b);return N[m.nid]=m,m}function R(b){return N[b].sid}class M{constructor(m){this.value=m}}e.$uw=M}),define(ke[6],Pe([1,0,48]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$ZM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var L;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput",h[h.ChatEditorInput=10]="ChatEditorInput",h[h.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(L||(e.TabInputKind=L={}));var R;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var M;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var b;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var m;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var E;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var A;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class D{static{this.a=0}static mixin(g){return g._id=D.a++,g}}e.$ZM=D;var $;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var y;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var w;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$1M={MainThreadAuthentication:(0,d.$sw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,d.$sw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,d.$sw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,d.$sw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,d.$sw)("MainThreadChatVariables"),MainThreadClipboard:(0,d.$sw)("MainThreadClipboard"),MainThreadCommands:(0,d.$sw)("MainThreadCommands"),MainThreadComments:(0,d.$sw)("MainThreadComments"),MainThreadConfiguration:(0,d.$sw)("MainThreadConfiguration"),MainThreadConsole:(0,d.$sw)("MainThreadConsole"),MainThreadDebugService:(0,d.$sw)("MainThreadDebugService"),MainThreadDecorations:(0,d.$sw)("MainThreadDecorations"),MainThreadDiagnostics:(0,d.$sw)("MainThreadDiagnostics"),MainThreadDialogs:(0,d.$sw)("MainThreadDiaglogs"),MainThreadDocuments:(0,d.$sw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,d.$sw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,d.$sw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,d.$sw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,d.$sw)("MainThreadEditorTabs"),MainThreadErrors:(0,d.$sw)("MainThreadErrors"),MainThreadTreeViews:(0,d.$sw)("MainThreadTreeViews"),MainThreadDownloadService:(0,d.$sw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,d.$sw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,d.$sw)("MainThreadLanguages"),MainThreadLogger:(0,d.$sw)("MainThreadLogger"),MainThreadMessageService:(0,d.$sw)("MainThreadMessageService"),MainThreadOutputService:(0,d.$sw)("MainThreadOutputService"),MainThreadProgress:(0,d.$sw)("MainThreadProgress"),MainThreadQuickDiff:(0,d.$sw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,d.$sw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,d.$sw)("MainThreadStatusBar"),MainThreadSecretState:(0,d.$sw)("MainThreadSecretState"),MainThreadStorage:(0,d.$sw)("MainThreadStorage"),MainThreadSpeech:(0,d.$sw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,d.$sw)("MainThreadTelemetry"),MainThreadTerminalService:(0,d.$sw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,d.$sw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,d.$sw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,d.$sw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,d.$sw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,d.$sw)("MainThreadCustomEditors"),MainThreadUrls:(0,d.$sw)("MainThreadUrls"),MainThreadUriOpeners:(0,d.$sw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,d.$sw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,d.$sw)("MainThreadWorkspace"),MainThreadFileSystem:(0,d.$sw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,d.$sw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,d.$sw)("MainThreadExtensionService"),MainThreadSCM:(0,d.$sw)("MainThreadSCM"),MainThreadSearch:(0,d.$sw)("MainThreadSearch"),MainThreadShare:(0,d.$sw)("MainThreadShare"),MainThreadTask:(0,d.$sw)("MainThreadTask"),MainThreadWindow:(0,d.$sw)("MainThreadWindow"),MainThreadLabelService:(0,d.$sw)("MainThreadLabelService"),MainThreadNotebook:(0,d.$sw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,d.$sw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,d.$sw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,d.$sw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,d.$sw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,d.$sw)("MainThreadInteractive"),MainThreadInlineChat:(0,d.$sw)("MainThreadInlineChatShape"),MainThreadTheming:(0,d.$sw)("MainThreadTheming"),MainThreadTunnelService:(0,d.$sw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,d.$sw)("MainThreadManagedSockets"),MainThreadTimeline:(0,d.$sw)("MainThreadTimeline"),MainThreadTesting:(0,d.$sw)("MainThreadTesting"),MainThreadLocalization:(0,d.$sw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,d.$sw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,d.$sw)("MainThreadAiEmbeddingVector")},e.$2M={ExtHostCommands:(0,d.$sw)("ExtHostCommands"),ExtHostConfiguration:(0,d.$sw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,d.$sw)("ExtHostDiagnostics"),ExtHostDebugService:(0,d.$sw)("ExtHostDebugService"),ExtHostDecorations:(0,d.$sw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,d.$sw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,d.$sw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,d.$sw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,d.$sw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,d.$sw)("ExtHostEditors"),ExtHostTreeViews:(0,d.$sw)("ExtHostTreeViews"),ExtHostFileSystem:(0,d.$sw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,d.$sw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,d.$sw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,d.$sw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,d.$sw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,d.$sw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,d.$sw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,d.$sw)("ExtHostStatusBar"),ExtHostShare:(0,d.$sw)("ExtHostShare"),ExtHostExtensionService:(0,d.$sw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,d.$sw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,d.$sw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,d.$sw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,d.$sw)("ExtHostSCM"),ExtHostSearch:(0,d.$sw)("ExtHostSearch"),ExtHostTask:(0,d.$sw)("ExtHostTask"),ExtHostWorkspace:(0,d.$sw)("ExtHostWorkspace"),ExtHostWindow:(0,d.$sw)("ExtHostWindow"),ExtHostWebviews:(0,d.$sw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,d.$sw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,d.$sw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,d.$sw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,d.$sw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,d.$sw)("ExtHostEditorTabs"),ExtHostProgress:(0,d.$sw)("ExtHostProgress"),ExtHostComments:(0,d.$sw)("ExtHostComments"),ExtHostSecretState:(0,d.$sw)("ExtHostSecretState"),ExtHostStorage:(0,d.$sw)("ExtHostStorage"),ExtHostUrls:(0,d.$sw)("ExtHostUrls"),ExtHostUriOpeners:(0,d.$sw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,d.$sw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,d.$sw)("ExtHostOutputService"),ExtHostLabelService:(0,d.$sw)("ExtHostLabelService"),ExtHostNotebook:(0,d.$sw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,d.$sw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,d.$sw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,d.$sw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,d.$sw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,d.$sw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,d.$sw)("ExtHostInteractive"),ExtHostInlineChat:(0,d.$sw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,d.$sw)("ExtHostChatAgents"),ExtHostChatVariables:(0,d.$sw)("ExtHostChatVariables"),ExtHostChatProvider:(0,d.$sw)("ExtHostChatProvider"),ExtHostSpeech:(0,d.$sw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,d.$sw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,d.$sw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,d.$sw)("ExtHostTheming"),ExtHostTunnelService:(0,d.$sw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,d.$sw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,d.$sw)("ExtHostAuthentication"),ExtHostTimeline:(0,d.$sw)("ExtHostTimeline"),ExtHostTesting:(0,d.$sw)("ExtHostTesting"),ExtHostTelemetry:(0,d.$sw)("ExtHostTelemetry"),ExtHostLocalization:(0,d.$sw)("ExtHostLocalization")}}),define(ke[91],Pe([1,0,5,11,6,20]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=e.$4kc=e.$3kc=void 0,e.$3kc=(0,d.$vi)("IExtHostApiDeprecationService");let M=class{constructor(m,E){this.c=E,this.a=new Set,this.b=m.getProxy(L.$1M.MainThreadTelemetry)}report(m,E,A){const D=this.d(m,E);this.a.has(D)||(this.a.add(D),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:m}))}d(m,E){return`${m}-${E.identifier.value}`}};e.$4kc=M,e.$4kc=M=Je([Ve(0,R.$oP),Ve(1,N.$2j)],M),e.$5kc=Object.freeze(new class{report(b,m,E){}})}),define(ke[316],Pe([1,0,6]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=void 0;class N{constructor(R){const M=R.getProxy(d.$1M.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(b){return M.$writeText(b)}})}}e.$flc=N}),define(ke[317],Pe([1,0,24,6,28,20]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=void 0;let M=class{constructor(A,D){this.a=A.getProxy(N.$1M.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,D){const $=this,y=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){$.e(A,D,y,arguments)}})}e(A,D,$,y){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:m(y,this.b)}),this.c&&this.f(A,$,y)}};e.$_mc=M,e.$_mc=M=Je([Ve(0,R.$oP),Ve(1,L.$EP)],M);const b=1e5;function m(E,A){const D=[];if(E.length)for(let $=0;$<E.length;$++){let y=E[$];if(typeof y>"u")y="undefined";else if(y instanceof Error){const w=y;w.stack?y=w.stack:y=w.toString()}D.push(y)}if(A){const $=new Error().stack;$&&D.push({__$stack:$.split(`
`).slice(3).join(`
`)})}try{const $=(0,d.$7n)(D);return $.length>b?"Output omitted for a large object that exceeds the limits":$}catch($){return`Output omitted for an object that cannot be inspected ('${$.toString()}')`}}}),define(ke[318],Pe([1,0,2,6,26]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=void 0;class R{constructor(b){this.a=b.getProxy(N.$1M.MainThreadDialogs)}showOpenDialog(b,m){return m?.allowUIResources&&(0,L.$GG)(b,"showLocal"),this.a.$showOpenDialog(m).then(E=>E?E.map(A=>d.URI.revive(A)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then(m=>m?d.URI.revive(m):void 0)}}e.$cmc=R}),define(ke[319],Pe([1,0,3,6]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=void 0;class L{constructor(M){this.b=0,this.a=M.getProxy(N.$1M.MainThreadLabelService)}$registerResourceLabelFormatter(M){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,M),(0,d.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$wmc=L}),define(ke[116],Pe([1,0,12,14,2,5,11,6,28,20]),function(le,e,d,N,L,R,M,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=e.$Wlc=void 0;let A=class{constructor($,y,w){this.f=w,this.d=new Map,this.a=y.getProxy(b.$1M.MainThreadLocalization),this.b=$.environment.appLanguage,this.c=this.b===d.$g}getMessage($,y){const{message:w,args:h,comment:g}=y;if(this.c)return(0,N.$9e)(w,h??{});let a=w;g&&g.length>0&&(a+=`/${Array.isArray(g)?g.join(""):g}`);const n=this.d.get($)?.contents[a];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,N.$9e)(n??w,h??{})}getBundle($){return this.d.get($)?.contents}getBundleUri($){return this.d.get($)?.uri}async initializeLocalizedMessages($){if(this.c||!$.l10n&&!$.isBuiltin||this.d.has($.identifier.value))return;let y;const w=await this.g($);if(!w){this.f.error(`No bundle location found for extension ${$.identifier.value}`);return}try{const h=await this.a.$fetchBundleContents(w),g=JSON.parse(h);y=$.isBuiltin?g.contents?.bundle:g}catch(h){this.f.error(`Failed to load translations for ${$.identifier.value} from ${w}: ${h.message}`);return}y&&this.d.set($.identifier.value,{contents:y,uri:w})}async g($){if($.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri($.identifier.value,this.b);return L.URI.revive(y)}return $.l10n?L.URI.joinPath($.extensionLocation,$.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Wlc=A,e.$Wlc=A=Je([Ve(0,m.$EP),Ve(1,E.$oP),Ve(2,M.$2j)],A),e.$Xlc=(0,R.$vi)("IExtHostLocalizationService")}),define(ke[150],Pe([1,0,11,6,28,20,2,58]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=void 0;let m=class extends d.$ak{constructor(D,$){super($.logLevel,$.logsLocation,$.loggers.map(y=>(0,b.$5h)(y))),this.r=D.getProxy(N.$1M.MainThreadLogger)}$setLogLevel(D,$){$?this.setLogLevel(M.URI.revive($),D):this.setLogLevel(D)}setVisibility(D,$){super.setVisibility(D,$),this.r.$setVisibility(D,$)}s(D,$,y){return new E(this.r,D,$,y)}};e.$$mc=m,e.$$mc=m=Je([Ve(0,R.$oP),Ve(1,L.$EP)],m);class E extends d.$8j{constructor(D,$,y,w){super(w?.logLevel==="always"),this.r=D,this.s=$,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger($,w).then(()=>{this.u(this.n),this.m=!0})}g(D,$){const y=[[D,$]];this.m?this.u(y):this.n.push(...y)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(ke[117],Pe([1,0,6,5,3,20,21]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=e.$Ylc=void 0,e.$Ylc=(0,N.$vi)("IExtHostManagedSockets");let b=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(d.$1M.MainThreadManagedSockets)}setFactory(D,$){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(D,$),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const $=++this.b,y=await this.c.makeConnection(),w=new L.$Uc;return this.d.set($,new E($,y,w)),w.add((0,L.$Tc)(()=>this.d.delete($))),w.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd($),w.dispose()})),w.add(y.onDidClose(h=>{this.a.$onDidManagedSocketClose($,h?.stack??h?.message),w.dispose()})),w.add(y.onDidReceiveMessage(h=>this.a.$onDidManagedSocketHaveData($,M.$Fe.wrap(h)))),$}$remoteSocketWrite(D,$){this.d.get(D)?.actual.send($.buffer)}$remoteSocketEnd(D){const $=this.d.get(D);$&&($.actual.end(),$.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$Zlc=b,e.$Zlc=b=Je([Ve(0,R.$oP)],b);class m{constructor(D,$){this.socketFactoryId=D,this.makeConnection=$}}class E extends L.$Vc{constructor(D,$,y){super(),this.socketId=D,this.actual=$,this.B(y)}}}),define(ke[320],Pe([1,0,6,11,26]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ymc=void 0;function R(b){return b&&b.title}let M=class{constructor(m,E){this.b=E,this.a=m.getProxy(d.$1M.MainThreadMessageService)}showMessage(m,E,A,D,$){const y={source:{identifier:m.identifier,label:m.displayName||m.name}};let w;typeof D=="string"||R(D)?w=[D,...$]:(y.modal=D?.modal,y.useCustom=D?.useCustom,y.detail=D?.detail,w=$),y.useCustom&&(0,L.$GG)(m,"resolvers");const h=[];let g=!1;for(let a=0;a<w.length;a++){const n=w[a];if(typeof n=="string")h.push({title:n,handle:a,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:u}=n;h.push({title:i,isCloseAffordance:!!u,handle:a}),u&&(g?this.b.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,n):g=!0)}else this.b.warn(`[${m.identifier}] Invalid message item:`,n)}return this.a.$showMessage(E,A,y,h).then(a=>{if(typeof a=="number")return w[a]})}};e.$ymc=M,e.$ymc=M=Je([Ve(1,N.$2j)],M)}),define(ke[321],Pe([1,0,3,18,2,26,6]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;class b{constructor(E){this.b=new Map,this.a=E.getProxy(M.$1M.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,A,D){if((0,R.$GG)(E,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,D),this.a.$registerProfileContentHandler(A,D.name,D.description,E.identifier.value),(0,d.$Tc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(E,A,D,$){const y=this.b.get(E);if(!y)throw new Error(`Unknown handler with id: ${E}`);return y.saveProfile(A,D,$)}async $readProfile(E,A,D){const $=this.b.get(E);if(!$)throw new Error(`Unknown handler with id: ${E}`);return $.readProfile((0,N.$8f)(A)?A:L.URI.revive(A),D)}}e.$Hmc=b}),define(ke[118],Pe([1,0,6,4,5]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=e.$Tlc=void 0;class R{constructor(b){this.b=new N.$ee,this.onDidChangePassword=this.b.event,this.a=b.getProxy(d.$1M.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,m){return this.a.$getPassword(b,m)}store(b,m,E){return this.a.$setPassword(b,m,E)}delete(b,m){return this.a.$deletePassword(b,m)}}e.$Tlc=R,e.$Ulc=(0,L.$vi)("IExtHostSecretState")}),define(ke[322],Pe([1,0,22,3,6]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=void 0;class R{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(L.$1M.MainThreadSpeech)}async $createSpeechToTextSession(b,m,E){const A=this.c.get(b);if(!A)return;const D=new N.$Uc,$=new d.$pe;this.d.set(m,$);const y=D.add(A.provideSpeechToTextSession($.token,E?{language:E}:void 0));D.add(y.onDidChange(w=>{$.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,w)})),D.add($.token.onCancellationRequested(()=>D.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}async $createKeywordRecognitionSession(b,m){const E=this.c.get(b);if(!E)return;const A=new N.$Uc,D=new d.$pe;this.d.set(m,D);const $=A.add(E.provideKeywordRecognitionSession(D.token));A.add($.onDidChange(y=>{D.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(m,y)})),A.add(D.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,m,E){const A=R.a++;return this.c.set(A,E),this.b.$registerProvider(A,m,{extension:b,displayName:b.value}),(0,N.$Tc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Omc=R}),define(ke[119],Pe([1,0,6,4,5]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=e.$Jlc=void 0;class R{constructor(b,m){this.c=m,this.b=new N.$ee,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(d.$1M.MainThreadStorage)}registerExtensionStorageKeysToSync(b,m){this.a.$registerExtensionStorageKeysToSync(b,m)}async initializeExtensionStorage(b,m,E){const A=await this.a.$initializeExtensionStorage(b,m);let D;return A&&(D=this.d(b,m,A)),D||E}setValue(b,m,E){return this.a.$setValue(b,m,E)}$acceptValue(b,m,E){const A=this.d(b,m,E);A&&this.b.fire({shared:b,key:m,value:A})}d(b,m,E){try{return JSON.parse(E)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${b}): ${A}`)}}}e.$Jlc=R,e.$Klc=(0,L.$vi)("IExtHostStorage")}),define(ke[323],Pe([1,0,3,15,2,6]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=void 0;class M{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(R.$1M.MainThreadUriOpeners)}registerExternalUriOpener(m,E,A,D){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const $=D.schemes.find(y=>!M.a.has(y));if($)throw new Error(`Scheme '${$}' is not supported. Only http and https are currently supported.`);return this.c.set(E,A),this.b.$registerUriOpener(E,D.schemes,m,D.label),(0,d.$Tc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(m,E,A){const D=this.c.get(m);if(!D)throw new Error(`Unknown opener with id: ${m}`);const $=L.URI.revive(E);return D.canOpenExternalUri($,A)}async $openUri(m,E,A){const D=this.c.get(m);if(!D)throw new Error(`Unknown opener id: '${m}'`);return D.openExternalUri(L.URI.revive(E.resolvedUri),{sourceUri:L.URI.revive(E.sourceUri)},A)}}e.$5mc=M}),define(ke[324],Pe([1,0,6,2,3,13,25]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=void 0;class b{static{this.a=0}constructor(E){this.c=new M.$Rm,this.d=new Map,this.b=E.getProxy(d.$1M.MainThreadUrls)}registerUriHandler(E,A){const D=E.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const $=b.a++;return this.c.add(D),this.d.set($,A),this.b.$registerUriHandler($,D,E.displayName||E.name),(0,L.$Tc)(()=>{this.c.delete(D),this.d.delete($),this.b.$unregisterUriHandler($)})}$handleExternalUri(E,A){const D=this.d.get(E);if(!D)return Promise.resolve(void 0);try{D.handleUri(N.URI.revive(A))}catch($){(0,R.$1)($)}return Promise.resolve(void 0)}async createAppUri(E){return N.URI.revive(await this.b.$createAppUri(E))}}e.$6mc=b}),define(ke[92],Pe([1,0,4,3,15,24,2,252,290,114,6]),function(le,e,d,N,L,R,M,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=e.$ulc=void 0,e.$vlc=$,e.$xlc=h,e.$ylc=g;class D{#e;#t;#n;#i;#s;#r;#a;#o;#c;#u;#l;#d;constructor(u,o,t,l,r,c,s){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new d.$ee,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new d.$ee,this._onDidDispose=this.#h.event,this.#e=u,this.#t=o,this.#o=t,this.#i=l,this.#s=r,this.#r=c,this.#l=$(c),this.#d=y(c),this.#n=s}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return this.#u=!0,(0,E.$4yb)(u,this.#i)}get cspSource(){const u=this.#r.extensionLocation;if(u.scheme===L.Schemas.https||u.scheme===L.Schemas.http){let o=u.toString();return o.endsWith("/")||(o+="/"),o+" "+E.$3yb}return E.$3yb}get html(){return this.a(),this.#a}set html(u){this.a(),this.#a!==u&&(this.#a=u,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(this.#u=!0,this.#n.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(u)))}get options(){return this.a(),this.#o}set options(u){this.a(),R.$6n(this.#o,u)||this.#t.$setOptions(this.#e,g(this.#r,this.#s,u)),this.#o=u}async postMessage(u){if(this.#c)return!1;const o=(0,m.$Cpb)(u,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,o.message,...o.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(u){if(!this.#d)return u;const o=this.#r.extensionLocation?.scheme===L.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return u.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,r,c,s,v,f)=>{const S=M.URI.from({scheme:s||"file",path:decodeURIComponent(v)}),p=(0,E.$4yb)(S,{isRemote:o,authority:t}).toString();return`${r}${p}${f}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,r,c,s,v,f)=>{const S=M.URI.from({scheme:s||"file",path:decodeURIComponent(v)}),p=(0,E.$4yb)(S,{isRemote:o,authority:t}).toString();return`${r}${p}${f}`})}}e.$ulc=D;function $(i){try{const u=(0,b.$Hp)((0,b.$Gp)(i.engines.vscode));return!!u&&u.majorBase>=1&&u.minorBase>=57}catch{return!1}}function y(i){try{const u=(0,b.$Hp)((0,b.$Gp)(i.engines.vscode));return u?u.majorBase<1||u.majorBase===1&&u.minorBase<60:!1}catch{return!1}}class w extends N.$Vc{constructor(u,o,t,l,r){super(),this.c=o,this.f=t,this.g=l,this.h=r,this.b=new Map,this.a=u.getProxy(A.$1M.MainThreadWebviews)}dispose(){super.dispose();for(const u of this.b.values())u.dispose();this.b.clear()}$onMessage(u,o,t){const l=this.j(u);if(l){const{message:r}=(0,m.$Dpb)(o,t.value);l._onMessageEmitter.fire(r)}}$onMissingCsp(u,o){this.g.warn(`${o} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,o,t){const l=new D(u,this.a,a(o),this.c,this.f,t,this.h);this.b.set(u,l);const r=l._onDidDispose(()=>{r.dispose(),this.deleteWebview(u)});return l}deleteWebview(u){this.b.delete(u)}j(u){return this.b.get(u)}}e.$wlc=w;function h(i){return{id:i.identifier,location:i.extensionLocation}}function g(i,u,o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots||n(i,u)}}function a(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(u=>M.URI.from(u))}}function n(i,u){return[...(u?.getWorkspaceFolders()||[]).map(o=>o.uri),i.extensionLocation]}}),define(ke[151],Pe([1,0,4,15,14,2,5,20,6]),function(le,e,d,N,L,R,M,b,m){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$9mc=e.$8mc=void 0;let A=class{static{E=this}static{this.a={focused:!0,active:!0}}getState(){const $=this.d;return{get focused(){return $.focused},get active(){return $.active}}}constructor($){this.c=new d.$ee,this.onDidChangeWindowState=this.c.event,this.d=E.a,this.b=$.getProxy(m.$1M.MainThreadWindow),this.b.$getInitialState().then(({isFocused:y,isActive:w})=>{this.onDidChangeWindowProperty("focused",y),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus($){this.onDidChangeWindowProperty("focused",$)}$onDidChangeWindowActive($){this.onDidChangeWindowProperty("active",$)}onDidChangeWindowProperty($,y){y!==this.d[$]&&(this.d={...this.d,[$]:y},this.c.fire(this.d))}openUri($,y){let w;if(typeof $=="string"){w=$;try{$=R.URI.parse($)}catch{return Promise.reject(`Invalid uri - '${$}'`)}}return(0,L.$7e)($.scheme)?Promise.reject("Invalid scheme - cannot be empty"):$.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${$.scheme}'`):this.b.$openUri($,w,y)}async asExternalUri($,y){if((0,L.$7e)($.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri($,y);return R.URI.from(w)}};e.$8mc=A,e.$8mc=A=E=Je([Ve(0,b.$oP)],A),e.$9mc=(0,M.$vi)("IExtHostWindow")}),define(ke[325],Pe([1,0,317,28,20]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Knc=void 0;const R=1024*1024;let M=class extends d.$_mc{constructor(m,E){super(m,E),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(m,E,A){const D=m==="error"||m==="warn"?process.stderr:process.stdout;this.g=!0,D.write(`
START_NATIVE_LOG
`),E.apply(console,A),D.write(`
END_NATIVE_LOG
`),this.g=!1}j(m,E){const A=process[m],D=A.write;let $="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(y,w,h)=>{if(!this.g){$+=y.toString(w);const g=$.length>R?$.length:$.lastIndexOf(`
`);g!==-1&&(console[E]($.slice(0,g)),$=$.slice(g+1))}D.call(A,y,w,h)}})}};e.$Knc=M,e.$Knc=M=Je([Ve(0,L.$oP),Ve(1,N.$EP)],M)}),define(ke[326],Pe([1,0,150,15,267,30]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=void 0;class M extends d.$$mc{s(m,E,A){return m.scheme===N.Schemas.file?new L.$BQ(A?.name||(0,R.$Rg)(),m.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,E):super.s(m,E,A)}registerLogger(m){super.registerLogger(m),this.r.$registerLogger(m)}deregisterLogger(m){super.deregisterLogger(m),this.r.$deregisterLogger(m)}}e.$Wnc=M}),define(ke[327],Pe([1,0,7,21,22,13,4,3,134,315,48]),function(le,e,d,N,L,R,M,b,m,E,A){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$K_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$I_b=g,e.$J_b=a;function $(P,C){try{return JSON.stringify(P,C)}catch{return"null"}}const y="$$ref$$",w={[y]:-1};class h{constructor(C,I){this.jsonString=C,this.referencedBuffers=I}}function g(P,C=null,I=!1){const T=[];return{jsonString:(I?$:JSON.stringify)(P,(z,O)=>{if(typeof O>"u")return w;if(typeof O=="object"){if(O instanceof N.$Fe){const F=T.push(O)-1;return{[y]:F}}if(C)return C(z,O)}return O}),referencedBuffers:T}}function a(P,C,I){return JSON.parse(P,(T,j)=>{if(j){const z=j[y];if(typeof z=="number")return C[z];if(I&&j.$mid===1)return I.transformIncoming(j)}return j})}function n(P,C){return JSON.stringify(P,C)}function i(P){return P?(C,I)=>I&&I.$mid===1?P.transformOutgoing(I):I:null}var u;(function(P){P[P.LocalSide=0]="LocalSide",P[P.OtherSide=1]="OtherSide"})(u||(e.RequestInitiator=u={}));var o;(function(P){P[P.Responsive=0]="Responsive",P[P.Unresponsive=1]="Unresponsive"})(o||(e.ResponsiveState=o={}));const t=()=>{},l=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class c extends b.$Vc{static{D=l}static{this.a=3*1e3}constructor(C,I=null,T=null){super(),this[D]=!0,this.b=this.B(new M.$ee),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=I,this.g=T,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,z=A.$rw.count;j<z;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new d.$Hh(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const I=this.w[C];delete this.w[C],I.resolveErr(R.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+c.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+c.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,m.$An)(C,this.g):C}getProxy(C){const{nid:I,sid:T}=C;return this.s[I]||(this.s[I]=this.J(I,T)),this.s[I]}J(C,I){const T={get:(j,z)=>(typeof z=="string"&&!j[z]&&z.charCodeAt(0)===36&&(j[z]=(...O)=>this.U(C,z,O)),z===r?I:j[z])};return new Proxy(Object.create(null),T)}set(C,I){return this.m[C.nid]=I,I}assertRegistered(C){for(let I=0,T=C.length;I<T;I++){const j=C[I];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(C){if(this.j)return;const I=C.byteLength,T=v.read(C,0),j=T.readUInt8(),z=T.readUInt32();switch(j){case 1:case 2:{let{rpcId:O,method:F,args:B}=S.deserializeRequestJSONArgs(T);this.g&&(B=(0,m.$An)(B,this.g)),this.M(I,z,O,F,B,j===2);break}case 3:case 4:{let{rpcId:O,method:F,args:B}=S.deserializeRequestMixedArgs(T);this.g&&(B=(0,m.$An)(B,this.g)),this.M(I,z,O,F,B,j===4);break}case 5:{this.f?.logIncoming(I,z,0,"ack"),this.G(z);break}case 6:{this.N(I,z);break}case 7:{this.O(I,z,void 0);break}case 9:{let O=S.deserializeReplyOKJSON(T);this.g&&(O=(0,m.$An)(O,this.g)),this.O(I,z,O);break}case 10:{const O=S.deserializeReplyOKJSONWithBuffers(T,this.g);this.O(I,z,O);break}case 8:{const O=S.deserializeReplyOKVSBuffer(T);this.O(I,z,O);break}case 11:{let O=S.deserializeReplyErrError(T);this.g&&(O=(0,m.$An)(O,this.g)),this.P(I,z,O);break}case 12:{this.P(I,z,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,I,T,j,z,O){this.f?.logIncoming(C,I,1,`receiveRequest ${(0,A.$tw)(T)}.${j}(`,z);const F=String(I);let B,Z;if(O){const Q=new L.$pe;z.push(Q.token),B=this.Q(T,j,z),Z=()=>Q.cancel()}else B=this.Q(T,j,z),Z=t;this.u[F]=Z;const q=S.serializeAcknowledged(I);this.f?.logOutgoing(q.byteLength,I,1,"ack"),this.c.send(q),B.then(Q=>{delete this.u[F];const x=S.serializeReplyOK(I,Q,this.h);this.f?.logOutgoing(x.byteLength,I,1,"reply:",Q),this.c.send(x)},Q=>{delete this.u[F];const x=S.serializeReplyErr(I,Q);this.f?.logOutgoing(x.byteLength,I,1,"replyErr:",Q),this.c.send(x)})}N(C,I){this.f?.logIncoming(C,I,1,"receiveCancel");const T=String(I);this.u[T]?.()}O(C,I,T){this.f?.logIncoming(C,I,0,"receiveReply:",T);const j=String(I);if(!this.w.hasOwnProperty(j))return;const z=this.w[j];delete this.w[j],z.resolveOk(T)}P(C,I,T){this.f?.logIncoming(C,I,0,"receiveReplyErr:",T);const j=String(I);if(!this.w.hasOwnProperty(j))return;const z=this.w[j];delete this.w[j];let O;T&&(T.$isError?(O=new Error,O.name=T.name,O.message=T.message,O.stack=T.stack):O=T),z.resolveErr(O)}Q(C,I,T){try{return Promise.resolve(this.S(C,I,T))}catch(j){return Promise.reject(j)}}S(C,I,T){const j=this.m[C];if(!j)throw new Error("Unknown actor "+(0,A.$tw)(C));const z=j[I];if(typeof z!="function")throw new Error("Unknown method "+I+" on actor "+(0,A.$tw)(C));return z.apply(j,T)}U(C,I,T){if(this.j)return new E.$H_b;let j=null;if(T.length>0&&L.CancellationToken.isCancellationToken(T[T.length-1])&&(j=T.pop()),j&&j.isCancellationRequested)return Promise.reject(R.$6());const z=S.serializeRequestArguments(T,this.h),O=++this.t,F=String(O),B=new E.$G_b,Z=new b.$Uc;j&&Z.add(j.onCancellationRequested(()=>{const Q=S.serializeCancel(O);this.f?.logOutgoing(Q.byteLength,O,0,"cancel"),this.c.send(S.serializeCancel(O))})),this.w[F]=new s(B,Z),this.F(O);const q=S.serializeRequest(O,C,I,z,!!j);return this.f?.logOutgoing(q.byteLength,O,0,`request: ${(0,A.$tw)(C)}.${I}(`,T),this.c.send(q),B}}e.$K_b=c;class s{constructor(C,I){this.a=C,this.b=I}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class v{static alloc(C,I,T){const j=new v(N.$Fe.alloc(T+1+4),0);return j.writeUInt8(C),j.writeUInt32(I),j}static read(C,I){return new v(C,I)}get buffer(){return this.a}constructor(C,I){this.a=C,this.b=I}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const T=this.a.slice(this.b,this.b+C).toString();return this.b+=C,T}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const T=this.a.slice(this.b,this.b+C).toString();return this.b+=C,T}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const I=this.a.slice(this.b,this.b+C);return this.b+=C,I}static sizeMixedArray(C){let I=0;I+=1;for(let T=0,j=C.length;T<j;T++){const z=C[T];switch(I+=1,z.type){case 1:I+=this.sizeLongString(z.value);break;case 2:I+=this.sizeVSBuffer(z.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(z.value);for(let O=0;O<z.buffers.length;++O)I+=this.sizeVSBuffer(z.buffers[O]);break;case 4:break}}return I}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let I=0,T=C.length;I<T;I++){const j=C[I];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let z=0;z<j.buffers.length;++z)this.writeBuffer(j.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const I=new Array(C);for(let T=0;T<C;T++)switch(this.readUInt8()){case 1:I[T]=this.readLongString();break;case 2:I[T]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),O=this.readLongString(),F=[];for(let B=0;B<z;++B)F.push(this.readVSBuffer());I[T]=new A.$uw(a(O,F,null));break}case 4:I[T]=void 0;break}return I}}var f;(function(P){P[P.Simple=0]="Simple",P[P.Mixed=1]="Mixed"})(f||(f={}));class S{static a(C){for(let I=0,T=C.length;I<T;I++)if(C[I]instanceof N.$Fe||C[I]instanceof A.$uw||typeof C[I]>"u")return!0;return!1}static serializeRequestArguments(C,I){if(this.a(C)){const T=[];for(let j=0,z=C.length;j<z;j++){const O=C[j];if(O instanceof N.$Fe)T[j]={type:2,value:O};else if(typeof O>"u")T[j]={type:4};else if(O instanceof A.$uw){const{jsonString:F,referencedBuffers:B}=g(O.value,I);T[j]={type:3,value:N.$Fe.fromString(F),buffers:B}}else T[j]={type:1,value:N.$Fe.fromString(n(O,I))}}return{type:1,args:T}}return{type:0,args:n(C,I)}}static serializeRequest(C,I,T,j,z){switch(j.type){case 0:return this.b(C,I,T,j.args,z);case 1:return this.c(C,I,T,j.args,z)}}static b(C,I,T,j,z){const O=N.$Fe.fromString(T),F=N.$Fe.fromString(j);let B=0;B+=v.sizeUInt8(),B+=v.sizeShortString(O),B+=v.sizeLongString(F);const Z=v.alloc(z?2:1,C,B);return Z.writeUInt8(I),Z.writeShortString(O),Z.writeLongString(F),Z.buffer}static deserializeRequestJSONArgs(C){const I=C.readUInt8(),T=C.readShortString(),j=C.readLongString();return{rpcId:I,method:T,args:JSON.parse(j)}}static c(C,I,T,j,z){const O=N.$Fe.fromString(T);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(O),F+=v.sizeMixedArray(j);const B=v.alloc(z?4:3,C,F);return B.writeUInt8(I),B.writeShortString(O),B.writeMixedArray(j),B.buffer}static deserializeRequestMixedArgs(C){const I=C.readUInt8(),T=C.readShortString(),j=C.readMixedArray(),z=new Array(j.length);for(let O=0,F=j.length;O<F;O++){const B=j[O];typeof B=="string"?z[O]=JSON.parse(B):z[O]=B}return{rpcId:I,method:T,args:z}}static serializeAcknowledged(C){return v.alloc(5,C,0).buffer}static serializeCancel(C){return v.alloc(6,C,0).buffer}static serializeReplyOK(C,I,T){if(typeof I>"u")return this.d(C);if(I instanceof N.$Fe)return this.e(C,I);if(I instanceof A.$uw){const{jsonString:j,referencedBuffers:z}=g(I.value,T,!0);return this.g(C,j,z)}else return this.f(C,$(I,T))}static d(C){return v.alloc(7,C,0).buffer}static e(C,I){let T=0;T+=v.sizeVSBuffer(I);const j=v.alloc(8,C,T);return j.writeVSBuffer(I),j.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,I){const T=N.$Fe.fromString(I);let j=0;j+=v.sizeLongString(T);const z=v.alloc(9,C,j);return z.writeLongString(T),z.buffer}static g(C,I,T){const j=N.$Fe.fromString(I);let z=0;z+=v.sizeUInt32,z+=v.sizeLongString(j);for(const F of T)z+=v.sizeVSBuffer(F);const O=v.alloc(10,C,z);O.writeUInt32(T.length),O.writeLongString(j);for(const F of T)O.writeBuffer(F);return O.buffer}static deserializeReplyOKJSON(C){const I=C.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(C,I){const T=C.readUInt32(),j=C.readLongString(),z=[];for(let O=0;O<T;++O)z.push(C.readVSBuffer());return new A.$uw(a(j,z,I))}static serializeReplyErr(C,I){const T=I?$(R.$3(I),null):void 0;if(typeof T!="string")return this.h(C);const j=N.$Fe.fromString(T);let z=0;z+=v.sizeLongString(j);const O=v.alloc(11,C,z);return O.writeLongString(j),O.buffer}static deserializeReplyErrError(C){const I=C.readLongString();return JSON.parse(I)}static h(C){return v.alloc(12,C,0).buffer}}var p;(function(P){P[P.RequestJSONArgs=1]="RequestJSONArgs",P[P.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",P[P.RequestMixedArgs=3]="RequestMixedArgs",P[P.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",P[P.Acknowledged=5]="Acknowledged",P[P.Cancel=6]="Cancel",P[P.ReplyOKEmpty=7]="ReplyOKEmpty",P[P.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",P[P.ReplyOKJSON=9]="ReplyOKJSON",P[P.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",P[P.ReplyErrError=11]="ReplyErrError",P[P.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var k;(function(P){P[P.String=1]="String",P[P.VSBuffer=2]="VSBuffer",P[P.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",P[P.Undefined=4]="Undefined"})(k||(k={}))}),define(ke[328],Pe([1,0,21,27,15,85,5]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FK=e.$CK=void 0,e.$DK=A,e.$EK=D,e.$CK=(0,M.$vi)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${b.join("")}]+`),E=7;function A(y){if(y.scheme!==L.Schemas.vscodeNotebookCell)return;const w=y.fragment.indexOf("s");if(w<0)return;const h=parseInt(y.fragment.substring(0,w).replace(m,""),E),g=(0,d.$Ye)(y.fragment.substring(w+1)).toString();if(!isNaN(h))return{handle:h,notebook:y.with({scheme:g,fragment:null})}}function D(y,w){const h=w.toString(E),a=`${h.length<b.length?b[h.length-1]:"z"}${h}s${(0,d.$Ze)(d.$Fe.fromString(y.scheme),!0,!0)}`;return y.with({scheme:L.Schemas.vscodeNotebookCell,fragment:a})}class ${constructor(){this.a=new N.$Bc}getNotebook(w){if(w.scheme===L.Schemas.vscodeNotebookCell){const h=A(w);if(h){const g=this.a.get(h.notebook);if(g)return g}}return this.a.get(w)}addNotebookDocument(w){this.a.set(w.uri,w)}removeNotebookDocument(w){this.a.delete(w.uri)}}e.$FK=$,(0,R.$ws)(e.$CK,$,1)}),define(ke[120],Pe([1,0,21,35,39,101,15,17,12,38,328]),function(le,e,d,N,L,R,M,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZK=e.$WK=e.CellStatusbarAlignment=e.$VK=e.NotebookEditorPriority=e.$SK=e.$RK=e.$PK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$OK=e.$NK=e.$MK=e.$LK=e.CellKind=e.$KK=e.$JK=e.$IK=void 0,e.$QK=l,e.$TK=c,e.$UK=s,e.$XK=S,e.$YK=k,e.$IK="workbench.editor.notebook",e.$JK="workbench.editor.notebookTextDiffEditor",e.$KK="workbench.editor.interactive";var D;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(D||(e.CellKind=D={})),e.$LK=["application/json","application/javascript","text/html","image/svg+xml",R.$Ps.latex,R.$Ps.markdown,"image/png","image/jpeg",R.$Ps.text],e.$MK=[R.$Ps.latex,R.$Ps.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Ps.text],e.$NK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$OK="_notAvailable";var $;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})($||(e.NotebookRunState=$={}));var y;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(y||(e.NotebookCellExecutionState=y={}));var w;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var h;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(h||(e.NotebookRendererMatch=h={}));var g;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var a;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var n;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var u;(function(B){B.scheme=M.Schemas.vscodeNotebookCell;function Z(me,ue){return(0,A.$EK)(me,ue)}B.generate=Z;function q(me){return(0,A.$DK)(me)}B.parse=q;function Q(me,ue){return me.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${ue??""},${me.scheme!==M.Schemas.file?me.scheme:""}`})}B.generateCellOutputUri=Q;function x(me){if(me.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const ue=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(me.fragment);if(!ue)return;const ve=ue[1]&&ue[1]!==""?ue[1]:void 0,te=ue[2];return{outputId:ve,notebook:me.with({scheme:te||M.Schemas.file,fragment:null})}}B.parseCellOutputUri=x;function X(me,ue,ve){return B.generate(me,ue).with({scheme:ve})}B.generateCellPropertyUri=X;function ie(me,ue){if(me.scheme===ue)return B.parse(me.with({scheme:B.scheme}))}B.parseCellPropertyUri=ie})(u||(e.CellUri=u={}));const o=B=>m.$i?B.replace(/\//g,"\\"):B;class t{constructor(Z=[],q=e.$LK){this.e=q,this.d=[...new Set(Z)].map(Q=>({pattern:Q,matches:N.$pk(o(Q))}))}sort(Z){const q=new Map(L.Iterable.map(Z,x=>[x,o(x)]));let Q=[];for(const{matches:x}of this.d)for(const[X,ie]of q)if(x(ie)){Q.push(X),q.delete(X);break}return q.size&&(Q=Q.concat([...q.keys()].sort((x,X)=>this.e.indexOf(x)-this.e.indexOf(X)))),Q}prioritize(Z,q){const Q=this.f(Z);if(Q===-1){this.d.unshift({pattern:Z,matches:N.$pk(o(Z))});return}const x=new Set(q.map(ie=>this.f(ie,Q)));x.delete(-1);const X=Array.from(x).sort();this.d.splice(Q+1,0,...X.map(ie=>this.d[ie]));for(let ie=X.length-1;ie>=0;ie--)this.d.splice(X[ie],1)}toArray(){return this.d.map(Z=>Z.pattern)}f(Z,q=this.d.length){const Q=o(Z);for(let x=0;x<q;x++)if(this.d[x].matches(Q))return x;return-1}}e.$PK=t;function l(B,Z,q,Q=(x,X)=>x===X){const x=[];function X(ue,ve,te){if(ve===0&&te.length===0)return;const U=x[x.length-1];U&&U.start+U.deleteCount===ue?(U.deleteCount+=ve,U.toInsert.push(...te)):x.push({start:ue,deleteCount:ve,toInsert:te})}let ie=0,me=0;for(;;){if(ie===B.length){X(ie,0,Z.slice(me));break}if(me===Z.length){X(ie,B.length-ie,[]);break}const ue=B[ie],ve=Z[me];if(Q(ue,ve)){ie+=1,me+=1;continue}q(ve)?(X(ie,1,[]),ie+=1):(X(ie,0,[ve]),me+=1)}return x}e.$RK=new E.$Mj("notebookEditorCursorAtBoundary","none"),e.$SK=new E.$Mj("notebookEditorCursorAtLineBoundary","none");var r;(function(B){B.default="default",B.option="option"})(r||(e.NotebookEditorPriority=r={}));function c(B){const Z=B;return!!((typeof Z.include=="string"||N.$qk(Z.include))&&(typeof Z.exclude=="string"||N.$qk(Z.exclude)))}function s(B,Z,q){if(Array.isArray(B.viewType)&&B.viewType.indexOf(Z)>=0||B.viewType===Z)return!0;if(B.filenamePattern){const Q=c(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,x=c(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(N.$ok(Q,(0,b.$oc)(q.fsPath).toLowerCase()))return!(x&&N.$ok(x,(0,b.$oc)(q.fsPath).toLowerCase()))}return!1}e.$VK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var v;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(v||(e.CellStatusbarAlignment=v={}));class f{static{this.d="notebook/"}static create(Z){return`${f.d}${Z}`}static parse(Z){if(Z.startsWith(f.d))return Z.substring(f.d.length)}}e.$WK=f;function S(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const p=new TextDecoder;function k(B){const Z=[];let q=!1;for(const ie of B)(Z.length===0||q)&&(Z.push(ie),q=!0);let Q=I(Z);const x=d.$Fe.concat(Z.map(ie=>d.$Fe.wrap(ie))),X=F(x);return Q=Q||X.byteLength!==x.byteLength,{data:X,didCompression:Q}}e.$ZK="\x1B[A";const P=e.$ZK.split("").map(B=>B.charCodeAt(0)),C=10;function I(B){let Z=!1;return B.forEach((q,Q)=>{if(Q===0||q.length<e.$ZK.length)return;const x=B[Q-1],X=q.subarray(0,e.$ZK.length);if(X[0]===P[0]&&X[1]===P[1]&&X[2]===P[2]){const ie=x.lastIndexOf(C);if(ie===-1)return;Z=!0,B[Q-1]=x.subarray(0,ie),B[Q]=q.subarray(e.$ZK.length)}}),Z}function T(B){let Z=B;do B=Z,Z=B.replace(/[^\n]\x08/gm,"");while(Z.length<B.length);return B}function j(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const Z=B.match(/^(.*)\r+/m)[1];let q=B.match(/\r+(.*)$/m)[1];q=q+Z.slice(q.length,Z.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,q)}return B}const z=8,O=13;function F(B){return!B.buffer.includes(z)&&!B.buffer.includes(O)?B:d.$Fe.fromString(j(T(p.decode(B.buffer))))}}),define(ke[8],Pe([1,0,19,13,81,27,101,14,18,2,30,25,33,67,120]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w){"use strict";var h,g,a,n,i,u,o,t,l,r,c,s,v,f,S,p,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$cP=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$bP=e.$aP=e.$_O=e.$$O=e.ChatLocation=e.$0O=e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$YO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$LO=e.$KO=e.$JO=e.$IO=e.$GO=e.$FO=e.$EO=e.$DO=e.TestRunProfileKind=e.TestResultState=e.$CO=e.$BO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$AO=e.NotebookVariablesRequestKind=e.$zO=e.$yO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$xO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.ColorThemeKind=e.$rO=e.$qO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$pO=e.$oO=e.DebugConsoleMode=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$iO=e.$hO=e.FileChangeType=e.$gO=e.NewSymbolNameTag=e.$fO=e.$eO=e.$dO=e.$cO=e.InlineCompletionTriggerKind=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$2N=e.ConfigurationTarget=e.$1N=e.$ZN=e.$YN=e.$XN=e.DocumentPasteTriggerKind=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$QN=e.ViewBadge=e.ProgressLocation=e.$PN=e.$ON=e.TaskScope=e.ShellQuoting=e.$NN=e.$MN=e.$LN=e.TaskPanelKind=e.TaskRevealKind=e.$KN=e.TerminalLocation=e.$JN=e.$IN=e.$HN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$GN=e.$FN=e.$EN=e.$DN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$BN=e.$AN=e.$zN=e.$yN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$xN=e.$wN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.LanguageStatusSeverity=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.CodeActionTriggerKind=e.$kN=e.$jN=e.SymbolTag=e.SymbolKind=e.$iN=e.$hN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.DiagnosticSeverity=e.DiagnosticTag=e.$bN=e.$aN=e.FileEditType=e.$_M=e.$$M=e.$0M=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$CN=Ot,e.$3N=He,e.$HO=wi;function P(G){return Object.assign(G,{apply:function(...ge){if(ge.length===0)return Reflect.construct(G,[]);{const Oe=ge.length===1?[]:ge[1];return Reflect.construct(G,Oe,ge[0].constructor)}},call:function(...ge){if(ge.length===0)return Reflect.construct(G,[]);{const[Oe,...Xe]=ge;return Reflect.construct(G,Xe,Oe.constructor)}}})}var C;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var I;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(I||(e.TerminalQuickFixType=I={}));let T=h=class{static from(...H){let ge=H;return new h(function(){if(ge){for(const Oe of ge)Oe&&typeof Oe.dispose=="function"&&Oe.dispose();ge=void 0}})}#e;constructor(H){this.#e=H}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$3M=T,e.$3M=T=h=Je([P],T);let j=g=class{static Min(...H){if(H.length===0)throw new TypeError;let ge=H[0];for(let Oe=1;Oe<H.length;Oe++){const Xe=H[Oe];Xe.isBefore(ge)&&(ge=Xe)}return ge}static Max(...H){if(H.length===0)throw new TypeError;let ge=H[0];for(let Oe=1;Oe<H.length;Oe++){const Xe=H[Oe];Xe.isAfter(ge)&&(ge=Xe)}return ge}static isPosition(H){if(!H)return!1;if(H instanceof g)return!0;const{line:ge,character:Oe}=H;return typeof ge=="number"&&typeof Oe=="number"}static of(H){if(H instanceof g)return H;if(this.isPosition(H))return new g(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,ge){if(H<0)throw(0,N.$7)("line must be non-negative");if(ge<0)throw(0,N.$7)("character must be non-negative");this.c=H,this.e=ge}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,ge=0){if(H===null||ge===null)throw(0,N.$7)();let Oe;return typeof H>"u"?Oe=0:typeof H=="number"?Oe=H:(Oe=typeof H.lineDelta=="number"?H.lineDelta:0,ge=typeof H.characterDelta=="number"?H.characterDelta:0),Oe===0&&ge===0?this:new g(this.line+Oe,this.character+ge)}with(H,ge=this.character){if(H===null||ge===null)throw(0,N.$7)();let Oe;return typeof H>"u"?Oe=this.line:typeof H=="number"?Oe=H:(Oe=typeof H.line=="number"?H.line:this.line,ge=typeof H.character=="number"?H.character:this.character),Oe===this.line&&ge===this.character?this:new g(Oe,ge)}toJSON(){return{line:this.line,character:this.character}}};e.$4M=j,e.$4M=j=g=Je([P],j);let z=a=class{static isRange(H){return H instanceof a?!0:H?j.isPosition(H.start)&&j.isPosition(H.end):!1}static of(H){if(H instanceof a)return H;if(this.isRange(H))return new a(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,ge,Oe,Xe){let rt,ft;if(typeof H=="number"&&typeof ge=="number"&&typeof Oe=="number"&&typeof Xe=="number"?(rt=new j(H,ge),ft=new j(Oe,Xe)):j.isPosition(H)&&j.isPosition(ge)&&(rt=j.of(H),ft=j.of(ge)),!rt||!ft)throw new Error("Invalid arguments");rt.isBefore(ft)?(this.c=rt,this.e=ft):(this.c=ft,this.e=rt)}contains(H){return a.isRange(H)?this.contains(H.start)&&this.contains(H.end):j.isPosition(H)?!(j.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const ge=j.Max(H.start,this.c),Oe=j.Min(H.end,this.e);if(!ge.isAfter(Oe))return new a(ge,Oe)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const ge=j.Min(H.start,this.c),Oe=j.Max(H.end,this.end);return new a(ge,Oe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,ge=this.end){if(H===null||ge===null)throw(0,N.$7)();let Oe;return H?j.isPosition(H)?Oe=H:(Oe=H.start||this.start,ge=H.end||this.end):Oe=this.start,Oe.isEqual(this.c)&&ge.isEqual(this.end)?this:new a(Oe,ge)}toJSON(){return[this.start,this.end]}};e.$5M=z,e.$5M=z=a=Je([P],z);let O=n=class extends z{static isSelection(H){return H instanceof n?!0:H?z.isRange(H)&&j.isPosition(H.anchor)&&j.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,ge,Oe,Xe){let rt,ft;if(typeof H=="number"&&typeof ge=="number"&&typeof Oe=="number"&&typeof Xe=="number"?(rt=new j(H,ge),ft=new j(Oe,Xe)):j.isPosition(H)&&j.isPosition(ge)&&(rt=j.of(H),ft=j.of(ge)),!rt||!ft)throw new Error("Invalid arguments");super(rt,ft),this.f=rt,this.g=ft}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$6M=O,e.$6M=O=n=Je([P],O);const F=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,N.$7)("connectionToken")};class B{static isResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.host=="string"&&typeof H.port=="number"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,ge,Oe){if(typeof H!="string"||H.length===0)throw(0,N.$7)("host");if(typeof ge!="number"||ge===0||Math.round(ge)!==ge)throw(0,N.$7)("port");typeof Oe<"u"&&F(Oe),this.host=H,this.port=Math.round(ge),this.connectionToken=Oe}}e.$7M=B;class Z{static isManagedResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.makeConnection=="function"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,ge){this.makeConnection=H,this.connectionToken=ge,typeof ge<"u"&&F(ge)}}e.$8M=Z;class q extends Error{static NotAvailable(H,ge){return new q(H,y.RemoteAuthorityResolverErrorCode.NotAvailable,ge)}static TemporarilyNotAvailable(H){return new q(H,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,ge=y.RemoteAuthorityResolverErrorCode.Unknown,Oe){super(H),this._message=H,this._code=ge,this._detail=Oe,Object.setPrototypeOf(this,q.prototype)}}e.$9M=q;var Q;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(Q||(e.EndOfLine=Q={}));var x;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(x||(e.EnvironmentVariableMutatorType=x={}));let X=i=class{static isTextEdit(H){return H instanceof i?!0:H?z.isRange(H)&&typeof H.newText=="string":!1}static replace(H,ge){return new i(H,ge)}static insert(H,ge){return i.replace(new z(H,H),ge)}static delete(H){return i.replace(H,"")}static setEndOfLine(H){const ge=new i(new z(new j(0,0),new j(0,0)),"");return ge.newEol=H,ge}get range(){return this.c}set range(H){if(H&&!z.isRange(H))throw(0,N.$7)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,N.$7)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,N.$7)("newEol");this.f=H}constructor(H,ge){this.c=H,this.e=ge}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$0M=X,e.$0M=X=i=Je([P],X);let ie=u=class{static isNotebookCellEdit(H){return H instanceof u?!0:H?fn.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,ge){return new u(H,ge)}static insertCells(H,ge){return new u(new fn(H,H),ge)}static deleteCells(H){return new u(H,[])}static updateCellMetadata(H,ge){const Oe=new u(new fn(H,H),[]);return Oe.newCellMetadata=ge,Oe}static updateNotebookMetadata(H){const ge=new u(new fn(0,0),[]);return ge.newNotebookMetadata=H,ge}constructor(H,ge){this.range=H,this.newCells=ge}};e.$$M=ie,e.$$M=ie=u=Je([P],ie);class me{static isSnippetTextEdit(H){return H instanceof me?!0:H?z.isRange(H.range)&&te.isSnippetString(H.snippet):!1}static replace(H,ge){return new me(H,ge)}static insert(H,ge){return me.replace(new z(H,H),ge)}constructor(H,ge){this.range=H,this.snippet=ge}}e.$_M=me;var ue;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(ue||(e.FileEditType=ue={}));let ve=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,ge,Oe,Xe){this.c.push({_type:1,from:H,to:ge,options:Oe,metadata:Xe})}createFile(H,ge,Oe){this.c.push({_type:1,from:void 0,to:H,options:ge,metadata:Oe})}deleteFile(H,ge,Oe){this.c.push({_type:1,from:H,to:void 0,options:ge,metadata:Oe})}e(H,ge,Oe){this.c.push({_type:3,metadata:Oe,uri:H,edit:{editType:5,metadata:ge},notebookMetadata:ge})}f(H,ge,Oe,Xe){const rt=ge.start,ft=ge.end;(rt!==ft||Oe.length>0)&&this.c.push({_type:5,uri:H,index:rt,count:ft-rt,cells:Oe,metadata:Xe})}g(H,ge,Oe,Xe){this.c.push({_type:3,metadata:Xe,uri:H,edit:{editType:3,index:ge,metadata:Oe}})}replace(H,ge,Oe,Xe){this.c.push({_type:2,uri:H,edit:new X(ge,Oe),metadata:Xe})}insert(H,ge,Oe,Xe){this.replace(H,new z(ge,ge),Oe,Xe)}delete(H,ge,Oe){this.replace(H,ge,"",Oe)}has(H){return this.c.some(ge=>ge._type===2&&ge.uri.toString()===H.toString())}set(H,ge){if(ge)for(const Oe of ge){if(!Oe)continue;let Xe,rt;Array.isArray(Oe)?(Xe=Oe[0],rt=Oe[1]):Xe=Oe,ie.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.g(H,Xe.range.start,Xe.newCellMetadata,rt):Xe.newNotebookMetadata?this.e(H,Xe.newNotebookMetadata,rt):this.f(H,Xe.range,Xe.newCells,rt):me.isSnippetTextEdit(Xe)?this.c.push({_type:6,uri:H,range:Xe.range,edit:Xe.snippet,metadata:rt}):this.c.push({_type:2,uri:H,edit:Xe,metadata:rt})}else{for(let Oe=0;Oe<this.c.length;Oe++){const Xe=this.c[Oe];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===H.toString()&&(this.c[Oe]=void 0);break}}(0,d.$Ib)(this.c)}}get(H){const ge=[];for(const Oe of this.c)Oe._type===2&&Oe.uri.toString()===H.toString()&&ge.push(Oe.edit);return ge}entries(){const H=new R.$Bc;for(const ge of this.c)if(ge._type===2){let Oe=H.get(ge.uri);Oe||(Oe=[ge.uri,[]],H.set(ge.uri,Oe)),Oe[1].push(ge.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$aN=ve,e.$aN=ve=Je([P],ve);let te=o=class{static isSnippetString(H){return H instanceof o?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=o.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,ge=this.e++){if(typeof H=="function"){const Oe=new o;Oe.e=this.e,H(Oe),this.e=Oe.e,H=Oe.value}else H=o.c(H);return this.value+="${",this.value+=ge,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,ge=this.e++){const Oe=H.map(Xe=>Xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ge,this.value+="|",this.value+=Oe,this.value+="|}",this}appendVariable(H,ge){if(typeof ge=="function"){const Oe=new o;Oe.e=this.e,ge(Oe),this.e=Oe.e,ge=Oe.value}else typeof ge=="string"&&(ge=ge.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,ge&&(this.value+=":",this.value+=ge),this.value+="}",this}};e.$bN=te,e.$bN=te=o=Je([P],te);var U;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var ee;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ee||(e.DiagnosticSeverity=ee={}));let pe=t=class{static isLocation(H){return H instanceof t?!0:H?z.isRange(H.range)&&E.URI.isUri(H.uri):!1}constructor(H,ge){if(this.uri=H,ge)if(z.isRange(ge))this.range=z.of(ge);else if(j.isPosition(ge))this.range=new z(ge,ge);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$cN=pe,e.$cN=pe=t=Je([P],pe);let Ce=class{static is(H){return H?typeof H.message=="string"&&H.location&&z.isRange(H.location.range)&&E.URI.isUri(H.location.uri):!1}constructor(H,ge){this.location=H,this.message=ge}static isEqual(H,ge){return H===ge?!0:!H||!ge?!1:H.message===ge.message&&H.location.range.isEqual(ge.location.range)&&H.location.uri.toString()===ge.location.uri.toString()}};e.$dN=Ce,e.$dN=Ce=Je([P],Ce);let se=class{constructor(H,ge,Oe=ee.Error){if(!z.isRange(H))throw new TypeError("range must be set");if(!ge)throw new TypeError("message must be set");this.range=H,this.message=ge,this.severity=Oe}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,ge){return H===ge?!0:!H||!ge?!1:H.message===ge.message&&H.severity===ge.severity&&H.code===ge.code&&H.severity===ge.severity&&H.source===ge.source&&H.range.isEqual(ge.range)&&(0,d.$ub)(H.tags,ge.tags)&&(0,d.$ub)(H.relatedInformation,ge.relatedInformation,Ce.isEqual)}};e.$eN=se,e.$eN=se=Je([P],se);let re=class{constructor(H,ge){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=ge}};e.$fN=re,e.$fN=re=Je([P],re);let oe=class extends re{constructor(H,ge,Oe,Xe){super(H,ge),this.canIncreaseHover=Oe,this.canDecreaseHover=Xe}};e.$gN=oe,e.$gN=oe=Je([P],oe);var K;(function(G){G[G.Increase=0]="Increase",G[G.Decrease=1]="Decrease"})(K||(e.HoverVerbosityAction=K={}));var ne;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(ne||(e.DocumentHighlightKind=ne={}));let $e=class{constructor(H,ge=ne.Text){this.range=H,this.kind=ge}toJSON(){return{range:this.range,kind:ne[this.kind]}}};e.$hN=$e,e.$hN=$e=Je([P],$e);let be=class{constructor(H,ge){this.uri=H,this.highlights=ge}toJSON(){return{uri:this.uri,highlights:this.highlights.map(H=>H.toJSON())}}};e.$iN=be,e.$iN=be=Je([P],be);var Ae;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(Ae||(e.SymbolKind=Ae={}));var fe;(function(G){G[G.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let Se=l=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,ge,Oe,Xe,rt){this.name=H,this.kind=ge,this.containerName=rt,typeof Oe=="string"&&(this.containerName=Oe),Xe instanceof pe?this.location=Xe:Oe instanceof z&&(this.location=new pe(Xe,Oe)),l.validate(this)}toJSON(){return{name:this.name,kind:Ae[this.kind],location:this.location,containerName:this.containerName}}};e.$jN=Se,e.$jN=Se=l=Je([P],Se);let Ie=r=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(r.validate)}constructor(H,ge,Oe,Xe,rt){this.name=H,this.detail=ge,this.kind=Oe,this.range=Xe,this.selectionRange=rt,this.children=[],r.validate(this)}};e.$kN=Ie,e.$kN=Ie=r=Je([P],Ie);var ze;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(ze||(e.CodeActionTriggerKind=ze={}));let V=class{constructor(H,ge){this.title=H,this.kind=ge}};e.$lN=V,e.$lN=V=Je([P],V);let W=class{static{c=this}static{this.c="."}constructor(H){this.value=H}append(H){return new c(this.value?this.value+c.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+c.c)}};e.$mN=W,e.$mN=W=c=Je([P],W),W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorMove=W.Refactor.append("move"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll"),W.Notebook=W.Empty.append("notebook");let J=class{constructor(H,ge){if(this.range=H,this.parent=ge,ge&&!ge.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$nN=J,e.$nN=J=Je([P],J);class Y{constructor(H,ge,Oe,Xe,rt,ft){this.kind=H,this.name=ge,this.detail=Oe,this.uri=Xe,this.range=rt,this.selectionRange=ft}}e.$oN=Y;class he{constructor(H,ge){this.fromRanges=ge,this.from=H}}e.$pN=he;class we{constructor(H,ge){this.fromRanges=ge,this.to=H}}e.$qN=we;var je;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let qe=class{constructor(H,ge){this.range=H,this.command=ge}get isResolved(){return!!this.command}};e.$rN=qe,e.$rN=qe=Je([P],qe);let Ye=s=class{#e;static isMarkdownString(H){return H instanceof s?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,ge=!1){this.#e=new L.$Sk(H,{supportThemeIcons:ge})}get value(){return this.#e.value}set value(H){this.#e.value=H}get isTrusted(){return this.#e.isTrusted}set isTrusted(H){this.#e.isTrusted=H}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(H){this.#e.supportThemeIcons=H}get supportHtml(){return this.#e.supportHtml}set supportHtml(H){this.#e.supportHtml=H}get baseUri(){return this.#e.baseUri}set baseUri(H){this.#e.baseUri=H}appendText(H){return this.#e.appendText(H),this}appendMarkdown(H){return this.#e.appendMarkdown(H),this}appendCodeblock(H,ge){return this.#e.appendCodeblock(ge??"",H),this}};e.$sN=Ye,e.$sN=Ye=s=Je([P],Ye);let st=class{constructor(H,ge){this.label=H,this.documentation=ge}};e.$tN=st,e.$tN=st=Je([P],st);let tt=class{constructor(H,ge){this.label=H,this.documentation=ge,this.parameters=[]}};e.$uN=tt,e.$uN=tt=Je([P],tt);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$vN=nt,e.$vN=nt=Je([P],nt);var ot;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(ot||(e.SignatureHelpTriggerKind=ot={}));var De;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(De||(e.InlayHintKind=De={}));let Be=class{constructor(H){this.value=H}};e.$wN=Be,e.$wN=Be=Je([P],Be);let Ge=class{constructor(H,ge,Oe){this.position=H,this.label=ge,this.kind=Oe}};e.$xN=Ge,e.$xN=Ge=Je([P],Ge);var Ne;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ne||(e.CompletionTriggerKind=Ne={}));var Ze;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Ze||(e.CompletionItemKind=Ze={}));var ae;(function(G){G[G.Deprecated=1]="Deprecated"})(ae||(e.CompletionItemTag=ae={}));let ce=class{constructor(H,ge){this.label=H,this.kind=ge}toJSON(){return{label:this.label,kind:this.kind&&Ze[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$yN=ce,e.$yN=ce=Je([P],ce);let Re=class{constructor(H=[],ge=!1){this.items=H,this.isIncomplete=ge}};e.$zN=Re,e.$zN=Re=Je([P],Re);let Ke=class{constructor(H,ge,Oe){this.insertText=H,this.range=ge,this.command=Oe}};e.$AN=Ke,e.$AN=Ke=Je([P],Ke);let Me=class{constructor(H){this.commands=void 0,this.suppressSuggestions=void 0,this.items=H}};e.$BN=Me,e.$BN=Me=Je([P],Me);var it;(function(G){G[G.Unknown=0]="Unknown",G[G.Word=1]="Word",G[G.Line=2]="Line",G[G.Suggest=3]="Suggest"})(it||(e.PartialAcceptTriggerKind=it={}));var lt;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(lt||(e.ViewColumn=lt={}));var bt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(bt||(e.StatusBarAlignment=bt={}));function Ot(G,H){return`${D.$Qm.toKey(G)}.${H}`}var Rt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(Rt||(e.TextEditorLineNumbersStyle=Rt={}));var sn;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(sn||(e.TextDocumentSaveReason=sn={}));var Zt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Zt||(e.TextEditorRevealType=Zt={}));var Dt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Dt||(e.TextEditorSelectionChangeKind=Dt={}));var Xt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(Xt||(e.TextDocumentChangeReason=Xt={}));var xt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(xt||(e.DecorationRangeBehavior=xt={})),function(G){function H(ge){switch(ge){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=H}(Dt||(e.TextEditorSelectionChangeKind=Dt={}));var et;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(et||(e.SyntaxTokenType=et={})),function(G){function H(ge){switch(ge){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=H}(et||(e.SyntaxTokenType=et={}));let on=class{constructor(H,ge){if(ge&&!E.URI.isUri(ge))throw(0,N.$7)("target");if(!z.isRange(H)||H.isEmpty)throw(0,N.$7)("range");this.range=H,this.target=ge}};e.$DN=on,e.$DN=on=Je([P],on);let qt=class{constructor(H,ge,Oe,Xe){this.red=H,this.green=ge,this.blue=Oe,this.alpha=Xe}};e.$EN=qt,e.$EN=qt=Je([P],qt);let dt=class{constructor(H,ge){if(ge&&!(ge instanceof qt))throw(0,N.$7)("color");if(!z.isRange(H)||H.isEmpty)throw(0,N.$7)("range");this.range=H,this.color=ge}};e.$FN=dt,e.$FN=dt=Je([P],dt);let wt=class{constructor(H){if(!H||typeof H!="string")throw(0,N.$7)("label");this.label=H}};e.$GN=wt,e.$GN=wt=Je([P],wt);var en;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(en||(e.ColorFormat=en={}));var Jt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var Ft;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(Ft||(e.TerminalExitReason=Ft={}));var gt;(function(G){G[G.Low=0]="Low",G[G.Medium=1]="Medium",G[G.High=2]="High"})(gt||(e.TerminalShellExecutionCommandLineConfidence=gt={}));class Bt{constructor(H,ge,Oe){if(this.startIndex=H,this.length=ge,this.tooltip=Oe,typeof H!="number"||H<0)throw(0,N.$7)("startIndex");if(typeof ge!="number"||ge<1)throw(0,N.$7)("length");if(Oe!==void 0&&typeof Oe!="string")throw(0,N.$7)("tooltip")}}e.$HN=Bt;class Ht{constructor(H){this.uri=H}}e.$IN=Ht;class Gt{constructor(H){this.terminalCommand=H}}e.$JN=Gt;var xe;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(xe||(e.TerminalLocation=xe={}));class dn{constructor(H){if(this.options=H,typeof H!="object")throw(0,N.$7)("options")}}e.$KN=dn;var Qt;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Qt||(e.TaskRevealKind=Qt={}));var zt;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(zt||(e.TaskPanelKind=zt={}));let mt=class{static{v=this}static{this.Clean=new v("clean","Clean")}static{this.Build=new v("build","Build")}static{this.Rebuild=new v("rebuild","Rebuild")}static{this.Test=new v("test","Test")}static from(H){switch(H){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}constructor(H,ge){if(this.label=ge,typeof H!="string"||typeof ge!="string")throw(0,N.$7)("name");this.c=H}get id(){return this.c}};e.$LN=mt,e.$LN=mt=v=Je([P],mt);function Ut(G){let H="";for(let ge=0;ge<G.length;ge++)H+=G[ge].replace(/,/g,",,")+",";return H}let It=class{constructor(H,ge,Oe){if(typeof H!="string")throw(0,N.$7)("process");this.e=[],this.c=H,ge!==void 0&&(Array.isArray(ge)?(this.e=ge,this.f=Oe):this.f=ge)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,N.$7)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const ge of this.e)H.push(ge);return Ut(H)}};e.$MN=It,e.$MN=It=Je([P],It);let Tt=class{constructor(H,ge,Oe){if(this.f=[],Array.isArray(ge)){if(!H)throw(0,N.$7)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,N.$7)("command");this.e=H,this.f=ge,this.g=Oe}else{if(typeof H!="string")throw(0,N.$7)("commandLine");this.c=H,this.g=ge}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,N.$7)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,N.$7)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ge of this.f)H.push(typeof ge=="string"?ge:ge.value);return Ut(H)}};e.$NN=Tt,e.$NN=Tt=Je([P],Tt);var tn;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(tn||(e.ShellQuoting=tn={}));var Wt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Wt||(e.TaskScope=Wt={}));class nn{constructor(H){this.c=H}computeId(){return"customExecution"+(0,A.$Rg)()}set callback(H){this.c=H}get callback(){return this.c}}e.$ON=nn;let Mt=class{static{f=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(H,ge,Oe,Xe,rt,ft){this.k=!1,this.l=this.definition=H;let pt;typeof ge=="string"?(this.o=this.name=ge,this.w=this.source=Oe,this.execution=Xe,pt=rt,this.k=!0):ge===Wt.Global||ge===Wt.Workspace?(this.target=ge,this.o=this.name=Oe,this.w=this.source=Xe,this.execution=rt,pt=ft):(this.target=ge,this.o=this.name=Oe,this.w=this.source=Xe,this.execution=rt,pt=ft),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(H){this.j=H}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof It?this.l={type:f.e,id:this.q.computeId()}:this.q instanceof Tt?this.l={type:f.f,id:this.q.computeId()}:this.q instanceof nn?this.l={type:f.c,id:this.q.computeId()}:this.l={type:f.g,id:(0,A.$Rg)()}}get definition(){return this.l}set definition(H){if(H==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=H}get scope(){return this.m}set target(H){this.B(),this.m=H}get name(){return this.o}set name(H){if(typeof H!="string")throw(0,N.$7)("name");this.B(),this.o=H}get execution(){return this.q}set execution(H){H===null&&(H=void 0),this.B(),this.q=H;const ge=this.l.type;(f.g===ge||f.e===ge||f.f===ge||f.c===ge)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(H){if(Array.isArray(H))this.B(),this.r=H,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.B(),this.u=H}get source(){return this.w}set source(H){if(typeof H!="string"||H.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=H}get group(){return this.x}set group(H){H===null&&(H=void 0),this.B(),this.x=H}get detail(){return this.A}set detail(H){H===null&&(H=void 0),this.A=H}get presentationOptions(){return this.y}set presentationOptions(H){H==null&&(H=Object.create(null)),this.B(),this.y=H}get runOptions(){return this.z}set runOptions(H){H==null&&(H=Object.create(null)),this.B(),this.z=H}};e.$PN=Mt,e.$PN=Mt=f=Je([P],Mt);var Lt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Lt||(e.ProgressLocation=Lt={}));var Nt;(function(G){function H(ge){const Oe=ge;return(0,m.$_f)(Oe.value)?Oe.tooltip&&!(0,m.$8f)(Oe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Oe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Oe.value),!1)}G.isViewBadge=H})(Nt||(e.ViewBadge=Nt={}));let Ct=S=class{static isTreeItem(H,ge){const Oe=H;if(Oe.checkboxState!==void 0){const Xe=(0,m.$_f)(Oe.checkboxState)?Oe.checkboxState:(0,m.$0f)(Oe.checkboxState)&&(0,m.$_f)(Oe.checkboxState.state)?Oe.checkboxState.state:void 0,rt=!(0,m.$_f)(Oe.checkboxState)&&(0,m.$0f)(Oe.checkboxState)?Oe.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==kt.Checked&&Xe!==kt.Unchecked||rt!==void 0&&!(0,m.$8f)(rt))return console.log("INVALID tree item, invalid checkboxState",Oe.checkboxState),!1}if(H instanceof S)return!0;if(Oe.label!==void 0&&!(0,m.$8f)(Oe.label)&&!Oe.label?.label)return console.log("INVALID tree item, invalid label",Oe.label),!1;if(Oe.id!==void 0&&!(0,m.$8f)(Oe.id))return console.log("INVALID tree item, invalid id",Oe.id),!1;if(Oe.iconPath!==void 0&&!(0,m.$8f)(Oe.iconPath)&&!E.URI.isUri(Oe.iconPath)&&(!Oe.iconPath||!(0,m.$8f)(Oe.iconPath.id))){const Xe=Oe.iconPath;if(!Xe||!(0,m.$8f)(Xe.light)&&!E.URI.isUri(Xe.light)&&!(0,m.$8f)(Xe.dark)&&!E.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Oe.iconPath),!1}return Oe.description!==void 0&&!(0,m.$8f)(Oe.description)&&typeof Oe.description!="boolean"?(console.log("INVALID tree item, invalid description",Oe.description),!1):Oe.resourceUri!==void 0&&!E.URI.isUri(Oe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Oe.resourceUri),!1):Oe.tooltip!==void 0&&!(0,m.$8f)(Oe.tooltip)&&!(Oe.tooltip instanceof Ye)?(console.log("INVALID tree item, invalid tooltip",Oe.tooltip),!1):Oe.command!==void 0&&!Oe.command.command?(console.log("INVALID tree item, invalid command",Oe.command),!1):Oe.collapsibleState!==void 0&&Oe.collapsibleState<$t.None&&Oe.collapsibleState>$t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Oe.collapsibleState),!1):Oe.contextValue!==void 0&&!(0,m.$8f)(Oe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Oe.contextValue),!1):Oe.accessibilityInformation!==void 0&&!Oe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Oe.accessibilityInformation),!1):!0}constructor(H,ge=$t.None){this.collapsibleState=ge,E.URI.isUri(H)?this.resourceUri=H:this.label=H}};e.$QN=Ct,e.$QN=Ct=S=Je([P],Ct);var $t;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})($t||(e.TreeItemCollapsibleState=$t={}));var kt;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(kt||(e.TreeItemCheckboxState=kt={}));let rn=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H){this.value=H}};e.$RN=rn,e.$RN=rn=Je([P],rn);class Pt extends rn{}e.$SN=Pt;class mn extends Pt{#e;constructor(H){super(""),this.#e=H}asFile(){return this.#e}}e.$TN=mn;class _t{constructor(H,ge,Oe,Xe){this.name=H,this.uri=ge,this._itemId=Oe,this.c=Xe}data(){return this.c()}}e.$UN=_t;let wn=class{#e=new Map;constructor(H){for(const[ge,Oe]of H??[]){const Xe=this.#e.get(this.#t(ge));Xe?Xe.push(Oe):this.#e.set(this.#t(ge),[Oe])}}get(H){return this.#e.get(this.#t(H))?.[0]}set(H,ge){this.#e.set(this.#t(H),[ge])}forEach(H,ge){for(const[Oe,Xe]of this.#e)for(const rt of Xe)H.call(ge,rt,Oe,this)}*[Symbol.iterator](){for(const[H,ge]of this.#e)for(const Oe of ge)yield[H,Oe]}#t(H){return H.toLowerCase()}};e.$VN=wn,e.$VN=wn=Je([P],wn);let un=class{constructor(H,ge,Oe){this.insertText=H,this.title=ge,this.kind=Oe}};e.$WN=un,e.$WN=un=Je([P],un);var vn;(function(G){G[G.Automatic=0]="Automatic",G[G.PasteAs=1]="PasteAs"})(vn||(e.DocumentPasteTriggerKind=vn={}));class St{static{this.c="."}constructor(H){this.value=H}append(...H){return new St((this.value?[this.value,...H]:H).join(St.c))}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+St.c)}}e.$XN=St,St.Empty=new St("");class Dn{constructor(H,ge,Oe){this.title=ge,this.insertText=H,this.kind=Oe}}e.$YN=Dn;let Le=class{constructor(H,ge){this.id=H,this.color=ge}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};e.$ZN=Le,e.$ZN=Le=Je([P],Le),Le.File=new Le("file"),Le.Folder=new Le("folder");let Te=class{constructor(H){this.id=H}};e.$1N=Te,e.$1N=Te=Je([P],Te);var Ee;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Ee||(e.ConfigurationTarget=Ee={}));let _=class{get base(){return this.c}set base(H){this.c=H,this.e=E.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,ge){if(typeof H!="string"&&(!H||!E.URI.isUri(H)&&!E.URI.isUri(H.uri)))throw(0,N.$7)("base");if(typeof ge!="string")throw(0,N.$7)("pattern");typeof H=="string"?this.baseUri=E.URI.file(H):E.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=ge}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$2N=_,e.$2N=_=Je([P],_);const Fe=new WeakMap;function He(G,H){Fe.set(G,H)}let _e=class{constructor(H,ge,Oe,Xe,rt){this.enabled=typeof H=="boolean"?H:!0,typeof ge=="string"&&(this.condition=ge),typeof Oe=="string"&&(this.hitCondition=Oe),typeof Xe=="string"&&(this.logMessage=Xe),typeof rt=="string"&&(this.mode=rt)}get id(){return this.c||(this.c=Fe.get(this)??(0,A.$Rg)()),this.c}};e.$4N=_e,e.$4N=_e=Je([P],_e);let Qe=class extends _e{constructor(H,ge,Oe,Xe,rt,ft){if(super(ge,Oe,Xe,rt,ft),H===null)throw(0,N.$7)("location");this.location=H}};e.$5N=Qe,e.$5N=Qe=Je([P],Qe);let ht=class extends _e{constructor(H,ge,Oe,Xe,rt,ft){super(ge,Oe,Xe,rt,ft),this.functionName=H}};e.$6N=ht,e.$6N=ht=Je([P],ht);let Et=class extends _e{constructor(H,ge,Oe,Xe,rt,ft,pt,Kt){if(super(Xe,rt,ft,pt,Kt),!ge)throw(0,N.$7)("dataId");this.label=H,this.dataId=ge,this.canPersist=Oe}};e.$7N=Et,e.$7N=Et=Je([P],Et);let jt=class{constructor(H,ge,Oe){this.command=H,this.args=ge||[],this.options=Oe}};e.$8N=jt,e.$8N=jt=Je([P],jt);let Vt=class{constructor(H,ge){this.port=H,this.host=ge}};e.$9N=Vt,e.$9N=Vt=Je([P],Vt);let ut=class{constructor(H){this.path=H}};e.$0N=ut,e.$0N=ut=Je([P],ut);let Yt=class{constructor(H){this.implementation=H}};e.$$N=Yt,e.$$N=Yt=Je([P],Yt);class $n{constructor(H,ge,Oe){this.session=H,this.threadId=ge,this.frameId=Oe}}e.$_N=$n;class kn{constructor(H,ge){this.session=H,this.threadId=ge}}e.$aO=kn;let Cn=class{constructor(H,ge){this.range=H,this.expression=ge}};e.$bO=Cn,e.$bO=Cn=Je([P],Cn);var Gn;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Gn||(e.InlineCompletionTriggerKind=Gn={}));let On=class{constructor(H,ge){this.range=H,this.text=ge}};e.$cO=On,e.$cO=On=Je([P],On);let Fn=class{constructor(H,ge,Oe=!0){this.range=H,this.variableName=ge,this.caseSensitiveLookup=Oe}};e.$dO=Fn,e.$dO=Fn=Je([P],Fn);let In=class{constructor(H,ge){this.range=H,this.expression=ge}};e.$eO=In,e.$eO=In=Je([P],In);let Tn=class{constructor(H,ge){this.frameId=H,this.stoppedLocation=ge}};e.$fO=Tn,e.$fO=Tn=Je([P],Tn);var jn;(function(G){G[G.AIGenerated=1]="AIGenerated"})(jn||(e.NewSymbolNameTag=jn={}));class ui{constructor(H,ge){this.newSymbolName=H,this.tags=ge}}e.$gO=ui;var An;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(An||(e.FileChangeType=An={}));let Pn=p=class extends Error{static FileExists(H){return new p(H,$.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(H){return new p(H,$.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(H){return new p(H,$.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(H){return new p(H,$.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(H){return new p(H,$.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(H){return new p(H,$.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}constructor(H,ge=$.FileSystemProviderErrorCode.Unknown,Oe){super(E.URI.isUri(H)?H.toString(!0):H),this.code=Oe?.name??"Unknown",(0,$.$el)(this,ge),Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof Oe=="function"&&Error.captureStackTrace(this,Oe)}};e.$hO=Pn,e.$hO=Pn=p=Je([P],Pn);let zn=class{constructor(H,ge,Oe){this.start=H,this.end=ge,this.kind=Oe}};e.$iO=zn,e.$iO=zn=Je([P],zn);var Kn;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(Kn||(e.FoldingRangeKind=Kn={}));var yn;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(yn||(e.CommentThreadCollapsibleState=yn={}));var Jn;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Jn||(e.CommentMode=Jn={}));var Qn;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Qn||(e.CommentState=Qn={}));var Yn;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(Yn||(e.CommentThreadState=Yn={}));var Rn;(function(G){G[G.Current=0]="Current",G[G.Outdated=1]="Outdated"})(Rn||(e.CommentThreadApplicability=Rn={}));class li{constructor(H,ge=[]){this.tokenTypes=H,this.tokenModifiers=ge}}e.$jO=li;function Zn(G){return typeof G>"u"||(0,m.$9f)(G)}class Bn{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,H){this.m=!0;for(let ge=0,Oe=H.tokenTypes.length;ge<Oe;ge++)this.k.set(H.tokenTypes[ge],ge);for(let ge=0,Oe=H.tokenModifiers.length;ge<Oe;ge++)this.l.set(H.tokenModifiers[ge],ge)}}push(H,ge,Oe,Xe,rt){if(typeof H=="number"&&typeof ge=="number"&&typeof Oe=="number"&&typeof Xe=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this.q(H,ge,Oe,Xe,rt);if(z.isRange(H)&&typeof ge=="string"&&Zn(Oe))return this.o(H,ge,Oe);throw(0,N.$7)()}o(H,ge,Oe){if(!this.m)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ge))throw new Error("`tokenType` is not in the provided legend");const Xe=H.start.line,rt=H.start.character,ft=H.end.character-H.start.character,pt=this.k.get(ge);let Kt=0;if(Oe)for(const cn of Oe){if(!this.l.has(cn))throw new Error("`tokenModifier` is not in the provided legend");const hn=this.l.get(cn);Kt|=1<<hn>>>0}this.q(Xe,rt,ft,pt,Kt)}q(H,ge,Oe,Xe,rt){if(this.f&&(H<this.c||H===this.c&&ge<this.e)){this.f=!1;const Kt=this.g.length/5|0;let cn=0,hn=0;for(let gn=0;gn<Kt;gn++){let bn=this.g[5*gn],qn=this.g[5*gn+1];bn===0?(bn=cn,qn+=hn):bn+=cn,this.g[5*gn]=bn,this.g[5*gn+1]=qn,cn=bn,hn=qn}}let ft=H,pt=ge;this.f&&this.j>0&&(ft-=this.c,ft===0&&(pt-=this.e)),this.g[this.j++]=ft,this.g[this.j++]=pt,this.g[this.j++]=Oe,this.g[this.j++]=Xe,this.g[this.j++]=rt,this.c=H,this.e=ge}static r(H){const ge=[],Oe=H.length/5|0;for(let pt=0;pt<Oe;pt++)ge[pt]=pt;ge.sort((pt,Kt)=>{const cn=H[5*pt],hn=H[5*Kt];if(cn===hn){const gn=H[5*pt+1],bn=H[5*Kt+1];return gn-bn}return cn-hn});const Xe=new Uint32Array(H.length);let rt=0,ft=0;for(let pt=0;pt<Oe;pt++){const Kt=5*ge[pt],cn=H[Kt+0],hn=H[Kt+1],gn=H[Kt+2],bn=H[Kt+3],qn=H[Kt+4],Ni=cn-rt,hr=Ni===0?hn-ft:hn,Hn=5*pt;Xe[Hn+0]=Ni,Xe[Hn+1]=hr,Xe[Hn+2]=gn,Xe[Hn+3]=bn,Xe[Hn+4]=qn,rt=cn,ft=hn}return Xe}build(H){return this.f?new Mn(new Uint32Array(this.g),H):new Mn(Bn.r(this.g),H)}}e.$kO=Bn;class Mn{constructor(H,ge){this.resultId=ge,this.data=H}}e.$lO=Mn;class hi{constructor(H,ge,Oe){this.start=H,this.deleteCount=ge,this.data=Oe}}e.$mO=hi;class di{constructor(H,ge){this.resultId=ge,this.edits=H}}e.$nO=di;var Xn;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Xn||(e.DebugConsoleMode=Xn={}));class fi{constructor(H){this.name=H}}e.$oO=fi;let Sn=class{static{this.Back={iconPath:new Le("arrow-left")}}constructor(){}};e.$pO=Sn,e.$pO=Sn=Je([P],Sn);var Un;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Un||(e.QuickPickItemKind=Un={}));var We;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(We||(e.InputBoxValidationSeverity=We={}));var ln;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(ln||(e.ExtensionKind=ln={}));class xn{static validate(H){if(typeof H.badge=="string"){let ge=(0,b.$Hf)(H.badge,0);if(ge<H.badge.length&&(ge+=(0,b.$Hf)(H.badge,ge)),H.badge.length>ge)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!Le.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,ge,Oe){this.badge=H,this.tooltip=ge,this.color=Oe}}e.$qO=xn;let at=class{constructor(H){this.kind=H}};e.$rO=at,e.$rO=at=Je([P],at);var vt;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(vt||(e.ColorThemeKind=vt={}));class fn{static isNotebookRange(H){return H instanceof fn?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,ge){if(H<0)throw(0,N.$7)("start must be positive");if(ge<0)throw(0,N.$7)("end must be positive");H<=ge?(this.c=H,this.e=ge):(this.c=ge,this.e=H)}with(H){let ge=this.c,Oe=this.e;return H.start!==void 0&&(ge=H.start),H.end!==void 0&&(Oe=H.end),ge===this.c&&Oe===this.e?this:new fn(ge,Oe)}}e.$sO=fn;class Ln{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(ge=>Ln.isNotebookCellData(ge))}static isNotebookCellData(H){return!0}constructor(H,ge,Oe,Xe,rt,ft,pt){this.kind=H,this.value=ge,this.languageId=Oe,this.mime=Xe,this.outputs=rt??[],this.metadata=ft,this.executionSummary=pt,Ln.validate(this)}}e.$tO=Ln;class _n{constructor(H){this.cells=H}}e.$uO=_n;class an{static isNotebookCellOutputItem(H){return H instanceof an?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const ge={name:H.name,message:H.message,stack:H.stack};return an.json(ge,"application/vnd.code.notebook.error")}static stdout(H){return an.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return an.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,ge="application/octet-stream"){return new an(H,ge)}static#e=new TextEncoder;static text(H,ge=M.$Ps.text){const Oe=an.#e.encode(String(H));return new an(Oe,ge)}static json(H,ge="text/x-json"){const Oe=JSON.stringify(H,void 0,"	");return an.text(Oe,ge)}constructor(H,ge){this.data=H,this.mime=ge;const Oe=(0,M.$Ts)(ge,!0);if(!Oe)throw new Error(`INVALID mime type: ${ge}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Oe}}e.$vO=an;class pn{static isNotebookCellOutput(H){return H instanceof pn?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,ge=!1){const Oe=new Set,Xe=new Set;for(let rt=0;rt<H.length;rt++){const ft=H[rt],pt=(0,M.$Ts)(ft.mime);if(!Oe.has(pt)||(0,w.$XK)(pt)){Oe.add(pt);continue}Xe.add(rt),ge&&console.warn(`DUPLICATED mime type '${ft.mime}' will be dropped`)}return Xe.size===0?H:H.filter((rt,ft)=>!Xe.has(ft))}constructor(H,ge,Oe){this.items=pn.ensureUniqueMimeTypes(H,!0),typeof ge=="string"?(this.id=ge,this.metadata=Oe):(this.id=(0,A.$Rg)(),this.metadata=ge??Oe)}}e.$wO=pn;var ei;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(ei||(e.NotebookCellKind=ei={}));var ti;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(ti||(e.NotebookCellExecutionState=ti={}));var ni;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(ni||(e.NotebookCellStatusBarAlignment=ni={}));var Wn;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Wn||(e.NotebookEditorRevealType=Wn={}));class gi{constructor(H,ge){this.text=H,this.alignment=ge}}e.$xO=gi;var ii;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(ii||(e.NotebookControllerAffinity=ii={}));var ri;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(ri||(e.NotebookControllerAffinity2=ri={}));class mi{constructor(H,ge=[]){this.uri=H,this.provides=(0,d.$3b)(ge)}}e.$yO=mi;class $i{constructor(H){this.label=H}}e.$zO=$i;var si;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(si||(e.NotebookVariablesRequestKind=si={}));let Vn=class{constructor(H,ge){this.label=H,this.timestamp=ge}};e.$AO=Vn,e.$AO=Vn=Je([P],Vn);var oi;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(oi||(e.ExtensionMode=oi={}));var ai;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(ai||(e.ExtensionRuntime=ai={}));var ci;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(ci||(e.StandardTokenType=ci={}));class pi{constructor(H,ge){this.ranges=H,this.wordPattern=ge}}e.$BO=pi;class de{constructor(H){this.c=H}get autoForwardAction(){return this.c}}e.$CO=de;var ye;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(ye||(e.TestResultState=ye={}));var Ue;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(Ue||(e.TestRunProfileKind=Ue={}));let ct=class{constructor(H=void 0,ge=void 0,Oe=void 0,Xe=!1,rt=!0){this.include=H,this.exclude=ge,this.profile=Oe,this.continuous=Xe,this.preserveFocus=rt}};e.$DO=ct,e.$DO=ct=Je([P],ct);let yt=k=class{static diff(H,ge,Oe){const Xe=new k(H);return Xe.expectedOutput=ge,Xe.actualOutput=Oe,Xe}constructor(H){this.message=H}};e.$EO=yt,e.$EO=yt=k=Je([P],yt);let At=class{constructor(H){this.id=H}};e.$FO=At,e.$FO=At=Je([P],At);class En{constructor(H,ge){this.covered=H,this.total=ge,wi(this)}}e.$GO=En;function wi(G){if(G){if(G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`);if(G.total<0)throw new Error(`The number of covered items (${G.total}) cannot be negative`)}}class bi{static fromDetails(H,ge){const Oe=new En(0,0),Xe=new En(0,0),rt=new En(0,0);for(const pt of ge)if("branches"in pt){Oe.total+=1,Oe.covered+=pt.executed?1:0;for(const Kt of pt.branches)Xe.total+=1,Xe.covered+=Kt.executed?1:0}else rt.total+=1,rt.covered+=pt.executed?1:0;const ft=new bi(H,Oe,Xe.total>0?Xe:void 0,rt.total>0?rt:void 0);return ft.detailedCoverage=ge,ft}constructor(H,ge,Oe,Xe){this.uri=H,this.statementCoverage=ge,this.branchCoverage=Oe,this.declarationCoverage=Xe}}e.$IO=bi;class Oi{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,ge,Oe=[]){this.executed=H,this.location=ge,this.branches=Oe}}e.$JO=Oi;class Fi{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,ge,Oe){this.executed=H,this.location=ge,this.label=Oe}}e.$KO=Fi;class Ti{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,ge,Oe){this.name=H,this.executed=ge,this.location=Oe}}e.$LO=Ti;var vi;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(vi||(e.ExternalUriOpenerPriority=vi={}));var yi;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(yi||(e.WorkspaceTrustState=yi={}));var Ei;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ei||(e.PortAutoForwardAction=Ei={}));class ji{constructor(H,ge,Oe,Xe,rt,ft){this.kind=H,this.name=ge,this.detail=Oe,this.uri=Xe,this.range=rt,this.selectionRange=ft}}e.$MO=ji;class zi{constructor(H){this.uri=H}}e.$NO=zi;class Bi{constructor(H,ge){this.original=H,this.modified=ge}}e.$OO=Bi;class Ui{constructor(H,ge,Oe,Xe){this.base=H,this.input1=ge,this.input2=Oe,this.result=Xe}}e.$PO=Ui;class Wi{constructor(H,ge){this.uri=H,this.viewType=ge}}e.$QO=Wi;class Vi{constructor(H){this.viewType=H}}e.$RO=Vi;class qi{constructor(H,ge){this.uri=H,this.notebookType=ge}}e.$SO=qi;class Hi{constructor(H,ge,Oe){this.original=H,this.modified=ge,this.notebookType=Oe}}e.$TO=Hi;class Gi{constructor(){}}e.$UO=Gi;class Ki{constructor(H,ge){this.uri=H,this.inputBoxUri=ge}}e.$VO=Ki;class Ji{constructor(){}}e.$WO=Ji;class Qi{constructor(H){this.textDiffs=H}}e.$XO=Qi;var ki;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(ki||(e.InteractiveSessionVoteDirection=ki={}));var Pi;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(Pi||(e.ChatCopyKind=Pi={}));var Si;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(Si||(e.ChatVariableLevel=Si={}));class Yi{constructor(H,ge){this.label=H,this.values=ge}}e.$YO=Yi;var Di;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(Di||(e.InteractiveEditorResponseFeedbackKind=Di={}));var Ci;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(Ci||(e.ChatResultFeedbackKind=Ci={}));class Zi{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ye(H):H}}e.$ZO=Zi;class Xi{constructor(H,ge){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ye(H):H,this.vulnerabilities=ge}}e.$1O=Xi;class xi{constructor(H,ge){this.participant=H,this.command=ge}}e.$2O=xi;class _i{constructor(H,ge){this.value=H,this.baseUri=ge}}e.$3O=_i;class er{constructor(H,ge){this.value=H,this.title=ge}}e.$4O=er;class tr{constructor(H){this.value=H}}e.$5O=tr;class nr{constructor(H){this.value=H}}e.$6O=nr;class ir{constructor(H){this.value=H}}e.$7O=ir;class rr{constructor(H,ge){this.uri=H,this.edits=Array.isArray(ge)?ge:[ge]}}e.$8O=rr;class sr{constructor(H,ge,Oe,Xe){this.prompt=H,this.command=ge,this.variables=Oe,this.participant=Xe}}e.$9O=sr;class or{constructor(H,ge,Oe,Xe){this.response=H,this.result=ge,this.participant=Oe,this.command=Xe}}e.$0O=or;var Ii;(function(G){G[G.Panel=1]="Panel",G[G.Terminal=2]="Terminal",G[G.Notebook=3]="Notebook",G[G.Editor=4]="Editor"})(Ii||(e.ChatLocation=Ii={}));class ar{constructor(H){this.content=H}}e.$$O=ar;class cr{constructor(H,ge){this.content=H,this.name=ge}}e.$_O=cr;class ur{constructor(H,ge){this.content=H,this.name=ge}}e.$aP=ur;class Nn extends Error{static NotFound(H){return new Nn(H,Nn.NotFound.name)}static NoPermissions(H){return new Nn(H,Nn.NoPermissions.name)}constructor(H,ge,Oe){super(H,{cause:Oe}),this.name="LanguageModelError",this.code=ge??""}}e.$bP=Nn;var Ai;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(Ai||(e.RelatedInformationType=Ai={}));var Ri;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped",G[G.Error=5]="Error"})(Ri||(e.SpeechToTextStatus=Ri={}));var Mi;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(Mi||(e.KeywordRecognitionStatus=Mi={}));class lr{constructor(H,ge){this.text=H,this.range=ge}}e.$cP=lr;var Li;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Li||(e.InlineEditTriggerKind=Li={}))}),define(ke[329],Pe([1,0,6,8]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2kc=void 0;class L{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(d.$1M.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,b,m){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(M);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(b,m)??[]}getRelatedInformation(M,b,m){return this.c.$getAiRelatedInformation(b,m)}registerRelatedInformationProvider(M,b,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerAiRelatedInformationProvider(E,b),new N.$3M(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$2kc=L}),define(ke[121],Pe([1,0,4,6,8,25,146,5,20]),function(le,e,d,N,L,R,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=e.$alc=void 0,e.$alc=(0,b.$vi)("IExtHostAuthentication");let E=class{constructor($){this.b=new Map,this.c=new d.$ee,this.onDidChangeSessions=this.c.event,this.d=new A,this.f=new A,this.a=$.getProxy(N.$1M.MainThreadAuthentication)}async getSession($,y,w,h={}){const g=R.$Qm.toKey($.identifier),a=[...w].sort().join(" ");return await this.d.getOrCreate(`${g} ${y} ${a}`,async()=>{await this.a.$ensureProvider(y);const n=$.displayName||$.name;return this.a.$getSession(y,w,g,n,h)})}async getSessions($,y,w){const h=R.$Qm.toKey($.identifier),g=[...w].sort().join(" ");return await this.f.getOrCreate(`${h} ${g}`,async()=>{await this.a.$ensureProvider(y);const a=$.displayName||$.name;return this.a.$getSessions(y,w,h,a)})}async removeSession($,y){const w=this.b.get($);return w?w.provider.removeSession(y):this.a.$removeSession($,y)}registerAuthenticationProvider($,y,w,h){if(this.b.get($))throw new Error(`An authentication provider with id '${$}' is already registered.`);this.b.set($,{label:y,provider:w,options:h??{supportsMultipleAccounts:!1}});const g=w.onDidChangeSessions(a=>this.a.$sendDidChangeSessions($,a));return this.a.$registerAuthenticationProvider($,y,h?.supportsMultipleAccounts??!1),new L.$3M(()=>{g.dispose(),this.b.delete($),this.a.$unregisterAuthenticationProvider($)})}$createSession($,y,w){const h=this.b.get($);if(h)return Promise.resolve(h.provider.createSession(y,w));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$removeSession($,y){const w=this.b.get($);if(w)return Promise.resolve(w.provider.removeSession(y));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$getSessions($,y){const w=this.b.get($);if(w)return Promise.resolve(w.provider.getSessions(y));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$onDidChangeAuthenticationSessions($,y){return $.startsWith(M.$3L)||this.c.fire({provider:{id:$,label:y}}),Promise.resolve()}};e.$blc=E,e.$blc=E=Je([Ve(0,m.$oP)],E);class A{constructor(){this.a=new Map}getOrCreate($,y){const w=this.a.get($);if(w)return w;const h=y().finally(()=>this.a.delete($));return this.a.set($,h),h}}}),define(ke[152],Pe([1,0,2,6,8,5,20,11,19,14,17,26]),function(le,e,d,N,L,R,M,b,m,E,A,D){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=void 0;let y=class{static{$=this}static{this.c=0}static{this.d=250}constructor(h,g){this.h=g,this.f=new Map,this.g=h.getProxy(N.$1M.MainThreadDecorations)}registerFileDecorationProvider(h,g){const a=$.c++;this.f.set(a,{provider:h,extensionDescription:g}),this.g.$registerDecorationProvider(a,g.identifier.value);const n=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(a,null);return}const u=(0,m.$3b)(i);if(u.length<=$.d){this.g.$onDidChange(a,u);return}this.h.warn("[Decorations] CAPPING events from decorations provider",g.identifier.value,u.length);const o=u.map(r=>({uri:r,rank:(0,E.$af)(r.path,"/")})),t=(0,m.$zb)(o,(r,c)=>r.rank-c.rank||(0,E.$qf)(r.uri.path,c.uri.path)),l=[];e:for(const r of t){let c;for(const s of r){const v=(0,A.$nc)(s.uri.path);if(c!==v&&(c=v,l.push(s.uri)>=$.d))break e}}this.g.$onDidChange(a,l)});return new L.$3M(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(h,g,a){if(!this.f.has(h))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:u}=this.f.get(h);return await Promise.all(g.map(async o=>{try{const{uri:t,id:l}=o,r=await Promise.resolve(i.provideFileDecoration(d.URI.revive(t),a));if(!r)return;try{L.$qO.validate(r),r.badge&&typeof r.badge!="string"&&(0,D.$GG)(u,"codiconDecoration"),n[l]=[r.propagate,r.tooltip,r.badge,r.color]}catch(c){this.h.warn(`INVALID decoration from extension '${u.identifier.value}': ${c}`)}}catch(t){this.h.error(t)}})),n}};e.$amc=y,e.$amc=y=$=Je([Ve(0,M.$oP),Ve(1,b.$2j)],y),e.$bmc=(0,R.$vi)("IExtHostDecorations")}),define(ke[330],Pe([1,0,13,2,8,6,15,22,14]),function(le,e,d,N,L,R,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;class E{static{this.a=0}constructor(D,$,y){this.d=$,this.e=y,this.b=new Map,this.c=D.getProxy(R.$1M.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,$){if(Object.keys(M.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const y=E.a++;this.b.set(y,$),this.c.$registerTextContentProvider(y,D);let w;if(typeof $.onDidChange=="function"){let h;w=$.onDidChange(async g=>{if(g.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(g))return;h&&await h;const a=this.$provideTextDocumentContent(y,g).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(g);if(!i)return;const u=(0,m.$kf)(n);if(!i.equalLines(u))return this.c.$onVirtualDocumentChange(g,n)}).catch(d.$1).finally(()=>{h===a&&(h=void 0)});h=a})}return new L.$3M(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(D,$){const y=this.b.get(D);return y?Promise.resolve(y.provideTextDocumentContent(N.URI.revive($),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${$.scheme}`))}}e.$dmc=E}),define(ke[153],Pe([1,0,62,15,14,188,130,8,19]),function(le,e,d,N,L,R,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sP=e.$rP=void 0,e.$qP=A;const E=new Map;function A(w,h){h?E.set(w,h):E.delete(w)}function D(w){return E.get(w)}class $ extends R.$Yv{constructor(h,g,a,n,i,u,o){super(g,a,n,i),this.c=h,this.m=u,this.q=o,this.b=!1}dispose(){(0,d.ok)(!this.b),this.b=!0,this.q=!1}equalLines(h){return(0,m.$ub)(this.f,h)}get document(){if(!this.a){const h=this;this.a={get uri(){return h.d},get fileName(){return h.d.fsPath},get isUntitled(){return h.d.scheme===N.Schemas.untitled},get languageId(){return h.m},get version(){return h.h},get isClosed(){return h.b},get isDirty(){return h.q},save(){return h.r()},getText(g){return g?h.s(g):h.getText()},get eol(){return h.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return h.f.length},lineAt(g){return h.t(g)},offsetAt(g){return h.u(g)},positionAt(g){return h.v(g)},validateRange(g){return h.w(g)},validatePosition(g){return h.x(g)},getWordRangeAtPosition(g,a){return h.y(g,a)}}}return Object.freeze(this.a)}_acceptLanguageId(h){(0,d.ok)(!this.b),this.m=h}_acceptIsDirty(h){(0,d.ok)(!this.b),this.q=h}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(h){const g=this.w(h);if(g.isEmpty)return"";if(g.isSingleLine)return this.f[g.start.line].substring(g.start.character,g.end.character);const a=this.g,n=g.start.line,i=g.end.line,u=[];u.push(this.f[n].substring(g.start.character));for(let o=n+1;o<i;o++)u.push(this.f[o]);return u.push(this.f[i].substring(0,g.end.character)),u.join(a)}t(h){let g;if(h instanceof b.$4M?g=h.line:typeof h=="number"&&(g=h),typeof g!="number"||g<0||g>=this.f.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new y(g,this.f[g],g===this.f.length-1)}u(h){return h=this.x(h),this.l(),this.j.getPrefixSum(h.line-1)+h.character}v(h){h=Math.floor(h),h=Math.max(0,h),this.l();const g=this.j.getIndexOf(h),a=this.f[g.index].length;return new b.$4M(g.index,Math.min(g.remainder,a))}w(h){if(!(h instanceof b.$5M))throw new Error("Invalid argument");const g=this.x(h.start),a=this.x(h.end);return g===h.start&&a===h.end?h:new b.$5M(g.line,g.character,a.line,a.character)}x(h){if(!(h instanceof b.$4M))throw new Error("Invalid argument");if(this.f.length===0)return h.with(0,0);let{line:g,character:a}=h,n=!1;if(g<0)g=0,a=0,n=!0;else if(g>=this.f.length)g=this.f.length-1,a=this.f[g].length,n=!0;else{const i=this.f[g].length;a<0?(a=0,n=!0):a>i&&(a=i,n=!0)}return n?new b.$4M(g,a):h}y(h,g){const a=this.x(h);if(!g)g=D(this.m);else if((0,L.$jf)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const n=(0,M.$8s)(a.character+1,(0,M.$6s)(g),this.f[a.line],0);if(n)return new b.$5M(a.line,n.startColumn-1,a.line,n.endColumn-1)}}e.$rP=$;class y{constructor(h,g,a){this.a=h,this.b=g,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$5M(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$5M(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$sP=y}),define(ke[331],Pe([1,0,6,8]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=void 0;class L{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(d.$1M.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,b,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(M);if(!E)throw new Error("Embedding vector provider not found");const A=await E.provideEmbeddingVector(b,m);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(M,b,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerAiEmbeddingVectorProvider(b,E),new N.$3M(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$fmc=L}),define(ke[70],Pe([1,0,6,33,8,21,5,20,60,3,7,23,15]),function(le,e,d,N,L,R,M,b,m,E,A,D,$){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=e.$qlc=void 0;let w=y=class{constructor(g,a){this.b=new Map,this.c=new A.$Eh,this.a=g.getProxy(d.$1M.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let u;const o=n.b.get(i.scheme);return o?(await n.a.$ensureActivation(i.scheme),u=await o.impl.stat(i)):u=await n.a.$stat(i),{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===N.FilePermission.Readonly?1:void 0}}catch(u){y.e(u)}},async readDirectory(i){try{const u=n.b.get(i.scheme);return u?(await n.a.$ensureActivation(i.scheme),(await u.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(u){return y.e(u)}},async createDirectory(i){try{const u=n.b.get(i.scheme);return u&&!u.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(u.impl,u.extUri,i)):await n.a.$mkdir(i)}catch(u){return y.e(u)}},async readFile(i){try{const u=n.b.get(i.scheme);return u?(await n.a.$ensureActivation(i.scheme),(await u.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(u){return y.e(u)}},async writeFile(i,u){try{const o=n.b.get(i.scheme);return o&&!o.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(o.impl,o.extUri,o.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(o.impl.writeFile(i,u,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,R.$Fe.wrap(u))}catch(o){return y.e(o)}},async delete(i,u){try{const o=n.b.get(i.scheme);return o&&!o.isReadonly&&!u?.useTrash?(await n.a.$ensureActivation(i.scheme),await o.impl.delete(i,{recursive:!1,...u})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...u})}catch(o){return y.e(o)}},async rename(i,u,o){try{return await n.a.$rename(i,u,{overwrite:!1,...o})}catch(t){return y.e(t)}},async copy(i,u,o){try{return await n.a.$copy(i,u,{overwrite:!1,...o})}catch(t){return y.e(t)}},isWritableFileSystem(i){const u=a.getCapabilities(i);if(typeof u=="number")return!(u&2048)}})}async d(g,a,n){const i=[];for(;!a.isEqual(n,a.dirname(n));)try{if(!((await g.stat(n)).type&N.FileType.Directory))throw L.$hO.FileExists(`Unable to create folder '${n.scheme===$.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(u){if(N.$fl(u)!==N.FileSystemProviderErrorCode.FileNotFound)throw u;i.push(a.basename(n)),n=a.dirname(n)}for(let u=i.length-1;u>=0;u--){n=a.joinPath(n,i[u]);try{await g.createDirectory(n)}catch(o){if(N.$fl(o)!==N.FileSystemProviderErrorCode.FileExists)throw o}}}static e(g){if(g instanceof L.$hO)throw g;if(g instanceof N.$bl)switch(g.code){case N.FileSystemProviderErrorCode.FileExists:throw L.$hO.FileExists(g.message);case N.FileSystemProviderErrorCode.FileNotFound:throw L.$hO.FileNotFound(g.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw L.$hO.FileNotADirectory(g.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw L.$hO.FileIsADirectory(g.message);case N.FileSystemProviderErrorCode.NoPermissions:throw L.$hO.NoPermissions(g.message);case N.FileSystemProviderErrorCode.Unavailable:throw L.$hO.Unavailable(g.message);default:throw new L.$hO(g.message,g.name)}if(!(g instanceof Error))throw new L.$hO(String(g));if(g.name==="ENOPRO"||g.message.includes("ENOPRO"))throw L.$hO.Unavailable(g.message);switch(g.name){case N.FileSystemProviderErrorCode.FileExists:throw L.$hO.FileExists(g.message);case N.FileSystemProviderErrorCode.FileNotFound:throw L.$hO.FileNotFound(g.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw L.$hO.FileNotADirectory(g.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw L.$hO.FileIsADirectory(g.message);case N.FileSystemProviderErrorCode.NoPermissions:throw L.$hO.NoPermissions(g.message);case N.FileSystemProviderErrorCode.Unavailable:throw L.$hO.Unavailable(g.message);default:throw new L.$hO(g.message,g.name)}}addFileSystemProvider(g,a,n){return this.b.set(g,{impl:a,extUri:n?.isCaseSensitive?D.$Yg:D.$1g,isReadonly:!!n?.isReadonly}),(0,E.$Tc)(()=>this.b.delete(g))}getFileSystemProviderExtUri(g){return this.b.get(g)?.extUri??D.$Yg}};e.$qlc=w,e.$qlc=w=y=Je([Ve(0,b.$oP),Ve(1,m.$7kc)],w),e.$rlc=(0,M.$vi)("IExtHostConsumerFileSystem")}),define(ke[93],Pe([1,0,5,28,11,70,2]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=e.$slc=void 0,e.$slc=(0,d.$vi)("IExtensionStoragePaths");let b=class{constructor(E,A,D){this.d=A,this.f=D,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then($=>this.c=$)}async g(E){return M.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,A=await this.g(E);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(M.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(E){if(this.c)return M.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return M.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$tlc=b,e.$tlc=b=Je([Ve(0,N.$EP),Ve(1,L.$2j),Ve(2,R.$rlc)],b)}),define(ke[332],Pe([1,0,8,20,4]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;let R=class{constructor(b){this.a=new d.$rO(d.ColorThemeKind.Dark),this.b=new L.$ee}get activeColorTheme(){return this.a}$onColorThemeChange(b){let m;switch(b){case"light":m=d.ColorThemeKind.Light;break;case"hcDark":m=d.ColorThemeKind.HighContrast;break;case"hcLight":m=d.ColorThemeKind.HighContrastLight;break;default:m=d.ColorThemeKind.Dark}this.a=new d.$rO(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$1mc=R,e.$1mc=R=Je([Ve(0,N.$oP)],R)}),define(ke[71],Pe([1,0,22,4,3,234,5,11,88,6,28,20,8]),function(le,e,d,N,L,R,M,b,m,E,A,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kDb=e.$jDb=e.TunnelDtoConverter=void 0;class y extends m.$lw{}var w;(function(g){function a(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:i.protocol}}g.fromApiTunnel=a;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==m.TunnelPrivacyId.ConstantPrivate&&i.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}g.fromServiceTunnel=n})(w||(e.TunnelDtoConverter=w={})),e.$jDb=(0,M.$vi)("IExtHostTunnelService");let h=class extends L.$Vc{constructor(a,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$ee,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(E.$1M.MainThreadTunnelService)}async openTunnel(a,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,a.displayName);if(i){const u=new y(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(u),u}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,n){a.portRange===void 0&&a.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:a,provider:n}),this.a.$registerPortsAttributesProvider(a,i),new $.$3M(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(a,n,i,u,o){const t=[];for(const r of a){const c=this.r.get(r);if(!c)return[];t.push(...await Promise.all(n.map(async s=>{let v;try{v=await c.provider.providePortAttributes({port:s,pid:i,commandLine:u},o)}catch{v=await c.provider.providePortAttributes(s,i,u,o)}return{providedAttributes:v,port:s}})))}const l=t.filter(r=>!!r.providedAttributes);return l.length>0?l.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(u,o)=>await a.provideTunnel(u,o,d.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,L.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,n){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const i=a.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let u=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const o=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:u,protocol:!0}:void 0;this.a.$setTunnelProvider(o)}}else this.b=void 0;return(0,L.$Tc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,n){if(this.g.has(a.host)){const i=this.g.get(a.host);i.has(a.port)&&(n&&i.get(a.port).disposeListener.dispose(),await i.get(a.port).tunnel.dispose(),i.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(a,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const u=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),u===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const o=this.B(u.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(u.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:u,disposeListener:o}),w.fromApiTunnel(u)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(a){const n=await Promise.all(a.map(u=>this.f(u.host,u.port,u.detail??""))),i=a.filter((u,o)=>n[o]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(u=>u.port).join(", ")} to ${i.map(u=>u.port).join(", ")}`),i}};e.$kDb=h,e.$kDb=h=Je([Ve(0,D.$oP),Ve(1,A.$EP),Ve(2,b.$2j)],h)}),define(ke[16],Pe([1,0,19,21,177,75,81,27,167,58,101,24,172,23,18,2,29,84,139,145,143,296,120,69,89,308,8]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i,u,o,t,l,r,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$lP=F,e.$mP=Z,e.$nP=q;var v;(function(Le){function Te(_){const{selectionStartLineNumber:Fe,selectionStartColumn:He,positionLineNumber:_e,positionColumn:Qe}=_,ht=new s.$4M(Fe-1,He-1),Et=new s.$4M(_e-1,Qe-1);return new s.$6M(ht,Et)}Le.to=Te;function Ee(_){const{anchor:Fe,active:He}=_;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Le.from=Ee})(v||(e.Selection=v={}));var f;(function(Le){function Te(_){if(!_)return;const{start:Fe,end:He}=_;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Le.from=Te;function Ee(_){if(!_)return;const{startLineNumber:Fe,startColumn:He,endLineNumber:_e,endColumn:Qe}=_;return new s.$5M(Fe-1,He-1,_e-1,Qe-1)}Le.to=Ee})(f||(e.Range=f={}));var S;(function(Le){function Te(_){return{uri:_.uri,range:f.from(_.range)}}Le.from=Te;function Ee(_){return new s.$cN(h.URI.revive(_.uri),f.to(_.range))}Le.to=Ee})(S||(e.Location=S={}));var p;(function(Le){function Te(Ee){switch(Ee){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Le.to=Te})(p||(e.TokenType=p={}));var k;(function(Le){function Te(_){return new s.$4M(_.lineNumber-1,_.column-1)}Le.to=Te;function Ee(_){return{lineNumber:_.line+1,column:_.character+1}}Le.from=Ee})(k||(e.Position=k={}));var P;(function(Le){function Te(Fe,He,_e){return(0,d.$Hb)((0,d.$3b)(Fe).map(Qe=>Ee(Qe,He,_e)))}Le.from=Te;function Ee(Fe,He,_e){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:_e?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:_(Fe.scheme,He),pattern:ce.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:_e?.isBuiltin}}function _(Fe,He){return He&&typeof Fe=="string"?He.transformOutgoingScheme(Fe):Fe}})(P||(e.DocumentSelector=P={}));var C;(function(Le){function Te(_){switch(_){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Le.from=Te;function Ee(_){switch(_){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Le.to=Ee})(C||(e.DiagnosticTag=C={}));var I;(function(Le){function Te(_){let Fe;return _.code&&((0,w.$8f)(_.code)||(0,w.$_f)(_.code)?Fe=String(_.code):Fe={value:String(_.code.value),target:_.code.target}),{...f.from(_.range),message:_.message,source:_.source,code:Fe,severity:j.from(_.severity),relatedInformation:_.relatedInformation&&_.relatedInformation.map(T.from),tags:Array.isArray(_.tags)?(0,d.$Hb)(_.tags.map(C.from)):void 0}}Le.from=Te;function Ee(_){const Fe=new s.$eN(f.to(_),_.message,j.to(_.severity));return Fe.source=_.source,Fe.code=(0,w.$8f)(_.code)?_.code:_.code?.value,Fe.relatedInformation=_.relatedInformation&&_.relatedInformation.map(T.to),Fe.tags=_.tags&&(0,d.$Hb)(_.tags.map(C.to)),Fe}Le.to=Ee})(I||(e.Diagnostic=I={}));var T;(function(Le){function Te(_){return{...f.from(_.location.range),message:_.message,resource:_.location.uri}}Le.from=Te;function Ee(_){return new s.$dN(new s.$cN(_.resource,f.to(_)),_.message)}Le.to=Ee})(T||(e.DiagnosticRelatedInformation=T={}));var j;(function(Le){function Te(_){switch(_){case s.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Le.from=Te;function Ee(_){switch(_){case n.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Le.to=Ee})(j||(e.DiagnosticSeverity=j={}));var z;(function(Le){function Te(_){return typeof _=="number"&&_>=s.ViewColumn.One?_-1:_===s.ViewColumn.Beside?c.$WD:c.$VD}Le.from=Te;function Ee(_){if(typeof _=="number"&&_>=0)return _+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=Ee})(z||(e.ViewColumn=z={}));function O(Le){return typeof Le.range<"u"}function F(Le){return Le.length===0?!0:!!O(Le[0])}var B;(function(Le){function Te(Qe){return Qe.map(Le.from)}Le.fromMany=Te;function Ee(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function _(Qe){let ht;if(Ee(Qe)){const{language:ut,value:Yt}=Qe;ht={value:"```"+ut+`
`+Yt+"\n```\n"}}else s.$sN.isMarkdownString(Qe)?ht={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ht={value:Qe}:ht={value:""};const Et=Object.create(null);ht.uris=Et;const jt=ut=>{try{let Yt=h.URI.parse(ut,!0);Yt=Yt.with({query:Fe(Yt.query,Et)}),Et[ut]=Yt}catch{}return""},Vt=new m.marked.Renderer;return Vt.link=jt,Vt.image=ut=>typeof ut=="string"?jt(M.$1k(ut).href):"",(0,m.marked)(ht.value,{renderer:Vt}),ht}Le.from=_;function Fe(Qe,ht){if(!Qe)return Qe;let Et;try{Et=(0,E.$4h)(Qe)}catch{}if(!Et)return Qe;let jt=!1;return Et=(0,D.$4n)(Et,Vt=>{if(h.URI.isUri(Vt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[ut]=Vt,jt=!0,ut}else return}),jt?JSON.stringify(Et):Qe}function He(Qe){const ht=new s.$sN(Qe.value,Qe.supportThemeIcons);return ht.isTrusted=Qe.isTrusted,ht.supportHtml=Qe.supportHtml,ht.baseUri=Qe.baseUri?h.URI.from(Qe.baseUri):void 0,ht}Le.to=He;function _e(Qe){if(Qe)return typeof Qe=="string"?Qe:Le.from(Qe)}Le.fromStrict=_e})(B||(e.MarkdownString=B={}));function Z(Le){return F(Le)?Le.map(Te=>({range:f.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?B.fromMany(Te.hoverMessage):Te.hoverMessage?B.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Le.map(Te=>({range:f.from(Te)}))}function q(Le){return typeof Le>"u"?Le:typeof Le=="string"?h.URI.file(Le):Le}var Q;(function(Le){function Te(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?q(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Le.from=Te})(Q||(e.ThemableDecorationAttachmentRenderOptions=Q={}));var x;(function(Le){function Te(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?q(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?Q.from(Ee.before):void 0,after:Ee.after?Q.from(Ee.after):void 0}}Le.from=Te})(x||(e.ThemableDecorationRenderOptions=x={}));var X;(function(Le){function Te(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=Te})(X||(e.DecorationRangeBehavior=X={}));var ie;(function(Le){function Te(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?X.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?x.from(Ee.light):void 0,dark:Ee.dark?x.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?q(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?Q.from(Ee.before):void 0,after:Ee.after?Q.from(Ee.after):void 0}}Le.from=Te})(ie||(e.DecorationRenderOptions=ie={}));var me;(function(Le){function Te(_){return{text:_.newText,eol:_.newEol&&Be.from(_.newEol),range:f.from(_.range)}}Le.from=Te;function Ee(_){const Fe=new s.$0M(f.to(_.range),_.text);return Fe.newEol=typeof _.eol>"u"?void 0:Be.to(_.eol),Fe}Le.to=Ee})(me||(e.TextEdit=me={}));var ue;(function(Le){function Te(_,Fe){const He={edits:[]};if(_ instanceof s.$aN){const _e=new b.$Cc;for(const Qe of _._allEntries())Qe._type===1&&h.URI.isUri(Qe.to)&&Qe.from===void 0&&_e.add(Qe.to);for(const Qe of _._allEntries())if(Qe._type===1){let ht;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?ht={type:"base64",value:(0,N.$Ze)(N.$Fe.wrap(Qe.options.contents))}:ht={type:"dataTransferItem",id:Qe.options.contents._itemId}),He.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:ht},metadata:Qe.metadata})}else Qe._type===2?He.edits.push({resource:Qe.uri,textEdit:me.from(Qe.edit),versionId:_e.has(Qe.uri)?void 0:Fe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?He.edits.push({resource:Qe.uri,textEdit:{range:f.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:_e.has(Qe.uri)?void 0:Fe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?He.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&He.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(Rt.from)}})}return He}Le.from=Te;function Ee(_){const Fe=new s.$aN,He=new b.$Bc;for(const _e of _.edits)if(_e.textEdit){const Qe=_e,ht=h.URI.revive(Qe.resource),Et=f.to(Qe.textEdit.range),jt=Qe.textEdit.text,Vt=Qe.textEdit.insertAsSnippet;let ut;Vt?ut=s.$_M.replace(Et,new s.$bN(jt)):ut=s.$0M.replace(Et,jt);const Yt=He.get(ht);Yt?Yt.push(ut):He.set(ht,[ut])}else Fe.renameFile(h.URI.revive(_e.oldResource),h.URI.revive(_e.newResource),_e.options);for(const[_e,Qe]of He)Fe.set(_e,Qe);return Fe}Le.to=Ee})(ue||(e.WorkspaceEdit=ue={}));var ve;(function(Le){const Te=Object.create(null);Te[s.SymbolKind.File]=0,Te[s.SymbolKind.Module]=1,Te[s.SymbolKind.Namespace]=2,Te[s.SymbolKind.Package]=3,Te[s.SymbolKind.Class]=4,Te[s.SymbolKind.Method]=5,Te[s.SymbolKind.Property]=6,Te[s.SymbolKind.Field]=7,Te[s.SymbolKind.Constructor]=8,Te[s.SymbolKind.Enum]=9,Te[s.SymbolKind.Interface]=10,Te[s.SymbolKind.Function]=11,Te[s.SymbolKind.Variable]=12,Te[s.SymbolKind.Constant]=13,Te[s.SymbolKind.String]=14,Te[s.SymbolKind.Number]=15,Te[s.SymbolKind.Boolean]=16,Te[s.SymbolKind.Array]=17,Te[s.SymbolKind.Object]=18,Te[s.SymbolKind.Key]=19,Te[s.SymbolKind.Null]=20,Te[s.SymbolKind.EnumMember]=21,Te[s.SymbolKind.Struct]=22,Te[s.SymbolKind.Event]=23,Te[s.SymbolKind.Operator]=24,Te[s.SymbolKind.TypeParameter]=25;function Ee(Fe){return typeof Te[Fe]=="number"?Te[Fe]:6}Le.from=Ee;function _(Fe){for(const He in Te)if(Te[He]===Fe)return Number(He);return s.SymbolKind.Property}Le.to=_})(ve||(e.SymbolKind=ve={}));var te;(function(Le){function Te(_){switch(_){case s.SymbolTag.Deprecated:return 1}}Le.from=Te;function Ee(_){switch(_){case 1:return s.SymbolTag.Deprecated}}Le.to=Ee})(te||(e.SymbolTag=te={}));var U;(function(Le){function Te(_){return{name:_.name,kind:ve.from(_.kind),tags:_.tags&&_.tags.map(te.from),containerName:_.containerName,location:re.from(_.location)}}Le.from=Te;function Ee(_){const Fe=new s.$jN(_.name,ve.to(_.kind),_.containerName,re.to(_.location));return Fe.tags=_.tags&&_.tags.map(te.to),Fe}Le.to=Ee})(U||(e.WorkspaceSymbol=U={}));var ee;(function(Le){function Te(_){const Fe={name:_.name||"!!MISSING: name!!",detail:_.detail,range:f.from(_.range),selectionRange:f.from(_.selectionRange),kind:ve.from(_.kind),tags:_.tags?.map(te.from)??[]};return _.children&&(Fe.children=_.children.map(Te)),Fe}Le.from=Te;function Ee(_){const Fe=new s.$kN(_.name,_.detail,ve.to(_.kind),f.to(_.range),f.to(_.selectionRange));return(0,d.$Lb)(_.tags)&&(Fe.tags=_.tags.map(te.to)),_.children&&(Fe.children=_.children.map(Ee)),Fe}Le.to=Ee})(ee||(e.DocumentSymbol=ee={}));var pe;(function(Le){function Te(_){const Fe=new s.$oN(ve.to(_.kind),_.name,_.detail||"",h.URI.revive(_.uri),f.to(_.range),f.to(_.selectionRange));return Fe._sessionId=_._sessionId,Fe._itemId=_._itemId,Fe}Le.to=Te;function Ee(_,Fe,He){if(Fe=Fe??_._sessionId,He=He??_._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,name:_.name,detail:_.detail,kind:ve.from(_.kind),uri:_.uri,range:f.from(_.range),selectionRange:f.from(_.selectionRange),tags:_.tags?.map(te.from)}}Le.from=Ee})(pe||(e.CallHierarchyItem=pe={}));var Ce;(function(Le){function Te(Ee){return new s.$pN(pe.to(Ee.from),Ee.fromRanges.map(_=>f.to(_)))}Le.to=Te})(Ce||(e.CallHierarchyIncomingCall=Ce={}));var se;(function(Le){function Te(Ee){return new s.$qN(pe.to(Ee.to),Ee.fromRanges.map(_=>f.to(_)))}Le.to=Te})(se||(e.CallHierarchyOutgoingCall=se={}));var re;(function(Le){function Te(_){return{range:_.range&&f.from(_.range),uri:_.uri}}Le.from=Te;function Ee(_){return new s.$cN(h.URI.revive(_.uri),f.to(_.range))}Le.to=Ee})(re||(e.location=re={}));var oe;(function(Le){function Te(_){const Fe=_,He=_;return{originSelectionRange:Fe.originSelectionRange?f.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:He.uri,range:f.from(Fe.targetRange?Fe.targetRange:He.range),targetSelectionRange:Fe.targetSelectionRange?f.from(Fe.targetSelectionRange):void 0}}Le.from=Te;function Ee(_){return{targetUri:h.URI.revive(_.uri),targetRange:f.to(_.range),targetSelectionRange:_.targetSelectionRange?f.to(_.targetSelectionRange):void 0,originSelectionRange:_.originSelectionRange?f.to(_.originSelectionRange):void 0}}Le.to=Ee})(oe||(e.DefinitionLink=oe={}));var K;(function(Le){function Te(_){return{range:f.from(_.range),contents:B.fromMany(_.contents),canIncreaseVerbosity:_.canIncreaseVerbosity,canDecreaseVerbosity:_.canDecreaseVerbosity}}Le.from=Te;function Ee(_){const Fe=_.contents.map(B.to),He=f.to(_.range),_e=_.canIncreaseVerbosity,Qe=_.canDecreaseVerbosity;return new s.$gN(Fe,He,_e,Qe)}Le.to=Ee})(K||(e.Hover=K={}));var ne;(function(Le){function Te(_){return{range:f.from(_.range),expression:_.expression}}Le.from=Te;function Ee(_){return new s.$bO(f.to(_.range),_.expression)}Le.to=Ee})(ne||(e.EvaluatableExpression=ne={}));var $e;(function(Le){function Te(_){if(_ instanceof s.$cO)return{type:"text",range:f.from(_.range),text:_.text};if(_ instanceof s.$dO)return{type:"variable",range:f.from(_.range),variableName:_.variableName,caseSensitiveLookup:_.caseSensitiveLookup};if(_ instanceof s.$eO)return{type:"expression",range:f.from(_.range),expression:_.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=Te;function Ee(_){switch(_.type){case"text":return{range:f.to(_.range),text:_.text};case"variable":return{range:f.to(_.range),variableName:_.variableName,caseSensitiveLookup:_.caseSensitiveLookup};case"expression":return{range:f.to(_.range),expression:_.expression}}}Le.to=Ee})($e||(e.InlineValue=$e={}));var be;(function(Le){function Te(_){return{frameId:_.frameId,stoppedLocation:f.from(_.stoppedLocation)}}Le.from=Te;function Ee(_){return new s.$fO(_.frameId,f.to(_.stoppedLocation))}Le.to=Ee})(be||(e.InlineValueContext=be={}));var Ae;(function(Le){function Te(_){return{range:f.from(_.range),kind:_.kind}}Le.from=Te;function Ee(_){return new s.$hN(f.to(_.range),_.kind)}Le.to=Ee})(Ae||(e.DocumentHighlight=Ae={}));var fe;(function(Le){function Te(_){return{uri:_.uri,highlights:_.highlights.map(Ae.from)}}Le.from=Te;function Ee(_){return new s.$iN(h.URI.revive(_.uri),_.highlights.map(Ae.to))}Le.to=Ee})(fe||(e.MultiDocumentHighlight=fe={}));var Se;(function(Le){function Te(Ee){switch(Ee){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Le.to=Te})(Se||(e.CompletionTriggerKind=Se={}));var Ie;(function(Le){function Te(Ee){return{triggerKind:Se.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Le.to=Te})(Ie||(e.CompletionContext=Ie={}));var ze;(function(Le){function Te(_){switch(_){case s.CompletionItemTag.Deprecated:return 1}}Le.from=Te;function Ee(_){switch(_){case 1:return s.CompletionItemTag.Deprecated}}Le.to=Ee})(ze||(e.CompletionItemTag=ze={}));var V;(function(Le){const Te=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Ee(He){return Te.get(He)??9}Le.from=Ee;const _=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Fe(He){return _.get(He)??s.CompletionItemKind.Property}Le.to=Fe})(V||(e.CompletionItemKind=V={}));var W;(function(Le){function Te(Ee,_){const Fe=new s.$yN(Ee.label);return Fe.insertText=Ee.insertText,Fe.kind=V.to(Ee.kind),Fe.tags=Ee.tags?.map(ze.to),Fe.detail=Ee.detail,Fe.documentation=M.$Uk(Ee.documentation)?B.to(Ee.documentation):Ee.documentation,Fe.sortText=Ee.sortText,Fe.filterText=Ee.filterText,Fe.preselect=Ee.preselect,Fe.commitCharacters=Ee.commitCharacters,g.$tt.isIRange(Ee.range)?Fe.range=f.to(Ee.range):typeof Ee.range=="object"&&(Fe.range={inserting:f.to(Ee.range.insert),replacing:f.to(Ee.range.replace)}),Fe.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:!!(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Fe.insertText=new s.$bN(Ee.insertText):(Fe.insertText=Ee.insertText,Fe.textEdit=Fe.range instanceof s.$5M?new s.$0M(Fe.range,Fe.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Ee.additionalTextEdits.map(He=>me.to(He))),Fe.command=_&&Ee.command?_.fromInternal(Ee.command):void 0,Fe}Le.to=Te})(W||(e.CompletionItem=W={}));var J;(function(Le){function Te(_){if(typeof _.label!="string"&&!Array.isArray(_.label))throw new TypeError("Invalid label");return{label:_.label,documentation:B.fromStrict(_.documentation)}}Le.from=Te;function Ee(_){return{label:_.label,documentation:M.$Uk(_.documentation)?B.to(_.documentation):_.documentation}}Le.to=Ee})(J||(e.ParameterInformation=J={}));var Y;(function(Le){function Te(_){return{label:_.label,documentation:B.fromStrict(_.documentation),parameters:Array.isArray(_.parameters)?_.parameters.map(J.from):[],activeParameter:_.activeParameter}}Le.from=Te;function Ee(_){return{label:_.label,documentation:M.$Uk(_.documentation)?B.to(_.documentation):_.documentation,parameters:Array.isArray(_.parameters)?_.parameters.map(J.to):[],activeParameter:_.activeParameter}}Le.to=Ee})(Y||(e.SignatureInformation=Y={}));var he;(function(Le){function Te(_){return{activeSignature:_.activeSignature,activeParameter:_.activeParameter,signatures:Array.isArray(_.signatures)?_.signatures.map(Y.from):[]}}Le.from=Te;function Ee(_){return{activeSignature:_.activeSignature,activeParameter:_.activeParameter,signatures:Array.isArray(_.signatures)?_.signatures.map(Y.to):[]}}Le.to=Ee})(he||(e.SignatureHelp=he={}));var we;(function(Le){function Te(Ee,_){const Fe=new s.$xN(k.to(_.position),typeof _.label=="string"?_.label:_.label.map(je.to.bind(void 0,Ee)),_.kind&&qe.to(_.kind));return Fe.textEdits=_.textEdits&&_.textEdits.map(me.to),Fe.tooltip=M.$Uk(_.tooltip)?B.to(_.tooltip):_.tooltip,Fe.paddingLeft=_.paddingLeft,Fe.paddingRight=_.paddingRight,Fe}Le.to=Te})(we||(e.InlayHint=we={}));var je;(function(Le){function Te(Ee,_){const Fe=new s.$wN(_.label);return Fe.tooltip=M.$Uk(_.tooltip)?B.to(_.tooltip):_.tooltip,a.Command.is(_.command)&&(Fe.command=Ee.fromInternal(_.command)),_.location&&(Fe.location=re.to(_.location)),Fe}Le.to=Te})(je||(e.InlayHintLabelPart=je={}));var qe;(function(Le){function Te(_){return _}Le.from=Te;function Ee(_){return _}Le.to=Ee})(qe||(e.InlayHintKind=qe={}));var Ye;(function(Le){function Te(_){return{range:f.from(_.range),url:_.target,tooltip:_.tooltip}}Le.from=Te;function Ee(_){let Fe;if(_.url)try{Fe=typeof _.url=="string"?h.URI.parse(_.url,!0):h.URI.revive(_.url)}catch{}return new s.$DN(f.to(_.range),Fe)}Le.to=Ee})(Ye||(e.DocumentLink=Ye={}));var st;(function(Le){function Te(_){const Fe=new s.$GN(_.label);return _.textEdit&&(Fe.textEdit=me.to(_.textEdit)),_.additionalTextEdits&&(Fe.additionalTextEdits=_.additionalTextEdits.map(He=>me.to(He))),Fe}Le.to=Te;function Ee(_){return{label:_.label,textEdit:_.textEdit?me.from(_.textEdit):void 0,additionalTextEdits:_.additionalTextEdits?_.additionalTextEdits.map(Fe=>me.from(Fe)):void 0}}Le.from=Ee})(st||(e.ColorPresentation=st={}));var tt;(function(Le){function Te(_){return new s.$EN(_[0],_[1],_[2],_[3])}Le.to=Te;function Ee(_){return[_.red,_.green,_.blue,_.alpha]}Le.from=Ee})(tt||(e.Color=tt={}));var nt;(function(Le){function Te(_){return{range:f.from(_.range)}}Le.from=Te;function Ee(_){return new s.$nN(f.to(_.range))}Le.to=Ee})(nt||(e.SelectionRange=nt={}));var ot;(function(Le){function Te(Ee){switch(Ee){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Le.to=Te})(ot||(e.TextDocumentSaveReason=ot={}));var De;(function(Le){function Te(_){switch(_){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.Interval:return 3;case s.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=Te;function Ee(_){switch(_){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 3:return s.TextEditorLineNumbersStyle.Interval;case 1:default:return s.TextEditorLineNumbersStyle.On}}Le.to=Ee})(De||(e.TextEditorLineNumbersStyle=De={}));var Be;(function(Le){function Te(_){if(_===s.EndOfLine.CRLF)return 1;if(_===s.EndOfLine.LF)return 0}Le.from=Te;function Ee(_){if(_===1)return s.EndOfLine.CRLF;if(_===0)return s.EndOfLine.LF}Le.to=Ee})(Be||(e.EndOfLine=Be={}));var Ge;(function(Le){function Te(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=Te})(Ge||(e.ProgressLocation=Ge={}));var Ne;(function(Le){function Te(_){const Fe={start:_.start+1,end:_.end+1};return _.kind&&(Fe.kind=Ze.from(_.kind)),Fe}Le.from=Te;function Ee(_){const Fe={start:_.start-1,end:_.end-1};return _.kind&&(Fe.kind=Ze.to(_.kind)),Fe}Le.to=Ee})(Ne||(e.FoldingRange=Ne={}));var Ze;(function(Le){function Te(_){if(_)switch(_){case s.FoldingRangeKind.Comment:return a.$cu.Comment;case s.FoldingRangeKind.Imports:return a.$cu.Imports;case s.FoldingRangeKind.Region:return a.$cu.Region}}Le.from=Te;function Ee(_){if(_)switch(_.value){case a.$cu.Comment.value:return s.FoldingRangeKind.Comment;case a.$cu.Imports.value:return s.FoldingRangeKind.Imports;case a.$cu.Region.value:return s.FoldingRangeKind.Region}}Le.to=Ee})(Ze||(e.FoldingRangeKind=Ze={}));var ae;(function(Le){function Te(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?f.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?u.$mF.id:void 0}}Le.from=Te})(ae||(e.TextEditorOpenOptions=ae={}));var ce;(function(Le){function Te(He){return He instanceof s.$2N?He.toJSON():typeof He=="string"?He:Ee(He)||_(He)?new s.$2N(He.baseUri??He.base,He.pattern).toJSON():He}Le.from=Te;function Ee(He){const _e=He;return _e?h.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function _(He){const _e=He;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Fe(He){return typeof He=="string"?He:new s.$2N(h.URI.revive(He.baseUri),He.pattern)}Le.to=Fe})(ce||(e.GlobPattern=ce={}));var Re;(function(Le){function Te(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(Te);if(typeof Ee=="string")return Ee;{const _=Ee;return{language:_.language,scheme:_.scheme,pattern:ce.from(_.pattern),exclusive:_.exclusive,notebookType:_.notebookType}}}else return}Le.from=Te})(Re||(e.LanguageSelector=Re={}));var Ke;(function(Le){function Te(_){return!!_&&typeof _=="object"&&"documents"in _&&Array.isArray(_.documents)&&_.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(He=>He&&typeof He=="object"&&"uri"in He&&h.URI.isUri(He.uri)&&"version"in He&&typeof He.version=="number"&&"ranges"in He&&Array.isArray(He.ranges)&&He.ranges.every(_e=>_e instanceof s.$5M)))}Le.is=Te;function Ee(_){return{documents:_.documents.map(Fe=>Fe.map(He=>({uri:h.URI.from(He.uri),version:He.version,ranges:He.ranges.map(_e=>f.from(_e))})))}}Le.from=Ee})(Ke||(e.MappedEditsContext=Ke={}));var Me;(function(Le){function Te(_){return{start:_.start,end:_.end}}Le.from=Te;function Ee(_){return new s.$sO(_.start,_.end)}Le.to=Ee})(Me||(e.NotebookRange=Me={}));var it;(function(Le){function Te(_){return{timing:typeof _.runStartTime=="number"&&typeof _.runEndTime=="number"?{startTime:_.runStartTime,endTime:_.runEndTime}:void 0,executionOrder:_.executionOrder,success:_.lastRunSuccess}}Le.to=Te;function Ee(_){return{lastRunSuccess:_.success,runStartTime:_.timing?.startTime,runEndTime:_.timing?.endTime,executionOrder:_.executionOrder}}Le.from=Ee})(it||(e.NotebookCellExecutionSummary=it={}));var lt;(function(Le){function Te(Ee){if(Ee===t.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Ee===t.NotebookCellExecutionState.Pending)return;if(Ee===t.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Le.to=Te})(lt||(e.NotebookCellExecutionState=lt={}));var bt;(function(Le){function Te(_){switch(_){case s.NotebookCellKind.Markup:return t.CellKind.Markup;case s.NotebookCellKind.Code:default:return t.CellKind.Code}}Le.from=Te;function Ee(_){switch(_){case t.CellKind.Markup:return s.NotebookCellKind.Markup;case t.CellKind.Code:default:return s.NotebookCellKind.Code}}Le.to=Ee})(bt||(e.NotebookCellKind=bt={}));var Ot;(function(Le){function Te(_){const Fe={metadata:_.metadata??Object.create(null),cells:[]};for(const He of _.cells)s.$tO.validate(He),Fe.cells.push(Rt.from(He));return Fe}Le.from=Te;function Ee(_){const Fe=new s.$uO(_.cells.map(Rt.to));return(0,w.$ig)(_.metadata)||(Fe.metadata=_.metadata),Fe}Le.to=Ee})(Ot||(e.NotebookData=Ot={}));var Rt;(function(Le){function Te(_){return{cellKind:bt.from(_.kind),language:_.languageId,mime:_.mime,source:_.value,metadata:_.metadata,internalMetadata:it.from(_.executionSummary??{}),outputs:_.outputs?_.outputs.map(Zt.from):[]}}Le.from=Te;function Ee(_){return new s.$tO(bt.to(_.cellKind),_.source,_.language,_.mime,_.outputs?_.outputs.map(Zt.to):void 0,_.metadata,_.internalMetadata?it.to(_.internalMetadata):void 0)}Le.to=Ee})(Rt||(e.NotebookCellData=Rt={}));var sn;(function(Le){function Te(_){return{mime:_.mime,valueBytes:N.$Fe.wrap(_.data)}}Le.from=Te;function Ee(_){return new s.$vO(_.valueBytes.buffer,_.mime)}Le.to=Ee})(sn||(e.NotebookCellOutputItem=sn={}));var Zt;(function(Le){function Te(_){return{outputId:_.id,items:_.items.map(sn.from),metadata:_.metadata}}Le.from=Te;function Ee(_){const Fe=_.items.map(sn.to);return new s.$wO(Fe,_.outputId,_.metadata)}Le.to=Ee})(Zt||(e.NotebookCellOutput=Zt={}));var Dt;(function(Le){function Te(Fe){return _(Fe)?{include:ce.from(Fe.include)??void 0,exclude:ce.from(Fe.exclude)??void 0}:ce.from(Fe)??void 0}Le.from=Te;function Ee(Fe){return _(Fe)?{include:ce.to(Fe.include),exclude:ce.to(Fe.exclude)}:ce.to(Fe)}Le.to=Ee;function _(Fe){const He=Fe;return He?!(0,w.$eg)(He.include)&&!(0,w.$eg)(He.exclude):!1}})(Dt||(e.NotebookExclusiveDocumentPattern=Dt={}));var Xt;(function(Le){function Te(Ee,_,Fe){const He=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:_.toInternal(He,Fe),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Le.from=Te})(Xt||(e.NotebookStatusBarItem=Xt={}));var xt;(function(Le){function Te(Ee,_,Fe){const He=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:_.toInternal(He,Fe),label:Ee.label,description:Ee.description,detail:Ee.detail,documentation:Ee.documentation}}Le.from=Te})(xt||(e.NotebookKernelSourceAction=xt={}));var et;(function(Le){function Te(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Le.from=Te})(et||(e.NotebookDocumentContentOptions=et={}));var on;(function(Le){function Te(_){return{uri:_.uri,provides:_.provides}}Le.from=Te;function Ee(_){return new s.$yO(h.URI.revive(_.uri),_.provides)}Le.to=Ee})(on||(e.NotebookRendererScript=on={}));var qt;(function(Le){function Te(_){return{message:B.fromStrict(_.message)||"",type:0,expected:_.expectedOutput,actual:_.actualOutput,contextValue:_.contextValue,location:_.location&&{range:f.from(_.location.range),uri:_.location.uri}}}Le.from=Te;function Ee(_){const Fe=new s.$EO(typeof _.message=="string"?_.message:B.to(_.message));return Fe.actualOutput=_.actual,Fe.expectedOutput=_.expected,Fe.contextValue=_.contextValue,Fe.location=_.location?re.to(_.location):void 0,Fe}Le.to=Ee})(qt||(e.TestMessage=qt={}));var dt;(function(Le){Le.namespace=r.$RL,Le.denamespace=r.$SL})(dt||(e.TestTag=dt={}));var wt;(function(Le){function Te(_){const Fe=(0,i.$kP)(_).controllerId;return{extId:l.$ML.fromExtHostTestItem(_,Fe).toString(),label:_.label,uri:h.URI.revive(_.uri),busy:_.busy,tags:_.tags.map(He=>dt.namespace(Fe,He.id)),range:g.$tt.lift(f.from(_.range)),description:_.description||null,sortText:_.sortText||null,error:_.error&&B.fromStrict(_.error)||null}}Le.from=Te;function Ee(_){return{parent:void 0,error:void 0,id:l.$ML.fromString(_.extId).localId,label:_.label,uri:h.URI.revive(_.uri),tags:(_.tags||[]).map(Fe=>{const{tagId:He}=dt.denamespace(Fe);return new s.$FO(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:f.to(_.range||void 0),canResolveChildren:!1,busy:_.busy,description:_.description||void 0,sortText:_.sortText||void 0}}Le.toPlain=Ee})(wt||(e.TestItem=wt={})),function(Le){function Te(_){return{id:_.id}}Le.from=Te;function Ee(_){return new s.$FO(_.id)}Le.to=Ee}(dt||(e.TestTag=dt={}));var en;(function(Le){const Te=(_,Fe)=>{const He=_.value;if(!He)return;const _e={...wt.toPlain(He.item),parent:Fe,taskStates:He.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(ht=>ht.type===0).map(qt.to)})),children:[]};if(_.children)for(const Qe of _.children.values()){const ht=Te(Qe,_e);ht&&_e.children.push(ht)}return _e};function Ee(_){const Fe=new $.$dP;for(const Qe of _.items)Fe.insert(l.$ML.fromString(Qe.item.extId).path,Qe);const He=[Fe.nodes],_e=[];for(;He.length;)for(const Qe of He.pop())Qe.value?_e.push(Qe):Qe.children&&He.push(Qe.children.values());return{completedAt:_.completedAt,results:_e.map(Qe=>Te(Qe)).filter(w.$dg)}}Le.to=Ee})(en||(e.TestResults=en={}));var Jt;(function(Le){function Te(He){return{covered:He.covered,total:He.total}}function Ee(He){return"line"in He?k.from(He):f.from(He)}function _(He){if(typeof He.executed=="number"&&He.executed<0)throw new Error(`Invalid coverage count ${He.executed}`);return"branches"in He?{count:He.executed,location:Ee(He.location),type:1,branches:He.branches.length?He.branches.map(_e=>({count:_e.executed,location:_e.location&&Ee(_e.location),label:_e.label})):void 0}:{type:0,name:He.name,count:He.executed,location:Ee(He.location)}}Le.fromDetails=_;function Fe(He,_e){return s.$HO(_e.statementCoverage),s.$HO(_e.branchCoverage),s.$HO(_e.declarationCoverage),{id:He,uri:_e.uri,statement:Te(_e.statementCoverage),branch:_e.branchCoverage&&Te(_e.branchCoverage),declaration:_e.declarationCoverage&&Te(_e.declarationCoverage)}}Le.fromFile=Fe})(Jt||(e.TestCoverage=Jt={}));var Ft;(function(Le){function Te(Ee){switch(Ee){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Le.to=Te})(Ft||(e.CodeActionTriggerKind=Ft={}));var gt;(function(Le){function Te(_){const Fe=new s.$MO(ve.to(_.kind),_.name,_.detail||"",h.URI.revive(_.uri),f.to(_.range),f.to(_.selectionRange));return Fe._sessionId=_._sessionId,Fe._itemId=_._itemId,Fe}Le.to=Te;function Ee(_,Fe,He){if(Fe=Fe??_._sessionId,He=He??_._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,kind:ve.from(_.kind),name:_.name,detail:_.detail??"",uri:_.uri,range:f.from(_.range),selectionRange:f.from(_.selectionRange),tags:_.tags?.map(te.from)}}Le.from=Ee})(gt||(e.TypeHierarchyItem=gt={}));var Bt;(function(Le){function Te(Ee){if(Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Le.from=Te})(Bt||(e.ViewBadge=Bt={}));var Ht;(function(Le){function Te(He,_e,Qe){const ht=_e.fileData;return ht?new s.$TN(new s.$UN(ht.name,h.URI.revive(ht.uri),ht.id,(0,R.$db)(()=>Qe(ht.id)))):He===A.$Ps.uriList&&_e.uriListData?new s.$SN(Fe(_e.uriListData)):new s.$SN(_e.asString)}Le.to=Te;async function Ee(He,_e){const Qe=await _e.asString();if(He===A.$Ps.uriList)return{asString:Qe,fileData:void 0,uriListData:_(Qe)};const ht=_e.asFile();return{asString:Qe,fileData:ht?{name:ht.name,uri:ht.uri,id:ht._itemId??ht.id}:void 0}}Le.from=Ee;function _(He){return L.$Tt.split(He).map(_e=>{if(_e.startsWith("#"))return _e;try{return h.URI.parse(_e)}catch{}return _e})}function Fe(He){return L.$Tt.create(He.map(_e=>typeof _e=="string"?_e:h.URI.revive(_e)))}})(Ht||(e.DataTransferItem=Ht={}));var Gt;(function(Le){function Te(_,Fe){const He=_.items.map(([_e,Qe])=>[_e,Ht.to(_e,Qe,Fe)]);return new s.$VN(He)}Le.toDataTransfer=Te;async function Ee(_){const Fe={items:[]},He=[];for(const[_e,Qe]of _)He.push((async()=>{Fe.items.push([_e,await Ht.from(_e,Qe)])})());return await Promise.all(He),Fe}Le.from=Ee})(Gt||(e.DataTransfer=Gt={}));var xe;(function(Le){function Te(_,Fe){return{kind:"reply",agentId:_.participant??Fe?.agentId??"",subCommand:_.command??Fe?.command,message:_.prompt,title:_.label}}Le.from=Te;function Ee(_){return{prompt:_.message,label:_.title,participant:_.agentId,command:_.subCommand}}Le.to=Ee})(xe||(e.ChatFollowup=xe={}));var dn;(function(Le){function Te(Ee){return"commandId"in Ee?{kind:"command",title:Ee.title??"",commandId:Ee.commandId??"",when:Ee.when??"",args:Ee.args}:{kind:"reply",message:Ee.message,title:Ee.title,tooltip:Ee.tooltip}}Le.from=Te})(dn||(e.ChatInlineFollowup=dn={}));var Qt;(function(Le){function Te(_){switch(_.role){case 0:return new s.$$O(_.content);case 1:return new s.$_O(_.content);case 2:return new s.$aP(_.content)}}Le.to=Te;function Ee(_){if(_ instanceof s.$$O)return{role:0,content:_.content};if(_ instanceof s.$_O)return{role:1,content:_.content};if(_ instanceof s.$aP)return{role:2,content:_.content};throw new Error("Invalid LanguageModelMessage")}Le.from=Ee})(Qt||(e.LanguageModelMessage=Qt={}));var zt;(function(Le){function Te(Fe){const He={};for(const _e of Object.keys(Fe))He[_e]=Fe[_e].map(Le.to);return He}Le.objectTo=Te;function Ee(Fe){return{level:mt.to(Fe.level),kind:Fe.kind,value:(0,h.$wc)(Fe.value)?h.URI.revive(Fe.value):Fe.value,description:Fe.description}}Le.to=Ee;function _(Fe){return{level:mt.from(Fe.level),kind:Fe.kind,value:Fe.value,description:Fe.description}}Le.from=_})(zt||(e.ChatVariable=zt={}));var mt;(function(Le){function Te(_){switch(_){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Le.to=Te;function Ee(_){switch(_){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Le.from=Ee})(mt||(e.ChatVariableLevel=mt={}));var Ut;(function(Le){function Te(Ee){switch(Ee){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Le.to=Te})(Ut||(e.InteractiveEditorResponseFeedbackKind=Ut={}));var It;(function(Le){function Te(_){return{kind:"markdownContent",content:B.from(_.value)}}Le.from=Te;function Ee(_){return new s.$ZO(B.to(_.content))}Le.to=Ee})(It||(e.ChatResponseMarkdownPart=It={}));var Tt;(function(Le){function Te(_){return{kind:"markdownVuln",content:B.from(_.value),vulnerabilities:_.vulnerabilities}}Le.from=Te;function Ee(_){return new s.$1O(B.to(_.content),_.vulnerabilities)}Le.to=Ee})(Tt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Tt={}));var tn;(function(Le){function Te(_){return{kind:"agentDetection",agentId:_.participant,command:_.command}}Le.from=Te;function Ee(_){return new s.$2O(_.agentId,_.command)}Le.to=Ee})(tn||(e.ChatResponseDetectedParticipantPart=tn={}));var Wt;(function(Le){function Te(_){const{value:Fe,baseUri:He}=_;function _e(Qe,ht){return Qe.map(Et=>{const jt=h.URI.joinPath(ht,Et.name);return{label:Et.name,uri:jt,children:Et.children&&_e(Et.children,jt)}})}return{kind:"treeData",treeData:{label:(0,y.$6g)(He),uri:He,children:_e(Fe,He)}}}Le.from=Te;function Ee(_){const Fe=(0,E.$5h)(_.treeData);function He(ht){return ht.map(Et=>({name:Et.label,children:Et.children&&He(Et.children)}))}const _e=Fe.uri,Qe=Fe.children?He(Fe.children):[];return new s.$3O(Qe,_e)}Le.to=Ee})(Wt||(e.ChatResponseFilesPart=Wt={}));var nn;(function(Le){function Te(_){return{kind:"inlineReference",name:_.title,inlineReference:h.URI.isUri(_.value)?_.value:S.from(_.value)}}Le.from=Te;function Ee(_){const Fe=(0,E.$5h)(_);return new s.$4O(h.URI.isUri(Fe.inlineReference)?Fe.inlineReference:S.to(Fe.inlineReference),_.name)}Le.to=Ee})(nn||(e.ChatResponseAnchorPart=nn={}));var Mt;(function(Le){function Te(_){return{kind:"progressMessage",content:B.from(_.value)}}Le.from=Te;function Ee(_){return new s.$5O(_.content.value)}Le.to=Ee})(Mt||(e.ChatResponseProgressPart=Mt={}));var Lt;(function(Le){function Te(_,Fe,He){return{kind:"command",command:Fe.toInternal(_.value,He)??{command:_.value.command,title:_.value.title}}}Le.from=Te;function Ee(_,Fe){return new s.$6O(Fe.fromInternal(_.command)??{command:_.command.id,title:_.command.title})}Le.to=Ee})(Lt||(e.ChatResponseCommandButtonPart=Lt={}));var Nt;(function(Le){function Te(_){return{kind:"textEdit",uri:_.uri,edits:_.edits.map(Fe=>me.from(Fe))}}Le.from=Te;function Ee(_){return new s.$8O(h.URI.revive(_.uri),_.edits.map(Fe=>me.to(Fe)))}Le.to=Ee})(Nt||(e.ChatResponseTextEditPart=Nt={}));var Ct;(function(Le){function Te(_){return"variableName"in _.value?{kind:"reference",reference:{variableName:_.value.variableName,value:h.URI.isUri(_.value.value)||!_.value.value?_.value.value:S.from(_.value.value)}}:{kind:"reference",reference:h.URI.isUri(_.value)?_.value:S.from(_.value)}}Le.from=Te;function Ee(_){const Fe=(0,E.$5h)(_),He=_e=>h.URI.isUri(_e)?_e:S.to(_e);return new s.$7O("variableName"in Fe.reference?{variableName:Fe.reference.variableName,value:Fe.reference.value&&He(Fe.reference.value)}:He(Fe.reference))}Le.to=Ee})(Ct||(e.ChatResponseReferencePart=Ct={}));var $t;(function(Le){function Te(Fe,He,_e){return Fe instanceof s.$ZO?It.from(Fe):Fe instanceof s.$4O?nn.from(Fe):Fe instanceof s.$7O?Ct.from(Fe):Fe instanceof s.$5O?Mt.from(Fe):Fe instanceof s.$3O?Wt.from(Fe):Fe instanceof s.$6O?Lt.from(Fe,He,_e):Fe instanceof s.$8O?Nt.from(Fe):Fe instanceof s.$1O?Tt.from(Fe):Fe instanceof s.$2O?tn.from(Fe):{kind:"markdownContent",content:B.from("")}}Le.from=Te;function Ee(Fe,He){switch(Fe.kind){case"reference":return Ct.to(Fe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return _(Fe,He)}}Le.to=Ee;function _(Fe,He){switch(Fe.kind){case"markdownContent":return It.to(Fe);case"inlineReference":return nn.to(Fe);case"progressMessage":return;case"treeData":return Wt.to(Fe);case"command":return Lt.to(Fe,He)}}Le.toContent=_})($t||(e.ChatResponsePart=$t={}));var kt;(function(Le){function Te(Ee){return{prompt:Ee.message,command:Ee.command,attempt:Ee.attempt??0,enableCommandDetection:Ee.enableCommandDetection??!0,variables:Ee.variables.variables.map(Pt.to),location:rn.to(Ee.location)}}Le.to=Te})(kt||(e.ChatAgentRequest=kt={}));var rn;(function(Le){function Te(Ee){switch(Ee){case o.ChatAgentLocation.Notebook:return s.ChatLocation.Notebook;case o.ChatAgentLocation.Terminal:return s.ChatLocation.Terminal;case o.ChatAgentLocation.Panel:return s.ChatLocation.Panel;case o.ChatAgentLocation.Editor:return s.ChatLocation.Editor}}Le.to=Te})(rn||(e.ChatLocation=rn={}));var Pt;(function(Le){function Te(Ee){return{name:Ee.name,range:Ee.range&&[Ee.range.start,Ee.range.endExclusive],values:Ee.values.map(zt.to)}}Le.to=Te})(Pt||(e.ChatAgentResolvedVariable=Pt={}));var mn;(function(Le){function Te(Ee,_,Fe){return{label:Ee.label,values:Ee.values.map(zt.from),insertText:Ee.insertText,detail:Ee.detail,documentation:Ee.documentation,command:_.toInternal(Ee.command,Fe)}}Le.from=Te})(mn||(e.ChatAgentCompletionItem=mn={}));var _t;(function(Le){function Te(Ee){return{errorDetails:Ee.errorDetails,metadata:Ee.metadata}}Le.to=Te})(_t||(e.ChatAgentResult=_t={}));var wn;(function(Le){function Te(Ee,_,Fe){if(_.action.kind==="vote")return;const He=_t.to(Ee);if(_.action.kind==="command"){const _e=_.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Fe.fromInternal(_e)??{command:_e.id,title:_e.title}}},result:He}}else return _.action.kind==="followUp"?{action:{kind:"followUp",followup:xe.to(_.action.followup)},result:He}:_.action.kind==="inlineChat"?{action:{kind:"editor",accepted:_.action.action==="accepted"},result:He}:{action:_.action,result:He}}Le.to=Te})(wn||(e.ChatAgentUserActionEvent=wn={}));var un;(function(Le){function Te(Ee,_,Fe){return"terminalCommand"in Ee?{terminalCommand:Ee.terminalCommand,shouldExecute:Ee.shouldExecute}:"uri"in Ee?{uri:Ee.uri}:_.toInternal(Ee,Fe)}Le.from=Te})(un||(e.TerminalQuickFix=un={}));var vn;(function(Le){function Te(Ee){return{kind:St.to(Ee.kind)}}Le.to=Te})(vn||(e.PartialAcceptInfo=vn={}));var St;(function(Le){function Te(Ee){switch(Ee){case 0:return s.PartialAcceptTriggerKind.Word;case 1:return s.PartialAcceptTriggerKind.Line;case 2:return s.PartialAcceptTriggerKind.Suggest;default:return s.PartialAcceptTriggerKind.Unknown}}Le.to=Te})(St||(e.PartialAcceptTriggerKind=St={}));var Dn;(function(Le){function Te(Ee,_){return{id:_,label:Ee.label,description:Ee.description,canEdit:Ee.canEdit,collapsibleState:Ee.collapsibleState||0,contextValue:Ee.contextValue}}Le.from=Te})(Dn||(e.DebugTreeItem=Dn={}))}),define(ke[333],Pe([1,0,6,20,16,48]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=void 0;let M=class{constructor(m,E){this.a=m.getProxy(d.$1M.MainThreadBulkEdits),this.b={getTextDocumentVersion:A=>E.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,E,A){const D=new R.$uw(L.WorkspaceEdit.from(m,this.b));return this.a.$tryApplyWorkspaceEdit(D,void 0,A?.isRefactoring??!1)}};e.$clc=M,e.$clc=M=Je([Ve(0,N.$oP)],M)}),define(ke[334],Pe([1,0,19,7,47,4,39,3,40,18,2,25,6,16,8,297,26]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlc=void 0;class a{constructor(o,t,l,r,c){this.j=o,this.k=t,this.l=l,this.m=r,this.n=c,this.b=m.$ae.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(r){if(o.c){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,r),c}};const o=this;this.b.reset();const l=r=>{typeof this.d>"u"&&"content"in r&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,r)};this.g={markdown(r){t(this.markdown);const c=new w.$ZO(r),s=y.ChatResponseMarkdownPart.from(c);return l(s),this},markdownWithVulnerabilities(r,c){t(this.markdown),c&&(0,g.$GG)(o.j,"chatParticipantAdditions");const s=new w.$1O(r,c),v=y.ChatResponseMarkdownWithVulnerabilitiesPart.from(s);return l(v),this},filetree(r,c){t(this.filetree);const s=new w.$3O(r,c),v=y.ChatResponseFilesPart.from(s);return l(v),this},anchor(r,c){t(this.anchor);const s=new w.$4O(r,c),v=y.ChatResponseAnchorPart.from(s);return l(v),this},button(r){t(this.anchor);const c=new w.$6O(r),s=y.ChatResponseCommandButtonPart.from(c,o.m,o.n);return l(s),this},progress(r){t(this.progress);const c=new w.$5O(r),s=y.ChatResponseProgressPart.from(c);return l(s),this},reference(r){if(t(this.reference),"variableName"in r&&!r.value){const c=o.k.variables.variables.find(s=>s.name===r.variableName);if(c){let s;if(c.references?.length)s=c.references.map(v=>({kind:"reference",reference:{variableName:r.variableName,value:v.reference}}));else{const v=new w.$7O(r);s=[y.ChatResponseReferencePart.from(v)]}return s.forEach(v=>l(v)),this}}else{const c=new w.$7O(r),s=y.ChatResponseReferencePart.from(c);l(s)}return this},textEdit(r,c){t(this.textEdit),(0,g.$GG)(o.j,"chatParticipantAdditions");const s=new w.$8O(r,c),v=y.ChatResponseTextEditPart.from(s);return l(v),this},detectedParticipant(r,c){t(this.detectedParticipant),(0,g.$GG)(o.j,"chatParticipantAdditions");const s=new w.$2O(r,c),v=y.ChatResponseDetectedParticipantPart.from(s);return l(v),this},push(r){if(t(this.push),(r instanceof w.$8O||r instanceof w.$1O||r instanceof w.$2O)&&(0,g.$GG)(o.j,"chatParticipantAdditions"),r instanceof w.$7O)this.reference(r.value);else{const c=y.ChatResponsePart.from(r,o.m,o.n);l(c)}return this}}}return this.g}}class n extends b.$Vc{static{this.b=0}constructor(o,t,l){super(),this.n=t,this.s=l,this.c=new Map,this.j=this.B(new b.$5c),this.m=this.B(new b.$Uc),this.g=o.getProxy($.$1M.MainThreadChatAgents2)}transferActiveChat(o){this.g.$transferActiveChatSession(o)}createChatAgent(o,t,l){const r=n.b++,c=new i(o,t,this.g,r,l);return this.c.set(r,c),this.g.$registerAgent(r,o.identifier,t,{},void 0),c.apiAgent}createDynamicChatAgent(o,t,l,r,c){const s=n.b++,v=new i(o,t,this.g,s,c);return this.c.set(s,v),this.g.$registerAgent(s,o.identifier,t,{isSticky:!0},{name:l,description:r}),v.apiAgent}async $invokeAgent(o,t,l,r){const c=this.c.get(o);if(!c)throw new Error(`[CHAT](${o}) CANNOT invoke agent because the agent is not registered`);let s=this.j.get(t.sessionId);s||(s=new b.$Uc,this.j.set(t.sessionId,s));const v=new a(c.extension,t,this.g,this.s.converter,s);try{const f=await this.t(t.agentId,l),S=c.invoke(y.ChatAgentRequest.to(t),{history:f},v.apiObject,r);return await(0,N.$jh)(Promise.resolve(S).then(p=>{if(p?.metadata)try{JSON.stringify(p.metadata)}catch(k){const P=`result.metadata MUST be JSON.stringify-able. Got error: ${k.message}`;return this.n.error(`[${c.extension.identifier.value}] [@${c.id}] ${P}`,c.extension),{errorDetails:{message:P},timings:v.timings}}return{errorDetails:p?.errorDetails,timings:v.timings,metadata:p?.metadata}}),r)}catch(f){return this.n.error(f,c.extension),{errorDetails:{message:(0,L.$gj)(f),responseIsIncomplete:!0}}}finally{v.close()}}async t(o,t){const l=[];for(const r of t.history){const c=y.ChatAgentResult.to(r.result),s=o===r.request.agentId?c:{...c,metadata:void 0};l.push(new w.$9O(r.request.message,r.request.command,r.request.variables.variables.map(y.ChatAgentResolvedVariable.to),r.request.agentId));const v=(0,d.$Hb)(r.response.map(f=>y.ChatResponsePart.toContent(f,this.s.converter)));l.push(new w.$0O(v,s,r.request.agentId,r.request.command))}return l}$releaseSession(o){this.j.deleteAndDispose(o)}async $provideFollowups(o,t,l,r,c){const s=this.c.get(t);if(!s)return Promise.resolve([]);const v=await this.t(s.id,r),f=y.ChatAgentResult.to(l);return(await s.provideFollowups(f,{history:v},c)).filter(S=>{const p=!S.participant||M.Iterable.some(this.c.values(),k=>k.id===S.participant&&D.$Qm.equals(k.extension.identifier,s.extension.identifier));return p||this.n.warn(`[@${s.id}] ChatFollowup refers to an unknown participant: ${S.participant}`),p}).map(S=>y.ChatFollowup.from(S,o))}$acceptFeedback(o,t,l,r){const c=this.c.get(o);if(!c)return;const s=y.ChatAgentResult.to(t);let v;switch(l){case h.InteractiveSessionVoteDirection.Down:v=w.ChatResultFeedbackKind.Unhelpful;break;case h.InteractiveSessionVoteDirection.Up:v=w.ChatResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(r?{result:s,kind:v,reportIssue:r}:{result:s,kind:v}))}$acceptAction(o,t,l){const r=this.c.get(o);if(!r||l.action.kind==="vote")return;const c=y.ChatAgentUserActionEvent.to(t,l,this.s.converter);c&&r.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(o,t,l){const r=this.c.get(o);return r?(await r.invokeCompletionProvider(t,l)).map(s=>y.ChatAgentCompletionItem.from(s,this.s.converter,this.m)):[]}async $provideWelcomeMessage(o,t,l){const r=this.c.get(o);if(r)return await r.provideWelcomeMessage(y.ChatLocation.to(t),l)}async $provideSampleQuestions(o,t,l){const r=this.c.get(o);if(r)return(await r.provideSampleQuestions(y.ChatLocation.to(t),l)).map(c=>y.ChatFollowup.from(c,void 0))}}e.$dlc=n;class i{constructor(o,t,l,r,c){this.extension=o,this.id=t,this.u=l,this.w=r,this.x=c,this.n=new R.$ee,this.o=new R.$ee}acceptFeedback(o){this.n.fire(o)}acceptAction(o){this.o.fire(o)}async invokeCompletionProvider(o,t){return this.q?await this.q.provider.provideCompletionItems(o,t)??[]:[]}async provideFollowups(o,t,l){if(!this.b)return[];const r=await this.b.provideFollowups(o,t,l);return r?r.filter(c=>!(c&&"commandId"in c)).filter(c=>!(c&&"message"in c)):[]}async provideWelcomeMessage(o,t){if(!this.s)return[];const l=await this.s.provideWelcomeMessage(o,t);return l?l.map(r=>typeof r=="string"?r:y.MarkdownString.from(r)):[]}async provideSampleQuestions(o,t){if(!this.s||!this.s.provideSampleQuestions)return[];const l=await this.s.provideSampleQuestions(o,t);return l||[]}get apiAgent(){let o=!1,t=!1;const l=()=>{o||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof A.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof w.$ZN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:y.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:y.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:y.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),t=!1}))},r=this;return{get id(){return r.id},get fullName(){return(0,g.$GG)(r.extension,"defaultChatParticipant"),r.c??r.extension.displayName??r.extension.name},set fullName(c){(0,g.$GG)(r.extension,"defaultChatParticipant"),r.c=c,l()},get iconPath(){return r.d},set iconPath(c){r.d=c,l()},get requestHandler(){return r.x},set requestHandler(c){(0,E.$fg)(typeof c=="function","Invalid request handler"),r.x=c},get followupProvider(){return r.b},set followupProvider(c){r.b=c,l()},get isDefault(){return(0,g.$GG)(r.extension,"defaultChatParticipant"),r.g},set isDefault(c){(0,g.$GG)(r.extension,"defaultChatParticipant"),r.g=c,l()},get helpTextPrefix(){return(0,g.$GG)(r.extension,"defaultChatParticipant"),r.j},set helpTextPrefix(c){(0,g.$GG)(r.extension,"defaultChatParticipant"),r.j=c,l()},get helpTextVariablesPrefix(){return(0,g.$GG)(r.extension,"defaultChatParticipant"),r.k},set helpTextVariablesPrefix(c){(0,g.$GG)(r.extension,"defaultChatParticipant"),r.k=c,l()},get helpTextPostfix(){return(0,g.$GG)(r.extension,"defaultChatParticipant"),r.l},set helpTextPostfix(c){(0,g.$GG)(r.extension,"defaultChatParticipant"),r.l=c,l()},get isSecondary(){return(0,g.$GG)(r.extension,"defaultChatParticipant"),r.m},set isSecondary(c){(0,g.$GG)(r.extension,"defaultChatParticipant"),r.m=c,l()},get supportIssueReporting(){return(0,g.$GG)(r.extension,"chatParticipantAdditions"),r.p},set supportIssueReporting(c){(0,g.$GG)(r.extension,"chatParticipantAdditions"),r.p=c,l()},get onDidReceiveFeedback(){return r.n.event},set participantVariableProvider(c){if((0,g.$GG)(r.extension,"chatParticipantAdditions"),r.q=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");r.u.$registerAgentCompletionsProvider(r.w,c.triggerCharacters)}else r.u.$unregisterAgentCompletionsProvider(r.w)},get participantVariableProvider(){return(0,g.$GG)(r.extension,"chatParticipantAdditions"),r.q},set welcomeMessageProvider(c){(0,g.$GG)(r.extension,"defaultChatParticipant"),r.s=c,l()},get welcomeMessageProvider(){return(0,g.$GG)(r.extension,"defaultChatParticipant"),r.s},onDidPerformAction:(0,g.$FG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(c){r.t=c,l()},get requester(){return r.t},dispose(){o=!0,r.b=void 0,r.n.dispose(),r.u.$unregisterAgent(r.w)}}}invoke(o,t,l,r){return this.x(o,t,l,r)}}}),define(ke[335],Pe([1,0,13,3,6,16,8,26]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=void 0;class m{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(L.$1M.MainThreadChatVariables)}async $resolveVariable(D,$,y,w){const h=this.b.get(D);if(h)try{if(h.resolver.resolve2){(0,b.$GG)(h.extension,"chatParticipantAdditions");const g=new E($,this.c),a=await h.resolver.resolve2(h.data.name,{prompt:y},g.apiObject,w);if(a)return a.map(R.ChatVariable.from)}else{const g=await h.resolver.resolve(h.data.name,{prompt:y},w);if(g)return g.map(R.ChatVariable.from)}}catch(g){(0,d.$2)(g)}}registerVariableResolver(D,$,y,w){const h=m.a++;return this.b.set(h,{extension:D,data:{name:$,description:y},resolver:w}),this.c.$registerVariable(h,{name:$,description:y}),(0,N.$Tc)(()=>{this.b.delete(h),this.c.$unregisterVariable(h)})}}e.$elc=m;class E{constructor(D,$){this.c=D,this.d=$,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let $=function(w){if(D.a){const h=new Error("Response stream has been closed");throw Error.captureStackTrace(h,w),h}};const D=this,y=w=>{this.d.$handleProgressChunk(this.c,w)};this.b={progress(w){$(this.progress);const h=new M.$5O(w),g=R.ChatResponseProgressPart.from(h);return y(g),this},reference(w){$(this.reference);const h=new M.$7O(w),g=R.ChatResponseReferencePart.from(h);return y(g),this},push(w){return $(this.push),w instanceof M.$7O?y(R.ChatResponseReferencePart.from(w)):w instanceof M.$5O&&y(R.ChatResponseProgressPart.from(w)),this}}}return this.b}}}),define(ke[336],Pe([1,0,7,55,4,3,2,84,25,16,8,6,26]),function(le,e,d,N,L,R,M,b,m,E,A,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=y;function y(w,h,g){const a=w.getProxy(D.$1M.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new m.$Sm,h.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const S=this.b.get(f.handle);return S?S.value:f}else if(f&&f.$mid===7){const S=f,p=this.b.get(S.commentControlHandle);if(!p)return S;const k=p.getCommentThread(S.commentThreadHandle);return k?k.value:S}else if(f&&(f.$mid===9||f.$mid===8)){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const p=S.getCommentThread(f.thread.commentThreadHandle);return p?f.$mid===8?p.value:{thread:p.value,text:f.text}:f}else if(f&&f.$mid===10){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const p=S.getCommentThread(f.thread.commentThreadHandle);if(!p)return f;const k=f.commentUniqueId,P=p.getCommentByUniqueId(k);return P||f}else if(f&&f.$mid===11){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const p=S.getCommentThread(f.thread.commentThreadHandle);if(!p)return f;const k=f.text,P=f.commentUniqueId,C=p.getCommentByUniqueId(P);return C?(typeof C.body=="string"?C.body=k:C.body=new A.$sN(k),C):f}return f}})}createCommentController(f,S,p){const k=n.a++,P=new u(f,k,S,p);this.b.set(P.handle,P);const C=this.c.get(f.identifier)||[];return C.push(P),this.c.set(f.identifier,C),P.value}async $createCommentThreadTemplate(f,S,p){const k=this.b.get(f);k&&k.$createCommentThreadTemplate(S,p)}async $setActiveComment(f,S){const p=this.b.get(f);p&&p.$setActiveComment(S??void 0)}async $updateCommentThreadTemplate(f,S,p){const k=this.b.get(f);k&&k.$updateCommentThreadTemplate(S,p)}$deleteCommentThread(f,S){this.b.get(f)?.$deleteCommentThread(S)}async $provideCommentingRanges(f,S,p){const k=this.b.get(f);if(!k||!k.commentingRangeProvider)return Promise.resolve(void 0);const P=await g.ensureDocumentData(M.URI.revive(S));return(0,d.$nh)(async()=>{const C=await k.commentingRangeProvider.provideCommentingRanges(P.document,p);let I;return Array.isArray(C)?I={ranges:C,fileComments:!1}:C?I={ranges:C.ranges||[],fileComments:C.fileComments||!1}:I=C??void 0,I}).then(C=>{let I;return C&&(I={ranges:C.ranges.map(T=>E.Range.from(T)),fileComments:C.fileComments}),I})}$toggleReaction(f,S,p,k,P){const C=this.b.get(f);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,d.$nh)(()=>{const I=C.getCommentThread(S);if(I){const T=I.getCommentByUniqueId(k.uniqueIdInThread);if(C!==void 0&&T&&C.reactionHandler)return C.reactionHandler(T,l(P))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,typeof f=="object"?((0,$.$GG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=f.resolved,this.b.applicability=f.applicability):this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,S,p,k,P,C,I,T){this.m=S,this.n=p,this.o=k,this.p=P,this.q=C,this.extensionDescription=I,this.r=T,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new L.$ee,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Wc,this.l.value=new R.$Uc,this.n===void 0&&(this.n=`${f}.${this.handle}`),a.$createCommentThread(S,this.handle,this.n,this.o,E.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{a.$deleteCommentThread(S,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(z){j.range=z},get comments(){return j.comments},set comments(z){j.comments=z},get collapsibleState(){return j.collapsibleState},set collapsibleState(z){j.collapsibleState=z},get canReply(){return j.canReply},set canReply(z){j.canReply=z},get contextValue(){return j.contextValue},set contextValue(z){j.contextValue=z},get label(){return j.label},set label(z){j.label=z},get state(){return j.state},set state(z){j.state=z},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Uc);const f=p=>Object.prototype.hasOwnProperty.call(this.b,p),S={};f("range")&&(S.range=E.Range.from(this.p)),f("label")&&(S.label=this.label),f("contextValue")&&(S.contextValue=this.contextValue??null),f("comments")&&(S.comments=this.q.map(p=>o(this,p,this.k,this.extensionDescription))),f("collapsibleState")&&(S.collapseState=r(this.g)),f("canReply")&&(S.canReply=this.canReply),f("state")&&(S.state=c(this.h)),f("applicability")&&(S.applicability=s(this.h)),f("isTemplate")&&(S.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(f){for(const S of this.k){const p=S[0],k=S[1];if(f===k)return p}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}Je([(0,N.$1h)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class u{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,f?.resourceHints&&(0,$.$GG)(this.h,"commentingRangeHint"),a.$updateCommentingRanges(this.handle,f?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,$.$GG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,$.$GG)(this.h,"activeComment"),this.f}constructor(f,S,p,k){this.h=f,this.i=S,this.j=p,this.k=k,this.a=new Map,a.$registerCommentController(this.handle,p,k,this.h.identifier.value);const P=this;this.value=Object.freeze({id:P.id,label:P.label,get options(){return P.options},set options(C){P.options=C},get commentingRangeProvider(){return P.commentingRangeProvider},set commentingRangeProvider(C){P.commentingRangeProvider=C},get reactionHandler(){return P.reactionHandler},set reactionHandler(C){P.reactionHandler=C},get activeCommentThread(){return P.activeCommentThread},createCommentThread(C,I,T){return P.createCommentThread(C,I,T).value},dispose:()=>{P.dispose()}}),this.g=[],this.g.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(f,S,p){S===void 0&&(0,$.$GG)(this.h,"fileComments");const k=new i(this.id,this.handle,void 0,f,S,p,this.h,!1);return this.a.set(k.handle,k),k}$setActiveComment(f){if(!f){this.e=void 0,this.f=void 0;return}const S=this.a.get(f.commentThreadHandle);S&&(this.e=f.uniqueIdInThread?S.getCommentByUniqueId(f.uniqueIdInThread):void 0,this.f=S)}$createCommentThreadTemplate(f,S){const p=new i(this.id,this.handle,void 0,M.URI.revive(f),E.Range.to(S),[],this.h,!0);return p.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(p.handle,p),p}$updateCommentThreadTemplate(f,S){const p=this.a.get(f);p&&(p.range=E.Range.to(S))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.g.forEach(f=>f.dispose())}}function o(v,f,S,p){let k=S.get(f);return k||(k=++v.commentHandle,S.set(f,k)),f.state!==void 0&&(0,$.$GG)(p,"commentsDraftState"),f.reactions?.some(P=>P.reactors!==void 0)&&(0,$.$GG)(p,"commentReactor"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:k,body:typeof f.body=="string"?f.body:E.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(P=>t(P)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function t(v){return{label:v.label,iconPath:v.iconPath?E.$nP(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted,reactors:v.reactors&&v.reactors.length>0&&typeof v.reactors[0]!="string"?v.reactors.map(f=>f.name):v.reactors}}function l(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?M.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1,reactors:v.reactors?.map(f=>({name:f}))}}function r(v){if(v!==void 0)switch(v){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function c(v){let f;if(typeof v=="object"?f=v.resolved:f=v,f!==void 0)switch(f){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function s(v){let f;if(typeof v=="object"&&(f=v.applicability),f!==void 0)switch(f){case A.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case A.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new n}}),define(ke[337],Pe([1,0,22,56,3,15,23,2,16,92,112,6,8]),function(le,e,d,N,L,R,M,b,m,E,A,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=void 0;class y{constructor(l,r){this.document=l,this.b=r,this.a=1,this.c=new A.$1kc("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,r){await this.f(l).undo(),r||this.disposeBackup()}async redo(l,r){await this.f(l).redo(),r||this.disposeBackup()}disposeEdits(l){for(const r of l)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=o(this.document.uri)+this.a++;return(0,M.$9g)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const r=this.c.get(l,0);if(!r)throw new Error("No edit found");return r}}class w{constructor(){this.a=new Map}get(l,r){return this.a.get(this.b(l,r))}add(l,r,c){const s=this.b(l,r.uri);if(this.a.has(s))throw new Error(`Document already exists for viewType:${l} resource:${r.uri}`);const v=new y(r,c);return this.a.set(s,v),v}delete(l,r){const c=this.b(l,r.uri);this.a.delete(c)}b(l,r){return`${l}@@@${r}`}}var h;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(h||(h={}));class g{constructor(){this.a=new Map}addTextProvider(l,r,c){return this.b(0,l,r,c)}addCustomProvider(l,r,c){return this.b(1,l,r,c)}get(l){return this.a.get(l)}b(l,r,c,s){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:l,extension:c,provider:s}),new $.$3M(()=>this.a.delete(r))}}class a{constructor(l,r,c,s,v){this.d=r,this.f=c,this.g=s,this.h=v,this.b=new g,this.c=new w,this.a=l.getProxy(D.$1M.MainThreadCustomEditors)}registerCustomEditorProvider(l,r,c,s){const v=new L.$Uc;return i(c)?(v.add(this.b.addTextProvider(r,l,c)),this.a.$registerTextEditorProvider((0,E.$xlc)(l),r,s.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,E.$vlc)(l))):(v.add(this.b.addCustomProvider(r,l,c)),n(c)&&v.add(c.onDidChangeCustomDocument(f=>{const S=this.i(r,f.document.uri);if(u(f)){const p=S.addEdit(f);this.a.$onDidEdit(f.document.uri,r,p,f.label)}else this.a.$onContentChange(f.document.uri,r)})),this.a.$registerCustomEditorProvider((0,E.$xlc)(l),r,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,E.$vlc)(l))),$.$3M.from(v,new $.$3M(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(l,r,c,s,v){const f=this.b.get(r);if(!f)throw new Error(`No provider found for '${r}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${r}'`);const S=b.URI.revive(l),p=await f.provider.openCustomDocument(S,{backupId:c,untitledDocumentData:s?.buffer},v);let k;return n(f.provider)&&this.f&&(k=this.f.workspaceValue(f.extension)??this.f.globalValue(f.extension)),this.c.add(r,p,k),{editable:n(f.provider)}}async $disposeCustomDocument(l,r){const c=this.b.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${r}'`);const s=b.URI.revive(l),{document:v}=this.i(r,s);this.c.delete(r,v),v.dispose()}async $resolveCustomEditor(l,r,c,s,v,f){const S=this.b.get(c);if(!S)throw new Error(`No provider found for '${c}'`);const p=m.ViewColumn.to(v),k=this.g.createNewWebview(r,s.contentOptions,S.extension),P=this.h.createNewWebviewPanel(r,c,s.title,p,s.options,k,s.active),C=b.URI.revive(l);switch(S.type){case 1:{const{document:I}=this.i(c,C);return S.provider.resolveCustomEditor(I,P,f)}case 0:{const I=this.d.getDocument(C);return S.provider.resolveCustomTextEditor(I,P,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,r,c){this.i(r,l).disposeEdits(c)}async $onMoveCustomEditor(l,r,c){const s=this.b.get(c);if(!s)throw new Error(`No provider found for '${c}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const v=this.h.getWebviewPanel(l);if(!v)throw new Error("No webview found");const f=b.URI.revive(r),S=this.d.getDocument(f);await s.provider.moveCustomTextEditor(S,v,d.CancellationToken.None)}async $undo(l,r,c,s){return this.i(r,l).undo(c,s)}async $redo(l,r,c,s){return this.i(r,l).redo(c,s)}async $revert(l,r,c){const s=this.i(r,l);await this.j(r).revertCustomDocument(s.document,c),s.disposeBackup()}async $onSave(l,r,c){const s=this.i(r,l);await this.j(r).saveCustomDocument(s.document,c),s.disposeBackup()}async $onSaveAs(l,r,c,s){const v=this.i(r,l);return this.j(r).saveCustomDocumentAs(v.document,b.URI.revive(c),s)}async $backup(l,r,c){const s=this.i(r,l),f=await this.j(r).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},c);return s.updateBackup(f),f.id}i(l,r){const c=this.c.get(l,b.URI.revive(r));if(!c)throw new Error("No custom document found");return c}j(l){const c=this.b.get(l)?.provider;if(!c||!n(c))throw new Error("Custom document is not editable");return c}}e.$Alc=a;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function u(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function o(t){const l=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,N.$jj)(l)+""}}),define(ke[338],Pe([1,0,224,139,2,6,8,16,4,11,27,60]),function(le,e,d,N,L,R,M,b,m,E,A,D){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$9kc=e.$8kc=void 0;class y{#e;#t;#n;constructor(g,a,n,i,u,o,t,l){this.d=g,this.e=a,this.f=n,this.g=i,this.h=u,this.c=!1,this.f=Math.max(i,n),this.#n=new A.$Bc(r=>o.getComparisonKey(r)),this.#e=t,this.#t=l}dispose(){this.c||(this.#t.fire([...this.#n.keys()]),this.#e?.$clear(this.e),this.#n.clear(),this.c=!0)}get name(){return this.j(),this.d}set(g,a){if(!g){this.clear();return}this.j();let n=[];if(L.URI.isUri(g)){if(!a){this.delete(g);return}this.#n.set(g,a.slice()),n=[g]}else if(Array.isArray(g)){n=[];let o;g=[...g].sort(y.k);for(const t of g){const[l,r]=t;if((!o||l.toString()!==o.toString())&&(o&&this.#n.get(o).length===0&&this.#n.delete(o),o=l,n.push(l),this.#n.set(l,[])),r)this.#n.get(l)?.push(...r);else{const c=this.#n.get(l);c&&(c.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let u=0;for(const o of n){let t=[];const l=this.#n.get(o);if(l)if(l.length>this.g){t=[];const r=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const s of l)if(s.severity===r[c]&&t.push({...b.Diagnostic.from(s),modelVersionId:this.h(o)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,d.localize)(0,null,l.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=l.map(r=>({...b.Diagnostic.from(r),modelVersionId:this.h(o)}));if(i.push([o,t]),u+=t.length,u>this.f)break}this.#e.$changeMany(this.e,i)}delete(g){this.j(),this.#t.fire([g]),this.#n.delete(g),this.#e?.$changeMany(this.e,[[g,void 0]])}clear(){this.j(),this.#t.fire([...this.#n.keys()]),this.#n.clear(),this.#e?.$clear(this.e)}forEach(g,a){this.j();for(const[n,i]of this)g.call(a,n,i,this)}*[Symbol.iterator](){this.j();for(const g of this.#n.keys())yield[g,this.get(g)]}get(g){this.j();const a=this.#n.get(g);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(g){return this.j(),Array.isArray(this.#n.get(g))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(g,a){return g[0].toString()<a[0].toString()?-1:g[0].toString()>a[0].toString()?1:0}}e.$8kc=y;let w=class{static{$=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*$.d}static _mapper(g){const a=new A.$Bc;for(const n of g)a.set(n,n);return{uris:Object.freeze(Array.from(a.values()))}}constructor(g,a,n,i){this.j=a,this.k=n,this.l=i,this.g=new Map,this.h=new m.$ie({merge:u=>u.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,$._mapper),this.f=g.getProxy(R.$1M.MainThreadDiagnostics)}createDiagnosticCollection(g,a){const{g:n,f:i,h:u,j:o,k:t,l}=this,r=new class{$changeMany(v,f){i.$changeMany(v,f),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,v,f.length===0?"CLEARING":f)}$clear(v){i.$clear(v),o.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,v)}dispose(){i.dispose()}};let c;if(!a)a="_generated_diagnostic_collection_name_#"+$.c++,c=a;else if(!n.has(a))c=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do c=a+$.c++;while(n.has(c))}return new class extends y{constructor(){super(a,c,$.e,$.d,v=>l.getDocument(v)?.version,t.extUri,r,u),n.set(c,this)}dispose(){super.dispose(),n.delete(c)}}}getDiagnostics(g){if(g)return this.m(g);{const a=new Map,n=[];for(const i of this.g.values())i.forEach((u,o)=>{let t=a.get(u.toString());typeof t>"u"&&(t=n.length,a.set(u.toString(),t),n.push([u,[]])),n[t][1]=n[t][1].concat(...o)});return n}}m(g){let a=[];for(const n of this.g.values())n.has(g)&&(a=a.concat(n.get(g)));return a}$acceptMarkersChange(g){if(!this.n){const a="_generated_mirror",n=new y(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(a,n),this.n=n}for(const[a,n]of g)this.n.set(L.URI.revive(a),n.map(b.Diagnostic.to))}};e.$9kc=w,e.$9kc=w=$=Je([Ve(1,E.$2j),Ve(2,D.$7kc)],w)}),define(ke[339],Pe([1,0,2,13,8,16,76,48]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=void 0;class m{constructor(A,D,$,y={timeout:1500,errors:3}){this.c=A,this.d=D,this.f=$,this.g=y,this.a=new M.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(A){return(D,$,y)=>{const h={dispose:this.a.push([D,$,A])};return Array.isArray(y)&&y.push(h),h}}async $participateInSave(A,D){const $=d.URI.revive(A);let y=!1;const w=setTimeout(()=>y=!0,this.g.timeout),h=[];try{for(const g of[...this.a]){if(y)break;const a=this.d.getDocument($),n=await this.h(g,{document:a,reason:R.TextDocumentSaveReason.to(D)});h.push(n)}}finally{clearTimeout(w)}return h}h([A,D,$],y){const w=this.b.get(A);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i($,A,D,y).then(()=>!0,h=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' threw ERROR`),this.c.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const g=this.b.get(A);this.b.set(A,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(A,D,$,y){const w=[],h=Date.now(),{document:g,reason:a}=y,{version:n}=g,i=Object.freeze({document:g,reason:a,waitUntil(u){if(Object.isFrozen(w))throw(0,N.$8)("waitUntil can not be called async");w.push(Promise.resolve(u))}});try{D.apply($,[i])}catch(u){return Promise.reject(u)}return Object.freeze(w),new Promise((u,o)=>{const t=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(w).then(l=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(t),u(l)}).catch(l=>{clearTimeout(t),o(l)})}).then(u=>{const o={edits:[]};for(const t of u)if(Array.isArray(t)&&t.every(l=>l instanceof L.$0M))for(const{newText:l,newEol:r,range:c}of t)o.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:c&&R.Range.from(c),text:l,eol:r&&R.EndOfLine.from(r)}});if(o.edits.length!==0)return n===g.version?this.f.$tryApplyWorkspaceEdit(new b.$uw(o)):Promise.reject(new Error("concurrent_edits"))})}}e.$emc=m}),define(ke[340],Pe([1,0,4,3,2,6,153,16,18,24,8]),function(le,e,d,N,L,R,M,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=void 0;class D{constructor(y,w){this.a=new d.$ee,this.b=new d.$ee,this.c=new d.$ee,this.d=new d.$ee,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Uc,this.h=new Map,this.f=y.getProxy(R.$1M.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(h=>{for(const g of h)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(h=>{for(const g of h)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(y){if(!y)return;const w=this.g.getDocument(y);if(w)return w}getDocument(y){const w=this.getDocumentData(y);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${y}'`);return w.document}ensureDocumentData(y){const w=this.g.getDocument(y);if(w)return Promise.resolve(w);let h=this.h.get(y.toString());return h||(h=this.f.$tryOpenDocument(y).then(g=>{this.h.delete(y.toString());const a=L.URI.revive(g);return(0,m.$gg)(this.g.getDocument(a))},g=>(this.h.delete(y.toString()),Promise.reject(g))),this.h.set(y.toString(),h)),h}createDocumentData(y){return this.f.$tryCreateDocument(y).then(w=>L.URI.revive(w))}$acceptModelLanguageChanged(y,w){const h=L.URI.revive(y),g=this.g.getDocument(h);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(w),this.a.fire(g.document)}$acceptModelSaved(y){const w=L.URI.revive(y),h=this.g.getDocument(w);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(y,!1),this.d.fire(h.document)}$acceptDirtyStateChanged(y,w){const h=L.URI.revive(y),g=this.g.getDocument(h);if(!g)throw new Error("unknown document");g._acceptIsDirty(w),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(y,w,h){const g=L.URI.revive(y),a=this.g.getDocument(g);if(!a)throw new Error("unknown document");a._acceptIsDirty(h),a.onEvents(w);let n;w.isUndoing?n=A.TextDocumentChangeReason.Undo:w.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,E.$3n)({document:a.document,contentChanges:w.changes.map(i=>({range:b.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(y,w){(0,M.$qP)(y,w)}}e.$0kc=D}),define(ke[72],Pe([1,0,74,4,18,2,5,6,20,16,8]),function(le,e,d,N,L,R,M,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clc=e.$Blc=void 0,e.$Blc=(0,M.$vi)("IExtHostEditorTabs");class D{constructor(g,a,n){this.e=n,this.d=a,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,a={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$NO(R.URI.revive(this.b.input.uri));case 2:return new A.$OO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$PO(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$QO(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$RO(this.b.input.viewType);case 4:return new A.$SO(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$TO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$UO;case 9:return new A.$VO(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$WO;case 11:return new A.$XO(this.b.input.diffEditors.map(g=>new A.$OO(R.URI.revive(g.original),R.URI.revive(g.modified))));default:return}}}class ${constructor(g,a){this.c=[],this.d="",this.b=g,this.e=a;for(const n of g.tabs)n.isActive&&(this.d=n.id),this.c.push(new D(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,a={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return E.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(n=>n.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(n=>n.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===0){const n=new D(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,n),g.tabDto.isActive&&(this.d=n.tabId),n}else if(g.kind===1){const n=this.c.splice(g.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(g.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,n),n}const a=this.c.find(n=>n.tabId===g.tabDto.id);if(!a)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(g.tabDto),a}activeTabId(){return this.d}}let y=class{constructor(g){this.b=new N.$ee,this.c=new N.$ee,this.e=[],this.a=g.getProxy(b.$1M.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,a={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(n=>n.apiObject))},get activeTabGroup(){const n=g.d;return(0,L.$gg)(g.e.find(u=>u.groupId===n)?.apiObject)},close:async(n,i)=>{const u=Array.isArray(n)?n:[n];return u.length?w(u[0])?this.j(u,i):this.i(u,i):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(g){const a=new Set(this.e.map(r=>r.groupId)),n=new Set(g.map(r=>r.groupId)),i=(0,d.$L)(a,n),u=this.e.filter(r=>i.removed.includes(r.groupId)).map(r=>r.apiObject),o=[],t=[];this.e=g.map(r=>{const c=new $(r,()=>this.d);return i.added.includes(c.groupId)?o.push(c.apiObject):t.push(c.apiObject),c});const l=(0,L.$gg)(g.find(r=>r.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:o,closed:u,changed:t}))}$acceptTabGroupUpdate(g){const a=this.e.find(n=>n.groupId===g.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const a=this.e.find(i=>i.groupId===g.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const n=a.acceptTabOperation(g);switch(g.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(g){for(const a of this.e)for(const n of a.tabs)if(n.apiObject===g)return n}h(g){return this.e.find(a=>a.apiObject===g)}async i(g,a){const n=[];for(const i of g){const u=this.g(i);if(!u)throw new Error("Tab close: Invalid tab not found!");n.push(u.tabId)}return this.a.$closeTab(n,a)}async j(g,a){const n=[];for(const i of g){const u=this.h(i);if(!u)throw new Error("Group close: Invalid group not found!");n.push(u.groupId)}return this.a.$closeGroup(n,a)}};e.$Clc=y,e.$Clc=y=Je([Ve(0,m.$oP)],y);function w(h){return h.tabs!==void 0}}),define(ke[341],Pe([1,0,2,6,3,8,16,185,14,21,26,81]),function(le,e,d,N,L,R,M,b,m,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=void 0;class ${constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const g=this.a.indexOf(h);g>=0&&(this.a.splice(g,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),g=[];let a,n,i=14,u=14;for(const o of h){let t=a?(0,m.$zf)(a,o):0;for(t===0?n=1:n=u;t<o.length;t++)t+1===o.length?(i=u,u=9):u+=1,g.push([n,o.toUpperCase().charCodeAt(t),u]),g.push([n,o.toLowerCase().charCodeAt(t),u]),n=u;a=o,u=i}g.push([9,58,10]),g.push([10,47,12]),this.b=new b.$i3(g)}}provideDocumentLinks(h){this.c();const g=[],a=b.$j3.computeLinks({getLineContent(n){return h.lineAt(n-1).text},getLineCount(){return h.lineCount}},this.b);for(const n of a){const i=M.DocumentLink.to(n);i.target&&g.push(i)}return g}}class y{constructor(h,g){this.i=g,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(N.$1M.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,g,a,n={}){if(y.j(a),this.d.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const i=this.h++;this.b.add(g),this.d.add(g),this.c.set(i,a);let u=2;n.isCaseSensitive&&(u+=1024),n.isReadonly&&(u+=2048),typeof a.copy=="function"&&(u+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&((0,A.$GG)(h,"fsChunks"),u+=4);let o;n.isReadonly&&(0,D.$Uk)(n.isReadonly)&&n.isReadonly.value!==""&&(o={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,g,u,o).catch(l=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${g}`),console.error(l)});const t=a.onDidChangeFile(l=>{const r=[];for(const c of l){const{uri:s,type:v}=c;if(s.scheme!==g)continue;let f;switch(v){case R.FileChangeType.Changed:f=0;break;case R.FileChangeType.Created:f=1;break;case R.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:s,type:f})}this.a.$onFileSystemChange(i,r)});return(0,L.$Tc)(()=>{t.dispose(),this.b.delete(g),this.d.delete(g),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(h){if(!h)throw new Error("MISSING provider");if(typeof h.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof h.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof h.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof h.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof h.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof h.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof h.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof h.rename!="function")throw new Error("Provider does NOT implement rename")}static k(h){const{type:g,ctime:a,mtime:n,size:i,permissions:u}=h;return{type:g,ctime:a,mtime:n,size:i,permissions:u}}$stat(h,g){return Promise.resolve(this.l(h).stat(d.URI.revive(g))).then(a=>y.k(a))}$readdir(h,g){return Promise.resolve(this.l(h).readDirectory(d.URI.revive(g)))}$readFile(h,g){return Promise.resolve(this.l(h).readFile(d.URI.revive(g))).then(a=>E.$Fe.wrap(a))}$writeFile(h,g,a,n){return Promise.resolve(this.l(h).writeFile(d.URI.revive(g),a.buffer,n))}$delete(h,g,a){return Promise.resolve(this.l(h).delete(d.URI.revive(g),a))}$rename(h,g,a,n){return Promise.resolve(this.l(h).rename(d.URI.revive(g),d.URI.revive(a),n))}$copy(h,g,a,n){const i=this.l(h);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(d.URI.revive(g),d.URI.revive(a),n))}$mkdir(h,g){return Promise.resolve(this.l(h).createDirectory(d.URI.revive(g)))}$watch(h,g,a,n){const i=this.l(h).watch(d.URI.revive(a),n);this.f.set(g,i)}$unwatch(h,g){const a=this.f.get(g);a&&(a.dispose(),this.f.delete(g))}$open(h,g,a){const n=this.l(h);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(d.URI.revive(g),a))}$close(h,g){const a=this.l(h);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(g))}$read(h,g,a,n){const i=this.l(h);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const u=E.$Fe.alloc(n);return Promise.resolve(i.read(g,a,u.buffer,0,n)).then(o=>u.slice(0,o))}$write(h,g,a,n){const i=this.l(h);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(g,a,n.buffer,0,n.byteLength))}l(h){const g=this.c.get(h);if(!g){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return g}}e.$gmc=y}),define(ke[342],Pe([1,0,4,35,2,6,16,8,46]),function(le,e,d,N,L,R,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,w,h,g,a,n){this.a=Math.random(),this.b=new d.$ee,this.c=new d.$ee,this.d=new d.$ee,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,N.$pk)(a),u=typeof a=="string",o=n?.correlate,t=g(l=>{if(!(typeof l.session=="number"&&l.session!==this.a)&&!(o&&typeof l.session>"u")){if(!n?.ignoreCreateEvents)for(const r of l.created){const c=L.URI.revive(r);i(c.fsPath)&&(!u||w.getWorkspaceFolder(c))&&this.b.fire(c)}if(!n?.ignoreChangeEvents)for(const r of l.changed){const c=L.URI.revive(r);i(c.fsPath)&&(!u||w.getWorkspaceFolder(c))&&this.c.fire(c)}if(!n?.ignoreDeleteEvents)for(const r of l.deleted){const c=L.URI.revive(r);i(c.fsPath)&&(!u||w.getWorkspaceFolder(c))&&this.d.fire(c)}}});this.g=b.$3M.from(this.i(y,h,a,n,n?.correlate),this.b,this.c,this.d,t)}i(y,w,h,g,a){const n=b.$3M.from();if(typeof h=="string"||g?.ignoreChangeEvents&&g?.ignoreCreateEvents&&g?.ignoreDeleteEvents)return n;const i=y.getProxy(R.$1M.MainThreadFileSystemEventService);let u=!1;(h.pattern.includes(N.$lk)||h.pattern.includes(N.$mk))&&(u=!0);let o;return a&&(g?.ignoreChangeEvents||g?.ignoreCreateEvents||g?.ignoreDeleteEvents)&&(o=14,g?.ignoreChangeEvents&&(o&=-3),g?.ignoreCreateEvents&&(o&=-5),g?.ignoreDeleteEvents&&(o&=-9)),i.$watch(w.identifier.value,this.a,h.baseUri,{recursive:u,excludes:g?.excludes??[],filter:o},!!a),b.$3M.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(y){this.a=y,this.session=this.a.session,this.b=new m.$V(()=>this.a.created.map(L.URI.revive)),this.c=new m.$V(()=>this.a.changed.map(L.URI.revive)),this.d=new m.$V(()=>this.a.deleted.map(L.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(y,w,h){this.j=y,this.k=w,this.l=h,this.a=new d.$ee,this.b=new d.$ee,this.c=new d.$ee,this.d=new d.$ee,this.g=new d.$ge,this.h=new d.$ge,this.i=new d.$ge,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,w,h,g){return new E(this.j,y,w,this.a.event,M.GlobPattern.from(h),g)}$onFileEvent(y){this.a.fire(new A(y))}$onDidRunFileOperation(y,w){switch(y){case 2:this.b.fire(Object.freeze({files:w.map(h=>({oldUri:L.URI.revive(h.source),newUri:L.URI.revive(h.target)}))}));break;case 1:this.d.fire(Object.freeze({files:w.map(h=>L.URI.revive(h.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:w.map(h=>L.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,w){return(h,g,a)=>{const n=function(u){h.call(g,u)};return n.extension=y,w.event(n,void 0,a)}}async $onWillRunFileOperation(y,w,h,g){switch(y){case 2:return await this.n(this.g,{files:w.map(a=>({oldUri:L.URI.revive(a.source),newUri:L.URI.revive(a.target)}))},h,g);case 1:return await this.n(this.i,{files:w.map(a=>L.URI.revive(a.target))},h,g);case 0:case 3:return await this.n(this.h,{files:w.map(a=>L.URI.revive(a.target))},h,g)}}async n(y,w,h,g){const a=new Set,n=[];if(await y.fireAsync(w,g,async(u,o)=>{const t=Date.now(),l=await Promise.resolve(u);l instanceof b.$aN&&(n.push([o.extension,l]),a.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-t>h&&this.k.warn("SLOW file-participant",o.extension.identifier)}),g.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,u]of n){const{edits:o}=M.WorkspaceEdit.from(u,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(o)}return{edit:i,extensionNames:Array.from(a)}}}e.$hmc=D}),define(ke[343],Pe([1,0,19,7,22,13,125,3,24,40,14,18,2,29,181,84,135,226,25,16,8,26,112,6]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i,u,o,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;class r{constructor(V,W){this.d=V,this.e=W}async provideDocumentSymbols(V,W){const J=this.d.getDocument(V),Y=await this.e.provideDocumentSymbols(J,W);if(!(0,d.$Kb)(Y))return Y[0]instanceof u.$kN?Y.map(i.DocumentSymbol.from):r.f(Y)}static f(V){V=V.slice(0).sort((Y,he)=>{let we=Y.location.range.start.compareTo(he.location.range.start);return we===0&&(we=he.location.range.end.compareTo(Y.location.range.end)),we});const W=[],J=[];for(const Y of V){const he={name:Y.name||"!!MISSING: name!!",kind:i.SymbolKind.from(Y.kind),tags:Y.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:Y.containerName,range:i.Range.from(Y.location.range),selectionRange:i.Range.from(Y.location.range),children:[]};for(;;){if(J.length===0){J.push(he),W.push(he);break}const we=J[J.length-1];if(y.$tt.containsRange(we.range,he.range)&&!y.$tt.equalsRange(we.range,he.range)){we.children?.push(he),J.push(he);break}J.pop()}}return W}}class c{constructor(V,W,J,Y,he,we){this.f=V,this.g=W,this.h=J,this.j=Y,this.k=he,this.l=we,this.d=new t.$1kc("CodeLens"),this.e=new Map}async provideCodeLenses(V,W){const J=this.f.getDocument(V),Y=await this.h.provideCodeLenses(J,W);if(!Y||W.isCancellationRequested)return;const he=this.d.add(Y),we=new b.$Uc;this.e.set(he,we);const je={cacheId:he,lenses:[]};for(let qe=0;qe<Y.length;qe++)je.lenses.push({cacheId:[he,qe],range:i.Range.from(Y[qe].range),command:this.g.toInternal(Y[qe].command,we)});return je}async resolveCodeLens(V,W){const J=V.cacheId&&this.d.get(...V.cacheId);if(!J)return;let Y;if(typeof this.h.resolveCodeLens!="function"||J.isResolved?Y=J:Y=await this.h.resolveCodeLens(J,W),Y||(Y=J),W.isCancellationRequested)return;const he=V.cacheId&&this.e.get(V.cacheId[0]);if(he){if(!Y.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return V.command=this.g.toInternal(Y.command,he),V}}releaseCodeLenses(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}}function s(ze){return Array.isArray(ze)?ze.map(i.DefinitionLink.from):ze?[i.DefinitionLink.from(ze)]:[]}class v{constructor(V,W){this.d=V,this.e=W}async provideDefinition(V,W,J){const Y=this.d.getDocument(V),he=i.Position.to(W),we=await this.e.provideDefinition(Y,he,J);return s(we)}}class f{constructor(V,W){this.d=V,this.e=W}async provideDeclaration(V,W,J){const Y=this.d.getDocument(V),he=i.Position.to(W),we=await this.e.provideDeclaration(Y,he,J);return s(we)}}class S{constructor(V,W){this.d=V,this.e=W}async provideImplementation(V,W,J){const Y=this.d.getDocument(V),he=i.Position.to(W),we=await this.e.provideImplementation(Y,he,J);return s(we)}}class p{constructor(V,W){this.d=V,this.e=W}async provideTypeDefinition(V,W,J){const Y=this.d.getDocument(V),he=i.Position.to(W),we=await this.e.provideTypeDefinition(Y,he,J);return s(we)}}class k{static{this.f=10}constructor(V,W){this.g=V,this.h=W,this.d=0,this.e=new Map}async provideHover(V,W,J,Y){const he=this.g.getDocument(V),we=i.Position.to(W);let je;if(J&&J.previousHover!==void 0&&J.action!==void 0){const tt=J.previousHover.id,nt=this.e.get(tt);if(!nt)throw new Error(`Hover with id ${tt} not found`);const ot={action:J.action,previousHover:nt};je=await this.h.provideHover(he,we,Y,ot)}else je=await this.h.provideHover(he,we,Y);if(!je||(0,d.$Kb)(je.contents))return;je.range||(je.range=he.getWordRangeAtPosition(we)),je.range||(je.range=new u.$5M(we,we));const qe=i.Hover.from(je),Ye=this.d;if(this.e.size===k.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Ye,je),this.d+=1,{...qe,id:Ye}}releaseHover(V){this.e.delete(V)}}class P{constructor(V,W){this.d=V,this.e=W}async provideEvaluatableExpression(V,W,J){const Y=this.d.getDocument(V),he=i.Position.to(W),we=await this.e.provideEvaluatableExpression(Y,he,J);if(we)return i.EvaluatableExpression.from(we)}}class C{constructor(V,W){this.d=V,this.e=W}async provideInlineValues(V,W,J,Y){const he=this.d.getDocument(V),we=await this.e.provideInlineValues(he,i.Range.to(W),i.InlineValueContext.to(J),Y);if(Array.isArray(we))return we.map(je=>i.InlineValue.from(je))}}class I{constructor(V,W){this.d=V,this.e=W}async provideDocumentHighlights(V,W,J){const Y=this.d.getDocument(V),he=i.Position.to(W),we=await this.e.provideDocumentHighlights(Y,he,J);if(Array.isArray(we))return we.map(i.DocumentHighlight.from)}}class T{constructor(V,W){this.d=V,this.e=W}async provideMultiDocumentHighlights(V,W,J,Y){const he=this.d.getDocument(V),we=J.map(Ye=>this.d.getDocument(Ye)),je=i.Position.to(W),qe=await this.e.provideMultiDocumentHighlights(he,je,we,Y);if(Array.isArray(qe))return qe.map(i.MultiDocumentHighlight.from)}}class j{constructor(V,W){this.d=V,this.e=W}async provideLinkedEditingRanges(V,W,J){const Y=this.d.getDocument(V),he=i.Position.to(W),we=await this.e.provideLinkedEditingRanges(Y,he,J);if(we&&Array.isArray(we.ranges))return{ranges:(0,d.$Hb)(we.ranges.map(i.Range.from)),wordPattern:we.wordPattern}}}class z{constructor(V,W){this.d=V,this.e=W}async provideReferences(V,W,J,Y){const he=this.d.getDocument(V),we=i.Position.to(W),je=await this.e.provideReferences(he,we,J,Y);if(Array.isArray(je))return je.map(i.location.from)}}class O{static{this.d=1e3}constructor(V,W,J,Y,he,we,je){this.g=V,this.h=W,this.j=J,this.k=Y,this.l=he,this.m=we,this.n=je,this.e=new t.$1kc("CodeAction"),this.f=new Map}async provideCodeActions(V,W,J,Y){const he=this.g.getDocument(V),we=w.$vt.isISelection(W)?i.Selection.to(W):i.Range.to(W),je=[];for(const ot of this.j.getDiagnostics(V))if(we.intersection(ot.range)&&je.push(ot)>O.d)break;const qe={diagnostics:je,only:J.only?new u.$mN(J.only):void 0,triggerKind:i.CodeActionTriggerKind.to(J.trigger)},Ye=await this.k.provideCodeActions(he,we,qe,Y);if(!(0,d.$Lb)(Ye)||Y.isCancellationRequested)return;const st=this.e.add(Ye),tt=new b.$Uc;this.f.set(st,tt);const nt=[];for(let ot=0;ot<Ye.length;ot++){const De=Ye[ot];if(De)if(O.o(De))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:De.title,command:this.h.toInternal(De,tt)});else{qe.only&&(De.kind?qe.only.contains(De.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action is of kind '${De.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=De.ranges??[];nt.push({cacheId:[st,ot],title:De.title,command:De.command&&this.h.toInternal(De.command,tt),diagnostics:De.diagnostics&&De.diagnostics.map(i.Diagnostic.from),edit:De.edit&&i.WorkspaceEdit.from(De.edit,void 0),kind:De.kind&&De.kind.value,isPreferred:De.isPreferred,isAI:(0,o.$FG)(this.m,"codeActionAI")?De.isAI:!1,ranges:(0,o.$FG)(this.m,"codeActionRanges")?(0,d.$Hb)(Be.map(i.Range.from)):void 0,disabled:De.disabled?.reason})}}return{cacheId:st,actions:nt}}async resolveCodeAction(V,W){const[J,Y]=V,he=this.e.get(J,Y);if(!he||O.o(he))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(he,W)??he;let je;we.edit&&(je=i.WorkspaceEdit.from(we.edit,void 0));let qe;if(we.command){const Ye=this.f.get(J);Ye&&(qe=this.h.toInternal(we.command,Ye))}return{edit:je,command:qe}}releaseCodeActions(V){this.f.get(V)?.dispose(),this.f.delete(V),this.e.delete(V)}static o(V){return typeof V.command=="string"&&typeof V.title=="string"}}class F{constructor(V,W,J,Y,he){this.e=V,this.f=W,this.g=J,this.h=Y,this.j=he,this.d=new t.$1kc("DocumentPasteEdit")}async prepareDocumentPaste(V,W,J,Y){if(!this.g.prepareDocumentPaste)return;const he=this.f.getDocument(V),we=W.map(Ye=>i.Range.to(Ye)),je=i.DataTransfer.toDataTransfer(J,()=>{throw new R.$$});if(await this.g.prepareDocumentPaste(he,we,je,Y),Y.isCancellationRequested)return;const qe=Array.from(je).filter(([,Ye])=>!(Ye instanceof u.$SN));return i.DataTransfer.from(qe)}async providePasteEdits(V,W,J,Y,he,we){if(!this.g.provideDocumentPasteEdits)return[];const je=this.f.getDocument(W),qe=J.map(nt=>i.Range.to(nt)),Ye=i.DataTransfer.toDataTransfer(Y,async nt=>(await this.e.$resolvePasteFileData(this.h,V,nt)).buffer),st=await this.g.provideDocumentPasteEdits(je,qe,Ye,{only:he.only?new u.$XN(he.only):void 0,triggerKind:he.triggerKind},we);if(!st||we.isCancellationRequested)return[];const tt=this.d.add(st);return st.map((nt,ot)=>({_cacheId:[tt,ot],title:nt.title??(0,a.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(De=>De.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,W){const[J,Y]=V,he=this.d.get(J,Y);if(!he||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(he,W)??he;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(V){this.d.delete(V)}}class B{constructor(V,W){this.d=V,this.e=W}async provideDocumentFormattingEdits(V,W,J){const Y=this.d.getDocument(V),he=await this.e.provideDocumentFormattingEdits(Y,W,J);if(Array.isArray(he))return he.map(i.TextEdit.from)}}class Z{constructor(V,W){this.d=V,this.e=W}async provideDocumentRangeFormattingEdits(V,W,J,Y){const he=this.d.getDocument(V),we=i.Range.to(W),je=await this.e.provideDocumentRangeFormattingEdits(he,we,J,Y);if(Array.isArray(je))return je.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,W,J,Y){(0,D.$fg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const he=this.d.getDocument(V),we=W.map(i.Range.to),je=await this.e.provideDocumentRangesFormattingEdits(he,we,J,Y);if(Array.isArray(je))return je.map(i.TextEdit.from)}}class q{constructor(V,W){this.d=V,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,W,J,Y,he){const we=this.d.getDocument(V),je=i.Position.to(W),qe=await this.e.provideOnTypeFormattingEdits(we,je,J,Y,he);if(Array.isArray(qe))return qe.map(i.TextEdit.from)}}class Q{constructor(V,W){this.e=V,this.f=W,this.d=new t.$1kc("WorkspaceSymbols")}async provideWorkspaceSymbols(V,W){const J=await this.e.provideWorkspaceSymbols(V,W);if(!(0,d.$Lb)(J))return{symbols:[]};const Y=this.d.add(J),he={cacheId:Y,symbols:[]};for(let we=0;we<J.length;we++){const je=J[we];if(!je||!je.name){this.f.warn("INVALID SymbolInformation",je);continue}he.symbols.push({...i.WorkspaceSymbol.from(je),cacheId:[Y,we]})}return he}async resolveWorkspaceSymbol(V,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const J=this.d.get(...V.cacheId);if(J){const Y=await this.e.resolveWorkspaceSymbol(J,W);return Y&&(0,m.$5n)(V,i.WorkspaceSymbol.from(Y),!0)}}releaseWorkspaceSymbols(V){this.d.delete(V)}}class x{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,W,J){this.d=V,this.e=W,this.f=J}async provideRenameEdits(V,W,J,Y){const he=this.d.getDocument(V),we=i.Position.to(W);try{const je=await this.e.provideRenameEdits(he,we,J,Y);return je?i.WorkspaceEdit.from(je):void 0}catch(je){const qe=x.g(je);return qe?{rejectReason:qe,edits:void 0}:Promise.reject(je)}}async resolveRenameLocation(V,W,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Y=this.d.getDocument(V),he=i.Position.to(W);try{const we=await this.e.prepareRename(Y,he,J);let je,qe;if(u.$5M.isRange(we)?(je=we,qe=Y.getText(we)):(0,D.$0f)(we)&&(je=we.range,qe=we.placeholder),!je||!qe)return;if(je.start.line>he.line||je.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(je),text:qe}}catch(we){const je=x.g(we);return je?{rejectReason:je,range:void 0,text:void 0}:Promise.reject(we)}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class X{constructor(V,W,J){this.d=V,this.e=W,this.f=J}async provideNewSymbolNames(V,W,J){const Y=this.d.getDocument(V),he=i.Range.to(W);try{const we=await this.e.provideNewSymbolNames(Y,he,J);return we?we.map(je=>typeof je=="string"?{newSymbolName:je}:{newSymbolName:je.newSymbolName,tags:je.tags}):void 0}catch(we){this.f.error(X.g(we)??JSON.stringify(we,null,"	"));return}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class ie{constructor(V,W){this.resultId=V,this.tokens=W}}class me{constructor(V,W){this.f=V,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(V,W,J){const Y=this.f.getDocument(V),he=W!==0?this.d.get(W):null;let we=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Y,he.resultId,J):await this.g.provideDocumentSemanticTokens(Y,J);return he&&this.d.delete(W),we?(we=me.h(we),this.o(me.n(he,we),we)):null}async releaseDocumentSemanticColoring(V){this.d.delete(V)}static h(V){return me.j(V)?me.k(V)?V:new u.$lO(new Uint32Array(V.data),V.resultId):me.l(V)?me.m(V)?V:new u.$nO(V.edits.map(W=>new u.$mO(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),V.resultId):V}static j(V){return V&&!!V.data}static k(V){return V.data instanceof Uint32Array}static l(V){return V&&Array.isArray(V.edits)}static m(V){for(const W of V.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(V,W){if(!me.j(W)||!V||!V.tokens)return W;const J=V.tokens,Y=J.length,he=W.data,we=he.length;let je=0;const qe=Math.min(Y,we);for(;je<qe&&J[je]===he[je];)je++;if(je===Y&&je===we)return new u.$nO([],W.resultId);let Ye=0;const st=qe-je;for(;Ye<st&&J[Y-Ye-1]===he[we-Ye-1];)Ye++;return new u.$nO([{start:je,deleteCount:Y-je-Ye,data:he.subarray(je,we-Ye)}],W.resultId)}o(V,W){if(me.j(V)){const J=this.e++;return this.d.set(J,new ie(V.resultId,V.data)),(0,g.$7bb)({id:J,type:"full",data:V.data})}if(me.l(V)){const J=this.e++;return me.j(W)?this.d.set(J,new ie(W.resultId,W.data)):this.d.set(J,new ie(V.resultId)),(0,g.$7bb)({id:J,type:"delta",deltas:(V.edits||[]).map(Y=>({start:Y.start,deleteCount:Y.deleteCount,data:Y.data}))})}return null}}class ue{constructor(V,W){this.d=V,this.e=W}async provideDocumentRangeSemanticTokens(V,W,J){const Y=this.d.getDocument(V),he=await this.e.provideDocumentRangeSemanticTokens(Y,i.Range.to(W),J);return he?this.f(he):null}f(V){return(0,g.$7bb)({id:0,type:"full",data:V.data})}}class ve{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,W,J,Y,he){this.f=V,this.g=W,this.h=J,this.j=Y,this.k=he,this.d=new t.$1kc("CompletionItem"),this.e=new Map}async provideCompletionItems(V,W,J,Y){const he=this.f.getDocument(V),we=i.Position.to(W),je=he.getWordRangeAtPosition(we)||new u.$5M(we,we),qe=je.with({end:we}),Ye=new E.$ae,st=await this.h.provideCompletionItems(he,we,Y,i.CompletionContext.to(J));if(!st||Y.isCancellationRequested)return;const tt=Array.isArray(st)?new u.$zN(st):st,nt=ve.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),ot=new b.$Uc;this.e.set(nt,ot);const De=[],Be={x:nt,b:De,a:{replace:i.Range.from(je),insert:i.Range.from(qe)},c:tt.isIncomplete||void 0,d:Ye.elapsed()};for(let Ge=0;Ge<tt.items.length;Ge++){const Ne=tt.items[Ge],Ze=this.l(Ne,[nt,Ge],qe,je);De.push(Ze)}return Be}async resolveCompletionItem(V,W){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...V);if(!J)return;const Y=this.l(J,V),he=await this.h.resolveCompletionItem(J,W);if(!he)return;const we=this.l(he,V);return(Y.h!==we.h||Y.i!==we.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Y.n!==we.n||Y.o!==we.o||!(0,m.$6n)(Y.p,we.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Y,d:we.d,c:we.c,l:we.l,h:we.h,i:we.i,n:we.n,o:we.o,p:we.p}}releaseCompletionItems(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,W,J,Y){const he=this.e.get(W[0]);if(!he)throw Error("DisposableStore is missing...");const we=this.g.toInternal(V.command,he),je={x:W,a:V.label,b:V.kind!==void 0?i.CompletionItemKind.from(V.kind):void 0,m:V.tags&&V.tags.map(i.CompletionItemTag.from),c:V.detail,d:typeof V.documentation>"u"?void 0:i.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters?.join(""),l:V.additionalTextEdits&&V.additionalTextEdits.map(i.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};V.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),je.h=V.textEdit.newText):typeof V.insertText=="string"?je.h=V.insertText:V.insertText instanceof u.$bN&&(je.h=V.insertText.value,je.i|=4);let qe;return V.textEdit?qe=V.textEdit.range:V.range&&(qe=V.range),u.$5M.isRange(qe)?je.j=i.Range.from(qe):qe&&(!J?.isEqual(qe.inserting)||!Y?.isEqual(qe.replacing))&&(je.j={insert:i.Range.from(qe.inserting),replace:i.Range.from(qe.replacing)}),je}}class te{async provideInlineCompletions(V,W,J,Y){}disposeCompletions(V){}handleDidShowCompletionItem(V,W,J){}handlePartialAccept(V,W,J,Y){}}class U extends te{constructor(V,W,J,Y){super(),this.f=V,this.g=W,this.h=J,this.j=Y,this.d=new pe,this.e=(0,o.$FG)(this.f,"inlineCompletionsAdditions"),this.k={[h.InlineCompletionTriggerKind.Automatic]:u.InlineCompletionTriggerKind.Automatic,[h.InlineCompletionTriggerKind.Explicit]:u.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,o.$FG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,W,J,Y){const he=this.g.getDocument(V),we=i.Position.to(W),je=await this.h.provideInlineCompletionItems(he,we,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:i.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},Y);if(!je||Y.isCancellationRequested)return;const qe=Array.isArray(je)?je:je.items,Ye=this.e?Array.isArray(je)?[]:je.commands||[]:[],st=this.e&&!Array.isArray(je)?je.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:qe}),items:qe.map((ot,De)=>{let Be;ot.command&&(tt||(tt=new b.$Uc),Be=this.j.toInternal(ot.command,tt));const Ge=ot.insertText;return{insertText:typeof Ge=="string"?Ge:{snippet:Ge.value},filterText:ot.filterText,range:ot.range?i.Range.from(ot.range):void 0,command:Be,idx:De,completeBracketPairs:this.e?ot.completeBracketPairs:!1}}),commands:Ye.map(ot=>(tt||(tt=new b.$Uc),this.j.toInternal(ot,tt))),suppressSuggestions:!1,enableForwardStability:st}}disposeCompletions(V){this.d.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,W,J){const Y=this.d.get(V)?.items[W];Y&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Y,J)}handlePartialAccept(V,W,J,Y){const he=this.d.get(V)?.items[W];he&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(he,J),this.h.handleDidPartiallyAcceptCompletionItem(he,i.PartialAcceptInfo.to(Y)))}}class ee{async provideInlineEdits(V,W,J){const Y=this.f.getDocument(V),he=await this.g.provideInlineEdit(Y,{triggerKind:this.e[W.triggerKind]},J);if(!he||J.isCancellationRequested)return;let we;const je=this.d.createReferenceId({dispose(){we?.dispose()},item:he});let qe;he.accepted&&(we||(we=new b.$Uc),qe=this.h.toInternal(he.accepted,we));let Ye;return he.rejected&&(we||(we=new b.$Uc),Ye=this.h.toInternal(he.rejected,we)),{pid:je,text:he.text,range:i.Range.from(he.range),accepted:qe,rejected:Ye}}disposeEdit(V){this.d.disposeReferenceId(V)?.dispose()}constructor(V,W,J,Y){this.f=W,this.g=J,this.h=Y,this.d=new pe,this.e={[h.InlineEditTriggerKind.Automatic]:u.InlineEditTriggerKind.Automatic,[h.InlineEditTriggerKind.Invoke]:u.InlineEditTriggerKind.Invoke}}}class pe{constructor(){this.d=new Map,this.e=1}createReferenceId(V){const W=this.e++;return this.d.set(W,V),W}disposeReferenceId(V){const W=this.d.get(V);return this.d.delete(V),W}get(V){return this.d.get(V)}}class Ce{constructor(V,W){this.e=V,this.f=W,this.d=new t.$1kc("SignatureHelp")}async provideSignatureHelp(V,W,J,Y){const he=this.e.getDocument(V),we=i.Position.to(W),je=this.g(J),qe=await this.f.provideSignatureHelp(he,we,Y,je);if(qe){const Ye=this.d.add([qe]);return{...i.SignatureHelp.from(qe),id:Ye}}}g(V){let W;if(V.activeSignatureHelp){const J=i.SignatureHelp.to(V.activeSignatureHelp),Y=this.d.get(V.activeSignatureHelp.id,0);Y?(W=Y,W.activeSignature=J.activeSignature,W.activeParameter=J.activeParameter):W=J}return{...V,activeSignatureHelp:W}}releaseSignatureHelp(V){this.d.delete(V)}}class se{constructor(V,W,J,Y,he){this.f=V,this.g=W,this.h=J,this.j=Y,this.k=he,this.d=new t.$1kc("InlayHints"),this.e=new Map}async provideInlayHints(V,W,J){const Y=this.f.getDocument(V),he=i.Range.to(W),we=await this.h.provideInlayHints(Y,he,J);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`);return}if(J.isCancellationRequested)return;const je=this.d.add(we);this.e.set(je,new b.$Uc);const qe={hints:[],cacheId:je};for(let Ye=0;Ye<we.length;Ye++)this.l(we[Ye],he)&&qe.hints.push(this.m(we[Ye],[je,Ye]));return this.j.trace(`[InlayHints] ${qe.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`),qe}async resolveInlayHint(V,W){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...V);if(!J)return;const Y=await this.h.resolveInlayHint(J,W);if(Y&&this.l(Y))return this.m(Y,V)}releaseHints(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,W){return V.label.length===0||Array.isArray(V.label)&&V.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(W&&!W.contains(V.position))}m(V,W){const J=this.e.get(W[0]);if(!J)throw Error("DisposableStore is missing...");const Y={label:"",cacheId:W,tooltip:i.MarkdownString.fromStrict(V.tooltip),position:i.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(i.TextEdit.from),kind:V.kind&&i.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")Y.label=V.label;else{const he=[];Y.label=he;for(const we of V.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const je={label:we.value,tooltip:i.MarkdownString.fromStrict(we.tooltip)};u.$cN.isLocation(we.location)&&(je.location=i.location.from(we.location)),we.command&&(je.command=this.g.toInternal(we.command,J)),he.push(je)}}return Y}}class re{constructor(V,W){this.e=V,this.f=W,this.d=new t.$1kc("DocumentLink")}async provideLinks(V,W){const J=this.e.getDocument(V),Y=await this.f.provideDocumentLinks(J,W);if(!(!Array.isArray(Y)||Y.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Y.filter(re.g).map(i.DocumentLink.from)};{const he=this.d.add(Y),we={links:[],cacheId:he};for(let je=0;je<Y.length;je++){if(!re.g(Y[je]))continue;const qe=i.DocumentLink.from(Y[je]);qe.cacheId=[he,je],we.links.push(qe)}return we}}}static g(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,W){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...V);if(!J)return;const Y=await this.f.resolveDocumentLink(J,W);if(!(!Y||!re.g(Y)))return i.DocumentLink.from(Y)}releaseLinks(V){this.d.delete(V)}}class oe{constructor(V,W){this.d=V,this.e=W}async provideColors(V,W){const J=this.d.getDocument(V),Y=await this.e.provideDocumentColors(J,W);return Array.isArray(Y)?Y.map(we=>({color:i.Color.from(we.color),range:i.Range.from(we.range)})):[]}async provideColorPresentations(V,W,J){const Y=this.d.getDocument(V),he=i.Range.to(W.range),we=i.Color.to(W.color),je=await this.e.provideColorPresentations(we,{document:Y,range:he},J);if(Array.isArray(je))return je.map(i.ColorPresentation.from)}}class K{constructor(V,W){this.d=V,this.e=W}async provideFoldingRanges(V,W,J){const Y=this.d.getDocument(V),he=await this.e.provideFoldingRanges(Y,W,J);if(Array.isArray(he))return he.map(i.FoldingRange.from)}}class ne{constructor(V,W,J){this.d=V,this.e=W,this.f=J}async provideSelectionRanges(V,W,J){const Y=this.d.getDocument(V),he=W.map(i.Position.to),we=await this.e.provideSelectionRanges(Y,he,J);if(!(0,d.$Lb)(we))return[];if(we.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const je=[];for(let qe=0;qe<he.length;qe++){const Ye=[];je.push(Ye);let st=he[qe],tt=we[qe];for(;;){if(!tt.range.contains(st))throw new Error("INVALID selection range, must contain the previous range");if(Ye.push(i.SelectionRange.from(tt)),!tt.parent)break;st=tt.range,tt=tt.parent}}return je}}class $e{constructor(V,W){this.f=V,this.g=W,this.d=new M.$tP(""),this.e=new Map}async prepareSession(V,W,J){const Y=this.f.getDocument(V),he=i.Position.to(W),we=await this.g.prepareCallHierarchy(Y,he,J);if(!we)return;const je=this.d.nextId();return this.e.set(je,new Map),Array.isArray(we)?we.map(qe=>this.h(je,qe)):[this.h(je,we)]}async provideCallsTo(V,W,J){const Y=this.j(V,W);if(!Y)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(Y,J);if(he)return he.map(we=>({from:this.h(V,we.from),fromRanges:we.fromRanges.map(je=>i.Range.from(je))}))}async provideCallsFrom(V,W,J){const Y=this.j(V,W);if(!Y)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(Y,J);if(he)return he.map(we=>({to:this.h(V,we.to),fromRanges:we.fromRanges.map(je=>i.Range.from(je))}))}releaseSession(V){this.e.delete(V)}h(V,W){const J=this.e.get(V),Y=i.CallHierarchyItem.from(W,V,J.size.toString(36));return J.set(Y._itemId,W),Y}j(V,W){return this.e.get(V)?.get(W)}}class be{constructor(V,W){this.f=V,this.g=W,this.d=new M.$tP(""),this.e=new Map}async prepareSession(V,W,J){const Y=this.f.getDocument(V),he=i.Position.to(W),we=await this.g.prepareTypeHierarchy(Y,he,J);if(!we)return;const je=this.d.nextId();return this.e.set(je,new Map),Array.isArray(we)?we.map(qe=>this.h(je,qe)):[this.h(je,we)]}async provideSupertypes(V,W,J){const Y=this.j(V,W);if(!Y)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(Y,J);if(he)return he.map(we=>this.h(V,we))}async provideSubtypes(V,W,J){const Y=this.j(V,W);if(!Y)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(Y,J);if(he)return he.map(we=>this.h(V,we))}releaseSession(V){this.e.delete(V)}h(V,W){const J=this.e.get(V),Y=i.TypeHierarchyItem.from(W,V,J.size.toString(36));return J.set(Y._itemId,W),Y}j(V,W){return this.e.get(V)?.get(W)}}class Ae{constructor(V,W,J,Y,he){this.e=V,this.f=W,this.g=J,this.h=Y,this.j=he,this.d=new t.$1kc("DocumentDropEdit")}async provideDocumentOnDropEdits(V,W,J,Y,he){const we=this.f.getDocument(W),je=i.Position.to(J),qe=i.DataTransfer.toDataTransfer(Y,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,V,nt)).buffer),Ye=await this.g.provideDocumentDropEdits(we,je,qe,he);if(!Ye)return;const st=(0,d.$3b)(Ye),tt=this.d.add(st);return st.map((nt,ot)=>({_cacheId:[tt,ot],title:nt.title??(0,a.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(De=>De.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(V,W){const[J,Y]=V,he=this.d.get(J,Y);if(!he||!this.g.resolveDocumentDropEdit)return{};const we=await this.g.resolveDocumentDropEdit(he,W)??he;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(V){this.d.delete(V)}}class fe{constructor(V,W){this.d=V,this.e=W}async provideMappedEdits(V,W,J,Y){const he=$.URI.revive(V),we=this.d.getDocument(he),je=J.documents.map(st=>st.map(tt=>({uri:$.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(nt=>i.Range.to(nt))}))),qe={documents:je,selections:je[0]?.[0]?.ranges??[]},Ye=await this.e.provideMappedEdits(we,W,qe,Y);return Ye?i.WorkspaceEdit.from(Ye):null}}class Se{constructor(V,W){this.adapter=V,this.extension=W}}class Ie{static{this.d=0}constructor(V,W,J,Y,he,we,je,qe){this.g=W,this.h=J,this.j=Y,this.k=he,this.l=we,this.m=je,this.n=qe,this.f=new Map,this.e=V.getProxy(l.$1M.MainThreadLanguageFeatures)}o(V,W){return i.DocumentSelector.from(V,this.g,W)}p(V){return new u.$3M(()=>{this.f.delete(V),this.e.$unregister(V)})}q(){return Ie.d++}async s(V,W,J,Y,he,we=!1){const je=this.f.get(V);if(!je||!(je.adapter instanceof W))return Y;const qe=Date.now();we||this.l.trace(`[${je.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Ye=J(je.adapter,je.extension);return Promise.resolve(Ye).catch(st=>{(0,R.$4)(st)||(this.l.error(`[${je.extension.identifier.value}] provider FAILED`),this.l.error(st),this.n.onExtensionError(je.extension.identifier,st))}).finally(()=>{we||this.l.trace(`[${je.extension.identifier.value}] provider DONE after ${Date.now()-qe}ms`)}),L.CancellationToken.isCancellationToken(he)?(0,N.$kh)(Ye,he):Ye}t(V,W){const J=this.q();return this.f.set(J,new Se(V,W)),J}static u(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,W,J,Y){const he=this.t(new r(this.h,J),V),we=Y&&Y.label||Ie.u(V);return this.e.$registerDocumentSymbolProvider(he,this.o(W,V),we),this.p(he)}$provideDocumentSymbols(V,W,J){return this.s(V,r,Y=>Y.provideDocumentSymbols($.URI.revive(W),J),void 0,J)}registerCodeLensProvider(V,W,J){const Y=this.q(),he=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Y,new Se(new c(this.h,this.j.converter,J,V,this.n,this.l),V)),this.e.$registerCodeLensSupport(Y,this.o(W,V),he);let we=this.p(Y);if(he!==void 0){const je=J.onDidChangeCodeLenses(qe=>this.e.$emitCodeLensEvent(he));we=u.$3M.from(we,je)}return we}$provideCodeLenses(V,W,J){return this.s(V,c,Y=>Y.provideCodeLenses($.URI.revive(W),J),void 0,J)}$resolveCodeLens(V,W,J){return this.s(V,c,Y=>Y.resolveCodeLens(W,J),void 0,void 0)}$releaseCodeLenses(V,W){this.s(V,c,J=>Promise.resolve(J.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(V,W,J){const Y=this.t(new v(this.h,J),V);return this.e.$registerDefinitionSupport(Y,this.o(W,V)),this.p(Y)}$provideDefinition(V,W,J,Y){return this.s(V,v,he=>he.provideDefinition($.URI.revive(W),J,Y),[],Y)}registerDeclarationProvider(V,W,J){const Y=this.t(new f(this.h,J),V);return this.e.$registerDeclarationSupport(Y,this.o(W,V)),this.p(Y)}$provideDeclaration(V,W,J,Y){return this.s(V,f,he=>he.provideDeclaration($.URI.revive(W),J,Y),[],Y)}registerImplementationProvider(V,W,J){const Y=this.t(new S(this.h,J),V);return this.e.$registerImplementationSupport(Y,this.o(W,V)),this.p(Y)}$provideImplementation(V,W,J,Y){return this.s(V,S,he=>he.provideImplementation($.URI.revive(W),J,Y),[],Y)}registerTypeDefinitionProvider(V,W,J){const Y=this.t(new p(this.h,J),V);return this.e.$registerTypeDefinitionSupport(Y,this.o(W,V)),this.p(Y)}$provideTypeDefinition(V,W,J,Y){return this.s(V,p,he=>he.provideTypeDefinition($.URI.revive(W),J,Y),[],Y)}registerHoverProvider(V,W,J,Y){const he=this.t(new k(this.h,J),V);return this.e.$registerHoverProvider(he,this.o(W,V)),this.p(he)}$provideHover(V,W,J,Y,he){return this.s(V,k,we=>we.provideHover($.URI.revive(W),J,Y,he),void 0,he)}$releaseHover(V,W){this.s(V,k,J=>Promise.resolve(J.releaseHover(W)),void 0,void 0)}registerEvaluatableExpressionProvider(V,W,J,Y){const he=this.t(new P(this.h,J),V);return this.e.$registerEvaluatableExpressionProvider(he,this.o(W,V)),this.p(he)}$provideEvaluatableExpression(V,W,J,Y){return this.s(V,P,he=>he.provideEvaluatableExpression($.URI.revive(W),J,Y),void 0,Y)}registerInlineValuesProvider(V,W,J,Y){const he=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new C(this.h,J),V);this.e.$registerInlineValuesProvider(we,this.o(W,V),he);let je=this.p(we);if(he!==void 0){const qe=J.onDidChangeInlineValues(Ye=>this.e.$emitInlineValuesEvent(he));je=u.$3M.from(je,qe)}return je}$provideInlineValues(V,W,J,Y,he){return this.s(V,C,we=>we.provideInlineValues($.URI.revive(W),J,Y,he),void 0,he)}registerDocumentHighlightProvider(V,W,J){const Y=this.t(new I(this.h,J),V);return this.e.$registerDocumentHighlightProvider(Y,this.o(W,V)),this.p(Y)}registerMultiDocumentHighlightProvider(V,W,J){const Y=this.t(new T(this.h,J),V);return this.e.$registerMultiDocumentHighlightProvider(Y,this.o(W,V)),this.p(Y)}$provideDocumentHighlights(V,W,J,Y){return this.s(V,I,he=>he.provideDocumentHighlights($.URI.revive(W),J,Y),void 0,Y)}$provideMultiDocumentHighlights(V,W,J,Y,he){return this.s(V,T,we=>we.provideMultiDocumentHighlights($.URI.revive(W),J,Y.map(je=>$.URI.revive(je)),he),void 0,he)}registerLinkedEditingRangeProvider(V,W,J){const Y=this.t(new j(this.h,J),V);return this.e.$registerLinkedEditingRangeProvider(Y,this.o(W,V)),this.p(Y)}$provideLinkedEditingRanges(V,W,J,Y){return this.s(V,j,async he=>{const we=await he.provideLinkedEditingRanges($.URI.revive(W),J,Y);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Ie.w(we.wordPattern):void 0}},void 0,Y)}registerReferenceProvider(V,W,J){const Y=this.t(new z(this.h,J),V);return this.e.$registerReferenceSupport(Y,this.o(W,V)),this.p(Y)}$provideReferences(V,W,J,Y,he){return this.s(V,z,we=>we.provideReferences($.URI.revive(W),J,Y,he),void 0,he)}registerCodeActionProvider(V,W,J,Y){const he=new b.$Uc,we=this.t(new O(this.h,this.j.converter,this.k,J,this.l,V,this.m),V);return this.e.$registerQuickFixSupport(we,this.o(W,V),{providedKinds:Y?.providedCodeActionKinds?.map(je=>je.value),documentation:Y?.documentation?.map(je=>({kind:je.kind.value,command:this.j.converter.toInternal(je.command,he)}))},Ie.u(V),!!J.resolveCodeAction),he.add(this.p(we)),he}$provideCodeActions(V,W,J,Y,he){return this.s(V,O,we=>we.provideCodeActions($.URI.revive(W),J,Y,he),void 0,he)}$resolveCodeAction(V,W,J){return this.s(V,O,Y=>Y.resolveCodeAction(W,J),{},void 0)}$releaseCodeActions(V,W){this.s(V,O,J=>Promise.resolve(J.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(V,W,J){const Y=this.t(new B(this.h,J),V);return this.e.$registerDocumentFormattingSupport(Y,this.o(W,V),V.identifier,V.displayName||V.name),this.p(Y)}$provideDocumentFormattingEdits(V,W,J,Y){return this.s(V,B,he=>he.provideDocumentFormattingEdits($.URI.revive(W),J,Y),void 0,Y)}registerDocumentRangeFormattingEditProvider(V,W,J){const Y=typeof J.provideDocumentRangesFormattingEdits=="function",he=this.t(new Z(this.h,J),V);return this.e.$registerRangeFormattingSupport(he,this.o(W,V),V.identifier,V.displayName||V.name,Y),this.p(he)}$provideDocumentRangeFormattingEdits(V,W,J,Y,he){return this.s(V,Z,we=>we.provideDocumentRangeFormattingEdits($.URI.revive(W),J,Y,he),void 0,he)}$provideDocumentRangesFormattingEdits(V,W,J,Y,he){return this.s(V,Z,we=>we.provideDocumentRangesFormattingEdits($.URI.revive(W),J,Y,he),void 0,he)}registerOnTypeFormattingEditProvider(V,W,J,Y){const he=this.t(new q(this.h,J),V);return this.e.$registerOnTypeFormattingSupport(he,this.o(W,V),Y,V.identifier),this.p(he)}$provideOnTypeFormattingEdits(V,W,J,Y,he,we){return this.s(V,q,je=>je.provideOnTypeFormattingEdits($.URI.revive(W),J,Y,he,we),void 0,we)}registerWorkspaceSymbolProvider(V,W){const J=this.t(new Q(W,this.l),V);return this.e.$registerNavigateTypeSupport(J,typeof W.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(V,W,J){return this.s(V,Q,Y=>Y.provideWorkspaceSymbols(W,J),{symbols:[]},J)}$resolveWorkspaceSymbol(V,W,J){return this.s(V,Q,Y=>Y.resolveWorkspaceSymbol(W,J),void 0,void 0)}$releaseWorkspaceSymbols(V,W){this.s(V,Q,J=>J.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(V,W,J){const Y=this.t(new x(this.h,J,this.l),V);return this.e.$registerRenameSupport(Y,this.o(W,V),x.supportsResolving(J)),this.p(Y)}$provideRenameEdits(V,W,J,Y,he){return this.s(V,x,we=>we.provideRenameEdits($.URI.revive(W),J,Y,he),void 0,he)}$resolveRenameLocation(V,W,J,Y){return this.s(V,x,he=>he.resolveRenameLocation($.URI.revive(W),J,Y),void 0,Y)}registerNewSymbolNamesProvider(V,W,J){const Y=this.t(new X(this.h,J,this.l),V);return this.e.$registerNewSymbolNamesProvider(Y,this.o(W,V)),this.p(Y)}$provideNewSymbolNames(V,W,J,Y){return this.s(V,X,he=>he.provideNewSymbolNames($.URI.revive(W),J,Y),void 0,Y)}registerDocumentSemanticTokensProvider(V,W,J,Y){const he=this.t(new me(this.h,J),V),we=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(W,V),Y,we);let je=this.p(he);if(we){const qe=J.onDidChangeSemanticTokens(Ye=>this.e.$emitDocumentSemanticTokensEvent(we));je=u.$3M.from(je,qe)}return je}$provideDocumentSemanticTokens(V,W,J,Y){return this.s(V,me,he=>he.provideDocumentSemanticTokens($.URI.revive(W),J,Y),null,Y)}$releaseDocumentSemanticTokens(V,W){this.s(V,me,J=>J.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,W,J,Y){const he=this.t(new ue(this.h,J),V);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(W,V),Y),this.p(he)}$provideDocumentRangeSemanticTokens(V,W,J,Y){return this.s(V,ue,he=>he.provideDocumentRangeSemanticTokens($.URI.revive(W),J,Y),null,Y)}registerCompletionItemProvider(V,W,J,Y){const he=this.t(new ve(this.h,this.j.converter,J,this.m,V),V);return this.e.$registerCompletionsProvider(he,this.o(W,V),Y,ve.supportsResolving(J),V.identifier),this.p(he)}$provideCompletionItems(V,W,J,Y,he){return this.s(V,ve,we=>we.provideCompletionItems($.URI.revive(W),J,Y,he),void 0,he)}$resolveCompletionItem(V,W,J){return this.s(V,ve,Y=>Y.resolveCompletionItem(W,J),void 0,J)}$releaseCompletionItems(V,W){this.s(V,ve,J=>J.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(V,W,J,Y){const he=new U(V,this.h,J,this.j.converter),we=this.t(he,V);return this.e.$registerInlineCompletionsSupport(we,this.o(W,V),he.supportsHandleEvents,n.$Qm.toKey(V.identifier.value),Y?.yieldTo?.map(je=>n.$Qm.toKey(je))||[]),this.p(we)}$provideInlineCompletions(V,W,J,Y,he){return this.s(V,te,we=>we.provideInlineCompletions($.URI.revive(W),J,Y,he),void 0,he)}$handleInlineCompletionDidShow(V,W,J,Y){this.s(V,te,async he=>{he.handleDidShowCompletionItem(W,J,Y)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,W,J,Y,he){this.s(V,te,async we=>{we.handlePartialAccept(W,J,Y,he)},void 0,void 0)}$freeInlineCompletionsList(V,W){this.s(V,te,async J=>{J.disposeCompletions(W)},void 0,void 0)}registerInlineEditProvider(V,W,J){const Y=new ee(V,this.h,J,this.j.converter),he=this.t(Y,V);return this.e.$registerInlineEditProvider(he,this.o(W,V),V.identifier),this.p(he)}$provideInlineEdit(V,W,J,Y){return this.s(V,ee,he=>he.provideInlineEdits($.URI.revive(W),J,Y),void 0,Y)}$freeInlineEdit(V,W){this.s(V,ee,async J=>{J.disposeEdit(W)},void 0,void 0)}registerSignatureHelpProvider(V,W,J,Y){const he=Array.isArray(Y)?{triggerCharacters:Y,retriggerCharacters:[]}:Y,we=this.t(new Ce(this.h,J),V);return this.e.$registerSignatureHelpProvider(we,this.o(W,V),he),this.p(we)}$provideSignatureHelp(V,W,J,Y,he){return this.s(V,Ce,we=>we.provideSignatureHelp($.URI.revive(W),J,Y,he),void 0,he)}$releaseSignatureHelp(V,W){this.s(V,Ce,J=>J.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(V,W,J){const Y=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new se(this.h,this.j.converter,J,this.l,V),V);this.e.$registerInlayHintsProvider(he,this.o(W,V),typeof J.resolveInlayHint=="function",Y,Ie.u(V));let we=this.p(he);if(Y!==void 0){const je=J.onDidChangeInlayHints(qe=>this.e.$emitInlayHintsEvent(Y));we=u.$3M.from(we,je)}return we}$provideInlayHints(V,W,J,Y){return this.s(V,se,he=>he.provideInlayHints($.URI.revive(W),J,Y),void 0,Y)}$resolveInlayHint(V,W,J){return this.s(V,se,Y=>Y.resolveInlayHint(W,J),void 0,J)}$releaseInlayHints(V,W){this.s(V,se,J=>J.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(V,W,J){const Y=this.t(new re(this.h,J),V);return this.e.$registerDocumentLinkProvider(Y,this.o(W,V),typeof J.resolveDocumentLink=="function"),this.p(Y)}$provideDocumentLinks(V,W,J){return this.s(V,re,Y=>Y.provideLinks($.URI.revive(W),J),void 0,J,W.scheme==="output")}$resolveDocumentLink(V,W,J){return this.s(V,re,Y=>Y.resolveLink(W,J),void 0,void 0,!0)}$releaseDocumentLinks(V,W){this.s(V,re,J=>J.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(V,W,J){const Y=this.t(new oe(this.h,J),V);return this.e.$registerDocumentColorProvider(Y,this.o(W,V)),this.p(Y)}$provideDocumentColors(V,W,J){return this.s(V,oe,Y=>Y.provideColors($.URI.revive(W),J),[],J)}$provideColorPresentations(V,W,J,Y){return this.s(V,oe,he=>he.provideColorPresentations($.URI.revive(W),J,Y),void 0,Y)}registerFoldingRangeProvider(V,W,J){const Y=this.q(),he=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Y,new Se(new K(this.h,J),V)),this.e.$registerFoldingRangeProvider(Y,this.o(W,V),V.identifier,he);let we=this.p(Y);if(he!==void 0){const je=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));we=u.$3M.from(we,je)}return we}$provideFoldingRanges(V,W,J,Y){return this.s(V,K,he=>he.provideFoldingRanges($.URI.revive(W),J,Y),void 0,Y)}registerSelectionRangeProvider(V,W,J){const Y=this.t(new ne(this.h,J,this.l),V);return this.e.$registerSelectionRangeProvider(Y,this.o(W,V)),this.p(Y)}$provideSelectionRanges(V,W,J,Y){return this.s(V,ne,he=>he.provideSelectionRanges($.URI.revive(W),J,Y),[],Y)}registerCallHierarchyProvider(V,W,J){const Y=this.t(new $e(this.h,J),V);return this.e.$registerCallHierarchyProvider(Y,this.o(W,V)),this.p(Y)}$prepareCallHierarchy(V,W,J,Y){return this.s(V,$e,he=>Promise.resolve(he.prepareSession($.URI.revive(W),J,Y)),void 0,Y)}$provideCallHierarchyIncomingCalls(V,W,J,Y){return this.s(V,$e,he=>he.provideCallsTo(W,J,Y),void 0,Y)}$provideCallHierarchyOutgoingCalls(V,W,J,Y){return this.s(V,$e,he=>he.provideCallsFrom(W,J,Y),void 0,Y)}$releaseCallHierarchy(V,W){this.s(V,$e,J=>Promise.resolve(J.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(V,W,J){const Y=this.t(new be(this.h,J),V);return this.e.$registerTypeHierarchyProvider(Y,this.o(W,V)),this.p(Y)}$prepareTypeHierarchy(V,W,J,Y){return this.s(V,be,he=>Promise.resolve(he.prepareSession($.URI.revive(W),J,Y)),void 0,Y)}$provideTypeHierarchySupertypes(V,W,J,Y){return this.s(V,be,he=>he.provideSupertypes(W,J,Y),void 0,Y)}$provideTypeHierarchySubtypes(V,W,J,Y){return this.s(V,be,he=>he.provideSubtypes(W,J,Y),void 0,Y)}$releaseTypeHierarchy(V,W){this.s(V,be,J=>Promise.resolve(J.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(V,W,J,Y){const he=this.q();return this.f.set(he,new Se(new Ae(this.e,this.h,J,he,V),V)),this.e.$registerDocumentOnDropEditProvider(he,this.o(W,V),(0,o.$FG)(V,"documentPaste")&&Y?{supportsResolve:!!J.resolveDocumentDropEdit,dropMimeTypes:Y.dropMimeTypes}:void 0),this.p(he)}$provideDocumentOnDropEdits(V,W,J,Y,he,we){return this.s(V,Ae,je=>Promise.resolve(je.provideDocumentOnDropEdits(W,$.URI.revive(J),Y,he,we)),void 0,void 0)}$resolveDropEdit(V,W,J){return this.s(V,Ae,Y=>Y.resolveDropEdit(W,J),{},void 0)}$releaseDropEdits(V,W){this.s(V,Ae,J=>Promise.resolve(J.releaseDropEdits(W)),void 0,void 0)}registerMappedEditsProvider(V,W,J){const Y=this.t(new fe(this.h,J),V);return this.e.$registerMappedEditsProvider(Y,this.o(W,V)),this.p(Y)}$provideMappedEdits(V,W,J,Y,he){return this.s(V,fe,we=>Promise.resolve(we.provideMappedEdits(W,J,Y,he)),null,he)}registerDocumentPasteEditProvider(V,W,J,Y){const he=this.q();return this.f.set(he,new Se(new F(this.e,this.h,J,he,V),V)),this.e.$registerPasteEditProvider(he,this.o(W,V),{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,supportsResolve:!!J.resolveDocumentPasteEdit,providedPasteEditKinds:Y.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:Y.copyMimeTypes,pasteMimeTypes:Y.pasteMimeTypes}),this.p(he)}$prepareDocumentPaste(V,W,J,Y,he){return this.s(V,F,we=>we.prepareDocumentPaste($.URI.revive(W),J,Y,he),void 0,he)}$providePasteEdits(V,W,J,Y,he,we,je){return this.s(V,F,qe=>qe.providePasteEdits(W,$.URI.revive(J),Y,he,we,je),void 0,je)}$resolvePasteEdit(V,W,J){return this.s(V,F,Y=>Y.resolvePasteEdit(W,J),{},void 0)}$releasePasteEdits(V,W){this.s(V,F,J=>Promise.resolve(J.releasePasteEdits(W)),void 0,void 0)}static w(V){return{pattern:V.source,flags:V.flags}}static y(V){return{decreaseIndentPattern:Ie.w(V.decreaseIndentPattern),increaseIndentPattern:Ie.w(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Ie.w(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Ie.w(V.unIndentedLinePattern):void 0}}static z(V){return{beforeText:Ie.w(V.beforeText),afterText:V.afterText?Ie.w(V.afterText):void 0,previousLineText:V.previousLineText?Ie.w(V.previousLineText):void 0,action:V.action}}static B(V){return V.map(Ie.z)}static C(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(W=>u.SyntaxTokenType.toString(W)):void 0}}static D(V){return V.map(Ie.C)}setLanguageConfiguration(V,W,J){const{wordPattern:Y}=J;if(Y&&(0,A.$jf)(Y))throw new Error(`Invalid language configuration: wordPattern '${Y}' is not allowed to match the empty string.`);Y?this.h.setWordDefinitionFor(W,Y):this.h.setWordDefinitionFor(W,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const he=this.q(),we={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Ie.w(J.wordPattern):void 0,indentationRules:J.indentationRules?Ie.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Ie.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?Ie.D(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(he,W,we),this.p(he)}$setWordDefinitions(V){for(const W of V)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.$$kc=Ie}),define(ke[122],Pe([1,0,3,6,16,8,109,25,7,4,227,146,13,5,20,121,11,39]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=e.$Rlc=void 0,e.$Rlc=(0,y.$vi)("IExtHostLanguageModels");class i{constructor(l,r){this.option=l,this.stream=new m.$Yh,this.stream=r??new m.$Yh}}class u{constructor(){this.a=new Map,this.b=new m.$Yh,this.c=!1,this.d=!1;const l=this;this.apiObject={stream:l.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,l]of this.a)yield l.stream;else yield this.b}handleFragment(l){if(this.c)return;this.d=!0;let r=this.a.get(l.index);r||(this.a.size===0?r=new i(l.index,this.b):r=new i(l.index),this.a.set(l.index,r)),r.stream.emitOne(l.part)}get isStreaming(){return this.d}reject(l){this.c=!0;for(const r of this.f())r.reject(l)}resolve(){this.c=!0;for(const l of this.f())l.resolve()}}let o=class{static{n=this}static{this.a=1}constructor(l,r,c){this.j=r,this.k=c,this.c=new E.$ee,this.d=new E.$ee,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new b.$Sm,this.i=new Map,this.o=new Set,this.b=l.getProxy(N.$1M.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(l,r,c,s){const v=n.a++;this.f.set(v,{extension:l.identifier,provider:c,languageModelId:r});let f;return s.auth&&(f={providerLabel:l.displayName||l.name,accountLabel:typeof s.auth=="object"?s.auth.label:void 0}),this.b.$registerLanguageModelProvider(v,r,{extension:l.identifier,identifier:r,name:s.name??"",version:s.version,tokens:s.tokens,auth:f}),(0,d.$Tc)(()=>{this.f.delete(v),this.b.$unregisterProvider(v)})}async $provideLanguageModelResponse(l,r,c,s,v,f){const S=this.f.get(l);if(!S)return;const p=new M.$9v(async k=>{if(f.isCancellationRequested){this.j.warn(`[CHAT](${S.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:k.index,part:k.part})});return S.provider.provideLanguageModelResponse2(s.map(L.LanguageModelMessage.to),v,b.$Qm.toKey(c),p,f)}$provideTokenLength(l,r,c){const s=this.f.get(l);return s?Promise.resolve(s.provider.provideTokenCount(r,c)):Promise.resolve(0)}$updateLanguageModels(l){const r=[],c=[];if(l.added)for(const s of l.added)this.g.set(s.identifier,s),r.push(s.identifier);if(l.removed)for(const s of l.removed){this.g.delete(s),c.push(s);for(const[v,f]of this.i)f.languageModelId===s&&(f.res.reject(new $.$5),this.i.delete(v))}this.d.fire(Object.freeze({added:Object.freeze(r),removed:Object.freeze(c)})),l.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(l){const r=new Array;for(const{from:c,to:s,enabled:v}of l){const f=this.h.get(c)??new b.$Rm;if(f.has(s)!==v){v?f.add(s):f.delete(s),this.h.set(c,f);const p={from:c,to:s};r.push(p),this.c.fire(p)}}}async sendChatRequest(l,r,c,s,v){const f=l.identifier,S=await this.b.$prepareChatAccess(f,r,s.justification);if(!S||!this.g.has(r))throw R.$bP.NotFound(`Language model '${r}' is unknown.`);if(this.m(f,S)&&(!await this.l(l,{identifier:S.extension,displayName:S.auth.providerLabel},s.justification,s.silent)||!this.h.get(f)?.has(S.extension)))throw R.$bP.NoPermissions(`Language model '${r}' cannot be used by '${f.value}'.`);const p=Math.random()*1e6|0,k=this.b.$fetchResponse(f,r,p,c.map(L.LanguageModelMessage.from),s.modelOptions??{},v),P=new m.$uh,C=new u;this.i.set(p,{languageModelId:r,res:C});let I;if(k.catch(T=>{P.isOpen()?C.reject(T):I=T}).finally(()=>{this.i.delete(p),C.resolve(),P.open()}),await P.wait(),I)throw new R.$bP(`Language model '${r}' errored, check cause for more details`,"Unknown",I);return C.apiObject}async $handleResponseFragment(l,r){const c=this.i.get(l);c&&c.res.handleFragment(r)}async l(l,r,c,s){const v=D.$3L+r.identifier.value;if(await this.k.getSession(l,v,[],{silent:!0}))return this.$updateModelAccesslist([{from:l.identifier,to:r.identifier,enabled:!0}]),!0;if(s)return!1;try{const S=c?(0,A.localize)(0,null,r.displayName,c):(0,A.localize)(1,null,r.displayName);return await this.k.getSession(l,v,[],{forceNewSession:{detail:S}}),this.$updateModelAccesslist([{from:l.identifier,to:r.identifier,enabled:!0}]),!0}catch{return!1}}m(l,r){return!!r.auth&&!b.$Qm.equals(r.extension,l)}async n(l){for(const r of this.o)try{await this.l(r,{identifier:l.extension,displayName:""},void 0,!0)}catch(c){this.j.error("Fake Auth request failed"),this.j.error(c)}}async computeTokenLength(l,r,c){const s=this.g.get(l);if(!s)throw R.$bP.NotFound(`Language model '${l}' is unknown.`);const v=a.Iterable.find(this.f.values(),f=>f.languageModelId===l);return v?v.provider.provideTokenCount(r,c):this.b.$countTokens(s.identifier,typeof r=="string"?r:L.LanguageModelMessage.from(r),c)}getLanguageModelInfo(l){const r=this.g.get(l);if(r)return{id:r.identifier,name:r.name,version:r.version,tokens:r.tokens}}createLanguageModelAccessInformation(l){this.o.add(l);const r=this,c=E.Event.signal(E.Event.filter(this.c.event,v=>b.$Qm.equals(v.from,l.identifier))),s=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(c,s)},canSendRequest(v){const f=r.g.get(v);if(!f)return;if(!r.m(l.identifier,f))return!0;const S=r.h.get(l.identifier);if(S)return S.has(f.extension)}}}};e.$Slc=o,e.$Slc=o=n=Je([Ve(0,w.$oP),Ve(1,g.$2j),Ve(2,h.$alc)],o)}),define(ke[344],Pe([1,0,6,16,8,41,7,3,26]),function(le,e,d,N,L,R,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xmc=void 0;class E{constructor(D,$,y,w){this.c=$,this.d=y,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(d.$1M.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,$){await this.a.$changeLanguage(D,$);const y=this.c.getDocumentData(D);if(!y)throw new Error(`document '${D.toString()}' NOT found`);return y.document}async tokenAtPosition(D,$){const y=D.version,w=N.Position.from($),h=await this.a.$tokensAtPosition(D.uri,w),g={type:L.StandardTokenType.Other,range:D.getWordRangeAtPosition($)??new L.$5M($.line,$.character,$.line,$.character)};if(!h)return g;const a={range:N.Range.to(h.range),type:N.TokenType.to(h.type)};return!a.range.contains($)||y!==D.version?g:a}createLanguageStatusItem(D,$,y){const w=this.f++,h=this.a,g=this.g,a=`${D.identifier.value}/${$}`;if(g.has(a))throw new Error(`LanguageStatusItem with id '${$}' ALREADY exists`);g.add(a);const n={selector:y,id:$,name:D.displayName??D.name,severity:L.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const u=new b.$Uc,o=()=>{if(i?.dispose(),!g.has(a)){console.warn(`LanguageStatusItem (${$}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,M.$xh)(()=>{u.clear(),this.a.$setLanguageStatus(w,{id:a,name:n.name??D.displayName??D.name,source:D.displayName??D.name,selector:N.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===L.LanguageStatusSeverity.Error?R.default.Error:n.severity===L.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:n.command&&this.d.toInternal(n.command,u),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){u.dispose(),i?.dispose(),h.$removeLanguageStatus(w),g.delete(a)},get id(){return n.id},get name(){return n.name},set name(l){n.name=l,o()},get selector(){return n.selector},set selector(l){n.selector=l,o()},get text(){return n.text},set text(l){n.text=l,o()},set text2(l){(0,m.$GG)(D,"languageStatusText"),n.text=l,o()},get text2(){return(0,m.$GG)(D,"languageStatusText"),n.text},get detail(){return n.detail},set detail(l){n.detail=l,o()},get severity(){return n.severity},set severity(l){n.severity=l,o()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(l){n.accessibilityInformation=l,o()},get command(){return n.command},set command(l){n.command=l,o()},get busy(){return n.busy},set busy(l){n.busy=l,o()}};return o(),t}}e.$xmc=E}),define(ke[345],Pe([1,0,15,2,16,8,120]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kmc=e.$jmc=void 0;class b{constructor(D,$,y,w){this.start=D,this.deletedCount=$,this.deletedItems=y,this.items=w}asApiEvent(){return{range:new R.$sO(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(D){return{EOL:D.eol,lines:D.source,languageId:D.language,uri:D.uri,isDirty:!1,versionId:1}}constructor(D,$,y){this.notebook=D,this.h=$,this.j=y,this.handle=y.handle,this.uri=N.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(L.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(L.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,$=this.h.getDocument(this.uri);if(!$)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:L.NotebookCellKind.to(this.j.cellKind),document:$.document,get mime(){return D.g},set mime(w){D.g=w},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(y)}return this.f}setOutputs(D){this.a=D.map(L.NotebookCellOutput.to)}setOutputItems(D,$,y){const w=y.map(L.NotebookCellOutputItem.to),h=this.a.find(g=>g.id===D);if(h&&($||(h.items.length=0),h.items.push(...w),h.items.length>1&&h.items.every(g=>M.$XK(g.mime)))){const g=new Map,a=[];h.items.forEach(n=>{let i;g.has(n.mime)?i=g.get(n.mime):(i=[],g.set(n.mime,i),a.push(n.mime)),i.push(n.data)}),h.items.length=0,a.forEach(n=>{const i=M.$YK(g.get(n));h.items.push({mime:n,data:i.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(L.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$jmc=m;class E{static{this.a=0}constructor(D,$,y,w,h){this.k=D,this.l=$,this.m=y,this.uri=w,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=h.viewType,this.f=Object.freeze(h.metadata??Object.create(null)),this.r([[0,0,h.cells]],!0,void 0),this.g=h.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,$={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===d.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(y){return y=D.n(y),D.b[y].apiCell},getCells(y){return(y?D.p(y):D.b).map(h=>h.apiCell)},save(){return D.q()}};this.e=Object.freeze($)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,$,y){this.g=D.versionId,this.h=$,this.acceptDocumentPropertiesChanged({metadata:y});const w={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},h=[];for(const a of D.rawEvents)a.kind===M.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,w.contentChanges):a.kind===M.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,w.contentChanges):a.kind===M.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),h.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===M.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),h.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),h.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===M.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),h.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),h.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const g=new Map;for(let a=0;a<h.length;a++){const n=h[a],i=g.get(n.cell);if(i===void 0){const u=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});g.set(n.cell,u-1)}else w.cellChanges[i]={...w.cellChanges[i],...n}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let $=D.start|0,y=D.end|0;return $<0&&($=0),y>this.b.length&&(y=this.b.length),D.with({start:$,end:y})}p(D){D=this.o(D);const $=[];for(let y=D.start;y<D.end;y++)$.push(this.b[y]);return $}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,$,y){if(this.j)return;const w=[],h=[],g=[];if(D.reverse().forEach(a=>{const i=a[2].map(t=>{const l=new m(this,this.l,t);return $||h.push(m.asModelAddData(t)),l}),u=new b(a[0],a[1],[],i),o=this.b.splice(a[0],a[1],...i);for(const t of o)g.push(t.uri),u.deletedItems.push(t.apiCell);w.push(u)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:g}),y)for(const a of w)y.push(a.asApiEvent())}s(D,$,y,w){const h=this.b.splice(D,$);this.b.splice(y,0,...h);const g=[new b(D,$,h.map(a=>a.apiCell),[]),new b(y,0,[],h)];for(const a of g)w.push(a.asApiEvent())}t(D,$){this.b[D].setOutputs($)}u(D,$,y,w){this.b[D].setOutputItems($,y,w)}v(D,$){const y=this.b[D];y.apiCell.document.languageId!==$&&this.m.$acceptModelLanguageChanged(y.uri,$)}w(D,$){const y=this.b[D];y.apiCell.mime=$}x(D,$){this.b[D].setMetadata($)}y(D,$){this.b[D].setInternalMetadata($)}getCellFromApiCell(D){return this.b.find($=>$.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find($=>$.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$kmc=E}),define(ke[346],Pe([1,0,4,2,16,8,48]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=void 0;class b{constructor(E,A,D,$={timeout:1500,errors:3}){this.b=E,this.c=A,this.d=D,this.f=$,this.a=new d.$ge}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(A,D,$)=>{const y=function(h){A.call(D,h)};return y.extension=E,this.a.event(y,void 0,$)}}async $participateInSave(E,A,D){const $=N.URI.revive(E),y=this.c.getNotebookDocument($);if(!y)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:y.apiNotebook,reason:L.TextDocumentSaveReason.to(A)},D,async(g,a)=>{const n=Date.now(),i=await await Promise.resolve(g);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!D.isCancellationRequested&&i&&(i instanceof R.$aN?w.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),D.isCancellationRequested)return!1;if(w.length===0)return!0;const h={edits:[]};for(const g of w){const{edits:a}=L.WorkspaceEdit.from(g);h.edits=h.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(new M.$uw(h))}}e.$zmc=b}),define(ke[154],Pe([1,0,13,16,8]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,m,E,A,D,$){this.id=b,this.f=m,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=A,this.c=$}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection(m){this.selections=[m]},get selections(){return b.a},set selections(m){if(!Array.isArray(m)||!m.every(L.$sO.isNotebookRange))throw(0,d.$7)("selections");b.a=m,b.g(m)},get visibleRanges(){return b.b},revealRange(m,E){b.f.$tryRevealRange(b.id,N.NotebookRange.from(m),E??L.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(N.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$lmc=R}),define(ke[347],Pe([1,0,4,11,16]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=void 0;let R=class{constructor(b,m){this.c=b,this.d=m,this.a=new d.$ee,this.b=new d.$ee,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,m);const E=this.d.getEditorById(b);m.visibleRanges&&E._acceptVisibleRanges(m.visibleRanges.ranges.map(L.NotebookRange.to)),m.selections&&E._acceptSelections(m.selections.selections.map(L.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const m in b)this.d.getEditorById(m)._acceptViewColumn(L.ViewColumn.to(b[m]))}};e.$Bmc=R,e.$Bmc=R=Je([Ve(0,N.$2j)],R)}),define(ke[348],Pe([1,0,4,6,154]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=void 0;class R{constructor(b,m){this.c=m,this.a=new Map,this.b=b.getProxy(N.$1M.MainThreadNotebookRenderers)}$postRendererMessage(b,m,E){const A=this.c.getEditorById(b);this.a.get(m)?.fire({editor:A.apiEditor,message:E})}createRendererMessaging(b,m){if(!b.contributes?.notebookRenderer?.some(A=>A.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(A,D,$)=>this.d(m).event(A,D,$),postMessage:(A,D)=>{L.$lmc.apiEditorsToExtHost.has(A)&&([A,D]=[D,A]);const $=D&&L.$lmc.apiEditorsToExtHost.get(D);return this.b.$postMessage($?.id,m,A)}}}d(b){let m=this.a.get(b);return m||(m=new d.$ee({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete(b)}}),this.a.set(b,m),m)}}e.$Emc=R}),define(ke[349],Pe([1,0,16,109,22,55,13]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;class b{constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,$,y){const w=this.b++,{title:h,location:g,cancellable:a}=$,n={label:D.displayName||D.name,id:D.identifier.value};return this.a.$startProgress(w,{location:d.ProgressLocation.from(g),title:h,source:n,cancellable:a},D.isUnderDevelopment?void 0:D.identifier.value).catch(M.$2),this.d(w,y,!!a)}d(D,$,y){let w;y&&(w=new L.$pe,this.c.set(D,w));const h=a=>{this.a.$progressEnd(a),this.c.delete(a),w?.dispose()};let g;try{g=$(new E(this.a,D),y&&w?w.token:L.CancellationToken.None)}catch(a){throw h(D),a}return g.then(a=>h(D),a=>h(D)),g}$acceptProgressCanceled(D){const $=this.c.get(D);$&&($.cancel(),this.c.delete(D))}}e.$Imc=b;function m(A,D){return A.message=D.message,typeof D.increment=="number"&&(typeof A.increment=="number"?A.increment+=D.increment:A.increment=D.increment),A}class E extends N.$9v{constructor(D,$){super(y=>this.throttledReport(y)),this.c=D,this.d=$}throttledReport(D){this.c.$progressReport(this.d,D)}}Je([(0,R.$2h)(100,(A,D)=>m(A,D),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(ke[350],Pe([1,0,2,6,7,16]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;class M{static{this.a=0}constructor(m,E){this.d=E,this.c=new Map,this.b=m.getProxy(N.$1M.MainThreadQuickDiff)}$provideOriginalResource(m,E,A){const D=d.URI.revive(E),$=this.c.get(m);return $?(0,L.$nh)(()=>$.provideOriginalResource(D,A)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(m,E,A,D){const $=M.a++;return this.c.set($,E),this.b.$registerQuickDiffProvider($,R.DocumentSelector.from(m,this.d),A,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider($),this.c.delete($)}}}}e.$Jmc=M}),define(ke[351],Pe([1,0,22,4,3,6,2,8,13,19,41,57,26,16]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=w;function w(h,g,a){const n=h.getProxy(R.$1M.MainThreadQuickOpen);class i{constructor(f,S){this.e=new Map,this.f=0,this.a=f,this.b=S}showQuickPick(f,S,p,k=d.CancellationToken.None){this.c=void 0;const P=Promise.resolve(S),C=++this.f,I=n.$show(C,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},k),T={},j=I.then(()=>T);return Promise.race([j,P]).then(z=>{if(z===T)return;const O=(0,$.$FG)(f,"quickPickItemTooltip");return P.then(F=>{const B=[];for(let Z=0;Z<F.length;Z++){const q=F[Z];if(typeof q=="string")B.push({label:q,handle:Z});else if(q.kind===b.QuickPickItemKind.Separator)B.push({type:"separator",label:q.label});else{q.tooltip&&!O&&console.warn(`Extension '${f.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${f.identifier.value}`);const Q=q.iconPath?r(q.iconPath):void 0;B.push({label:q.label,iconPath:Q?.iconPath,iconClass:Q?.iconClass,description:q.description,detail:q.detail,picked:q.picked,alwaysShow:q.alwaysShow,tooltip:O?y.MarkdownString.fromStrict(q.tooltip):void 0,handle:Z})}}return p&&typeof p.onDidSelectItem=="function"&&(this.c=Z=>{p.onDidSelectItem(F[Z])}),n.$setItems(C,B),I.then(Z=>{if(typeof Z=="number")return F[Z];if(Array.isArray(Z))return Z.map(q=>F[q])})})}).then(void 0,z=>{if(!(0,m.$4)(z))return n.$setError(C,z),Promise.reject(z)})}$onItemSelected(f){this.c?.(f)}showInput(f,S=d.CancellationToken.None){return this.d=f?.validateInput,n.$input(f,typeof this.d=="function",S).then(void 0,p=>{if(!(0,m.$4)(p))return Promise.reject(p)})}async $validateInput(f){if(!this.d)return;const S=await this.d(f);if(!S||typeof S=="string")return S;let p;switch(S.severity){case b.InputBoxValidationSeverity.Info:p=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:p=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:p=A.default.Error;break;default:p=S.message?A.default.Error:A.default.Ignore;break}return{content:S.message,severity:p}}async showWorkspaceFolderPick(f,S=d.CancellationToken.None){const p=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!p)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(P=>P.uri.toString()===p.uri.toString())}createQuickPick(f){const S=new c(f,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(f){const S=new s(f,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(f,S){this.e.get(f)?._fireDidChangeValue(S)}$onDidAccept(f){this.e.get(f)?._fireDidAccept()}$onDidChangeActive(f,S){const p=this.e.get(f);p instanceof c&&p._fireDidChangeActive(S)}$onDidChangeSelection(f,S){const p=this.e.get(f);p instanceof c&&p._fireDidChangeSelection(S)}$onDidTriggerButton(f,S){this.e.get(f)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(f,S,p){const k=this.e.get(f);k instanceof c&&k._fireDidTriggerItemButton(S,p)}$onDidHide(f){this.e.get(f)?._fireDidHide()}}class u{static{this.a=1}constructor(f,S){this.x=f,this.y=S,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$ee,this.q=new N.$ee,this.r=new N.$ee,this.s=new N.$ee,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(f){this.b=f,this.z({title:f})}get step(){return this.c}set step(f){this.c=f,this.z({step:f})}get totalSteps(){return this.d}set totalSteps(f){this.d=f,this.z({totalSteps:f})}get enabled(){return this.g}set enabled(f){this.g=f,this.z({enabled:f})}get busy(){return this.j}set busy(f){this.j=f,this.z({busy:f})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(f){this.k=f,this.z({ignoreFocusOut:f})}get value(){return this.l}set value(f){this.l=f,this.z({value:f})}get placeholder(){return this.m}set placeholder(f){this.m=f,this.z({placeholder:f})}get buttons(){return this.n}set buttons(f){this.n=f.slice(),this.o.clear(),f.forEach((S,p)=>{const k=S===b.$pO.Back?-1:p;this.o.set(k,S)}),this.z({buttons:f.map((S,p)=>({...r(S.iconPath),tooltip:S.tooltip,handle:S===b.$pO.Back?-1:p}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(f){this.l=f,this.q.fire(f)}_fireDidTriggerButton(f){const S=this.o.get(f);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,L.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(f){if(!this.v){for(const S of Object.keys(f)){const p=f[S];this.u[S]=p===void 0?null:p}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function o(v){if(v instanceof b.$ZN)return{id:v.id};const f=l(v),S=t(v);return{dark:typeof f=="string"?M.URI.file(f):f,light:typeof S=="string"?M.URI.file(S):S}}function t(v){return typeof v=="object"&&"light"in v?v.light:v}function l(v){return typeof v=="object"&&"dark"in v?v.dark:v}function r(v){const f=o(v);let S,p;return"id"in f?p=D.ThemeIcon.asClassName(f):S=f,{iconPath:S,iconClass:p}}class c extends u{constructor(f,S){super(f.identifier,S),this.O=f,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$ee,this.L=[],this.M=new N.$ee,this.N=new N.$ee,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(f){this.B=f.slice(),this.C.clear(),this.D.clear(),f.forEach((k,P)=>{this.C.set(P,k),this.D.set(k,P)});const S=(0,$.$FG)(this.O,"quickPickItemTooltip"),p=[];for(let k=0;k<f.length;k++){const P=f[k];if(P.kind===b.QuickPickItemKind.Separator)p.push({type:"separator",label:P.label});else{P.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=P.iconPath?r(P.iconPath):void 0;p.push({handle:k,label:P.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:P.description,detail:P.detail,picked:P.picked,alwaysShow:P.alwaysShow,tooltip:S?y.MarkdownString.fromStrict(P.tooltip):void 0,buttons:P.buttons?.map((I,T)=>({...r(I.iconPath),tooltip:I.tooltip,handle:T}))})}}this.z({items:p})}get canSelectMany(){return this.E}set canSelectMany(f){this.E=f,this.z({canSelectMany:f})}get matchOnDescription(){return this.F}set matchOnDescription(f){this.F=f,this.z({matchOnDescription:f})}get matchOnDetail(){return this.G}set matchOnDetail(f){this.G=f,this.z({matchOnDetail:f})}get sortByLabel(){return this.H}set sortByLabel(f){this.H=f,this.z({sortByLabel:f})}get keepScrollPosition(){return this.I}set keepScrollPosition(f){this.I=f,this.z({keepScrollPosition:f})}get activeItems(){return this.J}set activeItems(f){this.J=f.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(f){this.L=f.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(f){const S=(0,E.$Hb)(f.map(p=>this.C.get(p)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(f){const S=(0,E.$Hb)(f.map(p=>this.C.get(p)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(f,S){const p=this.C.get(f);if(!p||!p.buttons||!p.buttons.length)return;const k=p.buttons[S];k&&this.N.fire({button:k,item:p})}}class s extends u{constructor(f,S){super(f.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(f){this.B=f,this.z({password:f})}get prompt(){return this.C}set prompt(f){this.C=f,this.z({prompt:f})}get valueSelection(){return this.D}set valueSelection(f){this.D=f,this.z({valueSelection:f})}get validationMessage(){return this.E}set validationMessage(f){this.E=f,f?typeof f=="string"?this.z({validationMessage:f,severity:A.default.Error}):this.z({validationMessage:f.message,severity:f.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new i(g,a)}}),define(ke[352],Pe([1,0,2,4,55,3,7,6,19,132,11,25,57,16,26,15,12]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=e.$Lmc=void 0;function n(C){return C instanceof d.URI}function i(C,I){return C.scheme===h.Schemas.file&&I.scheme===h.Schemas.file&&g.$k?C.toString()===I.toString():C.toString().toLowerCase()===I.toString().toLowerCase()}function u(C){if(C)return typeof C.iconPath=="string"?d.URI.file(C.iconPath):d.URI.isUri(C.iconPath)||$.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function o(C){if(C.icon){if(d.URI.isUri(C.icon))return C.icon;if($.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const I=C.icon;return{light:I.light,dark:I.dark}}}else return}function t(C,I){if(!C.iconPath&&!I.iconPath)return 0;if(C.iconPath){if(!I.iconPath)return 1}else return-1;const T=typeof C.iconPath=="string"?C.iconPath:d.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,j=typeof I.iconPath=="string"?I.iconPath:d.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,E.$pr)(T,j)}function l(C,I){let T=0;if(C.strikeThrough!==I.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==I.faded)return C.faded?1:-1;if(C.tooltip!==I.tooltip)return(C.tooltip||"").localeCompare(I.tooltip||"");if(T=t(C,I),T!==0)return T;if(C.light&&I.light)T=t(C.light,I.light);else{if(C.light)return 1;if(I.light)return-1}if(T!==0)return T;if(C.dark&&I.dark)T=t(C.dark,I.dark);else{if(C.dark)return 1;if(I.dark)return-1}return T}function r(C,I){if(C.command!==I.command)return C.command<I.command?-1:1;if(C.title!==I.title)return C.title<I.title?-1:1;if(C.tooltip!==I.tooltip){if(C.tooltip!==void 0&&I.tooltip!==void 0)return C.tooltip<I.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(C.arguments===I.arguments)return 0;if(C.arguments)if(I.arguments){if(C.arguments.length!==I.arguments.length)return C.arguments.length-I.arguments.length}else return 1;else return-1;for(let T=0;T<C.arguments.length;T++){const j=C.arguments[T],z=I.arguments[T];if(j!==z&&!(n(j)&&n(z)&&i(j,z)))return j<z?-1:1}return 0}function c(C,I){let T=(0,E.$pr)(C.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(T!==0)return T;if(C.command&&I.command)T=r(C.command,I.command);else{if(C.command)return 1;if(I.command)return-1}if(T!==0)return T;if(C.decorations&&I.decorations)T=l(C.decorations,I.decorations);else{if(C.decorations)return 1;if(I.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&I.multiFileDiffEditorModifiedUri)T=(0,E.$pr)(C.multiFileDiffEditorModifiedUri.fsPath,I.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(I.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&I.multiDiffEditorOriginalUri)T=(0,E.$pr)(C.multiDiffEditorOriginalUri.fsPath,I.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(I.multiDiffEditorOriginalUri)return-1}return T}function s(C,I){for(let T=0;T<C.length;T++)if(C[T]!==I[T])return!1;return!0}function v(C,I){return C.command===I.command&&C.title===I.title&&C.tooltip===I.tooltip&&(C.arguments&&I.arguments?s(C.arguments,I.arguments):C.arguments===I.arguments)}function f(C,I){return(0,m.$ub)(C,I,v)}class S{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.l,I),this.n(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.l,I),this.f=I}get validateInput(){return(0,w.$GG)(this.k,"scmValidation"),this.g}set validateInput(I){if((0,w.$GG)(this.k,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.l,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.l,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.l,I))}get document(){return(0,w.$GG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(I,T,j,z,O){this.k=I,this.l=z,this.m=O,this.d="",this.e=new N.$ee,this.f="",this.h=!0,this.j=!0,this.#t=T,this.#e=j}showValidationMessage(I,T){(0,w.$GG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,I,T)}$onInputBoxValueChange(I){this.n(I)}n(I){this.d=I,this.e.fire(I)}}e.$Lmc=S;class p{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,T,j,z,O,F,B){this.q=I,this.s=T,this.t=j,this.u=z,this.v=O,this.multiDiffEditorEnableViewChanges=F,this.w=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$ee,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$ee,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=p.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,T){const j=this.h.get(I);return j?(0,M.$nh)(()=>this.s.executeCommand(j.command,...j.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(c),j=(0,m.$Db)(this.o,I,c).map(F=>{const B=F.toInsert.map(Z=>{const q=this.e++;this.g.set(q,Z);const Q=Z.resourceUri;let x;if(Z.command)if(Z.command.command==="vscode.open"||Z.command.command==="vscode.diff"||Z.command.command==="vscode.changes"){const oe=new R.$Uc;x=this.s.converter.toInternal(Z.command,oe),this.j.set(q,oe)}else this.h.set(q,Z.command);const X=(0,w.$FG)(this.w,"scmMultiDiffEditor"),ie=X?Z.multiDiffEditorOriginalUri:void 0,me=X?Z.multiFileDiffEditorModifiedUri:void 0,ue=u(Z.decorations),ve=Z.decorations&&u(Z.decorations.light)||ue,te=Z.decorations&&u(Z.decorations.dark)||ue,U=[ve,te],ee=Z.decorations&&Z.decorations.tooltip||"",pe=Z.decorations&&!!Z.decorations.strikeThrough,Ce=Z.decorations&&!!Z.decorations.faded,se=Z.contextValue||"";return{rawResource:[q,Q,U,ee,pe,Ce,se,x,ie,me],handle:q}});return{start:F.start,deleteCount:F.deleteCount,toInsert:B}}),z=j.map(({start:F,deleteCount:B,toInsert:Z})=>[F,B,Z.map(q=>q.rawResource)]),O=j.reverse();for(const{start:F,deleteCount:B,toInsert:Z}of O){const q=Z.map(x=>x.handle),Q=this.n.splice(F,B,...q);for(const x of Q)this.g.delete(x),this.h.delete(x),this.j.get(x)?.dispose(),this.j.delete(x)}return this.o=I,z}dispose(){this.l=!0,this.m.fire()}}class k{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.w,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let T;(0,w.$FG)(this.x,"quickDiffProvider")&&(T=I?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!I,quickDiffLabel:T})}get historyProvider(){return(0,w.$GG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(I){(0,w.$GG)(this.x,"scmHistoryProvider"),this.j=I,this.k.value=new R.$Uc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!I}),I&&this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(I){I!==this.m&&(this.m=I,this.#e.$updateSourceControl(this.w,{commitTemplate:I}))}get acceptInputCommand(){return this.o}set acceptInputCommand(I){this.n.value=new R.$Uc,this.o=I;const T=this.y.converter.toInternal(I,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:T})}get actionButton(){return(0,w.$GG)(this.x,"scmActionButton"),this.q}set actionButton(I){(0,w.$GG)(this.x,"scmActionButton"),this.p.value=new R.$Uc,this.q=I;const T=I!==void 0?{command:this.y.converter.toInternal(I.command,this.p.value),secondaryCommands:I.secondaryCommands?.map(j=>j.map(z=>this.y.converter.toInternal(z,this.p.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:T??null})}get statusBarCommands(){return this.t}set statusBarCommands(I){if(this.t&&I&&f(this.t,I))return;this.s.value=new R.$Uc,this.t=I;const T=(I||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:T})}get selected(){return this.u}constructor(I,T,j,z,O,F,B){this.x=I,this.y=z,this.z=O,this.A=F,this.B=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Wc,this.m=void 0,this.n=new R.$Wc,this.o=void 0,this.p=new R.$Wc,this.s=new R.$Wc,this.t=void 0,this.u=!1,this.v=new N.$ee,this.onDidChangeSelection=this.v.event,this.w=k.d++,this.C=new Map,this.D=new Set,this.#e=j;const Z=d.URI.from({scheme:h.Schemas.vscodeSourceControl,path:`${O}/scm${this.w}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new S(I,T,this.#e,this.w,Z),this.#e.$registerSourceControl(this.w,O,F,B,Z)}createResourceGroup(I,T,j){const z=(0,w.$FG)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,O=new p(this.#e,this.y,this.w,I,T,z,this.x),F=N.Event.once(O.onDidDispose)(()=>this.C.delete(O));return this.C.set(O,F),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const I=[],T=[];for(const[j,z]of this.C){z.dispose();const O=j.onDidUpdateResourceStates(()=>{this.D.add(j),this.eventuallyUpdateResourceStates()});N.Event.once(j.onDidDispose)(()=>{this.D.delete(j),O.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),I.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const F=j._takeResourceStateSnapshot();F.length>0&&T.push([j.handle,F]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,I,T),this.C.clear()}eventuallyUpdateResourceStates(){const I=[];this.D.forEach(T=>{const j=T._takeResourceStateSnapshot();j.length!==0&&I.push([T.handle,j])}),I.length>0&&this.#e.$spliceResourceStates(this.w,I),this.D.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.u=I,this.v.fire(I)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,L.$1h)(100)],k.prototype,"eventuallyAddResourceGroups",null),Je([(0,L.$1h)(100)],k.prototype,"eventuallyUpdateResourceStates",null);let P=class{static{a=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(I,T,j,z){this.l=T,this.m=j,this.n=z,this.g=new Map,this.h=new D.$Sm,this.j=new N.$ee,this.e=I.getProxy(b.$1M.MainThreadSCM),this.f=I.getProxy(b.$1M.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const F=this.g.get(O.sourceControlHandle);if(!F)return O;const B=F.getResourceGroup(O.groupHandle);return B?B.getResourceState(O.handle):O}else if(O&&O.$mid===4){const F=this.g.get(O.sourceControlHandle);return F?F.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const F=this.g.get(O.handle);return F||O}return O}})}createSourceControl(I,T,j,z){this.n.trace("ExtHostSCM#createSourceControl",I.identifier.value,T,j,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const O=a.d++,F=new k(I,this.m,this.e,this.l,T,j,z);this.g.set(O,F);const B=this.h.get(I.identifier)||[];return B.push(F),this.h.set(I.identifier,B),F}getLastInputBox(I){this.n.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const T=this.h.get(I.identifier),j=T&&T[T.length-1];return j&&j.inputBox}$provideOriginalResource(I,T,j){const z=d.URI.revive(T);this.n.trace("ExtHostSCM#$provideOriginalResource",I,z.toString());const O=this.g.get(I);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$nh)(()=>O.quickDiffProvider.provideOriginalResource(z,j)).then(F=>F||null)}$onInputBoxValueChange(I,T){this.n.trace("ExtHostSCM#$onInputBoxValueChange",I);const j=this.g.get(I);return j&&j.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(I,T,j,z){this.n.trace("ExtHostSCM#$executeResourceCommand",I,T,j);const O=this.g.get(I);if(!O)return Promise.resolve(void 0);const F=O.getResourceGroup(T);return F?F.$executeResourceCommand(j,z):Promise.resolve(void 0)}$validateInput(I,T,j){this.n.trace("ExtHostSCM#$validateInput",I);const z=this.g.get(I);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,M.$nh)(()=>z.inputBox.validateInput(T,j)).then(O=>{if(!O)return Promise.resolve(void 0);const F=y.MarkdownString.fromStrict(O.message);return F?Promise.resolve([F,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.g.get(I)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(I,T,j,z){return await this.g.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(T,j,z)??void 0}async $provideHistoryItems(I,T,j,z){return(await this.g.get(I)?.historyProvider?.provideHistoryItems(T,j,z))?.map(B=>({...B,icon:o(B)}))??void 0}async $provideHistoryItemSummary(I,T,j,z){const O=this.g.get(I)?.historyProvider;if(typeof O?.provideHistoryItemSummary!="function")return;const F=await O.provideHistoryItemSummary(T,j,z);return F?{...F,icon:o(F)}:void 0}async $provideHistoryItemChanges(I,T,j,z){return await this.g.get(I)?.historyProvider?.provideHistoryItemChanges(T,j,z)??void 0}};e.$Mmc=P,e.$Mmc=P=a=Je([Ve(3,A.$2j)],P)}),define(ke[353],Pe([1,0,6,16,2]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nmc=void 0;class R{static{this.a=0}constructor(b,m){this.d=m,this.c=new Map,this.b=b.getProxy(d.$1M.MainThreadShare)}async $provideShare(b,m,E){return await this.c.get(b)?.provideShare({selection:N.Range.to(m.selection),resourceUri:L.URI.revive(m.resourceUri)},E)??void 0}registerShareProvider(b,m){const E=R.a++;return this.c.set(E,m),this.b.$registerShareProvider(E,N.DocumentSelector.from(b,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Nmc=R}),define(ke[354],Pe([1,0,8,6,230,3,16,18]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=e.$Pmc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new d.$1N("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.$1N("statusBarItem.warningForeground")]])}#e;#t;constructor($,y,w,h,g,a=d.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new R.$Uc,this.#e=$,this.#t=y,g&&h){this.c=(0,d.$CN)(h.identifier,g);const i=w.get(this.c);i&&(a=i.alignLeft?d.StatusBarAlignment.Left:d.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(m.a++);this.e=h,this.f=g,this.g=a,this.h=this.u(n)}u($){if((0,b.$_f)($))return $===Number.POSITIVE_INFINITY?Number.MAX_VALUE:$===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:$}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text($){this.k=$,this.v()}set name($){this.m=$,this.v()}set tooltip($){this.l=$,this.v()}set color($){this.n=$,this.v()}set backgroundColor($){$&&!m.b.has($.id)&&($=void 0),this.o=$,this.v()}set command($){this.r?.fromApi!==$&&(this.p&&this.q.add(this.p),this.p=new R.$Uc,typeof $=="string"?this.r={fromApi:$,internal:this.#t.toInternal({title:"",command:$},this.p)}:$?this.r={fromApi:$,internal:this.#t.toInternal($,this.p)}:this.r=void 0,this.v())}set accessibilityInformation($){this.t=$,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let $;this.e?this.f?$=`${this.e.identifier.value}.${this.f}`:$=this.e.identifier.value:$=this.f;let y;this.m?y=this.m:y=(0,L.localize)(0,null,this.e.displayName||this.e.name);let w=this.n;this.o&&(w=m.b.get(this.o.id));const h=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,$,this.e?.identifier.value,y,this.k,h,this.r?.internal,w,this.o,this.g===d.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Pmc=m;class E{constructor($){this.b=[],this.a=$.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,L.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage($){const y={message:$};return this.b.unshift(y),this.c(),new d.$3M(()=>{const w=this.b.indexOf(y);w>=0&&(this.b.splice(w,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor($,y){this.e=new Map,this.a=$.getProxy(N.$1M.MainThreadStatusBar),this.b=y,this.c=new E(this)}$acceptStaticEntries($){for(const y of $)this.e.set(y.entryId,y)}createStatusBarEntry($,y,w,h){return new m(this.a,this.b,this.e,$,y,w,h)}setStatusBarMessage($,y){const w=this.c.setMessage($);let h;return typeof y=="number"?h=setTimeout(()=>w.dispose(),y):typeof y<"u"&&y.then(()=>w.dispose(),()=>w.dispose()),new d.$3M(()=>{w.dispose(),clearTimeout(h)})}}e.$Qmc=A}),define(ke[155],Pe([1,0,29,145,69,113,89,16,2]),function(le,e,d,N,L,R,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=e.$CP=e.$BP=e.$AP=void 0;const E=(i,u,o,t)=>{let l=u;return{enumerable:!0,configurable:!1,get(){return l},set(r){if(!o(l,r)){const c=l;l=r,i.listener?.(t(r,c))}}}},A=(i,u)=>i===u,D={range:(i,u)=>i===u?!0:!i||!u?!1:i.isEqual(u),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(i,u)=>!(i.length!==u.length||i.some(o=>!u.find(t=>o.id===t.id)))},$=i=>u=>({op:4,update:i(u)}),y=(i,u)=>({range:(()=>{let o;const t=$(l=>({range:d.$tt.lift(b.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return o},set(l){i.listener?.({op:6}),D.range(o,l)||(o=l,i.listener?.(t(l)))}}})(),label:E(i,u,D.label,$(o=>({label:o}))),description:E(i,void 0,D.description,$(o=>({description:o}))),sortText:E(i,void 0,D.sortText,$(o=>({sortText:o}))),canResolveChildren:E(i,!1,D.canResolveChildren,o=>({op:2,state:o})),busy:E(i,!1,D.busy,$(o=>({busy:o}))),error:E(i,void 0,D.error,$(o=>({error:b.MarkdownString.fromStrict(o)||null}))),tags:E(i,[],D.tags,(o,t)=>({op:1,new:o.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),w=i=>{const u=L.$ML.fromString(i.extId),o=new g(u.controllerId,u.localId,i.label,m.URI.revive(i.uri)||void 0);return o.range=b.Range.to(i.range||void 0),o.description=i.description||void 0,o.sortText=i.sortText||void 0,o.tags=i.tags.map(t=>b.TestTag.to({id:(0,M.$SL)(t).tagId})),o},h=i=>{let u;for(const o of i.tests){const t=w(o.item);(0,N.$kP)(t).parent=u,u=t}return u};e.$AP=h;class g{constructor(u,o,t,l){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const r=(0,N.$jP)(this,u);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof a?void 0:r.parent}},children:{value:(0,R.$iP)(r,N.$kP,g),enumerable:!0,writable:!1},...y(r,t)})}}e.$BP=g;class a extends g{constructor(u,o){super(u,u,o,void 0),this._isRoot=!0}}e.$CP=a;class n extends R.$eP{constructor(u,o,t){super({controllerId:u,getDocumentVersion:l=>l&&t.getDocument(l)?.version,getApiFor:N.$kP,getChildren:l=>l.children,root:new a(u,o),toITestItem:b.TestItem.from})}}e.$DP=n}),define(ke[34],Pe([1,0,18,8,16,24,6,19,11,58,29,50,2,3,5,20,155,21,48,47,40,87,90,30]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i,u,o,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=void 0;let r=class{#e;#t;#n;constructor(p,k,P){this.b=new Map,this.c=new Map,this.#e=p.getProxy(M.$1M.MainThreadCommands),this.d=k,this.#n=P,this.#t=p.getProxy(M.$1M.MainThreadTelemetry),this.converter=new c(this,C=>{const I=this.c.get(C);return I?.result===v.Void?I:void 0},k),this.f=[{processArgument(C){return(0,E.$5h)(C)}},{processArgument(C){return(0,R.$4n)(C,function(I){if(A.$tt.isIRange(I))return L.Range.to(I);if(D.$st.isIPosition(I))return L.Position.to(I);if(A.$tt.isIRange(I.range)&&$.URI.isUri(I.uri))return L.location.to(I);if(I instanceof a.$Fe)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(p){this.f.push(p)}registerApiCommand(p){const k=this.registerCommand(!1,p.id,async(...P)=>{const C=p.args.map((T,j)=>{if(!T.validate(P[j]))throw new Error(`Invalid argument '${T.name}' when running '${p.id}', received: ${typeof P[j]=="object"?JSON.stringify(P[j],null,"	"):P[j]} `);return T.convert(P[j])}),I=await this.executeCommand(p.internalId,...C);return p.result.convert(I,P,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this.c.set(p.id,p),new N.$3M(()=>{k.dispose(),this.c.delete(p.id)})}registerCommand(p,k,P,C,I,T){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:P,thisArg:C,metadata:I,extension:T}),p&&this.#e.$registerCommand(k),new N.$3M(()=>{this.b.delete(k)&&p&&this.#e.$unregisterCommand(k)})}executeCommand(p,...k){return this.d.trace("ExtHostCommands#executeCommand",p),this.g(p,k,!0)}async g(p,k,P){if(this.b.has(p))return this.#e.$fireCommandActivationEvent(p),this.h(p,k,!1);{let C=!1;const I=(0,R.$4n)(k,function(T){if(T instanceof N.$4M)return L.Position.from(T);if(T instanceof N.$5M)return L.Range.from(T);if(T instanceof N.$cN)return L.location.from(T);if(N.$sO.isNotebookRange(T))return L.NotebookRange.from(T);if(T instanceof ArrayBuffer)return C=!0,a.$Fe.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return C=!0,a.$Fe.wrap(T);if(T instanceof a.$Fe)return C=!0,T;if(!Array.isArray(T))return T});try{const T=await this.#e.$executeCommand(p,C?new n.$uw(I):I,P);return(0,E.$5h)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this.g(p,k,!1);throw T}}}async h(p,k,P){const C=this.b.get(p);if(!C)throw new Error("Unknown command");const{callback:I,thisArg:T,metadata:j}=C;if(j?.args)for(let O=0;O<j.args.length;O++)try{(0,d.$mg)(k[O],j.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${j.args[O].name}' - ${j.args[O].description}`)}const z=u.$ae.create();try{return await I.apply(T,k)}catch(O){if(p===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...k);F&&(p=F.command)}if(this.d.error(O,p,C.extension?.identifier),!P)throw O;if(C.extension?.identifier){const F=this.#n.onExtensionError(C.extension.identifier,O);this.d.trace("forwarded error to extension?",F,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$gj)(O)),this.id=p,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,p,z.elapsed())}}j(p,k,P){p.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:p.extension.identifier.value,id:new o.$ep(k),duration:P})}$executeContributedCommand(p,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",p);const P=this.b.get(p);return P?(k=k.map(C=>this.f.reduce((I,T)=>T.processArgument(I,P.extension?.identifier),C)),this.h(p,k,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this.d.trace("ExtHostCommands#getCommands",p),this.#e.$getCommands().then(k=>(p&&(k=k.filter(P=>P[0]!=="_")),k))}$getContributedCommandMetadata(){const p=Object.create(null);for(const[k,P]of this.b){const{metadata:C}=P;C&&(p[k]=C)}return Promise.resolve(p)}};e.$JP=r,e.$JP=r=Je([Ve(0,h.$oP),Ve(1,m.$2j),Ve(2,t.$IP)],r),e.$KP=(0,w.$vi)("IExtHostCommands");class c{constructor(p,k,P){this.d=p,this.f=k,this.g=P,this.delegatingCommandId=`__vsc${(0,l.$Rg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(p,k){if(!p)return;const P={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return P;const C=this.f(p.command);if(C)P.id=C.internalId,P.arguments=C.args.map((I,T)=>I.convert(p.arguments&&p.arguments[T]));else if((0,b.$Lb)(p.arguments)){const I=`${p.command} /${++this.c}`;this.b.set(I,p),k.add((0,y.$Tc)(()=>{this.b.delete(I),this.g.trace("CommandsConverter#DISPOSE",I)})),P.$ident=I,P.id=this.delegatingCommandId,P.arguments=[I],this.g.trace("CommandsConverter#CREATE",p.command,I)}return P}fromInternal(p){return typeof p.$ident=="string"?this.b.get(p.$ident):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this.b.get(p[0])}h(...p){const k=this.getActualCommand(...p);return this.g.trace("CommandsConverter#EXECUTE",p[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${p[0]}`)}}e.$LP=c;class s{static{this.Uri=new s("uri","Uri of a text document",p=>$.URI.isUri(p),p=>p)}static{this.Position=new s("position","A position in a text document",p=>N.$4M.isPosition(p),L.Position.from)}static{this.Range=new s("range","A range in a text document",p=>N.$5M.isRange(p),L.Range.from)}static{this.Selection=new s("selection","A selection in a text document",p=>N.$6M.isSelection(p),L.Selection.from)}static{this.Number=new s("number","",p=>typeof p=="number",p=>p)}static{this.String=new s("string","",p=>typeof p=="string",p=>p)}static{this.StringArray=s.Arr(s.String)}static Arr(p){return new s(`${p.name}_array`,`Array of ${p.name}, ${p.description}`,k=>Array.isArray(k)&&k.every(P=>p.validate(P)),k=>k.map(P=>p.convert(P)))}static{this.CallHierarchyItem=new s("item","A call hierarchy item",p=>p instanceof N.$oN,L.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new s("item","A type hierarchy item",p=>p instanceof N.$MO,L.TypeHierarchyItem.from)}static{this.TestItem=new s("testItem","A VS Code TestItem",p=>p instanceof g.$BP,L.TestItem.from)}constructor(p,k,P,C){this.name=p,this.description=k,this.validate=P,this.convert=C}optional(){return new s(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,k){return new s(p??this.name,k??this.description,this.validate,this.convert)}}e.$MP=s;class v{static{this.Void=new v("no result",p=>p)}constructor(p,k){this.description=p,this.convert=k}}e.$NP=v;class f{constructor(p,k,P,C,I){this.id=p,this.internalId=k,this.description=P,this.args=C,this.result=I}}e.$OP=f}),define(ke[355],Pe([1,0,19,15,2,84,135,38,34,16,8]),function(le,e,d,N,L,R,M,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=void 0;const D=[new m.$OP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$MP.Uri,m.$MP.Position],new m.$NP("A promise that resolves to an array of DocumentHighlight-instances.",y(E.DocumentHighlight.to))),new m.$OP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$MP.Uri],new m.$NP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,g)=>{if((0,d.$Kb)(h))return;class a extends A.$jN{static to(i){const u=new a(i.name,E.SymbolKind.to(i.kind),i.containerName||"",new A.$cN(g[0],E.Range.to(i.range)));return u.detail=i.detail,u.range=u.location.range,u.selectionRange=E.Range.to(i.selectionRange),u.children=i.children?i.children.map(a.to):[],u}}return h.map(a.to)})),new m.$OP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$MP.Uri,new m.$MP("options","Formatting options",h=>!0,h=>h)],new m.$NP("A promise that resolves to an array of TextEdits.",y(E.TextEdit.to))),new m.$OP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$MP.Uri,m.$MP.Range,new m.$MP("options","Formatting options",h=>!0,h=>h)],new m.$NP("A promise that resolves to an array of TextEdits.",y(E.TextEdit.to))),new m.$OP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$MP.Uri,m.$MP.Position,new m.$MP("ch","Trigger character",h=>typeof h=="string",h=>h),new m.$MP("options","Formatting options",h=>!0,h=>h)],new m.$NP("A promise that resolves to an array of TextEdits.",y(E.TextEdit.to))),new m.$OP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$MP.Uri,m.$MP.Position],new m.$NP("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$OP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$MP.Uri,m.$MP.Position],new m.$NP("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$OP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$MP.Uri,m.$MP.Position],new m.$NP("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$OP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$MP.Uri,m.$MP.Position],new m.$NP("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$OP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$MP.Uri,m.$MP.Position],new m.$NP("A promise that resolves to an array of Location-instances.",y(E.location.to))),new m.$OP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$MP.Uri,m.$MP.Position],new m.$NP("A promise that resolves to an array of Hover-instances.",y(E.Hover.to))),new m.$OP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$MP.Uri,new m.$MP("position","A position in a text document",h=>Array.isArray(h)&&h.every(g=>A.$4M.isPosition(g)),h=>h.map(E.Position.from))],new m.$NP("A promise that resolves to an array of ranges.",h=>h.map(g=>{let a;for(const n of g.reverse())a=new A.$nN(E.Range.to(n),a);return a}))),new m.$OP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$MP.String.with("query","Search string")],new m.$NP("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(E.WorkspaceSymbol.to))),new m.$OP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$MP.Uri,m.$MP.Position],new m.$NP("A promise that resolves to an array of CallHierarchyItem-instances",h=>h.map(E.CallHierarchyItem.to))),new m.$OP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$MP.CallHierarchyItem],new m.$NP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",h=>h.map(E.CallHierarchyIncomingCall.to))),new m.$OP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$MP.CallHierarchyItem],new m.$NP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",h=>h.map(E.CallHierarchyOutgoingCall.to))),new m.$OP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$MP.Uri,m.$MP.Position],new m.$NP("A promise that resolves to a range and placeholder text.",h=>{if(h)return{range:E.Range.to(h.range),placeholder:h.text}})),new m.$OP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$MP.Uri,m.$MP.Position,m.$MP.String.with("newName","The new symbol name")],new m.$NP("A promise that resolves to a WorkspaceEdit.",h=>{if(h){if(h.rejectReason)throw new Error(h.rejectReason);return E.WorkspaceEdit.to(h)}})),new m.$OP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$MP.Uri,m.$MP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$NP("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(E.DocumentLink.to))),new m.$OP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$MP.Uri],new m.$NP("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new A.$jO(h.tokenTypes,h.tokenModifiers)})),new m.$OP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$MP.Uri],new m.$NP("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const g=(0,M.$8bb)(h);if(g.type==="full")return new A.$lO(g.data,void 0)})),new m.$OP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$MP.Uri,m.$MP.Range.optional()],new m.$NP("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new A.$jO(h.tokenTypes,h.tokenModifiers)})),new m.$OP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$MP.Uri,m.$MP.Range],new m.$NP("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const g=(0,M.$8bb)(h);if(g.type==="full")return new A.$lO(g.data,void 0)})),new m.$OP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$MP.Uri,m.$MP.Position,m.$MP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$MP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$NP("A promise that resolves to a CompletionList-instance.",(h,g,a)=>{if(!h)return new A.$zN([]);const n=h.suggestions.map(i=>E.CompletionItem.to(i,a));return new A.$zN(n,h.incomplete)})),new m.$OP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$MP.Uri,m.$MP.Position,m.$MP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$NP("A promise that resolves to SignatureHelp.",h=>{if(h)return E.SignatureHelp.to(h)})),new m.$OP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$MP.Uri,m.$MP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$NP("A promise that resolves to an array of CodeLens-instances.",(h,g,a)=>y(n=>new A.$rN(E.Range.to(n.range),n.command&&a.fromInternal(n.command)))(h))),new m.$OP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$MP.Uri,new m.$MP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>A.$5M.isRange(h),h=>A.$6M.isSelection(h)?E.Selection.from(h):E.Range.from(h)),m.$MP.String.with("kind","Code action kind to return code actions for").optional(),m.$MP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$NP("A promise that resolves to an array of Command-instances.",(h,g,a)=>y(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(n.command)}else{const i=new A.$lN(n.title,n.kind?new A.$mN(n.kind):void 0);return n.edit&&(i.edit=E.WorkspaceEdit.to(n.edit)),n.command&&(i.command=a.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(h))),new m.$OP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$MP.Uri],new m.$NP("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(g=>new A.$FN(E.Range.to(g.range),E.Color.to(g.color))):[])),new m.$OP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$MP("color","The color to show and insert",h=>h instanceof A.$EN,E.Color.from),new m.$MP("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:E.Range.from(h.range)}))],new m.$NP("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(E.ColorPresentation.to):[])),new m.$OP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$MP.Uri,m.$MP.Range],new m.$NP("A promise that resolves to an array of Inlay objects",(h,g,a)=>h.map(E.InlayHint.to.bind(void 0,a)))),new m.$OP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$MP.Uri],new m.$NP("A promise that resolves to an array of FoldingRange objects",(h,g)=>{if(h)return h.map(E.FoldingRange.to)})),new m.$OP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$NP("A promise that resolves to an array of NotebookContentProvider static info objects.",y(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(g=>E.NotebookExclusiveDocumentPattern.to(g))})))),new m.$OP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$MP.Uri,m.$MP.Range,new m.$MP("context","An InlineValueContext",h=>h&&typeof h.frameId=="number"&&h.stoppedLocation instanceof A.$5M,h=>E.InlineValueContext.from(h))],new m.$NP("A promise that resolves to an array of InlineValue objects",h=>h.map(E.InlineValue.to))),new m.$OP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$MP("uriOrString","Uri-instance or string (only http/https)",h=>L.URI.isUri(h)||typeof h=="string"&&(0,N.$Fg)(h,N.Schemas.http,N.Schemas.https),h=>h),new m.$MP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[E.ViewColumn.from(h),void 0]:[E.ViewColumn.from(h.viewColumn),E.TextEditorOpenOptions.from(h)])).optional(),m.$MP.String.with("label","").optional()],m.$NP.Void),new m.$OP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$MP.Uri.with("resource","Resource to open"),m.$MP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$MP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[E.ViewColumn.from(h),void 0]:[E.ViewColumn.from(h.viewColumn),E.TextEditorOpenOptions.from(h)])).optional()],m.$NP.Void),new m.$OP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$MP.Uri.with("left","Left-hand side resource of the diff editor"),m.$MP.Uri.with("right","Right-hand side resource of the diff editor"),m.$MP.String.with("title","Human readable title for the diff editor").optional(),new m.$MP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[E.ViewColumn.from(h.viewColumn),E.TextEditorOpenOptions.from(h)]).optional()],m.$NP.Void),new m.$OP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$MP.String.with("title","Human readable title for the changes editor"),new m.$MP("resourceList","List of resources to compare",h=>{for(const g of h){if(g.length!==3)return!1;const[a,n,i]=g;if(!L.URI.isUri(a)||!L.URI.isUri(n)&&n!==void 0&&n!==null||!L.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},h=>h)],m.$NP.Void),new m.$OP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$MP.Uri,m.$MP.Position],new m.$NP("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(E.TypeHierarchyItem.to))),new m.$OP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$MP.TypeHierarchyItem],new m.$NP("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(E.TypeHierarchyItem.to))),new m.$OP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$MP.TypeHierarchyItem],new m.$NP("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(E.TypeHierarchyItem.to))),new m.$OP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$MP.TestItem],m.$NP.Void),new m.$OP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$MP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$NP.Void),new m.$OP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$MP.String.with("name","The context key name"),new m.$MP("value","The context key value",()=>!0,h=>h)],m.$NP.Void),new m.$OP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$MP.Uri,m.$MP.StringArray,new m.$MP("MappedEditsContext","Mapped Edits Context",h=>E.MappedEditsContext.is(h),h=>E.MappedEditsContext.from(h))],new m.$NP("A promise that resolves to a workspace edit or null",h=>h?E.WorkspaceEdit.to(h):null))];class ${static register(g){D.forEach(g.registerApiCommand,g),this.a(g)}static a(g){g.registerCommand(!1,"_validateWhenClauses",b.$uj)}}e.$_kc=$;function y(h){return g=>{if(Array.isArray(g))return g.map(h)}}function w(h){if(!Array.isArray(h))return;const g=[];for(const a of h)R.$$t(a)?g.push(E.DefinitionLink.to(a)):g.push(E.location.to(a));return g}}),define(ke[356],Pe([1,0,7,3,2,6,34,16,8]),function(le,e,d,N,L,R,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=void 0;class E{static{this.a=0}constructor(y,w){this.extension=y,this.provider=w,this.handle=E.a++}}class A{constructor(y){this.session=y,this.responses=[]}}class D{static{this.a=0}constructor(y,w,h,g){this.f=h,this.g=g,this.b=new Map,this.d=new Map,this.e=y.getProxy(R.$1M.MainThreadInlineChat),w.registerApiCommand(new M.$OP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$MP("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?b.Range.from(a.initialRange):void 0,initialSelection:m.$6M.isSelection(a.initialSelection)?b.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?b.Position.from(a.position):void 0}})],M.$NP.Void))}registerProvider(y,w,h){const g=new E(y,w);return this.b.set(g.handle,g),this.e.$registerInteractiveEditorProvider(g.handle,h?.label??y.displayName??y.name,y.identifier,typeof w.handleInteractiveEditorResponseFeedback=="function",typeof w.provideFollowups=="function",h?.supportReportIssue??!1),(0,N.$Tc)(()=>{this.e.$unregisterInteractiveEditorProvider(g.handle),this.b.delete(g.handle)})}async $prepareSession(y,w,h,g){const a=this.b.get(y);if(!a){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(L.URI.revive(w)),i=b.Selection.to(h),u=await a.provider.prepareInteractiveEditorSession({document:n,selection:i},g);if(!u)return;if(u.wholeRange&&!u.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const o=D.a++;return this.d.set(o,new A(u)),{id:o,placeholder:u.placeholder,input:u.input,slashCommands:u.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:b.Range.from(u.wholeRange),message:u.message}}async $provideResponse(y,w,h,g){const a=this.b.get(y);if(!a)return;const n=this.d.get(w.id);if(!n)return;const i={prompt:h.prompt,selection:b.Selection.to(h.selection),wholeRange:b.Range.to(h.wholeRange),attempt:h.attempt,live:h.live,previewDocument:this.f.getDocument(L.URI.revive(h.previewDocument)),withIntentDetection:h.withIntentDetection};let u=!1;const o={report:async S=>{if(!h.live&&S.edits?.length)throw new Error("Progress reporting is only supported for live sessions");u||g.isCancellationRequested||await this.e.$handleProgressChunk(h.requestId,{message:S.message,edits:S.edits?.map(b.TextEdit.from),editsShouldBeInstant:S.editsShouldBeInstant,slashCommand:S.slashCommand?.command,markdownFragment:m.$sN.isMarkdownString(S.content)?S.content.value:S.content})}},t=Promise.resolve(a.provider.provideInteractiveEditorResponse(n.session,i,o,g));let l;try{l=await(0,d.$jh)(t,g)}finally{u=!0}if(!l)return;const r=n.responses.push(l)-1,c={wholeRange:b.Range.from(l.wholeRange),placeholder:l.placeholder};if(!D.h(l))return{...c,id:r,type:"editorEdit",message:b.MarkdownString.from(l.contents),edits:[]};const{edits:s,contents:v}=l,f=v!==void 0?b.MarkdownString.from(v):void 0;return s instanceof m.$aN?{...c,id:r,type:"bulkEdit",edits:b.WorkspaceEdit.from(s),message:f}:{...c,id:r,type:"editorEdit",edits:s.map(b.TextEdit.from),message:f}}async $provideFollowups(y,w,h,g){const a=this.b.get(y),n=this.d.get(w),i=n?.responses[h];if(a&&i&&a.provider.provideFollowups){const u=Promise.resolve(a.provider.provideFollowups(n.session,i,g));return(await(0,d.$jh)(u,g))?.map(b.ChatInlineFollowup.from)}}$handleFeedback(y,w,h,g){const a=this.b.get(y),n=this.d.get(w),i=n?.responses[h];if(a&&i){const u=b.InteractiveEditorResponseFeedbackKind.to(g);a.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,u)}}$releaseSession(y,w){}static h(y){return typeof y=="object"&&typeof y.edits=="object"}}e.$imc=D}),define(ke[357],Pe([1,0,2,34]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=void 0;class L{constructor(M,b,m,E,A){this.a=b,this.b=m,this.c=E;const D=new N.$OP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$MP("showOptions","Show Options",$=>!0,$=>$),new N.$MP("resource","Interactive resource Uri",$=>!0,$=>$),new N.$MP("controllerId","Notebook controller Id",$=>!0,$=>$),new N.$MP("title","Interactive editor title",$=>!0,$=>$)],new N.$NP("Notebook and input URI",$=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",$.notebookEditorId),$.notebookEditorId!==void 0){const y=this.a.getEditorById($.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:d.URI.revive($.notebookUri),inputUri:d.URI.revive($.inputUri),notebookEditor:y.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",$.notebookUri,$.inputUri),{notebookUri:d.URI.revive($.notebookUri),inputUri:d.URI.revive($.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(M,b,m,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:m,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$vmc=L}),define(ke[358],Pe([1,0,19,7,22,4,3,27,2,25,11,6,34,16,8,114,302,26,48,303]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=void 0,e.$Dmc=s;let u=class{constructor(f,S,p,k,P){this.m=S,this.n=p,this.o=k,this.q=P,this.b=new b.$Bc,this.c=new b.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$ee,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=f.getProxy(D.$1M.MainThreadNotebookKernels);const C=new $.$OP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new $.$MP("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const j=this.n.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:j}}else if(T&&"notebookEditor"in T){const j=this.n.getIdByEditor(T.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return T})],$.$NP.Void),I=new $.$OP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[$.$MP.Uri],new $.$NP("A promise that resolves to an array of variables",(T,j)=>T.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(I)}createNotebookController(f,S,p,k,P,C){for(const ue of this.j.values())if(ue.controller.id===S&&E.$Qm.equals(f.identifier,ue.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const I=this.k++,T=this;this.q.trace(`NotebookController[${I}], CREATED by ${f.identifier.value}, ${S}`);const j=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${f.identifier}'`);let z=!1;const O=new R.$ee,F=new R.$ee,B={id:s(f.identifier,S),notebookType:p,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:k||f.identifier.value,preloads:C?C.map(y.NotebookRendererScript.from):[]};let Z=P??j,q,Q;this.a.$addKernel(I,B).catch(ue=>{console.log(ue),z=!0});let x=0;const X=()=>{if(z)return;const ue=++x;Promise.resolve().then(()=>{ue===x&&this.a.$updateKernel(I,B)})},ie=new b.$Bc,me={get id(){return S},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return B.label},set label(ue){B.label=ue??f.displayName??f.name,X()},get detail(){return B.detail??""},set detail(ue){B.detail=ue,X()},get description(){return B.description??""},set description(ue){B.description=ue,X()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(ue){B.supportedLanguages=ue,X()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){B.supportsExecutionOrder=ue,X()},get rendererScripts(){return B.preloads?B.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(ue){Z=ue??j},get interruptHandler(){return q},set interruptHandler(ue){q=ue,B.supportsInterrupt=!!ue,X()},set variableProvider(ue){(0,a.$GG)(f,"notebookVariableProvider"),Q=ue,B.hasVariableProvider=!!ue,ue?.onDidChangeVariables(ve=>T.a.$variablesUpdated(ve.uri)),X()},get variableProvider(){return Q},createNotebookCellExecution(ue){if(z)throw new Error("notebook controller is DISPOSED");if(!ie.has(ue.notebook.uri))throw T.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return T._createNotebookCellExecution(ue,s(f.identifier,this.id))},createNotebookExecution(ue){if((0,a.$GG)(f,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!ie.has(ue.uri))throw T.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.uri.toString()}`);return T._createNotebookExecution(ue,s(f.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${I}], DISPOSED`),z=!0,this.j.delete(I),O.dispose(),F.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(ue,ve){ve===w.NotebookControllerAffinity2.Hidden&&(0,a.$GG)(f,"notebookControllerAffinityHidden"),T.a.$updateNotebookPriority(I,ue.uri,ve)},onDidReceiveMessage:F.event,postMessage(ue,ve){return(0,a.$GG)(f,"notebookMessaging"),T.a.$postMessage(I,ve&&T.n.getIdByEditor(ve),ue)},asWebviewUri(ue){return(0,a.$GG)(f,"notebookMessaging"),(0,h.$4yb)(ue,T.m.remote)}};return this.j.set(I,{extensionId:f.identifier,controller:me,onDidReceiveMessage:F,onDidChangeSelection:O,associatedNotebooks:ie}),me}getIdByController(f){for(const[S,p]of this.j)if(p.controller===f)return s(p.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,S){const p=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${p}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(p,S);const P={dispose:()=>{this.f.delete(p),k.a.$removeKernelDetectionTask(p)}};return this.f.set(p,P),P}registerKernelSourceActionProvider(f,S,p){const k=this.i++,P=typeof p.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,C=this;this.h.set(k,p),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,S);let I;return P!==void 0&&(I=p.onDidChangeNotebookKernelSourceActions(T=>this.a.$emitNotebookKernelSourceActionsChangeEvent(P))),{dispose:()=>{this.h.delete(k),C.a.$removeKernelSourceActionProvider(k,k),I?.dispose()}}}async $provideKernelSourceActions(f,S){const p=this.h.get(f);if(p){const k=new M.$Uc;return(await p.provideNotebookKernelSourceActions(S)??[]).map(C=>y.NotebookKernelSourceAction.from(C,this.o.converter,k))}return[]}$acceptNotebookAssociation(f,S,p){const k=this.j.get(f);if(k){const P=this.n.getNotebookDocument(m.URI.revive(S));p?k.associatedNotebooks.set(P.uri,!0):k.associatedNotebooks.delete(P.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,P.uri.toString(),p),k.onDidChangeSelection.fire({selected:p,notebook:P.apiNotebook})}}async $executeCells(f,S,p){const k=this.j.get(f);if(!k)return;const P=this.n.getNotebookDocument(m.URI.revive(S)),C=[];for(const I of p){const T=P.getCell(I);T&&C.push(T.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,P.uri.toString(),C.length),await k.controller.executeHandler.call(k.controller,C,P.apiNotebook,k.controller)}catch(I){this.q.error(`NotebookController[${f}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(f,S,p){const k=this.j.get(f);if(!k)return;const P=this.n.getNotebookDocument(m.URI.revive(S));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,P.apiNotebook);else for(const C of p){const I=P.getCell(C);I&&this.b.get(I.uri)?.cancel()}if(k.controller.interruptHandler){const C=this.c.get(P.uri);p.length&&Array.isArray(C)&&C.length&&C.forEach(I=>I.dispose())}}async $provideVariables(f,S,p,k,P,C,I){const T=this.j.get(f);if(!T)return;const j=this.n.getNotebookDocument(m.URI.revive(p)),z=T.controller.variableProvider;if(!z)return;let O;if(k!==void 0){if(O=this.s[k],!O)return}else this.s={};const F=P==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,B=z.provideVariables(j.apiNotebook,O,F,C,I);let Z=0;for await(const q of B){if(I.isCancellationRequested)return;const Q={id:this.r++,name:q.variable.name,value:q.variable.value,type:q.variable.type,interfaces:q.variable.interfaces,language:q.variable.language,expression:q.variable.expression,hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount,extensionId:T.extensionId.value};if(this.s[Q.id]=q.variable,this.a.$receiveVariable(S,Q),Z++>=i.$_ib)return}}$acceptKernelMessageFromRenderer(f,S,p){const k=this.j.get(f);if(!k)return;const P=this.n.getEditorById(S);k.onDidReceiveMessage.fire(Object.freeze({editor:P.apiEditor,message:p}))}$cellExecutionChanged(f,S,p){const P=this.n.getNotebookDocument(m.URI.revive(f)).getCell(S);if(P){const C=p?y.NotebookCellExecutionState.to(p):w.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:P.apiCell,state:C})}}_createNotebookCellExecution(f,S){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const P=new t(S,k,this.a);this.b.set(k.uri,P);const C=P.onDidChangeState(()=>{P.state===o.Resolved&&(P.dispose(),C.dispose(),this.b.delete(k.uri))});return P.asApiObject()}_createNotebookExecution(f,S){const p=this.n.getNotebookDocument(f.uri),k=f.getCells().find(I=>{const T=p.getCellFromApiCell(I);return T&&this.b.has(T.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has(p.uri))throw new Error(`duplicate notebook execution for ${p.uri}`);const P=new r(S,p,this.a),C=P.onDidChangeState(()=>{P.state===l.Resolved&&(P.dispose(),C.dispose(),this.c.delete(p.uri))});return this.c.set(p.uri,[P,C]),P.asApiObject()}};e.$Cmc=u,e.$Cmc=u=Je([Ve(4,A.$2j)],u);var o;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(o||(o={}));class t extends M.$Vc{static{this.a=0}get state(){return this.f}constructor(f,S,p){super(),this.m=S,this.n=p,this.b=t.a++,this.c=new R.$ee,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new L.$pe),this.h=new c(10,k=>this.s(k)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const S=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new n.$uw(S))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let S=this.m;if(f&&(S=this.m.notebook.getCellFromApiCell(f)),!S)throw new Error("INVALID cell");return S.handle}y(f){return f.map(S=>{const p=w.$wO.ensureUniqueMimeTypes(S.items,!0);return p===S.items?y.NotebookCellOutput.from(S):y.NotebookCellOutput.from({items:p,id:S.id,metadata:S.metadata})})}async z(f,S,p){const k=this.w(S),P=this.y((0,d.$3b)(f));return this.r({editType:g.CellExecutionUpdateType.Output,cellHandle:k,append:p,outputs:P})}async C(f,S,p){return f=w.$wO.ensureUniqueMimeTypes((0,d.$3b)(f),!0),this.r({editType:g.CellExecutionUpdateType.OutputItems,items:f.map(y.NotebookCellOutputItem.from),outputId:S.id,append:p})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(p){f.j=p,f.s([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(p){if(f.f===o.Resolved||f.f===o.Started)throw new Error("Cannot call start again");f.f=o.Started,f.c.fire(),f.s({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:p})},end(p,k,P){if(f.f===o.Resolved)throw new Error("Cannot call resolve twice");f.f=o.Resolved,f.c.fire(),f.h.flush();const C=P?{message:P.message,stack:P.stack,location:P?.location?{startLineNumber:P.location.start.line,startColumn:P.location.start.character,endLineNumber:P.location.end.line,endColumn:P.location.end.character}:void 0,uri:P.uri}:void 0;f.n.$completeExecution(f.b,new n.$uw({runEndTime:k,lastRunSuccess:p,error:C}))},clearOutput(p){return f.t(),f.z([],p,!1)},appendOutput(p,k){return f.t(),f.z(p,k,!0)},replaceOutput(p,k){return f.t(),f.z(p,k,!1)},appendOutputItems(p,k){return f.t(),f.C(p,k,!0)},replaceOutputItems(p,k){return f.t(),f.C(p,k,!1)}})}}var l;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(l||(l={}));class r extends M.$Vc{static{this.a=0}get state(){return this.f}constructor(f,S,p){super(),this.h=S,this.j=p,this.b=r.a++,this.c=new R.$ee,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new L.$pe),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===l.Resolved||this.f===l.Started)throw new Error("Cannot call start again");this.f=l.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===l.Resolved)throw new Error("Cannot call resolve twice");this.f=l.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor(f,S){this.f=f,this.g=S,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new N.$Sh,this.b=Date.now(),(0,N.$wh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>f.complete())}}function s(v,f){return`${v.value}/${f}`}}),define(ke[43],Pe([1,0,4,6,5,2,20,3,8,232,13,279,22,30,280,57,7,16,34]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=e.$Plc=e.$Olc=e.$Nlc=void 0,e.$Nlc=(0,L.$vi)("IExtHostTerminalService");class i extends b.$Vc{constructor(p,k,P,C){super(),this.u=p,this._id=k,this.w=P,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new d.$ee),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(T=>this.g=T);const I=this;this.value={get name(){return I.y||""},get processId(){return I.b},get creationOptions(){return I.w},get exitStatus(){return I.j},get state(){return I.m},get selection(){return I.n},get shellIntegration(){return I.shellIntegration},sendText(T,j=!0){I.C(),I.u.$sendText(I._id,T,j)},show(T){I.C(),I.u.$show(I._id,T)},hide(){I.C(),I.u.$hide(I._id)},dispose(){I.a||(I.a=!0,I.u.$dispose(I._id))},get dimensions(){if(!(I.f===void 0||I.h===void 0))return{columns:I.f,rows:I.h}}}}dispose(){this.s.fire(),super.dispose()}async create(p,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??k?.cwd??void 0,env:p.env??void 0,icon:s(p.iconPath)??void 0,color:h.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,forceShellIntegration:k?.forceShellIntegration??void 0,isFeatureTerminal:k?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:k?.useShellEnvironment??void 0,location:k?.location||this.z(p.location,k?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,k,P,C,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:h.ThemeColor.isThemeColor(I)?I.id:void 0,location:k?.location||this.z(p,P),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(p,k){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&k?{parentTerminal:k}:"viewColumn"in p?{viewColumn:a.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.y=p}setExitStatus(p,k){this.j=Object.freeze({code:p,reason:k})}setDimensions(p,k){return p===this.f&&k===this.h||p===0||k===0?!1:(this.f=p,this.h=k,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(p){this.n=p}_setProcessId(p){this.g?(this.g(p),this.g=void 0):this.b.then(k=>{k!==p&&(this.b=Promise.resolve(p))})}}e.$Olc=i;class u{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new d.$ee,this.onProcessData=this.a.event,this.b=new d.$ee,this.d=new d.$ee,this.onDidChangeProperty=this.d.event,this.f=new d.$ee,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,k){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${k}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,k){this.g.setDimensions?.({columns:p,rows:k})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(k=>this.a.fire(k)),this.g.onDidClose?.((k=void 0)=>{this.f.fire(k===void 0?void 0:k)}),this.g.onDidOverrideDimensions?.(k=>{k&&this.d.fire({type:"overrideDimensions",value:{cols:k.columns,rows:k.rows}})}),this.g.onDidChangeName?.(k=>{this.d.fire({type:"title",value:k})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let o=1,t=class extends b.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,k,P){super(),this.Q=k,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new d.$ee,this.onDidCloseTerminal=this.H.event,this.I=new d.$ee,this.onDidOpenTerminal=this.I.event,this.J=new d.$ee,this.onDidChangeActiveTerminal=this.J.event,this.L=new d.$ee,this.onDidChangeTerminalDimensions=this.L.event,this.M=new d.$ee,this.onDidChangeTerminalState=this.M.event,this.N=new d.$ee,this.onDidChangeShell=this.N.event,this.O=new d.$ee({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new d.$ee({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=P.getProxy(N.$1M.MainThreadTerminalService),this.y=new w.$Vtb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:C=>{const I=T=>{const j=T;return this.getTerminalById(j.instanceId)?.value};switch(C?.$mid){case 15:return I(C);default:{if(Array.isArray(C))for(let T=0;T<C.length&&C[T].$mid===15;T++)C[T]=I(C[T]);return C}}}}),this.B({dispose:()=>{for(const[C,I]of this.g)I.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,k){const P=new i(this.a,(0,y.$Rg)(),p,p.name),C=new u(p.pty);return P.createExtensionTerminal(p.location,k,this.R(p,k).resolvedExtHostIdentifier,s(p.iconPath),v(p.color)).then(I=>{const T=this.S(I,C);this.h[I]=T}),this.f.push(P),P.value}R(p,k){if(k=k||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const P=p.location.parentTerminal;if(P){const C=this.f.find(I=>I.value===P);C&&(k.resolvedExtHostIdentifier=C._id)}}else p.location&&typeof p.location!="object"?k.location=p.location:k.location&&typeof k.location=="object"&&"splitActiveTerminal"in k.location&&(k.location={splitActiveTerminal:!0});return k}attachPtyToTerminal(p,k){if(!this.getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const C=new u(k),I=this.S(p,C);this.h[p]=I}async $acceptActiveTerminalChanged(p){const k=this.b;if(p===null){this.b=void 0,k!==this.b&&this.J.fire(this.b);return}const P=this.getTerminalById(p);P&&(this.b=P,k!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,k){const P=this.getTerminalById(p);P&&this.O.fire({terminal:P.value,data:k})}async $acceptTerminalDimensions(p,k,P){const C=this.getTerminalById(p);C&&C.setDimensions(k,P)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(p,k){const P=this.getTerminalById(p);P&&this.P.fire({terminal:P.value,...k})}async $acceptTerminalMaximumDimensions(p,k,P){this.g.get(p)?.resize(k,P)}async $acceptTerminalTitleChange(p,k){const P=this.getTerminalById(p);P&&(P.name=k)}async $acceptTerminalClosed(p,k,P){const C=this.X(this.f,p);if(C!==null){const I=this.f.splice(C,1)[0];I.setExitStatus(k,P),this.H.fire(I.value)}}$acceptTerminalOpened(p,k,P,C){if(k){const j=this.X(this.f,k);if(j!==null){this.f[j]._id=p,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const I={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:R.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},T=new i(this.a,p,I,P);this.f.push(T),this.I.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(p,k){this.getTerminalById(p)?._setProcessId(k)}async $startExtensionTerminal(p,k){const P=this.getTerminalById(p);if(!P)return{message:(0,E.localize)(0,null,p)};P.isOpen||await new Promise(I=>{const T=this.onDidOpenTerminal(async j=>{j===P.value&&(T.dispose(),I())})});const C=this.g.get(p);C?C.startSendingEvents(k):this.j[p]={initialDimensions:k}}S(p,k){const P=new b.$Uc;P.add(k.onProcessReady(I=>this.a.$sendProcessReady(p,I.pid,I.cwd,I.windowsPty))),P.add(k.onDidChangeProperty(I=>this.a.$sendProcessProperty(p,I))),this.y.startBuffering(p,k.onProcessData),P.add(k.onProcessExit(I=>this.U(p,I))),this.g.set(p,k);const C=this.j[p];return C&&k instanceof u&&(k.startSendingEvents(C.initialDimensions),delete this.j[p]),P}$acceptProcessAckDataEvent(p,k){this.g.get(p)?.acknowledgeDataEvent(k)}$acceptProcessInput(p,k){this.g.get(p)?.input(k)}$acceptTerminalInteraction(p){const k=this.getTerminalById(p);k?.setInteractedWith()&&this.M.fire(k.value)}$acceptTerminalSelection(p,k){this.getTerminalById(p)?.setSelection(k)}$acceptProcessResize(p,k,P){try{this.g.get(p)?.resize(k,P)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(p,k){this.g.get(p)?.shutdown(k)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(k=>this.a.$sendProcessProperty(p,{type:"initialCwd",value:k}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(k=>this.a.$sendProcessProperty(p,{type:"cwd",value:k}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new m.$3M(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,k,P){if(this.C.has(k))throw new Error(`Terminal profile provider "${k}" already registered`);return this.C.set(k,P),this.a.$registerProfileProvider(k,p.identifier.value),new m.$3M(()=>{this.C.delete(k),this.a.$unregisterProfileProvider(k)})}registerTerminalQuickFixProvider(p,k,P){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,P),this.a.$registerQuickFixProvider(p,k),new m.$3M(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,k){const P=new $.$pe().token;if(P.isCancellationRequested)return;const C=this.D.get(p);if(!C)return;const I=await C.provideTerminalQuickFixes(k,P);if(I===null||Array.isArray(I)&&I.length===0)return;const T=new b.$Uc;if(this.w.value=T,!Array.isArray(I))return I?a.TerminalQuickFix.from(I,this.Q.converter,T):void 0;const j=[];for(const z of I){const O=a.TerminalQuickFix.from(z,this.Q.converter,T);O&&j.push(O)}return j}async $createContributedProfileTerminal(p,k){const P=new $.$pe().token;let C=await this.C.get(p)?.provideTerminalProfile(P);if(!P.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,k);return}this.createTerminalFromOptions(C.options,k)}}async $provideLinks(p,k){const P=this.getTerminalById(p);if(!P)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const I=new $.$pe;this.G.set(p,I);const T=[],j={terminal:P.value,line:k},z=[];for(const B of this.z)z.push(g.Promises.withAsyncBody(async Z=>{I.token.onCancellationRequested(()=>Z({provider:B,links:[]}));const q=await B.provideTerminalLinks(j,I.token)||[];I.token.isCancellationRequested||Z({provider:B,links:q})}));const O=await Promise.all(z);if(I.token.isCancellationRequested)return[];const F=new Map;for(const B of O)B&&B.links.length>0&&T.push(...B.links.map(Z=>{const q={id:o++,startIndex:Z.startIndex,length:Z.length,label:Z.tooltip};return F.set(q.id,{provider:B.provider,link:Z}),q}));return this.F.set(p,F),T}$activateLink(p,k){const P=this.F.get(p)?.get(k);P&&P.provider.handleTerminalLink(P.link)}U(p,k){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const P=this.h[p];P&&(P.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,k)}getTerminalById(p){return this.W(this.f,p)}getTerminalIdByApiObject(p){const k=this.f.findIndex(P=>P.value===p);return k>=0?k:null}W(p,k){const P=this.X(p,k);return P!==null?p[P]:null}X(p,k){const P=p.findIndex(C=>C._id===k);return P>=0?P:null}getEnvironmentVariableCollection(p){let k=this.n.get(p.identifier.value);return k||(k=new l,this.Z(p.identifier.value,k)),k.getScopedEnvironmentVariableCollection(void 0)}Y(p,k){const P=(0,D.$ks)(k.map),C=(0,D.$ls)(k.descriptionMap);this.a.$setEnvironmentVariableCollection(p,k.persistent,P.length===0?void 0:P,C)}$initEnvironmentVariableCollections(p){p.forEach(k=>{const P=k[0],C=new l(k[1]);this.Z(P,C)})}$acceptDefaultProfile(p,k){const P=this.s;this.s=p,this.u=k,P?.path!==p.path&&this.N.fire(p.path)}Z(p,k){this.n.set(p,k),k.onDidChangeCollection(()=>{this.Y(p,k)})}};e.$Plc=t,e.$Plc=t=Je([Ve(1,n.$KP),Ve(2,M.$oP)],t);class l{get persistent(){return this.b}set persistent(p){this.b=p,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(p){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new d.$ee,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const k=this.h(p);let P=this.a.get(k);return P||(P=new r(this,p),this.a.set(k,P),P.onDidChangeCollection(()=>this.d.fire())),P}replace(p,k,P,C){this.f(p,{value:k,type:m.EnvironmentVariableMutatorType.Replace,options:P??{applyAtProcessCreation:!0},scope:C})}append(p,k,P,C){this.f(p,{value:k,type:m.EnvironmentVariableMutatorType.Append,options:P??{applyAtProcessCreation:!0},scope:C})}prepend(p,k,P,C){this.f(p,{value:k,type:m.EnvironmentVariableMutatorType.Prepend,options:P??{applyAtProcessCreation:!0},scope:C})}f(p,k){if(k.options&&k.options.applyAtProcessCreation===!1&&!k.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const P=this.g(p,k.scope),C=this.map.get(P),I=k.options?{applyAtProcessCreation:k.options.applyAtProcessCreation??!1,applyAtShellIntegration:k.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==k.value||C.type!==k.type||C.options?.applyAtProcessCreation!==I.applyAtProcessCreation||C.options?.applyAtShellIntegration!==I.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==k.scope?.workspaceFolder?.index){const T=this.g(p,k.scope),j={variable:p,...k,options:I};this.map.set(T,j),this.d.fire()}}get(p,k){const P=this.g(p,k),C=this.map.get(P);return C?f(C):void 0}g(p,k){const P=this.h(k);return P.length?`${p}:::${P}`:p}h(p){return this.j(p?.workspaceFolder)??""}j(p){return p?p.uri.toString():void 0}getVariableMap(p){const k=new Map;for(const[P,C]of this.map)this.h(C.scope)===this.h(p)&&k.set(C.variable,f(C));return k}delete(p,k){const P=this.g(p,k);this.map.delete(P),this.d.fire()}clear(p){if(p?.workspaceFolder){for(const[k,P]of this.map)P.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(k);this.k(p)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(p,k){const P=this.h(k),C=this.descriptionMap.get(P);if(!C||C.description!==p){let I;typeof p=="string"?I=p:I=p?.value.split(`

`)[0];const T={description:I,scope:k};this.descriptionMap.set(P,T),this.d.fire()}}getDescription(p){const k=this.h(p);return this.descriptionMap.get(k)?.description}k(p){const k=this.h(p);this.descriptionMap.delete(k)}}class r{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,k){this.b=p,this.d=k,this.a=new d.$ee}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,k,P){this.b.replace(p,k,P,this.d)}append(p,k,P){this.b.append(p,k,P,this.d)}prepend(p,k,P){this.b.prepend(p,k,P,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,k){this.b.getVariableMap(this.d).forEach((P,C)=>p.call(k,C,P,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let c=class extends t{constructor(p,k){super(!1,p,k)}createTerminal(p,k,P){throw new A.$_}createTerminalFromOptions(p,k){throw new A.$_}};e.$Qlc=c,e.$Qlc=c=Je([Ve(0,n.$KP),Ve(1,M.$oP)],c);function s(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function v(S){return h.ThemeColor.isThemeColor(S)?S:void 0}function f(S){const p={...S};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(ke[156],Pe([1,0,8,3,5,6,20,43,4,2,7]),function(le,e,d,N,L,R,M,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=e.$Umc=void 0,e.$Umc=(0,L.$vi)("IExtHostTerminalShellIntegration");let D=class extends N.$Vc{constructor(g,a){super(),this.h=a,this.b=new Map,this.c=new m.$ee,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$ee,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$ee,this.onDidEndTerminalShellExecution=this.g.event,this.a=g.getProxy(R.$1M.MainThreadTerminalShellIntegration),this.B((0,N.$Tc)(()=>{for(const[n,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(g){const a=this.h.getTerminalById(g);if(!a)return;const n=a.value;let i=this.b.get(g);i||(i=new $(a.value,this.f),this.b.set(g,i),i.store.add(a.onWillDispose(()=>this.b.get(g)?.dispose())),i.store.add(i.onDidRequestShellExecution(u=>this.a.$executeCommand(g,u))),i.store.add(i.onDidRequestEndExecution(u=>this.g.fire(u))),i.store.add(i.onDidRequestChangeShellIntegration(u=>this.c.fire(u))),a.shellIntegration=i.value),this.c.fire({terminal:n,shellIntegration:i.value})}$shellExecutionStart(g,a,n,i,u){this.b.has(g)||this.$shellIntegrationChange(g);const o={value:a,confidence:n,isTrusted:i};this.b.get(g)?.startShellExecution(o,u)}$shellExecutionEnd(g,a,n,i,u){const o={value:a,confidence:n,isTrusted:i};this.b.get(g)?.endShellExecution(o,u)}$shellExecutionData(g,a){this.b.get(g)?.emitData(a)}$cwdChange(g,a){this.b.get(g)?.setCwd((0,E.$wc)(a)?E.URI.revive(a):a)}$closeTerminal(g){this.b.get(g)?.dispose(),this.b.delete(g)}};e.$Vmc=D,e.$Vmc=D=Je([Ve(0,M.$oP),Ve(1,b.$Nlc)],D);class $ extends N.$Vc{get currentExecution(){return this.a}constructor(g,a){super(),this.j=g,this.m=a,this.b=!1,this.store=this.B(new N.$Uc),this.f=this.B(new m.$ee),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$ee),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$ee),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(i,u){let o=i;u&&(o+=` "${u.map(r=>`${r.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(o);const t={value:o,confidence:d.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},l=n.startShellExecution(t,n.c,!0).value;return n.b=!0,l}}}startShellExecution(g,a,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new y(g,a);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(g){this.currentExecution?.emitData(g)}endShellExecution(g,a){this.a&&(this.a.endExecution(g),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:a}),this.a=void 0)}setCwd(g){let a=!1;E.URI.isUri(this.c)?a=!E.URI.isUri(g)||this.c.toString()!==g.toString():this.c!==g&&(a=!0),a&&(this.c=g,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class y{constructor(g,a){this.c=g,this.cwd=a,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return A.$Vh.EMPTY;this.a=new w}return this.a.createIterable()}emitData(g){this.a?.emitData(g)}endExecution(g){g&&(this.c=g),this.a?.endExecution(),this.a=void 0,this.b=!0}}class w extends N.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new A.$uh);const g=this.a;return new A.$Vh(async n=>{this.b.push(n),await g.wait()})}emitData(g){for(const a of this.b)a.emitOne(g)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[359],Pe([1,0,7,21,22,4,75,56,3,18,30,11,6,20,155,16,8,69,113,89]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=e.$Ymc=e.$Xmc=e.$Wmc=void 0;let u=class extends m.$Vc{constructor(I,T,j,z){super(),this.w=z,this.f=this.B(new R.$ee),this.g=new Map,this.s=this.B(new R.$ee),this.onResultsChanged=this.f.event,this.results=[],this.h=I.getProxy($.$1M.MainThreadTesting),this.m=new S(this.h),this.j=new r(this.h,T),j.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const F=O,B=F.tests[F.tests.length-1].item.extId;return this.g.get(a.$ML.root(B))?.collection.tree.get(B)?.actual??(0,w.$AP)(O)}case 18:{const{test:F,message:B}=O,Z=F.item.extId;return{test:this.g.get(a.$ML.root(Z))?.collection.tree.get(Z)?.actual??(0,w.$AP)({$mid:16,tests:[F]}),message:h.TestMessage.to(B)}}default:return O}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await j.executeCommand("_testing.getExplorerSelection"),F=B=>{const Z=this.g.get(a.$ML.root(B));if(Z)return a.$ML.isRoot(B)?Z.controller:Z.collection.tree.get(B)?.actual};return{include:O?.include.map(F).filter(E.$dg)||[],exclude:O?.exclude.map(F).filter(E.$dg)||[]}})}createTestController(I,T,j,z){if(this.g.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const O=new m.$Uc,F=O.add(new w.$DP(T,j,this.w));F.root.label=j;const B=new Map,Z=new Set,q=this.h,Q={items:F.root.children,get label(){return j},set label(X){j=X,F.root.label=X,q.$updateController(T,{label:j})},get refreshHandler(){return z},set refreshHandler(X){z=X,q.$updateController(T,{canRefresh:!!X})},get id(){return T},createRunProfile:(X,ie,me,ue,ve,te)=>{let U=(0,b.$jj)(X);for(;B.has(U);)U++;return new k(this.h,B,Z,this.s.event,T,U,X,ie,me,ue,ve,te)},createTestItem(X,ie,me){return new w.$BP(T,X,ie,me)},createTestRun:(X,ie,me=!0)=>this.j.createTestRun(T,F,X,ie,me),invalidateTestResults:X=>{if(X===void 0)this.h.$markTestRetired(void 0);else{const ie=X instanceof Array?X:[X];this.h.$markTestRetired(ie.map(me=>a.$ML.fromExtHostTestItem(me,T).toString()))}},set resolveHandler(X){F.resolveHandler=X},get resolveHandler(){return F.resolveHandler},dispose:()=>{O.dispose()}};q.$registerTestController(T,j,!!z),O.add((0,m.$Tc)(()=>q.$unregisterTestController(T)));const x={controller:Q,collection:F,profiles:B,extension:I,activeProfiles:Z};return this.g.set(T,x),O.add((0,m.$Tc)(()=>this.g.delete(T))),O.add(F.onDidGenerateDiff(X=>q.$publishDiff(T,X.map(i.TestsDiffOp.serialize)))),Q}createTestObserver(){return this.m.checkout()}async runTests(I,T=L.CancellationToken.None){const j=c(I);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.g.get(j.controllerId);if(!z)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:I.preserveFocus??!0,targets:[{testIds:I.include?.map(O=>a.$ML.fromExtHostTestItem(O,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:P[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:I.exclude?.map(O=>O.id)},T)}$syncTests(){for(const{collection:I}of this.g.values())I.flushDiff();return Promise.resolve()}async $getCoverageDetails(I,T){return(await this.j.getCoverageDetails(I,T))?.map(h.TestCoverage.fromDetails)}async $disposeRun(I){this.j.disposeTestRun(I)}$configureRunProfile(I,T){this.g.get(I)?.profiles.get(T)?.configureHandler?.()}$setDefaultRunProfiles(I){const T=new Map;for(const[j,z]of Object.entries(I)){const O=this.g.get(j);if(!O)continue;const F=new Map,B=z.filter(q=>!O.activeProfiles.has(q)),Z=[...O.activeProfiles].filter(q=>!z.includes(q));for(const q of B)F.set(q,!0),O.activeProfiles.add(q);for(const q of Z)F.set(q,!1),O.activeProfiles.delete(q);F.size&&T.set(j,F)}this.s.fire(T)}async $refreshTests(I,T){await this.g.get(I)?.controller.refreshHandler?.(T)}$publishTestResults(I){this.results=Object.freeze(I.map(h.TestResults.to).concat(this.results).sort((T,j)=>j.completedAt-T.completedAt).slice(0,32)),this.f.fire()}async $expandTest(I,T){const j=this.g.get(a.$ML.fromString(I).controllerId)?.collection;j&&(await j.expand(I,T<0?1/0:T),j.flushDiff())}$acceptDiff(I){this.m.applyDiff(I.map(T=>i.TestsDiffOp.deserialize({asCanonicalUri:j=>j},T)))}async $runControllerTests(I,T){return Promise.all(I.map(j=>this.y(j,!1,T)))}async $startContinuousRun(I,T){const j=new L.$pe(T),z=await Promise.all(I.map(O=>this.y(O,!0,j.token)));return!T.isCancellationRequested&&!z.some(O=>O.error)&&await new Promise(O=>T.onCancellationRequested(O)),j.dispose(!0),z}async y(I,T,j){const z=this.g.get(I.controllerId);if(!z)return{};const{collection:O,profiles:F}=z,B=F.get(I.profileId);if(!B)return{};const Z=I.testIds.map(X=>O.tree.get(X)).filter(E.$dg),q=I.excludeExtIds.map(X=>z.collection.tree.get(X)).filter(E.$dg).filter(X=>Z.some(ie=>ie.fullId.compare(X.fullId)===2));if(!Z.length)return{};const Q=new g.$DO(Z.some(X=>X.actual instanceof w.$CP)?void 0:Z.map(X=>X.actual),q.map(X=>X.actual),B,T),x=(0,i.$PL)(I)&&this.j.prepareForMainThreadTestRun(Q,s.fromInternal(I,z.collection),B,j);try{return await B.runHandler(Q,j),{}}catch(X){return{error:String(X)}}finally{x&&x.hasRunningTasks&&!j.isCancellationRequested&&await R.Event.toPromise(x.onEnd)}}$cancelExtensionTestRun(I){I===void 0?this.j.cancelAllRuns():this.j.cancelRunById(I)}};e.$Wmc=u,e.$Wmc=u=Je([Ve(0,y.$oP),Ve(1,D.$2j)],u);const o=1e4;var t;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(t||(t={}));class l extends m.$Vc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(I,T,j,z,O){super(),this.y=I,this.z=T,this.C=j,this.D=z,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$ee),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new L.$pe(O));const F=this.B(new d.$Hh(()=>this.F(),o));this.B(this.j.token.onCancellationRequested(()=>F.schedule()));const B=new R.$ee;this.s=B.event,this.B((0,m.$Tc)(()=>{B.fire(),B.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(I,T){const[,j,z]=a.$ML.fromString(I).path,O=this.w.get(z);if(!O)return[];const F=this.g.get(j);if(!F)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(F.run,O,T)??[]}createRun(I){const T=this.y.id,j=this.y.controllerId,z=(0,A.$Rg)(),O=q=>(Q,...x)=>{if(B){this.C.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}this.y.isIncluded(Q)&&(this.H(Q),q(Q,...x))},F=(q,Q)=>{const x=Q instanceof Array?Q.map(h.TestMessage.from):[h.TestMessage.from(Q)];if(q.uri&&q.range){const X={range:h.Range.from(q.range),uri:q.uri};for(const ie of x)ie.location=ie.location||X}this.z.$appendTestMessagesInRun(T,z,a.$ML.fromExtHostTestItem(q,j).toString(),x)};let B=!1;const Z={isPersisted:this.y.isPersisted,token:this.j.token,name:I,onDidDispose:this.s,addCoverage:q=>{const Q=q.uri.toString(),x=new a.$ML([T,z,Q]).toString();this.w.set(Q,q),this.z.$appendCoverage(T,z,h.TestCoverage.fromFile(x,q))},enqueued:O(q=>{this.z.$updateTestStateInRun(T,z,a.$ML.fromExtHostTestItem(q,j).toString(),1)}),skipped:O(q=>{this.z.$updateTestStateInRun(T,z,a.$ML.fromExtHostTestItem(q,j).toString(),5)}),started:O(q=>{this.z.$updateTestStateInRun(T,z,a.$ML.fromExtHostTestItem(q,j).toString(),2)}),errored:O((q,Q,x)=>{F(q,Q),this.z.$updateTestStateInRun(T,z,a.$ML.fromExtHostTestItem(q,j).toString(),6,x)}),failed:O((q,Q,x)=>{F(q,Q),this.z.$updateTestStateInRun(T,z,a.$ML.fromExtHostTestItem(q,j).toString(),4,x)}),passed:O((q,Q)=>{this.z.$updateTestStateInRun(T,z,a.$ML.fromExtHostTestItem(q,this.y.controllerId).toString(),3,Q)}),appendOutput:(q,Q,x)=>{B||(x&&(this.y.isIncluded(x)?this.H(x):x=void 0),this.z.$appendOutputToRun(T,z,N.$Fe.fromString(q),Q&&h.location.from(Q),x&&a.$ML.fromExtHostTestItem(x,j).toString()))},end:()=>{B||(B=!0,this.z.$finishedTestRunTask(T,z),--this.f||this.G())}};return this.f++,this.g.set(z,{run:Z}),this.z.$startedTestRunTask(T,{id:z,name:I,running:!0}),Z}F(){for(const{run:I}of this.g.values())I.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(I){if(!(I instanceof w.$BP))throw new n.$gP(I.id);if(this.h.has(a.$ML.fromExtHostTestItem(I,this.y.controllerId).toString()))return;const T=[],j=this.y.colllection.root;for(;;){const z=h.TestItem.from(I);if(T.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),I===j))break;I=I.parent||j}this.z.$addTestsToRun(this.y.controllerId,this.y.id,T)}dispose(){this.G(),super.dispose()}}class r{get trackers(){return this.c.values()}constructor(I,T){this.g=I,this.h=T,this.c=new Map,this.f=new Map}getCoverageDetails(I,T){const j=a.$ML.root(I);return this.f.get(j)?.getCoverageDetails(I,T)||[]}disposeTestRun(I){this.f.get(I)?.dispose(),this.f.delete(I);for(const[T,{id:j}]of this.c)j===I&&this.c.delete(T)}prepareForMainThreadTestRun(I,T,j,z){return this.j(I,T,j,z)}cancelRunById(I){this.f.get(I)?.cancel()}cancelAllRuns(){for(const I of this.c.values())I.cancel()}createTestRun(I,T,j,z,O){const F=this.c.get(j);if(F)return F.createRun(z);const B=s.fromPublic(I,T,j,O),Z=c(j);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!j.continuous,profile:Z&&{group:P[Z.kind],id:Z.profileId},exclude:j.exclude?.map(Q=>a.$ML.fromExtHostTestItem(Q,T.root.id).toString())??[],id:B.id,include:j.include?.map(Q=>a.$ML.fromExtHostTestItem(Q,T.root.id).toString())??[T.root.id],preserveFocus:j.preserveFocus??!0,persist:O});const q=this.j(j,B,j.profile);return R.Event.once(q.onEnd)(()=>{this.g.$finishedExtensionTestRun(B.id)}),q.createRun(z)}j(I,T,j,z){const O=new l(T,this.g,this.h,j,z);return this.c.set(I,O),this.f.set(O.id,O),O}}e.$Xmc=r;const c=C=>{if(C.profile){if(!(C.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class s{static fromPublic(I,T,j,z){return new s(I,(0,A.$Rg)(),j.include?.map(O=>a.$ML.fromExtHostTestItem(O,I).toString())??[I],j.exclude?.map(O=>a.$ML.fromExtHostTestItem(O,I).toString())??[],z,T)}static fromInternal(I,T){return new s(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,T)}constructor(I,T,j,z,O,F){this.controllerId=I,this.id=T,this.isPersisted=O,this.colllection=F,this.c=j.map(B=>B+"\0"),this.f=z.map(B=>B+"\0")}isIncluded(I){const T=a.$ML.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const j of this.f)if(T===j||T.startsWith(j))return!1;for(const j of this.c)if(T===j||T.startsWith(j))return!0;return!1}}e.$Ymc=s;class v{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(I){this.j=I,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(I){this.c.add(I)}update(I){Object.assign(I.revived,h.TestItem.toPlain(I.item)),this.c.has(I)||this.f.add(I)}remove(I){if(this.c.has(I)){this.c.delete(I);return}this.f.delete(I);const T=a.$ML.parentId(I.item.extId);if(T&&this.h.has(T.toString())){this.h.add(I.item.extId);return}this.g.add(I)}getChangeEvent(){const{c:I,f:T,g:j}=this;return{get added(){return[...I].map(z=>z.revived)},get updated(){return[...T].map(z=>z.revived)},get removed(){return[...j].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class f extends i.$VL{constructor(){super(...arguments),this.s=new R.$ee,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(I){return this.f.get(I)}getMirroredTestDataByReference(I){return this.f.get(I.id)}w(I,T){return{...I,revived:h.TestItem.toPlain(I.item),depth:T?T.depth+1:0,children:new Set}}v(){return new v(this.s)}}class S{constructor(I){this.f=I}checkout(){this.c||(this.c=this.g());const I=this.c;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(T=>T.revived)},dispose:(0,M.$db)(()=>{--I.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(I){return this.c?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.c?.tests.apply(I)}g(){const I=new f({asCanonicalUri:T=>T});return this.f.$subscribeToDiffs(),{observers:0,tests:I}}}const p=(C,I,T,j)=>{T?Object.assign(T,j):I.$updateTestRunConfig(C.controllerId,C.profileId,j)};class k{#e;#t;#n;#i;#s;get label(){return this.f}set label(I){I!==this.f&&(this.f=I,p(this,this.#e,this.#i,{label:I}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(I){I!==this.g&&(this.g=I,p(this,this.#e,this.#i,{supportsContinuousRun:I}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(I){I!==this.isDefault&&(I?this.#t.add(this.profileId):this.#t.delete(this.profileId),p(this,this.#e,this.#i,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,p(this,this.#e,this.#i,{tag:I?h.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this.c}set configureHandler(I){I!==this.c&&(this.c=I,p(this,this.#e,this.#i,{hasConfigurationHandler:!!I}))}get onDidChangeDefault(){return R.Event.chain(this.#n,I=>I.map(T=>T.get(this.controllerId)?.get(this.profileId)).filter(E.$dg))}constructor(I,T,j,z,O,F,B,Z,q,Q=!1,x=void 0,X=!1){this.controllerId=O,this.profileId=F,this.f=B,this.kind=Z,this.runHandler=q,this._tag=x,this.g=X,this.#e=I,this.#s=T,this.#t=j,this.#n=z,T.set(F,this);const ie=P[Z];if(typeof ie!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);Q&&j.add(F),this.#i={profileId:F,controllerId:O,tag:x?h.TestTag.namespace(this.controllerId,x.id):null,label:B,group:ie,isDefault:Q,hasConfigurationHandler:!1,supportsContinuousRun:X},queueMicrotask(()=>{this.#i&&(this.#e.$publishTestRunProfile(this.#i),this.#i=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#i=void 0}}e.$Zmc=k;const P={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(ke[157],Pe([1,0,62,13,125,16,8]),function(le,e,d,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xP=e.$wP=e.$vP=void 0;class b{static{this.c=new L.$tP("TextEditorDecorationType")}constructor($,y,w){const h=b.c.nextId();$.$registerTextEditorDecorationType(y.identifier,h,R.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:h,dispose(){$.$removeTextEditorDecorationType(h)}})}}e.$vP=b;class m{constructor($,y){this.g=[],this.h=void 0,this.j=!1,this.c=$,this.d=$.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace($,y){this.k();let w=null;if($ instanceof M.$4M)w=new M.$5M($,$);else if($ instanceof M.$5M)w=$;else throw new Error("Unrecognized location");this.l(w,y,!1)}insert($,y){this.k(),this.l(new M.$5M($,$),y,!0)}delete($){this.k();let y=null;if($ instanceof M.$5M)y=$;else throw new Error("Unrecognized location");this.l(y,null,!0)}l($,y,w){const h=this.c.validateRange($);this.g.push({range:h,text:y,forceMoveMarkers:w})}setEndOfLine($){if(this.k(),$!==M.EndOfLine.LF&&$!==M.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=$}}class E{constructor($,y,w,h){this.c=$,this.d=y,this._accept(w),this.e=h;const g=this;this.value={get tabSize(){return g.f},set tabSize(a){g.n(a)},get indentSize(){return g.g},set indentSize(a){g.p(a)},get insertSpaces(){return g.j},set insertSpaces(a){g.s(a)},get cursorStyle(){return g.k},set cursorStyle(a){g.t(a)},get lineNumbers(){return g.l},set lineNumbers(a){g.u(a)}}}_accept($){this.f=$.tabSize,this.g=$.indentSize,this.h=$.originalIndentSize,this.j=$.insertSpaces,this.k=$.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to($.lineNumbers)}m($){if($==="auto")return"auto";if(typeof $=="number"){const y=Math.floor($);return y>0?y:null}if(typeof $=="string"){const y=parseInt($,10);return isNaN(y)?null:y>0?y:null}return null}n($){const y=this.m($);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}o($){if($==="tabSize")return"tabSize";if(typeof $=="number"){const y=Math.floor($);return y>0?y:null}if(typeof $=="string"){const y=parseInt($,10);return isNaN(y)?null:y>0?y:null}return null}p($){const y=this.o($);if(y!==null){if(typeof y=="number"){if(this.h===y)return;this.g=y,this.h=y}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}q($){return $==="auto"?"auto":$==="false"?!1:!!$}s($){const y=this.q($);if(typeof y=="boolean"){if(this.j===y)return;this.j=y}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}t($){this.k!==$&&(this.k=$,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:$})))}u($){this.l!==$&&(this.l=$,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from($)})))}assign($){const y={};let w=!1;if(typeof $.tabSize<"u"){const h=this.m($.tabSize);h==="auto"?(w=!0,y.tabSize=h):typeof h=="number"&&this.f!==h&&(this.f=h,w=!0,y.tabSize=h)}if(typeof $.indentSize<"u"){const h=this.o($.indentSize);h==="tabSize"?(w=!0,y.indentSize=h):typeof h=="number"&&this.h!==h&&(this.g=h,this.h=h,w=!0,y.indentSize=h)}if(typeof $.insertSpaces<"u"){const h=this.q($.insertSpaces);h==="auto"?(w=!0,y.insertSpaces=h):this.j!==h&&(this.j=h,w=!0,y.insertSpaces=h)}typeof $.cursorStyle<"u"&&this.k!==$.cursorStyle&&(this.k=$.cursorStyle,w=!0,y.cursorStyle=$.cursorStyle),typeof $.lineNumbers<"u"&&this.l!==$.lineNumbers&&(this.l=$.lineNumbers,w=!0,y.lineNumbers=R.TextEditorLineNumbersStyle.from($.lineNumbers)),w&&this.v("setOptions",this.c.$trySetOptions(this.d,y))}v($,y){y.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${$}' failed:'`),this.e.warn(w)})}}e.$wP=E;class A{constructor($,y,w,h,g,a,n,i){this.id=$,this.j=y,this.k=w,this.g=!1,this.h=new Set,this.c=g,this.d=new E(this.j,this.id,a,w),this.e=n,this.f=i;const u=this;this.value=Object.freeze({get document(){return h.value},set document(o){throw new N.$9("document")},get selection(){return u.c&&u.c[0]},set selection(o){if(!(o instanceof M.$6M))throw(0,N.$7)("selection");u.c=[o],u.l()},get selections(){return u.c},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof M.$6M)))throw(0,N.$7)("selections");u.c=o,u.l()},get visibleRanges(){return u.e},set visibleRanges(o){throw new N.$9("visibleRanges")},get options(){return u.d.value},set options(o){u.g||u.d.assign(o)},get viewColumn(){return u.f},set viewColumn(o){throw new N.$9("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(u.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new m(h.value,t);return o(l),u.m(l)},insertSnippet(o,t,l={undoStopBefore:!0,undoStopAfter:!0}){if(u.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=u.c.map(c=>R.Range.from(c));else if(t instanceof M.$4M){const{lineNumber:c,column:s}=R.Position.from(t);r=[{startLineNumber:c,startColumn:s,endLineNumber:c,endColumn:s}]}else if(t instanceof M.$5M)r=[R.Range.from(t)];else{r=[];for(const c of t)if(c instanceof M.$5M)r.push(R.Range.from(c));else{const{lineNumber:s,column:v}=R.Position.from(c);r.push({startLineNumber:s,startColumn:v,endLineNumber:s,endColumn:v})}}return y.$tryInsertSnippet($,h.value.version,o.value,r,l)},setDecorations(o,t){const l=t.length===0;l&&!u.h.has(o.key)||(l?u.h.delete(o.key):u.h.add(o.key),u.n(()=>{if(R.$lP(t))return y.$trySetDecorations($,o.key,R.$mP(t));{const r=new Array(4*t.length);for(let c=0,s=t.length;c<s;c++){const v=t[c];r[4*c]=v.start.line+1,r[4*c+1]=v.start.character+1,r[4*c+2]=v.end.line+1,r[4*c+3]=v.end.character+1}return y.$trySetDecorationsFast($,o.key,r)}}))},revealRange(o,t){u.n(()=>y.$tryRevealRange($,R.Range.from(o),t||M.TextEditorRevealType.Default))},show(o){y.$tryShowEditor($,R.ViewColumn.from(o))},hide(){y.$tryHideEditor($)}})}dispose(){(0,d.ok)(!this.g),this.g=!0}_acceptOptions($){(0,d.ok)(!this.g),this.d._accept($)}_acceptVisibleRanges($){(0,d.ok)(!this.g),this.e=$}_acceptViewColumn($){(0,d.ok)(!this.g),this.f=$}_acceptSelections($){(0,d.ok)(!this.g),this.c=$}async l(){const $=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,$)),this.value}m($){const y=$.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const w=y.edits.map(g=>g.range);w.sort((g,a)=>g.end.line===a.end.line?g.end.character===a.end.character?g.start.line===a.start.line?g.start.character-a.start.character:g.start.line-a.start.line:g.end.character-a.end.character:g.end.line-a.end.line);for(let g=0,a=w.length-1;g<a;g++){const n=w[g].end;if(w[g+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=y.edits.map(g=>({range:R.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,h,{setEndOfLine:typeof y.setEndOfLine=="number"?R.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n($){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):$().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$xP=A}),define(ke[73],Pe([1,0,62,4,3,2,5,6,153,20,157,16,11,27,15,39,46]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zP=e.$yP=void 0;class a{constructor(u){this.value=u,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(u,o){this.h=u,this.i=o,this.a=null,this.b=new Map,this.c=new y.$Bc,this.d=new N.$ee,this.e=new N.$ee,this.f=new N.$ee,this.g=new N.$ee,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const o=[],t=[],l=[];if(u.removedDocuments)for(const r of u.removedDocuments){const c=R.URI.revive(r),s=this.c.get(c);s?.unref()&&(this.c.delete(c),o.push(s.value))}if(u.addedDocuments)for(const r of u.addedDocuments){const c=R.URI.revive(r.uri);let s=this.c.get(c);if(s&&c.scheme!==w.Schemas.vscodeNotebookCell&&c.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);s||(s=new a(new m.$rP(this.h.getProxy(b.$1M.MainThreadDocuments),c,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty)),this.c.set(c,s),t.push(s.value)),s.ref()}if(u.removedEditors)for(const r of u.removedEditors){const c=this.b.get(r);this.b.delete(r),c&&l.push(c)}if(u.addedEditors)for(const r of u.addedEditors){const c=R.URI.revive(r.documentUri);d.ok(this.c.has(c),`document '${c}' does not exist`),d.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const s=this.c.get(c).value,v=new A.$xP(r.id,this.h.getProxy(b.$1M.MainThreadTextEditors),this.i,new g.$V(()=>s.document),r.selections.map(D.Selection.to),r.options,r.visibleRanges.map(f=>D.Range.to(f)),typeof r.editorPosition=="number"?D.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,v)}u.newActiveEditor!==void 0&&(d.ok(u.newActiveEditor===null||this.b.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this.a=u.newActiveEditor),(0,L.$Qc)(o),(0,L.$Qc)(l),u.removedDocuments&&this.e.fire(o),u.addedDocuments&&this.d.fire(t),(u.removedEditors||u.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),u.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(u){return this.c.get(u)?.value}allDocuments(){return h.Iterable.map(this.c.values(),u=>u.value)}getEditor(u){return this.b.get(u)}activeEditor(u){if(!this.a)return;const o=this.b.get(this.a);return u?o:o?.value}allEditors(){return[...this.b.values()]}};e.$yP=n,e.$yP=n=Je([Ve(0,E.$oP),Ve(1,$.$2j)],n),e.$zP=(0,M.$vi)("IExtHostDocumentsAndEditors")}),define(ke[360],Pe([1,0,19,4,6,157,16,8]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=void 0;class m{constructor(A,D){this.i=D,this.a=new N.$ee,this.b=new N.$ee,this.c=new N.$ee,this.d=new N.$ee,this.f=new N.$ee,this.g=new N.$ee,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(L.$1M.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors($=>this.g.fire($)),this.i.onDidChangeActiveTextEditor($=>this.f.fire($))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const D=this.i.allEditors();return A?D:D.map($=>$.value)}async showTextDocument(A,D,$){let y;typeof D=="number"?y={position:M.ViewColumn.from(D),preserveFocus:$}:typeof D=="object"?y={position:M.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?M.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:y={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(A.uri,y),h=w&&this.i.getEditor(w);if(h)return h.value;throw w?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,D){return new R.$vP(this.h,A,D).value}$acceptEditorPropertiesChanged(A,D){const $=this.i.getEditor(A);if(!$)throw new Error("unknown text editor");if(D.options&&$._acceptOptions(D.options),D.selections){const y=D.selections.selections.map(M.Selection.to);$._acceptSelections(y)}if(D.visibleRanges){const y=d.$Hb(D.visibleRanges.map(M.Range.to));$._acceptVisibleRanges(y)}if(D.options&&this.b.fire({textEditor:$.value,options:{...D.options,lineNumbers:M.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const y=b.TextEditorSelectionChangeKind.fromValue(D.selections.source),w=D.selections.selections.map(M.Selection.to);this.a.fire({textEditor:$.value,selections:w,kind:y})}if(D.visibleRanges){const y=d.$Hb(D.visibleRanges.map(M.Range.to));this.c.fire({textEditor:$.value,visibleRanges:y})}}$acceptEditorPositionData(A){for(const D in A){const $=this.i.getEditor(D);if(!$)throw new Error("Unknown text editor");const y=M.ViewColumn.to(A[D]);$.value.viewColumn!==y&&($._acceptViewColumn(y),this.d.fire({textEditor:$.value,viewColumn:y}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$glc=m}),define(ke[361],Pe([1,0,2,5,6,3,8,16,25,18]),function(le,e,d,N,L,R,M,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=e.$2mc=void 0,e.$2mc=(0,N.$vi)("IExtHostTimeline");class A{constructor(y,w){this.b=new Map,this.c=new Map,this.a=y.getProxy(L.$1M.MainThreadTimeline),w.registerArgumentProcessor({processArgument:(h,g)=>{if(h&&h.$mid===12)if(this.b.get(h.source)&&m.$Qm.equals(g,this.b.get(h.source)?.extension)){const a=h.uri===void 0?void 0:d.URI.revive(h.uri);return this.c.get(h.source)?.get(D(a))?.get(h.handle)}else return;return h}})}async $getTimeline(y,w,h,g){return this.b.get(y)?.provider.provideTimeline(d.URI.revive(w),h,g)}registerTimelineProvider(y,w,h,g){const a=new R.$Uc,n=this.d(w.id,g,a).bind(this);let i;w.onDidChange&&(i=w.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:w.id}),this));const u=this.c;return this.f({...w,scheme:y,onDidChange:void 0,async provideTimeline(o,t,l){t?.resetCache&&(a.clear(),u.get(w.id)?.clear());const r=await w.provideTimeline(o,t,l);if(r==null)return;const c=n(o,t);return{...r,source:w.id,items:r.items.map(c)}},dispose(){for(const o of u.values())o.get(w.id)?.clear();i?.dispose(),a.dispose()}},h)}d(y,w,h){return(g,a)=>{let n;if(a?.cacheResults){let i=this.c.get(y);i===void 0&&(i=new Map,this.c.set(y,i));const u=D(g);n=i.get(u),n===void 0&&(n=new Map,i.set(u,n))}return i=>{const{iconPath:u,...o}=i,t=`${y}|${i.id??i.timestamp}`;n?.set(t,i);let l,r,c;i.iconPath&&(u instanceof M.$ZN?c={id:u.id,color:u.color}:d.URI.isUri(u)?(l=u,r=u):{light:l,dark:r}=u);let s;return M.$sN.isMarkdownString(o.tooltip)?s=b.MarkdownString.from(o.tooltip):(0,E.$8f)(o.tooltip)?s=o.tooltip:M.$sN.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=b.MarkdownString.from(o.detail)):(0,E.$8f)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=o.detail),{...o,id:o.id??void 0,handle:t,source:y,command:i.command?w.toInternal(i.command,h):void 0,icon:l,iconDark:r,themeIcon:c,tooltip:s,accessibilityInformation:i.accessibilityInformation}}}}f(y,w){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:w}),(0,R.$Tc)(()=>{for(const g of this.c.values())g.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$3mc=A;function D($){return $?.toString()}}),define(ke[362],Pe([1,0,233,23,2,4,3,294,7,8,18,19,16,81,22,189,26]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=void 0;function a(u,o){if((0,A.$8f)(u))return{label:u};if(u&&typeof u=="object"&&typeof u.label=="string"){let t;return Array.isArray(u.highlights)&&(t=u.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),t=t.length?t:void 0),{label:u.label,highlights:t}}}class n extends M.$Vc{constructor(o,t,l){super(),this.f=o,this.g=t,this.h=l,this.a=new Map,this.b=new h.$n$;function r(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:c=>r(c)?this.r(c):Array.isArray(c)&&c.length>0?c.map(s=>r(s)?this.r(s):s):c})}registerTreeDataProvider(o,t,l){const r=this.createTreeView(o,{treeDataProvider:t},l);return{dispose:()=>r.dispose()}}createTreeView(o,t,l){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],c=t.dragAndDropController?.dragMimeTypes??[],s=!!t.dragAndDropController?.handleDrag,v=!!t.dragAndDropController?.handleDrop,f=this.m(o,t,l),S={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:c,hasHandleDrag:s,hasHandleDrop:v,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},p=this.f.$registerTreeViewDataProvider(o,S),k={get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get activeItem(){return(0,g.$GG)(l,"treeViewActiveItem"),f.focusedElement},get onDidChangeActiveItem(){return(0,g.$GG)(l,"treeViewActiveItem"),f.onDidChangeActiveItem},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get onDidChangeCheckboxState(){return f.onDidChangeCheckboxState},get message(){return f.message},set message(P){(0,y.$Uk)(P)&&(0,g.$GG)(l,"treeViewMarkdownMessage"),f.message=P},get title(){return f.title},set title(P){f.title=P},get description(){return f.description},set description(P){f.description=P},get badge(){return f.badge},set badge(P){P!==void 0&&E.ViewBadge.isViewBadge(P)?f.badge={value:Math.floor(Math.abs(P.value)),tooltip:P.tooltip}:P===void 0&&(f.badge=void 0)},reveal:(P,C)=>f.reveal(P,C),dispose:async()=>{await p,this.a.delete(o),f.dispose()}};return this.B(k),k}$getChildren(o,t){const l=this.a.get(o);return l?l.getChildren(t):Promise.reject(new b.$VF(o))}async $handleDrop(o,t,l,r,c,s,v,f){const S=this.a.get(o);if(!S)return Promise.reject(new b.$VF(o));const p=$.DataTransfer.toDataTransfer(l,async k=>(await this.f.$resolveDropFileData(o,t,k)).buffer);return v===o&&f&&await this.j(p,S,f,c,s),S.onDrop(p,r,c)}async j(o,t,l,r,c){const s=this.b.removeDragOperationTransfer(c);if(s)(await s)?.forEach((v,f)=>{v&&o.set(f,v)});else if(c&&t.handleDrag){const v=t.handleDrag(l,o,r);this.b.addDragOperationTransfer(c,v),await v}return o}async $handleDrag(o,t,l,r){const c=this.a.get(o);if(!c)return Promise.reject(new b.$VF(o));const s=await this.j(new E.$VN,c,t,r,l);if(!(!s||r.isCancellationRequested))return $.DataTransfer.from(s)}async $hasResolve(o){const t=this.a.get(o);if(!t)throw new b.$VF(o);return t.hasResolve}$resolve(o,t,l){const r=this.a.get(o);if(!r)throw new b.$VF(o);return r.resolveTreeItem(t,l)}$setExpanded(o,t,l){const r=this.a.get(o);if(!r)throw new b.$VF(o);r.setExpanded(t,l)}$setSelectionAndFocus(o,t,l){const r=this.a.get(o);if(!r)throw new b.$VF(o);r.setSelectionAndFocus(t,l)}$setVisible(o,t){const l=this.a.get(o);if(!l){if(!t)return;throw new b.$VF(o)}l.setVisible(t)}$changeCheckboxState(o,t){const l=this.a.get(o);if(!l)throw new b.$VF(o);l.setCheckboxState(t)}m(o,t,l){const r=this.B(new i(o,t,this.f,this.g.converter,this.h,l));return this.a.set(o,r),r}r(o){const t=this.a.get(o.$treeViewId);return t&&"$treeItemHandle"in o?t.getExtensionElement(o.$treeItemHandle):t&&"$focusedTreeItem"in o&&o.$focusedTreeItem?t.focusedElement:null}}e.$4mc=n;class i extends M.$Vc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(o=>this.getExtensionElement(o)).filter(o=>!(0,A.$eg)(o))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(o,t,l,r,c,s){if(super(),this.I=o,this.J=l,this.L=r,this.M=c,this.N=s,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$ee),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$ee),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$ee),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$ee),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$ee),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$ee),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$ee),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$pe,s.contributes&&s.contributes.views)for(const p in s.contributes.views)for(const k of s.contributes.views[p])k.id===o&&(this.P=k.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(p=>this.F.fire({message:!1,element:p})));let v,f;const S=R.Event.debounce(this.F.event,(p,k)=>(p||(p={message:!1,elements:[]}),k.element!==!1&&(v||(v=new Promise(P=>f=P),this.G=this.G.then(()=>v)),Array.isArray(k.element)?p.elements.push(...k.element):p.elements.push(k.element)),k.message&&(p.message=!0),p),200,!0);this.B(S(({message:p,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const P=f;return v=null,this.$(k).then(()=>P())})),p&&this.J.$setMessage(this.I,$.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(o){const t=o?this.getExtensionElement(o):void 0;if(o&&!t)return this.M.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let l=this.X(o);return l||(l=await this.Y(t)),l?l.map(r=>r.item):void 0}getExtensionElement(o){return this.j.get(o)}reveal(o,t){t=t||{select:!0,focus:!1};const l=(0,A.$eg)(t.select)?!0:t.select,r=(0,A.$eg)(t.focus)?!1:t.focus,c=(0,A.$eg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.G.then(()=>this.S(o)).then(s=>this.W(o,s[s.length-1]).then(v=>this.J.$reveal(this.I,{item:v.item,parentChain:s.map(f=>f.item)},{select:l,focus:r,expand:c})),s=>this.M.error(s)):this.J.$reveal(this.I,void 0,{select:l,focus:r,expand:c})}get message(){return this.O}set message(o){this.O=o,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(o){this.P=o,this.J.$setTitle(this.I,o,this.Q)}get description(){return this.Q}set description(o){this.Q=o,this.J.$setTitle(this.I,this.P,o)}get badge(){return this.R}set badge(o){this.R?.value===o?.value&&this.R?.tooltip===o?.tooltip||(this.R=$.ViewBadge.from(o),this.J.$setBadge(this.I,o))}setExpanded(o,t){const l=this.getExtensionElement(o);l&&(t?this.u.fire(Object.freeze({element:l})):this.w.fire(Object.freeze({element:l})))}setSelectionAndFocus(o,t){const l=!(0,D.$ub)(this.s,o);this.s=o;const r=this.t!==t;this.t=t,l&&this.y.fire(Object.freeze({selection:this.selectedElements})),r&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(o){o!==this.r&&(this.r=o,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(o){const t=(await Promise.all(o.map(async l=>{const r=this.getExtensionElement(l.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:l.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);t.forEach(l=>{l.treeItem.checkboxState=l.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(l=>[l.extensionItem,l.newState])})}async handleDrag(o,t,l){const r=[];for(const c of o){const s=this.getExtensionElement(c);s&&r.push(s)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,l),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(o,t,l){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,m.$nh)(()=>this.g?.handleDrop?this.g.handleDrop(r,o,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(o,t){if(!this.f.resolveTreeItem)return;const l=this.j.get(o);if(l){const r=this.m.get(l);if(r){const c=await this.f.resolveTreeItem(r.extensionItem,l,t)??r.extensionItem;return this.hb(c),r.item.tooltip=this.eb(c.tooltip),r.item.command=this.fb(r.disposableStore,c.command),r.item}}}S(o){return this.U(o).then(t=>t?this.S(t).then(l=>this.W(t,l[l.length-1]).then(r=>(l.push(r),l))):Promise.resolve([]))}U(o){const t=this.m.get(o);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,m.$nh)(()=>this.f.getParent(o))}W(o,t){const l=this.m.get(o);return l?Promise.resolve(l):(0,m.$nh)(()=>this.f.getTreeItem(o)).then(r=>this.kb(o,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const c=this.getExtensionElement(r);if(c){const s=this.m.get(c);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${r} from extension ${this.N.identifier.value}`)}))}X(o){if(o){let t;if(typeof o=="string"){const l=this.getExtensionElement(o);t=l?this.m.get(l):void 0}else t=o;return t&&t.children||void 0}return this.h}async Y(o){this.rb(o);const t=new w.$pe(this.Z.token);try{const l=o?this.m.get(o):void 0,r=await this.f.getChildren(o);if(t.token.isCancellationRequested)return;const c=(0,D.$Hb)(r||[]),s=await Promise.all((0,D.$Hb)(c).map(f=>this.f.getTreeItem(f)));if(t.token.isCancellationRequested)return;const v=s.map((f,S)=>f?this.db(c[S],f,l):null);return(0,D.$Hb)(v)}finally{t.dispose()}}$(o){if(o.some(l=>!l))return this.Z.dispose(!0),this.Z=new w.$pe,this.tb(),this.J.$refresh(this.I);{const l=this.ab(o);if(l.length)return this.bb(l)}return Promise.resolve(void 0)}ab(o){const t=new Set,l=o.map(c=>this.m.get(c));for(const c of l)if(c&&!t.has(c.item.handle)){let s=c;for(;s&&s.parent&&l.findIndex(v=>s&&s.parent&&v&&v.item.handle===s.parent.item.handle)===-1;){const v=this.j.get(s.parent.item.handle);s=v?this.m.get(v):void 0}s&&!s.parent&&t.add(c.item.handle)}const r=[];return t.forEach(c=>{const s=this.j.get(c);if(s){const v=this.m.get(s);v&&(!v.parent||!t.has(v.parent.item.handle))&&r.push(c)}}),r}bb(o){const t={};return Promise.all(o.map(l=>this.cb(l).then(r=>{r&&(t[l]=r.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(o){const t=this.getExtensionElement(o);if(t){const l=this.m.get(t);if(l)return this.rb(t),(0,m.$nh)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const c=this.ib(t,r,l.parent);return this.pb(t,c,l,l.parent),l.dispose(),c}return null})}return Promise.resolve(null)}db(o,t,l){const r=this.ib(o,t,l);if(t.id&&this.j.has(r.item.handle))throw new Error((0,d.localize)(0,null,t.id));return this.ob(o,r),this.qb(r,l),r}eb(o){return E.$sN.isMarkdownString(o)?$.MarkdownString.from(o):o}fb(o,t){return t?{...this.L.toInternal(t,o),originalId:t.command}:void 0}gb(o){if(o.checkboxState===void 0)return;let t,l,r;return typeof o.checkboxState=="number"?t=o.checkboxState:(t=o.checkboxState.state,l=o.checkboxState.tooltip,r=o.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:l,accessibilityInformation:r}}hb(o){if(!E.$QN.isTreeItem(o,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(o,t,l){this.hb(t);const r=this.B(new M.$Uc),c=this.kb(o,t,l),s=this.lb(t);return{item:{handle:c,parentHandle:l?l.item.handle:void 0,label:a(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(r,t.command),contextValue:t.contextValue,icon:s,iconDark:this.mb(t)||s,themeIcon:this.jb(t),collapsibleState:(0,A.$eg)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:l,children:void 0,disposableStore:r,dispose(){r.dispose()}}}jb(o){return o.iconPath instanceof E.$ZN?o.iconPath:void 0}kb(o,{id:t,label:l,resourceUri:r},c,s){if(t)return`${i.b}/${t}`;const v=a(l,this.N),f=c?c.item.handle:i.a;let S=v?v.label:r?(0,N.$6g)(r):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const p=this.m.has(o)?this.m.get(o).item.handle:void 0,k=this.X(c)||[];let P,C=0;do{if(P=`${f}/${C}:${S}`,s||!this.j.has(P)||p===P)break;C++}while(C<=k.length);return P}lb(o){if(o.iconPath&&!(o.iconPath instanceof E.$ZN))return typeof o.iconPath=="string"||L.URI.isUri(o.iconPath)?this.nb(o.iconPath):this.nb(o.iconPath.light)}mb(o){if(o.iconPath&&!(o.iconPath instanceof E.$ZN)&&o.iconPath.dark)return this.nb(o.iconPath.dark)}nb(o){return L.URI.isUri(o)?o:L.URI.file(o)}ob(o,t){this.j.set(t.item.handle,o),this.m.set(o,t)}pb(o,t,l,r){this.j.delete(t.item.handle),this.m.delete(o),t.item.handle!==l.item.handle&&this.j.delete(l.item.handle),this.ob(o,t);const c=this.X(r)||[],s=c.filter(v=>v.item.handle===l.item.handle)[0];s&&c.splice(c.indexOf(s),1,t)}qb(o,t){t?(t.children||(t.children=[]),t.children.push(o)):(this.h||(this.h=[]),this.h.push(o))}rb(o){if(o){const t=this.m.get(o);if(t){if(t.children)for(const l of t.children){const r=this.j.get(l.item.handle);r&&this.sb(r)}t.children=void 0}}else this.tb()}sb(o){const t=this.m.get(o);if(t){if(t.children)for(const l of t.children){const r=this.j.get(l.item.handle);r&&this.sb(r)}this.m.delete(o),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(o=>o.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[363],Pe([1,0,4,3,2,30,16,92,6,8]),function(le,e,d,N,L,R,M,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=void 0;class A extends N.$Vc{#e;#t;#n;#i;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(w,h,g,a){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new d.$ee),this.onDidDispose=this.#d.event,this.#h=this.B(new d.$ee),this.onDidChangeViewState=this.#h.event,this.#e=w,this.#t=h,this.#i=g,this.#n=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#u=a.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#i.dispose(),super.dispose())}get webview(){return this.c(),this.#i}get viewType(){return this.c(),this.#n}get title(){return this.c(),this.#r}set title(w){this.c(),this.#r!==w&&(this.#r=w,this.#t.$setTitle(this.#e,w))}get iconPath(){return this.c(),this.#a}set iconPath(w){this.c(),this.#a!==w&&(this.#a=w,this.#t.$setIconPath(this.#e,L.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(w){this.#l||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(this.#u=w.active,this.#c=w.visible,this.#o=w.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(w,h){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof w>"u"?void 0:M.ViewColumn.from(w),preserveFocus:!!h})}c(){if(this.#l)throw new Error("Webview is disposed")}}class D extends N.$Vc{static c(){return(0,R.$Rg)()}constructor(w,h,g){super(),this.j=h,this.m=g,this.g=new Map,this.h=new Map,this.f=w.getProxy(m.$1M.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(w=>w.dispose()),this.g.clear()}createWebviewPanel(w,h,g,a,n={}){const i=typeof a=="object"?a.viewColumn:a,u={viewColumn:M.ViewColumn.from(i),preserveFocus:typeof a=="object"&&!!a.preserveFocus},o=(0,b.$vlc)(w),t=D.c();this.f.$createWebviewPanel((0,b.$xlc)(w),t,h,{title:g,panelOptions:$(n),webviewOptions:(0,b.$ylc)(w,this.m,n),serializeBuffersForPostMessage:o},u);const l=this.j.createNewWebview(t,n,w);return this.createNewWebviewPanel(t,h,g,i,n,l,!0)}$onDidChangeWebviewPanelViewStates(w){const h=Object.keys(w);h.sort((g,a)=>{const n=w[g],i=w[a];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const g of h){const a=this.getWebviewPanel(g);if(!a)continue;const n=w[g];a._updateViewState({active:n.active,visible:n.visible,viewColumn:M.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(w){this.getWebviewPanel(w)?.dispose(),this.g.delete(w),this.j.deleteWebview(w)}registerWebviewPanelSerializer(w,h,g){if(this.h.has(h))throw new Error(`Serializer for '${h}' already registered`);return this.h.set(h,{serializer:g,extension:w}),this.f.$registerSerializer(h,{serializeBuffersForPostMessage:(0,b.$vlc)(w)}),new E.$3M(()=>{this.h.delete(h),this.f.$unregisterSerializer(h)})}async $deserializeWebviewPanel(w,h,g,a){const n=this.h.get(h);if(!n)throw new Error(`No serializer found for '${h}'`);const{serializer:i,extension:u}=n,o=this.j.createNewWebview(w,g.webviewOptions,u),t=this.createNewWebviewPanel(w,h,g.title,a,g.panelOptions,o,g.active);await i.deserializeWebviewPanel(t,g.state)}createNewWebviewPanel(w,h,g,a,n,i,u){const o=new A(w,this.f,i,{viewType:h,title:g,viewColumn:a,panelOptions:n,active:u});return this.g.set(w,o),o}getWebviewPanel(w){return this.g.get(w)}}e.$zlc=D;function $(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(ke[364],Pe([1,0,4,3,92,16,6,8]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=void 0;class m extends N.$Vc{#e;#t;#n;#i;#s;#r;#a;#o;#c;constructor(D,$,y,w,h,g){super(),this.#s=!1,this.#u=this.B(new d.$ee),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new d.$ee),this.onDidDispose=this.#l.event,this.#n=y,this.#a=w,this.#e=D,this.#t=$,this.#i=h,this.#r=g}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#i.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#o}set description(D){this.a(),this.#o!==D&&(this.#o=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#r}get webview(){return this.#i}get viewType(){return this.#n}_setVisible(D){D===this.#r||this.#s||(this.#r=D,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(D,$){this.d=$,this.b=new Map,this.c=new Map,this.a=D.getProxy(M.$1M.MainThreadWebviewViews)}registerWebviewViewProvider(D,$,y,w){if(this.b.has($))throw new Error(`View provider for '${$}' already registered`);return this.b.set($,{provider:y,extension:D}),this.a.$registerWebviewViewProvider((0,L.$xlc)(D),$,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,L.$vlc)(D)}),new b.$3M(()=>{this.b.delete($),this.a.$unregisterWebviewViewProvider($)})}async $resolveWebviewView(D,$,y,w,h){const g=this.b.get($);if(!g)throw new Error(`No view provider found for '${$}'`);const{provider:a,extension:n}=g,i=this.d.createNewWebview(D,{},n),u=new m(D,this.a,$,y,i,!0);this.c.set(D,u),await a.resolveWebviewView(u,{state:w},h)}async $onDidChangeWebviewViewVisibility(D,$){this.e(D)._setVisible($)}async $disposeWebviewView(D){const $=this.e(D);this.c.delete(D),$.dispose(),this.d.deleteWebview(D)}e(D){const $=this.c.get(D);if(!$)throw new Error("No webview found");return $}}e.$7mc=E}),define(ke[365],Pe([1,0,70,15,11,265,33,12]),function(le,e,d,N,L,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnc=void 0;let m=class{constructor(D,$){D.addFileSystemProvider(N.Schemas.file,new E($),{isCaseSensitive:b.$k})}};e.$Lnc=m,e.$Lnc=m=Je([Ve(0,d.$rlc),Ve(1,L.$2j)],m);class E{constructor(D){this.b=D,this.a=new R.$$q(this.b)}async stat(D){const $=await this.a.stat(D);return{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===M.FilePermission.Readonly?1:void 0}}readDirectory(D){return this.a.readdir(D)}createDirectory(D){return this.a.mkdir(D)}readFile(D){return this.a.readFile(D)}writeFile(D,$,y){return this.a.writeFile(D,$,{...y,unlock:!1,atomic:!1})}delete(D,$){return this.a.delete(D,{...$,useTrash:!1,atomic:!1})}rename(D,$,y){return this.a.rename(D,$,y)}copy(D,$,y){return this.a.copy(D,$,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(D,$){throw new Error("Method not implemented.")}}}),define(ke[366],Pe([1,0,17,64,30,34,3,6,2,20]),function(le,e,d,N,L,R,M,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jnc=void 0;let A=class extends M.$Vc{constructor($,y){super();const w=$.getProxy(b.$1M.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async h=>{const g=m.URI.file((0,d.$kc)((0,N.tmpdir)(),(0,L.$Rg)()));return await w.$download(h,g),g})}};e.$Jnc=A,e.$Jnc=A=Je([Ve(0,E.$oP),Ve(1,R.$KP)],A)}),define(ke[367],Pe([1,0,52,17,2,93,3,15,7,32]),function(le,e,d,N,L,R,M,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=void 0;class A extends R.$tlc{constructor(){super(...arguments),this.i=null}async g(t){const l=await super.g(t);if(l.scheme!==b.Schemas.file)return l;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${l.fsPath}.`),l;const r=l.fsPath;let c=0;do{let s;c===0?s=r:s=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${c}`:`${r}-${c}`,await D(s);const v=N.$kc(s,"vscode.lock"),f=await h(this.d,v,!1);if(f)return this.i=f,process.on("exit",()=>{f.dispose()}),L.URI.file(s);c++}while(c<10);return l}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Vnc=A;async function D(o){try{await E.Promises.stat(o);return}catch{}try{await E.Promises.mkdir(o,{recursive:!0})}catch{}}const $=1e3,y=10*60*1e3;class w extends M.$Vc{constructor(t,l){super(),this.b=t,this.c=l,this.a=this.B(new m.$Gh),this.a.cancelAndSet(async()=>{const r=await g(t,l);(!r||r.pid!==process.pid)&&(t.info(`Lock '${l}': The lock was lost unexpectedly.`),this.a.cancel());try{await E.Promises.utimes(l,new Date,new Date)}catch(c){t.error(c),t.info(`Lock '${l}': Could not update mtime.`)}},$)}dispose(){super.dispose();try{d.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const l={pid:process.pid,willReleaseAt:Date.now()+t};await E.Promises.writeFile(this.c,JSON.stringify(l),{flag:"w"})}catch(l){this.b.error(l)}}}async function h(o,t,l){try{const c={pid:process.pid,willReleaseAt:0};await E.Promises.writeFile(t,JSON.stringify(c),{flag:"wx"})}catch(c){o.error(c)}const r=await g(o,t);return!r||r.pid!==process.pid?l?(o.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(o,t)):(o.info(`Lock '${t}': Lock acquired.`),new w(o,t))}async function g(o,t){let l;try{l=await E.Promises.readFile(t)}catch(r){return o.error(r),null}try{return JSON.parse(String(l))}catch(r){return o.error(r),null}}async function a(o,t){let l;try{l=await E.Promises.stat(t)}catch(r){return o.error(r),0}return l.mtime.getTime()}function n(o){try{return process.kill(o,0),!0}catch{return!1}}async function i(o,t){const l=await g(o,t);if(!l)return o.info(`Lock '${t}': Could not read pid of lock holder.`),u(o,t);if(l.willReleaseAt){let f=l.willReleaseAt-Date.now();if(f<5e3){for(f>0?o.info(`Lock '${t}': The lockfile is scheduled to be released in ${f} ms.`):o.info(`Lock '${t}': The lockfile is scheduled to have been released.`);f>0;){if(await(0,m.$wh)(Math.min(100,f)),await a(o,t)===0)return u(o,t);f=l.willReleaseAt-Date.now()}return u(o,t)}}if(!n(l.pid))return o.info(`Lock '${t}': The pid ${l.pid} appears to be gone.`),u(o,t);const r=await a(o,t),c=Date.now()-r;if(c<=y)return o.info(`Lock '${t}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;o.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,m.$wh)(2e3);const s=await a(o,t),v=Date.now()-s;return v<=y?(o.info(`Lock '${t}': The lock does not look stale, elapsed: ${v} ms, giving up.`),null):(o.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),u(o,t))}async function u(o,t){o.info(`Lock '${t}': Deleting a stale lock.`);try{await E.Promises.unlink(t)}catch{}return h(o,t,!0)}}),define(ke[368],Pe([1,0,30,20,43,34]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=void 0;let M=class extends L.$Plc{constructor(m,E){super(!0,m,E)}createTerminal(m,E,A){return this.createTerminalFromOptions({name:m,shellPath:E,shellArgs:A})}createTerminalFromOptions(m,E){const A=new L.$Olc(this.a,(0,d.$Rg)(),m,m.name);return this.f.push(A),A.create(m,this.R(m,E)),A.value}};e.$enc=M,e.$enc=M=Je([Ve(0,R.$KP),Ve(1,N.$oP)],M)}),define(ke[369],Pe([1,0,4,36,38,5]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=e.$jM=e.OutputChannelUpdateMode=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=void 0,e.$9L="text/x-code-output",e.$0L="output",e.$$L="Log",e.$_L="text/x-code-log-output",e.$aM="log",e.$bM="workbench.panel.output",e.$cM=new L.$Mj("inOutput",!1),e.$dM=new L.$Mj("activeLogOutput",!1),e.$eM=new L.$Mj("activeLogOutput.levelSettable",!1),e.$fM=new L.$Mj("activeLogOutput.level",""),e.$gM=new L.$Mj("activeLogOutput.levelIsDefault",!1),e.$hM=new L.$Mj("outputView.scrollLock",!1),e.$iM=(0,R.$vi)("outputService");var M;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$jM={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new d.$ee,this.onDidRegisterChannel=this.b.event,this.c=new d.$ee,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(A=>E.push(A)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}N.$bo.add(e.$jM.OutputChannels,new b),e.$kM=new L.$Mj("activeOutputChannel","")}),define(ke[158],Pe([1,0,6,5,20,25,11,369,70,28,60,194,21,18,33,4,3]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=e.$Fmc=void 0;class a extends M.$8j{get disposed(){return this.n}constructor(o,t,l,r,c){super(),this.id=o,this.name=t,this.r=l,this.s=r,this.extension=c,this.m=0,this.n=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel(s=>this.setLevel(s)))}get logLevel(){return this.getLevel()}appendLine(o){this.append(o+`
`)}append(o){this.info(o)}clear(){const o=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,o)}replace(o){const t=this.m;this.info(o),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(o,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof o=="boolean"?o:t))}hide(){this.s.$close(this.id)}g(o,t){this.m+=$.$Fe.fromString(t).byteLength,(0,M.log)(this.r,o,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends a{appendLine(o){this.append(o)}}let i=class{constructor(o,t,l,r,c,s){this.i=t,this.j=l,this.k=r,this.l=c,this.m=s,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=o.getProxy(d.$1M.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,D.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.h=o;for(const[t,l]of this.g)l.visible=t===this.h}createOutputChannel(o,t,l){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,c=(0,y.$8f)(t)?t:void 0;if((0,y.$8f)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let s;const v=this.i.environment.extensionLogLevel?.find(([S])=>R.$Qm.equals(l.identifier,S))?.[1];v&&(s=(0,M.$gk)(v));const f=r?this.o(o,s,l):this.n(o,c,l);return f.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),r?this.r(o,s??this.m.getLevel(),f):this.q(o,f)}async n(o,t,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,c=this.k.extUri.joinPath(r,`${this.f++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),v=await this.a.$register(o,c,t,l.identifier.value);return new a(v,o,s,this.a,l)}async o(o,t,l){const r=await this.p(l),c=o.replace(/[\\/:\*\?"<>\|]/g,""),s=this.k.extUri.joinPath(r,`${c}.log`),v=`${l.identifier.value}.${c}`,f=this.l.createLogger(s,{id:v,name:o,logLevel:t,extensionId:l.identifier.value});return new n(v,o,f,this.a,l)}p(o){let t=this.d.get(o.identifier.value);if(!t){const l=this.k.extUri.joinPath(this.i.logsLocation,o.identifier.value);this.d.set(o.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(l)}catch(r){if((0,w.$fl)(r)!==w.FileSystemProviderErrorCode.FileExists)throw r}return l})())}return t}q(o,t){let l=!1;const r=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return o},append(c){r(),t.then(s=>s.append(c))},appendLine(c){r(),t.then(s=>s.appendLine(c))},clear(){r(),t.then(c=>c.clear())},replace(c){r(),t.then(s=>s.replace(c))},show(c,s){r(),t.then(v=>v.show(c,s))},hide(){r(),t.then(c=>c.hide())},dispose(){l=!0,t.then(c=>c.dispose())}}}r(o,t,l){const r=new g.$Uc,c=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},s=r.add(new h.$ee);function v(f){t=f,s.fire(f)}return l.then(f=>{r.add(f),f.logLevel!==t&&v(f.logLevel),r.add(f.onDidChangeLogLevel(S=>v(S)))}),{...this.q(o,l),get logLevel(){return t},onDidChangeLogLevel:s.event,trace(f,...S){c(),l.then(p=>p.trace(f,...S))},debug(f,...S){c(),l.then(p=>p.debug(f,...S))},info(f,...S){c(),l.then(p=>p.info(f,...S))},warn(f,...S){c(),l.then(p=>p.warn(f,...S))},error(f,...S){c(),l.then(p=>p.error(f,...S))},dispose(){r.dispose()}}}};e.$Fmc=i,e.$Fmc=i=Je([Ve(0,L.$oP),Ve(1,E.$EP),Ve(2,m.$rlc),Ve(3,A.$7kc),Ve(4,M.$3j),Ve(5,M.$2j)],i),e.$Gmc=(0,N.$vi)("IExtHostOutputService")}),define(ke[159],Pe([1,0,5,7]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=void 0,e.$fn=(0,d.$vi)("remoteAgentService"),e.$gn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(L){let R=1/0;for(let b=0;b<this.maxSampleCount;b++){const m=await L.getRoundTripTime();if(m===void 0)return;R=Math.min(R,m/2),await(0,N.$wh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(R):M=this.initial.reduce((b,m)=>b+m,0)/this.initial.length,this.lastMeasurement={initial:M,current:R,average:this.average.reduce((b,m)=>b+m,0)/this.average.length,high:typeof M>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[370],Pe([1,0,237,66,36,42,54,3,4,159,12,24,7]),function(le,e,d,N,L,R,M,b,m,E,A,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=void 0,e.$BJ=Object.freeze({id:"application",order:100,title:(0,d.localize)(0,null),type:"object"}),e.$CJ=Object.freeze({id:"workbench",order:7,title:(0,d.localize)(1,null),type:"object"}),e.$DJ=Object.freeze({id:"security",scope:1,title:(0,d.localize)(2,null),type:"object",order:7}),e.$EJ=Object.freeze({id:"problems",title:(0,d.localize)(3,null),type:"object",order:101}),e.$FJ={ConfigurationMigration:"base.contributions.configuration.migration"};class y{constructor(){this.migrations=[],this.a=new m.$ee,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const w=new y;L.$bo.add(e.$FJ.ConfigurationMigration,w);let h=class extends b.$Vc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async u=>{for(const o of u.added)await this.f(o,w.migrations)})),this.c(w.migrations),this.B(w.onDidRegisterConfigurationMigration(u=>this.c(u)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(u=>this.g(u,n?.uri))])}async g(n,i){const u=this.a.inspect(n.key,{resource:i}),o=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,l]of o){const r=u[t];if(!r)continue;const c=[];if(r.value!==void 0){const s=await this.h(n,t,r.value,i,void 0);for(const v of s??[])c.push([v,[]])}for(const{identifiers:s,value:v}of r.overrides??[])if(v!==void 0){const f=await this.h(n,t,v,i,s);for(const S of f??[])c.push([S,s])}c.length&&await Promise.allSettled(c.map(async([[s,v],f])=>this.a.updateValue(s,v.value,{resource:i,overrideIdentifiers:f},l)))}}async h(n,i,u,o,t){const l=c=>{const v=this.a.inspect(c,{resource:o})[i];if(v)return t?v.overrides?.find(({identifiers:f})=>(0,D.$6n)(f,t))?.value:v.value},r=await n.migrateFn(u,l);return Array.isArray(r)?r:[[n.key,r]]}};e.$GJ=h,e.$GJ=h=Je([Ve(0,M.$2i),Ve(1,R.$Ei)],h);let g=class extends b.$Vc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new $.$Sh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;L.$bo.as(N.$go.Configuration).registerConfiguration({...e.$DJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,d.localize)(4,null)},default:[],markdownDescription:(0,d.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,d.localize)(6,null),scope:2}}})}};e.$HJ=g,e.$HJ=g=Je([Ve(0,E.$fn)],g)}),define(ke[371],Pe([1,0,35,15,17,23,247,370,66,5,36]),function(le,e,d,N,L,R,M,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$_gb=e.$$gb=void 0,e.$ahb=h,e.$bhb=g,e.$$gb=(0,E.$vi)("editorResolverService"),e.$_gb="workbench.editorAssociations";const D=A.$bo.as(m.$go.Configuration),$={...b.$CJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration($);var y;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(y||(e.RegisteredEditorPriority=y={}));var w;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function h(a){switch(a){case y.exclusive:return 5;case y.default:return 4;case y.builtin:return 3;case y.option:default:return 1}}function g(a,n){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(n.scheme))return!1;const o=typeof a=="string"&&a.indexOf(L.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,R.$6g)(n);return d.$ok(typeof a=="string"?a.toLowerCase():a,o.toLowerCase())}}),define(ke[372],Pe([1,0,31,15,17,12,23,2,5,284,42,148,159]),function(le,e,d,N,L,R,M,b,m,E,A,D,$){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=void 0,e.$CM=(0,m.$vi)("pathService");let w=y=class{constructor(g,a,n,i){this.d=g,this.e=a,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const u=await this.e.getEnvironment();return this.c=u?.userHome??g})()}hasValidBasename(g,a,n){return typeof a=="string"||typeof a>"u"?this.a.then(i=>this.h(g,i,a)):this.h(g,a,n)}h(g,a,n){return g.scheme===N.Schemas.file||g.scheme===N.Schemas.vscodeRemote?(0,d.$sg)(n??(0,M.$6g)(g),a===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(g,a){if(g.remoteAuthority)return N.Schemas.vscodeRemote;const n=(0,E.$zM)(a.getWorkspace());if(n)return n;const i=a.getWorkspace().folders[0];if(i)return i.uri.scheme;const u=a.getWorkspace().configuration;return u?u.scheme:N.Schemas.file}userHome(g){return g?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(g=>g===1?L.$gc:L.$hc)}async fileURI(g){let a="";if(await this.a===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const i=g.indexOf("/",2);i===-1?(a=g.substring(2),g="/"):(a=g.substring(2,i),g=g.substring(i)||"/")}return b.URI.from({scheme:N.Schemas.file,authority:a,path:g,query:"",fragment:""})}};e.$DM=w,e.$DM=w=y=Je([Ve(1,$.$fn),Ve(2,D.$lM),Ve(3,A.$Ei)],w)}),define(ke[373],Pe([1,0,249,19,55,4,56,3,2,54,254,11,67,142,88,42,148,26,22,18,24,38]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=e.OnPortForward=e.$qM=e.$pM=e.TunnelSource=e.TunnelCloseReason=e.$nM=e.$mM=void 0,e.$oM=s,e.$rM=S,e.$sM=p,e.$tM=k,e.$uM=C;const t=10*1e3,l="remote.tunnels.toRestore",r="remote.tunnels.toRestoreExpiration",c=1e3*60*60*24*14;e.$mM="onTunnel",e.$nM=new o.$Mj("forwardedPortsViewEnabled",!1,d.localize(0,null));function s(j){const z=j.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}var v;(function(j){j.Other="Other",j.User="User",j.AutoForwardEnd="AutoForwardEnd"})(v||(e.TunnelCloseReason=v={}));var f;(function(j){j[j.User=0]="User",j[j.Auto=1]="Auto",j[j.Extension=2]="Extension"})(f||(e.TunnelSource=f={})),e.$pM={source:f.User,description:d.localize(1,null)},e.$qM={source:f.Auto,description:d.localize(2,null)};function S(j,z,O){const F=j.get(k(z,O));if(F)return F;if((0,w.$hw)(z))for(const B of w.$gw){const Z=k(B,O);if(j.has(Z))return j.get(Z)}else if((0,w.$jw)(z))for(const B of w.$iw){const Z=k(B,O);if(j.has(Z))return j.get(Z)}}function p(j,z,O){const F=S(j,z,O);if(F)return F;const B=(0,w.$jw)(z)?"localhost":(0,w.$hw)(z)?"0.0.0.0":void 0;if(B)return S(j,B,O)}function k(j,z){return j+":"+z}var P;(function(j){j.Notify="notify",j.OpenBrowser="openBrowser",j.OpenBrowserOnce="openBrowserOnce",j.OpenPreview="openPreview",j.Silent="silent",j.Ignore="ignore"})(P||(e.OnPortForward=P={}));function C(j){return j&&"host"in j&&typeof j.host=="string"&&"port"in j&&typeof j.port=="number"&&(!("detail"in j)||typeof j.detail=="string")&&(!("pid"in j)||typeof j.pid=="string")}class I extends b.$Vc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new R.$ee,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(O=>{(O.affectsConfiguration(I.c)||O.affectsConfiguration(I.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,O,F){let B=this.w(z,O,F,this.j,0);const Z={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;B>=0;){const q=this.j[B];q.key===z?(Z.onAutoForward=q.onAutoForward??Z.onAutoForward,Z.elevateIfNeeded=q.elevateIfNeeded!==void 0?q.elevateIfNeeded:Z.elevateIfNeeded,Z.label=q.label??Z.label,Z.requireLocalPort=q.requireLocalPort,Z.protocol=q.protocol):(Z.onAutoForward=Z.onAutoForward??q.onAutoForward,Z.elevateIfNeeded=Z.elevateIfNeeded!==void 0?Z.elevateIfNeeded:q.elevateIfNeeded,Z.label=Z.label??q.label,Z.requireLocalPort=Z.requireLocalPort!==void 0?Z.requireLocalPort:void 0,Z.protocol=Z.protocol??q.protocol),B=this.w(z,O,F,this.j,B+1)}return Z.onAutoForward!==void 0||Z.elevateIfNeeded!==void 0||Z.label!==void 0||Z.requireLocalPort!==void 0||Z.protocol!==void 0?Z:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,i.$8f)(z.host)&&(0,i.$_f)(z.port)}w(z,O,F,B,Z){if(Z>=B.length)return-1;const q=!(0,w.$hw)(O)&&!(0,w.$jw)(O),x=B.slice(Z).findIndex(X=>(0,i.$_f)(X.key)?q?!1:X.key===z:this.t(X.key)?q?!1:z>=X.key.start&&z<=X.key.end:this.u(X.key)?z===X.key.port&&O===X.key.host:F?X.key.test(F):!1);return x>=0?x+Z:-1}y(){const z=this.r.getValue(I.c);if(!z||!(0,i.$0f)(z))return[];const O=[];for(const B in z){if(B===void 0)continue;const Z=z[B];let q;if(Number(B))q=Number(B);else if((0,i.$8f)(B))if(I.g.test(B)){const Q=B.match(I.g);q={start:Number(Q[1]),end:Number(Q[2])}}else if(I.h.test(B)){const Q=B.match(I.h);q={host:Q[1],port:Number(Q[2])}}else{let Q;try{Q=RegExp(B)}catch{}Q&&(q=Q)}q&&O.push({key:q,elevateIfNeeded:Z.elevateIfNeeded,onAutoForward:Z.onAutoForward,label:Z.label,requireLocalPort:Z.requireLocalPort,protocol:Z.protocol})}const F=this.r.getValue(I.f);return F&&(this.m={elevateIfNeeded:F.elevateIfNeeded,label:F.label,onAutoForward:F.onAutoForward,requireLocalPort:F.requireLocalPort,protocol:F.protocol}),this.z(O)}z(z){function O(F,B){return(0,i.$_f)(F.key)?F.key:B.t(F.key)?F.key.start:B.u(F.key)?F.key.port:Number.MAX_VALUE}return z.sort((F,B)=>O(F,this)-O(B,this))}C(){return this.m}static providedActionToAction(z){switch(z){case w.ProvidedOnAutoForward.Notify:return P.Notify;case w.ProvidedOnAutoForward.OpenBrowser:return P.OpenBrowser;case w.ProvidedOnAutoForward.OpenBrowserOnce:return P.OpenBrowserOnce;case w.ProvidedOnAutoForward.OpenPreview:return P.OpenPreview;case w.ProvidedOnAutoForward.Silent:return P.Silent;case w.ProvidedOnAutoForward.Ignore:return P.Ignore;default:return}}async addAttributes(z,O,F){const Z=this.r.inspect(I.c).userRemoteValue;let q;!Z||!(0,i.$0f)(Z)?q={}:q=(0,u.$2n)(Z),q[`${z}`]||(q[`${z}`]={});for(const Q in O)q[`${z}`][Q]=O[Q];return this.r.updateValue(I.c,q,F)}}e.$vM=I;let T=class extends b.$Vc{constructor(z,O,F,B,Z,q,Q,x,X,ie){super(),this.H=z,this.I=O,this.J=F,this.L=B,this.M=Z,this.N=q,this.O=Q,this.P=x,this.Q=X,this.R=ie,this.c=new Map,this.g=new R.$ee,this.onForwardPort=this.g.event,this.h=new R.$ee,this.onClosePort=this.h.event,this.j=new R.$ee,this.onPortName=this.j.event,this.n=new R.$ee,this.onCandidatesChanged=this.n.event,this.t=new R.$ee,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$ee,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new I(F),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async me=>{const ue=await this.getAttributes(me.map(ve=>({port:ve.tunnelRemotePort,host:ve.tunnelRemoteHost})));for(const ve of me)if(ve.localAddress){const te=k(ve.tunnelRemoteHost,ve.tunnelRemotePort),U=p(this.m??new Map,ve.tunnelRemoteHost,ve.tunnelRemotePort);this.forwarded.set(te,{remotePort:ve.tunnelRemotePort,remoteHost:ve.tunnelRemoteHost,localAddress:ve.localAddress,protocol:ue?.get(ve.tunnelRemotePort)?.protocol??w.TunnelProtocol.Http,localUri:await this.X(ve.localAddress,ue?.get(ve.tunnelRemotePort)),localPort:ve.tunnelLocalPort,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:ve.privacy,source:e.$pM}),this.f.set(te,ve)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async me=>{const ue=k(me.tunnelRemoteHost,me.tunnelRemotePort);if(!p(this.forwarded,me.tunnelRemoteHost,me.tunnelRemotePort)&&!p(this.detected,me.tunnelRemoteHost,me.tunnelRemotePort)&&!p(this.c,me.tunnelRemoteHost,me.tunnelRemotePort)&&me.localAddress){const ve=p(this.m??new Map,me.tunnelRemoteHost,me.tunnelRemotePort),te=(await this.getAttributes([{port:me.tunnelRemotePort,host:me.tunnelRemoteHost}]))?.get(me.tunnelRemotePort);this.forwarded.set(ue,{remoteHost:me.tunnelRemoteHost,remotePort:me.tunnelRemotePort,localAddress:me.localAddress,protocol:te?.protocol??w.TunnelProtocol.Http,localUri:await this.X(me.localAddress,te),localPort:me.tunnelLocalPort,closeable:!0,runningProcess:ve?.detail,hasRunningProcess:!!ve,pid:ve?.pid,privacy:me.privacy,source:e.$pM})}await this.cb(),this.f.set(ue,me),this.g.fire(this.forwarded.get(ue))})),this.B(this.H.onTunnelClosed(me=>this.W(me,v.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$mM))?(this.R.createKey(e.$nM.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,O){const F=k(z.host,z.port);this.forwarded.has(F)&&(this.forwarded.delete(F),await this.cb(),this.h.fire(z))}X(z,O){if(z.startsWith("http"))return m.URI.parse(z);const F=O?.protocol??"http";return m.URI.parse(`${F}://${z}`)}async Y(z){const O=this.N.getWorkspace(),F=O.configuration?(0,M.$jj)(O.configuration.path):O.folders.length>0?(0,M.$jj)(O.folders[0].uri.path):void 0;if(F===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${z}.${this.L.remoteAuthority}.${F}`}async Z(){return this.Y(l)}async $(){return this.Y(r)}async ab(){const z=this.I.get(l,1);if(z)return this.I.remove(l,1),await this.cb(),z;const O=await this.Z();if(O)return this.I.get(O,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const O=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${O.map(F=>F.remotePort).join(", ")}`);for(const F of O){const B=p(this.detected,F.remoteHost,F.remotePort);F.source.source!==f.Extension&&!B||F.source.source===f.Extension&&B?await this.fb({remote:{host:F.remoteHost,port:F.remotePort},local:F.localPort,name:F.name,elevateIfNeeded:!0,source:F.source}):F.source.source===f.Extension&&!B&&this.D.set(k(F.remoteHost,F.remotePort),F)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Z();this.w=this.B(new b.$Uc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async O=>{O.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}bb(){const z=this.I.keys(0,0).filter(O=>O.startsWith(r));for(const O of z){const F=this.I.getNumber(O,0);if(F&&F<Date.now()){this.s=Promise.resolve(void 0);const B=O.replace(r,l);this.I.remove(O,0),this.I.remove(B,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=Array.from(this.forwarded.values()),O=z.map(q=>({remoteHost:q.remoteHost,remotePort:q.remotePort,localPort:q.localPort,name:q.name,localAddress:q.localAddress,localUri:q.localUri,protocol:q.protocol,source:q.source}));let F;z.length>0&&(F=JSON.stringify(O));const B=await this.Z(),Z=await this.$();!F&&B&&Z?(this.I.remove(B,0),this.I.remove(Z,0)):F!==this.y&&B&&Z&&(this.I.store(B,F,0,0),this.I.store(Z,Date.now()+c,0,0)),this.y=F}}async eb(z,O,F){if(!z.tunnelLocalPort||!F?.requireLocalPort||z.tunnelLocalPort===O)return;const B=new Date;if(this.db.getTime()+t>B.getTime())return;this.db=B;const Z=d.localize(3,null,O,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(Z)}async forward(z,O){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.fb(z,O)}async fb(z,O){await this.Q.activateByEvent(e.$mM);const F=p(this.forwarded,z.remote.host,z.remote.port);O=O??(O!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const B=z.local!==void 0?z.local:z.remote.port;let Z;if(F)return this.hb(F,z,O);{const q=this.L.remoteAuthority,Q=q?{getAddress:async()=>(await this.M.resolveAuthority(q)).authority}:void 0,x=k(z.remote.host,z.remote.port);this.c.set(x,!0),z=this.gb(x,z);const X=await this.H.openTunnel(Q,z.remote.host,z.remote.port,void 0,B,z.elevateIfNeeded?z.elevateIfNeeded:O?.elevateIfNeeded,z.privacy,O?.protocol);if(typeof X=="string")Z=X;else if(X&&X.localAddress){const ie=p(this.m??new Map,z.remote.host,z.remote.port),me=X.protocol?X.protocol===w.TunnelProtocol.Https?w.TunnelProtocol.Https:w.TunnelProtocol.Http:O?.protocol??w.TunnelProtocol.Http,ue={remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localPort:X.tunnelLocalPort,name:O?.label??z.name,closeable:!0,localAddress:X.localAddress,protocol:me,localUri:await this.X(X.localAddress,O),runningProcess:ie?.detail,hasRunningProcess:!!ie,pid:ie?.pid,source:z.source??e.$pM,privacy:X.privacy};return this.forwarded.set(x,ue),this.f.set(x,X),this.c.delete(x),await this.cb(),await this.eb(X,B,O),this.g.fire(ue),X}this.c.delete(x)}return Z}gb(z,O){const F=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(F){const B=F.get(z);F.delete(z),B&&(O.name=B.name??O.name,O.local=("local"in B?B.local:"localPort"in B?B.localPort:void 0)??O.local,O.privacy=O.privacy)}return O}async hb(z,O,F){const B=F?.label??O.name;let Z;(function(Q){Q[Q.None=0]="None",Q[Q.Fire=1]="Fire",Q[Q.Reopen=2]="Reopen"})(Z||(Z={}));let q=Z.None;switch(B!==z.name&&(z.name=B,q=Z.Fire),(F?.protocol||z.protocol!==w.TunnelProtocol.Http)&&F?.protocol!==z.protocol&&(O.source=z.source,q=Z.Reopen),O.privacy&&z.privacy!==O.privacy&&(q=Z.Reopen),q){case Z.Fire:{this.g.fire();break}case Z.Reopen:await this.close(z.remoteHost,z.remotePort,v.User),await this.fb(O,F)}return p(this.f,O.remote.host,O.remote.port)}async name(z,O,F){const B=p(this.forwarded,z,O),Z=k(z,O);if(B){B.name=F,await this.cb(),this.j.fire({host:z,port:O});return}else this.detected.has(Z)&&(this.detected.get(Z).name=F,this.j.fire({host:z,port:O}))}async close(z,O,F){const B=k(z,O),Z=this.forwarded.get(B);return F===v.AutoForwardEnd&&Z&&Z.source.source===f.Auto&&this.F.set(B,{local:Z.localPort,name:Z.name,privacy:Z.privacy}),await this.H.closeTunnel(z,O),this.W({host:z,port:O},F)}address(z,O){const F=k(z,O);return(this.forwarded.get(F)||this.detected.get(F))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const O of z){const F=p(this.m??new Map,O.remoteAddress.host,O.remoteAddress.port),B=typeof O.localAddress=="string"?O.localAddress:k(O.localAddress.host,O.localAddress.port);this.detected.set(k(O.remoteAddress.host,O.remoteAddress.port),{remoteHost:O.remoteAddress.host,remotePort:O.remoteAddress.port,localAddress:B,protocol:w.TunnelProtocol.Http,localUri:this.X(B),closeable:!1,runningProcess:F?.detail,hasRunningProcess:!!F,pid:F?.pid,privacy:w.TunnelPrivacyId.ConstantPrivate,source:{source:f.Extension,description:d.localize(4,null)}}),this.H.setEnvironmentTunnel(O.remoteAddress.host,O.remoteAddress.port,B,w.TunnelPrivacyId.ConstantPrivate,w.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let O=z;this.r&&(O=await this.r(z));const F=this.ib(O);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(F.values()).map(B=>B.port).join(", ")}`),this.n.fire(F)}ib(z){const O=this.m??new Map,F=new Map;return this.m=F,z.forEach(B=>{const Z=k(B.host,B.port);F.set(Z,{host:B.host,port:B.port,detail:B.detail,pid:B.pid}),O.has(Z)&&O.delete(Z);const q=p(this.forwarded,B.host,B.port);q&&(q.runningProcess=B.detail,q.hasRunningProcess=!0,q.pid=B.pid)}),O.forEach((B,Z)=>{const q=s(Z);if(!q)return;const Q=p(this.forwarded,q.host,q.port);Q&&(Q.runningProcess=void 0,Q.hasRunningProcess=!1,Q.pid=void 0);const x=p(this.detected,q.host,q.port);x&&(x.runningProcess=void 0,x.hasRunningProcess=!1,x.pid=void 0)}),O}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const z=Array.from(this.forwarded.values()),O=await this.getAttributes(z.map(F=>({port:F.remotePort,host:F.remoteHost})),!1);if(O)for(const F of z){const B=O.get(F.remotePort);(B?.protocol||F.protocol!==w.TunnelProtocol.Http)&&B?.protocol!==F.protocol&&await this.fb({remote:{host:F.remoteHost,port:F.remotePort},local:F.localPort,name:F.name,source:F.source},B),B&&B.label&&B.label!==F.name&&await this.name(F.remoteHost,F.remotePort,B.label)}}async getAttributes(z,O=!0){const F=new Map,B=new Map;z.forEach(X=>{const ie=p(this.m??new Map,w.$gw[0],X.port)??X;if(ie){F.set(X.port,ie);const me=C(ie)?ie.pid:void 0;B.has(me)||B.set(me,[]),B.get(me)?.push(X.port)}});const Z=new Map;if(z.forEach(X=>{const ie=this.configPortsAttributes.getAttributes(X.port,X.host,F.get(X.port)?.detail);ie&&Z.set(X.port,ie)}),this.G.length===0||!O)return Z.size>0?Z:void 0;const q=await Promise.all((0,N.$Rb)(this.G.map(X=>Array.from(B.entries()).map(ie=>{const me=ie[1],ue=F.get(me[0]);return X.providePortAttributes(me,ue?.pid,ue?.detail,n.CancellationToken.None)})))),Q=new Map;if(q.forEach(X=>X.forEach(ie=>{ie&&Q.set(ie.port,ie)})),!Z&&!Q)return;const x=new Map;return z.forEach(X=>{const ie=Z.get(X.port),me=Q.get(X.port);x.set(X.port,{elevateIfNeeded:ie?.elevateIfNeeded,label:ie?.label,onAutoForward:ie?.onAutoForward??I.providedActionToAction(me?.autoForwardAction),requireLocalPort:ie?.requireLocalPort,protocol:ie?.protocol})}),x}addAttributesProvider(z){this.G.push(z)}};e.$wM=T,Je([(0,L.$1h)(1e3)],T.prototype,"cb",null),e.$wM=T=Je([Ve(0,w.$bw),Ve(1,y.$Zp),Ve(2,E.$2i),Ve(3,g.$lM),Ve(4,$.$Gl),Ve(5,h.$Ei),Ve(6,D.$2j),Ve(7,A.$Gw),Ve(8,a.$CG),Ve(9,o.$Nj)],T)}),define(ke[94],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$9K=e.$8K=void 0;class d{constructor(M,b){this.line=M,this.character=b}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,b){return new d(0,0)}with(M){return new d(0,0)}}e.$8K=d;class N{constructor(M,b,m,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(M,b),this.end=new d(m,E)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new N(0,0,0,0)}with(M){return new N(0,0,0,0)}}e.$9K=N;var L;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(L||(e.TextSearchCompleteMessageType=L={}))}),define(ke[37],Pe([1,0,19,35,24,31,14,5,17,13,94,7]),function(le,e,d,N,L,R,M,b,m,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vL=e.$tL=e.$mL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$jL=e.$iL=e.$hL=e.$gL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.TextSearchCompleteMessageType=void 0,e.$dL=a,e.$eL=n,e.$fL=i,e.$kL=f,e.$lL=S,e.$nL=P,e.$oL=C,e.$pL=I,e.$qL=T,e.$rL=j,e.$sL=z,e.$uL=F,e.$wL=q,e.$xL=Q,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$0K="workbench.view.search",e.$$K="workbench.panel.search",e.$_K="workbench.view.search",e.$aL="search-result",e.$bL="search.exclude";const $="\u27EA ",y=" characters skipped \u27EB",w=($.length+y.length+5)*2;e.$cL=(0,b.$vi)("searchService");var h;(function(X){X[X.file=0]="file",X[X.text=1]="text",X[X.aiText=2]="aiText"})(h||(e.SearchProviderType=h={}));var g;(function(X){X[X.File=1]="File",X[X.Text=2]="Text",X[X.aiText=3]="aiText"})(g||(e.QueryType=g={}));function a(X){return!!X.preview}function n(X){return!!X.resource}function i(X){return!!X.message}var u;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(u||(e.SearchCompletionExitCode=u={}));class o{constructor(ie){this.resource=ie,this.results=[]}}e.$gL=o;class t{constructor(ie,me,ue,ve){this.ranges=me,this.webviewIndex=ve;const te=Array.isArray(me)?me:[me];if(ue&&ue.matchLines===1&&l(te)){ie=(0,M.$1f)(ie,ue.matchLines);let U="",ee=0,pe=0;const Ce=Math.floor(ue.charsPerLine/5),se=[];for(const re of te){const oe=Math.max(re.startColumn-Ce,0),K=re.startColumn+ue.charsPerLine;if(oe>pe+Ce+w){const ne=$+(oe-pe)+y;U+=ne+ie.slice(oe,K),ee+=oe-(pe+ne.length)}else U+=ie.slice(pe,K);se.push(new c(0,re.startColumn-ee,re.endColumn-ee)),pe=K}this.preview={text:U,matches:Array.isArray(this.ranges)?se:se[0]}}else{const U=Array.isArray(me)?me[0].startLineNumber:me.startLineNumber;this.preview={text:ie,matches:(0,d.$2b)(me,ee=>new r(ee.startLineNumber-U,ee.startColumn,ee.endLineNumber-U,ee.endColumn))}}}}e.$hL=t;function l(X){const ie=X[0].startLineNumber;for(const me of X)if(me.startLineNumber!==ie||me.endLineNumber!==ie)return!1;return!0}class r{constructor(ie,me,ue,ve){this.startLineNumber=ie,this.startColumn=me,this.endLineNumber=ue,this.endColumn=ve}}e.$iL=r;class c extends r{constructor(ie,me,ue){super(ie,me,ie,ue)}}e.$jL=c;var s;(function(X){X.List="list",X.Tree="tree"})(s||(e.ViewMode=s={}));var v;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(v||(e.SearchSortOrder=v={}));function f(X,ie=!0){const me=X&&X.files&&X.files.exclude,ue=ie&&X&&X.search&&X.search.exclude;if(!me&&!ue)return;if(!me||!ue)return me||ue;let ve=Object.create(null);return ve=L.$5n(ve,L.$2n(me)),ve=L.$5n(ve,L.$2n(ue),!0),ve}function S(X,ie){return X.excludePattern&&N.$ok(X.excludePattern,ie)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&N.$ok(X.includePattern,ie)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(me=>{const ue=me.folder.fsPath;if(R.$ug(ie,ue)){const ve=m.$mc(ue,ie);return!me.includePattern||!!N.$ok(me.includePattern,ve)}else return!1}):!1:!0}var p;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(p||(e.SearchErrorCode=p={}));class k extends Error{constructor(ie,me){super(ie),this.code=me}}e.$mL=k;function P(X){const ie=X.message;if((0,E.$4)(X))return new k(ie,p.canceled);try{const me=JSON.parse(ie);return new k(me.message,me.code)}catch{return new k(ie,p.other)}}function C(X){const ie={message:X.message,code:X.code};return new Error(JSON.stringify(ie))}function I(X){return X.type==="error"?!0:X.type==="success"}function T(X){return X.type==="success"}function j(X){return!!X.path}function z(X,ie,me=!0){const ue=X.searchPath?X.searchPath:X.relativePath;return me?(0,M.$Xf)(ue,ie):N.$ok(ie,ue)}class O{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$tL=O;function F(X,ie){const me={...X||{},...ie||{}};return Object.keys(me).filter(ue=>{const ve=me[ue];return typeof ve=="boolean"&&ve})}class B{constructor(ie,me){this.c=null,this.a={...ie.excludePattern||{},...me.excludePattern||{}},this.b=N.$pk(this.a);let ue=ie.includePattern;me.includePattern&&(ue?ue={...ue,...me.includePattern}:ue=me.includePattern),ue&&(this.c=N.$pk(ue))}matchesExcludesSync(ie,me,ue){return!!(this.b&&this.b(ie,me,ue))}includedInQuerySync(ie,me,ue){return!(this.b&&this.b(ie,me,ue)||this.c&&!this.c(ie,me,ue))}includedInQuery(ie,me,ue){const ve=this.b(ie,me,ue),te=()=>this.c?!!this.c(ie,me,ue):!0;return(0,D.$hh)(ve)?ve.then(U=>U?!1:te()):te()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$vL=B;function Z(X){for(const ie in X)if(typeof X[ie]!="boolean")return!0;return!1}function q(X){if(!X)return;let ie;return me=>(ie||(ie=(X()||Promise.resolve([])).then(ue=>ue?x(ue):{})),ie.then(ue=>!!ue[me]))}function Q(X){if(!X)return;let ie;return me=>{if(!ie){const ue=X();ie=ue?x(ue):{}}return!!ie[me]}}function x(X){const ie={};for(const me of X)ie[me]=!0;return ie}}),define(ke[44],Pe([1,0,19,7,22,4,3,78,15,126,23,14,2,235,5,11,268,42,60,28,20,16,8,68,37,6,58]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i,u,o,t,l,r,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mlc=e.$llc=void 0;function v(T,j,z){return new A.$Xg(O=>k(O,z)).isEqual(T,j)}function f(T,j,z){return v(T.uri,j.uri,z)?0:(0,D.$qf)(T.uri.toString(),j.uri.toString())}function S(T,j,z){return T.index!==j.index?T.index<j.index?-1:1:v(T.uri,j.uri,z)?(0,D.$qf)(T.name,j.name):(0,D.$qf)(T.uri.toString(),j.uri.toString())}function p(T,j,z,O){const F=T.slice(0).sort((Z,q)=>z(Z,q,O)),B=j.slice(0).sort((Z,q)=>z(Z,q,O));return(0,d.$Eb)(F,B,(Z,q)=>z(Z,q,O))}function k(T,j){const z=j.getCapabilities(T.scheme);return!(z&&z&1024)}class P extends a.$Oi{static toExtHostWorkspace(j,z,O,F){if(!j)return{workspace:null,added:[],removed:[]};const{id:B,name:Z,folders:q,configuration:Q,transient:x,isUntitled:X}=j,ie=[],me=z;z?q.forEach((U,ee)=>{const pe=$.URI.revive(U.uri),Ce=P.o(O||z,pe,F);Ce?(Ce.name=U.name,Ce.index=U.index,ie.push(Ce)):ie.push({uri:pe,name:U.name,index:ee})}):ie.push(...q.map(({uri:U,name:ee,index:pe})=>({uri:$.URI.revive(U),name:ee,index:pe}))),ie.sort((U,ee)=>U.index<ee.index?-1:1);const ue=new P(B,Z,ie,!!x,Q?$.URI.revive(Q):null,!!X,U=>k(U,F)),{added:ve,removed:te}=p(me?me.workspaceFolders:[],ue.workspaceFolders,f,F);return{workspace:ue,added:ve,removed:te}}static o(j,z,O){for(let F=0;F<j.folders.length;F++){const B=j.workspaceFolders[F];if(v(B.uri,z,O))return B}}constructor(j,z,O,F,B,Z,q){super(j,O.map(Q=>new a.$Pi(Q)),F,B,q),this.t=z,this.u=Z,this.q=[],this.s=b.$Bi.forUris(q),O.forEach(Q=>{this.q.push(Q),this.s.set(Q.uri,Q)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,z){return z&&this.s.get(j)&&(j=(0,A.$8g)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let C=class{constructor(j,z,O,F,B){this.c=new R.$ee,this.onDidChangeWorkspace=this.c.event,this.g=new R.$ee,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$ge,this.C=new Map,this.h=F,this.s=O,this.t=B,this.j=new E.$Cm,this.k=new N.$uh,this.o=j.getProxy(c.$1M.MainThreadWorkspace),this.q=j.getProxy(c.$1M.MainThreadMessageService);const Z=z.workspace;this.l=Z?new P(Z.id,Z.name,[],!!Z.transient,Z.configuration?$.URI.revive(Z.configuration):null,!!Z.isUntitled,q=>k(q,O)):void 0}$initializeWorkspace(j,z){this.v=z,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?$.URI.from({scheme:m.Schemas.untitled,path:(0,A.$6g)((0,A.$8g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,z,O,...F){const B=[];if(Array.isArray(F)&&F.forEach(X=>{$.URI.isUri(X.uri)&&!B.some(ie=>v(ie.uri,X.uri,this.s))&&B.push({uri:X.uri,name:X.name||(0,A.$5g)(X.uri)})}),this.n||[z,O].some(X=>typeof X!="number"||X<0)||O===0&&B.length===0)return!1;const Z=this.x?this.x.workspaceFolders:[];if(z+O>Z.length)return!1;const q=Z.slice(0);q.splice(z,O,...B.map(X=>({uri:X.uri,name:X.name||(0,A.$5g)(X.uri),index:void 0})));for(let X=0;X<q.length;X++){const ie=q[X];if(q.some((me,ue)=>ue!==X&&v(ie.uri,me.uri,this.s)))return!1}q.forEach((X,ie)=>X.index=ie);const{added:Q,removed:x}=p(Z,q,S,this.s);if(Q.length===0&&x.length===0)return!1;if(this.o){const X=j.displayName||j.name;this.o.$updateWorkspaceFolders(X,z,O,B).then(void 0,ie=>{this.n=void 0;const me={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(g.Severity.Error,(0,y.localize)(0,null,X,ie.toString()),me,[])})}return this.y(q),!0}getWorkspaceFolder(j,z){if(this.x)return this.x.getWorkspaceFolder(j,z)}async getWorkspaceFolder2(j,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,z)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,z){let O,F="";if(typeof j=="string"?(O=$.URI.file(j),F=j):typeof j<"u"&&(O=j,F=j.fsPath),!O)return F;const B=this.getWorkspaceFolder(O,!0);if(!B)return F;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let Z=(0,A.$$g)(B.uri,O);return z&&B.name&&(Z=`${B.name}/${Z}`),Z}y(j){this.x&&(this.n=P.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:z,added:O,removed:F}=P.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:F}))}findFiles(j,z,O,F,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let Z="",q=!0;return z===null?q=!1:z!==void 0&&(typeof z=="string"?Z=z:Z=z.pattern),this.z(j,void 0,{exclude:Z,maxResults:O,useDefaultExcludes:q,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(j,z={},O,F=L.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${O.value}, entryPoint: findFiles2`),this.z(void 0,j,z,F)}async z(j,z,O,F=L.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const B=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,Z={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof O.useDefaultSearchExcludes=="boolean"?!O.useDefaultSearchExcludes:!1,maxResults:O.maxResults,excludePattern:B,shouldGlobSearch:typeof O.fuzzy=="boolean"?!O.fuzzy:!0,_reason:"startFileSearch"};let q;if(j){const{includePattern:Q,folder:x}=I(o.GlobPattern.from(j));q=x,Z.includePattern=Q}else{const{includePattern:Q,folder:x}=I(o.GlobPattern.from(z));q=x,Z.filePattern=Q}return this.o.$startFileSearch(q??null,Z,F).then(Q=>Array.isArray(Q)?Q.map(x=>$.URI.revive(x)):[])}async findTextInFiles(j,z,O,F,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const Z=this.j.getNext(),q=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:Q,folder:x}=I(o.GlobPattern.from(z.include)),X=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ie={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:q,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:Q,excludePattern:X},me=!1;if(this.u[Z]=ue=>{if(me)return;const ve=$.URI.revive(ue.resource);ue.results.forEach(te=>{const U=(0,s.$5h)(te);(0,r.$dL)(U)?O({uri:ve,preview:{text:U.preview.text,matches:(0,d.$2b)(U.preview.matches,ee=>new t.$5M(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))},ranges:(0,d.$2b)(U.ranges,ee=>new t.$5M(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))}):O({uri:ve,text:U.text,lineNumber:U.lineNumber})})},B.isCancellationRequested)return{};try{const ue=await this.o.$startTextSearch(j,x??null,ie,Z,B);return delete this.u[Z],ue||{}}catch(ue){throw delete this.u[Z],ue}}$handleTextSearchResult(j,z){this.u[z]?.(j)}async save(j){const z=await this.o.$save(j,{saveAs:!1});return $.URI.revive(z)}async saveAs(j){const z=await this.o.$save(j,{saveAs:!0});return $.URI.revive(z)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,z){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,z);const O=this.t.transformOutgoingScheme(j),F=this.A++;return this.o.$registerEditSessionIdentityProvider(F,O),(0,M.$Tc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(j,z){this.h.info("Getting edit session identifier for workspaceFolder",j);const O=await this.resolveWorkspaceFolder($.URI.revive(j));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const F=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!F),!F)return;const B=await F.provideEditSessionIdentity(O,z);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(j,z,O,F){this.h.info("Getting edit session identifier for workspaceFolder",j);const B=await this.resolveWorkspaceFolder($.URI.revive(j));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const Z=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!Z),!Z)return;const q=await Z.provideEditSessionIdentityMatch?.(z,O,F);if(this.h.info("Provider returned edit session identifier match result: ",q),!!q)return q}getOnWillCreateEditSessionIdentityEvent(j){return(z,O,F)=>{const B=function(q){z.call(O,q)};return B.extension=j,this.B.event(B,void 0,F)}}async $onWillCreateEditSessionIdentity(j,z,O){const F=await this.resolveWorkspaceFolder($.URI.revive(j));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:F},z,async(B,Z)=>{const q=Date.now();await Promise.resolve(B),Date.now()-q>O&&this.h.warn("SLOW edit session create-participant",Z.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(j,z){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,z);const O=this.t.transformOutgoingScheme(j),F=this.A++;return this.o.$registerCanonicalUriProvider(F,O),(0,M.$Tc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(j,z,O){const F=this.C.get(j.scheme);if(!F)return;const B=await F.provideCanonicalUri?.($.URI.revive(j),z,O);if(B)return B}async $provideCanonicalUri(j,z,O){return this.provideCanonicalUri($.URI.revive(j),{targetScheme:z},O)}};e.$llc=C,e.$llc=C=Je([Ve(0,u.$oP),Ve(1,i.$EP),Ve(2,n.$7kc),Ve(3,h.$2j),Ve(4,l.$jlc)],C),e.$mlc=(0,w.$vi)("IExtHostWorkspace");function I(T){let j,z;return T&&(typeof T=="string"?j=T:(j=T.pattern,z=$.URI.revive(T.baseUri))),{includePattern:j,folder:z}}}),define(ke[45],Pe([1,0,24,4,44,6,8,270,66,18,7,5,20,11,2]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=e.$olc=e.$nlc=void 0;function h(l,r){if(r){const c=r.split(".");let s=l;for(let v=0;s&&v<c.length;v++)s=s[c[v]];return s}}function g(l){return l instanceof w.URI}function a(l){return l&&l.uri instanceof w.URI&&l.languageId&&typeof l.languageId=="string"}function n(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function i(l){return l&&l.uri instanceof w.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function u(l){if(g(l))return{resource:l};if(a(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(n(l))return{overrideIdentifier:l.languageId};if(i(l))return{resource:l.uri};if(l===null)return{resource:null}}let o=class{constructor(r,c,s){this.a=r.getProxy(R.$1M.MainThreadConfiguration),this.c=c,this.b=s,this.d=new A.$uh,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,c){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(r,c))}};e.$nlc=o,e.$nlc=o=Je([Ve(0,$.$oP),Ve(1,L.$mlc),Ve(2,y.$2j)],o);class t{constructor(r,c,s,v){this.a=new N.$ee,this.b=r,this.f=v,this.c=c,this.e=b.$zo.parse(s,v),this.d=this.k(s.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,c){const s={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$zo.parse(r,this.f),this.d=this.k(r.configurationScopes),this.a.fire(this.j(c,s))}getConfiguration(r,c,s){const v=u(c)||{},f=this.g(r?h(this.e.getValue(void 0,v,this.c.workspace),r):this.e.getValue(void 0,v,this.c.workspace));r&&this.h(r,v,s?.identifier);function S(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(k){return typeof h(f,k)<"u"},get:(k,P)=>{this.h(r?`${r}.${k}`:k,v,s?.identifier);let C=h(f,k);if(typeof C>"u")C=P;else{let I;const T=(j,z)=>{if((0,E.$0f)(j)){let O;const F=()=>{I=I||(0,d.$2n)(f),O=O||h(I,z)};return new Proxy(j,{get:(B,Z)=>{if(typeof Z=="string"&&Z.toLowerCase()==="tojson")return F(),()=>O;if(I)return O=O||h(I,z),O[Z];const q=B[Z];return typeof Z=="string"?T(q,`${z}.${Z}`):q},set:(B,Z,q)=>(F(),O&&(O[Z]=q),!0),deleteProperty:(B,Z)=>(F(),O&&delete O[Z],!0),defineProperty:(B,Z,q)=>(F(),O&&Object.defineProperty(O,Z,q),!0)})}return Array.isArray(j)?(0,d.$2n)(j):j};C=T(C,k)}return C},update:(k,P,C,I)=>{k=r?`${r}.${k}`:k;const T=S(C);return P!==void 0?this.b.$updateConfigurationOption(T,k,P,v,I):this.b.$removeConfigurationOption(T,k,v,I)},inspect:k=>{k=r?`${r}.${k}`:k;const P=this.e.inspect(k,v,this.c.workspace);if(P)return{key:k,defaultValue:(0,d.$2n)(P.policy?.value??P.default?.value),globalValue:(0,d.$2n)(P.user?.value??P.application?.value),workspaceValue:(0,d.$2n)(P.workspace?.value),workspaceFolderValue:(0,d.$2n)(P.workspaceFolder?.value),defaultLanguageValue:(0,d.$2n)(P.default?.override),globalLanguageValue:(0,d.$2n)(P.user?.override??P.application?.override),workspaceLanguageValue:(0,d.$2n)(P.workspace?.override),workspaceFolderLanguageValue:(0,d.$2n)(P.workspaceFolder?.override),languageIds:(0,d.$2n)(P.overrideIdentifiers)}}};return typeof f=="object"&&(0,d.$5n)(p,f,!1),Object.freeze(p)}g(r){const c=s=>(0,E.$0f)(s)?new Proxy(s,{get:(v,f)=>c(v[f]),set:(v,f,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(v,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(v,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return c(r)}h(r,c,s){const v=m.$qo.test(r)?4:this.d.get(r),f=s?`[${s.value}] `:"";if(v===4){typeof c?.resource>"u"&&this.f.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){c?.resource&&this.f.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,c){const s=new b.$Bo(r,c,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(v,f)=>s.affectsConfiguration(v,u(f))})}k(r){return r.reduce((c,s)=>(c.set(s[0],s[1]),c),new Map)}}e.$olc=t,e.$plc=(0,D.$vi)("IExtHostConfiguration")}),define(ke[95],Pe([1,0,2,7,4,6,8,44,73,45,22,43,20,28,5,15,12,11,91,314,13]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=e.$Smc=e.$Rmc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var o;(function(T){function j(O){if(O!=null)return O}T.from=j;function z(O){if(O!=null)return O}T.to=z})(o||(o={}));var t;(function(T){function j(O){if(O!=null)return O}T.from=j;function z(O){if(O!=null)return O}T.to=z})(t||(t={}));var l;(function(T){function j(O){if(O!=null)return O}T.from=j;function z(O){if(O!=null)return O}T.to=z})(l||(l={}));var r;(function(T){function j(F){if(F){const B=F;return B&&!!B.process}else return!1}T.is=j;function z(F){if(F==null)return;const B={process:F.process,args:F.args};return F.options&&(B.options=l.from(F.options)),B}T.from=z;function O(F){if(F!=null)return new M.$MN(F.process,F.args,F.options)}T.to=O})(r||(r={}));var c;(function(T){function j(O){if(O!=null)return O}T.from=j;function z(O){if(O!=null)return O}T.to=z})(c||(c={}));var s;(function(T){function j(F){if(F){const B=F;return B&&(!!B.commandLine||!!B.command)}else return!1}T.is=j;function z(F){if(F==null)return;const B={};return F.commandLine!==void 0?B.commandLine=F.commandLine:(B.command=F.command,B.args=F.args),F.options&&(B.options=c.from(F.options)),B}T.from=z;function O(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new M.$NN(F.commandLine,F.options):new M.$NN(F.command,F.args?F.args:[],F.options)}T.to=O})(s||(s={}));var v;(function(T){function j(F){if(F){const B=F;return B&&B.customExecution==="customExecution"}else return!1}T.is=j;function z(F){return{customExecution:"customExecution"}}T.from=z;function O(F,B){return B.get(F)}T.to=O})(v||(e.CustomExecutionDTO=v={}));var f;(function(T){function j(z,O){let F;return z.scope!==void 0&&typeof z.scope!="number"?F=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===M.TaskScope.Workspace&&O&&O.workspaceFile?F=O.workspaceFile:F=i.$7H),{id:z._id,workspaceFolder:F}}T.from=j})(f||(e.TaskHandleDTO=f={}));var S;(function(T){function j(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}T.from=j})(S||(S={}));var p;(function(T){function j(F,B){if(F==null)return[];const Z=[];for(const q of F){const Q=z(q,B);Q&&Z.push(Q)}return Z}T.fromMany=j;function z(F,B){if(F==null)return;let Z;F.execution instanceof M.$MN?Z=r.from(F.execution):F.execution instanceof M.$NN?Z=s.from(F.execution):F.execution&&F.execution instanceof M.$ON&&(Z=v.from(F.execution));const q=o.from(F.definition);let Q;return F.scope?typeof F.scope=="number"?Q=F.scope:Q=F.scope.uri:Q=M.TaskScope.Workspace,!q||!Q?void 0:{_id:F._id,definition:q,name:F.name,source:{extensionId:B.identifier.value,label:F.source,scope:Q},execution:Z,isBackground:F.isBackground,group:S.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}T.from=z;async function O(F,B,Z){if(F==null)return;let q;r.is(F.execution)?q=r.to(F.execution):s.is(F.execution)?q=s.to(F.execution):v.is(F.execution)&&(q=v.to(F._id,Z));const Q=o.to(F.definition);let x;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?x=F.source.scope:x=await B.resolveWorkspaceFolder(d.URI.revive(F.source.scope)):x=M.TaskScope.Workspace),!Q||!x)return;const X=new M.$PN(Q,x,F.name,F.source.label,q,F.problemMatchers);return F.isBackground!==void 0&&(X.isBackground=F.isBackground),F.group!==void 0&&(X.group=M.$LN.from(F.group._id),X.group&&F.group.isDefault&&(X.group=new M.$LN(X.group.id,X.group.label),F.group.isDefault===!0&&(X.group.isDefault=F.group.isDefault))),F.presentationOptions&&(X.presentationOptions=t.to(F.presentationOptions)),F._id&&(X._id=F._id),F.detail&&(X.detail=F.detail),X}T.to=O})(p||(e.TaskDTO=p={}));var k;(function(T){function j(O){return O}T.from=j;function z(O){if(O)return Object.assign(Object.create(null),O)}T.to=z})(k||(k={}));class P{#e;constructor(j,z,O){this._id=z,this.a=O,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let C=class{constructor(j,z,O,F,B,Z,q,Q){this.q=new L.$ee,this.r=new L.$ee,this.s=new L.$ee,this.u=new L.$ee,this.a=j.getProxy(R.$1M.MainThreadTask),this.b=O,this.c=F,this.d=B,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=q,this.g=Q,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,z,O){if(!O)return new M.$3M(()=>{});const F=this.x();return this.j.set(F,{type:z,provider:O,extension:j}),this.a.$registerTaskProvider(F,z),new M.$3M(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(j,z){this.a.$registerTaskSystem(j,z)}fetchTasks(j){return this.a.$fetchTasks(k.from(j)).then(async z=>{const O=[];for(const F of z){const B=await p.to(F,this.b,this.m);B&&O.push(B)}return O})}get taskExecutions(){const j=[];return this.k.forEach(z=>j.push(z)),j}terminateTask(j){if(!(j instanceof P))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,z,O){const F=this.m.get(j.id);F&&(this.o.set(j.id,F),this.e.attachPtyToTerminal(z,await F.callback(O))),this.p=j.id,this.q.fire({execution:await this.z(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){if(!this.l.has(j.id))return;const z=await this.z(j);this.l.delete(j.id),this.k.delete(j.id),this.B(j),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const z=await this.z(j.id);this.s.fire({execution:z,processId:j.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(j){const z=await this.z(j.id);this.u.fire({execution:z,exitCode:j.exitCode})}$provideTasks(j,z){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));const F=[],B=(0,N.$nh)(()=>O.provider.provideTasks(A.CancellationToken.None)).then(Z=>this.v(z,F,O,Z));return new Promise(Z=>{B.then(q=>{Promise.all(F).then(()=>{Z(q)})})})}async $resolveTask(j,z){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));if(z.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${O.type}].`);const F=await p.to(z,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const B=await O.provider.resolveTask(F,A.CancellationToken.None);if(!B)return;this.A(B,O);const Z=p.from(B,O.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(Z.execution)&&await this.y(Z,B,!0),await this.w(Z)}x(){return this.h++}async y(j,z,O){const F=await this.a.$createTaskId(j);!O&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,z.execution)),this.m.set(F,z.execution)}async z(j,z){if(typeof j=="string"){const B=this.l.get(j);if(!B)throw new u.$bb("Unexpected: The specified task is missing an execution");return B}const O=this.l.get(j.id);if(O)return O;let F;return z?F=Promise.resolve(new P(this,j.id,z)):F=p.to(j.task,this.b,this.m).then(B=>{if(!B)throw new u.$bb("Unexpected: Task does not exist.");return new P(this,j.id,B)}),this.l.set(j.id,F),F.then(B=>(this.k.set(j.id,B),B))}A(j,z){j._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const O=this.n.values();let F=O.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=O.next()}};e.$Rmc=C,e.$Rmc=C=Je([Ve(0,$.$oP),Ve(1,y.$EP),Ve(2,b.$mlc),Ve(3,m.$zP),Ve(4,E.$plc),Ve(5,D.$Nlc),Ve(6,a.$2j),Ve(7,n.$3kc)],C);let I=class extends C{constructor(j,z,O,F,B,Z,q,Q){super(j,z,O,F,B,Z,q,Q),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:g.$h(0)})}async executeTask(j,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const O=p.from(z,j);if(O===void 0)throw new Error("Task is not valid");if(v.is(O.execution))await this.y(O,z,!1);else throw new u.$_;const F=await this.z(await this.a.$getTaskExecution(O),z);return this.a.$executeTask(O).catch(B=>{throw new Error(B)}),F}v(j,z,O,F){const B=[];if(F)for(const Z of F){if(this.A(Z,O),!Z.definition||!j[Z.definition.type]){const Q=Z.source?Z.source:"No task source";this.f.warn(`The task [${Q}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`)}const q=p.from(Z,O.extension);q&&v.is(q.execution)?(B.push(q),z.push(this.y(q,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:O.extension}}async w(j){if(v.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,z,O){}};e.$Smc=I,e.$Smc=I=Je([Ve(0,$.$oP),Ve(1,y.$EP),Ve(2,b.$mlc),Ve(3,m.$zP),Ve(4,E.$plc),Ve(5,D.$Nlc),Ve(6,a.$2j),Ve(7,n.$3kc)],I),e.$Tmc=(0,w.$vi)("IExtHostTask")}),define(ke[374],Pe([1,0,37,29]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=void 0,e.$DL=L,e.$FL=R;function L(M){return"cellResults"in M}e.$EL="rawCell#";function R(M,b){let m=-1;const E=[];let A=[];return M.forEach($=>{$.range.startLineNumber!==m&&A.length>0&&(E.push([...A]),A=[]),A.push($),m=$.range.endLineNumber}),A.length>0&&E.push([...A]),E.map($=>{const y=[],w=$[0].range.startLineNumber,h=$[$.length-1].range.endLineNumber;for(let g=w;g<=h;g++)y.push(b.getLineContent(g));return new d.$hL(y.join(`
`)+`
`,$.map(g=>new N.$tt(g.range.startLineNumber-1,g.range.startColumn-1,g.range.endLineNumber-1,g.range.endColumn-1)))})}}),define(ke[375],Pe([1,0,229,21,4,3,27,14,18,2,33,112,6,34,16,8,48,345,154,24,15,304,374,371]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i,u,o,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(s=>s.apiEditor)}constructor(s,v,f,S,p,k){this.q=f,this.r=S,this.s=p,this.t=k,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new L.$ee,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new L.$ee,this.onDidOpenNotebookDocument=this.m.event,this.n=new L.$ee,this.onDidCloseNotebookDocument=this.n.event,this.o=new L.$ee,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$1kc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=s.getProxy($.$1M.MainThreadNotebook),this.c=s.getProxy($.$1M.MainThreadNotebookDocuments),this.d=s.getProxy($.$1M.MainThreadNotebookEditors),this.i=v.converter,v.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===13){const C=P.notebookEditor?.notebookUri,I=P.cell.handle,j=this.g.get(C)?.getCell(I);if(j)return j.apiCell}if(P&&P.$mid===14){const C=P.uri,I=this.g.get(C);if(I)return I.apiNotebook}return P}}),r.B(v)}getEditorById(s){const v=this.h.get(s);if(!v)throw new Error(`unknown text editor: ${s}. known editors: ${[...this.h.keys()]} `);return v}getIdByEditor(s){for(const[v,f]of this.h)if(f.apiEditor===s)return v}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(s,v){const f=this.g.get(s);if(!f&&!v)throw new Error(`NO notebook document for '${s}'`);return f}static u(s,v){if(!v)return;const f=v.filenamePattern.map(S=>w.NotebookExclusiveDocumentPattern.from(S)).filter(S=>S!==void 0);if(v.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:v.displayName,filenamePattern:f,exclusive:v.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,v,f){const S=r.a++,p=typeof f.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(S,f),this.b.$registerNotebookCellStatusBarItemProvider(S,p,v);let k;return p!==void 0&&(k=f.onDidChangeCellStatusBarItems(P=>this.b.$emitCellStatusBarEvent(p))),new h.$3M(()=>{this.f.delete(S),this.b.$unregisterNotebookCellStatusBarItemProvider(S,p),k?.dispose()})}async createNotebookDocument(s){const v=await this.c.$tryCreateNotebook({viewType:s.viewType,content:s.content&&w.NotebookData.from(s.content)});return E.URI.revive(v)}async openNotebookDocument(s){const v=this.g.get(s);if(v)return v.apiNotebook;const f=await this.c.$tryOpenNotebook(s),S=this.g.get(E.URI.revive(f));return(0,m.$gg)(S?.apiNotebook)}async showNotebookDocument(s,v){E.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let f;typeof v=="object"?f={position:w.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(w.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:f={preserveFocus:!1};const S=await this.d.$tryShowNotebookDocument(s.uri,s.notebookType,f),p=S&&this.h.get(S)?.apiEditor;if(p)return p;throw S?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,v,f,S){const p=this.f.get(s),k=E.URI.revive(v),P=this.g.get(k);if(!P||!p)return;const C=P.getCellFromIndex(f);if(!C)return;const I=await p.provideCellStatusBarItems(C.apiCell,S);if(!I)return;const T=new R.$Uc,j=this.p.add([T]),O=(Array.isArray(I)?I:[I]).map(F=>w.NotebookStatusBarItem.from(F,this.i,T));return{cacheId:j,items:O}}$releaseNotebookCellStatusBarItems(s){this.p.delete(s)}registerNotebookSerializer(s,v,f,S,p){if((0,b.$7e)(v))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:v,serializer:f,options:S}),this.b.$registerNotebookSerializer(k,{id:s.identifier,location:s.extensionLocation},v,w.NotebookDocumentContentOptions.from(S),r.u(s,p)),(0,R.$Tc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(s,v,f){const S=this.x.get(s);if(!S)throw new Error("NO serializer found");const p=await S.serializer.deserializeNotebook(v.buffer,f);return new g.$uw(w.NotebookData.from(p))}async $notebookToData(s,v,f){const S=this.x.get(s);if(!S)throw new Error("NO serializer found");const p=await S.serializer.serializeNotebook(w.NotebookData.to(v.value),f);return N.$Fe.wrap(p)}async $saveNotebook(s,v,f,S,p){const k=E.URI.revive(v),P=this.x.get(s);if(!P)throw new Error("NO serializer found");const C=this.g.get(k);if(!C)throw new Error("Document NOT found");if(C.versionId!==f)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new A.$kl((0,d.localize)(0,null,this.z(k)),6);await this.y(k,S);const I={metadata:(0,i.$0n)(C.apiNotebook.metadata,F=>!(P.options?.transientDocumentMetadata??{})[F]),cells:[]};for(const F of C.apiNotebook.getCells()){const B=new h.$tO(F.kind,F.document.getText(),F.document.languageId,F.mime,P.options?.transientOutputs?[]:[...F.outputs],F.metadata,F.executionSummary);B.metadata=(0,i.$0n)(F.metadata,Z=>!(P.options?.transientCellMetadata??{})[Z]),I.cells.push(B)}const T=await P.serializer.serializeNotebook(I,p);await this.s.value.writeFile(k,T);const j=this.s.getFileSystemProviderExtUri(k.scheme),z=await this.s.value.stat(k);return{name:j.basename(k),isFile:(z.type&A.FileType.File)!==0,isDirectory:(z.type&A.FileType.Directory)!==0,isSymbolicLink:(z.type&A.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((z.permissions??0)&A.FilePermission.Locked),etag:A.$vl({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(s,v,f,S,p){const k=this.x.get(s)?.serializer;if(!k)return{limitHit:!1,results:[]};const P=new M.$Cc;await(async(z,O,F)=>{await Promise.all(z.map(async B=>await Promise.all(B.filenamePatterns.map(Z=>{const q={_reason:F._reason,folderQueries:F.folderQueries,includePattern:F.includePattern,excludePattern:F.excludePattern,maxResults:F.maxResults,type:1,filePattern:Z};return this.t.doInternalFileSearchWithCustomCallback(q,O,Q=>{Q.forEach(x=>{P.has(x)||S.some(ie=>B.isFromSettings&&!ie.isFromSettings?!1:ie.filenamePatterns.some(me=>(0,l.$bhb)(me,x)))||P.add(x)})}).catch(Q=>{if(Q.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Q})}))))})(f,p,v);const I=new M.$Bc;let T=!1;const j=Array.from(P).map(async z=>{const O=[];try{if(p.isCancellationRequested)return;if(v.maxResults&&[...I.values()].reduce((q,Q)=>q+Q.cellResults.length,0)>v.maxResults){T=!0;return}const F=[],B=this.g.get(z);if(B)B.apiNotebook.getCells().forEach(Q=>F.push({input:Q.document.getText(),outputs:Q.outputs.flatMap(x=>x.items.map(X=>X.data.toString()))}));else{const q=await this.s.value.readFile(z),Q=N.$Fe.fromString(q.toString()),x=await k.deserializeNotebook(Q.buffer,p);if(p.isCancellationRequested)return;w.NotebookData.from(x).cells.forEach(ie=>F.push({input:ie.source,outputs:ie.outputs.flatMap(me=>me.items.map(ue=>ue.valueBytes.toString()))}))}if(p.isCancellationRequested)return;F.forEach((q,Q)=>{const x=v.contentPattern.pattern,X=new o.$0Wb(q.input,void 0,q.outputs),ie=X.findInInputs(x),me=X.findInOutputs(x),ue=me.flatMap(ve=>(0,t.$FL)(ve.matches,ve.textBuffer)).map((ve,te)=>(ve.webviewIndex=te,ve));if(ie.length>0||me.length>0){const ve={index:Q,contentResults:(0,t.$FL)(ie,X.inputTextBuffer),webviewResults:ue};O.push(ve)}});const Z={resource:z,cellResults:O};I.set(z,Z);return}catch{return}});return await Promise.all(j),{limitHit:T,results:[...I.values()]}}async y(s,v){const f=await this.s.value.stat(s);if(typeof v?.mtime=="number"&&typeof v.etag=="string"&&v.etag!==A.$ul&&typeof f.mtime=="number"&&typeof f.size=="number"&&v.mtime<f.mtime&&v.etag!==A.$vl({mtime:v.mtime,size:f.size}))throw new A.$kl((0,d.localize)(1,null),3,v)}z(s){return s.scheme===u.Schemas.file?s.fsPath:s.toString()}A(s,v,f){if(this.h.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const S=new n.$lmc(v,this.d,s,f.visibleRanges.map(w.NotebookRange.to),f.selections.map(w.NotebookRange.to),typeof f.viewColumn=="number"?w.ViewColumn.to(f.viewColumn):void 0);this.h.set(v,S)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const f of s.value.removedDocuments){const S=E.URI.revive(f),p=this.g.get(S);p&&(p.dispose(),this.g.delete(S),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(p.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===S.toString()&&this.h.delete(k.id)}if(s.value.addedDocuments){const f=[];for(const S of s.value.addedDocuments){const p=E.URI.revive(S.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const k=new a.$kmc(this.c,this.q,this.r,p,S);f.push(...S.cells.map(P=>a.$jmc.asModelAddData(P))),this.g.get(p)?.dispose(),this.g.set(p,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:f}),this.m.fire(k.apiNotebook)}}if(s.value.addedEditors)for(const f of s.value.addedEditors){if(this.h.has(f.id))return;const S=E.URI.revive(f.documentUri),p=this.g.get(S);p&&this.A(p,f.id,f)}const v=[];if(s.value.removedEditors)for(const f of s.value.removedEditors){const S=this.h.get(f);S&&(this.h.delete(f),this.k?.id===S.id&&(this.k=void 0),v.push(S))}if(s.value.visibleEditors){this.l=s.value.visibleEditors.map(S=>this.h.get(S)).filter(S=>!!S);const f=new Set;this.l.forEach(S=>f.add(S.id));for(const S of this.h.values()){const p=f.has(S.id);S._acceptVisibility(p)}this.l=[...this.h.values()].map(S=>S).filter(S=>S.visible),this.o.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this.k=void 0:s.value.newActiveEditor&&(this.h.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this.k=this.h.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(s){const v=y.$MP.String.with("notebookType","A notebook type"),f=new y.$OP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new y.$MP("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>N.$Fe.wrap(p))],new y.$NP("Notebook Data",p=>w.NotebookData.to(p.value))),S=new y.$OP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new y.$MP("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new g.$uw(w.NotebookData.from(p)))],new y.$NP("Bytes",p=>p.buffer));s.registerApiCommand(f),s.registerApiCommand(S)}}e.$umc=r}),define(ke[376],Pe([1,0,17,22,47,35,23,40,37]),function(le,e,d,N,L,R,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=void 0;class E{constructor($,y,w){this.k=$,this.l=y,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=$.filePattern,this.b=$.includePattern&&R.$pk($.includePattern),this.c=$.maxResults||void 0,this.d=$.exists,this.h=new Set,this.j=$.excludePattern&&R.$pk($.excludePattern)}cancel(){this.g=!0,this.h.forEach($=>$.cancel()),this.h=new Set}search($){const y=this.k.folderQueries||[];return new Promise((w,h)=>{const g=a=>{this.f++,$(a)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const n=a.toString(),i=d.$oc(n);this.j&&this.j(n,i)||this.v(g,{base:a,basename:i})}),Promise.all(y.map(a=>this.p(a,g))).then(a=>{w({limitHit:this.e,stats:a[0]||void 0})},a=>{h(new Error((0,L.$gj)(a)))})})}async p($,y){const w=new N.$pe,h=this.q($),g=this.r(),a=new m.$vL(this.k,$),n=!a.hasSiblingExcludeClauses();let i;try{this.h.add(w),i=b.$ae.create();const u=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},h,w.token),o=i.elapsed(),t=b.$ae.create();return this.g&&!this.e||(u&&u.forEach(l=>{const r=d.$hc.relative($.folder.path,l.path);if(n){const c=d.$oc(l.path);this.v(y,{base:$.folder,relativePath:r,basename:c});return}this.s(g,$.folder,r,y)}),this.g&&!this.e)?null:(this.u(g,a,y),{providerTime:o,postProcessTime:t.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q($){const y=(0,m.$uL)(this.k.includePattern,$.includePattern),w=(0,m.$uL)(this.k.excludePattern,$.excludePattern);return{folder:$.folder,excludes:w,includes:y,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const $={rootEntries:[],pathToEntries:Object.create(null)};return $.pathToEntries["."]=$.rootEntries,$}s({pathToEntries:$},y,w,h){if(w===this.a){const a=d.$oc(this.a);this.v(h,{base:y,relativePath:this.a,basename:a})}function g(a){const n=d.$oc(a),i=d.$nc(a);let u=$[i];u||(u=$[i]=[],g(i)),u.push({base:y,relativePath:a,basename:n})}g(w)}u({rootEntries:$,pathToEntries:y},w,h){const g=this,a=this.a;function n(i){const u=(0,m.$xL)(()=>i.map(o=>o.basename));for(let o=0,t=i.length;o<t;o++){const l=i[o],{relativePath:r,basename:c}=l;if(w.matchesExcludesSync(r,c,a!==c?u:void 0))continue;const s=y[r];if(s)n(s);else{if(r===a)continue;g.v(h,l)}if(g.e)break}}n($)}v($,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||$(y))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch($,y,w,h){const g=this.c($.cacheKey),a=new E($,y,g&&g.token);let n=0;const i=u=>{n+=u.length,w(u.map(o=>this.d(o)))};return this.e(a,A.a,i,h).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:u.stats}}))}clearCache($){this.c($)?.cancel()}c($){if($)return this.b.has($)||this.b.set($,new N.$pe),this.b.get($)}d($){return $.relativePath?{resource:M.$9g($.base,$.relativePath)}:{resource:$.base}}e($,y,w,h){const g=h.onCancellationRequested(()=>{$.cancel()}),a=i=>{i&&(n.push(i),y>0&&n.length>=y&&(w(n),n=[]))};let n=[];return $.search(a).then(i=>(n.length&&w(n),g.dispose(),i),i=>(n.length&&w(n),g.dispose(),Promise.reject(i)))}}e.$mmc=A}),define(ke[377],Pe([1,0,19,74,35,103,27,15,17,23,14,18,2,100,250,54,11,42,147,372,37]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EM=void 0,e.$FM=S;let o=class{constructor(k,P,C,I,T){this.a=k,this.b=P,this.c=C,this.d=I,this.e=T}text(k,P,C={}){k=this.f(k,C);const I=this.a.getValue(),T=P&&P.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(P?.map(a.$Qi),C),type:2,contentPattern:k,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:I.search.usePCRE2||T||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(k,P){const C=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const I={...k,wordSeparators:C.editor.wordSeparators};return this.j(k,P)&&(I.isCaseSensitive=!0),this.k(k)&&(I.isMultiline=!0),P.notebookSearchConfig?.includeMarkupInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownInput=P.notebookSearchConfig.includeMarkupInput),P.notebookSearchConfig?.includeMarkupPreview&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownPreview=P.notebookSearchConfig.includeMarkupPreview),P.notebookSearchConfig?.includeCodeInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellInput=P.notebookSearchConfig.includeCodeInput),P.notebookSearchConfig?.includeOutput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellOutput=P.notebookSearchConfig.includeOutput),I}file(k,P={}){return{...this.h(k,P),type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey,shouldGlobMatchFilePattern:P.shouldGlobSearch}}g(k,P){return k?(k=Array.isArray(k)?k.map(s):s(k),P?this.parseSearchPaths(k):{pattern:l(...Array.isArray(k)?k:[k])}):{}}h(k=[],P={}){const C=this.g(P.includePattern,P.expandPatterns),I=this.g(P.excludePattern,P.expandPatterns),T=k.length>1,j=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(F=>this.q(F,P,I)):k.map(F=>this.r(F,P,I,T))).filter(F=>!!F),z={_reason:P._reason,folderQueries:j,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:I.pattern,includePattern:C.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const F=d.$Hb(d.$Rb(this.c.groups.map(q=>q.editors.map(Q=>Q.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const B=F.filter(q=>(0,u.$lL)(z,q.fsPath)),Z=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...z,...Z}}const O=P.extraFileResources&&P.extraFileResources.filter(F=>(0,u.$lL)(z,F.fsPath));return z.extraFileResources=O&&O.length?O:void 0,z}i(k){const P=[],C=new M.$Bc,I={};let T=!1;return k.forEach(j=>{if(j.scheme===b.Schemas.walkThrough)return;if((0,E.$ah)(j)){const O=this.b.getWorkspaceFolder(j)?.uri??j.with({path:m.$nc(j.fsPath)});let F=C.get(O);F||(T=!0,F={folder:O,includePattern:{}},P.push(F),C.set(O,F));const B=m.$mc(O.fsPath,j.fsPath);(0,D.$gg)(F.includePattern)[B.replace(/\\/g,"/")]=!0}else j.fsPath&&(T=!0,I[j.fsPath]=!0)}),{folderQueries:P,includePattern:I,usingSearchPaths:!0,excludePattern:T?void 0:{"**/*":!0}}}j(k,P){if(P.isSmartCase){if(k.isRegExp){if(A.$Yf(k.pattern,!0))return!0}else if(A.$Yf(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,y.$JC)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const P=Z=>m.$jc(Z)||/^\.\.?([\/\\]|$)/.test(Z),I=(Array.isArray(k)?k:r(k)).map(Z=>{const q=this.e.resolvedUserHome;return q?(0,R.$zw)(Z,q.scheme===b.Schemas.file?q.fsPath:q.path):Z}),T=N.$K(I,Z=>P(Z)?"searchPaths":"exprSegments"),j=(T.exprSegments||[]).map(Z=>A.$ff(Z,"/")).map(Z=>A.$ff(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),c(Z))),z={},O=this.m(T.searchPaths||[]);O&&O.length&&(z.searchPaths=O);const F=d.$Rb(j),B=l(...F);return B&&(z.pattern=B),z}l(k,P){return P.disregardExcludeSettings?void 0:(0,u.$kL)(k,!P.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const P=k.flatMap(I=>{let{pathPortion:T,globPortion:j}=t(I);return j&&(j=v(j)),this.n(T).flatMap(O=>this.o(O,j))}),C=new Map;return P.forEach(I=>{const T=I.searchPath.toString(),j=C.get(T);j?I.pattern&&(j.pattern=j.pattern||{},j.pattern[I.pattern]=!0):C.set(T,{searchPath:I.searchPath,pattern:I.pattern?l(I.pattern):void 0})}),Array.from(C.values())}n(k){if(m.$jc(k)){const P=this.b.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==b.Schemas.file?[{searchPath:P[0].uri.with({path:k})}]:[{searchPath:$.URI.file(m.$ic(k))}]}if(this.b.getWorkbenchState()===2){const P=this.b.getWorkspace().folders[0].uri;if(k=s(k),k.startsWith("../")||k===".."){const I=m.$hc.resolve(P.path,k);return[{searchPath:P.with({path:I})}]}const C=v(k);return[{searchPath:P,pattern:C}]}else{if(k==="./"||k===".\\")return[];{const P=k.replace(/^\.[\/\\]/,""),I=this.b.getWorkspace().folders.map(T=>{const j=P.match(new RegExp(`^${A.$_e(T.name)}(?:/(.*)|$)`));return j?{match:j,folder:T}:null}).filter(D.$dg);if(I.length)return I.map(T=>{const j=T.match[1];return{searchPath:T.folder.uri,pattern:j&&v(j)}});{const T=k.match(/\.[\/\\](.+)[\/\\]?/),j=T?T[1]:k,z=w.localize(0,null,j);throw new Error(z)}}}}o(k,P){const C=k.pattern&&P?`${k.pattern}/${P}`:k.pattern||P,I=[{searchPath:k.searchPath,pattern:C}];return C&&!C.endsWith("**")&&I.push({searchPath:k.searchPath,pattern:C+"/**"}),I}q(k,P,C){const I=this.r((0,a.$Qi)(k.searchPath),P,C,!1);return I?{...I,includePattern:k.pattern}:null}r(k,P,C,I){let T;const j=$.URI.isUri(k)?k:k.uri;if(C.searchPaths){const Z=C.searchPaths.filter(q=>(0,E.$2g)(q.searchPath,j))[0];if(Z&&!Z.pattern)return null;Z&&(T=Z.pattern)}const z=this.a.getValue({resource:j}),F={...this.l(z,P)||{},...T||{}},B=$.URI.isUri(k)?(0,E.$6g)(k):k.name;return{folder:j,folderName:I?B:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof P.disregardParentIgnoreFiles=="boolean"?P.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!z.search.followSymlinks}}};e.$EM=o,e.$EM=o=Je([Ve(0,h.$2i),Ve(1,a.$Ei),Ve(2,n.$QD),Ve(3,g.$2j),Ve(4,i.$CM)],o);function t(p){const k=p.match(/[\*\{\}\(\)\[\]\?]/);if(k){const P=k.index,C=p.substr(0,P).match(/[/|\\][^/\\]*$/);if(C){let I=p.substr(0,C.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:p.substr((C.index||0)+1)}}}return{pathPortion:p}}function l(...p){return p.length?p.reduce((k,P)=>(k[P]=!0,k),Object.create(null)):void 0}function r(p){return L.$nk(p,",").map(k=>k.trim()).filter(k=>!!k.length)}function c(p){return[`**/${p}/**`,`**/${p}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function s(p){return p.replace(/\\/g,"/")}function v(p){return s(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(p){return p.replace(/([?*[\]])/g,"[$1]")}function S(p,k){p=d.$Mb(p,I=>I.toString());const P=[],C=k.getWorkspace();return p&&p.forEach(I=>{let T;if(k.getWorkbenchState()===2)T=(0,E.$$g)(C.folders[0].uri,I),T&&T!=="."&&(T="./"+T);else{const j=k.getWorkspaceFolder(I);if(j){const z=j.name;if(C.folders.filter(F=>F.name===z).length===1){const F=(0,E.$$g)(j.uri,I);F===""?T=`./${j.name}`:T=`./${j.name}/${F}`}else T=I.fsPath}}T&&P.push(f(T))}),P}}),define(ke[378],Pe([1,0,23,2,22,13,5,377,37,42,7]),function(le,e,d,N,L,R,M,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cub=$,e.$Dub=h;const D=7e3;function $(g,a){const n=a.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],u=[];for(const s of n)if(/^workspaceContains:/.test(s)){const v=s.substr(18);v.indexOf("*")>=0||v.indexOf("?")>=0||g.forceUsingSearch?u.push(v):i.push(v)}if(i.length===0&&u.length===0)return Promise.resolve(void 0);const{promise:o,resolve:t}=(0,A.$oh)(),l=s=>t({activationEvent:s}),r=Promise.all(i.map(s=>y(g,s,l))).then(()=>{}),c=w(g,a.identifier,u,l);return Promise.all([r,c]).then(()=>{t(void 0)}),o}async function y(g,a,n){for(const i of g.folders)if(await g.exists(d.$9g(N.URI.revive(i),a))){n(`workspaceContains:${a}`);return}}async function w(g,a,n,i){if(n.length===0)return Promise.resolve(void 0);const u=new L.$pe,o=g.checkExists(g.folders,n,u.token),t=setTimeout(async()=>{u.cancel(),g.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},D);let l=!1;try{l=await o}catch(r){R.$4(r)||R.$1(r)}u.dispose(),clearTimeout(t),l&&i(`workspaceContains:${n.join(",")}`)}function h(g,a,n,i){const u=g.get(M.$ui),o=g.get(m.$cL),l=u.createInstance(b.$EM).file(a.map(r=>(0,E.$Qi)(N.URI.revive(r))),{_reason:"checkExists",includePattern:n,exists:!0});return o.fileSearch(l,i).then(r=>!!r.limitHit,r=>R.$4(r)?!1:Promise.reject(r))}}),define(ke[49],Pe([1,0,225,17,59,23,7,3,78,2,11,6,45,310,119,44,26,149,13,25,21,287,8,67,5,28,93,20,107,71,43,122,4,378,118,289,15,116,40,12,117]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i,u,o,t,l,r,c,s,v,f,S,p,k,P,C,I,T,j,z,O,F,B){"use strict";var Z;Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=e.$4lc=e.$3lc=e.$2lc=e.$1lc=void 0,e.$1lc=(0,r.$vi)("IHostUtils");let q=Z=class extends b.$Vc{constructor(U,ee,pe,Ce,se,re,oe,K,ne,$e,be,Ae,fe){super(),this.Y=Ae,this.Z=fe,this.a=this.B(new P.$ee),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=ee,this.g=pe,this.f=oe,this.j=Ce,this.m=se,this.s=re,this.t=ne,this.u=$e,this.w=be,this.y=this.g.getProxy(D.$1M.MainThreadWorkspace),this.z=this.g.getProxy(D.$1M.MainThreadTelemetry),this.C=this.g.getProxy(D.$1M.MainThreadExtensionService),this.D=new M.$uh,this.F=new M.$uh,this.G=new M.$uh,this.H=new M.$uh,this.I=new ve(this.f.extensions.activationEvents),this.L=new a.$C_b(this.I,this.f.extensions.allExtensions);const Se=new i.$Rm(this.f.extensions.myExtensions);this.J=new a.$C_b(this.I,me(this.L,Se)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${X(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${X(this.J)}`)),this.M=new w.$Jlc(this.g,this.s),this.N=new I.$Tlc(this.g),this.O=K,this.h=U.createChild(new f.$ti([w.$Klc,this.M],[I.$Ulc,this.N])),this.P=this.B(new y.$Ilc(this.J,this.L,{onExtensionActivationError:(Ie,ze,V)=>{this.C.$onExtensionActivationError(Ie,n.$3(ze),V)},actualActivateExtension:async(Ie,ze)=>{if(a.$C_b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,ze),new y.$Hlc;const V=this.J.getExtensionDescription(Ie);return this.fb(V,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),L.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){n.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(se=>se.identifier).filter(se=>this.isActivated(se)).map(se=>this.eb(se))}catch{}await Promise.all(U)}terminate(U,ee=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ce=>{this.s.error(Ce)}),this.g.dispose();const pe=this.$();Promise.race([(0,M.$wh)(5e3),pe]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ee}`):this.s.info(`Extension host exiting with code ${ee}`),this.s.flush(),this.s.dispose(),this.c.exit(ee)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const ee=await this.C.$getExtension(U);return ee&&{...ee,identifier:new i.$Qm(ee.identifier.value),extensionLocation:E.URI.revive(ee.extensionLocation)}}ab(U,ee){return this.P.activateByEvent(U,ee)}bb(U,ee){return this.P.activateById(U,ee)}activateByIdWithErrors(U,ee){return this.bb(U,ee).then(()=>{const pe=this.P.getActivatedExtension(U);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===j.Schemas.file&&this.c.fsRealpath){const ee=U.fsPath;this.R.has(ee)||this.R.set(ee,this.c.fsRealpath(ee));const pe=await this.R.get(ee);return E.URI.file(pe)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new ue(U))),this.Q}async db(U){const ee=m.$Bi.forUris(pe=>R.$Zg.ignorePathCasing(pe));return await Promise.all(U.map(async pe=>{if(this.wb(pe)){const Ce=await this.cb(pe.extensionLocation);ee.set(Ce,pe)}})),ee}eb(U){let ee=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return ee;const pe=this.P.getActivatedExtension(U);if(!pe)return ee;try{typeof pe.module.deactivate=="function"&&(ee=Promise.resolve(pe.module.deactivate()).then(void 0,Ce=>(this.s.error(Ce),Promise.resolve(void 0))))}catch(Ce){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(Ce)}try{(0,b.$Qc)(pe.subscriptions)}catch(Ce){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(Ce)}return ee}async fb(U,ee){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,ee).then(pe=>{const Ce=pe.activationTimes;return this.C.$onDidActivateExtension(U.identifier,Ce.codeLoadingTime,Ce.activateCallTime,Ce.activateResolvedTime,ee),this.gb(U,ee,"success",Ce),pe},pe=>{throw this.gb(U,ee,"failure"),pe})}gb(U,ee,pe,Ce){const se=x(U,ee);this.z.$publicLog2("extensionActivationTimes",{...se,...Ce||{},outcome:pe})}hb(U,ee){const pe=x(U,ee);this.z.$publicLog2("activatePlugin",pe);const Ce=this.wb(U);if(!Ce)return Promise.resolve(new y.$Glc(y.$Dlc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${ee.startup}, activationEvent: '${ee.activationEvent}'${U.identifier.value!==ee.extensionId.value?`, root cause: ${ee.extensionId.value}`:""}`),this.s.flush();const se=new y.$Elc(ee.startup);return Promise.all([this.xb(U,(0,R.$9g)(U.extensionLocation,Ce),se),this.ib(U)]).then(re=>(L.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),Z.jb(this.s,U.identifier,re[0],re[1],se))).then(re=>(L.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),re))}ib(U){const ee=this.Z.createLanguageModelAccessInformation(U),pe=new o.$Mlc(U,this.M),Ce=new o.$Llc(U.identifier.value,!1,this.M),se=new T.$Vlc(U,this.N),re=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,oe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([pe.whenReady,Ce.whenReady,this.O.whenReady]).then(()=>{const K=this;let ne,$e;const be=(0,g.$FG)(U,"ipc")?this.f.messagePorts?.get(i.$Qm.toKey(U.identifier)):void 0;return Object.freeze({globalState:pe,workspaceState:Ce,secrets:se,subscriptions:[],get languageModelAccessInformation(){return ee},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Ae){return N.$kc(U.extensionLocation.fsPath,Ae)},get storagePath(){return K.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return K.O.globalValue(U).fsPath},get logPath(){return N.$kc(K.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return E.URI.joinPath(K.f.logsLocation,U.identifier.value)},get storageUri(){return K.O.workspaceValue(U)},get globalStorageUri(){return K.O.globalValue(U)},get extensionMode(){return re},get extension(){return ne===void 0&&(ne=new ie(K,U.identifier,U,oe,!1)),ne},get extensionRuntime(){return(0,g.$GG)(U,"extensionRuntime"),K.extensionRuntime},get environmentVariableCollection(){return K.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!$e){if(!be)return;const Ae=P.Event.buffer(P.Event.fromDOMEventEmitter(be,"message",fe=>fe.data));be.start(),$e={onDidReceiveMessage:Ae,postMessage:be.postMessage.bind(be)}}return $e}})})}static jb(U,ee,pe,Ce,se){return pe=pe||{activate:void 0,deactivate:void 0},this.kb(U,ee,pe,Ce,se).then(re=>new y.$Flc(!1,null,se.build(),pe,re,Ce.subscriptions))}static kb(U,ee,pe,Ce,se){if(typeof pe.activate=="function")try{se.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${ee.value}`);const re=typeof global=="object"?global:self,oe=pe.activate.apply(re,[Ce]);return se.activateCallStop(),se.activateResolveStart(),Promise.resolve(oe).then(K=>(se.activateResolveStop(),K))}catch(re){return Promise.reject(re)}else return Promise.resolve(pe)}lb(U,ee){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:ee}).then(void 0,pe=>{this.s.error(pe)})}mb(U,ee=0){const Ce=Date.now();(0,F.$B)(()=>{for(let se=ee;se<U.length;se+=1){const re=U[se];for(const oe of re.activationEvents??[])if(oe==="onStartupFinished")if(Date.now()-Ce>50){this.mb(U,se);break}else this.lb(re,oe)}})}nb(){this.C.$setPerformanceMarks(L.getMarks()),this.m.getConfigProvider().then(U=>{const ee=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),pe=this.J.getAllExtensionDescriptions();if(ee)this.mb(pe);else for(const Ce of pe)if(Ce.activationEvents)for(const se of Ce.activationEvents)se==="onStartupFinished"&&this.lb(Ce,se)})}ob(){const U=this.ab("*",!0).then(void 0,re=>{this.s.error(re)});this.B(this.j.onDidChangeWorkspace(re=>this.pb(re.added)));const ee=this.j.workspace?this.j.workspace.folders:[],pe=this.pb(ee),Ce=this.rb(),se=Promise.all([Ce,U,pe]).then(()=>{});return Promise.race([se,(0,M.$wh)(1e4)]).then(()=>{this.nb()}),se}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ee=>this.qb(U,ee))).then(()=>{})}async qb(U,ee){if(this.isActivated(ee.identifier))return;const pe=!this.f.remote.isRemote&&!!this.f.remote.authority,Ce={logService:this.s,folders:U.map(re=>re.uri),forceUsingSearch:pe||!this.c.fsExists,exists:re=>this.c.fsExists(re.fsPath),checkExists:(re,oe,K)=>this.y.$checkExists(re,oe,K)},se=await(0,C.$Cub)(Ce,ee);if(se)return this.bb(ee.identifier,{startup:!0,extensionId:ee.identifier,activationEvent:se.activationEvent}).then(void 0,re=>this.s.error(re))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:ee}=this.f.environment;if(!U||!ee)throw new Error(d.localize(0,null));const pe=await this.xb(null,ee,new y.$Elc(!1));if(!pe||typeof pe.run!="function")throw new Error(d.localize(1,null,ee.toString()));return new Promise((Ce,se)=>{const re=(ne,$e)=>{ne?(F.$t&&this.s.error("Test runner called back with error",ne),se(ne)):(F.$t&&($e?this.s.info(`Test runner called back with ${$e} failures.`):this.s.info("Test runner called back with successful outcome.")),Ce(typeof $e=="number"&&$e>0?1:0))},oe=(0,R.$Wg)(ee),K=pe.run(oe,re);K&&K.then&&K.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),Ce(0)}).catch(ne=>{F.$t&&this.s.error("Test runner finished with error",ne),se(ne instanceof Error&&ne.stack?ne.stack:String(ne))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$wh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,ee){return this.S[U]=ee,(0,b.$Tc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:ee}=await this.ub(U);return ee?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const ee=U.indexOf("+");if(ee===-1)throw new t.$9M("Not an authority that can be resolved!",l.RemoteAuthorityResolverErrorCode.InvalidAuthority);const pe=U.substr(0,ee);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this.S[pe]}}async $resolveAuthority(U,ee){const pe=O.$ae.create(!1),Ce=()=>`[resolveAuthority(${(0,l.$Kl)(U)},${ee})][${pe.elapsed()}ms] `,se=W=>this.s.info(`${Ce()}${W}`),re=W=>this.s.warn(`${Ce()}${W}`),oe=(W,J=void 0)=>this.s.error(`${Ce()}${W}`,J),K=W=>{if(W instanceof t.$9M)return{type:"error",error:{code:W._code,message:W._message,detail:W._detail}};throw W},ne=async W=>{se(`activating resolver for ${W}...`);const{resolver:J,authorityPrefix:Y}=await this.ub(W);if(!J)throw oe(`no resolver for ${Y}`),new t.$9M(`No remote extension installed to resolve ${Y}.`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:Y,remoteAuthority:W}},$e=U.split(/@|%40/g).reverse();se(`activating remote resolvers ${$e.join(" -> ")}`);let be;try{be=await Promise.all($e.map(ne)).catch(async W=>{if(!(W instanceof t.$9M)||W._code!==l.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw W;return re(`resolving nested authorities failed: ${W.message}`),[await ne(U)]})}catch(W){return K(W)}const Ae=new M.$Gh;Ae.cancelAndSet(()=>se("waiting..."),1e3);let fe,Se;for(const[W,{authorityPrefix:J,resolver:Y,remoteAuthority:he}]of be.entries())try{if(W===be.length-1)se("invoking final resolve()..."),L.mark(`code/extHost/willResolveAuthority/${J}`),fe=await Y.resolve(he,{resolveAttempt:ee,execServer:Se}),L.mark(`code/extHost/didResolveAuthorityOK/${J}`),se("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Y,t.$8M.isManagedResolvedAuthority(fe)?fe:void 0));else{if(se(`invoking resolveExecServer() for ${he}`),L.mark(`code/extHost/willResolveExecServer/${J}`),Se=await Y.resolveExecServer?.(he,{resolveAttempt:ee,execServer:Se}),!Se)throw new t.$9M(`Exec server was not available for ${he}`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);L.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(we){return L.mark(`code/extHost/didResolveAuthorityError/${J}`),oe("returned an error",we),Ae.dispose(),K(we)}Ae.dispose();const Ie={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures?{elevation:fe.tunnelFeatures.elevation,privacyOptions:fe.tunnelFeatures.privacyOptions,protocol:fe.tunnelFeatures.protocol===void 0?!0:fe.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};se(`returned ${t.$8M.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let V;if(t.$8M.isManagedResolvedAuthority(fe)){const W=ee;this.Y.setFactory(W,fe.makeConnection),V={authority:U,connectTo:new l.$Hl(W),connectionToken:fe.connectionToken}}else V={authority:U,connectTo:new l.$Il(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:V,options:ze,tunnelInformation:Ie}}}async $getCanonicalURI(U,ee){this.s.info(`$getCanonicalURI invoked for authority (${(0,l.$Kl)(U)})`);const{resolver:pe}=await this.ub(U);if(!pe)return null;const Ce=E.URI.revive(ee);if(typeof pe.getCanonicalURI>"u")return Ce;const se=await(0,M.$nh)(()=>pe.getCanonicalURI(Ce));return se||Ce}async $startExtensionHost(U){U.toAdd.forEach(re=>re.extensionLocation=E.URI.revive(re.extensionLocation));const{globalRegistry:ee,myExtensions:pe}=Q(this.I,this.L,this.J,U),Ce=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(Ce),this.L.set(ee.getAllExtensionDescriptions()),this.J.set(pe),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${X(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${X(this.J)}`)),this.tb()}$activateByEvent(U,ee){return ee===1?this.D.wait().then(pe=>this.ab(U,!1)):this.G.wait().then(pe=>this.ab(U,!1))}async $activate(U,ee){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,ee),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(re=>re.extensionLocation=E.URI.revive(re.extensionLocation));const{globalRegistry:ee,myExtensions:pe}=Q(this.I,this.L,this.J,U),Ce=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(Ce),this.L.set(ee.getAllExtensionDescriptions()),this.J.set(pe),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${X(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${X(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const ee=u.$Fe.alloc(U),pe=Math.random()%256;for(let Ce=0;Ce<U;Ce++)ee.writeUInt8(pe,Ce);return ee}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$2lc=q,e.$2lc=q=Z=Je([Ve(0,r.$ui),Ve(1,e.$1lc),Ve(2,v.$oP),Ve(3,h.$mlc),Ve(4,$.$plc),Ve(5,A.$2j),Ve(6,c.$EP),Ve(7,s.$slc),Ve(8,S.$jDb),Ve(9,p.$Nlc),Ve(10,z.$Xlc),Ve(11,B.$Ylc),Ve(12,k.$Rlc)],q);function Q(te,U,ee,pe){te.addActivationEvents(pe.addActivationEvents);const Ce=new a.$C_b(te,U.getAllExtensionDescriptions());Ce.deltaExtensions(pe.toAdd,pe.toRemove);const se=new i.$Rm(ee.getAllExtensionDescriptions().map(oe=>oe.identifier));for(const oe of pe.myToRemove)se.delete(oe);for(const oe of pe.myToAdd)se.add(oe);const re=me(Ce,se);return{globalRegistry:Ce,myExtensions:re}}function x(te,U){return{id:te.identifier.value,name:te.name,extensionVersion:te.version,publisherDisplayName:te.publisher,activationEvents:te.activationEvents?te.activationEvents.join(","):null,isBuiltin:te.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function X(te){return te.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$3lc=(0,r.$vi)("IExtHostExtensionService");class ie{#e;#t;#n;constructor(U,ee,pe,Ce,se){this.#e=U,this.#t=ee,this.#n=pe.identifier,this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=N.$ic((0,R.$Wg)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=Ce,this.isFromDifferentExtensionHost=se}get isActive(){return this.#e.isActivated(this.#n)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#n)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#n,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$4lc=ie;function me(te,U){return te.getAllExtensionDescriptions().filter(ee=>U.has(ee.identifier))}class ue{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$5lc=ue;class ve{constructor(U){this.a=new i.$Sm,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const ee of Object.keys(U))this.a.set(ee,U[ee])}}}),define(ke[379],Pe([1,0,59,2,6,45,26,25,20,28,5,49,11,14]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=void 0;let h=class{constructor(u,o,t,l,r,c,s){this.c=u,this.d=o,this.e=t,this.f=l,this.g=r,this.h=c,this.i=s,this.a=new Map,this.b=[]}async install(){this.j(),d.mark("code/extHost/willWaitForConfig");const u=await this.f.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const o=await this.g.getExtensionPathIndex();this.register(new a(this.c,o,this.d,u,this.i)),this.register(this.e.createInstance(g)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,o,this.h.environment.appUriScheme))}register(u){if("nodeModuleName"in u)if(Array.isArray(u.nodeModuleName))for(const o of u.nodeModuleName)this.a.set(o,u);else this.a.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this.b.push(o=>u.alternativeModuleName(o))}};e.$bnc=h,e.$bnc=h=Je([Ve(2,A.$ui),Ve(3,R.$plc),Ve(4,D.$3lc),Ve(5,E.$EP),Ve(6,$.$2j)],h);let g=class{static{w=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(u){if(u.environment.appRoot&&w.a.size){const o=(0,y.$_e)(this.c(u.environment.appRoot.fsPath)),t="[a-z0-9_.-]",l=`@${t}+\\/${t}+|${t}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${o}/${r}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(u){if(!this.b)return;const o=this.b.exec(this.c(u));if(!o)return;const[,t,l,r]=o,c=w.a.get(l);if(c!==void 0)return console.warn(`${l} as been renamed to ${c}, please update your imports`),t+c+r}c(u){return u.replace(/\\/g,"/")}};g=w=Je([Ve(0,E.$EP)],g);class a{constructor(u,o,t,l,r){this.c=u,this.d=o,this.e=t,this.f=l,this.g=r,this.nodeModuleName="vscode",this.a=new b.$Sm}load(u,o){const t=this.d.findSubstr(o);if(t){let l=this.a.get(t.identifier);return l||(l=this.c(t,this.e,this.f),this.a.set(t.identifier,l)),l}if(!this.b){let l="";this.d.forEach((r,c)=>l+=`	${c} -> ${r.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${l}`),this.b=this.c(M.$AG,this.e,this.f)}return this.b}}let n=class{constructor(u,o,t){this.e=u,this.f=o,this.nodeModuleName=["open","opn"],this.d=t.getProxy(L.$1M.MainThreadTelemetry);const l=t.getProxy(L.$1M.MainThreadWindow);this.c=(r,c)=>{const s=N.URI.parse(r);return c?this.g(r,c):s.scheme==="http"||s.scheme==="https"?l.$openUri(s,r,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this.f?l.$openUri(s,r,{}):this.g(r,c)}}load(u,o,t){const l=this.e.findSubstr(o);return l&&(this.a=l.identifier.value,this.h()),this.b=t(u),this.c}g(u,o){return this.i(),this.b(u,o)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([Ve(2,m.$oP)],n)}),define(ke[61],Pe([1,0,46,3,17,51,5,73,72,49,8,44,307,45]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=e.$6lc=void 0,e.$6lc=(0,M.$vi)("IExtHostVariableResolverProvider");class w extends $.$qQ{constructor(a,n,i,u,o,t,l){function r(){if(i){const c=i.activeEditor();if(c)return c.document.uri;const s=u.tabGroups.all.find(v=>v.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof A.$OO||s.input instanceof A.$TO)return s.input.modified;if(s.input instanceof A.$NO||s.input instanceof A.$SO||s.input instanceof A.$QO)return s.input.uri}}}super({getFolderUri:c=>{const s=t.folders.filter(v=>v.name===c);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(c,s)=>o.getConfiguration(void 0,c).get(s),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=r();if(c)return L.$ic(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const c=r();if(c){const s=n.getWorkspaceFolder(c);if(s)return L.$ic(s.uri.fsPath)}}},getSelectedText:()=>{if(i){const c=i.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(i){const c=i.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>a.getExtension(c)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(R.env))}}let h=class extends N.$Vc{constructor(a,n,i,u,o){super(),this.b=a,this.c=n,this.g=i,this.h=u,this.j=o,this.a=new d.$V(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,t,r,this.m())})}getResolver(){return this.a.value}m(){}};e.$7lc=h,e.$7lc=h=Je([Ve(0,E.$3lc),Ve(1,D.$mlc),Ve(2,b.$zP),Ve(3,y.$plc),Ve(4,m.$Blc)],h)}),define(ke[96],Pe([1,0,7,4,2,25,5,6,72,49,20,8,44,144,299,45,61,3,57,34,16]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=e.$$lc=e.$0lc=e.$9lc=e.$8lc=void 0,e.$8lc=(0,M.$vi)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(f,S,p,k,P,C,I){this.N=S,this.O=p,this.P=k,this.Q=P,this.R=C,this.S=I,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$ee,this.o=new N.$ee,this.q=new N.$ee,this.w=new N.$ee,this.l=f.getProxy(b.$1M.MainThreadDebugService),this.A=new N.$ee,this.C=new N.$ee,this.y=new l(this.l),this.z=new Map,this.O.getExtensionRegistry().then(T=>{T.onDidChange(j=>{this.V(T)}),this.V(T)})}async $getVisualizerTreeItem(f,S){const p=this.W(S);if(!p)return;const k=await this.H.get(f)?.getTreeItem?.(p);return k?this.U(f,k):void 0}registerDebugVisualizationTree(f,S,p){const k=R.$Qm.toKey(f.identifier),P=this.jb(k,S);if(this.G.has(P))throw new Error(`A debug visualization provider with id '${S}' is already registered`);return this.H.set(P,p),this.l.$registerDebugVisualizerTree(P,!!p.editItem),(0,a.$Tc)(()=>{this.l.$unregisterDebugVisualizerTree(P),this.H.delete(S)})}async $getVisualizerTreeItemChildren(f,S){const p=this.J.get(S)?.item;return p?(await this.H.get(f)?.getChildren?.(p))?.map(P=>this.U(f,P))||[]:[]}async $editVisualizerTreeItem(f,S){const p=this.J.get(f);if(!p)return;const k=await this.H.get(p.provider)?.editItem?.(p.item,S);return this.U(p.provider,k||p.item)}$disposeVisualizedTree(f){const S=this.J.get(f);if(!S)return;const p=[S.children];for(const k of p)if(k)for(const P of k)p.push(this.J.get(P)?.children),this.J.delete(P)}U(f,S){let p=this.I.get(S);return p||(p=this.F++,this.I.set(S,p),this.J.set(p,{provider:f,item:S})),u.DebugTreeItem.from(S,p)}asDebugSourceUri(f,S){const p=f;if(typeof p.sourceReference=="number"&&p.sourceReference>0){let k=`debug:${encodeURIComponent(p.path||"")}`,P="?";return S&&(k+=`${P}session=${encodeURIComponent(S.id)}`,P="&"),k+=`${P}ref=${p.sourceReference}`,L.URI.parse(k)}else{if(p.path)return L.URI.file(p.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(f){const S=[];for(const p of f.getAllExtensionDescriptions())if(p.contributes){const k=p.contributes.debuggers;if(k&&k.length>0)for(const P of k)(0,w.$kH)(P)&&S.push(P.type)}this.l.$registerDebugTypes(S)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const f=[];return this.z.forEach(S=>f.push(S)),f}async $resolveDebugVisualizer(f,S){const p=this.L.get(f);if(!p)throw new Error(`No debug visualizer found with id '${f}'`);let{v:k,provider:P,extensionId:C}=p;if(k.visualization||(k=await P.resolveDebugVisualization?.(k,S)||k,p.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${P}'`);return this.kb(C,k.visualization)}async $executeDebugVisualizerCommand(f){const S=this.L.get(f);if(!S)throw new Error(`No debug visualizer found with id '${f}'`);const p=S.v.visualization;p&&"command"in p&&this.S.executeCommand(p.command,...p.arguments||[])}W(f){const S=this.m.get(f.sessionId);return S&&{session:S.api,variable:f.variable,containerId:f.containerId,frameId:f.frameId,threadId:f.threadId}}async $provideDebugVisualizers(f,S,p,k){const P=this.W(p),C=this.jb(f,S),I=this.G.get(C);if(!P||!I)return[];const T=await I.provideDebugVisualization(P,k);return T?T.map(j=>{const z=++this.M;this.L.set(z,{v:j,provider:I,extensionId:f});const O=j.iconPath?this.lb(j.iconPath):void 0;return{id:z,name:j.name,iconClass:O?.iconClass,iconPath:O?.iconPath,visualization:this.kb(f,j.visualization)}}):[]}$disposeDebugVisualizers(f){for(const S of f)this.L.delete(S)}registerDebugVisualizationProvider(f,S,p){if(!f.contributes?.debugVisualizers?.some(C=>C.id===S))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${S})`);const k=R.$Qm.toKey(f.identifier),P=this.jb(k,S);if(this.G.has(P))throw new Error(`A debug visualization provider with id '${S}' is already registered`);return this.G.set(P,p),this.l.$registerDebugVisualizer(k,S),(0,a.$Tc)(()=>{this.l.$unregisterDebugVisualizer(k,S),this.G.delete(S)})}addBreakpoints(f){const S=f.filter(P=>{const C=P.id;return this.z.has(C)?!1:(this.z.set(C,P),!0)});this.gb(S,[],[]);const p=[],k=new Map;for(const P of S)if(P instanceof D.$5N){let C=k.get(P.location.uri.toString());C||(C={type:"sourceMulti",uri:P.location.uri,lines:[]},k.set(P.location.uri.toString(),C),p.push(C)),C.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character,mode:P.mode})}else P instanceof D.$6N&&p.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName,mode:P.mode});return this.l.$registerBreakpoints(p)}removeBreakpoints(f){const S=f.filter(C=>this.z.delete(C.id));this.gb([],S,[]);const p=S.filter(C=>C instanceof D.$5N).map(C=>C.id),k=S.filter(C=>C instanceof D.$6N).map(C=>C.id),P=S.filter(C=>C instanceof D.$7N).map(C=>C.id);return this.l.$unregisterBreakpoints(p,k,P)}startDebugging(f,S,p){return this.l.$startDebugging(f?f.uri:void 0,S,{parentSessionID:p.parentSession?p.parentSession.id:void 0,lifecycleManagedByParent:p.lifecycleManagedByParent,repl:p.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:p.noDebug,compact:p.compact,suppressSaveBeforeStart:p.suppressSaveBeforeStart,suppressDebugStatusbar:p.suppressDebugStatusbar??p.debugUI?.simple,suppressDebugToolbar:p.suppressDebugToolbar??p.debugUI?.simple,suppressDebugView:p.suppressDebugView??p.debugUI?.simple})}stopDebugging(f){return this.l.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,S,p){if(!S)return new D.$3M(()=>{});const k=this.d++;return this.f.push({type:f,handle:k,provider:S}),this.l.$registerDebugConfigurationProvider(f,p,!!S.provideDebugConfigurations,!!S.resolveDebugConfiguration,!!S.resolveDebugConfigurationWithSubstitutedVariables,k),new D.$3M(()=>{this.f=this.f.filter(P=>P.provider!==S),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(f,S,p){if(!p)return new D.$3M(()=>{});if(!this.cb(f,S))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${S}' debugger.`);if(this.$(S))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:S,handle:k,factory:p}),this.l.$registerDebugAdapterDescriptorFactory(S,k),new D.$3M(()=>{this.h=this.h.filter(P=>P.factory!==p),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(f,S){if(!S)return new D.$3M(()=>{});const p=this.j++;return this.k.push({type:f,handle:p,factory:S}),new D.$3M(()=>{this.k=this.k.filter(k=>k.factory!==S)})}async $runInTerminal(f,S){return Promise.resolve(void 0)}async $substituteVariables(f,S){let p;const k=await this.ib(f);return k&&(p={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(p,S)}X(f,S){if(f.type==="implementation")return new c(f.implementation)}Y(){}async $startDASession(f,S){const p=this,k=await this.hb(S);return this.eb(this.$(k.type),k).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const C=this.Z(P),I=this.X(C,k);if(!I)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const T=I;return this.D.set(f,T),this.db(k).then(j=>(j&&this.E.set(f,j),T.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const O=z,F={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const B=await this.K.sign(O.arguments.value);F.body={signature:B},T.sendResponse(F)}else throw new Error("no signer")}catch(B){F.success=!1,F.message=B.message,T.sendResponse(F)}}else j&&j.onDidSendMessage&&j.onDidSendMessage(z),z=(0,w.$pH)(z,!0),p.l.$acceptDAMessage(f,z)}),T.onError(z=>{j&&j.onError&&j.onError(z),this.l.$acceptDAError(f,z.name,z.message,z.stack)}),T.onExit(z=>{j&&j.onExit&&j.onExit(z??void 0,void 0),this.l.$acceptDAExit(f,z??void 0,void 0)}),j&&j.onWillStartSession&&j.onWillStartSession(),T.startSession()))})}$sendDAMessage(f,S){S=(0,w.$oH)(S,!1);const p=this.E.get(f);p&&p.onWillReceiveMessage&&p.onWillReceiveMessage(S),this.D.get(f)?.sendMessage(S)}$stopDASession(f){const S=this.E.get(f);this.E.delete(f),S&&S.onWillStopSession&&S.onWillStopSession();const p=this.D.get(f);return this.D.delete(f),p?p.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const S=[],p=[],k=[];if(f.added)for(const P of f.added){const C=P.id;if(C&&!this.z.has(C)){let I;if(P.type==="function")I=new D.$6N(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage,P.mode);else if(P.type==="data")I=new D.$7N(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage,P.mode);else{const T=L.URI.revive(P.uri);I=new D.$5N(new D.$cN(T,new D.$4M(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage,P.mode)}(0,D.$3N)(I,C),this.z.set(C,I),S.push(I)}}if(f.removed)for(const P of f.removed){const C=this.z.get(P);C&&(this.z.delete(P),p.push(C))}if(f.changed){for(const P of f.changed)if(P.id){const C=this.z.get(P.id);if(C){if(C instanceof D.$6N&&P.type==="function"){const I=C;I.enabled=P.enabled,I.condition=P.condition,I.hitCondition=P.hitCondition,I.logMessage=P.logMessage,I.functionName=P.functionName}else if(C instanceof D.$5N&&P.type==="source"){const I=C;I.enabled=P.enabled,I.condition=P.condition,I.hitCondition=P.hitCondition,I.logMessage=P.logMessage,I.location=new D.$cN(L.URI.revive(P.uri),new D.$4M(P.line,P.character))}k.push(C)}}}this.gb(S,p,k)}async $acceptStackFrameFocus(f){let S;if(f){const p=await this.hb(f.sessionId);f.kind==="thread"?S=new D.$aO(p.api,f.threadId):S=new D.$_N(p.api,f.threadId,f.frameId)}this.B=S,this.C.fire(this.B)}$provideDebugConfigurations(f,S,p){return(0,d.$nh)(async()=>{const k=this.bb(f);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.ib(S);return k.provideDebugConfigurations(P,p)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(f,S,p,k){return(0,d.$nh)(async()=>{const P=this.bb(f);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(S);return P.resolveDebugConfiguration(C,p,k)})}$resolveDebugConfigurationWithSubstitutedVariables(f,S,p,k){return(0,d.$nh)(async()=>{const P=this.bb(f);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(S);return P.resolveDebugConfigurationWithSubstitutedVariables(C,p,k)})}async $provideDebugAdapter(f,S){const p=this.ab(f);if(!p)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(S);return this.eb(p,k).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(P)})}async $acceptDebugSessionStarted(f){const S=await this.hb(f);this.n.fire(S.api)}async $acceptDebugSessionTerminated(f){const S=await this.hb(f);S&&(this.o.fire(S.api),this.m.delete(S.id))}async $acceptDebugSessionActiveChanged(f){this.u=f?await this.hb(f):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(f,S){(await this.hb(f))?._acceptNameChanged(S)}async $acceptDebugSessionCustomEvent(f,S){const k={session:(await this.hb(f)).api,event:S.event,body:S.body};this.w.fire(k)}Z(f){if(f instanceof D.$8N)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof D.$9N)return{type:"server",port:f.port,host:f.host};if(f instanceof D.$0N)return{type:"pipeServer",path:f.path};if(f instanceof D.$$N)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}$(f){const S=this.h.filter(p=>p.type===f);if(S.length>0)return S[0].factory}ab(f){const S=this.h.filter(p=>p.handle===f);if(S.length>0)return S[0].factory}bb(f){const S=this.f.filter(p=>p.handle===f);if(S.length>0)return S[0].provider}cb(f,S){if(f.contributes){const p=f.contributes.debuggers;if(p&&p.length>0){for(const k of p)if(k.label&&k.type&&k.type===S)return!0}}return!1}db(f){const p=f.configuration.type,k=this.k.filter(P=>P.type===p||P.type==="*").map(P=>(0,d.$nh)(()=>P.factory.createDebugAdapterTracker(f.api)).then(C=>C,C=>null));return Promise.race([Promise.all(k).then(P=>{const C=P.filter(I=>!!I);if(C.length>0)return new r(C)}),new Promise(P=>setTimeout(()=>P(void 0),1e3))]).catch(P=>{})}async eb(f,S){const p=S.configuration.debugServer;if(typeof p=="number")return Promise.resolve(new D.$9N(p));if(f){const P=await this.O.getExtensionRegistry();return(0,d.$nh)(()=>f.createDebugAdapterDescriptor(S.api,this.fb(S,P))).then(C=>{if(C)return C})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(S,k))}fb(f,S){}gb(f,S,p){(f.length>0||S.length>0||p.length>0)&&this.A.fire(Object.freeze({added:f,removed:S,changed:p}))}async hb(f){if(f)if(typeof f=="string"){const S=this.m.get(f);if(S)return S}else{let S=this.m.get(f.id);if(!S){const p=await this.ib(f.folderUri),k=f.parent?this.m.get(f.parent):void 0;S=new t(this.l,f.id,f.type,f.name,p,f.configuration,k?.api),this.m.set(S.id,S),this.l.$sessionCached(S.id)}return S}throw new Error("cannot find session")}ib(f){if(f){const S=L.URI.revive(f);return this.N.resolveWorkspaceFolder(S)}return Promise.resolve(void 0)}jb(f,S){return`${f}\0${S}`}kb(f,S){if(S){if("title"in S&&"command"in S)return{type:0};if("treeId"in S)return{type:1,id:`${f}\0${S.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(f){const S=this.mb(f);let p,k;return"id"in S?k=n.ThemeIcon.asClassName(S):p=S,{iconPath:p,iconClass:k}}mb(f){if(f instanceof D.$ZN)return{id:f.id};const S=typeof f=="object"&&"dark"in f?f.dark:f,p=typeof f=="object"&&"light"in f?f.light:f;return{dark:typeof S=="string"?L.URI.file(S):S,light:typeof p=="string"?L.URI.file(p):p}}};e.$9lc=o,e.$9lc=o=Je([Ve(0,A.$oP),Ve(1,$.$mlc),Ve(2,E.$3lc),Ve(3,h.$plc),Ve(4,m.$Blc),Ve(5,g.$6lc),Ve(6,i.$KP)],o);class t{constructor(f,S,p,k,P,C,I){this.f=f,this.g=S,this.h=p,this.j=k,this.k=P,this.l=C,this.m=I}get api(){const f=this;return this.d??=Object.freeze({id:f.g,type:f.h,get name(){return f.j},set name(S){f.j=S,f.f.$setDebugSessionName(f.g,S)},parentSession:f.m,workspaceFolder:f.k,configuration:f.l,customRequest(S,p){return f.f.$customDebugAdapterRequest(f.g,S,p)},getDebugProtocolBreakpoint(S){return f.f.$getDebugProtocolBreakpoint(f.g,S.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(f){this.j=f}get configuration(){return this.l}}e.$0lc=t;class l{constructor(f){this.value=Object.freeze({append(S){f.$appendDebugConsole(S)},appendLine(S){this.append(S+`
`)}})}}e.$$lc=l;class r{constructor(f){this.d=f}onWillStartSession(){this.d.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.d.forEach(S=>S.onWillReceiveMessage?S.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.d.forEach(S=>S.onDidSendMessage?S.onDidSendMessage(f):void 0)}onWillStopSession(){this.d.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.d.forEach(S=>S.onError?S.onError(f):void 0)}onExit(f,S){this.d.forEach(p=>p.onExit?p.onExit(f,S):void 0)}}class c extends y.$3pb{constructor(f){super(),this.h=f,f.onDidSendMessage(S=>{this.acceptMessage(S)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.h.handleMessage(f)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let s=class extends o{constructor(f,S,p,k,P,C,I){super(f,S,p,k,P,C,I)}};e.$_lc=s,e.$_lc=s=Je([Ve(0,A.$oP),Ve(1,$.$mlc),Ve(2,E.$3lc),Ve(3,h.$plc),Ve(4,m.$Blc),Ve(5,g.$6lc),Ve(6,i.$KP)],s)}),define(ke[380],Pe([1,0,13,59,2,6,327,11,85,107,28,263,20,68,49,90]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dnc=e.$cnc=void 0;class g{static async installEarlyHandler(i){Error.stackTraceLimit=100;const u=i.get(b.$2j),t=i.get($.$oP).getProxy(R.$1M.MainThreadErrors);d.setUnexpectedErrorHandler(l=>{u.error(l);const r=d.$3(l);t.$onUnexpectedError(r)})}static async installFullHandler(i){const u=i.get(b.$2j),o=i.get($.$oP),t=i.get(w.$3lc),l=i.get(h.$IP),r=o.getProxy(R.$1M.MainThreadExtensionService),c=o.getProxy(R.$1M.MainThreadErrors),s=await t.getExtensionPathIndex(),v=new WeakMap;function f(k,P){if(v.has(k))return v.get(k).stack;let C="",I,T;for(const z of P)C+=`
	at ${z.toString()}`,T=z.getFileName(),!I&&T&&(I=s.findSubstr(L.URI.file(T)));const j=`${k.name||"Error"}: ${k.message||""}${C}`;return v.set(k,{extensionIdentifier:I?.identifier,stack:j}),j}const S=Symbol("prepareStackTrace wrapped");let p=f;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return p},set(k){if(k===f||!k||k[S]){p=k||f;return}p=function(P,C){return f(P,C),k.call(Error,P,C)},Object.assign(p,{[S]:!0})}}),d.setUnexpectedErrorHandler(k=>{u.error(k);const P=d.$3(k),C=v.get(k);if(!C?.extensionIdentifier){c.$onUnexpectedError(P);return}r.$onExtensionRuntimeError(C.extensionIdentifier,P);const I=l.onExtensionError(C.extensionIdentifier,k);u.trace("forwarded error to extension?",I,C)})}}e.$cnc=g;class a{constructor(i,u,o,t,l){this.a=o,this.b=new M.$K_b(i,null,t),u=a.e(u,this.b);const r=new E.$ti(...(0,m.$xs)());r.set(A.$EP,{_serviceBrand:void 0,...u,messagePorts:l}),r.set($.$oP,new $.$pP(this.b)),r.set(y.$jlc,new y.$klc(t)),r.set(w.$1lc,o);const c=new D.$br(r,!0);c.invokeFunction(g.installEarlyHandler),this.d=c.invokeFunction(s=>s.get(b.$2j)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",u),this.c=c.invokeFunction(s=>s.get(w.$3lc)),this.c.initialize(),c.invokeFunction(g.installFullHandler)}async asBrowserUri(i){const u=this.b.getProxy(R.$1M.MainThreadExtensionService);return L.URI.revive(await u.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,u){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=L.URI.revive(u.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=L.URI.revive(u.transformIncomingURIs(i.environment.appRoot));const o=i.environment.extensionDevelopmentLocationURI;return o&&(i.environment.extensionDevelopmentLocationURI=o.map(t=>L.URI.revive(u.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=L.URI.revive(u.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=L.URI.revive(u.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=L.URI.revive(u.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=L.URI.revive(u.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=L.URI.revive(u.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=L.URI.revive(u.transformIncomingURIs(i.logsLocation)),i.workspace=u.transformIncomingURIs(i.workspace),i}}e.$dnc=a}),define(ke[381],Pe([1,0,7,12,236,256,141,96,72,49,20,43,8,61,44,300,301,45,34]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=void 0;let i=class extends b.$9lc{constructor(r,c,s,v,f,S,p,k){super(r,c,s,v,S,p,k),this.pb=f,this.nb=new t}X(r,c){switch(r.type){case"server":return new h.$inc(r);case"pipeServer":return new h.$jnc(r);case"executable":return new h.$knc(r,c.type)}return super.X(r,c)}fb(r,c){const s=h.$knc.platformAdapterExecutable(c.getAllExtensionDescriptions(),r.type);if(s)return new $.$8N(s.command,s.args,s.options)}Y(){return new M.$ydc}async $runInTerminal(r,c){if(r.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(z=>{this.nb.onTerminalClosed(z)}));const s=await this.P.getConfigProvider(),v=this.pb.getDefaultShell(!0),f=this.pb.getDefaultShellArgs(!0),S=r.title||L.localize(0,null),p=JSON.stringify({shell:v,shellArgs:f});let k=await this.nb.checkout(p,S),P,C=!1;if(k)P=r.cwd;else{const z={shellPath:v,shellArgs:f,cwd:r.cwd,name:S,iconPath:new $.$ZN("debug")};C=!0,k=this.pb.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(k,p)}k.show(!0);const I=await k.processId;C?await new Promise(z=>setTimeout(z,1e3)):(k.state.isInteractedWith&&k.sendText(""),s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(v.indexOf("powershell")>=0||v.indexOf("pwsh")>=0||v.indexOf("cmd.exe")>=0?k.sendText("cls"):v.indexOf("bash")>=0?k.sendText("clear"):N.$i?k.sendText("cls"):k.sendText("clear")));const T=(0,g.$mnc)(v,r.args,!!r.argsCanBeInterpretedByShell,P,r.env);k.sendText(T);const j=this.onDidTerminateDebugSession(z=>{z.id===c&&(this.nb.free(k),j.dispose())});return I}else if(r.kind==="external")return o(r,await this.P.getConfigProvider());return super.$runInTerminal(r,c)}};e.$nnc=i,e.$nnc=i=Je([Ve(0,A.$oP),Ve(1,w.$mlc),Ve(2,E.$3lc),Ve(3,a.$plc),Ve(4,D.$Nlc),Ve(5,m.$Blc),Ve(6,y.$6lc),Ve(7,n.$KP)],i);let u;function o(l,r){if(!u)if(N.$i)u=new R.$jcc;else if(N.$j)u=new R.$kcc;else if(N.$k)u=new R.$lcc;else throw new Error("external terminals not supported on this platform");const c=r.getConfiguration("terminal");return u.runInTerminal(l.title,l.cwd,l.args,l.env||{},c.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,c,s=!1){const f=[...this.b.entries()].map(([S,p])=>(0,d.$ih)(async k=>{if(S.name!==c||p.lastUsedAt!==-1&&await(0,g.$lnc)(await S.processId))return null;const P=Date.now();return p.lastUsedAt+t.a>P||k.isCancellationRequested?null:p.config!==r?(s&&S.dispose(),null):(p.lastUsedAt=P,S)}));return await(0,d.$Ah)(f,S=>!!S)}insert(r,c){this.b.set(r,{lastUsedAt:Date.now(),config:c})}free(r){const c=this.b.get(r);c&&(c.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(ke[382],Pe([1,0,17,2,105,44,73,45,42,43,20,28,95,15,11,91,23,64,61]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=void 0;let i=class extends $.$Rmc{constructor(o,t,l,r,c,s,v,f,S){super(o,t,l,r,c,s,v,f),this.C=l,this.D=S,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,t){const l=t;if(!t.execution&&l._id===void 0)throw new Error("Tasks to execute must include an execution");if(l._id!==void 0){const r=$.TaskHandleDTO.from(l,this.C),c=await this.a.$getTaskExecution(r);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.z(c,t);return this.a.$executeTask(r).catch(()=>{}),s}else{const r=$.TaskDTO.from(t,o);if(r===void 0)return Promise.reject(new Error("Task is not valid"));$.CustomExecutionDTO.is(r.execution)&&await this.y(r,t,!1);const c=await this.z(await this.a.$getTaskExecution(r),t);return this.a.$executeTask(r).catch(()=>{}),c}}v(o,t,l,r){const c=[];if(r)for(const s of r){this.A(s,l),(!s.definition||!o[s.definition.type])&&this.f.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const v=$.TaskDTO.from(s,l.extension);v&&(c.push(v),$.CustomExecutionDTO.is(v.execution)&&t.push(this.y(v,s,!0)))}return{tasks:c,extension:l.extension}}async w(o){return o}async G(o){let t=o&&o.length>0?o[0]:void 0;if(!t){const l=N.URI.file((0,a.homedir)());t=new m.$Pi({uri:l,name:g.$6g(l),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,t){const l=N.URI.revive(o),r={process:void 0,variables:Object.create(null)},c=await this.b.resolveWorkspaceFolder(l),s=await this.b.getWorkspaceFolders2()??[],v=await this.D.getResolver(),f=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(s);for(const S of t.variables)r.variables[S]=await v.resolveAsync(f,S);if(t.process!==void 0){let S;if(t.process.path!==void 0){S=t.process.path.split(d.$uc);for(let p=0;p<S.length;p++)S[p]=await v.resolveAsync(f,S[p])}r.process=await L.win32.findExecutable(await v.resolveAsync(f,t.process.name),t.process.cwd!==void 0?await v.resolveAsync(f,t.process.cwd):void 0,S)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(o,t,l){return L.win32.findExecutable(o,t,l)}};e.$fnc=i,e.$fnc=i=Je([Ve(0,A.$oP),Ve(1,D.$EP),Ve(2,R.$mlc),Ve(3,M.$zP),Ve(4,b.$plc),Ve(5,E.$Nlc),Ve(6,w.$2j),Ve(7,h.$3kc),Ve(8,n.$6lc)],i)}),define(ke[383],Pe([1,0,64,61]),function(le,e,d,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnc=void 0;class L extends N.$7lc{m(){return(0,d.homedir)()}}e.$Xnc=L}),define(ke[160],Pe([1,0,19,7,22,47,15,17,23,2,37]),function(le,e,d,N,L,R,M,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=e.$omc=e.$nmc=void 0,e.$pmc=h;class D{constructor(n,i,u){this.d=n,this.e=i,this.f=u,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const u=this.g.folderQueries||[],o=new L.$pe(i);return new Promise((t,l)=>{this.a=new y(n);let r=!1;const c=(s,v)=>{if(!r&&!this.b){const f=this.h(s);h(s)&&typeof this.g.maxResults=="number"&&this.c+f>this.g.maxResults&&(this.b=!0,r=!0,o.cancel(),s=this.j(s,this.g.maxResults-this.c));const S=this.h(s);this.c+=S,(S>0||!h(s))&&this.a.add(s,v)}};Promise.all(u.map((s,v)=>this.k(s,f=>c(f,v),o.token))).then(s=>{o.dispose(),this.a.flush();const v=s.some(f=>!!f&&!!f.limitHit);t({limitHit:this.b||v,messages:(0,d.$Rb)(s.map(f=>f?.message?Array.isArray(f.message)?f.message:[f.message]:[])),stats:{type:this.f}})},s=>{o.dispose();const v=(0,R.$gj)(s);l(new Error(v))})})}h(n){return h(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const u=Array.isArray(n.ranges)?n.ranges:[n.ranges],o=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:u.slice(0,i),preview:{matches:o.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,u){const o=new A.$vL(this.g,n),t=[],l={report:s=>{if(!this.l(s))return;const v=n.folder.scheme===M.Schemas.file?(0,A.$wL)(()=>this.e.readdir(m.$8g(s.uri))):void 0,f=m.$$g(n.folder,s.uri);if(f){const S=o.includedInQuery(f,b.$oc(f),v);(0,N.$hh)(S)?t.push(S.then(p=>{p&&i(s)})):S&&i(s)}}},r=this.n(n);let c;return this.d.query.type===3?c=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,r,l,u):c=await this.d.provider.provideTextSearchResults($(this.d.query.contentPattern),r,l,u),t.length&&await Promise.all(t),c}l(n){if(h(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,A.$uL)(this.g.includePattern,n.includePattern),u=(0,A.$uL)(this.g.excludePattern,n.excludePattern),o={folder:E.URI.from(n.folder),excludes:u,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(o.usePCRE2=this.g.usePCRE2),o}}e.$nmc=D;function $(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class y{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new g(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!m.$2g(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(w(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$omc=y;function w(a){return h(a)?{preview:{matches:(0,d.$2b)(a.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:a.preview.text},ranges:(0,d.$2b)(a.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function h(a){return!!a.preview}class g{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$qmc=g}),define(ke[97],Pe([1,0,3,6,5,376,20,68,11,2,160]),function(le,e,d,N,L,R,M,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=void 0,e.$tmc=$,e.$rmc=(0,L.$vi)("IExtHostSearch");let D=class{constructor(h,g,a){this.n=h,this.o=g,this.q=a,this.c=this.n.getProxy(N.$1M.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$mmc}s(h){return this.o.transformOutgoingScheme(h)}registerTextSearchProvider(h,g){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const a=this.d++;return this.e.set(a,g),this.c.$registerTextSearchProvider(a,this.s(h)),(0,d.$Tc)(()=>{this.g.delete(h),this.e.delete(a),this.c.$unregisterProvider(a)})}registerAITextSearchProvider(h,g){if(this.i.has(h))throw new Error(`an AI text search provider for the scheme '${h}'is already registered`);this.i.add(h);const a=this.d++;return this.h.set(a,g),this.c.$registerAITextSearchProvider(a,this.s(h)),(0,d.$Tc)(()=>{this.i.delete(h),this.h.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(h,g){if(this.k.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.k.add(h);const a=this.d++;return this.j.set(a,g),this.c.$registerFileSearchProvider(a,this.s(h)),(0,d.$Tc)(()=>{this.k.delete(h),this.j.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(h,g,a,n){const i=$(a),u=this.j.get(h);if(u)return this.l.fileSearch(i,u,o=>{this.c.$handleFileMatch(h,g,o.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+h)}async doInternalFileSearchWithCustomCallback(h,g,a){return{messages:[]}}$clearCache(h){return this.l.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,g,a,n){const i=this.e.get(h);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${h}`);const u=$(a);return this.t(u,i).search(t=>this.c.$handleTextMatch(h,g,t),n)}$provideAITextSearchResults(h,g,a,n){const i=this.h.get(h);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${h}`);const u=$(a);return this.v(u,i).search(t=>this.c.$handleTextMatch(h,g,t),n)}$enableExtensionHostSearch(){}t(h,g){return new A.$nmc({query:h,provider:g},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}v(h,g){return new A.$nmc({query:h,provider:g},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.$smc=D,e.$smc=D=Je([Ve(0,M.$oP),Ve(1,b.$jlc),Ve(2,m.$2j)],D);function $(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(y),extraFileResources:w.extraFileResources&&w.extraFileResources.map(h=>E.URI.revive(h))}}function y(w){return{...w,folder:E.URI.revive(w.folder)}}}),define(ke[384],Pe([1,0,22,13,4,3,15,41,2,136,203,184,80,25,33,11,86,87,283,6,329,355,91,121,333,334,335,316,305,34,336,45,337,96,152,338,318,330,339,340,73,72,331,49,341,70,342,60,28,356,357,319,343,122,344,116,117,320,375,346,288,347,358,348,158,321,349,350,351,20,352,97,118,353,322,354,119,93,95,90,43,156,359,360,332,361,362,71,16,8,323,68,324,92,363,364,151,44,298,115,26,94]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i,u,o,t,l,r,c,s,v,f,S,p,k,P,C,I,T,j,z,O,F,B,Z,q,Q,x,X,ie,me,ue,ve,te,U,ee,pe,Ce,se,re,oe,K,ne,$e,be,Ae,fe,Se,Ie,ze,V,W,J,Y,he,we,je,qe,Ye,st,tt,nt,ot,De,Be,Ge,Ne,Ze,ae,ce,Re,Ke,Me,it,lt,bt,Ot,Rt,sn,Zt,Dt,Xt,xt,et,on){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=qt;function qt(dt){const wt=dt.get(ue.$EP),en=dt.get(me.$7kc),Jt=dt.get(X.$rlc),Ft=dt.get(Q.$3lc),gt=dt.get(Dt.$mlc),Bt=dt.get(ot.$IP),Ht=dt.get(k.$plc),Gt=dt.get(lt.$jlc),xe=dt.get(J.$oP),dn=dt.get(st.$Klc),Qt=dt.get(tt.$slc),zt=dt.get(h.$3j),mt=dt.get(h.$2j),Ut=dt.get(Re.$jDb),It=dt.get(t.$3kc),Tt=dt.get(Zt.$9mc),tn=dt.get(we.$Ulc),Wt=dt.get(Z.$Blc),nn=dt.get(re.$Ylc),Mt=dt.get(l.$alc),Lt=dt.get(pe.$Rlc);xe.set(i.$2M.ExtHostFileSystemInfo,en),xe.set(i.$2M.ExtHostLogLevelServiceShape,zt),xe.set(i.$2M.ExtHostWorkspace,gt),xe.set(i.$2M.ExtHostConfiguration,Ht),xe.set(i.$2M.ExtHostExtensionService,Ft),xe.set(i.$2M.ExtHostStorage,dn),xe.set(i.$2M.ExtHostTunnelService,Ut),xe.set(i.$2M.ExtHostWindow,Tt),xe.set(i.$2M.ExtHostSecretState,tn),xe.set(i.$2M.ExtHostTelemetry,Bt),xe.set(i.$2M.ExtHostEditorTabs,Wt),xe.set(i.$2M.ExtHostManagedSockets,nn),xe.set(i.$2M.ExtHostAuthentication,Mt),xe.set(i.$2M.ExtHostChatProvider,Lt);const Nt=xe.set(i.$2M.ExtHostDecorations,dt.get(I.$bmc)),Ct=xe.set(i.$2M.ExtHostDocumentsAndEditors,dt.get(B.$zP)),$t=xe.set(i.$2M.ExtHostCommands,dt.get(S.$KP)),kt=xe.set(i.$2M.ExtHostTerminalService,dt.get(De.$Nlc)),rn=xe.set(i.$2M.ExtHostTerminalShellIntegration,dt.get(Be.$Umc)),Pt=xe.set(i.$2M.ExtHostDebugService,dt.get(C.$8lc)),mn=xe.set(i.$2M.ExtHostSearch,dt.get(he.$rmc)),_t=xe.set(i.$2M.ExtHostTask,dt.get(nt.$Tmc)),wn=xe.set(i.$2M.ExtHostOutputService,dt.get(Se.$Gmc)),un=xe.set(i.$2M.ExtHostLocalization,dt.get(se.$Xlc)),vn=xe.set(i.$2M.ExtHostUrls,new bt.$6mc(xe)),St=xe.set(i.$2M.ExtHostDocuments,new F.$0kc(xe,Ct)),Dn=xe.set(i.$2M.ExtHostDocumentContentProviders,new z.$dmc(xe,Ct,mt)),Le=xe.set(i.$2M.ExtHostDocumentSaveParticipant,new O.$emc(mt,St,xe.getProxy(i.$1M.MainThreadBulkEdits))),Te=xe.set(i.$2M.ExtHostNotebook,new K.$umc(xe,$t,Ct,St,Jt,mn)),Ee=xe.set(i.$2M.ExtHostNotebookDocuments,new $e.$Amc(Te)),_=xe.set(i.$2M.ExtHostNotebookEditors,new be.$Bmc(mt,Te)),Fe=xe.set(i.$2M.ExtHostNotebookKernels,new Ae.$Cmc(xe,wt,Te,$t,mt)),He=xe.set(i.$2M.ExtHostNotebookRenderers,new fe.$Emc(xe,Te)),_e=xe.set(i.$2M.ExtHostNotebookDocumentSaveParticipant,new ne.$zmc(mt,Te,xe.getProxy(i.$1M.MainThreadBulkEdits))),Qe=xe.set(i.$2M.ExtHostEditors,new Ne.$glc(xe,Ct)),ht=xe.set(i.$2M.ExtHostTreeViews,new ce.$4mc(xe.getProxy(i.$1M.MainThreadTreeViews),$t,mt)),Et=xe.set(i.$2M.ExtHostEditorInsets,new f.$hlc(xe.getProxy(i.$1M.MainThreadEditorInsets),Qe,wt.remote)),jt=xe.set(i.$2M.ExtHostDiagnostics,new T.$9kc(xe,mt,en,Ct)),Vt=xe.set(i.$2M.ExtHostLanguages,new Ce.$xmc(xe,St,$t.converter,Gt)),ut=xe.set(i.$2M.ExtHostLanguageFeatures,new ee.$$kc(xe,Gt,St,$t,jt,mt,It,Bt)),Yt=xe.set(i.$2M.ExtHostFileSystem,new x.$gmc(xe,ut)),$n=xe.set(i.$2M.ExtHostFileSystemEventService,new ie.$hmc(xe,mt,Ct)),kn=xe.set(i.$2M.ExtHostQuickOpen,(0,W.$Kmc)(xe,gt,$t)),Cn=xe.set(i.$2M.ExtHostSCM,new Y.$Mmc(xe,$t,St,mt)),Gn=xe.set(i.$2M.ExtHostQuickDiff,new V.$Jmc(xe,Gt)),On=xe.set(i.$2M.ExtHostShare,new je.$Nmc(xe,Gt)),Fn=xe.set(i.$2M.ExtHostComments,(0,p.$ilc)(xe,$t,St)),In=xe.set(i.$2M.ExtHostProgress,new ze.$Imc(xe.getProxy(i.$1M.MainThreadProgress))),Tn=xe.set(i.$2M.ExtHostLabelService,new U.$wmc(xe)),jn=xe.set(i.$2M.ExtHostTheming,new Ze.$1mc(xe)),ui=xe.set(i.$2M.ExtHostTimeline,new ae.$3mc(xe,$t)),An=xe.set(i.$2M.ExtHostWebviews,new Ot.$wlc(xe,wt.remote,gt,mt,It)),Pn=xe.set(i.$2M.ExtHostWebviewPanels,new Rt.$zlc(xe,An,gt)),zn=xe.set(i.$2M.ExtHostCustomEditors,new P.$Alc(xe,St,Qt,An,Pn)),Kn=xe.set(i.$2M.ExtHostWebviewViews,new sn.$7mc(xe,An)),yn=xe.set(i.$2M.ExtHostTesting,new Ge.$Wmc(xe,mt,$t,Ct)),Jn=xe.set(i.$2M.ExtHostUriOpeners,new it.$5mc(xe)),Qn=xe.set(i.$2M.ExtHostProfileContentHandlers,new Ie.$Hmc(xe));xe.set(i.$2M.ExtHostInteractive,new te.$vmc(xe,Te,Ct,$t,mt));const Yn=xe.set(i.$2M.ExtHostInlineChat,new ve.$imc(xe,$t,St,mt)),Rn=xe.set(i.$2M.ExtHostChatAgents2,new c.$dlc(xe,mt,$t)),li=xe.set(i.$2M.ExtHostChatVariables,new s.$elc(xe)),Zn=xe.set(i.$2M.ExtHostAiRelatedInformation,new u.$2kc(xe)),Bn=xe.set(i.$2M.ExtHostAiEmbeddingVector,new q.$fmc(xe)),Mn=xe.set(i.$2M.ExtHostStatusBar,new Ye.$Qmc(xe,$t.converter)),hi=xe.set(i.$2M.ExtHostSpeech,new qe.$Omc(xe)),di=Object.values(i.$2M);xe.assertRegistered(di);const Xn=new r.$clc(xe,Ct),fi=new v.$flc(xe),Sn=new oe.$ymc(xe,mt),Un=new j.$cmc(xe);return o.$_kc.register($t),function(We,ln,xn){function at(de){return(ye,Ue,ct)=>{const yt=de(At=>{try{ye.call(Ue,At)}catch(En){N.$2(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event: ${En.toString()}`,{cause:En})),Bt.onExtensionError(We.identifier,En)}});return ct?.push(yt),yt}}const vt=function(){let de=!We.isUnderDevelopment;function ye(){de||(mt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),de=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")ye();else{const yt=ct;typeof yt.scheme>"u"&&ye(),typeof yt.exclusive=="boolean"&&(0,et.$GG)(We,"documentFiltersExclusive")}return ct}}(),fn={getSession(de,ye,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,et.$GG)(We,"authLearnMore"),Mt.getSession(We,de,ye,Ue)},getSessions(de,ye){return(0,et.$GG)(We,"authGetSessions"),Mt.getSessions(We,de,ye)},async hasSession(de,ye){return(0,et.$GG)(We,"authSession"),!!await Mt.getSession(We,de,ye,{silent:!0})},get onDidChangeSessions(){return at(Mt.onDidChangeSessions)},registerAuthenticationProvider(de,ye,Ue,ct){return Mt.registerAuthenticationProvider(de,ye,Ue,ct)}},Ln={registerCommand(de,ye,Ue){return $t.registerCommand(!0,de,ye,Ue,void 0,We)},registerTextEditorCommand(de,ye,Ue){return $t.registerCommand(!0,de,(...ct)=>{const yt=Qe.getActiveTextEditor();if(!yt){mt.warn("Cannot execute "+de+" because there is no active text editor.");return}return yt.edit(At=>{ye.apply(Ue,[yt,At,...ct])}).then(At=>{At||mt.warn("Edits from command "+de+" were not applied.")},At=>{mt.warn("An error occurred while running command "+de,At)})},void 0,void 0,We)},registerDiffInformationCommand:(de,ye,Ue)=>((0,et.$GG)(We,"diffCommand"),$t.registerCommand(!0,de,async(...ct)=>{const yt=Ct.activeEditor(!0);if(!yt){mt.warn("Cannot execute "+de+" because there is no active text editor.");return}const At=await Qe.getDiffInformation(yt.id);ye.apply(Ue,[At,...ct])},void 0,void 0,We)),executeCommand(de,...ye){return $t.executeCommand(de,...ye)},getCommands(de=!1){return $t.getCommands(de)}},_n={get machineId(){return wt.telemetryInfo.machineId},get sessionId(){return wt.telemetryInfo.sessionId},get language(){return wt.environment.appLanguage},get appName(){return wt.environment.appName},get appRoot(){return wt.environment.appRoot?.fsPath??""},get appHost(){return wt.environment.appHost},get uriScheme(){return wt.environment.appUriScheme},get clipboard(){return fi.value},get shell(){return kt.getDefaultShell(!1)},get onDidChangeShell(){return at(kt.onDidChangeShell)},get isTelemetryEnabled(){return Bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return at(Bt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$GG)(We,"telemetry"),Bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$GG)(We,"telemetry"),at(Bt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ot.$HP)(wt.telemetryInfo.firstSessionDate)},createTelemetryLogger(de,ye){return ot.$GP.validateSender(de),Bt.instantiateLogger(We,de,ye)},openExternal(de,ye){return Tt.openUri(de,{allowTunneling:!!wt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(de){if(de.scheme===wt.environment.appUriScheme)return vn.createAppUri(de);try{return await Tt.asExternalUri(de,{allowTunneling:!!wt.remote.authority})}catch(ye){if((0,M.$Eg)(de,M.Schemas.http)||(0,M.$Eg)(de,M.Schemas.https))return de;throw ye}},get remoteName(){return(0,g.$Hm)(wt.remote.authority)},get remoteAuthority(){return(0,et.$GG)(We,"resolvers"),wt.remote.authority},get uiKind(){return wt.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return at(mt.onDidChangeLogLevel)},get appQuality(){return(0,et.$GG)(We,"resolvers"),wt.quality},get appCommit(){return(0,et.$GG)(We,"resolvers"),wt.commit}};wt.environment.extensionTestsLocationURI||Object.freeze(_n);const an={createTestController(de,ye,Ue){return yn.createTestController(We,de,ye,Ue)},createTestObserver(){return(0,et.$GG)(We,"testObserver"),yn.createTestObserver()},runTests(de){return(0,et.$GG)(We,"testObserver"),yn.runTests(de)},get onDidChangeTestResults(){return(0,et.$GG)(We,"testObserver"),at(yn.onResultsChanged)},get testResults(){return(0,et.$GG)(We,"testObserver"),yn.results}},pn=wt.remote.isRemote?Me.ExtensionKind.Workspace:Me.ExtensionKind.UI,ei={getExtension(de,ye){(0,et.$FG)(We,"extensionsAny")||(ye=!1);const Ue=ln.mine.getExtensionDescription(de);if(Ue)return new Q.$4lc(Ft,We.identifier,Ue,pn,!1);if(ye){const ct=ln.all.getExtensionDescription(de);if(ct)return new Q.$4lc(Ft,We.identifier,ct,pn,!0)}},get all(){const de=[];for(const ye of ln.mine.getAllExtensionDescriptions())de.push(new Q.$4lc(Ft,We.identifier,ye,pn,!1));return de},get allAcrossExtensionHosts(){(0,et.$GG)(We,"extensionsAny");const de=new y.$Rm(ln.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ye=[];for(const Ue of ln.all.getAllExtensionDescriptions()){const ct=!de.has(Ue.identifier);ye.push(new Q.$4lc(Ft,We.identifier,Ue,pn,ct))}return ye},get onDidChange(){return(0,et.$FG)(We,"extensionsAny")?at(L.Event.any(ln.mine.onDidChange,ln.all.onDidChange)):at(ln.mine.onDidChange)}},ti={createDiagnosticCollection(de){return jt.createDiagnosticCollection(We.identifier,de)},get onDidChangeDiagnostics(){return at(jt.onDidChangeDiagnostics)},getDiagnostics:de=>jt.getDiagnostics(de),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(de,ye){return Vt.changeLanguage(de.uri,ye)},match(de,ye){const Ue=Ke.LanguageSelector.from(de);let ct;return(0,A.$5t)(Ue)&&(ct=Te.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(At=>At.document===ye))?.apiNotebook),(0,A.$4t)(Ue,ye.uri,ye.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(de,ye,Ue){return ut.registerCodeActionProvider(We,vt(de),ye,Ue)},registerDocumentPasteEditProvider(de,ye,Ue){return(0,et.$GG)(We,"documentPaste"),ut.registerDocumentPasteEditProvider(We,vt(de),ye,Ue)},registerCodeLensProvider(de,ye){return ut.registerCodeLensProvider(We,vt(de),ye)},registerDefinitionProvider(de,ye){return ut.registerDefinitionProvider(We,vt(de),ye)},registerDeclarationProvider(de,ye){return ut.registerDeclarationProvider(We,vt(de),ye)},registerImplementationProvider(de,ye){return ut.registerImplementationProvider(We,vt(de),ye)},registerTypeDefinitionProvider(de,ye){return ut.registerTypeDefinitionProvider(We,vt(de),ye)},registerHoverProvider(de,ye){return ut.registerHoverProvider(We,vt(de),ye,We.identifier)},registerEvaluatableExpressionProvider(de,ye){return ut.registerEvaluatableExpressionProvider(We,vt(de),ye,We.identifier)},registerInlineValuesProvider(de,ye){return ut.registerInlineValuesProvider(We,vt(de),ye,We.identifier)},registerDocumentHighlightProvider(de,ye){return ut.registerDocumentHighlightProvider(We,vt(de),ye)},registerMultiDocumentHighlightProvider(de,ye){return ut.registerMultiDocumentHighlightProvider(We,vt(de),ye)},registerLinkedEditingRangeProvider(de,ye){return ut.registerLinkedEditingRangeProvider(We,vt(de),ye)},registerReferenceProvider(de,ye){return ut.registerReferenceProvider(We,vt(de),ye)},registerRenameProvider(de,ye){return ut.registerRenameProvider(We,vt(de),ye)},registerNewSymbolNamesProvider(de,ye){return(0,et.$GG)(We,"newSymbolNamesProvider"),ut.registerNewSymbolNamesProvider(We,vt(de),ye)},registerDocumentSymbolProvider(de,ye,Ue){return ut.registerDocumentSymbolProvider(We,vt(de),ye,Ue)},registerWorkspaceSymbolProvider(de){return ut.registerWorkspaceSymbolProvider(We,de)},registerDocumentFormattingEditProvider(de,ye){return ut.registerDocumentFormattingEditProvider(We,vt(de),ye)},registerDocumentRangeFormattingEditProvider(de,ye){return ut.registerDocumentRangeFormattingEditProvider(We,vt(de),ye)},registerOnTypeFormattingEditProvider(de,ye,Ue,...ct){return ut.registerOnTypeFormattingEditProvider(We,vt(de),ye,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(de,ye,Ue){return ut.registerDocumentSemanticTokensProvider(We,vt(de),ye,Ue)},registerDocumentRangeSemanticTokensProvider(de,ye,Ue){return ut.registerDocumentRangeSemanticTokensProvider(We,vt(de),ye,Ue)},registerSignatureHelpProvider(de,ye,Ue,...ct){return typeof Ue=="object"?ut.registerSignatureHelpProvider(We,vt(de),ye,Ue):ut.registerSignatureHelpProvider(We,vt(de),ye,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(de,ye,...Ue){return ut.registerCompletionItemProvider(We,vt(de),ye,Ue)},registerInlineCompletionItemProvider(de,ye,Ue){return ye.handleDidShowCompletionItem&&(0,et.$GG)(We,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,et.$GG)(We,"inlineCompletionsAdditions"),Ue&&(0,et.$GG)(We,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(We,vt(de),ye,Ue)},registerInlineEditProvider(de,ye){return(0,et.$GG)(We,"inlineEdit"),ut.registerInlineEditProvider(We,vt(de),ye)},registerDocumentLinkProvider(de,ye){return ut.registerDocumentLinkProvider(We,vt(de),ye)},registerColorProvider(de,ye){return ut.registerColorProvider(We,vt(de),ye)},registerFoldingRangeProvider(de,ye){return ut.registerFoldingRangeProvider(We,vt(de),ye)},registerSelectionRangeProvider(de,ye){return ut.registerSelectionRangeProvider(We,de,ye)},registerCallHierarchyProvider(de,ye){return ut.registerCallHierarchyProvider(We,de,ye)},registerTypeHierarchyProvider(de,ye){return ut.registerTypeHierarchyProvider(We,de,ye)},setLanguageConfiguration:(de,ye)=>ut.setLanguageConfiguration(We,de,ye),getTokenInformationAtPosition(de,ye){return(0,et.$GG)(We,"tokenInformation"),Vt.tokenAtPosition(de,ye)},registerInlayHintsProvider(de,ye){return ut.registerInlayHintsProvider(We,de,ye)},createLanguageStatusItem(de,ye){return Vt.createLanguageStatusItem(We,de,ye)},registerDocumentDropEditProvider(de,ye,Ue){return ut.registerDocumentOnDropEditProvider(We,de,ye,(0,et.$FG)(We,"documentPaste")?Ue:void 0)}},ni={get activeTextEditor(){return Qe.getActiveTextEditor()},get visibleTextEditors(){return Qe.getVisibleTextEditors()},get activeTerminal(){return kt.activeTerminal},get terminals(){return kt.terminals},async showTextDocument(de,ye,Ue){m.URI.isUri(de)&&de.scheme===M.Schemas.vscodeRemote&&!de.authority&&It.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await(m.URI.isUri(de)?Promise.resolve(Wn.openTextDocument(de)):Promise.resolve(de));return Qe.showTextDocument(ct,ye,Ue)},createTextEditorDecorationType(de){return Qe.createTextEditorDecorationType(We,de)},onDidChangeActiveTextEditor(de,ye,Ue){return at(Qe.onDidChangeActiveTextEditor)(de,ye,Ue)},onDidChangeVisibleTextEditors(de,ye,Ue){return at(Qe.onDidChangeVisibleTextEditors)(de,ye,Ue)},onDidChangeTextEditorSelection(de,ye,Ue){return at(Qe.onDidChangeTextEditorSelection)(de,ye,Ue)},onDidChangeTextEditorOptions(de,ye,Ue){return at(Qe.onDidChangeTextEditorOptions)(de,ye,Ue)},onDidChangeTextEditorVisibleRanges(de,ye,Ue){return at(Qe.onDidChangeTextEditorVisibleRanges)(de,ye,Ue)},onDidChangeTextEditorViewColumn(de,ye,Ue){return at(Qe.onDidChangeTextEditorViewColumn)(de,ye,Ue)},onDidCloseTerminal(de,ye,Ue){return at(kt.onDidCloseTerminal)(de,ye,Ue)},onDidOpenTerminal(de,ye,Ue){return at(kt.onDidOpenTerminal)(de,ye,Ue)},onDidChangeActiveTerminal(de,ye,Ue){return at(kt.onDidChangeActiveTerminal)(de,ye,Ue)},onDidChangeTerminalDimensions(de,ye,Ue){return(0,et.$GG)(We,"terminalDimensions"),at(kt.onDidChangeTerminalDimensions)(de,ye,Ue)},onDidChangeTerminalState(de,ye,Ue){return at(kt.onDidChangeTerminalState)(de,ye,Ue)},onDidWriteTerminalData(de,ye,Ue){return(0,et.$GG)(We,"terminalDataWriteEvent"),at(kt.onDidWriteTerminalData)(de,ye,Ue)},onDidExecuteTerminalCommand(de,ye,Ue){return(0,et.$GG)(We,"terminalExecuteCommandEvent"),at(kt.onDidExecuteTerminalCommand)(de,ye,Ue)},onDidChangeTerminalShellIntegration(de,ye,Ue){return(0,et.$GG)(We,"terminalShellIntegration"),at(rn.onDidChangeTerminalShellIntegration)(de,ye,Ue)},onDidStartTerminalShellExecution(de,ye,Ue){return(0,et.$GG)(We,"terminalShellIntegration"),at(rn.onDidStartTerminalShellExecution)(de,ye,Ue)},onDidEndTerminalShellExecution(de,ye,Ue){return(0,et.$GG)(We,"terminalShellIntegration"),at(rn.onDidEndTerminalShellExecution)(de,ye,Ue)},get state(){return Tt.getState()},onDidChangeWindowState(de,ye,Ue){return at(Tt.onDidChangeWindowState)(de,ye,Ue)},showInformationMessage(de,...ye){return Sn.showMessage(We,b.default.Info,de,ye[0],ye.slice(1))},showWarningMessage(de,...ye){return Sn.showMessage(We,b.default.Warning,de,ye[0],ye.slice(1))},showErrorMessage(de,...ye){return Sn.showMessage(We,b.default.Error,de,ye[0],ye.slice(1))},showQuickPick(de,ye,Ue){return kn.showQuickPick(We,de,ye,Ue)},showWorkspaceFolderPick(de){return kn.showWorkspaceFolderPick(de)},showInputBox(de,ye){return kn.showInput(de,ye)},showOpenDialog(de){return Un.showOpenDialog(We,de)},showSaveDialog(de){return Un.showSaveDialog(de)},createStatusBarItem(de,ye,Ue){let ct,yt,At;return typeof de=="string"?(ct=de,yt=ye,At=Ue):(yt=de,At=ye),Mn.createStatusBarEntry(We,ct,yt,At)},setStatusBarMessage(de,ye){return Mn.setStatusBarMessage(de,ye)},withScmProgress(de){return It.report("window.withScmProgress",We,"Use 'withProgress' instead."),In.withProgress(We,{location:Me.ProgressLocation.SourceControl},(ye,Ue)=>de({report(ct){}}))},withProgress(de,ye){return In.withProgress(We,de,ye)},createOutputChannel(de,ye){return wn.createOutputChannel(de,ye,We)},createWebviewPanel(de,ye,Ue,ct){return Pn.createWebviewPanel(We,de,ye,Ue,ct)},createWebviewTextEditorInset(de,ye,Ue,ct){return(0,et.$GG)(We,"editorInsets"),Et.createWebviewEditorInset(de,ye,Ue,ct,We)},createTerminal(de,ye,Ue){return typeof de=="object"?"pty"in de?kt.createExtensionTerminal(de):kt.createTerminalFromOptions(de):kt.createTerminal(de,ye,Ue)},registerTerminalLinkProvider(de){return kt.registerLinkProvider(de)},registerTerminalProfileProvider(de,ye){return kt.registerProfileProvider(We,de,ye)},registerTerminalQuickFixProvider(de,ye){return(0,et.$GG)(We,"terminalQuickFixProvider"),kt.registerTerminalQuickFixProvider(de,We.identifier.value,ye)},registerTreeDataProvider(de,ye){return ht.registerTreeDataProvider(de,ye,We)},createTreeView(de,ye){return ht.createTreeView(de,ye,We)},registerWebviewPanelSerializer:(de,ye)=>Pn.registerWebviewPanelSerializer(We,de,ye),registerCustomEditorProvider:(de,ye,Ue={})=>zn.registerCustomEditorProvider(We,de,ye,Ue),registerFileDecorationProvider(de){return Nt.registerFileDecorationProvider(de,We)},registerUriHandler(de){return vn.registerUriHandler(We,de)},createQuickPick(){return kn.createQuickPick(We)},createInputBox(){return kn.createInputBox(We)},get activeColorTheme(){return jn.activeColorTheme},onDidChangeActiveColorTheme(de,ye,Ue){return at(jn.onDidChangeActiveColorTheme)(de,ye,Ue)},registerWebviewViewProvider(de,ye,Ue){return Kn.registerWebviewViewProvider(We,de,ye,Ue?.webviewOptions)},get activeNotebookEditor(){return Te.activeNotebookEditor},onDidChangeActiveNotebookEditor(de,ye,Ue){return at(Te.onDidChangeActiveNotebookEditor)(de,ye,Ue)},get visibleNotebookEditors(){return Te.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return at(Te.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(de,ye,Ue){return at(_.onDidChangeNotebookEditorSelection)(de,ye,Ue)},onDidChangeNotebookEditorVisibleRanges(de,ye,Ue){return at(_.onDidChangeNotebookEditorVisibleRanges)(de,ye,Ue)},showNotebookDocument(de,ye){return Te.showNotebookDocument(de,ye)},registerExternalUriOpener(de,ye,Ue){return(0,et.$GG)(We,"externalUriOpener"),Jn.registerExternalUriOpener(We.identifier,de,ye,Ue)},registerProfileContentHandler(de,ye){return(0,et.$GG)(We,"profileContentHandlers"),Qn.registerProfileContentHandler(We,de,ye)},registerQuickDiffProvider(de,ye,Ue,ct){return(0,et.$GG)(We,"quickDiffProvider"),Gn.registerQuickDiffProvider(vt(de),ye,Ue,ct)},get tabGroups(){return Wt.tabGroups},registerShareProvider(de,ye){return(0,et.$GG)(We,"shareProvider"),On.registerShareProvider(vt(de),ye)}},Wn={get rootPath(){return It.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(de){throw new N.$9("rootPath")},getWorkspaceFolder(de){return gt.getWorkspaceFolder(de)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(de){throw new N.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(de){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(de,ye,...Ue)=>gt.updateWorkspaceFolders(We,de,ye||0,...Ue),onDidChangeWorkspaceFolders:function(de,ye,Ue){return at(gt.onDidChangeWorkspace)(de,ye,Ue)},asRelativePath:(de,ye)=>gt.getRelativePath(de,ye),findFiles:(de,ye,Ue,ct)=>gt.findFiles(de,ye,Ue,We.identifier,ct),findFiles2:(de,ye,Ue)=>((0,et.$GG)(We,"findFiles2"),gt.findFiles2(de,ye,We.identifier,Ue)),findTextInFiles:(de,ye,Ue,ct)=>{(0,et.$GG)(We,"findTextInFiles");let yt,At;return typeof ye=="object"?(yt=ye,At=Ue):(yt={},At=ye,ct=Ue),gt.findTextInFiles(de,yt||{},At,We.identifier,ct)},save:de=>gt.save(de),saveAs:de=>gt.saveAs(de),saveAll:de=>gt.saveAll(de),applyEdit(de,ye){return Xn.applyWorkspaceEdit(de,We,ye)},createFileSystemWatcher:(de,ye,Ue,ct)=>{let yt;return typeof ye=="boolean"?yt={ignoreCreateEvents:!!ye,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:ye&&((0,et.$GG)(We,"createFileSystemWatcher"),yt={...ye,correlate:!0}),$n.createFileSystemWatcher(gt,We,de,yt)},get textDocuments(){return St.getAllDocumentData().map(de=>de.document)},set textDocuments(de){throw new N.$9("textDocuments")},openTextDocument(de){let ye;const Ue=de;if(typeof de=="string")ye=Promise.resolve(m.URI.file(de));else if(m.URI.isUri(de))ye=Promise.resolve(de);else if(!Ue||typeof Ue=="object")ye=St.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(ct=>(ct.scheme===M.Schemas.vscodeRemote&&!ct.authority&&It.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),St.ensureDocumentData(ct).then(yt=>yt.document)))},onDidOpenTextDocument:(de,ye,Ue)=>at(St.onDidAddDocument)(de,ye,Ue),onDidCloseTextDocument:(de,ye,Ue)=>at(St.onDidRemoveDocument)(de,ye,Ue),onDidChangeTextDocument:(de,ye,Ue)=>at(St.onDidChangeDocument)(de,ye,Ue),onDidSaveTextDocument:(de,ye,Ue)=>at(St.onDidSaveDocument)(de,ye,Ue),onWillSaveTextDocument:(de,ye,Ue)=>at(Le.getOnWillSaveTextDocumentEvent(We))(de,ye,Ue),get notebookDocuments(){return Te.notebookDocuments.map(de=>de.apiNotebook)},async openNotebookDocument(de,ye){let Ue;if(m.URI.isUri(de))Ue=de,await Te.openNotebookDocument(de);else if(typeof de=="string")Ue=m.URI.revive(await Te.createNotebookDocument({viewType:de,content:ye}));else throw new Error("Invalid arguments");return Te.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(de,ye,Ue){return at(Ee.onDidSaveNotebookDocument)(de,ye,Ue)},onDidChangeNotebookDocument(de,ye,Ue){return at(Ee.onDidChangeNotebookDocument)(de,ye,Ue)},onWillSaveNotebookDocument(de,ye,Ue){return at(_e.getOnWillSaveNotebookDocumentEvent(We))(de,ye,Ue)},get onDidOpenNotebookDocument(){return at(Te.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return at(Te.onDidCloseNotebookDocument)},registerNotebookSerializer(de,ye,Ue,ct){return Te.registerNotebookSerializer(We,de,ye,Ue,(0,et.$FG)(We,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(de,ye,Ue)=>at(xn.onDidChangeConfiguration)(de,ye,Ue),getConfiguration(de,ye){return ye=arguments.length===1?void 0:ye,xn.getConfiguration(de,ye,We)},registerTextDocumentContentProvider(de,ye){return Dn.registerTextDocumentContentProvider(de,ye)},registerTaskProvider:(de,ye)=>(It.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(We,de,ye)),registerFileSystemProvider(de,ye,Ue){return(0,R.$Sc)(Yt.registerFileSystemProvider(We,de,ye,Ue),Jt.addFileSystemProvider(de,ye,Ue))},get fs(){return Jt.value},registerFileSearchProvider:(de,ye)=>((0,et.$GG)(We,"fileSearchProvider"),mn.registerFileSearchProvider(de,ye)),registerTextSearchProvider:(de,ye)=>((0,et.$GG)(We,"textSearchProvider"),mn.registerTextSearchProvider(de,ye)),registerAITextSearchProvider:(de,ye)=>((0,et.$GG)(We,"aiTextSearchProvider"),(0,et.$GG)(We,"textSearchProvider"),mn.registerAITextSearchProvider(de,ye)),registerRemoteAuthorityResolver:(de,ye)=>((0,et.$GG)(We,"resolvers"),Ft.registerRemoteAuthorityResolver(de,ye)),registerResourceLabelFormatter:de=>((0,et.$GG)(We,"resolvers"),Tn.$registerResourceLabelFormatter(de)),getRemoteExecServer:de=>((0,et.$GG)(We,"resolvers"),Ft.getRemoteExecServer(de)),onDidCreateFiles:(de,ye,Ue)=>at($n.onDidCreateFile)(de,ye,Ue),onDidDeleteFiles:(de,ye,Ue)=>at($n.onDidDeleteFile)(de,ye,Ue),onDidRenameFiles:(de,ye,Ue)=>at($n.onDidRenameFile)(de,ye,Ue),onWillCreateFiles:(de,ye,Ue)=>at($n.getOnWillCreateFileEvent(We))(de,ye,Ue),onWillDeleteFiles:(de,ye,Ue)=>at($n.getOnWillDeleteFileEvent(We))(de,ye,Ue),onWillRenameFiles:(de,ye,Ue)=>at($n.getOnWillRenameFileEvent(We))(de,ye,Ue),openTunnel:de=>((0,et.$GG)(We,"tunnels"),Ut.openTunnel(We,de).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,et.$GG)(We,"tunnels"),Ut.getTunnels()},onDidChangeTunnels:(de,ye,Ue)=>((0,et.$GG)(We,"tunnels"),at(Ut.onDidChangeTunnels)(de,ye,Ue)),registerPortAttributesProvider:(de,ye)=>((0,et.$GG)(We,"portsAttributes"),Ut.registerPortsAttributesProvider(de,ye)),registerTunnelProvider:(de,ye)=>((0,et.$GG)(We,"tunnelFactory"),Ut.registerTunnelProvider(de,ye)),registerTimelineProvider:(de,ye)=>((0,et.$GG)(We,"timeline"),ui.registerTimelineProvider(de,ye,We.identifier,$t.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:de=>((0,et.$GG)(We,"workspaceTrust"),gt.requestWorkspaceTrust(de)),onDidGrantWorkspaceTrust:(de,ye,Ue)=>at(gt.onDidGrantWorkspaceTrust)(de,ye,Ue),registerEditSessionIdentityProvider:(de,ye)=>((0,et.$GG)(We,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(de,ye)),onWillCreateEditSessionIdentity:(de,ye,Ue)=>((0,et.$GG)(We,"editSessionIdentityProvider"),at(gt.getOnWillCreateEditSessionIdentityEvent(We))(de,ye,Ue)),registerCanonicalUriProvider:(de,ye)=>((0,et.$GG)(We,"canonicalUriProvider"),gt.registerCanonicalUriProvider(de,ye)),getCanonicalUri:(de,ye,Ue)=>((0,et.$GG)(We,"canonicalUriProvider"),gt.provideCanonicalUri(de,ye,Ue))},gi={get inputBox(){return It.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),Cn.getLastInputBox(We)},createSourceControl(de,ye,Ue){return Cn.createSourceControl(We,de,ye,Ue)}},ii={createCommentController(de,ye){return Fn.createCommentController(We,de,ye)}},ri={get activeDebugSession(){return Pt.activeDebugSession},get activeDebugConsole(){return Pt.activeDebugConsole},get breakpoints(){return Pt.breakpoints},get activeStackItem(){if((0,et.$FG)(We,"debugFocus"))return Pt.activeStackItem},registerDebugVisualizationProvider(de,ye){return(0,et.$GG)(We,"debugVisualization"),Pt.registerDebugVisualizationProvider(We,de,ye)},registerDebugVisualizationTreeProvider(de,ye){return(0,et.$GG)(We,"debugVisualization"),Pt.registerDebugVisualizationTree(We,de,ye)},onDidStartDebugSession(de,ye,Ue){return at(Pt.onDidStartDebugSession)(de,ye,Ue)},onDidTerminateDebugSession(de,ye,Ue){return at(Pt.onDidTerminateDebugSession)(de,ye,Ue)},onDidChangeActiveDebugSession(de,ye,Ue){return at(Pt.onDidChangeActiveDebugSession)(de,ye,Ue)},onDidReceiveDebugSessionCustomEvent(de,ye,Ue){return at(Pt.onDidReceiveDebugSessionCustomEvent)(de,ye,Ue)},onDidChangeBreakpoints(de,ye,Ue){return at(Pt.onDidChangeBreakpoints)(de,ye,Ue)},onDidChangeActiveStackItem(de,ye,Ue){return(0,et.$GG)(We,"debugFocus"),at(Pt.onDidChangeActiveStackItem)(de,ye,Ue)},registerDebugConfigurationProvider(de,ye,Ue){return Pt.registerDebugConfigurationProvider(de,ye,Ue||Xt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(de,ye){return Pt.registerDebugAdapterDescriptorFactory(We,de,ye)},registerDebugAdapterTrackerFactory(de,ye){return Pt.registerDebugAdapterTrackerFactory(de,ye)},startDebugging(de,ye,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Pt.startDebugging(de,ye,{parentSession:Ue}):Pt.startDebugging(de,ye,Ue||{})},stopDebugging(de){return Pt.stopDebugging(de)},addBreakpoints(de){return Pt.addBreakpoints(de)},removeBreakpoints(de){return Pt.removeBreakpoints(de)},asDebugSourceUri(de,ye){return Pt.asDebugSourceUri(de,ye)}},mi={registerTaskProvider:(de,ye)=>_t.registerTaskProvider(We,de,ye),fetchTasks:de=>_t.fetchTasks(de),executeTask:de=>_t.executeTask(We,de),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(de,ye,Ue)=>at(_t.onDidStartTask)(de,ye,Ue),onDidEndTask:(de,ye,Ue)=>at(_t.onDidEndTask)(de,ye,Ue),onDidStartTaskProcess:(de,ye,Ue)=>at(_t.onDidStartTaskProcess)(de,ye,Ue),onDidEndTaskProcess:(de,ye,Ue)=>at(_t.onDidEndTaskProcess)(de,ye,Ue)},$i={createNotebookController(de,ye,Ue,ct,yt){return Fe.createNotebookController(We,de,ye,Ue,ct,(0,et.$FG)(We,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(de,ye)=>Te.registerNotebookCellStatusBarItemProvider(We,de,ye),createRendererMessaging(de){return He.createRendererMessaging(We,de)},createNotebookControllerDetectionTask(de){return(0,et.$GG)(We,"notebookKernelSource"),Fe.createNotebookControllerDetectionTask(We,de)},registerKernelSourceActionProvider(de,ye){return(0,et.$GG)(We,"notebookKernelSource"),Fe.registerKernelSourceActionProvider(We,de,ye)},onDidChangeNotebookCellExecutionState(de,ye,Ue){return(0,et.$GG)(We,"notebookCellExecutionState"),at(Fe.onDidChangeNotebookCellExecutionState)(de,ye,Ue)}},si={t(...de){if(typeof de[0]=="string"){const ye=de.shift(),Ue=!de||typeof de[0]!="object"?de:de[0];return un.getMessage(We.identifier.value,{message:ye,args:Ue})}return un.getMessage(We.identifier.value,de[0])},get bundle(){return un.getBundle(We.identifier.value)},get uri(){return un.getBundleUri(We.identifier.value)}},Vn={_version:1,registerInteractiveEditorSessionProvider(de,ye){return(0,et.$GG)(We,"interactive"),Yn.registerProvider(We,de,ye)},transferActiveChat(de){return(0,et.$GG)(We,"interactive"),Rn.transferActiveChat(de)}},oi={getRelatedInformation(de,ye){return(0,et.$GG)(We,"aiRelatedInformation"),Zn.getRelatedInformation(We,de,ye)},registerRelatedInformationProvider(de,ye){return(0,et.$GG)(We,"aiRelatedInformation"),Zn.registerRelatedInformationProvider(We,de,ye)},registerEmbeddingVectorProvider(de,ye){return(0,et.$GG)(We,"aiRelatedInformation"),Bn.registerEmbeddingVectorProvider(We,de,ye)}},ai={registerChatResponseProvider(de,ye,Ue){return(0,et.$GG)(We,"chatProvider"),Lt.registerLanguageModel(We,de,ye,Ue)},registerChatVariableResolver(de,ye,Ue){return(0,et.$GG)(We,"chatVariableResolver"),li.registerVariableResolver(We,de,ye,Ue)},registerMappedEditsProvider(de,ye){return(0,et.$GG)(We,"mappedEditsProvider"),ut.registerMappedEditsProvider(We,de,ye)},createChatParticipant(de,ye){return(0,et.$GG)(We,"chatParticipant"),Rn.createChatAgent(We,de,ye)},createDynamicChatParticipant(de,ye,Ue,ct){return(0,et.$GG)(We,"chatParticipantAdditions"),Rn.createDynamicChatAgent(We,de,ye,Ue,ct)}},ci={get languageModels(){return(0,et.$GG)(We,"languageModels"),Lt.getLanguageModelIds()},onDidChangeLanguageModels:(de,ye,Ue)=>((0,et.$GG)(We,"languageModels"),Lt.onDidChangeProviders(de,ye,Ue)),sendChatRequest(de,ye,Ue,ct){return(0,et.$GG)(We,"languageModels"),Lt.sendChatRequest(We,de,ye,Ue,ct)},computeTokenLength(de,ye,Ue){return(0,et.$GG)(We,"languageModels"),Ue??=d.CancellationToken.None,Lt.computeTokenLength(de,ye,Ue)},getLanguageModelInformation(de){return(0,et.$GG)(We,"languageModels"),Lt.getLanguageModelInfo(de)}},pi={registerSpeechProvider(de,ye){return(0,et.$GG)(We,"speech"),hi.registerProvider(We.identifier,de,ye)}};return{version:wt.version,ai:oi,authentication:fn,commands:Ln,comments:ii,chat:ai,debug:ri,env:_n,extensions:ei,interactive:Vn,l10n:si,languages:ti,lm:ci,notebooks:$i,scm:gi,speech:pi,tasks:mi,tests:an,window:ni,workspace:Wn,Breakpoint:Me.$4N,TerminalOutputAnchor:Me.TerminalOutputAnchor,ChatResultFeedbackKind:Me.ChatResultFeedbackKind,ChatVariableLevel:Me.ChatVariableLevel,ChatCompletionItem:Me.$YO,CallHierarchyIncomingCall:Me.$pN,CallHierarchyItem:Me.$oN,CallHierarchyOutgoingCall:Me.$qN,CancellationError:N.$5,CancellationTokenSource:d.$pe,CandidatePortSource:i.CandidatePortSource,CodeAction:Me.$lN,CodeActionKind:Me.$mN,CodeActionTriggerKind:Me.CodeActionTriggerKind,CodeLens:Me.$rN,Color:Me.$EN,ColorInformation:Me.$FN,ColorPresentation:Me.$GN,ColorThemeKind:Me.ColorThemeKind,CommentMode:Me.CommentMode,CommentState:Me.CommentState,CommentThreadCollapsibleState:Me.CommentThreadCollapsibleState,CommentThreadState:Me.CommentThreadState,CommentThreadApplicability:Me.CommentThreadApplicability,CompletionItem:Me.$yN,CompletionItemKind:Me.CompletionItemKind,CompletionItemTag:Me.CompletionItemTag,CompletionList:Me.$zN,CompletionTriggerKind:Me.CompletionTriggerKind,ConfigurationTarget:Me.ConfigurationTarget,CustomExecution:Me.$ON,DebugAdapterExecutable:Me.$8N,DebugAdapterInlineImplementation:Me.$$N,DebugAdapterNamedPipeServer:Me.$0N,DebugAdapterServer:Me.$9N,DebugConfigurationProviderTriggerKind:Xt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Me.DebugConsoleMode,DebugVisualization:Me.$oO,DecorationRangeBehavior:Me.DecorationRangeBehavior,Diagnostic:Me.$eN,DiagnosticRelatedInformation:Me.$dN,DiagnosticSeverity:Me.DiagnosticSeverity,DiagnosticTag:Me.DiagnosticTag,Disposable:Me.$3M,DocumentHighlight:Me.$hN,DocumentHighlightKind:Me.DocumentHighlightKind,MultiDocumentHighlight:Me.$iN,DocumentLink:Me.$DN,DocumentSymbol:Me.$kN,EndOfLine:Me.EndOfLine,EnvironmentVariableMutatorType:Me.EnvironmentVariableMutatorType,EvaluatableExpression:Me.$bO,InlineValueText:Me.$cO,InlineValueVariableLookup:Me.$dO,InlineValueEvaluatableExpression:Me.$eO,InlineCompletionTriggerKind:Me.InlineCompletionTriggerKind,EventEmitter:L.$ee,ExtensionKind:Me.ExtensionKind,ExtensionMode:Me.ExtensionMode,ExternalUriOpenerPriority:Me.ExternalUriOpenerPriority,FileChangeType:Me.FileChangeType,FileDecoration:Me.$qO,FileDecoration2:Me.$qO,FileSystemError:Me.$hO,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:Me.$iO,FoldingRangeKind:Me.FoldingRangeKind,FunctionBreakpoint:Me.$6N,InlineCompletionItem:Me.$AN,InlineCompletionList:Me.$BN,Hover:Me.$fN,VerboseHover:Me.$gN,HoverVerbosityAction:Me.HoverVerbosityAction,IndentAction:D.IndentAction,Location:Me.$cN,MarkdownString:Me.$sN,OverviewRulerLane:$.OverviewRulerLane,ParameterInformation:Me.$tN,PortAutoForwardAction:Me.PortAutoForwardAction,Position:Me.$4M,ProcessExecution:Me.$MN,ProgressLocation:Me.ProgressLocation,QuickInputButtons:Me.$pO,Range:Me.$5M,RelativePattern:Me.$2N,Selection:Me.$6M,SelectionRange:Me.$nN,SemanticTokens:Me.$lO,SemanticTokensBuilder:Me.$kO,SemanticTokensEdit:Me.$mO,SemanticTokensEdits:Me.$nO,SemanticTokensLegend:Me.$jO,ShellExecution:Me.$NN,ShellQuoting:Me.ShellQuoting,SignatureHelp:Me.$vN,SignatureHelpTriggerKind:Me.SignatureHelpTriggerKind,SignatureInformation:Me.$uN,SnippetString:Me.$bN,SourceBreakpoint:Me.$5N,StandardTokenType:Me.StandardTokenType,StatusBarAlignment:Me.StatusBarAlignment,SymbolInformation:Me.$jN,SymbolKind:Me.SymbolKind,SymbolTag:Me.SymbolTag,Task:Me.$PN,TaskGroup:Me.$LN,TaskPanelKind:Me.TaskPanelKind,TaskRevealKind:Me.TaskRevealKind,TaskScope:Me.TaskScope,TerminalLink:Me.$HN,TerminalQuickFixTerminalCommand:Me.$JN,TerminalQuickFixOpener:Me.$IN,TerminalLocation:Me.TerminalLocation,TerminalProfile:Me.$KN,TerminalExitReason:Me.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Me.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Me.TextDocumentSaveReason,TextEdit:Me.$0M,SnippetTextEdit:Me.$_M,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:Me.TextEditorLineNumbersStyle,TextEditorRevealType:Me.TextEditorRevealType,TextEditorSelectionChangeKind:Me.TextEditorSelectionChangeKind,SyntaxTokenType:Me.SyntaxTokenType,TextDocumentChangeReason:Me.TextDocumentChangeReason,ThemeColor:Me.$1N,ThemeIcon:Me.$ZN,TreeItem:Me.$QN,TreeItemCheckboxState:Me.TreeItemCheckboxState,TreeItemCollapsibleState:Me.TreeItemCollapsibleState,TypeHierarchyItem:Me.$MO,UIKind:xt.UIKind,Uri:m.URI,ViewColumn:Me.ViewColumn,WorkspaceEdit:Me.$aN,DocumentPasteTriggerKind:Me.DocumentPasteTriggerKind,DocumentDropEdit:Me.$WN,DocumentDropOrPasteEditKind:Me.$XN,DocumentPasteEdit:Me.$YN,InlayHint:Me.$xN,InlayHintLabelPart:Me.$wN,InlayHintKind:Me.InlayHintKind,RemoteAuthorityResolverError:Me.$9M,ResolvedAuthority:Me.$7M,ManagedResolvedAuthority:Me.$8M,SourceControlInputBoxValidationType:Me.SourceControlInputBoxValidationType,ExtensionRuntime:Me.ExtensionRuntime,TimelineItem:Me.$AO,NotebookRange:Me.$sO,NotebookCellKind:Me.NotebookCellKind,NotebookCellExecutionState:Me.NotebookCellExecutionState,NotebookCellData:Me.$tO,NotebookData:Me.$uO,NotebookRendererScript:Me.$yO,NotebookCellStatusBarAlignment:Me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Me.NotebookEditorRevealType,NotebookCellOutput:Me.$wO,NotebookCellOutputItem:Me.$vO,NotebookCellStatusBarItem:Me.$xO,NotebookControllerAffinity:Me.NotebookControllerAffinity,NotebookControllerAffinity2:Me.NotebookControllerAffinity2,NotebookEdit:Me.$$M,NotebookKernelSourceAction:Me.$zO,NotebookVariablesRequestKind:Me.NotebookVariablesRequestKind,PortAttributes:Me.$CO,LinkedEditingRanges:Me.$BO,TestResultState:Me.TestResultState,TestRunRequest:Me.$DO,TestRunRequest2:Me.$DO,TestMessage:Me.$EO,TestTag:Me.$FO,TestRunProfileKind:Me.TestRunProfileKind,TextSearchCompleteMessageType:on.TextSearchCompleteMessageType,DataTransfer:Me.$VN,DataTransferItem:Me.$RN,TestCoverageCount:Me.$GO,FileCoverage:Me.$IO,StatementCoverage:Me.$JO,BranchCoverage:Me.$KO,DeclarationCoverage:Me.$LO,WorkspaceTrustState:Me.WorkspaceTrustState,LanguageStatusSeverity:Me.LanguageStatusSeverity,QuickPickItemKind:Me.QuickPickItemKind,InputBoxValidationSeverity:Me.InputBoxValidationSeverity,TabInputText:Me.$NO,TabInputTextDiff:Me.$OO,TabInputTextMerge:Me.$PO,TabInputCustom:Me.$QO,TabInputNotebook:Me.$SO,TabInputNotebookDiff:Me.$TO,TabInputWebview:Me.$RO,TabInputTerminal:Me.$UO,TabInputInteractiveWindow:Me.$VO,TabInputChat:Me.$WO,TabInputTextMultiDiff:Me.$XO,TelemetryTrustedValue:a.$ep,LogLevel:h.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Me.InteractiveSessionVoteDirection,ChatCopyKind:Me.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Me.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Me.$_N,DebugThread:Me.$aO,RelatedInformationType:Me.RelatedInformationType,SpeechToTextStatus:Me.SpeechToTextStatus,PartialAcceptTriggerKind:Me.PartialAcceptTriggerKind,KeywordRecognitionStatus:Me.KeywordRecognitionStatus,ChatResponseMarkdownPart:Me.$ZO,ChatResponseFileTreePart:Me.$3O,ChatResponseAnchorPart:Me.$4O,ChatResponseProgressPart:Me.$5O,ChatResponseReferencePart:Me.$7O,ChatResponseTextEditPart:Me.$8O,ChatResponseMarkdownWithVulnerabilitiesPart:Me.$1O,ChatResponseCommandButtonPart:Me.$6O,ChatResponseDetectedParticipantPart:Me.$2O,ChatRequestTurn:Me.$9O,ChatResponseTurn:Me.$0O,ChatLocation:Me.ChatLocation,LanguageModelChatSystemMessage:Me.$$O,LanguageModelChatUserMessage:Me.$_O,LanguageModelChatAssistantMessage:Me.$aP,LanguageModelSystemMessage:Me.$$O,LanguageModelUserMessage:Me.$_O,LanguageModelAssistantMessage:Me.$aP,LanguageModelError:Me.$bP,NewSymbolName:Me.$gO,NewSymbolNameTag:Me.NewSymbolNameTag,InlineEdit:Me.$cP,InlineEditTriggerKind:Me.InlineEditTriggerKind}}}}),define(ke[385],Pe([1,0,85,158,44,152,45,34,73,43,95,96,97,119,71,91,151,70,60,118,90,72,150,11,61,116,117,121,122,156]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i,u,o,t,l,r,c,s,v,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.$ws)(c.$Xlc,c.$Wlc,1),(0,d.$ws)(l.$3j,t.$$mc,1),(0,d.$ws)(h.$3kc,h.$4kc,1),(0,d.$ws)(b.$KP,b.$JP,0),(0,d.$ws)(v.$alc,v.$blc,0),(0,d.$ws)(f.$Rlc,f.$Slc,0),(0,d.$ws)(M.$plc,M.$nlc,0),(0,d.$ws)(a.$rlc,a.$qlc,0),(0,d.$ws)(D.$8lc,D.$_lc,0),(0,d.$ws)(R.$bmc,R.$amc,0),(0,d.$ws)(m.$zP,m.$yP,0),(0,d.$ws)(s.$Ylc,s.$Zlc,0),(0,d.$ws)(n.$7kc,n.$6kc,0),(0,d.$ws)(N.$Gmc,N.$Fmc,1),(0,d.$ws)($.$rmc,$.$smc,0),(0,d.$ws)(y.$Klc,y.$Jlc,0),(0,d.$ws)(A.$Tmc,A.$Smc,0),(0,d.$ws)(E.$Nlc,E.$Qlc,0),(0,d.$ws)(S.$Umc,S.$Vmc,0),(0,d.$ws)(w.$jDb,w.$kDb,0),(0,d.$ws)(g.$9mc,g.$8mc,0),(0,d.$ws)(L.$mlc,L.$llc,0),(0,d.$ws)(i.$Ulc,i.$Tlc,0),(0,d.$ws)(u.$IP,u.$FP,0),(0,d.$ws)(o.$Blc,o.$Clc,0),(0,d.$ws)(r.$6lc,r.$7lc,0)}),define(ke[123],Pe([1,0,19,11,37,94]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=void 0,e.$onc=M,e.$pnc=b;function M(D){return D.startsWith("**")||D.startsWith("/")?D:`/${D}`}function b(D,$,y,w){const h=(0,d.$2b)(y,m),g=new L.$hL($,h,w),a=g.preview.matches;return{ranges:(0,d.$2b)(h,E),uri:D,preview:{text:g.preview.text,matches:(0,d.$2b)(a,E)}}}function m(D){return new L.$iL(D.start.line,D.start.character,D.end.line,D.end.character)}function E(D){return new R.$9K(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn)}let A=class{constructor($,y){this.a=$,this.b=y}appendLine($){this.b.debug(`${this.a}#search`,$)}};e.$qnc=A,e.$qnc=A=Je([Ve(1,N.$2j)],A)}),define(ke[386],Pe([1,0,53,17,77,31,12,14,123,387]),function(le,e,d,N,L,R,M,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=D,e.$snc=g,e.$tnc=n;const A=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function D(i,u,o,t){const l=$(i,u,o,t),r=u.folder.fsPath;return{cmd:d.spawn(A,l.args,{cwd:r}),rgDiskPath:A,siblingClauses:l.siblingClauses,rgArgs:l,cwd:r}}function $(i,u,o,t){const l=["--files","--hidden","--case-sensitive","--no-require-git"];w([u],o,!1).forEach(c=>{const s=(0,m.$onc)(c);if(l.push("-g",s),M.$j){const v=(0,L.$bm)(s);v!==s&&l.push("-g",v)}});const r=y([u],t,void 0,!1);return r.globArgs.forEach(c=>{const s=`!${(0,m.$onc)(c)}`;if(l.push("-g",s),M.$j){const v=(0,L.$bm)(s);v!==s&&l.push("-g",v)}}),u.disregardIgnoreFiles!==!1?l.push("--no-ignore"):u.disregardParentIgnoreFiles!==!1&&l.push("--no-ignore-parent"),u.ignoreSymlinks||l.push("--follow"),i.exists&&l.push("--quiet"),l.push("--no-config"),u.disregardGlobalIgnoreFiles&&l.push("--no-ignore-global"),{args:l,siblingClauses:r.siblingClauses}}function y(i,u,o,t=!0){const l=[];let r={};return i.forEach(c=>{const s=Object.assign({},c.excludePattern||{},u||{}),v=h(s,t?c.folder.fsPath:void 0,o);l.push(...v.globArgs),v.siblingClauses&&(r=Object.assign(r,v.siblingClauses))}),{globArgs:l,siblingClauses:r}}function w(i,u,o=!0){const t=[];return i.forEach(l=>{const r=Object.assign({},u||{},l.includePattern||{}),c=h(r,o?l.folder.fsPath:void 0);t.push(...c.globArgs)}),t}function h(i,u,o){const t=[],l={};return Object.keys(i).forEach(r=>{if(o&&o.has(r)||!r)return;const c=i[r];r=a(u?g(u,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof c=="boolean"&&c?(r.startsWith("\\\\")&&(r+="**"),t.push(n(r))):c&&c.when&&(l[r]=c)}),{globArgs:t,siblingClauses:l}}function g(i,u){return N.$jc(u)?u:N.$kc(i,u)}function a(i){return i=b.$ff(i,"\\"),b.$ff(i,"/")}function n(i){return R.$qg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[388],Pe([1,0,53,52,17,389,19,47,35,77,31,12,40,14,18,32,37,386,133]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=e.$unc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(r=>r())});class u{constructor(c){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=c,this.b=c.filePattern||"",this.d=c.includePattern&&m.$pk(c.includePattern),this.f=c.maxResults||null,this.g=!!c.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=c.shouldGlobMatchFilePattern?null:(0,n.$wr)(this.b).normalizedLowercase),this.u=c.excludePattern&&m.$pk(c.excludePattern),this.t=new Map,c.folderQueries.forEach(s=>{const v=Object.assign({},s.excludePattern||{},this.a.excludePattern||{}),f=s.folder.fsPath;c.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==f).forEach(S=>{(0,A.$ug)(S,f)&&(v[L.$mc(f,S)]=!0)}),this.t.set(f,new t(v,f))})}cancel(){this.l=!0,i.forEach(c=>c())}walk(c,s,v,f,S){if(this.m=$.$ae.create(!1),this.l)return S(null,this.j);s.forEach(p=>{const k=L.$oc(p.fsPath);this.u&&this.u(p.fsPath,k)||this.J(v,{relativePath:p.fsPath,searchPath:void 0})}),this.r=$.$ae.create(!1),this.w(c,(p,k)=>{this.x(this.y,this,p,v,f,P=>{if(P){const C=(0,b.$gj)(P);console.error(C),this.q.push(C),k(P,void 0)}else k(null,void 0)})},(p,k)=>{this.m.stop();const P=p?M.$Hb(p)[0]:null;S(P,this.j)})}w(c,s,v){const f=new Array(c.length),S=new Array(c.length);let p=!1,k=0;if(c.length===0)return v(null,[]);c.forEach((P,C)=>{s(P,(I,T)=>{if(I?(p=!0,f[C]=null,S[C]=I):(f[C]=T,S[C]=null),++k===c.length)return v(p?S:null,f)})})}x(c,s,...v){try{c.apply(s,v)}catch(f){v[v.length-1](f)}}y(c,s,v,f){const S=c.folder.fsPath,p=D.$j,k=()=>j&&j.kill();i.add(k);let P=B=>{i.delete(k),P=()=>{},f(B)},C="";const I=this.D(),T=(0,a.$rnc)(this.a,c,this.a.includePattern,this.t.get(c.folder.fsPath).expression),j=T.cmd,z=!Object.keys(T.siblingClauses).length,O=T.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let F=`${T.rgDiskPath} ${O}
 - cwd: ${T.cwd}`;T.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(T.rgArgs.siblingClauses)}`),v({message:F}),this.s=0,this.z(j,"utf8",v,(B,Z,q)=>{if(B){P(B);return}if(this.j){P();return}const x=(C+(p?E.$am(Z||""):Z)).split(`
`);if(q){const X=x.length;x[X-1]=x[X-1].trim(),x[X-1]||x.pop()}else C=x.pop()||"";if(x.length&&x[0].indexOf(`
`)!==-1){P(new Error("Splitting up files failed"));return}if(this.s+=x.length,z){for(const X of x)if(this.J(s,{base:S,relativePath:X,searchPath:this.N(c,X)}),this.j){k();break}(q||this.j)&&P();return}this.G(c,I,S,x,s),q&&(this.H(I,S,s),P())})}spawnFindCmd(c){const s=this.t.get(c.folder.fsPath),v=s.getBasenameTerms(),f=s.getPathTerms(),S=["-L","."];if(v.length||f.length){S.push("-not","(","(");for(const p of v)S.push("-name",p),S.push("-o");for(const p of f)S.push("-path",p),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),d.spawn("find",S,{cwd:c.folder.fsPath})}readStdout(c,s,v){let f="";this.z(c,s,()=>{},(S,p,k)=>{if(S){v(S);return}f+=p,k&&v(null,f)})}z(c,s,v,f){let S=(P,C,I)=>{(P||I)&&(S=()=>{},this.r?.stop()),f(P,C,I)},p=!1;c.stdout?(this.A(c.stdout,s,S),c.stdout.once("data",()=>p=!0)):v({message:"stdout is null"});let k;c.stderr?k=this.B(c.stderr):v({message:"stderr is null"}),c.on("error",P=>{S(P)}),c.on("close",P=>{let C;!p&&(C=this.C(k,s))&&l(C)?S(new Error(`command failed with error code ${P}: ${this.C(k,s)}`)):(this.g&&P===0&&(this.j=!0),S(null,"",!0))})}A(c,s,v){const f=new R.StringDecoder(s);return c.on("data",S=>{v(null,f.write(S))}),f}B(c){const s=[];return c.on("data",v=>{s.push(v)}),s}C(c,s){const v=new R.StringDecoder(s);return c.map(f=>v.write(f)).join("")}D(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}G(c,{pathToEntries:s},v,f,S){f.indexOf(this.b)!==-1&&this.J(S,{base:v,relativePath:this.b,searchPath:this.N(c,this.b)});const p=k=>{const P=L.$oc(k),C=L.$nc(k);let I=s[C];I||(I=s[C]=[],p(C)),I.push({base:v,relativePath:k,basename:P,searchPath:this.N(c,k)})};f.forEach(p)}H({rootEntries:c,pathToEntries:s},v,f){const S=this,p=this.t.get(v),k=this.b;function P(C){S.o++;const I=(0,g.$xL)(()=>C.map(T=>T.basename));for(let T=0,j=C.length;T<j;T++){const z=C[T],{relativePath:O,basename:F}=z;if(p.test(O,F,k!==F?I:void 0))continue;const B=s[O];if(B)P(B);else{if(S.p++,O===k)continue;S.J(f,z)}if(S.j)break}}P(c)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(c,s,v,f,S){const p=c.folder,k=(0,g.$xL)(()=>v);this.w(v,(P,C)=>{if(this.l||this.j)return C(null);const I=s?[s,P].join(L.sep):P;if(this.t.get(c.folder.fsPath).test(I,P,this.a.filePattern!==P?k:void 0))return C(null);const T=[p.fsPath,I].join(L.sep);N.lstat(T,(j,z)=>{if(j||this.l||this.j)return C(null);this.L(T,z,(O,F)=>O||this.l||this.j?C(null):F.isDirectory()?(this.o++,this.M(T,z,(B,Z)=>B||this.l||this.j||(Z=Z||"",this.v[Z])?C(null):(this.v[Z]=!0,h.Promises.readdir(T).then(q=>{if(this.l||this.j)return C(null);this.I(c,I,q,f,Q=>C(Q||null))},q=>{C(null)})))):(this.p++,I===this.b||this.h&&w.$_f(F.size)&&F.size>this.h||this.J(f,{base:p.fsPath,relativePath:I,searchPath:this.N(c,I)}),C(null,void 0)))})},P=>{const C=P&&M.$Hb(P);return S(C&&C.length>0?C[0]:void 0)})}J(c,s){this.K(s)&&(!this.d||this.d(s.relativePath,L.$oc(s.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||c(s))}K(c){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.$sL)(c,this.c);if(this.b)return(0,g.$sL)(c,this.b,!1)}return!0}L(c,s,v){return s.isSymbolicLink()?N.stat(c,v):v(null,s)}M(c,s,v){return s.isSymbolicLink()?N.realpath(c,(f,S)=>f?v(f):v(null,S)):v(null,c)}N(c,s){return c.folderName?L.$kc(c.folderName,s):s}}e.$unc=u;class o{constructor(c){this.a=c.folderQueries,this.b=c.extraFileResources||[],this.c=new u(c)}search(c,s,v){this.c.walk(this.a,this.b,c,s,(f,S)=>{v(f,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$vnc=o;class t{constructor(c,s){this.expression=c,this.c=s,this.d(c)}d(c){let s,v;Object.keys(c).filter(f=>c[f]).forEach(f=>{L.$jc(f)?(s=s||m.$kk(),s[f]=c[f]):(v=v||m.$kk(),v[f]=c[f])}),this.a=s&&m.$pk(s,{trimForExclusions:!0}),this.b=v&&m.$pk(v,{trimForExclusions:!0})}test(c,s,v){return this.b&&this.b(c,s,v)||this.a&&this.a(L.$kc(this.c,c),s,v)}getBasenameTerms(){const c=[];return this.a&&c.push(...m.$rk(this.a)),this.b&&c.push(...m.$rk(this.b)),c}getPathTerms(){const c=[];return this.a&&c.push(...m.$sk(this.a)),this.b&&c.push(...m.$sk(this.b)),c}}function l(r){const c=r.trim().split(`
`),s=c[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return y.$Zf(c[c.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}}),define(ke[390],Pe([1,0,98,21,198,22]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eE=e.$9D=e.DecodeStreamErrorKind=e.$8D=e.$7D=e.$6D=e.$4D=e.$3D=e.$2D=e.$1D=void 0,e.$5D=M,e.$0D=w,e.$$D=h,e.$_D=g,e.$aE=a,e.$bE=n,e.$cE=r,e.$dE=c,e.$1D="utf8",e.$2D="utf8bom",e.$3D="utf16be",e.$4D="utf16le";function M(s){return[e.$1D,e.$2D,e.$3D,e.$4D].some(v=>v===s)}e.$6D=[254,255],e.$7D=[255,254],e.$8D=[239,187,191];const b=512,m=512,E=512*8,A=512*128;var D;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(D||(e.DecodeStreamErrorKind=D={}));class $ extends Error{constructor(v,f){super(v),this.decodeStreamErrorKind=f}}e.$9D=$;class y{static async create(v){let f;if(v!==e.$1D)f=(await(0,L.$ZD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(a(v));else{const S=new TextDecoder;f={write(p){return S.decode(p,{stream:!0})},end(){return S.decode()}}}return new y(f)}constructor(v){this.a=v}write(v){return this.a.write(v)}end(){return this.a.end()}}function w(s,v){const f=v.minBytesRequiredForDetection??v.guessEncoding?E:m;return new Promise((S,p)=>{const k=(0,d.$te)(z=>z.join("")),P=[];let C=0,I;const T=new R.$pe,j=async()=>{try{const z=await c({buffer:N.$Fe.concat(P),bytesRead:C},v.guessEncoding);if(z.seemsBinary&&v.acceptTextOnly)throw new $("Stream is binary but only text is accepted for decoding",1);z.encoding=await v.overwriteEncoding(z.encoding),I=await y.create(z.encoding);const O=I.write(N.$Fe.concat(P).buffer);k.write(O),P.length=0,C=0,S({stream:k,detected:z})}catch(z){T.cancel(),k.destroy(),p(z)}};(0,d.$xe)(s,{onData:async z=>{I?k.write(I.write(z.buffer)):(P.push(z),C+=z.byteLength,C>=f&&(s.pause(),await j(),setTimeout(()=>s.resume())))},onError:z=>k.error(z),onEnd:async()=>{I||await j(),k.end(I?.end())}},T.token)})}async function h(s,v,f){const p=(await(0,L.$ZD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(a(v),f);let k=!1,P=!1;return{read(){if(P)return null;const C=s.read();if(typeof C!="string"){if(P=!0,!k&&f?.addBOM)switch(v){case e.$1D:case e.$2D:return N.$Fe.wrap(Uint8Array.from(e.$8D));case e.$3D:return N.$Fe.wrap(Uint8Array.from(e.$6D));case e.$4D:return N.$Fe.wrap(Uint8Array.from(e.$7D))}const I=p.end();return I&&I.length>0?(k=!0,N.$Fe.wrap(I)):null}return k=!0,N.$Fe.wrap(p.write(C))}}}async function g(s){return(await(0,L.$ZD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(a(s))}function a(s){return s===e.$2D||s===null?e.$1D:s}function n(s,v){if(!s||v<e.$6D.length)return null;const f=s.readUInt8(0),S=s.readUInt8(1);if(f===e.$6D[0]&&S===e.$6D[1])return e.$3D;if(f===e.$7D[0]&&S===e.$7D[1])return e.$4D;if(v<e.$8D.length)return null;const p=s.readUInt8(2);return f===e.$8D[0]&&S===e.$8D[1]&&p===e.$8D[2]?e.$2D:null}const i=["ascii","utf-16","utf-32"];async function u(s){const v=await(0,L.$ZD)("jschardet","dist/jschardet.min.js"),f=s.slice(0,A),S=l(f.buffer),p=v.detect(S);if(!p||!p.encoding)return null;const k=p.encoding.toLowerCase();return 0<=i.indexOf(k)?null:t(p.encoding)}const o={ibm866:"cp866",big5:"cp950"};function t(s){const v=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return o[v]||v}function l(s){let v="";for(let f=0;f<s.length;f++)v+=String.fromCharCode(s[f]);return v}function r(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const v=s.match(/windows(\d+)/);return v?"windows-"+v[1]:s}}}function c({buffer:s,bytesRead:v},f){let S=n(s,v),p=!1;if(S!==e.$3D&&S!==e.$4D&&s){let k=!0,P=!0,C=!1;for(let I=0;I<v&&I<b;I++){const T=I%2===1,j=s.readUInt8(I)===0;if(j&&(C=!0),k&&(T&&!j||!T&&j)&&(k=!1),P&&(T&&j||!T&&!j)&&(P=!1),j&&!k&&!P)break}C&&(k?S=e.$4D:P?S=e.$3D:p=!0)}return f&&!p&&!S&&s?u(s.slice(0,v)).then(k=>({seemsBinary:!1,encoding:k})):{seemsBinary:p,encoding:S}}e.$eE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[161],Pe([1,0,390,32,160]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dnc=void 0;class R extends L.$nmc{constructor(b,m,E=N,A="searchProcess"){super({query:b,provider:m},{readdir:D=>E.Promises.readdir(D.fsPath),toCanonicalName:D=>(0,d.$cE)(D)},A)}}e.$Dnc=R}),define(ke[162],Pe([1,0,53,406,389,19,74,35,14,2,37,94,407,387,123]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=e.$wnc=void 0,e.$ync=t,e.$znc=r,e.$Anc=s,e.$Bnc=v,e.$Cnc=S;const h=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(k){this.a=k}provideTextSearchResults(k,P,C,I){return this.a.appendLine(`provideTextSearchResults ${k.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((T,j)=>{I.onCancellationRequested(()=>x());const z=t(k,P),O=P.folder.fsPath,F=z.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.a.appendLine(`${h} ${F}
 - cwd: ${O}`);let B=d.spawn(h,z,{cwd:O});B.on("error",ve=>{console.error(ve),this.a.appendLine("Error: "+(ve&&ve.message)),j((0,A.$oL)(new A.$mL(ve&&ve.message,A.SearchErrorCode.rgProcessError)))});let Z=!1;const q=new i(P.maxResults,P.folder,P.previewOptions);q.on("result",ve=>{Z=!0,ie="",C.report(ve)});let Q=!1;const x=()=>{Q=!0,B?.kill(),q?.cancel()};let X=!1;q.on("hitLimit",()=>{X=!0,x()});let ie="";B.stdout.on("data",ve=>{q.handleData(ve),Z||(ie+=ve)});let me=!1;B.stdout.once("data",()=>me=!0);let ue="";B.stderr.on("data",ve=>{const te=ve.toString();this.a.appendLine(te),ue.length+te.length<1e6&&(ue+=te)}),B.on("close",()=>{if(this.a.appendLine(me?"Got data from stdout":"No data from stdout"),this.a.appendLine(Z?"Got result from parser":"No result from parser"),ie&&this.a.appendLine(`Got data without result: ${ie}`),this.a.appendLine(""),Q)T({limitHit:X});else{q.flush(),B=null;let ve;ue&&!me&&(ve=a(ue))?j((0,A.$oL)(new A.$mL(ve.message,ve.code))):T({limitHit:X})}})})}}e.$wnc=g;function a(p){const k=p.split(`
`),P=k[0].trim();if(k.some(I=>I.startsWith("regex parse error")))return new A.$mL(n(k),A.SearchErrorCode.regexParseError);const C=P.match(/grep config error: unknown encoding: (.*)/);if(C)return new A.$mL(`Unknown encoding: ${C[1]}`,A.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new A.$mL(P.charAt(0).toUpperCase()+P.substr(1),A.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new A.$mL(P.charAt(0).toUpperCase()+P.substr(1),A.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new A.$mL(P,A.SearchErrorCode.regexParseError)}function n(p){const k=["Regex parse error"],P=p.filter(C=>C.startsWith("PCRE2:"));if(P.length>=1){const C=P[0].replace("PCRE2:","");if(C.indexOf(":")!==-1&&C.split(":").length>=2){const I=C.split(":")[1];k.push(":"+I)}}return k.join("")}class i extends N.EventEmitter{constructor(k,P,C){super(),this.g=k,this.h=P,this.j=C,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new L.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(k,P){return super.on(k,P),this}handleData(k){if(this.b)return;const P=typeof k=="string"?k:this.d.write(k);this.k(P)}k(k){let P=k.indexOf(`
`);const C=this.a+k;if(P>=0)P+=this.a.length;else{this.a=C;return}let I=0;for(;P>=0;)this.m(C.substring(I,P).trim()),I=P+1,P=C.indexOf(`
`,I);this.a=C.substring(I)}m(k){if(this.b||!k)return;let P;try{P=JSON.parse(k)}catch{throw new Error(`malformed line from rg: ${k}`)}if(P.type==="match"){const C=u(P.data.path),I=E.URI.joinPath(this.h,C),T=this.n(P.data,I);this.p(T),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const C=u(P.data.path),I=E.URI.joinPath(this.h,C);this.o(P.data,I).forEach(j=>this.p(j))}}n(k,P){const C=k.line_number-1,I=u(k.lines),T=Buffer.from(I);let j=0,z=0,O=C;k.submatches.length===0&&k.submatches.push(I.length?{start:0,end:1,match:{text:I[0]}}:{start:0,end:0,match:{text:""}});const F=(0,R.$Hb)(k.submatches.map((B,Z)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const q=u(B.match),Q=T.slice(j,B.start).toString(),x=o(Q),X=x.numLines>0?x.lastLineLength:x.lastLineLength+z,ie=o(q),me=x.numLines+O,ue=ie.numLines+me,ve=ie.numLines>0?ie.lastLineLength:ie.lastLineLength+X;return j=B.end,z=ve,O=ue,new D.$9K(me,X,ue,ve)}));return(0,w.$pnc)(P,I,F,this.j)}o(k,P){const C=u(k.lines),I=k.line_number;return C.replace(/\r?\n$/,"").split(`
`).map((T,j)=>({text:T,uri:P,lineNumber:I+j}))}p(k){this.emit("result",k)}}e.$xnc=i;function u(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function o(p){const k=/\n/g;let P=0,C=-1,I;for(;I=k.exec(p);)P++,C=I.index;const T=C>=0?p.length-C-1:p.length;return{numLines:P,lastLineLength:T}}function t(p,k){const P=["--hidden","--no-require-git"];P.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:C,otherIncludes:I}=(0,M.$K)(k.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(I&&I.length){const j=new Set;I.forEach(z=>{j.add(z)}),P.push("-g","!*"),j.forEach(z=>{l(z).map(w.$onc).forEach(O=>{P.push("-g",O)})})}C&&C.length&&C.forEach(j=>{P.push("-g",j)}),k.excludes.map(w.$onc).forEach(j=>P.push("-g",`!${j}`)),k.maxFileSize&&P.push("--max-filesize",k.maxFileSize+""),k.useIgnoreFiles?k.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),k.followSymlinks&&P.push("--follow"),k.encoding&&k.encoding!=="utf8"&&P.push("--encoding",k.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,m.$_e)(p.pattern),p.isRegExp=!0),k.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),p.isRegExp&&(p.pattern=r(p.pattern),P.push("--engine","auto"));let T;if(p.isWordMatch){const z=(0,m.$if)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",z)}else if(p.isRegExp){let j=s(p.pattern);j=v(j),P.push("--regexp",j)}else T=p.pattern,P.push("--fixed-strings");return P.push("--no-config"),k.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),p.isMultiline&&P.push("--multiline"),k.beforeContext&&P.push("--before-context",k.beforeContext+""),k.afterContext&&P.push("--after-context",k.afterContext+""),P.push("--"),T&&P.push(T),P.push("."),P}function l(p){return S(p).flatMap(P=>{const C=(0,b.$nk)(P,"/");return C.map((I,T)=>C.slice(0,T+1).join("/"))})}function r(p){const k=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(k);)p=p.replace(k,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(P);)p=p.replace(P,"$1\\x{$2}");return p}const c=p=>p.type==="Assertion"&&p.kind==="lookbehind";function s(p){let k;try{k=new $.RegExpParser().parsePattern(p)}catch{return p}let P="",C=0;const I=(z,O,F)=>{P+=p.slice(C,z)+F,C=O},T=[];return new $.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const O=T[0];if(!O)I(z.start,z.end,"\\r?\\n");else if(!T.some(c))if(O.type==="CharacterClass")if(O.negate){const F=p.slice(O.start+2,z.start)+p.slice(z.end,O.end-1);O.parent?.type==="Quantifier"?I(O.start,O.end,F?`[^${F}]`:"."):I(O.start,O.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=p.slice(O.start+1,z.start)+p.slice(z.end,O.end-1);I(O.start,O.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else O.type==="Quantifier"&&I(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){T.unshift(z)},onQuantifierLeave(){T.shift()},onCharacterClassRangeEnter(z){T.unshift(z)},onCharacterClassRangeLeave(){T.shift()},onCharacterClassEnter(z){T.unshift(z)},onCharacterClassLeave(){T.shift()},onAssertionEnter(z){c(z)&&T.push(z)},onAssertionLeave(z){T[0]===z&&T.shift()}}).visit(k),P+=p.slice(C),P}function v(p){return p.replace(/\n/g,"\\r?\\n")}function f(p){let k=!1,P=!1,C="",I="";for(let T=0;T<p.length;T++){const j=p[T];switch(j){case"\\":P?(k?I+="\\"+j:C+="\\"+j,P=!1):P=!0;break;case"{":if(P)k?I+=j:C+=j,P=!1;else{if(k)return{strInBraces:C+"{"+I+"{"+p.substring(T+1)};k=!0}break;case"}":if(P)k?I+=j:C+=j,P=!1;else{if(k)return{fixedStart:C,strInBraces:I,fixedEnd:p.substring(T+1)};C+=j}break;default:k?I+=(P?"\\":"")+j:C+=(P?"\\":"")+j,P=!1;break}}return{strInBraces:C+(k?"{"+I:"")}}function S(p){const{fixedStart:k,strInBraces:P,fixedEnd:C}=f(p);if(k===void 0||C===void 0)return[P];let I=(0,b.$nk)(P,",");I.length||(I=[""]);const T=S(C);return I.flatMap(j=>{const z=k+j;return T.map(O=>z+O)})}}),define(ke[391],Pe([1,0,22,162,109,15]),function(le,e,d,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gnc=void 0;class M{constructor(E){this.b=E,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(E,A,D,$){const y=new N.$wnc(this.b);if(A.folder.scheme===R.Schemas.vscodeUserData){const w={...A,folder:A.folder.with({scheme:R.Schemas.file})},h=new L.$9v(g=>D.report({...g,uri:g.uri.with({scheme:A.folder.scheme})}));return this.c($,g=>y.provideTextSearchResults(E,w,h,g))}else return this.c($,w=>y.provideTextSearchResults(E,A,D,w))}async c(E,A){const D=b(E);this.a.add(D);const $=await A(D.token);return this.a.delete(D),$}d(){this.a.forEach(E=>E.cancel())}}e.$Gnc=M;function b(m){const E=new d.$pe;return m.onCancellationRequested(()=>E.cancel()),E}}),define(ke[392],Pe([1,0,32,162,161]),function(le,e,d,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=void 0;class R{constructor(m){this.a=m}search(m,E,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const D={appendLine(y){A({message:y})}},$=new L.$Dnc(this.a,new N.$wnc(D),d);return new Promise((y,w)=>$.search(h=>{E(h.map(M))},m).then(h=>y({limitHit:h.limitHit,type:"success",stats:h.stats}),w))}}e.$Enc=R;function M(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce((m,E)=>{if(E.ranges){const A=E;return m+(Array.isArray(A.ranges)?A.ranges.length:1)}else return m+1},0)}}}),define(ke[393],Pe([1,0,19,7,13,4,133,17,40,2,33,37,388,392]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnc=void 0;class w{static{this.a=512}constructor(u="searchProcess"){this.d=u,this.b=Object.create(null)}fileSearch(u){let o;const t=a(u),l=new R.$ee({onDidAddFirstListener:()=>{o=(0,N.$ih)(r=>this.doFileSearchWithEngine($.$vnc,t,c=>l.fire(c),r)),o.then(r=>l.fire(r),r=>l.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return l.event}textSearch(u){let o;const t=a(u),l=new R.$ee({onDidAddFirstListener:()=>{o=(0,N.$ih)(r=>this.f(t,c=>l.fire(c),r)),o.then(r=>l.fire(r),r=>l.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return l.event}f(u,o,t){return u.maxFileSize=this.g().maxFileSize,new y.$Enc(u).search(t,o,o)}g(){return{maxFileSize:16*A.$xl.GB}}doFileSearch(u,o,t){return this.doFileSearchWithEngine($.$vnc,u,o,t)}doFileSearchWithEngine(u,o,t,l,r=w.a){let c=0;const s=f=>{Array.isArray(f)?(c+=f.length,t(f.map(S=>this.h(S)))):f.relativePath?(c++,t(this.h(f))):t(f)};if(o.sortByScore){let f=this.l(o,s,l);if(!f){const S=o.maxResults?Object.assign({},o,{maxResults:null}):o,p=new u(S);f=this.j(p,o,t,s,l)}return new Promise((S,p)=>{f.then(([k,P])=>{const C=P.map(I=>this.h(I));this.o(C,t,r),S(k)},p)})}const v=new u(o);return this.r(v,s,r,l).then(f=>({limitHit:f.limitHit,type:"success",stats:{detailStats:f.stats,type:this.d,fromCache:!1,resultCount:c,sortingTime:void 0}}))}h(u){return{path:u.base?(0,b.$kc)(u.base,u.relativePath):u.relativePath}}j(u,o,t,l,r){const c=new R.$ee;let s=(0,N.$ih)(f=>{let S=[];const p=k=>{Array.isArray(k)?S=k:(l(k),c.fire(k))};return this.r(u,p,-1,f).then(k=>[k,S])}),v;if(o.cacheKey){v=this.k(o.cacheKey);const f={promise:s,event:c.event,resolved:!1};v.resultsToSearchCache[o.filePattern||""]=f,s.then(()=>{f.resolved=!0},S=>{delete v.resultsToSearchCache[o.filePattern||""]}),s=this.s(s)}return s.then(([f,S])=>{const p=v?v.scorerCache:Object.create(null),k=(typeof o.maxResults!="number"||o.maxResults>0)&&m.$ae.create(!1);return this.n(o,S,p,r).then(P=>{const C=k?k.elapsed():-1;return[{type:"success",stats:{detailStats:f.stats,sortingTime:C,fromCache:!1,type:this.d,workspaceFolderCount:o.folderQueries.length,resultCount:P.length},messages:f.messages,limitHit:f.limitHit||typeof o.maxResults=="number"&&S.length>o.maxResults},P]})})}k(u){const o=this.b[u];return o||(this.b[u]=new h)}l(u,o,t){const l=u.cacheKey&&this.b[u.cacheKey];if(!l)return;const r=this.q(l,u.filePattern||"",o,t);if(r)return r.then(([c,s,v])=>{const f=m.$ae.create(!1);return this.n(u,s,l.scorerCache,t).then(S=>{const p=f.elapsed(),k={fromCache:!0,detailStats:v,type:this.d,resultCount:s.length,sortingTime:p};return[{type:"success",limitHit:c.limitHit||typeof u.maxResults=="number"&&s.length>u.maxResults,stats:k},S]})})}n(u,o,t,l){const r=(0,M.$wr)(u.filePattern||""),c=(v,f)=>(0,M.$vr)(v,f,r,!0,g,t),s=typeof u.maxResults=="number"?u.maxResults:Number.MAX_VALUE;return d.$Gb(o,c,s,1e4,l)}o(u,o,t){if(t&&t>0)for(let l=0;l<u.length;l+=t)o(u.slice(l,l+t));else o(u)}q(u,o,t,l){const r=m.$ae.create(!1),c=o.indexOf(b.sep)>=0;let s;for(const p in u.resultsToSearchCache)if(o.startsWith(p)){if(c&&p.indexOf(b.sep)<0&&p!=="")continue;const k=u.resultsToSearchCache[p];s={promise:this.s(k.promise),event:k.event,resolved:k.resolved};break}if(!s)return null;const v=r.elapsed(),f=m.$ae.create(!1),S=s.event(t);return l&&l.onCancellationRequested(()=>{S.dispose()}),s.promise.then(([p,k])=>{if(l&&l.isCancellationRequested)throw(0,L.$6)();const P=[],C=(0,M.$wr)(o).normalizedLowercase;for(const I of k)(0,D.$sL)(I,C)&&P.push(I);return[p,P,{cacheWasResolved:s.resolved,cacheLookupTime:v,cacheFilterTime:f.elapsed(),cacheEntryCount:k.length}]})}r(u,o,t,l){return new Promise((r,c)=>{let s=[];l?.onCancellationRequested(()=>u.cancel()),u.search(v=>{v&&(t?(s.push(v),t>0&&s.length>=t&&(o(s),s=[])):o(v))},v=>{o(v)},(v,f)=>{s.length&&o(s),v?(o({message:"Search finished. Error: "+v.message}),c(v)):(o({message:"Search finished. Stats: "+JSON.stringify(f.stats)}),r(f))})})}clearCache(u){return delete this.b[u],Promise.resolve(void 0)}s(u){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(o,t){return u.then(o,t)}catch(o){return this.then(void 0,o)}finally(o){return u.finally(o)}}}}e.$Fnc=w;class h{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(i){return(0,b.$oc)(i.relativePath)}getItemDescription(i){return(0,b.$nc)(i.relativePath)}getItemPath(i){return i.relativePath}};function a(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(u=>E.URI.revive(u))}}function n(i){return{...i,folder:E.URI.revive(i.folder)}}}),define(ke[394],Pe([1,0,3,15,2,32,11,28,20,97,68,37,393,391,123,161]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=void 0;let g=class extends E.$smc{constructor(n,i,u,o){super(n,u,o),this.w=R,this.x=-1,this.y=null,this.z=!1,this.A=new d.$Uc;const t=new w.$qnc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new y.$Gnc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new w.$qnc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.file,new y.$Gnc(n))),this.A.add(this.C(N.Schemas.file,new $.$Fnc("fileSearchProvider")))}C(n,i){const u=this.d++;return this.y=i,this.x=u,this.c.$registerFileSearchProvider(u,this.s(n)),(0,d.$Tc)(()=>{this.y=null,this.c.$unregisterProvider(u)})}$provideFileSearchResults(n,i,u,o){const t=(0,E.$tmc)(u);if(n===this.x){const l=Date.now();return this.D(n,i,t,o).then(r=>{const c=Date.now()-l;return this.q.debug(`Ext host file search time: ${c}ms`),r})}return super.$provideFileSearchResults(n,i,u,o)}doInternalFileSearchWithCustomCallback(n,i,u){const o=t=>{if((0,D.$rL)(t)&&(t=[t]),Array.isArray(t)){u(t.map(l=>L.URI.file(l.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,o,i)}async D(n,i,u,o){return this.doInternalFileSearchWithCustomCallback(u,o,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new h.$Dnc(n,i,void 0,"textSearchProvider")}};e.$Hnc=g,e.$Hnc=g=Je([Ve(0,m.$oP),Ve(1,b.$EP),Ve(2,A.$jlc),Ve(3,M.$2j)],g)}),define(ke[124],Pe([1,0,408,63,64,409,21,13,4,3,17,12,30,82,83]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$mi=e.$li=e.$ki=void 0,e.$ni=r,e.$oi=c,e.$qi=f,e.$ri=S;class h{traceSocketEvent(k,P){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,P)}constructor(k,P=""){this.f=!0,this.debugLabel=P,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,b.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const P=C=>{this.traceSocketEvent("read",C),k(M.$Fe.wrap(C))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(k){const P=C=>{k({type:0,hadError:C,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(k){const P=()=>{k()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,b.$1)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,b.$1)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$ki=h;var g;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize",p[p.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var a;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(a||(a={}));class n extends E.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,P){this.socket.traceSocketEvent(k,P)}constructor(k,P,C,I){super(),this.f=this.B(new m.$ee),this.g=this.B(new m.$ee),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:C?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new i(this,P,C,I,this.f,(T,j)=>this.m(T,j))),this.B(this.a.onError(T=>{console.error(T),(0,b.$1)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new w.$fi,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await m.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let P=0;for(;P<k.byteLength;)this.a.writeMessage(k.slice(P,Math.min(P+262144,k.byteLength)),{compressed:!0,opcode:2}),P+=262144}m(k,{compressed:P,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let I=2;k.byteLength<126?I+=0:k.byteLength<2**16?I+=2:I+=8;const T=M.$Fe.alloc(I),j=P?64:0,z=C&15;if(T.writeUInt8(128|j|z,0),k.byteLength<126)T.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){T.writeUInt8(126,1);let O=1;T.writeUInt8(k.byteLength>>>8&255,++O),T.writeUInt8(k.byteLength>>>0&255,++O)}else{T.writeUInt8(127,1);let O=1;T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(k.byteLength>>>24&255,++O),T.writeUInt8(k.byteLength>>>16&255,++O),T.writeUInt8(k.byteLength>>>8&255,++O),T.writeUInt8(k.byteLength>>>0&255,++O)}this.socket.write(M.$Fe.concat([T,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const P=this.b.peek(this.j.readLen),C=P.readUInt8(0),I=(C&128)>>>7,T=(C&64)>>>6,j=C&15,z=P.readUInt8(1),O=(z&128)>>>7,F=z&127;this.j.state=2,this.j.readLen=2+(O?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!I,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const P=this.b.read(this.j.readLen),C=P.readUInt8(1),I=(C&128)>>>7;let T=C&127,j=1;T===126?T=P.readUInt8(++j)*2**8+P.readUInt8(++j):T===127&&(T=P.readUInt8(++j)*0+P.readUInt8(++j)*0+P.readUInt8(++j)*0+P.readUInt8(++j)*0+P.readUInt8(++j)*2**24+P.readUInt8(++j)*2**16+P.readUInt8(++j)*2**8+P.readUInt8(++j));let z=0;I&&(z=P.readUInt8(++j)*2**24+P.readUInt8(++j)*2**16+P.readUInt8(++j)*2**8+P.readUInt8(++j)),this.j.state=3,this.j.readLen=T,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const P=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),t(P,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(P,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(P,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await m.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$li=n;class i extends E.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:M.$Fe.alloc(0)}constructor(k,P,C,I,T,j){super(),this.n=k,this.r=T,this.s=j,this.a=this.B(new m.$ee),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new m.$ee),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new m.$ee),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,P?(this.b=this.B(new u(this.n,I,C,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(k,P){this.g.push({data:k,options:P}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:P}=this.g.shift();if(this.f&&P.compressed){const C=await this.w(this.f,k);this.s(C,P)}else this.s(k,{...P,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,P){return new Promise((C,I)=>{k.write(P),k.flush(T=>C(T))})}acceptFrame(k,P,C){this.h.push({data:k,isCompressed:P,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const P=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(P)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,P,C){return new Promise((I,T)=>{k.write(P),C&&k.write(M.$Fe.fromByteArray([0,0,255,255])),k.flush(j=>I(j))})}}class u extends E.$Vc{get recordedInflateBytes(){return this.j?M.$Fe.concat(this.f):M.$Fe.alloc(0)}constructor(k,P,C,I){super(),this.h=k,this.j=P,this.a=this.B(new m.$ee),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(I),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(M.$Fe.wrap(T))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const P=M.$Fe.concat(this.g);this.g.length=0,k(P)})}}class o extends E.$Vc{constructor(k,P){super(),this.g=k,this.a=this.B(new m.$ee),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(M.$Fe.wrap(C))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let P=M.$Fe.concat(this.f);this.f.length=0,P=P.slice(0,P.byteLength-4),k(P)})}}function t(p,k){if(k===0)return;const P=p.byteLength>>>2;for(let O=0;O<P;O++){const F=p.readUInt32BE(O*4);p.writeUInt32BE(F^k,O*4)}const C=P*4,I=p.byteLength-C,T=k>>>24&255,j=k>>>16&255,z=k>>>8&255;I>=1&&p.writeUInt8(p.readUInt8(C)^T,C),I>=2&&p.writeUInt8(p.readUInt8(C+1)^j,C+1),I>=3&&p.writeUInt8(p.readUInt8(C+2)^z,C+2)}e.$mi=process.env.XDG_RUNTIME_DIR;const l={2:107,1:103};function r(){const p=(0,$.$Rg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;const k=process.platform!=="darwin"&&e.$mi?e.$mi:(0,L.tmpdir)(),P=(0,A.$kc)(k,`vscode-ipc-${p}.sock`);return s(P),P}function c(p,k,P){const I=(0,d.createHash)("sha256").update(p).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${P}-${k}-sock`;const T=P.substr(0,4),j=k.substr(0,6);let z;return process.platform!=="darwin"&&e.$mi&&!process.env.VSCODE_PORTABLE?z=(0,A.$kc)(e.$mi,`vscode-${I}-${T}-${j}.sock`):z=(0,A.$kc)(p,`${T}-${j}.sock`),s(z),z}function s(p){const k=l[D.$u];typeof k=="number"&&p.length>=k&&console.warn(`WARNING: IPC handle "${p}" is longer than ${k} chars, try a shorter --user-data-dir`)}class v extends y.$_h{static b(k){const P=m.Event.fromNodeEventEmitter(k,"connection");return m.Event.map(P,C=>({protocol:new w.$gi(new h(C,"ipc-server-connection")),onDidClientDisconnect:m.Event.once(m.Event.fromNodeEventEmitter(C,"close"))}))}constructor(k){super(v.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$pi=v;function f(p){return new Promise((k,P)=>{const C=(0,N.createServer)();C.on("error",P),C.listen(p,()=>{C.removeListener("error",P),k(new v(C))})})}function S(p,k){return new Promise((P,C)=>{const I=(0,N.createConnection)(p,()=>{I.removeListener("error",C),P(w.$hi.fromSocket(new h(I,`ipc-client${k}`),k))});I.once("error",C)})}}),define(ke[395],Pe([1,0,63,64,178,124,7,3,12,54,11,108,272,273,111,88,21]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=e.$vdc=e.$udc=e.$tdc=void 0;async function a(t,l,r,c,s){let v;for(let f=3;f&&(v?.dispose(),v=await new n(t,l,r,c,s).waitForReady(),!(s&&L.$Ug[s]||!L.$Ug[v.tunnelLocalPort]));f--);return v}class n extends b.$Vc{constructor(l,r,c,s,v){super(),this.m=r,this.n=v,this.privacy=h.TunnelPrivacyId.Private,this.j=new Map,this.a=l,this.b=d.createServer(),this.c=new M.$uh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=f=>this.r(f),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const l=this.n??this.tunnelRemotePort,r=(0,h.$jw)(this.m)?"0.0.0.0":"127.0.0.1";let c=await(0,L.$Vg)(l,2,1e3,r),s=null;return this.b.listen(c,this.m),await this.c.wait(),s=this.b.address(),s||(c=0,this.b.listen(c,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(l){l.pause();const r=(0,h.$hw)(this.tunnelRemoteHost)||(0,h.$jw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,$.$Rl)(this.a,r,this.tunnelRemotePort),s=c.getSocket(),v=c.readEntireBuffer();c.dispose(),v.byteLength>0&&l.write(v.buffer),l.on("end",()=>{l.localAddress&&this.j.delete(l.localAddress),s.end()}),l.on("close",()=>s.end()),l.on("error",()=>{l.localAddress&&this.j.delete(l.localAddress),s instanceof R.$ki?s.socket.destroy():s.end()}),s instanceof R.$ki?this.t(l,s):this.s(l,s),l.localAddress&&this.j.set(l.localAddress,()=>{l.end(),s.end()})}s(l,r){r.onClose(()=>l.destroy()),r.onEnd(()=>l.end()),r.onData(c=>l.write(c.buffer)),l.on("data",c=>r.write(g.$Fe.wrap(c))),l.resume()}t(l,r){const c=r.socket;c.on("end",()=>l.end()),c.on("close",()=>l.end()),c.on("error",()=>{l.destroy()}),c.pipe(l),l.pipe(c)}}e.$tdc=n;let i=class extends h.$mw{constructor(l,r,c,s,v){super(r,v),this.v=l,this.w=c,this.y=s}isPortPrivileged(l){return(0,h.$kw)(l,this.m,m.OS,N.release())}t(l,r,c,s,v,f,S,p){const k=this.s(r,c);if(k)return++k.refcount,k.value;if((0,h.$dw)(l))return this.u(l,r,c,v,f,S,p);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${c} on local port ${v}.`);const P={commit:this.y.commit,quality:this.y.quality,addressProvider:l,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=a(P,s,r,c,v);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,c,C),C}}};e.$udc=i,e.$udc=i=Je([Ve(0,y.$Ll),Ve(1,A.$2j),Ve(2,w.$Ol),Ve(3,D.$ik),Ve(4,E.$2i)],i);let u=class extends i{constructor(l,r,c,s,v){super(l,r,c,s,v)}};e.$vdc=u,e.$vdc=u=Je([Ve(0,y.$Ll),Ve(1,A.$2j),Ve(2,w.$Ol),Ve(3,D.$ik),Ve(4,E.$2i)],u);let o=class extends b.$Vc{constructor(l,r,c,s,v){super(),this.b=l,this.c=r,this.f=c,this.g=s,this.h=v,this.a=new Map}async openTunnel(l,r,c,s,v,f,S,p,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${s} on local port ${f}.`),!this.a.has(l)){const P=new u(this.b,this.c,this.g,this.f,this.h);this.B(P),this.a.set(l,P),P.onTunnelClosed(async()=>{(await P.tunnels).length===0&&(P.dispose(),this.a.delete(l))})}return this.a.get(l).openTunnel(r,c,s,v,f,S,p,k)}};e.$wdc=o,e.$wdc=o=Je([Ve(0,y.$Ll),Ve(1,A.$2j),Ve(2,D.$ik),Ve(3,w.$Ol),Ve(4,E.$2i)],o)}),define(ke[396],Pe([1,0,124,292,52,34,2,11,42]),function(le,e,d,N,L,R,M,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=e.$PP=void 0;class E{constructor($,y,w){this.b=$,this.c=y,this.f=w,this.a=N.createServer((h,g)=>this.h(h,g)),this.g().catch(h=>(y.error(h),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,y){const w=(g,a)=>{y.writeHead(g,{"content-type":"application/json"}),y.end(JSON.stringify(a||null),n=>n&&this.c.error(n))},h=[];$.setEncoding("utf8"),$.on("data",g=>h.push(g)),$.on("end",async()=>{try{const g=JSON.parse(h.join(""));let a;switch(g.type){case"open":a=await this.i(g);break;case"openExternal":a=await this.j(g);break;case"status":a=await this.l(g);break;case"extensionManagement":a=await this.k(g);break;default:w(404,`Unknown message type: ${g.type}`);break}w(200,a)}catch(g){const a=g instanceof Error?g.message:JSON.stringify(g);w(500,a),this.c.error("Error while processing pipe request",g)}})}async i($){const{fileURIs:y,folderURIs:w,forceNewWindow:h,diffMode:g,mergeMode:a,addMode:n,forceReuseWindow:i,gotoLineMode:u,waitMarkerFilePath:o,remoteAuthority:t}=$,l=[];if(Array.isArray(w))for(const v of w)try{l.push({folderUri:M.URI.parse(v)})}catch{}if(Array.isArray(y))for(const v of y)try{(0,m.$1i)(v)?l.push({workspaceUri:M.URI.parse(v)}):l.push({fileUri:M.URI.parse(v)})}catch{}const r=o?M.URI.file(o):void 0,s={forceNewWindow:h,diffMode:g,mergeMode:a,addMode:n,gotoLineMode:u,forceReuseWindow:i,preferNewWindow:!i&&!r&&!n,waitMarkerFileURI:r,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",l,s)}async j($){for(const y of $.uris){const w=M.URI.parse(y),h=w.scheme==="file"?w:y;await this.b.executeCommand("_remoteCLI.openExternal",h)}}async k($){const y=h=>h?.map(g=>/\.vsix$/i.test(g)?M.URI.parse(g):g),w={list:$.list,install:y($.install),uninstall:y($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",w)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&L.existsSync(this.f)&&L.unlinkSync(this.f)}}e.$PP=E;let A=class extends E{constructor($,y){super($,y,(0,d.$ni)())}};e.$QP=A,e.$QP=A=Je([Ve(0,R.$KP),Ve(1,b.$2j)],A)}),define(ke[397],Pe([1,0,59,384,379,291,49,366,2,15,8,396,104,325,365]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=void 0;class h extends L.$bnc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,u=i._load;i._load=function(r,c,s){return r=t(r),n.a.has(r)?n.a.get(r).load(r,m.URI.file((0,$.$6q)(c.filename)),v=>u.apply(this,[v,c,s])):u.apply(this,arguments)};const o=i._resolveLookupPaths;i._resolveLookupPaths=(l,r)=>o.call(this,t(l),r);const t=l=>{for(const r of n.b){const c=r(l);if(c){l=c;break}}return l}}}class g extends M.$2lc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async vb(){this.h.createInstance(y.$Knc);const n=this.h.invokeFunction(N.$0mc);if(this.h.createInstance(b.$Jnc),this.f.remote.isRemote&&this.f.remote.authority){const o=this.h.createInstance(D.$QP);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}this.h.createInstance(w.$Lnc),await this.h.createInstance(h,n,{mine:this.J,all:this.L}).install(),d.mark("code/extHost/didInitAPI");const u=await this.m.getConfigProvider();await(0,R.$Inc)(this.j,u,this,this.s,this.z,this.f),d.mark("code/extHost/didInitProxyResolver")}wb(n){return n.main}async xb(n,i,u){if(i.scheme!==E.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let o=null;u.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&d.mark(`code/extHost/willLoadExtensionCode/${t}`),o=le.__$__nodeRequire(i.fsPath)}finally{t&&d.mark(`code/extHost/didLoadExtensionCode/${t}`),u.codeLoadingStop()}return o}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const u=n[i];u===null?delete process.env[i]:process.env[i]=u}}}e.$Mnc=g}),define(ke[398],Pe([1,0,53,21,4,3,126,12,23,2,32,11,271,67,111,88,395,28,20,71,373]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=void 0,e.$Nnc=o,e.$Onc=t,e.$Pnc=l,e.$Qnc=r,e.$Rnc=s,e.$Snc=v,e.$Tnc=f;function o(k){const P=k.trim().split(`
`),C=[];return P.forEach(T=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);j&&j.length>=3&&C.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),C.reduce((T,j)=>(T[j.socket]=j,T),{})}function t(...k){const P=[].concat(...k.map(r));return[...new Map(P.filter(C=>C.st==="0A").map(C=>{const I=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:l(I[0]),port:parseInt(I[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}function l(k){let P="";if(k.length===8)for(let C=k.length-2;C>=0;C-=2)P+=parseInt(k.substr(C,2),16),C!==0&&(P+=".");else for(let C=0;C<k.length;C+=8){const I=k.substring(C,C+8);let T="";for(let j=8;j>=2;j-=2)T+=I.substring(j-2,j),(j===6||j===2)&&(T=parseInt(T,16).toString(16),P+=`${T}`,T="",C+j!==k.length-6&&(P+=":"))}return P}function r(k){const P=k.trim().split(`
`),C=P.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return P.map(T=>T.trim().split(/\s+/).reduce((j,z,O)=>(j[C[O]||O]=z,j),{}))}function c(k){return!!k.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||k.indexOf("out/server-main.js")!==-1||k.indexOf("_productName=VSCode")!==-1}function s(k){const P=k.trim().split(`
`),C=[];return P.forEach(I=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(I);T&&T.length>=4&&C.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),C}async function v(k,P,C){const I=C.reduce((j,z)=>(j[z.pid]=z,j),{}),T=[];return k.forEach(({socket:j,ip:z,port:O})=>{const F=P[j]?P[j].pid:void 0,B=F?I[F]?.cmd:void 0;F&&B&&!c(B)&&T.push({host:z,port:O,detail:B,pid:F})}),T}function f(k,P,C){const I=new Map,T=s(P);for(const j of k){const z=C.get(j.port);if(z){I.set(j.port,z);continue}const O=T.find(F=>F.cmd.includes(`${j.port}`));if(O){let F=O,B;do B=T.find(Z=>Z.ppid===F.pid),B&&(F=B);while(B);I.set(j.port,{host:j.ip,port:j.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else I.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return I}let S=class extends i.$kDb{constructor(P,C,I,T){super(P,C,I),this.D=C,this.F=T,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(P){if(P&&this.C)return;this.C=P;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const I=new M.$Dm;let T=0;for(;this.C;){const j=new Date().getTime(),z=(await this.I()).filter(B=>(0,h.$hw)(B.host)||(0,h.$jw)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(B=>B.port).join(", ")}`);const O=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${O} ms.`),T++>3&&I.update(O),(!C||JSON.stringify(C)!==JSON.stringify(z))&&(C=z,await this.a.$onFoundNewCandidates(C));const F=this.G(I.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(B=>setTimeout(()=>B(),F))}}G(P){return Math.max(P*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(P=>P.port).join(", ")}`)}async I(){let P="",C="";try{P=await A.Promises.readFile("/proc/net/tcp","utf8"),C=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const I=t(P,C),T=await new Promise(Q=>{(0,d.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,X,ie)=>{Q(X)})}),j=o(T),z=await A.Promises.readdir("/proc"),O=[];for(const Q of z)try{const x=Number(Q),X=m.$9g(E.URI.file("/proc"),Q);if((await A.Promises.stat(X.fsPath)).isDirectory()&&!isNaN(x)){const me=await A.Promises.readlink(m.$9g(X,"cwd").fsPath),ue=await A.Promises.readFile(m.$9g(X,"cmdline").fsPath,"utf8");O.push({pid:x,cwd:me,cmd:ue})}}catch{}const F=[],B=I.filter(Q=>{const x=j[Q.socket];return x||F.push(Q),x}),Z=v(B,j,O);let q;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const Q=await new Promise(x=>{(0,d.exec)("ps -F -A -l | grep root",(X,ie,me)=>{x(ie)})});this.z=f(F,Q,this.z),q=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${q.map(x=>x.port).join(", ")}`)}return Z.then(Q=>q?Q.concat(q):Q)}w(P){return async C=>{const I=new g.$tdc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,z,O,F){const B=await P.makeConnection();return p.connect(B,z,O,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Hl(0),connectionToken:P.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await I.waitForReady();const T=new L.$ee;return{localAddress:(0,u.$oM)(I.localAddress)??I.localAddress,remoteAddress:{port:I.tunnelRemotePort,host:I.tunnelRemoteHost},onDidDispose:T.event,dispose:()=>{I.dispose(),T.fire(),T.dispose()}}}}};e.$Unc=S,e.$Unc=S=Je([Ve(0,n.$oP),Ve(1,a.$EP),Ve(2,D.$2j),Ve(3,w.$Ol)],S);class p extends $.$Dtb{static connect(P,C,I,T){const j=new R.$Uc,z={onClose:j.add(new L.$ee),onData:j.add(new L.$ee),onEnd:j.add(new L.$ee)};j.add(P.onDidReceiveMessage(F=>z.onData.fire(N.$Fe.wrap(F)))),j.add(P.onDidEnd(()=>z.onEnd.fire())),j.add(P.onDidClose(F=>z.onClose.fire({type:0,error:F,hadError:!!F})));const O=new p(P,T,z);return O.B(j),(0,$.$Ctb)(O,C,I,T,z)}constructor(P,C,I){super(C,I),this.n=P}write(P){this.n.send(P.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[399],Pe([1,0,85,368,382,381,394,397,398,96,49,97,95,43,71,93,367,326,11,383,61,286,106,111,141]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a,n,i,u,o,t,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.$ws)(A.$3lc,b.$Mnc,0),(0,d.$ws)(n.$3j,a.$Wnc,1),(0,d.$ws)(n.$2j,new t.$si(o.$anc,[!1],!0)),(0,d.$ws)(l.$Ol,r.$ydc,1),(0,d.$ws)(h.$slc,g.$Vnc,0),(0,d.$ws)(E.$8lc,R.$nnc,0),(0,d.$ws)(D.$rmc,M.$Hnc,0),(0,d.$ws)($.$Tmc,L.$fnc,0),(0,d.$ws)(y.$Nlc,N.$enc,0),(0,d.$ws)(w.$jDb,m.$Unc,0),(0,d.$ws)(u.$6lc,i.$Xnc,0)}),define(ke[410],Pe([1,0,63,411,59,13,83,124,269,115,380,21,32,104,7,136,293,309,385,399]),function(le,e,d,N,L,R,M,b,m,E,A,D,$,y,w,h,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let f=0;f<process.execArgv.length;f++)process.execArgv[f]==="--inspect-port=0"&&(process.execArgv.splice(f,1),f--)}();const n=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const v=globalThis._VSCODE_NODE_MODULES.module,f=v._load;v._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return f.apply(this,arguments)}})();const i=process.exit.bind(process),u=process.on.bind(process);function o(v){process.exit=function(f){if(v)i(f);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const f=new Error("An extension called process.crash() and this was prevented.");console.warn(f.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(f,S){f==="uncaughtException"&&(S=function(){try{return S.call(void 0,arguments)}catch{}}),u(f,S)}}let t=function(v){i()};function l(){const v=(0,a.$nn)(process.env);if(v.type===3)return new Promise((f,S)=>{const p=k=>{const P=k[0],C=new M.$ii;P.on("message",I=>C.fire(D.$Fe.wrap(I.data))),P.on("close",()=>{t("renderer closed the MessagePort")}),P.start(),f({onMessage:C.event,send:I=>P.postMessage(I.buffer)})};process.parentPort.on("message",k=>p(k.ports))});if(v.type===2)return new Promise((f,S)=>{let p=null;const k=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),P=108e5,C=3e5,I=new w.$Ih(()=>t("renderer disconnected for too long (1)"),P),T=new w.$Ih(()=>t("renderer disconnected for too long (2)"),C);process.on("message",(z,O)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const F=D.$Fe.wrap(Buffer.from(z.initialDataChunk,"base64"));let B;if(z.skipWebSocketFrames)B=new b.$ki(O,"extHost-socket");else{const Z=D.$Fe.wrap(Buffer.from(z.inflateBytes,"base64"));B=new b.$li(new b.$ki(O,"extHost-socket"),z.permessageDeflate,Z,!1)}p?(I.cancel(),T.cancel(),p.beginAcceptReconnection(B,F),p.endAcceptReconnection(),p.sendResume()):(clearTimeout(k),p=new M.$ji({socket:B,initialChunk:F}),p.sendResume(),p.onDidDispose(()=>t("renderer disconnected")),f(p),p.onSocketClose(()=>{I.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;I.isScheduled()&&T.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const f=v.pipeName;return new Promise((S,p)=>{const k=d.createConnection(f,()=>{k.removeListener("error",p);const P=new M.$ji({socket:new b.$ki(k,"extHost-renderer")});P.sendResume(),S(P)});k.once("error",p),k.on("close",()=>{t("renderer closed the socket")})})}}async function r(){const v=await l();return new class{constructor(){this.a=new M.$ii,this.onMessage=this.a.event,this.b=!1,v.onMessage(f=>{(0,E.$Zm)(f,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(f)})}send(f){this.b||v.send(f)}async drain(){if(v.drain)return v.drain()}}}function c(v){return new Promise(f=>{const S=v.onMessage(p=>{S.dispose();const k=JSON.parse(p.toString()),P=k.commit,C=m.default.commit;if(P&&C&&P!==C&&i(55),k.parentPid){let I=0;setInterval(function(){try{process.kill(k.parentPid,0),I=0}catch(j){j&&j.code==="EPERM"?(I++,I>=3&&t(`parent process ${k.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):t(`parent process ${k.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let T;try{T=globalThis._VSCODE_NODE_MODULES["native-watchdog"],T.start(k.parentPid)}catch(j){(0,R.$1)(j)}}v.send((0,E.$Ym)(0)),f({protocol:v,initData:k})});v.send((0,E.$Ym)(1))})}async function s(){const v=[];process.on("unhandledRejection",(I,T)=>{v.push(T),setTimeout(()=>{const j=v.indexOf(T);j>=0&&T.catch(z=>{v.splice(j,1),(0,R.$4)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),I&&(0,R.$1)(I))})},1e3)}),process.on("rejectionHandled",I=>{const T=v.indexOf(I);T>=0&&v.splice(T,1)}),process.on("uncaughtException",function(I){(0,R.$Z)(I)||(0,R.$1)(I)}),L.mark("code/extHost/willConnectToRenderer");const f=await r();L.mark("code/extHost/didConnectToRenderer");const S=await c(f);L.mark("code/extHost/didWaitForInitData");const{initData:p}=S;o(!!p.environment.extensionTestsLocationURI),p.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,p.environment.skipWorkspaceStorageLock=(0,h.boolean)(n.skipWorkspaceStorageLock,!1);const k=new class{constructor(){this.pid=process.pid}exit(T){i(T)}fsExists(T){return $.Promises.exists(T)}fsRealpath(T){return(0,y.$5q)(T)}};let P=null;p.remote.authority&&n.transformURIs&&(P=(0,g.$As)(p.remote.authority));const C=new A.$dnc(S.protocol,p,k,P);t=I=>C.terminate(I)}s().catch(v=>console.log(v))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5ae5a741bdb676abb667fd4896dc2a40e313db3a/core/vs/workbench/api/node/extensionHostProcess.js.map
