/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/marshalling","vs/platform/configuration/common/configuration","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ce=function(le){for(var e=[],I=0,N=le.length;I<N;I++)e[I]=Ie[le[I]];return e};define(Ie[69],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=N,e.$1h=R,e.$2h=O;function I(M){return(b,p,E)=>{let F=null,D=null;if(typeof E.value=="function"?(F="value",D=E.value):typeof E.get=="function"&&(F="get",D=E.get),!D)throw new Error("not supported");E[F]=M(D,p)}}function N(M,b,p){let E=null,F=null;if(typeof p.value=="function"?(E="value",F=p.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(E="get",F=p.get),!F)throw new Error("not supported");const D=`$memoize$${b}`;p[E]=function(...d){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,d)}),this[D]}}function R(M,b,p){return I((E,F)=>{const D=`$debounce$${F}`,d=`$debounce$result$${F}`;return function(...v){this[d]||(this[d]=p?p():void 0),clearTimeout(this[D]),b&&(this[d]=b(this[d],...v),v=[this[d]]),this[D]=setTimeout(()=>{E.apply(this,v),this[d]=p?p():void 0},M)}})}function O(M,b,p){return I((E,F)=>{const D=`$throttle$timer$${F}`,d=`$throttle$result$${F}`,v=`$throttle$lastRun$${F}`,m=`$throttle$pending$${F}`;return function(...r){if(this[d]||(this[d]=p?p():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),b&&(this[d]=b(this[d],...r)),this[m])return;const o=this[v]+M;o<=Date.now()?(this[v]=Date.now(),E.apply(this,[this[d]]),this[d]=p?p():void 0):(this[m]=!0,this[D]=setTimeout(()=>{this[m]=!1,this[v]=Date.now(),E.apply(this,[this[d]]),this[d]=p?p():void 0},o-Date.now()))}})}}),define(Ie[125],Ce([1,0,18]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=R,e.$9c=O,e.$0c=M,e.$$c=b,e.$_c=p,e.$ad=E;const N=(v,m)=>v===m;e.$7c=N;function R(v=e.$7c){return(m,r)=>I.$ub(m,r,v)}function O(){return(v,m)=>JSON.stringify(v)===JSON.stringify(m)}function M(){return(v,m)=>v.equals(m)}function b(v,m,r){return!v||!m?v===m:r(v,m)}function p(v,m){if(v===m)return!0;if(Array.isArray(v)&&Array.isArray(m)){if(v.length!==m.length)return!1;for(let r=0;r<v.length;r++)if(!p(v[r],m[r]))return!1;return!0}if(Object.getPrototypeOf(v)===Object.prototype&&Object.getPrototypeOf(m)===Object.prototype){const r=v,o=m,s=Object.keys(r),i=Object.keys(o),n=new Set(i);if(s.length!==i.length)return!1;for(const c of s)if(!n.has(c)||!p(r[c],o[c]))return!1;return!0}return!1}function E(v){return JSON.stringify(d(v))}let F=0;const D=new WeakMap;function d(v){if(Array.isArray(v))return v.map(d);if(v&&typeof v=="object")if(Object.getPrototypeOf(v)===Object.prototype){const m=v,r=Object.create(null);for(const o of Object.keys(m).sort())r[o]=d(m[o]);return r}else{let m=D.get(v);return m===void 0&&(m=F++,D.set(v,m)),m+"----2b76a038c20c4bcc"}return v}}),define(Ie[91],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uP=e.$tP=void 0;class I{constructor(R){this.a=R,this.b=0}nextId(){return this.a+ ++this.b}}e.$tP=I,e.$uP=new I("id#")}),define(Ie[126],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Gn=M,e.$Hn=D,e.$In=d,e.$Jn=v,e.$Kn=m,e.$Ln=r,e.$Mn=o,e.$Nn=s,e.$On=i,e.$Pn=n,e.$Qn=c,e.$Rn=h;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function M(t,f=!1){let a=0;const g=t.length;let u="",S=0,l=16,w=0;function $(q){let A=0,U=0;for(;A<q;){const K=t.charCodeAt(a);if(K>=48&&K<=57)U=U*16+K-48;else if(K>=65&&K<=70)U=U*16+K-65+10;else if(K>=97&&K<=102)U=U*16+K-97+10;else break;a++,A++}return A<q&&(U=-1),U}function k(q){a=q,u="",S=0,l=16,w=0}function y(){const q=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&E(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&E(t.charCodeAt(a)))for(a++;a<t.length&&E(t.charCodeAt(a));)a++;else return w=3,t.substring(q,a);let A=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&E(t.charCodeAt(a))){for(a++;a<t.length&&E(t.charCodeAt(a));)a++;A=a}else w=3;return t.substring(q,A)}function C(){let q="",A=a;for(;;){if(a>=g){q+=t.substring(A,a),w=2;break}const U=t.charCodeAt(a);if(U===34){q+=t.substring(A,a),a++;break}if(U===92){if(q+=t.substring(A,a),a++,a>=g){w=2;break}switch(t.charCodeAt(a++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const re=$(4);re>=0?q+=String.fromCharCode(re):w=4;break}default:w=5}A=a;continue}if(U>=0&&U<=31)if(p(U)){q+=t.substring(A,a),w=2;break}else w=6;a++}return q}function P(){if(u="",w=0,S=a,a>=g)return S=g,l=17;let q=t.charCodeAt(a);if(b(q)){do a++,u+=String.fromCharCode(q),q=t.charCodeAt(a);while(b(q));return l=15}if(p(q))return a++,u+=String.fromCharCode(q),q===13&&t.charCodeAt(a)===10&&(a++,u+=`
`),l=14;switch(q){case 123:return a++,l=1;case 125:return a++,l=2;case 91:return a++,l=3;case 93:return a++,l=4;case 58:return a++,l=6;case 44:return a++,l=5;case 34:return a++,u=C(),l=10;case 47:{const A=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<g&&!p(t.charCodeAt(a));)a++;return u=t.substring(A,a),l=12}if(t.charCodeAt(a+1)===42){a+=2;const U=g-1;let K=!1;for(;a<U;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,K=!0;break}a++}return K||(a++,w=1),u=t.substring(A,a),l=13}return u+=String.fromCharCode(q),a++,l=16}case 45:if(u+=String.fromCharCode(q),a++,a===g||!E(t.charCodeAt(a)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=y(),l=11;default:for(;a<g&&W(q);)a++,q=t.charCodeAt(a);if(S!==a){switch(u=t.substring(S,a),u){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return u+=String.fromCharCode(q),a++,l=16}}function W(q){if(b(q)||p(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=P();while(q>=12&&q<=15);return q}return{setPosition:k,getPosition:()=>a,scan:f?V:P,getToken:()=>l,getTokenValue:()=>u,getTokenOffset:()=>S,getTokenLength:()=>a-S,getTokenError:()=>w}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var F;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(F||(F={}));function D(t,f){const a=[],g=new Object;let u;const S={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function w($,k,y,C){S.value=$,S.offset=k,S.length=y,S.type=C,S.colonOffset=void 0,u=S}try{n(t,{onObjectBegin:($,k)=>{if(f<=$)throw g;u=void 0,l=f>$,a.push("")},onObjectProperty:($,k,y)=>{if(f<k||(w($,k,y,"property"),a[a.length-1]=$,f<=k+y))throw g},onObjectEnd:($,k)=>{if(f<=$)throw g;u=void 0,a.pop()},onArrayBegin:($,k)=>{if(f<=$)throw g;u=void 0,a.push(0)},onArrayEnd:($,k)=>{if(f<=$)throw g;u=void 0,a.pop()},onLiteralValue:($,k,y)=>{if(f<k||(w($,k,y,h($)),f<=k+y))throw g},onSeparator:($,k,y)=>{if(f<=k)throw g;if($===":"&&u&&u.type==="property")u.colonOffset=k,l=!1,u=void 0;else if($===","){const C=a[a.length-1];typeof C=="number"?a[a.length-1]=C+1:(l=!0,a[a.length-1]=""),u=void 0}}})}catch($){if($!==g)throw $}return{path:a,previousNode:u,isAtPropertyKey:l,matches:$=>{let k=0;for(let y=0;k<$.length&&y<a.length;y++)if($[k]===a[y]||$[k]==="*")k++;else if($[k]!=="**")return!1;return k===$.length}}}function d(t,f=[],a=O.DEFAULT){let g=null,u=[];const S=[];function l($){Array.isArray(u)?u.push($):g!==null&&(u[g]=$)}return n(t,{onObjectBegin:()=>{const $={};l($),S.push(u),u=$,g=null},onObjectProperty:$=>{g=$},onObjectEnd:()=>{u=S.pop()},onArrayBegin:()=>{const $=[];l($),S.push(u),u=$,g=null},onArrayEnd:()=>{u=S.pop()},onLiteralValue:l,onError:($,k,y)=>{f.push({error:$,offset:k,length:y})}},a),u[0]}function v(t,f=[],a=O.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u($){g.type==="property"&&(g.length=$-g.offset,g=g.parent)}function S($){return g.children.push($),$}n(t,{onObjectBegin:$=>{g=S({type:"object",offset:$,length:-1,parent:g,children:[]})},onObjectProperty:($,k,y)=>{g=S({type:"property",offset:k,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:$,offset:k,length:y,parent:g})},onObjectEnd:($,k)=>{g.length=$+k-g.offset,g=g.parent,u($+k)},onArrayBegin:($,k)=>{g=S({type:"array",offset:$,length:-1,parent:g,children:[]})},onArrayEnd:($,k)=>{g.length=$+k-g.offset,g=g.parent,u($+k)},onLiteralValue:($,k,y)=>{S({type:h($),offset:k,length:y,parent:g,value:$}),u(k+y)},onSeparator:($,k,y)=>{g.type==="property"&&($===":"?g.colonOffset=k:$===","&&u(k))},onError:($,k,y)=>{f.push({error:$,offset:k,length:y})}},a);const w=g.children[0];return w&&delete w.parent,w}function m(t,f){if(!t)return;let a=t;for(const g of f)if(typeof g=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let u=!1;for(const S of a.children)if(Array.isArray(S.children)&&S.children[0].value===g){a=S.children[1],u=!0;break}if(!u)return}else{const u=g;if(a.type!=="array"||u<0||!Array.isArray(a.children)||u>=a.children.length)return;a=a.children[u]}return a}function r(t){if(!t.parent||!t.parent.children)return[];const f=r(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;f.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&f.push(a)}return f}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const f=Object.create(null);for(const a of t.children){const g=a.children[1];g&&(f[a.children[0].value]=o(g))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,f,a=!1){return f>=t.offset&&f<t.offset+t.length||a&&f===t.offset+t.length}function i(t,f,a=!1){if(s(t,f,a)){const g=t.children;if(Array.isArray(g))for(let u=0;u<g.length&&g[u].offset<=f;u++){const S=i(g[u],f,a);if(S)return S}return t}}function n(t,f,a=O.DEFAULT){const g=M(t,!1);function u(Ae){return Ae?()=>Ae(g.getTokenOffset(),g.getTokenLength()):()=>!0}function S(Ae){return Ae?ce=>Ae(ce,g.getTokenOffset(),g.getTokenLength()):()=>!0}const l=u(f.onObjectBegin),w=S(f.onObjectProperty),$=u(f.onObjectEnd),k=u(f.onArrayBegin),y=u(f.onArrayEnd),C=S(f.onLiteralValue),P=S(f.onSeparator),W=u(f.onComment),V=S(f.onError),q=a&&a.disallowComments,A=a&&a.allowTrailingComma;function U(){for(;;){const Ae=g.scan();switch(g.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(Ae){case 12:case 13:q?K(10):W();break;case 16:K(1);break;case 15:case 14:break;default:return Ae}}}function K(Ae,ce=[],Me=[]){if(V(Ae),ce.length+Me.length>0){let ie=g.getToken();for(;ie!==17;){if(ce.indexOf(ie)!==-1){U();break}else if(Me.indexOf(ie)!==-1)break;ie=U()}}}function re(Ae){const ce=g.getTokenValue();return Ae?C(ce):w(ce),U(),!0}function ae(){switch(g.getToken()){case 11:{let Ae=0;try{Ae=JSON.parse(g.getTokenValue()),typeof Ae!="number"&&(K(2),Ae=0)}catch{K(2)}C(Ae);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return U(),!0}function ye(){return g.getToken()!==10?(K(3,[],[2,5]),!1):(re(!1),g.getToken()===6?(P(":"),U(),me()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Pe(){l(),U();let Ae=!1;for(;g.getToken()!==2&&g.getToken()!==17;){if(g.getToken()===5){if(Ae||K(4,[],[]),P(","),U(),g.getToken()===2&&A)break}else Ae&&K(6,[],[]);ye()||K(4,[],[2,5]),Ae=!0}return $(),g.getToken()!==2?K(7,[2],[]):U(),!0}function fe(){k(),U();let Ae=!1;for(;g.getToken()!==4&&g.getToken()!==17;){if(g.getToken()===5){if(Ae||K(4,[],[]),P(","),U(),g.getToken()===4&&A)break}else Ae&&K(6,[],[]);me()||K(4,[],[4,5]),Ae=!0}return y(),g.getToken()!==4?K(8,[4],[]):U(),!0}function me(){switch(g.getToken()){case 3:return fe();case 1:return Pe();case 10:return re(!0);default:return ae()}}return U(),g.getToken()===17?a.allowEmptyContent?!0:(K(4,[],[]),!1):me()?(g.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function c(t,f){const a=M(t),g=[];let u,S=0,l;do switch(l=a.getPosition(),u=a.scan(),u){case 12:case 13:case 17:S!==l&&g.push(t.substring(S,l)),f!==void 0&&g.push(a.getTokenValue().replace(/[^\r\n]/g,f)),S=a.getPosition();break}while(u!==17);return g.join("")}function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(le,e){typeof define=="function"&&define.amd?define(Ie[127],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(De,$e){for(var ge=0;ge<$e.length;ge++){var Q=$e[ge];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(De,Q.key,Q)}}function I(De,$e,ge){return $e&&e(De.prototype,$e),ge&&e(De,ge),Object.defineProperty(De,"prototype",{writable:!1}),De}function N(De,$e){if(De){if(typeof De=="string")return R(De,$e);var ge=Object.prototype.toString.call(De).slice(8,-1);if(ge==="Object"&&De.constructor&&(ge=De.constructor.name),ge==="Map"||ge==="Set")return Array.from(De);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return R(De,$e)}}function R(De,$e){($e==null||$e>De.length)&&($e=De.length);for(var ge=0,Q=new Array($e);ge<$e;ge++)Q[ge]=De[ge];return Q}function O(De,$e){var ge=typeof Symbol<"u"&&De[Symbol.iterator]||De["@@iterator"];if(ge)return(ge=ge.call(De)).next.bind(ge);if(Array.isArray(De)||(ge=N(De))||$e&&De&&typeof De.length=="number"){ge&&(De=ge);var Q=0;return function(){return Q>=De.length?{done:!0}:{done:!1,value:De[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=M();function b(De){le.defaults=De}var p=/[&<>"']/,E=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,d={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function($e){return d[$e]};function m(De,$e){if($e){if(p.test(De))return De.replace(E,v)}else if(F.test(De))return De.replace(D,v);return De}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(De){return De.replace(r,function($e,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(De,$e){De=typeof De=="string"?De:De.source,$e=$e||"";var ge={replace:function(X,he){return he=he.source||he,he=he.replace(s,"$1"),De=De.replace(X,he),ge},getRegex:function(){return new RegExp(De,$e)}};return ge}var n=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(De,$e,ge){if(De){var Q;try{Q=decodeURIComponent(o(ge)).replace(n,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}$e&&!c.test(ge)&&(ge=u($e,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},f=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,g=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(De,$e){t[" "+De]||(f.test(De)?t[" "+De]=De+"/":t[" "+De]=$(De,"/",!0)),De=t[" "+De];var ge=De.indexOf(":")===-1;return $e.substring(0,2)==="//"?ge?$e:De.replace(a,"$1")+$e:$e.charAt(0)==="/"?ge?$e:De.replace(g,"$1")+$e:De+$e}var S={exec:function(){}};function l(De){for(var $e=1,ge,Q;$e<arguments.length;$e++){ge=arguments[$e];for(Q in ge)Object.prototype.hasOwnProperty.call(ge,Q)&&(De[Q]=ge[Q])}return De}function w(De,$e){var ge=De.replace(/\|/g,function(he,ue,Fe){for(var de=!1,Re=ue;--Re>=0&&Fe[Re]==="\\";)de=!de;return de?"|":" |"}),Q=ge.split(/ \|/),X=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>$e)Q.splice($e);else for(;Q.length<$e;)Q.push("");for(;X<Q.length;X++)Q[X]=Q[X].trim().replace(/\\\|/g,"|");return Q}function $(De,$e,ge){var Q=De.length;if(Q===0)return"";for(var X=0;X<Q;){var he=De.charAt(Q-X-1);if(he===$e&&!ge)X++;else if(he!==$e&&ge)X++;else break}return De.slice(0,Q-X)}function k(De,$e){if(De.indexOf($e[1])===-1)return-1;for(var ge=De.length,Q=0,X=0;X<ge;X++)if(De[X]==="\\")X++;else if(De[X]===$e[0])Q++;else if(De[X]===$e[1]&&(Q--,Q<0))return X;return-1}function y(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(De,$e){if($e<1)return"";for(var ge="";$e>1;)$e&1&&(ge+=De),$e>>=1,De+=De;return ge+De}function P(De,$e,ge,Q){var X=$e.href,he=$e.title?m($e.title):null,ue=De[1].replace(/\\([\[\]])/g,"$1");if(De[0].charAt(0)!=="!"){Q.state.inLink=!0;var Fe={type:"link",raw:ge,href:X,title:he,text:ue,tokens:Q.inlineTokens(ue)};return Q.state.inLink=!1,Fe}return{type:"image",raw:ge,href:X,title:he,text:m(ue)}}function W(De,$e){var ge=De.match(/^(\s+)(?:```)/);if(ge===null)return $e;var Q=ge[1];return $e.split(`
`).map(function(X){var he=X.match(/^\s+/);if(he===null)return X;var ue=he[0];return ue.length>=Q.length?X.slice(Q.length):X}).join(`
`)}var V=function(){function De(ge){this.options=ge||le.defaults}var $e=De.prototype;return $e.space=function(Q){var X=this.rules.block.newline.exec(Q);if(X&&X[0].length>0)return{type:"space",raw:X[0]}},$e.code=function(Q){var X=this.rules.block.code.exec(Q);if(X){var he=X[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?he:$(he,`
`)}}},$e.fences=function(Q){var X=this.rules.block.fences.exec(Q);if(X){var he=X[0],ue=W(he,X[3]||"");return{type:"code",raw:he,lang:X[2]?X[2].trim():X[2],text:ue}}},$e.heading=function(Q){var X=this.rules.block.heading.exec(Q);if(X){var he=X[2].trim();if(/#$/.test(he)){var ue=$(he,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(he=ue.trim())}return{type:"heading",raw:X[0],depth:X[1].length,text:he,tokens:this.lexer.inline(he)}}},$e.hr=function(Q){var X=this.rules.block.hr.exec(Q);if(X)return{type:"hr",raw:X[0]}},$e.blockquote=function(Q){var X=this.rules.block.blockquote.exec(Q);if(X){var he=X[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:X[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},$e.list=function(Q){var X=this.rules.block.list.exec(Q);if(X){var he,ue,Fe,de,Re,Ne,Ue,j,T,G,H,ee,ne=X[1].trim(),Oe=ne.length>1,Be={type:"list",raw:"",ordered:Oe,start:Oe?+ne.slice(0,-1):"",loose:!1,items:[]};ne=Oe?"\\d{1,9}\\"+ne.slice(-1):"\\"+ne,this.options.pedantic&&(ne=Oe?ne:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+ne+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ee=!1,!(!(X=Ke.exec(Q))||this.rules.block.hr.test(Q)));){if(he=X[0],Q=Q.substring(he.length),j=X[2].split(`
`,1)[0],T=Q.split(`
`,1)[0],this.options.pedantic?(de=2,H=j.trimLeft()):(de=X[2].search(/[^ ]/),de=de>4?1:de,H=j.slice(de),de+=X[1].length),Ne=!1,!j&&/^ *$/.test(T)&&(he+=T+`
`,Q=Q.substring(T.length+1),ee=!0),!ee)for(var _e=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");Q&&(G=Q.split(`
`,1)[0],j=G,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(j)||tt.test(j)||_e.test(j)||xe.test(Q)));){if(j.search(/[^ ]/)>=de||!j.trim())H+=`
`+j.slice(de);else if(!Ne)H+=`
`+j;else break;!Ne&&!j.trim()&&(Ne=!0),he+=G+`
`,Q=Q.substring(G.length+1)}Be.loose||(Ue?Be.loose=!0:/\n *\n *$/.test(he)&&(Ue=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(H),ue&&(Fe=ue[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:he,task:!!ue,checked:Fe,loose:!1,text:H}),Be.raw+=he}Be.items[Be.items.length-1].raw=he.trimRight(),Be.items[Be.items.length-1].text=H.trimRight(),Be.raw=Be.raw.trimRight();var nt=Be.items.length;for(Re=0;Re<nt;Re++){this.lexer.state.top=!1,Be.items[Re].tokens=this.lexer.blockTokens(Be.items[Re].text,[]);var ct=Be.items[Re].tokens.filter(function(je){return je.type==="space"}),mt=ct.every(function(je){for(var st=je.raw.split(""),Z=0,Y=O(st),pe;!(pe=Y()).done;){var Ge=pe.value;if(Ge===`
`&&(Z+=1),Z>1)return!0}return!1});!Be.loose&&ct.length&&mt&&(Be.loose=!0,Be.items[Re].loose=!0)}return Be}},$e.html=function(Q){var X=this.rules.block.html.exec(Q);if(X){var he={type:"html",raw:X[0],pre:!this.options.sanitizer&&(X[1]==="pre"||X[1]==="script"||X[1]==="style"),text:X[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(X[0]):m(X[0]);he.type="paragraph",he.text=ue,he.tokens=this.lexer.inline(ue)}return he}},$e.def=function(Q){var X=this.rules.block.def.exec(Q);if(X){X[3]&&(X[3]=X[3].substring(1,X[3].length-1));var he=X[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:X[0],href:X[2],title:X[3]}}},$e.table=function(Q){var X=this.rules.block.table.exec(Q);if(X){var he={type:"table",header:w(X[1]).map(function(Ue){return{text:Ue}}),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:X[3]&&X[3].trim()?X[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=X[0];var ue=he.align.length,Fe,de,Re,Ne;for(Fe=0;Fe<ue;Fe++)/^ *-+: *$/.test(he.align[Fe])?he.align[Fe]="right":/^ *:-+: *$/.test(he.align[Fe])?he.align[Fe]="center":/^ *:-+ *$/.test(he.align[Fe])?he.align[Fe]="left":he.align[Fe]=null;for(ue=he.rows.length,Fe=0;Fe<ue;Fe++)he.rows[Fe]=w(he.rows[Fe],he.header.length).map(function(Ue){return{text:Ue}});for(ue=he.header.length,de=0;de<ue;de++)he.header[de].tokens=this.lexer.inline(he.header[de].text);for(ue=he.rows.length,de=0;de<ue;de++)for(Ne=he.rows[de],Re=0;Re<Ne.length;Re++)Ne[Re].tokens=this.lexer.inline(Ne[Re].text);return he}}},$e.lheading=function(Q){var X=this.rules.block.lheading.exec(Q);if(X)return{type:"heading",raw:X[0],depth:X[2].charAt(0)==="="?1:2,text:X[1],tokens:this.lexer.inline(X[1])}},$e.paragraph=function(Q){var X=this.rules.block.paragraph.exec(Q);if(X){var he=X[1].charAt(X[1].length-1)===`
`?X[1].slice(0,-1):X[1];return{type:"paragraph",raw:X[0],text:he,tokens:this.lexer.inline(he)}}},$e.text=function(Q){var X=this.rules.block.text.exec(Q);if(X)return{type:"text",raw:X[0],text:X[0],tokens:this.lexer.inline(X[0])}},$e.escape=function(Q){var X=this.rules.inline.escape.exec(Q);if(X)return{type:"escape",raw:X[0],text:m(X[1])}},$e.tag=function(Q){var X=this.rules.inline.tag.exec(Q);if(X)return!this.lexer.state.inLink&&/^<a /i.test(X[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(X[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(X[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(X[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:X[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):m(X[0]):X[0]}},$e.link=function(Q){var X=this.rules.inline.link.exec(Q);if(X){var he=X[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var ue=$(he.slice(0,-1),"\\");if((he.length-ue.length)%2===0)return}else{var Fe=k(X[2],"()");if(Fe>-1){var de=X[0].indexOf("!")===0?5:4,Re=de+X[1].length+Fe;X[2]=X[2].substring(0,Fe),X[0]=X[0].substring(0,Re).trim(),X[3]=""}}var Ne=X[2],Ue="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ne);j&&(Ne=j[1],Ue=j[3])}else Ue=X[3]?X[3].slice(1,-1):"";return Ne=Ne.trim(),/^</.test(Ne)&&(this.options.pedantic&&!/>$/.test(he)?Ne=Ne.slice(1):Ne=Ne.slice(1,-1)),P(X,{href:Ne&&Ne.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},X[0],this.lexer)}},$e.reflink=function(Q,X){var he;if((he=this.rules.inline.reflink.exec(Q))||(he=this.rules.inline.nolink.exec(Q))){var ue=(he[2]||he[1]).replace(/\s+/g," ");if(ue=X[ue.toLowerCase()],!ue||!ue.href){var Fe=he[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return P(he,ue,he[0],this.lexer)}},$e.emStrong=function(Q,X,he){he===void 0&&(he="");var ue=this.rules.inline.emStrong.lDelim.exec(Q);if(ue&&!(ue[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=ue[1]||ue[2]||"";if(!Fe||Fe&&(he===""||this.rules.inline.punctuation.exec(he))){var de=ue[0].length-1,Re,Ne,Ue=de,j=0,T=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(T.lastIndex=0,X=X.slice(-1*Q.length+de);(ue=T.exec(X))!=null;)if(Re=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!Re){if(Ne=Re.length,ue[3]||ue[4]){Ue+=Ne;continue}else if((ue[5]||ue[6])&&de%3&&!((de+Ne)%3)){j+=Ne;continue}if(Ue-=Ne,!(Ue>0)){if(Ne=Math.min(Ne,Ne+Ue+j),Math.min(de,Ne)%2){var G=Q.slice(1,de+ue.index+Ne);return{type:"em",raw:Q.slice(0,de+ue.index+Ne+1),text:G,tokens:this.lexer.inlineTokens(G)}}var H=Q.slice(2,de+ue.index+Ne-1);return{type:"strong",raw:Q.slice(0,de+ue.index+Ne+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},$e.codespan=function(Q){var X=this.rules.inline.code.exec(Q);if(X){var he=X[2].replace(/\n/g," "),ue=/[^ ]/.test(he),Fe=/^ /.test(he)&&/ $/.test(he);return ue&&Fe&&(he=he.substring(1,he.length-1)),he=m(he,!0),{type:"codespan",raw:X[0],text:he}}},$e.br=function(Q){var X=this.rules.inline.br.exec(Q);if(X)return{type:"br",raw:X[0]}},$e.del=function(Q){var X=this.rules.inline.del.exec(Q);if(X)return{type:"del",raw:X[0],text:X[2],tokens:this.lexer.inlineTokens(X[2])}},$e.autolink=function(Q,X){var he=this.rules.inline.autolink.exec(Q);if(he){var ue,Fe;return he[2]==="@"?(ue=m(this.options.mangle?X(he[1]):he[1]),Fe="mailto:"+ue):(ue=m(he[1]),Fe=ue),{type:"link",raw:he[0],text:ue,href:Fe,tokens:[{type:"text",raw:ue,text:ue}]}}},$e.url=function(Q,X){var he;if(he=this.rules.inline.url.exec(Q)){var ue,Fe;if(he[2]==="@")ue=m(this.options.mangle?X(he[0]):he[0]),Fe="mailto:"+ue;else{var de;do de=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(de!==he[0]);ue=m(he[0]),he[1]==="www."?Fe="http://"+ue:Fe=ue}return{type:"link",raw:he[0],text:ue,href:Fe,tokens:[{type:"text",raw:ue,text:ue}]}}},$e.inlineText=function(Q,X){var he=this.rules.inline.text.exec(Q);if(he){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):m(he[0]):he[0]:ue=m(this.options.smartypants?X(he[0]):he[0]),{type:"text",raw:he[0],text:ue}}},De}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:S,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=i(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=i(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=i(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=i(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=i(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=i(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=l({},q),q.gfm=l({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=i(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=i(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=l({},q.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:S,paragraph:i(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var A={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:S,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:S,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};A._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",A.punctuation=i(A.punctuation).replace(/punctuation/g,A._punctuation).getRegex(),A.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,A.escapedEmSt=/\\\*|\\_/g,A._comment=i(q._comment).replace("(?:-->|$)","-->").getRegex(),A.emStrong.lDelim=i(A.emStrong.lDelim).replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimAst=i(A.emStrong.rDelimAst,"g").replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimUnd=i(A.emStrong.rDelimUnd,"g").replace(/punct/g,A._punctuation).getRegex(),A._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,A._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,A._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,A.autolink=i(A.autolink).replace("scheme",A._scheme).replace("email",A._email).getRegex(),A._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,A.tag=i(A.tag).replace("comment",A._comment).replace("attribute",A._attribute).getRegex(),A._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,A._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,A._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,A.link=i(A.link).replace("label",A._label).replace("href",A._href).replace("title",A._title).getRegex(),A.reflink=i(A.reflink).replace("label",A._label).replace("ref",q._label).getRegex(),A.nolink=i(A.nolink).replace("ref",q._label).getRegex(),A.reflinkSearch=i(A.reflinkSearch,"g").replace("reflink",A.reflink).replace("nolink",A.nolink).getRegex(),A.normal=l({},A),A.pedantic=l({},A.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",A._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",A._label).getRegex()}),A.gfm=l({},A.normal,{escape:i(A.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),A.gfm.url=i(A.gfm.url,"i").replace("email",A.gfm._extended_email).getRegex(),A.breaks=l({},A.gfm,{br:i(A.br).replace("{2,}","*").getRegex(),text:i(A.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(De){var $e="",ge,Q,X=De.length;for(ge=0;ge<X;ge++)Q=De.charCodeAt(ge),Math.random()>.5&&(Q="x"+Q.toString(16)),$e+="&#"+Q+";";return $e}var re=function(){function De(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||le.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:A.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=A.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=A.breaks:Q.inline=A.gfm),this.tokenizer.rules=Q}De.lex=function(Q,X){var he=new De(X);return he.lex(Q)},De.lexInline=function(Q,X){var he=new De(X);return he.inlineTokens(Q)};var $e=De.prototype;return $e.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var X;X=this.inlineQueue.shift();)this.inlineTokens(X.src,X.tokens);return this.tokens},$e.blockTokens=function(Q,X){var he=this;X===void 0&&(X=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(Ue,j,T){return j+"    ".repeat(T.length)});for(var ue,Fe,de,Re;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ue){return(ue=Ue.call({lexer:he},Q,X))?(Q=Q.substring(ue.raw.length),X.push(ue),!0):!1}))){if(ue=this.tokenizer.space(Q)){Q=Q.substring(ue.raw.length),ue.raw.length===1&&X.length>0?X[X.length-1].raw+=`
`:X.push(ue);continue}if(ue=this.tokenizer.code(Q)){Q=Q.substring(ue.raw.length),Fe=X[X.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ue.raw,Fe.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):X.push(ue);continue}if(ue=this.tokenizer.fences(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.heading(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.hr(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.blockquote(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.list(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.html(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.def(Q)){Q=Q.substring(ue.raw.length),Fe=X[X.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ue.raw,Fe.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.lheading(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(de=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ue=1/0,j=Q.slice(1),T=void 0;he.options.extensions.startBlock.forEach(function(G){T=G.call({lexer:this},j),typeof T=="number"&&T>=0&&(Ue=Math.min(Ue,T))}),Ue<1/0&&Ue>=0&&(de=Q.substring(0,Ue+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(de))){Fe=X[X.length-1],Re&&Fe.type==="paragraph"?(Fe.raw+=`
`+ue.raw,Fe.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):X.push(ue),Re=de.length!==Q.length,Q=Q.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(Q)){Q=Q.substring(ue.raw.length),Fe=X[X.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+ue.raw,Fe.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):X.push(ue);continue}if(Q){var Ne="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Ne);break}else throw new Error(Ne)}}return this.state.top=!0,X},$e.inline=function(Q,X){return X===void 0&&(X=[]),this.inlineQueue.push({src:Q,tokens:X}),X},$e.inlineTokens=function(Q,X){var he=this;X===void 0&&(X=[]);var ue,Fe,de,Re=Q,Ne,Ue,j;if(this.tokens.links){var T=Object.keys(this.tokens.links);if(T.length>0)for(;(Ne=this.tokenizer.rules.inline.reflinkSearch.exec(Re))!=null;)T.includes(Ne[0].slice(Ne[0].lastIndexOf("[")+1,-1))&&(Re=Re.slice(0,Ne.index)+"["+C("a",Ne[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ne=this.tokenizer.rules.inline.blockSkip.exec(Re))!=null;)Re=Re.slice(0,Ne.index)+"["+C("a",Ne[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ne=this.tokenizer.rules.inline.escapedEmSt.exec(Re))!=null;)Re=Re.slice(0,Ne.index)+"++"+Re.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(Ue||(j=""),Ue=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(ue=H.call({lexer:he},Q,X))?(Q=Q.substring(ue.raw.length),X.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.tag(Q)){Q=Q.substring(ue.raw.length),Fe=X[X.length-1],Fe&&ue.type==="text"&&Fe.type==="text"?(Fe.raw+=ue.raw,Fe.text+=ue.text):X.push(ue);continue}if(ue=this.tokenizer.link(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(ue.raw.length),Fe=X[X.length-1],Fe&&ue.type==="text"&&Fe.type==="text"?(Fe.raw+=ue.raw,Fe.text+=ue.text):X.push(ue);continue}if(ue=this.tokenizer.emStrong(Q,Re,j)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.codespan(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.br(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.del(Q)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.autolink(Q,K)){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(Q,K))){Q=Q.substring(ue.raw.length),X.push(ue);continue}if(de=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=Q.slice(1),ne=void 0;he.options.extensions.startInline.forEach(function(Oe){ne=Oe.call({lexer:this},ee),typeof ne=="number"&&ne>=0&&(H=Math.min(H,ne))}),H<1/0&&H>=0&&(de=Q.substring(0,H+1))}(),ue=this.tokenizer.inlineText(de,U)){Q=Q.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(j=ue.raw.slice(-1)),Ue=!0,Fe=X[X.length-1],Fe&&Fe.type==="text"?(Fe.raw+=ue.raw,Fe.text+=ue.text):X.push(ue);continue}if(Q){var G="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return X},I(De,null,[{key:"rules",get:function(){return{block:q,inline:A}}}]),De}(),ae=function(){function De(ge){this.options=ge||le.defaults}var $e=De.prototype;return $e.code=function(Q,X,he){var ue=(X||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(Q,ue);Fe!=null&&Fe!==Q&&(he=!0,Q=Fe)}return Q=Q.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+m(ue,!0)+'">'+(he?Q:m(Q,!0))+`</code></pre>
`:"<pre><code>"+(he?Q:m(Q,!0))+`</code></pre>
`},$e.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},$e.html=function(Q){return Q},$e.heading=function(Q,X,he,ue){if(this.options.headerIds){var Fe=this.options.headerPrefix+ue.slug(he);return"<h"+X+' id="'+Fe+'">'+Q+"</h"+X+`>
`}return"<h"+X+">"+Q+"</h"+X+`>
`},$e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},$e.list=function(Q,X,he){var ue=X?"ol":"ul",Fe=X&&he!==1?' start="'+he+'"':"";return"<"+ue+Fe+`>
`+Q+"</"+ue+`>
`},$e.listitem=function(Q){return"<li>"+Q+`</li>
`},$e.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},$e.paragraph=function(Q){return"<p>"+Q+`</p>
`},$e.table=function(Q,X){return X&&(X="<tbody>"+X+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+X+`</table>
`},$e.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},$e.tablecell=function(Q,X){var he=X.header?"th":"td",ue=X.align?"<"+he+' align="'+X.align+'">':"<"+he+">";return ue+Q+("</"+he+`>
`)},$e.strong=function(Q){return"<strong>"+Q+"</strong>"},$e.em=function(Q){return"<em>"+Q+"</em>"},$e.codespan=function(Q){return"<code>"+Q+"</code>"},$e.br=function(){return this.options.xhtml?"<br/>":"<br>"},$e.del=function(Q){return"<del>"+Q+"</del>"},$e.link=function(Q,X,he){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ue='<a href="'+m(Q)+'"';return X&&(ue+=' title="'+X+'"'),ue+=">"+he+"</a>",ue},$e.image=function(Q,X,he){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ue='<img src="'+Q+'" alt="'+he+'"';return X&&(ue+=' title="'+X+'"'),ue+=this.options.xhtml?"/>":">",ue},$e.text=function(Q){return Q},De}(),ye=function(){function De(){}var $e=De.prototype;return $e.strong=function(Q){return Q},$e.em=function(Q){return Q},$e.codespan=function(Q){return Q},$e.del=function(Q){return Q},$e.html=function(Q){return Q},$e.text=function(Q){return Q},$e.link=function(Q,X,he){return""+he},$e.image=function(Q,X,he){return""+he},$e.br=function(){return""},De}(),Pe=function(){function De(){this.seen={}}var $e=De.prototype;return $e.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},$e.getNextSafeSlug=function(Q,X){var he=Q,ue=0;if(this.seen.hasOwnProperty(he)){ue=this.seen[Q];do ue++,he=Q+"-"+ue;while(this.seen.hasOwnProperty(he))}return X||(this.seen[Q]=ue,this.seen[he]=0),he},$e.slug=function(Q,X){X===void 0&&(X={});var he=this.serialize(Q);return this.getNextSafeSlug(he,X.dryrun)},De}(),fe=function(){function De(ge){this.options=ge||le.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new Pe}De.parse=function(Q,X){var he=new De(X);return he.parse(Q)},De.parseInline=function(Q,X){var he=new De(X);return he.parseInline(Q)};var $e=De.prototype;return $e.parse=function(Q,X){X===void 0&&(X=!0);var he="",ue,Fe,de,Re,Ne,Ue,j,T,G,H,ee,ne,Oe,Be,Ke,_e,xe,et,tt,nt=Q.length;for(ue=0;ue<nt;ue++){if(H=Q[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(tt=this.options.extensions.renderers[H.type].call({parser:this},H),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){he+=tt||"";continue}switch(H.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(H.tokens),H.depth,o(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(T="",j="",Re=H.header.length,Fe=0;Fe<Re;Fe++)j+=this.renderer.tablecell(this.parseInline(H.header[Fe].tokens),{header:!0,align:H.align[Fe]});for(T+=this.renderer.tablerow(j),G="",Re=H.rows.length,Fe=0;Fe<Re;Fe++){for(Ue=H.rows[Fe],j="",Ne=Ue.length,de=0;de<Ne;de++)j+=this.renderer.tablecell(this.parseInline(Ue[de].tokens),{header:!1,align:H.align[de]});G+=this.renderer.tablerow(j)}he+=this.renderer.table(T,G);continue}case"blockquote":{G=this.parse(H.tokens),he+=this.renderer.blockquote(G);continue}case"list":{for(ee=H.ordered,ne=H.start,Oe=H.loose,Re=H.items.length,G="",Fe=0;Fe<Re;Fe++)Ke=H.items[Fe],_e=Ke.checked,xe=Ke.task,Be="",Ke.task&&(et=this.renderer.checkbox(_e),Oe?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=et+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=et+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:et}):Be+=et),Be+=this.parse(Ke.tokens,Oe),G+=this.renderer.listitem(Be,xe,_e);he+=this.renderer.list(G,ee,ne);continue}case"html":{he+=this.renderer.html(H.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(G=H.tokens?this.parseInline(H.tokens):H.text;ue+1<nt&&Q[ue+1].type==="text";)H=Q[++ue],G+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);he+=X?this.renderer.paragraph(G):G;continue}default:{var ct='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}}return he},$e.parseInline=function(Q,X){X=X||this.renderer;var he="",ue,Fe,de,Re=Q.length;for(ue=0;ue<Re;ue++){if(Fe=Q[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(de=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){he+=de||"";continue}switch(Fe.type){case"escape":{he+=X.text(Fe.text);break}case"html":{he+=X.html(Fe.text);break}case"link":{he+=X.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,X));break}case"image":{he+=X.image(Fe.href,Fe.title,Fe.text);break}case"strong":{he+=X.strong(this.parseInline(Fe.tokens,X));break}case"em":{he+=X.em(this.parseInline(Fe.tokens,X));break}case"codespan":{he+=X.codespan(Fe.text);break}case"br":{he+=X.br();break}case"del":{he+=X.del(this.parseInline(Fe.tokens,X));break}case"text":{he+=X.text(Fe.text);break}default:{var Ne='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}}return he},De}();function me(De,$e,ge){if(typeof De>"u"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof $e=="function"&&(ge=$e,$e=null),$e=l({},me.defaults,$e||{}),y($e),ge){var Q=$e.highlight,X;try{X=re.lex(De,$e)}catch(Re){return ge(Re)}var he=function(Ne){var Ue;if(!Ne)try{$e.walkTokens&&me.walkTokens(X,$e.walkTokens),Ue=fe.parse(X,$e)}catch(j){Ne=j}return $e.highlight=Q,Ne?ge(Ne):ge(null,Ue)};if(!Q||Q.length<3||(delete $e.highlight,!X.length))return he();var ue=0;me.walkTokens(X,function(Re){Re.type==="code"&&(ue++,setTimeout(function(){Q(Re.text,Re.lang,function(Ne,Ue){if(Ne)return he(Ne);Ue!=null&&Ue!==Re.text&&(Re.text=Ue,Re.escaped=!0),ue--,ue===0&&he()})},0))}),ue===0&&he();return}function Fe(Re){if(Re.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+m(Re.message+"",!0)+"</pre>";throw Re}try{var de=re.lex(De,$e);if($e.walkTokens){if($e.async)return Promise.all(me.walkTokens(de,$e.walkTokens)).then(function(){return fe.parse(de,$e)}).catch(Fe);me.walkTokens(de,$e.walkTokens)}return fe.parse(de,$e)}catch(Re){Fe(Re)}}me.options=me.setOptions=function(De){return l(me.defaults,De),b(me.defaults),me},me.getDefaults=M,me.defaults=le.defaults,me.use=function(){for(var De=arguments.length,$e=new Array(De),ge=0;ge<De;ge++)$e[ge]=arguments[ge];var Q=l.apply(void 0,[{}].concat($e)),X=me.defaults.extensions||{renderers:{},childTokens:{}},he;$e.forEach(function(ue){if(ue.extensions&&(he=!0,ue.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Re=X.renderers?X.renderers[de.name]:null;Re?X.renderers[de.name]=function(){for(var Ne=arguments.length,Ue=new Array(Ne),j=0;j<Ne;j++)Ue[j]=arguments[j];var T=de.renderer.apply(this,Ue);return T===!1&&(T=Re.apply(this,Ue)),T}:X.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");X[de.level]?X[de.level].unshift(de.tokenizer):X[de.level]=[de.tokenizer],de.start&&(de.level==="block"?X.startBlock?X.startBlock.push(de.start):X.startBlock=[de.start]:de.level==="inline"&&(X.startInline?X.startInline.push(de.start):X.startInline=[de.start]))}de.childTokens&&(X.childTokens[de.name]=de.childTokens)})),ue.renderer&&function(){var de=me.defaults.renderer||new ae,Re=function(j){var T=de[j];de[j]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var ne=ue.renderer[j].apply(de,H);return ne===!1&&(ne=T.apply(de,H)),ne}};for(var Ne in ue.renderer)Re(Ne);Q.renderer=de}(),ue.tokenizer&&function(){var de=me.defaults.tokenizer||new V,Re=function(j){var T=de[j];de[j]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var ne=ue.tokenizer[j].apply(de,H);return ne===!1&&(ne=T.apply(de,H)),ne}};for(var Ne in ue.tokenizer)Re(Ne);Q.tokenizer=de}(),ue.walkTokens){var Fe=me.defaults.walkTokens;Q.walkTokens=function(de){var Re=[];return Re.push(ue.walkTokens.call(this,de)),Fe&&(Re=Re.concat(Fe.call(this,de))),Re}}he&&(Q.extensions=X),me.setOptions(Q)})},me.walkTokens=function(De,$e){for(var ge=[],Q=function(){var Fe=he.value;switch(ge=ge.concat($e.call(me,Fe)),Fe.type){case"table":{for(var de=O(Fe.header),Re;!(Re=de()).done;){var Ne=Re.value;ge=ge.concat(me.walkTokens(Ne.tokens,$e))}for(var Ue=O(Fe.rows),j;!(j=Ue()).done;)for(var T=j.value,G=O(T),H;!(H=G()).done;){var ee=H.value;ge=ge.concat(me.walkTokens(ee.tokens,$e))}break}case"list":{ge=ge.concat(me.walkTokens(Fe.items,$e));break}default:me.defaults.extensions&&me.defaults.extensions.childTokens&&me.defaults.extensions.childTokens[Fe.type]?me.defaults.extensions.childTokens[Fe.type].forEach(function(ne){ge=ge.concat(me.walkTokens(Fe[ne],$e))}):Fe.tokens&&(ge=ge.concat(me.walkTokens(Fe.tokens,$e)))}},X=O(De),he;!(he=X()).done;)Q();return ge},me.parseInline=function(De,$e){if(typeof De>"u"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");$e=l({},me.defaults,$e||{}),y($e);try{var ge=re.lexInline(De,$e);return $e.walkTokens&&me.walkTokens(ge,$e.walkTokens),fe.parseInline(ge,$e)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+m(Q.message+"",!0)+"</pre>";throw Q}},me.Parser=fe,me.parser=fe.parse,me.Renderer=ae,me.TextRenderer=ye,me.Lexer=re,me.lexer=re.lex,me.Tokenizer=V,me.Slugger=Pe,me.parse=me;var Ae=me.options,ce=me.setOptions,Me=me.use,ie=me.walkTokens,z=me.parseInline,x=me,ve=fe.parse,Te=re.lex;le.Lexer=re,le.Parser=fe,le.Renderer=ae,le.Slugger=Pe,le.TextRenderer=ye,le.Tokenizer=V,le.getDefaults=M,le.lexer=Te,le.marked=me,le.options=Ae,le.parse=x,le.parseInline=z,le.parser=ve,le.setOptions=ce,le.use=Me,le.walkTokens=ie,Object.defineProperty(le,"__esModule",{value:!0})}),define(Ie[128],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=I;function I(r){const o=O(r);if(o&&o.length>0)return new Uint32Array(o)}let N=0;const R=new Uint32Array(10);function O(r){if(N=0,M(r,D,4352),N>0||(M(r,d,4449),N>0)||(M(r,v,4520),N>0)||(M(r,m,12593),N))return R.subarray(0,N);if(r>=44032&&r<=55203){const o=r-44032,s=o%588,i=Math.floor(o/588),n=Math.floor(s/28),c=s%28-1;if(i<D.length?M(i,D,0):4352+i-12593<m.length&&M(4352+i,m,12593),n<d.length?M(n,d,0):4449+n-12593<m.length&&M(4449+n-12593,m,12593),c>=0&&(c<v.length?M(c,v,0):4520+c-12593<m.length&&M(4520+c-12593,m,12593)),N>0)return R.subarray(0,N)}}function M(r,o,s){r>=s&&r<s+o.length&&b(o[r-s])}function b(r){r!==0&&(R[N++]=r&255,r>>8&&(R[N++]=r>>8&255),r>>16&&(R[N++]=r>>16&255))}var p;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var E;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(E||(E={}));var F;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(F||(F={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),d=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),v=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),m=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ie[129],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=void 0,e.$Am=I,e.rot=N;function I(b,p,E){return Math.min(Math.max(b,p),E)}function N(b,p){return(p+b%p)%p}class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Cm=R;class O{constructor(){this.a=1,this.b=0}update(p){return this.b=this.b+(p-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Dm=O;class M{constructor(p){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(p),this.c.fill(0,0,p)}update(p){const E=this.c[this.d];return this.c[this.d]=p,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=p,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Em=M}),define(Ie[130],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=O,e.$dd=d;class I{constructor(m,r,o){this.owner=m,this.debugNameSource=r,this.referenceFn=o}getDebugName(m){return O(m,this)}}e.$bd=I;const N=new Map,R=new WeakMap;function O(v,m){const r=R.get(v);if(r)return r;const o=M(v,m);if(o){let s=N.get(o)??0;s++,N.set(o,s);const i=s===1?o:`${o}#${s}`;return R.set(v,i),i}}function M(v,m){const r=R.get(v);if(r)return r;const o=m.owner?F(m.owner)+".":"";let s;const i=m.debugNameSource;if(i!==void 0)if(typeof i=="function"){if(s=i(),s!==void 0)return o+s}else return o+i;const n=m.referenceFn;if(n!==void 0&&(s=d(n),s!==void 0))return o+s;if(m.owner!==void 0){const c=b(m.owner,v);if(c!==void 0)return o+c}}function b(v,m){for(const r in v)if(v[r]===m)return r}const p=new Map,E=new WeakMap;function F(v){const m=E.get(v);if(m)return m;const r=D(v);let o=p.get(r)??0;o++,p.set(r,o);const s=o===1?r:`${r}#${o}`;return E.set(v,s),s}function D(v){const m=v.constructor;return m?m.name:"Object"}function d(v){const m=v.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(m);return(o?o[1]:void 0)?.trim()}}),define(Ie[131],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=N,e.$Jd=R;let I;function N(r){I=r}function R(){return I}class O{constructor(){this.a=0,this.d=new WeakMap}b(o){return M([b(v("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[b(" "),E(F(o.oldValue,70),{color:"red",strikeThrough:!0}),b(" "),E(F(o.newValue,60),{color:"green"})]:[b(" (unchanged)")]:[b(" "),E(F(o.newValue,60),{color:"green"}),b(" (initial)")]}handleObservableChanged(o,s){console.log(...this.b([p("observable value changed"),E(o.debugName,{color:"BlueViolet"}),...this.c(s)]))}formatChanges(o){if(o.size!==0)return E(" (changed deps: "+[...o].map(s=>s.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const s=o.handleChange;this.d.set(o,new Set),o.handleChange=(i,n)=>(this.d.get(o).add(i),s.apply(o,[i,n]))}handleDerivedRecomputed(o,s){const i=this.d.get(o);console.log(...this.b([p("derived recomputed"),E(o.debugName,{color:"BlueViolet"}),...this.c(s),this.formatChanges(i),{data:[{fn:o._computeFn}]}])),i.clear()}handleFromEventObservableTriggered(o,s){console.log(...this.b([p("observable from event triggered"),E(o.debugName,{color:"BlueViolet"}),...this.c(s),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const s=o.handleChange;this.d.set(o,new Set),o.handleChange=(i,n)=>(this.d.get(o).add(i),s.apply(o,[i,n]))}handleAutorunTriggered(o){const s=this.d.get(o);console.log(...this.b([p("autorun"),E(o.debugName,{color:"BlueViolet"}),this.formatChanges(s),{data:[{fn:o._runFn}]}])),s.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let s=o.getDebugName();s===void 0&&(s=""),console.log(...this.b([p("transaction"),E(s,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=O;function M(r){const o=new Array,s=[];let i="";function n(h){if("length"in h)for(const t of h)t&&n(t);else"text"in h?(i+=`%c${h.text}`,o.push(h.style),h.data&&s.push(...h.data)):"data"in h&&s.push(...h.data)}n(r);const c=[i,...o];return c.push(...s),c}function b(r){return E(r,{color:"black"})}function p(r){return E(m(`${r}: `,10),{color:"black",bold:!0})}function E(r,o={color:"black"}){function s(n){return Object.entries(n).reduce((c,[h,t])=>`${c}${h}:${t};`,"")}const i={color:o.color};return o.strikeThrough&&(i["text-decoration"]="line-through"),o.bold&&(i["font-weight"]="bold"),{text:r,style:s(i)}}function F(r,o){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=o?`"${r}"`:`"${r.substr(0,o-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?D(r,o):d(r,o);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function D(r,o){let s="[ ",i=!0;for(const n of r){if(i||(s+=", "),s.length-5>o){s+="...";break}i=!1,s+=`${F(n,o-s.length)}`}return s+=" ]",s}function d(r,o){let s="{ ",i=!0;for(const[n,c]of Object.entries(r)){if(i||(s+=", "),s.length-5>o){s+="...";break}i=!1,s+=`${n}: ${F(c,o-s.length)}`}return s+=" }",s}function v(r,o){let s="";for(let i=1;i<=o;i++)s+=r;return s}function m(r,o){for(;r.length<o;)r+=" ";return r}}),define(Ie[132],Ce([1,0,125,130,131]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$4d=e.$1d=e.$Vd=e.$Ud=void 0,e.$Rd=M,e.$Sd=p,e.$Td=F,e.$Wd=v,e.$Xd=r,e.$Yd=o,e.$Zd=s,e.$2d=n,e.$3d=c,e.$5d=t;let O;function M(a){O=a}let b;function p(a){b=a}let E;function F(a){E=a}class D{get TChange(){return null}reportChanges(){this.get()}read(g){return g?g.readObservable(this):this.get()}map(g,u){const S=u===void 0?void 0:g,l=u===void 0?g:u;return E({owner:S,debugName:()=>{const w=(0,N.$dd)(l);if(w!==void 0)return w;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(l.toString());if(k)return`${this.debugName}.${k[2]}`;if(!S)return`${this.debugName} (mapped)`},debugReferenceFn:l},w=>l(this.read(w),w))}recomputeInitiallyAndOnChange(g,u){return g.add(O(this,u)),this}keepObserved(g){return g.add(b(this)),this}get a(){return this.get()}}e.$Ud=D;class d extends D{constructor(){super(...arguments),this.b=new Set}addObserver(g){const u=this.b.size;this.b.add(g),u===0&&this.c()}removeObserver(g){this.b.delete(g)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Vd=d;function v(a,g){const u=new i(a,g);try{a(u)}finally{u.finish()}}let m;function r(a){if(m)a(m);else{const g=new i(a,void 0);m=g;try{a(g)}finally{g.finish(),m=void 0}}}async function o(a,g){const u=new i(a,g);try{await a(u)}finally{u.finish()}}function s(a,g,u){a?g(a):v(g,u)}class i{constructor(g,u){this._fn=g,this.b=u,this.a=[],(0,R.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,N.$dd)(this._fn)}updateObserver(g,u){this.a.push({observer:g,observable:u}),g.beginUpdate(u)}finish(){const g=this.a;for(let u=0;u<g.length;u++){const{observer:S,observable:l}=g[u];S.endUpdate(l)}this.a=null,(0,R.$Jd)()?.handleEndTransaction()}}e.$1d=i;function n(a,g){let u;return typeof a=="string"?u=new N.$bd(void 0,a,void 0):u=new N.$bd(a,void 0,void 0),new h(u,g,I.$7c)}function c(a,g){return new h(new N.$bd(a.owner,a.debugName,void 0),g,a.equalsFn??I.$7c)}class h extends d{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(g,u,S){super(),this.e=g,this.g=S,this.d=u}get(){return this.d}set(g,u,S){if(this.g(this.d,g))return;let l;u||(u=l=new i(()=>{},()=>`Setting ${this.debugName}`));try{const w=this.d;this.h(g),(0,R.$Jd)()?.handleObservableChanged(this,{oldValue:w,newValue:g,change:S,didChange:!0,hadValue:!0});for(const $ of this.b)u.updateObserver($,this),$.handleChange(this,S)}finally{l&&l.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(g){this.d=g}}e.$4d=h;function t(a,g){let u;return typeof a=="string"?u=new N.$bd(void 0,a,void 0):u=new N.$bd(a,void 0,void 0),new f(u,g,I.$7c)}class f extends h{h(g){this.d!==g&&(this.d&&this.d.dispose(),this.d=g)}dispose(){this.d?.dispose()}}e.$6d=f}),function(){function le(R){const O=[];typeof R=="number"&&O.push("code/timeOrigin",R);function M(p){O.push(p,Date.now())}function b(){const p=[];for(let E=0;E<O.length;E+=2)p.push({name:O[E],startTime:O[E+1]});return p}return{mark:M,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const M of performance.getEntriesByType("mark"))O.push({name:M.name,startTime:Math.round(R+M.startTime)});return O}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function I(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=I(N))}(),define(Ie[133],Ce([1,0,41]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dP=void 0;const N=Symbol("unset");class R{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||I.Iterable.empty()}insert(p,E,F){this.d(p,D=>D._value=E,F)}mutate(p,E){this.d(p,F=>F._value=E(F._value===N?void 0:F._value))}delete(p){const E=this.c(p);if(!E)return;let F=E.length-1;const D=E[F].node._value;if(D!==N){for(this.b--,E[F].node._value=N;F>0;F--){const{node:d,part:v}=E[F];if(d.children?.size||d._value!==N)break;E[F-1].node.children.delete(v)}return D}}*deleteRecursive(p){const E=this.c(p);if(!E)return;const F=E[E.length-1].node;for(let D=E.length-1;D>0;D--){const d=E[D-1];if(d.node.children.delete(E[D].part),d.node.children.size>0||d.node._value!==N)break}for(const D of O(F))D._value!==N&&(this.b--,yield D._value)}find(p){let E=this.a;for(const F of p){const D=E.children?.get(F);if(!D)return;E=D}return E._value===N?void 0:E._value}hasKeyOrParent(p){let E=this.a;for(const F of p){const D=E.children?.get(F);if(!D)return!1;if(D._value!==N)return!0;E=D}return!1}hasKeyOrChildren(p){let E=this.a;for(const F of p){const D=E.children?.get(F);if(!D)return!1;E=D}return!0}hasKey(p){let E=this.a;for(const F of p){const D=E.children?.get(F);if(!D)return!1;E=D}return E._value!==N}c(p){const E=[{part:"",node:this.a}];let F=0;for(const D of p){const d=E[F].node.children?.get(D);if(!d)return;E.push({part:D,node:d}),F++}return E}d(p,E,F){let D=this.a;for(const m of p){if(D.children)if(D.children.has(m))D=D.children.get(m);else{const r=new M;D.children.set(m,r),D=r}else{const r=new M;D.children=new Map([[m,r]]),D=r}F?.(D)}const d=D._value===N?0:1;E(D);const v=D._value===N?0:1;this.b+=v-d}*values(){for(const{_value:p}of O(this.a))p!==N&&(yield p)}}e.$dP=R;function*O(b){const p=[b];for(;p.length>0;){const E=p.pop();if(yield E,E.children)for(const F of E.children.values())p.push(F)}}class M{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value(p){this._value=p===void 0?N:p}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var N in I)(typeof exports=="object"?exports:le)[N]=I[N]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function I(N){if(e[N])return e[N].exports;var R=e[N]={i:N,l:!1,exports:{}};return le[N].call(R.exports,R,R.exports,I),R.l=!0,R.exports}return I.m=le,I.c=e,I.d=function(N,R,O){I.o(N,R)||Object.defineProperty(N,R,{enumerable:!0,get:O})},I.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},I.t=function(N,R){if(1&R&&(N=I(N)),8&R||4&R&&typeof N=="object"&&N&&N.__esModule)return N;var O=Object.create(null);if(I.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:N}),2&R&&typeof N!="string")for(var M in N)I.d(O,M,function(b){return N[b]}.bind(null,M));return O},I.n=function(N){var R=N&&N.__esModule?function(){return N.default}:function(){return N};return I.d(R,"a",R),R},I.o=function(N,R){return Object.prototype.hasOwnProperty.call(N,R)},I.p="",I(I.s=0)}([function(le,e,I){(function(N){var R;e=le.exports=Me,R=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var T=Array.prototype.slice.call(arguments,0);T.unshift("SEMVER"),console.log.apply(console,T)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],p=e.src=[],E=0,F=E++;p[F]="0|[1-9]\\d*";var D=E++;p[D]="[0-9]+";var d=E++;p[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=E++;p[v]="("+p[F]+")\\.("+p[F]+")\\.("+p[F]+")";var m=E++;p[m]="("+p[D]+")\\.("+p[D]+")\\.("+p[D]+")";var r=E++;p[r]="(?:"+p[F]+"|"+p[d]+")";var o=E++;p[o]="(?:"+p[D]+"|"+p[d]+")";var s=E++;p[s]="(?:-("+p[r]+"(?:\\."+p[r]+")*))";var i=E++;p[i]="(?:-?("+p[o]+"(?:\\."+p[o]+")*))";var n=E++;p[n]="[0-9A-Za-z-]+";var c=E++;p[c]="(?:\\+("+p[n]+"(?:\\."+p[n]+")*))";var h=E++,t="v?"+p[v]+p[s]+"?"+p[c]+"?";p[h]="^"+t+"$";var f="[v=\\s]*"+p[m]+p[i]+"?"+p[c]+"?",a=E++;p[a]="^"+f+"$";var g=E++;p[g]="((?:<|>)?=?)";var u=E++;p[u]=p[D]+"|x|X|\\*";var S=E++;p[S]=p[F]+"|x|X|\\*";var l=E++;p[l]="[v=\\s]*("+p[S]+")(?:\\.("+p[S]+")(?:\\.("+p[S]+")(?:"+p[s]+")?"+p[c]+"?)?)?";var w=E++;p[w]="[v=\\s]*("+p[u]+")(?:\\.("+p[u]+")(?:\\.("+p[u]+")(?:"+p[i]+")?"+p[c]+"?)?)?";var $=E++;p[$]="^"+p[g]+"\\s*"+p[l]+"$";var k=E++;p[k]="^"+p[g]+"\\s*"+p[w]+"$";var y=E++;p[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=E++;p[C]="(?:~>?)";var P=E++;p[P]="(\\s*)"+p[C]+"\\s+",b[P]=new RegExp(p[P],"g");var W=E++;p[W]="^"+p[C]+p[l]+"$";var V=E++;p[V]="^"+p[C]+p[w]+"$";var q=E++;p[q]="(?:\\^)";var A=E++;p[A]="(\\s*)"+p[q]+"\\s+",b[A]=new RegExp(p[A],"g");var U=E++;p[U]="^"+p[q]+p[l]+"$";var K=E++;p[K]="^"+p[q]+p[w]+"$";var re=E++;p[re]="^"+p[g]+"\\s*("+f+")$|^$";var ae=E++;p[ae]="^"+p[g]+"\\s*("+t+")$|^$";var ye=E++;p[ye]="(\\s*)"+p[g]+"\\s*("+f+"|"+p[l]+")",b[ye]=new RegExp(p[ye],"g");var Pe=E++;p[Pe]="^\\s*("+p[l]+")\\s+-\\s+("+p[l]+")\\s*$";var fe=E++;p[fe]="^\\s*("+p[w]+")\\s+-\\s+("+p[w]+")\\s*$";var me=E++;p[me]="(<|>)?=?\\s*\\*";for(var Ae=0;Ae<35;Ae++)R(Ae,p[Ae]),b[Ae]||(b[Ae]=new RegExp(p[Ae]));function ce(T,G){if(T instanceof Me)return T;if(typeof T!="string"||T.length>O||!(G?b[a]:b[h]).test(T))return null;try{return new Me(T,G)}catch{return null}}function Me(T,G){if(T instanceof Me){if(T.loose===G)return T;T=T.version}else if(typeof T!="string")throw new TypeError("Invalid Version: "+T);if(T.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Me))return new Me(T,G);R("SemVer",T,G),this.loose=G;var H=T.trim().match(G?b[a]:b[h]);if(!H)throw new TypeError("Invalid Version: "+T);if(this.raw=T,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var ne=+ee;if(ne>=0&&ne<M)return ne}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=ce,e.valid=function(T,G){var H=ce(T,G);return H?H.version:null},e.clean=function(T,G){var H=ce(T.trim().replace(/^[=v]+/,""),G);return H?H.version:null},e.SemVer=Me,Me.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Me.prototype.toString=function(){return this.version},Me.prototype.compare=function(T){return R("SemVer.compare",this.version,this.loose,T),T instanceof Me||(T=new Me(T,this.loose)),this.compareMain(T)||this.comparePre(T)},Me.prototype.compareMain=function(T){return T instanceof Me||(T=new Me(T,this.loose)),z(this.major,T.major)||z(this.minor,T.minor)||z(this.patch,T.patch)},Me.prototype.comparePre=function(T){if(T instanceof Me||(T=new Me(T,this.loose)),this.prerelease.length&&!T.prerelease.length)return-1;if(!this.prerelease.length&&T.prerelease.length)return 1;if(!this.prerelease.length&&!T.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],ee=T.prerelease[G];if(R("prerelease compare",G,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return z(H,ee)}while(++G)},Me.prototype.inc=function(T,G){switch(T){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+T)}return this.format(),this.raw=this.version,this},e.inc=function(T,G,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new Me(T,H).inc(G,ee).version}catch{return null}},e.diff=function(T,G){if(De(T,G))return null;var H=ce(T),ee=ce(G);if(H.prerelease.length||ee.prerelease.length){for(var ne in H)if((ne==="major"||ne==="minor"||ne==="patch")&&H[ne]!==ee[ne])return"pre"+ne;return"prerelease"}for(var ne in H)if((ne==="major"||ne==="minor"||ne==="patch")&&H[ne]!==ee[ne])return ne},e.compareIdentifiers=z;var ie=/^[0-9]+$/;function z(T,G){var H=ie.test(T),ee=ie.test(G);return H&&ee&&(T=+T,G=+G),H&&!ee?-1:ee&&!H?1:T<G?-1:T>G?1:0}function x(T,G,H){return new Me(T,H).compare(new Me(G,H))}function ve(T,G,H){return x(T,G,H)>0}function Te(T,G,H){return x(T,G,H)<0}function De(T,G,H){return x(T,G,H)===0}function $e(T,G,H){return x(T,G,H)!==0}function ge(T,G,H){return x(T,G,H)>=0}function Q(T,G,H){return x(T,G,H)<=0}function X(T,G,H,ee){var ne;switch(G){case"===":typeof T=="object"&&(T=T.version),typeof H=="object"&&(H=H.version),ne=T===H;break;case"!==":typeof T=="object"&&(T=T.version),typeof H=="object"&&(H=H.version),ne=T!==H;break;case"":case"=":case"==":ne=De(T,H,ee);break;case"!=":ne=$e(T,H,ee);break;case">":ne=ve(T,H,ee);break;case">=":ne=ge(T,H,ee);break;case"<":ne=Te(T,H,ee);break;case"<=":ne=Q(T,H,ee);break;default:throw new TypeError("Invalid operator: "+G)}return ne}function he(T,G){if(T instanceof he){if(T.loose===G)return T;T=T.value}if(!(this instanceof he))return new he(T,G);R("comparator",T,G),this.loose=G,this.parse(T),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(T,G){return z(G,T)},e.major=function(T,G){return new Me(T,G).major},e.minor=function(T,G){return new Me(T,G).minor},e.patch=function(T,G){return new Me(T,G).patch},e.compare=x,e.compareLoose=function(T,G){return x(T,G,!0)},e.rcompare=function(T,G,H){return x(G,T,H)},e.sort=function(T,G){return T.sort(function(H,ee){return e.compare(H,ee,G)})},e.rsort=function(T,G){return T.sort(function(H,ee){return e.rcompare(H,ee,G)})},e.gt=ve,e.lt=Te,e.eq=De,e.neq=$e,e.gte=ge,e.lte=Q,e.cmp=X,e.Comparator=he;var ue={};function Fe(T,G){if(T instanceof Fe)return T.loose===G?T:new Fe(T.raw,G);if(T instanceof he)return new Fe(T.value,G);if(!(this instanceof Fe))return new Fe(T,G);if(this.loose=G,this.raw=T,this.set=T.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+T);this.format()}function de(T){return!T||T.toLowerCase()==="x"||T==="*"}function Re(T,G,H,ee,ne,Oe,Be,Ke,_e,xe,et,tt,nt){return((G=de(H)?"":de(ee)?">="+H+".0.0":de(ne)?">="+H+"."+ee+".0":">="+G)+" "+(Ke=de(_e)?"":de(xe)?"<"+(+_e+1)+".0.0":de(et)?"<"+_e+"."+(+xe+1)+".0":tt?"<="+_e+"."+xe+"."+et+"-"+tt:"<="+Ke)).trim()}function Ne(T,G){for(var H=0;H<T.length;H++)if(!T[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<T.length;H++)if(R(T[H].semver),T[H].semver!==ue&&T[H].semver.prerelease.length>0){var ee=T[H].semver;if(ee.major===G.major&&ee.minor===G.minor&&ee.patch===G.patch)return!0}return!1}return!0}function Ue(T,G,H){try{G=new Fe(G,H)}catch{return!1}return G.test(T)}function j(T,G,H,ee){var ne,Oe,Be,Ke,_e;switch(T=new Me(T,ee),G=new Fe(G,ee),H){case">":ne=ve,Oe=Q,Be=Te,Ke=">",_e=">=";break;case"<":ne=Te,Oe=ge,Be=ve,Ke="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(T,G,ee))return!1;for(var xe=0;xe<G.set.length;++xe){var et=G.set[xe],tt=null,nt=null;if(et.forEach(function(ct){ct.semver===ue&&(ct=new he(">=0.0.0")),tt=tt||ct,nt=nt||ct,ne(ct.semver,tt.semver,ee)?tt=ct:Be(ct.semver,nt.semver,ee)&&(nt=ct)}),tt.operator===Ke||tt.operator===_e||(!nt.operator||nt.operator===Ke)&&Oe(T,nt.semver)||nt.operator===_e&&Be(T,nt.semver))return!1}return!0}he.prototype.parse=function(T){var G=this.loose?b[re]:b[ae],H=T.match(G);if(!H)throw new TypeError("Invalid comparator: "+T);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Me(H[2],this.loose):this.semver=ue},he.prototype.toString=function(){return this.value},he.prototype.test=function(T){return R("Comparator.test",T,this.loose),this.semver===ue||(typeof T=="string"&&(T=new Me(T,this.loose)),X(T,this.operator,this.semver,this.loose))},he.prototype.intersects=function(T,G){if(!(T instanceof he))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Fe(T.value,G),Ue(this.value,H,G);if(T.operator==="")return H=new Fe(this.value,G),Ue(T.semver,H,G);var ee=!(this.operator!==">="&&this.operator!==">"||T.operator!==">="&&T.operator!==">"),ne=!(this.operator!=="<="&&this.operator!=="<"||T.operator!=="<="&&T.operator!=="<"),Oe=this.semver.version===T.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||T.operator!==">="&&T.operator!=="<="),Ke=X(this.semver,"<",T.semver,G)&&(this.operator===">="||this.operator===">")&&(T.operator==="<="||T.operator==="<"),_e=X(this.semver,">",T.semver,G)&&(this.operator==="<="||this.operator==="<")&&(T.operator===">="||T.operator===">");return ee||ne||Oe&&Be||Ke||_e},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(T){return T.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(T){var G=this.loose;T=T.trim(),R("range",T,G);var H=G?b[fe]:b[Pe];T=T.replace(H,Re),R("hyphen replace",T),T=T.replace(b[ye],"$1$2$3"),R("comparator trim",T,b[ye]),T=(T=(T=T.replace(b[P],"$1~")).replace(b[A],"$1^")).split(/\s+/).join(" ");var ee=G?b[re]:b[ae],ne=T.split(" ").map(function(Oe){return function(Be,Ke){return R("comp",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,nt){R("caret",tt,nt);var ct=nt?b[K]:b[U];return tt.replace(ct,function(mt,je,st,Z,Y){var pe;return R("caret",tt,mt,je,st,Z,Y),de(je)?pe="":de(st)?pe=">="+je+".0.0 <"+(+je+1)+".0.0":de(Z)?pe=je==="0"?">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":">="+je+"."+st+".0 <"+(+je+1)+".0.0":Y?(R("replaceCaret pr",Y),Y.charAt(0)!=="-"&&(Y="-"+Y),pe=je==="0"?st==="0"?">="+je+"."+st+"."+Z+Y+" <"+je+"."+st+"."+(+Z+1):">="+je+"."+st+"."+Z+Y+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+Z+Y+" <"+(+je+1)+".0.0"):(R("no pr"),pe=je==="0"?st==="0"?">="+je+"."+st+"."+Z+" <"+je+"."+st+"."+(+Z+1):">="+je+"."+st+"."+Z+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+Z+" <"+(+je+1)+".0.0"),R("caret return",pe),pe})}(et,xe)}).join(" ")}(Be,Ke),R("caret",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,nt){var ct=nt?b[V]:b[W];return tt.replace(ct,function(mt,je,st,Z,Y){var pe;return R("tilde",tt,mt,je,st,Z,Y),de(je)?pe="":de(st)?pe=">="+je+".0.0 <"+(+je+1)+".0.0":de(Z)?pe=">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":Y?(R("replaceTilde pr",Y),Y.charAt(0)!=="-"&&(Y="-"+Y),pe=">="+je+"."+st+"."+Z+Y+" <"+je+"."+(+st+1)+".0"):pe=">="+je+"."+st+"."+Z+" <"+je+"."+(+st+1)+".0",R("tilde return",pe),pe})}(et,xe)}).join(" ")}(Be,Ke),R("tildes",Be),Be=function(_e,xe){return R("replaceXRanges",_e,xe),_e.split(/\s+/).map(function(et){return function(tt,nt){tt=tt.trim();var ct=nt?b[k]:b[$];return tt.replace(ct,function(mt,je,st,Z,Y,pe){R("xRange",tt,mt,je,st,Z,Y,pe);var Ge=de(st),we=Ge||de(Z),ot=we||de(Y);return je==="="&&ot&&(je=""),Ge?mt=je===">"||je==="<"?"<0.0.0":"*":je&&ot?(we&&(Z=0),ot&&(Y=0),je===">"?(je=">=",we?(st=+st+1,Z=0,Y=0):ot&&(Z=+Z+1,Y=0)):je==="<="&&(je="<",we?st=+st+1:Z=+Z+1),mt=je+st+"."+Z+"."+Y):we?mt=">="+st+".0.0 <"+(+st+1)+".0.0":ot&&(mt=">="+st+"."+Z+".0 <"+st+"."+(+Z+1)+".0"),R("xRange return",mt),mt})}(et,xe)}).join(" ")}(Be,Ke),R("xrange",Be),Be=function(_e,xe){return R("replaceStars",_e,xe),_e.trim().replace(b[me],"")}(Be,Ke),R("stars",Be),Be}(Oe,G)}).join(" ").split(/\s+/);return this.loose&&(ne=ne.filter(function(Oe){return!!Oe.match(ee)})),ne=ne.map(function(Oe){return new he(Oe,G)})},Fe.prototype.intersects=function(T,G){if(!(T instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return T.set.some(function(ne){return ne.every(function(Oe){return ee.intersects(Oe,G)})})})})},e.toComparators=function(T,G){return new Fe(T,G).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(T){if(!T)return!1;typeof T=="string"&&(T=new Me(T,this.loose));for(var G=0;G<this.set.length;G++)if(Ne(this.set[G],T))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(T,G,H){var ee=null,ne=null;try{var Oe=new Fe(G,H)}catch{return null}return T.forEach(function(Be){Oe.test(Be)&&(ee&&ne.compare(Be)!==-1||(ne=new Me(ee=Be,H)))}),ee},e.minSatisfying=function(T,G,H){var ee=null,ne=null;try{var Oe=new Fe(G,H)}catch{return null}return T.forEach(function(Be){Oe.test(Be)&&(ee&&ne.compare(Be)!==1||(ne=new Me(ee=Be,H)))}),ee},e.validRange=function(T,G){try{return new Fe(T,G).range||"*"}catch{return null}},e.ltr=function(T,G,H){return j(T,G,"<",H)},e.gtr=function(T,G,H){return j(T,G,">",H)},e.outside=j,e.prerelease=function(T,G){var H=ce(T,G);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(T,G,H){return T=new Fe(T,H),G=new Fe(G,H),T.intersects(G)},e.coerce=function(T){if(T instanceof Me)return T;if(typeof T!="string")return null;var G=T.match(b[y]);return G==null?null:ce((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,I(1))},function(le,e){var I,N,R=le.exports={};function O(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function b(o){if(I===setTimeout)return setTimeout(o,0);if((I===O||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:O}catch{I=O}try{N=typeof clearTimeout=="function"?clearTimeout:M}catch{N=M}})();var p,E=[],F=!1,D=-1;function d(){F&&p&&(F=!1,p.length?E=p.concat(E):D=-1,E.length&&v())}function v(){if(!F){var o=b(d);F=!0;for(var s=E.length;s;){for(p=E,E=[];++D<s;)p&&p[D].run();D=-1,s=E.length}p=null,F=!1,function(i){if(N===clearTimeout)return clearTimeout(i);if((N===M||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(i);try{N(i)}catch{try{return N.call(null,i)}catch{return N.call(this,i)}}}(o)}}function m(o,s){this.fun=o,this.array=s}function r(){}R.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];E.push(new m(o,s)),E.length!==1||F||b(v)},m.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=r,R.addListener=r,R.once=r,R.off=r,R.removeListener=r,R.removeAllListeners=r,R.emit=r,R.prependListener=r,R.prependOnceListener=r,R.listeners=function(o){return[]},R.binding=function(o){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(o){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Ie[134],Ce([1,0,14,6]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=R,e.$re=O,e.$se=M,e.$te=b,e.$ue=E,e.$ve=F,e.$we=D,e.$xe=d,e.$ye=v,e.$ze=m,e.$Ae=r,e.$Be=o,e.$Ce=s,e.$De=i,e.$Ee=n;function R(c){const h=c;return h?typeof h.read=="function":!1}function O(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}function M(c){const h=c;return h?O(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function b(c,h){return new p(c,h)}class p{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,I.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let f;switch(h){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const a=f.indexOf(t);a>=0&&f.splice(a,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(c,h){const t=[];let f;for(;(f=c.read())!==null;)t.push(f);return h(t)}function F(c,h,t){const f=[];let a;for(;(a=c.read())!==null&&f.length<t;)f.push(a);return a===null&&f.length>0?h(f):{read:()=>{if(f.length>0)return f.shift();if(typeof a<"u"){const g=a;return a=void 0,g}return c.read()}}}function D(c,h){return new Promise((t,f)=>{const a=[];d(c,{onData:g=>{h&&a.push(g)},onError:g=>{h?f(g):t(void 0)},onEnd:()=>{t(h?h(a):void 0)}})})}function d(c,h,t){c.on("error",f=>{t?.isCancellationRequested||h.onError(f)}),c.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),c.on("data",f=>{t?.isCancellationRequested||h.onData(f)})}function v(c,h){return new Promise((t,f)=>{const a=new N.$Uc,g=[],u=w=>{if(g.push(w),g.length>h)return a.dispose(),c.pause(),t({stream:c,buffer:g,ended:!1})},S=w=>(a.dispose(),f(w)),l=()=>(a.dispose(),t({stream:c,buffer:g,ended:!0}));a.add((0,N.$Tc)(()=>c.removeListener("error",S))),c.on("error",S),a.add((0,N.$Tc)(()=>c.removeListener("end",l))),c.on("end",l),a.add((0,N.$Tc)(()=>c.removeListener("data",u))),c.on("data",u)})}function m(c,h){const t=b(h);return t.end(c),t}function r(){const c=b(()=>{throw new Error("not supported")});return c.end(),c}function o(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}function s(c,h,t){const f=b(t);return d(c,{onData:a=>f.write(h.data(a)),onError:a=>f.error(h.error?h.error(a):a),onEnd:()=>f.end()}),f}function i(c,h,t){let f=!1;return{read:()=>{const a=h.read();return f?a:(f=!0,a!==null?t([c,a]):c)}}}function n(c,h,t){let f=!1;const a=b(t);return d(h,{onData:g=>f?a.write(g):(f=!0,a.write(t([c,g]))),onError:g=>a.error(g),onEnd:()=>{f||(f=!0,a.write(c)),a.end()}}),a}}),define(Ie[21],Ce([1,0,42,134]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=void 0,e.$Ge=E,e.$He=F,e.$Ie=D,e.$Je=d,e.$Ke=v,e.$Le=m,e.$Me=r,e.$Ne=o,e.$Oe=s,e.$Pe=i,e.$Qe=n,e.$Re=c,e.$Se=h,e.$Te=t,e.$Ue=f,e.$Ve=a,e.$We=g,e.$Xe=u,e.$Ye=S,e.$Ze=$;const R=typeof Buffer<"u",O=new I.$V(()=>new Uint8Array(256));let M,b;class p{static alloc(y){return R?new p(Buffer.allocUnsafe(y)):new p(new Uint8Array(y))}static wrap(y){return R&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new p(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&R?new p(Buffer.from(y)):(M||(M=new TextEncoder),new p(M.encode(y)))}static fromByteArray(y){const C=p.alloc(y.length);for(let P=0,W=y.length;P<W;P++)C.buffer[P]=y[P];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let V=0,q=y.length;V<q;V++)C+=y[V].byteLength}const P=p.alloc(C);let W=0;for(let V=0,q=y.length;V<q;V++){const A=y[V];P.set(A,W),W+=A.byteLength}return P}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=p.alloc(this.byteLength);return y.set(this),y}toString(){return R?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(y,C){return new p(this.buffer.subarray(y,C))}set(y,C){if(y instanceof p)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return d(this.buffer,y)}writeUInt32BE(y,C){v(this.buffer,y,C)}readUInt32LE(y){return m(this.buffer,y)}writeUInt32LE(y,C){r(this.buffer,y,C)}readUInt8(y){return o(this.buffer,y)}writeUInt8(y,C){s(this.buffer,y,C)}indexOf(y,C=0){return E(this.buffer,y instanceof p?y.buffer:y,C)}}e.$Fe=p;function E(k,y,C=0){const P=y.byteLength,W=k.byteLength;if(P===0)return 0;if(P===1)return k.indexOf(y[0]);if(P>W-C)return-1;const V=O.value;V.fill(y.length);for(let K=0;K<y.length;K++)V[y[K]]=y.length-K-1;let q=C+y.length-1,A=q,U=-1;for(;q<W;)if(k[q]===y[A]){if(A===0){U=q;break}q--,A--}else q+=Math.max(y.length-A,V[k[q]]),A=y.length-1;return U}function F(k,y){return k[y+0]<<0>>>0|k[y+1]<<8>>>0}function D(k,y,C){k[C+0]=y&255,y=y>>>8,k[C+1]=y&255}function d(k,y){return k[y]*2**24+k[y+1]*2**16+k[y+2]*2**8+k[y+3]}function v(k,y,C){k[C+3]=y,y=y>>>8,k[C+2]=y,y=y>>>8,k[C+1]=y,y=y>>>8,k[C]=y}function m(k,y){return k[y+0]<<0>>>0|k[y+1]<<8>>>0|k[y+2]<<16>>>0|k[y+3]<<24>>>0}function r(k,y,C){k[C+0]=y&255,y=y>>>8,k[C+1]=y&255,y=y>>>8,k[C+2]=y&255,y=y>>>8,k[C+3]=y&255}function o(k,y){return k[y]}function s(k,y,C){k[C]=y}function i(k){return N.$ue(k,y=>p.concat(y))}function n(k){return N.$Be(k)}function c(k){return N.$we(k,y=>p.concat(y))}async function h(k){return k.ended?p.concat(k.buffer):p.concat([...k.buffer,await c(k.stream)])}function t(k){return N.$ze(k,y=>p.concat(y))}function f(k){return N.$Ce(k,{data:y=>typeof y=="string"?p.fromString(y):p.wrap(y)},y=>p.concat(y))}function a(k){return N.$te(y=>p.concat(y),k)}function g(k,y){return N.$De(k,y,C=>p.concat(C))}function u(k,y){return N.$Ee(k,y,C=>p.concat(C))}function S(k){let y=0,C=0,P=0;const W=new Uint8Array(Math.floor(k.length/4*3)),V=A=>{switch(C){case 3:W[P++]=y|A,C=0;break;case 2:W[P++]=y|A>>>2,y=A<<6,C=3;break;case 1:W[P++]=y|A>>>4,y=A<<4,C=2;break;default:y=A<<2,C=1}};for(let A=0;A<k.length;A++){const U=k.charCodeAt(A);if(U>=65&&U<=90)V(U-65);else if(U>=97&&U<=122)V(U-97+26);else if(U>=48&&U<=57)V(U-48+52);else if(U===43||U===45)V(62);else if(U===47||U===95)V(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${k[A]}`)}}const q=P;for(;C>0;)V(0);return p.wrap(W).slice(0,q)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:k},y=!0,C=!1){const P=C?w:l;let W="";const V=k.byteLength%3;let q=0;for(;q<k.byteLength-V;q+=3){const A=k[q+0],U=k[q+1],K=k[q+2];W+=P[A>>>2],W+=P[(A<<4|U>>>4)&63],W+=P[(U<<2|K>>>6)&63],W+=P[K&63]}if(V===1){const A=k[q+0];W+=P[A>>>2],W+=P[A<<4&63],y&&(W+="==")}else if(V===2){const A=k[q+0],U=k[q+1];W+=P[A>>>2],W+=P[(A<<4|U>>>4)&63],W+=P[U<<2&63],y&&(W+="=")}return W}}),define(Ie[135],Ce([1,0,28,128,13]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.FuzzyScore=e.$xk=e.$wk=void 0,e.or=O,e.$yk=b,e.$zk=p,e.$Ak=D,e.$Bk=S,e.$Ck=l,e.$Dk=P,e.$Ek=W,e.$Fk=V,e.$Gk=q,e.$Hk=x,e.$Jk=$e,e.$Kk=X,e.$Lk=he;function O(...de){return function(Re,Ne){for(let Ue=0,j=de.length;Ue<j;Ue++){const T=de[Ue](Re,Ne);if(T)return T}return null}}e.$wk=M.bind(void 0,!1),e.$xk=M.bind(void 0,!0);function M(de,Re,Ne){if(!Ne||Ne.length<Re.length)return null;let Ue;return de?Ue=R.$yf(Ne,Re):Ue=Ne.indexOf(Re)===0,Ue?Re.length>0?[{start:0,end:Re.length}]:[]:null}function b(de,Re){const Ne=Re.toLowerCase().indexOf(de.toLowerCase());return Ne===-1?null:[{start:Ne,end:Ne+de.length}]}function p(de,Re){return E(de.toLowerCase(),Re.toLowerCase(),0,0)}function E(de,Re,Ne,Ue){if(Ne===de.length)return[];if(Ue===Re.length)return null;if(de[Ne]===Re[Ue]){let j=null;return(j=E(de,Re,Ne+1,Ue+1))?c({start:Ue,end:Ue+1},j):null}return E(de,Re,Ne,Ue+1)}function F(de){return 97<=de&&de<=122}function D(de){return 65<=de&&de<=90}function d(de){return 48<=de&&de<=57}function v(de){return de===32||de===9||de===10||de===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>m.add(de.charCodeAt(0)));function r(de){return v(de)||m.has(de)}function o(de,Re){return de===Re||r(de)&&r(Re)}const s=new Map;function i(de){if(s.has(de))return s.get(de);let Re;const Ne=(0,N.$uk)(de);return Ne&&(Re=Ne),s.set(de,Re),Re}function n(de){return F(de)||D(de)||d(de)}function c(de,Re){return Re.length===0?Re=[de]:de.end===Re[0].start?Re[0].start=de.start:Re.unshift(de),Re}function h(de,Re){for(let Ne=Re;Ne<de.length;Ne++){const Ue=de.charCodeAt(Ne);if(D(Ue)||d(Ue)||Ne>0&&!n(de.charCodeAt(Ne-1)))return Ne}return de.length}function t(de,Re,Ne,Ue){if(Ne===de.length)return[];if(Ue===Re.length)return null;if(de[Ne]!==Re[Ue].toLowerCase())return null;{let j=null,T=Ue+1;for(j=t(de,Re,Ne+1,Ue+1);!j&&(T=h(Re,T))<Re.length;)j=t(de,Re,Ne+1,T),T++;return j===null?null:c({start:Ue,end:Ue+1},j)}}function f(de){let Re=0,Ne=0,Ue=0,j=0,T=0;for(let Oe=0;Oe<de.length;Oe++)T=de.charCodeAt(Oe),D(T)&&Re++,F(T)&&Ne++,n(T)&&Ue++,d(T)&&j++;const G=Re/de.length,H=Ne/de.length,ee=Ue/de.length,ne=j/de.length;return{upperPercent:G,lowerPercent:H,alphaPercent:ee,numericPercent:ne}}function a(de){const{upperPercent:Re,lowerPercent:Ne}=de;return Ne===0&&Re>.6}function g(de){const{upperPercent:Re,lowerPercent:Ne,alphaPercent:Ue,numericPercent:j}=de;return Ne>.2&&Re<.8&&Ue>.6&&j<.2}function u(de){let Re=0,Ne=0,Ue=0,j=0;for(let T=0;T<de.length;T++)Ue=de.charCodeAt(T),D(Ue)&&Re++,F(Ue)&&Ne++,v(Ue)&&j++;return(Re===0||Ne===0)&&j===0?de.length<=30:Re<=5}function S(de,Re){if(!Re||(Re=Re.trim(),Re.length===0)||!u(de))return null;Re.length>60&&(Re=Re.substring(0,60));const Ne=f(Re);if(!g(Ne)){if(!a(Ne))return null;Re=Re.toLowerCase()}let Ue=null,j=0;for(de=de.toLowerCase();j<Re.length&&(Ue=t(de,Re,0,j))===null;)j=h(Re,j+1);return Ue}function l(de,Re,Ne=!1){if(!Re||Re.length===0)return null;let Ue=null,j=0;for(de=de.toLowerCase(),Re=Re.toLowerCase();j<Re.length&&(Ue=w(de,Re,0,j,Ne),Ue===null);)j=$(Re,j+1);return Ue}function w(de,Re,Ne,Ue,j){let T=0;if(Ne===de.length)return[];if(Ue===Re.length)return null;if(!o(de.charCodeAt(Ne),Re.charCodeAt(Ue))){const ee=i(de.charCodeAt(Ne));if(!ee)return null;for(let ne=0;ne<ee.length;ne++)if(!o(ee[ne],Re.charCodeAt(Ue+ne)))return null;T+=ee.length-1}let G=null,H=Ue+T+1;if(G=w(de,Re,Ne+1,H,j),!j)for(;!G&&(H=$(Re,H))<Re.length;)G=w(de,Re,Ne+1,H,j),H++;if(!G)return null;if(de.charCodeAt(Ne)!==Re.charCodeAt(Ue)){const ee=i(de.charCodeAt(Ne));if(!ee)return G;for(let ne=0;ne<ee.length;ne++)if(ee[ne]!==Re.charCodeAt(Ue+ne))return G}return c({start:Ue,end:Ue+T+1},G)}function $(de,Re){for(let Ne=Re;Ne<de.length;Ne++)if(r(de.charCodeAt(Ne))||Ne>0&&r(de.charCodeAt(Ne-1)))return Ne;return de.length}const k=O(e.$xk,S,b),y=O(e.$xk,S,p),C=new I.$Ec(1e4);function P(de,Re,Ne=!1){if(typeof de!="string"||typeof Re!="string")return null;let Ue=C.get(de);Ue||(Ue=new RegExp(R.$gf(de),"i"),C.set(de,Ue));const j=Ue.exec(Re);return j?[{start:j.index,end:j.index+j[0].length}]:Ne?y(de,Re):k(de,Re)}function W(de,Re){const Ne=$e(de,de.toLowerCase(),0,Re,Re.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ne?q(Ne):null}function V(de,Re,Ne,Ue,j,T){const G=Math.min(13,de.length);for(;Ne<G;Ne++){const H=$e(de,Re,Ne,Ue,j,T,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,T]}function q(de){if(typeof de>"u")return[];const Re=[],Ne=de[1];for(let Ue=de.length-1;Ue>1;Ue--){const j=de[Ue]+Ne,T=Re[Re.length-1];T&&T.end===j?T.end=j+1:Re.push({start:j,end:j+1})}return Re}const A=128;function U(){const de=[],Re=[];for(let Ne=0;Ne<=A;Ne++)Re[Ne]=0;for(let Ne=0;Ne<=A;Ne++)de.push(Re.slice(0));return de}function K(de){const Re=[];for(let Ne=0;Ne<=de;Ne++)Re[Ne]=0;return Re}const re=K(2*A),ae=K(2*A),ye=U(),Pe=U(),fe=U(),me=!1;function Ae(de,Re,Ne,Ue,j){function T(H,ee,ne=" "){for(;H.length<ee;)H=ne+H;return H}let G=` |   |${Ue.split("").map(H=>T(H,3)).join("|")}
`;for(let H=0;H<=Ne;H++)H===0?G+=" |":G+=`${Re[H-1]}|`,G+=de[H].slice(0,j+1).map(ee=>T(ee.toString(),3)).join("|")+`
`;return G}function ce(de,Re,Ne,Ue){de=de.substr(Re),Ne=Ne.substr(Ue),console.log(Ae(Pe,de,de.length,Ne,Ne.length)),console.log(Ae(fe,de,de.length,Ne,Ne.length)),console.log(Ae(ye,de,de.length,Ne,Ne.length))}function Me(de,Re){if(Re<0||Re>=de.length)return!1;const Ne=de.codePointAt(Re);switch(Ne){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$Qf(Ne)}}function ie(de,Re){if(Re<0||Re>=de.length)return!1;switch(de.charCodeAt(Re)){case 32:case 9:return!0;default:return!1}}function z(de,Re,Ne){return Re[de]!==Ne[de]}function x(de,Re,Ne,Ue,j,T,G=!1){for(;Re<Ne&&j<T;)de[Re]===Ue[j]&&(G&&(re[Re]=j),Re+=1),j+=1;return Re===Ne}var ve;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Te;(function(de){de.Default=[-100,0];function Re(Ne){return!Ne||Ne.length===2&&Ne[0]===-100&&Ne[1]===0}de.isDefault=Re})(Te||(e.FuzzyScore=Te={}));class De{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Re,Ne){this.firstMatchCanBeWeak=Re,this.boostFullMatch=Ne}}e.$Ik=De;function $e(de,Re,Ne,Ue,j,T,G=De.default){const H=de.length>A?A:de.length,ee=Ue.length>A?A:Ue.length;if(Ne>=H||T>=ee||H-Ne>ee-T||!x(Re,Ne,H,j,T,ee,!0))return;ge(H,ee,Ne,T,Re,j);let ne=1,Oe=1,Be=Ne,Ke=T;const _e=[!1];for(ne=1,Be=Ne;Be<H;ne++,Be++){const ct=re[Be],mt=ae[Be],je=Be+1<H?ae[Be+1]:ee;for(Oe=ct-T+1,Ke=ct;Ke<je;Oe++,Ke++){let st=Number.MIN_SAFE_INTEGER,Z=!1;Ke<=mt&&(st=Q(de,Re,Be,Ne,Ue,j,Ke,ee,T,ye[ne-1][Oe-1]===0,_e));let Y=0;st!==Number.MAX_SAFE_INTEGER&&(Z=!0,Y=st+Pe[ne-1][Oe-1]);const pe=Ke>ct,Ge=pe?Pe[ne][Oe-1]+(ye[ne][Oe-1]>0?-5:0):0,we=Ke>ct+1&&ye[ne][Oe-1]>0,ot=we?Pe[ne][Oe-2]+(ye[ne][Oe-2]>0?-5:0):0;if(we&&(!pe||ot>=Ge)&&(!Z||ot>=Y))Pe[ne][Oe]=ot,fe[ne][Oe]=3,ye[ne][Oe]=0;else if(pe&&(!Z||Ge>=Y))Pe[ne][Oe]=Ge,fe[ne][Oe]=2,ye[ne][Oe]=0;else if(Z)Pe[ne][Oe]=Y,fe[ne][Oe]=1,ye[ne][Oe]=ye[ne-1][Oe-1]+1;else throw new Error("not possible")}}if(me&&ce(de,Ne,Ue,T),!_e[0]&&!G.firstMatchCanBeWeak)return;ne--,Oe--;const xe=[Pe[ne][Oe],T];let et=0,tt=0;for(;ne>=1;){let ct=Oe;do{const mt=fe[ne][ct];if(mt===3)ct=ct-2;else if(mt===2)ct=ct-1;else break}while(ct>=1);et>1&&Re[Ne+ne-1]===j[T+Oe-1]&&!z(ct+T-1,Ue,j)&&et+1>ye[ne][ct]&&(ct=Oe),ct===Oe?et++:et=1,tt||(tt=ct),ne--,Oe=ct-1,xe.push(Oe)}ee===H&&G.boostFullMatch&&(xe[0]+=2);const nt=tt-H;return xe[0]-=nt,xe}function ge(de,Re,Ne,Ue,j,T){let G=de-1,H=Re-1;for(;G>=Ne&&H>=Ue;)j[G]===T[H]&&(ae[G]=H,G--),H--}function Q(de,Re,Ne,Ue,j,T,G,H,ee,ne,Oe){if(Re[Ne]!==T[G])return Number.MIN_SAFE_INTEGER;let Be=1,Ke=!1;return G===Ne-Ue?Be=de[Ne]===j[G]?7:5:z(G,j,T)&&(G===0||!z(G-1,j,T))?(Be=de[Ne]===j[G]?7:5,Ke=!0):Me(T,G)&&(G===0||!Me(T,G-1))?Be=5:(Me(T,G-1)||ie(T,G-1))&&(Be=5,Ke=!0),Be>1&&Ne===Ue&&(Oe[0]=!0),Ke||(Ke=z(G,j,T)||Me(T,G-1)||ie(T,G-1)),Ne===Ue?G>ee&&(Be-=Ke?3:5):ne?Be+=Ke?2:0:Be+=Ke?0:1,G+1===H&&(Be-=Ke?3:5),Be}function X(de,Re,Ne,Ue,j,T,G){return ue(de,Re,Ne,Ue,j,T,!0,G)}function he(de,Re,Ne,Ue,j,T,G){return ue(de,Re,Ne,Ue,j,T,!1,G)}function ue(de,Re,Ne,Ue,j,T,G,H){let ee=$e(de,Re,Ne,Ue,j,T,H);if(ee&&!G)return ee;if(de.length>=3){const ne=Math.min(7,de.length-1);for(let Oe=Ne+1;Oe<ne;Oe++){const Be=Fe(de,Oe);if(Be){const Ke=$e(Be,Be.toLowerCase(),Ne,Ue,j,T,H);Ke&&(Ke[0]-=3,(!ee||Ke[0]>ee[0])&&(ee=Ke))}}}return ee}function Fe(de,Re){if(Re+1>=de.length)return;const Ne=de[Re],Ue=de[Re+1];if(Ne!==Ue)return de.slice(0,Re)+Ue+Ne+de.slice(Re+2)}}),define(Ie[33],Ce([1,0,13]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(N||(N={})),function(R){const O="error",M="warning",b="warn",p="info",E="ignore";function F(d){return d?I.$xf(O,d)?R.Error:I.$xf(M,d)||I.$xf(b,d)?R.Warning:I.$xf(p,d)?R.Info:R.Ignore:R.Ignore}R.fromValue=F;function D(d){switch(d){case R.Error:return O;case R.Warning:return M;case R.Info:return p;default:return E}}R.toString=D}(N||(N={})),e.default=N}),define(Ie[136],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0,e.$be=Symbol("MicrotaskDelay")}),define(Ie[54],Ce([1,0,18,13]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=void 0;class R{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const m=v.charCodeAt(0),r=this.b.charCodeAt(this.c);return m-r}value(){return this.b[this.c]}}e.$xi=R;class O{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,N.$rf)(v,this.b,0,v.length,this.c,this.d):(0,N.$tf)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$yi=O;class M{constructor(v=!0,m=!0){this.f=v,this.g=m}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let m=v.length-1;m>=0;m--,this.c--){const r=this.b.charCodeAt(m);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,N.$rf)(v,this.b,0,v.length,this.d,this.e):(0,N.$tf)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$zi=M;var b;(function(d){d[d.Scheme=1]="Scheme",d[d.Authority=2]="Authority",d[d.Path=3]="Path",d[d.Query=4]="Query",d[d.Fragment=5]="Fragment"})(b||(b={}));class p{constructor(v,m){this.f=v,this.g=m,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,N.$sf)(v,this.c.scheme);if(this.d[this.e]===2)return(0,N.$sf)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,N.$qf)(v,this.c.query);if(this.d[this.e]===5)return(0,N.$qf)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Ai=p;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var F;(function(d){d[d.Left=-1]="Left",d[d.Mid=0]="Mid",d[d.Right=1]="Right"})(F||(F={}));class D{static forUris(v=()=>!1,m=()=>!1){return new D(new p(v,m))}static forPaths(v=!1){return new D(new M(void 0,!v))}static forStrings(){return new D(new R)}static forConfigKeys(){return new D(new O)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,m){if(m){const r=m.slice(0);(0,I.$Xb)(r);for(const o of r)this.set(o,v)}else{const r=v.slice(0);(0,I.$Xb)(r);for(const o of r)this.set(o[0],o[1])}}set(v,m){const r=this.b.reset(v);let o;this.c||(this.c=new E,this.c.segment=r.value());const s=[];for(o=this.c;;){const n=r.cmp(o.segment);if(n>0)o.left||(o.left=new E,o.left.segment=r.value()),s.push([-1,o]),o=o.left;else if(n<0)o.right||(o.right=new E,o.right.segment=r.value()),s.push([1,o]),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new E,o.mid.segment=r.value()),s.push([0,o]),o=o.mid;else break}const i=o.value;o.value=m,o.key=v;for(let n=s.length-1;n>=0;n--){const c=s[n][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const t=s[n][0],f=s[n+1][0];if(t===1&&f===1)s[n][1]=c.rotateLeft();else if(t===-1&&f===-1)s[n][1]=c.rotateRight();else if(t===1&&f===-1)c.right=s[n+1][1]=s[n+1][1].rotateRight(),s[n][1]=c.rotateLeft();else if(t===-1&&f===1)c.left=s[n+1][1]=s[n+1][1].rotateLeft(),s[n][1]=c.rotateRight();else throw new Error;if(n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}return i}get(v){return this.d(v)?.value}d(v){const m=this.b.reset(v);let r=this.c;for(;r;){const o=m.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(m.hasNext())m.next(),r=r.mid;else break}return r}has(v){const m=this.d(v);return!(m?.value===void 0&&m?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,m){const r=this.b.reset(v),o=[];let s=this.c;for(;s;){const i=r.cmp(s.segment);if(i>0)o.push([-1,s]),s=s.left;else if(i<0)o.push([1,s]),s=s.right;else if(r.hasNext())r.next(),o.push([0,s]),s=s.mid;else break}if(s){if(m?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this.f(s.right);if(i.key){const{key:n,value:c,segment:h}=i;this.e(i.key,!1),s.key=n,s.value=c,s.segment=h}}else{const i=s.left??s.right;if(o.length>0){const[n,c]=o[o.length-1];switch(n){case-1:c.left=i;break;case 0:c.mid=i;break;case 1:c.right=i;break}}else this.c=i}for(let i=o.length-1;i>=0;i--){const n=o[i][1];n.updateHeight();const c=n.balanceFactor();if(c>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),o[i][1]=n.rotateLeft()):c<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),o[i][1]=n.rotateRight()),i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const m=this.b.reset(v);let r=this.c,o;for(;r;){const s=m.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(m.hasNext())m.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(v){return this.g(v,!1)}g(v,m){const r=this.b.reset(v);let o=this.c;for(;o;){const s=r.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this.h(o.mid):m?o.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[m,r]of this)v(r,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const m=[];return this.j(v,m),m[Symbol.iterator]()}j(v,m){v&&(v.left&&this.j(v.left,m),v.value&&m.push([v.key,v.value]),v.mid&&this.j(v.mid,m),v.right&&this.j(v.right,m))}_isBalanced(){const v=m=>{if(!m)return!0;const r=m.balanceFactor();return r<-1||r>1?!1:v(m.left)&&v(m.right)};return v(this.c)}}e.$Bi=D}),define(Ie[43],Ce([1,0,92]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Vj=R;var N;(function(M){function b(p){return p&&typeof p=="object"&&typeof p.id=="string"}M.isThemeColor=b})(N||(e.ThemeColor=N={}));function R(M){return{id:M}}var O;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function p(i){const n=b.exec(i.id);if(!n)return p(I.$Uj.error);const[,c,h]=n,t=["codicon","codicon-"+c];return h&&t.push("codicon-modifier-"+h.substring(1)),t}M.asClassNameArray=p;function E(i){return p(i).join(" ")}M.asClassName=E;function F(i){return"."+p(i).join(".")}M.asCSSSelector=F;function D(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||N.isThemeColor(i.color))}M.isThemeIcon=D;const d=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function v(i){const n=d.exec(i);if(!n)return;const[,c]=n;return{id:c}}M.fromString=v;function m(i){return{id:i}}M.fromId=m;function r(i,n){let c=i.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),n&&(c=`${c}~${n}`),{id:c}}M.modify=r;function o(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}M.getModifier=o;function s(i,n){return i.id===n.id&&i.color?.id===n.color?.id}M.isEqual=s})(O||(e.ThemeIcon=O={}))}),define(Ie[137],Ce([1,0,135,13,43]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=p,e.$Nk=F,e.$Ok=d,e.$Pk=v,e.$Qk=r,e.$Rk=o;const O="$(",M=new RegExp(`\\$\\(${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${M.source}`,"g");function p(s){return s.replace(b,(i,n)=>n?i:`\\${i}`)}const E=new RegExp(`\\\\${M.source}`,"g");function F(s){return s.replace(E,i=>`\\${i}`)}const D=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function d(s){return s.indexOf(O)===-1?s:s.replace(D,(i,n,c,h)=>c?i:n||h||"")}function v(s){return s?s.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}const m=new RegExp(`\\$\\(${R.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(s){m.lastIndex=0;let i="";const n=[];let c=0;for(;;){const h=m.lastIndex,t=m.exec(s),f=s.substring(h,t?.index);if(f.length>0){i+=f;for(let a=0;a<f.length;a++)n.push(c)}if(!t)break;c+=t[0].length}return{text:i,iconOffsets:n}}function o(s,i,n=!1){const{text:c,iconOffsets:h}=i;if(!h||h.length===0)return(0,I.$Dk)(s,c,n);const t=(0,N.$ef)(c," "),f=c.length-t.length,a=(0,I.$Dk)(s,t,n);if(a)for(const g of a){const u=h[g.start+f]+f;g.start+=u,g.end+=u}return a}}),define(Ie[34],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=void 0,e.$Qg=N;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(R){return I.test(R)}e.$Rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(b){for(let p=0;p<b.length;p++)b[p]=Math.floor(Math.random()*256);return b};const O=new Uint8Array(16),M=[];for(let b=0;b<256;b++)M.push(b.toString(16).padStart(2,"0"));return function(){R(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let p=0,E="";return E+=M[O[p++]],E+=M[O[p++]],E+=M[O[p++]],E+=M[O[p++]],E+="-",E+=M[O[p++]],E+=M[O[p++]],E+="-",E+=M[O[p++]],E+=M[O[p++]],E+="-",E+=M[O[p++]],E+=M[O[p++]],E+="-",E+=M[O[p++]],E+=M[O[p++]],E+=M[O[p++]],E+=M[O[p++]],E+=M[O[p++]],E+=M[O[p++]],E}}()}),define(Ie[138],Ce([1,0,18,41,34]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=e.$Rt=void 0,e.$Pt=O,e.$Qt=M,e.$St=E;function O(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}function M(D,d,v){const m={id:(0,R.$Rg)(),name:D,uri:d,data:v};return{asString:async()=>"",asFile:()=>m,value:void 0}}class b{constructor(){this.a=new Map}get size(){let d=0;for(const v of this.a)d++;return d}has(d){return this.a.has(this.b(d))}matches(d){const v=[...this.a.keys()];return N.Iterable.some(this,([m,r])=>r.asFile())&&v.push("files"),F(p(d),v)}get(d){return this.a.get(this.b(d))?.[0]}append(d,v){const m=this.a.get(d);m?m.push(v):this.a.set(this.b(d),[v])}replace(d,v){this.a.set(this.b(d),[v])}delete(d){this.a.delete(this.b(d))}*[Symbol.iterator](){for(const[d,v]of this.a)for(const m of v)yield[d,m]}b(d){return p(d)}}e.$Rt=b;function p(D){return D.toLowerCase()}function E(D,d){return F(p(D),d.map(p))}function F(D,d){if(D==="*/*")return d.length>0;if(d.includes(D))return!0;const v=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[m,r,o]=v;return o==="*"?d.some(s=>s.startsWith(r+"/")):!1}e.$Tt=Object.freeze({create:D=>(0,I.$Mb)(D.map(d=>d.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$Tt.split(D).filter(d=>!d.startsWith("#"))})}),define(Ie[139],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Wt=N;var I;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function N(R){let O=0,M=0,b=0,p=0;for(let E=0,F=R.length;E<F;E++){const D=R.charCodeAt(E);D===13?(O===0&&(M=E),O++,E+1<F&&R.charCodeAt(E+1)===10?(p|=2,E++):p|=3,b=E+1):D===10&&(p|=1,O===0&&(M=E),O++,b=E+1)}return O===0&&(M=R.length),[O,M,R.length-b,p]}}),define(Ie[140],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=void 0,e.$3s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[141],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ku=e.$ju=e.IndentAction=void 0;var I;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class N{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let p=0,E=b.notIn.length;p<E;p++)switch(b.notIn[p]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,p){if(b.getTokenCount()===0)return!0;const E=b.findTokenIndexAtOffset(p-2),F=b.getStandardTokenType(E);return this.isOK(F)}g(b,p){for(let E=b;E<=p;E++){const F=String.fromCharCode(E);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$ju=N;class R{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const p of b)O(this.autoClosingPairsOpenByStart,p.open.charAt(0),p),O(this.autoClosingPairsOpenByEnd,p.open.charAt(p.open.length-1),p),O(this.autoClosingPairsCloseByStart,p.close.charAt(0),p),O(this.autoClosingPairsCloseByEnd,p.close.charAt(p.close.length-1),p),p.close.length===1&&p.open.length===1&&O(this.autoClosingPairsCloseSingleChar,p.close,p)}}e.$ku=R;function O(M,b,p){M.has(b)?M.get(b).push(p):M.set(b,[p])}}),define(Ie[142],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=e.NodeColor=e.$yC=void 0,e.$AC=R,e.$BC=O,e.$CC=E,e.$DC=F,e.$EC=D,e.$FC=d,e.$GC=v,e.$HC=m;class I{constructor(o,s){this.piece=o,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$zC)return R(this.right);let o=this;for(;o.parent!==e.$zC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$zC?e.$zC:o.parent}prev(){if(this.left!==e.$zC)return O(this.left);let o=this;for(;o.parent!==e.$zC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$zC?e.$zC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$yC=I;var N;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$zC=new I(null,0),e.$zC.parent=e.$zC,e.$zC.left=e.$zC,e.$zC.right=e.$zC,e.$zC.color=0;function R(r){for(;r.left!==e.$zC;)r=r.left;return r}function O(r){for(;r.right!==e.$zC;)r=r.right;return r}function M(r){return r===e.$zC?0:r.size_left+r.piece.length+M(r.right)}function b(r){return r===e.$zC?0:r.lf_left+r.piece.lineFeedCnt+b(r.right)}function p(){e.$zC.parent=e.$zC}function E(r,o){const s=o.right;s.size_left+=o.size_left+(o.piece?o.piece.length:0),s.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=s.left,s.left!==e.$zC&&(s.left.parent=o),s.parent=o.parent,o.parent===e.$zC?r.root=s:o.parent.left===o?o.parent.left=s:o.parent.right=s,s.left=o,o.parent=s}function F(r,o){const s=o.left;o.left=s.right,s.right!==e.$zC&&(s.right.parent=o),s.parent=o.parent,o.size_left-=s.size_left+(s.piece?s.piece.length:0),o.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),o.parent===e.$zC?r.root=s:o===o.parent.right?o.parent.right=s:o.parent.left=s,s.right=o,o.parent=s}function D(r,o){let s,i;if(o.left===e.$zC?(i=o,s=i.right):o.right===e.$zC?(i=o,s=i.left):(i=R(o.right),s=i.right),i===r.root){r.root=s,s.color=0,o.detach(),p(),r.root.parent=e.$zC;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===o?(s.parent=i.parent,m(r,s)):(i.parent===o?s.parent=i:s.parent=i.parent,m(r,s),i.left=o.left,i.right=o.right,i.parent=o.parent,i.color=o.color,o===r.root?r.root=i:o===o.parent.left?o.parent.left=i:o.parent.right=i,i.left!==e.$zC&&(i.left.parent=i),i.right!==e.$zC&&(i.right.parent=i),i.size_left=o.size_left,i.lf_left=o.lf_left,m(r,i)),o.detach(),s.parent.left===s){const h=M(s),t=b(s);if(h!==s.parent.size_left||t!==s.parent.lf_left){const f=h-s.parent.size_left,a=t-s.parent.lf_left;s.parent.size_left=h,s.parent.lf_left=t,v(r,s.parent,f,a)}}if(m(r,s.parent),n){p();return}let c;for(;s!==r.root&&s.color===0;)s===s.parent.left?(c=s.parent.right,c.color===1&&(c.color=0,s.parent.color=1,E(r,s.parent),c=s.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.right.color===0&&(c.left.color=0,c.color=1,F(r,c),c=s.parent.right),c.color=s.parent.color,s.parent.color=0,c.right.color=0,E(r,s.parent),s=r.root)):(c=s.parent.left,c.color===1&&(c.color=0,s.parent.color=1,F(r,s.parent),c=s.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.left.color===0&&(c.right.color=0,c.color=1,E(r,c),c=s.parent.left),c.color=s.parent.color,s.parent.color=0,c.left.color=0,F(r,s.parent),s=r.root));s.color=0,p()}function d(r,o){for(m(r,o);o!==r.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const s=o.parent.parent.right;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,E(r,o)),o.parent.color=0,o.parent.parent.color=1,F(r,o.parent.parent))}else{const s=o.parent.parent.left;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,F(r,o)),o.parent.color=0,o.parent.parent.color=1,E(r,o.parent.parent))}r.root.color=0}function v(r,o,s,i){for(;o!==r.root&&o!==e.$zC;)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=i),o=o.parent}function m(r,o){let s=0,i=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,s=M(o.left)-o.size_left,i=b(o.left)-o.lf_left,o.size_left+=s,o.lf_left+=i;o!==r.root&&(s!==0||i!==0);)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=i),o=o.parent}}}),define(Ie[93],Ce([1,0,94,30,95,142,96]),function(le,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SC=e.$RC=e.$QC=void 0,e.$OC=F,e.$PC=D;const b=65535;function p(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class E{constructor(i,n,c,h,t){this.lineStarts=i,this.cr=n,this.lf=c,this.crlf=h,this.isBasicASCII=t}}function F(s,i=!0){const n=[0];let c=1;for(let h=0,t=s.length;h<t;h++){const f=s.charCodeAt(h);f===13?h+1<t&&s.charCodeAt(h+1)===10?(n[c++]=h+2,h++):n[c++]=h+1:f===10&&(n[c++]=h+1)}return i?p(n):n}function D(s,i){s.length=0,s[0]=0;let n=1,c=0,h=0,t=0,f=!0;for(let g=0,u=i.length;g<u;g++){const S=i.charCodeAt(g);S===13?g+1<u&&i.charCodeAt(g+1)===10?(t++,s[n++]=g+2,g++):(c++,s[n++]=g+1):S===10?(h++,s[n++]=g+1):f&&S!==9&&(S<32||S>126)&&(f=!1)}const a=new E(p(s),c,h,t,f);return s.length=0,a}class d{constructor(i,n,c,h,t){this.bufferIndex=i,this.start=n,this.end=c,this.lineFeedCnt=h,this.length=t}}e.$QC=d;class v{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$RC=v;class m{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==O.$zC&&i.iterate(i.root,c=>(c!==O.$zC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartOffset<=i&&c.nodeStartOffset+c.node.piece.length>=i)return c}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<i&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=i)return c}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const c=this.b;for(let h=0;h<c.length;h++){const t=c[h];if(t.node.parent===null||t.nodeStartOffset>=i){c[h]=null,n=!0;continue}}if(n){const h=[];for(const t of c)t!==null&&h.push(t);this.b=h}}}class o{constructor(i,n,c){this.create(i,n,c)}create(i,n,c){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=O.$zC,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=c;let h=null;for(let t=0,f=i.length;t<f;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=F(i[t].buffer));const a=new d(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),h=this.S(h,a)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=b,c=n-Math.floor(n/3),h=c*2;let t="",f=0;const a=[];if(this.iterate(this.root,g=>{const u=this.R(g),S=u.length;if(f<=c||f+S<h)return t+=u,f+=S,!0;const l=t.replace(/\r\n|\r|\n/g,i);return a.push(new v(l,F(l))),t=u,f=S,!0}),f>0){const g=t.replace(/\r\n|\r|\n/g,i);a.push(new v(g,F(g)))}this.create(a,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new m(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,h=>{if(h===O.$zC)return!0;const t=this.R(h),f=t.length,a=i.G(n),g=i.G(n+f),u=i.getValueInRange2(a,g);return n+=f,t===u})}getOffsetAt(i,n){let c=0,h=this.root;for(;h!==O.$zC;)if(h.left!==O.$zC&&h.lf_left+1>=i)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=i){c+=h.size_left;const t=this.B(h,i-h.lf_left-2);return c+=t+n-1}else i-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,c=0;const h=i;for(;n!==O.$zC;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(c+=n.lf_left+t.index,t.index===0){const f=this.getOffsetAt(c+1,1),a=h-f;return new I.$st(c+1,a+1)}return new I.$st(c+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,c+=n.lf_left+n.piece.lineFeedCnt,n.right===O.$zC){const t=this.getOffsetAt(c+1,1),f=h-i-t;return new I.$st(c+1,f+1)}else n=n.right;return new I.$st(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const c=this.H(i.startLineNumber,i.startColumn),h=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(c,h);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const a=i.node,g=this.a[a.piece.bufferIndex].buffer,u=this.u(a.piece.bufferIndex,a.piece.start);return g.substring(u+i.remainder,u+n.remainder)}let c=i.node;const h=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let f=h.substring(t+i.remainder,t+c.piece.length);for(c=c.next();c!==O.$zC;){const a=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);if(c===n.node){f+=a.substring(g,g+n.remainder);break}else f+=a.substr(g,c.piece.length);c=c.next()}return f}getLinesContent(){const i=[];let n=0,c="",h=!1;return this.iterate(this.root,t=>{if(t===O.$zC)return!0;const f=t.piece;let a=f.length;if(a===0)return!0;const g=this.a[f.bufferIndex].buffer,u=this.a[f.bufferIndex].lineStarts,S=f.start.line,l=f.end.line;let w=u[S]+f.start.column;if(h&&(g.charCodeAt(w)===10&&(w++,a--),i[n++]=c,c="",h=!1,a===0))return!0;if(S===l)return!this.f&&g.charCodeAt(w+a-1)===13?(h=!0,c+=g.substr(w,a-1)):c+=g.substr(w,a),!0;c+=this.f?g.substring(w,Math.max(w,u[S+1]-this.e)):g.substring(w,u[S+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;for(let $=S+1;$<l;$++)c=this.f?g.substring(u[$],u[$+1]-this.e):g.substring(u[$],u[$+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;return!this.f&&g.charCodeAt(u[l]+f.end.column-1)===13?(h=!0,f.end.column===0?n--:c=g.substr(u[l],f.end.column-1)):c=g.substr(u[l],f.end.column),!0}),h&&(i[n++]=c,c=""),i[n++]=c,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start);return c.buffer.charCodeAt(h)}else{const n=this.a[i.node.piece.bufferIndex],h=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(h)}}getLineCharCode(i,n){const c=this.H(i,n+1);return this.l(c)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,c,h,t,f,a,g,u,S,l){const w=this.a[i.piece.bufferIndex],$=this.u(i.piece.bufferIndex,i.piece.start),k=this.u(i.piece.bufferIndex,t),y=this.u(i.piece.bufferIndex,f);let C;const P={line:0,column:0};let W,V;n._wordSeparators?(W=w.buffer.substring(k,y),V=q=>q+k,n.reset(0)):(W=w.buffer,V=q=>q,n.reset(k));do if(C=n.next(W),C){if(V(C.index)>=y)return S;this.s(i,V(C.index)-$,P);const q=this.t(i.piece.bufferIndex,t,P),A=P.line===t.line?P.column-t.column+h:P.column+1,U=A+C[0].length;if(l[S++]=(0,M.$KC)(new N.$tt(c+q,A,c+q,U),C,g),V(C.index)+C[0].length>=y||S>=u)return S}while(C);return S}findMatchesLineByLine(i,n,c,h){const t=[];let f=0;const a=new M.$NC(n.wordSeparators,n.regex);let g=this.H(i.startLineNumber,i.startColumn);if(g===null)return[];const u=this.H(i.endLineNumber,i.endColumn);if(u===null)return[];let S=this.s(g.node,g.remainder);const l=this.s(u.node,u.remainder);if(g.node===u.node)return this.findMatchesInNode(g.node,a,i.startLineNumber,i.startColumn,S,l,n,c,h,f,t),t;let w=i.startLineNumber,$=g.node;for(;$!==u.node;){const y=this.t($.piece.bufferIndex,S,$.piece.end);if(y>=1){const P=this.a[$.piece.bufferIndex].lineStarts,W=this.u($.piece.bufferIndex,$.piece.start),V=P[S.line+y],q=w===i.startLineNumber?i.startColumn:1;if(f=this.findMatchesInNode($,a,w,q,S,this.s($,V-W),n,c,h,f,t),f>=h)return t;w+=y}const C=w===i.startLineNumber?i.startColumn-1:0;if(w===i.endLineNumber){const P=this.getLineContent(w).substring(C,i.endColumn-1);return f=this.n(n,a,P,i.endLineNumber,C,f,t,c,h),t}if(f=this.n(n,a,this.getLineContent(w).substr(C),w,C,f,t,c,h),f>=h)return t;w++,g=this.H(w,1),$=g.node,S=this.s(g.node,g.remainder)}if(w===i.endLineNumber){const y=w===i.startLineNumber?i.startColumn-1:0,C=this.getLineContent(w).substring(y,i.endColumn-1);return f=this.n(n,a,C,i.endLineNumber,y,f,t,c,h),t}const k=w===i.startLineNumber?i.startColumn:1;return f=this.findMatchesInNode(u.node,a,w,k,S,l,n,c,h,f,t),t}n(i,n,c,h,t,f,a,g,u){const S=i.wordSeparators;if(!g&&i.simpleSearch){const w=i.simpleSearch,$=w.length,k=c.length;let y=-$;for(;(y=c.indexOf(w,y+$))!==-1;)if((!S||(0,M.$MC)(S,c,k,y,$))&&(a[f++]=new R.$Ev(new N.$tt(h,y+1+t,h,y+1+$+t),null),f>=u))return f;return f}let l;n.reset(0);do if(l=n.next(c),l&&(a[f++]=(0,M.$KC)(new N.$tt(h,l.index+1+t,h,l.index+1+l[0].length+t),l,g),f>=u))return f;while(l);return f}insert(i,n,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==O.$zC){const{node:h,remainder:t,nodeStartOffset:f}=this.G(i),a=h.piece,g=a.bufferIndex,u=this.s(h,t);if(h.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&f+a.length===i&&n.length<b){this.F(h,n),this.y();return}if(f===i)this.o(n,h),this.h.validate(i);else if(f+h.piece.length>i){const S=[];let l=new d(a.bufferIndex,u,a.end,this.t(a.bufferIndex,u,a.end),this.u(g,a.end)-this.u(g,u));if(this.K()&&this.M(n)&&this.I(h,t)===10){const y={line:l.start.line+1,column:0};l=new d(l.bufferIndex,y,l.end,this.t(l.bufferIndex,y,l.end),l.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(h,t-1)===13){const y=this.s(h,t-1);this.C(h,y),n="\r"+n,h.piece.length===0&&S.push(h)}else this.C(h,u);else this.C(h,u);const w=this.w(n);l.length>0&&this.S(h,l);let $=h;for(let k=0;k<w.length;k++)$=this.S($,w[k]);this.v(S)}else this.q(n,h)}else{const h=this.w(n);let t=this.T(null,h[0]);for(let f=1;f<h.length;f++)t=this.S(t,h[f])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===O.$zC)return;const c=this.G(i),h=this.G(i+n),t=c.node,f=h.node;if(t===f){const w=this.s(t,c.remainder),$=this.s(t,h.remainder);if(c.nodeStartOffset===i){if(n===t.piece.length){const k=t.next();(0,O.$EC)(this,t),this.N(k),this.y();return}this.D(t,$),this.h.validate(i),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===i+n){this.C(t,w),this.O(t),this.y();return}this.E(t,w,$),this.y();return}const a=[],g=this.s(t,c.remainder);this.C(t,g),this.h.validate(i),t.piece.length===0&&a.push(t);const u=this.s(f,h.remainder);this.D(f,u),f.piece.length===0&&a.push(f);const S=t.next();for(let w=S;w!==O.$zC&&w!==f;w=w.next())a.push(w);const l=t.piece.length===0?t.prev():t;this.v(a),this.O(l),this.y()}o(i,n){const c=[];if(this.K()&&this.M(i)&&this.L(n)){const f=n.piece,a={line:f.start.line+1,column:0},g=new d(f.bufferIndex,a,f.end,this.t(f.bufferIndex,a,f.end),f.length-1);n.piece=g,i+=`
`,(0,O.$GC)(this,n,-1,-1),n.piece.length===0&&c.push(n)}const h=this.w(i);let t=this.T(n,h[h.length-1]);for(let f=h.length-2;f>=0;f--)t=this.T(t,h[f]);this.N(t),this.v(c)}q(i,n){this.Q(i,n)&&(i+=`
`);const c=this.w(i),h=this.S(n,c[0]);let t=h;for(let f=1;f<c.length;f++)t=this.S(t,c[f]);this.N(h)}s(i,n,c){const h=i.piece,t=i.piece.bufferIndex,f=this.a[t].lineStarts,g=f[h.start.line]+h.start.column+n;let u=h.start.line,S=h.end.line,l=0,w=0,$=0;for(;u<=S&&(l=u+(S-u)/2|0,$=f[l],l!==S);)if(w=f[l+1],g<$)S=l-1;else if(g>=w)u=l+1;else break;return c?(c.line=l,c.column=g-$,null):{line:l,column:g-$}}t(i,n,c){if(c.column===0)return c.line-n.line;const h=this.a[i].lineStarts;if(c.line===h.length-1)return c.line-n.line;const t=h[c.line+1],f=h[c.line]+c.column;if(t>f+1)return c.line-n.line;const a=f-1;return this.a[i].buffer.charCodeAt(a)===13?c.line-n.line+1:c.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,O.$EC)(this,i[n])}w(i){if(i.length>b){const S=[];for(;i.length>b;){const w=i.charCodeAt(b-1);let $;w===13||w>=55296&&w<=56319?($=i.substring(0,b-1),i=i.substring(b-1)):($=i.substring(0,b),i=i.substring(b));const k=F($);S.push(new d(this.a.length,{line:0,column:0},{line:k.length-1,column:$.length-k[k.length-1]},k.length-1,$.length)),this.a.push(new v($,k))}const l=F(i);return S.push(new d(this.a.length,{line:0,column:0},{line:l.length-1,column:i.length-l[l.length-1]},l.length-1,i.length)),this.a.push(new v(i,l)),S}let n=this.a[0].buffer.length;const c=F(i,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let S=0;S<c.length;S++)c[S]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let S=0;S<c.length;S++)c[S]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,a=t-this.a[0].lineStarts[f],g={line:f,column:a},u=new d(0,h,g,this.t(0,h,g),t-n);return this.g=g,[u]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let c=this.root,h="";const t=this.h.get2(i);if(t){c=t.node;const f=this.B(c,i-t.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===i)h=a.substring(g+f,g+c.piece.length);else{const u=this.B(c,i-t.nodeStartLineNumber);return a.substring(g+f,g+u-n)}}else{let f=0;const a=i;for(;c!==O.$zC;)if(c.left!==O.$zC&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const g=this.B(c,i-c.lf_left-2),u=this.B(c,i-c.lf_left-1),S=this.a[c.piece.bufferIndex].buffer,l=this.u(c.piece.bufferIndex,c.piece.start);return f+=c.size_left,this.h.set({node:c,nodeStartOffset:f,nodeStartLineNumber:a-(i-1-c.lf_left)}),S.substring(l+g,l+u-n)}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const g=this.B(c,i-c.lf_left-2),u=this.a[c.piece.bufferIndex].buffer,S=this.u(c.piece.bufferIndex,c.piece.start);h=u.substring(S+g,S+c.piece.length);break}else i-=c.lf_left+c.piece.lineFeedCnt,f+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==O.$zC;){const f=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),g=this.u(c.piece.bufferIndex,c.piece.start);return h+=f.substring(g,g+a-n),h}else{const a=this.u(c.piece.bufferIndex,c.piece.start);h+=f.substr(a,c.piece.length)}c=c.next()}return h}y(){let i=this.root,n=1,c=0;for(;i!==O.$zC;)n+=i.lf_left+i.piece.lineFeedCnt,c+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=c,this.h.validate(this.c)}A(i,n){const c=i.piece,h=this.s(i,n),t=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===n){const f=this.t(i.piece.bufferIndex,c.start,h);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:h.column}}B(i,n){if(n<0)return 0;const c=i.piece,h=this.a[c.bufferIndex].lineStarts,t=c.start.line+n+1;return t>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[t]-h[c.start.line]-c.start.column}C(i,n){const c=i.piece,h=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),f=n,a=this.u(c.bufferIndex,f),g=this.t(c.bufferIndex,c.start,f),u=g-h,S=a-t,l=c.length+S;i.piece=new d(c.bufferIndex,c.start,f,g,l),(0,O.$GC)(this,i,S,u)}D(i,n){const c=i.piece,h=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),f=n,a=this.t(c.bufferIndex,f,c.end),g=this.u(c.bufferIndex,f),u=a-h,S=t-g,l=c.length+S;i.piece=new d(c.bufferIndex,f,c.end,a,l),(0,O.$GC)(this,i,S,u)}E(i,n,c){const h=i.piece,t=h.start,f=h.end,a=h.length,g=h.lineFeedCnt,u=n,S=this.t(h.bufferIndex,h.start,u),l=this.u(h.bufferIndex,n)-this.u(h.bufferIndex,t);i.piece=new d(h.bufferIndex,h.start,u,S,l),(0,O.$GC)(this,i,l-a,S-g);const w=new d(h.bufferIndex,c,f,this.t(h.bufferIndex,c,f),this.u(h.bufferIndex,f)-this.u(h.bufferIndex,c)),$=this.S(i,w);this.N($)}F(i,n){this.Q(n,i)&&(n+=`
`);const c=this.K()&&this.L(n)&&this.M(i),h=this.a[0].buffer.length;this.a[0].buffer+=n;const t=F(n,!1);for(let $=0;$<t.length;$++)t[$]+=h;if(c){const $=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-$}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[f],g={line:f,column:a},u=i.piece.length+n.length,S=i.piece.lineFeedCnt,l=this.t(0,i.piece.start,g),w=l-S;i.piece=new d(i.piece.bufferIndex,i.piece.start,g,l,u),this.g=g,(0,O.$GC)(this,i,n.length,w)}G(i){let n=this.root;const c=this.h.get(i);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:i-c.nodeStartOffset};let h=0;for(;n!==O.$zC;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){h+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:h};return this.h.set(t),t}else i-=n.size_left+n.piece.length,h+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let c=this.root,h=0;for(;c!==O.$zC;)if(c.left!==O.$zC&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const t=this.B(c,i-c.lf_left-2),f=this.B(c,i-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(t+n-1,f),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const t=this.B(c,i-c.lf_left-2);if(t+n-1<=c.piece.length)return{node:c,remainder:t+n-1,nodeStartOffset:h};n-=c.piece.length-t;break}else i-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==O.$zC;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),f=this.J(c);return{node:c,remainder:Math.min(n-1,t),nodeStartOffset:f}}else if(c.piece.length>=n-1){const t=this.J(c);return{node:c,remainder:n-1,nodeStartOffset:t}}else n-=c.piece.length;c=c.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const c=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start)+n;return c.buffer.charCodeAt(h)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===O.$zC||i.piece.lineFeedCnt===0)return!1;const n=i.piece,c=this.a[n.bufferIndex].lineStarts,h=n.start.line,t=c[h]+n.start.column;return h===c.length-1||c[h+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===O.$zC||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const c=[],h=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:h[i.piece.end.line]-h[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const f=i.piece.length-1,a=i.piece.lineFeedCnt-1;i.piece=new d(i.piece.bufferIndex,i.piece.start,t,a,f),(0,O.$GC)(this,i,-1,-1),i.piece.length===0&&c.push(i);const g={line:n.piece.start.line+1,column:0},u=n.piece.length-1,S=this.t(n.piece.bufferIndex,g,n.piece.end);n.piece=new d(n.piece.bufferIndex,g,n.piece.end,S,u),(0,O.$GC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const l=this.w(`\r
`);this.S(i,l[0]);for(let w=0;w<c.length;w++)(0,O.$EC)(this,c[w])}Q(i,n){if(this.K()&&this.M(i)){const c=n.next();if(this.L(c)){if(i+=`
`,c.piece.length===1)(0,O.$EC)(this,c);else{const h=c.piece,t={line:h.start.line+1,column:0},f=h.length-1,a=this.t(h.bufferIndex,t,h.end);c.piece=new d(h.bufferIndex,t,h.end,a,f),(0,O.$GC)(this,c,-1,-1)}return!0}}return!1}iterate(i,n){if(i===O.$zC)return n(O.$zC);const c=this.iterate(i.left,n);return c&&n(i)&&this.iterate(i.right,n)}R(i){if(i===O.$zC)return"";const n=this.a[i.piece.bufferIndex],c=i.piece,h=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return n.buffer.substring(h,t)}getPieceContent(i){const n=this.a[i.bufferIndex],c=this.u(i.bufferIndex,i.start),h=this.u(i.bufferIndex,i.end);return n.buffer.substring(c,h)}S(i,n){const c=new O.$yC(n,1);if(c.left=O.$zC,c.right=O.$zC,c.parent=O.$zC,c.size_left=0,c.lf_left=0,this.root===O.$zC)this.root=c,c.color=0;else if(i.right===O.$zC)i.right=c,c.parent=i;else{const t=(0,O.$AC)(i.right);t.left=c,c.parent=t}return(0,O.$FC)(this,c),c}T(i,n){const c=new O.$yC(n,1);if(c.left=O.$zC,c.right=O.$zC,c.parent=O.$zC,c.size_left=0,c.lf_left=0,this.root===O.$zC)this.root=c,c.color=0;else if(i.left===O.$zC)i.left=c,c.parent=i;else{const h=(0,O.$BC)(i.left);h.right=c,c.parent=h}return(0,O.$FC)(this,c),c}U(i){let n="";return this.iterate(i,c=>(n+=this.R(c),!0)),n}}e.$SC=o}),define(Ie[143],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o$=e.$n$=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const M=this.a.get(O);return this.a.delete(O),M}}addDragOperationTransfer(O,M){this.a.set(O,M)}}e.$n$=I;class N{constructor(O){this.identifier=O}}e.$o$=N}),define(Ie[144],Ce([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(Ie[145],Ce([1,0,5,6,144]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=void 0,e.$fj=F;class O extends N.$Vc{constructor(d,v="",m="",r=!0,o){super(),this.h=this.B(new I.$ee),this.onDidChange=this.h.event,this.w=!0,this.j=d,this.m=v,this.u=m,this.w=r,this.C=o}get id(){return this.j}get label(){return this.m}set label(d){this.D(d)}D(d){this.m!==d&&(this.m=d,this.h.fire({label:d}))}get tooltip(){return this.n||""}set tooltip(d){this.F(d)}F(d){this.n!==d&&(this.n=d,this.h.fire({tooltip:d}))}get class(){return this.u}set class(d){this.G(d)}G(d){this.u!==d&&(this.u=d,this.h.fire({class:d}))}get enabled(){return this.w}set enabled(d){this.H(d)}H(d){this.w!==d&&(this.w=d,this.h.fire({enabled:d}))}get checked(){return this.z}set checked(d){this.I(d)}I(d){this.z!==d&&(this.z=d,this.h.fire({checked:d}))}async run(d,v){this.C&&await this.C(d)}}e.$aj=O;class M extends N.$Vc{constructor(){super(...arguments),this.f=this.B(new I.$ee),this.onWillRun=this.f.event,this.m=this.B(new I.$ee),this.onDidRun=this.m.event}async run(d,v){if(!d.enabled)return;this.f.fire({action:d});let m;try{await this.u(d,v)}catch(r){m=r}this.m.fire({action:d,error:m})}async u(d,v){await d.run(v)}}e.$bj=M;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...d){let v=[];for(const m of d)m.length&&(v.length?v=[...v,new b,...m]:v=m);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$cj=b;class p{get actions(){return this.a}constructor(d,v,m,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=d,this.label=v,this.class=r,this.a=m}async run(){}}e.$dj=p;class E extends O{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,R.localize(0,null),void 0,!1)}}e.$ej=E;function F(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked,run:async(...d)=>D.run(...d),tooltip:D.label}}}),define(Ie[146],Ce([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(Ie[147],Ce([1,0,146]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=E,e.$2m=F,e.$3m=D;const N=60,R=N*60,O=R*24,M=O*7,b=O*30,p=O*365;function E(d,v,m,r){typeof d!="number"&&(d=d.getTime());const o=Math.round((new Date().getTime()-d)/1e3);if(o<-30)return(0,I.localize)(0,null,E(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,I.localize)(1,null);let s;return o<N?(s=o,v?s===1?m?(0,I.localize)(2,null,s):(0,I.localize)(3,null,s):m?(0,I.localize)(4,null,s):(0,I.localize)(5,null,s):s===1?m?(0,I.localize)(6,null,s):(0,I.localize)(7,null,s):m?(0,I.localize)(8,null,s):(0,I.localize)(9,null,s)):o<R?(s=Math.floor(o/N),v?s===1?m?(0,I.localize)(10,null,s):(0,I.localize)(11,null,s):m?(0,I.localize)(12,null,s):(0,I.localize)(13,null,s):s===1?m?(0,I.localize)(14,null,s):(0,I.localize)(15,null,s):m?(0,I.localize)(16,null,s):(0,I.localize)(17,null,s)):o<O?(s=Math.floor(o/R),v?s===1?m?(0,I.localize)(18,null,s):(0,I.localize)(19,null,s):m?(0,I.localize)(20,null,s):(0,I.localize)(21,null,s):s===1?m?(0,I.localize)(22,null,s):(0,I.localize)(23,null,s):m?(0,I.localize)(24,null,s):(0,I.localize)(25,null,s)):o<M?(s=Math.floor(o/O),v?s===1?(0,I.localize)(26,null,s):(0,I.localize)(27,null,s):s===1?(0,I.localize)(28,null,s):(0,I.localize)(29,null,s)):o<b?(s=Math.floor(o/M),v?s===1?m?(0,I.localize)(30,null,s):(0,I.localize)(31,null,s):m?(0,I.localize)(32,null,s):(0,I.localize)(33,null,s):s===1?m?(0,I.localize)(34,null,s):(0,I.localize)(35,null,s):m?(0,I.localize)(36,null,s):(0,I.localize)(37,null,s)):o<p?(s=Math.floor(o/b),v?s===1?m?(0,I.localize)(38,null,s):(0,I.localize)(39,null,s):m?(0,I.localize)(40,null,s):(0,I.localize)(41,null,s):s===1?m?(0,I.localize)(42,null,s):(0,I.localize)(43,null,s):m?(0,I.localize)(44,null,s):(0,I.localize)(45,null,s)):(s=Math.floor(o/p),v?s===1?m?(0,I.localize)(46,null,s):(0,I.localize)(47,null,s):m?(0,I.localize)(48,null,s):(0,I.localize)(49,null,s):s===1?m?(0,I.localize)(50,null,s):(0,I.localize)(51,null,s):m?(0,I.localize)(52,null,s):(0,I.localize)(53,null,s))}function F(d,v){const m=Math.abs(d/1e3);return m<1?v?(0,I.localize)(54,null,d):(0,I.localize)(55,null,d):m<N?v?(0,I.localize)(56,null,Math.round(d)/1e3):(0,I.localize)(57,null,Math.round(d)/1e3):m<R?v?(0,I.localize)(58,null,Math.round(d/(1e3*N))):(0,I.localize)(59,null,Math.round(d/(1e3*N))):m<O?v?(0,I.localize)(60,null,Math.round(d/(1e3*R))):(0,I.localize)(61,null,Math.round(d/(1e3*R))):(0,I.localize)(62,null,Math.round(d/(1e3*O)))}function D(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ie[148],Ce([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(Ie[44],Ce([1,0,18,15,148]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gj=p,e.$hj=E,e.$ij=F;function O(D,d){return d&&(D.stack||D.stacktrace)?R.localize(0,null,b(D),M(D.stack)||M(D.stacktrace)):b(D)}function M(D){return Array.isArray(D)?D.join(`
`):D}function b(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?R.localize(1,null,D.message):D.message||R.localize(2,null)}function p(D=null,d=!1){if(!D)return R.localize(3,null);if(Array.isArray(D)){const v=I.$Hb(D),m=p(v[0],d);return v.length>1?R.localize(4,null,m,v.length):m}if(N.$8f(D))return D;if(D.detail){const v=D.detail;if(v.error)return O(v.error,d);if(v.exception)return O(v.exception,d)}return D.stack?O(D,d):D.message?D.message:R.localize(5,null)}function E(D){const d=D;return d instanceof Error&&Array.isArray(d.actions)}function F(D,d){let v;return typeof D=="string"?v=new Error(D):v=D,v.actions=d,v}}),define(Ie[149],Ce([1,0,42,19]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=b,e.$gr=p,e.$hr=E,e.$ir=F,e.$jr=D,e.$kr=d,e.$lr=v,e.$mr=m,e.$nr=r,e.$or=o,e.$pr=u,e.$qr=S,e.$rr=l;const R=new I.$V(()=>{const w=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:w,collatorIsNumeric:w.resolvedOptions().numeric}}),O=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(w,$,k=!1){const y=w||"",C=$||"",P=R.value.collator.compare(y,C);return R.value.collatorIsNumeric&&P===0&&y!==C?y<C?-1:1:P}function p(w,$){const k=O.value.collator;return w=w||"",$=$||"",c(k,w,$)}function E(w,$){const k=O.value.collator;return w=w||"",$=$||"",a(w,$)||c(k,w,$)}function F(w,$){const k=O.value.collator;return w=w||"",$=$||"",f(w,$)||c(k,w,$)}function D(w,$){return w=w||"",$=$||"",w===$?0:w<$?-1:1}function d(w,$){const[k,y]=i(w),[C,P]=i($);let W=R.value.collator.compare(y,P);if(W===0){if(R.value.collatorIsNumeric&&y!==P)return y<P?-1:1;if(W=R.value.collator.compare(k,C),R.value.collatorIsNumeric&&W===0&&k!==C)return k<C?-1:1}return W}function v(w,$){w=w||"",$=$||"";const k=n(w),y=n($),C=O.value.collator,P=M.value.collator;return c(P,k,y)||c(C,w,$)}function m(w,$){w=w||"",$=$||"";const k=n(w),y=n($),C=O.value.collator,P=M.value.collator;return c(P,k,y)||a(w,$)||c(C,w,$)}function r(w,$){w=w||"",$=$||"";const k=n(w),y=n($),C=O.value.collator,P=M.value.collator;return c(P,k,y)||f(w,$)||c(C,w,$)}function o(w,$){w=w||"",$=$||"";const k=n(w).toLowerCase(),y=n($).toLowerCase();return k!==y?k<y?-1:1:w!==$?w<$?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function i(w,$=!1){const k=w?s.exec(w):[];let y=[k&&k[1]||"",k&&k[3]||""];return $&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function n(w){const $=w?s.exec(w):[];return $&&$[1]&&$[1].charAt(0)!=="."&&$[3]||""}function c(w,$,k){const y=w.compare($,k);return y!==0?y:$.length!==k.length?$.length<k.length?-1:1:0}function h(w){const $=w.charAt(0);return $.toLocaleUpperCase()!==$}function t(w){const $=w.charAt(0);return $.toLocaleLowerCase()!==$}function f(w,$){return h(w)&&t($)?-1:t(w)&&h($)?1:0}function a(w,$){return t(w)&&h($)?-1:h(w)&&t($)?1:0}function g(w,$,k=!1){return k||(w=w&&w.toLowerCase(),$=$&&$.toLowerCase()),w===$?0:w<$?-1:1}function u(w,$,k=!1){const y=w.split(N.sep),C=$.split(N.sep),P=y.length-1,W=C.length-1;let V,q;for(let A=0;;A++){if(V=P===A,q=W===A,V&&q)return b(y[A],C[A],k);if(V)return-1;if(q)return 1;const U=g(y[A],C[A],k);if(U!==0)return U}}function S(w,$,k){const y=w.toLowerCase(),C=$.toLowerCase(),P=l(w,$,k);if(P)return P;const W=y.endsWith(k),V=C.endsWith(k);if(W!==V)return W?-1:1;const q=b(y,C);return q!==0?q:y.localeCompare(C)}function l(w,$,k){const y=w.toLowerCase(),C=$.toLowerCase(),P=y.startsWith(k),W=C.startsWith(k);if(P!==W)return P?-1:1;if(P&&W){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}}),define(Ie[48],Ce([1,0,19,22,13,15]),function(le,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=M,e.$og=b,e.$pg=p,e.$qg=E,e.$rg=F,e.$sg=m,e.$tg=r,e.$ug=o,e.$vg=s,e.$wg=i,e.$xg=n,e.$yg=c,e.$zg=h,e.$Ag=t,e.$Bg=f,e.$Cg=a,e.$Dg=S;function M(l){return l===47||l===92}function b(l){return l.replace(/[\\/]/g,I.$hc.sep)}function p(l){return l.indexOf("/")===-1&&(l=b(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}function E(l,w=I.$hc.sep){if(!l)return"";const $=l.length,k=l.charCodeAt(0);if(M(k)){if(M(l.charCodeAt(1))&&!M(l.charCodeAt(2))){let C=3;const P=C;for(;C<$&&!M(l.charCodeAt(C));C++);if(P!==C&&!M(l.charCodeAt(C+1))){for(C+=1;C<$;C++)if(M(l.charCodeAt(C)))return l.slice(0,C+1).replace(/[\\/]/g,w)}}return w}else if(s(k)&&l.charCodeAt(1)===58)return M(l.charCodeAt(2))?l.slice(0,2)+w:l.slice(0,2);let y=l.indexOf("://");if(y!==-1){for(y+=3;y<$;y++)if(M(l.charCodeAt(y)))return l.slice(0,y+1)}return""}function F(l){if(!N.$i||!l||l.length<5)return!1;let w=l.charCodeAt(0);if(w!==92||(w=l.charCodeAt(1),w!==92))return!1;let $=2;const k=$;for(;$<l.length&&(w=l.charCodeAt($),w!==92);$++);return!(k===$||(w=l.charCodeAt($+1),isNaN(w)||w===92))}const D=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(l,w=N.$i){const $=w?D:d;return!(!l||l.length===0||/^\s+$/.test(l)||($.lastIndex=0,$.test(l))||w&&v.test(l)||l==="."||l===".."||w&&l[l.length-1]==="."||w&&l.length!==l.trim().length||l.length>255)}function r(l,w,$){const k=l===w;return!$||k?k:!l||!w?!1:(0,R.$xf)(l,w)}function o(l,w,$,k=I.sep){if(l===w)return!0;if(!l||!w||w.length>l.length)return!1;if($){if(!(0,R.$yf)(l,w))return!1;if(w.length===l.length)return!0;let C=w.length;return w.charAt(w.length-1)===k&&C--,l.charAt(C)===k}return w.charAt(w.length-1)!==k&&(w+=k),l.indexOf(w)===0}function s(l){return l>=65&&l<=90||l>=97&&l<=122}function i(l,w){return N.$i&&l.endsWith(":")&&(l+=I.sep),(0,I.$jc)(l)||(l=(0,I.$kc)(w,l)),l=(0,I.$ic)(l),n(l)}function n(l){return N.$i?(l=(0,R.$ff)(l,I.sep),l.endsWith(":")&&(l+=I.sep)):(l=(0,R.$ff)(l,I.sep),l||(l=I.sep)),l}function c(l){const w=(0,I.$ic)(l);return N.$i?l.length>3?!1:h(w)&&(l.length===2||w.charCodeAt(2)===92):w===I.$hc.sep}function h(l,w=N.$i){return w?s(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}function t(l,w=N.$i){return h(l,w)?l[0]:void 0}function f(l,w,$){return w.length>l.length?-1:l===w?0:($&&(l=l.toLowerCase(),w=w.toLowerCase()),l.indexOf(w))}function a(l){const w=l.split(":");let $,k,y;for(const C of w){const P=Number(C);(0,O.$_f)(P)?k===void 0?k=P:y===void 0&&(y=P):$=$?[$,C].join(":"):C}if(!$)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:$,line:k!==void 0?k:void 0,column:y!==void 0?y:k!==void 0?1:void 0}}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(l,w,$=8){let k="";for(let C=0;C<$;C++){let P;C===0&&N.$i&&!w&&($===3||$===4)?P=u:P=g,k+=P.charAt(Math.floor(Math.random()*P.length))}let y;return w?y=`${w}-${k}`:y=k,l?(0,I.$kc)(l,y):y}}),define(Ie[70],Ce([1,0,19]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=void 0,e.$Qs=O,e.$Rs=M,e.$Ss=b,e.$Ts=E,e.$Ps=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(F){const D=(0,I.$pc)(F),d=N[D.toLowerCase()];return d!==void 0?d:M(F)}function M(F){const D=(0,I.$pc)(F);return R[D.toLowerCase()]}function b(F){for(const D in R)if(R[D]===F)return D}const p=/^(.+)\/(.+?)(;.+)?$/;function E(F,D){const d=p.exec(F);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:D?void 0:F}}),define(Ie[49],Ce([1,0,21,2]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=R,e.$4h=O,e.$5h=b;function R(p){return JSON.stringify(p,M)}function O(p){let E=JSON.parse(p);return E=b(E),E}function M(p,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function b(p,E=0){if(!p||E>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return N.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 17:return new Date(p.source)}if(p instanceof I.$Fe||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let F=0;F<p.length;++F)p[F]=b(p[F],E+1);else for(const F in p)Object.hasOwnProperty.call(p,F)&&(p[F]=b(p[F],E+1))}return p}}),define(Ie[16],Ce([1,0,14,22,13,2,19]),function(le,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Ig=e.$Hg=e.$Gg=e.Schemas=void 0,e.$Eg=p,e.$Fg=E,e.$Jg=D;var b;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.commentsInput="comment",m.codeSetting="code-setting"})(b||(e.Schemas=b={}));function p(m,r){return O.URI.isUri(m)?(0,R.$xf)(m.scheme,r):(0,R.$yf)(m,r+":")}function E(m,...r){return r.some(o=>p(m,o))}e.$Gg="vscode-tkn",e.$Hg="tkn";class F{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,o){this.f=D(r,o)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,b.vscodeRemoteResource)}set(r,o,s){this.a[r]=o,this.b[r]=s}setConnectionToken(r,o){this.c[r]=o}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(h){return I.$1(h),r}const o=r.authority;let s=this.a[o];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const i=this.b[o],n=this.c[o];let c=`path=${encodeURIComponent(r.path)}`;return typeof n=="string"&&(c+=`&${e.$Hg}=${encodeURIComponent(n)}`),O.URI.from({scheme:N.$o?this.d:b.vscodeRemoteResource,authority:`${s}:${i}`,path:this.g,query:c})}}e.$Ig=new F;function D(m,r){return M.$hc.join(r??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.$Kg="vs/../../extensions",e.$Lg="vs/../../node_modules",e.$Mg="vs/../../node_modules.asar",e.$Ng="vs/../../node_modules.asar.unpacked",e.$Og="vscode-app";class d{static{this.a=e.$Og}asBrowserUri(r){const o=this.b(r,le);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===b.vscodeRemote?e.$Ig.rewrite(r):r.scheme===b.file&&(N.$m||N.$q===`${b.vscodeFileResource}://${d.a}`)?r.with({scheme:b.vscodeFileResource,authority:r.authority||d.a,query:null,fragment:null}):r}asFileUri(r){const o=this.b(r,le);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===b.vscodeFileResource?r.with({scheme:b.file,authority:r.authority!==d.a?r.authority:null,query:null,fragment:null}):r}b(r,o){return O.URI.isUri(r)?r:O.URI.parse(o.toUrl(r))}}e.$Pg=new d;var v;(function(m){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function s(n){let c;typeof n=="string"?c=new URL(n).searchParams:n instanceof URL?c=n.searchParams:O.URI.isUri(n)&&(c=new URL(n.toString(!0)).searchParams);const h=c?.get(o);if(h)return r.get(h)}m.getHeadersFromQuery=s;function i(n,c,h){if(!globalThis.crossOriginIsolated)return;const t=c&&h?"3":h?"2":"1";n instanceof URLSearchParams?n.set(o,t):n[o]=t}m.addSearchParam=i})(v||(e.COI=v={}))}),define(Ie[23],Ce([1,0,48,16,19,22,13,2]),function(le,e,I,N,R,O,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=void 0,e.$Wg=p,e.$fh=F,e.$gh=d;function p(v){return(0,b.$xc)(v,!0)}class E{constructor(m){this.a=m}compare(m,r,o=!1){return m===r?0:(0,M.$qf)(this.getComparisonKey(m,o),this.getComparisonKey(r,o))}isEqual(m,r,o=!1){return m===r?!0:!m||!r?!1:this.getComparisonKey(m,o)===this.getComparisonKey(r,o)}getComparisonKey(m,r=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,r,o=!1){if(m.scheme===r.scheme){if(m.scheme===N.Schemas.file)return I.$ug(p(m),p(r),this.a(m))&&m.query===r.query&&(o||m.fragment===r.fragment);if((0,e.$bh)(m.authority,r.authority))return I.$ug(m.path,r.path,this.a(m),"/")&&m.query===r.query&&(o||m.fragment===r.fragment)}return!1}joinPath(m,...r){return b.URI.joinPath(m,...r)}basenameOrAuthority(m){return(0,e.$6g)(m)||m.authority}basename(m){return R.$hc.basename(m.path)}extname(m){return R.$hc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let r;return m.scheme===N.Schemas.file?r=b.URI.file(R.$nc(p(m))).path:(r=R.$hc.dirname(m.path),m.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),r="/")),m.with({path:r})}normalizePath(m){if(!m.path.length)return m;let r;return m.scheme===N.Schemas.file?r=b.URI.file(R.$ic(p(m))).path:r=R.$hc.normalize(m.path),m.with({path:r})}relativePath(m,r){if(m.scheme!==r.scheme||!(0,e.$bh)(m.authority,r.authority))return;if(m.scheme===N.Schemas.file){const i=R.$mc(p(m),p(r));return O.$i?I.$og(i):i}let o=m.path||"/";const s=r.path||"/";if(this.a(m)){let i=0;for(const n=Math.min(o.length,s.length);i<n&&!(o.charCodeAt(i)!==s.charCodeAt(i)&&o.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);o=s.substr(0,i)+o.substr(i)}return R.$hc.relative(o,s)}resolvePath(m,r){if(m.scheme===N.Schemas.file){const o=b.URI.file(R.$lc(p(m),r));return m.with({authority:o.authority,path:o.path})}return r=I.$pg(r),m.with({path:R.$hc.resolve(m.path,r)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,r){return m===r||m!==void 0&&r!==void 0&&(0,M.$xf)(m,r)}hasTrailingPathSeparator(m,r=R.sep){if(m.scheme===N.Schemas.file){const o=p(m);return o.length>I.$qg(o).length&&o[o.length-1]===r}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,r=R.sep){return(0,e.$ch)(m,r)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,r=R.sep){let o=!1;if(m.scheme===N.Schemas.file){const s=p(m);o=s!==void 0&&s.length===I.$qg(s).length&&s[s.length-1]===r}else{r="/";const s=m.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,e.$ch)(m,r)?m.with({path:m.path+"/"}):m}}e.$Xg=E,e.$Yg=new E(()=>!1),e.$Zg=new E(v=>v.scheme===N.Schemas.file?!O.$k:!0),e.$1g=new E(v=>!0),e.$2g=e.$Yg.isEqual.bind(e.$Yg),e.$3g=e.$Yg.isEqualOrParent.bind(e.$Yg),e.$4g=e.$Yg.getComparisonKey.bind(e.$Yg),e.$5g=e.$Yg.basenameOrAuthority.bind(e.$Yg),e.$6g=e.$Yg.basename.bind(e.$Yg),e.$7g=e.$Yg.extname.bind(e.$Yg),e.$8g=e.$Yg.dirname.bind(e.$Yg),e.$9g=e.$Yg.joinPath.bind(e.$Yg),e.$0g=e.$Yg.normalizePath.bind(e.$Yg),e.$$g=e.$Yg.relativePath.bind(e.$Yg),e.$_g=e.$Yg.resolvePath.bind(e.$Yg),e.$ah=e.$Yg.isAbsolutePath.bind(e.$Yg),e.$bh=e.$Yg.isEqualAuthority.bind(e.$Yg),e.$ch=e.$Yg.hasTrailingPathSeparator.bind(e.$Yg),e.$dh=e.$Yg.removeTrailingPathSeparator.bind(e.$Yg),e.$eh=e.$Yg.addTrailingPathSeparator.bind(e.$Yg);function F(v,m){const r=[];for(let o=0;o<v.length;o++){const s=m(v[o]);v.some((i,n)=>n===o?!1:(0,e.$3g)(s,m(i)))||r.push(v[o])}return r}var D;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function m(r){const o=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(n=>{const[c,h]=n.split(":");c&&h&&o.set(c,h)});const i=r.path.substring(0,r.path.indexOf(";"));return i&&o.set(v.META_DATA_MIME,i),o}v.parseMetaData=m})(D||(e.DataUri=D={}));function d(v,m,r){if(m){let o=v.path;return o&&o[0]!==R.$hc.sep&&(o=R.$hc.sep+o),v.with({scheme:r,authority:m,path:o})}return v.with({scheme:r})}}),define(Ie[11],Ce([1,0,24,14,5,6,23,22,136,42]),function(le,e,I,N,R,O,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.Promises=e.$Sh=e.$Rh=e.$Qh=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=void 0,e.$hh=F,e.$ih=D,e.$jh=d,e.$kh=v,e.$lh=m,e.$mh=r,e.$nh=o,e.$oh=s,e.$wh=S,e.$xh=l,e.$yh=w,e.$zh=$,e.$Ah=k,e.$Ph=Pe,e.$Xh=De;function F(ge){return!!ge&&typeof ge.then=="function"}function D(ge){const Q=new I.$pe,X=ge(Q.token),he=new Promise((ue,Fe)=>{const de=Q.token.onCancellationRequested(()=>{de.dispose(),Fe(new N.$5)});Promise.resolve(X).then(Re=>{de.dispose(),Q.dispose(),ue(Re)},Re=>{de.dispose(),Q.dispose(),Fe(Re)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(ue,Fe){return he.then(ue,Fe)}catch(ue){return this.then(void 0,ue)}finally(ue){return he.finally(ue)}}}function d(ge,Q,X){return new Promise((he,ue)=>{const Fe=Q.onCancellationRequested(()=>{Fe.dispose(),he(X)});ge.then(he,ue).finally(()=>Fe.dispose())})}function v(ge,Q){return new Promise((X,he)=>{const ue=Q.onCancellationRequested(()=>{ue.dispose(),he(new N.$5)});ge.then(X,he).finally(()=>ue.dispose())})}async function m(ge){let Q=-1;const X=ge.map((he,ue)=>he.then(Fe=>(Q=ue,Fe)));try{return await Promise.race(X)}finally{ge.forEach((he,ue)=>{ue!==Q&&he.cancel()})}}function r(ge,Q,X){let he;const ue=setTimeout(()=>{he?.(void 0),X?.()},Q);return Promise.race([ge.finally(()=>clearTimeout(ue)),new Promise(Fe=>he=Fe)])}function o(ge){return new Promise((Q,X)=>{const he=ge();F(he)?he.then(Q,X):Q(he)})}function s(){let ge,Q;return{promise:new Promise((he,ue)=>{ge=he,Q=ue}),resolve:ge,reject:Q}}class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const X=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(X,X).then(he)})}return new Promise((X,he)=>{this.b.then(X,he)})}return this.a=Q(),new Promise((X,he)=>{this.a.then(ue=>{this.a=null,X(ue)},ue=>{this.a=null,he(ue)})})}dispose(){this.f=!0}}e.$ph=i;class n{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$qh=n;class c{constructor(){this.a=new Map}queue(Q,X){const ue=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(X).finally(()=>{this.a.get(Q)===ue&&this.a.delete(Q)});return this.a.set(Q,ue),ue}}e.$rh=c;const h=(ge,Q)=>{let X=!0;const he=setTimeout(()=>{X=!1,Q()},ge);return{isTriggered:()=>X,dispose:()=>{clearTimeout(he),X=!1}}},t=ge=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,ge())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class f{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,X=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((ue,Fe)=>{this.d=ue,this.f=Fe}).then(()=>{if(this.b=null,this.d=null,this.g){const ue=this.g;return this.g=null,ue()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=X===p.$be?t(he):h(X,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$sh=f;class a{constructor(Q){this.a=new f(Q),this.b=new i}trigger(Q,X){return this.a.trigger(()=>this.b.queue(Q),X)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$th=a;class g{constructor(){this.a=!1,this.b=new Promise((Q,X)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$uh=g;class u extends g{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$vh=u;function S(ge,Q){return Q?new Promise((X,he)=>{const ue=setTimeout(()=>{Fe.dispose(),X()},ge),Fe=Q.onCancellationRequested(()=>{clearTimeout(ue),Fe.dispose(),he(new N.$5)})}):D(X=>S(ge,X))}function l(ge,Q=0,X){const he=setTimeout(()=>{ge(),X&&ue.dispose()},Q),ue=(0,O.$Tc)(()=>{clearTimeout(he),X?.deleteAndLeak(ue)});return X?.add(ue),ue}function w(ge){const Q=[];let X=0;const he=ge.length;function ue(){return X<he?ge[X++]():null}function Fe(de){de!=null&&Q.push(de);const Re=ue();return Re?Re.then(Fe):Promise.resolve(Q)}return Promise.resolve(null).then(Fe)}function $(ge,Q=he=>!!he,X=null){let he=0;const ue=ge.length,Fe=()=>{if(he>=ue)return Promise.resolve(X);const de=ge[he++];return Promise.resolve(de()).then(Ne=>Q(Ne)?Promise.resolve(Ne):Fe())};return Fe()}function k(ge,Q=he=>!!he,X=null){if(ge.length===0)return Promise.resolve(X);let he=ge.length;const ue=()=>{he=-1;for(const Fe of ge)Fe.cancel?.()};return new Promise((Fe,de)=>{for(const Re of ge)Re.then(Ne=>{--he>=0&&Q(Ne)?(ue(),Fe(Ne)):he===0&&Fe(X)}).catch(Ne=>{--he>=0&&(ue(),de(Ne))})})}class y{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new R.$ee}whenIdle(){return this.size>0?R.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((X,he)=>{this.g.push({factory:Q,c:X,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const X=Q.factory();X.then(Q.c,Q.e),X.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Bh=y;class C extends y{constructor(){super(1)}}e.$Ch=C;class P{constructor(){this.a=new fe,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Dh=P;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new ce;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,X=M.$Yg){const he=X.getComparisonKey(Q);return this.a.get(he)?.size??0}queueFor(Q,X,he=M.$Yg){const ue=he.getComparisonKey(Q);let Fe=this.a.get(ue);if(!Fe){Fe=new C;const de=this.f++,Re=R.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$5c),this.d.set(de,Re),this.a.set(ue,Fe)}return Fe.queue(X)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Eh=W;class V{constructor(Q,X){this.a=-1,typeof Q=="function"&&typeof X=="number"&&this.setIfNotSet(Q,X)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,X){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},X)}setIfNotSet(Q,X){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},X))}}e.$Fh=V;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,X,he=globalThis){this.cancel();const ue=he.setInterval(()=>{Q()},X);this.d=(0,O.$Tc)(()=>{he.clearInterval(ue),this.d=void 0})}dispose(){this.cancel()}}e.$Gh=q;class A{constructor(Q,X){this.b=-1,this.a=Q,this.d=X,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Hh=A;class U{constructor(Q,X){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.a=Q,this.b=X,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ih=U;class K extends A{constructor(Q,X){super(Q,X),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Jh=K;class re extends O.$Vc{constructor(Q,X){super(),this.g=Q,this.h=X,this.a=[],this.b=this.B(new O.$Wc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const X of Q)this.a.push(X);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new A(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Kh=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Mh=(ge,Q)=>{(0,b.$B)(()=>{if(X)return;const he=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let X=!1;return{dispose(){X||(X=!0)}}}:e.$Mh=(ge,Q,X)=>{const he=ge.requestIdleCallback(Q,typeof X=="number"?{timeout:X}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,ge.cancelIdleCallback(he))}}},e.$Lh=ge=>(0,e.$Mh)(globalThis,ge)}();class ae{constructor(Q,X){this.g=!1,this.d=()=>{try{this.j=X()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Mh)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Nh=ae;class ye extends ae{constructor(Q){super(globalThis,Q)}}e.$Oh=ye;async function Pe(ge,Q,X){let he;for(let ue=0;ue<X;ue++)try{return await ge()}catch(Fe){he=Fe,await S(Q)}throw he}class fe{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,X,he){return this.a={taskId:Q,cancel:()=>he?.(),promise:X},X.then(()=>this.d(Q),()=>this.d(Q)),X}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:X,resolve:he,reject:ue}=s();this.b={run:Q,promise:X,promiseResolve:he,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Qh=fe;class me{constructor(Q,X=()=>Date.now()){this.d=Q,this.f=X,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Rh=me;var Ae;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(Ae||(Ae={}));class ce{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,X)=>{this.a=Q,this.b=X})}complete(Q){return new Promise(X=>{this.a(Q),this.d={outcome:0,value:Q},X()})}error(Q){return new Promise(X=>{this.b(Q),this.d={outcome:1,value:Q},X()})}cancel(){return this.error(new N.$5)}}e.$Sh=ce;var Me;(function(ge){async function Q(he){let ue;const Fe=await Promise.all(he.map(de=>de.then(Re=>Re,Re=>{ue||(ue=Re)})));if(typeof ue<"u")throw ue;return Fe}ge.settled=Q;function X(he){return new Promise(async(ue,Fe)=>{try{await he(ue,Fe)}catch(de){Fe(de)}})}ge.withAsyncBody=X})(Me||(e.Promises=Me={}));class ie{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(X=>(this.a=X,this.d=!0,X),X=>{throw this.b=X,this.d=!0,X})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Th=ie;class z{constructor(Q){this.b=Q,this.a=new E.$V(()=>new ie(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Uh=z;var x;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(x||(x={}));class ve{static fromArray(Q){return new ve(X=>{X.emitMany(Q)})}static fromPromise(Q){return new ve(async X=>{X.emitMany(await Q)})}static fromPromises(Q){return new ve(async X=>{await Promise.all(Q.map(async he=>X.emitOne(await he)))})}static merge(Q){return new ve(async X=>{await Promise.all(Q.map(async he=>{for await(const ue of he)X.emitOne(ue)}))})}static{this.EMPTY=ve.fromArray([])}constructor(Q,X){this.a=0,this.b=[],this.d=null,this.f=X,this.g=new R.$ee,queueMicrotask(async()=>{const he={emitOne:ue=>this.h(ue),emitMany:ue=>this.j(ue),reject:ue=>this.l(ue)};try{await Promise.resolve(Q(he)),this.k()}catch(ue){this.l(ue)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await R.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,X){return new ve(async he=>{for await(const ue of Q)he.emitOne(X(ue))})}map(Q){return ve.map(this,Q)}static filter(Q,X){return new ve(async he=>{for await(const ue of Q)X(ue)&&he.emitOne(ue)})}filter(Q){return ve.filter(this,Q)}static coalesce(Q){return ve.filter(Q,X=>!!X)}coalesce(){return ve.coalesce(this)}static async toPromise(Q){const X=[];for await(const he of Q)X.push(he);return X}toPromise(){return ve.toPromise(this)}h(Q){this.a===0&&(this.b.push(Q),this.g.fire())}j(Q){this.a===0&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Q){this.a===0&&(this.a=2,this.d=Q,this.g.fire())}}e.$Vh=ve;class Te extends ve{constructor(Q,X){super(X),this.m=Q}cancel(){this.m.cancel()}}e.$Wh=Te;function De(ge){const Q=new I.$pe,X=ge(Q.token);return new Te(Q,async he=>{const ue=Q.token.onCancellationRequested(()=>{ue.dispose(),Q.dispose(),he.reject(new N.$5)});try{for await(const Fe of X){if(Q.token.isCancellationRequested)return;he.emitOne(Fe)}ue.dispose(),Q.dispose()}catch(Fe){ue.dispose(),Q.dispose(),he.reject(Fe)}})}class $e{constructor(Q){this.a=new ce,this.b=new ve(ue=>{if(X){ue.reject(X);return}return he&&ue.emitMany(he),this.d=Fe=>ue.reject(Fe),this.f=Fe=>ue.emitOne(Fe),this.a.p},Q);let X,he;this.f=ue=>{he||(he=[]),he.push(ue)},this.d=ue=>{X||(X=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$Yh=$e}),define(Ie[36],Ce([1,0,18,11,48,28,19,22,13]),function(le,e,I,N,R,O,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$kk=E,e.$nk=m,e.$ok=C,e.$pk=P,e.$qk=W,e.$rk=V,e.$sk=q,e.$tk=re;function E(){return Object.create(null)}e.$lk="**",e.$mk="/";const F="[/\\\\]",D="[^/\\\\]",d=/\//g;function v(ae,ye){switch(ae){case 0:return"";case 1:return`${D}*?`;default:return`(?:${F}|${D}+${F}${ye?`|${F}${D}+`:""})*?`}}function m(ae,ye){if(!ae)return[];const Pe=[];let fe=!1,me=!1,Ae="";for(const ce of ae){switch(ce){case ye:if(!fe&&!me){Pe.push(Ae),Ae="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":me=!0;break;case"]":me=!1;break}Ae+=ce}return Ae&&Pe.push(Ae),Pe}function r(ae){if(!ae)return"";let ye="";const Pe=m(ae,e.$mk);if(Pe.every(fe=>fe===e.$lk))ye=".*";else{let fe=!1;Pe.forEach((me,Ae)=>{if(me===e.$lk){if(fe)return;ye+=v(2,Ae===Pe.length-1)}else{let ce=!1,Me="",ie=!1,z="";for(const x of me){if(x!=="}"&&ce){Me+=x;continue}if(ie&&(x!=="]"||!z)){let ve;x==="-"?ve=x:(x==="^"||x==="!")&&!z?ve="^":x===e.$mk?ve="":ve=(0,p.$_e)(x),z+=ve;continue}switch(x){case"{":ce=!0;continue;case"[":ie=!0;continue;case"}":{const Te=`(?:${m(Me,",").map(De=>r(De)).join("|")})`;ye+=Te,ce=!1,Me="";break}case"]":{ye+="["+z+"]",ie=!1,z="";break}case"?":ye+=D;continue;case"*":ye+=v(1);continue;default:ye+=(0,p.$_e)(x)}}Ae<Pe.length-1&&(Pe[Ae+1]!==e.$lk||Ae+2<Pe.length)&&(ye+=F)}fe=me===e.$lk})}return ye}const o=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.$Ec(1e4),f=function(){return!1},a=function(){return null};function g(ae,ye){if(!ae)return a;let Pe;typeof ae!="string"?Pe=ae.pattern:Pe=ae,Pe=Pe.trim();const fe=`${Pe}_${!!ye.trimForExclusions}`;let me=t.get(fe);if(me)return u(me,ae);let Ae;return o.test(Pe)?me=l(Pe.substr(4),Pe):(Ae=s.exec(S(Pe,ye)))?me=w(Ae[1],Pe):(ye.trimForExclusions?n:i).test(Pe)?me=$(Pe,ye):(Ae=c.exec(S(Pe,ye)))?me=k(Ae[1].substr(1),Pe,!0):(Ae=h.exec(S(Pe,ye)))?me=k(Ae[1],Pe,!1):me=y(Pe),t.set(fe,me),u(me,ae)}function u(ae,ye){if(typeof ye=="string")return ae;const Pe=function(fe,me){return(0,R.$ug)(fe,ye.base,!b.$k)?ae((0,p.$ef)(fe.substr(ye.base.length),M.sep),me):null};return Pe.allBasenames=ae.allBasenames,Pe.allPaths=ae.allPaths,Pe.basenames=ae.basenames,Pe.patterns=ae.patterns,Pe}function S(ae,ye){return ye.trimForExclusions&&ae.endsWith("/**")?ae.substr(0,ae.length-2):ae}function l(ae,ye){return function(Pe,fe){return typeof Pe=="string"&&Pe.endsWith(ae)?ye:null}}function w(ae,ye){const Pe=`/${ae}`,fe=`\\${ae}`,me=function(ce,Me){return typeof ce!="string"?null:Me?Me===ae?ye:null:ce===ae||ce.endsWith(Pe)||ce.endsWith(fe)?ye:null},Ae=[ae];return me.basenames=Ae,me.patterns=[ye],me.allBasenames=Ae,me}function $(ae,ye){const Pe=K(ae.slice(1,-1).split(",").map(Me=>g(Me,ye)).filter(Me=>Me!==a),ae),fe=Pe.length;if(!fe)return a;if(fe===1)return Pe[0];const me=function(Me,ie){for(let z=0,x=Pe.length;z<x;z++)if(Pe[z](Me,ie))return ae;return null},Ae=Pe.find(Me=>!!Me.allBasenames);Ae&&(me.allBasenames=Ae.allBasenames);const ce=Pe.reduce((Me,ie)=>ie.allPaths?Me.concat(ie.allPaths):Me,[]);return ce.length&&(me.allPaths=ce),me}function k(ae,ye,Pe){const fe=M.sep===M.$hc.sep,me=fe?ae:ae.replace(d,M.sep),Ae=M.sep+me,ce=M.$hc.sep+ae;let Me;return Pe?Me=function(ie,z){return typeof ie=="string"&&(ie===me||ie.endsWith(Ae)||!fe&&(ie===ae||ie.endsWith(ce)))?ye:null}:Me=function(ie,z){return typeof ie=="string"&&(ie===me||!fe&&ie===ae)?ye:null},Me.allPaths=[(Pe?"*/":"./")+ae],Me}function y(ae){try{const ye=new RegExp(`^${r(ae)}$`);return function(Pe){return ye.lastIndex=0,typeof Pe=="string"&&ye.test(Pe)?ae:null}}catch{return a}}function C(ae,ye,Pe){return!ae||typeof ye!="string"?!1:P(ae)(ye,void 0,Pe)}function P(ae,ye={}){if(!ae)return f;if(typeof ae=="string"||W(ae)){const Pe=g(ae,ye);if(Pe===a)return f;const fe=function(me,Ae){return!!Pe(me,Ae)};return Pe.allBasenames&&(fe.allBasenames=Pe.allBasenames),Pe.allPaths&&(fe.allPaths=Pe.allPaths),fe}return A(ae,ye)}function W(ae){const ye=ae;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}function V(ae){return ae.allBasenames||[]}function q(ae){return ae.allPaths||[]}function A(ae,ye){const Pe=K(Object.getOwnPropertyNames(ae).map(Me=>U(Me,ae[Me],ye)).filter(Me=>Me!==a)),fe=Pe.length;if(!fe)return a;if(!Pe.some(Me=>!!Me.requiresSiblings)){if(fe===1)return Pe[0];const Me=function(x,ve){let Te;for(let De=0,$e=Pe.length;De<$e;De++){const ge=Pe[De](x,ve);if(typeof ge=="string")return ge;(0,N.$hh)(ge)&&(Te||(Te=[]),Te.push(ge))}return Te?(async()=>{for(const De of Te){const $e=await De;if(typeof $e=="string")return $e}return null})():null},ie=Pe.find(x=>!!x.allBasenames);ie&&(Me.allBasenames=ie.allBasenames);const z=Pe.reduce((x,ve)=>ve.allPaths?x.concat(ve.allPaths):x,[]);return z.length&&(Me.allPaths=z),Me}const me=function(Me,ie,z){let x,ve;for(let Te=0,De=Pe.length;Te<De;Te++){const $e=Pe[Te];$e.requiresSiblings&&z&&(ie||(ie=(0,M.$oc)(Me)),x||(x=ie.substr(0,ie.length-(0,M.$pc)(Me).length)));const ge=$e(Me,ie,x,z);if(typeof ge=="string")return ge;(0,N.$hh)(ge)&&(ve||(ve=[]),ve.push(ge))}return ve?(async()=>{for(const Te of ve){const De=await Te;if(typeof De=="string")return De}return null})():null},Ae=Pe.find(Me=>!!Me.allBasenames);Ae&&(me.allBasenames=Ae.allBasenames);const ce=Pe.reduce((Me,ie)=>ie.allPaths?Me.concat(ie.allPaths):Me,[]);return ce.length&&(me.allPaths=ce),me}function U(ae,ye,Pe){if(ye===!1)return a;const fe=g(ae,Pe);if(fe===a)return a;if(typeof ye=="boolean")return fe;if(ye){const me=ye.when;if(typeof me=="string"){const Ae=(ce,Me,ie,z)=>{if(!z||!fe(ce,Me))return null;const x=me.replace("$(basename)",()=>ie),ve=z(x);return(0,N.$hh)(ve)?ve.then(Te=>Te?ae:null):ve?ae:null};return Ae.requiresSiblings=!0,Ae}}return fe}function K(ae,ye){const Pe=ae.filter(Me=>!!Me.basenames);if(Pe.length<2)return ae;const fe=Pe.reduce((Me,ie)=>{const z=ie.basenames;return z?Me.concat(z):Me},[]);let me;if(ye){me=[];for(let Me=0,ie=fe.length;Me<ie;Me++)me.push(ye)}else me=Pe.reduce((Me,ie)=>{const z=ie.patterns;return z?Me.concat(z):Me},[]);const Ae=function(Me,ie){if(typeof Me!="string")return null;if(!ie){let x;for(x=Me.length;x>0;x--){const ve=Me.charCodeAt(x-1);if(ve===47||ve===92)break}ie=Me.substr(x)}const z=fe.indexOf(ie);return z!==-1?me[z]:null};Ae.basenames=fe,Ae.patterns=me,Ae.allBasenames=fe;const ce=ae.filter(Me=>!Me.basenames);return ce.push(Ae),ce}function re(ae,ye){return(0,I.$ub)(ae,ye,(Pe,fe)=>typeof Pe=="string"&&typeof fe=="string"?Pe===fe:typeof Pe!="string"&&typeof fe!="string"?Pe.base===fe.base&&Pe.pattern===fe.pattern:!1)}}),define(Ie[55],Ce([1,0,14,137,23,13,2]),function(le,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.MarkdownStringTextNewlineStyle=void 0,e.$Tk=E,e.$Uk=F,e.$Vk=D,e.$Wk=d,e.$Xk=v,e.$Yk=m,e.$Zk=r,e.$1k=o;var b;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class p{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,I.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=d(this.supportThemeIcons?(0,N.$Mk)(i):i).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${v(n,i)}
`,this}appendLink(i,n,c){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(i,n){const c=new RegExp((0,O.$_e)(n),"g");return i.replace(c,(h,t)=>i.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$Sk=p;function E(s){return F(s)?!s.value:Array.isArray(s)?s.every(E):!0}function F(s){return s instanceof p?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function D(s,i){return s===i?!0:!s||!i?!1:s.value===i.value&&s.isTrusted===i.isTrusted&&s.supportThemeIcons===i.supportThemeIcons&&s.supportHtml===i.supportHtml&&(s.baseUri===i.baseUri||!!s.baseUri&&!!i.baseUri&&(0,R.$2g)(M.URI.from(s.baseUri),M.URI.from(i.baseUri)))}function d(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function v(s,i){const n=s.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,c=n>=3?n+1:3;return[`${"`".repeat(c)}${i}`,s,`${"`".repeat(c)}`].join(`
`)}function m(s){return s.replace(/"/g,"&quot;")}function r(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(s){const i=[],n=s.split("|").map(h=>h.trim());s=n[0];const c=n[1];if(c){const h=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),f=h?h[1]:"",a=t?t[1]:"",g=isFinite(parseInt(a)),u=isFinite(parseInt(f));g&&i.push(`width="${a}"`),u&&i.push(`height="${f}"`)}return{href:s,dimensions:i}}}),define(Ie[97],Ce([1,0,18,48,19,22,23,13]),function(le,e,I,N,R,O,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ww=p,e.$xw=F,e.$yw=d,e.$zw=v,e.$Aw=s,e.$Bw=n,e.$Cw=c,e.$Dw=h,e.$Ew=t,e.$Fw=f;function p(g,u){const{os:S,tildify:l,relative:w}=u;if(w){const y=E(g,w,S);if(typeof y=="string")return y}let $=g.fsPath;if(S===1&&!O.$i?$=$.replace(/\//g,"\\"):S!==1&&O.$i&&($=$.replace(/\\/g,"/")),S!==1&&l?.userHome){const y=l.userHome.fsPath;let C;g.scheme!==l.userHome.scheme&&g.path[0]===R.$hc.sep&&g.path[1]!==R.$hc.sep?C=l.userHome.with({path:g.path}).fsPath:C=$,$=d(C,y,S)}return(S===1?R.$gc:R.$hc).normalize(F($,S===1))}function E(g,u,S){const l=S===1?R.$gc:R.$hc,w=S===3?M.$Yg:M.$1g,$=u.getWorkspace(),k=(0,I.$Ob)($.folders);if(!k)return;g.scheme!==k.uri.scheme&&g.path[0]===R.$hc.sep&&g.path[1]!==R.$hc.sep&&(g=k.uri.with({path:g.path}));const y=u.getWorkspaceFolder(g);if(!y)return;let C;if(w.isEqual(y.uri,g)?C="":C=w.relativePath(y.uri,g)??"",C&&(C=l.normalize(C)),$.folders.length>1&&!u.noPrefix){const P=y.name?y.name:w.basenameOrAuthority(y.uri);C=C?`${P} \u2022 ${C}`:P}return C}function F(g,u=O.$i){return(0,N.$zg)(g,u)?g.charAt(0).toUpperCase()+g.slice(1):g}let D=Object.create(null);function d(g,u,S=O.OS){if(S===1||!g||!u)return g;let l=D.original===u?D.normalized:void 0;l||(l=u,O.$i&&(l=(0,N.$og)(l)),l=`${(0,b.$ff)(l,R.$hc.sep)}${R.$hc.sep}`,D={original:u,normalized:l});let w=g;return O.$i&&(w=(0,N.$og)(w)),(S===3?w.startsWith(l):(0,b.$yf)(w,l))?`~/${w.substr(l.length)}`:g}function v(g,u){return g.replace(/^~($|\/|\\)/,`${u}$1`)}const m="\u2026",r="\\\\",o="~";function s(g,u=R.sep){const S=new Array(g.length);let l=!1;for(let w=0;w<g.length;w++){const $=g[w];if($===""){S[w]=`.${u}`;continue}if(!$){S[w]=$;continue}l=!0;let k="",y=$;y.indexOf(r)===0?(k=y.substr(0,y.indexOf(r)+r.length),y=y.substr(y.indexOf(r)+r.length)):y.indexOf(u)===0?(k=y.substr(0,y.indexOf(u)+u.length),y=y.substr(y.indexOf(u)+u.length)):y.indexOf(o)===0&&(k=y.substr(0,y.indexOf(o)+o.length),y=y.substr(y.indexOf(o)+o.length));const C=y.split(u);for(let P=1;l&&P<=C.length;P++)for(let W=C.length-P;l&&W>=0;W--){l=!1;let V=C.slice(W,W+P).join(u);for(let q=0;!l&&q<g.length;q++)if(q!==w&&g[q]&&g[q].indexOf(V)>-1){const A=W+P===C.length,U=W>0&&g[q].indexOf(u)>-1?u+V:V,K=g[q].endsWith(U);l=!A||K}if(!l){let q="";(C[0].endsWith(":")||k!=="")&&(W===1&&(W=0,P++,V=C[0]+u+V),W>0&&(q=C[0]+u),q=k+q),W>0&&(q=q+m+u),q=q+V,W+P<C.length&&(q=q+u+m),S[w]=q}}l&&(S[w]=$)}return S}var i;(function(g){g[g.TEXT=0]="TEXT",g[g.VARIABLE=1]="VARIABLE",g[g.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(g,u=Object.create(null)){const S=[];let l=!1,w="";for(const $ of g)if($==="$"||l&&$==="{")w&&S.push({value:w,type:i.TEXT}),w="",l=!0;else if($==="}"&&l){const k=u[w];if(typeof k=="string")k.length&&S.push({value:k,type:i.VARIABLE});else if(k){const y=S[S.length-1];(!y||y.type!==i.SEPARATOR)&&S.push({value:k.label,type:i.SEPARATOR})}w="",l=!1}else w+=$;return w&&!l&&S.push({value:w,type:i.TEXT}),S.filter(($,k)=>{if($.type===i.SEPARATOR){const y=S[k-1],C=S[k+1];return[y,C].every(P=>P&&(P.type===i.VARIABLE||P.type===i.TEXT)&&P.value.length>0)}return!0}).map($=>$.value).join("")}function c(g,u){return O.$j||u?g.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):g.replace(/&&|&/g,S=>S==="&"?"&&":"&")}function h(g,u){return O.$j||u?g.replace(/\(&&\w\)|&&/g,""):O.$i?g.replace(/&&|&/g,S=>S==="&"?"&&":"&"):g.replace(/&&/g,"_")}function t(g){return g.replace(/&/g,"&&")}function f(g){if(g.endsWith("]")){const u=g.lastIndexOf(" [",g.length-2);if(u!==-1){const S=a(g.substring(0,u)),l=g.substring(u);return{name:S.name+l,parentPath:S.parentPath}}}return a(g)}function a(g){const u=g.indexOf("/")!==-1?R.$hc:R.$gc,S=u.basename(g),l=u.dirname(g);return S.length?{name:S,parentPath:l}:{name:l,parentPath:""}}}),define(Ie[150],Ce([1,0,21,2]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=void 0,e.$zn=b,e.$An=E,e.$Bn=F;function R(D){return D.toJSON()}class O{constructor(d){this.a=d}transformIncoming(d){const v=this.a.transformIncoming(d);return v===d?d:R(N.URI.from(v))}transformOutgoing(d){const v=this.a.transformOutgoing(d);return v===d?d:R(N.URI.from(v))}transformOutgoingURI(d){const v=this.a.transformOutgoing(d);return v===d?d:N.URI.from(v)}transformOutgoingScheme(d){return this.a.transformOutgoingScheme(d)}}e.$xn=O,e.$yn=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function M(D,d,v){if(!D||v>200)return null;if(typeof D=="object"){if(D instanceof N.URI)return d.transformOutgoing(D);for(const m in D)if(Object.hasOwnProperty.call(D,m)){const r=M(D[m],d,v+1);r!==null&&(D[m]=r)}}return null}function b(D,d){const v=M(D,d,0);return v===null?D:v}function p(D,d,v,m){if(!D||m>200)return null;if(typeof D=="object"){if(D.$mid===1)return v?N.URI.revive(d.transformIncoming(D)):d.transformIncoming(D);if(D instanceof I.$Fe)return null;for(const r in D)if(Object.hasOwnProperty.call(D,r)){const o=p(D[r],d,v,m+1);o!==null&&(D[r]=o)}}return null}function E(D,d){const v=p(D,d,!1,0);return v===null?D:v}function F(D,d){const v=p(D,d,!0,0);return v===null?D:v}}),define(Ie[151],Ce([1,0,11,5,6,49,15]),function(le,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=e.StorageState=e.StorageHint=void 0,e.$Up=p;var b;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function p(d){const v=d;return v?.changed instanceof Map||v?.deleted instanceof Set}var E;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(E||(e.StorageState=E={}));class F extends R.$Vc{static{this.a=100}constructor(v,m=Object.create(null)){super(),this.r=v,this.s=m,this.b=this.B(new N.$he),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new I.$th(F.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(v=>this.u(v)))}u(v){this.b.pause();try{v.changed?.forEach((m,r)=>this.w(r,m)),v.deleted?.forEach(m=>this.w(m,void 0))}finally{this.b.resume()}}w(v,m){if(this.c===E.Closed)return;let r=!1;(0,M.$eg)(m)?r=this.f.delete(v):this.f.get(v)!==m&&(this.f.set(v,m),r=!0),r&&this.b.fire({key:v,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(v,m){const r=this.f.get(v);return(0,M.$eg)(r)?m:r}getBoolean(v,m){const r=this.get(v);return(0,M.$eg)(r)?m:r==="true"}getNumber(v,m){const r=this.get(v);return(0,M.$eg)(r)?m:parseInt(r,10)}getObject(v,m){const r=this.get(v);return(0,M.$eg)(r)?m:(0,O.$4h)(r)}async set(v,m,r=!1){if(this.c===E.Closed)return;if((0,M.$eg)(m))return this.delete(v,r);const o=(0,M.$0f)(m)||Array.isArray(m)?(0,O.$3h)(m):String(m);if(this.f.get(v)!==o)return this.f.set(v,o),this.j.set(v,o),this.h.delete(v),this.b.fire({key:v,external:r}),this.D()}async delete(v,m=!1){if(!(this.c===E.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire({key:v,external:m}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(v).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(v){if(this.z)return this.D(v)}async D(v){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),v)}async whenFlushed(){if(this.z)return new Promise(v=>this.n.push(v))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Vp=F;class D{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((m,r)=>this.a.set(r,m)),v.delete?.forEach(m=>this.a.delete(m))}async optimize(){}async close(){}}e.$Wp=D}),define(Ie[152],Ce([1,0,13,22,21]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=void 0,e.$Ct=F,e.$Dt=D;let O;function M(){return O||(O=new TextDecoder("UTF-16LE")),O}let b;function p(){return b||(b=new TextDecoder("UTF-16BE")),b}let E;function F(){return E||(E=N.$D()?M():p()),E}function D(m,r,o){const s=new Uint16Array(m.buffer,r,o);return o>0&&(s[0]===65279||s[0]===65534)?d(m,r,o):M().decode(s)}function d(m,r,o){const s=[];let i=0;for(let n=0;n<o;n++){const c=R.$He(m,r);r+=2,s[i++]=String.fromCharCode(c)}return s.join("")}class v{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return F().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||I.$Bf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let s=0;s<o;s++)this.b[this.d++]=r.charCodeAt(s)}}e.$Et=v}),define(Ie[153],Ce([1,0,21,152]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=void 0,e.$Gt=M;function R(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,F,D,d){this.oldPosition=E,this.oldText=F,this.newPosition=D,this.newText=d}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${R(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${R(this.oldText)}")`:`(replace@${this.oldPosition} "${R(this.oldText)}" with "${R(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,F,D){const d=F.length;I.$Ke(E,d,D),D+=4;for(let v=0;v<d;v++)I.$Ie(E,F.charCodeAt(v),D),D+=2;return D}static d(E,F){const D=I.$Je(E,F);return F+=4,(0,N.$Dt)(E,F,D)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(E,F){return I.$Ke(E,this.oldPosition,F),F+=4,I.$Ke(E,this.newPosition,F),F+=4,F=O.c(E,this.oldText,F),F=O.c(E,this.newText,F),F}static read(E,F,D){const d=I.$Je(E,F);F+=4;const v=I.$Je(E,F);F+=4;const m=O.d(E,F);F+=O.a(m);const r=O.d(E,F);return F+=O.a(r),D.push(new O(d,m,v,r)),F}}e.$Ft=O;function M(p,E){return p===null||p.length===0?E:new b(p,E).compress()}class b{constructor(E,F){this.a=E,this.c=F,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,F=0,D=this.n(E),d=this.l(F);for(;E<this.f||F<this.h;){if(D===null){this.k(d),d=this.l(++F);continue}if(d===null){this.m(D),D=this.n(++E);continue}if(d.oldEnd<=D.newPosition){this.k(d),d=this.l(++F);continue}if(D.newEnd<=d.oldPosition){this.m(D),D=this.n(++E);continue}if(d.oldPosition<D.newPosition){const[s,i]=b.r(d,D.newPosition-d.oldPosition);this.k(s),d=i;continue}if(D.newPosition<d.oldPosition){const[s,i]=b.q(D,d.oldPosition-D.newPosition);this.m(s),D=i;continue}let r,o;if(d.oldEnd===D.newEnd)r=D,o=d,D=this.n(++E),d=this.l(++F);else if(d.oldEnd<D.newEnd){const[s,i]=b.q(D,d.oldLength);r=s,o=d,D=i,d=this.l(++F)}else{const[s,i]=b.r(d,D.newLength);r=D,o=s,D=this.n(++E),d=i}this.d[this.e++]=new O(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const v=b.s(this.d);return b.t(v)}k(E){this.d[this.e++]=b.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=b.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,F){return new O(F.oldPosition-E,F.oldText,F.newPosition,F.newText)}static p(E,F){return new O(F.oldPosition,F.oldText,F.newPosition+E,F.newText)}static q(E,F){const D=E.newText.substr(0,F),d=E.newText.substr(F);return[new O(E.oldPosition,E.oldText,E.newPosition,D),new O(E.oldEnd,"",E.newPosition+F,d)]}static r(E,F){const D=E.oldText.substr(0,F),d=E.oldText.substr(F);return[new O(E.oldPosition,D,E.newPosition,E.newText),new O(E.oldPosition+F,d,E.newEnd,"")]}static s(E){if(E.length===0)return E;const F=[];let D=0,d=E[0];for(let v=1;v<E.length;v++){const m=E[v];d.oldEnd===m.oldPosition?d=new O(d.oldPosition,d.oldText+m.oldText,d.newPosition,d.newText+m.newText):(F[D++]=d,d=m)}return F[D++]=d,F}static t(E){if(E.length===0)return E;const F=[];let D=0;for(let d=0;d<E.length;d++){const v=E[d];v.oldText!==v.newText&&(F[D++]=v)}return F}}}),define(Ie[154],Ce([1,0,36,19]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4t=R,e.$5t=O;function R(M,b,p,E,F,D){if(Array.isArray(M)){let d=0;for(const v of M){const m=R(v,b,p,E,F,D);if(m===10)return m;m>d&&(d=m)}return d}else{if(typeof M=="string")return E?M==="*"?5:M===p?10:0:0;if(M){const{language:d,pattern:v,scheme:m,hasAccessToAllModels:r,notebookType:o}=M;if(!E&&!r)return 0;o&&F&&(b=F);let s=0;if(m)if(m===b.scheme)s=10;else if(m==="*")s=5;else return 0;if(d)if(d===p)s=10;else if(d==="*")s=Math.max(s,5);else return 0;if(o)if(o===D)s=10;else if(o==="*"&&D!==void 0)s=Math.max(s,5);else return 0;if(v){let i;if(typeof v=="string"?i=v:i={...v,base:(0,N.$ic)(v.base)},i===b.fsPath||(0,I.$ok)(i,b.fsPath))s=10;else return 0}return s}else return 0}}function O(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(O):!!M.notebookType}}),define(Ie[155],Ce([1,0,5,13,30,95,93,139,153,6]),function(le,e,I,N,R,O,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TC=void 0;class F extends E.$Vc{constructor(d,v,m,r,o,s,i){super(),this.m=this.B(new I.$ee),this.onDidChangeContent=this.m.event,this.f=v,this.j=!s,this.g=r,this.h=o,this.c=new M.$SC(d,m,i)}equals(d){return!(d instanceof F)||this.f!==d.f||this.getEOL()!==d.getEOL()?!1:this.c.equal(d.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(d){return this.c.createSnapshot(d?this.f:"")}getOffsetAt(d,v){return this.c.getOffsetAt(d,v)}getPositionAt(d){return this.c.getPositionAt(d)}getRangeAt(d,v){const m=d+v,r=this.getPositionAt(d),o=this.getPositionAt(m);return new R.$tt(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(d,v=0){if(d.isEmpty())return"";const m=this.n(v);return this.c.getValueInRange(d,m)}getValueLengthInRange(d,v=0){if(d.isEmpty())return 0;if(d.startLineNumber===d.endLineNumber)return d.endColumn-d.startColumn;const m=this.getOffsetAt(d.startLineNumber,d.startColumn),r=this.getOffsetAt(d.endLineNumber,d.endColumn);let o=0;const s=this.n(v),i=this.getEOL();if(s.length!==i.length){const n=s.length-i.length,c=d.endLineNumber-d.startLineNumber;o=n*c}return r-m+o}getCharacterCountInRange(d,v=0){if(this.j){let m=0;const r=d.startLineNumber,o=d.endLineNumber;for(let s=r;s<=o;s++){const i=this.getLineContent(s),n=s===r?d.startColumn-1:0,c=s===o?d.endColumn-1:i.length;for(let h=n;h<c;h++)N.$Bf(i.charCodeAt(h))?(m=m+1,h=h+1):m=m+1}return m+=this.n(v).length*(o-r),m}return this.getValueLengthInRange(d,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(d){return this.c.getLineContent(d)}getLineCharCode(d,v){return this.c.getLineCharCode(d,v)}getCharCode(d){return this.c.getCharCode(d)}getLineLength(d){return this.c.getLineLength(d)}getLineMinColumn(d){return 1}getLineMaxColumn(d){return this.getLineLength(d)+1}getLineFirstNonWhitespaceColumn(d){const v=N.$mf(this.getLineContent(d));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(d){const v=N.$of(this.getLineContent(d));return v===-1?0:v+2}n(d){switch(d){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(d){this.c.setEOL(d)}applyEdits(d,v,m){let r=this.g,o=this.h,s=this.j,i=!0,n=[];for(let u=0;u<d.length;u++){const S=d[u];i&&S._isTracked&&(i=!1);const l=S.range;if(S.text){let C=!0;s||(C=!N.$Mf(S.text),s=C),!r&&C&&(r=N.$Lf(S.text)),!o&&C&&(o=N.$Of(S.text))}let w="",$=0,k=0,y=0;if(S.text){let C;[$,k,y,C]=(0,b.$Wt)(S.text);const P=this.getEOL();C===0||C===(P===`\r
`?2:1)?w=S.text:w=S.text.replace(/\r\n|\r|\n/g,P)}n[u]={sortIndex:u,identifier:S.identifier||null,range:l,rangeOffset:this.getOffsetAt(l.startLineNumber,l.startColumn),rangeLength:this.getValueLengthInRange(l),text:w,eolCount:$,firstLineLength:k,lastLineLength:y,forceMoveMarkers:!!S.forceMoveMarkers,isAutoWhitespaceEdit:S.isAutoWhitespaceEdit||!1}}n.sort(F.u);let c=!1;for(let u=0,S=n.length-1;u<S;u++){const l=n[u].range.getEndPosition(),w=n[u+1].range.getStartPosition();if(w.isBeforeOrEqual(l)){if(w.isBefore(l))throw new Error("Overlapping ranges are not allowed!");c=!0}}i&&(n=this.s(n));const h=m||v?F._getInverseEditRanges(n):[],t=[];if(v)for(let u=0;u<n.length;u++){const S=n[u],l=h[u];if(S.isAutoWhitespaceEdit&&S.range.isEmpty())for(let w=l.startLineNumber;w<=l.endLineNumber;w++){let $="";w===l.startLineNumber&&($=this.getLineContent(S.range.startLineNumber),N.$mf($)!==-1)||t.push({lineNumber:w,oldContent:$})}}let f=null;if(m){let u=0;f=[];for(let S=0;S<n.length;S++){const l=n[S],w=h[S],$=this.getValueInRange(l.range),k=l.rangeOffset+u;u+=l.text.length-$.length,f[S]={sortIndex:l.sortIndex,identifier:l.identifier,range:w,text:$,textChange:new p.$Ft(l.rangeOffset,$,k,l.text)}}c||f.sort((S,l)=>S.sortIndex-l.sortIndex)}this.g=r,this.h=o,this.j=s;const a=this.t(n);let g=null;if(v&&t.length>0){t.sort((u,S)=>S.lineNumber-u.lineNumber),g=[];for(let u=0,S=t.length;u<S;u++){const l=t[u].lineNumber;if(u>0&&t[u-1].lineNumber===l)continue;const w=t[u].oldContent,$=this.getLineContent(l);$.length===0||$===w||N.$mf($)!==-1||g.push(l)}}return this.m.fire(),new O.$Iv(f,a,g)}s(d){return d.length<1e3?d:[this._toSingleEditOperation(d)]}_toSingleEditOperation(d){let v=!1;const m=d[0].range,r=d[d.length-1].range,o=new R.$tt(m.startLineNumber,m.startColumn,r.endLineNumber,r.endColumn);let s=m.startLineNumber,i=m.startColumn;const n=[];for(let a=0,g=d.length;a<g;a++){const u=d[a],S=u.range;v=v||u.forceMoveMarkers,n.push(this.getValueInRange(new R.$tt(s,i,S.startLineNumber,S.startColumn))),u.text.length>0&&n.push(u.text),s=S.endLineNumber,i=S.endColumn}const c=n.join(""),[h,t,f]=(0,b.$Wt)(c);return{sortIndex:0,identifier:d[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:h,firstLineLength:t,lastLineLength:f,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(d){d.sort(F.w);const v=[];for(let m=0;m<d.length;m++){const r=d[m],o=r.range.startLineNumber,s=r.range.startColumn,i=r.range.endLineNumber,n=r.range.endColumn;if(o===i&&s===n&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const c=new R.$tt(o,s,i,n);v.push({range:c,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return v}findMatchesLineByLine(d,v,m,r){return this.c.findMatchesLineByLine(d,v,m,r)}getPieceTree(){return this.c}static _getInverseEditRange(d,v){const m=d.startLineNumber,r=d.startColumn,[o,s,i]=(0,b.$Wt)(v);let n;if(v.length>0){const c=o+1;c===1?n=new R.$tt(m,r,m,r+s):n=new R.$tt(m,r,m+c-1,i+1)}else n=new R.$tt(m,r,m,r);return n}static _getInverseEditRanges(d){const v=[];let m=0,r=0,o=null;for(let s=0,i=d.length;s<i;s++){const n=d[s];let c,h;o?o.range.endLineNumber===n.range.startLineNumber?(c=m,h=r+(n.range.startColumn-o.range.endColumn)):(c=m+(n.range.startLineNumber-o.range.endLineNumber),h=n.range.startColumn):(c=n.range.startLineNumber,h=n.range.startColumn);let t;if(n.text.length>0){const f=n.eolCount+1;f===1?t=new R.$tt(c,h,c,h+n.firstLineLength):t=new R.$tt(c,h,c+f-1,n.lastLineLength+1)}else t=new R.$tt(c,h,c,h);m=t.endLineNumber,r=t.endColumn,v.push(t),o=n}return v}static u(d,v){const m=R.$tt.compareRangesUsingEnds(d.range,v.range);return m===0?d.sortIndex-v.sortIndex:m}static w(d,v){const m=R.$tt.compareRangesUsingEnds(d.range,v.range);return m===0?v.sortIndex-d.sortIndex:-m}}e.$TC=F}),define(Ie[156],Ce([1,0,13,93,155]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=void 0;class O{constructor(p,E,F,D,d,v,m,r,o){this.a=p,this.b=E,this.c=F,this.d=D,this.e=d,this.f=v,this.g=m,this.h=r,this.j=o}k(p){const E=this.c+this.d+this.e,F=this.c+this.e;return E===0?p===1?`
`:`\r
`:F>E/2?`\r
`:`
`}create(p){const E=this.k(p),F=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let d=0,v=F.length;d<v;d++){const m=F[d].buffer.replace(/\r\n|\r|\n/g,E),r=(0,N.$OC)(m);F[d]=new N.$RC(m,r)}const D=new R.$TC(F,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(p){return this.a[0].buffer.substr(0,p).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(p){if(p.length===0)return;this.a.length===0&&I.$Vf(p)&&(this.b=I.$Uf,p=p.substr(1));const E=p.charCodeAt(p.length-1);E===13||E>=55296&&E<=56319?(this.m(p.substr(0,p.length-1),!1),this.c=!0,this.d=E):(this.m(p,!1),this.c=!1,this.d=E)}m(p,E){!E&&p.length===0||(this.c?this.n(String.fromCharCode(this.d)+p):this.n(p))}n(p){const E=(0,N.$PC)(this.e,p);this.a.push(new N.$RC(p,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=I.$Lf(p)),this.k||(this.k=I.$Of(p)))}finish(p=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,p)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const p=this.a[this.a.length-1];p.buffer+=String.fromCharCode(this.d);const E=(0,N.$OC)(p.buffer);p.lineStarts=E,this.d===13&&this.f++}}}e.$UC=M}),define(Ie[98],Ce([1,0,21,22]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bb=p,e.$8bb=F;var R;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(R||(R={}));function O(D){for(let d=0,v=D.length;d<v;d+=4){const m=D[d+0],r=D[d+1],o=D[d+2],s=D[d+3];D[d+0]=s,D[d+1]=o,D[d+2]=r,D[d+3]=m}}function M(D){const d=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return N.$D()||O(d),I.$Fe.wrap(d)}function b(D){const d=D.buffer;if(N.$D()||O(d),d.byteOffset%4===0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const v=new Uint8Array(d.byteLength);return v.set(d),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function p(D){const d=new Uint32Array(E(D));let v=0;if(d[v++]=D.id,D.type==="full")d[v++]=1,d[v++]=D.data.length,d.set(D.data,v),v+=D.data.length;else{d[v++]=2,d[v++]=D.deltas.length;for(const m of D.deltas)d[v++]=m.start,d[v++]=m.deleteCount,m.data?(d[v++]=m.data.length,d.set(m.data,v),v+=m.data.length):d[v++]=0}return M(d)}function E(D){let d=0;if(d+=2,D.type==="full")d+=1+D.data.length;else{d+=1,d+=3*D.deltas.length;for(const v of D.deltas)v.data&&(d+=v.data.length)}return d}function F(D){const d=b(D);let v=0;const m=d[v++];if(d[v++]===1){const i=d[v++],n=d.subarray(v,v+i);return v+=i,{id:m,type:"full",data:n}}const o=d[v++],s=[];for(let i=0;i<o;i++){const n=d[v++],c=d[v++],h=d[v++];let t;h>0&&(t=d.subarray(v,v+h),v+=h),s[i]={start:n,deleteCount:c,data:t}}return{id:m,type:"delta",deltas:s}}}),define(Ie[157],Ce([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(Ie[158],Ce([1,0,18,25,22,140,159,157]),function(le,e,I,N,R,O,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=i,e.clampedFloat=c,e.stringSet=f,e.cursorStyleToString=y,e.filterValidationDecorations=ue;var p;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(p||(e.EditorAutoIndentStrategy=p={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=E;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class D{constructor(Y,pe,Ge,we){this.id=Y,this.name=pe,this.defaultValue=Ge,this.schema=we}applyUpdate(Y,pe){return v(Y,pe)}compute(Y,pe,Ge){return Ge}}class d{constructor(Y,pe){this.newValue=Y,this.didChange=pe}}e.ApplyUpdateResult=d;function v(Z,Y){if(typeof Z!="object"||typeof Y!="object"||!Z||!Y)return new d(Y,Z!==Y);if(Array.isArray(Z)||Array.isArray(Y)){const Ge=Array.isArray(Z)&&Array.isArray(Y)&&I.$ub(Z,Y);return new d(Y,!Ge)}let pe=!1;for(const Ge in Y)if(Y.hasOwnProperty(Ge)){const we=v(Z[Ge],Y[Ge]);we.didChange&&(Z[Ge]=we.newValue,pe=!0)}return new d(Z,pe)}class m{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,pe){return v(Y,pe)}validate(Y){return this.defaultValue}}class r{constructor(Y,pe,Ge,we){this.id=Y,this.name=pe,this.defaultValue=Ge,this.schema=we}applyUpdate(Y,pe){return v(Y,pe)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,pe,Ge){return Ge}}function o(Z,Y){return typeof Z>"u"?Y:Z==="false"?!1:!!Z}class s extends r{constructor(Y,pe,Ge,we=void 0){typeof we<"u"&&(we.type="boolean",we.default=Ge),super(Y,pe,Ge,we)}validate(Y){return o(Y,this.defaultValue)}}function i(Z,Y,pe,Ge){if(typeof Z>"u")return Y;let we=parseInt(Z,10);return isNaN(we)?Y:(we=Math.max(pe,we),we=Math.min(Ge,we),we|0)}class n extends r{static clampedInt(Y,pe,Ge,we){return i(Y,pe,Ge,we)}constructor(Y,pe,Ge,we,ot,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=Ge,dt.minimum=we,dt.maximum=ot),super(Y,pe,Ge,dt),this.minimum=we,this.maximum=ot}validate(Y){return n.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}function c(Z,Y,pe,Ge){if(typeof Z>"u")return Y;const we=h.float(Z,Y);return h.clamp(we,pe,Ge)}class h extends r{static clamp(Y,pe,Ge){return Y<pe?pe:Y>Ge?Ge:Y}static float(Y,pe){if(typeof Y=="number")return Y;if(typeof Y>"u")return pe;const Ge=parseFloat(Y);return isNaN(Ge)?pe:Ge}constructor(Y,pe,Ge,we,ot){typeof ot<"u"&&(ot.type="number",ot.default=Ge),super(Y,pe,Ge,ot),this.validationFn=we}validate(Y){return this.validationFn(h.float(Y,this.defaultValue))}}class t extends r{static string(Y,pe){return typeof Y!="string"?pe:Y}constructor(Y,pe,Ge,we=void 0){typeof we<"u"&&(we.type="string",we.default=Ge),super(Y,pe,Ge,we)}validate(Y){return t.string(Y,this.defaultValue)}}function f(Z,Y,pe,Ge){return typeof Z!="string"?Y:Ge&&Z in Ge?Ge[Z]:pe.indexOf(Z)===-1?Y:Z}class a extends r{constructor(Y,pe,Ge,we,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=we,ot.default=Ge),super(Y,pe,Ge,ot),this.c=we}validate(Y){return f(Y,this.defaultValue,this.c)}}class g extends D{constructor(Y,pe,Ge,we,ot,dt,Pt=void 0){typeof Pt<"u"&&(Pt.type="string",Pt.enum=ot,Pt.default=we),super(Y,pe,Ge,Pt),this.c=ot,this.d=dt}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function u(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class S extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,pe,Ge){return Ge===0?Y.accessibilitySupport:Ge}}class l extends D{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:b.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{insertSpace:o(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var w;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(w||(e.TextEditorCursorBlinkingStyle=w={}));function $(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var k;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(k||(e.TextEditorCursorStyle=k={}));function y(Z){switch(Z){case k.Line:return"line";case k.Block:return"block";case k.Underline:return"underline";case k.LineThin:return"line-thin";case k.BlockOutline:return"block-outline";case k.UnderlineThin:return"underline-thin"}}function C(Z){switch(Z){case"line":return k.Line;case"block":return k.Block;case"underline":return k.Underline;case"line-thin":return k.LineThin;case"block-outline":return k.BlockOutline;case"underline-thin":return k.UnderlineThin}}class P extends m{constructor(){super(142)}compute(Y,pe,Ge){const we=["monaco-editor"];return pe.get(39)&&we.push(pe.get(39)),Y.extraEditorClassName&&we.push(Y.extraEditorClassName),pe.get(74)==="default"?we.push("mouse-default"):pe.get(74)==="copy"&&we.push("mouse-copy"),pe.get(111)&&we.push("showUnused"),pe.get(140)&&we.push("showDeprecated"),we.join(" ")}}class W extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(Y,pe,Ge){return Ge&&Y.emptySelectionClipboard}}class V extends D{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:b.localize(16,null),included:R.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:b.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{cursorMoveOnType:o(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":f(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":f(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(pe.loop,this.defaultValue.loop)}}}class q extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"||Y.length===0?q.OFF:Y==="true"?q.ON:Y:Y?q.ON:q.OFF}}e.EditorFontLigatures=q;class A extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",A.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?A.OFF:Y==="true"?A.TRANSLATE:Y:Y?A.TRANSLATE:A.OFF}compute(Y,pe,Ge){return Y.fontInfo.fontVariationSettings}}e.EditorFontVariations=A;class U extends m{constructor(){super(50)}compute(Y,pe,Ge){return Y.fontInfo}}class K extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(Y){const pe=h.float(Y,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(pe,6,100)}compute(Y,pe,Ge){return Y.fontInfo.fontSize}}class re extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:re.d,maximum:re.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:re.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(n.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,re.d,re.e))}}class ae extends D{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Ge,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Ge,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Ge,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Ge,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Ge,description:b.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{multiple:f(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??f(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??f(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??f(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??f(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??f(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends D{constructor(){const Y={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Y.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:b.localize(46,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:o(pe.enabled,this.defaultValue.enabled),delay:n.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:o(pe.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(pe.above,this.defaultValue.above)}}}var Pe;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class fe extends m{constructor(){super(145)}compute(Y,pe,Ge){return fe.computeLayout(pe,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Y){const pe=Y.height/Y.lineHeight,Ge=Math.floor(Y.paddingTop/Y.lineHeight);let we=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(we=Math.max(we,pe-1));const ot=(Ge+Y.viewLineCount+we)/(Y.pixelRatio*Y.height),dt=Math.floor(Y.viewLineCount/ot);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:we,desiredRatio:ot,minimapLineCount:dt}}static c(Y,pe){const Ge=Y.outerWidth,we=Y.outerHeight,ot=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*we),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:we};const dt=pe.stableMinimapLayoutInput,Pt=dt&&Y.outerHeight===dt.outerHeight&&Y.lineHeight===dt.lineHeight&&Y.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Y.pixelRatio===dt.pixelRatio&&Y.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Y.paddingTop===dt.paddingTop&&Y.paddingBottom===dt.paddingBottom&&Y.minimap.enabled===dt.minimap.enabled&&Y.minimap.side===dt.minimap.side&&Y.minimap.size===dt.minimap.size&&Y.minimap.showSlider===dt.minimap.showSlider&&Y.minimap.renderCharacters===dt.minimap.renderCharacters&&Y.minimap.maxColumn===dt.minimap.maxColumn&&Y.minimap.scale===dt.minimap.scale&&Y.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Y.isViewportWrapping===dt.isViewportWrapping,Yt=Y.lineHeight,zt=Y.typicalHalfwidthCharacterWidth,ri=Y.scrollBeyondLastLine,Zt=Y.minimap.renderCharacters;let St=ot>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Xt=Y.minimap.maxColumn,xt=Y.minimap.size,Ze=Y.minimap.side,si=Y.verticalScrollbarWidth,Wt=Y.viewLineCount,lt=Y.remainingWidth,bt=Y.isViewportWrapping,ei=Zt?2:3;let Kt=Math.floor(ot*we);const Ot=Kt/ot;let ft=!1,jt=!1,qt=ei*St,Gt=St/ot,Qe=1;if(xt==="fill"||xt==="fit"){const{typicalViewportLineCount:Ft,extraLinesBeforeFirstLine:ti,extraLinesBeyondLastLine:Bt,desiredRatio:ii,minimapLineCount:Mt}=fe.computeContainedMinimapLineCount({viewLineCount:Wt,scrollBeyondLastLine:ri,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:we,lineHeight:Yt,pixelRatio:ot});if(Wt/Mt>1)ft=!0,jt=!0,St=1,qt=1,Gt=St/ot;else{let Nt=!1,It=St+1;if(xt==="fit"){const $t=Math.ceil((ti+Wt+Bt)*qt);bt&&Pt&&lt<=pe.stableFitRemainingWidth?(Nt=!0,It=pe.stableFitMaxMinimapScale):Nt=$t>Kt}if(xt==="fill"||Nt){ft=!0;const $t=St;qt=Math.min(Yt*ot,Math.max(1,Math.floor(1/ii))),bt&&Pt&&lt<=pe.stableFitRemainingWidth&&(It=pe.stableFitMaxMinimapScale),St=Math.min(It,Math.max(1,Math.floor(qt/ei))),St>$t&&(Qe=Math.min(2,St/$t)),Gt=St/ot/Qe,Kt=Math.ceil(Math.max(Ft,ti+Wt+Bt)*qt),bt?(pe.stableMinimapLayoutInput=Y,pe.stableFitRemainingWidth=lt,pe.stableFitMaxMinimapScale=St):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const hi=Math.floor(Xt*Gt),Jt=Math.min(hi,Math.max(0,Math.floor((lt-si-2)*Gt/(zt+Gt)))+e.MINIMAP_GUTTER_WIDTH);let Lt=Math.floor(ot*Jt);const gt=Lt/ot;Lt=Math.floor(Lt*Qe);const Ut=Zt?1:2,Ct=Ze==="left"?0:Ge-Jt-si;return{renderMinimap:Ut,minimapLeft:Ct,minimapWidth:Jt,minimapHeightIsEditorHeight:ft,minimapIsSampling:jt,minimapScale:St,minimapLineHeight:qt,minimapCanvasInnerWidth:Lt,minimapCanvasInnerHeight:Kt,minimapCanvasOuterWidth:gt,minimapCanvasOuterHeight:Ot}}static computeLayout(Y,pe){const Ge=pe.outerWidth|0,we=pe.outerHeight|0,ot=pe.lineHeight|0,dt=pe.lineNumbersDigitCount|0,Pt=pe.typicalHalfwidthCharacterWidth,Yt=pe.maxDigitWidth,zt=pe.pixelRatio,ri=pe.viewLineCount,Zt=Y.get(137),St=Zt==="inherit"?Y.get(136):Zt,Xt=St==="inherit"?Y.get(132):St,xt=Y.get(135),Ze=pe.isDominatedByLongLines,si=Y.get(57),Wt=Y.get(68).renderType!==0,lt=Y.get(69),bt=Y.get(105),ei=Y.get(84),Kt=Y.get(73),Ot=Y.get(103),ft=Ot.verticalScrollbarSize,jt=Ot.verticalHasArrows,qt=Ot.arrowSize,Gt=Ot.horizontalScrollbarSize,Qe=Y.get(43),hi=Y.get(110)!=="never";let Jt=Y.get(66);Qe&&hi&&(Jt+=16);let Lt=0;if(Wt){const ni=Math.max(dt,lt);Lt=Math.round(ni*Yt)}let gt=0;si&&(gt=ot*pe.glyphMarginDecorationLaneCount);let Ut=0,Ct=Ut+gt,Ft=Ct+Lt,ti=Ft+Jt;const Bt=Ge-gt-Lt-Jt;let ii=!1,Mt=!1,At=-1;St==="inherit"&&Ze?(ii=!0,Mt=!0):Xt==="on"||Xt==="bounded"?Mt=!0:Xt==="wordWrapColumn"&&(At=xt);const Nt=fe.c({outerWidth:Ge,outerHeight:we,lineHeight:ot,typicalHalfwidthCharacterWidth:Pt,pixelRatio:zt,scrollBeyondLastLine:bt,paddingTop:ei.top,paddingBottom:ei.bottom,minimap:Kt,verticalScrollbarWidth:ft,viewLineCount:ri,remainingWidth:Bt,isViewportWrapping:Mt},pe.memory||new F);Nt.renderMinimap!==0&&Nt.minimapLeft===0&&(Ut+=Nt.minimapWidth,Ct+=Nt.minimapWidth,Ft+=Nt.minimapWidth,ti+=Nt.minimapWidth);const It=Bt-Nt.minimapWidth,$t=Math.max(1,Math.floor((It-ft-2)/Pt)),Et=jt?qt:0;return Mt&&(At=Math.max(1,$t),Xt==="bounded"&&(At=Math.min(At,xt))),{width:Ge,height:we,glyphMarginLeft:Ut,glyphMarginWidth:gt,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Ct,lineNumbersWidth:Lt,decorationsLeft:Ft,decorationsWidth:Jt,contentLeft:ti,contentWidth:It,minimap:Nt,viewportColumn:$t,isWordWrapMinified:ii,isViewportWrapping:Mt,wrappingColumn:At,verticalScrollbarWidth:ft,horizontalScrollbarHeight:Gt,overviewRuler:{top:Et,width:ft,height:we-2*Et,right:0}}}}e.EditorLayoutInfoComputer=fe;class me extends D{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(Y){return f(Y,"simple",["simple","advanced"])}compute(Y,pe,Ge){return pe.get(2)===2?"advanced":Ge}}var Ae;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(Ae||(e.ShowLightbulbIconMode=Ae={}));class ce extends D{constructor(){const Y={enabled:Ae.On};super(65,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Ae.Off,Ae.OnCode,Ae.On],default:Y.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:f(Y.enabled,this.defaultValue.enabled,[Ae.Off,Ae.OnCode,Ae.On])}}}class Me extends D{constructor(){const Y={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Y.scrollWithEditor,description:b.localize(57,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:o(pe.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ie extends D{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:b.localize(65,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:f(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily),padding:o(pe.padding,this.defaultValue.padding)}}}class z extends D{constructor(){super(66,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):n.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,pe,Ge){return Ge<0?n.clampedInt(-Ge*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class x extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>h.clamp(Y,0,150),{markdownDescription:b.localize(66,null)})}compute(Y,pe,Ge){return Y.fontInfo.lineHeight}}class ve extends D{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:Y.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:b.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Y.showRegionSectionHeaders,description:b.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Y.showMarkSectionHeaders,description:b.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Y.sectionHeaderFontSize,description:b.localize(80,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:o(pe.enabled,this.defaultValue.enabled),autohide:o(pe.autohide,this.defaultValue.autohide),size:f(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(pe.side,this.defaultValue.side,["right","left"]),showSlider:f(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(pe.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(pe.scale,1,1,3),maxColumn:n.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o(pe.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o(pe.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp(pe.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Te(Z){return Z==="ctrlCmd"?R.$j?"metaKey":"ctrlKey":"altKey"}class De extends D{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(82,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{top:n.clampedInt(pe.top,0,0,1e3),bottom:n.clampedInt(pe.bottom,0,0,1e3)}}}class $e extends D{constructor(){const Y={enabled:!0,cycle:!0};super(86,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:b.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:b.localize(84,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:o(pe.enabled,this.defaultValue.enabled),cycle:o(pe.cycle,this.defaultValue.cycle)}}}class ge extends m{constructor(){super(143)}compute(Y,pe,Ge){return Y.pixelRatio}}class Q extends D{constructor(){const Y={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(85,null),b.localize(86,null),b.localize(87,null)]}];super(89,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Y.strings,description:b.localize(88,null)},comments:{anyOf:pe,default:Y.comments,description:b.localize(89,null)},other:{anyOf:pe,default:Y.other,description:b.localize(90,null)}},default:Y,markdownDescription:b.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const zt=Y?"on":"off";return{comments:zt,strings:zt,other:zt}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:pe,comments:Ge,strings:we}=Y,ot=["on","inline","off"];let dt,Pt,Yt;return typeof pe=="boolean"?dt=pe?"on":"off":dt=f(pe,this.defaultValue.other,ot),typeof Ge=="boolean"?Pt=Ge?"on":"off":Pt=f(Ge,this.defaultValue.comments,ot),typeof we=="boolean"?Yt=we?"on":"off":Yt=f(we,this.defaultValue.strings,ot),{other:dt,comments:Pt,strings:Yt}}}var X;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(X||(e.RenderLineNumbersType=X={}));class he extends D{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(92,null),b.localize(93,null),b.localize(94,null),b.localize(95,null)],default:"on",description:b.localize(96,null)})}validate(Y){let pe=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(pe=4,Ge=Y):Y==="interval"?pe=3:Y==="relative"?pe=2:Y==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ge}}}function ue(Z){const Y=Z.get(98);return Y==="editable"?Z.get(91):Y!=="on"}class Fe extends D{constructor(){const Y=[],pe={type:"number",description:b.localize(97,null)};super(102,"rulers",Y,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:b.localize(98,null),format:"color-hex"}}}]},default:Y,description:b.localize(99,null)})}validate(Y){if(Array.isArray(Y)){const pe=[];for(const Ge of Y)if(typeof Ge=="number")pe.push({column:n.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const we=Ge;pe.push({column:n.clampedInt(we.column,0,0,1e4),color:we.color})}return pe.sort((Ge,we)=>Ge.column-we.column),pe}return this.defaultValue}}class de extends D{constructor(){super(92,"readOnlyMessage",void 0)}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:Y}}function Re(Z,Y){if(typeof Z!="string")return Y;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ne extends D{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(100,null),b.localize(101,null),b.localize(102,null)],default:"auto",description:b.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(104,null),b.localize(105,null),b.localize(106,null)],default:"auto",description:b.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:b.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:b.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:b.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Y.ignoreHorizontalScrollbarInContentHeight,description:b.localize(111,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y,Ge=n.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),we=n.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Re(pe.vertical,this.defaultValue.vertical),horizontal:Re(pe.horizontal,this.defaultValue.horizontal),useShadows:o(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:n.clampedInt(pe.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:we,verticalSliderSize:n.clampedInt(pe.verticalSliderSize,we,0,1e3),scrollByPage:o(pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Ue extends D{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:b.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:b.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:b.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:b.localize(118,null)}})}applyUpdate(Y,pe){let Ge=!1;pe.allowedCharacters&&Y&&(N.$6n(Y.allowedCharacters,pe.allowedCharacters)||(Y={...Y,allowedCharacters:pe.allowedCharacters},Ge=!0)),pe.allowedLocales&&Y&&(N.$6n(Y.allowedLocales,pe.allowedLocales)||(Y={...Y,allowedLocales:pe.allowedLocales},Ge=!0));const we=super.applyUpdate(Y,pe);return Ge?new d(we.newValue,!0):we}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{nonBasicASCII:ee(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,pe){if(typeof Y!="object"||!Y)return pe;const Ge={};for(const[we,ot]of Object.entries(Y))ot===!0&&(Ge[we]=!0);return Ge}}class j extends D{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:b.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],description:b.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:b.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Y.fontFamily,description:b.localize(125,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:o(pe.enabled,this.defaultValue.enabled),mode:f(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class T extends D{constructor(){const Y={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Y,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Y.enabled,description:b.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Y.fontFamily,description:b.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Y.backgroundColoring,description:b.localize(132,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:o(pe.enabled,this.defaultValue.enabled),showToolbar:f(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(pe.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(pe.backgroundColoring,this.defaultValue.backgroundColoring)}}}class G extends D{constructor(){const Y={enabled:O.$3s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$3s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:b.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:b.localize(134,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:o(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends D{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:Y.bracketPairs,description:b.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null)],default:Y.bracketPairsHorizontal,description:b.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:b.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:b.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:Y.highlightActiveIndentation,description:b.localize(148,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{bracketPairs:ee(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Z,Y,pe){const Ge=pe.indexOf(Z);return Ge===-1?Y:pe[Ge]}class ne extends D{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(149,null),b.localize(150,null)],default:Y.insertMode,description:b.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:b.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:b.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:b.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(155,null),b.localize(156,null),b.localize(157,null),b.localize(158,null)],default:Y.selectionMode,markdownDescription:b.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:b.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:b.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:b.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:b.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:b.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(196,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{insertMode:f(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(pe.showIcons,this.defaultValue.showIcons),showStatusBar:o(pe.showStatusBar,this.defaultValue.showStatusBar),preview:o(pe.preview,this.defaultValue.preview),previewMode:f(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(pe.showMethods,this.defaultValue.showMethods),showFunctions:o(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:o(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(pe.showFields,this.defaultValue.showFields),showVariables:o(pe.showVariables,this.defaultValue.showVariables),showClasses:o(pe.showClasses,this.defaultValue.showClasses),showStructs:o(pe.showStructs,this.defaultValue.showStructs),showInterfaces:o(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:o(pe.showModules,this.defaultValue.showModules),showProperties:o(pe.showProperties,this.defaultValue.showProperties),showEvents:o(pe.showEvents,this.defaultValue.showEvents),showOperators:o(pe.showOperators,this.defaultValue.showOperators),showUnits:o(pe.showUnits,this.defaultValue.showUnits),showValues:o(pe.showValues,this.defaultValue.showValues),showConstants:o(pe.showConstants,this.defaultValue.showConstants),showEnums:o(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:o(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(pe.showKeywords,this.defaultValue.showKeywords),showWords:o(pe.showWords,this.defaultValue.showWords),showColors:o(pe.showColors,this.defaultValue.showColors),showFiles:o(pe.showFiles,this.defaultValue.showFiles),showReferences:o(pe.showReferences,this.defaultValue.showReferences),showFolders:o(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:o(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(pe.showSnippets,this.defaultValue.showSnippets),showUsers:o(pe.showUsers,this.defaultValue.showUsers),showIssues:o(pe.showIssues,this.defaultValue.showIssues)}}}class Oe extends D{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(198,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(Y.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends D{constructor(){const Y=[];super(130,"wordSegmenterLocales",Y,{anyOf:[{description:b.localize(199,null),type:"string"},{description:b.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Y){if(typeof Y=="string"&&(Y=[Y]),Array.isArray(Y)){const pe=[];for(const Ge of Y)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&pe.push(Ge)}catch{}return pe}return this.defaultValue}}var Ke;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Ke||(e.WrappingIndent=Ke={}));class _e extends D{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(201,null),b.localize(202,null),b.localize(203,null),b.localize(204,null)],description:b.localize(205,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,pe,Ge){return pe.get(2)===2?0:Ge}}class xe extends m{constructor(){super(146)}compute(Y,pe,Ge){const we=pe.get(145);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:we.isWordWrapMinified,isViewportWrapping:we.isViewportWrapping,wrappingColumn:we.wrappingColumn}}}class et extends D{constructor(){const Y={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:b.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(208,null),b.localize(209,null)],default:"afterDrop"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:o(pe.enabled,this.defaultValue.enabled),showDropSelector:f(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends D{constructor(){const Y={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Y,{"editor.pasteAs.enabled":{type:"boolean",default:Y.enabled,markdownDescription:b.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(212,null),b.localize(213,null)],default:"afterPaste"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:o(pe.enabled,this.defaultValue.enabled),showPasteSelector:f(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",mt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.$j?ct:R.$k?mt:nt,fontWeight:"normal",fontSize:R.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var st;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=89]="quickSuggestions",Z[Z.quickSuggestionsDelay=90]="quickSuggestionsDelay",Z[Z.readOnly=91]="readOnly",Z[Z.readOnlyMessage=92]="readOnlyMessage",Z[Z.renameOnType=93]="renameOnType",Z[Z.renderControlCharacters=94]="renderControlCharacters",Z[Z.renderFinalNewline=95]="renderFinalNewline",Z[Z.renderLineHighlight=96]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=98]="renderValidationDecorations",Z[Z.renderWhitespace=99]="renderWhitespace",Z[Z.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Z[Z.roundedSelection=101]="roundedSelection",Z[Z.rulers=102]="rulers",Z[Z.scrollbar=103]="scrollbar",Z[Z.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=105]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=106]="scrollPredominantAxis",Z[Z.selectionClipboard=107]="selectionClipboard",Z[Z.selectionHighlight=108]="selectionHighlight",Z[Z.selectOnLineNumbers=109]="selectOnLineNumbers",Z[Z.showFoldingControls=110]="showFoldingControls",Z[Z.showUnused=111]="showUnused",Z[Z.snippetSuggestions=112]="snippetSuggestions",Z[Z.smartSelect=113]="smartSelect",Z[Z.smoothScrolling=114]="smoothScrolling",Z[Z.stickyScroll=115]="stickyScroll",Z[Z.stickyTabStops=116]="stickyTabStops",Z[Z.stopRenderingLineAfter=117]="stopRenderingLineAfter",Z[Z.suggest=118]="suggest",Z[Z.suggestFontSize=119]="suggestFontSize",Z[Z.suggestLineHeight=120]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Z[Z.suggestSelection=122]="suggestSelection",Z[Z.tabCompletion=123]="tabCompletion",Z[Z.tabIndex=124]="tabIndex",Z[Z.unicodeHighlighting=125]="unicodeHighlighting",Z[Z.unusualLineTerminators=126]="unusualLineTerminators",Z[Z.useShadowDOM=127]="useShadowDOM",Z[Z.useTabStops=128]="useTabStops",Z[Z.wordBreak=129]="wordBreak",Z[Z.wordSegmenterLocales=130]="wordSegmenterLocales",Z[Z.wordSeparators=131]="wordSeparators",Z[Z.wordWrap=132]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=135]="wordWrapColumn",Z[Z.wordWrapOverride1=136]="wordWrapOverride1",Z[Z.wordWrapOverride2=137]="wordWrapOverride2",Z[Z.wrappingIndent=138]="wrappingIndent",Z[Z.wrappingStrategy=139]="wrappingStrategy",Z[Z.showDeprecated=140]="showDeprecated",Z[Z.inlayHints=141]="inlayHints",Z[Z.editorClassName=142]="editorClassName",Z[Z.pixelRatio=143]="pixelRatio",Z[Z.tabFocusMode=144]="tabFocusMode",Z[Z.layoutInfo=145]="layoutInfo",Z[Z.wrappingInfo=146]="wrappingInfo",Z[Z.defaultColorDecorators=147]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(214,null)})),acceptSuggestionOnEnter:je(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(215,null),""],markdownDescription:b.localize(216,null)})),accessibilitySupport:je(new S),accessibilityPageSize:je(new n(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(217,null),tags:["accessibility"]})),ariaLabel:je(new t(4,"ariaLabel",b.localize(218,null))),ariaRequired:je(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:je(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(220,null),b.localize(221,null),""],description:b.localize(222,null)})),autoClosingComments:je(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),autoClosingDelete:je(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(226,null),""],description:b.localize(227,null)})),autoClosingOvertype:je(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(228,null),""],description:b.localize(229,null)})),autoClosingQuotes:je(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(230,null),b.localize(231,null),""],description:b.localize(232,null)})),autoIndent:je(new g(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[b.localize(233,null),b.localize(234,null),b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),automaticLayout:je(new s(13,"automaticLayout",!1)),autoSurround:je(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null),""],description:b.localize(242,null)})),bracketPairColorization:je(new G),bracketPairGuides:je(new H),stickyTabStops:je(new s(116,"stickyTabStops",!1,{description:b.localize(243,null)})),codeLens:je(new s(17,"codeLens",!0,{description:b.localize(244,null)})),codeLensFontFamily:je(new t(18,"codeLensFontFamily","",{description:b.localize(245,null)})),codeLensFontSize:je(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(246,null)})),colorDecorators:je(new s(20,"colorDecorators",!0,{description:b.localize(247,null)})),colorDecoratorActivatedOn:je(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(248,null),b.localize(249,null),b.localize(250,null)],description:b.localize(251,null)})),colorDecoratorsLimit:je(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(252,null)})),columnSelection:je(new s(22,"columnSelection",!1,{description:b.localize(253,null)})),comments:je(new l),contextmenu:je(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new s(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(254,null)})),cursorBlinking:je(new g(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],$,{description:b.localize(255,null)})),cursorSmoothCaretAnimation:je(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(256,null),b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),cursorStyle:je(new g(28,"cursorStyle",k.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:b.localize(260,null)})),cursorSurroundingLines:je(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(261,null)})),cursorSurroundingLinesStyle:je(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(262,null),b.localize(263,null)],markdownDescription:b.localize(264,null)})),cursorWidth:je(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(265,null)})),disableLayerHinting:je(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new s(34,"domReadOnly",!1)),dragAndDrop:je(new s(35,"dragAndDrop",!0,{description:b.localize(266,null)})),emptySelectionClipboard:je(new W),dropIntoEditor:je(new et),stickyScroll:je(new Me),experimentalWhitespaceRendering:je(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(267,null),b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),extraEditorClassName:je(new t(39,"extraEditorClassName","")),fastScrollSensitivity:je(new h(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:b.localize(271,null)})),find:je(new V),fixedOverflowWidgets:je(new s(42,"fixedOverflowWidgets",!1)),folding:je(new s(43,"folding",!0,{description:b.localize(272,null)})),foldingStrategy:je(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(273,null),b.localize(274,null)],description:b.localize(275,null)})),foldingHighlight:je(new s(45,"foldingHighlight",!0,{description:b.localize(276,null)})),foldingImportsByDefault:je(new s(46,"foldingImportsByDefault",!1,{description:b.localize(277,null)})),foldingMaximumRegions:je(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(278,null)})),unfoldOnClickAfterEndOfLine:je(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(279,null)})),fontFamily:je(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(280,null)})),fontInfo:je(new U),fontLigatures2:je(new q),fontSize:je(new K),fontWeight:je(new re),fontVariations:je(new A),formatOnPaste:je(new s(55,"formatOnPaste",!1,{description:b.localize(281,null)})),formatOnType:je(new s(56,"formatOnType",!1,{description:b.localize(282,null)})),glyphMargin:je(new s(57,"glyphMargin",!0,{description:b.localize(283,null)})),gotoLocation:je(new ae),hideCursorInOverviewRuler:je(new s(59,"hideCursorInOverviewRuler",!1,{description:b.localize(284,null)})),hover:je(new ye),inDiffEditor:je(new s(61,"inDiffEditor",!1)),letterSpacing:je(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>h.clamp(Z,-5,20),{description:b.localize(285,null)})),lightbulb:je(new ce),lineDecorationsWidth:je(new z),lineHeight:je(new x),lineNumbers:je(new he),lineNumbersMinChars:je(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new s(70,"linkedEditing",!1,{description:b.localize(286,null)})),links:je(new s(71,"links",!0,{description:b.localize(287,null)})),matchBrackets:je(new a(72,"matchBrackets","always",["always","near","never"],{description:b.localize(288,null)})),minimap:je(new ve),mouseStyle:je(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new h(75,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:b.localize(289,null)})),mouseWheelZoom:je(new s(76,"mouseWheelZoom",!1,{markdownDescription:R.$j?b.localize(290,null):b.localize(291,null)})),multiCursorMergeOverlapping:je(new s(77,"multiCursorMergeOverlapping",!0,{description:b.localize(292,null)})),multiCursorModifier:je(new g(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[b.localize(293,null),b.localize(294,null)],markdownDescription:b.localize(295,null)})),multiCursorPaste:je(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),multiCursorLimit:je(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(299,null)})),occurrencesHighlight:je(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(300,null),b.localize(301,null),b.localize(302,null)],markdownDescription:b.localize(303,null)})),overviewRulerBorder:je(new s(82,"overviewRulerBorder",!0,{description:b.localize(304,null)})),overviewRulerLanes:je(new n(83,"overviewRulerLanes",3,0,3)),padding:je(new De),pasteAs:je(new tt),parameterHints:je(new $e),peekWidgetDefaultFocus:je(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(305,null),b.localize(306,null)],description:b.localize(307,null)})),definitionLinkOpensInPeek:je(new s(88,"definitionLinkOpensInPeek",!1,{description:b.localize(308,null)})),quickSuggestions:je(new Q),quickSuggestionsDelay:je(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(309,null)})),readOnly:je(new s(91,"readOnly",!1)),readOnlyMessage:je(new de),renameOnType:je(new s(93,"renameOnType",!1,{description:b.localize(310,null),markdownDeprecationMessage:b.localize(311,null)})),renderControlCharacters:je(new s(94,"renderControlCharacters",!0,{description:b.localize(312,null),restricted:!0})),renderFinalNewline:je(new a(95,"renderFinalNewline",R.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(313,null)})),renderLineHighlight:je(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(314,null)],description:b.localize(315,null)})),renderLineHighlightOnlyWhenFocus:je(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(316,null)})),renderValidationDecorations:je(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(317,null),b.localize(318,null),b.localize(319,null),""],description:b.localize(320,null)})),revealHorizontalRightPadding:je(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new s(101,"roundedSelection",!0,{description:b.localize(321,null)})),rulers:je(new Fe),scrollbar:je(new Ne),scrollBeyondLastColumn:je(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(322,null)})),scrollBeyondLastLine:je(new s(105,"scrollBeyondLastLine",!0,{description:b.localize(323,null)})),scrollPredominantAxis:je(new s(106,"scrollPredominantAxis",!0,{description:b.localize(324,null)})),selectionClipboard:je(new s(107,"selectionClipboard",!0,{description:b.localize(325,null),included:R.$k})),selectionHighlight:je(new s(108,"selectionHighlight",!0,{description:b.localize(326,null)})),selectOnLineNumbers:je(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:je(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(327,null),b.localize(328,null),b.localize(329,null)],description:b.localize(330,null)})),showUnused:je(new s(111,"showUnused",!0,{description:b.localize(331,null)})),showDeprecated:je(new s(140,"showDeprecated",!0,{description:b.localize(332,null)})),inlayHints:je(new ie),snippetSuggestions:je(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),smartSelect:je(new Oe),smoothScrolling:je(new s(114,"smoothScrolling",!1,{description:b.localize(338,null)})),stopRenderingLineAfter:je(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new ne),inlineSuggest:je(new j),inlineEdit:je(new T),inlineCompletionsAccessibilityVerbose:je(new s(149,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(339,null)})),suggestFontSize:je(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new s(121,"suggestOnTriggerCharacters",!0,{description:b.localize(342,null)})),suggestSelection:je(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),tabCompletion:je(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null)],description:b.localize(350,null)})),tabIndex:je(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new Ue),unusualLineTerminators:je(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(351,null),b.localize(352,null),b.localize(353,null)],description:b.localize(354,null)})),useShadowDOM:je(new s(127,"useShadowDOM",!0)),useTabStops:je(new s(128,"useTabStops",!0,{description:b.localize(355,null)})),wordBreak:je(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(356,null),b.localize(357,null)],description:b.localize(358,null)})),wordSegmenterLocales:je(new Be),wordSeparators:je(new t(131,"wordSeparators",M.$4s,{description:b.localize(359,null)})),wordWrap:je(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(360,null),b.localize(361,null),b.localize(362,null),b.localize(363,null)],description:b.localize(364,null)})),wordWrapBreakAfterCharacters:je(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new n(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(365,null)})),wordWrapOverride1:je(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new P),defaultColorDecorators:je(new s(147,"defaultColorDecorators",!1,{markdownDescription:b.localize(366,null)})),pixelRatio:je(new ge),tabFocusMode:je(new s(144,"tabFocusMode",!1,{markdownDescription:b.localize(367,null)})),layoutInfo:je(new fe),wrappingInfo:je(new xe),wrappingIndent:je(new _e),wrappingStrategy:je(new me)}}),define(Ie[160],Ce([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[161],Ce([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(Ie[162],Ce([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(Ie[163],Ce([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[164],Ce([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[165],Ce([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(Ie[166],Ce([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(Ie[167],Ce([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(Ie[168],Ce([9,10]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(Ie[169],Ce([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(Ie[170],Ce([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ie[171],Ce([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(Ie[172],Ce([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[173],Ce([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[174],Ce([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ie[175],Ce([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ie[176],Ce([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(Ie[177],Ce([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ie[178],Ce([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[179],Ce([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ie[180],Ce([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[181],Ce([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[182],Ce([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ie[183],Ce([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[184],Ce([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(Ie[185],Ce([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(Ie[186],Ce([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(Ie[187],Ce([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ie[188],Ce([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[189],Ce([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[190],Ce([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[191],Ce([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[192],Ce([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[193],Ce([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ie[194],Ce([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[195],Ce([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[196],Ce([1,0,14,162]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.TokenType=void 0;var R;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(R||(e.TokenType=R={}));function O(...E){switch(E.length){case 1:return(0,N.localize)(0,null,E[0]);case 2:return(0,N.localize)(1,null,E[0],E[1]);case 3:return(0,N.localize)(2,null,E[0],E[1],E[2]);default:return}}const M=(0,N.localize)(3,null),b=(0,N.localize)(4,null);class p{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(F){switch(F.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return F.isTripleEq?"===":"==";case 4:return F.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return F.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return F.lexeme;case 18:return F.lexeme;case 19:return F.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(F)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(F=>F.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(F){return this.c=F,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(F){return this.r()||this.c.charCodeAt(this.e)!==F?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(F){this.f.push({type:F,offset:this.d})}l(F){const D=this.d,d=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:d};this.g.push({offset:D,lexeme:d,additionalInfo:F}),this.f.push(v)}n(){this.m.lastIndex=this.d;const F=this.m.exec(this.c);if(F){this.e=this.d+F[0].length;const D=this.c.substring(this.d,this.e),d=p.b.get(D);d?this.k(d):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let F=this.e,D=!1,d=!1;for(;;){if(F>=this.c.length){this.e=F,this.l(b);return}const m=this.c.charCodeAt(F);if(D)D=!1;else if(m===47&&!d){F++;break}else m===91?d=!0:m===92?D=!0:m===93&&(d=!1);F++}for(;F<this.c.length&&p.a.has(this.c.charCodeAt(F));)F++;this.e=F;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$qj=p}),define(Ie[197],Ce([1,0,23,33,164,311]),function(le,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=p,e.$Gp=E,e.$Hp=F,e.$Ip=D,e.$Jp=d,e.$Kp=v,e.$Lp=m;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function p(s){return s=s.trim(),s==="*"||M.test(s)}function E(s){if(!p(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(M);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function F(s){if(!s)return null;const i=s.majorBase,n=s.majorMustEqual,c=s.minorBase;let h=s.minorMustEqual;const t=s.patchBase;let f=s.patchMustEqual;s.hasCaret&&(i===0||(h=!1),f=!1);let a=0;if(s.preRelease){const g=b.exec(s.preRelease);if(g){const[,u,S,l]=g;a=Date.UTC(Number(u),Number(S)-1,Number(l))}}return{majorBase:i,majorMustEqual:n,minorBase:c,minorMustEqual:h,patchBase:t,patchMustEqual:f,isMinimum:s.hasGreaterEquals,notBefore:a}}function D(s,i,n){let c;typeof s=="string"?c=F(E(s)):c=s;let h;i instanceof Date?h=i.getTime():typeof i=="string"&&(h=new Date(i).getTime());let t;if(typeof n=="string"?t=F(E(n)):t=n,!c||!t)return!1;const f=c.majorBase,a=c.minorBase,g=c.patchBase;let u=t.majorBase,S=t.minorBase,l=t.patchBase;const w=t.notBefore;let $=t.majorMustEqual,k=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?f>u?!0:f<u?!1:a>S?!0:a<S||h&&h<w?!1:g>=l:(f===1&&u===0&&(!$||!k||!y)&&(u=1,S=0,l=0,$=!0,k=!1,y=!1),f<u?!1:f>u?!$:a<S?!1:a>S?!k:g<l?!1:g>l?!y:!(h&&h<w))}function d(s,i,n,c,h){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([N.default.Error,R.localize(0,null)]),t;if(typeof c.name!="string")return t.push([N.default.Error,R.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([N.default.Error,R.localize(2,null,"version")]),t;if(!c.engines)return t.push([N.default.Error,R.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([N.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return t.push([N.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return t.push([N.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([N.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([N.default.Warning,R.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([N.default.Error,R.localize(9,null,"main")]),t;{const g=(0,I.$9g)(n,c.main);(0,I.$3g)(g,n)||t.push([N.default.Warning,R.localize(10,null,g.path,n.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([N.default.Error,R.localize(11,null,"browser")]),t;{const g=(0,I.$9g)(n,c.browser);(0,I.$3g)(g,n)||t.push([N.default.Warning,R.localize(12,null,g.path,n.path)])}}if(!O.valid(c.version))return t.push([N.default.Error,R.localize(13,null)]),t;const f=[];if(!v(s,i,c,h,f))for(const g of f)t.push([N.default.Error,g]);return t}function v(s,i,n,c,h){return c||typeof n.main>"u"&&typeof n.browser>"u"?!0:r(s,i,n.engines.vscode,h)}function m(s,i,n){return s==="*"||r(i,n,s)}function r(s,i,n,c=[]){const h=F(E(n));if(!h)return c.push(R.localize(14,null,n)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(R.localize(15,null,n)),!1}else if(!h.majorMustEqual)return c.push(R.localize(16,null,n)),!1;return D(s,i,h)?!0:(c.push(R.localize(17,null,s,n)),!1)}function o(s){if(!Array.isArray(s))return!1;for(let i=0,n=s.length;i<n;i++)if(typeof s[i]!="string")return!1;return!0}}),define(Ie[71],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=void 0;class I{constructor(R,O=[],M=!1){this.ctor=R,this.staticArguments=O,this.supportsDelayedInstantiation=M}}e.$si=I}),define(Ie[56],Ce([1,0,71]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ws=O,e.$xs=M;const N=[];var R;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function O(b,p,E){p instanceof I.$si||(p=new I.$si(p,[],!!E)),N.push([b,p])}function M(){return N}}),define(Ie[198],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=void 0;class I{constructor(O,M){this.key=O,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$_q=I;class N{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const M of this.a.values())M.outgoing.size===0&&O.push(M);return O}insertEdge(O,M){const b=this.lookupOrInsertNode(O),p=this.lookupOrInsertNode(M);b.outgoing.set(p.key,p),p.incoming.set(b.key,b)}removeNode(O){const M=this.b(O);this.a.delete(M);for(const b of this.a.values())b.outgoing.delete(M),b.incoming.delete(M)}lookupOrInsertNode(O){const M=this.b(O);let b=this.a.get(M);return b||(b=new I(M,O),this.a.set(M,b)),b}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[M,b]of this.a)O.push(`${M}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,M]of this.a){const b=new Set([O]),p=this.c(M,b);if(p)return p}}c(O,M){for(const[b,p]of O.outgoing){if(M.has(b))return[...M,b].join(" -> ");M.add(b);const E=this.c(p,M);if(E)return E;M.delete(b)}}}e.$ar=N}),define(Ie[3],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e._util=void 0,e.$vi=R,e.$wi=O;var I;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function b(p){return p[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=b})(I||(e._util=I={})),e.$ui=R("instantiationService");function N(M,b,p){b[I.DI_TARGET]===b?b[I.DI_DEPENDENCIES].push({id:M,index:p}):(b[I.DI_DEPENDENCIES]=[{id:M,index:p}],b[I.DI_TARGET]=b)}function R(M){if(I.serviceIds.has(M))return I.serviceIds.get(M);const b=function(p,E,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(b,p,F)};return b.toString=()=>M,I.serviceIds.set(M,b),b}function O(M){return M}}),define(Ie[50],Ce([1,0,15,2,3]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$2i=void 0,e.$3i=O,e.$4i=M,e.$5i=p,e.$6i=E,e.$7i=F,e.$8i=D,e.$9i=d,e.$0i=m,e.$$i=r,e.$_i=o,e.$2i=(0,R.$vi)("configurationService");function O(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof N.URI)}function M(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof N.URI)}var b;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function p(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function F(s,i){const n=Object.create(null);for(const c in s)D(n,c,s[c],i);return n}function D(s,i,n,c){const h=i.split("."),t=h.pop();let f=s;for(let a=0;a<h.length;a++){const g=h[a];let u=f[g];switch(typeof u){case"undefined":u=f[g]=Object.create(null);break;case"object":if(u===null){c(`Ignoring ${i} as ${h.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${i} as ${h.slice(0,a+1).join(".")} is ${JSON.stringify(u)}`);return}f=u}if(typeof f=="object"&&f!==null)try{f[t]=n}catch{c(`Ignoring ${i} as ${h.join(".")} is ${JSON.stringify(f)}`)}else c(`Ignoring ${i} as ${h.join(".")} is ${JSON.stringify(f)}`)}function d(s,i){const n=i.split(".");v(s,n)}function v(s,i){const n=i.shift();if(i.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const c=s[n];typeof c=="object"&&!Array.isArray(c)&&(v(c,i),Object.keys(c).length===0&&delete s[n])}}function m(s,i,n){function c(f,a){let g=f;for(const u of a){if(typeof g!="object"||g===null)return;g=g[u]}return g}const h=i.split("."),t=c(s,h);return typeof t>"u"?n:t}function r(s,i,n){Object.keys(i).forEach(c=>{c!=="__proto__"&&(c in s?I.$0f(s[c])&&I.$0f(i[c])?r(s[c],i[c],n):n&&(s[c]=i[c]):s[c]=i[c])})}function o(s){return s.replace(/[\[\]]/g,"")}}),define(Ie[31],Ce([1,0,22,13,196,3,161,14]),function(le,e,I,N,R,O,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$tj=e.$sj=e.ContextKeyExprType=void 0,e.$rj=E,e.$uj=f,e.$vj=a,e.$Oj=Ae;const p=new Map;p.set("false",!1),p.set("true",!0),p.set("isMac",I.$j),p.set("isLinux",I.$k),p.set("isWindows",I.$i),p.set("isWeb",I.$o),p.set("isMacNative",I.$j&&!I.$o),p.set("isEdge",I.$H),p.set("isFirefox",I.$F),p.set("isChrome",I.$E),p.set("isSafari",I.$G);function E(ie,z){if(p.get(ie)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");p.set(ie,z)}const F=Object.prototype.hasOwnProperty;var D;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const d={regexParsingWithErrorRecovery:!0},v=(0,M.localize)(0,null),m=(0,M.localize)(1,null),r=(0,M.localize)(2,null),o=(0,M.localize)(3,null),s=(0,M.localize)(4,null),i=(0,M.localize)(5,null),n=(0,M.localize)(6,null),c=(0,M.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=d){this.k=z,this.d=new R.$qj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const ve=this.D(),Te=ve.type===17?i:void 0;throw this.h.push({message:s,offset:ve.offset,lexeme:R.$qj.getLexeme(ve),additionalInfo:Te}),h.c}return x}catch(x){if(x!==h.c)throw x;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const x=this.o();z.push(x)}return z.length===1?z[0]:t.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const x=this.s();z.push(x)}return z.length===1?z[0]:t.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),u.INSTANCE;case 12:return this.z(),S.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,o),x?.negate()}case 17:return this.z(),C.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const x=this.l();return this.A(1,o),x}case 17:{const x=z.lexeme;if(this.z(),this.y(9)){const Te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Te.type!==10)throw this.B("REGEX",Te);const De=Te.lexeme,$e=De.lastIndexOf("/"),ge=$e===De.length-1?void 0:this.w(De.substring($e+1));let Q;try{Q=new RegExp(De.substring(1,$e),ge)}catch{throw this.B("REGEX",Te)}return U.create(x,Q)}switch(Te.type){case 10:case 19:{const De=[Te.lexeme];this.z();let $e=this.D(),ge=0;for(let Fe=0;Fe<Te.lexeme.length;Fe++)Te.lexeme.charCodeAt(Fe)===40?ge++:Te.lexeme.charCodeAt(Fe)===41&&ge--;for(;!this.E()&&$e.type!==15&&$e.type!==16;){switch($e.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Fe=0;Fe<$e.lexeme.length;Fe++)$e.lexeme.charCodeAt(Fe)===40?ge++:Te.lexeme.charCodeAt(Fe)===41&&ge--}if(ge<0)break;De.push(R.$qj.getLexeme($e)),this.z(),$e=this.D()}const Q=De.join(""),X=Q.lastIndexOf("/"),he=X===Q.length-1?void 0:this.w(Q.substring(X+1));let ue;try{ue=new RegExp(Q.substring(1,X),he)}catch{throw this.B("REGEX",Te)}return t.regex(x,ue)}case 18:{const De=Te.lexeme;this.z();let $e=null;if(!(0,N.$7e)(De)){const ge=De.indexOf("/"),Q=De.lastIndexOf("/");if(ge!==Q&&ge>=0){const X=De.slice(ge+1,Q),he=De[Q+1]==="i"?"i":"";try{$e=new RegExp(X,he)}catch{throw this.B("REGEX",Te)}}}if($e===null)throw this.B("REGEX",Te);return U.create(x,$e)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Te=this.u();return t.notIn(x,Te)}switch(this.D().type){case 3:{this.z();const Te=this.u();if(this.x().type===18)return t.equals(x,Te);switch(Te){case"true":return t.has(x);case"false":return t.not(x);default:return t.equals(x,Te)}}case 4:{this.z();const Te=this.u();if(this.x().type===18)return t.notEquals(x,Te);switch(Te){case"true":return t.not(x);case"false":return t.has(x);default:return t.notEquals(x,Te)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),A.create(x,this.u());case 7:return this.z(),W.create(x,this.u());case 8:return this.z(),V.create(x,this.u());case 13:return this.z(),t.in(x,this.u());default:return t.has(x)}}case 20:throw this.h.push({message:n,offset:z.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,x){if(this.C(z))return this.z();throw this.B(x,this.D())}B(z,x,ve){const Te=(0,M.localize)(8,null,z,R.$qj.getLexeme(x)),De=x.offset,$e=R.$qj.getLexeme(x);return this.h.push({message:Te,offset:De,lexeme:$e,additionalInfo:ve}),h.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$sj=h;class t{static false(){return u.INSTANCE}static true(){return S.INSTANCE}static has(z){return l.create(z)}static equals(z,x){return w.create(z,x)}static notEquals(z,x){return y.create(z,x)}static regex(z,x){return U.create(z,x)}static in(z,x){return $.create(z,x)}static notIn(z,x){return k.create(z,x)}static not(z){return C.create(z)}static and(...z){return ae.create(z,null,!0)}static or(...z){return ye.create(z,null,!0)}static greater(z,x){return W.create(z,x)}static greaterEquals(z,x){return V.create(z,x)}static smaller(z,x){return q.create(z,x)}static smallerEquals(z,x){return A.create(z,x)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$tj=t;function f(ie){const z=new h({regexParsingWithErrorRecovery:!1});return ie.map(x=>(z.parse(x),z.lexingErrors.length>0?z.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,M.localize)(9,null,ve.additionalInfo):(0,M.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function a(ie,z){const x=ie?ie.substituteConstants():void 0,ve=z?z.substituteConstants():void 0;return!x&&!ve?!0:!x||!ve?!1:x.equals(ve)}function g(ie,z){return ie.cmp(z)}class u{static{this.INSTANCE=new u}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return S.INSTANCE}}e.$wj=u;class S{static{this.INSTANCE=new S}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return u.INSTANCE}}e.$xj=S;class l{static create(z,x=null){const ve=p.get(z);return typeof ve=="boolean"?ve?S.INSTANCE:u.INSTANCE:new l(z,x)}constructor(z,x){this.key=z,this.c=x,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:fe(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=p.get(this.key);return typeof z=="boolean"?z?S.INSTANCE:u.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$yj=l;class w{static create(z,x,ve=null){if(typeof x=="boolean")return x?l.create(z,ve):C.create(z,ve);const Te=p.get(z);return typeof Te=="boolean"?x===(Te?"true":"false")?S.INSTANCE:u.INSTANCE:new w(z,x,ve)}constructor(z,x,ve){this.c=z,this.d=x,this.f=ve,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=p.get(this.c);if(typeof z=="boolean"){const x=z?"true":"false";return this.d===x?S.INSTANCE:u.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$zj=w;class ${static create(z,x){return new $(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:me(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const x=z.getValue(this.f),ve=z.getValue(this.d);return Array.isArray(x)?x.includes(ve):typeof ve=="string"&&typeof x=="object"&&x!==null?F.call(x,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Aj=$;class k{static create(z,x){return new k(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=11,this.c=$.create(z,x)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Bj=k;class y{static create(z,x,ve=null){if(typeof x=="boolean")return x?C.create(z,ve):l.create(z,ve);const Te=p.get(z);return typeof Te=="boolean"?x===(Te?"true":"false")?u.INSTANCE:S.INSTANCE:new y(z,x,ve)}constructor(z,x,ve){this.c=z,this.d=x,this.f=ve,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=p.get(this.c);if(typeof z=="boolean"){const x=z?"true":"false";return this.d===x?u.INSTANCE:S.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Cj=y;class C{static create(z,x=null){const ve=p.get(z);return typeof ve=="boolean"?ve?u.INSTANCE:S.INSTANCE:new C(z,x)}constructor(z,x){this.c=z,this.d=x,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:fe(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=p.get(this.c);return typeof z=="boolean"?z?u.INSTANCE:S.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Dj=C;function P(ie,z){if(typeof ie=="string"){const x=parseFloat(ie);isNaN(x)||(ie=x)}return typeof ie=="string"||typeof ie=="number"?z(ie):u.INSTANCE}class W{static create(z,x,ve=null){return P(x,Te=>new W(z,Te,ve))}constructor(z,x,ve){this.c=z,this.d=x,this.f=ve,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Ej=W;class V{static create(z,x,ve=null){return P(x,Te=>new V(z,Te,ve))}constructor(z,x,ve){this.c=z,this.d=x,this.f=ve,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Fj=V;class q{static create(z,x,ve=null){return P(x,Te=>new q(z,Te,ve))}constructor(z,x,ve){this.c=z,this.d=x,this.f=ve,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Gj=q;class A{static create(z,x,ve=null){return P(x,Te=>new A(z,Te,ve))}constructor(z,x,ve){this.c=z,this.d=x,this.f=ve,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Hj=A;class U{static create(z,x){return new U(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const x=this.f?this.f.source:"",ve=z.f?z.f.source:"";return x<ve?-1:x>ve?1:0}equals(z){if(z.type===this.type){const x=this.f?this.f.source:"",ve=z.f?z.f.source:"";return this.d===z.d&&x===ve}return!1}substituteConstants(){return this}evaluate(z){const x=z.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Ij=U;class K{static create(z){return new K(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new K(this.c.map(z))}negate(){return this.c}}e.$Jj=K;function re(ie){let z=null;for(let x=0,ve=ie.length;x<ve;x++){const Te=ie[x].substituteConstants();if(ie[x]!==Te&&z===null){z=[];for(let De=0;De<x;De++)z[De]=ie[De]}z!==null&&(z[x]=Te)}return z===null?ie:z}class ae{static create(z,x,ve){return ae.d(z,x,ve)}constructor(z,x){this.expr=z,this.c=x,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Te=g(this.expr[x],z.expr[x]);if(Te!==0)return Te}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(z.expr[x]))return!1;return!0}return!1}substituteConstants(){const z=re(this.expr);return z===this.expr?this:ae.create(z,this.c,!1)}evaluate(z){for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].evaluate(z))return!1;return!0}static d(z,x,ve){const Te=[];let De=!1;for(const $e of z)if($e){if($e.type===1){De=!0;continue}if($e.type===0)return u.INSTANCE;if($e.type===6){Te.push(...$e.expr);continue}Te.push($e)}if(Te.length===0&&De)return S.INSTANCE;if(Te.length!==0){if(Te.length===1)return Te[0];Te.sort(g);for(let $e=1;$e<Te.length;$e++)Te[$e-1].equals(Te[$e])&&(Te.splice($e,1),$e--);if(Te.length===1)return Te[0];for(;Te.length>1;){const $e=Te[Te.length-1];if($e.type!==9)break;Te.pop();const ge=Te.pop(),Q=Te.length===0,X=ye.create($e.expr.map(he=>ae.create([he,ge],null,ve)),null,Q);X&&(Te.push(X),Te.sort(g))}if(Te.length===1)return Te[0];if(ve){for(let $e=0;$e<Te.length;$e++)for(let ge=$e+1;ge<Te.length;ge++)if(Te[$e].negate().equals(Te[ge]))return u.INSTANCE;if(Te.length===1)return Te[0]}return new ae(Te,x)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const x of this.expr)z.push(...x.keys());return z}map(z){return new ae(this.expr.map(x=>x.map(z)),null)}negate(){if(!this.c){const z=[];for(const x of this.expr)z.push(x.negate());this.c=ye.create(z,this,!0)}return this.c}}e.$Kj=ae;class ye{static create(z,x,ve){return ye.d(z,x,ve)}constructor(z,x){this.expr=z,this.c=x,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Te=g(this.expr[x],z.expr[x]);if(Te!==0)return Te}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(z.expr[x]))return!1;return!0}return!1}substituteConstants(){const z=re(this.expr);return z===this.expr?this:ye.create(z,this.c,!1)}evaluate(z){for(let x=0,ve=this.expr.length;x<ve;x++)if(this.expr[x].evaluate(z))return!0;return!1}static d(z,x,ve){let Te=[],De=!1;if(z){for(let $e=0,ge=z.length;$e<ge;$e++){const Q=z[$e];if(Q){if(Q.type===0){De=!0;continue}if(Q.type===1)return S.INSTANCE;if(Q.type===9){Te=Te.concat(Q.expr);continue}Te.push(Q)}}if(Te.length===0&&De)return u.INSTANCE;Te.sort(g)}if(Te.length!==0){if(Te.length===1)return Te[0];for(let $e=1;$e<Te.length;$e++)Te[$e-1].equals(Te[$e])&&(Te.splice($e,1),$e--);if(Te.length===1)return Te[0];if(ve){for(let $e=0;$e<Te.length;$e++)for(let ge=$e+1;ge<Te.length;ge++)if(Te[$e].negate().equals(Te[ge]))return S.INSTANCE;if(Te.length===1)return Te[0]}return new ye(Te,x)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const x of this.expr)z.push(...x.keys());return z}map(z){return new ye(this.expr.map(x=>x.map(z)),null)}negate(){if(!this.c){const z=[];for(const x of this.expr)z.push(x.negate());for(;z.length>1;){const x=z.shift(),ve=z.shift(),Te=[];for(const De of Me(x))for(const $e of Me(ve))Te.push(ae.create([De,$e],null,!1));z.unshift(ye.create(Te,null,!1))}this.c=ye.create(z,this,!0)}return this.c}}e.$Lj=ye;class Pe extends l{static{this.d=[]}static all(){return Pe.d.values()}constructor(z,x,ve){super(z,null),this.f=x,typeof ve=="object"?Pe.d.push({...ve,key:z}):ve!==!0&&Pe.d.push({key:z,description:ve,type:x!=null?typeof x:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return w.create(this.key,z)}notEqualsTo(z){return y.create(this.key,z)}}e.$Mj=Pe,e.$Nj=(0,O.$vi)("contextKeyService");function fe(ie,z){return ie<z?-1:ie>z?1:0}function me(ie,z,x,ve){return ie<x?-1:ie>x?1:z<ve?-1:z>ve?1:0}function Ae(ie,z){if(ie.type===0||z.type===1)return!0;if(ie.type===9)return z.type===9?ce(ie.expr,z.expr):!1;if(z.type===9){for(const x of z.expr)if(Ae(ie,x))return!0;return!1}if(ie.type===6){if(z.type===6)return ce(z.expr,ie.expr);for(const x of ie.expr)if(Ae(x,z))return!0;return!1}return ie.equals(z)}function ce(ie,z){let x=0,ve=0;for(;x<ie.length&&ve<z.length;){const Te=ie[x].cmp(z[ve]);if(Te<0)return!1;Te===0&&x++,ve++}return x===ie.length}function Me(ie){return ie.type===9?ie.expr:[ie]}}),define(Ie[99],Ce([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=void 0,e.$Ci=(0,I.$vi)("environmentService"),e.$Di=(0,I.$wi)(e.$Ci)}),define(Ie[100],Ce([1,0,163,3]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.ExtensionGalleryErrorCode=e.$6o=e.ExtensionManagementErrorCode=e.$5o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=void 0,e.$Yo=R,e.$Zo=O,e.$1o=M,e.$2o=b,e.$3o=p,e.$4o=E,e.$So="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$To=new RegExp(e.$So),e.$Uo="__web_extension",e.$Vo="skipWalkthrough",e.$Wo="extensionsSync",e.$Xo="dependecyOrPackExtensionInstall";function R(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function O(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(i,n){switch(i){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(i,n){return n==="web"&&!i.includes("web")}function p(i,n,c){return b(n,c)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===c}function E(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var F;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(F||(e.SortBy=F={}));var D;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var d;(function(i){i.Install="install",i.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var v;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$5o=(0,N.$vi)("extensionGalleryService");var m;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));class r extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$6o=r;var o;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class s extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$7o=s,e.$8o=(0,N.$vi)("extensionManagementService"),e.$9o="extensionsIdentifiers/disabled",e.$0o="extensionsIdentifiers/enabled",e.$$o=(0,N.$vi)("IGlobalExtensionEnablementService"),e.$_o=(0,N.$vi)("IExtensionTipsService"),e.$ap=(0,I.localize2)(0,"Extensions"),e.$bp=(0,I.localize2)(1,"Preferences")}),define(Ie[37],Ce([1,0,54,19,13,15,2,165,3,22,16,42]),function(le,e,I,N,R,O,M,b,p,E,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$ul=e.FileKind=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.FileOperationResult=e.$ml=e.$ll=e.$kl=e.$il=e.FileChangeType=e.$hl=e.FileOperation=e.$bl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$2k=void 0,e.$3k=d,e.$4k=o,e.$5k=i,e.$6k=n,e.$7k=c,e.$8k=h,e.$9k=t,e.$0k=f,e.$$k=a,e.$_k=g,e.$al=u,e.$cl=w,e.$dl=$,e.$el=k,e.$fl=y,e.$gl=C,e.$jl=A,e.$vl=Pe,e.$wl=fe,e.$yl=Ae,e.$2k=(0,p.$vi)("fileService");function d(ce){return ce.create===!0}var v;(function(ce){ce[ce.Unknown=0]="Unknown",ce[ce.File=1]="File",ce[ce.Directory=2]="Directory",ce[ce.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var m;(function(ce){ce[ce.Readonly=1]="Readonly",ce[ce.Locked=2]="Locked"})(m||(e.FilePermission=m={}));var r;(function(ce){ce[ce.UPDATED=2]="UPDATED",ce[ce.ADDED=4]="ADDED",ce[ce.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function o(ce){const Me=ce;return!!Me&&typeof Me.onDidChange=="function"}var s;(function(ce){ce[ce.None=0]="None",ce[ce.FileReadWrite=2]="FileReadWrite",ce[ce.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ce[ce.FileReadStream=16]="FileReadStream",ce[ce.FileFolderCopy=8]="FileFolderCopy",ce[ce.PathCaseSensitive=1024]="PathCaseSensitive",ce[ce.Readonly=2048]="Readonly",ce[ce.Trash=4096]="Trash",ce[ce.FileWriteUnlock=8192]="FileWriteUnlock",ce[ce.FileAtomicRead=16384]="FileAtomicRead",ce[ce.FileAtomicWrite=32768]="FileAtomicWrite",ce[ce.FileAtomicDelete=65536]="FileAtomicDelete",ce[ce.FileClone=131072]="FileClone"})(s||(e.FileSystemProviderCapabilities=s={}));function i(ce){return!!(ce.capabilities&2)}function n(ce){return!!(ce.capabilities&8)}function c(ce){return!!(ce.capabilities&131072)}function h(ce){return!!(ce.capabilities&4)}function t(ce){return!!(ce.capabilities&16)}function f(ce){return i(ce)?!!(ce.capabilities&16384):!1}function a(ce){return i(ce)?!!(ce.capabilities&32768):!1}function g(ce){return!!(ce.capabilities&65536)}function u(ce){return!!(ce.capabilities&2048)}var S;(function(ce){ce.FileExists="EntryExists",ce.FileNotFound="EntryNotFound",ce.FileNotADirectory="EntryNotADirectory",ce.FileIsADirectory="EntryIsADirectory",ce.FileExceedsStorageQuota="EntryExceedsStorageQuota",ce.FileTooLarge="EntryTooLarge",ce.FileWriteLocked="EntryWriteLocked",ce.NoPermissions="NoPermissions",ce.Unavailable="Unavailable",ce.Unknown="Unknown"})(S||(e.FileSystemProviderErrorCode=S={}));class l extends Error{static create(Me,ie){const z=new l(Me.toString(),ie);return k(z,ie),z}constructor(Me,ie){super(Me),this.code=ie}}e.$bl=l;function w(ce,Me){return l.create(ce,Me)}function $(ce){return ce||w((0,b.localize)(0,null),S.Unknown)}function k(ce,Me){return ce.name=Me?`${Me} (FileSystemError)`:"FileSystemError",ce}function y(ce){if(!ce)return S.Unknown;if(ce instanceof l)return ce.code;const Me=/^(.+) \(FileSystemError\)$/.exec(ce.name);if(!Me)return S.Unknown;switch(Me[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}function C(ce){if(ce instanceof U)return ce.fileOperationResult;switch(y(ce)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 9;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileTooLarge:return 7;default:return 10}}var P;(function(ce){ce[ce.CREATE=0]="CREATE",ce[ce.DELETE=1]="DELETE",ce[ce.MOVE=2]="MOVE",ce[ce.COPY=3]="COPY",ce[ce.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class W{constructor(Me,ie,z){this.resource=Me,this.operation=ie,this.target=z}isOperation(Me){return this.operation===Me}}e.$hl=W;var V;(function(ce){ce[ce.UPDATED=0]="UPDATED",ce[ce.ADDED=1]="ADDED",ce[ce.DELETED=2]="DELETED"})(V||(e.FileChangeType=V={}));class q{static{this.a=null}constructor(Me,ie){this.c=ie,this.b=void 0,this.d=new D.$V(()=>{const z=I.$Bi.forUris(()=>this.c);return z.fill(this.rawAdded.map(x=>[x,!0])),z}),this.f=new D.$V(()=>{const z=I.$Bi.forUris(()=>this.c);return z.fill(this.rawUpdated.map(x=>[x,!0])),z}),this.g=new D.$V(()=>{const z=I.$Bi.forUris(()=>this.c);return z.fill(this.rawDeleted.map(x=>[x,!0])),z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const z of Me){switch(z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}this.b!==q.a&&(typeof z.cId=="number"?this.b===void 0?this.b=z.cId:this.b!==z.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Me,...ie){return this.h(Me,{includeChildren:!1},...ie)}affects(Me,...ie){return this.h(Me,{includeChildren:!0},...ie)}h(Me,ie,...z){if(!Me)return!1;const x=z.length>0;return!!((!x||z.includes(1))&&(this.d.value.get(Me)||ie.includeChildren&&this.d.value.findSuperstr(Me))||(!x||z.includes(0))&&(this.f.value.get(Me)||ie.includeChildren&&this.f.value.findSuperstr(Me))||(!x||z.includes(2))&&(this.g.value.findSubstr(Me)||ie.includeChildren&&this.g.value.findSuperstr(Me)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Me){return this.b===Me}hasCorrelation(){return typeof this.b=="number"}}e.$il=q;function A(ce,Me,ie){return!ce||!Me||ce===Me||Me.length>ce.length?!1:(Me.charAt(Me.length-1)!==N.sep&&(Me+=N.sep),ie?(0,R.$yf)(ce,Me):ce.indexOf(Me)===0)}class U extends Error{constructor(Me,ie,z){super(Me),this.fileOperationResult=ie,this.options=z}}e.$kl=U;class K extends U{constructor(Me,ie,z,x){super(Me,ie,x),this.fileOperationResult=ie,this.size=z}}e.$ll=K;class re extends U{constructor(Me,ie,z){super(Me,2,z),this.stat=ie}}e.$ml=re;var ae;(function(ce){ce[ce.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ce[ce.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ce[ce.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ce[ce.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ce[ce.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ce[ce.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ce[ce.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ce[ce.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ce[ce.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ce[ce.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ce[ce.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$nl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ol={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$pl="files.associations",e.$ql="files.exclude",e.$rl="files.readonlyInclude",e.$sl="files.readonlyExclude",e.$tl="files.readonlyFromPermissions";var ye;(function(ce){ce[ce.FILE=0]="FILE",ce[ce.FOLDER=1]="FOLDER",ce[ce.ROOT_FOLDER=2]="ROOT_FOLDER"})(ye||(e.FileKind=ye={})),e.$ul="";function Pe(ce){if(!(typeof ce.size!="number"||typeof ce.mtime!="number"))return ce.mtime.toString(29)+ce.size.toString(31)}async function fe(ce,Me){if(!Me.hasProvider(M.URI.from({scheme:ce.scheme})))return new Promise(ie=>{const z=Me.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===ce.scheme&&x.added&&(z.dispose(),ie())})})}class me{static{this.KB=1024}static{this.MB=me.KB*me.KB}static{this.GB=me.MB*me.KB}static{this.TB=me.GB*me.KB}static formatSize(Me){return(0,O.$_f)(Me)||(Me=0),Me<me.KB?(0,b.localize)(1,null,Me.toFixed(0)):Me<me.MB?(0,b.localize)(2,null,(Me/me.KB).toFixed(2)):Me<me.GB?(0,b.localize)(3,null,(Me/me.MB).toFixed(2)):Me<me.TB?(0,b.localize)(4,null,(Me/me.GB).toFixed(2)):(0,b.localize)(5,null,(Me/me.TB).toFixed(2))}}e.$xl=me;function Ae(ce){const Me=typeof ce=="string"||ce?.scheme===F.Schemas.vscodeRemote;return typeof ce!="string"&&ce?.scheme===F.Schemas.file?1024*me.MB:Me?10*me.MB:E.$o?50*me.MB:1024*me.MB}}),define(Ie[72],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class I{constructor(...R){this.a=new Map;for(const[O,M]of R)this.set(O,M)}set(R,O){const M=this.a.get(R);return this.a.set(R,O),M}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$ti=I}),define(Ie[199],Ce([1,0,11,14,6,71,198,3,72,200]),function(le,e,I,N,R,O,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=void 0;const F=!1;class D extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class d{constructor(o=new p.$ti,s=!1,i,n=F){this.i=o,this.j=s,this.k=i,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(b.$ui,this),this._globalGraph=n?i?._globalGraph??new M.$ar(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,R.$Qc)(this.h),this.h.clear();for(const o of this.g)(0,R.$Pc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o){this.m();const s=new class extends d{dispose(){this.h.delete(s),super.dispose()}}(o,this.j,this,this.l);return this.h.add(s),s}invokeFunction(o,...s){this.m();const i=m.traceInvocation(this.l,o);let n=!1;try{return o({get:h=>{if(n)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(h,i);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...s)}finally{n=!0,i.stop()}}createInstance(o,...s){this.m();let i,n;return o instanceof O.$si?(i=m.traceCreation(this.l,o.ctor),n=this.o(o.ctor,o.staticArguments.concat(s),i)):(i=m.traceCreation(this.l,o),n=this.o(o,s,i)),i.stop(),n}o(o,s=[],i){const n=b._util.getServiceDependencies(o).sort((t,f)=>t.index-f.index),c=[];for(const t of n){const f=this.s(t.id,i);f||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(f)}const h=n.length>0?n[0].index:s.length;if(s.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${s.length} static arguments`);const t=h-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,h)}return Reflect.construct(o,s.concat(c))}q(o,s){if(this.i.get(o)instanceof O.$si)this.i.set(o,s);else if(this.k)this.k.q(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const s=this.i.get(o);return!s&&this.k?this.k.r(o):s}s(o,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const i=this.r(o);return i instanceof O.$si?this.u(o,i,s.branch(o,!0)):(s.branch(o,!1),i)}u(o,s,i){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,s,i)}finally{this.t.delete(o)}}v(o,s,i){const n=new M.$ar(t=>t.id.toString());let c=0;const h=[{id:o,desc:s,_trace:i}];for(;h.length;){const t=h.pop();if(n.lookupOrInsertNode(t),c++>1e3)throw new D(n);for(const f of b._util.getServiceDependencies(t.desc.ctor)){const a=this.r(f.id);if(a||this.y(`[createInstance] ${o} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),a instanceof O.$si){const g={id:f.id,desc:a,_trace:t._trace.branch(f.id,!0)};n.insertEdge(t,g),h.push(g)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new D(n);break}for(const{data:f}of t){if(this.r(f.id)instanceof O.$si){const g=this.w(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.q(f.id,g)}n.removeNode(f)}}return this.r(o)}w(o,s,i=[],n,c){if(this.i.get(o)instanceof O.$si)return this.x(o,s,i,n,c,this.g);if(this.k)return this.k.w(o,s,i,n,c);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}x(o,s,i=[],n,c,h){if(n){const t=new d(void 0,this.j,this,this.l);t.c=String(o);const f=new Map,a=new I.$Oh(()=>{const g=t.o(s,i,c);for(const[u,S]of f){const l=g[u];if(typeof l=="function")for(const w of S)w.disposable=l.apply(g,w.listener)}return f.clear(),h.add(g),g});return new Proxy(Object.create(null),{get(g,u){if(!a.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let w=f.get(u);return w||(w=new E.$6c,f.set(u,w)),(k,y,C)=>{if(a.isInitialized)return a.value[u](k,y,C);{const P={listener:[k,y,C],disposable:void 0},W=w.push(P);return(0,R.$Tc)(()=>{W(),P.disposable?.dispose()})}}}if(u in g)return g[u];const S=a.value;let l=S[u];return typeof l!="function"||(l=l.bind(S),g[u]=l),l},set(g,u,S){return a.value[u]=S,!0},getPrototypeOf(g){return s.prototype}})}else{const t=this.o(s,i,c);return h.add(t),t}}y(o,s){if(s&&console.warn(o),this.j)throw new Error(o)}}e.$br=d;var v;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(v||(v={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new m(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(o,s){return o?new m(1,s.name):m.c}static{this.f=0}constructor(o,s){this.type=o,this.name=s,this.g=Date.now(),this.h=[]}branch(o,s){const i=new m(3,o.toString());return this.h.push([o,s,i]),i}stop(){const o=Date.now()-this.g;m.f+=o;let s=!1;function i(c,h){const t=[],f=new Array(c+1).join("	");for(const[a,g,u]of h.h)if(g&&u){s=!0,t.push(`${f}CREATES -> ${a}`);const S=i(c+1,u);S&&t.push(S)}else t.push(`${f}uses -> ${a}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(o>2||s)&&m.all.add(n.join(`
`))}}e.$cr=m}),define(Ie[12],Ce([1,0,166,44,5,73,6,28,22,23,15,2,31,3]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$5j=e.LogLevel=e.$3j=e.$2j=void 0,e.$4j=r,e.log=s,e.$dk=l,e.$ek=w,e.$fk=$,e.$gk=k,e.$2j=(0,v.$vi)("logService"),e.$3j=(0,v.$vi)("loggerService");function m(){return new Date().toISOString()}function r(y){return(0,F.$_f)(y)}var o;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$5j=o.Info;function s(y,C,P){switch(C){case o.Trace:y.trace(P);break;case o.Debug:y.debug(P);break;case o.Info:y.info(P);break;case o.Warning:y.warn(P);break;case o.Error:y.error(P);break;case o.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function i(y,C=!1){let P="";for(let W=0;W<y.length;W++){let V=y[W];if(V instanceof Error&&(V=(0,N.$gj)(V,C)),typeof V=="object")try{V=JSON.stringify(V)}catch{}P+=(W>0?" ":"")+V}return P}class n extends M.$Vc{constructor(){super(...arguments),this.b=e.$5j,this.c=this.B(new R.$ee),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==o.Off&&this.b<=C}}e.$7j=n;class c extends n{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...P){this.f(o.Trace)&&this.g(o.Trace,i([C,...P],!0))}debug(C,...P){this.f(o.Debug)&&this.g(o.Debug,i([C,...P]))}info(C,...P){this.f(o.Info)&&this.g(o.Info,i([C,...P]))}warn(C,...P){this.f(o.Warning)&&this.g(o.Warning,i([C,...P]))}error(C,...P){if(this.f(o.Error))if(C instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=C.stack,this.g(o.Error,i(W))}else this.g(o.Error,i([C,...P]))}flush(){}}e.$8j=c;class h extends n{constructor(C=e.$5j){super(),this.setLevel(C),this.g=!p.$i}trace(C,...P){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...P):console.log(`[main ${m()}]`,C,...P))}debug(C,...P){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...P):console.log(`[main ${m()}]`,C,...P))}info(C,...P){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,C,...P):console.log(`[main ${m()}]`,C,...P))}warn(C,...P){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,C,...P):console.warn(`[main ${m()}]`,C,...P))}error(C,...P){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,C,...P):console.error(`[main ${m()}]`,C,...P))}flush(){}}e.$9j=h;class t extends n{constructor(C=e.$5j,P=!0){super(),this.g=P,this.setLevel(C)}trace(C,...P){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...P):console.log(C,...P))}debug(C,...P){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...P):console.log(C,...P))}info(C,...P){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...P):console.log(C,...P))}warn(C,...P){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...P):console.log(C,...P))}error(C,...P){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...P):console.error(C,...P))}flush(){}}e.$0j=t;class f extends n{constructor(C,P=e.$5j){super(),this.g=C,this.setLevel(P)}trace(C,...P){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(C),...P])}debug(C,...P){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(C),...P])}info(C,...P){this.f(o.Info)&&this.g.log(o.Info,[this.h(C),...P])}warn(C,...P){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(C),...P])}error(C,...P){this.f(o.Error)&&this.g.log(o.Error,[this.h(C),...P])}h(C){return typeof C=="string"?C:(0,N.$gj)(C,this.f(o.Trace))}flush(){}}e.$$j=f;class a extends n{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const P of this.g)P.setLevel(C);super.setLevel(C)}trace(C,...P){for(const W of this.g)W.trace(C,...P)}debug(C,...P){for(const W of this.g)W.debug(C,...P)}info(C,...P){for(const W of this.g)W.info(C,...P)}warn(C,...P){for(const W of this.g)W.warn(C,...P)}error(C,...P){for(const W of this.g)W.error(C,...P)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$_j=a;class g extends M.$Vc{constructor(C,P,W){if(super(),this.h=C,this.j=P,this.b=new b.$Bc,this.c=this.B(new R.$ee),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$ee),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$ee),this.onDidChangeVisibility=this.g.event,W)for(const V of W)this.b.set(V.resource,{logger:void 0,info:V})}m(C){return(0,F.$8f)(C)?[...this.b.values()].find(P=>P.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,P){const W=this.n(C),V=(0,F.$8f)(C)?C:P?.id??(0,O.$jj)(W.toString()).toString(16);let q=this.b.get(W)?.logger;const A=P?.logLevel==="always"?o.Trace:P?.logLevel;q||(q=this.s(W,A??this.getLogLevel(W)??this.h,{...P,id:V}));const U={logger:q,info:{resource:W,id:V,logLevel:A,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(U.info),this.b.set(W,U),q}n(C){return(0,F.$8f)(C)?(0,E.$9g)(this.j,`${C}.log`):C}setLogLevel(C,P){if(D.URI.isUri(C)){const W=C,V=P,q=this.b.get(W);q&&V!==q.info.logLevel&&(q.info.logLevel=V===this.h?void 0:V,q.logger?.setLevel(V),this.b.set(q.info.resource,q),this.f.fire([W,V]))}else{this.h=C;for(const[W,V]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,P){const W=this.m(C);W&&P!==!W.info.hidden&&(W.info.hidden=!P,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,P]))}getLogLevel(C){let P;return C&&(P=this.b.get(C)?.info.logLevel),P??this.h}registerLogger(C){const P=this.b.get(C.resource);P?P.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const P=this.b.get(C);P&&(P.logger&&P.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ak=g;class u{constructor(){this.onDidChangeLogLevel=new R.$ee().event}setLevel(C){}getLevel(){return o.Info}trace(C,...P){}debug(C,...P){}info(C,...P){}warn(C,...P){}error(C,...P){}critical(C,...P){}dispose(){}flush(){}}e.$bk=u;class S extends u{}e.$ck=S;function l(y){if(y.verbose)return o.Trace;if(typeof y.logLevel=="string"){const C=k(y.logLevel.toLowerCase());if(C!==void 0)return C}return e.$5j}function w(y){switch(y){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function $(y){switch(y){case o.Trace:return{original:"Trace",value:I.localize(0,null)};case o.Debug:return{original:"Debug",value:I.localize(1,null)};case o.Info:return{original:"Info",value:I.localize(2,null)};case o.Warning:return{original:"Warning",value:I.localize(3,null)};case o.Error:return{original:"Error",value:I.localize(4,null)};case o.Off:return{original:"Off",value:I.localize(5,null)}}}function k(y){switch(y){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$hk=new d.$Mj("logLevel",w(o.Info))}),define(Ie[201],Ce([1,0,6,12]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=void 0;class R extends I.$Vc{constructor(M,b=[]){super(),this.a=new N.$_j([M,...b]),this.B(M.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...b){this.a.trace(M,...b)}debug(M,...b){this.a.debug(M,...b)}info(M,...b){this.a.info(M,...b)}warn(M,...b){this.a.warn(M,...b)}error(M,...b){this.a.error(M,...b)}flush(){this.a.flush()}}e.$MQ=R}),define(Ie[101],Ce([1,0,33,167,3]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var M;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(p){function E(m,r){return r-m}p.compare=E;const F=Object.create(null);F[p.Error]=(0,N.localize)(0,null),F[p.Warning]=(0,N.localize)(1,null),F[p.Info]=(0,N.localize)(2,null);function D(m){return F[m]||""}p.toString=D;function d(m){switch(m){case I.default.Error:return p.Error;case I.default.Warning:return p.Warning;case I.default.Info:return p.Info;case I.default.Ignore:return p.Hint}}p.fromSeverity=d;function v(m){switch(m){case p.Error:return I.default.Error;case p.Warning:return I.default.Warning;case p.Info:return I.default.Info;case p.Hint:return I.default.Ignore}}p.toSeverity=v}(M||(e.MarkerSeverity=M={}));var b;(function(p){const E="";function F(d){return D(d,!0)}p.makeKey=F;function D(d,v){const m=[E];return d.source?m.push(d.source.replace("\xA6","\\\xA6")):m.push(E),d.code?typeof d.code=="string"?m.push(d.code.replace("\xA6","\\\xA6")):m.push(d.code.value.replace("\xA6","\\\xA6")):m.push(E),d.severity!==void 0&&d.severity!==null?m.push(M.toString(d.severity)):m.push(E),d.message&&v?m.push(d.message.replace("\xA6","\\\xA6")):m.push(E),d.startLineNumber!==void 0&&d.startLineNumber!==null?m.push(d.startLineNumber.toString()):m.push(E),d.startColumn!==void 0&&d.startColumn!==null?m.push(d.startColumn.toString()):m.push(E),d.endLineNumber!==void 0&&d.endLineNumber!==null?m.push(d.endLineNumber.toString()):m.push(E),d.endColumn!==void 0&&d.endColumn!==null?m.push(d.endColumn.toString()):m.push(E),m.push(E),m.join("\xA6")}p.makeKeyOptionalMessage=D})(b||(e.IMarkerData=b={})),e.$3t=(0,R.$vi)("markerService")}),define(Ie[202],Ce([1,0,5,33,3]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=e.$5v=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$3v=e.Severity=void 0,e.$4v=b,e.Severity=N.default,e.$3v=(0,R.$vi)("notificationService");var O;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var M;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function b(D){if(D){const d=D;return typeof d.id=="string"&&typeof d.label=="string"}return!1}var p;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class E{constructor(){this.progress=new F,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(d){}updateMessage(d){}updateActions(d){}close(){}}e.$5v=E;class F{infinite(){}done(){}total(d){}worked(d){}}e.$6v=F}),define(Ie[102],Ce([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jk=e.$ik=void 0,e.$ik=(0,I.$vi)("productService"),e.$jk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(le,e,I,N){var R=arguments.length,O=R<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,I):N,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(le,e,I,N);else for(var b=le.length-1;b>=0;b--)(M=le[b])&&(O=(R<3?M(O):R>3?M(e,I,O):M(e,I))||O);return R>3&&O&&Object.defineProperty(e,I,O),O},We=this&&this.__param||function(le,e){return function(I,N){e(I,N,le)}};define(Ie[103],Ce([1,0,11,24,6,3]),function(le,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.$8v=e.ProgressLocation=e.$7v=void 0,e.$7v=(0,O.$vi)("progressService");var M;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$8v=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(d){this.b=d}report(d){this.a=d,this.b(this.a)}}e.$9v=b;class p{get value(){return this.a}constructor(d){this.e=d}report(d){this.b?this.b.push(d):this.b=[d],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const d=this.b.shift();this.a=d,await this.e(this.a)}}finally{this.c=!1;const d=this.d;this.d=void 0,d?.()}}drain(){return this.c?new Promise(d=>{const v=this.d;this.d=()=>{v?.(),d()}}):Promise.resolve()}}e.$0v=p;let E=class extends R.$Vc{constructor(d,v){super(),this.a=new I.$Sh,v.withProgress(d,m=>(this.b=m,this.c&&m.report(this.c),this.a.p)),this.B((0,R.$Tc)(()=>this.a.complete()))}report(d){this.b?this.b.report(d):this.c=d}};e.$$v=E,e.$$v=E=Je([We(1,e.$7v)],E);class F extends R.$Vc{constructor(d){super(),this.g=d,this.a=0,this.b=this.B(new R.$Uc)}start(d){this.stop();const v=++this.a,m=new N.$pe;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},d),this.b.add((0,R.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,R.$Tc)(()=>m.cancel())),this.b.add((0,R.$Tc)(()=>this.c?this.c.done():void 0)),{id:v,token:m.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(d){this.a===d&&this.b.clear()}}e.$_v=F,e.$aw=(0,O.$vi)("editorProgressService")}),define(Ie[29],Ce([1,0,57,15]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=void 0;class R{constructor(){this.a=new Map}add(M,b){I.ok(N.$8f(M)),I.ok(N.$0f(b)),I.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,b)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$bo=new R}),define(Ie[74],Ce([1,0,5,29]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0,e.$co={JSONContribution:"base.contributions.json"};function R(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class O{constructor(){this.b=new I.$ee,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,E){this.a[R(p)]=E,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const M=new O;N.$bo.add(e.$co.JSONContribution,M)}),define(Ie[51],Ce([1,0,18,5,15,160,50,74,29]),function(le,e,I,N,R,O,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.ConfigurationScope=e.$go=e.EditPresentationTypes=void 0,e.$ro=r,e.$so=o,e.$to=s,e.$uo=n,e.$vo=c;var E;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$go={Configuration:"base.contributions.configuration"};var F;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(F||(e.ConfigurationScope=F={})),e.$ho={properties:{},patternProperties:{}},e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no="vscode://schemas/settings/resourceLanguage",e.$oo="vscode://schemas/settings/configurationDefaults";const D=p.$bo.as(b.$co.JSONContribution);class d{constructor(){this.h=new Set,this.i=new N.$ee,this.onDidSchemaChange=this.i.event,this.j=new N.$ee,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$no,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const a=new Set;this.n(t,f,a),D.registerSchema(e.$no,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const f=new Set;this.o(t,f),D.registerSchema(e.$no,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const a=new Set;this.o(f,a),this.n(t,!1,a),D.registerSchema(e.$no,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const a=[];for(const{overrides:g,source:u}of t)for(const S in g)if(f.add(S),e.$qo.test(S)){const l=this.a.get(S),w=l?.valuesSources??new Map;if(u)for(const C of Object.keys(g[S]))w.set(C,u);const $={...l?.value||{},...g[S]};this.a.set(S,{source:u,value:$,valuesSources:w});const k=(0,M.$_i)(S),y={type:"object",default:$,description:O.localize(1,null,k),$ref:e.$no,defaultDefaultValue:$,source:R.$8f(u)?void 0:u,defaultValueSource:u};a.push(...r(S)),this.d[S]=y,this.b.properties[S]=y}else{this.a.set(S,{value:g[S],source:u});const l=this.d[S];l&&(this.w(S,l),this.r(S,l))}this.m(a)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:a,source:g}of t)for(const u in a){const S=this.a.get(u),l=R.$8f(g)?g:g?.id,w=R.$8f(S?.source)?S?.source:S?.source?.id;if(l===w)if(f.add(u),this.a.delete(u),e.$qo.test(u))delete this.d[u],delete this.b.properties[u];else{const $=this.d[u];$&&(this.w(u,$),this.r(u,$))}}this.u()}deltaConfiguration(t){let f=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,a){t.forEach(g=>{this.p(g,f,g.extensionInfo,g.restrictedProperties,void 0,a),this.c.push(g),this.q(g)})}o(t,f){const a=g=>{if(g.properties)for(const u in g.properties){f.add(u);const S=this.d[u];S?.policy?.name&&this.e.delete(S.policy.name),delete this.d[u],this.s(u,g.properties[u])}g.allOf?.forEach(u=>a(u))};for(const g of t){a(g);const u=this.c.indexOf(g);u!==-1&&this.c.splice(u,1)}}p(t,f=!0,a,g,u=3,S){u=R.$eg(t.scope)?u:t.scope;const l=t.properties;if(l)for(const $ in l){const k=l[$];if(f&&n($,k)){delete l[$];continue}if(k.source=a,k.defaultDefaultValue=l[$].default,this.w($,k),e.$qo.test($)?k.scope=void 0:(k.scope=R.$eg(k.scope)?u:k.scope,k.restricted=R.$eg(k.restricted)?!!g?.includes($):k.restricted),l[$].hasOwnProperty("included")&&!l[$].included){this.f[$]=l[$],delete l[$];continue}else this.d[$]=l[$],l[$].policy?.name&&this.e.set(l[$].policy.name,$);!l[$].deprecationMessage&&l[$].markdownDeprecationMessage&&(l[$].deprecationMessage=l[$].markdownDeprecationMessage),S.add($)}const w=t.allOf;if(w)for(const $ of w)this.p($,f,a,g,u,S)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=a=>{const g=a.properties;if(g)for(const S in g)this.r(S,g[S]);a.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$ho.properties[t]=f,f.scope){case 1:e.$io.properties[t]=f;break;case 2:e.$jo.properties[t]=f;break;case 6:e.$ko.properties[t]=f;break;case 3:e.$lo.properties[t]=f;break;case 4:e.$mo.properties[t]=f;break;case 5:e.$mo.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$ho.properties[t],f.scope){case 1:delete e.$io.properties[t];break;case 2:delete e.$jo.properties[t];break;case 6:delete e.$ko.properties[t];break;case 3:delete e.$lo.properties[t];break;case 4:case 5:delete e.$mo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,a={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$no};this.w(f,a),e.$ho.properties[f]=a,e.$io.properties[f]=a,e.$jo.properties[f]=a,e.$ko.properties[f]=a,e.$lo.properties[f]=a,e.$mo.properties[f]=a}}v(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$no};e.$ho.patternProperties[e.$po]=t,e.$io.patternProperties[e.$po]=t,e.$jo.patternProperties[e.$po]=t,e.$ko.patternProperties[e.$po]=t,e.$lo.patternProperties[e.$po]=t,e.$mo.patternProperties[e.$po]=t,this.i.fire()}w(t,f){const a=this.a.get(t);let g=a?.value,u=a?.source;R.$cg(g)&&(g=f.defaultDefaultValue,u=void 0),R.$cg(g)&&(g=s(f.type)),f.default=g,f.defaultValueSource=u}}const v="\\[([^\\]]+)\\]",m=new RegExp(v,"g");e.$po=`^(${v})+$`,e.$qo=new RegExp(e.$po);function r(h){const t=[];if(e.$qo.test(h)){let f=m.exec(h);for(;f?.length;){const a=f[1].trim();a&&t.push(a),f=m.exec(h)}}return(0,I.$Mb)(t)}function o(h){return h.reduce((t,f)=>`${t}[${f}]`,"")}function s(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const i=new d;p.$bo.add(e.$go.Configuration,i);function n(h,t){return h.trim()?e.$qo.test(h)?O.localize(7,null,h):i.getConfigurationProperties()[h]!==void 0?O.localize(8,null,h):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,h,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}function c(){const h=[],t=i.getConfigurationProperties();for(const f of Object.keys(t))h.push([f,t[f].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(Ie[203],Ce([1,0,18,5,126,6,28,25,15,2,50,51,29]),function(le,e,I,N,R,O,M,b,p,E,F,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$zo=e.$yo=e.$xo=e.$wo=void 0,e.$Ao=n;function v(f){return Object.isFrozen(f)?f:b.$3n(f)}class m{static createEmptyModel(a){return new m({},[],[],void 0,a)}constructor(a,g,u,S,l){this.b=a,this.c=g,this.d=u,this.raw=S,this.f=l,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(g=>{if(g instanceof m)return g;const u=new r("",this.f);return u.parseRaw(g),u.configurationModel});this.g=a.reduce((g,u)=>u===g?u:g.merge(u),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,F.$0i)(this.contents,a):this.contents}inspect(a,g){const u=this;return{get value(){return v(u.rawConfiguration.getValue(a))},get override(){return g?v(u.rawConfiguration.getOverrideValue(a,g)):void 0},get merged(){return v(g?u.rawConfiguration.override(g).getValue(a):u.rawConfiguration.getValue(a))},get overrides(){const S=[];for(const{contents:l,identifiers:w,keys:$}of u.rawConfiguration.overrides){const k=new m(l,$,[],void 0,u.f).getValue(a);k!==void 0&&S.push({identifiers:w,value:k})}return S.length?v(S):void 0}}}getOverrideValue(a,g){const u=this.j(g);return u?a?(0,F.$0i)(u,a):u:void 0}getKeysForOverrideIdentifier(a){const g=[];for(const u of this.overrides)u.identifiers.includes(a)&&g.push(...u.keys);return I.$Mb(g)}getAllOverrideIdentifiers(){const a=[];for(const g of this.overrides)a.push(...g.identifiers);return I.$Mb(a)}override(a){let g=this.a.get(a);return g||(g=this.h(a),this.a.set(a,g)),g}merge(...a){const g=b.$2n(this.contents),u=b.$2n(this.overrides),S=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const w of a)if(l.push(...w.raw?.length?w.raw:[w]),!w.isEmpty()){this.i(g,w.contents);for(const $ of w.overrides){const[k]=u.filter(y=>I.$ub(y.identifiers,$.identifiers));k?(this.i(k.contents,$.contents),k.keys.push(...$.keys),k.keys=I.$Mb(k.keys)):u.push(b.$2n($))}for(const $ of w.keys)S.indexOf($)===-1&&S.push($)}return new m(g,S,u,l.every(w=>w instanceof m)?void 0:l,this.f)}h(a){const g=this.j(a);if(!g||typeof g!="object"||!Object.keys(g).length)return this;const u={};for(const S of I.$Mb([...Object.keys(this.contents),...Object.keys(g)])){let l=this.contents[S];const w=g[S];w&&(typeof l=="object"&&typeof w=="object"?(l=b.$2n(l),this.i(l,w)):l=w),u[S]=l}return new m(u,this.keys,this.overrides,void 0,this.f)}i(a,g){for(const u of Object.keys(g)){if(u in a&&p.$0f(a[u])&&p.$0f(g[u])){this.i(a[u],g[u]);continue}a[u]=b.$2n(g[u])}}j(a){let g=null,u=null;const S=l=>{l&&(u?this.i(u,l):u=b.$2n(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===a?g=l.contents:l.identifiers.includes(a)&&S(l.contents);return S(g),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,g){this.k(a,g,!0)}setValue(a,g){this.k(a,g,!1)}removeValue(a){const g=this.keys.indexOf(a);g!==-1&&(this.keys.splice(g,1),(0,F.$9i)(this.contents,a),D.$qo.test(a)&&this.overrides.splice(this.overrides.findIndex(u=>I.$ub(u.identifiers,(0,D.$ro)(a))),1))}k(a,g,u){(0,F.$8i)(this.contents,a,g,S=>this.f.error(S)),u=u||this.keys.indexOf(a)===-1,u&&this.keys.push(a),D.$qo.test(a)&&this.overrides.push({identifiers:(0,D.$ro)(a),keys:Object.keys(this.contents[a]),contents:(0,F.$7i)(this.contents[a],S=>this.f.error(S))})}}e.$wo=m;class r{constructor(a,g){this.f=a,this.g=g,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||m.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,g){if(!p.$eg(a)){const u=this.h(a);this.parseRaw(u,g)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,g){this.a=a;const{contents:u,keys:S,overrides:l,restricted:w,hasExcludedProperties:$}=this.i(a,g);this.b=new m(u,S,l,$?[a]:void 0,this.g),this.c=w||[]}h(a){let g={},u=null,S=[];const l=[],w=[];function $(y){Array.isArray(S)?S.push(y):u!==null&&(S[u]=y)}const k={onObjectBegin:()=>{const y={};$(y),l.push(S),S=y,u=null},onObjectProperty:y=>{u=y},onObjectEnd:()=>{S=l.pop()},onArrayBegin:()=>{const y=[];$(y),l.push(S),S=y,u=null},onArrayEnd:()=>{S=l.pop()},onLiteralValue:$,onError:(y,C,P)=>{w.push({error:y,offset:C,length:P})}};if(a)try{R.$Pn(a,k),g=S[0]||{}}catch(y){this.g.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return g}i(a,g){const u=d.$bo.as(D.$go.Configuration).getConfigurationProperties(),S=this.j(a,u,!0,g);a=S.raw;const l=(0,F.$7i)(a,k=>this.g.error(`Conflict in settings file ${this.f}: ${k}`)),w=Object.keys(a),$=this.l(a,k=>this.g.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:l,keys:w,overrides:$,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(a,g,u,S){let l=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:l};const w={},$=[];for(const k in a)if(D.$qo.test(k)&&u){const y=this.j(a[k],g,!1,S);w[k]=y.raw,l=l||y.hasExcludedProperties,$.push(...y.restricted)}else{const y=g[k],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&$.push(k),!S.exclude?.includes(k)&&(S.include?.includes(k)||(C===void 0||S.scopes===void 0||S.scopes.includes(C))&&!(S.skipRestricted&&y?.restricted))?w[k]=a[k]:l=!0}return{raw:w,restricted:$,hasExcludedProperties:l}}l(a,g){const u=[];for(const S of Object.keys(a))if(D.$qo.test(S)){const l={};for(const w in a[S])l[w]=a[S][w];u.push({identifiers:(0,D.$ro)(S),keys:Object.keys(l),contents:(0,F.$7i)(l,g)})}return u}}e.$xo=r;class o extends O.$Vc{constructor(a,g,u,S,l){super(),this.c=a,this.f=g,this.g=S,this.h=l,this.b=this.B(new N.$ee),this.onDidChange=this.b.event,this.a=new r(this.c.toString(),l),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,w=>w.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,w=>(w.isOperation(0)||w.isOperation(3)||w.isOperation(1)||w.isOperation(4))&&u.isEqual(w.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return m.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$yo=o;class s{constructor(a,g,u,S,l,w,$,k,y,C,P,W,V){this.a=a,this.b=g,this.c=u,this.overrideIdentifiers=S,this.d=l,this.f=w,this.g=$,this.h=k,this.i=y,this.j=C,this.k=P,this.l=W,this.m=V}get value(){return v(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(a,g,u,S,l,w,$,k,y,C){this.j=a,this.l=g,this.m=u,this.n=S,this.p=l,this.q=w,this.r=$,this.s=k,this.t=y,this.u=C,this.h=null,this.i=new M.$Bc,this.v=null}getValue(a,g,u){return this.w(a,g,u).getValue(a)}updateValue(a,g,u={}){let S;u.resource?(S=this.t.get(u.resource),S||(S=m.createEmptyModel(this.u),this.t.set(u.resource,S))):S=this.s,g===void 0?S.removeValue(a):S.setValue(a,g),u.resource||(this.h=null)}inspect(a,g,u){const S=this.w(a,g,u),l=this.A(g.resource,u),w=g.resource?this.t.get(g.resource)||this.s:this.s,$=new Set;for(const k of S.overrides)for(const y of k.identifiers)S.getOverrideValue(a,y)!==void 0&&$.add(y);return new s(a,g,S.getValue(a),$.size?[...$]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.q:void 0,l||void 0,w)}keys(a){const g=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:g?g.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,g){this.r.set(a,g),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,g){const u=[];if(!g){const{added:S,updated:l,removed:w}=h(this.j,a);g=[...S,...l,...w]}for(const S of g)for(const l of(0,D.$ro)(S)){const w=this.j.getKeysForOverrideIdentifier(l),$=a.getKeysForOverrideIdentifier(l),k=[...$.filter(y=>w.indexOf(y)===-1),...w.filter(y=>$.indexOf(y)===-1),...w.filter(y=>!b.$6n(this.j.override(l).getValue(y),a.override(l).getValue(y)))];u.push([l,k])}return this.updateDefaultConfiguration(a),{keys:g,overrides:u}}compareAndUpdatePolicyConfiguration(a){const{added:g,updated:u,removed:S}=h(this.l,a),l=[...g,...u,...S];return l.length&&this.updatePolicyConfiguration(a),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:g,updated:u,removed:S,overrides:l}=h(this.applicationConfiguration,a),w=[...g,...u,...S];return w.length&&this.updateApplicationConfiguration(a),{keys:w,overrides:l}}compareAndUpdateLocalUserConfiguration(a){const{added:g,updated:u,removed:S,overrides:l}=h(this.localUserConfiguration,a),w=[...g,...u,...S];return w.length&&this.updateLocalUserConfiguration(a),{keys:w,overrides:l}}compareAndUpdateRemoteUserConfiguration(a){const{added:g,updated:u,removed:S,overrides:l}=h(this.remoteUserConfiguration,a),w=[...g,...u,...S];return w.length&&this.updateRemoteUserConfiguration(a),{keys:w,overrides:l}}compareAndUpdateWorkspaceConfiguration(a){const{added:g,updated:u,removed:S,overrides:l}=h(this.workspaceConfiguration,a),w=[...g,...u,...S];return w.length&&this.updateWorkspaceConfiguration(a),{keys:w,overrides:l}}compareAndUpdateFolderConfiguration(a,g){const u=this.folderConfigurations.get(a),{added:S,updated:l,removed:w,overrides:$}=h(u,g),k=[...S,...l,...w];return(k.length||!u)&&this.updateFolderConfiguration(a,g),{keys:k,overrides:$}}compareAndDeleteFolderConfiguration(a){const g=this.folderConfigurations.get(a);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:u,updated:S,removed:l,overrides:w}=h(g,void 0);return{keys:[...u,...S,...l],overrides:w}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,g,u){let S=this.x(g,u);return g.overrideIdentifier&&(S=S.override(g.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&(S=S.merge(this.l)),S}x({resource:a},g){let u=this.y();if(g&&a){const S=g.getFolder(a);S&&(u=this.z(S.uri)||u);const l=this.t.get(a);l&&(u=u.merge(l))}return u}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let g=this.i.get(a);if(!g){const u=this.y(),S=this.r.get(a);S?(g=u.merge(S),this.i.set(a,g)):g=u}return g}A(a,g){if(g&&a){const u=g.getFolder(a);if(u)return this.r.get(u.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,g)=>{const{contents:u,overrides:S,keys:l}=this.r.get(g);return a.push([g,{contents:u,overrides:S,keys:l}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(g=>a.add(g)),this.userConfiguration.keys.forEach(g=>a.add(g)),this.q.keys.forEach(g=>a.add(g)),this.r.forEach(g=>g.keys.forEach(u=>a.add(u))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(g=>a.add(g)),this.userConfiguration.getAllOverrideIdentifiers().forEach(g=>a.add(g)),this.q.getAllOverrideIdentifiers().forEach(g=>a.add(g)),this.r.forEach(g=>g.getAllOverrideIdentifiers().forEach(u=>a.add(u))),[...a.values()]}D(a){const g=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(u=>g.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(u=>g.add(u)),this.q.getKeysForOverrideIdentifier(a).forEach(u=>g.add(u)),this.r.forEach(u=>u.getKeysForOverrideIdentifier(a).forEach(S=>g.add(S))),[...g.values()]}static parse(a,g){const u=this.E(a.defaults,g),S=this.E(a.policy,g),l=this.E(a.application,g),w=this.E(a.user,g),$=this.E(a.workspace,g),k=a.folders.reduce((y,C)=>(y.set(E.URI.revive(C[0]),this.E(C[1],g)),y),new M.$Bc);return new i(u,S,l,w,m.createEmptyModel(g),$,k,m.createEmptyModel(g),new M.$Bc,g)}static E(a,g){return new m(a.contents,a.keys,a.overrides,void 0,g)}}e.$zo=i;function n(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const a=new Set,g=new Map;for(const S of f)S.keys.forEach(l=>a.add(l)),S.overrides.forEach(([l,w])=>{const $=(0,M.$yc)(g,l,new Set);w.forEach(k=>$.add(k))});const u=[];return g.forEach((S,l)=>u.push([l,[...S.values()]])),{keys:[...a.values()],overrides:u}}class c{constructor(a,g,u,S,l){this.change=a,this.f=g,this.g=u,this.h=S,this.i=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const w of a.keys)this.affectedKeys.add(w);for(const[,w]of a.overrides)for(const $ of w)this.affectedKeys.add($);this.d=this.a;for(const w of this.affectedKeys)this.d+=w+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,g){const u=this.a+a,S=this.d.indexOf(u);if(S<0)return!1;const l=S+u.length;if(l>=this.d.length)return!1;const w=this.d.charCodeAt(l);if(w!==this.b&&w!==this.c)return!1;if(g){const $=this.previousConfiguration?this.previousConfiguration.getValue(a,g,this.f?.workspace):void 0,k=this.g.getValue(a,g,this.h);return!b.$6n($,k)}return!0}}e.$Bo=c;function h(f,a){const{added:g,removed:u,updated:S}=t(a?.rawConfiguration,f?.rawConfiguration),l=[],w=f?.getAllOverrideIdentifiers()||[],$=a?.getAllOverrideIdentifiers()||[];if(a){const k=$.filter(y=>!w.includes(y));for(const y of k)l.push([y,a.getKeysForOverrideIdentifier(y)])}if(f){const k=w.filter(y=>!$.includes(y));for(const y of k)l.push([y,f.getKeysForOverrideIdentifier(y)])}if(a&&f){for(const k of w)if($.includes(k)){const y=t({contents:f.getOverrideValue(void 0,k)||{},keys:f.getKeysForOverrideIdentifier(k)},{contents:a.getOverrideValue(void 0,k)||{},keys:a.getKeysForOverrideIdentifier(k)});l.push([k,[...y.added,...y.removed,...y.updated]])}}return{added:g,removed:u,updated:S,overrides:l}}function t(f,a){const g=f?a?f.keys.filter(l=>a.keys.indexOf(l)===-1):[...f.keys]:[],u=a?f?a.keys.filter(l=>f.keys.indexOf(l)===-1):[...a.keys]:[],S=[];if(f&&a){for(const l of a.keys)if(f.keys.indexOf(l)!==-1){const w=(0,F.$0i)(a.contents,l),$=(0,F.$0i)(f.contents,l);b.$6n(w,$)||S.push(l)}}return{added:g,removed:u,updated:S}}}),define(Ie[104],Ce([1,0,14,3]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.RemoteAuthorityResolverErrorCode=e.$Il=e.$Hl=e.RemoteConnectionType=e.$Gl=void 0,e.$Kl=E,e.$Gl=(0,N.$vi)("remoteAuthorityResolverService");var R;(function(F){F[F.WebSocket=0]="WebSocket",F[F.Managed=1]="Managed"})(R||(e.RemoteConnectionType=R={}));class O{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$Hl=O;class M{constructor(D,d){this.host=D,this.port=d,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Il=M;var b;(function(F){F.Unknown="Unknown",F.NotAvailable="NotAvailable",F.TemporarilyNotAvailable="TemporarilyNotAvailable",F.NoResolverFound="NoResolverFound",F.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class p extends I.$bb{static isNotAvailable(D){return D instanceof p&&D._code===b.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof p&&D._code===b.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof p&&D._code===b.NoResolverFound}static isInvalidAuthority(D){return D instanceof p&&D._code===b.InvalidAuthority}static isHandled(D){return D instanceof p&&D.isHandled}constructor(D,d=b.Unknown,v){super(D),this._message=D,this._code=d,this._detail=v,this.isHandled=d===b.NotAvailable&&v===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Jl=p;function E(F){const D=F.indexOf("+");return D===-1?F:F.substring(0,D)}}),define(Ie[58],Ce([1,0,16]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=N,e.$Hm=R,e.$Im=O,e.$Jm=M;function N(p){return p.scheme===I.Schemas.vscodeRemote?p.authority:void 0}function R(p){if(!p)return;const E=p.indexOf("+");return E<0?p:p.substr(0,E)}function O(p){const{host:E,port:F}=b(p);if(typeof F>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:F}}function M(p,E){let{host:F,port:D}=b(p);return typeof D>"u"&&(D=E),{host:F,port:D}}function b(p){const E=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const F=p.match(/^(\[[0-9a-z:]+\])$/);if(F)return{host:F[1],port:void 0};const D=p.match(/(.*):(\d+)$/);return D?{host:D[1],port:parseInt(D[2],10)}:{host:p,port:void 0}}}),define(Ie[20],Ce([1,0,13,3,58]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Sm=e.$Rm=e.$Qm=e.TargetPlatform=e.ExtensionType=e.$Pm=e.$Nm=e.$Mm=e.$Lm=e.$Km=void 0,e.$Om=O,e.$Tm=D,e.$Um=d,e.$Vm=v,e.$Wm=m,e.$Km="extensions.user.cache",e.$Lm="extensions.builtin.cache",e.$Mm="undefined_publisher",e.$Nm=["ui","workspace","web"];function O(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$Pm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(M||(e.ExtensionType=M={}));var b;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class p{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const i=typeof o=="string"?o:o.value,n=typeof s=="string"?s:s.value;return I.$xf(i,n)}return o._lower===s._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Qm=p;class E{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const s of o)this.add(s)}add(o){this.c.add(p.toKey(o))}delete(o){return this.c.delete(p.toKey(o))}has(o){return this.c.has(p.toKey(o))}}e.$Rm=E;class F{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(p.toKey(o))}get(o){return this.c.get(p.toKey(o))}has(o){return this.c.has(p.toKey(o))}set(o,s){this.c.set(p.toKey(o),s)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Sm=F;function D(r){return d(r)}function d(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function v(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function m(r,o){if(o){const s=`onResolveRemoteAuthority:${(0,R.$Hm)(o)}`;return!!r.activationEvents?.includes(s)}return!1}e.$Xm=(0,N.$vi)("IBuiltinExtensionsScannerService")}),define(Ie[105],Ce([1,0,14,20]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lG=e.$kG=void 0;class R{constructor(){this.a=new Map,this.b=new WeakMap}register(M,b){this.a.set(M,b)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const b=Object.create(null);for(const p of M){const E=this.readActivationEvents(p);E.length>0&&(b[N.$Qm.toKey(p.identifier)]=E)}return b}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const b=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let p=0;p<b.length;p++)b[p]==="onUri"&&(b[p]=`onUri:${N.$Qm.toKey(M.identifier)}`);if(!M.contributes)return b;for(const p in M.contributes){const E=this.a.get(p);if(!E)continue;const F=M.contributes[p],D=Array.isArray(F)?F:[F];try{E(D,b)}catch(d){(0,I.$1)(d)}}return b}}e.$kG=R,e.$lG=new R}),define(Ie[204],Ce([1,0,21,14,6,168,51,3,12,29]),function(le,e,I,N,R,O,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=e.$Mp=void 0,e.$Op=d,e.$Pp=v,e.$Qp=m,e.$Rp=r,e.$Sp=o,e.$Tp=s,e.$Mp=(0,b.$vi)("requestService");class F{constructor(h){this.b=h}toJSON(){if(!this.a){const h=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?h[t]="*****":h[t]=this.b[t];this.a=h}return this.a}}class D extends R.$Vc{constructor(h){super(),this.b=0,this.a=h.createLogger("network",{name:(0,O.localize)(0,null),when:p.$hk.isEqualTo((0,p.$ek)(p.LogLevel.Trace)).serialize()})}async c(h,t,f){const a=`${h} #${++this.b}: ${t.url}`;this.a.trace(`${a} - begin`,t.type,new F(t.headers??{}));try{const g=await f();return this.a.trace(`${a} - end`,t.type,g.res.statusCode,g.res.headers),g}catch(g){throw this.a.error(`${a} - error`,t.type,(0,N.$0)(g)),g}}}e.$Np=D;function d(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function v(c){return c.res.statusCode===204}async function m(c){return v(c)?null:(await(0,I.$Re)(c.stream)).toString()}async function r(c){if(!d(c))throw new Error("Server returned "+c.res.statusCode);return m(c)}async function o(c){if(!d(c))throw new Error("Server returned "+c.res.statusCode);if(v(c))return null;const t=(await(0,I.$Re)(c.stream)).toString();try{return JSON.parse(t)}catch(f){throw f.message+=`:
`+t,f}}function s(c){n(c)}let i;function n(c){const h=E.$bo.as(M.$go.Configuration),t=i;i={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},h.updateConfigurations({add:[i],remove:t?[t]:[]})}n(1)}),define(Ie[205],Ce([1,0,22,75,34]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=M,e.$dp=b;function O(p){if(I.$u===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}function M(p,E,F,D,d,v,m,r,o){const s=Object.create(null);s["common.machineId"]=v,s["common.sqmId"]=m,s.sessionID=(0,R.$Rg)()+Date.now(),s.commitHash=D,s.version=d,s["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,I.$h)(I.$u),s["common.nodePlatform"]=N.$ec,s["common.nodeArch"]=F,s["common.product"]=o||"desktop",r&&(s["common.msftInternal"]=r);let i=0;const n=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),I.$l&&(s["common.snap"]="true");const c=O(E);return c&&(s["common.platformDetail"]=c),s}function b(p){const E=N.env.USERDNSDOMAIN;if(!E)return!1;const F=E.toLowerCase();return p.some(D=>F===D)}}),define(Ie[206],Ce([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=void 0,e.$1l=(0,I.$vi)("telemetryService"),e.$2l=(0,I.$vi)("customEndpointTelemetryService"),e.$3l="telemetry.currentSessionDate",e.$4l="telemetry.firstSessionDate",e.$5l="telemetry.lastSessionDate",e.$6l="telemetry.machineId",e.$7l="telemetry.sqmId",e.$8l="telemetry",e.$9l="telemetry.telemetryLevel",e.$0l="telemetry.enableCrashReporter",e.$$l="telemetry.enableTelemetry";var N;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var R;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(Ie[59],Ce([1,0,25,15,58,205,206]),function(le,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=void 0,e.$lp=F,e.$mp=D,e.$np=d,e.$op=v,e.$pp=r,e.$qp=s,e.$rp=i,e.$sp=h;class b{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$ep=b;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$fp=p,e.$gp=new p;class E{async publicLog(f,a,g){}async publicLogError(f,a,g){}}e.$hp=E,e.$ip="telemetry",e.$jp="extensionTelemetryLog",e.$kp={log:()=>null,flush:()=>Promise.resolve(null)};function F(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}function D(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function d(t){const f=t.getValue(M.$9l),a=t.getValue(M.$0l);if(t.getValue(M.$$l)===!1||a===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function v(t){const f={},a={},g={};o(t,g);for(let u in g){u=u.length>150?u.substr(u.length-149):u;const S=g[u];typeof S=="number"?a[u]=S:typeof S=="boolean"?a[u]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${S.length}`),f[u]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(f[u]=S)}return{properties:f,measurements:a}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const f=(0,R.$Hm)(t);return m.has(f)?f:"other"}function o(t,f,a=0,g){if(t)for(const u of Object.getOwnPropertyNames(t)){const S=t[u],l=g?g+u:u;Array.isArray(S)?f[l]=(0,I.$7n)(S):S instanceof Date?f[l]=S.toISOString():(0,N.$0f)(S)?a<2?o(S,f,a+1,l+"."):f[l]=(0,I.$7n)(S):f[l]=S}}function s(t,f){const a=t.msftInternalDomains||[],g=f.getValue("telemetry.internalTesting");return(0,O.$dp)(a)||g}function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const g=[];for(const w of f)for(;;){const $=w.exec(t);if(!$)break;g.push([$.index,w.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(a="";;){const w=S.exec(t);if(!w)break;const $=g.some(([k,y])=>w.index<y&&k<S.lastIndex);!u.test(w[0])&&!$&&(a+=t.substring(l,w.index)+"<REDACTED: user-file-path>",l=S.lastIndex)}return l<t.length&&(a+=t.substr(l)),a}function c(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of f)if(a.regex.test(t))return`<REDACTED: ${a.label}>`;return t}function h(t,f){return(0,I.$4n)(t,a=>{if(a instanceof b||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let g=a.replaceAll("%20"," ");g=n(g,f);for(const u of f)g=g.replace(u,"");return g=c(g),g}})}}),define(Ie[207],Ce([1,0,13,100,20,22,2,14,75,59]),function(le,e,I,N,R,O,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$up=void 0,e.$tp=F,e.$vp=m,e.$wp=r,e.$xp=o,e.$yp=s,e.$zp=i,e.$Ap=n,e.$Bp=c,e.$Dp=h,e.$Ep=f;function F(a,g){return a.uuid&&g.uuid?a.uuid===g.uuid:a.id===g.id?!0:(0,I.$sf)(a.id,g.id)===0}const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(g){const u=g.manifest?g.manifest.version:g.version,S=g.manifest?g.targetPlatform:g.properties.targetPlatform;return new d(g.identifier,u,S)}static parse(g){const u=D.exec(g);return u&&u[1]&&u[2]?new d({id:u[1]},u[2],u[4]||void 0):null}constructor(g,u,S="undefined"){this.version=u,this.targetPlatform=S,this.id=g.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(g){return g instanceof d?F(this,g)&&this.version===g.version&&this.targetPlatform===g.targetPlatform:!1}}e.$up=d;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(a){const g=v.exec(a);return g&&g[1]?[o(g[1]),g[2]]:[o(a),void 0]}function r(a,g){return`${a}.${g}`}function o(a){return a.toLowerCase()}function s(a,g){return o(r(a??R.$Mm,g))}function i(a,g){const u=[],S=l=>{for(const w of u)if(w.some($=>F(g($),g(l))))return w;return null};for(const l of a){const w=S(l);w?w.push(l):u.push([l])}return u}function n(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new E.$ep(a.identifier.id),name:new E.$ep(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Cp=new R.$Qm("pprice.better-merge");function h(a,g){const u=[],S=g.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const l=S.shift();if(l&&u.every(w=>!F(w.identifier,{id:l}))){const w=a.filter($=>F($.identifier,{id:l}));w.length===1&&(u.push(w[0]),S.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}async function t(a,g){if(!O.$k)return!1;let u;try{u=(await a.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await a.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){g.debug("Error while getting the os-release file.",(0,b.$0)(l))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(a,g){const u=await t(a,g),S=(0,N.$1o)(u?"alpine":O.$u,p.$fc);return g.debug("ComputeTargetPlatform:",S),S}}),define(Ie[208],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=I,e.$ls=N,e.$ms=R,e.$ns=O,e.$os=M,e.$ps=b;function I(p){return[...p.entries()]}function N(p){return p?[...p.entries()]:[]}function R(p){return new Map(p)}function O(p){return new Map(p??[])}function M(p){return Array.from(p.entries()).map(E=>[E[0],I(E[1].map),N(E[1].descriptionMap)])}function b(p){return new Map(p.map(E=>[E[0],{map:R(E[1]),descriptionMap:O(E[2])}]))}}),define(Ie[209],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vtb=void 0;class I{constructor(R){this.b=R,this.a=new Map}dispose(){for(const R of this.a.values())R.dispose()}startBuffering(R,O,M=5){const b=O(p=>{const E=typeof p=="string"?p:p.data;let F=this.a.get(R);if(F){F.data.push(E);return}const D=setTimeout(()=>this.flushBuffer(R),M);F={data:[E],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(R),b.dispose()}},this.a.set(R,F)});return b}stopBuffering(R){this.a.get(R)?.dispose()}flushBuffer(R){const O=this.a.get(R);O&&(this.a.delete(R),this.b(R,O.data.join("")))}}e.$Vtb=I}),define(Ie[210],Ce([1,0,11,92,312,43,5,15,2,169,74,29]),function(le,e,I,N,R,O,M,b,p,E,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fx=e.$ex=e.$dx=e.$cx=e.$bx=e.$ax=e.IconFontDefinition=e.IconContribution=e.$0w=void 0,e.$$w=o,e.$_w=s,e.$0w={IconContribution:"base.contributions.icons"};var d;(function(h){function t(f,a){let g=f.defaults;for(;O.ThemeIcon.isThemeIcon(g);){const u=r.getIcon(g.id);if(!u)return;g=u.defaults}return g}h.getDefinition=t})(d||(e.IconContribution=d={}));var v;(function(h){function t(a){return{weight:a.weight,style:a.style,src:a.src.map(g=>({format:g.format,location:g.location.toString()}))}}h.toJSONObject=t;function f(a){const g=u=>(0,b.$8f)(u)?u:void 0;if(a&&Array.isArray(a.src)&&a.src.every(u=>(0,b.$8f)(u.format)&&(0,b.$8f)(u.location)))return{weight:g(a.weight),style:g(a.style),src:a.src.map(u=>({format:u.format,location:p.URI.parse(u.location)}))}}h.fromJSONObject=f})(v||(e.IconFontDefinition=v={}));class m{constructor(){this.a=new M.$ee,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,f,a,g){const u=this.b[t];if(u){if(a&&!u.description){u.description=a,this.d.properties[t].markdownDescription=`${a} $(${t})`;const w=this.e.enum.indexOf(t);w!==-1&&(this.e.enumDescriptions[w]=a),this.a.fire()}return u}const S={id:t,description:a,defaults:f,deprecationMessage:g};this.b[t]=S;const l={$ref:"#/definitions/icons"};return g&&(l.deprecationMessage=g),a&&(l.markdownDescription=`${a}: $(${t})`),this.d.properties[t]=l,this.e.enum.push(t),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const f=this.e.enum.indexOf(t);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,f){const a=this.f[t];return a||(this.f[t]=f,this.a.fire(),f)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(u,S)=>u.id.localeCompare(S.id),f=u=>{for(;O.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const g=Object.keys(this.b).map(u=>this.b[u]);for(const u of g.filter(S=>!!S.description).sort(t))a.push(`|<i class="${f(u)}"></i>|${u.id}|${O.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const u of g.filter(S=>!O.ThemeIcon.isThemeIcon(S.defaults)).sort(t))a.push(`|<i class="${f(u)}"></i>|${u.id}|`);return a.join(`
`)}}const r=new m;D.$bo.add(e.$0w.IconContribution,r);function o(h,t,f,a){return r.registerIcon(h,t,f,a)}function s(){return r}function i(){const h=(0,R.$Qj)();for(const t in h){const f="\\"+h[t].toString(16);r.registerIcon(t,{fontCharacter:f})}}i(),e.$ax="vscode://schemas/icons";const n=D.$bo.as(F.$co.JSONContribution);n.registerSchema(e.$ax,r.getIconSchema());const c=new I.$Hh(()=>n.notifySchemaChanged(e.$ax),200);r.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$bx=o("widget-close",N.$Uj.close,(0,E.localize)(2,null)),e.$cx=o("goto-previous-location",N.$Uj.arrowUp,(0,E.localize)(3,null)),e.$dx=o("goto-next-location",N.$Uj.arrowDown,(0,E.localize)(4,null)),e.$ex=O.ThemeIcon.modify(N.$Uj.sync,"spin"),e.$fx=O.ThemeIcon.modify(N.$Uj.loading,"spin")}),define(Ie[211],Ce([1,0,5,2,50,3,12]),function(le,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=e.$iw=e.$gw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$cw=e.$bw=void 0,e.$dw=E,e.$ew=D,e.$fw=d,e.$hw=v,e.$jw=m,e.$kw=r,e.$bw=(0,O.$vi)("tunnelService"),e.$cw=(0,O.$vi)("sharedTunnelsService");var b;(function(i){i.Http="http",i.Https="https"})(b||(e.TunnelProtocol=b={}));var p;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})(p||(e.TunnelPrivacyId=p={}));function E(i){return!!i.forwardPort}var F;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(F||(e.ProvidedOnAutoForward=F={}));function D(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(n)return{address:n[1],port:+n[2]}}function d(i){if(i.scheme!=="http"&&i.scheme!=="https"||!i.query)return;const n=i.query.split("&");for(const c of n){const h=c.split("=")[1];if(/^https?:/.exec(h)){const t=D(N.URI.parse(h));if(t)return t}}}e.$gw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(i){return e.$gw.indexOf(i)>=0}e.$iw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(i){return e.$iw.indexOf(i)>=0}function r(i,n,c,h){if(c===1)return!1;if(c===2&&m(n)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(t?.length===4&&parseInt(t[1])>=18)return!1}return i<1024}class o{constructor(n,c,h){this.remoteAddress=n,this.localAddress=c,this.b=h,this.a=new I.$ee,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$lw=o;let s=class{constructor(n,c){this.k=n,this.l=c,this.a=new I.$ee,this.onTunnelOpened=this.a.event,this.b=new I.$ee,this.onTunnelClosed=this.b.event,this.c=new I.$ee,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const n=this.l.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.i=n.privacyOptions,this.h=n.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const n=[],c=Array.from(this.e.values());for(const h of c){const t=Array.from(h.values());for(const f of t){const a=await f.value;a&&typeof a!="string"&&n.push(a)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:c}of n.values())await c.then(h=>typeof h!="string"?h?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,c,h,t,f){this.q(n,c,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:c,localAddress:h,privacy:t,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,c){(m(n)||v(n))&&(n=e.$gw[0]);const h=this.s(n,c);if(h)return++h.refcount,h.value}openTunnel(n,c,h,t,f,a=!1,g,u){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${h} on local port ${f}.`);const S=this.f??n;if(!S)return;if(c||(c="localhost"),t||(t=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.t(S,c,h,t,f,a,g,u);return l?l.then(w=>{if(w){if(typeof w=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,h),w}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const $=this.o(w);return(w.tunnelRemoteHost!==c||w.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),g&&w.privacy!==g&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire($),$}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}o(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const c=this.e.get(n.tunnelRemoteHost);if(c){const h=c.get(n.tunnelRemotePort);h&&(h.refcount--,await this.p(n.tunnelRemoteHost,n.tunnelRemotePort,h))}}}}async p(n,c,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${c}.`);const t=h.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(c),t}}async closeTunnel(n,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${c} `);const h=this.e.get(n);if(h&&h.has(c)){const t=h.get(c);t.refcount=0,await this.p(n,c,t)}}q(n,c,h){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(c,{refcount:1,value:h})}async r(n,c){const h=this.e.get(n);if(h){const t=h.get(c),f=t?await t.value:void 0;(!f||typeof f=="string")&&h.delete(c),h.size===0&&this.e.delete(n)}}s(n,c){const h=[n];v(n)?(h.push(...e.$gw),h.push(...e.$iw)):m(n)&&h.push(...e.$iw);const t=h.map(f=>this.e.get(f));for(const f of t){const a=f?.get(c);if(a)return a}}canTunnel(n){return!!D(n)}u(n,c,h,t,f,a,g){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${h} on local port ${t}.`);const u=h;this.j.add(u);const S=t===void 0?h:t,l={elevationRequired:f?this.isPortPrivileged(S):!1},w={remoteAddress:{host:c,port:h},localAddressPort:t,privacy:a,public:a?a!==p.Private:void 0,protocol:g},$=n.forwardPort(w,l);return $?(this.q(c,h,$),$.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(u)})):this.j.delete(u),$}};e.$mw=s,e.$mw=s=Je([We(0,M.$2j),We(1,R.$2i)],s)}),define(Ie[212],Ce([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=void 0,e.$zl=(0,I.$vi)("IUriIdentityService")}),define(Ie[213],Ce([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$nw=void 0,e.$nw=(0,I.$vi)("editSessionIdentityService");var N;(function(R){R[R.Complete=100]="Complete",R[R.Partial=50]="Partial",R[R.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(Ie[214],Ce([1,0,16]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=N,e.$yM=R,e.$zM=O,e.$AM=M,e.$BM=b;function N(p){return p.scheme!==I.Schemas.file&&p.scheme!==I.Schemas.vscodeRemote}function R(p){if(p.folders.length)return p.folders.every(E=>N(E.uri))?p.folders[0].uri:void 0;if(p.configuration&&N(p.configuration))return p.configuration}function O(p){return R(p)?.scheme}function M(p){return R(p)?.authority}function b(p){return R(p)!==void 0}}),define(Ie[45],Ce([1,0,171,19,54,23,2,3,16]),function(le,e,I,N,R,O,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Pi=e.$Oi=e.WorkbenchState=e.$Ii=e.$Hi=e.$Ei=void 0,e.$Fi=E,e.$Gi=F,e.$Ji=D,e.$Ki=d,e.$Li=v,e.$Mi=r,e.$Ni=o,e.$Qi=n,e.$Vi=c,e.$Wi=h,e.$Yi=t,e.$Zi=f,e.$1i=a,e.$Ei=(0,b.$vi)("contextService");function E(g){const u=g;return typeof u?.id=="string"&&M.URI.isUri(u.uri)}function F(g){return typeof g?.id=="string"&&!E(g)&&!d(g)}e.$Hi={id:"ext-dev"},e.$Ii={id:"empty-window"};function D(g,u){if(typeof g=="string"||typeof g>"u")return typeof g=="string"?{id:(0,N.$oc)(g)}:u?e.$Hi:e.$Ii;const S=g;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}function d(g){const u=g;return typeof u?.id=="string"&&M.URI.isUri(u.configPath)}function v(g){const u=g;if(u?.uri)return{id:u.id,uri:M.URI.revive(u.uri)};const S=g;if(S?.configPath)return{id:S.id,configPath:M.URI.revive(S.configPath)};if(g?.id)return{id:g.id}}var m;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function r(g){const u=g;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}function o(g){const u=g;return!!(u&&typeof u=="object"&&M.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}class s{constructor(u,S,l,w,$){this.h=u,this.j=l,this.k=w,this.l=$,this.c=R.$Bi.forUris(this.l,()=>!0),this.folders=S}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=R.$Bi.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Oi=s;class i{constructor(u,S){this.raw=S,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,O.$9g)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Pi=i;function n(g){return new i({uri:g,index:0,name:(0,O.$5g)(g)},{uri:g.toString()})}e.$Ri="code-workspace",e.$Si=`.${e.$Ri}`,e.$Ti=[{name:(0,I.localize)(0,null),extensions:[e.$Ri]}],e.$Ui="workspace.json";function c(g,u){return O.$Zg.isEqualOrParent(g,u.untitledWorkspacesHome)}function h(g){let u;return M.URI.isUri(g)?u=g:u=g.configuration,u?.scheme===p.Schemas.tmp}e.$Xi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(g){return g.id===e.$Xi}function f(g,u){return!c(g,u)&&!h(g)}function a(g){return(typeof g=="string"?(0,N.$pc)(g):(0,O.$7g)(g))===e.$Si}}),define(Ie[215],Ce([1,0,73,5,6,23,2,170,99,37,3,12,45,28,212,11,34,13,15]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$El=e.$Bl=e.ProfileResourceType=void 0,e.$Al=c,e.$Cl=h,e.$Dl=t;var n;(function(g){g.Settings="settings",g.Keybindings="keybindings",g.Snippets="snippets",g.Tasks="tasks",g.Extensions="extensions",g.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function c(g){const u=g;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&typeof u.isDefault=="boolean"&&typeof u.name=="string"&&M.URI.isUri(u.location)&&M.URI.isUri(u.globalStorageHome)&&M.URI.isUri(u.settingsResource)&&M.URI.isUri(u.keybindingsResource)&&M.URI.isUri(u.tasksResource)&&M.URI.isUri(u.snippetsHome)&&M.URI.isUri(u.extensionsResource))}e.$Bl=(0,F.$vi)("IUserDataProfilesService");function h(g,u){return{id:g.id,isDefault:g.isDefault,name:g.name,shortName:g.shortName,icon:g.icon,location:M.URI.revive(g.location).with({scheme:u}),globalStorageHome:M.URI.revive(g.globalStorageHome).with({scheme:u}),settingsResource:M.URI.revive(g.settingsResource).with({scheme:u}),keybindingsResource:M.URI.revive(g.keybindingsResource).with({scheme:u}),tasksResource:M.URI.revive(g.tasksResource).with({scheme:u}),snippetsHome:M.URI.revive(g.snippetsHome).with({scheme:u}),extensionsResource:M.URI.revive(g.extensionsResource).with({scheme:u}),cacheHome:M.URI.revive(g.cacheHome).with({scheme:u}),useDefaultFlags:g.useDefaultFlags,isTransient:g.isTransient}}function t(g,u,S,l,w,$){return{id:g,name:u,location:S,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:$&&w?.useDefaultFlags?.globalState?$.globalStorageHome:(0,O.$9g)(S,"globalStorage"),settingsResource:$&&w?.useDefaultFlags?.settings?$.settingsResource:(0,O.$9g)(S,"settings.json"),keybindingsResource:$&&w?.useDefaultFlags?.keybindings?$.keybindingsResource:(0,O.$9g)(S,"keybindings.json"),tasksResource:$&&w?.useDefaultFlags?.tasks?$.tasksResource:(0,O.$9g)(S,"tasks.json"),snippetsHome:$&&w?.useDefaultFlags?.snippets?$.snippetsHome:(0,O.$9g)(S,"snippets"),extensionsResource:$&&w?.useDefaultFlags?.extensions?$.extensionsResource:(0,O.$9g)(S,"extensions.json"),cacheHome:(0,O.$9g)(l,g),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let f=class extends R.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(u,S,l,w){super(),this.t=u,this.u=S,this.w=l,this.y=w,this.f=!0,this.h=this.B(new N.$ee),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$ee),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$ee),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$ee),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new v.$Bc,emptyWindows:new Map},this.profilesHome=(0,O.$9g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$9g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(u){this.f!==u&&(this.z=void 0,this.f=u)}isEnabled(){return this.f}get C(){if(!this.z){const u=this.D(),S=[u];if(this.f)try{for(const $ of this.O()){if(!$.name||!(0,i.$8f)($.name)||!$.location){this.y.warn("Skipping the invalid stored profile",$.location||$.name);continue}S.push(t((0,O.$6g)($.location),$.name,$.location,this.g,{shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags},u))}}catch($){this.y.error($)}const l=new v.$Bc,w=new Map;if(S.length)try{const $=this.Q();if($.workspaces)for(const[k,y]of Object.entries($.workspaces)){const C=M.URI.parse(k),P=S.find(W=>W.id===y);P&&l.set(C,P)}if($.emptyWindows)for(const[k,y]of Object.entries($.emptyWindows)){const C=S.find(P=>P.id===y);C&&w.set(k,C)}}catch($){this.y.error($)}this.z={profiles:S,workspaces:l,emptyWindows:w}}return this.z}D(){const u=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...u,extensionsResource:this.S()??u.extensionsResource,isDefault:!0}}async createTransientProfile(u){const S="Temp",l=new RegExp(`${(0,s.$_e)(S)}\\s(\\d+)`);let w=0;for(const k of this.profiles){const y=l.exec(k.name),C=y?parseInt(y[1]):0;w=C>w?C:w}const $=`${S} ${w+1}`;return this.createProfile((0,I.$jj)((0,o.$Rg)()).toString(16),$,{transient:!0},u)}async createNamedProfile(u,S,l){return this.createProfile((0,I.$jj)((0,o.$Rg)()).toString(16),u,S,l)}async createProfile(u,S,l,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=await this.F(u,S,l);return w&&await this.setProfileForWorkspace(w,$),$}async F(u,S,l){if(!(0,i.$8f)(S)||!S)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.r.get(S);return w||(w=(async()=>{try{if(this.profiles.find(C=>C.name===S||C.id===u))throw new Error(`Profile with ${S} name already exists`);const k=t(u,S,(0,O.$9g)(this.profilesHome,u),this.g,l,this.defaultProfile);await this.u.createFolder(k.location);const y=[];return this.j.fire({profile:k,join(C){y.push(C)}}),await r.Promises.settled(y),this.I([k],[],[]),k}finally{this.r.delete(S)}})(),this.r.set(S,w)),w}async updateProfile(u,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(w=>w.id===u.id);if(!l)throw new Error(`Profile '${u.name}' does not exist`);return l=t(l.id,S.name??l.name,l.location,this.g,{shortName:S.shortName??l.shortName,icon:S.icon===null?void 0:S.icon??l.icon,transient:S.transient??l.isTransient,useDefaultFlags:S.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(u.isDefault)throw new Error("Cannot remove default profile");const S=this.profiles.find(w=>w.id===u.id);if(!S)throw new Error(`Profile '${u.name}' does not exist`);const l=[];this.m.fire({profile:S,join(w){l.push(w)}});try{await Promise.allSettled(l)}catch(w){this.y.error(w)}for(const w of[...this.C.emptyWindows.keys()])S.id===this.C.emptyWindows.get(w)?.id&&this.C.emptyWindows.delete(w);for(const w of[...this.C.workspaces.keys()])S.id===this.C.workspaces.get(w)?.id&&this.C.workspaces.delete(w);this.M(),this.I([],[S],[]);try{await this.u.del(S.cacheHome,{recursive:!0})}catch(w){(0,E.$gl)(w)!==1&&this.y.error(w)}}async setProfileForWorkspace(u,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(w=>w.id===S.id);if(!l)throw new Error(`Profile '${S.name}' does not exist`);this.L(u,l)}unsetWorkspace(u,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(u,void 0,S)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const u=await this.u.resolve(this.profilesHome);await Promise.all((u.children||[]).filter(S=>S.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,S.resource))).map(S=>this.u.del(S.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const u=this.s.profiles.filter(S=>!this.H(S));await Promise.allSettled(u.map(S=>this.removeProfile(S)))}getProfileForWorkspace(u){const S=this.G(u);return M.URI.isUri(S)?this.s.workspaces.get(S)??this.C.workspaces.get(S):this.s.emptyWindows.get(S)??this.C.emptyWindows.get(S)}G(u){return(0,d.$Fi)(u)?u.uri:(0,d.$Ki)(u)?u.configPath:u.id}H(u){return!!([...this.s.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,u.location))||[...this.s.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,u.location))||[...this.C.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,u.location))||[...this.C.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,u.location)))}I(u,S,l){const w=[...this.profiles,...u],$=[];this.s.profiles=[];for(let k of w)k.isDefault||S.some(y=>k.id===y.id)||(k=l.find(y=>k.id===y.id)??k,k.isTransient?this.s.profiles.push(k):$.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P($),this.z=void 0,this.J(u,S,l)}J(u,S,l){this.h.fire({added:u,removed:S,updated:l,all:this.profiles})}L(u,S,l){l=S?.isTransient?!0:l,l||this.L(u,void 0,!0);const w=this.G(u),$=l?this.s:this.C;M.URI.isUri(w)?($.workspaces.delete(w),S&&$.workspaces.set(w,S)):($.emptyWindows.delete(w),S&&$.emptyWindows.set(w,S)),l||this.M()}M(){const u={};for(const[l,w]of this.C.workspaces.entries())u[l.toString()]=w.id;const S={};for(const[l,w]of this.C.emptyWindows.entries())S[l.toString()]=w.id;this.R({workspaces:u,emptyWindows:S}),this.z=void 0}N(u){const S={},l=this.D();if(u.workspaces)for(const[$,k]of Object.entries(u.workspaces)){const y=M.URI.parse(k);S[$]=this.w.extUri.isEqual(y,l.location)?l.id:this.w.extUri.basename(y)}const w={};if(u.emptyWindows)for(const[$,k]of Object.entries(u.emptyWindows)){const y=M.URI.parse(k);w[$]=this.w.extUri.isEqual(y,l.location)?l.id:this.w.extUri.basename(y)}return{workspaces:S,emptyWindows:w}}O(){return[]}P(u){throw new Error("not implemented")}Q(){return{}}R(u){throw new Error("not implemented")}S(){}};e.$El=f,e.$El=f=Je([We(0,p.$Ci),We(1,E.$2k),We(2,m.$zl),We(3,D.$2j)],f);class a extends f{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(u){this.a=u}Q(){return this.X}R(u){this.X=u}}e.$Fl=a}),define(Ie[216],Ce([1,0,11,5,6,60,15,151,3,215]),function(le,e,I,N,R,O,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$2p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Zp=e.$Yp=e.$Xp=void 0,e.$1p=v,e.$3p=r,e.$5p=s,e.$Xp="__$__isNewStorageMarker",e.$Yp="__$__targetStorageMarker",e.$Zp=(0,p.$vi)("storageService");var F;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(F||(e.WillSaveStateReason=F={}));var D;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(D||(e.StorageScope=D={}));var d;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function v(i){const n=i.get(e.$Yp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class m extends R.$Vc{static{this.a=60*1e3}constructor(n={flushInterval:m.a}){super(),this.m=n,this.b=this.B(new N.$he),this.c=this.B(new N.$he),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$ee),this.onWillSaveState=this.f.event,this.h=this.B(new I.$Hh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,c,h){return N.Event.filter(this.b.event,t=>t.scope===n&&(c===void 0||t.key===c),h)}n(){this.j.value=(0,I.$Lh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,c){const{key:h,external:t}=c;if(h===e.$Yp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:h,target:this.J(n)[h],external:t})}w(n){this.f.fire({reason:n})}get(n,c,h){return this.P(c)?.get(n,h)}getBoolean(n,c,h){return this.P(c)?.getBoolean(n,h)}getNumber(n,c,h){return this.P(c)?.getNumber(n,h)}getObject(n,c,h){return this.P(c)?.getObject(n,h)}storeAll(n,c){this.y(()=>{for(const h of n)this.store(h.key,h.value,h.scope,h.target,c)})}store(n,c,h,t,f=!1){if((0,M.$eg)(c)){this.remove(n,h,f);return}this.y(()=>{this.z(n,h,t),this.P(h)?.set(n,c,f)})}remove(n,c,h=!1){this.y(()=>{this.z(n,c,void 0),this.P(c)?.delete(n,h)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,c){const h=[],t=this.J(n);for(const f of Object.keys(t))t[f]===c&&h.push(f);return h}z(n,c,h,t=!1){const f=this.J(c);typeof h=="number"?f[n]!==h&&(f[n]=h,this.P(c)?.set(e.$Yp,JSON.stringify(f),t)):typeof f[n]=="number"&&(delete f[n],this.P(c)?.set(e.$Yp,JSON.stringify(f),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const c=this.P(n);return c?v(c):Object.create(null)}isNew(n){return this.getBoolean(e.$Xp,n)===!0}async flush(n=F.NONE){this.f.fire({reason:n});const c=this.P(-1),h=this.P(0),t=this.P(1);switch(n){case F.NONE:await I.Promises.settled([c?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case F.SHUTDOWN:await I.Promises.settled([c?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return s(n,c,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,c){return this.w(F.NONE),(0,E.$Al)(n)?this.R(n,c):this.S(n,c)}M(n,c){return!(n.id===c.id||r(c)&&r(n))}N(n,c,h){this.y(()=>{const t=new Set;for(const[f,a]of n)t.add(f),c.get(f)!==a&&this.u(h,{key:f,external:!0});for(const[f]of c.items)t.has(f)||this.u(h,{key:f,external:!0})})}}e.$2p=m;function r(i){return i.isDefault||!!i.useDefaultFlags?.globalState}class o extends m{constructor(){super(),this.U=this.B(new b.$Vp(new b.$Wp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Vp(new b.$Wp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Vp(new b.$Wp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$4p=o;async function s(i,n,c,h,t,f){const a=C=>{try{return JSON.parse(C)}catch{return C}},g=new Map,u=new Map;i.forEach((C,P)=>{g.set(P,C),u.set(P,a(C))});const S=new Map,l=new Map;n.forEach((C,P)=>{S.set(P,C),l.set(P,a(C))});const w=new Map,$=new Map;c.forEach((C,P)=>{w.set(P,C),$.set(P,a(C))}),console.group(h!==t?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const k=[];if(g.forEach((C,P)=>{k.push({key:P,value:C})}),console.table(k),console.groupEnd(),console.log(u),h!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];S.forEach((P,W)=>{C.push({key:W,value:P})}),console.table(C),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${f})`);const y=[];w.forEach((C,P)=>{y.push({key:P,value:C})}),console.table(y),console.groupEnd(),console.log($)}}),define(Ie[76],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1kc=void 0;class I{static{this.a=!1}constructor(R){this.d=R,this.b=new Map,this.c=1}add(R){const O=this.c++;return this.b.set(O,R),this.e(),O}get(R,O){return this.b.has(R)?this.b.get(R)[O]:void 0}delete(R){this.b.delete(R),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$1kc=I}),define(Ie[46],Ce([1,0,16,23,3]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kc=e.$6kc=void 0;class O{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new N.$Xg(b=>{const p=this.b.get(b.scheme);return!(p===void 0||p&1024)})}$acceptProviderInfos(b,p){p===null?this.b.delete(b.scheme):this.b.set(b.scheme,p)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$6kc=O,e.$7kc=(0,R.$vi)("IExtHostFileSystemInfo")}),define(Ie[27],Ce([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EP=void 0,e.$EP=(0,I.$vi)("IExtHostInitDataService")}),define(Ie[217],Ce([1,0,176,12,201,27]),function(le,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=void 0;let M=class extends R.$MQ{constructor(p,E,F){const D=F.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",d=F.remote.isRemote?(0,I.localize)(0,null):p?(0,I.localize)(1,null):(0,I.localize)(2,null);super(E.createLogger(D,{name:d}))}};e.$anc=M,e.$anc=M=Je([We(1,N.$3j),We(2,O.$EP)],M)}),define(Ie[218],Ce([1,0,11]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=e.$Llc=void 0;class N{constructor(M,b,p){this.h=new Map,this.a=M,this.b=b,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new I.$Hh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const F of E.values())F.complete()}catch(F){for(const D of E.values())D.error(F)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,b){let p=this.f[M];return typeof p>"u"&&(p=b),p}update(M,b){this.f[M]=b;const p=this.h.get(M);if(p!==void 0)return p.p;const E=new I.$Sh;return this.h.set(M,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Llc=N;class R extends N{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,b){super(M.identifier.value,!0,b),this.j=M}}e.$Mlc=R}),define(Ie[219],Ce([1,0,5,2]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Amc=void 0;class R{constructor(M){this.c=M,this.a=new I.$ee,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$ee,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,b,p,E){const D=this.c.getNotebookDocument(N.URI.revive(M)).acceptModelChanged(b.value,p,E);this.b.fire(D)}$acceptDirtyStateChanged(M,b){this.c.getNotebookDocument(N.URI.revive(M)).acceptDirty(b)}$acceptModelSaved(M){const b=this.c.getNotebookDocument(N.URI.revive(M));this.a.fire(b.apiNotebook)}}e.$Amc=R}),define(Ie[17],Ce([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=e.$oP=void 0,e.$oP=(0,I.$vi)("IExtHostRpcService");class N{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$pP=N}),define(Ie[220],Ce([1,0,20,5]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=void 0;class R{#e;constructor(M,b){this.b=new N.$ee,this.onDidChange=this.b.event,this.a=I.$Qm.toKey(M.identifier),this.#e=b,this.#e.onDidChangePassword(p=>{p.extensionId===this.a&&this.b.fire({key:p.key})})}get(M){return this.#e.get(this.a,M)}store(M,b){return this.#e.store(this.a,M,b)}delete(M){return this.#e.delete(this.a,M)}}e.$Vlc=R}),define(Ie[61],Ce([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=e.$jlc=void 0,e.$jlc=(0,I.$vi)("IURITransformerService");class N{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$klc=N}),define(Ie[221],Ce([1,0,21]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpb=R,e.$Dpb=M;class N{constructor(){this.buffers=[]}add(p){let E=this.buffers.indexOf(p);return E<0&&(E=this.buffers.length,this.buffers.push(p)),E}}function R(b,p){if(p.serializeBuffersForPostMessage){const E=new N,D=JSON.stringify(b,(v,m)=>{if(m instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(m)};if(ArrayBuffer.isView(m)){const r=O(m);if(r)return{$$vscode_array_buffer_reference$$:!0,index:E.add(m.buffer),view:{type:r,byteLength:m.byteLength,byteOffset:m.byteOffset}}}return m}),d=E.buffers.map(v=>{const m=new Uint8Array(v);return I.$Fe.wrap(m)});return{message:D,buffers:d}}else return{message:JSON.stringify(b),buffers:[]}}function O(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(b,p){const E=p.map(d=>{const v=new ArrayBuffer(d.byteLength);return new Uint8Array(v).set(d.buffer),v}),F=p.length?(d,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const m=v,{index:r}=m,o=E[r];if(m.view)switch(m.view.type){case 1:return new Int8Array(o,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return v}:void 0;return{message:JSON.parse(b,F),arrayBuffers:E}}}),define(Ie[106],Ce([1,0,185,15,2,6,3,29,37,16,44,145,33]),function(le,e,I,N,R,O,M,b,p,E,F,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$JF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$AF=e.EditorInputCapabilities=e.$zF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=void 0,e.$qF=r,e.$rF=o,e.$sF=s,e.$tF=i,e.$uF=n,e.$vF=c,e.$wF=h,e.$xF=t,e.$yF=f,e.$BF=w,e.$CF=k,e.$DF=y,e.$EF=C,e.$FF=P,e.$GF=W,e.$HF=V,e.$IF=ae,e.$KF=fe,e.$LF=Ae,e.$MF=ce,e.$NF=Me,e.$lF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$mF={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$nF="workbench.editor.sidebysideEditor",e.$oF="workbench.editors.textDiffEditor",e.$pF="workbench.editors.binaryResourceDiffEditor";var v;(function(ie){ie[ie.PROGRAMMATIC=1]="PROGRAMMATIC",ie[ie.USER=2]="USER",ie[ie.EDIT=3]="EDIT",ie[ie.NAVIGATION=4]="NAVIGATION",ie[ie.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var m;(function(ie){ie[ie.IDENTICAL=1]="IDENTICAL",ie[ie.SIMILAR=2]="SIMILAR",ie[ie.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function r(ie){const z=ie;return!!z&&typeof z.getSelection=="function"&&!!z.onDidChangeSelection}function o(ie){const z=ie;return!!z&&typeof z.getScrollPosition=="function"&&typeof z.setScrollPosition=="function"&&!!z.onDidChangeScroll}function s(ie,z,x){for(const ve of x.visibleEditorPanes)if(ve.group.id===z&&ie.matches(ve.input))return ve.getViewState()}function i(ie){if(w(ie))return!1;const z=ie;return R.URI.isUri(z?.resource)}function n(ie){if(w(ie))return!1;const z=ie;return z?.original!==void 0&&z.modified!==void 0}function c(ie){if(w(ie))return!1;const z=ie;return!z||z.resources&&!Array.isArray(z.resources)?!1:!!z.resources||!!z.multiDiffSource}function h(ie){if(w(ie)||n(ie))return!1;const z=ie;return z?.primary!==void 0&&z.secondary!==void 0}function t(ie){if(w(ie))return!1;const z=ie;return z?z.resource===void 0||z.resource.scheme===E.Schemas.untitled||z.forceUntitled===!0:!1}function f(ie){if(w(ie))return!1;const z=ie;return R.URI.isUri(z?.base?.resource)&&R.URI.isUri(z?.input1?.resource)&&R.URI.isUri(z?.input2?.resource)&&R.URI.isUri(z?.result?.resource)}var a;(function(ie){ie[ie.SHORT=0]="SHORT",ie[ie.MEDIUM=1]="MEDIUM",ie[ie.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var g;(function(ie){ie[ie.EXPLICIT=1]="EXPLICIT",ie[ie.AUTO=2]="AUTO",ie[ie.FOCUS_CHANGE=3]="FOCUS_CHANGE",ie[ie.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(g||(e.SaveReason=g={}));class u{constructor(){this.a=new Map}registerSource(z,x){let ve=this.a.get(z);return ve||(ve={source:z,label:x},this.a.set(z,ve)),ve.source}getSourceLabel(z){return this.a.get(z)?.label??z}}e.$zF=new u;var S;(function(ie){ie[ie.None=0]="None",ie[ie.Readonly=2]="Readonly",ie[ie.Untitled=4]="Untitled",ie[ie.Singleton=8]="Singleton",ie[ie.RequiresTrust=16]="RequiresTrust",ie[ie.CanSplitInGroup=32]="CanSplitInGroup",ie[ie.ForceDescription=64]="ForceDescription",ie[ie.CanDropIntoEditor=128]="CanDropIntoEditor",ie[ie.MultipleEditors=256]="MultipleEditors",ie[ie.Scratchpad=512]="Scratchpad"})(S||(e.EditorInputCapabilities=S={}));class l extends O.$Vc{}e.$AF=l;function w(ie){return ie instanceof l}function $(ie){const z=ie;return R.URI.isUri(z?.preferredResource)}function k(ie){const z=ie;return w(z?.primary)&&w(z?.secondary)}function y(ie){const z=ie;return w(z?.modified)&&w(z?.original)}function C(ie,z,x,ve,Te){return Me(ve,[(0,D.$fj)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const De={...x,limits:{size:Number.MAX_VALUE}};ie.openEditor(z,De)}}),(0,D.$fj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:d.default.Warning})}function P(ie){return w(ie?.editor)}function W(ie){const z=ie;return P(ie)&&z?.group!==void 0}function V(ie){const z=ie;return typeof z?.groupId=="number"&&w(z.editor)}var q;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.REPLACE=1]="REPLACE",ie[ie.MOVE=2]="MOVE",ie[ie.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var A;(function(ie){ie[ie.GROUP_ACTIVE=0]="GROUP_ACTIVE",ie[ie.GROUP_INDEX=1]="GROUP_INDEX",ie[ie.GROUP_LABEL=2]="GROUP_LABEL",ie[ie.GROUP_LOCKED=3]="GROUP_LOCKED",ie[ie.EDITOR_OPEN=4]="EDITOR_OPEN",ie[ie.EDITOR_CLOSE=5]="EDITOR_CLOSE",ie[ie.EDITOR_MOVE=6]="EDITOR_MOVE",ie[ie.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ie[ie.EDITOR_LABEL=8]="EDITOR_LABEL",ie[ie.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ie[ie.EDITOR_PIN=10]="EDITOR_PIN",ie[ie.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ie[ie.EDITOR_STICKY=12]="EDITOR_STICKY",ie[ie.EDITOR_DIRTY=13]="EDITOR_DIRTY",ie[ie.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(A||(e.GroupModelChangeKind=A={}));var U;(function(ie){ie[ie.PRIMARY=1]="PRIMARY",ie[ie.SECONDARY=2]="SECONDARY",ie[ie.BOTH=3]="BOTH",ie[ie.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class K{getOriginalUri(z,x){if(!z)return;if(f(z))return e.$JF.getOriginalUri(z.result,x);if(x?.supportSideBySide){const{primary:Te,secondary:De}=this.a(z);if(Te&&De){if(x?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(Te,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(De,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===U.ANY)return this.getOriginalUri(Te,{filterByScheme:x.filterByScheme})??this.getOriginalUri(De,{filterByScheme:x.filterByScheme});z=x.supportSideBySide===U.PRIMARY?Te:De}}if(n(z)||c(z)||h(z)||f(z))return;const ve=$(z)?z.preferredResource:z.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}a(z){return k(z)||h(z)?{primary:z.primary,secondary:z.secondary}:y(z)||n(z)?{primary:z.modified,secondary:z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(z,x){if(!z)return;if(f(z))return e.$JF.getCanonicalUri(z.result,x);if(x?.supportSideBySide){const{primary:Te,secondary:De}=this.a(z);if(Te&&De){if(x?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(Te,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(De,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===U.ANY)return this.getCanonicalUri(Te,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(De,{filterByScheme:x.filterByScheme});z=x.supportSideBySide===U.PRIMARY?Te:De}}if(n(z)||c(z)||h(z)||f(z))return;const ve=z.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}b(z,x){if(Array.isArray(x)){if(x.some(ve=>z.scheme===ve))return z}else if(x===z.scheme)return z}}var re;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.KEYBOARD=1]="KEYBOARD",ie[ie.MOUSE=2]="MOUSE"})(re||(e.EditorCloseMethod=re={}));function ae(ie,z,x,ve){if(!ie.isSticky(z))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return x===re.MOUSE||x===re.KEYBOARD;case"mouse":return x===re.MOUSE;case"keyboard":return x===re.KEYBOARD}return!1}e.$JF=new K;var ye;(function(ie){ie[ie.LEFT=0]="LEFT",ie[ie.RIGHT=1]="RIGHT"})(ye||(e.CloseDirection=ye={}));class Pe{constructor(){this.c=new Map,this.d=new Map}start(z){const x=this.a=z.get(M.$ui);for(const[ve,Te]of this.c)this.e(ve,Te,x);this.c.clear()}e(z,x,ve){const Te=ve.createInstance(x);this.d.set(z,Te)}registerFileEditorFactory(z){if(this.b)throw new Error("Can only register one file editor factory.");this.b=z}getFileEditorFactory(){return(0,N.$gg)(this.b)}registerEditorSerializer(z,x){if(this.c.has(z)||this.d.has(z))throw new Error(`A editor serializer with type ID '${z}' was already registered.`);return this.a?this.e(z,x,this.a):this.c.set(z,x),(0,O.$Tc)(()=>{this.c.delete(z),this.d.delete(z)})}getEditorSerializer(z){return this.d.get(typeof z=="string"?z:z.typeId)}}b.$bo.add(e.$lF.EditorFactory,new Pe);async function fe(ie,z,x){return!ie||!ie.length?[]:await Promise.all(ie.map(async ve=>{const Te=R.URI.revive(ve.fileUri);if(!Te){x.info("Cannot resolve the path because it is not valid.",ve);return}if(!await z.canHandleResource(Te)){x.info("Cannot resolve the path because it cannot be handled",ve);return}let $e=ve.exists,ge=ve.type;if(typeof $e!="boolean"||typeof ge!="number")try{ge=(await z.stat(Te)).isDirectory?p.FileType.Directory:p.FileType.Unknown,$e=!0}catch(X){x.error(X),$e=!1}if(!$e&&ve.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",ve);return}if(ge===p.FileType.Directory){x.info("Cannot resolve the path because it is a directory",ve);return}const Q={...ve.options,pinned:!0};return $e?{resource:Te,options:Q}:{resource:Te,options:Q,forceUntitled:!0}}))}var me;(function(ie){ie[ie.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ie[ie.SEQUENTIAL=1]="SEQUENTIAL"})(me||(e.EditorsOrder=me={}));function Ae(ie){const z=ie;if(!z)return!1;const x=z;if(x.modified)return Ae(x.modified);const ve=z;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function ce(ie){return(0,F.$hj)(ie)}function Me(ie,z,x){const ve=(0,F.$ij)(ie,z);return ve.forceMessage=x?.forceMessage,ve.forceSeverity=x?.forceSeverity,ve.allowDialog=x?.allowDialog,ve}}),define(Ie[222],Ce([1,0,5,186,3,6,28,29,18,25,92,210]),function(le,e,I,N,R,O,M,b,p,E,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VF=e.$UF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$TF=e.ViewContentGroups=e.$RF=e.ViewContainerLocation=e.Extensions=e.$QF=e.$PF=e.$OF=void 0,e.$SF=m,e.$OF="views",e.$PF=(0,N.localize)(0,null),e.$QF=(0,D.$$w)("default-view-icon",F.$Uj.window,(0,N.localize)(1,null));var d;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(d||(e.Extensions=d={}));var v;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$RF=[0,1,2];function m(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class r extends O.$Vc{constructor(){super(...arguments),this.c=this.B(new I.$ee),this.onDidRegister=this.c.event,this.f=this.B(new I.$ee),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,p.$Rb)([...this.g.values()])}registerViewContainer(a,g,u){const S=this.get(a.id);if(S)return S;const l=a;return l.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:l.openCommandActionDescriptor??{id:l.id},(0,M.$yc)(this.g,g,[]).push(l),u?.isDefault&&this.h.push(l),this.c.fire({viewContainer:l,viewContainerLocation:g}),l}deregisterViewContainer(a){for(const g of this.g.keys()){const u=this.g.get(g),S=u?.indexOf(a);if(S!==-1){u?.splice(S,1),u.length===0&&this.g.delete(g),this.f.fire({viewContainer:a,viewContainerLocation:g});return}}}get(a){return this.all.filter(g=>g.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(g=>this.getViewContainers(g).filter(u=>u?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(g=>this.getViewContainerLocation(g)===a)}}b.$bo.add(d.ViewContainersRegistry,new r);var o;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(o||(e.ViewContentGroups=o={}));function s(f,a){const g=f.group??o.More,u=a.group??o.More;return g!==u?g.localeCompare(u):(f.order??5)-(a.order??5)}class i extends O.$Vc{constructor(){super(...arguments),this.c=this.B(new I.$ee),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$ee),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$ee),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$ee),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Ic}registerViews(a,g){this.registerViews2([{views:a,viewContainer:g}])}registerViews2(a){a.forEach(({views:g,viewContainer:u})=>this.r(g,u)),this.c.fire(a)}deregisterViews(a,g){const u=this.s(a,g);u.length&&this.f.fire({views:u,viewContainer:g})}moveViews(a,g){for(const u of this.m.keys())if(u!==g){const S=this.s(a,u);S.length&&(this.r(S,g),this.g.fire({views:S,from:u,to:g}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const g of this.j){const u=(this.m.get(g)||[]).filter(S=>S.id===a)[0];if(u)return u}return null}getViewContainer(a){for(const g of this.j)if((this.m.get(g)||[]).filter(S=>S.id===a)[0])return g;return null}registerViewWelcomeContent(a,g){return this.n.add(a,g),this.h.fire(a),(0,O.$Tc)(()=>{this.n.delete(a,g),this.h.fire(a)})}registerViewWelcomeContent2(a,g){const u=new Map;for(const[S,l]of g)this.n.add(a,l),u.set(S,(0,O.$Tc)(()=>{this.n.delete(a,l),this.h.fire(a)}));return this.h.fire(a),u}getViewWelcomeContent(a){const g=[];return this.n.forEach(a,u=>g.push(u)),g.sort(s)}r(a,g){let u=this.m.get(g);u||(u=[],this.m.set(g,u),this.j.push(g));for(const S of a){if(this.getView(S.id)!==null)throw new Error((0,N.localize)(2,null,S.id));u.push(S)}}s(a,g){const u=this.m.get(g);if(!u)return[];const S=[],l=[];for(const w of u)a.includes(w)?S.push(w):l.push(w);return S.length&&(l.length?this.m.set(g,l):(this.m.delete(g),this.j.splice(this.j.indexOf(g),1))),S}}b.$bo.add(d.ViewsRegistry,new i),e.$TF=(0,R.$vi)("viewDescriptorService");var n;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var c;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(a,g){this.c=!1,this.d=!1,(0,E.$5n)(this,a),this.d=!!g,this.resolve=async u=>{if(g&&!this.c){const S=await g(u);S&&(this.tooltip=this.tooltip??S.tooltip,this.command=this.command??S.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$UF=h;class t extends Error{constructor(a){super((0,N.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$VF=t}),define(Ie[223],Ce([1,0,187,31]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=void 0,e.$ZF=new N.$Mj("chatSessionResponseVote","",{type:"string",description:(0,I.localize)(0,null)}),e.$1F=new N.$Mj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,I.localize)(1,null)}),e.$2F=new N.$Mj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,I.localize)(2,null)}),e.$3F=new N.$Mj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,I.localize)(3,null)}),e.$4F=new N.$Mj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,I.localize)(4,null)}),e.$5F=new N.$Mj("chatResponse",!1,{type:"boolean",description:(0,I.localize)(5,null)}),e.$6F=new N.$Mj("chatRequest",!1,{type:"boolean",description:(0,I.localize)(6,null)}),e.$7F=new N.$Mj("chatInputHasText",!1,{type:"boolean",description:(0,I.localize)(7,null)}),e.$8F=new N.$Mj("chatInputHasFocus",!1,{type:"boolean",description:(0,I.localize)(8,null)}),e.$9F=new N.$Mj("inChatInput",!1,{type:"boolean",description:(0,I.localize)(9,null)}),e.$0F=new N.$Mj("inChat",!1,{type:"boolean",description:(0,I.localize)(10,null)}),e.$$F=new N.$Mj("chatIsEnabled",!1,{type:"boolean",description:(0,I.localize)(11,null)}),e.$_F=new N.$Mj("chatCursorAtTop",!1),e.$aG=new N.$Mj("chatInputHasAgent",!1),e.$bG=new N.$Mj("chatLocation",void 0)}),define(Ie[224],Ce([1,0,11,24,5,41,6,132,13,31,3,12,102,204,216,223]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.ChatAgentLocation=void 0;var s;(function(h){h.Panel="panel",h.Terminal="terminal",h.Notebook="notebook",h.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function(h){function t(f){switch(f){case"panel":return h.Panel;case"terminal":return h.Terminal;case"notebook":return h.Notebook;case"editor":return h.Editor}return h.Panel}h.fromRaw=t}(s||(e.ChatAgentLocation=s={})),e.$_G=(0,F.$vi)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(t){this.f=t,this.b=[],this.d=new R.$ee,this.onDidChangeAgents=this.d.event,this.e=r.$$F.bindTo(this.f)}registerAgent(t,f){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const g=this,u=f.slashCommands;f={...f,get slashCommands(){return u.filter(l=>!l.when||g.f.contextMatchesRules(E.$tj.deserialize(l.when)))}};const S={data:f};return this.b.push(S),(0,M.$Tc)(()=>{this.b=this.b.filter(l=>l!==S),this.d.fire(void 0)})}registerAgentImplementation(t,f){const a=this.g(t);if(!a)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(a.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return a.data.isDefault&&this.e.set(!0),a.impl=f,this.d.fire(new n(a.data,f)),(0,M.$Tc)(()=>{a.impl=void 0,this.d.fire(void 0),a.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,f){const a={data:t,impl:f};return this.b.push(a),this.d.fire(new n(t,f)),(0,M.$Tc)(()=>{this.b=this.b.filter(g=>g!==a),this.d.fire(void 0)})}updateAgent(t,f){const a=this.g(t);if(!a?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);a.data.metadata={...a.data.metadata,...f},this.d.fire(new n(a.data,a.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(f=>!!f.isDefault&&f.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(f=>!!f.isDefault&&f.locations.includes(t))}getSecondaryAgent(){return O.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(f=>f.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new n(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(f=>f.name===t)}async invokeAgent(t,f,a,g,u){const S=this.g(t);if(!S?.impl)throw new Error(`No activated agent with id ${t}`);return await S.impl.invoke(f,a,g,u)}async getFollowups(t,f,a,g,u){const S=this.g(t);if(!S?.impl)throw new Error(`No activated agent with id ${t}`);return S.impl?.provideFollowups?S.impl.provideFollowups(f,a,g,u):[]}};e.$aH=i,e.$aH=i=Je([We(0,E.$Nj)],i);class n{constructor(t,f){this.b=t,this.d=f}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisher(){return this.b.extensionPublisher}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,f,a,g){return this.d.invoke(t,f,a,g)}async provideFollowups(t,f,a,g){return this.d.provideFollowups?this.d.provideFollowups(t,f,a,g):[]}provideWelcomeMessage(t,f){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,f)}provideSampleQuestions(t,f){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,f)}}e.$bH=n,e.$cH=(0,F.$vi)("chatAgentNameService");let c=class{static{o=this}static{this.b="chat.participantNameRegistry"}constructor(t,f,a,g){if(this.g=f,this.h=a,this.i=g,this.e=(0,b.$2d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const u=g.get(o.b,-1);try{this.e.set(JSON.parse(u??"{}"),void 0)}catch{g.remove(o.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,I.$wh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},N.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const f=await(0,v.$Sp)(t);if(!f||f.version!==1)throw new Error("Unexpected chat participant registry response.");const a=f.restrictedChatParticipants;this.e.set(a,void 0),this.i.store(o.b,JSON.stringify(a),-1,1)}getAgentNameRestriction(t){return this.e.map(a=>a[t.name.toLowerCase()]).map(a=>a?a.some(g=>(0,p.$xf)(g,g.includes(".")?t.extensionId.value:t.extensionPublisher)):!0)}dispose(){this.f=!0}};e.$dH=c,e.$dH=c=o=Je([We(0,d.$ik),We(1,v.$Mp),We(2,D.$2j),We(3,m.$Zp)],c)}),define(Ie[225],Ce([1,0,2,30,3]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jG=e.$iG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$gG=O,e.$hG=M;function O(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof I.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(N.$tt.isIRange)}function M(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(O)}var b;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var p;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$iG=(0,R.$vi)("IChatService"),e.$jG="accessibility.voice.keywordActivation"}),define(Ie[226],Ce([1,0,5,11,188]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new I.$ee,this.o=new I.$ee,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(b){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=b}onEvent(b){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=b}onRequest(b){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.u("response",b)}sendRequest(b,p,E,F){const D={command:b};if(p&&Object.keys(p).length>0&&(D.arguments=p),this.u("request",D),typeof F=="number"){const d=setTimeout(()=>{clearTimeout(d);const v=this.f.get(D.seq);if(v){this.f.delete(D.seq);const m={type:"response",seq:0,request_seq:D.seq,success:!1,command:b,message:(0,R.localize)(0,null,F,b)};v(m)}},F)}return E&&this.f.set(D.seq,E),D.seq}acceptMessage(b){this.k?this.k(b):(this.m.push(b),this.m.length===1&&this.s())}q(b,p){return b.type!=="event"||p.type!=="event"}async s(){let b;for(;this.m.length;){if((!b||this.q(this.m[0],b))&&await(0,N.$wh)(0),b=this.m.shift(),!b)return;switch(b.type){case"event":this.j?.(b);break;case"request":this.g?.(b);break;case"response":{const p=b,E=this.f.get(p.request_seq);E&&(this.f.delete(p.request_seq),E(p));break}}}}u(b,p){p.type=b,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach((p,E)=>b.set(E,p)),await(0,N.$wh)(500),b.forEach((p,E)=>{p({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$3pb=O}),define(Ie[227],Ce([1,0,2,189,31,3]),function(le,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$tJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$rJ=e.MemoryRangeType=e.State=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=void 0,e.$qJ=p,e.$sJ=F,e.$eI="workbench.view.debug",e.$fI="workbench.debug.variablesView",e.$gI="workbench.debug.watchExpressionsView",e.$hI="workbench.debug.callStackView",e.$iI="workbench.debug.loadedScriptsView",e.$jI="workbench.debug.breakPointsView",e.$kI="workbench.debug.disassemblyView",e.$lI="workbench.panel.repl",e.$mI="workbench.panel.repl.view",e.$nI=new R.$Mj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$oI=new R.$Mj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$pI=new R.$Mj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$qI="debugUx",e.$rI=new R.$Mj(e.$qI,"default",{type:"string",description:N.localize(3,null)}),e.$sI=new R.$Mj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$tI=new R.$Mj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$uI=new R.$Mj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$vI=new R.$Mj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$wI=new R.$Mj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$xI=new R.$Mj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$yI=new R.$Mj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$zI=new R.$Mj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$AI=new R.$Mj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$BI=new R.$Mj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$CI=new R.$Mj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$DI=new R.$Mj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$EI=new R.$Mj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$FI=new R.$Mj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$GI=new R.$Mj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$HI=new R.$Mj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$II=new R.$Mj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$JI=new R.$Mj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$KI=new R.$Mj("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$LI=new R.$Mj("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$MI=new R.$Mj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$NI=new R.$Mj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$OI=new R.$Mj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$PI=new R.$Mj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$QI=new R.$Mj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$RI=new R.$Mj("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$SI=new R.$Mj("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$TI=new R.$Mj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$UI=new R.$Mj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$VI=new R.$Mj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$WI=new R.$Mj("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$XI=new R.$Mj("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$YI=new R.$Mj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$ZI=new R.$Mj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$1I=new R.$Mj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$2I=new R.$Mj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$3I=new R.$Mj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$4I=new R.$Mj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$5I=new R.$Mj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$6I=new R.$Mj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$7I=new R.$Mj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$8I=new R.$Mj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$9I=new R.$Mj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$0I=new R.$Mj("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$$I=new R.$Mj("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$_I=new R.$Mj("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$aJ=new R.$Mj("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$bJ=new R.$Mj("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$cJ=new R.$Mj("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$dJ=new R.$Mj("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$eJ=new R.$Mj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$fJ=new R.$Mj("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$gJ=new R.$Mj("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$hJ=new R.$Mj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$iJ=new R.$Mj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$jJ=new R.$Mj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$kJ=new R.$Mj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const M=n=>N.localize(61,null,n);e.$lJ=M,e.$mJ="editor.contrib.debug",e.$nJ="editor.contrib.breakpoint",e.$oJ="debug",e.$pJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var b;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(b||(e.State=b={}));function p(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$rJ="vscode-debug-memory";function F(n){return n.source.presentationHint==="deemphasize"||n.presentationHint==="deemphasize"||n.presentationHint==="subtle"}var D;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(D||(e.DataBreakpointSetType=D={}));var d;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(d||(e.DebugConfigurationProviderTriggerKind=d={}));var v;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(v||(e.DebuggerString=v={})),e.$tJ=(0,O.$vi)("debugService");var m;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(m||(e.BreakpointWidgetContext=m={}));var r;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var o;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var s;(function(n){n.deserialize=c=>c,n.serialize=c=>c})(s||(e.IDebugVisualizationTreeItem=s={}));var i;(function(n){n.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:I.URI.revive(c.iconPath.light),dark:I.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),n.serialize=c=>c})(i||(e.IDebugVisualization=i={}))}),define(Ie[228],Ce([1,0,13,2,19,25,16,30,24,18]),function(le,e,I,N,R,O,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sH=void 0,e.$gH=D,e.$hH=d,e.$iH=v,e.$jH=m,e.$kH=r,e.$lH=o,e.$mH=s,e.$nH=n,e.$oH=t,e.$pH=f,e.$qH=g,e.$rH=S;const F=/{([^}]+)}/g;function D(w,$,k){return w.replace(F,function(y,C){return $&&C.length>0&&C[0]!=="_"?y:k&&k.hasOwnProperty(C)?k[C]:y})}function d(w){const $={};for(const k of Object.keys(w))k.startsWith("!")||($[k]=w[k]);return $}function v(w){return w.configuration.request==="attach"&&!m(w)&&(!w.parentSession||v(w.parentSession))}function m(w){let $=w.configuration.type;if($)return $==="vslsShare"&&($=w.configuration.adapterProxy.configuration.type),(0,I.$xf)($,"extensionhost")||(0,I.$xf)($,"pwa-extensionhost")?w:w.parentSession?m(w.parentSession):void 0}function r(w){return w.type&&(w.label||w.program||w.runtime)}function o(w,$,k){let y,C=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=P.exec(w);){const V=W.index+1,q=V+W[0].length;if(V<=$&&q>=k){y=W[0],C=V;break}}if(y){const V=/\w+/g;let q=null;for(;(q=V.exec(y))&&!(q.index+1+C+q[0].length>=k););q&&(y=y.substring(0,V.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}async function s(w,$,k,y){if(w.evaluatableExpressionProvider.has($)){const C=w.evaluatableExpressionProvider.ordered($),P=(0,E.$Hb)(await Promise.all(C.map(async W=>{try{return await W.provideEvaluatableExpression($,k,y??p.CancellationToken.None)}catch{return}})));if(P.length>0){let W=P[0].expression;const V=P[0].range;return W||(W=$.getLineContent(k.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:W}}}else{const C=$.getLineContent(k.lineNumber),{start:P,end:W}=o(C,k.column,k.column),V=C.substring(P-1,W);return{matchingExpression:V,range:new b.$tt(k.lineNumber,P,k.lineNumber,P+V.length)}}return null}const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(w){return!!(w&&w.match(i))}function c(w){if(typeof w.path=="string"&&!(typeof w.sourceReference=="number"&&w.sourceReference>0)){if(n(w.path))return N.URI.parse(w.path);if((0,R.$jc)(w.path))return N.URI.file(w.path)}return w.path}function h(w){if(typeof w.path=="object"){const $=N.URI.revive(w.path);if($)return $.scheme===M.Schemas.file?$.fsPath:$.toString()}return w.path}function t(w,$){const k=$?c:h,y=(0,O.$2n)(w);return a(y,(C,P)=>{C&&P&&(P.path=k(P))}),y}function f(w,$){const k=$?c:h,y=(0,O.$2n)(w);return a(y,(C,P)=>{!C&&P&&(P.path=k(P))}),y}function a(w,$){switch(w.type){case"event":{const k=w;switch(k.event){case"output":$(!1,k.body.source);break;case"loadedSource":$(!1,k.body.source);break;case"breakpoint":$(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=w;switch(k.command){case"setBreakpoints":$(!0,k.arguments.source);break;case"breakpointLocations":$(!0,k.arguments.source);break;case"source":$(!0,k.arguments.source);break;case"gotoTargets":$(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(y=>$(!1,y));break;default:break}break}case"response":{const k=w;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(y=>$(!1,y.source));break;case"loadedSources":k.body.sources.forEach(y=>$(!1,y));break;case"scopes":k.body.scopes.forEach(y=>$(!1,y.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(y=>$(!1,y.source));break;case"setBreakpoints":k.body.breakpoints.forEach(y=>$(!1,y.source));break;case"disassemble":k.body?.instructions.forEach(C=>$(!1,C.location));break;default:break}break}}}function g(w){return w.filter($=>!$.presentation?.hidden).sort(($,k)=>$.presentation?k.presentation?$.presentation.group?k.presentation.group?$.presentation.group!==k.presentation.group?$.presentation.group.localeCompare(k.presentation.group):u($.presentation.order,k.presentation.order):-1:k.presentation.group?1:u($.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function u(w,$){return typeof w!="number"?typeof $!="number"?0:1:typeof $!="number"?-1:w-$}async function S(w,$){const k=w.getValue("debug.saveBeforeStart",{overrideIdentifier:$.activeTextEditorLanguageId});if(k!=="none"&&(await $.saveAll(),k==="allEditorsInActiveGroup")){const y=$.activeEditorPane;y&&y.input.resource?.scheme===M.Schemas.untitled&&await $.save({editor:y.input,groupId:y.group.id})}await w.reloadConfiguration()}const l=(w,$)=>!w||!$?w===$:w.name===$.name&&w.path===$.path&&w.sourceReference===$.sourceReference;e.$sH=l}),define(Ie[229],Ce([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GK=e.CellExecutionUpdateType=void 0;var N;(function(R){R[R.Output=1]="Output",R[R.OutputItems=2]="OutputItems",R[R.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$GK=(0,I.$vi)("INotebookExecutionService")}),define(Ie[230],Ce([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjb=e.$ajb=e.ProxyKernelState=e.$_ib=void 0,e.$_ib=100;var N;(function(R){R[R.Disconnected=1]="Disconnected",R[R.Connected=2]="Connected",R[R.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$ajb=(0,I.$vi)("INotebookKernelService"),e.$bjb=(0,I.$vi)("INotebookKernelHistoryService")}),define(Ie[231],Ce([1,0,6,30,156,96]),function(le,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Wb=void 0;class M extends I.$Vc{constructor(p,E,F){super(),this._source=p,this.b=E,this.c=F,this.a=void 0}f(p){const E=p.getLineCount();return new N.$tt(1,1,E,this.g(p,E))}g(p,E){if(E<1||E>p.getLineCount())throw new Error("Illegal value for lineNumber");return p.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const p=new R.$UC;p.acceptChunk(this._source);const E=p.finish(!0),{textBuffer:F,disposable:D}=E.create(1);this.b=F,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(p=>{const E=new R.$UC;E.acceptChunk(p);const F=E.finish(!0),{textBuffer:D,disposable:d}=F.create(1);return this.B(d),D})),this.a}findInInputs(p){const F=new O.$IC(p,!1,!1,null).parseSearchRequest();if(!F)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,F,!0,5e3)}findInOutputs(p){const F=new O.$IC(p,!1,!1,null).parseSearchRequest();return F?this.outputTextBuffers.map(D=>{const d=D.findMatchesLineByLine(this.f(D),F,!0,5e3);if(d.length!==0)return{textBuffer:D,matches:d}}).filter(D=>!!D):[]}}e.$0Wb=M}),define(Ie[52],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(O){O.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var N;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class R{static fromExtHostTestItem(M,b,p=M.parent){if(M._isRoot)return new R([b]);const E=[M.id];for(let F=p;F&&F.id!==b;F=F.parent)E.push(F.id);return E.push(b),new R(E.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const b=M.indexOf("\0");return b===-1?M:M.slice(0,b)}static fromString(M){return new R(M.split("\0"))}static join(M,b){return new R([...M.path,b])}static joinToString(M,b){return M.toString()+"\0"+b}static parentId(M){const b=M.lastIndexOf("\0");return b===-1?void 0:M.slice(0,b)}static localId(M){const b=M.lastIndexOf("\0");return b===-1?M:M.slice(b+1)}static isChild(M,b){return b.startsWith(M)&&b[M.length]==="\0"}static compare(M,b){return M===b?0:R.isChild(M,b)?2:R.isChild(b,M)?3:1}constructor(M,b=M.length){if(this.path=M,this.d=b,M.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new R(this.path,1)}get parentId(){return this.d>1?new R(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new R(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new R(this.path,M)}compare(M){if(typeof M=="string")return R.compare(this.toString(),M);for(let b=0;b<M.d&&b<this.d;b++)if(M.path[b]!==this.path[b])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$ML=R}),define(Ie[62],Ce([1,0,2,94,30,52]),function(le,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$UL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$TL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$SL=e.$RL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$QL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$PL=e.$OL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$NL=e.TestResultState=void 0;var M;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$NL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(A){A[A.Run=1]="Run",A[A.Debug=2]="Debug",A[A.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var p;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable",A[A.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$OL=[2,4,8,16,32,64];const E=A=>"runId"in A;e.$PL=E;var F;(function(A){A.serialize=U=>({range:U.range.toJSON(),uri:U.uri.toJSON()}),A.deserialize=(U,K)=>({range:R.$tt.lift(K.range),uri:U.asCanonicalUri(I.URI.revive(K.uri))})})(F||(e.IRichLocation=F={}));var D;(function(A){A[A.Error=0]="Error",A[A.Output=1]="Output"})(D||(e.TestMessageType=D={}));var d;(function(A){A.serialize=U=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&F.serialize(U.location)}),A.deserialize=(U,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&F.deserialize(U,K.location)})})(d||(e.ITestErrorMessage=d={}));const v=(A,U)=>`${U?"s":"e"}${A}`;e.$QL=v;var m;(function(A){A.serialize=U=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&F.serialize(U.location)}),A.deserialize=(U,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&F.deserialize(U,K.location)})})(m||(e.ITestOutputMessage=m={}));var r;(function(A){A.serialize=U=>U.type===0?d.serialize(U):m.serialize(U),A.deserialize=(U,K)=>K.type===0?d.deserialize(U,K):m.deserialize(U,K)})(r||(e.ITestMessage=r={}));var o;(function(A){A.serializeWithoutMessages=U=>({state:U.state,duration:U.duration,messages:[]}),A.serialize=U=>({state:U.state,duration:U.duration,messages:U.messages.map(r.serialize)}),A.deserialize=(U,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(re=>r.deserialize(U,re))})})(o||(e.ITestTaskState=o={}));const s="\0",i=(A,U)=>A+s+U;e.$RL=i;const n=A=>{const U=A.indexOf(s);return{ctrlId:A.slice(0,U),tagId:A.slice(U+1)}};e.$SL=n;var c;(function(A){A.serialize=U=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?.toJSON(),range:U.range?.toJSON()||null,description:U.description,error:U.error,sortText:U.sortText}),A.deserialize=(U,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?U.asCanonicalUri(I.URI.revive(K.uri)):void 0,range:K.range?R.$tt.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(c||(e.ITestItem=c={}));var h;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(A){A.serialize=U=>({expand:U.expand,item:c.serialize(U.item)}),A.deserialize=(U,K)=>({controllerId:O.$ML.root(K.item.extId),expand:K.expand,item:c.deserialize(U,K.item)})})(t||(e.InternalTestItem=t={}));var f;(function(A){A.serialize=U=>{let K;return U.item&&(K={},U.item.label!==void 0&&(K.label=U.item.label),U.item.tags!==void 0&&(K.tags=U.item.tags),U.item.busy!==void 0&&(K.busy=U.item.busy),U.item.uri!==void 0&&(K.uri=U.item.uri?.toJSON()),U.item.range!==void 0&&(K.range=U.item.range?.toJSON()),U.item.description!==void 0&&(K.description=U.item.description),U.item.error!==void 0&&(K.error=U.item.error),U.item.sortText!==void 0&&(K.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:K}},A.deserialize=U=>{let K;return U.item&&(K={},U.item.label!==void 0&&(K.label=U.item.label),U.item.tags!==void 0&&(K.tags=U.item.tags),U.item.busy!==void 0&&(K.busy=U.item.busy),U.item.range!==void 0&&(K.range=U.item.range?R.$tt.lift(U.item.range):null),U.item.description!==void 0&&(K.description=U.item.description),U.item.error!==void 0&&(K.error=U.item.error),U.item.sortText!==void 0&&(K.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:K}}})(f||(e.ITestItemUpdate=f={}));const a=(A,U)=>{U.expand!==void 0&&(A.expand=U.expand),U.item!==void 0&&(A.item=A.item?Object.assign(A.item,U.item):U.item)};e.$TL=a;var g;(function(A){A.serializeWithoutMessages=U=>({...t.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(o.serializeWithoutMessages)}),A.serialize=U=>({...t.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(o.serialize)}),A.deserialize=(U,K)=>({...t.deserialize(U,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(re=>o.deserialize(U,re)),retired:!0})})(g||(e.TestResultItem=g={}));var u;(function(A){A.empty=()=>({covered:0,total:0}),A.sum=(U,K)=>{U.covered+=K.covered,U.total+=K.total}})(u||(e.ICoverageCount=u={}));var S;(function(A){A.serialize=U=>({id:U.id,statement:U.statement,branch:U.branch,declaration:U.declaration,uri:U.uri.toJSON()}),A.deserialize=(U,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:U.asCanonicalUri(I.URI.revive(K.uri))})})(S||(e.IFileCoverage=S={}));function l(A){return{...A,location:A.location?.toJSON()}}function w(A){return A.location=A.location?N.$st.isIPosition(A.location)?N.$st.lift(A.location):R.$tt.lift(A.location):void 0,A}e.$UL=3;var $;(function(A){A[A.Declaration=0]="Declaration",A[A.Statement=1]="Statement",A[A.Branch=2]="Branch"})($||(e.DetailType=$={}));var k;(function(A){A.serialize=U=>U.type===0?C.serialize(U):P.serialize(U),A.deserialize=U=>U.type===0?C.deserialize(U):P.deserialize(U)})(k||(e.CoverageDetails=k={}));var y;(function(A){A.serialize=l,A.deserialize=w})(y||(e.IBranchCoverage=y={}));var C;(function(A){A.serialize=l,A.deserialize=w})(C||(e.IDeclarationCoverage=C={}));var P;(function(A){A.serialize=U=>({...l(U),branches:U.branches?.map(y.serialize)}),A.deserialize=U=>({...w(U),branches:U.branches?.map(y.deserialize)})})(P||(e.IStatementCoverage=P={}));var W;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.DocumentSynced=2]="DocumentSynced",A[A.Remove=3]="Remove",A[A.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",A[A.Retire=5]="Retire",A[A.AddTag=6]="AddTag",A[A.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var V;(function(A){A.deserialize=(U,K)=>K.op===0?{op:K.op,item:t.deserialize(U,K.item)}:K.op===1?{op:K.op,item:f.deserialize(K.item)}:K.op===2?{op:K.op,uri:U.asCanonicalUri(I.URI.revive(K.uri)),docv:K.docv}:K,A.serialize=U=>U.op===0?{op:U.op,item:t.serialize(U.item)}:U.op===1?{op:U.op,item:f.serialize(U.item)}:U})(V||(e.TestsDiffOp=V={}));class q{constructor(U){this.k=U,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(U){const K=this.v();for(const re of U)switch(re.op){case 0:this.l(t.deserialize(this.k,re.item),K);break;case 1:this.o(f.deserialize(re.item),K);break;case 3:this.p(re.itemId,K);break;case 5:this.q(re.itemId);break;case 4:this.updatePendingRoots(re.amount);break;case 6:this.c.set(re.tag.id,re.tag);break;case 7:this.c.delete(re.id);break}K.complete?.()}l(U,K){const re=O.$ML.parentId(U.item.extId)?.toString();let ae;if(!re)ae=this.w(U),this.g.add(ae),this.f.set(U.item.extId,ae);else if(this.f.has(re)){const ye=this.f.get(re);ye.children.add(U.item.extId),ae=this.w(U,ye),this.f.set(U.item.extId,ae)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(U)}`);return}return K.add?.(ae),U.expand===2&&this.h++,ae}o(U,K){const re=this.f.get(U.extId);if(re)return U.expand!==void 0&&(re.expand===2&&this.h--,U.expand===2&&this.h++),(0,e.$TL)(re,U),K.update?.(re),re}p(U,K){const re=this.f.get(U);if(!re)return;const ae=O.$ML.parentId(re.item.extId)?.toString();ae?this.f.get(ae).children.delete(re.item.extId):this.g.delete(re);const ye=[[U]];for(;ye.length;)for(const Pe of ye.pop()){const fe=this.f.get(Pe);fe&&(ye.push(fe.children),this.f.delete(Pe),K.remove?.(fe,fe!==re),fe.expand===2&&this.h--)}}q(U){}updatePendingRoots(U){this.j+=U}v(){return{}}}e.$VL=q}),define(Ie[77],Ce([1,0,11,5,6,57,62,52]),function(le,e,I,N,R,O,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.TestItemEventOp=void 0;var p;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const E=(i,n)=>i===n,D=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:E,label:E,description:E,error:E,sortText:E,tags:(i,n)=>!(i.length!==n.length||i.some(c=>!n.includes(c)))}),d=(i,n)=>{let c;for(const[h,t]of D)t(i[h],n[h])||(c?c[h]=n[h]:c={[h]:n[h]});return c};class v extends R.$Vc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new I.$Hh(()=>this.flushDiff(),200)),this.g=this.B(new N.$ee),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===n.uri){c.docv=n.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===n.item.extId){(0,M.$TL)(c.item,n.item);return}if(c.op===0&&c.item.item.extId===n.item.extId){(0,M.$TL)(c.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,c){const h=this.tree.get(n);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,c-1):t.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,c){switch(c.op){case 3:this.O(b.$ML.joinToString(n.fullId,c.id));break;case 0:this.z(c.item,n);break;case 5:for(const h of c.ops)this.w(n,h);break;case 1:this.C(c.new,c.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:c.update}});break;case 6:this.y(n.actual.uri);break;default:(0,O.$fd)(c)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,c){const h=b.$ML.fromExtHostTestItem(n,this.root.id,c?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(n.id);let f=this.tree.get(h.toString());if(!f){f={fullId:h,actual:n,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(n,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(n)}}),this.I(n,f,c);return}if(f.actual===n){this.H(n,f,c);return}if(f.actual.uri?.toString()!==n.uri?.toString())return this.O(h.toString()),this.z(n,c);const a=this.s.getChildren(f.actual),g=f.actual,u=d(this.s.toITestItem(g),this.s.toITestItem(n));this.s.getApiFor(g).listener=void 0,f.actual=n,f.resolveBarrier=void 0,f.expand=0,u&&(u.hasOwnProperty("tags")&&(this.C(n.tags,g.tags,h.toString()),delete u.tags),this.w(f,{op:4,update:u})),this.I(n,f,c);for(const[l,w]of a)this.s.getChildren(n).get(w.id)||this.O(b.$ML.joinToString(h,w.id));const S=f.expandLevels;S!==void 0&&queueMicrotask(()=>{f.expand===1&&(f.expandLevels=void 0,this.expand(h.toString(),S))}),this.y(f.actual.uri)}C(n,c,h){const t=new Set(c.map(f=>f.id));for(const f of n)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:h,item:{tags:n.map(f=>(0,M.$RL)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(n){const c=this.j.get(n.id);c?c.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$RL)(this.s.controllerId,n.id)}}))}F(n){const c=this.j.get(n);c&&!--c.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,M.$RL)(this.s.controllerId,n)}))}G(n,c){this.s.getApiFor(n).parent=c&&c.actual!==this.root?c.actual:void 0}H(n,c,h){this.G(n,h);const t=this.s.getApiFor(n);t.parent=h?.actual,t.listener=f=>this.w(c,f),this.J(c)}I(n,c,h){this.H(n,c,h);for(const[t,f]of this.s.getChildren(n))this.z(f,c)}J(n){let c;this.h?n.resolveBarrier?c=n.resolveBarrier.isOpen()?3:2:c=n.actual.canResolveChildren?1:0:c=0,c!==n.expand&&(n.expand=c,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:c}}),c===1&&n.expandLevels!==void 0&&this.M(n))}L(n,c){if(c<0)return;const h=[];for(const[t,f]of this.s.getChildren(n.actual)){const a=this.expand(b.$ML.joinToString(n.fullId,f.id),c);(0,I.$hh)(a)&&h.push(a)}if(h.length)return Promise.all(h).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const f=new I.$uh;return f.open(),f}n.expand=2,this.N(n);const c=n.resolveBarrier=new I.$uh,h=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(f){h(f)}return(0,I.$hh)(t)?t.catch(h).then(()=>{c.open(),this.J(n)}):(c.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const c=this.tree.get(n);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const h=[c];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,a]of this.s.getChildren(t.actual))h.push(this.tree.get(b.$ML.joinToString(t.fullId,a.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$eP=v;class m extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$fP=m;class r extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$gP=r;class o extends Error{constructor(n,c,h){super(`TestItem with ID "${n}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$hP=o;const s=(i,n,c)=>{let h=new Map;return{get size(){return h.size},forEach(t,f){for(const a of h.values())t.call(f,a,this)},[Symbol.iterator](){return h.entries()},replace(t){const f=new Map,a=new Set(h.keys()),g={op:5,ops:[]};for(const u of t){if(!(u instanceof c))throw new r(u.id);const S=n(u).controllerId;if(S!==i.controllerId)throw new o(u.id,S,i.controllerId);if(f.has(u.id))throw new m(u.id);f.set(u.id,u),a.delete(u.id),g.ops.push({op:0,item:u})}for(const u of a.keys())g.ops.push({op:3,id:u});i.listener?.(g),h=f},add(t){if(!(t instanceof c))throw new r(t.id);h.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){h.delete(t)&&i.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$iP=s}),define(Ie[107],Ce([1,0,77]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kP=e.$jP=void 0;const N=new WeakMap,R=(M,b)=>{const p={controllerId:b};return N.set(M,p),p};e.$jP=R;const O=M=>{const b=N.get(M);if(!b)throw new I.$gP(M?.id||"<unknown>");return b};e.$kP=O}),define(Ie[78],Ce([1,0,16,2]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3yb=e.$2yb=e.$1yb=void 0,e.$4yb=R,e.$5yb=M,e.$1yb="vscode-cdn.net",e.$2yb=`vscode-resource.${e.$1yb}`,e.$3yb=`'self' https://*.${e.$1yb}`;function R(b,p){return b.scheme===I.Schemas.http||b.scheme===I.Schemas.https?b:(p&&p.authority&&p.isRemote&&b.scheme===I.Schemas.file&&(b=N.URI.from({scheme:I.Schemas.vscodeRemote,authority:p.authority,path:b.path})),N.URI.from({scheme:I.Schemas.https,authority:`${b.scheme}+${O(b.authority)}.${e.$2yb}`,path:b.path,fragment:b.fragment,query:b.query}))}function O(b){return b.replace(/./g,p=>{const E=p.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?p:"-"+E.toString(16).padStart(4,"0")})}function M(b){return b.replace(/-([0-9a-f]{4})/g,(p,E)=>String.fromCharCode(parseInt(E,16)))}}),define(Ie[232],Ce([1,0,5,6,78]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=void 0;class O{constructor(b,p,E){this.d=b,this.e=p,this.f=E,this.a=0,this.b=new N.$Uc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const F=p.getVisibleTextEditors();for(const D of this.c.values())F.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,p,E,F,D){let d;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===b){d=n;break}if(!d)throw new Error("not a visible editor");const v=this,m=this.a++,r=new I.$ee,o=new I.$ee,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,R.$4yb)(n,v.f)}get cspSource(){return R.$3yb}set options(n){this.b=n,v.d.$setOptions(m,n)}get options(){return this.b}set html(n){this.a=n,v.d.$setHtml(m,n)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(n){return v.d.$postMessage(m,n)}},i=new class{constructor(){this.editor=b,this.line=p,this.height=E,this.webview=s,this.onDidDispose=o.event}dispose(){v.c.has(m)&&(v.c.delete(m),v.d.$disposeEditorInset(m),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(m,d.id,d.value.document.uri,p+1,E,F||{},D.identifier,D.extensionLocation),this.c.set(m,{editor:b,inset:i,onDidReceiveMessage:r}),i}$onDidDispose(b){const p=this.c.get(b);p&&p.inset.dispose()}$onDidReceiveMessage(b,p){this.c.get(b)?.onDidReceiveMessage.fire(p)}}e.$hlc=O}),define(Ie[108],Ce([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5L=e.$4L=e.$3L=void 0,e.$3L="__",e.$4L=(0,I.$vi)("IAuthenticationService"),e.$5L=(0,I.$vi)("IAuthenticationExtensionsService")}),define(Ie[233],Ce([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=e.VariableKind=e.$aQ=void 0,e.$aQ=(0,I.$vi)("configurationResolverService");var N;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class R extends Error{constructor(M,b){super(b),this.variable=M}}e.$bQ=R}),define(Ie[234],Ce([1,0,19,75,15,25,22,97,192,233,13]),function(le,e,I,N,R,O,M,b,p,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,m,r,o){this.h=new Map,this.a=v,this.b=m,this.g=r,o&&(this.c=o.then(s=>this.i(s)))}i(v){if(M.$i){const m=Object.create(null);return Object.keys(v).forEach(r=>{m[r.toLowerCase()]=v[r]}),m}return v}resolveWithEnvironment(v,m,r){return this.l({env:this.i(v),userHome:void 0},m?m.uri:void 0,r)}async resolveAsync(v,m){const r={env:await this.c,userHome:await this.g};return this.l(r,v?v.uri:void 0,m)}async j(v,m,r,o){const s=O.$2n(m);M.$i&&s.windows?Object.keys(s.windows).forEach(n=>s[n]=s.windows[n]):M.$j&&s.osx?Object.keys(s.osx).forEach(n=>s[n]=s.osx[n]):M.$k&&s.linux&&Object.keys(s.linux).forEach(n=>s[n]=s.linux[n]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,v?v.uri:void 0,s,r,o)}async resolveAnyAsync(v,m,r){return this.j(v,m,r)}async resolveAnyMap(v,m,r){const o=new Map;return{newConfig:await this.j(v,m,r,o),resolvedVariables:o}}resolveWithInteractionReplace(v,m,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,m,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,m){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,m)}async l(v,m,r,o,s){if(R.$8f(r))return this.m(v,m,r,o,s);if(Array.isArray(r))return Promise.all(r.map(i=>this.l(v,m,i,o,s)));if(R.$0f(r)){const i=Object.create(null),n=await Promise.all(Object.keys(r).map(async c=>[await this.m(v,m,c,o,s),await this.l(v,m,r[c],o,s)]));for(const[c,h]of n)i[c]=h;return i}return r}m(v,m,r,o,s){return(0,F.$pf)(r,D.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(D.VARIABLE_LHS))return i;let c=await this.o(v,i,n,m,o);return s?.set(n,c),c!==i&&R.$8f(c)&&c.match(D.VARIABLE_REGEXP)&&(c=await this.m(v,m,c,o,s)),c})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,m,r,o,s){let i;const n=r.split(":");n.length>1&&(r=n[0],i=n[1]);const c=f=>{const a=this.a.getFilePath();if(a)return(0,b.$xw)(a);throw new E.$bQ(f,(0,p.localize)(0,null,m))},h=f=>{const a=c(f);if(this.a.getWorkspaceFolderPathForFile){const g=this.a.getWorkspaceFolderPathForFile();if(g)return(0,b.$xw)(g)}throw new E.$bQ(f,(0,p.localize)(1,null,m,I.$oc(a)))},t=f=>{if(i){const a=this.a.getFolderUri(i);if(a)return a;throw new E.$bQ(f,(0,p.localize)(2,null,m,i))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new E.$bQ(f,(0,p.localize)(3,null,m)):new E.$bQ(f,(0,p.localize)(4,null,m))};switch(r){case"env":if(i){if(v.env){const f=v.env[M.$i?i.toLowerCase():i];if(R.$8f(f))return f}return""}throw new E.$bQ(E.VariableKind.Env,(0,p.localize)(5,null,m));case"config":if(i){const f=this.a.getConfigurationValue(o,i);if(R.$eg(f))throw new E.$bQ(E.VariableKind.Config,(0,p.localize)(6,null,m,i));if(R.$0f(f))throw new E.$bQ(E.VariableKind.Config,(0,p.localize)(7,null,m,i));return f}throw new E.$bQ(E.VariableKind.Config,(0,p.localize)(8,null,m));case"command":return this.p(E.VariableKind.Command,m,i,s,"command");case"input":return this.p(E.VariableKind.Input,m,i,s,"input");case"extensionInstallFolder":if(i){const f=await this.a.getExtension(i);if(!f)throw new E.$bQ(E.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,m,i));return this.n(f.extensionLocation)}throw new E.$bQ(E.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,m));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,b.$xw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return o||i?(0,b.$xw)(this.n(t(E.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$xw)(I.$oc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new E.$bQ(E.VariableKind.UserHome,(0,p.localize)(11,null,m))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new E.$bQ(E.VariableKind.LineNumber,(0,p.localize)(12,null,m))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new E.$bQ(E.VariableKind.SelectedText,(0,p.localize)(13,null,m))}case"file":return c(E.VariableKind.File);case"fileWorkspaceFolder":return h(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$oc(h(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||i?I.$mc(this.n(t(E.VariableKind.RelativeFile)),c(E.VariableKind.RelativeFile)):c(E.VariableKind.RelativeFile);case"relativeFileDirname":{const f=I.$nc(c(E.VariableKind.RelativeFileDirname));if(o||i){const a=I.$mc(this.n(t(E.VariableKind.RelativeFileDirname)),f);return a.length===0?".":a}return f}case"fileDirname":return I.$nc(c(E.VariableKind.FileDirname));case"fileExtname":return I.$pc(c(E.VariableKind.FileExtname));case"fileBasename":return I.$oc(c(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=I.$oc(c(E.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-I.$pc(f).length)}case"fileDirnameBasename":return I.$oc(I.$nc(c(E.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||m}case"execInstallFolder":{const f=this.a.getAppRoot();return f||m}case"pathSeparator":case"/":return I.sep;default:try{const f=i?`${r}:${i}`:r;return this.p(E.VariableKind.Unknown,m,f,s,void 0)}catch{return m}}}}p(v,m,r,o,s){if(r&&o){const i=s===void 0?o[r]:o[s+":"+r];if(typeof i=="string")return i;throw new E.$bQ(v,(0,p.localize)(14,null,m))}return m}}e.$qQ=D}),define(Ie[109],Ce([1,0,3,106]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$QD=void 0,e.$RD=E,e.$SD=d,e.$TD=v,e.$QD=(0,I.$vi)("editorGroupsService");var R;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(R||(e.GroupDirection=R={}));var O;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var M;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var b;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EXPAND=1]="EXPAND",m[m.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var p;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function E(m){const r=m;return(0,N.$BF)(r?.editor)&&(0,N.$BF)(r?.replacement)}var F;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F||(e.GroupsOrder=F={}));var D;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function d(m){const r=m;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function v(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Ie[235],Ce([1,0,3,109]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XD=e.$WD=e.$VD=e.$UD=void 0,e.$YD=R,e.$UD=(0,I.$vi)("editorService"),e.$VD=-1,e.$WD=-2,e.$XD=-3;function R(O){const M=O;return typeof O=="number"||(0,N.$SD)(M)}}),define(Ie[236],Ce([1,0,3,99]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=void 0,e.$lM=(0,I.$wi)(N.$Ci)}),define(Ie[110],Ce([1,0,20,5,19,6,11]),function(le,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F_b=e.$E_b=e.$D_b=e.$C_b=e.$B_b=void 0;class b{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$B_b=b;class p{static isHostExtension(i,n,c){if(n.getExtensionDescription(i))return!1;const h=c.getExtensionDescription(i);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(i,n){this.j=i,this.c=new N.$ee,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(r),this.f=new I.$Sm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const c of n)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=o(this.e,n),this.e=this.e.concat(i);const c=p.l(this.e);return this.e=o(this.e,c.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new b(this.d,c)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,g){this.addNode(a),this.addNode(g),this.c.has(a)?this.c.get(a).push(g):this.c.set(a,[g])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,g){const u=n.getArcs(a);for(let S=0;S<u.length;S++)if(!g.has(u[S]))return!1;return!0}getNodes(){return this.e}},c=new I.$Sm;for(const a of i)if(c.set(a.identifier,a),a.extensionDependencies)for(const g of a.extensionDependencies)n.addArc(I.$Qm.toKey(a.identifier),I.$Qm.toKey(g));const h=new Set;n.getNodes().filter(a=>n.getArcs(a).length===0).forEach(a=>h.add(a));const t=n.getNodes().filter(a=>!h.has(a));let f;do{f=!1;for(let a=0;a<t.length;a++){const g=t[a];n.hasOnlyGoodArcs(g,h)&&(t.splice(a,1),a--,h.add(g),f=!0)}}while(f);return t.map(a=>c.get(a))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$C_b=p;class E{constructor(i,n){this.versionId=i,this.extensions=n}}e.$D_b=E;class F{constructor(i){this.d=new v,this.c=new p(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new D(this,n)}deltaExtensions(i,n,c){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,c)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$E_b=F;class D extends O.$Vc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$F_b=D;class d{constructor(i){this.name=i;const n=(0,M.$oh)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class v{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new d(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const c=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{n&&(clearTimeout(c),n=!1,this.d=!1,this.e())};i.resolve((0,O.$Tc)(h))}}var m;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(m||(m={}));function r(s,i){const n=s.isBuiltin?0:s.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==c)return n-c;const h=R.$hc.basename(s.extensionLocation.path),t=R.$hc.basename(i.extensionLocation.path);return h<t?-1:h>t?1:0}function o(s,i){const n=new I.$Rm(i);return s.filter(c=>!n.has(c.identifier))}}),define(Ie[79],Ce([1,0,21]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Ym=M,e.$Zm=b;var N;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(N||(e.UIKind=N={}));var R;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(R||(e.ExtensionHostExitCode=R={}));var O;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function M(E){const F=I.$Fe.alloc(1);switch(E){case 0:F.writeUInt8(1,0);break;case 1:F.writeUInt8(2,0);break;case 2:F.writeUInt8(3,0);break}return F}function b(E,F){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return F===0;case 2:return F===1;case 3:return F===2;default:return!1}}var p;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Ie[63],Ce([1,0,3,5,12,27,79,58,59,25,2,6,179]),function(le,e,I,N,R,O,M,b,p,E,F,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=e.$GP=e.$FP=void 0,e.$HP=r;let v=class extends D.$Vc{constructor(s,i){super(),this.s=s,this.t=i,this.a=this.B(new N.$ee),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$ee),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=F.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:p.$jp,name:(0,d.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,R.$4j)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,i,n){const c=this.getTelemetryDetails(),h=new m(i,n,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(s,i,n){this.f=s,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:i["common.uikind"]="web";break;case M.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$Hm)((0,p.$pp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const i=this.getTelemetryDetails();this.r.forEach((n,c)=>{const h=n.filter(t=>!t.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(n=>{for(const c of n)c.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,i){const c=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(s.value),!1;let h=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(i),h=!0);return h}};e.$FP=v,e.$FP=v=Je([We(0,O.$EP),We(1,R.$3j)],v);class m{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,n,c,h,t,f){this.g=n,this.h=c,this.i=h,this.j=t,this.a=new N.$ee,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(s,i){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,p.$sp)(i,[]),this.c&&(i=(0,E.$5n)(i,this.c)),this.b||(i=(0,E.$5n)(i,this.j)),"properties"in s?s.properties=i:s=i,s}k(s,i){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(s,i),this.h.trace(s,i))}logUsage(s,i){this.d.isUsageEnabled&&this.k(s,i)}logError(s,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,i);else{const n={name:s.name,message:s.message,stack:s.stack,cause:s.cause},c=(0,p.$sp)(n,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(h,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$GP=m;function r(o){const s=Date.now()-new Date(o).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$IP=(0,I.$vi)("IExtHostTelemetry")}),define(Ie[26],Ce([1,0,5,2,207,105,20,3]),function(le,e,I,N,R,O,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LG=e.ActivationKind=e.$IG=e.$HG=e.$EG=e.ExtensionHostStartup=e.$DG=e.$CG=e.$BG=e.$AG=void 0,e.$FG=d,e.$GG=v,e.$JG=s,e.$KG=i,e.$AG=Object.freeze({identifier:new M.$Qm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$BG="extensions.webWorker",e.$CG=(0,b.$vi)("extensionService");class p{constructor(h){this.dependency=h}}e.$DG=p;var E;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class F{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,f){this.c=h,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$lG.createActivationEventsMap(this.d)}}set(h,t,f){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const a=[],g=[],u=[],S=[],l=D(this.d),w=D(t),$=(W,V)=>W.extensionLocation.toString()===V.extensionLocation.toString()||W.isBuiltin===V.isBuiltin||W.isUserBuiltin===V.isUserBuiltin||W.isUnderDevelopment===V.isUnderDevelopment;for(const W of this.d){const V=w.get(W.identifier);if(!V){a.push(W.identifier),l.delete(W.identifier);continue}if(!$(W,V)){a.push(W.identifier),l.delete(W.identifier);continue}}for(const W of t){const V=l.get(W.identifier);if(!V){g.push(W);continue}if(!$(V,W)){a.push(V.identifier),l.delete(V.identifier);continue}}const k=new M.$Rm(this.e),y=new M.$Rm(f);for(const W of this.e)y.has(W)||u.push(W);for(const W of f)k.has(W)||S.push(W);const C=O.$lG.createActivationEventsMap(g),P={versionId:h,toRemove:a,toAdd:g,addActivationEvents:C,myToRemove:u,myToAdd:S};return this.delta(P),P}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:a,myToAdd:g}=h,u=new M.$Rm(t),S=new M.$Rm(a);for(let l=0;l<this.d.length;l++)u.has(this.d[l].identifier)&&(this.d.splice(l,1),l--);for(let l=0;l<this.e.length;l++)S.has(this.e[l])&&(this.e.splice(l,1),l--);for(const l of f)this.d.push(l);for(const l of g)this.e.push(l);return this.f=null,h}containsExtension(h){for(const t of this.e)if(M.$Qm.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=O.$lG.readActivationEvents(t);for(const a of f)h.add(a)}return h}}e.$EG=F;function D(c){const h=new M.$Sm;for(const t of c)h.set(t.identifier,t);return h}function d(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}function v(c,h){if(!d(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class m{constructor(h,t,f,a){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=a}}e.$HG=m;class r{constructor(h,t){this.description=h,this.value=t}}e.$IG=r;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,R.$yp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function i(c,h){return{identifier:new M.$Qm((0,R.$wp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class n{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$LG=n}),define(Ie[237],Ce([1,0,14,110,20,26,12,11]),function(le,e,I,N,R,O,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=e.$Hlc=e.$Glc=e.$Flc=e.$Elc=e.$Dlc=void 0;class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(s,i,n,c){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=c}}e.$Dlc=p;class E{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,i){return s===-1||i===-1?-1:i-s}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Elc=E;class F{constructor(s,i,n,c,h,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=n,this.module=c,this.exports=h,this.subscriptions=t}}e.$Flc=F;class D extends F{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Glc=D;class d extends F{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Hlc=d;class v extends F{constructor(s){super(!0,s,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(s,i,n,c){this.g=c,this.a=s,this.b=i,this.c=n,this.d=new R.$Sm,this.f=Object.create(null)}dispose(){for(const[s,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,n]of this.d)s.push(n.wait());await Promise.all(s)}isActivated(s){const i=this.d.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this.d.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this.f[s])return;const n=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(n.map(c=>({id:c.identifier,reason:{startup:i,extensionId:c.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,i){const n=this.a.getExtensionDescription(s);if(!n)throw new Error(`Extension '${s.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(s){const i=s.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const i=this.a.getExtensionDescription(s.id);if(!i){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new v(h));return this.c.onExtensionActivationError(s.id,h,new O.$DG(s.id.value)),t}const n=[],c=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const h of c){if(this.m(h))continue;const t=this.d.get(h);if(t){n.push(t);continue}if(this.l(h)){n.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:s.reason}));continue}const f=this.a.getExtensionDescription(h);if(f){if(!f.main&&!f.browser)continue;n.push(this.j({id:f.identifier,reason:s.reason}));continue}const a=i.displayName||i.identifier.value,g=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${h}'`),u=this.k(s,i.displayName,[],new v(g));return this.c.onExtensionActivationError(i.identifier,g,new O.$DG(h)),u}return this.k(s,i.displayName,n,null)}k(s,i,n,c){const h=new r(s.id,i,s.reason,n,c,this.c,this.g);return this.d.set(s.id,h),h}l(s){return N.$C_b.isHostExtension(s,this.a,this.b)}m(s){const i=this.b.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.$Ilc=m,e.$Ilc=m=Je([We(3,M.$2j)],m);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,i,n,c,h,t,f){this.c=s,this.d=i,this.f=n,this.g=c,this.h=h,this.j=t,this.k=f,this.a=new b.$uh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const i=this.g[s];if(i.value&&!i.value.activationFailed){this.g.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new v(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this.h=new v(i),this.b&&I.$4(s))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};r=Je([We(6,M.$2j)],r)}),define(Ie[238],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testPreserveFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testPreserveFocus.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[239],Ce([1,0,194,14,33,100,74,29,20,238,102,105]),function(le,e,I,N,R,O,M,b,p,E,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=void 0;const d=b.$bo.as(M.$co.JSONContribution);class v{constructor(h,t,f){this.a=h,this.b=t,this.c=f}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(R.default.Error,h)}warn(h){this.d(R.default.Warning,h)}info(h){this.d(R.default.Info,h)}}e.$uG=v;class m{static a(h){const t=new p.$Rm;for(let f=0,a=h.length;f<a;f++)t.add(h[f].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new m(t,[]);if(!t||!t.length)return new m([],h);const f=this.a(h),a=this.a(t),g=t.filter(S=>!f.has(S.description.identifier)),u=h.filter(S=>!a.has(S.description.identifier));return new m(g,u)}constructor(h,t){this.added=h,this.removed=t}}e.$vG=m;class r{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=m.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,N.$1)(h)}}}e.$wG=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$xG={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$Pm},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$So}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$So}},extensionKind:{description:I.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new r(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&D.$lG.register(h.extensionPoint,h.activationEventsGenerator),e.$xG.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,d.registerSchema(s,e.$xG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$yG=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};b.$bo.add(n.ExtensionsRegistry,new i),e.$zG=b.$bo.as(n.ExtensionsRegistry),d.registerSchema(s,e.$xG),d.registerSchema(F.$jk,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Ie[240],Ce([1,0,190,15,25,239,31,5]),function(le,e,I,N,R,O,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6H=void 0;const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var E;(function(d){function v(m,r,o){if(!m)return;const s=N.$8f(m.type)?m.type:void 0;if(!s||s.length===0){o.error(I.localize(3,null));return}const i=[];if(Array.isArray(m.required))for(const n of m.required)N.$8f(n)&&i.push(n);return{extensionId:r.value,taskType:s,required:i,properties:m.properties?R.$2n(m.properties):{},when:m.when?M.$tj.deserialize(m.when):void 0}}d.from=v})(E||(E={}));const F=O.$zG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(d,v)=>{for(const m of d)m.type&&v.push(`onTaskType:${m.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:p}});class D{constructor(){this.d=new b.$ee,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,m)=>{F.setHandler((r,o)=>{this.c=void 0;try{for(const s of o.removed){const i=s.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const s of o.added){const i=s.value;for(const n of i){const c=E.from(n,s.description.identifier,s.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const m of this.all()){const r={type:"object",additionalProperties:!1};m.required.length>0&&(r.required=m.required.slice(0)),m.properties!==void 0?r.properties=R.$2n(m.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[m.taskType]},v.push(r)}this.c={oneOf:v}}return this.c}}e.$6H=new D}),define(Ie[241],Ce([1,0,191,15,23,25,31,240]),function(le,e,I,N,R,O,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$dI=e.JsonSchemaVersion=e.ExecutionEngine=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$0H=e.ShellQuoting=e.$9H=e.$8H=e.$7H=void 0,e.$7H="settings",e.$8H=new M.$Mj("taskRunning",!1,I.localize(0,null)),e.$9H=I.localize2(2,"Tasks");var p;(function(A){A[A.Escape=1]="Escape",A[A.Strong=2]="Strong",A[A.Weak=3]="Weak"})(p||(e.ShellQuoting=p={})),e.$0H="$customized",function(A){function U(K){if(!K)return A.Strong;switch(K.toLowerCase()){case"escape":return A.Escape;case"strong":return A.Strong;case"weak":return A.Weak;default:return A.Strong}}A.from=U}(p||(e.ShellQuoting=p={}));var E;(function(A){A.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var F;(function(A){A[A.Always=1]="Always",A[A.Silent=2]="Silent",A[A.Never=3]="Never"})(F||(e.RevealKind=F={})),function(A){function U(K){switch(K.toLowerCase()){case"always":return A.Always;case"silent":return A.Silent;case"never":return A.Never;default:return A.Always}}A.fromString=U}(F||(e.RevealKind=F={}));var D;(function(A){A[A.Never=1]="Never",A[A.OnProblem=2]="OnProblem",A[A.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(A){function U(K){switch(K.toLowerCase()){case"always":return A.Always;case"never":return A.Never;case"onproblem":return A.OnProblem;default:return A.OnProblem}}A.fromString=U}(D||(e.RevealProblemKind=D={}));var d;(function(A){A[A.Shared=1]="Shared",A[A.Dedicated=2]="Dedicated",A[A.New=3]="New"})(d||(e.PanelKind=d={})),function(A){function U(K){switch(K.toLowerCase()){case"shared":return A.Shared;case"dedicated":return A.Dedicated;case"new":return A.New;default:return A.Shared}}A.fromString=U}(d||(e.PanelKind=d={}));var v;(function(A){A.defaults={echo:!0,reveal:F.Always,revealProblems:D.Never,focus:!1,panel:d.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var m;(function(A){A[A.Shell=1]="Shell",A[A.Process=2]="Process",A[A.CustomExecution=3]="CustomExecution"})(m||(e.RuntimeType=m={})),function(A){function U(re){switch(re.toLowerCase()){case"shell":return A.Shell;case"process":return A.Process;case"customExecution":return A.CustomExecution;default:return A.Process}}A.fromString=U;function K(re){switch(re){case A.Shell:return"shell";case A.Process:return"process";case A.CustomExecution:return"customExecution";default:return"process"}}A.toString=K}(m||(e.RuntimeType=m={}));var r;(function(A){function U(K){return N.$8f(K)?K:K.value}A.value=U})(r||(e.CommandString=r={}));var o;(function(A){A.Clean={_id:"clean",isDefault:!1},A.Build={_id:"build",isDefault:!1},A.Rebuild={_id:"rebuild",isDefault:!1},A.Test={_id:"test",isDefault:!1};function U(re){return re===A.Clean._id||re===A.Build._id||re===A.Rebuild._id||re===A.Test._id}A.is=U;function K(re){if(re!==void 0)return N.$8f(re)?U(re)?{_id:re,isDefault:!1}:void 0:re}A.from=K})(o||(e.TaskGroup=o={}));var s;(function(A){A[A.Global=1]="Global",A[A.Workspace=2]="Workspace",A[A.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(A){A.Workspace="workspace",A.Extension="extension",A.InMemory="inMemory",A.WorkspaceFile="workspaceFile",A.User="user";function U(K){switch(K){case A.User:return 2;case A.WorkspaceFile:return 5;default:return 6}}A.toConfigurationTarget=U})(i||(e.TaskSourceKind=i={}));var n;(function(A){A.parallel="parallel",A.sequence="sequence"})(n||(e.DependsOrder=n={}));var c;(function(A){A[A.default=1]="default",A[A.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(A){A.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(U,K,re,ae,ye,Pe){this._label="",this._id=U,K&&(this._label=K),re&&(this.type=re),this.runOptions=ae,this.configurationProperties=ye,this._source=Pe}getDefinition(U){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,K=!1){if(U===void 0)return!1;if(N.$8f(U))return U===this._label||U===this.configurationProperties.identifier||K&&U===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.$$H=t;class f extends t{constructor(U,K,re,ae,ye,Pe,fe,me){super(U,re,void 0,fe,me,K),this.command={},this._source=K,this.hasDefinedMatchers=Pe,ye&&(this.command=ye)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case m.Shell:K="shell";break;case m.Process:K="process";break;case m.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(U){return U instanceof f}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$7H:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const U=this.d();if(!U)return;let K=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(K+=this._source.kind);const re={type:e.$0H,folder:U,id:K};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$6g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new f(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$_H=f;class a extends t{constructor(U,K,re,ae,ye,Pe,fe){super(U,re,ae,Pe,fe,K),this._source=K,this.configures=ye}static is(U){return U instanceof a}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$6g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$7H:this._source.config.workspaceFolder?.uri.toString()}getKey(){const U=this.d();if(!U)return;let K=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(K+=this._source.kind);const re={type:e.$0H,folder:U,id:K};return JSON.stringify(re)}}e.$aI=a;class g extends t{constructor(U,K,re,ae,ye,Pe,fe,me,Ae){super(U,re,ae,me,Ae,K),this.defines=ye,this.hasDefinedMatchers=fe,this.command=Pe,this.icon=Ae.icon,this.hide=Ae.hide}clone(){return new g(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof g}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new g(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$bI=g;class u extends t{constructor(U,K,re,ae,ye,Pe){super(U,re,ae,ye,Pe,K),this._source=K}clone(){return new u(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof u}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new u(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.$cI=u;var S;(function(A){A[A.Process=1]="Process",A[A.Terminal=2]="Terminal"})(S||(e.ExecutionEngine=S={})),function(A){A._default=A.Terminal}(S||(e.ExecutionEngine=S={}));var l;(function(A){A[A.V0_1_0=1]="V0_1_0",A[A.V2_0_0=2]="V2_0_0"})(l||(e.JsonSchemaVersion=l={}));class w{constructor(U){this.c=new Map;for(let K=0;K<U.length;K++)this.c.set(U[K].uri.toString(),K)}compare(U,K){const re=U.getWorkspaceFolder(),ae=K.getWorkspaceFolder();if(re&&ae){let ye=this.c.get(re.uri.toString());ye=ye===void 0?0:ye+1;let Pe=this.c.get(ae.uri.toString());return Pe=Pe===void 0?0:Pe+1,ye===Pe?U._label.localeCompare(K._label):ye-Pe}else return!re&&ae?-1:re&&!ae?1:0}}e.$dI=w;var $;(function(A){A.DependsOnStarted="dependsOnStarted",A.AcquiredInput="acquiredInput",A.Start="start",A.ProcessStarted="processStarted",A.Active="active",A.Inactive="inactive",A.Changed="changed",A.Terminated="terminated",A.ProcessEnded="processEnded",A.End="end"})($||(e.TaskEventKind=$={}));var k;(function(A){A.SingleRun="singleRun",A.Background="background"})(k||(e.TaskRunType=k={}));var y;(function(A){A[A.System=0]="System",A[A.User=1]="User",A[A.FolderOpen=2]="FolderOpen",A[A.ConfigurationChange=3]="ConfigurationChange",A[A.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(A){function U(me){return{taskId:me._id,taskName:me.configurationProperties.name,runType:me.configurationProperties.isBackground?"background":"singleRun",group:me.configurationProperties.group,__task:me}}function K(me,Ae,ce){return{...U(me),kind:"start",terminalId:Ae,resolvedVariables:ce}}A.start=K;function re(me,Ae,ce){return{...U(me),kind:"processStarted",terminalId:Ae,processId:ce}}A.processStarted=re;function ae(me,Ae,ce){return{...U(me),kind:"processEnded",terminalId:Ae,exitCode:ce}}A.processEnded=ae;function ye(me,Ae,ce){return{...U(me),kind:"terminated",exitReason:ce,terminalId:Ae}}A.terminated=ye;function Pe(me,Ae,ce){return{...U(Ae),kind:me,terminalId:ce}}A.general=Pe;function fe(){return{kind:"changed"}}A.changed=fe})(C||(e.TaskEvent=C={}));var P;(function(A){function U(re){const ae=Object.keys(re).sort();let ye="";for(const Pe of ae){let fe=re[Pe];fe instanceof Object?fe=U(fe):typeof fe=="string"&&(fe=fe.replace(/,/g,",,")),ye+=Pe+","+fe+","}return ye}function K(re){const ye={_key:U(re),type:re.taskType};return Object.assign(ye,re),ye}A.create=K})(P||(e.KeyedTaskIdentifier=P={}));var W;(function(A){A.AutoDetect="task.autoDetect",A.SaveBeforeRun="task.saveBeforeRun",A.ShowDecorations="task.showDecorations",A.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",A.SlowProviderWarning="task.slowProviderWarning",A.QuickOpenHistory="task.quickOpen.history",A.QuickOpenDetail="task.quickOpen.detail",A.QuickOpenSkip="task.quickOpen.skip",A.QuickOpenShowAll="task.quickOpen.showAll",A.AllowAutomaticTasks="task.allowAutomaticTasks",A.Reconnection="task.reconnection",A.VerboseLogging="task.verboseLogging"})(W||(e.TaskSettingId=W={}));var V;(function(A){A.Tasks="tasks",A.SuppressTaskName="tasks.suppressTaskName",A.Windows="tasks.windows",A.Osx="tasks.osx",A.Linux="tasks.linux",A.ShowOutput="tasks.showOutput",A.IsShellCommand="tasks.isShellCommand",A.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var q;(function(A){function U(K,re){const ae=b.$6H.get(K.type);if(ae===void 0){const me=O.$2n(K);return delete me._key,P.create(me)}const ye=Object.create(null);ye.type=ae.taskType;const Pe=new Set;ae.required.forEach(me=>Pe.add(me));const fe=ae.properties;for(const me of Object.keys(fe)){const Ae=K[me];if(Ae!=null)ye[me]=Ae;else if(Pe.has(me)){const ce=fe[me];if(ce.default!==void 0)ye[me]=O.$2n(ce.default);else switch(ce.type){case"boolean":ye[me]=!1;break;case"number":case"integer":ye[me]=0;break;case"string":ye[me]="";break;default:re.error(I.localize(1,null,JSON.stringify(K,void 0,0),me));return}}}return P.create(ye)}A.createTaskIdentifier=U})(q||(e.TaskDefinition=q={}))}),define(Ie[242],Ce([1,0,14]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H_b=e.$G_b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,b)=>{this.b=M,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,I.$1)(M))}then(M,b){return this.j().then(M,b)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$G_b=N;class R extends N{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$H_b=R}),define(Ie[35],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uw=e.$rw=void 0,e.$sw=R,e.$tw=O;class I{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++I.count}}e.$rw=I;const N=[];function R(b){const p=new I(b);return N[p.nid]=p,p}function O(b){return N[b].sid}class M{constructor(p){this.value=p}}e.$uw=M}),define(Ie[4],Ce([1,0,35]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$ZM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var R;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(R||(e.TabInputKind=R={}));var O;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var M;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var b;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var p;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var E;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var F;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(F||(e.CandidatePortSource=F={}));class D{static{this.a=0}static mixin(o){return o._id=D.a++,o}}e.$ZM=D;var d;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(d||(e.ISuggestDataDtoField=d={}));var v;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var m;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.$1M={MainThreadAuthentication:(0,I.$sw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$sw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,I.$sw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,I.$sw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$sw)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$sw)("MainThreadClipboard"),MainThreadCommands:(0,I.$sw)("MainThreadCommands"),MainThreadComments:(0,I.$sw)("MainThreadComments"),MainThreadConfiguration:(0,I.$sw)("MainThreadConfiguration"),MainThreadConsole:(0,I.$sw)("MainThreadConsole"),MainThreadDebugService:(0,I.$sw)("MainThreadDebugService"),MainThreadDecorations:(0,I.$sw)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$sw)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$sw)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$sw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$sw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$sw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$sw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$sw)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$sw)("MainThreadErrors"),MainThreadTreeViews:(0,I.$sw)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$sw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$sw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$sw)("MainThreadLanguages"),MainThreadLogger:(0,I.$sw)("MainThreadLogger"),MainThreadMessageService:(0,I.$sw)("MainThreadMessageService"),MainThreadOutputService:(0,I.$sw)("MainThreadOutputService"),MainThreadProgress:(0,I.$sw)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$sw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$sw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$sw)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$sw)("MainThreadSecretState"),MainThreadStorage:(0,I.$sw)("MainThreadStorage"),MainThreadSpeech:(0,I.$sw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$sw)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$sw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,I.$sw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,I.$sw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$sw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$sw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$sw)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$sw)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$sw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$sw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$sw)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$sw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$sw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$sw)("MainThreadExtensionService"),MainThreadSCM:(0,I.$sw)("MainThreadSCM"),MainThreadSearch:(0,I.$sw)("MainThreadSearch"),MainThreadShare:(0,I.$sw)("MainThreadShare"),MainThreadTask:(0,I.$sw)("MainThreadTask"),MainThreadWindow:(0,I.$sw)("MainThreadWindow"),MainThreadLabelService:(0,I.$sw)("MainThreadLabelService"),MainThreadNotebook:(0,I.$sw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$sw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$sw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$sw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$sw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$sw)("MainThreadInteractive"),MainThreadInlineChat:(0,I.$sw)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$sw)("MainThreadTheming"),MainThreadTunnelService:(0,I.$sw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$sw)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$sw)("MainThreadTimeline"),MainThreadTesting:(0,I.$sw)("MainThreadTesting"),MainThreadLocalization:(0,I.$sw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$sw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$sw)("MainThreadAiEmbeddingVector")},e.$2M={ExtHostCommands:(0,I.$sw)("ExtHostCommands"),ExtHostConfiguration:(0,I.$sw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$sw)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$sw)("ExtHostDebugService"),ExtHostDecorations:(0,I.$sw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$sw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$sw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$sw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$sw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$sw)("ExtHostEditors"),ExtHostTreeViews:(0,I.$sw)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$sw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$sw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$sw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$sw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$sw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$sw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$sw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$sw)("ExtHostStatusBar"),ExtHostShare:(0,I.$sw)("ExtHostShare"),ExtHostExtensionService:(0,I.$sw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$sw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$sw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,I.$sw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,I.$sw)("ExtHostSCM"),ExtHostSearch:(0,I.$sw)("ExtHostSearch"),ExtHostTask:(0,I.$sw)("ExtHostTask"),ExtHostWorkspace:(0,I.$sw)("ExtHostWorkspace"),ExtHostWindow:(0,I.$sw)("ExtHostWindow"),ExtHostWebviews:(0,I.$sw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$sw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$sw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$sw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$sw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$sw)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$sw)("ExtHostProgress"),ExtHostComments:(0,I.$sw)("ExtHostComments"),ExtHostSecretState:(0,I.$sw)("ExtHostSecretState"),ExtHostStorage:(0,I.$sw)("ExtHostStorage"),ExtHostUrls:(0,I.$sw)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$sw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$sw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$sw)("ExtHostOutputService"),ExtHostLabelService:(0,I.$sw)("ExtHostLabelService"),ExtHostNotebook:(0,I.$sw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$sw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$sw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$sw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$sw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$sw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$sw)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$sw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,I.$sw)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$sw)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$sw)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$sw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$sw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$sw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$sw)("ExtHostTheming"),ExtHostTunnelService:(0,I.$sw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$sw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$sw)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$sw)("ExtHostTimeline"),ExtHostTesting:(0,I.$sw)("ExtHostTesting"),ExtHostTelemetry:(0,I.$sw)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$sw)("ExtHostLocalization")}}),define(Ie[80],Ce([1,0,3,12,4,17]),function(le,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=e.$4kc=e.$3kc=void 0,e.$3kc=(0,I.$vi)("IExtHostApiDeprecationService");let M=class{constructor(p,E){this.c=E,this.a=new Set,this.b=p.getProxy(R.$1M.MainThreadTelemetry)}report(p,E,F){const D=this.d(p,E);this.a.has(D)||(this.a.add(D),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${F}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:p}))}d(p,E){return`${p}-${E.identifier.value}`}};e.$4kc=M,e.$4kc=M=Je([We(0,O.$oP),We(1,N.$2j)],M),e.$5kc=Object.freeze(new class{report(b,p,E){}})}),define(Ie[243],Ce([1,0,4]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=void 0;class N{constructor(O){const M=O.getProxy(I.$1M.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(b){return M.$writeText(b)}})}}e.$flc=N}),define(Ie[244],Ce([1,0,25,4,27,17]),function(le,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=void 0;let M=class{constructor(F,D){this.a=F.getProxy(N.$1M.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(F,D){const d=this,v=console[F];Object.defineProperty(console,F,{set:()=>{},get:()=>function(){d.e(F,D,v,arguments)}})}e(F,D,d,v){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:p(v,this.b)}),this.c&&this.f(F,d,v)}};e.$_mc=M,e.$_mc=M=Je([We(0,O.$oP),We(1,R.$EP)],M);const b=1e5;function p(E,F){const D=[];if(E.length)for(let d=0;d<E.length;d++){let v=E[d];if(typeof v>"u")v="undefined";else if(v instanceof Error){const m=v;m.stack?v=m.stack:v=m.toString()}D.push(v)}if(F){const d=new Error().stack;d&&D.push({__$stack:d.split(`
`).slice(3).join(`
`)})}try{const d=(0,I.$7n)(D);return d.length>b?"Output omitted for a large object that exceeds the limits":d}catch(d){return`Output omitted for an object that cannot be inspected ('${d.toString()}')`}}}),define(Ie[245],Ce([1,0,2,4,26]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=void 0;class O{constructor(b){this.a=b.getProxy(N.$1M.MainThreadDialogs)}showOpenDialog(b,p){return p?.allowUIResources&&(0,R.$GG)(b,"showLocal"),this.a.$showOpenDialog(p).then(E=>E?E.map(F=>I.URI.revive(F)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then(p=>p?I.URI.revive(p):void 0)}}e.$cmc=O}),define(Ie[246],Ce([1,0,6,4]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=void 0;class R{constructor(M){this.b=0,this.a=M.getProxy(N.$1M.MainThreadLabelService)}$registerResourceLabelFormatter(M){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,M),(0,I.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$wmc=R}),define(Ie[81],Ce([1,0,22,13,2,3,12,4,27,17]),function(le,e,I,N,R,O,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=e.$Wlc=void 0;let F=class{constructor(d,v,m){this.f=m,this.d=new Map,this.a=v.getProxy(b.$1M.MainThreadLocalization),this.b=d.environment.appLanguage,this.c=this.b===I.$g}getMessage(d,v){const{message:m,args:r,comment:o}=v;if(this.c)return(0,N.$9e)(m,r??{});let s=m;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const i=this.d.get(d)?.contents[s];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,N.$9e)(i??m,r??{})}getBundle(d){return this.d.get(d)?.contents}getBundleUri(d){return this.d.get(d)?.uri}async initializeLocalizedMessages(d){if(this.c||!d.l10n&&!d.isBuiltin||this.d.has(d.identifier.value))return;let v;const m=await this.g(d);if(!m){this.f.error(`No bundle location found for extension ${d.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(m),o=JSON.parse(r);v=d.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${d.identifier.value} from ${m}: ${r.message}`);return}v&&this.d.set(d.identifier.value,{contents:v,uri:m})}async g(d){if(d.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(d.identifier.value,this.b);return R.URI.revive(v)}return d.l10n?R.URI.joinPath(d.extensionLocation,d.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Wlc=F,e.$Wlc=F=Je([We(0,p.$EP),We(1,E.$oP),We(2,M.$2j)],F),e.$Xlc=(0,O.$vi)("IExtHostLocalizationService")}),define(Ie[247],Ce([1,0,12,4,27,17,2,49]),function(le,e,I,N,R,O,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=void 0;let p=class extends I.$ak{constructor(D,d){super(d.logLevel,d.logsLocation,d.loggers.map(v=>(0,b.$5h)(v))),this.r=D.getProxy(N.$1M.MainThreadLogger)}$setLogLevel(D,d){d?this.setLogLevel(M.URI.revive(d),D):this.setLogLevel(D)}setVisibility(D,d){super.setVisibility(D,d),this.r.$setVisibility(D,d)}s(D,d,v){return new E(this.r,D,d,v)}};e.$$mc=p,e.$$mc=p=Je([We(0,O.$oP),We(1,R.$EP)],p);class E extends I.$8j{constructor(D,d,v,m){super(m?.logLevel==="always"),this.r=D,this.s=d,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(d,m).then(()=>{this.u(this.n),this.m=!0})}g(D,d){const v=[[D,d]];this.m?this.u(v):this.n.push(...v)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Ie[82],Ce([1,0,4,3,6,17,21]),function(le,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=e.$Ylc=void 0,e.$Ylc=(0,N.$vi)("IExtHostManagedSockets");let b=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(I.$1M.MainThreadManagedSockets)}setFactory(D,d){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(D,d),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const d=++this.b,v=await this.c.makeConnection(),m=new R.$Uc;return this.d.set(d,new E(d,v,m)),m.add((0,R.$Tc)(()=>this.d.delete(d))),m.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(d),m.dispose()})),m.add(v.onDidClose(r=>{this.a.$onDidManagedSocketClose(d,r?.stack??r?.message),m.dispose()})),m.add(v.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(d,M.$Fe.wrap(r)))),d}$remoteSocketWrite(D,d){this.d.get(D)?.actual.send(d.buffer)}$remoteSocketEnd(D){const d=this.d.get(D);d&&(d.actual.end(),d.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$Zlc=b,e.$Zlc=b=Je([We(0,O.$oP)],b);class p{constructor(D,d){this.socketFactoryId=D,this.makeConnection=d}}class E extends R.$Vc{constructor(D,d,v){super(),this.socketId=D,this.actual=d,this.B(v)}}}),define(Ie[248],Ce([1,0,4,12,26]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ymc=void 0;function O(b){return b&&b.title}let M=class{constructor(p,E){this.b=E,this.a=p.getProxy(I.$1M.MainThreadMessageService)}showMessage(p,E,F,D,d){const v={source:{identifier:p.identifier,label:p.displayName||p.name}};let m;typeof D=="string"||O(D)?m=[D,...d]:(v.modal=D?.modal,v.useCustom=D?.useCustom,v.detail=D?.detail,m=d),v.useCustom&&(0,R.$GG)(p,"resolvers");const r=[];let o=!1;for(let s=0;s<m.length;s++){const i=m[s];if(typeof i=="string")r.push({title:i,handle:s,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:c}=i;r.push({title:n,isCloseAffordance:!!c,handle:s}),c&&(o?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,i):o=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,i)}return this.a.$showMessage(E,F,v,r).then(s=>{if(typeof s=="number")return m[s]})}};e.$ymc=M,e.$ymc=M=Je([We(1,N.$2j)],M)}),define(Ie[249],Ce([1,0,6,15,2,26,4]),function(le,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;class b{constructor(E){this.b=new Map,this.a=E.getProxy(M.$1M.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,F,D){if((0,O.$GG)(E,"profileContentHandlers"),this.b.has(F))throw new Error(`Handler with id '${F}' already registered`);return this.b.set(F,D),this.a.$registerProfileContentHandler(F,D.name,D.description,E.identifier.value),(0,I.$Tc)(()=>{this.b.delete(F),this.a.$unregisterProfileContentHandler(F)})}async $saveProfile(E,F,D,d){const v=this.b.get(E);if(!v)throw new Error(`Unknown handler with id: ${E}`);return v.saveProfile(F,D,d)}async $readProfile(E,F,D){const d=this.b.get(E);if(!d)throw new Error(`Unknown handler with id: ${E}`);return d.readProfile((0,N.$8f)(F)?F:R.URI.revive(F),D)}}e.$Hmc=b}),define(Ie[83],Ce([1,0,4,5,3]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=e.$Tlc=void 0;class O{constructor(b){this.b=new N.$ee,this.onDidChangePassword=this.b.event,this.a=b.getProxy(I.$1M.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,p){return this.a.$getPassword(b,p)}store(b,p,E){return this.a.$setPassword(b,p,E)}delete(b,p){return this.a.$deletePassword(b,p)}}e.$Tlc=O,e.$Ulc=(0,R.$vi)("IExtHostSecretState")}),define(Ie[250],Ce([1,0,24,6,4]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=void 0;class O{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(R.$1M.MainThreadSpeech)}async $createSpeechToTextSession(b,p,E){const F=this.c.get(b);if(!F)return;const D=new N.$Uc,d=new I.$pe;this.d.set(p,d);const v=D.add(F.provideSpeechToTextSession(d.token,E?{language:E}:void 0));D.add(v.onDidChange(m=>{d.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,m)})),D.add(d.token.onCancellationRequested(()=>D.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}async $createKeywordRecognitionSession(b,p){const E=this.c.get(b);if(!E)return;const F=new N.$Uc,D=new I.$pe;this.d.set(p,D);const d=F.add(E.provideKeywordRecognitionSession(D.token));F.add(d.onDidChange(v=>{D.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,v)})),F.add(D.token.onCancellationRequested(()=>F.dispose()))}async $cancelKeywordRecognitionSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,p,E){const F=O.a++;return this.c.set(F,E),this.b.$registerProvider(F,p,{extension:b,displayName:b.value}),(0,N.$Tc)(()=>{this.b.$unregisterProvider(F),this.c.delete(F)})}}e.$Omc=O}),define(Ie[84],Ce([1,0,4,5,3]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=e.$Jlc=void 0;class O{constructor(b,p){this.c=p,this.b=new N.$ee,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(I.$1M.MainThreadStorage)}registerExtensionStorageKeysToSync(b,p){this.a.$registerExtensionStorageKeysToSync(b,p)}async initializeExtensionStorage(b,p,E){const F=await this.a.$initializeExtensionStorage(b,p);let D;return F&&(D=this.d(b,p,F)),D||E}setValue(b,p,E){return this.a.$setValue(b,p,E)}$acceptValue(b,p,E){const F=this.d(b,p,E);F&&this.b.fire({shared:b,key:p,value:F})}d(b,p,E){try{return JSON.parse(E)}catch(F){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${b}): ${F}`)}}}e.$Jlc=O,e.$Klc=(0,R.$vi)("IExtHostStorage")}),define(Ie[251],Ce([1,0,6,16,2,4]),function(le,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=void 0;class M{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(O.$1M.MainThreadUriOpeners)}registerExternalUriOpener(p,E,F,D){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const d=D.schemes.find(v=>!M.a.has(v));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this.c.set(E,F),this.b.$registerUriOpener(E,D.schemes,p,D.label),(0,I.$Tc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(p,E,F){const D=this.c.get(p);if(!D)throw new Error(`Unknown opener with id: ${p}`);const d=R.URI.revive(E);return D.canOpenExternalUri(d,F)}async $openUri(p,E,F){const D=this.c.get(p);if(!D)throw new Error(`Unknown opener id: '${p}'`);return D.openExternalUri(R.URI.revive(E.resolvedUri),{sourceUri:R.URI.revive(E.sourceUri)},F)}}e.$5mc=M}),define(Ie[252],Ce([1,0,4,2,6,14,20]),function(le,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=void 0;class b{static{this.a=0}constructor(E){this.c=new M.$Rm,this.d=new Map,this.b=E.getProxy(I.$1M.MainThreadUrls)}registerUriHandler(E,F){const D=E.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const d=b.a++;return this.c.add(D),this.d.set(d,F),this.b.$registerUriHandler(d,D,E.displayName||E.name),(0,R.$Tc)(()=>{this.c.delete(D),this.d.delete(d),this.b.$unregisterUriHandler(d)})}$handleExternalUri(E,F){const D=this.d.get(E);if(!D)return Promise.resolve(void 0);try{D.handleUri(N.URI.revive(F))}catch(d){(0,O.$1)(d)}return Promise.resolve(void 0)}async createAppUri(E){return N.URI.revive(await this.b.$createAppUri(E))}}e.$6mc=b}),define(Ie[64],Ce([1,0,5,6,16,25,2,197,221,78,4]),function(le,e,I,N,R,O,M,b,p,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=e.$ulc=void 0,e.$vlc=d,e.$xlc=r,e.$ylc=o;class D{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,h,t,f,a,g,u){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$ee,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$ee,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#o=t,this.#n=f,this.#s=a,this.#r=g,this.#l=d(g),this.#d=v(g),this.#i=u}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,E.$4yb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===R.Schemas.https||c.scheme===R.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+E.$3yb}return E.$3yb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),O.$6n(this.#o,c)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const h=(0,p.$Cpb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#r.extensionLocation?.scheme===R.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===R.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,a,g,u,S,l)=>{const w=M.URI.from({scheme:u||"file",path:decodeURIComponent(S)}),$=(0,E.$4yb)(w,{isRemote:h,authority:t}).toString();return`${a}${$}${l}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,a,g,u,S,l)=>{const w=M.URI.from({scheme:u||"file",path:decodeURIComponent(S)}),$=(0,E.$4yb)(w,{isRemote:h,authority:t}).toString();return`${a}${$}${l}`})}}e.$ulc=D;function d(n){try{const c=(0,b.$Hp)((0,b.$Gp)(n.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function v(n){try{const c=(0,b.$Hp)((0,b.$Gp)(n.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class m extends N.$Vc{constructor(c,h,t,f,a){super(),this.c=h,this.f=t,this.g=f,this.h=a,this.b=new Map,this.a=c.getProxy(F.$1M.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,t){const f=this.j(c);if(f){const{message:a}=(0,p.$Dpb)(h,t.value);f._onMessageEmitter.fire(a)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,t){const f=new D(c,this.a,s(h),this.c,this.f,t,this.h);this.b.set(c,f);const a=f._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return f}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$wlc=m;function r(n){return{id:n.identifier,location:n.extensionLocation}}function o(n,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||i(n,c)}}function s(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(c=>M.URI.from(c))}}function i(n,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),n.extensionLocation]}}),define(Ie[111],Ce([1,0,5,16,13,2,3,17,4]),function(le,e,I,N,R,O,M,b,p){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$9mc=e.$8mc=void 0;let F=class{static{E=this}static{this.a={focused:!0,active:!0}}getState(){const d=this.d;return{get focused(){return d.focused},get active(){return d.active}}}constructor(d){this.c=new I.$ee,this.onDidChangeWindowState=this.c.event,this.d=E.a,this.b=d.getProxy(p.$1M.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:m})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",m)})}$onDidChangeWindowFocus(d){this.onDidChangeWindowProperty("focused",d)}$onDidChangeWindowActive(d){this.onDidChangeWindowProperty("active",d)}onDidChangeWindowProperty(d,v){v!==this.d[d]&&(this.d={...this.d,[d]:v},this.c.fire(this.d))}openUri(d,v){let m;if(typeof d=="string"){m=d;try{d=O.URI.parse(d)}catch{return Promise.reject(`Invalid uri - '${d}'`)}}return(0,R.$7e)(d.scheme)?Promise.reject("Invalid scheme - cannot be empty"):d.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${d.scheme}'`):this.b.$openUri(d,m,v)}async asExternalUri(d,v){if((0,R.$7e)(d.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this.b.$asExternalUri(d,v);return O.URI.from(m)}};e.$8mc=F,e.$8mc=F=E=Je([We(0,b.$oP)],F),e.$9mc=(0,M.$vi)("IExtHostWindow")}),define(Ie[253],Ce([1,0,244,27,17]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=void 0;let O=class extends I.$_mc{constructor(b,p){super(b,p)}f(b,p,E){p.apply(console,E)}};e.$hpc=O,e.$hpc=O=Je([We(0,R.$oP),We(1,N.$EP)],O)}),define(Ie[254],Ce([1,0,11,21,24,14,5,6,150,242,35]),function(le,e,I,N,R,O,M,b,p,E,F){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$K_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$I_b=o,e.$J_b=s;function d(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const v="$$ref$$",m={[v]:-1};class r{constructor(C,P){this.jsonString=C,this.referencedBuffers=P}}function o(y,C=null,P=!1){const W=[];return{jsonString:(P?d:JSON.stringify)(y,(q,A)=>{if(typeof A>"u")return m;if(typeof A=="object"){if(A instanceof N.$Fe){const U=W.push(A)-1;return{[v]:U}}if(C)return C(q,A)}return A}),referencedBuffers:W}}function s(y,C,P){return JSON.parse(y,(W,V)=>{if(V){const q=V[v];if(typeof q=="number")return C[q];if(P&&V.$mid===1)return P.transformIncoming(V)}return V})}function i(y,C){return JSON.stringify(y,C)}function n(y){return y?(C,P)=>P&&P.$mid===1?y.transformOutgoing(P):P:null}var c;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},f=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class g extends b.$Vc{static{D=f}static{this.a=3*1e3}constructor(C,P=null,W=null){super(),this[D]=!0,this.b=this.B(new M.$ee),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=P,this.g=W,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,q=F.$rw.count;V<q;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$Hh(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const P=this.w[C];delete this.w[C],P.resolveErr(O.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+g.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+g.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,p.$An)(C,this.g):C}getProxy(C){const{nid:P,sid:W}=C;return this.s[P]||(this.s[P]=this.J(P,W)),this.s[P]}J(C,P){const W={get:(V,q)=>(typeof q=="string"&&!V[q]&&q.charCodeAt(0)===36&&(V[q]=(...A)=>this.U(C,q,A)),q===a?P:V[q])};return new Proxy(Object.create(null),W)}set(C,P){return this.m[C.nid]=P,P}assertRegistered(C){for(let P=0,W=C.length;P<W;P++){const V=C[P];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(C){if(this.j)return;const P=C.byteLength,W=S.read(C,0),V=W.readUInt8(),q=W.readUInt32();switch(V){case 1:case 2:{let{rpcId:A,method:U,args:K}=w.deserializeRequestJSONArgs(W);this.g&&(K=(0,p.$An)(K,this.g)),this.M(P,q,A,U,K,V===2);break}case 3:case 4:{let{rpcId:A,method:U,args:K}=w.deserializeRequestMixedArgs(W);this.g&&(K=(0,p.$An)(K,this.g)),this.M(P,q,A,U,K,V===4);break}case 5:{this.f?.logIncoming(P,q,0,"ack"),this.G(q);break}case 6:{this.N(P,q);break}case 7:{this.O(P,q,void 0);break}case 9:{let A=w.deserializeReplyOKJSON(W);this.g&&(A=(0,p.$An)(A,this.g)),this.O(P,q,A);break}case 10:{const A=w.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(P,q,A);break}case 8:{const A=w.deserializeReplyOKVSBuffer(W);this.O(P,q,A);break}case 11:{let A=w.deserializeReplyErrError(W);this.g&&(A=(0,p.$An)(A,this.g)),this.P(P,q,A);break}case 12:{this.P(P,q,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,P,W,V,q,A){this.f?.logIncoming(C,P,1,`receiveRequest ${(0,F.$tw)(W)}.${V}(`,q);const U=String(P);let K,re;if(A){const ye=new R.$pe;q.push(ye.token),K=this.Q(W,V,q),re=()=>ye.cancel()}else K=this.Q(W,V,q),re=t;this.u[U]=re;const ae=w.serializeAcknowledged(P);this.f?.logOutgoing(ae.byteLength,P,1,"ack"),this.c.send(ae),K.then(ye=>{delete this.u[U];const Pe=w.serializeReplyOK(P,ye,this.h);this.f?.logOutgoing(Pe.byteLength,P,1,"reply:",ye),this.c.send(Pe)},ye=>{delete this.u[U];const Pe=w.serializeReplyErr(P,ye);this.f?.logOutgoing(Pe.byteLength,P,1,"replyErr:",ye),this.c.send(Pe)})}N(C,P){this.f?.logIncoming(C,P,1,"receiveCancel");const W=String(P);this.u[W]?.()}O(C,P,W){this.f?.logIncoming(C,P,0,"receiveReply:",W);const V=String(P);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V],q.resolveOk(W)}P(C,P,W){this.f?.logIncoming(C,P,0,"receiveReplyErr:",W);const V=String(P);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V];let A;W&&(W.$isError?(A=new Error,A.name=W.name,A.message=W.message,A.stack=W.stack):A=W),q.resolveErr(A)}Q(C,P,W){try{return Promise.resolve(this.S(C,P,W))}catch(V){return Promise.reject(V)}}S(C,P,W){const V=this.m[C];if(!V)throw new Error("Unknown actor "+(0,F.$tw)(C));const q=V[P];if(typeof q!="function")throw new Error("Unknown method "+P+" on actor "+(0,F.$tw)(C));return q.apply(V,W)}U(C,P,W){if(this.j)return new E.$H_b;let V=null;if(W.length>0&&R.CancellationToken.isCancellationToken(W[W.length-1])&&(V=W.pop()),V&&V.isCancellationRequested)return Promise.reject(O.$6());const q=w.serializeRequestArguments(W,this.h),A=++this.t,U=String(A),K=new E.$G_b,re=new b.$Uc;V&&re.add(V.onCancellationRequested(()=>{const ye=w.serializeCancel(A);this.f?.logOutgoing(ye.byteLength,A,0,"cancel"),this.c.send(w.serializeCancel(A))})),this.w[U]=new u(K,re),this.F(A);const ae=w.serializeRequest(A,C,P,q,!!V);return this.f?.logOutgoing(ae.byteLength,A,0,`request: ${(0,F.$tw)(C)}.${P}(`,W),this.c.send(ae),K}}e.$K_b=g;class u{constructor(C,P){this.a=C,this.b=P}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class S{static alloc(C,P,W){const V=new S(N.$Fe.alloc(W+1+4),0);return V.writeUInt8(C),V.writeUInt32(P),V}static read(C,P){return new S(C,P)}get buffer(){return this.a}constructor(C,P){this.a=C,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+C).toString();return this.b+=C,W}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+C).toString();return this.b+=C,W}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+C);return this.b+=C,P}static sizeMixedArray(C){let P=0;P+=1;for(let W=0,V=C.length;W<V;W++){const q=C[W];switch(P+=1,q.type){case 1:P+=this.sizeLongString(q.value);break;case 2:P+=this.sizeVSBuffer(q.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(q.value);for(let A=0;A<q.buffers.length;++A)P+=this.sizeVSBuffer(q.buffers[A]);break;case 4:break}}return P}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let P=0,W=C.length;P<W;P++){const V=C[P];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let q=0;q<V.buffers.length;++q)this.writeBuffer(V.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const P=new Array(C);for(let W=0;W<C;W++)switch(this.readUInt8()){case 1:P[W]=this.readLongString();break;case 2:P[W]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),A=this.readLongString(),U=[];for(let K=0;K<q;++K)U.push(this.readVSBuffer());P[W]=new F.$uw(s(A,U,null));break}case 4:P[W]=void 0;break}return P}}var l;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(l||(l={}));class w{static a(C){for(let P=0,W=C.length;P<W;P++)if(C[P]instanceof N.$Fe||C[P]instanceof F.$uw||typeof C[P]>"u")return!0;return!1}static serializeRequestArguments(C,P){if(this.a(C)){const W=[];for(let V=0,q=C.length;V<q;V++){const A=C[V];if(A instanceof N.$Fe)W[V]={type:2,value:A};else if(typeof A>"u")W[V]={type:4};else if(A instanceof F.$uw){const{jsonString:U,referencedBuffers:K}=o(A.value,P);W[V]={type:3,value:N.$Fe.fromString(U),buffers:K}}else W[V]={type:1,value:N.$Fe.fromString(i(A,P))}}return{type:1,args:W}}return{type:0,args:i(C,P)}}static serializeRequest(C,P,W,V,q){switch(V.type){case 0:return this.b(C,P,W,V.args,q);case 1:return this.c(C,P,W,V.args,q)}}static b(C,P,W,V,q){const A=N.$Fe.fromString(W),U=N.$Fe.fromString(V);let K=0;K+=S.sizeUInt8(),K+=S.sizeShortString(A),K+=S.sizeLongString(U);const re=S.alloc(q?2:1,C,K);return re.writeUInt8(P),re.writeShortString(A),re.writeLongString(U),re.buffer}static deserializeRequestJSONArgs(C){const P=C.readUInt8(),W=C.readShortString(),V=C.readLongString();return{rpcId:P,method:W,args:JSON.parse(V)}}static c(C,P,W,V,q){const A=N.$Fe.fromString(W);let U=0;U+=S.sizeUInt8(),U+=S.sizeShortString(A),U+=S.sizeMixedArray(V);const K=S.alloc(q?4:3,C,U);return K.writeUInt8(P),K.writeShortString(A),K.writeMixedArray(V),K.buffer}static deserializeRequestMixedArgs(C){const P=C.readUInt8(),W=C.readShortString(),V=C.readMixedArray(),q=new Array(V.length);for(let A=0,U=V.length;A<U;A++){const K=V[A];typeof K=="string"?q[A]=JSON.parse(K):q[A]=K}return{rpcId:P,method:W,args:q}}static serializeAcknowledged(C){return S.alloc(5,C,0).buffer}static serializeCancel(C){return S.alloc(6,C,0).buffer}static serializeReplyOK(C,P,W){if(typeof P>"u")return this.d(C);if(P instanceof N.$Fe)return this.e(C,P);if(P instanceof F.$uw){const{jsonString:V,referencedBuffers:q}=o(P.value,W,!0);return this.g(C,V,q)}else return this.f(C,d(P,W))}static d(C){return S.alloc(7,C,0).buffer}static e(C,P){let W=0;W+=S.sizeVSBuffer(P);const V=S.alloc(8,C,W);return V.writeVSBuffer(P),V.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,P){const W=N.$Fe.fromString(P);let V=0;V+=S.sizeLongString(W);const q=S.alloc(9,C,V);return q.writeLongString(W),q.buffer}static g(C,P,W){const V=N.$Fe.fromString(P);let q=0;q+=S.sizeUInt32,q+=S.sizeLongString(V);for(const U of W)q+=S.sizeVSBuffer(U);const A=S.alloc(10,C,q);A.writeUInt32(W.length),A.writeLongString(V);for(const U of W)A.writeBuffer(U);return A.buffer}static deserializeReplyOKJSON(C){const P=C.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(C,P){const W=C.readUInt32(),V=C.readLongString(),q=[];for(let A=0;A<W;++A)q.push(C.readVSBuffer());return new F.$uw(s(V,q,P))}static serializeReplyErr(C,P){const W=P?d(O.$3(P),null):void 0;if(typeof W!="string")return this.h(C);const V=N.$Fe.fromString(W);let q=0;q+=S.sizeLongString(V);const A=S.alloc(11,C,q);return A.writeLongString(V),A.buffer}static deserializeReplyErrError(C){const P=C.readLongString();return JSON.parse(P)}static h(C){return S.alloc(12,C,0).buffer}}var $;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var k;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(k||(k={}))}),define(Ie[255],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jpc=void 0;const I=function(O){const M=b=>{globalThis.removeEventListener("message",M);const p=b.data;Object.defineProperties(globalThis,{postMessage:{value(E,F){p.postMessage(E,F)}},onmessage:{get(){return p.onmessage},set(E){p.onmessage=E}}}),p.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),p.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",M)}.toString();class N extends EventTarget{constructor(O,M,b){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const p=`((${I})('${M}'))`,E=new Blob([p],{type:"application/javascript"}),F=URL.createObjectURL(E),D=new MessageChannel,d=F,v={type:"_newWorker",id:d,port:D.port2,url:F,options:b};O(v,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{O({type:"_terminateWorker",id:d}),URL.revokeObjectURL(F),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(m){D.port1.onmessage=m}},onmessageerror:{get(){return D.port1.onmessageerror},set(m){D.port1.onmessageerror=m}}}),D.port1.addEventListener("messageerror",m=>{const r=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(r)}),D.port1.addEventListener("message",m=>{const r=new MessageEvent("message",{data:m.data});this.dispatchEvent(r)}),D.port1.start()}}e.$jpc=N}),define(Ie[256],Ce([1,0,21,28,16,56,3]),function(le,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FK=e.$CK=void 0,e.$DK=F,e.$EK=D,e.$CK=(0,M.$vi)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${b.join("")}]+`),E=7;function F(v){if(v.scheme!==R.Schemas.vscodeNotebookCell)return;const m=v.fragment.indexOf("s");if(m<0)return;const r=parseInt(v.fragment.substring(0,m).replace(p,""),E),o=(0,I.$Ye)(v.fragment.substring(m+1)).toString();if(!isNaN(r))return{handle:r,notebook:v.with({scheme:o,fragment:null})}}function D(v,m){const r=m.toString(E),s=`${r.length<b.length?b[r.length-1]:"z"}${r}s${(0,I.$Ze)(I.$Fe.fromString(v.scheme),!0,!0)}`;return v.with({scheme:R.Schemas.vscodeNotebookCell,fragment:s})}class d{constructor(){this.a=new N.$Bc}getNotebook(m){if(m.scheme===R.Schemas.vscodeNotebookCell){const r=F(m);if(r){const o=this.a.get(r.notebook);if(o)return o}}return this.a.get(m)}addNotebookDocument(m){this.a.set(m.uri,m)}removeNotebookDocument(m){this.a.delete(m.uri)}}e.$FK=d,(0,O.$ws)(e.$CK,d,1)}),define(Ie[85],Ce([1,0,21,36,41,70,16,19,22,31,256]),function(le,e,I,N,R,O,M,b,p,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZK=e.$WK=e.CellStatusbarAlignment=e.$VK=e.NotebookEditorPriority=e.$SK=e.$RK=e.$PK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$OK=e.$NK=e.$MK=e.$LK=e.CellKind=e.$KK=e.$JK=e.$IK=void 0,e.$QK=f,e.$TK=g,e.$UK=u,e.$XK=w,e.$YK=k,e.$IK="workbench.editor.notebook",e.$JK="workbench.editor.notebookTextDiffEditor",e.$KK="workbench.editor.interactive";var D;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(D||(e.CellKind=D={})),e.$LK=["application/json","application/javascript","text/html","image/svg+xml",O.$Ps.latex,O.$Ps.markdown,"image/png","image/jpeg",O.$Ps.text],e.$MK=[O.$Ps.latex,O.$Ps.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$Ps.text],e.$NK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$OK="_notAvailable";var d;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(d||(e.NotebookRunState=d={}));var v;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var m;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(m||(e.NotebookExecutionState=m={}));var r;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var s;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var i;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var c;(function(K){K.scheme=M.Schemas.vscodeNotebookCell;function re(Ae,ce){return(0,F.$EK)(Ae,ce)}K.generate=re;function ae(Ae){return(0,F.$DK)(Ae)}K.parse=ae;function ye(Ae,ce){return Ae.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${ce??""},${Ae.scheme!==M.Schemas.file?Ae.scheme:""}`})}K.generateCellOutputUri=ye;function Pe(Ae){if(Ae.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const ce=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Ae.fragment);if(!ce)return;const Me=ce[1]&&ce[1]!==""?ce[1]:void 0,ie=ce[2];return{outputId:Me,notebook:Ae.with({scheme:ie||M.Schemas.file,fragment:null})}}K.parseCellOutputUri=Pe;function fe(Ae,ce,Me){return K.generate(Ae,ce).with({scheme:Me})}K.generateCellPropertyUri=fe;function me(Ae,ce){if(Ae.scheme===ce)return K.parse(Ae.with({scheme:K.scheme}))}K.parseCellPropertyUri=me})(c||(e.CellUri=c={}));const h=K=>p.$i?K.replace(/\//g,"\\"):K;class t{constructor(re=[],ae=e.$LK){this.e=ae,this.d=[...new Set(re)].map(ye=>({pattern:ye,matches:N.$pk(h(ye))}))}sort(re){const ae=new Map(R.Iterable.map(re,Pe=>[Pe,h(Pe)]));let ye=[];for(const{matches:Pe}of this.d)for(const[fe,me]of ae)if(Pe(me)){ye.push(fe),ae.delete(fe);break}return ae.size&&(ye=ye.concat([...ae.keys()].sort((Pe,fe)=>this.e.indexOf(Pe)-this.e.indexOf(fe)))),ye}prioritize(re,ae){const ye=this.f(re);if(ye===-1){this.d.unshift({pattern:re,matches:N.$pk(h(re))});return}const Pe=new Set(ae.map(me=>this.f(me,ye)));Pe.delete(-1);const fe=Array.from(Pe).sort();this.d.splice(ye+1,0,...fe.map(me=>this.d[me]));for(let me=fe.length-1;me>=0;me--)this.d.splice(fe[me],1)}toArray(){return this.d.map(re=>re.pattern)}f(re,ae=this.d.length){const ye=h(re);for(let Pe=0;Pe<ae;Pe++)if(this.d[Pe].matches(ye))return Pe;return-1}}e.$PK=t;function f(K,re,ae,ye=(Pe,fe)=>Pe===fe){const Pe=[];function fe(ce,Me,ie){if(Me===0&&ie.length===0)return;const z=Pe[Pe.length-1];z&&z.start+z.deleteCount===ce?(z.deleteCount+=Me,z.toInsert.push(...ie)):Pe.push({start:ce,deleteCount:Me,toInsert:ie})}let me=0,Ae=0;for(;;){if(me===K.length){fe(me,0,re.slice(Ae));break}if(Ae===re.length){fe(me,K.length-me,[]);break}const ce=K[me],Me=re[Ae];if(ye(ce,Me)){me+=1,Ae+=1;continue}ae(Me)?(fe(me,1,[]),me+=1):(fe(me,0,[Me]),Ae+=1)}return Pe}e.$RK=new E.$Mj("notebookEditorCursorAtBoundary","none"),e.$SK=new E.$Mj("notebookEditorCursorAtLineBoundary","none");var a;(function(K){K.default="default",K.option="option"})(a||(e.NotebookEditorPriority=a={}));function g(K){const re=K;return!!((typeof re.include=="string"||N.$qk(re.include))&&(typeof re.exclude=="string"||N.$qk(re.exclude)))}function u(K,re,ae){if(Array.isArray(K.viewType)&&K.viewType.indexOf(re)>=0||K.viewType===re)return!0;if(K.filenamePattern){const ye=g(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,Pe=g(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(N.$ok(ye,(0,b.$oc)(ae.fsPath).toLowerCase()))return!(Pe&&N.$ok(Pe,(0,b.$oc)(ae.fsPath).toLowerCase()))}return!1}e.$VK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var S;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class l{static{this.d="notebook/"}static create(re){return`${l.d}${re}`}static parse(re){if(re.startsWith(l.d))return re.substring(l.d.length)}}e.$WK=l;function w(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const $=new TextDecoder;function k(K){const re=[];let ae=!1;for(const me of K)(re.length===0||ae)&&(re.push(me),ae=!0);let ye=P(re);const Pe=I.$Fe.concat(re.map(me=>I.$Fe.wrap(me))),fe=U(Pe);return ye=ye||fe.byteLength!==Pe.byteLength,{data:fe,didCompression:ye}}e.$ZK="\x1B[A";const y=e.$ZK.split("").map(K=>K.charCodeAt(0)),C=10;function P(K){let re=!1;return K.forEach((ae,ye)=>{if(ye===0||ae.length<e.$ZK.length)return;const Pe=K[ye-1],fe=ae.subarray(0,e.$ZK.length);if(fe[0]===y[0]&&fe[1]===y[1]&&fe[2]===y[2]){const me=Pe.lastIndexOf(C);if(me===-1)return;re=!0,K[ye-1]=Pe.subarray(0,me),K[ye]=ae.subarray(e.$ZK.length)}}),re}function W(K){let re=K;do K=re,re=K.replace(/[^\n]\x08/gm,"");while(re.length<K.length);return K}function V(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const re=K.match(/^(.*)\r+/m)[1];let ae=K.match(/\r+(.*)$/m)[1];ae=ae+re.slice(ae.length,re.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ae)}return K}const q=8,A=13;function U(K){return!K.buffer.includes(q)&&!K.buffer.includes(A)?K:I.$Fe.fromString(V(W($.decode(K.buffer))))}}),define(Ie[7],Ce([1,0,18,14,55,28,70,13,15,2,34,20,37,104,85]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m){"use strict";var r,o,s,i,n,c,h,t,f,a,g,u,S,l,w,$,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$cP=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$bP=e.$aP=e.$_O=e.$$O=e.ChatLocation=e.$0O=e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$YO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$LO=e.$KO=e.$JO=e.$IO=e.$GO=e.$FO=e.$EO=e.$DO=e.TestRunProfileKind=e.TestResultState=e.$CO=e.$BO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$AO=e.NotebookVariablesRequestKind=e.$zO=e.$yO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$xO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.ColorThemeKind=e.$rO=e.$qO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$pO=e.$oO=e.DebugConsoleMode=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$iO=e.$hO=e.FileChangeType=e.$gO=e.NewSymbolNameTag=e.$fO=e.$eO=e.$dO=e.$cO=e.InlineCompletionTriggerKind=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$2N=e.ConfigurationTarget=e.$1N=e.$ZN=e.$YN=e.$XN=e.DocumentPasteTriggerKind=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$QN=e.ViewBadge=e.ProgressLocation=e.$PN=e.$ON=e.TaskScope=e.ShellQuoting=e.$NN=e.$MN=e.$LN=e.TaskPanelKind=e.TaskRevealKind=e.$KN=e.TerminalLocation=e.$JN=e.$IN=e.$HN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$GN=e.$FN=e.$EN=e.$DN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$BN=e.$AN=e.$zN=e.$yN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$xN=e.$wN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.LanguageStatusSeverity=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.CodeActionTriggerKind=e.$kN=e.$jN=e.SymbolTag=e.SymbolKind=e.$iN=e.$hN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.DiagnosticSeverity=e.DiagnosticTag=e.$bN=e.$aN=e.FileEditType=e.$_M=e.$$M=e.$0M=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$CN=Yt,e.$3N=Ve,e.$HO=vn;function y(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const Ee=te.length===1?[]:te[1];return Reflect.construct(B,Ee,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[Ee,...He]=te;return Reflect.construct(B,He,Ee.constructor)}}})}var C;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var P;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let W=r=class{static from(...L){let te=L;return new r(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$3M=W,e.$3M=W=r=Je([y],W);let V=o=class{static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Ee=1;Ee<L.length;Ee++){const He=L[Ee];He.isBefore(te)&&(te=He)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Ee=1;Ee<L.length;Ee++){const He=L[Ee];He.isAfter(te)&&(te=He)}return te}static isPosition(L){if(!L)return!1;if(L instanceof o)return!0;const{line:te,character:Ee}=L;return typeof te=="number"&&typeof Ee=="number"}static of(L){if(L instanceof o)return L;if(this.isPosition(L))return new o(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,te){if(L<0)throw(0,N.$7)("line must be non-negative");if(te<0)throw(0,N.$7)("character must be non-negative");this.c=L,this.e=te}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,te=0){if(L===null||te===null)throw(0,N.$7)();let Ee;return typeof L>"u"?Ee=0:typeof L=="number"?Ee=L:(Ee=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),Ee===0&&te===0?this:new o(this.line+Ee,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,N.$7)();let Ee;return typeof L>"u"?Ee=this.line:typeof L=="number"?Ee=L:(Ee=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),Ee===this.line&&te===this.character?this:new o(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};e.$4M=V,e.$4M=V=o=Je([y],V);let q=s=class{static isRange(L){return L instanceof s?!0:L?V.isPosition(L.start)&&V.isPosition(L.end):!1}static of(L){if(L instanceof s)return L;if(this.isRange(L))return new s(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,te,Ee,He){let Xe,ht;if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof He=="number"?(Xe=new V(L,te),ht=new V(Ee,He)):V.isPosition(L)&&V.isPosition(te)&&(Xe=V.of(L),ht=V.of(te)),!Xe||!ht)throw new Error("Invalid arguments");Xe.isBefore(ht)?(this.c=Xe,this.e=ht):(this.c=ht,this.e=Xe)}contains(L){return s.isRange(L)?this.contains(L.start)&&this.contains(L.end):V.isPosition(L)?!(V.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const te=V.Max(L.start,this.c),Ee=V.Min(L.end,this.e);if(!te.isAfter(Ee))return new s(te,Ee)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=V.Min(L.start,this.c),Ee=V.Max(L.end,this.end);return new s(te,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,te=this.end){if(L===null||te===null)throw(0,N.$7)();let Ee;return L?V.isPosition(L)?Ee=L:(Ee=L.start||this.start,te=L.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&te.isEqual(this.end)?this:new s(Ee,te)}toJSON(){return[this.start,this.end]}};e.$5M=q,e.$5M=q=s=Je([y],q);let A=i=class extends q{static isSelection(L){return L instanceof i?!0:L?q.isRange(L)&&V.isPosition(L.anchor)&&V.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,te,Ee,He){let Xe,ht;if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof He=="number"?(Xe=new V(L,te),ht=new V(Ee,He)):V.isPosition(L)&&V.isPosition(te)&&(Xe=V.of(L),ht=V.of(te)),!Xe||!ht)throw new Error("Invalid arguments");super(Xe,ht),this.f=Xe,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$6M=A,e.$6M=A=i=Je([y],A);const U=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,N.$7)("connectionToken")};class K{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,te,Ee){if(typeof L!="string"||L.length===0)throw(0,N.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,N.$7)("port");typeof Ee<"u"&&U(Ee),this.host=L,this.port=Math.round(te),this.connectionToken=Ee}}e.$7M=K;class re{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,te){this.makeConnection=L,this.connectionToken=te,typeof te<"u"&&U(te)}}e.$8M=re;class ae extends Error{static NotAvailable(L,te){return new ae(L,v.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new ae(L,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,te=v.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(L),this._message=L,this._code=te,this._detail=Ee,Object.setPrototypeOf(this,ae.prototype)}}e.$9M=ae;var ye;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var Pe;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Pe||(e.EnvironmentVariableMutatorType=Pe={}));let fe=n=class{static isTextEdit(L){return L instanceof n?!0:L?q.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new n(L,te)}static insert(L,te){return n.replace(new q(L,L),te)}static delete(L){return n.replace(L,"")}static setEndOfLine(L){const te=new n(new q(new V(0,0),new V(0,0)),"");return te.newEol=L,te}get range(){return this.c}set range(L){if(L&&!q.isRange(L))throw(0,N.$7)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,N.$7)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,N.$7)("newEol");this.f=L}constructor(L,te){this.c=L,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$0M=fe,e.$0M=fe=n=Je([y],fe);let me=c=class{static isNotebookCellEdit(L){return L instanceof c?!0:L?di.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,te){return new c(L,te)}static insertCells(L,te){return new c(new di(L,L),te)}static deleteCells(L){return new c(L,[])}static updateCellMetadata(L,te){const Ee=new c(new di(L,L),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(L){const te=new c(new di(0,0),[]);return te.newNotebookMetadata=L,te}constructor(L,te){this.range=L,this.newCells=te}};e.$$M=me,e.$$M=me=c=Je([y],me);class Ae{static isSnippetTextEdit(L){return L instanceof Ae?!0:L?q.isRange(L.range)&&ie.isSnippetString(L.snippet):!1}static replace(L,te){return new Ae(L,te)}static insert(L,te){return Ae.replace(new q(L,L),te)}constructor(L,te){this.range=L,this.snippet=te}}e.$_M=Ae;var ce;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(ce||(e.FileEditType=ce={}));let Me=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,te,Ee,He){this.c.push({_type:1,from:L,to:te,options:Ee,metadata:He})}createFile(L,te,Ee){this.c.push({_type:1,from:void 0,to:L,options:te,metadata:Ee})}deleteFile(L,te,Ee){this.c.push({_type:1,from:L,to:void 0,options:te,metadata:Ee})}e(L,te,Ee){this.c.push({_type:3,metadata:Ee,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}f(L,te,Ee,He){const Xe=te.start,ht=te.end;(Xe!==ht||Ee.length>0)&&this.c.push({_type:5,uri:L,index:Xe,count:ht-Xe,cells:Ee,metadata:He})}g(L,te,Ee,He){this.c.push({_type:3,metadata:He,uri:L,edit:{editType:3,index:te,metadata:Ee}})}replace(L,te,Ee,He){this.c.push({_type:2,uri:L,edit:new fe(te,Ee),metadata:He})}insert(L,te,Ee,He){this.replace(L,new q(te,te),Ee,He)}delete(L,te,Ee){this.replace(L,te,"",Ee)}has(L){return this.c.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const Ee of te){if(!Ee)continue;let He,Xe;Array.isArray(Ee)?(He=Ee[0],Xe=Ee[1]):He=Ee,me.isNotebookCellEdit(He)?He.newCellMetadata?this.g(L,He.range.start,He.newCellMetadata,Xe):He.newNotebookMetadata?this.e(L,He.newNotebookMetadata,Xe):this.f(L,He.range,He.newCells,Xe):Ae.isSnippetTextEdit(He)?this.c.push({_type:6,uri:L,range:He.range,edit:He.snippet,metadata:Xe}):this.c.push({_type:2,uri:L,edit:He,metadata:Xe})}else{for(let Ee=0;Ee<this.c.length;Ee++){const He=this.c[Ee];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===L.toString()&&(this.c[Ee]=void 0);break}}(0,I.$Ib)(this.c)}}get(L){const te=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===L.toString()&&te.push(Ee.edit);return te}entries(){const L=new O.$Bc;for(const te of this.c)if(te._type===2){let Ee=L.get(te.uri);Ee||(Ee=[te.uri,[]],L.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$aN=Me,e.$aN=Me=Je([y],Me);let ie=h=class{static isSnippetString(L){return L instanceof h?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=h.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this.e++){if(typeof L=="function"){const Ee=new h;Ee.e=this.e,L(Ee),this.e=Ee.e,L=Ee.value}else L=h.c(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this.e++){const Ee=L.map(He=>He.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const Ee=new h;Ee.e=this.e,te(Ee),this.e=Ee.e,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$bN=ie,e.$bN=ie=h=Je([y],ie);var z;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(z||(e.DiagnosticTag=z={}));var x;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let ve=t=class{static isLocation(L){return L instanceof t?!0:L?q.isRange(L.range)&&E.URI.isUri(L.uri):!1}constructor(L,te){if(this.uri=L,te)if(q.isRange(te))this.range=q.of(te);else if(V.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$cN=ve,e.$cN=ve=t=Je([y],ve);let Te=class{static is(L){return L?typeof L.message=="string"&&L.location&&q.isRange(L.location.range)&&E.URI.isUri(L.location.uri):!1}constructor(L,te){this.location=L,this.message=te}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};e.$dN=Te,e.$dN=Te=Je([y],Te);let De=class{constructor(L,te,Ee=x.Error){if(!q.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=Ee}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,I.$ub)(L.tags,te.tags)&&(0,I.$ub)(L.relatedInformation,te.relatedInformation,Te.isEqual)}};e.$eN=De,e.$eN=De=Je([y],De);let $e=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};e.$fN=$e,e.$fN=$e=Je([y],$e);let ge=class extends $e{constructor(L,te,Ee,He){super(L,te),this.canIncreaseHover=Ee,this.canDecreaseHover=He}};e.$gN=ge,e.$gN=ge=Je([y],ge);var Q;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(Q||(e.HoverVerbosityAction=Q={}));var X;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(X||(e.DocumentHighlightKind=X={}));let he=class{constructor(L,te=X.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:X[this.kind]}}};e.$hN=he,e.$hN=he=Je([y],he);let ue=class{constructor(L,te){this.uri=L,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(L=>L.toJSON())}}};e.$iN=ue,e.$iN=ue=Je([y],ue);var Fe;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Fe||(e.SymbolKind=Fe={}));var de;(function(B){B[B.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Re=f=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,te,Ee,He,Xe){this.name=L,this.kind=te,this.containerName=Xe,typeof Ee=="string"&&(this.containerName=Ee),He instanceof ve?this.location=He:Ee instanceof q&&(this.location=new ve(He,Ee)),f.validate(this)}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};e.$jN=Re,e.$jN=Re=f=Je([y],Re);let Ne=a=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(a.validate)}constructor(L,te,Ee,He,Xe){this.name=L,this.detail=te,this.kind=Ee,this.range=He,this.selectionRange=Xe,this.children=[],a.validate(this)}};e.$kN=Ne,e.$kN=Ne=a=Je([y],Ne);var Ue;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ue||(e.CodeActionTriggerKind=Ue={}));let j=class{constructor(L,te){this.title=L,this.kind=te}};e.$lN=j,e.$lN=j=Je([y],j);let T=class{static{g=this}static{this.c="."}constructor(L){this.value=L}append(L){return new g(this.value?this.value+g.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+g.c)}};e.$mN=T,e.$mN=T=g=Je([y],T),T.Empty=new T(""),T.QuickFix=T.Empty.append("quickfix"),T.Refactor=T.Empty.append("refactor"),T.RefactorExtract=T.Refactor.append("extract"),T.RefactorInline=T.Refactor.append("inline"),T.RefactorMove=T.Refactor.append("move"),T.RefactorRewrite=T.Refactor.append("rewrite"),T.Source=T.Empty.append("source"),T.SourceOrganizeImports=T.Source.append("organizeImports"),T.SourceFixAll=T.Source.append("fixAll"),T.Notebook=T.Empty.append("notebook");let G=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$nN=G,e.$nN=G=Je([y],G);class H{constructor(L,te,Ee,He,Xe,ht){this.kind=L,this.name=te,this.detail=Ee,this.uri=He,this.range=Xe,this.selectionRange=ht}}e.$oN=H;class ee{constructor(L,te){this.fromRanges=te,this.from=L}}e.$pN=ee;class ne{constructor(L,te){this.fromRanges=te,this.to=L}}e.$qN=ne;var Oe;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let Be=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};e.$rN=Be,e.$rN=Be=Je([y],Be);let Ke=u=class{#e;static isMarkdownString(L){return L instanceof u?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,te=!1){this.#e=new R.$Sk(L,{supportThemeIcons:te})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,te){return this.#e.appendCodeblock(te??"",L),this}};e.$sN=Ke,e.$sN=Ke=u=Je([y],Ke);let _e=class{constructor(L,te){this.label=L,this.documentation=te}};e.$tN=_e,e.$tN=_e=Je([y],_e);let xe=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};e.$uN=xe,e.$uN=xe=Je([y],xe);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$vN=et,e.$vN=et=Je([y],et);var tt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var nt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(nt||(e.InlayHintKind=nt={}));let ct=class{constructor(L){this.value=L}};e.$wN=ct,e.$wN=ct=Je([y],ct);let mt=class{constructor(L,te,Ee){this.position=L,this.label=te,this.kind=Ee}};e.$xN=mt,e.$xN=mt=Je([y],mt);var je;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je||(e.CompletionTriggerKind=je={}));var st;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(st||(e.CompletionItemKind=st={}));var Z;(function(B){B[B.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let Y=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&st[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$yN=Y,e.$yN=Y=Je([y],Y);let pe=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};e.$zN=pe,e.$zN=pe=Je([y],pe);let Ge=class{constructor(L,te,Ee){this.insertText=L,this.range=te,this.command=Ee}};e.$AN=Ge,e.$AN=Ge=Je([y],Ge);let we=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$BN=we,e.$BN=we=Je([y],we);var ot;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(ot||(e.PartialAcceptTriggerKind=ot={}));var dt;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(dt||(e.ViewColumn=dt={}));var Pt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Pt||(e.StatusBarAlignment=Pt={}));function Yt(B,L){return`${D.$Qm.toKey(B)}.${L}`}var zt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(zt||(e.TextEditorLineNumbersStyle=zt={}));var ri;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(ri||(e.TextDocumentSaveReason=ri={}));var Zt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Zt||(e.TextEditorRevealType=Zt={}));var St;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(St||(e.TextEditorSelectionChangeKind=St={}));var Xt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Xt||(e.TextDocumentChangeReason=Xt={}));var xt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(xt||(e.DecorationRangeBehavior=xt={})),function(B){function L(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=L}(St||(e.TextEditorSelectionChangeKind=St={}));var Ze;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Ze||(e.SyntaxTokenType=Ze={})),function(B){function L(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=L}(Ze||(e.SyntaxTokenType=Ze={}));let si=class{constructor(L,te){if(te&&!E.URI.isUri(te))throw(0,N.$7)("target");if(!q.isRange(L)||L.isEmpty)throw(0,N.$7)("range");this.range=L,this.target=te}};e.$DN=si,e.$DN=si=Je([y],si);let Wt=class{constructor(L,te,Ee,He){this.red=L,this.green=te,this.blue=Ee,this.alpha=He}};e.$EN=Wt,e.$EN=Wt=Je([y],Wt);let lt=class{constructor(L,te){if(te&&!(te instanceof Wt))throw(0,N.$7)("color");if(!q.isRange(L)||L.isEmpty)throw(0,N.$7)("range");this.range=L,this.color=te}};e.$FN=lt,e.$FN=lt=Je([y],lt);let bt=class{constructor(L){if(!L||typeof L!="string")throw(0,N.$7)("label");this.label=L}};e.$GN=bt,e.$GN=bt=Je([y],bt);var ei;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(ei||(e.ColorFormat=ei={}));var Kt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var Ot;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(Ot||(e.TerminalExitReason=Ot={}));var ft;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(ft||(e.TerminalShellExecutionCommandLineConfidence=ft={}));class jt{constructor(L,te,Ee){if(this.startIndex=L,this.length=te,this.tooltip=Ee,typeof L!="number"||L<0)throw(0,N.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,N.$7)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,N.$7)("tooltip")}}e.$HN=jt;class qt{constructor(L){this.uri=L}}e.$IN=qt;class Gt{constructor(L){this.terminalCommand=L}}e.$JN=Gt;var Qe;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class hi{constructor(L){if(this.options=L,typeof L!="object")throw(0,N.$7)("options")}}e.$KN=hi;var Jt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Jt||(e.TaskRevealKind=Jt={}));var Lt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(Lt||(e.TaskPanelKind=Lt={}));let gt=class{static{S=this}static{this.Clean=new S("clean","Clean")}static{this.Build=new S("build","Build")}static{this.Rebuild=new S("rebuild","Rebuild")}static{this.Test=new S("test","Test")}static from(L){switch(L){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,N.$7)("name");this.c=L}get id(){return this.c}};e.$LN=gt,e.$LN=gt=S=Je([y],gt);function Ut(B){let L="";for(let te=0;te<B.length;te++)L+=B[te].replace(/,/g,",,")+",";return L}let Ct=class{constructor(L,te,Ee){if(typeof L!="string")throw(0,N.$7)("process");this.e=[],this.c=L,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Ee):this.f=te)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,N.$7)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const te of this.e)L.push(te);return Ut(L)}};e.$MN=Ct,e.$MN=Ct=Je([y],Ct);let Ft=class{constructor(L,te,Ee){if(this.f=[],Array.isArray(te)){if(!L)throw(0,N.$7)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,N.$7)("command");this.e=L,this.f=te,this.g=Ee}else{if(typeof L!="string")throw(0,N.$7)("commandLine");this.c=L,this.g=te}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,N.$7)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,N.$7)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)L.push(typeof te=="string"?te:te.value);return Ut(L)}};e.$NN=Ft,e.$NN=Ft=Je([y],Ft);var ti;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ti||(e.ShellQuoting=ti={}));var Bt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Bt||(e.TaskScope=Bt={}));class ii{constructor(L){this.c=L}computeId(){return"customExecution"+(0,F.$Rg)()}set callback(L){this.c=L}get callback(){return this.c}}e.$ON=ii;let Mt=class{static{l=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,te,Ee,He,Xe,ht){this.k=!1,this.l=this.definition=L;let pt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Ee,this.execution=He,pt=Xe,this.k=!0):te===Bt.Global||te===Bt.Workspace?(this.target=te,this.o=this.name=Ee,this.w=this.source=He,this.execution=Xe,pt=ht):(this.target=te,this.o=this.name=Ee,this.w=this.source=He,this.execution=Xe,pt=ht),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(L){this.j=L}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ct?this.l={type:l.e,id:this.q.computeId()}:this.q instanceof Ft?this.l={type:l.f,id:this.q.computeId()}:this.q instanceof ii?this.l={type:l.c,id:this.q.computeId()}:this.l={type:l.g,id:(0,F.$Rg)()}}get definition(){return this.l}set definition(L){if(L==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=L}get scope(){return this.m}set target(L){this.B(),this.m=L}get name(){return this.o}set name(L){if(typeof L!="string")throw(0,N.$7)("name");this.B(),this.o=L}get execution(){return this.q}set execution(L){L===null&&(L=void 0),this.B(),this.q=L;const te=this.l.type;(l.g===te||l.e===te||l.f===te||l.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(L){if(Array.isArray(L))this.B(),this.r=L,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.B(),this.u=L}get source(){return this.w}set source(L){if(typeof L!="string"||L.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=L}get group(){return this.x}set group(L){L===null&&(L=void 0),this.B(),this.x=L}get detail(){return this.A}set detail(L){L===null&&(L=void 0),this.A=L}get presentationOptions(){return this.y}set presentationOptions(L){L==null&&(L=Object.create(null)),this.B(),this.y=L}get runOptions(){return this.z}set runOptions(L){L==null&&(L=Object.create(null)),this.B(),this.z=L}};e.$PN=Mt,e.$PN=Mt=l=Je([y],Mt);var At;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(At||(e.ProgressLocation=At={}));var Nt;(function(B){function L(te){const Ee=te;return(0,p.$_f)(Ee.value)?Ee.tooltip&&!(0,p.$8f)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}B.isViewBadge=L})(Nt||(e.ViewBadge=Nt={}));let It=w=class{static isTreeItem(L,te){const Ee=L;if(Ee.checkboxState!==void 0){const He=(0,p.$_f)(Ee.checkboxState)?Ee.checkboxState:(0,p.$0f)(Ee.checkboxState)&&(0,p.$_f)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,Xe=!(0,p.$_f)(Ee.checkboxState)&&(0,p.$0f)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(He===void 0||He!==Et.Checked&&He!==Et.Unchecked||Xe!==void 0&&!(0,p.$8f)(Xe))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(L instanceof w)return!0;if(Ee.label!==void 0&&!(0,p.$8f)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,p.$8f)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,p.$8f)(Ee.iconPath)&&!E.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,p.$8f)(Ee.iconPath.id))){const He=Ee.iconPath;if(!He||!(0,p.$8f)(He.light)&&!E.URI.isUri(He.light)&&!(0,p.$8f)(He.dark)&&!E.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,p.$8f)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!E.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,p.$8f)(Ee.tooltip)&&!(Ee.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<$t.None&&Ee.collapsibleState>$t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,p.$8f)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(L,te=$t.None){this.collapsibleState=te,E.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$QN=It,e.$QN=It=w=Je([y],It);var $t;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})($t||(e.TreeItemCollapsibleState=$t={}));var Et;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Et||(e.TreeItemCheckboxState=Et={}));let ni=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$RN=ni,e.$RN=ni=Je([y],ni);class Dt extends ni{}e.$SN=Dt;class gi extends Dt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$TN=gi;class _t{constructor(L,te,Ee,He){this.name=L,this.uri=te,this._itemId=Ee,this.c=He}data(){return this.c()}}e.$UN=_t;let bi=class{#e=new Map;constructor(L){for(const[te,Ee]of L??[]){const He=this.#e.get(this.#t(te));He?He.push(Ee):this.#e.set(this.#t(te),[Ee])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,te){this.#e.set(this.#t(L),[te])}forEach(L,te){for(const[Ee,He]of this.#e)for(const Xe of He)L.call(te,Xe,Ee,this)}*[Symbol.iterator](){for(const[L,te]of this.#e)for(const Ee of te)yield[L,Ee]}#t(L){return L.toLowerCase()}};e.$VN=bi,e.$VN=bi=Je([y],bi);let ci=class{constructor(L,te,Ee){this.insertText=L,this.title=te,this.kind=Ee}};e.$WN=ci,e.$WN=ci=Je([y],ci);var vi;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(vi||(e.DocumentPasteTriggerKind=vi={}));class kt{static{this.c="."}constructor(L){this.value=L}append(...L){return new kt((this.value?[this.value,...L]:L).join(kt.c))}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+kt.c)}}e.$XN=kt,kt.Empty=new kt("");class Si{constructor(L,te,Ee){this.title=te,this.insertText=L,this.kind=Ee}}e.$YN=Si;let be=class{constructor(L,te){this.id=L,this.color=te}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$ZN=be,e.$ZN=be=Je([y],be),be.File=new be("file"),be.Folder=new be("folder");let Se=class{constructor(L){this.id=L}};e.$1N=Se,e.$1N=Se=Je([y],Se);var oe;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(oe||(e.ConfigurationTarget=oe={}));let J=class{get base(){return this.c}set base(L){this.c=L,this.e=E.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,te){if(typeof L!="string"&&(!L||!E.URI.isUri(L)&&!E.URI.isUri(L.uri)))throw(0,N.$7)("base");if(typeof te!="string")throw(0,N.$7)("pattern");typeof L=="string"?this.baseUri=E.URI.file(L):E.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$2N=J,e.$2N=J=Je([y],J);const ke=new WeakMap;function Ve(B,L){ke.set(B,L)}let Ye=class{constructor(L,te,Ee,He,Xe){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof He=="string"&&(this.logMessage=He),typeof Xe=="string"&&(this.mode=Xe)}get id(){return this.c||(this.c=ke.get(this)??(0,F.$Rg)()),this.c}};e.$4N=Ye,e.$4N=Ye=Je([y],Ye);let qe=class extends Ye{constructor(L,te,Ee,He,Xe,ht){if(super(te,Ee,He,Xe,ht),L===null)throw(0,N.$7)("location");this.location=L}};e.$5N=qe,e.$5N=qe=Je([y],qe);let ut=class extends Ye{constructor(L,te,Ee,He,Xe,ht){super(te,Ee,He,Xe,ht),this.functionName=L}};e.$6N=ut,e.$6N=ut=Je([y],ut);let yt=class extends Ye{constructor(L,te,Ee,He,Xe,ht,pt,Ht){if(super(He,Xe,ht,pt,Ht),!te)throw(0,N.$7)("dataId");this.label=L,this.dataId=te,this.canPersist=Ee}};e.$7N=yt,e.$7N=yt=Je([y],yt);let Tt=class{constructor(L,te,Ee){this.command=L,this.args=te||[],this.options=Ee}};e.$8N=Tt,e.$8N=Tt=Je([y],Tt);let Vt=class{constructor(L,te){this.port=L,this.host=te}};e.$9N=Vt,e.$9N=Vt=Je([y],Vt);let at=class{constructor(L){this.path=L}};e.$0N=at,e.$0N=at=Je([y],at);let Qt=class{constructor(L){this.implementation=L}};e.$$N=Qt,e.$$N=Qt=Je([y],Qt);class mi{constructor(L,te,Ee){this.session=L,this.threadId=te,this.frameId=Ee}}e.$_N=mi;class Ei{constructor(L,te){this.session=L,this.threadId=te}}e.$aO=Ei;let Ii=class{constructor(L,te){this.range=L,this.expression=te}};e.$bO=Ii,e.$bO=Ii=Je([y],Ii);var Gi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Gi||(e.InlineCompletionTriggerKind=Gi={}));let Oi=class{constructor(L,te){this.range=L,this.text=te}};e.$cO=Oi,e.$cO=Oi=Je([y],Oi);let Fi=class{constructor(L,te,Ee=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=Ee}};e.$dO=Fi,e.$dO=Fi=Je([y],Fi);let Pi=class{constructor(L,te){this.range=L,this.expression=te}};e.$eO=Pi,e.$eO=Pi=Je([y],Pi);let Ti=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};e.$fO=Ti,e.$fO=Ti=Je([y],Ti);var Li;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Li||(e.NewSymbolNameTag=Li={}));class un{constructor(L,te){this.newSymbolName=L,this.tags=te}}e.$gO=un;var Ci;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Ci||(e.FileChangeType=Ci={}));let Di=$=class extends Error{static FileExists(L){return new $(L,d.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(L){return new $(L,d.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(L){return new $(L,d.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(L){return new $(L,d.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(L){return new $(L,d.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(L){return new $(L,d.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(L,te=d.FileSystemProviderErrorCode.Unknown,Ee){super(E.URI.isUri(L)?L.toString(!0):L),this.code=Ee?.name??"Unknown",(0,d.$el)(this,te),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};e.$hO=Di,e.$hO=Di=$=Je([y],Di);let zi=class{constructor(L,te,Ee){this.start=L,this.end=te,this.kind=Ee}};e.$iO=zi,e.$iO=zi=Je([y],zi);var Hi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Hi||(e.FoldingRangeKind=Hi={}));var wi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(wi||(e.CommentThreadCollapsibleState=wi={}));var Ki;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var Ji;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Ji||(e.CommentState=Ji={}));var Qi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Qi||(e.CommentThreadState=Qi={}));var Ri;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Ri||(e.CommentThreadApplicability=Ri={}));class ln{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.$jO=ln;function Yi(B){return typeof B>"u"||(0,p.$9f)(B)}class ji{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,L){this.m=!0;for(let te=0,Ee=L.tokenTypes.length;te<Ee;te++)this.k.set(L.tokenTypes[te],te);for(let te=0,Ee=L.tokenModifiers.length;te<Ee;te++)this.l.set(L.tokenModifiers[te],te)}}push(L,te,Ee,He,Xe){if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof He=="number"&&(typeof Xe=="number"||typeof Xe>"u"))return typeof Xe>"u"&&(Xe=0),this.q(L,te,Ee,He,Xe);if(q.isRange(L)&&typeof te=="string"&&Yi(Ee))return this.o(L,te,Ee);throw(0,N.$7)()}o(L,te,Ee){if(!this.m)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const He=L.start.line,Xe=L.start.character,ht=L.end.character-L.start.character,pt=this.k.get(te);let Ht=0;if(Ee)for(const ai of Ee){if(!this.l.has(ai))throw new Error("`tokenModifier` is not in the provided legend");const li=this.l.get(ai);Ht|=1<<li>>>0}this.q(He,Xe,ht,pt,Ht)}q(L,te,Ee,He,Xe){if(this.f&&(L<this.c||L===this.c&&te<this.e)){this.f=!1;const Ht=this.g.length/5|0;let ai=0,li=0;for(let fi=0;fi<Ht;fi++){let pi=this.g[5*fi],Wi=this.g[5*fi+1];pi===0?(pi=ai,Wi+=li):pi+=ai,this.g[5*fi]=pi,this.g[5*fi+1]=Wi,ai=pi,li=Wi}}let ht=L,pt=te;this.f&&this.j>0&&(ht-=this.c,ht===0&&(pt-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=pt,this.g[this.j++]=Ee,this.g[this.j++]=He,this.g[this.j++]=Xe,this.c=L,this.e=te}static r(L){const te=[],Ee=L.length/5|0;for(let pt=0;pt<Ee;pt++)te[pt]=pt;te.sort((pt,Ht)=>{const ai=L[5*pt],li=L[5*Ht];if(ai===li){const fi=L[5*pt+1],pi=L[5*Ht+1];return fi-pi}return ai-li});const He=new Uint32Array(L.length);let Xe=0,ht=0;for(let pt=0;pt<Ee;pt++){const Ht=5*te[pt],ai=L[Ht+0],li=L[Ht+1],fi=L[Ht+2],pi=L[Ht+3],Wi=L[Ht+4],On=ai-Xe,hr=On===0?li-ht:li,qi=5*pt;He[qi+0]=On,He[qi+1]=hr,He[qi+2]=fi,He[qi+3]=pi,He[qi+4]=Wi,Xe=ai,ht=li}return He}build(L){return this.f?new Mi(new Uint32Array(this.g),L):new Mi(ji.r(this.g),L)}}e.$kO=ji;class Mi{constructor(L,te){this.resultId=te,this.data=L}}e.$lO=Mi;class hn{constructor(L,te,Ee){this.start=L,this.deleteCount=te,this.data=Ee}}e.$mO=hn;class dn{constructor(L,te){this.resultId=te,this.edits=L}}e.$nO=dn;var Zi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));class fn{constructor(L){this.name=L}}e.$oO=fn;let ki=class{static{this.Back={iconPath:new be("arrow-left")}}constructor(){}};e.$pO=ki,e.$pO=ki=Je([y],ki);var Ui;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Ui||(e.QuickPickItemKind=Ui={}));var ze;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(ze||(e.InputBoxValidationSeverity=ze={}));var ui;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(ui||(e.ExtensionKind=ui={}));class Xi{static validate(L){if(typeof L.badge=="string"){let te=(0,b.$Hf)(L.badge,0);if(te<L.badge.length&&(te+=(0,b.$Hf)(L.badge,te)),L.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!be.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,te,Ee){this.badge=L,this.tooltip=te,this.color=Ee}}e.$qO=Xi;let it=class{constructor(L){this.kind=L}};e.$rO=it,e.$rO=it=Je([y],it);var vt;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(vt||(e.ColorThemeKind=vt={}));class di{static isNotebookRange(L){return L instanceof di?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,te){if(L<0)throw(0,N.$7)("start must be positive");if(te<0)throw(0,N.$7)("end must be positive");L<=te?(this.c=L,this.e=te):(this.c=te,this.e=L)}with(L){let te=this.c,Ee=this.e;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(Ee=L.end),te===this.c&&Ee===this.e?this:new di(te,Ee)}}e.$sO=di;class Ai{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>Ai.isNotebookCellData(te))}static isNotebookCellData(L){return!0}constructor(L,te,Ee,He,Xe,ht,pt){this.kind=L,this.value=te,this.languageId=Ee,this.mime=He,this.outputs=Xe??[],this.metadata=ht,this.executionSummary=pt,Ai.validate(this)}}e.$tO=Ai;class xi{constructor(L){this.cells=L}}e.$uO=xi;class oi{static isNotebookCellOutputItem(L){return L instanceof oi?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return oi.json(te,"application/vnd.code.notebook.error")}static stdout(L){return oi.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return oi.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new oi(L,te)}static#e=new TextEncoder;static text(L,te=M.$Ps.text){const Ee=oi.#e.encode(String(L));return new oi(Ee,te)}static json(L,te="text/x-json"){const Ee=JSON.stringify(L,void 0,"	");return oi.text(Ee,te)}constructor(L,te){this.data=L,this.mime=te;const Ee=(0,M.$Ts)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.$vO=oi;class $i{static isNotebookCellOutput(L){return L instanceof $i?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,te=!1){const Ee=new Set,He=new Set;for(let Xe=0;Xe<L.length;Xe++){const ht=L[Xe],pt=(0,M.$Ts)(ht.mime);if(!Ee.has(pt)||(0,m.$XK)(pt)){Ee.add(pt);continue}He.add(Xe),te&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return He.size===0?L:L.filter((Xe,ht)=>!He.has(ht))}constructor(L,te,Ee){this.items=$i.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,F.$Rg)(),this.metadata=te??Ee)}}e.$wO=$i;var _i;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(_i||(e.NotebookCellKind=_i={}));var en;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(en||(e.NotebookCellExecutionState=en={}));var tn;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(tn||(e.NotebookCellStatusBarAlignment=tn={}));var Bi;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Bi||(e.NotebookEditorRevealType=Bi={}));class gn{constructor(L,te){this.text=L,this.alignment=te}}e.$xO=gn;var nn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(nn||(e.NotebookControllerAffinity=nn={}));var rn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(rn||(e.NotebookControllerAffinity2=rn={}));class mn{constructor(L,te=[]){this.uri=L,this.provides=(0,I.$3b)(te)}}e.$yO=mn;class $n{constructor(L){this.label=L}}e.$zO=$n;var sn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(sn||(e.NotebookVariablesRequestKind=sn={}));let Vi=class{constructor(L,te){this.label=L,this.timestamp=te}};e.$AO=Vi,e.$AO=Vi=Je([y],Vi);var on;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var an;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(an||(e.ExtensionRuntime=an={}));var cn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class pn{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.$BO=pn;class _{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$CO=_;var se;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(se||(e.TestResultState=se={}));var Le;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(Le||(e.TestRunProfileKind=Le={}));let rt=class{constructor(L=void 0,te=void 0,Ee=void 0,He=!1,Xe=!0){this.include=L,this.exclude=te,this.profile=Ee,this.continuous=He,this.preserveFocus=Xe}};e.$DO=rt,e.$DO=rt=Je([y],rt);let wt=k=class{static diff(L,te,Ee){const He=new k(L);return He.expectedOutput=te,He.actualOutput=Ee,He}constructor(L){this.message=L}};e.$EO=wt,e.$EO=wt=k=Je([y],wt);let Rt=class{constructor(L){this.id=L}};e.$FO=Rt,e.$FO=Rt=Je([y],Rt);class yi{constructor(L,te){this.covered=L,this.total=te,vn(this)}}e.$GO=yi;function vn(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class bn{static fromDetails(L,te){const Ee=new yi(0,0),He=new yi(0,0),Xe=new yi(0,0);for(const pt of te)if("branches"in pt){Ee.total+=1,Ee.covered+=pt.executed?1:0;for(const Ht of pt.branches)He.total+=1,He.covered+=Ht.executed?1:0}else Xe.total+=1,Xe.covered+=pt.executed?1:0;const ht=new bn(L,Ee,He.total>0?He:void 0,Xe.total>0?Xe:void 0);return ht.detailedCoverage=te,ht}constructor(L,te,Ee,He){this.uri=L,this.statementCoverage=te,this.branchCoverage=Ee,this.declarationCoverage=He}}e.$IO=bn;class Fn{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee=[]){this.executed=L,this.location=te,this.branches=Ee}}e.$JO=Fn;class Tn{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee){this.executed=L,this.location=te,this.label=Ee}}e.$KO=Tn;class Ln{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee){this.name=L,this.executed=te,this.location=Ee}}e.$LO=Ln;var wn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(wn||(e.ExternalUriOpenerPriority=wn={}));var yn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var En;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(En||(e.PortAutoForwardAction=En={}));class zn{constructor(L,te,Ee,He,Xe,ht){this.kind=L,this.name=te,this.detail=Ee,this.uri=He,this.range=Xe,this.selectionRange=ht}}e.$MO=zn;class jn{constructor(L){this.uri=L}}e.$NO=jn;class Un{constructor(L,te){this.original=L,this.modified=te}}e.$OO=Un;class Bn{constructor(L,te,Ee,He){this.base=L,this.input1=te,this.input2=Ee,this.result=He}}e.$PO=Bn;class Vn{constructor(L,te){this.uri=L,this.viewType=te}}e.$QO=Vn;class Wn{constructor(L){this.viewType=L}}e.$RO=Wn;class qn{constructor(L,te){this.uri=L,this.notebookType=te}}e.$SO=qn;class Gn{constructor(L,te,Ee){this.original=L,this.modified=te,this.notebookType=Ee}}e.$TO=Gn;class Hn{constructor(){}}e.$UO=Hn;class Kn{constructor(L,te){this.uri=L,this.inputBoxUri=te}}e.$VO=Kn;class Jn{constructor(){}}e.$WO=Jn;class Qn{constructor(L){this.textDiffs=L}}e.$XO=Qn;var Dn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(Dn||(e.InteractiveSessionVoteDirection=Dn={}));var kn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var Sn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Sn||(e.ChatVariableLevel=Sn={}));class Yn{constructor(L,te){this.label=L,this.values=te}}e.$YO=Yn;var In;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(In||(e.InteractiveEditorResponseFeedbackKind=In={}));var Pn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Pn||(e.ChatResultFeedbackKind=Pn={}));class Zn{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Ke(L):L}}e.$ZO=Zn;class Xn{constructor(L,te){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Ke(L):L,this.vulnerabilities=te}}e.$1O=Xn;class xn{constructor(L,te){this.participant=L,this.command=te}}e.$2O=xn;class _n{constructor(L,te){this.value=L,this.baseUri=te}}e.$3O=_n;class er{constructor(L,te){this.value=L,this.title=te}}e.$4O=er;class tr{constructor(L){this.value=L}}e.$5O=tr;class ir{constructor(L){this.value=L}}e.$6O=ir;class nr{constructor(L){this.value=L}}e.$7O=nr;class rr{constructor(L,te){this.uri=L,this.edits=Array.isArray(te)?te:[te]}}e.$8O=rr;class sr{constructor(L,te,Ee,He){this.prompt=L,this.command=te,this.variables=Ee,this.participant=He}}e.$9O=sr;class or{constructor(L,te,Ee,He){this.response=L,this.result=te,this.participant=Ee,this.command=He}}e.$0O=or;var Cn;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(Cn||(e.ChatLocation=Cn={}));class ar{constructor(L){this.content=L}}e.$$O=ar;class cr{constructor(L,te){this.content=L,this.name=te}}e.$_O=cr;class ur{constructor(L,te){this.content=L,this.name=te}}e.$aP=ur;class Ni extends Error{static NotFound(L){return new Ni(L,Ni.NotFound.name)}static NoPermissions(L){return new Ni(L,Ni.NoPermissions.name)}constructor(L,te,Ee){super(L,{cause:Ee}),this.name="LanguageModelError",this.code=te??""}}e.$bP=Ni;var Rn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Rn||(e.RelatedInformationType=Rn={}));var Mn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(Mn||(e.SpeechToTextStatus=Mn={}));var An;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(An||(e.KeywordRecognitionStatus=An={}));class lr{constructor(L,te){this.text=L,this.range=te}}e.$cP=lr;var Nn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Nn||(e.InlineEditTriggerKind=Nn={}))}),define(Ie[257],Ce([1,0,4,7]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2kc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$1M.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,b,p){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(M);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(b,p)??[]}getRelatedInformation(M,b,p){return this.c.$getAiRelatedInformation(b,p)}registerRelatedInformationProvider(M,b,p){const E=this.b;return this.b++,this.a.set(E,p),this.c.$registerAiRelatedInformationProvider(E,b),new N.$3M(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$2kc=R}),define(Ie[86],Ce([1,0,5,4,7,20,108,3,17]),function(le,e,I,N,R,O,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=e.$alc=void 0,e.$alc=(0,b.$vi)("IExtHostAuthentication");let E=class{constructor(d){this.b=new Map,this.c=new I.$ee,this.onDidChangeSessions=this.c.event,this.d=new F,this.f=new F,this.a=d.getProxy(N.$1M.MainThreadAuthentication)}async getSession(d,v,m,r={}){const o=O.$Qm.toKey(d.identifier),s=[...m].sort().join(" ");return await this.d.getOrCreate(`${o} ${v} ${s}`,async()=>{await this.a.$ensureProvider(v);const i=d.displayName||d.name;return this.a.$getSession(v,m,o,i,r)})}async getSessions(d,v,m){const r=O.$Qm.toKey(d.identifier),o=[...m].sort().join(" ");return await this.f.getOrCreate(`${r} ${o}`,async()=>{await this.a.$ensureProvider(v);const s=d.displayName||d.name;return this.a.$getSessions(v,m,r,s)})}async removeSession(d,v){const m=this.b.get(d);return m?m.provider.removeSession(v):this.a.$removeSession(d,v)}registerAuthenticationProvider(d,v,m,r){if(this.b.get(d))throw new Error(`An authentication provider with id '${d}' is already registered.`);this.b.set(d,{label:v,provider:m,options:r??{supportsMultipleAccounts:!1}});const o=m.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(d,s));return this.a.$registerAuthenticationProvider(d,v,r?.supportsMultipleAccounts??!1),new R.$3M(()=>{o.dispose(),this.b.delete(d),this.a.$unregisterAuthenticationProvider(d)})}$createSession(d,v,m){const r=this.b.get(d);if(r)return Promise.resolve(r.provider.createSession(v,m));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$removeSession(d,v){const m=this.b.get(d);if(m)return Promise.resolve(m.provider.removeSession(v));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$getSessions(d,v){const m=this.b.get(d);if(m)return Promise.resolve(m.provider.getSessions(v));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$onDidChangeAuthenticationSessions(d,v){return d.startsWith(M.$3L)||this.c.fire({provider:{id:d,label:v}}),Promise.resolve()}};e.$blc=E,e.$blc=E=Je([We(0,p.$oP)],E);class F{constructor(){this.a=new Map}getOrCreate(d,v){const m=this.a.get(d);if(m)return m;const r=v().finally(()=>this.a.delete(d));return this.a.set(d,r),r}}}),define(Ie[112],Ce([1,0,2,4,7,3,17,12,18,13,19,26]),function(le,e,I,N,R,O,M,b,p,E,F,D){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=void 0;let v=class{static{d=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(N.$1M.MainThreadDecorations)}registerFileDecorationProvider(r,o){const s=d.c++;this.f.set(s,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const i=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(s,null);return}const c=(0,p.$3b)(n);if(c.length<=d.d){this.g.$onDidChange(s,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const h=c.map(a=>({uri:a,rank:(0,E.$af)(a.path,"/")})),t=(0,p.$zb)(h,(a,g)=>a.rank-g.rank||(0,E.$qf)(a.uri.path,g.uri.path)),f=[];e:for(const a of t){let g;for(const u of a){const S=(0,F.$nc)(u.uri.path);if(g!==S&&(g=S,f.push(u.uri)>=d.d))break e}}this.g.$onDidChange(s,f)});return new R.$3M(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(r,o,s){if(!this.f.has(r))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:c}=this.f.get(r);return await Promise.all(o.map(async h=>{try{const{uri:t,id:f}=h,a=await Promise.resolve(n.provideFileDecoration(I.URI.revive(t),s));if(!a)return;try{R.$qO.validate(a),a.badge&&typeof a.badge!="string"&&(0,D.$GG)(c,"codiconDecoration"),i[f]=[a.propagate,a.tooltip,a.badge,a.color]}catch(g){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${g}`)}}catch(t){this.h.error(t)}})),i}};e.$amc=v,e.$amc=v=d=Je([We(0,M.$oP),We(1,b.$2j)],v),e.$bmc=(0,O.$vi)("IExtHostDecorations")}),define(Ie[258],Ce([1,0,14,2,7,4,16,24,13]),function(le,e,I,N,R,O,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;class E{static{this.a=0}constructor(D,d,v){this.d=d,this.e=v,this.b=new Map,this.c=D.getProxy(O.$1M.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,d){if(Object.keys(M.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const v=E.a++;this.b.set(v,d),this.c.$registerTextContentProvider(v,D);let m;if(typeof d.onDidChange=="function"){let r;m=d.onDidChange(async o=>{if(o.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const s=this.$provideTextDocumentContent(v,o).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(o);if(!n)return;const c=(0,p.$kf)(i);if(!n.equalLines(c))return this.c.$onVirtualDocumentChange(o,i)}).catch(I.$1).finally(()=>{r===s&&(r=void 0)});r=s})}return new R.$3M(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(D,d){const v=this.b.get(D);return v?Promise.resolve(v.provideTextDocumentContent(N.URI.revive(d),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.$dmc=E}),define(Ie[113],Ce([1,0,57,16,13,313,159,7,18]),function(le,e,I,N,R,O,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sP=e.$rP=void 0,e.$qP=F;const E=new Map;function F(m,r){r?E.set(m,r):E.delete(m)}function D(m){return E.get(m)}class d extends O.$Yv{constructor(r,o,s,i,n,c,h){super(o,s,i,n),this.c=r,this.m=c,this.q=h,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,p.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===N.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,s){return r.y(o,s)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,I.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,I.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const s=this.g,i=o.start.line,n=o.end.line,c=[];c.push(this.f[i].substring(o.start.character));for(let h=i+1;h<n;h++)c.push(this.f[h]);return c.push(this.f[n].substring(0,o.end.character)),c.join(s)}t(r){let o;if(r instanceof b.$4M?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new v(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),s=this.f[o.index].length;return new b.$4M(o.index,Math.min(o.remainder,s))}w(r){if(!(r instanceof b.$5M))throw new Error("Invalid argument");const o=this.x(r.start),s=this.x(r.end);return o===r.start&&s===r.end?r:new b.$5M(o.line,o.character,s.line,s.character)}x(r){if(!(r instanceof b.$4M))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:s}=r,i=!1;if(o<0)o=0,s=0,i=!0;else if(o>=this.f.length)o=this.f.length-1,s=this.f[o].length,i=!0;else{const n=this.f[o].length;s<0?(s=0,i=!0):s>n&&(s=n,i=!0)}return i?new b.$4M(o,s):r}y(r,o){const s=this.x(r);if(!o)o=D(this.m);else if((0,R.$jf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const i=(0,M.$8s)(s.character+1,(0,M.$6s)(o),this.f[s.line],0);if(i)return new b.$5M(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.$rP=d;class v{constructor(r,o,s){this.a=r,this.b=o,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$5M(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$5M(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$sP=v}),define(Ie[259],Ce([1,0,4,7]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$1M.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,b,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(M);if(!E)throw new Error("Embedding vector provider not found");const F=await E.provideEmbeddingVector(b,p);if(!F)throw new Error("Embedding vector provider returned undefined");return F}registerEmbeddingVectorProvider(M,b,p){const E=this.b;return this.b++,this.a.set(E,p),this.c.$registerAiEmbeddingVectorProvider(b,E),new N.$3M(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$fmc=R}),define(Ie[65],Ce([1,0,4,37,7,21,3,17,46,6,11,23,16]),function(le,e,I,N,R,O,M,b,p,E,F,D,d){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=e.$qlc=void 0;let m=v=class{constructor(o,s){this.b=new Map,this.c=new F.$Eh,this.a=o.getProxy(I.$1M.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let c;const h=i.b.get(n.scheme);return h?(await i.a.$ensureActivation(n.scheme),c=await h.impl.stat(n)):c=await i.a.$stat(n),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===N.FilePermission.Readonly?1:void 0}}catch(c){v.e(c)}},async readDirectory(n){try{const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),(await c.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(c){return v.e(c)}},async createDirectory(n){try{const c=i.b.get(n.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(c.impl,c.extUri,n)):await i.a.$mkdir(n)}catch(c){return v.e(c)}},async readFile(n){try{const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),(await c.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(c){return v.e(c)}},async writeFile(n,c){try{const h=i.b.get(n.scheme);return h&&!h.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(h.impl,h.extUri,h.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(h.impl.writeFile(n,c,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,O.$Fe.wrap(c))}catch(h){return v.e(h)}},async delete(n,c){try{const h=i.b.get(n.scheme);return h&&!h.isReadonly&&!c?.useTrash?(await i.a.$ensureActivation(n.scheme),await h.impl.delete(n,{recursive:!1,...c})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return v.e(h)}},async rename(n,c,h){try{return await i.a.$rename(n,c,{overwrite:!1,...h})}catch(t){return v.e(t)}},async copy(n,c,h){try{return await i.a.$copy(n,c,{overwrite:!1,...h})}catch(t){return v.e(t)}},isWritableFileSystem(n){const c=s.getCapabilities(n);if(typeof c=="number")return!(c&2048)}})}async d(o,s,i){const n=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await o.stat(i)).type&N.FileType.Directory))throw R.$hO.FileExists(`Unable to create folder '${i.scheme===d.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(N.$fl(c)!==N.FileSystemProviderErrorCode.FileNotFound)throw c;n.push(s.basename(i)),i=s.dirname(i)}for(let c=n.length-1;c>=0;c--){i=s.joinPath(i,n[c]);try{await o.createDirectory(i)}catch(h){if(N.$fl(h)!==N.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof R.$hO)throw o;if(o instanceof N.$bl)switch(o.code){case N.FileSystemProviderErrorCode.FileExists:throw R.$hO.FileExists(o.message);case N.FileSystemProviderErrorCode.FileNotFound:throw R.$hO.FileNotFound(o.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw R.$hO.FileNotADirectory(o.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw R.$hO.FileIsADirectory(o.message);case N.FileSystemProviderErrorCode.NoPermissions:throw R.$hO.NoPermissions(o.message);case N.FileSystemProviderErrorCode.Unavailable:throw R.$hO.Unavailable(o.message);default:throw new R.$hO(o.message,o.name)}if(!(o instanceof Error))throw new R.$hO(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw R.$hO.Unavailable(o.message);switch(o.name){case N.FileSystemProviderErrorCode.FileExists:throw R.$hO.FileExists(o.message);case N.FileSystemProviderErrorCode.FileNotFound:throw R.$hO.FileNotFound(o.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw R.$hO.FileNotADirectory(o.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw R.$hO.FileIsADirectory(o.message);case N.FileSystemProviderErrorCode.NoPermissions:throw R.$hO.NoPermissions(o.message);case N.FileSystemProviderErrorCode.Unavailable:throw R.$hO.Unavailable(o.message);default:throw new R.$hO(o.message,o.name)}}addFileSystemProvider(o,s,i){return this.b.set(o,{impl:s,extUri:i?.isCaseSensitive?D.$Yg:D.$1g,isReadonly:!!i?.isReadonly}),(0,E.$Tc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??D.$Yg}};e.$qlc=m,e.$qlc=m=v=Je([We(0,b.$oP),We(1,p.$7kc)],m),e.$rlc=(0,M.$vi)("IExtHostConsumerFileSystem")}),define(Ie[87],Ce([1,0,3,27,12,65,2]),function(le,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=e.$slc=void 0,e.$slc=(0,I.$vi)("IExtensionStoragePaths");let b=class{constructor(E,F,D){this.d=F,this.f=D,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(d=>this.c=d)}async g(E){return M.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,F=await this.g(E);try{return await this.f.value.stat(F),this.d.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",F),await this.f.value.createDirectory(F),await this.f.value.writeFile(M.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),F}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(E){if(this.c)return M.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return M.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$tlc=b,e.$tlc=b=Je([We(0,N.$EP),We(1,R.$2j),We(2,O.$rlc)],b)}),define(Ie[260],Ce([1,0,7,17,5]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;let O=class{constructor(b){this.a=new I.$rO(I.ColorThemeKind.Dark),this.b=new R.$ee}get activeColorTheme(){return this.a}$onColorThemeChange(b){let p;switch(b){case"light":p=I.ColorThemeKind.Light;break;case"hcDark":p=I.ColorThemeKind.HighContrast;break;case"hcLight":p=I.ColorThemeKind.HighContrastLight;break;default:p=I.ColorThemeKind.Dark}this.a=new I.$rO(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$1mc=O,e.$1mc=O=Je([We(0,N.$oP)],O)}),define(Ie[88],Ce([1,0,24,5,6,182,3,12,211,4,27,17,7]),function(le,e,I,N,R,O,M,b,p,E,F,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kDb=e.$jDb=e.TunnelDtoConverter=void 0;class v extends p.$lw{}var m;(function(o){function s(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:n.protocol}}o.fromApiTunnel=s;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==p.TunnelPrivacyId.ConstantPrivate&&n.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}o.fromServiceTunnel=i})(m||(e.TunnelDtoConverter=m={})),e.$jDb=(0,M.$vi)("IExtHostTunnelService");let r=class extends R.$Vc{constructor(s,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$ee,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(E.$1M.MainThreadTunnelService)}async openTunnel(s,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,s.displayName);if(n){const c=new v(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,i){s.portRange===void 0&&s.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:s,provider:i}),this.a.$registerPortsAttributesProvider(s,n),new d.$3M(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(s,i,n,c,h){const t=[];for(const a of s){const g=this.r.get(a);if(!g)return[];t.push(...await Promise.all(i.map(async u=>{let S;try{S=await g.provider.providePortAttributes({port:u,pid:n,commandLine:c},h)}catch{S=await g.provider.providePortAttributes(u,n,c,h)}return{providedAttributes:S,port:u}})))}const f=t.filter(a=>!!a.providedAttributes);return f.length>0?f.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await s.provideTunnel(c,h,I.CancellationToken.None)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,R.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const n=s.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let c=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const h=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,R.$Tc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,i){if(this.g.has(s.host)){const n=this.g.get(s.host);n.has(s.port)&&(i&&n.get(s.port).disposeListener.dispose(),await n.get(s.port).tunnel.dispose(),n.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(s,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const c=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:c,disposeListener:h}),m.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(c=>this.f(c.host,c.port,c.detail??""))),n=s.filter((c,h)=>i[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(c=>c.port).join(", ")} to ${n.map(c=>c.port).join(", ")}`),n}};e.$kDb=r,e.$kDb=r=Je([We(0,D.$oP),We(1,F.$EP),We(2,b.$2j)],r)}),define(Ie[8],Ce([1,0,18,21,138,261,55,28,127,49,70,25,133,23,15,2,30,89,101,107,106,224,85,52,62,235,7]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o,s,i,n,c,h,t,f,a,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$lP=U,e.$mP=re,e.$nP=ae;var S;(function(be){function Se(J){const{selectionStartLineNumber:ke,selectionStartColumn:Ve,positionLineNumber:Ye,positionColumn:qe}=J,ut=new u.$4M(ke-1,Ve-1),yt=new u.$4M(Ye-1,qe-1);return new u.$6M(ut,yt)}be.to=Se;function oe(J){const{anchor:ke,active:Ve}=J;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}be.from=oe})(S||(e.Selection=S={}));var l;(function(be){function Se(J){if(!J)return;const{start:ke,end:Ve}=J;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}be.from=Se;function oe(J){if(!J)return;const{startLineNumber:ke,startColumn:Ve,endLineNumber:Ye,endColumn:qe}=J;return new u.$5M(ke-1,Ve-1,Ye-1,qe-1)}be.to=oe})(l||(e.Range=l={}));var w;(function(be){function Se(J){return{uri:J.uri,range:l.from(J.range)}}be.from=Se;function oe(J){return new u.$cN(r.URI.revive(J.uri),l.to(J.range))}be.to=oe})(w||(e.Location=w={}));var $;(function(be){function Se(oe){switch(oe){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 3:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}be.to=Se})($||(e.TokenType=$={}));var k;(function(be){function Se(J){return new u.$4M(J.lineNumber-1,J.column-1)}be.to=Se;function oe(J){return{lineNumber:J.line+1,column:J.character+1}}be.from=oe})(k||(e.Position=k={}));var y;(function(be){function Se(ke,Ve,Ye){return(0,I.$Hb)((0,I.$3b)(ke).map(qe=>oe(qe,Ve,Ye)))}be.from=Se;function oe(ke,Ve,Ye){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:Ye?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:J(ke.scheme,Ve),pattern:Y.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:Ye?.isBuiltin}}function J(ke,Ve){return Ve&&typeof ke=="string"?Ve.transformOutgoingScheme(ke):ke}})(y||(e.DocumentSelector=y={}));var C;(function(be){function Se(J){switch(J){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}be.from=Se;function oe(J){switch(J){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}be.to=oe})(C||(e.DiagnosticTag=C={}));var P;(function(be){function Se(J){let ke;return J.code&&((0,m.$8f)(J.code)||(0,m.$_f)(J.code)?ke=String(J.code):ke={value:String(J.code.value),target:J.code.target}),{...l.from(J.range),message:J.message,source:J.source,code:ke,severity:V.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(W.from),tags:Array.isArray(J.tags)?(0,I.$Hb)(J.tags.map(C.from)):void 0}}be.from=Se;function oe(J){const ke=new u.$eN(l.to(J),J.message,V.to(J.severity));return ke.source=J.source,ke.code=(0,m.$8f)(J.code)?J.code:J.code?.value,ke.relatedInformation=J.relatedInformation&&J.relatedInformation.map(W.to),ke.tags=J.tags&&(0,I.$Hb)(J.tags.map(C.to)),ke}be.to=oe})(P||(e.Diagnostic=P={}));var W;(function(be){function Se(J){return{...l.from(J.location.range),message:J.message,resource:J.location.uri}}be.from=Se;function oe(J){return new u.$dN(new u.$cN(J.resource,l.to(J)),J.message)}be.to=oe})(W||(e.DiagnosticRelatedInformation=W={}));var V;(function(be){function Se(J){switch(J){case u.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}be.from=Se;function oe(J){switch(J){case i.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}be.to=oe})(V||(e.DiagnosticSeverity=V={}));var q;(function(be){function Se(J){return typeof J=="number"&&J>=u.ViewColumn.One?J-1:J===u.ViewColumn.Beside?g.$WD:g.$VD}be.from=Se;function oe(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=oe})(q||(e.ViewColumn=q={}));function A(be){return typeof be.range<"u"}function U(be){return be.length===0?!0:!!A(be[0])}var K;(function(be){function Se(qe){return qe.map(be.from)}be.fromMany=Se;function oe(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function J(qe){let ut;if(oe(qe)){const{language:at,value:Qt}=qe;ut={value:"```"+at+`
`+Qt+"\n```\n"}}else u.$sN.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const yt=Object.create(null);ut.uris=yt;const Tt=at=>{try{let Qt=r.URI.parse(at,!0);Qt=Qt.with({query:ke(Qt.query,yt)}),yt[at]=Qt}catch{}return""},Vt=new p.marked.Renderer;return Vt.link=Tt,Vt.image=at=>typeof at=="string"?Tt(M.$1k(at).href):"",(0,p.marked)(ut.value,{renderer:Vt}),ut}be.from=J;function ke(qe,ut){if(!qe)return qe;let yt;try{yt=(0,E.$4h)(qe)}catch{}if(!yt)return qe;let Tt=!1;return yt=(0,D.$4n)(yt,Vt=>{if(r.URI.isUri(Vt)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[at]=Vt,Tt=!0,at}else return}),Tt?JSON.stringify(yt):qe}function Ve(qe){const ut=new u.$sN(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?r.URI.from(qe.baseUri):void 0,ut}be.to=Ve;function Ye(qe){if(qe)return typeof qe=="string"?qe:be.from(qe)}be.fromStrict=Ye})(K||(e.MarkdownString=K={}));function re(be){return U(be)?be.map(Se=>({range:l.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?K.fromMany(Se.hoverMessage):Se.hoverMessage?K.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):be.map(Se=>({range:l.from(Se)}))}function ae(be){return typeof be>"u"?be:typeof be=="string"?r.URI.file(be):be}var ye;(function(be){function Se(oe){return typeof oe>"u"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?ae(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}be.from=Se})(ye||(e.ThemableDecorationAttachmentRenderOptions=ye={}));var Pe;(function(be){function Se(oe){return typeof oe>"u"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ae(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?ye.from(oe.before):void 0,after:oe.after?ye.from(oe.after):void 0}}be.from=Se})(Pe||(e.ThemableDecorationRenderOptions=Pe={}));var fe;(function(be){function Se(oe){if(typeof oe>"u")return oe;switch(oe){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=Se})(fe||(e.DecorationRangeBehavior=fe={}));var me;(function(be){function Se(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?fe.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?Pe.from(oe.light):void 0,dark:oe.dark?Pe.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ae(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?ye.from(oe.before):void 0,after:oe.after?ye.from(oe.after):void 0}}be.from=Se})(me||(e.DecorationRenderOptions=me={}));var Ae;(function(be){function Se(J){return{text:J.newText,eol:J.newEol&&ct.from(J.newEol),range:l.from(J.range)}}be.from=Se;function oe(J){const ke=new u.$0M(l.to(J.range),J.text);return ke.newEol=typeof J.eol>"u"?void 0:ct.to(J.eol),ke}be.to=oe})(Ae||(e.TextEdit=Ae={}));var ce;(function(be){function Se(J,ke){const Ve={edits:[]};if(J instanceof u.$aN){const Ye=new b.$Cc;for(const qe of J._allEntries())qe._type===1&&r.URI.isUri(qe.to)&&qe.from===void 0&&Ye.add(qe.to);for(const qe of J._allEntries())if(qe._type===1){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,N.$Ze)(N.$Fe.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),Ve.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===2?Ve.edits.push({resource:qe.uri,textEdit:Ae.from(qe.edit),versionId:Ye.has(qe.uri)?void 0:ke?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ve.edits.push({resource:qe.uri,textEdit:{range:l.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Ye.has(qe.uri)?void 0:ke?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ve.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ve.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:ke?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(zt.from)}})}return Ve}be.from=Se;function oe(J){const ke=new u.$aN,Ve=new b.$Bc;for(const Ye of J.edits)if(Ye.textEdit){const qe=Ye,ut=r.URI.revive(qe.resource),yt=l.to(qe.textEdit.range),Tt=qe.textEdit.text,Vt=qe.textEdit.insertAsSnippet;let at;Vt?at=u.$_M.replace(yt,new u.$bN(Tt)):at=u.$0M.replace(yt,Tt);const Qt=Ve.get(ut);Qt?Qt.push(at):Ve.set(ut,[at])}else ke.renameFile(r.URI.revive(Ye.oldResource),r.URI.revive(Ye.newResource),Ye.options);for(const[Ye,qe]of Ve)ke.set(Ye,qe);return ke}be.to=oe})(ce||(e.WorkspaceEdit=ce={}));var Me;(function(be){const Se=Object.create(null);Se[u.SymbolKind.File]=0,Se[u.SymbolKind.Module]=1,Se[u.SymbolKind.Namespace]=2,Se[u.SymbolKind.Package]=3,Se[u.SymbolKind.Class]=4,Se[u.SymbolKind.Method]=5,Se[u.SymbolKind.Property]=6,Se[u.SymbolKind.Field]=7,Se[u.SymbolKind.Constructor]=8,Se[u.SymbolKind.Enum]=9,Se[u.SymbolKind.Interface]=10,Se[u.SymbolKind.Function]=11,Se[u.SymbolKind.Variable]=12,Se[u.SymbolKind.Constant]=13,Se[u.SymbolKind.String]=14,Se[u.SymbolKind.Number]=15,Se[u.SymbolKind.Boolean]=16,Se[u.SymbolKind.Array]=17,Se[u.SymbolKind.Object]=18,Se[u.SymbolKind.Key]=19,Se[u.SymbolKind.Null]=20,Se[u.SymbolKind.EnumMember]=21,Se[u.SymbolKind.Struct]=22,Se[u.SymbolKind.Event]=23,Se[u.SymbolKind.Operator]=24,Se[u.SymbolKind.TypeParameter]=25;function oe(ke){return typeof Se[ke]=="number"?Se[ke]:6}be.from=oe;function J(ke){for(const Ve in Se)if(Se[Ve]===ke)return Number(Ve);return u.SymbolKind.Property}be.to=J})(Me||(e.SymbolKind=Me={}));var ie;(function(be){function Se(J){switch(J){case u.SymbolTag.Deprecated:return 1}}be.from=Se;function oe(J){switch(J){case 1:return u.SymbolTag.Deprecated}}be.to=oe})(ie||(e.SymbolTag=ie={}));var z;(function(be){function Se(J){return{name:J.name,kind:Me.from(J.kind),tags:J.tags&&J.tags.map(ie.from),containerName:J.containerName,location:$e.from(J.location)}}be.from=Se;function oe(J){const ke=new u.$jN(J.name,Me.to(J.kind),J.containerName,$e.to(J.location));return ke.tags=J.tags&&J.tags.map(ie.to),ke}be.to=oe})(z||(e.WorkspaceSymbol=z={}));var x;(function(be){function Se(J){const ke={name:J.name||"!!MISSING: name!!",detail:J.detail,range:l.from(J.range),selectionRange:l.from(J.selectionRange),kind:Me.from(J.kind),tags:J.tags?.map(ie.from)??[]};return J.children&&(ke.children=J.children.map(Se)),ke}be.from=Se;function oe(J){const ke=new u.$kN(J.name,J.detail,Me.to(J.kind),l.to(J.range),l.to(J.selectionRange));return(0,I.$Lb)(J.tags)&&(ke.tags=J.tags.map(ie.to)),J.children&&(ke.children=J.children.map(oe)),ke}be.to=oe})(x||(e.DocumentSymbol=x={}));var ve;(function(be){function Se(J){const ke=new u.$oN(Me.to(J.kind),J.name,J.detail||"",r.URI.revive(J.uri),l.to(J.range),l.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}be.to=Se;function oe(J,ke,Ve){if(ke=ke??J._sessionId,Ve=Ve??J._itemId,ke===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ve,name:J.name,detail:J.detail,kind:Me.from(J.kind),uri:J.uri,range:l.from(J.range),selectionRange:l.from(J.selectionRange),tags:J.tags?.map(ie.from)}}be.from=oe})(ve||(e.CallHierarchyItem=ve={}));var Te;(function(be){function Se(oe){return new u.$pN(ve.to(oe.from),oe.fromRanges.map(J=>l.to(J)))}be.to=Se})(Te||(e.CallHierarchyIncomingCall=Te={}));var De;(function(be){function Se(oe){return new u.$qN(ve.to(oe.to),oe.fromRanges.map(J=>l.to(J)))}be.to=Se})(De||(e.CallHierarchyOutgoingCall=De={}));var $e;(function(be){function Se(J){return{range:J.range&&l.from(J.range),uri:J.uri}}be.from=Se;function oe(J){return new u.$cN(r.URI.revive(J.uri),l.to(J.range))}be.to=oe})($e||(e.location=$e={}));var ge;(function(be){function Se(J){const ke=J,Ve=J;return{originSelectionRange:ke.originSelectionRange?l.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Ve.uri,range:l.from(ke.targetRange?ke.targetRange:Ve.range),targetSelectionRange:ke.targetSelectionRange?l.from(ke.targetSelectionRange):void 0}}be.from=Se;function oe(J){return{targetUri:r.URI.revive(J.uri),targetRange:l.to(J.range),targetSelectionRange:J.targetSelectionRange?l.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?l.to(J.originSelectionRange):void 0}}be.to=oe})(ge||(e.DefinitionLink=ge={}));var Q;(function(be){function Se(J){return{range:l.from(J.range),contents:K.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}be.from=Se;function oe(J){const ke=J.contents.map(K.to),Ve=l.to(J.range),Ye=J.canIncreaseVerbosity,qe=J.canDecreaseVerbosity;return new u.$gN(ke,Ve,Ye,qe)}be.to=oe})(Q||(e.Hover=Q={}));var X;(function(be){function Se(J){return{range:l.from(J.range),expression:J.expression}}be.from=Se;function oe(J){return new u.$bO(l.to(J.range),J.expression)}be.to=oe})(X||(e.EvaluatableExpression=X={}));var he;(function(be){function Se(J){if(J instanceof u.$cO)return{type:"text",range:l.from(J.range),text:J.text};if(J instanceof u.$dO)return{type:"variable",range:l.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof u.$eO)return{type:"expression",range:l.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}be.from=Se;function oe(J){switch(J.type){case"text":return{range:l.to(J.range),text:J.text};case"variable":return{range:l.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:l.to(J.range),expression:J.expression}}}be.to=oe})(he||(e.InlineValue=he={}));var ue;(function(be){function Se(J){return{frameId:J.frameId,stoppedLocation:l.from(J.stoppedLocation)}}be.from=Se;function oe(J){return new u.$fO(J.frameId,l.to(J.stoppedLocation))}be.to=oe})(ue||(e.InlineValueContext=ue={}));var Fe;(function(be){function Se(J){return{range:l.from(J.range),kind:J.kind}}be.from=Se;function oe(J){return new u.$hN(l.to(J.range),J.kind)}be.to=oe})(Fe||(e.DocumentHighlight=Fe={}));var de;(function(be){function Se(J){return{uri:J.uri,highlights:J.highlights.map(Fe.from)}}be.from=Se;function oe(J){return new u.$iN(r.URI.revive(J.uri),J.highlights.map(Fe.to))}be.to=oe})(de||(e.MultiDocumentHighlight=de={}));var Re;(function(be){function Se(oe){switch(oe){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}be.to=Se})(Re||(e.CompletionTriggerKind=Re={}));var Ne;(function(be){function Se(oe){return{triggerKind:Re.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}be.to=Se})(Ne||(e.CompletionContext=Ne={}));var Ue;(function(be){function Se(J){switch(J){case u.CompletionItemTag.Deprecated:return 1}}be.from=Se;function oe(J){switch(J){case 1:return u.CompletionItemTag.Deprecated}}be.to=oe})(Ue||(e.CompletionItemTag=Ue={}));var j;(function(be){const Se=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function oe(Ve){return Se.get(Ve)??9}be.from=oe;const J=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function ke(Ve){return J.get(Ve)??u.CompletionItemKind.Property}be.to=ke})(j||(e.CompletionItemKind=j={}));var T;(function(be){function Se(oe,J){const ke=new u.$yN(oe.label);return ke.insertText=oe.insertText,ke.kind=j.to(oe.kind),ke.tags=oe.tags?.map(Ue.to),ke.detail=oe.detail,ke.documentation=M.$Uk(oe.documentation)?K.to(oe.documentation):oe.documentation,ke.sortText=oe.sortText,ke.filterText=oe.filterText,ke.preselect=oe.preselect,ke.commitCharacters=oe.commitCharacters,o.$tt.isIRange(oe.range)?ke.range=l.to(oe.range):typeof oe.range=="object"&&(ke.range={inserting:l.to(oe.range.insert),replacing:l.to(oe.range.replace)}),ke.keepWhitespace=typeof oe.insertTextRules>"u"?!1:!!(oe.insertTextRules&1),typeof oe.insertTextRules<"u"&&oe.insertTextRules&4?ke.insertText=new u.$bN(oe.insertText):(ke.insertText=oe.insertText,ke.textEdit=ke.range instanceof u.$5M?new u.$0M(ke.range,ke.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(ke.additionalTextEdits=oe.additionalTextEdits.map(Ve=>Ae.to(Ve))),ke.command=J&&oe.command?J.fromInternal(oe.command):void 0,ke}be.to=Se})(T||(e.CompletionItem=T={}));var G;(function(be){function Se(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:K.fromStrict(J.documentation)}}be.from=Se;function oe(J){return{label:J.label,documentation:M.$Uk(J.documentation)?K.to(J.documentation):J.documentation}}be.to=oe})(G||(e.ParameterInformation=G={}));var H;(function(be){function Se(J){return{label:J.label,documentation:K.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(G.from):[],activeParameter:J.activeParameter}}be.from=Se;function oe(J){return{label:J.label,documentation:M.$Uk(J.documentation)?K.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(G.to):[],activeParameter:J.activeParameter}}be.to=oe})(H||(e.SignatureInformation=H={}));var ee;(function(be){function Se(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(H.from):[]}}be.from=Se;function oe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(H.to):[]}}be.to=oe})(ee||(e.SignatureHelp=ee={}));var ne;(function(be){function Se(oe,J){const ke=new u.$xN(k.to(J.position),typeof J.label=="string"?J.label:J.label.map(Oe.to.bind(void 0,oe)),J.kind&&Be.to(J.kind));return ke.textEdits=J.textEdits&&J.textEdits.map(Ae.to),ke.tooltip=M.$Uk(J.tooltip)?K.to(J.tooltip):J.tooltip,ke.paddingLeft=J.paddingLeft,ke.paddingRight=J.paddingRight,ke}be.to=Se})(ne||(e.InlayHint=ne={}));var Oe;(function(be){function Se(oe,J){const ke=new u.$wN(J.label);return ke.tooltip=M.$Uk(J.tooltip)?K.to(J.tooltip):J.tooltip,s.Command.is(J.command)&&(ke.command=oe.fromInternal(J.command)),J.location&&(ke.location=$e.to(J.location)),ke}be.to=Se})(Oe||(e.InlayHintLabelPart=Oe={}));var Be;(function(be){function Se(J){return J}be.from=Se;function oe(J){return J}be.to=oe})(Be||(e.InlayHintKind=Be={}));var Ke;(function(be){function Se(J){return{range:l.from(J.range),url:J.target,tooltip:J.tooltip}}be.from=Se;function oe(J){let ke;if(J.url)try{ke=typeof J.url=="string"?r.URI.parse(J.url,!0):r.URI.revive(J.url)}catch{}return new u.$DN(l.to(J.range),ke)}be.to=oe})(Ke||(e.DocumentLink=Ke={}));var _e;(function(be){function Se(J){const ke=new u.$GN(J.label);return J.textEdit&&(ke.textEdit=Ae.to(J.textEdit)),J.additionalTextEdits&&(ke.additionalTextEdits=J.additionalTextEdits.map(Ve=>Ae.to(Ve))),ke}be.to=Se;function oe(J){return{label:J.label,textEdit:J.textEdit?Ae.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(ke=>Ae.from(ke)):void 0}}be.from=oe})(_e||(e.ColorPresentation=_e={}));var xe;(function(be){function Se(J){return new u.$EN(J[0],J[1],J[2],J[3])}be.to=Se;function oe(J){return[J.red,J.green,J.blue,J.alpha]}be.from=oe})(xe||(e.Color=xe={}));var et;(function(be){function Se(J){return{range:l.from(J.range)}}be.from=Se;function oe(J){return new u.$nN(l.to(J.range))}be.to=oe})(et||(e.SelectionRange=et={}));var tt;(function(be){function Se(oe){switch(oe){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}be.to=Se})(tt||(e.TextDocumentSaveReason=tt={}));var nt;(function(be){function Se(J){switch(J){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.Interval:return 3;case u.TextEditorLineNumbersStyle.On:default:return 1}}be.from=Se;function oe(J){switch(J){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 3:return u.TextEditorLineNumbersStyle.Interval;case 1:default:return u.TextEditorLineNumbersStyle.On}}be.to=oe})(nt||(e.TextEditorLineNumbersStyle=nt={}));var ct;(function(be){function Se(J){if(J===u.EndOfLine.CRLF)return 1;if(J===u.EndOfLine.LF)return 0}be.from=Se;function oe(J){if(J===1)return u.EndOfLine.CRLF;if(J===0)return u.EndOfLine.LF}be.to=oe})(ct||(e.EndOfLine=ct={}));var mt;(function(be){function Se(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=Se})(mt||(e.ProgressLocation=mt={}));var je;(function(be){function Se(J){const ke={start:J.start+1,end:J.end+1};return J.kind&&(ke.kind=st.from(J.kind)),ke}be.from=Se;function oe(J){const ke={start:J.start-1,end:J.end-1};return J.kind&&(ke.kind=st.to(J.kind)),ke}be.to=oe})(je||(e.FoldingRange=je={}));var st;(function(be){function Se(J){if(J)switch(J){case u.FoldingRangeKind.Comment:return s.$cu.Comment;case u.FoldingRangeKind.Imports:return s.$cu.Imports;case u.FoldingRangeKind.Region:return s.$cu.Region}}be.from=Se;function oe(J){if(J)switch(J.value){case s.$cu.Comment.value:return u.FoldingRangeKind.Comment;case s.$cu.Imports.value:return u.FoldingRangeKind.Imports;case s.$cu.Region.value:return u.FoldingRangeKind.Region}}be.to=oe})(st||(e.FoldingRangeKind=st={}));var Z;(function(be){function Se(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?l.from(oe.selection):void 0,override:typeof oe.override=="boolean"?c.$mF.id:void 0}}be.from=Se})(Z||(e.TextEditorOpenOptions=Z={}));var Y;(function(be){function Se(Ve){return Ve instanceof u.$2N?Ve.toJSON():typeof Ve=="string"?Ve:oe(Ve)||J(Ve)?new u.$2N(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}be.from=Se;function oe(Ve){const Ye=Ve;return Ye?r.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function J(Ve){const Ye=Ve;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function ke(Ve){return typeof Ve=="string"?Ve:new u.$2N(r.URI.revive(Ve.baseUri),Ve.pattern)}be.to=ke})(Y||(e.GlobPattern=Y={}));var pe;(function(be){function Se(oe){if(oe){if(Array.isArray(oe))return oe.map(Se);if(typeof oe=="string")return oe;{const J=oe;return{language:J.language,scheme:J.scheme,pattern:Y.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}be.from=Se})(pe||(e.LanguageSelector=pe={}));var Ge;(function(be){function Se(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(ke=>Array.isArray(ke)&&ke.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&r.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Ye=>Ye instanceof u.$5M)))}be.is=Se;function oe(J){return{documents:J.documents.map(ke=>ke.map(Ve=>({uri:r.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Ye=>l.from(Ye))})))}}be.from=oe})(Ge||(e.MappedEditsContext=Ge={}));var we;(function(be){function Se(J){return{start:J.start,end:J.end}}be.from=Se;function oe(J){return new u.$sO(J.start,J.end)}be.to=oe})(we||(e.NotebookRange=we={}));var ot;(function(be){function Se(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}be.to=Se;function oe(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}be.from=oe})(ot||(e.NotebookCellExecutionSummary=ot={}));var dt;(function(be){function Se(oe){if(oe===t.NotebookCellExecutionState.Unconfirmed)return u.NotebookCellExecutionState.Pending;if(oe===t.NotebookCellExecutionState.Pending)return;if(oe===t.NotebookCellExecutionState.Executing)return u.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${oe}`)}be.to=Se})(dt||(e.NotebookCellExecutionState=dt={}));var Pt;(function(be){function Se(J){switch(J){case u.NotebookCellKind.Markup:return t.CellKind.Markup;case u.NotebookCellKind.Code:default:return t.CellKind.Code}}be.from=Se;function oe(J){switch(J){case t.CellKind.Markup:return u.NotebookCellKind.Markup;case t.CellKind.Code:default:return u.NotebookCellKind.Code}}be.to=oe})(Pt||(e.NotebookCellKind=Pt={}));var Yt;(function(be){function Se(J){const ke={metadata:J.metadata??Object.create(null),cells:[]};for(const Ve of J.cells)u.$tO.validate(Ve),ke.cells.push(zt.from(Ve));return ke}be.from=Se;function oe(J){const ke=new u.$uO(J.cells.map(zt.to));return(0,m.$ig)(J.metadata)||(ke.metadata=J.metadata),ke}be.to=oe})(Yt||(e.NotebookData=Yt={}));var zt;(function(be){function Se(J){return{cellKind:Pt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:ot.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Zt.from):[]}}be.from=Se;function oe(J){return new u.$tO(Pt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Zt.to):void 0,J.metadata,J.internalMetadata?ot.to(J.internalMetadata):void 0)}be.to=oe})(zt||(e.NotebookCellData=zt={}));var ri;(function(be){function Se(J){return{mime:J.mime,valueBytes:N.$Fe.wrap(J.data)}}be.from=Se;function oe(J){return new u.$vO(J.valueBytes.buffer,J.mime)}be.to=oe})(ri||(e.NotebookCellOutputItem=ri={}));var Zt;(function(be){function Se(J){return{outputId:J.id,items:J.items.map(ri.from),metadata:J.metadata}}be.from=Se;function oe(J){const ke=J.items.map(ri.to);return new u.$wO(ke,J.outputId,J.metadata)}be.to=oe})(Zt||(e.NotebookCellOutput=Zt={}));var St;(function(be){function Se(ke){return J(ke)?{include:Y.from(ke.include)??void 0,exclude:Y.from(ke.exclude)??void 0}:Y.from(ke)??void 0}be.from=Se;function oe(ke){return J(ke)?{include:Y.to(ke.include),exclude:Y.to(ke.exclude)}:Y.to(ke)}be.to=oe;function J(ke){const Ve=ke;return Ve?!(0,m.$eg)(Ve.include)&&!(0,m.$eg)(Ve.exclude):!1}})(St||(e.NotebookExclusiveDocumentPattern=St={}));var Xt;(function(be){function Se(oe,J,ke){const Ve=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ve,ke),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}be.from=Se})(Xt||(e.NotebookStatusBarItem=Xt={}));var xt;(function(be){function Se(oe,J,ke){const Ve=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{command:J.toInternal(Ve,ke),label:oe.label,description:oe.description,detail:oe.detail,documentation:oe.documentation}}be.from=Se})(xt||(e.NotebookKernelSourceAction=xt={}));var Ze;(function(be){function Se(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{},cellContentMetadata:oe?.cellContentMetadata??{}}}be.from=Se})(Ze||(e.NotebookDocumentContentOptions=Ze={}));var si;(function(be){function Se(J){return{uri:J.uri,provides:J.provides}}be.from=Se;function oe(J){return new u.$yO(r.URI.revive(J.uri),J.provides)}be.to=oe})(si||(e.NotebookRendererScript=si={}));var Wt;(function(be){function Se(J){return{message:K.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:l.from(J.location.range),uri:J.location.uri}}}be.from=Se;function oe(J){const ke=new u.$EO(typeof J.message=="string"?J.message:K.to(J.message));return ke.actualOutput=J.actual,ke.expectedOutput=J.expected,ke.contextValue=J.contextValue,ke.location=J.location?$e.to(J.location):void 0,ke}be.to=oe})(Wt||(e.TestMessage=Wt={}));var lt;(function(be){be.namespace=a.$RL,be.denamespace=a.$SL})(lt||(e.TestTag=lt={}));var bt;(function(be){function Se(J){const ke=(0,n.$kP)(J).controllerId;return{extId:f.$ML.fromExtHostTestItem(J,ke).toString(),label:J.label,uri:r.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ve=>lt.namespace(ke,Ve.id)),range:o.$tt.lift(l.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&K.fromStrict(J.error)||null}}be.from=Se;function oe(J){return{parent:void 0,error:void 0,id:f.$ML.fromString(J.extId).localId,label:J.label,uri:r.URI.revive(J.uri),tags:(J.tags||[]).map(ke=>{const{tagId:Ve}=lt.denamespace(ke);return new u.$FO(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}be.toPlain=oe})(bt||(e.TestItem=bt={})),function(be){function Se(J){return{id:J.id}}be.from=Se;function oe(J){return new u.$FO(J.id)}be.to=oe}(lt||(e.TestTag=lt={}));var ei;(function(be){const Se=(J,ke)=>{const Ve=J.value;if(!Ve)return;const Ye={...bt.toPlain(Ve.item),parent:ke,taskStates:Ve.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===0).map(Wt.to)})),children:[]};if(J.children)for(const qe of J.children.values()){const ut=Se(qe,Ye);ut&&Ye.children.push(ut)}return Ye};function oe(J){const ke=new d.$dP;for(const qe of J.items)ke.insert(f.$ML.fromString(qe.item.extId).path,qe);const Ve=[ke.nodes],Ye=[];for(;Ve.length;)for(const qe of Ve.pop())qe.value?Ye.push(qe):qe.children&&Ve.push(qe.children.values());return{completedAt:J.completedAt,results:Ye.map(qe=>Se(qe)).filter(m.$dg)}}be.to=oe})(ei||(e.TestResults=ei={}));var Kt;(function(be){function Se(Ve){return{covered:Ve.covered,total:Ve.total}}function oe(Ve){return"line"in Ve?k.from(Ve):l.from(Ve)}function J(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:oe(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&oe(Ye.location),label:Ye.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:oe(Ve.location)}}be.fromDetails=J;function ke(Ve,Ye){return u.$HO(Ye.statementCoverage),u.$HO(Ye.branchCoverage),u.$HO(Ye.declarationCoverage),{id:Ve,uri:Ye.uri,statement:Se(Ye.statementCoverage),branch:Ye.branchCoverage&&Se(Ye.branchCoverage),declaration:Ye.declarationCoverage&&Se(Ye.declarationCoverage)}}be.fromFile=ke})(Kt||(e.TestCoverage=Kt={}));var Ot;(function(be){function Se(oe){switch(oe){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}be.to=Se})(Ot||(e.CodeActionTriggerKind=Ot={}));var ft;(function(be){function Se(J){const ke=new u.$MO(Me.to(J.kind),J.name,J.detail||"",r.URI.revive(J.uri),l.to(J.range),l.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}be.to=Se;function oe(J,ke,Ve){if(ke=ke??J._sessionId,Ve=Ve??J._itemId,ke===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ve,kind:Me.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:l.from(J.range),selectionRange:l.from(J.selectionRange),tags:J.tags?.map(ie.from)}}be.from=oe})(ft||(e.TypeHierarchyItem=ft={}));var jt;(function(be){function Se(oe){if(oe)return{value:oe.value,tooltip:oe.tooltip}}be.from=Se})(jt||(e.ViewBadge=jt={}));var qt;(function(be){function Se(Ve,Ye,qe){const ut=Ye.fileData;return ut?new u.$TN(new u.$UN(ut.name,r.URI.revive(ut.uri),ut.id,(0,O.$db)(()=>qe(ut.id)))):Ve===F.$Ps.uriList&&Ye.uriListData?new u.$SN(ke(Ye.uriListData)):new u.$SN(Ye.asString)}be.to=Se;async function oe(Ve,Ye){const qe=await Ye.asString();if(Ve===F.$Ps.uriList)return{asString:qe,fileData:void 0,uriListData:J(qe)};const ut=Ye.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}be.from=oe;function J(Ve){return R.$Tt.split(Ve).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return r.URI.parse(Ye)}catch{}return Ye})}function ke(Ve){return R.$Tt.create(Ve.map(Ye=>typeof Ye=="string"?Ye:r.URI.revive(Ye)))}})(qt||(e.DataTransferItem=qt={}));var Gt;(function(be){function Se(J,ke){const Ve=J.items.map(([Ye,qe])=>[Ye,qt.to(Ye,qe,ke)]);return new u.$VN(Ve)}be.toDataTransfer=Se;async function oe(J){const ke={items:[]},Ve=[];for(const[Ye,qe]of J)Ve.push((async()=>{ke.items.push([Ye,await qt.from(Ye,qe)])})());return await Promise.all(Ve),ke}be.from=oe})(Gt||(e.DataTransfer=Gt={}));var Qe;(function(be){function Se(J,ke){return{kind:"reply",agentId:J.participant??ke?.agentId??"",subCommand:J.command??ke?.command,message:J.prompt,title:J.label}}be.from=Se;function oe(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}be.to=oe})(Qe||(e.ChatFollowup=Qe={}));var hi;(function(be){function Se(oe){return"commandId"in oe?{kind:"command",title:oe.title??"",commandId:oe.commandId??"",when:oe.when??"",args:oe.args}:{kind:"reply",message:oe.message,title:oe.title,tooltip:oe.tooltip}}be.from=Se})(hi||(e.ChatInlineFollowup=hi={}));var Jt;(function(be){function Se(J){switch(J.role){case 0:return new u.$$O(J.content);case 1:return new u.$_O(J.content);case 2:return new u.$aP(J.content)}}be.to=Se;function oe(J){if(J instanceof u.$$O)return{role:0,content:J.content};if(J instanceof u.$_O)return{role:1,content:J.content};if(J instanceof u.$aP)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}be.from=oe})(Jt||(e.LanguageModelMessage=Jt={}));var Lt;(function(be){function Se(ke){const Ve={};for(const Ye of Object.keys(ke))Ve[Ye]=ke[Ye].map(be.to);return Ve}be.objectTo=Se;function oe(ke){return{level:gt.to(ke.level),kind:ke.kind,value:(0,r.$wc)(ke.value)?r.URI.revive(ke.value):ke.value,description:ke.description}}be.to=oe;function J(ke){return{level:gt.from(ke.level),kind:ke.kind,value:ke.value,description:ke.description}}be.from=J})(Lt||(e.ChatVariable=Lt={}));var gt;(function(be){function Se(J){switch(J){case"short":return u.ChatVariableLevel.Short;case"medium":return u.ChatVariableLevel.Medium;case"full":default:return u.ChatVariableLevel.Full}}be.to=Se;function oe(J){switch(J){case u.ChatVariableLevel.Short:return"short";case u.ChatVariableLevel.Medium:return"medium";case u.ChatVariableLevel.Full:default:return"full"}}be.from=oe})(gt||(e.ChatVariableLevel=gt={}));var Ut;(function(be){function Se(oe){switch(oe){case 1:return u.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return u.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return u.InteractiveEditorResponseFeedbackKind.Undone;case 3:return u.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return u.InteractiveEditorResponseFeedbackKind.Bug}}be.to=Se})(Ut||(e.InteractiveEditorResponseFeedbackKind=Ut={}));var Ct;(function(be){function Se(J){return{kind:"markdownContent",content:K.from(J.value)}}be.from=Se;function oe(J){return new u.$ZO(K.to(J.content))}be.to=oe})(Ct||(e.ChatResponseMarkdownPart=Ct={}));var Ft;(function(be){function Se(J){return{kind:"markdownVuln",content:K.from(J.value),vulnerabilities:J.vulnerabilities}}be.from=Se;function oe(J){return new u.$1O(K.to(J.content),J.vulnerabilities)}be.to=oe})(Ft||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Ft={}));var ti;(function(be){function Se(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}be.from=Se;function oe(J){return new u.$2O(J.agentId,J.command)}be.to=oe})(ti||(e.ChatResponseDetectedParticipantPart=ti={}));var Bt;(function(be){function Se(J){const{value:ke,baseUri:Ve}=J;function Ye(qe,ut){return qe.map(yt=>{const Tt=r.URI.joinPath(ut,yt.name);return{label:yt.name,uri:Tt,children:yt.children&&Ye(yt.children,Tt)}})}return{kind:"treeData",treeData:{label:(0,v.$6g)(Ve),uri:Ve,children:Ye(ke,Ve)}}}be.from=Se;function oe(J){const ke=(0,E.$5h)(J.treeData);function Ve(ut){return ut.map(yt=>({name:yt.label,children:yt.children&&Ve(yt.children)}))}const Ye=ke.uri,qe=ke.children?Ve(ke.children):[];return new u.$3O(qe,Ye)}be.to=oe})(Bt||(e.ChatResponseFilesPart=Bt={}));var ii;(function(be){function Se(J){return{kind:"inlineReference",name:J.title,inlineReference:r.URI.isUri(J.value)?J.value:w.from(J.value)}}be.from=Se;function oe(J){const ke=(0,E.$5h)(J);return new u.$4O(r.URI.isUri(ke.inlineReference)?ke.inlineReference:w.to(ke.inlineReference),J.name)}be.to=oe})(ii||(e.ChatResponseAnchorPart=ii={}));var Mt;(function(be){function Se(J){return{kind:"progressMessage",content:K.from(J.value)}}be.from=Se;function oe(J){return new u.$5O(J.content.value)}be.to=oe})(Mt||(e.ChatResponseProgressPart=Mt={}));var At;(function(be){function Se(J,ke,Ve){return{kind:"command",command:ke.toInternal(J.value,Ve)??{command:J.value.command,title:J.value.title}}}be.from=Se;function oe(J,ke){return new u.$6O(ke.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}be.to=oe})(At||(e.ChatResponseCommandButtonPart=At={}));var Nt;(function(be){function Se(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(ke=>Ae.from(ke))}}be.from=Se;function oe(J){return new u.$8O(r.URI.revive(J.uri),J.edits.map(ke=>Ae.to(ke)))}be.to=oe})(Nt||(e.ChatResponseTextEditPart=Nt={}));var It;(function(be){function Se(J){return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:r.URI.isUri(J.value.value)||!J.value.value?J.value.value:w.from(J.value.value)}}:{kind:"reference",reference:r.URI.isUri(J.value)?J.value:w.from(J.value)}}be.from=Se;function oe(J){const ke=(0,E.$5h)(J),Ve=Ye=>r.URI.isUri(Ye)?Ye:w.to(Ye);return new u.$7O("variableName"in ke.reference?{variableName:ke.reference.variableName,value:ke.reference.value&&Ve(ke.reference.value)}:Ve(ke.reference))}be.to=oe})(It||(e.ChatResponseReferencePart=It={}));var $t;(function(be){function Se(ke,Ve,Ye){return ke instanceof u.$ZO?Ct.from(ke):ke instanceof u.$4O?ii.from(ke):ke instanceof u.$7O?It.from(ke):ke instanceof u.$5O?Mt.from(ke):ke instanceof u.$3O?Bt.from(ke):ke instanceof u.$6O?At.from(ke,Ve,Ye):ke instanceof u.$8O?Nt.from(ke):ke instanceof u.$1O?Ft.from(ke):ke instanceof u.$2O?ti.from(ke):{kind:"markdownContent",content:K.from("")}}be.from=Se;function oe(ke,Ve){switch(ke.kind){case"reference":return It.to(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(ke,Ve)}}be.to=oe;function J(ke,Ve){switch(ke.kind){case"markdownContent":return Ct.to(ke);case"inlineReference":return ii.to(ke);case"progressMessage":return;case"treeData":return Bt.to(ke);case"command":return At.to(ke,Ve)}}be.toContent=J})($t||(e.ChatResponsePart=$t={}));var Et;(function(be){function Se(oe){return{prompt:oe.message,command:oe.command,attempt:oe.attempt??0,enableCommandDetection:oe.enableCommandDetection??!0,variables:oe.variables.variables.map(Dt.to),location:ni.to(oe.location)}}be.to=Se})(Et||(e.ChatAgentRequest=Et={}));var ni;(function(be){function Se(oe){switch(oe){case h.ChatAgentLocation.Notebook:return u.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return u.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return u.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return u.ChatLocation.Editor}}be.to=Se})(ni||(e.ChatLocation=ni={}));var Dt;(function(be){function Se(oe){return{name:oe.name,range:oe.range&&[oe.range.start,oe.range.endExclusive],values:oe.values.map(Lt.to)}}be.to=Se})(Dt||(e.ChatAgentResolvedVariable=Dt={}));var gi;(function(be){function Se(oe,J,ke){return{label:oe.label,values:oe.values.map(Lt.from),insertText:oe.insertText,detail:oe.detail,documentation:oe.documentation,command:J.toInternal(oe.command,ke)}}be.from=Se})(gi||(e.ChatAgentCompletionItem=gi={}));var _t;(function(be){function Se(oe){return{errorDetails:oe.errorDetails,metadata:oe.metadata}}be.to=Se})(_t||(e.ChatAgentResult=_t={}));var bi;(function(be){function Se(oe,J,ke){if(J.action.kind==="vote")return;const Ve=_t.to(oe);if(J.action.kind==="command"){const Ye=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:ke.fromInternal(Ye)??{command:Ye.id,title:Ye.title}}},result:Ve}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:Qe.to(J.action.followup)},result:Ve}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Ve}:{action:J.action,result:Ve}}be.to=Se})(bi||(e.ChatAgentUserActionEvent=bi={}));var ci;(function(be){function Se(oe,J,ke){return"terminalCommand"in oe?{terminalCommand:oe.terminalCommand,shouldExecute:oe.shouldExecute}:"uri"in oe?{uri:oe.uri}:J.toInternal(oe,ke)}be.from=Se})(ci||(e.TerminalQuickFix=ci={}));var vi;(function(be){function Se(oe){return{kind:kt.to(oe.kind)}}be.to=Se})(vi||(e.PartialAcceptInfo=vi={}));var kt;(function(be){function Se(oe){switch(oe){case 0:return u.PartialAcceptTriggerKind.Word;case 1:return u.PartialAcceptTriggerKind.Line;case 2:return u.PartialAcceptTriggerKind.Suggest;default:return u.PartialAcceptTriggerKind.Unknown}}be.to=Se})(kt||(e.PartialAcceptTriggerKind=kt={}));var Si;(function(be){function Se(oe,J){return{id:J,label:oe.label,description:oe.description,canEdit:oe.canEdit,collapsibleState:oe.collapsibleState||0,contextValue:oe.contextValue}}be.from=Se})(Si||(e.DebugTreeItem=Si={}))}),define(Ie[262],Ce([1,0,4,17,8,35]),function(le,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=void 0;let M=class{constructor(p,E){this.a=p.getProxy(I.$1M.MainThreadBulkEdits),this.b={getTextDocumentVersion:F=>E.getDocument(F)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,E,F){const D=new O.$uw(R.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(D,void 0,F?.isRefactoring??!1)}};e.$clc=M,e.$clc=M=Je([We(0,N.$oP)],M)}),define(Ie[263],Ce([1,0,18,11,44,5,41,6,66,15,2,20,4,8,7,225,26]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlc=void 0;class s{constructor(h,t,f,a,g){this.j=h,this.k=t,this.l=f,this.m=a,this.n=g,this.b=p.$ae.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(a){if(h.c){const g=new Error("Response stream has been closed");throw Error.captureStackTrace(g,a),g}};const h=this;this.b.reset();const f=a=>{typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,a)};this.g={markdown(a){t(this.markdown);const g=new m.$ZO(a),u=v.ChatResponseMarkdownPart.from(g);return f(u),this},markdownWithVulnerabilities(a,g){t(this.markdown),g&&(0,o.$GG)(h.j,"chatParticipantAdditions");const u=new m.$1O(a,g),S=v.ChatResponseMarkdownWithVulnerabilitiesPart.from(u);return f(S),this},filetree(a,g){t(this.filetree);const u=new m.$3O(a,g),S=v.ChatResponseFilesPart.from(u);return f(S),this},anchor(a,g){t(this.anchor);const u=new m.$4O(a,g),S=v.ChatResponseAnchorPart.from(u);return f(S),this},button(a){t(this.anchor);const g=new m.$6O(a),u=v.ChatResponseCommandButtonPart.from(g,h.m,h.n);return f(u),this},progress(a){t(this.progress);const g=new m.$5O(a),u=v.ChatResponseProgressPart.from(g);return f(u),this},reference(a){if(t(this.reference),"variableName"in a&&!a.value){const g=h.k.variables.variables.find(u=>u.name===a.variableName);if(g){let u;if(g.references?.length)u=g.references.map(S=>({kind:"reference",reference:{variableName:a.variableName,value:S.reference}}));else{const S=new m.$7O(a);u=[v.ChatResponseReferencePart.from(S)]}return u.forEach(S=>f(S)),this}}else{const g=new m.$7O(a),u=v.ChatResponseReferencePart.from(g);f(u)}return this},textEdit(a,g){t(this.textEdit),(0,o.$GG)(h.j,"chatParticipantAdditions");const u=new m.$8O(a,g),S=v.ChatResponseTextEditPart.from(u);return f(S),this},detectedParticipant(a,g){t(this.detectedParticipant),(0,o.$GG)(h.j,"chatParticipantAdditions");const u=new m.$2O(a,g),S=v.ChatResponseDetectedParticipantPart.from(u);return f(S),this},push(a){if(t(this.push),(a instanceof m.$8O||a instanceof m.$1O||a instanceof m.$2O)&&(0,o.$GG)(h.j,"chatParticipantAdditions"),a instanceof m.$7O)this.reference(a.value);else{const g=v.ChatResponsePart.from(a,h.m,h.n);f(g)}return this}}}return this.g}}class i extends b.$Vc{static{this.b=0}constructor(h,t,f){super(),this.n=t,this.s=f,this.c=new Map,this.j=this.B(new b.$5c),this.m=this.B(new b.$Uc),this.g=h.getProxy(d.$1M.MainThreadChatAgents2)}transferActiveChat(h){this.g.$transferActiveChatSession(h)}createChatAgent(h,t,f){const a=i.b++,g=new n(h,t,this.g,a,f);return this.c.set(a,g),this.g.$registerAgent(a,h.identifier,t,{},void 0),g.apiAgent}createDynamicChatAgent(h,t,f,a,g){const u=i.b++,S=new n(h,t,this.g,u,g);return this.c.set(u,S),this.g.$registerAgent(u,h.identifier,t,{isSticky:!0},{name:f,description:a}),S.apiAgent}async $invokeAgent(h,t,f,a){const g=this.c.get(h);if(!g)throw new Error(`[CHAT](${h}) CANNOT invoke agent because the agent is not registered`);let u=this.j.get(t.sessionId);u||(u=new b.$Uc,this.j.set(t.sessionId,u));const S=new s(g.extension,t,this.g,this.s.converter,u);try{const l=await this.t(t.agentId,f),w=g.invoke(v.ChatAgentRequest.to(t),{history:l},S.apiObject,a);return await(0,N.$jh)(Promise.resolve(w).then($=>{if($?.metadata)try{JSON.stringify($.metadata)}catch(k){const y=`result.metadata MUST be JSON.stringify-able. Got error: ${k.message}`;return this.n.error(`[${g.extension.identifier.value}] [@${g.id}] ${y}`,g.extension),{errorDetails:{message:y},timings:S.timings}}return{errorDetails:$?.errorDetails,timings:S.timings,metadata:$?.metadata}}),a)}catch(l){return this.n.error(l,g.extension),{errorDetails:{message:(0,R.$gj)(l),responseIsIncomplete:!0}}}finally{S.close()}}async t(h,t){const f=[];for(const a of t.history){const g=v.ChatAgentResult.to(a.result),u=h===a.request.agentId?g:{...g,metadata:void 0};f.push(new m.$9O(a.request.message,a.request.command,a.request.variables.variables.map(v.ChatAgentResolvedVariable.to),a.request.agentId));const S=(0,I.$Hb)(a.response.map(l=>v.ChatResponsePart.toContent(l,this.s.converter)));f.push(new m.$0O(S,u,a.request.agentId,a.request.command))}return f}$releaseSession(h){this.j.deleteAndDispose(h)}async $provideFollowups(h,t,f,a,g){const u=this.c.get(t);if(!u)return Promise.resolve([]);const S=await this.t(u.id,a),l=v.ChatAgentResult.to(f);return(await u.provideFollowups(l,{history:S},g)).filter(w=>{const $=!w.participant||M.Iterable.some(this.c.values(),k=>k.id===w.participant&&D.$Qm.equals(k.extension.identifier,u.extension.identifier));return $||this.n.warn(`[@${u.id}] ChatFollowup refers to an unknown participant: ${w.participant}`),$}).map(w=>v.ChatFollowup.from(w,h))}$acceptFeedback(h,t,f,a){const g=this.c.get(h);if(!g)return;const u=v.ChatAgentResult.to(t);let S;switch(f){case r.InteractiveSessionVoteDirection.Down:S=m.ChatResultFeedbackKind.Unhelpful;break;case r.InteractiveSessionVoteDirection.Up:S=m.ChatResultFeedbackKind.Helpful;break}g.acceptFeedback(Object.freeze(a?{result:u,kind:S,reportIssue:a}:{result:u,kind:S}))}$acceptAction(h,t,f){const a=this.c.get(h);if(!a||f.action.kind==="vote")return;const g=v.ChatAgentUserActionEvent.to(t,f,this.s.converter);g&&a.acceptAction(Object.freeze(g))}async $invokeCompletionProvider(h,t,f){const a=this.c.get(h);return a?(await a.invokeCompletionProvider(t,f)).map(u=>v.ChatAgentCompletionItem.from(u,this.s.converter,this.m)):[]}async $provideWelcomeMessage(h,t,f){const a=this.c.get(h);if(a)return await a.provideWelcomeMessage(v.ChatLocation.to(t),f)}async $provideSampleQuestions(h,t,f){const a=this.c.get(h);if(a)return(await a.provideSampleQuestions(v.ChatLocation.to(t),f)).map(g=>v.ChatFollowup.from(g,void 0))}}e.$dlc=i;class n{constructor(h,t,f,a,g){this.extension=h,this.id=t,this.u=f,this.w=a,this.x=g,this.n=new O.$ee,this.o=new O.$ee}acceptFeedback(h){this.n.fire(h)}acceptAction(h){this.o.fire(h)}async invokeCompletionProvider(h,t){return this.q?await this.q.provider.provideCompletionItems(h,t)??[]:[]}async provideFollowups(h,t,f){if(!this.b)return[];const a=await this.b.provideFollowups(h,t,f);return a?a.filter(g=>!(g&&"commandId"in g)).filter(g=>!(g&&"message"in g)):[]}async provideWelcomeMessage(h,t){if(!this.s)return[];const f=await this.s.provideWelcomeMessage(h,t);return f?f.map(a=>typeof a=="string"?a:v.MarkdownString.from(a)):[]}async provideSampleQuestions(h,t){if(!this.s||!this.s.provideSampleQuestions)return[];const f=await this.s.provideSampleQuestions(h,t);return f||[]}get apiAgent(){let h=!1,t=!1;const f=()=>{h||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof F.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof m.$ZN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:v.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:v.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:v.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),t=!1}))},a=this;return{get id(){return a.id},get fullName(){return(0,o.$GG)(a.extension,"defaultChatParticipant"),a.c??a.extension.displayName??a.extension.name},set fullName(g){(0,o.$GG)(a.extension,"defaultChatParticipant"),a.c=g,f()},get iconPath(){return a.d},set iconPath(g){a.d=g,f()},get requestHandler(){return a.x},set requestHandler(g){(0,E.$fg)(typeof g=="function","Invalid request handler"),a.x=g},get followupProvider(){return a.b},set followupProvider(g){a.b=g,f()},get isDefault(){return(0,o.$GG)(a.extension,"defaultChatParticipant"),a.g},set isDefault(g){(0,o.$GG)(a.extension,"defaultChatParticipant"),a.g=g,f()},get helpTextPrefix(){return(0,o.$GG)(a.extension,"defaultChatParticipant"),a.j},set helpTextPrefix(g){(0,o.$GG)(a.extension,"defaultChatParticipant"),a.j=g,f()},get helpTextVariablesPrefix(){return(0,o.$GG)(a.extension,"defaultChatParticipant"),a.k},set helpTextVariablesPrefix(g){(0,o.$GG)(a.extension,"defaultChatParticipant"),a.k=g,f()},get helpTextPostfix(){return(0,o.$GG)(a.extension,"defaultChatParticipant"),a.l},set helpTextPostfix(g){(0,o.$GG)(a.extension,"defaultChatParticipant"),a.l=g,f()},get isSecondary(){return(0,o.$GG)(a.extension,"defaultChatParticipant"),a.m},set isSecondary(g){(0,o.$GG)(a.extension,"defaultChatParticipant"),a.m=g,f()},get supportIssueReporting(){return(0,o.$GG)(a.extension,"chatParticipantAdditions"),a.p},set supportIssueReporting(g){(0,o.$GG)(a.extension,"chatParticipantAdditions"),a.p=g,f()},get onDidReceiveFeedback(){return a.n.event},set participantVariableProvider(g){if((0,o.$GG)(a.extension,"chatParticipantAdditions"),a.q=g,g){if(!g.triggerCharacters.length)throw new Error("triggerCharacters are required");a.u.$registerAgentCompletionsProvider(a.w,g.triggerCharacters)}else a.u.$unregisterAgentCompletionsProvider(a.w)},get participantVariableProvider(){return(0,o.$GG)(a.extension,"chatParticipantAdditions"),a.q},set welcomeMessageProvider(g){(0,o.$GG)(a.extension,"defaultChatParticipant"),a.s=g,f()},get welcomeMessageProvider(){return(0,o.$GG)(a.extension,"defaultChatParticipant"),a.s},onDidPerformAction:(0,o.$FG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(g){a.t=g,f()},get requester(){return a.t},dispose(){h=!0,a.b=void 0,a.n.dispose(),a.u.$unregisterAgent(a.w)}}}invoke(h,t,f,a){return this.x(h,t,f,a)}}}),define(Ie[264],Ce([1,0,14,6,4,8,7,26]),function(le,e,I,N,R,O,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=void 0;class p{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(R.$1M.MainThreadChatVariables)}async $resolveVariable(D,d,v,m){const r=this.b.get(D);if(r)try{if(r.resolver.resolve2){(0,b.$GG)(r.extension,"chatParticipantAdditions");const o=new E(d,this.c),s=await r.resolver.resolve2(r.data.name,{prompt:v},o.apiObject,m);if(s)return s.map(O.ChatVariable.from)}else{const o=await r.resolver.resolve(r.data.name,{prompt:v},m);if(o)return o.map(O.ChatVariable.from)}}catch(o){(0,I.$2)(o)}}registerVariableResolver(D,d,v,m){const r=p.a++;return this.b.set(r,{extension:D,data:{name:d,description:v},resolver:m}),this.c.$registerVariable(r,{name:d,description:v}),(0,N.$Tc)(()=>{this.b.delete(r),this.c.$unregisterVariable(r)})}}e.$elc=p;class E{constructor(D,d){this.c=D,this.d=d,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let d=function(m){if(D.a){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,m),r}};const D=this,v=m=>{this.d.$handleProgressChunk(this.c,m)};this.b={progress(m){d(this.progress);const r=new M.$5O(m),o=O.ChatResponseProgressPart.from(r);return v(o),this},reference(m){d(this.reference);const r=new M.$7O(m),o=O.ChatResponseReferencePart.from(r);return v(o),this},push(m){return d(this.push),m instanceof M.$7O?v(O.ChatResponseReferencePart.from(m)):m instanceof M.$5O&&v(O.ChatResponseProgressPart.from(m)),this}}}return this.b}}}),define(Ie[265],Ce([1,0,11,69,5,6,2,89,20,8,7,4,26]),function(le,e,I,N,R,O,M,b,p,E,F,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=v;function v(m,r,o){const s=m.getProxy(D.$1M.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new p.$Sm,r.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const w=this.b.get(l.handle);return w?w.value:l}else if(l&&l.$mid===7){const w=l,$=this.b.get(w.commentControlHandle);if(!$)return w;const k=$.getCommentThread(w.commentThreadHandle);return k?k.value:w}else if(l&&(l.$mid===9||l.$mid===8)){const w=this.b.get(l.thread.commentControlHandle);if(!w)return l;const $=w.getCommentThread(l.thread.commentThreadHandle);return $?l.$mid===8?$.value:{thread:$.value,text:l.text}:l}else if(l&&l.$mid===10){const w=this.b.get(l.thread.commentControlHandle);if(!w)return l;const $=w.getCommentThread(l.thread.commentThreadHandle);if(!$)return l;const k=l.commentUniqueId,y=$.getCommentByUniqueId(k);return y||l}else if(l&&l.$mid===11){const w=this.b.get(l.thread.commentControlHandle);if(!w)return l;const $=w.getCommentThread(l.thread.commentThreadHandle);if(!$)return l;const k=l.text,y=l.commentUniqueId,C=$.getCommentByUniqueId(y);return C?(typeof C.body=="string"?C.body=k:C.body=new F.$sN(k),C):l}return l}})}createCommentController(l,w,$){const k=i.a++,y=new c(l,k,w,$);this.b.set(y.handle,y);const C=this.c.get(l.identifier)||[];return C.push(y),this.c.set(l.identifier,C),y.value}async $createCommentThreadTemplate(l,w,$){const k=this.b.get(l);k&&k.$createCommentThreadTemplate(w,$)}async $setActiveComment(l,w){const $=this.b.get(l);$&&$.$setActiveComment(w??void 0)}async $updateCommentThreadTemplate(l,w,$){const k=this.b.get(l);k&&k.$updateCommentThreadTemplate(w,$)}$deleteCommentThread(l,w){this.b.get(l)?.$deleteCommentThread(w)}async $provideCommentingRanges(l,w,$){const k=this.b.get(l);if(!k||!k.commentingRangeProvider)return Promise.resolve(void 0);const y=await o.ensureDocumentData(M.URI.revive(w));return(0,I.$nh)(async()=>{const C=await k.commentingRangeProvider.provideCommentingRanges(y.document,$);let P;return Array.isArray(C)?P={ranges:C,fileComments:!1}:C?P={ranges:C.ranges||[],fileComments:C.fileComments||!1}:P=C??void 0,P}).then(C=>{let P;return C&&(P={ranges:C.ranges.map(W=>E.Range.from(W)),fileComments:C.fileComments}),P})}$toggleReaction(l,w,$,k,y){const C=this.b.get(l);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,I.$nh)(()=>{const P=C.getCommentThread(w);if(P){const W=P.getCommentByUniqueId(k.uniqueIdInThread);if(C!==void 0&&W&&C.reactionHandler)return C.reactionHandler(W,f(y))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,typeof l=="object"?((0,d.$GG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=l.resolved,this.b.applicability=l.applicability):this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,w,$,k,y,C,P,W){this.m=w,this.n=$,this.o=k,this.p=y,this.q=C,this.extensionDescription=P,this.r=W,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new R.$ee,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Wc,this.l.value=new O.$Uc,this.n===void 0&&(this.n=`${l}.${this.handle}`),s.$createCommentThread(w,this.handle,this.n,this.o,E.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{s.$deleteCommentThread(w,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(q){V.range=q},get comments(){return V.comments},set comments(q){V.comments=q},get collapsibleState(){return V.collapsibleState},set collapsibleState(q){V.collapsibleState=q},get canReply(){return V.canReply},set canReply(q){V.canReply=q},get contextValue(){return V.contextValue},set contextValue(q){V.contextValue=q},get label(){return V.label},set label(q){V.label=q},get state(){return V.state},set state(q){V.state=q},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Uc);const l=$=>Object.prototype.hasOwnProperty.call(this.b,$),w={};l("range")&&(w.range=E.Range.from(this.p)),l("label")&&(w.label=this.label),l("contextValue")&&(w.contextValue=this.contextValue??null),l("comments")&&(w.comments=this.q.map($=>h(this,$,this.k,this.extensionDescription))),l("collapsibleState")&&(w.collapseState=a(this.g)),l("canReply")&&(w.canReply=this.canReply),l("state")&&(w.state=g(this.h)),l("applicability")&&(w.applicability=u(this.h)),l("isTemplate")&&(w.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,w)}getCommentByUniqueId(l){for(const w of this.k){const $=w[0],k=w[1];if(l===k)return $}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}Je([(0,N.$1h)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,l?.resourceHints&&(0,d.$GG)(this.h,"commentingRangeHint"),s.$updateCommentingRanges(this.handle,l?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,d.$GG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,d.$GG)(this.h,"activeComment"),this.f}constructor(l,w,$,k){this.h=l,this.i=w,this.j=$,this.k=k,this.a=new Map,s.$registerCommentController(this.handle,$,k,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(C){y.options=C},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(C){y.commentingRangeProvider=C},get reactionHandler(){return y.reactionHandler},set reactionHandler(C){y.reactionHandler=C},get activeCommentThread(){return y.activeCommentThread},createCommentThread(C,P,W){return y.createCommentThread(C,P,W).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(l,w,$){w===void 0&&(0,d.$GG)(this.h,"fileComments");const k=new n(this.id,this.handle,void 0,l,w,$,this.h,!1);return this.a.set(k.handle,k),k}$setActiveComment(l){if(!l){this.e=void 0,this.f=void 0;return}const w=this.a.get(l.commentThreadHandle);w&&(this.e=l.uniqueIdInThread?w.getCommentByUniqueId(l.uniqueIdInThread):void 0,this.f=w)}$createCommentThreadTemplate(l,w){const $=new n(this.id,this.handle,void 0,M.URI.revive(l),E.Range.to(w),[],this.h,!0);return $.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set($.handle,$),$}$updateCommentThreadTemplate(l,w){const $=this.a.get(l);$&&($.range=E.Range.to(w))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.g.forEach(l=>l.dispose())}}function h(S,l,w,$){let k=w.get(l);return k||(k=++S.commentHandle,w.set(l,k)),l.state!==void 0&&(0,d.$GG)($,"commentsDraftState"),l.reactions?.some(y=>y.reactors!==void 0)&&(0,d.$GG)($,"commentReactor"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:k,body:typeof l.body=="string"?l.body:E.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(y=>t(y)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(S){return{label:S.label,iconPath:S.iconPath?E.$nP(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted,reactors:S.reactors&&S.reactors.length>0&&typeof S.reactors[0]!="string"?S.reactors.map(l=>l.name):S.reactors}}function f(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?M.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1,reactors:S.reactors?.map(l=>({name:l}))}}function a(S){if(S!==void 0)switch(S){case F.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function g(S){let l;if(typeof S=="object"?l=S.resolved:l=S,l!==void 0)switch(l){case F.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case F.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function u(S){let l;if(typeof S=="object"&&(l=S.applicability),l!==void 0)switch(l){case F.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case F.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new i}}),define(Ie[266],Ce([1,0,24,73,6,16,23,2,8,64,76,4,7]),function(le,e,I,N,R,O,M,b,p,E,F,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=void 0;class v{constructor(f,a){this.document=f,this.b=a,this.a=1,this.c=new F.$1kc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,a){await this.f(f).undo(),a||this.disposeBackup()}async redo(f,a){await this.f(f).redo(),a||this.disposeBackup()}disposeEdits(f){for(const a of f)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=h(this.document.uri)+this.a++;return(0,M.$9g)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const a=this.c.get(f,0);if(!a)throw new Error("No edit found");return a}}class m{constructor(){this.a=new Map}get(f,a){return this.a.get(this.b(f,a))}add(f,a,g){const u=this.b(f,a.uri);if(this.a.has(u))throw new Error(`Document already exists for viewType:${f} resource:${a.uri}`);const S=new v(a,g);return this.a.set(u,S),S}delete(f,a){const g=this.b(f,a.uri);this.a.delete(g)}b(f,a){return`${f}@@@${a}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(f,a,g){return this.b(0,f,a,g)}addCustomProvider(f,a,g){return this.b(1,f,a,g)}get(f){return this.a.get(f)}b(f,a,g,u){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:f,extension:g,provider:u}),new d.$3M(()=>this.a.delete(a))}}class s{constructor(f,a,g,u,S){this.d=a,this.f=g,this.g=u,this.h=S,this.b=new o,this.c=new m,this.a=f.getProxy(D.$1M.MainThreadCustomEditors)}registerCustomEditorProvider(f,a,g,u){const S=new R.$Uc;return n(g)?(S.add(this.b.addTextProvider(a,f,g)),this.a.$registerTextEditorProvider((0,E.$xlc)(f),a,u.webviewOptions||{},{supportsMove:!!g.moveCustomTextEditor},(0,E.$vlc)(f))):(S.add(this.b.addCustomProvider(a,f,g)),i(g)&&S.add(g.onDidChangeCustomDocument(l=>{const w=this.i(a,l.document.uri);if(c(l)){const $=w.addEdit(l);this.a.$onDidEdit(l.document.uri,a,$,l.label)}else this.a.$onContentChange(l.document.uri,a)})),this.a.$registerCustomEditorProvider((0,E.$xlc)(f),a,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,E.$vlc)(f))),d.$3M.from(S,new d.$3M(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(f,a,g,u,S){const l=this.b.get(a);if(!l)throw new Error(`No provider found for '${a}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${a}'`);const w=b.URI.revive(f),$=await l.provider.openCustomDocument(w,{backupId:g,untitledDocumentData:u?.buffer},S);let k;return i(l.provider)&&this.f&&(k=this.f.workspaceValue(l.extension)??this.f.globalValue(l.extension)),this.c.add(a,$,k),{editable:i(l.provider)}}async $disposeCustomDocument(f,a){const g=this.b.get(a);if(!g)throw new Error(`No provider found for '${a}'`);if(g.type!==1)throw new Error(`Invalid provider type for '${a}'`);const u=b.URI.revive(f),{document:S}=this.i(a,u);this.c.delete(a,S),S.dispose()}async $resolveCustomEditor(f,a,g,u,S,l){const w=this.b.get(g);if(!w)throw new Error(`No provider found for '${g}'`);const $=p.ViewColumn.to(S),k=this.g.createNewWebview(a,u.contentOptions,w.extension),y=this.h.createNewWebviewPanel(a,g,u.title,$,u.options,k,u.active),C=b.URI.revive(f);switch(w.type){case 1:{const{document:P}=this.i(g,C);return w.provider.resolveCustomEditor(P,y,l)}case 0:{const P=this.d.getDocument(C);return w.provider.resolveCustomTextEditor(P,y,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,a,g){this.i(a,f).disposeEdits(g)}async $onMoveCustomEditor(f,a,g){const u=this.b.get(g);if(!u)throw new Error(`No provider found for '${g}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${g}'`);const S=this.h.getWebviewPanel(f);if(!S)throw new Error("No webview found");const l=b.URI.revive(a),w=this.d.getDocument(l);await u.provider.moveCustomTextEditor(w,S,I.CancellationToken.None)}async $undo(f,a,g,u){return this.i(a,f).undo(g,u)}async $redo(f,a,g,u){return this.i(a,f).redo(g,u)}async $revert(f,a,g){const u=this.i(a,f);await this.j(a).revertCustomDocument(u.document,g),u.disposeBackup()}async $onSave(f,a,g){const u=this.i(a,f);await this.j(a).saveCustomDocument(u.document,g),u.disposeBackup()}async $onSaveAs(f,a,g,u){const S=this.i(a,f);return this.j(a).saveCustomDocumentAs(S.document,b.URI.revive(g),u)}async $backup(f,a,g){const u=this.i(a,f),l=await this.j(a).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},g);return u.updateBackup(l),l.id}i(f,a){const g=this.c.get(f,b.URI.revive(a));if(!g)throw new Error("No custom document found");return g}j(f){const g=this.b.get(f)?.provider;if(!g||!i(g))throw new Error("Custom document is not editable");return g}}e.$Alc=s;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const f=t.scheme===O.Schemas.file||t.scheme===O.Schemas.untitled?t.fsPath:t.toString();return(0,N.$jj)(f)+""}}),define(Ie[267],Ce([1,0,172,101,2,4,7,8,5,12,28,46]),function(le,e,I,N,R,O,M,b,p,E,F,D){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$9kc=e.$8kc=void 0;class v{#e;#t;#i;constructor(o,s,i,n,c,h,t,f){this.d=o,this.e=s,this.f=i,this.g=n,this.h=c,this.c=!1,this.f=Math.max(n,i),this.#i=new F.$Bc(a=>h.getComparisonKey(a)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,s){if(!o){this.clear();return}this.j();let i=[];if(R.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),i=[o]}else if(Array.isArray(o)){i=[];let h;o=[...o].sort(v.k);for(const t of o){const[f,a]=t;if((!h||f.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=f,i.push(f),this.#i.set(f,[])),a)this.#i.get(f)?.push(...a);else{const g=this.#i.get(f);g&&(g.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let c=0;for(const h of i){let t=[];const f=this.#i.get(h);if(f)if(f.length>this.g){t=[];const a=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let g=0;g<4;g++)for(const u of f)if(u.severity===a[g]&&t.push({...b.Diagnostic.from(u),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,I.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(a=>({...b.Diagnostic.from(a),modelVersionId:this.h(h)}));if(n.push([h,t]),c+=t.length,c>this.f)break}this.#e.$changeMany(this.e,n)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,s){this.j();for(const[i,n]of this)o.call(s,i,n,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.$8kc=v;let m=class{static{d=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*d.d}static _mapper(o){const s=new F.$Bc;for(const i of o)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,i,n){this.j=s,this.k=i,this.l=n,this.g=new Map,this.h=new p.$ie({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,d._mapper),this.f=o.getProxy(O.$1M.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{g:i,f:n,h:c,j:h,k:t,l:f}=this,a=new class{$changeMany(S,l){n.$changeMany(S,l),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,S,l.length===0?"CLEARING":l)}$clear(S){n.$clear(S),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,S)}dispose(){n.dispose()}};let g;if(!s)s="_generated_diagnostic_collection_name_#"+d.c++,g=s;else if(!i.has(s))g=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do g=s+d.c++;while(i.has(g))}return new class extends v{constructor(){super(s,g,d.e,d.d,S=>f.getDocument(S)?.version,t.extUri,a,c),i.set(g,this)}dispose(){super.dispose(),i.delete(g)}}}getDiagnostics(o){if(o)return this.m(o);{const s=new Map,i=[];for(const n of this.g.values())n.forEach((c,h)=>{let t=s.get(c.toString());typeof t>"u"&&(t=i.length,s.set(c.toString(),t),i.push([c,[]])),i[t][1]=i[t][1].concat(...h)});return i}}m(o){let s=[];for(const i of this.g.values())i.has(o)&&(s=s.concat(i.get(o)));return s}$acceptMarkersChange(o){if(!this.n){const s="_generated_mirror",i=new v(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(s,i),this.n=i}for(const[s,i]of o)this.n.set(R.URI.revive(s),i.map(b.Diagnostic.to))}};e.$9kc=m,e.$9kc=m=d=Je([We(1,E.$2j),We(2,D.$7kc)],m)}),define(Ie[268],Ce([1,0,2,14,7,8,200,35]),function(le,e,I,N,R,O,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=void 0;class p{constructor(F,D,d,v={timeout:1500,errors:3}){this.c=F,this.d=D,this.f=d,this.g=v,this.a=new M.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(F){return(D,d,v)=>{const r={dispose:this.a.push([D,d,F])};return Array.isArray(v)&&v.push(r),r}}async $participateInSave(F,D){const d=I.URI.revive(F);let v=!1;const m=setTimeout(()=>v=!0,this.g.timeout),r=[];try{for(const o of[...this.a]){if(v)break;const s=this.d.getDocument(d),i=await this.h(o,{document:s,reason:O.TextDocumentSaveReason.to(D)});r.push(i)}}finally{clearTimeout(m)}return r}h([F,D,d],v){const m=this.b.get(F);return typeof m=="number"&&m>this.g.errors?Promise.resolve(!1):this.i(d,F,D,v).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${d.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this.b.get(F);this.b.set(F,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${d.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(F,D,d,v){const m=[],r=Date.now(),{document:o,reason:s}=v,{version:i}=o,n=Object.freeze({document:o,reason:s,waitUntil(c){if(Object.isFrozen(m))throw(0,N.$8)("waitUntil can not be called async");m.push(Promise.resolve(c))}});try{D.apply(d,[n])}catch(c){return Promise.reject(c)}return Object.freeze(m),new Promise((c,h)=>{const t=setTimeout(()=>h(new Error("timeout")),this.g.timeout);return Promise.all(m).then(f=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${F.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(t),c(f)}).catch(f=>{clearTimeout(t),h(f)})}).then(c=>{const h={edits:[]};for(const t of c)if(Array.isArray(t)&&t.every(f=>f instanceof R.$0M))for(const{newText:f,newEol:a,range:g}of t)h.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:g&&O.Range.from(g),text:f,eol:a&&O.EndOfLine.from(a)}});if(h.edits.length!==0)return i===o.version?this.f.$tryApplyWorkspaceEdit(new b.$uw(h)):Promise.reject(new Error("concurrent_edits"))})}}e.$emc=p}),define(Ie[269],Ce([1,0,5,6,2,4,113,8,15,25,7]),function(le,e,I,N,R,O,M,b,p,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=void 0;class D{constructor(v,m){this.a=new I.$ee,this.b=new I.$ee,this.c=new I.$ee,this.d=new I.$ee,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Uc,this.h=new Map,this.f=v.getProxy(O.$1M.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const m=this.g.getDocument(v);if(m)return m}getDocument(v){const m=this.getDocumentData(v);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return m.document}ensureDocumentData(v){const m=this.g.getDocument(v);if(m)return Promise.resolve(m);let r=this.h.get(v.toString());return r||(r=this.f.$tryOpenDocument(v).then(o=>{this.h.delete(v.toString());const s=R.URI.revive(o);return(0,p.$gg)(this.g.getDocument(s))},o=>(this.h.delete(v.toString()),Promise.reject(o))),this.h.set(v.toString(),r)),r}createDocumentData(v){return this.f.$tryCreateDocument(v).then(m=>R.URI.revive(m))}$acceptModelLanguageChanged(v,m){const r=R.URI.revive(v),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(m),this.a.fire(o.document)}$acceptModelSaved(v){const m=R.URI.revive(v),r=this.g.getDocument(m);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(v,m){const r=R.URI.revive(v),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(m),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,m,r){const o=R.URI.revive(v),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(m);let i;m.isUndoing?i=F.TextDocumentChangeReason.Undo:m.isRedoing&&(i=F.TextDocumentChangeReason.Redo),this.c.fire((0,E.$3n)({document:s.document,contentChanges:m.changes.map(n=>({range:b.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(v,m){(0,M.$qP)(v,m)}}e.$0kc=D}),define(Ie[67],Ce([1,0,270,5,15,2,3,4,17,8,7]),function(le,e,I,N,R,O,M,b,p,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clc=e.$Blc=void 0,e.$Blc=(0,M.$vi)("IExtHostEditorTabs");class D{constructor(o,s,i){this.e=i,this.d=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new F.$NO(O.URI.revive(this.b.input.uri));case 2:return new F.$OO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case 3:return new F.$PO(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case 6:return new F.$QO(O.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new F.$RO(this.b.input.viewType);case 4:return new F.$SO(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new F.$TO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new F.$UO;case 9:return new F.$VO(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case 10:return new F.$WO;case 11:return new F.$XO(this.b.input.diffEditors.map(o=>new F.$OO(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class d{constructor(o,s){this.c=[],this.d="",this.b=o,this.e=s;for(const i of o.tabs)i.isActive&&(this.d=i.id),this.c.push(new D(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return E.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(i=>i.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(i=>i.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const i=new D(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,i),o.tabDto.isActive&&(this.d=i.tabId),i}else if(o.kind===1){const i=this.c.splice(o.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(o.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,i),i}const s=this.c.find(i=>i.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this.d}}let v=class{constructor(o){this.b=new N.$ee,this.c=new N.$ee,this.e=[],this.a=o.getProxy(b.$1M.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,s={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(i=>i.apiObject))},get activeTabGroup(){const i=o.d;return(0,R.$gg)(o.e.find(c=>c.groupId===i)?.apiObject)},close:async(i,n)=>{const c=Array.isArray(i)?i:[i];return c.length?m(c[0])?this.j(c,n):this.i(c,n):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(o){const s=new Set(this.e.map(a=>a.groupId)),i=new Set(o.map(a=>a.groupId)),n=(0,I.$L)(s,i),c=this.e.filter(a=>n.removed.includes(a.groupId)).map(a=>a.apiObject),h=[],t=[];this.e=o.map(a=>{const g=new d(a,()=>this.d);return n.added.includes(g.groupId)?h.push(g.apiObject):t.push(g.apiObject),g});const f=(0,R.$gg)(o.find(a=>a.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:h,closed:c,changed:t}))}$acceptTabGroupUpdate(o){const s=this.e.find(i=>i.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this.e.find(n=>n.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(o){for(const s of this.e)for(const i of s.tabs)if(i.apiObject===o)return i}h(o){return this.e.find(s=>s.apiObject===o)}async i(o,s){const i=[];for(const n of o){const c=this.g(n);if(!c)throw new Error("Tab close: Invalid tab not found!");i.push(c.tabId)}return this.a.$closeTab(i,s)}async j(o,s){const i=[];for(const n of o){const c=this.h(n);if(!c)throw new Error("Group close: Invalid group not found!");i.push(c.groupId)}return this.a.$closeGroup(i,s)}};e.$Clc=v,e.$Clc=v=Je([We(0,p.$oP)],v);function m(r){return r.tabs!==void 0}}),define(Ie[271],Ce([1,0,2,4,6,7,8,314,13,21,26,55]),function(le,e,I,N,R,O,M,b,p,E,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=void 0;class d{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const o=this.a.indexOf(r);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),o=[];let s,i,n=14,c=14;for(const h of r){let t=s?(0,p.$zf)(s,h):0;for(t===0?i=1:i=c;t<h.length;t++)t+1===h.length?(n=c,c=9):c+=1,o.push([i,h.toUpperCase().charCodeAt(t),c]),o.push([i,h.toLowerCase().charCodeAt(t),c]),i=c;s=h,c=n}o.push([9,58,10]),o.push([10,47,12]),this.b=new b.$i3(o)}}provideDocumentLinks(r){this.c();const o=[],s=b.$j3.computeLinks({getLineContent(i){return r.lineAt(i-1).text},getLineCount(){return r.lineCount}},this.b);for(const i of s){const n=M.DocumentLink.to(i);n.target&&o.push(n)}return o}}class v{constructor(r,o){this.i=o,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(N.$1M.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,o,s,i={}){if(v.j(s),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const n=this.h++;this.b.add(o),this.d.add(o),this.c.set(n,s);let c=2;i.isCaseSensitive&&(c+=1024),i.isReadonly&&(c+=2048),typeof s.copy=="function"&&(c+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,F.$GG)(r,"fsChunks"),c+=4);let h;i.isReadonly&&(0,D.$Uk)(i.isReadonly)&&i.isReadonly.value!==""&&(h={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,o,c,h).catch(f=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${o}`),console.error(f)});const t=s.onDidChangeFile(f=>{const a=[];for(const g of f){const{uri:u,type:S}=g;if(u.scheme!==o)continue;let l;switch(S){case O.FileChangeType.Changed:l=0;break;case O.FileChangeType.Created:l=1;break;case O.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:u,type:l})}this.a.$onFileSystemChange(n,a)});return(0,R.$Tc)(()=>{t.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:o,ctime:s,mtime:i,size:n,permissions:c}=r;return{type:o,ctime:s,mtime:i,size:n,permissions:c}}$stat(r,o){return Promise.resolve(this.l(r).stat(I.URI.revive(o))).then(s=>v.k(s))}$readdir(r,o){return Promise.resolve(this.l(r).readDirectory(I.URI.revive(o)))}$readFile(r,o){return Promise.resolve(this.l(r).readFile(I.URI.revive(o))).then(s=>E.$Fe.wrap(s))}$writeFile(r,o,s,i){return Promise.resolve(this.l(r).writeFile(I.URI.revive(o),s.buffer,i))}$delete(r,o,s){return Promise.resolve(this.l(r).delete(I.URI.revive(o),s))}$rename(r,o,s,i){return Promise.resolve(this.l(r).rename(I.URI.revive(o),I.URI.revive(s),i))}$copy(r,o,s,i){const n=this.l(r);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(I.URI.revive(o),I.URI.revive(s),i))}$mkdir(r,o){return Promise.resolve(this.l(r).createDirectory(I.URI.revive(o)))}$watch(r,o,s,i){const n=this.l(r).watch(I.URI.revive(s),i);this.f.set(o,n)}$unwatch(r,o){const s=this.f.get(o);s&&(s.dispose(),this.f.delete(o))}$open(r,o,s){const i=this.l(r);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(I.URI.revive(o),s))}$close(r,o){const s=this.l(r);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(r,o,s,i){const n=this.l(r);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const c=E.$Fe.alloc(i);return Promise.resolve(n.read(o,s,c.buffer,0,i)).then(h=>c.slice(0,h))}$write(r,o,s,i){const n=this.l(r);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(o,s,i.buffer,0,i.byteLength))}l(r){const o=this.c.get(r);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.$gmc=v}),define(Ie[272],Ce([1,0,5,36,2,4,8,7,42]),function(le,e,I,N,R,O,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,m,r,o,s,i){this.a=Math.random(),this.b=new I.$ee,this.c=new I.$ee,this.d=new I.$ee,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,N.$pk)(s),c=typeof s=="string",h=i?.correlate,t=o(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(h&&typeof f.session>"u")){if(!i?.ignoreCreateEvents)for(const a of f.created){const g=R.URI.revive(a);n(g.fsPath)&&(!c||m.getWorkspaceFolder(g))&&this.b.fire(g)}if(!i?.ignoreChangeEvents)for(const a of f.changed){const g=R.URI.revive(a);n(g.fsPath)&&(!c||m.getWorkspaceFolder(g))&&this.c.fire(g)}if(!i?.ignoreDeleteEvents)for(const a of f.deleted){const g=R.URI.revive(a);n(g.fsPath)&&(!c||m.getWorkspaceFolder(g))&&this.d.fire(g)}}});this.g=b.$3M.from(this.i(v,r,s,i,i?.correlate),this.b,this.c,this.d,t)}i(v,m,r,o,s){const i=b.$3M.from();if(typeof r=="string"||o?.ignoreChangeEvents&&o?.ignoreCreateEvents&&o?.ignoreDeleteEvents)return i;const n=v.getProxy(O.$1M.MainThreadFileSystemEventService);let c=!1;(r.pattern.includes(N.$lk)||r.pattern.includes(N.$mk))&&(c=!0);let h;return s&&(o?.ignoreChangeEvents||o?.ignoreCreateEvents||o?.ignoreDeleteEvents)&&(h=14,o?.ignoreChangeEvents&&(h&=-3),o?.ignoreCreateEvents&&(h&=-5),o?.ignoreDeleteEvents&&(h&=-9)),n.$watch(m.identifier.value,this.a,r.baseUri,{recursive:c,excludes:o?.excludes??[],filter:h},!!s),b.$3M.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class F{constructor(v){this.a=v,this.session=this.a.session,this.b=new p.$V(()=>this.a.created.map(R.URI.revive)),this.c=new p.$V(()=>this.a.changed.map(R.URI.revive)),this.d=new p.$V(()=>this.a.deleted.map(R.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(v,m,r){this.j=v,this.k=m,this.l=r,this.a=new I.$ee,this.b=new I.$ee,this.c=new I.$ee,this.d=new I.$ee,this.g=new I.$ge,this.h=new I.$ge,this.i=new I.$ge,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,m,r,o){return new E(this.j,v,m,this.a.event,M.GlobPattern.from(r),o)}$onFileEvent(v){this.a.fire(new F(v))}$onDidRunFileOperation(v,m){switch(v){case 2:this.b.fire(Object.freeze({files:m.map(r=>({oldUri:R.URI.revive(r.source),newUri:R.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(r=>R.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(r=>R.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,m){return(r,o,s)=>{const i=function(c){r.call(o,c)};return i.extension=v,m.event(i,void 0,s)}}async $onWillRunFileOperation(v,m,r,o){switch(v){case 2:return await this.n(this.g,{files:m.map(s=>({oldUri:R.URI.revive(s.source),newUri:R.URI.revive(s.target)}))},r,o);case 1:return await this.n(this.i,{files:m.map(s=>R.URI.revive(s.target))},r,o);case 0:case 3:return await this.n(this.h,{files:m.map(s=>R.URI.revive(s.target))},r,o)}}async n(v,m,r,o){const s=new Set,i=[];if(await v.fireAsync(m,o,async(c,h)=>{const t=Date.now(),f=await Promise.resolve(c);f instanceof b.$aN&&(i.push([h.extension,f]),s.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,c]of i){const{edits:h}=M.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(h)}return{edit:n,extensionNames:Array.from(s)}}}e.$hmc=D}),define(Ie[273],Ce([1,0,18,11,24,14,91,6,25,66,13,15,2,30,315,89,98,174,20,8,7,26,76,4]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o,s,i,n,c,h,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;class a{constructor(j,T){this.d=j,this.e=T}async provideDocumentSymbols(j,T){const G=this.d.getDocument(j),H=await this.e.provideDocumentSymbols(G,T);if(!(0,I.$Kb)(H))return H[0]instanceof c.$kN?H.map(n.DocumentSymbol.from):a.f(H)}static f(j){j=j.slice(0).sort((H,ee)=>{let ne=H.location.range.start.compareTo(ee.location.range.start);return ne===0&&(ne=ee.location.range.end.compareTo(H.location.range.end)),ne});const T=[],G=[];for(const H of j){const ee={name:H.name||"!!MISSING: name!!",kind:n.SymbolKind.from(H.kind),tags:H.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:n.Range.from(H.location.range),selectionRange:n.Range.from(H.location.range),children:[]};for(;;){if(G.length===0){G.push(ee),T.push(ee);break}const ne=G[G.length-1];if(v.$tt.containsRange(ne.range,ee.range)&&!v.$tt.equalsRange(ne.range,ee.range)){ne.children?.push(ee),G.push(ee);break}G.pop()}}return T}}class g{constructor(j,T,G,H,ee,ne){this.f=j,this.g=T,this.h=G,this.j=H,this.k=ee,this.l=ne,this.d=new t.$1kc("CodeLens"),this.e=new Map}async provideCodeLenses(j,T){const G=this.f.getDocument(j),H=await this.h.provideCodeLenses(G,T);if(!H||T.isCancellationRequested)return;const ee=this.d.add(H),ne=new b.$Uc;this.e.set(ee,ne);const Oe={cacheId:ee,lenses:[]};for(let Be=0;Be<H.length;Be++)Oe.lenses.push({cacheId:[ee,Be],range:n.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,ne)});return Oe}async resolveCodeLens(j,T){const G=j.cacheId&&this.d.get(...j.cacheId);if(!G)return;let H;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?H=G:H=await this.h.resolveCodeLens(G,T),H||(H=G),T.isCancellationRequested)return;const ee=j.cacheId&&this.e.get(j.cacheId[0]);if(ee){if(!H.command){const ne=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ne),this.l.error(ne);return}return j.command=this.g.toInternal(H.command,ee),j}}releaseCodeLenses(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}}function u(Ue){return Array.isArray(Ue)?Ue.map(n.DefinitionLink.from):Ue?[n.DefinitionLink.from(Ue)]:[]}class S{constructor(j,T){this.d=j,this.e=T}async provideDefinition(j,T,G){const H=this.d.getDocument(j),ee=n.Position.to(T),ne=await this.e.provideDefinition(H,ee,G);return u(ne)}}class l{constructor(j,T){this.d=j,this.e=T}async provideDeclaration(j,T,G){const H=this.d.getDocument(j),ee=n.Position.to(T),ne=await this.e.provideDeclaration(H,ee,G);return u(ne)}}class w{constructor(j,T){this.d=j,this.e=T}async provideImplementation(j,T,G){const H=this.d.getDocument(j),ee=n.Position.to(T),ne=await this.e.provideImplementation(H,ee,G);return u(ne)}}class ${constructor(j,T){this.d=j,this.e=T}async provideTypeDefinition(j,T,G){const H=this.d.getDocument(j),ee=n.Position.to(T),ne=await this.e.provideTypeDefinition(H,ee,G);return u(ne)}}class k{static{this.f=10}constructor(j,T){this.g=j,this.h=T,this.d=0,this.e=new Map}async provideHover(j,T,G,H){const ee=this.g.getDocument(j),ne=n.Position.to(T);let Oe;if(G&&G.previousHover!==void 0&&G.action!==void 0){const xe=G.previousHover.id,et=this.e.get(xe);if(!et)throw new Error(`Hover with id ${xe} not found`);const tt={action:G.action,previousHover:et};Oe=await this.h.provideHover(ee,ne,H,tt)}else Oe=await this.h.provideHover(ee,ne,H);if(!Oe||(0,I.$Kb)(Oe.contents))return;Oe.range||(Oe.range=ee.getWordRangeAtPosition(ne)),Oe.range||(Oe.range=new c.$5M(ne,ne));const Be=n.Hover.from(Oe),Ke=this.d;if(this.e.size===k.f){const xe=Math.min(...this.e.keys());this.e.delete(xe)}return this.e.set(Ke,Oe),this.d+=1,{...Be,id:Ke}}releaseHover(j){this.e.delete(j)}}class y{constructor(j,T){this.d=j,this.e=T}async provideEvaluatableExpression(j,T,G){const H=this.d.getDocument(j),ee=n.Position.to(T),ne=await this.e.provideEvaluatableExpression(H,ee,G);if(ne)return n.EvaluatableExpression.from(ne)}}class C{constructor(j,T){this.d=j,this.e=T}async provideInlineValues(j,T,G,H){const ee=this.d.getDocument(j),ne=await this.e.provideInlineValues(ee,n.Range.to(T),n.InlineValueContext.to(G),H);if(Array.isArray(ne))return ne.map(Oe=>n.InlineValue.from(Oe))}}class P{constructor(j,T){this.d=j,this.e=T}async provideDocumentHighlights(j,T,G){const H=this.d.getDocument(j),ee=n.Position.to(T),ne=await this.e.provideDocumentHighlights(H,ee,G);if(Array.isArray(ne))return ne.map(n.DocumentHighlight.from)}}class W{constructor(j,T){this.d=j,this.e=T}async provideMultiDocumentHighlights(j,T,G,H){const ee=this.d.getDocument(j),ne=G.map(Ke=>this.d.getDocument(Ke)),Oe=n.Position.to(T),Be=await this.e.provideMultiDocumentHighlights(ee,Oe,ne,H);if(Array.isArray(Be))return Be.map(n.MultiDocumentHighlight.from)}}class V{constructor(j,T){this.d=j,this.e=T}async provideLinkedEditingRanges(j,T,G){const H=this.d.getDocument(j),ee=n.Position.to(T),ne=await this.e.provideLinkedEditingRanges(H,ee,G);if(ne&&Array.isArray(ne.ranges))return{ranges:(0,I.$Hb)(ne.ranges.map(n.Range.from)),wordPattern:ne.wordPattern}}}class q{constructor(j,T){this.d=j,this.e=T}async provideReferences(j,T,G,H){const ee=this.d.getDocument(j),ne=n.Position.to(T),Oe=await this.e.provideReferences(ee,ne,G,H);if(Array.isArray(Oe))return Oe.map(n.location.from)}}class A{static{this.d=1e3}constructor(j,T,G,H,ee,ne,Oe){this.g=j,this.h=T,this.j=G,this.k=H,this.l=ee,this.m=ne,this.n=Oe,this.e=new t.$1kc("CodeAction"),this.f=new Map}async provideCodeActions(j,T,G,H){const ee=this.g.getDocument(j),ne=m.$vt.isISelection(T)?n.Selection.to(T):n.Range.to(T),Oe=[];for(const tt of this.j.getDiagnostics(j))if(ne.intersection(tt.range)&&Oe.push(tt)>A.d)break;const Be={diagnostics:Oe,only:G.only?new c.$mN(G.only):void 0,triggerKind:n.CodeActionTriggerKind.to(G.trigger)},Ke=await this.k.provideCodeActions(ee,ne,Be,H);if(!(0,I.$Lb)(Ke)||H.isCancellationRequested)return;const _e=this.e.add(Ke),xe=new b.$Uc;this.f.set(_e,xe);const et=[];for(let tt=0;tt<Ke.length;tt++){const nt=Ke[tt];if(nt)if(A.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,xe)});else{Be.only&&(nt.kind?Be.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=nt.ranges??[];et.push({cacheId:[_e,tt],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,xe),diagnostics:nt.diagnostics&&nt.diagnostics.map(n.Diagnostic.from),edit:nt.edit&&n.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,h.$FG)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,h.$FG)(this.m,"codeActionRanges")?(0,I.$Hb)(ct.map(n.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:_e,actions:et}}async resolveCodeAction(j,T){const[G,H]=j,ee=this.e.get(G,H);if(!ee||A.o(ee))return{};if(!this.k.resolveCodeAction)return{};const ne=await this.k.resolveCodeAction(ee,T)??ee;let Oe;ne.edit&&(Oe=n.WorkspaceEdit.from(ne.edit,void 0));let Be;if(ne.command){const Ke=this.f.get(G);Ke&&(Be=this.h.toInternal(ne.command,Ke))}return{edit:Oe,command:Be}}releaseCodeActions(j){this.f.get(j)?.dispose(),this.f.delete(j),this.e.delete(j)}static o(j){return typeof j.command=="string"&&typeof j.title=="string"}}class U{constructor(j,T,G,H,ee){this.e=j,this.f=T,this.g=G,this.h=H,this.j=ee,this.d=new t.$1kc("DocumentPasteEdit")}async prepareDocumentPaste(j,T,G,H){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(j),ne=T.map(Ke=>n.Range.to(Ke)),Oe=n.DataTransfer.toDataTransfer(G,()=>{throw new O.$$});if(await this.g.prepareDocumentPaste(ee,ne,Oe,H),H.isCancellationRequested)return;const Be=Array.from(Oe).filter(([,Ke])=>!(Ke instanceof c.$SN));return n.DataTransfer.from(Be)}async providePasteEdits(j,T,G,H,ee,ne){if(!this.g.provideDocumentPasteEdits)return[];const Oe=this.f.getDocument(T),Be=G.map(et=>n.Range.to(et)),Ke=n.DataTransfer.toDataTransfer(H,async et=>(await this.e.$resolvePasteFileData(this.h,j,et)).buffer),_e=await this.g.provideDocumentPasteEdits(Oe,Be,Ke,{only:ee.only?new c.$XN(ee.only):void 0,triggerKind:ee.triggerKind},ne);if(!_e||ne.isCancellationRequested)return[];const xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,s.localize)(0,null,this.j.displayName||this.j.name),kind:et.kind,yieldTo:et.yieldTo?.map(nt=>nt.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?n.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolvePasteEdit(j,T){const[G,H]=j,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const ne=await this.g.resolveDocumentPasteEdit(ee,T)??ee;return{additionalEdit:ne.additionalEdit?n.WorkspaceEdit.from(ne.additionalEdit,void 0):void 0}}releasePasteEdits(j){this.d.delete(j)}}class K{constructor(j,T){this.d=j,this.e=T}async provideDocumentFormattingEdits(j,T,G){const H=this.d.getDocument(j),ee=await this.e.provideDocumentFormattingEdits(H,T,G);if(Array.isArray(ee))return ee.map(n.TextEdit.from)}}class re{constructor(j,T){this.d=j,this.e=T}async provideDocumentRangeFormattingEdits(j,T,G,H){const ee=this.d.getDocument(j),ne=n.Range.to(T),Oe=await this.e.provideDocumentRangeFormattingEdits(ee,ne,G,H);if(Array.isArray(Oe))return Oe.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(j,T,G,H){(0,D.$fg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(j),ne=T.map(n.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(ee,ne,G,H);if(Array.isArray(Oe))return Oe.map(n.TextEdit.from)}}class ae{constructor(j,T){this.d=j,this.e=T,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,T,G,H,ee){const ne=this.d.getDocument(j),Oe=n.Position.to(T),Be=await this.e.provideOnTypeFormattingEdits(ne,Oe,G,H,ee);if(Array.isArray(Be))return Be.map(n.TextEdit.from)}}class ye{constructor(j,T){this.e=j,this.f=T,this.d=new t.$1kc("WorkspaceSymbols")}async provideWorkspaceSymbols(j,T){const G=await this.e.provideWorkspaceSymbols(j,T);if(!(0,I.$Lb)(G))return{symbols:[]};const H=this.d.add(G),ee={cacheId:H,symbols:[]};for(let ne=0;ne<G.length;ne++){const Oe=G[ne];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}ee.symbols.push({...n.WorkspaceSymbol.from(Oe),cacheId:[H,ne]})}return ee}async resolveWorkspaceSymbol(j,T){if(typeof this.e.resolveWorkspaceSymbol!="function"||!j.cacheId)return j;const G=this.d.get(...j.cacheId);if(G){const H=await this.e.resolveWorkspaceSymbol(G,T);return H&&(0,p.$5n)(j,n.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(j){this.d.delete(j)}}class Pe{static supportsResolving(j){return typeof j.prepareRename=="function"}constructor(j,T,G){this.d=j,this.e=T,this.f=G}async provideRenameEdits(j,T,G,H){const ee=this.d.getDocument(j),ne=n.Position.to(T);try{const Oe=await this.e.provideRenameEdits(ee,ne,G,H);return Oe?n.WorkspaceEdit.from(Oe):void 0}catch(Oe){const Be=Pe.g(Oe);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(j,T,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(j),ee=n.Position.to(T);try{const ne=await this.e.prepareRename(H,ee,G);let Oe,Be;if(c.$5M.isRange(ne)?(Oe=ne,Be=H.getText(ne)):(0,D.$0f)(ne)&&(Oe=ne.range,Be=ne.placeholder),!Oe||!Be)return;if(Oe.start.line>ee.line||Oe.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Oe),text:Be}}catch(ne){const Oe=Pe.g(ne);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(ne)}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class fe{constructor(j,T,G){this.d=j,this.e=T,this.f=G}async provideNewSymbolNames(j,T,G){const H=this.d.getDocument(j),ee=n.Range.to(T);try{const ne=await this.e.provideNewSymbolNames(H,ee,G);return ne?ne.map(Oe=>typeof Oe=="string"?{newSymbolName:Oe}:{newSymbolName:Oe.newSymbolName,tags:Oe.tags}):void 0}catch(ne){this.f.error(fe.g(ne)??JSON.stringify(ne,null,"	"));return}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class me{constructor(j,T){this.resultId=j,this.tokens=T}}class Ae{constructor(j,T){this.f=j,this.g=T,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(j,T,G){const H=this.f.getDocument(j),ee=T!==0?this.d.get(T):null;let ne=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,G):await this.g.provideDocumentSemanticTokens(H,G);return ee&&this.d.delete(T),ne?(ne=Ae.h(ne),this.o(Ae.n(ee,ne),ne)):null}async releaseDocumentSemanticColoring(j){this.d.delete(j)}static h(j){return Ae.j(j)?Ae.k(j)?j:new c.$lO(new Uint32Array(j.data),j.resultId):Ae.l(j)?Ae.m(j)?j:new c.$nO(j.edits.map(T=>new c.$mO(T.start,T.deleteCount,T.data?new Uint32Array(T.data):T.data)),j.resultId):j}static j(j){return j&&!!j.data}static k(j){return j.data instanceof Uint32Array}static l(j){return j&&Array.isArray(j.edits)}static m(j){for(const T of j.edits)if(!(T.data instanceof Uint32Array))return!1;return!0}static n(j,T){if(!Ae.j(T)||!j||!j.tokens)return T;const G=j.tokens,H=G.length,ee=T.data,ne=ee.length;let Oe=0;const Be=Math.min(H,ne);for(;Oe<Be&&G[Oe]===ee[Oe];)Oe++;if(Oe===H&&Oe===ne)return new c.$nO([],T.resultId);let Ke=0;const _e=Be-Oe;for(;Ke<_e&&G[H-Ke-1]===ee[ne-Ke-1];)Ke++;return new c.$nO([{start:Oe,deleteCount:H-Oe-Ke,data:ee.subarray(Oe,ne-Ke)}],T.resultId)}o(j,T){if(Ae.j(j)){const G=this.e++;return this.d.set(G,new me(j.resultId,j.data)),(0,o.$7bb)({id:G,type:"full",data:j.data})}if(Ae.l(j)){const G=this.e++;return Ae.j(T)?this.d.set(G,new me(T.resultId,T.data)):this.d.set(G,new me(j.resultId)),(0,o.$7bb)({id:G,type:"delta",deltas:(j.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class ce{constructor(j,T){this.d=j,this.e=T}async provideDocumentRangeSemanticTokens(j,T,G){const H=this.d.getDocument(j),ee=await this.e.provideDocumentRangeSemanticTokens(H,n.Range.to(T),G);return ee?this.f(ee):null}f(j){return(0,o.$7bb)({id:0,type:"full",data:j.data})}}class Me{static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}constructor(j,T,G,H,ee){this.f=j,this.g=T,this.h=G,this.j=H,this.k=ee,this.d=new t.$1kc("CompletionItem"),this.e=new Map}async provideCompletionItems(j,T,G,H){const ee=this.f.getDocument(j),ne=n.Position.to(T),Oe=ee.getWordRangeAtPosition(ne)||new c.$5M(ne,ne),Be=Oe.with({end:ne}),Ke=new E.$ae,_e=await this.h.provideCompletionItems(ee,ne,H,n.CompletionContext.to(G));if(!_e||H.isCancellationRequested)return;const xe=Array.isArray(_e)?new c.$zN(_e):_e,et=Me.supportsResolving(this.h)?this.d.add(xe.items):this.d.add([]),tt=new b.$Uc;this.e.set(et,tt);const nt=[],ct={x:et,b:nt,a:{replace:n.Range.from(Oe),insert:n.Range.from(Be)},c:xe.isIncomplete||void 0,d:Ke.elapsed()};for(let mt=0;mt<xe.items.length;mt++){const je=xe.items[mt],st=this.l(je,[et,mt],Be,Oe);nt.push(st)}return ct}async resolveCompletionItem(j,T){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...j);if(!G)return;const H=this.l(G,j),ee=await this.h.resolveCompletionItem(G,T);if(!ee)return;const ne=this.l(ee,j);return(H.h!==ne.h||H.i!==ne.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==ne.n||H.o!==ne.o||!(0,p.$6n)(H.p,ne.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:ne.d,c:ne.c,l:ne.l,h:ne.h,i:ne.i,n:ne.n,o:ne.o,p:ne.p}}releaseCompletionItems(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,T,G,H){const ee=this.e.get(T[0]);if(!ee)throw Error("DisposableStore is missing...");const ne=this.g.toInternal(j.command,ee),Oe={x:T,a:j.label,b:j.kind!==void 0?n.CompletionItemKind.from(j.kind):void 0,m:j.tags&&j.tags.map(n.CompletionItemTag.from),c:j.detail,d:typeof j.documentation>"u"?void 0:n.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters?.join(""),l:j.additionalTextEdits&&j.additionalTextEdits.map(n.TextEdit.from),n:ne?.$ident,o:ne?.id,p:ne?.$ident?void 0:ne?.arguments};j.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=j.textEdit.newText):typeof j.insertText=="string"?Oe.h=j.insertText:j.insertText instanceof c.$bN&&(Oe.h=j.insertText.value,Oe.i|=4);let Be;return j.textEdit?Be=j.textEdit.range:j.range&&(Be=j.range),c.$5M.isRange(Be)?Oe.j=n.Range.from(Be):Be&&(!G?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Oe.j={insert:n.Range.from(Be.inserting),replace:n.Range.from(Be.replacing)}),Oe}}class ie{async provideInlineCompletions(j,T,G,H){}disposeCompletions(j){}handleDidShowCompletionItem(j,T,G){}handlePartialAccept(j,T,G,H){}}class z extends ie{constructor(j,T,G,H){super(),this.f=j,this.g=T,this.h=G,this.j=H,this.d=new ve,this.e=(0,h.$FG)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$FG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(j,T,G,H){const ee=this.g.getDocument(j),ne=n.Position.to(T),Oe=await this.h.provideInlineCompletionItems(ee,ne,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:n.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},H);if(!Oe||H.isCancellationRequested)return;const Be=Array.isArray(Oe)?Oe:Oe.items,Ke=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],_e=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let xe;return{pid:this.d.createReferenceId({dispose(){xe?.dispose()},items:Be}),items:Be.map((tt,nt)=>{let ct;tt.command&&(xe||(xe=new b.$Uc),ct=this.j.toInternal(tt.command,xe));const mt=tt.insertText;return{insertText:typeof mt=="string"?mt:{snippet:mt.value},filterText:tt.filterText,range:tt.range?n.Range.from(tt.range):void 0,command:ct,idx:nt,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:Ke.map(tt=>(xe||(xe=new b.$Uc),this.j.toInternal(tt,xe))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(j){this.d.disposeReferenceId(j)?.dispose()}handleDidShowCompletionItem(j,T,G){const H=this.d.get(j)?.items[T];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,G)}handlePartialAccept(j,T,G,H){const ee=this.d.get(j)?.items[T];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,G),this.h.handleDidPartiallyAcceptCompletionItem(ee,n.PartialAcceptInfo.to(H)))}}class x{async provideInlineEdits(j,T,G){const H=this.f.getDocument(j),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[T.triggerKind]},G);if(!ee||G.isCancellationRequested)return;let ne;const Oe=this.d.createReferenceId({dispose(){ne?.dispose()},item:ee});let Be;ee.accepted&&(ne||(ne=new b.$Uc),Be=this.h.toInternal(ee.accepted,ne));let Ke;return ee.rejected&&(ne||(ne=new b.$Uc),Ke=this.h.toInternal(ee.rejected,ne)),{pid:Oe,text:ee.text,range:n.Range.from(ee.range),accepted:Be,rejected:Ke}}disposeEdit(j){this.d.disposeReferenceId(j)?.dispose()}constructor(j,T,G,H){this.f=T,this.g=G,this.h=H,this.d=new ve,this.e={[r.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class ve{constructor(){this.d=new Map,this.e=1}createReferenceId(j){const T=this.e++;return this.d.set(T,j),T}disposeReferenceId(j){const T=this.d.get(j);return this.d.delete(j),T}get(j){return this.d.get(j)}}class Te{constructor(j,T){this.e=j,this.f=T,this.d=new t.$1kc("SignatureHelp")}async provideSignatureHelp(j,T,G,H){const ee=this.e.getDocument(j),ne=n.Position.to(T),Oe=this.g(G),Be=await this.f.provideSignatureHelp(ee,ne,H,Oe);if(Be){const Ke=this.d.add([Be]);return{...n.SignatureHelp.from(Be),id:Ke}}}g(j){let T;if(j.activeSignatureHelp){const G=n.SignatureHelp.to(j.activeSignatureHelp),H=this.d.get(j.activeSignatureHelp.id,0);H?(T=H,T.activeSignature=G.activeSignature,T.activeParameter=G.activeParameter):T=G}return{...j,activeSignatureHelp:T}}releaseSignatureHelp(j){this.d.delete(j)}}class De{constructor(j,T,G,H,ee){this.f=j,this.g=T,this.h=G,this.j=H,this.k=ee,this.d=new t.$1kc("InlayHints"),this.e=new Map}async provideInlayHints(j,T,G){const H=this.f.getDocument(j),ee=n.Range.to(T),ne=await this.h.provideInlayHints(H,ee,G);if(!Array.isArray(ne)||ne.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(T)}`);return}if(G.isCancellationRequested)return;const Oe=this.d.add(ne);this.e.set(Oe,new b.$Uc);const Be={hints:[],cacheId:Oe};for(let Ke=0;Ke<ne.length;Ke++)this.l(ne[Ke],ee)&&Be.hints.push(this.m(ne[Ke],[Oe,Ke]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(T)}`),Be}async resolveInlayHint(j,T){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...j);if(!G)return;const H=await this.h.resolveInlayHint(G,T);if(H&&this.l(H))return this.m(H,j)}releaseHints(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,T){return j.label.length===0||Array.isArray(j.label)&&j.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",j),!1):!(T&&!T.contains(j.position))}m(j,T){const G=this.e.get(T[0]);if(!G)throw Error("DisposableStore is missing...");const H={label:"",cacheId:T,tooltip:n.MarkdownString.fromStrict(j.tooltip),position:n.Position.from(j.position),textEdits:j.textEdits&&j.textEdits.map(n.TextEdit.from),kind:j.kind&&n.InlayHintKind.from(j.kind),paddingLeft:j.paddingLeft,paddingRight:j.paddingRight};if(typeof j.label=="string")H.label=j.label;else{const ee=[];H.label=ee;for(const ne of j.label){if(!ne.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:ne.value,tooltip:n.MarkdownString.fromStrict(ne.tooltip)};c.$cN.isLocation(ne.location)&&(Oe.location=n.location.from(ne.location)),ne.command&&(Oe.command=this.g.toInternal(ne.command,G)),ee.push(Oe)}}return H}}class $e{constructor(j,T){this.e=j,this.f=T,this.d=new t.$1kc("DocumentLink")}async provideLinks(j,T){const G=this.e.getDocument(j),H=await this.f.provideDocumentLinks(G,T);if(!(!Array.isArray(H)||H.length===0)&&!T.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter($e.g).map(n.DocumentLink.from)};{const ee=this.d.add(H),ne={links:[],cacheId:ee};for(let Oe=0;Oe<H.length;Oe++){if(!$e.g(H[Oe]))continue;const Be=n.DocumentLink.from(H[Oe]);Be.cacheId=[ee,Oe],ne.links.push(Be)}return ne}}}static g(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,T){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...j);if(!G)return;const H=await this.f.resolveDocumentLink(G,T);if(!(!H||!$e.g(H)))return n.DocumentLink.from(H)}releaseLinks(j){this.d.delete(j)}}class ge{constructor(j,T){this.d=j,this.e=T}async provideColors(j,T){const G=this.d.getDocument(j),H=await this.e.provideDocumentColors(G,T);return Array.isArray(H)?H.map(ne=>({color:n.Color.from(ne.color),range:n.Range.from(ne.range)})):[]}async provideColorPresentations(j,T,G){const H=this.d.getDocument(j),ee=n.Range.to(T.range),ne=n.Color.to(T.color),Oe=await this.e.provideColorPresentations(ne,{document:H,range:ee},G);if(Array.isArray(Oe))return Oe.map(n.ColorPresentation.from)}}class Q{constructor(j,T){this.d=j,this.e=T}async provideFoldingRanges(j,T,G){const H=this.d.getDocument(j),ee=await this.e.provideFoldingRanges(H,T,G);if(Array.isArray(ee))return ee.map(n.FoldingRange.from)}}class X{constructor(j,T,G){this.d=j,this.e=T,this.f=G}async provideSelectionRanges(j,T,G){const H=this.d.getDocument(j),ee=T.map(n.Position.to),ne=await this.e.provideSelectionRanges(H,ee,G);if(!(0,I.$Lb)(ne))return[];if(ne.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let Be=0;Be<ee.length;Be++){const Ke=[];Oe.push(Ke);let _e=ee[Be],xe=ne[Be];for(;;){if(!xe.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(n.SelectionRange.from(xe)),!xe.parent)break;_e=xe.range,xe=xe.parent}}return Oe}}class he{constructor(j,T){this.f=j,this.g=T,this.d=new M.$tP(""),this.e=new Map}async prepareSession(j,T,G){const H=this.f.getDocument(j),ee=n.Position.to(T),ne=await this.g.prepareCallHierarchy(H,ee,G);if(!ne)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(ne)?ne.map(Be=>this.h(Oe,Be)):[this.h(Oe,ne)]}async provideCallsTo(j,T,G){const H=this.j(j,T);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,G);if(ee)return ee.map(ne=>({from:this.h(j,ne.from),fromRanges:ne.fromRanges.map(Oe=>n.Range.from(Oe))}))}async provideCallsFrom(j,T,G){const H=this.j(j,T);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,G);if(ee)return ee.map(ne=>({to:this.h(j,ne.to),fromRanges:ne.fromRanges.map(Oe=>n.Range.from(Oe))}))}releaseSession(j){this.e.delete(j)}h(j,T){const G=this.e.get(j),H=n.CallHierarchyItem.from(T,j,G.size.toString(36));return G.set(H._itemId,T),H}j(j,T){return this.e.get(j)?.get(T)}}class ue{constructor(j,T){this.f=j,this.g=T,this.d=new M.$tP(""),this.e=new Map}async prepareSession(j,T,G){const H=this.f.getDocument(j),ee=n.Position.to(T),ne=await this.g.prepareTypeHierarchy(H,ee,G);if(!ne)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(ne)?ne.map(Be=>this.h(Oe,Be)):[this.h(Oe,ne)]}async provideSupertypes(j,T,G){const H=this.j(j,T);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,G);if(ee)return ee.map(ne=>this.h(j,ne))}async provideSubtypes(j,T,G){const H=this.j(j,T);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,G);if(ee)return ee.map(ne=>this.h(j,ne))}releaseSession(j){this.e.delete(j)}h(j,T){const G=this.e.get(j),H=n.TypeHierarchyItem.from(T,j,G.size.toString(36));return G.set(H._itemId,T),H}j(j,T){return this.e.get(j)?.get(T)}}class Fe{constructor(j,T,G,H,ee){this.e=j,this.f=T,this.g=G,this.h=H,this.j=ee,this.d=new t.$1kc("DocumentDropEdit")}async provideDocumentOnDropEdits(j,T,G,H,ee){const ne=this.f.getDocument(T),Oe=n.Position.to(G),Be=n.DataTransfer.toDataTransfer(H,async et=>(await this.e.$resolveDocumentOnDropFileData(this.h,j,et)).buffer),Ke=await this.g.provideDocumentDropEdits(ne,Oe,Be,ee);if(!Ke)return;const _e=(0,I.$3b)(Ke),xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,s.localize)(1,null,this.j.displayName||this.j.name),kind:et.kind?.value,yieldTo:et.yieldTo?.map(nt=>nt.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?n.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolveDropEdit(j,T){const[G,H]=j,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentDropEdit)return{};const ne=await this.g.resolveDocumentDropEdit(ee,T)??ee;return{additionalEdit:ne.additionalEdit?n.WorkspaceEdit.from(ne.additionalEdit,void 0):void 0}}releaseDropEdits(j){this.d.delete(j)}}class de{constructor(j,T){this.d=j,this.e=T}async provideMappedEdits(j,T,G,H){const ee=d.URI.revive(j),ne=this.d.getDocument(ee),Oe=G.documents.map(_e=>_e.map(xe=>({uri:d.URI.revive(xe.uri),version:xe.version,ranges:xe.ranges.map(et=>n.Range.to(et))}))),Be={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(ne,T,Be,H);return Ke?n.WorkspaceEdit.from(Ke):null}}class Re{constructor(j,T){this.adapter=j,this.extension=T}}class Ne{static{this.d=0}constructor(j,T,G,H,ee,ne,Oe,Be){this.g=T,this.h=G,this.j=H,this.k=ee,this.l=ne,this.m=Oe,this.n=Be,this.f=new Map,this.e=j.getProxy(f.$1M.MainThreadLanguageFeatures)}o(j,T){return n.DocumentSelector.from(j,this.g,T)}p(j){return new c.$3M(()=>{this.f.delete(j),this.e.$unregister(j)})}q(){return Ne.d++}async s(j,T,G,H,ee,ne=!1){const Oe=this.f.get(j);if(!Oe||!(Oe.adapter instanceof T))return H;const Be=Date.now();ne||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ke=G(Oe.adapter,Oe.extension);return Promise.resolve(Ke).catch(_e=>{(0,O.$4)(_e)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Oe.extension.identifier,_e))}).finally(()=>{ne||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),R.CancellationToken.isCancellationToken(ee)?(0,N.$kh)(Ke,ee):Ke}t(j,T){const G=this.q();return this.f.set(G,new Re(j,T)),G}static u(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,T,G,H){const ee=this.t(new a(this.h,G),j),ne=H&&H.label||Ne.u(j);return this.e.$registerDocumentSymbolProvider(ee,this.o(T,j),ne),this.p(ee)}$provideDocumentSymbols(j,T,G){return this.s(j,a,H=>H.provideDocumentSymbols(d.URI.revive(T),G),void 0,G)}registerCodeLensProvider(j,T,G){const H=this.q(),ee=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Re(new g(this.h,this.j.converter,G,j,this.n,this.l),j)),this.e.$registerCodeLensSupport(H,this.o(T,j),ee);let ne=this.p(H);if(ee!==void 0){const Oe=G.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ee));ne=c.$3M.from(ne,Oe)}return ne}$provideCodeLenses(j,T,G){return this.s(j,g,H=>H.provideCodeLenses(d.URI.revive(T),G),void 0,G)}$resolveCodeLens(j,T,G){return this.s(j,g,H=>H.resolveCodeLens(T,G),void 0,void 0)}$releaseCodeLenses(j,T){this.s(j,g,G=>Promise.resolve(G.releaseCodeLenses(T)),void 0,void 0)}registerDefinitionProvider(j,T,G){const H=this.t(new S(this.h,G),j);return this.e.$registerDefinitionSupport(H,this.o(T,j)),this.p(H)}$provideDefinition(j,T,G,H){return this.s(j,S,ee=>ee.provideDefinition(d.URI.revive(T),G,H),[],H)}registerDeclarationProvider(j,T,G){const H=this.t(new l(this.h,G),j);return this.e.$registerDeclarationSupport(H,this.o(T,j)),this.p(H)}$provideDeclaration(j,T,G,H){return this.s(j,l,ee=>ee.provideDeclaration(d.URI.revive(T),G,H),[],H)}registerImplementationProvider(j,T,G){const H=this.t(new w(this.h,G),j);return this.e.$registerImplementationSupport(H,this.o(T,j)),this.p(H)}$provideImplementation(j,T,G,H){return this.s(j,w,ee=>ee.provideImplementation(d.URI.revive(T),G,H),[],H)}registerTypeDefinitionProvider(j,T,G){const H=this.t(new $(this.h,G),j);return this.e.$registerTypeDefinitionSupport(H,this.o(T,j)),this.p(H)}$provideTypeDefinition(j,T,G,H){return this.s(j,$,ee=>ee.provideTypeDefinition(d.URI.revive(T),G,H),[],H)}registerHoverProvider(j,T,G,H){const ee=this.t(new k(this.h,G),j);return this.e.$registerHoverProvider(ee,this.o(T,j)),this.p(ee)}$provideHover(j,T,G,H,ee){return this.s(j,k,ne=>ne.provideHover(d.URI.revive(T),G,H,ee),void 0,ee)}$releaseHover(j,T){this.s(j,k,G=>Promise.resolve(G.releaseHover(T)),void 0,void 0)}registerEvaluatableExpressionProvider(j,T,G,H){const ee=this.t(new y(this.h,G),j);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(T,j)),this.p(ee)}$provideEvaluatableExpression(j,T,G,H){return this.s(j,y,ee=>ee.provideEvaluatableExpression(d.URI.revive(T),G,H),void 0,H)}registerInlineValuesProvider(j,T,G,H){const ee=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,ne=this.t(new C(this.h,G),j);this.e.$registerInlineValuesProvider(ne,this.o(T,j),ee);let Oe=this.p(ne);if(ee!==void 0){const Be=G.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(ee));Oe=c.$3M.from(Oe,Be)}return Oe}$provideInlineValues(j,T,G,H,ee){return this.s(j,C,ne=>ne.provideInlineValues(d.URI.revive(T),G,H,ee),void 0,ee)}registerDocumentHighlightProvider(j,T,G){const H=this.t(new P(this.h,G),j);return this.e.$registerDocumentHighlightProvider(H,this.o(T,j)),this.p(H)}registerMultiDocumentHighlightProvider(j,T,G){const H=this.t(new W(this.h,G),j);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(T,j)),this.p(H)}$provideDocumentHighlights(j,T,G,H){return this.s(j,P,ee=>ee.provideDocumentHighlights(d.URI.revive(T),G,H),void 0,H)}$provideMultiDocumentHighlights(j,T,G,H,ee){return this.s(j,W,ne=>ne.provideMultiDocumentHighlights(d.URI.revive(T),G,H.map(Oe=>d.URI.revive(Oe)),ee),void 0,ee)}registerLinkedEditingRangeProvider(j,T,G){const H=this.t(new V(this.h,G),j);return this.e.$registerLinkedEditingRangeProvider(H,this.o(T,j)),this.p(H)}$provideLinkedEditingRanges(j,T,G,H){return this.s(j,V,async ee=>{const ne=await ee.provideLinkedEditingRanges(d.URI.revive(T),G,H);if(ne)return{ranges:ne.ranges,wordPattern:ne.wordPattern?Ne.w(ne.wordPattern):void 0}},void 0,H)}registerReferenceProvider(j,T,G){const H=this.t(new q(this.h,G),j);return this.e.$registerReferenceSupport(H,this.o(T,j)),this.p(H)}$provideReferences(j,T,G,H,ee){return this.s(j,q,ne=>ne.provideReferences(d.URI.revive(T),G,H,ee),void 0,ee)}registerCodeActionProvider(j,T,G,H){const ee=new b.$Uc,ne=this.t(new A(this.h,this.j.converter,this.k,G,this.l,j,this.m),j);return this.e.$registerQuickFixSupport(ne,this.o(T,j),{providedKinds:H?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:H?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,ee)}))},Ne.u(j),!!G.resolveCodeAction),ee.add(this.p(ne)),ee}$provideCodeActions(j,T,G,H,ee){return this.s(j,A,ne=>ne.provideCodeActions(d.URI.revive(T),G,H,ee),void 0,ee)}$resolveCodeAction(j,T,G){return this.s(j,A,H=>H.resolveCodeAction(T,G),{},void 0)}$releaseCodeActions(j,T){this.s(j,A,G=>Promise.resolve(G.releaseCodeActions(T)),void 0,void 0)}registerDocumentFormattingEditProvider(j,T,G){const H=this.t(new K(this.h,G),j);return this.e.$registerDocumentFormattingSupport(H,this.o(T,j),j.identifier,j.displayName||j.name),this.p(H)}$provideDocumentFormattingEdits(j,T,G,H){return this.s(j,K,ee=>ee.provideDocumentFormattingEdits(d.URI.revive(T),G,H),void 0,H)}registerDocumentRangeFormattingEditProvider(j,T,G){const H=typeof G.provideDocumentRangesFormattingEdits=="function",ee=this.t(new re(this.h,G),j);return this.e.$registerRangeFormattingSupport(ee,this.o(T,j),j.identifier,j.displayName||j.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(j,T,G,H,ee){return this.s(j,re,ne=>ne.provideDocumentRangeFormattingEdits(d.URI.revive(T),G,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(j,T,G,H,ee){return this.s(j,re,ne=>ne.provideDocumentRangesFormattingEdits(d.URI.revive(T),G,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(j,T,G,H){const ee=this.t(new ae(this.h,G),j);return this.e.$registerOnTypeFormattingSupport(ee,this.o(T,j),H,j.identifier),this.p(ee)}$provideOnTypeFormattingEdits(j,T,G,H,ee,ne){return this.s(j,ae,Oe=>Oe.provideOnTypeFormattingEdits(d.URI.revive(T),G,H,ee,ne),void 0,ne)}registerWorkspaceSymbolProvider(j,T){const G=this.t(new ye(T,this.l),j);return this.e.$registerNavigateTypeSupport(G,typeof T.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(j,T,G){return this.s(j,ye,H=>H.provideWorkspaceSymbols(T,G),{symbols:[]},G)}$resolveWorkspaceSymbol(j,T,G){return this.s(j,ye,H=>H.resolveWorkspaceSymbol(T,G),void 0,void 0)}$releaseWorkspaceSymbols(j,T){this.s(j,ye,G=>G.releaseWorkspaceSymbols(T),void 0,void 0)}registerRenameProvider(j,T,G){const H=this.t(new Pe(this.h,G,this.l),j);return this.e.$registerRenameSupport(H,this.o(T,j),Pe.supportsResolving(G)),this.p(H)}$provideRenameEdits(j,T,G,H,ee){return this.s(j,Pe,ne=>ne.provideRenameEdits(d.URI.revive(T),G,H,ee),void 0,ee)}$resolveRenameLocation(j,T,G,H){return this.s(j,Pe,ee=>ee.resolveRenameLocation(d.URI.revive(T),G,H),void 0,H)}registerNewSymbolNamesProvider(j,T,G){const H=this.t(new fe(this.h,G,this.l),j);return this.e.$registerNewSymbolNamesProvider(H,this.o(T,j)),this.p(H)}$provideNewSymbolNames(j,T,G,H){return this.s(j,fe,ee=>ee.provideNewSymbolNames(d.URI.revive(T),G,H),void 0,H)}registerDocumentSemanticTokensProvider(j,T,G,H){const ee=this.t(new Ae(this.h,G),j),ne=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(T,j),H,ne);let Oe=this.p(ee);if(ne){const Be=G.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(ne));Oe=c.$3M.from(Oe,Be)}return Oe}$provideDocumentSemanticTokens(j,T,G,H){return this.s(j,Ae,ee=>ee.provideDocumentSemanticTokens(d.URI.revive(T),G,H),null,H)}$releaseDocumentSemanticTokens(j,T){this.s(j,Ae,G=>G.releaseDocumentSemanticColoring(T),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(j,T,G,H){const ee=this.t(new ce(this.h,G),j);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(T,j),H),this.p(ee)}$provideDocumentRangeSemanticTokens(j,T,G,H){return this.s(j,ce,ee=>ee.provideDocumentRangeSemanticTokens(d.URI.revive(T),G,H),null,H)}registerCompletionItemProvider(j,T,G,H){const ee=this.t(new Me(this.h,this.j.converter,G,this.m,j),j);return this.e.$registerCompletionsProvider(ee,this.o(T,j),H,Me.supportsResolving(G),j.identifier),this.p(ee)}$provideCompletionItems(j,T,G,H,ee){return this.s(j,Me,ne=>ne.provideCompletionItems(d.URI.revive(T),G,H,ee),void 0,ee)}$resolveCompletionItem(j,T,G){return this.s(j,Me,H=>H.resolveCompletionItem(T,G),void 0,G)}$releaseCompletionItems(j,T){this.s(j,Me,G=>G.releaseCompletionItems(T),void 0,void 0)}registerInlineCompletionsProvider(j,T,G,H){const ee=new z(j,this.h,G,this.j.converter),ne=this.t(ee,j);return this.e.$registerInlineCompletionsSupport(ne,this.o(T,j),ee.supportsHandleEvents,i.$Qm.toKey(j.identifier.value),H?.yieldTo?.map(Oe=>i.$Qm.toKey(Oe))||[]),this.p(ne)}$provideInlineCompletions(j,T,G,H,ee){return this.s(j,ie,ne=>ne.provideInlineCompletions(d.URI.revive(T),G,H,ee),void 0,ee)}$handleInlineCompletionDidShow(j,T,G,H){this.s(j,ie,async ee=>{ee.handleDidShowCompletionItem(T,G,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(j,T,G,H,ee){this.s(j,ie,async ne=>{ne.handlePartialAccept(T,G,H,ee)},void 0,void 0)}$freeInlineCompletionsList(j,T){this.s(j,ie,async G=>{G.disposeCompletions(T)},void 0,void 0)}registerInlineEditProvider(j,T,G){const H=new x(j,this.h,G,this.j.converter),ee=this.t(H,j);return this.e.$registerInlineEditProvider(ee,this.o(T,j),j.identifier),this.p(ee)}$provideInlineEdit(j,T,G,H){return this.s(j,x,ee=>ee.provideInlineEdits(d.URI.revive(T),G,H),void 0,H)}$freeInlineEdit(j,T){this.s(j,x,async G=>{G.disposeEdit(T)},void 0,void 0)}registerSignatureHelpProvider(j,T,G,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,ne=this.t(new Te(this.h,G),j);return this.e.$registerSignatureHelpProvider(ne,this.o(T,j),ee),this.p(ne)}$provideSignatureHelp(j,T,G,H,ee){return this.s(j,Te,ne=>ne.provideSignatureHelp(d.URI.revive(T),G,H,ee),void 0,ee)}$releaseSignatureHelp(j,T){this.s(j,Te,G=>G.releaseSignatureHelp(T),void 0,void 0)}registerInlayHintsProvider(j,T,G){const H=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new De(this.h,this.j.converter,G,this.l,j),j);this.e.$registerInlayHintsProvider(ee,this.o(T,j),typeof G.resolveInlayHint=="function",H,Ne.u(j));let ne=this.p(ee);if(H!==void 0){const Oe=G.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));ne=c.$3M.from(ne,Oe)}return ne}$provideInlayHints(j,T,G,H){return this.s(j,De,ee=>ee.provideInlayHints(d.URI.revive(T),G,H),void 0,H)}$resolveInlayHint(j,T,G){return this.s(j,De,H=>H.resolveInlayHint(T,G),void 0,G)}$releaseInlayHints(j,T){this.s(j,De,G=>G.releaseHints(T),void 0,void 0)}registerDocumentLinkProvider(j,T,G){const H=this.t(new $e(this.h,G),j);return this.e.$registerDocumentLinkProvider(H,this.o(T,j),typeof G.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(j,T,G){return this.s(j,$e,H=>H.provideLinks(d.URI.revive(T),G),void 0,G,T.scheme==="output")}$resolveDocumentLink(j,T,G){return this.s(j,$e,H=>H.resolveLink(T,G),void 0,void 0,!0)}$releaseDocumentLinks(j,T){this.s(j,$e,G=>G.releaseLinks(T),void 0,void 0,!0)}registerColorProvider(j,T,G){const H=this.t(new ge(this.h,G),j);return this.e.$registerDocumentColorProvider(H,this.o(T,j)),this.p(H)}$provideDocumentColors(j,T,G){return this.s(j,ge,H=>H.provideColors(d.URI.revive(T),G),[],G)}$provideColorPresentations(j,T,G,H){return this.s(j,ge,ee=>ee.provideColorPresentations(d.URI.revive(T),G,H),void 0,H)}registerFoldingRangeProvider(j,T,G){const H=this.q(),ee=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Re(new Q(this.h,G),j)),this.e.$registerFoldingRangeProvider(H,this.o(T,j),j.identifier,ee);let ne=this.p(H);if(ee!==void 0){const Oe=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));ne=c.$3M.from(ne,Oe)}return ne}$provideFoldingRanges(j,T,G,H){return this.s(j,Q,ee=>ee.provideFoldingRanges(d.URI.revive(T),G,H),void 0,H)}registerSelectionRangeProvider(j,T,G){const H=this.t(new X(this.h,G,this.l),j);return this.e.$registerSelectionRangeProvider(H,this.o(T,j)),this.p(H)}$provideSelectionRanges(j,T,G,H){return this.s(j,X,ee=>ee.provideSelectionRanges(d.URI.revive(T),G,H),[],H)}registerCallHierarchyProvider(j,T,G){const H=this.t(new he(this.h,G),j);return this.e.$registerCallHierarchyProvider(H,this.o(T,j)),this.p(H)}$prepareCallHierarchy(j,T,G,H){return this.s(j,he,ee=>Promise.resolve(ee.prepareSession(d.URI.revive(T),G,H)),void 0,H)}$provideCallHierarchyIncomingCalls(j,T,G,H){return this.s(j,he,ee=>ee.provideCallsTo(T,G,H),void 0,H)}$provideCallHierarchyOutgoingCalls(j,T,G,H){return this.s(j,he,ee=>ee.provideCallsFrom(T,G,H),void 0,H)}$releaseCallHierarchy(j,T){this.s(j,he,G=>Promise.resolve(G.releaseSession(T)),void 0,void 0)}registerTypeHierarchyProvider(j,T,G){const H=this.t(new ue(this.h,G),j);return this.e.$registerTypeHierarchyProvider(H,this.o(T,j)),this.p(H)}$prepareTypeHierarchy(j,T,G,H){return this.s(j,ue,ee=>Promise.resolve(ee.prepareSession(d.URI.revive(T),G,H)),void 0,H)}$provideTypeHierarchySupertypes(j,T,G,H){return this.s(j,ue,ee=>ee.provideSupertypes(T,G,H),void 0,H)}$provideTypeHierarchySubtypes(j,T,G,H){return this.s(j,ue,ee=>ee.provideSubtypes(T,G,H),void 0,H)}$releaseTypeHierarchy(j,T){this.s(j,ue,G=>Promise.resolve(G.releaseSession(T)),void 0,void 0)}registerDocumentOnDropEditProvider(j,T,G,H){const ee=this.q();return this.f.set(ee,new Re(new Fe(this.e,this.h,G,ee,j),j)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(T,j),(0,h.$FG)(j,"documentPaste")&&H?{supportsResolve:!!G.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(j,T,G,H,ee,ne){return this.s(j,Fe,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(T,d.URI.revive(G),H,ee,ne)),void 0,void 0)}$resolveDropEdit(j,T,G){return this.s(j,Fe,H=>H.resolveDropEdit(T,G),{},void 0)}$releaseDropEdits(j,T){this.s(j,Fe,G=>Promise.resolve(G.releaseDropEdits(T)),void 0,void 0)}registerMappedEditsProvider(j,T,G){const H=this.t(new de(this.h,G),j);return this.e.$registerMappedEditsProvider(H,this.o(T,j)),this.p(H)}$provideMappedEdits(j,T,G,H,ee){return this.s(j,de,ne=>Promise.resolve(ne.provideMappedEdits(T,G,H,ee)),null,ee)}registerDocumentPasteEditProvider(j,T,G,H){const ee=this.q();return this.f.set(ee,new Re(new U(this.e,this.h,G,ee,j),j)),this.e.$registerPasteEditProvider(ee,this.o(T,j),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(ne=>ne.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(j,T,G,H,ee){return this.s(j,U,ne=>ne.prepareDocumentPaste(d.URI.revive(T),G,H,ee),void 0,ee)}$providePasteEdits(j,T,G,H,ee,ne,Oe){return this.s(j,U,Be=>Be.providePasteEdits(T,d.URI.revive(G),H,ee,ne,Oe),void 0,Oe)}$resolvePasteEdit(j,T,G){return this.s(j,U,H=>H.resolvePasteEdit(T,G),{},void 0)}$releasePasteEdits(j,T){this.s(j,U,G=>Promise.resolve(G.releasePasteEdits(T)),void 0,void 0)}static w(j){return{pattern:j.source,flags:j.flags}}static y(j){return{decreaseIndentPattern:Ne.w(j.decreaseIndentPattern),increaseIndentPattern:Ne.w(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Ne.w(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Ne.w(j.unIndentedLinePattern):void 0}}static z(j){return{beforeText:Ne.w(j.beforeText),afterText:j.afterText?Ne.w(j.afterText):void 0,previousLineText:j.previousLineText?Ne.w(j.previousLineText):void 0,action:j.action}}static B(j){return j.map(Ne.z)}static C(j){return{open:j.open,close:j.close,notIn:j.notIn?j.notIn.map(T=>c.SyntaxTokenType.toString(T)):void 0}}static D(j){return j.map(Ne.C)}setLanguageConfiguration(j,T,G){const{wordPattern:H}=G;if(H&&(0,F.$jf)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(T,H):this.h.setWordDefinitionFor(T,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const ee=this.q(),ne={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Ne.w(G.wordPattern):void 0,indentationRules:G.indentationRules?Ne.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Ne.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Ne.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,T,ne),this.p(ee)}$setWordDefinitions(j){for(const T of j)this.h.setWordDefinitionFor(T.languageId,new RegExp(T.regexSource,T.regexFlags))}}e.$$kc=Ne}),define(Ie[90],Ce([1,0,6,4,8,7,103,20,11,5,175,108,14,3,17,86,12,41]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o,s){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=e.$Rlc=void 0,e.$Rlc=(0,v.$vi)("IExtHostLanguageModels");class n{constructor(f,a){this.option=f,this.stream=new p.$Yh,this.stream=a??new p.$Yh}}class c{constructor(){this.a=new Map,this.b=new p.$Yh,this.c=!1,this.d=!1;const f=this;this.apiObject={stream:f.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,f]of this.a)yield f.stream;else yield this.b}handleFragment(f){if(this.c)return;this.d=!0;let a=this.a.get(f.index);a||(this.a.size===0?a=new n(f.index,this.b):a=new n(f.index),this.a.set(f.index,a)),a.stream.emitOne(f.part)}get isStreaming(){return this.d}reject(f){this.c=!0;for(const a of this.f())a.reject(f)}resolve(){this.c=!0;for(const f of this.f())f.resolve()}}let h=class{static{i=this}static{this.a=1}constructor(f,a,g){this.j=a,this.k=g,this.c=new E.$ee,this.d=new E.$ee,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new b.$Sm,this.i=new Map,this.o=new Set,this.b=f.getProxy(N.$1M.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(f,a,g,u){const S=i.a++;this.f.set(S,{extension:f.identifier,provider:g,languageModelId:a});let l;return u.auth&&(l={providerLabel:f.displayName||f.name,accountLabel:typeof u.auth=="object"?u.auth.label:void 0}),this.b.$registerLanguageModelProvider(S,a,{extension:f.identifier,identifier:a,name:u.name??"",version:u.version,tokens:u.tokens,auth:l}),(0,I.$Tc)(()=>{this.f.delete(S),this.b.$unregisterProvider(S)})}async $provideLanguageModelResponse(f,a,g,u,S,l){const w=this.f.get(f);if(!w)return;const $=new M.$9v(async k=>{if(l.isCancellationRequested){this.j.warn(`[CHAT](${w.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(a,{index:k.index,part:k.part})});return w.provider.provideLanguageModelResponse2(u.map(R.LanguageModelMessage.to),S,b.$Qm.toKey(g),$,l)}$provideTokenLength(f,a,g){const u=this.f.get(f);return u?Promise.resolve(u.provider.provideTokenCount(a,g)):Promise.resolve(0)}$updateLanguageModels(f){const a=[],g=[];if(f.added)for(const u of f.added)this.g.set(u.identifier,u),a.push(u.identifier);if(f.removed)for(const u of f.removed){this.g.delete(u),g.push(u);for(const[S,l]of this.i)l.languageModelId===u&&(l.res.reject(new d.$5),this.i.delete(S))}this.d.fire(Object.freeze({added:Object.freeze(a),removed:Object.freeze(g)})),f.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(f){const a=new Array;for(const{from:g,to:u,enabled:S}of f){const l=this.h.get(g)??new b.$Rm;if(l.has(u)!==S){S?l.add(u):l.delete(u),this.h.set(g,l);const $={from:g,to:u};a.push($),this.c.fire($)}}}async sendChatRequest(f,a,g,u,S){const l=f.identifier,w=await this.b.$prepareChatAccess(l,a,u.justification);if(!w||!this.g.has(a))throw O.$bP.NotFound(`Language model '${a}' is unknown.`);if(this.m(l,w)&&(!await this.l(f,{identifier:w.extension,displayName:w.auth.providerLabel},u.justification,u.silent)||!this.h.get(l)?.has(w.extension)))throw O.$bP.NoPermissions(`Language model '${a}' cannot be used by '${l.value}'.`);const $=Math.random()*1e6|0,k=this.b.$fetchResponse(l,a,$,g.map(R.LanguageModelMessage.from),u.modelOptions??{},S),y=new p.$uh,C=new c;this.i.set($,{languageModelId:a,res:C});let P;if(k.catch(W=>{y.isOpen()?C.reject(W):P=W}).finally(()=>{this.i.delete($),C.resolve(),y.open()}),await y.wait(),P)throw new O.$bP(`Language model '${a}' errored, check cause for more details`,"Unknown",P);return C.apiObject}async $handleResponseFragment(f,a){const g=this.i.get(f);g&&g.res.handleFragment(a)}async l(f,a,g,u){const S=D.$3L+a.identifier.value;if(await this.k.getSession(f,S,[],{silent:!0}))return this.$updateModelAccesslist([{from:f.identifier,to:a.identifier,enabled:!0}]),!0;if(u)return!1;try{const w=g?(0,F.localize)(0,null,a.displayName,g):(0,F.localize)(1,null,a.displayName);return await this.k.getSession(f,S,[],{forceNewSession:{detail:w}}),this.$updateModelAccesslist([{from:f.identifier,to:a.identifier,enabled:!0}]),!0}catch{return!1}}m(f,a){return!!a.auth&&!b.$Qm.equals(a.extension,f)}async n(f){for(const a of this.o)try{await this.l(a,{identifier:f.extension,displayName:""},void 0,!0)}catch(g){this.j.error("Fake Auth request failed"),this.j.error(g)}}async computeTokenLength(f,a,g){const u=this.g.get(f);if(!u)throw O.$bP.NotFound(`Language model '${f}' is unknown.`);const S=s.Iterable.find(this.f.values(),l=>l.languageModelId===f);return S?S.provider.provideTokenCount(a,g):this.b.$countTokens(u.identifier,typeof a=="string"?a:R.LanguageModelMessage.from(a),g)}getLanguageModelInfo(f){const a=this.g.get(f);if(a)return{id:a.identifier,name:a.name,version:a.version,tokens:a.tokens}}createLanguageModelAccessInformation(f){this.o.add(f);const a=this,g=E.Event.signal(E.Event.filter(this.c.event,S=>b.$Qm.equals(S.from,f.identifier))),u=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(g,u)},canSendRequest(S){const l=a.g.get(S);if(!l)return;if(!a.m(f.identifier,l))return!0;const w=a.h.get(f.identifier);if(w)return w.has(l.extension)}}}};e.$Slc=h,e.$Slc=h=i=Je([We(0,m.$oP),We(1,o.$2j),We(2,r.$alc)],h)}),define(Ie[274],Ce([1,0,4,8,7,33,11,6,26]),function(le,e,I,N,R,O,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xmc=void 0;class E{constructor(D,d,v,m){this.c=d,this.d=v,this.e=m,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(I.$1M.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,d){await this.a.$changeLanguage(D,d);const v=this.c.getDocumentData(D);if(!v)throw new Error(`document '${D.toString()}' NOT found`);return v.document}async tokenAtPosition(D,d){const v=D.version,m=N.Position.from(d),r=await this.a.$tokensAtPosition(D.uri,m),o={type:R.StandardTokenType.Other,range:D.getWordRangeAtPosition(d)??new R.$5M(d.line,d.character,d.line,d.character)};if(!r)return o;const s={range:N.Range.to(r.range),type:N.TokenType.to(r.type)};return!s.range.contains(d)||v!==D.version?o:s}createLanguageStatusItem(D,d,v){const m=this.f++,r=this.a,o=this.g,s=`${D.identifier.value}/${d}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${d}' ALREADY exists`);o.add(s);const i={selector:v,id:d,name:D.displayName??D.name,severity:R.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const c=new b.$Uc,h=()=>{if(n?.dispose(),!o.has(s)){console.warn(`LanguageStatusItem (${d}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,M.$xh)(()=>{c.clear(),this.a.$setLanguageStatus(m,{id:s,name:i.name??D.displayName??D.name,source:D.displayName??D.name,selector:N.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===R.LanguageStatusSeverity.Error?O.default.Error:i.severity===R.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:i.command&&this.d.toInternal(i.command,c),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){c.dispose(),n?.dispose(),r.$removeLanguageStatus(m),o.delete(s)},get id(){return i.id},get name(){return i.name},set name(f){i.name=f,h()},get selector(){return i.selector},set selector(f){i.selector=f,h()},get text(){return i.text},set text(f){i.text=f,h()},set text2(f){(0,p.$GG)(D,"languageStatusText"),i.text=f,h()},get text2(){return(0,p.$GG)(D,"languageStatusText"),i.text},get detail(){return i.detail},set detail(f){i.detail=f,h()},get severity(){return i.severity},set severity(f){i.severity=f,h()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(f){i.accessibilityInformation=f,h()},get command(){return i.command},set command(f){i.command=f,h()},get busy(){return i.busy},set busy(f){i.busy=f,h()}};return h(),t}}e.$xmc=E}),define(Ie[275],Ce([1,0,16,2,8,7,85]),function(le,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kmc=e.$jmc=void 0;class b{constructor(D,d,v,m){this.start=D,this.deletedCount=d,this.deletedItems=v,this.items=m}asApiEvent(){return{range:new O.$sO(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(D){return{EOL:D.eol,lines:D.source,languageId:D.language,uri:D.uri,isDirty:!1,versionId:1}}constructor(D,d,v){this.notebook=D,this.h=d,this.j=v,this.handle=v.handle,this.uri=N.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(R.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(R.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,d=this.h.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:R.NotebookCellKind.to(this.j.cellKind),document:d.document,get mime(){return D.g},set mime(m){D.g=m},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(v)}return this.f}setOutputs(D){this.a=D.map(R.NotebookCellOutput.to)}setOutputItems(D,d,v){const m=v.map(R.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===D);if(r&&(d||(r.items.length=0),r.items.push(...m),r.items.length>1&&r.items.every(o=>M.$XK(o.mime)))){const o=new Map,s=[];r.items.forEach(i=>{let n;o.has(i.mime)?n=o.get(i.mime):(n=[],o.set(i.mime,n),s.push(i.mime)),n.push(i.data)}),r.items.length=0,s.forEach(i=>{const n=M.$YK(o.get(i));r.items.push({mime:i,data:n.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(R.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$jmc=p;class E{static{this.a=0}constructor(D,d,v,m,r){this.k=D,this.l=d,this.m=v,this.uri=m,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,d={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===I.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(v){return v=D.n(v),D.b[v].apiCell},getCells(v){return(v?D.p(v):D.b).map(r=>r.apiCell)},save(){return D.q()}};this.e=Object.freeze(d)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,d,v){this.g=D.versionId,this.h=d,this.acceptDocumentPropertiesChanged({metadata:v});const m={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},r=[];for(const s of D.rawEvents)s.kind===M.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,m.contentChanges):s.kind===M.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,m.contentChanges):s.kind===M.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===M.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===M.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),r.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),r.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<r.length;s++){const i=r[s],n=o.get(i.cell);if(n===void 0){const c=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});o.set(i.cell,c-1)}else m.cellChanges[n]={...m.cellChanges[n],...i}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let d=D.start|0,v=D.end|0;return d<0&&(d=0),v>this.b.length&&(v=this.b.length),D.with({start:d,end:v})}p(D){D=this.o(D);const d=[];for(let v=D.start;v<D.end;v++)d.push(this.b[v]);return d}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,d,v){if(this.j)return;const m=[],r=[],o=[];if(D.reverse().forEach(s=>{const n=s[2].map(t=>{const f=new p(this,this.l,t);return d||r.push(p.asModelAddData(t)),f}),c=new b(s[0],s[1],[],n),h=this.b.splice(s[0],s[1],...n);for(const t of h)o.push(t.uri),c.deletedItems.push(t.apiCell);m.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),v)for(const s of m)v.push(s.asApiEvent())}s(D,d,v,m){const r=this.b.splice(D,d);this.b.splice(v,0,...r);const o=[new b(D,d,r.map(s=>s.apiCell),[]),new b(v,0,[],r)];for(const s of o)m.push(s.asApiEvent())}t(D,d){this.b[D].setOutputs(d)}u(D,d,v,m){this.b[D].setOutputItems(d,v,m)}v(D,d){const v=this.b[D];v.apiCell.document.languageId!==d&&this.m.$acceptModelLanguageChanged(v.uri,d)}w(D,d){const v=this.b[D];v.apiCell.mime=d}x(D,d){this.b[D].setMetadata(d)}y(D,d){this.b[D].setInternalMetadata(d)}getCellFromApiCell(D){return this.b.find(d=>d.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(d=>d.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$kmc=E}),define(Ie[276],Ce([1,0,5,2,8,7,35]),function(le,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=void 0;class b{constructor(E,F,D,d={timeout:1500,errors:3}){this.b=E,this.c=F,this.d=D,this.f=d,this.a=new I.$ge}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(F,D,d)=>{const v=function(r){F.call(D,r)};return v.extension=E,this.a.event(v,void 0,d)}}async $participateInSave(E,F,D){const d=N.URI.revive(E),v=this.c.getNotebookDocument(d);if(!v)throw new Error("Unable to resolve notebook document");const m=[];if(await this.a.fireAsync({notebook:v.apiNotebook,reason:R.TextDocumentSaveReason.to(F)},D,async(o,s)=>{const i=Date.now(),n=await await Promise.resolve(o);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!D.isCancellationRequested&&n&&(n instanceof O.$aN?m.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),D.isCancellationRequested)return!1;if(m.length===0)return!0;const r={edits:[]};for(const o of m){const{edits:s}=R.WorkspaceEdit.from(o);r.edits=r.edits.concat(s)}return this.d.$tryApplyWorkspaceEdit(new M.$uw(r))}}e.$zmc=b}),define(Ie[114],Ce([1,0,14,8,7]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=void 0;class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,p,E,F,D,d){this.id=b,this.f=p,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=F,this.c=d}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection(p){this.selections=[p]},get selections(){return b.a},set selections(p){if(!Array.isArray(p)||!p.every(R.$sO.isNotebookRange))throw(0,I.$7)("selections");b.a=p,b.g(p)},get visibleRanges(){return b.b},revealRange(p,E){b.f.$tryRevealRange(b.id,N.NotebookRange.from(p),E??R.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(N.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$lmc=O}),define(Ie[277],Ce([1,0,5,12,8]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=void 0;let O=class{constructor(b,p){this.c=b,this.d=p,this.a=new I.$ee,this.b=new I.$ee,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,p);const E=this.d.getEditorById(b);p.visibleRanges&&E._acceptVisibleRanges(p.visibleRanges.ranges.map(R.NotebookRange.to)),p.selections&&E._acceptSelections(p.selections.selections.map(R.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const p in b)this.d.getEditorById(p)._acceptViewColumn(R.ViewColumn.to(b[p]))}};e.$Bmc=O,e.$Bmc=O=Je([We(0,N.$2j)],O)}),define(Ie[278],Ce([1,0,5,4,114]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=void 0;class O{constructor(b,p){this.c=p,this.a=new Map,this.b=b.getProxy(N.$1M.MainThreadNotebookRenderers)}$postRendererMessage(b,p,E){const F=this.c.getEditorById(b);this.a.get(p)?.fire({editor:F.apiEditor,message:E})}createRendererMessaging(b,p){if(!b.contributes?.notebookRenderer?.some(F=>F.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(F,D,d)=>this.d(p).event(F,D,d),postMessage:(F,D)=>{R.$lmc.apiEditorsToExtHost.has(F)&&([F,D]=[D,F]);const d=D&&R.$lmc.apiEditorsToExtHost.get(D);return this.b.$postMessage(d?.id,p,F)}}}d(b){let p=this.a.get(b);return p||(p=new I.$ee({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(b)}}),this.a.set(b,p),p)}}e.$Emc=O}),define(Ie[279],Ce([1,0,8,103,24,69,14]),function(le,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;class b{constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,d,v){const m=this.b++,{title:r,location:o,cancellable:s}=d,i={label:D.displayName||D.name,id:D.identifier.value};return this.a.$startProgress(m,{location:I.ProgressLocation.from(o),title:r,source:i,cancellable:s},D.isUnderDevelopment?void 0:D.identifier.value).catch(M.$2),this.d(m,v,!!s)}d(D,d,v){let m;v&&(m=new R.$pe,this.c.set(D,m));const r=s=>{this.a.$progressEnd(s),this.c.delete(s),m?.dispose()};let o;try{o=d(new E(this.a,D),v&&m?m.token:R.CancellationToken.None)}catch(s){throw r(D),s}return o.then(s=>r(D),s=>r(D)),o}$acceptProgressCanceled(D){const d=this.c.get(D);d&&(d.cancel(),this.c.delete(D))}}e.$Imc=b;function p(F,D){return F.message=D.message,typeof D.increment=="number"&&(typeof F.increment=="number"?F.increment+=D.increment:F.increment=D.increment),F}class E extends N.$9v{constructor(D,d){super(v=>this.throttledReport(v)),this.c=D,this.d=d}throttledReport(D){this.c.$progressReport(this.d,D)}}Je([(0,O.$2h)(100,(F,D)=>p(F,D),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Ie[280],Ce([1,0,2,4,11,8]),function(le,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;class M{static{this.a=0}constructor(p,E){this.d=E,this.c=new Map,this.b=p.getProxy(N.$1M.MainThreadQuickDiff)}$provideOriginalResource(p,E,F){const D=I.URI.revive(E),d=this.c.get(p);return d?(0,R.$nh)(()=>d.provideOriginalResource(D,F)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(p,E,F,D){const d=M.a++;return this.c.set(d,E),this.b.$registerQuickDiffProvider(d,O.DocumentSelector.from(p,this.d),F,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(d),this.c.delete(d)}}}}e.$Jmc=M}),define(Ie[281],Ce([1,0,24,5,6,4,2,7,14,18,33,43,26,8]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=m;function m(r,o,s){const i=r.getProxy(O.$1M.MainThreadQuickOpen);class n{constructor(l,w){this.e=new Map,this.f=0,this.a=l,this.b=w}showQuickPick(l,w,$,k=I.CancellationToken.None){this.c=void 0;const y=Promise.resolve(w),C=++this.f,P=i.$show(C,{title:$?.title,placeHolder:$?.placeHolder,matchOnDescription:$?.matchOnDescription,matchOnDetail:$?.matchOnDetail,ignoreFocusLost:$?.ignoreFocusOut,canPickMany:$?.canPickMany},k),W={},V=P.then(()=>W);return Promise.race([V,y]).then(q=>{if(q===W)return;const A=(0,d.$FG)(l,"quickPickItemTooltip");return y.then(U=>{const K=[];for(let re=0;re<U.length;re++){const ae=U[re];if(typeof ae=="string")K.push({label:ae,handle:re});else if(ae.kind===b.QuickPickItemKind.Separator)K.push({type:"separator",label:ae.label});else{ae.tooltip&&!A&&console.warn(`Extension '${l.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`);const ye=ae.iconPath?a(ae.iconPath):void 0;K.push({label:ae.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:ae.description,detail:ae.detail,picked:ae.picked,alwaysShow:ae.alwaysShow,tooltip:A?v.MarkdownString.fromStrict(ae.tooltip):void 0,handle:re})}}return $&&typeof $.onDidSelectItem=="function"&&(this.c=re=>{$.onDidSelectItem(U[re])}),i.$setItems(C,K),P.then(re=>{if(typeof re=="number")return U[re];if(Array.isArray(re))return re.map(ae=>U[ae])})})}).then(void 0,q=>{if(!(0,p.$4)(q))return i.$setError(C,q),Promise.reject(q)})}$onItemSelected(l){this.c?.(l)}showInput(l,w=I.CancellationToken.None){return this.d=l?.validateInput,i.$input(l,typeof this.d=="function",w).then(void 0,$=>{if(!(0,p.$4)($))return Promise.reject($)})}async $validateInput(l){if(!this.d)return;const w=await this.d(l);if(!w||typeof w=="string")return w;let $;switch(w.severity){case b.InputBoxValidationSeverity.Info:$=F.default.Info;break;case b.InputBoxValidationSeverity.Warning:$=F.default.Warning;break;case b.InputBoxValidationSeverity.Error:$=F.default.Error;break;default:$=w.message?F.default.Error:F.default.Ignore;break}return{content:w.message,severity:$}}async showWorkspaceFolderPick(l,w=I.CancellationToken.None){const $=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!$)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(y=>y.uri.toString()===$.uri.toString())}createQuickPick(l){const w=new g(l,()=>this.e.delete(w._id));return this.e.set(w._id,w),w}createInputBox(l){const w=new u(l,()=>this.e.delete(w._id));return this.e.set(w._id,w),w}$onDidChangeValue(l,w){this.e.get(l)?._fireDidChangeValue(w)}$onDidAccept(l){this.e.get(l)?._fireDidAccept()}$onDidChangeActive(l,w){const $=this.e.get(l);$ instanceof g&&$._fireDidChangeActive(w)}$onDidChangeSelection(l,w){const $=this.e.get(l);$ instanceof g&&$._fireDidChangeSelection(w)}$onDidTriggerButton(l,w){this.e.get(l)?._fireDidTriggerButton(w)}$onDidTriggerItemButton(l,w,$){const k=this.e.get(l);k instanceof g&&k._fireDidTriggerItemButton(w,$)}$onDidHide(l){this.e.get(l)?._fireDidHide()}}class c{static{this.a=1}constructor(l,w){this.x=l,this.y=w,this._id=g.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$ee,this.q=new N.$ee,this.r=new N.$ee,this.s=new N.$ee,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(l){this.b=l,this.z({title:l})}get step(){return this.c}set step(l){this.c=l,this.z({step:l})}get totalSteps(){return this.d}set totalSteps(l){this.d=l,this.z({totalSteps:l})}get enabled(){return this.g}set enabled(l){this.g=l,this.z({enabled:l})}get busy(){return this.j}set busy(l){this.j=l,this.z({busy:l})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(l){this.k=l,this.z({ignoreFocusOut:l})}get value(){return this.l}set value(l){this.l=l,this.z({value:l})}get placeholder(){return this.m}set placeholder(l){this.m=l,this.z({placeholder:l})}get buttons(){return this.n}set buttons(l){this.n=l.slice(),this.o.clear(),l.forEach((w,$)=>{const k=w===b.$pO.Back?-1:$;this.o.set(k,w)}),this.z({buttons:l.map((w,$)=>({...a(w.iconPath),tooltip:w.tooltip,handle:w===b.$pO.Back?-1:$}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(l){this.l=l,this.q.fire(l)}_fireDidTriggerButton(l){const w=this.o.get(l);w&&this.r.fire(w)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,R.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(l){if(!this.v){for(const w of Object.keys(l)){const $=l[w];this.u[w]=$===void 0?null:$}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function h(S){if(S instanceof b.$ZN)return{id:S.id};const l=f(S),w=t(S);return{dark:typeof l=="string"?M.URI.file(l):l,light:typeof w=="string"?M.URI.file(w):w}}function t(S){return typeof S=="object"&&"light"in S?S.light:S}function f(S){return typeof S=="object"&&"dark"in S?S.dark:S}function a(S){const l=h(S);let w,$;return"id"in l?$=D.ThemeIcon.asClassName(l):w=l,{iconPath:w,iconClass:$}}class g extends c{constructor(l,w){super(l.identifier,w),this.O=l,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$ee,this.L=[],this.M=new N.$ee,this.N=new N.$ee,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(l){this.B=l.slice(),this.C.clear(),this.D.clear(),l.forEach((k,y)=>{this.C.set(y,k),this.D.set(k,y)});const w=(0,d.$FG)(this.O,"quickPickItemTooltip"),$=[];for(let k=0;k<l.length;k++){const y=l[k];if(y.kind===b.QuickPickItemKind.Separator)$.push({type:"separator",label:y.label});else{y.tooltip&&!w&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?a(y.iconPath):void 0;$.push({handle:k,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:w?v.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((P,W)=>({...a(P.iconPath),tooltip:P.tooltip,handle:W}))})}}this.z({items:$})}get canSelectMany(){return this.E}set canSelectMany(l){this.E=l,this.z({canSelectMany:l})}get matchOnDescription(){return this.F}set matchOnDescription(l){this.F=l,this.z({matchOnDescription:l})}get matchOnDetail(){return this.G}set matchOnDetail(l){this.G=l,this.z({matchOnDetail:l})}get sortByLabel(){return this.H}set sortByLabel(l){this.H=l,this.z({sortByLabel:l})}get keepScrollPosition(){return this.I}set keepScrollPosition(l){this.I=l,this.z({keepScrollPosition:l})}get activeItems(){return this.J}set activeItems(l){this.J=l.filter(w=>this.D.has(w)),this.z({activeItems:this.J.map(w=>this.D.get(w))})}get selectedItems(){return this.L}set selectedItems(l){this.L=l.filter(w=>this.D.has(w)),this.z({selectedItems:this.L.map(w=>this.D.get(w))})}_fireDidChangeActive(l){const w=(0,E.$Hb)(l.map($=>this.C.get($)));this.J=w,this.K.fire(w)}_fireDidChangeSelection(l){const w=(0,E.$Hb)(l.map($=>this.C.get($)));this.L=w,this.M.fire(w)}_fireDidTriggerItemButton(l,w){const $=this.C.get(l);if(!$||!$.buttons||!$.buttons.length)return;const k=$.buttons[w];k&&this.N.fire({button:k,item:$})}}class u extends c{constructor(l,w){super(l.identifier,w),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(l){this.B=l,this.z({password:l})}get prompt(){return this.C}set prompt(l){this.C=l,this.z({prompt:l})}get valueSelection(){return this.D}set valueSelection(l){this.D=l,this.z({valueSelection:l})}get validationMessage(){return this.E}set validationMessage(l){this.E=l,l?typeof l=="string"?this.z({validationMessage:l,severity:F.default.Error}):this.z({validationMessage:l.message,severity:l.severity??F.default.Error}):this.z({validationMessage:void 0,severity:F.default.Ignore})}}return new n(o,s)}}),define(Ie[282],Ce([1,0,2,5,69,6,11,4,18,149,12,20,43,8,26,16,22]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=e.$Lmc=void 0;function i(C){return C instanceof I.URI}function n(C,P){return C.scheme===r.Schemas.file&&P.scheme===r.Schemas.file&&o.$k?C.toString()===P.toString():C.toString().toLowerCase()===P.toString().toLowerCase()}function c(C){if(C)return typeof C.iconPath=="string"?I.URI.file(C.iconPath):I.URI.isUri(C.iconPath)||d.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function h(C){if(C.icon){if(I.URI.isUri(C.icon))return C.icon;if(d.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const P=C.icon;return{light:P.light,dark:P.dark}}}else return}function t(C,P){if(!C.iconPath&&!P.iconPath)return 0;if(C.iconPath){if(!P.iconPath)return 1}else return-1;const W=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,V=typeof P.iconPath=="string"?P.iconPath:I.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,E.$pr)(W,V)}function f(C,P){let W=0;if(C.strikeThrough!==P.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==P.faded)return C.faded?1:-1;if(C.tooltip!==P.tooltip)return(C.tooltip||"").localeCompare(P.tooltip||"");if(W=t(C,P),W!==0)return W;if(C.light&&P.light)W=t(C.light,P.light);else{if(C.light)return 1;if(P.light)return-1}if(W!==0)return W;if(C.dark&&P.dark)W=t(C.dark,P.dark);else{if(C.dark)return 1;if(P.dark)return-1}return W}function a(C,P){if(C.command!==P.command)return C.command<P.command?-1:1;if(C.title!==P.title)return C.title<P.title?-1:1;if(C.tooltip!==P.tooltip){if(C.tooltip!==void 0&&P.tooltip!==void 0)return C.tooltip<P.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(C.arguments===P.arguments)return 0;if(C.arguments)if(P.arguments){if(C.arguments.length!==P.arguments.length)return C.arguments.length-P.arguments.length}else return 1;else return-1;for(let W=0;W<C.arguments.length;W++){const V=C.arguments[W],q=P.arguments[W];if(V!==q&&!(i(V)&&i(q)&&n(V,q)))return V<q?-1:1}return 0}function g(C,P){let W=(0,E.$pr)(C.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(W!==0)return W;if(C.command&&P.command)W=a(C.command,P.command);else{if(C.command)return 1;if(P.command)return-1}if(W!==0)return W;if(C.decorations&&P.decorations)W=f(C.decorations,P.decorations);else{if(C.decorations)return 1;if(P.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)W=(0,E.$pr)(C.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)W=(0,E.$pr)(C.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return W}function u(C,P){for(let W=0;W<C.length;W++)if(C[W]!==P[W])return!1;return!0}function S(C,P){return C.command===P.command&&C.title===P.title&&C.tooltip===P.tooltip&&(C.arguments&&P.arguments?u(C.arguments,P.arguments):C.arguments===P.arguments)}function l(C,P){return(0,p.$ub)(C,P,S)}class w{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,m.$GG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,m.$GG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,m.$GG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,W,V,q,A){this.k=P,this.l=q,this.m=A,this.d="",this.e=new N.$ee,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=V}showValidationMessage(P,W){(0,m.$GG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,W)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$Lmc=w;class ${static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,W,V,q,A,U,K){this.q=P,this.s=W,this.t=V,this.u=q,this.v=A,this.multiDiffEditorEnableViewChanges=U,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$ee,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$ee,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=$.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,W){const V=this.h.get(P);return V?(0,M.$nh)(()=>this.s.executeCommand(V.command,...V.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort(g),V=(0,p.$Db)(this.o,P,g).map(U=>{const K=U.toInsert.map(re=>{const ae=this.e++;this.g.set(ae,re);const ye=re.resourceUri;let Pe;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const ge=new O.$Uc;Pe=this.s.converter.toInternal(re.command,ge),this.j.set(ae,ge)}else this.h.set(ae,re.command);const fe=(0,m.$FG)(this.w,"scmMultiDiffEditor"),me=fe?re.multiDiffEditorOriginalUri:void 0,Ae=fe?re.multiFileDiffEditorModifiedUri:void 0,ce=c(re.decorations),Me=re.decorations&&c(re.decorations.light)||ce,ie=re.decorations&&c(re.decorations.dark)||ce,z=[Me,ie],x=re.decorations&&re.decorations.tooltip||"",ve=re.decorations&&!!re.decorations.strikeThrough,Te=re.decorations&&!!re.decorations.faded,De=re.contextValue||"";return{rawResource:[ae,ye,z,x,ve,Te,De,Pe,me,Ae],handle:ae}});return{start:U.start,deleteCount:U.deleteCount,toInsert:K}}),q=V.map(({start:U,deleteCount:K,toInsert:re})=>[U,K,re.map(ae=>ae.rawResource)]),A=V.reverse();for(const{start:U,deleteCount:K,toInsert:re}of A){const ae=re.map(Pe=>Pe.handle),ye=this.n.splice(U,K,...ae);for(const Pe of ye)this.g.delete(Pe),this.h.delete(Pe),this.j.get(Pe)?.dispose(),this.j.delete(Pe)}return this.o=P,q}dispose(){this.l=!0,this.m.fire()}}class k{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let W;(0,m.$FG)(this.x,"quickDiffProvider")&&(W=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:W})}get historyProvider(){return(0,m.$GG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,m.$GG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new O.$Uc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new O.$Uc,this.o=P;const W=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:W})}get actionButton(){return(0,m.$GG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,m.$GG)(this.x,"scmActionButton"),this.p.value=new O.$Uc,this.q=P;const W=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(V=>V.map(q=>this.y.converter.toInternal(q,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:W??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&l(this.t,P))return;this.s.value=new O.$Uc,this.t=P;const W=(P||[]).map(V=>this.y.converter.toInternal(V,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:W})}get selected(){return this.u}constructor(P,W,V,q,A,U,K){this.x=P,this.y=q,this.z=A,this.A=U,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Wc,this.m=void 0,this.n=new O.$Wc,this.o=void 0,this.p=new O.$Wc,this.s=new O.$Wc,this.t=void 0,this.u=!1,this.v=new N.$ee,this.onDidChangeSelection=this.v.event,this.w=k.d++,this.C=new Map,this.D=new Set,this.#e=V;const re=I.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${A}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new w(P,W,this.#e,this.w,re),this.#e.$registerSourceControl(this.w,A,U,K,re)}createResourceGroup(P,W,V){const q=(0,m.$FG)(this.x,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,A=new $(this.#e,this.y,this.w,P,W,q,this.x),U=N.Event.once(A.onDidDispose)(()=>this.C.delete(A));return this.C.set(A,U),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const P=[],W=[];for(const[V,q]of this.C){q.dispose();const A=V.onDidUpdateResourceStates(()=>{this.D.add(V),this.eventuallyUpdateResourceStates()});N.Event.once(V.onDidDispose)(()=>{this.D.delete(V),A.dispose(),this.e.delete(V.handle),this.#e.$unregisterGroup(this.w,V.handle)}),P.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const U=V._takeResourceStateSnapshot();U.length>0&&W.push([V.handle,U]),this.e.set(V.handle,V)}this.#e.$registerGroups(this.w,P,W),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(W=>{const V=W._takeResourceStateSnapshot();V.length!==0&&P.push([W.handle,V])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,R.$1h)(100)],k.prototype,"eventuallyAddResourceGroups",null),Je([(0,R.$1h)(100)],k.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,W,V,q){this.l=W,this.m=V,this.n=q,this.g=new Map,this.h=new D.$Sm,this.j=new N.$ee,this.e=P.getProxy(b.$1M.MainThreadSCM),this.f=P.getProxy(b.$1M.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const U=this.g.get(A.sourceControlHandle);if(!U)return A;const K=U.getResourceGroup(A.groupHandle);return K?K.getResourceState(A.handle):A}else if(A&&A.$mid===4){const U=this.g.get(A.sourceControlHandle);return U?U.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const U=this.g.get(A.handle);return U||A}return A}})}createSourceControl(P,W,V,q){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,W,V,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const A=s.d++,U=new k(P,this.m,this.e,this.l,W,V,q);this.g.set(A,U);const K=this.h.get(P.identifier)||[];return K.push(U),this.h.set(P.identifier,K),U}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const W=this.h.get(P.identifier),V=W&&W[W.length-1];return V&&V.inputBox}$provideOriginalResource(P,W,V){const q=I.URI.revive(W);this.n.trace("ExtHostSCM#$provideOriginalResource",P,q.toString());const A=this.g.get(P);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$nh)(()=>A.quickDiffProvider.provideOriginalResource(q,V)).then(U=>U||null)}$onInputBoxValueChange(P,W){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const V=this.g.get(P);return V&&V.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(P,W,V,q){this.n.trace("ExtHostSCM#$executeResourceCommand",P,W,V);const A=this.g.get(P);if(!A)return Promise.resolve(void 0);const U=A.getResourceGroup(W);return U?U.$executeResourceCommand(V,q):Promise.resolve(void 0)}$validateInput(P,W,V){this.n.trace("ExtHostSCM#$validateInput",P);const q=this.g.get(P);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,M.$nh)(()=>q.inputBox.validateInput(W,V)).then(A=>{if(!A)return Promise.resolve(void 0);const U=v.MarkdownString.fromStrict(A.message);return U?Promise.resolve([U,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,W,V,q){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,V,q)??void 0}async $provideHistoryItems(P,W,V,q){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(W,V,q))?.map(K=>({...K,icon:h(K)}))??void 0}async $provideHistoryItemSummary(P,W,V,q){const A=this.g.get(P)?.historyProvider;if(typeof A?.provideHistoryItemSummary!="function")return;const U=await A.provideHistoryItemSummary(W,V,q);return U?{...U,icon:h(U)}:void 0}async $provideHistoryItemChanges(P,W,V,q){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(W,V,q)??void 0}};e.$Mmc=y,e.$Mmc=y=s=Je([We(3,F.$2j)],y)}),define(Ie[283],Ce([1,0,4,8,2]),function(le,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nmc=void 0;class O{static{this.a=0}constructor(b,p){this.d=p,this.c=new Map,this.b=b.getProxy(I.$1M.MainThreadShare)}async $provideShare(b,p,E){return await this.c.get(b)?.provideShare({selection:N.Range.to(p.selection),resourceUri:R.URI.revive(p.resourceUri)},E)??void 0}registerShareProvider(b,p){const E=O.a++;return this.c.set(E,p),this.b.$registerShareProvider(E,N.DocumentSelector.from(b,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Nmc=O}),define(Ie[284],Ce([1,0,7,4,178,6,8,15]),function(le,e,I,N,R,O,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=e.$Pmc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$1N("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$1N("statusBarItem.warningForeground")]])}#e;#t;constructor(d,v,m,r,o,s=I.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new O.$Uc,this.#e=d,this.#t=v,o&&r){this.c=(0,I.$CN)(r.identifier,o);const n=m.get(this.c);n&&(s=n.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(p.a++);this.e=r,this.f=o,this.g=s,this.h=this.u(i)}u(d){if((0,b.$_f)(d))return d===Number.POSITIVE_INFINITY?Number.MAX_VALUE:d===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:d}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(d){this.k=d,this.v()}set name(d){this.m=d,this.v()}set tooltip(d){this.l=d,this.v()}set color(d){this.n=d,this.v()}set backgroundColor(d){d&&!p.b.has(d.id)&&(d=void 0),this.o=d,this.v()}set command(d){this.r?.fromApi!==d&&(this.p&&this.q.add(this.p),this.p=new O.$Uc,typeof d=="string"?this.r={fromApi:d,internal:this.#t.toInternal({title:"",command:d},this.p)}:d?this.r={fromApi:d,internal:this.#t.toInternal(d,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(d){this.t=d,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let d;this.e?this.f?d=`${this.e.identifier.value}.${this.f}`:d=this.e.identifier.value:d=this.f;let v;this.m?v=this.m:v=(0,R.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=p.b.get(this.o.id));const r=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,d,this.e?.identifier.value,v,this.k,r,this.r?.internal,m,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Pmc=p;class E{constructor(d){this.b=[],this.a=d.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,R.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(d){const v={message:d};return this.b.unshift(v),this.c(),new I.$3M(()=>{const m=this.b.indexOf(v);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class F{constructor(d,v){this.e=new Map,this.a=d.getProxy(N.$1M.MainThreadStatusBar),this.b=v,this.c=new E(this)}$acceptStaticEntries(d){for(const v of d)this.e.set(v.entryId,v)}createStatusBarEntry(d,v,m,r){return new p(this.a,this.b,this.e,d,v,m,r)}setStatusBarMessage(d,v){const m=this.c.setMessage(d);let r;return typeof v=="number"?r=setTimeout(()=>m.dispose(),v):typeof v<"u"&&v.then(()=>m.dispose(),()=>m.dispose()),new I.$3M(()=>{m.dispose(),clearTimeout(r)})}}e.$Qmc=F}),define(Ie[115],Ce([1,0,30,107,52,77,62,8,2]),function(le,e,I,N,R,O,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=e.$CP=e.$BP=e.$AP=void 0;const E=(n,c,h,t)=>{let f=c;return{enumerable:!0,configurable:!1,get(){return f},set(a){if(!h(f,a)){const g=f;f=a,n.listener?.(t(a,g))}}}},F=(n,c)=>n===c,D={range:(n,c)=>n===c?!0:!n||!c?!1:n.isEqual(c),label:F,description:F,sortText:F,busy:F,error:F,canResolveChildren:F,tags:(n,c)=>!(n.length!==c.length||n.some(h=>!c.find(t=>h.id===t.id)))},d=n=>c=>({op:4,update:n(c)}),v=(n,c)=>({range:(()=>{let h;const t=d(f=>({range:I.$tt.lift(b.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return h},set(f){n.listener?.({op:6}),D.range(h,f)||(h=f,n.listener?.(t(f)))}}})(),label:E(n,c,D.label,d(h=>({label:h}))),description:E(n,void 0,D.description,d(h=>({description:h}))),sortText:E(n,void 0,D.sortText,d(h=>({sortText:h}))),canResolveChildren:E(n,!1,D.canResolveChildren,h=>({op:2,state:h})),busy:E(n,!1,D.busy,d(h=>({busy:h}))),error:E(n,void 0,D.error,d(h=>({error:b.MarkdownString.fromStrict(h)||null}))),tags:E(n,[],D.tags,(h,t)=>({op:1,new:h.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),m=n=>{const c=R.$ML.fromString(n.extId),h=new o(c.controllerId,c.localId,n.label,p.URI.revive(n.uri)||void 0);return h.range=b.Range.to(n.range||void 0),h.description=n.description||void 0,h.sortText=n.sortText||void 0,h.tags=n.tags.map(t=>b.TestTag.to({id:(0,M.$SL)(t).tagId})),h},r=n=>{let c;for(const h of n.tests){const t=m(h.item);(0,N.$kP)(t).parent=c,c=t}return c};e.$AP=r;class o{constructor(c,h,t,f){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const a=(0,N.$jP)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof s?void 0:a.parent}},children:{value:(0,O.$iP)(a,N.$kP,o),enumerable:!0,writable:!1},...v(a,t)})}}e.$BP=o;class s extends o{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$CP=s;class i extends O.$eP{constructor(c,h,t){super({controllerId:c,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:N.$kP,getChildren:f=>f.children,root:new s(c,h),toITestItem:b.TestItem.from})}}e.$DP=i}),define(Ie[32],Ce([1,0,15,7,8,25,4,18,12,49,30,94,2,6,3,17,115,21,35,44,66,59,63,34]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o,s,i,n,c,h,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=void 0;let a=class{#e;#t;#i;constructor($,k,y){this.b=new Map,this.c=new Map,this.#e=$.getProxy(M.$1M.MainThreadCommands),this.d=k,this.#i=y,this.#t=$.getProxy(M.$1M.MainThreadTelemetry),this.converter=new g(this,C=>{const P=this.c.get(C);return P?.result===S.Void?P:void 0},k),this.f=[{processArgument(C){return(0,E.$5h)(C)}},{processArgument(C){return(0,O.$4n)(C,function(P){if(F.$tt.isIRange(P))return R.Range.to(P);if(D.$st.isIPosition(P))return R.Position.to(P);if(F.$tt.isIRange(P.range)&&d.URI.isUri(P.uri))return R.location.to(P);if(P instanceof s.$Fe)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor($){this.f.push($)}registerApiCommand($){const k=this.registerCommand(!1,$.id,async(...y)=>{const C=$.args.map((W,V)=>{if(!W.validate(y[V]))throw new Error(`Invalid argument '${W.name}' when running '${$.id}', received: ${typeof y[V]=="object"?JSON.stringify(y[V],null,"	"):y[V]} `);return W.convert(y[V])}),P=await this.executeCommand($.internalId,...C);return $.result.convert(P,y,this.converter)},void 0,{description:$.description,args:$.args,returns:$.result.description});return this.c.set($.id,$),new N.$3M(()=>{k.dispose(),this.c.delete($.id)})}registerCommand($,k,y,C,P,W){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:y,thisArg:C,metadata:P,extension:W}),$&&this.#e.$registerCommand(k),new N.$3M(()=>{this.b.delete(k)&&$&&this.#e.$unregisterCommand(k)})}executeCommand($,...k){return this.d.trace("ExtHostCommands#executeCommand",$),this.g($,k,!0)}async g($,k,y){if(this.b.has($))return this.#e.$fireCommandActivationEvent($),this.h($,k,!1);{let C=!1;const P=(0,O.$4n)(k,function(W){if(W instanceof N.$4M)return R.Position.from(W);if(W instanceof N.$5M)return R.Range.from(W);if(W instanceof N.$cN)return R.location.from(W);if(N.$sO.isNotebookRange(W))return R.NotebookRange.from(W);if(W instanceof ArrayBuffer)return C=!0,s.$Fe.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return C=!0,s.$Fe.wrap(W);if(W instanceof s.$Fe)return C=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand($,C?new i.$uw(P):P,y);return(0,E.$5h)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g($,k,!1);throw W}}}async h($,k,y){const C=this.b.get($);if(!C)throw new Error("Unknown command");const{callback:P,thisArg:W,metadata:V}=C;if(V?.args)for(let A=0;A<V.args.length;A++)try{(0,I.$mg)(k[A],V.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${$}' failed. Illegal argument '${V.args[A].name}' - ${V.args[A].description}`)}const q=c.$ae.create();try{return await P.apply(W,k)}catch(A){if($===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...k);U&&($=U.command)}if(this.d.error(A,$,C.extension?.identifier),!y)throw A;if(C.extension?.identifier){const U=this.#i.onExtensionError(C.extension.identifier,A);this.d.trace("forwarded error to extension?",U,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$gj)(A)),this.id=$,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,$,q.elapsed())}}j($,k,y){$.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:$.extension.identifier.value,id:new h.$ep(k),duration:y})}$executeContributedCommand($,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",$);const y=this.b.get($);return y?(k=k.map(C=>this.f.reduce((P,W)=>W.processArgument(P,y.extension?.identifier),C)),this.h($,k,!0)):Promise.reject(new Error(`Contributed command '${$}' does not exist.`))}getCommands($=!1){return this.d.trace("ExtHostCommands#getCommands",$),this.#e.$getCommands().then(k=>($&&(k=k.filter(y=>y[0]!=="_")),k))}$getContributedCommandMetadata(){const $=Object.create(null);for(const[k,y]of this.b){const{metadata:C}=y;C&&($[k]=C)}return Promise.resolve($)}};e.$JP=a,e.$JP=a=Je([We(0,r.$oP),We(1,p.$2j),We(2,t.$IP)],a),e.$KP=(0,m.$vi)("IExtHostCommands");class g{constructor($,k,y){this.d=$,this.f=k,this.g=y,this.delegatingCommandId=`__vsc${(0,f.$Rg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal($,k){if(!$)return;const y={$ident:void 0,id:$.command,title:$.title,tooltip:$.tooltip};if(!$.command)return y;const C=this.f($.command);if(C)y.id=C.internalId,y.arguments=C.args.map((P,W)=>P.convert($.arguments&&$.arguments[W]));else if((0,b.$Lb)($.arguments)){const P=`${$.command} /${++this.c}`;this.b.set(P,$),k.add((0,v.$Tc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),y.$ident=P,y.id=this.delegatingCommandId,y.arguments=[P],this.g.trace("CommandsConverter#CREATE",$.command,P)}return y}fromInternal($){return typeof $.$ident=="string"?this.b.get($.$ident):{command:$.id,title:$.title,arguments:$.arguments}}getActualCommand(...$){return this.b.get($[0])}h(...$){const k=this.getActualCommand(...$);return this.g.trace("CommandsConverter#EXECUTE",$[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${$[0]}`)}}e.$LP=g;class u{static{this.Uri=new u("uri","Uri of a text document",$=>d.URI.isUri($),$=>$)}static{this.Position=new u("position","A position in a text document",$=>N.$4M.isPosition($),R.Position.from)}static{this.Range=new u("range","A range in a text document",$=>N.$5M.isRange($),R.Range.from)}static{this.Selection=new u("selection","A selection in a text document",$=>N.$6M.isSelection($),R.Selection.from)}static{this.Number=new u("number","",$=>typeof $=="number",$=>$)}static{this.String=new u("string","",$=>typeof $=="string",$=>$)}static{this.StringArray=u.Arr(u.String)}static Arr($){return new u(`${$.name}_array`,`Array of ${$.name}, ${$.description}`,k=>Array.isArray(k)&&k.every(y=>$.validate(y)),k=>k.map(y=>$.convert(y)))}static{this.CallHierarchyItem=new u("item","A call hierarchy item",$=>$ instanceof N.$oN,R.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new u("item","A type hierarchy item",$=>$ instanceof N.$MO,R.TypeHierarchyItem.from)}static{this.TestItem=new u("testItem","A VS Code TestItem",$=>$ instanceof o.$BP,R.TestItem.from)}constructor($,k,y,C){this.name=$,this.description=k,this.validate=y,this.convert=C}optional(){return new u(this.name,`(optional) ${this.description}`,$=>$==null||this.validate($),$=>$===void 0?void 0:$===null?null:this.convert($))}with($,k){return new u($??this.name,k??this.description,this.validate,this.convert)}}e.$MP=u;class S{static{this.Void=new S("no result",$=>$)}constructor($,k){this.description=$,this.convert=k}}e.$NP=S;class l{constructor($,k,y,C,P){this.id=$,this.internalId=k,this.description=y,this.args=C,this.result=P}}e.$OP=l}),define(Ie[285],Ce([1,0,18,16,2,89,98,31,32,8,7]),function(le,e,I,N,R,O,M,b,p,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=void 0;const D=[new p.$OP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$MP.Uri,p.$MP.Position],new p.$NP("A promise that resolves to an array of DocumentHighlight-instances.",v(E.DocumentHighlight.to))),new p.$OP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$MP.Uri],new p.$NP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,I.$Kb)(r))return;class s extends F.$jN{static to(n){const c=new s(n.name,E.SymbolKind.to(n.kind),n.containerName||"",new F.$cN(o[0],E.Range.to(n.range)));return c.detail=n.detail,c.range=c.location.range,c.selectionRange=E.Range.to(n.selectionRange),c.children=n.children?n.children.map(s.to):[],c}}return r.map(s.to)})),new p.$OP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$MP.Uri,new p.$MP("options","Formatting options",r=>!0,r=>r)],new p.$NP("A promise that resolves to an array of TextEdits.",v(E.TextEdit.to))),new p.$OP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$MP.Uri,p.$MP.Range,new p.$MP("options","Formatting options",r=>!0,r=>r)],new p.$NP("A promise that resolves to an array of TextEdits.",v(E.TextEdit.to))),new p.$OP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$MP.Uri,p.$MP.Position,new p.$MP("ch","Trigger character",r=>typeof r=="string",r=>r),new p.$MP("options","Formatting options",r=>!0,r=>r)],new p.$NP("A promise that resolves to an array of TextEdits.",v(E.TextEdit.to))),new p.$OP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$MP.Uri,p.$MP.Position],new p.$NP("A promise that resolves to an array of Location or LocationLink instances.",m)),new p.$OP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$MP.Uri,p.$MP.Position],new p.$NP("A promise that resolves to an array of Location or LocationLink instances.",m)),new p.$OP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$MP.Uri,p.$MP.Position],new p.$NP("A promise that resolves to an array of Location or LocationLink instances.",m)),new p.$OP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$MP.Uri,p.$MP.Position],new p.$NP("A promise that resolves to an array of Location or LocationLink instances.",m)),new p.$OP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$MP.Uri,p.$MP.Position],new p.$NP("A promise that resolves to an array of Location-instances.",v(E.location.to))),new p.$OP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$MP.Uri,p.$MP.Position],new p.$NP("A promise that resolves to an array of Hover-instances.",v(E.Hover.to))),new p.$OP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$MP.Uri,new p.$MP("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>F.$4M.isPosition(o)),r=>r.map(E.Position.from))],new p.$NP("A promise that resolves to an array of ranges.",r=>r.map(o=>{let s;for(const i of o.reverse())s=new F.$nN(E.Range.to(i),s);return s}))),new p.$OP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$MP.String.with("query","Search string")],new p.$NP("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(E.WorkspaceSymbol.to))),new p.$OP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$MP.Uri,p.$MP.Position],new p.$NP("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(E.CallHierarchyItem.to))),new p.$OP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$MP.CallHierarchyItem],new p.$NP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(E.CallHierarchyIncomingCall.to))),new p.$OP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$MP.CallHierarchyItem],new p.$NP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(E.CallHierarchyOutgoingCall.to))),new p.$OP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$MP.Uri,p.$MP.Position],new p.$NP("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:E.Range.to(r.range),placeholder:r.text}})),new p.$OP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$MP.Uri,p.$MP.Position,p.$MP.String.with("newName","The new symbol name")],new p.$NP("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return E.WorkspaceEdit.to(r)}})),new p.$OP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$MP.Uri,p.$MP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$NP("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(E.DocumentLink.to))),new p.$OP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$MP.Uri],new p.$NP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new F.$jO(r.tokenTypes,r.tokenModifiers)})),new p.$OP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$MP.Uri],new p.$NP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,M.$8bb)(r);if(o.type==="full")return new F.$lO(o.data,void 0)})),new p.$OP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$MP.Uri,p.$MP.Range.optional()],new p.$NP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new F.$jO(r.tokenTypes,r.tokenModifiers)})),new p.$OP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$MP.Uri,p.$MP.Range],new p.$NP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,M.$8bb)(r);if(o.type==="full")return new F.$lO(o.data,void 0)})),new p.$OP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$MP.Uri,p.$MP.Position,p.$MP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$MP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$NP("A promise that resolves to a CompletionList-instance.",(r,o,s)=>{if(!r)return new F.$zN([]);const i=r.suggestions.map(n=>E.CompletionItem.to(n,s));return new F.$zN(i,r.incomplete)})),new p.$OP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$MP.Uri,p.$MP.Position,p.$MP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$NP("A promise that resolves to SignatureHelp.",r=>{if(r)return E.SignatureHelp.to(r)})),new p.$OP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$MP.Uri,p.$MP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$NP("A promise that resolves to an array of CodeLens-instances.",(r,o,s)=>v(i=>new F.$rN(E.Range.to(i.range),i.command&&s.fromInternal(i.command)))(r))),new p.$OP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$MP.Uri,new p.$MP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>F.$5M.isRange(r),r=>F.$6M.isSelection(r)?E.Selection.from(r):E.Range.from(r)),p.$MP.String.with("kind","Code action kind to return code actions for").optional(),p.$MP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$NP("A promise that resolves to an array of Command-instances.",(r,o,s)=>v(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(i.command)}else{const n=new F.$lN(i.title,i.kind?new F.$mN(i.kind):void 0);return i.edit&&(n.edit=E.WorkspaceEdit.to(i.edit)),i.command&&(n.command=s.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(r))),new p.$OP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$MP.Uri],new p.$NP("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new F.$FN(E.Range.to(o.range),E.Color.to(o.color))):[])),new p.$OP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$MP("color","The color to show and insert",r=>r instanceof F.$EN,E.Color.from),new p.$MP("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:E.Range.from(r.range)}))],new p.$NP("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(E.ColorPresentation.to):[])),new p.$OP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$MP.Uri,p.$MP.Range],new p.$NP("A promise that resolves to an array of Inlay objects",(r,o,s)=>r.map(E.InlayHint.to.bind(void 0,s)))),new p.$OP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$MP.Uri],new p.$NP("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(E.FoldingRange.to)})),new p.$OP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$NP("A promise that resolves to an array of NotebookContentProvider static info objects.",v(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>E.NotebookExclusiveDocumentPattern.to(o))})))),new p.$OP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$MP.Uri,p.$MP.Range,new p.$MP("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof F.$5M,r=>E.InlineValueContext.from(r))],new p.$NP("A promise that resolves to an array of InlineValue objects",r=>r.map(E.InlineValue.to))),new p.$OP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$MP("uriOrString","Uri-instance or string (only http/https)",r=>R.URI.isUri(r)||typeof r=="string"&&(0,N.$Fg)(r,N.Schemas.http,N.Schemas.https),r=>r),new p.$MP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[E.ViewColumn.from(r),void 0]:[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)])).optional(),p.$MP.String.with("label","").optional()],p.$NP.Void),new p.$OP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$MP.Uri.with("resource","Resource to open"),p.$MP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$MP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[E.ViewColumn.from(r),void 0]:[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)])).optional()],p.$NP.Void),new p.$OP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$MP.Uri.with("left","Left-hand side resource of the diff editor"),p.$MP.Uri.with("right","Right-hand side resource of the diff editor"),p.$MP.String.with("title","Human readable title for the diff editor").optional(),new p.$MP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)]).optional()],p.$NP.Void),new p.$OP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$MP.String.with("title","Human readable title for the changes editor"),new p.$MP("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[s,i,n]=o;if(!R.URI.isUri(s)||!R.URI.isUri(i)&&i!==void 0&&i!==null||!R.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},r=>r)],p.$NP.Void),new p.$OP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$MP.Uri,p.$MP.Position],new p.$NP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new p.$OP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$MP.TypeHierarchyItem],new p.$NP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new p.$OP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$MP.TypeHierarchyItem],new p.$NP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new p.$OP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$MP.TestItem],p.$NP.Void),new p.$OP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$MP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$NP.Void),new p.$OP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$MP.String.with("name","The context key name"),new p.$MP("value","The context key value",()=>!0,r=>r)],p.$NP.Void),new p.$OP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$MP.Uri,p.$MP.StringArray,new p.$MP("MappedEditsContext","Mapped Edits Context",r=>E.MappedEditsContext.is(r),r=>E.MappedEditsContext.from(r))],new p.$NP("A promise that resolves to a workspace edit or null",r=>r?E.WorkspaceEdit.to(r):null))];class d{static register(o){D.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",b.$uj)}}e.$_kc=d;function v(r){return o=>{if(Array.isArray(o))return o.map(r)}}function m(r){if(!Array.isArray(r))return;const o=[];for(const s of r)O.$$t(s)?o.push(E.DefinitionLink.to(s)):o.push(E.location.to(s));return o}}),define(Ie[286],Ce([1,0,11,6,2,4,32,8,7]),function(le,e,I,N,R,O,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=void 0;class E{static{this.a=0}constructor(v,m){this.extension=v,this.provider=m,this.handle=E.a++}}class F{constructor(v){this.session=v,this.responses=[]}}class D{static{this.a=0}constructor(v,m,r,o){this.f=r,this.g=o,this.b=new Map,this.d=new Map,this.e=v.getProxy(O.$1M.MainThreadInlineChat),m.registerApiCommand(new M.$OP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$MP("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?b.Range.from(s.initialRange):void 0,initialSelection:p.$6M.isSelection(s.initialSelection)?b.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?b.Position.from(s.position):void 0}})],M.$NP.Void))}registerProvider(v,m,r){const o=new E(v,m);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,r?.label??v.displayName??v.name,v.identifier,typeof m.handleInteractiveEditorResponseFeedback=="function",typeof m.provideFollowups=="function",r?.supportReportIssue??!1),(0,N.$Tc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(v,m,r,o){const s=this.b.get(v);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(R.URI.revive(m)),n=b.Selection.to(r),c=await s.provider.prepareInteractiveEditorSession({document:i,selection:n},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=D.a++;return this.d.set(h,new F(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:b.Range.from(c.wholeRange),message:c.message}}async $provideResponse(v,m,r,o){const s=this.b.get(v);if(!s)return;const i=this.d.get(m.id);if(!i)return;const n={prompt:r.prompt,selection:b.Selection.to(r.selection),wholeRange:b.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,previewDocument:this.f.getDocument(R.URI.revive(r.previewDocument)),withIntentDetection:r.withIntentDetection};let c=!1;const h={report:async w=>{if(!r.live&&w.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:w.message,edits:w.edits?.map(b.TextEdit.from),editsShouldBeInstant:w.editsShouldBeInstant,slashCommand:w.slashCommand?.command,markdownFragment:p.$sN.isMarkdownString(w.content)?w.content.value:w.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,n,h,o));let f;try{f=await(0,I.$jh)(t,o)}finally{c=!0}if(!f)return;const a=i.responses.push(f)-1,g={wholeRange:b.Range.from(f.wholeRange),placeholder:f.placeholder};if(!D.h(f))return{...g,id:a,type:"editorEdit",message:b.MarkdownString.from(f.contents),edits:[]};const{edits:u,contents:S}=f,l=S!==void 0?b.MarkdownString.from(S):void 0;return u instanceof p.$aN?{...g,id:a,type:"bulkEdit",edits:b.WorkspaceEdit.from(u),message:l}:{...g,id:a,type:"editorEdit",edits:u.map(b.TextEdit.from),message:l}}async $provideFollowups(v,m,r,o){const s=this.b.get(v),i=this.d.get(m),n=i?.responses[r];if(s&&n&&s.provider.provideFollowups){const c=Promise.resolve(s.provider.provideFollowups(i.session,n,o));return(await(0,I.$jh)(c,o))?.map(b.ChatInlineFollowup.from)}}$handleFeedback(v,m,r,o){const s=this.b.get(v),i=this.d.get(m),n=i?.responses[r];if(s&&n){const c=b.InteractiveEditorResponseFeedbackKind.to(o);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,c)}}$releaseSession(v,m){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$imc=D}),define(Ie[287],Ce([1,0,2,32]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=void 0;class R{constructor(M,b,p,E,F){this.a=b,this.b=p,this.c=E;const D=new N.$OP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$MP("showOptions","Show Options",d=>!0,d=>d),new N.$MP("resource","Interactive resource Uri",d=>!0,d=>d),new N.$MP("controllerId","Notebook controller Id",d=>!0,d=>d),new N.$MP("title","Interactive editor title",d=>!0,d=>d)],new N.$NP("Notebook and input URI",d=>{if(F.debug("[ExtHostInteractive] open iw with notebook editor id",d.notebookEditorId),d.notebookEditorId!==void 0){const v=this.a.getEditorById(d.notebookEditorId);return F.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:I.URI.revive(d.notebookUri),inputUri:I.URI.revive(d.inputUri),notebookEditor:v.apiEditor}}return F.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",d.notebookUri,d.inputUri),{notebookUri:I.URI.revive(d.notebookUri),inputUri:I.URI.revive(d.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(M,b,p,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:p,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$vmc=R}),define(Ie[288],Ce([1,0,18,11,24,5,6,28,2,20,12,4,32,8,7,78,229,26,35,230]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o,s,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=void 0,e.$Dmc=u;let c=class{constructor(l,w,$,k,y){this.m=w,this.n=$,this.o=k,this.q=y,this.b=new b.$Bc,this.c=new b.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$ee,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=l.getProxy(D.$1M.MainThreadNotebookKernels);const C=new d.$OP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new d.$MP("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],d.$NP.Void),P=new d.$OP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[d.$MP.Uri],new d.$NP("A promise that resolves to an array of variables",(W,V)=>W.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(P)}createNotebookController(l,w,$,k,y,C){for(const ce of this.j.values())if(ce.controller.id===w&&E.$Qm.equals(l.identifier,ce.extensionId))throw new Error(`notebook controller with id '${w}' ALREADY exist`);const P=this.k++,W=this;this.q.trace(`NotebookController[${P}], CREATED by ${l.identifier.value}, ${w}`);const V=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${l.identifier}'`);let q=!1;const A=new O.$ee,U=new O.$ee,K={id:u(l.identifier,w),notebookType:$,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:k||l.identifier.value,preloads:C?C.map(v.NotebookRendererScript.from):[]};let re=y??V,ae,ye;this.a.$addKernel(P,K).catch(ce=>{console.log(ce),q=!0});let Pe=0;const fe=()=>{if(q)return;const ce=++Pe;Promise.resolve().then(()=>{ce===Pe&&this.a.$updateKernel(P,K)})},me=new b.$Bc,Ae={get id(){return w},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return K.label},set label(ce){K.label=ce??l.displayName??l.name,fe()},get detail(){return K.detail??""},set detail(ce){K.detail=ce,fe()},get description(){return K.description??""},set description(ce){K.description=ce,fe()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(ce){K.supportedLanguages=ce,fe()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){K.supportsExecutionOrder=ce,fe()},get rendererScripts(){return K.preloads?K.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler(ce){re=ce??V},get interruptHandler(){return ae},set interruptHandler(ce){ae=ce,K.supportsInterrupt=!!ce,fe()},set variableProvider(ce){(0,s.$GG)(l,"notebookVariableProvider"),ye=ce,K.hasVariableProvider=!!ce,ce?.onDidChangeVariables(Me=>W.a.$variablesUpdated(Me.uri)),fe()},get variableProvider(){return ye},createNotebookCellExecution(ce){if(q)throw new Error("notebook controller is DISPOSED");if(!me.has(ce.notebook.uri))throw W.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(me.keys()).map(Me=>Me.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return W._createNotebookCellExecution(ce,u(l.identifier,this.id))},createNotebookExecution(ce){if((0,s.$GG)(l,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!me.has(ce.uri))throw W.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(me.keys()).map(Me=>Me.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.uri.toString()}`);return W._createNotebookExecution(ce,u(l.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${P}], DISPOSED`),q=!0,this.j.delete(P),A.dispose(),U.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(ce,Me){Me===m.NotebookControllerAffinity2.Hidden&&(0,s.$GG)(l,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(P,ce.uri,Me)},onDidReceiveMessage:U.event,postMessage(ce,Me){return(0,s.$GG)(l,"notebookMessaging"),W.a.$postMessage(P,Me&&W.n.getIdByEditor(Me),ce)},asWebviewUri(ce){return(0,s.$GG)(l,"notebookMessaging"),(0,r.$4yb)(ce,W.m.remote)}};return this.j.set(P,{extensionId:l.identifier,controller:Ae,onDidReceiveMessage:U,onDidChangeSelection:A,associatedNotebooks:me}),Ae}getIdByController(l){for(const[w,$]of this.j)if($.controller===l)return u($.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,w){const $=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${$}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask($,w);const y={dispose:()=>{this.f.delete($),k.a.$removeKernelDetectionTask($)}};return this.f.set($,y),y}registerKernelSourceActionProvider(l,w,$){const k=this.i++,y=typeof $.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,C=this;this.h.set(k,$),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,w);let P;return y!==void 0&&(P=$.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(k),C.a.$removeKernelSourceActionProvider(k,k),P?.dispose()}}}async $provideKernelSourceActions(l,w){const $=this.h.get(l);if($){const k=new M.$Uc;return(await $.provideNotebookKernelSourceActions(w)??[]).map(C=>v.NotebookKernelSourceAction.from(C,this.o.converter,k))}return[]}$acceptNotebookAssociation(l,w,$){const k=this.j.get(l);if(k){const y=this.n.getNotebookDocument(p.URI.revive(w));$?k.associatedNotebooks.set(y.uri,!0):k.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,y.uri.toString(),$),k.onDidChangeSelection.fire({selected:$,notebook:y.apiNotebook})}}async $executeCells(l,w,$){const k=this.j.get(l);if(!k)return;const y=this.n.getNotebookDocument(p.URI.revive(w)),C=[];for(const P of $){const W=y.getCell(P);W&&C.push(W.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,y.uri.toString(),C.length),await k.controller.executeHandler.call(k.controller,C,y.apiNotebook,k.controller)}catch(P){this.q.error(`NotebookController[${l}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(l,w,$){const k=this.j.get(l);if(!k)return;const y=this.n.getNotebookDocument(p.URI.revive(w));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,y.apiNotebook);else for(const C of $){const P=y.getCell(C);P&&this.b.get(P.uri)?.cancel()}if(k.controller.interruptHandler){const C=this.c.get(y.uri);$.length&&Array.isArray(C)&&C.length&&C.forEach(P=>P.dispose())}}async $provideVariables(l,w,$,k,y,C,P){const W=this.j.get(l);if(!W)return;const V=this.n.getNotebookDocument(p.URI.revive($)),q=W.controller.variableProvider;if(!q)return;let A;if(k!==void 0){if(A=this.s[k],!A)return}else this.s={};const U=y==="named"?m.NotebookVariablesRequestKind.Named:m.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(V.apiNotebook,A,U,C,P);let re=0;for await(const ae of K){if(P.isCancellationRequested)return;const ye={id:this.r++,name:ae.variable.name,value:ae.variable.value,type:ae.variable.type,interfaces:ae.variable.interfaces,language:ae.variable.language,expression:ae.variable.expression,hasNamedChildren:ae.hasNamedChildren,indexedChildrenCount:ae.indexedChildrenCount,extensionId:W.extensionId.value};if(this.s[ye.id]=ae.variable,this.a.$receiveVariable(w,ye),re++>=n.$_ib)return}}$acceptKernelMessageFromRenderer(l,w,$){const k=this.j.get(l);if(!k)return;const y=this.n.getEditorById(w);k.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:$}))}$cellExecutionChanged(l,w,$){const y=this.n.getNotebookDocument(p.URI.revive(l)).getCell(w);if(y){const C=$?v.NotebookCellExecutionState.to($):m.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:y.apiCell,state:C})}}_createNotebookCellExecution(l,w){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const y=new t(w,k,this.a);this.b.set(k.uri,y);const C=y.onDidChangeState(()=>{y.state===h.Resolved&&(y.dispose(),C.dispose(),this.b.delete(k.uri))});return y.asApiObject()}_createNotebookExecution(l,w){const $=this.n.getNotebookDocument(l.uri),k=l.getCells().find(P=>{const W=$.getCellFromApiCell(P);return W&&this.b.has(W.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has($.uri))throw new Error(`duplicate notebook execution for ${$.uri}`);const y=new a(w,$,this.a),C=y.onDidChangeState(()=>{y.state===f.Resolved&&(y.dispose(),C.dispose(),this.c.delete($.uri))});return this.c.set($.uri,[y,C]),y.asApiObject()}};e.$Cmc=c,e.$Cmc=c=Je([We(4,F.$2j)],c);var h;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(h||(h={}));class t extends M.$Vc{static{this.a=0}get state(){return this.f}constructor(l,w,$){super(),this.m=w,this.n=$,this.b=t.a++,this.c=new O.$ee,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new R.$pe),this.h=new g(10,k=>this.s(k)),this.j=w.internalMetadata.executionOrder,this.n.$createExecution(this.b,l,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(l){await this.h.addItem(l)}async s(l){const w=Array.isArray(l)?l:[l];return this.n.$updateExecution(this.b,new i.$uw(w))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(l){let w=this.m;if(l&&(w=this.m.notebook.getCellFromApiCell(l)),!w)throw new Error("INVALID cell");return w.handle}y(l){return l.map(w=>{const $=m.$wO.ensureUniqueMimeTypes(w.items,!0);return $===w.items?v.NotebookCellOutput.from(w):v.NotebookCellOutput.from({items:$,id:w.id,metadata:w.metadata})})}async z(l,w,$){const k=this.w(w),y=this.y((0,I.$3b)(l));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:k,append:$,outputs:y})}async C(l,w,$){return l=m.$wO.ensureUniqueMimeTypes((0,I.$3b)(l),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:l.map(v.NotebookCellOutputItem.from),outputId:w.id,append:$})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.m.apiCell},get executionOrder(){return l.j},set executionOrder($){l.j=$,l.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:l.j}])},start($){if(l.f===h.Resolved||l.f===h.Started)throw new Error("Cannot call start again");l.f=h.Started,l.c.fire(),l.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:$})},end($,k,y){if(l.f===h.Resolved)throw new Error("Cannot call resolve twice");l.f=h.Resolved,l.c.fire(),l.h.flush();const C=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;l.n.$completeExecution(l.b,new i.$uw({runEndTime:k,lastRunSuccess:$,error:C}))},clearOutput($){return l.t(),l.z([],$,!1)},appendOutput($,k){return l.t(),l.z($,k,!0)},replaceOutput($,k){return l.t(),l.z($,k,!1)},appendOutputItems($,k){return l.t(),l.C($,k,!0)},replaceOutputItems($,k){return l.t(),l.C($,k,!1)}})}}var f;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(f||(f={}));class a extends M.$Vc{static{this.a=0}get state(){return this.f}constructor(l,w,$){super(),this.h=w,this.j=$,this.b=a.a++,this.c=new O.$ee,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new R.$pe),this.j.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class g{constructor(l,w){this.f=l,this.g=w,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new N.$Sh,this.b=Date.now(),(0,N.$wh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const w=this.a;return this.a=[],this.g(w).finally(()=>l.complete())}}function u(S,l){return`${S.value}/${l}`}}),define(Ie[53],Ce([1,0,5,4,3,2,17,6,7,180,14,208,24,34,209,43,11,8,32]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=e.$Plc=e.$Olc=e.$Nlc=void 0,e.$Nlc=(0,R.$vi)("IExtHostTerminalService");class n extends b.$Vc{constructor($,k,y,C){super(),this.u=$,this._id=k,this.w=y,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new I.$ee),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const P=this;this.value={get name(){return P.y||""},get processId(){return P.b},get creationOptions(){return P.w},get exitStatus(){return P.j},get state(){return P.m},get selection(){return P.n},get shellIntegration(){return P.shellIntegration},sendText(W,V=!0){P.C(),P.u.$sendText(P._id,W,V)},show(W){P.C(),P.u.$show(P._id,W)},hide(){P.C(),P.u.$hide(P._id)},dispose(){P.a||(P.a=!0,P.u.$dispose(P._id))},get dimensions(){if(!(P.f===void 0||P.h===void 0))return{columns:P.f,rows:P.h}}}}dispose(){this.s.fire(),super.dispose()}async create($,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??k?.cwd??void 0,env:$.env??void 0,icon:u($.iconPath)??void 0,color:r.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,forceShellIntegration:k?.forceShellIntegration??void 0,isFeatureTerminal:k?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:k?.useShellEnvironment??void 0,location:k?.location||this.z($.location,k?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,k,y,C,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:r.ThemeColor.isThemeColor(P)?P.id:void 0,location:k?.location||this.z($,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z($,k){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&k?{parentTerminal:k}:"viewColumn"in $?{viewColumn:s.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.y=$}setExitStatus($,k){this.j=Object.freeze({code:$,reason:k})}setDimensions($,k){return $===this.f&&k===this.h||$===0||k===0?!1:(this.f=$,this.h=k,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection($){this.n=$}_setProcessId($){this.g?(this.g($),this.g=void 0):this.b.then(k=>{k!==$&&(this.b=Promise.resolve($))})}}e.$Olc=n;class c{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new I.$ee,this.onProcessData=this.a.event,this.b=new I.$ee,this.d=new I.$ee,this.onDidChangeProperty=this.d.event,this.f=new I.$ee,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,k){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${k}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,k){this.g.setDimensions?.({columns:$,rows:k})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(k=>this.a.fire(k)),this.g.onDidClose?.((k=void 0)=>{this.f.fire(k===void 0?void 0:k)}),this.g.onDidOverrideDimensions?.(k=>{k&&this.d.fire({type:"overrideDimensions",value:{cols:k.columns,rows:k.rows}})}),this.g.onDidChangeName?.(k=>{this.d.fire({type:"title",value:k})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends b.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,k,y){super(),this.Q=k,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$ee,this.onDidCloseTerminal=this.H.event,this.I=new I.$ee,this.onDidOpenTerminal=this.I.event,this.J=new I.$ee,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$ee,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$ee,this.onDidChangeTerminalState=this.M.event,this.N=new I.$ee,this.onDidChangeShell=this.N.event,this.O=new I.$ee({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$ee({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(N.$1M.MainThreadTerminalService),this.y=new m.$Vtb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:C=>{const P=W=>{const V=W;return this.getTerminalById(V.instanceId)?.value};switch(C?.$mid){case 15:return P(C);default:{if(Array.isArray(C))for(let W=0;W<C.length&&C[W].$mid===15;W++)C[W]=P(C[W]);return C}}}}),this.B({dispose:()=>{for(const[C,P]of this.g)P.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,k){const y=new n(this.a,(0,v.$Rg)(),$,$.name),C=new c($.pty);return y.createExtensionTerminal($.location,k,this.R($,k).resolvedExtHostIdentifier,u($.iconPath),S($.color)).then(P=>{const W=this.S(P,C);this.h[P]=W}),this.f.push(y),y.value}R($,k){if(k=k||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const y=$.location.parentTerminal;if(y){const C=this.f.find(P=>P.value===y);C&&(k.resolvedExtHostIdentifier=C._id)}}else $.location&&typeof $.location!="object"?k.location=$.location:k.location&&typeof k.location=="object"&&"splitActiveTerminal"in k.location&&(k.location={splitActiveTerminal:!0});return k}attachPtyToTerminal($,k){if(!this.getTerminalById($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const C=new c(k),P=this.S($,C);this.h[$]=P}async $acceptActiveTerminalChanged($){const k=this.b;if($===null){this.b=void 0,k!==this.b&&this.J.fire(this.b);return}const y=this.getTerminalById($);y&&(this.b=y,k!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,k){const y=this.getTerminalById($);y&&this.O.fire({terminal:y.value,data:k})}async $acceptTerminalDimensions($,k,y){const C=this.getTerminalById($);C&&C.setDimensions(k,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand($,k){const y=this.getTerminalById($);y&&this.P.fire({terminal:y.value,...k})}async $acceptTerminalMaximumDimensions($,k,y){this.g.get($)?.resize(k,y)}async $acceptTerminalTitleChange($,k){const y=this.getTerminalById($);y&&(y.name=k)}async $acceptTerminalClosed($,k,y){const C=this.X(this.f,$);if(C!==null){const P=this.f.splice(C,1)[0];P.setExitStatus(k,y),this.H.fire(P.value)}}$acceptTerminalOpened($,k,y,C){if(k){const V=this.X(this.f,k);if(V!==null){this.f[V]._id=$,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const P={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:O.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},W=new n(this.a,$,P,y);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId($,k){this.getTerminalById($)?._setProcessId(k)}async $startExtensionTerminal($,k){const y=this.getTerminalById($);if(!y)return{message:(0,E.localize)(0,null,$)};y.isOpen||await new Promise(P=>{const W=this.onDidOpenTerminal(async V=>{V===y.value&&(W.dispose(),P())})});const C=this.g.get($);C?C.startSendingEvents(k):this.j[$]={initialDimensions:k}}S($,k){const y=new b.$Uc;y.add(k.onProcessReady(P=>this.a.$sendProcessReady($,P.pid,P.cwd,P.windowsPty))),y.add(k.onDidChangeProperty(P=>this.a.$sendProcessProperty($,P))),this.y.startBuffering($,k.onProcessData),y.add(k.onProcessExit(P=>this.U($,P))),this.g.set($,k);const C=this.j[$];return C&&k instanceof c&&(k.startSendingEvents(C.initialDimensions),delete this.j[$]),y}$acceptProcessAckDataEvent($,k){this.g.get($)?.acknowledgeDataEvent(k)}$acceptProcessInput($,k){this.g.get($)?.input(k)}$acceptTerminalInteraction($){const k=this.getTerminalById($);k?.setInteractedWith()&&this.M.fire(k.value)}$acceptTerminalSelection($,k){this.getTerminalById($)?.setSelection(k)}$acceptProcessResize($,k,y){try{this.g.get($)?.resize(k,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown($,k){this.g.get($)?.shutdown(k)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(k=>this.a.$sendProcessProperty($,{type:"initialCwd",value:k}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(k=>this.a.$sendProcessProperty($,{type:"cwd",value:k}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new p.$3M(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,k,y){if(this.C.has(k))throw new Error(`Terminal profile provider "${k}" already registered`);return this.C.set(k,y),this.a.$registerProfileProvider(k,$.identifier.value),new p.$3M(()=>{this.C.delete(k),this.a.$unregisterProfileProvider(k)})}registerTerminalQuickFixProvider($,k,y){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,y),this.a.$registerQuickFixProvider($,k),new p.$3M(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,k){const y=new d.$pe().token;if(y.isCancellationRequested)return;const C=this.D.get($);if(!C)return;const P=await C.provideTerminalQuickFixes(k,y);if(P===null||Array.isArray(P)&&P.length===0)return;const W=new b.$Uc;if(this.w.value=W,!Array.isArray(P))return P?s.TerminalQuickFix.from(P,this.Q.converter,W):void 0;const V=[];for(const q of P){const A=s.TerminalQuickFix.from(q,this.Q.converter,W);A&&V.push(A)}return V}async $createContributedProfileTerminal($,k){const y=new d.$pe().token;let C=await this.C.get($)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,k);return}this.createTerminalFromOptions(C.options,k)}}async $provideLinks($,k){const y=this.getTerminalById($);if(!y)return[];this.F.delete($),this.G.get($)?.dispose(!0);const P=new d.$pe;this.G.set($,P);const W=[],V={terminal:y.value,line:k},q=[];for(const K of this.z)q.push(o.Promises.withAsyncBody(async re=>{P.token.onCancellationRequested(()=>re({provider:K,links:[]}));const ae=await K.provideTerminalLinks(V,P.token)||[];P.token.isCancellationRequested||re({provider:K,links:ae})}));const A=await Promise.all(q);if(P.token.isCancellationRequested)return[];const U=new Map;for(const K of A)K&&K.links.length>0&&W.push(...K.links.map(re=>{const ae={id:h++,startIndex:re.startIndex,length:re.length,label:re.tooltip};return U.set(ae.id,{provider:K.provider,link:re}),ae}));return this.F.set($,U),W}$activateLink($,k){const y=this.F.get($)?.get(k);y&&y.provider.handleTerminalLink(y.link)}U($,k){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const y=this.h[$];y&&(y.dispose(),delete this.h[$]),this.a.$sendProcessExit($,k)}getTerminalById($){return this.W(this.f,$)}getTerminalIdByApiObject($){const k=this.f.findIndex(y=>y.value===$);return k>=0?k:null}W($,k){const y=this.X($,k);return y!==null?$[y]:null}X($,k){const y=$.findIndex(C=>C._id===k);return y>=0?y:null}getEnvironmentVariableCollection($){let k=this.n.get($.identifier.value);return k||(k=new f,this.Z($.identifier.value,k)),k.getScopedEnvironmentVariableCollection(void 0)}Y($,k){const y=(0,D.$ks)(k.map),C=(0,D.$ls)(k.descriptionMap);this.a.$setEnvironmentVariableCollection($,k.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections($){$.forEach(k=>{const y=k[0],C=new f(k[1]);this.Z(y,C)})}$acceptDefaultProfile($,k){const y=this.s;this.s=$,this.u=k,y?.path!==$.path&&this.N.fire($.path)}Z($,k){this.n.set($,k),k.onDidChangeCollection(()=>{this.Y($,k)})}};e.$Plc=t,e.$Plc=t=Je([We(1,i.$KP),We(2,M.$oP)],t);class f{get persistent(){return this.b}set persistent($){this.b=$,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor($){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$ee,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const k=this.h($);let y=this.a.get(k);return y||(y=new a(this,$),this.a.set(k,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace($,k,y,C){this.f($,{value:k,type:p.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append($,k,y,C){this.f($,{value:k,type:p.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend($,k,y,C){this.f($,{value:k,type:p.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f($,k){if(k.options&&k.options.applyAtProcessCreation===!1&&!k.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g($,k.scope),C=this.map.get(y),P=k.options?{applyAtProcessCreation:k.options.applyAtProcessCreation??!1,applyAtShellIntegration:k.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==k.value||C.type!==k.type||C.options?.applyAtProcessCreation!==P.applyAtProcessCreation||C.options?.applyAtShellIntegration!==P.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==k.scope?.workspaceFolder?.index){const W=this.g($,k.scope),V={variable:$,...k,options:P};this.map.set(W,V),this.d.fire()}}get($,k){const y=this.g($,k),C=this.map.get(y);return C?l(C):void 0}g($,k){const y=this.h(k);return y.length?`${$}:::${y}`:$}h($){return this.j($?.workspaceFolder)??""}j($){return $?$.uri.toString():void 0}getVariableMap($){const k=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h($)&&k.set(C.variable,l(C));return k}delete($,k){const y=this.g($,k);this.map.delete(y),this.d.fire()}clear($){if($?.workspaceFolder){for(const[k,y]of this.map)y.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(k);this.k($)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription($,k){const y=this.h(k),C=this.descriptionMap.get(y);if(!C||C.description!==$){let P;typeof $=="string"?P=$:P=$?.value.split(`

`)[0];const W={description:P,scope:k};this.descriptionMap.set(y,W),this.d.fire()}}getDescription($){const k=this.h($);return this.descriptionMap.get(k)?.description}k($){const k=this.h($);this.descriptionMap.delete(k)}}class a{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,k){this.b=$,this.d=k,this.a=new I.$ee}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,k,y){this.b.replace($,k,y,this.d)}append($,k,y){this.b.append($,k,y,this.d)}prepend($,k,y){this.b.prepend($,k,y,this.d)}get($){return this.b.get($,this.d)}forEach($,k){this.b.getVariableMap(this.d).forEach((y,C)=>$.call(k,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let g=class extends t{constructor($,k){super(!1,$,k)}createTerminal($,k,y){throw new F.$_}createTerminalFromOptions($,k){throw new F.$_}};e.$Qlc=g,e.$Qlc=g=Je([We(0,i.$KP),We(1,M.$oP)],g);function u(w){if(!(!w||typeof w=="string"))return"id"in w?{id:w.id,color:w.color}:w}function S(w){return r.ThemeColor.isThemeColor(w)?w:void 0}function l(w){const $={...w};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(Ie[116],Ce([1,0,7,6,3,4,17,53,5,2,11]),function(le,e,I,N,R,O,M,b,p,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=e.$Umc=void 0,e.$Umc=(0,R.$vi)("IExtHostTerminalShellIntegration");let D=class extends N.$Vc{constructor(o,s){super(),this.h=s,this.b=new Map,this.c=new p.$ee,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$ee,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$ee,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(O.$1M.MainThreadTerminalShellIntegration),this.B((0,N.$Tc)(()=>{for(const[i,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(o){const s=this.h.getTerminalById(o);if(!s)return;const i=s.value;let n=this.b.get(o);n||(n=new d(s.value,this.f),this.b.set(o,n),n.store.add(s.onWillDispose(()=>this.b.get(o)?.dispose())),n.store.add(n.onDidRequestShellExecution(c=>this.a.$executeCommand(o,c))),n.store.add(n.onDidRequestEndExecution(c=>this.g.fire(c))),n.store.add(n.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),s.shellIntegration=n.value),this.c.fire({terminal:i,shellIntegration:n.value})}$shellExecutionStart(o,s,i,n,c){this.b.has(o)||this.$shellIntegrationChange(o);const h={value:s,confidence:i,isTrusted:n};this.b.get(o)?.startShellExecution(h,c)}$shellExecutionEnd(o,s,i,n,c){const h={value:s,confidence:i,isTrusted:n};this.b.get(o)?.endShellExecution(h,c)}$shellExecutionData(o,s){this.b.get(o)?.emitData(s)}$cwdChange(o,s){this.b.get(o)?.setCwd((0,E.$wc)(s)?E.URI.revive(s):s)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$Vmc=D,e.$Vmc=D=Je([We(0,M.$oP),We(1,b.$Nlc)],D);class d extends N.$Vc{get currentExecution(){return this.a}constructor(o,s){super(),this.j=o,this.m=s,this.b=!1,this.store=this.B(new N.$Uc),this.f=this.B(new p.$ee),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$ee),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$ee),this.onDidRequestEndExecution=this.h.event;const i=this;this.value={get cwd(){return i.c},executeCommand(n,c){let h=n;c&&(h+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),i.g.fire(h);const t={value:h,confidence:I.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},f=i.startShellExecution(t,i.c,!0).value;return i.b=!0,f}}}startShellExecution(o,s,i){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new v(o,s);i?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,s){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:s}),this.a=void 0)}setCwd(o){let s=!1;E.URI.isUri(this.c)?s=!E.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(s=!0),s&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class v{constructor(o,s){this.c=o,this.cwd=s,this.b=!1;const i=this;this.value={get commandLine(){return i.c},get cwd(){return i.cwd},read(){return i.d()}}}d(){if(!this.a){if(this.b)return F.$Vh.EMPTY;this.a=new m}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class m extends N.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new F.$uh);const o=this.a;return new F.$Vh(async i=>{this.b.push(i),await o.wait()})}emitData(o){for(const s of this.b)s.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ie[289],Ce([1,0,11,21,24,5,261,73,6,15,34,12,4,17,115,8,7,52,77,62]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o,s,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=e.$Ymc=e.$Xmc=e.$Wmc=void 0;let c=class extends p.$Vc{constructor(P,W,V,q){super(),this.w=q,this.f=this.B(new O.$ee),this.g=new Map,this.s=this.B(new O.$ee),this.onResultsChanged=this.f.event,this.results=[],this.h=P.getProxy(d.$1M.MainThreadTesting),this.m=new w(this.h),this.j=new a(this.h,W),V.registerArgumentProcessor({processArgument:A=>{switch(A?.$mid){case 16:{const U=A,K=U.tests[U.tests.length-1].item.extId;return this.g.get(s.$ML.root(K))?.collection.tree.get(K)?.actual??(0,m.$AP)(A)}case 18:{const{test:U,message:K}=A,re=U.item.extId;return{test:this.g.get(s.$ML.root(re))?.collection.tree.get(re)?.actual??(0,m.$AP)({$mid:16,tests:[U]}),message:r.TestMessage.to(K)}}default:return A}}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const A=await V.executeCommand("_testing.getExplorerSelection"),U=K=>{const re=this.g.get(s.$ML.root(K));if(re)return s.$ML.isRoot(K)?re.controller:re.collection.tree.get(K)?.actual};return{include:A?.include.map(U).filter(E.$dg)||[],exclude:A?.exclude.map(U).filter(E.$dg)||[]}})}createTestController(P,W,V,q){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const A=new p.$Uc,U=A.add(new m.$DP(W,V,this.w));U.root.label=V;const K=new Map,re=new Set,ae=this.h,ye={items:U.root.children,get label(){return V},set label(fe){V=fe,U.root.label=fe,ae.$updateController(W,{label:V})},get refreshHandler(){return q},set refreshHandler(fe){q=fe,ae.$updateController(W,{canRefresh:!!fe})},get id(){return W},createRunProfile:(fe,me,Ae,ce,Me,ie)=>{let z=(0,b.$jj)(fe);for(;K.has(z);)z++;return new k(this.h,K,re,this.s.event,W,z,fe,me,Ae,ce,Me,ie)},createTestItem(fe,me,Ae){return new m.$BP(W,fe,me,Ae)},createTestRun:(fe,me,Ae=!0)=>this.j.createTestRun(W,U,fe,me,Ae),invalidateTestResults:fe=>{if(fe===void 0)this.h.$markTestRetired(void 0);else{const me=fe instanceof Array?fe:[fe];this.h.$markTestRetired(me.map(Ae=>s.$ML.fromExtHostTestItem(Ae,W).toString()))}},set resolveHandler(fe){U.resolveHandler=fe},get resolveHandler(){return U.resolveHandler},dispose:()=>{A.dispose()}};ae.$registerTestController(W,V,!!q),A.add((0,p.$Tc)(()=>ae.$unregisterTestController(W)));const Pe={controller:ye,collection:U,profiles:K,extension:P,activeProfiles:re};return this.g.set(W,Pe),A.add((0,p.$Tc)(()=>this.g.delete(W))),A.add(U.onDidGenerateDiff(fe=>ae.$publishDiff(W,fe.map(n.TestsDiffOp.serialize)))),ye}createTestObserver(){return this.m.checkout()}async runTests(P,W=R.CancellationToken.None){const V=g(P);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(V.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:P.preserveFocus??!0,targets:[{testIds:P.include?.map(A=>s.$ML.fromExtHostTestItem(A,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:y[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:P.exclude?.map(A=>A.id)},W)}$syncTests(){for(const{collection:P}of this.g.values())P.flushDiff();return Promise.resolve()}async $getCoverageDetails(P,W){return(await this.j.getCoverageDetails(P,W))?.map(r.TestCoverage.fromDetails)}async $disposeRun(P){this.j.disposeTestRun(P)}$configureRunProfile(P,W){this.g.get(P)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(P){const W=new Map;for(const[V,q]of Object.entries(P)){const A=this.g.get(V);if(!A)continue;const U=new Map,K=q.filter(ae=>!A.activeProfiles.has(ae)),re=[...A.activeProfiles].filter(ae=>!q.includes(ae));for(const ae of K)U.set(ae,!0),A.activeProfiles.add(ae);for(const ae of re)U.set(ae,!1),A.activeProfiles.delete(ae);U.size&&W.set(V,U)}this.s.fire(W)}async $refreshTests(P,W){await this.g.get(P)?.controller.refreshHandler?.(W)}$publishTestResults(P){this.results=Object.freeze(P.map(r.TestResults.to).concat(this.results).sort((W,V)=>V.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(P,W){const V=this.g.get(s.$ML.fromString(P).controllerId)?.collection;V&&(await V.expand(P,W<0?1/0:W),V.flushDiff())}$acceptDiff(P){this.m.applyDiff(P.map(W=>n.TestsDiffOp.deserialize({asCanonicalUri:V=>V},W)))}async $runControllerTests(P,W){return Promise.all(P.map(V=>this.y(V,!1,W)))}async $startContinuousRun(P,W){const V=new R.$pe(W),q=await Promise.all(P.map(A=>this.y(A,!0,V.token)));return!W.isCancellationRequested&&!q.some(A=>A.error)&&await new Promise(A=>W.onCancellationRequested(A)),V.dispose(!0),q}async y(P,W,V){const q=this.g.get(P.controllerId);if(!q)return{};const{collection:A,profiles:U}=q,K=U.get(P.profileId);if(!K)return{};const re=P.testIds.map(fe=>A.tree.get(fe)).filter(E.$dg),ae=P.excludeExtIds.map(fe=>q.collection.tree.get(fe)).filter(E.$dg).filter(fe=>re.some(me=>me.fullId.compare(fe.fullId)===2));if(!re.length)return{};const ye=new o.$DO(re.some(fe=>fe.actual instanceof m.$CP)?void 0:re.map(fe=>fe.actual),ae.map(fe=>fe.actual),K,W),Pe=(0,n.$PL)(P)&&this.j.prepareForMainThreadTestRun(ye,u.fromInternal(P,q.collection),K,V);try{return await K.runHandler(ye,V),{}}catch(fe){return{error:String(fe)}}finally{Pe&&Pe.hasRunningTasks&&!V.isCancellationRequested&&await O.Event.toPromise(Pe.onEnd)}}$cancelExtensionTestRun(P){P===void 0?this.j.cancelAllRuns():this.j.cancelRunById(P)}};e.$Wmc=c,e.$Wmc=c=Je([We(0,v.$oP),We(1,D.$2j)],c);const h=1e4;var t;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(t||(t={}));class f extends p.$Vc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(P,W,V,q,A){super(),this.y=P,this.z=W,this.C=V,this.D=q,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$ee),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new R.$pe(A));const U=this.B(new I.$Hh(()=>this.F(),h));this.B(this.j.token.onCancellationRequested(()=>U.schedule()));const K=new O.$ee;this.s=K.event,this.B((0,p.$Tc)(()=>{K.fire(),K.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(P,W){const[,V,q]=s.$ML.fromString(P).path,A=this.w.get(q);if(!A)return[];const U=this.g.get(V);if(!U)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(U.run,A,W)??[]}createRun(P){const W=this.y.id,V=this.y.controllerId,q=(0,F.$Rg)(),A=ae=>(ye,...Pe)=>{if(K){this.C.warn(`Setting the state of test "${ye.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ye)&&(this.H(ye),ae(ye,...Pe))},U=(ae,ye)=>{const Pe=ye instanceof Array?ye.map(r.TestMessage.from):[r.TestMessage.from(ye)];if(ae.uri&&ae.range){const fe={range:r.Range.from(ae.range),uri:ae.uri};for(const me of Pe)me.location=me.location||fe}this.z.$appendTestMessagesInRun(W,q,s.$ML.fromExtHostTestItem(ae,V).toString(),Pe)};let K=!1;const re={isPersisted:this.y.isPersisted,token:this.j.token,name:P,onDidDispose:this.s,addCoverage:ae=>{const ye=ae.uri.toString(),Pe=new s.$ML([W,q,ye]).toString();this.w.set(ye,ae),this.z.$appendCoverage(W,q,r.TestCoverage.fromFile(Pe,ae))},enqueued:A(ae=>{this.z.$updateTestStateInRun(W,q,s.$ML.fromExtHostTestItem(ae,V).toString(),1)}),skipped:A(ae=>{this.z.$updateTestStateInRun(W,q,s.$ML.fromExtHostTestItem(ae,V).toString(),5)}),started:A(ae=>{this.z.$updateTestStateInRun(W,q,s.$ML.fromExtHostTestItem(ae,V).toString(),2)}),errored:A((ae,ye,Pe)=>{U(ae,ye),this.z.$updateTestStateInRun(W,q,s.$ML.fromExtHostTestItem(ae,V).toString(),6,Pe)}),failed:A((ae,ye,Pe)=>{U(ae,ye),this.z.$updateTestStateInRun(W,q,s.$ML.fromExtHostTestItem(ae,V).toString(),4,Pe)}),passed:A((ae,ye)=>{this.z.$updateTestStateInRun(W,q,s.$ML.fromExtHostTestItem(ae,this.y.controllerId).toString(),3,ye)}),appendOutput:(ae,ye,Pe)=>{K||(Pe&&(this.y.isIncluded(Pe)?this.H(Pe):Pe=void 0),this.z.$appendOutputToRun(W,q,N.$Fe.fromString(ae),ye&&r.location.from(ye),Pe&&s.$ML.fromExtHostTestItem(Pe,V).toString()))},end:()=>{K||(K=!0,this.z.$finishedTestRunTask(W,q),--this.f||this.G())}};return this.f++,this.g.set(q,{run:re}),this.z.$startedTestRunTask(W,{id:q,name:P,running:!0}),re}F(){for(const{run:P}of this.g.values())P.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(P){if(!(P instanceof m.$BP))throw new i.$gP(P.id);if(this.h.has(s.$ML.fromExtHostTestItem(P,this.y.controllerId).toString()))return;const W=[],V=this.y.colllection.root;for(;;){const q=r.TestItem.from(P);if(W.unshift(q),this.h.has(q.extId)||(this.h.add(q.extId),P===V))break;P=P.parent||V}this.z.$addTestsToRun(this.y.controllerId,this.y.id,W)}dispose(){this.G(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(P,W){this.g=P,this.h=W,this.c=new Map,this.f=new Map}getCoverageDetails(P,W){const V=s.$ML.root(P);return this.f.get(V)?.getCoverageDetails(P,W)||[]}disposeTestRun(P){this.f.get(P)?.dispose(),this.f.delete(P);for(const[W,{id:V}]of this.c)V===P&&this.c.delete(W)}prepareForMainThreadTestRun(P,W,V,q){return this.j(P,W,V,q)}cancelRunById(P){this.f.get(P)?.cancel()}cancelAllRuns(){for(const P of this.c.values())P.cancel()}createTestRun(P,W,V,q,A){const U=this.c.get(V);if(U)return U.createRun(q);const K=u.fromPublic(P,W,V,A),re=g(V);this.g.$startedExtensionTestRun({controllerId:P,continuous:!!V.continuous,profile:re&&{group:y[re.kind],id:re.profileId},exclude:V.exclude?.map(ye=>s.$ML.fromExtHostTestItem(ye,W.root.id).toString())??[],id:K.id,include:V.include?.map(ye=>s.$ML.fromExtHostTestItem(ye,W.root.id).toString())??[W.root.id],preserveFocus:V.preserveFocus??!0,persist:A});const ae=this.j(V,K,V.profile);return O.Event.once(ae.onEnd)(()=>{this.g.$finishedExtensionTestRun(K.id)}),ae.createRun(q)}j(P,W,V,q){const A=new f(W,this.g,this.h,V,q);return this.c.set(P,A),this.f.set(A.id,A),A}}e.$Xmc=a;const g=C=>{if(C.profile){if(!(C.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class u{static fromPublic(P,W,V,q){return new u(P,(0,F.$Rg)(),V.include?.map(A=>s.$ML.fromExtHostTestItem(A,P).toString())??[P],V.exclude?.map(A=>s.$ML.fromExtHostTestItem(A,P).toString())??[],q,W)}static fromInternal(P,W){return new u(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,W)}constructor(P,W,V,q,A,U){this.controllerId=P,this.id=W,this.isPersisted=A,this.colllection=U,this.c=V.map(K=>K+"\0"),this.f=q.map(K=>K+"\0")}isIncluded(P){const W=s.$ML.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const V of this.f)if(W===V||W.startsWith(V))return!1;for(const V of this.c)if(W===V||W.startsWith(V))return!0;return!1}}e.$Ymc=u;class S{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(P){this.j=P,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(P){this.c.add(P)}update(P){Object.assign(P.revived,r.TestItem.toPlain(P.item)),this.c.has(P)||this.f.add(P)}remove(P){if(this.c.has(P)){this.c.delete(P);return}this.f.delete(P);const W=s.$ML.parentId(P.item.extId);if(W&&this.h.has(W.toString())){this.h.add(P.item.extId);return}this.g.add(P)}getChangeEvent(){const{c:P,f:W,g:V}=this;return{get added(){return[...P].map(q=>q.revived)},get updated(){return[...W].map(q=>q.revived)},get removed(){return[...V].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class l extends n.$VL{constructor(){super(...arguments),this.s=new O.$ee,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(P){return this.f.get(P)}getMirroredTestDataByReference(P){return this.f.get(P.id)}w(P,W){return{...P,revived:r.TestItem.toPlain(P.item),depth:W?W.depth+1:0,children:new Set}}v(){return new S(this.s)}}class w{constructor(P){this.f=P}checkout(){this.c||(this.c=this.g());const P=this.c;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(W=>W.revived)},dispose:(0,M.$db)(()=>{--P.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(P){return this.c?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.c?.tests.apply(P)}g(){const P=new l({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:P}}}const $=(C,P,W,V)=>{W?Object.assign(W,V):P.$updateTestRunConfig(C.controllerId,C.profileId,V)};class k{#e;#t;#i;#n;#s;get label(){return this.f}set label(P){P!==this.f&&(this.f=P,$(this,this.#e,this.#n,{label:P}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(P){P!==this.g&&(this.g=P,$(this,this.#e,this.#n,{supportsContinuousRun:P}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(P){P!==this.isDefault&&(P?this.#t.add(this.profileId):this.#t.delete(this.profileId),$(this,this.#e,this.#n,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,$(this,this.#e,this.#n,{tag:P?r.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.c}set configureHandler(P){P!==this.c&&(this.c=P,$(this,this.#e,this.#n,{hasConfigurationHandler:!!P}))}get onDidChangeDefault(){return O.Event.chain(this.#i,P=>P.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(E.$dg))}constructor(P,W,V,q,A,U,K,re,ae,ye=!1,Pe=void 0,fe=!1){this.controllerId=A,this.profileId=U,this.f=K,this.kind=re,this.runHandler=ae,this._tag=Pe,this.g=fe,this.#e=P,this.#s=W,this.#t=V,this.#i=q,W.set(U,this);const me=y[re];if(typeof me!="number")throw new Error(`Unknown TestRunProfile.group ${re}`);ye&&V.add(U),this.#n={profileId:U,controllerId:A,tag:Pe?r.TestTag.namespace(this.controllerId,Pe.id):null,label:K,group:me,isDefault:ye,hasConfigurationHandler:!1,supportsContinuousRun:fe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Zmc=k;const y={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Ie[117],Ce([1,0,57,14,91,8,7]),function(le,e,I,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xP=e.$wP=e.$vP=void 0;class b{static{this.c=new R.$tP("TextEditorDecorationType")}constructor(d,v,m){const r=b.c.nextId();d.$registerTextEditorDecorationType(v.identifier,r,O.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:r,dispose(){d.$removeTextEditorDecorationType(r)}})}}e.$vP=b;class p{constructor(d,v){this.g=[],this.h=void 0,this.j=!1,this.c=d,this.d=d.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(d,v){this.k();let m=null;if(d instanceof M.$4M)m=new M.$5M(d,d);else if(d instanceof M.$5M)m=d;else throw new Error("Unrecognized location");this.l(m,v,!1)}insert(d,v){this.k(),this.l(new M.$5M(d,d),v,!0)}delete(d){this.k();let v=null;if(d instanceof M.$5M)v=d;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(d,v,m){const r=this.c.validateRange(d);this.g.push({range:r,text:v,forceMoveMarkers:m})}setEndOfLine(d){if(this.k(),d!==M.EndOfLine.LF&&d!==M.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=d}}class E{constructor(d,v,m,r){this.c=d,this.d=v,this._accept(m),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(s){o.n(s)},get indentSize(){return o.g},set indentSize(s){o.p(s)},get insertSpaces(){return o.j},set insertSpaces(s){o.s(s)},get cursorStyle(){return o.k},set cursorStyle(s){o.t(s)},get lineNumbers(){return o.l},set lineNumbers(s){o.u(s)}}}_accept(d){this.f=d.tabSize,this.g=d.indentSize,this.h=d.originalIndentSize,this.j=d.insertSpaces,this.k=d.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(d.lineNumbers)}m(d){if(d==="auto")return"auto";if(typeof d=="number"){const v=Math.floor(d);return v>0?v:null}if(typeof d=="string"){const v=parseInt(d,10);return isNaN(v)?null:v>0?v:null}return null}n(d){const v=this.m(d);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}o(d){if(d==="tabSize")return"tabSize";if(typeof d=="number"){const v=Math.floor(d);return v>0?v:null}if(typeof d=="string"){const v=parseInt(d,10);return isNaN(v)?null:v>0?v:null}return null}p(d){const v=this.o(d);if(v!==null){if(typeof v=="number"){if(this.h===v)return;this.g=v,this.h=v}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}q(d){return d==="auto"?"auto":d==="false"?!1:!!d}s(d){const v=this.q(d);if(typeof v=="boolean"){if(this.j===v)return;this.j=v}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}t(d){this.k!==d&&(this.k=d,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:d})))}u(d){this.l!==d&&(this.l=d,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(d)})))}assign(d){const v={};let m=!1;if(typeof d.tabSize<"u"){const r=this.m(d.tabSize);r==="auto"?(m=!0,v.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,m=!0,v.tabSize=r)}if(typeof d.indentSize<"u"){const r=this.o(d.indentSize);r==="tabSize"?(m=!0,v.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,m=!0,v.indentSize=r)}if(typeof d.insertSpaces<"u"){const r=this.q(d.insertSpaces);r==="auto"?(m=!0,v.insertSpaces=r):this.j!==r&&(this.j=r,m=!0,v.insertSpaces=r)}typeof d.cursorStyle<"u"&&this.k!==d.cursorStyle&&(this.k=d.cursorStyle,m=!0,v.cursorStyle=d.cursorStyle),typeof d.lineNumbers<"u"&&this.l!==d.lineNumbers&&(this.l=d.lineNumbers,m=!0,v.lineNumbers=O.TextEditorLineNumbersStyle.from(d.lineNumbers)),m&&this.v("setOptions",this.c.$trySetOptions(this.d,v))}v(d,v){v.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${d}' failed:'`),this.e.warn(m)})}}e.$wP=E;class F{constructor(d,v,m,r,o,s,i,n){this.id=d,this.j=v,this.k=m,this.g=!1,this.h=new Set,this.c=o,this.d=new E(this.j,this.id,s,m),this.e=i,this.f=n;const c=this;this.value=Object.freeze({get document(){return r.value},set document(h){throw new N.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof M.$6M))throw(0,N.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof M.$6M)))throw(0,N.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new N.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new N.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new p(r.value,t);return h(f),c.m(f)},insertSnippet(h,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=c.c.map(g=>O.Range.from(g));else if(t instanceof M.$4M){const{lineNumber:g,column:u}=O.Position.from(t);a=[{startLineNumber:g,startColumn:u,endLineNumber:g,endColumn:u}]}else if(t instanceof M.$5M)a=[O.Range.from(t)];else{a=[];for(const g of t)if(g instanceof M.$5M)a.push(O.Range.from(g));else{const{lineNumber:u,column:S}=O.Position.from(g);a.push({startLineNumber:u,startColumn:S,endLineNumber:u,endColumn:S})}}return v.$tryInsertSnippet(d,r.value.version,h.value,a,f)},setDecorations(h,t){const f=t.length===0;f&&!c.h.has(h.key)||(f?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(O.$lP(t))return v.$trySetDecorations(d,h.key,O.$mP(t));{const a=new Array(4*t.length);for(let g=0,u=t.length;g<u;g++){const S=t[g];a[4*g]=S.start.line+1,a[4*g+1]=S.start.character+1,a[4*g+2]=S.end.line+1,a[4*g+3]=S.end.character+1}return v.$trySetDecorationsFast(d,h.key,a)}}))},revealRange(h,t){c.n(()=>v.$tryRevealRange(d,O.Range.from(h),t||M.TextEditorRevealType.Default))},show(h){v.$tryShowEditor(d,O.ViewColumn.from(h))},hide(){v.$tryHideEditor(d)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(d){(0,I.ok)(!this.g),this.d._accept(d)}_acceptVisibleRanges(d){(0,I.ok)(!this.g),this.e=d}_acceptViewColumn(d){(0,I.ok)(!this.g),this.f=d}_acceptSelections(d){(0,I.ok)(!this.g),this.c=d}async l(){const d=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,d)),this.value}m(d){const v=d.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const m=v.edits.map(o=>o.range);m.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=m.length-1;o<s;o++){const i=m[o].end;if(m[o+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=v.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,r,{setEndOfLine:typeof v.setEndOfLine=="number"?O.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(d){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$xP=F}),define(Ie[68],Ce([1,0,57,5,6,2,3,4,113,17,117,8,12,28,16,41,42]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zP=e.$yP=void 0;class s{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new v.$Bc,this.d=new N.$ee,this.e=new N.$ee,this.f=new N.$ee,this.g=new N.$ee,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],t=[],f=[];if(c.removedDocuments)for(const a of c.removedDocuments){const g=O.URI.revive(a),u=this.c.get(g);u?.unref()&&(this.c.delete(g),h.push(u.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const g=O.URI.revive(a.uri);let u=this.c.get(g);if(u&&g.scheme!==m.Schemas.vscodeNotebookCell&&g.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${g} already exists!'`);u||(u=new s(new p.$rP(this.h.getProxy(b.$1M.MainThreadDocuments),g,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set(g,u),t.push(u.value)),u.ref()}if(c.removedEditors)for(const a of c.removedEditors){const g=this.b.get(a);this.b.delete(a),g&&f.push(g)}if(c.addedEditors)for(const a of c.addedEditors){const g=O.URI.revive(a.documentUri);I.ok(this.c.has(g),`document '${g}' does not exist`),I.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const u=this.c.get(g).value,S=new F.$xP(a.id,this.h.getProxy(b.$1M.MainThreadTextEditors),this.i,new o.$V(()=>u.document),a.selections.map(D.Selection.to),a.options,a.visibleRanges.map(l=>D.Range.to(l)),typeof a.editorPosition=="number"?D.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,S)}c.newActiveEditor!==void 0&&(I.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,R.$Qc)(h),(0,R.$Qc)(f),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return r.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$yP=i,e.$yP=i=Je([We(0,E.$oP),We(1,d.$2j)],i),e.$zP=(0,M.$vi)("IExtHostDocumentsAndEditors")}),define(Ie[290],Ce([1,0,18,5,4,117,8,7]),function(le,e,I,N,R,O,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=void 0;class p{constructor(F,D){this.i=D,this.a=new N.$ee,this.b=new N.$ee,this.c=new N.$ee,this.d=new N.$ee,this.f=new N.$ee,this.g=new N.$ee,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=F.getProxy(R.$1M.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(d=>this.g.fire(d)),this.i.onDidChangeActiveTextEditor(d=>this.f.fire(d))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(F){const D=this.i.allEditors();return F?D:D.map(d=>d.value)}async showTextDocument(F,D,d){let v;typeof D=="number"?v={position:M.ViewColumn.from(D),preserveFocus:d}:typeof D=="object"?v={position:M.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?M.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:v={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(F.uri,v),r=m&&this.i.getEditor(m);if(r)return r.value;throw m?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,D){return new O.$vP(this.h,F,D).value}$acceptEditorPropertiesChanged(F,D){const d=this.i.getEditor(F);if(!d)throw new Error("unknown text editor");if(D.options&&d._acceptOptions(D.options),D.selections){const v=D.selections.selections.map(M.Selection.to);d._acceptSelections(v)}if(D.visibleRanges){const v=I.$Hb(D.visibleRanges.map(M.Range.to));d._acceptVisibleRanges(v)}if(D.options&&this.b.fire({textEditor:d.value,options:{...D.options,lineNumbers:M.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const v=b.TextEditorSelectionChangeKind.fromValue(D.selections.source),m=D.selections.selections.map(M.Selection.to);this.a.fire({textEditor:d.value,selections:m,kind:v})}if(D.visibleRanges){const v=I.$Hb(D.visibleRanges.map(M.Range.to));this.c.fire({textEditor:d.value,visibleRanges:v})}}$acceptEditorPositionData(F){for(const D in F){const d=this.i.getEditor(D);if(!d)throw new Error("Unknown text editor");const v=M.ViewColumn.to(F[D]);d.value.viewColumn!==v&&(d._acceptViewColumn(v),this.d.fire({textEditor:d.value,viewColumn:v}))}}getDiffInformation(F){return Promise.resolve(this.h.$getDiffInformation(F))}}e.$glc=p}),define(Ie[291],Ce([1,0,2,3,4,6,7,8,20,15]),function(le,e,I,N,R,O,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=e.$2mc=void 0,e.$2mc=(0,N.$vi)("IExtHostTimeline");class F{constructor(v,m){this.b=new Map,this.c=new Map,this.a=v.getProxy(R.$1M.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(r,o)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&p.$Qm.equals(o,this.b.get(r.source)?.extension)){const s=r.uri===void 0?void 0:I.URI.revive(r.uri);return this.c.get(r.source)?.get(D(s))?.get(r.handle)}else return;return r}})}async $getTimeline(v,m,r,o){return this.b.get(v)?.provider.provideTimeline(I.URI.revive(m),r,o)}registerTimelineProvider(v,m,r,o){const s=new O.$Uc,i=this.d(m.id,o,s).bind(this);let n;m.onDidChange&&(n=m.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:m.id}),this));const c=this.c;return this.f({...m,scheme:v,onDidChange:void 0,async provideTimeline(h,t,f){t?.resetCache&&(s.clear(),c.get(m.id)?.clear());const a=await m.provideTimeline(h,t,f);if(a==null)return;const g=i(h,t);return{...a,source:m.id,items:a.items.map(g)}},dispose(){for(const h of c.values())h.get(m.id)?.clear();n?.dispose(),s.dispose()}},r)}d(v,m,r){return(o,s)=>{let i;if(s?.cacheResults){let n=this.c.get(v);n===void 0&&(n=new Map,this.c.set(v,n));const c=D(o);i=n.get(c),i===void 0&&(i=new Map,n.set(c,i))}return n=>{const{iconPath:c,...h}=n,t=`${v}|${n.id??n.timestamp}`;i?.set(t,n);let f,a,g;n.iconPath&&(c instanceof M.$ZN?g={id:c.id,color:c.color}:I.URI.isUri(c)?(f=c,a=c):{light:f,dark:a}=c);let u;return M.$sN.isMarkdownString(h.tooltip)?u=b.MarkdownString.from(h.tooltip):(0,E.$8f)(h.tooltip)?u=h.tooltip:M.$sN.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=b.MarkdownString.from(h.detail)):(0,E.$8f)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=h.detail),{...h,id:h.id??void 0,handle:t,source:v,command:n.command?m.toInternal(n.command,r):void 0,icon:f,iconDark:a,themeIcon:g,tooltip:u,accessibilityInformation:n.accessibilityInformation}}}}f(v,m){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:m}),(0,O.$Tc)(()=>{for(const o of this.c.values())o.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$3mc=F;function D(d){return d?.toString()}}),define(Ie[292],Ce([1,0,181,23,2,5,6,222,11,7,15,18,8,55,24,143,26]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=void 0;function s(c,h){if((0,F.$8f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class i extends M.$Vc{constructor(h,t,f){super(),this.f=h,this.g=t,this.h=f,this.a=new Map,this.b=new r.$n$;function a(g){return g&&g.$treeViewId&&(g.$treeItemHandle||g.$selectedTreeItems||g.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:g=>a(g)?this.r(g):Array.isArray(g)&&g.length>0?g.map(u=>a(u)?this.r(u):u):g})}registerTreeDataProvider(h,t,f){const a=this.createTreeView(h,{treeDataProvider:t},f);return{dispose:()=>a.dispose()}}createTreeView(h,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],g=t.dragAndDropController?.dragMimeTypes??[],u=!!t.dragAndDropController?.handleDrag,S=!!t.dragAndDropController?.handleDrop,l=this.m(h,t,f),w={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:g,hasHandleDrag:u,hasHandleDrop:S,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},$=this.f.$registerTreeViewDataProvider(h,w),k={get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get activeItem(){return(0,o.$GG)(f,"treeViewActiveItem"),l.focusedElement},get onDidChangeActiveItem(){return(0,o.$GG)(f,"treeViewActiveItem"),l.onDidChangeActiveItem},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get onDidChangeCheckboxState(){return l.onDidChangeCheckboxState},get message(){return l.message},set message(y){(0,v.$Uk)(y)&&(0,o.$GG)(f,"treeViewMarkdownMessage"),l.message=y},get title(){return l.title},set title(y){l.title=y},get description(){return l.description},set description(y){l.description=y},get badge(){return l.badge},set badge(y){y!==void 0&&E.ViewBadge.isViewBadge(y)?l.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(l.badge=void 0)},reveal:(y,C)=>l.reveal(y,C),dispose:async()=>{await $,this.a.delete(h),l.dispose()}};return this.B(k),k}$getChildren(h,t){const f=this.a.get(h);return f?f.getChildren(t):Promise.reject(new b.$VF(h))}async $handleDrop(h,t,f,a,g,u,S,l){const w=this.a.get(h);if(!w)return Promise.reject(new b.$VF(h));const $=d.DataTransfer.toDataTransfer(f,async k=>(await this.f.$resolveDropFileData(h,t,k)).buffer);return S===h&&l&&await this.j($,w,l,g,u),w.onDrop($,a,g)}async j(h,t,f,a,g){const u=this.b.removeDragOperationTransfer(g);if(u)(await u)?.forEach((S,l)=>{S&&h.set(l,S)});else if(g&&t.handleDrag){const S=t.handleDrag(f,h,a);this.b.addDragOperationTransfer(g,S),await S}return h}async $handleDrag(h,t,f,a){const g=this.a.get(h);if(!g)return Promise.reject(new b.$VF(h));const u=await this.j(new E.$VN,g,t,a,f);if(!(!u||a.isCancellationRequested))return d.DataTransfer.from(u)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new b.$VF(h);return t.hasResolve}$resolve(h,t,f){const a=this.a.get(h);if(!a)throw new b.$VF(h);return a.resolveTreeItem(t,f)}$setExpanded(h,t,f){const a=this.a.get(h);if(!a)throw new b.$VF(h);a.setExpanded(t,f)}$setSelectionAndFocus(h,t,f){const a=this.a.get(h);if(!a)throw new b.$VF(h);a.setSelectionAndFocus(t,f)}$setVisible(h,t){const f=this.a.get(h);if(!f){if(!t)return;throw new b.$VF(h)}f.setVisible(t)}$changeCheckboxState(h,t){const f=this.a.get(h);if(!f)throw new b.$VF(h);f.setCheckboxState(t)}m(h,t,f){const a=this.B(new n(h,t,this.f,this.g.converter,this.h,f));return this.a.set(h,a),a}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$4mc=i;class n extends M.$Vc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,F.$eg)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,f,a,g,u){if(super(),this.I=h,this.J=f,this.L=a,this.M=g,this.N=u,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$ee),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$ee),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$ee),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$ee),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$ee),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$ee),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$ee),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new m.$pe,u.contributes&&u.contributes.views)for(const $ in u.contributes.views)for(const k of u.contributes.views[$])k.id===h&&(this.P=k.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData($=>this.F.fire({message:!1,element:$})));let S,l;const w=O.Event.debounce(this.F.event,($,k)=>($||($={message:!1,elements:[]}),k.element!==!1&&(S||(S=new Promise(y=>l=y),this.G=this.G.then(()=>S)),Array.isArray(k.element)?$.elements.push(...k.element):$.elements.push(k.element)),k.message&&($.message=!0),$),200,!0);this.B(w(({message:$,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const y=l;return S=null,this.$(k).then(()=>y())})),$&&this.J.$setMessage(this.I,d.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let f=this.X(h);return f||(f=await this.Y(t)),f?f.map(a=>a.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const f=(0,F.$eg)(t.select)?!0:t.select,a=(0,F.$eg)(t.focus)?!1:t.focus,g=(0,F.$eg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(u=>this.W(h,u[u.length-1]).then(S=>this.J.$reveal(this.I,{item:S.item,parentChain:u.map(l=>l.item)},{select:f,focus:a,expand:g})),u=>this.M.error(u)):this.J.$reveal(this.I,void 0,{select:f,focus:a,expand:g})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=d.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const f=this.getExtensionElement(h);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(h,t){const f=!(0,D.$ub)(this.s,h);this.s=h;const a=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async f=>{const a=this.getExtensionElement(f.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:f.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(h,t,f){const a=[];for(const g of h){const u=this.getExtensionElement(g);u&&a.push(u)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,f){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,p.$nh)(()=>this.g?.handleDrop?this.g.handleDrop(a,h,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(h);if(f){const a=this.m.get(f);if(a){const g=await this.f.resolveTreeItem(a.extensionItem,f,t)??a.extensionItem;return this.hb(g),a.item.tooltip=this.eb(g.tooltip),a.item.command=this.fb(a.disposableStore,g.command),a.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(a=>(f.push(a),f))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,p.$nh)(()=>this.f.getParent(h))}W(h,t){const f=this.m.get(h);return f?Promise.resolve(f):(0,p.$nh)(()=>this.f.getTreeItem(h)).then(a=>this.kb(h,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const g=this.getExtensionElement(a);if(g){const u=this.m.get(g);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const f=this.getExtensionElement(h);t=f?this.m.get(f):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new m.$pe(this.Z.token);try{const f=h?this.m.get(h):void 0,a=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const g=(0,D.$Hb)(a||[]),u=await Promise.all((0,D.$Hb)(g).map(l=>this.f.getTreeItem(l)));if(t.token.isCancellationRequested)return;const S=u.map((l,w)=>l?this.db(g[w],l,f):null);return(0,D.$Hb)(S)}finally{t.dispose()}}$(h){if(h.some(f=>!f))return this.Z.dispose(!0),this.Z=new m.$pe,this.tb(),this.J.$refresh(this.I);{const f=this.ab(h);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(h){const t=new Set,f=h.map(g=>this.m.get(g));for(const g of f)if(g&&!t.has(g.item.handle)){let u=g;for(;u&&u.parent&&f.findIndex(S=>u&&u.parent&&S&&S.item.handle===u.parent.item.handle)===-1;){const S=this.j.get(u.parent.item.handle);u=S?this.m.get(S):void 0}u&&!u.parent&&t.add(g.item.handle)}const a=[];return t.forEach(g=>{const u=this.j.get(g);if(u){const S=this.m.get(u);S&&(!S.parent||!t.has(S.parent.item.handle))&&a.push(g)}}),a}bb(h){const t={};return Promise.all(h.map(f=>this.cb(f).then(a=>{a&&(t[f]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,p.$nh)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const g=this.ib(t,a,f.parent);return this.pb(t,g,f,f.parent),f.dispose(),g}return null})}return Promise.resolve(null)}db(h,t,f){const a=this.ib(h,t,f);if(t.id&&this.j.has(a.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(h,a),this.qb(a,f),a}eb(h){return E.$sN.isMarkdownString(h)?d.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,f,a;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,f=h.checkboxState.tooltip,a=h.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:a}}hb(h){if(!E.$QN.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,f){this.hb(t);const a=this.B(new M.$Uc),g=this.kb(h,t,f),u=this.lb(t);return{item:{handle:g,parentHandle:f?f.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:u,iconDark:this.mb(t)||u,themeIcon:this.jb(t),collapsibleState:(0,F.$eg)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(h){return h.iconPath instanceof E.$ZN?h.iconPath:void 0}kb(h,{id:t,label:f,resourceUri:a},g,u){if(t)return`${n.b}/${t}`;const S=s(f,this.N),l=g?g.item.handle:n.a;let w=S?S.label:a?(0,N.$6g)(a):"";w=w.indexOf("/")!==-1?w.replace("/","//"):w;const $=this.m.has(h)?this.m.get(h).item.handle:void 0,k=this.X(g)||[];let y,C=0;do{if(y=`${l}/${C}:${w}`,u||!this.j.has(y)||$===y)break;C++}while(C<=k.length);return y}lb(h){if(h.iconPath&&!(h.iconPath instanceof E.$ZN))return typeof h.iconPath=="string"||R.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof E.$ZN)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return R.URI.isUri(h)?h:R.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,f,a){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(h,t);const g=this.X(a)||[],u=g.filter(S=>S.item.handle===f.item.handle)[0];u&&g.splice(g.indexOf(u),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const f of t.children){const a=this.j.get(f.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const f of t.children){const a=this.j.get(f.item.handle);a&&this.sb(a)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ie[293],Ce([1,0,5,6,2,34,8,64,4,7]),function(le,e,I,N,R,O,M,b,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=void 0;class F extends N.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(m,r,o,s){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$ee),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$ee),this.onDidChangeViewState=this.#h.event,this.#e=m,this.#t=r,this.#n=o,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(m){this.c(),this.#r!==m&&(this.#r=m,this.#t.$setTitle(this.#e,m))}get iconPath(){return this.c(),this.#a}set iconPath(m){this.c(),this.#a!==m&&(this.#a=m,this.#t.$setIconPath(this.#e,R.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(m){this.#l||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(this.#u=m.active,this.#c=m.visible,this.#o=m.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(m,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof m>"u"?void 0:M.ViewColumn.from(m),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class D extends N.$Vc{static c(){return(0,O.$Rg)()}constructor(m,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=m.getProxy(p.$1M.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(m=>m.dispose()),this.g.clear()}createWebviewPanel(m,r,o,s,i={}){const n=typeof s=="object"?s.viewColumn:s,c={viewColumn:M.ViewColumn.from(n),preserveFocus:typeof s=="object"&&!!s.preserveFocus},h=(0,b.$vlc)(m),t=D.c();this.f.$createWebviewPanel((0,b.$xlc)(m),t,r,{title:o,panelOptions:d(i),webviewOptions:(0,b.$ylc)(m,this.m,i),serializeBuffersForPostMessage:h},c);const f=this.j.createNewWebview(t,i,m);return this.createNewWebviewPanel(t,r,o,n,i,f,!0)}$onDidChangeWebviewPanelViewStates(m){const r=Object.keys(m);r.sort((o,s)=>{const i=m[o],n=m[s];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const o of r){const s=this.getWebviewPanel(o);if(!s)continue;const i=m[o];s._updateViewState({active:i.active,visible:i.visible,viewColumn:M.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.g.delete(m),this.j.deleteWebview(m)}registerWebviewPanelSerializer(m,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:m}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,b.$vlc)(m)}),new E.$3M(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(m,r,o,s){const i=this.h.get(r);if(!i)throw new Error(`No serializer found for '${r}'`);const{serializer:n,extension:c}=i,h=this.j.createNewWebview(m,o.webviewOptions,c),t=this.createNewWebviewPanel(m,r,o.title,s,o.panelOptions,h,o.active);await n.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(m,r,o,s,i,n,c){const h=new F(m,this.f,n,{viewType:r,title:o,viewColumn:s,panelOptions:i,active:c});return this.g.set(m,h),h}getWebviewPanel(m){return this.g.get(m)}}e.$zlc=D;function d(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Ie[294],Ce([1,0,5,6,64,8,4,7]),function(le,e,I,N,R,O,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=void 0;class p extends N.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(D,d,v,m,r,o){super(),this.#s=!1,this.#u=this.B(new I.$ee),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$ee),this.onDidDispose=this.#l.event,this.#i=v,this.#a=m,this.#e=D,this.#t=d,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#o}set description(D){this.a(),this.#o!==D&&(this.#o=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(D){D===this.#r||this.#s||(this.#r=D,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(D,d){this.d=d,this.b=new Map,this.c=new Map,this.a=D.getProxy(M.$1M.MainThreadWebviewViews)}registerWebviewViewProvider(D,d,v,m){if(this.b.has(d))throw new Error(`View provider for '${d}' already registered`);return this.b.set(d,{provider:v,extension:D}),this.a.$registerWebviewViewProvider((0,R.$xlc)(D),d,{retainContextWhenHidden:m?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,R.$vlc)(D)}),new b.$3M(()=>{this.b.delete(d),this.a.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(D,d,v,m,r){const o=this.b.get(d);if(!o)throw new Error(`No view provider found for '${d}'`);const{provider:s,extension:i}=o,n=this.d.createNewWebview(D,{},i),c=new p(D,this.a,d,v,n,!0);this.c.set(D,c),await s.resolveWebviewView(c,{state:m},r)}async $onDidChangeWebviewViewVisibility(D,d){this.e(D)._setVisible(d)}async $disposeWebviewView(D){const d=this.e(D);this.c.delete(D),d.dispose(),this.d.deleteWebview(D)}e(D){const d=this.c.get(D);if(!d)throw new Error("No webview found");return d}}e.$7mc=E}),define(Ie[295],Ce([1,0,5,29,31,3]),function(le,e,I,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=e.$jM=e.OutputChannelUpdateMode=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=void 0,e.$9L="text/x-code-output",e.$0L="output",e.$$L="Log",e.$_L="text/x-code-log-output",e.$aM="log",e.$bM="workbench.panel.output",e.$cM=new R.$Mj("inOutput",!1),e.$dM=new R.$Mj("activeLogOutput",!1),e.$eM=new R.$Mj("activeLogOutput.levelSettable",!1),e.$fM=new R.$Mj("activeLogOutput.level",""),e.$gM=new R.$Mj("activeLogOutput.levelIsDefault",!1),e.$hM=new R.$Mj("outputView.scrollLock",!1),e.$iM=(0,O.$vi)("outputService");var M;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$jM={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new I.$ee,this.onDidRegisterChannel=this.b.event,this.c=new I.$ee,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(F=>E.push(F)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}N.$bo.add(e.$jM.OutputChannels,new b),e.$kM=new R.$Mj("activeOutputChannel","")}),define(Ie[118],Ce([1,0,4,3,17,20,12,295,65,27,46,147,21,15,37,5,6]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=e.$Fmc=void 0;class s extends M.$8j{get disposed(){return this.n}constructor(h,t,f,a,g){super(),this.id=h,this.name=t,this.r=f,this.s=a,this.extension=g,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=d.$Fe.fromString(t).byteLength,(0,M.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends s{appendLine(h){this.append(h)}}let n=class{constructor(h,t,f,a,g,u){this.i=t,this.j=f,this.k=a,this.l=g,this.m=u,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(I.$1M.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,D.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(h,t,f){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,g=(0,v.$8f)(t)?t:void 0;if((0,v.$8f)(g)&&!g.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const S=this.i.environment.extensionLogLevel?.find(([w])=>O.$Qm.equals(f.identifier,w))?.[1];S&&(u=(0,M.$gk)(S));const l=a?this.o(h,u,f):this.n(h,g,f);return l.then(w=>{this.g.set(w.id,w),w.visible=w.id===this.h}),a?this.r(h,u??this.m.getLevel(),l):this.q(h,l)}async n(h,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,g=this.k.extUri.joinPath(a,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.l.createLogger(g,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(h,g,t,f.identifier.value);return new s(S,h,u,this.a,f)}async o(h,t,f){const a=await this.p(f),g=h.replace(/[\\/:\*\?"<>\|]/g,""),u=this.k.extUri.joinPath(a,`${g}.log`),S=`${f.identifier.value}.${g}`,l=this.l.createLogger(u,{id:S,name:h,logLevel:t,extensionId:f.identifier.value});return new i(S,h,l,this.a,f)}p(h){let t=this.d.get(h.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(a){if((0,m.$fl)(a)!==m.FileSystemProviderErrorCode.FileExists)throw a}return f})())}return t}q(h,t){let f=!1;const a=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return h},append(g){a(),t.then(u=>u.append(g))},appendLine(g){a(),t.then(u=>u.appendLine(g))},clear(){a(),t.then(g=>g.clear())},replace(g){a(),t.then(u=>u.replace(g))},show(g,u){a(),t.then(S=>S.show(g,u))},hide(){a(),t.then(g=>g.hide())},dispose(){f=!0,t.then(g=>g.dispose())}}}r(h,t,f){const a=new o.$Uc,g=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},u=a.add(new r.$ee);function S(l){t=l,u.fire(l)}return f.then(l=>{a.add(l),l.logLevel!==t&&S(l.logLevel),a.add(l.onDidChangeLogLevel(w=>S(w)))}),{...this.q(h,f),get logLevel(){return t},onDidChangeLogLevel:u.event,trace(l,...w){g(),f.then($=>$.trace(l,...w))},debug(l,...w){g(),f.then($=>$.debug(l,...w))},info(l,...w){g(),f.then($=>$.info(l,...w))},warn(l,...w){g(),f.then($=>$.warn(l,...w))},error(l,...w){g(),f.then($=>$.error(l,...w))},dispose(){a.dispose()}}}};e.$Fmc=n,e.$Fmc=n=Je([We(0,R.$oP),We(1,E.$EP),We(2,p.$rlc),We(3,F.$7kc),We(4,M.$3j),We(5,M.$2j)],n),e.$Gmc=(0,N.$vi)("IExtHostOutputService")}),define(Ie[119],Ce([1,0,3,11]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=void 0,e.$fn=(0,I.$vi)("remoteAgentService"),e.$gn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(R){let O=1/0;for(let b=0;b<this.maxSampleCount;b++){const p=await R.getRoundTripTime();if(p===void 0)return;O=Math.min(O,p/2),await(0,N.$wh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(O):M=this.initial.reduce((b,p)=>b+p,0)/this.initial.length,this.lastMeasurement={initial:M,current:O,average:this.average.reduce((b,p)=>b+p,0)/this.average.length,high:typeof M>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ie[296],Ce([1,0,184,51,29,45,50,6,5,119,22,25,11]),function(le,e,I,N,R,O,M,b,p,E,F,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=void 0,e.$BJ=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$CJ=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$DJ=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$EJ=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$FJ={ConfigurationMigration:"base.contributions.configuration.migration"};class v{constructor(){this.migrations=[],this.a=new p.$ee,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const m=new v;R.$bo.add(e.$FJ.ConfigurationMigration,m);let r=class extends b.$Vc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const h of c.added)await this.f(h,m.migrations)})),this.c(m.migrations),this.B(m.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(c=>this.g(c,i?.uri))])}async g(i,n){const c=this.a.inspect(i.key,{resource:n}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of h){const a=c[t];if(!a)continue;const g=[];if(a.value!==void 0){const u=await this.h(i,t,a.value,n,void 0);for(const S of u??[])g.push([S,[]])}for(const{identifiers:u,value:S}of a.overrides??[])if(S!==void 0){const l=await this.h(i,t,S,n,u);for(const w of l??[])g.push([w,u])}g.length&&await Promise.allSettled(g.map(async([[u,S],l])=>this.a.updateValue(u,S.value,{resource:n,overrideIdentifiers:l},f)))}}async h(i,n,c,h,t){const f=g=>{const S=this.a.inspect(g,{resource:h})[n];if(S)return t?S.overrides?.find(({identifiers:l})=>(0,D.$6n)(l,t))?.value:S.value},a=await i.migrateFn(c,f);return Array.isArray(a)?a:[[i.key,a]]}};e.$GJ=r,e.$GJ=r=Je([We(0,M.$2i),We(1,O.$Ei)],r);let o=class extends b.$Vc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new d.$Sh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!F.$i&&(await this.b.getEnvironment())?.os!==1)return;R.$bo.as(N.$go.Configuration).registerConfiguration({...e.$DJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$HJ=o,e.$HJ=o=Je([We(0,E.$fn)],o)}),define(Ie[297],Ce([1,0,36,16,19,23,193,296,51,3,29]),function(le,e,I,N,R,O,M,b,p,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$_gb=e.$$gb=void 0,e.$ahb=r,e.$bhb=o,e.$$gb=(0,E.$vi)("editorResolverService"),e.$_gb="workbench.editorAssociations";const D=F.$bo.as(p.$go.Configuration),d={...b.$CJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(d);var v;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(v||(e.RegisteredEditorPriority=v={}));var m;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(m||(e.ResolvedStatus=m={}));function r(s){switch(s){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}function o(s,i){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(i.scheme))return!1;const h=typeof s=="string"&&s.indexOf(R.$hc.sep)>=0?`${i.scheme}:${i.path}`:(0,O.$6g)(i);return I.$ok(typeof s=="string"?s.toLowerCase():s,h.toLowerCase())}}),define(Ie[298],Ce([1,0,48,16,19,22,23,2,3,214,45,236,119]),function(le,e,I,N,R,O,M,b,p,E,F,D,d){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=void 0,e.$CM=(0,p.$vi)("pathService");let m=v=class{constructor(o,s,i,n){this.d=o,this.e=s,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,s,i){return typeof s=="string"||typeof s>"u"?this.a.then(n=>this.h(o,n,s)):this.h(o,s,i)}h(o,s,i){return o.scheme===N.Schemas.file||o.scheme===N.Schemas.vscodeRemote?(0,I.$sg)(i??(0,M.$6g)(o),s===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return N.Schemas.vscodeRemote;const i=(0,E.$zM)(s.getWorkspace());if(i)return i;const n=s.getWorkspace().folders[0];if(n)return n.uri.scheme;const c=s.getWorkspace().configuration;return c?c.scheme:N.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?R.$gc:R.$hc)}async fileURI(o){let s="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const n=o.indexOf("/",2);n===-1?(s=o.substring(2),o="/"):(s=o.substring(2,n),o=o.substring(n)||"/")}return b.URI.from({scheme:N.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.$DM=m,e.$DM=m=v=Je([We(1,d.$fn),We(2,D.$lM),We(3,F.$Ei)],m)}),define(Ie[120],Ce([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$9K=e.$8K=void 0;class I{constructor(M,b){this.line=M,this.character=b}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,b){return new I(0,0)}with(M){return new I(0,0)}}e.$8K=I;class N{constructor(M,b,p,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(M,b),this.end=new I(p,E)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new N(0,0,0,0)}with(M){return new N(0,0,0,0)}}e.$9K=N;var R;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}))}),define(Ie[47],Ce([1,0,18,36,25,48,13,3,19,14,120,11]),function(le,e,I,N,R,O,M,b,p,E,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vL=e.$tL=e.$mL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$jL=e.$iL=e.$hL=e.$gL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.TextSearchCompleteMessageType=void 0,e.$dL=s,e.$eL=i,e.$fL=n,e.$kL=l,e.$lL=w,e.$nL=y,e.$oL=C,e.$pL=P,e.$qL=W,e.$rL=V,e.$sL=q,e.$uL=U,e.$wL=ae,e.$xL=ye,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.$0K="workbench.view.search",e.$$K="workbench.panel.search",e.$_K="workbench.view.search",e.$aL="search-result",e.$bL="search.exclude";const d="\u27EA ",v=" characters skipped \u27EB",m=(d.length+v.length+5)*2;e.$cL=(0,b.$vi)("searchService");var r;(function(fe){fe[fe.file=0]="file",fe[fe.text=1]="text",fe[fe.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(fe){fe[fe.File=1]="File",fe[fe.Text=2]="Text",fe[fe.aiText=3]="aiText"})(o||(e.QueryType=o={}));function s(fe){return!!fe.preview}function i(fe){return!!fe.resource}function n(fe){return!!fe.message}var c;(function(fe){fe[fe.Normal=0]="Normal",fe[fe.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(me){this.resource=me,this.results=[]}}e.$gL=h;class t{constructor(me,Ae,ce,Me){this.ranges=Ae,this.webviewIndex=Me;const ie=Array.isArray(Ae)?Ae:[Ae];if(ce&&ce.matchLines===1&&f(ie)){me=(0,M.$1f)(me,ce.matchLines);let z="",x=0,ve=0;const Te=Math.floor(ce.charsPerLine/5),De=[];for(const $e of ie){const ge=Math.max($e.startColumn-Te,0),Q=$e.startColumn+ce.charsPerLine;if(ge>ve+Te+m){const X=d+(ge-ve)+v;z+=X+me.slice(ge,Q),x+=ge-(ve+X.length)}else z+=me.slice(ve,Q);De.push(new g(0,$e.startColumn-x,$e.endColumn-x)),ve=Q}this.preview={text:z,matches:Array.isArray(this.ranges)?De:De[0]}}else{const z=Array.isArray(Ae)?Ae[0].startLineNumber:Ae.startLineNumber;this.preview={text:me,matches:(0,I.$2b)(Ae,x=>new a(x.startLineNumber-z,x.startColumn,x.endLineNumber-z,x.endColumn))}}}}e.$hL=t;function f(fe){const me=fe[0].startLineNumber;for(const Ae of fe)if(Ae.startLineNumber!==me||Ae.endLineNumber!==me)return!1;return!0}class a{constructor(me,Ae,ce,Me){this.startLineNumber=me,this.startColumn=Ae,this.endLineNumber=ce,this.endColumn=Me}}e.$iL=a;class g extends a{constructor(me,Ae,ce){super(me,Ae,me,ce)}}e.$jL=g;var u;(function(fe){fe.List="list",fe.Tree="tree"})(u||(e.ViewMode=u={}));var S;(function(fe){fe.Default="default",fe.FileNames="fileNames",fe.Type="type",fe.Modified="modified",fe.CountDescending="countDescending",fe.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function l(fe,me=!0){const Ae=fe&&fe.files&&fe.files.exclude,ce=me&&fe&&fe.search&&fe.search.exclude;if(!Ae&&!ce)return;if(!Ae||!ce)return Ae||ce;let Me=Object.create(null);return Me=R.$5n(Me,R.$2n(Ae)),Me=R.$5n(Me,R.$2n(ce),!0),Me}function w(fe,me){return fe.excludePattern&&N.$ok(fe.excludePattern,me)?!1:fe.includePattern||fe.usingSearchPaths?fe.includePattern&&N.$ok(fe.includePattern,me)?!0:fe.usingSearchPaths?!!fe.folderQueries&&fe.folderQueries.some(Ae=>{const ce=Ae.folder.fsPath;if(O.$ug(me,ce)){const Me=p.$mc(ce,me);return!Ae.includePattern||!!N.$ok(Ae.includePattern,Me)}else return!1}):!1:!0}var $;(function(fe){fe[fe.unknownEncoding=1]="unknownEncoding",fe[fe.regexParseError=2]="regexParseError",fe[fe.globParseError=3]="globParseError",fe[fe.invalidLiteral=4]="invalidLiteral",fe[fe.rgProcessError=5]="rgProcessError",fe[fe.other=6]="other",fe[fe.canceled=7]="canceled"})($||(e.SearchErrorCode=$={}));class k extends Error{constructor(me,Ae){super(me),this.code=Ae}}e.$mL=k;function y(fe){const me=fe.message;if((0,E.$4)(fe))return new k(me,$.canceled);try{const Ae=JSON.parse(me);return new k(Ae.message,Ae.code)}catch{return new k(me,$.other)}}function C(fe){const me={message:fe.message,code:fe.code};return new Error(JSON.stringify(me))}function P(fe){return fe.type==="error"?!0:fe.type==="success"}function W(fe){return fe.type==="success"}function V(fe){return!!fe.path}function q(fe,me,Ae=!0){const ce=fe.searchPath?fe.searchPath:fe.relativePath;return Ae?(0,M.$Xf)(ce,me):N.$ok(me,ce)}class A{constructor(me){this.path=me,this.results=[]}addMatch(me){this.results.push(me)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$tL=A;function U(fe,me){const Ae={...fe||{},...me||{}};return Object.keys(Ae).filter(ce=>{const Me=Ae[ce];return typeof Me=="boolean"&&Me})}class K{constructor(me,Ae){this.c=null,this.a={...me.excludePattern||{},...Ae.excludePattern||{}},this.b=N.$pk(this.a);let ce=me.includePattern;Ae.includePattern&&(ce?ce={...ce,...Ae.includePattern}:ce=Ae.includePattern),ce&&(this.c=N.$pk(ce))}matchesExcludesSync(me,Ae,ce){return!!(this.b&&this.b(me,Ae,ce))}includedInQuerySync(me,Ae,ce){return!(this.b&&this.b(me,Ae,ce)||this.c&&!this.c(me,Ae,ce))}includedInQuery(me,Ae,ce){const Me=this.b(me,Ae,ce),ie=()=>this.c?!!this.c(me,Ae,ce):!0;return(0,D.$hh)(Me)?Me.then(z=>z?!1:ie()):ie()}hasSiblingExcludeClauses(){return re(this.a)}}e.$vL=K;function re(fe){for(const me in fe)if(typeof fe[me]!="boolean")return!0;return!1}function ae(fe){if(!fe)return;let me;return Ae=>(me||(me=(fe()||Promise.resolve([])).then(ce=>ce?Pe(ce):{})),me.then(ce=>!!ce[Ae]))}function ye(fe){if(!fe)return;let me;return Ae=>{if(!me){const ce=fe();me=ce?Pe(ce):{}}return!!me[Ae]}}function Pe(fe){const me={};for(const Ae of fe)me[Ae]=!0;return me}}),define(Ie[38],Ce([1,0,18,11,24,5,6,54,16,129,23,13,2,183,3,12,202,45,46,27,17,8,7,61,47,4,49]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o,s,i,n,c,h,t,f,a,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mlc=e.$llc=void 0;function S(W,V,q){return new F.$Xg(A=>k(A,q)).isEqual(W,V)}function l(W,V,q){return S(W.uri,V.uri,q)?0:(0,D.$qf)(W.uri.toString(),V.uri.toString())}function w(W,V,q){return W.index!==V.index?W.index<V.index?-1:1:S(W.uri,V.uri,q)?(0,D.$qf)(W.name,V.name):(0,D.$qf)(W.uri.toString(),V.uri.toString())}function $(W,V,q,A){const U=W.slice(0).sort((re,ae)=>q(re,ae,A)),K=V.slice(0).sort((re,ae)=>q(re,ae,A));return(0,I.$Eb)(U,K,(re,ae)=>q(re,ae,A))}function k(W,V){const q=V.getCapabilities(W.scheme);return!(q&&q&1024)}class y extends s.$Oi{static toExtHostWorkspace(V,q,A,U){if(!V)return{workspace:null,added:[],removed:[]};const{id:K,name:re,folders:ae,configuration:ye,transient:Pe,isUntitled:fe}=V,me=[],Ae=q;q?ae.forEach((z,x)=>{const ve=d.URI.revive(z.uri),Te=y.o(A||q,ve,U);Te?(Te.name=z.name,Te.index=z.index,me.push(Te)):me.push({uri:ve,name:z.name,index:x})}):me.push(...ae.map(({uri:z,name:x,index:ve})=>({uri:d.URI.revive(z),name:x,index:ve}))),me.sort((z,x)=>z.index<x.index?-1:1);const ce=new y(K,re,me,!!Pe,ye?d.URI.revive(ye):null,!!fe,z=>k(z,U)),{added:Me,removed:ie}=$(Ae?Ae.workspaceFolders:[],ce.workspaceFolders,l,U);return{workspace:ce,added:Me,removed:ie}}static o(V,q,A){for(let U=0;U<V.folders.length;U++){const K=V.workspaceFolders[U];if(S(K.uri,q,A))return K}}constructor(V,q,A,U,K,re,ae){super(V,A.map(ye=>new s.$Pi(ye)),U,K,ae),this.t=q,this.u=re,this.q=[],this.s=b.$Bi.forUris(ae),A.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,q){return q&&this.s.get(V)&&(V=(0,F.$8g)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let C=class{constructor(V,q,A,U,K){this.c=new O.$ee,this.onDidChangeWorkspace=this.c.event,this.g=new O.$ee,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$ge,this.C=new Map,this.h=U,this.s=A,this.t=K,this.j=new E.$Cm,this.k=new N.$uh,this.o=V.getProxy(g.$1M.MainThreadWorkspace),this.q=V.getProxy(g.$1M.MainThreadMessageService);const re=q.workspace;this.l=re?new y(re.id,re.name,[],!!re.transient,re.configuration?d.URI.revive(re.configuration):null,!!re.isUntitled,ae=>k(ae,A)):void 0}$initializeWorkspace(V,q){this.v=q,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?d.URI.from({scheme:p.Schemas.untitled,path:(0,F.$6g)((0,F.$8g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,q,A,...U){const K=[];if(Array.isArray(U)&&U.forEach(fe=>{d.URI.isUri(fe.uri)&&!K.some(me=>S(me.uri,fe.uri,this.s))&&K.push({uri:fe.uri,name:fe.name||(0,F.$5g)(fe.uri)})}),this.n||[q,A].some(fe=>typeof fe!="number"||fe<0)||A===0&&K.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(q+A>re.length)return!1;const ae=re.slice(0);ae.splice(q,A,...K.map(fe=>({uri:fe.uri,name:fe.name||(0,F.$5g)(fe.uri),index:void 0})));for(let fe=0;fe<ae.length;fe++){const me=ae[fe];if(ae.some((Ae,ce)=>ce!==fe&&S(me.uri,Ae.uri,this.s)))return!1}ae.forEach((fe,me)=>fe.index=me);const{added:ye,removed:Pe}=$(re,ae,w,this.s);if(ye.length===0&&Pe.length===0)return!1;if(this.o){const fe=V.displayName||V.name;this.o.$updateWorkspaceFolders(fe,q,A,K).then(void 0,me=>{this.n=void 0;const Ae={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(o.Severity.Error,(0,v.localize)(0,null,fe,me.toString()),Ae,[])})}return this.y(ae),!0}getWorkspaceFolder(V,q){if(this.x)return this.x.getWorkspaceFolder(V,q)}async getWorkspaceFolder2(V,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,q)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,q){let A,U="";if(typeof V=="string"?(A=d.URI.file(V),U=V):typeof V<"u"&&(A=V,U=V.fsPath),!A)return U;const K=this.getWorkspaceFolder(A,!0);if(!K)return U;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let re=(0,F.$$g)(K.uri,A);return q&&K.name&&(re=`${K.name}/${re}`),re}y(V){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:q,added:A,removed:U}=y.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:A,removed:U}))}findFiles(V,q,A,U,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let re="",ae=!0;return q===null?ae=!1:q!==void 0&&(typeof q=="string"?re=q:re=q.pattern),this.z(V,void 0,{exclude:re,maxResults:A,useDefaultExcludes:ae,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(V,q={},A,U=R.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${A.value}, entryPoint: findFiles2`),this.z(void 0,V,q,U)}async z(V,q,A,U=R.CancellationToken.None){if(U&&U.isCancellationRequested)return Promise.resolve([]);const K=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,re={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof A.useDefaultSearchExcludes=="boolean"?!A.useDefaultSearchExcludes:!1,maxResults:A.maxResults,excludePattern:K,shouldGlobSearch:typeof A.fuzzy=="boolean"?!A.fuzzy:!0,_reason:"startFileSearch"};let ae;if(V){const{includePattern:ye,folder:Pe}=P(h.GlobPattern.from(V));ae=Pe,re.includePattern=ye}else{const{includePattern:ye,folder:Pe}=P(h.GlobPattern.from(q));ae=Pe,re.filePattern=ye}return this.o.$startFileSearch(ae??null,re,U).then(ye=>Array.isArray(ye)?ye.map(Pe=>d.URI.revive(Pe)):[])}async findTextInFiles(V,q,A,U,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),ae=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ye,folder:Pe}=P(h.GlobPattern.from(q.include)),fe=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,me={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:ae,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ye,excludePattern:fe},Ae=!1;if(this.u[re]=ce=>{if(Ae)return;const Me=d.URI.revive(ce.resource);ce.results.forEach(ie=>{const z=(0,u.$5h)(ie);(0,a.$dL)(z)?A({uri:Me,preview:{text:z.preview.text,matches:(0,I.$2b)(z.preview.matches,x=>new t.$5M(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,I.$2b)(z.ranges,x=>new t.$5M(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):A({uri:Me,text:z.text,lineNumber:z.lineNumber})})},K.isCancellationRequested)return{};try{const ce=await this.o.$startTextSearch(V,Pe??null,me,re,K);return delete this.u[re],ce||{}}catch(ce){throw delete this.u[re],ce}}$handleTextSearchResult(V,q){this.u[q]?.(V)}async save(V){const q=await this.o.$save(V,{saveAs:!1});return d.URI.revive(q)}async saveAs(V){const q=await this.o.$save(V,{saveAs:!0});return d.URI.revive(q)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,q){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,q);const A=this.t.transformOutgoingScheme(V),U=this.A++;return this.o.$registerEditSessionIdentityProvider(U,A),(0,M.$Tc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(V,q){this.h.info("Getting edit session identifier for workspaceFolder",V);const A=await this.resolveWorkspaceFolder(d.URI.revive(V));if(!A){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",A);const U=this.w.get(A.uri.scheme);if(this.h.info(`Provider for scheme ${A.uri.scheme} is defined: `,!!U),!U)return;const K=await U.provideEditSessionIdentity(A,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(V,q,A,U){this.h.info("Getting edit session identifier for workspaceFolder",V);const K=await this.resolveWorkspaceFolder(d.URI.revive(V));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const re=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!re),!re)return;const ae=await re.provideEditSessionIdentityMatch?.(q,A,U);if(this.h.info("Provider returned edit session identifier match result: ",ae),!!ae)return ae}getOnWillCreateEditSessionIdentityEvent(V){return(q,A,U)=>{const K=function(ae){q.call(A,ae)};return K.extension=V,this.B.event(K,void 0,U)}}async $onWillCreateEditSessionIdentity(V,q,A){const U=await this.resolveWorkspaceFolder(d.URI.revive(V));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:U},q,async(K,re)=>{const ae=Date.now();await Promise.resolve(K),Date.now()-ae>A&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(V,q){if(this.C.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.C.set(V,q);const A=this.t.transformOutgoingScheme(V),U=this.A++;return this.o.$registerCanonicalUriProvider(U,A),(0,M.$Tc)(()=>{this.C.delete(V),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(V,q,A){const U=this.C.get(V.scheme);if(!U)return;const K=await U.provideCanonicalUri?.(d.URI.revive(V),q,A);if(K)return K}async $provideCanonicalUri(V,q,A){return this.provideCanonicalUri(d.URI.revive(V),{targetScheme:q},A)}};e.$llc=C,e.$llc=C=Je([We(0,c.$oP),We(1,n.$EP),We(2,i.$7kc),We(3,r.$2j),We(4,f.$jlc)],C),e.$mlc=(0,m.$vi)("IExtHostWorkspace");function P(W){let V,q;return W&&(typeof W=="string"?V=W:(V=W.pattern,q=d.URI.revive(W.baseUri))),{includePattern:V,folder:q}}}),define(Ie[39],Ce([1,0,25,5,38,4,7,203,51,15,11,3,17,12,2]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=e.$olc=e.$nlc=void 0;function r(f,a){if(a){const g=a.split(".");let u=f;for(let S=0;u&&S<g.length;S++)u=u[g[S]];return u}}function o(f){return f instanceof m.URI}function s(f){return f&&f.uri instanceof m.URI&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&f.uri instanceof m.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function c(f){if(o(f))return{resource:f};if(s(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(i(f))return{overrideIdentifier:f.languageId};if(n(f))return{resource:f.uri};if(f===null)return{resource:null}}let h=class{constructor(a,g,u){this.a=a.getProxy(O.$1M.MainThreadConfiguration),this.c=g,this.b=u,this.d=new F.$uh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,g){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(a,g))}};e.$nlc=h,e.$nlc=h=Je([We(0,d.$oP),We(1,R.$mlc),We(2,v.$2j)],h);class t{constructor(a,g,u,S){this.a=new N.$ee,this.b=a,this.f=S,this.c=g,this.e=b.$zo.parse(u,S),this.d=this.k(u.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,g){const u={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$zo.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(g,u))}getConfiguration(a,g,u){const S=c(g)||{},l=this.g(a?r(this.e.getValue(void 0,S,this.c.workspace),a):this.e.getValue(void 0,S,this.c.workspace));a&&this.h(a,S,u?.identifier);function w(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const $={has(k){return typeof r(l,k)<"u"},get:(k,y)=>{this.h(a?`${a}.${k}`:k,S,u?.identifier);let C=r(l,k);if(typeof C>"u")C=y;else{let P;const W=(V,q)=>{if((0,E.$0f)(V)){let A;const U=()=>{P=P||(0,I.$2n)(l),A=A||r(P,q)};return new Proxy(V,{get:(K,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return U(),()=>A;if(P)return A=A||r(P,q),A[re];const ae=K[re];return typeof re=="string"?W(ae,`${q}.${re}`):ae},set:(K,re,ae)=>(U(),A&&(A[re]=ae),!0),deleteProperty:(K,re)=>(U(),A&&delete A[re],!0),defineProperty:(K,re,ae)=>(U(),A&&Object.defineProperty(A,re,ae),!0)})}return Array.isArray(V)?(0,I.$2n)(V):V};C=W(C,k)}return C},update:(k,y,C,P)=>{k=a?`${a}.${k}`:k;const W=w(C);return y!==void 0?this.b.$updateConfigurationOption(W,k,y,S,P):this.b.$removeConfigurationOption(W,k,S,P)},inspect:k=>{k=a?`${a}.${k}`:k;const y=this.e.inspect(k,S,this.c.workspace);if(y)return{key:k,defaultValue:(0,I.$2n)(y.policy?.value??y.default?.value),globalValue:(0,I.$2n)(y.user?.value??y.application?.value),workspaceValue:(0,I.$2n)(y.workspace?.value),workspaceFolderValue:(0,I.$2n)(y.workspaceFolder?.value),defaultLanguageValue:(0,I.$2n)(y.default?.override),globalLanguageValue:(0,I.$2n)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,I.$2n)(y.workspace?.override),workspaceFolderLanguageValue:(0,I.$2n)(y.workspaceFolder?.override),languageIds:(0,I.$2n)(y.overrideIdentifiers)}}};return typeof l=="object"&&(0,I.$5n)($,l,!1),Object.freeze($)}g(a){const g=u=>(0,E.$0f)(u)?new Proxy(u,{get:(S,l)=>g(S[l]),set:(S,l,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(S,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(S,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return g(a)}h(a,g,u){const S=p.$qo.test(a)?4:this.d.get(a),l=u?`[${u.value}] `:"";if(S===4){typeof g?.resource>"u"&&this.f.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(S===3){g?.resource&&this.f.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,g){const u=new b.$Bo(a,g,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(S,l)=>u.affectsConfiguration(S,c(l))})}k(a){return a.reduce((g,u)=>(g.set(u[0],u[1]),g),new Map)}}e.$olc=t,e.$plc=(0,D.$vi)("IExtHostConfiguration")}),define(Ie[121],Ce([1,0,2,11,5,4,7,38,68,39,24,53,17,27,3,16,22,12,80,241,14]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o,s,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=e.$Smc=e.$Rmc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(h||(h={}));var t;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(t||(t={}));var f;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(f||(f={}));var a;(function(W){function V(U){if(U){const K=U;return K&&!!K.process}else return!1}W.is=V;function q(U){if(U==null)return;const K={process:U.process,args:U.args};return U.options&&(K.options=f.from(U.options)),K}W.from=q;function A(U){if(U!=null)return new M.$MN(U.process,U.args,U.options)}W.to=A})(a||(a={}));var g;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(g||(g={}));var u;(function(W){function V(U){if(U){const K=U;return K&&(!!K.commandLine||!!K.command)}else return!1}W.is=V;function q(U){if(U==null)return;const K={};return U.commandLine!==void 0?K.commandLine=U.commandLine:(K.command=U.command,K.args=U.args),U.options&&(K.options=g.from(U.options)),K}W.from=q;function A(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new M.$NN(U.commandLine,U.options):new M.$NN(U.command,U.args?U.args:[],U.options)}W.to=A})(u||(u={}));var S;(function(W){function V(U){if(U){const K=U;return K&&K.customExecution==="customExecution"}else return!1}W.is=V;function q(U){return{customExecution:"customExecution"}}W.from=q;function A(U,K){return K.get(U)}W.to=A})(S||(e.CustomExecutionDTO=S={}));var l;(function(W){function V(q,A){let U;return q.scope!==void 0&&typeof q.scope!="number"?U=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===M.TaskScope.Workspace&&A&&A.workspaceFile?U=A.workspaceFile:U=n.$7H),{id:q._id,workspaceFolder:U}}W.from=V})(l||(e.TaskHandleDTO=l={}));var w;(function(W){function V(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}W.from=V})(w||(w={}));var $;(function(W){function V(U,K){if(U==null)return[];const re=[];for(const ae of U){const ye=q(ae,K);ye&&re.push(ye)}return re}W.fromMany=V;function q(U,K){if(U==null)return;let re;U.execution instanceof M.$MN?re=a.from(U.execution):U.execution instanceof M.$NN?re=u.from(U.execution):U.execution&&U.execution instanceof M.$ON&&(re=S.from(U.execution));const ae=h.from(U.definition);let ye;return U.scope?typeof U.scope=="number"?ye=U.scope:ye=U.scope.uri:ye=M.TaskScope.Workspace,!ae||!ye?void 0:{_id:U._id,definition:ae,name:U.name,source:{extensionId:K.identifier.value,label:U.source,scope:ye},execution:re,isBackground:U.isBackground,group:w.from(U.group),presentationOptions:t.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}W.from=q;async function A(U,K,re){if(U==null)return;let ae;a.is(U.execution)?ae=a.to(U.execution):u.is(U.execution)?ae=u.to(U.execution):S.is(U.execution)&&(ae=S.to(U._id,re));const ye=h.to(U.definition);let Pe;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?Pe=U.source.scope:Pe=await K.resolveWorkspaceFolder(I.URI.revive(U.source.scope)):Pe=M.TaskScope.Workspace),!ye||!Pe)return;const fe=new M.$PN(ye,Pe,U.name,U.source.label,ae,U.problemMatchers);return U.isBackground!==void 0&&(fe.isBackground=U.isBackground),U.group!==void 0&&(fe.group=M.$LN.from(U.group._id),fe.group&&U.group.isDefault&&(fe.group=new M.$LN(fe.group.id,fe.group.label),U.group.isDefault===!0&&(fe.group.isDefault=U.group.isDefault))),U.presentationOptions&&(fe.presentationOptions=t.to(U.presentationOptions)),U._id&&(fe._id=U._id),U.detail&&(fe.detail=U.detail),fe}W.to=A})($||(e.TaskDTO=$={}));var k;(function(W){function V(A){return A}W.from=V;function q(A){if(A)return Object.assign(Object.create(null),A)}W.to=q})(k||(k={}));class y{#e;constructor(V,q,A){this._id=q,this.a=A,this.#e=V}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}let C=class{constructor(V,q,A,U,K,re,ae,ye){this.q=new R.$ee,this.r=new R.$ee,this.s=new R.$ee,this.u=new R.$ee,this.a=V.getProxy(O.$1M.MainThreadTask),this.b=A,this.c=U,this.d=K,this.e=re,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ae,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,q,A){if(!A)return new M.$3M(()=>{});const U=this.x();return this.j.set(U,{type:q,provider:A,extension:V}),this.a.$registerTaskProvider(U,q),new M.$3M(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(V,q){this.a.$registerTaskSystem(V,q)}fetchTasks(V){return this.a.$fetchTasks(k.from(V)).then(async q=>{const A=[];for(const U of q){const K=await $.to(U,this.b,this.m);K&&A.push(K)}return A})}get taskExecutions(){const V=[];return this.k.forEach(q=>V.push(q)),V}terminateTask(V){if(!(V instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,q,A){const U=this.m.get(V.id);U&&(this.o.set(V.id,U),this.e.attachPtyToTerminal(q,await U.callback(A))),this.p=V.id,this.q.fire({execution:await this.z(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){if(!this.l.has(V.id))return;const q=await this.z(V);this.l.delete(V.id),this.k.delete(V.id),this.B(V),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const q=await this.z(V.id);this.s.fire({execution:q,processId:V.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(V){const q=await this.z(V.id);this.u.fire({execution:q,exitCode:V.exitCode})}$provideTasks(V,q){const A=this.j.get(V);if(!A)return Promise.reject(new Error("no handler found"));const U=[],K=(0,N.$nh)(()=>A.provider.provideTasks(F.CancellationToken.None)).then(re=>this.v(q,U,A,re));return new Promise(re=>{K.then(ae=>{Promise.all(U).then(()=>{re(ae)})})})}async $resolveTask(V,q){const A=this.j.get(V);if(!A)return Promise.reject(new Error("no handler found"));if(q.definition.type!==A.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${A.type}].`);const U=await $.to(q,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const K=await A.provider.resolveTask(U,F.CancellationToken.None);if(!K)return;this.A(K,A);const re=$.from(K,A.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return S.is(re.execution)&&await this.y(re,K,!0),await this.w(re)}x(){return this.h++}async y(V,q,A){const U=await this.a.$createTaskId(V);!A&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,q.execution)),this.m.set(U,q.execution)}async z(V,q){if(typeof V=="string"){const K=this.l.get(V);if(!K)throw new c.$bb("Unexpected: The specified task is missing an execution");return K}const A=this.l.get(V.id);if(A)return A;let U;return q?U=Promise.resolve(new y(this,V.id,q)):U=$.to(V.task,this.b,this.m).then(K=>{if(!K)throw new c.$bb("Unexpected: Task does not exist.");return new y(this,V.id,K)}),this.l.set(V.id,U),U.then(K=>(this.k.set(V.id,K),K))}A(V,q){V._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const A=this.n.values();let U=A.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=A.next()}};e.$Rmc=C,e.$Rmc=C=Je([We(0,d.$oP),We(1,v.$EP),We(2,b.$mlc),We(3,p.$zP),We(4,E.$plc),We(5,D.$Nlc),We(6,s.$2j),We(7,i.$3kc)],C);let P=class extends C{constructor(V,q,A,U,K,re,ae,ye){super(V,q,A,U,K,re,ae,ye),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(V,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const A=$.from(q,V);if(A===void 0)throw new Error("Task is not valid");if(S.is(A.execution))await this.y(A,q,!1);else throw new c.$_;const U=await this.z(await this.a.$getTaskExecution(A),q);return this.a.$executeTask(A).catch(K=>{throw new Error(K)}),U}v(V,q,A,U){const K=[];if(U)for(const re of U){if(this.A(re,A),!re.definition||!V[re.definition.type]){const ye=re.source?re.source:"No task source";this.f.warn(`The task [${ye}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`)}const ae=$.from(re,A.extension);ae&&S.is(ae.execution)?(K.push(ae),q.push(this.y(ae,re,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:A.extension}}async w(V){if(S.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,q,A){}};e.$Smc=P,e.$Smc=P=Je([We(0,d.$oP),We(1,v.$EP),We(2,b.$mlc),We(3,p.$zP),We(4,E.$plc),We(5,D.$Nlc),We(6,s.$2j),We(7,i.$3kc)],P),e.$Tmc=(0,m.$vi)("IExtHostTask")}),define(Ie[299],Ce([1,0,47,30]),function(le,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=void 0,e.$DL=R,e.$FL=O;function R(M){return"cellResults"in M}e.$EL="rawCell#";function O(M,b){let p=-1;const E=[];let F=[];return M.forEach(d=>{d.range.startLineNumber!==p&&F.length>0&&(E.push([...F]),F=[]),F.push(d),p=d.range.endLineNumber}),F.length>0&&E.push([...F]),E.map(d=>{const v=[],m=d[0].range.startLineNumber,r=d[d.length-1].range.endLineNumber;for(let o=m;o<=r;o++)v.push(b.getLineContent(o));return new I.$hL(v.join(`
`)+`
`,d.map(o=>new N.$tt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Ie[300],Ce([1,0,177,21,5,6,28,13,15,2,37,76,4,32,8,7,35,275,114,25,16,231,299,297]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o,s,i,n,c,h,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(u=>u.apiEditor)}constructor(u,S,l,w,$,k){this.q=l,this.r=w,this.s=$,this.t=k,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new R.$ee,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.$ee,this.onDidOpenNotebookDocument=this.m.event,this.n=new R.$ee,this.onDidCloseNotebookDocument=this.n.event,this.o=new R.$ee,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$1kc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=u.getProxy(d.$1M.MainThreadNotebook),this.c=u.getProxy(d.$1M.MainThreadNotebookDocuments),this.d=u.getProxy(d.$1M.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const C=y.notebookEditor?.notebookUri,P=y.cell.handle,V=this.g.get(C)?.getCell(P);if(V)return V.apiCell}if(y&&y.$mid===14){const C=y.uri,P=this.g.get(C);if(P)return P.apiNotebook}return y}}),a.B(S)}getEditorById(u){const S=this.h.get(u);if(!S)throw new Error(`unknown text editor: ${u}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(u){for(const[S,l]of this.h)if(l.apiEditor===u)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(u,S){const l=this.g.get(u);if(!l&&!S)throw new Error(`NO notebook document for '${u}'`);return l}static u(u,S){if(!S)return;const l=S.filenamePattern.map(w=>m.NotebookExclusiveDocumentPattern.from(w)).filter(w=>w!==void 0);if(S.filenamePattern&&!l){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:S.displayName,filenamePattern:l,exclusive:S.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,S,l){const w=a.a++,$=typeof l.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(w,l),this.b.$registerNotebookCellStatusBarItemProvider(w,$,S);let k;return $!==void 0&&(k=l.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent($))),new r.$3M(()=>{this.f.delete(w),this.b.$unregisterNotebookCellStatusBarItemProvider(w,$),k?.dispose()})}async createNotebookDocument(u){const S=await this.c.$tryCreateNotebook({viewType:u.viewType,content:u.content&&m.NotebookData.from(u.content)});return E.URI.revive(S)}async openNotebookDocument(u){const S=this.g.get(u);if(S)return S.apiNotebook;const l=await this.c.$tryOpenNotebook(u),w=this.g.get(E.URI.revive(l));return(0,p.$gg)(w?.apiNotebook)}async showNotebookDocument(u,S){E.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let l;typeof S=="object"?l={position:m.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(m.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:l={preserveFocus:!1};const w=await this.d.$tryShowNotebookDocument(u.uri,u.notebookType,l),$=w&&this.h.get(w)?.apiEditor;if($)return $;throw w?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,S,l,w){const $=this.f.get(u),k=E.URI.revive(S),y=this.g.get(k);if(!y||!$)return;const C=y.getCellFromIndex(l);if(!C)return;const P=await $.provideCellStatusBarItems(C.apiCell,w);if(!P)return;const W=new O.$Uc,V=this.p.add([W]),A=(Array.isArray(P)?P:[P]).map(U=>m.NotebookStatusBarItem.from(U,this.i,W));return{cacheId:V,items:A}}$releaseNotebookCellStatusBarItems(u){this.p.delete(u)}registerNotebookSerializer(u,S,l,w,$){if((0,b.$7e)(S))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:S,serializer:l,options:w}),this.b.$registerNotebookSerializer(k,{id:u.identifier,location:u.extensionLocation},S,m.NotebookDocumentContentOptions.from(w),a.u(u,$)),(0,O.$Tc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(u,S,l){const w=this.x.get(u);if(!w)throw new Error("NO serializer found");const $=await w.serializer.deserializeNotebook(S.buffer,l);return new o.$uw(m.NotebookData.from($))}async $notebookToData(u,S,l){const w=this.x.get(u);if(!w)throw new Error("NO serializer found");const $=await w.serializer.serializeNotebook(m.NotebookData.to(S.value),l);return N.$Fe.wrap($)}async $saveNotebook(u,S,l,w,$){const k=E.URI.revive(S),y=this.x.get(u);if(!y)throw new Error("NO serializer found");const C=this.g.get(k);if(!C)throw new Error("Document NOT found");if(C.versionId!==l)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new F.$kl((0,I.localize)(0,null,this.z(k)),6);await this.y(k,w);const P={metadata:(0,n.$0n)(C.apiNotebook.metadata,U=>!(y.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of C.apiNotebook.getCells()){const K=new r.$tO(U.kind,U.document.getText(),U.document.languageId,U.mime,y.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);K.metadata=(0,n.$0n)(U.metadata,re=>!(y.options?.transientCellMetadata??{})[re]),P.cells.push(K)}const W=await y.serializer.serializeNotebook(P,$);await this.s.value.writeFile(k,W);const V=this.s.getFileSystemProviderExtUri(k.scheme),q=await this.s.value.stat(k);return{name:V.basename(k),isFile:(q.type&F.FileType.File)!==0,isDirectory:(q.type&F.FileType.Directory)!==0,isSymbolicLink:(q.type&F.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&F.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((q.permissions??0)&F.FilePermission.Locked),etag:F.$vl({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(u,S,l,w,$){const k=this.x.get(u)?.serializer;if(!k)return{limitHit:!1,results:[]};const y=new M.$Cc;await(async(q,A,U)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(re=>{const ae={_reason:U._reason,folderQueries:U.folderQueries,includePattern:U.includePattern,excludePattern:U.excludePattern,maxResults:U.maxResults,type:1,filePattern:re};return this.t.doInternalFileSearchWithCustomCallback(ae,A,ye=>{ye.forEach(Pe=>{y.has(Pe)||w.some(me=>K.isFromSettings&&!me.isFromSettings?!1:me.filenamePatterns.some(Ae=>(0,f.$bhb)(Ae,Pe)))||y.add(Pe)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})(l,$,S);const P=new M.$Bc;let W=!1;const V=Array.from(y).map(async q=>{const A=[];try{if($.isCancellationRequested)return;if(S.maxResults&&[...P.values()].reduce((ae,ye)=>ae+ye.cellResults.length,0)>S.maxResults){W=!0;return}const U=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(ye=>U.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(Pe=>Pe.items.map(fe=>fe.data.toString()))}));else{const ae=await this.s.value.readFile(q),ye=N.$Fe.fromString(ae.toString()),Pe=await k.deserializeNotebook(ye.buffer,$);if($.isCancellationRequested)return;m.NotebookData.from(Pe).cells.forEach(me=>U.push({input:me.source,outputs:me.outputs.flatMap(Ae=>Ae.items.map(ce=>ce.valueBytes.toString()))}))}if($.isCancellationRequested)return;U.forEach((ae,ye)=>{const Pe=S.contentPattern.pattern,fe=new h.$0Wb(ae.input,void 0,ae.outputs),me=fe.findInInputs(Pe),Ae=fe.findInOutputs(Pe),ce=Ae.flatMap(Me=>(0,t.$FL)(Me.matches,Me.textBuffer)).map((Me,ie)=>(Me.webviewIndex=ie,Me));if(me.length>0||Ae.length>0){const Me={index:ye,contentResults:(0,t.$FL)(me,fe.inputTextBuffer),webviewResults:ce};A.push(Me)}});const re={resource:q,cellResults:A};P.set(q,re);return}catch{return}});return await Promise.all(V),{limitHit:W,results:[...P.values()]}}async y(u,S){const l=await this.s.value.stat(u);if(typeof S?.mtime=="number"&&typeof S.etag=="string"&&S.etag!==F.$ul&&typeof l.mtime=="number"&&typeof l.size=="number"&&S.mtime<l.mtime&&S.etag!==F.$vl({mtime:S.mtime,size:l.size}))throw new F.$kl((0,I.localize)(1,null),3,S)}z(u){return u.scheme===c.Schemas.file?u.fsPath:u.toString()}A(u,S,l){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const w=new i.$lmc(S,this.d,u,l.visibleRanges.map(m.NotebookRange.to),l.selections.map(m.NotebookRange.to),typeof l.viewColumn=="number"?m.ViewColumn.to(l.viewColumn):void 0);this.h.set(S,w)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const l of u.value.removedDocuments){const w=E.URI.revive(l),$=this.g.get(w);$&&($.dispose(),this.g.delete(w),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:$.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire($.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===w.toString()&&this.h.delete(k.id)}if(u.value.addedDocuments){const l=[];for(const w of u.value.addedDocuments){const $=E.URI.revive(w.uri);if(this.g.has($))throw new Error(`adding EXISTING notebook ${$} `);const k=new s.$kmc(this.c,this.q,this.r,$,w);l.push(...w.cells.map(y=>s.$jmc.asModelAddData(y))),this.g.get($)?.dispose(),this.g.set($,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:l}),this.m.fire(k.apiNotebook)}}if(u.value.addedEditors)for(const l of u.value.addedEditors){if(this.h.has(l.id))return;const w=E.URI.revive(l.documentUri),$=this.g.get(w);$&&this.A($,l.id,l)}const S=[];if(u.value.removedEditors)for(const l of u.value.removedEditors){const w=this.h.get(l);w&&(this.h.delete(l),this.k?.id===w.id&&(this.k=void 0),S.push(w))}if(u.value.visibleEditors){this.l=u.value.visibleEditors.map(w=>this.h.get(w)).filter(w=>!!w);const l=new Set;this.l.forEach(w=>l.add(w.id));for(const w of this.h.values()){const $=l.has(w.id);w._acceptVisibility($)}this.l=[...this.h.values()].map(w=>w).filter(w=>w.visible),this.o.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this.k=void 0:u.value.newActiveEditor&&(this.h.get(u.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${u.value.newActiveEditor}`),this.k=this.h.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(u){const S=v.$MP.String.with("notebookType","A notebook type"),l=new v.$OP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new v.$MP("data","Bytes to convert to data",$=>$ instanceof Uint8Array,$=>N.$Fe.wrap($))],new v.$NP("Notebook Data",$=>m.NotebookData.to($.value))),w=new v.$OP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new v.$MP("NotebookData","Notebook data to convert to bytes",$=>!0,$=>new o.$uw(m.NotebookData.from($)))],new v.$NP("Bytes",$=>$.buffer));u.registerApiCommand(l),u.registerApiCommand(w)}}e.$umc=a}),define(Ie[301],Ce([1,0,19,24,44,36,23,66,47]),function(le,e,I,N,R,O,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=void 0;class E{constructor(d,v,m){this.k=d,this.l=v,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=d.filePattern,this.b=d.includePattern&&O.$pk(d.includePattern),this.c=d.maxResults||void 0,this.d=d.exists,this.h=new Set,this.j=d.excludePattern&&O.$pk(d.excludePattern)}cancel(){this.g=!0,this.h.forEach(d=>d.cancel()),this.h=new Set}search(d){const v=this.k.folderQueries||[];return new Promise((m,r)=>{const o=s=>{this.f++,d(s)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const i=s.toString(),n=I.$oc(i);this.j&&this.j(i,n)||this.v(o,{base:s,basename:n})}),Promise.all(v.map(s=>this.p(s,o))).then(s=>{m({limitHit:this.e,stats:s[0]||void 0})},s=>{r(new Error((0,R.$gj)(s)))})})}async p(d,v){const m=new N.$pe,r=this.q(d),o=this.r(),s=new p.$vL(this.k,d),i=!s.hasSiblingExcludeClauses();let n;try{this.h.add(m),n=b.$ae.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,m.token),h=n.elapsed(),t=b.$ae.create();return this.g&&!this.e||(c&&c.forEach(f=>{const a=I.$hc.relative(d.folder.path,f.path);if(i){const g=I.$oc(f.path);this.v(v,{base:d.folder,relativePath:a,basename:g});return}this.s(o,d.folder,a,v)}),this.g&&!this.e)?null:(this.u(o,s,v),{providerTime:h,postProcessTime:t.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(d){const v=(0,p.$uL)(this.k.includePattern,d.includePattern),m=(0,p.$uL)(this.k.excludePattern,d.excludePattern);return{folder:d.folder,excludes:m,includes:v,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}s({pathToEntries:d},v,m,r){if(m===this.a){const s=I.$oc(this.a);this.v(r,{base:v,relativePath:this.a,basename:s})}function o(s){const i=I.$oc(s),n=I.$nc(s);let c=d[n];c||(c=d[n]=[],o(n)),c.push({base:v,relativePath:s,basename:i})}o(m)}u({rootEntries:d,pathToEntries:v},m,r){const o=this,s=this.a;function i(n){const c=(0,p.$xL)(()=>n.map(h=>h.basename));for(let h=0,t=n.length;h<t;h++){const f=n[h],{relativePath:a,basename:g}=f;if(m.matchesExcludesSync(a,g,s!==g?c:void 0))continue;const u=v[a];if(u)i(u);else{if(a===s)continue;o.v(r,f)}if(o.e)break}}i(d)}v(d,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||d(v))}}class F{constructor(){this.b=new Map}static{this.a=512}fileSearch(d,v,m,r){const o=this.c(d.cacheKey),s=new E(d,v,o&&o.token);let i=0;const n=c=>{i+=c.length,m(c.map(h=>this.d(h)))};return this.e(s,F.a,n,r).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:c.stats}}))}clearCache(d){this.c(d)?.cancel()}c(d){if(d)return this.b.has(d)||this.b.set(d,new N.$pe),this.b.get(d)}d(d){return d.relativePath?{resource:M.$9g(d.base,d.relativePath)}:{resource:d.base}}e(d,v,m,r){const o=r.onCancellationRequested(()=>{d.cancel()}),s=n=>{n&&(i.push(n),v>0&&i.length>=v&&(m(i),i=[]))};let i=[];return d.search(s).then(n=>(i.length&&m(i),o.dispose(),n),n=>(i.length&&m(i),o.dispose(),Promise.reject(n)))}}e.$mmc=F}),define(Ie[302],Ce([1,0,18,270,36,97,28,16,19,23,13,15,2,96,195,50,12,45,109,298,47]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o,s,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EM=void 0,e.$FM=w;let h=class{constructor(k,y,C,P,W){this.a=k,this.b=y,this.c=C,this.d=P,this.e=W}text(k,y,C={}){k=this.f(k,C);const P=this.a.getValue(),W=y&&y.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(y?.map(s.$Qi),C),type:2,contentPattern:k,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:P.search.usePCRE2||W||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(k,y){const C=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const P={...k,wordSeparators:C.editor.wordSeparators};return this.j(k,y)&&(P.isCaseSensitive=!0),this.k(k)&&(P.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),P}file(k,y={}){return{...this.h(k,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(k,y){return k?(k=Array.isArray(k)?k.map(u):u(k),y?this.parseSearchPaths(k):{pattern:f(...Array.isArray(k)?k:[k])}):{}}h(k=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),P=this.g(y.excludePattern,y.expandPatterns),W=k.length>1,V=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(U=>this.q(U,y,P)):k.map(U=>this.r(U,y,P,W))).filter(U=>!!U),q={_reason:y._reason,folderQueries:V,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:P.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const U=I.$Hb(I.$Rb(this.c.groups.map(ae=>ae.editors.map(ye=>ye.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const K=U.filter(ae=>(0,c.$lL)(q,ae.fsPath)),re=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(re)),{...q,...re}}const A=y.extraFileResources&&y.extraFileResources.filter(U=>(0,c.$lL)(q,U.fsPath));return q.extraFileResources=A&&A.length?A:void 0,q}i(k){const y=[],C=new M.$Bc,P={};let W=!1;return k.forEach(V=>{if(V.scheme===b.Schemas.walkThrough)return;if((0,E.$ah)(V)){const A=this.b.getWorkspaceFolder(V)?.uri??V.with({path:p.$nc(V.fsPath)});let U=C.get(A);U||(W=!0,U={folder:A,includePattern:{}},y.push(U),C.set(A,U));const K=p.$mc(A.fsPath,V.fsPath);(0,D.$gg)(U.includePattern)[K.replace(/\\/g,"/")]=!0}else V.fsPath&&(W=!0,P[V.fsPath]=!0)}),{folderQueries:y,includePattern:P,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}j(k,y){if(y.isSmartCase){if(k.isRegExp){if(F.$Yf(k.pattern,!0))return!0}else if(F.$Yf(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,v.$JC)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const y=re=>p.$jc(re)||/^\.\.?([\/\\]|$)/.test(re),P=(Array.isArray(k)?k:a(k)).map(re=>{const ae=this.e.resolvedUserHome;return ae?(0,O.$zw)(re,ae.scheme===b.Schemas.file?ae.fsPath:ae.path):re}),W=N.$K(P,re=>y(re)?"searchPaths":"exprSegments"),V=(W.exprSegments||[]).map(re=>F.$ff(re,"/")).map(re=>F.$ff(re,"\\")).map(re=>(re[0]==="."&&(re="*"+re),g(re))),q={},A=this.m(W.searchPaths||[]);A&&A.length&&(q.searchPaths=A);const U=I.$Rb(V),K=f(...U);return K&&(q.pattern=K),q}l(k,y){return y.disregardExcludeSettings?void 0:(0,c.$kL)(k,!y.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const y=k.flatMap(P=>{let{pathPortion:W,globPortion:V}=t(P);return V&&(V=S(V)),this.n(W).flatMap(A=>this.o(A,V))}),C=new Map;return y.forEach(P=>{const W=P.searchPath.toString(),V=C.get(W);V?P.pattern&&(V.pattern=V.pattern||{},V.pattern[P.pattern]=!0):C.set(W,{searchPath:P.searchPath,pattern:P.pattern?f(P.pattern):void 0})}),Array.from(C.values())}n(k){if(p.$jc(k)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==b.Schemas.file?[{searchPath:y[0].uri.with({path:k})}]:[{searchPath:d.URI.file(p.$ic(k))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(k=u(k),k.startsWith("../")||k===".."){const P=p.$hc.resolve(y.path,k);return[{searchPath:y.with({path:P})}]}const C=S(k);return[{searchPath:y,pattern:C}]}else{if(k==="./"||k===".\\")return[];{const y=k.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(W=>{const V=y.match(new RegExp(`^${F.$_e(W.name)}(?:/(.*)|$)`));return V?{match:V,folder:W}:null}).filter(D.$dg);if(P.length)return P.map(W=>{const V=W.match[1];return{searchPath:W.folder.uri,pattern:V&&S(V)}});{const W=k.match(/\.[\/\\](.+)[\/\\]?/),V=W?W[1]:k,q=m.localize(0,null,V);throw new Error(q)}}}}o(k,y){const C=k.pattern&&y?`${k.pattern}/${y}`:k.pattern||y,P=[{searchPath:k.searchPath,pattern:C}];return C&&!C.endsWith("**")&&P.push({searchPath:k.searchPath,pattern:C+"/**"}),P}q(k,y,C){const P=this.r((0,s.$Qi)(k.searchPath),y,C,!1);return P?{...P,includePattern:k.pattern}:null}r(k,y,C,P){let W;const V=d.URI.isUri(k)?k:k.uri;if(C.searchPaths){const re=C.searchPaths.filter(ae=>(0,E.$2g)(ae.searchPath,V))[0];if(re&&!re.pattern)return null;re&&(W=re.pattern)}const q=this.a.getValue({resource:V}),U={...this.l(q,y)||{},...W||{}},K=d.URI.isUri(k)?(0,E.$6g)(k):k.name;return{folder:V,folderName:P?K:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!q.search.followSymlinks}}};e.$EM=h,e.$EM=h=Je([We(0,r.$2i),We(1,s.$Ei),We(2,i.$QD),We(3,o.$2j),We(4,n.$CM)],h);function t($){const k=$.match(/[\*\{\}\(\)\[\]\?]/);if(k){const y=k.index,C=$.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let P=$.substr(0,C.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:$.substr((C.index||0)+1)}}}return{pathPortion:$}}function f(...$){return $.length?$.reduce((k,y)=>(k[y]=!0,k),Object.create(null)):void 0}function a($){return R.$nk($,",").map(k=>k.trim()).filter(k=>!!k.length)}function g($){return[`**/${$}/**`,`**/${$}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function u($){return $.replace(/\\/g,"/")}function S($){return u($).replace(/^\.\//,"").replace(/\/+$/g,"")}function l($){return $.replace(/([?*[\]])/g,"[$1]")}function w($,k){$=I.$Mb($,P=>P.toString());const y=[],C=k.getWorkspace();return $&&$.forEach(P=>{let W;if(k.getWorkbenchState()===2)W=(0,E.$$g)(C.folders[0].uri,P),W&&W!=="."&&(W="./"+W);else{const V=k.getWorkspaceFolder(P);if(V){const q=V.name;if(C.folders.filter(U=>U.name===q).length===1){const U=(0,E.$$g)(V.uri,P);U===""?W=`./${V.name}`:W=`./${V.name}/${U}`}else W=P.fsPath}}W&&y.push(l(W))}),y}}),define(Ie[303],Ce([1,0,23,2,24,14,3,302,47,45,11]),function(le,e,I,N,R,O,M,b,p,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cub=d,e.$Dub=r;const D=7e3;function d(o,s){const i=s.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],c=[];for(const u of i)if(/^workspaceContains:/.test(u)){const S=u.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||o.forceUsingSearch?c.push(S):n.push(S)}if(n.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:h,resolve:t}=(0,F.$oh)(),f=u=>t({activationEvent:u}),a=Promise.all(n.map(u=>v(o,u,f))).then(()=>{}),g=m(o,s.identifier,c,f);return Promise.all([a,g]).then(()=>{t(void 0)}),h}async function v(o,s,i){for(const n of o.folders)if(await o.exists(I.$9g(N.URI.revive(n),s))){i(`workspaceContains:${s}`);return}}async function m(o,s,i,n){if(i.length===0)return Promise.resolve(void 0);const c=new R.$pe,h=o.checkExists(o.folders,i,c.token),t=setTimeout(async()=>{c.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},D);let f=!1;try{f=await h}catch(a){O.$4(a)||O.$1(a)}c.dispose(),clearTimeout(t),f&&n(`workspaceContains:${i.join(",")}`)}function r(o,s,i,n){const c=o.get(M.$ui),h=o.get(p.$cL),f=c.createInstance(b.$EM).file(s.map(a=>(0,E.$Qi)(N.URI.revive(a))),{_reason:"checkExists",includePattern:i,exists:!0});return h.fileSearch(f,n).then(a=>!!a.limitHit,a=>O.$4(a)?!1:Promise.reject(a))}}),define(Ie[40],Ce([1,0,173,19,60,23,11,6,54,2,12,4,39,237,84,38,26,110,14,20,21,218,7,104,3,27,87,17,72,88,53,90,5,303,83,220,16,81,66,22,82]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o,s,i,n,c,h,t,f,a,g,u,S,l,w,$,k,y,C,P,W,V,q,A,U,K){"use strict";var re;Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=e.$4lc=e.$3lc=e.$2lc=e.$1lc=void 0,e.$1lc=(0,a.$vi)("IHostUtils");let ae=re=class extends b.$Vc{constructor(z,x,ve,Te,De,$e,ge,Q,X,he,ue,Fe,de){super(),this.Y=Fe,this.Z=de,this.a=this.B(new y.$ee),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=ve,this.f=ge,this.j=Te,this.m=De,this.s=$e,this.t=X,this.u=he,this.w=ue,this.y=this.g.getProxy(D.$1M.MainThreadWorkspace),this.z=this.g.getProxy(D.$1M.MainThreadTelemetry),this.C=this.g.getProxy(D.$1M.MainThreadExtensionService),this.D=new M.$uh,this.F=new M.$uh,this.G=new M.$uh,this.H=new M.$uh,this.I=new Me(this.f.extensions.activationEvents),this.L=new s.$C_b(this.I,this.f.extensions.allExtensions);const Re=new n.$Rm(this.f.extensions.myExtensions);this.J=new s.$C_b(this.I,Ae(this.L,Re)),U.$t&&(this.s.info(`Creating extension host with the following global extensions: ${fe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${fe(this.J)}`)),this.M=new m.$Jlc(this.g,this.s),this.N=new P.$Tlc(this.g),this.O=Q,this.h=z.createChild(new l.$ti([m.$Klc,this.M],[P.$Ulc,this.N])),this.P=this.B(new v.$Ilc(this.J,this.L,{onExtensionActivationError:(Ne,Ue,j)=>{this.C.$onExtensionActivationError(Ne,i.$3(Ue),j)},actualActivateExtension:async(Ne,Ue)=>{if(s.$C_b.isHostExtension(Ne,this.J,this.L))return await this.C.$activateExtension(Ne,Ue),new v.$Hlc;const j=this.J.getExtensionDescription(Ne);return this.fb(j,Ue)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),R.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(z){i.$1(z)}}async $(){this.O.onWillDeactivateAll();let z=[];try{z=this.J.getAllExtensionDescriptions().map(De=>De.identifier).filter(De=>this.isActivated(De)).map(De=>this.eb(De))}catch{}await Promise.all(z)}terminate(z,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${z}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Te=>{this.s.error(Te)}),this.g.dispose();const ve=this.$();Promise.race([(0,M.$wh)(5e3),ve]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(z){return this.G.isOpen()?this.P.isActivated(z):!1}async getExtension(z){const x=await this.C.$getExtension(z);return x&&{...x,identifier:new n.$Qm(x.identifier.value),extensionLocation:E.URI.revive(x.extensionLocation)}}ab(z,x){return this.P.activateByEvent(z,x)}bb(z,x){return this.P.activateById(z,x)}activateByIdWithErrors(z,x){return this.bb(z,x).then(()=>{const ve=this.P.getActivatedExtension(z);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(z=>this.J)}getExtensionExports(z){if(this.G.isOpen())return this.P.getActivatedExtension(z).exports;try{return this.P.getActivatedExtension(z).exports}catch{return null}}async cb(z){if(z.scheme===V.Schemas.file&&this.c.fsRealpath){const x=z.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const ve=await this.R.get(x);return E.URI.file(ve)}return z}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(z=>new ce(z))),this.Q}async db(z){const x=p.$Bi.forUris(ve=>O.$Zg.ignorePathCasing(ve));return await Promise.all(z.map(async ve=>{if(this.wb(ve)){const Te=await this.cb(ve.extensionLocation);x.set(Te,ve)}})),x}eb(z){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(z))return x;const ve=this.P.getActivatedExtension(z);if(!ve)return x;try{typeof ve.module.deactivate=="function"&&(x=Promise.resolve(ve.module.deactivate()).then(void 0,Te=>(this.s.error(Te),Promise.resolve(void 0))))}catch(Te){this.s.error(`An error occurred when deactivating the extension '${z.value}':`),this.s.error(Te)}try{(0,b.$Qc)(ve.subscriptions)}catch(Te){this.s.error(`An error occurred when deactivating the subscriptions for extension '${z.value}':`),this.s.error(Te)}return x}async fb(z,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(z.identifier):await this.C.$onWillActivateExtension(z.identifier),this.hb(z,x).then(ve=>{const Te=ve.activationTimes;return this.C.$onDidActivateExtension(z.identifier,Te.codeLoadingTime,Te.activateCallTime,Te.activateResolvedTime,x),this.gb(z,x,"success",Te),ve},ve=>{throw this.gb(z,x,"failure"),ve})}gb(z,x,ve,Te){const De=Pe(z,x);this.z.$publicLog2("extensionActivationTimes",{...De,...Te||{},outcome:ve})}hb(z,x){const ve=Pe(z,x);this.z.$publicLog2("activatePlugin",ve);const Te=this.wb(z);if(!Te)return Promise.resolve(new v.$Glc(v.$Dlc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${z.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${z.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const De=new v.$Elc(x.startup);return Promise.all([this.xb(z,(0,O.$9g)(z.extensionLocation,Te),De),this.ib(z)]).then($e=>(R.mark(`code/extHost/willActivateExtension/${z.identifier.value}`),re.jb(this.s,z.identifier,$e[0],$e[1],De))).then($e=>(R.mark(`code/extHost/didActivateExtension/${z.identifier.value}`),$e))}ib(z){const x=this.Z.createLanguageModelAccessInformation(z),ve=new h.$Mlc(z,this.M),Te=new h.$Llc(z.identifier.value,!1,this.M),De=new W.$Vlc(z,this.N),$e=z.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${z.identifier.value}`),Promise.all([ve.whenReady,Te.whenReady,this.O.whenReady]).then(()=>{const Q=this;let X,he;const ue=(0,o.$FG)(z,"ipc")?this.f.messagePorts?.get(n.$Qm.toKey(z.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:Te,secrets:De,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return z.extensionLocation},get extensionPath(){return z.extensionLocation.fsPath},asAbsolutePath(Fe){return N.$kc(z.extensionLocation.fsPath,Fe)},get storagePath(){return Q.O.workspaceValue(z)?.fsPath},get globalStoragePath(){return Q.O.globalValue(z).fsPath},get logPath(){return N.$kc(Q.f.logsLocation.fsPath,z.identifier.value)},get logUri(){return E.URI.joinPath(Q.f.logsLocation,z.identifier.value)},get storageUri(){return Q.O.workspaceValue(z)},get globalStorageUri(){return Q.O.globalValue(z)},get extensionMode(){return $e},get extension(){return X===void 0&&(X=new me(Q,z.identifier,z,ge,!1)),X},get extensionRuntime(){return(0,o.$GG)(z,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(z)},get messagePassingProtocol(){if(!he){if(!ue)return;const Fe=y.Event.buffer(y.Event.fromDOMEventEmitter(ue,"message",de=>de.data));ue.start(),he={onDidReceiveMessage:Fe,postMessage:ue.postMessage.bind(ue)}}return he}})})}static jb(z,x,ve,Te,De){return ve=ve||{activate:void 0,deactivate:void 0},this.kb(z,x,ve,Te,De).then($e=>new v.$Flc(!1,null,De.build(),ve,$e,Te.subscriptions))}static kb(z,x,ve,Te,De){if(typeof ve.activate=="function")try{De.activateCallStart(),z.trace(`ExtensionService#_callActivateOptional ${x.value}`);const $e=typeof global=="object"?global:self,ge=ve.activate.apply($e,[Te]);return De.activateCallStop(),De.activateResolveStart(),Promise.resolve(ge).then(Q=>(De.activateResolveStop(),Q))}catch($e){return Promise.reject($e)}else return Promise.resolve(ve)}lb(z,x){this.bb(z.identifier,{startup:!1,extensionId:z.identifier,activationEvent:x}).then(void 0,ve=>{this.s.error(ve)})}mb(z,x=0){const Te=Date.now();(0,U.$B)(()=>{for(let De=x;De<z.length;De+=1){const $e=z[De];for(const ge of $e.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-Te>50){this.mb(z,De);break}else this.lb($e,ge)}})}nb(){this.C.$setPerformanceMarks(R.getMarks()),this.m.getConfigProvider().then(z=>{const x=z.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this.J.getAllExtensionDescriptions();if(x)this.mb(ve);else for(const Te of ve)if(Te.activationEvents)for(const De of Te.activationEvents)De==="onStartupFinished"&&this.lb(Te,De)})}ob(){const z=this.ab("*",!0).then(void 0,$e=>{this.s.error($e)});this.B(this.j.onDidChangeWorkspace($e=>this.pb($e.added)));const x=this.j.workspace?this.j.workspace.folders:[],ve=this.pb(x),Te=this.rb(),De=Promise.all([Te,z,ve]).then(()=>{});return Promise.race([De,(0,M.$wh)(1e4)]).then(()=>{this.nb()}),De}pb(z){return z.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(z,x))).then(()=>{})}async qb(z,x){if(this.isActivated(x.identifier))return;const ve=!this.f.remote.isRemote&&!!this.f.remote.authority,Te={logService:this.s,folders:z.map($e=>$e.uri),forceUsingSearch:ve||!this.c.fsExists,exists:$e=>this.c.fsExists($e.fsPath),checkExists:($e,ge,Q)=>this.y.$checkExists($e,ge,Q)},De=await(0,C.$Cub)(Te,x);if(De)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:De.activationEvent}).then(void 0,$e=>this.s.error($e))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(z){throw console.error(z),z}}async sb(){const{extensionDevelopmentLocationURI:z,extensionTestsLocationURI:x}=this.f.environment;if(!z||!x)throw new Error(I.localize(0,null));const ve=await this.xb(null,x,new v.$Elc(!1));if(!ve||typeof ve.run!="function")throw new Error(I.localize(1,null,x.toString()));return new Promise((Te,De)=>{const $e=(X,he)=>{X?(U.$t&&this.s.error("Test runner called back with error",X),De(X)):(U.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Te(typeof he=="number"&&he>0?1:0))},ge=(0,O.$Wg)(x),Q=ve.run(ge,$e);Q&&Q.then&&Q.then(()=>{U.$t&&this.s.info("Test runner finished successfully."),Te(0)}).catch(X=>{U.$t&&this.s.error("Test runner finished with error",X),De(X instanceof Error&&X.stack?X.stack:String(X))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$wh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(z,x){return this.S[z]=x,(0,b.$Tc)(()=>{delete this.S[z]})}async getRemoteExecServer(z){const{resolver:x}=await this.ub(z);return x?.resolveExecServer?.(z,{resolveAttempt:0})}async ub(z){const x=z.indexOf("+");if(x===-1)throw new t.$9M("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ve=z.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this.S[ve]}}async $resolveAuthority(z,x){const ve=A.$ae.create(!1),Te=()=>`[resolveAuthority(${(0,f.$Kl)(z)},${x})][${ve.elapsed()}ms] `,De=T=>this.s.info(`${Te()}${T}`),$e=T=>this.s.warn(`${Te()}${T}`),ge=(T,G=void 0)=>this.s.error(`${Te()}${T}`,G),Q=T=>{if(T instanceof t.$9M)return{type:"error",error:{code:T._code,message:T._message,detail:T._detail}};throw T},X=async T=>{De(`activating resolver for ${T}...`);const{resolver:G,authorityPrefix:H}=await this.ub(T);if(!G)throw ge(`no resolver for ${H}`),new t.$9M(`No remote extension installed to resolve ${H}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:H,remoteAuthority:T}},he=z.split(/@|%40/g).reverse();De(`activating remote resolvers ${he.join(" -> ")}`);let ue;try{ue=await Promise.all(he.map(X)).catch(async T=>{if(!(T instanceof t.$9M)||T._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw T;return $e(`resolving nested authorities failed: ${T.message}`),[await X(z)]})}catch(T){return Q(T)}const Fe=new M.$Gh;Fe.cancelAndSet(()=>De("waiting..."),1e3);let de,Re;for(const[T,{authorityPrefix:G,resolver:H,remoteAuthority:ee}]of ue.entries())try{if(T===ue.length-1)De("invoking final resolve()..."),R.mark(`code/extHost/willResolveAuthority/${G}`),de=await H.resolve(ee,{resolveAttempt:x,execServer:Re}),R.mark(`code/extHost/didResolveAuthorityOK/${G}`),De("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$8M.isManagedResolvedAuthority(de)?de:void 0));else{if(De(`invoking resolveExecServer() for ${ee}`),R.mark(`code/extHost/willResolveExecServer/${G}`),Re=await H.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Re}),!Re)throw new t.$9M(`Exec server was not available for ${ee}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);R.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(ne){return R.mark(`code/extHost/didResolveAuthorityError/${G}`),ge("returned an error",ne),Fe.dispose(),Q(ne)}Fe.dispose();const Ne={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures?{elevation:de.tunnelFeatures.elevation,privacyOptions:de.tunnelFeatures.privacyOptions,protocol:de.tunnelFeatures.protocol===void 0?!0:de.tunnelFeatures.protocol}:void 0},Ue={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};De(`returned ${t.$8M.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let j;if(t.$8M.isManagedResolvedAuthority(de)){const T=x;this.Y.setFactory(T,de.makeConnection),j={authority:z,connectTo:new f.$Hl(T),connectionToken:de.connectionToken}}else j={authority:z,connectTo:new f.$Il(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:j,options:Ue,tunnelInformation:Ne}}}async $getCanonicalURI(z,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$Kl)(z)})`);const{resolver:ve}=await this.ub(z);if(!ve)return null;const Te=E.URI.revive(x);if(typeof ve.getCanonicalURI>"u")return Te;const De=await(0,M.$nh)(()=>ve.getCanonicalURI(Te));return De||Te}async $startExtensionHost(z){z.toAdd.forEach($e=>$e.extensionLocation=E.URI.revive($e.extensionLocation));const{globalRegistry:x,myExtensions:ve}=ye(this.I,this.L,this.J,z),Te=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Te),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),U.$t&&(this.s.info(`$startExtensionHost: global extensions: ${fe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${fe(this.J)}`)),this.tb()}$activateByEvent(z,x){return x===1?this.D.wait().then(ve=>this.ab(z,!1)):this.G.wait().then(ve=>this.ab(z,!1))}async $activate(z,x){return await this.G.wait(),this.J.getExtensionDescription(z)?(await this.bb(z,x),!0):!1}async $deltaExtensions(z){z.toAdd.forEach($e=>$e.extensionLocation=E.URI.revive($e.extensionLocation));const{globalRegistry:x,myExtensions:ve}=ye(this.I,this.L,this.J,z),Te=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Te),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),U.$t&&(this.s.info(`$deltaExtensions: global extensions: ${fe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${fe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(z){return z}async $test_up(z){return z.byteLength}async $test_down(z){const x=c.$Fe.alloc(z),ve=Math.random()%256;for(let Te=0;Te<z;Te++)x.writeUInt8(ve,Te);return x}async $updateRemoteConnectionData(z){this.X=z,this.a.fire()}};e.$2lc=ae,e.$2lc=ae=re=Je([We(0,a.$ui),We(1,e.$1lc),We(2,S.$oP),We(3,r.$mlc),We(4,d.$plc),We(5,F.$2j),We(6,g.$EP),We(7,u.$slc),We(8,w.$jDb),We(9,$.$Nlc),We(10,q.$Xlc),We(11,K.$Ylc),We(12,k.$Rlc)],ae);function ye(ie,z,x,ve){ie.addActivationEvents(ve.addActivationEvents);const Te=new s.$C_b(ie,z.getAllExtensionDescriptions());Te.deltaExtensions(ve.toAdd,ve.toRemove);const De=new n.$Rm(x.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of ve.myToRemove)De.delete(ge);for(const ge of ve.myToAdd)De.add(ge);const $e=Ae(Te,De);return{globalRegistry:Te,myExtensions:$e}}function Pe(ie,z){return{id:ie.identifier.value,name:ie.name,extensionVersion:ie.version,publisherDisplayName:ie.publisher,activationEvents:ie.activationEvents?ie.activationEvents.join(","):null,isBuiltin:ie.isBuiltin,reason:z.activationEvent,reasonId:z.extensionId.value}}function fe(ie){return ie.getAllExtensionDescriptions().map(z=>z.identifier.value).join(",")}e.$3lc=(0,a.$vi)("IExtHostExtensionService");class me{#e;#t;#i;constructor(z,x,ve,Te,De){this.#e=z,this.#t=x,this.#i=ve.identifier,this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=N.$ic((0,O.$Wg)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=Te,this.isFromDifferentExtensionHost=De}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$4lc=me;function Ae(ie,z){return ie.getAllExtensionDescriptions().filter(x=>z.has(x.identifier))}class ce{constructor(z){this.a=z}setSearchTree(z){this.a=z}findSubstr(z){return this.a.findSubstr(z)}forEach(z){return this.a.forEach(z)}}e.$5lc=ce;class Me{constructor(z){this.a=new n.$Sm,this.addActivationEvents(z)}readActivationEvents(z){return this.a.get(z.identifier)??[]}addActivationEvents(z){for(const x of Object.keys(z))this.a.set(x,z[x])}}}),define(Ie[304],Ce([1,0,60,2,4,39,26,20,17,27,3,40,12,13]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=void 0;let r=class{constructor(c,h,t,f,a,g,u){this.c=c,this.d=h,this.e=t,this.f=f,this.g=a,this.h=g,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new s(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$bnc=r,e.$bnc=r=Je([We(2,F.$ui),We(3,O.$plc),We(4,D.$3lc),We(5,E.$EP),We(6,d.$2j)],r);let o=class{static{m=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&m.a.size){const h=(0,v.$_e)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${a}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,t,f,a]=h,g=m.a.get(f);if(g!==void 0)return console.warn(`${f} as been renamed to ${g}, please update your imports`),t+g+a}c(c){return c.replace(/\\/g,"/")}};o=m=Je([We(0,E.$EP)],o);class s{constructor(c,h,t,f,a){this.c=c,this.d=h,this.e=t,this.f=f,this.g=a,this.nodeModuleName="vscode",this.a=new b.$Sm}load(c,h){const t=this.d.findSubstr(h);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((a,g)=>f+=`	${g} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${f}`),this.b=this.c(M.$AG,this.e,this.f)}return this.b}}let i=class{constructor(c,h,t){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(R.$1M.MainThreadTelemetry);const f=t.getProxy(R.$1M.MainThreadWindow);this.c=(a,g)=>{const u=N.URI.parse(a);return g?this.g(a,g):u.scheme==="http"||u.scheme==="https"?f.$openUri(u,a,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?f.$openUri(u,a,{}):this.g(a,g)}}load(c,h,t){const f=this.e.findSubstr(h);return f&&(this.a=f.identifier.value,this.h()),this.b=t(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([We(2,p.$oP)],i)}),define(Ie[122],Ce([1,0,42,6,19,75,3,68,67,40,7,38,234,39]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=e.$6lc=void 0,e.$6lc=(0,M.$vi)("IExtHostVariableResolverProvider");class m extends d.$qQ{constructor(s,i,n,c,h,t,f){function a(){if(n){const g=n.activeEditor();if(g)return g.document.uri;const u=c.tabGroups.all.find(S=>S.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof F.$OO||u.input instanceof F.$TO)return u.input.modified;if(u.input instanceof F.$NO||u.input instanceof F.$SO||u.input instanceof F.$QO)return u.input.uri}}}super({getFolderUri:g=>{const u=t.folders.filter(S=>S.name===g);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(g,u)=>h.getConfiguration(void 0,g).get(u),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const g=a();if(g)return R.$ic(g.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const g=a();if(g){const u=i.getWorkspaceFolder(g);if(u)return R.$ic(u.uri.fsPath)}}},getSelectedText:()=>{if(n){const g=n.activeEditor();if(g&&!g.selection.isEmpty)return g.document.getText(g.selection)}},getLineNumber:()=>{if(n){const g=n.activeEditor();if(g)return String(g.selection.end.line+1)}},getExtension:g=>s.getExtension(g)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(O.env))}}let r=class extends N.$Vc{constructor(s,i,n,c,h){super(),this.b=s,this.c=i,this.g=n,this.h=c,this.j=h,this.a=new I.$V(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async g=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$7lc=r,e.$7lc=r=Je([We(0,E.$3lc),We(1,D.$mlc),We(2,b.$zP),We(3,v.$plc),We(4,p.$Blc)],r)}),define(Ie[123],Ce([1,0,11,5,2,20,3,4,67,40,17,7,38,226,228,39,122,6,43,32,8]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o,s,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=e.$$lc=e.$0lc=e.$9lc=e.$8lc=void 0,e.$8lc=(0,M.$vi)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(l,w,$,k,y,C,P){this.N=w,this.O=$,this.P=k,this.Q=y,this.R=C,this.S=P,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$ee,this.o=new N.$ee,this.q=new N.$ee,this.w=new N.$ee,this.l=l.getProxy(b.$1M.MainThreadDebugService),this.A=new N.$ee,this.C=new N.$ee,this.y=new f(this.l),this.z=new Map,this.O.getExtensionRegistry().then(W=>{W.onDidChange(V=>{this.V(W)}),this.V(W)})}async $getVisualizerTreeItem(l,w){const $=this.W(w);if(!$)return;const k=await this.H.get(l)?.getTreeItem?.($);return k?this.U(l,k):void 0}registerDebugVisualizationTree(l,w,$){const k=O.$Qm.toKey(l.identifier),y=this.jb(k,w);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${w}' is already registered`);return this.H.set(y,$),this.l.$registerDebugVisualizerTree(y,!!$.editItem),(0,s.$Tc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(w)})}async $getVisualizerTreeItemChildren(l,w){const $=this.J.get(w)?.item;return $?(await this.H.get(l)?.getChildren?.($))?.map(y=>this.U(l,y))||[]:[]}async $editVisualizerTreeItem(l,w){const $=this.J.get(l);if(!$)return;const k=await this.H.get($.provider)?.editItem?.($.item,w);return this.U($.provider,k||$.item)}$disposeVisualizedTree(l){const w=this.J.get(l);if(!w)return;const $=[w.children];for(const k of $)if(k)for(const y of k)$.push(this.J.get(y)?.children),this.J.delete(y)}U(l,w){let $=this.I.get(w);return $||($=this.F++,this.I.set(w,$),this.J.set($,{provider:l,item:w})),c.DebugTreeItem.from(w,$)}asDebugSourceUri(l,w){const $=l;if(typeof $.sourceReference=="number"&&$.sourceReference>0){let k=`debug:${encodeURIComponent($.path||"")}`,y="?";return w&&(k+=`${y}session=${encodeURIComponent(w.id)}`,y="&"),k+=`${y}ref=${$.sourceReference}`,R.URI.parse(k)}else{if($.path)return R.URI.file($.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(l){const w=[];for(const $ of l.getAllExtensionDescriptions())if($.contributes){const k=$.contributes.debuggers;if(k&&k.length>0)for(const y of k)(0,m.$kH)(y)&&w.push(y.type)}this.l.$registerDebugTypes(w)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const l=[];return this.z.forEach(w=>l.push(w)),l}async $resolveDebugVisualizer(l,w){const $=this.L.get(l);if(!$)throw new Error(`No debug visualizer found with id '${l}'`);let{v:k,provider:y,extensionId:C}=$;if(k.visualization||(k=await y.resolveDebugVisualization?.(k,w)||k,$.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(C,k.visualization)}async $executeDebugVisualizerCommand(l){const w=this.L.get(l);if(!w)throw new Error(`No debug visualizer found with id '${l}'`);const $=w.v.visualization;$&&"command"in $&&this.S.executeCommand($.command,...$.arguments||[])}W(l){const w=this.m.get(l.sessionId);return w&&{session:w.api,variable:l.variable,containerId:l.containerId,frameId:l.frameId,threadId:l.threadId}}async $provideDebugVisualizers(l,w,$,k){const y=this.W($),C=this.jb(l,w),P=this.G.get(C);if(!y||!P)return[];const W=await P.provideDebugVisualization(y,k);return W?W.map(V=>{const q=++this.M;this.L.set(q,{v:V,provider:P,extensionId:l});const A=V.iconPath?this.lb(V.iconPath):void 0;return{id:q,name:V.name,iconClass:A?.iconClass,iconPath:A?.iconPath,visualization:this.kb(l,V.visualization)}}):[]}$disposeDebugVisualizers(l){for(const w of l)this.L.delete(w)}registerDebugVisualizationProvider(l,w,$){if(!l.contributes?.debugVisualizers?.some(C=>C.id===w))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${w})`);const k=O.$Qm.toKey(l.identifier),y=this.jb(k,w);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${w}' is already registered`);return this.G.set(y,$),this.l.$registerDebugVisualizer(k,w),(0,s.$Tc)(()=>{this.l.$unregisterDebugVisualizer(k,w),this.G.delete(w)})}addBreakpoints(l){const w=l.filter(y=>{const C=y.id;return this.z.has(C)?!1:(this.z.set(C,y),!0)});this.gb(w,[],[]);const $=[],k=new Map;for(const y of w)if(y instanceof D.$5N){let C=k.get(y.location.uri.toString());C||(C={type:"sourceMulti",uri:y.location.uri,lines:[]},k.set(y.location.uri.toString(),C),$.push(C)),C.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof D.$6N&&$.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints($)}removeBreakpoints(l){const w=l.filter(C=>this.z.delete(C.id));this.gb([],w,[]);const $=w.filter(C=>C instanceof D.$5N).map(C=>C.id),k=w.filter(C=>C instanceof D.$6N).map(C=>C.id),y=w.filter(C=>C instanceof D.$7N).map(C=>C.id);return this.l.$unregisterBreakpoints($,k,y)}startDebugging(l,w,$){return this.l.$startDebugging(l?l.uri:void 0,w,{parentSessionID:$.parentSession?$.parentSession.id:void 0,lifecycleManagedByParent:$.lifecycleManagedByParent,repl:$.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:$.noDebug,compact:$.compact,suppressSaveBeforeStart:$.suppressSaveBeforeStart,suppressDebugStatusbar:$.suppressDebugStatusbar??$.debugUI?.simple,suppressDebugToolbar:$.suppressDebugToolbar??$.debugUI?.simple,suppressDebugView:$.suppressDebugView??$.debugUI?.simple})}stopDebugging(l){return this.l.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,w,$){if(!w)return new D.$3M(()=>{});const k=this.d++;return this.f.push({type:l,handle:k,provider:w}),this.l.$registerDebugConfigurationProvider(l,$,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,k),new D.$3M(()=>{this.f=this.f.filter(y=>y.provider!==w),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(l,w,$){if(!$)return new D.$3M(()=>{});if(!this.cb(l,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.$(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:w,handle:k,factory:$}),this.l.$registerDebugAdapterDescriptorFactory(w,k),new D.$3M(()=>{this.h=this.h.filter(y=>y.factory!==$),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(l,w){if(!w)return new D.$3M(()=>{});const $=this.j++;return this.k.push({type:l,handle:$,factory:w}),new D.$3M(()=>{this.k=this.k.filter(k=>k.factory!==w)})}async $runInTerminal(l,w){return Promise.resolve(void 0)}async $substituteVariables(l,w){let $;const k=await this.ib(l);return k&&($={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync($,w)}X(l,w){if(l.type==="implementation")return new g(l.implementation)}Y(){}async $startDASession(l,w){const $=this,k=await this.hb(w);return this.eb(this.$(k.type),k).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const C=this.Z(y),P=this.X(C,k);if(!P)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const W=P;return this.D.set(l,W),this.db(k).then(V=>(V&&this.E.set(l,V),W.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const A=q,U={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const K=await this.K.sign(A.arguments.value);U.body={signature:K},W.sendResponse(U)}else throw new Error("no signer")}catch(K){U.success=!1,U.message=K.message,W.sendResponse(U)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(q),q=(0,m.$pH)(q,!0),$.l.$acceptDAMessage(l,q)}),W.onError(q=>{V&&V.onError&&V.onError(q),this.l.$acceptDAError(l,q.name,q.message,q.stack)}),W.onExit(q=>{V&&V.onExit&&V.onExit(q??void 0,void 0),this.l.$acceptDAExit(l,q??void 0,void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),W.startSession()))})}$sendDAMessage(l,w){w=(0,m.$oH)(w,!1);const $=this.E.get(l);$&&$.onWillReceiveMessage&&$.onWillReceiveMessage(w),this.D.get(l)?.sendMessage(w)}$stopDASession(l){const w=this.E.get(l);this.E.delete(l),w&&w.onWillStopSession&&w.onWillStopSession();const $=this.D.get(l);return this.D.delete(l),$?$.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const w=[],$=[],k=[];if(l.added)for(const y of l.added){const C=y.id;if(C&&!this.z.has(C)){let P;if(y.type==="function")P=new D.$6N(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")P=new D.$7N(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const W=R.URI.revive(y.uri);P=new D.$5N(new D.$cN(W,new D.$4M(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,D.$3N)(P,C),this.z.set(C,P),w.push(P)}}if(l.removed)for(const y of l.removed){const C=this.z.get(y);C&&(this.z.delete(y),$.push(C))}if(l.changed){for(const y of l.changed)if(y.id){const C=this.z.get(y.id);if(C){if(C instanceof D.$6N&&y.type==="function"){const P=C;P.enabled=y.enabled,P.condition=y.condition,P.hitCondition=y.hitCondition,P.logMessage=y.logMessage,P.functionName=y.functionName}else if(C instanceof D.$5N&&y.type==="source"){const P=C;P.enabled=y.enabled,P.condition=y.condition,P.hitCondition=y.hitCondition,P.logMessage=y.logMessage,P.location=new D.$cN(R.URI.revive(y.uri),new D.$4M(y.line,y.character))}k.push(C)}}}this.gb(w,$,k)}async $acceptStackFrameFocus(l){let w;if(l){const $=await this.hb(l.sessionId);l.kind==="thread"?w=new D.$aO($.api,l.threadId):w=new D.$_N($.api,l.threadId,l.frameId)}this.B=w,this.C.fire(this.B)}$provideDebugConfigurations(l,w,$){return(0,I.$nh)(async()=>{const k=this.bb(l);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(w);return k.provideDebugConfigurations(y,$)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(l,w,$,k){return(0,I.$nh)(async()=>{const y=this.bb(l);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(w);return y.resolveDebugConfiguration(C,$,k)})}$resolveDebugConfigurationWithSubstitutedVariables(l,w,$,k){return(0,I.$nh)(async()=>{const y=this.bb(l);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(w);return y.resolveDebugConfigurationWithSubstitutedVariables(C,$,k)})}async $provideDebugAdapter(l,w){const $=this.ab(l);if(!$)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(w);return this.eb($,k).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(l){const w=await this.hb(l);this.n.fire(w.api)}async $acceptDebugSessionTerminated(l){const w=await this.hb(l);w&&(this.o.fire(w.api),this.m.delete(w.id))}async $acceptDebugSessionActiveChanged(l){this.u=l?await this.hb(l):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(l,w){(await this.hb(l))?._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(l,w){const k={session:(await this.hb(l)).api,event:w.event,body:w.body};this.w.fire(k)}Z(l){if(l instanceof D.$8N)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof D.$9N)return{type:"server",port:l.port,host:l.host};if(l instanceof D.$0N)return{type:"pipeServer",path:l.path};if(l instanceof D.$$N)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}$(l){const w=this.h.filter($=>$.type===l);if(w.length>0)return w[0].factory}ab(l){const w=this.h.filter($=>$.handle===l);if(w.length>0)return w[0].factory}bb(l){const w=this.f.filter($=>$.handle===l);if(w.length>0)return w[0].provider}cb(l,w){if(l.contributes){const $=l.contributes.debuggers;if($&&$.length>0){for(const k of $)if(k.label&&k.type&&k.type===w)return!0}}return!1}db(l){const $=l.configuration.type,k=this.k.filter(y=>y.type===$||y.type==="*").map(y=>(0,I.$nh)(()=>y.factory.createDebugAdapterTracker(l.api)).then(C=>C,C=>null));return Promise.race([Promise.all(k).then(y=>{const C=y.filter(P=>!!P);if(C.length>0)return new a(C)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(l,w){const $=w.configuration.debugServer;if(typeof $=="number")return Promise.resolve(new D.$9N($));if(l){const y=await this.O.getExtensionRegistry();return(0,I.$nh)(()=>l.createDebugAdapterDescriptor(w.api,this.fb(w,y))).then(C=>{if(C)return C})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(w,k))}fb(l,w){}gb(l,w,$){(l.length>0||w.length>0||$.length>0)&&this.A.fire(Object.freeze({added:l,removed:w,changed:$}))}async hb(l){if(l)if(typeof l=="string"){const w=this.m.get(l);if(w)return w}else{let w=this.m.get(l.id);if(!w){const $=await this.ib(l.folderUri),k=l.parent?this.m.get(l.parent):void 0;w=new t(this.l,l.id,l.type,l.name,$,l.configuration,k?.api),this.m.set(w.id,w),this.l.$sessionCached(w.id)}return w}throw new Error("cannot find session")}ib(l){if(l){const w=R.URI.revive(l);return this.N.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}jb(l,w){return`${l}\0${w}`}kb(l,w){if(w){if("title"in w&&"command"in w)return{type:0};if("treeId"in w)return{type:1,id:`${l}\0${w.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(l){const w=this.mb(l);let $,k;return"id"in w?k=i.ThemeIcon.asClassName(w):$=w,{iconPath:$,iconClass:k}}mb(l){if(l instanceof D.$ZN)return{id:l.id};const w=typeof l=="object"&&"dark"in l?l.dark:l,$=typeof l=="object"&&"light"in l?l.light:l;return{dark:typeof w=="string"?R.URI.file(w):w,light:typeof $=="string"?R.URI.file($):$}}};e.$9lc=h,e.$9lc=h=Je([We(0,F.$oP),We(1,d.$mlc),We(2,E.$3lc),We(3,r.$plc),We(4,p.$Blc),We(5,o.$6lc),We(6,n.$KP)],h);class t{constructor(l,w,$,k,y,C,P){this.f=l,this.g=w,this.h=$,this.j=k,this.k=y,this.l=C,this.m=P}get api(){const l=this;return this.d??=Object.freeze({id:l.g,type:l.h,get name(){return l.j},set name(w){l.j=w,l.f.$setDebugSessionName(l.g,w)},parentSession:l.m,workspaceFolder:l.k,configuration:l.l,customRequest(w,$){return l.f.$customDebugAdapterRequest(l.g,w,$)},getDebugProtocolBreakpoint(w){return l.f.$getDebugProtocolBreakpoint(l.g,w.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(l){this.j=l}get configuration(){return this.l}}e.$0lc=t;class f{constructor(l){this.value=Object.freeze({append(w){l.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.$$lc=f;class a{constructor(l){this.d=l}onWillStartSession(){this.d.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.d.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.d.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(l):void 0)}onWillStopSession(){this.d.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.d.forEach(w=>w.onError?w.onError(l):void 0)}onExit(l,w){this.d.forEach($=>$.onExit?$.onExit(l,w):void 0)}}class g extends v.$3pb{constructor(l){super(),this.h=l,l.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.h.handleMessage(l)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let u=class extends h{constructor(l,w,$,k,y,C,P){super(l,w,$,k,y,C,P)}};e.$_lc=u,e.$_lc=u=Je([We(0,F.$oP),We(1,d.$mlc),We(2,E.$3lc),We(3,r.$plc),We(4,p.$Blc),We(5,o.$6lc),We(6,n.$KP)],u)}),define(Ie[305],Ce([1,0,14,60,2,4,254,12,56,72,27,199,17,61,40,63]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dnc=e.$cnc=void 0;class o{static async installEarlyHandler(n){Error.stackTraceLimit=100;const c=n.get(b.$2j),t=n.get(d.$oP).getProxy(O.$1M.MainThreadErrors);I.setUnexpectedErrorHandler(f=>{c.error(f);const a=I.$3(f);t.$onUnexpectedError(a)})}static async installFullHandler(n){const c=n.get(b.$2j),h=n.get(d.$oP),t=n.get(m.$3lc),f=n.get(r.$IP),a=h.getProxy(O.$1M.MainThreadExtensionService),g=h.getProxy(O.$1M.MainThreadErrors),u=await t.getExtensionPathIndex(),S=new WeakMap;function l(k,y){if(S.has(k))return S.get(k).stack;let C="",P,W;for(const q of y)C+=`
	at ${q.toString()}`,W=q.getFileName(),!P&&W&&(P=u.findSubstr(R.URI.file(W)));const V=`${k.name||"Error"}: ${k.message||""}${C}`;return S.set(k,{extensionIdentifier:P?.identifier,stack:V}),V}const w=Symbol("prepareStackTrace wrapped");let $=l;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return $},set(k){if(k===l||!k||k[w]){$=k||l;return}$=function(y,C){return l(y,C),k.call(Error,y,C)},Object.assign($,{[w]:!0})}}),I.setUnexpectedErrorHandler(k=>{c.error(k);const y=I.$3(k),C=S.get(k);if(!C?.extensionIdentifier){g.$onUnexpectedError(y);return}a.$onExtensionRuntimeError(C.extensionIdentifier,y);const P=f.onExtensionError(C.extensionIdentifier,k);c.trace("forwarded error to extension?",P,C)})}}e.$cnc=o;class s{constructor(n,c,h,t,f){this.a=h,this.b=new M.$K_b(n,null,t),c=s.e(c,this.b);const a=new E.$ti(...(0,p.$xs)());a.set(F.$EP,{_serviceBrand:void 0,...c,messagePorts:f}),a.set(d.$oP,new d.$pP(this.b)),a.set(v.$jlc,new v.$klc(t)),a.set(m.$1lc,h);const g=new D.$br(a,!0);g.invokeFunction(o.installEarlyHandler),this.d=g.invokeFunction(u=>u.get(b.$2j)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=g.invokeFunction(u=>u.get(m.$3lc)),this.c.initialize(),g.invokeFunction(o.installFullHandler)}async asBrowserUri(n){const c=this.b.getProxy(O.$1M.MainThreadExtensionService);return R.URI.revive(await c.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,c){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=R.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=R.URI.revive(c.transformIncomingURIs(n.environment.appRoot));const h=n.environment.extensionDevelopmentLocationURI;return h&&(n.environment.extensionDevelopmentLocationURI=h.map(t=>R.URI.revive(c.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=R.URI.revive(c.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=R.URI.revive(c.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=R.URI.revive(c.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=R.URI.revive(c.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=R.URI.revive(c.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=R.URI.revive(c.transformIncomingURIs(n.logsLocation)),n.workspace=c.transformIncomingURIs(n.workspace),n}}e.$dnc=s}),define(Ie[306],Ce([1,0,18,11,24,44,16,19,23,2,47]),function(le,e,I,N,R,O,M,b,p,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=e.$omc=e.$nmc=void 0,e.$pmc=r;class D{constructor(i,n,c){this.d=i,this.e=n,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(i,n){const c=this.g.folderQueries||[],h=new R.$pe(n);return new Promise((t,f)=>{this.a=new v(i);let a=!1;const g=(u,S)=>{if(!a&&!this.b){const l=this.h(u);r(u)&&typeof this.g.maxResults=="number"&&this.c+l>this.g.maxResults&&(this.b=!0,a=!0,h.cancel(),u=this.j(u,this.g.maxResults-this.c));const w=this.h(u);this.c+=w,(w>0||!r(u))&&this.a.add(u,S)}};Promise.all(c.map((u,S)=>this.k(u,l=>g(l,S),h.token))).then(u=>{h.dispose(),this.a.flush();const S=u.some(l=>!!l&&!!l.limitHit);t({limitHit:this.b||S,messages:(0,I.$Rb)(u.map(l=>l?.message?Array.isArray(l.message)?l.message:[l.message]:[])),stats:{type:this.f}})},u=>{h.dispose();const S=(0,O.$gj)(u);f(new Error(S))})})}h(i){return r(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const c=Array.isArray(i.ranges)?i.ranges:[i.ranges],h=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:c.slice(0,n),preview:{matches:h.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,c){const h=new F.$vL(this.g,i),t=[],f={report:u=>{if(!this.l(u))return;const S=i.folder.scheme===M.Schemas.file?(0,F.$wL)(()=>this.e.readdir(p.$8g(u.uri))):void 0,l=p.$$g(i.folder,u.uri);if(l){const w=h.includedInQuery(l,b.$oc(l),S);(0,N.$hh)(w)?t.push(w.then($=>{$&&n(u)})):w&&n(u)}}},a=this.n(i);let g;return this.d.query.type===3?g=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,f,c):g=await this.d.provider.provideTextSearchResults(d(this.d.query.contentPattern),a,f,c),t.length&&await Promise.all(t),g}l(i){if(r(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,F.$uL)(this.g.includePattern,i.includePattern),c=(0,F.$uL)(this.g.excludePattern,i.excludePattern),h={folder:E.URI.from(i.folder),excludes:c,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.e.toCanonicalName(i.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(h.usePCRE2=this.g.usePCRE2),h}}e.$nmc=D;function d(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class v{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new o(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!p.$2g(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(m(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$omc=v;function m(s){return r(s)?{preview:{matches:(0,I.$2b)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,I.$2b)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function r(s){return!!s.preview}class o{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$qmc=o}),define(Ie[124],Ce([1,0,6,4,3,301,17,61,12,2,306]),function(le,e,I,N,R,O,M,b,p,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=e.$rmc=void 0,e.$tmc=d,e.$rmc=(0,R.$vi)("IExtHostSearch");let D=class{constructor(r,o,s){this.n=r,this.o=o,this.q=s,this.c=this.n.getProxy(N.$1M.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$mmc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const s=this.d++;return this.e.set(s,o),this.c.$registerTextSearchProvider(s,this.s(r)),(0,I.$Tc)(()=>{this.g.delete(r),this.e.delete(s),this.c.$unregisterProvider(s)})}registerAITextSearchProvider(r,o){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const s=this.d++;return this.h.set(s,o),this.c.$registerAITextSearchProvider(s,this.s(r)),(0,I.$Tc)(()=>{this.i.delete(r),this.h.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(r,o){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const s=this.d++;return this.j.set(s,o),this.c.$registerFileSearchProvider(s,this.s(r)),(0,I.$Tc)(()=>{this.k.delete(r),this.j.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(r,o,s,i){const n=d(s),c=this.j.get(r);if(c)return this.l.fileSearch(n,c,h=>{this.c.$handleFileMatch(r,o,h.map(t=>t.resource))},i);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,s){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,s,i){const n=this.e.get(r);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const c=d(s);return this.t(c,n).search(t=>this.c.$handleTextMatch(r,o,t),i)}$provideAITextSearchResults(r,o,s,i){const n=this.h.get(r);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const c=d(s);return this.v(c,n).search(t=>this.c.$handleTextMatch(r,o,t),i)}$enableExtensionHostSearch(){}t(r,o){return new F.$nmc({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}v(r,o){return new F.$nmc({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.$smc=D,e.$smc=D=Je([We(0,M.$oP),We(1,b.$jlc),We(2,p.$2j)],D);function d(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(v),extraFileResources:m.extraFileResources&&m.extraFileResources.map(r=>E.URI.revive(r))}}function v(m){return{...m,folder:E.URI.revive(m.folder)}}}),define(Ie[307],Ce([1,0,24,14,5,6,16,33,2,158,154,141,95,20,37,12,58,59,213,4,257,285,80,86,262,263,264,243,232,32,265,39,266,123,112,267,245,258,268,269,68,67,259,40,271,65,272,46,27,286,287,246,273,90,274,81,82,248,300,276,219,277,288,278,118,249,279,280,281,17,282,124,83,283,250,284,84,87,121,63,53,116,289,290,260,291,292,88,8,7,251,61,252,64,293,294,111,38,227,79,26,120]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o,s,i,n,c,h,t,f,a,g,u,S,l,w,$,k,y,C,P,W,V,q,A,U,K,re,ae,ye,Pe,fe,me,Ae,ce,Me,ie,z,x,ve,Te,De,$e,ge,Q,X,he,ue,Fe,de,Re,Ne,Ue,j,T,G,H,ee,ne,Oe,Be,Ke,_e,xe,et,tt,nt,ct,mt,je,st,Z,Y,pe,Ge,we,ot,dt,Pt,Yt,zt,ri,Zt,St,Xt,xt,Ze,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=Wt;function Wt(lt){const bt=lt.get(ce.$EP),ei=lt.get(Ae.$7kc),Kt=lt.get(fe.$rlc),Ot=lt.get(ye.$3lc),ft=lt.get(St.$mlc),jt=lt.get(tt.$IP),qt=lt.get(k.$plc),Gt=lt.get(dt.$jlc),Qe=lt.get(G.$oP),hi=lt.get(_e.$Klc),Jt=lt.get(xe.$slc),Lt=lt.get(r.$3j),gt=lt.get(r.$2j),Ut=lt.get(pe.$jDb),Ct=lt.get(t.$3kc),Ft=lt.get(Zt.$9mc),ti=lt.get(ne.$Ulc),Bt=lt.get(re.$Blc),ii=lt.get($e.$Ylc),Mt=lt.get(f.$alc),At=lt.get(ve.$Rlc);Qe.set(n.$2M.ExtHostFileSystemInfo,ei),Qe.set(n.$2M.ExtHostLogLevelServiceShape,Lt),Qe.set(n.$2M.ExtHostWorkspace,ft),Qe.set(n.$2M.ExtHostConfiguration,qt),Qe.set(n.$2M.ExtHostExtensionService,Ot),Qe.set(n.$2M.ExtHostStorage,hi),Qe.set(n.$2M.ExtHostTunnelService,Ut),Qe.set(n.$2M.ExtHostWindow,Ft),Qe.set(n.$2M.ExtHostSecretState,ti),Qe.set(n.$2M.ExtHostTelemetry,jt),Qe.set(n.$2M.ExtHostEditorTabs,Bt),Qe.set(n.$2M.ExtHostManagedSockets,ii),Qe.set(n.$2M.ExtHostAuthentication,Mt),Qe.set(n.$2M.ExtHostChatProvider,At);const Nt=Qe.set(n.$2M.ExtHostDecorations,lt.get(P.$bmc)),It=Qe.set(n.$2M.ExtHostDocumentsAndEditors,lt.get(K.$zP)),$t=Qe.set(n.$2M.ExtHostCommands,lt.get(w.$KP)),Et=Qe.set(n.$2M.ExtHostTerminalService,lt.get(nt.$Nlc)),ni=Qe.set(n.$2M.ExtHostTerminalShellIntegration,lt.get(ct.$Umc)),Dt=Qe.set(n.$2M.ExtHostDebugService,lt.get(C.$8lc)),gi=Qe.set(n.$2M.ExtHostSearch,lt.get(ee.$rmc)),_t=Qe.set(n.$2M.ExtHostTask,lt.get(et.$Tmc)),bi=Qe.set(n.$2M.ExtHostOutputService,lt.get(Re.$Gmc)),ci=Qe.set(n.$2M.ExtHostLocalization,lt.get(De.$Xlc)),vi=Qe.set(n.$2M.ExtHostUrls,new Pt.$6mc(Qe)),kt=Qe.set(n.$2M.ExtHostDocuments,new U.$0kc(Qe,It)),Si=Qe.set(n.$2M.ExtHostDocumentContentProviders,new q.$dmc(Qe,It,gt)),be=Qe.set(n.$2M.ExtHostDocumentSaveParticipant,new A.$emc(gt,kt,Qe.getProxy(n.$1M.MainThreadBulkEdits))),Se=Qe.set(n.$2M.ExtHostNotebook,new Q.$umc(Qe,$t,It,kt,Kt,gi)),oe=Qe.set(n.$2M.ExtHostNotebookDocuments,new he.$Amc(Se)),J=Qe.set(n.$2M.ExtHostNotebookEditors,new ue.$Bmc(gt,Se)),ke=Qe.set(n.$2M.ExtHostNotebookKernels,new Fe.$Cmc(Qe,bt,Se,$t,gt)),Ve=Qe.set(n.$2M.ExtHostNotebookRenderers,new de.$Emc(Qe,Se)),Ye=Qe.set(n.$2M.ExtHostNotebookDocumentSaveParticipant,new X.$zmc(gt,Se,Qe.getProxy(n.$1M.MainThreadBulkEdits))),qe=Qe.set(n.$2M.ExtHostEditors,new je.$glc(Qe,It)),ut=Qe.set(n.$2M.ExtHostTreeViews,new Y.$4mc(Qe.getProxy(n.$1M.MainThreadTreeViews),$t,gt)),yt=Qe.set(n.$2M.ExtHostEditorInsets,new l.$hlc(Qe.getProxy(n.$1M.MainThreadEditorInsets),qe,bt.remote)),Tt=Qe.set(n.$2M.ExtHostDiagnostics,new W.$9kc(Qe,gt,ei,It)),Vt=Qe.set(n.$2M.ExtHostLanguages,new Te.$xmc(Qe,kt,$t.converter,Gt)),at=Qe.set(n.$2M.ExtHostLanguageFeatures,new x.$$kc(Qe,Gt,kt,$t,Tt,gt,Ct,jt)),Qt=Qe.set(n.$2M.ExtHostFileSystem,new Pe.$gmc(Qe,at)),mi=Qe.set(n.$2M.ExtHostFileSystemEventService,new me.$hmc(Qe,gt,It)),Ei=Qe.set(n.$2M.ExtHostQuickOpen,(0,T.$Kmc)(Qe,ft,$t)),Ii=Qe.set(n.$2M.ExtHostSCM,new H.$Mmc(Qe,$t,kt,gt)),Gi=Qe.set(n.$2M.ExtHostQuickDiff,new j.$Jmc(Qe,Gt)),Oi=Qe.set(n.$2M.ExtHostShare,new Oe.$Nmc(Qe,Gt)),Fi=Qe.set(n.$2M.ExtHostComments,(0,$.$ilc)(Qe,$t,kt)),Pi=Qe.set(n.$2M.ExtHostProgress,new Ue.$Imc(Qe.getProxy(n.$1M.MainThreadProgress))),Ti=Qe.set(n.$2M.ExtHostLabelService,new z.$wmc(Qe)),Li=Qe.set(n.$2M.ExtHostTheming,new st.$1mc(Qe)),un=Qe.set(n.$2M.ExtHostTimeline,new Z.$3mc(Qe,$t)),Ci=Qe.set(n.$2M.ExtHostWebviews,new Yt.$wlc(Qe,bt.remote,ft,gt,Ct)),Di=Qe.set(n.$2M.ExtHostWebviewPanels,new zt.$zlc(Qe,Ci,ft)),zi=Qe.set(n.$2M.ExtHostCustomEditors,new y.$Alc(Qe,kt,Jt,Ci,Di)),Hi=Qe.set(n.$2M.ExtHostWebviewViews,new ri.$7mc(Qe,Ci)),wi=Qe.set(n.$2M.ExtHostTesting,new mt.$Wmc(Qe,gt,$t,It)),Ki=Qe.set(n.$2M.ExtHostUriOpeners,new ot.$5mc(Qe)),Ji=Qe.set(n.$2M.ExtHostProfileContentHandlers,new Ne.$Hmc(Qe));Qe.set(n.$2M.ExtHostInteractive,new ie.$vmc(Qe,Se,It,$t,gt));const Qi=Qe.set(n.$2M.ExtHostInlineChat,new Me.$imc(Qe,$t,kt,gt)),Ri=Qe.set(n.$2M.ExtHostChatAgents2,new g.$dlc(Qe,gt,$t)),ln=Qe.set(n.$2M.ExtHostChatVariables,new u.$elc(Qe)),Yi=Qe.set(n.$2M.ExtHostAiRelatedInformation,new c.$2kc(Qe)),ji=Qe.set(n.$2M.ExtHostAiEmbeddingVector,new ae.$fmc(Qe)),Mi=Qe.set(n.$2M.ExtHostStatusBar,new Ke.$Qmc(Qe,$t.converter)),hn=Qe.set(n.$2M.ExtHostSpeech,new Be.$Omc(Qe)),dn=Object.values(n.$2M);Qe.assertRegistered(dn);const Zi=new a.$clc(Qe,It),fn=new S.$flc(Qe),ki=new ge.$ymc(Qe,gt),Ui=new V.$cmc(Qe);return h.$_kc.register($t),function(ze,ui,Xi){function it(_){return(se,Le,rt)=>{const wt=_(Rt=>{try{se.call(Le,Rt)}catch(yi){N.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${yi.toString()}`,{cause:yi})),jt.onExtensionError(ze.identifier,yi)}});return rt?.push(wt),wt}}const vt=function(){let _=!ze.isUnderDevelopment;function se(){_||(gt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Le(rt){if(Array.isArray(rt))rt.forEach(Le);else if(typeof rt=="string")se();else{const wt=rt;typeof wt.scheme>"u"&&se(),typeof wt.exclusive=="boolean"&&(0,Ze.$GG)(ze,"documentFiltersExclusive")}return rt}}(),di={getSession(_,se,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Ze.$GG)(ze,"authLearnMore"),Mt.getSession(ze,_,se,Le)},getSessions(_,se){return(0,Ze.$GG)(ze,"authGetSessions"),Mt.getSessions(ze,_,se)},async hasSession(_,se){return(0,Ze.$GG)(ze,"authSession"),!!await Mt.getSession(ze,_,se,{silent:!0})},get onDidChangeSessions(){return it(Mt.onDidChangeSessions)},registerAuthenticationProvider(_,se,Le,rt){return Mt.registerAuthenticationProvider(_,se,Le,rt)}},Ai={registerCommand(_,se,Le){return $t.registerCommand(!0,_,se,Le,void 0,ze)},registerTextEditorCommand(_,se,Le){return $t.registerCommand(!0,_,(...rt)=>{const wt=qe.getActiveTextEditor();if(!wt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}return wt.edit(Rt=>{se.apply(Le,[wt,Rt,...rt])}).then(Rt=>{Rt||gt.warn("Edits from command "+_+" were not applied.")},Rt=>{gt.warn("An error occurred while running command "+_,Rt)})},void 0,void 0,ze)},registerDiffInformationCommand:(_,se,Le)=>((0,Ze.$GG)(ze,"diffCommand"),$t.registerCommand(!0,_,async(...rt)=>{const wt=It.activeEditor(!0);if(!wt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}const Rt=await qe.getDiffInformation(wt.id);se.apply(Le,[Rt,...rt])},void 0,void 0,ze)),executeCommand(_,...se){return $t.executeCommand(_,...se)},getCommands(_=!1){return $t.getCommands(_)}},xi={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return fn.value},get shell(){return Et.getDefaultShell(!1)},get onDidChangeShell(){return it(Et.onDidChangeShell)},get isTelemetryEnabled(){return jt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return it(jt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$GG)(ze,"telemetry"),jt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$GG)(ze,"telemetry"),it(jt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$HP)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,se){return tt.$GP.validateSender(_),jt.instantiateLogger(ze,_,se)},openExternal(_,se){return Ft.openUri(_,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:se?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===bt.environment.appUriScheme)return vi.createAppUri(_);try{return await Ft.asExternalUri(_,{allowTunneling:!!bt.remote.authority})}catch(se){if((0,M.$Eg)(_,M.Schemas.http)||(0,M.$Eg)(_,M.Schemas.https))return _;throw se}},get remoteName(){return(0,o.$Hm)(bt.remote.authority)},get remoteAuthority(){return(0,Ze.$GG)(ze,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return it(gt.onDidChangeLogLevel)},get appQuality(){return(0,Ze.$GG)(ze,"resolvers"),bt.quality},get appCommit(){return(0,Ze.$GG)(ze,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(xi);const oi={createTestController(_,se,Le){return wi.createTestController(ze,_,se,Le)},createTestObserver(){return(0,Ze.$GG)(ze,"testObserver"),wi.createTestObserver()},runTests(_){return(0,Ze.$GG)(ze,"testObserver"),wi.runTests(_)},get onDidChangeTestResults(){return(0,Ze.$GG)(ze,"testObserver"),it(wi.onResultsChanged)},get testResults(){return(0,Ze.$GG)(ze,"testObserver"),wi.results}},$i=bt.remote.isRemote?we.ExtensionKind.Workspace:we.ExtensionKind.UI,_i={getExtension(_,se){(0,Ze.$FG)(ze,"extensionsAny")||(se=!1);const Le=ui.mine.getExtensionDescription(_);if(Le)return new ye.$4lc(Ot,ze.identifier,Le,$i,!1);if(se){const rt=ui.all.getExtensionDescription(_);if(rt)return new ye.$4lc(Ot,ze.identifier,rt,$i,!0)}},get all(){const _=[];for(const se of ui.mine.getAllExtensionDescriptions())_.push(new ye.$4lc(Ot,ze.identifier,se,$i,!1));return _},get allAcrossExtensionHosts(){(0,Ze.$GG)(ze,"extensionsAny");const _=new v.$Rm(ui.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),se=[];for(const Le of ui.all.getAllExtensionDescriptions()){const rt=!_.has(Le.identifier);se.push(new ye.$4lc(Ot,ze.identifier,Le,$i,rt))}return se},get onDidChange(){return(0,Ze.$FG)(ze,"extensionsAny")?it(R.Event.any(ui.mine.onDidChange,ui.all.onDidChange)):it(ui.mine.onDidChange)}},en={createDiagnosticCollection(_){return Tt.createDiagnosticCollection(ze.identifier,_)},get onDidChangeDiagnostics(){return it(Tt.onDidChangeDiagnostics)},getDiagnostics:_=>Tt.getDiagnostics(_),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(_,se){return Vt.changeLanguage(_.uri,se)},match(_,se){const Le=Ge.LanguageSelector.from(_);let rt;return(0,F.$5t)(Le)&&(rt=Se.notebookDocuments.find(wt=>wt.apiNotebook.getCells().find(Rt=>Rt.document===se))?.apiNotebook),(0,F.$4t)(Le,se.uri,se.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(_,se,Le){return at.registerCodeActionProvider(ze,vt(_),se,Le)},registerDocumentPasteEditProvider(_,se,Le){return(0,Ze.$GG)(ze,"documentPaste"),at.registerDocumentPasteEditProvider(ze,vt(_),se,Le)},registerCodeLensProvider(_,se){return at.registerCodeLensProvider(ze,vt(_),se)},registerDefinitionProvider(_,se){return at.registerDefinitionProvider(ze,vt(_),se)},registerDeclarationProvider(_,se){return at.registerDeclarationProvider(ze,vt(_),se)},registerImplementationProvider(_,se){return at.registerImplementationProvider(ze,vt(_),se)},registerTypeDefinitionProvider(_,se){return at.registerTypeDefinitionProvider(ze,vt(_),se)},registerHoverProvider(_,se){return at.registerHoverProvider(ze,vt(_),se,ze.identifier)},registerEvaluatableExpressionProvider(_,se){return at.registerEvaluatableExpressionProvider(ze,vt(_),se,ze.identifier)},registerInlineValuesProvider(_,se){return at.registerInlineValuesProvider(ze,vt(_),se,ze.identifier)},registerDocumentHighlightProvider(_,se){return at.registerDocumentHighlightProvider(ze,vt(_),se)},registerMultiDocumentHighlightProvider(_,se){return at.registerMultiDocumentHighlightProvider(ze,vt(_),se)},registerLinkedEditingRangeProvider(_,se){return at.registerLinkedEditingRangeProvider(ze,vt(_),se)},registerReferenceProvider(_,se){return at.registerReferenceProvider(ze,vt(_),se)},registerRenameProvider(_,se){return at.registerRenameProvider(ze,vt(_),se)},registerNewSymbolNamesProvider(_,se){return(0,Ze.$GG)(ze,"newSymbolNamesProvider"),at.registerNewSymbolNamesProvider(ze,vt(_),se)},registerDocumentSymbolProvider(_,se,Le){return at.registerDocumentSymbolProvider(ze,vt(_),se,Le)},registerWorkspaceSymbolProvider(_){return at.registerWorkspaceSymbolProvider(ze,_)},registerDocumentFormattingEditProvider(_,se){return at.registerDocumentFormattingEditProvider(ze,vt(_),se)},registerDocumentRangeFormattingEditProvider(_,se){return at.registerDocumentRangeFormattingEditProvider(ze,vt(_),se)},registerOnTypeFormattingEditProvider(_,se,Le,...rt){return at.registerOnTypeFormattingEditProvider(ze,vt(_),se,[Le].concat(rt))},registerDocumentSemanticTokensProvider(_,se,Le){return at.registerDocumentSemanticTokensProvider(ze,vt(_),se,Le)},registerDocumentRangeSemanticTokensProvider(_,se,Le){return at.registerDocumentRangeSemanticTokensProvider(ze,vt(_),se,Le)},registerSignatureHelpProvider(_,se,Le,...rt){return typeof Le=="object"?at.registerSignatureHelpProvider(ze,vt(_),se,Le):at.registerSignatureHelpProvider(ze,vt(_),se,typeof Le>"u"?[]:[Le,...rt])},registerCompletionItemProvider(_,se,...Le){return at.registerCompletionItemProvider(ze,vt(_),se,Le)},registerInlineCompletionItemProvider(_,se,Le){return se.handleDidShowCompletionItem&&(0,Ze.$GG)(ze,"inlineCompletionsAdditions"),se.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$GG)(ze,"inlineCompletionsAdditions"),Le&&(0,Ze.$GG)(ze,"inlineCompletionsAdditions"),at.registerInlineCompletionsProvider(ze,vt(_),se,Le)},registerInlineEditProvider(_,se){return(0,Ze.$GG)(ze,"inlineEdit"),at.registerInlineEditProvider(ze,vt(_),se)},registerDocumentLinkProvider(_,se){return at.registerDocumentLinkProvider(ze,vt(_),se)},registerColorProvider(_,se){return at.registerColorProvider(ze,vt(_),se)},registerFoldingRangeProvider(_,se){return at.registerFoldingRangeProvider(ze,vt(_),se)},registerSelectionRangeProvider(_,se){return at.registerSelectionRangeProvider(ze,_,se)},registerCallHierarchyProvider(_,se){return at.registerCallHierarchyProvider(ze,_,se)},registerTypeHierarchyProvider(_,se){return at.registerTypeHierarchyProvider(ze,_,se)},setLanguageConfiguration:(_,se)=>at.setLanguageConfiguration(ze,_,se),getTokenInformationAtPosition(_,se){return(0,Ze.$GG)(ze,"tokenInformation"),Vt.tokenAtPosition(_,se)},registerInlayHintsProvider(_,se){return at.registerInlayHintsProvider(ze,_,se)},createLanguageStatusItem(_,se){return Vt.createLanguageStatusItem(ze,_,se)},registerDocumentDropEditProvider(_,se,Le){return at.registerDocumentOnDropEditProvider(ze,_,se,(0,Ze.$FG)(ze,"documentPaste")?Le:void 0)}},tn={get activeTextEditor(){return qe.getActiveTextEditor()},get visibleTextEditors(){return qe.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(_,se,Le){p.URI.isUri(_)&&_.scheme===M.Schemas.vscodeRemote&&!_.authority&&Ct.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(p.URI.isUri(_)?Promise.resolve(Bi.openTextDocument(_)):Promise.resolve(_));return qe.showTextDocument(rt,se,Le)},createTextEditorDecorationType(_){return qe.createTextEditorDecorationType(ze,_)},onDidChangeActiveTextEditor(_,se,Le){return it(qe.onDidChangeActiveTextEditor)(_,se,Le)},onDidChangeVisibleTextEditors(_,se,Le){return it(qe.onDidChangeVisibleTextEditors)(_,se,Le)},onDidChangeTextEditorSelection(_,se,Le){return it(qe.onDidChangeTextEditorSelection)(_,se,Le)},onDidChangeTextEditorOptions(_,se,Le){return it(qe.onDidChangeTextEditorOptions)(_,se,Le)},onDidChangeTextEditorVisibleRanges(_,se,Le){return it(qe.onDidChangeTextEditorVisibleRanges)(_,se,Le)},onDidChangeTextEditorViewColumn(_,se,Le){return it(qe.onDidChangeTextEditorViewColumn)(_,se,Le)},onDidCloseTerminal(_,se,Le){return it(Et.onDidCloseTerminal)(_,se,Le)},onDidOpenTerminal(_,se,Le){return it(Et.onDidOpenTerminal)(_,se,Le)},onDidChangeActiveTerminal(_,se,Le){return it(Et.onDidChangeActiveTerminal)(_,se,Le)},onDidChangeTerminalDimensions(_,se,Le){return(0,Ze.$GG)(ze,"terminalDimensions"),it(Et.onDidChangeTerminalDimensions)(_,se,Le)},onDidChangeTerminalState(_,se,Le){return it(Et.onDidChangeTerminalState)(_,se,Le)},onDidWriteTerminalData(_,se,Le){return(0,Ze.$GG)(ze,"terminalDataWriteEvent"),it(Et.onDidWriteTerminalData)(_,se,Le)},onDidExecuteTerminalCommand(_,se,Le){return(0,Ze.$GG)(ze,"terminalExecuteCommandEvent"),it(Et.onDidExecuteTerminalCommand)(_,se,Le)},onDidChangeTerminalShellIntegration(_,se,Le){return(0,Ze.$GG)(ze,"terminalShellIntegration"),it(ni.onDidChangeTerminalShellIntegration)(_,se,Le)},onDidStartTerminalShellExecution(_,se,Le){return(0,Ze.$GG)(ze,"terminalShellIntegration"),it(ni.onDidStartTerminalShellExecution)(_,se,Le)},onDidEndTerminalShellExecution(_,se,Le){return(0,Ze.$GG)(ze,"terminalShellIntegration"),it(ni.onDidEndTerminalShellExecution)(_,se,Le)},get state(){return Ft.getState()},onDidChangeWindowState(_,se,Le){return it(Ft.onDidChangeWindowState)(_,se,Le)},showInformationMessage(_,...se){return ki.showMessage(ze,b.default.Info,_,se[0],se.slice(1))},showWarningMessage(_,...se){return ki.showMessage(ze,b.default.Warning,_,se[0],se.slice(1))},showErrorMessage(_,...se){return ki.showMessage(ze,b.default.Error,_,se[0],se.slice(1))},showQuickPick(_,se,Le){return Ei.showQuickPick(ze,_,se,Le)},showWorkspaceFolderPick(_){return Ei.showWorkspaceFolderPick(_)},showInputBox(_,se){return Ei.showInput(_,se)},showOpenDialog(_){return Ui.showOpenDialog(ze,_)},showSaveDialog(_){return Ui.showSaveDialog(_)},createStatusBarItem(_,se,Le){let rt,wt,Rt;return typeof _=="string"?(rt=_,wt=se,Rt=Le):(wt=_,Rt=se),Mi.createStatusBarEntry(ze,rt,wt,Rt)},setStatusBarMessage(_,se){return Mi.setStatusBarMessage(_,se)},withScmProgress(_){return Ct.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Pi.withProgress(ze,{location:we.ProgressLocation.SourceControl},(se,Le)=>_({report(rt){}}))},withProgress(_,se){return Pi.withProgress(ze,_,se)},createOutputChannel(_,se){return bi.createOutputChannel(_,se,ze)},createWebviewPanel(_,se,Le,rt){return Di.createWebviewPanel(ze,_,se,Le,rt)},createWebviewTextEditorInset(_,se,Le,rt){return(0,Ze.$GG)(ze,"editorInsets"),yt.createWebviewEditorInset(_,se,Le,rt,ze)},createTerminal(_,se,Le){return typeof _=="object"?"pty"in _?Et.createExtensionTerminal(_):Et.createTerminalFromOptions(_):Et.createTerminal(_,se,Le)},registerTerminalLinkProvider(_){return Et.registerLinkProvider(_)},registerTerminalProfileProvider(_,se){return Et.registerProfileProvider(ze,_,se)},registerTerminalQuickFixProvider(_,se){return(0,Ze.$GG)(ze,"terminalQuickFixProvider"),Et.registerTerminalQuickFixProvider(_,ze.identifier.value,se)},registerTreeDataProvider(_,se){return ut.registerTreeDataProvider(_,se,ze)},createTreeView(_,se){return ut.createTreeView(_,se,ze)},registerWebviewPanelSerializer:(_,se)=>Di.registerWebviewPanelSerializer(ze,_,se),registerCustomEditorProvider:(_,se,Le={})=>zi.registerCustomEditorProvider(ze,_,se,Le),registerFileDecorationProvider(_){return Nt.registerFileDecorationProvider(_,ze)},registerUriHandler(_){return vi.registerUriHandler(ze,_)},createQuickPick(){return Ei.createQuickPick(ze)},createInputBox(){return Ei.createInputBox(ze)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(_,se,Le){return it(Li.onDidChangeActiveColorTheme)(_,se,Le)},registerWebviewViewProvider(_,se,Le){return Hi.registerWebviewViewProvider(ze,_,se,Le?.webviewOptions)},get activeNotebookEditor(){return Se.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,se,Le){return it(Se.onDidChangeActiveNotebookEditor)(_,se,Le)},get visibleNotebookEditors(){return Se.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return it(Se.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,se,Le){return it(J.onDidChangeNotebookEditorSelection)(_,se,Le)},onDidChangeNotebookEditorVisibleRanges(_,se,Le){return it(J.onDidChangeNotebookEditorVisibleRanges)(_,se,Le)},showNotebookDocument(_,se){return Se.showNotebookDocument(_,se)},registerExternalUriOpener(_,se,Le){return(0,Ze.$GG)(ze,"externalUriOpener"),Ki.registerExternalUriOpener(ze.identifier,_,se,Le)},registerProfileContentHandler(_,se){return(0,Ze.$GG)(ze,"profileContentHandlers"),Ji.registerProfileContentHandler(ze,_,se)},registerQuickDiffProvider(_,se,Le,rt){return(0,Ze.$GG)(ze,"quickDiffProvider"),Gi.registerQuickDiffProvider(vt(_),se,Le,rt)},get tabGroups(){return Bt.tabGroups},registerShareProvider(_,se){return(0,Ze.$GG)(ze,"shareProvider"),Oi.registerShareProvider(vt(_),se)}},Bi={get rootPath(){return Ct.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(_){throw new N.$9("rootPath")},getWorkspaceFolder(_){return ft.getWorkspaceFolder(_)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(_){throw new N.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(_){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(_,se,...Le)=>ft.updateWorkspaceFolders(ze,_,se||0,...Le),onDidChangeWorkspaceFolders:function(_,se,Le){return it(ft.onDidChangeWorkspace)(_,se,Le)},asRelativePath:(_,se)=>ft.getRelativePath(_,se),findFiles:(_,se,Le,rt)=>ft.findFiles(_,se,Le,ze.identifier,rt),findFiles2:(_,se,Le)=>((0,Ze.$GG)(ze,"findFiles2"),ft.findFiles2(_,se,ze.identifier,Le)),findTextInFiles:(_,se,Le,rt)=>{(0,Ze.$GG)(ze,"findTextInFiles");let wt,Rt;return typeof se=="object"?(wt=se,Rt=Le):(wt={},Rt=se,rt=Le),ft.findTextInFiles(_,wt||{},Rt,ze.identifier,rt)},save:_=>ft.save(_),saveAs:_=>ft.saveAs(_),saveAll:_=>ft.saveAll(_),applyEdit(_,se){return Zi.applyWorkspaceEdit(_,ze,se)},createFileSystemWatcher:(_,se,Le,rt)=>{let wt;return typeof se=="boolean"?wt={ignoreCreateEvents:!!se,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!rt,correlate:!1}:se&&((0,Ze.$GG)(ze,"createFileSystemWatcher"),wt={...se,correlate:!0}),mi.createFileSystemWatcher(ft,ze,_,wt)},get textDocuments(){return kt.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new N.$9("textDocuments")},openTextDocument(_){let se;const Le=_;if(typeof _=="string")se=Promise.resolve(p.URI.file(_));else if(p.URI.isUri(_))se=Promise.resolve(_);else if(!Le||typeof Le=="object")se=kt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return se.then(rt=>(rt.scheme===M.Schemas.vscodeRemote&&!rt.authority&&Ct.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),kt.ensureDocumentData(rt).then(wt=>wt.document)))},onDidOpenTextDocument:(_,se,Le)=>it(kt.onDidAddDocument)(_,se,Le),onDidCloseTextDocument:(_,se,Le)=>it(kt.onDidRemoveDocument)(_,se,Le),onDidChangeTextDocument:(_,se,Le)=>it(kt.onDidChangeDocument)(_,se,Le),onDidSaveTextDocument:(_,se,Le)=>it(kt.onDidSaveDocument)(_,se,Le),onWillSaveTextDocument:(_,se,Le)=>it(be.getOnWillSaveTextDocumentEvent(ze))(_,se,Le),get notebookDocuments(){return Se.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,se){let Le;if(p.URI.isUri(_))Le=_,await Se.openNotebookDocument(_);else if(typeof _=="string")Le=p.URI.revive(await Se.createNotebookDocument({viewType:_,content:se}));else throw new Error("Invalid arguments");return Se.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(_,se,Le){return it(oe.onDidSaveNotebookDocument)(_,se,Le)},onDidChangeNotebookDocument(_,se,Le){return it(oe.onDidChangeNotebookDocument)(_,se,Le)},onWillSaveNotebookDocument(_,se,Le){return it(Ye.getOnWillSaveNotebookDocumentEvent(ze))(_,se,Le)},get onDidOpenNotebookDocument(){return it(Se.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return it(Se.onDidCloseNotebookDocument)},registerNotebookSerializer(_,se,Le,rt){return Se.registerNotebookSerializer(ze,_,se,Le,(0,Ze.$FG)(ze,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(_,se,Le)=>it(Xi.onDidChangeConfiguration)(_,se,Le),getConfiguration(_,se){return se=arguments.length===1?void 0:se,Xi.getConfiguration(_,se,ze)},registerTextDocumentContentProvider(_,se){return Si.registerTextDocumentContentProvider(_,se)},registerTaskProvider:(_,se)=>(Ct.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(ze,_,se)),registerFileSystemProvider(_,se,Le){return(0,O.$Sc)(Qt.registerFileSystemProvider(ze,_,se,Le),Kt.addFileSystemProvider(_,se,Le))},get fs(){return Kt.value},registerFileSearchProvider:(_,se)=>((0,Ze.$GG)(ze,"fileSearchProvider"),gi.registerFileSearchProvider(_,se)),registerTextSearchProvider:(_,se)=>((0,Ze.$GG)(ze,"textSearchProvider"),gi.registerTextSearchProvider(_,se)),registerAITextSearchProvider:(_,se)=>((0,Ze.$GG)(ze,"aiTextSearchProvider"),(0,Ze.$GG)(ze,"textSearchProvider"),gi.registerAITextSearchProvider(_,se)),registerRemoteAuthorityResolver:(_,se)=>((0,Ze.$GG)(ze,"resolvers"),Ot.registerRemoteAuthorityResolver(_,se)),registerResourceLabelFormatter:_=>((0,Ze.$GG)(ze,"resolvers"),Ti.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Ze.$GG)(ze,"resolvers"),Ot.getRemoteExecServer(_)),onDidCreateFiles:(_,se,Le)=>it(mi.onDidCreateFile)(_,se,Le),onDidDeleteFiles:(_,se,Le)=>it(mi.onDidDeleteFile)(_,se,Le),onDidRenameFiles:(_,se,Le)=>it(mi.onDidRenameFile)(_,se,Le),onWillCreateFiles:(_,se,Le)=>it(mi.getOnWillCreateFileEvent(ze))(_,se,Le),onWillDeleteFiles:(_,se,Le)=>it(mi.getOnWillDeleteFileEvent(ze))(_,se,Le),onWillRenameFiles:(_,se,Le)=>it(mi.getOnWillRenameFileEvent(ze))(_,se,Le),openTunnel:_=>((0,Ze.$GG)(ze,"tunnels"),Ut.openTunnel(ze,_).then(se=>{if(!se)throw new Error("cannot open tunnel");return se})),get tunnels(){return(0,Ze.$GG)(ze,"tunnels"),Ut.getTunnels()},onDidChangeTunnels:(_,se,Le)=>((0,Ze.$GG)(ze,"tunnels"),it(Ut.onDidChangeTunnels)(_,se,Le)),registerPortAttributesProvider:(_,se)=>((0,Ze.$GG)(ze,"portsAttributes"),Ut.registerPortsAttributesProvider(_,se)),registerTunnelProvider:(_,se)=>((0,Ze.$GG)(ze,"tunnelFactory"),Ut.registerTunnelProvider(_,se)),registerTimelineProvider:(_,se)=>((0,Ze.$GG)(ze,"timeline"),un.registerTimelineProvider(_,se,ze.identifier,$t.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:_=>((0,Ze.$GG)(ze,"workspaceTrust"),ft.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,se,Le)=>it(ft.onDidGrantWorkspaceTrust)(_,se,Le),registerEditSessionIdentityProvider:(_,se)=>((0,Ze.$GG)(ze,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(_,se)),onWillCreateEditSessionIdentity:(_,se,Le)=>((0,Ze.$GG)(ze,"editSessionIdentityProvider"),it(ft.getOnWillCreateEditSessionIdentityEvent(ze))(_,se,Le)),registerCanonicalUriProvider:(_,se)=>((0,Ze.$GG)(ze,"canonicalUriProvider"),ft.registerCanonicalUriProvider(_,se)),getCanonicalUri:(_,se,Le)=>((0,Ze.$GG)(ze,"canonicalUriProvider"),ft.provideCanonicalUri(_,se,Le))},gn={get inputBox(){return Ct.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Ii.getLastInputBox(ze)},createSourceControl(_,se,Le){return Ii.createSourceControl(ze,_,se,Le)}},nn={createCommentController(_,se){return Fi.createCommentController(ze,_,se)}},rn={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){if((0,Ze.$FG)(ze,"debugFocus"))return Dt.activeStackItem},registerDebugVisualizationProvider(_,se){return(0,Ze.$GG)(ze,"debugVisualization"),Dt.registerDebugVisualizationProvider(ze,_,se)},registerDebugVisualizationTreeProvider(_,se){return(0,Ze.$GG)(ze,"debugVisualization"),Dt.registerDebugVisualizationTree(ze,_,se)},onDidStartDebugSession(_,se,Le){return it(Dt.onDidStartDebugSession)(_,se,Le)},onDidTerminateDebugSession(_,se,Le){return it(Dt.onDidTerminateDebugSession)(_,se,Le)},onDidChangeActiveDebugSession(_,se,Le){return it(Dt.onDidChangeActiveDebugSession)(_,se,Le)},onDidReceiveDebugSessionCustomEvent(_,se,Le){return it(Dt.onDidReceiveDebugSessionCustomEvent)(_,se,Le)},onDidChangeBreakpoints(_,se,Le){return it(Dt.onDidChangeBreakpoints)(_,se,Le)},onDidChangeActiveStackItem(_,se,Le){return(0,Ze.$GG)(ze,"debugFocus"),it(Dt.onDidChangeActiveStackItem)(_,se,Le)},registerDebugConfigurationProvider(_,se,Le){return Dt.registerDebugConfigurationProvider(_,se,Le||Xt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,se){return Dt.registerDebugAdapterDescriptorFactory(ze,_,se)},registerDebugAdapterTrackerFactory(_,se){return Dt.registerDebugAdapterTrackerFactory(_,se)},startDebugging(_,se,Le){return!Le||typeof Le=="object"&&"configuration"in Le?Dt.startDebugging(_,se,{parentSession:Le}):Dt.startDebugging(_,se,Le||{})},stopDebugging(_){return Dt.stopDebugging(_)},addBreakpoints(_){return Dt.addBreakpoints(_)},removeBreakpoints(_){return Dt.removeBreakpoints(_)},asDebugSourceUri(_,se){return Dt.asDebugSourceUri(_,se)}},mn={registerTaskProvider:(_,se)=>_t.registerTaskProvider(ze,_,se),fetchTasks:_=>_t.fetchTasks(_),executeTask:_=>_t.executeTask(ze,_),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(_,se,Le)=>it(_t.onDidStartTask)(_,se,Le),onDidEndTask:(_,se,Le)=>it(_t.onDidEndTask)(_,se,Le),onDidStartTaskProcess:(_,se,Le)=>it(_t.onDidStartTaskProcess)(_,se,Le),onDidEndTaskProcess:(_,se,Le)=>it(_t.onDidEndTaskProcess)(_,se,Le)},$n={createNotebookController(_,se,Le,rt,wt){return ke.createNotebookController(ze,_,se,Le,rt,(0,Ze.$FG)(ze,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(_,se)=>Se.registerNotebookCellStatusBarItemProvider(ze,_,se),createRendererMessaging(_){return Ve.createRendererMessaging(ze,_)},createNotebookControllerDetectionTask(_){return(0,Ze.$GG)(ze,"notebookKernelSource"),ke.createNotebookControllerDetectionTask(ze,_)},registerKernelSourceActionProvider(_,se){return(0,Ze.$GG)(ze,"notebookKernelSource"),ke.registerKernelSourceActionProvider(ze,_,se)},onDidChangeNotebookCellExecutionState(_,se,Le){return(0,Ze.$GG)(ze,"notebookCellExecutionState"),it(ke.onDidChangeNotebookCellExecutionState)(_,se,Le)}},sn={t(..._){if(typeof _[0]=="string"){const se=_.shift(),Le=!_||typeof _[0]!="object"?_:_[0];return ci.getMessage(ze.identifier.value,{message:se,args:Le})}return ci.getMessage(ze.identifier.value,_[0])},get bundle(){return ci.getBundle(ze.identifier.value)},get uri(){return ci.getBundleUri(ze.identifier.value)}},Vi={_version:1,registerInteractiveEditorSessionProvider(_,se){return(0,Ze.$GG)(ze,"interactive"),Qi.registerProvider(ze,_,se)},transferActiveChat(_){return(0,Ze.$GG)(ze,"interactive"),Ri.transferActiveChat(_)}},on={getRelatedInformation(_,se){return(0,Ze.$GG)(ze,"aiRelatedInformation"),Yi.getRelatedInformation(ze,_,se)},registerRelatedInformationProvider(_,se){return(0,Ze.$GG)(ze,"aiRelatedInformation"),Yi.registerRelatedInformationProvider(ze,_,se)},registerEmbeddingVectorProvider(_,se){return(0,Ze.$GG)(ze,"aiRelatedInformation"),ji.registerEmbeddingVectorProvider(ze,_,se)}},an={registerChatResponseProvider(_,se,Le){return(0,Ze.$GG)(ze,"chatProvider"),At.registerLanguageModel(ze,_,se,Le)},registerChatVariableResolver(_,se,Le){return(0,Ze.$GG)(ze,"chatVariableResolver"),ln.registerVariableResolver(ze,_,se,Le)},registerMappedEditsProvider(_,se){return(0,Ze.$GG)(ze,"mappedEditsProvider"),at.registerMappedEditsProvider(ze,_,se)},createChatParticipant(_,se){return(0,Ze.$GG)(ze,"chatParticipant"),Ri.createChatAgent(ze,_,se)},createDynamicChatParticipant(_,se,Le,rt){return(0,Ze.$GG)(ze,"chatParticipantAdditions"),Ri.createDynamicChatAgent(ze,_,se,Le,rt)}},cn={get languageModels(){return(0,Ze.$GG)(ze,"languageModels"),At.getLanguageModelIds()},onDidChangeLanguageModels:(_,se,Le)=>((0,Ze.$GG)(ze,"languageModels"),At.onDidChangeProviders(_,se,Le)),sendChatRequest(_,se,Le,rt){return(0,Ze.$GG)(ze,"languageModels"),At.sendChatRequest(ze,_,se,Le,rt)},computeTokenLength(_,se,Le){return(0,Ze.$GG)(ze,"languageModels"),Le??=I.CancellationToken.None,At.computeTokenLength(_,se,Le)},getLanguageModelInformation(_){return(0,Ze.$GG)(ze,"languageModels"),At.getLanguageModelInfo(_)}},pn={registerSpeechProvider(_,se){return(0,Ze.$GG)(ze,"speech"),hn.registerProvider(ze.identifier,_,se)}};return{version:bt.version,ai:on,authentication:di,commands:Ai,comments:nn,chat:an,debug:rn,env:xi,extensions:_i,interactive:Vi,l10n:sn,languages:en,lm:cn,notebooks:$n,scm:gn,speech:pn,tasks:mn,tests:oi,window:tn,workspace:Bi,Breakpoint:we.$4N,TerminalOutputAnchor:we.TerminalOutputAnchor,ChatResultFeedbackKind:we.ChatResultFeedbackKind,ChatVariableLevel:we.ChatVariableLevel,ChatCompletionItem:we.$YO,CallHierarchyIncomingCall:we.$pN,CallHierarchyItem:we.$oN,CallHierarchyOutgoingCall:we.$qN,CancellationError:N.$5,CancellationTokenSource:I.$pe,CandidatePortSource:n.CandidatePortSource,CodeAction:we.$lN,CodeActionKind:we.$mN,CodeActionTriggerKind:we.CodeActionTriggerKind,CodeLens:we.$rN,Color:we.$EN,ColorInformation:we.$FN,ColorPresentation:we.$GN,ColorThemeKind:we.ColorThemeKind,CommentMode:we.CommentMode,CommentState:we.CommentState,CommentThreadCollapsibleState:we.CommentThreadCollapsibleState,CommentThreadState:we.CommentThreadState,CommentThreadApplicability:we.CommentThreadApplicability,CompletionItem:we.$yN,CompletionItemKind:we.CompletionItemKind,CompletionItemTag:we.CompletionItemTag,CompletionList:we.$zN,CompletionTriggerKind:we.CompletionTriggerKind,ConfigurationTarget:we.ConfigurationTarget,CustomExecution:we.$ON,DebugAdapterExecutable:we.$8N,DebugAdapterInlineImplementation:we.$$N,DebugAdapterNamedPipeServer:we.$0N,DebugAdapterServer:we.$9N,DebugConfigurationProviderTriggerKind:Xt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:we.DebugConsoleMode,DebugVisualization:we.$oO,DecorationRangeBehavior:we.DecorationRangeBehavior,Diagnostic:we.$eN,DiagnosticRelatedInformation:we.$dN,DiagnosticSeverity:we.DiagnosticSeverity,DiagnosticTag:we.DiagnosticTag,Disposable:we.$3M,DocumentHighlight:we.$hN,DocumentHighlightKind:we.DocumentHighlightKind,MultiDocumentHighlight:we.$iN,DocumentLink:we.$DN,DocumentSymbol:we.$kN,EndOfLine:we.EndOfLine,EnvironmentVariableMutatorType:we.EnvironmentVariableMutatorType,EvaluatableExpression:we.$bO,InlineValueText:we.$cO,InlineValueVariableLookup:we.$dO,InlineValueEvaluatableExpression:we.$eO,InlineCompletionTriggerKind:we.InlineCompletionTriggerKind,EventEmitter:R.$ee,ExtensionKind:we.ExtensionKind,ExtensionMode:we.ExtensionMode,ExternalUriOpenerPriority:we.ExternalUriOpenerPriority,FileChangeType:we.FileChangeType,FileDecoration:we.$qO,FileDecoration2:we.$qO,FileSystemError:we.$hO,FileType:m.FileType,FilePermission:m.FilePermission,FoldingRange:we.$iO,FoldingRangeKind:we.FoldingRangeKind,FunctionBreakpoint:we.$6N,InlineCompletionItem:we.$AN,InlineCompletionList:we.$BN,Hover:we.$fN,VerboseHover:we.$gN,HoverVerbosityAction:we.HoverVerbosityAction,IndentAction:D.IndentAction,Location:we.$cN,MarkdownString:we.$sN,OverviewRulerLane:d.OverviewRulerLane,ParameterInformation:we.$tN,PortAutoForwardAction:we.PortAutoForwardAction,Position:we.$4M,ProcessExecution:we.$MN,ProgressLocation:we.ProgressLocation,QuickInputButtons:we.$pO,Range:we.$5M,RelativePattern:we.$2N,Selection:we.$6M,SelectionRange:we.$nN,SemanticTokens:we.$lO,SemanticTokensBuilder:we.$kO,SemanticTokensEdit:we.$mO,SemanticTokensEdits:we.$nO,SemanticTokensLegend:we.$jO,ShellExecution:we.$NN,ShellQuoting:we.ShellQuoting,SignatureHelp:we.$vN,SignatureHelpTriggerKind:we.SignatureHelpTriggerKind,SignatureInformation:we.$uN,SnippetString:we.$bN,SourceBreakpoint:we.$5N,StandardTokenType:we.StandardTokenType,StatusBarAlignment:we.StatusBarAlignment,SymbolInformation:we.$jN,SymbolKind:we.SymbolKind,SymbolTag:we.SymbolTag,Task:we.$PN,TaskGroup:we.$LN,TaskPanelKind:we.TaskPanelKind,TaskRevealKind:we.TaskRevealKind,TaskScope:we.TaskScope,TerminalLink:we.$HN,TerminalQuickFixTerminalCommand:we.$JN,TerminalQuickFixOpener:we.$IN,TerminalLocation:we.TerminalLocation,TerminalProfile:we.$KN,TerminalExitReason:we.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:we.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:we.TextDocumentSaveReason,TextEdit:we.$0M,SnippetTextEdit:we.$_M,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:we.TextEditorLineNumbersStyle,TextEditorRevealType:we.TextEditorRevealType,TextEditorSelectionChangeKind:we.TextEditorSelectionChangeKind,SyntaxTokenType:we.SyntaxTokenType,TextDocumentChangeReason:we.TextDocumentChangeReason,ThemeColor:we.$1N,ThemeIcon:we.$ZN,TreeItem:we.$QN,TreeItemCheckboxState:we.TreeItemCheckboxState,TreeItemCollapsibleState:we.TreeItemCollapsibleState,TypeHierarchyItem:we.$MO,UIKind:xt.UIKind,Uri:p.URI,ViewColumn:we.ViewColumn,WorkspaceEdit:we.$aN,DocumentPasteTriggerKind:we.DocumentPasteTriggerKind,DocumentDropEdit:we.$WN,DocumentDropOrPasteEditKind:we.$XN,DocumentPasteEdit:we.$YN,InlayHint:we.$xN,InlayHintLabelPart:we.$wN,InlayHintKind:we.InlayHintKind,RemoteAuthorityResolverError:we.$9M,ResolvedAuthority:we.$7M,ManagedResolvedAuthority:we.$8M,SourceControlInputBoxValidationType:we.SourceControlInputBoxValidationType,ExtensionRuntime:we.ExtensionRuntime,TimelineItem:we.$AO,NotebookRange:we.$sO,NotebookCellKind:we.NotebookCellKind,NotebookCellExecutionState:we.NotebookCellExecutionState,NotebookCellData:we.$tO,NotebookData:we.$uO,NotebookRendererScript:we.$yO,NotebookCellStatusBarAlignment:we.NotebookCellStatusBarAlignment,NotebookEditorRevealType:we.NotebookEditorRevealType,NotebookCellOutput:we.$wO,NotebookCellOutputItem:we.$vO,NotebookCellStatusBarItem:we.$xO,NotebookControllerAffinity:we.NotebookControllerAffinity,NotebookControllerAffinity2:we.NotebookControllerAffinity2,NotebookEdit:we.$$M,NotebookKernelSourceAction:we.$zO,NotebookVariablesRequestKind:we.NotebookVariablesRequestKind,PortAttributes:we.$CO,LinkedEditingRanges:we.$BO,TestResultState:we.TestResultState,TestRunRequest:we.$DO,TestRunRequest2:we.$DO,TestMessage:we.$EO,TestTag:we.$FO,TestRunProfileKind:we.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:we.$VN,DataTransferItem:we.$RN,TestCoverageCount:we.$GO,FileCoverage:we.$IO,StatementCoverage:we.$JO,BranchCoverage:we.$KO,DeclarationCoverage:we.$LO,WorkspaceTrustState:we.WorkspaceTrustState,LanguageStatusSeverity:we.LanguageStatusSeverity,QuickPickItemKind:we.QuickPickItemKind,InputBoxValidationSeverity:we.InputBoxValidationSeverity,TabInputText:we.$NO,TabInputTextDiff:we.$OO,TabInputTextMerge:we.$PO,TabInputCustom:we.$QO,TabInputNotebook:we.$SO,TabInputNotebookDiff:we.$TO,TabInputWebview:we.$RO,TabInputTerminal:we.$UO,TabInputInteractiveWindow:we.$VO,TabInputChat:we.$WO,TabInputTextMultiDiff:we.$XO,TelemetryTrustedValue:s.$ep,LogLevel:r.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:we.InteractiveSessionVoteDirection,ChatCopyKind:we.ChatCopyKind,InteractiveEditorResponseFeedbackKind:we.InteractiveEditorResponseFeedbackKind,DebugStackFrame:we.$_N,DebugThread:we.$aO,RelatedInformationType:we.RelatedInformationType,SpeechToTextStatus:we.SpeechToTextStatus,PartialAcceptTriggerKind:we.PartialAcceptTriggerKind,KeywordRecognitionStatus:we.KeywordRecognitionStatus,ChatResponseMarkdownPart:we.$ZO,ChatResponseFileTreePart:we.$3O,ChatResponseAnchorPart:we.$4O,ChatResponseProgressPart:we.$5O,ChatResponseReferencePart:we.$7O,ChatResponseTextEditPart:we.$8O,ChatResponseMarkdownWithVulnerabilitiesPart:we.$1O,ChatResponseCommandButtonPart:we.$6O,ChatResponseDetectedParticipantPart:we.$2O,ChatRequestTurn:we.$9O,ChatResponseTurn:we.$0O,ChatLocation:we.ChatLocation,LanguageModelChatSystemMessage:we.$$O,LanguageModelChatUserMessage:we.$_O,LanguageModelChatAssistantMessage:we.$aP,LanguageModelSystemMessage:we.$$O,LanguageModelUserMessage:we.$_O,LanguageModelAssistantMessage:we.$aP,LanguageModelError:we.$bP,NewSymbolName:we.$gO,NewSymbolNameTag:we.NewSymbolNameTag,InlineEdit:we.$cP,InlineEditTriggerKind:we.InlineEditTriggerKind}}}}),define(Ie[308],Ce([1,0,56,118,38,112,39,32,68,53,121,123,124,84,88,80,111,65,46,83,63,67,247,12,122,81,82,86,90,116]),function(le,e,I,N,R,O,M,b,p,E,F,D,d,v,m,r,o,s,i,n,c,h,t,f,a,g,u,S,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$ws)(g.$Xlc,g.$Wlc,1),(0,I.$ws)(f.$3j,t.$$mc,1),(0,I.$ws)(r.$3kc,r.$4kc,1),(0,I.$ws)(b.$KP,b.$JP,0),(0,I.$ws)(S.$alc,S.$blc,0),(0,I.$ws)(l.$Rlc,l.$Slc,0),(0,I.$ws)(M.$plc,M.$nlc,0),(0,I.$ws)(s.$rlc,s.$qlc,0),(0,I.$ws)(D.$8lc,D.$_lc,0),(0,I.$ws)(O.$bmc,O.$amc,0),(0,I.$ws)(p.$zP,p.$yP,0),(0,I.$ws)(u.$Ylc,u.$Zlc,0),(0,I.$ws)(i.$7kc,i.$6kc,0),(0,I.$ws)(N.$Gmc,N.$Fmc,1),(0,I.$ws)(d.$rmc,d.$smc,0),(0,I.$ws)(v.$Klc,v.$Jlc,0),(0,I.$ws)(F.$Tmc,F.$Smc,0),(0,I.$ws)(E.$Nlc,E.$Qlc,0),(0,I.$ws)(w.$Umc,w.$Vmc,0),(0,I.$ws)(m.$jDb,m.$kDb,0),(0,I.$ws)(o.$9mc,o.$8mc,0),(0,I.$ws)(R.$mlc,R.$llc,0),(0,I.$ws)(n.$Ulc,n.$Tlc,0),(0,I.$ws)(c.$IP,c.$FP,0),(0,I.$ws)(h.$Blc,h.$Clc,0),(0,I.$ws)(a.$6lc,a.$7lc,0)}),define(Ie[309],Ce([1,0,307,40,2,304,7,11,253]),function(le,e,I,N,R,O,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=void 0;class E extends O.$bnc{j(){}getModule(v,m){for(const r of this.b){const o=r(v);if(o){v=o;break}}if(this.a.has(v))return this.a.get(v).load(v,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class F extends N.$2lc{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(p.$hpc);const v=this.h.invokeFunction(I.$0mc);this.r=this.h.createInstance(E,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(v){return v.browser}async xb(v,m,r){m=m.with({path:D(m.path,".js")});const o=v?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const s=R.URI.revive(await this.C.$asBrowserUri(m)),i=await fetch(s.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),i.status!==200)throw new Error(i.statusText);const n=await i.text(),c=`${m.toString(!0)}#vscode-extension`,h=`${n}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",h)}catch(u){throw console.error(o?`Loading code for extension ${o} failed: ${u.message}`:`Loading code failed: ${u.message}`),console.error(`${m.toString(!0)}${typeof u.line=="number"?` line ${u.line}`:""}${typeof u.column=="number"?` column ${u.column}`:""}`),console.error(u),u}v&&await this.w.initializeLocalizedMessages(v);const f={},a={exports:f},g=u=>{const S=this.r.getModule(u,m);if(S===void 0)throw new Error(`Cannot load module '${u}'`);return S};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(a,f,g),a.exports!==f?a.exports:f}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(v){}async Bb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+v;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,b.$wh)(10)}}e.$ipc=F;function D(d,v){return d.endsWith(v)?d:d+v}}),define(Ie[310],Ce([1,0,71,56,12,40,217,87,309]),function(le,e,I,N,R,O,M,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,N.$ws)(R.$2j,new I.$si(M.$anc,[!0],!0)),(0,N.$ws)(O.$3lc,p.$ipc,0),(0,N.$ws)(b.$slc,b.$tlc,0)}),define(Ie[316],Ce([1,0,21,5,79,305,255,19,60,16,2,308,310]),function(le,e,I,N,R,O,M,b,p,E,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=h;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const d=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(t){return/^(file|vscode-remote):/i.test(t)}const m=fetch.bind(self);function r(t){self.fetch=async function(f,a){return f instanceof Request||v(String(f))&&(f=(await t(F.URI.parse(String(f)))).toString(!0)),m(f,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(f,a,g,u,S){(async()=>(v(a.toString())&&(a=(await t(F.URI.parse(a.toString()))).toString(!0)),super.open(f,a,g??!0,u,S)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(f,a){if(/^file:/i.test(f.toString()))f=E.$Pg.uriToBrowserUri(F.URI.parse(f.toString())).toString(!0);else if(/^vscode-remote:/i.test(f.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const u=`(${function($){function k(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const y=fetch.bind(self);self.fetch=function(P,W){return P instanceof Request?y(P,W):y(k(P),W)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,W,V,q,A){return super.open(P,k(W),V??!0,q,A)}};const C=importScripts.bind(self);self.importScripts=(...P)=>{C(...P.map(k))},C($)}.toString()}('${f}'))`;a=a||{},a.name=`${name} -> ${a.name||b.$oc(f.toString())}`;const S=new Blob([u],{type:"application/javascript"}),l=URL.createObjectURL(S);return new t(l,a)}}else self.Worker=class extends M.$jpc{constructor(t,f){super(d,t,{name:b.$oc(t.toString()),...f})}};const o=new class{constructor(){this.pid=void 0}exit(t){D()}};class s{constructor(){const f=new MessageChannel,a=new N.$ee;let g=!1;d(f.port2,[f.port2]),f.port1.onmessage=u=>{const{data:S}=u;if(!(S instanceof ArrayBuffer)){console.warn("UNKNOWN data received",S);return}const l=I.$Fe.wrap(new Uint8Array(S,0,S.byteLength));if((0,R.$Zm)(l,2)){g=!0,n("received terminate message from renderer");return}a.fire(l)},this.protocol={onMessage:a.event,send:u=>{if(!g){const S=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);f.port1.postMessage(S,[S])}}}}}function i(t){return new Promise(f=>{const a=t.onMessage(g=>{a.dispose();const u=JSON.parse(g.toString());t.send((0,R.$Ym)(0)),f({protocol:t,initData:u})});t.send((0,R.$Ym)(1))})}let n=t=>D();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){p.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(f){c(f)&&i(t.protocol).then(a=>{p.mark("code/extHost/didWaitForInitData");const g=new O.$dnc(a.protocol,a.initData,o,null,f.data);r(u=>g.asBrowserUri(u)),n=u=>g.terminate(u)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5ae5a741bdb676abb667fd4896dc2a40e313db3a/core/vs/workbench/api/worker/extensionHostWorker.js.map
